/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/objects","vs/editor/common/core/lineRange","vs/base/common/platform","vs/base/common/uri","vs/base/common/arrays","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/advancedLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ae=function(z){for(var t=[],D=0,P=z.length;D<P;D++)t[D]=se[z[D]];return t};const We=this,Ve=typeof global=="object"?global:{};var we;(function(z){z.global=We;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof z.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}z.Environment=t})(we||(we={}));var we;(function(z){class t{constructor(o,p,l){this.type=o,this.detail=p,this.timestamp=l}}z.LoaderEvent=t;class D{constructor(o){this._events=[new t(1,"",o)]}record(o,p){this._events.push(new t(o,p,z.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}z.LoaderEventRecorder=D;class P{record(o,p){}getEvents(){return[]}}P.INSTANCE=new P,z.NullLoaderEventRecorder=P})(we||(we={}));var we;(function(z){class t{static fileUriToFilePath(P,i){if(i=decodeURI(i).replace(/%23/g,"#"),P){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(P,i){return P.length>=i.length&&P.substr(0,i.length)===i}static endsWith(P,i){return P.length>=i.length&&P.substr(P.length-i.length)===i}static containsQueryString(P){return/^[^\#]*\?/gi.test(P)}static isAbsolutePath(P){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(P)}static forEachProperty(P,i){if(P){let o;for(o in P)P.hasOwnProperty(o)&&i(o,P[o])}}static isEmpty(P){let i=!0;return t.forEachProperty(P,()=>{i=!1}),i}static recursiveClone(P){if(!P||typeof P!="object"||P instanceof RegExp||!Array.isArray(P)&&Object.getPrototypeOf(P)!==Object.prototype)return P;let i=Array.isArray(P)?[]:{};return t.forEachProperty(P,(o,p)=>{p&&typeof p=="object"?i[o]=t.recursiveClone(p):i[o]=p}),i}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(P){return t.startsWith(P,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=z.global.performance&&typeof z.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?z.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,z.Utilities=t})(we||(we={}));var we;(function(z){function t(i){if(i instanceof Error)return i;const o=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(o.stack=i.stack),o}z.ensureError=t;class D{static validateConfigurationOptions(o){function p(l){if(l.phase==="loading"){console.error('Loading "'+l.moduleId+'" failed'),console.error(l),console.error("Here are the modules that depend on it:"),console.error(l.neededBy);return}if(l.phase==="factory"){console.error('The factory function of "'+l.moduleId+'" has thrown an exception'),console.error(l),console.error("Here are the modules that depend on it:"),console.error(l.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError>"u"&&(o.catchError=!1),typeof o.recordStats>"u"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=p),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(z.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags>"u"&&(o.preferScriptTags=!1),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){const l=t(new Error("INVALID cached data configuration, 'path' MUST be set"));l.phase="configuration",o.onError(l),o.nodeCachedData=void 0}return o}static mergeConfigurationOptions(o=null,p=null){let l=z.Utilities.recursiveClone(p||{});return z.Utilities.forEachProperty(o,(s,a)=>{s==="ignoreDuplicateModules"&&typeof l.ignoreDuplicateModules<"u"?l.ignoreDuplicateModules=l.ignoreDuplicateModules.concat(a):s==="paths"&&typeof l.paths<"u"?z.Utilities.forEachProperty(a,(h,R)=>l.paths[h]=R):s==="config"&&typeof l.config<"u"?z.Utilities.forEachProperty(a,(h,R)=>l.config[h]=R):l[s]=z.Utilities.recursiveClone(a)}),D.validateConfigurationOptions(l)}}z.ConfigurationOptionsUtil=D;class P{constructor(o,p){if(this._env=o,this.options=D.mergeConfigurationOptions(p),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let l=this.options.nodeRequire.main.filename,s=Math.max(l.lastIndexOf("/"),l.lastIndexOf("\\"));this.options.baseUrl=l.substring(0,s+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],z.Utilities.forEachProperty(this.options.paths,(o,p)=>{Array.isArray(p)?this.sortedPathsRules.push({from:o,to:p}):this.sortedPathsRules.push({from:o,to:[p]})}),this.sortedPathsRules.sort((o,p)=>p.from.length-o.from.length)}cloneAndMerge(o){return new P(this._env,D.mergeConfigurationOptions(o,this.options))}getOptionsLiteral(){return this.options}_applyPaths(o){let p;for(let l=0,s=this.sortedPathsRules.length;l<s;l++)if(p=this.sortedPathsRules[l],z.Utilities.startsWith(o,p.from)){let a=[];for(let h=0,R=p.to.length;h<R;h++)a.push(p.to[h]+o.substr(p.from.length));return a}return[o]}_addUrlArgsToUrl(o){return z.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o}_addUrlArgsIfNecessaryToUrls(o){if(this.options.urlArgs)for(let p=0,l=o.length;p<l;p++)o[p]=this._addUrlArgsToUrl(o[p]);return o}moduleIdToPaths(o){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o))return this.isBuild()?["empty:"]:["node|"+o];let p=o,l;if(!z.Utilities.endsWith(p,".js")&&!z.Utilities.isAbsolutePath(p)){l=this._applyPaths(p);for(let s=0,a=l.length;s<a;s++)this.isBuild()&&l[s]==="empty:"||(z.Utilities.isAbsolutePath(l[s])||(l[s]=this.options.baseUrl+l[s]),!z.Utilities.endsWith(l[s],".js")&&!z.Utilities.containsQueryString(l[s])&&(l[s]=l[s]+".js"))}else!z.Utilities.endsWith(p,".js")&&!z.Utilities.containsQueryString(p)&&(p=p+".js"),l=[p];return this._addUrlArgsIfNecessaryToUrls(l)}requireToUrl(o){let p=o;return z.Utilities.isAbsolutePath(p)||(p=this._applyPaths(p)[0],z.Utilities.isAbsolutePath(p)||(p=this.options.baseUrl+p)),this._addUrlArgsIfNecessaryToUrl(p)}isBuild(){return this.options.isBuild}shouldInvokeFactory(o){return!!(!this.options.isBuild||z.Utilities.isAnonymousModule(o)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[o])}isDuplicateMessageIgnoredFor(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)}getConfigForModule(o){if(this.options.config)return this.options.config[o]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(o){this.options.onError(o)}}z.Configuration=P})(we||(we={}));var we;(function(z){class t{constructor(a){this._env=a,this._scriptLoader=null,this._callbackMap={}}load(a,h,R,f){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=a.getConfig().getOptionsLiteral();e?this._scriptLoader=new D:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new D;let d={callback:R,errorback:f};if(this._callbackMap.hasOwnProperty(h)){this._callbackMap[h].push(d);return}this._callbackMap[h]=[d],this._scriptLoader.load(a,h,()=>this.triggerCallback(h),e=>this.triggerErrorback(h,e))}triggerCallback(a){let h=this._callbackMap[a];delete this._callbackMap[a];for(let R=0;R<h.length;R++)h[R].callback()}triggerErrorback(a,h){let R=this._callbackMap[a];delete this._callbackMap[a];for(let f=0;f<R.length;f++)R[f].errorback(h)}}class D{attachListeners(a,h,R){let f=()=>{a.removeEventListener("load",d),a.removeEventListener("error",e)},d=w=>{f(),h()},e=w=>{f(),R(w)};a.addEventListener("load",d),a.addEventListener("error",e)}load(a,h,R,f){if(/^node\|/.test(h)){let d=a.getConfig().getOptionsLiteral(),e=p(a.getRecorder(),d.nodeRequire||z.global.nodeRequire),w=h.split("|"),M=null;try{M=e(w[1])}catch(N){f(N);return}a.enqueueDefineAnonymousModule([],()=>M),R()}else{let d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript"),this.attachListeners(d,R,f);const{trustedTypesPolicy:e}=a.getConfig().getOptionsLiteral();e&&(h=e.createScriptURL(h)),d.setAttribute("src",h);const{cspNonce:w}=a.getConfig().getOptionsLiteral();w&&d.setAttribute("nonce",w),document.getElementsByTagName("head")[0].appendChild(d)}}}function P(s){const{trustedTypesPolicy:a}=s.getConfig().getOptionsLiteral();try{return(a?self.eval(a.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(a){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=P(a)),this._cachedCanUseEval}load(a,h,R,f){if(/^node\|/.test(h)){const d=a.getConfig().getOptionsLiteral(),e=p(a.getRecorder(),d.nodeRequire||z.global.nodeRequire),w=h.split("|");let M=null;try{M=e(w[1])}catch(N){f(N);return}a.enqueueDefineAnonymousModule([],function(){return M}),R()}else{const{trustedTypesPolicy:d}=a.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(a)){fetch(h).then(w=>{if(w.status!==200)throw new Error(w.statusText);return w.text()}).then(w=>{w=`${w}
//# sourceURL=${h}`,(d?self.eval(d.createScript("",w)):new Function(w)).call(self),R()}).then(void 0,f);return}try{d&&(h=d.createScriptURL(h)),importScripts(h),R()}catch(w){f(w)}}}}class o{constructor(a){this._env=a,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(a){this._didInitialize||(this._didInitialize=!0,this._fs=a("fs"),this._vm=a("vm"),this._path=a("path"),this._crypto=a("crypto"))}_initNodeRequire(a,h){const{nodeCachedData:R}=h.getConfig().getOptionsLiteral();if(!R||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const f=this,d=a("module");function e(w){const M=w.constructor;let N=function(A){try{return w.require(A)}finally{}};return N.resolve=function(A,g){return M._resolveFilename(A,w,!1,g)},N.resolve.paths=function(A){return M._resolveLookupPaths(A,w)},N.main=process.mainModule,N.extensions=M._extensions,N.cache=M._cache,N}d.prototype._compile=function(w,M){const N=d.wrap(w.replace(/^#!.*/,"")),b=h.getRecorder(),A=f._getCachedDataPath(R,M),g={filename:M};let c;try{const L=f._fs.readFileSync(A);c=L.slice(0,16),g.cachedData=L.slice(16),b.record(60,A)}catch{b.record(61,A)}const r=new f._vm.Script(N,g),u=r.runInThisContext(g),E=f._path.dirname(M),m=e(this),_=[this.exports,m,this,M,E,process,Ve,Buffer],v=u.apply(this.exports,_);return f._handleCachedData(r,N,A,!g.cachedData,h),f._verifyCachedData(r,N,A,c,h),v}}load(a,h,R,f){const d=a.getConfig().getOptionsLiteral(),e=p(a.getRecorder(),d.nodeRequire||z.global.nodeRequire),w=d.nodeInstrumenter||function(N){return N};this._init(e),this._initNodeRequire(e,a);let M=a.getRecorder();if(/^node\|/.test(h)){let N=h.split("|"),b=null;try{b=e(N[1])}catch(A){f(A);return}a.enqueueDefineAnonymousModule([],()=>b),R()}else{h=z.Utilities.fileUriToFilePath(this._env.isWindows,h);const N=this._path.normalize(h),b=this._getElectronRendererScriptPathOrUri(N),A=!!d.nodeCachedData,g=A?this._getCachedDataPath(d.nodeCachedData,h):void 0;this._readSourceAndCachedData(N,g,M,(c,r,u,E)=>{if(c){f(c);return}let m;r.charCodeAt(0)===o._BOM?m=o._PREFIX+r.substring(1)+o._SUFFIX:m=o._PREFIX+r+o._SUFFIX,m=w(m,N);const _={filename:b,cachedData:u},v=this._createAndEvalScript(a,m,_,R,f);this._handleCachedData(v,m,g,A&&!u,a),this._verifyCachedData(v,m,g,E,a)})}}_createAndEvalScript(a,h,R,f,d){const e=a.getRecorder();e.record(31,R.filename);const w=new this._vm.Script(h,R),M=w.runInThisContext(R),N=a.getGlobalAMDDefineFunc();let b=!1;const A=function(){return b=!0,N.apply(null,arguments)};return A.amd=N.amd,M.call(z.global,a.getGlobalAMDRequireFunc(),A,R.filename,this._path.dirname(R.filename)),e.record(32,R.filename),b?f():d(new Error(`Didn't receive define call in ${R.filename}!`)),w}_getElectronRendererScriptPathOrUri(a){if(!this._env.isElectronRenderer)return a;let h=a.match(/^([a-z])\:(.*)/i);return h?`file:///${(h[1].toUpperCase()+":"+h[2]).replace(/\\/g,"/")}`:`file://${a}`}_getCachedDataPath(a,h){const R=this._crypto.createHash("md5").update(h,"utf8").update(a.seed,"utf8").update(process.arch,"").digest("hex"),f=this._path.basename(h).replace(/\.js$/,"");return this._path.join(a.path,`${f}-${R}.code`)}_handleCachedData(a,h,R,f,d){a.cachedDataRejected?this._fs.unlink(R,e=>{d.getRecorder().record(62,R),this._createAndWriteCachedData(a,h,R,d),e&&d.getConfig().onError(e)}):f&&this._createAndWriteCachedData(a,h,R,d)}_createAndWriteCachedData(a,h,R,f){let d=Math.ceil(f.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,w=0,M;const N=()=>{setTimeout(()=>{M||(M=this._crypto.createHash("md5").update(h,"utf8").digest());const b=a.createCachedData();if(!(b.length===0||b.length===e||w>=5)){if(b.length<e){N();return}e=b.length,this._fs.writeFile(R,Buffer.concat([M,b]),A=>{A&&f.getConfig().onError(A),f.getRecorder().record(63,R),N()})}},d*Math.pow(4,w++))};N()}_readSourceAndCachedData(a,h,R,f){if(!h)this._fs.readFile(a,{encoding:"utf8"},f);else{let d,e,w,M=2;const N=b=>{b?f(b):--M===0&&f(void 0,d,e,w)};this._fs.readFile(a,{encoding:"utf8"},(b,A)=>{d=A,N(b)}),this._fs.readFile(h,(b,A)=>{!b&&A&&A.length>0?(w=A.slice(0,16),e=A.slice(16),R.record(60,h)):R.record(61,h),N()})}}_verifyCachedData(a,h,R,f,d){f&&(a.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(h,"utf8").digest();f.equals(e)||(d.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${R}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(R,w=>{w&&d.getConfig().onError(w)}))},Math.ceil(5e3*(1+Math.random()))))}}o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`;function p(s,a){if(a.__$__isRecorded)return a;const h=function(f){s.record(33,f);try{return a(f)}finally{s.record(34,f)}};return h.__$__isRecorded=!0,h}z.ensureRecordedNodeRequire=p;function l(s){return new t(s)}z.createScriptLoader=l})(we||(we={}));var we;(function(z){class t{constructor(s){let a=s.lastIndexOf("/");a!==-1?this.fromModulePath=s.substr(0,a+1):this.fromModulePath=""}static _normalizeModuleId(s){let a=s,h;for(h=/\/\.\//;h.test(a);)a=a.replace(h,"/");for(a=a.replace(/^\.\//g,""),h=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;h.test(a);)a=a.replace(h,"/");return a=a.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),a}resolveModule(s){let a=s;return z.Utilities.isAbsolutePath(a)||(z.Utilities.startsWith(a,"./")||z.Utilities.startsWith(a,"../"))&&(a=t._normalizeModuleId(this.fromModulePath+a)),a}}t.ROOT=new t(""),z.ModuleIdResolver=t;class D{constructor(s,a,h,R,f,d){this.id=s,this.strId=a,this.dependencies=h,this._callback=R,this._errorback=f,this.moduleIdResolver=d,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(s,a){try{return{returnedValue:s.apply(z.global,a),producedError:null}}catch(h){return{returnedValue:null,producedError:h}}}static _invokeFactory(s,a,h,R){return s.shouldInvokeFactory(a)?s.shouldCatchError()?this._safeInvokeFunction(h,R):{returnedValue:h.apply(z.global,R),producedError:null}:{returnedValue:null,producedError:null}}complete(s,a,h,R){this._isComplete=!0;let f=null;if(this._callback)if(typeof this._callback=="function"){s.record(21,this.strId);let d=D._invokeFactory(a,this.strId,this._callback,h);f=d.producedError,s.record(22,this.strId),!f&&typeof d.returnedValue<"u"&&(!this.exportsPassedIn||z.Utilities.isEmpty(this.exports))&&(this.exports=d.returnedValue)}else this.exports=this._callback;if(f){let d=z.ensureError(f);d.phase="factory",d.moduleId=this.strId,d.neededBy=R(this.id),this.error=d,a.onError(d)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(s){return this._isComplete=!0,this.error=s,this._errorback?(this._errorback(s),!0):!1}isComplete(){return this._isComplete}}z.Module=D;class P{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(s){let a=this._strModuleIdToIntModuleId.get(s);return typeof a>"u"&&(a=this._nextId++,this._strModuleIdToIntModuleId.set(s,a),this._intModuleIdToStrModuleId[a]=s),a}getStrModuleId(s){return this._intModuleIdToStrModuleId[s]}}class i{constructor(s){this.id=s}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),z.RegularDependency=i;class o{constructor(s,a,h){this.id=s,this.pluginId=a,this.pluginParam=h}}z.PluginDependency=o;class p{constructor(s,a,h,R,f=0){this._env=s,this._scriptLoader=a,this._loaderAvailableTimestamp=f,this._defineFunc=h,this._requireFunc=R,this._moduleIdProvider=new P,this._config=new z.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new p(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(s,a){let h=d=>d.replace(/\\/g,"/"),R=h(s),f=a.split(/\n/);for(let d=0;d<f.length;d++){let e=f[d].match(/(.*):(\d+):(\d+)\)?$/);if(e){let w=e[1],M=e[2],N=e[3],b=Math.max(w.lastIndexOf(" ")+1,w.lastIndexOf("(")+1);if(w=w.substr(b),w=h(w),w===R){let A={line:parseInt(M,10),col:parseInt(N,10)};return A.line===1&&(A.col-=53),A}}}throw new Error("Could not correlate define call site for needle "+s)}getBuildInfo(){if(!this._config.isBuild())return null;let s=[],a=0;for(let h=0,R=this._modules2.length;h<R;h++){let f=this._modules2[h];if(!f)continue;let d=this._buildInfoPath[f.id]||null,e=this._buildInfoDefineStack[f.id]||null,w=this._buildInfoDependencies[f.id];s[a++]={id:f.strId,path:d,defineLocation:d&&e?p._findRelevantLocationInStack(d,e):null,dependencies:w,shim:null,exports:f.exports}}return s}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new z.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=z.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(s,a){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let h=null;this._config.isBuild()&&(h=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:h,dependencies:s,callback:a}}defineModule(s,a,h,R,f,d=new t(s)){let e=this._moduleIdProvider.getModuleId(s);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(s)||console.warn("Duplicate definition of module '"+s+"'");return}let w=new D(e,s,this._normalizeDependencies(a,d),h,R,d);this._modules2[e]=w,this._config.isBuild()&&(this._buildInfoDefineStack[e]=f,this._buildInfoDependencies[e]=(w.dependencies||[]).map(M=>this._moduleIdProvider.getStrModuleId(M.id))),this._resolve(w)}_normalizeDependency(s,a){if(s==="exports")return i.EXPORTS;if(s==="module")return i.MODULE;if(s==="require")return i.REQUIRE;let h=s.indexOf("!");if(h>=0){let R=a.resolveModule(s.substr(0,h)),f=a.resolveModule(s.substr(h+1)),d=this._moduleIdProvider.getModuleId(R+"!"+f),e=this._moduleIdProvider.getModuleId(R);return new o(d,e,f)}return new i(this._moduleIdProvider.getModuleId(a.resolveModule(s)))}_normalizeDependencies(s,a){let h=[],R=0;for(let f=0,d=s.length;f<d;f++)h[R++]=this._normalizeDependency(s[f],a);return h}_relativeRequire(s,a,h,R){if(typeof a=="string")return this.synchronousRequire(a,s);this.defineModule(z.Utilities.generateAnonymousModule(),a,h,R,null,s)}synchronousRequire(s,a=new t(s)){let h=this._normalizeDependency(s,a),R=this._modules2[h.id];if(!R)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This is the first mention of this module!");if(!R.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This module has not been resolved completely yet.");if(R.error)throw R.error;return R.exports}configure(s,a){let h=this._config.shouldRecordStats();a?this._config=new z.Configuration(this._env,s):this._config=this._config.cloneAndMerge(s),this._config.shouldRecordStats()&&!h&&(this._recorder=null)}getConfig(){return this._config}_onLoad(s){if(this._currentAnonymousDefineCall!==null){let a=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(s),a.dependencies,a.callback,null,a.stack)}}_createLoadError(s,a){let h=this._moduleIdProvider.getStrModuleId(s),R=(this._inverseDependencies2[s]||[]).map(d=>this._moduleIdProvider.getStrModuleId(d));const f=z.ensureError(a);return f.phase="loading",f.moduleId=h,f.neededBy=R,f}_onLoadError(s,a){const h=this._createLoadError(s,a);this._modules2[s]||(this._modules2[s]=new D(s,this._moduleIdProvider.getStrModuleId(s),[],()=>{},null,null));let R=[];for(let e=0,w=this._moduleIdProvider.getMaxModuleId();e<w;e++)R[e]=!1;let f=!1,d=[];for(d.push(s),R[s]=!0;d.length>0;){let e=d.shift(),w=this._modules2[e];w&&(f=w.onDependencyError(h)||f);let M=this._inverseDependencies2[e];if(M)for(let N=0,b=M.length;N<b;N++){let A=M[N];R[A]||(d.push(A),R[A]=!0)}}f||this._config.onError(h)}_hasDependencyPath(s,a){let h=this._modules2[s];if(!h)return!1;let R=[];for(let d=0,e=this._moduleIdProvider.getMaxModuleId();d<e;d++)R[d]=!1;let f=[];for(f.push(h),R[s]=!0;f.length>0;){let e=f.shift().dependencies;if(e)for(let w=0,M=e.length;w<M;w++){let N=e[w];if(N.id===a)return!0;let b=this._modules2[N.id];b&&!R[N.id]&&(R[N.id]=!0,f.push(b))}}return!1}_findCyclePath(s,a,h){if(s===a||h===50)return[s];let R=this._modules2[s];if(!R)return null;let f=R.dependencies;if(f)for(let d=0,e=f.length;d<e;d++){let w=this._findCyclePath(f[d].id,a,h+1);if(w!==null)return w.push(s),w}return null}_createRequire(s){let a=(h,R,f)=>this._relativeRequire(s,h,R,f);return a.toUrl=h=>this._config.requireToUrl(s.resolveModule(h)),a.getStats=()=>this.getLoaderEvents(),a.hasDependencyCycle=()=>this._hasDependencyCycle,a.config=(h,R=!1)=>{this.configure(h,R)},a.__$__nodeRequire=z.global.nodeRequire,a}_loadModule(s){if(this._modules2[s]||this._knownModules2[s])return;this._knownModules2[s]=!0;let a=this._moduleIdProvider.getStrModuleId(s),h=this._config.moduleIdToPaths(a),R=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(a.indexOf("/")===-1||R.test(a))&&h.push("node|"+a);let f=-1,d=e=>{if(f++,f>=h.length)this._onLoadError(s,e);else{let w=h[f],M=this.getRecorder();if(this._config.isBuild()&&w==="empty:"){this._buildInfoPath[s]=w,this.defineModule(this._moduleIdProvider.getStrModuleId(s),[],null,null,null),this._onLoad(s);return}M.record(10,w),this._scriptLoader.load(this,w,()=>{this._config.isBuild()&&(this._buildInfoPath[s]=w),M.record(11,w),this._onLoad(s)},N=>{M.record(12,w),d(N)})}};d(null)}_loadPluginDependency(s,a){if(this._modules2[a.id]||this._knownModules2[a.id])return;this._knownModules2[a.id]=!0;let h=R=>{this.defineModule(this._moduleIdProvider.getStrModuleId(a.id),[],R,null,null)};h.error=R=>{this._config.onError(this._createLoadError(a.id,R))},s.load(a.pluginParam,this._createRequire(t.ROOT),h,this._config.getOptionsLiteral())}_resolve(s){let a=s.dependencies;if(a)for(let h=0,R=a.length;h<R;h++){let f=a[h];if(f===i.EXPORTS){s.exportsPassedIn=!0,s.unresolvedDependenciesCount--;continue}if(f===i.MODULE){s.unresolvedDependenciesCount--;continue}if(f===i.REQUIRE){s.unresolvedDependenciesCount--;continue}let d=this._modules2[f.id];if(d&&d.isComplete()){if(d.error){s.onDependencyError(d.error);return}s.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(f.id,s.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(f.id)+"' and '"+this._moduleIdProvider.getStrModuleId(s.id)+"'. The cyclic path follows:");let e=this._findCyclePath(f.id,s.id,0)||[];e.reverse(),e.push(f.id),console.warn(e.map(w=>this._moduleIdProvider.getStrModuleId(w)).join(` => 
`)),s.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[f.id]=this._inverseDependencies2[f.id]||[],this._inverseDependencies2[f.id].push(s.id),f instanceof o){let e=this._modules2[f.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,f);continue}let w=this._inversePluginDependencies2.get(f.pluginId);w||(w=[],this._inversePluginDependencies2.set(f.pluginId,w)),w.push(f),this._loadModule(f.pluginId);continue}this._loadModule(f.id)}s.unresolvedDependenciesCount===0&&this._onModuleComplete(s)}_onModuleComplete(s){let a=this.getRecorder();if(s.isComplete())return;let h=s.dependencies,R=[];if(h)for(let w=0,M=h.length;w<M;w++){let N=h[w];if(N===i.EXPORTS){R[w]=s.exports;continue}if(N===i.MODULE){R[w]={id:s.strId,config:()=>this._config.getConfigForModule(s.strId)};continue}if(N===i.REQUIRE){R[w]=this._createRequire(s.moduleIdResolver);continue}let b=this._modules2[N.id];if(b){R[w]=b.exports;continue}R[w]=null}const f=w=>(this._inverseDependencies2[w]||[]).map(M=>this._moduleIdProvider.getStrModuleId(M));s.complete(a,this._config,R,f);let d=this._inverseDependencies2[s.id];if(this._inverseDependencies2[s.id]=null,d)for(let w=0,M=d.length;w<M;w++){let N=d[w],b=this._modules2[N];b.unresolvedDependenciesCount--,b.unresolvedDependenciesCount===0&&this._onModuleComplete(b)}let e=this._inversePluginDependencies2.get(s.id);if(e){this._inversePluginDependencies2.delete(s.id);for(let w=0,M=e.length;w<M;w++)this._loadPluginDependency(s.exports,e[w])}}}z.ModuleManager=p})(we||(we={}));var re,we;(function(z){const t=new z.Environment;let D=null;const P=function(l,s,a){typeof l!="string"&&(a=s,s=l,l=null),(typeof s!="object"||!Array.isArray(s))&&(a=s,s=null),s||(s=["require","exports","module"]),l?D.defineModule(l,s,a,null,null):D.enqueueDefineAnonymousModule(s,a)};P.amd={jQuery:!0};const i=function(l,s=!1){D.configure(l,s)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return D.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){D.defineModule(z.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=i,o.getConfig=function(){return D.getConfig().getOptionsLiteral()},o.reset=function(){D=D.reset()},o.getBuildInfo=function(){return D.getBuildInfo()},o.getStats=function(){return D.getLoaderEvents()},o.define=P;function p(){if(typeof z.global.require<"u"||typeof require<"u"){const l=z.global.require||require;if(typeof l=="function"&&typeof l.resolve=="function"){const s=z.ensureRecordedNodeRequire(D.getRecorder(),l);z.global.nodeRequire=s,o.nodeRequire=s,o.__$__nodeRequire=s}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=o:(t.isElectronRenderer||(z.global.define=P),z.global.require=o)}z.init=p,(typeof z.global.define!="function"||!z.global.define.amd)&&(D=new z.ModuleManager(t,z.createScriptLoader(t),P,o,z.Utilities.getHighPerformanceTimestamp()),typeof z.global.require<"u"&&typeof z.global.require!="function"&&o.config(z.global.require),re=function(){return P.apply(null,arguments)},re.amd=P.amd,typeof doNotInitLoader>"u"&&p())})(we||(we={})),re(se[63],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function D(l,s,a,h){if(h=h||{},(h["vs/css"]||{}).disabled){a({});return}const f=s.toUrl(l+".css");P(l,f,()=>{a({})},d=>{typeof a.error=="function"&&a.error("Could not find "+f+".")})}t.load=D;function P(l,s,a,h){if(i(l,s)){a();return}o(l,s,a,h)}function i(l,s){const a=document.getElementsByTagName("link");for(let h=0,R=a.length;h<R;h++){const f=a[h].getAttribute("data-name"),d=a[h].getAttribute("href");if(f===l||d===s)return!0}return!1}function o(l,s,a,h){const R=document.createElement("link");R.setAttribute("rel","stylesheet"),R.setAttribute("type","text/css"),R.setAttribute("data-name",l),p(l,R,a,h),R.setAttribute("href",s),(document.head||document.getElementsByTagName("head")[0]).appendChild(R)}function p(l,s,a,h){const R=()=>{s.removeEventListener("load",f),s.removeEventListener("error",d)},f=e=>{R(),a()},d=e=>{R(),h(e)};s.addEventListener("load",f),s.addEventListener("error",d)}}),re("vs/nls",["require","exports"],function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let D=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const P="i-default";function i(e,w){let M;return w.length===0?M=e:M=e.replace(/\{(\d+)\}/g,(N,b)=>{const A=b[0],g=w[A];let c=N;return typeof g=="string"?c=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(c=String(g)),c}),D&&(M="\uFF3B"+M.replace(/[aouei]/g,"$&$&")+"\uFF3D"),M}function o(e,w){let M=e[w];return M||(M=e["*"],M)?M:null}function p(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function l(e,w,M){const N=p(e)+p(w)+"vscode/"+p(M),b=await fetch(N);if(b.ok)return await b.json();throw new Error(`${b.status} - ${b.statusText}`)}function s(e){return function(w,M){const N=Array.prototype.slice.call(arguments,2);return i(e[w],N)}}function a(e,w,...M){return i(w,M)}t.localize=a;function h(e){}t.getConfiguredDefaultLocale=h;function R(e){D=e}t.setPseudoTranslation=R;function f(e,w){return{localize:s(w[e]),getConfiguredDefaultLocale:w.getConfiguredDefaultLocale??(M=>{})}}t.create=f;function d(e,w,M,N){const b=N["vs/nls"]??{};if(!e||e.length===0)return M({localize:a,getConfiguredDefaultLocale:()=>b.availableLanguages?.["*"]});const A=b.availableLanguages?o(b.availableLanguages,e):null,g=A===null||A===P;let c=".nls";g||(c=c+"."+A);const r=u=>{Array.isArray(u)?u.localize=s(u):u.localize=s(u[e]),u.getConfiguredDefaultLocale=()=>b.availableLanguages?.["*"],M(u)};typeof b.loadBundle=="function"?b.loadBundle(e,A,(u,E)=>{u?w([e+".nls"],r):r(E)}):b.translationServiceUrl&&!g?(async()=>{try{const u=await l(b.translationServiceUrl,A,e);return r(u)}catch(u){if(!A.includes("-"))return console.error(u),w([e+".nls"],r);try{const E=A.split("-")[0],m=await l(b.translationServiceUrl,E,e);return b.availableLanguages??={},b.availableLanguages["*"]=E,r(m)}catch(E){return console.error(E),w([e+".nls"],r)}}})():w([e+c],r,u=>{if(c===".nls"){console.error("Failed trying to load default language strings",u);return}console.error(`Failed to load message bundle for language ${A}. Falling back to the default language:`,u),w([e+".nls"],r)})}t.load=d}),function(){const z=globalThis.MonacoEnvironment,t=z&&z.baseUrl?z.baseUrl:"../../../";function D(h,R){if(z?.createTrustedTypesPolicy)try{return z.createTrustedTypesPolicy(h,R)}catch(f){console.warn(f);return}try{return self.trustedTypes?.createPolicy(h,R)}catch(f){console.warn(f);return}}const P=D("amdLoader",{createScriptURL:h=>h,createScript:(h,...R)=>{const f=R.slice(0,-1).join(","),d=R.pop().toString();return`(function anonymous(${f}) { ${d}
})`}});function i(){try{return(P?globalThis.eval(P.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function o(){return new Promise((h,R)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return h();const f=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(f).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${f}`,(P?globalThis.eval(P.createScript("",e)):new Function(e)).call(globalThis),h()}).then(void 0,R);return}P?importScripts(P.createScriptURL(f)):importScripts(f),h()})}function p(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:P,amdModulesPattern:/^vs\//})}function l(h){o().then(()=>{p(),require([h],function(R){setTimeout(function(){const f=R.create((d,e)=>{globalThis.postMessage(d,e)},null);for(globalThis.onmessage=d=>f.onmessage(d.data,d.ports);a.length>0;){const d=a.shift();f.onmessage(d.data,d.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&p();let s=!0;const a=[];globalThis.onmessage=h=>{if(!s){a.push(h);return}s=!1,l(h.data)}}(),re(se[28],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function D(p,l){const s=Object.create(null);for(const a of p){const h=l(a);let R=s[h];R||(R=s[h]=[]),R.push(a)}return s}t.groupBy=D;function P(p,l){const s=[],a=[];for(const h of p)l.has(h)||s.push(h);for(const h of l)p.has(h)||a.push(h);return{removed:s,added:a}}t.diffSets=P;function i(p,l){const s=[],a=[];for(const[h,R]of p)l.has(h)||s.push(R);for(const[h,R]of l)p.has(h)||a.push(R);return{removed:s,added:a}}t.diffMaps=i;class o{constructor(){this.map=new Map}add(l,s){let a=this.map.get(l);a||(a=new Set,this.map.set(l,a)),a.add(s)}delete(l,s){const a=this.map.get(l);a&&(a.delete(s),a.size===0&&this.map.delete(l))}forEach(l,s){const a=this.map.get(l);a&&a.forEach(s)}get(l){const s=this.map.get(l);return s||new Set}}t.SetMap=o}),re(se[29],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function D(l,s){const a=Math.pow(10,s);return Math.round(l*a)/a}class P{constructor(s,a,h,R=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,s))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=D(Math.max(Math.min(1,R),0),3)}static equals(s,a){return s.r===a.r&&s.g===a.g&&s.b===a.b&&s.a===a.a}}t.RGBA=P;class i{constructor(s,a,h,R){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=D(Math.max(Math.min(1,a),0),3),this.l=D(Math.max(Math.min(1,h),0),3),this.a=D(Math.max(Math.min(1,R),0),3)}static equals(s,a){return s.h===a.h&&s.s===a.s&&s.l===a.l&&s.a===a.a}static fromRGBA(s){const a=s.r/255,h=s.g/255,R=s.b/255,f=s.a,d=Math.max(a,h,R),e=Math.min(a,h,R);let w=0,M=0;const N=(e+d)/2,b=d-e;if(b>0){switch(M=Math.min(N<=.5?b/(2*N):b/(2-2*N),1),d){case a:w=(h-R)/b+(h<R?6:0);break;case h:w=(R-a)/b+2;break;case R:w=(a-h)/b+4;break}w*=60,w=Math.round(w)}return new i(w,M,N,f)}static _hue2rgb(s,a,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?s+(a-s)*6*h:h<1/2?a:h<2/3?s+(a-s)*(2/3-h)*6:s}static toRGBA(s){const a=s.h/360,{s:h,l:R,a:f}=s;let d,e,w;if(h===0)d=e=w=R;else{const M=R<.5?R*(1+h):R+h-R*h,N=2*R-M;d=i._hue2rgb(N,M,a+1/3),e=i._hue2rgb(N,M,a),w=i._hue2rgb(N,M,a-1/3)}return new P(Math.round(d*255),Math.round(e*255),Math.round(w*255),f)}}t.HSLA=i;class o{constructor(s,a,h,R){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=D(Math.max(Math.min(1,a),0),3),this.v=D(Math.max(Math.min(1,h),0),3),this.a=D(Math.max(Math.min(1,R),0),3)}static equals(s,a){return s.h===a.h&&s.s===a.s&&s.v===a.v&&s.a===a.a}static fromRGBA(s){const a=s.r/255,h=s.g/255,R=s.b/255,f=Math.max(a,h,R),d=Math.min(a,h,R),e=f-d,w=f===0?0:e/f;let M;return e===0?M=0:f===a?M=((h-R)/e%6+6)%6:f===h?M=(R-a)/e+2:M=(a-h)/e+4,new o(Math.round(M*60),w,f,s.a)}static toRGBA(s){const{h:a,s:h,v:R,a:f}=s,d=R*h,e=d*(1-Math.abs(a/60%2-1)),w=R-d;let[M,N,b]=[0,0,0];return a<60?(M=d,N=e):a<120?(M=e,N=d):a<180?(N=d,b=e):a<240?(N=e,b=d):a<300?(M=e,b=d):a<=360&&(M=d,b=e),M=Math.round((M+w)*255),N=Math.round((N+w)*255),b=Math.round((b+w)*255),new P(M,N,b,f)}}t.HSVA=o;class p{static fromHex(s){return p.Format.CSS.parseHex(s)||p.red}static equals(s,a){return!s&&!a?!0:!s||!a?!1:s.equals(a)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:o.fromRGBA(this.rgba)}constructor(s){if(s)if(s instanceof P)this.rgba=s;else if(s instanceof i)this._hsla=s,this.rgba=i.toRGBA(s);else if(s instanceof o)this._hsva=s,this.rgba=o.toRGBA(s);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(s){return!!s&&P.equals(this.rgba,s.rgba)&&i.equals(this.hsla,s.hsla)&&o.equals(this.hsva,s.hsva)}getRelativeLuminance(){const s=p._relativeLuminanceForComponent(this.rgba.r),a=p._relativeLuminanceForComponent(this.rgba.g),h=p._relativeLuminanceForComponent(this.rgba.b),R=.2126*s+.7152*a+.0722*h;return D(R,4)}static _relativeLuminanceForComponent(s){const a=s/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(s){const a=this.getRelativeLuminance(),h=s.getRelativeLuminance();return a>h?(a+.05)/(h+.05):(h+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(s){const a=this.getRelativeLuminance(),h=s.getRelativeLuminance();return a>h}isDarkerThan(s){const a=this.getRelativeLuminance(),h=s.getRelativeLuminance();return a<h}lighten(s){return new p(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*s,this.hsla.a))}darken(s){return new p(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*s,this.hsla.a))}transparent(s){const{r:a,g:h,b:R,a:f}=this.rgba;return new p(new P(a,h,R,f*s))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new p(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(s){const a=s.rgba,h=this.rgba.a,R=a.a,f=h+R*(1-h);if(f<1e-6)return p.transparent;const d=this.rgba.r*h/f+a.r*R*(1-h)/f,e=this.rgba.g*h/f+a.g*R*(1-h)/f,w=this.rgba.b*h/f+a.b*R*(1-h)/f;return new p(new P(d,e,w,f))}makeOpaque(s){if(this.isOpaque()||s.rgba.a!==1)return this;const{r:a,g:h,b:R,a:f}=this.rgba;return new p(new P(s.rgba.r-f*(s.rgba.r-a),s.rgba.g-f*(s.rgba.g-h),s.rgba.b-f*(s.rgba.b-R),1))}flatten(...s){const a=s.reduceRight((h,R)=>p._flatten(R,h));return p._flatten(this,a)}static _flatten(s,a){const h=1-s.rgba.a;return new p(new P(h*a.rgba.r+s.rgba.a*s.rgba.r,h*a.rgba.g+s.rgba.a*s.rgba.g,h*a.rgba.b+s.rgba.a*s.rgba.b))}toString(){return this._toString||(this._toString=p.Format.CSS.format(this)),this._toString}static getLighterColor(s,a,h){if(s.isLighterThan(a))return s;h=h||.5;const R=s.getRelativeLuminance(),f=a.getRelativeLuminance();return h=h*(f-R)/f,s.lighten(h)}static getDarkerColor(s,a,h){if(s.isDarkerThan(a))return s;h=h||.5;const R=s.getRelativeLuminance(),f=a.getRelativeLuminance();return h=h*(R-f)/R,s.darken(h)}static{this.white=new p(new P(255,255,255,1))}static{this.black=new p(new P(0,0,0,1))}static{this.red=new p(new P(255,0,0,1))}static{this.blue=new p(new P(0,0,255,1))}static{this.green=new p(new P(0,255,0,1))}static{this.cyan=new p(new P(0,255,255,1))}static{this.lightgrey=new p(new P(211,211,211,1))}static{this.transparent=new p(new P(0,0,0,0))}}t.Color=p,function(l){let s;(function(a){let h;(function(R){function f(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:l.Format.CSS.formatRGBA(r)}R.formatRGB=f;function d(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}R.formatRGBA=d;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:l.Format.CSS.formatHSLA(r)}R.formatHSL=e;function w(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}R.formatHSLA=w;function M(r){const u=r.toString(16);return u.length!==2?"0"+u:u}function N(r){return`#${M(r.rgba.r)}${M(r.rgba.g)}${M(r.rgba.b)}`}R.formatHex=N;function b(r,u=!1){return u&&r.rgba.a===1?l.Format.CSS.formatHex(r):`#${M(r.rgba.r)}${M(r.rgba.g)}${M(r.rgba.b)}${M(Math.round(r.rgba.a*255))}`}R.formatHexA=b;function A(r){return r.isOpaque()?l.Format.CSS.formatHex(r):l.Format.CSS.formatRGBA(r)}R.format=A;function g(r){const u=r.length;if(u===0||r.charCodeAt(0)!==35)return null;if(u===7){const E=16*c(r.charCodeAt(1))+c(r.charCodeAt(2)),m=16*c(r.charCodeAt(3))+c(r.charCodeAt(4)),_=16*c(r.charCodeAt(5))+c(r.charCodeAt(6));return new l(new P(E,m,_,1))}if(u===9){const E=16*c(r.charCodeAt(1))+c(r.charCodeAt(2)),m=16*c(r.charCodeAt(3))+c(r.charCodeAt(4)),_=16*c(r.charCodeAt(5))+c(r.charCodeAt(6)),v=16*c(r.charCodeAt(7))+c(r.charCodeAt(8));return new l(new P(E,m,_,v/255))}if(u===4){const E=c(r.charCodeAt(1)),m=c(r.charCodeAt(2)),_=c(r.charCodeAt(3));return new l(new P(16*E+E,16*m+m,16*_+_))}if(u===5){const E=c(r.charCodeAt(1)),m=c(r.charCodeAt(2)),_=c(r.charCodeAt(3)),v=c(r.charCodeAt(4));return new l(new P(16*E+E,16*m+m,16*_+_,(16*v+v)/255))}return null}R.parseHex=g;function c(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(h=a.CSS||(a.CSS={}))})(s=l.Format||(l.Format={}))}(p||(t.Color=p={}))}),re(se[30],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class D{constructor(i,o,p,l){this.originalStart=i,this.originalLength=o,this.modifiedStart=p,this.modifiedLength=l}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=D}),re(se[3],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(u){setTimeout(()=>{throw u.stack?g.isErrorNoTelemetry(u)?new g(u.message+`

`+u.stack):new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.listeners.push(u),()=>{this._removeListener(u)}}emit(u){this.listeners.forEach(E=>{E(u)})}_removeListener(u){this.listeners.splice(this.listeners.indexOf(u),1)}setUnexpectedErrorHandler(u){this.unexpectedErrorHandler=u}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(u){this.unexpectedErrorHandler(u),this.emit(u)}onUnexpectedExternalError(u){this.unexpectedErrorHandler(u)}}t.ErrorHandler=D,t.errorHandler=new D;function P(r){t.errorHandler.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=P;function i(r){if(!r||typeof r!="object")return!1;const u=r;return u.code==="EPIPE"&&u.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function o(r){a(r)||t.errorHandler.onUnexpectedError(r)}t.onUnexpectedError=o;function p(r){a(r)||t.errorHandler.onUnexpectedExternalError(r)}t.onUnexpectedExternalError=p;function l(r){if(r instanceof Error){const{name:u,message:E}=r,m=r.stacktrace||r.stack;return{$isError:!0,name:u,message:E,stack:m,noTelemetry:g.isErrorNoTelemetry(r)}}return r}t.transformErrorForSerialization=l;const s="Canceled";function a(r){return r instanceof h?!0:r instanceof Error&&r.name===s&&r.message===s}t.isCancellationError=a;class h extends Error{constructor(){super(s),this.name=this.message}}t.CancellationError=h;function R(){const r=new Error(s);return r.name=r.message,r}t.canceled=R;function f(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.illegalArgument=f;function d(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.illegalState=d;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function w(r){const u=new Error(`${r} has been disposed`);return u.name="DISPOSED",u}t.disposed=w;function M(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.getErrorMessage=M;class N extends Error{constructor(u){super("NotImplemented"),u&&(this.message=u)}}t.NotImplementedError=N;class b extends Error{constructor(u){super("NotSupported"),u&&(this.message=u)}}t.NotSupportedError=b;class A extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=A;class g extends Error{constructor(u){super(u),this.name="CodeExpectedError"}static fromError(u){if(u instanceof g)return u;const E=new g;return E.message=u.message,E.stack=u.stack,E}static isErrorNoTelemetry(u){return u.name==="CodeExpectedError"}}t.ErrorNoTelemetry=g;class c extends Error{constructor(u){super(u||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}t.BugIndicatingError=c}),re(se[15],ae([0,1,3]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMaxIdxBy=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.reverseOrder=t.booleanComparator=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.findLastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function P(k,O=0){return k[k.length-(1+O)]}t.tail=P;function i(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}t.tail2=i;function o(k,O,T=(B,q)=>B===q){if(k===O)return!0;if(!k||!O||k.length!==O.length)return!1;for(let B=0,q=k.length;B<q;B++)if(!T(k[B],O[B]))return!1;return!0}t.equals=o;function p(k,O){const T=k.length-1;O<T&&(k[O]=k[T]),k.pop()}t.removeFastWithoutKeepingOrder=p;function l(k,O,T){return s(k.length,B=>T(k[B],O))}t.binarySearch=l;function s(k,O){let T=0,B=k-1;for(;T<=B;){const q=(T+B)/2|0,J=O(q);if(J<0)T=q+1;else if(J>0)B=q-1;else return q}return-(T+1)}t.binarySearch2=s;function a(k,O){let T=0,B=k.length;if(B===0)return 0;for(;T<B;){const q=Math.floor((T+B)/2);O(k[q])?B=q:T=q+1}return T}t.findFirstInSorted=a;function h(k,O,T){if(k=k|0,k>=O.length)throw new TypeError("invalid index");const B=O[Math.floor(O.length*Math.random())],q=[],J=[],te=[];for(const oe of O){const he=T(oe,B);he<0?q.push(oe):he>0?J.push(oe):te.push(oe)}return k<q.length?h(k,q,T):k<q.length+te.length?te[0]:h(k-(q.length+te.length),J,T)}t.quickSelect=h;function R(k,O){const T=[];let B;for(const q of k.slice(0).sort(O))!B||O(B[0],q)!==0?(B=[q],T.push(B)):B.push(q);return T}t.groupBy=R;function f(k,O,T){const B=[];function q(oe,he,me){if(he===0&&me.length===0)return;const _e=B[B.length-1];_e&&_e.start+_e.deleteCount===oe?(_e.deleteCount+=he,_e.toInsert.push(...me)):B.push({start:oe,deleteCount:he,toInsert:me})}let J=0,te=0;for(;;){if(J===k.length){q(J,0,O.slice(te));break}if(te===O.length){q(J,k.length-J,[]);break}const oe=k[J],he=O[te],me=T(oe,he);me===0?(J+=1,te+=1):me<0?(q(J,1,[]),J+=1):me>0&&(q(J,0,[he]),te+=1)}return B}t.sortedDiff=f;function d(k,O,T){const B=f(k,O,T),q=[],J=[];for(const te of B)q.push(...k.slice(te.start,te.start+te.deleteCount)),J.push(...te.toInsert);return{removed:q,added:J}}t.delta=d;function e(k,O,T){if(T===0)return[];const B=k.slice(0,T).sort(O);return M(k,O,B,T,k.length),B}t.top=e;function w(k,O,T,B,q){return T===0?Promise.resolve([]):new Promise((J,te)=>{(async()=>{const oe=k.length,he=k.slice(0,T).sort(O);for(let me=T,_e=Math.min(T+B,oe);me<oe;me=_e,_e=Math.min(_e+B,oe)){if(me>T&&await new Promise(ye=>setTimeout(ye)),q&&q.isCancellationRequested)throw new D.CancellationError;M(k,O,he,me,_e)}return he})().then(J,te)})}t.topAsync=w;function M(k,O,T,B,q){for(const J=T.length;B<q;B++){const te=k[B];if(O(te,T[J-1])<0){T.pop();const oe=a(T,he=>O(te,he)<0);T.splice(oe,0,te)}}}function N(k){return k.filter(O=>!!O)}t.coalesce=N;function b(k){let O=0;for(let T=0;T<k.length;T++)k[T]&&(k[O]=k[T],O+=1);k.length=O}t.coalesceInPlace=b;function A(k,O,T){k.splice(T,0,k.splice(O,1)[0])}t.move=A;function g(k){return!Array.isArray(k)||k.length===0}t.isFalsyOrEmpty=g;function c(k){return Array.isArray(k)&&k.length>0}t.isNonEmptyArray=c;function r(k,O=T=>T){const T=new Set;return k.filter(B=>{const q=O(B);return T.has(q)?!1:(T.add(q),!0)})}t.distinct=r;function u(k){const O=new Set;return T=>{const B=k(T);return O.has(B)?!1:(O.add(B),!0)}}t.uniqueFilter=u;function E(k,O){const T=m(k,O);if(T!==-1)return k[T]}t.findLast=E;function m(k,O){for(let T=k.length-1;T>=0;T--){const B=k[T];if(O(B))return T}return-1}t.findLastIndex=m;function _(k,O){return k.length>0?k[0]:O}t.firstOrDefault=_;function v(k,O){return k.length>0?k[k.length-1]:O}t.lastOrDefault=v;function L(k,O,T=(B,q)=>B===q){let B=0;for(let q=0,J=Math.min(k.length,O.length);q<J&&T(k[q],O[q]);q++)B++;return B}t.commonPrefixLength=L;function y(k){return[].concat(...k)}t.flatten=y;function C(k,O){let T=typeof O=="number"?k:0;typeof O=="number"?T=k:(T=0,O=k);const B=[];if(T<=O)for(let q=T;q<O;q++)B.push(q);else for(let q=T;q>O;q--)B.push(q);return B}t.range=C;function S(k,O,T){return k.reduce((B,q)=>(B[O(q)]=T?T(q):q,B),Object.create(null))}t.index=S;function U(k,O){return k.push(O),()=>H(k,O)}t.insert=U;function H(k,O){const T=k.indexOf(O);if(T>-1)return k.splice(T,1),O}t.remove=H;function x(k,O,T){const B=k.slice(0,O),q=k.slice(O);return B.concat(T,q)}t.arrayInsert=x;function Q(k,O){let T;if(typeof O=="number"){let B=O;T=()=>{const q=Math.sin(B++)*179426549;return q-Math.floor(q)}}else T=Math.random;for(let B=k.length-1;B>0;B-=1){const q=Math.floor(T()*(B+1)),J=k[B];k[B]=k[q],k[q]=J}}t.shuffle=Q;function F(k,O){const T=k.indexOf(O);T>-1&&(k.splice(T,1),k.unshift(O))}t.pushToStart=F;function j(k,O){const T=k.indexOf(O);T>-1&&(k.splice(T,1),k.push(O))}t.pushToEnd=j;function Z(k,O){for(const T of O)k.push(T)}t.pushMany=Z;function Y(k,O){return Array.isArray(k)?k.map(O):O(k)}t.mapArrayOrNot=Y;function ge(k){return Array.isArray(k)?k:[k]}t.asArray=ge;function n(k){return k[Math.floor(Math.random()*k.length)]}t.getRandomElement=n;function W(k,O){for(const T of k){const B=O(T);if(B!==void 0)return B}}t.mapFind=W;function $(k,O,T){const B=X(k,O),q=k.length,J=T.length;k.length=q+J;for(let te=q-1;te>=B;te--)k[te+J]=k[te];for(let te=0;te<J;te++)k[te+B]=T[te]}t.insertInto=$;function K(k,O,T,B){const q=X(k,O),J=k.splice(q,T);return $(k,q,B),J}t.splice=K;function X(k,O){return O<0?Math.max(O+k.length,0):Math.min(O,k.length)}var ie;(function(k){function O(J){return J<0}k.isLessThan=O;function T(J){return J<=0}k.isLessThanOrEqual=T;function B(J){return J>0}k.isGreaterThan=B;function q(J){return J===0}k.isNeitherLessOrGreaterThan=q,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(ie||(t.CompareResult=ie={}));function le(k,O){return(T,B)=>O(k(T),k(B))}t.compareBy=le;function ce(...k){return(O,T)=>{for(const B of k){const q=B(O,T);if(!ie.isNeitherLessOrGreaterThan(q))return q}return ie.neitherLessOrGreaterThan}}t.tieBreakComparators=ce;const fe=(k,O)=>k-O;t.numberComparator=fe;const be=(k,O)=>(0,t.numberComparator)(k?1:0,O?1:0);t.booleanComparator=be;function Le(k){return(O,T)=>-k(O,T)}t.reverseOrder=Le;function ve(k,O){if(k.length===0)return;let T=k[0];for(let B=1;B<k.length;B++){const q=k[B];O(q,T)>0&&(T=q)}return T}t.findMaxBy=ve;function Ae(k,O){if(k.length===0)return;let T=k[0];for(let B=1;B<k.length;B++){const q=k[B];O(q,T)>=0&&(T=q)}return T}t.findLastMaxBy=Ae;function pe(k,O){return ve(k,(T,B)=>-O(T,B))}t.findMinBy=pe;function Ne(k,O){if(k.length===0)return-1;let T=0;for(let B=1;B<k.length;B++){const q=k[B];O(q,k[T])>0&&(T=B)}return T}t.findMaxIdxBy=Ne;class Me{constructor(O){this.items=O,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(O){let T=this.firstIdx;for(;T<this.items.length&&O(this.items[T]);)T++;const B=T===this.firstIdx?null:this.items.slice(this.firstIdx,T);return this.firstIdx=T,B}takeFromEndWhile(O){let T=this.lastIdx;for(;T>=0&&O(this.items[T]);)T--;const B=T===this.lastIdx?null:this.items.slice(T+1,this.lastIdx+1);return this.lastIdx=T,B}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const O=this.items[this.firstIdx];return this.firstIdx++,O}removeLast(){const O=this.items[this.lastIdx];return this.lastIdx--,O}takeCount(O){const T=this.items.slice(this.firstIdx,this.firstIdx+O);return this.firstIdx+=O,T}}t.ArrayQueue=Me;class ne{static{this.empty=new ne(O=>{})}constructor(O){this.iterate=O}forEach(O){this.iterate(T=>(O(T),!0))}toArray(){const O=[];return this.iterate(T=>(O.push(T),!0)),O}filter(O){return new ne(T=>this.iterate(B=>O(B)?T(B):!0))}map(O){return new ne(T=>this.iterate(B=>T(O(B))))}some(O){let T=!1;return this.iterate(B=>(T=O(B),!T)),T}findFirst(O){let T;return this.iterate(B=>O(B)?(T=B,!1):!0),T}findLast(O){let T;return this.iterate(B=>(O(B)&&(T=B),!0)),T}findLastMaxBy(O){let T,B=!0;return this.iterate(q=>((B||ie.isGreaterThan(O(q,T)))&&(B=!1,T=q),!0)),T}}t.CallbackIterable=ne}),re(se[10],ae([0,1,3]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function P(s,a){if(!s)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}t.ok=P;function i(s,a="Unreachable"){throw new Error(a)}t.assertNever=i;function o(s){if(!s)throw new D.BugIndicatingError("Assertion Failed")}t.assert=o;function p(s){if(!s()){debugger;s(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}t.assertFn=p;function l(s,a){let h=0;for(;h<s.length-1;){const R=s[h],f=s[h+1];if(!a(R,f))return!1;h++}return!0}t.checkAdjacentItems=l}),re(se[16],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function D(P){const i=this;let o=!1,p;return function(){return o||(o=!0,p=P.apply(i,arguments)),p}}t.once=D}),re(se[17],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var D;(function(P){function i(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}P.is=i;const o=Object.freeze([]);function p(){return o}P.empty=p;function*l(g){yield g}P.single=l;function s(g){return i(g)?g:l(g)}P.wrap=s;function a(g){return g||o}P.from=a;function h(g){return!g||g[Symbol.iterator]().next().done===!0}P.isEmpty=h;function R(g){return g[Symbol.iterator]().next().value}P.first=R;function f(g,c){for(const r of g)if(c(r))return!0;return!1}P.some=f;function d(g,c){for(const r of g)if(c(r))return r}P.find=d;function*e(g,c){for(const r of g)c(r)&&(yield r)}P.filter=e;function*w(g,c){let r=0;for(const u of g)yield c(u,r++)}P.map=w;function*M(...g){for(const c of g)for(const r of c)yield r}P.concat=M;function N(g,c,r){let u=r;for(const E of g)u=c(u,E);return u}P.reduce=N;function*b(g,c,r=g.length){for(c<0&&(c+=g.length),r<0?r+=g.length:r>g.length&&(r=g.length);c<r;c++)yield g[c]}P.slice=b;function A(g,c=Number.POSITIVE_INFINITY){const r=[];if(c===0)return[r,g];const u=g[Symbol.iterator]();for(let E=0;E<c;E++){const m=u.next();if(m.done)return[r,P.empty()];r.push(m.value)}return[r,{[Symbol.iterator](){return u}}]}P.consume=A})(D||(t.Iterable=D={}))}),re(se[31],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(D||(t.KeyCode=D={}));var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(P||(t.ScanCode=P={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,M){this._keyCodeToStr[w]=M,this._strToKeyCode[M.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const o=new i,p=new i,l=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const s=[],a=Object.create(null),h=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>h[e]||0,toEnum:e=>a[e]||0,toString:e=>s[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",w=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],M=[],N=[];for(const b of w){const[A,g,c,r,u,E,m,_,v]=b;if(N[g]||(N[g]=!0,s[g]=c,a[c]=g,h[c.toLowerCase()]=g,A&&(t.IMMUTABLE_CODE_TO_KEY_CODE[g]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[r]=g))),!M[r]){if(M[r]=!0,!u)throw new Error(`String representation missing for key code ${r} around scan code ${c}`);o.define(r,u),p.define(r,_||u),l.define(r,v||_||u)}E&&(t.EVENT_KEY_CODE_MAP[E]=r),m&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[m]=r)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var R;(function(e){function w(c){return o.keyCodeToStr(c)}e.toString=w;function M(c){return o.strToKeyCode(c)}e.fromString=M;function N(c){return p.keyCodeToStr(c)}e.toUserSettingsUS=N;function b(c){return l.keyCodeToStr(c)}e.toUserSettingsGeneral=b;function A(c){return p.strToKeyCode(c)||l.strToKeyCode(c)}e.fromUserSettings=A;function g(c){if(c>=98&&c<=113)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return o.keyCodeToStr(c)}e.toElectronAccelerator=g})(R||(t.KeyCodeUtils=R={}));var f;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(f||(t.KeyMod=f={}));function d(e,w){const M=(w&65535)<<16>>>0;return(e|M)>>>0}t.KeyChord=d}),re(se[32],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class D{constructor(i){this.executor=i,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=D}),re(se[7],ae([0,1,16,17]),function(z,t,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let o=null;function p(v){o=v}if(t.setDisposableTracker=p,i){const v="__is_disposable_tracked__";p(new class{trackDisposable(L){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[v]||console.log(y)},3e3)}setParent(L,y){if(L&&L!==b.None)try{L[v]=!0}catch{}}markAsDisposed(L){if(L&&L!==b.None)try{L[v]=!0}catch{}}markAsSingleton(L){}})}function l(v){return o?.trackDisposable(v),v}function s(v){o?.markAsDisposed(v)}function a(v,L){o?.setParent(v,L)}function h(v,L){if(o)for(const y of v)o.setParent(y,L)}function R(v){return o?.markAsSingleton(v),v}t.markAsSingleton=R;function f(v){return typeof v.dispose=="function"&&v.dispose.length===0}t.isDisposable=f;function d(v){if(P.Iterable.is(v)){const L=[];for(const y of v)if(y)try{y.dispose()}catch(C){L.push(C)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}t.dispose=d;function e(v){for(const L of v)f(L)&&L.dispose();return[]}t.disposeIfDisposable=e;function w(...v){const L=M(()=>d(v));return h(v,L),L}t.combinedDisposable=w;function M(v){const L=l({dispose:(0,D.once)(()=>{s(L),v()})});return L}t.toDisposable=M;class N{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,l(this)}dispose(){this._isDisposed||(s(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{d(this._toDispose)}finally{this._toDispose.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return a(L,this),this._isDisposed?N.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(L),L}}t.DisposableStore=N;class b{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new N,l(this),a(this._store,this)}dispose(){s(this),this._store.dispose()}_register(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(L)}}t.Disposable=b;class A{constructor(){this._isDisposed=!1,l(this)}get value(){return this._isDisposed?void 0:this._value}set value(L){this._isDisposed||L===this._value||(this._value?.dispose(),L&&a(L,this),this._value=L)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,s(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const L=this._value;return this._value=void 0,L&&a(L,null),L}}t.MutableDisposable=A;class g{constructor(L){this._disposable=L,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=g;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,l(this)}set(L){let y=L;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,s(this))},this}}t.SafeDisposable=c;class r{constructor(){this.references=new Map}acquire(L,...y){let C=this.references.get(L);C||(C={counter:0,object:this.createReferencedObject(L,...y)},this.references.set(L,C));const{object:S}=C,U=(0,D.once)(()=>{--C.counter===0&&(this.destroyReferencedObject(L,C.object),this.references.delete(L))});return C.counter++,{object:S,dispose:U}}}t.ReferenceCollection=r;class u{constructor(L){this.referenceCollection=L}async acquire(L,...y){const C=this.referenceCollection.acquire(L,...y);try{return{object:await C.object,dispose:()=>C.dispose()}}catch(S){throw C.dispose(),S}}}t.AsyncReferenceCollection=u;class E{constructor(L){this.object=L}dispose(){}}t.ImmortalReference=E;function m(v){const L=new N;try{v(L)}finally{L.dispose()}}t.disposeOnReturn=m;class _{constructor(){this._store=new Map,this._isDisposed=!1,l(this)}dispose(){s(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{d(this._store.values())}finally{this._store.clear()}}has(L){return this._store.has(L)}get(L){return this._store.get(L)}set(L,y,C=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),C||this._store.get(L)?.dispose(),this._store.set(L,y)}deleteAndDispose(L){this._store.get(L)?.dispose(),this._store.delete(L)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=_}),re(se[18],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class D{static{this.Undefined=new D(void 0)}constructor(o){this.element=o,this.next=D.Undefined,this.prev=D.Undefined}}class P{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let o=this._first;for(;o!==D.Undefined;){const p=o.next;o.prev=D.Undefined,o.next=D.Undefined,o=p}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(o){return this._insert(o,!1)}push(o){return this._insert(o,!0)}_insert(o,p){const l=new D(o);if(this._first===D.Undefined)this._first=l,this._last=l;else if(p){const a=this._last;this._last=l,l.prev=a,a.next=l}else{const a=this._first;this._first=l,l.next=a,a.prev=l}this._size+=1;let s=!1;return()=>{s||(s=!0,this._remove(l))}}shift(){if(this._first!==D.Undefined){const o=this._first.element;return this._remove(this._first),o}}pop(){if(this._last!==D.Undefined){const o=this._last.element;return this._remove(this._last),o}}_remove(o){if(o.prev!==D.Undefined&&o.next!==D.Undefined){const p=o.prev;p.next=o.next,o.next.prev=p}else o.prev===D.Undefined&&o.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):o.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):o.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let o=this._first;for(;o!==D.Undefined;)yield o.element,o=o.next}}t.LinkedList=P}),re(se[19],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class P{static create(o){return new P(o)}constructor(o){this._now=D&&o===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=P}),re(se[8],ae([0,1,3,16,7,18,19]),function(z,t,D,P,i,o,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const l=!1,s=!1;var a;(function(C){C.None=()=>i.Disposable.None;function S(ne){if(s){const{onDidAddListener:k}=ne,O=e.create();let T=0;ne.onDidAddListener=()=>{++T===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),O.print()),k?.()}}}function U(ne,k){return n(ne,()=>{},0,void 0,!0,void 0,k)}C.defer=U;function H(ne){return(k,O=null,T)=>{let B=!1,q;return q=ne(J=>{if(!B)return q?q.dispose():B=!0,k.call(O,J)},null,T),B&&q.dispose(),q}}C.once=H;function x(ne,k,O){return ge((T,B=null,q)=>ne(J=>T.call(B,k(J)),null,q),O)}C.map=x;function Q(ne,k,O){return ge((T,B=null,q)=>ne(J=>{k(J),T.call(B,J)},null,q),O)}C.forEach=Q;function F(ne,k,O){return ge((T,B=null,q)=>ne(J=>k(J)&&T.call(B,J),null,q),O)}C.filter=F;function j(ne){return ne}C.signal=j;function Z(...ne){return(k,O=null,T)=>(0,i.combinedDisposable)(...ne.map(B=>B(q=>k.call(O,q),null,T)))}C.any=Z;function Y(ne,k,O,T){let B=O;return x(ne,q=>(B=k(B,q),B),T)}C.reduce=Y;function ge(ne,k){let O;const T={onWillAddFirstListener(){O=ne(B.fire,B)},onDidRemoveLastListener(){O?.dispose()}};k||S(T);const B=new A(T);return k?.add(B),B.event}function n(ne,k,O=100,T=!1,B=!1,q,J){let te,oe,he,me=0,_e;const ye={leakWarningThreshold:q,onWillAddFirstListener(){te=ne(Ue=>{me++,oe=k(oe,Ue),T&&!he&&(Ie.fire(oe),oe=void 0),_e=()=>{const Be=oe;oe=void 0,he=void 0,(!T||me>1)&&Ie.fire(Be),me=0},typeof O=="number"?(clearTimeout(he),he=setTimeout(_e,O)):he===void 0&&(he=0,queueMicrotask(_e))})},onWillRemoveListener(){B&&me>0&&_e?.()},onDidRemoveLastListener(){_e=void 0,te.dispose()}};J||S(ye);const Ie=new A(ye);return J?.add(Ie),Ie.event}C.debounce=n;function W(ne,k=0,O){return C.debounce(ne,(T,B)=>T?(T.push(B),T):[B],k,void 0,!0,void 0,O)}C.accumulate=W;function $(ne,k=(T,B)=>T===B,O){let T=!0,B;return F(ne,q=>{const J=T||!k(q,B);return T=!1,B=q,J},O)}C.latch=$;function K(ne,k,O){return[C.filter(ne,k,O),C.filter(ne,T=>!k(T),O)]}C.split=K;function X(ne,k=!1,O=[]){let T=O.slice(),B=ne(te=>{T?T.push(te):J.fire(te)});const q=()=>{T?.forEach(te=>J.fire(te)),T=null},J=new A({onWillAddFirstListener(){B||(B=ne(te=>J.fire(te)))},onDidAddFirstListener(){T&&(k?setTimeout(q):q())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return J.event}C.buffer=X;class ie{constructor(k){this.event=k,this.disposables=new i.DisposableStore}map(k){return new ie(x(this.event,k,this.disposables))}forEach(k){return new ie(Q(this.event,k,this.disposables))}filter(k){return new ie(F(this.event,k,this.disposables))}reduce(k,O){return new ie(Y(this.event,k,O,this.disposables))}latch(){return new ie($(this.event,void 0,this.disposables))}debounce(k,O=100,T=!1,B=!1,q){return new ie(n(this.event,k,O,T,B,q,this.disposables))}on(k,O,T){return this.event(k,O,T)}once(k,O,T){return H(this.event)(k,O,T)}dispose(){this.disposables.dispose()}}function le(ne){return new ie(ne)}C.chain=le;function ce(ne,k,O=T=>T){const T=(...te)=>J.fire(O(...te)),B=()=>ne.on(k,T),q=()=>ne.removeListener(k,T),J=new A({onWillAddFirstListener:B,onDidRemoveLastListener:q});return J.event}C.fromNodeEventEmitter=ce;function fe(ne,k,O=T=>T){const T=(...te)=>J.fire(O(...te)),B=()=>ne.addEventListener(k,T),q=()=>ne.removeEventListener(k,T),J=new A({onWillAddFirstListener:B,onDidRemoveLastListener:q});return J.event}C.fromDOMEventEmitter=fe;function be(ne){return new Promise(k=>H(ne)(k))}C.toPromise=be;function Le(ne){const k=new A;return ne.then(O=>{k.fire(O)},()=>{k.fire(void 0)}).finally(()=>{k.dispose()}),k.event}C.fromPromise=Le;function ve(ne,k){return k(void 0),ne(O=>k(O))}C.runAndSubscribe=ve;function Ae(ne,k){let O=null;function T(q){O?.dispose(),O=new i.DisposableStore,k(q,O)}T(void 0);const B=ne(q=>T(q));return(0,i.toDisposable)(()=>{B.dispose(),O?.dispose()})}C.runAndSubscribeWithStore=Ae;class pe{constructor(k,O){this._observable=k,this._counter=0,this._hasChanged=!1;const T={onWillAddFirstListener:()=>{k.addObserver(this)},onDidRemoveLastListener:()=>{k.removeObserver(this)}};O||S(T),this.emitter=new A(T),O&&O.add(this.emitter)}beginUpdate(k){this._counter++}handlePossibleChange(k){}handleChange(k,O){this._hasChanged=!0}endUpdate(k){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Ne(ne,k){return new pe(ne,k).emitter.event}C.fromObservable=Ne;function Me(ne){return k=>{let O=0,T=!1;const B={beginUpdate(){O++},endUpdate(){O--,O===0&&(ne.reportChanges(),T&&(T=!1,k()))},handlePossibleChange(){},handleChange(){T=!0}};return ne.addObserver(B),ne.reportChanges(),{dispose(){ne.removeObserver(B)}}}}C.fromObservableLight=Me})(a||(t.Event=a={}));class h{static{this.all=new Set}static{this._idPool=0}constructor(S){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${S}_${h._idPool++}`,h.all.add(this)}start(S){this._stopWatch=new p.StopWatch,this.listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this.durations.push(S),this.elapsedOverall+=S,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=h;let R=-1;function f(C){const S=R;return R=C,{dispose(){R=S}}}t.setGlobalLeakWarningThreshold=f;class d{constructor(S,U=Math.random().toString(18).slice(2,5)){this.threshold=S,this.name=U,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(S,U){const H=this.threshold;if(H<=0||U<H)return;this._stacks||(this._stacks=new Map);const x=this._stacks.get(S.value)||0;if(this._stacks.set(S.value,x+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=H*.5;let Q,F=0;for(const[j,Z]of this._stacks)(!Q||F<Z)&&(Q=j,F=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${U} listeners already. MOST frequent listener (${F}):`),console.warn(Q)}return()=>{const Q=this._stacks.get(S.value)||0;this._stacks.set(S.value,Q-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(S){this.value=S}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class M{constructor(S){this.value=S,this.id=w++}}const N=2,b=(C,S)=>{if(C instanceof M)S(C);else for(let U=0;U<C.length;U++){const H=C[U];H&&S(H)}};class A{constructor(S){this._size=0,this._options=S,this._leakageMon=R>0||this._options?.leakWarningThreshold?new d(this._options?.leakWarningThreshold??R):void 0,this._perfMon=this._options?._profName?new h(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(l){const S=this._listeners;queueMicrotask(()=>{b(S,U=>U.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(S,U,H)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;if(this._disposed)return i.Disposable.None;U&&(S=S.bind(U));const x=new M(S);let Q,F;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(x.stack=e.create(),Q=this._leakageMon.check(x.stack,this._size+1)),l&&(x.stack=F??e.create()),this._listeners?this._listeners instanceof M?(this._deliveryQueue??=new c,this._listeners=[this._listeners,x]):this._listeners.push(x):(this._options?.onWillAddFirstListener?.(this),this._listeners=x,this._options?.onDidAddFirstListener?.(this)),this._size++;const j=(0,i.toDisposable)(()=>{Q?.(),this._removeListener(x)});return H instanceof i.DisposableStore?H.add(j):Array.isArray(H)&&H.push(j),j},this._event}_removeListener(S){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const U=this._listeners,H=U.indexOf(S);if(H===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,U[H]=void 0;const x=this._deliveryQueue.current===this;if(this._size*N<=U.length){let Q=0;for(let F=0;F<U.length;F++)U[F]?U[Q++]=U[F]:x&&(this._deliveryQueue.end--,Q<this._deliveryQueue.i&&this._deliveryQueue.i--);U.length=Q}}_deliver(S,U){if(!S)return;const H=this._options?.onListenerError||D.onUnexpectedError;if(!H){S.value(U);return}try{S.value(U)}catch(x){H(x)}}_deliverQueue(S){const U=S.current._listeners;for(;S.i<S.end;)this._deliver(U[S.i++],S.value);S.reset()}fire(S){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof M)this._deliver(this._listeners,S);else{const U=this._deliveryQueue;U.enqueue(this,S,this._listeners.length),this._deliverQueue(U)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=A;const g=()=>new c;t.createEventDeliveryQueue=g;class c{constructor(){this.i=-1,this.end=0}enqueue(S,U,H){this.i=0,this.end=H,this.current=S,this.value=U}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends A{async fireAsync(S,U,H){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new o.LinkedList),b(this._listeners,x=>this._asyncDeliveryQueue.push([x.value,S]));this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[x,Q]=this._asyncDeliveryQueue.shift(),F=[],j={...Q,token:U,waitUntil:Z=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");H&&(Z=H(Z,x)),F.push(Z)}};try{x(j)}catch(Z){(0,D.onUnexpectedError)(Z);continue}Object.freeze(F),await Promise.allSettled(F).then(Z=>{for(const Y of Z)Y.status==="rejected"&&(0,D.onUnexpectedError)(Y.reason)})}}}t.AsyncEmitter=r;class u extends A{get isPaused(){return this._isPaused!==0}constructor(S){super(S),this._isPaused=0,this._eventQueue=new o.LinkedList,this._mergeFn=S?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._size&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}t.PauseableEmitter=u;class E extends u{constructor(S){super(S),this._delay=S.delay??100}fire(S){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(S)}}t.DebounceEmitter=E;class m extends A{constructor(S){super(S),this._queuedEvents=[],this._mergeFn=S?.merge}fire(S){this.hasListeners()&&(this._queuedEvents.push(S),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(U=>super.fire(U)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=m;class _{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new A({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const U={event:S,listener:null};this.events.push(U),this.hasListeners&&this.hook(U);const H=()=>{this.hasListeners&&this.unhook(U);const x=this.events.indexOf(U);this.events.splice(x,1)};return(0,i.toDisposable)((0,P.once)(H))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(U=>this.emitter.fire(U))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=_;class v{constructor(S,U,H,x){this._store=new i.DisposableStore;const Q=this._store.add(new _),F=this._store.add(new i.DisposableMap);function j(Z){F.set(Z,Q.add(x(Z)))}for(const Z of S)j(Z);this._store.add(U(Z=>{j(Z)})),this._store.add(H(Z=>{F.deleteAndDispose(Z)})),this.event=Q.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=v;class L{constructor(){this.buffers=[]}wrapEvent(S){return(U,H,x)=>S(Q=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>U.call(H,Q)):U.call(H,Q)},void 0,x)}bufferEvents(S){const U=[];this.buffers.push(U);const H=S();return this.buffers.pop(),U.forEach(x=>x()),H}}t.EventBufferer=L;class y{constructor(){this.listening=!1,this.inputEvent=a.None,this.inputEventListener=i.Disposable.None,this.emitter=new A({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=y}),re(se[20],ae([0,1,8]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const P=Object.freeze(function(l,s){const a=setTimeout(l.bind(s),0);return{dispose(){clearTimeout(a)}}});var i;(function(l){function s(a){return a===l.None||a===l.Cancelled||a instanceof o?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}l.isCancellationToken=s,l.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),l.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(i||(t.CancellationToken=i={}));class o{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?P:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class p{constructor(s){this._token=void 0,this._parentListener=void 0,this._parentListener=s&&s.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new o),this._token}cancel(){this._token?this._token instanceof o&&this._token.cancel():this._token=i.Cancelled}dispose(s=!1){s&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof o&&this._token.dispose():this._token=i.None}}t.CancellationTokenSource=p}),re(se[33],ae([0,1,20]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class P{constructor(l){this.task=l,this.result=null}get(){if(this.result)return this.result;const l=new D.CancellationTokenSource,s=this.task(l.token);return this.result={promise:s,dispose:()=>{this.result=null,l.cancel(),l.dispose()}},this.result}}t.Cache=P;class i{constructor(l){this.fn=l,this.lastCache=void 0,this.lastArgKey=void 0}get(l){const s=JSON.stringify(l);return this.lastArgKey!==s&&(this.lastArgKey=s,this.lastCache=this.fn(l)),this.lastCache}}t.LRUCachedFunction=i;class o{get cachedValues(){return this._map}constructor(l){this.fn=l,this._map=new Map}get(l){if(this._map.has(l))return this._map.get(l);const s=this.fn(l);return this._map.set(l,s),s}}t.CachedFunction=o}),re(se[5],ae([0,1,33,32]),function(z,t,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function i(I){return!I||typeof I!="string"?!0:I.trim().length===0}t.isFalsyOrWhitespace=i;const o=/{(\d+)}/g;function p(I,...V){return V.length===0?I:I.replace(o,function(G,ee){const ue=parseInt(ee,10);return isNaN(ue)||ue<0||ue>=V.length?G:V[ue]})}t.format=p;const l=/{([^}]+)}/g;function s(I,V){return I.replace(l,(G,ee)=>V[ee]??G)}t.format2=s;function a(I){return I.replace(/[<>&]/g,function(V){switch(V){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return V}})}t.escape=a;function h(I){return I.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=h;function R(I,V){let G=0;const ee=V.charCodeAt(0);for(let ue=I.length-1;ue>=0;ue--)I.charCodeAt(ue)===ee&&G++;return G}t.count=R;function f(I,V,G="\u2026"){return I.length<=V?I:`${I.substr(0,V)}${G}`}t.truncate=f;function d(I,V=" "){const G=e(I,V);return w(G,V)}t.trim=d;function e(I,V){if(!I||!V)return I;const G=V.length;if(G===0||I.length===0)return I;let ee=0;for(;I.indexOf(V,ee)===ee;)ee=ee+G;return I.substring(ee)}t.ltrim=e;function w(I,V){if(!I||!V)return I;const G=V.length,ee=I.length;if(G===0||ee===0)return I;let ue=ee,de=-1;for(;de=I.lastIndexOf(V,ue-1),!(de===-1||de+G!==ue);){if(de===0)return"";ue=de}return I.substring(0,ue)}t.rtrim=w;function M(I){return I.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=M;function N(I){return I.replace(/\*/g,"")}t.stripWildcards=N;function b(I,V,G={}){if(!I)throw new Error("Cannot create regex from empty string");V||(I=h(I)),G.wholeWord&&(/\B/.test(I.charAt(0))||(I="\\b"+I),/\B/.test(I.charAt(I.length-1))||(I=I+"\\b"));let ee="";return G.global&&(ee+="g"),G.matchCase||(ee+="i"),G.multiline&&(ee+="m"),G.unicode&&(ee+="u"),new RegExp(I,ee)}t.createRegExp=b;function A(I){return I.source==="^"||I.source==="^$"||I.source==="$"||I.source==="^\\s*$"?!1:!!(I.exec("")&&I.lastIndex===0)}t.regExpLeadsToEndlessLoop=A;function g(I){return I.split(/\r\n|\r|\n/)}t.splitLines=g;function c(I){for(let V=0,G=I.length;V<G;V++){const ee=I.charCodeAt(V);if(ee!==32&&ee!==9)return V}return-1}t.firstNonWhitespaceIndex=c;function r(I,V=0,G=I.length){for(let ee=V;ee<G;ee++){const ue=I.charCodeAt(ee);if(ue!==32&&ue!==9)return I.substring(V,ee)}return I.substring(V,G)}t.getLeadingWhitespace=r;function u(I,V=I.length-1){for(let G=V;G>=0;G--){const ee=I.charCodeAt(G);if(ee!==32&&ee!==9)return G}return-1}t.lastNonWhitespaceIndex=u;function E(I,V,G){const ee=[];let ue=0;for(const de of I.matchAll(V)){if(ee.push(I.slice(ue,de.index)),de.index===void 0)throw new Error("match.index should be defined");ue=de.index+de[0].length,ee.push(G(de[0],...de.slice(1),de.index,I,de.groups))}return ee.push(I.slice(ue)),Promise.all(ee).then(de=>de.join(""))}t.replaceAsync=E;function m(I,V){return I<V?-1:I>V?1:0}t.compare=m;function _(I,V,G=0,ee=I.length,ue=0,de=V.length){for(;G<ee&&ue<de;G++,ue++){const De=I.charCodeAt(G),Se=V.charCodeAt(ue);if(De<Se)return-1;if(De>Se)return 1}const Ee=ee-G,Pe=de-ue;return Ee<Pe?-1:Ee>Pe?1:0}t.compareSubstring=_;function v(I,V){return L(I,V,0,I.length,0,V.length)}t.compareIgnoreCase=v;function L(I,V,G=0,ee=I.length,ue=0,de=V.length){for(;G<ee&&ue<de;G++,ue++){let De=I.charCodeAt(G),Se=V.charCodeAt(ue);if(De===Se)continue;if(De>=128||Se>=128)return _(I.toLowerCase(),V.toLowerCase(),G,ee,ue,de);C(De)&&(De-=32),C(Se)&&(Se-=32);const Re=De-Se;if(Re!==0)return Re}const Ee=ee-G,Pe=de-ue;return Ee<Pe?-1:Ee>Pe?1:0}t.compareSubstringIgnoreCase=L;function y(I){return I>=48&&I<=57}t.isAsciiDigit=y;function C(I){return I>=97&&I<=122}t.isLowerAsciiLetter=C;function S(I){return I>=65&&I<=90}t.isUpperAsciiLetter=S;function U(I,V){return I.length===V.length&&L(I,V)===0}t.equalsIgnoreCase=U;function H(I,V){const G=V.length;return V.length>I.length?!1:L(I,V,0,G)===0}t.startsWithIgnoreCase=H;function x(I,V){const G=Math.min(I.length,V.length);let ee;for(ee=0;ee<G;ee++)if(I.charCodeAt(ee)!==V.charCodeAt(ee))return ee;return G}t.commonPrefixLength=x;function Q(I,V){const G=Math.min(I.length,V.length);let ee;const ue=I.length-1,de=V.length-1;for(ee=0;ee<G;ee++)if(I.charCodeAt(ue-ee)!==V.charCodeAt(de-ee))return ee;return G}t.commonSuffixLength=Q;function F(I){return 55296<=I&&I<=56319}t.isHighSurrogate=F;function j(I){return 56320<=I&&I<=57343}t.isLowSurrogate=j;function Z(I,V){return(I-55296<<10)+(V-56320)+65536}t.computeCodePoint=Z;function Y(I,V,G){const ee=I.charCodeAt(G);if(F(ee)&&G+1<V){const ue=I.charCodeAt(G+1);if(j(ue))return Z(ee,ue)}return ee}t.getNextCodePoint=Y;function ge(I,V){const G=I.charCodeAt(V-1);if(j(G)&&V>1){const ee=I.charCodeAt(V-2);if(F(ee))return Z(ee,G)}return G}class n{get offset(){return this._offset}constructor(V,G=0){this._str=V,this._len=V.length,this._offset=G}setOffset(V){this._offset=V}prevCodePoint(){const V=ge(this._str,this._offset);return this._offset-=V>=65536?2:1,V}nextCodePoint(){const V=Y(this._str,this._len,this._offset);return this._offset+=V>=65536?2:1,V}eol(){return this._offset>=this._len}}t.CodePointIterator=n;class W{get offset(){return this._iterator.offset}constructor(V,G=0){this._iterator=new n(V,G)}nextGraphemeLength(){const V=ye.getInstance(),G=this._iterator,ee=G.offset;let ue=V.getGraphemeBreakType(G.nextCodePoint());for(;!G.eol();){const de=G.offset,Ee=V.getGraphemeBreakType(G.nextCodePoint());if(me(ue,Ee)){G.setOffset(de);break}ue=Ee}return G.offset-ee}prevGraphemeLength(){const V=ye.getInstance(),G=this._iterator,ee=G.offset;let ue=V.getGraphemeBreakType(G.prevCodePoint());for(;G.offset>0;){const de=G.offset,Ee=V.getGraphemeBreakType(G.prevCodePoint());if(me(Ee,ue)){G.setOffset(de);break}ue=Ee}return ee-G.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=W;function $(I,V){return new W(I,V).nextGraphemeLength()}t.nextCharLength=$;function K(I,V){return new W(I,V).prevGraphemeLength()}t.prevCharLength=K;function X(I,V){V>0&&j(I.charCodeAt(V))&&V--;const G=V+$(I,V);return[G-K(I,G),G]}t.getCharContainingOffset=X;function ie(I){const V=new W(I);let G=0;for(;!V.eol();)G++,V.nextGraphemeLength();return G}t.charCount=ie;let le;function ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function fe(I){return le||(le=ce()),le.test(I)}t.containsRTL=fe;const be=/^[\t\n\r\x20-\x7E]*$/;function Le(I){return be.test(I)}t.isBasicASCII=Le,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ve(I){return t.UNUSUAL_LINE_TERMINATORS.test(I)}t.containsUnusualLineTerminators=ve;function Ae(I){return I>=11904&&I<=55215||I>=63744&&I<=64255||I>=65281&&I<=65374}t.isFullWidthCharacter=Ae;function pe(I){return I>=127462&&I<=127487||I===8986||I===8987||I===9200||I===9203||I>=9728&&I<=10175||I===11088||I===11093||I>=127744&&I<=128591||I>=128640&&I<=128764||I>=128992&&I<=129008||I>=129280&&I<=129535||I>=129648&&I<=129782}t.isEmojiImprecise=pe;function Ne(I,V){if(I.length<V)return I;const G=/\b/g;let ee=0;for(;G.test(I)&&!(I.length-G.lastIndex<V);)ee=G.lastIndex,G.lastIndex+=1;return I.substring(ee).replace(/^\s/,"")}t.lcut=Ne;const Me=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ne=/\x1b\].*?\x07/g;function k(I){return I&&(I=I.replace(Me,"").replace(ne,"")),I}t.removeAnsiEscapeCodes=k,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function O(I){return!!(I&&I.length>0&&I.charCodeAt(0)===65279)}t.startsWithUTF8BOM=O;function T(I){return O(I)?I.substr(1):I}t.stripUTF8BOM=T;function B(I,V){if(!I||!V||I.length<V.length)return!1;const G=V.length,ee=I.toLowerCase();let ue=0,de=-1;for(;ue<G;){const Ee=ee.indexOf(V[ue],de+1);if(Ee<0)return!1;de=Ee,ue++}return!0}t.fuzzyContains=B;function q(I,V=!1){return I?(V&&(I=I.replace(/\\./g,"")),I.toLowerCase()!==I):!1}t.containsUppercaseCharacter=q;function J(I){return I.charAt(0).toUpperCase()+I.slice(1)}t.uppercaseFirstLetter=J;function te(I,V=1){if(V===0)return"";let G=-1;do G=I.indexOf(`
`,G+1),V--;while(V>0&&G>=0);return G===-1?I:(I[G-1]==="\r"&&G--,I.substr(0,G))}t.getNLines=te;function oe(I){return I=I%(2*26),I<26?String.fromCharCode(97+I):String.fromCharCode(65+I-26)}t.singleLetterHash=oe;function he(I){return ye.getInstance().getGraphemeBreakType(I)}t.getGraphemeBreakType=he;function me(I,V){return I===0?V!==5&&V!==7:I===2&&V===3?!1:I===4||I===2||I===3||V===4||V===2||V===3?!0:!(I===8&&(V===8||V===9||V===11||V===12)||(I===11||I===9)&&(V===9||V===10)||(I===12||I===10)&&V===10||V===5||V===13||V===7||I===1||I===13&&V===14||I===6&&V===6)}var _e;(function(I){I[I.Other=0]="Other",I[I.Prepend=1]="Prepend",I[I.CR=2]="CR",I[I.LF=3]="LF",I[I.Control=4]="Control",I[I.Extend=5]="Extend",I[I.Regional_Indicator=6]="Regional_Indicator",I[I.SpacingMark=7]="SpacingMark",I[I.L=8]="L",I[I.V=9]="V",I[I.T=10]="T",I[I.LV=11]="LV",I[I.LVT=12]="LVT",I[I.ZWJ=13]="ZWJ",I[I.Extended_Pictographic=14]="Extended_Pictographic"})(_e||(t.GraphemeBreakType=_e={}));class ye{static{this._INSTANCE=null}static getInstance(){return ye._INSTANCE||(ye._INSTANCE=new ye),ye._INSTANCE}constructor(){this._data=Ie()}getGraphemeBreakType(V){if(V<32)return V===10?3:V===13?2:4;if(V<127)return 0;const G=this._data,ee=G.length/3;let ue=1;for(;ue<=ee;)if(V<G[3*ue])ue=2*ue;else if(V>G[3*ue+1])ue=2*ue+1;else return G[3*ue+2];return 0}}function Ie(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(I,V){if(I===0)return 0;const G=Be(I,V);if(G!==void 0)return G;const ee=new n(V,I);return ee.prevCodePoint(),ee.offset}t.getLeftDeleteOffset=Ue;function Be(I,V){const G=new n(V,I);let ee=G.prevCodePoint();for(;ze(ee)||ee===65039||ee===8419;){if(G.offset===0)return;ee=G.prevCodePoint()}if(!pe(ee))return;let ue=G.offset;return ue>0&&G.prevCodePoint()===8205&&(ue=G.offset),ue}function ze(I){return 127995<=I&&I<=127999}var qe;(function(I){I[I.zwj=8205]="zwj",I[I.emojiVariantSelector=65039]="emojiVariantSelector",I[I.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),t.noBreakWhitespace="\xA0";class ke{static{this.ambiguousCharacterData=new P.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new D.LRUCachedFunction(V=>{function G(Re){const Te=new Map;for(let Fe=0;Fe<Re.length;Fe+=2)Te.set(Re[Fe],Re[Fe+1]);return Te}function ee(Re,Te){const Fe=new Map(Re);for(const[Oe,xe]of Te)Fe.set(Oe,xe);return Fe}function ue(Re,Te){if(!Re)return Te;const Fe=new Map;for(const[Oe,xe]of Re)Te.has(Oe)&&Fe.set(Oe,xe);return Fe}const de=this.ambiguousCharacterData.value;let Ee=V.filter(Re=>!Re.startsWith("_")&&Re in de);Ee.length===0&&(Ee=["_default"]);let Pe;for(const Re of Ee){const Te=G(de[Re]);Pe=ue(Pe,Te)}const De=G(de._common),Se=ee(De,Pe);return new ke(Se)})}static getInstance(V){return ke.cache.get(Array.from(V))}static{this._locales=new P.Lazy(()=>Object.keys(ke.ambiguousCharacterData.value).filter(V=>!V.startsWith("_")))}static getLocales(){return ke._locales.value}constructor(V){this.confusableDictionary=V}isAmbiguous(V){return this.confusableDictionary.has(V)}getPrimaryConfusable(V){return this.confusableDictionary.get(V)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=ke;class Ce{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ce.getRawData())),this._data}static isInvisibleCharacter(V){return Ce.getData().has(V)}static get codePoints(){return Ce.getData()}}t.InvisibleCharacters=Ce}),re(se[34],ae([0,1,5]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function P(N){return i(N,0)}t.hash=P;function i(N,b){switch(typeof N){case"object":return N===null?o(349,b):Array.isArray(N)?s(N,b):a(N,b);case"string":return l(N,b);case"boolean":return p(N,b);case"number":return o(N,b);case"undefined":return o(937,b);default:return o(617,b)}}t.doHash=i;function o(N,b){return(b<<5)-b+N|0}t.numberHash=o;function p(N,b){return o(N?433:863,b)}function l(N,b){b=o(149417,b);for(let A=0,g=N.length;A<g;A++)b=o(N.charCodeAt(A),b);return b}t.stringHash=l;function s(N,b){return b=o(104579,b),N.reduce((A,g)=>i(g,A),b)}function a(N,b){return b=o(181387,b),Object.keys(N).sort().reduce((A,g)=>(A=l(g,A),i(N[g],A)),b)}class h{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=i(b,this._value),this._value}}t.Hasher=h;var R;(function(N){N[N.BLOCK_SIZE=64]="BLOCK_SIZE",N[N.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function f(N,b,A=32){const g=A-b,c=~((1<<g)-1);return(N<<b|(c&N)>>>g)>>>0}function d(N,b=0,A=N.byteLength,g=0){for(let c=0;c<A;c++)N[b+c]=g}function e(N,b,A="0"){for(;N.length<b;)N=A+N;return N}function w(N,b=32){return N instanceof ArrayBuffer?Array.from(new Uint8Array(N)).map(A=>A.toString(16).padStart(2,"0")).join(""):e((N>>>0).toString(16),b/4)}t.toHexString=w;class M{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const A=b.length;if(A===0)return;const g=this._buff;let c=this._buffLen,r=this._leftoverHighSurrogate,u,E;for(r!==0?(u=r,E=-1,r=0):(u=b.charCodeAt(0),E=0);;){let m=u;if(D.isHighSurrogate(u))if(E+1<A){const _=b.charCodeAt(E+1);D.isLowSurrogate(_)?(E++,m=D.computeCodePoint(u,_)):m=65533}else{r=u;break}else D.isLowSurrogate(u)&&(m=65533);if(c=this._push(g,c,m),E++,E<A)u=b.charCodeAt(E);else break}this._buffLen=c,this._leftoverHighSurrogate=r}_push(b,A,g){return g<128?b[A++]=g:g<2048?(b[A++]=192|(g&1984)>>>6,b[A++]=128|(g&63)>>>0):g<65536?(b[A++]=224|(g&61440)>>>12,b[A++]=128|(g&4032)>>>6,b[A++]=128|(g&63)>>>0):(b[A++]=240|(g&1835008)>>>18,b[A++]=128|(g&258048)>>>12,b[A++]=128|(g&4032)>>>6,b[A++]=128|(g&63)>>>0),A>=64&&(this._step(),A-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),A}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=M._bigBlock32,A=this._buffDV;for(let L=0;L<64;L+=4)b.setUint32(L,A.getUint32(L,!1),!1);for(let L=64;L<320;L+=4)b.setUint32(L,f(b.getUint32(L-12,!1)^b.getUint32(L-32,!1)^b.getUint32(L-56,!1)^b.getUint32(L-64,!1),1),!1);let g=this._h0,c=this._h1,r=this._h2,u=this._h3,E=this._h4,m,_,v;for(let L=0;L<80;L++)L<20?(m=c&r|~c&u,_=1518500249):L<40?(m=c^r^u,_=1859775393):L<60?(m=c&r|c&u|r&u,_=2400959708):(m=c^r^u,_=3395469782),v=f(g,5)+m+E+_+b.getUint32(L*4,!1)&4294967295,E=u,u=r,r=f(c,30),c=g,g=v;this._h0=this._h0+g&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+E&4294967295}}t.StringSHA1=M}),re(se[21],ae([0,1,30,34]),function(z,t,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(f){this.source=f}getElements(){const f=this.source,d=new Int32Array(f.length);for(let e=0,w=f.length;e<w;e++)d[e]=f.charCodeAt(e);return d}}t.StringDiffSequence=i;function o(R,f,d){return new h(new i(R),new i(f)).ComputeDiff(d).changes}t.stringDiff=o;class p{static Assert(f,d){if(!f)throw new Error(d)}}class l{static Copy(f,d,e,w,M){for(let N=0;N<M;N++)e[w+N]=f[d+N]}static Copy2(f,d,e,w,M){for(let N=0;N<M;N++)e[w+N]=f[d+N]}}var s;(function(R){R[R.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(s||(s={}));class a{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new D.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(f,d){this.m_originalStart=Math.min(this.m_originalStart,f),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_originalCount++}AddModifiedElement(f,d){this.m_originalStart=Math.min(this.m_originalStart,f),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class h{constructor(f,d,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=f,this._modifiedSequence=d;const[w,M,N]=h._getElements(f),[b,A,g]=h._getElements(d);this._hasStrings=N&&g,this._originalStringElements=w,this._originalElementsOrHash=M,this._modifiedStringElements=b,this._modifiedElementsOrHash=A,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(f){return f.length>0&&typeof f[0]=="string"}static _getElements(f){const d=f.getElements();if(h._isStringArray(d)){const e=new Int32Array(d.length);for(let w=0,M=d.length;w<M;w++)e[w]=(0,P.stringHash)(d[w],0);return[d,e,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}ElementsAreEqual(f,d){return this._originalElementsOrHash[f]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[f]===this._modifiedStringElements[d]:!0}ElementsAreStrictEqual(f,d){if(!this.ElementsAreEqual(f,d))return!1;const e=h._getStrictElement(this._originalSequence,f),w=h._getStrictElement(this._modifiedSequence,d);return e===w}static _getStrictElement(f,d){return typeof f.getStrictElement=="function"?f.getStrictElement(d):null}OriginalElementsAreEqual(f,d){return this._originalElementsOrHash[f]!==this._originalElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[f]===this._originalStringElements[d]:!0}ModifiedElementsAreEqual(f,d){return this._modifiedElementsOrHash[f]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._modifiedStringElements[f]===this._modifiedStringElements[d]:!0}ComputeDiff(f){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,f)}_ComputeDiff(f,d,e,w,M){const N=[!1];let b=this.ComputeDiffRecursive(f,d,e,w,N);return M&&(b=this.PrettifyChanges(b)),{quitEarly:N[0],changes:b}}ComputeDiffRecursive(f,d,e,w,M){for(M[0]=!1;f<=d&&e<=w&&this.ElementsAreEqual(f,e);)f++,e++;for(;d>=f&&w>=e&&this.ElementsAreEqual(d,w);)d--,w--;if(f>d||e>w){let r;return e<=w?(p.Assert(f===d+1,"originalStart should only be one more than originalEnd"),r=[new D.DiffChange(f,0,e,w-e+1)]):f<=d?(p.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),r=[new D.DiffChange(f,d-f+1,e,0)]):(p.Assert(f===d+1,"originalStart should only be one more than originalEnd"),p.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const N=[0],b=[0],A=this.ComputeRecursionPoint(f,d,e,w,N,b,M),g=N[0],c=b[0];if(A!==null)return A;if(!M[0]){const r=this.ComputeDiffRecursive(f,g,e,c,M);let u=[];return M[0]?u=[new D.DiffChange(g+1,d-(g+1)+1,c+1,w-(c+1)+1)]:u=this.ComputeDiffRecursive(g+1,d,c+1,w,M),this.ConcatenateChanges(r,u)}return[new D.DiffChange(f,d-f+1,e,w-e+1)]}WALKTRACE(f,d,e,w,M,N,b,A,g,c,r,u,E,m,_,v,L,y){let C=null,S=null,U=new a,H=d,x=e,Q=E[0]-v[0]-w,F=-1073741824,j=this.m_forwardHistory.length-1;do{const Z=Q+f;Z===H||Z<x&&g[Z-1]<g[Z+1]?(r=g[Z+1],m=r-Q-w,r<F&&U.MarkNextChange(),F=r,U.AddModifiedElement(r+1,m),Q=Z+1-f):(r=g[Z-1]+1,m=r-Q-w,r<F&&U.MarkNextChange(),F=r-1,U.AddOriginalElement(r,m+1),Q=Z-1-f),j>=0&&(g=this.m_forwardHistory[j],f=g[0],H=1,x=g.length-1)}while(--j>=-1);if(C=U.getReverseChanges(),y[0]){let Z=E[0]+1,Y=v[0]+1;if(C!==null&&C.length>0){const ge=C[C.length-1];Z=Math.max(Z,ge.getOriginalEnd()),Y=Math.max(Y,ge.getModifiedEnd())}S=[new D.DiffChange(Z,u-Z+1,Y,_-Y+1)]}else{U=new a,H=N,x=b,Q=E[0]-v[0]-A,F=1073741824,j=L?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const Z=Q+M;Z===H||Z<x&&c[Z-1]>=c[Z+1]?(r=c[Z+1]-1,m=r-Q-A,r>F&&U.MarkNextChange(),F=r+1,U.AddOriginalElement(r+1,m+1),Q=Z+1-M):(r=c[Z-1],m=r-Q-A,r>F&&U.MarkNextChange(),F=r,U.AddModifiedElement(r+1,m+1),Q=Z-1-M),j>=0&&(c=this.m_reverseHistory[j],M=c[0],H=1,x=c.length-1)}while(--j>=-1);S=U.getChanges()}return this.ConcatenateChanges(C,S)}ComputeRecursionPoint(f,d,e,w,M,N,b){let A=0,g=0,c=0,r=0,u=0,E=0;f--,e--,M[0]=0,N[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const m=d-f+(w-e),_=m+1,v=new Int32Array(_),L=new Int32Array(_),y=w-e,C=d-f,S=f-e,U=d-w,x=(C-y)%2===0;v[y]=f,L[C]=d,b[0]=!1;for(let Q=1;Q<=m/2+1;Q++){let F=0,j=0;c=this.ClipDiagonalBound(y-Q,Q,y,_),r=this.ClipDiagonalBound(y+Q,Q,y,_);for(let Y=c;Y<=r;Y+=2){Y===c||Y<r&&v[Y-1]<v[Y+1]?A=v[Y+1]:A=v[Y-1]+1,g=A-(Y-y)-S;const ge=A;for(;A<d&&g<w&&this.ElementsAreEqual(A+1,g+1);)A++,g++;if(v[Y]=A,A+g>F+j&&(F=A,j=g),!x&&Math.abs(Y-C)<=Q-1&&A>=L[Y])return M[0]=A,N[0]=g,ge<=L[Y]&&1447>0&&Q<=1447+1?this.WALKTRACE(y,c,r,S,C,u,E,U,v,L,A,d,M,g,w,N,x,b):null}const Z=(F-f+(j-e)-Q)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(F,Z))return b[0]=!0,M[0]=F,N[0]=j,Z>0&&1447>0&&Q<=1447+1?this.WALKTRACE(y,c,r,S,C,u,E,U,v,L,A,d,M,g,w,N,x,b):(f++,e++,[new D.DiffChange(f,d-f+1,e,w-e+1)]);u=this.ClipDiagonalBound(C-Q,Q,C,_),E=this.ClipDiagonalBound(C+Q,Q,C,_);for(let Y=u;Y<=E;Y+=2){Y===u||Y<E&&L[Y-1]>=L[Y+1]?A=L[Y+1]-1:A=L[Y-1],g=A-(Y-C)-U;const ge=A;for(;A>f&&g>e&&this.ElementsAreEqual(A,g);)A--,g--;if(L[Y]=A,x&&Math.abs(Y-y)<=Q&&A<=v[Y])return M[0]=A,N[0]=g,ge>=v[Y]&&1447>0&&Q<=1447+1?this.WALKTRACE(y,c,r,S,C,u,E,U,v,L,A,d,M,g,w,N,x,b):null}if(Q<=1447){let Y=new Int32Array(r-c+2);Y[0]=y-c+1,l.Copy2(v,c,Y,1,r-c+1),this.m_forwardHistory.push(Y),Y=new Int32Array(E-u+2),Y[0]=C-u+1,l.Copy2(L,u,Y,1,E-u+1),this.m_reverseHistory.push(Y)}}return this.WALKTRACE(y,c,r,S,C,u,E,U,v,L,A,d,M,g,w,N,x,b)}PrettifyChanges(f){for(let d=0;d<f.length;d++){const e=f[d],w=d<f.length-1?f[d+1].originalStart:this._originalElementsOrHash.length,M=d<f.length-1?f[d+1].modifiedStart:this._modifiedElementsOrHash.length,N=e.originalLength>0,b=e.modifiedLength>0;for(;e.originalStart+e.originalLength<w&&e.modifiedStart+e.modifiedLength<M&&(!N||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!b||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const g=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!g)break;e.originalStart++,e.modifiedStart++}const A=[null];if(d<f.length-1&&this.ChangesOverlap(f[d],f[d+1],A)){f[d]=A[0],f.splice(d+1,1),d--;continue}}for(let d=f.length-1;d>=0;d--){const e=f[d];let w=0,M=0;if(d>0){const r=f[d-1];w=r.originalStart+r.originalLength,M=r.modifiedStart+r.modifiedLength}const N=e.originalLength>0,b=e.modifiedLength>0;let A=0,g=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const u=e.originalStart-r,E=e.modifiedStart-r;if(u<w||E<M||N&&!this.OriginalElementsAreEqual(u,u+e.originalLength)||b&&!this.ModifiedElementsAreEqual(E,E+e.modifiedLength))break;const _=(u===w&&E===M?5:0)+this._boundaryScore(u,e.originalLength,E,e.modifiedLength);_>g&&(g=_,A=r)}e.originalStart-=A,e.modifiedStart-=A;const c=[null];if(d>0&&this.ChangesOverlap(f[d-1],f[d],c)){f[d-1]=c[0],f.splice(d,1),d++;continue}}if(this._hasStrings)for(let d=1,e=f.length;d<e;d++){const w=f[d-1],M=f[d],N=M.originalStart-w.originalStart-w.originalLength,b=w.originalStart,A=M.originalStart+M.originalLength,g=A-b,c=w.modifiedStart,r=M.modifiedStart+M.modifiedLength,u=r-c;if(N<5&&g<20&&u<20){const E=this._findBetterContiguousSequence(b,g,c,u,N);if(E){const[m,_]=E;(m!==w.originalStart+w.originalLength||_!==w.modifiedStart+w.modifiedLength)&&(w.originalLength=m-w.originalStart,w.modifiedLength=_-w.modifiedStart,M.originalStart=m+N,M.modifiedStart=_+N,M.originalLength=A-M.originalStart,M.modifiedLength=r-M.modifiedStart)}}}return f}_findBetterContiguousSequence(f,d,e,w,M){if(d<M||w<M)return null;const N=f+d-M+1,b=e+w-M+1;let A=0,g=0,c=0;for(let r=f;r<N;r++)for(let u=e;u<b;u++){const E=this._contiguousSequenceScore(r,u,M);E>0&&E>A&&(A=E,g=r,c=u)}return A>0?[g,c]:null}_contiguousSequenceScore(f,d,e){let w=0;for(let M=0;M<e;M++){if(!this.ElementsAreEqual(f+M,d+M))return 0;w+=this._originalStringElements[f+M].length}return w}_OriginalIsBoundary(f){return f<=0||f>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[f])}_OriginalRegionIsBoundary(f,d){if(this._OriginalIsBoundary(f)||this._OriginalIsBoundary(f-1))return!0;if(d>0){const e=f+d;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(f){return f<=0||f>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[f])}_ModifiedRegionIsBoundary(f,d){if(this._ModifiedIsBoundary(f)||this._ModifiedIsBoundary(f-1))return!0;if(d>0){const e=f+d;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(f,d,e,w){const M=this._OriginalRegionIsBoundary(f,d)?1:0,N=this._ModifiedRegionIsBoundary(e,w)?1:0;return M+N}ConcatenateChanges(f,d){const e=[];if(f.length===0||d.length===0)return d.length>0?d:f;if(this.ChangesOverlap(f[f.length-1],d[0],e)){const w=new Array(f.length+d.length-1);return l.Copy(f,0,w,0,f.length-1),w[f.length-1]=e[0],l.Copy(d,1,w,f.length,d.length-1),w}else{const w=new Array(f.length+d.length);return l.Copy(f,0,w,0,f.length),l.Copy(d,0,w,f.length,d.length),w}}ChangesOverlap(f,d,e){if(p.Assert(f.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),p.Assert(f.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),f.originalStart+f.originalLength>=d.originalStart||f.modifiedStart+f.modifiedLength>=d.modifiedStart){const w=f.originalStart;let M=f.originalLength;const N=f.modifiedStart;let b=f.modifiedLength;return f.originalStart+f.originalLength>=d.originalStart&&(M=d.originalStart+d.originalLength-f.originalStart),f.modifiedStart+f.modifiedLength>=d.modifiedStart&&(b=d.modifiedStart+d.modifiedLength-f.modifiedStart),e[0]=new D.DiffChange(w,M,N,b),!0}else return e[0]=null,!1}ClipDiagonalBound(f,d,e,w){if(f>=0&&f<w)return f;const M=e,N=w-e-1,b=d%2===0;if(f<0){const A=M%2===0;return b===A?0:1}else{const A=N%2===0;return b===A?w-1:w-2}}}t.LcsDiff=h}),re(se[22],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function D(c){return typeof c=="string"}t.isString=D;function P(c){return Array.isArray(c)&&c.every(r=>D(r))}t.isStringArray=P;function i(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.isObject=i;function o(c){const r=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof r}t.isTypedArray=o;function p(c){return typeof c=="number"&&!isNaN(c)}t.isNumber=p;function l(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.isIterable=l;function s(c){return c===!0||c===!1}t.isBoolean=s;function a(c){return typeof c>"u"}t.isUndefined=a;function h(c){return!R(c)}t.isDefined=h;function R(c){return a(c)||c===null}t.isUndefinedOrNull=R;function f(c,r){if(!c)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}t.assertType=f;function d(c){if(R(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.assertIsDefined=d;function e(...c){const r=[];for(let u=0;u<c.length;u++){const E=c[u];if(R(E))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);r.push(E)}return r}t.assertAllDefined=e;const w=Object.prototype.hasOwnProperty;function M(c){if(!i(c))return!1;for(const r in c)if(w.call(c,r))return!1;return!0}t.isEmptyObject=M;function N(c){return typeof c=="function"}t.isFunction=N;function b(...c){return c.length>0&&c.every(N)}t.areFunctions=b;function A(c,r){const u=Math.min(c.length,r.length);for(let E=0;E<u;E++)g(c[E],r[E])}t.validateConstraints=A;function g(c,r){if(D(r)){if(typeof c!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(N(r)){try{if(c instanceof r)return}catch{}if(!R(c)&&c.constructor===r||r.length===1&&r.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=g}),re(se[35],ae([0,1,22]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const P=Object.create(null);function i(l,s){if((0,D.isString)(s)){const a=P[s];if(a===void 0)throw new Error(`${l} references an unknown codicon: ${s}`);s=a}return P[l]=s,{id:l}}function o(){return P}t.getCodiconFontCharacters=o;function p(){return Object.values(t.Codicon)}t.getAllCodicons=p,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),re(se[11],ae([0,1,22]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function P(N){if(!N||typeof N!="object"||N instanceof RegExp)return N;const b=Array.isArray(N)?[]:{};return Object.entries(N).forEach(([A,g])=>{b[A]=g&&typeof g=="object"?P(g):g}),b}t.deepClone=P;function i(N){if(!N||typeof N!="object")return N;const b=[N];for(;b.length>0;){const A=b.shift();Object.freeze(A);for(const g in A)if(o.call(A,g)){const c=A[g];typeof c=="object"&&!Object.isFrozen(c)&&!(0,D.isTypedArray)(c)&&b.push(c)}}return N}t.deepFreeze=i;const o=Object.prototype.hasOwnProperty;function p(N,b){return l(N,b,new Set)}t.cloneAndChange=p;function l(N,b,A){if((0,D.isUndefinedOrNull)(N))return N;const g=b(N);if(typeof g<"u")return g;if(Array.isArray(N)){const c=[];for(const r of N)c.push(l(r,b,A));return c}if((0,D.isObject)(N)){if(A.has(N))throw new Error("Cannot clone recursive data-structure");A.add(N);const c={};for(const r in N)o.call(N,r)&&(c[r]=l(N[r],b,A));return A.delete(N),c}return N}function s(N,b,A=!0){return(0,D.isObject)(N)?((0,D.isObject)(b)&&Object.keys(b).forEach(g=>{g in N?A&&((0,D.isObject)(N[g])&&(0,D.isObject)(b[g])?s(N[g],b[g],A):N[g]=b[g]):N[g]=b[g]}),N):b}t.mixin=s;function a(N,b){if(N===b)return!0;if(N==null||b===null||b===void 0||typeof N!=typeof b||typeof N!="object"||Array.isArray(N)!==Array.isArray(b))return!1;let A,g;if(Array.isArray(N)){if(N.length!==b.length)return!1;for(A=0;A<N.length;A++)if(!a(N[A],b[A]))return!1}else{const c=[];for(g in N)c.push(g);c.sort();const r=[];for(g in b)r.push(g);if(r.sort(),!a(c,r))return!1;for(A=0;A<c.length;A++)if(!a(N[c[A]],b[c[A]]))return!1}return!0}t.equals=a;function h(N){const b=new Set;return JSON.stringify(N,(A,g)=>{if((0,D.isObject)(g)||Array.isArray(g)){if(b.has(g))return"[Circular]";b.add(g)}return g})}t.safeStringify=h;function R(N,b){const A=Object.create(null);return!N||!b||Object.keys(b).forEach(c=>{const r=N[c],u=b[c];a(r,u)||(A[c]=u)}),A}t.distinct=R;function f(N,b){const A=b.toLowerCase(),g=Object.keys(N).find(c=>c.toLowerCase()===A);return g?N[g]:N[b]}t.getCaseInsensitive=f;function d(N,b){const A=Object.create(null);for(const[g,c]of Object.entries(N))b(g,c)&&(A[g]=c);return A}t.filter=d;function e(N){let b=[];for(;Object.prototype!==N;)b=b.concat(Object.getOwnPropertyNames(N)),N=Object.getPrototypeOf(N);return b}t.getAllPropertyNames=e;function w(N){const b=[];for(const A of e(N))typeof N[A]=="function"&&b.push(A);return b}t.getAllMethodNames=w;function M(N,b){const A=c=>function(){const r=Array.prototype.slice.call(arguments,0);return b(c,r)},g={};for(const c of N)g[c]=A(c);return g}t.createProxyObject=M}),re(se[23],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var D;(function(o){o[o.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",o[o.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",o[o.MAX_UINT_8=255]="MAX_UINT_8",o[o.MAX_UINT_16=65535]="MAX_UINT_16",o[o.MAX_UINT_32=4294967295]="MAX_UINT_32",o[o.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(t.Constants=D={}));function P(o){return o<0?0:o>255?255:o|0}t.toUint8=P;function i(o){return o<0?0:o>4294967295?4294967295:o|0}t.toUint32=i}),re(se[24],ae([0,1,23]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class P{constructor(l){const s=(0,D.toUint8)(l);this._defaultValue=s,this._asciiMap=P._createAsciiMap(s),this._map=new Map}static _createAsciiMap(l){const s=new Uint8Array(256);return s.fill(l),s}set(l,s){const a=(0,D.toUint8)(s);l>=0&&l<256?this._asciiMap[l]=a:this._map.set(l,a)}get(l){return l>=0&&l<256?this._asciiMap[l]:this._map.get(l)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}t.CharacterClassifier=P;var i;(function(p){p[p.False=0]="False",p[p.True=1]="True"})(i||(i={}));class o{constructor(){this._actual=new P(0)}add(l){this._actual.set(l,1)}has(l){return this._actual.get(l)===1}clear(){return this._actual.clear()}}t.CharacterSet=o}),re(se[6],ae([0,1,3]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRangeSet=t.OffsetRange=void 0;class P{static addRange(p,l){let s=0;for(;s<l.length&&l[s].endExclusive<p.start;)s++;let a=s;for(;a<l.length&&l[a].start<=p.endExclusive;)a++;if(s===a)l.splice(s,0,p);else{const h=Math.min(p.start,l[s].start),R=Math.max(p.endExclusive,l[a-1].endExclusive);l.splice(s,a-s,new P(h,R))}}static tryCreate(p,l){if(!(p>l))return new P(p,l)}static ofLength(p){return new P(0,p)}constructor(p,l){if(this.start=p,this.endExclusive=l,p>l)throw new D.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(p){return new P(this.start+p,this.endExclusive+p)}deltaStart(p){return new P(this.start+p,this.endExclusive)}deltaEnd(p){return new P(this.start,this.endExclusive+p)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(p){return this.start===p.start&&this.endExclusive===p.endExclusive}containsRange(p){return this.start<=p.start&&p.endExclusive<=this.endExclusive}contains(p){return this.start<=p&&p<this.endExclusive}join(p){return new P(Math.min(this.start,p.start),Math.max(this.endExclusive,p.endExclusive))}intersect(p){const l=Math.max(this.start,p.start),s=Math.min(this.endExclusive,p.endExclusive);if(l<=s)return new P(l,s)}slice(p){return p.slice(this.start,this.endExclusive)}clip(p){if(this.isEmpty)throw new D.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,p))}clipCyclic(p){if(this.isEmpty)throw new D.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return p<this.start?this.endExclusive-(this.start-p)%this.length:p>=this.endExclusive?this.start+(p-this.start)%this.length:p}}t.OffsetRange=P;class i{constructor(){this._sortedRanges=[]}addRange(p){let l=0;for(;l<this._sortedRanges.length&&this._sortedRanges[l].endExclusive<p.start;)l++;let s=l;for(;s<this._sortedRanges.length&&this._sortedRanges[s].start<=p.endExclusive;)s++;if(l===s)this._sortedRanges.splice(l,0,p);else{const a=Math.min(p.start,this._sortedRanges[l].start),h=Math.max(p.endExclusive,this._sortedRanges[s-1].endExclusive);this._sortedRanges.splice(l,s-l,new P(a,h))}}toString(){return this._sortedRanges.map(p=>p.toString()).join(", ")}intersectsStrict(p){let l=0;for(;l<this._sortedRanges.length&&this._sortedRanges[l].endExclusive<=p.start;)l++;return l<this._sortedRanges.length&&this._sortedRanges[l].start<p.endExclusive}intersectWithRange(p){const l=new i;for(const s of this._sortedRanges){const a=s.intersect(p);a&&l.addRange(a)}return l}intersectWithRangeLength(p){return this.intersectWithRange(p).length}get length(){return this._sortedRanges.reduce((p,l)=>p+l.length,0)}}t.OffsetRangeSet=i}),re(se[4],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class D{constructor(i,o){this.lineNumber=i,this.column=o}with(i=this.lineNumber,o=this.column){return i===this.lineNumber&&o===this.column?this:new D(i,o)}delta(i=0,o=0){return this.with(this.lineNumber+i,this.column+o)}equals(i){return D.equals(this,i)}static equals(i,o){return!i&&!o?!0:!!i&&!!o&&i.lineNumber===o.lineNumber&&i.column===o.column}isBefore(i){return D.isBefore(this,i)}static isBefore(i,o){return i.lineNumber<o.lineNumber?!0:o.lineNumber<i.lineNumber?!1:i.column<o.column}isBeforeOrEqual(i){return D.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,o){return i.lineNumber<o.lineNumber?!0:o.lineNumber<i.lineNumber?!1:i.column<=o.column}static compare(i,o){const p=i.lineNumber|0,l=o.lineNumber|0;if(p===l){const s=i.column|0,a=o.column|0;return s-a}return p-l}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new D(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.Position=D}),re(se[2],ae([0,1,4]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class P{constructor(o,p,l,s){o>l||o===l&&p>s?(this.startLineNumber=l,this.startColumn=s,this.endLineNumber=o,this.endColumn=p):(this.startLineNumber=o,this.startColumn=p,this.endLineNumber=l,this.endColumn=s)}isEmpty(){return P.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return P.containsPosition(this,o)}static containsPosition(o,p){return!(p.lineNumber<o.startLineNumber||p.lineNumber>o.endLineNumber||p.lineNumber===o.startLineNumber&&p.column<o.startColumn||p.lineNumber===o.endLineNumber&&p.column>o.endColumn)}static strictContainsPosition(o,p){return!(p.lineNumber<o.startLineNumber||p.lineNumber>o.endLineNumber||p.lineNumber===o.startLineNumber&&p.column<=o.startColumn||p.lineNumber===o.endLineNumber&&p.column>=o.endColumn)}containsRange(o){return P.containsRange(this,o)}static containsRange(o,p){return!(p.startLineNumber<o.startLineNumber||p.endLineNumber<o.startLineNumber||p.startLineNumber>o.endLineNumber||p.endLineNumber>o.endLineNumber||p.startLineNumber===o.startLineNumber&&p.startColumn<o.startColumn||p.endLineNumber===o.endLineNumber&&p.endColumn>o.endColumn)}strictContainsRange(o){return P.strictContainsRange(this,o)}static strictContainsRange(o,p){return!(p.startLineNumber<o.startLineNumber||p.endLineNumber<o.startLineNumber||p.startLineNumber>o.endLineNumber||p.endLineNumber>o.endLineNumber||p.startLineNumber===o.startLineNumber&&p.startColumn<=o.startColumn||p.endLineNumber===o.endLineNumber&&p.endColumn>=o.endColumn)}plusRange(o){return P.plusRange(this,o)}static plusRange(o,p){let l,s,a,h;return p.startLineNumber<o.startLineNumber?(l=p.startLineNumber,s=p.startColumn):p.startLineNumber===o.startLineNumber?(l=p.startLineNumber,s=Math.min(p.startColumn,o.startColumn)):(l=o.startLineNumber,s=o.startColumn),p.endLineNumber>o.endLineNumber?(a=p.endLineNumber,h=p.endColumn):p.endLineNumber===o.endLineNumber?(a=p.endLineNumber,h=Math.max(p.endColumn,o.endColumn)):(a=o.endLineNumber,h=o.endColumn),new P(l,s,a,h)}intersectRanges(o){return P.intersectRanges(this,o)}static intersectRanges(o,p){let l=o.startLineNumber,s=o.startColumn,a=o.endLineNumber,h=o.endColumn;const R=p.startLineNumber,f=p.startColumn,d=p.endLineNumber,e=p.endColumn;return l<R?(l=R,s=f):l===R&&(s=Math.max(s,f)),a>d?(a=d,h=e):a===d&&(h=Math.min(h,e)),l>a||l===a&&s>h?null:new P(l,s,a,h)}equalsRange(o){return P.equalsRange(this,o)}static equalsRange(o,p){return!o&&!p?!0:!!o&&!!p&&o.startLineNumber===p.startLineNumber&&o.startColumn===p.startColumn&&o.endLineNumber===p.endLineNumber&&o.endColumn===p.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(o){return new D.Position(o.endLineNumber,o.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(o){return new D.Position(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,p){return new P(this.startLineNumber,this.startColumn,o,p)}setStartPosition(o,p){return new P(o,p,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(o){return new P(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}collapseToEnd(){return P.collapseToEnd(this)}static collapseToEnd(o){return new P(o.endLineNumber,o.endColumn,o.endLineNumber,o.endColumn)}delta(o){return new P(this.startLineNumber+o,this.startColumn,this.endLineNumber+o,this.endColumn)}static fromPositions(o,p=o){return new P(o.lineNumber,o.column,p.lineNumber,p.column)}static lift(o){return o?new P(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,p){return!(o.endLineNumber<p.startLineNumber||o.endLineNumber===p.startLineNumber&&o.endColumn<p.startColumn||p.endLineNumber<o.startLineNumber||p.endLineNumber===o.startLineNumber&&p.endColumn<o.startColumn)}static areIntersecting(o,p){return!(o.endLineNumber<p.startLineNumber||o.endLineNumber===p.startLineNumber&&o.endColumn<=p.startColumn||p.endLineNumber<o.startLineNumber||p.endLineNumber===o.startLineNumber&&p.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,p){if(o&&p){const a=o.startLineNumber|0,h=p.startLineNumber|0;if(a===h){const R=o.startColumn|0,f=p.startColumn|0;if(R===f){const d=o.endLineNumber|0,e=p.endLineNumber|0;if(d===e){const w=o.endColumn|0,M=p.endColumn|0;return w-M}return d-e}return R-f}return a-h}return(o?1:0)-(p?1:0)}static compareRangesUsingEnds(o,p){return o.endLineNumber===p.endLineNumber?o.endColumn===p.endColumn?o.startLineNumber===p.startLineNumber?o.startColumn-p.startColumn:o.startLineNumber-p.startLineNumber:o.endColumn-p.endColumn:o.endLineNumber-p.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}t.Range=P}),re(se[36],ae([0,1,2]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditOperation=void 0;class P{static insert(o,p){return{range:new D.Range(o.lineNumber,o.column,o.lineNumber,o.column),text:p,forceMoveMarkers:!0}}static delete(o){return{range:o,text:null}}static replace(o,p){return{range:o,text:p}}static replaceMove(o,p){return{range:o,text:p,forceMoveMarkers:!0}}}t.EditOperation=P}),re(se[12],ae([0,1,3,6,2]),function(z,t,D,P,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRange=void 0;class o{static fromRange(l){return new o(l.startLineNumber,l.endLineNumber)}static subtract(l,s){return s?l.startLineNumber<s.startLineNumber&&s.endLineNumberExclusive<l.endLineNumberExclusive?[new o(l.startLineNumber,s.startLineNumber),new o(s.endLineNumberExclusive,l.endLineNumberExclusive)]:s.startLineNumber<=l.startLineNumber&&l.endLineNumberExclusive<=s.endLineNumberExclusive?[]:s.endLineNumberExclusive<l.endLineNumberExclusive?[new o(Math.max(s.endLineNumberExclusive,l.startLineNumber),l.endLineNumberExclusive)]:[new o(l.startLineNumber,Math.min(s.startLineNumber,l.endLineNumberExclusive))]:[l]}static joinMany(l){if(l.length===0)return[];let s=l[0];for(let a=1;a<l.length;a++)s=this.join(s,l[a]);return s}static join(l,s){if(l.length===0)return s;if(s.length===0)return l;const a=[];let h=0,R=0,f=null;for(;h<l.length||R<s.length;){let d=null;if(h<l.length&&R<s.length){const e=l[h],w=s[R];e.startLineNumber<w.startLineNumber?(d=e,h++):(d=w,R++)}else h<l.length?(d=l[h],h++):(d=s[R],R++);f===null?f=d:f.endLineNumberExclusive>=d.startLineNumber?f=new o(f.startLineNumber,Math.max(f.endLineNumberExclusive,d.endLineNumberExclusive)):(a.push(f),f=d)}return f!==null&&a.push(f),a}static ofLength(l,s){return new o(l,l+s)}static deserialize(l){return new o(l[0],l[1])}constructor(l,s){if(l>s)throw new D.BugIndicatingError(`startLineNumber ${l} cannot be after endLineNumberExclusive ${s}`);this.startLineNumber=l,this.endLineNumberExclusive=s}contains(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(l){return new o(this.startLineNumber+l,this.endLineNumberExclusive+l)}deltaLength(l){return new o(this.startLineNumber,this.endLineNumberExclusive+l)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(l){return new o(Math.min(this.startLineNumber,l.startLineNumber),Math.max(this.endLineNumberExclusive,l.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(l){const s=Math.max(this.startLineNumber,l.startLineNumber),a=Math.min(this.endLineNumberExclusive,l.endLineNumberExclusive);if(s<=a)return new o(s,a)}intersectsStrict(l){return this.startLineNumber<l.endLineNumberExclusive&&l.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(l){return this.startLineNumber<=l.endLineNumberExclusive&&l.startLineNumber<=this.endLineNumberExclusive}equals(l){return this.startLineNumber===l.startLineNumber&&this.endLineNumberExclusive===l.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new i.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new i.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(l){const s=[];for(let a=this.startLineNumber;a<this.endLineNumberExclusive;a++)s.push(l(a));return s}forEach(l){for(let s=this.startLineNumber;s<this.endLineNumberExclusive;s++)l(s)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}toOffsetRange(){return new P.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.LineRange=o}),re(se[37],ae([0,1,4,2]),function(z,t,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var i;(function(p){p[p.LTR=0]="LTR",p[p.RTL=1]="RTL"})(i||(t.SelectionDirection=i={}));class o extends P.Range{constructor(l,s,a,h){super(l,s,a,h),this.selectionStartLineNumber=l,this.selectionStartColumn=s,this.positionLineNumber=a,this.positionColumn=h}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(l){return o.selectionsEqual(this,l)}static selectionsEqual(l,s){return l.selectionStartLineNumber===s.selectionStartLineNumber&&l.selectionStartColumn===s.selectionStartColumn&&l.positionLineNumber===s.positionLineNumber&&l.positionColumn===s.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(l,s){return this.getDirection()===0?new o(this.startLineNumber,this.startColumn,l,s):new o(l,s,this.startLineNumber,this.startColumn)}getPosition(){return new D.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(l,s){return this.getDirection()===0?new o(l,s,this.endLineNumber,this.endColumn):new o(this.endLineNumber,this.endColumn,l,s)}static fromPositions(l,s=l){return new o(l.lineNumber,l.column,s.lineNumber,s.column)}static fromRange(l,s){return s===0?new o(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):new o(l.endLineNumber,l.endColumn,l.startLineNumber,l.startColumn)}static liftSelection(l){return new o(l.selectionStartLineNumber,l.selectionStartColumn,l.positionLineNumber,l.positionColumn)}static selectionsArrEqual(l,s){if(l&&!s||!l&&s)return!1;if(!l&&!s)return!0;if(l.length!==s.length)return!1;for(let a=0,h=l.length;a<h;a++)if(!this.selectionsEqual(l[a],s[a]))return!1;return!0}static isISelection(l){return l&&typeof l.selectionStartLineNumber=="number"&&typeof l.selectionStartColumn=="number"&&typeof l.positionLineNumber=="number"&&typeof l.positionColumn=="number"}static createWithDirection(l,s,a,h,R){return R===0?new o(l,s,a,h):new o(a,h,l,s)}}t.Selection=o}),re(se[38],ae([0,1,24]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var P;(function(p){p[p.Regular=0]="Regular",p[p.Whitespace=1]="Whitespace",p[p.WordSeparator=2]="WordSeparator"})(P||(t.WordCharacterClass=P={}));class i extends D.CharacterClassifier{constructor(l){super(0);for(let s=0,a=l.length;s<a;s++)this.set(l.charCodeAt(s),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=i;function o(p){const l={};return s=>(l.hasOwnProperty(s)||(l[s]=p(s)),l[s])}t.getMapForWordSeparators=o(p=>new i(p))}),re(se[25],ae([0,1,17,7,18]),function(z,t,D,P,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function o(R=""){let f="(-?\\d*\\.\\d\\w*)|([^";for(const d of t.USUAL_WORD_SEPARATORS)R.indexOf(d)>=0||(f+="\\"+d);return f+="\\s]+)",new RegExp(f,"g")}t.DEFAULT_WORD_REGEXP=o();function p(R){let f=t.DEFAULT_WORD_REGEXP;if(R&&R instanceof RegExp)if(R.global)f=R;else{let d="g";R.ignoreCase&&(d+="i"),R.multiline&&(d+="m"),R.unicode&&(d+="u"),f=new RegExp(R.source,d)}return f.lastIndex=0,f}t.ensureValidWordDefinition=p;const l=new i.LinkedList;l.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function s(R){const f=l.unshift(R);return(0,P.toDisposable)(f)}t.setDefaultGetWordAtTextConfig=s;function a(R,f,d,e,w){if(w||(w=D.Iterable.first(l)),d.length>w.maxLen){let g=R-w.maxLen/2;return g<0?g=0:e+=g,d=d.substring(g,R+w.maxLen/2),a(R,f,d,e,w)}const M=Date.now(),N=R-1-e;let b=-1,A=null;for(let g=1;!(Date.now()-M>=w.timeBudget);g++){const c=N-w.windowSize*g;f.lastIndex=Math.max(0,c);const r=h(f,d,N,b);if(!r&&A||(A=r,c<=0))break;b=c}if(A){const g={word:A[0],startColumn:e+1+A.index,endColumn:e+1+A.index+A[0].length};return f.lastIndex=0,g}return null}t.getWordAtText=a;function h(R,f,d,e){let w;for(;w=R.exec(f);){const M=w.index||0;if(M<=d&&R.lastIndex>=d)return w;if(e>0&&M>e)return null}return null}}),re(se[9],ae([0,1,3,6]),function(z,t,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DateTimeout=t.InfiniteTimeout=t.SequenceDiff=t.DiffAlgorithmResult=void 0;class i{static trivial(a,h){return new i([new o(new P.OffsetRange(0,a.length),new P.OffsetRange(0,h.length))],!1)}static trivialTimedOut(a,h){return new i([new o(new P.OffsetRange(0,a.length),new P.OffsetRange(0,h.length))],!0)}constructor(a,h){this.diffs=a,this.hitTimeout=h}}t.DiffAlgorithmResult=i;class o{constructor(a,h){this.seq1Range=a,this.seq2Range=h}reverse(){return new o(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(a){return new o(this.seq1Range.join(a.seq1Range),this.seq2Range.join(a.seq2Range))}delta(a){return a===0?this:new o(this.seq1Range.delta(a),this.seq2Range.delta(a))}}t.SequenceDiff=o;class p{static{this.instance=new p}isValid(){return!0}}t.InfiniteTimeout=p;class l{constructor(a){if(this.timeout=a,this.startTime=Date.now(),this.valid=!0,a<=0)throw new D.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}disable(){this.timeout=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.valid=!0}}t.DateTimeout=l}),re(se[39],ae([0,1,6,9]),function(z,t,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shiftSequenceDiffs=t.joinSequenceDiffs=t.removeRandomMatches=t.removeRandomLineMatches=t.smoothenSequenceDiffs=t.optimizeSequenceDiffs=void 0;function i(R,f,d){let e=d;return e=s(R,f,e),e=a(R,f,e),e}t.optimizeSequenceDiffs=i;function o(R,f,d){const e=[];for(const w of d){const M=e[e.length-1];if(!M){e.push(w);continue}w.seq1Range.start-M.seq1Range.endExclusive<=2||w.seq2Range.start-M.seq2Range.endExclusive<=2?e[e.length-1]=new P.SequenceDiff(M.seq1Range.join(w.seq1Range),M.seq2Range.join(w.seq2Range)):e.push(w)}return e}t.smoothenSequenceDiffs=o;function p(R,f,d){let e=d;if(e.length===0)return e;let w=0,M;do{M=!1;const N=[e[0]];for(let b=1;b<e.length;b++){let c=function(u,E){const m=new D.OffsetRange(g.seq1Range.endExclusive,A.seq1Range.start);return R.getText(m).replace(/\s/g,"").length<=4&&(u.seq1Range.length+u.seq2Range.length>5||E.seq1Range.length+E.seq2Range.length>5)};const A=e[b],g=N[N.length-1];c(g,A)?(M=!0,N[N.length-1]=N[N.length-1].join(A)):N.push(A)}e=N}while(w++<10&&M);return e}t.removeRandomLineMatches=p;function l(R,f,d){let e=d;if(e.length===0)return e;let w=0,M;do{M=!1;const N=[e[0]];for(let b=1;b<e.length;b++){let c=function(u,E){const m=new D.OffsetRange(g.seq1Range.endExclusive,A.seq1Range.start);if(R.countLinesIn(m)>5||m.length>500)return!1;const v=R.getText(m).trim();if(v.length>20||v.split(/\r\n|\r|\n/).length>1)return!1;const L=R.countLinesIn(u.seq1Range),y=u.seq1Range.length,C=f.countLinesIn(u.seq2Range),S=u.seq2Range.length,U=R.countLinesIn(E.seq1Range),H=E.seq1Range.length,x=f.countLinesIn(E.seq2Range),Q=E.seq2Range.length,F=2*40+50;function j(Z){return Math.min(Z,F)}return Math.pow(Math.pow(j(L*40+y),1.5)+Math.pow(j(C*40+S),1.5),1.5)+Math.pow(Math.pow(j(U*40+H),1.5)+Math.pow(j(x*40+Q),1.5),1.5)>(F**1.5)**1.5*1.3};const A=e[b],g=N[N.length-1];c(g,A)?(M=!0,N[N.length-1]=N[N.length-1].join(A)):N.push(A)}e=N}while(w++<10&&M);for(let N=0;N<e.length;N++){const b=e[N];let A=b.seq1Range,g=b.seq2Range;const c=R.extendToFullLines(b.seq1Range),r=R.getText(new D.OffsetRange(c.start,b.seq1Range.start));r.length>0&&r.trim().length<=3&&b.seq1Range.length+b.seq2Range.length>100&&(A=b.seq1Range.deltaStart(-r.length),g=b.seq2Range.deltaStart(-r.length));const u=R.getText(new D.OffsetRange(b.seq1Range.endExclusive,c.endExclusive));u.length>0&&u.trim().length<=3&&b.seq1Range.length+b.seq2Range.length>150&&(A=A.deltaEnd(u.length),g=g.deltaEnd(u.length)),e[N]=new P.SequenceDiff(A,g)}return e}t.removeRandomMatches=l;function s(R,f,d){if(d.length===0)return d;const e=[];e.push(d[0]);for(let M=1;M<d.length;M++){const N=e[e.length-1];let b=d[M];if(b.seq1Range.isEmpty||b.seq2Range.isEmpty){const A=b.seq1Range.start-N.seq1Range.endExclusive;let g;for(g=1;g<=A&&!(R.getElement(b.seq1Range.start-g)!==R.getElement(b.seq1Range.endExclusive-g)||f.getElement(b.seq2Range.start-g)!==f.getElement(b.seq2Range.endExclusive-g));g++);if(g--,g===A){e[e.length-1]=new P.SequenceDiff(new D.OffsetRange(N.seq1Range.start,b.seq1Range.endExclusive-A),new D.OffsetRange(N.seq2Range.start,b.seq2Range.endExclusive-A));continue}b=b.delta(-g)}e.push(b)}const w=[];for(let M=0;M<e.length-1;M++){const N=e[M+1];let b=e[M];if(b.seq1Range.isEmpty||b.seq2Range.isEmpty){const A=N.seq1Range.start-b.seq1Range.endExclusive;let g;for(g=0;g<A&&!(R.getElement(b.seq1Range.start+g)!==R.getElement(b.seq1Range.endExclusive+g)||f.getElement(b.seq2Range.start+g)!==f.getElement(b.seq2Range.endExclusive+g));g++);if(g===A){e[M+1]=new P.SequenceDiff(new D.OffsetRange(b.seq1Range.start+A,N.seq1Range.endExclusive),new D.OffsetRange(b.seq2Range.start+A,N.seq2Range.endExclusive));continue}g>0&&(b=b.delta(g))}w.push(b)}return e.length>0&&w.push(e[e.length-1]),w}t.joinSequenceDiffs=s;function a(R,f,d){if(!R.getBoundaryScore||!f.getBoundaryScore)return d;for(let e=0;e<d.length;e++){const w=e>0?d[e-1]:void 0,M=d[e],N=e+1<d.length?d[e+1]:void 0,b=new D.OffsetRange(w?w.seq1Range.start+1:0,N?N.seq1Range.endExclusive-1:R.length),A=new D.OffsetRange(w?w.seq2Range.start+1:0,N?N.seq2Range.endExclusive-1:f.length);M.seq1Range.isEmpty?d[e]=h(M,R,f,b,A):M.seq2Range.isEmpty&&(d[e]=h(M.reverse(),f,R,A,b).reverse())}return d}t.shiftSequenceDiffs=a;function h(R,f,d,e,w){let N=1;for(;R.seq1Range.start-N>=e.start&&R.seq2Range.start-N>=w.start&&d.isStronglyEqual(R.seq2Range.start-N,R.seq2Range.endExclusive-N)&&N<100;)N++;N--;let b=0;for(;R.seq1Range.start+b<e.endExclusive&&R.seq2Range.endExclusive+b<w.endExclusive&&d.isStronglyEqual(R.seq2Range.start+b,R.seq2Range.endExclusive+b)&&b<100;)b++;if(N===0&&b===0)return R;let A=0,g=-1;for(let c=-N;c<=b;c++){const r=R.seq2Range.start+c,u=R.seq2Range.endExclusive+c,E=R.seq1Range.start+c,m=f.getBoundaryScore(E)+d.getBoundaryScore(r)+d.getBoundaryScore(u);m>g&&(g=m,A=c)}return R.delta(A)}}),re(se[40],ae([0,1,6,9]),function(z,t,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class i{compute(a,h,R=P.InfiniteTimeout.instance){if(a.length===0||h.length===0)return P.DiffAlgorithmResult.trivial(a,h);function f(c,r){for(;c<a.length&&r<h.length&&a.getElement(c)===h.getElement(r);)c++,r++;return c}let d=0;const e=new p;e.set(0,f(0,0));const w=new l;w.set(0,e.get(0)===0?null:new o(null,0,0,e.get(0)));let M=0;e:for(;;){if(d++,!R.isValid())return P.DiffAlgorithmResult.trivialTimedOut(a,h);const c=-Math.min(d,h.length+d%2),r=Math.min(d,a.length+d%2);for(M=c;M<=r;M+=2){const u=M===r?-1:e.get(M+1),E=M===c?-1:e.get(M-1)+1,m=Math.min(Math.max(u,E),a.length),_=m-M;if(m>a.length||_>h.length)continue;const v=f(m,_);e.set(M,v);const L=m===u?w.get(M+1):w.get(M-1);if(w.set(M,v!==m?new o(L,m,_,v-m):L),e.get(M)===a.length&&e.get(M)-M===h.length)break e}}let N=w.get(M);const b=[];let A=a.length,g=h.length;for(;;){const c=N?N.x+N.length:0,r=N?N.y+N.length:0;if((c!==A||r!==g)&&b.push(new P.SequenceDiff(new D.OffsetRange(c,A),new D.OffsetRange(r,g))),!N)break;A=N.x,g=N.y,N=N.prev}return b.reverse(),new P.DiffAlgorithmResult(b,!1)}}t.MyersDiffAlgorithm=i;class o{constructor(a,h,R,f){this.prev=a,this.x=h,this.y=R,this.length=f}}class p{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,h){if(a<0){if(a=-a-1,a>=this.negativeArr.length){const R=this.negativeArr;this.negativeArr=new Int32Array(R.length*2),this.negativeArr.set(R)}this.negativeArr[a]=h}else{if(a>=this.positiveArr.length){const R=this.positiveArr;this.positiveArr=new Int32Array(R.length*2),this.positiveArr.set(R)}this.positiveArr[a]=h}}}class l{constructor(){this.positiveArr=[],this.negativeArr=[]}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,h){a<0?(a=-a-1,this.negativeArr[a]=h):this.positiveArr[a]=h}}}),re(se[41],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Array2D=void 0;class D{constructor(i,o){this.width=i,this.height=o,this.array=[],this.array=new Array(i*o)}get(i,o){return this.array[i+o*this.width]}set(i,o,p){this.array[i+o*this.width]=p}}t.Array2D=D}),re(se[42],ae([0,1,6,9,41]),function(z,t,D,P,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class o{compute(l,s,a=P.InfiniteTimeout.instance,h){if(l.length===0||s.length===0)return P.DiffAlgorithmResult.trivial(l,s);const R=new i.Array2D(l.length,s.length),f=new i.Array2D(l.length,s.length),d=new i.Array2D(l.length,s.length);for(let g=0;g<l.length;g++)for(let c=0;c<s.length;c++){if(!a.isValid())return P.DiffAlgorithmResult.trivialTimedOut(l,s);const r=g===0?0:R.get(g-1,c),u=c===0?0:R.get(g,c-1);let E;l.getElement(g)===s.getElement(c)?(g===0||c===0?E=0:E=R.get(g-1,c-1),g>0&&c>0&&f.get(g-1,c-1)===3&&(E+=d.get(g-1,c-1)),E+=h?h(g,c):1):E=-1;const m=Math.max(r,u,E);if(m===E){const _=g>0&&c>0?d.get(g-1,c-1):0;d.set(g,c,_+1),f.set(g,c,3)}else m===r?(d.set(g,c,0),f.set(g,c,1)):m===u&&(d.set(g,c,0),f.set(g,c,2));R.set(g,c,m)}const e=[];let w=l.length,M=s.length;function N(g,c){(g+1!==w||c+1!==M)&&e.push(new P.SequenceDiff(new D.OffsetRange(g+1,w),new D.OffsetRange(c+1,M))),w=g,M=c}let b=l.length-1,A=s.length-1;for(;b>=0&&A>=0;)f.get(b,A)===3?(N(b,A),b--,A--):f.get(b,A)===1?b--:A--;return N(-1,-1),e.reverse(),new P.DiffAlgorithmResult(e,!1)}}t.DynamicProgrammingDiffing=o}),re(se[26],ae([0,1,12]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MovedText=t.SimpleLineRangeMapping=t.RangeMapping=t.LineRangeMapping=t.LinesDiff=void 0;class P{constructor(a,h,R){this.changes=a,this.moves=h,this.hitTimeout=R}}t.LinesDiff=P;class i{static inverse(a,h,R){const f=[];let d=1,e=1;for(const M of a){const N=new i(new D.LineRange(d,M.originalRange.startLineNumber),new D.LineRange(e,M.modifiedRange.startLineNumber),void 0);N.modifiedRange.isEmpty||f.push(N),d=M.originalRange.endLineNumberExclusive,e=M.modifiedRange.endLineNumberExclusive}const w=new i(new D.LineRange(d,h+1),new D.LineRange(e,R+1),void 0);return w.modifiedRange.isEmpty||f.push(w),f}constructor(a,h,R){this.originalRange=a,this.modifiedRange=h,this.innerChanges=R}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}flip(){return new i(this.modifiedRange,this.originalRange,this.innerChanges?.map(a=>a.flip()))}}t.LineRangeMapping=i;class o{constructor(a,h){this.originalRange=a,this.modifiedRange=h}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new o(this.modifiedRange,this.originalRange)}}t.RangeMapping=o;class p{constructor(a,h){this.original=a,this.modified=h}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new p(this.modified,this.original)}join(a){return new p(this.original.join(a.original),this.modified.join(a.modified))}}t.SimpleLineRangeMapping=p;class l{constructor(a,h){this.lineRangeMapping=a,this.changes=h}flip(){return new l(this.lineRangeMapping.flip(),this.changes.map(a=>a.flip()))}}t.MovedText=l}),re(se[43],ae([0,1,15,10,28,3,12,6,4,2,9,42,39,40,26]),function(z,t,D,P,i,o,p,l,s,a,h,R,f,d,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.findFirstMonotonous=t.findLastMonotonous=t.LinesSliceCharSequence=t.LineSequence=t.getLineRangeMapping=t.lineRangeMappingFromRangeMappings=t.AdvancedLinesDiffComputer=void 0;class w{constructor(){this.dynamicProgrammingDiffing=new R.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new d.MyersDiffAlgorithm}computeDiff(W,$,K){if(W.length<=1&&(0,D.equals)(W,$,(q,J)=>q===J))return new e.LinesDiff([],[],!1);if(W.length===1&&W[0].length===0||$.length===1&&$[0].length===0)return new e.LinesDiff([new e.LineRangeMapping(new p.LineRange(1,W.length+1),new p.LineRange(1,$.length+1),[new e.RangeMapping(new a.Range(1,1,W.length,W[0].length+1),new a.Range(1,1,$.length,$[0].length+1))])],[],!1);const X=K.maxComputationTimeMs===0?h.InfiniteTimeout.instance:new h.DateTimeout(K.maxComputationTimeMs),ie=!K.ignoreTrimWhitespace,le=new Map;function ce(q){let J=le.get(q);return J===void 0&&(J=le.size,le.set(q,J)),J}const fe=W.map(q=>ce(q.trim())),be=$.map(q=>ce(q.trim())),Le=new m(fe,W),ve=new m(be,$),Ae=(()=>Le.length+ve.length<1700?this.dynamicProgrammingDiffing.compute(Le,ve,X,(q,J)=>W[q]===$[J]?$[J].length===0?.1:1+Math.log(1+$[J].length):.99):this.myersDiffingAlgorithm.compute(Le,ve))();let pe=Ae.diffs,Ne=Ae.hitTimeout;pe=(0,f.optimizeSequenceDiffs)(Le,ve,pe),pe=(0,f.removeRandomLineMatches)(Le,ve,pe);const Me=[],ne=q=>{if(ie)for(let J=0;J<q;J++){const te=k+J,oe=O+J;if(W[te]!==$[oe]){const he=this.refineDiff(W,$,new h.SequenceDiff(new l.OffsetRange(te,te+1),new l.OffsetRange(oe,oe+1)),X,ie);for(const me of he.mappings)Me.push(me);he.hitTimeout&&(Ne=!0)}}};let k=0,O=0;for(const q of pe){(0,P.assertFn)(()=>q.seq1Range.start-k===q.seq2Range.start-O);const J=q.seq1Range.start-k;ne(J),k=q.seq1Range.endExclusive,O=q.seq2Range.endExclusive;const te=this.refineDiff(W,$,q,X,ie);te.hitTimeout&&(Ne=!0);for(const oe of te.mappings)Me.push(oe)}ne(W.length-k);const T=r(Me,W,$);let B=[];return K.computeMoves&&(B=this.computeMoves(T,W,$,fe,be,X,ie)),(0,P.assertFn)(()=>{function q(te,oe){if(te.lineNumber<1||te.lineNumber>oe.length)return!1;const he=oe[te.lineNumber-1];return!(te.column<1||te.column>he.length+1)}function J(te,oe){return!(te.startLineNumber<1||te.startLineNumber>oe.length+1||te.endLineNumberExclusive<1||te.endLineNumberExclusive>oe.length+1)}for(const te of T){if(!te.innerChanges)return!1;for(const oe of te.innerChanges)if(!(q(oe.modifiedRange.getStartPosition(),$)&&q(oe.modifiedRange.getEndPosition(),$)&&q(oe.originalRange.getStartPosition(),W)&&q(oe.originalRange.getEndPosition(),W)))return!1;if(!J(te.modifiedRange,$)||!J(te.originalRange,W))return!1}return!0}),new e.LinesDiff(T,B,Ne)}computeMoves(W,$,K,X,ie,le,ce){const fe=[],be=W.filter(T=>T.modifiedRange.isEmpty&&T.originalRange.length>=3).map(T=>new ge(T.originalRange,$,T)),Le=new Set(W.filter(T=>T.originalRange.isEmpty&&T.modifiedRange.length>=3).map(T=>new ge(T.modifiedRange,K,T))),ve=new Set;for(const T of be){let B=-1,q;for(const J of Le){const te=T.computeSimilarity(J);te>B&&(B=te,q=J)}if(B>.9&&q&&(Le.delete(q),fe.push(new e.SimpleLineRangeMapping(T.range,q.range)),ve.add(T.source),ve.add(q.source)),!le.isValid())return[]}const Ae=new i.SetMap;for(const T of W)if(!ve.has(T))for(let B=T.originalRange.startLineNumber;B<T.originalRange.endLineNumberExclusive-2;B++){const q=`${X[B-1]}:${X[B+1-1]}:${X[B+2-1]}`;Ae.add(q,{range:new p.LineRange(B,B+3)})}const pe=[];W.sort((0,D.compareBy)(T=>T.modifiedRange.startLineNumber,D.numberComparator));for(const T of W){if(ve.has(T))continue;let B=[];for(let q=T.modifiedRange.startLineNumber;q<T.modifiedRange.endLineNumberExclusive-2;q++){const J=`${ie[q-1]}:${ie[q+1-1]}:${ie[q+2-1]}`,te=new p.LineRange(q,q+3),oe=[];Ae.forEach(J,({range:he})=>{for(const _e of B)if(_e.originalLineRange.endLineNumberExclusive+1===he.endLineNumberExclusive&&_e.modifiedLineRange.endLineNumberExclusive+1===te.endLineNumberExclusive){_e.originalLineRange=new p.LineRange(_e.originalLineRange.startLineNumber,he.endLineNumberExclusive),_e.modifiedLineRange=new p.LineRange(_e.modifiedLineRange.startLineNumber,te.endLineNumberExclusive),oe.push(_e);return}const me={modifiedLineRange:te,originalLineRange:he};pe.push(me),oe.push(me)}),B=oe}if(!le.isValid())return[]}pe.sort((0,D.reverseOrder)((0,D.compareBy)(T=>T.modifiedLineRange.length,D.numberComparator)));const Ne=new b,Me=new b;for(const T of pe){const B=T.modifiedLineRange.startLineNumber-T.originalLineRange.startLineNumber,q=Ne.subtractFrom(T.modifiedLineRange),J=Me.subtractFrom(T.originalLineRange).map(oe=>oe.delta(B)),te=N(q,J);for(const oe of te){if(oe.length<3)continue;const he=oe,me=oe.delta(-B);fe.push(new e.SimpleLineRangeMapping(me,he)),Ne.addRange(he),Me.addRange(me)}}if(fe.sort((0,D.compareBy)(T=>T.original.startLineNumber,D.numberComparator)),fe.length===0)return[];let ne=[fe[0]];for(let T=1;T<fe.length;T++){const B=ne[ne.length-1],q=fe[T],J=q.original.startLineNumber-B.original.endLineNumberExclusive,te=q.modified.startLineNumber-B.modified.endLineNumberExclusive;if(J>=0&&te>=0&&J+te<=2){ne[ne.length-1]=B.join(q);continue}q.original.toOffsetRange().slice($).map(me=>me.trim()).join(`
`).length<=10||ne.push(q)}const k=M.createOfSorted(W,T=>T.originalRange.endLineNumberExclusive,D.numberComparator);return ne=ne.filter(T=>{const B=k.findLastItemBeforeOrEqual(T.original.startLineNumber)||new e.LineRangeMapping(new p.LineRange(1,1),new p.LineRange(1,1),[]),q=T.modified.startLineNumber-B.modifiedRange.endLineNumberExclusive,J=T.original.startLineNumber-B.originalRange.endLineNumberExclusive;return q!==J}),ne.map(T=>{const B=this.refineDiff($,K,new h.SequenceDiff(T.original.toOffsetRange(),T.modified.toOffsetRange()),le,ce),q=r(B.mappings,$,K,!0);return new e.MovedText(T,q)})}refineDiff(W,$,K,X,ie){const le=new v(W,K.seq1Range,ie),ce=new v($,K.seq2Range,ie),fe=le.length+ce.length<500?this.dynamicProgrammingDiffing.compute(le,ce,X):this.myersDiffingAlgorithm.compute(le,ce,X);let be=fe.diffs;return be=(0,f.optimizeSequenceDiffs)(le,ce,be),be=g(le,ce,be),be=(0,f.smoothenSequenceDiffs)(le,ce,be),be=(0,f.removeRandomMatches)(le,ce,be),{mappings:be.map(ve=>new e.RangeMapping(le.translateRange(ve.seq1Range),ce.translateRange(ve.seq2Range))),hitTimeout:fe.hitTimeout}}}t.AdvancedLinesDiffComputer=w;class M{static create(W,$,K){return W.sort((X,ie)=>K($(X),$(ie))),new M(W,$,K)}static createOfSorted(W,$,K){return new M(W,$,K)}constructor(W,$,K){this._items=W,this._itemToDomain=$,this._domainComparator=K,this._currentIdx=0,this._lastValue=void 0,this._hasLastValue=!1}findLastItemBeforeOrEqual(W){if(this._hasLastValue&&D.CompareResult.isLessThan(this._domainComparator(W,this._lastValue)))throw new o.BugIndicatingError;for(this._lastValue=W,this._hasLastValue=!0;this._currentIdx<this._items.length&&D.CompareResult.isLessThanOrEqual(this._domainComparator(this._itemToDomain(this._items[this._currentIdx]),W));)this._currentIdx++;return this._currentIdx===0?void 0:this._items[this._currentIdx-1]}}function N(n,W){const $=[];let K=0,X=0;for(;K<n.length&&X<W.length;){const ie=n[K],le=W[X],ce=ie.intersect(le);ce&&!ce.isEmpty&&$.push(ce),ie.endLineNumberExclusive<le.endLineNumberExclusive?K++:X++}return $}class b{constructor(){this._normalizedRanges=[]}addRange(W){const $=A(this._normalizedRanges.findIndex(X=>X.endLineNumberExclusive>=W.startLineNumber),this._normalizedRanges.length),K=(0,D.findLastIndex)(this._normalizedRanges,X=>X.startLineNumber<=W.endLineNumberExclusive)+1;if($===K)this._normalizedRanges.splice($,0,W);else if($===K-1){const X=this._normalizedRanges[$];this._normalizedRanges[$]=X.join(W)}else{const X=this._normalizedRanges[$].join(this._normalizedRanges[K-1]).join(W);this._normalizedRanges.splice($,K-$,X)}}intersects(W){for(const $ of this._normalizedRanges)if($.intersectsStrict(W))return!0;return!1}subtractFrom(W){const $=A(this._normalizedRanges.findIndex(le=>le.endLineNumberExclusive>=W.startLineNumber),this._normalizedRanges.length),K=(0,D.findLastIndex)(this._normalizedRanges,le=>le.startLineNumber<=W.endLineNumberExclusive)+1;if($===K)return[W];const X=[];let ie=W.startLineNumber;for(let le=$;le<K;le++){const ce=this._normalizedRanges[le];ce.startLineNumber>ie&&X.push(new p.LineRange(ie,ce.startLineNumber)),ie=ce.endLineNumberExclusive}return ie<W.endLineNumberExclusive&&X.push(new p.LineRange(ie,W.endLineNumberExclusive)),X}}function A(n,W){return n===-1?W:n}function g(n,W,$){const K=[];let X;function ie(){if(!X)return;const ce=X.s1Range.length-X.deleted,fe=X.s2Range.length-X.added;Math.max(X.deleted,X.added)+(X.count-1)>ce&&K.push(new h.SequenceDiff(X.s1Range,X.s2Range)),X=void 0}for(const ce of $){let fe=function(pe,Ne){if(!X||!X.s1Range.containsRange(pe)||!X.s2Range.containsRange(Ne))if(X&&!(X.s1Range.endExclusive<pe.start&&X.s2Range.endExclusive<Ne.start)){const k=l.OffsetRange.tryCreate(X.s1Range.endExclusive,pe.start),O=l.OffsetRange.tryCreate(X.s2Range.endExclusive,Ne.start);X.deleted+=k?.length??0,X.added+=O?.length??0,X.s1Range=X.s1Range.join(pe),X.s2Range=X.s2Range.join(Ne)}else ie(),X={added:0,deleted:0,count:0,s1Range:pe,s2Range:Ne};const Me=pe.intersect(ce.seq1Range),ne=Ne.intersect(ce.seq2Range);X.count++,X.deleted+=Me?.length??0,X.added+=ne?.length??0};const be=n.findWordContaining(ce.seq1Range.start-1),Le=W.findWordContaining(ce.seq2Range.start-1),ve=n.findWordContaining(ce.seq1Range.endExclusive),Ae=W.findWordContaining(ce.seq2Range.endExclusive);be&&ve&&Le&&Ae&&be.equals(ve)&&Le.equals(Ae)?fe(be,Le):(be&&Le&&fe(be,Le),ve&&Ae&&fe(ve,Ae))}return ie(),c($,K)}function c(n,W){const $=[];for(;n.length>0||W.length>0;){const K=n[0],X=W[0];let ie;K&&(!X||K.seq1Range.start<X.seq1Range.start)?ie=n.shift():ie=W.shift(),$.length>0&&$[$.length-1].seq1Range.endExclusive>=ie.seq1Range.start?$[$.length-1]=$[$.length-1].join(ie):$.push(ie)}return $}function r(n,W,$,K=!1){const X=[];for(const ie of E(n.map(le=>u(le,W,$)),(le,ce)=>le.originalRange.overlapOrTouch(ce.originalRange)||le.modifiedRange.overlapOrTouch(ce.modifiedRange))){const le=ie[0],ce=ie[ie.length-1];X.push(new e.LineRangeMapping(le.originalRange.join(ce.originalRange),le.modifiedRange.join(ce.modifiedRange),ie.map(fe=>fe.innerChanges[0])))}return(0,P.assertFn)(()=>!K&&X.length>0&&X[0].originalRange.startLineNumber!==X[0].modifiedRange.startLineNumber?!1:(0,P.checkAdjacentItems)(X,(ie,le)=>le.originalRange.startLineNumber-ie.originalRange.endLineNumberExclusive===le.modifiedRange.startLineNumber-ie.modifiedRange.endLineNumberExclusive&&ie.originalRange.endLineNumberExclusive<le.originalRange.startLineNumber&&ie.modifiedRange.endLineNumberExclusive<le.modifiedRange.startLineNumber)),X}t.lineRangeMappingFromRangeMappings=r;function u(n,W,$){let K=0,X=0;n.modifiedRange.endColumn===1&&n.originalRange.endColumn===1&&n.originalRange.startLineNumber+K<=n.originalRange.endLineNumber&&n.modifiedRange.startLineNumber+K<=n.modifiedRange.endLineNumber&&(X=-1),n.modifiedRange.startColumn-1>=$[n.modifiedRange.startLineNumber-1].length&&n.originalRange.startColumn-1>=W[n.originalRange.startLineNumber-1].length&&n.originalRange.startLineNumber<=n.originalRange.endLineNumber+X&&n.modifiedRange.startLineNumber<=n.modifiedRange.endLineNumber+X&&(K=1);const ie=new p.LineRange(n.originalRange.startLineNumber+K,n.originalRange.endLineNumber+1+X),le=new p.LineRange(n.modifiedRange.startLineNumber+K,n.modifiedRange.endLineNumber+1+X);return new e.LineRangeMapping(ie,le,[n])}t.getLineRangeMapping=u;function*E(n,W){let $,K;for(const X of n)K!==void 0&&W(K,X)?$.push(X):($&&(yield $),$=[X]),K=X;$&&(yield $)}class m{constructor(W,$){this.trimmedHash=W,this.lines=$}getElement(W){return this.trimmedHash[W]}get length(){return this.trimmedHash.length}getBoundaryScore(W){const $=W===0?0:_(this.lines[W-1]),K=W===this.lines.length?0:_(this.lines[W]);return 1e3-($+K)}getText(W){return this.lines.slice(W.start,W.endExclusive).join(`
`)}isStronglyEqual(W,$){return this.lines[W]===this.lines[$]}}t.LineSequence=m;function _(n){let W=0;for(;W<n.length&&(n.charCodeAt(W)===32||n.charCodeAt(W)===9);)W++;return W}class v{constructor(W,$,K){this.lines=W,this.considerWhitespaceChanges=K,this.elements=[],this.firstCharOffsetByLineMinusOne=[],this.additionalOffsetByLine=[];let X=!1;$.start>0&&$.endExclusive>=W.length&&($=new l.OffsetRange($.start-1,$.endExclusive),X=!0),this.lineRange=$;for(let ie=this.lineRange.start;ie<this.lineRange.endExclusive;ie++){let le=W[ie],ce=0;if(X)ce=le.length,le="",X=!1;else if(!K){const fe=le.trimStart();ce=le.length-fe.length,le=fe.trimEnd()}this.additionalOffsetByLine.push(ce);for(let fe=0;fe<le.length;fe++)this.elements.push(le.charCodeAt(fe));ie<W.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLineMinusOne[ie-this.lineRange.start]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new l.OffsetRange(0,this.length))}getText(W){return this.elements.slice(W.start,W.endExclusive).map($=>String.fromCharCode($)).join("")}getElement(W){return this.elements[W]}get length(){return this.elements.length}getBoundaryScore(W){const $=F(W>0?this.elements[W-1]:-1),K=F(W<this.elements.length?this.elements[W]:-1);if($===6&&K===7)return 0;let X=0;return $!==K&&(X+=10,K===1&&(X+=1)),X+=Q($),X+=Q(K),X}translateOffset(W){if(this.lineRange.isEmpty)return new s.Position(this.lineRange.start+1,1);let $=0,K=this.firstCharOffsetByLineMinusOne.length;for(;$<K;){const ie=Math.floor(($+K)/2);this.firstCharOffsetByLineMinusOne[ie]>W?K=ie:$=ie+1}const X=$===0?0:this.firstCharOffsetByLineMinusOne[$-1];return new s.Position(this.lineRange.start+$+1,W-X+1+this.additionalOffsetByLine[$])}translateRange(W){return a.Range.fromPositions(this.translateOffset(W.start),this.translateOffset(W.endExclusive))}findWordContaining(W){if(W<0||W>=this.elements.length||!U(this.elements[W]))return;let $=W;for(;$>0&&U(this.elements[$-1]);)$--;let K=W;for(;K<this.elements.length&&U(this.elements[K]);)K++;return new l.OffsetRange($,K)}countLinesIn(W){return this.translateOffset(W.endExclusive).lineNumber-this.translateOffset(W.start).lineNumber}isStronglyEqual(W,$){return this.elements[W]===this.elements[$]}extendToFullLines(W){const $=y(this.firstCharOffsetByLineMinusOne,X=>X<=W.start)??0,K=S(this.firstCharOffsetByLineMinusOne,X=>W.endExclusive<=X)??this.elements.length;return new l.OffsetRange($,K)}}t.LinesSliceCharSequence=v;function L(n,W){let $=0,K=n.length;for(;$<K;){const X=Math.floor(($+K)/2);W(n[X])?$=X+1:K=X}return $-1}function y(n,W){const $=L(n,W);return $===-1?void 0:n[$]}t.findLastMonotonous=y;function C(n,W){let $=0,K=n.length;for(;$<K;){const X=Math.floor(($+K)/2);W(n[X])?K=X:$=X+1}return $}function S(n,W){const $=C(n,W);return $===n.length?void 0:n[$]}t.findFirstMonotonous=S;function U(n){return n>=97&&n<=122||n>=65&&n<=90||n>=48&&n<=57}var H;(function(n){n[n.WordLower=0]="WordLower",n[n.WordUpper=1]="WordUpper",n[n.WordNumber=2]="WordNumber",n[n.End=3]="End",n[n.Other=4]="Other",n[n.Space=5]="Space",n[n.LineBreakCR=6]="LineBreakCR",n[n.LineBreakLF=7]="LineBreakLF"})(H||(H={}));const x={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function Q(n){return x[n]}function F(n){return n===10?7:n===13?6:j(n)?5:n>=97&&n<=122?0:n>=65&&n<=90?1:n>=48&&n<=57?2:n===-1?3:4}function j(n){return n===32||n===9}const Z=new Map;function Y(n){let W=Z.get(n);return W===void 0&&(W=Z.size,Z.set(n,W)),W}class ge{constructor(W,$,K){this.range=W,this.lines=$,this.source=K,this.histogram=[];let X=0;for(let ie=W.startLineNumber-1;ie<W.endLineNumberExclusive-1;ie++){const le=$[ie];for(let fe=0;fe<le.length;fe++){X++;const be=le[fe],Le=Y(be);this.histogram[Le]=(this.histogram[Le]||0)+1}X++;const ce=Y(`
`);this.histogram[ce]=(this.histogram[ce]||0)+1}this.totalCount=X}computeSimilarity(W){let $=0;const K=Math.max(this.histogram.length,W.histogram.length);for(let X=0;X<K;X++)$+=Math.abs((this.histogram[X]??0)-(W.histogram[X]??0));return 1-$/(this.totalCount+W.totalCount)}}}),re(se[27],ae([0,1,21,26,5,2,10,12]),function(z,t,D,P,i,o,p,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.LegacyLinesDiffComputer=void 0;const s=3;class a{computeDiff(c,r,u){const m=new M(c,r,{maxComputationTime:u.maxComputationTimeMs,shouldIgnoreTrimWhitespace:u.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),_=[];let v=null;for(const L of m.changes){let y;L.originalEndLineNumber===0?y=new l.LineRange(L.originalStartLineNumber+1,L.originalStartLineNumber+1):y=new l.LineRange(L.originalStartLineNumber,L.originalEndLineNumber+1);let C;L.modifiedEndLineNumber===0?C=new l.LineRange(L.modifiedStartLineNumber+1,L.modifiedStartLineNumber+1):C=new l.LineRange(L.modifiedStartLineNumber,L.modifiedEndLineNumber+1);let S=new P.LineRangeMapping(y,C,L.charChanges?.map(U=>new P.RangeMapping(new o.Range(U.originalStartLineNumber,U.originalStartColumn,U.originalEndLineNumber,U.originalEndColumn),new o.Range(U.modifiedStartLineNumber,U.modifiedStartColumn,U.modifiedEndLineNumber,U.modifiedEndColumn))));v&&(v.modifiedRange.endLineNumberExclusive===S.modifiedRange.startLineNumber||v.originalRange.endLineNumberExclusive===S.originalRange.startLineNumber)&&(S=new P.LineRangeMapping(v.originalRange.join(S.originalRange),v.modifiedRange.join(S.modifiedRange),v.innerChanges&&S.innerChanges?v.innerChanges.concat(S.innerChanges):void 0),_.pop()),_.push(S),v=S}return(0,p.assertFn)(()=>(0,p.checkAdjacentItems)(_,(L,y)=>y.originalRange.startLineNumber-L.originalRange.endLineNumberExclusive===y.modifiedRange.startLineNumber-L.modifiedRange.endLineNumberExclusive&&L.originalRange.endLineNumberExclusive<y.originalRange.startLineNumber&&L.modifiedRange.endLineNumberExclusive<y.modifiedRange.startLineNumber)),new P.LinesDiff(_,[],m.quitEarly)}}t.LegacyLinesDiffComputer=a;function h(g,c,r,u){return new D.LcsDiff(g,c,r).ComputeDiff(u)}class R{constructor(c){const r=[],u=[];for(let E=0,m=c.length;E<m;E++)r[E]=N(c[E],1),u[E]=b(c[E],1);this.lines=c,this._startColumns=r,this._endColumns=u}getElements(){const c=[];for(let r=0,u=this.lines.length;r<u;r++)c[r]=this.lines[r].substring(this._startColumns[r]-1,this._endColumns[r]-1);return c}getStrictElement(c){return this.lines[c]}getStartLineNumber(c){return c+1}getEndLineNumber(c){return c+1}createCharSequence(c,r,u){const E=[],m=[],_=[];let v=0;for(let L=r;L<=u;L++){const y=this.lines[L],C=c?this._startColumns[L]:1,S=c?this._endColumns[L]:y.length+1;for(let U=C;U<S;U++)E[v]=y.charCodeAt(U-1),m[v]=L+1,_[v]=U,v++;!c&&L<u&&(E[v]=10,m[v]=L+1,_[v]=y.length+1,v++)}return new f(E,m,_)}}class f{constructor(c,r,u){this._charCodes=c,this._lineNumbers=r,this._columns=u}toString(){return"["+this._charCodes.map((c,r)=>(c===10?"\\n":String.fromCharCode(c))+`-(${this._lineNumbers[r]},${this._columns[r]})`).join(", ")+"]"}_assertIndex(c,r){if(c<0||c>=r.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(c){return c>0&&c===this._lineNumbers.length?this.getEndLineNumber(c-1):(this._assertIndex(c,this._lineNumbers),this._lineNumbers[c])}getEndLineNumber(c){return c===-1?this.getStartLineNumber(c+1):(this._assertIndex(c,this._lineNumbers),this._charCodes[c]===10?this._lineNumbers[c]+1:this._lineNumbers[c])}getStartColumn(c){return c>0&&c===this._columns.length?this.getEndColumn(c-1):(this._assertIndex(c,this._columns),this._columns[c])}getEndColumn(c){return c===-1?this.getStartColumn(c+1):(this._assertIndex(c,this._columns),this._charCodes[c]===10?1:this._columns[c]+1)}}class d{constructor(c,r,u,E,m,_,v,L){this.originalStartLineNumber=c,this.originalStartColumn=r,this.originalEndLineNumber=u,this.originalEndColumn=E,this.modifiedStartLineNumber=m,this.modifiedStartColumn=_,this.modifiedEndLineNumber=v,this.modifiedEndColumn=L}static createFromDiffChange(c,r,u){const E=r.getStartLineNumber(c.originalStart),m=r.getStartColumn(c.originalStart),_=r.getEndLineNumber(c.originalStart+c.originalLength-1),v=r.getEndColumn(c.originalStart+c.originalLength-1),L=u.getStartLineNumber(c.modifiedStart),y=u.getStartColumn(c.modifiedStart),C=u.getEndLineNumber(c.modifiedStart+c.modifiedLength-1),S=u.getEndColumn(c.modifiedStart+c.modifiedLength-1);return new d(E,m,_,v,L,y,C,S)}}function e(g){if(g.length<=1)return g;const c=[g[0]];let r=c[0];for(let u=1,E=g.length;u<E;u++){const m=g[u],_=m.originalStart-(r.originalStart+r.originalLength),v=m.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(_,v)<s?(r.originalLength=m.originalStart+m.originalLength-r.originalStart,r.modifiedLength=m.modifiedStart+m.modifiedLength-r.modifiedStart):(c.push(m),r=m)}return c}class w{constructor(c,r,u,E,m){this.originalStartLineNumber=c,this.originalEndLineNumber=r,this.modifiedStartLineNumber=u,this.modifiedEndLineNumber=E,this.charChanges=m}static createFromDiffResult(c,r,u,E,m,_,v){let L,y,C,S,U;if(r.originalLength===0?(L=u.getStartLineNumber(r.originalStart)-1,y=0):(L=u.getStartLineNumber(r.originalStart),y=u.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(C=E.getStartLineNumber(r.modifiedStart)-1,S=0):(C=E.getStartLineNumber(r.modifiedStart),S=E.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),_&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&m()){const H=u.createCharSequence(c,r.originalStart,r.originalStart+r.originalLength-1),x=E.createCharSequence(c,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(H.getElements().length>0&&x.getElements().length>0){let Q=h(H,x,m,!0).changes;v&&(Q=e(Q)),U=[];for(let F=0,j=Q.length;F<j;F++)U.push(d.createFromDiffChange(Q[F],H,x))}}return new w(L,y,C,S,U)}}class M{constructor(c,r,u){this.shouldComputeCharChanges=u.shouldComputeCharChanges,this.shouldPostProcessCharChanges=u.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=u.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=u.shouldMakePrettyDiff,this.originalLines=c,this.modifiedLines=r,this.original=new R(c),this.modified=new R(r),this.continueLineDiff=A(u.maxComputationTime),this.continueCharDiff=A(u.maxComputationTime===0?0:Math.min(u.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const c=h(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),r=c.changes,u=c.quitEarly;if(this.shouldIgnoreTrimWhitespace){const v=[];for(let L=0,y=r.length;L<y;L++)v.push(w.createFromDiffResult(this.shouldIgnoreTrimWhitespace,r[L],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:u,changes:v}}const E=[];let m=0,_=0;for(let v=-1,L=r.length;v<L;v++){const y=v+1<L?r[v+1]:null,C=y?y.originalStart:this.originalLines.length,S=y?y.modifiedStart:this.modifiedLines.length;for(;m<C&&_<S;){const U=this.originalLines[m],H=this.modifiedLines[_];if(U!==H){{let x=N(U,1),Q=N(H,1);for(;x>1&&Q>1;){const F=U.charCodeAt(x-2),j=H.charCodeAt(Q-2);if(F!==j)break;x--,Q--}(x>1||Q>1)&&this._pushTrimWhitespaceCharChange(E,m+1,1,x,_+1,1,Q)}{let x=b(U,1),Q=b(H,1);const F=U.length+1,j=H.length+1;for(;x<F&&Q<j;){const Z=U.charCodeAt(x-1),Y=U.charCodeAt(Q-1);if(Z!==Y)break;x++,Q++}(x<F||Q<j)&&this._pushTrimWhitespaceCharChange(E,m+1,x,F,_+1,Q,j)}}m++,_++}y&&(E.push(w.createFromDiffResult(this.shouldIgnoreTrimWhitespace,y,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),m+=y.originalLength,_+=y.modifiedLength)}return{quitEarly:u,changes:E}}_pushTrimWhitespaceCharChange(c,r,u,E,m,_,v){if(this._mergeTrimWhitespaceCharChange(c,r,u,E,m,_,v))return;let L;this.shouldComputeCharChanges&&(L=[new d(r,u,r,E,m,_,m,v)]),c.push(new w(r,r,m,m,L))}_mergeTrimWhitespaceCharChange(c,r,u,E,m,_,v){const L=c.length;if(L===0)return!1;const y=c[L-1];return y.originalEndLineNumber===0||y.modifiedEndLineNumber===0?!1:y.originalEndLineNumber===r&&y.modifiedEndLineNumber===m?(this.shouldComputeCharChanges&&y.charChanges&&y.charChanges.push(new d(r,u,r,E,m,_,m,v)),!0):y.originalEndLineNumber+1===r&&y.modifiedEndLineNumber+1===m?(y.originalEndLineNumber=r,y.modifiedEndLineNumber=m,this.shouldComputeCharChanges&&y.charChanges&&y.charChanges.push(new d(r,u,r,E,m,_,m,v)),!0):!1}}t.DiffComputer=M;function N(g,c){const r=i.firstNonWhitespaceIndex(g);return r===-1?c:r+1}function b(g,c){const r=i.lastNonWhitespaceIndex(g);return r===-1?c:r+2}function A(g){if(g===0)return()=>!0;const c=Date.now();return()=>Date.now()-c<g}}),re(se[44],ae([0,1,27,43]),function(z,t,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={getLegacy:()=>new D.LegacyLinesDiffComputer,getAdvanced:()=>new P.AdvancedLinesDiffComputer}}),re(se[45],ae([0,1,29]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeDefaultDocumentColors=void 0;function P(f){const d=[];for(const e of f){const w=Number(e);(w||w===0&&e.replace(/\s/g,"")!=="")&&d.push(w)}return d}function i(f,d,e,w){return{red:f/255,blue:e/255,green:d/255,alpha:w}}function o(f,d){const e=d.index,w=d[0].length;if(!e)return;const M=f.positionAt(e);return{startLineNumber:M.lineNumber,startColumn:M.column,endLineNumber:M.lineNumber,endColumn:M.column+w}}function p(f,d){if(!f)return;const e=D.Color.Format.CSS.parseHex(d);if(e)return{range:f,color:i(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function l(f,d,e){if(!f||d.length!==1)return;const M=d[0].values(),N=P(M);return{range:f,color:i(N[0],N[1],N[2],e?N[3]:1)}}function s(f,d,e){if(!f||d.length!==1)return;const M=d[0].values(),N=P(M),b=new D.Color(new D.HSLA(N[0],N[1]/100,N[2]/100,e?N[3]:1));return{range:f,color:i(b.rgba.r,b.rgba.g,b.rgba.b,b.rgba.a)}}function a(f,d){return typeof f=="string"?[...f.matchAll(d)]:f.findMatches(d)}function h(f){const d=[],w=a(f,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(w.length>0)for(const M of w){const N=M.filter(c=>c!==void 0),b=N[1],A=N[2];if(!A)continue;let g;if(b==="rgb"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;g=l(o(f,M),a(A,c),!1)}else if(b==="rgba"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;g=l(o(f,M),a(A,c),!0)}else if(b==="hsl"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;g=s(o(f,M),a(A,c),!1)}else if(b==="hsla"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;g=s(o(f,M),a(A,c),!0)}else b==="#"&&(g=p(o(f,M),b+A));g&&d.push(g)}return d}function R(f){return!f||typeof f.getValue!="function"||typeof f.positionAt!="function"?[]:h(f)}t.computeDefaultDocumentColors=R}),re(se[46],ae([0,1,24]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var P;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(P||(t.State=P={}));class i{constructor(e,w,M){const N=new Uint8Array(e*w);for(let b=0,A=e*w;b<A;b++)N[b]=M;this._data=N,this.rows=e,this.cols=w}get(e,w){return this._data[e*this.cols+w]}set(e,w,M){this._data[e*this.cols+w]=M}}class o{constructor(e){let w=0,M=0;for(let b=0,A=e.length;b<A;b++){const[g,c,r]=e[b];c>w&&(w=c),g>M&&(M=g),r>M&&(M=r)}w++,M++;const N=new i(M,w,0);for(let b=0,A=e.length;b<A;b++){const[g,c,r]=e[b];N.set(g,c,r)}this._states=N,this._maxCharCode=w}nextState(e,w){return w<0||w>=this._maxCharCode?0:this._states.get(e,w)}}t.StateMachine=o;let p=null;function l(){return p===null&&(p=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),p}var s;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(s||(s={}));let a=null;function h(){if(a===null){a=new D.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<d.length;w++)a.set(d.charCodeAt(w),1);const e=".,;:";for(let w=0;w<e.length;w++)a.set(e.charCodeAt(w),2)}return a}class R{static _createLink(e,w,M,N,b){let A=b-1;do{const g=w.charCodeAt(A);if(e.get(g)!==2)break;A--}while(A>N);if(N>0){const g=w.charCodeAt(N-1),c=w.charCodeAt(A);(g===40&&c===41||g===91&&c===93||g===123&&c===125)&&A--}return{range:{startLineNumber:M,startColumn:N+1,endLineNumber:M,endColumn:A+2},url:w.substring(N,A+1)}}static computeLinks(e,w=l()){const M=h(),N=[];for(let b=1,A=e.getLineCount();b<=A;b++){const g=e.getLineContent(b),c=g.length;let r=0,u=0,E=0,m=1,_=!1,v=!1,L=!1,y=!1;for(;r<c;){let C=!1;const S=g.charCodeAt(r);if(m===13){let U;switch(S){case 40:_=!0,U=0;break;case 41:U=_?0:1;break;case 91:L=!0,v=!0,U=0;break;case 93:L=!1,U=v?0:1;break;case 123:y=!0,U=0;break;case 125:U=y?0:1;break;case 39:case 34:case 96:E===S?U=1:E===39||E===34||E===96?U=0:U=1;break;case 42:U=E===42?1:0;break;case 124:U=E===124?1:0;break;case 32:U=L?0:1;break;default:U=M.get(S)}U===1&&(N.push(R._createLink(M,g,b,u,r)),C=!0)}else if(m===12){let U;S===91?(v=!0,U=0):U=M.get(S),U===1?C=!0:m=13}else m=w.nextState(m,S),m===0&&(C=!0);C&&(m=1,_=!1,v=!1,y=!1,u=r+1,E=S),r++}m===13&&N.push(R._createLink(M,g,b,u,c))}return N}}t.LinkComputer=R;function f(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:R.computeLinks(d)}t.computeLinks=f}),re(se[47],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class D{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new D}navigateValueSet(i,o,p,l,s){if(i&&o){const a=this.doNavigateValueSet(o,s);if(a)return{range:i,value:a}}if(p&&l){const a=this.doNavigateValueSet(l,s);if(a)return{range:p,value:a}}return null}doNavigateValueSet(i,o){const p=this.numberReplace(i,o);return p!==null?p:this.textReplace(i,o)}numberReplace(i,o){const p=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let l=Number(i);const s=parseFloat(i);return!isNaN(l)&&!isNaN(s)&&l===s?l===0&&!o?null:(l=Math.floor(l*p),l+=o?p:-p,String(l/p)):null}textReplace(i,o){return this.valueSetsReplace(this._defaultValueSet,i,o)}valueSetsReplace(i,o,p){let l=null;for(let s=0,a=i.length;l===null&&s<a;s++)l=this.valueSetReplace(i[s],o,p);return l}valueSetReplace(i,o,p){let l=i.indexOf(o);return l>=0?(l+=p?1:-1,l<0?l=i.length-1:l%=i.length,i[l]):null}}t.BasicInplaceReplace=D}),re(se[48],ae([0,1,11]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var P;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(P||(t.OverviewRulerLane=P={}));var i;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(i||(t.GlyphMarginLane=i={}));var o;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(o||(t.MinimapPosition=o={}));var p;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(p||(t.InjectedTextCursorStops=p={}));var l;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(l||(t.EndOfLinePreference=l={}));var s;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(s||(t.DefaultEndOfLine=s={}));var a;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(a||(t.EndOfLineSequence=a={}));class h{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,c.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this._indentSizeIsTabSize===c._indentSizeIsTabSize&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,D.equals)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}t.TextModelResolvedOptions=h;class R{constructor(c,r){this._findMatchBrand=void 0,this.range=c,this.matches=r}}t.FindMatch=R;var f;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(f||(t.TrackedRangeStickiness=f={}));function d(g){return g&&typeof g.read=="function"}t.isITextSnapshot=d;var e;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var w;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(t.ModelConstants=w={}));class M{constructor(c,r,u,E,m,_){this.identifier=c,this.range=r,this.text=u,this.forceMoveMarkers=E,this.isAutoWhitespaceEdit=m,this._isTracked=_}}t.ValidAnnotatedEditOperation=M;class N{constructor(c,r,u){this.regex=c,this.wordSeparators=r,this.simpleSearch=u}}t.SearchData=N;class b{constructor(c,r,u){this.reverseEdits=c,this.changes=r,this.trimAutoWhitespaceLineNumbers=u}}t.ApplyEditsResult=b;function A(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}t.shouldSynchronizeModel=A}),re(se[49],ae([0,1,15,23]),function(z,t,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class i{constructor(s){this.values=s,this.prefixSum=new Uint32Array(s.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(s,a){s=(0,P.toUint32)(s);const h=this.values,R=this.prefixSum,f=a.length;return f===0?!1:(this.values=new Uint32Array(h.length+f),this.values.set(h.subarray(0,s),0),this.values.set(h.subarray(s),s+f),this.values.set(a,s),s-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=s-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(R.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(s,a){return s=(0,P.toUint32)(s),a=(0,P.toUint32)(a),this.values[s]===a?!1:(this.values[s]=a,s-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=s-1),!0)}removeValues(s,a){s=(0,P.toUint32)(s),a=(0,P.toUint32)(a);const h=this.values,R=this.prefixSum;if(s>=h.length)return!1;const f=h.length-s;return a>=f&&(a=f),a===0?!1:(this.values=new Uint32Array(h.length-a),this.values.set(h.subarray(0,s),0),this.values.set(h.subarray(s+a),s),this.prefixSum=new Uint32Array(this.values.length),s-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=s-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(R.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(s){return s<0?0:(s=(0,P.toUint32)(s),this._getPrefixSum(s))}_getPrefixSum(s){if(s<=this.prefixSumValidIndex[0])return this.prefixSum[s];let a=this.prefixSumValidIndex[0]+1;a===0&&(this.prefixSum[0]=this.values[0],a++),s>=this.values.length&&(s=this.values.length-1);for(let h=a;h<=s;h++)this.prefixSum[h]=this.prefixSum[h-1]+this.values[h];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],s),this.prefixSum[s]}getIndexOf(s){s=Math.floor(s),this.getTotalSum();let a=0,h=this.values.length-1,R=0,f=0,d=0;for(;a<=h;)if(R=a+(h-a)/2|0,f=this.prefixSum[R],d=f-this.values[R],s<d)h=R-1;else if(s>=f)a=R+1;else break;return new p(R,s-d)}}t.PrefixSumComputer=i;class o{constructor(s){this._values=s,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(s){return this._ensureValid(),s===0?0:this._prefixSum[s-1]}getIndexOf(s){this._ensureValid();const a=this._indexBySum[s],h=a>0?this._prefixSum[a-1]:0;return new p(a,s-h)}removeValues(s,a){this._values.splice(s,a),this._invalidate(s)}insertValues(s,a){this._values=(0,D.arrayInsert)(this._values,s,a),this._invalidate(s)}_invalidate(s){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,s-1)}_ensureValid(){if(!this._isValid){for(let s=this._validEndIndex+1,a=this._values.length;s<a;s++){const h=this._values[s],R=s>0?this._prefixSum[s-1]:0;this._prefixSum[s]=R+h;for(let f=0;f<h;f++)this._indexBySum[R+f]=s}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(s,a){this._values[s]!==a&&(this._values[s]=a,this._invalidate(s))}}t.ConstantTimePrefixSumComputer=o;class p{constructor(s,a){this.index=s,this.remainder=a,this._prefixSumIndexOfResultBrand=void 0,this.index=s,this.remainder=a}}t.PrefixSumIndexOfResult=p}),re(se[50],ae([0,1,5,4,49]),function(z,t,D,P,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class o{constructor(l,s,a,h){this._uri=l,this._lines=s,this._eol=a,this._versionId=h,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(l){l.eol&&l.eol!==this._eol&&(this._eol=l.eol,this._lineStarts=null);const s=l.changes;for(const a of s)this._acceptDeleteRange(a.range),this._acceptInsertText(new P.Position(a.range.startLineNumber,a.range.startColumn),a.text);this._versionId=l.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const l=this._eol.length,s=this._lines.length,a=new Uint32Array(s);for(let h=0;h<s;h++)a[h]=this._lines[h].length+l;this._lineStarts=new i.PrefixSumComputer(a)}}_setLineText(l,s){this._lines[l]=s,this._lineStarts&&this._lineStarts.setValue(l,this._lines[l].length+this._eol.length)}_acceptDeleteRange(l){if(l.startLineNumber===l.endLineNumber){if(l.startColumn===l.endColumn)return;this._setLineText(l.startLineNumber-1,this._lines[l.startLineNumber-1].substring(0,l.startColumn-1)+this._lines[l.startLineNumber-1].substring(l.endColumn-1));return}this._setLineText(l.startLineNumber-1,this._lines[l.startLineNumber-1].substring(0,l.startColumn-1)+this._lines[l.endLineNumber-1].substring(l.endColumn-1)),this._lines.splice(l.startLineNumber,l.endLineNumber-l.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(l.startLineNumber,l.endLineNumber-l.startLineNumber)}_acceptInsertText(l,s){if(s.length===0)return;const a=(0,D.splitLines)(s);if(a.length===1){this._setLineText(l.lineNumber-1,this._lines[l.lineNumber-1].substring(0,l.column-1)+a[0]+this._lines[l.lineNumber-1].substring(l.column-1));return}a[a.length-1]+=this._lines[l.lineNumber-1].substring(l.column-1),this._setLineText(l.lineNumber-1,this._lines[l.lineNumber-1].substring(0,l.column-1)+a[0]);const h=new Uint32Array(a.length-1);for(let R=1;R<a.length;R++)this._lines.splice(l.lineNumber+R-1,0,a[R]),h[R-1]=a[R].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(l.lineNumber,h)}}t.MirrorTextModel=o}),re(se[51],ae([0,1,5,38,4,2,48]),function(z,t,D,P,i,o,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const l=999;class s{constructor(b,A,g,c){this.searchString=b,this.isRegex=A,this.matchCase=g,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=a(this.searchString):b=this.searchString.indexOf(`
`)>=0;let A=null;try{A=D.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!A)return null;let g=!this.isRegex&&!b;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new p.SearchData(A,this.wordSeparators?(0,P.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}t.SearchParams=s;function a(N){if(!N||N.length===0)return!1;for(let b=0,A=N.length;b<A;b++){const g=N.charCodeAt(b);if(g===10)return!0;if(g===92){if(b++,b>=A)break;const c=N.charCodeAt(b);if(c===110||c===114||c===87)return!0}}return!1}t.isMultilineRegexSource=a;function h(N,b,A){if(!A)return new p.FindMatch(N,null);const g=[];for(let c=0,r=b.length;c<r;c++)g[c]=b[c];return new p.FindMatch(N,g)}t.createFindMatch=h;class R{constructor(b){const A=[];let g=0;for(let c=0,r=b.length;c<r;c++)b.charCodeAt(c)===10&&(A[g++]=c);this._lineFeedsOffsets=A}findLineFeedCountBeforeOffset(b){const A=this._lineFeedsOffsets;let g=0,c=A.length-1;if(c===-1||b<=A[0])return 0;for(;g<c;){const r=g+((c-g)/2>>0);A[r]>=b?c=r-1:A[r+1]>=b?(g=r,c=r):g=r+1}return g+1}}class f{static findMatches(b,A,g,c,r){const u=A.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(b,g,new M(u.wordSeparators,u.regex),c,r):this._doFindMatchesLineByLine(b,g,u,c,r):[]}static _getMultilineMatchRange(b,A,g,c,r,u){let E,m=0;c?(m=c.findLineFeedCountBeforeOffset(r),E=A+r+m):E=A+r;let _;if(c){const C=c.findLineFeedCountBeforeOffset(r+u.length)-m;_=E+u.length+C}else _=E+u.length;const v=b.getPositionAt(E),L=b.getPositionAt(_);return new o.Range(v.lineNumber,v.column,L.lineNumber,L.column)}static _doFindMatchesMultiline(b,A,g,c,r){const u=b.getOffsetAt(A.getStartPosition()),E=b.getValueInRange(A,1),m=b.getEOL()===`\r
`?new R(E):null,_=[];let v=0,L;for(g.reset(0);L=g.next(E);)if(_[v++]=h(this._getMultilineMatchRange(b,u,E,m,L.index,L[0]),L,c),v>=r)return _;return _}static _doFindMatchesLineByLine(b,A,g,c,r){const u=[];let E=0;if(A.startLineNumber===A.endLineNumber){const _=b.getLineContent(A.startLineNumber).substring(A.startColumn-1,A.endColumn-1);return E=this._findMatchesInLine(g,_,A.startLineNumber,A.startColumn-1,E,u,c,r),u}const m=b.getLineContent(A.startLineNumber).substring(A.startColumn-1);E=this._findMatchesInLine(g,m,A.startLineNumber,A.startColumn-1,E,u,c,r);for(let _=A.startLineNumber+1;_<A.endLineNumber&&E<r;_++)E=this._findMatchesInLine(g,b.getLineContent(_),_,0,E,u,c,r);if(E<r){const _=b.getLineContent(A.endLineNumber).substring(0,A.endColumn-1);E=this._findMatchesInLine(g,_,A.endLineNumber,0,E,u,c,r)}return u}static _findMatchesInLine(b,A,g,c,r,u,E,m){const _=b.wordSeparators;if(!E&&b.simpleSearch){const y=b.simpleSearch,C=y.length,S=A.length;let U=-C;for(;(U=A.indexOf(y,U+C))!==-1;)if((!_||w(_,A,S,U,C))&&(u[r++]=new p.FindMatch(new o.Range(g,U+1+c,g,U+1+C+c),null),r>=m))return r;return r}const v=new M(b.wordSeparators,b.regex);let L;v.reset(0);do if(L=v.next(A),L&&(u[r++]=h(new o.Range(g,L.index+1+c,g,L.index+1+L[0].length+c),L,E),r>=m))return r;while(L);return r}static findNextMatch(b,A,g,c){const r=A.parseSearchRequest();if(!r)return null;const u=new M(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(b,g,u,c):this._doFindNextMatchLineByLine(b,g,u,c)}static _doFindNextMatchMultiline(b,A,g,c){const r=new i.Position(A.lineNumber,1),u=b.getOffsetAt(r),E=b.getLineCount(),m=b.getValueInRange(new o.Range(r.lineNumber,r.column,E,b.getLineMaxColumn(E)),1),_=b.getEOL()===`\r
`?new R(m):null;g.reset(A.column-1);const v=g.next(m);return v?h(this._getMultilineMatchRange(b,u,m,_,v.index,v[0]),v,c):A.lineNumber!==1||A.column!==1?this._doFindNextMatchMultiline(b,new i.Position(1,1),g,c):null}static _doFindNextMatchLineByLine(b,A,g,c){const r=b.getLineCount(),u=A.lineNumber,E=b.getLineContent(u),m=this._findFirstMatchInLine(g,E,u,A.column,c);if(m)return m;for(let _=1;_<=r;_++){const v=(u+_-1)%r,L=b.getLineContent(v+1),y=this._findFirstMatchInLine(g,L,v+1,1,c);if(y)return y}return null}static _findFirstMatchInLine(b,A,g,c,r){b.reset(c-1);const u=b.next(A);return u?h(new o.Range(g,u.index+1,g,u.index+1+u[0].length),u,r):null}static findPreviousMatch(b,A,g,c){const r=A.parseSearchRequest();if(!r)return null;const u=new M(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(b,g,u,c):this._doFindPreviousMatchLineByLine(b,g,u,c)}static _doFindPreviousMatchMultiline(b,A,g,c){const r=this._doFindMatchesMultiline(b,new o.Range(1,1,A.lineNumber,A.column),g,c,10*l);if(r.length>0)return r[r.length-1];const u=b.getLineCount();return A.lineNumber!==u||A.column!==b.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(b,new i.Position(u,b.getLineMaxColumn(u)),g,c):null}static _doFindPreviousMatchLineByLine(b,A,g,c){const r=b.getLineCount(),u=A.lineNumber,E=b.getLineContent(u).substring(0,A.column-1),m=this._findLastMatchInLine(g,E,u,c);if(m)return m;for(let _=1;_<=r;_++){const v=(r+u-_-1)%r,L=b.getLineContent(v+1),y=this._findLastMatchInLine(g,L,v+1,c);if(y)return y}return null}static _findLastMatchInLine(b,A,g,c){let r=null,u;for(b.reset(0);u=b.next(A);)r=h(new o.Range(g,u.index+1,g,u.index+1+u[0].length),u,c);return r}}t.TextModelSearch=f;function d(N,b,A,g,c){if(g===0)return!0;const r=b.charCodeAt(g-1);if(N.get(r)!==0||r===13||r===10)return!0;if(c>0){const u=b.charCodeAt(g);if(N.get(u)!==0)return!0}return!1}function e(N,b,A,g,c){if(g+c===A)return!0;const r=b.charCodeAt(g+c);if(N.get(r)!==0||r===13||r===10)return!0;if(c>0){const u=b.charCodeAt(g+c-1);if(N.get(u)!==0)return!0}return!1}function w(N,b,A,g,c){return d(N,b,A,g,c)&&e(N,b,A,g,c)}t.isValidMatch=w;class M{constructor(b,A){this._wordSeparators=b,this._searchRegex=A,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(b){this._searchRegex.lastIndex=b,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(b){const A=b.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===A||(g=this._searchRegex.exec(b),!g))return null;const c=g.index,r=g[0].length;if(c===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){D.getNextCodePoint(b,A,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=c,this._prevMatchLength=r,!this._wordSeparators||w(this._wordSeparators,b,A,c,r))return g}while(g);return null}}t.Searcher=M}),re(se[52],ae([0,1,2,51,5,10,25]),function(z,t,D,P,i,o,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class l{static computeUnicodeHighlights(e,w,M){const N=M?M.startLineNumber:1,b=M?M.endLineNumber:e.getLineCount(),A=new h(w),g=A.getCandidateCodePoints();let c;g==="allNonBasicAscii"?c=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):c=new RegExp(`${s(Array.from(g))}`,"g");const r=new P.Searcher(null,c),u=[];let E=!1,m,_=0,v=0,L=0;e:for(let y=N,C=b;y<=C;y++){const S=e.getLineContent(y),U=S.length;r.reset(0);do if(m=r.next(S),m){let H=m.index,x=m.index+m[0].length;if(H>0){const Z=S.charCodeAt(H-1);i.isHighSurrogate(Z)&&H--}if(x+1<U){const Z=S.charCodeAt(x-1);i.isHighSurrogate(Z)&&x++}const Q=S.substring(H,x);let F=(0,p.getWordAtText)(H+1,p.DEFAULT_WORD_REGEXP,S,0);F&&F.endColumn<=H+1&&(F=null);const j=A.shouldHighlightNonBasicASCII(Q,F?F.word:null);if(j!==0){j===3?_++:j===2?v++:j===1?L++:(0,o.assertNever)(j);const Z=1e3;if(u.length>=Z){E=!0;break e}u.push(new D.Range(y,H+1,y,x+1))}}while(m)}return{ranges:u,hasMore:E,ambiguousCharacterCount:_,invisibleCharacterCount:v,nonBasicAsciiCharacterCount:L}}static computeUnicodeHighlightReason(e,w){const M=new h(w);switch(M.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const b=e.codePointAt(0),A=M.ambiguousCharacters.getPrimaryConfusable(b),g=i.AmbiguousCharacters.getLocales().filter(c=>!i.AmbiguousCharacters.getInstance(new Set([...w.allowedLocales,c])).isAmbiguous(b));return{kind:0,confusableWith:String.fromCodePoint(A),notAmbiguousInLocales:g}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=l;function s(d,e){return`[${i.escapeRegExpCharacters(d.map(M=>String.fromCodePoint(M)).join(""))}]`}var a;(function(d){d[d.Ambiguous=0]="Ambiguous",d[d.Invisible=1]="Invisible",d[d.NonBasicAscii=2]="NonBasicAscii"})(a||(t.UnicodeHighlighterReasonKind=a={}));class h{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const w of i.InvisibleCharacters.codePoints)R(String.fromCodePoint(w))||e.add(w);if(this.options.ambiguousCharacters)for(const w of this.ambiguousCharacters.getConfusableCodePoints())e.add(w);for(const w of this.allowedCodePoints)e.delete(w);return e}shouldHighlightNonBasicASCII(e,w){const M=e.codePointAt(0);if(this.allowedCodePoints.has(M))return 0;if(this.options.nonBasicASCII)return 1;let N=!1,b=!1;if(w)for(const A of w){const g=A.codePointAt(0),c=i.isBasicASCII(A);N=N||c,!c&&!this.ambiguousCharacters.isAmbiguous(g)&&!i.InvisibleCharacters.isInvisibleCharacter(g)&&(b=!0)}return!N&&b?0:this.options.invisibleCharacters&&!R(e)&&i.InvisibleCharacters.isInvisibleCharacter(M)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(M)?3:0}}function R(d){return d===" "||d===`
`||d==="	"}var f;(function(d){d[d.None=0]="None",d[d.NonBasicASCII=1]="NonBasicASCII",d[d.Invisible=2]="Invisible",d[d.Ambiguous=3]="Ambiguous"})(f||(f={}))}),re(se[53],ae([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var D;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(D||(t.AccessibilitySupport=D={}));var P;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(P||(t.CodeActionTriggerType=P={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i||(t.CompletionItemInsertTextRule=i={}));var o;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(o||(t.CompletionItemKind=o={}));var p;(function(n){n[n.Deprecated=1]="Deprecated"})(p||(t.CompletionItemTag=p={}));var l;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(l||(t.CompletionTriggerKind=l={}));var s;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(s||(t.ContentWidgetPositionPreference=s={}));var a;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(a||(t.CursorChangeReason=a={}));var h;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(h||(t.DefaultEndOfLine=h={}));var R;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(R||(t.DocumentHighlightKind=R={}));var f;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(f||(t.EditorAutoIndentStrategy=f={}));var d;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=8]="autoClosingDelete",n[n.autoClosingOvertype=9]="autoClosingOvertype",n[n.autoClosingQuotes=10]="autoClosingQuotes",n[n.autoIndent=11]="autoIndent",n[n.automaticLayout=12]="automaticLayout",n[n.autoSurround=13]="autoSurround",n[n.bracketPairColorization=14]="bracketPairColorization",n[n.guides=15]="guides",n[n.codeLens=16]="codeLens",n[n.codeLensFontFamily=17]="codeLensFontFamily",n[n.codeLensFontSize=18]="codeLensFontSize",n[n.colorDecorators=19]="colorDecorators",n[n.colorDecoratorsLimit=20]="colorDecoratorsLimit",n[n.columnSelection=21]="columnSelection",n[n.comments=22]="comments",n[n.contextmenu=23]="contextmenu",n[n.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",n[n.cursorBlinking=25]="cursorBlinking",n[n.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",n[n.cursorStyle=27]="cursorStyle",n[n.cursorSurroundingLines=28]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",n[n.cursorWidth=30]="cursorWidth",n[n.disableLayerHinting=31]="disableLayerHinting",n[n.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",n[n.domReadOnly=33]="domReadOnly",n[n.dragAndDrop=34]="dragAndDrop",n[n.dropIntoEditor=35]="dropIntoEditor",n[n.emptySelectionClipboard=36]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",n[n.extraEditorClassName=38]="extraEditorClassName",n[n.fastScrollSensitivity=39]="fastScrollSensitivity",n[n.find=40]="find",n[n.fixedOverflowWidgets=41]="fixedOverflowWidgets",n[n.folding=42]="folding",n[n.foldingStrategy=43]="foldingStrategy",n[n.foldingHighlight=44]="foldingHighlight",n[n.foldingImportsByDefault=45]="foldingImportsByDefault",n[n.foldingMaximumRegions=46]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=48]="fontFamily",n[n.fontInfo=49]="fontInfo",n[n.fontLigatures=50]="fontLigatures",n[n.fontSize=51]="fontSize",n[n.fontWeight=52]="fontWeight",n[n.fontVariations=53]="fontVariations",n[n.formatOnPaste=54]="formatOnPaste",n[n.formatOnType=55]="formatOnType",n[n.glyphMargin=56]="glyphMargin",n[n.gotoLocation=57]="gotoLocation",n[n.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",n[n.hover=59]="hover",n[n.inDiffEditor=60]="inDiffEditor",n[n.inlineSuggest=61]="inlineSuggest",n[n.letterSpacing=62]="letterSpacing",n[n.lightbulb=63]="lightbulb",n[n.lineDecorationsWidth=64]="lineDecorationsWidth",n[n.lineHeight=65]="lineHeight",n[n.lineNumbers=66]="lineNumbers",n[n.lineNumbersMinChars=67]="lineNumbersMinChars",n[n.linkedEditing=68]="linkedEditing",n[n.links=69]="links",n[n.matchBrackets=70]="matchBrackets",n[n.minimap=71]="minimap",n[n.mouseStyle=72]="mouseStyle",n[n.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=74]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",n[n.multiCursorModifier=76]="multiCursorModifier",n[n.multiCursorPaste=77]="multiCursorPaste",n[n.multiCursorLimit=78]="multiCursorLimit",n[n.occurrencesHighlight=79]="occurrencesHighlight",n[n.overviewRulerBorder=80]="overviewRulerBorder",n[n.overviewRulerLanes=81]="overviewRulerLanes",n[n.padding=82]="padding",n[n.pasteAs=83]="pasteAs",n[n.parameterHints=84]="parameterHints",n[n.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",n[n.quickSuggestions=87]="quickSuggestions",n[n.quickSuggestionsDelay=88]="quickSuggestionsDelay",n[n.readOnly=89]="readOnly",n[n.readOnlyMessage=90]="readOnlyMessage",n[n.renameOnType=91]="renameOnType",n[n.renderControlCharacters=92]="renderControlCharacters",n[n.renderFinalNewline=93]="renderFinalNewline",n[n.renderLineHighlight=94]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=96]="renderValidationDecorations",n[n.renderWhitespace=97]="renderWhitespace",n[n.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",n[n.roundedSelection=99]="roundedSelection",n[n.rulers=100]="rulers",n[n.scrollbar=101]="scrollbar",n[n.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=103]="scrollBeyondLastLine",n[n.scrollPredominantAxis=104]="scrollPredominantAxis",n[n.selectionClipboard=105]="selectionClipboard",n[n.selectionHighlight=106]="selectionHighlight",n[n.selectOnLineNumbers=107]="selectOnLineNumbers",n[n.showFoldingControls=108]="showFoldingControls",n[n.showUnused=109]="showUnused",n[n.snippetSuggestions=110]="snippetSuggestions",n[n.smartSelect=111]="smartSelect",n[n.smoothScrolling=112]="smoothScrolling",n[n.stickyScroll=113]="stickyScroll",n[n.stickyTabStops=114]="stickyTabStops",n[n.stopRenderingLineAfter=115]="stopRenderingLineAfter",n[n.suggest=116]="suggest",n[n.suggestFontSize=117]="suggestFontSize",n[n.suggestLineHeight=118]="suggestLineHeight",n[n.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",n[n.suggestSelection=120]="suggestSelection",n[n.tabCompletion=121]="tabCompletion",n[n.tabIndex=122]="tabIndex",n[n.unicodeHighlighting=123]="unicodeHighlighting",n[n.unusualLineTerminators=124]="unusualLineTerminators",n[n.useShadowDOM=125]="useShadowDOM",n[n.useTabStops=126]="useTabStops",n[n.wordBreak=127]="wordBreak",n[n.wordSeparators=128]="wordSeparators",n[n.wordWrap=129]="wordWrap",n[n.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=132]="wordWrapColumn",n[n.wordWrapOverride1=133]="wordWrapOverride1",n[n.wordWrapOverride2=134]="wordWrapOverride2",n[n.wrappingIndent=135]="wrappingIndent",n[n.wrappingStrategy=136]="wrappingStrategy",n[n.showDeprecated=137]="showDeprecated",n[n.inlayHints=138]="inlayHints",n[n.editorClassName=139]="editorClassName",n[n.pixelRatio=140]="pixelRatio",n[n.tabFocusMode=141]="tabFocusMode",n[n.layoutInfo=142]="layoutInfo",n[n.wrappingInfo=143]="wrappingInfo",n[n.defaultColorDecorators=144]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=146]="inlineCompletionsAccessibilityVerbose"})(d||(t.EditorOption=d={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var w;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(w||(t.EndOfLineSequence=w={}));var M;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(M||(t.GlyphMarginLane=M={}));var N;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(N||(t.IndentAction=N={}));var b;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(b||(t.InjectedTextCursorStops=b={}));var A;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(A||(t.InlayHintKind=A={}));var g;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(g||(t.InlineCompletionTriggerKind=g={}));var c;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(c||(t.KeyCode=c={}));var r;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(r||(t.MarkerSeverity=r={}));var u;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(u||(t.MarkerTag=u={}));var E;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(E||(t.MinimapPosition=E={}));var m;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(m||(t.MouseTargetType=m={}));var _;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(_||(t.OverlayWidgetPositionPreference=_={}));var v;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(v||(t.OverviewRulerLane=v={}));var L;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(L||(t.PositionAffinity=L={}));var y;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(y||(t.RenderLineNumbersType=y={}));var C;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(C||(t.RenderMinimap=C={}));var S;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(S||(t.ScrollType=S={}));var U;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(U||(t.ScrollbarVisibility=U={}));var H;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(H||(t.SelectionDirection=H={}));var x;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(x||(t.SignatureHelpTriggerKind=x={}));var Q;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(Q||(t.SymbolKind=Q={}));var F;(function(n){n[n.Deprecated=1]="Deprecated"})(F||(t.SymbolTag=F={}));var j;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(j||(t.TextEditorCursorBlinkingStyle=j={}));var Z;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(Z||(t.TextEditorCursorStyle=Z={}));var Y;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(Y||(t.TrackedRangeStickiness=Y={}));var ge;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(ge||(t.WrappingIndent=ge={}))}),re(se[54],ae([0,1,8,7]),function(z,t,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(l){this._onDidChange.fire({changedLanguages:l,changedColorMap:!1})}register(l,s){return this._tokenizationSupports.set(l,s),this.handleChange([l]),(0,P.toDisposable)(()=>{this._tokenizationSupports.get(l)===s&&(this._tokenizationSupports.delete(l),this.handleChange([l]))})}get(l){return this._tokenizationSupports.get(l)||null}registerFactory(l,s){this._factories.get(l)?.dispose();const a=new o(this,l,s);return this._factories.set(l,a),(0,P.toDisposable)(()=>{const h=this._factories.get(l);!h||h!==a||(this._factories.delete(l),h.dispose())})}async getOrCreate(l){const s=this.get(l);if(s)return s;const a=this._factories.get(l);return!a||a.isResolved?null:(await a.resolve(),this.get(l))}isResolved(l){if(this.get(l))return!0;const a=this._factories.get(l);return!!(!a||a.isResolved)}setColorMap(l){this._colorMap=l,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}t.TokenizationRegistry=i;class o extends P.Disposable{get isResolved(){return this._isResolved}constructor(l,s,a){super(),this._registry=l,this._languageId=s,this._factory=a,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const l=await this._factory.tokenizationSupport;this._isResolved=!0,l&&!this._isDisposed&&this._register(this._registry.register(this._languageId,l))}}}),re(se[55],ae([56,57]),function(z,t){return z.create("vs/base/common/platform",t)}),re(se[13],ae([0,1,55]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let P=!1,i=!1,o=!1,p=!1,l=!1,s=!1,a=!1,h=!1,R=!1,f=!1,d,e=t.LANGUAGE_DEFAULT,w=t.LANGUAGE_DEFAULT,M,N;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let b;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?b=t.globals.vscode.process:typeof process<"u"&&(b=process);const A=typeof b?.versions?.electron=="string",g=A&&b?.type==="renderer";if(typeof navigator=="object"&&!g)N=navigator.userAgent,P=N.indexOf("Windows")>=0,i=N.indexOf("Macintosh")>=0,h=(N.indexOf("Macintosh")>=0||N.indexOf("iPad")>=0||N.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,o=N.indexOf("Linux")>=0,f=N?.indexOf("Mobi")>=0,s=!0,d=D.getConfiguredDefaultLocale(D.localize(0,null))||t.LANGUAGE_DEFAULT,e=d,w=navigator.language;else if(typeof b=="object"){P=b.platform==="win32",i=b.platform==="darwin",o=b.platform==="linux",p=o&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,a=A,R=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const y=b.env.VSCODE_NLS_CONFIG;if(y)try{const C=JSON.parse(y),S=C.availableLanguages["*"];d=C.locale,w=C.osLocale,e=S||t.LANGUAGE_DEFAULT,M=C._translationsConfigFile}catch{}l=!0}else console.error("Unable to resolve platform.");var c;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(c||(t.Platform=c={}));function r(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=r;let u=0;i?u=1:P?u=3:o&&(u=2),t.isWindows=P,t.isMacintosh=i,t.isLinux=o,t.isLinuxSnap=p,t.isNative=l,t.isElectron=a,t.isWeb=s,t.isWebWorker=s&&typeof t.globals.importScripts=="function",t.isIOS=h,t.isMobile=f,t.isCI=R,t.platform=u,t.userAgent=N,t.language=e;var E;(function(y){function C(){return t.language}y.value=C;function S(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}y.isDefaultVariant=S;function U(){return t.language==="en"}y.isDefault=U})(E||(t.Language=E={})),t.locale=d,t.platformLocale=w,t.translationsConfigFile=M,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const y=[];t.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let U=0,H=y.length;U<H;U++){const x=y[U];if(x.id===S.data.vscodeScheduleAsyncWork){y.splice(U,1),x.callback();return}}});let C=0;return S=>{const U=++C;y.push({id:U,callback:S}),t.globals.postMessage({vscodeScheduleAsyncWork:U},"*")}}return y=>setTimeout(y)})();var m;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(m||(t.OperatingSystem=m={})),t.OS=i||h?2:P?1:3;let _=!0,v=!1;function L(){if(!v){v=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,_=new Uint16Array(y.buffer)[0]===(2<<8)+1}return _}t.isLittleEndian=L,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),re(se[58],ae([0,1,13]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let P;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const i=D.globals.vscode.process;P={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?P={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:P={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=P.cwd,t.env=P.env,t.platform=P.platform,t.arch=P.arch}),re(se[59],ae([0,1,58]),function(z,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const P=65,i=97,o=90,p=122,l=46,s=47,a=92,h=58,R=63;class f extends Error{constructor(u,E,m){let _;typeof E=="string"&&E.indexOf("not ")===0?(_="must not be",E=E.replace(/^not /,"")):_="must be";const v=u.indexOf(".")!==-1?"property":"argument";let L=`The "${u}" ${v} ${_} of type ${E}`;L+=`. Received type ${typeof m}`,super(L),this.code="ERR_INVALID_ARG_TYPE"}}function d(r,u){if(r===null||typeof r!="object")throw new f(u,"Object",r)}function e(r,u){if(typeof r!="string")throw new f(u,"string",r)}const w=D.platform==="win32";function M(r){return r===s||r===a}function N(r){return r===s}function b(r){return r>=P&&r<=o||r>=i&&r<=p}function A(r,u,E,m){let _="",v=0,L=-1,y=0,C=0;for(let S=0;S<=r.length;++S){if(S<r.length)C=r.charCodeAt(S);else{if(m(C))break;C=s}if(m(C)){if(!(L===S-1||y===1))if(y===2){if(_.length<2||v!==2||_.charCodeAt(_.length-1)!==l||_.charCodeAt(_.length-2)!==l){if(_.length>2){const U=_.lastIndexOf(E);U===-1?(_="",v=0):(_=_.slice(0,U),v=_.length-1-_.lastIndexOf(E)),L=S,y=0;continue}else if(_.length!==0){_="",v=0,L=S,y=0;continue}}u&&(_+=_.length>0?`${E}..`:"..",v=2)}else _.length>0?_+=`${E}${r.slice(L+1,S)}`:_=r.slice(L+1,S),v=S-L-1;L=S,y=0}else C===l&&y!==-1?++y:y=-1}return _}function g(r,u){d(u,"pathObject");const E=u.dir||u.root,m=u.base||`${u.name||""}${u.ext||""}`;return E?E===u.root?`${E}${m}`:`${E}${r}${m}`:m}t.win32={resolve(...r){let u="",E="",m=!1;for(let _=r.length-1;_>=-1;_--){let v;if(_>=0){if(v=r[_],e(v,"path"),v.length===0)continue}else u.length===0?v=D.cwd():(v=D.env[`=${u}`]||D.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==u.toLowerCase()&&v.charCodeAt(2)===a)&&(v=`${u}\\`));const L=v.length;let y=0,C="",S=!1;const U=v.charCodeAt(0);if(L===1)M(U)&&(y=1,S=!0);else if(M(U))if(S=!0,M(v.charCodeAt(1))){let H=2,x=H;for(;H<L&&!M(v.charCodeAt(H));)H++;if(H<L&&H!==x){const Q=v.slice(x,H);for(x=H;H<L&&M(v.charCodeAt(H));)H++;if(H<L&&H!==x){for(x=H;H<L&&!M(v.charCodeAt(H));)H++;(H===L||H!==x)&&(C=`\\\\${Q}\\${v.slice(x,H)}`,y=H)}}}else y=1;else b(U)&&v.charCodeAt(1)===h&&(C=v.slice(0,2),y=2,L>2&&M(v.charCodeAt(2))&&(S=!0,y=3));if(C.length>0)if(u.length>0){if(C.toLowerCase()!==u.toLowerCase())continue}else u=C;if(m){if(u.length>0)break}else if(E=`${v.slice(y)}\\${E}`,m=S,S&&u.length>0)break}return E=A(E,!m,"\\",M),m?`${u}\\${E}`:`${u}${E}`||"."},normalize(r){e(r,"path");const u=r.length;if(u===0)return".";let E=0,m,_=!1;const v=r.charCodeAt(0);if(u===1)return N(v)?"\\":r;if(M(v))if(_=!0,M(r.charCodeAt(1))){let y=2,C=y;for(;y<u&&!M(r.charCodeAt(y));)y++;if(y<u&&y!==C){const S=r.slice(C,y);for(C=y;y<u&&M(r.charCodeAt(y));)y++;if(y<u&&y!==C){for(C=y;y<u&&!M(r.charCodeAt(y));)y++;if(y===u)return`\\\\${S}\\${r.slice(C)}\\`;y!==C&&(m=`\\\\${S}\\${r.slice(C,y)}`,E=y)}}}else E=1;else b(v)&&r.charCodeAt(1)===h&&(m=r.slice(0,2),E=2,u>2&&M(r.charCodeAt(2))&&(_=!0,E=3));let L=E<u?A(r.slice(E),!_,"\\",M):"";return L.length===0&&!_&&(L="."),L.length>0&&M(r.charCodeAt(u-1))&&(L+="\\"),m===void 0?_?`\\${L}`:L:_?`${m}\\${L}`:`${m}${L}`},isAbsolute(r){e(r,"path");const u=r.length;if(u===0)return!1;const E=r.charCodeAt(0);return M(E)||u>2&&b(E)&&r.charCodeAt(1)===h&&M(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let u,E;for(let v=0;v<r.length;++v){const L=r[v];e(L,"path"),L.length>0&&(u===void 0?u=E=L:u+=`\\${L}`)}if(u===void 0)return".";let m=!0,_=0;if(typeof E=="string"&&M(E.charCodeAt(0))){++_;const v=E.length;v>1&&M(E.charCodeAt(1))&&(++_,v>2&&(M(E.charCodeAt(2))?++_:m=!1))}if(m){for(;_<u.length&&M(u.charCodeAt(_));)_++;_>=2&&(u=`\\${u.slice(_)}`)}return t.win32.normalize(u)},relative(r,u){if(e(r,"from"),e(u,"to"),r===u)return"";const E=t.win32.resolve(r),m=t.win32.resolve(u);if(E===m||(r=E.toLowerCase(),u=m.toLowerCase(),r===u))return"";let _=0;for(;_<r.length&&r.charCodeAt(_)===a;)_++;let v=r.length;for(;v-1>_&&r.charCodeAt(v-1)===a;)v--;const L=v-_;let y=0;for(;y<u.length&&u.charCodeAt(y)===a;)y++;let C=u.length;for(;C-1>y&&u.charCodeAt(C-1)===a;)C--;const S=C-y,U=L<S?L:S;let H=-1,x=0;for(;x<U;x++){const F=r.charCodeAt(_+x);if(F!==u.charCodeAt(y+x))break;F===a&&(H=x)}if(x!==U){if(H===-1)return m}else{if(S>U){if(u.charCodeAt(y+x)===a)return m.slice(y+x+1);if(x===2)return m.slice(y+x)}L>U&&(r.charCodeAt(_+x)===a?H=x:x===2&&(H=3)),H===-1&&(H=0)}let Q="";for(x=_+H+1;x<=v;++x)(x===v||r.charCodeAt(x)===a)&&(Q+=Q.length===0?"..":"\\..");return y+=H,Q.length>0?`${Q}${m.slice(y,C)}`:(m.charCodeAt(y)===a&&++y,m.slice(y,C))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const u=t.win32.resolve(r);if(u.length<=2)return r;if(u.charCodeAt(0)===a){if(u.charCodeAt(1)===a){const E=u.charCodeAt(2);if(E!==R&&E!==l)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(b(u.charCodeAt(0))&&u.charCodeAt(1)===h&&u.charCodeAt(2)===a)return`\\\\?\\${u}`;return r},dirname(r){e(r,"path");const u=r.length;if(u===0)return".";let E=-1,m=0;const _=r.charCodeAt(0);if(u===1)return M(_)?r:".";if(M(_)){if(E=m=1,M(r.charCodeAt(1))){let y=2,C=y;for(;y<u&&!M(r.charCodeAt(y));)y++;if(y<u&&y!==C){for(C=y;y<u&&M(r.charCodeAt(y));)y++;if(y<u&&y!==C){for(C=y;y<u&&!M(r.charCodeAt(y));)y++;if(y===u)return r;y!==C&&(E=m=y+1)}}}}else b(_)&&r.charCodeAt(1)===h&&(E=u>2&&M(r.charCodeAt(2))?3:2,m=E);let v=-1,L=!0;for(let y=u-1;y>=m;--y)if(M(r.charCodeAt(y))){if(!L){v=y;break}}else L=!1;if(v===-1){if(E===-1)return".";v=E}return r.slice(0,v)},basename(r,u){u!==void 0&&e(u,"ext"),e(r,"path");let E=0,m=-1,_=!0,v;if(r.length>=2&&b(r.charCodeAt(0))&&r.charCodeAt(1)===h&&(E=2),u!==void 0&&u.length>0&&u.length<=r.length){if(u===r)return"";let L=u.length-1,y=-1;for(v=r.length-1;v>=E;--v){const C=r.charCodeAt(v);if(M(C)){if(!_){E=v+1;break}}else y===-1&&(_=!1,y=v+1),L>=0&&(C===u.charCodeAt(L)?--L===-1&&(m=v):(L=-1,m=y))}return E===m?m=y:m===-1&&(m=r.length),r.slice(E,m)}for(v=r.length-1;v>=E;--v)if(M(r.charCodeAt(v))){if(!_){E=v+1;break}}else m===-1&&(_=!1,m=v+1);return m===-1?"":r.slice(E,m)},extname(r){e(r,"path");let u=0,E=-1,m=0,_=-1,v=!0,L=0;r.length>=2&&r.charCodeAt(1)===h&&b(r.charCodeAt(0))&&(u=m=2);for(let y=r.length-1;y>=u;--y){const C=r.charCodeAt(y);if(M(C)){if(!v){m=y+1;break}continue}_===-1&&(v=!1,_=y+1),C===l?E===-1?E=y:L!==1&&(L=1):E!==-1&&(L=-1)}return E===-1||_===-1||L===0||L===1&&E===_-1&&E===m+1?"":r.slice(E,_)},format:g.bind(null,"\\"),parse(r){e(r,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return u;const E=r.length;let m=0,_=r.charCodeAt(0);if(E===1)return M(_)?(u.root=u.dir=r,u):(u.base=u.name=r,u);if(M(_)){if(m=1,M(r.charCodeAt(1))){let H=2,x=H;for(;H<E&&!M(r.charCodeAt(H));)H++;if(H<E&&H!==x){for(x=H;H<E&&M(r.charCodeAt(H));)H++;if(H<E&&H!==x){for(x=H;H<E&&!M(r.charCodeAt(H));)H++;H===E?m=H:H!==x&&(m=H+1)}}}}else if(b(_)&&r.charCodeAt(1)===h){if(E<=2)return u.root=u.dir=r,u;if(m=2,M(r.charCodeAt(2))){if(E===3)return u.root=u.dir=r,u;m=3}}m>0&&(u.root=r.slice(0,m));let v=-1,L=m,y=-1,C=!0,S=r.length-1,U=0;for(;S>=m;--S){if(_=r.charCodeAt(S),M(_)){if(!C){L=S+1;break}continue}y===-1&&(C=!1,y=S+1),_===l?v===-1?v=S:U!==1&&(U=1):v!==-1&&(U=-1)}return y!==-1&&(v===-1||U===0||U===1&&v===y-1&&v===L+1?u.base=u.name=r.slice(L,y):(u.name=r.slice(L,v),u.base=r.slice(L,y),u.ext=r.slice(v,y))),L>0&&L!==m?u.dir=r.slice(0,L-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(w){const r=/\\/g;return()=>{const u=D.cwd().replace(r,"/");return u.slice(u.indexOf("/"))}}return()=>D.cwd()})();t.posix={resolve(...r){let u="",E=!1;for(let m=r.length-1;m>=-1&&!E;m--){const _=m>=0?r[m]:c();e(_,"path"),_.length!==0&&(u=`${_}/${u}`,E=_.charCodeAt(0)===s)}return u=A(u,!E,"/",N),E?`/${u}`:u.length>0?u:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const u=r.charCodeAt(0)===s,E=r.charCodeAt(r.length-1)===s;return r=A(r,!u,"/",N),r.length===0?u?"/":E?"./":".":(E&&(r+="/"),u?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===s},join(...r){if(r.length===0)return".";let u;for(let E=0;E<r.length;++E){const m=r[E];e(m,"path"),m.length>0&&(u===void 0?u=m:u+=`/${m}`)}return u===void 0?".":t.posix.normalize(u)},relative(r,u){if(e(r,"from"),e(u,"to"),r===u||(r=t.posix.resolve(r),u=t.posix.resolve(u),r===u))return"";const E=1,m=r.length,_=m-E,v=1,L=u.length-v,y=_<L?_:L;let C=-1,S=0;for(;S<y;S++){const H=r.charCodeAt(E+S);if(H!==u.charCodeAt(v+S))break;H===s&&(C=S)}if(S===y)if(L>y){if(u.charCodeAt(v+S)===s)return u.slice(v+S+1);if(S===0)return u.slice(v+S)}else _>y&&(r.charCodeAt(E+S)===s?C=S:S===0&&(C=0));let U="";for(S=E+C+1;S<=m;++S)(S===m||r.charCodeAt(S)===s)&&(U+=U.length===0?"..":"/..");return`${U}${u.slice(v+C)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const u=r.charCodeAt(0)===s;let E=-1,m=!0;for(let _=r.length-1;_>=1;--_)if(r.charCodeAt(_)===s){if(!m){E=_;break}}else m=!1;return E===-1?u?"/":".":u&&E===1?"//":r.slice(0,E)},basename(r,u){u!==void 0&&e(u,"ext"),e(r,"path");let E=0,m=-1,_=!0,v;if(u!==void 0&&u.length>0&&u.length<=r.length){if(u===r)return"";let L=u.length-1,y=-1;for(v=r.length-1;v>=0;--v){const C=r.charCodeAt(v);if(C===s){if(!_){E=v+1;break}}else y===-1&&(_=!1,y=v+1),L>=0&&(C===u.charCodeAt(L)?--L===-1&&(m=v):(L=-1,m=y))}return E===m?m=y:m===-1&&(m=r.length),r.slice(E,m)}for(v=r.length-1;v>=0;--v)if(r.charCodeAt(v)===s){if(!_){E=v+1;break}}else m===-1&&(_=!1,m=v+1);return m===-1?"":r.slice(E,m)},extname(r){e(r,"path");let u=-1,E=0,m=-1,_=!0,v=0;for(let L=r.length-1;L>=0;--L){const y=r.charCodeAt(L);if(y===s){if(!_){E=L+1;break}continue}m===-1&&(_=!1,m=L+1),y===l?u===-1?u=L:v!==1&&(v=1):u!==-1&&(v=-1)}return u===-1||m===-1||v===0||v===1&&u===m-1&&u===E+1?"":r.slice(u,m)},format:g.bind(null,"/"),parse(r){e(r,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return u;const E=r.charCodeAt(0)===s;let m;E?(u.root="/",m=1):m=0;let _=-1,v=0,L=-1,y=!0,C=r.length-1,S=0;for(;C>=m;--C){const U=r.charCodeAt(C);if(U===s){if(!y){v=C+1;break}continue}L===-1&&(y=!1,L=C+1),U===l?_===-1?_=C:S!==1&&(S=1):_!==-1&&(S=-1)}if(L!==-1){const U=v===0&&E?1:v;_===-1||S===0||S===1&&_===L-1&&_===v+1?u.base=u.name=r.slice(U,L):(u.name=r.slice(U,_),u.base=r.slice(U,L),u.ext=r.slice(_,L))}return v>0?u.dir=r.slice(0,v-1):E&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=w?t.win32.normalize:t.posix.normalize,t.isAbsolute=w?t.win32.isAbsolute:t.posix.isAbsolute,t.join=w?t.win32.join:t.posix.join,t.resolve=w?t.win32.resolve:t.posix.resolve,t.relative=w?t.win32.relative:t.posix.relative,t.dirname=w?t.win32.dirname:t.posix.dirname,t.basename=w?t.win32.basename:t.posix.basename,t.extname=w?t.win32.extname:t.posix.extname,t.format=w?t.win32.format:t.posix.format,t.parse=w?t.win32.parse:t.posix.parse,t.toNamespacedPath=w?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=w?t.win32.sep:t.posix.sep,t.delimiter=w?t.win32.delimiter:t.posix.delimiter}),re(se[14],ae([0,1,59,13]),function(z,t,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.isUriComponents=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,o=/^\//,p=/^\/\//;function l(m,_){if(!m.scheme&&_)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!i.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!o.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function s(m,_){return!m&&!_?"file":m}function a(m,_){switch(m){case"https":case"http":case"file":_?_[0]!==R&&(_=R+_):_=R;break}return _}const h="",R="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(_){return _ instanceof d?!0:_?typeof _.authority=="string"&&typeof _.fragment=="string"&&typeof _.path=="string"&&typeof _.query=="string"&&typeof _.scheme=="string"&&typeof _.fsPath=="string"&&typeof _.with=="function"&&typeof _.toString=="function":!1}constructor(_,v,L,y,C,S=!1){typeof _=="object"?(this.scheme=_.scheme||h,this.authority=_.authority||h,this.path=_.path||h,this.query=_.query||h,this.fragment=_.fragment||h):(this.scheme=s(_,S),this.authority=v||h,this.path=a(this.scheme,L||h),this.query=y||h,this.fragment=C||h,l(this,S))}get fsPath(){return g(this,!1)}with(_){if(!_)return this;let{scheme:v,authority:L,path:y,query:C,fragment:S}=_;return v===void 0?v=this.scheme:v===null&&(v=h),L===void 0?L=this.authority:L===null&&(L=h),y===void 0?y=this.path:y===null&&(y=h),C===void 0?C=this.query:C===null&&(C=h),S===void 0?S=this.fragment:S===null&&(S=h),v===this.scheme&&L===this.authority&&y===this.path&&C===this.query&&S===this.fragment?this:new M(v,L,y,C,S)}static parse(_,v=!1){const L=f.exec(_);return L?new M(L[2]||h,E(L[4]||h),E(L[5]||h),E(L[7]||h),E(L[9]||h),v):new M(h,h,h,h,h)}static file(_){let v=h;if(P.isWindows&&(_=_.replace(/\\/g,R)),_[0]===R&&_[1]===R){const L=_.indexOf(R,2);L===-1?(v=_.substring(2),_=R):(v=_.substring(2,L),_=_.substring(L)||R)}return new M("file",v,_,h,h)}static from(_,v){return new M(_.scheme,_.authority,_.path,_.query,_.fragment,v)}static joinPath(_,...v){if(!_.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let L;return P.isWindows&&_.scheme==="file"?L=d.file(D.win32.join(g(_,!0),...v)).path:L=D.posix.join(_.path,...v),_.with({path:L})}toString(_=!1){return c(this,_)}toJSON(){return this}static revive(_){if(_){if(_ instanceof d)return _;{const v=new M(_);return v._formatted=_.external??null,v._fsPath=_._sep===w?_.fsPath??null:null,v}}else return _}}t.URI=d;function e(m){return!m||typeof m!="object"?!1:typeof m.scheme=="string"&&(typeof m.authority=="string"||typeof m.authority>"u")&&(typeof m.path=="string"||typeof m.path>"u")&&(typeof m.query=="string"||typeof m.query>"u")&&(typeof m.fragment=="string"||typeof m.fragment>"u")}t.isUriComponents=e;const w=P.isWindows?1:void 0;class M extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(_=!1){return _?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const _={$mid:1};return this._fsPath&&(_.fsPath=this._fsPath,_._sep=w),this._formatted&&(_.external=this._formatted),this.path&&(_.path=this.path),this.scheme&&(_.scheme=this.scheme),this.authority&&(_.authority=this.authority),this.query&&(_.query=this.query),this.fragment&&(_.fragment=this.fragment),_}}const N={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(m,_,v){let L,y=-1;for(let C=0;C<m.length;C++){const S=m.charCodeAt(C);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||_&&S===47||v&&S===91||v&&S===93||v&&S===58)y!==-1&&(L+=encodeURIComponent(m.substring(y,C)),y=-1),L!==void 0&&(L+=m.charAt(C));else{L===void 0&&(L=m.substr(0,C));const U=N[S];U!==void 0?(y!==-1&&(L+=encodeURIComponent(m.substring(y,C)),y=-1),L+=U):y===-1&&(y=C)}}return y!==-1&&(L+=encodeURIComponent(m.substring(y))),L!==void 0?L:m}function A(m){let _;for(let v=0;v<m.length;v++){const L=m.charCodeAt(v);L===35||L===63?(_===void 0&&(_=m.substr(0,v)),_+=N[L]):_!==void 0&&(_+=m[v])}return _!==void 0?_:m}function g(m,_){let v;return m.authority&&m.path.length>1&&m.scheme==="file"?v=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===47&&(m.path.charCodeAt(1)>=65&&m.path.charCodeAt(1)<=90||m.path.charCodeAt(1)>=97&&m.path.charCodeAt(1)<=122)&&m.path.charCodeAt(2)===58?_?v=m.path.substr(1):v=m.path[1].toLowerCase()+m.path.substr(2):v=m.path,P.isWindows&&(v=v.replace(/\//g,"\\")),v}t.uriToFsPath=g;function c(m,_){const v=_?A:b;let L="",{scheme:y,authority:C,path:S,query:U,fragment:H}=m;if(y&&(L+=y,L+=":"),(C||y==="file")&&(L+=R,L+=R),C){let x=C.indexOf("@");if(x!==-1){const Q=C.substr(0,x);C=C.substr(x+1),x=Q.lastIndexOf(":"),x===-1?L+=v(Q,!1,!1):(L+=v(Q.substr(0,x),!1,!1),L+=":",L+=v(Q.substr(x+1),!1,!0)),L+="@"}C=C.toLowerCase(),x=C.lastIndexOf(":"),x===-1?L+=v(C,!1,!0):(L+=v(C.substr(0,x),!1,!0),L+=C.substr(x))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const x=S.charCodeAt(1);x>=65&&x<=90&&(S=`/${String.fromCharCode(x+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const x=S.charCodeAt(0);x>=65&&x<=90&&(S=`${String.fromCharCode(x+32)}:${S.substr(2)}`)}L+=v(S,!0,!1)}return U&&(L+="?",L+=v(U,!1,!1)),H&&(L+="#",L+=_?H:b(H,!1,!1)),L}function r(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+r(m.substr(3)):m}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(m){return m.match(u)?m.replace(u,_=>r(_)):m}}),re(se[64],ae([0,1,3,8,7,11,13,5]),function(z,t,D,P,i,o,p,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const s="$initialize";let a=!1;function h(E){p.isWeb&&(a||(a=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(E.message))}t.logOnceWebWorkerWarning=h;var R;(function(E){E[E.Request=0]="Request",E[E.Reply=1]="Reply",E[E.SubscribeEvent=2]="SubscribeEvent",E[E.Event=3]="Event",E[E.UnsubscribeEvent=4]="UnsubscribeEvent"})(R||(R={}));class f{constructor(m,_,v,L){this.vsWorker=m,this.req=_,this.method=v,this.args=L,this.type=0}}class d{constructor(m,_,v,L){this.vsWorker=m,this.seq=_,this.res=v,this.err=L,this.type=1}}class e{constructor(m,_,v,L){this.vsWorker=m,this.req=_,this.eventName=v,this.arg=L,this.type=2}}class w{constructor(m,_,v){this.vsWorker=m,this.req=_,this.event=v,this.type=3}}class M{constructor(m,_){this.vsWorker=m,this.req=_,this.type=4}}class N{constructor(m){this._workerId=-1,this._handler=m,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(m){this._workerId=m}sendMessage(m,_){const v=String(++this._lastSentReq);return new Promise((L,y)=>{this._pendingReplies[v]={resolve:L,reject:y},this._send(new f(this._workerId,v,m,_))})}listen(m,_){let v=null;const L=new P.Emitter({onWillAddFirstListener:()=>{v=String(++this._lastSentReq),this._pendingEmitters.set(v,L),this._send(new e(this._workerId,v,m,_))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(v),this._send(new M(this._workerId,v)),v=null}});return L.event}handleMessage(m){!m||!m.vsWorker||this._workerId!==-1&&m.vsWorker!==this._workerId||this._handleMessage(m)}_handleMessage(m){switch(m.type){case 1:return this._handleReplyMessage(m);case 0:return this._handleRequestMessage(m);case 2:return this._handleSubscribeEventMessage(m);case 3:return this._handleEventMessage(m);case 4:return this._handleUnsubscribeEventMessage(m)}}_handleReplyMessage(m){if(!this._pendingReplies[m.seq]){console.warn("Got reply to unknown seq");return}const _=this._pendingReplies[m.seq];if(delete this._pendingReplies[m.seq],m.err){let v=m.err;m.err.$isError&&(v=new Error,v.name=m.err.name,v.message=m.err.message,v.stack=m.err.stack),_.reject(v);return}_.resolve(m.res)}_handleRequestMessage(m){const _=m.req;this._handler.handleMessage(m.method,m.args).then(L=>{this._send(new d(this._workerId,_,L,void 0))},L=>{L.detail instanceof Error&&(L.detail=(0,D.transformErrorForSerialization)(L.detail)),this._send(new d(this._workerId,_,void 0,(0,D.transformErrorForSerialization)(L)))})}_handleSubscribeEventMessage(m){const _=m.req,v=this._handler.handleEvent(m.eventName,m.arg)(L=>{this._send(new w(this._workerId,_,L))});this._pendingEvents.set(_,v)}_handleEventMessage(m){if(!this._pendingEmitters.has(m.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(m.req).fire(m.event)}_handleUnsubscribeEventMessage(m){if(!this._pendingEvents.has(m.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(m.req).dispose(),this._pendingEvents.delete(m.req)}_send(m){const _=[];if(m.type===0)for(let v=0;v<m.args.length;v++)m.args[v]instanceof ArrayBuffer&&_.push(m.args[v]);else m.type===1&&m.res instanceof ArrayBuffer&&_.push(m.res);this._handler.sendMessage(m,_)}}class b extends i.Disposable{constructor(m,_,v){super();let L=null;this._worker=this._register(m.create("vs/base/common/worker/simpleWorker",x=>{this._protocol.handleMessage(x)},x=>{L?.(x)})),this._protocol=new N({sendMessage:(x,Q)=>{this._worker.postMessage(x,Q)},handleMessage:(x,Q)=>{if(typeof v[x]!="function")return Promise.reject(new Error("Missing method "+x+" on main thread host."));try{return Promise.resolve(v[x].apply(v,Q))}catch(F){return Promise.reject(F)}},handleEvent:(x,Q)=>{if(g(x)){const F=v[x].call(v,Q);if(typeof F!="function")throw new Error(`Missing dynamic event ${x} on main thread host.`);return F}if(A(x)){const F=v[x];if(typeof F!="function")throw new Error(`Missing event ${x} on main thread host.`);return F}throw new Error(`Malformed event name ${x}`)}}),this._protocol.setWorkerId(this._worker.getId());let y=null;const C=globalThis.require;typeof C<"u"&&typeof C.getConfig=="function"?y=C.getConfig():typeof globalThis.requirejs<"u"&&(y=globalThis.requirejs.s.contexts._.config);const S=(0,o.getAllMethodNames)(v);this._onModuleLoaded=this._protocol.sendMessage(s,[this._worker.getId(),JSON.parse(JSON.stringify(y)),_,S]);const U=(x,Q)=>this._request(x,Q),H=(x,Q)=>this._protocol.listen(x,Q);this._lazyProxy=new Promise((x,Q)=>{L=Q,this._onModuleLoaded.then(F=>{x(c(F,U,H))},F=>{Q(F),this._onError("Worker failed to load "+_,F)})})}getProxyObject(){return this._lazyProxy}_request(m,_){return new Promise((v,L)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(m,_).then(v,L)},L)})}_onError(m,_){console.error(m),console.info(_)}}t.SimpleWorkerClient=b;function A(E){return E[0]==="o"&&E[1]==="n"&&l.isUpperAsciiLetter(E.charCodeAt(2))}function g(E){return/^onDynamic/.test(E)&&l.isUpperAsciiLetter(E.charCodeAt(9))}function c(E,m,_){const v=C=>function(){const S=Array.prototype.slice.call(arguments,0);return m(C,S)},L=C=>function(S){return _(C,S)},y={};for(const C of E){if(g(C)){y[C]=L(C);continue}if(A(C)){y[C]=_(C,void 0);continue}y[C]=v(C)}return y}class r{constructor(m,_){this._requestHandlerFactory=_,this._requestHandler=null,this._protocol=new N({sendMessage:(v,L)=>{m(v,L)},handleMessage:(v,L)=>this._handleMessage(v,L),handleEvent:(v,L)=>this._handleEvent(v,L)})}onmessage(m){this._protocol.handleMessage(m)}_handleMessage(m,_){if(m===s)return this.initialize(_[0],_[1],_[2],_[3]);if(!this._requestHandler||typeof this._requestHandler[m]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+m));try{return Promise.resolve(this._requestHandler[m].apply(this._requestHandler,_))}catch(v){return Promise.reject(v)}}_handleEvent(m,_){if(!this._requestHandler)throw new Error("Missing requestHandler");if(g(m)){const v=this._requestHandler[m].call(this._requestHandler,_);if(typeof v!="function")throw new Error(`Missing dynamic event ${m} on request handler.`);return v}if(A(m)){const v=this._requestHandler[m];if(typeof v!="function")throw new Error(`Missing event ${m} on request handler.`);return v}throw new Error(`Malformed event name ${m}`)}initialize(m,_,v,L){this._protocol.setWorkerId(m);const S=c(L,(U,H)=>this._protocol.sendMessage(U,H),(U,H)=>this._protocol.listen(U,H));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(S),Promise.resolve((0,o.getAllMethodNames)(this._requestHandler))):(_&&(typeof _.baseUrl<"u"&&delete _.baseUrl,typeof _.paths<"u"&&typeof _.paths.vs<"u"&&delete _.paths.vs,typeof _.trustedTypesPolicy!==void 0&&delete _.trustedTypesPolicy,_.catchError=!0,globalThis.require.config(_)),new Promise((U,H)=>{(globalThis.require||z)([v],Q=>{if(this._requestHandler=Q.create(S),!this._requestHandler){H(new Error("No RequestHandler!"));return}U((0,o.getAllMethodNames)(this._requestHandler))},H)}))}}t.SimpleWorkerServer=r;function u(E){return new r(E,null)}t.create=u}),re(se[60],ae([56,57]),function(z,t){return z.create("vs/editor/common/languages",t)}),re(se[61],ae([0,1,35,14,36,2,54,60]),function(z,t,D,P,i,o,p,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.TextEdit=t.SymbolKinds=t.SymbolTag=t.getAriaLabelForSymbol=t.symbolKindNames=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.SelectedSuggestionInfo=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class s{constructor(j,Z,Y){this.offset=j,this.type=Z,this.language=Y,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=s;class a{constructor(j,Z){this.tokens=j,this.endState=Z,this._tokenizationResultBrand=void 0}}t.TokenizationResult=a;class h{constructor(j,Z){this.tokens=j,this.endState=Z,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=h;var R;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(R||(t.CompletionItemKind=R={}));var f;(function(F){const j=new Map;j.set(0,D.Codicon.symbolMethod),j.set(1,D.Codicon.symbolFunction),j.set(2,D.Codicon.symbolConstructor),j.set(3,D.Codicon.symbolField),j.set(4,D.Codicon.symbolVariable),j.set(5,D.Codicon.symbolClass),j.set(6,D.Codicon.symbolStruct),j.set(7,D.Codicon.symbolInterface),j.set(8,D.Codicon.symbolModule),j.set(9,D.Codicon.symbolProperty),j.set(10,D.Codicon.symbolEvent),j.set(11,D.Codicon.symbolOperator),j.set(12,D.Codicon.symbolUnit),j.set(13,D.Codicon.symbolValue),j.set(15,D.Codicon.symbolEnum),j.set(14,D.Codicon.symbolConstant),j.set(15,D.Codicon.symbolEnum),j.set(16,D.Codicon.symbolEnumMember),j.set(17,D.Codicon.symbolKeyword),j.set(27,D.Codicon.symbolSnippet),j.set(18,D.Codicon.symbolText),j.set(19,D.Codicon.symbolColor),j.set(20,D.Codicon.symbolFile),j.set(21,D.Codicon.symbolReference),j.set(22,D.Codicon.symbolCustomColor),j.set(23,D.Codicon.symbolFolder),j.set(24,D.Codicon.symbolTypeParameter),j.set(25,D.Codicon.account),j.set(26,D.Codicon.issues);function Z(n){let W=j.get(n);return W||(console.info("No codicon found for CompletionItemKind "+n),W=D.Codicon.symbolProperty),W}F.toIcon=Z;const Y=new Map;Y.set("method",0),Y.set("function",1),Y.set("constructor",2),Y.set("field",3),Y.set("variable",4),Y.set("class",5),Y.set("struct",6),Y.set("interface",7),Y.set("module",8),Y.set("property",9),Y.set("event",10),Y.set("operator",11),Y.set("unit",12),Y.set("value",13),Y.set("constant",14),Y.set("enum",15),Y.set("enum-member",16),Y.set("enumMember",16),Y.set("keyword",17),Y.set("snippet",27),Y.set("text",18),Y.set("color",19),Y.set("file",20),Y.set("reference",21),Y.set("customcolor",22),Y.set("folder",23),Y.set("type-parameter",24),Y.set("typeParameter",24),Y.set("account",25),Y.set("issue",26);function ge(n,W){let $=Y.get(n);return typeof $>"u"&&!W&&($=9),$}F.fromString=ge})(f||(t.CompletionItemKinds=f={}));var d;(function(F){F[F.Deprecated=1]="Deprecated"})(d||(t.CompletionItemTag=d={}));var e;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var w;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(t.CompletionTriggerKind=w={}));var M;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(M||(t.InlineCompletionTriggerKind=M={}));class N{constructor(j,Z,Y,ge){this.range=j,this.text=Z,this.completionKind=Y,this.isSnippetText=ge}equals(j){return o.Range.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}t.SelectedSuggestionInfo=N;var b;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(b||(t.CodeActionTriggerType=b={}));var A;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(A||(t.SignatureHelpTriggerKind=A={}));var g;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(g||(t.DocumentHighlightKind=g={}));function c(F){return F&&P.URI.isUri(F.uri)&&o.Range.isIRange(F.range)&&(o.Range.isIRange(F.originSelectionRange)||o.Range.isIRange(F.targetSelectionRange))}t.isLocationLink=c;var r;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(r||(t.SymbolKind=r={})),t.symbolKindNames={[17]:(0,l.localize)(0,null),[16]:(0,l.localize)(1,null),[4]:(0,l.localize)(2,null),[13]:(0,l.localize)(3,null),[8]:(0,l.localize)(4,null),[9]:(0,l.localize)(5,null),[21]:(0,l.localize)(6,null),[23]:(0,l.localize)(7,null),[7]:(0,l.localize)(8,null),[0]:(0,l.localize)(9,null),[11]:(0,l.localize)(10,null),[10]:(0,l.localize)(11,null),[19]:(0,l.localize)(12,null),[5]:(0,l.localize)(13,null),[1]:(0,l.localize)(14,null),[2]:(0,l.localize)(15,null),[20]:(0,l.localize)(16,null),[15]:(0,l.localize)(17,null),[18]:(0,l.localize)(18,null),[24]:(0,l.localize)(19,null),[3]:(0,l.localize)(20,null),[6]:(0,l.localize)(21,null),[14]:(0,l.localize)(22,null),[22]:(0,l.localize)(23,null),[25]:(0,l.localize)(24,null),[12]:(0,l.localize)(25,null)};function u(F,j){return(0,l.localize)(26,null,F,t.symbolKindNames[j])}t.getAriaLabelForSymbol=u;var E;(function(F){F[F.Deprecated=1]="Deprecated"})(E||(t.SymbolTag=E={}));var m;(function(F){const j=new Map;j.set(0,D.Codicon.symbolFile),j.set(1,D.Codicon.symbolModule),j.set(2,D.Codicon.symbolNamespace),j.set(3,D.Codicon.symbolPackage),j.set(4,D.Codicon.symbolClass),j.set(5,D.Codicon.symbolMethod),j.set(6,D.Codicon.symbolProperty),j.set(7,D.Codicon.symbolField),j.set(8,D.Codicon.symbolConstructor),j.set(9,D.Codicon.symbolEnum),j.set(10,D.Codicon.symbolInterface),j.set(11,D.Codicon.symbolFunction),j.set(12,D.Codicon.symbolVariable),j.set(13,D.Codicon.symbolConstant),j.set(14,D.Codicon.symbolString),j.set(15,D.Codicon.symbolNumber),j.set(16,D.Codicon.symbolBoolean),j.set(17,D.Codicon.symbolArray),j.set(18,D.Codicon.symbolObject),j.set(19,D.Codicon.symbolKey),j.set(20,D.Codicon.symbolNull),j.set(21,D.Codicon.symbolEnumMember),j.set(22,D.Codicon.symbolStruct),j.set(23,D.Codicon.symbolEvent),j.set(24,D.Codicon.symbolOperator),j.set(25,D.Codicon.symbolTypeParameter);function Z(Y){let ge=j.get(Y);return ge||(console.info("No codicon found for SymbolKind "+Y),ge=D.Codicon.symbolProperty),ge}F.toIcon=Z})(m||(t.SymbolKinds=m={}));class _{static asEditOperation(j){return i.EditOperation.replace(o.Range.lift(j.range),j.text)}}t.TextEdit=_;class v{static{this.Comment=new v("comment")}static{this.Imports=new v("imports")}static{this.Region=new v("region")}static fromValue(j){switch(j){case"comment":return v.Comment;case"imports":return v.Imports;case"region":return v.Region}return new v(j)}constructor(j){this.value=j}}t.FoldingRangeKind=v;var L;(function(F){function j(Z){return!Z||typeof Z!="object"?!1:typeof Z.id=="string"&&typeof Z.title=="string"}F.is=j})(L||(t.Command=L={}));var y;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(y||(t.CommentThreadCollapsibleState=y={}));var C;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(C||(t.CommentThreadState=C={}));var S;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(S||(t.CommentMode=S={}));var U;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(U||(t.CommentState=U={}));var H;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(H||(t.InlayHintKind=H={}));class x{constructor(j){this.createSupport=j,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}t.LazyTokenizationSupport=x,t.TokenizationRegistry=new p.TokenizationRegistry;var Q;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(Q||(t.ExternalUriOpenerPriority=Q={}))}),re(se[62],ae([0,1,20,8,31,14,4,2,37,61,53]),function(z,t,D,P,i,o,p,l,s,a,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class R{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,w){return(0,i.KeyChord)(e,w)}}t.KeyMod=R;function f(){return{editor:void 0,languages:void 0,CancellationTokenSource:D.CancellationTokenSource,Emitter:P.Emitter,KeyCode:h.KeyCode,KeyMod:R,Position:p.Position,Range:l.Range,Selection:s.Selection,SelectionDirection:h.SelectionDirection,MarkerSeverity:h.MarkerSeverity,MarkerTag:h.MarkerTag,Uri:o.URI,Token:a.Token}}t.createMonacoBaseAPI=f}),re(se[65],ae([0,1,21,14,4,2,50,25,46,47,62,19,52,27,44,11,3,45]),function(z,t,D,P,i,o,p,l,s,a,h,R,f,d,e,w,M,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class b extends p.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(r){const u=[];for(let E=0;E<this._lines.length;E++){const m=this._lines[E],_=this.offsetAt(new i.Position(E+1,1)),v=m.matchAll(r);for(const L of v)(L.index||L.index===0)&&(L.index=L.index+_),u.push(L)}return u}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(r){return this._lines[r-1]}getWordAtPosition(r,u){const E=(0,l.getWordAtText)(r.column,(0,l.ensureValidWordDefinition)(u),this._lines[r.lineNumber-1],0);return E?new o.Range(r.lineNumber,E.startColumn,r.lineNumber,E.endColumn):null}getWordUntilPosition(r,u){const E=this.getWordAtPosition(r,u);return E?{word:this._lines[r.lineNumber-1].substring(E.startColumn-1,r.column-1),startColumn:E.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const u=this._lines,E=this._wordenize.bind(this);let m=0,_="",v=0,L=[];return{*[Symbol.iterator](){for(;;)if(v<L.length){const y=_.substring(L[v].start,L[v].end);v+=1,yield y}else if(m<u.length)_=u[m],L=E(_,r),v=0,m+=1;else break}}}getLineWords(r,u){const E=this._lines[r-1],m=this._wordenize(E,u),_=[];for(const v of m)_.push({word:E.substring(v.start,v.end),startColumn:v.start+1,endColumn:v.end+1});return _}_wordenize(r,u){const E=[];let m;for(u.lastIndex=0;(m=u.exec(r))&&m[0].length!==0;)E.push({start:m.index,end:m.index+m[0].length});return E}getValueInRange(r){if(r=this._validateRange(r),r.startLineNumber===r.endLineNumber)return this._lines[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const u=this._eol,E=r.startLineNumber-1,m=r.endLineNumber-1,_=[];_.push(this._lines[E].substring(r.startColumn-1));for(let v=E+1;v<m;v++)_.push(this._lines[v]);return _.push(this._lines[m].substring(0,r.endColumn-1)),_.join(u)}offsetAt(r){return r=this._validatePosition(r),this._ensureLineStarts(),this._lineStarts.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this._ensureLineStarts();const u=this._lineStarts.getIndexOf(r),E=this._lines[u.index].length;return{lineNumber:1+u.index,column:1+Math.min(u.remainder,E)}}_validateRange(r){const u=this._validatePosition({lineNumber:r.startLineNumber,column:r.startColumn}),E=this._validatePosition({lineNumber:r.endLineNumber,column:r.endColumn});return u.lineNumber!==r.startLineNumber||u.column!==r.startColumn||E.lineNumber!==r.endLineNumber||E.column!==r.endColumn?{startLineNumber:u.lineNumber,startColumn:u.column,endLineNumber:E.lineNumber,endColumn:E.column}:r}_validatePosition(r){if(!i.Position.isIPosition(r))throw new Error("bad position");let{lineNumber:u,column:E}=r,m=!1;if(u<1)u=1,E=1,m=!0;else if(u>this._lines.length)u=this._lines.length,E=this._lines[u-1].length+1,m=!0;else{const _=this._lines[u-1].length+1;E<1?(E=1,m=!0):E>_&&(E=_,m=!0)}return m?{lineNumber:u,column:E}:r}}class A{constructor(r,u){this._host=r,this._models=Object.create(null),this._foreignModuleFactory=u,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(r){return this._models[r]}_getModels(){const r=[];return Object.keys(this._models).forEach(u=>r.push(this._models[u])),r}acceptNewModel(r){this._models[r.url]=new b(P.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,u){if(!this._models[r])return;this._models[r].onEvents(u)}acceptRemovedModel(r){this._models[r]&&delete this._models[r]}async computeUnicodeHighlights(r,u,E){const m=this._getModel(r);return m?f.UnicodeTextModelHighlighter.computeUnicodeHighlights(m,u,E):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(r,u,E,m){const _=this._getModel(r),v=this._getModel(u);return!_||!v?null:A.computeDiff(_,v,E,m)}static computeDiff(r,u,E,m){const _=m==="advanced"?e.linesDiffComputers.getAdvanced():e.linesDiffComputers.getLegacy(),v=r.getLinesContent(),L=u.getLinesContent(),y=_.computeDiff(v,L,E),C=y.changes.length>0?!1:this._modelsAreIdentical(r,u);function S(U){return U.map(H=>[H.originalRange.startLineNumber,H.originalRange.endLineNumberExclusive,H.modifiedRange.startLineNumber,H.modifiedRange.endLineNumberExclusive,H.innerChanges?.map(x=>[x.originalRange.startLineNumber,x.originalRange.startColumn,x.originalRange.endLineNumber,x.originalRange.endColumn,x.modifiedRange.startLineNumber,x.modifiedRange.startColumn,x.modifiedRange.endLineNumber,x.modifiedRange.endColumn])])}return{identical:C,quitEarly:y.hitTimeout,changes:S(y.changes),moves:y.moves.map(U=>[U.lineRangeMapping.original.startLineNumber,U.lineRangeMapping.original.endLineNumberExclusive,U.lineRangeMapping.modified.startLineNumber,U.lineRangeMapping.modified.endLineNumberExclusive,S(U.changes)])}}static _modelsAreIdentical(r,u){const E=r.getLineCount(),m=u.getLineCount();if(E!==m)return!1;for(let _=1;_<=E;_++){const v=r.getLineContent(_),L=u.getLineContent(_);if(v!==L)return!1}return!0}async computeDirtyDiff(r,u,E){const m=this._getModel(r),_=this._getModel(u);if(!m||!_)return null;const v=m.getLinesContent(),L=_.getLinesContent();return new d.DiffComputer(v,L,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:E,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this._diffLimit=1e5}async computeMoreMinimalEdits(r,u,E){const m=this._getModel(r);if(!m)return u;const _=[];let v;u=u.slice(0).sort((L,y)=>{if(L.range&&y.range)return o.Range.compareRangesUsingStarts(L.range,y.range);const C=L.range?0:1,S=y.range?0:1;return C-S});for(let{range:L,text:y,eol:C}of u){if(typeof C=="number"&&(v=C),o.Range.isEmpty(L)&&!y)continue;const S=m.getValueInRange(L);if(y=y.replace(/\r\n|\n|\r/g,m.eol),S===y)continue;if(Math.max(y.length,S.length)>A._diffLimit){_.push({range:L,text:y});continue}const U=(0,D.stringDiff)(S,y,E),H=m.offsetAt(o.Range.lift(L).getStartPosition());for(const x of U){const Q=m.positionAt(H+x.originalStart),F=m.positionAt(H+x.originalStart+x.originalLength),j={text:y.substr(x.modifiedStart,x.modifiedLength),range:{startLineNumber:Q.lineNumber,startColumn:Q.column,endLineNumber:F.lineNumber,endColumn:F.column}};m.getValueInRange(j.range)!==j.text&&_.push(j)}}return typeof v=="number"&&_.push({eol:v,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),_}async computeHumanReadableDiff(r,u,E){const m=this._getModel(r);if(!m)return u;const _=[];let v;u=u.slice(0).sort((L,y)=>{if(L.range&&y.range)return o.Range.compareRangesUsingStarts(L.range,y.range);const C=L.range?0:1,S=y.range?0:1;return C-S});for(let{range:L,text:y,eol:C}of u){let F=function(Z,Y){return new i.Position(Z.lineNumber+Y.lineNumber-1,Y.lineNumber===1?Z.column+Y.column-1:Y.column)},j=function(Z,Y){const ge=[];for(let n=Y.startLineNumber;n<=Y.endLineNumber;n++){const W=Z[n-1];n===Y.startLineNumber&&n===Y.endLineNumber?ge.push(W.substring(Y.startColumn-1,Y.endColumn-1)):n===Y.startLineNumber?ge.push(W.substring(Y.startColumn-1)):n===Y.endLineNumber?ge.push(W.substring(0,Y.endColumn-1)):ge.push(W)}return ge};if(typeof C=="number"&&(v=C),o.Range.isEmpty(L)&&!y)continue;const S=m.getValueInRange(L);if(y=y.replace(/\r\n|\n|\r/g,m.eol),S===y)continue;if(Math.max(y.length,S.length)>A._diffLimit){_.push({range:L,text:y});continue}const U=S.split(/\r\n|\n|\r/),H=y.split(/\r\n|\n|\r/),x=e.linesDiffComputers.getAdvanced().computeDiff(U,H,E),Q=o.Range.lift(L).getStartPosition();for(const Z of x.changes)if(Z.innerChanges)for(const Y of Z.innerChanges)_.push({range:o.Range.fromPositions(F(Q,Y.originalRange.getStartPosition()),F(Q,Y.originalRange.getEndPosition())),text:j(H,Y.modifiedRange).join(m.eol)});else throw new M.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof v=="number"&&_.push({eol:v,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),_}async computeLinks(r){const u=this._getModel(r);return u?(0,s.computeLinks)(u):null}async computeDefaultDocumentColors(r){const u=this._getModel(r);return u?(0,N.computeDefaultDocumentColors)(u):null}static{this._suggestionsLimit=1e4}async textualSuggest(r,u,E,m){const _=new R.StopWatch,v=new RegExp(E,m),L=new Set;e:for(const y of r){const C=this._getModel(y);if(C){for(const S of C.words(v))if(!(S===u||!isNaN(Number(S)))&&(L.add(S),L.size>A._suggestionsLimit))break e}}return{words:Array.from(L),duration:_.elapsed()}}async computeWordRanges(r,u,E,m){const _=this._getModel(r);if(!_)return Object.create(null);const v=new RegExp(E,m),L=Object.create(null);for(let y=u.startLineNumber;y<u.endLineNumber;y++){const C=_.getLineWords(y,v);for(const S of C){if(!isNaN(Number(S.word)))continue;let U=L[S.word];U||(U=[],L[S.word]=U),U.push({startLineNumber:y,startColumn:S.startColumn,endLineNumber:y,endColumn:S.endColumn})}}return L}async navigateValueSet(r,u,E,m,_){const v=this._getModel(r);if(!v)return null;const L=new RegExp(m,_);u.startColumn===u.endColumn&&(u={startLineNumber:u.startLineNumber,startColumn:u.startColumn,endLineNumber:u.endLineNumber,endColumn:u.endColumn+1});const y=v.getValueInRange(u),C=v.getWordAtPosition({lineNumber:u.startLineNumber,column:u.startColumn},L);if(!C)return null;const S=v.getValueInRange(C);return a.BasicInplaceReplace.INSTANCE.navigateValueSet(u,y,C,S,E)}loadForeignModule(r,u,E){const m=(L,y)=>this._host.fhr(L,y),v={host:(0,w.createProxyObject)(E,m),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(v,u),Promise.resolve((0,w.getAllMethodNames)(this._foreignModule))):new Promise((L,y)=>{z([r],C=>{this._foreignModule=C.create(v,u),L((0,w.getAllMethodNames)(this._foreignModule))},y)})}fmr(r,u){if(!this._foreignModule||typeof this._foreignModule[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this._foreignModule[r].apply(this._foreignModule,u))}catch(E){return Promise.reject(E)}}}t.EditorSimpleWorker=A;function g(c){return new A(c,null)}t.create=g,typeof importScripts=="function"&&(globalThis.monaco=(0,h.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a5004432af6600c99fa4f918a3f2f8df44df71e6/core/vs/base/worker/workerMain.js.map
