/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/node/state","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/stream","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/lazy","vs/base/common/normalization","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/code/electron-main/auth","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],te=function(H){for(var e=[],E=0,A=H.length;E<A;E++)e[E]=ee[H[E]];return e};define(ee[134],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(P,h){const d=Math.pow(10,h);return Math.round(P*d)/d}class A{constructor(h,d,m,g=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,d))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=E(Math.max(Math.min(1,g),0),3)}static equals(h,d){return h.r===d.r&&h.g===d.g&&h.b===d.b&&h.a===d.a}}e.RGBA=A;class n{constructor(h,d,m,g){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=E(Math.max(Math.min(1,d),0),3),this.l=E(Math.max(Math.min(1,m),0),3),this.a=E(Math.max(Math.min(1,g),0),3)}static equals(h,d){return h.h===d.h&&h.s===d.s&&h.l===d.l&&h.a===d.a}static fromRGBA(h){const d=h.r/255,m=h.g/255,g=h.b/255,S=h.a,u=Math.max(d,m,g),y=Math.min(d,m,g);let b=0,c=0;const f=(y+u)/2,l=u-y;if(l>0){switch(c=Math.min(f<=.5?l/(2*f):l/(2-2*f),1),u){case d:b=(m-g)/l+(m<g?6:0);break;case m:b=(g-d)/l+2;break;case g:b=(d-m)/l+4;break}b*=60,b=Math.round(b)}return new n(b,c,f,S)}static _hue2rgb(h,d,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?h+(d-h)*6*m:m<1/2?d:m<2/3?h+(d-h)*(2/3-m)*6:h}static toRGBA(h){const d=h.h/360,{s:m,l:g,a:S}=h;let u,y,b;if(m===0)u=y=b=g;else{const c=g<.5?g*(1+m):g+m-g*m,f=2*g-c;u=n._hue2rgb(f,c,d+1/3),y=n._hue2rgb(f,c,d),b=n._hue2rgb(f,c,d-1/3)}return new A(Math.round(u*255),Math.round(y*255),Math.round(b*255),S)}}e.HSLA=n;class _{constructor(h,d,m,g){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=E(Math.max(Math.min(1,d),0),3),this.v=E(Math.max(Math.min(1,m),0),3),this.a=E(Math.max(Math.min(1,g),0),3)}static equals(h,d){return h.h===d.h&&h.s===d.s&&h.v===d.v&&h.a===d.a}static fromRGBA(h){const d=h.r/255,m=h.g/255,g=h.b/255,S=Math.max(d,m,g),u=Math.min(d,m,g),y=S-u,b=S===0?0:y/S;let c;return y===0?c=0:S===d?c=((m-g)/y%6+6)%6:S===m?c=(g-d)/y+2:c=(d-m)/y+4,new _(Math.round(c*60),b,S,h.a)}static toRGBA(h){const{h:d,s:m,v:g,a:S}=h,u=g*m,y=u*(1-Math.abs(d/60%2-1)),b=g-u;let[c,f,l]=[0,0,0];return d<60?(c=u,f=y):d<120?(c=y,f=u):d<180?(f=u,l=y):d<240?(f=y,l=u):d<300?(c=y,l=u):d<=360&&(c=u,l=y),c=Math.round((c+b)*255),f=Math.round((f+b)*255),l=Math.round((l+b)*255),new A(c,f,l,S)}}e.HSVA=_;class D{static fromHex(h){return D.Format.CSS.parseHex(h)||D.red}static equals(h,d){return!h&&!d?!0:!h||!d?!1:h.equals(d)}get hsla(){return this._hsla?this._hsla:n.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:_.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof A)this.rgba=h;else if(h instanceof n)this._hsla=h,this.rgba=n.toRGBA(h);else if(h instanceof _)this._hsva=h,this.rgba=_.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&A.equals(this.rgba,h.rgba)&&n.equals(this.hsla,h.hsla)&&_.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=D._relativeLuminanceForComponent(this.rgba.r),d=D._relativeLuminanceForComponent(this.rgba.g),m=D._relativeLuminanceForComponent(this.rgba.b),g=.2126*h+.7152*d+.0722*m;return E(g,4)}static _relativeLuminanceForComponent(h){const d=h/255;return d<=.03928?d/12.92:Math.pow((d+.055)/1.055,2.4)}getContrastRatio(h){const d=this.getRelativeLuminance(),m=h.getRelativeLuminance();return d>m?(d+.05)/(m+.05):(m+.05)/(d+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const d=this.getRelativeLuminance(),m=h.getRelativeLuminance();return d>m}isDarkerThan(h){const d=this.getRelativeLuminance(),m=h.getRelativeLuminance();return d<m}lighten(h){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:d,g:m,b:g,a:S}=this.rgba;return new D(new A(d,m,g,S*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new A(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const d=h.rgba,m=this.rgba.a,g=d.a,S=m+g*(1-m);if(S<1e-6)return D.transparent;const u=this.rgba.r*m/S+d.r*g*(1-m)/S,y=this.rgba.g*m/S+d.g*g*(1-m)/S,b=this.rgba.b*m/S+d.b*g*(1-m)/S;return new D(new A(u,y,b,S))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:d,g:m,b:g,a:S}=this.rgba;return new D(new A(h.rgba.r-S*(h.rgba.r-d),h.rgba.g-S*(h.rgba.g-m),h.rgba.b-S*(h.rgba.b-g),1))}flatten(...h){const d=h.reduceRight((m,g)=>D._flatten(g,m));return D._flatten(this,d)}static _flatten(h,d){const m=1-h.rgba.a;return new D(new A(m*d.rgba.r+h.rgba.a*h.rgba.r,m*d.rgba.g+h.rgba.a*h.rgba.g,m*d.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(h,d,m){if(h.isLighterThan(d))return h;m=m||.5;const g=h.getRelativeLuminance(),S=d.getRelativeLuminance();return m=m*(S-g)/S,h.lighten(m)}static getDarkerColor(h,d,m){if(h.isDarkerThan(d))return h;m=m||.5;const g=h.getRelativeLuminance(),S=d.getRelativeLuminance();return m=m*(g-S)/g,h.darken(m)}static{this.white=new D(new A(255,255,255,1))}static{this.black=new D(new A(0,0,0,1))}static{this.red=new D(new A(255,0,0,1))}static{this.blue=new D(new A(0,0,255,1))}static{this.green=new D(new A(0,255,0,1))}static{this.cyan=new D(new A(0,255,255,1))}static{this.lightgrey=new D(new A(211,211,211,1))}static{this.transparent=new D(new A(0,0,0,0))}}e.Color=D,function(P){let h;(function(d){let m;(function(g){function S(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}g.formatRGB=S;function u(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}g.formatRGBA=u;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}g.formatHSL=y;function b(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}g.formatHSLA=b;function c(t){const a=t.toString(16);return a.length!==2?"0"+a:a}function f(t){return`#${c(t.rgba.r)}${c(t.rgba.g)}${c(t.rgba.b)}`}g.formatHex=f;function l(t,a=!1){return a&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${c(t.rgba.r)}${c(t.rgba.g)}${c(t.rgba.b)}${c(Math.round(t.rgba.a*255))}`}g.formatHexA=l;function v(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}g.format=v;function I(t){const a=t.length;if(a===0||t.charCodeAt(0)!==35)return null;if(a===7){const s=16*p(t.charCodeAt(1))+p(t.charCodeAt(2)),i=16*p(t.charCodeAt(3))+p(t.charCodeAt(4)),r=16*p(t.charCodeAt(5))+p(t.charCodeAt(6));return new P(new A(s,i,r,1))}if(a===9){const s=16*p(t.charCodeAt(1))+p(t.charCodeAt(2)),i=16*p(t.charCodeAt(3))+p(t.charCodeAt(4)),r=16*p(t.charCodeAt(5))+p(t.charCodeAt(6)),o=16*p(t.charCodeAt(7))+p(t.charCodeAt(8));return new P(new A(s,i,r,o/255))}if(a===4){const s=p(t.charCodeAt(1)),i=p(t.charCodeAt(2)),r=p(t.charCodeAt(3));return new P(new A(16*s+s,16*i+i,16*r+r))}if(a===5){const s=p(t.charCodeAt(1)),i=p(t.charCodeAt(2)),r=p(t.charCodeAt(3)),o=p(t.charCodeAt(4));return new P(new A(16*s+s,16*i+i,16*r+r,(16*o+o)/255))}return null}g.parseHex=I;function p(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=d.CSS||(d.CSS={}))})(h=P.Format||(P.Format={}))}(D||(e.Color=D={}))}),define(ee[55],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(D){return(P,h,d)=>{let m=null,g=null;if(typeof d.value=="function"?(m="value",g=d.value):typeof d.get=="function"&&(m="get",g=d.get),!g)throw new Error("not supported");d[m]=D(g,h)}}function A(D,P,h){let d=null,m=null;if(typeof h.value=="function"?(d="value",m=h.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(d="get",m=h.get),!m)throw new Error("not supported");const g=`$memoize$${P}`;h[d]=function(...S){return this.hasOwnProperty(g)||Object.defineProperty(this,g,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,S)}),this[g]}}e.memoize=A;function n(D,P,h){return E((d,m)=>{const g=`$debounce$${m}`,S=`$debounce$result$${m}`;return function(...u){this[S]||(this[S]=h?h():void 0),clearTimeout(this[g]),P&&(this[S]=P(this[S],...u),u=[this[S]]),this[g]=setTimeout(()=>{d.apply(this,u),this[S]=h?h():void 0},D)}})}e.debounce=n;function _(D,P,h){return E((d,m)=>{const g=`$throttle$timer$${m}`,S=`$throttle$result$${m}`,u=`$throttle$lastRun$${m}`,y=`$throttle$pending$${m}`;return function(...b){if(this[S]||(this[S]=h?h():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),P&&(this[S]=P(this[S],...b)),this[y])return;const c=this[u]+D;c<=Date.now()?(this[u]=Date.now(),d.apply(this,[this[S]]),this[S]=h?h():void 0):(this[y]=!0,this[g]=setTimeout(()=>{this[y]=!1,this[u]=Date.now(),d.apply(this,[this[S]]),this[S]=h?h():void 0},c-Date.now()))}})}e.throttle=_}),define(ee[13],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?I.isErrorNoTelemetry(a)?new I(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(s=>{s(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=E,e.errorHandler=new E;function A(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=A;function n(t){if(!t||typeof t!="object")return!1;const a=t;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=n;function _(t){d(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=_;function D(t){d(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=D;function P(t){if(t instanceof Error){const{name:a,message:s}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:a,message:s,stack:i,noTelemetry:I.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=P;const h="Canceled";function d(t){return t instanceof m?!0:t instanceof Error&&t.name===h&&t.message===h}e.isCancellationError=d;class m extends Error{constructor(){super(h),this.name=this.message}}e.CancellationError=m;function g(){const t=new Error(h);return t.name=t.message,t}e.canceled=g;function S(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=S;function u(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=u;function y(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function b(t){const a=new Error(`${t} has been disposed`);return a.name="DISPOSED",a}e.disposed=b;function c(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=c;class f extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=f;class l extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=l;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class I extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof I)return a;const s=new I;return s.message=a.message,s.stack=a.stack,s}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=I;class p extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype)}}e.BugIndicatingError=p}),define(ee[24],te([0,1,13]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMaxIdxBy=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.findLastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(j,Z=0){return j[j.length-(1+Z)]}e.tail=A;function n(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=n;function _(j,Z,Q=(fe,pe)=>fe===pe){if(j===Z)return!0;if(!j||!Z||j.length!==Z.length)return!1;for(let fe=0,pe=j.length;fe<pe;fe++)if(!Q(j[fe],Z[fe]))return!1;return!0}e.equals=_;function D(j,Z){const Q=j.length-1;Z<Q&&(j[Z]=j[Q]),j.pop()}e.removeFastWithoutKeepingOrder=D;function P(j,Z,Q){return h(j.length,fe=>Q(j[fe],Z))}e.binarySearch=P;function h(j,Z){let Q=0,fe=j-1;for(;Q<=fe;){const pe=(Q+fe)/2|0,Pe=Z(pe);if(Pe<0)Q=pe+1;else if(Pe>0)fe=pe-1;else return pe}return-(Q+1)}e.binarySearch2=h;function d(j,Z){let Q=0,fe=j.length;if(fe===0)return 0;for(;Q<fe;){const pe=Math.floor((Q+fe)/2);Z(j[pe])?fe=pe:Q=pe+1}return Q}e.findFirstInSorted=d;function m(j,Z,Q){if(j=j|0,j>=Z.length)throw new TypeError("invalid index");const fe=Z[Math.floor(Z.length*Math.random())],pe=[],Pe=[],De=[];for(const Te of Z){const ye=Q(Te,fe);ye<0?pe.push(Te):ye>0?Pe.push(Te):De.push(Te)}return j<pe.length?m(j,pe,Q):j<pe.length+De.length?De[0]:m(j-(pe.length+De.length),Pe,Q)}e.quickSelect=m;function g(j,Z){const Q=[];let fe;for(const pe of j.slice(0).sort(Z))!fe||Z(fe[0],pe)!==0?(fe=[pe],Q.push(fe)):fe.push(pe);return Q}e.groupBy=g;function S(j,Z,Q){const fe=[];function pe(Te,ye,we){if(ye===0&&we.length===0)return;const K=fe[fe.length-1];K&&K.start+K.deleteCount===Te?(K.deleteCount+=ye,K.toInsert.push(...we)):fe.push({start:Te,deleteCount:ye,toInsert:we})}let Pe=0,De=0;for(;;){if(Pe===j.length){pe(Pe,0,Z.slice(De));break}if(De===Z.length){pe(Pe,j.length-Pe,[]);break}const Te=j[Pe],ye=Z[De],we=Q(Te,ye);we===0?(Pe+=1,De+=1):we<0?(pe(Pe,1,[]),Pe+=1):we>0&&(pe(Pe,0,[ye]),De+=1)}return fe}e.sortedDiff=S;function u(j,Z,Q){const fe=S(j,Z,Q),pe=[],Pe=[];for(const De of fe)pe.push(...j.slice(De.start,De.start+De.deleteCount)),Pe.push(...De.toInsert);return{removed:pe,added:Pe}}e.delta=u;function y(j,Z,Q){if(Q===0)return[];const fe=j.slice(0,Q).sort(Z);return c(j,Z,fe,Q,j.length),fe}e.top=y;function b(j,Z,Q,fe,pe){return Q===0?Promise.resolve([]):new Promise((Pe,De)=>{(async()=>{const Te=j.length,ye=j.slice(0,Q).sort(Z);for(let we=Q,K=Math.min(Q+fe,Te);we<Te;we=K,K=Math.min(K+fe,Te)){if(we>Q&&await new Promise(he=>setTimeout(he)),pe&&pe.isCancellationRequested)throw new E.CancellationError;c(j,Z,ye,we,K)}return ye})().then(Pe,De)})}e.topAsync=b;function c(j,Z,Q,fe,pe){for(const Pe=Q.length;fe<pe;fe++){const De=j[fe];if(Z(De,Q[Pe-1])<0){Q.pop();const Te=d(Q,ye=>Z(De,ye)<0);Q.splice(Te,0,De)}}}function f(j){return j.filter(Z=>!!Z)}e.coalesce=f;function l(j){let Z=0;for(let Q=0;Q<j.length;Q++)j[Q]&&(j[Z]=j[Q],Z+=1);j.length=Z}e.coalesceInPlace=l;function v(j,Z,Q){j.splice(Q,0,j.splice(Z,1)[0])}e.move=v;function I(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=I;function p(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=p;function t(j,Z=Q=>Q){const Q=new Set;return j.filter(fe=>{const pe=Z(fe);return Q.has(pe)?!1:(Q.add(pe),!0)})}e.distinct=t;function a(j){const Z=new Set;return Q=>{const fe=j(Q);return Z.has(fe)?!1:(Z.add(fe),!0)}}e.uniqueFilter=a;function s(j,Z){const Q=i(j,Z);if(Q!==-1)return j[Q]}e.findLast=s;function i(j,Z){for(let Q=j.length-1;Q>=0;Q--){const fe=j[Q];if(Z(fe))return Q}return-1}e.findLastIndex=i;function r(j,Z){return j.length>0?j[0]:Z}e.firstOrDefault=r;function o(j,Z){return j.length>0?j[j.length-1]:Z}e.lastOrDefault=o;function w(j,Z,Q=(fe,pe)=>fe===pe){let fe=0;for(let pe=0,Pe=Math.min(j.length,Z.length);pe<Pe&&Q(j[pe],Z[pe]);pe++)fe++;return fe}e.commonPrefixLength=w;function k(j){return[].concat(...j)}e.flatten=k;function M(j,Z){let Q=typeof Z=="number"?j:0;typeof Z=="number"?Q=j:(Q=0,Z=j);const fe=[];if(Q<=Z)for(let pe=Q;pe<Z;pe++)fe.push(pe);else for(let pe=Q;pe>Z;pe--)fe.push(pe);return fe}e.range=M;function C(j,Z,Q){return j.reduce((fe,pe)=>(fe[Z(pe)]=Q?Q(pe):pe,fe),Object.create(null))}e.index=C;function L(j,Z){return j.push(Z),()=>T(j,Z)}e.insert=L;function T(j,Z){const Q=j.indexOf(Z);if(Q>-1)return j.splice(Q,1),Z}e.remove=T;function F(j,Z,Q){const fe=j.slice(0,Z),pe=j.slice(Z);return fe.concat(Q,pe)}e.arrayInsert=F;function B(j,Z){let Q;if(typeof Z=="number"){let fe=Z;Q=()=>{const pe=Math.sin(fe++)*179426549;return pe-Math.floor(pe)}}else Q=Math.random;for(let fe=j.length-1;fe>0;fe-=1){const pe=Math.floor(Q()*(fe+1)),Pe=j[fe];j[fe]=j[pe],j[pe]=Pe}}e.shuffle=B;function se(j,Z){const Q=j.indexOf(Z);Q>-1&&(j.splice(Q,1),j.unshift(Z))}e.pushToStart=se;function ie(j,Z){const Q=j.indexOf(Z);Q>-1&&(j.splice(Q,1),j.push(Z))}e.pushToEnd=ie;function de(j,Z){for(const Q of Z)j.push(Q)}e.pushMany=de;function ae(j,Z){return Array.isArray(j)?j.map(Z):Z(j)}e.mapArrayOrNot=ae;function ue(j){return Array.isArray(j)?j:[j]}e.asArray=ue;function x(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=x;function G(j,Z){for(const Q of j){const fe=Z(Q);if(fe!==void 0)return fe}}e.mapFind=G;function z(j,Z,Q){const fe=U(j,Z),pe=j.length,Pe=Q.length;j.length=pe+Pe;for(let De=pe-1;De>=fe;De--)j[De+Pe]=j[De];for(let De=0;De<Pe;De++)j[De+fe]=Q[De]}e.insertInto=z;function W(j,Z,Q,fe){const pe=U(j,Z),Pe=j.splice(pe,Q);return z(j,pe,fe),Pe}e.splice=W;function U(j,Z){return Z<0?Math.max(Z+j.length,0):Math.min(Z,j.length)}var $;(function(j){function Z(Pe){return Pe<0}j.isLessThan=Z;function Q(Pe){return Pe<=0}j.isLessThanOrEqual=Q;function fe(Pe){return Pe>0}j.isGreaterThan=fe;function pe(Pe){return Pe===0}j.isNeitherLessOrGreaterThan=pe,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})($||(e.CompareResult=$={}));function X(j,Z){return(Q,fe)=>Z(j(Q),j(fe))}e.compareBy=X;function oe(...j){return(Z,Q)=>{for(const fe of j){const pe=fe(Z,Q);if(!$.isNeitherLessOrGreaterThan(pe))return pe}return $.neitherLessOrGreaterThan}}e.tieBreakComparators=oe;const ce=(j,Z)=>j-Z;e.numberComparator=ce;const V=(j,Z)=>(0,e.numberComparator)(j?1:0,Z?1:0);e.booleanComparator=V;function R(j){return(Z,Q)=>-j(Z,Q)}e.reverseOrder=R;function O(j,Z){if(j.length===0)return;let Q=j[0];for(let fe=1;fe<j.length;fe++){const pe=j[fe];Z(pe,Q)>0&&(Q=pe)}return Q}e.findMaxBy=O;function N(j,Z){if(j.length===0)return;let Q=j[0];for(let fe=1;fe<j.length;fe++){const pe=j[fe];Z(pe,Q)>=0&&(Q=pe)}return Q}e.findLastMaxBy=N;function q(j,Z){return O(j,(Q,fe)=>-Z(Q,fe))}e.findMinBy=q;function re(j,Z){if(j.length===0)return-1;let Q=0;for(let fe=1;fe<j.length;fe++){const pe=j[fe];Z(pe,j[Q])>0&&(Q=fe)}return Q}e.findMaxIdxBy=re;class ne{constructor(Z){this.items=Z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Z){let Q=this.firstIdx;for(;Q<this.items.length&&Z(this.items[Q]);)Q++;const fe=Q===this.firstIdx?null:this.items.slice(this.firstIdx,Q);return this.firstIdx=Q,fe}takeFromEndWhile(Z){let Q=this.lastIdx;for(;Q>=0&&Z(this.items[Q]);)Q--;const fe=Q===this.lastIdx?null:this.items.slice(Q+1,this.lastIdx+1);return this.lastIdx=Q,fe}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const Z=this.items[this.firstIdx];return this.firstIdx++,Z}removeLast(){const Z=this.items[this.lastIdx];return this.lastIdx--,Z}takeCount(Z){const Q=this.items.slice(this.firstIdx,this.firstIdx+Z);return this.firstIdx+=Z,Q}}e.ArrayQueue=ne;class le{static{this.empty=new le(Z=>{})}constructor(Z){this.iterate=Z}forEach(Z){this.iterate(Q=>(Z(Q),!0))}toArray(){const Z=[];return this.iterate(Q=>(Z.push(Q),!0)),Z}filter(Z){return new le(Q=>this.iterate(fe=>Z(fe)?Q(fe):!0))}map(Z){return new le(Q=>this.iterate(fe=>Q(Z(fe))))}some(Z){let Q=!1;return this.iterate(fe=>(Q=Z(fe),!Q)),Q}findFirst(Z){let Q;return this.iterate(fe=>Z(fe)?(Q=fe,!1):!0),Q}findLast(Z){let Q;return this.iterate(fe=>(Z(fe)&&(Q=fe),!0)),Q}findLastMaxBy(Z){let Q,fe=!0;return this.iterate(pe=>((fe||$.isGreaterThan(Z(pe,Q)))&&(fe=!1,Q=pe),!0)),Q}}e.CallbackIterable=le}),define(ee[135],te([0,1,13]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(h,d){if(!h)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}e.ok=A;function n(h,d="Unreachable"){throw new Error(d)}e.assertNever=n;function _(h){if(!h)throw new E.BugIndicatingError("Assertion Failed")}e.assert=_;function D(h){if(!h()){debugger;h(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function P(h,d){let m=0;for(;m<h.length-1;){const g=h[m],S=h[m+1];if(!d(g,S))return!1;m++}return!0}e.checkAdjacentItems=P}),define(ee[49],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(A){const n=this;let _=!1,D;return function(){return _||(_=!0,D=A.apply(n,arguments)),D}}e.once=E}),define(ee[68],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(A){function n(I){return I&&typeof I=="object"&&typeof I[Symbol.iterator]=="function"}A.is=n;const _=Object.freeze([]);function D(){return _}A.empty=D;function*P(I){yield I}A.single=P;function h(I){return n(I)?I:P(I)}A.wrap=h;function d(I){return I||_}A.from=d;function m(I){return!I||I[Symbol.iterator]().next().done===!0}A.isEmpty=m;function g(I){return I[Symbol.iterator]().next().value}A.first=g;function S(I,p){for(const t of I)if(p(t))return!0;return!1}A.some=S;function u(I,p){for(const t of I)if(p(t))return t}A.find=u;function*y(I,p){for(const t of I)p(t)&&(yield t)}A.filter=y;function*b(I,p){let t=0;for(const a of I)yield p(a,t++)}A.map=b;function*c(...I){for(const p of I)for(const t of p)yield t}A.concat=c;function f(I,p,t){let a=t;for(const s of I)a=p(a,s);return a}A.reduce=f;function*l(I,p,t=I.length){for(p<0&&(p+=I.length),t<0?t+=I.length:t>I.length&&(t=I.length);p<t;p++)yield I[p]}A.slice=l;function v(I,p=Number.POSITIVE_INFINITY){const t=[];if(p===0)return[t,I];const a=I[Symbol.iterator]();for(let s=0;s<p;s++){const i=a.next();if(i.done)return[t,A.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return a}}]}A.consume=v})(E||(e.Iterable=E={}))}),define(ee[44],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var n;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(n||(e.ParseErrorCode=n={}));var _;(function(t){t.DEFAULT={allowTrailingComma:!0}})(_||(e.ParseOptions=_={}));function D(t,a=!1){let s=0;const i=t.length;let r="",o=0,w=16,k=0;function M(ie){let de=0,ae=0;for(;de<ie;){const ue=t.charCodeAt(s);if(ue>=48&&ue<=57)ae=ae*16+ue-48;else if(ue>=65&&ue<=70)ae=ae*16+ue-65+10;else if(ue>=97&&ue<=102)ae=ae*16+ue-97+10;else break;s++,de++}return de<ie&&(ae=-1),ae}function C(ie){s=ie,r="",o=0,w=16,k=0}function L(){const ie=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&d(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&d(t.charCodeAt(s)))for(s++;s<t.length&&d(t.charCodeAt(s));)s++;else return k=3,t.substring(ie,s);let de=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&d(t.charCodeAt(s))){for(s++;s<t.length&&d(t.charCodeAt(s));)s++;de=s}else k=3;return t.substring(ie,de)}function T(){let ie="",de=s;for(;;){if(s>=i){ie+=t.substring(de,s),k=2;break}const ae=t.charCodeAt(s);if(ae===34){ie+=t.substring(de,s),s++;break}if(ae===92){if(ie+=t.substring(de,s),s++,s>=i){k=2;break}switch(t.charCodeAt(s++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const x=M(4);x>=0?ie+=String.fromCharCode(x):k=4;break}default:k=5}de=s;continue}if(ae>=0&&ae<=31)if(h(ae)){ie+=t.substring(de,s),k=2;break}else k=6;s++}return ie}function F(){if(r="",k=0,o=s,s>=i)return o=i,w=17;let ie=t.charCodeAt(s);if(P(ie)){do s++,r+=String.fromCharCode(ie),ie=t.charCodeAt(s);while(P(ie));return w=15}if(h(ie))return s++,r+=String.fromCharCode(ie),ie===13&&t.charCodeAt(s)===10&&(s++,r+=`
`),w=14;switch(ie){case 123:return s++,w=1;case 125:return s++,w=2;case 91:return s++,w=3;case 93:return s++,w=4;case 58:return s++,w=6;case 44:return s++,w=5;case 34:return s++,r=T(),w=10;case 47:{const de=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!h(t.charCodeAt(s));)s++;return r=t.substring(de,s),w=12}if(t.charCodeAt(s+1)===42){s+=2;const ae=i-1;let ue=!1;for(;s<ae;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,ue=!0;break}s++}return ue||(s++,k=1),r=t.substring(de,s),w=13}return r+=String.fromCharCode(ie),s++,w=16}case 45:if(r+=String.fromCharCode(ie),s++,s===i||!d(t.charCodeAt(s)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=L(),w=11;default:for(;s<i&&B(ie);)s++,ie=t.charCodeAt(s);if(o!==s){switch(r=t.substring(o,s),r){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return r+=String.fromCharCode(ie),s++,w=16}}function B(ie){if(P(ie)||h(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ie;do ie=F();while(ie>=12&&ie<=15);return ie}return{setPosition:C,getPosition:()=>s,scan:a?se:F,getToken:()=>w,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>s-o,getTokenError:()=>k}}e.createScanner=D;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var m;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(m||(m={}));function g(t,a){const s=[],i=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function k(M,C,L,T){o.value=M,o.offset=C,o.length=L,o.type=T,o.colonOffset=void 0,r=o}try{v(t,{onObjectBegin:(M,C)=>{if(a<=M)throw i;r=void 0,w=a>M,s.push("")},onObjectProperty:(M,C,L)=>{if(a<C||(k(M,C,L,"property"),s[s.length-1]=M,a<=C+L))throw i},onObjectEnd:(M,C)=>{if(a<=M)throw i;r=void 0,s.pop()},onArrayBegin:(M,C)=>{if(a<=M)throw i;r=void 0,s.push(0)},onArrayEnd:(M,C)=>{if(a<=M)throw i;r=void 0,s.pop()},onLiteralValue:(M,C,L)=>{if(a<C||(k(M,C,L,p(M)),a<=C+L))throw i},onSeparator:(M,C,L)=>{if(a<=C)throw i;if(M===":"&&r&&r.type==="property")r.colonOffset=C,w=!1,r=void 0;else if(M===","){const T=s[s.length-1];typeof T=="number"?s[s.length-1]=T+1:(w=!0,s[s.length-1]=""),r=void 0}}})}catch(M){if(M!==i)throw M}return{path:s,previousNode:r,isAtPropertyKey:w,matches:M=>{let C=0;for(let L=0;C<M.length&&L<s.length;L++)if(M[C]===s[L]||M[C]==="*")C++;else if(M[C]!=="**")return!1;return C===M.length}}}e.getLocation=g;function S(t,a=[],s=_.DEFAULT){let i=null,r=[];const o=[];function w(M){Array.isArray(r)?r.push(M):i!==null&&(r[i]=M)}return v(t,{onObjectBegin:()=>{const M={};w(M),o.push(r),r=M,i=null},onObjectProperty:M=>{i=M},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const M=[];w(M),o.push(r),r=M,i=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:w,onError:(M,C,L)=>{a.push({error:M,offset:C,length:L})}},s),r[0]}e.parse=S;function u(t,a=[],s=_.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(M){i.type==="property"&&(i.length=M-i.offset,i=i.parent)}function o(M){return i.children.push(M),M}v(t,{onObjectBegin:M=>{i=o({type:"object",offset:M,length:-1,parent:i,children:[]})},onObjectProperty:(M,C,L)=>{i=o({type:"property",offset:C,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:M,offset:C,length:L,parent:i})},onObjectEnd:(M,C)=>{i.length=M+C-i.offset,i=i.parent,r(M+C)},onArrayBegin:(M,C)=>{i=o({type:"array",offset:M,length:-1,parent:i,children:[]})},onArrayEnd:(M,C)=>{i.length=M+C-i.offset,i=i.parent,r(M+C)},onLiteralValue:(M,C,L)=>{o({type:p(M),offset:C,length:L,parent:i,value:M}),r(C+L)},onSeparator:(M,C,L)=>{i.type==="property"&&(M===":"?i.colonOffset=C:M===","&&r(C))},onError:(M,C,L)=>{a.push({error:M,offset:C,length:L})}},s);const k=i.children[0];return k&&delete k.parent,k}e.parseTree=u;function y(t,a){if(!t)return;let s=t;for(const i of a)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const o of s.children)if(Array.isArray(o.children)&&o.children[0].value===i){s=o.children[1],r=!0;break}if(!r)return}else{const r=i;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=y;function b(t){if(!t.parent||!t.parent.children)return[];const a=b(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;a.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&a.push(s)}return a}e.getNodePath=b;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const a=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(a[s.children[0].value]=c(i))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=c;function f(t,a,s=!1){return a>=t.offset&&a<t.offset+t.length||s&&a===t.offset+t.length}e.contains=f;function l(t,a,s=!1){if(f(t,a,s)){const i=t.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=a;r++){const o=l(i[r],a,s);if(o)return o}return t}}e.findNodeAtOffset=l;function v(t,a,s=_.DEFAULT){const i=D(t,!1);function r(X){return X?()=>X(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(X){return X?oe=>X(oe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const w=r(a.onObjectBegin),k=o(a.onObjectProperty),M=r(a.onObjectEnd),C=r(a.onArrayBegin),L=r(a.onArrayEnd),T=o(a.onLiteralValue),F=o(a.onSeparator),B=r(a.onComment),se=o(a.onError),ie=s&&s.disallowComments,de=s&&s.allowTrailingComma;function ae(){for(;;){const X=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:ie||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(X){case 12:case 13:ie?ue(10):B();break;case 16:ue(1);break;case 15:case 14:break;default:return X}}}function ue(X,oe=[],ce=[]){if(se(X),oe.length+ce.length>0){let V=i.getToken();for(;V!==17;){if(oe.indexOf(V)!==-1){ae();break}else if(ce.indexOf(V)!==-1)break;V=ae()}}}function x(X){const oe=i.getTokenValue();return X?T(oe):k(oe),ae(),!0}function G(){switch(i.getToken()){case 11:{let X=0;try{X=JSON.parse(i.getTokenValue()),typeof X!="number"&&(ue(2),X=0)}catch{ue(2)}T(X);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return ae(),!0}function z(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(x(!1),i.getToken()===6?(F(":"),ae(),$()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function W(){w(),ae();let X=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(X||ue(4,[],[]),F(","),ae(),i.getToken()===2&&de)break}else X&&ue(6,[],[]);z()||ue(4,[],[2,5]),X=!0}return M(),i.getToken()!==2?ue(7,[2],[]):ae(),!0}function U(){C(),ae();let X=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(X||ue(4,[],[]),F(","),ae(),i.getToken()===4&&de)break}else X&&ue(6,[],[]);$()||ue(4,[],[4,5]),X=!0}return L(),i.getToken()!==4?ue(8,[4],[]):ae(),!0}function $(){switch(i.getToken()){case 3:return U();case 1:return W();case 10:return x(!0);default:return G()}}return ae(),i.getToken()===17?s.allowEmptyContent?!0:(ue(4,[],[]),!1):$()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.visit=v;function I(t,a){const s=D(t),i=[];let r,o=0,w;do switch(w=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:o!==w&&i.push(t.substring(o,w)),a!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,a)),o=s.getPosition();break}while(r!==17);return i.join("")}e.stripComments=I;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(ee[136],te([0,1,44]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function A(d,m,g){let S,u,y,b,c;if(m){for(b=m.offset,c=b+m.length,y=b;y>0&&!h(d,y-1);)y--;let w=c;for(;w<d.length&&!h(d,w);)w++;u=d.substring(y,w),S=D(u,g)}else u=d,S=0,y=0,b=0,c=d.length;const f=P(g,d);let l=!1,v=0,I;g.insertSpaces?I=_(" ",g.tabSize||4):I="	";const p=(0,E.createScanner)(u,!1);let t=!1;function a(){return f+_(I,S+v)}function s(){let w=p.scan();for(l=!1;w===15||w===14;)l=l||w===14,w=p.scan();return t=w===16||p.getTokenError()!==0,w}const i=[];function r(w,k,M){!t&&k<c&&M>b&&d.substring(k,M)!==w&&i.push({offset:k,length:M-k,content:w})}let o=s();if(o!==17){const w=p.getTokenOffset()+y,k=_(I,S);r(k,y,w)}for(;o!==17;){let w=p.getTokenOffset()+p.getTokenLength()+y,k=s(),M="";for(;!l&&(k===12||k===13);){const L=p.getTokenOffset()+y;r(" ",w,L),w=p.getTokenOffset()+p.getTokenLength()+y,M=k===12?a():"",k=s()}if(k===2)o!==1&&(v--,M=a());else if(k===4)o!==3&&(v--,M=a());else{switch(o){case 3:case 1:v++,M=a();break;case 5:case 12:M=a();break;case 13:l?M=a():M=" ";break;case 6:M=" ";break;case 10:if(k===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:k===12||k===13?M=" ":k!==5&&k!==17&&(t=!0);break;case 16:t=!0;break}l&&(k===12||k===13)&&(M=a())}const C=p.getTokenOffset()+y;r(M,w,C),o=k}return i}e.format=A;function n(d,m){const g=JSON.stringify(d,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?g.replace(/\r\n|\r|\n/g,m.eol):g}e.toFormattedString=n;function _(d,m){let g="";for(let S=0;S<m;S++)g+=d;return g}function D(d,m){let g=0,S=0;const u=m.tabSize||4;for(;g<d.length;){const y=d.charAt(g);if(y===" ")S++;else if(y==="	")S+=u;else break;g++}return Math.floor(S/u)}function P(d,m){for(let g=0;g<m.length;g++){const S=m.charAt(g);if(S==="\r")return g+1<m.length&&m.charAt(g+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return d&&d.eol||`
`}e.getEOL=P;function h(d,m){return`\r
`.indexOf(d.charAt(m))!==-1}e.isEOL=h}),define(ee[137],te([0,1,44,136]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function n(d,m,g){return _(d,m,void 0,g)}e.removeProperty=n;function _(d,m,g,S,u){const y=m.slice(),b=[],c=(0,E.parseTree)(d,b);let f,l;for(;y.length>0&&(l=y.pop(),f=(0,E.findNodeAtLocation)(c,y),f===void 0&&g!==void 0);)typeof l=="string"?g={[l]:g}:g=[g];if(f)if(f.type==="object"&&typeof l=="string"&&Array.isArray(f.children)){const v=(0,E.findNodeAtLocation)(f,[l]);if(v!==void 0)if(g===void 0){if(!v.parent)throw new Error("Malformed AST");const I=f.children.indexOf(v.parent);let p,t=v.parent.offset+v.parent.length;if(I>0){const a=f.children[I-1];p=a.offset+a.length}else p=f.offset+1,f.children.length>1&&(t=f.children[1].offset);return D(d,{offset:p,length:t-p,content:""},S)}else return D(d,{offset:v.offset,length:v.length,content:JSON.stringify(g)},S);else{if(g===void 0)return[];const I=`${JSON.stringify(l)}: ${JSON.stringify(g)}`,p=u?u(f.children.map(a=>a.children[0].value)):f.children.length;let t;if(p>0){const a=f.children[p-1];t={offset:a.offset+a.length,length:0,content:","+I}}else f.children.length===0?t={offset:f.offset+1,length:0,content:I}:t={offset:f.offset+1,length:0,content:I+","};return D(d,t,S)}}else if(f.type==="array"&&typeof l=="number"&&Array.isArray(f.children))if(g!==void 0){const v=`${JSON.stringify(g)}`;let I;if(f.children.length===0||l===0)I={offset:f.offset+1,length:0,content:f.children.length===0?v:v+","};else{const p=l===-1||l>f.children.length?f.children.length:l,t=f.children[p-1];I={offset:t.offset+t.length,length:0,content:","+v}}return D(d,I,S)}else{const v=l,I=f.children[v];let p;if(f.children.length===1)p={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===v){const t=f.children[v-1],a=t.offset+t.length,s=f.offset+f.length;p={offset:a,length:s-2-a,content:""}}else p={offset:I.offset,length:f.children[v+1].offset-I.offset,content:""};return D(d,p,S)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${f.type}`);else{if(g===void 0)throw new Error("Can not delete in empty document");return D(d,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(g)},S)}}e.setProperty=_;function D(d,m,g){let S=P(d,m),u=m.offset,y=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;u>0&&!(0,A.isEOL)(S,u-1);)u--;for(;y<S.length&&!(0,A.isEOL)(S,y);)y++}const b=(0,A.format)(S,{offset:u,length:y-u},g);for(let f=b.length-1;f>=0;f--){const l=b[f];S=P(S,l),u=Math.min(u,l.offset),y=Math.max(y,l.offset+l.length),y+=l.content.length-l.length}const c=d.length-(S.length-y)-u;return[{offset:u,length:c,content:S.substring(u,y)}]}e.withFormatting=D;function P(d,m){return d.substring(0,m.offset)+m.content+d.substring(m.offset+m.length)}e.applyEdit=P;function h(d,m){const g=m.slice(0).sort((u,y)=>{const b=u.offset-y.offset;return b===0?u.length-y.length:b});let S=d.length;for(let u=g.length-1;u>=0;u--){const y=g[u];if(y.offset+y.length<=S)d=P(d,y);else throw new Error("Overlapping edit");S=y.offset}return d}e.applyEdits=h}),define(ee[85],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(n){this.executor=n,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(n){this._error=n}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=E}),define(ee[2],te([0,1,49,68]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const n=!1;let _=null;function D(o){_=o}if(e.setDisposableTracker=D,n){const o="__is_disposable_tracked__";D(new class{trackDisposable(w){const k=new Error("Potentially leaked disposable").stack;setTimeout(()=>{w[o]||console.log(k)},3e3)}setParent(w,k){if(w&&w!==l.None)try{w[o]=!0}catch{}}markAsDisposed(w){if(w&&w!==l.None)try{w[o]=!0}catch{}}markAsSingleton(w){}})}function P(o){return _?.trackDisposable(o),o}function h(o){_?.markAsDisposed(o)}function d(o,w){_?.setParent(o,w)}function m(o,w){if(_)for(const k of o)_.setParent(k,w)}function g(o){return _?.markAsSingleton(o),o}e.markAsSingleton=g;function S(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=S;function u(o){if(A.Iterable.is(o)){const w=[];for(const k of o)if(k)try{k.dispose()}catch(M){w.push(M)}if(w.length===1)throw w[0];if(w.length>1)throw new AggregateError(w,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=u;function y(o){for(const w of o)S(w)&&w.dispose();return[]}e.disposeIfDisposable=y;function b(...o){const w=c(()=>u(o));return m(o,w),w}e.combinedDisposable=b;function c(o){const w=P({dispose:(0,E.once)(()=>{h(w),o()})});return w}e.toDisposable=c;class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(w){if(!w)return w;if(w===this)throw new Error("Cannot register a disposable on itself!");return d(w,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(w),w}}e.DisposableStore=f;class l{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new f,P(this),d(this._store,this)}dispose(){h(this),this._store.dispose()}_register(w){if(w===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(w)}}e.Disposable=l;class v{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(w){this._isDisposed||w===this._value||(this._value?.dispose(),w&&d(w,this),this._value=w)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const w=this._value;return this._value=void 0,w&&d(w,null),w}}e.MutableDisposable=v;class I{constructor(w){this._disposable=w,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=I;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(w){let k=w;return this.unset=()=>k=void 0,this.isset=()=>k!==void 0,this.dispose=()=>{k&&(k(),k=void 0,h(this))},this}}e.SafeDisposable=p;class t{constructor(){this.references=new Map}acquire(w,...k){let M=this.references.get(w);M||(M={counter:0,object:this.createReferencedObject(w,...k)},this.references.set(w,M));const{object:C}=M,L=(0,E.once)(()=>{--M.counter===0&&(this.destroyReferencedObject(w,M.object),this.references.delete(w))});return M.counter++,{object:C,dispose:L}}}e.ReferenceCollection=t;class a{constructor(w){this.referenceCollection=w}async acquire(w,...k){const M=this.referenceCollection.acquire(w,...k);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(C){throw M.dispose(),C}}}e.AsyncReferenceCollection=a;class s{constructor(w){this.object=w}dispose(){}}e.ImmortalReference=s;function i(o){const w=new f;try{o(w)}finally{w.dispose()}}e.disposeOnReturn=i;class r{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){h(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{u(this._store.values())}finally{this._store.clear()}}has(w){return this._store.has(w)}get(w){return this._store.get(w)}set(w,k,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(w)?.dispose(),this._store.set(w,k)}deleteAndDispose(w){this._store.get(w)?.dispose(),this._store.delete(w)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=r}),define(ee[102],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{static{this.Undefined=new E(void 0)}constructor(_){this.element=_,this.next=E.Undefined,this.prev=E.Undefined}}class A{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let _=this._first;for(;_!==E.Undefined;){const D=_.next;_.prev=E.Undefined,_.next=E.Undefined,_=D}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,D){const P=new E(_);if(this._first===E.Undefined)this._first=P,this._last=P;else if(D){const d=this._last;this._last=P,P.prev=d,d.next=P}else{const d=this._first;this._first=P,P.next=d,d.prev=P}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(P))}}shift(){if(this._first!==E.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==E.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==E.Undefined&&_.next!==E.Undefined){const D=_.prev;D.next=_.next,_.next.prev=D}else _.prev===E.Undefined&&_.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):_.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):_.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==E.Undefined;)yield _.element,_=_.next}}e.LinkedList=A}),define(ee[35],te([0,1]),function(H,e){"use strict";var E,A,n;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function _(b,c,f){let l=b.get(c);return l===void 0&&(l=f,b.set(c,l)),l}e.getOrSet=_;function D(b){const c=[];return b.forEach((f,l)=>{c.push(`${l} => ${f}`)}),`Map(${b.size}) {${c.join(", ")}}`}e.mapToString=D;function P(b){const c=[];return b.forEach(f=>{c.push(f)}),`Set(${b.size}) {${c.join(", ")}}`}e.setToString=P;class h{constructor(c,f){this.uri=c,this.value=f}}class d{static{this.defaultToKey=c=>c.toString()}constructor(c,f){this[E]="ResourceMap",c instanceof d?(this.map=new Map(c.map),this.toKey=f??d.defaultToKey):(this.map=new Map,this.toKey=c??d.defaultToKey)}set(c,f){return this.map.set(this.toKey(c),new h(c,f)),this}get(c){return this.map.get(this.toKey(c))?.value}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,f){typeof f<"u"&&(c=c.bind(f));for(const[l,v]of this.map)c(v.value,v.uri,this)}*values(){for(const c of this.map.values())yield c.value}*keys(){for(const c of this.map.values())yield c.uri}*entries(){for(const c of this.map.values())yield[c.uri,c.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.map)yield[c.uri,c.value]}}e.ResourceMap=d;class m{constructor(c,f){this[A]="ResourceSet",!c||typeof c=="function"?this._map=new d(c):(this._map=new d(f),c.forEach(this.add,this))}get size(){return this._map.size}add(c){return this._map.set(c,c),this}clear(){this._map.clear()}delete(c){return this._map.delete(c)}forEach(c,f){this._map.forEach((l,v)=>c.call(f,v,v,this))}has(c){return this._map.has(c)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=m;var g;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class S{constructor(){this[n]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(c){return this._map.has(c)}get(c,f=0){const l=this._map.get(c);if(l)return f!==0&&this.touch(l,f),l.value}set(c,f,l=0){let v=this._map.get(c);if(v)v.value=f,l!==0&&this.touch(v,l);else{switch(v={key:c,value:f,next:void 0,previous:void 0},l){case 0:this.addItemLast(v);break;case 1:this.addItemFirst(v);break;case 2:this.addItemLast(v);break;default:this.addItemLast(v);break}this._map.set(c,v),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const f=this._map.get(c);if(f)return this._map.delete(c),this.removeItem(f),this._size--,f.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}forEach(c,f){const l=this._state;let v=this._head;for(;v;){if(f?c.bind(f)(v.value,v.key,this):c(v.value,v.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const c=this,f=this._state;let l=this._head;const v={[Symbol.iterator](){return v},next(){if(c._state!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const I={value:l.key,done:!1};return l=l.next,I}else return{value:void 0,done:!0}}};return v}values(){const c=this,f=this._state;let l=this._head;const v={[Symbol.iterator](){return v},next(){if(c._state!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const I={value:l.value,done:!1};return l=l.next,I}else return{value:void 0,done:!0}}};return v}entries(){const c=this,f=this._state;let l=this._head;const v={[Symbol.iterator](){return v},next(){if(c._state!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const I={value:[l.key,l.value],done:!1};return l=l.next,I}else return{value:void 0,done:!0}}};return v}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(c>=this.size)return;if(c===0){this.clear();return}let f=this._head,l=this.size;for(;f&&l>c;)this._map.delete(f.key),f=f.next,l--;this._head=f,this._size=l,f&&(f.previous=void 0),this._state++}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const f=c.next,l=c.previous;if(!f||!l)throw new Error("Invalid list");f.previous=l,l.next=f}c.next=void 0,c.previous=void 0,this._state++}touch(c,f){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(c===this._head)return;const l=c.next,v=c.previous;c===this._tail?(v.next=void 0,this._tail=v):(l.previous=v,v.next=l),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(f===2){if(c===this._tail)return;const l=c.next,v=c.previous;c===this._head?(l.previous=void 0,this._head=l):(l.previous=v,v.next=l),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((f,l)=>{c.push([l,f])}),c}fromJSON(c){this.clear();for(const[f,l]of c)this.set(f,l)}}e.LinkedMap=S;class u extends S{constructor(c,f=1){super(),this._limit=c,this._ratio=Math.min(Math.max(0,f),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,f=2){return super.get(c,f)}peek(c){return super.get(c,0)}set(c,f){return super.set(c,f,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class y{constructor(){this.map=new Map}add(c){return this.map.set(c,(this.map.get(c)||0)+1),this}delete(c){let f=this.map.get(c)||0;return f===0?!1:(f--,f===0?this.map.delete(c):this.map.set(c,f),!0)}has(c){return this.map.has(c)}}e.CounterSet=y}),define(ee[86],te([0,1,35]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new E.LRUCache(1e4);function n(d){return h(d,"NFC",A)}e.normalizeNFC=n;const _=new E.LRUCache(1e4);function D(d){return h(d,"NFD",_)}e.normalizeNFD=D;const P=/[^\u0000-\u0080]/;function h(d,m,g){if(!d)return d;const S=g.get(d);if(S)return S;let u;return P.test(d)?u=d.normalize(m):u=d,g.set(d,u),u}e.removeAccents=function(){const d=/[\u0300-\u036f]/g;return function(m){return D(m).replace(d,"")}}()}),define(ee[138],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(P,h,d){return Math.min(Math.max(P,h),d)}e.clamp=E;function A(P,h){return(h+P%h)%h}e.rot=A;class n{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=n;class _{constructor(){this._n=1,this._val=0}update(h){return this._val=this._val+(h-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=_;class D{constructor(h){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(h),this._values.fill(0,0,h)}update(h){const d=this._values[this._index];return this._values[this._index]=h,this._index=(this._index+1)%this._values.length,this._sum-=d,this._sum+=h,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function H(n){const _=[];typeof n=="number"&&_.push("code/timeOrigin",n);function D(h){_.push(h,Date.now())}function P(){const h=[];for(let d=0;d<_.length;d+=2)h.push({name:_[d],startTime:_[d+1]});return h}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(n){performance.mark(n)},getMarks(){let n=performance.timeOrigin;typeof n!="number"&&(n=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(n)}];for(const D of performance.getEntriesByType("mark"))_.push({name:D.name,startTime:Math.round(n+D.startTime)});return _}};if(typeof process=="object"){const n=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(n)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function E(n){return n.MonacoPerformanceMarks||(n.MonacoPerformanceMarks=e()),n.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=E(A))}(),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var A in E)(typeof exports=="object"?exports:H)[A]=E[A]}}(typeof self<"u"?self:this,function(){return function(H){var e={};function E(A){if(e[A])return e[A].exports;var n=e[A]={i:A,l:!1,exports:{}};return H[A].call(n.exports,n,n.exports,E),n.l=!0,n.exports}return E.m=H,E.c=e,E.d=function(A,n,_){E.o(A,n)||Object.defineProperty(A,n,{enumerable:!0,get:_})},E.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},E.t=function(A,n){if(1&n&&(A=E(A)),8&n||4&n&&typeof A=="object"&&A&&A.__esModule)return A;var _=Object.create(null);if(E.r(_),Object.defineProperty(_,"default",{enumerable:!0,value:A}),2&n&&typeof A!="string")for(var D in A)E.d(_,D,function(P){return A[P]}.bind(null,D));return _},E.n=function(A){var n=A&&A.__esModule?function(){return A.default}:function(){return A};return E.d(n,"a",n),n},E.o=function(A,n){return Object.prototype.hasOwnProperty.call(A,n)},E.p="",E(E.s=0)}([function(H,e,E){(function(A){var n;e=H.exports=ce,n=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var K=Array.prototype.slice.call(arguments,0);K.unshift("SEMVER"),console.log.apply(console,K)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var _=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],h=e.src=[],d=0,m=d++;h[m]="0|[1-9]\\d*";var g=d++;h[g]="[0-9]+";var S=d++;h[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=d++;h[u]="("+h[m]+")\\.("+h[m]+")\\.("+h[m]+")";var y=d++;h[y]="("+h[g]+")\\.("+h[g]+")\\.("+h[g]+")";var b=d++;h[b]="(?:"+h[m]+"|"+h[S]+")";var c=d++;h[c]="(?:"+h[g]+"|"+h[S]+")";var f=d++;h[f]="(?:-("+h[b]+"(?:\\."+h[b]+")*))";var l=d++;h[l]="(?:-?("+h[c]+"(?:\\."+h[c]+")*))";var v=d++;h[v]="[0-9A-Za-z-]+";var I=d++;h[I]="(?:\\+("+h[v]+"(?:\\."+h[v]+")*))";var p=d++,t="v?"+h[u]+h[f]+"?"+h[I]+"?";h[p]="^"+t+"$";var a="[v=\\s]*"+h[y]+h[l]+"?"+h[I]+"?",s=d++;h[s]="^"+a+"$";var i=d++;h[i]="((?:<|>)?=?)";var r=d++;h[r]=h[g]+"|x|X|\\*";var o=d++;h[o]=h[m]+"|x|X|\\*";var w=d++;h[w]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[f]+")?"+h[I]+"?)?)?";var k=d++;h[k]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[l]+")?"+h[I]+"?)?)?";var M=d++;h[M]="^"+h[i]+"\\s*"+h[w]+"$";var C=d++;h[C]="^"+h[i]+"\\s*"+h[k]+"$";var L=d++;h[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=d++;h[T]="(?:~>?)";var F=d++;h[F]="(\\s*)"+h[T]+"\\s+",P[F]=new RegExp(h[F],"g");var B=d++;h[B]="^"+h[T]+h[w]+"$";var se=d++;h[se]="^"+h[T]+h[k]+"$";var ie=d++;h[ie]="(?:\\^)";var de=d++;h[de]="(\\s*)"+h[ie]+"\\s+",P[de]=new RegExp(h[de],"g");var ae=d++;h[ae]="^"+h[ie]+h[w]+"$";var ue=d++;h[ue]="^"+h[ie]+h[k]+"$";var x=d++;h[x]="^"+h[i]+"\\s*("+a+")$|^$";var G=d++;h[G]="^"+h[i]+"\\s*("+t+")$|^$";var z=d++;h[z]="(\\s*)"+h[i]+"\\s*("+a+"|"+h[w]+")",P[z]=new RegExp(h[z],"g");var W=d++;h[W]="^\\s*("+h[w]+")\\s+-\\s+("+h[w]+")\\s*$";var U=d++;h[U]="^\\s*("+h[k]+")\\s+-\\s+("+h[k]+")\\s*$";var $=d++;h[$]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)n(X,h[X]),P[X]||(P[X]=new RegExp(h[X]));function oe(K,he){if(K instanceof ce)return K;if(typeof K!="string"||K.length>_||!(he?P[s]:P[p]).test(K))return null;try{return new ce(K,he)}catch{return null}}function ce(K,he){if(K instanceof ce){if(K.loose===he)return K;K=K.version}else if(typeof K!="string")throw new TypeError("Invalid Version: "+K);if(K.length>_)throw new TypeError("version is longer than "+_+" characters");if(!(this instanceof ce))return new ce(K,he);n("SemVer",K,he),this.loose=he;var me=K.trim().match(he?P[s]:P[p]);if(!me)throw new TypeError("Invalid Version: "+K);if(this.raw=K,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Re=+Ie;if(Re>=0&&Re<D)return Re}return Ie}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=oe,e.valid=function(K,he){var me=oe(K,he);return me?me.version:null},e.clean=function(K,he){var me=oe(K.trim().replace(/^[=v]+/,""),he);return me?me.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(K){return n("SemVer.compare",this.version,this.loose,K),K instanceof ce||(K=new ce(K,this.loose)),this.compareMain(K)||this.comparePre(K)},ce.prototype.compareMain=function(K){return K instanceof ce||(K=new ce(K,this.loose)),R(this.major,K.major)||R(this.minor,K.minor)||R(this.patch,K.patch)},ce.prototype.comparePre=function(K){if(K instanceof ce||(K=new ce(K,this.loose)),this.prerelease.length&&!K.prerelease.length)return-1;if(!this.prerelease.length&&K.prerelease.length)return 1;if(!this.prerelease.length&&!K.prerelease.length)return 0;var he=0;do{var me=this.prerelease[he],Ie=K.prerelease[he];if(n("prerelease compare",he,me,Ie),me===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(me===void 0)return-1;if(me!==Ie)return R(me,Ie)}while(++he)},ce.prototype.inc=function(K,he){switch(K){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+K)}return this.format(),this.raw=this.version,this},e.inc=function(K,he,me,Ie){typeof me=="string"&&(Ie=me,me=void 0);try{return new ce(K,me).inc(he,Ie).version}catch{return null}},e.diff=function(K,he){if(re(K,he))return null;var me=oe(K),Ie=oe(he);if(me.prerelease.length||Ie.prerelease.length){for(var Re in me)if((Re==="major"||Re==="minor"||Re==="patch")&&me[Re]!==Ie[Re])return"pre"+Re;return"prerelease"}for(var Re in me)if((Re==="major"||Re==="minor"||Re==="patch")&&me[Re]!==Ie[Re])return Re},e.compareIdentifiers=R;var V=/^[0-9]+$/;function R(K,he){var me=V.test(K),Ie=V.test(he);return me&&Ie&&(K=+K,he=+he),me&&!Ie?-1:Ie&&!me?1:K<he?-1:K>he?1:0}function O(K,he,me){return new ce(K,me).compare(new ce(he,me))}function N(K,he,me){return O(K,he,me)>0}function q(K,he,me){return O(K,he,me)<0}function re(K,he,me){return O(K,he,me)===0}function ne(K,he,me){return O(K,he,me)!==0}function le(K,he,me){return O(K,he,me)>=0}function j(K,he,me){return O(K,he,me)<=0}function Z(K,he,me,Ie){var Re;switch(he){case"===":typeof K=="object"&&(K=K.version),typeof me=="object"&&(me=me.version),Re=K===me;break;case"!==":typeof K=="object"&&(K=K.version),typeof me=="object"&&(me=me.version),Re=K!==me;break;case"":case"=":case"==":Re=re(K,me,Ie);break;case"!=":Re=ne(K,me,Ie);break;case">":Re=N(K,me,Ie);break;case">=":Re=le(K,me,Ie);break;case"<":Re=q(K,me,Ie);break;case"<=":Re=j(K,me,Ie);break;default:throw new TypeError("Invalid operator: "+he)}return Re}function Q(K,he){if(K instanceof Q){if(K.loose===he)return K;K=K.value}if(!(this instanceof Q))return new Q(K,he);n("comparator",K,he),this.loose=he,this.parse(K),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,n("comp",this)}e.rcompareIdentifiers=function(K,he){return R(he,K)},e.major=function(K,he){return new ce(K,he).major},e.minor=function(K,he){return new ce(K,he).minor},e.patch=function(K,he){return new ce(K,he).patch},e.compare=O,e.compareLoose=function(K,he){return O(K,he,!0)},e.rcompare=function(K,he,me){return O(he,K,me)},e.sort=function(K,he){return K.sort(function(me,Ie){return e.compare(me,Ie,he)})},e.rsort=function(K,he){return K.sort(function(me,Ie){return e.rcompare(me,Ie,he)})},e.gt=N,e.lt=q,e.eq=re,e.neq=ne,e.gte=le,e.lte=j,e.cmp=Z,e.Comparator=Q;var fe={};function pe(K,he){if(K instanceof pe)return K.loose===he?K:new pe(K.raw,he);if(K instanceof Q)return new pe(K.value,he);if(!(this instanceof pe))return new pe(K,he);if(this.loose=he,this.raw=K,this.set=K.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+K);this.format()}function Pe(K){return!K||K.toLowerCase()==="x"||K==="*"}function De(K,he,me,Ie,Re,Ue,Ae,ze,Be,J,ge,ve,be){return((he=Pe(me)?"":Pe(Ie)?">="+me+".0.0":Pe(Re)?">="+me+"."+Ie+".0":">="+he)+" "+(ze=Pe(Be)?"":Pe(J)?"<"+(+Be+1)+".0.0":Pe(ge)?"<"+Be+"."+(+J+1)+".0":ve?"<="+Be+"."+J+"."+ge+"-"+ve:"<="+ze)).trim()}function Te(K,he){for(var me=0;me<K.length;me++)if(!K[me].test(he))return!1;if(he.prerelease.length){for(me=0;me<K.length;me++)if(n(K[me].semver),K[me].semver!==fe&&K[me].semver.prerelease.length>0){var Ie=K[me].semver;if(Ie.major===he.major&&Ie.minor===he.minor&&Ie.patch===he.patch)return!0}return!1}return!0}function ye(K,he,me){try{he=new pe(he,me)}catch{return!1}return he.test(K)}function we(K,he,me,Ie){var Re,Ue,Ae,ze,Be;switch(K=new ce(K,Ie),he=new pe(he,Ie),me){case">":Re=N,Ue=j,Ae=q,ze=">",Be=">=";break;case"<":Re=q,Ue=le,Ae=N,ze="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye(K,he,Ie))return!1;for(var J=0;J<he.set.length;++J){var ge=he.set[J],ve=null,be=null;if(ge.forEach(function(Le){Le.semver===fe&&(Le=new Q(">=0.0.0")),ve=ve||Le,be=be||Le,Re(Le.semver,ve.semver,Ie)?ve=Le:Ae(Le.semver,be.semver,Ie)&&(be=Le)}),ve.operator===ze||ve.operator===Be||(!be.operator||be.operator===ze)&&Ue(K,be.semver)||be.operator===Be&&Ae(K,be.semver))return!1}return!0}Q.prototype.parse=function(K){var he=this.loose?P[x]:P[G],me=K.match(he);if(!me)throw new TypeError("Invalid comparator: "+K);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new ce(me[2],this.loose):this.semver=fe},Q.prototype.toString=function(){return this.value},Q.prototype.test=function(K){return n("Comparator.test",K,this.loose),this.semver===fe||(typeof K=="string"&&(K=new ce(K,this.loose)),Z(K,this.operator,this.semver,this.loose))},Q.prototype.intersects=function(K,he){if(!(K instanceof Q))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new pe(K.value,he),ye(this.value,me,he);if(K.operator==="")return me=new pe(this.value,he),ye(K.semver,me,he);var Ie=!(this.operator!==">="&&this.operator!==">"||K.operator!==">="&&K.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||K.operator!=="<="&&K.operator!=="<"),Ue=this.semver.version===K.semver.version,Ae=!(this.operator!==">="&&this.operator!=="<="||K.operator!==">="&&K.operator!=="<="),ze=Z(this.semver,"<",K.semver,he)&&(this.operator===">="||this.operator===">")&&(K.operator==="<="||K.operator==="<"),Be=Z(this.semver,">",K.semver,he)&&(this.operator==="<="||this.operator==="<")&&(K.operator===">="||K.operator===">");return Ie||Re||Ue&&Ae||ze||Be},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(K){return K.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(K){var he=this.loose;K=K.trim(),n("range",K,he);var me=he?P[U]:P[W];K=K.replace(me,De),n("hyphen replace",K),K=K.replace(P[z],"$1$2$3"),n("comparator trim",K,P[z]),K=(K=(K=K.replace(P[F],"$1~")).replace(P[de],"$1^")).split(/\s+/).join(" ");var Ie=he?P[x]:P[G],Re=K.split(" ").map(function(Ue){return function(Ae,ze){return n("comp",Ae),Ae=function(Be,J){return Be.trim().split(/\s+/).map(function(ge){return function(ve,be){n("caret",ve,be);var Le=be?P[ue]:P[ae];return ve.replace(Le,function(Fe,_e,We,$e,He){var qe;return n("caret",ve,Fe,_e,We,$e,He),Pe(_e)?qe="":Pe(We)?qe=">="+_e+".0.0 <"+(+_e+1)+".0.0":Pe($e)?qe=_e==="0"?">="+_e+"."+We+".0 <"+_e+"."+(+We+1)+".0":">="+_e+"."+We+".0 <"+(+_e+1)+".0.0":He?(n("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),qe=_e==="0"?We==="0"?">="+_e+"."+We+"."+$e+He+" <"+_e+"."+We+"."+(+$e+1):">="+_e+"."+We+"."+$e+He+" <"+_e+"."+(+We+1)+".0":">="+_e+"."+We+"."+$e+He+" <"+(+_e+1)+".0.0"):(n("no pr"),qe=_e==="0"?We==="0"?">="+_e+"."+We+"."+$e+" <"+_e+"."+We+"."+(+$e+1):">="+_e+"."+We+"."+$e+" <"+_e+"."+(+We+1)+".0":">="+_e+"."+We+"."+$e+" <"+(+_e+1)+".0.0"),n("caret return",qe),qe})}(ge,J)}).join(" ")}(Ae,ze),n("caret",Ae),Ae=function(Be,J){return Be.trim().split(/\s+/).map(function(ge){return function(ve,be){var Le=be?P[se]:P[B];return ve.replace(Le,function(Fe,_e,We,$e,He){var qe;return n("tilde",ve,Fe,_e,We,$e,He),Pe(_e)?qe="":Pe(We)?qe=">="+_e+".0.0 <"+(+_e+1)+".0.0":Pe($e)?qe=">="+_e+"."+We+".0 <"+_e+"."+(+We+1)+".0":He?(n("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),qe=">="+_e+"."+We+"."+$e+He+" <"+_e+"."+(+We+1)+".0"):qe=">="+_e+"."+We+"."+$e+" <"+_e+"."+(+We+1)+".0",n("tilde return",qe),qe})}(ge,J)}).join(" ")}(Ae,ze),n("tildes",Ae),Ae=function(Be,J){return n("replaceXRanges",Be,J),Be.split(/\s+/).map(function(ge){return function(ve,be){ve=ve.trim();var Le=be?P[C]:P[M];return ve.replace(Le,function(Fe,_e,We,$e,He,qe){n("xRange",ve,Fe,_e,We,$e,He,qe);var Je=Pe(We),Ye=Je||Pe($e),tt=Ye||Pe(He);return _e==="="&&tt&&(_e=""),Je?Fe=_e===">"||_e==="<"?"<0.0.0":"*":_e&&tt?(Ye&&($e=0),tt&&(He=0),_e===">"?(_e=">=",Ye?(We=+We+1,$e=0,He=0):tt&&($e=+$e+1,He=0)):_e==="<="&&(_e="<",Ye?We=+We+1:$e=+$e+1),Fe=_e+We+"."+$e+"."+He):Ye?Fe=">="+We+".0.0 <"+(+We+1)+".0.0":tt&&(Fe=">="+We+"."+$e+".0 <"+We+"."+(+$e+1)+".0"),n("xRange return",Fe),Fe})}(ge,J)}).join(" ")}(Ae,ze),n("xrange",Ae),Ae=function(Be,J){return n("replaceStars",Be,J),Be.trim().replace(P[$],"")}(Ae,ze),n("stars",Ae),Ae}(Ue,he)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Ue){return!!Ue.match(Ie)})),Re=Re.map(function(Ue){return new Q(Ue,he)})},pe.prototype.intersects=function(K,he){if(!(K instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Ie){return K.set.some(function(Re){return Re.every(function(Ue){return Ie.intersects(Ue,he)})})})})},e.toComparators=function(K,he){return new pe(K,he).set.map(function(me){return me.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(K){if(!K)return!1;typeof K=="string"&&(K=new ce(K,this.loose));for(var he=0;he<this.set.length;he++)if(Te(this.set[he],K))return!0;return!1},e.satisfies=ye,e.maxSatisfying=function(K,he,me){var Ie=null,Re=null;try{var Ue=new pe(he,me)}catch{return null}return K.forEach(function(Ae){Ue.test(Ae)&&(Ie&&Re.compare(Ae)!==-1||(Re=new ce(Ie=Ae,me)))}),Ie},e.minSatisfying=function(K,he,me){var Ie=null,Re=null;try{var Ue=new pe(he,me)}catch{return null}return K.forEach(function(Ae){Ue.test(Ae)&&(Ie&&Re.compare(Ae)!==1||(Re=new ce(Ie=Ae,me)))}),Ie},e.validRange=function(K,he){try{return new pe(K,he).range||"*"}catch{return null}},e.ltr=function(K,he,me){return we(K,he,"<",me)},e.gtr=function(K,he,me){return we(K,he,">",me)},e.outside=we,e.prerelease=function(K,he){var me=oe(K,he);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(K,he,me){return K=new pe(K,me),he=new pe(he,me),K.intersects(he)},e.coerce=function(K){if(K instanceof ce)return K;if(typeof K!="string")return null;var he=K.match(P[L]);return he==null?null:oe((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,E(1))},function(H,e){var E,A,n=H.exports={};function _(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(c){if(E===setTimeout)return setTimeout(c,0);if((E===_||!E)&&setTimeout)return E=setTimeout,setTimeout(c,0);try{return E(c,0)}catch{try{return E.call(null,c,0)}catch{return E.call(this,c,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:_}catch{E=_}try{A=typeof clearTimeout=="function"?clearTimeout:D}catch{A=D}})();var h,d=[],m=!1,g=-1;function S(){m&&h&&(m=!1,h.length?d=h.concat(d):g=-1,d.length&&u())}function u(){if(!m){var c=P(S);m=!0;for(var f=d.length;f;){for(h=d,d=[];++g<f;)h&&h[g].run();g=-1,f=d.length}h=null,m=!1,function(l){if(A===clearTimeout)return clearTimeout(l);if((A===D||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(l);try{A(l)}catch{try{return A.call(null,l)}catch{return A.call(this,l)}}}(c)}}function y(c,f){this.fun=c,this.array=f}function b(){}n.nextTick=function(c){var f=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)f[l-1]=arguments[l];d.push(new y(c,f)),d.length!==1||m||P(u)},y.prototype.run=function(){this.fun.apply(null,this.array)},n.title="browser",n.browser=!0,n.env={},n.argv=[],n.version="",n.versions={},n.on=b,n.addListener=b,n.once=b,n.off=b,n.removeListener=b,n.removeAllListeners=b,n.emit=b,n.prependListener=b,n.prependOnceListener=b,n.listeners=function(c){return[]},n.binding=function(c){throw new Error("process.binding is not supported")},n.cwd=function(){return"/"},n.chdir=function(c){throw new Error("process.chdir is not supported")},n.umask=function(){return 0}}])}),define(ee[139],te([0,1]),function(H,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class A{constructor(P,h,d){this.level=P,this.key=h,this.value=d,this.forward=[]}}const n=void 0;class _{constructor(P,h=2**16){this.comparator=P,this[E]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new A(this._maxLevel,n,n)}get size(){return this._size}clear(){this._header=new A(this._maxLevel,n,n)}has(P){return!!_._search(this,P,this.comparator)}get(P){return _._search(this,P,this.comparator)?.value}set(P,h){return _._insert(this,P,h,this.comparator)&&(this._size+=1),this}delete(P){const h=_._delete(this,P,this.comparator);return h&&(this._size-=1),h}forEach(P,h){let d=this._header.forward[0];for(;d;)P.call(h,d.value,d.key,this),d=d.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",h=this._header.forward[0];for(;h;)P+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return P}static _search(P,h,d){let m=P._header;for(let g=P._level-1;g>=0;g--)for(;m.forward[g]&&d(m.forward[g].key,h)<0;)m=m.forward[g];if(m=m.forward[0],m&&d(m.key,h)===0)return m}static _insert(P,h,d,m){const g=[];let S=P._header;for(let u=P._level-1;u>=0;u--){for(;S.forward[u]&&m(S.forward[u].key,h)<0;)S=S.forward[u];g[u]=S}if(S=S.forward[0],S&&m(S.key,h)===0)return S.value=d,!1;{const u=_._randomLevel(P);if(u>P._level){for(let y=P._level;y<u;y++)g[y]=P._header;P._level=u}S=new A(u,h,d);for(let y=0;y<u;y++)S.forward[y]=g[y].forward[y],g[y].forward[y]=S;return!0}}static _randomLevel(P,h=.5){let d=1;for(;Math.random()<h&&d<P._maxLevel;)d+=1;return d}static _delete(P,h,d){const m=[];let g=P._header;for(let S=P._level-1;S>=0;S--){for(;g.forward[S]&&d(g.forward[S].key,h)<0;)g=g.forward[S];m[S]=g}if(g=g.forward[0],!g||d(g.key,h)!==0)return!1;for(let S=0;S<P._level&&m[S].forward[S]===g;S++)m[S].forward[S]=g.forward[S];for(;P._level>0&&P._header.forward[P._level-1]===n;)P._level-=1;return!0}}e.SkipList=_}),define(ee[69],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(_){return new A(_)}constructor(_){this._now=E&&_===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=A}),define(ee[3],te([0,1,13,49,2,102,69]),function(H,e,E,A,n,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,h=!1;var d;(function(M){M.None=()=>n.Disposable.None;function C(le){if(h){const{onDidAddListener:j}=le,Z=y.create();let Q=0;le.onDidAddListener=()=>{++Q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),j?.()}}}function L(le,j){return x(le,()=>{},0,void 0,!0,void 0,j)}M.defer=L;function T(le){return(j,Z=null,Q)=>{let fe=!1,pe;return pe=le(Pe=>{if(!fe)return pe?pe.dispose():fe=!0,j.call(Z,Pe)},null,Q),fe&&pe.dispose(),pe}}M.once=T;function F(le,j,Z){return ue((Q,fe=null,pe)=>le(Pe=>Q.call(fe,j(Pe)),null,pe),Z)}M.map=F;function B(le,j,Z){return ue((Q,fe=null,pe)=>le(Pe=>{j(Pe),Q.call(fe,Pe)},null,pe),Z)}M.forEach=B;function se(le,j,Z){return ue((Q,fe=null,pe)=>le(Pe=>j(Pe)&&Q.call(fe,Pe),null,pe),Z)}M.filter=se;function ie(le){return le}M.signal=ie;function de(...le){return(j,Z=null,Q)=>(0,n.combinedDisposable)(...le.map(fe=>fe(pe=>j.call(Z,pe),null,Q)))}M.any=de;function ae(le,j,Z,Q){let fe=Z;return F(le,pe=>(fe=j(fe,pe),fe),Q)}M.reduce=ae;function ue(le,j){let Z;const Q={onWillAddFirstListener(){Z=le(fe.fire,fe)},onDidRemoveLastListener(){Z?.dispose()}};j||C(Q);const fe=new v(Q);return j?.add(fe),fe.event}function x(le,j,Z=100,Q=!1,fe=!1,pe,Pe){let De,Te,ye,we=0,K;const he={leakWarningThreshold:pe,onWillAddFirstListener(){De=le(Ie=>{we++,Te=j(Te,Ie),Q&&!ye&&(me.fire(Te),Te=void 0),K=()=>{const Re=Te;Te=void 0,ye=void 0,(!Q||we>1)&&me.fire(Re),we=0},typeof Z=="number"?(clearTimeout(ye),ye=setTimeout(K,Z)):ye===void 0&&(ye=0,queueMicrotask(K))})},onWillRemoveListener(){fe&&we>0&&K?.()},onDidRemoveLastListener(){K=void 0,De.dispose()}};Pe||C(he);const me=new v(he);return Pe?.add(me),me.event}M.debounce=x;function G(le,j=0,Z){return M.debounce(le,(Q,fe)=>Q?(Q.push(fe),Q):[fe],j,void 0,!0,void 0,Z)}M.accumulate=G;function z(le,j=(Q,fe)=>Q===fe,Z){let Q=!0,fe;return se(le,pe=>{const Pe=Q||!j(pe,fe);return Q=!1,fe=pe,Pe},Z)}M.latch=z;function W(le,j,Z){return[M.filter(le,j,Z),M.filter(le,Q=>!j(Q),Z)]}M.split=W;function U(le,j=!1,Z=[]){let Q=Z.slice(),fe=le(De=>{Q?Q.push(De):Pe.fire(De)});const pe=()=>{Q?.forEach(De=>Pe.fire(De)),Q=null},Pe=new v({onWillAddFirstListener(){fe||(fe=le(De=>Pe.fire(De)))},onDidAddFirstListener(){Q&&(j?setTimeout(pe):pe())},onDidRemoveLastListener(){fe&&fe.dispose(),fe=null}});return Pe.event}M.buffer=U;class ${constructor(j){this.event=j,this.disposables=new n.DisposableStore}map(j){return new $(F(this.event,j,this.disposables))}forEach(j){return new $(B(this.event,j,this.disposables))}filter(j){return new $(se(this.event,j,this.disposables))}reduce(j,Z){return new $(ae(this.event,j,Z,this.disposables))}latch(){return new $(z(this.event,void 0,this.disposables))}debounce(j,Z=100,Q=!1,fe=!1,pe){return new $(x(this.event,j,Z,Q,fe,pe,this.disposables))}on(j,Z,Q){return this.event(j,Z,Q)}once(j,Z,Q){return T(this.event)(j,Z,Q)}dispose(){this.disposables.dispose()}}function X(le){return new $(le)}M.chain=X;function oe(le,j,Z=Q=>Q){const Q=(...De)=>Pe.fire(Z(...De)),fe=()=>le.on(j,Q),pe=()=>le.removeListener(j,Q),Pe=new v({onWillAddFirstListener:fe,onDidRemoveLastListener:pe});return Pe.event}M.fromNodeEventEmitter=oe;function ce(le,j,Z=Q=>Q){const Q=(...De)=>Pe.fire(Z(...De)),fe=()=>le.addEventListener(j,Q),pe=()=>le.removeEventListener(j,Q),Pe=new v({onWillAddFirstListener:fe,onDidRemoveLastListener:pe});return Pe.event}M.fromDOMEventEmitter=ce;function V(le){return new Promise(j=>T(le)(j))}M.toPromise=V;function R(le){const j=new v;return le.then(Z=>{j.fire(Z)},()=>{j.fire(void 0)}).finally(()=>{j.dispose()}),j.event}M.fromPromise=R;function O(le,j){return j(void 0),le(Z=>j(Z))}M.runAndSubscribe=O;function N(le,j){let Z=null;function Q(pe){Z?.dispose(),Z=new n.DisposableStore,j(pe,Z)}Q(void 0);const fe=le(pe=>Q(pe));return(0,n.toDisposable)(()=>{fe.dispose(),Z?.dispose()})}M.runAndSubscribeWithStore=N;class q{constructor(j,Z){this._observable=j,this._counter=0,this._hasChanged=!1;const Q={onWillAddFirstListener:()=>{j.addObserver(this)},onDidRemoveLastListener:()=>{j.removeObserver(this)}};Z||C(Q),this.emitter=new v(Q),Z&&Z.add(this.emitter)}beginUpdate(j){this._counter++}handlePossibleChange(j){}handleChange(j,Z){this._hasChanged=!0}endUpdate(j){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function re(le,j){return new q(le,j).emitter.event}M.fromObservable=re;function ne(le){return j=>{let Z=0,Q=!1;const fe={beginUpdate(){Z++},endUpdate(){Z--,Z===0&&(le.reportChanges(),Q&&(Q=!1,j()))},handlePossibleChange(){},handleChange(){Q=!0}};return le.addObserver(fe),le.reportChanges(),{dispose(){le.removeObserver(fe)}}}}M.fromObservableLight=ne})(d||(e.Event=d={}));class m{static{this.all=new Set}static{this._idPool=0}constructor(C){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${C}_${m._idPool++}`,m.all.add(this)}start(C){this._stopWatch=new D.StopWatch,this.listenerCount=C}stop(){if(this._stopWatch){const C=this._stopWatch.elapsed();this.durations.push(C),this.elapsedOverall+=C,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=m;let g=-1;function S(M){const C=g;return g=M,{dispose(){g=C}}}e.setGlobalLeakWarningThreshold=S;class u{constructor(C,L=Math.random().toString(18).slice(2,5)){this.threshold=C,this.name=L,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(C,L){const T=this.threshold;if(T<=0||L<T)return;this._stacks||(this._stacks=new Map);const F=this._stacks.get(C.value)||0;if(this._stacks.set(C.value,F+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=T*.5;let B,se=0;for(const[ie,de]of this._stacks)(!B||se<de)&&(B=ie,se=de);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${se}):`),console.warn(B)}return()=>{const B=this._stacks.get(C.value)||0;this._stacks.set(C.value,B-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(C){this.value=C}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let b=0;class c{constructor(C){this.value=C,this.id=b++}}const f=2,l=(M,C)=>{if(M instanceof c)C(M);else for(let L=0;L<M.length;L++){const T=M[L];T&&C(T)}};class v{constructor(C){this._size=0,this._options=C,this._leakageMon=g>0||this._options?.leakWarningThreshold?new u(this._options?.leakWarningThreshold??g):void 0,this._perfMon=this._options?._profName?new m(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(P){const C=this._listeners;queueMicrotask(()=>{l(C,L=>L.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(C,L,T)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.Disposable.None;if(this._disposed)return n.Disposable.None;L&&(C=C.bind(L));const F=new c(C);let B,se;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(F.stack=y.create(),B=this._leakageMon.check(F.stack,this._size+1)),P&&(F.stack=se??y.create()),this._listeners?this._listeners instanceof c?(this._deliveryQueue??=new p,this._listeners=[this._listeners,F]):this._listeners.push(F):(this._options?.onWillAddFirstListener?.(this),this._listeners=F,this._options?.onDidAddFirstListener?.(this)),this._size++;const ie=(0,n.toDisposable)(()=>{B?.(),this._removeListener(F)});return T instanceof n.DisposableStore?T.add(ie):Array.isArray(T)&&T.push(ie),ie},this._event}_removeListener(C){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const L=this._listeners,T=L.indexOf(C);if(T===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,L[T]=void 0;const F=this._deliveryQueue.current===this;if(this._size*f<=L.length){let B=0;for(let se=0;se<L.length;se++)L[se]?L[B++]=L[se]:F&&(this._deliveryQueue.end--,B<this._deliveryQueue.i&&this._deliveryQueue.i--);L.length=B}}_deliver(C,L){if(!C)return;const T=this._options?.onListenerError||E.onUnexpectedError;if(!T){C.value(L);return}try{C.value(L)}catch(F){T(F)}}_deliverQueue(C){const L=C.current._listeners;for(;C.i<C.end;)this._deliver(L[C.i++],C.value);C.reset()}fire(C){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof c)this._deliver(this._listeners,C);else{const L=this._deliveryQueue;L.enqueue(this,C,this._listeners.length),this._deliverQueue(L)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=v;const I=()=>new p;e.createEventDeliveryQueue=I;class p{constructor(){this.i=-1,this.end=0}enqueue(C,L,T){this.i=0,this.end=T,this.current=C,this.value=L}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends v{async fireAsync(C,L,T){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList),l(this._listeners,F=>this._asyncDeliveryQueue.push([F.value,C]));this._asyncDeliveryQueue.size>0&&!L.isCancellationRequested;){const[F,B]=this._asyncDeliveryQueue.shift(),se=[],ie={...B,token:L,waitUntil:de=>{if(Object.isFrozen(se))throw new Error("waitUntil can NOT be called asynchronous");T&&(de=T(de,F)),se.push(de)}};try{F(ie)}catch(de){(0,E.onUnexpectedError)(de);continue}Object.freeze(se),await Promise.allSettled(se).then(de=>{for(const ae of de)ae.status==="rejected"&&(0,E.onUnexpectedError)(ae.reason)})}}}e.AsyncEmitter=t;class a extends v{get isPaused(){return this._isPaused!==0}constructor(C){super(C),this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=C?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const C=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(C))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(C){this._size&&(this._isPaused!==0?this._eventQueue.push(C):super.fire(C))}}e.PauseableEmitter=a;class s extends a{constructor(C){super(C),this._delay=C.delay??100}fire(C){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(C)}}e.DebounceEmitter=s;class i extends v{constructor(C){super(C),this._queuedEvents=[],this._mergeFn=C?.merge}fire(C){this.hasListeners()&&(this._queuedEvents.push(C),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(L=>super.fire(L)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=i;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(C){const L={event:C,listener:null};this.events.push(L),this.hasListeners&&this.hook(L);const T=()=>{this.hasListeners&&this.unhook(L);const F=this.events.indexOf(L);this.events.splice(F,1)};return(0,n.toDisposable)((0,A.once)(T))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(C=>this.hook(C))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(C=>this.unhook(C))}hook(C){C.listener=C.event(L=>this.emitter.fire(L))}unhook(C){C.listener&&C.listener.dispose(),C.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class o{constructor(C,L,T,F){this._store=new n.DisposableStore;const B=this._store.add(new r),se=this._store.add(new n.DisposableMap);function ie(de){se.set(de,B.add(F(de)))}for(const de of C)ie(de);this._store.add(L(de=>{ie(de)})),this._store.add(T(de=>{se.deleteAndDispose(de)})),this.event=B.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=o;class w{constructor(){this.buffers=[]}wrapEvent(C){return(L,T,F)=>C(B=>{const se=this.buffers[this.buffers.length-1];se?se.push(()=>L.call(T,B)):L.call(T,B)},void 0,F)}bufferEvents(C){const L=[];this.buffers.push(L);const T=C();return this.buffers.pop(),L.forEach(F=>F()),T}}e.EventBufferer=w;class k{constructor(){this.listening=!1,this.inputEvent=d.None,this.inputEventListener=n.Disposable.None,this.emitter=new v({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(C){this.inputEvent=C,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=C(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=k}),define(ee[23],te([0,1,3]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(P,h){const d=setTimeout(P.bind(h),0);return{dispose(){clearTimeout(d)}}});var n;(function(P){function h(d){return d===P.None||d===P.Cancelled||d instanceof _?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}P.isCancellationToken=h,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(n||(e.CancellationToken=n={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=n.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=n.None}}e.CancellationTokenSource=D}),define(ee[140],te([0,1,23]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new E.CancellationTokenSource,h=this.task(P.token);return this.result={promise:h,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=A;class n{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const h=JSON.stringify(P);return this.lastArgKey!==h&&(this.lastArgKey=h,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=n;class _{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const h=this.fn(P);return this._map.set(P,h),h}}e.CachedFunction=_}),define(ee[56],te([0,1,13,2]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function n(I){const p=I;return p?typeof p.read=="function":!1}e.isReadable=n;function _(I){const p=I;return p?[p.on,p.pause,p.resume,p.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=_;function D(I){const p=I;return p?_(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=D;function P(I,p){return new h(I,p)}e.newWriteableStream=P;class h{constructor(p,t){this.reducer=p,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p<"u"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(t=>t(p))}emitError(p){this.listeners.error.length===0?(0,E.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(t=>t(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,t){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(p,t){if(this.state.destroyed)return;let a;switch(p){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const s=a.indexOf(t);s>=0&&a.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(I,p){const t=[];let a;for(;(a=I.read())!==null;)t.push(a);return p(t)}e.consumeReadable=d;function m(I,p,t){const a=[];let s;for(;(s=I.read())!==null&&a.length<t;)a.push(s);return s===null&&a.length>0?p(a):{read:()=>{if(a.length>0)return a.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return I.read()}}}e.peekReadable=m;function g(I,p){return new Promise((t,a)=>{const s=[];S(I,{onData:i=>{p&&s.push(i)},onError:i=>{p?a(i):t(void 0)},onEnd:()=>{t(p?p(s):void 0)}})})}e.consumeStream=g;function S(I,p,t){I.on("error",a=>{t?.isCancellationRequested||p.onError(a)}),I.on("end",()=>{t?.isCancellationRequested||p.onEnd()}),I.on("data",a=>{t?.isCancellationRequested||p.onData(a)})}e.listenStream=S;function u(I,p){return new Promise((t,a)=>{const s=new A.DisposableStore,i=[],r=k=>{if(i.push(k),i.length>p)return s.dispose(),I.pause(),t({stream:I,buffer:i,ended:!1})},o=k=>a(k),w=()=>t({stream:I,buffer:i,ended:!0});s.add((0,A.toDisposable)(()=>I.removeListener("error",o))),I.on("error",o),s.add((0,A.toDisposable)(()=>I.removeListener("end",w))),I.on("end",w),s.add((0,A.toDisposable)(()=>I.removeListener("data",r))),I.on("data",r)})}e.peekStream=u;function y(I,p){const t=P(p);return t.end(I),t}e.toStream=y;function b(){const I=P(()=>{throw new Error("not supported")});return I.end(),I}e.emptyStream=b;function c(I){let p=!1;return{read:()=>p?null:(p=!0,I)}}e.toReadable=c;function f(I,p,t){const a=P(t);return S(I,{onData:s=>a.write(p.data(s)),onError:s=>a.error(p.error?p.error(s):s),onEnd:()=>a.end()}),a}e.transform=f;function l(I,p,t){let a=!1;return{read:()=>{const s=p.read();return a?s:(a=!0,s!==null?t([I,s]):I)}}}e.prefixedReadable=l;function v(I,p,t){let a=!1;const s=P(t);return S(p,{onData:i=>a?s.write(i):(a=!0,s.write(t([I,i]))),onError:i=>s.error(i),onEnd:()=>{a||(a=!0,s.write(I)),s.end()}}),s}e.prefixedStream=v}),define(ee[17],te([0,1,85,56]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const n=typeof Buffer<"u",_=new E.Lazy(()=>new Uint8Array(256));let D,P;class h{static alloc(L){return n?new h(Buffer.allocUnsafe(L)):new h(new Uint8Array(L))}static wrap(L){return n&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new h(L)}static fromString(L,T){return!(T?.dontUseNodeBuffer||!1)&&n?new h(Buffer.from(L)):(D||(D=new TextEncoder),new h(D.encode(L)))}static fromByteArray(L){const T=h.alloc(L.length);for(let F=0,B=L.length;F<B;F++)T.buffer[F]=L[F];return T}static concat(L,T){if(typeof T>"u"){T=0;for(let se=0,ie=L.length;se<ie;se++)T+=L[se].byteLength}const F=h.alloc(T);let B=0;for(let se=0,ie=L.length;se<ie;se++){const de=L[se];F.set(de,B),B+=de.byteLength}return F}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=h.alloc(this.byteLength);return L.set(this),L}toString(){return n?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(L,T){return new h(this.buffer.subarray(L,T))}set(L,T){if(L instanceof h)this.buffer.set(L.buffer,T);else if(L instanceof Uint8Array)this.buffer.set(L,T);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),T);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return S(this.buffer,L)}writeUInt32BE(L,T){u(this.buffer,L,T)}readUInt32LE(L){return y(this.buffer,L)}writeUInt32LE(L,T){b(this.buffer,L,T)}readUInt8(L){return c(this.buffer,L)}writeUInt8(L,T){f(this.buffer,L,T)}indexOf(L,T=0){return d(this.buffer,L instanceof h?L.buffer:L,T)}}e.VSBuffer=h;function d(C,L,T=0){const F=L.byteLength,B=C.byteLength;if(F===0)return 0;if(F===1)return C.indexOf(L[0]);if(F>B-T)return-1;const se=_.value;se.fill(L.length);for(let ue=0;ue<L.length;ue++)se[L[ue]]=L.length-ue-1;let ie=T+L.length-1,de=ie,ae=-1;for(;ie<B;)if(C[ie]===L[de]){if(de===0){ae=ie;break}ie--,de--}else ie+=Math.max(L.length-de,se[C[ie]]),de=L.length-1;return ae}e.binaryIndexOf=d;function m(C,L){return C[L+0]<<0>>>0|C[L+1]<<8>>>0}e.readUInt16LE=m;function g(C,L,T){C[T+0]=L&255,L=L>>>8,C[T+1]=L&255}e.writeUInt16LE=g;function S(C,L){return C[L]*2**24+C[L+1]*2**16+C[L+2]*2**8+C[L+3]}e.readUInt32BE=S;function u(C,L,T){C[T+3]=L,L=L>>>8,C[T+2]=L,L=L>>>8,C[T+1]=L,L=L>>>8,C[T]=L}e.writeUInt32BE=u;function y(C,L){return C[L+0]<<0>>>0|C[L+1]<<8>>>0|C[L+2]<<16>>>0|C[L+3]<<24>>>0}e.readUInt32LE=y;function b(C,L,T){C[T+0]=L&255,L=L>>>8,C[T+1]=L&255,L=L>>>8,C[T+2]=L&255,L=L>>>8,C[T+3]=L&255}e.writeUInt32LE=b;function c(C,L){return C[L]}e.readUInt8=c;function f(C,L,T){C[T]=L}e.writeUInt8=f;function l(C){return A.consumeReadable(C,L=>h.concat(L))}e.readableToBuffer=l;function v(C){return A.toReadable(C)}e.bufferToReadable=v;function I(C){return A.consumeStream(C,L=>h.concat(L))}e.streamToBuffer=I;async function p(C){return C.ended?h.concat(C.buffer):h.concat([...C.buffer,await I(C.stream)])}e.bufferedStreamToBuffer=p;function t(C){return A.toStream(C,L=>h.concat(L))}e.bufferToStream=t;function a(C){return A.transform(C,{data:L=>typeof L=="string"?h.fromString(L):h.wrap(L)},L=>h.concat(L))}e.streamToBufferReadableStream=a;function s(C){return A.newWriteableStream(L=>h.concat(L),C)}e.newWriteableBufferStream=s;function i(C,L){return A.prefixedReadable(C,L,T=>h.concat(T))}e.prefixedBufferReadable=i;function r(C,L){return A.prefixedStream(C,L,T=>h.concat(T))}e.prefixedBufferStream=r;function o(C){let L=0,T=0,F=0;const B=new Uint8Array(Math.floor(C.length/4*3)),se=de=>{switch(T){case 3:B[F++]=L|de,T=0;break;case 2:B[F++]=L|de>>>2,L=de<<6,T=3;break;case 1:B[F++]=L|de>>>4,L=de<<4,T=2;break;default:L=de<<2,T=1}};for(let de=0;de<C.length;de++){const ae=C.charCodeAt(de);if(ae>=65&&ae<=90)se(ae-65);else if(ae>=97&&ae<=122)se(ae-97+26);else if(ae>=48&&ae<=57)se(ae-48+52);else if(ae===43||ae===45)se(62);else if(ae===47||ae===95)se(63);else{if(ae===61)break;throw new SyntaxError(`Unexpected base64 character ${C[de]}`)}}const ie=F;for(;T>0;)se(0);return h.wrap(B).slice(0,ie)}e.decodeBase64=o;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:C},L=!0,T=!1){const F=T?k:w;let B="";const se=C.byteLength%3;let ie=0;for(;ie<C.byteLength-se;ie+=3){const de=C[ie+0],ae=C[ie+1],ue=C[ie+2];B+=F[de>>>2],B+=F[(de<<4|ae>>>4)&63],B+=F[(ae<<2|ue>>>6)&63],B+=F[ue&63]}if(se===1){const de=C[ie+0];B+=F[de>>>2],B+=F[de<<4&63],L&&(B+="==")}else if(se===2){const de=C[ie+0],ae=C[ie+1];B+=F[de>>>2],B+=F[(de<<4|ae>>>4)&63],B+=F[ae<<2&63],L&&(B+="=")}return B}e.encodeBase64=M}),define(ee[26],te([0,1,140,85]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function n(J){return!J||typeof J!="string"?!0:J.trim().length===0}e.isFalsyOrWhitespace=n;const _=/{(\d+)}/g;function D(J,...ge){return ge.length===0?J:J.replace(_,function(ve,be){const Le=parseInt(be,10);return isNaN(Le)||Le<0||Le>=ge.length?ve:ge[Le]})}e.format=D;const P=/{([^}]+)}/g;function h(J,ge){return J.replace(P,(ve,be)=>ge[be]??ve)}e.format2=h;function d(J){return J.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.escape=d;function m(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=m;function g(J,ge){let ve=0;const be=ge.charCodeAt(0);for(let Le=J.length-1;Le>=0;Le--)J.charCodeAt(Le)===be&&ve++;return ve}e.count=g;function S(J,ge,ve="\u2026"){return J.length<=ge?J:`${J.substr(0,ge)}${ve}`}e.truncate=S;function u(J,ge=" "){const ve=y(J,ge);return b(ve,ge)}e.trim=u;function y(J,ge){if(!J||!ge)return J;const ve=ge.length;if(ve===0||J.length===0)return J;let be=0;for(;J.indexOf(ge,be)===be;)be=be+ve;return J.substring(be)}e.ltrim=y;function b(J,ge){if(!J||!ge)return J;const ve=ge.length,be=J.length;if(ve===0||be===0)return J;let Le=be,Fe=-1;for(;Fe=J.lastIndexOf(ge,Le-1),!(Fe===-1||Fe+ve!==Le);){if(Fe===0)return"";Le=Fe}return J.substring(0,Le)}e.rtrim=b;function c(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function f(J){return J.replace(/\*/g,"")}e.stripWildcards=f;function l(J,ge,ve={}){if(!J)throw new Error("Cannot create regex from empty string");ge||(J=m(J)),ve.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let be="";return ve.global&&(be+="g"),ve.matchCase||(be+="i"),ve.multiline&&(be+="m"),ve.unicode&&(be+="u"),new RegExp(J,be)}e.createRegExp=l;function v(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function I(J){return J.split(/\r\n|\r|\n/)}e.splitLines=I;function p(J){for(let ge=0,ve=J.length;ge<ve;ge++){const be=J.charCodeAt(ge);if(be!==32&&be!==9)return ge}return-1}e.firstNonWhitespaceIndex=p;function t(J,ge=0,ve=J.length){for(let be=ge;be<ve;be++){const Le=J.charCodeAt(be);if(Le!==32&&Le!==9)return J.substring(ge,be)}return J.substring(ge,ve)}e.getLeadingWhitespace=t;function a(J,ge=J.length-1){for(let ve=ge;ve>=0;ve--){const be=J.charCodeAt(ve);if(be!==32&&be!==9)return ve}return-1}e.lastNonWhitespaceIndex=a;function s(J,ge,ve){const be=[];let Le=0;for(const Fe of J.matchAll(ge)){if(be.push(J.slice(Le,Fe.index)),Fe.index===void 0)throw new Error("match.index should be defined");Le=Fe.index+Fe[0].length,be.push(ve(Fe[0],...Fe.slice(1),Fe.index,J,Fe.groups))}return be.push(J.slice(Le)),Promise.all(be).then(Fe=>Fe.join(""))}e.replaceAsync=s;function i(J,ge){return J<ge?-1:J>ge?1:0}e.compare=i;function r(J,ge,ve=0,be=J.length,Le=0,Fe=ge.length){for(;ve<be&&Le<Fe;ve++,Le++){const $e=J.charCodeAt(ve),He=ge.charCodeAt(Le);if($e<He)return-1;if($e>He)return 1}const _e=be-ve,We=Fe-Le;return _e<We?-1:_e>We?1:0}e.compareSubstring=r;function o(J,ge){return w(J,ge,0,J.length,0,ge.length)}e.compareIgnoreCase=o;function w(J,ge,ve=0,be=J.length,Le=0,Fe=ge.length){for(;ve<be&&Le<Fe;ve++,Le++){let $e=J.charCodeAt(ve),He=ge.charCodeAt(Le);if($e===He)continue;if($e>=128||He>=128)return r(J.toLowerCase(),ge.toLowerCase(),ve,be,Le,Fe);M($e)&&($e-=32),M(He)&&(He-=32);const qe=$e-He;if(qe!==0)return qe}const _e=be-ve,We=Fe-Le;return _e<We?-1:_e>We?1:0}e.compareSubstringIgnoreCase=w;function k(J){return J>=48&&J<=57}e.isAsciiDigit=k;function M(J){return J>=97&&J<=122}e.isLowerAsciiLetter=M;function C(J){return J>=65&&J<=90}e.isUpperAsciiLetter=C;function L(J,ge){return J.length===ge.length&&w(J,ge)===0}e.equalsIgnoreCase=L;function T(J,ge){const ve=ge.length;return ge.length>J.length?!1:w(J,ge,0,ve)===0}e.startsWithIgnoreCase=T;function F(J,ge){const ve=Math.min(J.length,ge.length);let be;for(be=0;be<ve;be++)if(J.charCodeAt(be)!==ge.charCodeAt(be))return be;return ve}e.commonPrefixLength=F;function B(J,ge){const ve=Math.min(J.length,ge.length);let be;const Le=J.length-1,Fe=ge.length-1;for(be=0;be<ve;be++)if(J.charCodeAt(Le-be)!==ge.charCodeAt(Fe-be))return be;return ve}e.commonSuffixLength=B;function se(J){return 55296<=J&&J<=56319}e.isHighSurrogate=se;function ie(J){return 56320<=J&&J<=57343}e.isLowSurrogate=ie;function de(J,ge){return(J-55296<<10)+(ge-56320)+65536}e.computeCodePoint=de;function ae(J,ge,ve){const be=J.charCodeAt(ve);if(se(be)&&ve+1<ge){const Le=J.charCodeAt(ve+1);if(ie(Le))return de(be,Le)}return be}e.getNextCodePoint=ae;function ue(J,ge){const ve=J.charCodeAt(ge-1);if(ie(ve)&&ge>1){const be=J.charCodeAt(ge-2);if(se(be))return de(be,ve)}return ve}class x{get offset(){return this._offset}constructor(ge,ve=0){this._str=ge,this._len=ge.length,this._offset=ve}setOffset(ge){this._offset=ge}prevCodePoint(){const ge=ue(this._str,this._offset);return this._offset-=ge>=65536?2:1,ge}nextCodePoint(){const ge=ae(this._str,this._len,this._offset);return this._offset+=ge>=65536?2:1,ge}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class G{get offset(){return this._iterator.offset}constructor(ge,ve=0){this._iterator=new x(ge,ve)}nextGraphemeLength(){const ge=he.getInstance(),ve=this._iterator,be=ve.offset;let Le=ge.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const Fe=ve.offset,_e=ge.getGraphemeBreakType(ve.nextCodePoint());if(we(Le,_e)){ve.setOffset(Fe);break}Le=_e}return ve.offset-be}prevGraphemeLength(){const ge=he.getInstance(),ve=this._iterator,be=ve.offset;let Le=ge.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const Fe=ve.offset,_e=ge.getGraphemeBreakType(ve.prevCodePoint());if(we(_e,Le)){ve.setOffset(Fe);break}Le=_e}return be-ve.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=G;function z(J,ge){return new G(J,ge).nextGraphemeLength()}e.nextCharLength=z;function W(J,ge){return new G(J,ge).prevGraphemeLength()}e.prevCharLength=W;function U(J,ge){ge>0&&ie(J.charCodeAt(ge))&&ge--;const ve=ge+z(J,ge);return[ve-W(J,ve),ve]}e.getCharContainingOffset=U;function $(J){const ge=new G(J);let ve=0;for(;!ge.eol();)ve++,ge.nextGraphemeLength();return ve}e.charCount=$;let X;function oe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ce(J){return X||(X=oe()),X.test(J)}e.containsRTL=ce;const V=/^[\t\n\r\x20-\x7E]*$/;function R(J){return V.test(J)}e.isBasicASCII=R,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function O(J){return e.UNUSUAL_LINE_TERMINATORS.test(J)}e.containsUnusualLineTerminators=O;function N(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}e.isFullWidthCharacter=N;function q(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}e.isEmojiImprecise=q;function re(J,ge){if(J.length<ge)return J;const ve=/\b/g;let be=0;for(;ve.test(J)&&!(J.length-ve.lastIndex<ge);)be=ve.lastIndex,ve.lastIndex+=1;return J.substring(be).replace(/^\s/,"")}e.lcut=re;const ne=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,le=/\x1b\].*?\x07/g;function j(J){return J&&(J=J.replace(ne,"").replace(le,"")),J}e.removeAnsiEscapeCodes=j,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Z(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Z;function Q(J){return Z(J)?J.substr(1):J}e.stripUTF8BOM=Q;function fe(J,ge){if(!J||!ge||J.length<ge.length)return!1;const ve=ge.length,be=J.toLowerCase();let Le=0,Fe=-1;for(;Le<ve;){const _e=be.indexOf(ge[Le],Fe+1);if(_e<0)return!1;Fe=_e,Le++}return!0}e.fuzzyContains=fe;function pe(J,ge=!1){return J?(ge&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}e.containsUppercaseCharacter=pe;function Pe(J){return J.charAt(0).toUpperCase()+J.slice(1)}e.uppercaseFirstLetter=Pe;function De(J,ge=1){if(ge===0)return"";let ve=-1;do ve=J.indexOf(`
`,ve+1),ge--;while(ge>0&&ve>=0);return ve===-1?J:(J[ve-1]==="\r"&&ve--,J.substr(0,ve))}e.getNLines=De;function Te(J){return J=J%(2*26),J<26?String.fromCharCode(97+J):String.fromCharCode(65+J-26)}e.singleLetterHash=Te;function ye(J){return he.getInstance().getGraphemeBreakType(J)}e.getGraphemeBreakType=ye;function we(J,ge){return J===0?ge!==5&&ge!==7:J===2&&ge===3?!1:J===4||J===2||J===3||ge===4||ge===2||ge===3?!0:!(J===8&&(ge===8||ge===9||ge===11||ge===12)||(J===11||J===9)&&(ge===9||ge===10)||(J===12||J===10)&&ge===10||ge===5||ge===13||ge===7||J===1||J===13&&ge===14||J===6&&ge===6)}var K;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(K||(e.GraphemeBreakType=K={}));class he{static{this._INSTANCE=null}static getInstance(){return he._INSTANCE||(he._INSTANCE=new he),he._INSTANCE}constructor(){this._data=me()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const ve=this._data,be=ve.length/3;let Le=1;for(;Le<=be;)if(ge<ve[3*Le])Le=2*Le;else if(ge>ve[3*Le+1])Le=2*Le+1;else return ve[3*Le+2];return 0}}function me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ie(J,ge){if(J===0)return 0;const ve=Re(J,ge);if(ve!==void 0)return ve;const be=new x(ge,J);return be.prevCodePoint(),be.offset}e.getLeftDeleteOffset=Ie;function Re(J,ge){const ve=new x(ge,J);let be=ve.prevCodePoint();for(;Ue(be)||be===65039||be===8419;){if(ve.offset===0)return;be=ve.prevCodePoint()}if(!q(be))return;let Le=ve.offset;return Le>0&&ve.prevCodePoint()===8205&&(Le=ve.offset),Le}function Ue(J){return 127995<=J&&J<=127999}var Ae;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={})),e.noBreakWhitespace="\xA0";class ze{static{this.ambiguousCharacterData=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new E.LRUCachedFunction(ge=>{function ve(qe){const Je=new Map;for(let Ye=0;Ye<qe.length;Ye+=2)Je.set(qe[Ye],qe[Ye+1]);return Je}function be(qe,Je){const Ye=new Map(qe);for(const[tt,nt]of Je)Ye.set(tt,nt);return Ye}function Le(qe,Je){if(!qe)return Je;const Ye=new Map;for(const[tt,nt]of qe)Je.has(tt)&&Ye.set(tt,nt);return Ye}const Fe=this.ambiguousCharacterData.value;let _e=ge.filter(qe=>!qe.startsWith("_")&&qe in Fe);_e.length===0&&(_e=["_default"]);let We;for(const qe of _e){const Je=ve(Fe[qe]);We=Le(We,Je)}const $e=ve(Fe._common),He=be($e,We);return new ze(He)})}static getInstance(ge){return ze.cache.get(Array.from(ge))}static{this._locales=new A.Lazy(()=>Object.keys(ze.ambiguousCharacterData.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return ze._locales.value}constructor(ge){this.confusableDictionary=ge}isAmbiguous(ge){return this.confusableDictionary.has(ge)}getPrimaryConfusable(ge){return this.confusableDictionary.get(ge)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ze;class Be{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Be.getRawData())),this._data}static isInvisibleCharacter(ge){return Be.getData().has(ge)}static get codePoints(){return Be.getData()}}e.InvisibleCharacters=Be}),define(ee[57],te([0,1,26]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(f){return n(f,0)}e.hash=A;function n(f,l){switch(typeof f){case"object":return f===null?_(349,l):Array.isArray(f)?h(f,l):d(f,l);case"string":return P(f,l);case"boolean":return D(f,l);case"number":return _(f,l);case"undefined":return _(937,l);default:return _(617,l)}}e.doHash=n;function _(f,l){return(l<<5)-l+f|0}e.numberHash=_;function D(f,l){return _(f?433:863,l)}function P(f,l){l=_(149417,l);for(let v=0,I=f.length;v<I;v++)l=_(f.charCodeAt(v),l);return l}e.stringHash=P;function h(f,l){return l=_(104579,l),f.reduce((v,I)=>n(I,v),l)}function d(f,l){return l=_(181387,l),Object.keys(f).sort().reduce((v,I)=>(v=P(I,v),n(f[I],v)),l)}class m{constructor(){this._value=0}get value(){return this._value}hash(l){return this._value=n(l,this._value),this._value}}e.Hasher=m;var g;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(g||(g={}));function S(f,l,v=32){const I=v-l,p=~((1<<I)-1);return(f<<l|(p&f)>>>I)>>>0}function u(f,l=0,v=f.byteLength,I=0){for(let p=0;p<v;p++)f[l+p]=I}function y(f,l,v="0"){for(;f.length<l;)f=v+f;return f}function b(f,l=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(v=>v.toString(16).padStart(2,"0")).join(""):y((f>>>0).toString(16),l/4)}e.toHexString=b;class c{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(l){const v=l.length;if(v===0)return;const I=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,a,s;for(t!==0?(a=t,s=-1,t=0):(a=l.charCodeAt(0),s=0);;){let i=a;if(E.isHighSurrogate(a))if(s+1<v){const r=l.charCodeAt(s+1);E.isLowSurrogate(r)?(s++,i=E.computeCodePoint(a,r)):i=65533}else{t=a;break}else E.isLowSurrogate(a)&&(i=65533);if(p=this._push(I,p,i),s++,s<v)a=l.charCodeAt(s);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(l,v,I){return I<128?l[v++]=I:I<2048?(l[v++]=192|(I&1984)>>>6,l[v++]=128|(I&63)>>>0):I<65536?(l[v++]=224|(I&61440)>>>12,l[v++]=128|(I&4032)>>>6,l[v++]=128|(I&63)>>>0):(l[v++]=240|(I&1835008)>>>18,l[v++]=128|(I&258048)>>>12,l[v++]=128|(I&4032)>>>6,l[v++]=128|(I&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,u(this._buff,this._buffLen),this._buffLen>56&&(this._step(),u(this._buff));const l=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(l/4294967296),!1),this._buffDV.setUint32(60,l%4294967296,!1),this._step()}_step(){const l=c._bigBlock32,v=this._buffDV;for(let w=0;w<64;w+=4)l.setUint32(w,v.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)l.setUint32(w,S(l.getUint32(w-12,!1)^l.getUint32(w-32,!1)^l.getUint32(w-56,!1)^l.getUint32(w-64,!1),1),!1);let I=this._h0,p=this._h1,t=this._h2,a=this._h3,s=this._h4,i,r,o;for(let w=0;w<80;w++)w<20?(i=p&t|~p&a,r=1518500249):w<40?(i=p^t^a,r=1859775393):w<60?(i=p&t|p&a|t&a,r=2400959708):(i=p^t^a,r=3395469782),o=S(I,5)+i+s+r+l.getUint32(w*4,!1)&4294967295,s=a,a=t,t=S(p,30),p=I,I=o;this._h0=this._h0+I&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=c}),define(ee[70],te([0,1,26]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(n){n[n.Ignore=0]="Ignore",n[n.Info=1]="Info",n[n.Warning=2]="Warning",n[n.Error=3]="Error"})(A||(A={})),function(n){const _="error",D="warning",P="warn",h="info",d="ignore";function m(S){return S?E.equalsIgnoreCase(_,S)?n.Error:E.equalsIgnoreCase(D,S)||E.equalsIgnoreCase(P,S)?n.Warning:E.equalsIgnoreCase(h,S)?n.Info:n.Ignore:n.Ignore}n.fromValue=m;function g(S){switch(S){case n.Error:return _;case n.Warning:return D;case n.Info:return h;default:return d}}n.toString=g}(A||(A={})),e.default=A}),define(ee[141],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ee[58],te([0,1,24,26]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class n{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const y=u.charCodeAt(0),b=this._value.charCodeAt(this._pos);return y-b}value(){return this._value[this._pos]}}e.StringIterator=n;class _{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,A.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class D{constructor(u=!0,y=!0){this._splitOnBackslash=u,this._caseSensitive=y}reset(u){this._from=0,this._to=0,this._value=u,this._valueLen=u.length;for(let y=u.length-1;y>=0;y--,this._valueLen--){const b=this._value.charCodeAt(y);if(!(b===47||this._splitOnBackslash&&b===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let u=!0;for(;this._to<this._valueLen;this._to++){const y=this._value.charCodeAt(this._to);if(y===47||this._splitOnBackslash&&y===92)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,A.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=D;var P;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(P||(P={}));class h{constructor(u,y){this._ignorePathCasing=u,this._ignoreQueryAndFragment=y,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new D(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(u)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===1)return(0,A.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,A.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===4)return(0,A.compare)(u,this._value.query);if(this._states[this._stateIdx]===5)return(0,A.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(m||(m={}));class g{static forUris(u=()=>!1,y=()=>!1){return new g(new h(u,y))}static forPaths(u=!1){return new g(new D(void 0,!u))}static forStrings(){return new g(new n)}static forConfigKeys(){return new g(new _)}constructor(u){this._iter=u}clear(){this._root=void 0}fill(u,y){if(y){const b=y.slice(0);(0,E.shuffle)(b);for(const c of b)this.set(c,u)}else{const b=u.slice(0);(0,E.shuffle)(b);for(const c of b)this.set(c[0],c[1])}}set(u,y){const b=this._iter.reset(u);let c;this._root||(this._root=new d,this._root.segment=b.value());const f=[];for(c=this._root;;){const v=b.cmp(c.segment);if(v>0)c.left||(c.left=new d,c.left.segment=b.value()),f.push([-1,c]),c=c.left;else if(v<0)c.right||(c.right=new d,c.right.segment=b.value()),f.push([1,c]),c=c.right;else if(b.hasNext())b.next(),c.mid||(c.mid=new d,c.mid.segment=b.value()),f.push([0,c]),c=c.mid;else break}const l=c.value;c.value=y,c.key=u;for(let v=f.length-1;v>=0;v--){const I=f[v][1];I.updateHeight();const p=I.balanceFactor();if(p<-1||p>1){const t=f[v][0],a=f[v+1][0];if(t===1&&a===1)f[v][1]=I.rotateLeft();else if(t===-1&&a===-1)f[v][1]=I.rotateRight();else if(t===1&&a===-1)I.right=f[v+1][1]=f[v+1][1].rotateRight(),f[v][1]=I.rotateLeft();else if(t===-1&&a===1)I.left=f[v+1][1]=f[v+1][1].rotateLeft(),f[v][1]=I.rotateRight();else throw new Error;if(v>0)switch(f[v-1][0]){case-1:f[v-1][1].left=f[v][1];break;case 1:f[v-1][1].right=f[v][1];break;case 0:f[v-1][1].mid=f[v][1];break}else this._root=f[0][1]}}return l}get(u){return this._getNode(u)?.value}_getNode(u){const y=this._iter.reset(u);let b=this._root;for(;b;){const c=y.cmp(b.segment);if(c>0)b=b.left;else if(c<0)b=b.right;else if(y.hasNext())y.next(),b=b.mid;else break}return b}has(u){const y=this._getNode(u);return!(y?.value===void 0&&y?.mid===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,y){const b=this._iter.reset(u),c=[];let f=this._root;for(;f;){const l=b.cmp(f.segment);if(l>0)c.push([-1,f]),f=f.left;else if(l<0)c.push([1,f]),f=f.right;else if(b.hasNext())b.next(),c.push([0,f]),f=f.mid;else break}if(f){if(y?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const l=this._min(f.right);if(l.key){const{key:v,value:I,segment:p}=l;this._delete(l.key,!1),f.key=v,f.value=I,f.segment=p}}else{const l=f.left??f.right;if(c.length>0){const[v,I]=c[c.length-1];switch(v){case-1:I.left=l;break;case 0:I.mid=l;break;case 1:I.right=l;break}}else this._root=l}for(let l=c.length-1;l>=0;l--){const v=c[l][1];v.updateHeight();const I=v.balanceFactor();if(I>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),c[l][1]=v.rotateLeft()):I<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),c[l][1]=v.rotateRight()),l>0)switch(c[l-1][0]){case-1:c[l-1][1].left=c[l][1];break;case 1:c[l-1][1].right=c[l][1];break;case 0:c[l-1][1].mid=c[l][1];break}else this._root=c[0][1]}}}_min(u){for(;u.left;)u=u.left;return u}findSubstr(u){const y=this._iter.reset(u);let b=this._root,c;for(;b;){const f=y.cmp(b.segment);if(f>0)b=b.left;else if(f<0)b=b.right;else if(y.hasNext())y.next(),c=b.value||c,b=b.mid;else break}return b&&b.value||c}findSuperstr(u){return this._findSuperstrOrElement(u,!1)}_findSuperstrOrElement(u,y){const b=this._iter.reset(u);let c=this._root;for(;c;){const f=b.cmp(c.segment);if(f>0)c=c.left;else if(f<0)c=c.right;else if(b.hasNext())b.next(),c=c.mid;else return c.mid?this._entries(c.mid):y?c.value:void 0}}hasElementOrSubtree(u){return this._findSuperstrOrElement(u,!0)!==void 0}forEach(u){for(const[y,b]of this)u(b,y)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(u){const y=[];return this._dfsEntries(u,y),y[Symbol.iterator]()}_dfsEntries(u,y){u&&(u.left&&this._dfsEntries(u.left,y),u.value&&y.push([u.key,u.value]),u.mid&&this._dfsEntries(u.mid,y),u.right&&this._dfsEntries(u.right,y))}_isBalanced(){const u=y=>{if(!y)return!0;const b=y.balanceFactor();return b<-1||b>1?!1:u(y.left)&&u(y.right)};return u(this._root)}}e.TernarySearchTree=g}),define(ee[12],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(p){return typeof p=="string"}e.isString=E;function A(p){return Array.isArray(p)&&p.every(t=>E(t))}e.isStringArray=A;function n(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=n;function _(p){const t=Object.getPrototypeOf(Uint8Array);return typeof p=="object"&&p instanceof t}e.isTypedArray=_;function D(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=D;function P(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=P;function h(p){return p===!0||p===!1}e.isBoolean=h;function d(p){return typeof p>"u"}e.isUndefined=d;function m(p){return!g(p)}e.isDefined=m;function g(p){return d(p)||p===null}e.isUndefinedOrNull=g;function S(p,t){if(!p)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=S;function u(p){if(g(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=u;function y(...p){const t=[];for(let a=0;a<p.length;a++){const s=p[a];if(g(s))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);t.push(s)}return t}e.assertAllDefined=y;const b=Object.prototype.hasOwnProperty;function c(p){if(!n(p))return!1;for(const t in p)if(b.call(p,t))return!1;return!0}e.isEmptyObject=c;function f(p){return typeof p=="function"}e.isFunction=f;function l(...p){return p.length>0&&p.every(f)}e.areFunctions=l;function v(p,t){const a=Math.min(p.length,t.length);for(let s=0;s<a;s++)I(p[s],t[s])}e.validateConstraints=v;function I(p,t){if(E(t)){if(typeof p!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(f(t)){try{if(p instanceof t)return}catch{}if(!g(p)&&p.constructor===t||t.length===1&&t.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=I}),define(ee[71],te([0,1,12]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function n(P,h){if((0,E.isString)(h)){const d=A[h];if(d===void 0)throw new Error(`${P} references an unknown codicon: ${h}`);h=d}return A[P]=h,{id:P}}function _(){return A}e.getCodiconFontCharacters=_;function D(){return Object.values(e.Codicon)}e.getAllCodicons=D,e.Codicon={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),gitPullRequestLabel:n("git-pull-request-label",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),gitPullRequestMilestone:n("git-pull-request-milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package_:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),gitPullRequestReviewer:n("git-pull-request-reviewer",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),gitPullRequestAssignee:n("git-pull-request-assignee",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),send:n("send",60431),sparkle:n("sparkle",60432),insert:n("insert",60433),mic:n("mic",60434),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(ee[37],te([0,1,12]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const l=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([v,I])=>{l[v]=I&&typeof I=="object"?A(I):I}),l}e.deepClone=A;function n(f){if(!f||typeof f!="object")return f;const l=[f];for(;l.length>0;){const v=l.shift();Object.freeze(v);for(const I in v)if(_.call(v,I)){const p=v[I];typeof p=="object"&&!Object.isFrozen(p)&&!(0,E.isTypedArray)(p)&&l.push(p)}}return f}e.deepFreeze=n;const _=Object.prototype.hasOwnProperty;function D(f,l){return P(f,l,new Set)}e.cloneAndChange=D;function P(f,l,v){if((0,E.isUndefinedOrNull)(f))return f;const I=l(f);if(typeof I<"u")return I;if(Array.isArray(f)){const p=[];for(const t of f)p.push(P(t,l,v));return p}if((0,E.isObject)(f)){if(v.has(f))throw new Error("Cannot clone recursive data-structure");v.add(f);const p={};for(const t in f)_.call(f,t)&&(p[t]=P(f[t],l,v));return v.delete(f),p}return f}function h(f,l,v=!0){return(0,E.isObject)(f)?((0,E.isObject)(l)&&Object.keys(l).forEach(I=>{I in f?v&&((0,E.isObject)(f[I])&&(0,E.isObject)(l[I])?h(f[I],l[I],v):f[I]=l[I]):f[I]=l[I]}),f):l}e.mixin=h;function d(f,l){if(f===l)return!0;if(f==null||l===null||l===void 0||typeof f!=typeof l||typeof f!="object"||Array.isArray(f)!==Array.isArray(l))return!1;let v,I;if(Array.isArray(f)){if(f.length!==l.length)return!1;for(v=0;v<f.length;v++)if(!d(f[v],l[v]))return!1}else{const p=[];for(I in f)p.push(I);p.sort();const t=[];for(I in l)t.push(I);if(t.sort(),!d(p,t))return!1;for(v=0;v<p.length;v++)if(!d(f[p[v]],l[p[v]]))return!1}return!0}e.equals=d;function m(f){const l=new Set;return JSON.stringify(f,(v,I)=>{if((0,E.isObject)(I)||Array.isArray(I)){if(l.has(I))return"[Circular]";l.add(I)}return I})}e.safeStringify=m;function g(f,l){const v=Object.create(null);return!f||!l||Object.keys(l).forEach(p=>{const t=f[p],a=l[p];d(t,a)||(v[p]=a)}),v}e.distinct=g;function S(f,l){const v=l.toLowerCase(),I=Object.keys(f).find(p=>p.toLowerCase()===v);return I?f[I]:f[l]}e.getCaseInsensitive=S;function u(f,l){const v=Object.create(null);for(const[I,p]of Object.entries(f))l(I,p)&&(v[I]=p);return v}e.filter=u;function y(f){let l=[];for(;Object.prototype!==f;)l=l.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return l}e.getAllPropertyNames=y;function b(f){const l=[];for(const v of y(f))typeof f[v]=="function"&&l.push(v);return l}e.getAllMethodNames=b;function c(f,l){const v=p=>function(){const t=Array.prototype.slice.call(arguments,0);return l(p,t)},I={};for(const p of f)I[p]=v(p);return I}e.createProxyObject=c}),define(ee[103],te([0,1,71]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(D){function P(h){return h&&typeof h=="object"&&typeof h.id=="string"}D.isThemeColor=P})(A||(e.ThemeColor=A={}));function n(D){return{id:D}}e.themeColorFromId=n;var _;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function h(l){const v=P.exec(l.id);if(!v)return h(E.Codicon.error);const[,I,p]=v,t=["codicon","codicon-"+I];return p&&t.push("codicon-modifier-"+p.substring(1)),t}D.asClassNameArray=h;function d(l){return h(l).join(" ")}D.asClassName=d;function m(l){return"."+h(l).join(".")}D.asCSSSelector=m;function g(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||A.isThemeColor(l.color))}D.isThemeIcon=g;const S=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function u(l){const v=S.exec(l);if(!v)return;const[,I]=v;return{id:I}}D.fromString=u;function y(l){return{id:l}}D.fromId=y;function b(l,v){let I=l.id;const p=I.lastIndexOf("~");return p!==-1&&(I=I.substring(0,p)),v&&(I=`${I}~${v}`),{id:I}}D.modify=b;function c(l){const v=l.id.lastIndexOf("~");if(v!==-1)return l.id.substring(v+1)}D.getModifier=c;function f(l,v){return l.id===v.id&&l.color?.id===v.color?.id}D.isEqual=f})(_||(e.ThemeIcon=_={}))}),define(ee[31],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(n){return E.test(n)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(P){for(let h=0;h<P.length;h++)P[h]=Math.floor(Math.random()*256);return P};const _=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){n(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let h=0,d="";return d+=D[_[h++]],d+=D[_[h++]],d+=D[_[h++]],d+=D[_[h++]],d+="-",d+=D[_[h++]],d+=D[_[h++]],d+="-",d+=D[_[h++]],d+=D[_[h++]],d+="-",d+=D[_[h++]],d+=D[_[h++]],d+="-",d+=D[_[h++]],d+=D[_[h++]],d+=D[_[h++]],d+=D[_[h++]],d+=D[_[h++]],d+=D[_[h++]],d}}()}),define(ee[142],te([0,1,72,45,49]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function _(D,P){if(await new Promise((m,g)=>{const S=A.createReadStream(D),u=E.createHash("sha1");S.pipe(u);const y=(0,n.once)((b,c)=>{S.removeAllListeners(),u.removeAllListeners(),b?g(b):m(c)});S.once("error",y),S.once("end",y),u.once("error",y),u.once("data",b=>y(void 0,b.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=_}),define(ee[143],te([0,1,27]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function n(D){const P=D.replace(/\-/g,":").toLowerCase();return!A.has(P)}function _(){const D=(0,E.networkInterfaces)();for(const P in D){const h=D[P];if(h){for(const{mac:d}of h)if(n(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=_}),define(ee[87],te([0,1,27,58,31,143]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(d){return this._virtualMachineOUIs||(this._virtualMachineOUIs=A.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(d)}value(){if(this._value===void 0){let d=0,m=0;const g=(0,E.networkInterfaces)();for(const S in g){const u=g[S];if(u)for(const{mac:y,internal:b}of u)b||(m+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(d+=1))}this._value=m>0?d/m:0}return this._value}};let D;async function P(d){return D||(D=(async()=>await h(d)||n.generateUuid())()),D}e.getMachineId=P;async function h(d){try{const m=await new Promise((S,u)=>{H(["crypto"],S,u)}),g=(0,_.getMac)();return m.createHash("sha256").update(g,"utf8").digest("hex")}catch(m){d(m);return}}}),define(ee[104],te([0,1,88]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function A(P,h,d,m=1){let g=!1;return new Promise(S=>{const u=setTimeout(()=>{if(!g)return g=!0,S(0)},d);n(P,h,m,y=>{if(!g)return g=!0,clearTimeout(u),S(y)})})}e.findFreePort=A;function n(P,h,d,m){if(h===0)return m(0);const g=new E.Socket;g.once("connect",()=>(D(g),n(P+d,h-1,d,m))),g.once("data",()=>{}),g.once("error",S=>(D(g),S.code!=="ECONNREFUSED"?n(P+d,h-1,d,m):m(P))),g.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function _(P,h,d,m="127.0.0.1"){let g=!1,S,u=1;const y=E.createServer({pauseOnConnect:!0});function b(c,f){g||(g=!0,y.removeAllListeners(),y.close(),S&&clearTimeout(S),f(c))}return new Promise(c=>{S=setTimeout(()=>{b(0,c)},d),y.on("listening",()=>{b(P,c)}),y.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&u<h?(P++,u++,y.listen(P,m)):b(0,c)}),y.on("close",()=>{b(0,c)}),y.listen(P,m)})}e.findFreePortFaster=_;function D(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(h){console.error(h)}}}),function(){function H(){function e(){return process.uncHostAllowlist}function E(h){const d=new Set;if(Array.isArray(h))for(const m of h)typeof m=="string"&&d.add(m);return Array.from(d)}function A(){const h=e();return h?Array.from(h):[]}function n(h){if(process.platform!=="win32")return;const d=e();if(d)if(typeof h=="string")d.add(h.toLowerCase());else for(const m of E(h))n(m)}function _(h){if(typeof h!="string")return;const d=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const g of d){if(h.indexOf(g)!==0)continue;const u=h.indexOf("\\",g.length);if(u===-1)continue;const y=h.substring(g.length,u);if(y){m=y;break}}return m}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:A,addUNCHostToAllowlist:n,getUNCHost:_,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return H()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=H():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ee[144],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[145],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(n,_){this.sender=n,this.onMessage=_}send(n){try{this.sender.send("vscode:message",n.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=E}),define(ee[38],te([0,1,14,13]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class n{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,P){const h=(d,...m)=>{this.validateEvent(D,d)&&P(d,...m)};return this.mapListenerToWrapper.set(P,h),E.ipcMain.on(D,h),this}once(D,P){return E.ipcMain.once(D,(h,...d)=>{this.validateEvent(D,h)&&P(h,...d)}),this}handle(D,P){return E.ipcMain.handle(D,(h,...d)=>this.validateEvent(D,h)?P(h,...d):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return E.ipcMain.removeHandler(D),this}removeListener(D,P){const h=this.mapListenerToWrapper.get(P);return h&&(E.ipcMain.removeListener(D,h),this.mapListenerToWrapper.delete(P)),this}validateEvent(D,P){if(!D||!D.startsWith("vscode:"))return(0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const h=P.senderFrame,d=h.url;if(!d||d==="about:blank")return!0;let m="unknown";try{m=new URL(d).host}catch{return(0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${d}'.`),!1}return m!=="vscode-app"?((0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${m}'.`),!1):h.parent!==null?((0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${m}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new n}),define(ee[146],te([0,1,14,38,144]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function _(){A.validatedIpcMain.on(n.CONTEXT_MENU_CHANNEL,(P,h,d,m,g)=>{const S=D(P,m,d);S.popup({window:E.BrowserWindow.fromWebContents(P.sender)??void 0,x:g?g.x:void 0,y:g?g.y:void 0,positioningItem:g?g.positioningItem:void 0,callback:()=>{S&&P.sender.send(n.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}e.registerContextMenuListener=_;function D(P,h,d){const m=new E.Menu;return d.forEach(g=>{let S;g.type==="separator"?S=new E.MenuItem({type:g.type}):Array.isArray(g.submenu)?S=new E.MenuItem({submenu:D(P,h,g.submenu),label:g.label}):S=new E.MenuItem({label:g.label,type:g.type,accelerator:g.accelerator,checked:g.checked,enabled:g.enabled,visible:g.visible,click:(u,y,b)=>P.sender.send(h,g.id,b)}),m.append(S)}),m}}),define(ee[147],te([11,10]),function(H,e){return H.create("vs/base/common/date",e)}),define(ee[148],te([0,1,147]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,n=A*60,_=n*24,D=_*7,P=_*30,h=_*365;function d(g,S,u,y){typeof g!="number"&&(g=g.getTime());const b=Math.round((new Date().getTime()-g)/1e3);if(b<-30)return(0,E.localize)(0,null,d(new Date().getTime()+b*1e3,!1));if(!y&&b<30)return(0,E.localize)(1,null);let c;return b<A?(c=b,S?c===1?u?(0,E.localize)(2,null,c):(0,E.localize)(3,null,c):u?(0,E.localize)(4,null,c):(0,E.localize)(5,null,c):c===1?u?(0,E.localize)(6,null,c):(0,E.localize)(7,null,c):u?(0,E.localize)(8,null,c):(0,E.localize)(9,null,c)):b<n?(c=Math.floor(b/A),S?c===1?u?(0,E.localize)(10,null,c):(0,E.localize)(11,null,c):u?(0,E.localize)(12,null,c):(0,E.localize)(13,null,c):c===1?u?(0,E.localize)(14,null,c):(0,E.localize)(15,null,c):u?(0,E.localize)(16,null,c):(0,E.localize)(17,null,c)):b<_?(c=Math.floor(b/n),S?c===1?u?(0,E.localize)(18,null,c):(0,E.localize)(19,null,c):u?(0,E.localize)(20,null,c):(0,E.localize)(21,null,c):c===1?u?(0,E.localize)(22,null,c):(0,E.localize)(23,null,c):u?(0,E.localize)(24,null,c):(0,E.localize)(25,null,c)):b<D?(c=Math.floor(b/_),S?c===1?(0,E.localize)(26,null,c):(0,E.localize)(27,null,c):c===1?(0,E.localize)(28,null,c):(0,E.localize)(29,null,c)):b<P?(c=Math.floor(b/D),S?c===1?u?(0,E.localize)(30,null,c):(0,E.localize)(31,null,c):u?(0,E.localize)(32,null,c):(0,E.localize)(33,null,c):c===1?u?(0,E.localize)(34,null,c):(0,E.localize)(35,null,c):u?(0,E.localize)(36,null,c):(0,E.localize)(37,null,c)):b<h?(c=Math.floor(b/P),S?c===1?u?(0,E.localize)(38,null,c):(0,E.localize)(39,null,c):u?(0,E.localize)(40,null,c):(0,E.localize)(41,null,c):c===1?u?(0,E.localize)(42,null,c):(0,E.localize)(43,null,c):u?(0,E.localize)(44,null,c):(0,E.localize)(45,null,c)):(c=Math.floor(b/h),S?c===1?u?(0,E.localize)(46,null,c):(0,E.localize)(47,null,c):u?(0,E.localize)(48,null,c):(0,E.localize)(49,null,c):c===1?u?(0,E.localize)(50,null,c):(0,E.localize)(51,null,c):u?(0,E.localize)(52,null,c):(0,E.localize)(53,null,c))}e.fromNow=d;function m(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=m}),define(ee[149],te([11,10]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(ee[50],te([0,1,24,12,149]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function _(g,S){return S&&(g.stack||g.stacktrace)?n.localize(0,null,P(g),D(g.stack)||D(g.stacktrace)):P(g)}function D(g){return Array.isArray(g)?g.join(`
`):g}function P(g){return g.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${g.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?n.localize(1,null,g.message):g.message||n.localize(2,null)}function h(g=null,S=!1){if(!g)return n.localize(3,null);if(Array.isArray(g)){const u=E.coalesce(g),y=h(u[0],S);return u.length>1?n.localize(4,null,y,u.length):y}if(A.isString(g))return g;if(g.detail){const u=g.detail;if(u.error)return _(u.error,S);if(u.exception)return _(u.exception,S)}return g.stack?_(g,S):g.message?g.message:n.localize(5,null)}e.toErrorMessage=h;function d(g){const S=g;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=d;function m(g,S){let u;return typeof g=="string"?u=new Error(g):u=g,u.actions=S,u}e.createErrorWithActions=m}),define(ee[150],te([11,10]),function(H,e){return H.create("vs/base/common/jsonErrorMessages",e)}),define(ee[151],te([0,1,150]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function A(n){switch(n){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=A}),define(ee[152],te([11,10]),function(H,e){return H.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,152]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,n=!1,_=!1,D=!1,P=!1,h=!1,d=!1,m=!1,g=!1,S=!1,u,y=e.LANGUAGE_DEFAULT,b=e.LANGUAGE_DEFAULT,c,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const v=typeof l?.versions?.electron=="string",I=v&&l?.type==="renderer";if(typeof navigator=="object"&&!I)f=navigator.userAgent,A=f.indexOf("Windows")>=0,n=f.indexOf("Macintosh")>=0,m=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=f.indexOf("Linux")>=0,S=f?.indexOf("Mobi")>=0,h=!0,u=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,y=u,b=navigator.language;else if(typeof l=="object"){A=l.platform==="win32",n=l.platform==="darwin",_=l.platform==="linux",D=_&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,d=v,g=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const k=l.env.VSCODE_NLS_CONFIG;if(k)try{const M=JSON.parse(k),C=M.availableLanguages["*"];u=M.locale,b=M.osLocale,y=C||e.LANGUAGE_DEFAULT,c=M._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var p;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(p||(e.Platform=p={}));function t(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let a=0;n?a=1:A?a=3:_&&(a=2),e.isWindows=A,e.isMacintosh=n,e.isLinux=_,e.isLinuxSnap=D,e.isNative=P,e.isElectron=d,e.isWeb=h,e.isWebWorker=h&&typeof e.globals.importScripts=="function",e.isIOS=m,e.isMobile=S,e.isCI=g,e.platform=a,e.userAgent=f,e.language=y;var s;(function(k){function M(){return e.language}k.value=M;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}k.isDefaultVariant=C;function L(){return e.language==="en"}k.isDefault=L})(s||(e.Language=s={})),e.locale=u,e.platformLocale=b,e.translationsConfigFile=c,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const k=[];e.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let L=0,T=k.length;L<T;L++){const F=k[L];if(F.id===C.data.vscodeScheduleAsyncWork){k.splice(L,1),F.callback();return}}});let M=0;return C=>{const L=++M;k.push({id:L,callback:C}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return k=>setTimeout(k)})();var i;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=n||m?2:A?1:3;let r=!0,o=!1;function w(){if(!o){o=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,r=new Uint16Array(k.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=w,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[36],te([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const n=E.globals.vscode.process;A={get platform(){return n.platform},get arch(){return n.arch},get env(){return n.env},cwd(){return n.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(ee[9],te([0,1,36]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,n=97,_=90,D=122,P=46,h=47,d=92,m=58,g=63;class S extends Error{constructor(a,s,i){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const o=a.indexOf(".")!==-1?"property":"argument";let w=`The "${a}" ${o} ${r} of type ${s}`;w+=`. Received type ${typeof i}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function u(t,a){if(t===null||typeof t!="object")throw new S(a,"Object",t)}function y(t,a){if(typeof t!="string")throw new S(a,"string",t)}const b=E.platform==="win32";function c(t){return t===h||t===d}function f(t){return t===h}function l(t){return t>=A&&t<=_||t>=n&&t<=D}function v(t,a,s,i){let r="",o=0,w=-1,k=0,M=0;for(let C=0;C<=t.length;++C){if(C<t.length)M=t.charCodeAt(C);else{if(i(M))break;M=h}if(i(M)){if(!(w===C-1||k===1))if(k===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const L=r.lastIndexOf(s);L===-1?(r="",o=0):(r=r.slice(0,L),o=r.length-1-r.lastIndexOf(s)),w=C,k=0;continue}else if(r.length!==0){r="",o=0,w=C,k=0;continue}}a&&(r+=r.length>0?`${s}..`:"..",o=2)}else r.length>0?r+=`${s}${t.slice(w+1,C)}`:r=t.slice(w+1,C),o=C-w-1;w=C,k=0}else M===P&&k!==-1?++k:k=-1}return r}function I(t,a){u(a,"pathObject");const s=a.dir||a.root,i=a.base||`${a.name||""}${a.ext||""}`;return s?s===a.root?`${s}${i}`:`${s}${t}${i}`:i}e.win32={resolve(...t){let a="",s="",i=!1;for(let r=t.length-1;r>=-1;r--){let o;if(r>=0){if(o=t[r],y(o,"path"),o.length===0)continue}else a.length===0?o=E.cwd():(o=E.env[`=${a}`]||E.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==a.toLowerCase()&&o.charCodeAt(2)===d)&&(o=`${a}\\`));const w=o.length;let k=0,M="",C=!1;const L=o.charCodeAt(0);if(w===1)c(L)&&(k=1,C=!0);else if(c(L))if(C=!0,c(o.charCodeAt(1))){let T=2,F=T;for(;T<w&&!c(o.charCodeAt(T));)T++;if(T<w&&T!==F){const B=o.slice(F,T);for(F=T;T<w&&c(o.charCodeAt(T));)T++;if(T<w&&T!==F){for(F=T;T<w&&!c(o.charCodeAt(T));)T++;(T===w||T!==F)&&(M=`\\\\${B}\\${o.slice(F,T)}`,k=T)}}}else k=1;else l(L)&&o.charCodeAt(1)===m&&(M=o.slice(0,2),k=2,w>2&&c(o.charCodeAt(2))&&(C=!0,k=3));if(M.length>0)if(a.length>0){if(M.toLowerCase()!==a.toLowerCase())continue}else a=M;if(i){if(a.length>0)break}else if(s=`${o.slice(k)}\\${s}`,i=C,C&&a.length>0)break}return s=v(s,!i,"\\",c),i?`${a}\\${s}`:`${a}${s}`||"."},normalize(t){y(t,"path");const a=t.length;if(a===0)return".";let s=0,i,r=!1;const o=t.charCodeAt(0);if(a===1)return f(o)?"\\":t;if(c(o))if(r=!0,c(t.charCodeAt(1))){let k=2,M=k;for(;k<a&&!c(t.charCodeAt(k));)k++;if(k<a&&k!==M){const C=t.slice(M,k);for(M=k;k<a&&c(t.charCodeAt(k));)k++;if(k<a&&k!==M){for(M=k;k<a&&!c(t.charCodeAt(k));)k++;if(k===a)return`\\\\${C}\\${t.slice(M)}\\`;k!==M&&(i=`\\\\${C}\\${t.slice(M,k)}`,s=k)}}}else s=1;else l(o)&&t.charCodeAt(1)===m&&(i=t.slice(0,2),s=2,a>2&&c(t.charCodeAt(2))&&(r=!0,s=3));let w=s<a?v(t.slice(s),!r,"\\",c):"";return w.length===0&&!r&&(w="."),w.length>0&&c(t.charCodeAt(a-1))&&(w+="\\"),i===void 0?r?`\\${w}`:w:r?`${i}\\${w}`:`${i}${w}`},isAbsolute(t){y(t,"path");const a=t.length;if(a===0)return!1;const s=t.charCodeAt(0);return c(s)||a>2&&l(s)&&t.charCodeAt(1)===m&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,s;for(let o=0;o<t.length;++o){const w=t[o];y(w,"path"),w.length>0&&(a===void 0?a=s=w:a+=`\\${w}`)}if(a===void 0)return".";let i=!0,r=0;if(typeof s=="string"&&c(s.charCodeAt(0))){++r;const o=s.length;o>1&&c(s.charCodeAt(1))&&(++r,o>2&&(c(s.charCodeAt(2))?++r:i=!1))}if(i){for(;r<a.length&&c(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(t,a){if(y(t,"from"),y(a,"to"),t===a)return"";const s=e.win32.resolve(t),i=e.win32.resolve(a);if(s===i||(t=s.toLowerCase(),a=i.toLowerCase(),t===a))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===d;)r++;let o=t.length;for(;o-1>r&&t.charCodeAt(o-1)===d;)o--;const w=o-r;let k=0;for(;k<a.length&&a.charCodeAt(k)===d;)k++;let M=a.length;for(;M-1>k&&a.charCodeAt(M-1)===d;)M--;const C=M-k,L=w<C?w:C;let T=-1,F=0;for(;F<L;F++){const se=t.charCodeAt(r+F);if(se!==a.charCodeAt(k+F))break;se===d&&(T=F)}if(F!==L){if(T===-1)return i}else{if(C>L){if(a.charCodeAt(k+F)===d)return i.slice(k+F+1);if(F===2)return i.slice(k+F)}w>L&&(t.charCodeAt(r+F)===d?T=F:F===2&&(T=3)),T===-1&&(T=0)}let B="";for(F=r+T+1;F<=o;++F)(F===o||t.charCodeAt(F)===d)&&(B+=B.length===0?"..":"\\..");return k+=T,B.length>0?`${B}${i.slice(k,M)}`:(i.charCodeAt(k)===d&&++k,i.slice(k,M))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===d){if(a.charCodeAt(1)===d){const s=a.charCodeAt(2);if(s!==g&&s!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(l(a.charCodeAt(0))&&a.charCodeAt(1)===m&&a.charCodeAt(2)===d)return`\\\\?\\${a}`;return t},dirname(t){y(t,"path");const a=t.length;if(a===0)return".";let s=-1,i=0;const r=t.charCodeAt(0);if(a===1)return c(r)?t:".";if(c(r)){if(s=i=1,c(t.charCodeAt(1))){let k=2,M=k;for(;k<a&&!c(t.charCodeAt(k));)k++;if(k<a&&k!==M){for(M=k;k<a&&c(t.charCodeAt(k));)k++;if(k<a&&k!==M){for(M=k;k<a&&!c(t.charCodeAt(k));)k++;if(k===a)return t;k!==M&&(s=i=k+1)}}}}else l(r)&&t.charCodeAt(1)===m&&(s=a>2&&c(t.charCodeAt(2))?3:2,i=s);let o=-1,w=!0;for(let k=a-1;k>=i;--k)if(c(t.charCodeAt(k))){if(!w){o=k;break}}else w=!1;if(o===-1){if(s===-1)return".";o=s}return t.slice(0,o)},basename(t,a){a!==void 0&&y(a,"ext"),y(t,"path");let s=0,i=-1,r=!0,o;if(t.length>=2&&l(t.charCodeAt(0))&&t.charCodeAt(1)===m&&(s=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let w=a.length-1,k=-1;for(o=t.length-1;o>=s;--o){const M=t.charCodeAt(o);if(c(M)){if(!r){s=o+1;break}}else k===-1&&(r=!1,k=o+1),w>=0&&(M===a.charCodeAt(w)?--w===-1&&(i=o):(w=-1,i=k))}return s===i?i=k:i===-1&&(i=t.length),t.slice(s,i)}for(o=t.length-1;o>=s;--o)if(c(t.charCodeAt(o))){if(!r){s=o+1;break}}else i===-1&&(r=!1,i=o+1);return i===-1?"":t.slice(s,i)},extname(t){y(t,"path");let a=0,s=-1,i=0,r=-1,o=!0,w=0;t.length>=2&&t.charCodeAt(1)===m&&l(t.charCodeAt(0))&&(a=i=2);for(let k=t.length-1;k>=a;--k){const M=t.charCodeAt(k);if(c(M)){if(!o){i=k+1;break}continue}r===-1&&(o=!1,r=k+1),M===P?s===-1?s=k:w!==1&&(w=1):s!==-1&&(w=-1)}return s===-1||r===-1||w===0||w===1&&s===r-1&&s===i+1?"":t.slice(s,r)},format:I.bind(null,"\\"),parse(t){y(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const s=t.length;let i=0,r=t.charCodeAt(0);if(s===1)return c(r)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(c(r)){if(i=1,c(t.charCodeAt(1))){let T=2,F=T;for(;T<s&&!c(t.charCodeAt(T));)T++;if(T<s&&T!==F){for(F=T;T<s&&c(t.charCodeAt(T));)T++;if(T<s&&T!==F){for(F=T;T<s&&!c(t.charCodeAt(T));)T++;T===s?i=T:T!==F&&(i=T+1)}}}}else if(l(r)&&t.charCodeAt(1)===m){if(s<=2)return a.root=a.dir=t,a;if(i=2,c(t.charCodeAt(2))){if(s===3)return a.root=a.dir=t,a;i=3}}i>0&&(a.root=t.slice(0,i));let o=-1,w=i,k=-1,M=!0,C=t.length-1,L=0;for(;C>=i;--C){if(r=t.charCodeAt(C),c(r)){if(!M){w=C+1;break}continue}k===-1&&(M=!1,k=C+1),r===P?o===-1?o=C:L!==1&&(L=1):o!==-1&&(L=-1)}return k!==-1&&(o===-1||L===0||L===1&&o===k-1&&o===w+1?a.base=a.name=t.slice(w,k):(a.name=t.slice(w,o),a.base=t.slice(w,k),a.ext=t.slice(o,k))),w>0&&w!==i?a.dir=t.slice(0,w-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(b){const t=/\\/g;return()=>{const a=E.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...t){let a="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const r=i>=0?t[i]:p();y(r,"path"),r.length!==0&&(a=`${r}/${a}`,s=r.charCodeAt(0)===h)}return a=v(a,!s,"/",f),s?`/${a}`:a.length>0?a:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===h,s=t.charCodeAt(t.length-1)===h;return t=v(t,!a,"/",f),t.length===0?a?"/":s?"./":".":(s&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let a;for(let s=0;s<t.length;++s){const i=t[s];y(i,"path"),i.length>0&&(a===void 0?a=i:a+=`/${i}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(y(t,"from"),y(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const s=1,i=t.length,r=i-s,o=1,w=a.length-o,k=r<w?r:w;let M=-1,C=0;for(;C<k;C++){const T=t.charCodeAt(s+C);if(T!==a.charCodeAt(o+C))break;T===h&&(M=C)}if(C===k)if(w>k){if(a.charCodeAt(o+C)===h)return a.slice(o+C+1);if(C===0)return a.slice(o+C)}else r>k&&(t.charCodeAt(s+C)===h?M=C:C===0&&(M=0));let L="";for(C=s+M+1;C<=i;++C)(C===i||t.charCodeAt(C)===h)&&(L+=L.length===0?"..":"/..");return`${L}${a.slice(o+M)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===h;let s=-1,i=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===h){if(!i){s=r;break}}else i=!1;return s===-1?a?"/":".":a&&s===1?"//":t.slice(0,s)},basename(t,a){a!==void 0&&y(a,"ext"),y(t,"path");let s=0,i=-1,r=!0,o;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let w=a.length-1,k=-1;for(o=t.length-1;o>=0;--o){const M=t.charCodeAt(o);if(M===h){if(!r){s=o+1;break}}else k===-1&&(r=!1,k=o+1),w>=0&&(M===a.charCodeAt(w)?--w===-1&&(i=o):(w=-1,i=k))}return s===i?i=k:i===-1&&(i=t.length),t.slice(s,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===h){if(!r){s=o+1;break}}else i===-1&&(r=!1,i=o+1);return i===-1?"":t.slice(s,i)},extname(t){y(t,"path");let a=-1,s=0,i=-1,r=!0,o=0;for(let w=t.length-1;w>=0;--w){const k=t.charCodeAt(w);if(k===h){if(!r){s=w+1;break}continue}i===-1&&(r=!1,i=w+1),k===P?a===-1?a=w:o!==1&&(o=1):a!==-1&&(o=-1)}return a===-1||i===-1||o===0||o===1&&a===i-1&&a===s+1?"":t.slice(a,i)},format:I.bind(null,"/"),parse(t){y(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const s=t.charCodeAt(0)===h;let i;s?(a.root="/",i=1):i=0;let r=-1,o=0,w=-1,k=!0,M=t.length-1,C=0;for(;M>=i;--M){const L=t.charCodeAt(M);if(L===h){if(!k){o=M+1;break}continue}w===-1&&(k=!1,w=M+1),L===P?r===-1?r=M:C!==1&&(C=1):r!==-1&&(C=-1)}if(w!==-1){const L=o===0&&s?1:o;r===-1||C===0||C===1&&r===w-1&&r===o+1?a.base=a.name=t.slice(L,w):(a.name=t.slice(L,r),a.base=t.slice(L,w),a.ext=t.slice(r,w))}return o>0?a.dir=t.slice(0,o-1):s&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b?e.win32.normalize:e.posix.normalize,e.isAbsolute=b?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b?e.win32.join:e.posix.join,e.resolve=b?e.win32.resolve:e.posix.resolve,e.relative=b?e.win32.relative:e.posix.relative,e.dirname=b?e.win32.dirname:e.posix.dirname,e.basename=b?e.win32.basename:e.posix.basename,e.extname=b?e.win32.extname:e.posix.extname,e.format=b?e.win32.format:e.posix.format,e.parse=b?e.win32.parse:e.posix.parse,e.toNamespacedPath=b?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b?e.win32.sep:e.posix.sep,e.delimiter=b?e.win32.delimiter:e.posix.delimiter}),define(ee[32],te([0,1,9,4,26,12]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(o){return o===47||o===92}e.isPathSeparator=D;function P(o){return o.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function h(o){return o.indexOf("/")===-1&&(o=P(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=h;function d(o,w=E.posix.sep){if(!o)return"";const k=o.length,M=o.charCodeAt(0);if(D(M)){if(D(o.charCodeAt(1))&&!D(o.charCodeAt(2))){let L=3;const T=L;for(;L<k&&!D(o.charCodeAt(L));L++);if(T!==L&&!D(o.charCodeAt(L+1))){for(L+=1;L<k;L++)if(D(o.charCodeAt(L)))return o.slice(0,L+1).replace(/[\\/]/g,w)}}return w}else if(f(M)&&o.charCodeAt(1)===58)return D(o.charCodeAt(2))?o.slice(0,2)+w:o.slice(0,2);let C=o.indexOf("://");if(C!==-1){for(C+=3;C<k;C++)if(D(o.charCodeAt(C)))return o.slice(0,C+1)}return""}e.getRoot=d;function m(o){if(!A.isWindows||!o||o.length<5)return!1;let w=o.charCodeAt(0);if(w!==92||(w=o.charCodeAt(1),w!==92))return!1;let k=2;const M=k;for(;k<o.length&&(w=o.charCodeAt(k),w!==92);k++);return!(M===k||(w=o.charCodeAt(k+1),isNaN(w)||w===92))}e.isUNC=m;const g=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(o,w=A.isWindows){const k=w?g:S;return!(!o||o.length===0||/^\s+$/.test(o)||(k.lastIndex=0,k.test(o))||w&&u.test(o)||o==="."||o===".."||w&&o[o.length-1]==="."||w&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=y;function b(o,w,k){const M=o===w;return!k||M?M:!o||!w?!1:(0,n.equalsIgnoreCase)(o,w)}e.isEqual=b;function c(o,w,k,M=E.sep){if(o===w)return!0;if(!o||!w||w.length>o.length)return!1;if(k){if(!(0,n.startsWithIgnoreCase)(o,w))return!1;if(w.length===o.length)return!0;let L=w.length;return w.charAt(w.length-1)===M&&L--,o.charAt(L)===M}return w.charAt(w.length-1)!==M&&(w+=M),o.indexOf(w)===0}e.isEqualOrParent=c;function f(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=f;function l(o,w){return A.isWindows&&o.endsWith(":")&&(o+=E.sep),(0,E.isAbsolute)(o)||(o=(0,E.join)(w,o)),o=(0,E.normalize)(o),A.isWindows?(o=(0,n.rtrim)(o,E.sep),o.endsWith(":")&&(o+=E.sep)):(o=(0,n.rtrim)(o,E.sep),o||(o=E.sep)),o}e.sanitizeFilePath=l;function v(o){const w=(0,E.normalize)(o);return A.isWindows?o.length>3?!1:I(w)&&(o.length===2||w.charCodeAt(2)===92):w===E.posix.sep}e.isRootOrDriveLetter=v;function I(o,w=A.isWindows){return w?f(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=I;function p(o,w=A.isWindows){return I(o,w)?o[0]:void 0}e.getDriveLetter=p;function t(o,w,k){return w.length>o.length?-1:o===w?0:(k&&(o=o.toLowerCase(),w=w.toLowerCase()),o.indexOf(w))}e.indexOfPath=t;function a(o){const w=o.split(":");let k,M,C;for(const L of w){const T=Number(L);(0,_.isNumber)(T)?M===void 0?M=T:C===void 0&&(C=T):k=k?[k,L].join(":"):L}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:M!==void 0?M:void 0,column:C!==void 0?C:M!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function r(o,w,k=8){let M="";for(let L=0;L<k;L++){let T;L===0&&A.isWindows&&!w&&(k===3||k===4)?T=i:T=s,M+=T.charAt(Math.floor(Math.random()*T.length))}let C;return w?C=`${w}-${M}`:C=M,o?(0,E.join)(o,C):C}e.randomPath=r}),define(ee[73],te([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A||(e.Source=A={}));var n;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(n||(e.TerminateResponseCode=n={}));function _(P,...h){const d=h.reduce((S,u)=>(S[u]=!0,S),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(S=>!d[S]).forEach(S=>{for(let u=0;u<m.length;u++)if(S.search(m[u])!==-1){delete P[S];break}})}e.sanitizeProcessEnvironment=_;function D(P){P&&(delete P.DEBUG,E.isMacintosh&&delete P.DYLD_LIBRARY_PATH,E.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(ee[7],te([0,1,9,4]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const n=/^\w[\w\d+.-]*$/,_=/^\//,D=/^\/\//;function P(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!n.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!_.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,r){return!i&&!r?"file":i}function d(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==g&&(r=g+r):r=g;break}return r}const m="",g="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(r){return r instanceof u?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,o,w,k,M,C=!1){typeof r=="object"?(this.scheme=r.scheme||m,this.authority=r.authority||m,this.path=r.path||m,this.query=r.query||m,this.fragment=r.fragment||m):(this.scheme=h(r,C),this.authority=o||m,this.path=d(this.scheme,w||m),this.query=k||m,this.fragment=M||m,P(this,C))}get fsPath(){return I(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:w,path:k,query:M,fragment:C}=r;return o===void 0?o=this.scheme:o===null&&(o=m),w===void 0?w=this.authority:w===null&&(w=m),k===void 0?k=this.path:k===null&&(k=m),M===void 0?M=this.query:M===null&&(M=m),C===void 0?C=this.fragment:C===null&&(C=m),o===this.scheme&&w===this.authority&&k===this.path&&M===this.query&&C===this.fragment?this:new c(o,w,k,M,C)}static parse(r,o=!1){const w=S.exec(r);return w?new c(w[2]||m,s(w[4]||m),s(w[5]||m),s(w[7]||m),s(w[9]||m),o):new c(m,m,m,m,m)}static file(r){let o=m;if(A.isWindows&&(r=r.replace(/\\/g,g)),r[0]===g&&r[1]===g){const w=r.indexOf(g,2);w===-1?(o=r.substring(2),r=g):(o=r.substring(2,w),r=r.substring(w)||g)}return new c("file",o,r,m,m)}static from(r,o){return new c(r.scheme,r.authority,r.path,r.query,r.fragment,o)}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return A.isWindows&&r.scheme==="file"?w=u.file(E.win32.join(I(r,!0),...o)).path:w=E.posix.join(r.path,...o),r.with({path:w})}toString(r=!1){return p(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof u)return r;{const o=new c(r);return o._formatted=r.external??null,o._fsPath=r._sep===b?r.fsPath??null:null,o}}else return r}}e.URI=u;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=y;const b=A.isWindows?1:void 0;class c extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=I(this,!1)),this._fsPath}toString(r=!1){return r?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=b),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(i,r,o){let w,k=-1;for(let M=0;M<i.length;M++){const C=i.charCodeAt(M);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||r&&C===47||o&&C===91||o&&C===93||o&&C===58)k!==-1&&(w+=encodeURIComponent(i.substring(k,M)),k=-1),w!==void 0&&(w+=i.charAt(M));else{w===void 0&&(w=i.substr(0,M));const L=f[C];L!==void 0?(k!==-1&&(w+=encodeURIComponent(i.substring(k,M)),k=-1),w+=L):k===-1&&(k=M)}}return k!==-1&&(w+=encodeURIComponent(i.substring(k))),w!==void 0?w:i}function v(i){let r;for(let o=0;o<i.length;o++){const w=i.charCodeAt(o);w===35||w===63?(r===void 0&&(r=i.substr(0,o)),r+=f[w]):r!==void 0&&(r+=i[o])}return r!==void 0?r:i}function I(i,r){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,A.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=I;function p(i,r){const o=r?v:l;let w="",{scheme:k,authority:M,path:C,query:L,fragment:T}=i;if(k&&(w+=k,w+=":"),(M||k==="file")&&(w+=g,w+=g),M){let F=M.indexOf("@");if(F!==-1){const B=M.substr(0,F);M=M.substr(F+1),F=B.lastIndexOf(":"),F===-1?w+=o(B,!1,!1):(w+=o(B.substr(0,F),!1,!1),w+=":",w+=o(B.substr(F+1),!1,!0)),w+="@"}M=M.toLowerCase(),F=M.lastIndexOf(":"),F===-1?w+=o(M,!1,!0):(w+=o(M.substr(0,F),!1,!0),w+=M.substr(F))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const F=C.charCodeAt(1);F>=65&&F<=90&&(C=`/${String.fromCharCode(F+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const F=C.charCodeAt(0);F>=65&&F<=90&&(C=`${String.fromCharCode(F+32)}:${C.substr(2)}`)}w+=o(C,!0,!1)}return L&&(w+="?",w+=o(L,!1,!1)),T&&(w+="#",w+=r?T:l(T,!1,!1)),w}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(a)?i.replace(a,r=>t(r)):i}}),define(ee[153],te([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(d){const m=d;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.isRemoteConsoleLog=A;function n(d){const m=[];let g;try{const S=JSON.parse(d.arguments),u=S[S.length-1];u&&u.__$stack&&(S.pop(),g=u.__$stack),m.push(...S)}catch{m.push("Unable to log remote console arguments",d.arguments)}return{args:m,stack:g}}e.parse=n;function _(d){if(typeof d!="string")return _(n(d).stack);const m=d;if(m){const g=D(m),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(g||"");if(S&&S.length===4)return{uri:E.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=_;function D(d){if(!d)return d;const m=d.indexOf(`
`);return m===-1?d:d.substring(0,m)}function P(d,m){const{args:g,stack:S}=n(d),u=typeof g[0]=="string"&&g.length===1;let y=D(S);y&&(y=`(${y.trim()})`);let b=[];if(typeof g[0]=="string"?y&&u?b=[`%c[${m}] %c${g[0]} %c${y}`,h("blue"),h(""),h("grey")]:b=[`%c[${m}] %c${g[0]}`,h("blue"),h(""),...g.slice(1)]:b=[`%c[${m}]%`,h("blue"),...g],y&&!u&&b.push(y),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,b)}e.log=P;function h(d){return`color: ${d}`}}),define(ee[74],te([0,1,17,7]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function n(h){return JSON.stringify(h,D)}e.stringify=n;function _(h){let d=JSON.parse(h);return d=P(d),d}e.parse=_;function D(h,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function P(h,d=0){if(!h||d>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return A.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 16:return new Date(h.source)}if(h instanceof E.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let m=0;m<h.length;++m)h[m]=P(h[m],d+1);else for(const m in h)Object.hasOwnProperty.call(h,m)&&(h[m]=P(h[m],d+1))}return h}e.revive=P}),define(ee[15],te([0,1,13,4,7]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var _;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(_||(e.Schemas=_={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${_.vscodeRemoteResource}`}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}setServerRootPath(m){this._remoteResourcesPath=`${m}/${_.vscodeRemoteResource}`}set(m,g,S){this._hosts[m]=g,this._ports[m]=S}setConnectionToken(m,g){this._connectionTokens[m]=g}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(m){if(this._delegate)try{return this._delegate(m)}catch(c){return E.onUnexpectedError(c),m}const g=m.authority;let S=this._hosts[g];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const u=this._ports[g],y=this._connectionTokens[g];let b=`path=${encodeURIComponent(m.path)}`;return typeof y=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),n.URI.from({scheme:A.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${S}:${u}`,path:this._remoteResourcesPath,query:b})}}e.RemoteAuthorities=new D,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(m){const g=this.toUri(m,H);return this.uriToBrowserUri(g)}uriToBrowserUri(m){return m.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(m):m.scheme===_.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${_.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?m.with({scheme:_.vscodeFileResource,authority:m.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):m}asFileUri(m){const g=this.toUri(m,H);return this.uriToFileUri(g)}uriToFileUri(m){return m.scheme===_.vscodeFileResource?m.with({scheme:_.file,authority:m.authority!==P.FALLBACK_AUTHORITY?m.authority:null,query:null,fragment:null}):m}toUri(m,g){return n.URI.isUri(m)?m:n.URI.parse(g.toUrl(m))}}e.FileAccess=new P;var h;(function(d){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(m.get("3"));const g="vscode-coi";function S(y){let b;typeof y=="string"?b=new URL(y).searchParams:y instanceof URL?b=y.searchParams:n.URI.isUri(y)&&(b=new URL(y.toString(!0)).searchParams);const c=b?.get(g);if(c)return m.get(c)}d.getHeadersFromQuery=S;function u(y,b,c){if(!globalThis.crossOriginIsolated)return;const f=b&&c?"3":c?"2":"1";y instanceof URLSearchParams?y.set(g,f):y[g]=f}d.addSearchParam=u})(h||(e.COI=h={}))}),define(ee[19],te([0,1,32,15,9,4,26,7]),function(H,e,E,A,n,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(u){return(0,P.uriToFsPath)(u,!0)}e.originalFSPath=h;class d{constructor(y){this._ignorePathCasing=y}compare(y,b,c=!1){return y===b?0:(0,D.compare)(this.getComparisonKey(y,c),this.getComparisonKey(b,c))}isEqual(y,b,c=!1){return y===b?!0:!y||!b?!1:this.getComparisonKey(y,c)===this.getComparisonKey(b,c)}getComparisonKey(y,b=!1){return y.with({path:this._ignorePathCasing(y)?y.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(y){return this._ignorePathCasing(y)}isEqualOrParent(y,b,c=!1){if(y.scheme===b.scheme){if(y.scheme===A.Schemas.file)return E.isEqualOrParent(h(y),h(b),this._ignorePathCasing(y))&&y.query===b.query&&(c||y.fragment===b.fragment);if((0,e.isEqualAuthority)(y.authority,b.authority))return E.isEqualOrParent(y.path,b.path,this._ignorePathCasing(y),"/")&&y.query===b.query&&(c||y.fragment===b.fragment)}return!1}joinPath(y,...b){return P.URI.joinPath(y,...b)}basenameOrAuthority(y){return(0,e.basename)(y)||y.authority}basename(y){return n.posix.basename(y.path)}extname(y){return n.posix.extname(y.path)}dirname(y){if(y.path.length===0)return y;let b;return y.scheme===A.Schemas.file?b=P.URI.file(n.dirname(h(y))).path:(b=n.posix.dirname(y.path),y.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),b="/")),y.with({path:b})}normalizePath(y){if(!y.path.length)return y;let b;return y.scheme===A.Schemas.file?b=P.URI.file(n.normalize(h(y))).path:b=n.posix.normalize(y.path),y.with({path:b})}relativePath(y,b){if(y.scheme!==b.scheme||!(0,e.isEqualAuthority)(y.authority,b.authority))return;if(y.scheme===A.Schemas.file){const l=n.relative(h(y),h(b));return _.isWindows?E.toSlashes(l):l}let c=y.path||"/";const f=b.path||"/";if(this._ignorePathCasing(y)){let l=0;for(const v=Math.min(c.length,f.length);l<v&&!(c.charCodeAt(l)!==f.charCodeAt(l)&&c.charAt(l).toLowerCase()!==f.charAt(l).toLowerCase());l++);c=f.substr(0,l)+c.substr(l)}return n.posix.relative(c,f)}resolvePath(y,b){if(y.scheme===A.Schemas.file){const c=P.URI.file(n.resolve(h(y),b));return y.with({authority:c.authority,path:c.path})}return b=E.toPosixPath(b),y.with({path:n.posix.resolve(y.path,b)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,b){return y===b||y!==void 0&&b!==void 0&&(0,D.equalsIgnoreCase)(y,b)}hasTrailingPathSeparator(y,b=n.sep){if(y.scheme===A.Schemas.file){const c=h(y);return c.length>E.getRoot(c).length&&c[c.length-1]===b}else{const c=y.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,b=n.sep){return(0,e.hasTrailingPathSeparator)(y,b)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,b=n.sep){let c=!1;if(y.scheme===A.Schemas.file){const f=h(y);c=f!==void 0&&f.length===E.getRoot(f).length&&f[f.length-1]===b}else{b="/";const f=y.path;c=f.length===1&&f.charCodeAt(f.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(y,b)?y.with({path:y.path+"/"}):y}}e.ExtUri=d,e.extUri=new d(()=>!1),e.extUriBiasedIgnorePathCase=new d(u=>u.scheme===A.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new d(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function m(u,y){const b=[];for(let c=0;c<u.length;c++){const f=y(u[c]);u.some((l,v)=>v===c?!1:(0,e.isEqualOrParent)(f,y(l)))||b.push(u[c])}return b}e.distinctParents=m;var g;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function y(b){const c=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(v=>{const[I,p]=v.split(":");I&&p&&c.set(I,p)});const l=b.path.substring(0,b.path.indexOf(";"));return l&&c.set(u.META_DATA_MIME,l),c}u.parseMetaData=y})(g||(e.DataUri=g={}));function S(u,y,b){if(y){let c=u.path;return c&&c[0]!==n.posix.sep&&(c=n.posix.sep+c),u.with({scheme:b,authority:y,path:c})}return u.with({scheme:b})}e.toLocalResource=S}),define(ee[8],te([0,1,23,13,3,2,19,4,141]),function(H,e,E,A,n,_,D,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(R){return!!R&&typeof R.then=="function"}e.isThenable=d;function m(R){const O=new E.CancellationTokenSource,N=R(O.token),q=new Promise((re,ne)=>{const le=O.token.onCancellationRequested(()=>{le.dispose(),O.dispose(),ne(new A.CancellationError)});Promise.resolve(N).then(j=>{le.dispose(),O.dispose(),re(j)},j=>{le.dispose(),O.dispose(),ne(j)})});return new class{cancel(){O.cancel()}then(re,ne){return q.then(re,ne)}catch(re){return this.then(void 0,re)}finally(re){return q.finally(re)}}}e.createCancelablePromise=m;function g(R,O,N){return new Promise((q,re)=>{const ne=O.onCancellationRequested(()=>{ne.dispose(),q(N)});R.then(q,re).finally(()=>ne.dispose())})}e.raceCancellation=g;function S(R,O){return new Promise((N,q)=>{const re=O.onCancellationRequested(()=>{re.dispose(),q(new A.CancellationError)});R.then(N,q).finally(()=>re.dispose())})}e.raceCancellationError=S;async function u(R){let O=-1;const N=R.map((q,re)=>q.then(ne=>(O=re,ne)));try{return await Promise.race(N)}finally{R.forEach((q,re)=>{re!==O&&q.cancel()})}}e.raceCancellablePromises=u;function y(R,O,N){let q;const re=setTimeout(()=>{q?.(void 0),N?.()},O);return Promise.race([R.finally(()=>clearTimeout(re)),new Promise(ne=>q=ne)])}e.raceTimeout=y;function b(R){return new Promise((O,N)=>{const q=R();d(q)?q.then(O,N):O(q)})}e.asPromise=b;class c{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const N=()=>{if(this.queuedPromise=null,this.isDisposed)return;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(N,N).then(q)})}return new Promise((N,q)=>{this.queuedPromise.then(N,q)})}return this.activePromise=O(),new Promise((N,q)=>{this.activePromise.then(re=>{this.activePromise=null,N(re)},re=>{this.activePromise=null,q(re)})})}dispose(){this.isDisposed=!0}}e.Throttler=c;class f{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=f;class l{constructor(){this.promiseMap=new Map}queue(O,N){const re=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(O)===re&&this.promiseMap.delete(O)});return this.promiseMap.set(O,re),re}}e.SequencerByKey=l;const v=(R,O)=>{let N=!0;const q=setTimeout(()=>{N=!1,O()},R);return{isTriggered:()=>N,dispose:()=>{clearTimeout(q),N=!1}}},I=R=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,R())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};class p{constructor(O){this.defaultDelay=O,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,N=this.defaultDelay){this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((re,ne)=>{this.doResolve=re,this.doReject=ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const re=this.task;return this.task=null,re()}}));const q=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=N===h.MicrotaskDelay?I(q):v(N,q),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new A.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class t{constructor(O){this.delayer=new p(O),this.throttler=new c}trigger(O,N){return this.delayer.trigger(()=>this.throttler.queue(O),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=t;class a{constructor(){this._isOpen=!1,this._promise=new Promise((O,N)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class s extends a{constructor(O){super(),this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function i(R,O){return O?new Promise((N,q)=>{const re=setTimeout(()=>{ne.dispose(),N()},R),ne=O.onCancellationRequested(()=>{clearTimeout(re),ne.dispose(),q(new A.CancellationError)})}):m(N=>i(R,N))}e.timeout=i;function r(R,O=0){const N=setTimeout(R,O);return(0,_.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=r;function o(R){const O=[];let N=0;const q=R.length;function re(){return N<q?R[N++]():null}function ne(le){le!=null&&O.push(le);const j=re();return j?j.then(ne):Promise.resolve(O)}return Promise.resolve(null).then(ne)}e.sequence=o;function w(R,O=q=>!!q,N=null){let q=0;const re=R.length,ne=()=>{if(q>=re)return Promise.resolve(N);const le=R[q++];return Promise.resolve(le()).then(Z=>O(Z)?Promise.resolve(Z):ne())};return ne()}e.first=w;function k(R,O=q=>!!q,N=null){if(R.length===0)return Promise.resolve(N);let q=R.length;const re=()=>{q=-1;for(const ne of R)ne.cancel?.()};return new Promise((ne,le)=>{for(const j of R)j.then(Z=>{--q>=0&&O(Z)?(re(),ne(Z)):q===0&&ne(N)}).catch(Z=>{--q>=0&&(re(),le(Z))})})}e.firstParallel=k;class M{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new n.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(O){return this._size++,new Promise((N,q)=>{this.outstandingPromises.push({factory:O,c:N,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const N=O.factory();N.then(O.c,O.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=M;class C extends M{constructor(){super(1)}}e.Queue=C;class L{constructor(){this.sequentializer=new G,this.tasks=0}queue(O){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,O())):this.sequentializer.run(this.tasks++,O())}}e.LimitedQueue=L;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const O=new U;return this.drainers.add(O),O.p}isDrained(){for(const[,O]of this.queues)if(O.size>0)return!1;return!0}queueFor(O,N=D.extUri){const q=N.getComparisonKey(O);let re=this.queues.get(q);return re||(re=new C,n.Event.once(re.onDrained)(()=>{re?.dispose(),this.queues.delete(q),this.onDidQueueDrain()}),this.queues.set(q,re)),re}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const O of this.drainers)O.complete();this.drainers.clear()}dispose(){for(const[,O]of this.queues)O.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class F{constructor(O,N){this._token=-1,typeof O=="function"&&typeof N=="number"&&this.setIfNotSet(O,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},N)}setIfNotSet(O,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},N))}}e.TimeoutTimer=F;class B{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,N){this.cancel(),this._token=setInterval(()=>{O()},N)}}e.IntervalTimer=B;class se{constructor(O,N){this.timeoutToken=-1,this.runner=O,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=se;class ie{constructor(O,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=O,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(O=this.timeout){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(O/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=ie;class de extends se{constructor(O,N){super(O,N),this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner?.(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=de;class ae extends _.Disposable{constructor(O,N){super(),this.options=O,this.handler=N,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.options.maxBufferedWork)return!1}else if(this.pending+O.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const N of O)this.pendingWork.push(N);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new se(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ae,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=R=>{(0,P.setTimeout0)(()=>{if(O)return;const N=Date.now()+15;R(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(R,O)=>{const N=requestIdleCallback(R,typeof O=="number"?{timeout:O}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(N))}}}}();class ue{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ue;async function x(R,O,N){let q;for(let re=0;re<N;re++)try{return await R()}catch(ne){q=ne,await i(O)}throw q}e.retry=x;class G{isRunning(O){return typeof O=="number"?this._running?.taskId===O:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(O,N,q){return this._running={taskId:O,cancel:()=>q?.(),promise:N},N.then(()=>this.doneRunning(O),()=>this.doneRunning(O)),N}doneRunning(O){this._running&&O===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const O=this._queued;this._queued=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}queue(O){if(this._queued)this._queued.run=O;else{let N,q;const re=new Promise((ne,le)=>{N=ne,q=le});this._queued={run:O,promise:re,promiseResolve:N,promiseReject:q}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=G;class z{constructor(O,N=()=>Date.now()){this.interval=O,this.nowFn=N,this.lastIncrementTime=0,this.value=0}increment(){const O=this.nowFn();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=z;var W;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(W||(W={}));class U{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((O,N)=>{this.completeCallback=O,this.errorCallback=N})}complete(O){return new Promise(N=>{this.completeCallback(O),this.outcome={outcome:0,value:O},N()})}error(O){return new Promise(N=>{this.errorCallback(O),this.outcome={outcome:1,value:O},N()})}cancel(){return this.error(new A.CancellationError)}}e.DeferredPromise=U;var $;(function(R){async function O(q){let re;const ne=await Promise.all(q.map(le=>le.then(j=>j,j=>{re||(re=j)})));if(typeof re<"u")throw re;return ne}R.settled=O;function N(q){return new Promise(async(re,ne)=>{try{await q(re,ne)}catch(le){ne(le)}})}R.withAsyncBody=N})($||(e.Promises=$={}));var X;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(X||(X={}));class oe{static fromArray(O){return new oe(N=>{N.emitMany(O)})}static fromPromise(O){return new oe(async N=>{N.emitMany(await O)})}static fromPromises(O){return new oe(async N=>{await Promise.all(O.map(async q=>N.emitOne(await q)))})}static merge(O){return new oe(async N=>{await Promise.all(O.map(async q=>{for await(const re of q)N.emitOne(re)}))})}static{this.EMPTY=oe.fromArray([])}constructor(O){this._state=0,this._results=[],this._error=null,this._onStateChanged=new n.Emitter,queueMicrotask(async()=>{const N={emitOne:q=>this.emitOne(q),emitMany:q=>this.emitMany(q),reject:q=>this.reject(q)};try{await Promise.resolve(O(N)),this.resolve()}catch(q){this.reject(q)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(O<this._results.length)return{done:!1,value:this._results[O++]};if(this._state===1)return{done:!0,value:void 0};await n.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(O,N){return new oe(async q=>{for await(const re of O)q.emitOne(N(re))})}map(O){return oe.map(this,O)}static filter(O,N){return new oe(async q=>{for await(const re of O)N(re)&&q.emitOne(re)})}filter(O){return oe.filter(this,O)}static coalesce(O){return oe.filter(O,N=>!!N)}coalesce(){return oe.coalesce(this)}static async toPromise(O){const N=[];for await(const q of O)N.push(q);return N}toPromise(){return oe.toPromise(this)}emitOne(O){this._state===0&&(this._results.push(O),this._onStateChanged.fire())}emitMany(O){this._state===0&&(this._results=this._results.concat(O),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(O){this._state===0&&(this._state=2,this._error=O,this._onStateChanged.fire())}}e.AsyncIterableObject=oe;class ce extends oe{constructor(O,N){super(N),this._source=O}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function V(R){const O=new E.CancellationTokenSource,N=R(O.token);return new ce(O,async q=>{const re=O.token.onCancellationRequested(()=>{re.dispose(),O.dispose(),q.reject(new A.CancellationError)});try{for await(const ne of N){if(O.token.isCancellationRequested)return;q.emitOne(ne)}re.dispose(),O.dispose()}catch(ne){re.dispose(),O.dispose(),q.reject(ne)}})}e.createCancelableAsyncIterable=V}),define(ee[105],te([0,1,24,8,32,35,9,4,26]),function(H,e,E,A,n,_,D,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function d(){return Object.create(null)}e.getEmptyExpression=d,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const m="[/\\\\]",g="[^/\\\\]",S=/\//g;function u(G,z){switch(G){case 0:return"";case 1:return`${g}*?`;default:return`(?:${m}|${g}+${m}${z?`|${m}${g}+`:""})*?`}}function y(G,z){if(!G)return[];const W=[];let U=!1,$=!1,X="";for(const oe of G){switch(oe){case z:if(!U&&!$){W.push(X),X="";continue}break;case"{":U=!0;break;case"}":U=!1;break;case"[":$=!0;break;case"]":$=!1;break}X+=oe}return X&&W.push(X),W}e.splitGlobAware=y;function b(G){if(!G)return"";let z="";const W=y(G,e.GLOB_SPLIT);if(W.every(U=>U===e.GLOBSTAR))z=".*";else{let U=!1;W.forEach(($,X)=>{if($===e.GLOBSTAR){if(U)return;z+=u(2,X===W.length-1)}else{let oe=!1,ce="",V=!1,R="";for(const O of $){if(O!=="}"&&oe){ce+=O;continue}if(V&&(O!=="]"||!R)){let N;O==="-"?N=O:(O==="^"||O==="!")&&!R?N="^":O===e.GLOB_SPLIT?N="":N=(0,h.escapeRegExpCharacters)(O),R+=N;continue}switch(O){case"{":oe=!0;continue;case"[":V=!0;continue;case"}":{const q=`(?:${y(ce,",").map(re=>b(re)).join("|")})`;z+=q,oe=!1,ce="";break}case"]":{z+="["+R+"]",V=!1,R="";break}case"?":z+=g;continue;case"*":z+=u(1);continue;default:z+=(0,h.escapeRegExpCharacters)(O)}}X<W.length-1&&(W[X+1]!==e.GLOBSTAR||X+2<W.length)&&(z+=m)}U=$===e.GLOBSTAR})}return z}const c=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,I=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new _.LRUCache(1e4),a=function(){return!1},s=function(){return null};function i(G,z){if(!G)return s;let W;typeof G!="string"?W=G.pattern:W=G,W=W.trim();const U=`${W}_${!!z.trimForExclusions}`;let $=t.get(U);if($)return r($,G);let X;return c.test(W)?$=w(W.substr(4),W):(X=f.exec(o(W,z)))?$=k(X[1],W):(z.trimForExclusions?v:l).test(W)?$=M(W,z):(X=I.exec(o(W,z)))?$=C(X[1].substr(1),W,!0):(X=p.exec(o(W,z)))?$=C(X[1],W,!1):$=L(W),t.set(U,$),r($,G)}function r(G,z){if(typeof z=="string")return G;const W=function(U,$){return(0,n.isEqualOrParent)(U,z.base,!P.isLinux)?G((0,h.ltrim)(U.substr(z.base.length),D.sep),$):null};return W.allBasenames=G.allBasenames,W.allPaths=G.allPaths,W.basenames=G.basenames,W.patterns=G.patterns,W}function o(G,z){return z.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function w(G,z){return function(W,U){return typeof W=="string"&&W.endsWith(G)?z:null}}function k(G,z){const W=`/${G}`,U=`\\${G}`,$=function(oe,ce){return typeof oe!="string"?null:ce?ce===G?z:null:oe===G||oe.endsWith(W)||oe.endsWith(U)?z:null},X=[G];return $.basenames=X,$.patterns=[z],$.allBasenames=X,$}function M(G,z){const W=ue(G.slice(1,-1).split(",").map(ce=>i(ce,z)).filter(ce=>ce!==s),G),U=W.length;if(!U)return s;if(U===1)return W[0];const $=function(ce,V){for(let R=0,O=W.length;R<O;R++)if(W[R](ce,V))return G;return null},X=W.find(ce=>!!ce.allBasenames);X&&($.allBasenames=X.allBasenames);const oe=W.reduce((ce,V)=>V.allPaths?ce.concat(V.allPaths):ce,[]);return oe.length&&($.allPaths=oe),$}function C(G,z,W){const U=D.sep===D.posix.sep,$=U?G:G.replace(S,D.sep),X=D.sep+$,oe=D.posix.sep+G;let ce;return W?ce=function(V,R){return typeof V=="string"&&(V===$||V.endsWith(X)||!U&&(V===G||V.endsWith(oe)))?z:null}:ce=function(V,R){return typeof V=="string"&&(V===$||!U&&V===G)?z:null},ce.allPaths=[(W?"*/":"./")+G],ce}function L(G){try{const z=new RegExp(`^${b(G)}$`);return function(W){return z.lastIndex=0,typeof W=="string"&&z.test(W)?G:null}}catch{return s}}function T(G,z,W){return!G||typeof z!="string"?!1:F(G)(z,void 0,W)}e.match=T;function F(G,z={}){if(!G)return a;if(typeof G=="string"||B(G)){const W=i(G,z);if(W===s)return a;const U=function($,X){return!!W($,X)};return W.allBasenames&&(U.allBasenames=W.allBasenames),W.allPaths&&(U.allPaths=W.allPaths),U}return de(G,z)}e.parse=F;function B(G){const z=G;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.isRelativePattern=B;function se(G){return G.allBasenames||[]}e.getBasenameTerms=se;function ie(G){return G.allPaths||[]}e.getPathTerms=ie;function de(G,z){const W=ue(Object.getOwnPropertyNames(G).map(ce=>ae(ce,G[ce],z)).filter(ce=>ce!==s)),U=W.length;if(!U)return s;if(!W.some(ce=>!!ce.requiresSiblings)){if(U===1)return W[0];const ce=function(O,N){let q;for(let re=0,ne=W.length;re<ne;re++){const le=W[re](O,N);if(typeof le=="string")return le;(0,A.isThenable)(le)&&(q||(q=[]),q.push(le))}return q?(async()=>{for(const re of q){const ne=await re;if(typeof ne=="string")return ne}return null})():null},V=W.find(O=>!!O.allBasenames);V&&(ce.allBasenames=V.allBasenames);const R=W.reduce((O,N)=>N.allPaths?O.concat(N.allPaths):O,[]);return R.length&&(ce.allPaths=R),ce}const $=function(ce,V,R){let O,N;for(let q=0,re=W.length;q<re;q++){const ne=W[q];ne.requiresSiblings&&R&&(V||(V=(0,D.basename)(ce)),O||(O=V.substr(0,V.length-(0,D.extname)(ce).length)));const le=ne(ce,V,O,R);if(typeof le=="string")return le;(0,A.isThenable)(le)&&(N||(N=[]),N.push(le))}return N?(async()=>{for(const q of N){const re=await q;if(typeof re=="string")return re}return null})():null},X=W.find(ce=>!!ce.allBasenames);X&&($.allBasenames=X.allBasenames);const oe=W.reduce((ce,V)=>V.allPaths?ce.concat(V.allPaths):ce,[]);return oe.length&&($.allPaths=oe),$}function ae(G,z,W){if(z===!1)return s;const U=i(G,W);if(U===s)return s;if(typeof z=="boolean")return U;if(z){const $=z.when;if(typeof $=="string"){const X=(oe,ce,V,R)=>{if(!R||!U(oe,ce))return null;const O=$.replace("$(basename)",()=>V),N=R(O);return(0,A.isThenable)(N)?N.then(q=>q?G:null):N?G:null};return X.requiresSiblings=!0,X}}return U}function ue(G,z){const W=G.filter(ce=>!!ce.basenames);if(W.length<2)return G;const U=W.reduce((ce,V)=>{const R=V.basenames;return R?ce.concat(R):ce},[]);let $;if(z){$=[];for(let ce=0,V=U.length;ce<V;ce++)$.push(z)}else $=W.reduce((ce,V)=>{const R=V.patterns;return R?ce.concat(R):ce},[]);const X=function(ce,V){if(typeof ce!="string")return null;if(!V){let O;for(O=ce.length;O>0;O--){const N=ce.charCodeAt(O-1);if(N===47||N===92)break}V=ce.substr(O)}const R=U.indexOf(V);return R!==-1?$[R]:null};X.basenames=U,X.patterns=$,X.allBasenames=U;const oe=G.filter(ce=>!ce.basenames);return oe.push(X),oe}function x(G,z){return(0,E.equals)(G,z,(W,U)=>typeof W=="string"&&typeof U=="string"?W===U:typeof W!="string"&&typeof U!="string"?W.base===U.base&&W.pattern===U.pattern:!1)}e.patternsEquals=x}),define(ee[46],te([0,1,24,32,9,4,19,26]),function(H,e,E,A,n,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function h(i,r){const{os:o,tildify:w,relative:k}=r;if(k){const L=d(i,k,o);if(typeof L=="string")return L}let M=i.fsPath;if(o===1&&!_.isWindows?M=M.replace(/\//g,"\\"):o!==1&&_.isWindows&&(M=M.replace(/\\/g,"/")),o!==1&&w?.userHome){const L=w.userHome.fsPath;let T;i.scheme!==w.userHome.scheme&&i.path.startsWith(n.posix.sep)?T=w.userHome.with({path:i.path}).fsPath:T=i.fsPath,M=S(T,L,o)}return(o===1?n.win32:n.posix).normalize(m(M,o===1))}e.getPathLabel=h;function d(i,r,o){const w=o===1?n.win32:n.posix,k=o===3?D.extUri:D.extUriIgnorePathCase,M=r.getWorkspace(),C=(0,E.firstOrDefault)(M.folders);if(!C)return;i.scheme!==C.uri.scheme&&i.path.startsWith(n.posix.sep)&&(i=C.uri.with({path:i.path}));const L=r.getWorkspaceFolder(i);if(!L)return;let T;if(k.isEqual(L.uri,i)?T="":T=k.relativePath(L.uri,i)??"",T&&(T=w.normalize(T)),M.folders.length>1&&!r.noPrefix){const F=L.name?L.name:k.basenameOrAuthority(L.uri);T=T?`${F} \u2022 ${T}`:F}return T}function m(i,r=_.isWindows){return(0,A.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=m;let g=Object.create(null);function S(i,r,o=_.OS){if(o===1||!i||!r)return i;let w=g.original===r?g.normalized:void 0;w||(w=r,_.isWindows&&(w=(0,A.toSlashes)(w)),w=`${(0,P.rtrim)(w,n.posix.sep)}${n.posix.sep}`,g={original:r,normalized:w});let k=i;return _.isWindows&&(k=(0,A.toSlashes)(k)),(o===3?k.startsWith(w):(0,P.startsWithIgnoreCase)(k,w))?`~/${k.substr(w.length)}`:i}e.tildify=S;function u(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=u;const y="\u2026",b="\\\\",c="~";function f(i,r=n.sep){const o=new Array(i.length);let w=!1;for(let k=0;k<i.length;k++){const M=i[k];if(M===""){o[k]=`.${r}`;continue}if(!M){o[k]=M;continue}w=!0;let C="",L=M;L.indexOf(b)===0?(C=L.substr(0,L.indexOf(b)+b.length),L=L.substr(L.indexOf(b)+b.length)):L.indexOf(r)===0?(C=L.substr(0,L.indexOf(r)+r.length),L=L.substr(L.indexOf(r)+r.length)):L.indexOf(c)===0&&(C=L.substr(0,L.indexOf(c)+c.length),L=L.substr(L.indexOf(c)+c.length));const T=L.split(r);for(let F=1;w&&F<=T.length;F++)for(let B=T.length-F;w&&B>=0;B--){w=!1;let se=T.slice(B,B+F).join(r);for(let ie=0;!w&&ie<i.length;ie++)if(ie!==k&&i[ie]&&i[ie].indexOf(se)>-1){const de=B+F===T.length,ae=B>0&&i[ie].indexOf(r)>-1?r+se:se,ue=i[ie].endsWith(ae);w=!de||ue}if(!w){let ie="";(T[0].endsWith(":")||C!=="")&&(B===1&&(B=0,F++,se=T[0]+r+se),B>0&&(ie=T[0]+r),ie=C+ie),B>0&&(ie=ie+y+r),ie=ie+se,B+F<T.length&&(ie=ie+r+y),o[k]=ie}}w&&(o[k]=M)}return o}e.shorten=f;var l;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function v(i,r=Object.create(null)){const o=[];let w=!1,k="";for(const M of i)if(M==="$"||w&&M==="{")k&&o.push({value:k,type:l.TEXT}),k="",w=!0;else if(M==="}"&&w){const C=r[k];if(typeof C=="string")C.length&&o.push({value:C,type:l.VARIABLE});else if(C){const L=o[o.length-1];(!L||L.type!==l.SEPARATOR)&&o.push({value:C.label,type:l.SEPARATOR})}k="",w=!1}else k+=M;return k&&!w&&o.push({value:k,type:l.TEXT}),o.filter((M,C)=>{if(M.type===l.SEPARATOR){const L=o[C-1],T=o[C+1];return[L,T].every(F=>F&&(F.type===l.VARIABLE||F.type===l.TEXT)&&F.value.length>0)}return!0}).map(M=>M.value).join("")}e.template=v;function I(i,r){return _.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,_.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=I;function p(i,r){return _.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):_.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function a(i){if(i.endsWith("]")){const r=i.lastIndexOf(" [",i.length-2);if(r!==-1){const o=s(i.substring(0,r));return{name:o.name,parentPath:o.parentPath+i.substring(r)}}}return s(i)}e.splitRecentLabel=a;function s(i){const r=i.indexOf("/")!==-1?n.posix:n.win32,o=r.basename(i),w=r.dirname(i);return o.length?{name:o,parentPath:w}:{name:w,parentPath:""}}}),define(ee[154],te([0,1,17,7]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(g){return g.toJSON()}class _{constructor(S){this._uriTransformer=S}transformIncoming(S){const u=this._uriTransformer.transformIncoming(S);return u===S?S:n(A.URI.from(u))}transformOutgoing(S){const u=this._uriTransformer.transformOutgoing(S);return u===S?S:n(A.URI.from(u))}transformOutgoingURI(S){const u=this._uriTransformer.transformOutgoing(S);return u===S?S:A.URI.from(u)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(g){return g}transformOutgoing(g){return g}transformOutgoingURI(g){return g}transformOutgoingScheme(g){return g}};function D(g,S,u){if(!g||u>200)return null;if(typeof g=="object"){if(g instanceof A.URI)return S.transformOutgoing(g);for(const y in g)if(Object.hasOwnProperty.call(g,y)){const b=D(g[y],S,u+1);b!==null&&(g[y]=b)}}return null}function P(g,S){const u=D(g,S,0);return u===null?g:u}e.transformOutgoingURIs=P;function h(g,S,u,y){if(!g||y>200)return null;if(typeof g=="object"){if(g.$mid===1)return u?A.URI.revive(S.transformIncoming(g)):S.transformIncoming(g);if(g instanceof E.VSBuffer)return null;for(const b in g)if(Object.hasOwnProperty.call(g,b)){const c=h(g[b],S,u,y+1);c!==null&&(g[b]=c)}}return null}function d(g,S){const u=h(g,S,!1,0);return u===null?g:u}e.transformIncomingURIs=d;function m(g,S){const u=h(g,S,!0,0);return u===null?g:u}e.transformAndReviveIncomingURIs=m}),define(ee[21],te([0,1,45,27,155,8,32,86,9,4,19,7]),function(H,e,E,A,n,_,D,P,h,d,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(ae){ae[ae.UNLINK=0]="UNLINK",ae[ae.MOVE=1]="MOVE"})(S||(e.RimRafMode=S={}));async function u(ae,ue=S.UNLINK,x){if((0,D.isRootOrDriveLetter)(ae))throw new Error("rimraf - will refuse to recursively delete root");return ue===S.UNLINK?b(ae):y(ae,x)}async function y(ae,ue=(0,D.randomPath)((0,A.tmpdir)())){try{try{await E.promises.rename(ae,ue)}catch(x){return x.code==="ENOENT"?void 0:b(ae)}b(ue).catch(x=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function b(ae){return(0,n.promisify)(E.rm)(ae,{recursive:!0,force:!0,maxRetries:3})}function c(ae){if((0,D.isRootOrDriveLetter)(ae))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(ae,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function f(ae,ue){return I(await(ue?l(ae):(0,n.promisify)(E.readdir)(ae)))}async function l(ae){try{return await(0,n.promisify)(E.readdir)(ae,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const ue=[],x=await f(ae);for(const G of x){let z=!1,W=!1,U=!1;try{const $=await e.Promises.lstat((0,h.join)(ae,G));z=$.isFile(),W=$.isDirectory(),U=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}ue.push({name:G,isFile:()=>z,isDirectory:()=>W,isSymbolicLink:()=>U})}return ue}function v(ae){return I(E.readdirSync(ae))}e.readdirSync=v;function I(ae){return ae.map(ue=>typeof ue=="string"?d.isMacintosh?(0,P.normalizeNFC)(ue):ue:(ue.name=d.isMacintosh?(0,P.normalizeNFC)(ue.name):ue.name,ue))}async function p(ae){const ue=await f(ae),x=[];for(const G of ue)await a.existsDirectory((0,h.join)(ae,G))&&x.push(G);return x}function t(ae,ue=1e3){return new Promise(x=>{let G=!1;const z=setInterval(()=>{G||(G=!0,E.access(ae,W=>{G=!1,W&&(clearInterval(z),x(void 0))}))},ue)})}e.whenDeleted=t;var a;(function(ae){async function ue(z){let W;try{if(W=await e.Promises.lstat(z),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(d.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw $}throw U}}ae.stat=ue;async function x(z){try{const{stat:W,symbolicLink:U}=await ae.stat(z);return W.isFile()&&U?.dangling!==!0}catch{}return!1}ae.existsFile=x;async function G(z){try{const{stat:W,symbolicLink:U}=await ae.stat(z);return W.isDirectory()&&U?.dangling!==!0}catch{}return!1}ae.existsDirectory=G})(a||(e.SymlinkSupport=a={}));const s=new _.ResourceQueue;function i(ae,ue,x){return s.queueFor(g.URI.file(ae),m.extUriBiasedIgnorePathCase).queue(()=>{const G=M(x);return new Promise((z,W)=>w(ae,ue,G,U=>U?W(U):z()))})}let r=!0;function o(ae){r=ae}e.configureFlushOnWrite=o;function w(ae,ue,x,G){if(!r)return E.writeFile(ae,ue,{mode:x.mode,flag:x.flag},G);E.open(ae,x.flag,x.mode,(z,W)=>{if(z)return G(z);E.writeFile(W,ue,U=>{if(U)return E.close(W,()=>G(U));E.fdatasync(W,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),o(!1)),E.close(W,X=>G(X))))})})}function k(ae,ue,x){const G=M(x);if(!r)return E.writeFileSync(ae,ue,{mode:G.mode,flag:G.flag});const z=E.openSync(ae,G.flag,G.mode);try{E.writeFileSync(z,ue);try{E.fdatasyncSync(z)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),o(!1)}}finally{E.closeSync(z)}}e.writeFileSync=k;function M(ae){return ae?{mode:typeof ae.mode=="number"?ae.mode:438,flag:typeof ae.flag=="string"?ae.flag:"w"}:{mode:438,flag:"w"}}async function C(ae,ue,x=6e4){if(ae!==ue)try{d.isWindows&&typeof x=="number"?await L(ae,ue,Date.now(),x):await(0,n.promisify)(E.rename)(ae,ue)}catch(G){if(ae.toLowerCase()!==ue.toLowerCase()&&G.code==="EXDEV"||ae.endsWith("."))await T(ae,ue,{preserveSymlinks:!1}),await u(ae,S.MOVE);else throw G}}async function L(ae,ue,x,G,z=0){try{return await(0,n.promisify)(E.rename)(ae,ue)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-x>=G)throw console.error(`[node.js fs] rename failed after ${z} retries with error: ${W}`),W;if(z===0){let U=!1;try{const{stat:$}=await a.stat(ue);$.isFile()||(U=!0)}catch{}if(U)throw W}return await(0,_.timeout)(Math.min(100,z*10)),L(ae,ue,x,G,z+1)}}async function T(ae,ue,x){return B(ae,ue,{root:{source:ae,target:ue},options:x,handledSourcePaths:new Set})}const F=511;async function B(ae,ue,x){if(x.handledSourcePaths.has(ae))return;x.handledSourcePaths.add(ae);const{stat:G,symbolicLink:z}=await a.stat(ae);if(z){if(x.options.preserveSymlinks)try{return await de(ae,ue,x)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(z.dangling)return}return G.isDirectory()?se(ae,ue,G.mode&F,x):ie(ae,ue,G.mode&F)}async function se(ae,ue,x,G){await e.Promises.mkdir(ue,{recursive:!0,mode:x});const z=await f(ae);for(const W of z)await B((0,h.join)(ae,W),(0,h.join)(ue,W),G)}async function ie(ae,ue,x){await e.Promises.copyFile(ae,ue),await e.Promises.chmod(ue,x)}async function de(ae,ue,x){let G=await e.Promises.readlink(ae);(0,D.isEqualOrParent)(G,x.root.source,!d.isLinux)&&(G=(0,h.join)(x.root.target,G.substr(x.root.source.length+1))),await e.Promises.symlink(G,ue)}e.Promises=new class{get access(){return(0,n.promisify)(E.access)}get stat(){return(0,n.promisify)(E.stat)}get lstat(){return(0,n.promisify)(E.lstat)}get utimes(){return(0,n.promisify)(E.utimes)}get read(){return(ae,ue,x,G,z)=>new Promise((W,U)=>{E.read(ae,ue,x,G,z,($,X,oe)=>$?U($):W({bytesRead:X,buffer:oe}))})}get readFile(){return(0,n.promisify)(E.readFile)}get write(){return(ae,ue,x,G,z)=>new Promise((W,U)=>{E.write(ae,ue,x,G,z,($,X,oe)=>$?U($):W({bytesWritten:X,buffer:oe}))})}get appendFile(){return(0,n.promisify)(E.appendFile)}get fdatasync(){return(0,n.promisify)(E.fdatasync)}get truncate(){return(0,n.promisify)(E.truncate)}get copyFile(){return(0,n.promisify)(E.copyFile)}get open(){return(0,n.promisify)(E.open)}get close(){return(0,n.promisify)(E.close)}get symlink(){return(0,n.promisify)(E.symlink)}get readlink(){return(0,n.promisify)(E.readlink)}get chmod(){return(0,n.promisify)(E.chmod)}get mkdir(){return(0,n.promisify)(E.mkdir)}get unlink(){return(0,n.promisify)(E.unlink)}get rmdir(){return(0,n.promisify)(E.rmdir)}get realpath(){return(0,n.promisify)(E.realpath)}async exists(ae){try{return await e.Promises.access(ae),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return p}get writeFile(){return i}get rm(){return u}get rename(){return C}get copy(){return T}}}),define(ee[106],te([0,1,45,9,4,26,21]),function(H,e,E,A,n,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(S){if(n.isLinux)return S;const u=(0,A.dirname)(S);if(S===u)return S;const y=((0,A.basename)(S)||S).toLowerCase();try{const c=(0,D.readdirSync)(u).filter(f=>f.toLowerCase()===y);if(c.length===1){const f=P(u);if(f)return(0,A.join)(f,c[0])}else if(c.length>1){const f=c.indexOf(y);if(f>=0){const l=P(u);if(l)return(0,A.join)(l,c[f])}}}catch{}return null}e.realcaseSync=P;async function h(S){if(n.isLinux)return S;const u=(0,A.dirname)(S);if(S===u)return S;const y=((0,A.basename)(S)||S).toLowerCase();try{const c=(await D.Promises.readdir(u)).filter(f=>f.toLowerCase()===y);if(c.length===1){const f=await h(u);if(f)return(0,A.join)(f,c[0])}else if(c.length>1){const f=c.indexOf(y);if(f>=0){const l=await h(u);if(l)return(0,A.join)(l,c[f])}}}catch{}return null}e.realcase=h;async function d(S){try{return await D.Promises.realpath(S)}catch{const y=g(S);return await D.Promises.access(y,E.constants.R_OK),y}}e.realpath=d;function m(S){try{return E.realpathSync(S)}catch{const y=g(S);return E.accessSync(y,E.constants.R_OK),y}}e.realpathSync=m;function g(S){return(0,_.rtrim)((0,A.normalize)(S),A.sep)}}),define(ee[107],te([0,1,27,9,21]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const _=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var h;(function(I){I[I.x64=0]="x64",I[I.x86=1]="x86",I[I.ARM=2]="ARM"})(h||(h={}));let d;switch(process.arch){case"ia32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class g{constructor(p,t,a){this.exePath=p,this.displayName=t,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await n.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:I=!1}={}){return I?d===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:I=!1,findPreview:p=!1}={}){const t=S({useAlternateBitness:I});if(!t)return null;const a=A.join(t,"PowerShell");if(!await n.SymlinkSupport.existsDirectory(a))return null;let s=-1,i=null;for(const w of await n.Promises.readdir(a)){let k=-1;if(p){const C=w.indexOf("-");if(C<0)continue;const L=w.substring(0,C);if(!_.test(L)||w.substring(C+1)!=="preview")continue;k=parseInt(L,10)}else{if(!_.test(w))continue;k=parseInt(w,10)}if(k<=s)continue;const M=A.join(a,w,"pwsh.exe");await n.SymlinkSupport.existsFile(M)&&(i=M,s=k)}if(!i)return null;const r=t.includes("x86")?" (x86)":"",o=p?" Preview":"";return new g(i,`PowerShell${o}${r}`,!0)}async function y({findPreview:I}={}){if(!process.env.LOCALAPPDATA)return null;const p=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await n.SymlinkSupport.existsDirectory(p))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=I?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const s of await n.Promises.readdir(p))if(t.test(s)){const i=A.join(p,s,"pwsh.exe");return new g(i,a)}return null}function b(){const I=A.join(E.homedir(),".dotnet","tools","pwsh.exe");return new g(I,".NET Core PowerShell Global Tool")}function c(){const I=A.join(process.env.windir,d===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new g(I,"Windows PowerShell",!0)}async function*f(){let I=await u();I&&(yield I),I=await u({useAlternateBitness:!0}),I&&(yield I),I=await y(),I&&(yield I),I=b(),I&&(yield I),I=await u({findPreview:!0}),I&&(yield I),I=await y({findPreview:!0}),I&&(yield I),I=await u({useAlternateBitness:!0,findPreview:!0}),I&&(yield I),I=c(),I&&(yield I)}async function*l(){for await(const I of f())await I.exists()&&(yield I)}e.enumeratePowerShellInstallations=l;async function v(){for await(const I of l())return I;return null}e.getFirstAvailablePowerShellInstallation=v}),define(ee[89],te([0,1,9,4,36,73,12,21]),function(H,e,E,A,n,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return _.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return _.TerminateResponseCode}});function h(g=n.env){return g.comspec||"cmd.exe"}e.getWindowsShell=h;function d(g){let S=[],u=!1;const y=function(b){if(u){S.push(b);return}(!g.send(b,f=>{if(f&&console.error(f),u=!1,S.length>0){const l=S.slice(0);S=[],l.forEach(v=>y(v))}})||A.isWindows)&&(u=!0)};return{send:y}}e.createQueuedSender=d;var m;(function(g){async function S(u,y,b){if(E.isAbsolute(u))return u;if(y===void 0&&(y=n.cwd()),E.dirname(u)!=="."||(b===void 0&&D.isString(n.env.PATH)&&(b=n.env.PATH.split(E.delimiter)),b===void 0||b.length===0))return E.join(y,u);async function f(l){if(await P.Promises.exists(l)){let v;try{v=await P.Promises.stat(l)}catch(I){I.message.startsWith("EACCES")&&(v=await P.Promises.lstat(l))}return v?!v.isDirectory():!1}return!1}for(const l of b){let v;if(E.isAbsolute(l)?v=E.join(l,u):v=E.join(y,l,u),await f(v))return v;let I=v+".com";if(await f(I)||(I=v+".exe",await f(I)))return I}return E.join(y,u)}g.findExecutable=S})(m||(e.win32=m={}))}),define(ee[108],te([0,1,47,15]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function n(D){return new Promise((P,h)=>{let d;const m=new Map;function g(u,y,b,c,f){const l=m.get(y);if(u===D||l){const v={name:S(b),cmd:b,pid:u,ppid:y,load:c,mem:f};m.set(u,v),u===D&&(d=v),l&&(l.children||(l.children=[]),l.children.push(v),l.children.length>1&&(l.children=l.children.sort((I,p)=>I.pid-p.pid)))}}function S(u){const y=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,c=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,v=/--type=([a-zA-Z-]+)/;if(c.exec(u))return"electron-crash-reporter";if(f.exec(u))return"winpty-agent";if(l.exec(u))return"conpty-agent";let I=v.exec(u);if(I&&I.length===2)return I[1]==="renderer"?"window":I[1]==="utility"?y.exec(u)?"utility-network-service":"utility-process":I[1]==="extensionHost"?"extension-host":I[1];const p=/[a-zA-Z-]+\.js/g;let t="";do I=p.exec(u),I&&(t+=I+" ");while(I);return t&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${t})`:b.exec(u)?`electron-nodejs (${u})`:u}if(process.platform==="win32"){const u=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,b)=>{H(["@vscode/windows-process-tree"],y,b)}).then(y=>{y.getProcessList(D,b=>{if(!b){h(new Error(`Root process ${D} not found`));return}y.getProcessCpuUsage(b,c=>{const f=new Map;c.forEach(l=>{const v=u(l.commandLine||"");f.set(l.pid,{name:S(v),cmd:v,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),d=f.get(D),d?(f.forEach(l=>{const v=f.get(l.ppid);v&&(v.children||(v.children=[]),v.children.push(l))}),f.forEach(l=>{l.children&&(l.children=l.children.sort((v,I)=>v.pid-I.pid))}),P(d)):h(new Error(`Root process ${D} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let u=function(){let y=[d];const b=[];for(;y.length;){const f=y.shift();f&&(b.push(f.pid),f.children&&(y=y.concat(f.children)))}let c=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+b.join(" "),(0,E.exec)(c,{},(f,l,v)=>{if(f||v)h(f||new Error(v.toString()));else{const I=l.toString().split(`
`);for(let p=0;p<b.length;p++){const t=m.get(b[p]);t.load=parseFloat(I[p])}if(!d){h(new Error(`Root process ${D} not found`));return}P(d)}})};(0,E.exec)("which ps",{},(y,b,c)=>{if(y||c)if(process.platform!=="linux")h(y||new Error(c.toString()));else{const f=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(f,{},(l,v,I)=>{l||I?h(l||new Error(I.toString())):(_(v,g),u())})}else{const f=b.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${f} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,I,p)=>{v||p&&!p.includes("screen size is bogus")?h(v||new Error(p.toString())):(_(I,g),process.platform==="linux"?u():d?P(d):h(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=n;function _(D,P){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=D.toString().split(`
`);for(const m of d){const g=h.exec(m.trim());g&&g.length===6&&P(parseInt(g[1]),parseInt(g[2]),g[5],parseFloat(g[3]),parseFloat(g[4]))}}}),define(ee[109],te([0,1,27,4,107,89]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function D(g,S){return g===1?A.isWindows?m():_.getWindowsShell(S):h(g,S)}e.getSystemShell=D;let P=null;function h(g,S){if(A.isLinux&&g===2||A.isMacintosh&&g===3)return"/bin/bash";if(!P){let u;if(A.isWindows)u="/bin/bash";else{if(u=S.SHELL,!u)try{u=(0,E.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}P=u}return P}let d=null;async function m(){return d||(d=(await(0,n.getFirstAvailablePowerShellInstallation)()).exePath),d}});var Ee=this&&this.__decorate||function(H,e,E,A){var n=arguments.length,_=n<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,E):A,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(H,e,E,A);else for(var P=H.length-1;P>=0;P--)(D=H[P])&&(_=(n<3?D(_):n>3?D(e,E,_):D(e,E))||_);return n>3&&_&&Object.defineProperty(e,E,_),_};define(ee[42],te([0,1,24,8,17,23,55,13,3,2,74,26,12]),function(H,e,E,A,n,_,D,P,h,d,m,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var u;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(u||(u={}));function y(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(b||(b={}));function c(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(f||(f={}));function l(z){let W=0;for(let U=0;;U+=7){const $=z.read(1);if(W|=($.buffer[0]&127)<<U,!($.buffer[0]&128))return W}}const v=s(0);function I(z,W){if(W===0){z.write(v);return}let U=0;for(let X=W;X!==0;X=X>>>7)U++;const $=n.VSBuffer.alloc(U);for(let X=0;W!==0;X++)$.buffer[X]=W&127,W=W>>>7,W>0&&($.buffer[X]|=128);z.write($)}class p{constructor(W){this.buffer=W,this.pos=0}read(W){const U=this.buffer.slice(this.pos,this.pos+W);return this.pos+=U.byteLength,U}}e.BufferReader=p;class t{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}e.BufferWriter=t;var a;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(a||(a={}));function s(z){const W=n.VSBuffer.alloc(1);return W.writeUInt8(z,0),W}const i={Undefined:s(a.Undefined),String:s(a.String),Buffer:s(a.Buffer),VSBuffer:s(a.VSBuffer),Array:s(a.Array),Object:s(a.Object),Uint:s(a.Int)},r=typeof Buffer<"u";function o(z,W){if(typeof W>"u")z.write(i.Undefined);else if(typeof W=="string"){const U=n.VSBuffer.fromString(W);z.write(i.String),I(z,U.byteLength),z.write(U)}else if(r&&Buffer.isBuffer(W)){const U=n.VSBuffer.wrap(W);z.write(i.Buffer),I(z,U.byteLength),z.write(U)}else if(W instanceof n.VSBuffer)z.write(i.VSBuffer),I(z,W.byteLength),z.write(W);else if(Array.isArray(W)){z.write(i.Array),I(z,W.length);for(const U of W)o(z,U)}else if(typeof W=="number"&&(W|0)===W)z.write(i.Uint),I(z,W);else{const U=n.VSBuffer.fromString(JSON.stringify(W));z.write(i.Object),I(z,U.byteLength),z.write(U)}}e.serialize=o;function w(z){switch(z.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return z.read(l(z)).toString();case a.Buffer:return z.read(l(z)).buffer;case a.VSBuffer:return z.read(l(z));case a.Array:{const U=l(z),$=[];for(let X=0;X<U;X++)$.push(w(z));return $}case a.Object:return JSON.parse(z.read(l(z)).toString());case a.Int:return l(z)}}e.deserialize=w;class k{constructor(W,U,$=null,X=1e3){this.protocol=W,this.ctx=U,this.logger=$,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(oe=>this.onRawMessage(oe)),this.sendResponse({type:200})}registerChannel(W,U){this.channels.set(W,U),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case 200:{const U=this.send([W.type]);this.logger?.logOutgoing(U,0,1,c(W.type));return}case 201:case 202:case 204:case 203:{const U=this.send([W.type,W.id],W.data);this.logger?.logOutgoing(U,W.id,1,c(W.type),W.data);return}}}send(W,U=void 0){const $=new t;return o($,W),o($,U),this.sendBuffer($.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const U=new p(W),$=w(U),X=w(U),oe=$[0];switch(oe){case 100:return this.logger?.logIncoming(W.byteLength,$[1],1,`${y(oe)}: ${$[2]}.${$[3]}`,X),this.onPromise({type:oe,id:$[1],channelName:$[2],name:$[3],arg:X});case 102:return this.logger?.logIncoming(W.byteLength,$[1],1,`${y(oe)}: ${$[2]}.${$[3]}`,X),this.onEventListen({type:oe,id:$[1],channelName:$[2],name:$[3],arg:X});case 101:return this.logger?.logIncoming(W.byteLength,$[1],1,`${y(oe)}`),this.disposeActiveRequest({type:oe,id:$[1]});case 103:return this.logger?.logIncoming(W.byteLength,$[1],1,`${y(oe)}`),this.disposeActiveRequest({type:oe,id:$[1]})}}onPromise(W){const U=this.channels.get(W.channelName);if(!U){this.collectPendingRequest(W);return}const $=new _.CancellationTokenSource;let X;try{X=U.call(this.ctx,W.name,W.arg,$.token)}catch(V){X=Promise.reject(V)}const oe=W.id;X.then(V=>{this.sendResponse({id:oe,data:V,type:201}),this.activeRequests.delete(W.id)},V=>{V instanceof Error?this.sendResponse({id:oe,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.sendResponse({id:oe,data:V,type:203}),this.activeRequests.delete(W.id)});const ce=(0,d.toDisposable)(()=>$.cancel());this.activeRequests.set(W.id,ce)}onEventListen(W){const U=this.channels.get(W.channelName);if(!U){this.collectPendingRequest(W);return}const $=W.id,oe=U.listen(this.ctx,W.name,W.arg)(ce=>this.sendResponse({id:$,data:ce,type:204}));this.activeRequests.set(W.id,oe)}disposeActiveRequest(W){const U=this.activeRequests.get(W.id);U&&(U.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let U=this.pendingRequests.get(W.channelName);U||(U=[],this.pendingRequests.set(W.channelName,U));const $=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);U.push({request:W,timeoutTimer:$})}flushPendingRequests(W){const U=this.pendingRequests.get(W);if(U){for(const $ of U)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=k;var M;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(M||(e.RequestInitiator=M={}));class C{constructor(W,U=null){this.protocol=W,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=U}getChannel(W){const U=this;return{call($,X,oe){return U.isDisposed?Promise.reject(new P.CancellationError):U.requestPromise(W,$,X,oe)},listen($,X){return U.isDisposed?h.Event.None:U.requestEvent(W,$,X)}}}requestPromise(W,U,$,X=_.CancellationToken.None){const oe=this.lastRequestId++,V={id:oe,type:100,channelName:W,name:U,arg:$};if(X.isCancellationRequested)return Promise.reject(new P.CancellationError);let R;return new Promise((N,q)=>{if(X.isCancellationRequested)return q(new P.CancellationError);const re=()=>{const Z=Q=>{switch(Q.type){case 201:this.handlers.delete(oe),N(Q.data);break;case 202:{this.handlers.delete(oe);const fe=new Error(Q.data.message);fe.stack=Array.isArray(Q.data.stack)?Q.data.stack.join(`
`):Q.data.stack,fe.name=Q.data.name,q(fe);break}case 203:this.handlers.delete(oe),q(Q.data);break}};this.handlers.set(oe,Z),this.sendRequest(V)};let ne=null;this.state===f.Idle?re():(ne=(0,A.createCancelablePromise)(Z=>this.whenInitialized()),ne.then(()=>{ne=null,re()}));const le=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:oe,type:101}),q(new P.CancellationError)},j=X.onCancellationRequested(le);R=(0,d.combinedDisposable)((0,d.toDisposable)(le),j),this.activeRequests.add(R)}).finally(()=>{this.activeRequests.delete(R)})}requestEvent(W,U,$){const X=this.lastRequestId++,ce={id:X,type:102,channelName:W,name:U,arg:$};let V=null;const R=new h.Emitter({onWillAddFirstListener:()=>{V=(0,A.createCancelablePromise)(N=>this.whenInitialized()),V.then(()=>{V=null,this.activeRequests.add(R),this.sendRequest(ce)})},onDidRemoveLastListener:()=>{V?(V.cancel(),V=null):(this.activeRequests.delete(R),this.sendRequest({id:X,type:103}))}}),O=N=>R.fire(N.data);return this.handlers.set(X,O),R.event}sendRequest(W){switch(W.type){case 100:case 102:{const U=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger?.logOutgoing(U,W.id,0,`${y(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const U=this.send([W.type,W.id]);this.logger?.logOutgoing(U,W.id,0,y(W.type));return}}}send(W,U=void 0){const $=new t;return o($,W),o($,U),this.sendBuffer($.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const U=new p(W),$=w(U),X=w(U),oe=$[0];switch(oe){case 200:return this.logger?.logIncoming(W.byteLength,0,0,c(oe)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(W.byteLength,$[1],0,c(oe),X),this.onResponse({type:$[0],id:$[1],data:X})}}onResponse(W){if(W.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(W.id)?.(W)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=C,Ee([D.memoize],C.prototype,"onDidInitializePromise",null);class L{get connections(){const W=[];return this._connections.forEach(U=>W.push(U)),W}constructor(W){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,W(({protocol:U,onDidClientDisconnect:$})=>{h.Event.once(U.onMessage)(oe=>{const ce=new p(oe),V=w(ce),R=new k(U,V),O=new C(U);this.channels.forEach((q,re)=>R.registerChannel(re,q));const N={channelServer:R,channelClient:O,ctx:V};this._connections.add(N),this._onDidAddConnection.fire(N),$(()=>{R.dispose(),O.dispose(),this._connections.delete(N),this._onDidRemoveConnection.fire(N)})})})}getChannel(W,U){const $=this;return{call(X,oe,ce){let V;if((0,S.isFunction)(U)){const O=(0,E.getRandomElement)($.connections.filter(U));V=O?Promise.resolve(O):h.Event.toPromise(h.Event.filter($.onDidAddConnection,U))}else V=U.routeCall($,X,oe);const R=V.then(O=>O.channelClient.getChannel(W));return F(R).call(X,oe,ce)},listen(X,oe){if((0,S.isFunction)(U))return $.getMulticastEvent(W,U,X,oe);const ce=U.routeEvent($,X,oe).then(V=>V.channelClient.getChannel(W));return F(ce).listen(X,oe)}}}getMulticastEvent(W,U,$,X){const oe=this;let ce=new d.DisposableStore;const V=new h.Emitter({onWillAddFirstListener:()=>{ce=new d.DisposableStore;const R=new h.EventMultiplexer,O=new Map,N=re=>{const le=re.channelClient.getChannel(W).listen($,X),j=R.add(le);O.set(re,j)},q=re=>{const ne=O.get(re);ne&&(ne.dispose(),O.delete(re))};oe.connections.filter(U).forEach(N),h.Event.filter(oe.onDidAddConnection,U)(N,void 0,ce),oe.onDidRemoveConnection(q,void 0,ce),R.event(V.fire,V,ce),ce.add(R)},onDidRemoveLastListener:()=>{ce.dispose()}});return V.event}registerChannel(W,U){this.channels.set(W,U),this._connections.forEach($=>{$.channelServer.registerChannel(W,U)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class T{constructor(W,U,$=null){const X=new t;o(X,U),W.send(X.buffer),this.channelClient=new C(W,$),this.channelServer=new k(W,U,$)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,U){this.channelServer.registerChannel(W,U)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function F(z){return{call(W,U,$){return z.then(X=>X.call(W,U,$))},listen(W,U){const $=new h.Relay;return z.then(X=>$.input=X.listen(W,U)),$.event}}}e.getDelayedChannel=F;function B(z){let W=!1;return{call(U,$,X){return W?z.call(U,$,X):(0,A.timeout)(0).then(()=>W=!0).then(()=>z.call(U,$,X))},listen(U,$){if(W)return z.listen(U,$);const X=new h.Relay;return(0,A.timeout)(0).then(()=>W=!0).then(()=>X.input=z.listen(U,$)),X.event}}}e.getNextTickChannel=B;class se{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const U of W.connections)if(await Promise.resolve(this.fn(U.ctx)))return Promise.resolve(U);return await h.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=se;var ie;(function(z){function W(oe,ce){const V=oe,R=ce&&ce.disableMarshalling,O=new Map;for(const N in V)$(N)&&O.set(N,h.Event.buffer(V[N],!0));return new class{listen(N,q,re){const ne=O.get(q);if(ne)return ne;if(X(q)){const le=V[q];if(typeof le=="function")return le.call(V,re)}throw new P.ErrorNoTelemetry(`Event not found: ${q}`)}call(N,q,re){const ne=V[q];if(typeof ne=="function"){if(!R&&Array.isArray(re))for(let le=0;le<re.length;le++)re[le]=(0,m.revive)(re[le]);return ne.apply(V,re)}throw new P.ErrorNoTelemetry(`Method not found: ${q}`)}}}z.fromService=W;function U(oe,ce){const V=ce&&ce.disableMarshalling;return new Proxy({},{get(R,O){if(typeof O=="string")return ce?.properties?.has(O)?ce.properties.get(O):X(O)?function(N){return oe.listen(O,N)}:$(O)?oe.listen(O):async function(...N){let q;ce&&!(0,S.isUndefinedOrNull)(ce.context)?q=[ce.context,...N]:q=N;const re=await oe.call(O,q);return V?re:(0,m.revive)(re)};throw new P.ErrorNoTelemetry(`Property not found: ${String(O)}`)}})}z.toService=U;function $(oe){return oe[0]==="o"&&oe[1]==="n"&&g.isUpperAsciiLetter(oe.charCodeAt(2))}function X(oe){return/^onDynamic/.test(oe)&&g.isUpperAsciiLetter(oe.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const de=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const W=z.toString();if(W!=="[object Object]")return W}return z}function ue(z){return Array.isArray(z)?z.map(ae):ae(z)}function x(z,W,U,$,X,oe,ce){ce=ue(ce);const V=de[X],R=V[$%V.length];let O=[`%c[${z}]%c[${String(W).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String($).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(oe)?(O=O.concat(ce),O.push(")")):O.push(ce),console.log.apply(console,O)}class G{constructor(W,U){this._outgoingPrefix=W,this._incomingPrefix=U,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,U,$,X,oe){this._totalOutgoing+=W,x(this._outgoingPrefix,this._totalOutgoing,W,U,$,X,oe)}logIncoming(W,U,$,X,oe){this._totalIncoming+=W,x(this._incomingPrefix,this._totalIncoming,W,U,$,X,oe)}}e.IPCLogger=G}),define(ee[156],te([0,1,17,3,42]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class _{constructor(h){this.port=h,this.onMessage=A.Event.fromDOMEventEmitter(this.port,"message",d=>E.VSBuffer.wrap(d.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=_;class D extends n.IPCClient{constructor(h,d){const m=new _(h);super(m,d),this.protocol=m}dispose(){this.protocol.disconnect()}}e.Client=D}),define(ee[110],te([0,1,17,3,2,42]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let o=0;function w(M,C){if(!r.has(M)){const L=String(++o);r.set(M,L)}return r.get(M)}function k(M,C,L,T){if(!i.enableDiagnostics)return;const F=w(M,C);if(T instanceof E.VSBuffer||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const B=E.VSBuffer.alloc(T.byteLength);B.set(T),i.records.push({timestamp:Date.now(),id:F,label:C,type:L,buff:B})}else i.records.push({timestamp:Date.now(),id:F,label:C,type:L,data:T})}i.traceSocketEvent=k})(P||(e.SocketDiagnostics=P={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let d=null;function m(){return d||(d=E.VSBuffer.alloc(0)),d}class g{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,o){if(r===0)return m();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const C=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=r),C}if(this._chunks[0].byteLength>r){const C=this._chunks[0].slice(0,r);return o&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),C}const w=E.VSBuffer.alloc(r);let k=0,M=0;for(;r>0;){const C=this._chunks[M];if(C.byteLength>r){const L=C.slice(0,r);w.set(L,k),k+=r,o&&(this._chunks[M]=C.slice(r),this._totalLength-=r),r-=r}else w.set(C,k),k+=C.byteLength,o?(this._chunks.shift(),this._totalLength-=C.byteLength):M++,r-=C.byteLength}return w}}e.ChunkStream=g;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(S||(S={}));function u(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class b{constructor(r,o,w,k){this.type=r,this.id=o,this.ack=w,this.data=k,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends n.Disposable{constructor(r){super(),this._onMessage=this._register(new A.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new g,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:u(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const w=this._state.messageType,k=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new b(w,k,M,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=E.VSBuffer.alloc(13);o.writeUInt8(r.type,0),o.writeUInt32BE(r.id,1),o.writeUInt32BE(r.ack,5),o.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:u(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(o,r.data)}_bufferAdd(r,o){const w=this._totalLength===0;return this._data.push(r,o),this._totalLength+=r.byteLength+o.byteLength,w}_bufferTake(){const r=E.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,o){this._bufferAdd(r,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class l extends n.Disposable{constructor(r){super(),this._onMessage=new A.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new A.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new c(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new b(1,0,0,r))}}e.Protocol=l;class v extends _.IPCClient{static fromSocket(r,o){return new v(new l(r),o)}get onDidDispose(){return this.protocol.onDidDispose}constructor(r,o,w=null){super(r,o,w),this.protocol=r}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=v;class I{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new A.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=I;class p{constructor(r){this.data=r,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let r=0,o=this._first;for(;o;)o=o.next,r++;return r}peek(){return this._first?this._first.data:null}toArray(){const r=[];let o=0,w=this._first;for(;w;)r[o++]=w.data,w=w.next;return r}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const o=new p(r);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class a{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}constructor(){this.lastRuns=[];const r=Date.now();for(let o=0;o<a._HISTORY_LENGTH;o++)this.lastRuns[o]=r-1e3*o;setInterval(()=>{for(let o=a._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}load(){const r=Date.now(),o=(1+a._HISTORY_LENGTH)*1e3;let w=0;for(let k=0;k<a._HISTORY_LENGTH;k++)r-this.lastRuns[k]<=o&&w++;return 1-w/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(r){this._onControlMessage=new I,this.onControlMessage=this._onControlMessage.event,this._onMessage=new I,this.onMessage=this._onMessage.event,this._onDidDispose=new I,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new I,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new I,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=r.loadEstimator??a.getInstance(),this._shouldSendKeepAlive=r.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new n.DisposableStore,this._socket=r.socket,this._socketWriter=this._socketDisposables.add(new f(this._socket)),this._socketReader=this._socketDisposables.add(new c(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.add(this._socket.onClose(o=>this._onSocketClose.fire(o))),r.initialChunk&&this._socketReader.acceptChunk(r.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new b(5,0,0,m());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new b(7,0,0,m());this._socketWriter.write(r)}sendResume(){const r=new b(8,0,0,m());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,o){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new n.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=this._socketDisposables.add(new f(this._socket)),this._socketReader=this._socketDisposables.add(new c(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.add(this._socket.onClose(w=>this._onSocketClose.fire(w))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new b(3,0,this._incomingAckId,m());this._socketWriter.write(r);const o=this._outgoingUnackMsg.toArray();for(let w=0,k=o.length;w<k;w++)this._socketWriter.write(o[w]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new b(6,0,0,m())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let w=0,k=o.length;w<k;w++)this._socketWriter.write(o[w]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const w=new b(1,o,this._incomingAckId,r);this._outgoingUnackMsg.push(w),this._isReconnecting||(this._socketWriter.write(w),this._recvAckCheck())}sendControl(r){const o=new b(2,0,0,r);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),o=Date.now()-r.writtenTime,w=Date.now()-this._socketReader.lastReadTime,k=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&w>=2e4&&k>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:w});return}const M=Math.max(2e4-o,2e4-w,2e4-k,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new b(3,0,this._incomingAckId,m());this._socketWriter.write(r)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const r=new b(9,0,this._incomingAckId,m());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(ee[157],te([0,1,38,17,3,2,42,145]),function(H,e,E,A,n,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(m,g){const S=n.Event.fromNodeEventEmitter(E.validatedIpcMain,g,(y,b)=>({event:y,message:b})),u=n.Event.filter(S,({event:y})=>y.sender.id===m);return n.Event.map(u,({message:y})=>y&&A.VSBuffer.wrap(y))}class d extends D.IPCServer{static{this.Clients=new Map}static getOnDidClientConnect(){const g=n.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:S})=>S);return n.Event.map(g,S=>{const u=S.id;d.Clients.get(u)?.dispose();const b=new n.Emitter;d.Clients.set(u,(0,_.toDisposable)(()=>b.fire()));const c=h(u,"vscode:message"),f=n.Event.any(n.Event.signal(h(u,"vscode:disconnect")),b.event);return{protocol:new P.Protocol(S,c),onDidClientDisconnect:f}})}constructor(){super(d.getOnDidClientConnect())}}e.Server=d}),define(ee[111],te([0,1,38,3,31,156]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends _.Client{constructor(d,m){super({addEventListener:(g,S)=>d.addListener(g,S),removeEventListener:(g,S)=>d.removeListener(g,S),postMessage:g=>d.postMessage(g),start:()=>d.start(),close:()=>d.close()},m)}}e.Client=D;async function P(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const d=(0,n.generateUuid)();h.webContents.send("vscode:createMessageChannel",d);const m=A.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(S,u)=>({nonce:u,port:S.ports[0]})),{port:g}=await A.Event.toPromise(A.Event.once(A.Event.filter(m,S=>S.nonce===d)));return g}e.connect=P}),define(ee[158],te([0,1,47,8,17,23,153,13,3,2,37,89,73,42]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends u.ChannelServer{constructor(f){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",l=>n.VSBuffer.wrap(Buffer.from(l,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=y;class b{constructor(f,l){this.modulePath=f,this.options=l,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=l&&l.timeout?l.timeout:6e4;this.disposeDelayer=new A.Delayer(v),this.child=null,this._client=null}getChannel(f){const l=this;return{call(v,I,p){return l.requestPromise(f,v,I,p)},listen(v,I){return l.requestEvent(f,v,I)}}}requestPromise(f,l,v,I=_.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(I.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const p=this.getCachedChannel(f),t=(0,A.createCancelablePromise)(i=>p.call(l,v,i)),a=I.onCancellationRequested(()=>t.cancel()),s=(0,d.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{a.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(f,l,v){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let I;const p=new h.Emitter({onWillAddFirstListener:()=>{I=this.getCachedChannel(f).listen(l,v)(p.fire,p),this.activeRequests.add(I)},onDidRemoveLastListener:()=>{this.activeRequests.delete(I),I.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return p.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],l=Object.create(null);l.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(l.env={...l.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(l.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,S.removeDangerousEnvVariables)(l.env),this.child=(0,E.fork)(this.modulePath,f,l);const v=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,D.isRemoteConsoleLog)(r)){(0,D.log)(r,`IPC Library: ${this.options.serverName}`);return}v.fire(n.VSBuffer.wrap(Buffer.from(r,"base64")))});const p=this.options.useQueue?(0,g.createQueuedSender)(this.child):this.child,t=r=>this.child&&this.child.connected&&p.send(r.buffer.toString("base64")),a=v.event,s={send:t,onMessage:a};this._client=new u.ChannelClient(s);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(w=>(0,d.dispose)(w)),this.activeRequests.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+o),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:o})})}return this._client}getCachedChannel(f){let l=this.channels.get(f);return l||(l=this.client.getChannel(f),this.channels.set(f,l)),l}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=b}),define(ee[112],te([0,1,8,3,2,74,12]),function(H,e,E,A,n,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var P;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function h(S){const u=S;return u?.changed instanceof Map||u?.deleted instanceof Set}e.isStorageItemsChangeEvent=h;var d;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(d||(e.StorageState=d={}));class m extends n.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(u,y=Object.create(null)){super(),this.database=u,this.options=y,this._onDidChangeStorage=this._register(new A.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new E.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(u=>this.onDidChangeItemsExternal(u)))}onDidChangeItemsExternal(u){this._onDidChangeStorage.pause();try{u.changed?.forEach((y,b)=>this.acceptExternal(b,y)),u.deleted?.forEach(y=>this.acceptExternal(y,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(u,y){if(this.state===d.Closed)return;let b=!1;(0,D.isUndefinedOrNull)(y)?b=this.cache.delete(u):this.cache.get(u)!==y&&(this.cache.set(u,y),b=!0),b&&this._onDidChangeStorage.fire({key:u,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(u,y){const b=this.cache.get(u);return(0,D.isUndefinedOrNull)(b)?y:b}getBoolean(u,y){const b=this.get(u);return(0,D.isUndefinedOrNull)(b)?y:b==="true"}getNumber(u,y){const b=this.get(u);return(0,D.isUndefinedOrNull)(b)?y:parseInt(b,10)}getObject(u,y){const b=this.get(u);return(0,D.isUndefinedOrNull)(b)?y:(0,_.parse)(b)}async set(u,y,b=!1){if(this.state===d.Closed)return;if((0,D.isUndefinedOrNull)(y))return this.delete(u,b);const c=(0,D.isObject)(y)||Array.isArray(y)?(0,_.stringify)(y):String(y);if(this.cache.get(u)!==c)return this.cache.set(u,c),this.pendingInserts.set(u,c),this.pendingDeletes.delete(u),this._onDidChangeStorage.fire({key:u,external:b}),this.doFlush()}async delete(u,y=!1){if(!(this.state===d.Closed||!this.cache.delete(u)))return this.pendingDeletes.has(u)||this.pendingDeletes.add(u),this.pendingInserts.delete(u),this._onDidChangeStorage.fire({key:u,external:y}),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const u={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(u).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(u){if(this.hasPending)return this.doFlush(u)}async doFlush(u){return this.flushDelayer.trigger(()=>this.flushPending(),u)}async whenFlushed(){if(this.hasPending)return new Promise(u=>this.whenFlushedCallbacks.push(u))}isInMemory(){return this.options.hint===P.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m;class g{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(u){u.insert?.forEach((y,b)=>this.items.set(b,y)),u.delete?.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=g}),define(ee[159],te([0,1,8,3,35,9,21]),function(H,e,E,A,n,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return A.Event.None}static{this.BUSY_OPEN_TIMEOUT=2e3}static{this.MAX_HOST_PARAMETERS=256}constructor(m,g=Object.create(null)){this.path=m,this.options=g,this.name=(0,_.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const m=await this.whenConnected,g=new Map;return(await this.all(m,"SELECT * FROM ItemTable")).forEach(u=>g.set(u.key,u.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${g.size} rows`),g}async updateItems(m){const g=await this.whenConnected;return this.doUpdateItems(g,m)}doUpdateItems(m,g){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${g.insert?(0,n.mapToString)(g.insert):"0"}), delete(${g.delete?(0,n.setToString)(g.delete):"0"})`),this.transaction(m,()=>{const S=g.insert,u=g.delete;if(S&&S.size>0){const y=[];y.push([]);let b=0;S.forEach((c,f)=>{let l=y[b];l.length>P.MAX_HOST_PARAMETERS&&(b++,l=[],y.push(l)),l.push(f,c)}),y.forEach(c=>{this.prepare(m,`INSERT INTO ItemTable VALUES ${new Array(c.length/2).fill("(?,?)").join(",")}`,f=>f.run(c),()=>{const f=[];let l=0;return S.forEach((v,I)=>{f.push(I),l+=v.length}),`Keys: ${f.join(", ")} Length: ${l}`})})}if(u&&u.size){const y=[];y.push([]);let b=0;u.forEach(c=>{let f=y[b];f.length>P.MAX_HOST_PARAMETERS&&(b++,f=[],y.push(f)),f.push(c)}),y.forEach(c=>{this.prepare(m,`DELETE FROM ItemTable WHERE key IN (${new Array(c.length).fill("?").join(",")})`,f=>f.run(c),()=>{const f=[];return u.forEach(l=>{f.push(l)}),`Keys: ${f.join(", ")}`})})}})}async close(m){this.logger.trace(`[storage ${this.name}] close()`);const g=await this.whenConnected;return this.doClose(g,m)}doClose(m,g){return new Promise((S,u)=>{m.db.close(y=>(y&&this.handleSQLiteError(m,`[storage ${this.name}] close(): ${y}`),this.path===P.IN_MEMORY_PATH?S():!m.isErroneous&&!m.isInMemory?this.backup().then(S,b=>(this.logger.error(`[storage ${this.name}] backup(): ${b}`),S())):typeof g=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(b=>{const c=()=>this.doClose(b,void 0);return this.doUpdateItems(b,{insert:g()}).then(()=>c(),f=>(c(),Promise.reject(f)))})).then(S,u):u(y||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const m=this.toBackupPath(this.path);return D.Promises.copy(this.path,m,{preserveSymlinks:!1})}toBackupPath(m){return`${m}.backup`}async checkIntegrity(m){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${m})`);const g=await this.whenConnected,S=await this.get(g,m?"PRAGMA integrity_check":"PRAGMA quick_check"),u=m?S.integrity_check:S.quick_check;return g.isErroneous?`${u} (last error: ${g.lastError})`:g.isInMemory?`${u} (in-memory!)`:u}async connect(m,g=!0){this.logger.trace(`[storage ${this.name}] open(${m}, retryOnBusy: ${g})`);try{return await this.doConnect(m)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&g)return await(0,E.timeout)(P.BUSY_OPEN_TIMEOUT),this.connect(m,!1);try{await D.Promises.unlink(m);try{await D.Promises.rename(this.toBackupPath(m),m,!1)}catch{}return await this.doConnect(m)}catch(u){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${u}`),this.doConnect(P.IN_MEMORY_PATH)}}}handleSQLiteError(m,g){m.isErroneous=!0,m.lastError=g,this.logger.error(g)}doConnect(m){return new Promise((g,S)=>{new Promise((u,y)=>{H(["@vscode/sqlite3"],u,y)}).then(u=>{const y={db:new(this.logger.isTracing?u.verbose().Database:u.Database)(m,b=>b?y.db&&b.code!=="SQLITE_CANTOPEN"?y.db.close(()=>S(b)):S(b):this.exec(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>g(y),c=>y.db.close(()=>S(c)))),isInMemory:m===P.IN_MEMORY_PATH};y.db.on("error",b=>this.handleSQLiteError(y,`[storage ${this.name}] Error (event): ${b}`)),this.logger.isTracing&&y.db.on("trace",b=>this.logger.trace(`[storage ${this.name}] Trace (event): ${b}`))},S)})}exec(m,g){return new Promise((S,u)=>{m.db.exec(g,y=>y?(this.handleSQLiteError(m,`[storage ${this.name}] exec(): ${y}`),u(y)):S())})}get(m,g){return new Promise((S,u)=>{m.db.get(g,(y,b)=>y?(this.handleSQLiteError(m,`[storage ${this.name}] get(): ${y}`),u(y)):S(b))})}all(m,g){return new Promise((S,u)=>{m.db.all(g,(y,b)=>y?(this.handleSQLiteError(m,`[storage ${this.name}] all(): ${y}`),u(y)):S(b))})}transaction(m,g){return new Promise((S,u)=>{m.db.serialize(()=>{m.db.run("BEGIN TRANSACTION"),g(),m.db.run("END TRANSACTION",y=>y?(this.handleSQLiteError(m,`[storage ${this.name}] transaction(): ${y}`),u(y)):S())})})}prepare(m,g,S,u){const y=m.db.prepare(g),b=c=>{this.handleSQLiteError(m,`[storage ${this.name}] prepare(): ${c} (${g}). Details: ${u()}`)};y.on("error",b),S(y),y.finalize(c=>{c&&b(c),y.removeListener("error",b)})}}e.SQLiteStorageDatabase=P;class h{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor(m){m&&typeof m.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=m.logTrace),m&&typeof m.logError=="function"&&(this.logError=m.logError)}get isTracing(){return!!this.logTrace}trace(m){this.logTrace?.(m)}error(m){this.logError?.(m)}}}),define(ee[160],te([11,10]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(ee[161],te([11,10]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[162],te([11,10]),function(H,e){return H.create("vs/platform/contextkey/common/contextkey",e)}),define(ee[163],te([11,10]),function(H,e){return H.create("vs/platform/contextkey/common/scanner",e)}),define(ee[164],te([11,10]),function(H,e){return H.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[165],te([11,10]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[166],te([11,10]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(ee[167],te([11,10]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(ee[168],te([11,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[169],te([11,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[170],te([11,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[171],te([11,10]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[172],te([11,10]),function(H,e){return H.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[173],te([11,10]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(ee[174],te([11,10]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(ee[175],te([11,10]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(ee[176],te([11,10]),function(H,e){return H.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[177],te([11,10]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[178],te([11,10]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[179],te([11,10]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[180],te([11,10]),function(H,e){return H.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[181],te([11,10]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(ee[182],te([11,10]),function(H,e){return H.create("vs/platform/shell/node/shellEnv",e)}),define(ee[183],te([11,10]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[184],te([11,10]),function(H,e){return H.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ee[185],te([11,10]),function(H,e){return H.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ee[186],te([11,10]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[187],te([11,10]),function(H,e){return H.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[188],te([11,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[189],te([11,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[190],te([11,10]),function(H,e){return H.create("vs/platform/workspace/common/workspace",e)}),define(ee[191],te([11,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[192],te([11,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[193],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(n){return n&&n.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function A(n){return n&&n.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=A}),define(ee[194],te([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function A(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=A;function n(D){let P=[];try{Array.isArray(D.workspaces)&&(P=D.workspaces.map(h=>({workspace:{id:h.id,configPath:E.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=n;function _(D){let P=[];try{Array.isArray(D.folders)&&(P=D.folders.map(h=>({folderUri:E.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=_}),define(ee[195],te([0,1,13,163]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var n;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(n||(e.TokenType=n={}));function _(...d){switch(d.length){case 1:return(0,A.localize)(0,null,d[0]);case 2:return(0,A.localize)(1,null,d[0],d[1]);case 3:return(0,A.localize)(2,null,d[0],d[1],d[2]);default:return}}const D=(0,A.localize)(3,null),P=(0,A.localize)(4,null);class h{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return m.isTripleEq?"===":"==";case 4:return m.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return m.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return m.lexeme;case 18:return m.lexeme;case 19:return m.lexeme;case 20:return"EOF";default:throw(0,E.illegalState)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(m){return this._input=m,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const g=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:g})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const g=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:g})}else this._match(126)?this._addToken(9):this._error(_("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(_("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(_("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(m){return this._isAtEnd()||this._input.charCodeAt(this._current)!==m?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(m){this._tokens.push({type:m,offset:this._start})}_error(m){const g=this._start,S=this._input.substring(this._start,this._current),u={type:19,offset:this._start,lexeme:S};this._errors.push({offset:g,lexeme:S,additionalInfo:m}),this._tokens.push(u)}_string(){this.stringRe.lastIndex=this._start;const m=this.stringRe.exec(this._input);if(m){this._current=this._start+m[0].length;const g=this._input.substring(this._start,this._current),S=h._keywords.get(g);S?this._addToken(S):this._tokens.push({type:17,lexeme:g,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(D);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let m=this._current,g=!1,S=!1;for(;;){if(m>=this._input.length){this._current=m,this._error(P);return}const y=this._input.charCodeAt(m);if(g)g=!1;else if(y===47&&!S){m++;break}else y===91?S=!0:y===92?g=!0:y===93&&(S=!1);m++}for(;m<this._input.length&&h._regexFlags.has(this._input.charCodeAt(m));)m++;this._current=m;const u=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:u,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=h}),define(ee[196],te([0,1,3,2]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class n{constructor(){this._onCloseEmitter=new E.Emitter,this._onReloadEmitter=new E.Emitter,this._onTerminateEmitter=new E.Emitter,this._onAttachEmitter=new E.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(P,h,d){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:d[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:d[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:d[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:d[0],port:d[1],subId:d[2]}))}throw new Error("Method not implemented.")}listen(P,h,d){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=n;class _ extends A.Disposable{constructor(P){super(),this.channel=P}reload(P){this.channel.call("reload",[P])}get onReload(){return this.channel.listen("reload")}close(P){this.channel.call("close",[P])}get onClose(){return this.channel.listen("close")}attachSession(P,h,d){this.channel.call("attach",[P,h,d])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(P,h){this.channel.call("terminate",[P,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(P,h){return this.channel.call("openExtensionDevelopmentHostWindow",[P,h])}}e.ExtensionHostDebugChannelClient=_}),define(ee[197],te([0,1,148,55,15,9,36,19,7]),function(H,e,E,A,n,_,D,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class d{get appRoot(){return(0,_.dirname)(n.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,_.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,_.join)(this.userDataPath,"logs",u)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(h.URI.file((0,_.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=D.env.VSCODE_PORTABLE;return u?h.URI.file((0,_.join)(u,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,_.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,_.resolve)(u):(0,_.normalize)((0,_.join)(n.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?h.URI.file((0,_.resolve)(u)):h.URI.file((0,_.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,_.resolve)(u);const y=D.env.VSCODE_EXTENSIONS;if(y)return y;const b=D.env.VSCODE_PORTABLE;return b?(0,_.join)(b,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(y=>/^[^:/?#]+?:\/\//.test(y)?h.URI.parse(y):h.URI.file((0,_.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?h.URI.parse(u):h.URI.file((0,_.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(u))}get extensionLogLevel(){const u=[];for(const y of this.args.log||[]){const b=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);b&&b[1]&&b[2]&&u.push([b[1],b[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get disableKeytar(){return!!this.args["disable-keytar"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=D.env.VSCODE_PORTABLE;return u?h.URI.file((0,_.join)(u,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this._args}constructor(u,y,b){this._args=u,this.paths=y,this.productService=b,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=d,Ee([A.memoize],d.prototype,"appRoot",null),Ee([A.memoize],d.prototype,"userHome",null),Ee([A.memoize],d.prototype,"userDataPath",null),Ee([A.memoize],d.prototype,"appSettingsHome",null),Ee([A.memoize],d.prototype,"tmpDir",null),Ee([A.memoize],d.prototype,"cacheHome",null),Ee([A.memoize],d.prototype,"stateResource",null),Ee([A.memoize],d.prototype,"userRoamingDataHome",null),Ee([A.memoize],d.prototype,"userDataSyncHome",null),Ee([A.memoize],d.prototype,"sync",null),Ee([A.memoize],d.prototype,"machineSettingsResource",null),Ee([A.memoize],d.prototype,"workspaceStorageHome",null),Ee([A.memoize],d.prototype,"localHistoryHome",null),Ee([A.memoize],d.prototype,"keyboardLayoutResource",null),Ee([A.memoize],d.prototype,"argvResource",null),Ee([A.memoize],d.prototype,"isExtensionDevelopment",null),Ee([A.memoize],d.prototype,"untitledWorkspacesHome",null),Ee([A.memoize],d.prototype,"builtinExtensionsPath",null),Ee([A.memoize],d.prototype,"extensionsPath",null),Ee([A.memoize],d.prototype,"extensionDevelopmentLocationURI",null),Ee([A.memoize],d.prototype,"extensionDevelopmentKind",null),Ee([A.memoize],d.prototype,"extensionTestsLocationURI",null),Ee([A.memoize],d.prototype,"debugExtensionHost",null),Ee([A.memoize],d.prototype,"logLevel",null),Ee([A.memoize],d.prototype,"extensionLogLevel",null),Ee([A.memoize],d.prototype,"serviceMachineIdResource",null),Ee([A.memoize],d.prototype,"disableTelemetry",null),Ee([A.memoize],d.prototype,"disableWorkspaceTrust",null),Ee([A.memoize],d.prototype,"disableKeytar",null),Ee([A.memoize],d.prototype,"policyFile",null);function m(S,u){return g(S["inspect-extensions"],S["inspect-brk-extensions"],5870,u,S.debugId,S.extensionEnvironment)}e.parseExtensionHostDebugPort=m;function g(S,u,y,b,c,f){const v=Number(u||S)||(b?null:y),I=v?!!u:!1;let p;if(f)try{p=JSON.parse(f)}catch{}return{port:v,break:I,debugId:c,env:p}}e.parseDebugParams=g}),define(ee[113],te([0,1,308,4,166]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0;const _={o:(0,n.localize)(0,null),e:(0,n.localize)(1,null),t:(0,n.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,n.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,n.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,n.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,n.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,n.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,n.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,n.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,n.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,n.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,n.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,n.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,n.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,n.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,n.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,n.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,n.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,n.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,n.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,n.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,n.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,n.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,n.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,n.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,n.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,n.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,n.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,n.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,n.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,n.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,n.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,n.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,n.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,n.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,n.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(b,c,f=D){const l=b.find(o=>o.length>0&&o[0]!=="-"),v={},I=["_"],p=[],t={};let a;for(const o in c){const w=c[o];w.type==="subcommand"?o===l&&(a=w):(w.alias&&(v[o]=w.alias),w.type==="string"||w.type==="string[]"?(I.push(o),w.deprecates&&I.push(...w.deprecates)):w.type==="boolean"&&(p.push(o),w.deprecates&&p.push(...w.deprecates)),w.global&&(t[o]=w))}if(a&&l){const o=t;for(const C in a.options)o[C]=a.options[C];const w=b.filter(C=>C!==l),k=f.getSubcommandReporter?f.getSubcommandReporter(l):void 0,M=P(w,o,k);return{[l]:M,_:[]}}const s=E(b,{string:I,boolean:p,alias:v}),i={},r=s;i._=s._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(const o in c){const w=c[o];if(w.type==="subcommand")continue;w.alias&&delete r[w.alias];let k=r[o];if(w.deprecates)for(const M of w.deprecates)r.hasOwnProperty(M)&&(k||(k=r[M],k&&f.onDeprecatedOption(M,w.deprecationMessage||(0,n.localize)(37,null,o))),delete r[M]);if(typeof k<"u"){if(w.type==="string[]"){if(Array.isArray(k)||(k=[k]),!w.allowEmptyValue){const M=k.filter(C=>C.length>0);M.length!==k.length&&(f.onEmptyValue(o),k=M.length>0?M:void 0)}}else w.type==="string"&&(Array.isArray(k)?(k=k.pop(),f.onMultipleValues(o,k)):!k&&!w.allowEmptyValue&&(f.onEmptyValue(o),k=void 0));i[o]=k,w.deprecationMessage&&f.onDeprecatedOption(o,w.deprecationMessage)}delete r[o]}for(const o in r)f.onUnknownOption(o);return i}e.parseArgs=P;function h(b,c){let f="";return c.args&&(Array.isArray(c.args)?f=` <${c.args.join("> <")}>`:f=` <${c.args}>`),c.alias?`-${c.alias} --${b}${f}`:`--${b}${f}`}function d(b,c){const f=[];for(const l in b){const v=b[l],I=h(l,v);f.push([I,v.description])}return m(f,c)}e.formatOptions=d;function m(b,c){const l=b.reduce((p,t)=>Math.max(p,t[0].length),12)+2+1;if(c-l<25)return b.reduce((p,t)=>p.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const v=c-l-1,I=[];for(const p of b){const t=p[0],a=S(p[1],v),s=g(l-t.length-2);I.push("  "+t+s+a[0]);for(let i=1;i<a.length;i++)I.push(g(l)+a[i])}return I}function g(b){return" ".repeat(b)}function S(b,c){const f=[];for(;b.length;){const l=b.length<c?b.length:b.lastIndexOf(" ",c),v=b.slice(0,l).trim();b=b.slice(l),f.push(v)}return f}function u(b,c,f,l,v){const I=process.stdout.isTTY&&process.stdout.columns||80,p=v?.noInputFiles!==!0?`[${(0,n.localize)(38,null)}...]`:"",t=[`${b} ${f}`];t.push(""),t.push(`${(0,n.localize)(39,null)}: ${c} [${(0,n.localize)(40,null)}]${p}`),t.push(""),v?.noPipe!==!0&&(A.isWindows?t.push((0,n.localize)(41,null,c)):t.push((0,n.localize)(42,null,c)),t.push(""));const a={},s=[];for(const i in l){const r=l[i];if(r.type==="subcommand")r.description&&s.push({command:i,description:r.description});else if(r.description&&r.cat){let o=a[r.cat];o||(a[r.cat]=o={}),o[i]=r}}for(const i in a){const r=i,o=a[r];o&&(t.push(_[r]),t.push(...d(o,I)),t.push(""))}return s.length&&(t.push((0,n.localize)(43,null)),t.push(...m(s.map(i=>[i.command,i.description]),I)),t.push("")),t.join(`
`)}e.buildHelpMessage=u;function y(b,c){return`${b||(0,n.localize)(44,null)}
${c||(0,n.localize)(45,null)}
${process.arch}`}e.buildVersionMessage=y}),define(ee[198],te([0,1,88,196,113]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class _ extends A.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.windowsMainService=P}call(P,h,d){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(d[0],d[1]):super.call(P,h,d)}async openExtensionDevelopmentHostWindow(P,h){const d=(0,n.parseArgs)(P,n.OPTIONS);d.debugRenderer=h;const m=d.extensionDevelopmentPath;if(!m)return{success:!1};const[g]=await this.windowsMainService.openExtensionDevelopmentHostWindow(m,{context:5,cli:d,forceProfile:d.profile,forceTempProfile:d["profile-temp"]});if(!h)return{success:!0};const S=g.win;if(!S)return{success:!0};const u=S.webContents.debugger;let y=u.isAttached()?1/0:0;const b=(0,E.createServer)(c=>{y++===0&&u.attach();let f=!1;const l=p=>{f||c.write(JSON.stringify(p)+"\0")},v=(p,t,a,s)=>l({method:t,params:a,sessionId:s});S.on("close",()=>{u.removeListener("message",v),c.end(),f=!0}),u.addListener("message",v);let I=Buffer.alloc(0);c.on("data",p=>{I=Buffer.concat([I,p]);for(let t=I.indexOf(0);t!==-1;t=I.indexOf(0)){let a;try{const s=I.slice(0,t).toString("utf8");I=I.slice(t+1),a=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}u.sendCommand(a.method,a.params,a.sessionId).then(s=>l({id:a.id,sessionId:a.sessionId,result:s})).catch(s=>l({id:a.id,sessionId:a.sessionId,error:{code:0,message:s.message}}))}}),c.on("error",p=>{console.error("error on cdp pipe:",p)}),c.on("close",()=>{f=!0,--y===0&&u.detach()})});return await new Promise(c=>b.listen(0,c)),S.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=_}),define(ee[63],te([0,1,309,167,113]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function _(g,S){const u=(v,I)=>{console.warn((0,A.localize)(0,null,v,I))},y=v=>{console.warn((0,A.localize)(1,null,v))},b=(v,I)=>{console.warn((0,A.localize)(2,null,v,I))},c=v=>({onUnknownOption:I=>{n.NATIVE_CLI_COMMANDS.includes(v)||console.warn((0,A.localize)(3,null,I,v))},onMultipleValues:u,onEmptyValue:y,onDeprecatedOption:b,getSubcommandReporter:n.NATIVE_CLI_COMMANDS.includes(v)?c:void 0}),f={onUnknownOption:v=>{console.warn((0,A.localize)(4,null,v))},onMultipleValues:u,onEmptyValue:y,onDeprecatedOption:b,getSubcommandReporter:c},l=(0,n.parseArgs)(g,n.OPTIONS,S?f:void 0);return l.goto&&l._.forEach(v=>E(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(v),(0,A.localize)(5,null))),l}function D(g){const S=g.findIndex(u=>!/^-/.test(u));if(S>-1)return[...g.slice(0,S),...g.slice(S+1)]}function P(g){let[,...S]=g;process.env.VSCODE_DEV&&(S=D(S)||[]);const u=!m(process.env);return _(S,u)}e.parseMainProcessArgv=P;function h(g){let[,,...S]=g;return process.env.VSCODE_DEV&&(S=D(S)||[]),_(S,!0)}e.parseCLIProcessArgv=h;function d(g,...S){const u=g.indexOf("--");return u===-1?g.push(...S):g.splice(u,0,...S),g}e.addArg=d;function m(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=m}),function(){"use strict";function H(e,E,A){function n(D,P){const h=_(D,P),d=[h];return e.isAbsolute(h)||d.unshift(A),e.resolve(...d)}function _(D,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,P);const m=D["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const g=process.env.USERPROFILE;if(typeof g!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(g,"AppData","Roaming")}break;case"darwin":d=e.join(E.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,P)}return{getUserDataPath:n}}if(typeof define=="function")define(ee[199],te([114,27,36]),function(e,E,A){return H(e,E,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=H(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[90],te([0,1,27,197,199]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class _ extends A.AbstractNativeEnvironmentService{constructor(d,m){super(d,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,n.getUserDataPath)(d,m.nameShort)},m)}}e.NativeEnvironmentService=_;function D(h,d){return(0,A.parseDebugParams)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,d,h.extensionEnvironment)}e.parsePtyHostDebugPort=D;function P(h,d){return(0,A.parseDebugParams)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,d,h.extensionEnvironment)}e.parseSharedProcessDebugPort=P}),define(ee[200],te([0,1,45,27,32]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function _(D){const P=(0,n.randomPath)((0,A.tmpdir)());try{return(0,E.writeFileSync)(P,""),D&&console.log(`Marker file for --wait created: ${P}`),P}catch(h){D&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFileSync=_}),define(ee[201],te([0,1,12,169]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function n(D,P,h){try{_(D,P,h)}catch(d){console.error(d?.message??d)}return D}e.localizeManifest=n;function _(D,P,h){const d=(m,g,S)=>{const u=m[g];if((0,E.isString)(u)){const y=u,b=y.length;if(b>1&&y[0]==="%"&&y[b-1]==="%"){const c=y.substr(1,b-2);let f=P[c];f===void 0&&h&&(f=h[c]);const l=typeof f=="string"?f:f?.message,v=h?.[c],I=typeof v=="string"?v:v?.message;if(!l){I||console.warn(`[${D.name}]: ${(0,A.localize)(0,null,c)}`);return}if(S&&(g==="title"||g==="category")&&I&&I!==l){const p={value:l,original:I};m[g]=p}else m[g]=l}}else if((0,E.isObject)(u))for(const y in u)u.hasOwnProperty(y)&&(y==="commands"?d(u,y,!0):d(u,y,S));else if(Array.isArray(u))for(let y=0;y<u.length;y++)d(u,y,S)};for(const m in D)D.hasOwnProperty(m)&&d(D,m)}}),define(ee[202],te([0,1,19,70,171,203]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function h(f){return f=f.trim(),f==="*"||D.test(f)}e.isValidVersionStr=h;function d(f){if(!h(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=f.match(D);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.parseVersion=d;function m(f){if(!f)return null;const l=f.majorBase,v=f.majorMustEqual,I=f.minorBase;let p=f.minorMustEqual;const t=f.patchBase;let a=f.patchMustEqual;f.hasCaret&&(l===0||(p=!1),a=!1);let s=0;if(f.preRelease){const i=P.exec(f.preRelease);if(i){const[,r,o,w]=i;s=Date.UTC(Number(r),Number(o)-1,Number(w))}}return{majorBase:l,majorMustEqual:v,minorBase:I,minorMustEqual:p,patchBase:t,patchMustEqual:a,isMinimum:f.hasGreaterEquals,notBefore:s}}e.normalizeVersion=m;function g(f,l,v){let I;typeof f=="string"?I=m(d(f)):I=f;let p;l instanceof Date?p=l.getTime():typeof l=="string"&&(p=new Date(l).getTime());let t;if(typeof v=="string"?t=m(d(v)):t=v,!I||!t)return!1;const a=I.majorBase,s=I.minorBase,i=I.patchBase;let r=t.majorBase,o=t.minorBase,w=t.patchBase;const k=t.notBefore;let M=t.majorMustEqual,C=t.minorMustEqual,L=t.patchMustEqual;return t.isMinimum?a>r?!0:a<r?!1:s>o?!0:s<o||p&&p<k?!1:i>=w:(a===1&&r===0&&(!M||!C||!L)&&(r=1,o=0,w=0,M=!0,C=!1,L=!1),a<r?!1:a>r?!M:s<o?!1:s>o?!C:i<w?!1:i>w?!L:!(p&&p<k))}e.isValidVersion=g;function S(f,l,v,I,p){const t=[];if(typeof I.publisher<"u"&&typeof I.publisher!="string")return t.push([A.default.Error,n.localize(0,null)]),t;if(typeof I.name!="string")return t.push([A.default.Error,n.localize(1,null,"name")]),t;if(typeof I.version!="string")return t.push([A.default.Error,n.localize(2,null,"version")]),t;if(!I.engines)return t.push([A.default.Error,n.localize(3,null,"engines")]),t;if(typeof I.engines.vscode!="string")return t.push([A.default.Error,n.localize(4,null,"engines.vscode")]),t;if(typeof I.extensionDependencies<"u"&&!c(I.extensionDependencies))return t.push([A.default.Error,n.localize(5,null,"extensionDependencies")]),t;if(typeof I.activationEvents<"u"){if(!c(I.activationEvents))return t.push([A.default.Error,n.localize(6,null,"activationEvents")]),t;if(typeof I.main>"u"&&typeof I.browser>"u")return t.push([A.default.Error,n.localize(7,null,"activationEvents","main","browser")]),t}if(typeof I.extensionKind<"u"&&typeof I.main>"u"&&t.push([A.default.Warning,n.localize(8,null,"extensionKind")]),typeof I.main<"u"){if(typeof I.main!="string")return t.push([A.default.Error,n.localize(9,null,"main")]),t;{const i=(0,E.joinPath)(v,I.main);(0,E.isEqualOrParent)(i,v)||t.push([A.default.Warning,n.localize(10,null,i.path,v.path)])}}if(typeof I.browser<"u"){if(typeof I.browser!="string")return t.push([A.default.Error,n.localize(11,null,"browser")]),t;{const i=(0,E.joinPath)(v,I.browser);(0,E.isEqualOrParent)(i,v)||t.push([A.default.Warning,n.localize(12,null,i.path,v.path)])}}if(!_.valid(I.version))return t.push([A.default.Error,n.localize(13,null)]),t;const a=[];if(!u(f,l,I,p,a))for(const i of a)t.push([A.default.Error,i]);return t}e.validateExtensionManifest=S;function u(f,l,v,I,p){return I||typeof v.main>"u"&&typeof v.browser>"u"?!0:b(f,l,v.engines.vscode,p)}e.isValidExtensionVersion=u;function y(f,l,v){return f==="*"||b(l,v,f)}e.isEngineValid=y;function b(f,l,v,I=[]){const p=m(d(v));if(!p)return I.push(n.localize(14,null,v)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return I.push(n.localize(15,null,v)),!1}else if(!p.majorMustEqual)return I.push(n.localize(16,null,v)),!1;return g(f,l,p)?!0:(I.push(n.localize(17,null,f,v)),!1)}function c(f){if(!Array.isArray(f))return!1;for(let l=0,v=f.length;l<v;l++)if(typeof f[l]!="string")return!1;return!0}}),define(ee[204],te([0,1,17,31]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function n(_,D,P){let h=P&&P.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const m=(await D.readFile(_.serviceMachineIdResource)).value.toString();h=(0,A.isUUID)(m)?m:null}catch{h=null}if(!h){h=(0,A.generateUuid)();try{await D.writeFile(_.serviceMachineIdResource,E.VSBuffer.fromString(h))}catch{}}return P?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=n}),define(ee[75],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(n,_=[],D=!1){this.ctor=n,this.staticArguments=_,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=E}),define(ee[205],te([0,1,75]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var n;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(n||(e.InstantiationType=n={}));function _(P,h,d){h instanceof E.SyncDescriptor||(h=new E.SyncDescriptor(h,[],!!d)),A.push([P,h])}e.registerSingleton=_;function D(){return A}e.getSingletonServiceDescriptors=D}),define(ee[206],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(_,D){this.key=_,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class A{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(const D of this._nodes.values())D.outgoing.size===0&&_.push(D);return _}insertEdge(_,D){const P=this.lookupOrInsertNode(_),h=this.lookupOrInsertNode(D);P.outgoing.set(h.key,h),h.incoming.set(P.key,P)}removeNode(_){const D=this._hashFn(_);this._nodes.delete(D);for(const P of this._nodes.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(_){const D=this._hashFn(_);let P=this._nodes.get(D);return P||(P=new E(D,_),this._nodes.set(D,P)),P}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){const _=[];for(const[D,P]of this._nodes)_.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return _.join(`
`)}findCycleSlow(){for(const[_,D]of this._nodes){const P=new Set([_]),h=this._findCycle(D,P);if(h)return h}}_findCycle(_,D){for(const[P,h]of _.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const d=this._findCycle(h,D);if(d)return d;D.delete(P)}}}e.Graph=A}),define(ee[6],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(h){return h[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(E||(e._util=E={})),e.IInstantiationService=n("instantiationService");function A(D,P,h){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:D,index:h}):(P[E.DI_DEPENDENCIES]=[{id:D,index:h}],P[E.DI_TARGET]=P)}function n(D){if(E.serviceIds.has(D))return E.serviceIds.get(D);const P=function(h,d,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,h,m)};return P.toString=()=>D,E.serviceIds.set(D,P),P}e.createDecorator=n;function _(D){return D}e.refineServiceDecorator=_}),define(ee[64],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(ee[18],te([0,1,12,7,6]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,n.createDecorator)("configurationService");function _(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof A.URI)}e.isConfigurationOverrides=_;function D(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=D;var P;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function h(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function d(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}e.isConfigured=d;function m(f,l){const v=Object.create(null);for(const I in f)g(v,I,f[I],l);return v}e.toValuesTree=m;function g(f,l,v,I){const p=l.split("."),t=p.pop();let a=f;for(let s=0;s<p.length;s++){const i=p[s];let r=a[i];switch(typeof r){case"undefined":r=a[i]=Object.create(null);break;case"object":break;default:I(`Ignoring ${l} as ${p.slice(0,s+1).join(".")} is ${JSON.stringify(r)}`);return}a=r}if(typeof a=="object"&&a!==null)try{a[t]=v}catch{I(`Ignoring ${l} as ${p.join(".")} is ${JSON.stringify(a)}`)}else I(`Ignoring ${l} as ${p.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=g;function S(f,l){const v=l.split(".");u(f,v)}e.removeFromValueTree=S;function u(f,l){const v=l.shift();if(l.length===0){delete f[v];return}if(Object.keys(f).indexOf(v)!==-1){const I=f[v];typeof I=="object"&&!Array.isArray(I)&&(u(I,l),Object.keys(I).length===0&&delete f[v])}}function y(f,l,v){function I(a,s){let i=a;for(const r of s){if(typeof i!="object"||i===null)return;i=i[r]}return i}const p=l.split("."),t=I(f,p);return typeof t>"u"?v:t}e.getConfigurationValue=y;function b(f,l,v){Object.keys(l).forEach(I=>{I!=="__proto__"&&(I in f?E.isObject(f[I])&&E.isObject(l[I])?b(f[I],l[I],v):v&&(f[I]=l[I]):f[I]=l[I])})}e.merge=b;function c(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=c}),define(ee[115],te([0,1,4,26,195,6,162,13]),function(H,e,E,A,n,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",E.isMacintosh),h.set("isLinux",E.isLinux),h.set("isWindows",E.isWindows),h.set("isWeb",E.isWeb),h.set("isMacNative",E.isMacintosh&&!E.isWeb),h.set("isEdge",E.isEdge),h.set("isFirefox",E.isFirefox),h.set("isChrome",E.isChrome),h.set("isSafari",E.isSafari);function d(V,R){if(h.get(V)!==void 0)throw(0,P.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(V,R)}e.setConstant=d;const m=Object.prototype.hasOwnProperty;var g;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(g||(e.ContextKeyExprType=g={}));const S={regexParsingWithErrorRecovery:!0},u=(0,D.localize)(0,null),y=(0,D.localize)(1,null),b=(0,D.localize)(2,null),c=(0,D.localize)(3,null),f=(0,D.localize)(4,null),l=(0,D.localize)(5,null),v=(0,D.localize)(6,null),I=(0,D.localize)(7,null);class p{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(R=S){this._config=R,this._scanner=new n.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(R){if(R===""){this._parsingErrors.push({message:u,offset:0,lexeme:"",additionalInfo:y});return}this._tokens=this._scanner.reset(R).scan(),this._current=0,this._parsingErrors=[];try{const O=this._expr();if(!this._isAtEnd()){const N=this._peek(),q=N.type===17?l:void 0;throw this._parsingErrors.push({message:f,offset:N.offset,lexeme:n.Scanner.getLexeme(N),additionalInfo:q}),p._parseError}return O}catch(O){if(O!==p._parseError)throw O;return}}_expr(){return this._or()}_or(){const R=[this._and()];for(;this._matchOne(16);){const O=this._and();R.push(O)}return R.length===1?R[0]:t.or(...R)}_and(){const R=[this._term()];for(;this._matchOne(15);){const O=this._term();R.push(O)}return R.length===1?R[0]:t.and(...R)}_term(){if(this._matchOne(2)){const R=this._peek();switch(R.type){case 11:return this._advance(),r.INSTANCE;case 12:return this._advance(),o.INSTANCE;case 0:{this._advance();const O=this._expr();return this._consume(1,c),O?.negate()}case 17:return this._advance(),T.create(R.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",R)}}return this._primary()}_primary(){const R=this._peek();switch(R.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const O=this._expr();return this._consume(1,c),O}case 17:{const O=R.lexeme;if(this._advance(),this._matchOne(9)){const q=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),q.type!==10)throw this._errExpectedButGot("REGEX",q);const re=q.lexeme,ne=re.lastIndexOf("/"),le=ne===re.length-1?void 0:this._removeFlagsGY(re.substring(ne+1));let j;try{j=new RegExp(re.substring(1,ne),le)}catch{throw this._errExpectedButGot("REGEX",q)}return ae.create(O,j)}switch(q.type){case 10:case 19:{const re=[q.lexeme];this._advance();let ne=this._peek(),le=0;for(let pe=0;pe<q.lexeme.length;pe++)q.lexeme.charCodeAt(pe)===40?le++:q.lexeme.charCodeAt(pe)===41&&le--;for(;!this._isAtEnd()&&ne.type!==15&&ne.type!==16;){switch(ne.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let pe=0;pe<ne.lexeme.length;pe++)ne.lexeme.charCodeAt(pe)===40?le++:q.lexeme.charCodeAt(pe)===41&&le--}if(le<0)break;re.push(n.Scanner.getLexeme(ne)),this._advance(),ne=this._peek()}const j=re.join(""),Z=j.lastIndexOf("/"),Q=Z===j.length-1?void 0:this._removeFlagsGY(j.substring(Z+1));let fe;try{fe=new RegExp(j.substring(1,Z),Q)}catch{throw this._errExpectedButGot("REGEX",q)}return t.regex(O,fe)}case 18:{const re=q.lexeme;this._advance();let ne=null;if(!(0,A.isFalsyOrWhitespace)(re)){const le=re.indexOf("/"),j=re.lastIndexOf("/");if(le!==j&&le>=0){const Z=re.slice(le+1,j),Q=re[j+1]==="i"?"i":"";try{ne=new RegExp(Z,Q)}catch{throw this._errExpectedButGot("REGEX",q)}}}if(ne===null)throw this._errExpectedButGot("REGEX",q);return ae.create(O,ne)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,b);const q=this._value();return t.notIn(O,q)}switch(this._peek().type){case 3:{this._advance();const q=this._value();if(this._previous().type===18)return t.equals(O,q);switch(q){case"true":return t.has(O);case"false":return t.not(O);default:return t.equals(O,q)}}case 4:{this._advance();const q=this._value();if(this._previous().type===18)return t.notEquals(O,q);switch(q){case"true":return t.not(O);case"false":return t.has(O);default:return t.notEquals(O,q)}}case 5:return this._advance(),ie.create(O,this._value());case 6:return this._advance(),de.create(O,this._value());case 7:return this._advance(),B.create(O,this._value());case 8:return this._advance(),se.create(O,this._value());case 13:return this._advance(),t.in(O,this._value());default:return t.has(O)}}case 20:throw this._parsingErrors.push({message:v,offset:R.offset,lexeme:"",additionalInfo:I}),p._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const R=this._peek();switch(R.type){case 17:case 18:return this._advance(),R.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(R){return R.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(R){return this._check(R)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(R,O){if(this._check(R))return this._advance();throw this._errExpectedButGot(O,this._peek())}_errExpectedButGot(R,O,N){const q=(0,D.localize)(8,null,R,n.Scanner.getLexeme(O)),re=O.offset,ne=n.Scanner.getLexeme(O);return this._parsingErrors.push({message:q,offset:re,lexeme:ne,additionalInfo:N}),p._parseError}_check(R){return this._peek().type===R}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=p;class t{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(R){return w.create(R)}static equals(R,O){return k.create(R,O)}static notEquals(R,O){return L.create(R,O)}static regex(R,O){return ae.create(R,O)}static in(R,O){return M.create(R,O)}static notIn(R,O){return C.create(R,O)}static not(R){return T.create(R)}static and(...R){return G.create(R,null,!0)}static or(...R){return z.create(R,null,!0)}static greater(R,O){return B.create(R,O)}static greaterEquals(R,O){return se.create(R,O)}static smaller(R,O){return ie.create(R,O)}static smallerEquals(R,O){return de.create(R,O)}static{this._parser=new p({regexParsingWithErrorRecovery:!1})}static deserialize(R){return R==null?void 0:this._parser.parse(R)}}e.ContextKeyExpr=t;function a(V){const R=new p({regexParsingWithErrorRecovery:!1});return V.map(O=>(R.parse(O),R.lexingErrors.length>0?R.lexingErrors.map(N=>({errorMessage:N.additionalInfo?(0,D.localize)(9,null,N.additionalInfo):(0,D.localize)(10,null),offset:N.offset,length:N.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(N=>({errorMessage:N.additionalInfo?`${N.message}. ${N.additionalInfo}`:N.message,offset:N.offset,length:N.lexeme.length})):[]))}e.validateWhenClauses=a;function s(V,R){const O=V?V.substituteConstants():void 0,N=R?R.substituteConstants():void 0;return!O&&!N?!0:!O||!N?!1:O.equals(N)}e.expressionsAreEqualWithConstantSubstitution=s;function i(V,R){return V.cmp(R)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=r;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=o;class w{static create(R,O=null){const N=h.get(R);return typeof N=="boolean"?N?o.INSTANCE:r.INSTANCE:new w(R,O)}constructor(R,O){this.key=R,this.negated=O,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:U(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=h.get(this.key);return typeof R=="boolean"?R?o.INSTANCE:r.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=w;class k{static create(R,O,N=null){if(typeof O=="boolean")return O?w.create(R,N):T.create(R,N);const q=h.get(R);return typeof q=="boolean"?O===(q?"true":"false")?o.INSTANCE:r.INSTANCE:new k(R,O,N)}constructor(R,O,N){this.key=R,this.value=O,this.negated=N,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:$(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=h.get(this.key);if(typeof R=="boolean"){const O=R?"true":"false";return this.value===O?o.INSTANCE:r.INSTANCE}return this}evaluate(R){return R.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(R){return R.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=L.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=k;class M{static create(R,O){return new M(R,O)}constructor(R,O){this.key=R,this.valueKey=O,this.type=10,this.negated=null}cmp(R){return R.type!==this.type?this.type-R.type:$(this.key,this.valueKey,R.key,R.valueKey)}equals(R){return R.type===this.type?this.key===R.key&&this.valueKey===R.valueKey:!1}substituteConstants(){return this}evaluate(R){const O=R.getValue(this.valueKey),N=R.getValue(this.key);return Array.isArray(O)?O.includes(N):typeof N=="string"&&typeof O=="object"&&O!==null?m.call(O,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(R){return R.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=C.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=M;class C{static create(R,O){return new C(R,O)}constructor(R,O){this.key=R,this.valueKey=O,this.type=11,this._negated=M.create(R,O)}cmp(R){return R.type!==this.type?this.type-R.type:this._negated.cmp(R._negated)}equals(R){return R.type===this.type?this._negated.equals(R._negated):!1}substituteConstants(){return this}evaluate(R){return!this._negated.evaluate(R)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(R){return R.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=C;class L{static create(R,O,N=null){if(typeof O=="boolean")return O?T.create(R,N):w.create(R,N);const q=h.get(R);return typeof q=="boolean"?O===(q?"true":"false")?r.INSTANCE:o.INSTANCE:new L(R,O,N)}constructor(R,O,N){this.key=R,this.value=O,this.negated=N,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:$(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=h.get(this.key);if(typeof R=="boolean"){const O=R?"true":"false";return this.value===O?r.INSTANCE:o.INSTANCE}return this}evaluate(R){return R.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(R){return R.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=L;class T{static create(R,O=null){const N=h.get(R);return typeof N=="boolean"?N?r.INSTANCE:o.INSTANCE:new T(R,O)}constructor(R,O){this.key=R,this.negated=O,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:U(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=h.get(this.key);return typeof R=="boolean"?R?r.INSTANCE:o.INSTANCE:this}evaluate(R){return!R.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(R){return R.mapNot(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=T;function F(V,R){if(typeof V=="string"){const O=parseFloat(V);isNaN(O)||(V=O)}return typeof V=="string"||typeof V=="number"?R(V):r.INSTANCE}class B{static create(R,O,N=null){return F(O,q=>new B(R,q,N))}constructor(R,O,N){this.key=R,this.value=O,this.negated=N,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:$(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=de.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=B;class se{static create(R,O,N=null){return F(O,q=>new se(R,q,N))}constructor(R,O,N){this.key=R,this.value=O,this.negated=N,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:$(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ie.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=se;class ie{static create(R,O,N=null){return F(O,q=>new ie(R,q,N))}constructor(R,O,N){this.key=R,this.value=O,this.negated=N,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:$(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=se.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=ie;class de{static create(R,O,N=null){return F(O,q=>new de(R,q,N))}constructor(R,O,N){this.key=R,this.value=O,this.negated=N,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:$(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=de;class ae{static create(R,O){return new ae(R,O)}constructor(R,O){this.key=R,this.regexp=O,this.type=7,this.negated=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.key<R.key)return-1;if(this.key>R.key)return 1;const O=this.regexp?this.regexp.source:"",N=R.regexp?R.regexp.source:"";return O<N?-1:O>N?1:0}equals(R){if(R.type===this.type){const O=this.regexp?this.regexp.source:"",N=R.regexp?R.regexp.source:"";return this.key===R.key&&O===N}return!1}substituteConstants(){return this}evaluate(R){const O=R.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const R=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${R}`}keys(){return[this.key]}map(R){return R.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ue.create(this)),this.negated}}e.ContextKeyRegexExpr=ae;class ue{static create(R){return new ue(R)}constructor(R){this._actual=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(R){return new ue(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ue;function x(V){let R=null;for(let O=0,N=V.length;O<N;O++){const q=V[O].substituteConstants();if(V[O]!==q&&R===null){R=[];for(let re=0;re<O;re++)R[re]=V[re]}R!==null&&(R[O]=q)}return R===null?V:R}class G{static create(R,O,N){return G._normalizeArr(R,O,N)}constructor(R,O){this.expr=R,this.negated=O,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let O=0,N=this.expr.length;O<N;O++){const q=i(this.expr[O],R.expr[O]);if(q!==0)return q}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let O=0,N=this.expr.length;O<N;O++)if(!this.expr[O].equals(R.expr[O]))return!1;return!0}return!1}substituteConstants(){const R=x(this.expr);return R===this.expr?this:G.create(R,this.negated,!1)}evaluate(R){for(let O=0,N=this.expr.length;O<N;O++)if(!this.expr[O].evaluate(R))return!1;return!0}static _normalizeArr(R,O,N){const q=[];let re=!1;for(const ne of R)if(ne){if(ne.type===1){re=!0;continue}if(ne.type===0)return r.INSTANCE;if(ne.type===6){q.push(...ne.expr);continue}q.push(ne)}if(q.length===0&&re)return o.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(i);for(let ne=1;ne<q.length;ne++)q[ne-1].equals(q[ne])&&(q.splice(ne,1),ne--);if(q.length===1)return q[0];for(;q.length>1;){const ne=q[q.length-1];if(ne.type!==9)break;q.pop();const le=q.pop(),j=q.length===0,Z=z.create(ne.expr.map(Q=>G.create([Q,le],null,N)),null,j);Z&&(q.push(Z),q.sort(i))}if(q.length===1)return q[0];if(N){for(let ne=0;ne<q.length;ne++)for(let le=ne+1;le<q.length;le++)if(q[ne].negate().equals(q[le]))return r.INSTANCE;if(q.length===1)return q[0]}return new G(q,O)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const O of this.expr)R.push(...O.keys());return R}map(R){return new G(this.expr.map(O=>O.map(R)),null)}negate(){if(!this.negated){const R=[];for(const O of this.expr)R.push(O.negate());this.negated=z.create(R,this,!0)}return this.negated}}e.ContextKeyAndExpr=G;class z{static create(R,O,N){return z._normalizeArr(R,O,N)}constructor(R,O){this.expr=R,this.negated=O,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let O=0,N=this.expr.length;O<N;O++){const q=i(this.expr[O],R.expr[O]);if(q!==0)return q}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let O=0,N=this.expr.length;O<N;O++)if(!this.expr[O].equals(R.expr[O]))return!1;return!0}return!1}substituteConstants(){const R=x(this.expr);return R===this.expr?this:z.create(R,this.negated,!1)}evaluate(R){for(let O=0,N=this.expr.length;O<N;O++)if(this.expr[O].evaluate(R))return!0;return!1}static _normalizeArr(R,O,N){let q=[],re=!1;if(R){for(let ne=0,le=R.length;ne<le;ne++){const j=R[ne];if(j){if(j.type===0){re=!0;continue}if(j.type===1)return o.INSTANCE;if(j.type===9){q=q.concat(j.expr);continue}q.push(j)}}if(q.length===0&&re)return r.INSTANCE;q.sort(i)}if(q.length!==0){if(q.length===1)return q[0];for(let ne=1;ne<q.length;ne++)q[ne-1].equals(q[ne])&&(q.splice(ne,1),ne--);if(q.length===1)return q[0];if(N){for(let ne=0;ne<q.length;ne++)for(let le=ne+1;le<q.length;le++)if(q[ne].negate().equals(q[le]))return o.INSTANCE;if(q.length===1)return q[0]}return new z(q,O)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const O of this.expr)R.push(...O.keys());return R}map(R){return new z(this.expr.map(O=>O.map(R)),null)}negate(){if(!this.negated){const R=[];for(const O of this.expr)R.push(O.negate());for(;R.length>1;){const O=R.shift(),N=R.shift(),q=[];for(const re of ce(O))for(const ne of ce(N))q.push(G.create([re,ne],null,!1));R.unshift(z.create(q,null,!1))}this.negated=z.create(R,this,!0)}return this.negated}}e.ContextKeyOrExpr=z;class W extends w{static{this._info=[]}static all(){return W._info.values()}constructor(R,O,N){super(R,null),this._defaultValue=O,typeof N=="object"?W._info.push({...N,key:R}):N!==!0&&W._info.push({key:R,description:N,type:O!=null?typeof O:void 0})}bindTo(R){return R.createKey(this.key,this._defaultValue)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return k.create(this.key,R)}notEqualsTo(R){return L.create(this.key,R)}}e.RawContextKey=W,e.IContextKeyService=(0,_.createDecorator)("contextKeyService");function U(V,R){return V<R?-1:V>R?1:0}function $(V,R,O,N){return V<O?-1:V>O?1:R<N?-1:R>N?1:0}function X(V,R){if(V.type===0||R.type===1)return!0;if(V.type===9)return R.type===9?oe(V.expr,R.expr):!1;if(R.type===9){for(const O of R.expr)if(X(V,O))return!0;return!1}if(V.type===6){if(R.type===6)return oe(R.expr,V.expr);for(const O of V.expr)if(X(O,R))return!0;return!1}return V.equals(R)}e.implies=X;function oe(V,R){let O=0,N=0;for(;O<V.length&&N<R.length;){const q=V[O].cmp(R[N]);if(q<0)return!1;q===0&&O++,N++}return O===V.length}function ce(V){return V.type===9?V.expr:[V]}}),define(ee[76],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class A{constructor(){this.secretVault={}}async getPassword(_,D){return this.secretVault[_]?.[D]??null}async setPassword(_,D,P){this.secretVault[_]=this.secretVault[_]??{},this.secretVault[_][D]=P}async deletePassword(_,D){return this.secretVault[_]?.[D]?(delete this.secretVault[_][D],Object.keys(this.secretVault[_]).length===0&&delete this.secretVault[_],!0):!1}async findPassword(_){return JSON.stringify(this.secretVault[_])??null}async findCredentials(_){const D=[];for(const P of Object.keys(this.secretVault[_]||{}))D.push({account:P,password:this.secretVault[_][P]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=A}),define(ee[91],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function A(_){return!!_.hostName&&!!_.errorMessage}e.isRemoteDiagnosticError=A;class n{async getPerformanceInfo(D,P){return{}}async getSystemInfo(D,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,P){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=n}),define(ee[92],te([0,1,19,70,164,6,46,4,37]),function(H,e,E,A,n,_,D,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,_.createDecorator)("dialogService");var d;(function(b){b[b.Confirmation=1]="Confirmation",b[b.Prompt=2]="Prompt",b[b.Input=3]="Input"})(d||(d={}));class m{getConfirmationButtons(c){return this.getButtons(c,d.Confirmation)}getPromptButtons(c){return this.getButtons(c,d.Prompt)}getInputButtons(c){return this.getButtons(c,d.Input)}getButtons(c,f){const l=[];switch(f){case d.Confirmation:{const v=c;v.primaryButton?l.push(v.primaryButton):l.push((0,n.localize)(0,null)),v.cancelButton?l.push(v.cancelButton):l.push((0,n.localize)(1,null));break}case d.Prompt:{const v=c;Array.isArray(v.buttons)&&v.buttons.length>0&&l.push(...v.buttons.map(I=>I.label)),v.cancelButton&&(v.cancelButton===!0?l.push((0,n.localize)(2,null)):typeof v.cancelButton=="string"?l.push(v.cancelButton):v.cancelButton.label?l.push(v.cancelButton.label):l.push((0,n.localize)(3,null))),l.length===0&&l.push((0,n.localize)(4,null));break}case d.Input:{const v=c;v.primaryButton?l.push(v.primaryButton):l.push((0,n.localize)(5,null)),v.cancelButton?l.push(v.cancelButton):l.push((0,n.localize)(6,null));break}}return l}getDialogType(c){if(typeof c=="string")return c;if(typeof c=="number")return c===A.default.Info?"info":c===A.default.Error?"error":c===A.default.Warning?"warning":"none"}async getPromptResult(c,f,l){const v=[...c.buttons??[]];return c.cancelButton&&typeof c.cancelButton!="string"&&typeof c.cancelButton!="boolean"&&v.push(c.cancelButton),{result:await v[f]?.run({checkboxChecked:l}),checkboxChecked:l}}}e.AbstractDialogHandler=m,e.IFileDialogService=(0,_.createDecorator)("fileDialogService");var g;(function(b){b[b.SAVE=0]="SAVE",b[b.DONT_SAVE=1]="DONT_SAVE",b[b.CANCEL=2]="CANCEL"})(g||(e.ConfirmResult=g={}));const S=10;function u(b){const c=[];return c.push(...b.slice(0,S).map(f=>typeof f=="string"?f:(0,E.basename)(f))),b.length>S&&(b.length-S===1?c.push((0,n.localize)(7,null)):c.push((0,n.localize)(8,null,b.length-S))),c.push(""),c.join(`
`)}e.getFileNamesMessage=u;function y(b,c){const f=(0,h.deepClone)(b);let l=(f.buttons??[]).map(t=>(0,D.mnemonicButtonLabel)(t)),v=(b.buttons||[]).map((t,a)=>a),I=0,p=f.cancelId??l.length-1;if(l.length>1){const t=typeof p=="number"?l[p]:void 0;if(P.isLinux||P.isMacintosh){if(typeof t=="string"&&l.length>1&&p!==1){l.splice(p,1),l.splice(1,0,t);const a=v[p];v.splice(p,1),v.splice(1,0,a),p=1}P.isLinux&&l.length>1&&(l=l.reverse(),v=v.reverse(),I=l.length-1,typeof t=="string"&&(p=I-1))}else if(P.isWindows&&typeof t=="string"&&l.length>1&&p!==l.length-1){l.splice(p,1),l.push(t);const a=v[p];v.splice(p,1),v.push(a),p=l.length-1}}return f.buttons=l,f.defaultId=I,f.cancelId=p,f.noLink=!0,f.title=f.title||c.nameLong,{options:f,buttonIndeces:v}}e.massageMessageBoxOptions=y}),define(ee[116],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isGnome=e.isKwallet=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.IEncryptionMainService=e.IEncryptionService=void 0,e.IEncryptionService=(0,E.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService");var A;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnome="gnome",P.gnomeKeyring="gnome-keyring",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(A||(e.PasswordStoreCLIOption=A={}));var n;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(n||(e.KnownStorageProvider=n={}));function _(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}e.isKwallet=_;function D(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}e.isGnome=D}),define(ee[33],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[117],te([0,1,168,6]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function n(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function _(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=_;function D(l,v){switch(l){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":v==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function P(l,v){return v==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function h(l,v,I){return P(v,I)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===I?!0:d(I).includes(l)}e.isTargetPlatformCompatible=h;function d(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=d;function m(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=m;var g;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var S;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var u;(function(l){l.Install="install",l.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var y;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var b;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var c;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class f extends Error{constructor(v,I){super(v),this.code=I,this.name=I}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,E.localize)(1,null),original:"Preferences"}}),define(ee[207],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(ee[208],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[118],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(ee[209],te([0,1,47,15,9,4,73,21,89,172,118]),function(H,e,E,A,n,_,D,P,h,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const g=d.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:u.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class u extends S{static{this.CMD="cmd.exe"}openTerminal(I,p){return this.spawnTerminal(E,I,h.getWindowsShell(),p)}spawnTerminal(I,p,t,a){const s=p.windowsExec||u.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const i=n.basename(s,".exe").toLowerCase();if(i==="cmder")return I.spawn(s,a?[a]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),i==="wt"&&r.push("-d ."),new Promise((o,w)=>{const k=c(process),M=I.spawn(t,r,{cwd:a,env:k});M.on("error",w),M.on("exit",()=>o())})}runInTerminal(I,p,t,a,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:u.getDefaultTerminalWindows();return new Promise((r,o)=>{const w=`"${p} - ${g}"`,k=`""${t.join('" "')}" & pause"`,M=Object.assign({},c(process),a);Object.keys(M).filter(B=>M[B]===null).forEach(B=>delete M[B]);const C={cwd:p,env:M,windowsVerbatimArguments:!0};let L,T;n.basename(i,".exe")==="wt"?(L=i,T=["-d",".",u.CMD,"/c",k]):(L=u.CMD,T=["/c","start",w,"/wait",i,"/c",k]),E.spawn(L,T,C).on("error",B=>{o(f(B))}),r(void 0)})}static getDefaultTerminalWindows(){if(!u._DEFAULT_TERMINAL_WINDOWS){const I=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");u._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${I?"Sysnative":"System32"}\\cmd.exe`}return u._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=u;class y extends S{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(I,p){return this.spawnTerminal(E,I,p)}runInTerminal(I,p,t,a,s){const i=s.osxExec||m.DEFAULT_TERMINAL_OSX;return new Promise((r,o)=>{if(i===m.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const w=i===m.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`).fsPath,"-t",I||g,"-w",p];for(const T of t)M.push("-a"),M.push(T);if(a){const T=Object.assign({},c(process),a);for(const F in T){const B=T[F];B===null?(M.push("-u"),M.push(F)):(M.push("-e"),M.push(`${F}=${B}`))}}let C="";const L=E.spawn(y.OSASCRIPT,M);L.on("error",T=>{o(f(T))}),L.stderr.on("data",T=>{C+=T.toString()}),L.on("exit",T=>{if(T===0)r(void 0);else if(C){const F=C.split(`
`,1);o(new Error(F[0]))}else o(new Error(d.localize(1,null,w,T)))})}else o(new Error(d.localize(2,null,i)))})}spawnTerminal(I,p,t){const a=p.osxExec||m.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const r=["-a",a];t&&r.push(t);const o=c(process),w=I.spawn("/usr/bin/open",r,{cwd:t,env:o});w.on("error",i),w.on("exit",()=>s())})}}e.MacExternalTerminalService=y;class b extends S{static{this.WAIT_MESSAGE=d.localize(3,null)}openTerminal(I,p){return this.spawnTerminal(E,I,p)}runInTerminal(I,p,t,a,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((r,o)=>{const w=[];i.then(k=>{k.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const M=`${l(t)}; echo; read -p "${b.WAIT_MESSAGE}" -n1;`;w.push(`''${M}''`);const C=Object.assign({},c(process),a);Object.keys(C).filter(B=>C[B]===null).forEach(B=>delete C[B]);const L={cwd:p,env:C};let T="";const F=E.spawn(k,w,L);F.on("error",B=>{o(f(B))}),F.stderr.on("data",B=>{T+=B.toString()}),F.on("exit",B=>{if(B===0)r(void 0);else if(T){const se=T.split(`
`,1);o(new Error(se[0]))}else o(new Error(d.localize(4,null,k,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!b._DEFAULT_TERMINAL_LINUX_READY)if(!_.isLinux)b._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const I=await P.Promises.exists("/etc/debian_version");b._DEFAULT_TERMINAL_LINUX_READY=new Promise(p=>{I?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return b._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(I,p,t){const a=p.linuxExec?Promise.resolve(p.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{a.then(r=>{const o=c(process),w=I.spawn(r,[],{cwd:t,env:o});w.on("error",i),w.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=b;function c(v){const I={...v.env};return(0,D.sanitizeProcessEnvironment)(I),I}function f(v){return"errno"in v&&v.errno==="ENOENT"&&"path"in v&&typeof v.path=="string"?new Error(d.localize(5,null,v.path)):v}function l(v){let I="";for(const p of v)p.indexOf(" ")>=0?I+='"'+p+'"':I+=p,I+=" ";return I}}),define(ee[16],te([0,1,58,9,26,12,7,174,6,4,15]),function(H,e,E,A,n,_,D,P,h,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function g(U){return U.create===!0}e.isFileOpenForWriteOptions=g;var S;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var u;(function(U){U[U.Readonly=1]="Readonly",U[U.Locked=2]="Locked"})(u||(e.FilePermission=u={}));var y;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileAtomicWrite=32768]="FileAtomicWrite",U[U.FileAtomicDelete=65536]="FileAtomicDelete",U[U.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function b(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=b;function c(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=c;function f(U){return!!(U.capabilities&131072)}e.hasFileCloneCapability=f;function l(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function v(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=v;function I(U){return b(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=I;function p(U){return b(U)?!!(U.capabilities&32768):!1}e.hasFileAtomicWriteCapability=p;function t(U){return!!(U.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;function a(U){return!!(U.capabilities&2048)}e.hasReadonlyCapability=a;var s;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsStorageQuota="EntryExceedsStorageQuota",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class i extends Error{static create($,X){const oe=new i($.toString(),X);return w(oe,X),oe}constructor($,X){super($),this.code=X}}e.FileSystemProviderError=i;function r(U,$){return i.create(U,$)}e.createFileSystemProviderError=r;function o(U){return U||r((0,P.localize)(0,null),s.Unknown)}e.ensureFileSystemProviderError=o;function w(U,$){return U.name=$?`${$} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=w;function k(U){if(!U)return s.Unknown;if(U instanceof i)return U.code;const $=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!$)return s.Unknown;switch($[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.toFileSystemProviderErrorCode=k;function M(U){if(U instanceof se)return U.fileOperationResult;switch(k(U)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=M;var C;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class L{constructor($,X,oe){this.resource=$,this.operation=X,this.target=oe}isOperation($){return this.operation===$}}e.FileOperationEvent=L;var T;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class F{constructor($,X){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const oe=new Map;for(const ce of $){const V=oe.get(ce.type);switch(V?V.push([ce.resource,ce]):oe.set(ce.type,[[ce.resource,ce]]),ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}}for(const[ce,V]of oe)switch(ce){case 1:this.added=E.TernarySearchTree.forUris(()=>X),this.added.fill(V);break;case 0:this.updated=E.TernarySearchTree.forUris(()=>X),this.updated.fill(V);break;case 2:this.deleted=E.TernarySearchTree.forUris(()=>X),this.deleted.fill(V);break}}contains($,...X){return this.doContains($,{includeChildren:!1},...X)}affects($,...X){return this.doContains($,{includeChildren:!0},...X)}doContains($,X,...oe){if(!$)return!1;const ce=oe.length>0;return!!((!ce||oe.includes(1))&&(this.added?.get($)||X.includeChildren&&this.added?.findSuperstr($))||(!ce||oe.includes(0))&&(this.updated?.get($)||X.includeChildren&&this.updated?.findSuperstr($))||(!ce||oe.includes(2))&&(this.deleted?.findSubstr($)||X.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=F;function B(U,$,X){return!U||!$||U===$||$.length>U.length?!1:($.charAt($.length-1)!==A.sep&&($+=A.sep),X?(0,n.startsWithIgnoreCase)(U,$):U.indexOf($)===0)}e.isParent=B;class se extends Error{constructor($,X,oe){super($),this.fileOperationResult=X,this.options=oe}}e.FileOperationError=se;class ie extends se{constructor($,X,oe,ce){super($,X,ce),this.fileOperationResult=X,this.size=oe}}e.TooLargeFileOperationError=ie;class de extends se{constructor($,X,oe){super($,2,oe),this.stat=X}}e.NotModifiedSinceFileOperationError=de;var ae;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ue;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.ETAG_DISABLED="";function x(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=x;async function G(U,$){if(!$.hasProvider(D.URI.from({scheme:U.scheme})))return new Promise(X=>{const oe=$.onDidChangeFileSystemProviderRegistrations(ce=>{ce.scheme===U.scheme&&ce.added&&(oe.dispose(),X())})})}e.whenProviderRegistered=G;class z{static{this.KB=1024}static{this.MB=z.KB*z.KB}static{this.GB=z.MB*z.KB}static{this.TB=z.GB*z.KB}static formatSize($){return(0,_.isNumber)($)||($=0),$<z.KB?(0,P.localize)(1,null,$.toFixed(0)):$<z.MB?(0,P.localize)(2,null,($/z.KB).toFixed(2)):$<z.GB?(0,P.localize)(3,null,($/z.MB).toFixed(2)):$<z.TB?(0,P.localize)(4,null,($/z.GB).toFixed(2)):(0,P.localize)(5,null,($/z.TB).toFixed(2))}}e.ByteSize=z;function W(U){const $=typeof U=="string"||U?.scheme===m.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===m.Schemas.file?1024*z.MB:$?10*z.MB:d.isWeb?50*z.MB:1024*z.MB}e.getLargeFileConfirmationLimit=W}),define(ee[210],te([0,1,17,50,13,3,2,56,7,31,16]),function(H,e,E,A,n,_,D,P,h,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class g extends D.Disposable{constructor(u,y){super(),this.channel=u,this.extraCapabilities=y,this.onDidChangeCapabilities=_.Event.None,this._onDidChange=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,d.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(u){return this.channel.call("stat",[u])}readdir(u){return this.channel.call("readdir",[u])}async readFile(u,y){const{buffer:b}=await this.channel.call("readFile",[u,y]);return b}readFileStream(u,y,b){const c=(0,P.newWriteableStream)(l=>E.VSBuffer.concat(l.map(v=>E.VSBuffer.wrap(v))).buffer),f=this.channel.listen("readFileStream",[u,y])(l=>{if(l instanceof E.VSBuffer)c.write(l.buffer);else{if(l==="end")c.end();else{let v;if(l instanceof Error)v=l;else{const I=l;v=(0,m.createFileSystemProviderError)(I.message??(0,A.toErrorMessage)(I),I.code??m.FileSystemProviderErrorCode.Unknown)}c.error(v),c.end()}f.dispose()}});return b.onCancellationRequested(()=>{c.error((0,n.canceled)()),c.end(),f.dispose()}),c}writeFile(u,y,b){return this.channel.call("writeFile",[u,E.VSBuffer.wrap(y),b])}open(u,y){return this.channel.call("open",[u,y])}close(u){return this.channel.call("close",[u])}async read(u,y,b,c,f){const[l,v]=await this.channel.call("read",[u,y,f]);return b.set(l.buffer.slice(0,v),c),v}write(u,y,b,c,f){return this.channel.call("write",[u,y,E.VSBuffer.wrap(b),c,f])}mkdir(u){return this.channel.call("mkdir",[u])}delete(u,y){return this.channel.call("delete",[u,y])}rename(u,y,b){return this.channel.call("rename",[u,y,b])}copy(u,y,b){return this.channel.call("copy",[u,y,b])}cloneFile(u,y){return this.channel.call("cloneFile",[u,y])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(u=>{if(Array.isArray(u)){const y=u;this._onDidChange.fire(y.map(b=>({resource:h.URI.revive(b.resource),type:b.type})))}else{const y=u;this._onDidWatchError.fire(y)}}))}watch(u,y){const b=(0,d.generateUuid)();return this.channel.call("watch",[this.sessionId,b,u,y]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,b]))}}e.DiskFileSystemProviderClient=g}),define(ee[119],te([0,1,17,13,175,16]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(m,g,S,u,y,b){let c;try{await P(m,g,S,u,y,b)}catch(f){c=f}finally{c&&y.errorTransformer&&(c=y.errorTransformer(c)),typeof c<"u"&&S.error(c),S.end()}}e.readFileIntoStream=D;async function P(m,g,S,u,y,b){h(b);const c=await m.open(g,{create:!1});try{h(b);let f=0,l=0,v=y&&typeof y.length=="number"?y.length:void 0,I=E.VSBuffer.alloc(Math.min(y.bufferSize,typeof v=="number"?v:y.bufferSize)),p=y&&typeof y.position=="number"?y.position:0,t=0;do l=await m.read(c,p,I.buffer,t,I.byteLength-t),p+=l,t+=l,f+=l,typeof v=="number"&&(v-=l),t===I.byteLength&&(await S.write(u(I)),I=E.VSBuffer.alloc(Math.min(y.bufferSize,typeof v=="number"?v:y.bufferSize)),t=0);while(l>0&&(typeof v!="number"||v>0)&&h(b)&&d(f,y));if(t>0){let a=t;typeof v=="number"&&(a=Math.min(t,v)),S.write(u(I.slice(0,a)))}}catch(f){throw(0,_.ensureFileSystemProviderError)(f)}finally{await m.close(c)}}function h(m){if(m.isCancellationRequested)throw(0,A.canceled)();return!0}function d(m,g){if(typeof g?.limits?.size=="number"&&m>g.limits.size)throw(0,_.createFileSystemProviderError)((0,n.localize)(0,null),_.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ee[77],te([0,1,105,2,9,4,7,16]),function(H,e,E,A,n,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function h(f){return f.recursive===!0}e.isRecursiveWatchRequest=h;class d extends A.Disposable{static{this.MAX_RESTARTS=5}constructor(l,v,I,p){super(),this.onFileChanges=l,this.onLogMessage=v,this.verboseLogging=I,this.options=p,this.watcherDisposables=this._register(new A.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const l=new A.DisposableStore;this.watcherDisposables.value=l,this.watcher=this.createWatcher(l),this.watcher.setVerboseLogging(this.verboseLogging),l.add(this.watcher.onDidChangeFile(v=>this.onFileChanges(v))),l.add(this.watcher.onDidLogMessage(v=>this.onLogMessage(v))),l.add(this.watcher.onDidError(v=>this.onError(v)))}onError(l){this.options.restartOnError?this.restartCounter<d.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${l}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${l}`):this.error(l)}restart(l){this.restartCounter++,this.init(),this.watch(l)}async watch(l){this.requests=l,await this.watcher?.watch(l)}async setVerboseLogging(l){this.verboseLogging=l,await this.watcher?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${l}`})}trace(l){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${l}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=d;class m extends d{constructor(l,v,I){super(l,v,I,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=m;class g extends d{constructor(l,v,I){super(l,v,I,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=g;function S(f){return f.map(l=>({type:l.type,resource:D.URI.file(l.path)}))}e.toFileChanges=S;function u(f){const l=new c;for(const v of f)l.processEvent(v);return l.coalesce()}e.coalesceEvents=u;function y(f,l){return typeof l=="string"&&!l.startsWith(E.GLOBSTAR)&&!(0,n.isAbsolute)(l)?{base:f,pattern:l}:l}e.normalizeWatcherPattern=y;function b(f,l){const v=[];for(const I of l)v.push((0,E.parse)(y(f,I)));return v}e.parseWatcherPatterns=b;class c{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(l){return _.isLinux?l.path:l.path.toLowerCase()}processEvent(l){const v=this.mapPathToChange.get(this.toKey(l));let I=!1;if(v){const p=v.type,t=l.type;v.path!==l.path&&(l.type===2||l.type===1)?I=!0:p===1&&t===2?(this.mapPathToChange.delete(this.toKey(l)),this.coalesced.delete(v)):p===2&&t===1?v.type=0:p===1&&t===0||(v.type=t)}else I=!0;I&&(this.coalesced.add(l),this.mapPathToChange.set(this.toKey(l),l))}coalesce(){const l=[],v=[];return Array.from(this.coalesced).filter(I=>I.type!==2?(l.push(I),!1):!0).sort((I,p)=>I.path.length-p.path.length).filter(I=>v.some(p=>(0,P.isParent)(I.path,p,!_.isLinux))?!1:(v.push(I.path),!0)).concat(l)}}}),define(ee[211],te([0,1,45,8,23,32,2,86,9,4,106,21,77]),function(H,e,E,A,n,_,D,P,h,d,m,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends D.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(c,f,l,v){super(),this.request=c,this.onDidFilesChange=f,this.onLogMessage=l,this.verboseLogging=v,this.throttledFileChangesEmitter=this._register(new A.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},I=>this.onDidFilesChange(I))),this.fileChangesAggregator=this._register(new A.RunOnceWorker(I=>this.handleFileChanges(I),u.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new n.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const c=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const f=await g.Promises.stat(c);this._register(await this.doWatch(c,f.isDirectory()))}catch(c){c.code!=="ENOENT"?this.error(c):this.trace(c)}}async normalizePath(c){let f=c.path;try{f=await g.Promises.realpath(c.path),c.path===f&&(f=await(0,m.realcase)(c.path)??c.path),c.path!==f&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${f})`)}catch{}return f}async doWatch(c,f){if(d.isMacintosh&&(0,_.isEqualOrParent)(c,"/Volumes/",!0))return this.error(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const l=new n.CancellationTokenSource(this.cts.token),v=new D.DisposableStore;try{const I=(0,h.basename)(c),p=(0,E.watch)(c);v.add((0,D.toDisposable)(()=>{p.removeAllListeners(),p.close()})),this.trace(`Started watching: '${c}'`);const t=new Set;if(f)try{for(const s of await g.Promises.readdir(c))t.add(s)}catch(s){this.error(s)}const a=new Map;v.add((0,D.toDisposable)(()=>{for(const[,s]of a)s.dispose();a.clear()})),p.on("error",(s,i)=>{this.error(`Failed to watch ${c} for changes using fs.watch() (${s}, ${i})`),this.dispose()}),p.on("change",(s,i)=>{if(l.token.isCancellationRequested)return;this.trace(`[raw] ["${s}"] ${i}`);let r="";if(i&&(r=i.toString(),d.isMacintosh&&(r=(0,P.normalizeNFC)(r))),!(!r||s!=="change"&&s!=="rename"))if(f)if(s==="rename"){a.get(r)?.dispose();const o=setTimeout(async()=>{if(a.delete(r),r===I&&!await g.Promises.exists(c)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const w=await this.existsChildStrictCase((0,h.join)(c,r));if(l.token.isCancellationRequested)return;let k;w?t.has(r)?k=0:(k=1,t.add(r)):(t.delete(r),k=2),this.onFileChange({path:(0,h.join)(this.request.path,r),type:k})},u.FILE_DELETE_HANDLER_DELAY);a.set(r,(0,D.toDisposable)(()=>clearTimeout(o)))}else{let o;t.has(r)?o=0:(o=1,t.add(r)),this.onFileChange({path:(0,h.join)(this.request.path,r),type:o})}else if(s==="rename"||r!==I){const o=setTimeout(async()=>{const w=await g.Promises.exists(c);l.token.isCancellationRequested||(w?(this.onFileChange({path:this.request.path,type:0},!0),v.add(await this.doWatch(c,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},u.FILE_DELETE_HANDLER_DELAY);v.clear(),v.add((0,D.toDisposable)(()=>clearTimeout(o)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(I){await g.Promises.exists(c)&&!l.token.isCancellationRequested&&this.error(`Failed to watch ${c} for changes using fs.watch() (${I.toString()})`)}return(0,D.toDisposable)(()=>{l.dispose(!0),v.dispose()})}onFileChange(c,f=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!f&&this.excludes.some(l=>l(c.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${c.path}`):!f&&this.includes&&this.includes.length>0&&!this.includes.some(l=>l(c.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${c.path}`):this.fileChangesAggregator.work(c))}handleFileChanges(c){const f=(0,S.coalesceEvents)(c);if(f.length>0){if(this.verboseLogging)for(const v of f)this.trace(`>> normalized ${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`);this.throttledFileChangesEmitter.work(f)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(c){if(d.isLinux)return g.Promises.exists(c);try{const f=(0,h.basename)(c);return(await g.Promises.readdir((0,h.dirname)(c))).some(v=>v===f)}catch(f){return this.trace(f),!1}}setVerboseLogging(c){this.verboseLogging=c}error(c){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}warn(c){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}trace(c){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u;async function y(b,c,f,l,v=512){const I=await g.Promises.open(b,"r"),p=Buffer.allocUnsafe(v),t=new n.CancellationTokenSource(l);let a,s=!1;const i={path:b,excludes:[],recursive:!1},r=new u(i,o=>{(async()=>{for(const{type:w}of o)if(w===0){if(s)return;s=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:k}=await g.Promises.read(I,p,0,v,null);if(!k||t.token.isCancellationRequested)break;c(p.slice(0,k))}}catch(k){a=new Error(k),t.dispose(!0)}finally{s=!1}}})()});return await r.ready,f(),new Promise((o,w)=>{t.token.onCancellationRequested(async()=>{r.dispose();try{await g.Promises.close(I)}catch(k){a=new Error(k)}a?w(a):o()})})}e.watchFileContents=y}),define(ee[212],te([0,1,3,105,2,4,211]),function(H,e,E,A,n,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends n.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new E.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new E.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=E.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(d){const m=this.normalizeRequests(d),g=m.filter(u=>{const y=this.watchers.get(u.path);return y?!(0,A.patternsEquals)(y.request.excludes,u.excludes)||!(0,A.patternsEquals)(y.request.includes,u.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:u})=>!m.find(y=>y.path===u.path&&(0,A.patternsEquals)(y.excludes,u.excludes)&&(0,A.patternsEquals)(y.includes,u.includes))).map(({request:u})=>u.path);g.length&&this.trace(`Request to start watching: ${g.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const u of S)this.stopWatching(u);for(const u of g)this.startWatching(u)}startWatching(d){const m=new D.NodeJSFileWatcherLibrary(d,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),g={request:d,instance:m};this.watchers.set(d.path,g)}async stop(){for(const[d]of this.watchers)this.stopWatching(d);this.watchers.clear()}stopWatching(d){const m=this.watchers.get(d);m&&(this.watchers.delete(d),m.instance.dispose())}normalizeRequests(d){const m=new Map;for(const g of d){const S=_.isLinux?g.path:g.path.toLowerCase();m.set(S,g)}return Array.from(m.values())}async setVerboseLogging(d){this.verboseLogging=d;for(const[,m]of this.watchers)m.instance.setVerboseLogging(d)}trace(d){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(d)})}toMessage(d,m){return m?`[File Watcher (node.js)] ${d} (path: ${m.request.path})`:`[File Watcher (node.js)] ${d}`}}e.NodeJSWatcher=P}),define(ee[213],te([0,1,77,212]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class n extends E.AbstractNonRecursiveWatcherClient{constructor(D,P,h){super(D,P,h),this.init()}createWatcher(){return new A.NodeJSWatcher}}e.NodeJSWatcherClient=n}),define(ee[214],te([0,1,15,42,158,77]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends _.AbstractUniversalWatcherClient{constructor(h,d,m){super(h,d,m),this.init()}createWatcher(h){const d=h.add(new n.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(d.onDidProcessExit(({code:m,signal:g})=>this.onError(`terminated by itself with code ${m}, signal: ${g}`))),A.ProxyChannel.toService((0,A.getNextTickChannel)(d.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(ee[93],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...n){this._entries=new Map;for(const[_,D]of n)this.set(_,D)}set(n,_){const D=this._entries.get(n);return this._entries.set(n,_),D}has(n){return this._entries.has(n)}get(n){return this._entries.get(n)}}e.ServiceCollection=E}),define(ee[215],te([0,1,8,13,2,75,206,6,93,102]),function(H,e,E,A,n,_,D,P,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const m=!1;class g extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class S{constructor(c=new h.ServiceCollection,f=!1,l,v=m){this._services=c,this._strict=f,this._parent=l,this._enableTracing=v,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=v?l?._globalGraph??new D.Graph(I=>I):void 0}createChild(c){return new S(c,this._strict,this,this._enableTracing)}invokeFunction(c,...f){const l=y.traceInvocation(this._enableTracing,c);let v=!1;try{return c({get:p=>{if(v)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(p,l);if(!t)throw new Error(`[invokeFunction] unknown service '${p}'`);return t}},...f)}finally{v=!0,l.stop()}}createInstance(c,...f){let l,v;return c instanceof _.SyncDescriptor?(l=y.traceCreation(this._enableTracing,c.ctor),v=this._createInstance(c.ctor,c.staticArguments.concat(f),l)):(l=y.traceCreation(this._enableTracing,c),v=this._createInstance(c,f,l)),l.stop(),v}_createInstance(c,f=[],l){const v=P._util.getServiceDependencies(c).sort((t,a)=>t.index-a.index),I=[];for(const t of v){const a=this._getOrCreateServiceInstance(t.id,l);a||this._throwIfStrict(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),I.push(a)}const p=v.length>0?v[0].index:f.length;if(f.length!==p){console.trace(`[createInstance] First service dependency of ${c.name} at position ${p+1} conflicts with ${f.length} static arguments`);const t=p-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,p)}return Reflect.construct(c,f.concat(I))}_setServiceInstance(c,f){if(this._services.get(c)instanceof _.SyncDescriptor)this._services.set(c,f);else if(this._parent)this._parent._setServiceInstance(c,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){const f=this._services.get(c);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):f}_getOrCreateServiceInstance(c,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(c));const l=this._getServiceInstanceOrDescriptor(c);return l instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,l,f.branch(c,!0)):(f.branch(c,!1),l)}_safeCreateAndCacheServiceInstance(c,f,l){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,f,l)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,f,l){const v=new D.Graph(t=>t.id.toString());let I=0;const p=[{id:c,desc:f,_trace:l}];for(;p.length;){const t=p.pop();if(v.lookupOrInsertNode(t),I++>1e3)throw new g(v);for(const a of P._util.getServiceDependencies(t.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(a.id);if(s||this._throwIfStrict(`[createInstance] ${c} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),s instanceof _.SyncDescriptor){const i={id:a.id,desc:s,_trace:t._trace.branch(a.id,!0)};v.insertEdge(t,i),p.push(i)}}}for(;;){const t=v.roots();if(t.length===0){if(!v.isEmpty())throw new g(v);break}for(const{data:a}of t){if(this._getServiceInstanceOrDescriptor(a.id)instanceof _.SyncDescriptor){const i=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,i)}v.removeNode(a)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,f,l=[],v,I){if(this._services.get(c)instanceof _.SyncDescriptor)return this._createServiceInstance(c,f,l,v,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,f,l,v,I);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(c,f,l=[],v,I){if(v){const p=new S(void 0,this._strict,this,this._enableTracing);p._globalGraphImplicitDependency=String(c);const t=new Map,a=new E.IdleValue(()=>{const s=p._createInstance(f,l,I);for(const[i,r]of t){const o=s[i];if(typeof o=="function")for(const w of r)o.apply(s,w)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,i){if(!a.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let w=t.get(i);return w||(w=new d.LinkedList,t.set(i,w)),(M,C,L)=>{const T=w.push([M,C,L]);return(0,n.toDisposable)(T)}}if(i in s)return s[i];const r=a.value;let o=r[i];return typeof o!="function"||(o=o.bind(r),s[i]=o),o},set(s,i,r){return a.value[i]=r,!0},getPrototypeOf(s){return f.prototype}})}else return this._createInstance(f,l,I)}_throwIfStrict(c,f){if(f&&console.warn(c),this._strict)throw new Error(c)}}e.InstantiationService=S;var u;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(u||(u={}));class y{static{this.all=new Set}static{this._None=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,f){return c?new y(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y._None}static traceCreation(c,f){return c?new y(1,f.name):y._None}static{this._totals=0}constructor(c,f){this.type=c,this.name=f,this._start=Date.now(),this._dep=[]}branch(c,f){const l=new y(3,c.toString());return this._dep.push([c,f,l]),l}stop(){const c=Date.now()-this._start;y._totals+=c;let f=!1;function l(I,p){const t=[],a=new Array(I+1).join("	");for(const[s,i,r]of p._dep)if(i&&r){f=!0,t.push(`${a}CREATES -> ${s}`);const o=l(I+1,r);o&&t.push(o)}else t.push(`${a}uses -> ${s}`);return t.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(c>2||f)&&y.all.add(v.join(`
`))}}e.Trace=y}),define(ee[216],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueType=void 0;var A;(function(n){n[n.Bug=0]="Bug",n[n.PerformanceIssue=1]="PerformanceIssue",n[n.FeatureRequest=2]="FeatureRequest"})(A||(e.IssueType=A={})),e.IIssueMainService=(0,E.createDecorator)("issueService")}),define(ee[5],te([0,1,50,3,57,2,35,4,19,12,7,115,6]),function(H,e,E,A,n,_,D,P,h,d,m,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function u(){return new Date().toISOString()}function y(M){return(0,d.isNumber)(M)}e.isLogLevel=y;var b;(function(M){M[M.Off=0]="Off",M[M.Trace=1]="Trace",M[M.Debug=2]="Debug",M[M.Info=3]="Info",M[M.Warning=4]="Warning",M[M.Error=5]="Error"})(b||(e.LogLevel=b={})),e.DEFAULT_LOG_LEVEL=b.Info;function c(M,C,L){switch(C){case b.Trace:M.trace(L);break;case b.Debug:M.debug(L);break;case b.Info:M.info(L);break;case b.Warning:M.warn(L);break;case b.Error:M.error(L);break;case b.Off:break;default:throw new Error(`Invalid log level ${C}`)}}e.log=c;function f(M,C=!1){let L="";for(let T=0;T<M.length;T++){let F=M[T];if(F instanceof Error&&(F=(0,E.toErrorMessage)(F,C)),typeof F=="object")try{F=JSON.stringify(F)}catch{}L+=(T>0?" ":"")+F}return L}class l extends _.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(C){this.level!==C&&(this.level=C,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(C){return this.level!==b.Off&&this.level<=C}}e.AbstractLogger=l;class v extends l{constructor(C){super(),this.logAlways=C}checkLogLevel(C){return this.logAlways||super.checkLogLevel(C)}trace(C,...L){this.checkLogLevel(b.Trace)&&this.log(b.Trace,f([C,...L],!0))}debug(C,...L){this.checkLogLevel(b.Debug)&&this.log(b.Debug,f([C,...L]))}info(C,...L){this.checkLogLevel(b.Info)&&this.log(b.Info,f([C,...L]))}warn(C,...L){this.checkLogLevel(b.Warning)&&this.log(b.Warning,f([C,...L]))}error(C,...L){if(this.checkLogLevel(b.Error))if(C instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=C.stack,this.log(b.Error,f(T))}else this.log(b.Error,f([C,...L]))}flush(){}}e.AbstractMessageLogger=v;class I extends l{constructor(C=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(C),this.useColors=!P.isWindows}trace(C,...L){this.checkLogLevel(b.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,C,...L):console.log(`[main ${u()}]`,C,...L))}debug(C,...L){this.checkLogLevel(b.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,C,...L):console.log(`[main ${u()}]`,C,...L))}info(C,...L){this.checkLogLevel(b.Info)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,C,...L):console.log(`[main ${u()}]`,C,...L))}warn(C,...L){this.checkLogLevel(b.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,C,...L):console.warn(`[main ${u()}]`,C,...L))}error(C,...L){this.checkLogLevel(b.Error)&&(this.useColors?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,C,...L):console.error(`[main ${u()}]`,C,...L))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class p extends l{constructor(C=e.DEFAULT_LOG_LEVEL,L=!0){super(),this.useColors=L,this.setLevel(C)}trace(C,...L){this.checkLogLevel(b.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",C,...L):console.log(C,...L))}debug(C,...L){this.checkLogLevel(b.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",C,...L):console.log(C,...L))}info(C,...L){this.checkLogLevel(b.Info)&&(this.useColors?console.log("%c INFO","color: #33f",C,...L):console.log(C,...L))}warn(C,...L){this.checkLogLevel(b.Warning)&&(this.useColors?console.log("%c WARN","color: #993",C,...L):console.log(C,...L))}error(C,...L){this.checkLogLevel(b.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",C,...L):console.error(C,...L))}dispose(){}flush(){}}e.ConsoleLogger=p;class t extends l{constructor(C,L=e.DEFAULT_LOG_LEVEL){super(),this.adapter=C,this.setLevel(L)}trace(C,...L){this.checkLogLevel(b.Trace)&&this.adapter.log(b.Trace,[this.extractMessage(C),...L])}debug(C,...L){this.checkLogLevel(b.Debug)&&this.adapter.log(b.Debug,[this.extractMessage(C),...L])}info(C,...L){this.checkLogLevel(b.Info)&&this.adapter.log(b.Info,[this.extractMessage(C),...L])}warn(C,...L){this.checkLogLevel(b.Warning)&&this.adapter.log(b.Warning,[this.extractMessage(C),...L])}error(C,...L){this.checkLogLevel(b.Error)&&this.adapter.log(b.Error,[this.extractMessage(C),...L])}extractMessage(C){return typeof C=="string"?C:(0,E.toErrorMessage)(C,this.checkLogLevel(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class a extends l{constructor(C){super(),this.loggers=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const L of this.loggers)L.setLevel(C);super.setLevel(C)}trace(C,...L){for(const T of this.loggers)T.trace(C,...L)}debug(C,...L){for(const T of this.loggers)T.debug(C,...L)}info(C,...L){for(const T of this.loggers)T.info(C,...L)}warn(C,...L){for(const T of this.loggers)T.warn(C,...L)}error(C,...L){for(const T of this.loggers)T.error(C,...L)}flush(){for(const C of this.loggers)C.flush()}dispose(){for(const C of this.loggers)C.dispose()}}e.MultiplexLogger=a;class s extends _.Disposable{constructor(C,L,T){if(super(),this.logLevel=C,this.logsHome=L,this._loggers=new D.ResourceMap,this._onDidChangeLoggers=this._register(new A.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,T)for(const F of T)this._loggers.set(F.resource,{logger:void 0,info:F})}getLoggerEntry(C){return(0,d.isString)(C)?[...this._loggers.values()].find(L=>L.info.id===C):this._loggers.get(C)}getLogger(C){return this.getLoggerEntry(C)?.logger}createLogger(C,L){const T=this.toResource(C),F=(0,d.isString)(C)?C:L?.id??(0,n.hash)(T.toString()).toString(16);let B=this._loggers.get(T)?.logger;const se=L?.logLevel==="always"?b.Trace:L?.logLevel;B||(B=this.doCreateLogger(T,se??this.getLogLevel(T)??this.logLevel,{...L,id:F}));const ie={logger:B,info:{resource:T,id:F,logLevel:se,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(ie.info),this._loggers.set(T,ie),B}toResource(C){return(0,d.isString)(C)?(0,h.joinPath)(this.logsHome,`${C}.log`):C}setLogLevel(C,L){if(m.URI.isUri(C)){const T=C,F=L,B=this._loggers.get(T);B&&F!==B.info.logLevel&&(B.info.logLevel=F===this.logLevel?void 0:F,B.logger?.setLevel(F),this._loggers.set(B.info.resource,B),this._onDidChangeLogLevel.fire([T,F]))}else{this.logLevel=C;for(const[T,F]of this._loggers.entries())this._loggers.get(T)?.info.logLevel===void 0&&F.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(C,L){const T=this.getLoggerEntry(C);T&&L!==!T.info.hidden&&(T.info.hidden=!L,this._loggers.set(T.info.resource,T),this._onDidChangeVisibility.fire([T.info.resource,L]))}getLogLevel(C){let L;return C&&(L=this._loggers.get(C)?.info.logLevel),L??this.logLevel}registerLogger(C){const L=this._loggers.get(C.resource);L?L.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this._loggers.set(C.resource,{info:C,logger:void 0}),this._onDidChangeLoggers.fire({added:[C],removed:[]}))}deregisterLogger(C){const L=this._loggers.get(C);L&&(L.logger&&L.logger.dispose(),this._loggers.delete(C),this._onDidChangeLoggers.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const C of this._loggers.values())yield C.info}getRegisteredLogger(C){return this._loggers.get(C)?.info}dispose(){this._loggers.forEach(C=>C.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class i{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(C){}getLevel(){return b.Info}trace(C,...L){}debug(C,...L){}info(C,...L){}warn(C,...L){}error(C,...L){}critical(C,...L){}dispose(){}flush(){}}e.NullLogger=i;class r extends i{}e.NullLogService=r;function o(M){if(M.verbose)return b.Trace;if(typeof M.logLevel=="string"){const C=k(M.logLevel.toLowerCase());if(C!==void 0)return C}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function w(M){switch(M){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=w;function k(M){switch(M){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=k,e.CONTEXT_LOG_LEVEL=new g.RawContextKey("logLevel",w(b.Info))});var Y=this&&this.__param||function(H,e){return function(E,A){e(E,A,H)}};define(ee[217],te([0,1,76,3,2,5,4,8]),function(H,e,E,A,n,_,D,P){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let d=class extends n.Disposable{static{h=this}static{this.MAX_PASSWORD_LENGTH=2500}static{this.PASSWORD_CHUNK_SIZE=h.MAX_PASSWORD_LENGTH-100}constructor(g){super(),this.logService=g,this._onDidChangePassword=this._register(new A.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this._sequencer=new P.SequencerByKey}async getPassword(g,S){this.logService.trace("Going to get password from keytar:",g,S);let u;try{u=await this.withKeytar()}catch{return null}return await this._sequencer.queue(g+S,()=>this.doGetPassword(u,g,S))}async doGetPassword(g,S,u){this.logService.trace("Doing get password from keytar:",S,u);const y=await(0,P.retry)(()=>g.getPassword(S,u),50,3);if(!y)return this.logService.trace("Did not get a password from keytar for account:",u),y;let b,c;try{const f=JSON.parse(y);b=f.content,c=f.hasNextChunk}catch{}if(!b||!c)return this.logService.trace("Got password from keytar for account:",u),y;try{let f=1;for(;c;){const l=await(0,P.retry)(()=>g.getPassword(S,`${u}-${f}`),50,3),v=JSON.parse(l);b+=v.content,c=v.hasNextChunk,f++}return this.logService.trace(`Got ${f}-chunked password from keytar for account:`,u),b}catch(f){return this.logService.error(f),y}}async setPassword(g,S,u){this.logService.trace("Going to set password using keytar:",g,S);let y;try{y=await this.withKeytar()}catch(b){throw this.surfaceKeytarLoadError?.(b),b}await this._sequencer.queue(g+S,()=>this.doSetPassword(y,g,S,u)),this._onDidChangePassword.fire({service:g,account:S})}async doSetPassword(g,S,u,y){if(this.logService.trace("Doing set password from keytar:",S,u),!D.isWindows){await(0,P.retry)(()=>g.setPassword(S,u,y),50,3),this.logService.trace("Set password from keytar for account:",u);return}if(await this.doDeletePassword(g,S,u),y.length<=h.PASSWORD_CHUNK_SIZE){await(0,P.retry)(()=>g.setPassword(S,u,y),50,3),this.logService.trace("Set password from keytar for account:",u);return}let b=0,c=0,f=!0;for(;f;){const l=y.substring(b,b+h.PASSWORD_CHUNK_SIZE);b+=h.PASSWORD_CHUNK_SIZE,f=y.length-b>0;const v={content:l,hasNextChunk:f};await(0,P.retry)(()=>g.setPassword(S,c?`${u}-${c}`:u,JSON.stringify(v)),50,3),c++}this.logService.trace(`Set${c?` ${c}-chunked`:""} password from keytar for account:`,u)}async deletePassword(g,S){this.logService.trace("Going to delete password using keytar:",g,S);let u;try{u=await this.withKeytar()}catch(b){throw this.surfaceKeytarLoadError?.(b),b}const y=await this._sequencer.queue(g+S,()=>this.doDeletePassword(u,g,S));return y&&this._onDidChangePassword.fire({service:g,account:S}),y}async doDeletePassword(g,S,u){this.logService.trace("Doing delete password from keytar:",S,u);const y=await g.getPassword(S,u);if(!y)return this.logService.trace("Did not get a password to delete from keytar for account:",u),!1;let b,c;try{const l=JSON.parse(y);b=l.content,c=l.hasNextChunk}catch{}let f=0;if(b&&c)try{for(f++;c;){const l=`${u}-${f}`,v=await g.getPassword(S,l);await g.deletePassword(S,l),c=JSON.parse(v).hasNextChunk,f++}}catch(l){this.logService.error(l)}return await g.deletePassword(S,u)?(this.logService.trace(`Deleted${f?` ${f}-chunked`:""} password from keytar for account:`,u),!0):(this.logService.trace(`Keytar failed to delete${f?` ${f}-chunked`:""} password for account:`,u),!1)}async findPassword(g){let S;try{S=await this.withKeytar()}catch{return null}return await S.findPassword(g)}async findCredentials(g){let S;try{S=await this.withKeytar()}catch{return[]}return await S.findCredentials(g)}clear(){return this._keytarCache instanceof E.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};e.BaseCredentialsMainService=d,e.BaseCredentialsMainService=d=h=Ee([Y(0,_.ILogService)],d)}),define(ee[218],te([0,1,14,4,5]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const _=E.safeStorage;let D=class{constructor(h){this.logService=h,E.app.commandLine.getSwitchValue("password-store")==="basic"&&_.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.logService.trace("[EncryptionMainService] Encrypting value.");try{const d=JSON.stringify(_.encryptString(h));return this.logService.trace("[EncryptionMainService] Encrypted value."),d}catch(d){throw this.logService.error(d),d}}async decrypt(h){let d;try{if(d=JSON.parse(h),!d.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const m=Buffer.from(d.data);this.logService.trace("[EncryptionMainService] Decrypting value.");const g=_.decryptString(m);return this.logService.trace("[EncryptionMainService] Decrypted value."),g}catch(m){throw this.logService.error(m),m}}isEncryptionAvailable(){return Promise.resolve(_.isEncryptionAvailable())}getKeyStorageProvider(){if(A.isWindows)return Promise.resolve("dpapi");if(A.isMacintosh)return Promise.resolve("keychain_access");if(_.getSelectedStorageBackend)try{const h=_.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.logService.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(A.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(A.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!_.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");_.setUsePlainTextEncryption(!0)}};e.EncryptionMainService=D,e.EncryptionMainService=D=Ee([Y(0,n.ILogService)],D)}),define(ee[219],te([0,1,24,8,13,3,2,9,77,5]),function(H,e,E,A,n,_,D,P,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class m extends D.Disposable{constructor(S,u){super(),this.logService=S,this.options=u,this._onDidChangeFile=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new A.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new A.ThrottledDelayer(0))}watch(S,u){return u.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,u):this.watchNonRecursive(S,u)}watchUniversal(S,u){const y={path:this.toFilePath(S),excludes:u.excludes,includes:u.includes,recursive:u.recursive},b=(0,E.insert)(this.universalPathsToWatch,y);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{b(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,n.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(u=>this._onDidChangeFile.fire((0,h.toFileChanges)(u)),u=>this.onWatcherLogMessage(u),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const u of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(u)&&(u.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const u of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(u)&&S.includes(u.path)&&(u.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,u){const y={path:this.toFilePath(S),excludes:u.excludes,includes:u.includes,recursive:!1},b=(0,E.insert)(this.nonRecursivePathsToWatch,y);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{b(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,n.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,h.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,P.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=m}),define(ee[220],te([0,1,24,8,17,23,3,57,68,2,58,15,65,19,56,173,16,119,5,13]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class extends d.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new A.ResourceQueue)}registerProvider(t,a){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${t}`);const s=new d.DisposableStore;return this.provider.set(t,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:a}),s.add(a.onDidChangeFile(i=>this._onDidFilesChange.fire(new c.FileChangesEvent(i,!this.isPathCaseSensitive(a))))),typeof a.onDidWatchError=="function"&&s.add(a.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),s.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:t}))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:a}),this.provider.delete(t),(0,d.dispose)(s)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(s){a.push(s)}}),!this.provider.has(t)&&await A.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,a){const s=this.provider.get(t.scheme);return!!(s&&s.capabilities&a)}listCapabilities(){return h.Iterable.map(this.provider,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async withProvider(t){if(!(0,u.isAbsolutePath)(t))throw new c.FileOperationError((0,b.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const a=this.provider.get(t.scheme);if(!a){const s=new v.ErrorNoTelemetry;throw s.message=(0,b.localize)(1,null,t.toString()),s}return a}async withReadProvider(t){const a=await this.withProvider(t);if((0,c.hasOpenReadWriteCloseCapability)(a)||(0,c.hasReadWriteCapability)(a)||(0,c.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const a=await this.withProvider(t);if((0,c.hasOpenReadWriteCloseCapability)(a)||(0,c.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.doResolveFile(t,a)}catch(s){throw(0,c.toFileSystemProviderErrorCode)(s)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,b.localize)(2,null,this.resourceForError(t)),1):(0,c.ensureFileSystemProviderError)(s)}}async doResolveFile(t,a){const s=await this.withProvider(t),i=this.isPathCaseSensitive(s),r=a?.resolveTo,o=a?.resolveSingleChildDescendants,w=a?.resolveMetadata,k=await s.stat(t);let M;return this.toFileStat(s,t,k,void 0,!!w,(C,L)=>(M||(M=m.TernarySearchTree.forUris(()=>!i),M.set(t,!0),r&&M.fill(!0,r)),M.get(C.resource)||M.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&o?L===1:!1))}async toFileStat(t,a,s,i,r,o){const{providerExtUri:w}=this.getExtUri(t),k={resource:a,name:w.basename(a),isFile:(s.type&c.FileType.File)!==0,isDirectory:(s.type&c.FileType.Directory)!==0,isSymbolicLink:(s.type&c.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&c.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((s.permissions??0)&c.FilePermission.Locked),etag:(0,c.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(k.isDirectory&&o(k,i)){try{const M=await t.readdir(a),C=await A.Promises.settled(M.map(async([L,T])=>{try{const F=w.joinPath(a,L),B=r?await t.stat(F):{type:T};return await this.toFileStat(t,F,B,M.length,r,o)}catch(F){return this.logService.trace(F),null}}));k.children=(0,E.coalesce)(C)}catch(M){this.logService.trace(M),k.children=[]}return k}return k}async resolveAll(t){return A.Promises.settled(t.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.withProvider(t),s=await a.stat(t);return this.toFileStat(a,t,s,void 0,!0,()=>!1)}async exists(t){const a=await this.withProvider(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.doValidateCreateFile(t,a)}catch(s){return s}return!0}async doValidateCreateFile(t,a){if(!a?.overwrite&&await this.exists(t))throw new c.FileOperationError((0,b.localize)(3,null,this.resourceForError(t)),3,a)}async createFile(t,a=n.VSBuffer.fromString(""),s){await this.doValidateCreateFile(t,s);const i=await this.writeFile(t,a);return this._onDidRunOperation.fire(new c.FileOperationEvent(t,0,i)),i}async writeFile(t,a,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,t,s)||await this.mkdirp(i,r.dirname(t));let w;if((0,c.hasReadWriteCapability)(i)&&!(a instanceof n.VSBuffer))if((0,y.isReadableStream)(a)){const k=await(0,y.peekStream)(a,3);k.ended?w=n.VSBuffer.concat(k.buffer):w=k}else w=(0,y.peekReadable)(a,k=>n.VSBuffer.concat(k),3);else w=a;if(!(0,c.hasOpenReadWriteCloseCapability)(i)||(0,c.hasReadWriteCapability)(i)&&w instanceof n.VSBuffer)await this.doWriteUnbuffered(i,t,s,w);else{const k=w instanceof n.VSBuffer?(0,n.bufferToReadable)(w):w;s?.atomic!==!1&&s?.atomic?.postfix?await this.doWriteBufferedAtomic(i,t,(0,u.joinPath)((0,u.dirname)(t),`${(0,u.basename)(t)}${s.atomic.postfix}`),s,k):await this.doWriteBuffered(i,t,s,k)}this._onDidRunOperation.fire(new c.FileOperationEvent(t,4))}catch(o){throw new c.FileOperationError((0,b.localize)(4,null,this.resourceForError(t),(0,c.ensureFileSystemProviderError)(o).toString()),(0,c.toFileOperationResult)(o),s)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,a,s){const i=!!s?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,b.localize)(5,null,this.resourceForError(a)));if(!!s?.atomic){if(!(t.capabilities&32768))throw new Error((0,b.localize)(6,null,this.resourceForError(a)));if(i)throw new Error((0,b.localize)(7,null,this.resourceForError(a)))}let o;try{o=await t.stat(a)}catch{return}if(o.type&c.FileType.Directory)throw new c.FileOperationError((0,b.localize)(8,null,this.resourceForError(a)),0,s);if(this.throwIfFileIsReadonly(a,o),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==c.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&s.mtime<o.mtime&&s.etag!==(0,c.etag)({mtime:s.mtime,size:o.size}))throw new c.FileOperationError((0,b.localize)(9,null),3,s);return o}async readFile(t,a,s){const i=await this.withReadProvider(t);return a?.atomic?this.doReadFileAtomic(i,t,a,s):this.doReadFile(i,t,a,s)}async doReadFileAtomic(t,a,s,i){return new Promise((r,o)=>{this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(async()=>{try{const w=await this.doReadFile(t,a,s,i);r(w)}catch(w){o(w)}})})}async doReadFile(t,a,s,i){const r=await this.doReadFileStream(t,a,{...s,preferUnbuffered:!0},i);return{...r,value:await(0,n.streamToBuffer)(r.value)}}async readFileStream(t,a,s){const i=await this.withReadProvider(t);return this.doReadFileStream(i,t,a,s)}async doReadFileStream(t,a,s,i){const r=new _.CancellationTokenSource(i),o=this.validateReadFile(a,s).then(k=>k,k=>{throw r.cancel(),k});let w;try{return typeof s?.etag=="string"&&s.etag!==c.ETAG_DISABLED&&await o,s?.atomic&&(0,c.hasFileAtomicReadCapability)(t)||!((0,c.hasOpenReadWriteCloseCapability)(t)||(0,c.hasFileReadStreamCapability)(t))||(0,c.hasReadWriteCapability)(t)&&s?.preferUnbuffered?w=this.readFileUnbuffered(t,a,s):(0,c.hasFileReadStreamCapability)(t)?w=this.readFileStreamed(t,a,r.token,s):w=this.readFileBuffered(t,a,r.token,s),{...await o,value:w}}catch(k){throw w&&await(0,y.consumeStream)(w),this.restoreReadError(k,a,s)}}restoreReadError(t,a,s){const i=(0,b.localize)(10,null,this.resourceForError(a),(0,c.ensureFileSystemProviderError)(t).toString());return t instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(i,t.stat,s):t instanceof c.TooLargeFileOperationError?new c.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new c.FileOperationError(i,(0,c.toFileOperationResult)(t),s)}readFileStreamed(t,a,s,i=Object.create(null)){const r=t.readFileStream(a,i,s);return(0,y.transform)(r,{data:o=>o instanceof n.VSBuffer?o:n.VSBuffer.wrap(o),error:o=>this.restoreReadError(o,a,i)},o=>n.VSBuffer.concat(o))}readFileBuffered(t,a,s,i=Object.create(null)){const r=(0,n.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,a,r,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>this.restoreReadError(o,a,i)},s),r}readFileUnbuffered(t,a,s){const i=(0,y.newWriteableStream)(r=>n.VSBuffer.concat(r));return(async()=>{try{let r;s?.atomic&&(0,c.hasFileAtomicReadCapability)(t)?r=await t.readFile(a,{atomic:!0}):r=await t.readFile(a),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.validateReadFileLimits(a,r.byteLength,s),i.end(n.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(t,a){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new c.FileOperationError((0,b.localize)(11,null,this.resourceForError(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==c.ETAG_DISABLED&&a.etag===s.etag)throw new c.NotModifiedSinceFileOperationError((0,b.localize)(12,null),s,a);return this.validateReadFileLimits(t,s.size,a),s}validateReadFileLimits(t,a,s){if(typeof s?.limits?.size=="number"&&a>s.limits.size)throw new c.TooLargeFileOperationError((0,b.localize)(13,null,this.resourceForError(t)),7,a,s)}async canMove(t,a,s){return this.doCanMoveCopy(t,a,"move",s)}async canCopy(t,a,s){return this.doCanMoveCopy(t,a,"copy",s)}async doCanMoveCopy(t,a,s,i){if(t.toString()!==a.toString())try{const r=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(r,t,o,a,s,i)}catch(r){return r}return!0}async move(t,a,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),o=await this.doMoveCopy(i,t,r,a,"move",!!s),w=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(t,o==="move"?2:3,w)),w}async copy(t,a,s){const i=await this.withReadProvider(t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),o=await this.doMoveCopy(i,t,r,a,"copy",!!s),w=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(t,o==="copy"?3:2,w)),w}async doMoveCopy(t,a,s,i,r,o){if(a.toString()===i.toString())return r;const{exists:w,isSameResourceWithDifferentPathCase:k}=await this.doValidateMoveCopy(t,a,s,i,r,o);if(w&&!k&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(i)),r==="copy"){if(t===s&&(0,c.hasFileFolderCopyCapability)(t))await t.copy(a,i,{overwrite:o});else{const M=await this.resolve(a);M.isDirectory?await this.doCopyFolder(t,M,s,i):await this.doCopyFile(t,a,s,i)}return r}else return t===s?(await t.rename(a,i,{overwrite:o}),r):(await this.doMoveCopy(t,a,s,i,"copy",o),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(t,a,s,i){if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(t,a,s,i);if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(t,a,s,i);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(t,a,s,i);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasReadWriteCapability)(s))return this.doPipeUnbuffered(t,a,s,i)}async doCopyFolder(t,a,s,i){await s.mkdir(i),Array.isArray(a.children)&&await A.Promises.settled(a.children.map(async r=>{const o=this.getExtUri(s).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(t,await this.resolve(r.resource),s,o):this.doCopyFile(t,r.resource,s,o)}))}async doValidateMoveCopy(t,a,s,i,r,o){let w=!1;if(t===s){const{providerExtUri:M,isPathCaseSensitive:C}=this.getExtUri(t);if(C||(w=M.isEqual(a,i)),w&&r==="copy")throw new Error((0,b.localize)(14,null,this.resourceForError(a),this.resourceForError(i)));if(!w&&M.isEqualOrParent(i,a))throw new Error((0,b.localize)(15,null,this.resourceForError(a),this.resourceForError(i)))}const k=await this.exists(i);if(k&&!w){if(!o)throw new c.FileOperationError((0,b.localize)(16,null,this.resourceForError(a),this.resourceForError(i)),4);if(t===s){const{providerExtUri:M}=this.getExtUri(t);if(M.isEqualOrParent(a,i))throw new Error((0,b.localize)(17,null,this.resourceForError(a),this.resourceForError(i)))}}return{exists:k,isSameResourceWithDifferentPathCase:w}}getExtUri(t){const a=this.isPathCaseSensitive(t);return{providerExtUri:a?u.extUri:u.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(a,t);const s=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(t,0,s)),s}async mkdirp(t,a){const s=[],{providerExtUri:i}=this.getExtUri(t);for(;!i.isEqual(a,i.dirname(a));)try{if(!((await t.stat(a)).type&c.FileType.Directory))throw new Error((0,b.localize)(18,null,this.resourceForError(a)));break}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(i.basename(a)),a=i.dirname(a)}for(let r=s.length-1;r>=0;r--){a=i.joinPath(a,s[r]);try{await t.mkdir(a)}catch(o){if((0,c.toFileSystemProviderErrorCode)(o)!==c.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,a){try{await this.doValidateDelete(t,a)}catch(s){return s}return!0}async doValidateDelete(t,a){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),i=!!a?.useTrash;if(i&&!(s.capabilities&4096))throw new Error((0,b.localize)(19,null,this.resourceForError(t)));const r=a?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,b.localize)(20,null,this.resourceForError(t)));if(i&&r)throw new Error((0,b.localize)(21,null,this.resourceForError(t)));let o;try{o=await s.stat(t)}catch{}if(o)this.throwIfFileIsReadonly(t,o);else throw new c.FileOperationError((0,b.localize)(22,null,this.resourceForError(t)),1);if(!!!a?.recursive){const k=await this.resolve(t);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,b.localize)(23,null,this.resourceForError(t)))}return s}async del(t,a){const s=await this.doValidateDelete(t,a),i=!!a?.useTrash,r=!!a?.recursive,o=a?.atomic??!1;await s.delete(t,{recursive:r,useTrash:i,atomic:o}),this._onDidRunOperation.fire(new c.FileOperationEvent(t,1))}async cloneFile(t,a){const s=await this.withProvider(t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);if(s===i&&this.getExtUri(s).providerExtUri.isEqual(t,a))return;if(s===i&&(0,c.hasFileCloneCapability)(s))return s.cloneFile(t,a);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(a));const r=this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri);return s===i&&(0,c.hasFileFolderCopyCapability)(s)?r.queue(()=>s.copy(t,a,{overwrite:!0})):r.queue(()=>this.doCopyFile(s,t,i,a))}watch(t,a={recursive:!1,excludes:[]}){const s=new d.DisposableStore;let i=!1,r=()=>{i=!0};return s.add((0,d.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(t,a);i?(0,d.dispose)(o):r=()=>(0,d.dispose)(o)}catch(o){this.logService.error(o)}})(),s}async doWatch(t,a){const s=await this.withProvider(t),i=(0,P.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(t),a]);let r=this.activeWatchers.get(i);return r||(r={count:0,disposable:s.watch(t,a)},this.activeWatchers.set(i,r)),r.count+=1,(0,d.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,d.dispose)(r.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,d.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBufferedAtomic(t,a,s,i,r){await this.doWriteBuffered(t,s,i,r);try{await t.rename(s,a,{overwrite:!0})}catch(o){try{await t.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async doWriteBuffered(t,a,s,i){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(async()=>{const r=await t.open(a,{create:!0,unlock:s?.unlock??!1});try{(0,y.isReadableStream)(i)||(0,y.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(t,r,i):await this.doWriteReadableBufferedQueued(t,r,i)}catch(o){throw(0,c.ensureFileSystemProviderError)(o)}finally{await t.close(r)}})}async doWriteStreamBufferedQueued(t,a,s){let i=0,r;if((0,y.isReadableBufferedStream)(s)){if(s.buffer.length>0){const o=n.VSBuffer.concat(s.buffer);await this.doWriteBuffer(t,a,o,o.byteLength,i,0),i+=o.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((o,w)=>{(0,y.listenStream)(r,{onData:async k=>{r.pause();try{await this.doWriteBuffer(t,a,k,k.byteLength,i,0)}catch(M){return w(M)}i+=k.byteLength,setTimeout(()=>r.resume())},onError:k=>w(k),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(t,a,s){let i=0,r;for(;(r=s.read())!==null;)await this.doWriteBuffer(t,a,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(t,a,s,i,r,o){let w=0;for(;w<i;){const k=await t.write(a,r+w,s.buffer,o+w,i-w);w+=k}}async doWriteUnbuffered(t,a,s,i){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,a,s,i))}async doWriteUnbufferedQueued(t,a,s,i){let r;i instanceof n.VSBuffer?r=i:(0,y.isReadableStream)(i)?r=await(0,n.streamToBuffer)(i):(0,y.isReadableBufferedStream)(i)?r=await(0,n.bufferedStreamToBuffer)(i):r=(0,n.readableToBuffer)(i),await t.writeFile(a,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async doPipeBuffered(t,a,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,a,s,i))}async doPipeBufferedQueued(t,a,s,i){let r,o;try{r=await t.open(a,{create:!1}),o=await s.open(i,{create:!0,unlock:!1});const w=n.VSBuffer.alloc(this.BUFFER_SIZE);let k=0,M=0,C=0;do C=await t.read(r,k,w.buffer,M,w.byteLength-M),await this.doWriteBuffer(s,o,w,C,k,M),k+=C,M+=C,M===w.byteLength&&(M=0);while(C>0)}catch(w){throw(0,c.ensureFileSystemProviderError)(w)}finally{await A.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof o=="number"?s.close(o):Promise.resolve()])}}async doPipeUnbuffered(t,a,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,a,s,i))}async doPipeUnbufferedQueued(t,a,s,i){return s.writeFile(i,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,a,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,a,s,i))}async doPipeUnbufferedToBufferedQueued(t,a,s,i){const r=await s.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(a);await this.doWriteBuffer(s,r,n.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,c.ensureFileSystemProviderError)(o)}finally{await s.close(r)}}async doPipeBufferedToUnbuffered(t,a,s,i){const r=await(0,n.streamToBuffer)(this.readFileBuffered(t,a,_.CancellationToken.None));await this.doWriteUnbuffered(s,i,void 0,r)}throwIfFileSystemIsReadonly(t,a){if(t.capabilities&2048)throw new c.FileOperationError((0,b.localize)(24,null,this.resourceForError(a)),6);return t}throwIfFileIsReadonly(t,a){if((a.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,b.localize)(25,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===g.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=I,e.FileService=I=Ee([Y(0,l.ILogService)],I)}),define(ee[94],te([0,1,45,310,8,35,17,3,32,2,9,4,19,56,21,177,16,119,219,50,214,213]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f,l,v,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,A.gracefulify)(E)}catch(a){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(a)}`)}})();class t extends l.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new _.ResourceMap(r=>S.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,g.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:r}=await y.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:c.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await y.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async o=>{try{let w;o.isSymbolicLink()?w=(await this.stat((0,S.joinPath)(s,o.name))).type:w=this.toType(o),r.push([o.name,w])}catch(w){this.logService.trace(w)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let r;return i?.dangling?r=c.FileType.Unknown:s.isFile()?r=c.FileType.File:s.isDirectory()?r=c.FileType.Directory:r=c.FileType.Unknown,i&&(r|=c.FileType.SymbolicLink),r}async createResourceLock(s){const i=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const o=new n.Barrier;return this.resourceLocks.set(s,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,d.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(s)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(s,i){let r;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),r=await this.createResourceLock(s));const o=this.toFilePath(s);return await y.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{r?.dispose()}}traceLock(s){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,i,r){const o=(0,u.newWriteableStream)(w=>D.VSBuffer.concat(w.map(k=>D.VSBuffer.wrap(k))).buffer);return(0,f.readFileIntoStream)(this,s,o,w=>w.buffer,{...i,bufferSize:256*1024},r),o}async writeFile(s,i,r){return r?.atomic!==!1&&r?.atomic?.postfix?this.doWriteFileAtomic(s,(0,S.joinPath)((0,S.dirname)(s),`${(0,S.basename)(s)}${r.atomic.postfix}`),i,r):this.doWriteFile(s,i,r)}async doWriteFileAtomic(s,i,r,o){await this.doWriteFile(i,r,o);try{await this.rename(i,s,{overwrite:!0})}catch(w){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw w}}async doWriteFile(s,i,r){let o;try{const w=this.toFilePath(s);if(!r.create||!r.overwrite){if(await y.Promises.exists(w)){if(!r.overwrite)throw(0,c.createFileSystemProviderError)((0,b.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,c.createFileSystemProviderError)((0,b.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(s,{create:!0,unlock:r.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(w){throw await this.toFileSystemProviderWriteError(s,w)}finally{typeof o=="number"&&await this.close(o)}}static{this.canFlush=!0}static configureFlushOnWrite(s){t.canFlush=s}async open(s,i){const r=this.toFilePath(s);let o;(0,c.isFileOpenForWriteOptions)(i)&&(o=await this.createResourceLock(s));let w;try{if((0,c.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:M}=await y.SymlinkSupport.stat(r);M.mode&128||await y.Promises.chmod(r,M.mode|128)}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}let k;if((0,c.isFileOpenForWriteOptions)(i)){if(g.isWindows)try{await y.Promises.truncate(r,0),k="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}k||(k="w")}else k="r";w=await y.Promises.open(r,k)}catch(k){throw o?.dispose(),(0,c.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,k):this.toFileSystemProviderError(k)}if(this.mapHandleToPos.set(w,0),(0,c.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(w,s),o){const k=this.mapHandleToLock.get(w);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${w} (${r})`),this.mapHandleToLock.set(w,o),k&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${w} (${r})`),k.dispose())}return w}async close(s){const i=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&t.canFlush)try{await y.Promises.fdatasync(s)}catch(r){t.configureFlushOnWrite(!1),this.logService.error(r)}return await y.Promises.close(s)}catch(r){throw this.toFileSystemProviderError(r)}finally{i&&(this.mapHandleToLock.get(s)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,r,o,w){const k=this.normalizePos(s,i);let M=null;try{M=(await y.Promises.read(s,r,o,w,k)).bytesRead}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(s,k,M)}return M}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,r){const o=this.mapHandleToPos.get(s);typeof o=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(s,o+r):this.mapHandleToPos.delete(s)))}async write(s,i,r,o,w){return(0,n.retry)(()=>this.doWrite(s,i,r,o,w),100,3)}async doWrite(s,i,r,o,w){const k=this.normalizePos(s,i);let M=null;try{M=(await y.Promises.write(s,r,o,w,k)).bytesWritten}catch(C){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),C)}finally{this.updatePos(s,k,M)}return M}async mkdir(s){try{await y.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const r=this.toFilePath(s);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,m.join)((0,m.dirname)(r),`${(0,m.basename)(r)}${i.atomic.postfix}`)),await y.Promises.rm(r,y.RimRafMode.MOVE,o)}else try{await y.Promises.unlink(r)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let w=!1;try{const{stat:k,symbolicLink:M}=await y.SymlinkSupport.stat(r);w=k.isDirectory()&&!M}catch{}if(w)await y.Promises.rmdir(r);else throw o}else throw o}}catch(r){throw this.toFileSystemProviderError(r)}}async rename(s,i,r){const o=this.toFilePath(s),w=this.toFilePath(i);if(o!==w)try{await this.validateMoveCopy(s,i,"move",r.overwrite),await y.Promises.rename(o,w)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,b.localize)(2,null,(0,m.basename)(o),(0,m.basename)((0,m.dirname)(w)),k.toString()))),this.toFileSystemProviderError(k)}}async copy(s,i,r){const o=this.toFilePath(s),w=this.toFilePath(i);if(o!==w)try{await this.validateMoveCopy(s,i,"copy",r.overwrite),await y.Promises.copy(o,w,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,b.localize)(3,null,(0,m.basename)(o),(0,m.basename)((0,m.dirname)(w)),k.toString()))),this.toFileSystemProviderError(k)}}async validateMoveCopy(s,i,r,o){const w=this.toFilePath(s),k=this.toFilePath(i);let M=!1;if(!!(this.capabilities&1024)||(M=(0,h.isEqual)(w,k,!0)),M){if(r==="copy")throw(0,c.createFileSystemProviderError)((0,b.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const L=await this.statIgnoreError(s);if(!L)throw(0,c.createFileSystemProviderError)((0,b.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const T=await this.statIgnoreError(i);if(T){if(!o)throw(0,c.createFileSystemProviderError)((0,b.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);L.type&c.FileType.File&&T.type&c.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.doCloneFile(s,i,!1)}async doCloneFile(s,i,r){const o=this.toFilePath(s),w=this.toFilePath(i),k=!!(this.capabilities&1024);if((0,h.isEqual)(o,w,!k))return;const M=new d.DisposableStore;try{const[C,L]=await Promise.all([this.createResourceLock(s),this.createResourceLock(i)]);M.add(C),M.add(L),r&&await y.Promises.mkdir((0,m.dirname)(w),{recursive:!0}),await y.Promises.copyFile(o,w)}catch(C){if(C.code==="ENOENT"&&!r)return this.doCloneFile(s,i,!0);throw this.toFileSystemProviderError(C)}finally{M.dispose()}}createUniversalWatcher(s,i,r){return new I.UniversalWatcherClient(o=>s(o),o=>i(o),r)}createNonRecursiveWatcher(s,i,r){return new p.NodeJSWatcherClient(o=>s(o),o=>i(o),r)}toFileSystemProviderError(s){if(s instanceof c.FileSystemProviderError)return s;let i=s,r;switch(s.code){case"ENOENT":r=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=c.FileSystemProviderErrorCode.Unknown;break;default:r=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(s,i){let r=this.toFileSystemProviderError(i);if(s&&r.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.toFilePath(s));o.mode&128||(r=(0,c.createFileSystemProviderError)(i,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return r}}e.DiskFileSystemProvider=t}),define(ee[221],te([0,1,3,94,2,17,56,23]),function(H,e,E,A,n,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class h extends n.Disposable{constructor(g,S){super(),this.provider=g,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(g,S,u){const y=this.getUriTransformer(g);switch(S){case"stat":return this.stat(y,u[0]);case"readdir":return this.readdir(y,u[0]);case"open":return this.open(y,u[0],u[1]);case"close":return this.close(u[0]);case"read":return this.read(u[0],u[1],u[2]);case"readFile":return this.readFile(y,u[0],u[1]);case"write":return this.write(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.writeFile(y,u[0],u[1],u[2]);case"rename":return this.rename(y,u[0],u[1],u[2]);case"copy":return this.copy(y,u[0],u[1],u[2]);case"cloneFile":return this.cloneFile(y,u[0],u[1]);case"mkdir":return this.mkdir(y,u[0]);case"delete":return this.delete(y,u[0],u[1]);case"watch":return this.watch(y,u[0],u[1],u[2],u[3]);case"unwatch":return this.unwatch(u[0],u[1])}throw new Error(`IPC Command ${S} not found`)}listen(g,S,u){const y=this.getUriTransformer(g);switch(S){case"fileChange":return this.onFileChange(y,u[0]);case"readFileStream":return this.onReadFileStream(y,u[0],u[1])}throw new Error(`Unknown event ${S}`)}stat(g,S){const u=this.transformIncoming(g,S,!0);return this.provider.stat(u)}readdir(g,S){const u=this.transformIncoming(g,S);return this.provider.readdir(u)}async readFile(g,S,u){const y=this.transformIncoming(g,S,!0),b=await this.provider.readFile(y,u);return _.VSBuffer.wrap(b)}onReadFileStream(g,S,u){const y=this.transformIncoming(g,S,!0),b=new P.CancellationTokenSource,c=new E.Emitter({onDidRemoveLastListener:()=>{b.cancel()}}),f=this.provider.readFileStream(y,u,b.token);return(0,D.listenStream)(f,{onData:l=>c.fire(_.VSBuffer.wrap(l)),onError:l=>c.fire(l),onEnd:()=>{c.fire("end"),c.dispose(),b.dispose()}}),c.event}writeFile(g,S,u,y){const b=this.transformIncoming(g,S);return this.provider.writeFile(b,u.buffer,y)}open(g,S,u){const y=this.transformIncoming(g,S,!0);return this.provider.open(y,u)}close(g){return this.provider.close(g)}async read(g,S,u){const y=_.VSBuffer.alloc(u),b=0,c=await this.provider.read(g,S,y.buffer,b,u);return[y,c]}write(g,S,u,y,b){return this.provider.write(g,S,u.buffer,y,b)}mkdir(g,S){const u=this.transformIncoming(g,S);return this.provider.mkdir(u)}delete(g,S,u){const y=this.transformIncoming(g,S);return this.provider.delete(y,u)}rename(g,S,u,y){const b=this.transformIncoming(g,S),c=this.transformIncoming(g,u);return this.provider.rename(b,c,y)}copy(g,S,u,y){const b=this.transformIncoming(g,S),c=this.transformIncoming(g,u);return this.provider.copy(b,c,y)}cloneFile(g,S,u){const y=this.transformIncoming(g,S),b=this.transformIncoming(g,u);return this.provider.cloneFile(y,b)}onFileChange(g,S){const u=new E.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(g,u))},onDidRemoveLastListener:()=>{(0,n.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return u.event}async watch(g,S,u,y,b){const c=this.sessionToWatcher.get(S);if(c){const f=this.transformIncoming(g,y),l=c.watch(u,f,b);this.watchRequests.set(S+u,l)}}async unwatch(g,S){const u=g+S,y=this.watchRequests.get(u);y&&((0,n.dispose)(y),this.watchRequests.delete(u))}dispose(){super.dispose();for(const[,g]of this.watchRequests)g.dispose();this.watchRequests.clear();for(const[,g]of this.sessionToWatcher)g.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=h;class d extends n.Disposable{constructor(g,S,u,y){super(),this.uriTransformer=g,this.logService=u,this.environmentService=y,this.watcherRequests=new Map,this.fileWatcher=this._register(new A.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(g){const S=this._register(new E.Emitter);this._register(S.event(u=>{g.fire(u.map(y=>({resource:this.uriTransformer.transformOutgoingURI(y.resource),type:y.type})))})),this._register(this.fileWatcher.onDidChangeFile(u=>S.fire(u))),this._register(this.fileWatcher.onDidWatchError(u=>g.fire(u)))}getRecursiveWatcherOptions(g){}getExtraExcludes(g){}watch(g,S,u){const y=this.getExtraExcludes(this.environmentService);return Array.isArray(y)&&(u.excludes=[...u.excludes,...y]),this.watcherRequests.set(g,this.fileWatcher.watch(S,u)),(0,n.toDisposable)(()=>{(0,n.dispose)(this.watcherRequests.get(g)),this.watcherRequests.delete(g)})}dispose(){super.dispose();for(const[,g]of this.watcherRequests)g.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=d}),define(ee[222],te([0,1,14,176,4,7,16,9,221,154]),function(H,e,E,A,n,_,D,P,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class m extends h.AbstractDiskFileSystemProviderChannel{constructor(u,y,b){super(u,y),this.environmentService=b}getUriTransformer(u){return d.DefaultURITransformer}transformIncoming(u,y){return _.URI.revive(y)}async delete(u,y,b){if(!b.useTrash)return super.delete(u,y,b);const c=this.transformIncoming(u,y),f=(0,P.normalize)(c.fsPath);try{await E.shell.trashItem(f)}catch{throw(0,D.createFileSystemProviderError)(n.isWindows?(0,A.localize)(0,null,(0,P.basename)(f)):(0,A.localize)(1,null,(0,P.basename)(f)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(u,y){return new g(u,y,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=m;class g extends h.AbstractSessionFileWatcher{watch(u,y,b){if(b.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(u,y,b)}}}),define(ee[223],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class A extends E.AbstractMessageLogger{constructor(_=E.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(_),this._register(this.onDidChangeLogLevel(D=>{this._logger?.setLevel(D)}))}set logger(_){this._logger=_;for(const{level:D,message:P}of this.buffer)(0,E.log)(_,D,P);this.buffer=[]}log(_,D){this._logger?(0,E.log)(this._logger,_,D):this.getLevel()<=_&&this.buffer.push({level:_,message:D})}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=A}),define(ee[224],te([0,1,7,3,5,2]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class D extends n.AbstractLoggerService{constructor(g,S,u,y,b){super(S,u,y),this.windowId=g,this.channel=b,this._register(b.listen("onDidChangeLogLevel",g)(c=>{(0,n.isLogLevel)(c)?super.setLogLevel(c):super.setLogLevel(E.URI.revive(c[0]),c[1])})),this._register(b.listen("onDidChangeVisibility",g)(([c,f])=>super.setVisibility(E.URI.revive(c),f))),this._register(b.listen("onDidChangeLoggers",g)(({added:c,removed:f})=>{for(const l of c)super.registerLogger({...l,resource:E.URI.revive(l.resource)});for(const l of f)super.deregisterLogger(l.resource)}))}createConsoleMainLogger(){return new n.AdapterLogger({log:(g,S)=>{this.channel.call("consoleLog",[g,S])}})}registerLogger(g){super.registerLogger(g),this.channel.call("registerLogger",[g,this.windowId])}deregisterLogger(g){super.deregisterLogger(g),this.channel.call("deregisterLogger",[g,this.windowId])}setLogLevel(g,S){super.setLogLevel(g,S),this.channel.call("setLogLevel",[g,S])}setVisibility(g,S){super.setVisibility(g,S),this.channel.call("setVisibility",[this.toResource(g),S])}doCreateLogger(g,S,u){return new P(this.channel,g,S,u,this.windowId)}static setLogLevel(g,S,u){return g.call("setLogLevel",[S,u])}}e.LoggerChannelClient=D;class P extends n.AbstractMessageLogger{constructor(g,S,u,y,b){super(y?.logLevel==="always"),this.channel=g,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[S,y,b]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,S){const u=[[g,S]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(g){this.channel.call("log",[this.file,g])}}class h{constructor(g,S){this.loggerService=g,this.getUriTransformer=S}listen(g,S){const u=this.getUriTransformer(g);switch(S){case"onDidChangeLoggers":return A.Event.map(this.loggerService.onDidChangeLoggers,y=>({added:[...y.added].map(b=>this.transformLogger(b,u)),removed:[...y.removed].map(b=>this.transformLogger(b,u))}));case"onDidChangeVisibility":return A.Event.map(this.loggerService.onDidChangeVisibility,y=>[u.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return A.Event.map(this.loggerService.onDidChangeLogLevel,y=>(0,n.isLogLevel)(y)?y:[u.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${S}`)}async call(g,S,u){const y=this.getUriTransformer(g);switch(S){case"setLogLevel":return(0,n.isLogLevel)(u[0])?this.loggerService.setLogLevel(u[0]):this.loggerService.setLogLevel(E.URI.revive(y.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(b=>this.transformLogger(b,y)))}throw new Error(`Call not found: ${S}`)}transformLogger(g,S){return{...g,resource:S.transformOutgoingURI(g.resource)}}}e.LoggerChannel=h;class d extends _.Disposable{constructor(g,S){super(),S.call("setLogLevel",[g.getLogLevel()]),this._register(g.onDidChangeLogLevel(u=>S.call("setLogLevel",[u]))),S.call("getRegisteredLoggers").then(u=>{for(const y of u)g.registerLogger({...y,resource:E.URI.revive(y.resource)})}),this._register(S.listen("onDidChangeVisibility")(([u,y])=>g.setVisibility(E.URI.revive(u),y))),this._register(S.listen("onDidChangeLoggers")(({added:u,removed:y})=>{for(const b of u)g.registerLogger({...b,resource:E.URI.revive(b.resource)});for(const b of y)g.deregisterLogger(b.resource)}))}}e.RemoteLoggerChannelClient=d}),define(ee[225],te([0,1,2,5]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class n extends E.Disposable{constructor(D,P=[]){super(),this.logger=new A.MultiplexLogger([D,...P]),this._register(D.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(D){this.logger.setLevel(D)}getLevel(){return this.logger.getLevel()}trace(D,...P){this.logger.trace(D,...P)}debug(D,...P){this.logger.debug(D,...P)}info(D,...P){this.logger.info(D,...P)}warn(D,...P){this.logger.warn(D,...P)}error(D,...P){this.logger.error(D,...P)}flush(){this.logger.flush()}}e.LogService=n}),define(ee[226],te([0,1,35,7,5]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class _{constructor(P){this.loggerService=P,this.loggers=new E.ResourceMap}listen(P,h,d){switch(h){case"onDidChangeLoggers":return d?this.loggerService.getOnDidChangeLoggersEvent(d):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return d?this.loggerService.getOnDidChangeLogLevelEvent(d):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return d?this.loggerService.getOnDidChangeVisibilityEvent(d):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(P,h,d){switch(h){case"createLogger":this.createLogger(A.URI.revive(d[0]),d[1],d[2]);return;case"log":return this.log(A.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1]);case"setLogLevel":return(0,n.isLogLevel)(d[0])?this.loggerService.setLogLevel(d[0]):this.loggerService.setLogLevel(A.URI.revive(d[0]),d[1]);case"setVisibility":return this.loggerService.setVisibility(A.URI.revive(d[0]),d[1]);case"registerLogger":return this.loggerService.registerLogger({...d[0],resource:A.URI.revive(d[0].resource)},d[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(A.URI.revive(d[0]))}throw new Error(`Call not found: ${h}`)}createLogger(P,h,d){this.loggers.set(P,this.loggerService.createLogger(P,h,d))}consoleLog(P,h){let d=console.log;switch(P){case n.LogLevel.Error:d=console.error;break;case n.LogLevel.Warning:d=console.warn;break;case n.LogLevel.Info:d=console.info;break}d.call(console,...h)}log(P,h){const d=this.loggers.get(P);if(!d)throw new Error("Create the logger before logging");for(const[m,g]of h)(0,n.log)(d,m,g)}}e.LoggerChannel=_}),define(ee[227],te([0,1,16,5]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var n;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(n||(n={}));async function _(d,m,g,S,u){try{const y=await new Promise((c,f)=>{H(["@vscode/spdlog"],c,f)});y.setFlushOn(n.Trace);const b=await y.createAsyncRotatingLogger(d,m,g,S);return u?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(y){console.error(y)}return null}function D(d,m,g){switch(m){case A.LogLevel.Trace:d.trace(g);break;case A.LogLevel.Debug:d.debug(g);break;case A.LogLevel.Info:d.info(g);break;case A.LogLevel.Warning:d.warn(g);break;case A.LogLevel.Error:d.error(g);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function P(d,m){switch(m){case A.LogLevel.Trace:d.setLevel(n.Trace);break;case A.LogLevel.Debug:d.setLevel(n.Debug);break;case A.LogLevel.Info:d.setLevel(n.Info);break;case A.LogLevel.Warning:d.setLevel(n.Warning);break;case A.LogLevel.Error:d.setLevel(n.Error);break;case A.LogLevel.Off:d.setLevel(n.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class h extends A.AbstractMessageLogger{constructor(m,g,S,u,y){super(),this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(m,g,S,u),this._register(this.onDidChangeLogLevel(b=>{this._logger&&P(this._logger,b)}))}async _createSpdLogLogger(m,g,S,u){const y=S?6:1,b=30/y*E.ByteSize.MB,c=await _(m,g,b,y,u);if(c){this._logger=c,P(this._logger,this.getLevel());for(const{level:f,message:l}of this.buffer)D(this._logger,f,l);this.buffer=[]}}log(m,g){this._logger?D(this._logger,m,g):this.getLevel()<=m&&this.buffer.push({level:m,message:g})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=h}),define(ee[228],te([0,1,31,5,227]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class _ extends A.AbstractLoggerService{doCreateLogger(P,h,d){return new n.SpdLogLogger((0,E.generateUuid)(),P.fsPath,!d?.donotRotate,!!d?.donotUseFormatters,h)}}e.LoggerService=_}),define(ee[66],te([0,1,35,3,6,5,228]),function(H,e,E,A,n,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,n.refineServiceDecorator)(_.ILoggerService);class P extends D.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new E.ResourceMap}createLogger(d,m,g){g!==void 0&&this.loggerResourcesByWindow.set(this.toResource(d),g);try{return super.createLogger(d,m)}catch(S){throw this.loggerResourcesByWindow.delete(this.toResource(d)),S}}registerLogger(d,m){m!==void 0&&this.loggerResourcesByWindow.set(d.resource,m),super.registerLogger(d)}deregisterLogger(d){this.loggerResourcesByWindow.delete(d),super.deregisterLogger(d)}getRegisteredLoggers(d){const m=[];for(const g of super.getRegisteredLoggers())d===this.loggerResourcesByWindow.get(g.resource)&&m.push(g);return m}getOnDidChangeLogLevelEvent(d){return A.Event.filter(this.onDidChangeLogLevel,m=>(0,_.isLogLevel)(m)||this.isInterestedLoggerResource(m[0],d))}getOnDidChangeVisibilityEvent(d){return A.Event.filter(this.onDidChangeVisibility,([m])=>this.isInterestedLoggerResource(m,d))}getOnDidChangeLoggersEvent(d){return A.Event.filter(A.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(S=>this.isInterestedLoggerResource(S.resource,d)),removed:[...m.removed].filter(S=>this.isInterestedLoggerResource(S.resource,d))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(d){for(const[m,g]of this.loggerResourcesByWindow)g===d&&this.deregisterLogger(m)}isInterestedLoggerResource(d,m){const g=this.loggerResourcesByWindow.get(d);return g===void 0||g===m}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=P}),define(ee[229],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function A(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=A;function n(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=n;function _(D){return!E(D)&&!A(D)&&!n(D)}e.isMenubarMenuItemAction=_}),define(ee[39],te([0,1,3,68,2,6]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,_.createDecorator)("policy");class D extends n.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(d){const m=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...d,...this.policyDefinitions},m!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(d),A.Iterable.reduce(this.policies.entries(),(g,[S,u])=>({...g,[S]:u}),{})}getPolicyValue(d){return this.policies.get(d)}serialize(){return A.Iterable.reduce(Object.entries(this.policyDefinitions),(d,[m,g])=>({...d,[m]:{definition:g,value:this.policies.get(m)}}),{})}}e.AbstractPolicyService=D;class P{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ee[230],te([0,1,8,3,68,12,16,5,39]),function(H,e,E,A,n,_,D,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function d(g,S){const u=[];for(const y of new Set(n.Iterable.concat(g.keys(),S.keys())))g.get(y)!==S.get(y)&&u.push(y);return u}let m=class extends h.AbstractPolicyService{constructor(S,u,y){super(),this.file=S,this.fileService=u,this.logService=y,this.throttledDelayer=this._register(new E.ThrottledDelayer(500));const b=A.Event.filter(u.onDidFilesChange,c=>c.affects(S));this._register(u.watch(S)),this._register(b(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const S=new Map;try{const u=await this.fileService.readFile(this.file),y=JSON.parse(u.value.toString());if(!(0,_.isObject)(y))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(y))this.policyDefinitions[b]&&S.set(b,y[b])}catch(u){u.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",u)}return S}async refresh(){const S=await this.read(),u=d(this.policies,S);this.policies=S,u.length>0&&this._onDidChange.fire(u)}};e.FilePolicyService=m,e.FilePolicyService=m=Ee([Y(1,D.IFileService),Y(2,P.ILogService)],m)}),define(ee[231],te([0,1,3,2,39]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class _{constructor(h){this.service=h,this.disposables=new A.DisposableStore}listen(h,d){switch(d){case"onDidChange":return E.Event.map(this.service.onDidChange,m=>m.reduce((g,S)=>({...g,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${d}`)}call(h,d,m){switch(d){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${d}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=_;class D extends n.AbstractPolicyService{constructor(h,d){super(),this.channel=d;for(const m in h){const{definition:g,value:S}=h[m];this.policyDefinitions[m]=g,S!==void 0&&this.policies.set(m,S)}this.channel.listen("onDidChange")(m=>{for(const g in m){const S=m[g];S===null?this.policies.delete(g):this.policies.set(g,S)}this._onDidChange.fire(Object.keys(m))})}async _updatePolicyDefinitions(h){const d=await this.channel.call("updatePolicyDefinitions",h);for(const m in d)this.policies.set(m,d[m])}}e.PolicyChannelClient=D}),define(ee[232],te([0,1,39,8,311,2,5]),function(H,e,E,A,n,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends E.AbstractPolicyService{constructor(d,m){super(),this.logService=d,this.productName=m,this.throttler=new A.Throttler,this.watcher=this._register(new _.MutableDisposable)}async _updatePolicyDefinitions(d){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(d).length} policy definitions`),await this.throttler.queue(()=>new Promise((m,g)=>{try{this.watcher.value=(0,n.createWatcher)(this.productName,d,S=>{this._onDidPolicyChange(S),m()})}catch(S){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",S),g(S)}}))}_onDidPolicyChange(d){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(d)}`);for(const m in d){const g=d[m];g===void 0?this.policies.delete(m):this.policies.set(m,g)}this._onDidChange.fire(Object.keys(d))}};e.NativePolicyService=P,e.NativePolicyService=P=Ee([Y(0,D.ILogService)],P)}),define(ee[78],te([0,1,4,36]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const _=E.globals.vscode.context.configuration();if(_)n=_.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){n=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:_,searchUrl:D,itemUrl:P,controlUrl:h}=n.extensionsGallery||{};Object.assign(n,{extensionsGallery:{serviceUrl:A.env.VSCODE_GALLERY_SERVICE_URL||_,searchUrl:A.env.VSCODE_GALLERY_SEARCH_URL||D,itemUrl:A.env.VSCODE_GALLERY_ITEM_URL||P,controlUrl:A.env.VSCODE_GALLERY_CONTROL_URL||h}});try{const d=(...g)=>g.reduce((S,u)=>(Object.keys(u).forEach(y=>{Array.isArray(S[y])&&Array.isArray(u[y])?S[y]=u[y]:typeof S[y]=="object"&&typeof u[y]=="object"?S[y]=d(S[y],u[y]):S[y]=u[y]}),S),{}),m=globalThis._VSCODE_USER_PRODUCT_JSON||{};n=d(n,m)}catch{}if(A.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`,serverDataFolderName:n.serverDataFolderName?`${n.serverDataFolderName}-dev`:void 0}),!n.version){const d=globalThis._VSCODE_PACKAGE_JSON;Object.assign(n,{version:d.version,release:d.release})}}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=n}),define(ee[22],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[233],te([0,1,72,5,22]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let _=class{constructor(P,h){this.productService=P,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(P,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const d=/^(.*)#([^#]+)$/.exec(h);if(!d)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,m,g]=d;let S=this.trustedExtensionUrlPublicKeys.get(P);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[P],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.trustedExtensionUrlPublicKeys.set(P,[...S])}const u=Buffer.from(decodeURIComponent(g),"base64");if(u.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const y=u.slice(0,6),b=u.readUIntBE(0,6),c=Date.now()-b;if(c<0||c>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const f=u.slice(6),l=E.createVerify("SHA256");l.write(y),l.write(Buffer.from(m)),l.end();for(let v=0;v<S.length;v++){let I=S[v];if(I!==null){if(typeof I=="string")try{I=E.createPublicKey({key:Buffer.from(I,"base64"),format:"der",type:"spki"}),S[v]=I}catch(p){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${v+1} for ${P}:`,p),S[v]=null;continue}if(l.verify(I,f))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};e.ExtensionUrlTrustService=_,e.ExtensionUrlTrustService=_=Ee([Y(0,n.IProductService),Y(1,A.ILogService)],_)}),define(ee[234],te([0,1,8,5]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let n=class{constructor(D,P,h){this._window=D,this._sessionId=P,this._logService=h}async inspect(D){await this._connect();const P=this._window.webContents.debugger;await P.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,E.timeout)(D);const h=await P.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),h.profile}async _connect(){const D=this._window.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async _disconnect(){const D=this._window.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.WindowProfiler=n,e.WindowProfiler=n=Ee([Y(2,A.ILogService)],n)}),define(ee[79],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(ee[43],te([0,1,135,12]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class n{constructor(){this.data=new Map}add(D,P){E.ok(A.isString(D)),E.ok(A.isObject(P)),E.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,P)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new n}),define(ee[235],te([0,1,3,43]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function n(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class _{constructor(){this._onDidChangeSchema=new E.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,d){this.schemasById[n(h)]=d,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new _;A.Registry.add(e.Extensions.JSONContribution,D)}),define(ee[59],te([0,1,24,3,12,161,18,235,43]),function(H,e,E,A,n,_,D,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const g=h.Registry.as(P.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const s=new Set;this.doRegisterConfigurations(t,a,s),g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(t){const a=new Set;this.doDeregisterConfigurations(t,a),g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:t,remove:a}){const s=new Set;this.doDeregisterConfigurations(a,s),this.doRegisterConfigurations(t,!1,s),g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(t){const a=new Set;this.doRegisterDefaultConfigurations(t,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,a){const s=[];for(const{overrides:i,source:r}of t)for(const o in i)if(a.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const w=this.configurationDefaultsOverrides.get(o),k=w?.valuesSources??new Map;if(r)for(const T of Object.keys(i[o]))k.set(T,r);const M={...w?.value||{},...i[o]};this.configurationDefaultsOverrides.set(o,{source:r,value:M,valuesSources:k});const C=(0,D.getLanguageTagSettingPlainKey)(o),L={type:"object",default:M,description:_.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:n.isString(r)?void 0:r,defaultValueSource:r};s.push(...b(o)),this.configurationProperties[o]=L,this.defaultLanguageConfigurationOverridesNode.properties[o]=L}else{this.configurationDefaultsOverrides.set(o,{value:i[o],source:r});const w=this.configurationProperties[o];w&&(this.updatePropertyDefaultValue(o,w),this.updateSchema(o,w))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(t){const a=new Set;this.doDeregisterDefaultConfigurations(t,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,a){for(const{overrides:s,source:i}of t)for(const r in s){const o=this.configurationDefaultsOverrides.get(r),w=n.isString(i)?i:i?.id,k=n.isString(o?.source)?o?.source:o?.source?.id;if(w===k)if(a.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const M=this.configurationProperties[r];M&&(this.updatePropertyDefaultValue(r,M),this.updateSchema(r,M))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let a=!1;const s=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,s),a=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,s),a=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,s),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const a of t)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,a,s){t.forEach(i=>{this.validateAndRegisterProperties(i,a,i.extensionInfo,i.restrictedProperties,void 0,s),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,a){const s=i=>{if(i.properties)for(const r in i.properties){a.add(r);const o=this.configurationProperties[r];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>s(r))};for(const i of t){s(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(t,a=!0,s,i,r=3,o){r=n.isUndefinedOrNull(t.scope)?r:t.scope;const w=t.properties;if(w)for(const M in w){const C=w[M];if(a&&v(M,C)){delete w[M];continue}if(C.source=s,C.defaultDefaultValue=w[M].default,this.updatePropertyDefaultValue(M,C),e.OVERRIDE_PROPERTY_REGEX.test(M)?C.scope=void 0:(C.scope=n.isUndefinedOrNull(C.scope)?r:C.scope,C.restricted=n.isUndefinedOrNull(C.restricted)?!!i?.includes(M):C.restricted),w[M].hasOwnProperty("included")&&!w[M].included){this.excludedConfigurationProperties[M]=w[M],delete w[M];continue}else this.configurationProperties[M]=w[M],w[M].policy?.name&&this.policyConfigurations.set(w[M].policy.name,M);!w[M].deprecationMessage&&w[M].markdownDeprecationMessage&&(w[M].deprecationMessage=w[M].markdownDeprecationMessage),o.add(M)}const k=t.allOf;if(k)for(const M of k)this.validateAndRegisterProperties(M,a,s,i,r,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const a=s=>{const i=s.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);s.allOf?.forEach(a)};a(t)}updateSchema(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.resourceLanguageSettingsSchema.properties[t]=a;break}}removeFromSchema(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const a=`[${t}]`,s={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,s),e.allSettings.properties[a]=s,e.applicationSettings.properties[a]=s,e.machineSettings.properties[a]=s,e.machineOverridableSettings.properties[a]=s,e.windowSettings.properties[a]=s,e.resourceSettings.properties[a]=s}}registerOverridePropertyPatternKey(){const t={type:"object",description:_.localize(4,null),errorMessage:_.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,a){const s=this.configurationDefaultsOverrides.get(t);let i=s?.value,r=s?.source;n.isUndefined(i)&&(i=a.defaultDefaultValue,r=void 0),n.isUndefined(i)&&(i=f(a.type)),a.default=i,a.defaultValueSource=r}}const u="\\[([^\\]]+)\\]",y=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(p){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let a=y.exec(p);for(;a?.length;){const s=a[1].trim();s&&t.push(s),a=y.exec(p)}}return(0,E.distinct)(t)}e.overrideIdentifiersFromKey=b;function c(p){return p.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=c;function f(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const l=new S;h.Registry.add(e.Extensions.Configuration,l);function v(p,t){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?_.localize(7,null,p):l.getConfigurationProperties()[p]!==void 0?_.localize(8,null,p):t.policy?.name&&l.getPolicyConfigurations().get(t.policy?.name)!==void 0?_.localize(9,null,p,t.policy?.name,l.getPolicyConfigurations().get(t.policy?.name)):null:_.localize(6,null)}e.validateProperty=v;function I(){const p=[],t=l.getConfigurationProperties();for(const a of Object.keys(t))p.push([a,t[a].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=I}),define(ee[120],te([0,1,24,3,44,2,35,37,12,7,18,59,43]),function(H,e,E,A,n,_,D,P,h,d,m,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function u(a){return Object.isFrozen(a)?a:P.deepFreeze(a)}class y{constructor(s={},i=[],r=[],o){this._contents=s,this._keys=i,this._overrides=r,this.raw=o,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof y)return i;const r=new b("");return r.parseRaw(i),r.configurationModel});this._rawConfiguration=s.reduce((i,r)=>r===i?r:i.merge(r),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,m.getConfigurationValue)(this.contents,s):this.contents}inspect(s,i){const r=this.rawConfiguration.getValue(s),o=i?this.rawConfiguration.getOverrideValue(s,i):void 0,w=i?this.rawConfiguration.override(i).getValue(s):r;return{value:r,override:o,merged:w}}getOverrideValue(s,i){const r=this.getContentsForOverrideIdentifer(i);return r?s?(0,m.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const r of this.overrides)r.identifiers.includes(s)&&i.push(...r.keys);return E.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return E.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=P.deepClone(this.contents),r=P.deepClone(this.overrides),o=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const k of s)if(w.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.mergeContents(i,k.contents);for(const M of k.overrides){const[C]=r.filter(L=>E.equals(L.identifiers,M.identifiers));C?(this.mergeContents(C.contents,M.contents),C.keys.push(...M.keys),C.keys=E.distinct(C.keys)):r.push(P.deepClone(M))}for(const M of k.keys)o.indexOf(M)===-1&&o.push(M)}return new y(i,o,r,w.every(k=>k instanceof y)?void 0:w)}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const o of E.distinct([...Object.keys(this.contents),...Object.keys(i)])){let w=this.contents[o];const k=i[o];k&&(typeof w=="object"&&typeof k=="object"?(w=P.deepClone(w),this.mergeContents(w,k)):w=k),r[o]=w}return new y(r,this.keys,this.overrides)}mergeContents(s,i){for(const r of Object.keys(i)){if(r in s&&h.isObject(s[r])&&h.isObject(i[r])){this.mergeContents(s[r],i[r]);continue}s[r]=P.deepClone(i[r])}}getContentsForOverrideIdentifer(s){let i=null,r=null;const o=w=>{w&&(r?this.mergeContents(r,w):r=P.deepClone(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===s?i=w.contents:w.identifiers.includes(s)&&o(w.contents);return o(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.updateValue(s,i,!0)}setValue(s,i){this.updateValue(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,m.removeFromValueTree)(this.contents,s),g.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(r=>E.equals(r.identifiers,(0,g.overrideIdentifiersFromKey)(s))),1))}updateValue(s,i,r){(0,m.addToValueTree)(this.contents,s,i,o=>console.error(o)),r=r||this.keys.indexOf(s)===-1,r&&this.keys.push(s),g.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,g.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,m.toValuesTree)(this.contents[s],o=>console.error(o))})}}e.ConfigurationModel=y;class b{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!h.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:r,keys:o,overrides:w,restricted:k,hasExcludedProperties:M}=this.doParseRaw(s,i);this._configurationModel=new y(r,o,w,M?[s]:void 0),this._restrictedConfigurations=k||[]}doParseContent(s){let i={},r=null,o=[];const w=[],k=[];function M(L){Array.isArray(o)?o.push(L):r!==null&&(o[r]=L)}const C={onObjectBegin:()=>{const L={};M(L),w.push(o),o=L,r=null},onObjectProperty:L=>{r=L},onObjectEnd:()=>{o=w.pop()},onArrayBegin:()=>{const L=[];M(L),w.push(o),o=L,r=null},onArrayEnd:()=>{o=w.pop()},onLiteralValue:M,onError:(L,T,F)=>{k.push({error:L,offset:T,length:F})}};if(s)try{n.visit(s,C),i=o[0]||{}}catch(L){console.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return i}doParseRaw(s,i){const r=S.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),o=this.filter(s,r,!0,i);s=o.raw;const w=(0,m.toValuesTree)(s,C=>console.error(`Conflict in settings file ${this._name}: ${C}`)),k=Object.keys(s),M=this.toOverrides(s,C=>console.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:w,keys:k,overrides:M,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(s,i,r,o){let w=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:w};const k={},M=[];for(const C in s)if(g.OVERRIDE_PROPERTY_REGEX.test(C)&&r){const L=this.filter(s[C],i,!1,o);k[C]=L.raw,w=w||L.hasExcludedProperties,M.push(...L.restricted)}else{const L=i[C],T=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&M.push(C),!o.exclude?.includes(C)&&(o.include?.includes(C)||(T===void 0||o.scopes===void 0||o.scopes.includes(T))&&!(o.skipRestricted&&L?.restricted))?k[C]=s[C]:w=!0}return{raw:k,restricted:M,hasExcludedProperties:w}}toOverrides(s,i){const r=[];for(const o of Object.keys(s))if(g.OVERRIDE_PROPERTY_REGEX.test(o)){const w={};for(const k in s[o])w[k]=s[o][k];r.push({identifiers:(0,g.overrideIdentifiersFromKey)(o),keys:Object.keys(w),contents:(0,m.toValuesTree)(w,i)})}return r}}e.ConfigurationModelParser=b;class c extends _.Disposable{constructor(s,i,r,o){super(),this.userSettingsResource=s,this.parseOptions=i,this.fileService=o,this._onDidChange=this._register(new A.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new b(this.userSettingsResource.toString()),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(A.Event.any(A.Event.filter(this.fileService.onDidFilesChange,w=>w.contains(this.userSettingsResource)),A.Event.filter(this.fileService.onDidRunOperation,w=>(w.isOperation(0)||w.isOperation(3)||w.isOperation(1)||w.isOperation(4))&&r.isEqual(w.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=c;class f{constructor(s,i,r,o,w,k,M,C,L,T,F,B,se){this.key=s,this.overrides=i,this._value=r,this.overrideIdentifiers=o,this.defaultConfiguration=w,this.policyConfiguration=k,this.applicationConfiguration=M,this.userConfiguration=C,this.localUserConfiguration=L,this.remoteUserConfiguration=T,this.workspaceConfiguration=F,this.folderConfigurationModel=B,this.memoryConfigurationModel=se}get value(){return u(this._value)}inspect(s,i,r){const o=s.inspect(i,r);return{get value(){return u(o.value)},get override(){return u(o.override)},get merged(){return u(o.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class l{constructor(s,i,r,o,w=new y,k=new y,M=new D.ResourceMap,C=new y,L=new D.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=i,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=w,this._workspaceConfiguration=k,this._folderConfigurations=M,this._memoryConfiguration=C,this._memoryConfigurationByResource=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(s,i,r){return this.getConsolidatedConfigurationModel(s,i,r).getValue(s)}updateValue(s,i,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new y,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(s):o.setValue(s,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,r){const o=this.getConsolidatedConfigurationModel(s,i,r),w=this.getFolderConfigurationModelForResource(i.resource,r),k=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,M=new Set;for(const C of o.overrides)for(const L of C.identifiers)o.getOverrideValue(s,L)!==void 0&&M.add(L);return new f(s,i,o.getValue(s),M.size?[...M]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,w||void 0,k)}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const r=[];if(!i){const{added:o,updated:w,removed:k}=p(this._defaultConfiguration,s);i=[...o,...w,...k]}for(const o of i)for(const w of(0,g.overrideIdentifiersFromKey)(o)){const k=this._defaultConfiguration.getKeysForOverrideIdentifier(w),M=s.getKeysForOverrideIdentifier(w),C=[...M.filter(L=>k.indexOf(L)===-1),...k.filter(L=>M.indexOf(L)===-1),...k.filter(L=>!P.equals(this._defaultConfiguration.override(w).getValue(L),s.override(w).getValue(L)))];r.push([w,C])}return this.updateDefaultConfiguration(s),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:r,removed:o}=p(this._policyConfiguration,s),w=[...i,...r,...o];return w.length&&this.updatePolicyConfiguration(s),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:r,removed:o,overrides:w}=p(this.applicationConfiguration,s),k=[...i,...r,...o];return k.length&&this.updateApplicationConfiguration(s),{keys:k,overrides:w}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:r,removed:o,overrides:w}=p(this.localUserConfiguration,s),k=[...i,...r,...o];return k.length&&this.updateLocalUserConfiguration(s),{keys:k,overrides:w}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:r,removed:o,overrides:w}=p(this.remoteUserConfiguration,s),k=[...i,...r,...o];return k.length&&this.updateRemoteUserConfiguration(s),{keys:k,overrides:w}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:r,removed:o,overrides:w}=p(this.workspaceConfiguration,s),k=[...i,...r,...o];return k.length&&this.updateWorkspaceConfiguration(s),{keys:k,overrides:w}}compareAndUpdateFolderConfiguration(s,i){const r=this.folderConfigurations.get(s),{added:o,updated:w,removed:k,overrides:M}=p(r,i),C=[...o,...w,...k];return(C.length||!r)&&this.updateFolderConfiguration(s,i),{keys:C,overrides:M}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:o,removed:w,overrides:k}=p(i,void 0);return{keys:[...r,...o,...w],overrides:k}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,i,r){let o=this.getConsolidatedConfigurationModelForResource(i,r);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:s},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const o=i.getFolder(s);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const w=this._memoryConfigurationByResource.get(s);w&&(r=r.merge(w))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(s);o?(i=r.merge(o),this._foldersConsolidatedConfigurations.set(s,i)):i=r}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const r=i.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:r,overrides:o,keys:w}=this._folderConfigurations.get(i);return s.push([i,{contents:r,overrides:o,keys:w}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this._workspaceConfiguration.keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.policy),o=this.parseConfigurationModel(s.application),w=this.parseConfigurationModel(s.user),k=this.parseConfigurationModel(s.workspace),M=s.folders.reduce((C,L)=>(C.set(d.URI.revive(L[0]),this.parseConfigurationModel(L[1])),C),new D.ResourceMap);return new l(i,r,o,w,new y,k,M,new y,new D.ResourceMap)}static parseConfigurationModel(s){return new y(s.contents,s.keys,s.overrides)}}e.Configuration=l;function v(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const s=new Set,i=new Map;for(const o of a)o.keys.forEach(w=>s.add(w)),o.overrides.forEach(([w,k])=>{const M=(0,D.getOrSet)(i,w,new Set);k.forEach(C=>M.add(C))});const r=[];return i.forEach((o,w)=>r.push([w,[...o.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=v;class I{constructor(s,i,r,o){this.change=s,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=o,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const w of s.keys)this.affectedKeys.add(w);for(const[,w]of s.overrides)for(const k of w)this.affectedKeys.add(k);this._affectsConfigStr=this._marker;for(const w of this.affectedKeys)this._affectsConfigStr+=w+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=l.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){const r=this._marker+s,o=this._affectsConfigStr.indexOf(r);if(o<0)return!1;const w=o+r.length;if(w>=this._affectsConfigStr.length)return!1;const k=this._affectsConfigStr.charCodeAt(w);if(k!==this._markerCode1&&k!==this._markerCode2)return!1;if(i){const M=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,C=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!P.equals(M,C)}return!0}}e.ConfigurationChangeEvent=I;function p(a,s){const{added:i,removed:r,updated:o}=t(s?.rawConfiguration,a?.rawConfiguration),w=[],k=a?.getAllOverrideIdentifiers()||[],M=s?.getAllOverrideIdentifiers()||[];if(s){const C=M.filter(L=>!k.includes(L));for(const L of C)w.push([L,s.getKeysForOverrideIdentifier(L)])}if(a){const C=k.filter(L=>!M.includes(L));for(const L of C)w.push([L,a.getKeysForOverrideIdentifier(L)])}if(s&&a){for(const C of k)if(M.includes(C)){const L=t({contents:a.getOverrideValue(void 0,C)||{},keys:a.getKeysForOverrideIdentifier(C)},{contents:s.getOverrideValue(void 0,C)||{},keys:s.getKeysForOverrideIdentifier(C)});w.push([C,[...L.added,...L.removed,...L.updated]])}}return{added:i,removed:r,updated:o,overrides:w}}function t(a,s){const i=a?s?a.keys.filter(w=>s.keys.indexOf(w)===-1):[...a.keys]:[],r=s?a?s.keys.filter(w=>a.keys.indexOf(w)===-1):[...s.keys]:[],o=[];if(a&&s){for(const w of s.keys)if(a.keys.indexOf(w)!==-1){const k=(0,m.getConfigurationValue)(s.contents,w),M=(0,m.getConfigurationValue)(a.contents,w);P.equals(k,M)||o.push(w)}}return{added:i,removed:r,updated:o}}}),define(ee[236],te([0,1,24,3,2,37,12,120,59,5,39,43]),function(H,e,E,A,n,_,D,P,h,d,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class S extends n.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(g.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:f})=>this.onDidUpdateConfiguration(Array.from(c),f))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(c,f){this.updateConfigurationModel(c,g.Registry.as(h.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:c})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new P.ConfigurationModel;const c=g.Registry.as(h.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(c),c)}updateConfigurationModel(c,f){const l=this.getConfigurationDefaultOverrides();for(const v of c){const I=l[v],p=f[v];I!==void 0?this._configurationModel.addValue(v,I):p?this._configurationModel.addValue(v,p.default):this._configurationModel.removeValue(v)}}}e.DefaultConfiguration=S;class u{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=u;let y=class extends n.Disposable{get configurationModel(){return this._configurationModel}constructor(c,f,l){super(),this.defaultConfiguration=c,this.policyService=f,this.logService=l,this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(c=>this.onDidChangePolicies(c))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:c})=>this.update(await this.updatePolicyDefinitions(c),!0))),this._configurationModel}async updatePolicyDefinitions(c){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",c);const f={},l=[],v=g.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const I of c){const p=v[I];if(!p){l.push(I);continue}if(p.policy){if(p.type!=="string"&&p.type!=="number"){this.logService.warn(`Policy ${p.policy.name} has unsupported type ${p.type}`);continue}l.push(I),f[p.policy.name]={type:p.type}}}return(0,D.isEmptyObject)(f)||await this.policyService.updatePolicyDefinitions(f),l}onDidChangePolicies(c){this.logService.trace("PolicyConfiguration#onDidChangePolicies",c);const f=g.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),l=(0,E.coalesce)(c.map(v=>f.get(v)));this.update(l,!0)}update(c,f){this.logService.trace("PolicyConfiguration#update",c);const l=g.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),v=[],I=this._configurationModel.isEmpty();for(const p of c){const t=l[p]?.policy?.name;if(t){const a=this.policyService.getPolicyValue(t);(I?a!==void 0:!(0,_.equals)(this._configurationModel.getValue(p),a))&&v.push([p,a])}else this._configurationModel.getValue(p)!==void 0&&v.push([p,void 0])}if(v.length){this.logService.trace("PolicyConfiguration#changed",v);const p=this._configurationModel;this._configurationModel=new P.ConfigurationModel;for(const t of p.keys)this._configurationModel.setValue(t,p.getValue(t));for(const[t,a]of v)a===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,a);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=y,e.PolicyConfiguration=y=Ee([Y(1,m.IPolicyService),Y(2,d.ILogService)],y)}),define(ee[237],te([0,1,8,3,2,19,18,120,236,39]),function(H,e,E,A,n,_,D,P,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class m extends n.Disposable{constructor(S,u,y,b){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new h.DefaultConfiguration),this.policyConfiguration=y instanceof d.NullPolicyService?new h.NullPolicyConfiguration:this._register(new h.PolicyConfiguration(this.defaultConfiguration,y,b)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,{},_.extUriBiasedIgnorePathCase,u)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:c,properties:f})=>this.onDidDefaultConfigurationChange(c,f))),this._register(this.policyConfiguration.onDidChangeConfiguration(c=>this.onDidPolicyConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,u,y]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(S,u,new P.ConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(S,u){const y=typeof S=="string"?S:void 0,b=(0,D.isConfigurationOverrides)(S)?S:(0,D.isConfigurationOverrides)(u)?u:{};return this.configuration.getValue(y,b,void 0)}updateValue(S,u,y,b){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const u=this.configuration.toData(),y=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(y,u,2)}onDidDefaultConfigurationChange(S,u){const y=this.configuration.toData(),b=this.configuration.compareAndUpdateDefaultConfiguration(S,u);this.trigger(b,y,7)}onDidPolicyConfigurationChange(S){const u=this.configuration.toData(),y=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(y,u,7)}trigger(S,u,y){const b=new P.ConfigurationChangeEvent(S,{data:u},this.configuration);b.source=y,b.sourceConfig=this.getTargetConfiguration(y),this._onDidChangeConfiguration.fire(b)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=m}),define(ee[238],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class E{async routeCall(n,_,D){if(_!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${_}`);const P=D[0];if(P?.authority){const h=n.connections.find(d=>d.ctx===P.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(n,_){throw new Error(`Event not found: ${_}`)}}e.NodeRemoteResourceRouter=E}),define(ee[239],te([0,1,13,6]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var n;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(n||(e.RemoteConnectionType=n={}));class _{constructor(g){this.id=g,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=_;class D{constructor(g,S){this.host=g,this.port=S,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=D;var P;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class h extends E.ErrorNoTelemetry{static isNotAvailable(g){return g instanceof h&&g._code===P.NotAvailable}static isTemporarilyNotAvailable(g){return g instanceof h&&g._code===P.TemporarilyNotAvailable}static isNoResolverFound(g){return g instanceof h&&g._code===P.NoResolverFound}static isInvalidAuthority(g){return g instanceof h&&g._code===P.InvalidAuthority}static isHandled(g){return g instanceof h&&g.isHandled}constructor(g,S=P.Unknown,u){super(g),this._message=g,this._code=S,this._detail=u,this.isHandled=S===P.NotAvailable&&u===!0,Object.setPrototypeOf(this,h.prototype)}}e.RemoteAuthorityResolverError=h;function d(m){const g=m.indexOf("+");return g===-1?m:m.substring(0,g)}e.getRemoteAuthorityPrefix=d}),define(ee[60],te([0,1,15]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(d){return d.scheme===E.Schemas.vscodeRemote?d.authority:void 0}e.getRemoteAuthority=A;function n(d){if(!d)return;const m=d.indexOf("+");return m<0?d:d.substr(0,m)}e.getRemoteName=n;function _(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.getRemoteServerRootPath=_;function D(d){const{host:m,port:g}=h(d);if(typeof g>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:g}}e.parseAuthorityWithPort=D;function P(d,m){let{host:g,port:S}=h(d);return typeof S>"u"&&(S=m),{host:g,port:S}}e.parseAuthorityWithOptionalPort=P;function h(d){const m=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const g=d.match(/^(\[[0-9a-z:]+\])$/);if(g)return{host:g[1],port:void 0};const S=d.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:d,port:void 0}}}),define(ee[121],te([0,1,26,6,60]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(D||(e.ExtensionType=D={}));var P;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.LINUX_PPC64LE="linux-ppc64le",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class h{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,f){if(typeof c>"u"||c===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof c=="string"||typeof f=="string"){const l=typeof c=="string"?c:c.value,v=typeof f=="string"?f:f.value;return E.equalsIgnoreCase(l,v)}return c._lower===f._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.ExtensionIdentifier=h;class d{get size(){return this._set.size}constructor(c){if(this._set=new Set,c)for(const f of c)this.add(f)}add(c){this._set.add(h.toKey(c))}delete(c){return this._set.delete(h.toKey(c))}has(c){return this._set.has(h.toKey(c))}}e.ExtensionIdentifierSet=d;class m{constructor(){this._map=new Map}clear(){this._map.clear()}delete(c){this._map.delete(h.toKey(c))}get(c){return this._map.get(h.toKey(c))}has(c){return this._map.has(h.toKey(c))}set(c,f){this._map.set(h.toKey(c),f)}values(){return this._map.values()}forEach(c){this._map.forEach(c)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=m;function g(b){return S(b)}e.isApplicationScopedExtension=g;function S(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function u(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=u;function y(b,c){if(c){const f=`onResolveRemoteAuthority:${(0,n.getRemoteName)(c)}`;return!!b.activationEvents?.includes(f)}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[240],te([0,1,8,17,23,13,3,2,65,69,31,110,239,60]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var b;(function(V){V[V.Management=1]="Management",V[V.ExtensionHost=2]="ExtensionHost",V[V.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function c(V){switch(V){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function f(V){const R=new n.CancellationTokenSource;return setTimeout(()=>R.cancel(),V),R.token}function l(V,R){if(V.isCancellationRequested||R.isCancellationRequested)return n.CancellationToken.Cancelled;const O=new n.CancellationTokenSource;return V.onCancellationRequested(()=>O.cancel()),R.onCancellationRequested(()=>O.cancel()),O.token}class v{get didTimeout(){return this._state==="timedout"}constructor(R){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((O,N)=>{this._resolvePromise=O,this._rejectPromise=N}),R.isCancellationRequested?this._timeout():this._disposables.add(R.onCancellationRequested(()=>this._timeout()))}registerDisposable(R){this._state==="pending"?this._disposables.add(R):R.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const R=new Error("Time limit reached");return R.code="ETIMEDOUT",R.syscall="connect",R}resolve(R){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(R))}reject(R){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(R))}}function I(V,R){const O=new v(R);return O.registerDisposable(V.onControlMessage(N=>{const q=JSON.parse(N.toString()),re=W(q);re?O.reject(re):O.resolve(q)})),O.promise}function p(V,R,O,N,q,re,ne,le){const j=new v(le),Z=d.StopWatch.create(!1);return V.info(`Creating a socket (${ne})...`),h.mark(`code/willCreateSocket/${re}`),R.connect(O,N,q,ne).then(Q=>{j.didTimeout?(h.mark(`code/didCreateSocketError/${re}`),V.info(`Creating a socket (${ne}) finished after ${Z.elapsed()} ms, but this is too late and has timed out already.`),Q?.dispose()):(h.mark(`code/didCreateSocketOK/${re}`),V.info(`Creating a socket (${ne}) was successful after ${Z.elapsed()} ms.`),j.resolve(Q))},Q=>{h.mark(`code/didCreateSocketError/${re}`),V.info(`Creating a socket (${ne}) returned an error after ${Z.elapsed()} ms.`),V.error(Q),j.reject(Q)}),j.promise}function t(V,R){const O=new v(R);return V.then(N=>{O.didTimeout||O.resolve(N)},N=>{O.didTimeout||O.reject(N)}),O.promise}async function a(V,R,O,N){const q=oe(V,R);V.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let re;try{re=await p(V.logService,V.remoteSocketFactoryService,V.connectTo,(0,u.getRemoteServerRootPath)(V),`reconnectionToken=${V.reconnectionToken}&reconnection=${V.reconnectionProtocol?"true":"false"}`,c(R),`renderer-${c(R)}-${V.reconnectionToken}`,N)}catch(Q){throw V.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),V.logService.error(Q),Q}V.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let ne,le;V.reconnectionProtocol?(V.reconnectionProtocol.beginAcceptReconnection(re,null),ne=V.reconnectionProtocol,le=!1):(ne=new g.PersistentProtocol({socket:re}),le=!0),V.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const j=await t(V.signService.createNewMessage((0,m.generateUuid)()),N),Z={type:"auth",auth:V.connectionToken||"00000000000000000000",data:j.data};ne.sendControl(A.VSBuffer.fromString(JSON.stringify(Z)));try{const Q=await I(ne,l(N,f(1e4)));if(Q.type!=="sign"||typeof Q.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(V.logService.trace(`${q} 4/6. received SignRequest control message.`),!await t(V.signService.validate(j,Q.signedData),N)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const pe=await t(V.signService.sign(Q.data),N),Pe={type:"connectionType",commit:V.commit,signedData:pe,desiredConnectionType:R};return O&&(Pe.args=O),V.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),ne.sendControl(A.VSBuffer.fromString(JSON.stringify(Pe))),{protocol:ne,ownsProtocol:le}}catch(Q){throw Q&&Q.code==="ETIMEDOUT"&&(V.logService.error(`${q} the handshake timed out. Error:`),V.logService.error(Q)),Q&&Q.code==="VSCODE_CONNECTION_ERROR"&&(V.logService.error(`${q} received error control message when negotiating connection. Error:`),V.logService.error(Q)),le&&z(ne),Q}}async function s(V,R,O,N){const q=Date.now(),re=oe(V,R),{protocol:ne,ownsProtocol:le}=await a(V,R,O,N),j=new v(N);return j.registerDisposable(ne.onControlMessage(Z=>{const Q=JSON.parse(Z.toString()),fe=W(Q);fe?(V.logService.error(`${re} received error control message when negotiating connection. Error:`),V.logService.error(fe),le&&z(ne),j.reject(fe)):(V.reconnectionProtocol?.endAcceptReconnection(),V.logService.trace(`${re} 6/6. handshake finished, connection is up and running after ${ce(q)}!`),j.resolve({protocol:ne,firstMessage:Q}))})),j.promise}async function i(V,R){const{protocol:O}=await s(V,1,void 0,R);return{protocol:O}}async function r(V,R,O){const{protocol:N,firstMessage:q}=await s(V,2,R,O),re=q&&q.debugPort;return{protocol:N,debugPort:re}}async function o(V,R,O){const N=Date.now(),q=oe(V,3),{protocol:re}=await a(V,3,R,O);return V.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${ce(N)}!`),re}async function w(V,R,O){const{connectTo:N,connectionToken:q}=await V.addressProvider.getAddress();return{commit:V.commit,quality:V.quality,connectTo:N,connectionToken:q,reconnectionToken:R,reconnectionProtocol:O,remoteSocketFactoryService:V.remoteSocketFactoryService,signService:V.signService,logService:V.logService}}async function k(V,R,O){return C(V,async N=>{const{protocol:q}=await i(N,n.CancellationToken.None);return new x(V,R,O,N.reconnectionToken,q)})}e.connectRemoteAgentManagement=k;async function M(V,R){return C(V,async O=>{const{protocol:N,debugPort:q}=await r(O,R,n.CancellationToken.None);return new G(V,R,O.reconnectionToken,N,q)})}e.connectRemoteAgentExtensionHost=M;async function C(V,R){for(let N=1;;N++)try{const q=(0,m.generateUuid)(),re=await w(V,q,null);return await R(re)}catch(q){if(N<5)V.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),V.logService.error(q);else throw V.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),V.logService.error(q),ue.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(q)),q}}async function L(V,R,O){const N=await w(V,(0,m.generateUuid)(),null);return await o(N,{host:R,port:O},n.CancellationToken.None)}e.connectRemoteAgentTunnel=L;function T(V){return(0,E.createCancelablePromise)(R=>new Promise((O,N)=>{const q=setTimeout(O,V*1e3);R.onCancellationRequested(()=>{clearTimeout(q),O()})}))}var F;(function(V){V[V.ConnectionLost=0]="ConnectionLost",V[V.ReconnectionWait=1]="ReconnectionWait",V[V.ReconnectionRunning=2]="ReconnectionRunning",V[V.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",V[V.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class B{constructor(R,O){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=B;class se{constructor(R,O,N,q){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.durationSeconds=N,this.cancellableTimer=q,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=se;class ie{constructor(R,O,N){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.attempt=N,this.type=2}}e.ReconnectionRunningEvent=ie;class de{constructor(R,O,N){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.attempt=N,this.type=4}}e.ConnectionGainEvent=de;class ae{constructor(R,O,N,q){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.attempt=N,this.handled=q,this.type=3}}e.ReconnectionPermanentFailureEvent=ae;class ue extends P.Disposable{static triggerPermanentFailure(R,O,N){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=R,this._permanentFailureAttempt=O,this._permanentFailureHandled=N,this._instances.forEach(q=>q._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(R=>R._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(R=>R._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||ue._permanentFailure}constructor(R,O,N,q,re){super(),this._connectionType=R,this._options=O,this.reconnectionToken=N,this.protocol=q,this._reconnectionFailureIsFatal=re,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new de(this.reconnectionToken,0,0)),this._register(q.onSocketClose(ne=>{const le=X(this._connectionType,this.reconnectionToken,!0);ne?ne.type===0?(this._options.logService.info(`${le} received socket close event (hadError: ${ne.hadError}).`),ne.error&&this._options.logService.error(ne.error)):(this._options.logService.info(`${le} received socket close event (wasClean: ${ne.wasClean}, code: ${ne.code}, reason: ${ne.reason}).`),ne.event&&this._options.logService.error(ne.event)):this._options.logService.info(`${le} received socket close event.`),this._beginReconnecting()})),this._register(q.onSocketTimeout(ne=>{const le=X(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${ne.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ne.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ne.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),ue._instances.push(this),this._register((0,P.toDisposable)(()=>{const ne=ue._instances.indexOf(this);ne>=0&&ue._instances.splice(ne,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ue._permanentFailureMillisSinceLastIncomingData,ue._permanentFailureAttempt,ue._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const R=X(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${R} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const q=N<O.length?O[N]:O[O.length-1];try{if(q>0){const ne=T(q);this._onDidStateChange.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,ne)),this._options.logService.info(`${R} waiting for ${q} seconds before reconnecting...`);try{await ne}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${R} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this._options.logService.info(`${R} resolving connection...`);const re=await w(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${R} connecting to ${re.connectTo}...`),await this._reconnect(re,f(y)),this._options.logService.info(`${R} reconnected!`),this._onDidStateChange.fire(new de(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(re){if(re.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${R} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(re),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this._options.logService.error(`${R} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(re),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(re)){this._options.logService.info(`${R} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(re);continue}if((re.code==="ETIMEDOUT"||re.code==="ENETUNREACH"||re.code==="ECONNREFUSED"||re.code==="ECONNRESET")&&re.syscall==="connect"){this._options.logService.info(`${R} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(re);continue}if((0,_.isCancellationError)(re)){this._options.logService.info(`${R} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(re);continue}if(re instanceof S.RemoteAuthorityResolverError){this._options.logService.error(`${R} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(re),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,S.RemoteAuthorityResolverError.isHandled(re));break}this._options.logService.error(`${R} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(re),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(R,O,N){this._reconnectionFailureIsFatal?ue.triggerPermanentFailure(R,O,N):this._gotoPermanentFailure(R,O,N)}_gotoPermanentFailure(R,O,N){this._onDidStateChange.fire(new ae(this.reconnectionToken,R,O,N)),z(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ue;class x extends ue{constructor(R,O,N,q,re){super(1,R,q,re,!0),this.client=this._register(new g.Client(re,{remoteAuthority:O,clientId:N},R.ipcLogger))}async _reconnect(R,O){await i(R,O)}}e.ManagementPersistentConnection=x;class G extends ue{constructor(R,O,N,q,re){super(2,R,N,q,!1),this._startArguments=O,this.debugPort=re}async _reconnect(R,O){await r(R,this._startArguments,O)}}e.ExtensionHostPersistentConnection=G;function z(V){try{V.acceptDisconnect();const R=V.getSocket();V.dispose(),R.dispose()}catch(R){(0,_.onUnexpectedError)(R)}}function W(V){if(V&&V.type==="error"){const R=new Error(`Connection error: ${V.reason}`);return R.code="VSCODE_CONNECTION_ERROR",R}return null}function U(V,R){for(;V.length<R;)V+=" ";return V}function $(V,R){return`[remote-connection][${U(c(V),13)}][${R.substr(0,5)}\u2026]`}function X(V,R,O){return`${$(V,R)}[${O?"reconnect":"initial"}]`}function oe(V,R){return`${X(R,V.reconnectionToken,!!V.reconnectionProtocol)}[${V.connectTo}]`}function ce(V){return`${Date.now()-V} ms`}}),define(ee[241],te([0,1,2,6]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,A.createDecorator)("remoteSocketFactoryService");class n{constructor(){this.factories={}}register(D,P){return this.factories[D]??=[],this.factories[D].push(P),(0,E.toDisposable)(()=>{const h=this.factories[D]?.indexOf(P);typeof h=="number"&&h>=0&&this.factories[D]?.splice(h,1)})}getSocketFactory(D){return(this.factories[D.type]||[]).find(h=>h.supports(D))}connect(D,P,h,d){const m=this.getSocketFactory(D);if(!m)throw new Error(`No socket factory found for ${D}`);return m.connect(D,P,h,d)}}e.RemoteSocketFactoryService=n}),define(ee[242],te([0,1,27,47,21,114]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function P(u=!1){return(D===void 0||u)&&(D=h()),D}e.hasWSLFeatureInstalled=P;async function h(){const u=d();if(u===void 0)return!1;if(u>=22e3){const y=g();if(y)return new Promise(b=>{A.execFile(y,["--status"],c=>b(!c))})}else{const y=S();if(y)try{if((await n.Promises.stat(y)).isFile())return!0}catch{}}return!1}function d(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(u)return parseInt(u[3])}function m(u){const y=process.env.SystemRoot;if(y){const b=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return _.join(y,b?"Sysnative":"System32",u)}}function g(){return m("wsl.exe")}function S(){return m("lxss\\LxssManager.dll")}}),define(ee[51],te([0,1,17,13,2,181,59,6,5,43]),function(H,e,E,A,n,_,D,P,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,P.createDecorator)("requestService");class m{constructor(p){this.original=p}toJSON(){if(!this.headers){const p=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?p[t]="*****":p[t]=this.original[t];this.headers=p}return this.headers}}class g extends n.Disposable{constructor(p){super(),this.counter=0,this.logger=p.createLogger("network",{name:(0,_.localize)(0,null),when:h.CONTEXT_LOG_LEVEL.isEqualTo((0,h.LogLevelToString)(h.LogLevel.Trace)).serialize()})}async logAndRequest(p,t,a){const s=`${p} #${++this.counter}: ${t.url}`;this.logger.trace(`${s} - begin`,t.type,new m(t.headers??{}));try{const i=await a();return this.logger.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${s} - error`,t.type,(0,A.getErrorMessage)(i)),i}}}e.AbstractRequestService=g;function S(I){return I.res.statusCode&&I.res.statusCode>=200&&I.res.statusCode<300||I.res.statusCode===1223}e.isSuccess=S;function u(I){return I.res.statusCode===204}async function y(I){return u(I)?null:(await(0,E.streamToBuffer)(I.stream)).toString()}e.asText=y;async function b(I){if(!S(I))throw new Error("Server returned "+I.res.statusCode);return y(I)}e.asTextOrError=b;async function c(I){if(!S(I))throw new Error("Server returned "+I.res.statusCode);if(u(I))return null;const t=(await(0,E.streamToBuffer)(I.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.asJson=c;function f(I){v(I)}e.updateProxyConfigurationsScope=f;let l;function v(I){const p=d.Registry.as(D.Extensions.Configuration),t=l;l={id:"http",order:15,title:(0,_.localize)(1,null),type:"object",scope:I,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,_.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,_.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,_.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,_.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,_.localize)(6,null),(0,_.localize)(7,null),(0,_.localize)(8,null),(0,_.localize)(9,null)],default:"override",description:(0,_.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,_.localize)(11,null),restricted:!0}}},p.updateConfigurations({add:[l],remove:t?[t]:[]})}v(1)}),define(ee[243],te([0,1,17,23]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class n{constructor(P){this.service=P}listen(P,h){throw new Error("Invalid listen")}call(P,h,d,m=A.CancellationToken.None){switch(h){case"request":return this.service.request(d[0],m).then(async({res:g,stream:S})=>{const u=await(0,E.streamToBuffer)(S);return[{statusCode:g.statusCode,headers:g.headers},u]});case"resolveProxy":return this.service.resolveProxy(d[0])}throw new Error("Invalid call")}}e.RequestChannel=n;class _{constructor(P){this.channel=P}async request(P,h){const[d,m]=await this.channel.call("request",[P],h);return{res:d,stream:(0,E.bufferToStream)(m)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=_}),define(ee[244],te([0,1,245,12]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function n(D,P){return D.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:D.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function _(D,P,h={}){const d=(0,E.parse)(D),m=h.proxyUrl||n(d,P);if(!m)return null;const g=(0,E.parse)(m);if(!/^https?:$/.test(g.protocol||""))return null;const S={host:g.hostname||"",port:g.port||(g.protocol==="https"?"443":"80"),auth:g.auth,rejectUnauthorized:(0,A.isBoolean)(h.strictSSL)?h.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((u,y)=>{H(["http-proxy-agent"],u,y)}))(S):new(await new Promise((u,y)=>{H(["https-proxy-agent"],u,y)}))(S)}e.getProxyAgent=_}),define(ee[246],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ee[95],te([0,1,47,9,182,23,50,13,4,31,109,63,8,138]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let y;async function b(f,l,v,I){return v["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,g.isLaunchedFromCli)(I)&&!v["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,g.isLaunchedFromCli)(I)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=S.Promises.withAsyncBody(async(p,t)=>{const a=new _.CancellationTokenSource;let s=1e4;const i=f.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(s=(0,u.clamp)(i,1,120)*1e3);const r=setTimeout(()=>{a.dispose(!0),t(new Error((0,n.localize)(0,null)))},s);try{p(await c(l,a.token))}catch(o){!(0,P.isCancellationError)(o)&&!a.token.isCancellationRequested?t(new Error((0,n.localize)(1,null,(0,D.toErrorMessage)(o)))):p({})}finally{clearTimeout(r),a.dispose()}})),y)}e.getResolvedShellEnv=b;async function c(f,l){const v=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",v);const I=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",I);const p=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(p+"({.*})"+p),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",a);const s=await(0,m.getSystemShell)(h.OS,a);return f.trace("getUnixShellEnvironment#shell",s),new Promise((i,r)=>{if(l.isCancellationRequested)return r(new P.CancellationError);const o=(0,A.basename)(s);let w,k;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(w=`& '${process.execPath}' ${M} -p '''${p}'' + JSON.stringify(process.env) + ''${p}'''`,k=["-Login","-Command"]):o==="nu"?(w=`^'${process.execPath}' ${M} -p '"${p}" + JSON.stringify(process.env) + "${p}"'`,k=["-i","-l","-c"]):(w=`'${process.execPath}' ${M} -p '"${p}" + JSON.stringify(process.env) + "${p}"'`,o==="tcsh"||o==="csh"?k=["-ic"]:k=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),w);const C=(0,E.spawn)(s,[...k,w],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});l.onCancellationRequested(()=>(C.kill(),r(new P.CancellationError))),C.on("error",F=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(F)),r(F)});const L=[];C.stdout.on("data",F=>L.push(F));const T=[];C.stderr.on("data",F=>T.push(F)),C.on("close",(F,B)=>{const se=Buffer.concat(L).toString("utf8");f.trace("getUnixShellEnvironment#raw",se);const ie=Buffer.concat(T).toString("utf8");if(ie.trim()&&f.trace("getUnixShellEnvironment#stderr",ie),F||B)return r(new Error((0,n.localize)(2,null,F,B)));const de=t.exec(se),ae=de?de[1]:"{}";try{const ue=JSON.parse(ae);v?ue.ELECTRON_RUN_AS_NODE=v:delete ue.ELECTRON_RUN_AS_NODE,I?ue.ELECTRON_NO_ATTACH_CONSOLE=I:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){f.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(ue)),r(ue)}})})}}),define(ee[247],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class E{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(n){try{const _=await this.getValidator();if(_){const D=String(E._nextId++);return this.validators.set(D,_),{id:D,data:_.createNewMessage(n)}}}catch{}return{id:"",data:n}}async validate(n,_){if(!n.id)return!0;const D=this.validators.get(n.id);if(!D)return!1;this.validators.delete(n.id);try{return D.validate(_)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(n){try{return await this.signValue(n)}catch{}return n}}e.AbstractSignService=E}),define(ee[96],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[248],te([0,1,247]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class A extends E.AbstractSignService{getValidator(){return this.vsda().then(_=>new _.validator)}signValue(_){return this.vsda().then(D=>new D.signer().sign(_))}vsda(){return new Promise((_,D)=>H(["vsda"],_,D))}}e.SignService=A}),define(ee[34],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,E.createDecorator)("stateReadService"),e.IStateService=(0,E.createDecorator)("stateService")}),define(ee[122],te([0,1,8,17,12,33,16,5]),function(H,e,E,A,n,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var h;(function(S){S[S.IMMEDIATE=0]="IMMEDIATE",S[S.DELAYED=1]="DELAYED"})(h||(e.SaveStrategy=h={}));class d{constructor(u,y,b,c){this.storagePath=u,this.logService=b,this.fileService=c,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=y===0?void 0:new E.ThrottledDelayer(100)}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(u){u.fileOperationResult!==1&&this.logService.error(u)}}getItem(u,y){const b=this.storage[u];return(0,n.isUndefinedOrNull)(b)?y:b}setItem(u,y){this.setItems([{key:u,data:y}])}setItems(u){let y=!1;for(const{key:b,data:c}of u)this.storage[b]!==c&&((0,n.isUndefinedOrNull)(c)?(0,n.isUndefined)(this.storage[b])||(this.storage[b]=void 0,y=!0):(this.storage[b]=c,y=!0));y&&this.save()}removeItem(u){(0,n.isUndefined)(this.storage[u])||(this.storage[u]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const u=JSON.stringify(this.storage,null,4);if(u!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,A.VSBuffer.fromString(u),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=u}catch(y){this.logService.error(y)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=d;let m=class{constructor(u,y,b,c){this.fileStorage=new d(y.stateResource,u,b,c)}async init(){await this.fileStorage.init()}getItem(u,y){return this.fileStorage.getItem(u,y)}};e.StateReadonlyService=m,e.StateReadonlyService=m=Ee([Y(1,_.IEnvironmentService),Y(2,P.ILogService),Y(3,D.IFileService)],m);class g extends m{setItem(u,y){this.fileStorage.setItem(u,y)}setItems(u){this.fileStorage.setItems(u)}removeItem(u){this.fileStorage.removeItem(u)}close(){return this.fileStorage.close()}}e.StateService=g}),define(ee[123],te([0,1,4,36,31]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function _(h){if(E.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function D(h,d,m,g,S,u,y,b){const c=Object.create(null);c["common.machineId"]=u,c.sessionID=(0,n.generateUuid)()+Date.now(),c.commitHash=g,c.version=S,c["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,E.PlatformToString)(E.platform),c["common.nodePlatform"]=A.platform,c["common.nodeArch"]=m,c["common.product"]=b||"desktop",y&&(c["common.msftInternal"]=y);let f=0;const l=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),E.isLinuxSnap&&(c["common.snap"]="true");const v=_(d);return v&&(c["common.platformDetail"]=v),c}e.resolveCommonProperties=D;function P(h){const d=A.env.USERDNSDOMAIN;if(!d)return!1;const m=d.toLowerCase();return h.some(g=>m===g)}e.verifyMicrosoftInternalDomain=P}),define(ee[25],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(_){_[_.NONE=0]="NONE",_[_.CRASH=1]="CRASH",_[_.ERROR=2]="ERROR",_[_.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var n;(function(_){_.OFF="off",_.CRASH="crash",_.ERROR="error",_.ON="all"})(n||(e.TelemetryConfiguration=n={}))}),define(ee[249],te([0,1,27,8,44,15,9,4,7,87,21,108,91,16,22,25]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const c=new Map;async function f(t,a){const s=`${t}::${a.join(":")}`,i=c.get(s);if(i)return i;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,w=new Map,k=2e4;function M(L,T,F,B){const se=T.substring(L.length+1);return A.Promises.withAsyncBody(async ie=>{let de;try{de=await m.Promises.readdir(T,{withFileTypes:!0})}catch{ie();return}if(B.count>=k){B.count+=de.length,B.maxReached=!0,ie();return}let ae=de.length;if(ae===0){ie();return}let ue=de;B.count+de.length>k&&(B.maxReached=!0,ae=k-B.count,ue=de.slice(0,ae)),B.count+=de.length;for(const x of ue)if(x.isDirectory()){if(F.includes(x.name)||await M(L,(0,D.join)(T,x.name),F,B),--ae===0){ie();return}}else{const G=x.name.lastIndexOf(".");if(G>=0){const z=x.name.substring(G+1);z&&o.set(z,(o.get(z)??0)+1)}for(const z of r)z.relativePathPattern?.test(se)!==!1&&z.filePattern.test(x.name)&&w.set(z.tag,(w.get(z.tag)??0)+1);if(--ae===0){ie();return}}})}const C=A.Promises.withAsyncBody(async L=>{const T={count:0,maxReached:!1};await M(t,t,a,T);const F=await I(t);L({configFiles:l(w),fileTypes:l(o),fileCount:T.count,maxFilesReached:T.maxReached,launchConfigFiles:F})});return c.set(s,C),C}e.collectWorkspaceStats=f;function l(t){return Array.from(t.entries(),([a,s])=>({name:a,count:s})).sort((a,s)=>s.count-a.count)}function v(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.virtualMachineHint.value()*100)}%`},a=E.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.getMachineInfo=v;async function I(t){try{const a=new Map,s=(0,D.join)(t,".vscode","launch.json"),i=await m.Promises.readFile(s),r=[],o=(0,n.parse)(i.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,n.getNodeType)(o)==="object"&&o.configurations)for(const w of o.configurations){const k=w.type;k&&(a.has(k)?a.set(k,a.get(k)+1):a.set(k,1))}return l(a)}catch{return[]}}e.collectLaunchConfigs=I;let p=class{constructor(a,s){this.telemetryService=a,this.productService=s}formatMachineInfo(a){const s=[];return s.push(`OS Version:       ${a.os}`),s.push(`CPUs:             ${a.cpus}`),s.push(`Memory (System):  ${a.memory}`),s.push(`VM:               ${a.vmHint}`),s.join(`
`)}formatEnvironment(a){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const i=E.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||s.push(`Load (avg):       ${E.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(d.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${a.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(a,s){return Promise.all([(0,g.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async i=>{let[r,o]=i,w=this.formatProcessList(a,r);return s.forEach(k=>{if((0,S.isRemoteDiagnosticError)(k))w+=`
${k.errorMessage}`,o+=`
${k.errorMessage}`;else if(w+=`

Remote: ${k.hostName}`,k.processes&&(w+=`
${this.formatProcessList(a,k.processes)}`),k.workspaceMetadata){o+=`
|  Remote: ${k.hostName}`;for(const M of Object.keys(k.workspaceMetadata)){const C=k.workspaceMetadata[M];let L=`${C.fileCount} files`;C.maxFilesReached&&(L=`more than ${L}`),o+=`|    Folder (${M}): ${L}`,o+=this.formatWorkspaceStats(C)}}}),{processInfo:w,workspaceInfo:o}})}async getSystemInfo(a,s){const{memory:i,vmHint:r,os:o,cpus:w}=v(),k={os:o,memory:i,cpus:w,vmHint:r,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:s};return P.isWindows||(k.load=`${E.loadavg().map(M=>Math.round(M)).join(", ")}`),P.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(a,s){const i=[];return(0,g.listProcesses)(a.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(a)),i.push(""),i.push(this.formatProcessList(a,r)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(a))),s.forEach(o=>{if((0,S.isRemoteDiagnosticError)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.formatMachineInfo(o.machineInfo)),o.processes&&i.push(this.formatProcessList(a,o.processes)),o.workspaceMetadata)for(const w of Object.keys(o.workspaceMetadata)){const k=o.workspaceMetadata[w];let M=`${k.fileCount} files`;k.maxFilesReached&&(M=`more than ${M}`),i.push(`Folder (${w}): ${M}`),i.push(this.formatWorkspaceStats(k))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(a){const s=[];let r=0;const o=(C,L)=>{const T=` ${C}(${L})`;r+T.length>60?(s.push(w),w="|                 ",r=w.length):r+=T.length,w+=T};let w="|      File types:";const k=10,M=a.fileTypes.length>k?k:a.fileTypes.length;for(let C=0;C<M;C++){const L=a.fileTypes[C];o(L.name,L.count)}if(s.push(w),a.configFiles.length>=0&&(w="|      Conf files:",r=0,a.configFiles.forEach(C=>{o(C.name,C.count)}),s.push(w)),a.launchConfigFiles.length>0){let C="|      Launch Configs:";a.launchConfigFiles.forEach(L=>{const T=L.count>1?` ${L.name}(${L.count})`:` ${L.name}`;C+=T}),s.push(C)}return s.join(`
`)}expandGPUFeatures(a){const s=Math.max(...Object.keys(a).map(i=>i.length));return Object.keys(a).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${a[i]}`).join(`
                  `)}formatWorkspaceMetadata(a){const s=[],i=[];return a.windows.forEach(r=>{r.folderURIs.length===0||r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(o=>{const w=h.URI.revive(o);if(w.scheme===_.Schemas.file){const k=w.fsPath;i.push(f(k,["node_modules",".git"]).then(M=>{let C=`${M.fileCount} files`;M.maxFilesReached&&(C=`more than ${C}`),s.push(`|    Folder (${(0,D.basename)(k)}): ${C}`),s.push(this.formatWorkspaceStats(M))}).catch(M=>{s.push(`|      Error: Unable to collect workspace stats for folder ${k} (${M.toString()})`)}))}else s.push(`|    Folder (${w.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(a,s){const i=new Map;a.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),a.pidToNames.forEach(({pid:o,name:w})=>i.set(o,w));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(a.mainPID,i,r,s,0),r.join(`
`)}formatProcessItem(a,s,i,r,o){const w=o===0;let k;w?k=r.pid===a?`${this.productService.applicationName} main`:"remote agent":s.has(r.pid)?k=s.get(r.pid):k=`${"  ".repeat(o)} ${r.name}`;const M=process.platform==="win32"?r.mem:E.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}	${(M/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(r.children)&&r.children.forEach(C=>this.formatProcessItem(a,s,i,C,o+1))}async getWorkspaceFileExtensions(a){const s=new Set;for(const{uri:i}of a.folders){const r=h.URI.revive(i);if(r.scheme!==_.Schemas.file)continue;const o=r.fsPath;try{(await f(o,["node_modules",".git"])).fileTypes.forEach(k=>s.add(k.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(a){for(const{uri:s}of a.folders){const i=h.URI.revive(s);if(i.scheme!==_.Schemas.file)continue;const r=i.fsPath;try{const o=await f(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:w.name,count:w.count})}),o.launchConfigFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:w.name,count:w.count})}),o.configFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:w.name,count:w.count})})}catch{}}}};e.DiagnosticsService=p,e.DiagnosticsService=p=Ee([Y(0,b.ITelemetryService),Y(1,y.IProductService)],p)}),define(ee[250],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(_){this.appenders=_}listen(_,D){throw new Error(`Event not found: ${D}`)}call(_,D,{eventName:P,data:h}){return this.appenders.forEach(d=>d.log(P,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class A{constructor(_){this.channel=_}log(_,D){return this.channel.call("log",{eventName:_,data:D}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(ee[52],te([0,1,37,12,3,18,60,123,25]),function(H,e,E,A,n,_,D,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class d{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=d;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=m,e.NullTelemetryService=new m;class g{async publicLog(r,o,w){}async publicLogError(r,o,w){}}e.NullEndpointTelemetryService=g,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(i,r){return n.Event.debounce(r.onDidChangeConfiguration,(w,k)=>{const M=w?new Set([...w.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:M}},1e3,!0)(w=>{w.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,_.ConfigurationTargetToString)(w.source),configurationKeys:Array.from(w.affectedKeys)})})}e.configurationTelemetry=S;function u(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=u;function y(i,r){return!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=y;function b(i){const r=i.getValue(h.TELEMETRY_SETTING_ID),o=i.getValue(h.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(h.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function c(i){const r={},o={},w={};v(i,w);for(let k in w){k=k.length>150?k.substr(k.length-149):k;const M=w[k];typeof M=="number"?o[k]=M:typeof M=="boolean"?o[k]=M?1:0:typeof M=="string"?(M.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${M.length}`),r[k]=M.substring(0,8191)):typeof M<"u"&&M!==null&&(r[k]=M)}return{properties:r,measurements:o}}e.validateTelemetryData=c;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(i){if(!i)return"none";const r=(0,D.getRemoteName)(i);return f.has(r)?r:"other"}e.cleanRemoteAuthority=l;function v(i,r,o=0,w){if(i)for(const k of Object.getOwnPropertyNames(i)){const M=i[k],C=w?w+k:k;Array.isArray(M)?r[C]=(0,E.safeStringify)(M):M instanceof Date?r[C]=M.toISOString():(0,A.isObject)(M)?o<2?v(M,r,o+1,C+"."):r[C]=(0,E.safeStringify)(M):r[C]=M}}function I(i,r){const o=i.msftInternalDomains||[],w=r.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(o)||w}e.isInternalTelemetry=I;function p(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=p;function t(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const w=[];for(const L of r)for(;;){const T=L.exec(i);if(!T)break;w.push([T.index,L.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,M=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let C=0;for(o="";;){const L=M.exec(i);if(!L)break;const T=w.some(([F,B])=>L.index<B&&F<M.lastIndex);!k.test(L[0])&&!T&&(o+=i.substring(C,L.index)+"<REDACTED: user-file-path>",C=M.lastIndex)}return C<i.length&&(o+=i.substr(C)),o}function a(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of r)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function s(i,r){return(0,E.cloneAndChange)(i,o=>{if(o instanceof d||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let w=o.replaceAll("%20"," ");w=t(w,r);for(const k of r)w=w.replace(k,"");return w=a(w),w}})}e.cleanData=s}),define(ee[124],te([0,1,26,117,121,4,7,13,36,52]),function(H,e,E,A,n,_,D,P,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,E.compareIgnoreCase)(s.id,i.id)===0}e.areSameExtensions=m;const g=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(i){const r=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new S(i.identifier,r,o)}static parse(i){const r=g.exec(i);return r&&r[1]&&r[2]?new S({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof S?m(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=S;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(s){const i=u.exec(s);return i&&i[1]?[c(i[1]),i[2]]:[c(s),void 0]}e.getIdAndVersion=y;function b(s,i){return`${s}.${i}`}e.getExtensionId=b;function c(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=c;function f(s,i){return c(b(s??n.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=f;function l(s,i){const r=[],o=w=>{for(const k of r)if(k.some(M=>m(i(M),i(w))))return k;return null};for(const w of s){const k=o(w);k?k.push(w):r.push([w])}return r}e.groupByExtension=l;function v(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function I(s){return{id:new d.TelemetryTrustedValue(s.identifier.id),name:new d.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function p(s,i){const r=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const w=o.shift();if(w&&r.every(k=>!m(k.identifier,{id:w}))){const k=s.filter(M=>m(M.identifier,{id:w}));k.length===1&&(r.push(k[0]),o.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=p;async function t(s,i){if(!_.isLinux)return!1;let r;try{r=(await s.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(w){i.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(w))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(s,i){const r=await t(s,i),o=(0,A.getTargetPlatform)(r?"alpine":_.platform,h.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=a}),define(ee[251],te([0,1,204,52]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function n(_,D,P,h,d,m,g){const S={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_} (${D.nameShort})`};if((0,A.supportsTelemetry)(D,P)&&(0,A.getTelemetryLevel)(h)===3){const u=await(0,E.getServiceMachineId)(P,d,m);S["X-Market-User-Id"]=u,S["VSCode-SessionId"]=g.machineId||u}return S}e.resolveMarketplaceHeaders=n}),define(ee[252],te([0,1,2,37,4,26,183,18,59,78,22,43,25,52]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,l,v){this._configurationService=l,this._productService=v,this._experimentProperties={},this._disposables=new E.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(I),"gi")),I.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(I.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(I=>{(I.affectsConfiguration(S.TELEMETRY_SETTING_ID)||I.affectsConfiguration(S.TELEMETRY_OLD_SETTING_ID)||I.affectsConfiguration(S.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(f,l){this._experimentProperties[f]=l}_updateTelemetryLevel(){let f=(0,u.getTelemetryLevel)(this._configurationService);const l=this._productService.enabledTelemetryLevels;if(l){this._sendErrorTelemetry=this.sendErrorTelemetry?l.error:!1;const v=l.usage?3:l.error?2:0;f=Math.min(f,v)}this._telemetryLevel=f}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(f,l,v){this._telemetryLevel<l||(v=(0,A.mixin)(v,this._experimentProperties),v=(0,u.cleanData)(v,this._cleanupPatterns),v=(0,A.mixin)(v,this._commonProperties),this._appenders.forEach(I=>I.log(f,v)))}publicLog(f,l){this._log(f,3,l)}publicLog2(f,l){this.publicLog(f,l)}publicLogError(f,l){this._sendErrorTelemetry&&this._log(f,2,l)}publicLogError2(f,l){this.publicLogError(f,l)}};e.TelemetryService=y,e.TelemetryService=y=Ee([Y(1,P.IConfigurationService),Y(2,m.IProductService)],y);function b(){const c=(0,D.localize)(0,null,d.default.nameLong),f=d.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=n.isWeb?"":(0,D.localize)(3,null),v=(0,D.localize)(4,null),I=(0,D.localize)(5,null),p=(0,D.localize)(6,null),t=(0,D.localize)(7,null),a=`
|       | ${v} | ${I} | ${p} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,D.localize)(8,null);return`
${c} ${f} ${l}

&nbsp;

${t}
${a}

&nbsp;

${s}
`}g.Registry.as(h.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:b(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),g.Registry.as(h.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,D.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,D.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[253],te([0,1,4,87,25]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function _(D,P){let h=D.getItem(n.machineIdKey);return(typeof h!="string"||E.isMacintosh&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,A.getMachineId)(P.error.bind(P))),h}e.resolveMachineId=_}),define(ee[254],te([0,1,25,253]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function n(_,D){const P=await(0,A.resolveMachineId)(_,D);return _.setItem(E.machineIdKey,P),P}e.resolveMachineId=n}),define(ee[125],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var E;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(E||(e.EnvironmentVariableMutatorType=E={}))}),define(ee[255],te([0,1,4,125]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const n=new Map([[A.EnvironmentVariableMutatorType.Append,"APPEND"],[A.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[A.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class _{constructor(m){this.collections=m,this.map=new Map,this.descriptionMap=new Map,m.forEach((g,S)=>{this.populateDescriptionMap(g,S);const u=g.map.entries();let y=u.next();for(;!y.done;){const b=y.value[1],c=y.value[0];let f=this.map.get(c);if(f||(f=[],this.map.set(c,f)),f.length>0&&f[0].type===A.EnvironmentVariableMutatorType.Replace){y=u.next();continue}const l={extensionIdentifier:S,value:b.value,type:b.type,scope:b.scope,variable:b.variable,options:b.options};l.scope||delete l.scope,f.unshift(l),y=u.next()}})}async applyToProcessEnvironment(m,g,S){let u;E.isWindows&&(u={},Object.keys(m).forEach(y=>u[y.toLowerCase()]=y));for(const[y,b]of this.getVariableMap(g)){const c=E.isWindows&&u[y.toLowerCase()]||y;for(const f of b){const l=S?await S(f.value):f.value;if(f.options?.applyAtProcessCreation??!0)switch(f.type){case A.EnvironmentVariableMutatorType.Append:m[c]=(m[c]||"")+l;break;case A.EnvironmentVariableMutatorType.Prepend:m[c]=l+(m[c]||"");break;case A.EnvironmentVariableMutatorType.Replace:m[c]=l;break}if(f.options?.applyAtShellIntegration??!1){const v=`VSCODE_ENV_${n.get(f.type)}`;m[v]=(m[v]?m[v]+":":"")+y+"="+this._encodeColons(l)}}}}_encodeColons(m){return m.replaceAll(":","\\x3a")}diff(m,g){const S=new Map,u=new Map,y=new Map;if(m.getVariableMap(g).forEach((b,c)=>{const f=this.getVariableMap(g).get(c),l=P(b,f);l&&S.set(c,l)}),this.getVariableMap(g).forEach((b,c)=>{const f=m.getVariableMap(g).get(c),l=P(b,f);l&&y.set(c,l)}),this.getVariableMap(g).forEach((b,c)=>{const f=m.getVariableMap(g).get(c),l=h(b,f);l&&u.set(c,l)}),!(S.size===0&&u.size===0&&y.size===0))return{added:S,changed:u,removed:y}}getVariableMap(m){const g=new Map;for(const S of this.map.values()){const u=S.filter(y=>D(y,m));u.length>0&&g.set(u[0].variable,u)}return g}getDescriptionMap(m){const g=new Map;for(const S of this.descriptionMap.values()){const u=S.filter(y=>D(y,m,!0));for(const y of u)g.set(y.extensionIdentifier,y.description)}return g}populateDescriptionMap(m,g){if(!m.descriptionMap)return;const S=m.descriptionMap.entries();let u=S.next();for(;!u.done;){const y=u.value[1],b=u.value[0];let c=this.descriptionMap.get(b);c||(c=[],this.descriptionMap.set(b,c));const f={extensionIdentifier:g,scope:y.scope,description:y.description};f.scope||delete f.scope,c.push(f),u=S.next()}}}e.MergedEnvironmentVariableCollection=_;function D(d,m,g=!1){return d.scope?!!(d.scope.workspaceFolder&&m?.workspaceFolder&&d.scope.workspaceFolder.index===m.workspaceFolder.index):g?m===d.scope:!0}function P(d,m){if(!m)return d;const g=new Set;m.forEach(u=>g.add(u.extensionIdentifier));const S=[];return d.forEach(u=>{g.has(u.extensionIdentifier)||S.push(u)}),S.length===0?void 0:S}function h(d,m){if(!m)return;const g=new Map;m.forEach(u=>g.set(u.extensionIdentifier,u));const S=[];return d.forEach(u=>{const y=g.get(u.extensionIdentifier);y&&(u.type!==y.type||u.value!==y.value||u.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&S.push(y)}),S.length===0?void 0:S}}),define(ee[256],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function E(h){return[...h.entries()]}e.serializeEnvironmentVariableCollection=E;function A(h){return h?[...h.entries()]:[]}e.serializeEnvironmentDescriptionMap=A;function n(h){return new Map(h)}e.deserializeEnvironmentVariableCollection=n;function _(h){return new Map(h??[])}e.deserializeEnvironmentDescriptionMap=_;function D(h){return Array.from(h.entries()).map(d=>[d[0],E(d[1].map),A(d[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=D;function P(h){return new Map(h.map(d=>[d[0],{map:n(d[1]),descriptionMap:_(d[2])}]))}e.deserializeEnvironmentVariableCollections=P}),define(ee[257],te([0,1,8,23,3,2,5]),function(H,e,E,A,n,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends _.Disposable{constructor(d,m){super(),this._logService=m,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new n.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=d===void 0?15e3:d}createRequest(d){return new Promise((m,g)=>{const S=++this._lastRequestId;this._pendingRequests.set(S,m),this._onCreateRequest.fire({requestId:S,...d});const u=new A.CancellationTokenSource;(0,E.timeout)(this._timeout,u.token).then(()=>g(`Request ${S} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(S,[(0,_.toDisposable)(()=>u.cancel())])})}acceptReply(d,m){const g=this._pendingRequests.get(d);g?(this._pendingRequests.delete(d),(0,_.dispose)(this._pendingRequestDisposables.get(d)||[]),this._pendingRequestDisposables.delete(d),g(m)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${d}`)}};e.RequestStore=P,e.RequestStore=P=Ee([Y(1,D.ILogService)],P)}),define(ee[126],te([0,1,6,115,43]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new A.RawContextKey("terminalTabFocusMode",!1,!0);var _;(function(p){p.DefaultProfile="terminal.integrated.defaultProfile.",p.Profiles="terminal.integrated.profiles."})(_||(e.TerminalSettingPrefix=_={}));var D;(function(p){p.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",p.AutomationProfileLinux="terminal.integrated.automationProfile.linux",p.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",p.AutomationProfileWindows="terminal.integrated.automationProfile.windows",p.ProfilesWindows="terminal.integrated.profiles.windows",p.ProfilesMacOs="terminal.integrated.profiles.osx",p.ProfilesLinux="terminal.integrated.profiles.linux",p.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",p.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",p.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",p.UseWslProfiles="terminal.integrated.useWslProfiles",p.TabsDefaultColor="terminal.integrated.tabs.defaultColor",p.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",p.TabsEnabled="terminal.integrated.tabs.enabled",p.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",p.TabsHideCondition="terminal.integrated.tabs.hideCondition",p.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",p.TabsShowActions="terminal.integrated.tabs.showActions",p.TabsLocation="terminal.integrated.tabs.location",p.TabsFocusMode="terminal.integrated.tabs.focusMode",p.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",p.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",p.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",p.CopyOnSelection="terminal.integrated.copyOnSelection",p.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",p.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",p.FontFamily="terminal.integrated.fontFamily",p.FontSize="terminal.integrated.fontSize",p.LetterSpacing="terminal.integrated.letterSpacing",p.LineHeight="terminal.integrated.lineHeight",p.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",p.TabStopWidth="terminal.integrated.tabStopWidth",p.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",p.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",p.BellDuration="terminal.integrated.bellDuration",p.FontWeight="terminal.integrated.fontWeight",p.FontWeightBold="terminal.integrated.fontWeightBold",p.CursorBlinking="terminal.integrated.cursorBlinking",p.CursorStyle="terminal.integrated.cursorStyle",p.CursorStyleInactive="terminal.integrated.cursorStyleInactive",p.CursorWidth="terminal.integrated.cursorWidth",p.Scrollback="terminal.integrated.scrollback",p.DetectLocale="terminal.integrated.detectLocale",p.DefaultLocation="terminal.integrated.defaultLocation",p.GpuAcceleration="terminal.integrated.gpuAcceleration",p.TerminalTitleSeparator="terminal.integrated.tabs.separator",p.TerminalTitle="terminal.integrated.tabs.title",p.TerminalDescription="terminal.integrated.tabs.description",p.RightClickBehavior="terminal.integrated.rightClickBehavior",p.Cwd="terminal.integrated.cwd",p.ConfirmOnExit="terminal.integrated.confirmOnExit",p.ConfirmOnKill="terminal.integrated.confirmOnKill",p.EnableBell="terminal.integrated.enableBell",p.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",p.AllowChords="terminal.integrated.allowChords",p.AllowMnemonics="terminal.integrated.allowMnemonics",p.TabFocusMode="terminal.integrated.tabFocusMode",p.EnvMacOs="terminal.integrated.env.osx",p.EnvLinux="terminal.integrated.env.linux",p.EnvWindows="terminal.integrated.env.windows",p.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",p.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",p.ShowExitAlert="terminal.integrated.showExitAlert",p.SplitCwd="terminal.integrated.splitCwd",p.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",p.WordSeparators="terminal.integrated.wordSeparators",p.EnableFileLinks="terminal.integrated.enableFileLinks",p.UnicodeVersion="terminal.integrated.unicodeVersion",p.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",p.LocalEchoEnabled="terminal.integrated.localEchoEnabled",p.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",p.LocalEchoStyle="terminal.integrated.localEchoStyle",p.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",p.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",p.HideOnStartup="terminal.integrated.hideOnStartup",p.CustomGlyphs="terminal.integrated.customGlyphs",p.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",p.InheritEnv="terminal.integrated.inheritEnv",p.ShowLinkHover="terminal.integrated.showLinkHover",p.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",p.AutoReplies="terminal.integrated.autoReplies",p.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",p.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",p.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",p.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",p.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",p.EnableImages="terminal.integrated.enableImages",p.SmoothScrolling="terminal.integrated.smoothScrolling",p.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",p.FocusAfterRun="terminal.integrated.focusAfterRun",p.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",p.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",p.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var P;(function(p){p.PowerShell="pwsh",p.Bash="bash",p.Fish="fish",p.Sh="sh",p.Csh="csh",p.Ksh="ksh",p.Zsh="zsh"})(P||(e.PosixShellType=P={}));var h;(function(p){p.CommandPrompt="cmd",p.PowerShell="pwsh",p.Wsl="wsl",p.GitBash="gitbash"})(h||(e.WindowsShellType=h={}));var d;(function(p){p[p.Api=0]="Api",p[p.Process=1]="Process",p[p.Sequence=2]="Sequence",p[p.Config=3]="Config"})(d||(e.TitleEventSource=d={}));var m;(function(p){p.LocalPty="localPty",p.PtyHost="ptyHost",p.PtyHostWindow="ptyHostWindow",p.Logger="logger",p.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={}));var g;(function(p){p.Cwd="cwd",p.InitialCwd="initialCwd",p.FixedDimensions="fixedDimensions",p.Title="title",p.ShellType="shellType",p.HasChildProcesses="hasChildProcesses",p.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",p.OverrideDimensions="overrideDimensions",p.FailedShellIntegrationActivation="failedShellIntegrationActivation",p.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(g||(e.ProcessPropertyType=g={})),e.IPtyService=(0,E.createDecorator)("ptyService");var S;(function(p){p[p.BeatInterval=5e3]="BeatInterval",p[p.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",p[p.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",p[p.SecondWaitMultiplier=1]="SecondWaitMultiplier",p[p.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S||(e.HeartbeatConstants=S={}));var u;(function(p){p[p.Panel=1]="Panel",p[p.Editor=2]="Editor"})(u||(e.TerminalLocation=u={}));var y;(function(p){p.TerminalView="view",p.Editor="editor"})(y||(e.TerminalLocationString=y={}));var b;(function(p){p[p.GraceTime=6e4]="GraceTime",p[p.ShortGraceTime=6e3]="ShortGraceTime"})(b||(e.LocalReconnectConstants=b={}));var c;(function(p){p[p.HighWatermarkChars=1e5]="HighWatermarkChars",p[p.LowWatermarkChars=5e3]="LowWatermarkChars",p[p.CharCountAckSize=5e3]="CharCountAckSize"})(c||(e.FlowControlConstants=c={}));var f;(function(p){p.GitBash="Git Bash",p.Pwsh="PowerShell"})(f||(e.ProfileSource=f={}));var l;(function(p){p[p.Off=0]="Off",p[p.FinalTerm=1]="FinalTerm",p[p.VSCode=2]="VSCode"})(l||(e.ShellIntegrationStatus=l={}));var v;(function(p){p[p.Unknown=0]="Unknown",p[p.Shutdown=1]="Shutdown",p[p.Process=2]="Process",p[p.User=3]="User",p[p.Extension=4]="Extension"})(v||(e.TerminalExitReason=v={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class I{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(t){const a=this._sanitizeRemoteAuthority(t.remoteAuthority);if(this._backends.has(a))throw new Error(`A terminal backend with remote authority '${a}' was already registered.`);this._backends.set(a,t)}getTerminalBackend(t){return this._backends.get(this._sanitizeRemoteAuthority(t))}_sanitizeRemoteAuthority(t){return t?.toLowerCase()??""}}n.Registry.add(e.TerminalExtensions.Backend,new I),e.ILocalPtyService=(0,E.createDecorator)("localPtyService"),e.ITerminalLogService=(0,E.createDecorator)("terminalLogService")}),define(ee[258],te([0,1,71,7,185,103]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function D(S,u){const y=[{name:null,description:(0,n.localize)(0,null)}];return y.push(...S.map(b=>({name:b.profileName,description:P(b)}))),u&&y.push(...u.map(b=>({name:b.title,description:h(b)}))),{values:y.map(b=>b.name),markdownDescriptions:y.map(b=>b.description)}}e.createProfileSchemaEnums=D;function P(S){let u=`$(${_.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:E.Codicon.terminal.id}) ${S.profileName}
- path: ${S.path}`;return S.args&&(typeof S.args=="string"?u+=`
- args: "${S.args}"`:u+=`
- args: [${S.args.length===0?"":`'${S.args.join("','")}'`}]`),S.overrideName!==void 0&&(u+=`
- overrideName: ${S.overrideName}`),S.color&&(u+=`
- color: ${S.color}`),S.env&&(u+=`
- env: ${JSON.stringify(S.env)}`),u}function h(S){return`$(${_.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:E.Codicon.terminal.id}) ${S.title}
- extensionIdentifier: ${S.extensionIdentifier}`}function d(S,u){if(!S&&!u)return!0;if(typeof S=="string"&&typeof u=="string")return S===u;if(Array.isArray(S)&&Array.isArray(u)){if(S.length!==u.length)return!1;for(let y=0;y<S.length;y++)if(S[y]!==u[y])return!1;return!0}return!1}e.terminalProfileArgsMatch=d;function m(S,u){if(!S&&!u)return!0;if(!S||!u)return!1;if(_.ThemeIcon.isThemeIcon(S)&&_.ThemeIcon.isThemeIcon(u))return S.id===u.id&&S.color===u.color;if(typeof S=="object"&&"light"in S&&"dark"in S&&typeof u=="object"&&"light"in u&&"dark"in u){const y=S,b=u;if((A.URI.isUri(y.light)||g(y.light))&&(A.URI.isUri(y.dark)||g(y.dark))&&(A.URI.isUri(b.light)||g(b.light))&&(A.URI.isUri(b.dark)||g(b.dark)))return y.light.path===b.light.path&&y.dark.path===b.dark.path}if(A.URI.isUri(S)&&A.URI.isUri(u)||g(S)||g(u)){const y=S,b=u;return y.path===b.path&&y.scheme===b.scheme}return!1}e.terminalIconsEqual=m;function g(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}e.isUriComponents=g}),define(ee[259],te([0,1,71,4,184,59,43,258]),function(H,e,E,A,n,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,E.getAllCodicons)(),c=>c.id),markdownEnumDescriptions:Array.from((0,E.getAllCodicons)(),c=>`$(${c.id})`)};const h={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),...e.terminalIconSchema},color:{description:(0,n.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},d={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},m={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function g(c){const f=c===2?"linux":c===1?"osx":"windows";return(0,n.localize)(7,null,(0,A.PlatformToString)(c),'```json\n"terminal.integrated.profile.'+f+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const S={id:"terminal",order:100,title:(0,n.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:g(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(13,null),type:"string"},id:{description:(0,n.localize)(14,null),type:"string"},title:{description:(0,n.localize)(15,null),type:"string"},...h}},{type:"null"},d]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:g(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(16,null),type:"string"},id:{description:(0,n.localize)(17,null),type:"string"},title:{description:(0,n.localize)(18,null),type:"string"},...h}},{type:"null"},d]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:g(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(19,null),type:"string"},id:{description:(0,n.localize)(20,null),type:"string"},title:{description:(0,n.localize)(21,null),type:"string"},...h}},{type:"null"},d]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(26,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){D.Registry.as(_.Extensions.Configuration).registerConfiguration(S),b()}e.registerTerminalPlatformConfiguration=u;let y;function b(c,f){const l=D.Registry.as(_.Extensions.Configuration);let v;c&&(v=(0,P.createProfileSchemaEnums)(c?.profiles,f));const I=y;y={id:"terminal",order:100,title:(0,n.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null),type:["string","null"],default:null,enum:c?.os===3?v?.values:void 0,markdownEnumDescriptions:c?.os===3?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(29,null),type:["string","null"],default:null,enum:c?.os===2?v?.values:void 0,markdownEnumDescriptions:c?.os===2?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(30,null),type:["string","null"],default:null,enum:c?.os===1?v?.values:void 0,markdownEnumDescriptions:c?.os===1?v?.markdownDescriptions:void 0}}},l.updateConfigurations({add:[y],remove:I?[I]:[]})}e.registerTerminalDefaultProfileConfiguration=b}),define(ee[260],te([0,1,27,15,37,9,4,36,26,12,21,125,256,255]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let r=0;return i&&i.length===4&&(r=parseInt(i[3])),r}e.getWindowsBuildNumber=y;async function b(i,r,o,w=P.env,k=m.Promises.exists){if(_.isAbsolute(i))return await k(i)?i:void 0;if(r===void 0&&(r=P.cwd()),_.dirname(i)!=="."){const T=_.join(r,i);return await k(T)?T:void 0}const C=(0,n.getCaseInsensitive)(w,"PATH");if(o===void 0&&(0,d.isString)(C)&&(o=C.split(_.delimiter)),o===void 0||o.length===0){const T=_.join(r,i);return await k(T)?T:void 0}for(const T of o){let F;if(_.isAbsolute(T)?F=_.join(T,i):F=_.join(r,T,i),await k(F))return F;if(D.isWindows){let B=F+".com";if(await k(B)||(B=F+".exe",await k(B)))return B}}const L=_.join(r,i);return await k(L)?L:void 0}e.findExecutable=b;function c(i,r,o,w,k){const M=D.isWindows&&(!r.windowsEnableConpty||y()<18309);if(!r.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||M)return;const C=i.args,L=P.platform==="win32"?_.basename(i.executable).toLowerCase():_.basename(i.executable),T=_.dirname(A.FileAccess.asFileUri("").fsPath);let F;const B={VSCODE_INJECTION:"1"};if(r.shellIntegration.nonce&&(B.VSCODE_NONCE=r.shellIntegration.nonce),D.isWindows){if(L==="pwsh.exe"||L==="powershell.exe")return!C||a(C)?F=v.get(l.WindowsPwsh):t(C)&&(F=v.get(l.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],T,""),{newArgs:F,envMixin:B}):void 0;w.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(L){case"bash":return!C||C.length===0?F=v.get(l.Bash):s(C)&&(B.VSCODE_SHELL_LOGIN="1",f(r,B),F=v.get(l.Bash)),F?(F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],T),{newArgs:F,envMixin:B}):void 0;case"fish":{const se=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ie=_.join(T,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return B.XDG_DATA_DIRS=`${se}:${ie}`,f(r,B),{newArgs:void 0,envMixin:B}}case"pwsh":return!C||a(C)?F=v.get(l.Pwsh):t(C)&&(F=v.get(l.PwshLogin)),F?(F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],T,""),{newArgs:F,envMixin:B}):void 0;case"zsh":{if(!C||C.length===0?F=v.get(l.Zsh):s(C)?(F=v.get(l.ZshLogin),f(r,B)):(C===v.get(l.Zsh)||C===v.get(l.ZshLogin))&&(F=C),!F)return;F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],T);let se;try{se=E.userInfo().username}catch{se="unknown"}const ie=_.join(E.tmpdir(),`${se}-${k.applicationName}-zsh`);B.ZDOTDIR=ie;const de=o?.ZDOTDIR??E.homedir()??"~";B.USER_ZDOTDIR=de;const ae=[];return ae.push({source:_.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:_.join(ie,".zshrc")}),ae.push({source:_.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:_.join(ie,".zprofile")}),ae.push({source:_.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:_.join(ie,".zshenv")}),ae.push({source:_.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:_.join(ie,".zlogin")}),{newArgs:F,envMixin:B,filesToCopy:ae}}}w.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=c;function f(i,r){if(D.isMacintosh&&i.environmentVariableCollections){const o=(0,S.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),k=new u.MergedEnvironmentVariableCollection(o).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),M=[];if(k)for(const C of k)C.type===g.EnvironmentVariableMutatorType.Prepend&&M.push(C.value);M.length>0&&(r.VSCODE_PATH_PREFIX=M.join(""))}}var l;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(l||(l={}));const v=new Map;v.set(l.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(l.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(l.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),v.set(l.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),v.set(l.Zsh,["-i"]),v.set(l.ZshLogin,["-il"]),v.set(l.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const I=["-login","-l"],p=["-nol","-nologo"];function t(i){return typeof i=="string"?I.includes(i.toLowerCase()):i.length===1&&I.includes(i[0].toLowerCase())||i.length===2&&(I.includes(i[0].toLowerCase())||I.includes(i[1].toLowerCase()))&&(p.includes(i[0].toLowerCase())||p.includes(i[1].toLowerCase()))}function a(i){return typeof i=="string"?p.includes(i.toLowerCase()):i.length===0||i?.length===1&&p.includes(i[0].toLowerCase())}function s(i){return i==="string"&&I.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&I.includes(i[0].toLowerCase())}}),define(ee[261],te([0,1,47,71,9,4,12,21,107,260,114]),function(H,e,E,A,n,_,D,P,h,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let g,S=!0;function u(r,o,w,k,M=process.env,C,L,T,F){return C=C||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},_.isWindows?y(w,C,M,L,k.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:k.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:k.getValue("terminal.integrated.defaultProfile.windows"),F,T):a(C,L,w,r&&typeof r=="object"?{...r}:k.getValue(_.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:k.getValue(_.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,T,M)}e.detectAvailableProfiles=u;async function y(r,o,w,k,M,C,L,T,F){const B=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),se=`${process.env.windir}\\${B?"Sysnative":"System32"}`;let ie=!1;(0,d.getWindowsBuildNumber)()>=16299&&(ie=!0),await l(T);const de=new Map;if(r){de.set("PowerShell",{source:"PowerShell",icon:A.Codicon.terminalPowershell,isAutoDetected:!0}),de.set("Windows PowerShell",{path:`${se}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.Codicon.terminalPowershell,isAutoDetected:!0}),de.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),de.set("Command Prompt",{path:`${se}\\cmd.exe`,icon:A.Codicon.terminalCmd,isAutoDetected:!0}),de.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),de.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:A.Codicon.terminalBash,isAutoDetected:!0});const ue=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;de.set("Cmder",{path:`${se}\\cmd.exe`,args:["/K",ue],requiresPath:process.env.CMDER_ROOT?ue:{path:ue,isUnsafe:!0},isAutoDetected:!0})}s(C,de);const ae=await b(de.entries(),L,o,w,k,F);if(r&&M)try{const ue=await p(`${se}\\${ie?"wsl":"bash"}.exe`,L);for(const x of ue)(!C||!(x.profileName in C))&&ae.push(x)}catch{S&&(k?.info("WSL is not installed, so could not detect WSL profiles"),S=!1)}return ae}async function b(r,o,w,k=process.env,M,C){const L=[];for(const[T,F]of r)L.push(c(T,F,o,w,k,M,C));return(await Promise.all(L)).filter(T=>!!T)}async function c(r,o,w,k,M=process.env,C,L){if(o===null)return;let T,F,B;if("source"in o&&!("path"in o)){const ae=g?.get(o.source);if(!ae)return;T=ae.paths,F=o.args||ae.args,o.icon?B=f(o.icon):ae.icon&&(B=ae.icon)}else T=Array.isArray(o.path)?o.path:[o.path],F=_.isWindows||Array.isArray(o.args)?o.args:void 0,B=f(o.icon);let se;if(L){const ae=T.map(x=>typeof x=="string"?x:x.path),ue=await L(ae);se=new Array(T.length);for(let x=0;x<T.length;x++)typeof T[x]=="string"?se[x]=ue[x]:se[x]={path:ue[x],isUnsafe:!0}}else se=T.slice();let ie;if(o.requiresPath){let ae;if((0,D.isString)(o.requiresPath)?ae=o.requiresPath:(ae=o.requiresPath.path,o.requiresPath.isUnsafe&&(ie=ae)),!await k.existsFile(ae))return}const de=await i(r,w,se,k,M,F,o.env,o.overrideName,o.isAutoDetected,ie);if(!de){C?.debug("Terminal profile not validated",r,T);return}return de.isAutoDetected=o.isAutoDetected,de.icon=B,de.color=o.color,de}function f(r){return typeof r=="string"?{id:r}:r}async function l(r){if(g&&!r)return;const[o,w]=await Promise.all([v(),r||I()]);g=new Map,g.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),g.set("PowerShell",{profileName:"PowerShell",paths:w,icon:A.Codicon.terminalPowershell})}async function v(){const r=new Set,o=await(0,d.findExecutable)("git.exe");if(o){const M=(0,m.dirname)(o);r.add((0,m.resolve)(M,"../.."))}function w(M,C){C&&M.add(C)}w(r,process.env.ProgramW6432),w(r,process.env.ProgramFiles),w(r,process.env["ProgramFiles(X86)"]),w(r,`${process.env.LocalAppData}\\Program`);const k=[];for(const M of r)k.push(`${M}\\Git\\bin\\bash.exe`,`${M}\\Git\\usr\\bin\\bash.exe`,`${M}\\usr\\bin\\bash.exe`);return k.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),k}async function I(){const r=[];for await(const o of(0,h.enumeratePowerShellInstallations)())r.push(o.exePath);return r}async function p(r,o){const w=[],k=await new Promise((L,T)=>{E.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,B)=>{if(F)return T("Problem occurred when getting wsl distros");L(B)})});if(!k)return[];const M=new RegExp(/[\r?\n]/),C=k.split(M).filter(L=>L.trim().length>0&&L!=="");for(const L of C){if(L===""||L.startsWith("docker-desktop"))continue;const T=`${L} (WSL)`,F={profileName:T,path:r,args:["-d",`${L}`],isDefault:T===o,icon:t(L),isAutoDetected:!1};w.push(F)}return w}function t(r){return r.includes("Ubuntu")?A.Codicon.terminalUbuntu:r.includes("Debian")?A.Codicon.terminalDebian:A.Codicon.terminalLinux}async function a(r,o,w,k,M,C,L,T){const F=new Map;if(w){const B=(await r.readFile("/etc/shells")).toString(),se=(C||B.split(`
`)).map(de=>{const ae=de.indexOf("#");return ae===-1?de:de.substring(0,ae)}).filter(de=>de.trim().length>0),ie=new Map;for(const de of se){let ae=(0,n.basename)(de),ue=ie.get(ae)||0;ue++,ue>1&&(ae=`${ae} (${ue})`),ie.set(ae,ue),F.set(ae,{path:de,isAutoDetected:!0})}}return s(k,F),await b(F.entries(),M,r,T,o,L)}function s(r,o){if(r)for(const[w,k]of Object.entries(r))k===null||typeof k!="object"||!("path"in k)&&!("source"in k)?o.delete(w):(k.icon=k.icon||o.get(w)?.icon,o.set(w,k))}async function i(r,o,w,k,M,C,L,T,F,B){if(w.length===0)return Promise.resolve(void 0);const se=w.shift();if(se==="")return i(r,o,w,k,M,C,L,T,F);const ie=typeof se!="string"&&se.isUnsafe,de=typeof se=="string"?se:se.path,ae={profileName:r,path:de,args:C,env:L,overrideName:T,isAutoDetected:F,isDefault:r===o,isUnsafePath:ie,requiresUnsafePath:B};if((0,n.basename)(de)===de){const x=M.PATH?M.PATH.split(n.delimiter):void 0,G=await(0,d.findExecutable)(de,void 0,x,void 0,k.existsFile);return G?(ae.path=G,ae.isFromPath=!0,ae):i(r,o,w,k,M,C)}return await k.existsFile((0,n.normalize)(de))?ae:i(r,o,w,k,M,C,L,T,F)}}),define(ee[262],te([0,1,3,2,4,42,18,5,224,95,257,126,259,261,109,69]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var c;(function(l){l[l.MaxRestarts=5]="MaxRestarts"})(c||(c={}));let f=class extends A.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(v,I,p,t){super(),this._ptyHostStarter=v,this._configurationService=I,this._logService=p,this._loggerService=t,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new E.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new E.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new E.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new E.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new E.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new E.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new E.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new E.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new E.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new E.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new E.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new E.Emitter),this.onProcessExit=this._onProcessExit.event,(0,S.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,A.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new m.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),this._ptyHostStarter.onRequestConnection&&E.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost()),this._ptyHostStarter.onWillShutdown?.(()=>this._wasQuitRequested=!0)}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(n.isWindows)return process.env;try{return await(0,d.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(v){return this._logService.error("ptyHost was unable to resolve shell environment",v),{}}}_startPtyHost(){const v=this._ptyHostStarter.start(),I=v.client;this._logService.getLevel()===P.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),_.ProxyChannel.toService(I.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(v.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),!this._wasQuitRequested&&!this._isDisposed&&(this._restartCount<=c.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const t=_.ProxyChannel.toService(I.getChannel(g.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(a=>this._onProcessData.fire(a))),this._register(t.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(t.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(t.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(t.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(t.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(t.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),this._register(new h.RemoteLoggerChannelClient(this._loggerService,I.getChannel(g.TerminalIpcChannels.Logger))),this.__connection=v,this.__proxy=t,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[v,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(v,I,p,t,a,s,i,r,o,w,k){const M=setTimeout(()=>this._handleUnresponsiveCreateProcess(),g.HeartbeatConstants.CreateProcessTimeout),C=await this._proxy.createProcess(v,I,p,t,a,s,i,r,o,w,k);return clearTimeout(M),C}updateTitle(v,I,p){return this._proxy.updateTitle(v,I,p)}updateIcon(v,I,p,t){return this._proxy.updateIcon(v,I,p,t)}attachToProcess(v){return this._proxy.attachToProcess(v)}detachFromProcess(v,I){return this._proxy.detachFromProcess(v,I)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(v){return this._proxy.start(v)}shutdown(v,I){return this._proxy.shutdown(v,I)}input(v,I){return this._proxy.input(v,I)}processBinary(v,I){return this._proxy.processBinary(v,I)}resize(v,I,p){return this._proxy.resize(v,I,p)}clearBuffer(v){return this._proxy.clearBuffer(v)}acknowledgeDataEvent(v,I){return this._proxy.acknowledgeDataEvent(v,I)}setUnicodeVersion(v,I){return this._proxy.setUnicodeVersion(v,I)}getInitialCwd(v){return this._proxy.getInitialCwd(v)}getCwd(v){return this._proxy.getCwd(v)}async getLatency(){const v=new b.StopWatch,I=await this._proxy.getLatency();return v.stop(),[{label:"ptyhostservice<->ptyhost",latency:v.elapsed()},...I]}orphanQuestionReply(v){return this._proxy.orphanQuestionReply(v)}installAutoReply(v,I){return this._proxy.installAutoReply(v,I)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(v){return this._proxy.uninstallAutoReply(v)}getDefaultSystemShell(v){return this._optionalProxy?.getDefaultSystemShell(v)??(0,y.getSystemShell)(v??n.OS,process.env)}async getProfiles(v,I,p,t=!1){const a=await this._resolveShellEnv();return(0,u.detectAvailableProfiles)(I,p,t,this._configurationService,a,void 0,this._logService,this._resolveVariables.bind(this,v))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(v,I){return this._proxy.getWslPath(v,I)}getRevivedPtyNewId(v,I){return this._proxy.getRevivedPtyNewId(v,I)}setTerminalLayoutInfo(v){return this._proxy.setTerminalLayoutInfo(v)}async getTerminalLayoutInfo(v){return this._optionalProxy?.getTerminalLayoutInfo(v)}async requestDetachInstance(v,I){return this._proxy.requestDetachInstance(v,I)}async acceptDetachInstanceReply(v,I){return this._proxy.acceptDetachInstanceReply(v,I)}async freePortKillProcess(v){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(v)}async serializeTerminalState(v){return this._proxy.serializeTerminalState(v)}async reviveTerminalProcesses(v,I,p){return this._proxy.reviveTerminalProcesses(v,I,p)}async refreshProperty(v,I){return this._proxy.refreshProperty(v,I)}async updateProperty(v,I,p){return this._proxy.updateProperty(v,I,p)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(v){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),v?g.HeartbeatConstants.ConnectingBeatInterval:g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(v,I){return this._resolveVariablesRequestStore.createRequest({workspaceId:v,originalText:I})}async acceptPtyHostResolvedVariables(v,I){this._resolveVariablesRequestStore.acceptReply(v,I)}};e.PtyHostService=f,e.PtyHostService=f=Ee([Y(1,D.IConfigurationService),Y(2,P.ILogService),Y(3,P.ILoggerService)],f)}),define(ee[80],te([0,1,14,3,2,4,18,6,34]),function(H,e,E,A,n,_,D,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const d="#FFFFFF",m="#1E1E1E",g="#000000",S="#FFFFFF",u="theme",y="themeBackground",b="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let c=class extends n.Disposable{constructor(l,v){super(),this.stateService=l,this.configurationService=v,this._onDidChangeColorScheme=this._register(new A.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,E.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(_.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(_.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(_.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const l=this.getColorScheme();if(l.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return l.dark?g:S;let v=this.stateService.getItem(y,null);if(!v)switch(this.stateService.getItem(u,"vs-dark").split(" ")[0]){case"vs":v=d;break;case"hc-black":v=g;break;case"hc-light":v=S;break;default:v=m}return _.isMacintosh&&v.toUpperCase()===m&&(v="#171717"),v}saveWindowSplash(l,v){this.stateService.setItems([{key:u,data:v.baseTheme},{key:y,data:v.colorInfo.background},{key:b,data:v}]),typeof l=="number"&&this.updateBackgroundColor(l,v)}updateBackgroundColor(l,v){for(const I of E.BrowserWindow.getAllWindows())if(I.id===l){I.setBackgroundColor(v.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(b)}};e.ThemeMainService=c,e.ThemeMainService=c=Ee([Y(0,h.IStateService),Y(1,D.IConfigurationService)],c)}),define(ee[127],te([0,1,3,18,6,5]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,n.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,n.createDecorator)("sharedTunnelsService");var D;(function(c){c.Http="http",c.Https="https"})(D||(e.TunnelProtocol=D={}));var P;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(P||(e.TunnelPrivacyId=P={}));function h(c){return!!c.forwardPort}e.isTunnelProvider=h;var d;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function m(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(f)return{address:f[1],port:+f[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g(c){return e.LOCALHOST_ADDRESSES.indexOf(c)>=0}e.isLocalhost=g,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(c){return e.ALL_INTERFACES_ADDRESSES.indexOf(c)>=0}e.isAllInterfaces=S;function u(c,f,l,v){if(l===1)return!1;if(l===2&&S(f)){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(I?.length===4&&parseInt(I[1])>=18)return!1}return c<1024}e.isPortPrivileged=u;class y{constructor(f,l,v){this.remoteAddress=f,this.localAddress=l,this._dispose=v,this._onDispose=new E.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=y;let b=class{constructor(f,l){this.logService=f,this.configurationService=l,this._onTunnelOpened=new E.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new E.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new E.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const f=this.configurationService.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(f){return this._tunnelProvider=f,f?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(f){this._canElevate=f.elevation,this._privacyOptions=f.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const f=[],l=Array.from(this._tunnels.values());for(const v of l){const I=Array.from(v.values());for(const p of I){const t=await p.value;t&&typeof t!="string"&&f.push(t)}}return f}async dispose(){for(const f of this._tunnels.values()){for(const{value:l}of f.values())await l.then(v=>typeof v!="string"?v?.dispose():void 0);f.clear()}this._tunnels.clear()}setEnvironmentTunnel(f,l,v,I,p){this.addTunnelToMap(f,l,Promise.resolve({tunnelRemoteHost:f,tunnelRemotePort:l,localAddress:v,privacy:I,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(f,l){(S(f)||g(f))&&(f=e.LOCALHOST_ADDRESSES[0]);const v=this.getTunnelFromMap(f,l);if(v)return++v.refcount,v.value}openTunnel(f,l,v,I,p,t=!1,a,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${v} on local port ${p}.`);const i=this._tunnelProvider??f;if(!i)return;if(l||(l="localhost"),I||(I=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(i,l,v,I,p,t,a,s);return r?r.then(o=>{if(o){if(typeof o=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(l,v),o}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(l,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.makeTunnel(o);return(o.tunnelRemoteHost!==l||o.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&o.privacy!==a&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(w),w}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const l=this._tunnels.get(f.tunnelRemoteHost);if(l){const v=l.get(f.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(f.tunnelRemoteHost,f.tunnelRemotePort,v))}}}}async tryDisposeTunnel(f,l,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${l}.`);const I=v.value.then(async p=>{p&&typeof p!="string"&&(await p.dispose(!0),this._onTunnelClosed.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this._tunnels.has(f)&&this._tunnels.get(f).delete(l),I}}async closeTunnel(f,l){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${l} `);const v=this._tunnels.get(f);if(v&&v.has(l)){const I=v.get(l);I.refcount=0,await this.tryDisposeTunnel(f,l,I)}}addTunnelToMap(f,l,v){this._tunnels.has(f)||this._tunnels.set(f,new Map),this._tunnels.get(f).set(l,{refcount:1,value:v})}async removeEmptyOrErrorTunnelFromMap(f,l){const v=this._tunnels.get(f);if(v){const I=v.get(l),p=I?await I.value:void 0;(!p||typeof p=="string")&&v.delete(l),v.size===0&&this._tunnels.delete(f)}}getTunnelFromMap(f,l){const v=[f];g(f)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):S(f)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const I=v.map(p=>this._tunnels.get(p));for(const p of I){const t=p?.get(l);if(t)return t}}canTunnel(f){return!!m(f)}createWithProvider(f,l,v,I,p,t,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${v} on local port ${I}.`);const s=v;this._factoryInProgress.add(s);const i=I===void 0?v:I,r={elevationRequired:p?this.isPortPrivileged(i):!1},o={remoteAddress:{host:l,port:v},localAddressPort:I,privacy:t,public:t?t!==P.Private:void 0,protocol:a},w=f.forwardPort(o,r);return w?(this.addTunnelToMap(l,v,w),w.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),w}};e.AbstractTunnelService=b,e.AbstractTunnelService=b=Ee([Y(0,_.ILogService),Y(1,A.IConfigurationService)],b)}),define(ee[48],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.DisablementReason=e.UpdateType=e.StateType=void 0;var A;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(A||(e.StateType=A={}));var n;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap",D[D.WindowsInstaller=3]="WindowsInstaller"})(n||(e.UpdateType=n={}));var _;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(_||(e.DisablementReason=_={})),e.State={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,P)=>({type:"idle",updateType:D,error:P}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(ee[263],te([0,1,4,186,59,43]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),_.Registry.as(n.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[264],te([0,1,3,48]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class n{constructor(P){this.service=P}listen(P,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(P,h,d){switch(h){case"checkForUpdates":return this.service.checkForUpdates(d);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(d)}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=n;class _{get state(){return this._state}set state(P){this._state=P,this._onStateChange.fire(P)}constructor(P){this.channel=P,this._onStateChange=new E.Emitter,this.onStateChange=this._onStateChange.event,this._state=A.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(P){return this.channel.call("checkForUpdates",P)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(P){return this.channel.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=_}),define(ee[40],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(ee[265],te([0,1,40,205,16,19,139,3,2]),function(H,e,E,A,n,_,D,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class d{static{this._clock=0}constructor(S){this.uri=S,this.time=d._clock++}touch(){return this.time=d._clock++,this}}let m=class{constructor(S){this._fileService=S,this._dispooables=new h.DisposableStore,this._limit=2**16;const u=new Map,y=b=>{let c=u.get(b.scheme);return c===void 0&&(c=S.hasProvider(b)&&!this._fileService.hasCapability(b,1024),u.set(b.scheme,c)),c};this._dispooables.add(P.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(b=>{u.delete(b.scheme)})),this.extUri=new _.ExtUri(y),this._canonicalUris=new D.SkipList((b,c)=>this.extUri.compare(b,c,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,_.normalizePath)(S));const u=this._canonicalUris.get(S);return u?u.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new d(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((y,b)=>y[1].time<b[1].time?1:y[1].time>b[1].time?-1:0);d._clock=0,this._canonicalUris.clear();const u=this._limit*.5;for(let y=0;y<u;y++)this._canonicalUris.set(S[y][0],S[y][1].touch())}};e.UriIdentityService=m,e.UriIdentityService=m=Ee([Y(0,n.IFileService)],m),(0,A.registerSingleton)(E.IUriIdentityService,m,1)}),define(ee[128],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(ee[266],te([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class A{constructor(P){this.handler=P}listen(P,h){throw new Error(`Event not found: ${h}`)}call(P,h,d){switch(h){case"handleURL":return this.handler.handleURL(E.URI.revive(d[0]),d[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=A;class n{constructor(P){this.channel=P}handleURL(P,h){return this.channel.call("handleURL",[P.toJSON(),h])}}e.URLHandlerChannelClient=n;class _{constructor(P,h){this.next=P,this.logService=h}async routeCall(P,h,d,m){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(d)&&d.length>0){const g=E.URI.revive(d[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",g.toString(!0)),g.query){const S=/\bwindowId=(\d+)/.exec(g.query);if(S){const u=S[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${u}"`,g.toString(!0));const y=new RegExp(`window:${u}`),b=P.connections.find(c=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",c.ctx),y.test(c.ctx)));if(b)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",g.toString(!0)),b;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",g.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",g.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(P,h,d,m)}routeEvent(P,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=_}),define(ee[267],te([0,1,8,2,7,22]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends A.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(d,m){const g=[...this.handlers.values()];return(0,E.first)(g.map(S=>()=>S.handleURL(d,m)),void 0,!1).then(S=>S||!1)}registerHandler(d){return this.handlers.add(d),(0,A.toDisposable)(()=>this.handlers.delete(d))}}e.AbstractURLService=D;let P=class extends D{constructor(d){super(),this.productService=d}create(d){let{authority:m,path:g,query:S,fragment:u}=d||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&g&&g.indexOf("/")!==0&&(g=`/${g}`),n.URI.from({scheme:this.productService.urlProtocol,authority:m,path:g,query:S,fragment:u})}};e.NativeURLService=P,e.NativeURLService=P=Ee([Y(0,_.IProductService)],P)}),define(ee[268],te([0,1,14,8,3,2,4,7]),function(H,e,E,A,n,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class h{constructor(m,g,S,u,y,b){if(this.urlService=g,this.logService=b,this.uris=[],this.retryCount=0,this.flushDisposable=_.Disposable.None,this.disposables=new _.DisposableStore,m&&(b.trace("ElectronURLListener initialUrisToHandle:",m.map(l=>l.originalUrl)),this.uris=m),D.isWindows){const l=u.isBuilt?[]:[`"${u.appRoot}"`];l.push("--open-url","--"),E.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,l)}const c=n.Event.map(n.Event.fromNodeEventEmitter(E.app,"open-url",(l,v)=>({event:l,url:v})),({event:l,url:v})=>(l.preventDefault(),v));this.disposables.add(c(l=>{const v=this.uriFromRawUrl(l);v&&this.urlService.open(v,{originalUrl:l})})),S.getWindows().filter(l=>l.isReady).length>0?(b.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(b.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),n.Event.once(S.onDidSignalReadyWindow)(this.flush,this,this.disposables))}uriFromRawUrl(m){try{return P.URI.parse(m)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const g of this.uris)await this.urlService.open(g.uri,{originalUrl:g.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",g.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",g.originalUrl),m.push(g));m.length!==0&&(this.uris=m,this.flushDisposable=(0,A.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=h}),define(ee[269],te([0,1,3,2,16,56,58,17]),function(H,e,E,A,n,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class h extends A.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(m,g,S,u){super(),this.fileSystemScheme=m,this.fileSystemProvider=g,this.userDataScheme=S,this.logService=u,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new E.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=D.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(y=>this.handleFileChanges(y)))}watch(m,g){this.watchResources.set(m,m);const S=this.fileSystemProvider.watch(this.toFileSystemResource(m),g);return(0,A.toDisposable)(()=>{this.watchResources.delete(m),S.dispose()})}stat(m){return this.fileSystemProvider.stat(this.toFileSystemResource(m))}mkdir(m){return this.fileSystemProvider.mkdir(this.toFileSystemResource(m))}rename(m,g,S){return this.fileSystemProvider.rename(this.toFileSystemResource(m),this.toFileSystemResource(g),S)}readFile(m){return this.fileSystemProvider.readFile(this.toFileSystemResource(m),{atomic:!0})}readFileStream(m,g,S){const u=(0,_.newWriteableStream)(y=>P.VSBuffer.concat(y.map(b=>P.VSBuffer.wrap(b))).buffer);return(async()=>{try{const y=await this.readFile(m);u.end(y)}catch(y){u.error(y),u.end()}})(),u}readdir(m){return this.fileSystemProvider.readdir(this.toFileSystemResource(m))}writeFile(m,g,S){return this.fileSystemProvider.writeFile(this.toFileSystemResource(m),g,S)}delete(m,g){return this.fileSystemProvider.delete(this.toFileSystemResource(m),g)}copy(m,g,S){if((0,n.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(m),this.toFileSystemResource(g),S);throw new Error("copy not supported")}handleFileChanges(m){const g=[];for(const S of m){if(S.resource.scheme!==this.fileSystemScheme)continue;const u=this.toUserDataResource(S.resource);this.watchResources.findSubstr(u)&&g.push({resource:u,type:S.type})}g.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(g))}toFileSystemResource(m){return m.with({scheme:this.fileSystemScheme})}toUserDataResource(m){return m.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=h}),define(ee[270],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(ee[271],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(ee[272],te([0,1,14,2,15,7]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends A.Disposable{static{this.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.handleWebviewRequest.bind(this);E.protocol.registerFileProtocol(n.Schemas.vscodeWebview,h)}handleWebviewRequest(h,d){try{const m=_.URI.parse(h.url),g=D.validWebviewFilePaths.get(m.path);if(typeof g=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${g}`,u=n.FileAccess.asFileUri(S);return d({path:u.fsPath,headers:{...n.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return d({error:-10})}catch{}return d({error:-2})}}e.WebviewProtocolProvider=D}),define(ee[81],te([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(m){return!!m.workspaceUri}e.isWorkspaceToOpen=A;function n(m){return!!m.folderUri}e.isFolderToOpen=n;function _(m){return!!m.fileUri}e.isFileToOpen=_;function D(m){const g=P(m),S=m.getValue("window.menuBarVisibility");return S==="default"||g==="native"&&S==="compact"||E.isMacintosh&&E.isNative?"classic":S}e.getMenuBarVisibility=D;function P(m){if(E.isWeb)return"custom";const g=m.getValue("window");if(g){if(E.isMacintosh&&g.nativeTabs===!0||E.isMacintosh&&g.nativeFullScreen===!1)return"native";const y=g.titleBarStyle;if(y==="native"||y==="custom")return y}return E.isLinux?"native":"custom"}e.getTitleBarStyle=P;function h(m){return!(!E.isWindows||E.isWeb||P(m)==="native")}e.useWindowControlsOverlay=h;function d(m=0){return Math.pow(1.2,m)}e.zoomLevelToZoomFactor=d}),define(ee[129],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(E||(e.LoadReason=E={}));var A;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(A||(e.UnloadReason=A={}));const n=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=n;var _;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(_||(e.WindowMode=_={}));var D;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(ee[29],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var A;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(A||(e.OpenContext=A={}))}),define(ee[273],te([0,1,76,5,33,22,29,217]),function(H,e,E,A,n,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let h=class extends P.BaseCredentialsMainService{constructor(m,g,S,u){super(m),this.environmentMainService=g,this.productService=S,this.windowsMainService=u,this.surfaceKeytarLoadError=y=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",y.message??y)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new E.InMemoryCredentialsProvider,this._keytarCache;const m=await new Promise((g,S)=>{H(["keytar"],g,S)});return await m.findCredentials("test-keytar-loads"),this._keytarCache=m,this._keytarCache}};e.CredentialsNativeMainService=h,e.CredentialsNativeMainService=h=Ee([Y(0,A.ILogService),Y(1,n.INativeEnvironmentService),Y(2,_.IProductService),Y(3,D.IWindowsMainService)],h)}),define(ee[274],te([0,1,14,24,4,7,21,18,63,6,5,128,29]),function(H,e,E,A,n,_,D,P,h,d,m,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,d.createDecorator)(e.ID);let u=class{constructor(b,c,f,l){this.logService=b,this.windowsMainService=c,this.urlService=f,this.configurationService=l}async start(b,c){this.logService.trace("Received data from other instance: ",b,c),n.isMacintosh&&E.app.focus({steal:!0});const f=this.parseOpenUrl(b);if(f.length){let l=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const v=(0,A.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));v&&(l=v.ready())}l.then(()=>{for(const{uri:v,originalUrl:I}of f)this.urlService.open(v,{originalUrl:I})})}else return this.startOpenWindow(b,c)}parseOpenUrl(b){return b["open-url"]&&b._urls&&b._urls.length>0?(0,A.coalesce)(b._urls.map(c=>{try{return{uri:_.URI.parse(c),originalUrl:c}}catch{return null}})):[]}async startOpenWindow(b,c){const f=(0,h.isLaunchedFromCli)(c)?0:4;let l=[];const v=b.wait&&b.waitMarkerFilePath?_.URI.file(b.waitMarkerFilePath):void 0,I=b.remote||void 0,p={context:f,cli:b,userEnv:c,waitMarkerFileURI:v,remoteAuthority:I,forceProfile:b.profile,forceTempProfile:b["profile-temp"]};if(b.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(b.extensionDevelopmentPath,p);else if(!b._.length&&!b["folder-uri"]&&!b["file-uri"]){let t=!1;if(b["new-window"]||b["unity-launch"]||p.forceProfile||p.forceTempProfile)t=!0;else if(b["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!n.isMacintosh}if(t)l=await this.windowsMainService.open({...p,forceNewWindow:!0,forceEmpty:!0});else{const a=this.windowsMainService.getLastActiveWindow();a?(this.windowsMainService.openExistingWindow(a,p),l=[a]):l=await this.windowsMainService.open({...p,forceEmpty:!0})}}else l=await this.windowsMainService.open({...p,forceNewWindow:b["new-window"],preferNewWindow:!b["reuse-window"]&&!b.wait,forceReuseWindow:b["reuse-window"],diffMode:b.diff,mergeMode:b.merge,addMode:b.add,noRecentEntry:!!b["skip-add-to-recently-opened"],gotoLineMode:b.goto});if(v&&l.length===1&&l[0])return Promise.race([l[0].whenClosedOrLoaded,(0,D.whenDeleted)(v.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=u,e.LaunchMainService=u=Ee([Y(0,m.ILogService),Y(1,S.IWindowsMainService),Y(2,g.IURLService),Y(3,P.IConfigurationService)],u)}),define(ee[275],te([0,1,14,3,2,272,29]),function(H,e,E,A,n,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends n.Disposable{constructor(d){super(),this.windowsMainService=d,this._onFoundInFrame=this._register(new A.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new _.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(d,m){let g;if(typeof d.windowId=="number"){const{windowId:S}=d,u=this.windowsMainService.getWindowById(S);if(!u?.win)throw new Error(`Invalid windowId: ${S}`);g=u.win.webContents}else{const{webContentsId:S}=d;if(g=E.webContents.fromId(S),!g)throw new Error(`Invalid webContentsId: ${S}`)}g.isDestroyed()||g.setIgnoreMenuShortcuts(m)}async findInFrame(d,m,g,S){const y=this.getFrameByName(d,m);if(typeof y.findInFrame=="function"){y.findInFrame(g,{findNext:S.findNext,forward:S.forward});const b=(c,f)=>{f.finalUpdate&&(this._onFoundInFrame.fire(f),y.removeListener("found-in-frame",b))};y.on("found-in-frame",b)}}async stopFindInFrame(d,m,g){const u=this.getFrameByName(d,m);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(g.keepSelection?"keepSelection":"clearSelection")}getFrameByName(d,m){const g=this.windowsMainService.getWindowById(d.windowId);if(!g?.win)throw new Error(`Invalid windowId: ${d}`);const S=g.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===m);if(!S)throw new Error(`Unknown frame: ${m}`);return S}};e.WebviewMainService=P,e.WebviewMainService=P=Ee([Y(0,D.IWindowsMainService)],P)}),define(ee[276],te([0,1,8,3,2]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class _ extends n.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:h,getActiveWindowId:d}){super(),this.disposables=this._register(new n.DisposableStore),A.Event.latch(A.Event.any(P,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,E.createCancelablePromise)(()=>d()),(async()=>{try{const g=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:g}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=_}),define(ee[30],te([0,1,190,9,58,19,7,6,15]),function(H,e,E,A,n,_,D,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function d(i){const r=i;return typeof r?.id=="string"&&D.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=d;function m(i){return typeof i?.id=="string"&&!d(i)&&!S(i)}e.isEmptyWorkspaceIdentifier=m,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function g(i,r){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,A.basename)(i)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=g;function S(i){const r=i;return typeof r?.id=="string"&&D.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=S;function u(i){const r=i;if(r?.uri)return{id:r.id,uri:D.URI.revive(r.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=u;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function b(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=b;function c(i){const r=i;return!!(r&&typeof r=="object"&&D.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=c;class f{constructor(r,o,w,k,M){this._id=r,this._transient=w,this._configuration=k,this._ignorePathCasing=M,this._foldersMap=n.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=n.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class l{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,_.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function v(i){return new l({uri:i,index:0,name:(0,_.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(i,r){return _.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}e.isUntitledWorkspace=I;function p(i){let r;return D.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=p,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function a(i,r){return!I(i,r)&&!p(i)}e.isSavedWorkspace=a;function s(i){return(typeof i=="string"?(0,A.extname)(i):(0,_.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ee[61],te([0,1,14,8,57,46,2,86,4,21,165,92,6,5,22,30]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let c=class{constructor(l,v){this.logService=l,this.productService=v,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new A.Queue}pickFileFolder(l,v){return this.doPick({...l,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},v)}pickFolder(l,v){return this.doPick({...l,pickFolders:!0,title:(0,m.localize)(1,null)},v)}pickFile(l,v){return this.doPick({...l,pickFiles:!0,title:(0,m.localize)(2,null)},v)}pickWorkspace(l,v){const I=(0,m.localize)(3,null),p=(0,_.mnemonicButtonLabel)((0,m.localize)(4,null)),t=b.WORKSPACE_FILTER;return this.doPick({...l,pickFiles:!0,title:I,filters:t,buttonLabel:p},v)}async doPick(l,v){const I={title:l.title,buttonLabel:l.buttonLabel,filters:l.filters,defaultPath:l.defaultPath};(typeof l.pickFiles=="boolean"||typeof l.pickFolders=="boolean")&&(I.properties=void 0,l.pickFiles&&l.pickFolders&&(I.properties=["multiSelections","openDirectory","openFile","createDirectory"])),I.properties||(I.properties=["multiSelections",l.pickFolders?"openDirectory":"openFile","createDirectory"]),h.isMacintosh&&I.properties.push("treatPackageAsDirectory");const p=await this.showOpenDialog(I,(v||E.BrowserWindow.getFocusedWindow())??void 0);if(p&&p.filePaths&&p.filePaths.length>0)return p.filePaths}getWindowDialogQueue(l){if(l){let v=this.windowDialogQueues.get(l.id);return v||(v=new A.Queue,this.windowDialogQueues.set(l.id,v)),v}else return this.noWindowDialogueQueue}showMessageBox(l,v){return this.getWindowDialogQueue(v).queue(async()=>{const{options:I,buttonIndeces:p}=(0,g.massageMessageBoxOptions)(l,this.productService);let t;return v?t=await E.dialog.showMessageBox(v,I):t=await E.dialog.showMessageBox(I),{response:p[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(l,v){const I=this.acquireFileDialogLock(l,v);if(!I)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(v).queue(async()=>{let p;return v?p=await E.dialog.showSaveDialog(v,l):p=await E.dialog.showSaveDialog(l),p.filePath=this.normalizePath(p.filePath),p})}finally{(0,D.dispose)(I)}}normalizePath(l){return l&&h.isMacintosh&&(l=(0,P.normalizeNFC)(l)),l}normalizePaths(l){return l.map(v=>this.normalizePath(v))}async showOpenDialog(l,v){l.defaultPath&&(await d.Promises.exists(l.defaultPath)||(l.defaultPath=void 0));const I=this.acquireFileDialogLock(l,v);if(!I)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(v).queue(async()=>{let p;return v?p=await E.dialog.showOpenDialog(v,l):p=await E.dialog.showOpenDialog(l),p.filePaths=this.normalizePaths(p.filePaths),p})}finally{(0,D.dispose)(I)}}acquireFileDialogLock(l,v){if(!v)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",l);let I=this.windowFileDialogLocks.get(v.id);I||(I=new Set,this.windowFileDialogLocks.set(v.id,I));const p=(0,n.hash)(l);if(!I.has(p))return this.logService.trace("[DialogMainService]: new file dialog lock created",l),I.add(p),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",l),I?.delete(p),I?.size===0&&this.windowFileDialogLocks.delete(v.id)})}};e.DialogMainService=c,e.DialogMainService=c=Ee([Y(0,u.ILogService),Y(1,y.IProductService)],c)}),define(ee[277],te([0,1,3,2,74,30]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends A.Disposable{static{this.STORAGE_CHANGE_DEBOUNCE_TIME=100}constructor(h,d){super(),this.logService=h,this.storageMainService=d,this.onDidChangeApplicationStorageEmitter=this._register(new E.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(d.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(h,d){this._register(E.Event.debounce(h.onDidChangeStorage,(m,g)=>(m?m.push(g):m=[g],m),D.STORAGE_CHANGE_DEBOUNCE_TIME)(m=>{m.length&&d.fire(this.serializeStorageChangeEvents(m,h))}))}serializeStorageChangeEvents(h,d){const m=new Map,g=new Set;return h.forEach(S=>{const u=d.get(S.key);typeof u=="string"?m.set(S.key,u):g.add(S.key)}),{changed:Array.from(m.entries()),deleted:Array.from(g.values())}}listen(h,d,m){switch(d){case"onDidChangeStorage":{const g=m.profile?(0,n.revive)(m.profile):void 0;if(!g)return this.onDidChangeApplicationStorageEmitter.event;let S=this.mapProfileToOnDidChangeProfileStorageEmitter.get(g.id);return S||(S=this._register(new E.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(g),S),this.mapProfileToOnDidChangeProfileStorageEmitter.set(g.id,S)),S.event}}throw new Error(`Event not found: ${d}`)}async call(h,d,m){const g=m.profile?(0,n.revive)(m.profile):void 0,S=(0,_.reviveIdentifier)(m.workspace),u=await this.withStorageInitialized(g,S);switch(d){case"getItems":return Array.from(u.items.entries());case"updateItems":{const y=m;if(y.insert)for(const[b,c]of y.insert)u.set(b,c);y.delete?.forEach(b=>u.delete(b));break}case"isUsed":{const y=m.payload;if(typeof y=="string")return this.storageMainService.isUsed(y)}default:throw new Error(`Call not found: ${d}`)}}async withStorageInitialized(h,d){let m;d?m=this.storageMainService.workspaceStorage(d):h?m=this.storageMainService.profileStorage(h):m=this.storageMainService.applicationStorage;try{await m.init()}catch(g){this.logService.error(`StorageIPC#init: Unable to init ${d?"workspace":h?"profile":"application"} storage due to ${g}`)}return m}}e.StorageDatabaseChannel=D}),define(ee[41],te([0,1,57,3,2,19,7,187,33,16,6,5,30,35,40,8,31,26,12]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var v;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(v||(e.ProfileResourceType=v={}));function I(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&D.URI.isUri(r.location)&&D.URI.isUri(r.globalStorageHome)&&D.URI.isUri(r.settingsResource)&&D.URI.isUri(r.keybindingsResource)&&D.URI.isUri(r.tasksResource)&&D.URI.isUri(r.snippetsHome)&&D.URI.isUri(r.extensionsResource))}e.isUserDataProfile=I,e.IUserDataProfilesService=(0,m.createDecorator)("IUserDataProfilesService");function p(i,r){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:D.URI.revive(i.location).with({scheme:r}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:r}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:r}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:r}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:r}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:r}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:r}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:r}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=p;function t(i,r,o,w,k,M){return{id:i,name:r,location:o,isDefault:!1,shortName:k?.shortName,globalStorageHome:M&&k?.useDefaultFlags?.globalState?M.globalStorageHome:(0,_.joinPath)(o,"globalStorage"),settingsResource:M&&k?.useDefaultFlags?.settings?M.settingsResource:(0,_.joinPath)(o,"settings.json"),keybindingsResource:M&&k?.useDefaultFlags?.keybindings?M.keybindingsResource:(0,_.joinPath)(o,"keybindings.json"),tasksResource:M&&k?.useDefaultFlags?.tasks?M.tasksResource:(0,_.joinPath)(o,"tasks.json"),snippetsHome:M&&k?.useDefaultFlags?.snippets?M.snippetsHome:(0,_.joinPath)(o,"snippets"),extensionsResource:M&&k?.useDefaultFlags?.extensions?M.extensionsResource:(0,_.joinPath)(o,"extensions.json"),cacheHome:(0,_.joinPath)(w,i),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.toUserDataProfile=t;let a=class extends n.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(r,o,w,k){super(),this.environmentService=r,this.fileService=o,this.uriIdentityService=w,this.logService=k,this.enabled=!0,this._onDidChangeProfiles=this._register(new A.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new A.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new A.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new A.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new u.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,_.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,_.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const r=this.createDefaultProfile(),o=[r];if(this.enabled)try{for(const M of this.getStoredProfiles()){if(!M.name||!(0,l.isString)(M.name)||!M.location){this.logService.warn("Skipping the invalid stored profile",M.location||M.name);continue}o.push(t((0,_.basename)(M.location),M.name,M.location,this.profilesCacheHome,{shortName:M.shortName,useDefaultFlags:M.useDefaultFlags},r))}}catch(M){this.logService.error(M)}const w=new u.ResourceMap,k=new Map;if(o.length)try{const M=this.getStoredProfileAssociations();if(M.workspaces)for(const[C,L]of Object.entries(M.workspaces)){const T=D.URI.parse(C),F=o.find(B=>B.id===L);F&&w.set(T,F)}if(M.emptyWindows)for(const[C,L]of Object.entries(M.emptyWindows)){const T=o.find(F=>F.id===L);T&&k.set(C,T)}}catch(M){this.logService.error(M)}this._profilesObject={profiles:o,workspaces:w,emptyWindows:k}}return this._profilesObject}createDefaultProfile(){const r=t("__default__profile__",(0,P.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...r,extensionsResource:this.getDefaultProfileExtensionsLocation()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const o="Temp",w=new RegExp(`${(0,f.escapeRegExpCharacters)(o)}\\s(\\d+)`);let k=0;for(const C of this.profiles){const L=w.exec(C.name),T=L?parseInt(L[1]):0;k=T>k?T:k}const M=`${o} ${k+1}`;return this.createProfile((0,E.hash)((0,c.generateUuid)()).toString(16),M,{transient:!0},r)}async createNamedProfile(r,o,w){return this.createProfile((0,E.hash)((0,c.generateUuid)()).toString(16),r,o,w)}async createProfile(r,o,w,k){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const M=await this.doCreateProfile(r,o,w);return k&&await this.setProfileForWorkspace(k,M),M}async doCreateProfile(r,o,w){if(!(0,l.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.profileCreationPromises.get(o);return k||(k=(async()=>{try{const M=this.profiles.find(T=>T.name===o||T.id===r);if(M)return M;const C=t(r,o,(0,_.joinPath)(this.profilesHome,r),this.profilesCacheHome,w,this.defaultProfile);await this.fileService.createFolder(C.location);const L=[];return this._onWillCreateProfile.fire({profile:C,join(T){L.push(T)}}),await b.Promises.settled(L),this.updateProfiles([C],[],[]),C}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,k)),k}async updateProfile(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let w=this.profiles.find(k=>k.id===r.id);if(!w)throw new Error(`Profile '${r.name}' does not exist`);return w=t(w.id,o.name??w.name,w.location,this.profilesCacheHome,{shortName:o.shortName??w.shortName,transient:o.transient??w.isTransient,useDefaultFlags:o.useDefaultFlags??w.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[w]),w}async removeProfile(r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(k=>k.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const w=[];this._onWillRemoveProfile.fire({profile:o,join(k){w.push(k)}});try{await Promise.allSettled(w)}catch(k){this.logService.error(k)}for(const k of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(k)?.id&&this.profilesObject.emptyWindows.delete(k);for(const k of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(k)?.id&&this.profilesObject.workspaces.delete(k);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(k){(0,d.toFileOperationResult)(k)!==1&&this.logService.error(k)}}async setProfileForWorkspace(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const w=this.profiles.find(k=>k.id===o.id);if(!w)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(r,w)}unsetWorkspace(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(r,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(w=>!this.uriIdentityService.extUri.isEqual(w.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}getProfileForWorkspace(r){const o=this.getWorkspace(r);return D.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindows.get(o)??this.profilesObject.emptyWindows.get(o)}getWorkspace(r){return(0,S.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,S.isWorkspaceIdentifier)(r)?r.configPath:r.id}isProfileAssociatedToWorkspace(r){return!!([...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location)))}updateProfiles(r,o,w){const k=[...this.profiles,...r],M=[];this.transientProfilesObject.profiles=[];for(let C of k)C.isDefault||o.some(L=>C.id===L.id)||(C=w.find(L=>C.id===L.id)??C,C.isTransient?this.transientProfilesObject.profiles.push(C):M.push({location:C.location,name:C.name,shortName:C.shortName,useDefaultFlags:C.useDefaultFlags}));this.saveStoredProfiles(M),this._profilesObject=void 0,this.triggerProfilesChanges(r,o,w)}triggerProfilesChanges(r,o,w){this._onDidChangeProfiles.fire({added:r,removed:o,updated:w,all:this.profiles})}updateWorkspaceAssociation(r,o,w){w=o?.isTransient?!0:w,w||this.updateWorkspaceAssociation(r,void 0,!0);const k=this.getWorkspace(r),M=w?this.transientProfilesObject:this.profilesObject;D.URI.isUri(k)?(M.workspaces.delete(k),o&&M.workspaces.set(k,o)):(M.emptyWindows.delete(k),o&&M.emptyWindows.set(k,o)),w||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[w,k]of this.profilesObject.workspaces.entries())r[w.toString()]=k.id;const o={};for(const[w,k]of this.profilesObject.emptyWindows.entries())o[w.toString()]=k.id;this.saveStoredProfileAssociations({workspaces:r,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(r){const o={},w=this.createDefaultProfile();if(r.workspaces)for(const[M,C]of Object.entries(r.workspaces)){const L=D.URI.parse(C);o[M]=this.uriIdentityService.extUri.isEqual(L,w.location)?w.id:this.uriIdentityService.extUri.basename(L)}const k={};if(r.emptyWindows)for(const[M,C]of Object.entries(r.emptyWindows)){const L=D.URI.parse(C);k[M]=this.uriIdentityService.extUri.isEqual(L,w.location)?w.id:this.uriIdentityService.extUri.basename(L)}return{workspaces:o,emptyWindows:k}}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=a,e.UserDataProfilesService=a=Ee([Y(0,h.IEnvironmentService),Y(1,d.IFileService),Y(2,y.IUriIdentityService),Y(3,g.ILogService)],a);class s extends a{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(r){this.storedProfiles=r}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(r){this.storedProfileAssociations=r}}e.InMemoryUserDataProfilesService=s}),define(ee[82],te([0,1,8,17,2,3,35,7,117,124,16,6,5,41,40,12,13,25]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var l;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(l||(e.ExtensionsProfileScanningErrorCode=l={}));class v extends Error{constructor(s,i){super(s),this.code=i}}e.ExtensionsProfileScanningError=v,e.IExtensionsProfileScannerService=(0,g.createDecorator)("IExtensionsProfileScannerService");let I=class extends n.Disposable{constructor(s,i,r,o,w,k){super(),this.extensionsLocation=s,this.fileService=i,this.userDataProfilesService=r,this.uriIdentityService=o,this.telemetryService=w,this.logService=k,this._onAddExtensions=this._register(new _.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new _.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new _.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new _.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new D.ResourceMap}scanProfileExtensions(s,i){return this.withProfileExtensions(s,void 0,i)}async addExtensionsToProfile(s,i){const r=[],o=[];try{return await this.withProfileExtensions(i,w=>{const k=[];for(const M of w)s.some(([C])=>(0,d.areSameExtensions)(C.identifier,M.identifier)&&C.manifest.version!==M.version)?r.push(M):k.push(M);for(const[M,C]of s){const L=k.findIndex(F=>(0,d.areSameExtensions)(F.identifier,M.identifier)&&F.version===M.manifest.version),T={identifier:M.identifier,version:M.manifest.version,location:M.location,metadata:C};L===-1?(o.push(T),k.push(T)):k.splice(L,1,T)}return o.length&&this._onAddExtensions.fire({extensions:o,profileLocation:i}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:i}),k}),o.length&&this._onDidAddExtensions.fire({extensions:o,profileLocation:i}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:i}),o}catch(w){throw o.length&&this._onDidAddExtensions.fire({extensions:o,error:w,profileLocation:i}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:w,profileLocation:i}),w}}async updateMetadata(s,i){const r=[];return await this.withProfileExtensions(i,o=>{const w=[];for(const k of o){const M=s.find(([C])=>(0,d.areSameExtensions)(C.identifier,k.identifier)&&C.manifest.version===k.version);M&&(k.metadata={...k.metadata,...M[1]},r.push(k)),w.push(k)}return w}),r}async removeExtensionFromProfile(s,i){const r=[];try{await this.withProfileExtensions(i,o=>{const w=[];for(const k of o)(0,d.areSameExtensions)(k.identifier,s.identifier)?r.push(k):w.push(k);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:i}),w}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:i})}catch(o){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:o,profileLocation:i}),o}}async withProfileExtensions(s,i,r){return this.getResourceAccessQueue(s).queue(async()=>{let o=[],w;try{const k=await this.fileService.readFile(s);w=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,m.toFileOperationResult)(k)!==1)throw k;if(this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)&&(w=await this.migrateFromOldDefaultProfileExtensionsLocation()),!w&&r?.bailOutWhenFileNotFound)throw new v((0,c.getErrorMessage)(k),"ERROR_PROFILE_NOT_FOUND")}if(w){Array.isArray(w)||this.reportAndThrowInvalidConentError(s);let k=!1;for(const M of w){p(M)||this.reportAndThrowInvalidConentError(s);let C;if((0,b.isString)(M.relativeLocation)&&M.relativeLocation)C=this.resolveExtensionLocation(M.relativeLocation);else if((0,b.isString)(M.location))C=this.resolveExtensionLocation(M.location),k=!0,M.relativeLocation=M.location,M.location=C.toJSON();else{C=P.URI.revive(M.location);const L=this.toRelativePath(C);L&&(k=!0,M.relativeLocation=L)}o.push({identifier:M.identifier,location:C,version:M.version,metadata:M.metadata})}k&&await this.fileService.writeFile(s,A.VSBuffer.fromString(JSON.stringify(w)))}if(i){o=i(o);const k=o.map(M=>({identifier:M.identifier,version:M.version,location:M.location.toJSON(),relativeLocation:this.toRelativePath(M.location),metadata:M.metadata}));await this.fileService.writeFile(s,A.VSBuffer.fromString(JSON.stringify(k)))}return o})}reportAndThrowInvalidConentError(s){const i=new v(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(s){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(s),this.extensionsLocation)?this.uriIdentityService.extUri.basename(s):void 0}resolveExtensionLocation(s){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,s)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const s=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let r;try{r=(await this.fileService.readFile(s)).value.toString()}catch(w){if((0,m.toFileOperationResult)(w)===1)return;throw w}this.logService.info("Migrating extensions from old default profile location",s.toString());let o;try{const w=JSON.parse(r);Array.isArray(w)&&w.every(k=>p(k))?o=w:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",w)}catch(w){this.logService.error(w)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(w){if((0,m.toFileOperationResult)(w)===3)this.logService.info("Migration from old default profile location to new location is done by another window",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw w}try{await this.fileService.del(s)}catch(w){(0,m.toFileOperationResult)(w)!==1&&this.logService.error(w)}try{await this.fileService.del(i)}catch(w){(0,m.toFileOperationResult)(w)!==1&&this.logService.error(w)}return o})()),this._migrationPromise}getResourceAccessQueue(s){let i=this.resourcesAccessQueueMap.get(s);return i||(i=new E.Queue,this.resourcesAccessQueueMap.set(s,i)),i}};e.AbstractExtensionsProfileScannerService=I,e.AbstractExtensionsProfileScannerService=I=Ee([Y(1,m.IFileService),Y(2,u.IUserDataProfilesService),Y(3,y.IUriIdentityService),Y(4,f.ITelemetryService),Y(5,S.ILogService)],I);function p(a){return(0,b.isObject)(a)&&(0,h.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,b.isString)(a.location)&&a.location)&&((0,b.isUndefined)(a.relativeLocation)||(0,b.isString)(a.relativeLocation))&&a.version&&(0,b.isString)(a.version)}function t(a){return a?(0,b.isString)(a.path)&&(0,b.isString)(a.scheme):!1}}),define(ee[130],te([0,1,24,8,37,17,13,44,151,2,15,9,4,19,203,70,12,7,170,33,124,121,202,16,6,5,22,3,74,82,41,40,201]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f,l,v,I,p,t,a,s,i,r,o,w,k,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var T;(function(ue){function x(G,z){if(G===z)return!0;const W=Object.keys(G),U=new Set;for(const $ of Object.keys(z))U.add($);if(W.length!==U.size)return!1;for(const $ of W){if(G[$]!==z[$])return!1;U.delete($)}return U.size===0}ue.equals=x})(T||(e.Translations=T={})),e.IExtensionsScannerService=(0,s.createDecorator)("IExtensionsScannerService");let F=class extends d.Disposable{constructor(x,G,z,W,U,$,X,oe,ce,V,R,O){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=G,this.extensionsControlLocation=z,this.currentProfile=W,this.userDataProfilesService=U,this.extensionsProfileScannerService=$,this.fileService=X,this.logService=oe,this.environmentService=ce,this.productService=V,this.uriIdentityService=R,this.instantiationService=O,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,u.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ie,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ie,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(se,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,I.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(x,G,z){const[W,U]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(G)]),$=z?await this.scanExtensionsUnderDevelopment(x,[...W,...U]):[];return this.dedupExtensions(W,U,$,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const G=[];G.push(this.scanDefaultSystemExtensions(!!x.useCache,x.language)),G.push(this.scanDevSystemExtensions(x.language,!!x.checkControlFile));const[z,W]=await Promise.all(G);return this.applyScanOptions([...z,...W],0,x,!1)}async scanUserExtensions(x){const G=x.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",G);const z=this.uriIdentityService.extUri.isEqual(x.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.createExtensionScannerInput(G,!!x.profileLocation,1,!x.includeUninstalled,x.language,!0,z),U=x.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let $;try{$=await U.scanExtensions(W)}catch(X){if(X instanceof k.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),$=await U.scanExtensions(W);else throw X}return $=await this.applyScanOptions($,1,x,!0),this.logService.trace("Scanned user extensions:",$.length),$}async scanExtensionsUnderDevelopment(x,G){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const z=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===m.Schemas.file).map(async W=>{const U=await this.createExtensionScannerInput(W,!1,1,!0,x.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(U)).map(X=>(X.type=G.find(oe=>(0,I.areSameExtensions)(oe.identifier,X.identifier))?.type??X.type,this.extensionsScanner.validate(X,U)))}))).flat();return this.applyScanOptions(z,"development",x,!0)}return[]}async scanExistingExtension(x,G,z){const W=await this.createExtensionScannerInput(x,!1,G,!0,z.language,!0,void 0),U=await this.extensionsScanner.scanExtension(W);return!U||!z.includeInvalid&&!U.isValid?null:U}async scanOneOrMultipleExtensions(x,G,z){const W=await this.createExtensionScannerInput(x,!1,G,!0,z.language,!0,void 0),U=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(U,G,z,!0)}async scanMetadata(x){const G=(0,u.joinPath)(x,"package.json"),z=(await this.fileService.readFile(G)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(x,G){const z=(0,u.joinPath)(x,"package.json"),W=(await this.fileService.readFile(z)).value.toString(),U=JSON.parse(W);G.isMachineScoped=G.isMachineScoped||void 0,G.isBuiltin=G.isBuiltin||void 0,U.__metadata={...U.__metadata,...G},await this.fileService.writeFile((0,u.joinPath)(x,"package.json"),_.VSBuffer.fromString(JSON.stringify(U,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof k.ExtensionsProfileScanningError&&x.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw x}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.extensionsProfileScannerService.addExtensionsToProfile(x.map(G=>[G,G.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,_.VSBuffer.fromString(JSON.stringify([])))}catch(G){(0,a.toFileOperationResult)(G)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(G))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.logService.error(x)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(x,G,z,W){return z.includeAllVersions||(x=this.dedupExtensions(G===0?x:void 0,G===1?x:void 0,G==="development"?x:void 0,await this.getTargetPlatform(),W)),z.includeInvalid||(x=x.filter(U=>U.isValid)),x.sort((U,$)=>{const X=g.basename(U.location.fsPath),oe=g.basename($.location.fsPath);return X<oe?-1:X>oe?1:0})}dedupExtensions(x,G,z,W,U){const $=(oe,ce,V)=>{if(oe.isValid&&!ce.isValid)return!1;if(oe.isValid===ce.isValid){if(U&&y.gt(oe.manifest.version,ce.manifest.version))return this.logService.debug(`Skipping extension ${ce.location.path} with lower version ${ce.manifest.version} in favour of ${oe.location.path} with version ${oe.manifest.version}`),!1;if(y.eq(oe.manifest.version,ce.manifest.version)){if(oe.type===0)return this.logService.debug(`Skipping extension ${ce.location.path} in favour of system extension ${oe.location.path} with same version`),!1;if(oe.targetPlatform===W)return this.logService.debug(`Skipping extension ${ce.location.path} from different target platform ${ce.targetPlatform}`),!1}}return V?this.logService.warn(`Overwriting user extension ${oe.location.path} with ${ce.location.path}.`):this.logService.debug(`Overwriting user extension ${oe.location.path} with ${ce.location.path}.`),!0},X=new p.ExtensionIdentifierMap;return x?.forEach(oe=>{const ce=X.get(oe.identifier.id);(!ce||$(ce,oe,!1))&&X.set(oe.identifier.id,oe)}),G?.forEach(oe=>{const ce=X.get(oe.identifier.id);if(!ce&&x&&oe.type===0){this.logService.debug(`Skipping obsolete system extension ${oe.location.path}.`);return}(!ce||$(ce,oe,!1))&&X.set(oe.identifier.id,oe)}),z?.forEach(oe=>{const ce=X.get(oe.identifier.id);(!ce||$(ce,oe,!0))&&X.set(oe.identifier.id,oe),X.set(oe.identifier.id,oe)}),[...X.values()]}async scanDefaultSystemExtensions(x,G){this.logService.trace("Started scanning system extensions");const z=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0),U=await(x&&!z.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return this.logService.trace("Scanned system extensions:",U.length),U}async scanDevSystemExtensions(x,G){const z=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!z?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=G?await this.getBuiltInExtensionControl():{},U=[],$=f.URI.file(g.normalize(g.join(m.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const oe of z){const ce=W[oe.name]||"marketplace";switch(ce){case"disabled":break;case"marketplace":U.push((0,u.joinPath)($,oe.name));break;default:U.push(f.URI.file(ce));break}}const X=await Promise.all(U.map(async oe=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(oe,!1,0,!0,x,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",X.length),(0,E.coalesce)(X)}async getBuiltInExtensionControl(){try{const x=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(x.value.toString())}catch{return{}}}async createExtensionScannerInput(x,G,z,W,U,$,X){const oe=await this.getTranslations(U??S.language),ce=await this.getMtime(x),V=G&&!this.uriIdentityService.extUri.isEqual(x,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,R=V?await this.getMtime(V):void 0;return new B(x,ce,V,R,G,X,z,W,$,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,U,oe)}async getMtime(x){try{const G=await this.fileService.stat(x);if(typeof G.mtime=="number")return G.mtime}catch{}}};e.AbstractExtensionsScannerService=F,e.AbstractExtensionsScannerService=F=Ee([Y(4,M.IUserDataProfilesService),Y(5,k.IExtensionsProfileScannerService),Y(6,a.IFileService),Y(7,i.ILogService),Y(8,v.IEnvironmentService),Y(9,r.IProductService),Y(10,C.IUriIdentityService),Y(11,s.IInstantiationService)],F);class B{constructor(x,G,z,W,U,$,X,oe,ce,V,R,O,N,q,re){this.location=x,this.mtime=G,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=W,this.profile=U,this.profileScanOptions=$,this.type=X,this.excludeObsolete=oe,this.validate=ce,this.productVersion=V,this.productDate=R,this.productCommit=O,this.devMode=N,this.language=q,this.translations=re}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,G){return(0,u.isEqual)(x.location,G.location)&&x.mtime===G.mtime&&(0,u.isEqual)(x.applicationExtensionslocation,G.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&x.profile===G.profile&&n.equals(x.profileScanOptions,G.profileScanOptions)&&x.type===G.type&&x.excludeObsolete===G.excludeObsolete&&x.validate===G.validate&&x.productVersion===G.productVersion&&x.productDate===G.productDate&&x.productCommit===G.productCommit&&x.devMode===G.devMode&&x.language===G.language&&T.equals(x.translations,G.translations)}}e.ExtensionScannerInput=B;let se=class extends d.Disposable{constructor(x,G,z,W,U){super(),this.obsoleteFile=x,this.extensionsProfileScannerService=G,this.uriIdentityService=z,this.fileService=W,this.logService=U}async scanExtensions(x){const G=x.profile?await this.scanExtensionsFromProfile(x):await this.scanExtensionsFromLocation(x);let z={};if(x.excludeObsolete&&x.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();z=JSON.parse(W)}catch{}return(0,c.isEmptyObject)(z)?G:G.filter(W=>!z[I.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(x){const G=await this.fileService.resolve(x.location);if(!G.children?.length)return[];const z=await Promise.all(G.children.map(async W=>{if(!W.isDirectory||x.type===1&&(0,u.basename)(W.resource).indexOf(".")===0)return null;const U=new B(W.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(U)}));return(0,E.coalesce)(z).sort((W,U)=>W.location.path<U.location.path?-1:1)}async scanExtensionsFromProfile(x){let G=await this.scanExtensionsFromProfileResource(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(x.location,x.applicationExtensionslocation)){G=G.filter(W=>!W.metadata?.isApplicationScoped);const z=await this.scanExtensionsFromProfileResource(x.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,x);G.push(...z)}return G}async scanExtensionsFromProfileResource(x,G,z){const W=await this.extensionsProfileScannerService.scanProfileExtensions(x,z.profileScanOptions);if(!W.length)return[];const U=await Promise.all(W.map(async $=>{if(G($)){const X=new B($.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(X,$.metadata)}return null}));return(0,E.coalesce)(U)}async scanOneOrMultipleExtensions(x){try{if(await this.fileService.exists((0,u.joinPath)(x.location,"package.json"))){const G=await this.scanExtension(x);return G?[G]:[]}else return await this.scanExtensions(x)}catch(G){return this.logService.error(`Error scanning extensions at ${x.location.path}:`,(0,D.getErrorMessage)(G)),[]}}async scanExtension(x,G){try{let z=await this.scanExtensionManifest(x.location);if(z){z.publisher||(z.publisher=p.UNDEFINED_PUBLISHER),G=G??z.__metadata,delete z.__metadata;const W=(0,I.getGalleryExtensionId)(z.publisher,z.name),U=G?.id?{id:W,uuid:G.id}:{id:W},$=G?.isSystem?0:x.type,X=$===0||!!G?.isBuiltin;z=await this.translateManifest(x.location,z,B.createNlsConfiguration(x));const oe={type:$,identifier:U,manifest:z,location:x.location,isBuiltin:X,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return x.validate?this.validate(oe,x):oe}}catch(z){x.type!==0&&this.logService.error(z)}return null}validate(x,G){let z=!0;const W=(0,t.validateExtensionManifest)(G.productVersion,G.productDate,G.location,x.manifest,x.isBuiltin);for(const[U,$]of W)U===b.default.Error&&(z=!1,this.logService.error(this.formatMessage(G.location,$)));return x.isValid=z,x.validations=W,x}async scanExtensionManifest(x){const G=(0,u.joinPath)(x,"package.json");let z;try{z=(await this.fileService.readFile(G)).value.toString()}catch(U){return(0,a.toFileOperationResult)(U)!==1&&this.logService.error(this.formatMessage(x,(0,l.localize)(0,null,G.path,U.message))),null}let W;try{W=JSON.parse(z)}catch{const $=[];(0,P.parse)(z,$);for(const X of $)this.logService.error(this.formatMessage(x,(0,l.localize)(1,null,G.path,X.offset,X.length,(0,h.getParseErrorMessage)(X.error))));return null}return(0,P.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(x,(0,l.localize)(2,null,G.path))),null):W}async translateManifest(x,G,z){const W=await this.getLocalizedMessages(x,G,z);if(W)try{const U=[],$=await this.resolveOriginalMessageBundle(W.default,U);if(U.length>0)return U.forEach(oe=>{this.logService.error(this.formatMessage(x,(0,l.localize)(3,null,W.default?.path,(0,h.getParseErrorMessage)(oe.error))))}),G;if((0,P.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(x,(0,l.localize)(4,null,W.default?.path))),G;const X=W.values||Object.create(null);return(0,L.localizeManifest)(G,X,$)}catch{}return G}async getLocalizedMessages(x,G,z){const W=(0,u.joinPath)(x,"package.nls.json"),U=(ce,V)=>{V.forEach(R=>{this.logService.error(this.formatMessage(x,(0,l.localize)(5,null,ce?.path,(0,h.getParseErrorMessage)(R.error))))})},$=ce=>{this.logService.error(this.formatMessage(x,(0,l.localize)(6,null,ce?.path)))},X=`${G.publisher}.${G.name}`,oe=z.translations[X];if(oe)try{const ce=f.URI.file(oe),V=(await this.fileService.readFile(ce)).value.toString(),R=[],O=(0,P.parse)(V,R);return R.length>0?(U(ce,R),{values:void 0,default:W}):(0,P.getNodeType)(O)!=="object"?($(ce),{values:void 0,default:W}):{values:O.contents?O.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let V;try{V=await this.findMessageBundles(x,z)}catch{return}if(!V.localized)return{values:void 0,default:V.original};try{const R=(await this.fileService.readFile(V.localized)).value.toString(),O=[],N=(0,P.parse)(R,O);return O.length>0?(U(V.localized,O),{values:void 0,default:V.original}):(0,P.getNodeType)(N)!=="object"?($(V.localized),{values:void 0,default:V.original}):{values:N,default:V.original}}catch{return{values:void 0,default:V.original}}}}async resolveOriginalMessageBundle(x,G){if(x)try{const z=(await this.fileService.readFile(x)).value.toString();return(0,P.parse)(z,G)}catch{}}findMessageBundles(x,G){return new Promise((z,W)=>{const U=$=>{const X=(0,u.joinPath)(x,`package.nls.${$}.json`);this.fileService.exists(X).then(oe=>{oe&&z({localized:X,original:(0,u.joinPath)(x,"package.nls.json")});const ce=$.lastIndexOf("-");ce===-1?z({localized:(0,u.joinPath)(x,"package.nls.json"),original:null}):($=$.substring(0,ce),U($))})};if(G.devMode||G.pseudo||!G.language)return z({localized:(0,u.joinPath)(x,"package.nls.json"),original:null});U(G.language)})}formatMessage(x,G){return`[${x.path}]: ${G}`}};se=Ee([Y(1,k.IExtensionsProfileScannerService),Y(2,C.IUriIdentityService),Y(3,a.IFileService),Y(4,i.ILogService)],se);let ie=class extends se{constructor(x,G,z,W,U,$,X){super(G,W,U,$,X),this.currentProfile=x,this.userDataProfilesService=z,this.cacheValidatorThrottler=this._register(new A.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(x){const G=this.getCacheFile(x),z=await this.readExtensionCache(G);if(this.input=x,z&&z.input&&B.equals(z.input,this.input))return this.logService.debug("Using cached extensions scan result",x.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(U=>(U.location=f.URI.revive(U.location),U));const W=await super.scanExtensions(x);return await this.writeExtensionCache(G,{input:x,result:W}),W}async readExtensionCache(x){try{const G=await this.fileService.readFile(x),z=JSON.parse(G.value.toString());return{result:z.result,input:(0,w.revive)(z.input)}}catch(G){this.logService.debug("Error while reading the extension cache file:",x.path,(0,D.getErrorMessage)(G))}return null}async writeExtensionCache(x,G){try{await this.fileService.writeFile(x,_.VSBuffer.fromString(JSON.stringify(G)))}catch(z){this.logService.debug("Error while writing the extension cache file:",x.path,(0,D.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const x=this.getCacheFile(this.input),G=await this.readExtensionCache(x);if(!G)return;const z=G.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!n.equals(W,z))try{this.logService.info("Invalidating Cache",z,W),await this.fileService.del(x),this._onDidChangeCache.fire()}catch(U){this.logService.error(U)}}getCacheFile(x){const G=this.getProfile(x);return this.uriIdentityService.extUri.joinPath(G.cacheHome,x.type===0?p.BUILTIN_MANIFEST_CACHE_FILE:p.USER_MANIFEST_CACHE_FILE)}getProfile(x){return x.type===0?this.userDataProfilesService.defaultProfile:x.profile?this.uriIdentityService.extUri.isEqual(x.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(G=>this.uriIdentityService.extUri.isEqual(x.location,G.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};ie=Ee([Y(2,M.IUserDataProfilesService),Y(3,k.IExtensionsProfileScannerService),Y(4,C.IUriIdentityService),Y(5,a.IFileService),Y(6,i.ILogService)],ie);function de(ue,x){const G=(0,I.getExtensionId)(ue.manifest.publisher,ue.manifest.name);return{id:G,identifier:new p.ExtensionIdentifier(G),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:x,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.toExtensionDescription=de;class ae extends F{constructor(x,G,z,W,U,$,X,oe,ce,V,R,O){super(x,G,(0,u.joinPath)(z,".vscode-oss-dev","extensions","control.json"),W,U,$,X,oe,ce,V,R,O),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const N=await this.fileService.readFile(f.URI.file(S.translationsConfigFile));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}getTranslations(x){return this.translationsPromise}}e.NativeExtensionsScannerService=ae}),define(ee[278],te([0,1,5,41,40,25,82,16,33,7]),function(H,e,E,A,n,_,D,P,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let m=class extends D.AbstractExtensionsProfileScannerService{constructor(S,u,y,b,c,f){super(d.URI.file(S.extensionsPath),u,y,b,c,f)}};e.ExtensionsProfileScannerService=m,e.ExtensionsProfileScannerService=m=Ee([Y(0,h.INativeEnvironmentService),Y(1,P.IFileService),Y(2,A.IUserDataProfilesService),Y(3,n.IUriIdentityService),Y(4,_.ITelemetryService),Y(5,E.ILogService)],m)}),define(ee[279],te([0,1,7,33,82,130,16,6,5,22,40,41]),function(H,e,E,A,n,_,D,P,h,d,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let S=class extends _.NativeExtensionsScannerService{constructor(y,b,c,f,l,v,I,p){super(E.URI.file(l.builtinExtensionsPath),E.URI.file(l.extensionsPath),l.userHome,y.defaultProfile,y,b,c,f,l,v,I,p)}};e.ExtensionsScannerService=S,e.ExtensionsScannerService=S=Ee([Y(0,g.IUserDataProfilesService),Y(1,n.IExtensionsProfileScannerService),Y(2,D.IFileService),Y(3,h.ILogService),Y(4,A.INativeEnvironmentService),Y(5,d.IProductService),Y(6,m.IUriIdentityService),Y(7,P.IInstantiationService)],S)}),define(ee[280],te([0,1,14,2,15,9,4,58,7,31,38,33,5,41]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let y=class extends A.Disposable{constructor(c,f,l){super(),this.environmentService=c,this.logService=l,this.validRoots=P.TernarySearchTree.forPaths(!D.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(c.appRoot),this.addValidFileRoot(c.extensionsPath),this.addValidFileRoot(f.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(c.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:c}=E.session;c.protocol.registerFileProtocol(n.Schemas.vscodeFileResource,(f,l)=>this.handleResourceRequest(f,l)),c.protocol.interceptFileProtocol(n.Schemas.file,(f,l)=>this.handleFileRequest(f,l)),this._register((0,A.toDisposable)(()=>{c.protocol.unregisterProtocol(n.Schemas.vscodeFileResource),c.protocol.uninterceptProtocol(n.Schemas.file)}))}addValidFileRoot(c){const f=(0,_.normalize)(c);return this.validRoots.get(f)?A.Disposable.None:(this.validRoots.set(f,!0),(0,A.toDisposable)(()=>this.validRoots.delete(f)))}handleFileRequest(c,f){const l=h.URI.parse(c.url);return this.logService.error(`Refused to load resource ${l.fsPath} from ${n.Schemas.file}: protocol (original URL: ${c.url})`),f({error:-3})}handleResourceRequest(c,f){const l=this.requestToNormalizedFilePath(c);let v;return this.environmentService.crossOriginIsolated&&((0,_.basename)(l)==="workbench.html"||(0,_.basename)(l)==="workbench-dev.html"?v=n.COI.CoopAndCoep:v=n.COI.getHeadersFromQuery(c.url)),this.validRoots.findSubstr(l)?f({path:l,headers:v}):this.validExtensions.has((0,_.extname)(l).toLowerCase())?f({path:l}):(this.logService.error(`${n.Schemas.vscodeFileResource}: Refused to load resource ${l} from ${n.Schemas.vscodeFileResource}: protocol (original URL: ${c.url})`),f({error:-3}))}requestToNormalizedFilePath(c){const f=h.URI.parse(c.url),l=n.FileAccess.uriToFileUri(f);return(0,_.normalize)(l.fsPath)}createIPCObjectUrl(){let c;const f=h.URI.from({scheme:"vscode",path:(0,d.generateUuid)()}),l=f.toString(),v=async()=>c;return m.validatedIpcMain.handle(l,v),this.logService.trace(`IPC Object URL: Registered new channel ${l}.`),{resource:f,update:I=>c=I,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${l}.`),m.validatedIpcMain.removeHandler(l)}}}};e.ProtocolMainService=y,e.ProtocolMainService=y=Ee([Y(0,g.INativeEnvironmentService),Y(1,u.IUserDataProfilesService),Y(2,S.ILogService)],y)}),define(ee[97],te([0,1,8,3,2,65,12,112,6,41]),function(H,e,E,A,n,_,D,P,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var m;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var g;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(g||(e.StorageScope=g={}));var S;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(S||(e.StorageTarget=S={}));function u(l){const v=l.get(e.TARGET_KEY);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}e.loadKeyTargets=u;class y extends n.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(v={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super(),this.options=v,this._onDidChangeValue=this._register(new A.PauseableEmitter),this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new E.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new n.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(v,I,p){return A.Event.filter(this._onDidChangeValue.event,t=>t.scope===v&&(I===void 0||t.key===I),p)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,E.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,n.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,_.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,_.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,I){const{key:p,external:t}=I;if(p===e.TARGET_KEY){switch(v){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:v})}else this._onDidChangeValue.fire({scope:v,key:p,target:this.getKeyTargets(v)[p],external:t})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,I,p){return this.getStorage(I)?.get(v,p)}getBoolean(v,I,p){return this.getStorage(I)?.getBoolean(v,p)}getNumber(v,I,p){return this.getStorage(I)?.getNumber(v,p)}getObject(v,I,p){return this.getStorage(I)?.getObject(v,p)}storeAll(v,I){this.withPausedEmitters(()=>{for(const p of v)this.store(p.key,p.value,p.scope,p.target,I)})}store(v,I,p,t,a=!1){if((0,D.isUndefinedOrNull)(I)){this.remove(v,p,a);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,p,t),this.getStorage(p)?.set(v,I,a)})}remove(v,I,p=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(v,I,void 0),this.getStorage(I)?.delete(v,p)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,I){const p=[],t=this.getKeyTargets(v);for(const a of Object.keys(t))t[a]===I&&p.push(a);return p}updateKeyTarget(v,I,p,t=!1){const a=this.getKeyTargets(I);typeof p=="number"?a[v]!==p&&(a[v]=p,this.getStorage(I)?.set(e.TARGET_KEY,JSON.stringify(a),t)):typeof a[v]=="number"&&(delete a[v],this.getStorage(I)?.set(e.TARGET_KEY,JSON.stringify(a),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(v){switch(v){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(v){const I=this.getStorage(v);return I?u(I):Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=m.NONE){this._onWillSaveState.fire({reason:v});const I=this.getStorage(-1),p=this.getStorage(0),t=this.getStorage(1);switch(v){case m.NONE:await E.Promises.settled([I?.whenFlushed()??Promise.resolve(),p?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await E.Promises.settled([I?.flush(0)??Promise.resolve(),p?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.getStorage(-1)?.items??new Map,I=this.getStorage(0)?.items??new Map,p=this.getStorage(1)?.items??new Map;return f(v,I,p,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(v,I){return this.emitWillSaveState(m.NONE),(0,d.isUserDataProfile)(v)?this.switchToProfile(v,I):this.switchToWorkspace(v,I)}canSwitchProfile(v,I){return!(v.id===I.id||b(I)&&b(v))}switchData(v,I,p){this.withPausedEmitters(()=>{const t=new Set;for(const[a,s]of v)t.add(a),I.get(a)!==s&&this.emitDidChangeValue(p,{key:a,external:!0});for(const[a]of I.items)t.has(a)||this.emitDidChangeValue(p,{key:a,external:!0})})}}e.AbstractStorageService=y;function b(l){return l.isDefault||!!l.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=b;class c extends y{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.profileStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),this._register(this.applicationStorage.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v)))}getStorage(v){switch(v){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(v){return!1}}e.InMemoryStorageService=c;async function f(l,v,I,p,t,a){const s=T=>{try{return JSON.parse(T)}catch{return T}},i=new Map,r=new Map;l.forEach((T,F)=>{i.set(F,T),r.set(F,s(T))});const o=new Map,w=new Map;v.forEach((T,F)=>{o.set(F,T),w.set(F,s(T))});const k=new Map,M=new Map;I.forEach((T,F)=>{k.set(F,T),M.set(F,s(T))}),console.group(p!==t?`Storage: Application (path: ${p})`:`Storage: Application & Profile (path: ${p}, default profile)`);const C=[];if(i.forEach((T,F)=>{C.push({key:F,value:T})}),console.table(C),console.groupEnd(),console.log(r),p!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const T=[];o.forEach((F,B)=>{T.push({key:B,value:F})}),console.table(T),console.groupEnd(),console.log(w)}console.group(`Storage: Workspace (path: ${a})`);const L=[];k.forEach((T,F)=>{L.push({key:F,value:T})}),console.table(L),console.groupEnd(),console.log(M)}e.logStorage=f}),define(ee[281],te([0,1,24,8,3,2,9,69,7,21,112,159,5,97,25,30]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class c extends _.Disposable{static{this.LOG_SLOW_CLOSE_THRESHOLD=2e3}get storage(){return this._storage}constructor(a,s){super(),this.logService=a,this.fileService=s,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new m.Storage(new m.InMemoryStorageDatabase,{hint:m.StorageHint.STORAGE_IN_MEMORY}),this.initializePromise=void 0,this.whenInitPromise=new A.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=m.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===m.StorageState.None)try{const a=await this.doCreate();this._storage.dispose(),this._storage=a,this._register(a.onDidChangeStorage(i=>this._onDidChangeStorage.fire(i))),await this.doInit(a);const s=a.getBoolean(u.IS_NEW_KEY);s===void 0?a.set(u.IS_NEW_KEY,!0):s&&a.set(u.IS_NEW_KEY,!1)}catch(a){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.state=m.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?a=>this.logService.trace(a):void 0,logError:a=>this.logService.error(a)}}doInit(a){return a.init()}get items(){return this._storage.items}get(a,s){return this._storage.get(a,s)}set(a,s){return this._storage.set(a,s)}delete(a){return this._storage.delete(a)}async close(){const a=new P.StopWatch(!1);await this.doClose(),a.stop(),a.elapsed()>c.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(a),this._onDidCloseStorage.fire()}async logSlowClose(a){if(this.path)try{const s=(0,E.top)(Array.from(this._storage.items.entries()).map(([r,o])=>({key:r,length:o.length})),(r,o)=>o.length-r.length,5).map(r=>`${r.key}:${r.length}`).join(", "),i=(await this.fileService.stat(h.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${i}b, Large Keys: ${s}`)}catch(s){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",s)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=m.StorageState.Closed,await this._storage.close()}}class f extends c{static{this.STORAGE_NAME="state.vscdb"}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,f.STORAGE_NAME)}constructor(a,s,i,r){super(i,r),this.profile=a,this.options=s}async doCreate(){return new m.Storage(new g.SQLiteStorageDatabase(this.path??g.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:m.StorageHint.STORAGE_IN_MEMORY})}}class l extends f{constructor(a,s,i,r){super(a,s,i,r)}}e.ProfileStorageMain=l;class v extends f{constructor(a,s,i,r){super(s.defaultProfile,a,i,r)}async doInit(a){await super.doInit(a),this.updateTelemetryState(a)}updateTelemetryState(a){a.get(y.firstSessionDateStorageKey,void 0)===void 0&&a.set(y.firstSessionDateStorageKey,new Date().toUTCString());const i=a.get(y.currentSessionDateStorageKey,void 0),r=new Date().toUTCString();a.set(y.lastSessionDateStorageKey,typeof i>"u"?null:i),a.set(y.currentSessionDateStorageKey,r)}}e.ApplicationStorageMain=v;class I extends c{static{this.WORKSPACE_STORAGE_NAME="state.vscdb"}static{this.WORKSPACE_META_NAME="workspace.json"}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,I.WORKSPACE_STORAGE_NAME)}constructor(a,s,i,r,o){super(i,o),this.workspace=a,this.options=s,this.environmentService=r}async doCreate(){const{storageFilePath:a,wasCreated:s}=await this.prepareWorkspaceStorageFolder();return new m.Storage(new g.SQLiteStorageDatabase(a,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?m.StorageHint.STORAGE_IN_MEMORY:s?m.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:g.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),s=(0,D.join)(a,I.WORKSPACE_STORAGE_NAME);return await d.Promises.exists(a)?{storageFilePath:s,wasCreated:!1}:(await d.Promises.mkdir(a,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(a),{storageFilePath:s,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(a){let s;if((0,b.isSingleFolderWorkspaceIdentifier)(this.workspace)?s={folder:this.workspace.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.workspace)&&(s={workspace:this.workspace.configPath.toString()}),s)try{const i=(0,D.join)(a,I.WORKSPACE_META_NAME);await d.Promises.exists(i)||await d.Promises.writeFile(i,JSON.stringify(s,void 0,2))}catch(i){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${i}`)}}}e.WorkspaceStorageMain=I;class p extends c{get path(){}async doCreate(){return new m.Storage(new m.InMemoryStorageDatabase,{hint:m.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=p}),define(ee[282],te([0,1,3,2,97]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class _ extends A.Disposable{constructor(P,h,d){super(),this.storageMainService=P,this.userDataProfilesService=h,this.logService=d;const m=this._register(new A.MutableDisposable);this._onDidChange=this._register(new E.Emitter({onWillAddFirstListener:()=>m.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>m.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new A.DisposableStore;return P.add(E.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(h,d)=>(h?h.push(d.key):h=[d.key],h),100)(h=>this.onDidChangeApplicationStorage(h))),P.add(E.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(h,d)=>{h||(h=new Map);let m=h.get(d.profile.id);return m||h.set(d.profile.id,m={profile:d.profile,keys:[],storage:d.storage}),m.keys.push(d.key),h},100)(h=>this.onDidChangeProfileStorage(h))),P}onDidChangeApplicationStorage(P){const h=P.includes(n.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],d=[];if(P=P.filter(m=>m!==n.TARGET_KEY),P.length){const m=(0,n.loadKeyTargets)(this.storageMainService.applicationStorage.storage);d.push({profile:this.userDataProfilesService.defaultProfile,changes:P.map(g=>({key:g,scope:0,target:m[g]}))})}this.triggerEvents(h,d)}onDidChangeProfileStorage(P){const h=[],d=new Map;for(const[m,g]of P.entries()){g.keys.includes(n.TARGET_KEY)&&h.push(g.profile);const S=g.keys.filter(u=>u!==n.TARGET_KEY);if(S.length){const u=(0,n.loadKeyTargets)(g.storage.storage);d.set(m,{profile:g.profile,changes:S.map(y=>({key:y,scope:0,target:u[y]}))})}}this.triggerEvents(h,[...d.values()])}triggerEvents(P,h){(P.length||h.length)&&this._onDidChange.fire({valueChanges:h,targetChanges:P})}listen(P,h,d){switch(h){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${h}`)}async call(P,h){throw new Error(`Call not found: ${h}`)}}e.ProfileStorageChangesListenerChannel=_}),define(ee[283],te([0,1,7,33,16,5,34,40,41,12,122]),function(H,e,E,A,n,_,D,P,h,d,m){"use strict";var g,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let u=class extends h.UserDataProfilesService{static{g=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(f,l,v,I,p){super(v,I,l,p),this.stateReadonlyService=f,this.nativeEnvironmentService=v}getStoredProfiles(){return this.stateReadonlyService.getItem(g.PROFILES_KEY,[]).map(l=>({...l,location:(0,d.isString)(l.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,l.location):E.URI.revive(l.location)}))}getStoredProfileAssociations(){const f=this.stateReadonlyService.getItem(g.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(g.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?f:this.migrateStoredProfileAssociations(f)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(E.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=u,e.UserDataProfilesReadonlyService=u=g=Ee([Y(0,D.IStateReadService),Y(1,P.IUriIdentityService),Y(2,A.INativeEnvironmentService),Y(3,n.IFileService),Y(4,_.ILogService)],u);let y=S=class extends u{constructor(f,l,v,I,p){super(f,l,v,I,p),this.stateService=f}saveStoredProfiles(f){f.length?this.stateService.setItem(S.PROFILES_KEY,f.map(l=>({...l,location:this.uriIdentityService.extUri.basename(l.location)}))):this.stateService.removeItem(S.PROFILES_KEY)}getStoredProfiles(){const f=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(f),this.stateService.setItem("userDataProfilesMigration",!0)),f}saveStoredProfileAssociations(f){f.emptyWindows||f.workspaces?this.stateService.setItem(S.PROFILE_ASSOCIATIONS_KEY,f):this.stateService.removeItem(S.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const f="workspaceAndProfileInfo",l=this.stateService.getItem(f,void 0);if(l){this.stateService.removeItem(f);const I=l.reduce((p,{workspace:t,profile:a})=>(p[E.URI.revive(t).toString()]=E.URI.revive(a).toString(),p),{});this.stateService.setItem(S.PROFILE_ASSOCIATIONS_KEY,{workspaces:I})}const v=super.getStoredProfileAssociations();return this.stateService.getItem(S.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(v),this.stateService.setItem(S.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),v}};e.UserDataProfilesService=y,e.UserDataProfilesService=y=S=Ee([Y(0,D.IStateService),Y(1,P.IUriIdentityService),Y(2,A.INativeEnvironmentService),Y(3,n.IFileService),Y(4,_.ILogService)],y);let b=class extends y{constructor(f,l,v,I){super(new m.StateService(0,l,I,v),f,l,v,I)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=b,e.ServerUserDataProfilesService=b=Ee([Y(0,P.IUriIdentityService),Y(1,A.INativeEnvironmentService),Y(2,n.IFileService),Y(3,_.ILogService)],b)}),define(ee[53],te([0,1,33,16,6,5,40,41,283,34]),function(H,e,E,A,n,_,D,P,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,n.refineServiceDecorator)(P.IUserDataProfilesService);let m=class extends h.UserDataProfilesService{constructor(S,u,y,b,c){super(S,u,y,b,c)}getAssociatedEmptyWindows(){const S=[];for(const u of this.profilesObject.emptyWindows.keys())S.push({id:u});return S}};e.UserDataProfilesMainService=m,e.UserDataProfilesMainService=m=Ee([Y(0,d.IStateService),Y(1,D.IUriIdentityService),Y(2,E.INativeEnvironmentService),Y(3,A.IFileService),Y(4,_.ILogService)],m)}),define(ee[131],te([0,1,19,7,30]),function(H,e,E,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function _(h,d,m){for(const S of h){const u=S.openedWorkspace;if((0,n.isWorkspaceIdentifier)(u)){const y=await m(u);if(y){if(y.folders.some(b=>E.extUriBiasedIgnorePathCase.isEqualOrParent(d,b.uri)))return S}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(d,u.configPath))return S}}const g=h.filter(S=>(0,n.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(d,S.openedWorkspace.uri));if(g.length)return g.sort((S,u)=>-(S.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=_;function D(h,d){for(const m of h)if((0,n.isWorkspaceIdentifier)(m.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(m.openedWorkspace.configPath,d)||(0,n.isSingleFolderWorkspaceIdentifier)(m.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(m.openedWorkspace.uri,d))return m}e.findWindowOnWorkspaceOrFolder=D;function P(h,d){const m=g=>d.some(S=>E.extUriBiasedIgnorePathCase.isEqual(A.URI.file(S),A.URI.file(g)));for(const g of h)if(g.config?.extensionDevelopmentPath?.some(S=>m(S)))return g}e.findWindowOnExtensionDevelopmentPath=P}),define(ee[98],te([0,1,32,44,137,46,15,9,4,19,7,6,60,30]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,g.createDecorator)("workspacesService");function y(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function b(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=b;function c(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=c;function f(M){return l(M)||v(M)}e.isStoredWorkspaceFolder=f;function l(M){const C=M;return typeof C?.path=="string"&&(!C.name||typeof C.name=="string")}function v(M){const C=M;return typeof C?.uri=="string"&&(!C.name||typeof C.name=="string")}function I(M,C,L,T,F){if(M.scheme!==T.scheme)return{name:L,uri:M.toString(!0)};let B=C?void 0:F.relativePath(T,M);if(B!==void 0)B.length===0?B=".":h.isWindows&&(B=p(B));else if(M.scheme===D.Schemas.file)B=M.fsPath,h.isWindows&&(B=p(B));else if(F.isEqualAuthority(M.authority,T.authority))B=M.path;else return{name:L,uri:M.toString(!0)};return{name:L,path:B}}e.getStoredWorkspaceFolder=I;function p(M){return M=(0,_.normalizeDriveLetter)(M),(0,E.isUNC)(M)||(M=(0,E.toSlashes)(M)),M}function t(M,C,L){const T=[],F=new Set,B=L.dirname(C);for(const se of M){let ie;if(l(se))se.path&&(ie=L.resolvePath(B,se.path));else if(v(se))try{ie=m.URI.parse(se.uri),ie.path[0]!==P.posix.sep&&(ie=ie.with({path:P.posix.sep+ie.path}))}catch(de){console.warn(de)}if(ie){const de=L.getComparisonKey(ie);if(!F.has(de)){F.add(de);const ae=se.name||L.basenameOrAuthority(ie);T.push(new u.WorkspaceFolder({uri:ie,name:ae,index:T.length},se))}}}return T}e.toWorkspaceFolders=t;function a(M,C,L,T,F){const B=s(C,M),se=F.dirname(C),ie=F.dirname(T),de=[];for(const G of B.folders){const z=l(G)?F.resolvePath(se,G.path):m.URI.parse(G.uri);let W;L?W=!1:W=!l(G)||(0,P.isAbsolute)(G.path),de.push(I(z,W,G.name,ie,F))}const ae={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},ue=n.setProperty(M,["folders"],de,ae);let x=n.applyEdits(M,ue);return(0,d.isEqualAuthority)(B.remoteAuthority,(0,S.getRemoteAuthority)(T))&&(x=n.applyEdits(x,n.removeProperty(x,["remoteAuthority"],ae))),x}e.rewriteWorkspaceFileForNewLocation=a;function s(M,C){const L=A.parse(C);if(L&&Array.isArray(L.folders))L.folders=L.folders.filter(T=>f(T));else throw new Error(`${M} looks like an invalid workspace file.`);return L}function i(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function r(M){return typeof M.folderUri=="string"}function o(M){return typeof M.fileUri=="string"}function w(M,C){const L={workspaces:[],files:[]};if(M){const T=function(B,se){for(let ie=0;ie<B.length;ie++)try{se(B[ie],ie)}catch(de){C.warn(`Error restoring recent entry ${JSON.stringify(B[ie])}: ${de.toString()}. Skip entry.`)}},F=M;Array.isArray(F.entries)&&T(F.entries,B=>{const se=B.label,ie=B.remoteAuthority;i(B)?L.workspaces.push({label:se,remoteAuthority:ie,workspace:{id:B.workspace.id,configPath:m.URI.parse(B.workspace.configPath)}}):r(B)?L.workspaces.push({label:se,remoteAuthority:ie,folderUri:m.URI.parse(B.folderUri)}):o(B)&&L.files.push({label:se,remoteAuthority:ie,fileUri:m.URI.parse(B.fileUri)})})}return L}e.restoreRecentlyOpened=w;function k(M){const C={entries:[]};for(const L of M.workspaces)b(L)?C.entries.push({folderUri:L.folderUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority}):C.entries.push({workspace:{id:L.workspace.id,configPath:L.workspace.configPath.toString()},label:L.label,remoteAuthority:L.remoteAuthority});for(const L of M.files)C.entries.push({fileUri:L.fileUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority});return C}e.toStoreData=k}),define(ee[99],te([0,1,72,15,4,19]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(d){function m(){let g=d.scheme===A.Schemas.file?(0,_.originalFSPath)(d):d.toString();return n.isLinux||(g=g.toLowerCase()),(0,E.createHash)("md5").update(g).digest("hex")}return{id:m(),configPath:d}}e.getWorkspaceIdentifier=D;function P(d,m){function g(){if(d.scheme!==A.Schemas.file)return(0,E.createHash)("md5").update(d.toString()).digest("hex");if(!m)return;let u;return n.isLinux?u=m.ino:n.isMacintosh?u=m.birthtime.getTime():n.isWindows&&(typeof m.birthtimeMs=="number"?u=Math.floor(m.birthtimeMs):u=m.birthtime.getTime()),(0,E.createHash)("md5").update(d.fsPath).update(u?String(u):"").digest("hex")}const S=g();if(typeof S=="string")return{id:S,uri:d}}e.getSingleFolderWorkspaceIdentifier=P;function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=h}),define(ee[100],te([0,1,72,88,27,284,17,13,3,2,9,4,31,42,110]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class b{traceSocketEvent(C,L){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,L)}constructor(C,L=""){this._canWrite=!0,this.debugLabel=L,this.socket=C,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=T=>{if(this.traceSocketEvent("error",{code:T?.code,message:T?.message}),T){if(T.code==="EPIPE")return;(0,P.onUnexpectedError)(T)}},this.socket.on("error",this._errorListener),this._closeListener=T=>{this.traceSocketEvent("close",{hadError:T}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(C){const L=T=>{this.traceSocketEvent("read",T),C(D.VSBuffer.wrap(T))};return this.socket.on("data",L),{dispose:()=>this.socket.off("data",L)}}onClose(C){const L=T=>{C({type:0,hadError:T,error:void 0})};return this.socket.on("close",L),{dispose:()=>this.socket.off("close",L)}}onEnd(C){const L=()=>{C()};return this.socket.on("end",L),{dispose:()=>this.socket.off("end",L)}}write(C){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",C),this.socket.write(C.buffer,L=>{if(L){if(L.code==="EPIPE")return;(0,P.onUnexpectedError)(L)}})}catch(L){if(L.code==="EPIPE")return;(0,P.onUnexpectedError)(L)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((C,L)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),C();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent("nodeDrainEnd"),C()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=b;var c;(function(M){M[M.MinHeaderByteSize=2]="MinHeaderByteSize",M[M.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(c||(c={}));var f;(function(M){M[M.PeekHeader=1]="PeekHeader",M[M.ReadHeader=2]="ReadHeader",M[M.ReadBody=3]="ReadBody",M[M.Fin=4]="Fin"})(f||(f={}));class l extends d.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(C,L){this.socket.traceSocketEvent(C,L)}constructor(C,L,T,F){super(),this._onData=this._register(new h.Emitter),this._onClose=this._register(new h.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=C,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:L,inflateBytesLength:T?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new v(this,L,T,F,this._onData,(B,se)=>this._write(B,se))),this._register(this._flowManager.onError(B=>{console.error(B),(0,P.onUnexpectedError)(B),this._onClose.fire({type:0,hadError:!0,error:B})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(B=>this._acceptChunk(B))),this._register(this.socket.onClose(async B=>{this._flowManager.isProcessingReadQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(B)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this._onData.event(C)}onClose(C){return this._onClose.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){let L=0;for(;L<C.byteLength;)this._flowManager.writeMessage(C.slice(L,Math.min(L+262144,C.byteLength))),L+=262144}_write(C,L){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",C);let T=2;C.byteLength<126?T+=0:C.byteLength<2**16?T+=2:T+=8;const F=D.VSBuffer.alloc(T);if(L?F.writeUInt8(194,0):F.writeUInt8(130,0),C.byteLength<126)F.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){F.writeUInt8(126,1);let B=1;F.writeUInt8(C.byteLength>>>8&255,++B),F.writeUInt8(C.byteLength>>>0&255,++B)}else{F.writeUInt8(127,1);let B=1;F.writeUInt8(0,++B),F.writeUInt8(0,++B),F.writeUInt8(0,++B),F.writeUInt8(0,++B),F.writeUInt8(C.byteLength>>>24&255,++B),F.writeUInt8(C.byteLength>>>16&255,++B),F.writeUInt8(C.byteLength>>>8&255,++B),F.writeUInt8(C.byteLength>>>0&255,++B)}this.socket.write(D.VSBuffer.concat([F,C]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(C){if(C.byteLength!==0){for(this._incomingData.acceptChunk(C);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const L=this._incomingData.peek(this._state.readLen),T=L.readUInt8(0),F=(T&128)>>>7,B=(T&64)>>>6,se=L.readUInt8(1),ie=(se&128)>>>7,de=se&127;this._state.state=2,this._state.readLen=2+(ie?4:0)+(de===126?2:0)+(de===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=!!B),this._state.firstFrameOfMessage=!!F,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const L=this._incomingData.read(this._state.readLen),T=L.readUInt8(1),F=(T&128)>>>7;let B=T&127,se=1;B===126?B=L.readUInt8(++se)*2**8+L.readUInt8(++se):B===127&&(B=L.readUInt8(++se)*0+L.readUInt8(++se)*0+L.readUInt8(++se)*0+L.readUInt8(++se)*0+L.readUInt8(++se)*2**24+L.readUInt8(++se)*2**16+L.readUInt8(++se)*2**8+L.readUInt8(++se));let ie=0;F&&(ie=L.readUInt8(++se)*2**24+L.readUInt8(++se)*2**16+L.readUInt8(++se)*2**8+L.readUInt8(++se)),this._state.state=3,this._state.readLen=B,this._state.mask=ie,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const L=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",L),t(L,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",L),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(L,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=l;class v extends d.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(C,L,T,F,B,se){super(),this._tracer=C,this._onData=B,this._writeFn=se,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new h.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new h.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,L?(this._zlibInflateStream=this._register(new I(this._tracer,F,T,{windowBits:15})),this._zlibDeflateStream=this._register(new p(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(ie=>this._onError.fire(ie))),this._register(this._zlibDeflateStream.onError(ie=>this._onError.fire(ie)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(C){this._writeQueue.push(C),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const C=this._writeQueue.shift();if(this._zlibDeflateStream){const L=await this._deflateMessage(this._zlibDeflateStream,C);this._writeFn(L,!0)}else this._writeFn(C,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(C,L){return new Promise((T,F)=>{C.write(L),C.flush(B=>T(B))})}acceptFrame(C,L,T){this._readQueue.push({data:C,isCompressed:L,isLastFrameOfMessage:T}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const C=this._readQueue.shift();if(this._zlibInflateStream&&C.isCompressed){const L=await this._inflateFrame(this._zlibInflateStream,C.data,C.isLastFrameOfMessage);this._onData.fire(L)}else this._onData.fire(C.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(C,L,T){return new Promise((F,B)=>{C.write(L),T&&C.write(D.VSBuffer.fromByteArray([0,0,255,255])),C.flush(se=>F(se))})}}class I extends d.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}constructor(C,L,T,F){super(),this._tracer=C,this._recordInflateBytes=L,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,_.createInflateRaw)(F),this._zlibInflate.on("error",B=>{this._tracer.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this._onError.fire(B)}),this._zlibInflate.on("data",B=>{this._tracer.traceSocketEvent("zlibInflateData",B),this._pendingInflateData.push(D.VSBuffer.wrap(B))}),T&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",T.buffer),this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(C){this._recordInflateBytes&&this._recordedInflateBytes.push(C.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",C),this._zlibInflate.write(C.buffer)}flush(C){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const L=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,C(L)})}}class p extends d.Disposable{constructor(C,L){super(),this._tracer=C,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,_.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",T=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibDeflate.on("data",T=>{this._tracer.traceSocketEvent("zlibDeflateData",T),this._pendingDeflateData.push(D.VSBuffer.wrap(T))})}write(C){this._tracer.traceSocketEvent("zlibDeflateWrite",C.buffer),this._zlibDeflate.write(C.buffer)}flush(C){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let L=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,L=L.slice(0,L.byteLength-4),C(L)})}}function t(M,C){if(C===0)return;const L=M.byteLength>>>2;for(let de=0;de<L;de++){const ae=M.readUInt32BE(de*4);M.writeUInt32BE(ae^C,de*4)}const T=L*4,F=M.byteLength-T,B=C>>>24&255,se=C>>>16&255,ie=C>>>8&255;F>=1&&M.writeUInt8(M.readUInt8(T)^B,T),F>=2&&M.writeUInt8(M.readUInt8(T+1)^se,T+1),F>=3&&M.writeUInt8(M.readUInt8(T+2)^ie,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function s(){const M=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${M}-sock`;const C=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,n.tmpdir)(),L=(0,m.join)(C,`vscode-ipc-${M}.sock`);return r(L),L}e.createRandomIPCHandle=s;function i(M,C,L){const T=(0,E.createHash)("md5").update(M).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${L}-${C}-sock`;const F=L.substr(0,4),B=C.substr(0,6),se=T.substr(0,8);let ie;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?ie=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-${se}-${F}-${B}.sock`):ie=(0,m.join)(M,`${F}-${B}.sock`),r(ie),ie}e.createStaticIPCHandle=i;function r(M){const C=a[g.platform];typeof C=="number"&&M.length>=C&&console.warn(`WARNING: IPC handle "${M}" is longer than ${C} chars, try a shorter --user-data-dir`)}class o extends u.IPCServer{static toClientConnectionEvent(C){const L=h.Event.fromNodeEventEmitter(C,"connection");return h.Event.map(L,T=>({protocol:new y.Protocol(new b(T,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(T,"close"))}))}constructor(C){super(o.toClientConnectionEvent(C)),this.server=C}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function w(M){return new Promise((C,L)=>{const T=(0,A.createServer)();T.on("error",L),T.listen(M,()=>{T.removeListener("error",L),C(new o(T))})})}e.serve=w;function k(M,C){return new Promise((L,T)=>{const F=(0,A.createConnection)(M,()=>{F.removeListener("error",T),L(y.Client.fromSocket(new b(F,`ipc-client${C}`),C))});F.once("error",T)})}e.connect=k}),define(ee[28],te([0,1,55,9,4,100,33,90,6]),function(H,e,E,A,n,_,D,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,h.refineServiceDecorator)(D.IEnvironmentService);class d extends P.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get cachedLanguagesPath(){return(0,A.join)(this.userDataPath,"clp")}get backupHome(){return(0,A.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,_.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,A.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}get userRoamingDataHome(){return this.appSettingsHome}unsetSnapExportedVariables(){if(n.isLinux){for(const g in process.env)if(g.endsWith("_VSCODE_SNAP_ORIG")){const S=g.slice(0,-17);if(this._snapEnv[S])continue;process.env[S]&&(this._snapEnv[S]=process.env[S]),process.env[g]?process.env[S]=process.env[g]:delete process.env[S]}}}restoreSnapExportedVariables(){if(n.isLinux)for(const g in this._snapEnv)process.env[g]=this._snapEnv[g],delete this._snapEnv[g]}}e.EnvironmentMainService=d,Ee([E.memoize],d.prototype,"cachedLanguagesPath",null),Ee([E.memoize],d.prototype,"backupHome",null),Ee([E.memoize],d.prototype,"mainIPCHandle",null),Ee([E.memoize],d.prototype,"mainLockfile",null),Ee([E.memoize],d.prototype,"disableUpdates",null),Ee([E.memoize],d.prototype,"crossOriginIsolated",null),Ee([E.memoize],d.prototype,"codeCachePath",null),Ee([E.memoize],d.prototype,"useCodeCache",null),Ee([E.memoize],d.prototype,"userRoamingDataHome",null)}),define(ee[285],te([0,1,72,32,15,9,4,19,21,194,18,28,34,16,5,193,30,99]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{static{l=this}static{this.backupWorkspacesMetadataStorageKey="backupWorkspaces"}constructor(p,t,a,s){this.environmentMainService=p,this.configurationService=t,this.logService=a,this.stateService=s,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=P.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,r)=>(0,A.isEqual)(i,r,!D.isLinux)}}async initialize(){const p=this.stateService.getItem(l.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(p.emptyWindows),this.workspaces=await this.validateWorkspaces((0,d.deserializeWorkspaceInfos)(p)),this.folders=await this.validateFolders((0,d.deserializeFolderInfos)(p)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==u.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(p,t){this.workspaces.some(s=>p.workspace.id===s.workspace.id)||(this.workspaces.push(p),this.storeWorkspacesMetadata());const a=(0,_.join)(this.backupHome,p.workspace.id);return t?this.moveBackupFolder(a,t).then(()=>a):a}async moveBackupFolder(p,t){if(await h.Promises.exists(p)&&await this.convertToEmptyWindowBackup(p),await h.Promises.exists(t))try{await h.Promises.rename(t,p,!1)}catch(a){this.logService.error(`Backup: Could not move backup folder to new location: ${a.toString()}`)}}registerFolderBackup(p){return this.folders.some(t=>this.backupUriComparer.isEqual(p.folderUri,t.folderUri))||(this.folders.push(p),this.storeWorkspacesMetadata()),(0,_.join)(this.backupHome,this.getFolderHash(p))}registerEmptyWindowBackup(p){return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,p.backupFolder))||(this.emptyWindows.push(p),this.storeWorkspacesMetadata()),(0,_.join)(this.backupHome,p.backupFolder)}async validateWorkspaces(p){if(!Array.isArray(p))return[];const t=new Set,a=[];for(const s of p){const i=s.workspace;if(!(0,c.isWorkspaceIdentifier)(i))return[];if(!t.has(i.id)){t.add(i.id);const r=(0,_.join)(this.backupHome,i.id);await this.doHasBackups(r)?i.configPath.scheme!==n.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?a.push(s):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return a}async validateFolders(p){if(!Array.isArray(p))return[];const t=[],a=new Set;for(const s of p){const i=s.folderUri,r=this.backupUriComparer.getComparisonKey(i);if(!a.has(r)){a.add(r);const o=(0,_.join)(this.backupHome,this.getFolderHash(s));await this.doHasBackups(o)?i.scheme!==n.Schemas.file||await h.Promises.exists(i.fsPath)?t.push(s):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return t}async validateEmptyWorkspaces(p){if(!Array.isArray(p))return[];const t=[],a=new Set;for(const s of p){const i=s.backupFolder;if(typeof i!="string")return[];if(!a.has(i)){a.add(i);const r=(0,_.join)(this.backupHome,i);await this.doHasBackups(r)?t.push(s):await this.deleteStaleBackup(r)}}return t}async deleteStaleBackup(p){try{await h.Promises.rm(p,h.RimRafMode.MOVE)}catch(t){this.logService.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}prepareNewEmptyWindowBackup(){let p=(0,f.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,p.id));)p=(0,f.createEmptyWorkspaceIdentifier)();return{backupFolder:p.id}}async convertToEmptyWindowBackup(p){const t=this.prepareNewEmptyWindowBackup(),a=(0,_.join)(this.backupHome,t.backupFolder);try{await h.Promises.rename(p,a,!1)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push(t),!0}async getDirtyWorkspaces(){const p=[];for(const t of this.workspaces)await this.hasBackups(t)&&p.push(t);for(const t of this.folders)await this.hasBackups(t)&&p.push(t);return p}hasBackups(p){let t;return(0,d.isEmptyWindowBackupInfo)(p)?t=(0,_.join)(this.backupHome,p.backupFolder):(0,b.isFolderBackupInfo)(p)?t=(0,_.join)(this.backupHome,this.getFolderHash(p)):t=(0,_.join)(this.backupHome,p.workspace.id),this.doHasBackups(t)}async doHasBackups(p){try{const t=await h.Promises.readdir(p);for(const a of t)try{if((await h.Promises.readdir((0,_.join)(p,a))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const p={workspaces:this.workspaces.map(({workspace:t,remoteAuthority:a})=>{const s={id:t.id,configURIPath:t.configPath.toString()};return a&&(s.remoteAuthority=a),s}),folders:this.folders.map(({folderUri:t,remoteAuthority:a})=>{const s={folderUri:t.toString()};return a&&(s.remoteAuthority=a),s}),emptyWindows:this.emptyWindows.map(({backupFolder:t,remoteAuthority:a})=>{const s={backupFolder:t};return a&&(s.remoteAuthority=a),s})};this.stateService.setItem(l.backupWorkspacesMetadataStorageKey,p)}getFolderHash(p){const t=p.folderUri;let a;return t.scheme===n.Schemas.file?a=D.isLinux?t.fsPath:t.fsPath.toLowerCase():a=t.toString().toLowerCase(),(0,E.createHash)("md5").update(a).digest("hex")}};e.BackupMainService=v,e.BackupMainService=v=l=Ee([Y(0,g.IEnvironmentMainService),Y(1,m.IConfigurationService),Y(2,y.ILogService),Y(3,S.IStateService)],v)}),define(ee[20],te([0,1,14,38,8,3,2,4,36,12,6,5,34,28]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,m.createDecorator)("lifecycleMainService");var b;(function(l){l[l.QUIT=1]="QUIT",l[l.KILL=2]="KILL"})(b||(e.ShutdownReason=b={}));var c;(function(l){l[l.Starting=1]="Starting",l[l.Ready=2]="Ready",l[l.AfterWindowOpen=3]="AfterWindowOpen",l[l.Eventually=4]="Eventually"})(c||(e.LifecycleMainPhase=c={}));let f=class extends D.Disposable{static{y=this}static{this.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart"}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(v,I,p){super(),this.logService=v,this.stateService=I,this.environmentMainService=p,this._onBeforeShutdown=this._register(new _.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new _.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new _.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new _.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.relaunchHandler=void 0,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(y.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(y.QUIT_AND_RESTART_KEY)}registerListeners(){const v=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};E.app.addListener("before-quit",v);const I=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",I),E.app.once("will-quit",p=>{this.trace("Lifecycle#app.on(will-quit) - begin"),p.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),E.app.removeListener("before-quit",v),E.app.removeListener("window-all-closed",I),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),E.app.quit()})})}fireOnWillShutdown(v){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const I=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const p=[];return this._onWillShutdown.fire({reason:v,join(t,a){I.trace(`Lifecycle#onWillShutdown - begin '${t}'`),p.push(a.finally(()=>{I.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(p)}catch(t){this.logService.error(t)}try{await this.stateService.close()}catch(t){this.logService.error(t)}})(),this.pendingWillShutdownPromise}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===v)return;this.trace(`lifecycle (main): phase changed (value: ${v})`),this._phase=v;const I=this.phaseWhen.get(this._phase);I&&(I.open(),this.phaseWhen.delete(this._phase))}async when(v){if(v<=this._phase)return;let I=this.phaseWhen.get(v);I||(I=new n.Barrier,this.phaseWhen.set(v,I)),await I.wait()}registerWindow(v){const I=new D.DisposableStore;this.windowCounter++,I.add(v.onWillLoad(t=>this._onWillLoadWindow.fire({window:v,workspace:t.workspace,reason:t.reason})));const p=(0,d.assertIsDefined)(v.win);p.on("close",t=>{const a=v.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.trace(`Lifecycle#window.on('close') - window ID ${v.id}`),t.preventDefault(),this.unload(v,1).then(s=>{if(s){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(v),v.close()})}),p.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.windowCounter--,I.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(v,I){await this.unload(v,3)||v.reload(I)}unload(v,I){const p=this.mapWindowIdToPendingUnload.get(v.id);if(p)return p;const t=this.doUnload(v,I).finally(()=>{this.mapWindowIdToPendingUnload.delete(v.id)});return this.mapWindowIdToPendingUnload.set(v.id,t),t}async doUnload(v,I){if(!v.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${v.id}`);const p=this._quitRequested?2:I,t=await this.onBeforeUnloadWindowInRenderer(v,p);return t?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.handleWindowUnloadVeto(t)):(await this.onWillUnloadWindowInRenderer(v,p),!1)}handleWindowUnloadVeto(v){return v?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(v){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(v),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(v,I){return new Promise(p=>{const t=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${t}`,s=`vscode:cancel${t}`;A.validatedIpcMain.once(a,()=>{p(!1)}),A.validatedIpcMain.once(s,()=>{p(!0)}),v.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:s,reason:I})})}onWillUnloadWindowInRenderer(v,I){return new Promise(p=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;A.validatedIpcMain.once(a,()=>p()),v.send("vscode:onWillUnload",{replyChannel:a,reason:I})})}quit(v){return this.doQuit(v).then(I=>{if(!I&&v)try{if(P.isWindows){const p=(0,h.cwd)();p!==process.cwd()&&process.chdir(p)}}catch(p){this.logService.error(p)}return I})}doQuit(v){return this.trace(`Lifecycle#quit() - begin (willRestart: ${v})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(v&&this.stateService.setItem(y.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(I=>{this.pendingQuitPromiseResolve=I,this.trace("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.pendingQuitPromise)}trace(v){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(v):this.logService.trace(v)}setRelaunchHandler(v){this.relaunchHandler=v}async relaunch(v){this.trace("Lifecycle#relaunch()");const I=process.argv.slice(1);if(v?.addArgs&&I.push(...v.addArgs),v?.removeArgs)for(const a of v.removeArgs){const s=I.indexOf(a);s>=0&&I.splice(s,1)}const p=()=>{this.relaunchHandler?.handleRelaunch(v)||(this.trace("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:I}))};E.app.once("quit",p),await this.quit(!0)&&E.app.removeListener("quit",p)}async kill(v){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const I of E.BrowserWindow.getAllWindows())if(I&&!I.isDestroyed()){let p;I.webContents&&!I.webContents.isDestroyed()?p=new Promise(t=>I.once("closed",t)):p=Promise.resolve(),I.destroy(),await p}})()]),E.app.exit(v)}};e.LifecycleMainService=f,e.LifecycleMainService=f=y=Ee([Y(0,g.ILogService),Y(1,S.IStateService),Y(2,u.IEnvironmentMainService)],f)}),define(ee[286],te([0,1,4,3,2,6,20]),function(H,e,E,A,n,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,_.createDecorator)("keyboardLayoutMainService");let P=class extends n.Disposable{constructor(m){super(),this._onDidChangeKeyboardLayout=this._register(new A.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,m.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const m=await new Promise((g,S)=>{H(["native-keymap"],g,S)});this._keyboardLayoutData=h(m),E.isCI||m.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=h(m),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=P,e.KeyboardLayoutMainService=P=Ee([Y(0,D.ILifecycleMainService)],P);function h(d){const m=d.getKeyMap(),g=d.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:g}}}),define(ee[287],te([0,1,245,8,17,13,12,18,33,95,5,51,244,284]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let y=class extends g.AbstractRequestService{constructor(l,v,I,p){super(p),this.configurationService=l,this.environmentService=v,this.logService=I,this.configure(),this._register(l.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const l=this.configurationService.getValue("http");this.proxyUrl=l?.proxy,this.strictSSL=!!l?.proxyStrictSSL,this.authorization=l?.proxyAuthorization}async request(l,v){const{proxyUrl:I,strictSSL:p}=this;let t;try{t=await(0,d.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(i){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,_.getErrorMessage)(i)))}const a={...process.env,...t},s=l.agent?l.agent:await(0,S.getProxyAgent)(l.url||"",a,{proxyUrl:I,strictSSL:p});return l.agent=s,l.strictSSL=p,this.authorization&&(l.headers={...l.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(l.isChromiumNetwork?"electron":"node",l,()=>c(l,v))}async resolveProxy(l){}};e.RequestService=y,e.RequestService=y=Ee([Y(0,P.IConfigurationService),Y(1,h.INativeEnvironmentService),Y(2,m.ILogService),Y(3,m.ILoggerService)],y);async function b(f){return((0,E.parse)(f.url).protocol==="https:"?await new Promise((I,p)=>{H(["https"],I,p)}):await new Promise((I,p)=>{H(["http"],I,p)})).request}async function c(f,l){return A.Promises.withAsyncBody(async(v,I)=>{const p=(0,E.parse)(f.url),t=f.getRawRequest?f.getRawRequest(f):await b(f),a={hostname:p.hostname,port:p.port?parseInt(p.port):p.protocol==="https:"?443:80,protocol:p.protocol,path:p.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,D.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(a.auth=f.user+":"+f.password);const s=t(a,i=>{const r=(0,D.isNumber)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)c({...f,url:i.headers.location,followRedirects:r-1},l).then(v,I);else{let o=i;!f.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,u.createGunzip)())),v({res:i,stream:(0,n.streamToBufferReadableStream)(o)})}});s.on("error",I),f.timeout&&s.setTimeout(f.timeout),f.isChromiumNetwork&&s.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&s.write(f.data),s.end(),l.onCancellationRequested(()=>{s.abort(),I(new _.CancellationError)})})}e.nodeRequest=c}),define(ee[288],te([0,1,14,287]),function(H,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function n(D){return E.net.request}class _ extends A.RequestService{request(P,h){return super.request({...P||{},getRawRequest:n,isChromiumNetwork:!0},h)}}e.RequestMainService=_}),define(ee[83],te([0,1,7,49,3,2,33,16,6,20,5,97,281,41,53,40]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,h.createDecorator)("storageMainService");let c=class extends _.Disposable{constructor(v,I,p,t,a,s){super(),this.logService=v,this.environmentService=I,this.userDataProfilesService=p,this.lifecycleMainService=t,this.fileService=a,this.uriIdentityService=s,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new n.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(v=>{v.window.profile&&this.profileStorage(v.window.profile).init(),v.workspace&&this.workspaceStorage(v.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(v=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=v.reason,v.join("applicationStorage",this.applicationStorage.close());for(const[,I]of this.mapProfileToStorage)v.join("profileStorage",I.close());for(const[,I]of this.mapWorkspaceToStorage)v.join("workspaceStorage",I.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(v=>{v.join((async()=>{await this.fileService.exists(v.profile.globalStorageHome)||await this.fileService.createFolder(v.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(v=>{const I=this.mapProfileToStorage.get(v.profile.id);I&&v.join(I.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const v=new S.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,A.once)(v.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),v}profileStorage(v){if((0,g.isProfileUsingDefaultStorage)(v))return this.applicationStorage;let I=this.mapProfileToStorage.get(v.id);if(!I){this.logService.trace(`StorageMainService: creating profile storage (${v.name})`),I=this.createProfileStorage(v),this.mapProfileToStorage.set(v.id,I);const p=this._register(I.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:I,profile:v})));(0,A.once)(I.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${v.name})`),this.mapProfileToStorage.delete(v.id),p.dispose()})}return I}createProfileStorage(v){return this.shutdownReason===2?new S.InMemoryStorageMain(this.logService,this.fileService):new S.ProfileStorageMain(v,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(v){let I=this.mapWorkspaceToStorage.get(v.id);return I||(this.logService.trace(`StorageMainService: creating workspace storage (${v.id})`),I=this.createWorkspaceStorage(v),this.mapWorkspaceToStorage.set(v.id,I),(0,A.once)(I.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${v.id})`),this.mapWorkspaceToStorage.delete(v.id)})),I}createWorkspaceStorage(v){return this.shutdownReason===2?new S.InMemoryStorageMain(this.logService,this.fileService):new S.WorkspaceStorageMain(v,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(v){const I=E.URI.file(v);for(const p of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(p.path&&this.uriIdentityService.extUri.isEqualOrParent(E.URI.file(p.path),I))return!0;return!1}};e.StorageMainService=c,e.StorageMainService=c=Ee([Y(0,m.ILogService),Y(1,D.IEnvironmentService),Y(2,y.IUserDataProfilesMainService),Y(3,d.ILifecycleMainService),Y(4,P.IFileService),Y(5,b.IUriIdentityService)],c),e.IApplicationStorageMainService=(0,h.createDecorator)("applicationStorageMainService");let f=class extends g.AbstractStorageService{constructor(v,I){super(),this.userDataProfilesService=v,this.storageMainService=I,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(v){if(v===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(v){if(v===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=f,e.ApplicationStorageMainService=f=Ee([Y(0,u.IUserDataProfilesService),Y(1,e.IStorageMainService)],f)}),define(ee[289],te([0,1,14,23,3,57,2,31,76,116,5,22,83,29]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(c){c[c.Initial=1]="Initial",c[c.StoredCredentialsUsed=2]="StoredCredentialsUsed",c[c.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let b=class extends D.Disposable{constructor(f,l,v,I,p,t){super(),this.logService=f,this.windowsMainService=l,this.credentialsService=v,this.encryptionMainService=I,this.applicationStorageMainService=p,this.productService=t,this.OLD_PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.PROXY_CREDENTIALS_SERVICE_KEY="proxy-credentials://",this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const f=n.Event.fromNodeEventEmitter(E.app,"login",(l,v,I,p,t)=>({event:l,webContents:v,req:I,authInfo:p,callback:t}));this._register(f(this.onLogin,this))}async onLogin({event:f,authInfo:l,req:v,callback:I}){if(!l.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&v.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}f.preventDefault();let p;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),p=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(l);try{p=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}I(p?.username,p?.password)}async resolveProxyCredentials(f){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const l=await this.doResolveProxyCredentials(f);if(l)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),l;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async getAndMigrateProxyCredentials(f){try{let l=this.applicationStorageMainService.get(this.PROXY_CREDENTIALS_SERVICE_KEY+f,-1),v;if(l||(l=await this.credentialsService.getPassword(this.OLD_PROXY_CREDENTIALS_SERVICE_KEY,f)??void 0,l&&(v=await this.encryptionMainService.decrypt(l),l=await this.encryptionMainService.encrypt(v),this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+f,l,-1,1),await this.credentialsService.deletePassword(this.OLD_PROXY_CREDENTIALS_SERVICE_KEY,f))),l){const I=JSON.parse(v??await this.encryptionMainService.decrypt(l));return{storedUsername:I.username,storedPassword:I.password}}}catch(l){this.logService.error(l)}return{storedUsername:void 0,storedPassword:void 0}}async doResolveProxyCredentials(f){this.logService.trace("auth#doResolveProxyCredentials - enter",f);const l=String((0,_.hash)({scheme:f.scheme,host:f.host,port:f.port})),{storedUsername:v,storedPassword:I}=await this.getAndMigrateProxyCredentials(l);if(this.state!==y.StoredCredentialsUsed&&typeof v=="string"&&typeof I=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:v,password:I};const p=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!p){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${p.id} to handle proxy login`);const t={authInfo:f,username:this.sessionCredentials?.username??v,password:this.sessionCredentials?.password??I,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};p.sendWhenReady("vscode:openProxyAuthenticationDialog",A.CancellationToken.None,t),this.state=y.LoginDialogShown;const a=await new Promise(s=>{const i=async(r,o,w)=>{if(o===t.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${p.id}`),p.win?.webContents.off("ipc-message",i),w){const k={username:w.username,password:w.password};try{if(w.remember){const M=await this.encryptionMainService.encrypt(JSON.stringify(k));this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+l,M,-1,1)}else this.applicationStorageMainService.remove(this.PROXY_CREDENTIALS_SERVICE_KEY+l,-1)}catch(M){this.logService.error(M)}s({username:k.username,password:k.password})}else s(void 0)};p.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=a,a}};e.ProxyAuthHandler=b,e.ProxyAuthHandler=b=Ee([Y(0,m.ILogService),Y(1,u.IWindowsMainService),Y(2,h.ICredentialsMainService),Y(3,d.IEncryptionMainService),Y(4,S.IApplicationStorageMainService),Y(5,g.IProductService)],b)}),define(ee[290],te([0,1,88,27,104,100,8,2,4,18,5,22,240,241,96,127,17]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function f(t,a,s,i,r){let o;for(let w=3;w&&(o?.dispose(),o=await new l(t,a,s,i,r).waitForReady(),!(r&&n.BROWSER_RESTRICTED_PORTS[r]||!n.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));w--);return o}class l extends P.Disposable{constructor(a,s,i,r,o){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=o,this.privacy=b.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=a,this._server=E.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=w=>this._onConnection(w),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){const a=this.suggestedLocalPort??this.tunnelRemotePort,s=(0,b.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let i=await(0,n.findFreePortFaster)(a,2,1e3,s),r=null;return this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),r=this._server.address(),r||(i=0,this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),r=this._server.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async _onConnection(a){a.pause();const s=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,S.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),r=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&a.write(o.buffer),a.on("end",()=>{a.localAddress&&this._socketsDispose.delete(a.localAddress),r.end()}),a.on("close",()=>r.end()),a.on("error",()=>{a.localAddress&&this._socketsDispose.delete(a.localAddress),r instanceof _.NodeSocket?r.socket.destroy():r.end()}),r instanceof _.NodeSocket?this._mirrorNodeSocket(a,r):this._mirrorGenericSocket(a,r),a.localAddress&&this._socketsDispose.set(a.localAddress,()=>{a.end(),r.end()})}_mirrorGenericSocket(a,s){s.onClose(()=>a.destroy()),s.onEnd(()=>a.end()),s.onData(i=>a.write(i.buffer)),a.on("data",i=>s.write(c.VSBuffer.wrap(i))),a.resume()}_mirrorNodeSocket(a,s){const i=s.socket;i.on("end",()=>a.end()),i.on("close",()=>a.end()),i.on("error",()=>{a.destroy()}),i.pipe(a),a.pipe(i)}}e.NodeRemoteTunnel=l;let v=class extends b.AbstractTunnelService{constructor(a,s,i,r,o){super(s,o),this.remoteSocketFactoryService=a,this.signService=i,this.productService=r}isPortPrivileged(a){return(0,b.isPortPrivileged)(a,this.defaultTunnelHost,h.OS,A.release())}retainOrCreateTunnel(a,s,i,r,o,w,k,M){const C=this.getTunnelFromMap(s,i);if(C)return++C.refcount,C.value;if((0,b.isTunnelProvider)(a))return this.createWithProvider(a,s,i,o,w,k,M);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${o}.`);const L={commit:this.productService.commit,quality:this.productService.quality,addressProvider:a,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},T=f(L,r,s,i,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,i,T),T}}};e.BaseTunnelService=v,e.BaseTunnelService=v=Ee([Y(0,u.IRemoteSocketFactoryService),Y(1,m.ILogService),Y(2,y.ISignService),Y(3,g.IProductService),Y(4,d.IConfigurationService)],v);let I=class extends v{constructor(a,s,i,r,o){super(a,s,i,r,o)}};e.TunnelService=I,e.TunnelService=I=Ee([Y(0,u.IRemoteSocketFactoryService),Y(1,m.ILogService),Y(2,y.ISignService),Y(3,g.IProductService),Y(4,d.IConfigurationService)],I);let p=class extends P.Disposable{constructor(a,s,i,r,o){super(),this.remoteSocketFactoryService=a,this.logService=s,this.productService=i,this.signService=r,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(a,s,i,r,o,w,k,M,C){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${r} on local port ${w}.`),!this._tunnelServices.has(a)){const L=new I(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(L),this._tunnelServices.set(a,L),L.onTunnelClosed(async()=>{(await L.tunnels).length===0&&(L.dispose(),this._tunnelServices.delete(a))})}return this._tunnelServices.get(a).openTunnel(s,i,r,o,w,k,M,C)}};e.SharedTunnelsService=p,e.SharedTunnelsService=p=Ee([Y(0,u.IRemoteSocketFactoryService),Y(1,m.ILogService),Y(2,g.IProductService),Y(3,y.ISignService),Y(4,d.IConfigurationService)],p)}),define(ee[101],te([0,1,8,23,3,18,28,20,5,22,51,48]),function(H,e,E,A,n,_,D,P,h,d,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(y,b,c){return`${c.updateUrl}/api/update/${y}/${b}/${c.commit}`}e.createUpdateURL=S;let u=class{get state(){return this._state}setState(b){this.logService.info("update#setState",b.type),this._state=b,this._onStateChange.fire(b)}constructor(b,c,f,l,v,I){this.lifecycleMainService=b,this.configurationService=c,this.environmentMainService=f,this.requestService=l,this.logService=v,this.productService=I,this._state=g.State.Uninitialized,this._onStateChange=new n.Emitter,this.onStateChange=this._onStateChange.event,b.when(3).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt){this.setState(g.State.Disabled(0));return}if(this.environmentMainService.disableUpdates){this.setState(g.State.Disabled(1)),this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.setState(g.State.Disabled(3)),this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.configurationService.getValue("update.mode"),c=this.getProductQuality(b);if(!c){this.setState(g.State.Disabled(2)),this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(c),!this.url){this.setState(g.State.Disabled(4)),this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(g.State.Idle(this.getUpdateType())),b==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,f=>this.logService.error(f))}getProductQuality(b){return b==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(b=60*60*1e3){return(0,E.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(b){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(b)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(b){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(b=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},A.CancellationToken.None)).res.statusCode===204}catch(c){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(c);return}}async _applySpecificUpdate(b){}getUpdateType(){return 1}doQuitAndInstall(){}};e.AbstractUpdateService=u,e.AbstractUpdateService=u=Ee([Y(0,P.ILifecycleMainService),Y(1,_.IConfigurationService),Y(2,D.IEnvironmentMainService),Y(3,m.IRequestService),Y(4,h.ILogService),Y(5,d.IProductService)],u)}),define(ee[291],te([0,1,14,55,3,2,18,28,20,5,22,51,25,48,101]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let b=class extends y.AbstractUpdateService{get onRawError(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"error",(f,l)=>l)}get onRawUpdateNotAvailable(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(f,l,v)=>({url:l,version:v,productVersion:v}))}get onRawUpdateDownloaded(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(f,l,v,I)=>({releaseNotes:l,version:v,productVersion:v,date:I}))}constructor(f,l,v,I,p,t,a){super(f,l,I,p,t,a),this.telemetryService=v,this.disposables=new _.DisposableStore,f.setRelaunchHandler(this)}handleRelaunch(f){return f?.addArgs||f?.removeArgs||this.state.type!=="ready"?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(f){this.logService.error("UpdateService error:",f);const l=this.state.type==="checking for updates"&&this.state.explicit?f:void 0;this.setState(u.State.Idle(1,l))}buildUpdateFeedUrl(f){let l;this.productService.darwinUniversalAssetId?l=this.productService.darwinUniversalAssetId:l=process.arch==="x64"?"darwin":"darwin-arm64";const v=(0,y.createUpdateURL)(l,f,this.productService);try{E.autoUpdater.setFeedURL({url:v})}catch(I){this.logService.error("Failed to set update feed URL",I);return}return v}doCheckForUpdates(f){this.setState(u.State.CheckingForUpdates(f)),E.autoUpdater.checkForUpdates()}onUpdateAvailable(f){this.state.type==="checking for updates"&&this.setState(u.State.Downloading(f))}onUpdateDownloaded(f){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:f.version}),this.setState(u.State.Ready(f)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(u.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};e.DarwinUpdateService=b,Ee([A.memoize],b.prototype,"onRawError",null),Ee([A.memoize],b.prototype,"onRawUpdateNotAvailable",null),Ee([A.memoize],b.prototype,"onRawUpdateAvailable",null),Ee([A.memoize],b.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=b=Ee([Y(0,h.ILifecycleMainService),Y(1,D.IConfigurationService),Y(2,S.ITelemetryService),Y(3,P.IEnvironmentMainService),Y(4,g.IRequestService),Y(5,d.ILogService),Y(6,m.IProductService)],b)}),define(ee[292],te([0,1,47,45,8,3,9,28,20,5,25,48]),function(H,e,E,A,n,_,D,P,h,d,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{get state(){return this._state}setState(b){this.logService.info("update#setState",b.type),this._state=b,this._onStateChange.fire(b)}constructor(b,c,f){if(this.lifecycleMainService=b,this.logService=f,this._state=g.State.Uninitialized,this._onStateChange=new _.Emitter,this.onStateChange=this._onStateChange.event,c.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(g.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,l=>this.logService.error(l))}scheduleCheckForUpdates(b=60*60*1e3){return(0,n.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(b){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(b)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(b){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(b=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(b){}};S=Ee([Y(0,h.ILifecycleMainService),Y(1,P.IEnvironmentMainService),Y(2,d.ILogService)],S);let u=class extends S{constructor(b,c,f,l,v,I){super(f,l,v),this.snap=b,this.snapRevision=c,this.telemetryService=I;const p=(0,A.watch)(D.dirname(this.snap)),t=_.Event.fromNodeEventEmitter(p,"change",(r,o)=>o),a=_.Event.filter(t,r=>r==="current"),i=_.Event.debounce(a,(r,o)=>o,2e3)(()=>this.checkForUpdates(!1));f.onWillShutdown(()=>{i.dispose(),p.close()})}doCheckForUpdates(){this.setState(g.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(b=>{b?this.setState(g.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(g.State.Idle(2)))},b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(g.State.Idle(2,b.message||b))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const b=await new Promise((f,l)=>(0,A.realpath)(`${D.dirname(this.snap)}/current`,(v,I)=>v?l(v):f(I))),c=D.basename(b);return this.snapRevision!==c}isLatestVersion(){return this.isUpdateAvailable().then(void 0,b=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=u,e.SnapUpdateService=u=Ee([Y(2,h.ILifecycleMainService),Y(3,P.IEnvironmentMainService),Y(4,d.ILogService),Y(5,m.ITelemetryService)],u)}),define(ee[293],te([0,1,2,20,53,30,8,29]),function(H,e,E,A,n,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let h=class extends E.Disposable{constructor(m,g,S){super(),this.userDataProfilesService=g,this.windowsMainService=S,this._register(m.onWillLoadWindow(u=>{u.reason===2&&this.unsetProfileForWorkspace(u.window)})),this._register(m.onBeforeCloseWindow(u=>this.unsetProfileForWorkspace(u))),this._register(new D.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(m){const g=this.getWorkspace(m),S=this.userDataProfilesService.getProfileForWorkspace(g);S?.isTransient&&(this.userDataProfilesService.unsetWorkspace(g,S.isTransient),S.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(m){return m.openedWorkspace??(0,_.toWorkspaceIdentifier)(m.backupPath,m.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const m=this.userDataProfilesService.getAssociatedEmptyWindows();if(m.length===0)return;const g=this.windowsMainService.getWindows().map(S=>this.getWorkspace(S));for(const S of m)g.some(u=>u.id===S.id)||this.userDataProfilesService.unsetWorkspace(S,!1)}};e.UserDataProfilesHandler=h,e.UserDataProfilesHandler=h=Ee([Y(0,A.ILifecycleMainService),Y(1,n.IUserDataProfilesMainService),Y(2,P.IWindowsMainService)],h)}),define(ee[62],te([0,1,14,2,3,5,312,8,15,29,70,25,20,73,37,4,132]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function l(p){return typeof p.responseWindowId=="number"}let v=class extends A.Disposable{static{f=this}static{this.ID_COUNTER=0}static{this.all=new Map}static getAll(){return Array.from(f.all.values())}constructor(t,a,s){super(),this.logService=t,this.telemetryService=a,this.lifecycleMainService=s,this.id=String(++f.ID_COUNTER),this._onStdout=this._register(new n.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new n.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new n.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new n.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0}log(t,a){let s;switch(this.configuration?.correlationId?s=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`,a){case m.default.Error:this.logService.error(s);break;case m.default.Warning:this.logService.warn(s);break;case m.default.Info:this.logService.trace(s);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(t){const a=this.doStart(t);return a&&t.payload&&this.postMessage(t.payload),a}doStart(t){if(!this.validateCanStart())return!1;this.configuration=t;const a=`${this.configuration.type}-${this.id}`,s=h.FileAccess.asFileUri("bootstrap-fork.js").fsPath,i=this.configuration.args??[],r=this.configuration.execArgv??[],o=this.configuration.allowLoadingUnsignedLibraries,w=this.configuration.forceAllocationsToV8Sandbox,k="pipe",M=this.createEnv(t);return this.log("creating new...",m.default.Info),this.process=E.utilityProcess.fork(s,i,{serviceName:a,env:M,execArgv:r,allowLoadingUnsignedLibraries:o,forceAllocationsToV8Sandbox:w,stdio:k}),this.registerListeners(this.process,this.configuration,a),!0}createEnv(t){const a=t.env?{...t.env}:{...(0,y.deepClone)(process.env)};a.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(a.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),a.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,b.isWindows&&((0,c.isUNCAccessRestrictionsDisabled)()?a.NODE_DISABLE_UNC_ACCESS_CHECKS="1":a.NODE_UNC_HOST_ALLOWLIST=(0,c.getUNCHostAllowlist)().join("\\")),(0,u.removeDangerousEnvVariables)(a);for(const s of Object.keys(a))a[s]=String(a[s]);return a}registerListeners(t,a,s){if(t.stdout){const i=new D.StringDecoder("utf-8");this._register(n.Event.fromNodeEventEmitter(t.stdout,"data")(r=>this._onStdout.fire(typeof r=="string"?r:i.write(r))))}if(t.stderr){const i=new D.StringDecoder("utf-8");this._register(n.Event.fromNodeEventEmitter(t.stderr,"data")(r=>this._onStderr.fire(typeof r=="string"?r:i.write(r))))}this._register(n.Event.fromNodeEventEmitter(t,"message")(i=>this._onMessage.fire(i))),this._register(n.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.processPid=t.pid,typeof t.pid=="number"&&f.all.set(t.pid,{pid:t.pid,name:l(a)?`${a.type} [${a.responseWindowId}]`:a.type}),this.log("successfully created",m.default.Info)})),this._register(n.Event.fromNodeEventEmitter(t,"exit")(i=>{this.log(`received exit event with code ${i}`,m.default.Info),this._onExit.fire({pid:this.processPid,code:i,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(n.Event.fromNodeEventEmitter(E.app,"child-process-gone",(i,r)=>({event:i,details:r}))(({details:i})=>{i.type==="Utility"&&i.name===s&&(this.log(`crashed with code ${i.exitCode} and reason '${i.reason}'`,m.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:a.type,reason:i.reason,code:i.exitCode}),this._onCrash.fire({pid:this.processPid,code:i.exitCode,reason:i.reason}),this.onDidExitOrCrashOrKill())}))}once(t,a){const s=this._register(this._onMessage.event(i=>{i===t&&(s.dispose(),a())}))}postMessage(t,a){this.process&&this.process.postMessage(t,a)}connect(t){const{port1:a,port2:s}=new E.MessageChannelMain;return this.postMessage(t,[s]),a}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",m.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",m.default.Info),this.process.kill()?(this.log("successfully killed the process",m.default.Info),this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",m.default.Warning)}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&f.all.delete(this.processPid),this.process=void 0}async waitForExit(t){this.process&&(this.log("waiting to exit...",m.default.Info),await Promise.race([n.Event.toPromise(this.onExit),(0,P.timeout)(t)]),this.process&&(this.log(`did not exit within ${t}ms, will kill it now...`,m.default.Info),this.kill()))}};e.UtilityProcess=v,e.UtilityProcess=v=f=Ee([Y(0,_.ILogService),Y(1,g.ITelemetryService),Y(2,S.ILifecycleMainService)],v);let I=class extends v{constructor(t,a,s,i){super(t,s,i),this.windowsMainService=a}start(t){const a=this.windowsMainService.getWindowById(t.responseWindowId);if(!a?.win||a.win.isDestroyed()||a.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.doStart(t))return!1;this.registerWindowListeners(a.win,t);const i=this.connect(t.payload);return a.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}registerWindowListeners(t,a){a.windowLifecycleBound&&(this._register(n.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this._register(n.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=I,e.WindowUtilityProcess=I=Ee([Y(0,_.ILogService),Y(1,d.IWindowsMainService),Y(2,g.ITelemetryService),Y(3,S.ILifecycleMainService)],I)}),define(ee[294],te([0,1,13,5,20,8,62,29,25]),function(H,e,E,A,n,_,D,P,h){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let m=class{static{d=this}static{this._lastId=0}constructor(S,u,y,b){this._logService=S,this._lifecycleMainService=u,this._windowsMainService=y,this._telemetryService=b,this._extHosts=new Map,this._shutdown=!1,this._lifecycleMainService.onWillShutdown(c=>{this._shutdown=!0,c.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(S){const u=this._extHosts.get(S);if(!u)throw new Error("Unknown extension host!");return u}onDynamicStdout(S){return this._getExtHost(S).onStdout}onDynamicStderr(S){return this._getExtHost(S).onStderr}onDynamicMessage(S){return this._getExtHost(S).onMessage}onDynamicExit(S){return this._getExtHost(S).onExit}async createExtensionHost(){if(this._shutdown)throw(0,E.canceled)();const S=String(++d._lastId),u=new D.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);return this._extHosts.set(S,u),u.onExit(({pid:y,code:b,signal:c})=>{this._logService.info(`Extension host with pid ${y} exited with code: ${b}, signal: ${c}.`),setTimeout(()=>{u.dispose(),this._extHosts.delete(S)})}),{id:S}}async start(S,u){if(this._shutdown)throw(0,E.canceled)();this._getExtHost(S).start({...u,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:u.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:S})}async enableInspectPort(S){if(this._shutdown)throw(0,E.canceled)();const u=this._extHosts.get(S);return u?u.enableInspectPort():!1}async kill(S){if(this._shutdown)throw(0,E.canceled)();const u=this._extHosts.get(S);u&&u.kill()}async _killAllNow(){for(const[,S]of this._extHosts)S.kill()}async _waitForAllExit(S){const u=[];for(const[,y]of this._extHosts)u.push(y.waitForExit(S));return _.Promises.settled(u).then(()=>{})}};e.ExtensionHostStarter=m,e.ExtensionHostStarter=m=d=Ee([Y(0,A.ILogService),Y(1,n.ILifecycleMainService),Y(2,P.IWindowsMainService),Y(3,h.ITelemetryService)],m)}),define(ee[295],te([0,1,38,8,2,28,20,5,41,39,66,62,52,90,12,246,22]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let f=class extends n.Disposable{constructor(v,I,p,t,a,s,i,r){super(),this.machineId=v,this.environmentMainService=I,this.userDataProfilesService=p,this.lifecycleMainService=t,this.logService=a,this.loggerMainService=s,this.policyService=i,this.productService=r,this.firstWindowConnectionBarrier=new A.Barrier,this.utilityProcess=void 0,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){E.validatedIpcMain.on(b.SharedProcessChannelConnection.request,(v,I)=>this.onWindowConnection(v,I,b.SharedProcessChannelConnection.response)),E.validatedIpcMain.on(b.SharedProcessRawConnection.request,(v,I)=>this.onWindowConnection(v,I,b.SharedProcessRawConnection.response)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(v,I,p){this.logService.trace(`[SharedProcess] onWindowConnection for: ${p}`),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const t=await this.connect(p);if(v.sender.isDestroyed())return t.close();v.sender.postMessage(p,I,[t])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage(b.SharedProcessLifecycle.exit),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const v=new A.DeferredPromise;this.utilityProcess?this.utilityProcess.once(b.SharedProcessLifecycle.initDone,()=>v.complete()):E.validatedIpcMain.once(b.SharedProcessLifecycle.initDone,()=>v.complete()),await v.p,this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const v=new A.DeferredPromise;this.utilityProcess?this.utilityProcess.once(b.SharedProcessLifecycle.ipcReady,()=>v.complete()):E.validatedIpcMain.once(b.SharedProcessLifecycle.ipcReady,()=>v.complete()),await v.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new g.UtilityProcess(this.logService,S.NullTelemetryService,this.lifecycleMainService));const v=(0,u.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let I;v.port&&(I=["--nolazy"],v.break?I.push(`--inspect-brk=${v.port}`):I.push(`--inspect=${v.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:I,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.productService.quality!=="stable"})}createSharedProcessConfiguration(){return{machineId:this.machineId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(v){return await this.whenIpcReady,(0,y.assertIsDefined)(this.utilityProcess).connect(v)}};e.SharedProcess=f,e.SharedProcess=f=Ee([Y(1,_.IEnvironmentMainService),Y(2,h.IUserDataProfilesService),Y(3,D.ILifecycleMainService),Y(4,P.ILogService),Y(5,m.ILoggerMainService),Y(6,d.IPolicyService),Y(7,c.IProductService)],f)}),define(ee[296],te([0,1,28,90,20,5,52,62,111,38,2,3,37,18]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let y=class extends m.Disposable{constructor(c,f,l,v,I){super(),this._reconnectConstants=c,this._configurationService=f,this._environmentMainService=l,this._lifecycleMainService=v,this._logService=I,this.utilityProcess=void 0,this._onRequestConnection=new g.Emitter,this.onRequestConnection=this._onRequestConnection.event,this._onWillShutdown=new g.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire()),d.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(p,t)=>this._onWindowConnection(p,t)),this._register((0,m.toDisposable)(()=>{d.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.utilityProcess=new P.UtilityProcess(this._logService,D.NullTelemetryService,this._lifecycleMainService);const c=(0,A.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),f=c.port?["--nolazy",`--inspect${c.break?"-brk":""}=${c.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:f,args:["--logsPath",this._environmentMainService.logsHome.fsPath],env:this._createPtyHostConfiguration()});const l=this.utilityProcess.connect(),v=new h.Client(l,"ptyHost"),I=new m.DisposableStore;return I.add(v),I.add((0,m.toDisposable)(()=>{this.utilityProcess?.kill(),this.utilityProcess?.dispose(),this.utilityProcess=void 0})),{client:v,store:I,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(){this._environmentMainService.unsetSnapExportedVariables();const c={...(0,S.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},f=this._configurationService.getValue("terminal.integrated.developer.ptyHost.latency");f&&typeof f=="number"&&(c.VSCODE_LATENCY=String(f));const l=this._configurationService.getValue("terminal.integrated.developer.ptyHost.startupDelay");return l&&typeof l=="number"&&(c.VSCODE_STARTUP_DELAY=String(l)),this._environmentMainService.restoreSnapExportedVariables(),c}_onWindowConnection(c,f){this._onRequestConnection.fire();const l=this.utilityProcess.connect();if(c.sender.isDestroyed()){l.close();return}c.sender.postMessage("vscode:createPtyHostMessageChannelResult",f,[l])}};e.ElectronPtyHostStarter=y,e.ElectronPtyHostStarter=y=Ee([Y(1,u.IConfigurationService),Y(2,E.IEnvironmentMainService),Y(3,n.ILifecycleMainService),Y(4,_.ILogService)],y)}),define(ee[297],te([0,1,2,6,5,29,62,25,57,3,8,20]),function(H,e,E,A,n,_,D,P,h,d,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,A.createDecorator)("utilityProcessWorker");let S=class extends E.Disposable{constructor(b,c,f,l){super(),this.logService=b,this.windowsMainService=c,this.telemetryService=f,this.lifecycleMainService=l,this.workers=new Map}async createWorker(b){const c=`window: ${b.reply.windowId}, moduleId: ${b.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${c})`);const f=this.hash(b);this.workers.has(f)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${c})`),this.disposeWorker(b));const l=new u(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,b);if(!l.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(f,l);const v=new m.DeferredPromise;return d.Event.once(l.onDidTerminate)(I=>{I.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${I.code}, signal: ${I.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${I.code}, signal: ${I.signal}`),this.workers.delete(f),v.complete({reason:I})}),v.p}hash(b){return(0,h.hash)({moduleId:b.process.moduleId,windowId:b.reply.windowId})}async disposeWorker(b){const c=this.hash(b),f=this.workers.get(c);f&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${b.reply.windowId}, moduleId: ${b.process.moduleId})`),f.kill(),this.workers.delete(c))}};e.UtilityProcessWorkerMainService=S,e.UtilityProcessWorkerMainService=S=Ee([Y(0,n.ILogService),Y(1,_.IWindowsMainService),Y(2,P.ITelemetryService),Y(3,g.ILifecycleMainService)],S);let u=class extends E.Disposable{constructor(b,c,f,l,v){super(),this.logService=b,this.windowsMainService=c,this.telemetryService=f,this.lifecycleMainService=l,this.configuration=v,this._onDidTerminate=this._register(new d.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new D.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(b=>this._onDidTerminate.fire({code:b.code,signal:b.signal}))),this._register(this.utilityProcess.onCrash(b=>this._onDidTerminate.fire({code:b.code,signal:"ECRASH"})))}spawn(){const c=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:c,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};u=Ee([Y(0,n.ILogService),Y(1,_.IWindowsMainService),Y(2,P.ITelemetryService),Y(3,g.ILifecycleMainService)],u)}),define(ee[298],te([0,1,14,2,4,19,7,18,20,5,34,29,129,30]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let b=class extends A.Disposable{static{y=this}static{this.windowsStateStorageKey="windowsState"}get state(){return this._state}constructor(p,t,a,s,i){super(),this.windowsMainService=p,this.stateService=t,this.lifecycleMainService=a,this.logService=s,this.configurationService=i,this._state=c(this.stateService.getItem(y.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){E.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(p=>this.onBeforeCloseWindow(p)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(p=>{p.newCount-p.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(p=>this.onBeforeCloseWindow(p))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const p=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!t.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.toWindowState(i),t.lastActiveWindow.uiState.mode===3&&p.add(t.lastActiveWindow.uiState.display))}const a=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);a&&(t.lastPluginDevelopmentHostWindow=this.toWindowState(a),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(p.has(t.lastPluginDevelopmentHostWindow.uiState.display)?n.isMacintosh&&!a.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):p.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(t.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const r=this.toWindowState(i);return r.uiState.mode===3&&(p.has(r.uiState.display)?n.isMacintosh&&r.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(r.uiState.mode=1):p.add(r.uiState.display)),r}));const s=l(t);this.stateService.setItem(y.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(p){if(this.lifecycleMainService.quitRequested)return;const t=this.toWindowState(p);p.isExtensionDevelopmentHost&&!p.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=t:!p.isExtensionDevelopmentHost&&p.openedWorkspace&&this._state.openedWindows.forEach(a=>{const s=(0,u.isWorkspaceIdentifier)(p.openedWorkspace)&&a.workspace?.id===p.openedWorkspace.id,i=(0,u.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&a.folderUri&&_.extUriBiasedIgnorePathCase.isEqual(a.folderUri,p.openedWorkspace.uri);(s||i)&&(a.uiState=t.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=t)}toWindowState(p){return{windowId:p.id,workspace:(0,u.isWorkspaceIdentifier)(p.openedWorkspace)?p.openedWorkspace:void 0,folderUri:(0,u.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)?p.openedWorkspace.uri:void 0,backupPath:p.backupPath,remoteAuthority:p.remoteAuthority,uiState:p.serializeWindowState()}}getNewWindowState(p){const t=this.doGetNewWindowState(p),a=this.configurationService.getValue("window");if(t.mode===3){let s;t.hasDefaultState?s=!!(a?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(a.newWindowDimensions)>=0):s=!!(this.lifecycleMainService.wasRestarted||a?.restoreFullscreen),s||(t.mode=1)}return t}doGetNewWindowState(p){const t=this.windowsMainService.getLastActiveWindow();if(!p.extensionTestsPath){if(p.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const w=p.workspace;if((0,u.isWorkspaceIdentifier)(w)){const M=this.state.openedWindows.filter(C=>C.workspace&&C.workspace.id===w.id).map(C=>C.uiState);if(M.length)return M[0]}if((0,u.isSingleFolderWorkspaceIdentifier)(w)){const M=this.state.openedWindows.filter(C=>C.folderUri&&_.extUriBiasedIgnorePathCase.isEqual(C.folderUri,w.uri)).map(C=>C.uiState);if(M.length)return M[0]}else if(p.backupPath){const M=this.state.openedWindows.filter(C=>C.backupPath===p.backupPath).map(C=>C.uiState);if(M.length)return M[0]}const k=this.lastClosedState||this.state.lastActiveWindow;if(!t&&k)return k.uiState}let a;const s=E.screen.getAllDisplays();if(s.length===1)a=s[0];else{if(n.isMacintosh){const w=E.screen.getCursorScreenPoint();a=E.screen.getDisplayNearestPoint(w)}!a&&t&&(a=E.screen.getDisplayMatching(t.getBounds())),a||(a=E.screen.getPrimaryDisplay()||s[0])}let i=(0,S.defaultWindowState)();i.x=Math.round(a.bounds.x+a.bounds.width/2-i.width/2),i.y=Math.round(a.bounds.y+a.bounds.height/2-i.height/2);const r=this.configurationService.getValue("window");let o=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(r.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&t){const w=t.serializeWindowState();w.mode===3?i.mode=3:i=w,o=i.mode!==3&&r.newWindowDimensions==="offset"}}return o&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(p){if(this.windowsMainService.getWindows().length===0)return p;p.x=typeof p.x=="number"?p.x:0,p.y=typeof p.y=="number"?p.y:0;const t=this.windowsMainService.getWindows().map(a=>a.getBounds());for(;t.some(a=>a.x===p.x||a.y===p.y);)p.x+=30,p.y+=30;return p}};e.WindowsStateHandler=b,e.WindowsStateHandler=b=y=Ee([Y(0,g.IWindowsMainService),Y(1,m.IStateService),Y(2,h.ILifecycleMainService),Y(3,d.ILogService),Y(4,P.IConfigurationService)],b);function c(I){const p={openedWindows:[]},t=I||{openedWindows:[]};return t.lastActiveWindow&&(p.lastActiveWindow=f(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(p.lastPluginDevelopmentHostWindow=f(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(p.openedWindows=t.openedWindows.map(a=>f(a))),p}e.restoreWindowsState=c;function f(I){const p={uiState:I.uiState};return I.backupPath&&(p.backupPath=I.backupPath),I.remoteAuthority&&(p.remoteAuthority=I.remoteAuthority),I.folder&&(p.folderUri=D.URI.parse(I.folder)),I.workspaceIdentifier&&(p.workspace={id:I.workspaceIdentifier.id,configPath:D.URI.parse(I.workspaceIdentifier.configURIPath)}),p}function l(I){return{lastActiveWindow:I.lastActiveWindow&&v(I.lastActiveWindow),lastPluginDevelopmentHostWindow:I.lastPluginDevelopmentHostWindow&&v(I.lastPluginDevelopmentHostWindow),openedWindows:I.openedWindows.map(p=>v(p))}}e.getWindowsStateStoreData=l;function v(I){return{workspaceIdentifier:I.workspace&&{id:I.workspace.id,configURIPath:I.workspace.configPath.toString()},folder:I.folderUri&&I.folderUri.toString(),backupPath:I.backupPath,remoteAuthority:I.remoteAuthority,uiState:I.uiState}}}),define(ee[54],te([0,1,14,3,44,2,15,9,19,21,192,64,61,28,6,5,53,131,30,98,99]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f,l,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,y.createDecorator)("workspacesManagementMainService");let p=class extends _.Disposable{constructor(a,s,i,r,o){super(),this.environmentMainService=a,this.logService=s,this.userDataProfilesMainService=i,this.backupMainService=r,this.dialogMainService=o,this._onDidDeleteUntitledWorkspace=this._register(new A.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new A.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const a=(await d.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(s=>(0,h.joinPath)(this.untitledWorkspacesHome,s,l.UNTITLED_WORKSPACE_NAME));for(const s of a){const i=(0,I.getWorkspaceIdentifier)(s),r=await this.resolveLocalWorkspace(s);r?this.untitledWorkspaces.push({workspace:i,remoteAuthority:r.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(a){a.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${a}).`)}}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,s=>d.Promises.readFile(s,"utf8"))}doResolveLocalWorkspace(a,s){if(this.isWorkspacePath(a)&&a.scheme===D.Schemas.file)try{const i=s(a.fsPath);return i instanceof Promise?i.then(r=>this.doResolveWorkspace(a,r),r=>{}):this.doResolveWorkspace(a,i)}catch{return}}isWorkspacePath(a){return(0,l.isUntitledWorkspace)(a,this.environmentMainService)||(0,l.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,s){try{const i=this.doParseStoredWorkspace(a,s),r=(0,I.getWorkspaceIdentifier)(a);return{id:r.id,configPath:r.configPath,folders:(0,v.toWorkspaceFolders)(i.folders,r.configPath,h.extUriBiasedIgnorePathCase),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.logService.warn(i.toString())}}doParseStoredWorkspace(a,s){const i=(0,n.parse)(s);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(r=>(0,v.isStoredWorkspaceFolder)(r));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(a,s){const{workspace:i,storedWorkspace:r}=this.newUntitledWorkspace(a,s),o=i.configPath.fsPath;return await d.Promises.mkdir((0,P.dirname)(o),{recursive:!0}),await d.Promises.writeFile(o,JSON.stringify(r,null,"	")),this.untitledWorkspaces.push({workspace:i,remoteAuthority:s}),i}newUntitledWorkspace(a=[],s){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),r=(0,h.joinPath)(this.untitledWorkspacesHome,i),o=(0,h.joinPath)(r,l.UNTITLED_WORKSPACE_NAME),w=[];for(const k of a)w.push((0,v.getStoredWorkspaceFolder)(k.uri,!0,k.name,r,h.extUriBiasedIgnorePathCase));return{workspace:(0,I.getWorkspaceIdentifier)(o),storedWorkspace:{folders:w,remoteAuthority:s}}}async getWorkspaceIdentifier(a){return(0,I.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,l.isUntitledWorkspace)(a.configPath,this.environmentMainService)}async deleteUntitledWorkspace(a){this.isUntitledWorkspace(a)&&(await this.doDeleteUntitledWorkspace(a),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(a),this._onDidDeleteUntitledWorkspace.fire(a))}async doDeleteUntitledWorkspace(a){const s=(0,h.originalFSPath)(a.configPath);try{await d.Promises.rm((0,P.dirname)(s));const i=(0,P.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);await d.Promises.exists(i)&&await d.Promises.writeFile((0,P.join)(i,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(r=>r.workspace.id!==a.id)}catch(i){this.logService.warn(`Unable to delete untitled workspace ${s} (${i}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(a,s,i){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,s,i))return;const o=await this.doEnterWorkspace(a,(0,I.getWorkspaceIdentifier)(i));if(o)return this._onDidEnterWorkspace.fire({window:a,workspace:o.workspace}),o}async isValidTargetWorkspacePath(a,s,i){return i?(0,l.isWorkspaceIdentifier)(a.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,i)?!1:(0,f.findWindowOnWorkspaceOrFolder)(s,i)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:(0,m.localize)(1,null,(0,h.basename)(i)),detail:(0,m.localize)(2,null)},E.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async doEnterWorkspace(a,s){if(!a.config)return;a.focus();let i;return a.config.extensionDevelopmentPath||(a.config.backupPath?i=await this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:a.remoteAuthority},a.config.backupPath):i=this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:a.remoteAuthority})),(0,l.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&await this.deleteUntitledWorkspace(a.openedWorkspace),a.config.workspace=s,a.config.backupPath=i,{workspace:s,backupPath:i}}};e.WorkspacesManagementMainService=p,e.WorkspacesManagementMainService=p=Ee([Y(0,u.IEnvironmentMainService),Y(1,b.ILogService),Y(2,c.IUserDataProfilesMainService),Y(3,g.IBackupMainService),Y(4,S.IDialogMainService)],p)}),define(ee[133],te([0,1,14,38,23,6,29,30,54,12,5,62]),function(H,e,E,A,n,_,D,P,h,d,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,_.createDecorator)(e.ID);let S=class{constructor(y,b,c){this.windowsMainService=y,this.workspacesManagementMainService=b,this.logService=c}async getRemoteDiagnostics(y){const b=this.windowsMainService.getWindows();return(await Promise.all(b.map(async f=>{const l=f.remoteAuthority;if(!l)return;const v=`vscode:getDiagnosticInfoResponse${f.id}`,I={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.getFolderURIs(f):void 0};return new Promise(p=>{f.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:v,args:I}),A.validatedIpcMain.once(v,(t,a)=>{a||p({hostName:l,errorMessage:`Unable to resolve connection to '${l}'.`}),p(a)}),setTimeout(()=>{p({hostName:l,errorMessage:`Connection to '${l}' could not be established`})},5e3)})}))).filter(f=>!!f)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const y=[];for(const c of E.BrowserWindow.getAllWindows()){const f=this.windowsMainService.getWindowById(c.id);f?y.push(await this.codeWindowToInfo(f)):y.push(this.browserWindowToInfo(c))}const b=[];for(const{pid:c,name:f}of g.UtilityProcess.getAll())b.push({pid:c,name:f});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:b,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async codeWindowToInfo(y){const b=await this.getFolderURIs(y),c=(0,d.assertIsDefined)(y.win);return this.browserWindowToInfo(c,b,y.remoteAuthority)}browserWindowToInfo(y,b=[],c){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:b,remoteAuthority:c}}async getFolderURIs(y){const b=[],c=y.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(c))b.push(c.uri);else if((0,P.isWorkspaceIdentifier)(c)){const f=await this.workspacesManagementMainService.resolveLocalWorkspace(c.configPath);f&&f.folders.forEach(v=>{b.push(v.uri)})}return b}};e.DiagnosticsMainService=S,e.DiagnosticsMainService=S=Ee([Y(0,D.IWindowsMainService),Y(1,h.IWorkspacesManagementMainService),Y(2,m.ILogService)],S)}),define(ee[67],te([0,1,47,14,27,155,55,3,2,15,9,4,7,106,87,21,104,180,61,28,6,20,5,22,80,29,30,54,17,242,234]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f,l,v,I,p,t,a,s,i,r,o,w,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,I.createDecorator)("nativeHostMainService");let C=class extends h.Disposable{constructor(T,F,B,se,ie,de,ae,ue){super(),this.windowsMainService=T,this.dialogMainService=F,this.lifecycleMainService=B,this.environmentMainService=se,this.logService=ie,this.productService=de,this.themeMainService=ae,this.workspacesManagementMainService=ue,this.onDidOpenWindow=P.Event.map(this.windowsMainService.onDidOpenWindow,x=>x.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:x,x:G,y:z})=>({windowId:x.id,x:G,y:z})),({windowId:x})=>!!this.windowsMainService.getWindowById(x)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-maximize",(x,G)=>G.id),x=>!!this.windowsMainService.getWindowById(x)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-unmaximize",(x,G)=>G.id),x=>!!this.windowsMainService.getWindowById(x)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(x,G)=>G.id),x=>!!this.windowsMainService.getWindowById(x)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),x=>!!x),x=>x.id),P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(x,G)=>G.id),x=>!!this.windowsMainService.getWindowById(x))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(A.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new P.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(A.screen,"display-metrics-changed",(x,G,z)=>z),x=>!(Array.isArray(x)&&x.length===1&&x[0]==="workArea")),P.Event.fromNodeEventEmitter(A.screen,"display-added"),P.Event.fromNodeEventEmitter(A.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(F=>({id:F.id,workspace:F.openedWorkspace??(0,r.toWorkspaceIdentifier)(F.backupPath,F.isExtensionDevelopmentHost),title:F.win?.getTitle()??"",filename:F.getRepresentedFilename(),dirty:F.isDocumentEdited()}))}async getWindowCount(T){return this.windowsMainService.getWindowCount()}async getActiveWindowId(T){const F=A.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(F)return F.id}openWindow(T,F,B){return Array.isArray(F)?this.doOpenWindow(T,F,B):this.doOpenEmptyWindow(T,F)}async doOpenWindow(T,F,B=Object.create(null)){F.length>0&&await this.windowsMainService.open({context:5,contextWindowId:T,urisToOpen:F,cli:this.environmentMainService.args,forceNewWindow:B.forceNewWindow,forceReuseWindow:B.forceReuseWindow,preferNewWindow:B.preferNewWindow,diffMode:B.diffMode,mergeMode:B.mergeMode,addMode:B.addMode,gotoLineMode:B.gotoLineMode,noRecentEntry:B.noRecentEntry,waitMarkerFileURI:B.waitMarkerFileURI,remoteAuthority:B.remoteAuthority||void 0,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}async doOpenEmptyWindow(T,F){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:T},F)}async toggleFullScreen(T){this.windowById(T)?.toggleFullScreen()}async handleTitleDoubleClick(T){this.windowById(T)?.handleTitleDoubleClick()}async isMaximized(T){const F=this.windowById(T);return F?.win?F.win.isMaximized():!1}async maximizeWindow(T){const F=this.windowById(T);F?.win&&F.win.maximize()}async unmaximizeWindow(T){const F=this.windowById(T);F?.win&&F.win.unmaximize()}async minimizeWindow(T){const F=this.windowById(T);F?.win&&F.win.minimize()}async updateWindowControls(T,F){const B=this.windowById(T);B&&B.updateWindowControls(F)}async focusWindow(T,F){F&&typeof F.windowId=="number"&&(T=F.windowId),this.windowById(T)?.focus({force:F?.force??!1})}async setMinimumSize(T,F,B){const se=this.windowById(T);if(se?.win){const[ie,de]=se.win.getSize(),[ae,ue]=se.win.getMinimumSize(),[x,G]=[F??ae,B??ue],[z,W]=[Math.max(ie,x),Math.max(de,G)];(ae!==x||ue!==G)&&se.win.setMinimumSize(x,G),(ie!==z||de!==W)&&se.win.setSize(z,W)}}async saveWindowSplash(T,F){this.themeMainService.saveWindowSplash(T,F)}async installShellCommand(T){const{source:F,target:B}=await this.getShellCommandLink();try{const{symbolicLink:se}=await b.SymlinkSupport.stat(F);if(se&&!se.dangling){const ie=await(0,u.realpath)(F);if(B===ie)return}await b.Promises.unlink(F)}catch(se){if(se.code!=="ENOENT")throw se}try{await b.Promises.symlink(B,F)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:ie}=await this.showMessageBox(T,{type:"info",message:(0,f.localize)(0,null,this.productService.nameShort),buttons:[(0,f.localize)(1,null),(0,f.localize)(2,null)]});if(ie===0)try{const de=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${B}' '${F}'\\" with administrator privileges"`;await(0,_.promisify)(E.exec)(de)}catch{throw new Error((0,f.localize)(3,null,F))}}}async uninstallShellCommand(T){const{source:F}=await this.getShellCommandLink();try{await b.Promises.unlink(F)}catch(B){switch(B.code){case"EACCES":{const{response:se}=await this.showMessageBox(T,{type:"info",message:(0,f.localize)(4,null,this.productService.nameShort),buttons:[(0,f.localize)(5,null),(0,f.localize)(6,null)]});if(se===0)try{const ie=`osascript -e "do shell script \\"rm '${F}'\\" with administrator privileges"`;await(0,_.promisify)(E.exec)(ie)}catch{throw new Error((0,f.localize)(7,null,F))}break}case"ENOENT":break;default:throw B}}}async getShellCommandLink(){const T=(0,m.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),F=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(T))throw new Error((0,f.localize)(8,null,T));return{source:F,target:T}}async showMessageBox(T,F){return this.dialogMainService.showMessageBox(F,this.toBrowserWindow(T))}async showSaveDialog(T,F){return this.dialogMainService.showSaveDialog(F,this.toBrowserWindow(T))}async showOpenDialog(T,F){return this.dialogMainService.showOpenDialog(F,this.toBrowserWindow(T))}toBrowserWindow(T){const F=this.windowById(T);if(F?.win)return F.win}async pickFileFolderAndOpen(T,F){const B=await this.dialogMainService.pickFileFolder(F);B&&await this.doOpenPicked(await Promise.all(B.map(async se=>await b.SymlinkSupport.existsDirectory(se)?{folderUri:S.URI.file(se)}:{fileUri:S.URI.file(se)})),F,T)}async pickFolderAndOpen(T,F){const B=await this.dialogMainService.pickFolder(F);B&&await this.doOpenPicked(B.map(se=>({folderUri:S.URI.file(se)})),F,T)}async pickFileAndOpen(T,F){const B=await this.dialogMainService.pickFile(F);B&&await this.doOpenPicked(B.map(se=>({fileUri:S.URI.file(se)})),F,T)}async pickWorkspaceAndOpen(T,F){const B=await this.dialogMainService.pickWorkspace(F);B&&await this.doOpenPicked(B.map(se=>({workspaceUri:S.URI.file(se)})),F,T)}async doOpenPicked(T,F,B){await this.windowsMainService.open({context:3,contextWindowId:B,cli:this.environmentMainService.args,urisToOpen:T,forceNewWindow:F.forceNewWindow})}async showItemInFolder(T,F){A.shell.showItemInFolder(F)}async setRepresentedFilename(T,F){this.windowById(T)?.setRepresentedFilename(F)}async setDocumentEdited(T,F){this.windowById(T)?.setDocumentEdited(F)}async openExternal(T,F){return this.environmentMainService.unsetSnapExportedVariables(),A.shell.openExternal(F),this.environmentMainService.restoreSnapExportedVariables(),!0}moveItemToTrash(T,F){return A.shell.trashItem(F)}async isAdmin(){let T;return g.isWindows?T=(await new Promise((F,B)=>{H(["native-is-elevated"],F,B)}))():T=process.getuid?.()===0,T}async writeElevated(T,F,B,se){const ie=await new Promise((de,ae)=>{H(["@vscode/sudo-prompt"],de,ae)});return new Promise((de,ae)=>{const ue=[`"${this.cliPath}"`];se?.unlock&&ue.push("--file-chmod"),ue.push("--file-write",`"${F.fsPath}"`,`"${B.fsPath}"`);const x={name:this.productService.nameLong.replace("-",""),icns:g.isMacintosh&&this.environmentMainService.isBuilt?(0,m.join)((0,m.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ie.exec(ue.join(" "),x,(G,z,W)=>{z&&this.logService.trace(`[sudo-prompt] received stdout: ${z}`),W&&this.logService.trace(`[sudo-prompt] received stderr: ${W}`),G?ae(G):de(void 0)})})}async isRunningUnderARM64Translation(){return g.isLinux||g.isWindows?!1:A.app.runningUnderARM64Translation}get cliPath(){return g.isWindows?this.environmentMainService.isBuilt?(0,m.join)((0,m.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,m.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):g.isLinux?this.environmentMainService.isBuilt?(0,m.join)((0,m.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,m.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,m.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,m.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,n.totalmem)(),freemem:(0,n.freemem)(),loadavg:(0,n.loadavg)()}}async getOSProperties(){return{arch:(0,n.arch)(),platform:(0,n.platform)(),release:(0,n.release)(),type:(0,n.type)(),cpus:(0,n.cpus)()}}async getOSVirtualMachineHint(){return y.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return g.isWindows&&(0,k.hasWSLFeatureInstalled)()}async killProcess(T,F,B){process.kill(F,B)}async readClipboardText(T,F){return A.clipboard.readText(F)}async writeClipboardText(T,F,B){return A.clipboard.writeText(F,B)}async readClipboardFindText(T){return A.clipboard.readFindText()}async writeClipboardFindText(T,F){return A.clipboard.writeFindText(F)}async writeClipboardBuffer(T,F,B,se){return A.clipboard.writeBuffer(F,Buffer.from(B.buffer),se)}async readClipboardBuffer(T,F){return w.VSBuffer.wrap(A.clipboard.readBuffer(F))}async hasClipboard(T,F,B){return A.clipboard.has(F,B)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){A.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){A.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){A.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){A.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){A.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(T,F){this.windowById(T)?.updateTouchBar(F)}async notifyReady(T){this.windowById(T)?.setReady()}async relaunch(T,F){return this.lifecycleMainService.relaunch(F)}async reload(T,F){const B=this.windowById(T);if(B){if((0,r.isWorkspaceIdentifier)(B.openedWorkspace)){const se=B.openedWorkspace.configPath;if(se.scheme===d.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(se))?.transient)return this.openWindow(B.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(B,F?.disableExtensions!==void 0?{_:[],"disable-extensions":F.disableExtensions}:void 0)}}async closeWindow(T){this.closeWindowById(T,T)}async closeWindowById(T,F){const B=this.windowById(F);if(B?.win)return B.win.close()}async quit(T){const F=this.windowsMainService.getLastActiveWindow();F?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&F.win?F.win.close():this.lifecycleMainService.quit()}async exit(T,F){await this.lifecycleMainService.kill(F)}async resolveProxy(T,F){return this.windowById(T)?.win?.webContents?.session?.resolveProxy(F)}findFreePort(T,F,B,se,ie=1){return(0,c.findFreePort)(F,B,se,ie)}async openDevTools(T,F){const B=this.windowById(T);B?.win&&B.win.webContents.openDevTools(F)}async toggleDevTools(T){const F=this.windowById(T);F?.win&&F.win.webContents.toggleDevTools()}async sendInputEvent(T,F){const B=this.windowById(T);B?.win&&(F.type==="mouseDown"||F.type==="mouseUp")&&B.win.webContents.sendInputEvent(F)}async profileRenderer(T,F,B){const se=this.windowById(T);if(!se||!se.win)throw new Error;return await new M.WindowProfiler(se.win,F,this.logService).inspect(B)}async windowsGetStringRegKey(T,F,B,se){if(!g.isWindows)return;const ie=await new Promise((de,ae)=>{H(["@vscode/windows-registry"],de,ae)});try{return ie.GetStringRegKey(F,B,se)}catch{return}}windowById(T){if(typeof T=="number")return this.windowsMainService.getWindowById(T)}};e.NativeHostMainService=C,Ee([D.memoize],C.prototype,"cliPath",null),e.NativeHostMainService=C=Ee([Y(0,i.IWindowsMainService),Y(1,l.IDialogMainService),Y(2,p.ILifecycleMainService),Y(3,v.IEnvironmentMainService),Y(4,t.ILogService),Y(5,a.IProductService),Y(6,s.IThemeMainService),Y(7,o.IWorkspacesManagementMainService)],C)}),define(ee[299],te([0,1,14,38,27,2,15,4,108,178,91,133,61,28,5,67,78,22,79,81,32,34,62,23,7,29,8]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f,l,v,I,p,t,a,s,i,r){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const w="issue.processExplorerWindowState";let k=class{static{o=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(L,T,F,B,se,ie,de,ae,ue,x,G){this.userEnv=L,this.environmentMainService=T,this.logService=F,this.diagnosticsService=B,this.diagnosticsMainService=se,this.dialogMainService=ie,this.nativeHostMainService=de,this.protocolMainService=ae,this.productService=ue,this.stateService=x,this.windowsMainService=G,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){A.validatedIpcMain.on("vscode:listProcesses",async L=>{const T=[];try{T.push({name:(0,d.localize)(0,null),rootProcess:await(0,h.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(B=>{(0,m.isRemoteDiagnosticError)(B)?T.push({name:B.hostName,rootProcess:B}):B.processes&&T.push({name:B.hostName,rootProcess:B.processes})})}catch(F){this.logService.error(`Listing processes failed: ${F}`)}this.safeSend(L,"vscode:listProcessesResponse",T)}),A.validatedIpcMain.on("vscode:workbenchCommand",(L,T)=>{const{id:F,from:B,args:se}=T;let ie;switch(B){case"processExplorer":ie=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${B}`)}ie?.webContents.send("vscode:runAction",{id:F,from:B,args:se})}),A.validatedIpcMain.on("vscode:closeProcessExplorer",L=>{this.processExplorerWindow?.close()}),A.validatedIpcMain.on("vscode:pidToNameRequest",async L=>{const T=await this.diagnosticsMainService.getMainDiagnostics(),F=[];for(const B of T.windows)F.push([B.pid,`window [${B.id}] (${B.title})`]);for(const{pid:B,name:se}of t.UtilityProcess.getAll())F.push([B,se]);this.safeSend(L,"vscode:pidToNameResponse",F)})}async openReporter(L){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=E.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const T=new _.DisposableStore,F=T.add(this.protocolMainService.createIPCObjectUrl()),B=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(B,F,{backgroundColor:L.styles.backgroundColor,title:(0,d.localize)(1,null),zoomLevel:L.zoomLevel,alwaysOnTop:!1},"issue-reporter"),F.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:L,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:c.default}),this.issueReporterWindow.loadURL(D.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,T.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,T.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(L){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=E.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const T=new _.DisposableStore,F=T.add(this.protocolMainService.createIPCObjectUrl()),B=this.stateService.getItem(w,void 0),se=M(B)?B:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(se,F,{backgroundColor:L.styles.backgroundColor,title:(0,d.localize)(2,null),zoomLevel:L.zoomLevel,alwaysOnTop:!0},"process-explorer"),F.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:L,product:c.default}),this.processExplorerWindow.loadURL(D.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,T.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,T.dispose())});const ie=()=>{if(!this.processExplorerWindow)return;const de=this.processExplorerWindow.getSize(),ae=this.processExplorerWindow.getPosition();if(!de||!ae)return;const ue={width:de[0],height:de[1],x:ae[0],y:ae[1]};this.stateService.setItem(w,ue)};this.processExplorerWindow.on("moved",ie),this.processExplorerWindow.on("resized",ie)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}async stopTracing(){if(!this.environmentMainService.args.trace)return;const L=await E.contentTracing.stopRecording(`${(0,I.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null,L),buttons:[(0,d.localize)(5,null)]},E.BrowserWindow.getFocusedWindow()??void 0),this.nativeHostMainService.showItemInFolder(void 0,L)}async getSystemStatus(){const[L,T]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(L,T)}async $getSystemInfo(){const[L,T]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(L,T)}async $getPerformanceInfo(){try{const[L,T]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(L,T)}catch(L){throw this.logService.warn("issueService#getPerformanceInfo ",L.message),L}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(L){this.logService.error(L)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:L}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,d.localize)(6,null),buttons:[(0,d.localize)(7,null),(0,d.localize)(8,null)]},this.issueReporterWindow);L===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:L}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,d.localize)(9,null),buttons:[(0,d.localize)(10,null),(0,d.localize)(11,null)]},this.issueReporterWindow);return L===0}return!1}async $getIssueReporterUri(L){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const T=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!T)throw new Error("Window not found");const F=`vscode:triggerIssueUriRequestHandlerResponse${T.id}`;return r.Promises.withAsyncBody(async(B,se)=>{const ie=new a.CancellationTokenSource;T.sendWhenReady("vscode:triggerIssueUriRequestHandler",ie.token,{replyChannel:F,extensionId:L}),A.validatedIpcMain.once(F,(de,ae)=>{B(s.URI.parse(ae))});try{await(0,r.timeout)(5e3),ie.cancel(),se(new Error("Timed out waiting for issue reporter URI"))}finally{A.validatedIpcMain.removeHandler(F)}})}async $closeReporter(){this.issueReporterWindow?.close()}async closeProcessExplorer(){this.processExplorerWindow?.close()}focusWindow(L){L.isMinimized()&&L.restore(),L.focus()}safeSend(L,T,...F){L.sender.isDestroyed()||L.sender.send(T,...F)}createBrowserWindow(L,T,F,B){const se=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:L.width,height:L.height,minWidth:300,minHeight:200,x:L.x,y:L.y,title:F.title,backgroundColor:F.backgroundColor||o.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:D.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${T.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,v.zoomLevelToZoomFactor)(F.zoomLevel),sandbox:!0},alwaysOnTop:F.alwaysOnTop,experimentalDarkMode:!0});return se.setMenuBarVisibility(!1),se}getWindowPosition(L,T,F){let B;const se=E.screen.getAllDisplays();if(se.length===1)B=se[0];else{if(P.isMacintosh){const ae=E.screen.getCursorScreenPoint();B=E.screen.getDisplayNearestPoint(ae)}!B&&L&&(B=E.screen.getDisplayMatching(L.getBounds())),B||(B=E.screen.getPrimaryDisplay()||se[0])}const ie=B.bounds,de={width:T,height:F,x:ie.x+ie.width/2-T/2,y:ie.y+ie.height/2-F/2};return ie.width>0&&ie.height>0&&(de.x<ie.x&&(de.x=ie.x),de.y<ie.y&&(de.y=ie.y),de.x>ie.x+ie.width&&(de.x=ie.x),de.y>ie.y+ie.height&&(de.y=ie.y),de.width>ie.width&&(de.width=ie.width),de.height>ie.height&&(de.height=ie.height)),de}};e.IssueMainService=k,e.IssueMainService=k=o=Ee([Y(1,u.IEnvironmentMainService),Y(2,y.ILogService),Y(3,m.IDiagnosticsService),Y(4,g.IDiagnosticsMainService),Y(5,S.IDialogMainService),Y(6,b.INativeHostMainService),Y(7,l.IProtocolMainService),Y(8,f.IProductService),Y(9,p.IStateService),Y(10,i.IWindowsMainService)],k);function M(C){return typeof C!="object"||C===null?!1:"x"in C&&"y"in C&&"width"in C&&"height"in C}}),define(ee[300],te([0,1,23,18,28,20,5,67,22,51,25,48,101]),function(H,e,E,A,n,_,D,P,h,d,m,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let u=class extends S.AbstractUpdateService{constructor(b,c,f,l,v,I,p,t){super(b,c,l,v,I,t),this.telemetryService=f,this.nativeHostMainService=p}buildUpdateFeedUrl(b){return(0,S.createUpdateURL)(`linux-${process.arch}`,b,this.productService)}doCheckForUpdates(b){this.url&&(this.setState(g.State.CheckingForUpdates(b)),this.requestService.request({url:this.url},E.CancellationToken.None).then(d.asJson).then(c=>{!c||!c.url||!c.version||!c.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b}),this.setState(g.State.Idle(1))):this.setState(g.State.AvailableForDownload(c))}).then(void 0,c=>{this.logService.error(c),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b});const f=b?c.message||c:void 0;this.setState(g.State.Idle(1,f))}))}async doDownloadUpdate(b){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):b.update.url&&this.nativeHostMainService.openExternal(void 0,b.update.url),this.setState(g.State.Idle(1))}};e.LinuxUpdateService=u,e.LinuxUpdateService=u=Ee([Y(0,_.ILifecycleMainService),Y(1,A.IConfigurationService),Y(2,m.ITelemetryService),Y(3,n.IEnvironmentMainService),Y(4,d.IRequestService),Y(5,D.ILogService),Y(6,P.INativeHostMainService),Y(7,h.IProductService)],u)}),define(ee[301],te([0,1,47,45,27,8,23,55,9,7,142,21,18,28,16,20,5,67,22,51,25,48,101]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f,l,v,I,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(o,w=1e3){for(;!o();)await(0,_.timeout)(w)}let s;function i(){return typeof s>"u"&&(A.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?s=0:h.basename(h.normalize(h.join(process.execPath,"..","..")))==="Program Files"?s=3:s=1),s}let r=class extends t.AbstractUpdateService{get cachePath(){const w=h.join((0,n.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return g.Promises.mkdir(w,{recursive:!0}).then(()=>w)}constructor(w,k,M,C,L,T,F,B,se){super(w,k,C,L,T,se),this.telemetryService=M,this.fileService=F,this.nativeHostMainService=B,w.setRelaunchHandler(this)}handleRelaunch(w){return w?.addArgs||w?.removeArgs||this.state.type!=="ready"||!this.availableUpdate?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.setState(p.State.Disabled(5)),this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(w){let k="win32";switch(process.arch!=="ia32"&&(k+=`-${process.arch}`),i()){case 1:k+="-archive";break;case 3:k+="-msi";break;default:this.productService.target==="user"&&(k+="-user")}return(0,t.createUpdateURL)(k,w,this.productService)}doCheckForUpdates(w){this.url&&(this.setState(p.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},D.CancellationToken.None).then(v.asJson).then(k=>{const M=i();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(p.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(p.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(p.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(C=>g.Promises.exists(C).then(L=>{if(L)return Promise.resolve(C);const T=k.url,F=k.hash,B=`${C}.tmp`;return this.requestService.request({url:T},D.CancellationToken.None).then(se=>this.fileService.writeFile(d.URI.file(B),se.stream)).then(F?()=>(0,m.checksum)(B,k.hash):()=>{}).then(()=>g.Promises.rename(B,C,!1)).then(()=>C)})).then(C=>{const L=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:C},L?this.productService.target==="user"?this.doApplyUpdate():this.setState(p.State.Downloaded(k)):this.setState(p.State.Ready(k))})))}).then(void 0,k=>{this.logService.error(k),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const M=w?k.message||k:void 0;this.setState(p.State.Idle(i(),M))}))}async doDownloadUpdate(w){w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(p.State.Idle(i()))}async getUpdatePackagePath(w){const k=await this.cachePath;return h.join(k,`CodeSetup-${this.productService.quality}-${w}.exe`)}async cleanup(w=null){const k=w?T=>!new RegExp(`${this.productService.quality}-${w}\\.exe$`).test(T):()=>!0,M=await this.cachePath,L=(await g.Promises.readdir(M)).filter(k).map(async T=>{try{await g.Promises.unlink(h.join(M,T))}catch{}});await Promise.all(L)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const w=this.state.update;this.setState(p.State.Updating(w));const k=await this.cachePath;this.availableUpdate.updateFilePath=h.join(k,`CodeSetup-${this.productService.quality}-${w.version}.flag`),await g.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,E.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(p.State.Idle(i()))});const C=`${this.productService.win32MutexName}-ready`,L=await new Promise((T,F)=>{H(["@vscode/windows-mutex"],T,F)});a(()=>L.isActive(C)).then(()=>this.setState(p.State.Ready(w)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.availableUpdate.updateFilePath?A.unlinkSync(this.availableUpdate.updateFilePath):i()==3?(0,E.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,E.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}async _applySpecificUpdate(w){if(this.state.type!=="idle")return;const k=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown"};this.setState(p.State.Downloading(M)),this.availableUpdate={packagePath:w},k?this.productService.target==="user"?this.doApplyUpdate():this.setState(p.State.Downloaded(M)):this.setState(p.State.Ready(M))}};e.Win32UpdateService=r,Ee([P.memoize],r.prototype,"cachePath",null),e.Win32UpdateService=r=Ee([Y(0,b.ILifecycleMainService),Y(1,S.IConfigurationService),Y(2,I.ITelemetryService),Y(3,u.IEnvironmentMainService),Y(4,v.IRequestService),Y(5,c.ILogService),Y(6,y.IFileService),Y(7,f.INativeHostMainService),Y(8,l.IProductService)],r)}),define(ee[302],te([0,1,14,8,23,50,3,2,15,9,65,4,7,188,64,18,61,28,63,16,20,5,22,79,251,83,25,103,80,81,29,30,54,129,134,39,34,53,66,24]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f,l,v,I,p,t,a,s,i,r,o,w,k,M,C,L,T,F,B,se,ie,de,ae){"use strict";var ue;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var x;(function(z){z[z.NONE=0]="NONE",z[z.NAVIGATING=1]="NAVIGATING",z[z.READY=2]="READY"})(x||(x={}));let G=class extends P.Disposable{static{ue=this}static{this.windowControlHeightStateStorageKey="windowControlHeight"}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const W=this.userDataProfilesService.profiles.find(U=>U.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&W?W:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,C.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(W,U,$,X,oe,ce,V,R,O,N,q,re,ne,le,j,Z,Q,fe,pe,Pe){super(),this.logService=U,this.loggerMainService=$,this.environmentMainService=X,this.policyService=oe,this.userDataProfilesService=ce,this.fileService=V,this.applicationStorageMainService=R,this.storageMainService=O,this.configurationService=N,this.themeMainService=q,this.workspacesManagementMainService=re,this.backupMainService=ne,this.telemetryService=le,this.dialogMainService=j,this.lifecycleMainService=Z,this.productService=Q,this.protocolMainService=fe,this.windowsMainService=pe,this.stateService=Pe,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[De,Te]=this.restoreWindowState(W.state);this.windowState=De,this.logService.trace("window#ctor: using window state",De);const ye=this.windowState.mode===0||this.windowState.mode===3,we=this.configurationService.getValue("window"),K={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!ye,title:this.productService.nameLong,webPreferences:{preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,k.zoomLevelToZoomFactor)(we?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};g.isLinux?K.icon=(0,d.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):g.isWindows&&!this.environmentMainService.isBuilt&&(K.icon=(0,d.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),g.isMacintosh&&!this.useNativeFullScreen()&&(K.fullscreenable=!1),g.isMacintosh&&(K.acceptFirstMouse=!0,we?.clickThroughInactive===!1&&(K.acceptFirstMouse=!1));const he=g.isMacintosh&&we?.nativeTabs===!0;he&&(K.tabbingIdentifier=this.productService.nameShort);const me=(0,k.getTitleBarStyle)(this.configurationService)==="custom";if(me&&(K.titleBarStyle="hidden",g.isMacintosh||(K.frame=!1),(0,k.useWindowControlsOverlay)(this.configurationService))){const Ie=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Re=F.Color.fromHex(Ie).isDarker()?"#FFFFFF":"#000000";K.titleBarOverlay={height:29,color:Ie,symbolColor:Re},this.hasWindowControlOverlay=!0}if((0,m.mark)("code/willCreateCodeBrowserWindow"),this._win=new E.BrowserWindow(K),(0,m.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,g.isMacintosh&&me&&this._win.setSheetOffset(22),me&&(g.isWindows&&(0,k.useWindowControlsOverlay)(this.configurationService)||g.isMacintosh)){const Ie=this.stateService.getItem(ue.windowControlHeightStateStorageKey);Ie&&this.updateWindowControls({height:Ie})}g.isWindows&&me&&this._win.hookWindowMessage(278,()=>{const[Re,Ue]=this._win.getPosition(),Ae=E.screen.getCursorScreenPoint(),ze=Ae.x-Re,Be=Ae.y-Ue;return(()=>!(ze>30&&Be>=0&&Be<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:ze,y:Be})),0}),(g.isMacintosh||g.isWindows)&&Te&&(!he||E.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(Ie=>typeof Ie=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),ye&&((0,m.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,m.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setRepresentedFilename(W){g.isMacintosh?this._win.setRepresentedFilename(W):this.representedFilename=W}getRepresentedFilename(){return g.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(W){g.isMacintosh&&this._win.setDocumentEdited(W),this.documentEdited=W}isDocumentEdited(){return g.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(W){g.isMacintosh&&W?.force&&E.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.whenReadyCallbacks.push(W)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(W=>{function U(){$.dispose(),X.dispose(),W()}const $=this.onDidClose(()=>U()),X=this.onWillLoad(()=>U())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(U,$)=>this.onWindowError(2,{...$})),this._win.webContents.on("did-fail-load",(U,$,X)=>this.onWindowError(3,{reason:X,exitCode:$})),this._win.webContents.on("will-prevent-unload",U=>{U.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",U=>{this._config&&(this._config.maximized=!0),E.app.emit("browser-window-maximize",U,this._win)}),this._win.on("unmaximize",U=>{this._config&&(this._config.maximized=!1),E.app.emit("browser-window-unmaximize",U,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",n.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",n.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(U=>this.onConfigurationUpdated(U))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(U=>this.onDidDeleteUntitledWorkspace(U)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(U,$)=>{const X=await this.getMarketplaceHeaders();$({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,X)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,s.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(W,U){switch(W){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:W,reason:U?.reason,code:U?.exitCode}),W){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:$,checkboxChecked:X}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,u.localize)(0,null),(0,u.localize)(1,null),(0,u.localize)(2,null)],message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null),checkboxLabel:this._config?.workspace?(0,u.localize)(5,null):void 0},this._win);if($!==2){const oe=$===0;await this.destroyWindow(oe,X)}}else if(W===2){let $;U?$=(0,u.localize)(7,null,U.reason,U.exitCode??"<unknown>"):$=(0,u.localize)(6,null);const{response:X,checkboxChecked:oe}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,u.localize)(8,null):(0,u.localize)(9,null),(0,u.localize)(10,null)],message:$,detail:this._config?.workspace?(0,u.localize)(11,null):(0,u.localize)(12,null),checkboxLabel:this._config?.workspace?(0,u.localize)(13,null):void 0},this._win),ce=X===0;await this.destroyWindow(ce,oe)}break}}async destroyWindow(W,U){const $=this._config?.workspace;if(U&&$)try{const X=this.storageMainService.workspaceStorage($);await X.init(),X.delete("memento/workbench.parts.editor"),await X.close()}catch(X){this.logService.error(X)}if(this._onDidDestroy.fire(),this._win?.destroy(),W&&this._config){let X,oe;(0,C.isSingleFolderWorkspaceIdentifier)($)?X={folderUri:$.uri}:(0,C.isWorkspaceIdentifier)($)?X={workspaceUri:$.configPath}:oe=!0,(0,ae.firstOrDefault)(await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:X?[X]:void 0,forceEmpty:oe,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}onDidDeleteUntitledWorkspace(W){this._config?.workspace?.id===W.id&&(this._config.workspace=void 0)}onConfigurationUpdated(W){if(!W||W.affectsConfiguration("window.menuBarVisibility")){const U=this.getMenuBarVisibility();U!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=U,this.setMenuBarVisibility(U))}if(!W||W.affectsConfiguration("http.proxy")){let U=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const $=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.currentHttpProxy||$!==this.currentNoProxy)){this.currentHttpProxy=U,this.currentNoProxy=$;const X=U||"",oe=$?`${$},<local>`:"<local>";this.logService.trace(`Setting proxy to '${X}', bypassing '${oe}'`),this._win.webContents.session.setProxy({proxyRules:X,proxyBypassRules:oe,pacScript:""})}}}addTabbedWindow(W){g.isMacintosh&&W.win&&this._win.addTabbedWindow(W.win)}load(W,U=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!U.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),U.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(W,U),this.readyState===0?this._config=W:this.pendingLoadConfig=W,this.readyState=1,this._win.loadURL(h.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const $=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new A.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:W.workspace,reason:U.isReload?3:$?2:1})}updateConfiguration(W,U){const $=(this._config??this.pendingLoadConfig)?.userEnv;if($){const X=(0,l.isLaunchedFromCli)($)&&!(0,l.isLaunchedFromCli)(W.userEnv),oe=this.isExtensionDevelopmentHost;(X||oe)&&(W.userEnv={...$,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),U.disableExtensions!==void 0&&(W["disable-extensions"]=U.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this._win.isMaximized(),W.partsSplash=this.themeMainService.getWindowSplash(),(0,m.mark)("code/willOpenNewWindow"),W.perfMarks=(0,m.getMarks)(),this.configObjectUrl.update(W)}async reload(W){const U=Object.assign({},this._config);U.workspace=await this.validateWorkspaceBeforeReload(U),delete U.filesToOpenOrCreate,delete U.filesToDiff,delete U.filesToMerge,delete U.filesToWait,this.isExtensionDevelopmentHost&&W&&(U.verbose=W.verbose,U.debugId=W.debugId,U.extensionEnvironment=W.extensionEnvironment,U["inspect-extensions"]=W["inspect-extensions"],U["inspect-brk-extensions"]=W["inspect-brk-extensions"],U["extensions-dir"]=W["extensions-dir"]),U.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),U.isInitialStartup=!1,U.policiesData=this.policyService.serialize(),U.continueOn=this.environmentMainService.continueOn,U.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},U.logLevel=this.loggerMainService.getLogLevel(),U.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(U,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async validateWorkspaceBeforeReload(W){if((0,C.isWorkspaceIdentifier)(W.workspace)){const U=W.workspace.configPath;if(U.scheme===h.Schemas.file&&!await this.fileService.exists(U))return}else if((0,C.isSingleFolderWorkspaceIdentifier)(W.workspace)){const U=W.workspace.uri;if(U.scheme===h.Schemas.file&&!await this.fileService.exists(U))return}return W.workspace}serializeWindowState(){if(!this._win)return(0,T.defaultWindowState)();if(this.isFullScreen){let $;try{$=E.screen.getDisplayMatching(this.getBounds())}catch{}const X=(0,T.defaultWindowState)();return{mode:3,display:$?$.id:void 0,width:this.windowState.width||X.width,height:this.windowState.height||X.height,x:this.windowState.x||0,y:this.windowState.y||0}}const W=Object.create(null);let U;if(!g.isMacintosh&&this._win.isMaximized()?U=0:U=1,U===0?W.mode=0:W.mode=1,U===1||U===0){let $;U===1?$=this.getBounds():$=this._win.getNormalBounds(),W.x=$.x,W.y=$.y,W.width=$.width,W.height=$.height}return W}updateWindowControls(W){if(W.height&&this.stateService.setItem(ue.windowControlHeightStateStorageKey,W.height),g.isWindows&&this.hasWindowControlOverlay)this._win.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0});else if(g.isMacintosh&&W.height!==void 0){const U=(W.height-15)/2;U?this._win.setWindowButtonPosition({x:U,y:U}):this._win.setWindowButtonPosition(null)}}restoreWindowState(W){(0,m.mark)("code/willRestoreCodeWindowState");let U=!1;if(W)try{const $=E.screen.getAllDisplays();U=$.length>1,W=this.validateWindowState(W,$)}catch($){this.logService.warn(`Unexpected error validating window state: ${$}
${$.stack}`)}return(0,m.mark)("code/didRestoreCodeWindowState"),[W||(0,T.defaultWindowState)(),U]}validateWindowState(W,U){if(this.logService.trace(`window#validateWindowState: validating window state on ${U.length} display(s)`,W),typeof W.x!="number"||typeof W.y!="number"||typeof W.width!="number"||typeof W.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(W.width<=0||W.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(U.length===1){const oe=this.getWorkingArea(U[0]);if(oe){let ce=function(){!W||typeof W.x!="number"||typeof W.y!="number"||!oe||(W.x<oe.x&&(W.x=oe.x),W.y<oe.y&&(W.y=oe.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",oe),ce(),W.width>oe.width&&(W.width=oe.width),W.height>oe.height&&(W.height=oe.height),W.x>oe.x+oe.width-128&&(W.x=oe.x+oe.width-W.width),W.y>oe.y+oe.height-128&&(W.y=oe.y+oe.height-W.height),ce()}return W}if(W.display&&W.mode===3){const oe=U.find(ce=>ce.id===W.display);if(oe&&typeof oe.bounds?.x=="number"&&typeof oe.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const ce=(0,T.defaultWindowState)(3);return ce.x=oe.bounds.x,ce.y=oe.bounds.y,ce}}let $,X;try{$=E.screen.getDisplayMatching({x:W.x,y:W.y,width:W.width,height:W.height}),X=this.getWorkingArea($)}catch{}if($&&X&&W.x+W.width>X.x&&W.y+W.height>X.y&&W.x<X.x+X.width&&W.y<X.y+X.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",X),W}getWorkingArea(W){if(W.workArea.width>0&&W.workArea.height>0)return W.workArea;if(W.bounds.width>0&&W.bounds.height>0)return W.bounds}getBounds(){const[W,U]=this._win.getPosition(),[$,X]=this._win.getSize();return{x:W,y:U,width:$,height:X}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(W){this.useNativeFullScreen()?this.setNativeFullScreen(W):this.setSimpleFullScreen(W),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",n.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return g.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(W){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(W)}doSetNativeFullScreen(W){g.isMacintosh&&(this.transientIsNativeFullScreen=W,this.joinNativeFullScreenTransition=new A.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,A.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(W)}setSimpleFullScreen(W){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(W),this._win.webContents.focus()}useNativeFullScreen(){const W=this.configurationService.getValue("window");return!W||typeof W.nativeFullScreen!="boolean"||W.nativeTabs?!0:W.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let W=(0,k.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}setMenuBarVisibility(W,U=!0){g.isMacintosh||(W==="toggle"&&U&&this.send("vscode:showInfoMessage",(0,u.localize)(14,null)),W==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(W)}):this.doSetMenuBarVisibility(W))}doSetMenuBarVisibility(W){const U=this.isFullScreen;switch(W){case"classic":this._win.setMenuBarVisibility(!U),this._win.autoHideMenuBar=U;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(W,U,...$){this.isReady?this.send(W,...$):this.ready().then(()=>{U.isCancellationRequested||this.send(W,...$)})}send(W,...U){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this._win.webContents.send(W,...U)}catch($){this.logService.warn(`Error sending IPC message to channel '${W}' of window ${this._id}: ${(0,_.toErrorMessage)($)}`)}}}updateTouchBar(W){g.isMacintosh&&this.touchBarGroups.forEach((U,$)=>{const X=W[$];U.segments=this.createTouchBarGroupSegments(X)})}createTouchBar(){if(g.isMacintosh){for(let W=0;W<10;W++){const U=this.createTouchBarGroup();this.touchBarGroups.push(U)}this._win.setTouchBar(new E.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(W=[]){const U=this.createTouchBarGroupSegments(W),$=new E.TouchBar.TouchBarSegmentedControl({segments:U,mode:"buttons",segmentStyle:"automatic",change:X=>{this.sendWhenReady("vscode:runAction",n.CancellationToken.None,{id:$.segments[X].id,from:"touchbar"})}});return $}createTouchBarGroupSegments(W=[]){return W.map($=>{let X;$.icon&&!o.ThemeIcon.isThemeIcon($.icon)&&$.icon?.dark?.scheme===h.Schemas.file&&(X=E.nativeImage.createFromPath(S.URI.revive($.icon.dark).fsPath),X.isEmpty()&&(X=void 0));let oe;return typeof $.title=="string"?oe=$.title:oe=$.title.value,{id:$.id,label:X?void 0:oe,icon:X}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id),this._win=null}};e.CodeWindow=G,e.CodeWindow=G=ue=Ee([Y(1,p.ILogService),Y(2,de.ILoggerMainService),Y(3,f.IEnvironmentMainService),Y(4,B.IPolicyService),Y(5,ie.IUserDataProfilesMainService),Y(6,v.IFileService),Y(7,i.IApplicationStorageMainService),Y(8,i.IStorageMainService),Y(9,b.IConfigurationService),Y(10,w.IThemeMainService),Y(11,L.IWorkspacesManagementMainService),Y(12,y.IBackupMainService),Y(13,r.ITelemetryService),Y(14,c.IDialogMainService),Y(15,I.ILifecycleMainService),Y(16,t.IProductService),Y(17,a.IProtocolMainService),Y(18,M.IWindowsMainService),Y(19,se.IStateService)],G)}),define(ee[84],te([0,1,14,24,8,3,46,2,15,4,19,7,21,191,6,20,5,83,98,30,54,35]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f,l,v,I,p){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,y.createDecorator)("workspacesHistoryMainService");let a=class extends P.Disposable{static{t=this}static{this.MAX_TOTAL_RECENT_ENTRIES=500}static{this.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList"}constructor(i,r,o,w){super(),this.logService=i,this.workspacesManagementMainService=r,this.lifecycleMainService=o,this.applicationStorageMainService=w,this._onDidChangeRecentlyOpened=this._register(new _.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new n.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let r=[],o=[];for(const k of i)if((0,l.isRecentWorkspace)(k))!this.workspacesManagementMainService.isUntitledWorkspace(k.workspace)&&!this.containsWorkspace(r,k.workspace)&&r.push(k);else if((0,l.isRecentFolder)(k))this.containsFolder(r,k.folderUri)||r.push(k);else{const M=this.containsFile(o,k.fileUri),C=k.fileUri.scheme===h.Schemas.file&&t.COMMON_FILES_FILTER.indexOf((0,m.basename)(k.fileUri))>=0;!M&&!C&&(o.push(k),d.isWindows&&k.fileUri.scheme===h.Schemas.file&&E.app.addRecentDocument(k.fileUri.fsPath))}const w=await this.mergeEntriesFromStorage({workspaces:r,files:o});r=w.workspaces,o=w.files,r.length>t.MAX_TOTAL_RECENT_ENTRIES&&(r.length=t.MAX_TOTAL_RECENT_ENTRIES),o.length>t.MAX_TOTAL_RECENT_ENTRIES&&(o.length=t.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:r,files:o}),this._onDidChangeRecentlyOpened.fire(),d.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(i){const r=M=>{const C=this.location(M);for(const L of i)if(m.extUriBiasedIgnorePathCase.isEqual(L,C))return!1;return!0},o=await this.getRecentlyOpened(),w=o.workspaces.filter(r),k=o.files.filter(r);(w.length!==o.workspaces.length||k.length!==o.files.length)&&(await this.saveRecentlyOpened({files:k,workspaces:w}),this._onDidChangeRecentlyOpened.fire(),d.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(i){const r=new p.ResourceMap(k=>m.extUriBiasedIgnorePathCase.getComparisonKey(k));if(i?.workspaces)for(const k of i.workspaces)r.set(this.location(k),k);const o=new p.ResourceMap(k=>m.extUriBiasedIgnorePathCase.getComparisonKey(k));if(i?.files)for(const k of i.files)o.set(this.location(k),k);const w=await this.getRecentlyOpenedFromStorage();for(const k of w.workspaces){const M=r.get(this.location(k));M?M.label=M.label??k.label:r.set(this.location(k),k)}for(const k of w.files){const M=o.get(this.location(k));M?M.label=M.label??k.label:o.set(this.location(k),k)}return{workspaces:[...r.values()],files:[...o.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let i;const r=this.applicationStorageMainService.get(t.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof r=="string")try{i=JSON.parse(r)}catch(o){this.logService.error("Unexpected error parsing opened paths list",o)}return(0,l.restoreRecentlyOpened)(i,this.logService)}async saveRecentlyOpened(i){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(t.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,l.toStoreData)(i)),-1,1)}location(i){return(0,l.isRecentFolder)(i)?i.folderUri:(0,l.isRecentFile)(i)?i.fileUri:i.workspace.configPath}containsWorkspace(i,r){return!!i.find(o=>(0,l.isRecentWorkspace)(o)&&o.workspace.id===r.id)}containsFolder(i,r){return!!i.find(o=>(0,l.isRecentFolder)(o)&&m.extUriBiasedIgnorePathCase.isEqual(o.folderUri,r))}containsFile(i,r){return!!i.find(o=>m.extUriBiasedIgnorePathCase.isEqual(o.fileUri,r))}static{this.MAX_MACOS_DOCK_RECENT_WORKSPACES=7}static{this.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10}static{this.MAX_WINDOWS_JUMP_LIST_ENTRIES=7}static{this.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"]}async handleWindowsJumpList(){d.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!d.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(0,null),description:(0,u.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const r=[];for(const k of E.app.getJumpListSettings().removedItems){const M=k.args;if(M){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(M);C&&r.push(g.URI.parse(C[2]))}}await this.removeRecentlyOpened(r);let o=!1;const w=(0,A.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,t.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(k=>{const M=(0,l.isRecentWorkspace)(k)?k.workspace:k.folderUri,{title:C,description:L}=this.getWindowsJumpListLabel(M,k.label);let T;return g.URI.isUri(M)?T=`--folder-uri "${M.toString()}"`:(o=!0,T=`--file-uri "${M.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:L.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));w.length>0&&i.push({type:"custom",name:o?(0,u.localize)(2,null):(0,u.localize)(3,null),items:w})}i.push({type:"recent"});try{const r=E.app.setJumpList(i);r&&r!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${r}`)}catch(r){this.logService.warn("updateWindowsJumpList#setJumpList",r)}}getWindowsJumpListLabel(i,r){if(r)return{title:(0,D.splitRecentLabel)(r).name,description:r};if(g.URI.isUri(i))return{title:(0,m.basename)(i),description:this.renderJumpListPathDescription(i)};if(this.workspacesManagementMainService.isUntitledWorkspace(i))return{title:(0,u.localize)(4,null),description:""};let o=(0,m.basename)(i.configPath);return o.endsWith(v.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-v.WORKSPACE_EXTENSION.length-1)),{title:(0,u.localize)(5,null,o),description:this.renderJumpListPathDescription(i.configPath)}}renderJumpListPathDescription(i){return i.scheme==="file"?(0,D.normalizeDriveLetter)(i.fsPath):i.toString()}async updateMacOSRecentDocuments(){if(!d.isMacintosh)return;E.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),r=[];let o=0;for(let k=0;k<i.workspaces.length&&o<t.MAX_MACOS_DOCK_RECENT_WORKSPACES;k++){const M=this.location(i.workspaces[k]);if(M.scheme===h.Schemas.file){const C=(0,m.originalFSPath)(M);await S.Promises.exists(C)&&(r.push(C),o++)}}const w=[];for(let k=0;k<i.files.length&&o<t.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;k++){const M=this.location(i.files[k]);if(M.scheme===h.Schemas.file){const C=(0,m.originalFSPath)(M);if(t.COMMON_FILES_FILTER.includes((0,m.basename)(M))||r.includes(C))continue;await S.Promises.exists(C)&&(w.push(C),o++)}}w.reverse().forEach(k=>E.app.addRecentDocument(k)),r.reverse().forEach(k=>E.app.addRecentDocument(k))}};e.WorkspacesHistoryMainService=a,e.WorkspacesHistoryMainService=a=t=Ee([Y(0,c.ILogService),Y(1,I.IWorkspacesManagementMainService),Y(2,b.ILifecycleMainService),Y(3,f.IApplicationStorageMainService)],a)}),define(ee[303],te([0,1,14,8,23,46,4,7,179,18,28,20,5,229,67,22,34,25,48,81,29,84]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f,l,v,I,p){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const a="menu";let s=class{static{t=this}static{this.lastKnownMenubarStorageKey="lastKnownMenubarData"}constructor(o,w,k,M,C,L,T,F,B,se,ie){this.updateService=o,this.configurationService=w,this.windowsMainService=k,this.environmentMainService=M,this.telemetryService=C,this.workspacesHistoryMainService=L,this.stateService=T,this.lifecycleMainService=F,this.logService=B,this.nativeHostMainService=se,this.productService=ie,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new A.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new A.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,v.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateService.getItem(t.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(L,T,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(L,T,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(L,T,F)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(L,T,F)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(L,T,F)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.youTubeUrl;o&&(this.fallbackMenuHandlers["workbench.action.openYouTubeUrl"]=()=>this.openUrl(o,"openYouTubeUrl"));const w=this.productService.requestFeatureUrl;w&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(w,"openUserVoiceUrl"));const k=this.productService.reportIssueUrl;k&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(k,"openReportIssues"));const M=this.productService.licenseUrl;M&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const L=M.indexOf("?")>0?"&":"?";this.openUrl(`${M}${L}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(M,"openLicenseUrl")});const C=this.productService.privacyStatementUrl;C&&M&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(C,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,w){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateService.setItem(t.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){D.isMacintosh&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){D.isMacintosh&&(this.noActiveWindow=!E.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=E.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){E.Menu.setApplicationMenu(D.isMacintosh?new E.Menu:null);return}const w=new E.Menu;let k;if(D.isMacintosh){const C=new E.Menu;k=new E.MenuItem({label:this.productService.nameShort,submenu:C}),this.setMacApplicationMenu(C),w.append(k)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const C=new E.Menu;C.append(new E.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),E.app.dock.setMenu(C)}if(this.shouldDrawMenu("File")){const C=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:C});this.setMenuById(C,"File"),w.append(L)}if(this.shouldDrawMenu("Edit")){const C=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:C});this.setMenuById(C,"Edit"),w.append(L)}if(this.shouldDrawMenu("Selection")){const C=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:C});this.setMenuById(C,"Selection"),w.append(L)}if(this.shouldDrawMenu("View")){const C=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:C});this.setMenuById(C,"View"),w.append(L)}if(this.shouldDrawMenu("Go")){const C=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:C});this.setMenuById(C,"Go"),w.append(L)}if(this.shouldDrawMenu("Run")){const C=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:C});this.setMenuById(C,"Run"),w.append(L)}if(this.shouldDrawMenu("Terminal")){const C=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:C});this.setMenuById(C,"Terminal"),w.append(L)}let M;if(this.shouldDrawMenu("Window")){const C=new E.Menu;M=new E.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:C,role:"window"}),this.setMacWindowMenu(C)}if(M&&w.append(M),this.shouldDrawMenu("Help")){const C=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:C,role:"help"});this.setMenuById(C,"Help"),w.append(L)}w.items&&w.items.length>0?E.Menu.setApplicationMenu(w):E.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const w=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),k=this.getUpdateMenuItems();let M;if(this.shouldDrawMenu("Preferences")){const de=new E.Menu;this.setMenuById(de,"Preferences"),M=new E.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:de})}const C=new E.Menu,L=new E.MenuItem({label:h.localize(12,null),role:"services",submenu:C}),T=new E.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),F=new E.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),B=new E.MenuItem({label:h.localize(15,null),role:"unhide"}),se=new E.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:async(de,ae,ue)=>{const x=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||E.BrowserWindow.getFocusedWindow()||x?.isMinimized())&&await this.confirmBeforeQuit(ue)&&this.nativeHostMainService.quit(void 0)}})),ie=[w];ie.push(...k),M&&ie.push(i(),M),ie.push(i(),L,i(),T,F,B,i(),se),ie.forEach(de=>o.append(de))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const w=this.configurationService.getValue("window.confirmBeforeClose");if(w==="always"||w==="keyboardOnly"&&this.isKeyboardEvent(o)){const{response:k}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return k===0}return!0}shouldDrawMenu(o){if(!D.isMacintosh&&(0,v.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,w){w.forEach(k=>{if((0,u.isMenubarMenuItemSeparator)(k))o.append(i());else if((0,u.isMenubarMenuItemSubmenu)(k)){const M=new E.Menu,C=new E.MenuItem({label:this.mnemonicLabel(k.label),submenu:M});this.setMenu(M,k.submenu.items),o.append(C)}else(0,u.isMenubarMenuItemRecentAction)(k)?o.append(this.createOpenRecentMenuItem(k)):(0,u.isMenubarMenuItemAction)(k)&&(k.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[k.id]?o.append(new E.MenuItem(this.likeAction(k.id,{label:this.mnemonicLabel(k.label),click:this.fallbackMenuHandlers[k.id]}))):o.append(this.createMenuItem(k.label,k.id,!1,k.checked)):o.append(this.createMenuItem(k.label,k.id,k.enabled!==!1,!!k.checked)):o.append(this.createMenuItem(k.label,k.id,k.enabled!==!1,!!k.checked)))})}setMenuById(o,w){this.menubarMenus&&this.menubarMenus[w]&&this.setMenu(o,this.menubarMenus[w].items)}insertCheckForUpdatesItems(o){const w=this.getUpdateMenuItems();w.length&&(w.forEach(k=>o.append(k)),o.append(i()))}createOpenRecentMenuItem(o){const w=P.URI.revive(o.uri),k=o.id,M=k==="openRecentFile"?{fileUri:w}:k==="openRecentWorkspace"?{workspaceUri:w}:{folderUri:w};return new E.MenuItem(this.likeAction(k,{label:o.label,click:async(C,L,T)=>{const F=this.isOptionClick(T);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[M],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([w])}},!1))}isOptionClick(o){return!!(o&&(!D.isMacintosh&&(o.ctrlKey||o.shiftKey)||D.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,w,k){const M={label:this.mnemonicLabel(o),role:k,enabled:!0};return new E.MenuItem(this.withKeybinding(w,M))}setMacWindowMenu(o){const w=new E.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),k=new E.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),M=new E.MenuItem({label:h.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),C=this.createMenuItem(h.localize(23,null),"workbench.action.switchWindow"),L=[];this.currentEnableNativeTabs&&(L.push(i()),L.push(this.createMenuItem(h.localize(24,null),"workbench.action.newWindowTab")),L.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.createRoleMenuItem(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.createRoleMenuItem(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.createRoleMenuItem(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[w,k,i(),C,...L,i(),M].forEach(T=>o.append(T))}getUpdateMenuItems(){switch(this.updateService.state.type){case"idle":return[new E.MenuItem({label:this.mnemonicLabel(h.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.mnemonicLabel(h.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.mnemonicLabel(h.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new E.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.mnemonicLabel(h.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})];default:return[]}}createMenuItem(o,w,k,M){const C=this.mnemonicLabel(o),L=typeof w=="function"?w:(ie,de,ae)=>{const ue=ie?ie.userSettingsLabel:null;let x=w;Array.isArray(w)&&(x=this.isOptionClick(ae)?w[1]:w[0]),ue&&ae.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ue}):this.runActionInRenderer({type:"commandId",commandId:x})},T=typeof k=="boolean"?k:this.windowsMainService.getWindowCount()>0,F=typeof M=="boolean"?M:!1,B={label:C,click:L,enabled:T};F&&(B.type="checkbox",B.checked=F);let se;return typeof w=="string"?se=w:Array.isArray(w)&&(se=w[0]),D.isMacintosh&&(se==="editor.action.clipboardCutAction"?B.role="cut":se==="editor.action.clipboardCopyAction"?B.role="copy":se==="editor.action.clipboardPasteAction"&&(B.role="paste"),se==="undo"?B.click=this.makeContextAwareClickHandler(L,{inDevTools:ie=>ie.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?B.click=this.makeContextAwareClickHandler(L,{inDevTools:ie=>ie.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(B.click=this.makeContextAwareClickHandler(L,{inDevTools:ie=>ie.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.withKeybinding(se,B))}makeContextAwareClickHandler(o,w){return(k,M,C)=>{const L=E.BrowserWindow.getFocusedWindow();if(!L)return w.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return w.inDevTools(L.webContents.devToolsWebContents);o(k,M||L,C)}}runActionInRenderer(o){let w=E.BrowserWindow.getFocusedWindow();if(!w){const M=this.windowsMainService.getLastActiveWindow();M?.isMinimized()&&(w=M.win)}const k=w?this.windowsMainService.getWindowById(w.id):void 0;if(k){if(this.logService.trace("menubar#runActionInRenderer",o),D.isMacintosh&&!this.environmentMainService.isBuilt&&!k.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const M={id:o.commandId,from:"menu"};k.sendWhenReady("vscode:runAction",n.CancellationToken.None,M)}else{const M={userSettingsLabel:o.userSettingsLabel};k.sendWhenReady("vscode:runKeybinding",n.CancellationToken.None,M)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,w){const k=typeof o=="string"?this.keybindings[o]:void 0;if(k?.label){if(k.isNative!==!1)w.accelerator=k.label,w.userSettingsLabel=k.userSettingsLabel;else if(typeof w.label=="string"){const M=w.label.indexOf("[");M>=0?w.label=`${w.label.substr(0,M)} [${k.label}]`:w.label=`${w.label} [${k.label}]`}}else w.accelerator=void 0;return w}likeAction(o,w,k=!w.accelerator){k&&(w=this.withKeybinding(o,w));const M=w.click;return w.click=(C,L,T)=>{this.reportMenuActionTelemetry(o),M?.(C,L,T)},w}openUrl(o,w){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(w)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:a})}mnemonicLabel(o){return(0,_.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};e.Menubar=s,e.Menubar=s=t=Ee([Y(0,l.IUpdateService),Y(1,d.IConfigurationService),Y(2,I.IWindowsMainService),Y(3,m.IEnvironmentMainService),Y(4,f.ITelemetryService),Y(5,p.IWorkspacesHistoryMainService),Y(6,c.IStateService),Y(7,g.ILifecycleMainService),Y(8,S.ILogService),Y(9,y.INativeHostMainService),Y(10,b.IProductService)],s);function i(){return new E.MenuItem({type:"separator"})}}),define(ee[304],te([0,1,6,20,5,303]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let D=class{constructor(h,d,m){this.instantiationService=h,this.lifecycleMainService=d,this.logService=m,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(_.Menubar)}async updateMenubar(h,d){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(d,h)}};e.MenubarMainService=D,e.MenubarMainService=D=Ee([Y(0,E.IInstantiationService),Y(1,A.ILifecycleMainService),Y(2,n.ILogService)],D)}),define(ee[305],te([0,1,14,21,132,27,24,23,3,32,49,46,2,15,9,65,4,36,19,12,7,189,64,18,61,28,16,6,20,5,78,79,60,34,81,302,131,298,30,99,84,54,80,39,53,66]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f,l,v,I,p,t,a,s,i,r,o,w,k,M,C,L,T,F,B,se,ie,de,ae,ue,x,G,z,W,U){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function X(V){return(0,de.isWorkspaceIdentifier)(V?.workspace)}function oe(V){return(0,de.isSingleFolderWorkspaceIdentifier)(V?.workspace)}let ce=class extends S.Disposable{static{$=this}static{this.WINDOWS=[]}constructor(R,O,N,q,re,ne,le,j,Z,Q,fe,pe,Pe,De,Te,ye,we,K){super(),this.machineId=R,this.initialUserEnv=O,this.logService=N,this.loggerService=q,this.stateService=re,this.policyService=ne,this.environmentMainService=le,this.userDataProfilesMainService=j,this.lifecycleMainService=Z,this.backupMainService=Q,this.configurationService=fe,this.workspacesHistoryMainService=pe,this.workspacesManagementMainService=Pe,this.instantiationService=De,this.dialogMainService=Te,this.fileService=ye,this.protocolMainService=we,this.themeMainService=K,this._onDidOpenWindow=this._register(new h.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new h.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new h.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new h.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new h.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ie.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(R=>this._onDidSignalReadyWindow.fire(R.window))),this._register(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const O=new S.DisposableStore;if(O.add(h.Event.any(R.onDidClose,R.onDidDestroy)(()=>O.dispose())),R.config.extensionDevelopmentPath)for(const N of R.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(N));R.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(R.config.extensionTestsPath))}}))}openEmptyWindow(R,O){const N=this.environmentMainService.args,q=O?.remoteAuthority||void 0,re=!0,ne=O?.forceReuseWindow,le=!ne;return this.open({...R,cli:N,forceEmpty:re,forceNewWindow:le,forceReuseWindow:ne,remoteAuthority:q})}openExistingWindow(R,O){R.focus(),this.handleWaitMarkerFile(O,[R])}async open(R){this.logService.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const O=[],N=[],q=[],re=[],ne=[];let le,j=0;const Z=await this.getPathsToOpen(R);this.logService.trace("windowsManager#open pathsToOpen",Z);for(const De of Z)oe(De)?R.addMode?O.push(De):N.push(De):X(De)?q.push(De):De.fileUri?(le||(le={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),le.filesToOpenOrCreate.push(De)):De.backupPath?ne.push({backupFolder:(0,y.basename)(De.backupPath),remoteAuthority:De.remoteAuthority}):j++;R.diffMode&&le&&le.filesToOpenOrCreate.length>=2&&(le.filesToDiff=le.filesToOpenOrCreate.slice(0,2),le.filesToOpenOrCreate=[]),R.mergeMode&&le&&le.filesToOpenOrCreate.length===4&&(le.filesToMerge=le.filesToOpenOrCreate.slice(0,4),le.filesToOpenOrCreate=[],le.filesToDiff=[]),le&&R.waitMarkerFileURI&&(le.filesToWait={paths:(0,D.coalesce)([...le.filesToDiff,le.filesToMerge[3],...le.filesToOpenOrCreate]),waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?(re.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),q.push(...re),ne.push(...this.backupMainService.getEmptyWindowBackups())):ne.length=0;const{windows:Q,filesOpenedInWindow:fe}=await this.doOpen(R,q,N,ne,j,le,O);if(this.logService.trace(`windowsManager#open used window count ${Q.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${N.length}, emptyToRestore: ${ne.length}, emptyToOpen: ${j})`),Q.length>1)if(fe)fe.focus();else{const De=this.windowsStateHandler.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let Te=!0,ye=!0;if(De){const we=Q.filter(K=>this.windowsStateHandler.state.lastActiveWindow&&K.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Te=!1,ye=!1)}if(Te)for(let we=Q.length-1;we>=0;we--){const K=Q[we];if(!(K.openedWorkspace&&re.some(he=>K.openedWorkspace&&he.workspace.id===K.openedWorkspace.id)||K.backupPath&&ne.some(he=>K.backupPath&&he.backupFolder===(0,y.basename)(K.backupPath)))){K.focus(),ye=!1;break}}ye&&Q[Q.length-1].focus()}const pe=le&&le.filesToDiff.length>0,Pe=le&&le.filesToMerge.length>0;if(!Q.some(De=>De.isExtensionDevelopmentHost)&&!pe&&!Pe&&!R.noRecentEntry){const De=[];for(const Te of Z)X(Te)&&!Te.transient?De.push({label:Te.label,workspace:Te.workspace,remoteAuthority:Te.remoteAuthority}):oe(Te)?De.push({label:Te.label,folderUri:Te.workspace.uri,remoteAuthority:Te.remoteAuthority}):Te.fileUri&&De.push({label:Te.label,fileUri:Te.fileUri,remoteAuthority:Te.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(De)}return this.handleWaitMarkerFile(R,Q),Q}handleWaitMarkerFile(R,O){const N=R.waitMarkerFileURI;R.context===0&&N&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(N)}catch{}})()}async doOpen(R,O,N,q,re,ne,le){const j=[];let Z;function Q(we,K){j.push(we),K&&(Z=we,ne=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:pe}=this.shouldOpenNewWindow(R);if(!R.initialStartup&&le.length>0){const we=le[0].remoteAuthority,K=this.getLastActiveWindowForAuthority(we);K&&Q(this.doAddFoldersToExistingWindow(K,le.map(he=>he.workspace.uri)))}const Pe=N.length+O.length+q.length;if(ne&&Pe===0){const we=ne.filesToOpenOrCreate[0]||ne.filesToDiff[0]||ne.filesToMerge[3],K=this.getWindows().filter(me=>ne&&(0,l.isEqualAuthority)(me.remoteAuthority,ne.remoteAuthority));let he;we?.fileUri&&!pe&&((R.context===4||R.context===0||R.context===1)&&(he=await(0,se.findWindowOnFile)(K,we.fileUri,async me=>me.configPath.scheme===u.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(me.configPath):void 0)),he||(he=this.doGetLastActiveWindow(K))),he?(0,de.isWorkspaceIdentifier)(he.openedWorkspace)?O.push({workspace:he.openedWorkspace,remoteAuthority:he.remoteAuthority}):(0,de.isSingleFolderWorkspaceIdentifier)(he.openedWorkspace)?N.push({workspace:he.openedWorkspace,remoteAuthority:he.remoteAuthority}):Q(this.doOpenFilesInExistingWindow(R,he,ne),!0):Q(await this.openInBrowserWindow({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:ne,forceNewWindow:!0,remoteAuthority:ne.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile}),!0)}const De=(0,D.distinct)(O,we=>we.workspace.id);if(De.length>0){const we=(0,D.coalesce)(De.map(K=>(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),K.workspace.configPath)));if(we.length>0){const K=we[0],he=(0,l.isEqualAuthority)(ne?.remoteAuthority,K.remoteAuthority)?ne:void 0;Q(this.doOpenFilesInExistingWindow(R,K,he),!!he),fe=!0}for(const K of De){if(we.some(Ie=>Ie.openedWorkspace&&Ie.openedWorkspace.id===K.workspace.id))continue;const he=K.remoteAuthority,me=(0,l.isEqualAuthority)(ne?.remoteAuthority,he)?ne:void 0;Q(await this.doOpenFolderOrWorkspace(R,K,fe,me),!!me),fe=!0}}const Te=(0,D.distinct)(N,we=>l.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Te.length>0){const we=(0,D.coalesce)(Te.map(K=>(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),K.workspace.uri)));if(we.length>0){const K=we[0],he=(0,l.isEqualAuthority)(ne?.remoteAuthority,K.remoteAuthority)?ne:void 0;Q(this.doOpenFilesInExistingWindow(R,K,he),!!he),fe=!0}for(const K of Te){if(we.some(Ie=>(0,de.isSingleFolderWorkspaceIdentifier)(Ie.openedWorkspace)&&l.extUriBiasedIgnorePathCase.isEqual(Ie.openedWorkspace.uri,K.workspace.uri)))continue;const he=K.remoteAuthority,me=(0,l.isEqualAuthority)(ne?.remoteAuthority,he)?ne:void 0;Q(await this.doOpenFolderOrWorkspace(R,K,fe,me),!!me),fe=!0}}const ye=(0,D.distinct)(q,we=>we.backupFolder);if(ye.length>0)for(const we of ye){const K=we.remoteAuthority,he=(0,l.isEqualAuthority)(ne?.remoteAuthority,K)?ne:void 0;Q(await this.doOpenEmpty(R,!0,K,he,we),!!he),fe=!0}if(j.length===0||ne){ne&&!re&&re++;const we=ne?ne.remoteAuthority:R.remoteAuthority;for(let K=0;K<re;K++)Q(await this.doOpenEmpty(R,fe,we,ne),!!ne),fe=!0}return{windows:(0,D.distinct)(j),filesOpenedInWindow:Z}}doOpenFilesInExistingWindow(R,O,N){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:N}),O.focus();const q={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToMerge:N?.filesToMerge,filesToWait:N?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",P.CancellationToken.None,q),O}doAddFoldersToExistingWindow(R,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),R.focus();const N={foldersToAdd:O};return R.sendWhenReady("vscode:addFolders",P.CancellationToken.None,N),R}doOpenEmpty(R,O,N,q,re){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!re,remoteAuthority:N,filesToOpen:q,forceNewWindow:O});let ne;return!O&&typeof R.contextWindowId=="number"&&(ne=this.getWindowById(R.contextWindowId)),this.openInBrowserWindow({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:N,forceNewWindow:O,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:q,windowToUse:ne,emptyWindowBackupInfo:re,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}doOpenFolderOrWorkspace(R,O,N,q,re){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:q}),!N&&!re&&typeof R.contextWindowId=="number"&&(re=this.getWindowById(R.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:q,windowToUse:re,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}async getPathsToOpen(R){let O,N=!1,q=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(O=await this.doExtractPathsFromAPI(R),N=!0):R.forceEmpty?O=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(O=await this.doExtractPathsFromCLI(R.cli),O.length===0&&O.push(Object.create(null)),N=!0):(O=await this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),q=!0),!R.addMode&&N){const re=O.filter(ne=>oe(ne));if(re.length>1){const ne=re[0].remoteAuthority;if(re.every(le=>(0,l.isEqualAuthority)(le.remoteAuthority,ne))){const le=await this.workspacesManagementMainService.createUntitledWorkspace(re.map(j=>({uri:j.workspace.uri})));O.push({workspace:le,remoteAuthority:ne}),O=O.filter(j=>!oe(j))}}}if(R.initialStartup&&!q&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const re=await this.doGetPathsFromLastSession();O.unshift(...re.filter(ne=>X(ne)||oe(ne)||ne.backupPath))}return O}async doExtractPathsFromAPI(R){const O={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority},N=await Promise.all((0,D.coalesce)(R.urisToOpen||[]).map(async q=>{const re=await this.resolveOpenable(q,O);if(re)return re.label=q.label,re;const ne=this.resourceFromOpenable(q);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,p.localize)(0,null)],message:ne.scheme===u.Schemas.file?(0,p.localize)(1,null):(0,p.localize)(2,null),detail:ne.scheme===u.Schemas.file?(0,p.localize)(3,null,(0,g.getPathLabel)(ne,{os:c.OS,tildify:this.environmentMainService})):(0,p.localize)(4,null,ne.toString(!0))},E.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.coalesce)(N)}async doExtractPathsFromCLI(R){const O=[],N={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:R.diff&&R._.length===2||R.merge&&R._.length===4},q=R["folder-uri"];if(q){const le=await Promise.all(q.map(j=>{const Z=this.cliArgToUri(j);if(Z)return this.resolveOpenable({folderUri:Z},N)}));O.push(...(0,D.coalesce)(le))}const re=R["file-uri"];if(re){const le=await Promise.all(re.map(j=>{const Z=this.cliArgToUri(j);if(Z)return this.resolveOpenable((0,de.hasWorkspaceFileExtension)(j)?{workspaceUri:Z}:{fileUri:Z},N)}));O.push(...(0,D.coalesce)(le))}const ne=await Promise.all(R._.map(le=>N.remoteAuthority?this.doResolveRemotePath(le,N):this.doResolveFilePath(le,N)));return O.push(...(0,D.coalesce)(ne)),O}cliArgToUri(R){try{const O=I.URI.parse(R);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${R}`);return}return O.path?O:O.with({path:"/"})}catch(O){this.logService.error(`Invalid URI input string: ${R}, ${O.message}`)}}async doGetPathsFromLastSession(){const R=this.getRestoreWindowsSetting();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];R!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const N=await Promise.all(O.map(async q=>{if(q.workspace){const re=await this.resolveOpenable({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority,rejectTransientWorkspaces:!0});if(X(re))return re}else if(q.folderUri){const re=await this.resolveOpenable({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});if(oe(re))return re}else if(R!=="folders"&&q.backupPath)return{backupPath:q.backupPath,remoteAuthority:q.remoteAuthority}}));return(0,D.coalesce)(N)}}}getRestoreWindowsSetting(){let R;return this.lifecycleMainService.wasRestarted?R="all":(R=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}async resolveOpenable(R,O=Object.create(null)){const N=this.resourceFromOpenable(R);return N.scheme===u.Schemas.file?((0,F.isFileToOpen)(R)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(N.fsPath,O)):this.doResolveRemoteOpenable(R,O)}doResolveRemoteOpenable(R,O){let N=this.resourceFromOpenable(R);const q=(0,L.getRemoteAuthority)(N)||O.remoteAuthority;if(N=(0,l.removeTrailingPathSeparator)((0,l.normalizePath)(N)),(0,F.isFileToOpen)(R)){if(O.gotoLineMode){const{path:re,line:ne,column:le}=(0,d.parseLineAndColumnAware)(N.path);return{fileUri:N.with({path:re}),options:{selection:ne?{startLineNumber:ne,startColumn:le||1}:void 0},remoteAuthority:q}}return{fileUri:N,remoteAuthority:q}}else if((0,F.isWorkspaceToOpen)(R))return{workspace:(0,ae.getWorkspaceIdentifier)(N),remoteAuthority:q};return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(N),remoteAuthority:q}}resourceFromOpenable(R){return(0,F.isWorkspaceToOpen)(R)?R.workspaceUri:(0,F.isFolderToOpen)(R)?R.folderUri:R.fileUri}async doResolveFilePath(R,O,N){let q,re;O.gotoLineMode&&({path:R,line:q,column:re}=(0,d.parseLineAndColumnAware)(R)),R=(0,d.sanitizeFilePath)((0,y.normalize)(R),(0,f.cwd)());try{const ne=await A.Promises.stat(R);if(ne.isFile()){if(!O.forceOpenWorkspaceAsFile){const le=await this.workspacesManagementMainService.resolveLocalWorkspace(I.URI.file(R));if(le)return le.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:le.id,configPath:le.configPath},type:r.FileType.File,exists:!0,remoteAuthority:le.remoteAuthority,transient:le.transient}}return{fileUri:I.URI.file(R),type:r.FileType.File,exists:!0,options:{selection:q?{startLineNumber:q,startColumn:re||1}:void 0}}}else{if(ne.isDirectory())return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(I.URI.file(R),ne),type:r.FileType.Directory,exists:!0};if(!c.isWindows&&R==="/dev/null")return{fileUri:I.URI.file(R),type:r.FileType.File,exists:!0}}}catch(ne){if(ne.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!N)return this.onUNCHostNotAllowed(R,O);const le=I.URI.file(R);if(this.workspacesHistoryMainService.removeRecentlyOpened([le]),O.ignoreFileNotFound)return{fileUri:le,type:r.FileType.File,exists:!1}}}async onUNCHostNotAllowed(R,O){const N=I.URI.file(R),{response:q,checkboxChecked:re}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,p.localize)(5,null),(0,p.localize)(6,null),(0,p.localize)(7,null)],message:(0,p.localize)(8,null,N.authority),detail:(0,p.localize)(9,null,(0,g.getPathLabel)(N,{os:c.OS,tildify:this.environmentMainService})),checkboxLabel:(0,p.localize)(10,null,N.authority),cancelId:1});if(q===0)return(0,n.addUNCHostToAllowlist)(N.authority),re&&this._register(h.Event.once(this.onDidOpenWindow)(ne=>{ne.sendWhenReady("vscode:configureAllowedUNCHost",P.CancellationToken.None,N.authority)})),this.doResolveFilePath(R,O,!0);if(q===2)return E.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(R,O)}doResolveRemotePath(R,O){const N=R.charCodeAt(0),q=O.remoteAuthority;let re,ne;O.gotoLineMode&&({path:R,line:re,column:ne}=(0,d.parseLineAndColumnAware)(R)),N!==47&&((0,d.isWindowsDriveLetter)(N)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,d.toSlashes)(R)),R=`/${R}`);const le=I.URI.from({scheme:u.Schemas.vscodeRemote,authority:q,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,de.hasWorkspaceFileExtension)(R))return O.forceOpenWorkspaceAsFile?{fileUri:le,options:{selection:re?{startLineNumber:re,startColumn:ne||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,ae.getWorkspaceIdentifier)(le),remoteAuthority:q};if(O.gotoLineMode||y.posix.basename(R).indexOf(".")!==-1)return{fileUri:le,options:{selection:re?{startLineNumber:re,startColumn:ne||1}:void 0},remoteAuthority:q}}return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(le),remoteAuthority:q}}shouldOpenNewWindow(R){const O=this.configurationService.getValue("window"),N=O?.openFoldersInNewWindow||"default",q=O?.openFilesInNewWindow||"off";let re=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&(N==="on"||N==="off")&&(re=N==="on");let ne=!1;return R.forceNewWindow||R.forceReuseWindow?ne=!!R.forceNewWindow&&!R.forceReuseWindow:(c.isMacintosh?R.context===1&&(ne=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(ne=!0),!R.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&(ne=q==="on")),{openFolderInNewWindow:!!re,openFilesInNewWindow:ne}}async openExtensionDevelopmentHostWindow(R,O){const N=(0,se.findWindowOnExtensionDevelopmentPath)(this.getWindows(),R);if(N)return this.lifecycleMainService.reload(N,O.cli),N.focus(),[N];let q=O.cli["folder-uri"]||[],re=O.cli["file-uri"]||[],ne=O.cli._;if(!ne.length&&!q.length&&!re.length&&!O.cli.extensionTestsPath){const Z=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,Q=Z?.workspace??Z?.folderUri;Q&&(I.URI.isUri(Q)?Q.scheme===u.Schemas.file?ne=[Q.fsPath]:q=[Q.toString()]:Q.configPath.scheme===u.Schemas.file?ne=[(0,l.originalFSPath)(Q.configPath)]:re=[Q.configPath.toString()])}let le=O.remoteAuthority;for(const Z of R)if(Z.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const Q=I.URI.parse(Z),fe=(0,L.getRemoteAuthority)(Q);fe&&(le?(0,l.isEqualAuthority)(fe,le)||this.logService.error("more than one extension development path authority"):le=fe)}ne=ne.filter(Z=>{const Q=I.URI.file(Z);return(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),Q)?!1:(0,l.isEqualAuthority)((0,L.getRemoteAuthority)(Q),le)}),q=q.filter(Z=>{const Q=this.cliArgToUri(Z);return Q&&(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),Q)?!1:Q?(0,l.isEqualAuthority)((0,L.getRemoteAuthority)(Q),le):!1}),re=re.filter(Z=>{const Q=this.cliArgToUri(Z);return Q&&(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),Q)?!1:Q?(0,l.isEqualAuthority)((0,L.getRemoteAuthority)(Q),le):!1}),O.cli._=ne,O.cli["folder-uri"]=q,O.cli["file-uri"]=re;const j={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!ne.length&&!q.length&&!re.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:le,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(j)}async openInBrowserWindow(R){const O=this.configurationService.getValue("window"),N=this.getLastActiveWindow(),q=N?.profile??this.userDataProfilesMainService.defaultProfile;let re;!R.forceNewWindow&&!R.forceNewTabbedWindow&&(re=R.windowToUse||N,re&&re.focus());const ne={...this.environmentMainService.args,...R.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,y.join)(this.environmentMainService.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:q},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.initialUserEnv,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToMerge:R.filesToOpen?.filesToMerge,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.fsPath,product:M.default,isInitialStartup:R.initialStartup,perfMarks:(0,b.getMarks)(),os:{release:(0,_.release)(),hostname:(0,_.hostname)(),arch:(0,_.arch)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(re){const le=re.config;!ne.extensionDevelopmentPath&&le?.extensionDevelopmentPath&&(ne.extensionDevelopmentPath=le.extensionDevelopmentPath,ne.extensionDevelopmentKind=le.extensionDevelopmentKind,ne["enable-proposed-api"]=le["enable-proposed-api"],ne.verbose=le.verbose,ne["inspect-extensions"]=le["inspect-extensions"],ne["inspect-brk-extensions"]=le["inspect-brk-extensions"],ne.debugId=le.debugId,ne.extensionEnvironment=le.extensionEnvironment,ne["extensions-dir"]=le["extensions-dir"],ne["disable-extensions"]=le["disable-extensions"]),ne.loggers={global:ne.loggers.global,window:le?.loggers.window??ne.loggers.window}}else{const le=this.windowsStateHandler.getNewWindowState(ne);(0,b.mark)("code/willCreateCodeWindow");const j=re=this.instantiationService.createInstance(B.CodeWindow,{state:le,extensionDevelopmentPath:ne.extensionDevelopmentPath,isExtensionTestHost:!!ne.extensionTestsPath});(0,b.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(j),$.WINDOWS.push(j),this._onDidOpenWindow.fire(j),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(j.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(j)),(0,m.once)(j.onDidClose)(()=>this.onWindowClosed(j)),(0,m.once)(j.onDidDestroy)(()=>this._onDidDestroyWindow.fire(j)),j.onDidTriggerSystemContextMenu(({x:Q,y:fe})=>this._onDidTriggerSystemContextMenu.fire({window:j,x:Q,y:fe}));const Z=(0,v.assertIsDefined)(j.win?.webContents);Z.removeAllListeners("devtools-reload-page"),Z.on("devtools-reload-page",()=>this.lifecycleMainService.reload(j)),this.lifecycleMainService.registerWindow(j)}return ne.windowId=re.id,re.isReady?this.lifecycleMainService.unload(re,4).then(async le=>{le||await this.doOpenInBrowserWindow(re,ne,R,q)}):await this.doOpenInBrowserWindow(re,ne,R,q),re}async doOpenInBrowserWindow(R,O,N,q){if(O.extensionDevelopmentPath||((0,de.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,de.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:N.emptyWindowBackupInfo?.backupFolder??(0,ae.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const re=O.workspace??(0,de.toWorkspaceIdentifier)(O.backupPath,!1),ne=this.resolveProfileForBrowserWindow(N,re,q),le=ne instanceof Promise?await ne:ne;O.profiles.profile=le,O.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(re,le)}R.load(O)}resolveProfileForBrowserWindow(R,O,N){return R.forceProfile?this.userDataProfilesMainService.profiles.find(q=>q.name===R.forceProfile)??this.userDataProfilesMainService.createNamedProfile(R.forceProfile):R.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(O)??N}onWindowClosed(R){const O=$.WINDOWS.indexOf(R);$.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const R=E.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(R){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,l.isEqualAuthority)(O.remoteAuthority,R)))}doGetLastActiveWindow(R){const O=Math.max.apply(Math,R.map(N=>N.lastFocusTime));return R.find(N=>N.lastFocusTime===O)}sendToFocused(R,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(R,P.CancellationToken.None,...O)}sendToAll(R,O,N){for(const q of this.getWindows())N&&N.indexOf(q.id)>=0||q.sendWhenReady(R,P.CancellationToken.None,O)}getWindows(){return $.WINDOWS}getWindowCount(){return $.WINDOWS.length}getWindowById(R){const O=this.getWindows().filter(N=>N.id===R);return(0,D.firstOrDefault)(O)}getWindowByWebContents(R){const O=E.BrowserWindow.fromWebContents(R);if(O)return this.getWindowById(O.id)}};e.WindowsMainService=ce,e.WindowsMainService=ce=$=Ee([Y(2,k.ILogService),Y(3,U.ILoggerMainService),Y(4,T.IStateService),Y(5,z.IPolicyService),Y(6,i.IEnvironmentMainService),Y(7,W.IUserDataProfilesMainService),Y(8,w.ILifecycleMainService),Y(9,t.IBackupMainService),Y(10,a.IConfigurationService),Y(11,ue.IWorkspacesHistoryMainService),Y(12,x.IWorkspacesManagementMainService),Y(13,o.IInstantiationService),Y(14,s.IDialogMainService),Y(15,r.IFileService),Y(16,C.IProtocolMainService),Y(17,G.IThemeMainService)],ce)}),define(ee[306],te([0,1,64,29,84,54]),function(H,e,E,A,n,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(h,d,m,g){this.workspacesManagementMainService=h,this.windowsMainService=d,this.workspacesHistoryMainService=m,this.backupMainService=g,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,d){const m=this.windowsMainService.getWindowById(h);if(m)return this.workspacesManagementMainService.enterWorkspace(m,this.windowsMainService.getWindows(),d)}createUntitledWorkspace(h,d,m){return this.workspacesManagementMainService.createUntitledWorkspace(d,m)}deleteUntitledWorkspace(h,d){return this.workspacesManagementMainService.deleteUntitledWorkspace(d)}getWorkspaceIdentifier(h,d){return this.workspacesManagementMainService.getWorkspaceIdentifier(d)}getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(h,d){return this.workspacesHistoryMainService.addRecentlyOpened(d)}removeRecentlyOpened(h,d){return this.workspacesHistoryMainService.removeRecentlyOpened(d)}clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=D,e.WorkspacesMainService=D=Ee([Y(0,_.IWorkspacesManagementMainService),Y(1,A.IWindowsMainService),Y(2,n.IWorkspacesHistoryMainService),Y(3,E.IBackupMainService)],D)}),define(ee[307],te([0,1,14,132,38,27,17,50,13,32,49,44,46,2,15,9,4,12,7,31,146,42,157,111,289,160,64,285,18,76,198,91,133,61,116,218,28,63,95,207,233,208,294,118,209,210,16,222,94,75,6,93,216,299,286,274,20,5,304,67,22,60,295,96,34,277,83,123,25,250,252,52,48,264,291,300,292,301,128,266,267,268,271,275,29,305,276,30,98,84,306,54,273,39,231,53,243,51,82,130,279,293,282,8,254,278,226,66,92,297,270,24,126,296,262,238,85]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f,l,v,I,p,t,a,s,i,r,o,w,k,M,C,L,T,F,B,se,ie,de,ae,ue,x,G,z,W,U,$,X,oe,ce,V,R,O,N,q,re,ne,le,j,Z,Q,fe,pe,Pe,De,Te,ye,we,K,he,me,Ie,Re,Ue,Ae,ze,Be,J,ge,ve,be,Le,Fe,_e,We,$e,He,qe,Je,Ye,tt,nt,mt,pt,vt,st,wt,St,yt,bt,Et,Pt,It,ot,Ct,kt,Dt,Mt,Rt,at,Lt,dt,ct,At,_t,lt,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ut=class extends u.Disposable{constructor(ke,Ce,Se,Oe,Me,Ne,Ke,Xe,Qe,je,xe,Ve){super(),this.mainProcessNodeIpcServer=ke,this.userEnv=Ce,this.mainInstantiationService=Se,this.logService=Oe,this.loggerService=Me,this.environmentMainService=Ne,this.lifecycleMainService=Ke,this.configurationService=Xe,this.stateService=Qe,this.fileService=je,this.productService=xe,this.userDataProfilesMainService=Ve,this.configureSession(),this.registerListeners()}configureSession(){const ke=je=>je?.startsWith(`${y.Schemas.vscodeWebview}://`),Ce=new Set(this.productService.quality==="stable"?[]:["media"]),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((je,xe,Ve,Ge)=>ke(Ge.requestingUrl)?Ve(Se.has(xe)):Ge.isMainFrame&&Ge.securityOrigin==="vscode-file://vscode-app/"?Ve(Ce.has(xe)):Ve(!1)),E.session.defaultSession.setPermissionCheckHandler((je,xe,Ve,Ge)=>ke(Ge.requestingUrl)?Se.has(xe):Ge.isMainFrame&&Ge.securityOrigin==="vscode-file://vscode-app/"?Ce.has(xe):!1);const Oe=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),Me=je=>{for(let xe=je;xe;xe=xe.parent)if(xe.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Ne=je=>je.resourceType==="xhr"||Me(je.frame),Ke=je=>{const xe=je.frame;if(!xe||!this.windowsMainService)return!1;const Ve=E.BrowserWindow.getAllWindows();for(const Ge of Ve)if(xe.processId===Ge.webContents.mainFrame.processId)return!0;return!1},Xe=(je,xe)=>{if(je.path!=="/index.html")return!0;const Ve=xe.frame;if(!Ve||!this.windowsMainService)return!1;for(const Ge of this.windowsMainService.getWindows())if(Ge.win&&Ve.processId===Ge.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((je,xe)=>{const Ve=l.URI.parse(je.url);return Ve.scheme===y.Schemas.vscodeWebview&&!Xe(Ve,je)?(this.logService.error("Blocked vscode-webview request",je.url),xe({cancel:!0})):Ve.scheme===y.Schemas.vscodeFileResource&&!Ke(je)?(this.logService.error("Blocked vscode-file request",je.url),xe({cancel:!0})):Ve.path.endsWith(".svg")&&!Oe.has(Ve.scheme)?xe({cancel:!Ne(je)}):xe({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((je,xe)=>{const Ve=je.responseHeaders,Ge=Ve["content-type"]||Ve["Content-Type"];if(Ge&&Array.isArray(Ge)){const it=l.URI.parse(je.url);if(it.path.endsWith(".svg")&&Oe.has(it.scheme))return Ve["Content-Type"]=["image/svg+xml"],xe({cancel:!1,responseHeaders:Ve});if(!it.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ge.some(Ze=>Ze.toLowerCase().includes("image/svg")))return xe({cancel:!Ne(je)})}return xe({cancel:!1})});const Qe=E.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Qe.setCodeCachePath((0,b.join)(this.environmentMainService.codeCachePath,"chrome")),c.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,A.disableUNCAccessRestrictions)():(0,A.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,h.setUnexpectedErrorHandler)(Se=>this.onUnexpectedError(Se)),process.on("uncaughtException",Se=>{(0,h.isSigPipeError)(Se)||(0,h.onUnexpectedError)(Se)}),process.on("unhandledRejection",Se=>(0,h.onUnexpectedError)(Se)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,I.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(Se,Oe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Oe)}),E.app.on("activate",async(Se,Oe)=>{this.logService.trace("app#activate"),Oe||await this.windowsMainService?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(Se,Oe)=>{Oe.on("will-navigate",Me=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Me.preventDefault()}),Oe.setWindowOpenHandler(({url:Me})=>(this.nativeHostMainService?.openExternal(void 0,Me),{action:"deny"}))});let ke=[],Ce;E.app.on("open-file",(Se,Oe)=>{this.logService.trace("app#open-file: ",Oe),Se.preventDefault(),ke.push((0,qe.hasWorkspaceFileExtension)(Oe)?{workspaceUri:l.URI.file(Oe)}:{fileUri:l.URI.file(Oe)}),Ce!==void 0&&(clearTimeout(Ce),Ce=void 0),Ce=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:ke,gotoLineMode:!1,preferNewWindow:!0}),ke=[],Ce=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),n.validatedIpcMain.handle("vscode:fetchShellEnv",Se=>{const Oe=this.windowsMainService?.getWindowByWebContents(Se.sender);let Me,Ne;return Oe?.config?(Me=Oe.config,Ne={...process.env,...Oe.config.userEnv}):(Me=this.environmentMainService.args,Ne=process.env),this.resolveShellEnvironment(Me,Ne,!1)}),n.validatedIpcMain.handle("vscode:writeNlsFile",(Se,Oe,Me)=>{const Ne=this.validateNlsPath([Oe]);if(!Ne||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ne,D.VSBuffer.fromString(Me))}),n.validatedIpcMain.handle("vscode:readNlsFile",async(Se,...Oe)=>{const Me=this.validateNlsPath(Oe);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Me)).value.toString()}),n.validatedIpcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),n.validatedIpcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),n.validatedIpcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}validateNlsPath(ke){let Ce;for(const Se of ke)typeof Se=="string"&&(typeof Ce!="string"?Ce=Se:Ce=(0,b.join)(Ce,Se));if(!(typeof Ce!="string"||!(0,b.isAbsolute)(Ce)||!(0,d.isEqualOrParent)(Ce,this.environmentMainService.cachedLanguagesPath,!c.isLinux)))return l.URI.file(Ce)}onUnexpectedError(ke){if(ke){const Ce={message:`[uncaught exception in main]: ${ke.message}`,stack:ke.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Ce))}this.logService.error(`[uncaught exception in main]: ${ke}`),ke.stack&&this.logService.error(ke.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ke=this.productService.win32AppUserModelId;c.isWindows&&ke&&E.app.setAppUserModelId(ke);try{c.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Qe){this.logService.error(Qe)}const Ce=new t.Server;this.lifecycleMainService.onWillShutdown(Qe=>{Qe.reason===2&&Ce.dispose()}),this.logService.trace("Resolving machine identifier...");const Se=await(0,Ct.resolveMachineId)(this.stateService,this.logService);this.logService.trace(`Resolved machine identifier: ${Se}`);const{sharedProcessReady:Oe,sharedProcessClient:Me}=this.setupSharedProcess(Se),Ne=await this.initServices(Se,Oe);this._register(Ne.createInstance(s.ProxyAuthHandler)),this._register(Ne.createInstance(Pt.UserDataProfilesHandler)),Ne.invokeFunction(Qe=>this.initChannels(Qe,Ce,Me));const Ke=Ne.invokeFunction(Qe=>this.setupProtocolUrlHandlers(Qe,Ce));this.setupManagedRemoteResourceUrlHandler(Ce),this.lifecycleMainService.phase=2,await Ne.invokeFunction(Qe=>this.openFirstWindow(Qe,Ke)),this.lifecycleMainService.phase=3,this.afterWindowOpen(),this._register(new ot.RunOnceScheduler(()=>{this._register((0,ot.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setupProtocolUrlHandlers(ke,Ce){const Se=this.windowsMainService=ke.get(We.IWindowsMainService),Oe=ke.get(ge.IURLService),Me=this.nativeHostMainService=ke.get(Z.INativeHostMainService),Ne=this;Oe.registerHandler({async handleURL(Ve,Ge){return Ne.handleProtocolUrl(Se,Oe,Ve,Ge)}});const Ke=this._register(new He.ActiveWindowManager({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),Xe=new p.StaticRouter(Ve=>Ke.getActiveClientId().then(Ge=>Ve===Ge)),Qe=new ve.URLHandlerRouter(Xe,this.logService),je=Ce.getChannel("urlHandler",Qe);Oe.registerHandler(new ve.URLHandlerChannelClient(je));const xe=this.resolveInitialProtocolUrls();return this._register(new Le.ElectronURLListener(xe?.urls,Oe,Se,this.environmentMainService,this.productService,this.logService)),xe}setupManagedRemoteResourceUrlHandler(ke){const Ce=()=>({statusCode:404,data:"Not found"}),Se=new Ot.Lazy(()=>ke.getChannel(lt.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new lt.NodeRemoteResourceRouter));E.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(Oe,Me)=>{const Ne=l.URI.parse(Oe.url);if(!Ne.authority.startsWith("window:"))return Me(Ce());Se.value.call(lt.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[Ne]).then(Ke=>Me({...Ke,data:Buffer.from(Ke.body,"base64")}),Ke=>{this.logService.warn("error dispatching remote resource call",Ke),Me({statusCode:500,data:String(Ke)})})})}resolveInitialProtocolUrls(){const ke=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];ke.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",ke);const Ce=global.getOpenUrls()||[];if(Ce.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ce),ke.length+Ce.length===0)return;const Se=[];return{urls:[...ke,...Ce].map(Me=>{try{return{uri:l.URI.parse(Me),originalUrl:Me}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Me);return}}).filter(Me=>{if(!Me)return!1;if(this.shouldBlockURI(Me.uri))return this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Me.uri.toString(!0)),!1;const Ne=this.getWindowOpenableFromProtocolUrl(Me.uri);return Ne?(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Me.uri.toString(!0),Ne),Se.push(Ne),!1):(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Me.uri.toString(!0)),!0)}),openables:Se}}shouldBlockURI(ke){if(ke.authority===y.Schemas.file&&c.isWindows){const{options:Ce,buttonIndeces:Se}=(0,Rt.massageMessageBoxOptions)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,S.getPathLabel)(ke,{os:c.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,i.localize)(3,null)},this.productService);if(Se[E.dialog.showMessageBoxSync(Ce)]===1)return!0}return!1}getWindowOpenableFromProtocolUrl(ke){if(ke.path){if(ke.authority===y.Schemas.file){const Ce=l.URI.file(ke.fsPath);return(0,qe.hasWorkspaceFileExtension)(Ce)?{workspaceUri:Ce}:{fileUri:Ce}}else if(ke.authority===y.Schemas.vscodeRemote){const Ce=ke.path.indexOf(b.posix.sep,1);if(Ce!==-1){const Se=ke.path.substring(1,Ce),Oe=ke.path.substring(Ce),Me=l.URI.from({scheme:y.Schemas.vscodeRemote,authority:Se,path:Oe,query:ke.query,fragment:ke.fragment});return(0,qe.hasWorkspaceFileExtension)(Oe)?{workspaceUri:Me}:/:[\d]+$/.test(Oe)?{fileUri:Me}:{folderUri:Me}}}}}async handleProtocolUrl(ke,Ce,Se,Oe){if(this.logService.trace("app#handleProtocolUrl():",Se.toString(!0),Oe),Se.scheme===this.productService.urlProtocol&&Se.path==="workspace"&&(Se=Se.with({authority:"file",path:l.URI.parse(Se.query).path,query:""})),this.shouldBlockURI(Se))return this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",Se.toString(!0)),!0;let Me=!1;const Ne=new URLSearchParams(Se.query);Ne.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Se.toString(!0)),Ne.delete("windowId"),Se=Se.with({query:Ne.toString()}),Me=!0):c.isMacintosh&&ke.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Se.toString(!0)),Me=!0);const Ke=Ne.get("continueOn");Ke!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Se.toString(!0)),Ne.delete("continueOn"),Se=Se.with({query:Ne.toString()}),this.environmentMainService.continueOn=Ke??void 0);const Xe=this.getWindowOpenableFromProtocolUrl(Se);return Xe?(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Xe,Se.toString(!0)),(0,dt.firstOrDefault)(await ke.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[Xe],forceNewWindow:Me,gotoLineMode:!0}))?.focus(),!0):Me?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Se.toString(!0)),await(0,dt.firstOrDefault)(await ke.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,fe.getRemoteAuthority)(Se)}))?.ready(),Ce.open(Se,Oe)):(this.logService.trace("app#handleProtocolUrl(): not handled",Se.toString(!0),Oe),!1)}setupSharedProcess(ke){const Ce=this._register(this.mainInstantiationService.createInstance(pe.SharedProcess,ke)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Me=await Ce.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new a.Client(Me,"main")})();return{sharedProcessReady:(async()=>(await Ce.whenReady(),Se))(),sharedProcessClient:Se}}async initServices(ke,Ce){const Se=new R.ServiceCollection;switch(process.platform){case"win32":Se.set(Re.IUpdateService,new ce.SyncDescriptor(J.Win32UpdateService));break;case"linux":c.isLinuxSnap?Se.set(Re.IUpdateService,new ce.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(Re.IUpdateService,new ce.SyncDescriptor(ze.LinuxUpdateService));break;case"darwin":Se.set(Re.IUpdateService,new ce.SyncDescriptor(Ae.DarwinUpdateService));break}Se.set(We.IWindowsMainService,new ce.SyncDescriptor($e.WindowsMainService,[ke,this.userEnv],!1));const Oe=new T.DialogMainService(this.logService,this.productService);Se.set(T.IDialogMainService,Oe),Se.set(re.ILaunchMainService,new ce.SyncDescriptor(re.LaunchMainService,void 0,!1)),Se.set(L.IDiagnosticsMainService,new ce.SyncDescriptor(L.DiagnosticsMainService,void 0,!1)),Se.set(C.IDiagnosticsService,p.ProxyChannel.toService((0,p.getDelayedChannel)(Ce.then(Qe=>Qe.getChannel("diagnostics"))))),Se.set(O.IIssueMainService,new ce.SyncDescriptor(N.IssueMainService,[this.userEnv])),Se.set(F.IEncryptionMainService,new ce.SyncDescriptor(B.EncryptionMainService)),Se.set(q.IKeyboardLayoutMainService,new ce.SyncDescriptor(q.KeyboardLayoutMainService)),Se.set(Z.INativeHostMainService,new ce.SyncDescriptor(Z.NativeHostMainService,void 0,!1)),Se.set(k.ICredentialsMainService,new ce.SyncDescriptor(mt.CredentialsNativeMainService)),Se.set(Fe.IWebviewManagerService,new ce.SyncDescriptor(_e.WebviewMainService)),Se.set(j.IMenubarMainService,new ce.SyncDescriptor(j.MenubarMainService)),Se.set(ae.IExtensionUrlTrustService,new ce.SyncDescriptor(ue.ExtensionUrlTrustService)),Se.set(x.IExtensionHostStarter,new ce.SyncDescriptor(G.ExtensionHostStarter)),Se.set(ye.IStorageMainService,new ce.SyncDescriptor(ye.StorageMainService)),Se.set(ye.IApplicationStorageMainService,new ce.SyncDescriptor(ye.ApplicationStorageMainService));const Me=new At.ElectronPtyHostStarter({graceTime:6e4,shortGraceTime:6e3,scrollback:this.configurationService.getValue("terminal.integrated.persistentSessionScrollback")??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),Ne=new _t.PtyHostService(Me,this.configurationService,this.logService,this.loggerService);Se.set(ct.ILocalPtyService,Ne),c.isWindows?Se.set(z.IExternalTerminalMainService,new ce.SyncDescriptor(W.WindowsExternalTerminalService)):c.isMacintosh?Se.set(z.IExternalTerminalMainService,new ce.SyncDescriptor(W.MacExternalTerminalService)):c.isLinux&&Se.set(z.IExternalTerminalMainService,new ce.SyncDescriptor(W.LinuxExternalTerminalService));const Ke=new o.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);Se.set(r.IBackupMainService,Ke);const Xe=new nt.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Ke,Oe);if(Se.set(nt.IWorkspacesManagementMainService,Xe),Se.set(Je.IWorkspacesService,new ce.SyncDescriptor(tt.WorkspacesMainService,void 0,!1)),Se.set(Ye.IWorkspacesHistoryMainService,new ce.SyncDescriptor(Ye.WorkspacesHistoryMainService,void 0,!1)),Se.set(ge.IURLService,new ce.SyncDescriptor(be.NativeURLService,void 0,!1)),(0,Ie.supportsTelemetry)(this.productService,this.environmentMainService)){const Qe=(0,Ie.isInternalTelemetry)(this.productService,this.configurationService),je=(0,p.getDelayedChannel)(Ce.then(Ze=>Ze.getChannel("telemetryAppender"))),xe=new he.TelemetryAppenderClient(je),Ve=(0,we.resolveCommonProperties)((0,_.release)(),(0,_.hostname)(),process.arch,this.productService.commit,this.productService.version,ke,Qe),Ge=(0,Ie.getPiiPathsFromEnvironment)(this.environmentMainService),it={appenders:[xe],commonProperties:Ve,piiPaths:Ge,sendErrorTelemetry:!0};Se.set(K.ITelemetryService,new ce.SyncDescriptor(me.TelemetryService,[it],!1))}else Se.set(K.ITelemetryService,Ie.NullTelemetryService);return Se.set(yt.IExtensionsProfileScannerService,new ce.SyncDescriptor(kt.ExtensionsProfileScannerService,void 0,!0)),Se.set(bt.IExtensionsScannerService,new ce.SyncDescriptor(Et.ExtensionsScannerService,void 0,!0)),Se.set(at.IUtilityProcessWorkerMainService,new ce.SyncDescriptor(at.UtilityProcessWorkerMainService,void 0,!0)),await ot.Promises.settled([Ke.initialize(),Xe.initialize()]),this.mainInstantiationService.createChild(Se)}initChannels(ke,Ce,Se){const Oe=p.ProxyChannel.fromService(ke.get(re.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Oe);const Me=p.ProxyChannel.fromService(ke.get(L.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Me);const Ne=new vt.PolicyChannel(ke.get(pt.IPolicyService));Ce.registerChannel("policy",Ne),Se.then(et=>et.registerChannel("policy",Ne));const Ke=this.fileService.getProvider(y.Schemas.file);(0,f.assertType)(Ke instanceof oe.DiskFileSystemProvider);const Xe=new X.DiskFileSystemProviderChannel(Ke,this.logService,this.environmentMainService);Ce.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Xe),Se.then(et=>et.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Xe));const Qe=p.ProxyChannel.fromService(ke.get(st.IUserDataProfilesMainService));Ce.registerChannel("userDataProfiles",Qe),Se.then(et=>et.registerChannel("userDataProfiles",Qe));const je=new wt.RequestChannel(ke.get(St.IRequestService));Se.then(et=>et.registerChannel("request",je));const xe=new Ue.UpdateChannel(ke.get(Re.IUpdateService));Ce.registerChannel("update",xe);const Ve=p.ProxyChannel.fromService(ke.get(O.IIssueMainService));Ce.registerChannel("issue",Ve);const Ge=p.ProxyChannel.fromService(ke.get(F.IEncryptionMainService));Ce.registerChannel("encryption",Ge);const it=p.ProxyChannel.fromService(ke.get(k.ICredentialsMainService));Ce.registerChannel("credentials",it);const Ze=p.ProxyChannel.fromService(ke.get(Pe.ISignService));Ce.registerChannel("sign",Ze);const rt=p.ProxyChannel.fromService(ke.get(q.IKeyboardLayoutMainService));Ce.registerChannel("keyboardLayout",rt),this.nativeHostMainService=ke.get(Z.INativeHostMainService);const ht=p.ProxyChannel.fromService(this.nativeHostMainService);Ce.registerChannel("nativeHost",ht),Se.then(et=>et.registerChannel("nativeHost",ht));const Tt=p.ProxyChannel.fromService(ke.get(Je.IWorkspacesService));Ce.registerChannel("workspaces",Tt);const Wt=p.ProxyChannel.fromService(ke.get(j.IMenubarMainService));Ce.registerChannel("menubar",Wt);const Ft=p.ProxyChannel.fromService(ke.get(ge.IURLService));Ce.registerChannel("url",Ft);const Ut=p.ProxyChannel.fromService(ke.get(ae.IExtensionUrlTrustService));Ce.registerChannel("extensionUrlTrust",Ut);const Nt=p.ProxyChannel.fromService(ke.get(Fe.IWebviewManagerService));Ce.registerChannel("webview",Nt);const ft=this._register(new Te.StorageDatabaseChannel(this.logService,ke.get(ye.IStorageMainService)));Ce.registerChannel("storage",ft),Se.then(et=>et.registerChannel("storage",ft));const Bt=this._register(new It.ProfileStorageChangesListenerChannel(ke.get(ye.IStorageMainService),ke.get(st.IUserDataProfilesMainService),this.logService));Se.then(et=>et.registerChannel("profileStorageListener",Bt));const zt=p.ProxyChannel.fromService(ke.get(ct.ILocalPtyService));Ce.registerChannel(ct.TerminalIpcChannels.LocalPty,zt);const $t=p.ProxyChannel.fromService(ke.get(z.IExternalTerminalMainService));Ce.registerChannel("externalTerminal",$t);const gt=new Dt.LoggerChannel(ke.get(Mt.ILoggerMainService));Ce.registerChannel("logger",gt),Se.then(et=>et.registerChannel("logger",gt));const qt=new M.ElectronExtensionHostDebugBroadcastChannel(ke.get(We.IWindowsMainService));Ce.registerChannel("extensionhostdebugservice",qt);const Ht=p.ProxyChannel.fromService(ke.get(x.IExtensionHostStarter));Ce.registerChannel(x.ipcExtensionHostStarterChannelName,Ht);const xt=p.ProxyChannel.fromService(ke.get(at.IUtilityProcessWorkerMainService));Ce.registerChannel(Lt.ipcUtilityProcessWorkerChannelName,xt)}async openFirstWindow(ke,Ce){const Se=this.windowsMainService=ke.get(We.IWindowsMainService),Oe=(0,ie.isLaunchedFromCli)(process.env)?0:4,Me=this.environmentMainService.args;if(Ce){if(Ce.openables.length>0)return Se.open({context:Oe,cli:Me,urisToOpen:Ce.openables,gotoLineMode:!0,initialStartup:!0});if(Ce.urls.length>0)for(const Ze of Ce.urls){const rt=new URLSearchParams(Ze.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),Ze.originalUrl=Ze.uri.toString(!0),Ze.uri=Ze.uri.with({query:rt.toString()}),Se.open({context:Oe,cli:Me,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ne=global.macOpenFiles,Ke=Me._.length,Xe=!!Me["folder-uri"],Qe=!!Me["file-uri"],je=Me["skip-add-to-recently-opened"]===!0,xe=Me.wait&&Me.waitMarkerFilePath?l.URI.file(Me.waitMarkerFilePath):void 0,Ve=Me.remote||void 0,Ge=Me.profile,it=Me["profile-temp"];if(!Ke&&!Xe&&!Qe){if(Me["new-window"]||Ge||it)return Se.open({context:Oe,cli:Me,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:je,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Ve,forceProfile:Ge,forceTempProfile:it});if(Ne.length)return Se.open({context:1,cli:Me,urisToOpen:Ne.map(Ze=>(0,qe.hasWorkspaceFileExtension)(Ze)?{workspaceUri:l.URI.file(Ze)}:{fileUri:l.URI.file(Ze)}),noRecentEntry:je,waitMarkerFileURI:xe,initialStartup:!0})}return Se.open({context:Oe,cli:Me,forceNewWindow:Me["new-window"]||!Ke&&Me["unity-launch"],diffMode:Me.diff,mergeMode:Me.merge,noRecentEntry:je,waitMarkerFileURI:xe,gotoLineMode:Me.goto,initialStartup:!0,remoteAuthority:Ve,forceProfile:Ge,forceTempProfile:it})}afterWindowOpen(){this.installMutex(),E.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(ke,Ce)=>{Ce({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),c.isMacintosh&&E.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const ke=this.productService.win32MutexName;if(c.isWindows&&ke)try{const Ce=await new Promise((Oe,Me)=>{H(["@vscode/windows-mutex"],Oe,Me)}),Se=new Ce.Mutex(ke);(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>Se.release())}catch(Ce){this.logService.error(Ce)}}async resolveShellEnvironment(ke,Ce,Se){try{return await(0,de.getResolvedShellEnv)(this.configurationService,this.logService,ke,Ce)}catch(Oe){const Me=(0,P.toErrorMessage)(Oe);Se?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Me):this.logService.error(Me)}return{}}async updateCrashReporterEnablement(){try{const Ce=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Se=JSON.parse((0,g.stripComments)(Ce)),Me=(0,Ie.getTelemetryLevel)(this.configurationService)>=1;if(Se["enable-crash-reporter"]===void 0){const Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Me},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.generateUuid)()}"`,"}"],Ke=Ce.substring(0,Ce.length-2).concat(`,
`,Ne.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(Ke))}else{const Ne=Ce.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Me},`);Ne!==Ce&&await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(Ne))}}catch(ke){this.logService.error(ke)}}};e.CodeApplication=ut,e.CodeApplication=ut=Ee([Y(2,V.IInstantiationService),Y(3,le.ILogService),Y(4,le.ILoggerService),Y(5,se.IEnvironmentMainService),Y(6,ne.ILifecycleMainService),Y(7,w.IConfigurationService),Y(8,De.IStateService),Y(9,$.IFileService),Y(10,Q.IProductService),Y(11,st.IUserDataProfilesMainService)],ut)}),define(ee[313],te([0,1,14,45,7,24,8,50,13,32,49,46,15,9,65,4,36,26,21,42,100,307,10,18,237,249,28,63,200,16,220,94,75,215,93,20,223,5,78,22,79,280,127,290,51,288,96,248,34,52,80,53,39,232,230,2,40,265,66,225,92,122,269,263]),function(H,e,E,A,n,_,D,P,h,d,m,g,S,u,y,b,c,f,l,v,I,p,t,a,s,i,r,o,w,k,M,C,L,T,F,B,se,ie,de,ae,ue,x,G,z,W,U,$,X,oe,ce,V,R,O,N,q,re,ne,le,j,Z,Q,fe,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Pe{main(){try{this.startup()}catch(ye){console.error(ye.message),E.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[ye,we,K,he,me,Ie,Re,Ue]=this.createServices();try{try{await this.initServices(K,Ue,he,me,Re)}catch(Ae){throw this.handleStartupDataDirError(K,Re,Ae),Ae}await ye.invokeFunction(async Ae=>{const ze=Ae.get(ie.ILogService),Be=Ae.get(B.ILifecycleMainService),J=Ae.get(k.IFileService),ge=Ae.get(ie.ILoggerService),ve=await this.claimInstance(ze,K,Be,ye,Re,!0);return l.Promises.writeFile(K.mainLockfile,String(process.pid)).catch(be=>{ze.warn(`app#startup(): Error writing main lockfile: ${be.stack}`)}),Ie.logger=ge.createLogger("main",{name:(0,t.localize)(0,null)}),(0,m.once)(Be.onWillShutdown)(be=>{J.dispose(),he.dispose(),be.join("instanceLockfile",l.Promises.unlink(K.mainLockfile).catch(()=>{}))}),ye.createInstance(p.CodeApplication,ve,we).startup()})}catch(Ae){ye.invokeFunction(this.quit,Ae)}}createServices(){const ye=new F.ServiceCollection,we=new re.DisposableStore;process.once("exit",()=>we.dispose());const K={_serviceBrand:void 0,...de.default};ye.set(ae.IProductService,K);const he=new r.EnvironmentMainService(this.resolveArgs(),K),me=this.patchEnvironment(he);ye.set(r.IEnvironmentMainService,he);const Ie=new j.LoggerMainService((0,ie.getLogLevel)(he),he.logsHome);ye.set(j.ILoggerMainService,Ie);const Re=new se.BufferLogger(Ie.getLogLevel()),Ue=we.add(new Z.LogService(Re,[new ie.ConsoleMainLogger(Ie.getLogLevel())]));ye.set(ie.ILogService,Ue);const Ae=new M.FileService(Ue);ye.set(k.IFileService,Ae);const ze=new C.DiskFileSystemProvider(Ue);Ae.registerProvider(S.Schemas.file,ze),Ae.registerProvider(S.Schemas.vscodeUserData,new pe.FileUserDataProvider(S.Schemas.file,ze,S.Schemas.vscodeUserData,Ue));const Be=new le.UriIdentityService(Ae);ye.set(ne.IUriIdentityService,Be);const J=new fe.StateService(1,he,Ue,Ae);ye.set(oe.IStateReadService,J),ye.set(oe.IStateService,J);const ge=new R.UserDataProfilesMainService(J,Be,he,Ae,Ue);ye.set(R.IUserDataProfilesMainService,ge);const ve=b.isWindows&&K.win32RegValueName?we.add(new N.NativePolicyService(Ue,K.win32RegValueName)):he.policyFile?we.add(new q.FilePolicyService(he.policyFile,Ae,Ue)):new O.NullPolicyService;ye.set(O.IPolicyService,ve);const be=new s.ConfigurationService(ge.defaultProfile.settingsResource,Ae,ve,Ue);return ye.set(a.IConfigurationService,be),ye.set(B.ILifecycleMainService,new L.SyncDescriptor(B.LifecycleMainService,void 0,!1)),ye.set(W.IRequestService,new L.SyncDescriptor(U.RequestMainService,void 0,!0)),ye.set(V.IThemeMainService,new L.SyncDescriptor(V.ThemeMainService)),ye.set($.ISignService,new L.SyncDescriptor(X.SignService,void 0,!1)),ye.set(G.ITunnelService,new L.SyncDescriptor(z.TunnelService)),ye.set(ue.IProtocolMainService,new x.ProtocolMainService(he,ge,Ue)),[new T.InstantiationService(ye,!0),me,he,be,J,Re,K,ge]}patchEnvironment(ye){const we={VSCODE_IPC_HOOK:ye.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(K=>{const he=process.env[K];typeof he=="string"&&(we[K]=he)}),Object.assign(process.env,we),we}async initServices(ye,we,K,he,me){await D.Promises.settled([Promise.all([ye.extensionsPath,ye.codeCachePath,ye.logsHome.fsPath,we.defaultProfile.globalStorageHome.fsPath,ye.workspaceStorageHome.fsPath,ye.localHistoryHome.fsPath,ye.backupHome].map(Ie=>Ie?l.Promises.mkdir(Ie,{recursive:!0}):void 0)),he.init(),K.initialize()]),we.init()}async claimInstance(ye,we,K,he,me,Ie){let Re;try{(0,y.mark)("code/willStartMainServer"),Re=await(0,I.serve)(we.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,m.once)(K.onWillShutdown)(()=>Re.dispose())}catch(Ue){if(Ue.code!=="EADDRINUSE")throw this.handleStartupDataDirError(we,me,Ue),Ue;let Ae;try{Ae=await(0,I.connect)(we.mainIPCHandle,"main")}catch(ge){if(!Ie||b.isWindows||ge.code!=="ECONNREFUSED")throw ge.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,me.nameShort),(0,t.localize)(2,null),me),ge;try{(0,A.unlinkSync)(we.mainIPCHandle)}catch(ve){throw ye.warn("Could not delete obsolete instance handle",ve),ve}return this.claimInstance(ye,we,K,he,me,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const ge=`Running extension tests from the command line is currently only supported if no other instance of ${me.nameShort} is running.`;throw ye.error(ge),Ae.dispose(),new Error(ge)}let ze;!we.args.wait&&!we.args.status&&(ze=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,me.nameShort),(0,t.localize)(4,null),me)},1e4));const Be=v.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),J=v.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return he.invokeFunction(async()=>{const ge=new i.DiagnosticsService(ce.NullTelemetryService,me),ve=await J.getMainDiagnostics(),be=await J.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Le=await ge.getDiagnostics(ve,be);throw console.log(Le),new h.ExpectedError});throw b.isWindows&&await this.windowsAllowSetForegroundWindow(Be,ye),ye.trace("Sending env to running instance..."),await Be.start(we.args,process.env),Ae.dispose(),ze&&clearTimeout(ze),new h.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw console.log((0,t.localize)(5,null,me.nameShort)),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Re}handleStartupDataDirError(ye,we,K){if(K.code==="EACCES"||K.code==="EPERM"){const he=(0,_.coalesce)([ye.userDataPath,ye.extensionsPath,I.XDG_RUNTIME_DIR]).map(me=>(0,g.getPathLabel)(n.URI.file(me),{os:b.OS,tildify:ye}));this.showStartupWarningDialog((0,t.localize)(6,null),(0,t.localize)(7,null,(0,P.toErrorMessage)(K),he.join(`
`)),we)}}showStartupWarningDialog(ye,we,K){E.dialog.showMessageBoxSync((0,Q.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ye,detail:we},K).options)}async windowsAllowSetForegroundWindow(ye,we){if(b.isWindows){const K=await ye.getMainProcessId();we.trace("Sending some foreground love to the running instance:",K);try{(await new Promise((he,me)=>{H(["windows-foreground-love"],he,me)})).allowSetForegroundWindow(K)}catch(he){we.error(he)}}}quit(ye,we){const K=ye.get(ie.ILogService),he=ye.get(B.ILifecycleMainService);let me=0;we&&(we.isExpected?we.message&&K.trace(we.message):(me=1,we.stack?K.error(we.stack):K.error(`Startup error: ${we.toString()}`))),he.kill(me)}resolveArgs(){const ye=this.validatePaths((0,o.parseMainProcessArgv)(process.argv));if(ye.wait&&!ye.waitMarkerFilePath){const we=(0,w.createWaitMarkerFileSync)(ye.verbose);we&&((0,o.addArg)(process.argv,"--waitMarkerFilePath",we),ye.waitMarkerFilePath=we)}return ye}validatePaths(ye){if(ye["open-url"]&&(ye._urls=ye._,ye._=[]),!ye.remote){const we=this.doValidatePaths(ye._,ye.goto);ye._=we}return ye}doValidatePaths(ye,we){const K=(0,c.cwd)(),he=ye.map(Re=>{let Ue=String(Re),Ae;we&&(Ae=(0,d.parseLineAndColumnAware)(Ue),Ue=Ae.path),Ue&&(Ue=this.preparePath(K,Ue));const ze=(0,d.sanitizeFilePath)(Ue,K),Be=(0,u.basename)(ze);return Be&&!(0,d.isValidBasename)(Be)?null:we&&Ae?(Ae.path=ze,this.toPath(Ae)):ze}),me=b.isWindows||b.isMacintosh,Ie=(0,_.distinct)(he,Re=>Re&&me?Re.toLowerCase():Re||"");return(0,_.coalesce)(Ie)}preparePath(ye,we){return b.isWindows&&(we=(0,f.rtrim)(we,'"')),we=(0,f.trim)((0,f.trim)(we," "),"	"),b.isWindows&&(we=(0,u.resolve)(ye,we),we=(0,f.rtrim)(we,".")),we}toPath(ye){const we=[ye.path];return typeof ye.line=="number"&&we.push(String(ye.line)),typeof ye.column=="number"&&we.push(String(ye.column)),we.join(":")}}new Pe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a5004432af6600c99fa4f918a3f2f8df44df71e6/core/vs/code/electron-main/main.js.map
