/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],se=function(G){for(var e=[],N=0,O=G.length;N<O;N++)e[N]=ne[G[N]];return e};define(ne[70],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class N{static get(){const k=new Map,A=new Map,T=new Map,y=new Map;function u(d,w){d.has(w.detail)||d.set(w.detail,-w.timestamp)}function c(d,w){const I=d.get(w.detail);I&&(I>=0||d.set(w.detail,I+w.timestamp))}let S=[];typeof G=="function"&&typeof G.getStats=="function"&&(S=G.getStats().slice(0).sort((d,w)=>d.timestamp-w.timestamp));for(const d of S)switch(d.type){case 10:u(k,d);break;case 11:case 12:c(k,d);break;case 21:u(A,d);break;case 22:c(A,d);break;case 33:u(T,d);break;case 34:c(T,d);break;case 31:u(y,d);break;case 32:c(y,d);break}let R=0;T.forEach(d=>R+=d);function g(d){const w=[];return d.forEach((I,p)=>w.push([p,I])),w}return{amdLoad:g(k),amdInvoke:g(A),nodeRequire:g(T),nodeEval:g(y),nodeRequireTotal:R}}static toMarkdownTable(k,A){let T="";const y=[];return k.forEach((u,c)=>{y[c]=u.length}),A.forEach(u=>{u.forEach((c,S)=>{typeof c>"u"&&(c=u[S]="-");const R=c.toString().length;y[S]=Math.max(R,y[S])})}),k.forEach((u,c)=>{T+=`| ${u+" ".repeat(y[c]-u.toString().length)} `}),T+=`|
`,k.forEach((u,c)=>{T+=`| ${"-".repeat(y[c])} `}),T+=`|
`,A.forEach(u=>{u.forEach((c,S)=>{typeof c<"u"&&(T+=`| ${c+" ".repeat(y[S]-c.toString().length)} `)}),T+=`|
`}),T}}e.LoaderStats=N}),define(ne[52],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function N(T){return(y,u,c)=>{let S=null,R=null;if(typeof c.value=="function"?(S="value",R=c.value):typeof c.get=="function"&&(S="get",R=c.get),!R)throw new Error("not supported");c[S]=T(R,u)}}function O(T,y,u){let c=null,S=null;if(typeof u.value=="function"?(c="value",S=u.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",S=u.get),!S)throw new Error("not supported");const R=`$memoize$${y}`;u[c]=function(...g){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,g)}),this[R]}}e.memoize=O;function k(T,y,u){return N((c,S)=>{const R=`$debounce$${S}`,g=`$debounce$result$${S}`;return function(...d){this[g]||(this[g]=u?u():void 0),clearTimeout(this[R]),y&&(this[g]=y(this[g],...d),d=[this[g]]),this[R]=setTimeout(()=>{c.apply(this,d),this[g]=u?u():void 0},T)}})}e.debounce=k;function A(T,y,u){return N((c,S)=>{const R=`$throttle$timer$${S}`,g=`$throttle$result$${S}`,d=`$throttle$lastRun$${S}`,w=`$throttle$pending$${S}`;return function(...I){if(this[g]||(this[g]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),y&&(this[g]=y(this[g],...I)),this[w])return;const p=this[d]+T;p<=Date.now()?(this[d]=Date.now(),c.apply(this,[this[g]]),this[g]=u?u():void 0):(this[w]=!0,this[R]=setTimeout(()=>{this[w]=!1,this[d]=Date.now(),c.apply(this,[this[g]]),this[g]=u?u():void 0},p-Date.now()))}})}e.throttle=A}),define(ne[71],se([0,1,9]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=O;function k(u,c="Unreachable"){throw new Error(c)}e.assertNever=k;function A(u){if(!u)throw new N.BugIndicatingError("Assertion Failed")}e.assert=A;function T(u){if(!u()){debugger;u(),(0,N.onUnexpectedError)(new N.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function y(u,c){let S=0;for(;S<u.length-1;){const R=u[S],g=u[S+1];if(!c(R,g))return!1;S++}return!0}e.checkAdjacentItems=y}),define(ne[53],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var N;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(N||(e.ScanError=N={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function T(t,o=!1){let i=0;const r=t.length;let n="",s=0,l=16,D=0;function C(te){let le=0,ue=0;for(;le<te;){const ie=t.charCodeAt(i);if(ie>=48&&ie<=57)ue=ue*16+ie-48;else if(ie>=65&&ie<=70)ue=ue*16+ie-65+10;else if(ie>=97&&ie<=102)ue=ue*16+ie-97+10;else break;i++,le++}return le<te&&(ue=-1),ue}function E(te){i=te,n="",s=0,l=16,D=0}function L(){const te=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return D=3,t.substring(te,i);let le=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;le=i}else D=3;return t.substring(te,le)}function $(){let te="",le=i;for(;;){if(i>=r){te+=t.substring(le,i),D=2;break}const ue=t.charCodeAt(i);if(ue===34){te+=t.substring(le,i),i++;break}if(ue===92){if(te+=t.substring(le,i),i++,i>=r){D=2;break}switch(t.charCodeAt(i++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const W=C(4);W>=0?te+=String.fromCharCode(W):D=4;break}default:D=5}le=i;continue}if(ue>=0&&ue<=31)if(u(ue)){te+=t.substring(le,i),D=2;break}else D=6;i++}return te}function Z(){if(n="",D=0,s=i,i>=r)return s=r,l=17;let te=t.charCodeAt(i);if(y(te)){do i++,n+=String.fromCharCode(te),te=t.charCodeAt(i);while(y(te));return l=15}if(u(te))return i++,n+=String.fromCharCode(te),te===13&&t.charCodeAt(i)===10&&(i++,n+=`
`),l=14;switch(te){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,n=$(),l=10;case 47:{const le=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!u(t.charCodeAt(i));)i++;return n=t.substring(le,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const ue=r-1;let ie=!1;for(;i<ue;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,D=1),n=t.substring(le,i),l=13}return n+=String.fromCharCode(te),i++,l=16}case 45:if(n+=String.fromCharCode(te),i++,i===r||!c(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=L(),l=11;default:for(;i<r&&Q(te);)i++,te=t.charCodeAt(i);if(s!==i){switch(n=t.substring(s,i),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(te),i++,l=16}}function Q(te){if(y(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let te;do te=Z();while(te>=12&&te<=15);return te}return{setPosition:E,getPosition:()=>i,scan:o?ce:Z,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>D}}e.createScanner=T;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var S;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(S||(S={}));function R(t,o){const i=[],r=new Object;let n;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function D(C,E,L,$){s.value=C,s.offset=E,s.length=L,s.type=$,s.colonOffset=void 0,n=s}try{b(t,{onObjectBegin:(C,E)=>{if(o<=C)throw r;n=void 0,l=o>C,i.push("")},onObjectProperty:(C,E,L)=>{if(o<E||(D(C,E,L,"property"),i[i.length-1]=C,o<=E+L))throw r},onObjectEnd:(C,E)=>{if(o<=C)throw r;n=void 0,i.pop()},onArrayBegin:(C,E)=>{if(o<=C)throw r;n=void 0,i.push(0)},onArrayEnd:(C,E)=>{if(o<=C)throw r;n=void 0,i.pop()},onLiteralValue:(C,E,L)=>{if(o<E||(D(C,E,L,P(C)),o<=E+L))throw r},onSeparator:(C,E,L)=>{if(o<=E)throw r;if(C===":"&&n&&n.type==="property")n.colonOffset=E,l=!1,n=void 0;else if(C===","){const $=i[i.length-1];typeof $=="number"?i[i.length-1]=$+1:(l=!0,i[i.length-1]=""),n=void 0}}})}catch(C){if(C!==r)throw C}return{path:i,previousNode:n,isAtPropertyKey:l,matches:C=>{let E=0;for(let L=0;E<C.length&&L<i.length;L++)if(C[E]===i[L]||C[E]==="*")E++;else if(C[E]!=="**")return!1;return E===C.length}}}e.getLocation=R;function g(t,o=[],i=A.DEFAULT){let r=null,n=[];const s=[];function l(C){Array.isArray(n)?n.push(C):r!==null&&(n[r]=C)}return b(t,{onObjectBegin:()=>{const C={};l(C),s.push(n),n=C,r=null},onObjectProperty:C=>{r=C},onObjectEnd:()=>{n=s.pop()},onArrayBegin:()=>{const C=[];l(C),s.push(n),n=C,r=null},onArrayEnd:()=>{n=s.pop()},onLiteralValue:l,onError:(C,E,L)=>{o.push({error:C,offset:E,length:L})}},i),n[0]}e.parse=g;function d(t,o=[],i=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(C){r.type==="property"&&(r.length=C-r.offset,r=r.parent)}function s(C){return r.children.push(C),C}b(t,{onObjectBegin:C=>{r=s({type:"object",offset:C,length:-1,parent:r,children:[]})},onObjectProperty:(C,E,L)=>{r=s({type:"property",offset:E,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:C,offset:E,length:L,parent:r})},onObjectEnd:(C,E)=>{r.length=C+E-r.offset,r=r.parent,n(C+E)},onArrayBegin:(C,E)=>{r=s({type:"array",offset:C,length:-1,parent:r,children:[]})},onArrayEnd:(C,E)=>{r.length=C+E-r.offset,r=r.parent,n(C+E)},onLiteralValue:(C,E,L)=>{s({type:P(C),offset:E,length:L,parent:r,value:C}),n(E+L)},onSeparator:(C,E,L)=>{r.type==="property"&&(C===":"?r.colonOffset=E:C===","&&n(E))},onError:(C,E,L)=>{o.push({error:C,offset:E,length:L})}},i);const D=r.children[0];return D&&delete D.parent,D}e.parseTree=d;function w(t,o){if(!t)return;let i=t;for(const r of o)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===r){i=s.children[1],n=!0;break}if(!n)return}else{const n=r;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}e.findNodeAtLocation=w;function I(t){if(!t.parent||!t.parent.children)return[];const o=I(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;o.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&o.push(i)}return o}e.getNodePath=I;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":{const o=Object.create(null);for(const i of t.children){const r=i.children[1];r&&(o[i.children[0].value]=p(r))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function h(t,o,i=!1){return o>=t.offset&&o<t.offset+t.length||i&&o===t.offset+t.length}e.contains=h;function f(t,o,i=!1){if(h(t,o,i)){const r=t.children;if(Array.isArray(r))for(let n=0;n<r.length&&r[n].offset<=o;n++){const s=f(r[n],o,i);if(s)return s}return t}}e.findNodeAtOffset=f;function b(t,o,i=A.DEFAULT){const r=T(t,!1);function n(X){return X?()=>X(r.getTokenOffset(),r.getTokenLength()):()=>!0}function s(X){return X?J=>X(J,r.getTokenOffset(),r.getTokenLength()):()=>!0}const l=n(o.onObjectBegin),D=s(o.onObjectProperty),C=n(o.onObjectEnd),E=n(o.onArrayBegin),L=n(o.onArrayEnd),$=s(o.onLiteralValue),Z=s(o.onSeparator),Q=n(o.onComment),ce=s(o.onError),te=i&&i.disallowComments,le=i&&i.allowTrailingComma;function ue(){for(;;){const X=r.scan();switch(r.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(X){case 12:case 13:te?ie(10):Q();break;case 16:ie(1);break;case 15:case 14:break;default:return X}}}function ie(X,J=[],_=[]){if(ce(X),J.length+_.length>0){let x=r.getToken();for(;x!==17;){if(J.indexOf(x)!==-1){ue();break}else if(_.indexOf(x)!==-1)break;x=ue()}}}function W(X){const J=r.getTokenValue();return X?$(J):D(J),ue(),!0}function q(){switch(r.getToken()){case 11:{let X=0;try{X=JSON.parse(r.getTokenValue()),typeof X!="number"&&(ie(2),X=0)}catch{ie(2)}$(X);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return ue(),!0}function V(){return r.getToken()!==10?(ie(3,[],[2,5]),!1):(W(!1),r.getToken()===6?(Z(":"),ue(),K()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function M(){l(),ue();let X=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(X||ie(4,[],[]),Z(","),ue(),r.getToken()===2&&le)break}else X&&ie(6,[],[]);V()||ie(4,[],[2,5]),X=!0}return C(),r.getToken()!==2?ie(7,[2],[]):ue(),!0}function z(){E(),ue();let X=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(X||ie(4,[],[]),Z(","),ue(),r.getToken()===4&&le)break}else X&&ie(6,[],[]);K()||ie(4,[],[4,5]),X=!0}return L(),r.getToken()!==4?ie(8,[4],[]):ue(),!0}function K(){switch(r.getToken()){case 3:return z();case 1:return M();case 10:return W(!0);default:return q()}}return ue(),r.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):K()?(r.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.visit=b;function v(t,o){const i=T(t),r=[];let n,s=0,l;do switch(l=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:s!==l&&r.push(t.substring(s,l)),o!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,o)),s=i.getPosition();break}while(n!==17);return r.join("")}e.stripComments=v;function P(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=P}),define(ne[72],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function N(y,u,c){return Math.min(Math.max(y,u),c)}e.clamp=N;function O(y,u){return(u+y%u)%u}e.rot=O;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class A{constructor(){this._n=1,this._val=0}update(u){return this._val=this._val+(u-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class T{constructor(u){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(u),this._values.fill(0,0,u)}update(u){const c=this._values[this._index];return this._values[this._index]=u,this._index=(this._index+1)%this._values.length,this._sum-=c,this._sum+=u,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function G(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function T(u){A.push(u,Date.now())}function y(){const u=[];for(let c=0;c<A.length;c+=2)u.push({name:A[c],startTime:A[c+1]});return u}return{mark:T,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(k+T.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function N(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return N(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=N(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=N(O))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var N=e();for(var O in N)(typeof exports=="object"?exports:G)[O]=N[O]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function N(O){if(e[O])return e[O].exports;var k=e[O]={i:O,l:!1,exports:{}};return G[O].call(k.exports,k,k.exports,N),k.l=!0,k.exports}return N.m=G,N.c=e,N.d=function(O,k,A){N.o(O,k)||Object.defineProperty(O,k,{enumerable:!0,get:A})},N.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},N.t=function(O,k){if(1&k&&(O=N(O)),8&k||4&k&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(N.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&k&&typeof O!="string")for(var T in O)N.d(A,T,function(y){return O[y]}.bind(null,T));return A},N.n=function(O){var k=O&&O.__esModule?function(){return O.default}:function(){return O};return N.d(k,"a",k),k},N.o=function(O,k){return Object.prototype.hasOwnProperty.call(O,k)},N.p="",N(N.s=0)}([function(G,e,N){(function(O){var k;e=G.exports=_,k=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],u=e.src=[],c=0,S=c++;u[S]="0|[1-9]\\d*";var R=c++;u[R]="[0-9]+";var g=c++;u[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=c++;u[d]="("+u[S]+")\\.("+u[S]+")\\.("+u[S]+")";var w=c++;u[w]="("+u[R]+")\\.("+u[R]+")\\.("+u[R]+")";var I=c++;u[I]="(?:"+u[S]+"|"+u[g]+")";var p=c++;u[p]="(?:"+u[R]+"|"+u[g]+")";var h=c++;u[h]="(?:-("+u[I]+"(?:\\."+u[I]+")*))";var f=c++;u[f]="(?:-?("+u[p]+"(?:\\."+u[p]+")*))";var b=c++;u[b]="[0-9A-Za-z-]+";var v=c++;u[v]="(?:\\+("+u[b]+"(?:\\."+u[b]+")*))";var P=c++,t="v?"+u[d]+u[h]+"?"+u[v]+"?";u[P]="^"+t+"$";var o="[v=\\s]*"+u[w]+u[f]+"?"+u[v]+"?",i=c++;u[i]="^"+o+"$";var r=c++;u[r]="((?:<|>)?=?)";var n=c++;u[n]=u[R]+"|x|X|\\*";var s=c++;u[s]=u[S]+"|x|X|\\*";var l=c++;u[l]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[h]+")?"+u[v]+"?)?)?";var D=c++;u[D]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[f]+")?"+u[v]+"?)?)?";var C=c++;u[C]="^"+u[r]+"\\s*"+u[l]+"$";var E=c++;u[E]="^"+u[r]+"\\s*"+u[D]+"$";var L=c++;u[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=c++;u[$]="(?:~>?)";var Z=c++;u[Z]="(\\s*)"+u[$]+"\\s+",y[Z]=new RegExp(u[Z],"g");var Q=c++;u[Q]="^"+u[$]+u[l]+"$";var ce=c++;u[ce]="^"+u[$]+u[D]+"$";var te=c++;u[te]="(?:\\^)";var le=c++;u[le]="(\\s*)"+u[te]+"\\s+",y[le]=new RegExp(u[le],"g");var ue=c++;u[ue]="^"+u[te]+u[l]+"$";var ie=c++;u[ie]="^"+u[te]+u[D]+"$";var W=c++;u[W]="^"+u[r]+"\\s*("+o+")$|^$";var q=c++;u[q]="^"+u[r]+"\\s*("+t+")$|^$";var V=c++;u[V]="(\\s*)"+u[r]+"\\s*("+o+"|"+u[l]+")",y[V]=new RegExp(u[V],"g");var M=c++;u[M]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var z=c++;u[z]="^\\s*("+u[D]+")\\s+-\\s+("+u[D]+")\\s*$";var K=c++;u[K]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)k(X,u[X]),y[X]||(y[X]=new RegExp(u[X]));function J(j,Y){if(j instanceof _)return j;if(typeof j!="string"||j.length>A||!(Y?y[i]:y[P]).test(j))return null;try{return new _(j,Y)}catch{return null}}function _(j,Y){if(j instanceof _){if(j.loose===Y)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof _))return new _(j,Y);k("SemVer",j,Y),this.loose=Y;var ee=j.trim().match(Y?y[i]:y[P]);if(!ee)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var ye=+me;if(ye>=0&&ye<T)return ye}return me}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=J,e.valid=function(j,Y){var ee=J(j,Y);return ee?ee.version:null},e.clean=function(j,Y){var ee=J(j.trim().replace(/^[=v]+/,""),Y);return ee?ee.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(j){return k("SemVer.compare",this.version,this.loose,j),j instanceof _||(j=new _(j,this.loose)),this.compareMain(j)||this.comparePre(j)},_.prototype.compareMain=function(j){return j instanceof _||(j=new _(j,this.loose)),a(this.major,j.major)||a(this.minor,j.minor)||a(this.patch,j.patch)},_.prototype.comparePre=function(j){if(j instanceof _||(j=new _(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var Y=0;do{var ee=this.prerelease[Y],me=j.prerelease[Y];if(k("prerelease compare",Y,ee,me),ee===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(ee===void 0)return-1;if(ee!==me)return a(ee,me)}while(++Y)},_.prototype.inc=function(j,Y){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,Y,ee,me){typeof ee=="string"&&(me=ee,ee=void 0);try{return new _(j,ee).inc(Y,me).version}catch{return null}},e.diff=function(j,Y){if(H(j,Y))return null;var ee=J(j),me=J(Y);if(ee.prerelease.length||me.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==me[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==me[ye])return ye},e.compareIdentifiers=a;var x=/^[0-9]+$/;function a(j,Y){var ee=x.test(j),me=x.test(Y);return ee&&me&&(j=+j,Y=+Y),ee&&!me?-1:me&&!ee?1:j<Y?-1:j>Y?1:0}function m(j,Y,ee){return new _(j,ee).compare(new _(Y,ee))}function F(j,Y,ee){return m(j,Y,ee)>0}function U(j,Y,ee){return m(j,Y,ee)<0}function H(j,Y,ee){return m(j,Y,ee)===0}function B(j,Y,ee){return m(j,Y,ee)!==0}function oe(j,Y,ee){return m(j,Y,ee)>=0}function ae(j,Y,ee){return m(j,Y,ee)<=0}function ve(j,Y,ee,me){var ye;switch(Y){case"===":typeof j=="object"&&(j=j.version),typeof ee=="object"&&(ee=ee.version),ye=j===ee;break;case"!==":typeof j=="object"&&(j=j.version),typeof ee=="object"&&(ee=ee.version),ye=j!==ee;break;case"":case"=":case"==":ye=H(j,ee,me);break;case"!=":ye=B(j,ee,me);break;case">":ye=F(j,ee,me);break;case">=":ye=oe(j,ee,me);break;case"<":ye=U(j,ee,me);break;case"<=":ye=ae(j,ee,me);break;default:throw new TypeError("Invalid operator: "+Y)}return ye}function de(j,Y){if(j instanceof de){if(j.loose===Y)return j;j=j.value}if(!(this instanceof de))return new de(j,Y);k("comparator",j,Y),this.loose=Y,this.parse(j),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(j,Y){return a(Y,j)},e.major=function(j,Y){return new _(j,Y).major},e.minor=function(j,Y){return new _(j,Y).minor},e.patch=function(j,Y){return new _(j,Y).patch},e.compare=m,e.compareLoose=function(j,Y){return m(j,Y,!0)},e.rcompare=function(j,Y,ee){return m(Y,j,ee)},e.sort=function(j,Y){return j.sort(function(ee,me){return e.compare(ee,me,Y)})},e.rsort=function(j,Y){return j.sort(function(ee,me){return e.rcompare(ee,me,Y)})},e.gt=F,e.lt=U,e.eq=H,e.neq=B,e.gte=oe,e.lte=ae,e.cmp=ve,e.Comparator=de;var ge={};function he(j,Y){if(j instanceof he)return j.loose===Y?j:new he(j.raw,Y);if(j instanceof de)return new he(j.value,Y);if(!(this instanceof he))return new he(j,Y);if(this.loose=Y,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function fe(j){return!j||j.toLowerCase()==="x"||j==="*"}function Se(j,Y,ee,me,ye,Le,Ie,Ne,Ce,Ae,_e,Re,Te){return((Y=fe(ee)?"":fe(me)?">="+ee+".0.0":fe(ye)?">="+ee+"."+me+".0":">="+Y)+" "+(Ne=fe(Ce)?"":fe(Ae)?"<"+(+Ce+1)+".0.0":fe(_e)?"<"+Ce+"."+(+Ae+1)+".0":Re?"<="+Ce+"."+Ae+"."+_e+"-"+Re:"<="+Ne)).trim()}function we(j,Y){for(var ee=0;ee<j.length;ee++)if(!j[ee].test(Y))return!1;if(Y.prerelease.length){for(ee=0;ee<j.length;ee++)if(k(j[ee].semver),j[ee].semver!==ge&&j[ee].semver.prerelease.length>0){var me=j[ee].semver;if(me.major===Y.major&&me.minor===Y.minor&&me.patch===Y.patch)return!0}return!1}return!0}function be(j,Y,ee){try{Y=new he(Y,ee)}catch{return!1}return Y.test(j)}function Fe(j,Y,ee,me){var ye,Le,Ie,Ne,Ce;switch(j=new _(j,me),Y=new he(Y,me),ee){case">":ye=F,Le=ae,Ie=U,Ne=">",Ce=">=";break;case"<":ye=U,Le=oe,Ie=F,Ne="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(j,Y,me))return!1;for(var Ae=0;Ae<Y.set.length;++Ae){var _e=Y.set[Ae],Re=null,Te=null;if(_e.forEach(function(Oe){Oe.semver===ge&&(Oe=new de(">=0.0.0")),Re=Re||Oe,Te=Te||Oe,ye(Oe.semver,Re.semver,me)?Re=Oe:Ie(Oe.semver,Te.semver,me)&&(Te=Oe)}),Re.operator===Ne||Re.operator===Ce||(!Te.operator||Te.operator===Ne)&&Le(j,Te.semver)||Te.operator===Ce&&Ie(j,Te.semver))return!1}return!0}de.prototype.parse=function(j){var Y=this.loose?y[W]:y[q],ee=j.match(Y);if(!ee)throw new TypeError("Invalid comparator: "+j);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new _(ee[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(j){return k("Comparator.test",j,this.loose),this.semver===ge||(typeof j=="string"&&(j=new _(j,this.loose)),ve(j,this.operator,this.semver,this.loose))},de.prototype.intersects=function(j,Y){if(!(j instanceof de))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new he(j.value,Y),be(this.value,ee,Y);if(j.operator==="")return ee=new he(this.value,Y),be(j.semver,ee,Y);var me=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Le=this.semver.version===j.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Ne=ve(this.semver,"<",j.semver,Y)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),Ce=ve(this.semver,">",j.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return me||ye||Le&&Ie||Ne||Ce},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(j){var Y=this.loose;j=j.trim(),k("range",j,Y);var ee=Y?y[z]:y[M];j=j.replace(ee,Se),k("hyphen replace",j),j=j.replace(y[V],"$1$2$3"),k("comparator trim",j,y[V]),j=(j=(j=j.replace(y[Z],"$1~")).replace(y[le],"$1^")).split(/\s+/).join(" ");var me=Y?y[W]:y[q],ye=j.split(" ").map(function(Le){return function(Ie,Ne){return k("comp",Ie),Ie=function(Ce,Ae){return Ce.trim().split(/\s+/).map(function(_e){return function(Re,Te){k("caret",Re,Te);var Oe=Te?y[ie]:y[ue];return Re.replace(Oe,function(Me,Ee,Pe,De,ke){var xe;return k("caret",Re,Me,Ee,Pe,De,ke),fe(Ee)?xe="":fe(Pe)?xe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(De)?xe=Ee==="0"?">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+".0 <"+(+Ee+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),xe=Ee==="0"?Pe==="0"?">="+Ee+"."+Pe+"."+De+ke+" <"+Ee+"."+Pe+"."+(+De+1):">="+Ee+"."+Pe+"."+De+ke+" <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+"."+De+ke+" <"+(+Ee+1)+".0.0"):(k("no pr"),xe=Ee==="0"?Pe==="0"?">="+Ee+"."+Pe+"."+De+" <"+Ee+"."+Pe+"."+(+De+1):">="+Ee+"."+Pe+"."+De+" <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+"."+De+" <"+(+Ee+1)+".0.0"),k("caret return",xe),xe})}(_e,Ae)}).join(" ")}(Ie,Ne),k("caret",Ie),Ie=function(Ce,Ae){return Ce.trim().split(/\s+/).map(function(_e){return function(Re,Te){var Oe=Te?y[ce]:y[Q];return Re.replace(Oe,function(Me,Ee,Pe,De,ke){var xe;return k("tilde",Re,Me,Ee,Pe,De,ke),fe(Ee)?xe="":fe(Pe)?xe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(De)?xe=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),xe=">="+Ee+"."+Pe+"."+De+ke+" <"+Ee+"."+(+Pe+1)+".0"):xe=">="+Ee+"."+Pe+"."+De+" <"+Ee+"."+(+Pe+1)+".0",k("tilde return",xe),xe})}(_e,Ae)}).join(" ")}(Ie,Ne),k("tildes",Ie),Ie=function(Ce,Ae){return k("replaceXRanges",Ce,Ae),Ce.split(/\s+/).map(function(_e){return function(Re,Te){Re=Re.trim();var Oe=Te?y[E]:y[C];return Re.replace(Oe,function(Me,Ee,Pe,De,ke,xe){k("xRange",Re,Me,Ee,Pe,De,ke,xe);var We=fe(Pe),Ue=We||fe(De),Ve=Ue||fe(ke);return Ee==="="&&Ve&&(Ee=""),We?Me=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Ve?(Ue&&(De=0),Ve&&(ke=0),Ee===">"?(Ee=">=",Ue?(Pe=+Pe+1,De=0,ke=0):Ve&&(De=+De+1,ke=0)):Ee==="<="&&(Ee="<",Ue?Pe=+Pe+1:De=+De+1),Me=Ee+Pe+"."+De+"."+ke):Ue?Me=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ve&&(Me=">="+Pe+"."+De+".0 <"+Pe+"."+(+De+1)+".0"),k("xRange return",Me),Me})}(_e,Ae)}).join(" ")}(Ie,Ne),k("xrange",Ie),Ie=function(Ce,Ae){return k("replaceStars",Ce,Ae),Ce.trim().replace(y[K],"")}(Ie,Ne),k("stars",Ie),Ie}(Le,Y)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Le){return!!Le.match(me)})),ye=ye.map(function(Le){return new de(Le,Y)})},he.prototype.intersects=function(j,Y){if(!(j instanceof he))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(me){return j.set.some(function(ye){return ye.every(function(Le){return me.intersects(Le,Y)})})})})},e.toComparators=function(j,Y){return new he(j,Y).set.map(function(ee){return ee.map(function(me){return me.value}).join(" ").trim().split(" ")})},he.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new _(j,this.loose));for(var Y=0;Y<this.set.length;Y++)if(we(this.set[Y],j))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(j,Y,ee){var me=null,ye=null;try{var Le=new he(Y,ee)}catch{return null}return j.forEach(function(Ie){Le.test(Ie)&&(me&&ye.compare(Ie)!==-1||(ye=new _(me=Ie,ee)))}),me},e.minSatisfying=function(j,Y,ee){var me=null,ye=null;try{var Le=new he(Y,ee)}catch{return null}return j.forEach(function(Ie){Le.test(Ie)&&(me&&ye.compare(Ie)!==1||(ye=new _(me=Ie,ee)))}),me},e.validRange=function(j,Y){try{return new he(j,Y).range||"*"}catch{return null}},e.ltr=function(j,Y,ee){return Fe(j,Y,"<",ee)},e.gtr=function(j,Y,ee){return Fe(j,Y,">",ee)},e.outside=Fe,e.prerelease=function(j,Y){var ee=J(j,Y);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(j,Y,ee){return j=new he(j,ee),Y=new he(Y,ee),j.intersects(Y)},e.coerce=function(j){if(j instanceof _)return j;if(typeof j!="string")return null;var Y=j.match(y[L]);return Y==null?null:J((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,N(1))},function(G,e){var N,O,k=G.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function y(p){if(N===setTimeout)return setTimeout(p,0);if((N===A||!N)&&setTimeout)return N=setTimeout,setTimeout(p,0);try{return N(p,0)}catch{try{return N.call(null,p,0)}catch{return N.call(this,p,0)}}}(function(){try{N=typeof setTimeout=="function"?setTimeout:A}catch{N=A}try{O=typeof clearTimeout=="function"?clearTimeout:T}catch{O=T}})();var u,c=[],S=!1,R=-1;function g(){S&&u&&(S=!1,u.length?c=u.concat(c):R=-1,c.length&&d())}function d(){if(!S){var p=y(g);S=!0;for(var h=c.length;h;){for(u=c,c=[];++R<h;)u&&u[R].run();R=-1,h=c.length}u=null,S=!1,function(f){if(O===clearTimeout)return clearTimeout(f);if((O===T||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(f);try{O(f)}catch{try{return O.call(null,f)}catch{return O.call(this,f)}}}(p)}}function w(p,h){this.fun=p,this.array=h}function I(){}k.nextTick=function(p){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];c.push(new w(p,h)),c.length!==1||S||y(d)},w.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=I,k.addListener=I,k.once=I,k.off=I,k.removeListener=I,k.removeAllListeners=I,k.emit=I,k.prependListener=I,k.prependOnceListener=I,k.listeners=function(p){return[]},k.binding=function(p){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(p){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[73],se([0,1]),function(G,e){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(y,u,c){this.level=y,this.key=u,this.value=c,this.forward=[]}}const k=void 0;class A{constructor(y,u=2**16){this.comparator=y,this[N]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new O(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new O(this._maxLevel,k,k)}has(y){return!!A._search(this,y,this.comparator)}get(y){return A._search(this,y,this.comparator)?.value}set(y,u){return A._insert(this,y,u,this.comparator)&&(this._size+=1),this}delete(y){const u=A._delete(this,y,this.comparator);return u&&(this._size-=1),u}forEach(y,u){let c=this._header.forward[0];for(;c;)y.call(u,c.value,c.key,this),c=c.forward[0]}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let y=this._header.forward[0];for(;y;)yield[y.key,y.value],y=y.forward[0]}*keys(){let y=this._header.forward[0];for(;y;)yield y.key,y=y.forward[0]}*values(){let y=this._header.forward[0];for(;y;)yield y.value,y=y.forward[0]}toString(){let y="[SkipList]:",u=this._header.forward[0];for(;u;)y+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return y}static _search(y,u,c){let S=y._header;for(let R=y._level-1;R>=0;R--)for(;S.forward[R]&&c(S.forward[R].key,u)<0;)S=S.forward[R];if(S=S.forward[0],S&&c(S.key,u)===0)return S}static _insert(y,u,c,S){const R=[];let g=y._header;for(let d=y._level-1;d>=0;d--){for(;g.forward[d]&&S(g.forward[d].key,u)<0;)g=g.forward[d];R[d]=g}if(g=g.forward[0],g&&S(g.key,u)===0)return g.value=c,!1;{const d=A._randomLevel(y);if(d>y._level){for(let w=y._level;w<d;w++)R[w]=y._header;y._level=d}g=new O(d,u,c);for(let w=0;w<d;w++)g.forward[w]=R[w].forward[w],R[w].forward[w]=g;return!0}}static _randomLevel(y,u=.5){let c=1;for(;Math.random()<u&&c<y._maxLevel;)c+=1;return c}static _delete(y,u,c){const S=[];let R=y._header;for(let g=y._level-1;g>=0;g--){for(;R.forward[g]&&c(R.forward[g].key,u)<0;)R=R.forward[g];S[g]=R}if(R=R.forward[0],!R||c(R.key,u)!==0)return!1;for(let g=0;g<y._level&&S[g].forward[g]===R;g++)S[g].forward[g]=R.forward[g];for(;y._level>0&&y._header.forward[y._level-1]===k;)y._level-=1;return!0}}e.SkipList=A}),define(ne[41],se([0,1,9,2]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(v){const P=v;return P?typeof P.read=="function":!1}e.isReadable=k;function A(v){const P=v;return P?[P.on,P.pause,P.resume,P.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function T(v){const P=v;return P?A(P.stream)&&Array.isArray(P.buffer)&&typeof P.ended=="boolean":!1}e.isReadableBufferedStream=T;function y(v,P){return new u(v,P)}e.newWriteableStream=y;class u{constructor(P,t){this.reducer=P,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(P){if(!this.state.destroyed){if(this.state.flowing)this.emitData(P);else if(this.buffer.data.push(P),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(P){this.state.destroyed||(this.state.flowing?this.emitError(P):this.buffer.error.push(P))}end(P){this.state.destroyed||(typeof P<"u"&&this.write(P),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(P){this.listeners.data.slice(0).forEach(t=>t(P))}emitError(P){this.listeners.error.length===0?(0,N.onUnexpectedError)(P):this.listeners.error.slice(0).forEach(t=>t(P))}emitEnd(){this.listeners.end.slice(0).forEach(P=>P())}on(P,t){if(!this.state.destroyed)switch(P){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(P,t){if(this.state.destroyed)return;let o;switch(P){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const i=o.indexOf(t);i>=0&&o.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const P=this.reducer(this.buffer.data);this.emitData(P),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const P of this.buffer.error)this.emitError(P);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(v,P){const t=[];let o;for(;(o=v.read())!==null;)t.push(o);return P(t)}e.consumeReadable=c;function S(v,P,t){const o=[];let i;for(;(i=v.read())!==null&&o.length<t;)o.push(i);return i===null&&o.length>0?P(o):{read:()=>{if(o.length>0)return o.shift();if(typeof i<"u"){const r=i;return i=void 0,r}return v.read()}}}e.peekReadable=S;function R(v,P){return new Promise((t,o)=>{const i=[];g(v,{onData:r=>{P&&i.push(r)},onError:r=>{P?o(r):t(void 0)},onEnd:()=>{t(P?P(i):void 0)}})})}e.consumeStream=R;function g(v,P,t){v.on("error",o=>{t?.isCancellationRequested||P.onError(o)}),v.on("end",()=>{t?.isCancellationRequested||P.onEnd()}),v.on("data",o=>{t?.isCancellationRequested||P.onData(o)})}e.listenStream=g;function d(v,P){return new Promise((t,o)=>{const i=new O.DisposableStore,r=[],n=D=>{if(r.push(D),r.length>P)return i.dispose(),v.pause(),t({stream:v,buffer:r,ended:!1})},s=D=>o(D),l=()=>t({stream:v,buffer:r,ended:!0});i.add((0,O.toDisposable)(()=>v.removeListener("error",s))),v.on("error",s),i.add((0,O.toDisposable)(()=>v.removeListener("end",l))),v.on("end",l),i.add((0,O.toDisposable)(()=>v.removeListener("data",n))),v.on("data",n)})}e.peekStream=d;function w(v,P){const t=y(P);return t.end(v),t}e.toStream=w;function I(){const v=y(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=I;function p(v){let P=!1;return{read:()=>P?null:(P=!0,v)}}e.toReadable=p;function h(v,P,t){const o=y(t);return g(v,{onData:i=>o.write(P.data(i)),onError:i=>o.error(P.error?P.error(i):i),onEnd:()=>o.end()}),o}e.transform=h;function f(v,P,t){let o=!1;return{read:()=>{const i=P.read();return o?i:(o=!0,i!==null?t([v,i]):v)}}}e.prefixedReadable=f;function b(v,P,t){let o=!1;const i=y(t);return g(P,{onData:r=>o?i.write(r):(o=!0,i.write(t([v,r]))),onError:r=>i.error(r),onEnd:()=>{o||(o=!0,i.write(v)),i.end()}}),i}e.prefixedStream=b}),define(ne[14],se([0,1,164,41]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const k=typeof Buffer<"u",A=new N.Lazy(()=>new Uint8Array(256));let T,y;class u{static alloc(L){return k?new u(Buffer.allocUnsafe(L)):new u(new Uint8Array(L))}static wrap(L){return k&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new u(L)}static fromString(L,$){return!($?.dontUseNodeBuffer||!1)&&k?new u(Buffer.from(L)):(T||(T=new TextEncoder),new u(T.encode(L)))}static fromByteArray(L){const $=u.alloc(L.length);for(let Z=0,Q=L.length;Z<Q;Z++)$.buffer[Z]=L[Z];return $}static concat(L,$){if(typeof $>"u"){$=0;for(let ce=0,te=L.length;ce<te;ce++)$+=L[ce].byteLength}const Z=u.alloc($);let Q=0;for(let ce=0,te=L.length;ce<te;ce++){const le=L[ce];Z.set(le,Q),Q+=le.byteLength}return Z}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=u.alloc(this.byteLength);return L.set(this),L}toString(){return k?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(L,$){return new u(this.buffer.subarray(L,$))}set(L,$){if(L instanceof u)this.buffer.set(L.buffer,$);else if(L instanceof Uint8Array)this.buffer.set(L,$);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),$);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),$);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return g(this.buffer,L)}writeUInt32BE(L,$){d(this.buffer,L,$)}readUInt32LE(L){return w(this.buffer,L)}writeUInt32LE(L,$){I(this.buffer,L,$)}readUInt8(L){return p(this.buffer,L)}writeUInt8(L,$){h(this.buffer,L,$)}indexOf(L,$=0){return c(this.buffer,L instanceof u?L.buffer:L,$)}}e.VSBuffer=u;function c(E,L,$=0){const Z=L.byteLength,Q=E.byteLength;if(Z===0)return 0;if(Z===1)return E.indexOf(L[0]);if(Z>Q-$)return-1;const ce=A.value;ce.fill(L.length);for(let ie=0;ie<L.length;ie++)ce[L[ie]]=L.length-ie-1;let te=$+L.length-1,le=te,ue=-1;for(;te<Q;)if(E[te]===L[le]){if(le===0){ue=te;break}te--,le--}else te+=Math.max(L.length-le,ce[E[te]]),le=L.length-1;return ue}e.binaryIndexOf=c;function S(E,L){return E[L+0]<<0>>>0|E[L+1]<<8>>>0}e.readUInt16LE=S;function R(E,L,$){E[$+0]=L&255,L=L>>>8,E[$+1]=L&255}e.writeUInt16LE=R;function g(E,L){return E[L]*2**24+E[L+1]*2**16+E[L+2]*2**8+E[L+3]}e.readUInt32BE=g;function d(E,L,$){E[$+3]=L,L=L>>>8,E[$+2]=L,L=L>>>8,E[$+1]=L,L=L>>>8,E[$]=L}e.writeUInt32BE=d;function w(E,L){return E[L+0]<<0>>>0|E[L+1]<<8>>>0|E[L+2]<<16>>>0|E[L+3]<<24>>>0}e.readUInt32LE=w;function I(E,L,$){E[$+0]=L&255,L=L>>>8,E[$+1]=L&255,L=L>>>8,E[$+2]=L&255,L=L>>>8,E[$+3]=L&255}e.writeUInt32LE=I;function p(E,L){return E[L]}e.readUInt8=p;function h(E,L,$){E[$]=L}e.writeUInt8=h;function f(E){return O.consumeReadable(E,L=>u.concat(L))}e.readableToBuffer=f;function b(E){return O.toReadable(E)}e.bufferToReadable=b;function v(E){return O.consumeStream(E,L=>u.concat(L))}e.streamToBuffer=v;async function P(E){return E.ended?u.concat(E.buffer):u.concat([...E.buffer,await v(E.stream)])}e.bufferedStreamToBuffer=P;function t(E){return O.toStream(E,L=>u.concat(L))}e.bufferToStream=t;function o(E){return O.transform(E,{data:L=>typeof L=="string"?u.fromString(L):u.wrap(L)},L=>u.concat(L))}e.streamToBufferReadableStream=o;function i(E){return O.newWriteableStream(L=>u.concat(L),E)}e.newWriteableBufferStream=i;function r(E,L){return O.prefixedReadable(E,L,$=>u.concat($))}e.prefixedBufferReadable=r;function n(E,L){return O.prefixedStream(E,L,$=>u.concat($))}e.prefixedBufferStream=n;function s(E){let L=0,$=0,Z=0;const Q=new Uint8Array(Math.floor(E.length/4*3)),ce=le=>{switch($){case 3:Q[Z++]=L|le,$=0;break;case 2:Q[Z++]=L|le>>>2,L=le<<6,$=3;break;case 1:Q[Z++]=L|le>>>4,L=le<<4,$=2;break;default:L=le<<2,$=1}};for(let le=0;le<E.length;le++){const ue=E.charCodeAt(le);if(ue>=65&&ue<=90)ce(ue-65);else if(ue>=97&&ue<=122)ce(ue-97+26);else if(ue>=48&&ue<=57)ce(ue-48+52);else if(ue===43||ue===45)ce(62);else if(ue===47||ue===95)ce(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${E[le]}`)}}const te=Z;for(;$>0;)ce(0);return u.wrap(Q).slice(0,te)}e.decodeBase64=s;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:E},L=!0,$=!1){const Z=$?D:l;let Q="";const ce=E.byteLength%3;let te=0;for(;te<E.byteLength-ce;te+=3){const le=E[te+0],ue=E[te+1],ie=E[te+2];Q+=Z[le>>>2],Q+=Z[(le<<4|ue>>>4)&63],Q+=Z[(ue<<2|ie>>>6)&63],Q+=Z[ie&63]}if(ce===1){const le=E[te+0];Q+=Z[le>>>2],Q+=Z[le<<4&63],L&&(Q+="==")}else if(ce===2){const le=E[te+0],ue=E[te+1];Q+=Z[le>>>2],Q+=Z[(le<<4|ue>>>4)&63],Q+=Z[ue<<2&63],L&&(Q+="=")}return Q}e.encodeBase64=C}),define(ne[42],se([0,1,29]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(h){return k(h,0)}e.hash=O;function k(h,f){switch(typeof h){case"object":return h===null?A(349,f):Array.isArray(h)?u(h,f):c(h,f);case"string":return y(h,f);case"boolean":return T(h,f);case"number":return A(h,f);case"undefined":return A(937,f);default:return A(617,f)}}e.doHash=k;function A(h,f){return(f<<5)-f+h|0}e.numberHash=A;function T(h,f){return A(h?433:863,f)}function y(h,f){f=A(149417,f);for(let b=0,v=h.length;b<v;b++)f=A(h.charCodeAt(b),f);return f}e.stringHash=y;function u(h,f){return f=A(104579,f),h.reduce((b,v)=>k(v,b),f)}function c(h,f){return f=A(181387,f),Object.keys(h).sort().reduce((b,v)=>(b=y(v,b),k(h[v],b)),f)}class S{constructor(){this._value=0}get value(){return this._value}hash(f){return this._value=k(f,this._value),this._value}}e.Hasher=S;var R;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function g(h,f,b=32){const v=b-f,P=~((1<<v)-1);return(h<<f|(P&h)>>>v)>>>0}function d(h,f=0,b=h.byteLength,v=0){for(let P=0;P<b;P++)h[f+P]=v}function w(h,f,b="0"){for(;h.length<f;)h=b+h;return h}function I(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(b=>b.toString(16).padStart(2,"0")).join(""):w((h>>>0).toString(16),f/4)}e.toHexString=I;class p{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const b=f.length;if(b===0)return;const v=this._buff;let P=this._buffLen,t=this._leftoverHighSurrogate,o,i;for(t!==0?(o=t,i=-1,t=0):(o=f.charCodeAt(0),i=0);;){let r=o;if(N.isHighSurrogate(o))if(i+1<b){const n=f.charCodeAt(i+1);N.isLowSurrogate(n)?(i++,r=N.computeCodePoint(o,n)):r=65533}else{t=o;break}else N.isLowSurrogate(o)&&(r=65533);if(P=this._push(v,P,r),i++,i<b)o=f.charCodeAt(i);else break}this._buffLen=P,this._leftoverHighSurrogate=t}_push(f,b,v){return v<128?f[b++]=v:v<2048?(f[b++]=192|(v&1984)>>>6,f[b++]=128|(v&63)>>>0):v<65536?(f[b++]=224|(v&61440)>>>12,f[b++]=128|(v&4032)>>>6,f[b++]=128|(v&63)>>>0):(f[b++]=240|(v&1835008)>>>18,f[b++]=128|(v&258048)>>>12,f[b++]=128|(v&4032)>>>6,f[b++]=128|(v&63)>>>0),b>=64&&(this._step(),b-=64,this._totalLen+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),b}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),I(this._h0)+I(this._h1)+I(this._h2)+I(this._h3)+I(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=p._bigBlock32,b=this._buffDV;for(let l=0;l<64;l+=4)f.setUint32(l,b.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)f.setUint32(l,g(f.getUint32(l-12,!1)^f.getUint32(l-32,!1)^f.getUint32(l-56,!1)^f.getUint32(l-64,!1),1),!1);let v=this._h0,P=this._h1,t=this._h2,o=this._h3,i=this._h4,r,n,s;for(let l=0;l<80;l++)l<20?(r=P&t|~P&o,n=1518500249):l<40?(r=P^t^o,n=1859775393):l<60?(r=P&t|P&o|t&o,n=2400959708):(r=P^t^o,n=3395469782),s=g(v,5)+r+i+n+f.getUint32(l*4,!1)&4294967295,i=o,o=t,t=g(P,30),P=v,v=s;this._h0=this._h0+v&4294967295,this._h1=this._h1+P&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=p}),define(ne[54],se([0,1,29]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(O||(O={})),function(k){const A="error",T="warning",y="warn",u="info",c="ignore";function S(g){return g?N.equalsIgnoreCase(A,g)?k.Error:N.equalsIgnoreCase(T,g)||N.equalsIgnoreCase(y,g)?k.Warning:N.equalsIgnoreCase(u,g)?k.Info:k.Ignore:k.Ignore}k.fromValue=S;function R(g){switch(g){case k.Error:return A;case k.Warning:return T;case k.Info:return u;default:return c}}k.toString=R}(O||(O={})),e.default=O}),define(ne[30],se([0,1,3]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([b,v])=>{f[b]=v&&typeof v=="object"?O(v):v}),f}e.deepClone=O;function k(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const b=f.shift();Object.freeze(b);for(const v in b)if(A.call(b,v)){const P=b[v];typeof P=="object"&&!Object.isFrozen(P)&&!(0,N.isTypedArray)(P)&&f.push(P)}}return h}e.deepFreeze=k;const A=Object.prototype.hasOwnProperty;function T(h,f){return y(h,f,new Set)}e.cloneAndChange=T;function y(h,f,b){if((0,N.isUndefinedOrNull)(h))return h;const v=f(h);if(typeof v<"u")return v;if(Array.isArray(h)){const P=[];for(const t of h)P.push(y(t,f,b));return P}if((0,N.isObject)(h)){if(b.has(h))throw new Error("Cannot clone recursive data-structure");b.add(h);const P={};for(const t in h)A.call(h,t)&&(P[t]=y(h[t],f,b));return b.delete(h),P}return h}function u(h,f,b=!0){return(0,N.isObject)(h)?((0,N.isObject)(f)&&Object.keys(f).forEach(v=>{v in h?b&&((0,N.isObject)(h[v])&&(0,N.isObject)(f[v])?u(h[v],f[v],b):h[v]=f[v]):h[v]=f[v]}),h):f}e.mixin=u;function c(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let b,v;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(b=0;b<h.length;b++)if(!c(h[b],f[b]))return!1}else{const P=[];for(v in h)P.push(v);P.sort();const t=[];for(v in f)t.push(v);if(t.sort(),!c(P,t))return!1;for(b=0;b<P.length;b++)if(!c(h[P[b]],f[P[b]]))return!1}return!0}e.equals=c;function S(h){const f=new Set;return JSON.stringify(h,(b,v)=>{if((0,N.isObject)(v)||Array.isArray(v)){if(f.has(v))return"[Circular]";f.add(v)}return v})}e.safeStringify=S;function R(h,f){const b=Object.create(null);return!h||!f||Object.keys(f).forEach(P=>{const t=h[P],o=f[P];c(t,o)||(b[P]=o)}),b}e.distinct=R;function g(h,f){const b=f.toLowerCase(),v=Object.keys(h).find(P=>P.toLowerCase()===b);return v?h[v]:h[f]}e.getCaseInsensitive=g;function d(h,f){const b=Object.create(null);for(const[v,P]of Object.entries(h))f(v,P)&&(b[v]=P);return b}e.filter=d;function w(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}e.getAllPropertyNames=w;function I(h){const f=[];for(const b of w(h))typeof h[b]=="function"&&f.push(b);return f}e.getAllMethodNames=I;function p(h,f){const b=P=>function(){const t=Array.prototype.slice.call(arguments,0);return f(P,t)},v={};for(const P of h)v[P]=b(P);return v}e.createProxyObject=p}),define(ne[28],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const N=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(k){return N.test(k)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(y){for(let u=0;u<y.length;u++)y[u]=Math.floor(Math.random()*256);return y};const A=new Uint8Array(16),T=[];for(let y=0;y<256;y++)T.push(y.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,c="";return c+=T[A[u++]],c+=T[A[u++]],c+=T[A[u++]],c+=T[A[u++]],c+="-",c+=T[A[u++]],c+=T[A[u++]],c+="-",c+=T[A[u++]],c+=T[A[u++]],c+="-",c+=T[A[u++]],c+=T[A[u++]],c+="-",c+=T[A[u++]],c+=T[A[u++]],c+=T[A[u++]],c+=T[A[u++]],c+=T[A[u++]],c+=T[A[u++]],c}}()}),define(ne[74],se([0,1,32]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(T){const y=T.replace(/\-/g,":").toLowerCase();return!O.has(y)}function A(){const T=(0,N.networkInterfaces)();for(const y in T){const u=T[y];if(u){for(const{mac:c}of u)if(k(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ne[75],se([0,1,32,46,28,74]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(c){return this._virtualMachineOUIs||(this._virtualMachineOUIs=O.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(c)}value(){if(this._value===void 0){let c=0,S=0;const R=(0,N.networkInterfaces)();for(const g in R){const d=R[g];if(d)for(const{mac:w,internal:I}of d)I||(S+=1,this._isVirtualMachineMacAddress(w.toUpperCase())&&(c+=1))}this._value=S>0?c/S:0}return this._value}};let T;async function y(c){return T||(T=(async()=>await u(c)||k.generateUuid())()),T}e.getMachineId=y;async function u(c){try{const S=await new Promise((g,d)=>{G(["crypto"],g,d)}),R=(0,A.getMac)();return S.createHash("sha256").update(R,"utf8").digest("hex")}catch(S){c(S);return}}}),define(ne[76],se([7,5]),function(G,e){return G.create("vs/base/common/date",e)}),define(ne[77],se([0,1,76]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,k=O*60,A=k*24,T=A*7,y=A*30,u=A*365;function c(R,g,d,w){typeof R!="number"&&(R=R.getTime());const I=Math.round((new Date().getTime()-R)/1e3);if(I<-30)return(0,N.localize)(0,null,c(new Date().getTime()+I*1e3,!1));if(!w&&I<30)return(0,N.localize)(1,null);let p;return I<O?(p=I,g?p===1?d?(0,N.localize)(2,null,p):(0,N.localize)(3,null,p):d?(0,N.localize)(4,null,p):(0,N.localize)(5,null,p):p===1?d?(0,N.localize)(6,null,p):(0,N.localize)(7,null,p):d?(0,N.localize)(8,null,p):(0,N.localize)(9,null,p)):I<k?(p=Math.floor(I/O),g?p===1?d?(0,N.localize)(10,null,p):(0,N.localize)(11,null,p):d?(0,N.localize)(12,null,p):(0,N.localize)(13,null,p):p===1?d?(0,N.localize)(14,null,p):(0,N.localize)(15,null,p):d?(0,N.localize)(16,null,p):(0,N.localize)(17,null,p)):I<A?(p=Math.floor(I/k),g?p===1?d?(0,N.localize)(18,null,p):(0,N.localize)(19,null,p):d?(0,N.localize)(20,null,p):(0,N.localize)(21,null,p):p===1?d?(0,N.localize)(22,null,p):(0,N.localize)(23,null,p):d?(0,N.localize)(24,null,p):(0,N.localize)(25,null,p)):I<T?(p=Math.floor(I/A),g?p===1?(0,N.localize)(26,null,p):(0,N.localize)(27,null,p):p===1?(0,N.localize)(28,null,p):(0,N.localize)(29,null,p)):I<y?(p=Math.floor(I/T),g?p===1?d?(0,N.localize)(30,null,p):(0,N.localize)(31,null,p):d?(0,N.localize)(32,null,p):(0,N.localize)(33,null,p):p===1?d?(0,N.localize)(34,null,p):(0,N.localize)(35,null,p):d?(0,N.localize)(36,null,p):(0,N.localize)(37,null,p)):I<u?(p=Math.floor(I/y),g?p===1?d?(0,N.localize)(38,null,p):(0,N.localize)(39,null,p):d?(0,N.localize)(40,null,p):(0,N.localize)(41,null,p):p===1?d?(0,N.localize)(42,null,p):(0,N.localize)(43,null,p):d?(0,N.localize)(44,null,p):(0,N.localize)(45,null,p)):(p=Math.floor(I/u),g?p===1?d?(0,N.localize)(46,null,p):(0,N.localize)(47,null,p):d?(0,N.localize)(48,null,p):(0,N.localize)(49,null,p):p===1?d?(0,N.localize)(50,null,p):(0,N.localize)(51,null,p):d?(0,N.localize)(52,null,p):(0,N.localize)(53,null,p))}e.fromNow=c;function S(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=S}),define(ne[78],se([7,5]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ne[33],se([0,1,19,3,78]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(R,g){return g&&(R.stack||R.stacktrace)?k.localize(0,null,y(R),T(R.stack)||T(R.stacktrace)):y(R)}function T(R){return Array.isArray(R)?R.join(`
`):R}function y(R){return R.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${R.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?k.localize(1,null,R.message):R.message||k.localize(2,null)}function u(R=null,g=!1){if(!R)return k.localize(3,null);if(Array.isArray(R)){const d=N.coalesce(R),w=u(d[0],g);return d.length>1?k.localize(4,null,w,d.length):w}if(O.isString(R))return R;if(R.detail){const d=R.detail;if(d.error)return A(d.error,g);if(d.exception)return A(d.exception,g)}return R.stack?A(R,g):R.message?R.message:k.localize(5,null)}e.toErrorMessage=u;function c(R){const g=R;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=c;function S(R,g){let d;return typeof R=="string"?d=new Error(R):d=R,d.actions=g,d}e.createErrorWithActions=S}),define(ne[79],se([7,5]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],se([0,1,79]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(k){switch(k){case 1:return(0,N.localize)(0,null);case 2:return(0,N.localize)(1,null);case 3:return(0,N.localize)(2,null);case 4:return(0,N.localize)(3,null);case 5:return(0,N.localize)(4,null);case 6:return(0,N.localize)(5,null);case 7:return(0,N.localize)(6,null);case 8:return(0,N.localize)(7,null);case 9:return(0,N.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(ne[55],se([0,1,13]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(O||(e.Source=O={}));var k;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function A(y,...u){const c=u.reduce((g,d)=>(g[d]=!0,g),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(g=>!c[g]).forEach(g=>{for(let d=0;d<S.length;d++)if(g.search(S[d])!==-1){delete y[g];break}})}e.sanitizeProcessEnvironment=A;function T(y){y&&(delete y.DEBUG,N.isMacintosh&&delete y.DYLD_LIBRARY_PATH,N.isLinux&&delete y.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(ne[81],se([0,1,11]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(c){const S=c;return S&&typeof S.type=="string"&&typeof S.severity=="string"}e.isRemoteConsoleLog=O;function k(c){const S=[];let R;try{const g=JSON.parse(c.arguments),d=g[g.length-1];d&&d.__$stack&&(g.pop(),R=d.__$stack),S.push(...g)}catch{S.push("Unable to log remote console arguments",c.arguments)}return{args:S,stack:R}}e.parse=k;function A(c){if(typeof c!="string")return A(k(c).stack);const S=c;if(S){const R=T(S),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(g&&g.length===4)return{uri:N.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=A;function T(c){if(!c)return c;const S=c.indexOf(`
`);return S===-1?c:c.substring(0,S)}function y(c,S){const{args:R,stack:g}=k(c),d=typeof R[0]=="string"&&R.length===1;let w=T(g);w&&(w=`(${w.trim()})`);let I=[];if(typeof R[0]=="string"?w&&d?I=[`%c[${S}] %c${R[0]} %c${w}`,u("blue"),u(""),u("grey")]:I=[`%c[${S}] %c${R[0]}`,u("blue"),u(""),...R.slice(1)]:I=[`%c[${S}]%`,u("blue"),...R],w&&!d&&I.push(w),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,I)}e.log=y;function u(c){return`color: ${c}`}}),define(ne[47],se([0,1,14,11]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(u){return JSON.stringify(u,T)}e.stringify=k;function A(u){let c=JSON.parse(u);return c=y(c),c}e.parse=A;function T(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function y(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return O.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof N.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let S=0;S<u.length;++S)u[S]=y(u[S],c+1);else for(const S in u)Object.hasOwnProperty.call(u,S)&&(u[S]=y(u[S],c+1))}return u}e.revive=y}),define(ne[82],se([0,1,70,15,13,11]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class T{constructor(g,d,w){this.id=g,this.dependencies=d,this.callback=w}}class y{static{this.INSTANCE=new y}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(g,d,w)=>{typeof g!="string"&&(w=d,d=g,g=null),(typeof d!="object"||!Array.isArray(d))&&(w=d,d=null),this._defineCalls.push(new T(g,d,w))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this._initialize();const d=await(this._isWebWorker?this._workerLoadScript(g):this._isRenderer?this._rendererLoadScript(g):this._nodeJSLoadScript(g));if(!d)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}_rendererLoadScript(g){return new Promise((d,w)=>{const I=document.createElement("script");I.setAttribute("async","async"),I.setAttribute("type","text/javascript");const p=()=>{I.removeEventListener("load",h),I.removeEventListener("error",f)},h=b=>{p(),d(this._defineCalls.pop())},f=b=>{p(),w(b)};I.addEventListener("load",h),I.addEventListener("error",f),this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),I.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(I)})}_workerLoadScript(g){return new Promise((d,w)=>{try{this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),importScripts(g),d(this._defineCalls.pop())}catch(I){w(I)}})}async _nodeJSLoadScript(g){try{const d=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,I=globalThis._VSCODE_NODE_MODULES.module,p=A.URI.parse(g).fsPath,h=d.readFileSync(p).toString(),f=I.wrap(h.replace(/^#!.*/,""));return new w.Script(f).runInThisContext().apply(),this._defineCalls.pop()}catch(d){throw d}}}const u=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function S(R,g,d){if(N.isESM){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[R]&&(R=c[R]);const w=`${R}/${g}`;if(u.has(w))return u.get(w);let I;if(/^\w[\w\d+.-]*:\/\//.test(w))I=w;else{const b=`${d&&!k.isWeb?O.nodeModulesAsarPath:O.nodeModulesPath}/${w}`;I=O.FileAccess.asBrowserUri(b).toString(!0)}const p=y.INSTANCE.load(I);return u.set(w,p),p}else return await new Promise((w,I)=>{G([R],w,I)})}e.importAMDNodeModule=S}),define(ne[83],se([0,1,32,16,24]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,T=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var u;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class R{constructor(P,t,o){this.exePath=P,this.displayName=t,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:v=!1}={}){return v?c===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:v=!1,findPreview:P=!1}={}){const t=g({useAlternateBitness:v});if(!t)return null;const o=O.join(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(o))return null;let i=-1,r=null;for(const l of await k.Promises.readdir(o)){let D=-1;if(P){const E=l.indexOf("-");if(E<0)continue;const L=l.substring(0,E);if(!A.test(L)||l.substring(E+1)!=="preview")continue;D=parseInt(L,10)}else{if(!A.test(l))continue;D=parseInt(l,10)}if(D<=i)continue;const C=O.join(o,l,"pwsh.exe");await k.SymlinkSupport.existsFile(C)&&(r=C,i=D)}if(!r)return null;const n=t.includes("x86")?" (x86)":"",s=P?" Preview":"";return new R(r,`PowerShell${s}${n}`,!0)}async function w({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const P=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(P))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=v?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(P))if(t.test(i)){const r=O.join(P,i,"pwsh.exe");return new R(r,o)}return null}function I(){const v=O.join(N.homedir(),".dotnet","tools","pwsh.exe");return new R(v,".NET Core PowerShell Global Tool")}function p(){const v=O.join(process.env.windir,c===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(v,"Windows PowerShell",!0)}async function*h(){let v=await d();v&&(yield v),v=await d({useAlternateBitness:!0}),v&&(yield v),v=await w(),v&&(yield v),v=I(),v&&(yield v),v=await d({findPreview:!0}),v&&(yield v),v=await w({findPreview:!0}),v&&(yield v),v=await d({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=p(),v&&(yield v)}async function*f(){for await(const v of h())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=f;async function b(){for await(const v of f())return v;return null}e.getFirstAvailablePowerShellInstallation=b}),define(ne[56],se([0,1,16,13,34,55,3,24]),function(G,e,N,O,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(R=k.env){return R.comspec||"cmd.exe"}e.getWindowsShell=u;function c(R){let g=[],d=!1;const w=function(I){if(d){g.push(I);return}(!R.send(I,h=>{if(h&&console.error(h),d=!1,g.length>0){const f=g.slice(0);g=[],f.forEach(b=>w(b))}})||O.isWindows)&&(d=!0)};return{send:w}}e.createQueuedSender=c;var S;(function(R){async function g(d,w,I){if(N.isAbsolute(d))return d;if(w===void 0&&(w=k.cwd()),N.dirname(d)!=="."||(I===void 0&&T.isString(k.env.PATH)&&(I=k.env.PATH.split(N.delimiter)),I===void 0||I.length===0))return N.join(w,d);async function h(f){if(await y.Promises.exists(f)){let b;try{b=await y.Promises.stat(f)}catch(v){v.message.startsWith("EACCES")&&(b=await y.Promises.lstat(f))}return b?!b.isDirectory():!1}return!1}for(const f of I){let b;if(N.isAbsolute(f)?b=N.join(f,d):b=N.join(w,f,d),await h(b))return b;let v=b+".com";if(await h(v)||(v=b+".exe",await h(v)))return v}return N.join(w,d)}R.findExecutable=g})(S||(e.win32=S={}))}),define(ne[84],se([0,1,32,13,83,56]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function T(R,g){return R===1?O.isWindows?S():A.getWindowsShell(g):u(R,g)}e.getSystemShell=T;let y=null;function u(R,g){if(O.isLinux&&R===2||O.isMacintosh&&R===3)return"/bin/bash";if(!y){let d;if(O.isWindows)d="/bin/bash";else{if(d=g.SHELL,!d)try{d=(0,N.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}y=d}return y}let c=null;async function S(){return c||(c=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),c}});var pe=this&&this.__decorate||function(G,e,N,O){var k=arguments.length,A=k<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,N):O,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,N,O);else for(var y=G.length-1;y>=0;y--)(T=G[y])&&(A=(k<3?T(A):k>3?T(e,N,A):T(e,N))||A);return k>3&&A&&Object.defineProperty(e,N,A),A};define(ne[57],se([0,1,19,8,14,20,52,9,4,2,47,29,3]),function(G,e,N,O,k,A,T,y,u,c,S,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(d||(d={}));function w(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var I;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(I||(I={}));function p(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(h||(h={}));function f(V){let M=0;for(let z=0;;z+=7){const K=V.read(1);if(M|=(K.buffer[0]&127)<<z,!(K.buffer[0]&128))return M}}const b=i(0);function v(V,M){if(M===0){V.write(b);return}let z=0;for(let X=M;X!==0;X=X>>>7)z++;const K=k.VSBuffer.alloc(z);for(let X=0;M!==0;X++)K.buffer[X]=M&127,M=M>>>7,M>0&&(K.buffer[X]|=128);V.write(K)}class P{constructor(M){this.buffer=M,this.pos=0}read(M){const z=this.buffer.slice(this.pos,this.pos+M);return this.pos+=z.byteLength,z}}e.BufferReader=P;class t{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}e.BufferWriter=t;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function i(V){const M=k.VSBuffer.alloc(1);return M.writeUInt8(V,0),M}const r={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object),Uint:i(o.Int)},n=typeof Buffer<"u";function s(V,M){if(typeof M>"u")V.write(r.Undefined);else if(typeof M=="string"){const z=k.VSBuffer.fromString(M);V.write(r.String),v(V,z.byteLength),V.write(z)}else if(n&&Buffer.isBuffer(M)){const z=k.VSBuffer.wrap(M);V.write(r.Buffer),v(V,z.byteLength),V.write(z)}else if(M instanceof k.VSBuffer)V.write(r.VSBuffer),v(V,M.byteLength),V.write(M);else if(Array.isArray(M)){V.write(r.Array),v(V,M.length);for(const z of M)s(V,z)}else if(typeof M=="number"&&(M|0)===M)V.write(r.Uint),v(V,M);else{const z=k.VSBuffer.fromString(JSON.stringify(M));V.write(r.Object),v(V,z.byteLength),V.write(z)}}e.serialize=s;function l(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(f(V)).toString();case o.Buffer:return V.read(f(V)).buffer;case o.VSBuffer:return V.read(f(V));case o.Array:{const z=f(V),K=[];for(let X=0;X<z;X++)K.push(l(V));return K}case o.Object:return JSON.parse(V.read(f(V)).toString());case o.Int:return f(V)}}e.deserialize=l;class D{constructor(M,z,K=null,X=1e3){this.protocol=M,this.ctx=z,this.logger=K,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(M,z){this.channels.set(M,z),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const z=this.send([M.type]);this.logger?.logOutgoing(z,0,1,p(M.type));return}case 201:case 202:case 204:case 203:{const z=this.send([M.type,M.id],M.data);this.logger?.logOutgoing(z,M.id,1,p(M.type),M.data);return}}}send(M,z=void 0){const K=new t;return s(K,M),s(K,z),this.sendBuffer(K.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onRawMessage(M){const z=new P(M),K=l(z),X=l(z),J=K[0];switch(J){case 100:return this.logger?.logIncoming(M.byteLength,K[1],1,`${w(J)}: ${K[2]}.${K[3]}`,X),this.onPromise({type:J,id:K[1],channelName:K[2],name:K[3],arg:X});case 102:return this.logger?.logIncoming(M.byteLength,K[1],1,`${w(J)}: ${K[2]}.${K[3]}`,X),this.onEventListen({type:J,id:K[1],channelName:K[2],name:K[3],arg:X});case 101:return this.logger?.logIncoming(M.byteLength,K[1],1,`${w(J)}`),this.disposeActiveRequest({type:J,id:K[1]});case 103:return this.logger?.logIncoming(M.byteLength,K[1],1,`${w(J)}`),this.disposeActiveRequest({type:J,id:K[1]})}}onPromise(M){const z=this.channels.get(M.channelName);if(!z){this.collectPendingRequest(M);return}const K=new A.CancellationTokenSource;let X;try{X=z.call(this.ctx,M.name,M.arg,K.token)}catch(x){X=Promise.reject(x)}const J=M.id;X.then(x=>{this.sendResponse({id:J,data:x,type:201}),this.activeRequests.delete(M.id)},x=>{x instanceof Error?this.sendResponse({id:J,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.sendResponse({id:J,data:x,type:203}),this.activeRequests.delete(M.id)});const _=(0,c.toDisposable)(()=>K.cancel());this.activeRequests.set(M.id,_)}onEventListen(M){const z=this.channels.get(M.channelName);if(!z){this.collectPendingRequest(M);return}const K=M.id,J=z.listen(this.ctx,M.name,M.arg)(_=>this.sendResponse({id:K,data:_,type:204}));this.activeRequests.set(M.id,J)}disposeActiveRequest(M){const z=this.activeRequests.get(M.id);z&&(z.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let z=this.pendingRequests.get(M.channelName);z||(z=[],this.pendingRequests.set(M.channelName,z));const K=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:M,timeoutTimer:K})}flushPendingRequests(M){const z=this.pendingRequests.get(M);if(z){for(const K of z)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var C;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class E{constructor(M,z=null){this.protocol=M,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=z}getChannel(M){const z=this;return{call(K,X,J){return z.isDisposed?Promise.reject(new y.CancellationError):z.requestPromise(M,K,X,J)},listen(K,X){return z.isDisposed?u.Event.None:z.requestEvent(M,K,X)}}}requestPromise(M,z,K,X=A.CancellationToken.None){const J=this.lastRequestId++,x={id:J,type:100,channelName:M,name:z,arg:K};if(X.isCancellationRequested)return Promise.reject(new y.CancellationError);let a;return new Promise((F,U)=>{if(X.isCancellationRequested)return U(new y.CancellationError);const H=()=>{const ve=de=>{switch(de.type){case 201:this.handlers.delete(J),F(de.data);break;case 202:{this.handlers.delete(J);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,U(ge);break}case 203:this.handlers.delete(J),U(de.data);break}};this.handlers.set(J,ve),this.sendRequest(x)};let B=null;this.state===h.Idle?H():(B=(0,O.createCancelablePromise)(ve=>this.whenInitialized()),B.then(()=>{B=null,H()}));const oe=()=>{B?(B.cancel(),B=null):this.sendRequest({id:J,type:101}),U(new y.CancellationError)},ae=X.onCancellationRequested(oe);a=(0,c.combinedDisposable)((0,c.toDisposable)(oe),ae),this.activeRequests.add(a)}).finally(()=>{this.activeRequests.delete(a)})}requestEvent(M,z,K){const X=this.lastRequestId++,_={id:X,type:102,channelName:M,name:z,arg:K};let x=null;const a=new u.Emitter({onWillAddFirstListener:()=>{x=(0,O.createCancelablePromise)(F=>this.whenInitialized()),x.then(()=>{x=null,this.activeRequests.add(a),this.sendRequest(_)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.activeRequests.delete(a),this.sendRequest({id:X,type:103}))}}),m=F=>a.fire(F.data);return this.handlers.set(X,m),a.event}sendRequest(M){switch(M.type){case 100:case 102:{const z=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger?.logOutgoing(z,M.id,0,`${w(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const z=this.send([M.type,M.id]);this.logger?.logOutgoing(z,M.id,0,w(M.type));return}}}send(M,z=void 0){const K=new t;return s(K,M),s(K,z),this.sendBuffer(K.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onBuffer(M){const z=new P(M),K=l(z),X=l(z),J=K[0];switch(J){case 200:return this.logger?.logIncoming(M.byteLength,0,0,p(J)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(M.byteLength,K[1],0,p(J),X),this.onResponse({type:K[0],id:K[1],data:X})}}onResponse(M){if(M.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(M.id)?.(M)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=E,pe([T.memoize],E.prototype,"onDidInitializePromise",null);class L{get connections(){const M=[];return this._connections.forEach(z=>M.push(z)),M}constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:z,onDidClientDisconnect:K})=>{u.Event.once(z.onMessage)(J=>{const _=new P(J),x=l(_),a=new D(z,x),m=new E(z);this.channels.forEach((U,H)=>a.registerChannel(H,U));const F={channelServer:a,channelClient:m,ctx:x};this._connections.add(F),this._onDidAddConnection.fire(F),K(()=>{a.dispose(),m.dispose(),this._connections.delete(F),this._onDidRemoveConnection.fire(F)})})})}getChannel(M,z){const K=this;return{call(X,J,_){let x;if((0,g.isFunction)(z)){const m=(0,N.getRandomElement)(K.connections.filter(z));x=m?Promise.resolve(m):u.Event.toPromise(u.Event.filter(K.onDidAddConnection,z))}else x=z.routeCall(K,X,J);const a=x.then(m=>m.channelClient.getChannel(M));return Z(a).call(X,J,_)},listen(X,J){if((0,g.isFunction)(z))return K.getMulticastEvent(M,z,X,J);const _=z.routeEvent(K,X,J).then(x=>x.channelClient.getChannel(M));return Z(_).listen(X,J)}}}getMulticastEvent(M,z,K,X){const J=this;let _=new c.DisposableStore;const x=new u.Emitter({onWillAddFirstListener:()=>{_=new c.DisposableStore;const a=new u.EventMultiplexer,m=new Map,F=H=>{const oe=H.channelClient.getChannel(M).listen(K,X),ae=a.add(oe);m.set(H,ae)},U=H=>{const B=m.get(H);B&&(B.dispose(),m.delete(H))};J.connections.filter(z).forEach(F),u.Event.filter(J.onDidAddConnection,z)(F,void 0,_),J.onDidRemoveConnection(U,void 0,_),a.event(x.fire,x,_),_.add(a)},onDidRemoveLastListener:()=>{_.dispose()}});return x.event}registerChannel(M,z){this.channels.set(M,z),this._connections.forEach(K=>{K.channelServer.registerChannel(M,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class ${constructor(M,z,K=null){const X=new t;s(X,z),M.send(X.buffer),this.channelClient=new E(M,K),this.channelServer=new D(M,z,K)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,z){this.channelServer.registerChannel(M,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=$;function Z(V){return{call(M,z,K){return V.then(X=>X.call(M,z,K))},listen(M,z){const K=new u.Relay;return V.then(X=>K.input=X.listen(M,z)),K.event}}}e.getDelayedChannel=Z;function Q(V){let M=!1;return{call(z,K,X){return M?V.call(z,K,X):(0,O.timeout)(0).then(()=>M=!0).then(()=>V.call(z,K,X))},listen(z,K){if(M)return V.listen(z,K);const X=new u.Relay;return(0,O.timeout)(0).then(()=>M=!0).then(()=>X.input=V.listen(z,K)),X.event}}}e.getNextTickChannel=Q;class ce{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const z of M.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await u.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=ce;var te;(function(V){function M(J,_){const x=J,a=_&&_.disableMarshalling,m=new Map;for(const F in x)K(F)&&m.set(F,u.Event.buffer(x[F],!0));return new class{listen(F,U,H){const B=m.get(U);if(B)return B;if(X(U)){const oe=x[U];if(typeof oe=="function")return oe.call(x,H)}throw new y.ErrorNoTelemetry(`Event not found: ${U}`)}call(F,U,H){const B=x[U];if(typeof B=="function"){if(!a&&Array.isArray(H))for(let oe=0;oe<H.length;oe++)H[oe]=(0,S.revive)(H[oe]);return B.apply(x,H)}throw new y.ErrorNoTelemetry(`Method not found: ${U}`)}}}V.fromService=M;function z(J,_){const x=_&&_.disableMarshalling;return new Proxy({},{get(a,m){if(typeof m=="string")return _?.properties?.has(m)?_.properties.get(m):X(m)?function(F){return J.listen(m,F)}:K(m)?J.listen(m):async function(...F){let U;_&&!(0,g.isUndefinedOrNull)(_.context)?U=[_.context,...F]:U=F;const H=await J.call(m,U);return x?H:(0,S.revive)(H)};throw new y.ErrorNoTelemetry(`Property not found: ${String(m)}`)}})}V.toService=z;function K(J){return J[0]==="o"&&J[1]==="n"&&R.isUpperAsciiLetter(J.charCodeAt(2))}function X(J){return/^onDynamic/.test(J)&&R.isUpperAsciiLetter(J.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const M=V.toString();if(M!=="[object Object]")return M}return V}function ie(V){return Array.isArray(V)?V.map(ue):ue(V)}function W(V,M,z,K,X,J,_){_=ie(_);const x=le[X],a=x[K%x.length];let m=[`%c[${V}]%c[${String(M).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(J)?(m=m.concat(_),m.push(")")):m.push(_),console.log.apply(console,m)}class q{constructor(M,z){this._outgoingPrefix=M,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,z,K,X,J){this._totalOutgoing+=M,W(this._outgoingPrefix,this._totalOutgoing,M,z,K,X,J)}logIncoming(M,z,K,X,J){this._totalIncoming+=M,W(this._incomingPrefix,this._totalIncoming,M,z,K,X,J)}}e.IPCLogger=q}),define(ne[85],se([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class w extends d.ChannelServer{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>k.VSBuffer.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=w;class I{constructor(h,f){this.modulePath=h,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const b=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new O.Delayer(b),this.child=null,this._client=null}getChannel(h){const f=this;return{call(b,v,P){return f.requestPromise(h,b,v,P)},listen(b,v){return f.requestEvent(h,b,v)}}}requestPromise(h,f,b,v=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const P=this.getCachedChannel(h),t=(0,O.createCancelablePromise)(r=>P.call(f,b,r)),o=v.onCancellationRequested(()=>t.cancel()),i=(0,c.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{o.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(h,f,b){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let v;const P=new u.Emitter({onWillAddFirstListener:()=>{v=this.getCachedChannel(h).listen(f,b)(P.fire,P),this.activeRequests.add(v)},onDidRemoveLastListener:()=>{this.activeRequests.delete(v),v.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return P.event}get client(){if(!this._client){const h=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,S.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,g.removeDangerousEnvVariables)(f.env),this.child=(0,N.fork)(this.modulePath,h,f);const b=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,T.isRemoteConsoleLog)(n)){(0,T.log)(n,`IPC Library: ${this.options.serverName}`);return}b.fire(k.VSBuffer.wrap(Buffer.from(n,"base64")))});const P=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,t=n=>this.child&&this.child.connected&&P.send(n.buffer.toString("base64")),o=b.event,i={send:t,onMessage:o};this._client=new d.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,s)=>{process.removeListener("exit",r),this.activeRequests.forEach(l=>(0,c.dispose)(l)),this.activeRequests.clear(),n!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+s),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:s})})}return this._client}getCachedChannel(h){let f=this.channels.get(h);return f||(f=this.client.getChannel(h),this.channels.set(h,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=I}),define(ne[86],se([0,1,8,4,2,47,3]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var y;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(y||(e.StorageHint=y={}));function u(g){const d=g;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=u;var c;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(c||(e.StorageState=c={}));class S extends k.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(d,w=Object.create(null)){super(),this.database=d,this.options=w,this._onDidChangeStorage=this._register(new O.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new N.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){this._onDidChangeStorage.pause();try{d.changed?.forEach((w,I)=>this.acceptExternal(I,w)),d.deleted?.forEach(w=>this.acceptExternal(w,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(d,w){if(this.state===c.Closed)return;let I=!1;(0,T.isUndefinedOrNull)(w)?I=this.cache.delete(d):this.cache.get(d)!==w&&(this.cache.set(d,w),I=!0),I&&this._onDidChangeStorage.fire({key:d,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==y.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,w){const I=this.cache.get(d);return(0,T.isUndefinedOrNull)(I)?w:I}getBoolean(d,w){const I=this.get(d);return(0,T.isUndefinedOrNull)(I)?w:I==="true"}getNumber(d,w){const I=this.get(d);return(0,T.isUndefinedOrNull)(I)?w:parseInt(I,10)}getObject(d,w){const I=this.get(d);return(0,T.isUndefinedOrNull)(I)?w:(0,A.parse)(I)}async set(d,w,I=!1){if(this.state===c.Closed)return;if((0,T.isUndefinedOrNull)(w))return this.delete(d,I);const p=(0,T.isObject)(w)||Array.isArray(w)?(0,A.stringify)(w):String(w);if(this.cache.get(d)!==p)return this.cache.set(d,p),this.pendingInserts.set(d,p),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire({key:d,external:I}),this.doFlush()}async delete(d,w=!1){if(!(this.state===c.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire({key:d,external:w}),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}isInMemory(){return this.options.hint===y.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=S;class R{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert?.forEach((w,I)=>this.items.set(I,w)),d.delete?.forEach(w=>this.items.delete(w))}async close(){}}e.InMemoryStorageDatabase=R}),define(ne[87],se([7,5]),function(G,e){return G.create("vs/base/node/zip",e)}),define(ne[88],se([7,5]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],se([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],se([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],se([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],se([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],se([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],se([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],se([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],se([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],se([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],se([7,5]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],se([7,5]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ne[100],se([7,5]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ne[101],se([7,5]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],se([7,5]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],se([7,5]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ne[104],se([7,5]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],se([7,5]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],se([7,5]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],se([7,5]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],se([0,1,9,90]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...c){switch(c.length){case 1:return(0,O.localize)(0,null,c[0]);case 2:return(0,O.localize)(1,null,c[0],c[1]);case 3:return(0,O.localize)(2,null,c[0],c[1],c[2]);default:return}}const T=(0,O.localize)(3,null),y=(0,O.localize)(4,null);class u{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return S.isTripleEq?"===":"==";case 4:return S.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return S.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return S.lexeme;case 18:return S.lexeme;case 19:return S.lexeme;case 20:return"EOF";default:throw(0,N.illegalState)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(S){return this._input=S,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const R=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:R})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const R=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:R})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(S){return this._isAtEnd()||this._input.charCodeAt(this._current)!==S?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(S){this._tokens.push({type:S,offset:this._start})}_error(S){const R=this._start,g=this._input.substring(this._start,this._current),d={type:19,offset:this._start,lexeme:g};this._errors.push({offset:R,lexeme:g,additionalInfo:S}),this._tokens.push(d)}_string(){this.stringRe.lastIndex=this._start;const S=this.stringRe.exec(this._input);if(S){this._current=this._start+S[0].length;const R=this._input.substring(this._start,this._current),g=u._keywords.get(R);g?this._addToken(g):this._tokens.push({type:17,lexeme:R,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let S=this._current,R=!1,g=!1;for(;;){if(S>=this._input.length){this._current=S,this._error(y);return}const w=this._input.charCodeAt(S);if(R)R=!1;else if(w===47&&!g){S++;break}else w===91?g=!0:w===92?R=!0:w===93&&(g=!1);S++}for(;S<this._input.length&&u._regexFlags.has(this._input.charCodeAt(S));)S++;this._current=S;const d=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:d,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=u}),define(ne[109],se([0,1,77,52,15,16,34,17,11]),function(G,e,N,O,k,A,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,y.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,y.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,N.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",d)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,y.joinPath)(u.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,y.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,y.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,y.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=T.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.join)(d,"argv.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.resolve)(d):(0,A.normalize)((0,A.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?u.URI.file((0,A.resolve)(d)):u.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.resolve)(d);const w=T.env.VSCODE_EXTENSIONS;if(w)return w;const I=T.env.VSCODE_PORTABLE;return I?(0,A.join)(I,"extensions"):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(w=>/^[^:/?#]+?:\/\//.test(w)?u.URI.parse(w):u.URI.file((0,A.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?u.URI.parse(d):u.URI.file((0,A.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const w of this.args.log||[]){const I=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(w);I&&I[1]&&I[2]&&d.push([I[1],I[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,y.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get disableKeytar(){return!!this.args["disable-keytar"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=T.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.join)(d,"policy.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this._args}constructor(d,w,I){this._args=d,this.paths=w,this.productService=I,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=c,pe([O.memoize],c.prototype,"appRoot",null),pe([O.memoize],c.prototype,"userHome",null),pe([O.memoize],c.prototype,"userDataPath",null),pe([O.memoize],c.prototype,"appSettingsHome",null),pe([O.memoize],c.prototype,"tmpDir",null),pe([O.memoize],c.prototype,"cacheHome",null),pe([O.memoize],c.prototype,"stateResource",null),pe([O.memoize],c.prototype,"userRoamingDataHome",null),pe([O.memoize],c.prototype,"userDataSyncHome",null),pe([O.memoize],c.prototype,"sync",null),pe([O.memoize],c.prototype,"machineSettingsResource",null),pe([O.memoize],c.prototype,"workspaceStorageHome",null),pe([O.memoize],c.prototype,"localHistoryHome",null),pe([O.memoize],c.prototype,"keyboardLayoutResource",null),pe([O.memoize],c.prototype,"argvResource",null),pe([O.memoize],c.prototype,"isExtensionDevelopment",null),pe([O.memoize],c.prototype,"untitledWorkspacesHome",null),pe([O.memoize],c.prototype,"builtinExtensionsPath",null),pe([O.memoize],c.prototype,"extensionsPath",null),pe([O.memoize],c.prototype,"extensionDevelopmentLocationURI",null),pe([O.memoize],c.prototype,"extensionDevelopmentKind",null),pe([O.memoize],c.prototype,"extensionTestsLocationURI",null),pe([O.memoize],c.prototype,"debugExtensionHost",null),pe([O.memoize],c.prototype,"logLevel",null),pe([O.memoize],c.prototype,"extensionLogLevel",null),pe([O.memoize],c.prototype,"serviceMachineIdResource",null),pe([O.memoize],c.prototype,"disableTelemetry",null),pe([O.memoize],c.prototype,"disableWorkspaceTrust",null),pe([O.memoize],c.prototype,"disableKeytar",null),pe([O.memoize],c.prototype,"policyFile",null);function S(g,d){return R(g["inspect-extensions"],g["inspect-brk-extensions"],5870,d,g.debugId,g.extensionEnvironment)}e.parseExtensionHostDebugPort=S;function R(g,d,w,I,p,h){const b=Number(d||g)||(I?null:w),v=b?!!d:!1;let P;if(h)try{P=JSON.parse(h)}catch{}return{port:b,break:v,debugId:p,env:P}}e.parseDebugParams=R}),function(){"use strict";function G(e,N,O){function k(T,y){const u=A(T,y),c=[u];return e.isAbsolute(u)||c.unshift(O),e.resolve(...c)}function A(T,y){process.env.VSCODE_DEV&&(y="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,y);const S=T["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(R,"AppData","Roaming")}break;case"darwin":c=e.join(N.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(N.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,y)}return{getUserDataPath:k}}if(typeof define=="function")define(ne[110],se([165,32,34]),function(e,N,O){return G(e,N,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),N=require("os");module.exports=G(e,N,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],se([0,1,32,109,110]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends O.AbstractNativeEnvironmentService{constructor(c,S){super(c,{homeDir:(0,N.homedir)(),tmpDir:(0,N.tmpdir)(),userDataDir:(0,k.getUserDataPath)(c,S.nameShort)},S)}}e.NativeEnvironmentService=A;function T(u,c){return(0,O.parseDebugParams)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}e.parsePtyHostDebugPort=T;function y(u,c){return(0,O.parseDebugParams)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}e.parseSharedProcessDebugPort=y}),define(ne[112],se([0,1,3,94]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(T,y,u){try{A(T,y,u)}catch(c){console.error(c?.message??c)}return T}e.localizeManifest=k;function A(T,y,u){const c=(S,R,g)=>{const d=S[R];if((0,N.isString)(d)){const w=d,I=w.length;if(I>1&&w[0]==="%"&&w[I-1]==="%"){const p=w.substr(1,I-2);let h=y[p];h===void 0&&u&&(h=u[p]);const f=typeof h=="string"?h:h?.message,b=u?.[p],v=typeof b=="string"?b:b?.message;if(!f){v||console.warn(`[${T.name}]: ${(0,O.localize)(0,null,p)}`);return}if(g&&(R==="title"||R==="category")&&v&&v!==f){const P={value:f,original:v};S[R]=P}else S[R]=f}}else if((0,N.isObject)(d))for(const w in d)d.hasOwnProperty(w)&&(w==="commands"?c(d,w,!0):c(d,w,g));else if(Array.isArray(d))for(let w=0;w<d.length;w++)c(d,w,g)};for(const S in T)T.hasOwnProperty(S)&&c(T,S)}}),define(ne[48],se([0,1,17,54,98,43]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function u(h){return h=h.trim(),h==="*"||T.test(h)}e.isValidVersionStr=u;function c(h){if(!u(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(T);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=c;function S(h){if(!h)return null;const f=h.majorBase,b=h.majorMustEqual,v=h.minorBase;let P=h.minorMustEqual;const t=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(f===0||(P=!1),o=!1);let i=0;if(h.preRelease){const r=y.exec(h.preRelease);if(r){const[,n,s,l]=r;i=Date.UTC(Number(n),Number(s)-1,Number(l))}}return{majorBase:f,majorMustEqual:b,minorBase:v,minorMustEqual:P,patchBase:t,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:i}}e.normalizeVersion=S;function R(h,f,b){let v;typeof h=="string"?v=S(c(h)):v=h;let P;f instanceof Date?P=f.getTime():typeof f=="string"&&(P=new Date(f).getTime());let t;if(typeof b=="string"?t=S(c(b)):t=b,!v||!t)return!1;const o=v.majorBase,i=v.minorBase,r=v.patchBase;let n=t.majorBase,s=t.minorBase,l=t.patchBase;const D=t.notBefore;let C=t.majorMustEqual,E=t.minorMustEqual,L=t.patchMustEqual;return t.isMinimum?o>n?!0:o<n?!1:i>s?!0:i<s||P&&P<D?!1:r>=l:(o===1&&n===0&&(!C||!E||!L)&&(n=1,s=0,l=0,C=!0,E=!1,L=!1),o<n?!1:o>n?!C:i<s?!1:i>s?!E:r<l?!1:r>l?!L:!(P&&P<D))}e.isValidVersion=R;function g(h,f,b,v,P){const t=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return t.push([O.default.Error,k.localize(0,null)]),t;if(typeof v.name!="string")return t.push([O.default.Error,k.localize(1,null,"name")]),t;if(typeof v.version!="string")return t.push([O.default.Error,k.localize(2,null,"version")]),t;if(!v.engines)return t.push([O.default.Error,k.localize(3,null,"engines")]),t;if(typeof v.engines.vscode!="string")return t.push([O.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof v.extensionDependencies<"u"&&!p(v.extensionDependencies))return t.push([O.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof v.activationEvents<"u"){if(!p(v.activationEvents))return t.push([O.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof v.main>"u"&&typeof v.browser>"u")return t.push([O.default.Error,k.localize(7,null,"activationEvents","main","browser")]),t}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&t.push([O.default.Warning,k.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return t.push([O.default.Error,k.localize(9,null,"main")]),t;{const r=(0,N.joinPath)(b,v.main);(0,N.isEqualOrParent)(r,b)||t.push([O.default.Warning,k.localize(10,null,r.path,b.path)])}}if(typeof v.browser<"u"){if(typeof v.browser!="string")return t.push([O.default.Error,k.localize(11,null,"browser")]),t;{const r=(0,N.joinPath)(b,v.browser);(0,N.isEqualOrParent)(r,b)||t.push([O.default.Warning,k.localize(12,null,r.path,b.path)])}}if(!A.valid(v.version))return t.push([O.default.Error,k.localize(13,null)]),t;const o=[];if(!d(h,f,v,P,o))for(const r of o)t.push([O.default.Error,r]);return t}e.validateExtensionManifest=g;function d(h,f,b,v,P){return v||typeof b.main>"u"&&typeof b.browser>"u"?!0:I(h,f,b.engines.vscode,P)}e.isValidExtensionVersion=d;function w(h,f,b){return h==="*"||I(f,b,h)}e.isEngineValid=w;function I(h,f,b,v=[]){const P=S(c(b));if(!P)return v.push(k.localize(14,null,b)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return v.push(k.localize(15,null,b)),!1}else if(!P.majorMustEqual)return v.push(k.localize(16,null,b)),!1;return R(h,f,P)?!0:(v.push(k.localize(17,null,h,b)),!1)}function p(h){if(!Array.isArray(h))return!1;for(let f=0,b=h.length;f<b;f++)if(typeof h[f]!="string")return!1;return!0}}),define(ne[113],se([0,1,14,28]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(A,T,y){let u=y&&y.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const S=(await T.readFile(A.serviceMachineIdResource)).value.toString();u=(0,O.isUUID)(S)?S:null}catch{u=null}if(!u){u=(0,O.generateUuid)();try{await T.writeFile(A.serviceMachineIdResource,N.VSBuffer.fromString(u))}catch{}}return y?.store("storage.serviceMachineId",u,-1,1),u}e.getServiceMachineId=k}),define(ne[49],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class N{constructor(k,A=[],T=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=N}),define(ne[114],se([0,1,49]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var k;(function(y){y[y.Eager=0]="Eager",y[y.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function A(y,u,c){u instanceof N.SyncDescriptor||(u=new N.SyncDescriptor(u,[],!!c)),O.push([y,u])}e.registerSingleton=A;function T(){return O}e.getSingletonServiceDescriptors=T}),define(ne[115],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class N{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=N;class O{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const y=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(T);y.outgoing.set(u.key,u),u.incoming.set(y.key,y)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(const y of this._nodes.values())y.outgoing.delete(T),y.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let y=this._nodes.get(T);return y||(y=new N(T,A),this._nodes.set(T,y)),y}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[T,y]of this._nodes)A.push(`${T}
	(-> incoming)[${[...y.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...y.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this._nodes){const y=new Set([A]),u=this._findCycle(T,y);if(u)return u}}_findCycle(A,T){for(const[y,u]of A.outgoing){if(T.has(y))return[...T,y].join(" -> ");T.add(y);const c=this._findCycle(u,T);if(c)return c;T.delete(y)}}}e.Graph=O}),define(ne[25],se([0,1,3,11,10]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof O.URI)}e.isConfigurationOverrides=A;function T(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=T;var y;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(y||(e.ConfigurationTarget=y={}));function u(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=u;function c(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.isConfigured=c;function S(h,f){const b=Object.create(null);for(const v in h)R(b,v,h[v],f);return b}e.toValuesTree=S;function R(h,f,b,v){const P=f.split("."),t=P.pop();let o=h;for(let i=0;i<P.length;i++){const r=P[i];let n=o[r];switch(typeof n){case"undefined":n=o[r]=Object.create(null);break;case"object":break;default:v(`Ignoring ${f} as ${P.slice(0,i+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[t]=b}catch{v(`Ignoring ${f} as ${P.join(".")} is ${JSON.stringify(o)}`)}else v(`Ignoring ${f} as ${P.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=R;function g(h,f){const b=f.split(".");d(h,b)}e.removeFromValueTree=g;function d(h,f){const b=f.shift();if(f.length===0){delete h[b];return}if(Object.keys(h).indexOf(b)!==-1){const v=h[b];typeof v=="object"&&!Array.isArray(v)&&(d(v,f),Object.keys(v).length===0&&delete h[b])}}function w(h,f,b){function v(o,i){let r=o;for(const n of i){if(typeof r!="object"||r===null)return;r=r[n]}return r}const P=f.split("."),t=v(h,P);return typeof t>"u"?b:t}e.getConfigurationValue=w;function I(h,f,b){Object.keys(f).forEach(v=>{v!=="__proto__"&&(v in h?N.isObject(h[v])&&N.isObject(f[v])?I(h[v],f[v],b):b&&(h[v]=f[v]):h[v]=f[v])})}e.merge=I;function p(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(ne[116],se([0,1,13,29,108,10,89,9]),function(G,e,N,O,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",N.isMacintosh),u.set("isLinux",N.isLinux),u.set("isWindows",N.isWindows),u.set("isWeb",N.isWeb),u.set("isMacNative",N.isMacintosh&&!N.isWeb),u.set("isEdge",N.isEdge),u.set("isFirefox",N.isFirefox),u.set("isChrome",N.isChrome),u.set("isSafari",N.isSafari);function c(x,a){if(u.get(x)!==void 0)throw(0,y.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(x,a)}e.setConstant=c;const S=Object.prototype.hasOwnProperty;var R;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(R||(e.ContextKeyExprType=R={}));const g={regexParsingWithErrorRecovery:!0},d=(0,T.localize)(0,null),w=(0,T.localize)(1,null),I=(0,T.localize)(2,null),p=(0,T.localize)(3,null),h=(0,T.localize)(4,null),f=(0,T.localize)(5,null),b=(0,T.localize)(6,null),v=(0,T.localize)(7,null);class P{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(a=g){this._config=a,this._scanner=new k.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(a){if(a===""){this._parsingErrors.push({message:d,offset:0,lexeme:"",additionalInfo:w});return}this._tokens=this._scanner.reset(a).scan(),this._current=0,this._parsingErrors=[];try{const m=this._expr();if(!this._isAtEnd()){const F=this._peek(),U=F.type===17?f:void 0;throw this._parsingErrors.push({message:h,offset:F.offset,lexeme:k.Scanner.getLexeme(F),additionalInfo:U}),P._parseError}return m}catch(m){if(m!==P._parseError)throw m;return}}_expr(){return this._or()}_or(){const a=[this._and()];for(;this._matchOne(16);){const m=this._and();a.push(m)}return a.length===1?a[0]:t.or(...a)}_and(){const a=[this._term()];for(;this._matchOne(15);){const m=this._term();a.push(m)}return a.length===1?a[0]:t.and(...a)}_term(){if(this._matchOne(2)){const a=this._peek();switch(a.type){case 11:return this._advance(),n.INSTANCE;case 12:return this._advance(),s.INSTANCE;case 0:{this._advance();const m=this._expr();return this._consume(1,p),m?.negate()}case 17:return this._advance(),$.create(a.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",a)}}return this._primary()}_primary(){const a=this._peek();switch(a.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const m=this._expr();return this._consume(1,p),m}case 17:{const m=a.lexeme;if(this._advance(),this._matchOne(9)){const U=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),U.type!==10)throw this._errExpectedButGot("REGEX",U);const H=U.lexeme,B=H.lastIndexOf("/"),oe=B===H.length-1?void 0:this._removeFlagsGY(H.substring(B+1));let ae;try{ae=new RegExp(H.substring(1,B),oe)}catch{throw this._errExpectedButGot("REGEX",U)}return ue.create(m,ae)}switch(U.type){case 10:case 19:{const H=[U.lexeme];this._advance();let B=this._peek(),oe=0;for(let he=0;he<U.lexeme.length;he++)U.lexeme.charCodeAt(he)===40?oe++:U.lexeme.charCodeAt(he)===41&&oe--;for(;!this._isAtEnd()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let he=0;he<B.lexeme.length;he++)B.lexeme.charCodeAt(he)===40?oe++:U.lexeme.charCodeAt(he)===41&&oe--}if(oe<0)break;H.push(k.Scanner.getLexeme(B)),this._advance(),B=this._peek()}const ae=H.join(""),ve=ae.lastIndexOf("/"),de=ve===ae.length-1?void 0:this._removeFlagsGY(ae.substring(ve+1));let ge;try{ge=new RegExp(ae.substring(1,ve),de)}catch{throw this._errExpectedButGot("REGEX",U)}return t.regex(m,ge)}case 18:{const H=U.lexeme;this._advance();let B=null;if(!(0,O.isFalsyOrWhitespace)(H)){const oe=H.indexOf("/"),ae=H.lastIndexOf("/");if(oe!==ae&&oe>=0){const ve=H.slice(oe+1,ae),de=H[ae+1]==="i"?"i":"";try{B=new RegExp(ve,de)}catch{throw this._errExpectedButGot("REGEX",U)}}}if(B===null)throw this._errExpectedButGot("REGEX",U);return ue.create(m,B)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,I);const U=this._value();return t.notIn(m,U)}switch(this._peek().type){case 3:{this._advance();const U=this._value();if(this._previous().type===18)return t.equals(m,U);switch(U){case"true":return t.has(m);case"false":return t.not(m);default:return t.equals(m,U)}}case 4:{this._advance();const U=this._value();if(this._previous().type===18)return t.notEquals(m,U);switch(U){case"true":return t.not(m);case"false":return t.has(m);default:return t.notEquals(m,U)}}case 5:return this._advance(),te.create(m,this._value());case 6:return this._advance(),le.create(m,this._value());case 7:return this._advance(),Q.create(m,this._value());case 8:return this._advance(),ce.create(m,this._value());case 13:return this._advance(),t.in(m,this._value());default:return t.has(m)}}case 20:throw this._parsingErrors.push({message:b,offset:a.offset,lexeme:"",additionalInfo:v}),P._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const a=this._peek();switch(a.type){case 17:case 18:return this._advance(),a.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(a){return a.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(a){return this._check(a)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(a,m){if(this._check(a))return this._advance();throw this._errExpectedButGot(m,this._peek())}_errExpectedButGot(a,m,F){const U=(0,T.localize)(8,null,a,k.Scanner.getLexeme(m)),H=m.offset,B=k.Scanner.getLexeme(m);return this._parsingErrors.push({message:U,offset:H,lexeme:B,additionalInfo:F}),P._parseError}_check(a){return this._peek().type===a}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=P;class t{static false(){return n.INSTANCE}static true(){return s.INSTANCE}static has(a){return l.create(a)}static equals(a,m){return D.create(a,m)}static notEquals(a,m){return L.create(a,m)}static regex(a,m){return ue.create(a,m)}static in(a,m){return C.create(a,m)}static notIn(a,m){return E.create(a,m)}static not(a){return $.create(a)}static and(...a){return q.create(a,null,!0)}static or(...a){return V.create(a,null,!0)}static greater(a,m){return Q.create(a,m)}static greaterEquals(a,m){return ce.create(a,m)}static smaller(a,m){return te.create(a,m)}static smallerEquals(a,m){return le.create(a,m)}static{this._parser=new P({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this._parser.parse(a)}}e.ContextKeyExpr=t;function o(x){const a=new P({regexParsingWithErrorRecovery:!1});return x.map(m=>(a.parse(m),a.lexingErrors.length>0?a.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,T.localize)(9,null,F.additionalInfo):(0,T.localize)(10,null),offset:F.offset,length:F.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}e.validateWhenClauses=o;function i(x,a){const m=x?x.substituteConstants():void 0,F=a?a.substituteConstants():void 0;return!m&&!F?!0:!m||!F?!1:m.equals(F)}e.expressionsAreEqualWithConstantSubstitution=i;function r(x,a){return x.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return s.INSTANCE}}e.ContextKeyFalseExpr=n;class s{static{this.INSTANCE=new s}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=s;class l{static create(a,m=null){const F=u.get(a);return typeof F=="boolean"?F?s.INSTANCE:n.INSTANCE:new l(a,m)}constructor(a,m){this.key=a,this.negated=m,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:z(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=u.get(this.key);return typeof a=="boolean"?a?s.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.negated||(this.negated=$.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=l;class D{static create(a,m,F=null){if(typeof m=="boolean")return m?l.create(a,F):$.create(a,F);const U=u.get(a);return typeof U=="boolean"?m===(U?"true":"false")?s.INSTANCE:n.INSTANCE:new D(a,m,F)}constructor(a,m,F){this.key=a,this.value=m,this.negated=F,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:K(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){const a=u.get(this.key);if(typeof a=="boolean"){const m=a?"true":"false";return this.value===m?s.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=L.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class C{static create(a,m){return new C(a,m)}constructor(a,m){this.key=a,this.valueKey=m,this.type=10,this.negated=null}cmp(a){return a.type!==this.type?this.type-a.type:K(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.valueKey),F=a.getValue(this.key);return Array.isArray(m)?m.includes(F):typeof F=="string"&&typeof m=="object"&&m!==null?S.call(m,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=E.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=C;class E{static create(a,m){return new E(a,m)}constructor(a,m){this.key=a,this.valueKey=m,this.type=11,this._negated=C.create(a,m)}cmp(a){return a.type!==this.type?this.type-a.type:this._negated.cmp(a._negated)}equals(a){return a.type===this.type?this._negated.equals(a._negated):!1}substituteConstants(){return this}evaluate(a){return!this._negated.evaluate(a)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(a){return a.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=E;class L{static create(a,m,F=null){if(typeof m=="boolean")return m?$.create(a,F):l.create(a,F);const U=u.get(a);return typeof U=="boolean"?m===(U?"true":"false")?n.INSTANCE:s.INSTANCE:new L(a,m,F)}constructor(a,m,F){this.key=a,this.value=m,this.negated=F,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:K(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){const a=u.get(this.key);if(typeof a=="boolean"){const m=a?"true":"false";return this.value===m?n.INSTANCE:s.INSTANCE}return this}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=L;class ${static create(a,m=null){const F=u.get(a);return typeof F=="boolean"?F?n.INSTANCE:s.INSTANCE:new $(a,m)}constructor(a,m){this.key=a,this.negated=m,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:z(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=u.get(this.key);return typeof a=="boolean"?a?n.INSTANCE:s.INSTANCE:this}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=$;function Z(x,a){if(typeof x=="string"){const m=parseFloat(x);isNaN(m)||(x=m)}return typeof x=="string"||typeof x=="number"?a(x):n.INSTANCE}class Q{static create(a,m,F=null){return Z(m,U=>new Q(a,U,F))}constructor(a,m,F){this.key=a,this.value=m,this.negated=F,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:K(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){return this}evaluate(a){return typeof this.value=="string"?!1:parseFloat(a.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=le.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=Q;class ce{static create(a,m,F=null){return Z(m,U=>new ce(a,U,F))}constructor(a,m,F){this.key=a,this.value=m,this.negated=F,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:K(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){return this}evaluate(a){return typeof this.value=="string"?!1:parseFloat(a.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=te.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=ce;class te{static create(a,m,F=null){return Z(m,U=>new te(a,U,F))}constructor(a,m,F){this.key=a,this.value=m,this.negated=F,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:K(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){return this}evaluate(a){return typeof this.value=="string"?!1:parseFloat(a.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=ce.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=te;class le{static create(a,m,F=null){return Z(m,U=>new le(a,U,F))}constructor(a,m,F){this.key=a,this.value=m,this.negated=F,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:K(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){return this}evaluate(a){return typeof this.value=="string"?!1:parseFloat(a.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=le;class ue{static create(a,m){return new ue(a,m)}constructor(a,m){this.key=a,this.regexp=m,this.type=7,this.negated=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const m=this.regexp?this.regexp.source:"",F=a.regexp?a.regexp.source:"";return m<F?-1:m>F?1:0}equals(a){if(a.type===this.type){const m=this.regexp?this.regexp.source:"",F=a.regexp?a.regexp.source:"";return this.key===a.key&&m===F}return!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.key);return this.regexp?this.regexp.test(m):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ie.create(this)),this.negated}}e.ContextKeyRegexExpr=ue;class ie{static create(a){return new ie(a)}constructor(a){this._actual=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}substituteConstants(){return this}evaluate(a){return!this._actual.evaluate(a)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(a){return new ie(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ie;function W(x){let a=null;for(let m=0,F=x.length;m<F;m++){const U=x[m].substituteConstants();if(x[m]!==U&&a===null){a=[];for(let H=0;H<m;H++)a[H]=x[H]}a!==null&&(a[m]=U)}return a===null?x:a}class q{static create(a,m,F){return q._normalizeArr(a,m,F)}constructor(a,m){this.expr=a,this.negated=m,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,F=this.expr.length;m<F;m++){const U=r(this.expr[m],a.expr[m]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=W(this.expr);return a===this.expr?this:q.create(a,this.negated,!1)}evaluate(a){for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].evaluate(a))return!1;return!0}static _normalizeArr(a,m,F){const U=[];let H=!1;for(const B of a)if(B){if(B.type===1){H=!0;continue}if(B.type===0)return n.INSTANCE;if(B.type===6){U.push(...B.expr);continue}U.push(B)}if(U.length===0&&H)return s.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(r);for(let B=1;B<U.length;B++)U[B-1].equals(U[B])&&(U.splice(B,1),B--);if(U.length===1)return U[0];for(;U.length>1;){const B=U[U.length-1];if(B.type!==9)break;U.pop();const oe=U.pop(),ae=U.length===0,ve=V.create(B.expr.map(de=>q.create([de,oe],null,F)),null,ae);ve&&(U.push(ve),U.sort(r))}if(U.length===1)return U[0];if(F){for(let B=0;B<U.length;B++)for(let oe=B+1;oe<U.length;oe++)if(U[B].negate().equals(U[oe]))return n.INSTANCE;if(U.length===1)return U[0]}return new q(U,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new q(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.negated){const a=[];for(const m of this.expr)a.push(m.negate());this.negated=V.create(a,this,!0)}return this.negated}}e.ContextKeyAndExpr=q;class V{static create(a,m,F){return V._normalizeArr(a,m,F)}constructor(a,m){this.expr=a,this.negated=m,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,F=this.expr.length;m<F;m++){const U=r(this.expr[m],a.expr[m]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=W(this.expr);return a===this.expr?this:V.create(a,this.negated,!1)}evaluate(a){for(let m=0,F=this.expr.length;m<F;m++)if(this.expr[m].evaluate(a))return!0;return!1}static _normalizeArr(a,m,F){let U=[],H=!1;if(a){for(let B=0,oe=a.length;B<oe;B++){const ae=a[B];if(ae){if(ae.type===0){H=!0;continue}if(ae.type===1)return s.INSTANCE;if(ae.type===9){U=U.concat(ae.expr);continue}U.push(ae)}}if(U.length===0&&H)return n.INSTANCE;U.sort(r)}if(U.length!==0){if(U.length===1)return U[0];for(let B=1;B<U.length;B++)U[B-1].equals(U[B])&&(U.splice(B,1),B--);if(U.length===1)return U[0];if(F){for(let B=0;B<U.length;B++)for(let oe=B+1;oe<U.length;oe++)if(U[B].negate().equals(U[oe]))return s.INSTANCE;if(U.length===1)return U[0]}return new V(U,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new V(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.negated){const a=[];for(const m of this.expr)a.push(m.negate());for(;a.length>1;){const m=a.shift(),F=a.shift(),U=[];for(const H of _(m))for(const B of _(F))U.push(q.create([H,B],null,!1));a.unshift(V.create(U,null,!1))}this.negated=V.create(a,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class M extends l{static{this._info=[]}static all(){return M._info.values()}constructor(a,m,F){super(a,null),this._defaultValue=m,typeof F=="object"?M._info.push({...F,key:a}):F!==!0&&M._info.push({key:a,description:F,type:m!=null?typeof m:void 0})}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return D.create(this.key,a)}notEqualsTo(a){return L.create(this.key,a)}}e.RawContextKey=M,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function z(x,a){return x<a?-1:x>a?1:0}function K(x,a,m,F){return x<m?-1:x>m?1:a<F?-1:a>F?1:0}function X(x,a){if(x.type===0||a.type===1)return!0;if(x.type===9)return a.type===9?J(x.expr,a.expr):!1;if(a.type===9){for(const m of a.expr)if(X(x,m))return!0;return!1}if(x.type===6){if(a.type===6)return J(a.expr,x.expr);for(const m of x.expr)if(X(m,a))return!0;return!1}return x.equals(a)}e.implies=X;function J(x,a){let m=0,F=0;for(;m<x.length&&F<a.length;){const U=x[m].cmp(a[F]);if(U<0)return!1;U===0&&m++,F++}return m===x.length}function _(x){return x.type===9?x.expr:[x]}}),define(ne[59],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,N.createDecorator)("downloadService")}),define(ne[18],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,N.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,N.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[21],se([0,1,92,10]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function k(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function T(f,b){switch(f){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":b==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function y(f,b){return b==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function u(f,b,v){return y(b,v)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===v?!0:c(v).includes(f)}e.isTargetPlatformCompatible=u;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function S(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=S;var R;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var g;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var d;(function(f){f.Install="install",f.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var w;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var I;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(I||(e.ExtensionManagementErrorCode=I={}));var p;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class h extends Error{constructor(b,v){super(b),this.code=v,this.name=v}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,N.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,N.localize)(1,null),original:"Preferences"}}),define(ne[60],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,N.createDecorator)("IExtensionSignatureVerificationService");class O{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((A,T)=>G(["node-vsce-sign"],async y=>A(y),T))),this.moduleLoadingPromise}async verify(A,T,y){let u;try{u=await this.vsceSign()}catch{return!1}return u.verify(A,T,y)}}e.ExtensionSignatureVerificationService=O}),define(ne[61],se([0,1,14,9,100,12]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(S,R,g,d,w,I){let p;try{await y(S,R,g,d,w,I)}catch(h){p=h}finally{p&&w.errorTransformer&&(p=w.errorTransformer(p)),typeof p<"u"&&g.error(p),g.end()}}e.readFileIntoStream=T;async function y(S,R,g,d,w,I){u(I);const p=await S.open(R,{create:!1});try{u(I);let h=0,f=0,b=w&&typeof w.length=="number"?w.length:void 0,v=N.VSBuffer.alloc(Math.min(w.bufferSize,typeof b=="number"?b:w.bufferSize)),P=w&&typeof w.position=="number"?w.position:0,t=0;do f=await S.read(p,P,v.buffer,t,v.byteLength-t),P+=f,t+=f,h+=f,typeof b=="number"&&(b-=f),t===v.byteLength&&(await g.write(d(v)),v=N.VSBuffer.alloc(Math.min(w.bufferSize,typeof b=="number"?b:w.bufferSize)),t=0);while(f>0&&(typeof b!="number"||b>0)&&u(I)&&c(h,w));if(t>0){let o=t;typeof b=="number"&&(o=Math.min(t,b)),g.write(d(v.slice(0,o)))}}catch(h){throw(0,A.ensureFileSystemProviderError)(h)}finally{await S.close(p)}}function u(S){if(S.isCancellationRequested)throw(0,O.canceled)();return!0}function c(S,R){if(typeof R?.limits?.size=="number"&&S>R.limits.size)throw(0,A.createFileSystemProviderError)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],se([0,1,4,166,2,13,167]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class y extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new N.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new N.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=N.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(c){const S=this.normalizeRequests(c),R=S.filter(d=>{const w=this.watchers.get(d.path);return w?!(0,O.patternsEquals)(w.request.excludes,d.excludes)||!(0,O.patternsEquals)(w.request.includes,d.includes):!0}),g=Array.from(this.watchers.values()).filter(({request:d})=>!S.find(w=>w.path===d.path&&(0,O.patternsEquals)(w.excludes,d.excludes)&&(0,O.patternsEquals)(w.includes,d.includes))).map(({request:d})=>d.path);R.length&&this.trace(`Request to start watching: ${R.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),g.length&&this.trace(`Request to stop watching: ${g.join(",")}`);for(const d of g)this.stopWatching(d);for(const d of R)this.startWatching(d)}startWatching(c){const S=new T.NodeJSFileWatcherLibrary(c,g=>this._onDidChangeFile.fire(g),g=>this._onDidLogMessage.fire(g),this.verboseLogging),R={request:c,instance:S};this.watchers.set(c.path,R)}async stop(){for(const[c]of this.watchers)this.stopWatching(c);this.watchers.clear()}stopWatching(c){const S=this.watchers.get(c);S&&(this.watchers.delete(c),S.instance.dispose())}normalizeRequests(c){const S=new Map;for(const R of c){const g=A.isLinux?R.path:R.path.toLowerCase();S.set(g,R)}return Array.from(S.values())}async setVerboseLogging(c){this.verboseLogging=c;for(const[,S]of this.watchers)S.instance.setVerboseLogging(c)}trace(c){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(c)})}toMessage(c,S){return S?`[File Watcher (node.js)] ${c} (path: ${S.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=y}),define(ne[118],se([0,1,62,117]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends N.AbstractNonRecursiveWatcherClient{constructor(T,y,u){super(T,y,u),this.init()}createWatcher(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ne[119],se([0,1,15,57,85,62]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends A.AbstractUniversalWatcherClient{constructor(u,c,S){super(u,c,S),this.init()}createWatcher(u){const c=u.add(new k.Client(N.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:S,signal:R})=>this.onError(`terminated by itself with code ${S}, signal: ${R}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ne[63],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class N{constructor(...k){this._entries=new Map;for(const[A,T]of k)this.set(A,T)}set(k,A){const T=this._entries.get(k);return this._entries.set(k,A),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=N}),define(ne[120],se([0,1,8,9,2,49,115,10,63,168]),function(G,e,N,O,k,A,T,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const S=!1;class R extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class g{constructor(p=new u.ServiceCollection,h=!1,f,b=S){this._services=p,this._strict=h,this._parent=f,this._enableTracing=b,this._activeInstantiations=new Set,this._services.set(y.IInstantiationService,this),this._globalGraph=b?f?._globalGraph??new T.Graph(v=>v):void 0}createChild(p){return new g(p,this._strict,this,this._enableTracing)}invokeFunction(p,...h){const f=w.traceInvocation(this._enableTracing,p);let b=!1;try{return p({get:P=>{if(b)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(P,f);if(!t)throw new Error(`[invokeFunction] unknown service '${P}'`);return t}},...h)}finally{b=!0,f.stop()}}createInstance(p,...h){let f,b;return p instanceof A.SyncDescriptor?(f=w.traceCreation(this._enableTracing,p.ctor),b=this._createInstance(p.ctor,p.staticArguments.concat(h),f)):(f=w.traceCreation(this._enableTracing,p),b=this._createInstance(p,h,f)),f.stop(),b}_createInstance(p,h=[],f){const b=y._util.getServiceDependencies(p).sort((t,o)=>t.index-o.index),v=[];for(const t of b){const o=this._getOrCreateServiceInstance(t.id,f);o||this._throwIfStrict(`[createInstance] ${p.name} depends on UNKNOWN service ${t.id}.`,!1),v.push(o)}const P=b.length>0?b[0].index:h.length;if(h.length!==P){console.trace(`[createInstance] First service dependency of ${p.name} at position ${P+1} conflicts with ${h.length} static arguments`);const t=P-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,P)}return Reflect.construct(p,h.concat(v))}_setServiceInstance(p,h){if(this._services.get(p)instanceof A.SyncDescriptor)this._services.set(p,h);else if(this._parent)this._parent._setServiceInstance(p,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){const h=this._services.get(p);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):h}_getOrCreateServiceInstance(p,h){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(p));const f=this._getServiceInstanceOrDescriptor(p);return f instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,f,h.branch(p,!0)):(h.branch(p,!1),f)}_safeCreateAndCacheServiceInstance(p,h,f){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,h,f)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,h,f){const b=new T.Graph(t=>t.id.toString());let v=0;const P=[{id:p,desc:h,_trace:f}];for(;P.length;){const t=P.pop();if(b.lookupOrInsertNode(t),v++>1e3)throw new R(b);for(const o of y._util.getServiceDependencies(t.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(o.id);if(i||this._throwIfStrict(`[createInstance] ${p} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),i instanceof A.SyncDescriptor){const r={id:o.id,desc:i,_trace:t._trace.branch(o.id,!0)};b.insertEdge(t,r),P.push(r)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new R(b);break}for(const{data:o}of t){if(this._getServiceInstanceOrDescriptor(o.id)instanceof A.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}b.removeNode(o)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,h,f=[],b,v){if(this._services.get(p)instanceof A.SyncDescriptor)return this._createServiceInstance(p,h,f,b,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,h,f,b,v);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(p,h,f=[],b,v){if(b){const P=new g(void 0,this._strict,this,this._enableTracing);P._globalGraphImplicitDependency=String(p);const t=new Map,o=new N.IdleValue(()=>{const i=P._createInstance(h,f,v);for(const[r,n]of t){const s=i[r];if(typeof s=="function")for(const l of n)s.apply(i,l)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,r){if(!o.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let l=t.get(r);return l||(l=new c.LinkedList,t.set(r,l)),(C,E,L)=>{const $=l.push([C,E,L]);return(0,k.toDisposable)($)}}if(r in i)return i[r];const n=o.value;let s=n[r];return typeof s!="function"||(s=s.bind(n),i[r]=s),s},set(i,r,n){return o.value[r]=n,!0},getPrototypeOf(i){return h.prototype}})}else return this._createInstance(h,f,v)}_throwIfStrict(p,h){if(h&&console.warn(p),this._strict)throw new Error(p)}}e.InstantiationService=g;var d;(function(I){I[I.None=0]="None",I[I.Creation=1]="Creation",I[I.Invocation=2]="Invocation",I[I.Branch=3]="Branch"})(d||(d={}));class w{static{this.all=new Set}static{this._None=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,h){return p?new w(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w._None}static traceCreation(p,h){return p?new w(1,h.name):w._None}static{this._totals=0}constructor(p,h){this.type=p,this.name=h,this._start=Date.now(),this._dep=[]}branch(p,h){const f=new w(3,p.toString());return this._dep.push([p,h,f]),f}stop(){const p=Date.now()-this._start;w._totals+=p;let h=!1;function f(v,P){const t=[],o=new Array(v+1).join("	");for(const[i,r,n]of P._dep)if(r&&n){h=!0,t.push(`${o}CREATES -> ${i}`);const s=f(v+1,n);s&&t.push(s)}else t.push(`${o}uses -> ${i}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(p>2||h)&&w.all.add(b.join(`
`))}}e.Trace=w});var re=this&&this.__param||function(G,e){return function(N,O){e(N,O,G)}};define(ne[64],se([0,1,20,2,13,102,21,10]),function(G,e,N,O,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function u(S){return S.tags.find(R=>R.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=u,e.ILanguagePackService=(0,y.createDecorator)("languagePackService");let c=class extends O.Disposable{constructor(R){super(),this.extensionGalleryService=R}async getAvailableLanguages(){const R=new N.CancellationTokenSource;setTimeout(()=>R.cancel(),1e3);let g;try{g=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},R.token)}catch{return[]}const w=g.firstPage.filter(I=>I.properties.localizedLanguages?.length&&I.tags.some(p=>p.startsWith("lp-"))).map(I=>{const p=I.properties.localizedLanguages?.[0],h=u(I);return{...this.createQuickPickItem(h,p,I),extensionId:I.identifier.id,galleryExtension:I}});return w.push(this.createQuickPickItem("en","English")),w}createQuickPickItem(R,g,d){const w=g??R;let I;if(w!==R&&(I=`(${R})`),R.toLowerCase()===k.language.toLowerCase()&&(I??="",I+=(0,A.localize)(0,null)),d?.installCount){I??="";const p=d.installCount;let h;p>1e6?h=`${Math.floor(p/1e5)/10}M`:p>1e3?h=`${Math.floor(p/1e3)}K`:h=String(p),I+=` $(cloud-download) ${h}`}return{id:R,label:w,description:I}}};e.LanguagePackBaseService=c,e.LanguagePackBaseService=c=pe([re(0,T.IExtensionGalleryService)],c)}),define(ne[6],se([0,1,33,4,42,2,35,13,17,3,11,116,10]),function(G,e,N,O,k,A,T,y,u,c,S,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function d(){return new Date().toISOString()}function w(C){return(0,c.isNumber)(C)}e.isLogLevel=w;var I;(function(C){C[C.Off=0]="Off",C[C.Trace=1]="Trace",C[C.Debug=2]="Debug",C[C.Info=3]="Info",C[C.Warning=4]="Warning",C[C.Error=5]="Error"})(I||(e.LogLevel=I={})),e.DEFAULT_LOG_LEVEL=I.Info;function p(C,E,L){switch(E){case I.Trace:C.trace(L);break;case I.Debug:C.debug(L);break;case I.Info:C.info(L);break;case I.Warning:C.warn(L);break;case I.Error:C.error(L);break;case I.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=p;function h(C,E=!1){let L="";for(let $=0;$<C.length;$++){let Z=C[$];if(Z instanceof Error&&(Z=(0,N.toErrorMessage)(Z,E)),typeof Z=="object")try{Z=JSON.stringify(Z)}catch{}L+=($>0?" ":"")+Z}return L}class f extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(E){this.level!==E&&(this.level=E,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(E){return this.level!==I.Off&&this.level<=E}}e.AbstractLogger=f;class b extends f{constructor(E){super(),this.logAlways=E}checkLogLevel(E){return this.logAlways||super.checkLogLevel(E)}trace(E,...L){this.checkLogLevel(I.Trace)&&this.log(I.Trace,h([E,...L],!0))}debug(E,...L){this.checkLogLevel(I.Debug)&&this.log(I.Debug,h([E,...L]))}info(E,...L){this.checkLogLevel(I.Info)&&this.log(I.Info,h([E,...L]))}warn(E,...L){this.checkLogLevel(I.Warning)&&this.log(I.Warning,h([E,...L]))}error(E,...L){if(this.checkLogLevel(I.Error))if(E instanceof Error){const $=Array.prototype.slice.call(arguments);$[0]=E.stack,this.log(I.Error,h($))}else this.log(I.Error,h([E,...L]))}flush(){}}e.AbstractMessageLogger=b;class v extends f{constructor(E=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(E),this.useColors=!y.isWindows}trace(E,...L){this.checkLogLevel(I.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...L):console.log(`[main ${d()}]`,E,...L))}debug(E,...L){this.checkLogLevel(I.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...L):console.log(`[main ${d()}]`,E,...L))}info(E,...L){this.checkLogLevel(I.Info)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...L):console.log(`[main ${d()}]`,E,...L))}warn(E,...L){this.checkLogLevel(I.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,E,...L):console.warn(`[main ${d()}]`,E,...L))}error(E,...L){this.checkLogLevel(I.Error)&&(this.useColors?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,E,...L):console.error(`[main ${d()}]`,E,...L))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class P extends f{constructor(E=e.DEFAULT_LOG_LEVEL,L=!0){super(),this.useColors=L,this.setLevel(E)}trace(E,...L){this.checkLogLevel(I.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",E,...L):console.log(E,...L))}debug(E,...L){this.checkLogLevel(I.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",E,...L):console.log(E,...L))}info(E,...L){this.checkLogLevel(I.Info)&&(this.useColors?console.log("%c INFO","color: #33f",E,...L):console.log(E,...L))}warn(E,...L){this.checkLogLevel(I.Warning)&&(this.useColors?console.log("%c WARN","color: #993",E,...L):console.log(E,...L))}error(E,...L){this.checkLogLevel(I.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",E,...L):console.error(E,...L))}dispose(){}flush(){}}e.ConsoleLogger=P;class t extends f{constructor(E,L=e.DEFAULT_LOG_LEVEL){super(),this.adapter=E,this.setLevel(L)}trace(E,...L){this.checkLogLevel(I.Trace)&&this.adapter.log(I.Trace,[this.extractMessage(E),...L])}debug(E,...L){this.checkLogLevel(I.Debug)&&this.adapter.log(I.Debug,[this.extractMessage(E),...L])}info(E,...L){this.checkLogLevel(I.Info)&&this.adapter.log(I.Info,[this.extractMessage(E),...L])}warn(E,...L){this.checkLogLevel(I.Warning)&&this.adapter.log(I.Warning,[this.extractMessage(E),...L])}error(E,...L){this.checkLogLevel(I.Error)&&this.adapter.log(I.Error,[this.extractMessage(E),...L])}extractMessage(E){return typeof E=="string"?E:(0,N.toErrorMessage)(E,this.checkLogLevel(I.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class o extends f{constructor(E){super(),this.loggers=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const L of this.loggers)L.setLevel(E);super.setLevel(E)}trace(E,...L){for(const $ of this.loggers)$.trace(E,...L)}debug(E,...L){for(const $ of this.loggers)$.debug(E,...L)}info(E,...L){for(const $ of this.loggers)$.info(E,...L)}warn(E,...L){for(const $ of this.loggers)$.warn(E,...L)}error(E,...L){for(const $ of this.loggers)$.error(E,...L)}flush(){for(const E of this.loggers)E.flush()}dispose(){for(const E of this.loggers)E.dispose()}}e.MultiplexLogger=o;class i extends A.Disposable{constructor(E,L,$){if(super(),this.logLevel=E,this.logsHome=L,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,$)for(const Z of $)this._loggers.set(Z.resource,{logger:void 0,info:Z})}getLoggerEntry(E){return(0,c.isString)(E)?[...this._loggers.values()].find(L=>L.info.id===E):this._loggers.get(E)}getLogger(E){return this.getLoggerEntry(E)?.logger}createLogger(E,L){const $=this.toResource(E),Z=(0,c.isString)(E)?E:L?.id??(0,k.hash)($.toString()).toString(16);let Q=this._loggers.get($)?.logger;const ce=L?.logLevel==="always"?I.Trace:L?.logLevel;Q||(Q=this.doCreateLogger($,ce??this.getLogLevel($)??this.logLevel,{...L,id:Z}));const te={logger:Q,info:{resource:$,id:Z,logLevel:ce,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(te.info),this._loggers.set($,te),Q}toResource(E){return(0,c.isString)(E)?(0,u.joinPath)(this.logsHome,`${E}.log`):E}setLogLevel(E,L){if(S.URI.isUri(E)){const $=E,Z=L,Q=this._loggers.get($);Q&&Z!==Q.info.logLevel&&(Q.info.logLevel=Z===this.logLevel?void 0:Z,Q.logger?.setLevel(Z),this._loggers.set(Q.info.resource,Q),this._onDidChangeLogLevel.fire([$,Z]))}else{this.logLevel=E;for(const[$,Z]of this._loggers.entries())this._loggers.get($)?.info.logLevel===void 0&&Z.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(E,L){const $=this.getLoggerEntry(E);$&&L!==!$.info.hidden&&($.info.hidden=!L,this._loggers.set($.info.resource,$),this._onDidChangeVisibility.fire([$.info.resource,L]))}getLogLevel(E){let L;return E&&(L=this._loggers.get(E)?.info.logLevel),L??this.logLevel}registerLogger(E){const L=this._loggers.get(E.resource);L?L.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this._loggers.set(E.resource,{info:E,logger:void 0}),this._onDidChangeLoggers.fire({added:[E],removed:[]}))}deregisterLogger(E){const L=this._loggers.get(E);L&&(L.logger&&L.logger.dispose(),this._loggers.delete(E),this._onDidChangeLoggers.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const E of this._loggers.values())yield E.info}getRegisteredLogger(E){return this._loggers.get(E)?.info}dispose(){this._loggers.forEach(E=>E.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=i;class r{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(E){}getLevel(){return I.Info}trace(E,...L){}debug(E,...L){}info(E,...L){}warn(E,...L){}error(E,...L){}critical(E,...L){}dispose(){}flush(){}}e.NullLogger=r;class n extends r{}e.NullLogService=n;function s(C){if(C.verbose)return I.Trace;if(typeof C.logLevel=="string"){const E=D(C.logLevel.toLowerCase());if(E!==void 0)return E}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function l(C){switch(C){case I.Trace:return"trace";case I.Debug:return"debug";case I.Info:return"info";case I.Warning:return"warn";case I.Error:return"error";case I.Off:return"off"}}e.LogLevelToString=l;function D(C){switch(C){case"trace":return I.Trace;case"debug":return I.Debug;case"info":return I.Info;case"warn":return I.Warning;case"error":return I.Error;case"critical":return I.Error;case"off":return I.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new R.RawContextKey("logLevel",l(I.Info))}),define(ne[121],se([0,1,19,8,9,4,2,16,62,6]),function(G,e,N,O,k,A,T,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class S extends T.Disposable{constructor(g,d){super(),this.logService=g,this.options=d,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(g,d){return d.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(g,d):this.watchNonRecursive(g,d)}watchUniversal(g,d){const w={path:this.toFilePath(g),excludes:d.excludes,includes:d.includes,recursive:d.recursive},I=(0,N.insert)(this.universalPathsToWatch,w);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{I(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(g=>(0,k.onUnexpectedError)(g))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(d=>this._onDidChangeFile.fire((0,u.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===c.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)})));const g=this.options?.watcher?.recursive?.usePolling;if(g===!0)for(const d of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const d of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(d)&&g.includes(d.path)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(g,d){const w={path:this.toFilePath(g),excludes:d.excludes,includes:d.includes,recursive:!1},I=(0,N.insert)(this.nonRecursivePathsToWatch,w);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{I(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(g=>(0,k.onUnexpectedError)(g))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(g=>this._onDidChangeFile.fire((0,u.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===c.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,y.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=S}),define(ne[122],se([0,1,19,8,14,20,4,42,65,2,46,15,123,17,41,99,12,61,6,9]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d,w,I,p,h,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends c.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(t,o){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${t}`);const i=new c.DisposableStore;return this.provider.set(t,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:o}),i.add(o.onDidChangeFile(r=>this._onDidFilesChange.fire(new p.FileChangesEvent(r,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&i.add(o.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),i.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:t}))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:o}),this.provider.delete(t),(0,c.dispose)(i)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(i){o.push(i)}}),!this.provider.has(t)&&await O.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,o){const i=this.provider.get(t.scheme);return!!(i&&i.capabilities&o)}listCapabilities(){return u.Iterable.map(this.provider,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async withProvider(t){if(!(0,d.isAbsolutePath)(t))throw new p.FileOperationError((0,I.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const o=this.provider.get(t.scheme);if(!o){const i=new b.ErrorNoTelemetry;throw i.message=(0,I.localize)(1,null,t.toString()),i}return o}async withReadProvider(t){const o=await this.withProvider(t);if((0,p.hasOpenReadWriteCloseCapability)(o)||(0,p.hasReadWriteCapability)(o)||(0,p.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const o=await this.withProvider(t);if((0,p.hasOpenReadWriteCloseCapability)(o)||(0,p.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.doResolveFile(t,o)}catch(i){throw(0,p.toFileSystemProviderErrorCode)(i)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,I.localize)(2,null,this.resourceForError(t)),1):(0,p.ensureFileSystemProviderError)(i)}}async doResolveFile(t,o){const i=await this.withProvider(t),r=this.isPathCaseSensitive(i),n=o?.resolveTo,s=o?.resolveSingleChildDescendants,l=o?.resolveMetadata,D=await i.stat(t);let C;return this.toFileStat(i,t,D,void 0,!!l,(E,L)=>(C||(C=S.TernarySearchTree.forUris(()=>!r),C.set(t,!0),n&&C.fill(!0,n)),C.get(E.resource)||C.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&s?L===1:!1))}async toFileStat(t,o,i,r,n,s){const{providerExtUri:l}=this.getExtUri(t),D={resource:o,name:l.basename(o),isFile:(i.type&p.FileType.File)!==0,isDirectory:(i.type&p.FileType.Directory)!==0,isSymbolicLink:(i.type&p.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&p.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((i.permissions??0)&p.FilePermission.Locked),etag:(0,p.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(D.isDirectory&&s(D,r)){try{const C=await t.readdir(o),E=await O.Promises.settled(C.map(async([L,$])=>{try{const Z=l.joinPath(o,L),Q=n?await t.stat(Z):{type:$};return await this.toFileStat(t,Z,Q,C.length,n,s)}catch(Z){return this.logService.trace(Z),null}}));D.children=(0,N.coalesce)(E)}catch(C){this.logService.trace(C),D.children=[]}return D}return D}async resolveAll(t){return O.Promises.settled(t.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.withProvider(t),i=await o.stat(t);return this.toFileStat(o,t,i,void 0,!0,()=>!1)}async exists(t){const o=await this.withProvider(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.doValidateCreateFile(t,o)}catch(i){return i}return!0}async doValidateCreateFile(t,o){if(!o?.overwrite&&await this.exists(t))throw new p.FileOperationError((0,I.localize)(3,null,this.resourceForError(t)),3,o)}async createFile(t,o=k.VSBuffer.fromString(""),i){await this.doValidateCreateFile(t,i);const r=await this.writeFile(t,o);return this._onDidRunOperation.fire(new p.FileOperationEvent(t,0,r)),r}async writeFile(t,o,i){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:n}=this.getExtUri(r);try{await this.validateWriteFile(r,t,i)||await this.mkdirp(r,n.dirname(t));let l;if((0,p.hasReadWriteCapability)(r)&&!(o instanceof k.VSBuffer))if((0,w.isReadableStream)(o)){const D=await(0,w.peekStream)(o,3);D.ended?l=k.VSBuffer.concat(D.buffer):l=D}else l=(0,w.peekReadable)(o,D=>k.VSBuffer.concat(D),3);else l=o;if(!(0,p.hasOpenReadWriteCloseCapability)(r)||(0,p.hasReadWriteCapability)(r)&&l instanceof k.VSBuffer)await this.doWriteUnbuffered(r,t,i,l);else{const D=l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l;i?.atomic!==!1&&i?.atomic?.postfix?await this.doWriteBufferedAtomic(r,t,(0,d.joinPath)((0,d.dirname)(t),`${(0,d.basename)(t)}${i.atomic.postfix}`),i,D):await this.doWriteBuffered(r,t,i,D)}this._onDidRunOperation.fire(new p.FileOperationEvent(t,4))}catch(s){throw new p.FileOperationError((0,I.localize)(4,null,this.resourceForError(t),(0,p.ensureFileSystemProviderError)(s).toString()),(0,p.toFileOperationResult)(s),i)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,o,i){const r=!!i?.unlock;if(r&&!(t.capabilities&8192))throw new Error((0,I.localize)(5,null,this.resourceForError(o)));if(!!i?.atomic){if(!(t.capabilities&32768))throw new Error((0,I.localize)(6,null,this.resourceForError(o)));if(r)throw new Error((0,I.localize)(7,null,this.resourceForError(o)))}let s;try{s=await t.stat(o)}catch{return}if(s.type&p.FileType.Directory)throw new p.FileOperationError((0,I.localize)(8,null,this.resourceForError(o)),0,i);if(this.throwIfFileIsReadonly(o,s),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==p.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&i.mtime<s.mtime&&i.etag!==(0,p.etag)({mtime:i.mtime,size:s.size}))throw new p.FileOperationError((0,I.localize)(9,null),3,i);return s}async readFile(t,o,i){const r=await this.withReadProvider(t);return o?.atomic?this.doReadFileAtomic(r,t,o,i):this.doReadFile(r,t,o,i)}async doReadFileAtomic(t,o,i,r){return new Promise((n,s)=>{this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(t,o,i,r);n(l)}catch(l){s(l)}})})}async doReadFile(t,o,i,r){const n=await this.doReadFileStream(t,o,{...i,preferUnbuffered:!0},r);return{...n,value:await(0,k.streamToBuffer)(n.value)}}async readFileStream(t,o,i){const r=await this.withReadProvider(t);return this.doReadFileStream(r,t,o,i)}async doReadFileStream(t,o,i,r){const n=new A.CancellationTokenSource(r),s=this.validateReadFile(o,i).then(D=>D,D=>{throw n.cancel(),D});let l;try{return typeof i?.etag=="string"&&i.etag!==p.ETAG_DISABLED&&await s,i?.atomic&&(0,p.hasFileAtomicReadCapability)(t)||!((0,p.hasOpenReadWriteCloseCapability)(t)||(0,p.hasFileReadStreamCapability)(t))||(0,p.hasReadWriteCapability)(t)&&i?.preferUnbuffered?l=this.readFileUnbuffered(t,o,i):(0,p.hasFileReadStreamCapability)(t)?l=this.readFileStreamed(t,o,n.token,i):l=this.readFileBuffered(t,o,n.token,i),{...await s,value:l}}catch(D){throw l&&await(0,w.consumeStream)(l),this.restoreReadError(D,o,i)}}restoreReadError(t,o,i){const r=(0,I.localize)(10,null,this.resourceForError(o),(0,p.ensureFileSystemProviderError)(t).toString());return t instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(r,t.stat,i):t instanceof p.TooLargeFileOperationError?new p.TooLargeFileOperationError(r,t.fileOperationResult,t.size,t.options):new p.FileOperationError(r,(0,p.toFileOperationResult)(t),i)}readFileStreamed(t,o,i,r=Object.create(null)){const n=t.readFileStream(o,r,i);return(0,w.transform)(n,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>this.restoreReadError(s,o,r)},s=>k.VSBuffer.concat(s))}readFileBuffered(t,o,i,r=Object.create(null)){const n=(0,k.newWriteableBufferStream)();return(0,h.readFileIntoStream)(t,o,n,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>this.restoreReadError(s,o,r)},i),n}readFileUnbuffered(t,o,i){const r=(0,w.newWriteableStream)(n=>k.VSBuffer.concat(n));return(async()=>{try{let n;i?.atomic&&(0,p.hasFileAtomicReadCapability)(t)?n=await t.readFile(o,{atomic:!0}):n=await t.readFile(o),typeof i?.position=="number"&&(n=n.slice(i.position)),typeof i?.length=="number"&&(n=n.slice(0,i.length)),this.validateReadFileLimits(o,n.byteLength,i),r.end(k.VSBuffer.wrap(n))}catch(n){r.error(n),r.end()}})(),r}async validateReadFile(t,o){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new p.FileOperationError((0,I.localize)(11,null,this.resourceForError(t)),0,o);if(typeof o?.etag=="string"&&o.etag!==p.ETAG_DISABLED&&o.etag===i.etag)throw new p.NotModifiedSinceFileOperationError((0,I.localize)(12,null),i,o);return this.validateReadFileLimits(t,i.size,o),i}validateReadFileLimits(t,o,i){if(typeof i?.limits?.size=="number"&&o>i.limits.size)throw new p.TooLargeFileOperationError((0,I.localize)(13,null,this.resourceForError(t)),7,o,i)}async canMove(t,o,i){return this.doCanMoveCopy(t,o,"move",i)}async canCopy(t,o,i){return this.doCanMoveCopy(t,o,"copy",i)}async doCanMoveCopy(t,o,i,r){if(t.toString()!==o.toString())try{const n=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(n,t,s,o,i,r)}catch(n){return n}return!0}async move(t,o,i){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(r,t,n,o,"move",!!i),l=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(t,s==="move"?2:3,l)),l}async copy(t,o,i){const r=await this.withReadProvider(t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(r,t,n,o,"copy",!!i),l=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(t,s==="copy"?3:2,l)),l}async doMoveCopy(t,o,i,r,n,s){if(o.toString()===r.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:D}=await this.doValidateMoveCopy(t,o,i,r,n,s);if(l&&!D&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(r)),n==="copy"){if(t===i&&(0,p.hasFileFolderCopyCapability)(t))await t.copy(o,r,{overwrite:s});else{const C=await this.resolve(o);C.isDirectory?await this.doCopyFolder(t,C,i,r):await this.doCopyFile(t,o,i,r)}return n}else return t===i?(await t.rename(o,r,{overwrite:s}),n):(await this.doMoveCopy(t,o,i,r,"copy",s),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(t,o,i,r){if((0,p.hasOpenReadWriteCloseCapability)(t)&&(0,p.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(t,o,i,r);if((0,p.hasOpenReadWriteCloseCapability)(t)&&(0,p.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(t,o,i,r);if((0,p.hasReadWriteCapability)(t)&&(0,p.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(t,o,i,r);if((0,p.hasReadWriteCapability)(t)&&(0,p.hasReadWriteCapability)(i))return this.doPipeUnbuffered(t,o,i,r)}async doCopyFolder(t,o,i,r){await i.mkdir(r),Array.isArray(o.children)&&await O.Promises.settled(o.children.map(async n=>{const s=this.getExtUri(i).providerExtUri.joinPath(r,n.name);return n.isDirectory?this.doCopyFolder(t,await this.resolve(n.resource),i,s):this.doCopyFile(t,n.resource,i,s)}))}async doValidateMoveCopy(t,o,i,r,n,s){let l=!1;if(t===i){const{providerExtUri:C,isPathCaseSensitive:E}=this.getExtUri(t);if(E||(l=C.isEqual(o,r)),l&&n==="copy")throw new Error((0,I.localize)(14,null,this.resourceForError(o),this.resourceForError(r)));if(!l&&C.isEqualOrParent(r,o))throw new Error((0,I.localize)(15,null,this.resourceForError(o),this.resourceForError(r)))}const D=await this.exists(r);if(D&&!l){if(!s)throw new p.FileOperationError((0,I.localize)(16,null,this.resourceForError(o),this.resourceForError(r)),4);if(t===i){const{providerExtUri:C}=this.getExtUri(t);if(C.isEqualOrParent(o,r))throw new Error((0,I.localize)(17,null,this.resourceForError(o),this.resourceForError(r)))}}return{exists:D,isSameResourceWithDifferentPathCase:l}}getExtUri(t){const o=this.isPathCaseSensitive(t);return{providerExtUri:o?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(o,t);const i=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(t,0,i)),i}async mkdirp(t,o){const i=[],{providerExtUri:r}=this.getExtUri(t);for(;!r.isEqual(o,r.dirname(o));)try{if(!((await t.stat(o)).type&p.FileType.Directory))throw new Error((0,I.localize)(18,null,this.resourceForError(o)));break}catch(n){if((0,p.toFileSystemProviderErrorCode)(n)!==p.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(r.basename(o)),o=r.dirname(o)}for(let n=i.length-1;n>=0;n--){o=r.joinPath(o,i[n]);try{await t.mkdir(o)}catch(s){if((0,p.toFileSystemProviderErrorCode)(s)!==p.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(t,o){try{await this.doValidateDelete(t,o)}catch(i){return i}return!0}async doValidateDelete(t,o){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),r=!!o?.useTrash;if(r&&!(i.capabilities&4096))throw new Error((0,I.localize)(19,null,this.resourceForError(t)));const n=o?.atomic;if(n&&!(i.capabilities&65536))throw new Error((0,I.localize)(20,null,this.resourceForError(t)));if(r&&n)throw new Error((0,I.localize)(21,null,this.resourceForError(t)));let s;try{s=await i.stat(t)}catch{}if(s)this.throwIfFileIsReadonly(t,s);else throw new p.FileOperationError((0,I.localize)(22,null,this.resourceForError(t)),1);if(!!!o?.recursive){const D=await this.resolve(t);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,I.localize)(23,null,this.resourceForError(t)))}return i}async del(t,o){const i=await this.doValidateDelete(t,o),r=!!o?.useTrash,n=!!o?.recursive,s=o?.atomic??!1;await i.delete(t,{recursive:n,useTrash:r,atomic:s}),this._onDidRunOperation.fire(new p.FileOperationEvent(t,1))}async cloneFile(t,o){const i=await this.withProvider(t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(i===r&&this.getExtUri(i).providerExtUri.isEqual(t,o))return;if(i===r&&(0,p.hasFileCloneCapability)(i))return i.cloneFile(t,o);await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(o));const n=this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri);return i===r&&(0,p.hasFileFolderCopyCapability)(i)?n.queue(()=>i.copy(t,o,{overwrite:!0})):n.queue(()=>this.doCopyFile(i,t,r,o))}watch(t,o={recursive:!1,excludes:[]}){const i=new c.DisposableStore;let r=!1,n=()=>{r=!0};return i.add((0,c.toDisposable)(()=>n())),(async()=>{try{const s=await this.doWatch(t,o);r?(0,c.dispose)(s):n=()=>(0,c.dispose)(s)}catch(s){this.logService.error(s)}})(),i}async doWatch(t,o){const i=await this.withProvider(t),r=(0,y.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(t),o]);let n=this.activeWatchers.get(r);return n||(n={count:0,disposable:i.watch(t,o)},this.activeWatchers.set(r,n)),n.count+=1,(0,c.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,c.dispose)(n.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,c.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBufferedAtomic(t,o,i,r,n){await this.doWriteBuffered(t,i,r,n);try{await t.rename(i,o,{overwrite:!0})}catch(s){try{await t.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw s}}async doWriteBuffered(t,o,i,r){return this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(async()=>{const n=await t.open(o,{create:!0,unlock:i?.unlock??!1});try{(0,w.isReadableStream)(r)||(0,w.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(t,n,r):await this.doWriteReadableBufferedQueued(t,n,r)}catch(s){throw(0,p.ensureFileSystemProviderError)(s)}finally{await t.close(n)}})}async doWriteStreamBufferedQueued(t,o,i){let r=0,n;if((0,w.isReadableBufferedStream)(i)){if(i.buffer.length>0){const s=k.VSBuffer.concat(i.buffer);await this.doWriteBuffer(t,o,s,s.byteLength,r,0),r+=s.byteLength}if(i.ended)return;n=i.stream}else n=i;return new Promise((s,l)=>{(0,w.listenStream)(n,{onData:async D=>{n.pause();try{await this.doWriteBuffer(t,o,D,D.byteLength,r,0)}catch(C){return l(C)}r+=D.byteLength,setTimeout(()=>n.resume())},onError:D=>l(D),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(t,o,i){let r=0,n;for(;(n=i.read())!==null;)await this.doWriteBuffer(t,o,n,n.byteLength,r,0),r+=n.byteLength}async doWriteBuffer(t,o,i,r,n,s){let l=0;for(;l<r;){const D=await t.write(o,n+l,i.buffer,s+l,r-l);l+=D}}async doWriteUnbuffered(t,o,i,r){return this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,o,i,r))}async doWriteUnbufferedQueued(t,o,i,r){let n;r instanceof k.VSBuffer?n=r:(0,w.isReadableStream)(r)?n=await(0,k.streamToBuffer)(r):(0,w.isReadableBufferedStream)(r)?n=await(0,k.bufferedStreamToBuffer)(r):n=(0,k.readableToBuffer)(r),await t.writeFile(o,n.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(t,o,i,r){return this.writeQueue.queueFor(r,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,o,i,r))}async doPipeBufferedQueued(t,o,i,r){let n,s;try{n=await t.open(o,{create:!1}),s=await i.open(r,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.BUFFER_SIZE);let D=0,C=0,E=0;do E=await t.read(n,D,l.buffer,C,l.byteLength-C),await this.doWriteBuffer(i,s,l,E,D,C),D+=E,C+=E,C===l.byteLength&&(C=0);while(E>0)}catch(l){throw(0,p.ensureFileSystemProviderError)(l)}finally{await O.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof s=="number"?i.close(s):Promise.resolve()])}}async doPipeUnbuffered(t,o,i,r){return this.writeQueue.queueFor(r,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,o,i,r))}async doPipeUnbufferedQueued(t,o,i,r){return i.writeFile(r,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,o,i,r){return this.writeQueue.queueFor(r,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,o,i,r))}async doPipeUnbufferedToBufferedQueued(t,o,i,r){const n=await i.open(r,{create:!0,unlock:!1});try{const s=await t.readFile(o);await this.doWriteBuffer(i,n,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,p.ensureFileSystemProviderError)(s)}finally{await i.close(n)}}async doPipeBufferedToUnbuffered(t,o,i,r){const n=await(0,k.streamToBuffer)(this.readFileBuffered(t,o,A.CancellationToken.None));await this.doWriteUnbuffered(i,r,void 0,n)}throwIfFileSystemIsReadonly(t,o){if(t.capabilities&2048)throw new p.FileOperationError((0,I.localize)(24,null,this.resourceForError(o)),6);return t}throwIfFileIsReadonly(t,o){if((o.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,I.localize)(25,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===R.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=v,e.FileService=v=pe([re(0,f.ILogService)],v)}),define(ne[124],se([0,1,125,169,8,35,14,4,170,2,16,13,17,41,24,101,12,61,121,33,119,118]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d,w,I,p,h,f,b,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(N)}catch(o){console.error(`Error enabling graceful-fs: ${(0,b.toErrorMessage)(o)}`)}})();class t extends f.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(i,r){super(i,r),this.onDidChangeCapabilities=y.Event.None,this.resourceLocks=new A.ResourceMap(n=>g.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:r,symbolicLink:n}=await w.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(r,n),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:p.FilePermission.Locked}}catch(r){throw this.toFileSystemProviderError(r)}}async statIgnoreError(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const r=await w.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),n=[];return await Promise.all(r.map(async s=>{try{let l;s.isSymbolicLink()?l=(await this.stat((0,g.joinPath)(i,s.name))).type:l=this.toType(s),n.push([s.name,l])}catch(l){this.logService.trace(l)}})),n}catch(r){throw this.toFileSystemProviderError(r)}}toType(i,r){let n;return r?.dangling?n=p.FileType.Unknown:i.isFile()?n=p.FileType.File:i.isDirectory()?n=p.FileType.Directory:n=p.FileType.Unknown,r&&(n|=p.FileType.SymbolicLink),n}async createResourceLock(i){const r=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let n;for(;n=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await n.wait();const s=new k.Barrier;return this.resourceLocks.set(i,s),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,c.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(i)===s&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),s.open()})}async readFile(i,r){let n;try{r?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),n=await this.createResourceLock(i));const s=this.toFilePath(i);return await w.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{n?.dispose()}}traceLock(i){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,r,n){const s=(0,d.newWriteableStream)(l=>T.VSBuffer.concat(l.map(D=>T.VSBuffer.wrap(D))).buffer);return(0,h.readFileIntoStream)(this,i,s,l=>l.buffer,{...r,bufferSize:256*1024},n),s}async writeFile(i,r,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.doWriteFileAtomic(i,(0,g.joinPath)((0,g.dirname)(i),`${(0,g.basename)(i)}${n.atomic.postfix}`),r,n):this.doWriteFile(i,r,n)}async doWriteFileAtomic(i,r,n,s){await this.doWriteFile(r,n,s);try{await this.rename(r,i,{overwrite:!0})}catch(l){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}async doWriteFile(i,r,n){let s;try{const l=this.toFilePath(i);if(!n.create||!n.overwrite){if(await w.Promises.exists(l)){if(!n.overwrite)throw(0,p.createFileSystemProviderError)((0,I.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,p.createFileSystemProviderError)((0,I.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:n.unlock}),await this.write(s,0,r,0,r.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof s=="number"&&await this.close(s)}}static{this.canFlush=!0}static configureFlushOnWrite(i){t.canFlush=i}async open(i,r){const n=this.toFilePath(i);let s;(0,p.isFileOpenForWriteOptions)(r)&&(s=await this.createResourceLock(i));let l;try{if((0,p.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:C}=await w.SymlinkSupport.stat(n);C.mode&128||await w.Promises.chmod(n,C.mode|128)}catch(C){C.code!=="ENOENT"&&this.logService.trace(C)}let D;if((0,p.isFileOpenForWriteOptions)(r)){if(R.isWindows)try{await w.Promises.truncate(n,0),D="r+"}catch(C){C.code!=="ENOENT"&&this.logService.trace(C)}D||(D="w")}else D="r";l=await w.Promises.open(n,D)}catch(D){throw s?.dispose(),(0,p.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(i,D):this.toFileSystemProviderError(D)}if(this.mapHandleToPos.set(l,0),(0,p.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(l,i),s){const D=this.mapHandleToLock.get(l);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${n})`),this.mapHandleToLock.set(l,s),D&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${n})`),D.dispose())}return l}async close(i){const r=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&t.canFlush)try{await w.Promises.fdatasync(i)}catch(n){t.configureFlushOnWrite(!1),this.logService.error(n)}return await w.Promises.close(i)}catch(n){throw this.toFileSystemProviderError(n)}finally{r&&(this.mapHandleToLock.get(i)===r&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,n,s,l){const D=this.normalizePos(i,r);let C=null;try{C=(await w.Promises.read(i,n,s,l,D)).bytesRead}catch(E){throw this.toFileSystemProviderError(E)}finally{this.updatePos(i,D,C)}return C}normalizePos(i,r){return r===this.mapHandleToPos.get(i)?null:r}updatePos(i,r,n){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof r=="number"||(typeof n=="number"?this.mapHandleToPos.set(i,s+n):this.mapHandleToPos.delete(i)))}async write(i,r,n,s,l){return(0,k.retry)(()=>this.doWrite(i,r,n,s,l),100,3)}async doWrite(i,r,n,s,l){const D=this.normalizePos(i,r);let C=null;try{C=(await w.Promises.write(i,n,s,l,D)).bytesWritten}catch(E){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),E)}finally{this.updatePos(i,D,C)}return C}async mkdir(i){try{await w.Promises.mkdir(this.toFilePath(i))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(i,r){try{const n=this.toFilePath(i);if(r.recursive){let s;r?.atomic!==!1&&r.atomic.postfix&&(s=(0,S.join)((0,S.dirname)(n),`${(0,S.basename)(n)}${r.atomic.postfix}`)),await w.Promises.rm(n,w.RimRafMode.MOVE,s)}else try{await w.Promises.unlink(n)}catch(s){if(s.code==="EPERM"||s.code==="EISDIR"){let l=!1;try{const{stat:D,symbolicLink:C}=await w.SymlinkSupport.stat(n);l=D.isDirectory()&&!C}catch{}if(l)await w.Promises.rmdir(n);else throw s}else throw s}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(i,r,n){const s=this.toFilePath(i),l=this.toFilePath(r);if(s!==l)try{await this.validateMoveCopy(i,r,"move",n.overwrite),await w.Promises.rename(s,l)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,I.localize)(2,null,(0,S.basename)(s),(0,S.basename)((0,S.dirname)(l)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(i,r,n){const s=this.toFilePath(i),l=this.toFilePath(r);if(s!==l)try{await this.validateMoveCopy(i,r,"copy",n.overwrite),await w.Promises.copy(s,l,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,I.localize)(3,null,(0,S.basename)(s),(0,S.basename)((0,S.dirname)(l)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(i,r,n,s){const l=this.toFilePath(i),D=this.toFilePath(r);let C=!1;if(!!(this.capabilities&1024)||(C=(0,u.isEqual)(l,D,!0)),C){if(n==="copy")throw(0,p.createFileSystemProviderError)((0,I.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const L=await this.statIgnoreError(i);if(!L)throw(0,p.createFileSystemProviderError)((0,I.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const $=await this.statIgnoreError(r);if($){if(!s)throw(0,p.createFileSystemProviderError)((0,I.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);L.type&p.FileType.File&&$.type&p.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,r){return this.doCloneFile(i,r,!1)}async doCloneFile(i,r,n){const s=this.toFilePath(i),l=this.toFilePath(r),D=!!(this.capabilities&1024);if((0,u.isEqual)(s,l,!D))return;const C=new c.DisposableStore;try{const[E,L]=await Promise.all([this.createResourceLock(i),this.createResourceLock(r)]);C.add(E),C.add(L),n&&await w.Promises.mkdir((0,S.dirname)(l),{recursive:!0}),await w.Promises.copyFile(s,l)}catch(E){if(E.code==="ENOENT"&&!n)return this.doCloneFile(i,r,!0);throw this.toFileSystemProviderError(E)}finally{C.dispose()}}createUniversalWatcher(i,r,n){return new v.UniversalWatcherClient(s=>i(s),s=>r(s),n)}createNonRecursiveWatcher(i,r,n){return new P.NodeJSWatcherClient(s=>i(s),s=>r(s),n)}toFileSystemProviderError(i){if(i instanceof p.FileSystemProviderError)return i;let r=i,n;switch(i.code){case"ENOENT":n=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=p.FileSystemProviderErrorCode.Unknown;break;default:n=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(r,n)}async toFileSystemProviderWriteError(i,r){let n=this.toFileSystemProviderError(r);if(i&&n.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await w.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(n=(0,p.createFileSystemProviderError)(r,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return n}}e.DiskFileSystemProvider=t}),define(ne[126],se([0,1,2,6]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class k extends N.Disposable{constructor(T,y=[]){super(),this.logger=new O.MultiplexLogger([T,...y]),this._register(T.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...y){this.logger.trace(T,...y)}debug(T,...y){this.logger.debug(T,...y)}info(T,...y){this.logger.info(T,...y)}warn(T,...y){this.logger.warn(T,...y)}error(T,...y){this.logger.error(T,...y)}flush(){this.logger.flush()}}e.LogService=k}),define(ne[127],se([0,1,12,6]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(k||(k={}));async function A(c,S,R,g,d){try{const w=await new Promise((p,h)=>{G(["@vscode/spdlog"],p,h)});w.setFlushOn(k.Trace);const I=await w.createAsyncRotatingLogger(c,S,R,g);return d?I.clearFormatters():I.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),I}catch(w){console.error(w)}return null}function T(c,S,R){switch(S){case O.LogLevel.Trace:c.trace(R);break;case O.LogLevel.Debug:c.debug(R);break;case O.LogLevel.Info:c.info(R);break;case O.LogLevel.Warning:c.warn(R);break;case O.LogLevel.Error:c.error(R);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function y(c,S){switch(S){case O.LogLevel.Trace:c.setLevel(k.Trace);break;case O.LogLevel.Debug:c.setLevel(k.Debug);break;case O.LogLevel.Info:c.setLevel(k.Info);break;case O.LogLevel.Warning:c.setLevel(k.Warning);break;case O.LogLevel.Error:c.setLevel(k.Error);break;case O.LogLevel.Off:c.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${S}`)}}class u extends O.AbstractMessageLogger{constructor(S,R,g,d,w){super(),this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(S,R,g,d),this._register(this.onDidChangeLogLevel(I=>{this._logger&&y(this._logger,I)}))}async _createSpdLogLogger(S,R,g,d){const w=g?6:1,I=30/w*N.ByteSize.MB,p=await A(S,R,I,w,d);if(p){this._logger=p,y(this._logger,this.getLevel());for(const{level:h,message:f}of this.buffer)T(this._logger,h,f);this.buffer=[]}}log(S,R){this._logger?T(this._logger,S,R):this.getLevel()<=S&&this.buffer.push({level:S,message:R})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=u}),define(ne[128],se([0,1,28,6,127]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends O.AbstractLoggerService{doCreateLogger(y,u,c){return new k.SpdLogLogger((0,N.generateUuid)(),y.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.LoggerService=A}),define(ne[38],se([0,1,4,65,2,10]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class T extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new N.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(c){const S=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...c,...this.policyDefinitions},S!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(c),O.Iterable.reduce(this.policies.entries(),(R,[g,d])=>({...R,[g]:d}),{})}getPolicyValue(c){return this.policies.get(c)}serialize(){return O.Iterable.reduce(Object.entries(this.policyDefinitions),(c,[S,R])=>({...c,[S]:{definition:R,value:this.policies.get(S)}}),{})}}e.AbstractPolicyService=T;class y{constructor(){this.onDidChange=N.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=y}),define(ne[129],se([0,1,8,4,65,3,12,6,38]),function(G,e,N,O,k,A,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(R,g){const d=[];for(const w of new Set(k.Iterable.concat(R.keys(),g.keys())))R.get(w)!==g.get(w)&&d.push(w);return d}let S=class extends u.AbstractPolicyService{constructor(g,d,w){super(),this.file=g,this.fileService=d,this.logService=w,this.throttledDelayer=this._register(new N.ThrottledDelayer(500));const I=O.Event.filter(d.onDidFilesChange,p=>p.affects(g));this._register(d.watch(g)),this._register(I(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const g=new Map;try{const d=await this.fileService.readFile(this.file),w=JSON.parse(d.value.toString());if(!(0,A.isObject)(w))throw new Error("Policy file isn't a JSON object");for(const I of Object.keys(w))this.policyDefinitions[I]&&g.set(I,w[I])}catch(d){d.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",d)}return g}async refresh(){const g=await this.read(),d=c(this.policies,g);this.policies=g,d.length>0&&this._onDidChange.fire(d)}};e.FilePolicyService=S,e.FilePolicyService=S=pe([re(1,T.IFileService),re(2,y.ILogService)],S)}),define(ne[130],se([0,1,38,8,171,2,6]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let y=class extends N.AbstractPolicyService{constructor(c,S){super(),this.logService=c,this.productName=S,this.throttler=new O.Throttler,this.watcher=this._register(new A.MutableDisposable)}async _updatePolicyDefinitions(c){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.throttler.queue(()=>new Promise((S,R)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,c,g=>{this._onDidPolicyChange(g),S()})}catch(g){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),R(g)}}))}_onDidPolicyChange(c){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const S in c){const R=c[S];R===void 0?this.policies.delete(S):this.policies.set(S,R)}this._onDidChange.fire(Object.keys(c))}};e.NativePolicyService=y,e.NativePolicyService=y=pe([re(0,T.ILogService)],y)}),define(ne[31],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,N.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[36],se([0,1,71,3]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,y){N.ok(O.isString(T)),N.ok(O.isObject(y)),N.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,y)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(ne[131],se([0,1,4,36]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class A{constructor(){this._onDidChangeSchema=new N.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,c){this.schemasById[k(u)]=c,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;O.Registry.add(e.Extensions.JSONContribution,T)}),define(ne[44],se([0,1,19,4,3,88,25,131,36]),function(G,e,N,O,k,A,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=u.Registry.as(y.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const i=new Set;this.doRegisterConfigurations(t,o,i),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const o=new Set;this.doDeregisterConfigurations(t,o),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:t,remove:o}){const i=new Set;this.doDeregisterConfigurations(o,i),this.doRegisterConfigurations(t,!1,i),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}registerDefaultConfigurations(t){const o=new Set;this.doRegisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,o){const i=[];for(const{overrides:r,source:n}of t)for(const s in r)if(o.add(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const l=this.configurationDefaultsOverrides.get(s),D=l?.valuesSources??new Map;if(n)for(const $ of Object.keys(r[s]))D.set($,n);const C={...l?.value||{},...r[s]};this.configurationDefaultsOverrides.set(s,{source:n,value:C,valuesSources:D});const E=(0,T.getLanguageTagSettingPlainKey)(s),L={type:"object",default:C,description:A.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:C,source:k.isString(n)?void 0:n,defaultValueSource:n};i.push(...I(s)),this.configurationProperties[s]=L,this.defaultLanguageConfigurationOverridesNode.properties[s]=L}else{this.configurationDefaultsOverrides.set(s,{value:r[s],source:n});const l=this.configurationProperties[s];l&&(this.updatePropertyDefaultValue(s,l),this.updateSchema(s,l))}this.doRegisterOverrideIdentifiers(i)}deregisterDefaultConfigurations(t){const o=new Set;this.doDeregisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,o){for(const{overrides:i,source:r}of t)for(const n in i){const s=this.configurationDefaultsOverrides.get(n),l=k.isString(r)?r:r?.id,D=k.isString(s?.source)?s?.source:s?.source?.id;if(l===D)if(o.add(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const C=this.configurationProperties[n];C&&(this.updatePropertyDefaultValue(n,C),this.updateSchema(n,C))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let o=!1;const i=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,i),o=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,i),o=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,i),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const o of t)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,o,i){t.forEach(r=>{this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties,void 0,i),this.configurationContributors.push(r),this.registerJSONConfiguration(r)})}doDeregisterConfigurations(t,o){const i=r=>{if(r.properties)for(const n in r.properties){o.add(n);const s=this.configurationProperties[n];s?.policy?.name&&this.policyConfigurations.delete(s.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,r.properties[n])}r.allOf?.forEach(n=>i(n))};for(const r of t){i(r);const n=this.configurationContributors.indexOf(r);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(t,o=!0,i,r,n=3,s){n=k.isUndefinedOrNull(t.scope)?n:t.scope;const l=t.properties;if(l)for(const C in l){const E=l[C];if(o&&b(C,E)){delete l[C];continue}if(E.source=i,E.defaultDefaultValue=l[C].default,this.updatePropertyDefaultValue(C,E),e.OVERRIDE_PROPERTY_REGEX.test(C)?E.scope=void 0:(E.scope=k.isUndefinedOrNull(E.scope)?n:E.scope,E.restricted=k.isUndefinedOrNull(E.restricted)?!!r?.includes(C):E.restricted),l[C].hasOwnProperty("included")&&!l[C].included){this.excludedConfigurationProperties[C]=l[C],delete l[C];continue}else this.configurationProperties[C]=l[C],l[C].policy?.name&&this.policyConfigurations.set(l[C].policy.name,C);!l[C].deprecationMessage&&l[C].markdownDeprecationMessage&&(l[C].deprecationMessage=l[C].markdownDeprecationMessage),s.add(C)}const D=t.allOf;if(D)for(const C of D)this.validateAndRegisterProperties(C,o,i,r,n,s)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const o=i=>{const r=i.properties;if(r)for(const s in r)this.updateSchema(s,r[s]);i.allOf?.forEach(o)};o(t)}updateSchema(t,o){switch(e.allSettings.properties[t]=o,o.scope){case 1:e.applicationSettings.properties[t]=o;break;case 2:e.machineSettings.properties[t]=o;break;case 6:e.machineOverridableSettings.properties[t]=o;break;case 3:e.windowSettings.properties[t]=o;break;case 4:e.resourceSettings.properties[t]=o;break;case 5:e.resourceSettings.properties[t]=o,this.resourceLanguageSettingsSchema.properties[t]=o;break}}removeFromSchema(t,o){switch(delete e.allSettings.properties[t],o.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const o=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,i),e.allSettings.properties[o]=i,e.applicationSettings.properties[o]=i,e.machineSettings.properties[o]=i,e.machineOverridableSettings.properties[o]=i,e.windowSettings.properties[o]=i,e.resourceSettings.properties[o]=i}}registerOverridePropertyPatternKey(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,o){const i=this.configurationDefaultsOverrides.get(t);let r=i?.value,n=i?.source;k.isUndefined(r)&&(r=o.defaultDefaultValue,n=void 0),k.isUndefined(r)&&(r=h(o.type)),o.default=r,o.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",w=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function I(P){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(P)){let o=w.exec(P);for(;o?.length;){const i=o[1].trim();i&&t.push(i),o=w.exec(P)}}return(0,N.distinct)(t)}e.overrideIdentifiersFromKey=I;function p(P){return P.reduce((t,o)=>`${t}[${o}]`,"")}e.keyFromOverrideIdentifiers=p;function h(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const f=new g;u.Registry.add(e.Extensions.Configuration,f);function b(P,t){return P.trim()?e.OVERRIDE_PROPERTY_REGEX.test(P)?A.localize(7,null,P):f.getConfigurationProperties()[P]!==void 0?A.localize(8,null,P):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,P,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=b;function v(){const P=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))P.push([o,t[o].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=v}),define(ne[66],se([0,1,19,4,53,2,35,30,3,11,25,44,36]),function(G,e,N,O,k,A,T,y,u,c,S,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(o){return Object.isFrozen(o)?o:y.deepFreeze(o)}class w{constructor(i={},r=[],n=[],s){this._contents=i,this._keys=r,this._overrides=n,this.raw=s,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(r=>{if(r instanceof w)return r;const n=new I("");return n.parseRaw(r),n.configurationModel});this._rawConfiguration=i.reduce((r,n)=>n===r?n:r.merge(n),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,S.getConfigurationValue)(this.contents,i):this.contents}inspect(i,r){const n=this.rawConfiguration.getValue(i),s=r?this.rawConfiguration.getOverrideValue(i,r):void 0,l=r?this.rawConfiguration.override(r).getValue(i):n;return{value:n,override:s,merged:l}}getOverrideValue(i,r){const n=this.getContentsForOverrideIdentifer(r);return n?i?(0,S.getConfigurationValue)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const r=[];for(const n of this.overrides)n.identifiers.includes(i)&&r.push(...n.keys);return N.distinct(r)}getAllOverrideIdentifiers(){const i=[];for(const r of this.overrides)i.push(...r.identifiers);return N.distinct(i)}override(i){let r=this.overrideConfigurations.get(i);return r||(r=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,r)),r}merge(...i){const r=y.deepClone(this.contents),n=y.deepClone(this.overrides),s=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const D of i)if(l.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(r,D.contents);for(const C of D.overrides){const[E]=n.filter(L=>N.equals(L.identifiers,C.identifiers));E?(this.mergeContents(E.contents,C.contents),E.keys.push(...C.keys),E.keys=N.distinct(E.keys)):n.push(y.deepClone(C))}for(const C of D.keys)s.indexOf(C)===-1&&s.push(C)}return new w(r,s,n,l.every(D=>D instanceof w)?void 0:l)}createOverrideConfigurationModel(i){const r=this.getContentsForOverrideIdentifer(i);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const n={};for(const s of N.distinct([...Object.keys(this.contents),...Object.keys(r)])){let l=this.contents[s];const D=r[s];D&&(typeof l=="object"&&typeof D=="object"?(l=y.deepClone(l),this.mergeContents(l,D)):l=D),n[s]=l}return new w(n,this.keys,this.overrides)}mergeContents(i,r){for(const n of Object.keys(r)){if(n in i&&u.isObject(i[n])&&u.isObject(r[n])){this.mergeContents(i[n],r[n]);continue}i[n]=y.deepClone(r[n])}}getContentsForOverrideIdentifer(i){let r=null,n=null;const s=l=>{l&&(n?this.mergeContents(n,l):n=y.deepClone(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===i?r=l.contents:l.identifiers.includes(i)&&s(l.contents);return s(r),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,r){this.updateValue(i,r,!0)}setValue(i,r){this.updateValue(i,r,!1)}removeValue(i){const r=this.keys.indexOf(i);r!==-1&&(this.keys.splice(r,1),(0,S.removeFromValueTree)(this.contents,i),R.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(n=>N.equals(n.identifiers,(0,R.overrideIdentifiersFromKey)(i))),1))}updateValue(i,r,n){(0,S.addToValueTree)(this.contents,i,r,s=>console.error(s)),n=n||this.keys.indexOf(i)===-1,n&&this.keys.push(i),R.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,R.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,S.toValuesTree)(this.contents[i],s=>console.error(s))})}}e.ConfigurationModel=w;class I{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,r){if(!u.isUndefinedOrNull(i)){const n=this.doParseContent(i);this.parseRaw(n,r)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,r){this._raw=i;const{contents:n,keys:s,overrides:l,restricted:D,hasExcludedProperties:C}=this.doParseRaw(i,r);this._configurationModel=new w(n,s,l,C?[i]:void 0),this._restrictedConfigurations=D||[]}doParseContent(i){let r={},n=null,s=[];const l=[],D=[];function C(L){Array.isArray(s)?s.push(L):n!==null&&(s[n]=L)}const E={onObjectBegin:()=>{const L={};C(L),l.push(s),s=L,n=null},onObjectProperty:L=>{n=L},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const L=[];C(L),l.push(s),s=L,n=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:C,onError:(L,$,Z)=>{D.push({error:L,offset:$,length:Z})}};if(i)try{k.visit(i,E),r=s[0]||{}}catch(L){console.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return r}doParseRaw(i,r){const n=g.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,n,!0,r);i=s.raw;const l=(0,S.toValuesTree)(i,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),D=Object.keys(i),C=this.toOverrides(i,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:l,keys:D,overrides:C,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}filter(i,r,n,s){let l=!1;if(!s?.scopes&&!s?.skipRestricted&&!s?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:l};const D={},C=[];for(const E in i)if(R.OVERRIDE_PROPERTY_REGEX.test(E)&&n){const L=this.filter(i[E],r,!1,s);D[E]=L.raw,l=l||L.hasExcludedProperties,C.push(...L.restricted)}else{const L=r[E],$=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&C.push(E),!s.exclude?.includes(E)&&(s.include?.includes(E)||($===void 0||s.scopes===void 0||s.scopes.includes($))&&!(s.skipRestricted&&L?.restricted))?D[E]=i[E]:l=!0}return{raw:D,restricted:C,hasExcludedProperties:l}}toOverrides(i,r){const n=[];for(const s of Object.keys(i))if(R.OVERRIDE_PROPERTY_REGEX.test(s)){const l={};for(const D in i[s])l[D]=i[s][D];n.push({identifiers:(0,R.overrideIdentifiersFromKey)(s),keys:Object.keys(l),contents:(0,S.toValuesTree)(l,r)})}return n}}e.ConfigurationModelParser=I;class p extends A.Disposable{constructor(i,r,n,s){super(),this.userSettingsResource=i,this.parseOptions=r,this.fileService=s,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new I(this.userSettingsResource.toString()),this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new w}}reparse(i){return i&&(this.parseOptions=i),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class h{constructor(i,r,n,s,l,D,C,E,L,$,Z,Q,ce){this.key=i,this.overrides=r,this._value=n,this.overrideIdentifiers=s,this.defaultConfiguration=l,this.policyConfiguration=D,this.applicationConfiguration=C,this.userConfiguration=E,this.localUserConfiguration=L,this.remoteUserConfiguration=$,this.workspaceConfiguration=Z,this.folderConfigurationModel=Q,this.memoryConfigurationModel=ce}get value(){return d(this._value)}inspect(i,r,n){const s=i.inspect(r,n);return{get value(){return d(s.value)},get override(){return d(s.override)},get merged(){return d(s.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class f{constructor(i,r,n,s,l=new w,D=new w,C=new T.ResourceMap,E=new w,L=new T.ResourceMap){this._defaultConfiguration=i,this._policyConfiguration=r,this._applicationConfiguration=n,this._localUserConfiguration=s,this._remoteUserConfiguration=l,this._workspaceConfiguration=D,this._folderConfigurations=C,this._memoryConfiguration=E,this._memoryConfigurationByResource=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,r,n){return this.getConsolidatedConfigurationModel(i,r,n).getValue(i)}updateValue(i,r,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new w,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,r===void 0?s.removeValue(i):s.setValue(i,r),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,r,n){const s=this.getConsolidatedConfigurationModel(i,r,n),l=this.getFolderConfigurationModelForResource(r.resource,n),D=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,C=new Set;for(const E of s.overrides)for(const L of E.identifiers)s.getOverrideValue(i,L)!==void 0&&C.add(L);return new h(i,r,s.getValue(i),C.size?[...C]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this._workspaceConfiguration:void 0,l||void 0,D)}keys(i){const r=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:r?r.keys.slice(0):[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,r){this._folderConfigurations.set(i,r),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,r){const n=[];if(!r){const{added:s,updated:l,removed:D}=P(this._defaultConfiguration,i);r=[...s,...l,...D]}for(const s of r)for(const l of(0,R.overrideIdentifiersFromKey)(s)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(l),C=i.getKeysForOverrideIdentifier(l),E=[...C.filter(L=>D.indexOf(L)===-1),...D.filter(L=>C.indexOf(L)===-1),...D.filter(L=>!y.equals(this._defaultConfiguration.override(l).getValue(L),i.override(l).getValue(L)))];n.push([l,E])}return this.updateDefaultConfiguration(i),{keys:r,overrides:n}}compareAndUpdatePolicyConfiguration(i){const{added:r,updated:n,removed:s}=P(this._policyConfiguration,i),l=[...r,...n,...s];return l.length&&this.updatePolicyConfiguration(i),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:r,updated:n,removed:s,overrides:l}=P(this.applicationConfiguration,i),D=[...r,...n,...s];return D.length&&this.updateApplicationConfiguration(i),{keys:D,overrides:l}}compareAndUpdateLocalUserConfiguration(i){const{added:r,updated:n,removed:s,overrides:l}=P(this.localUserConfiguration,i),D=[...r,...n,...s];return D.length&&this.updateLocalUserConfiguration(i),{keys:D,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:r,updated:n,removed:s,overrides:l}=P(this.remoteUserConfiguration,i),D=[...r,...n,...s];return D.length&&this.updateRemoteUserConfiguration(i),{keys:D,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:r,updated:n,removed:s,overrides:l}=P(this.workspaceConfiguration,i),D=[...r,...n,...s];return D.length&&this.updateWorkspaceConfiguration(i),{keys:D,overrides:l}}compareAndUpdateFolderConfiguration(i,r){const n=this.folderConfigurations.get(i),{added:s,updated:l,removed:D,overrides:C}=P(n,r),E=[...s,...l,...D];return(E.length||!n)&&this.updateFolderConfiguration(i,r),{keys:E,overrides:C}}compareAndDeleteFolderConfiguration(i){const r=this.folderConfigurations.get(i);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:s,removed:l,overrides:D}=P(r,void 0);return{keys:[...n,...s,...l],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,r,n){let s=this.getConsolidatedConfigurationModelForResource(r,n);return r.overrideIdentifier&&(s=s.override(r.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(s=s.merge(this._policyConfiguration)),s}getConsolidatedConfigurationModelForResource({resource:i},r){let n=this.getWorkspaceConsolidatedConfiguration();if(r&&i){const s=r.getFolder(i);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const l=this._memoryConfigurationByResource.get(i);l&&(n=n.merge(l))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let r=this._foldersConsolidatedConfigurations.get(i);if(!r){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(r=n.merge(s),this._foldersConsolidatedConfigurations.set(i,r)):r=n}return r}getFolderConfigurationModelForResource(i,r){if(r&&i){const n=r.getFolder(i);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,r)=>{const{contents:n,overrides:s,keys:l}=this._folderConfigurations.get(r);return i.push([r,{contents:n,overrides:s,keys:l}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.keys.forEach(r=>i.add(r)),this.userConfiguration.keys.forEach(r=>i.add(r)),this._workspaceConfiguration.keys.forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.keys.forEach(n=>i.add(n))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.userConfiguration.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>r.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>r.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(s=>r.add(s))),[...r.values()]}static parse(i){const r=this.parseConfigurationModel(i.defaults),n=this.parseConfigurationModel(i.policy),s=this.parseConfigurationModel(i.application),l=this.parseConfigurationModel(i.user),D=this.parseConfigurationModel(i.workspace),C=i.folders.reduce((E,L)=>(E.set(c.URI.revive(L[0]),this.parseConfigurationModel(L[1])),E),new T.ResourceMap);return new f(r,n,s,l,new w,D,C,new w,new T.ResourceMap)}static parseConfigurationModel(i){return new w(i.contents,i.keys,i.overrides)}}e.Configuration=f;function b(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const i=new Set,r=new Map;for(const s of o)s.keys.forEach(l=>i.add(l)),s.overrides.forEach(([l,D])=>{const C=(0,T.getOrSet)(r,l,new Set);D.forEach(E=>C.add(E))});const n=[];return r.forEach((s,l)=>n.push([l,[...s.values()]])),{keys:[...i.values()],overrides:n}}e.mergeChanges=b;class v{constructor(i,r,n,s){this.change=i,this.previous=r,this.currentConfiguraiton=n,this.currentWorkspace=s,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const l of i.keys)this.affectedKeys.add(l);for(const[,l]of i.overrides)for(const D of l)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const l of this.affectedKeys)this._affectsConfigStr+=l+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,r){const n=this._marker+i,s=this._affectsConfigStr.indexOf(n);if(s<0)return!1;const l=s+n.length;if(l>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(l);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(r){const C=this.previousConfiguration?this.previousConfiguration.getValue(i,r,this.previous?.workspace):void 0,E=this.currentConfiguraiton.getValue(i,r,this.currentWorkspace);return!y.equals(C,E)}return!0}}e.ConfigurationChangeEvent=v;function P(o,i){const{added:r,removed:n,updated:s}=t(i?.rawConfiguration,o?.rawConfiguration),l=[],D=o?.getAllOverrideIdentifiers()||[],C=i?.getAllOverrideIdentifiers()||[];if(i){const E=C.filter(L=>!D.includes(L));for(const L of E)l.push([L,i.getKeysForOverrideIdentifier(L)])}if(o){const E=D.filter(L=>!C.includes(L));for(const L of E)l.push([L,o.getKeysForOverrideIdentifier(L)])}if(i&&o){for(const E of D)if(C.includes(E)){const L=t({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});l.push([E,[...L.added,...L.removed,...L.updated]])}}return{added:r,removed:n,updated:s,overrides:l}}function t(o,i){const r=o?i?o.keys.filter(l=>i.keys.indexOf(l)===-1):[...o.keys]:[],n=i?o?i.keys.filter(l=>o.keys.indexOf(l)===-1):[...i.keys]:[],s=[];if(o&&i){for(const l of i.keys)if(o.keys.indexOf(l)!==-1){const D=(0,S.getConfigurationValue)(i.contents,l),C=(0,S.getConfigurationValue)(o.contents,l);y.equals(D,C)||s.push(l)}}return{added:r,removed:n,updated:s}}}),define(ne[132],se([0,1,19,4,2,30,3,66,44,6,38,36]),function(G,e,N,O,k,A,T,y,u,c,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class g extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new y.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(R.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:h})=>this.onDidUpdateConfiguration(Array.from(p),h))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(p,h){this.updateConfigurationModel(p,R.Registry.as(u.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:p})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new y.ConfigurationModel;const p=R.Registry.as(u.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(p),p)}updateConfigurationModel(p,h){const f=this.getConfigurationDefaultOverrides();for(const b of p){const v=f[b],P=h[b];v!==void 0?this._configurationModel.addValue(b,v):P?this._configurationModel.addValue(b,P.default):this._configurationModel.removeValue(b)}}}e.DefaultConfiguration=g;class d{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new y.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let w=class extends k.Disposable{get configurationModel(){return this._configurationModel}constructor(p,h,f){super(),this.defaultConfiguration=p,this.policyService=h,this.logService=f,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new y.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(p=>this.onDidChangePolicies(p))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:p})=>this.update(await this.updatePolicyDefinitions(p),!0))),this._configurationModel}async updatePolicyDefinitions(p){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",p);const h={},f=[],b=R.Registry.as(u.Extensions.Configuration).getConfigurationProperties();for(const v of p){const P=b[v];if(!P){f.push(v);continue}if(P.policy){if(P.type!=="string"&&P.type!=="number"){this.logService.warn(`Policy ${P.policy.name} has unsupported type ${P.type}`);continue}f.push(v),h[P.policy.name]={type:P.type}}}return(0,T.isEmptyObject)(h)||await this.policyService.updatePolicyDefinitions(h),f}onDidChangePolicies(p){this.logService.trace("PolicyConfiguration#onDidChangePolicies",p);const h=R.Registry.as(u.Extensions.Configuration).getPolicyConfigurations(),f=(0,N.coalesce)(p.map(b=>h.get(b)));this.update(f,!0)}update(p,h){this.logService.trace("PolicyConfiguration#update",p);const f=R.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),b=[],v=this._configurationModel.isEmpty();for(const P of p){const t=f[P]?.policy?.name;if(t){const o=this.policyService.getPolicyValue(t);(v?o!==void 0:!(0,A.equals)(this._configurationModel.getValue(P),o))&&b.push([P,o])}else this._configurationModel.getValue(P)!==void 0&&b.push([P,void 0])}if(b.length){this.logService.trace("PolicyConfiguration#changed",b);const P=this._configurationModel;this._configurationModel=new y.ConfigurationModel;for(const t of P.keys)this._configurationModel.setValue(t,P.getValue(t));for(const[t,o]of b)o===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,o);h&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=w,e.PolicyConfiguration=w=pe([re(1,S.IPolicyService),re(2,c.ILogService)],w)}),define(ne[133],se([0,1,8,4,2,17,25,66,132,38]),function(G,e,N,O,k,A,T,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class S extends k.Disposable{constructor(g,d,w,I){super(),this.settingsResource=g,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new u.DefaultConfiguration),this.policyConfiguration=w instanceof c.NullPolicyService?new u.NullPolicyConfiguration:this._register(new u.PolicyConfiguration(this.defaultConfiguration,w,I)),this.userConfiguration=this._register(new y.UserSettings(this.settingsResource,{},A.extUriBiasedIgnorePathCase,d)),this.configuration=new y.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new y.ConfigurationModel,new y.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new N.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:p,properties:h})=>this.onDidDefaultConfigurationChange(p,h))),this._register(this.policyConfiguration.onDidChangeConfiguration(p=>this.onDidPolicyConfigurationChange(p))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[g,d,w]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new y.Configuration(g,d,new y.ConfigurationModel,w)}getConfigurationData(){return this.configuration.toData()}getValue(g,d){const w=typeof g=="string"?g:void 0,I=(0,T.isConfigurationOverrides)(g)?g:(0,T.isConfigurationOverrides)(d)?d:{};return this.configuration.getValue(w,I,void 0)}updateValue(g,d,w,I){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const d=this.configuration.toData(),w=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(w,d,2)}onDidDefaultConfigurationChange(g,d){const w=this.configuration.toData(),I=this.configuration.compareAndUpdateDefaultConfiguration(g,d);this.trigger(I,w,7)}onDidPolicyConfigurationChange(g){const d=this.configuration.toData(),w=this.configuration.compareAndUpdatePolicyConfiguration(g);this.trigger(w,d,7)}trigger(g,d,w){const I=new y.ConfigurationChangeEvent(g,{data:d},this.configuration);I.source=w,I.sourceConfig=this.getTargetConfiguration(w),this._onDidChangeConfiguration.fire(I)}getTargetConfiguration(g){switch(g){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=S}),define(ne[67],se([0,1,15]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(c){return c.scheme===N.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=O;function k(c){if(!c)return;const S=c.indexOf("+");return S<0?c:c.substr(0,S)}e.getRemoteName=k;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=A;function T(c){const{host:S,port:R}=u(c);if(typeof R>"u")throw new Error("Remote authority doesn't contain a port!");return{host:S,port:R}}e.parseAuthorityWithPort=T;function y(c,S){let{host:R,port:g}=u(c);return typeof g>"u"&&(g=S),{host:R,port:g}}e.parseAuthorityWithOptionalPort=y;function u(c){const S=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const R=c.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const g=c.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:c,port:void 0}}}),define(ne[37],se([0,1,29,10,67]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(I){if(typeof I=="object"&&I!==null&&I.supported!==!0)return I.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(I){I[I.System=0]="System",I[I.User=1]="User"})(T||(e.ExtensionType=T={}));var y;(function(I){I.WIN32_X64="win32-x64",I.WIN32_IA32="win32-ia32",I.WIN32_ARM64="win32-arm64",I.LINUX_X64="linux-x64",I.LINUX_ARM64="linux-arm64",I.LINUX_ARMHF="linux-armhf",I.LINUX_PPC64LE="linux-ppc64le",I.ALPINE_X64="alpine-x64",I.ALPINE_ARM64="alpine-arm64",I.DARWIN_X64="darwin-x64",I.DARWIN_ARM64="darwin-arm64",I.WEB="web",I.UNIVERSAL="universal",I.UNKNOWN="unknown",I.UNDEFINED="undefined"})(y||(e.TargetPlatform=y={}));class u{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p>"u"||p===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){const f=typeof p=="string"?p:p.value,b=typeof h=="string"?h:h.value;return N.equalsIgnoreCase(f,b)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=u;class c{get size(){return this._set.size}constructor(p){if(this._set=new Set,p)for(const h of p)this.add(h)}add(p){this._set.add(u.toKey(p))}delete(p){return this._set.delete(u.toKey(p))}has(p){return this._set.has(u.toKey(p))}}e.ExtensionIdentifierSet=c;class S{constructor(){this._map=new Map}clear(){this._map.clear()}delete(p){this._map.delete(u.toKey(p))}get(p){return this._map.get(u.toKey(p))}has(p){return this._map.has(u.toKey(p))}set(p,h){this._map.set(u.toKey(p),h)}values(){return this._map.values()}forEach(p){this._map.forEach(p)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=S;function R(I){return g(I)}e.isApplicationScopedExtension=R;function g(I){return I.contributes&&I.contributes.localizations?I.contributes.localizations.length>0:!1}e.isLanguagePackExtension=g;function d(I){return I.contributes&&I.contributes.authentication?I.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function w(I,p){if(p){const h=`onResolveRemoteAuthority:${(0,k.getRemoteName)(p)}`;return!!I.activationEvents?.includes(h)}return!1}e.isResolverExtension=w,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[134],se([0,1,2,37,12]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends N.Disposable{constructor(y,u,c,S,R){super(),this.userDataProfilesService=y,this.fileService=u,this.uriIdentityService=c,this.logService=R,this._register(S.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(S.onDidUninstallExtension(g=>this.onDidUnInstallExtension(g)))}onDidInstallExtensions(y){for(const u of y)u.local&&this.invalidate(u.profileLocation)}onDidUnInstallExtension(y){y.error||this.invalidate(y.profileLocation)}async invalidate(y){if(y)for(const u of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(u.extensionsResource,y)&&await this.deleteUserCacheFile(u);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(y){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(y.cacheHome,O.USER_MANIFEST_CACHE_FILE))}catch(u){(0,k.toFileOperationResult)(u)!==1&&this.logService.error(u)}}}e.ExtensionsManifestCache=A}),define(ne[45],se([0,1,14,9,2,103,44,10,6,36]),function(G,e,N,O,k,A,T,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,y.createDecorator)("requestService");class S{constructor(P){this.original=P}toJSON(){if(!this.headers){const P=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?P[t]="*****":P[t]=this.original[t];this.headers=P}return this.headers}}class R extends k.Disposable{constructor(P){super(),this.counter=0,this.logger=P.createLogger("network",{name:(0,A.localize)(0,null),when:u.CONTEXT_LOG_LEVEL.isEqualTo((0,u.LogLevelToString)(u.LogLevel.Trace)).serialize()})}async logAndRequest(P,t,o){const i=`${P} #${++this.counter}: ${t.url}`;this.logger.trace(`${i} - begin`,t.type,new S(t.headers??{}));try{const r=await o();return this.logger.trace(`${i} - end`,t.type,r.res.statusCode,r.res.headers),r}catch(r){throw this.logger.error(`${i} - error`,t.type,(0,O.getErrorMessage)(r)),r}}}e.AbstractRequestService=R;function g(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=g;function d(v){return v.res.statusCode===204}async function w(v){return d(v)?null:(await(0,N.streamToBuffer)(v.stream)).toString()}e.asText=w;async function I(v){if(!g(v))throw new Error("Server returned "+v.res.statusCode);return w(v)}e.asTextOrError=I;async function p(v){if(!g(v))throw new Error("Server returned "+v.res.statusCode);if(d(v))return null;const t=(await(0,N.streamToBuffer)(v.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.asJson=p;function h(v){b(v)}e.updateProxyConfigurationsScope=h;let f;function b(v){const P=c.Registry.as(T.Extensions.Configuration),t=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},P.updateConfigurations({add:[f],remove:t?[t]:[]})}b(1)}),define(ne[135],se([0,1,20,15,12,45]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(u,c){this.requestService=u,this.fileService=c}async download(u,c,S=N.CancellationToken.None){if(u.scheme===O.Schemas.file||u.scheme===O.Schemas.vscodeRemote){await this.fileService.copy(u,c);return}const R={type:"GET",url:u.toString(!0)},g=await this.requestService.request(R,S);if(g.res.statusCode===200)await this.fileService.writeFile(c,g.stream);else{const d=await(0,A.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${d}`)}}};e.DownloadService=T,e.DownloadService=T=pe([re(0,A.IRequestService),re(1,k.IFileService)],T)}),define(ne[136],se([0,1,137,3]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(T,y){return T.protocol==="http:"?y.HTTP_PROXY||y.http_proxy||null:T.protocol==="https:"&&(y.HTTPS_PROXY||y.https_proxy||y.HTTP_PROXY||y.http_proxy)||null}async function A(T,y,u={}){const c=(0,N.parse)(T),S=u.proxyUrl||k(c,y);if(!S)return null;const R=(0,N.parse)(S);if(!/^https?:$/.test(R.protocol||""))return null;const g={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,O.isBoolean)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((d,w)=>{G(["http-proxy-agent"],d,w)}))(g):new(await new Promise((d,w)=>{G(["https-proxy-agent"],d,w)}))(g)}e.getProxyAgent=A}),define(ne[138],se([0,1,58,16,104,20,33,9,13,28,84,172,8,72]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let w;async function I(h,f,b,v){return b["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.isLaunchedFromCli)(v)&&!b["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.isLaunchedFromCli)(v)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=g.Promises.withAsyncBody(async(P,t)=>{const o=new A.CancellationTokenSource;let i=1e4;const r=h.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(i=(0,d.clamp)(r,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),t(new Error((0,k.localize)(0,null)))},i);try{P(await p(f,o.token))}catch(s){!(0,y.isCancellationError)(s)&&!o.token.isCancellationRequested?t(new Error((0,k.localize)(1,null,(0,T.toErrorMessage)(s)))):P({})}finally{clearTimeout(n),o.dispose()}})),w)}e.getResolvedShellEnv=I;async function p(h,f){const b=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",b);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",v);const P=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(P+"({.*})"+P),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",o);const i=await(0,S.getSystemShell)(u.OS,o);return h.trace("getUnixShellEnvironment#shell",i),new Promise((r,n)=>{if(f.isCancellationRequested)return n(new y.CancellationError);const s=(0,O.basename)(i);let l,D;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(l=`& '${process.execPath}' ${C} -p '''${P}'' + JSON.stringify(process.env) + ''${P}'''`,D=["-Login","-Command"]):s==="nu"?(l=`^'${process.execPath}' ${C} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,D=["-i","-l","-c"]):(l=`'${process.execPath}' ${C} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,s==="tcsh"||s==="csh"?D=["-ic"]:D=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),l);const E=(0,N.spawn)(i,[...D,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(E.kill(),n(new y.CancellationError))),E.on("error",Z=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(Z)),n(Z)});const L=[];E.stdout.on("data",Z=>L.push(Z));const $=[];E.stderr.on("data",Z=>$.push(Z)),E.on("close",(Z,Q)=>{const ce=Buffer.concat(L).toString("utf8");h.trace("getUnixShellEnvironment#raw",ce);const te=Buffer.concat($).toString("utf8");if(te.trim()&&h.trace("getUnixShellEnvironment#stderr",te),Z||Q)return n(new Error((0,k.localize)(2,null,Z,Q)));const le=t.exec(ce),ue=le?le[1]:"{}";try{const ie=JSON.parse(ue);b?ie.ELECTRON_RUN_AS_NODE=b:delete ie.ELECTRON_RUN_AS_NODE,v?ie.ELECTRON_NO_ATTACH_CONSOLE=v:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",ie),r(ie)}catch(ie){h.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(ie)),n(ie)}})})}}),define(ne[139],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,N.createDecorator)("stateReadService"),e.IStateService=(0,N.createDecorator)("stateService")}),define(ne[68],se([0,1,8,14,3,18,12,6]),function(G,e,N,O,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var u;(function(g){g[g.IMMEDIATE=0]="IMMEDIATE",g[g.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class c{constructor(d,w,I,p){this.storagePath=d,this.logService=I,this.fileService=p,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=w===0?void 0:new N.ThrottledDelayer(100)}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(d){d.fileOperationResult!==1&&this.logService.error(d)}}getItem(d,w){const I=this.storage[d];return(0,k.isUndefinedOrNull)(I)?w:I}setItem(d,w){this.setItems([{key:d,data:w}])}setItems(d){let w=!1;for(const{key:I,data:p}of d)this.storage[I]!==p&&((0,k.isUndefinedOrNull)(p)?(0,k.isUndefined)(this.storage[I])||(this.storage[I]=void 0,w=!0):(this.storage[I]=p,w=!0));w&&this.save()}removeItem(d){(0,k.isUndefined)(this.storage[d])||(this.storage[d]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const d=JSON.stringify(this.storage,null,4);if(d!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,O.VSBuffer.fromString(d),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=d}catch(w){this.logService.error(w)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=c;let S=class{constructor(d,w,I,p){this.fileStorage=new c(w.stateResource,d,I,p)}async init(){await this.fileStorage.init()}getItem(d,w){return this.fileStorage.getItem(d,w)}};e.StateReadonlyService=S,e.StateReadonlyService=S=pe([re(1,A.IEnvironmentService),re(2,y.ILogService),re(3,T.IFileService)],S);class R extends S{setItem(d,w){this.fileStorage.setItem(d,w)}setItems(d){this.fileStorage.setItems(d)}removeItem(d){this.fileStorage.removeItem(d)}close(){return this.fileStorage.close()}}e.StateService=R}),define(ne[69],se([0,1,13,34,28]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(u){if(N.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function T(u,c,S,R,g,d,w,I){const p=Object.create(null);p["common.machineId"]=d,p.sessionID=(0,k.generateUuid)()+Date.now(),p.commitHash=R,p.version=g,p["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,N.PlatformToString)(N.platform),p["common.nodePlatform"]=O.platform,p["common.nodeArch"]=S,p["common.product"]=I||"desktop",w&&(p["common.msftInternal"]=w);let h=0;const f=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),N.isLinuxSnap&&(p["common.snap"]="true");const b=A(c);return b&&(p["common.platformDetail"]=b),p}e.resolveCommonProperties=T;function y(u){const c=O.env.USERDNSDOMAIN;if(!c)return!1;const S=c.toLowerCase();return u.some(R=>S===R)}e.verifyMicrosoftInternalDomain=y}),define(ne[26],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,N.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,N.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(ne[39],se([0,1,30,3,4,25,67,69,26]),function(G,e,N,O,k,A,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=c;class S{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class R{async publicLog(n,s,l){}async publicLogError(n,s,l){}}e.NullEndpointTelemetryService=R,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(r,n){return k.Event.debounce(n.onDidChangeConfiguration,(l,D)=>{const C=l?new Set([...l.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:C}},1e3,!0)(l=>{l.source!==7&&r.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.configurationTelemetry=g;function d(r,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!r.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=d;function w(r,n){return!(n.isBuilt||n.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}e.isLoggingOnly=w;function I(r){const n=r.getValue(u.TELEMETRY_SETTING_ID),s=r.getValue(u.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(r.getValue(u.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function p(r){const n={},s={},l={};b(r,l);for(let D in l){D=D.length>150?D.substr(D.length-149):D;const C=l[D];typeof C=="number"?s[D]=C:typeof C=="boolean"?s[D]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${C.length}`),n[D]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(n[D]=C)}return{properties:n,measurements:s}}e.validateTelemetryData=p;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(r){if(!r)return"none";const n=(0,T.getRemoteName)(r);return h.has(n)?n:"other"}e.cleanRemoteAuthority=f;function b(r,n,s=0,l){if(r)for(const D of Object.getOwnPropertyNames(r)){const C=r[D],E=l?l+D:D;Array.isArray(C)?n[E]=(0,N.safeStringify)(C):C instanceof Date?n[E]=C.toISOString():(0,O.isObject)(C)?s<2?b(C,n,s+1,E+"."):n[E]=(0,N.safeStringify)(C):n[E]=C}}function v(r,n){const s=r.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,y.verifyMicrosoftInternalDomain)(s)||l}e.isInternalTelemetry=v;function P(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}e.getPiiPathsFromEnvironment=P;function t(r,n){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let s=r;const l=[];for(const L of n)for(;;){const $=L.exec(r);if(!$)break;l.push([$.index,L.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(s="";;){const L=C.exec(r);if(!L)break;const $=l.some(([Z,Q])=>L.index<Q&&Z<C.lastIndex);!D.test(L[0])&&!$&&(s+=r.substring(E,L.index)+"<REDACTED: user-file-path>",E=C.lastIndex)}return E<r.length&&(s+=r.substr(E)),s}function o(r){if(!r)return r;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of n)if(s.regex.test(r))return`<REDACTED: ${s.label}>`;return r}function i(r,n){return(0,N.cloneAndChange)(r,s=>{if(s instanceof c||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let l=s.replaceAll("%20"," ");l=t(l,n);for(const D of n)l=l.replace(D,"");return l=o(l),l}})}e.cleanData=i}),define(ne[27],se([0,1,29,21,37,13,11,9,34,39]),function(G,e,N,O,k,A,T,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function S(i,r){return i.uuid&&r.uuid?i.uuid===r.uuid:i.id===r.id?!0:(0,N.compareIgnoreCase)(i.id,r.id)===0}e.areSameExtensions=S;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(r){const n=r.manifest?r.manifest.version:r.version,s=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new g(r.identifier,n,s)}static parse(r){const n=R.exec(r);return n&&n[1]&&n[2]?new g({id:n[1]},n[2],n[4]||void 0):null}constructor(r,n,s="undefined"){this.version=n,this.targetPlatform=s,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof g?S(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=g;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(i){const r=d.exec(i);return r&&r[1]?[p(r[1]),r[2]]:[p(i),void 0]}e.getIdAndVersion=w;function I(i,r){return`${i}.${r}`}e.getExtensionId=I;function p(i){return i.toLowerCase()}e.adoptToGalleryExtensionId=p;function h(i,r){return p(I(i??k.UNDEFINED_PUBLISHER,r))}e.getGalleryExtensionId=h;function f(i,r){const n=[],s=l=>{for(const D of n)if(D.some(C=>S(r(C),r(l))))return D;return null};for(const l of i){const D=s(l);D?D.push(l):n.push([l])}return n}e.groupByExtension=f;function b(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function v(i){return{id:new c.TelemetryTrustedValue(i.identifier.id),name:new c.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function P(i,r){const n=[],s=r.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const l=s.shift();if(l&&n.every(D=>!S(D.identifier,{id:l}))){const D=i.filter(C=>S(C.identifier,{id:l}));D.length===1&&(n.push(D[0]),s.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=P;async function t(i,r){if(!A.isLinux)return!1;let n;try{n=(await i.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await i.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){r.debug("Error while getting the os-release file.",(0,y.getErrorMessage)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(i,r){const n=await t(i,r),s=(0,O.getTargetPlatform)(n?"alpine":A.platform,u.arch);return r.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=o}),define(ne[140],se([0,1,20,9,15,17,43,11,93,21,27,37]),function(G,e,N,O,k,A,T,y,u,c,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const g=p=>(0,u.localize)(0,null,p),d=(0,u.localize)(1,null,"ms-dotnettools.csharp");function w(p,h){return h?`${p.publisher}.${p.name}@${p.version}`:`${p.publisher}.${p.name}`}let I=class{constructor(h,f,b){this.logger=h,this.extensionManagementService=f,this.extensionGalleryService=b}get location(){}async listExtensions(h,f,b){let v=await this.extensionManagementService.getInstalled(1,b);const P=R.EXTENSION_CATEGORIES.map(o=>o.toLowerCase());if(f&&f!==""){if(P.indexOf(f.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}v=v.filter(o=>o.manifest.categories?o.manifest.categories.map(r=>r.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.logger.info("Possible Categories: "),P.forEach(o=>{this.logger.info(o)});return}this.location&&this.logger.info((0,u.localize)(2,null,this.location)),v=v.sort((o,i)=>o.identifier.id.localeCompare(i.identifier.id));let t;for(const o of v)t!==o.identifier.id&&(t=o.identifier.id,this.logger.info(w(o.manifest,h)))}async installExtensions(h,f,b,v){const P=[];try{const t=[];h.length&&this.logger.info(this.location?(0,u.localize)(3,null,this.location):(0,u.localize)(4,null));const o=[];let i=[];const r=(s,l,D)=>{i.push({id:s,version:l!=="prerelease"?l:void 0,installOptions:{...b,isBuiltin:D,installPreReleaseVersion:l==="prerelease"||b.installPreReleaseVersion}})};for(const s of h)if(s instanceof y.URI)o.push({vsix:s,installOptions:b});else{const[l,D]=(0,S.getIdAndVersion)(s);r(l,D,!1)}for(const s of f)if(s instanceof y.URI)o.push({vsix:s,installOptions:{...b,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,D]=(0,S.getIdAndVersion)(s);r(l,D,!0)}const n=await this.extensionManagementService.getInstalled(1,b.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:s,installOptions:l})=>{try{const D=await this.installVSIX(s,l,v,n);D&&t.push(D)}catch(D){this.logger.error(D),P.push(s.toString())}})),i.length&&(i=i.filter(({id:s,version:l})=>{const D=n.find(C=>(0,S.areSameExtensions)(C.identifier,{id:s}));if(D){if(!v&&(!l||l==="prerelease"&&D.preRelease))return this.logger.info((0,u.localize)(5,null,s,D.manifest.version,s)),!1;if(l&&D.manifest.version===l)return this.logger.info((0,u.localize)(6,null,`${s}@${l}`)),!1}return!0}),i.length)){const s=await this.getGalleryExtensions(i);await Promise.all(i.map(async l=>{const D=s.get(l.id.toLowerCase());if(D)try{const C=await this.installFromGallery(l,D,n);C&&t.push(C)}catch(C){this.logger.error(C.message||C.stack||C),P.push(l.id)}else this.logger.error(`${g(l.version?`${l.id}@${l.version}`:l.id)}
${d}`),P.push(l.id)}))}}catch(t){throw this.logger.error((0,u.localize)(7,null,(0,O.getErrorMessage)(t))),t}if(P.length)throw new Error((0,u.localize)(8,null,P.join(", ")))}async installVSIX(h,f,b,v){const P=await this.extensionManagementService.getManifest(h);if(!P)throw new Error("Invalid vsix");if(await this.validateVSIX(P,b,f.profileLocation,v))try{return await this.extensionManagementService.install(h,f),this.logger.info((0,u.localize)(9,null,(0,A.basename)(h))),P}catch(o){if((0,O.isCancellationError)(o))return this.logger.info((0,u.localize)(10,null,(0,A.basename)(h))),null;throw o}return null}async getGalleryExtensions(h){const f=new Map,b=h.some(t=>t.installOptions.installPreReleaseVersion),v=await this.extensionManagementService.getTargetPlatform(),P=[];for(const t of h)c.EXTENSION_IDENTIFIER_REGEX.test(t.id)&&P.push({...t,preRelease:b});if(P.length){const t=await this.extensionGalleryService.getExtensions(P,{targetPlatform:v},N.CancellationToken.None);for(const o of t)f.set(o.identifier.id.toLowerCase(),o)}return f}async installFromGallery({id:h,version:f,installOptions:b},v,P){const t=await this.extensionGalleryService.getManifest(v,N.CancellationToken.None);if(t&&!this.validateExtensionKind(t))return null;const o=P.find(i=>(0,S.areSameExtensions)(i.identifier,v.identifier));if(o){if(v.version===o.manifest.version)return this.logger.info((0,u.localize)(11,null,f?`${h}@${f}`:h)),null;this.logger.info((0,u.localize)(12,null,h,v.version))}try{b.isBuiltin?this.logger.info(f?(0,u.localize)(13,null,h,f):(0,u.localize)(14,null,h)):this.logger.info(f?(0,u.localize)(15,null,h,f):(0,u.localize)(16,null,h));const i=await this.extensionManagementService.installFromGallery(v,{...b,installGivenVersion:!!f});return this.logger.info((0,u.localize)(17,null,h,i.manifest.version)),t}catch(i){if((0,O.isCancellationError)(i))return this.logger.info((0,u.localize)(18,null,h)),null;throw i}}validateExtensionKind(h){return!0}async validateVSIX(h,f,b,v){if(!f){const P={id:(0,S.getGalleryExtensionId)(h.publisher,h.name)},t=v.find(o=>(0,S.areSameExtensions)(P,o.identifier)&&(0,T.gt)(o.manifest.version,h.version));if(t)return this.logger.info((0,u.localize)(19,null,t.identifier.id,t.manifest.version,h.version)),!1}return this.validateExtensionKind(h)}async uninstallExtensions(h,f,b){const v=async t=>{if(t instanceof y.URI){const o=await this.extensionManagementService.getManifest(t);return w(o)}return t},P=[];for(const t of h){const o=await v(t),r=(await this.extensionManagementService.getInstalled(void 0,b)).filter(n=>(0,S.areSameExtensions)(n.identifier,{id:o}));if(!r.length)throw new Error(`${this.notInstalled(o)}
${d}`);if(r.some(n=>n.type===0)){this.logger.info((0,u.localize)(20,null,o));return}if(!f&&r.some(n=>n.isBuiltin)){this.logger.info((0,u.localize)(21,null,o));return}this.logger.info((0,u.localize)(22,null,o));for(const n of r)await this.extensionManagementService.uninstall(n,{profileLocation:b}),P.push(n);this.location?this.logger.info((0,u.localize)(23,null,o,this.location)):this.logger.info((0,u.localize)(24,null,o))}}async locateExtension(h){const f=await this.extensionManagementService.getInstalled();h.forEach(b=>{f.forEach(v=>{if(v.identifier.id===b&&v.location.scheme===k.Schemas.file){this.logger.info(v.location.fsPath);return}})})}notInstalled(h){return this.location?(0,u.localize)(25,null,h,this.location):(0,u.localize)(26,null,h)}};e.ExtensionManagementCLI=I,e.ExtensionManagementCLI=I=pe([re(1,c.IExtensionManagementService),re(2,c.IExtensionGalleryService)],I)}),define(ne[141],se([0,1,4,2,35,27,37]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class y extends O.Disposable{constructor(c,S,R,g,d,w,I){super(),this.extensionManagementService=c,this.extensionsScannerService=S,this.userDataProfilesService=R,this.extensionsProfileScannerService=g,this.uriIdentityService=d,this.fileService=w,this.logService=I,this._onDidChangeExtensionsByAnotherSource=this._register(new N.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new O.DisposableMap),this.initialize().then(null,p=>I.error(p))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(c=>this.onDidChangeProfiles(c.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(c=>this.onAddExtensions(c))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(c=>this.onDidAddExtensions(c))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(c=>this.onRemoveExtensions(c))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(c=>this.onDidRemoveExtensions(c))),this._register(this.fileService.onDidFilesChange(c=>this.onDidFilesChange(c)))}async onDidChangeProfiles(c){try{c.length&&await Promise.all(c.map(S=>(this.extensionsProfileWatchDisposables.set(S.id,(0,O.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(S.extensionsResource)),this.fileService.watch(S.extensionsResource))),this.populateExtensionsFromProfile(S.extensionsResource))))}catch(S){throw this.logService.error(S),S}}async onAddExtensions(c){for(const S of c.extensions)this.addExtensionWithKey(this.getKey(S.identifier,S.version),c.profileLocation)}async onDidAddExtensions(c){for(const S of c.extensions){const R=this.getKey(S.identifier,S.version);c.error?this.removeExtensionWithKey(R,c.profileLocation):this.addExtensionWithKey(R,c.profileLocation)}}async onRemoveExtensions(c){for(const S of c.extensions)this.removeExtensionWithKey(this.getKey(S.identifier,S.version),c.profileLocation)}async onDidRemoveExtensions(c){const S=[],R=[];for(const g of c.extensions){const d=this.getKey(g.identifier,g.version);c.error?this.addExtensionWithKey(d,c.profileLocation):(this.removeExtensionWithKey(d,c.profileLocation),this.allExtensions.has(d)||(this.logService.debug("Extension is removed from all profiles",g.identifier.id,g.version),R.push(this.extensionManagementService.scanInstalledExtensionAtLocation(g.location).then(w=>{w?S.push(w):this.logService.info("Extension not found at the location",g.location.toString())},w=>this.logService.error(w)))))}try{await Promise.all(R),S.length&&await this.uninstallExtensionsNotInProfiles(S)}catch(g){this.logService.error(g)}}onDidFilesChange(c){for(const S of this.userDataProfilesService.profiles)c.contains(S.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(S.extensionsResource)}async onDidExtensionsProfileChange(c){const S=[],R=[],g=await this.extensionsProfileScannerService.scanProfileExtensions(c),d=new Set,w=new Set;for(const[I,p]of this.allExtensions)p.has(c)&&w.add(I);for(const I of g){const p=this.getKey(I.identifier,I.version);d.add(p),w.has(p)||(S.push(I.identifier),this.addExtensionWithKey(p,c))}for(const I of w)if(!d.has(I)){const p=this.fromKey(I);p&&(R.push(p.identifier),this.removeExtensionWithKey(I,c))}(S.length||R.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S.length?{extensions:S,profileLocation:c}:void 0,removed:R.length?{extensions:R,profileLocation:c}:void 0})}async populateExtensionsFromProfile(c){const S=await this.extensionsProfileScannerService.scanProfileExtensions(c);for(const R of S)this.addExtensionWithKey(this.getKey(R.identifier,R.version),c)}async uninstallExtensionsNotInProfiles(c){c||(c=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(R=>!this.allExtensions.has(this.getKey(R.identifier,R.manifest.version)))),c.length&&await this.extensionManagementService.markAsUninstalled(...c)}addExtensionWithKey(c,S){let R=this.allExtensions.get(c);R||this.allExtensions.set(c,R=new k.ResourceSet(g=>this.uriIdentityService.extUri.getComparisonKey(g))),R.add(S)}removeExtensionWithKey(c,S){const R=this.allExtensions.get(c);R&&R.delete(S),R?.size||this.allExtensions.delete(c)}getKey(c,S){return`${T.ExtensionIdentifier.toKey(c.id)}@${S}`}fromKey(c){const[S,R]=(0,A.getIdAndVersion)(c);return R?{identifier:{id:S},version:R}:void 0}}e.ExtensionsWatcher=y}),define(ne[142],se([0,1,113,39]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(A,T,y,u,c,S,R){const g={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${T.nameShort})`};if((0,O.supportsTelemetry)(T,y)&&(0,O.getTelemetryLevel)(u)===3){const d=await(0,N.getServiceMachineId)(y,c,S);g["X-Market-User-Id"]=d,g["VSCode-SessionId"]=R.machineId||d}return g}e.resolveMarketplaceHeaders=k}),define(ne[143],se([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let I=class extends d.LanguagePackBaseService{constructor(b,v,P,t){super(P),this.extensionManagementService=b,this.logService=t,this.cache=this._register(new p(v,t)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getBuiltInExtensionTranslationsUri(b,v){const t=(await this.cache.getLanguagePacks())[v];if(!t){this.logService.warn(`No language pack found for ${v}`);return}const o=t.translations[b];return o?w.URI.file(o):void 0}async getInstalledLanguages(){const b=await this.cache.getLanguagePacks(),v=Object.keys(b).map(P=>{const t=b[P];return{...this.createQuickPickItem(P,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return v.push(this.createQuickPickItem("en","English")),v.sort((P,t)=>P.label.localeCompare(t.label)),v}async postInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",b.identifier.id),await this.update())}async postUninstallExtension(b){const v=await this.cache.getLanguagePacks();Object.keys(v).some(P=>v[P]&&v[P].extensions.some(t=>(0,R.areSameExtensions)(t.extensionIdentifier,b.identifier)))&&(this.logService.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),P=await this.cache.update(v);return!(0,O.equals)(Object.keys(b),Object.keys(P))}};e.NativeLanguagePackService=I,e.NativeLanguagePackService=I=pe([re(0,S.IExtensionManagementService),re(1,c.INativeEnvironmentService),re(2,S.IExtensionGalleryService),re(3,g.ILogService)],I);let p=class extends A.Disposable{constructor(b,v){super(),this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,y.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(v=>{Object.keys(v).forEach(P=>delete v[P]),this.createLanguagePacksFromExtensions(v,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...v){for(const P of v)P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,P);Object.keys(b).forEach(P=>this.updateHash(b[P]))}createLanguagePacksFromExtension(b,v){const P=v.identifier,t=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const o of t)if(v.location.scheme===T.Schemas.file&&h(o)){let i=b[o.languageId];i||(i={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},b[o.languageId]=i);const r=i.extensions.filter(n=>(0,R.areSameExtensions)(n.extensionIdentifier,P))[0];r?r.version=v.manifest.version:i.extensions.push({extensionIdentifier:P,version:v.manifest.version});for(const n of o.translations)i.translations[n.id]=(0,y.join)(v.location.fsPath,n.path)}}updateHash(b){if(b){const v=(0,N.createHash)("md5");for(const P of b.extensions)v.update(P.extensionIdentifier.uuid||P.extensionIdentifier.id).update(P.version);b.hash=v.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return u.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,P=>P.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(P)).then(P=>{try{return JSON.parse(P)}catch{return{}}}).then(P=>(v=b(P),P)).then(P=>{for(const o of Object.keys(P))P[o]||delete P[o];this.languagePacks=P,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),u.Promises.writeFile(this.languagePacksFilePath,t)}).then(()=>v,P=>this.logService.error(P))})}};p=pe([re(0,c.INativeEnvironmentService),re(1,g.ILogService)],p);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const b of f.translations)if(typeof b.id!="string"||typeof b.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ne[144],se([0,1,82,9,30,39]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://0.0.0.0/OneCollector/1.0",y="https://0.0.0.0/ping";async function u(S,R,g){const d=await(0,N.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),w=await(0,N.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),I=new d.AppInsightsCore,p=new w.PostChannel,h={instrumentationKey:S,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(g){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:g};h.extensionConfig[p.identifier]=f}return I.initialize(h,[]),I.addTelemetryInitializer(f=>{R&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),I}class c{constructor(R,g,d,w,I){this._isInternalTelemetry=R,this._eventPrefix=g,this._defaultData=d,this._xhrOverride=I,this.endPointUrl=T,this.endPointHealthUrl=y,this._defaultData||(this._defaultData={}),typeof w=="function"?this._aiCoreOrKey=w():this._aiCoreOrKey=w,this._asyncAiCore=null}_withAIClient(R){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){R(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=u(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(g=>{R(g)},g=>{(0,O.onUnexpectedError)(g),console.error(g)})}}log(R,g){if(!this._aiCoreOrKey)return;g=(0,k.mixin)(g,this._defaultData),g=(0,A.validateTelemetryData)(g);const d=this._eventPrefix+"/"+R;try{this._withAIClient(w=>{w.pluginVersionString=g?.properties.version??"Unknown",w.track({name:d,baseData:{name:d,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(R=>{this._withAIClient(g=>{g.unload(!0,()=>{this._aiCoreOrKey=void 0,R(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=c}),define(ne[145],se([0,1,2,30,13,29,105,25,44,146,31,36,26,39]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,b){this._configurationService=f,this._productService=b,this._experimentProperties={},this._disposables=new N.DisposableStore,this._cleanupPatterns=[],this._appenders=h.appenders,this._commonProperties=h.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=h.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(v=>{(v.affectsConfiguration(g.TELEMETRY_SETTING_ID)||v.affectsConfiguration(g.TELEMETRY_OLD_SETTING_ID)||v.affectsConfiguration(g.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(h,f){this._experimentProperties[h]=f}_updateTelemetryLevel(){let h=(0,d.getTelemetryLevel)(this._configurationService);const f=this._productService.enabledTelemetryLevels;if(f){this._sendErrorTelemetry=this.sendErrorTelemetry?f.error:!1;const b=f.usage?3:f.error?2:0;h=Math.min(h,b)}this._telemetryLevel=h}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(h,f,b){this._telemetryLevel<f||(b=(0,O.mixin)(b,this._experimentProperties),b=(0,d.cleanData)(b,this._cleanupPatterns),b=(0,O.mixin)(b,this._commonProperties),this._appenders.forEach(v=>v.log(h,b)))}publicLog(h,f){this._log(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this._sendErrorTelemetry&&this._log(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.TelemetryService=w,e.TelemetryService=w=pe([re(1,y.IConfigurationService),re(2,S.IProductService)],w);function I(){const p=(0,T.localize)(0,null,c.default.nameLong),h=c.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=k.isWeb?"":(0,T.localize)(3,null),b=(0,T.localize)(4,null),v=(0,T.localize)(5,null),P=(0,T.localize)(6,null),t=(0,T.localize)(7,null),o=`
|       | ${b} | ${v} | ${P} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,T.localize)(8,null);return`
${p} ${h} ${f}

&nbsp;

${t}
${o}

&nbsp;

${i}
`}R.Registry.as(u.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:I(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),R.Registry.as(u.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,T.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,T.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],se([0,1,14,20,174,144]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function T(S,R){const g=await R.request(S,O.CancellationToken.None),d=(await(0,N.streamToBuffer)(g.stream)).toString(),w=g.res.statusCode??200;return{headers:g.res.headers,statusCode:w,responseData:d}}async function y(S){const R={method:S.type,headers:S.headers};return new Promise((d,w)=>{const I=k.request(S.url??"",R,p=>{p.on("data",function(h){d({headers:p.headers,statusCode:p.statusCode??200,responseData:h.toString()})}),p.on("error",function(h){w(h)})});I.write(S.data,p=>{p&&w(p)}),I.end()})}async function u(S,R,g){const d=typeof R.data=="string"?R.data:new TextDecoder().decode(R.data),w={type:"POST",headers:{...R.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(R.data).toString()},url:R.urlString,data:d};try{const I=S?await T(w,S):await y(w);g(I.statusCode,I.headers,I.responseData)}catch{g(0,{})}}class c extends A.AbstractOneDataSystemAppender{constructor(R,g,d,w,I){const p={sendPOST:(h,f)=>{u(R,h,f)}};super(g,d,w,I,p)}}e.OneDataSystemAppender=c}),define(ne[148],se([0,1,16,24]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(A,T){const y=Object.create(null),u=(S,R)=>{const g=JSON.parse(S);y[R]=g};if(T){const S=[],R=await O.Promises.readdir(T);for(const d of R)try{(await O.Promises.stat((0,N.join)(T,d))).isDirectory()&&S.push(d)}catch{}const g=[];for(const d of S)(await O.Promises.readdir((0,N.join)(T,d))).filter(I=>I==="telemetry.json").length===1&&g.push(d);for(const d of g){const w=(await O.Promises.readFile((0,N.join)(T,d,"telemetry.json"))).toString();u(w,d)}}let c=(await O.Promises.readFile((0,N.join)(A,"telemetry-core.json"))).toString();return u(c,"vscode-core"),c=(await O.Promises.readFile((0,N.join)(A,"telemetry-extensions.json"))).toString(),u(c,"vscode-extensions"),JSON.stringify(y,null,4)}e.buildTelemetryMessage=k}),define(ne[149],se([0,1,13,75,26]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function A(T,y){let u=T.getItem(k.machineIdKey);return(typeof u!="string"||N.isMacintosh&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,O.getMachineId)(y.error.bind(y))),u}e.resolveMachineId=A}),define(ne[22],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,N.createDecorator)("IUriIdentityService")}),define(ne[150],se([0,1,22,114,12,17,73,4,2]),function(G,e,N,O,k,A,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{static{this._clock=0}constructor(g){this.uri=g,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let S=class{constructor(g){this._fileService=g,this._dispooables=new u.DisposableStore,this._limit=2**16;const d=new Map,w=I=>{let p=d.get(I.scheme);return p===void 0&&(p=g.hasProvider(I)&&!this._fileService.hasCapability(I,1024),d.set(I.scheme,p)),p};this._dispooables.add(y.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(I=>{d.delete(I.scheme)})),this.extUri=new A.ExtUri(w),this._canonicalUris=new T.SkipList((I,p)=>this.extUri.compare(I,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,A.normalizePath)(g));const d=this._canonicalUris.get(g);return d?d.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new c(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((w,I)=>w[1].time<I[1].time?1:w[1].time>I[1].time?-1:0);c._clock=0,this._canonicalUris.clear();const d=this._limit*.5;for(let w=0;w<d;w++)this._canonicalUris.set(g[w][0],g[w][1].touch())}};e.UriIdentityService=S,e.UriIdentityService=S=pe([re(0,k.IFileService)],S),(0,O.registerSingleton)(N.IUriIdentityService,S,1)}),define(ne[151],se([0,1,4,2,12,41,46,14]),function(G,e,N,O,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class u extends O.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(S,R,g,d){super(),this.fileSystemScheme=S,this.fileSystemProvider=R,this.userDataScheme=g,this.logService=d,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new N.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(w=>this.handleFileChanges(w)))}watch(S,R){this.watchResources.set(S,S);const g=this.fileSystemProvider.watch(this.toFileSystemResource(S),R);return(0,O.toDisposable)(()=>{this.watchResources.delete(S),g.dispose()})}stat(S){return this.fileSystemProvider.stat(this.toFileSystemResource(S))}mkdir(S){return this.fileSystemProvider.mkdir(this.toFileSystemResource(S))}rename(S,R,g){return this.fileSystemProvider.rename(this.toFileSystemResource(S),this.toFileSystemResource(R),g)}readFile(S){return this.fileSystemProvider.readFile(this.toFileSystemResource(S),{atomic:!0})}readFileStream(S,R,g){const d=(0,A.newWriteableStream)(w=>y.VSBuffer.concat(w.map(I=>y.VSBuffer.wrap(I))).buffer);return(async()=>{try{const w=await this.readFile(S);d.end(w)}catch(w){d.error(w),d.end()}})(),d}readdir(S){return this.fileSystemProvider.readdir(this.toFileSystemResource(S))}writeFile(S,R,g){return this.fileSystemProvider.writeFile(this.toFileSystemResource(S),R,g)}delete(S,R){return this.fileSystemProvider.delete(this.toFileSystemResource(S),R)}copy(S,R,g){if((0,k.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(S),this.toFileSystemResource(R),g);throw new Error("copy not supported")}handleFileChanges(S){const R=[];for(const g of S){if(g.resource.scheme!==this.fileSystemScheme)continue;const d=this.toUserDataResource(g.resource);this.watchResources.findSubstr(d)&&R.push({resource:d,type:g.type})}R.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(R))}toFileSystemResource(S){return S.with({scheme:this.fileSystemScheme})}toUserDataResource(S){return S.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=u}),define(ne[152],se([0,1,107,16,46,17,11,10,15]),function(G,e,N,O,k,A,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");function c(r){const n=r;return typeof n?.id=="string"&&T.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=c;function S(r){return typeof r?.id=="string"&&!c(r)&&!g(r)}e.isEmptyWorkspaceIdentifier=S,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function R(r,n){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,O.basename)(r)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=r;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=R;function g(r){const n=r;return typeof n?.id=="string"&&T.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=g;function d(r){const n=r;if(n?.uri)return{id:n.id,uri:T.URI.revive(n.uri)};const s=r;if(s?.configPath)return{id:s.id,configPath:T.URI.revive(s.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=d;var w;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function I(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=I;function p(r){const n=r;return!!(n&&typeof n=="object"&&T.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=p;class h{constructor(n,s,l,D,C){this._id=n,this._transient=l,this._configuration=D,this._ignorePathCasing=C,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class f{constructor(n,s){this.raw=s,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function b(r){return new f({uri:r,index:0,name:(0,A.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,N.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(r,n){return A.extUriBiasedIgnorePathCase.isEqualOrParent(r,n.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function P(r){let n;return T.URI.isUri(r)?n=r:n=r.configuration,n?.scheme===u.Schemas.tmp}e.isTemporaryWorkspace=P,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(r){return r.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function o(r,n){return!v(r,n)&&!P(r)}e.isSavedWorkspace=o;function i(r){return(typeof r=="string"?(0,O.extname)(r):(0,A.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ne[23],se([0,1,42,4,2,17,11,106,18,12,10,6,152,35,22,8,28,29,3]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d,w,I,p,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var b;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState"})(b||(e.ProfileResourceType=b={}));function v(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&T.URI.isUri(n.location)&&T.URI.isUri(n.globalStorageHome)&&T.URI.isUri(n.settingsResource)&&T.URI.isUri(n.keybindingsResource)&&T.URI.isUri(n.tasksResource)&&T.URI.isUri(n.snippetsHome)&&T.URI.isUri(n.extensionsResource))}e.isUserDataProfile=v,e.IUserDataProfilesService=(0,S.createDecorator)("IUserDataProfilesService");function P(r,n){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:T.URI.revive(r.location).with({scheme:n}),globalStorageHome:T.URI.revive(r.globalStorageHome).with({scheme:n}),settingsResource:T.URI.revive(r.settingsResource).with({scheme:n}),keybindingsResource:T.URI.revive(r.keybindingsResource).with({scheme:n}),tasksResource:T.URI.revive(r.tasksResource).with({scheme:n}),snippetsHome:T.URI.revive(r.snippetsHome).with({scheme:n}),extensionsResource:T.URI.revive(r.extensionsResource).with({scheme:n}),cacheHome:T.URI.revive(r.cacheHome).with({scheme:n}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=P;function t(r,n,s,l,D,C){return{id:r,name:n,location:s,isDefault:!1,shortName:D?.shortName,globalStorageHome:C&&D?.useDefaultFlags?.globalState?C.globalStorageHome:(0,A.joinPath)(s,"globalStorage"),settingsResource:C&&D?.useDefaultFlags?.settings?C.settingsResource:(0,A.joinPath)(s,"settings.json"),keybindingsResource:C&&D?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,A.joinPath)(s,"keybindings.json"),tasksResource:C&&D?.useDefaultFlags?.tasks?C.tasksResource:(0,A.joinPath)(s,"tasks.json"),snippetsHome:C&&D?.useDefaultFlags?.snippets?C.snippetsHome:(0,A.joinPath)(s,"snippets"),extensionsResource:C&&D?.useDefaultFlags?.extensions?C.extensionsResource:(0,A.joinPath)(s,"extensions.json"),cacheHome:(0,A.joinPath)(l,r),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.toUserDataProfile=t;let o=class extends k.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,s,l,D){super(),this.environmentService=n,this.fileService=s,this.uriIdentityService=l,this.logService=D,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=this.createDefaultProfile(),s=[n];if(this.enabled)try{for(const C of this.getStoredProfiles()){if(!C.name||!(0,f.isString)(C.name)||!C.location){this.logService.warn("Skipping the invalid stored profile",C.location||C.name);continue}s.push(t((0,A.basename)(C.location),C.name,C.location,this.profilesCacheHome,{shortName:C.shortName,useDefaultFlags:C.useDefaultFlags},n))}}catch(C){this.logService.error(C)}const l=new d.ResourceMap,D=new Map;if(s.length)try{const C=this.getStoredProfileAssociations();if(C.workspaces)for(const[E,L]of Object.entries(C.workspaces)){const $=T.URI.parse(E),Z=s.find(Q=>Q.id===L);Z&&l.set($,Z)}if(C.emptyWindows)for(const[E,L]of Object.entries(C.emptyWindows)){const $=s.find(Z=>Z.id===L);$&&D.set(E,$)}}catch(C){this.logService.error(C)}this._profilesObject={profiles:s,workspaces:l,emptyWindows:D}}return this._profilesObject}createDefaultProfile(){const n=t("__default__profile__",(0,y.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...n,extensionsResource:this.getDefaultProfileExtensionsLocation()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const s="Temp",l=new RegExp(`${(0,h.escapeRegExpCharacters)(s)}\\s(\\d+)`);let D=0;for(const E of this.profiles){const L=l.exec(E.name),$=L?parseInt(L[1]):0;D=$>D?$:D}const C=`${s} ${D+1}`;return this.createProfile((0,N.hash)((0,p.generateUuid)()).toString(16),C,{transient:!0},n)}async createNamedProfile(n,s,l){return this.createProfile((0,N.hash)((0,p.generateUuid)()).toString(16),n,s,l)}async createProfile(n,s,l,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const C=await this.doCreateProfile(n,s,l);return D&&await this.setProfileForWorkspace(D,C),C}async doCreateProfile(n,s,l){if(!(0,f.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.profileCreationPromises.get(s);return D||(D=(async()=>{try{const C=this.profiles.find($=>$.name===s||$.id===n);if(C)return C;const E=t(n,s,(0,A.joinPath)(this.profilesHome,n),this.profilesCacheHome,l,this.defaultProfile);await this.fileService.createFolder(E.location);const L=[];return this._onWillCreateProfile.fire({profile:E,join($){L.push($)}}),await I.Promises.settled(L),this.updateProfiles([E],[],[]),E}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,D)),D}async updateProfile(n,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(D=>D.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=t(l.id,s.name??l.name,l.location,this.profilesCacheHome,{shortName:s.shortName??l.shortName,transient:s.transient??l.isTransient,useDefaultFlags:s.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[l]),l}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(D=>D.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this._onWillRemoveProfile.fire({profile:s,join(D){l.push(D)}});try{await Promise.allSettled(l)}catch(D){this.logService.error(D)}for(const D of[...this.profilesObject.emptyWindows.keys()])s.id===this.profilesObject.emptyWindows.get(D)?.id&&this.profilesObject.emptyWindows.delete(D);for(const D of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(D)?.id&&this.profilesObject.workspaces.delete(D);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{await this.fileService.del(s.cacheHome,{recursive:!0})}catch(D){(0,c.toFileOperationResult)(D)!==1&&this.logService.error(D)}}async setProfileForWorkspace(n,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(D=>D.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(n,l)}unsetWorkspace(n,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(s=>s.isDirectory&&this.profiles.every(l=>!this.uriIdentityService.extUri.isEqual(l.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(n.map(s=>this.removeProfile(s)))}getProfileForWorkspace(n){const s=this.getWorkspace(n);return T.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindows.get(s)??this.profilesObject.emptyWindows.get(s)}getWorkspace(n){return(0,g.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,g.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location))||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location)))}updateProfiles(n,s,l){const D=[...this.profiles,...n],C=[];this.transientProfilesObject.profiles=[];for(let E of D)E.isDefault||s.some(L=>E.id===L.id)||(E=l.find(L=>E.id===L.id)??E,E.isTransient?this.transientProfilesObject.profiles.push(E):C.push({location:E.location,name:E.name,shortName:E.shortName,useDefaultFlags:E.useDefaultFlags}));this.saveStoredProfiles(C),this._profilesObject=void 0,this.triggerProfilesChanges(n,s,l)}triggerProfilesChanges(n,s,l){this._onDidChangeProfiles.fire({added:n,removed:s,updated:l,all:this.profiles})}updateWorkspaceAssociation(n,s,l){l=s?.isTransient?!0:l,l||this.updateWorkspaceAssociation(n,void 0,!0);const D=this.getWorkspace(n),C=l?this.transientProfilesObject:this.profilesObject;T.URI.isUri(D)?(C.workspaces.delete(D),s&&C.workspaces.set(D,s)):(C.emptyWindows.delete(D),s&&C.emptyWindows.set(D,s)),l||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[l,D]of this.profilesObject.workspaces.entries())n[l.toString()]=D.id;const s={};for(const[l,D]of this.profilesObject.emptyWindows.entries())s[l.toString()]=D.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:s}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const s={},l=this.createDefaultProfile();if(n.workspaces)for(const[C,E]of Object.entries(n.workspaces)){const L=T.URI.parse(E);s[C]=this.uriIdentityService.extUri.isEqual(L,l.location)?l.id:this.uriIdentityService.extUri.basename(L)}const D={};if(n.emptyWindows)for(const[C,E]of Object.entries(n.emptyWindows)){const L=T.URI.parse(E);D[C]=this.uriIdentityService.extUri.isEqual(L,l.location)?l.id:this.uriIdentityService.extUri.basename(L)}return{workspaces:s,emptyWindows:D}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=o,e.UserDataProfilesService=o=pe([re(0,u.IEnvironmentService),re(1,c.IFileService),re(2,w.IUriIdentityService),re(3,R.ILogService)],o);class i extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=i}),define(ne[153],se([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,31,26,22,23]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d,w,I,p,h,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let v=class extends y.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(n,s,l,D,C,E){super(),this.galleryService=n,this.telemetryService=s,this.uriIdentityService=l,this.logService=D,this.productService=C,this.userDataProfilesService=E,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this._onDidUpdateExtensionMetadata=this._register(new T.Emitter),this.participants=[],this._register((0,y.toDisposable)(()=>{this.installingExtensions.forEach(({task:L})=>L.cancel()),this.uninstallingExtensions.forEach(L=>L.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const s=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,g.isTargetPlatformCompatible)(l,n.allTargetPlatforms,s))}async installFromGallery(n,s={}){try{const D=(await this.installGalleryExtensions([{extension:n,options:s}])).find(({identifier:C})=>(0,d.areSameExtensions)(C,n.identifier));if(D?.local)return D?.local;throw D?.error?D.error:t(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(l){throw t(l)}}async installGalleryExtensions(n){if(!this.galleryService.isEnabled())throw new g.ExtensionManagementError(R.localize(0,null),g.ExtensionManagementErrorCode.Internal);const s=[],l=[];await Promise.allSettled(n.map(async({extension:D,options:C})=>{try{const E=await this.checkAndGetCompatibleVersion(D,!!C?.installGivenVersion,!!C?.installPreReleaseVersion);l.push({...E,options:C})}catch(E){s.push({identifier:D.identifier,operation:2,source:D,error:E})}})),l.length&&s.push(...await this.installExtensions(l));for(const D of s)D.error&&(this.logService.error("Failed to install extension.",D.identifier.id),this.logService.error(D.error),D.source&&!S.URI.isUri(D.source)&&o(this.telemetryService,"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(D.source),error:D.error}));return s}async uninstall(n,s={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,s)}async toggleAppliationScope(n,s){if((0,w.isApplicationScopedExtension)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let l=await this.updateMetadata(n,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)||(l=await this.copyExtension(n,this.userDataProfilesService.defaultProfile.extensionsResource,s));for(const D of this.userDataProfilesService.profiles){const C=(await this.getInstalled(1,D.extensionsResource)).find(E=>(0,d.areSameExtensions)(E.identifier,n.identifier));C?this._onDidUpdateExtensionMetadata.fire(C):this._onDidUninstallExtension.fire({identifier:n.identifier,profileLocation:D.extensionsResource})}return l}else{const l=this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(n,s,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtensions(n){const s=[];return await Promise.allSettled(n.map(async l=>{try{const D=await this.installExtension(l);s.push(...D)}catch(D){s.push({identifier:{id:(0,d.getGalleryExtensionId)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:D})}})),this._onDidInstallExtensions.fire(s),s}async installExtension({manifest:n,extension:s,options:l}){const D=l.isApplicationScoped||l.isBuiltin||(0,w.isApplicationScopedExtension)(n),C={...l,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(s)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:D,profileLocation:D?this.userDataProfilesService.defaultProfile.extensionsResource:l.profileLocation??this.getCurrentExtensionsManifestLocation()},E=te=>`${d.ExtensionKey.create(te).toString()}${C.profileLocation?`-${C.profileLocation.toString()}`:""}`;if(!S.URI.isUri(s)){const te=this.installingExtensions.get(E(s));if(te)return this.logService.info("Extensions is already requested to install",s.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const L=[],$=[],Z=[],Q=this.createInstallExtensionTask(n,s,C);S.URI.isUri(s)||this.installingExtensions.set(E(s),{task:Q,waitingTasks:[]}),this._onInstallExtension.fire({identifier:Q.identifier,source:s,profileLocation:C.profileLocation}),this.logService.info("Installing extension:",Q.identifier.id),L.push({task:Q,manifest:n});let ce=!1;try{if(C.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",Q.identifier.id);else try{const le=await this.getAllDepsAndPackExtensions(Q.identifier,n,!!C.installOnlyNewlyAddedFromExtensionPack,!!C.installPreReleaseVersion,C.profileLocation),ue=await this.getInstalled(void 0,C.profileLocation),ie={...C,donotIncludePackAndDependencies:!0,context:{...C.context,[g.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:W,manifest:q}of(0,N.distinct)(le,({gallery:V})=>V.identifier.id)){ce=ce||!!q.extensionDependencies?.some(z=>(0,d.areSameExtensions)({id:z},Q.identifier));const V=E(W),M=this.installingExtensions.get(V);if(M){if(this.canWaitForTask(Q,M.task)){const z=M.task.identifier;this.logService.info("Waiting for already requested installing extension",z.id,Q.identifier.id),M.waitingTasks.push(Q),$.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,K=>K.some(X=>(0,d.areSameExtensions)(X.identifier,z)))).then(K=>{if(this.logService.info("Finished waiting for already requested installing extension",z.id,Q.identifier.id),!K.find(J=>(0,d.areSameExtensions)(J.identifier,z))?.local)throw new Error(`Extension ${z.id} is not installed`)}))}}else if(!ue.some(({identifier:z})=>(0,d.areSameExtensions)(z,W.identifier))){const z=this.createInstallExtensionTask(q,W,ie);this.installingExtensions.set(V,{task:z,waitingTasks:[Q]}),this._onInstallExtension.fire({identifier:z.identifier,source:W,profileLocation:C.profileLocation}),this.logService.info("Installing extension:",z.identifier.id,Q.identifier.id),L.push({task:z,manifest:q})}}}catch(le){if(S.URI.isUri(Q.source))(0,N.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",Q.identifier.id,le.message),(0,N.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",Q.identifier.id,le.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",Q.identifier.id),le}const te=L.reduce((le,{task:ue,manifest:ie})=>(le.set(ue.identifier.id.toLowerCase(),{task:ue,manifest:ie}),le),new Map);for(;te.size;){let le;const ue=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(W=>te.has(W.toLowerCase())));ue.length?le=te.size===1?ue:ue.filter(({task:ie})=>!(ie===Q&&!ce)):(this.logService.info("Found extensions with circular dependencies",ue.map(({task:ie})=>ie.identifier.id)),le=[...te.values()]),await this.joinAllSettled(le.map(async({task:ie})=>{const W=new Date().getTime();try{const q=await ie.run();if(await this.joinAllSettled(this.participants.map(V=>V.postInstall(q,ie.source,C,k.CancellationToken.None))),!S.URI.isUri(ie.source)){const V=ie.operation===3,M=V?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(o(this.telemetryService,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-W,durationSinceUpdate:M}),u.isWeb&&ie.operation!==3)try{await this.galleryService.reportStatistic(q.manifest.publisher,q.manifest.name,q.manifest.version,"install")}catch{}}Z.push({local:q,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:ie.options.context,profileLocation:ie.profileLocation,applicationScoped:q.isApplicationScoped})}catch(q){throw S.URI.isUri(ie.source)||o(this.telemetryService,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-W,error:q}),this.logService.error("Error while installing the extension:",ie.identifier.id),q}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return $.length&&await this.joinAllSettled($),Z.forEach(({identifier:le})=>this.logService.info("Extension installed successfully:",le.id)),Z}catch(te){if(L.forEach(({task:le})=>le.cancel()),Z.length)try{const le=await Promise.allSettled(Z.map(({local:ue})=>this.createUninstallExtensionTask(ue,{versionOnly:!0,profileLocation:C.profileLocation}).run()));for(let ue=0;ue<le.length;ue++){const ie=le[ue],{identifier:W}=Z[ue];ie.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",W.id):this.logService.warn("Rollback: Error while uninstalling extension",W.id,(0,A.getErrorMessage)(ie.reason))}}catch(le){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(le),Z.map(({identifier:ue})=>ue.id))}return L.map(({task:le})=>({identifier:le.identifier,operation:2,source:le.source,context:C.context,profileLocation:C.profileLocation,error:te}))}finally{for(const{task:te}of L)te.source&&!S.URI.isUri(te.source)&&this.installingExtensions.delete(E(te.source))}}canWaitForTask(n,s){for(const[,{task:l,waitingTasks:D}]of this.installingExtensions.entries())if(l===n&&(D.includes(s)||D.some(C=>this.canWaitForTask(C,s)))||l===s&&D[0]&&!this.canWaitForTask(n,D[0]))return!1;return!0}async joinAllSettled(n){const s=[],l=[],D=await Promise.allSettled(n);for(const C of D)C.status==="fulfilled"?s.push(C.value):l.push(C.reason);if(l.length)throw P(l);return s}async getAllDepsAndPackExtensions(n,s,l,D,C){if(!this.galleryService.isEnabled())return[];const E=await this.getInstalled(void 0,C),L=[],$=[],Z=async(Q,ce)=>{L.push(Q);const te=ce.extensionDependencies||[],le=[...te];if(ce.extensionPack){const ue=l?E.find(ie=>(0,d.areSameExtensions)(ie.identifier,Q)):void 0;for(const ie of ce.extensionPack)ue&&ue.manifest.extensionPack&&ue.manifest.extensionPack.some(W=>(0,d.areSameExtensions)({id:W},{id:ie}))||le.every(W=>!(0,d.areSameExtensions)({id:W},{id:ie}))&&le.push(ie)}if(le.length){const ue=le.filter(ie=>L.every(W=>!(0,d.areSameExtensions)(W,{id:ie})));if(ue.length){const ie=await this.galleryService.getExtensions(ue.map(W=>({id:W,preRelease:D})),k.CancellationToken.None);for(const W of ie){if(L.find(M=>(0,d.areSameExtensions)(M,W.identifier)))continue;const q=te.some(M=>(0,d.areSameExtensions)({id:M},W.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(W,!1,D)}catch(M){if(q)throw M;this.logService.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,A.getErrorMessage)(M));continue}$.push({gallery:V.extension,manifest:V.manifest}),await Z(V.extension.identifier,V.manifest)}}}};return await Z(n,s),$}async checkAndGetCompatibleVersion(n,s,l){let D;const C=await this.getExtensionsControlManifest();if(C.malicious.some($=>(0,d.areSameExtensions)(n.identifier,$)))throw new g.ExtensionManagementError(R.localize(1,null,n.identifier.id),g.ExtensionManagementErrorCode.Malicious);const E=C.deprecated[n.identifier.id.toLowerCase()];if(E?.extension?.autoMigrate){if(this.logService.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${E.extension.id}' extension instead.`),D=(await this.galleryService.getExtensions([{id:E.extension.id,preRelease:E.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0],!D)throw new g.ExtensionManagementError(R.localize(2,null,n.identifier.id,E.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const $=await this.getTargetPlatform();throw new g.ExtensionManagementError(R.localize(3,null,n.identifier.id,this.productService.nameLong,(0,g.TargetPlatformToString)($)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(D=await this.getCompatibleVersion(n,s,l),!D)throw!l&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],k.CancellationToken.None))[0]?new g.ExtensionManagementError(R.localize(4,null,n.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.ExtensionManagementError(R.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",D.identifier.id);const L=await this.galleryService.getManifest(D,k.CancellationToken.None);if(L===null)throw new g.ExtensionManagementError(`Missing manifest for extension ${D.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(L.version!==D.version)throw new g.ExtensionManagementError(`Cannot install '${D.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:D,manifest:L}}async getCompatibleVersion(n,s,l){const D=await this.getTargetPlatform();let C=null;return!s&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(C=(await this.galleryService.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:D,compatible:!0},k.CancellationToken.None))[0]||null),!C&&await this.galleryService.isExtensionCompatible(n,l,D)&&(C=n),C||(s?C=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:D,compatible:!0},k.CancellationToken.None))[0]||null:C=await this.galleryService.getCompatibleExtension(n,l,D)),C}async uninstallExtension(n,s){const l={...s,profileLocation:n.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:s.profileLocation??this.getCurrentExtensionsManifestLocation()},D=Q=>`${Q.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,C=this.uninstallingExtensions.get(D(n.identifier));if(C)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),C.waitUntilTaskIsFinished();const E=Q=>{const ce=this.createUninstallExtensionTask(Q,l);return this.uninstallingExtensions.set(D(ce.extension.identifier),ce),l.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,l.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${Q.identifier.id}@${Q.manifest.version}`),this._onUninstallExtension.fire({identifier:Q.identifier,profileLocation:l.profileLocation,applicationScoped:Q.isApplicationScoped}),ce},L=(Q,ce)=>{ce?l.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,l.profileLocation.toString(),ce.message):this.logService.error("Failed to uninstall extension:",`${Q.identifier.id}@${Q.manifest.version}`,ce.message):l.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${Q.identifier.id}@${Q.manifest.version}`,l.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${Q.identifier.id}@${Q.manifest.version}`),o(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,d.getLocalExtensionTelemetryData)(Q),error:ce}),this._onDidUninstallExtension.fire({identifier:Q.identifier,error:ce?.code,profileLocation:l.profileLocation,applicationScoped:Q.isApplicationScoped})},$=[],Z=[];try{$.push(E(n));const Q=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const ce=this.getAllPackExtensionsToUninstall(n,Q);for(const te of ce)this.uninstallingExtensions.has(D(te.identifier))?this.logService.info("Extensions is already requested to uninstall",te.identifier.id):$.push(E(te))}l.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents($.map(ce=>ce.extension),Q,n),await this.joinAllSettled($.map(async ce=>{try{if(await ce.run(),await this.joinAllSettled(this.participants.map(te=>te.postUninstall(ce.extension,l,k.CancellationToken.None))),ce.extension.identifier.uuid)try{await this.galleryService.reportStatistic(ce.extension.manifest.publisher,ce.extension.manifest.name,ce.extension.manifest.version,"uninstall")}catch{}L(ce.extension)}catch(te){const le=te instanceof g.ExtensionManagementError?te:new g.ExtensionManagementError((0,A.getErrorMessage)(te),g.ExtensionManagementErrorCode.Internal);throw L(ce.extension,le),le}finally{Z.push(ce)}}))}catch(Q){const ce=Q instanceof g.ExtensionManagementError?Q:new g.ExtensionManagementError((0,A.getErrorMessage)(Q),g.ExtensionManagementErrorCode.Internal);for(const te of $){try{te.cancel()}catch{}Z.includes(te)||L(te.extension,ce)}throw ce}finally{for(const Q of $)this.uninstallingExtensions.delete(D(Q.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",Q.extension.identifier.id)}}checkForDependents(n,s,l){for(const D of n){const C=this.getDependents(D,s);if(C.length){const E=C.filter(L=>!n.some($=>(0,d.areSameExtensions)($.identifier,L.identifier)));if(E.length)throw new Error(this.getDependentsErrorMessage(D,E,l))}}}getDependentsErrorMessage(n,s,l){return l===n?s.length===1?R.localize(6,null,l.manifest.displayName||l.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?R.localize(7,null,l.manifest.displayName||l.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):R.localize(8,null,l.manifest.displayName||l.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?R.localize(9,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?R.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):R.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(n,s,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const D=n.manifest.extensionPack?n.manifest.extensionPack:[];if(D.length){const C=s.filter(L=>!L.isBuiltin&&D.some($=>(0,d.areSameExtensions)({id:$},L.identifier))),E=[];for(const L of C)E.push(...this.getAllPackExtensionsToUninstall(L,s,l));return[...C,...E]}return[]}getDependents(n,s){return s.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(D=>(0,d.areSameExtensions)({id:D},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=v,e.AbstractExtensionManagementService=v=pe([re(0,g.IExtensionGalleryService),re(1,h.ITelemetryService),re(2,f.IUriIdentityService),re(3,I.ILogService),re(4,p.IProductService),re(5,b.IUserDataProfilesService)],v);function P(r){const n=Array.isArray(r)?r:[r];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((s,l)=>new Error(`${s.message}${s.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.joinErrors=P;function t(r){if(r instanceof g.ExtensionManagementError)return r;const n=new g.ExtensionManagementError(r.message,g.ExtensionManagementErrorCode.Internal);return n.stack=r.stack,n}e.toExtensionManagementError=t;function o(r,n,{extensionData:s,verificationStatus:l,duration:D,error:C,durationSinceUpdate:E}){let L,$;(0,c.isDefined)(l)&&(l===!0?l="Verified":(l===!1||(L=g.ExtensionManagementErrorCode.Signature,$=l),l="Unverified")),C&&(C instanceof g.ExtensionManagementError?(L=C.code,C.code===g.ExtensionManagementErrorCode.Signature&&($=C.message)):L=g.ExtensionManagementErrorCode.Internal),r.publicLog(n,{...s,verificationStatus:l,success:!C,duration:D,errorcode:L,errorcodeDetail:$,durationSinceUpdate:E})}class i{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(n=>new Promise((s,l)=>{const D=n.onCancellationRequested(()=>{D.dispose(),l(new A.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=i}),define(ne[40],se([0,1,8,14,2,4,35,11,21,27,12,10,6,23,22,3,9,26]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d,w,I,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class b extends Error{constructor(i,r){super(i),this.code=r}}e.ExtensionsProfileScanningError=b,e.IExtensionsProfileScannerService=(0,R.createDecorator)("IExtensionsProfileScannerService");let v=class extends k.Disposable{constructor(i,r,n,s,l,D){super(),this.extensionsLocation=i,this.fileService=r,this.userDataProfilesService=n,this.uriIdentityService=s,this.telemetryService=l,this.logService=D,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(i,r){return this.withProfileExtensions(i,void 0,r)}async addExtensionsToProfile(i,r){const n=[],s=[];try{return await this.withProfileExtensions(r,l=>{const D=[];for(const C of l)i.some(([E])=>(0,c.areSameExtensions)(E.identifier,C.identifier)&&E.manifest.version!==C.version)?n.push(C):D.push(C);for(const[C,E]of i){const L=D.findIndex(Z=>(0,c.areSameExtensions)(Z.identifier,C.identifier)&&Z.version===C.manifest.version),$={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:E};L===-1?(s.push($),D.push($)):D.splice(L,1,$)}return s.length&&this._onAddExtensions.fire({extensions:s,profileLocation:r}),n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:r}),D}),s.length&&this._onDidAddExtensions.fire({extensions:s,profileLocation:r}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:r}),s}catch(l){throw s.length&&this._onDidAddExtensions.fire({extensions:s,error:l,profileLocation:r}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:l,profileLocation:r}),l}}async updateMetadata(i,r){const n=[];return await this.withProfileExtensions(r,s=>{const l=[];for(const D of s){const C=i.find(([E])=>(0,c.areSameExtensions)(E.identifier,D.identifier)&&E.manifest.version===D.version);C&&(D.metadata={...D.metadata,...C[1]},n.push(D)),l.push(D)}return l}),n}async removeExtensionFromProfile(i,r){const n=[];try{await this.withProfileExtensions(r,s=>{const l=[];for(const D of s)(0,c.areSameExtensions)(D.identifier,i.identifier)?n.push(D):l.push(D);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:r}),l}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:r})}catch(s){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:s,profileLocation:r}),s}}async withProfileExtensions(i,r,n){return this.getResourceAccessQueue(i).queue(async()=>{let s=[],l;try{const D=await this.fileService.readFile(i);l=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,S.toFileOperationResult)(D)!==1)throw D;if(this.uriIdentityService.extUri.isEqual(i,this.userDataProfilesService.defaultProfile.extensionsResource)&&(l=await this.migrateFromOldDefaultProfileExtensionsLocation()),!l&&n?.bailOutWhenFileNotFound)throw new b((0,p.getErrorMessage)(D),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.reportAndThrowInvalidConentError(i);let D=!1;for(const C of l){P(C)||this.reportAndThrowInvalidConentError(i);let E;if((0,I.isString)(C.relativeLocation)&&C.relativeLocation)E=this.resolveExtensionLocation(C.relativeLocation);else if((0,I.isString)(C.location))E=this.resolveExtensionLocation(C.location),D=!0,C.relativeLocation=C.location,C.location=E.toJSON();else{E=y.URI.revive(C.location);const L=this.toRelativePath(E);L&&(D=!0,C.relativeLocation=L)}s.push({identifier:C.identifier,location:E,version:C.version,metadata:C.metadata})}D&&await this.fileService.writeFile(i,O.VSBuffer.fromString(JSON.stringify(l)))}if(r){s=r(s);const D=s.map(C=>({identifier:C.identifier,version:C.version,location:C.location.toJSON(),relativeLocation:this.toRelativePath(C.location),metadata:C.metadata}));await this.fileService.writeFile(i,O.VSBuffer.fromString(JSON.stringify(D)))}return s})}reportAndThrowInvalidConentError(i){const r=new b(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}toRelativePath(i){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(i),this.extensionsLocation)?this.uriIdentityService.extUri.basename(i):void 0}resolveExtensionLocation(i){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,i)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const i=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),r=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(i)).value.toString()}catch(l){if((0,S.toFileOperationResult)(l)===1)return;throw l}this.logService.info("Migrating extensions from old default profile location",i.toString());let s;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(D=>P(D))?s=l:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.logService.error(l)}if(s)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(s)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(l){if((0,S.toFileOperationResult)(l)===3)this.logService.info("Migration from old default profile location to new location is done by another window",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw l}try{await this.fileService.del(i)}catch(l){(0,S.toFileOperationResult)(l)!==1&&this.logService.error(l)}try{await this.fileService.del(r)}catch(l){(0,S.toFileOperationResult)(l)!==1&&this.logService.error(l)}return s})()),this._migrationPromise}getResourceAccessQueue(i){let r=this.resourcesAccessQueueMap.get(i);return r||(r=new N.Queue,this.resourcesAccessQueueMap.set(i,r)),r}};e.AbstractExtensionsProfileScannerService=v,e.AbstractExtensionsProfileScannerService=v=pe([re(1,S.IFileService),re(2,d.IUserDataProfilesService),re(3,w.IUriIdentityService),re(4,h.ITelemetryService),re(5,g.ILogService)],v);function P(o){return(0,I.isObject)(o)&&(0,u.isIExtensionIdentifier)(o.identifier)&&(t(o.location)||(0,I.isString)(o.location)&&o.location)&&((0,I.isUndefined)(o.relativeLocation)||(0,I.isString)(o.relativeLocation))&&o.version&&(0,I.isString)(o.version)}function t(o){return o?(0,I.isString)(o.path)&&(0,I.isString)(o.scheme):!1}}),define(ne[50],se([0,1,19,8,30,14,9,53,80,2,15,16,13,17,43,54,3,11,95,18,27,37,48,12,10,6,31,4,47,40,23,22,112]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d,w,I,p,h,f,b,v,P,t,o,i,r,n,s,l,D,C,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var $;(function(ie){function W(q,V){if(q===V)return!0;const M=Object.keys(q),z=new Set;for(const K of Object.keys(V))z.add(K);if(M.length!==z.size)return!1;for(const K of M){if(q[K]!==V[K])return!1;z.delete(K)}return z.size===0}ie.equals=W})($||(e.Translations=$={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let Z=class extends c.Disposable{constructor(W,q,V,M,z,K,X,J,_,x,a,m){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=q,this.extensionsControlLocation=V,this.currentProfile=M,this.userDataProfilesService=z,this.extensionsProfileScannerService=K,this.fileService=X,this.logService=J,this.environmentService=_,this.productService=x,this.uriIdentityService=a,this.instantiationService=m,this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(te,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(te,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ce,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,v.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(W,q,V){const[M,z]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(q)]),K=V?await this.scanExtensionsUnderDevelopment(W,[...M,...z]):[];return this.dedupExtensions(M,z,K,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const q=[];q.push(this.scanDefaultSystemExtensions(!!W.useCache,W.language)),q.push(this.scanDevSystemExtensions(W.language,!!W.checkControlFile));const[V,M]=await Promise.all(q);return this.applyScanOptions([...V,...M],0,W,!1)}async scanUserExtensions(W){const q=W.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",q);const V=this.uriIdentityService.extUri.isEqual(W.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.createExtensionScannerInput(q,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,V),z=W.useCache&&!M.devMode&&M.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let K;try{K=await z.scanExtensions(M)}catch(X){if(X instanceof D.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),K=await z.scanExtensions(M);else throw X}return K=await this.applyScanOptions(K,1,W,!0),this.logService.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(W,q){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const V=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(M=>M.scheme===S.Schemas.file).map(async M=>{const z=await this.createExtensionScannerInput(M,!1,1,!0,W.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(z)).map(X=>(X.type=q.find(J=>(0,v.areSameExtensions)(J.identifier,X.identifier))?.type??X.type,this.extensionsScanner.validate(X,z)))}))).flat();return this.applyScanOptions(V,"development",W,!0)}return[]}async scanExistingExtension(W,q,V){const M=await this.createExtensionScannerInput(W,!1,q,!0,V.language,!0,void 0),z=await this.extensionsScanner.scanExtension(M);return!z||!V.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(W,q,V){const M=await this.createExtensionScannerInput(W,!1,q,!0,V.language,!0,void 0),z=await this.extensionsScanner.scanOneOrMultipleExtensions(M);return this.applyScanOptions(z,q,V,!0)}async scanMetadata(W){const q=(0,d.joinPath)(W,"package.json"),V=(await this.fileService.readFile(q)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(W,q){const V=(0,d.joinPath)(W,"package.json"),M=(await this.fileService.readFile(V)).value.toString(),z=JSON.parse(M);q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,z.__metadata={...z.__metadata,...q},await this.fileService.writeFile((0,d.joinPath)(W,"package.json"),A.VSBuffer.fromString(JSON.stringify(z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof D.ExtensionsProfileScanningError&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw W}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.extensionsProfileScannerService.addExtensionsToProfile(W.map(q=>[q,q.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(q){(0,o.toFileOperationResult)(q)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.getErrorMessage)(q))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.logService.error(W)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(W,q,V,M){return V.includeAllVersions||(W=this.dedupExtensions(q===0?W:void 0,q===1?W:void 0,q==="development"?W:void 0,await this.getTargetPlatform(),M)),V.includeInvalid||(W=W.filter(z=>z.isValid)),W.sort((z,K)=>{const X=R.basename(z.location.fsPath),J=R.basename(K.location.fsPath);return X<J?-1:X>J?1:0})}dedupExtensions(W,q,V,M,z){const K=(J,_,x)=>{if(J.isValid&&!_.isValid)return!1;if(J.isValid===_.isValid){if(z&&w.gt(J.manifest.version,_.manifest.version))return this.logService.debug(`Skipping extension ${_.location.path} with lower version ${_.manifest.version} in favour of ${J.location.path} with version ${J.manifest.version}`),!1;if(w.eq(J.manifest.version,_.manifest.version)){if(J.type===0)return this.logService.debug(`Skipping extension ${_.location.path} in favour of system extension ${J.location.path} with same version`),!1;if(J.targetPlatform===M)return this.logService.debug(`Skipping extension ${_.location.path} from different target platform ${_.targetPlatform}`),!1}}return x?this.logService.warn(`Overwriting user extension ${J.location.path} with ${_.location.path}.`):this.logService.debug(`Overwriting user extension ${J.location.path} with ${_.location.path}.`),!0},X=new P.ExtensionIdentifierMap;return W?.forEach(J=>{const _=X.get(J.identifier.id);(!_||K(_,J,!1))&&X.set(J.identifier.id,J)}),q?.forEach(J=>{const _=X.get(J.identifier.id);if(!_&&W&&J.type===0){this.logService.debug(`Skipping obsolete system extension ${J.location.path}.`);return}(!_||K(_,J,!1))&&X.set(J.identifier.id,J)}),V?.forEach(J=>{const _=X.get(J.identifier.id);(!_||K(_,J,!0))&&X.set(J.identifier.id,J),X.set(J.identifier.id,J)}),[...X.values()]}async scanDefaultSystemExtensions(W,q){this.logService.trace("Started scanning system extensions");const V=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,q,!0,void 0),z=await(W&&!V.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(V);return this.logService.trace("Scanned system extensions:",z.length),z}async scanDevSystemExtensions(W,q){const V=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!V?.length)return[];this.logService.trace("Started scanning dev system extensions");const M=q?await this.getBuiltInExtensionControl():{},z=[],K=h.URI.file(R.normalize(R.join(S.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const J of V){const _=M[J.name]||"marketplace";switch(_){case"disabled":break;case"marketplace":z.push((0,d.joinPath)(K,J.name));break;default:z.push(h.URI.file(_));break}}const X=await Promise.all(z.map(async J=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(J,!1,0,!0,W,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",X.length),(0,N.coalesce)(X)}async getBuiltInExtensionControl(){try{const W=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(W.value.toString())}catch{return{}}}async createExtensionScannerInput(W,q,V,M,z,K,X){const J=await this.getTranslations(z??g.language),_=await this.getMtime(W),x=q&&!this.uriIdentityService.extUri.isEqual(W,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,a=x?await this.getMtime(x):void 0;return new Q(W,_,x,a,q,X,V,M,K,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,z,J)}async getMtime(W){try{const q=await this.fileService.stat(W);if(typeof q.mtime=="number")return q.mtime}catch{}}};e.AbstractExtensionsScannerService=Z,e.AbstractExtensionsScannerService=Z=pe([re(4,C.IUserDataProfilesService),re(5,D.IExtensionsProfileScannerService),re(6,o.IFileService),re(7,r.ILogService),re(8,b.IEnvironmentService),re(9,n.IProductService),re(10,E.IUriIdentityService),re(11,i.IInstantiationService)],Z);class Q{constructor(W,q,V,M,z,K,X,J,_,x,a,m,F,U,H){this.location=W,this.mtime=q,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=M,this.profile=z,this.profileScanOptions=K,this.type=X,this.excludeObsolete=J,this.validate=_,this.productVersion=x,this.productDate=a,this.productCommit=m,this.devMode=F,this.language=U,this.translations=H}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,q){return(0,d.isEqual)(W.location,q.location)&&W.mtime===q.mtime&&(0,d.isEqual)(W.applicationExtensionslocation,q.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===q.applicationExtensionslocationMtime&&W.profile===q.profile&&k.equals(W.profileScanOptions,q.profileScanOptions)&&W.type===q.type&&W.excludeObsolete===q.excludeObsolete&&W.validate===q.validate&&W.productVersion===q.productVersion&&W.productDate===q.productDate&&W.productCommit===q.productCommit&&W.devMode===q.devMode&&W.language===q.language&&$.equals(W.translations,q.translations)}}e.ExtensionScannerInput=Q;let ce=class extends c.Disposable{constructor(W,q,V,M,z){super(),this.obsoleteFile=W,this.extensionsProfileScannerService=q,this.uriIdentityService=V,this.fileService=M,this.logService=z}async scanExtensions(W){const q=W.profile?await this.scanExtensionsFromProfile(W):await this.scanExtensionsFromLocation(W);let V={};if(W.excludeObsolete&&W.type===1)try{const M=(await this.fileService.readFile(this.obsoleteFile)).value.toString();V=JSON.parse(M)}catch{}return(0,p.isEmptyObject)(V)?q:q.filter(M=>!V[v.ExtensionKey.create(M).toString()])}async scanExtensionsFromLocation(W){const q=await this.fileService.resolve(W.location);if(!q.children?.length)return[];const V=await Promise.all(q.children.map(async M=>{if(!M.isDirectory||W.type===1&&(0,d.basename)(M.resource).indexOf(".")===0)return null;const z=new Q(M.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(z)}));return(0,N.coalesce)(V).sort((M,z)=>M.location.path<z.location.path?-1:1)}async scanExtensionsFromProfile(W){let q=await this.scanExtensionsFromProfileResource(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(W.location,W.applicationExtensionslocation)){q=q.filter(M=>!M.metadata?.isApplicationScoped);const V=await this.scanExtensionsFromProfileResource(W.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,W);q.push(...V)}return q}async scanExtensionsFromProfileResource(W,q,V){const M=await this.extensionsProfileScannerService.scanProfileExtensions(W,V.profileScanOptions);if(!M.length)return[];const z=await Promise.all(M.map(async K=>{if(q(K)){const X=new Q(K.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(X,K.metadata)}return null}));return(0,N.coalesce)(z)}async scanOneOrMultipleExtensions(W){try{if(await this.fileService.exists((0,d.joinPath)(W.location,"package.json"))){const q=await this.scanExtension(W);return q?[q]:[]}else return await this.scanExtensions(W)}catch(q){return this.logService.error(`Error scanning extensions at ${W.location.path}:`,(0,T.getErrorMessage)(q)),[]}}async scanExtension(W,q){try{let V=await this.scanExtensionManifest(W.location);if(V){V.publisher||(V.publisher=P.UNDEFINED_PUBLISHER),q=q??V.__metadata,delete V.__metadata;const M=(0,v.getGalleryExtensionId)(V.publisher,V.name),z=q?.id?{id:M,uuid:q.id}:{id:M},K=q?.isSystem?0:W.type,X=K===0||!!q?.isBuiltin;V=await this.translateManifest(W.location,V,Q.createNlsConfiguration(W));const J={type:K,identifier:z,manifest:V,location:W.location,isBuiltin:X,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return W.validate?this.validate(J,W):J}}catch(V){W.type!==0&&this.logService.error(V)}return null}validate(W,q){let V=!0;const M=(0,t.validateExtensionManifest)(q.productVersion,q.productDate,q.location,W.manifest,W.isBuiltin);for(const[z,K]of M)z===I.default.Error&&(V=!1,this.logService.error(this.formatMessage(q.location,K)));return W.isValid=V,W.validations=M,W}async scanExtensionManifest(W){const q=(0,d.joinPath)(W,"package.json");let V;try{V=(await this.fileService.readFile(q)).value.toString()}catch(z){return(0,o.toFileOperationResult)(z)!==1&&this.logService.error(this.formatMessage(W,(0,f.localize)(0,null,q.path,z.message))),null}let M;try{M=JSON.parse(V)}catch{const K=[];(0,y.parse)(V,K);for(const X of K)this.logService.error(this.formatMessage(W,(0,f.localize)(1,null,q.path,X.offset,X.length,(0,u.getParseErrorMessage)(X.error))));return null}return(0,y.getNodeType)(M)!=="object"?(this.logService.error(this.formatMessage(W,(0,f.localize)(2,null,q.path))),null):M}async translateManifest(W,q,V){const M=await this.getLocalizedMessages(W,q,V);if(M)try{const z=[],K=await this.resolveOriginalMessageBundle(M.default,z);if(z.length>0)return z.forEach(J=>{this.logService.error(this.formatMessage(W,(0,f.localize)(3,null,M.default?.path,(0,u.getParseErrorMessage)(J.error))))}),q;if((0,y.getNodeType)(M)!=="object")return this.logService.error(this.formatMessage(W,(0,f.localize)(4,null,M.default?.path))),q;const X=M.values||Object.create(null);return(0,L.localizeManifest)(q,X,K)}catch{}return q}async getLocalizedMessages(W,q,V){const M=(0,d.joinPath)(W,"package.nls.json"),z=(_,x)=>{x.forEach(a=>{this.logService.error(this.formatMessage(W,(0,f.localize)(5,null,_?.path,(0,u.getParseErrorMessage)(a.error))))})},K=_=>{this.logService.error(this.formatMessage(W,(0,f.localize)(6,null,_?.path)))},X=`${q.publisher}.${q.name}`,J=V.translations[X];if(J)try{const _=h.URI.file(J),x=(await this.fileService.readFile(_)).value.toString(),a=[],m=(0,y.parse)(x,a);return a.length>0?(z(_,a),{values:void 0,default:M}):(0,y.getNodeType)(m)!=="object"?(K(_),{values:void 0,default:M}):{values:m.contents?m.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.fileService.exists(M))return;let x;try{x=await this.findMessageBundles(W,V)}catch{return}if(!x.localized)return{values:void 0,default:x.original};try{const a=(await this.fileService.readFile(x.localized)).value.toString(),m=[],F=(0,y.parse)(a,m);return m.length>0?(z(x.localized,m),{values:void 0,default:x.original}):(0,y.getNodeType)(F)!=="object"?(K(x.localized),{values:void 0,default:x.original}):{values:F,default:x.original}}catch{return{values:void 0,default:x.original}}}}async resolveOriginalMessageBundle(W,q){if(W)try{const V=(await this.fileService.readFile(W)).value.toString();return(0,y.parse)(V,q)}catch{}}findMessageBundles(W,q){return new Promise((V,M)=>{const z=K=>{const X=(0,d.joinPath)(W,`package.nls.${K}.json`);this.fileService.exists(X).then(J=>{J&&V({localized:X,original:(0,d.joinPath)(W,"package.nls.json")});const _=K.lastIndexOf("-");_===-1?V({localized:(0,d.joinPath)(W,"package.nls.json"),original:null}):(K=K.substring(0,_),z(K))})};if(q.devMode||q.pseudo||!q.language)return V({localized:(0,d.joinPath)(W,"package.nls.json"),original:null});z(q.language)})}formatMessage(W,q){return`[${W.path}]: ${q}`}};ce=pe([re(1,D.IExtensionsProfileScannerService),re(2,E.IUriIdentityService),re(3,o.IFileService),re(4,r.ILogService)],ce);let te=class extends ce{constructor(W,q,V,M,z,K,X){super(q,M,z,K,X),this.currentProfile=W,this.userDataProfilesService=V,this.cacheValidatorThrottler=this._register(new O.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(W){const q=this.getCacheFile(W),V=await this.readExtensionCache(q);if(this.input=W,V&&V.input&&Q.equals(V.input,this.input))return this.logService.debug("Using cached extensions scan result",W.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),V.result.map(z=>(z.location=h.URI.revive(z.location),z));const M=await super.scanExtensions(W);return await this.writeExtensionCache(q,{input:W,result:M}),M}async readExtensionCache(W){try{const q=await this.fileService.readFile(W),V=JSON.parse(q.value.toString());return{result:V.result,input:(0,l.revive)(V.input)}}catch(q){this.logService.debug("Error while reading the extension cache file:",W.path,(0,T.getErrorMessage)(q))}return null}async writeExtensionCache(W,q){try{await this.fileService.writeFile(W,A.VSBuffer.fromString(JSON.stringify(q)))}catch(V){this.logService.debug("Error while writing the extension cache file:",W.path,(0,T.getErrorMessage)(V))}}async validateCache(){if(!this.input)return;const W=this.getCacheFile(this.input),q=await this.readExtensionCache(W);if(!q)return;const V=q.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(M,V))try{this.logService.info("Invalidating Cache",V,M),await this.fileService.del(W),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}getCacheFile(W){const q=this.getProfile(W);return this.uriIdentityService.extUri.joinPath(q.cacheHome,W.type===0?P.BUILTIN_MANIFEST_CACHE_FILE:P.USER_MANIFEST_CACHE_FILE)}getProfile(W){return W.type===0?this.userDataProfilesService.defaultProfile:W.profile?this.uriIdentityService.extUri.isEqual(W.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(q=>this.uriIdentityService.extUri.isEqual(W.location,q.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};te=pe([re(2,C.IUserDataProfilesService),re(3,D.IExtensionsProfileScannerService),re(4,E.IUriIdentityService),re(5,o.IFileService),re(6,r.ILogService)],te);function le(ie,W){const q=(0,v.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:q,identifier:new P.ExtensionIdentifier(q),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:W,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.toExtensionDescription=le;class ue extends Z{constructor(W,q,V,M,z,K,X,J,_,x,a,m){super(W,q,(0,d.joinPath)(V,".vscode-oss-dev","extensions","control.json"),M,z,K,X,J,_,x,a,m),this.translationsPromise=(async()=>{if(g.translationsConfigFile)try{const F=await this.fileService.readFile(h.URI.file(g.translationsConfigFile));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}getTranslations(W){return this.translationsPromise}}e.NativeExtensionsScannerService=ue}),define(ne[154],se([0,1,58,8,33,4,2,15,16,24,6,23]),function(G,e,N,O,k,A,T,y,u,c,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends T.Disposable{constructor(w,I){super(),this.userDataProfilesService=w,this.logService=I,this.processesLimiter=new O.Limiter(5)}async postUninstall(w){const I=this.parseScript(w,"uninstall");I&&(this.logService.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(I.script,"uninstall",I.args,!0,w),this.logService.info("Finished running post uninstall script",w.identifier.id,w.manifest.version)}catch(p){this.logService.error("Failed to run post uninstall script",w.identifier.id,w.manifest.version),this.logService.error(p)}}));try{await c.Promises.rm(this.getExtensionStoragePath(w))}catch(p){this.logService.error("Error while removing extension storage path",w.identifier.id),this.logService.error(p)}}parseScript(w,I){const p=`vscode:${I}`;if(w.location.scheme===y.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[p]=="string"){const h=w.manifest.scripts[p].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.logService.warn(w.identifier.id,w.manifest.version,`${p} should be a node script`),null):{script:(0,u.join)(w.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}runLifecycleHook(w,I,p,h,f){return new Promise((b,v)=>{const P=this.start(w,I,p,f);let t;const o=i=>{t&&(clearTimeout(t),t=null),i?v(i):b(void 0)};P.on("error",i=>{o((0,k.toErrorMessage)(i)||"Unknown")}),P.on("exit",(i,r)=>{o(i?`post-${I} process exited with code ${i}`:void 0)}),h&&(t=setTimeout(()=>{t=null,P.kill(),v("timed out")},5e3))})}start(w,I,p,h){const f={silent:!0,execArgv:void 0},b=(0,N.fork)(w,[`--type=extension-post-${I}`,...p],f);b.stdout.setEncoding("utf8"),b.stderr.setEncoding("utf8");const v=A.Event.fromNodeEventEmitter(b.stdout,"data"),P=A.Event.fromNodeEventEmitter(b.stderr,"data");v(i=>this.logService.info(h.identifier.id,h.manifest.version,`post-${I}`,i)),P(i=>this.logService.error(h.identifier.id,h.manifest.version,`post-${I}`,i));const t=A.Event.any(A.Event.map(v,i=>({data:`%c${i}`,format:[""]})),A.Event.map(P,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(t,(i,r)=>i?{data:i.data+r.data,format:[...i.format,...r.format]}:{data:r.data,format:r.format},100)(i=>{console.group(h.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),b}getExtensionStoragePath(w){return(0,u.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=g,e.ExtensionsLifecycle=g=pe([re(0,R.IUserDataProfilesService),re(1,S.ILogService)],g)}),define(ne[155],se([0,1,6,23,22,26,40,12,18,11]),function(G,e,N,O,k,A,T,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let S=class extends T.AbstractExtensionsProfileScannerService{constructor(g,d,w,I,p,h){super(c.URI.file(g.extensionsPath),d,w,I,p,h)}};e.ExtensionsProfileScannerService=S,e.ExtensionsProfileScannerService=S=pe([re(0,u.INativeEnvironmentService),re(1,y.IFileService),re(2,O.IUserDataProfilesService),re(3,k.IUriIdentityService),re(4,A.ITelemetryService),re(5,N.ILogService)],S)}),define(ne[156],se([0,1,11,18,40,50,12,10,6,31,22,23]),function(G,e,N,O,k,A,T,y,u,c,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends A.NativeExtensionsScannerService{constructor(w,I,p,h,f,b,v,P){super(N.URI.file(f.builtinExtensionsPath),N.URI.file(f.extensionsPath),f.userHome,w.defaultProfile,w,I,p,h,f,b,v,P)}};e.ExtensionsScannerService=g,e.ExtensionsScannerService=g=pe([re(0,R.IUserDataProfilesService),re(1,k.IExtensionsProfileScannerService),re(2,T.IFileService),re(3,u.ILogService),re(4,O.INativeEnvironmentService),re(5,c.IProductService),re(6,S.IUriIdentityService),re(7,y.IInstantiationService)],g)}),define(ne[157],se([0,1,8,4,2,123,3,86,10,23]),function(G,e,N,O,k,A,T,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,u.createDecorator)("storageService");var S;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var R;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(R||(e.StorageScope=R={}));var g;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function d(f){const b=f.get(e.TARGET_KEY);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.loadKeyTargets=d;class w extends k.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(b={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super(),this.options=b,this._onDidChangeValue=this._register(new O.PauseableEmitter),this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new N.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(b,v,P){return O.Event.filter(this._onDidChangeValue.event,t=>t.scope===b&&(v===void 0||t.key===v),P)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,N.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,v){const{key:P,external:t}=v;if(P===e.TARGET_KEY){switch(b){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:b})}else this._onDidChangeValue.fire({scope:b,key:P,target:this.getKeyTargets(b)[P],external:t})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,v,P){return this.getStorage(v)?.get(b,P)}getBoolean(b,v,P){return this.getStorage(v)?.getBoolean(b,P)}getNumber(b,v,P){return this.getStorage(v)?.getNumber(b,P)}getObject(b,v,P){return this.getStorage(v)?.getObject(b,P)}storeAll(b,v){this.withPausedEmitters(()=>{for(const P of b)this.store(P.key,P.value,P.scope,P.target,v)})}store(b,v,P,t,o=!1){if((0,T.isUndefinedOrNull)(v)){this.remove(b,P,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,P,t),this.getStorage(P)?.set(b,v,o)})}remove(b,v,P=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(b,v,void 0),this.getStorage(v)?.delete(b,P)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,v){const P=[],t=this.getKeyTargets(b);for(const o of Object.keys(t))t[o]===v&&P.push(o);return P}updateKeyTarget(b,v,P,t=!1){const o=this.getKeyTargets(v);typeof P=="number"?o[b]!==P&&(o[b]=P,this.getStorage(v)?.set(e.TARGET_KEY,JSON.stringify(o),t)):typeof o[b]=="number"&&(delete o[b],this.getStorage(v)?.set(e.TARGET_KEY,JSON.stringify(o),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(b){switch(b){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(b){const v=this.getStorage(b);return v?d(v):Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=S.NONE){this._onWillSaveState.fire({reason:b});const v=this.getStorage(-1),P=this.getStorage(0),t=this.getStorage(1);switch(b){case S.NONE:await N.Promises.settled([v?.whenFlushed()??Promise.resolve(),P?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await N.Promises.settled([v?.flush(0)??Promise.resolve(),P?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.getStorage(-1)?.items??new Map,v=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return h(b,v,P,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(b,v){return this.emitWillSaveState(S.NONE),(0,c.isUserDataProfile)(b)?this.switchToProfile(b,v):this.switchToWorkspace(b,v)}canSwitchProfile(b,v){return!(b.id===v.id||I(v)&&I(b))}switchData(b,v,P){this.withPausedEmitters(()=>{const t=new Set;for(const[o,i]of b)t.add(o),v.get(o)!==i&&this.emitDidChangeValue(P,{key:o,external:!0});for(const[o]of v.items)t.has(o)||this.emitDidChangeValue(P,{key:o,external:!0})})}}e.AbstractStorageService=w;function I(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=I;class p extends w{constructor(){super(),this.applicationStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.profileStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),this._register(this.applicationStorage.onDidChangeStorage(b=>this.emitDidChangeValue(-1,b)))}getStorage(b){switch(b){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(b){return!1}}e.InMemoryStorageService=p;async function h(f,b,v,P,t,o){const i=$=>{try{return JSON.parse($)}catch{return $}},r=new Map,n=new Map;f.forEach(($,Z)=>{r.set(Z,$),n.set(Z,i($))});const s=new Map,l=new Map;b.forEach(($,Z)=>{s.set(Z,$),l.set(Z,i($))});const D=new Map,C=new Map;v.forEach(($,Z)=>{D.set(Z,$),C.set(Z,i($))}),console.group(P!==t?`Storage: Application (path: ${P})`:`Storage: Application & Profile (path: ${P}, default profile)`);const E=[];if(r.forEach(($,Z)=>{E.push({key:Z,value:$})}),console.table(E),console.groupEnd(),console.log(n),P!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const $=[];s.forEach((Z,Q)=>{$.push({key:Q,value:Z})}),console.table($),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const L=[];D.forEach(($,Z)=>{L.push({key:Z,value:$})}),console.table(L),console.groupEnd(),console.log(C)}e.logStorage=h}),define(ne[158],se([0,1,19,20,9,13,34,3,11,25,18,21,27,48,12,6,31,45,142,157,26,175]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d,w,I,p,h,f,b,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=A.isWeb?"web":(0,R.getTargetPlatform)(A.platform,T.arch),o="X-Market-Search-Activity-Id";var i;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function r(...a){return String(a.reduce((m,F)=>m|F,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},C={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class E{constructor(m=C){this.state=m}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(m,F=this.state.pageSize){return new E({...this.state,pageNumber:m,pageSize:F})}withFilter(m,...F){const U=[...this.state.criteria,...F.length?F.map(H=>({filterType:m,value:H})):[{filterType:m}]];return new E({...this.state,criteria:U})}withSortBy(m){return new E({...this.state,sortBy:m})}withSortOrder(m){return new E({...this.state,sortOrder:m})}withFlags(...m){return new E({...this.state,flags:m.reduce((F,U)=>F|U,0)})}withAssetTypes(...m){return new E({...this.state,assetTypes:m})}withSource(m){return new E({...this.state,source:m})}get raw(){const{criteria:m,pageNumber:F,pageSize:U,sortBy:H,sortOrder:B,flags:oe,assetTypes:ae}=this.state;return{filters:[{criteria:m,pageNumber:F,pageSize:U,sortBy:H,sortOrder:B}],assetTypes:ae,flags:oe}}get searchText(){const m=this.state.criteria.filter(F=>F.filterType===n.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(m=>String(m.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function L(a,m){const F=(a||[]).filter(U=>U.statisticName===m)[0];return F?F.value:0}function $(a){const m="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(U=>U.assetType.indexOf(m)===0).reduce((U,H)=>{const B=ce(a,H.assetType);return B&&U.push([H.assetType.substring(m.length),B]),U},[])}function Z(a){if(a.properties){const m=a.properties.filter(H=>H.key===s.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=m.filter(H=>F.test(H.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return ce(a,s.Repository)}function Q(a){return{uri:`${a.fallbackAssetUri}/${s.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${s.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function ce(a,m){return a.files.filter(U=>U.assetType===m)[0]?{uri:`${a.assetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function te(a,m){const F=a.properties?a.properties.filter(H=>H.key===m):[],U=F.length>0&&F[0].value;return U?U.split(",").map(H=>(0,g.adoptToGalleryExtensionId)(H)):[]}function le(a){const m=a.properties?a.properties.filter(F=>F.key===l.Engine):[];return m.length>0&&m[0].value||""}function ue(a){const m=a.properties?a.properties.filter(F=>F.key===l.PreRelease):[];return m.length>0&&m[0].value==="true"}function ie(a){const m=a.properties?a.properties.filter(U=>U.key===l.LocalizedLanguages):[],F=m.length>0&&m[0].value||"";return F?F.split(","):[]}function W(a){return a.properties?.find(m=>m.key===l.SponsorLink)?.value}function q(a){return a.indexOf("preview")!==-1}function V(a){return a.targetPlatform?(0,R.toTargetPlatform)(a.targetPlatform):"undefined"}function M(a){const m=(0,N.distinct)(a.versions.map(V)),F=!!a.tags?.includes(R.WEB_EXTENSION_TAG),U=m.indexOf("web");return F?U===-1&&m.push("web"):U!==-1&&m.splice(U,1),m}function z(a,m){const F=(0,R.getFallbackTargetPlarforms)(m);for(let U=0;U<a.length;U++){const H=a[U];if(H.version===a[U-1]?.version){let B=U;const oe=V(H);if(oe===m)for(;B>0&&a[B-1].version===H.version;)B--;else if(F.includes(oe))for(;B>0&&a[B-1].version===H.version&&V(a[B-1])!==m;)B--;B!==U&&(a.splice(U,1),a.splice(B,0,H))}}return a}e.sortExtensionVersions=z;function K(a,m,F){a.telemetryData={index:m,querySource:F,queryActivityId:a.queryContext?.[o]}}function X(a,m,F,U){const H=a.versions[0],B={manifest:ce(m,s.Manifest),readme:ce(m,s.Details),changelog:ce(m,s.Changelog),license:ce(m,s.License),repository:Z(m),download:Q(m),icon:ce(m,s.Icon),signature:ce(m,s.Signature),coreTranslations:$(m)};return{identifier:{id:(0,g.getGalleryExtensionId)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:m.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(H),description:a.shortDescription||"",installCount:L(a.statistics,"install"),rating:L(a.statistics,"averagerating"),ratingCount:L(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:F,assets:B,properties:{dependencies:te(m,l.Dependency),extensionPack:te(m,l.ExtensionPack),engine:le(m),localizedLanguages:ie(m),targetPlatform:V(m),isPreReleaseVersion:ue(m)},hasPreReleaseVersion:ue(H),hasReleaseVersion:!0,preview:q(a.flags),isSigned:!!B.signature,queryContext:U}}let J=class{constructor(m,F,U,H,B,oe,ae,ve){this.requestService=F,this.logService=U,this.environmentService=H,this.telemetryService=B,this.fileService=oe,this.productService=ae,this.configurationService=ve;const de=ae.extensionsGallery,ge=de?.servicePPEUrl&&ve.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=ge?de.servicePPEUrl:de?.serviceUrl,this.extensionsGallerySearchUrl=ge?void 0:de?.searchUrl,this.extensionsControlUrl=de?.controlUrl,this.commonHeadersPromise=(0,f.resolveMarketplaceHeaders)(ae.version,ae,this.environmentService,this.configurationService,this.fileService,m,this.telemetryService)}api(m=""){return`${this.extensionsGalleryUrl}${m}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(m,F,U){const H=O.CancellationToken.isCancellationToken(F)?{}:F,B=O.CancellationToken.isCancellationToken(F)?F:U,oe=[],ae=[],ve=[],de=[];let ge=!0;for(const Se of m){Se.uuid?ae.push(Se.uuid):oe.push(Se.id);const we=!!(Se.version||Se.preRelease);ve.push({id:Se.id,uuid:Se.uuid,includePreRelease:we}),Se.version&&de.push({id:Se.id,uuid:Se.uuid,version:Se.version}),ge=ge&&!!Se.hasPreRelease&&!we}if(!ae.length&&!oe.length)return[];let he=new E().withPage(1,m.length);ae.length&&(he=he.withFilter(n.ExtensionId,...ae)),oe.length&&(he=he.withFilter(n.ExtensionName,...oe)),(H.queryAllVersions||ge)&&(he=he.withFlags(he.flags,i.IncludeVersions)),H.source&&(he=he.withSource(H.source));const{extensions:fe}=await this.queryGalleryExtensions(he,{targetPlatform:H.targetPlatform??t,includePreRelease:ve,versions:de,compatible:!!H.compatible},B);return H.source&&fe.forEach((Se,we)=>K(Se,we,H.source)),fe}async getCompatibleExtension(m,F,U){if((0,R.isNotWebExtensionInWebTargetPlatform)(m.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible(m,F,U))return m;const H=new E().withFlags(i.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,m.identifier.uuid),{extensions:B}=await this.queryGalleryExtensions(H,{targetPlatform:U,compatible:!0,includePreRelease:F},O.CancellationToken.None);return B[0]||null}async isExtensionCompatible(m,F,U){if(!(0,R.isTargetPlatformCompatible)(m.properties.targetPlatform,m.allTargetPlatforms,U)||!F&&m.properties.isPreReleaseVersion)return!1;let H=m.properties.engine;if(!H){const B=await this.getManifest(m,O.CancellationToken.None);if(!B)throw new Error("Manifest was not found");H=B.engines.vscode}return(0,d.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(m,F,U,H,B){if(!(0,R.isTargetPlatformCompatible)(V(m),H,B)||F!=="any"&&ue(m)!==(F==="prerelease"))return!1;if(U)try{const oe=await this.getEngine(m);if(!(0,d.isEngineValid)(oe,this.productService.version,this.productService.date))return!1}catch(oe){return this.logService.error(`Error while getting the engine for the version ${m.version}.`,(0,k.getErrorMessage)(oe)),!1}return!0}async query(m,F){let U=m.text||"";const H=m.pageSize??50;let B=new E().withPage(1,H);U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,he,fe)=>(B=B.withFilter(n.Category,fe||he),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,he,fe)=>(B=B.withFilter(n.Tag,fe||he),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(n.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),B=B.withFilter(n.SearchText,U)),B=B.withSortBy(0)):m.ids?B=B.withFilter(n.ExtensionId,...m.ids):m.names?B=B.withFilter(n.ExtensionName,...m.names):B=B.withSortBy(4),typeof m.sortBy=="number"&&(B=B.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&(B=B.withSortOrder(m.sortOrder)),m.source&&(B=B.withSource(m.source));const oe=async(ge,he)=>{const{extensions:fe,total:Se}=await this.queryGalleryExtensions(ge,{targetPlatform:t,compatible:!1,includePreRelease:!!m.includePreRelease},he);return fe.forEach((we,be)=>K(we,(ge.pageNumber-1)*ge.pageSize+be,m.source)),{extensions:fe,total:Se}},{extensions:ae,total:ve}=await oe(B,F),de=async(ge,he)=>{if(he.isCancellationRequested)throw new k.CancellationError;const{extensions:fe}=await oe(B.withPage(ge+1),he);return fe};return{firstPage:ae,total:ve,pageSize:B.pageSize,getPage:de}}async queryGalleryExtensions(m,F,U){const H=m.flags;m.flags&i.IncludeLatestVersionOnly&&m.flags&i.IncludeVersions&&(m=m.withFlags(m.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(m.flags&i.IncludeLatestVersionOnly)&&!(m.flags&i.IncludeVersions)&&(m=m.withFlags(m.flags,i.IncludeLatestVersionOnly)),F.versions?.length&&(m=m.withFlags(m.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),m=m.withFlags(m.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:B,total:oe,context:ae}=await this.queryRawGalleryExtensions(m,U);if(!(m.flags&i.IncludeLatestVersionOnly)){const he=[];for(const fe of B){const Se=await this.toGalleryExtensionWithCriteria(fe,F,ae);Se&&he.push(Se)}return{extensions:he,total:oe}}const de=[],ge=new Map;for(let he=0;he<B.length;he++){const fe=B[he],Se={id:(0,g.getGalleryExtensionId)(fe.publisher.publisherName,fe.extensionName),uuid:fe.extensionId},we=(0,y.isBoolean)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(Fe=>(0,g.areSameExtensions)(Fe,Se))?.includePreRelease;if(F.compatible&&(0,R.isNotWebExtensionInWebTargetPlatform)(M(fe),F.targetPlatform))continue;const be=await this.toGalleryExtensionWithCriteria(fe,F,ae);!be||be.properties.isPreReleaseVersion&&(!we||!be.hasReleaseVersion)||!be.properties.isPreReleaseVersion&&be.properties.targetPlatform!==F.targetPlatform&&be.hasPreReleaseVersion?ge.set(fe.extensionId,he):de.push([he,be])}if(ge.size){const he=new P.StopWatch,fe=new E().withFlags(H&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:Se}=await this.queryGalleryExtensions(fe,F,U);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:he.elapsed(),count:ge.size});for(const we of Se){const be=ge.get(we.identifier.uuid);de.push([be,we])}}return{extensions:de.sort((he,fe)=>he[0]-fe[0]).map(([,he])=>he),total:oe}}async toGalleryExtensionWithCriteria(m,F,U){const H={id:(0,g.getGalleryExtensionId)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},B=F.versions?.find(de=>(0,g.areSameExtensions)(de,H))?.version,oe=(0,y.isBoolean)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(de=>(0,g.areSameExtensions)(de,H))?.includePreRelease,ae=M(m),ve=z(m.versions,F.targetPlatform);if(F.compatible&&(0,R.isNotWebExtensionInWebTargetPlatform)(ae,F.targetPlatform))return null;for(let de=0;de<ve.length;de++){const ge=ve[de];if(!(B&&ge.version!==B)){if(await this.isValidVersion(ge,oe?"any":"release",F.compatible,ae,F.targetPlatform))return X(m,ge,ae,U);if(B&&ge.version===B)return null}}return B||F.compatible?null:X(m,m.versions[0],ae)}async queryRawGalleryExtensions(m,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,i.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,r(i.Unpublished));const U=await this.commonHeadersPromise,H=JSON.stringify(m.raw),B={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},oe=new P.StopWatch;let ae,ve,de=0;try{if(ae=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&m.criteria.some(he=>he.filterType===n.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:H,headers:B},F),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,h.asJson)(ae);if(ge){const he=ge.results[0],fe=he.extensions,Se=he.resultMetadata&&he.resultMetadata.filter(we=>we.metadataType==="ResultCount")[0];return de=Se&&Se.metadataItems.filter(we=>we.name==="TotalCount")[0].count||0,{galleryExtensions:fe,total:de,context:{[o]:ae.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw ve=ge,ge}finally{this.telemetryService.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(H.length),duration:oe.elapsed(),success:!!ae&&(0,h.isSuccess)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:ve?(0,k.isCancellationError)(ve)?"canceled":(0,k.getErrorMessage)(ve).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(m,F,U,H){if(!this.isEnabled())return;const B=A.isWeb?this.api(`/itemName/${m}.${F}/version/${U}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${m}/extensions/${F}/${U}/stats?statType=${H}`),oe=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ve={...await this.commonHeadersPromise,Accept:oe};try{await this.requestService.request({type:"POST",url:B,headers:ve},O.CancellationToken.None)}catch{}}async download(m,F,U){this.logService.trace("ExtensionGalleryService#download",m.identifier.id);const H=(0,g.getGalleryExtensionTelemetryData)(m),B=new Date().getTime(),oe=he=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:he}),ae=U===2?"install":U===3?"update":"",ve=ae?{uri:`${m.assets.download.uri}${u.URI.parse(m.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${m.assets.download.fallbackUri}${u.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:m.assets.download,de=m.queryContext?.[o]?{[o]:m.queryContext[o]}:void 0,ge=await this.getAsset(ve,de?{headers:de}:void 0);await this.fileService.writeFile(F,ge.stream),oe(new Date().getTime()-B)}async downloadSignatureArchive(m,F){if(!m.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const U=await this.getAsset(m.assets.signature);await this.fileService.writeFile(F,U.stream)}async getReadme(m,F){if(m.assets.readme){const U=await this.getAsset(m.assets.readme,{},F);return await(0,h.asTextOrError)(U)||""}return""}async getManifest(m,F){if(m.assets.manifest){const U=await this.getAsset(m.assets.manifest,{},F),H=await(0,h.asTextOrError)(U);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(m,F){const U=ce(m,s.Manifest);if(!U)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},B=await this.getAsset(U,{headers:H});return await(0,h.asJson)(B)}async getCoreTranslation(m,F){const U=m.assets.coreTranslations.filter(H=>H[0]===F.toUpperCase())[0];if(U){const H=await this.getAsset(U[1]),B=await(0,h.asTextOrError)(H);return B?JSON.parse(B):null}return null}async getChangelog(m,F){if(m.assets.changelog){const U=await this.getAsset(m.assets.changelog,{},F);return await(0,h.asTextOrError)(U)||""}return""}async getAllCompatibleVersions(m,F,U){let H=new E().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?H=H.withFilter(n.ExtensionId,m.identifier.uuid):H=H.withFilter(n.ExtensionName,m.identifier.id);const{galleryExtensions:B}=await this.queryRawGalleryExtensions(H,O.CancellationToken.None);if(!B.length)return[];const oe=M(B[0]);if((0,R.isNotWebExtensionInWebTargetPlatform)(oe,U))return[];const ae=[];await Promise.all(B[0].versions.map(async ge=>{try{await this.isValidVersion(ge,F?"any":"release",!0,oe,U)&&ae.push(ge)}catch{}}));const ve=[],de=new Set;for(const ge of z(ae,U))de.has(ge.version)||(de.add(ge.version),ve.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:ue(ge)}));return ve}async getAsset(m,F={},U=O.CancellationToken.None){const H=await this.commonHeadersPromise,B={type:"GET"},oe={...H,...F.headers||{}};F={...F,...B,headers:oe};const ae=m.uri,ve=m.fallbackUri,de={...F,url:ae};try{const ge=await this.requestService.request(de,U);if(ge.res.statusCode===200)return ge;const he=await(0,h.asTextOrError)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${he}`)}catch(ge){if((0,k.isCancellationError)(ge))throw ge;const he=(0,k.getErrorMessage)(ge);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:he});const fe={...F,url:ve};return this.requestService.request(fe,U)}}async getEngine(m){let F=le(m);if(!F){const U=await this.getManifestFromRawExtensionVersion(m,O.CancellationToken.None);if(!U)throw new Error("Manifest was not found");F=U.engines.vscode}return F}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const m=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,h.asJson)(m),U=[],H={},B=[];if(F){for(const oe of F.malicious)U.push({id:oe});if(F.migrateToPreRelease)for(const[oe,ae]of Object.entries(F.migrateToPreRelease))(!ae.engine||(0,d.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(H[oe.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(F.deprecated)for(const[oe,ae]of Object.entries(F.deprecated))ae&&(H[oe.toLowerCase()]=(0,y.isBoolean)(ae)?{}:ae);if(F.search)for(const oe of F.search)B.push(oe)}return{malicious:U,deprecated:H,search:B}}};J=pe([re(1,h.IRequestService),re(2,I.ILogService),re(3,S.IEnvironmentService),re(4,v.ITelemetryService),re(5,w.IFileService),re(6,p.IProductService),re(7,c.IConfigurationService)],J);let _=class extends J{constructor(m,F,U,H,B,oe,ae,ve){super(m,F,U,H,B,oe,ae,ve)}};e.ExtensionGalleryService=_,e.ExtensionGalleryService=_=pe([re(0,b.IStorageService),re(1,h.IRequestService),re(2,I.ILogService),re(3,S.IEnvironmentService),re(4,v.ITelemetryService),re(5,w.IFileService),re(6,p.IProductService),re(7,c.IConfigurationService)],_);let x=class extends J{constructor(m,F,U,H,B,oe,ae){super(void 0,m,F,U,H,B,oe,ae)}};e.ExtensionGalleryServiceWithNoStorageService=x,e.ExtensionGalleryServiceWithNoStorageService=x=pe([re(0,h.IRequestService),re(1,I.ILogService),re(2,S.IEnvironmentService),re(3,v.ITelemetryService),re(4,w.IFileService),re(5,p.IProductService),re(6,c.IConfigurationService)],x)}),define(ne[159],se([0,1,11,18,12,6,139,22,23,3,68]),function(G,e,N,O,k,A,T,y,u,c,S){"use strict";var R,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let d=class extends u.UserDataProfilesService{static{R=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(h,f,b,v,P){super(b,v,f,P),this.stateReadonlyService=h,this.nativeEnvironmentService=b}getStoredProfiles(){return this.stateReadonlyService.getItem(R.PROFILES_KEY,[]).map(f=>({...f,location:(0,c.isString)(f.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,f.location):N.URI.revive(f.location)}))}getStoredProfileAssociations(){const h=this.stateReadonlyService.getItem(R.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(R.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?h:this.migrateStoredProfileAssociations(h)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(N.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=d,e.UserDataProfilesReadonlyService=d=R=pe([re(0,T.IStateReadService),re(1,y.IUriIdentityService),re(2,O.INativeEnvironmentService),re(3,k.IFileService),re(4,A.ILogService)],d);let w=g=class extends d{constructor(h,f,b,v,P){super(h,f,b,v,P),this.stateService=h}saveStoredProfiles(h){h.length?this.stateService.setItem(g.PROFILES_KEY,h.map(f=>({...f,location:this.uriIdentityService.extUri.basename(f.location)}))):this.stateService.removeItem(g.PROFILES_KEY)}getStoredProfiles(){const h=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(h),this.stateService.setItem("userDataProfilesMigration",!0)),h}saveStoredProfileAssociations(h){h.emptyWindows||h.workspaces?this.stateService.setItem(g.PROFILE_ASSOCIATIONS_KEY,h):this.stateService.removeItem(g.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const h="workspaceAndProfileInfo",f=this.stateService.getItem(h,void 0);if(f){this.stateService.removeItem(h);const v=f.reduce((P,{workspace:t,profile:o})=>(P[N.URI.revive(t).toString()]=N.URI.revive(o).toString(),P),{});this.stateService.setItem(g.PROFILE_ASSOCIATIONS_KEY,{workspaces:v})}const b=super.getStoredProfileAssociations();return this.stateService.getItem(g.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(b),this.stateService.setItem(g.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),b}};e.UserDataProfilesService=w,e.UserDataProfilesService=w=g=pe([re(0,T.IStateService),re(1,y.IUriIdentityService),re(2,O.INativeEnvironmentService),re(3,k.IFileService),re(4,A.ILogService)],w);let I=class extends w{constructor(h,f,b,v){super(new S.StateService(0,f,v,b),h,f,b,v)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=I,e.ServerUserDataProfilesService=I=pe([re(0,y.IUriIdentityService),re(1,O.INativeEnvironmentService),re(2,k.IFileService),re(3,A.ILogService)],I)}),define(ne[51],se([0,1,125,8,16,3,24,87,176,177]),function(G,e,N,O,k,A,T,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const S=new RegExp(e.CorruptZipMessage);class R extends Error{constructor(o,i){let r=i.message;switch(o){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=o,this.cause=i}}e.ExtractError=R;function g(t){const o=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>o&i).reduce((i,r)=>i+r,o&61440)}function d(t){if(t instanceof R)return t;let o;return S.test(t.message)&&(o="CorruptZip"),new R(o,t)}function w(t,o,i,r,n,s){const l=k.dirname(o),D=k.join(r,l);if(!D.startsWith(r))return Promise.reject(new Error(y.localize(0,null,o)));const C=k.join(r,o);let E;return s.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(T.Promises.mkdir(D,{recursive:!0})).then(()=>new Promise((L,$)=>{if(!s.isCancellationRequested)try{E=(0,N.createWriteStream)(C,{mode:i}),E.once("close",()=>L()),E.once("error",$),t.once("error",$),t.pipe(E)}catch(Z){$(Z)}}))}function I(t,o,i,r){let n=(0,O.createCancelablePromise)(()=>Promise.resolve()),s=0;return r.onCancellationRequested(()=>{n.cancel(),t.close()}),new Promise((l,D)=>{const C=new O.Sequencer,E=L=>{L.isCancellationRequested||(s++,t.readEntry())};t.once("error",D),t.once("close",()=>n.then(()=>{r.isCancellationRequested||t.entryCount===s?l():D(new R("Incomplete",new Error(y.localize(1,null,s,t.entryCount))))},D)),t.readEntry(),t.on("entry",L=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(L.fileName)){E(r);return}const $=L.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test($)){const ce=k.join(o,$);n=(0,O.createCancelablePromise)(te=>T.Promises.mkdir(ce,{recursive:!0}).then(()=>E(te)).then(void 0,D));return}const Z=h(t,L),Q=g(L);n=(0,O.createCancelablePromise)(ce=>C.queue(()=>Z.then(te=>w(te,$,Q,o,i,ce).then(()=>E(ce)))).then(null,D))})})}function p(t,o=!1){return new Promise((i,r)=>{(0,u.open)(t,o?{lazyEntries:!0}:void 0,(n,s)=>{n?r(d(n)):i((0,A.assertIsDefined)(s))})})}function h(t,o){return new Promise((i,r)=>{t.openReadStream(o,(n,s)=>{n?r(d(n)):i((0,A.assertIsDefined)(s))})})}function f(t,o){return new Promise((i,r)=>{const n=new c.ZipFile;o.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const s=(0,N.createWriteStream)(t);n.outputStream.pipe(s),n.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>i(t))})}e.zip=f;function b(t,o,i={},r){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=p(t,!0);return i.overwrite&&(s=s.then(l=>T.Promises.rm(o).then(()=>l))),s.then(l=>I(l,o,{sourcePathRegex:n},r))}e.extract=b;function v(t,o){return p(t).then(i=>new Promise((r,n)=>{i.on("entry",s=>{s.fileName===o&&h(i,s).then(l=>r(l),l=>n(l))}),i.once("close",()=>n(new Error(y.localize(2,null,o))))}))}function P(t,o){return v(t,o).then(i=>new Promise((r,n)=>{const s=[];i.once("error",n),i.on("data",l=>s.push(l)),i.on("end",()=>r(Buffer.concat(s)))}))}e.buffer=P}),define(ne[160],se([0,1,8,9,2,15,17,43,3,28,24,51,25,18,21,27,60,12,6]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d,w,I,p,h,f){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let v=class extends k.Disposable{static{b=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(t,o,i,r,n,s){super(),this.fileService=o,this.extensionGalleryService=i,this.configurationService=r,this.extensionSignatureVerificationService=n,this.logService=s,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(t,o,i){await this.cleanUpPromise;const r=(0,T.joinPath)(this.extensionsDownloadDir,this.getName(t));try{await this.downloadFile(t,r,s=>this.extensionGalleryService.download(t,s,o))}catch(s){throw new w.ExtensionManagementError(s.message,w.ExtensionManagementErrorCode.Download)}let n=!1;if(i&&this.shouldVerifySignature(t)){const s=await this.downloadSignatureArchive(t);try{n=await this.extensionSignatureVerificationService.verify(r.fsPath,s.fsPath,this.logService.getLevel()===f.LogLevel.Trace)}catch(l){const D=l;if(n=D.code,D.output&&this.logService.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${D.output}`),n===w.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===w.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new w.ExtensionManagementError(R.CorruptZipMessage,w.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(s)}catch(l){this.logService.error(l)}}}return n===!0?this.logService.info(`Extension signature is verified: ${t.identifier.id}`):n===!1?this.logService.info(`Extension signature verification is not done: ${t.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${n}': ${t.identifier.id}`),{location:r,verificationStatus:n}}shouldVerifySignature(t){if(!t.isSigned)return!1;const o=this.configurationService.getValue("extensions.verifySignature");return(0,u.isBoolean)(o)?o:!0}async downloadSignatureArchive(t){await this.cleanUpPromise;const o=(0,T.joinPath)(this.extensionsDownloadDir,`${this.getName(t)}${b.SignatureArchiveExtension}`);return await this.downloadFile(t,o,i=>this.extensionGalleryService.downloadSignatureArchive(t,i)),o}async downloadFile(t,o,i){if(await this.fileService.exists(o))return;if(o.scheme!==A.Schemas.file){await i(o);return}const r=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,c.generateUuid)()}`);await this.fileService.exists(r)||await i(r);try{await S.Promises.rename(r.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.fileService.del(r)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,o.path);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(n)}. Deleted the file from downloaded location`,r.path),n}}async delete(t){await this.cleanUpPromise,await this.fileService.del(t)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const o=[],i=[],r=[];for(const l of t.children)if(l.name.endsWith(b.SignatureArchiveExtension))r.push(l.resource);else{const D=I.ExtensionKey.parse(l.name);D&&i.push([D,l])}const n=(0,I.groupByExtension)(i,([l])=>l),s=[];for(const l of n)l.sort((D,C)=>y.rcompare(D[0].version,C[0].version)),o.push(...l.slice(1).map(D=>D[1].resource)),s.push(l[0][1]);s.sort((l,D)=>l.mtime-D.mtime),o.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(l=>l.resource)),o.push(...r),await N.Promises.settled(o.map(l=>(this.logService.trace("Deleting from cache",l.path),this.fileService.del(l))))}}catch(t){this.logService.error(t)}}getName(t){return this.cache?I.ExtensionKey.create(t).toString().toLowerCase():(0,c.generateUuid)()}};e.ExtensionsDownloader=v,e.ExtensionsDownloader=v=b=pe([re(0,d.INativeEnvironmentService),re(1,h.IFileService),re(2,w.IExtensionGalleryService),re(3,g.IConfigurationService),re(4,p.IExtensionSignatureVerificationService),re(5,f.ILogService)],v)}),define(ne[161],se([0,1,51,97]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(A){return(0,N.buffer)(A,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=k}),define(ne[162],se([0,1,8,14,20,33,9,4,42,2,35,15,16,17,43,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,31,26,22,23]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d,w,I,p,h,f,b,v,P,t,o,i,r,n,s,l,D,C,E,L,$,Z,Q,ce,te,le,ue,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,Q.refineServiceDecorator)(i.IExtensionManagementService);const W=".vsctmp";let q=class extends o.AbstractExtensionManagementService{constructor(_,x,a,m,F,U,H,B,oe,ae,ve,de){super(_,x,ve,a,ae,de),this.extensionsScannerService=F,this.extensionsProfileScannerService=U,this.downloadService=H,this.fileService=oe,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new S.ResourceSet;const ge=this._register(B.createInstance(D.ExtensionsLifecycle));this.extensionsScanner=this._register(B.createInstance(V,fe=>ge.postUninstall(fe))),this.manifestCache=this._register(new E.ExtensionsManifestCache(de,oe,ve,this,this.logService)),this.extensionsDownloader=this._register(B.createInstance(l.ExtensionsDownloader));const he=this._register(new L.ExtensionsWatcher(this,this.extensionsScannerService,de,U,ve,oe,a));this._register(he.onDidChangeExtensionsByAnotherSource(fe=>this.onDidChangeExtensionsFromAnotherSource(fe))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,r.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(_){this.logService.trace("ExtensionManagementService#zip",_.identifier.id);const x=await this.collectFiles(_),a=await(0,b.zip)((0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)()).fsPath,x);return p.URI.file(a)}async unzip(_){return this.logService.trace("ExtensionManagementService#unzip",_.toString()),(await this.install(_)).identifier}async getManifest(_){const{location:x,cleanup:a}=await this.downloadVsix(_),m=g.resolve(x.fsPath);try{return await(0,C.getManifest)(m)}finally{await a()}}getInstalled(_,x=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(_??null,x)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(_){return this.extensionsScanner.scanUserExtensionAtLocation(_)}async install(_,x={}){this.logService.trace("ExtensionManagementService#install",_.toString());const{location:a,cleanup:m}=await this.downloadVsix(_);try{const F=await(0,C.getManifest)(g.resolve(a.fsPath)),U=(0,r.getGalleryExtensionId)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,$.isEngineValid)(F.engines.vscode,this.productService.version,this.productService.date))throw new Error(v.localize(0,null,U,this.productService.version));const B=(await this.installExtensions([{manifest:F,extension:a,options:x}])).find(({identifier:oe})=>(0,r.areSameExtensions)(oe,{id:U}));if(B?.local)return B.local;throw B?.error?B.error:(0,o.toExtensionManagementError)(new Error(`Unknown error while installing extension ${U}`))}finally{await m()}}async installFromLocation(_,x){this.logService.trace("ExtensionManagementService#installFromLocation",_.toString());const a=await this.extensionsScanner.scanUserExtensionAtLocation(_);if(!a)throw new Error(`Cannot find a valid extension from the location ${_.toString()}`);return await this.addExtensionsToProfile([[a,void 0]],x),this.logService.info("Successfully installed extension",a.identifier.id,x.toString()),a}async installExtensionsFromProfile(_,x,a){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",_,x.toString(),a.toString());const m=(await this.extensionsScanner.scanExtensions(1,x)).filter(F=>_.some(U=>(0,r.areSameExtensions)(U,F.identifier)));if(m.length){const F=await Promise.all(m.map(U=>this.extensionsScanner.scanMetadata(U,x)));await this.addExtensionsToProfile(m.map((U,H)=>[U,F[H]]),a),this.logService.info("Successfully installed extensions",m.map(U=>U.identifier.id),a.toString())}return m}async updateMetadata(_,x,a=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",_.identifier.id),x.isPreReleaseVersion&&(x.preRelease=!0),x.isMachineScoped=x.isMachineScoped||void 0,x.isBuiltin=x.isBuiltin||void 0,x.pinned=x.pinned||void 0,_=await this.extensionsScanner.updateMetadata(_,x,a),this.manifestCache.invalidate(a),this._onDidUpdateExtensionMetadata.fire(_),_}async reinstallFromGallery(_){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",_.identifier.id),!this.galleryService.isEnabled())throw new Error(v.localize(1,null));const x=await this.getTargetPlatform(),[a]=await this.galleryService.getExtensions([{..._.identifier,preRelease:_.preRelease}],{targetPlatform:x,compatible:!0},k.CancellationToken.None);if(!a)throw new Error(v.localize(2,null));await this.extensionsScanner.setUninstalled(_);try{await this.extensionsScanner.removeUninstalledExtension(_)}catch(m){throw new Error(v.localize(3,null,(0,A.toErrorMessage)(m)))}return this.installFromGallery(a)}copyExtension(_,x,a,m){return this.extensionsScanner.copyExtension(_,x,a,m)}copyExtensions(_,x){return this.extensionsScanner.copyExtensions(_,x)}markAsUninstalled(..._){return this.extensionsScanner.setUninstalled(..._)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(_){this.logService.error(_)}}async download(_,x,a){const{location:m}=await this.extensionsDownloader.download(_,x,!a);return m}async downloadVsix(_){if(_.scheme===R.Schemas.file)return{location:_,async cleanup(){}};this.logService.trace("Downloading extension from",_.toString());const x=(0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)());return await this.downloadService.download(_,x),this.logService.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.fileService.del(x)}catch(m){this.logService.error(m)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(_,x,a){if(p.URI.isUri(x))return new K(_,x,a,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const m=r.ExtensionKey.create(x).toString();let F=this.installGalleryExtensionsTasks.get(m);return F||(this.installGalleryExtensionsTasks.set(m,F=new z(_,x,a,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),F.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(m))),F}createUninstallExtensionTask(_,x){return new X(_,x.profileLocation,this.extensionsProfileScannerService)}async collectFiles(_){const x=async m=>{let F=await f.Promises.readdir(m);F=F.map(B=>g.join(m,B));const U=await Promise.all(F.map(B=>f.Promises.stat(B)));let H=Promise.resolve([]);return U.forEach((B,oe)=>{const ae=F[oe];B.isFile()&&(H=H.then(ve=>[...ve,ae])),B.isDirectory()&&(H=H.then(ve=>x(ae).then(de=>[...ve,...de])))}),H};return(await x(_.location.fsPath)).map(m=>({path:`extension/${g.relative(_.location.fsPath,m)}`,localPath:m}))}async onDidChangeExtensionsFromAnotherSource({added:_,removed:x}){if(x)for(const a of x.extensions)this.logService.info("Extensions removed from another source",a.id,x.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:a,profileLocation:x.profileLocation});if(_){const m=(await this.extensionsScanner.scanExtensions(1,_.profileLocation)).filter(F=>_.extensions.some(U=>(0,r.areSameExtensions)(U,F.identifier)));this._onDidInstallExtensions.fire(m.map(F=>(this.logService.info("Extensions added from another source",F.identifier.id,_.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:_.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(x=>this.knownDirectories.add(x)));const _=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const x of _.children??[])x.isDirectory&&this.knownDirectories.add(x.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(x=>this.onDidFilesChange(x)))}async onDidFilesChange(_){if(!_.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const x=[];for(const a of _.rawAdded){if(this.knownDirectories.has(a)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(a),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(a,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(a).startsWith(".")||!(await this.fileService.stat(a)).isDirectory)continue;const m=await this.extensionsScanner.scanUserExtensionAtLocation(a);m&&m.installedTimestamp===void 0&&(this.knownDirectories.add(a),x.push(m))}x.length&&(await this.addExtensionsToProfile(x.map(a=>[a,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",x.map(a=>a.identifier.id)))}async addExtensionsToProfile(_,x){const a=_.map(m=>m[0]);await this.setInstalled(a),await this.extensionsProfileScannerService.addExtensionsToProfile(_,x),this._onDidInstallExtensions.fire(a.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:x})))}async setInstalled(_){const x=await this.extensionsScanner.getUninstalledExtensions();for(const a of _){const m=r.ExtensionKey.create(a);x[m.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",m.id),await this.extensionsScanner.setInstalled(m),this.logService.info("Removed the extension from uninstalled list:",m.id))}}};e.ExtensionManagementService=q,e.ExtensionManagementService=q=pe([re(0,i.IExtensionGalleryService),re(1,le.ITelemetryService),re(2,ce.ILogService),re(3,t.INativeEnvironmentService),re(4,s.IExtensionsScannerService),re(5,n.IExtensionsProfileScannerService),re(6,P.IDownloadService),re(7,Q.IInstantiationService),re(8,Z.IFileService),re(9,te.IProductService),re(10,ue.IUriIdentityService),re(11,ie.IUserDataProfilesService)],q);let V=class extends c.Disposable{constructor(_,x,a,m,F,U){super(),this.beforeRemovingExtension=_,this.fileService=x,this.extensionsScannerService=a,this.extensionsProfileScannerService=m,this.uriIdentityService=F,this.logService=U,this._onExtract=this._register(new y.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new N.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(_,x){const a={includeInvalid:!0,profileLocation:x};let m=[];return _===null||_===0?m.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},a,!1)):_===1&&m.push(...await this.extensionsScannerService.scanUserExtensions(a)),m=_!==null?m.filter(F=>F.type===_):m,Promise.all(m.map(F=>this.toLocalExtension(F)))}async scanAllUserExtensions(_){const x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!_,includeInvalid:!0});return Promise.all(x.map(a=>this.toLocalExtension(a)))}async scanUserExtensionAtLocation(_){try{const x=await this.extensionsScannerService.scanExistingExtension(_,1,{includeInvalid:!0});if(x)return await this.toLocalExtension(x)}catch(x){this.logService.error(x)}return null}async extractUserExtension(_,x,a,m,F){const U=_.toString(),H=p.URI.file(g.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,h.generateUuid)()}`)),B=p.URI.file(g.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U));let oe=await this.fileService.exists(B);if(oe&&m){try{await this.deleteExtensionFromLocation(_.id,B,"removeExisting")}catch{throw new i.ExtensionManagementError(v.localize(4,null,B.fsPath,_.id),i.ExtensionManagementErrorCode.Delete)}oe=!1}if(!oe)try{try{this.logService.trace(`Started extracting the extension from ${x} to ${B.fsPath}`),await(0,b.extract)(x,H.fsPath,{sourcePath:"extension",overwrite:!0},F),this.logService.info(`Extracted extension to ${B}:`,_.id)}catch(ae){let ve=i.ExtensionManagementErrorCode.Extract;throw ae instanceof b.ExtractError&&(ae.type==="CorruptZip"?ve=i.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(ve=i.ExtensionManagementErrorCode.IncompleteZip)),new i.ExtensionManagementError(ae.message,ve)}await this.extensionsScannerService.updateMetadata(H,a);try{this.logService.trace(`Started renaming the extension from ${H.fsPath} to ${B.fsPath}`),await this.rename(H.fsPath,B.fsPath),this.logService.info("Renamed to",B.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",_.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(ae)}. Deleted from extracted location`,H),ae}this._onExtract.fire(B)}catch(ae){try{await this.fileService.del(H,{recursive:!0})}catch{}throw ae}return this.scanLocalExtension(B,1)}async scanMetadata(_,x){return x?(await this.getScannedExtension(_,x))?.metadata:this.extensionsScannerService.scanMetadata(_.location)}async getScannedExtension(_,x){return(await this.extensionsProfileScannerService.scanProfileExtensions(x)).find(m=>(0,r.areSameExtensions)(m.identifier,_.identifier))}async updateMetadata(_,x,a){return a?await this.extensionsProfileScannerService.updateMetadata([[_,x]],a):await this.extensionsScannerService.updateMetadata(_.location,x),this.scanLocalExtension(_.location,_.type,a)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(..._){const x=_.map(a=>r.ExtensionKey.create(a));await this.withUninstalledExtensions(a=>x.forEach(m=>{a[m.toString()]=!0,this.logService.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(_){await this.withUninstalledExtensions(x=>delete x[_.toString()])}async removeExtension(_,x){if(this.uriIdentityService.extUri.isEqualOrParent(_.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(_.identifier.id,_.location,x)}async removeUninstalledExtension(_){await this.removeExtension(_,"uninstalled"),await this.withUninstalledExtensions(x=>delete x[r.ExtensionKey.create(_).toString()])}async copyExtension(_,x,a,m){const F=await this.getScannedExtension(_,x),U=await this.getScannedExtension(_,a);return m={...F?.metadata,...m},U?await this.extensionsProfileScannerService.updateMetadata([[_,{...U.metadata,...m}]],a):await this.extensionsProfileScannerService.addExtensionsToProfile([[_,m]],a),this.scanLocalExtension(_.location,_.type,a)}async copyExtensions(_,x){const a=await this.scanExtensions(1,_),m=await Promise.all(a.filter(F=>!F.isApplicationScoped).map(async F=>[F,await this.scanMetadata(F,_)]));await this.extensionsProfileScannerService.addExtensionsToProfile(m,x)}async deleteExtensionFromLocation(_,x,a){this.logService.trace(`Deleting ${a} extension from disk`,_,x.fsPath);const m=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(x),`${this.uriIdentityService.extUri.basename(x)}.${(0,u.hash)((0,h.generateUuid)()).toString(16)}${W}`);await this.rename(x.fsPath,m.fsPath),await this.fileService.del(m,{recursive:!0}),this.logService.info(`Deleted ${a} extension from disk`,_,x.fsPath)}async withUninstalledExtensions(_){return this.uninstalledFileLimiter.queue(async()=>{let x;try{x=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(m){if((0,Z.toFileOperationResult)(m)!==1)throw m}let a={};if(x)try{a=JSON.parse(x)}catch{}return _&&(_(a),Object.keys(a).length?await this.fileService.writeFile(this.uninstalledResource,O.VSBuffer.fromString(JSON.stringify(a))):await this.fileService.del(this.uninstalledResource)),a})}async rename(_,x){try{await f.Promises.rename(_,x,2*60*1e3)}catch(a){throw new i.ExtensionManagementError(a.message||v.localize(5,null,_,x),a.code||i.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(_,x,a){if(a){const F=(await this.extensionsScannerService.scanUserExtensions({profileLocation:a})).find(U=>this.uriIdentityService.extUri.isEqual(U.location,_));if(F)return this.toLocalExtension(F)}else{const m=await this.extensionsScannerService.scanExistingExtension(_,x,{includeInvalid:!0});if(m)return this.toLocalExtension(m)}throw new Error(v.localize(6,null,_.path))}async toLocalExtension(_){const x=await this.fileService.resolve(_.location);let a,m;return x.children&&(a=x.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,m=x.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:_.identifier,type:_.type,isBuiltin:_.isBuiltin||!!_.metadata?.isBuiltin,location:_.location,manifest:_.manifest,targetPlatform:_.targetPlatform,validations:_.validations,isValid:_.isValid,readmeUrl:a,changelogUrl:m,publisherDisplayName:_.metadata?.publisherDisplayName||null,publisherId:_.metadata?.publisherId||null,isApplicationScoped:!!_.metadata?.isApplicationScoped,isMachineScoped:!!_.metadata?.isMachineScoped,isPreReleaseVersion:!!_.metadata?.isPreReleaseVersion,preRelease:!!_.metadata?.preRelease,installedTimestamp:_.metadata?.installedTimestamp,updated:!!_.metadata?.updated,pinned:!!_.metadata?.pinned}}async removeUninstalledExtensions(){const _=await this.getUninstalledExtensions();if(Object.keys(_).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(_));const x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const F of x)_[r.ExtensionKey.create(F).toString()]||a.add(F.identifier.id.toLowerCase());try{const F=(0,r.groupByExtension)(x,U=>U.identifier);await N.Promises.settled(F.map(async U=>{const H=U.sort((B,oe)=>w.rcompare(B.manifest.version,oe.manifest.version))[0];a.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(H))}))}catch(F){this.logService.error(F)}const m=x.filter(F=>F.metadata&&_[r.ExtensionKey.create(F).toString()]);await Promise.allSettled(m.map(F=>this.removeUninstalledExtension(F)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let _;try{_=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(x){(0,Z.toFileOperationResult)(x)!==1&&this.logService.error(x);return}if(_?.children)try{await Promise.allSettled(_.children.map(async x=>{if(!(!x.isDirectory||!x.name.endsWith(W))){this.logService.trace("Deleting the temporarily deleted folder",x.resource.toString());try{await this.fileService.del(x.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",x.resource.toString())}catch(a){(0,Z.toFileOperationResult)(a)!==1&&this.logService.error(a)}}}))}catch{}}};e.ExtensionsScanner=V,e.ExtensionsScanner=V=pe([re(1,Z.IFileService),re(2,s.IExtensionsScannerService),re(3,n.IExtensionsProfileScannerService),re(4,ue.IUriIdentityService),re(5,ce.ILogService)],V);class M extends o.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,I.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(_,x,a,m,F,U,H,B,oe){super(),this.identifier=_,this.source=x,this.options=a,this.extensionsScanner=m,this.uriIdentityService=F,this.userDataProfilesService=U,this.extensionsScannerService=H,this.extensionsProfileScannerService=B,this.logService=oe,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(_){const[x,a]=await this.install(_);return this._profileLocation=x.isBuiltin||x.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[x,a]],this._profileLocation),x}async extractExtension({zipPath:_,key:x,metadata:a},m,F){let U=await this.unsetIfUninstalled(x);return U||(this.logService.trace("Extracting extension...",x.id),U=await this.extensionsScanner.extractUserExtension(x,_,a,m,F),this.logService.info("Extracting extension completed.",x.id)),U}async unsetIfUninstalled(_){return await this.isUninstalled(_)?(this.logService.trace("Removing the extension from uninstalled list:",_.id),await this.extensionsScanner.setInstalled(_),this.logService.info("Removed the extension from uninstalled list:",_.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(m=>r.ExtensionKey.create(m).equals(_))):void 0}async isUninstalled(_){return!!(await this.extensionsScanner.getUninstalledExtensions())[_.toString()]}}class z extends M{constructor(_,x,a,m,F,U,H,B,oe,ae){super(x.identifier,x,a,F,U,H,B,oe,ae),this.gallery=x,this.extensionsDownloader=m}async install(_){const a=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(H=>(0,r.areSameExtensions)(H.identifier,this.gallery.identifier));a&&(this._operation=3);const m={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,I.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(a,m),m];const{location:F,verificationStatus:U}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=U,this.validateManifest(F.fsPath),[await this.extractExtension({zipPath:F.fsPath,key:r.ExtensionKey.create(this.gallery),metadata:m},!1,_),m]}catch(H){try{await this.extensionsDownloader.delete(F)}catch(B){this.logService.warn("Error while deleting the downloaded file",F.toString(),(0,T.getErrorMessage)(B))}throw H}}async validateManifest(_){try{await(0,C.getManifest)(_)}catch(x){throw new i.ExtensionManagementError((0,o.joinErrors)(x).message,i.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=z;class K extends M{constructor(_,x,a,m,F,U,H,B,oe,ae){super({id:(0,r.getGalleryExtensionId)(_.publisher,_.name)},x,a,F,U,H,B,oe,ae),this.manifest=_,this.location=x,this.galleryService=m}async doRun(_){const x=await super.doRun(_);return this.updateMetadata(x,_),x}async install(_){const x=new r.ExtensionKey(this.identifier,this.manifest.version),m=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(H=>(0,r.areSameExtensions)(this.identifier,H.identifier)),F={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(m)if(this._operation=3,x.equals(new r.ExtensionKey(m.identifier,m.manifest.version)))try{await this.extensionsScanner.removeExtension(m,"existing")}catch{throw new Error(v.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&w.gt(m.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(m);else{const H=await this.unsetIfUninstalled(x);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(v.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:g.resolve(this.location.fsPath),key:x,metadata:F},!0,_),F]}async updateMetadata(_,x){try{let[a]=await this.galleryService.getExtensions([{id:_.identifier.id,version:_.manifest.version}],x);if(a||([a]=await this.galleryService.getExtensions([{id:_.identifier.id}],x)),a){const m={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(_,m,this.options.profileLocation)}}catch{}}}class X extends o.AbstractExtensionTask{constructor(_,x,a){super(),this.extension=_,this.profileLocation=x,this.extensionsProfileScannerService=a}async doRun(_){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(ne[163],se([0,1,137,8,14,9,3,25,18,138,6,45,136,178]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let w=class extends R.AbstractRequestService{constructor(f,b,v,P){super(P),this.configurationService=f,this.environmentService=b,this.logService=v,this.configure(),this._register(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const f=this.configurationService.getValue("http");this.proxyUrl=f?.proxy,this.strictSSL=!!f?.proxyStrictSSL,this.authorization=f?.proxyAuthorization}async request(f,b){const{proxyUrl:v,strictSSL:P}=this;let t;try{t=await(0,c.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,A.getErrorMessage)(r)))}const o={...process.env,...t},i=f.agent?f.agent:await(0,g.getProxyAgent)(f.url||"",o,{proxyUrl:v,strictSSL:P});return f.agent=i,f.strictSSL=P,this.authorization&&(f.headers={...f.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(f.isChromiumNetwork?"electron":"node",f,()=>p(f,b))}async resolveProxy(f){}};e.RequestService=w,e.RequestService=w=pe([re(0,y.IConfigurationService),re(1,u.INativeEnvironmentService),re(2,S.ILogService),re(3,S.ILoggerService)],w);async function I(h){return((0,N.parse)(h.url).protocol==="https:"?await new Promise((v,P)=>{G(["https"],v,P)}):await new Promise((v,P)=>{G(["http"],v,P)})).request}async function p(h,f){return O.Promises.withAsyncBody(async(b,v)=>{const P=(0,N.parse)(h.url),t=h.getRawRequest?h.getRawRequest(h):await I(h),o={hostname:P.hostname,port:P.port?parseInt(P.port):P.protocol==="https:"?443:80,protocol:P.protocol,path:P.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,T.isBoolean)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(o.auth=h.user+":"+h.password);const i=t(o,r=>{const n=(0,T.isNumber)(h.followRedirects)?h.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&n>0&&r.headers.location)p({...h,url:r.headers.location,followRedirects:n-1},f).then(b,v);else{let s=r;!h.isChromiumNetwork&&r.headers["content-encoding"]==="gzip"&&(s=r.pipe((0,d.createGunzip)())),b({res:r,stream:(0,k.streamToBufferReadableStream)(s)})}});i.on("error",v),h.timeout&&i.setTimeout(h.timeout),h.isChromiumNetwork&&i.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&i.write(h.data),i.end(),f.onCancellationRequested(()=>{i.abort(),v(new A.CancellationError)})})}e.nodeRequest=p}),define(ne[179],se([0,1,32,8,33,9,2,15,16,13,34,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,31,45,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(G,e,N,O,k,A,T,y,u,c,S,R,g,d,w,I,p,h,f,b,v,P,t,o,i,r,n,s,l,D,C,E,L,$,Z,Q,ce,te,le,ue,ie,W,q,V,M,z,K,X,J,_,x,a,m,F,U,H,B,oe,ae,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends T.Disposable{constructor(fe){super(),this.argv=fe,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[fe,Se]=await this.initServices();return fe.invokeFunction(async we=>{const be=we.get(Q.ILogService),Fe=we.get(s.IFileService),j=we.get(h.INativeEnvironmentService),Y=we.get(m.IUserDataProfilesService);be.info("CLI main",this.argv),this.registerErrorHandler(be),await this.doRun(j,Fe,Y,fe),await Promise.all(Se.map(ee=>{(0,O.raceTimeout)(ee.flush(),1e3)}))})}async initServices(){const fe=new L.ServiceCollection,Se={_serviceBrand:void 0,...ue.default};fe.set(ie.IProductService,Se);const we=new f.NativeEnvironmentService(this.argv,Se);fe.set(h.INativeEnvironmentService,we),await Promise.all([we.appSettingsHome.fsPath,we.extensionsPath].map(Oe=>Oe?g.Promises.mkdir(Oe,{recursive:!0}):void 0));const be=new oe.LoggerService((0,Q.getLogLevel)(we),we.logsHome);fe.set(Q.ILoggerService,be);const Fe=this._register(be.createLogger("cli",{name:(0,ae.localize)(0,null)})),j=[];be.getLogLevel()===Q.LogLevel.Trace&&j.push(new Q.ConsoleLogger(be.getLogLevel()));const Y=this._register(new B.LogService(Fe,j));fe.set(Q.ILogService,Y);const ee=this._register(new l.FileService(Y));fe.set(s.IFileService,ee);const me=this._register(new D.DiskFileSystemProvider(Y));ee.registerProvider(y.Schemas.file,me),ee.registerProvider(y.Schemas.vscodeUserData,new ve.FileUserDataProvider(y.Schemas.file,me,y.Schemas.vscodeUserData,Y));const ye=new a.UriIdentityService(ee);fe.set(x.IUriIdentityService,ye);const Le=new V.StateReadonlyService(1,we,Y,ee),Ie=new F.UserDataProfilesReadonlyService(Le,ye,we,ee,Y);fe.set(m.IUserDataProfilesService,Ie);const Ne=c.isWindows&&Se.win32RegValueName?this._register(new le.NativePolicyService(Y,Se.win32RegValueName)):we.policyFile?this._register(new ce.FilePolicyService(we.policyFile,ee,Y)):new te.NullPolicyService;fe.set(te.IPolicyService,Ne);const Ce=this._register(new w.ConfigurationService(Ie.defaultProfile.settingsResource,ee,Ne,Y));fe.set(d.IConfigurationService,Ce),await Promise.all([Le.init(),Ce.initialize()]);let Ae;try{Ae=await(0,U.resolveMachineId)(Le,Y)}catch(Oe){Oe.code!=="ENOENT"&&Y.error(Oe)}Ie.init(),fe.set(x.IUriIdentityService,new a.UriIdentityService(ee));const _e=new q.RequestService(Ce,we,Y,be);fe.set(W.IRequestService,_e),fe.set(I.IDownloadService,new C.SyncDescriptor(p.DownloadService,void 0,!0)),fe.set(o.IExtensionsProfileScannerService,new C.SyncDescriptor(H.ExtensionsProfileScannerService,void 0,!0)),fe.set(i.IExtensionsScannerService,new C.SyncDescriptor(n.ExtensionsScannerService,void 0,!0)),fe.set(P.IExtensionSignatureVerificationService,new C.SyncDescriptor(P.ExtensionSignatureVerificationService,void 0,!0)),fe.set(r.INativeServerExtensionManagementService,new C.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),fe.set(v.IExtensionGalleryService,new C.SyncDescriptor(b.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),fe.set($.ILanguagePackService,new C.SyncDescriptor(Z.NativeLanguagePackService,void 0,!1));const Re=[],Te=(0,X.isInternalTelemetry)(Se,Ce);if((0,X.supportsTelemetry)(Se,we)){Se.aiConfig&&Se.aiConfig.ariaKey&&Re.push(new J.OneDataSystemAppender(_e,Te,"monacoworkbench",null,Se.aiConfig.ariaKey));const Oe={appenders:Re,sendErrorTelemetry:!1,commonProperties:(0,M.resolveCommonProperties)((0,N.release)(),(0,N.hostname)(),process.arch,Se.commit,Se.version,Ae,Te),piiPaths:(0,X.getPiiPathsFromEnvironment)(we)};fe.set(z.ITelemetryService,new C.SyncDescriptor(K.TelemetryService,[Oe],!1))}else fe.set(z.ITelemetryService,X.NullTelemetryService);return[new E.InstantiationService(fe),Re]}registerErrorHandler(fe){(0,A.setUnexpectedErrorHandler)(Se=>{const we=(0,k.toErrorMessage)(Se,!0);we&&fe.error(`[uncaught exception in CLI]: ${we}`)}),process.on("uncaughtException",Se=>{(0,A.isSigPipeError)(Se)||(0,A.onUnexpectedError)(Se)}),process.on("unhandledRejection",Se=>(0,A.onUnexpectedError)(Se))}async doRun(fe,Se,we,be){let Fe;if(fe.args.profile&&(Fe=we.profiles.find(Y=>Y.name===fe.args.profile),!Fe))throw new Error(`Profile '${fe.args.profile}' not found.`);const j=(Fe??we.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return be.createInstance(t.ExtensionManagementCLI,new Q.ConsoleLogger(Q.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,j);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const Y={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:j};return be.createInstance(t.ExtensionManagementCLI,new Q.ConsoleLogger(Q.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),Y,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return be.createInstance(t.ExtensionManagementCLI,new Q.ConsoleLogger(Q.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,j);if(this.argv["locate-extension"])return be.createInstance(t.ExtensionManagementCLI,new Q.ConsoleLogger(Q.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,_.buildTelemetryMessage)(fe.appRoot,fe.extensionsPath))}}asExtensionIdOrVSIX(fe){return fe.map(Se=>/\.vsix$/i.test(Se)?R.URI.file((0,u.isAbsolute)(Se)?Se:(0,u.join)((0,S.cwd)(),Se)):Se)}}async function ge(he){const fe=new de(he);try{await fe.run()}finally{fe.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a5004432af6600c99fa4f918a3f2f8df44df71e6/core/vs/code/node/cliProcessMain.js.map
