/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/base/common/types","vs/nls","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/base/common/resources","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/network","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/voiceRecognition/node/voiceRecognitionService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/code/node/sharedProcess/contrib/voiceTranscriber","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],le=function(ie){for(var e=[],k=0,O=ie.length;k<O;k++)e[k]=ce[ie[k]];return e};define(ce[124],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class k{static get(){const T=new Map,A=new Map,_=new Map,R=new Map;function P(h,f){h.has(f.detail)||h.set(f.detail,-f.timestamp)}function m(h,f){const E=h.get(f.detail);E&&(E>=0||h.set(f.detail,E+f.timestamp))}let I=[];typeof ie=="function"&&typeof ie.getStats=="function"&&(I=ie.getStats().slice(0).sort((h,f)=>h.timestamp-f.timestamp));for(const h of I)switch(h.type){case 10:P(T,h);break;case 11:case 12:m(T,h);break;case 21:P(A,h);break;case 22:m(A,h);break;case 33:P(_,h);break;case 34:m(_,h);break;case 31:P(R,h);break;case 32:m(R,h);break}let y=0;_.forEach(h=>y+=h);function g(h){const f=[];return h.forEach((E,c)=>f.push([c,E])),f}return{amdLoad:g(T),amdInvoke:g(A),nodeRequire:g(_),nodeEval:g(R),nodeRequireTotal:y}}static toMarkdownTable(T,A){let _="";const R=[];return T.forEach((P,m)=>{R[m]=P.length}),A.forEach(P=>{P.forEach((m,I)=>{typeof m>"u"&&(m=P[I]="-");const y=m.toString().length;R[I]=Math.max(y,R[I])})}),T.forEach((P,m)=>{_+=`| ${P+" ".repeat(R[m]-P.toString().length)} `}),_+=`|
`,T.forEach((P,m)=>{_+=`| ${"-".repeat(R[m])} `}),_+=`|
`,A.forEach(P=>{P.forEach((m,I)=>{typeof m<"u"&&(_+=`| ${m+" ".repeat(R[I]-m.toString().length)} `)}),_+=`|
`}),_}}e.LoaderStats=k}),define(ce[83],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function k(_){return(R,P,m)=>{let I=null,y=null;if(typeof m.value=="function"?(I="value",y=m.value):typeof m.get=="function"&&(I="get",y=m.get),!y)throw new Error("not supported");m[I]=_(y,P)}}function O(_,R,P){let m=null,I=null;if(typeof P.value=="function"?(m="value",I=P.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(m="get",I=P.get),!I)throw new Error("not supported");const y=`$memoize$${R}`;P[m]=function(...g){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,g)}),this[y]}}e.memoize=O;function T(_,R,P){return k((m,I)=>{const y=`$debounce$${I}`,g=`$debounce$result$${I}`;return function(...h){this[g]||(this[g]=P?P():void 0),clearTimeout(this[y]),R&&(this[g]=R(this[g],...h),h=[this[g]]),this[y]=setTimeout(()=>{m.apply(this,h),this[g]=P?P():void 0},_)}})}e.debounce=T;function A(_,R,P){return k((m,I)=>{const y=`$throttle$timer$${I}`,g=`$throttle$result$${I}`,h=`$throttle$lastRun$${I}`,f=`$throttle$pending$${I}`;return function(...E){if(this[g]||(this[g]=P?P():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[g]=R(this[g],...E)),this[f])return;const c=this[h]+_;c<=Date.now()?(this[h]=Date.now(),m.apply(this,[this[g]]),this[g]=P?P():void 0):(this[f]=!0,this[y]=setTimeout(()=>{this[f]=!1,this[h]=Date.now(),m.apply(this,[this[g]]),this[g]=P?P():void 0},c-Date.now()))}})}e.throttle=A}),define(ce[8],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?p.isErrorNoTelemetry(o)?new p(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(s=>{s(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=k,e.errorHandler=new k;function O(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=O;function T(t){if(!t||typeof t!="object")return!1;const o=t;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=T;function A(t){m(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=A;function _(t){m(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=_;function R(t){if(t instanceof Error){const{name:o,message:s}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:o,message:s,stack:n,noTelemetry:p.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=R;const P="Canceled";function m(t){return t instanceof I?!0:t instanceof Error&&t.name===P&&t.message===P}e.isCancellationError=m;class I extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=I;function y(){const t=new Error(P);return t.name=t.message,t}e.canceled=y;function g(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=g;function h(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=h;function f(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function E(t){const o=new Error(`${t} has been disposed`);return o.name="DISPOSED",o}e.disposed=E;function c(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=c;class u extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=u;class d extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=d;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class p extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof p)return o;const s=new p;return s.message=o.message,s.stack=o.stack,s}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=p;class L extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,L.prototype)}}e.BugIndicatingError=L}),define(ce[20],le([0,1,8]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMaxIdxBy=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.findLastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function O(X,se=0){return X[X.length-(1+se)]}e.tail=O;function T(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.tail2=T;function A(X,se,te=(he,fe)=>he===fe){if(X===se)return!0;if(!X||!se||X.length!==se.length)return!1;for(let he=0,fe=X.length;he<fe;he++)if(!te(X[he],se[he]))return!1;return!0}e.equals=A;function _(X,se){const te=X.length-1;se<te&&(X[se]=X[te]),X.pop()}e.removeFastWithoutKeepingOrder=_;function R(X,se,te){return P(X.length,he=>te(X[he],se))}e.binarySearch=R;function P(X,se){let te=0,he=X-1;for(;te<=he;){const fe=(te+he)/2|0,pe=se(fe);if(pe<0)te=fe+1;else if(pe>0)he=fe-1;else return fe}return-(te+1)}e.binarySearch2=P;function m(X,se){let te=0,he=X.length;if(he===0)return 0;for(;te<he;){const fe=Math.floor((te+he)/2);se(X[fe])?he=fe:te=fe+1}return te}e.findFirstInSorted=m;function I(X,se,te){if(X=X|0,X>=se.length)throw new TypeError("invalid index");const he=se[Math.floor(se.length*Math.random())],fe=[],pe=[],Ce=[];for(const ke of se){const _e=te(ke,he);_e<0?fe.push(ke):_e>0?pe.push(ke):Ce.push(ke)}return X<fe.length?I(X,fe,te):X<fe.length+Ce.length?Ce[0]:I(X-(fe.length+Ce.length),pe,te)}e.quickSelect=I;function y(X,se){const te=[];let he;for(const fe of X.slice(0).sort(se))!he||se(he[0],fe)!==0?(he=[fe],te.push(he)):he.push(fe);return te}e.groupBy=y;function g(X,se,te){const he=[];function fe(ke,_e,Fe){if(_e===0&&Fe.length===0)return;const ue=he[he.length-1];ue&&ue.start+ue.deleteCount===ke?(ue.deleteCount+=_e,ue.toInsert.push(...Fe)):he.push({start:ke,deleteCount:_e,toInsert:Fe})}let pe=0,Ce=0;for(;;){if(pe===X.length){fe(pe,0,se.slice(Ce));break}if(Ce===se.length){fe(pe,X.length-pe,[]);break}const ke=X[pe],_e=se[Ce],Fe=te(ke,_e);Fe===0?(pe+=1,Ce+=1):Fe<0?(fe(pe,1,[]),pe+=1):Fe>0&&(fe(pe,0,[_e]),Ce+=1)}return he}e.sortedDiff=g;function h(X,se,te){const he=g(X,se,te),fe=[],pe=[];for(const Ce of he)fe.push(...X.slice(Ce.start,Ce.start+Ce.deleteCount)),pe.push(...Ce.toInsert);return{removed:fe,added:pe}}e.delta=h;function f(X,se,te){if(te===0)return[];const he=X.slice(0,te).sort(se);return c(X,se,he,te,X.length),he}e.top=f;function E(X,se,te,he,fe){return te===0?Promise.resolve([]):new Promise((pe,Ce)=>{(async()=>{const ke=X.length,_e=X.slice(0,te).sort(se);for(let Fe=te,ue=Math.min(te+he,ke);Fe<ke;Fe=ue,ue=Math.min(ue+he,ke)){if(Fe>te&&await new Promise(me=>setTimeout(me)),fe&&fe.isCancellationRequested)throw new k.CancellationError;c(X,se,_e,Fe,ue)}return _e})().then(pe,Ce)})}e.topAsync=E;function c(X,se,te,he,fe){for(const pe=te.length;he<fe;he++){const Ce=X[he];if(se(Ce,te[pe-1])<0){te.pop();const ke=m(te,_e=>se(Ce,_e)<0);te.splice(ke,0,Ce)}}}function u(X){return X.filter(se=>!!se)}e.coalesce=u;function d(X){let se=0;for(let te=0;te<X.length;te++)X[te]&&(X[se]=X[te],se+=1);X.length=se}e.coalesceInPlace=d;function v(X,se,te){X.splice(te,0,X.splice(se,1)[0])}e.move=v;function p(X){return!Array.isArray(X)||X.length===0}e.isFalsyOrEmpty=p;function L(X){return Array.isArray(X)&&X.length>0}e.isNonEmptyArray=L;function t(X,se=te=>te){const te=new Set;return X.filter(he=>{const fe=se(he);return te.has(fe)?!1:(te.add(fe),!0)})}e.distinct=t;function o(X){const se=new Set;return te=>{const he=X(te);return se.has(he)?!1:(se.add(he),!0)}}e.uniqueFilter=o;function s(X,se){const te=n(X,se);if(te!==-1)return X[te]}e.findLast=s;function n(X,se){for(let te=X.length-1;te>=0;te--){const he=X[te];if(se(he))return te}return-1}e.findLastIndex=n;function i(X,se){return X.length>0?X[0]:se}e.firstOrDefault=i;function r(X,se){return X.length>0?X[X.length-1]:se}e.lastOrDefault=r;function a(X,se,te=(he,fe)=>he===fe){let he=0;for(let fe=0,pe=Math.min(X.length,se.length);fe<pe&&te(X[fe],se[fe]);fe++)he++;return he}e.commonPrefixLength=a;function w(X){return[].concat(...X)}e.flatten=w;function S(X,se){let te=typeof se=="number"?X:0;typeof se=="number"?te=X:(te=0,se=X);const he=[];if(te<=se)for(let fe=te;fe<se;fe++)he.push(fe);else for(let fe=te;fe>se;fe--)he.push(fe);return he}e.range=S;function l(X,se,te){return X.reduce((he,fe)=>(he[se(fe)]=te?te(fe):fe,he),Object.create(null))}e.index=l;function C(X,se){return X.push(se),()=>U(X,se)}e.insert=C;function U(X,se){const te=X.indexOf(se);if(te>-1)return X.splice(te,1),se}e.remove=U;function N(X,se,te){const he=X.slice(0,se),fe=X.slice(se);return he.concat(te,fe)}e.arrayInsert=N;function F(X,se){let te;if(typeof se=="number"){let he=se;te=()=>{const fe=Math.sin(he++)*179426549;return fe-Math.floor(fe)}}else te=Math.random;for(let he=X.length-1;he>0;he-=1){const fe=Math.floor(te()*(he+1)),pe=X[he];X[he]=X[fe],X[fe]=pe}}e.shuffle=F;function $(X,se){const te=X.indexOf(se);te>-1&&(X.splice(te,1),X.unshift(se))}e.pushToStart=$;function z(X,se){const te=X.indexOf(se);te>-1&&(X.splice(te,1),X.push(se))}e.pushToEnd=z;function J(X,se){for(const te of se)X.push(te)}e.pushMany=J;function H(X,se){return Array.isArray(X)?X.map(se):se(X)}e.mapArrayOrNot=H;function Q(X){return Array.isArray(X)?X:[X]}e.asArray=Q;function B(X){return X[Math.floor(Math.random()*X.length)]}e.getRandomElement=B;function Y(X,se){for(const te of X){const he=se(te);if(he!==void 0)return he}}e.mapFind=Y;function x(X,se,te){const he=q(X,se),fe=X.length,pe=te.length;X.length=fe+pe;for(let Ce=fe-1;Ce>=he;Ce--)X[Ce+pe]=X[Ce];for(let Ce=0;Ce<pe;Ce++)X[Ce+he]=te[Ce]}e.insertInto=x;function j(X,se,te,he){const fe=q(X,se),pe=X.splice(fe,te);return x(X,fe,he),pe}e.splice=j;function q(X,se){return se<0?Math.max(se+X.length,0):Math.min(se,X.length)}var Z;(function(X){function se(pe){return pe<0}X.isLessThan=se;function te(pe){return pe<=0}X.isLessThanOrEqual=te;function he(pe){return pe>0}X.isGreaterThan=he;function fe(pe){return pe===0}X.isNeitherLessOrGreaterThan=fe,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(Z||(e.CompareResult=Z={}));function oe(X,se){return(te,he)=>se(X(te),X(he))}e.compareBy=oe;function ae(...X){return(se,te)=>{for(const he of X){const fe=he(se,te);if(!Z.isNeitherLessOrGreaterThan(fe))return fe}return Z.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const G=(X,se)=>X-se;e.numberComparator=G;const W=(X,se)=>(0,e.numberComparator)(X?1:0,se?1:0);e.booleanComparator=W;function b(X){return(se,te)=>-X(se,te)}e.reverseOrder=b;function D(X,se){if(X.length===0)return;let te=X[0];for(let he=1;he<X.length;he++){const fe=X[he];se(fe,te)>0&&(te=fe)}return te}e.findMaxBy=D;function M(X,se){if(X.length===0)return;let te=X[0];for(let he=1;he<X.length;he++){const fe=X[he];se(fe,te)>=0&&(te=fe)}return te}e.findLastMaxBy=M;function V(X,se){return D(X,(te,he)=>-se(te,he))}e.findMinBy=V;function ee(X,se){if(X.length===0)return-1;let te=0;for(let he=1;he<X.length;he++){const fe=X[he];se(fe,X[te])>0&&(te=he)}return te}e.findMaxIdxBy=ee;class ne{constructor(se){this.items=se,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(se){let te=this.firstIdx;for(;te<this.items.length&&se(this.items[te]);)te++;const he=te===this.firstIdx?null:this.items.slice(this.firstIdx,te);return this.firstIdx=te,he}takeFromEndWhile(se){let te=this.lastIdx;for(;te>=0&&se(this.items[te]);)te--;const he=te===this.lastIdx?null:this.items.slice(te+1,this.lastIdx+1);return this.lastIdx=te,he}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const se=this.items[this.firstIdx];return this.firstIdx++,se}removeLast(){const se=this.items[this.lastIdx];return this.lastIdx--,se}takeCount(se){const te=this.items.slice(this.firstIdx,this.firstIdx+se);return this.firstIdx+=se,te}}e.ArrayQueue=ne;class de{static{this.empty=new de(se=>{})}constructor(se){this.iterate=se}forEach(se){this.iterate(te=>(se(te),!0))}toArray(){const se=[];return this.iterate(te=>(se.push(te),!0)),se}filter(se){return new de(te=>this.iterate(he=>se(he)?te(he):!0))}map(se){return new de(te=>this.iterate(he=>te(se(he))))}some(se){let te=!1;return this.iterate(he=>(te=se(he),!te)),te}findFirst(se){let te;return this.iterate(he=>se(he)?(te=he,!1):!0),te}findLast(se){let te;return this.iterate(he=>(se(he)&&(te=he),!0)),te}findLastMaxBy(se){let te,he=!0;return this.iterate(fe=>((he||Z.isGreaterThan(se(fe,te)))&&(he=!1,te=fe),!0)),te}}e.CallbackIterable=de}),define(ce[125],le([0,1,8]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(P,m){if(!P)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=O;function T(P,m="Unreachable"){throw new Error(m)}e.assertNever=T;function A(P){if(!P)throw new k.BugIndicatingError("Assertion Failed")}e.assert=A;function _(P){if(!P()){debugger;P(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}e.assertFn=_;function R(P,m){let I=0;for(;I<P.length-1;){const y=P[I],g=P[I+1];if(!m(y,g))return!1;I++}return!0}e.checkAdjacentItems=R}),define(ce[84],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(O){const T=this;let A=!1,_;return function(){return A||(A=!0,_=O.apply(T,arguments)),_}}e.once=k}),define(ce[59],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(O){function T(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}O.is=T;const A=Object.freeze([]);function _(){return A}O.empty=_;function*R(p){yield p}O.single=R;function P(p){return T(p)?p:R(p)}O.wrap=P;function m(p){return p||A}O.from=m;function I(p){return!p||p[Symbol.iterator]().next().done===!0}O.isEmpty=I;function y(p){return p[Symbol.iterator]().next().value}O.first=y;function g(p,L){for(const t of p)if(L(t))return!0;return!1}O.some=g;function h(p,L){for(const t of p)if(L(t))return t}O.find=h;function*f(p,L){for(const t of p)L(t)&&(yield t)}O.filter=f;function*E(p,L){let t=0;for(const o of p)yield L(o,t++)}O.map=E;function*c(...p){for(const L of p)for(const t of L)yield t}O.concat=c;function u(p,L,t){let o=t;for(const s of p)o=L(o,s);return o}O.reduce=u;function*d(p,L,t=p.length){for(L<0&&(L+=p.length),t<0?t+=p.length:t>p.length&&(t=p.length);L<t;L++)yield p[L]}O.slice=d;function v(p,L=Number.POSITIVE_INFINITY){const t=[];if(L===0)return[t,p];const o=p[Symbol.iterator]();for(let s=0;s<L;s++){const n=o.next();if(n.done)return[t,O.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return o}}]}O.consume=v})(k||(e.Iterable=k={}))}),define(ce[34],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(k||(e.ScanError=k={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T||(e.ParseErrorCode=T={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function _(t,o=!1){let s=0;const n=t.length;let i="",r=0,a=16,w=0;function S(z){let J=0,H=0;for(;J<z;){const Q=t.charCodeAt(s);if(Q>=48&&Q<=57)H=H*16+Q-48;else if(Q>=65&&Q<=70)H=H*16+Q-65+10;else if(Q>=97&&Q<=102)H=H*16+Q-97+10;else break;s++,J++}return J<z&&(H=-1),H}function l(z){s=z,i="",r=0,a=16,w=0}function C(){const z=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&m(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&m(t.charCodeAt(s)))for(s++;s<t.length&&m(t.charCodeAt(s));)s++;else return w=3,t.substring(z,s);let J=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&m(t.charCodeAt(s))){for(s++;s<t.length&&m(t.charCodeAt(s));)s++;J=s}else w=3;return t.substring(z,J)}function U(){let z="",J=s;for(;;){if(s>=n){z+=t.substring(J,s),w=2;break}const H=t.charCodeAt(s);if(H===34){z+=t.substring(J,s),s++;break}if(H===92){if(z+=t.substring(J,s),s++,s>=n){w=2;break}switch(t.charCodeAt(s++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const B=S(4);B>=0?z+=String.fromCharCode(B):w=4;break}default:w=5}J=s;continue}if(H>=0&&H<=31)if(P(H)){z+=t.substring(J,s),w=2;break}else w=6;s++}return z}function N(){if(i="",w=0,r=s,s>=n)return r=n,a=17;let z=t.charCodeAt(s);if(R(z)){do s++,i+=String.fromCharCode(z),z=t.charCodeAt(s);while(R(z));return a=15}if(P(z))return s++,i+=String.fromCharCode(z),z===13&&t.charCodeAt(s)===10&&(s++,i+=`
`),a=14;switch(z){case 123:return s++,a=1;case 125:return s++,a=2;case 91:return s++,a=3;case 93:return s++,a=4;case 58:return s++,a=6;case 44:return s++,a=5;case 34:return s++,i=U(),a=10;case 47:{const J=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!P(t.charCodeAt(s));)s++;return i=t.substring(J,s),a=12}if(t.charCodeAt(s+1)===42){s+=2;const H=n-1;let Q=!1;for(;s<H;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,Q=!0;break}s++}return Q||(s++,w=1),i=t.substring(J,s),a=13}return i+=String.fromCharCode(z),s++,a=16}case 45:if(i+=String.fromCharCode(z),s++,s===n||!m(t.charCodeAt(s)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=C(),a=11;default:for(;s<n&&F(z);)s++,z=t.charCodeAt(s);if(r!==s){switch(i=t.substring(r,s),i){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return i+=String.fromCharCode(z),s++,a=16}}function F(z){if(R(z)||P(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function $(){let z;do z=N();while(z>=12&&z<=15);return z}return{setPosition:l,getPosition:()=>s,scan:o?$:N,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>r,getTokenLength:()=>s-r,getTokenError:()=>w}}e.createScanner=_;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function P(t){return t===10||t===13||t===8232||t===8233}function m(t){return t>=48&&t<=57}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function y(t,o){const s=[],n=new Object;let i;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function w(S,l,C,U){r.value=S,r.offset=l,r.length=C,r.type=U,r.colonOffset=void 0,i=r}try{v(t,{onObjectBegin:(S,l)=>{if(o<=S)throw n;i=void 0,a=o>S,s.push("")},onObjectProperty:(S,l,C)=>{if(o<l||(w(S,l,C,"property"),s[s.length-1]=S,o<=l+C))throw n},onObjectEnd:(S,l)=>{if(o<=S)throw n;i=void 0,s.pop()},onArrayBegin:(S,l)=>{if(o<=S)throw n;i=void 0,s.push(0)},onArrayEnd:(S,l)=>{if(o<=S)throw n;i=void 0,s.pop()},onLiteralValue:(S,l,C)=>{if(o<l||(w(S,l,C,L(S)),o<=l+C))throw n},onSeparator:(S,l,C)=>{if(o<=l)throw n;if(S===":"&&i&&i.type==="property")i.colonOffset=l,a=!1,i=void 0;else if(S===","){const U=s[s.length-1];typeof U=="number"?s[s.length-1]=U+1:(a=!0,s[s.length-1]=""),i=void 0}}})}catch(S){if(S!==n)throw S}return{path:s,previousNode:i,isAtPropertyKey:a,matches:S=>{let l=0;for(let C=0;l<S.length&&C<s.length;C++)if(S[l]===s[C]||S[l]==="*")l++;else if(S[l]!=="**")return!1;return l===S.length}}}e.getLocation=y;function g(t,o=[],s=A.DEFAULT){let n=null,i=[];const r=[];function a(S){Array.isArray(i)?i.push(S):n!==null&&(i[n]=S)}return v(t,{onObjectBegin:()=>{const S={};a(S),r.push(i),i=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const S=[];a(S),r.push(i),i=S,n=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:a,onError:(S,l,C)=>{o.push({error:S,offset:l,length:C})}},s),i[0]}e.parse=g;function h(t,o=[],s=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function r(S){return n.children.push(S),S}v(t,{onObjectBegin:S=>{n=r({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,l,C)=>{n=r({type:"property",offset:l,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:l,length:C,parent:n})},onObjectEnd:(S,l)=>{n.length=S+l-n.offset,n=n.parent,i(S+l)},onArrayBegin:(S,l)=>{n=r({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,l)=>{n.length=S+l-n.offset,n=n.parent,i(S+l)},onLiteralValue:(S,l,C)=>{r({type:L(S),offset:l,length:C,parent:n,value:S}),i(l+C)},onSeparator:(S,l,C)=>{n.type==="property"&&(S===":"?n.colonOffset=l:S===","&&i(l))},onError:(S,l,C)=>{o.push({error:S,offset:l,length:C})}},s);const w=n.children[0];return w&&delete w.parent,w}e.parseTree=h;function f(t,o){if(!t)return;let s=t;for(const n of o)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let i=!1;for(const r of s.children)if(Array.isArray(r.children)&&r.children[0].value===n){s=r.children[1],i=!0;break}if(!i)return}else{const i=n;if(s.type!=="array"||i<0||!Array.isArray(s.children)||i>=s.children.length)return;s=s.children[i]}return s}e.findNodeAtLocation=f;function E(t){if(!t.parent||!t.parent.children)return[];const o=E(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;o.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&o.push(s)}return o}e.getNodePath=E;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const o=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(o[s.children[0].value]=c(n))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=c;function u(t,o,s=!1){return o>=t.offset&&o<t.offset+t.length||s&&o===t.offset+t.length}e.contains=u;function d(t,o,s=!1){if(u(t,o,s)){const n=t.children;if(Array.isArray(n))for(let i=0;i<n.length&&n[i].offset<=o;i++){const r=d(n[i],o,s);if(r)return r}return t}}e.findNodeAtOffset=d;function v(t,o,s=A.DEFAULT){const n=_(t,!1);function i(oe){return oe?()=>oe(n.getTokenOffset(),n.getTokenLength()):()=>!0}function r(oe){return oe?ae=>oe(ae,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=i(o.onObjectBegin),w=r(o.onObjectProperty),S=i(o.onObjectEnd),l=i(o.onArrayBegin),C=i(o.onArrayEnd),U=r(o.onLiteralValue),N=r(o.onSeparator),F=i(o.onComment),$=r(o.onError),z=s&&s.disallowComments,J=s&&s.allowTrailingComma;function H(){for(;;){const oe=n.scan();switch(n.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:z||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(oe){case 12:case 13:z?Q(10):F();break;case 16:Q(1);break;case 15:case 14:break;default:return oe}}}function Q(oe,ae=[],G=[]){if($(oe),ae.length+G.length>0){let W=n.getToken();for(;W!==17;){if(ae.indexOf(W)!==-1){H();break}else if(G.indexOf(W)!==-1)break;W=H()}}}function B(oe){const ae=n.getTokenValue();return oe?U(ae):w(ae),H(),!0}function Y(){switch(n.getToken()){case 11:{let oe=0;try{oe=JSON.parse(n.getTokenValue()),typeof oe!="number"&&(Q(2),oe=0)}catch{Q(2)}U(oe);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return H(),!0}function x(){return n.getToken()!==10?(Q(3,[],[2,5]),!1):(B(!1),n.getToken()===6?(N(":"),H(),Z()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function j(){a(),H();let oe=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(oe||Q(4,[],[]),N(","),H(),n.getToken()===2&&J)break}else oe&&Q(6,[],[]);x()||Q(4,[],[2,5]),oe=!0}return S(),n.getToken()!==2?Q(7,[2],[]):H(),!0}function q(){l(),H();let oe=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(oe||Q(4,[],[]),N(","),H(),n.getToken()===4&&J)break}else oe&&Q(6,[],[]);Z()||Q(4,[],[4,5]),oe=!0}return C(),n.getToken()!==4?Q(8,[4],[]):H(),!0}function Z(){switch(n.getToken()){case 3:return q();case 1:return j();case 10:return B(!0);default:return Y()}}return H(),n.getToken()===17?s.allowEmptyContent?!0:(Q(4,[],[]),!1):Z()?(n.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.visit=v;function p(t,o){const s=_(t),n=[];let i,r=0,a;do switch(a=s.getPosition(),i=s.scan(),i){case 12:case 13:case 17:r!==a&&n.push(t.substring(r,a)),o!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,o)),r=s.getPosition();break}while(i!==17);return n.join("")}e.stripComments=p;function L(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=L}),define(ce[41],le([0,1,34]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function O(m,I,y){let g,h,f,E,c;if(I){for(E=I.offset,c=E+I.length,f=E;f>0&&!P(m,f-1);)f--;let a=c;for(;a<m.length&&!P(m,a);)a++;h=m.substring(f,a),g=_(h,y)}else h=m,g=0,f=0,E=0,c=m.length;const u=R(y,m);let d=!1,v=0,p;y.insertSpaces?p=A(" ",y.tabSize||4):p="	";const L=(0,k.createScanner)(h,!1);let t=!1;function o(){return u+A(p,g+v)}function s(){let a=L.scan();for(d=!1;a===15||a===14;)d=d||a===14,a=L.scan();return t=a===16||L.getTokenError()!==0,a}const n=[];function i(a,w,S){!t&&w<c&&S>E&&m.substring(w,S)!==a&&n.push({offset:w,length:S-w,content:a})}let r=s();if(r!==17){const a=L.getTokenOffset()+f,w=A(p,g);i(w,f,a)}for(;r!==17;){let a=L.getTokenOffset()+L.getTokenLength()+f,w=s(),S="";for(;!d&&(w===12||w===13);){const C=L.getTokenOffset()+f;i(" ",a,C),a=L.getTokenOffset()+L.getTokenLength()+f,S=w===12?o():"",w=s()}if(w===2)r!==1&&(v--,S=o());else if(w===4)r!==3&&(v--,S=o());else{switch(r){case 3:case 1:v++,S=o();break;case 5:case 12:S=o();break;case 13:d?S=o():S=" ";break;case 6:S=" ";break;case 10:if(w===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?S=" ":w!==5&&w!==17&&(t=!0);break;case 16:t=!0;break}d&&(w===12||w===13)&&(S=o())}const l=L.getTokenOffset()+f;i(S,a,l),r=w}return n}e.format=O;function T(m,I){const y=JSON.stringify(m,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?y.replace(/\r\n|\r|\n/g,I.eol):y}e.toFormattedString=T;function A(m,I){let y="";for(let g=0;g<I;g++)y+=m;return y}function _(m,I){let y=0,g=0;const h=I.tabSize||4;for(;y<m.length;){const f=m.charAt(y);if(f===" ")g++;else if(f==="	")g+=h;else break;y++}return Math.floor(g/h)}function R(m,I){for(let y=0;y<I.length;y++){const g=I.charAt(y);if(g==="\r")return y+1<I.length&&I.charAt(y+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=R;function P(m,I){return`\r
`.indexOf(m.charAt(I))!==-1}e.isEOL=P}),define(ce[85],le([0,1,34,41]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(m,I,y){return A(m,I,void 0,y)}e.removeProperty=T;function A(m,I,y,g,h){const f=I.slice(),E=[],c=(0,k.parseTree)(m,E);let u,d;for(;f.length>0&&(d=f.pop(),u=(0,k.findNodeAtLocation)(c,f),u===void 0&&y!==void 0);)typeof d=="string"?y={[d]:y}:y=[y];if(u)if(u.type==="object"&&typeof d=="string"&&Array.isArray(u.children)){const v=(0,k.findNodeAtLocation)(u,[d]);if(v!==void 0)if(y===void 0){if(!v.parent)throw new Error("Malformed AST");const p=u.children.indexOf(v.parent);let L,t=v.parent.offset+v.parent.length;if(p>0){const o=u.children[p-1];L=o.offset+o.length}else L=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return _(m,{offset:L,length:t-L,content:""},g)}else return _(m,{offset:v.offset,length:v.length,content:JSON.stringify(y)},g);else{if(y===void 0)return[];const p=`${JSON.stringify(d)}: ${JSON.stringify(y)}`,L=h?h(u.children.map(o=>o.children[0].value)):u.children.length;let t;if(L>0){const o=u.children[L-1];t={offset:o.offset+o.length,length:0,content:","+p}}else u.children.length===0?t={offset:u.offset+1,length:0,content:p}:t={offset:u.offset+1,length:0,content:p+","};return _(m,t,g)}}else if(u.type==="array"&&typeof d=="number"&&Array.isArray(u.children))if(y!==void 0){const v=`${JSON.stringify(y)}`;let p;if(u.children.length===0||d===0)p={offset:u.offset+1,length:0,content:u.children.length===0?v:v+","};else{const L=d===-1||d>u.children.length?u.children.length:d,t=u.children[L-1];p={offset:t.offset+t.length,length:0,content:","+v}}return _(m,p,g)}else{const v=d,p=u.children[v];let L;if(u.children.length===1)L={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===v){const t=u.children[v-1],o=t.offset+t.length,s=u.offset+u.length;L={offset:o,length:s-2-o,content:""}}else L={offset:p.offset,length:u.children[v+1].offset-p.offset,content:""};return _(m,L,g)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${u.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return _(m,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(y)},g)}}e.setProperty=A;function _(m,I,y){let g=R(m,I),h=I.offset,f=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;h>0&&!(0,O.isEOL)(g,h-1);)h--;for(;f<g.length&&!(0,O.isEOL)(g,f);)f++}const E=(0,O.format)(g,{offset:h,length:f-h},y);for(let u=E.length-1;u>=0;u--){const d=E[u];g=R(g,d),h=Math.min(h,d.offset),f=Math.max(f,d.offset+d.length),f+=d.content.length-d.length}const c=m.length-(g.length-f)-h;return[{offset:h,length:c,content:g.substring(h,f)}]}e.withFormatting=_;function R(m,I){return m.substring(0,I.offset)+I.content+m.substring(I.offset+I.length)}e.applyEdit=R;function P(m,I){const y=I.slice(0).sort((h,f)=>{const E=h.offset-f.offset;return E===0?h.length-f.length:E});let g=m.length;for(let h=y.length-1;h>=0;h--){const f=y[h];if(f.offset+f.length<=g)m=R(m,f);else throw new Error("Overlapping edit");g=f.offset}return m}e.applyEdits=P}),define(ce[86],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(T){this.executor=T,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=k}),define(ce[2],le([0,1,84,59]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const T=!1;let A=null;function _(r){A=r}if(e.setDisposableTracker=_,T){const r="__is_disposable_tracked__";_(new class{trackDisposable(a){const w=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(w)},3e3)}setParent(a,w){if(a&&a!==d.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==d.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function R(r){return A?.trackDisposable(r),r}function P(r){A?.markAsDisposed(r)}function m(r,a){A?.setParent(r,a)}function I(r,a){if(A)for(const w of r)A.setParent(w,a)}function y(r){return A?.markAsSingleton(r),r}e.markAsSingleton=y;function g(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=g;function h(r){if(O.Iterable.is(r)){const a=[];for(const w of r)if(w)try{w.dispose()}catch(S){a.push(S)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=h;function f(r){for(const a of r)g(a)&&a.dispose();return[]}e.disposeIfDisposable=f;function E(...r){const a=c(()=>h(r));return I(r,a),a}e.combinedDisposable=E;function c(r){const a=R({dispose:(0,k.once)(()=>{P(a),r()})});return a}e.toDisposable=c;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{h(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return m(a,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=u;class d{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new u,R(this),m(this._store,this)}dispose(){P(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=d;class v{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&m(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,P(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&m(a,null),a}}e.MutableDisposable=v;class p{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=p;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(a){let w=a;return this.unset=()=>w=void 0,this.isset=()=>w!==void 0,this.dispose=()=>{w&&(w(),w=void 0,P(this))},this}}e.SafeDisposable=L;class t{constructor(){this.references=new Map}acquire(a,...w){let S=this.references.get(a);S||(S={counter:0,object:this.createReferencedObject(a,...w)},this.references.set(a,S));const{object:l}=S,C=(0,k.once)(()=>{--S.counter===0&&(this.destroyReferencedObject(a,S.object),this.references.delete(a))});return S.counter++,{object:l,dispose:C}}}e.ReferenceCollection=t;class o{constructor(a){this.referenceCollection=a}async acquire(a,...w){const S=this.referenceCollection.acquire(a,...w);try{return{object:await S.object,dispose:()=>S.dispose()}}catch(l){throw S.dispose(),l}}}e.AsyncReferenceCollection=o;class s{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=s;function n(r){const a=new u;try{r(a)}finally{a.dispose()}}e.disposeOnReturn=n;class i{constructor(){this._store=new Map,this._isDisposed=!1,R(this)}dispose(){P(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{h(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,w,S=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),S||this._store.get(a)?.dispose(),this._store.set(a,w)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=i}),define(ce[87],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{static{this.Undefined=new k(void 0)}constructor(A){this.element=A,this.next=k.Undefined,this.prev=k.Undefined}}class O{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let A=this._first;for(;A!==k.Undefined;){const _=A.next;A.prev=k.Undefined,A.next=k.Undefined,A=_}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,_){const R=new k(A);if(this._first===k.Undefined)this._first=R,this._last=R;else if(_){const m=this._last;this._last=R,R.prev=m,m.next=R}else{const m=this._first;this._first=R,R.next=m,m.prev=R}this._size+=1;let P=!1;return()=>{P||(P=!0,this._remove(R))}}shift(){if(this._first!==k.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==k.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==k.Undefined&&A.next!==k.Undefined){const _=A.prev;_.next=A.next,A.next.prev=_}else A.prev===k.Undefined&&A.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):A.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):A.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==k.Undefined;)yield A.element,A=A.next}}e.LinkedList=O}),define(ce[35],le([0,1]),function(ie,e){"use strict";var k,O,T;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(E,c,u){let d=E.get(c);return d===void 0&&(d=u,E.set(c,d)),d}e.getOrSet=A;function _(E){const c=[];return E.forEach((u,d)=>{c.push(`${d} => ${u}`)}),`Map(${E.size}) {${c.join(", ")}}`}e.mapToString=_;function R(E){const c=[];return E.forEach(u=>{c.push(u)}),`Set(${E.size}) {${c.join(", ")}}`}e.setToString=R;class P{constructor(c,u){this.uri=c,this.value=u}}class m{static{this.defaultToKey=c=>c.toString()}constructor(c,u){this[k]="ResourceMap",c instanceof m?(this.map=new Map(c.map),this.toKey=u??m.defaultToKey):(this.map=new Map,this.toKey=c??m.defaultToKey)}set(c,u){return this.map.set(this.toKey(c),new P(c,u)),this}get(c){return this.map.get(this.toKey(c))?.value}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,u){typeof u<"u"&&(c=c.bind(u));for(const[d,v]of this.map)c(v.value,v.uri,this)}*values(){for(const c of this.map.values())yield c.value}*keys(){for(const c of this.map.values())yield c.uri}*entries(){for(const c of this.map.values())yield[c.uri,c.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.map)yield[c.uri,c.value]}}e.ResourceMap=m;class I{constructor(c,u){this[O]="ResourceSet",!c||typeof c=="function"?this._map=new m(c):(this._map=new m(u),c.forEach(this.add,this))}get size(){return this._map.size}add(c){return this._map.set(c,c),this}clear(){this._map.clear()}delete(c){return this._map.delete(c)}forEach(c,u){this._map.forEach((d,v)=>c.call(u,v,v,this))}has(c){return this._map.has(c)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=I;var y;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class g{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(c){return this._map.has(c)}get(c,u=0){const d=this._map.get(c);if(d)return u!==0&&this.touch(d,u),d.value}set(c,u,d=0){let v=this._map.get(c);if(v)v.value=u,d!==0&&this.touch(v,d);else{switch(v={key:c,value:u,next:void 0,previous:void 0},d){case 0:this.addItemLast(v);break;case 1:this.addItemFirst(v);break;case 2:this.addItemLast(v);break;default:this.addItemLast(v);break}this._map.set(c,v),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const u=this._map.get(c);if(u)return this._map.delete(c),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}forEach(c,u){const d=this._state;let v=this._head;for(;v;){if(u?c.bind(u)(v.value,v.key,this):c(v.value,v.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const c=this,u=this._state;let d=this._head;const v={[Symbol.iterator](){return v},next(){if(c._state!==u)throw new Error("LinkedMap got modified during iteration.");if(d){const p={value:d.key,done:!1};return d=d.next,p}else return{value:void 0,done:!0}}};return v}values(){const c=this,u=this._state;let d=this._head;const v={[Symbol.iterator](){return v},next(){if(c._state!==u)throw new Error("LinkedMap got modified during iteration.");if(d){const p={value:d.value,done:!1};return d=d.next,p}else return{value:void 0,done:!0}}};return v}entries(){const c=this,u=this._state;let d=this._head;const v={[Symbol.iterator](){return v},next(){if(c._state!==u)throw new Error("LinkedMap got modified during iteration.");if(d){const p={value:[d.key,d.value],done:!1};return d=d.next,p}else return{value:void 0,done:!0}}};return v}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(c>=this.size)return;if(c===0){this.clear();return}let u=this._head,d=this.size;for(;u&&d>c;)this._map.delete(u.key),u=u.next,d--;this._head=u,this._size=d,u&&(u.previous=void 0),this._state++}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const u=c.next,d=c.previous;if(!u||!d)throw new Error("Invalid list");u.previous=d,d.next=u}c.next=void 0,c.previous=void 0,this._state++}touch(c,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(c===this._head)return;const d=c.next,v=c.previous;c===this._tail?(v.next=void 0,this._tail=v):(d.previous=v,v.next=d),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(u===2){if(c===this._tail)return;const d=c.next,v=c.previous;c===this._head?(d.previous=void 0,this._head=d):(d.previous=v,v.next=d),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((u,d)=>{c.push([d,u])}),c}fromJSON(c){this.clear();for(const[u,d]of c)this.set(u,d)}}e.LinkedMap=g;class h extends g{constructor(c,u=1){super(),this._limit=c,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,u=2){return super.get(c,u)}peek(c){return super.get(c,0)}set(c,u){return super.set(c,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class f{constructor(){this.map=new Map}add(c){return this.map.set(c,(this.map.get(c)||0)+1),this}delete(c){let u=this.map.get(c)||0;return u===0?!1:(u--,u===0?this.map.delete(c):this.map.set(c,u),!0)}has(c){return this.map.has(c)}}e.CounterSet=f}),define(ce[88],le([0,1,35]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const O=new k.LRUCache(1e4);function T(m){return P(m,"NFC",O)}e.normalizeNFC=T;const A=new k.LRUCache(1e4);function _(m){return P(m,"NFD",A)}e.normalizeNFD=_;const R=/[^\u0000-\u0080]/;function P(m,I,y){if(!m)return m;const g=y.get(m);if(g)return g;let h;return R.test(m)?h=m.normalize(I):h=m,y.set(m,h),h}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(I){return _(I).replace(m,"")}}()}),function(){function ie(T){const A=[];typeof T=="number"&&A.push("code/timeOrigin",T);function _(P){A.push(P,Date.now())}function R(){const P=[];for(let m=0;m<A.length;m+=2)P.push({name:A[m],startTime:A[m+1]});return P}return{mark:_,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const _ of performance.getEntriesByType("mark"))A.push({name:_.name,startTime:Math.round(T+_.startTime)});return A}};if(typeof process=="object"){const T=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function k(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=k(O))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var O in k)(typeof exports=="object"?exports:ie)[O]=k[O]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function k(O){if(e[O])return e[O].exports;var T=e[O]={i:O,l:!1,exports:{}};return ie[O].call(T.exports,T,T.exports,k),T.l=!0,T.exports}return k.m=ie,k.c=e,k.d=function(O,T,A){k.o(O,T)||Object.defineProperty(O,T,{enumerable:!0,get:A})},k.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},k.t=function(O,T){if(1&T&&(O=k(O)),8&T||4&T&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(k.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&T&&typeof O!="string")for(var _ in O)k.d(A,_,function(R){return O[R]}.bind(null,_));return A},k.n=function(O){var T=O&&O.__esModule?function(){return O.default}:function(){return O};return k.d(T,"a",T),T},k.o=function(O,T){return Object.prototype.hasOwnProperty.call(O,T)},k.p="",k(k.s=0)}([function(ie,e,k){(function(O){var T;e=ie.exports=G,T=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],P=e.src=[],m=0,I=m++;P[I]="0|[1-9]\\d*";var y=m++;P[y]="[0-9]+";var g=m++;P[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=m++;P[h]="("+P[I]+")\\.("+P[I]+")\\.("+P[I]+")";var f=m++;P[f]="("+P[y]+")\\.("+P[y]+")\\.("+P[y]+")";var E=m++;P[E]="(?:"+P[I]+"|"+P[g]+")";var c=m++;P[c]="(?:"+P[y]+"|"+P[g]+")";var u=m++;P[u]="(?:-("+P[E]+"(?:\\."+P[E]+")*))";var d=m++;P[d]="(?:-?("+P[c]+"(?:\\."+P[c]+")*))";var v=m++;P[v]="[0-9A-Za-z-]+";var p=m++;P[p]="(?:\\+("+P[v]+"(?:\\."+P[v]+")*))";var L=m++,t="v?"+P[h]+P[u]+"?"+P[p]+"?";P[L]="^"+t+"$";var o="[v=\\s]*"+P[f]+P[d]+"?"+P[p]+"?",s=m++;P[s]="^"+o+"$";var n=m++;P[n]="((?:<|>)?=?)";var i=m++;P[i]=P[y]+"|x|X|\\*";var r=m++;P[r]=P[I]+"|x|X|\\*";var a=m++;P[a]="[v=\\s]*("+P[r]+")(?:\\.("+P[r]+")(?:\\.("+P[r]+")(?:"+P[u]+")?"+P[p]+"?)?)?";var w=m++;P[w]="[v=\\s]*("+P[i]+")(?:\\.("+P[i]+")(?:\\.("+P[i]+")(?:"+P[d]+")?"+P[p]+"?)?)?";var S=m++;P[S]="^"+P[n]+"\\s*"+P[a]+"$";var l=m++;P[l]="^"+P[n]+"\\s*"+P[w]+"$";var C=m++;P[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=m++;P[U]="(?:~>?)";var N=m++;P[N]="(\\s*)"+P[U]+"\\s+",R[N]=new RegExp(P[N],"g");var F=m++;P[F]="^"+P[U]+P[a]+"$";var $=m++;P[$]="^"+P[U]+P[w]+"$";var z=m++;P[z]="(?:\\^)";var J=m++;P[J]="(\\s*)"+P[z]+"\\s+",R[J]=new RegExp(P[J],"g");var H=m++;P[H]="^"+P[z]+P[a]+"$";var Q=m++;P[Q]="^"+P[z]+P[w]+"$";var B=m++;P[B]="^"+P[n]+"\\s*("+o+")$|^$";var Y=m++;P[Y]="^"+P[n]+"\\s*("+t+")$|^$";var x=m++;P[x]="(\\s*)"+P[n]+"\\s*("+o+"|"+P[a]+")",R[x]=new RegExp(P[x],"g");var j=m++;P[j]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var q=m++;P[q]="^\\s*("+P[w]+")\\s+-\\s+("+P[w]+")\\s*$";var Z=m++;P[Z]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)T(oe,P[oe]),R[oe]||(R[oe]=new RegExp(P[oe]));function ae(ue,me){if(ue instanceof G)return ue;if(typeof ue!="string"||ue.length>A||!(me?R[s]:R[L]).test(ue))return null;try{return new G(ue,me)}catch{return null}}function G(ue,me){if(ue instanceof G){if(ue.loose===me)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof G))return new G(ue,me);T("SemVer",ue,me),this.loose=me;var ve=ue.trim().match(me?R[s]:R[L]);if(!ve)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var De=+Pe;if(De>=0&&De<_)return De}return Pe}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ue,me){var ve=ae(ue,me);return ve?ve.version:null},e.clean=function(ue,me){var ve=ae(ue.trim().replace(/^[=v]+/,""),me);return ve?ve.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(ue){return T("SemVer.compare",this.version,this.loose,ue),ue instanceof G||(ue=new G(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},G.prototype.compareMain=function(ue){return ue instanceof G||(ue=new G(ue,this.loose)),b(this.major,ue.major)||b(this.minor,ue.minor)||b(this.patch,ue.patch)},G.prototype.comparePre=function(ue){if(ue instanceof G||(ue=new G(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var me=0;do{var ve=this.prerelease[me],Pe=ue.prerelease[me];if(T("prerelease compare",me,ve,Pe),ve===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(ve===void 0)return-1;if(ve!==Pe)return b(ve,Pe)}while(++me)},G.prototype.inc=function(ue,me){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,me,ve,Pe){typeof ve=="string"&&(Pe=ve,ve=void 0);try{return new G(ue,ve).inc(me,Pe).version}catch{return null}},e.diff=function(ue,me){if(ee(ue,me))return null;var ve=ae(ue),Pe=ae(me);if(ve.prerelease.length||Pe.prerelease.length){for(var De in ve)if((De==="major"||De==="minor"||De==="patch")&&ve[De]!==Pe[De])return"pre"+De;return"prerelease"}for(var De in ve)if((De==="major"||De==="minor"||De==="patch")&&ve[De]!==Pe[De])return De},e.compareIdentifiers=b;var W=/^[0-9]+$/;function b(ue,me){var ve=W.test(ue),Pe=W.test(me);return ve&&Pe&&(ue=+ue,me=+me),ve&&!Pe?-1:Pe&&!ve?1:ue<me?-1:ue>me?1:0}function D(ue,me,ve){return new G(ue,ve).compare(new G(me,ve))}function M(ue,me,ve){return D(ue,me,ve)>0}function V(ue,me,ve){return D(ue,me,ve)<0}function ee(ue,me,ve){return D(ue,me,ve)===0}function ne(ue,me,ve){return D(ue,me,ve)!==0}function de(ue,me,ve){return D(ue,me,ve)>=0}function X(ue,me,ve){return D(ue,me,ve)<=0}function se(ue,me,ve,Pe){var De;switch(me){case"===":typeof ue=="object"&&(ue=ue.version),typeof ve=="object"&&(ve=ve.version),De=ue===ve;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof ve=="object"&&(ve=ve.version),De=ue!==ve;break;case"":case"=":case"==":De=ee(ue,ve,Pe);break;case"!=":De=ne(ue,ve,Pe);break;case">":De=M(ue,ve,Pe);break;case">=":De=de(ue,ve,Pe);break;case"<":De=V(ue,ve,Pe);break;case"<=":De=X(ue,ve,Pe);break;default:throw new TypeError("Invalid operator: "+me)}return De}function te(ue,me){if(ue instanceof te){if(ue.loose===me)return ue;ue=ue.value}if(!(this instanceof te))return new te(ue,me);T("comparator",ue,me),this.loose=me,this.parse(ue),this.semver===he?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(ue,me){return b(me,ue)},e.major=function(ue,me){return new G(ue,me).major},e.minor=function(ue,me){return new G(ue,me).minor},e.patch=function(ue,me){return new G(ue,me).patch},e.compare=D,e.compareLoose=function(ue,me){return D(ue,me,!0)},e.rcompare=function(ue,me,ve){return D(me,ue,ve)},e.sort=function(ue,me){return ue.sort(function(ve,Pe){return e.compare(ve,Pe,me)})},e.rsort=function(ue,me){return ue.sort(function(ve,Pe){return e.rcompare(ve,Pe,me)})},e.gt=M,e.lt=V,e.eq=ee,e.neq=ne,e.gte=de,e.lte=X,e.cmp=se,e.Comparator=te;var he={};function fe(ue,me){if(ue instanceof fe)return ue.loose===me?ue:new fe(ue.raw,me);if(ue instanceof te)return new fe(ue.value,me);if(!(this instanceof fe))return new fe(ue,me);if(this.loose=me,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function pe(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function Ce(ue,me,ve,Pe,De,We,Ae,$e,Ne,re,ge,Se,Ee){return((me=pe(ve)?"":pe(Pe)?">="+ve+".0.0":pe(De)?">="+ve+"."+Pe+".0":">="+me)+" "+($e=pe(Ne)?"":pe(re)?"<"+(+Ne+1)+".0.0":pe(ge)?"<"+Ne+"."+(+re+1)+".0":Se?"<="+Ne+"."+re+"."+ge+"-"+Se:"<="+$e)).trim()}function ke(ue,me){for(var ve=0;ve<ue.length;ve++)if(!ue[ve].test(me))return!1;if(me.prerelease.length){for(ve=0;ve<ue.length;ve++)if(T(ue[ve].semver),ue[ve].semver!==he&&ue[ve].semver.prerelease.length>0){var Pe=ue[ve].semver;if(Pe.major===me.major&&Pe.minor===me.minor&&Pe.patch===me.patch)return!0}return!1}return!0}function _e(ue,me,ve){try{me=new fe(me,ve)}catch{return!1}return me.test(ue)}function Fe(ue,me,ve,Pe){var De,We,Ae,$e,Ne;switch(ue=new G(ue,Pe),me=new fe(me,Pe),ve){case">":De=M,We=X,Ae=V,$e=">",Ne=">=";break;case"<":De=V,We=de,Ae=M,$e="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(_e(ue,me,Pe))return!1;for(var re=0;re<me.set.length;++re){var ge=me.set[re],Se=null,Ee=null;if(ge.forEach(function(be){be.semver===he&&(be=new te(">=0.0.0")),Se=Se||be,Ee=Ee||be,De(be.semver,Se.semver,Pe)?Se=be:Ae(be.semver,Ee.semver,Pe)&&(Ee=be)}),Se.operator===$e||Se.operator===Ne||(!Ee.operator||Ee.operator===$e)&&We(ue,Ee.semver)||Ee.operator===Ne&&Ae(ue,Ee.semver))return!1}return!0}te.prototype.parse=function(ue){var me=this.loose?R[B]:R[Y],ve=ue.match(me);if(!ve)throw new TypeError("Invalid comparator: "+ue);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new G(ve[2],this.loose):this.semver=he},te.prototype.toString=function(){return this.value},te.prototype.test=function(ue){return T("Comparator.test",ue,this.loose),this.semver===he||(typeof ue=="string"&&(ue=new G(ue,this.loose)),se(ue,this.operator,this.semver,this.loose))},te.prototype.intersects=function(ue,me){if(!(ue instanceof te))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new fe(ue.value,me),_e(this.value,ve,me);if(ue.operator==="")return ve=new fe(this.value,me),_e(ue.semver,ve,me);var Pe=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),We=this.semver.version===ue.semver.version,Ae=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),$e=se(this.semver,"<",ue.semver,me)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),Ne=se(this.semver,">",ue.semver,me)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return Pe||De||We&&Ae||$e||Ne},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(ue){var me=this.loose;ue=ue.trim(),T("range",ue,me);var ve=me?R[q]:R[j];ue=ue.replace(ve,Ce),T("hyphen replace",ue),ue=ue.replace(R[x],"$1$2$3"),T("comparator trim",ue,R[x]),ue=(ue=(ue=ue.replace(R[N],"$1~")).replace(R[J],"$1^")).split(/\s+/).join(" ");var Pe=me?R[B]:R[Y],De=ue.split(" ").map(function(We){return function(Ae,$e){return T("comp",Ae),Ae=function(Ne,re){return Ne.trim().split(/\s+/).map(function(ge){return function(Se,Ee){T("caret",Se,Ee);var be=Ee?R[Q]:R[H];return Se.replace(be,function(Re,Ie,Le,Te,Ue){var Oe;return T("caret",Se,Re,Ie,Le,Te,Ue),pe(Ie)?Oe="":pe(Le)?Oe=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":pe(Te)?Oe=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":Ue?(T("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Oe=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Te+Ue+" <"+Ie+"."+Le+"."+(+Te+1):">="+Ie+"."+Le+"."+Te+Ue+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Te+Ue+" <"+(+Ie+1)+".0.0"):(T("no pr"),Oe=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Te+" <"+Ie+"."+Le+"."+(+Te+1):">="+Ie+"."+Le+"."+Te+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Te+" <"+(+Ie+1)+".0.0"),T("caret return",Oe),Oe})}(ge,re)}).join(" ")}(Ae,$e),T("caret",Ae),Ae=function(Ne,re){return Ne.trim().split(/\s+/).map(function(ge){return function(Se,Ee){var be=Ee?R[$]:R[F];return Se.replace(be,function(Re,Ie,Le,Te,Ue){var Oe;return T("tilde",Se,Re,Ie,Le,Te,Ue),pe(Ie)?Oe="":pe(Le)?Oe=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":pe(Te)?Oe=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":Ue?(T("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Oe=">="+Ie+"."+Le+"."+Te+Ue+" <"+Ie+"."+(+Le+1)+".0"):Oe=">="+Ie+"."+Le+"."+Te+" <"+Ie+"."+(+Le+1)+".0",T("tilde return",Oe),Oe})}(ge,re)}).join(" ")}(Ae,$e),T("tildes",Ae),Ae=function(Ne,re){return T("replaceXRanges",Ne,re),Ne.split(/\s+/).map(function(ge){return function(Se,Ee){Se=Se.trim();var be=Ee?R[l]:R[S];return Se.replace(be,function(Re,Ie,Le,Te,Ue,Oe){T("xRange",Se,Re,Ie,Le,Te,Ue,Oe);var qe=pe(Le),je=qe||pe(Te),ze=je||pe(Ue);return Ie==="="&&ze&&(Ie=""),qe?Re=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&ze?(je&&(Te=0),ze&&(Ue=0),Ie===">"?(Ie=">=",je?(Le=+Le+1,Te=0,Ue=0):ze&&(Te=+Te+1,Ue=0)):Ie==="<="&&(Ie="<",je?Le=+Le+1:Te=+Te+1),Re=Ie+Le+"."+Te+"."+Ue):je?Re=">="+Le+".0.0 <"+(+Le+1)+".0.0":ze&&(Re=">="+Le+"."+Te+".0 <"+Le+"."+(+Te+1)+".0"),T("xRange return",Re),Re})}(ge,re)}).join(" ")}(Ae,$e),T("xrange",Ae),Ae=function(Ne,re){return T("replaceStars",Ne,re),Ne.trim().replace(R[Z],"")}(Ae,$e),T("stars",Ae),Ae}(We,me)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(We){return!!We.match(Pe)})),De=De.map(function(We){return new te(We,me)})},fe.prototype.intersects=function(ue,me){if(!(ue instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Pe){return ue.set.some(function(De){return De.every(function(We){return Pe.intersects(We,me)})})})})},e.toComparators=function(ue,me){return new fe(ue,me).set.map(function(ve){return ve.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new G(ue,this.loose));for(var me=0;me<this.set.length;me++)if(ke(this.set[me],ue))return!0;return!1},e.satisfies=_e,e.maxSatisfying=function(ue,me,ve){var Pe=null,De=null;try{var We=new fe(me,ve)}catch{return null}return ue.forEach(function(Ae){We.test(Ae)&&(Pe&&De.compare(Ae)!==-1||(De=new G(Pe=Ae,ve)))}),Pe},e.minSatisfying=function(ue,me,ve){var Pe=null,De=null;try{var We=new fe(me,ve)}catch{return null}return ue.forEach(function(Ae){We.test(Ae)&&(Pe&&De.compare(Ae)!==1||(De=new G(Pe=Ae,ve)))}),Pe},e.validRange=function(ue,me){try{return new fe(ue,me).range||"*"}catch{return null}},e.ltr=function(ue,me,ve){return Fe(ue,me,"<",ve)},e.gtr=function(ue,me,ve){return Fe(ue,me,">",ve)},e.outside=Fe,e.prerelease=function(ue,me){var ve=ae(ue,me);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(ue,me,ve){return ue=new fe(ue,ve),me=new fe(me,ve),ue.intersects(me)},e.coerce=function(ue){if(ue instanceof G)return ue;if(typeof ue!="string")return null;var me=ue.match(R[C]);return me==null?null:ae((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,k(1))},function(ie,e){var k,O,T=ie.exports={};function A(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function R(c){if(k===setTimeout)return setTimeout(c,0);if((k===A||!k)&&setTimeout)return k=setTimeout,setTimeout(c,0);try{return k(c,0)}catch{try{return k.call(null,c,0)}catch{return k.call(this,c,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:A}catch{k=A}try{O=typeof clearTimeout=="function"?clearTimeout:_}catch{O=_}})();var P,m=[],I=!1,y=-1;function g(){I&&P&&(I=!1,P.length?m=P.concat(m):y=-1,m.length&&h())}function h(){if(!I){var c=R(g);I=!0;for(var u=m.length;u;){for(P=m,m=[];++y<u;)P&&P[y].run();y=-1,u=m.length}P=null,I=!1,function(d){if(O===clearTimeout)return clearTimeout(d);if((O===_||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(d);try{O(d)}catch{try{return O.call(null,d)}catch{return O.call(this,d)}}}(c)}}function f(c,u){this.fun=c,this.array=u}function E(){}T.nextTick=function(c){var u=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)u[d-1]=arguments[d];m.push(new f(c,u)),m.length!==1||I||R(h)},f.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=E,T.addListener=E,T.once=E,T.off=E,T.removeListener=E,T.removeAllListeners=E,T.emit=E,T.prependListener=E,T.prependOnceListener=E,T.listeners=function(c){return[]},T.binding=function(c){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(c){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(ce[126],le([0,1]),function(ie,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(R,P,m){this.level=R,this.key=P,this.value=m,this.forward=[]}}const T=void 0;class A{constructor(R,P=2**16){this.comparator=R,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(P)|0),this._header=new O(this._maxLevel,T,T)}get size(){return this._size}clear(){this._header=new O(this._maxLevel,T,T)}has(R){return!!A._search(this,R,this.comparator)}get(R){return A._search(this,R,this.comparator)?.value}set(R,P){return A._insert(this,R,P,this.comparator)&&(this._size+=1),this}delete(R){const P=A._delete(this,R,this.comparator);return P&&(this._size-=1),P}forEach(R,P){let m=this._header.forward[0];for(;m;)R.call(P,m.value,m.key,this),m=m.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",P=this._header.forward[0];for(;P;)R+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return R}static _search(R,P,m){let I=R._header;for(let y=R._level-1;y>=0;y--)for(;I.forward[y]&&m(I.forward[y].key,P)<0;)I=I.forward[y];if(I=I.forward[0],I&&m(I.key,P)===0)return I}static _insert(R,P,m,I){const y=[];let g=R._header;for(let h=R._level-1;h>=0;h--){for(;g.forward[h]&&I(g.forward[h].key,P)<0;)g=g.forward[h];y[h]=g}if(g=g.forward[0],g&&I(g.key,P)===0)return g.value=m,!1;{const h=A._randomLevel(R);if(h>R._level){for(let f=R._level;f<h;f++)y[f]=R._header;R._level=h}g=new O(h,P,m);for(let f=0;f<h;f++)g.forward[f]=y[f].forward[f],y[f].forward[f]=g;return!0}}static _randomLevel(R,P=.5){let m=1;for(;Math.random()<P&&m<R._maxLevel;)m+=1;return m}static _delete(R,P,m){const I=[];let y=R._header;for(let g=R._level-1;g>=0;g--){for(;y.forward[g]&&m(y.forward[g].key,P)<0;)y=y.forward[g];I[g]=y}if(y=y.forward[0],!y||m(y.key,P)!==0)return!1;for(let g=0;g<R._level&&I[g].forward[g]===y;g++)I[g].forward[g]=y.forward[g];for(;R._level>0&&R._header.forward[R._level-1]===T;)R._level-=1;return!0}}e.SkipList=A}),define(ce[60],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(A){return new O(A)}constructor(A){this._now=k&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=O}),define(ce[3],le([0,1,8,84,2,87,60]),function(ie,e,k,O,T,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,P=!1;var m;(function(S){S.None=()=>T.Disposable.None;function l(de){if(P){const{onDidAddListener:X}=de,se=f.create();let te=0;de.onDidAddListener=()=>{++te===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),se.print()),X?.()}}}function C(de,X){return B(de,()=>{},0,void 0,!0,void 0,X)}S.defer=C;function U(de){return(X,se=null,te)=>{let he=!1,fe;return fe=de(pe=>{if(!he)return fe?fe.dispose():he=!0,X.call(se,pe)},null,te),he&&fe.dispose(),fe}}S.once=U;function N(de,X,se){return Q((te,he=null,fe)=>de(pe=>te.call(he,X(pe)),null,fe),se)}S.map=N;function F(de,X,se){return Q((te,he=null,fe)=>de(pe=>{X(pe),te.call(he,pe)},null,fe),se)}S.forEach=F;function $(de,X,se){return Q((te,he=null,fe)=>de(pe=>X(pe)&&te.call(he,pe),null,fe),se)}S.filter=$;function z(de){return de}S.signal=z;function J(...de){return(X,se=null,te)=>(0,T.combinedDisposable)(...de.map(he=>he(fe=>X.call(se,fe),null,te)))}S.any=J;function H(de,X,se,te){let he=se;return N(de,fe=>(he=X(he,fe),he),te)}S.reduce=H;function Q(de,X){let se;const te={onWillAddFirstListener(){se=de(he.fire,he)},onDidRemoveLastListener(){se?.dispose()}};X||l(te);const he=new v(te);return X?.add(he),he.event}function B(de,X,se=100,te=!1,he=!1,fe,pe){let Ce,ke,_e,Fe=0,ue;const me={leakWarningThreshold:fe,onWillAddFirstListener(){Ce=de(Pe=>{Fe++,ke=X(ke,Pe),te&&!_e&&(ve.fire(ke),ke=void 0),ue=()=>{const De=ke;ke=void 0,_e=void 0,(!te||Fe>1)&&ve.fire(De),Fe=0},typeof se=="number"?(clearTimeout(_e),_e=setTimeout(ue,se)):_e===void 0&&(_e=0,queueMicrotask(ue))})},onWillRemoveListener(){he&&Fe>0&&ue?.()},onDidRemoveLastListener(){ue=void 0,Ce.dispose()}};pe||l(me);const ve=new v(me);return pe?.add(ve),ve.event}S.debounce=B;function Y(de,X=0,se){return S.debounce(de,(te,he)=>te?(te.push(he),te):[he],X,void 0,!0,void 0,se)}S.accumulate=Y;function x(de,X=(te,he)=>te===he,se){let te=!0,he;return $(de,fe=>{const pe=te||!X(fe,he);return te=!1,he=fe,pe},se)}S.latch=x;function j(de,X,se){return[S.filter(de,X,se),S.filter(de,te=>!X(te),se)]}S.split=j;function q(de,X=!1,se=[]){let te=se.slice(),he=de(Ce=>{te?te.push(Ce):pe.fire(Ce)});const fe=()=>{te?.forEach(Ce=>pe.fire(Ce)),te=null},pe=new v({onWillAddFirstListener(){he||(he=de(Ce=>pe.fire(Ce)))},onDidAddFirstListener(){te&&(X?setTimeout(fe):fe())},onDidRemoveLastListener(){he&&he.dispose(),he=null}});return pe.event}S.buffer=q;class Z{constructor(X){this.event=X,this.disposables=new T.DisposableStore}map(X){return new Z(N(this.event,X,this.disposables))}forEach(X){return new Z(F(this.event,X,this.disposables))}filter(X){return new Z($(this.event,X,this.disposables))}reduce(X,se){return new Z(H(this.event,X,se,this.disposables))}latch(){return new Z(x(this.event,void 0,this.disposables))}debounce(X,se=100,te=!1,he=!1,fe){return new Z(B(this.event,X,se,te,he,fe,this.disposables))}on(X,se,te){return this.event(X,se,te)}once(X,se,te){return U(this.event)(X,se,te)}dispose(){this.disposables.dispose()}}function oe(de){return new Z(de)}S.chain=oe;function ae(de,X,se=te=>te){const te=(...Ce)=>pe.fire(se(...Ce)),he=()=>de.on(X,te),fe=()=>de.removeListener(X,te),pe=new v({onWillAddFirstListener:he,onDidRemoveLastListener:fe});return pe.event}S.fromNodeEventEmitter=ae;function G(de,X,se=te=>te){const te=(...Ce)=>pe.fire(se(...Ce)),he=()=>de.addEventListener(X,te),fe=()=>de.removeEventListener(X,te),pe=new v({onWillAddFirstListener:he,onDidRemoveLastListener:fe});return pe.event}S.fromDOMEventEmitter=G;function W(de){return new Promise(X=>U(de)(X))}S.toPromise=W;function b(de){const X=new v;return de.then(se=>{X.fire(se)},()=>{X.fire(void 0)}).finally(()=>{X.dispose()}),X.event}S.fromPromise=b;function D(de,X){return X(void 0),de(se=>X(se))}S.runAndSubscribe=D;function M(de,X){let se=null;function te(fe){se?.dispose(),se=new T.DisposableStore,X(fe,se)}te(void 0);const he=de(fe=>te(fe));return(0,T.toDisposable)(()=>{he.dispose(),se?.dispose()})}S.runAndSubscribeWithStore=M;class V{constructor(X,se){this._observable=X,this._counter=0,this._hasChanged=!1;const te={onWillAddFirstListener:()=>{X.addObserver(this)},onDidRemoveLastListener:()=>{X.removeObserver(this)}};se||l(te),this.emitter=new v(te),se&&se.add(this.emitter)}beginUpdate(X){this._counter++}handlePossibleChange(X){}handleChange(X,se){this._hasChanged=!0}endUpdate(X){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ee(de,X){return new V(de,X).emitter.event}S.fromObservable=ee;function ne(de){return X=>{let se=0,te=!1;const he={beginUpdate(){se++},endUpdate(){se--,se===0&&(de.reportChanges(),te&&(te=!1,X()))},handlePossibleChange(){},handleChange(){te=!0}};return de.addObserver(he),de.reportChanges(),{dispose(){de.removeObserver(he)}}}}S.fromObservableLight=ne})(m||(e.Event=m={}));class I{static{this.all=new Set}static{this._idPool=0}constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${I._idPool++}`,I.all.add(this)}start(l){this._stopWatch=new _.StopWatch,this.listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=I;let y=-1;function g(S){const l=y;return y=S,{dispose(){y=l}}}e.setGlobalLeakWarningThreshold=g;class h{constructor(l,C=Math.random().toString(18).slice(2,5)){this.threshold=l,this.name=C,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(l,C){const U=this.threshold;if(U<=0||C<U)return;this._stacks||(this._stacks=new Map);const N=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,N+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=U*.5;let F,$=0;for(const[z,J]of this._stacks)(!F||$<J)&&(F=z,$=J);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${$}):`),console.warn(F)}return()=>{const F=this._stacks.get(l.value)||0;this._stacks.set(l.value,F-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class c{constructor(l){this.value=l,this.id=E++}}const u=2,d=(S,l)=>{if(S instanceof c)l(S);else for(let C=0;C<S.length;C++){const U=S[C];U&&l(U)}};class v{constructor(l){this._size=0,this._options=l,this._leakageMon=y>0||this._options?.leakWarningThreshold?new h(this._options?.leakWarningThreshold??y):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(R){const l=this._listeners;queueMicrotask(()=>{d(l,C=>C.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(l,C,U)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),T.Disposable.None;if(this._disposed)return T.Disposable.None;C&&(l=l.bind(C));const N=new c(l);let F,$;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(N.stack=f.create(),F=this._leakageMon.check(N.stack,this._size+1)),R&&(N.stack=$??f.create()),this._listeners?this._listeners instanceof c?(this._deliveryQueue??=new L,this._listeners=[this._listeners,N]):this._listeners.push(N):(this._options?.onWillAddFirstListener?.(this),this._listeners=N,this._options?.onDidAddFirstListener?.(this)),this._size++;const z=(0,T.toDisposable)(()=>{F?.(),this._removeListener(N)});return U instanceof T.DisposableStore?U.add(z):Array.isArray(U)&&U.push(z),z},this._event}_removeListener(l){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const C=this._listeners,U=C.indexOf(l);if(U===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,C[U]=void 0;const N=this._deliveryQueue.current===this;if(this._size*u<=C.length){let F=0;for(let $=0;$<C.length;$++)C[$]?C[F++]=C[$]:N&&(this._deliveryQueue.end--,F<this._deliveryQueue.i&&this._deliveryQueue.i--);C.length=F}}_deliver(l,C){if(!l)return;const U=this._options?.onListenerError||k.onUnexpectedError;if(!U){l.value(C);return}try{l.value(C)}catch(N){U(N)}}_deliverQueue(l){const C=l.current._listeners;for(;l.i<l.end;)this._deliver(C[l.i++],l.value);l.reset()}fire(l){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof c)this._deliver(this._listeners,l);else{const C=this._deliveryQueue;C.enqueue(this,l,this._listeners.length),this._deliverQueue(C)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=v;const p=()=>new L;e.createEventDeliveryQueue=p;class L{constructor(){this.i=-1,this.end=0}enqueue(l,C,U){this.i=0,this.end=U,this.current=l,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends v{async fireAsync(l,C,U){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),d(this._listeners,N=>this._asyncDeliveryQueue.push([N.value,l]));this._asyncDeliveryQueue.size>0&&!C.isCancellationRequested;){const[N,F]=this._asyncDeliveryQueue.shift(),$=[],z={...F,token:C,waitUntil:J=>{if(Object.isFrozen($))throw new Error("waitUntil can NOT be called asynchronous");U&&(J=U(J,N)),$.push(J)}};try{N(z)}catch(J){(0,k.onUnexpectedError)(J);continue}Object.freeze($),await Promise.allSettled($).then(J=>{for(const H of J)H.status==="rejected"&&(0,k.onUnexpectedError)(H.reason)})}}}e.AsyncEmitter=t;class o extends v{get isPaused(){return this._isPaused!==0}constructor(l){super(l),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._size&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=o;class s extends o{constructor(l){super(l),this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=s;class n extends v{constructor(l){super(l),this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this.hasListeners()&&(this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(C=>super.fire(C)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=n;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const C={event:l,listener:null};this.events.push(C),this.hasListeners&&this.hook(C);const U=()=>{this.hasListeners&&this.unhook(C);const N=this.events.indexOf(C);this.events.splice(N,1)};return(0,T.toDisposable)((0,O.once)(U))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(C=>this.emitter.fire(C))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class r{constructor(l,C,U,N){this._store=new T.DisposableStore;const F=this._store.add(new i),$=this._store.add(new T.DisposableMap);function z(J){$.set(J,F.add(N(J)))}for(const J of l)z(J);this._store.add(C(J=>{z(J)})),this._store.add(U(J=>{$.deleteAndDispose(J)})),this.event=F.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=r;class a{constructor(){this.buffers=[]}wrapEvent(l){return(C,U,N)=>l(F=>{const $=this.buffers[this.buffers.length-1];$?$.push(()=>C.call(U,F)):C.call(U,F)},void 0,N)}bufferEvents(l){const C=[];this.buffers.push(C);const U=l();return this.buffers.pop(),C.forEach(N=>N()),U}}e.EventBufferer=a;class w{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=T.Disposable.None,this.emitter=new v({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(ce[25],le([0,1,3]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const O=Object.freeze(function(R,P){const m=setTimeout(R.bind(P),0);return{dispose(){clearTimeout(m)}}});var T;(function(R){function P(m){return m===R.None||m===R.Cancelled||m instanceof A?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}R.isCancellationToken=P,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(T||(e.CancellationToken=T={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?O:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(P){this._token=void 0,this._parentListener=void 0,this._parentListener=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=T.Cancelled}dispose(P=!1){P&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=_}),define(ce[127],le([0,1,25]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class O{constructor(R){this.task=R,this.result=null}get(){if(this.result)return this.result;const R=new k.CancellationTokenSource,P=this.task(R.token);return this.result={promise:P,dispose:()=>{this.result=null,R.cancel(),R.dispose()}},this.result}}e.Cache=O;class T{constructor(R){this.fn=R,this.lastCache=void 0,this.lastArgKey=void 0}get(R){const P=JSON.stringify(R);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.fn(R)),this.lastCache}}e.LRUCachedFunction=T;class A{get cachedValues(){return this._map}constructor(R){this.fn=R,this._map=new Map}get(R){if(this._map.has(R))return this._map.get(R);const P=this.fn(R);return this._map.set(R,P),P}}e.CachedFunction=A}),define(ce[42],le([0,1,8,2]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function T(p){const L=p;return L?typeof L.read=="function":!1}e.isReadable=T;function A(p){const L=p;return L?[L.on,L.pause,L.resume,L.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function _(p){const L=p;return L?A(L.stream)&&Array.isArray(L.buffer)&&typeof L.ended=="boolean":!1}e.isReadableBufferedStream=_;function R(p,L){return new P(p,L)}e.newWriteableStream=R;class P{constructor(L,t){this.reducer=L,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(L){if(!this.state.destroyed){if(this.state.flowing)this.emitData(L);else if(this.buffer.data.push(L),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(L){this.state.destroyed||(this.state.flowing?this.emitError(L):this.buffer.error.push(L))}end(L){this.state.destroyed||(typeof L<"u"&&this.write(L),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(L){this.listeners.data.slice(0).forEach(t=>t(L))}emitError(L){this.listeners.error.length===0?(0,k.onUnexpectedError)(L):this.listeners.error.slice(0).forEach(t=>t(L))}emitEnd(){this.listeners.end.slice(0).forEach(L=>L())}on(L,t){if(!this.state.destroyed)switch(L){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(L,t){if(this.state.destroyed)return;let o;switch(L){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const s=o.indexOf(t);s>=0&&o.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const L=this.reducer(this.buffer.data);this.emitData(L),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const L of this.buffer.error)this.emitError(L);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(p,L){const t=[];let o;for(;(o=p.read())!==null;)t.push(o);return L(t)}e.consumeReadable=m;function I(p,L,t){const o=[];let s;for(;(s=p.read())!==null&&o.length<t;)o.push(s);return s===null&&o.length>0?L(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return p.read()}}}e.peekReadable=I;function y(p,L){return new Promise((t,o)=>{const s=[];g(p,{onData:n=>{L&&s.push(n)},onError:n=>{L?o(n):t(void 0)},onEnd:()=>{t(L?L(s):void 0)}})})}e.consumeStream=y;function g(p,L,t){p.on("error",o=>{t?.isCancellationRequested||L.onError(o)}),p.on("end",()=>{t?.isCancellationRequested||L.onEnd()}),p.on("data",o=>{t?.isCancellationRequested||L.onData(o)})}e.listenStream=g;function h(p,L){return new Promise((t,o)=>{const s=new O.DisposableStore,n=[],i=w=>{if(n.push(w),n.length>L)return s.dispose(),p.pause(),t({stream:p,buffer:n,ended:!1})},r=w=>o(w),a=()=>t({stream:p,buffer:n,ended:!0});s.add((0,O.toDisposable)(()=>p.removeListener("error",r))),p.on("error",r),s.add((0,O.toDisposable)(()=>p.removeListener("end",a))),p.on("end",a),s.add((0,O.toDisposable)(()=>p.removeListener("data",i))),p.on("data",i)})}e.peekStream=h;function f(p,L){const t=R(L);return t.end(p),t}e.toStream=f;function E(){const p=R(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=E;function c(p){let L=!1;return{read:()=>L?null:(L=!0,p)}}e.toReadable=c;function u(p,L,t){const o=R(t);return g(p,{onData:s=>o.write(L.data(s)),onError:s=>o.error(L.error?L.error(s):s),onEnd:()=>o.end()}),o}e.transform=u;function d(p,L,t){let o=!1;return{read:()=>{const s=L.read();return o?s:(o=!0,s!==null?t([p,s]):p)}}}e.prefixedReadable=d;function v(p,L,t){let o=!1;const s=R(t);return g(L,{onData:n=>o?s.write(n):(o=!0,s.write(t([p,n]))),onError:n=>s.error(n),onEnd:()=>{o||(o=!0,s.write(p)),s.end()}}),s}e.prefixedStream=v}),define(ce[14],le([0,1,86,42]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const T=typeof Buffer<"u",A=new k.Lazy(()=>new Uint8Array(256));let _,R;class P{static alloc(C){return T?new P(Buffer.allocUnsafe(C)):new P(new Uint8Array(C))}static wrap(C){return T&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new P(C)}static fromString(C,U){return!(U?.dontUseNodeBuffer||!1)&&T?new P(Buffer.from(C)):(_||(_=new TextEncoder),new P(_.encode(C)))}static fromByteArray(C){const U=P.alloc(C.length);for(let N=0,F=C.length;N<F;N++)U.buffer[N]=C[N];return U}static concat(C,U){if(typeof U>"u"){U=0;for(let $=0,z=C.length;$<z;$++)U+=C[$].byteLength}const N=P.alloc(U);let F=0;for(let $=0,z=C.length;$<z;$++){const J=C[$];N.set(J,F),F+=J.byteLength}return N}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=P.alloc(this.byteLength);return C.set(this),C}toString(){return T?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(C,U){return new P(this.buffer.subarray(C,U))}set(C,U){if(C instanceof P)this.buffer.set(C.buffer,U);else if(C instanceof Uint8Array)this.buffer.set(C,U);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),U);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),U);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return g(this.buffer,C)}writeUInt32BE(C,U){h(this.buffer,C,U)}readUInt32LE(C){return f(this.buffer,C)}writeUInt32LE(C,U){E(this.buffer,C,U)}readUInt8(C){return c(this.buffer,C)}writeUInt8(C,U){u(this.buffer,C,U)}indexOf(C,U=0){return m(this.buffer,C instanceof P?C.buffer:C,U)}}e.VSBuffer=P;function m(l,C,U=0){const N=C.byteLength,F=l.byteLength;if(N===0)return 0;if(N===1)return l.indexOf(C[0]);if(N>F-U)return-1;const $=A.value;$.fill(C.length);for(let Q=0;Q<C.length;Q++)$[C[Q]]=C.length-Q-1;let z=U+C.length-1,J=z,H=-1;for(;z<F;)if(l[z]===C[J]){if(J===0){H=z;break}z--,J--}else z+=Math.max(C.length-J,$[l[z]]),J=C.length-1;return H}e.binaryIndexOf=m;function I(l,C){return l[C+0]<<0>>>0|l[C+1]<<8>>>0}e.readUInt16LE=I;function y(l,C,U){l[U+0]=C&255,C=C>>>8,l[U+1]=C&255}e.writeUInt16LE=y;function g(l,C){return l[C]*2**24+l[C+1]*2**16+l[C+2]*2**8+l[C+3]}e.readUInt32BE=g;function h(l,C,U){l[U+3]=C,C=C>>>8,l[U+2]=C,C=C>>>8,l[U+1]=C,C=C>>>8,l[U]=C}e.writeUInt32BE=h;function f(l,C){return l[C+0]<<0>>>0|l[C+1]<<8>>>0|l[C+2]<<16>>>0|l[C+3]<<24>>>0}e.readUInt32LE=f;function E(l,C,U){l[U+0]=C&255,C=C>>>8,l[U+1]=C&255,C=C>>>8,l[U+2]=C&255,C=C>>>8,l[U+3]=C&255}e.writeUInt32LE=E;function c(l,C){return l[C]}e.readUInt8=c;function u(l,C,U){l[U]=C}e.writeUInt8=u;function d(l){return O.consumeReadable(l,C=>P.concat(C))}e.readableToBuffer=d;function v(l){return O.toReadable(l)}e.bufferToReadable=v;function p(l){return O.consumeStream(l,C=>P.concat(C))}e.streamToBuffer=p;async function L(l){return l.ended?P.concat(l.buffer):P.concat([...l.buffer,await p(l.stream)])}e.bufferedStreamToBuffer=L;function t(l){return O.toStream(l,C=>P.concat(C))}e.bufferToStream=t;function o(l){return O.transform(l,{data:C=>typeof C=="string"?P.fromString(C):P.wrap(C)},C=>P.concat(C))}e.streamToBufferReadableStream=o;function s(l){return O.newWriteableStream(C=>P.concat(C),l)}e.newWriteableBufferStream=s;function n(l,C){return O.prefixedReadable(l,C,U=>P.concat(U))}e.prefixedBufferReadable=n;function i(l,C){return O.prefixedStream(l,C,U=>P.concat(U))}e.prefixedBufferStream=i;function r(l){let C=0,U=0,N=0;const F=new Uint8Array(Math.floor(l.length/4*3)),$=J=>{switch(U){case 3:F[N++]=C|J,U=0;break;case 2:F[N++]=C|J>>>2,C=J<<6,U=3;break;case 1:F[N++]=C|J>>>4,C=J<<4,U=2;break;default:C=J<<2,U=1}};for(let J=0;J<l.length;J++){const H=l.charCodeAt(J);if(H>=65&&H<=90)$(H-65);else if(H>=97&&H<=122)$(H-97+26);else if(H>=48&&H<=57)$(H-48+52);else if(H===43||H===45)$(62);else if(H===47||H===95)$(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${l[J]}`)}}const z=N;for(;U>0;)$(0);return P.wrap(F).slice(0,z)}e.decodeBase64=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:l},C=!0,U=!1){const N=U?w:a;let F="";const $=l.byteLength%3;let z=0;for(;z<l.byteLength-$;z+=3){const J=l[z+0],H=l[z+1],Q=l[z+2];F+=N[J>>>2],F+=N[(J<<4|H>>>4)&63],F+=N[(H<<2|Q>>>6)&63],F+=N[Q&63]}if($===1){const J=l[z+0];F+=N[J>>>2],F+=N[J<<4&63],C&&(F+="==")}else if($===2){const J=l[z+0],H=l[z+1];F+=N[J>>>2],F+=N[(J<<4|H>>>4)&63],F+=N[H<<2&63],C&&(F+="=")}return F}e.encodeBase64=S}),define(ce[28],le([0,1,127,86]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function _(re,...ge){return ge.length===0?re:re.replace(A,function(Se,Ee){const be=parseInt(Ee,10);return isNaN(be)||be<0||be>=ge.length?Se:ge[be]})}e.format=_;const R=/{([^}]+)}/g;function P(re,ge){return re.replace(R,(Se,Ee)=>ge[Ee]??Se)}e.format2=P;function m(re){return re.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.escape=m;function I(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function y(re,ge){let Se=0;const Ee=ge.charCodeAt(0);for(let be=re.length-1;be>=0;be--)re.charCodeAt(be)===Ee&&Se++;return Se}e.count=y;function g(re,ge,Se="\u2026"){return re.length<=ge?re:`${re.substr(0,ge)}${Se}`}e.truncate=g;function h(re,ge=" "){const Se=f(re,ge);return E(Se,ge)}e.trim=h;function f(re,ge){if(!re||!ge)return re;const Se=ge.length;if(Se===0||re.length===0)return re;let Ee=0;for(;re.indexOf(ge,Ee)===Ee;)Ee=Ee+Se;return re.substring(Ee)}e.ltrim=f;function E(re,ge){if(!re||!ge)return re;const Se=ge.length,Ee=re.length;if(Se===0||Ee===0)return re;let be=Ee,Re=-1;for(;Re=re.lastIndexOf(ge,be-1),!(Re===-1||Re+Se!==be);){if(Re===0)return"";be=Re}return re.substring(0,be)}e.rtrim=E;function c(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function u(re){return re.replace(/\*/g,"")}e.stripWildcards=u;function d(re,ge,Se={}){if(!re)throw new Error("Cannot create regex from empty string");ge||(re=I(re)),Se.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let Ee="";return Se.global&&(Ee+="g"),Se.matchCase||(Ee+="i"),Se.multiline&&(Ee+="m"),Se.unicode&&(Ee+="u"),new RegExp(re,Ee)}e.createRegExp=d;function v(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function p(re){return re.split(/\r\n|\r|\n/)}e.splitLines=p;function L(re){for(let ge=0,Se=re.length;ge<Se;ge++){const Ee=re.charCodeAt(ge);if(Ee!==32&&Ee!==9)return ge}return-1}e.firstNonWhitespaceIndex=L;function t(re,ge=0,Se=re.length){for(let Ee=ge;Ee<Se;Ee++){const be=re.charCodeAt(Ee);if(be!==32&&be!==9)return re.substring(ge,Ee)}return re.substring(ge,Se)}e.getLeadingWhitespace=t;function o(re,ge=re.length-1){for(let Se=ge;Se>=0;Se--){const Ee=re.charCodeAt(Se);if(Ee!==32&&Ee!==9)return Se}return-1}e.lastNonWhitespaceIndex=o;function s(re,ge,Se){const Ee=[];let be=0;for(const Re of re.matchAll(ge)){if(Ee.push(re.slice(be,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");be=Re.index+Re[0].length,Ee.push(Se(Re[0],...Re.slice(1),Re.index,re,Re.groups))}return Ee.push(re.slice(be)),Promise.all(Ee).then(Re=>Re.join(""))}e.replaceAsync=s;function n(re,ge){return re<ge?-1:re>ge?1:0}e.compare=n;function i(re,ge,Se=0,Ee=re.length,be=0,Re=ge.length){for(;Se<Ee&&be<Re;Se++,be++){const Te=re.charCodeAt(Se),Ue=ge.charCodeAt(be);if(Te<Ue)return-1;if(Te>Ue)return 1}const Ie=Ee-Se,Le=Re-be;return Ie<Le?-1:Ie>Le?1:0}e.compareSubstring=i;function r(re,ge){return a(re,ge,0,re.length,0,ge.length)}e.compareIgnoreCase=r;function a(re,ge,Se=0,Ee=re.length,be=0,Re=ge.length){for(;Se<Ee&&be<Re;Se++,be++){let Te=re.charCodeAt(Se),Ue=ge.charCodeAt(be);if(Te===Ue)continue;if(Te>=128||Ue>=128)return i(re.toLowerCase(),ge.toLowerCase(),Se,Ee,be,Re);S(Te)&&(Te-=32),S(Ue)&&(Ue-=32);const Oe=Te-Ue;if(Oe!==0)return Oe}const Ie=Ee-Se,Le=Re-be;return Ie<Le?-1:Ie>Le?1:0}e.compareSubstringIgnoreCase=a;function w(re){return re>=48&&re<=57}e.isAsciiDigit=w;function S(re){return re>=97&&re<=122}e.isLowerAsciiLetter=S;function l(re){return re>=65&&re<=90}e.isUpperAsciiLetter=l;function C(re,ge){return re.length===ge.length&&a(re,ge)===0}e.equalsIgnoreCase=C;function U(re,ge){const Se=ge.length;return ge.length>re.length?!1:a(re,ge,0,Se)===0}e.startsWithIgnoreCase=U;function N(re,ge){const Se=Math.min(re.length,ge.length);let Ee;for(Ee=0;Ee<Se;Ee++)if(re.charCodeAt(Ee)!==ge.charCodeAt(Ee))return Ee;return Se}e.commonPrefixLength=N;function F(re,ge){const Se=Math.min(re.length,ge.length);let Ee;const be=re.length-1,Re=ge.length-1;for(Ee=0;Ee<Se;Ee++)if(re.charCodeAt(be-Ee)!==ge.charCodeAt(Re-Ee))return Ee;return Se}e.commonSuffixLength=F;function $(re){return 55296<=re&&re<=56319}e.isHighSurrogate=$;function z(re){return 56320<=re&&re<=57343}e.isLowSurrogate=z;function J(re,ge){return(re-55296<<10)+(ge-56320)+65536}e.computeCodePoint=J;function H(re,ge,Se){const Ee=re.charCodeAt(Se);if($(Ee)&&Se+1<ge){const be=re.charCodeAt(Se+1);if(z(be))return J(Ee,be)}return Ee}e.getNextCodePoint=H;function Q(re,ge){const Se=re.charCodeAt(ge-1);if(z(Se)&&ge>1){const Ee=re.charCodeAt(ge-2);if($(Ee))return J(Ee,Se)}return Se}class B{get offset(){return this._offset}constructor(ge,Se=0){this._str=ge,this._len=ge.length,this._offset=Se}setOffset(ge){this._offset=ge}prevCodePoint(){const ge=Q(this._str,this._offset);return this._offset-=ge>=65536?2:1,ge}nextCodePoint(){const ge=H(this._str,this._len,this._offset);return this._offset+=ge>=65536?2:1,ge}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class Y{get offset(){return this._iterator.offset}constructor(ge,Se=0){this._iterator=new B(ge,Se)}nextGraphemeLength(){const ge=me.getInstance(),Se=this._iterator,Ee=Se.offset;let be=ge.getGraphemeBreakType(Se.nextCodePoint());for(;!Se.eol();){const Re=Se.offset,Ie=ge.getGraphemeBreakType(Se.nextCodePoint());if(Fe(be,Ie)){Se.setOffset(Re);break}be=Ie}return Se.offset-Ee}prevGraphemeLength(){const ge=me.getInstance(),Se=this._iterator,Ee=Se.offset;let be=ge.getGraphemeBreakType(Se.prevCodePoint());for(;Se.offset>0;){const Re=Se.offset,Ie=ge.getGraphemeBreakType(Se.prevCodePoint());if(Fe(Ie,be)){Se.setOffset(Re);break}be=Ie}return Ee-Se.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function x(re,ge){return new Y(re,ge).nextGraphemeLength()}e.nextCharLength=x;function j(re,ge){return new Y(re,ge).prevGraphemeLength()}e.prevCharLength=j;function q(re,ge){ge>0&&z(re.charCodeAt(ge))&&ge--;const Se=ge+x(re,ge);return[Se-j(re,Se),Se]}e.getCharContainingOffset=q;function Z(re){const ge=new Y(re);let Se=0;for(;!ge.eol();)Se++,ge.nextGraphemeLength();return Se}e.charCount=Z;let oe;function ae(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function G(re){return oe||(oe=ae()),oe.test(re)}e.containsRTL=G;const W=/^[\t\n\r\x20-\x7E]*$/;function b(re){return W.test(re)}e.isBasicASCII=b,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function D(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}e.containsUnusualLineTerminators=D;function M(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.isFullWidthCharacter=M;function V(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.isEmojiImprecise=V;function ee(re,ge){if(re.length<ge)return re;const Se=/\b/g;let Ee=0;for(;Se.test(re)&&!(re.length-Se.lastIndex<ge);)Ee=Se.lastIndex,Se.lastIndex+=1;return re.substring(Ee).replace(/^\s/,"")}e.lcut=ee;const ne=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,de=/\x1b\].*?\x07/g;function X(re){return re&&(re=re.replace(ne,"").replace(de,"")),re}e.removeAnsiEscapeCodes=X,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function se(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.startsWithUTF8BOM=se;function te(re){return se(re)?re.substr(1):re}e.stripUTF8BOM=te;function he(re,ge){if(!re||!ge||re.length<ge.length)return!1;const Se=ge.length,Ee=re.toLowerCase();let be=0,Re=-1;for(;be<Se;){const Ie=Ee.indexOf(ge[be],Re+1);if(Ie<0)return!1;Re=Ie,be++}return!0}e.fuzzyContains=he;function fe(re,ge=!1){return re?(ge&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.containsUppercaseCharacter=fe;function pe(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.uppercaseFirstLetter=pe;function Ce(re,ge=1){if(ge===0)return"";let Se=-1;do Se=re.indexOf(`
`,Se+1),ge--;while(ge>0&&Se>=0);return Se===-1?re:(re[Se-1]==="\r"&&Se--,re.substr(0,Se))}e.getNLines=Ce;function ke(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.singleLetterHash=ke;function _e(re){return me.getInstance().getGraphemeBreakType(re)}e.getGraphemeBreakType=_e;function Fe(re,ge){return re===0?ge!==5&&ge!==7:re===2&&ge===3?!1:re===4||re===2||re===3||ge===4||ge===2||ge===3?!0:!(re===8&&(ge===8||ge===9||ge===11||ge===12)||(re===11||re===9)&&(ge===9||ge===10)||(re===12||re===10)&&ge===10||ge===5||ge===13||ge===7||re===1||re===13&&ge===14||re===6&&ge===6)}var ue;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(ue||(e.GraphemeBreakType=ue={}));class me{static{this._INSTANCE=null}static getInstance(){return me._INSTANCE||(me._INSTANCE=new me),me._INSTANCE}constructor(){this._data=ve()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const Se=this._data,Ee=Se.length/3;let be=1;for(;be<=Ee;)if(ge<Se[3*be])be=2*be;else if(ge>Se[3*be+1])be=2*be+1;else return Se[3*be+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Pe(re,ge){if(re===0)return 0;const Se=De(re,ge);if(Se!==void 0)return Se;const Ee=new B(ge,re);return Ee.prevCodePoint(),Ee.offset}e.getLeftDeleteOffset=Pe;function De(re,ge){const Se=new B(ge,re);let Ee=Se.prevCodePoint();for(;We(Ee)||Ee===65039||Ee===8419;){if(Se.offset===0)return;Ee=Se.prevCodePoint()}if(!V(Ee))return;let be=Se.offset;return be>0&&Se.prevCodePoint()===8205&&(be=Se.offset),be}function We(re){return 127995<=re&&re<=127999}var Ae;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={})),e.noBreakWhitespace="\xA0";class $e{static{this.ambiguousCharacterData=new O.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new k.LRUCachedFunction(ge=>{function Se(Oe){const qe=new Map;for(let je=0;je<Oe.length;je+=2)qe.set(Oe[je],Oe[je+1]);return qe}function Ee(Oe,qe){const je=new Map(Oe);for(const[ze,Xe]of qe)je.set(ze,Xe);return je}function be(Oe,qe){if(!Oe)return qe;const je=new Map;for(const[ze,Xe]of Oe)qe.has(ze)&&je.set(ze,Xe);return je}const Re=this.ambiguousCharacterData.value;let Ie=ge.filter(Oe=>!Oe.startsWith("_")&&Oe in Re);Ie.length===0&&(Ie=["_default"]);let Le;for(const Oe of Ie){const qe=Se(Re[Oe]);Le=be(Le,qe)}const Te=Se(Re._common),Ue=Ee(Te,Le);return new $e(Ue)})}static getInstance(ge){return $e.cache.get(Array.from(ge))}static{this._locales=new O.Lazy(()=>Object.keys($e.ambiguousCharacterData.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return $e._locales.value}constructor(ge){this.confusableDictionary=ge}isAmbiguous(ge){return this.confusableDictionary.has(ge)}getPrimaryConfusable(ge){return this.confusableDictionary.get(ge)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=$e;class Ne{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ne.getRawData())),this._data}static isInvisibleCharacter(ge){return Ne.getData().has(ge)}static get codePoints(){return Ne.getData()}}e.InvisibleCharacters=Ne}),define(ce[51],le([0,1,28]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(u){return T(u,0)}e.hash=O;function T(u,d){switch(typeof u){case"object":return u===null?A(349,d):Array.isArray(u)?P(u,d):m(u,d);case"string":return R(u,d);case"boolean":return _(u,d);case"number":return A(u,d);case"undefined":return A(937,d);default:return A(617,d)}}e.doHash=T;function A(u,d){return(d<<5)-d+u|0}e.numberHash=A;function _(u,d){return A(u?433:863,d)}function R(u,d){d=A(149417,d);for(let v=0,p=u.length;v<p;v++)d=A(u.charCodeAt(v),d);return d}e.stringHash=R;function P(u,d){return d=A(104579,d),u.reduce((v,p)=>T(p,v),d)}function m(u,d){return d=A(181387,d),Object.keys(u).sort().reduce((v,p)=>(v=R(p,v),T(u[p],v)),d)}class I{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=T(d,this._value),this._value}}e.Hasher=I;var y;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function g(u,d,v=32){const p=v-d,L=~((1<<p)-1);return(u<<d|(L&u)>>>p)>>>0}function h(u,d=0,v=u.byteLength,p=0){for(let L=0;L<v;L++)u[d+L]=p}function f(u,d,v="0"){for(;u.length<d;)u=v+u;return u}function E(u,d=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(v=>v.toString(16).padStart(2,"0")).join(""):f((u>>>0).toString(16),d/4)}e.toHexString=E;class c{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const v=d.length;if(v===0)return;const p=this._buff;let L=this._buffLen,t=this._leftoverHighSurrogate,o,s;for(t!==0?(o=t,s=-1,t=0):(o=d.charCodeAt(0),s=0);;){let n=o;if(k.isHighSurrogate(o))if(s+1<v){const i=d.charCodeAt(s+1);k.isLowSurrogate(i)?(s++,n=k.computeCodePoint(o,i)):n=65533}else{t=o;break}else k.isLowSurrogate(o)&&(n=65533);if(L=this._push(p,L,n),s++,s<v)o=d.charCodeAt(s);else break}this._buffLen=L,this._leftoverHighSurrogate=t}_push(d,v,p){return p<128?d[v++]=p:p<2048?(d[v++]=192|(p&1984)>>>6,d[v++]=128|(p&63)>>>0):p<65536?(d[v++]=224|(p&61440)>>>12,d[v++]=128|(p&4032)>>>6,d[v++]=128|(p&63)>>>0):(d[v++]=240|(p&1835008)>>>18,d[v++]=128|(p&258048)>>>12,d[v++]=128|(p&4032)>>>6,d[v++]=128|(p&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=c._bigBlock32,v=this._buffDV;for(let a=0;a<64;a+=4)d.setUint32(a,v.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,g(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let p=this._h0,L=this._h1,t=this._h2,o=this._h3,s=this._h4,n,i,r;for(let a=0;a<80;a++)a<20?(n=L&t|~L&o,i=1518500249):a<40?(n=L^t^o,i=1859775393):a<60?(n=L&t|L&o|t&o,i=2400959708):(n=L^t^o,i=3395469782),r=g(p,5)+n+s+i+d.getUint32(a*4,!1)&4294967295,s=o,o=t,t=g(L,30),L=p,p=r;this._h0=this._h0+p&4294967295,this._h1=this._h1+L&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=c}),define(ce[89],le([0,1,28]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(O||(O={})),function(T){const A="error",_="warning",R="warn",P="info",m="ignore";function I(g){return g?k.equalsIgnoreCase(A,g)?T.Error:k.equalsIgnoreCase(_,g)||k.equalsIgnoreCase(R,g)?T.Warning:k.equalsIgnoreCase(P,g)?T.Info:T.Ignore:T.Ignore}T.fromValue=I;function y(g){switch(g){case T.Error:return A;case T.Warning:return _;case T.Info:return P;default:return m}}T.toString=y}(O||(O={})),e.default=O}),define(ce[128],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ce[47],le([0,1,20,28]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class T{constructor(){this._value="",this._pos=0}reset(h){return this._value=h,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(h){const f=h.charCodeAt(0),E=this._value.charCodeAt(this._pos);return f-E}value(){return this._value[this._pos]}}e.StringIterator=T;class A{constructor(h=!0){this._caseSensitive=h}reset(h){return this._value=h,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let h=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(h)this._from++;else break;else h=!1;return this}cmp(h){return this._caseSensitive?(0,O.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class _{constructor(h=!0,f=!0){this._splitOnBackslash=h,this._caseSensitive=f}reset(h){this._from=0,this._to=0,this._value=h,this._valueLen=h.length;for(let f=h.length-1;f>=0;f--,this._valueLen--){const E=this._value.charCodeAt(f);if(!(E===47||this._splitOnBackslash&&E===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let h=!0;for(;this._to<this._valueLen;this._to++){const f=this._value.charCodeAt(this._to);if(f===47||this._splitOnBackslash&&f===92)if(h)this._from++;else break;else h=!1}return this}cmp(h){return this._caseSensitive?(0,O.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=_;var R;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(R||(R={}));class P{constructor(h,f){this._ignorePathCasing=h,this._ignoreQueryAndFragment=f,this._states=[],this._stateIdx=0}reset(h){return this._value=h,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(h)),this._pathIterator.reset(h.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(h)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(h){if(this._states[this._stateIdx]===1)return(0,O.compareIgnoreCase)(h,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,O.compareIgnoreCase)(h,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(h);if(this._states[this._stateIdx]===4)return(0,O.compare)(h,this._value.query);if(this._states[this._stateIdx]===5)return(0,O.compare)(h,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=P;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(I||(I={}));class y{static forUris(h=()=>!1,f=()=>!1){return new y(new P(h,f))}static forPaths(h=!1){return new y(new _(void 0,!h))}static forStrings(){return new y(new T)}static forConfigKeys(){return new y(new A)}constructor(h){this._iter=h}clear(){this._root=void 0}fill(h,f){if(f){const E=f.slice(0);(0,k.shuffle)(E);for(const c of E)this.set(c,h)}else{const E=h.slice(0);(0,k.shuffle)(E);for(const c of E)this.set(c[0],c[1])}}set(h,f){const E=this._iter.reset(h);let c;this._root||(this._root=new m,this._root.segment=E.value());const u=[];for(c=this._root;;){const v=E.cmp(c.segment);if(v>0)c.left||(c.left=new m,c.left.segment=E.value()),u.push([-1,c]),c=c.left;else if(v<0)c.right||(c.right=new m,c.right.segment=E.value()),u.push([1,c]),c=c.right;else if(E.hasNext())E.next(),c.mid||(c.mid=new m,c.mid.segment=E.value()),u.push([0,c]),c=c.mid;else break}const d=c.value;c.value=f,c.key=h;for(let v=u.length-1;v>=0;v--){const p=u[v][1];p.updateHeight();const L=p.balanceFactor();if(L<-1||L>1){const t=u[v][0],o=u[v+1][0];if(t===1&&o===1)u[v][1]=p.rotateLeft();else if(t===-1&&o===-1)u[v][1]=p.rotateRight();else if(t===1&&o===-1)p.right=u[v+1][1]=u[v+1][1].rotateRight(),u[v][1]=p.rotateLeft();else if(t===-1&&o===1)p.left=u[v+1][1]=u[v+1][1].rotateLeft(),u[v][1]=p.rotateRight();else throw new Error;if(v>0)switch(u[v-1][0]){case-1:u[v-1][1].left=u[v][1];break;case 1:u[v-1][1].right=u[v][1];break;case 0:u[v-1][1].mid=u[v][1];break}else this._root=u[0][1]}}return d}get(h){return this._getNode(h)?.value}_getNode(h){const f=this._iter.reset(h);let E=this._root;for(;E;){const c=f.cmp(E.segment);if(c>0)E=E.left;else if(c<0)E=E.right;else if(f.hasNext())f.next(),E=E.mid;else break}return E}has(h){const f=this._getNode(h);return!(f?.value===void 0&&f?.mid===void 0)}delete(h){return this._delete(h,!1)}deleteSuperstr(h){return this._delete(h,!0)}_delete(h,f){const E=this._iter.reset(h),c=[];let u=this._root;for(;u;){const d=E.cmp(u.segment);if(d>0)c.push([-1,u]),u=u.left;else if(d<0)c.push([1,u]),u=u.right;else if(E.hasNext())E.next(),c.push([0,u]),u=u.mid;else break}if(u){if(f?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const d=this._min(u.right);if(d.key){const{key:v,value:p,segment:L}=d;this._delete(d.key,!1),u.key=v,u.value=p,u.segment=L}}else{const d=u.left??u.right;if(c.length>0){const[v,p]=c[c.length-1];switch(v){case-1:p.left=d;break;case 0:p.mid=d;break;case 1:p.right=d;break}}else this._root=d}for(let d=c.length-1;d>=0;d--){const v=c[d][1];v.updateHeight();const p=v.balanceFactor();if(p>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),c[d][1]=v.rotateLeft()):p<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),c[d][1]=v.rotateRight()),d>0)switch(c[d-1][0]){case-1:c[d-1][1].left=c[d][1];break;case 1:c[d-1][1].right=c[d][1];break;case 0:c[d-1][1].mid=c[d][1];break}else this._root=c[0][1]}}}_min(h){for(;h.left;)h=h.left;return h}findSubstr(h){const f=this._iter.reset(h);let E=this._root,c;for(;E;){const u=f.cmp(E.segment);if(u>0)E=E.left;else if(u<0)E=E.right;else if(f.hasNext())f.next(),c=E.value||c,E=E.mid;else break}return E&&E.value||c}findSuperstr(h){return this._findSuperstrOrElement(h,!1)}_findSuperstrOrElement(h,f){const E=this._iter.reset(h);let c=this._root;for(;c;){const u=E.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(E.hasNext())E.next(),c=c.mid;else return c.mid?this._entries(c.mid):f?c.value:void 0}}hasElementOrSubtree(h){return this._findSuperstrOrElement(h,!0)!==void 0}forEach(h){for(const[f,E]of this)h(E,f)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(h){const f=[];return this._dfsEntries(h,f),f[Symbol.iterator]()}_dfsEntries(h,f){h&&(h.left&&this._dfsEntries(h.left,f),h.value&&f.push([h.key,h.value]),h.mid&&this._dfsEntries(h.mid,f),h.right&&this._dfsEntries(h.right,f))}_isBalanced(){const h=f=>{if(!f)return!0;const E=f.balanceFactor();return E<-1||E>1?!1:h(f.left)&&h(f.right)};return h(this._root)}}e.TernarySearchTree=y}),define(ce[11],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function k(L){return typeof L=="string"}e.isString=k;function O(L){return Array.isArray(L)&&L.every(t=>k(t))}e.isStringArray=O;function T(L){return typeof L=="object"&&L!==null&&!Array.isArray(L)&&!(L instanceof RegExp)&&!(L instanceof Date)}e.isObject=T;function A(L){const t=Object.getPrototypeOf(Uint8Array);return typeof L=="object"&&L instanceof t}e.isTypedArray=A;function _(L){return typeof L=="number"&&!isNaN(L)}e.isNumber=_;function R(L){return!!L&&typeof L[Symbol.iterator]=="function"}e.isIterable=R;function P(L){return L===!0||L===!1}e.isBoolean=P;function m(L){return typeof L>"u"}e.isUndefined=m;function I(L){return!y(L)}e.isDefined=I;function y(L){return m(L)||L===null}e.isUndefinedOrNull=y;function g(L,t){if(!L)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=g;function h(L){if(y(L))throw new Error("Assertion Failed: argument is undefined or null");return L}e.assertIsDefined=h;function f(...L){const t=[];for(let o=0;o<L.length;o++){const s=L[o];if(y(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(s)}return t}e.assertAllDefined=f;const E=Object.prototype.hasOwnProperty;function c(L){if(!T(L))return!1;for(const t in L)if(E.call(L,t))return!1;return!0}e.isEmptyObject=c;function u(L){return typeof L=="function"}e.isFunction=u;function d(...L){return L.length>0&&L.every(u)}e.areFunctions=d;function v(L,t){const o=Math.min(L.length,t.length);for(let s=0;s<o;s++)p(L[s],t[s])}e.validateConstraints=v;function p(L,t){if(k(t)){if(typeof L!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(L instanceof t)return}catch{}if(!y(L)&&L.constructor===t||t.length===1&&t.call(void 0,L)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p}),define(ce[30],le([0,1,11]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const d=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([v,p])=>{d[v]=p&&typeof p=="object"?O(p):p}),d}e.deepClone=O;function T(u){if(!u||typeof u!="object")return u;const d=[u];for(;d.length>0;){const v=d.shift();Object.freeze(v);for(const p in v)if(A.call(v,p)){const L=v[p];typeof L=="object"&&!Object.isFrozen(L)&&!(0,k.isTypedArray)(L)&&d.push(L)}}return u}e.deepFreeze=T;const A=Object.prototype.hasOwnProperty;function _(u,d){return R(u,d,new Set)}e.cloneAndChange=_;function R(u,d,v){if((0,k.isUndefinedOrNull)(u))return u;const p=d(u);if(typeof p<"u")return p;if(Array.isArray(u)){const L=[];for(const t of u)L.push(R(t,d,v));return L}if((0,k.isObject)(u)){if(v.has(u))throw new Error("Cannot clone recursive data-structure");v.add(u);const L={};for(const t in u)A.call(u,t)&&(L[t]=R(u[t],d,v));return v.delete(u),L}return u}function P(u,d,v=!0){return(0,k.isObject)(u)?((0,k.isObject)(d)&&Object.keys(d).forEach(p=>{p in u?v&&((0,k.isObject)(u[p])&&(0,k.isObject)(d[p])?P(u[p],d[p],v):u[p]=d[p]):u[p]=d[p]}),u):d}e.mixin=P;function m(u,d){if(u===d)return!0;if(u==null||d===null||d===void 0||typeof u!=typeof d||typeof u!="object"||Array.isArray(u)!==Array.isArray(d))return!1;let v,p;if(Array.isArray(u)){if(u.length!==d.length)return!1;for(v=0;v<u.length;v++)if(!m(u[v],d[v]))return!1}else{const L=[];for(p in u)L.push(p);L.sort();const t=[];for(p in d)t.push(p);if(t.sort(),!m(L,t))return!1;for(v=0;v<L.length;v++)if(!m(u[L[v]],d[L[v]]))return!1}return!0}e.equals=m;function I(u){const d=new Set;return JSON.stringify(u,(v,p)=>{if((0,k.isObject)(p)||Array.isArray(p)){if(d.has(p))return"[Circular]";d.add(p)}return p})}e.safeStringify=I;function y(u,d){const v=Object.create(null);return!u||!d||Object.keys(d).forEach(L=>{const t=u[L],o=d[L];m(t,o)||(v[L]=o)}),v}e.distinct=y;function g(u,d){const v=d.toLowerCase(),p=Object.keys(u).find(L=>L.toLowerCase()===v);return p?u[p]:u[d]}e.getCaseInsensitive=g;function h(u,d){const v=Object.create(null);for(const[p,L]of Object.entries(u))d(p,L)&&(v[p]=L);return v}e.filter=h;function f(u){let d=[];for(;Object.prototype!==u;)d=d.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return d}e.getAllPropertyNames=f;function E(u){const d=[];for(const v of f(u))typeof u[v]=="function"&&d.push(v);return d}e.getAllMethodNames=E;function c(u,d){const v=L=>function(){const t=Array.prototype.slice.call(arguments,0);return d(L,t)},p={};for(const L of u)p[L]=v(L);return p}e.createProxyObject=c}),define(ce[32],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(T){return k.test(T)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(R){for(let P=0;P<R.length;P++)R[P]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),_=[];for(let R=0;R<256;R++)_.push(R.toString(16).padStart(2,"0"));return function(){T(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let P=0,m="";return m+=_[A[P++]],m+=_[A[P++]],m+=_[A[P++]],m+=_[A[P++]],m+="-",m+=_[A[P++]],m+=_[A[P++]],m+="-",m+=_[A[P++]],m+=_[A[P++]],m+="-",m+=_[A[P++]],m+=_[A[P++]],m+="-",m+=_[A[P++]],m+=_[A[P++]],m+=_[A[P++]],m+=_[A[P++]],m+=_[A[P++]],m+=_[A[P++]],m}}()}),define(ce[129],le([0,1,36]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function T(_){const R=_.replace(/\-/g,":").toLowerCase();return!O.has(R)}function A(){const _=(0,k.networkInterfaces)();for(const R in _){const P=_[R];if(P){for(const{mac:m}of P)if(T(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ce[130],le([0,1,36,47,32,129]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(m){return this._virtualMachineOUIs||(this._virtualMachineOUIs=O.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(m)}value(){if(this._value===void 0){let m=0,I=0;const y=(0,k.networkInterfaces)();for(const g in y){const h=y[g];if(h)for(const{mac:f,internal:E}of h)E||(I+=1,this._isVirtualMachineMacAddress(f.toUpperCase())&&(m+=1))}this._value=I>0?m/I:0}return this._value}};let _;async function R(m){return _||(_=(async()=>await P(m)||T.generateUuid())()),_}e.getMachineId=R;async function P(m){try{const I=await new Promise((g,h)=>{ie(["crypto"],g,h)}),y=(0,A.getMac)();return I.createHash("sha256").update(y,"utf8").digest("hex")}catch(I){m(I);return}}}),define(ce[131],le([0,1,266,14]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StreamSplitter=void 0;class T extends k.Transform{constructor(_){if(super(),typeof _=="number")this.splitter=_,this.spitterLen=1;else{const R=Buffer.isBuffer(_)?_:Buffer.from(_);this.splitter=R.length===1?R[0]:R,this.spitterLen=R.length}}_transform(_,R,P){this.buffer?this.buffer=Buffer.concat([this.buffer,_]):this.buffer=_;let m=0;for(;m<this.buffer.length;){const I=typeof this.splitter=="number"?this.buffer.indexOf(this.splitter,m):(0,O.binaryIndexOf)(this.buffer,this.splitter,m);if(I===-1)break;this.push(this.buffer.slice(m,I+this.spitterLen)),m=I+this.spitterLen}this.buffer=m===this.buffer.length?void 0:this.buffer.slice(m),P()}_flush(_){this.buffer&&this.push(this.buffer),_()}}e.StreamSplitter=T}),define(ce[132],le([0,1,61]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function O(R,P,m,I=1){let y=!1;return new Promise(g=>{const h=setTimeout(()=>{if(!y)return y=!0,g(0)},m);T(R,P,I,f=>{if(!y)return y=!0,clearTimeout(h),g(f)})})}e.findFreePort=O;function T(R,P,m,I){if(P===0)return I(0);const y=new k.Socket;y.once("connect",()=>(_(y),T(R+m,P-1,m,I))),y.once("data",()=>{}),y.once("error",g=>(_(y),g.code!=="ECONNREFUSED"?T(R+m,P-1,m,I):I(R))),y.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,P,m,I="127.0.0.1"){let y=!1,g,h=1;const f=k.createServer({pauseOnConnect:!0});function E(c,u){y||(y=!0,f.removeAllListeners(),f.close(),g&&clearTimeout(g),u(c))}return new Promise(c=>{g=setTimeout(()=>{E(0,c)},m),f.on("listening",()=>{E(R,c)}),f.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&h<P?(R++,h++,f.listen(R,I)):E(0,c)}),f.on("close",()=>{E(0,c)}),f.listen(R,I)})}e.findFreePortFaster=A;function _(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(P){console.error(P)}}}),define(ce[133],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function k(O){return!!O.parentPort}e.isUtilityProcess=k}),define(ce[134],le([12,9]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(ce[62],le([0,1,134]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,T=O*60,A=T*24,_=A*7,R=A*30,P=A*365;function m(y,g,h,f){typeof y!="number"&&(y=y.getTime());const E=Math.round((new Date().getTime()-y)/1e3);if(E<-30)return(0,k.localize)(0,null,m(new Date().getTime()+E*1e3,!1));if(!f&&E<30)return(0,k.localize)(1,null);let c;return E<O?(c=E,g?c===1?h?(0,k.localize)(2,null,c):(0,k.localize)(3,null,c):h?(0,k.localize)(4,null,c):(0,k.localize)(5,null,c):c===1?h?(0,k.localize)(6,null,c):(0,k.localize)(7,null,c):h?(0,k.localize)(8,null,c):(0,k.localize)(9,null,c)):E<T?(c=Math.floor(E/O),g?c===1?h?(0,k.localize)(10,null,c):(0,k.localize)(11,null,c):h?(0,k.localize)(12,null,c):(0,k.localize)(13,null,c):c===1?h?(0,k.localize)(14,null,c):(0,k.localize)(15,null,c):h?(0,k.localize)(16,null,c):(0,k.localize)(17,null,c)):E<A?(c=Math.floor(E/T),g?c===1?h?(0,k.localize)(18,null,c):(0,k.localize)(19,null,c):h?(0,k.localize)(20,null,c):(0,k.localize)(21,null,c):c===1?h?(0,k.localize)(22,null,c):(0,k.localize)(23,null,c):h?(0,k.localize)(24,null,c):(0,k.localize)(25,null,c)):E<_?(c=Math.floor(E/A),g?c===1?(0,k.localize)(26,null,c):(0,k.localize)(27,null,c):c===1?(0,k.localize)(28,null,c):(0,k.localize)(29,null,c)):E<R?(c=Math.floor(E/_),g?c===1?h?(0,k.localize)(30,null,c):(0,k.localize)(31,null,c):h?(0,k.localize)(32,null,c):(0,k.localize)(33,null,c):c===1?h?(0,k.localize)(34,null,c):(0,k.localize)(35,null,c):h?(0,k.localize)(36,null,c):(0,k.localize)(37,null,c)):E<P?(c=Math.floor(E/R),g?c===1?h?(0,k.localize)(38,null,c):(0,k.localize)(39,null,c):h?(0,k.localize)(40,null,c):(0,k.localize)(41,null,c):c===1?h?(0,k.localize)(42,null,c):(0,k.localize)(43,null,c):h?(0,k.localize)(44,null,c):(0,k.localize)(45,null,c)):(c=Math.floor(E/P),g?c===1?h?(0,k.localize)(46,null,c):(0,k.localize)(47,null,c):h?(0,k.localize)(48,null,c):(0,k.localize)(49,null,c):c===1?h?(0,k.localize)(50,null,c):(0,k.localize)(51,null,c):h?(0,k.localize)(52,null,c):(0,k.localize)(53,null,c))}e.fromNow=m;function I(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(ce[135],le([12,9]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(ce[38],le([0,1,20,11,135]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(y,g){return g&&(y.stack||y.stacktrace)?T.localize(0,null,R(y),_(y.stack)||_(y.stacktrace)):R(y)}function _(y){return Array.isArray(y)?y.join(`
`):y}function R(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?T.localize(1,null,y.message):y.message||T.localize(2,null)}function P(y=null,g=!1){if(!y)return T.localize(3,null);if(Array.isArray(y)){const h=k.coalesce(y),f=P(h[0],g);return h.length>1?T.localize(4,null,f,h.length):f}if(O.isString(y))return y;if(y.detail){const h=y.detail;if(h.error)return A(h.error,g);if(h.exception)return A(h.exception,g)}return y.stack?A(y,g):y.message?y.message:T.localize(5,null)}e.toErrorMessage=P;function m(y){const g=y;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=m;function I(y,g){let h;return typeof y=="string"?h=new Error(y):h=y,h.actions=g,h}e.createErrorWithActions=I}),define(ce[136],le([12,9]),function(ie,e){return ie.create("vs/base/common/jsonErrorMessages",e)}),define(ce[137],le([0,1,136]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(T){switch(T){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(ce[138],le([12,9]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(ce[6],le([0,1,138]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let O=!1,T=!1,A=!1,_=!1,R=!1,P=!1,m=!1,I=!1,y=!1,g=!1,h,f=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT,c,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const v=typeof d?.versions?.electron=="string",p=v&&d?.type==="renderer";if(typeof navigator=="object"&&!p)u=navigator.userAgent,O=u.indexOf("Windows")>=0,T=u.indexOf("Macintosh")>=0,I=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=u.indexOf("Linux")>=0,g=u?.indexOf("Mobi")>=0,P=!0,h=k.getConfiguredDefaultLocale(k.localize(0,null))||e.LANGUAGE_DEFAULT,f=h,E=navigator.language;else if(typeof d=="object"){O=d.platform==="win32",T=d.platform==="darwin",A=d.platform==="linux",_=A&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,m=v,y=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const w=d.env.VSCODE_NLS_CONFIG;if(w)try{const S=JSON.parse(w),l=S.availableLanguages["*"];h=S.locale,E=S.osLocale,f=l||e.LANGUAGE_DEFAULT,c=S._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var L;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(L||(e.Platform=L={}));function t(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let o=0;T?o=1:O?o=3:A&&(o=2),e.isWindows=O,e.isMacintosh=T,e.isLinux=A,e.isLinuxSnap=_,e.isNative=R,e.isElectron=m,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isMobile=g,e.isCI=y,e.platform=o,e.userAgent=u,e.language=f;var s;(function(w){function S(){return e.language}w.value=S;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}w.isDefaultVariant=l;function C(){return e.language==="en"}w.isDefault=C})(s||(e.Language=s={})),e.locale=h,e.platformLocale=E,e.translationsConfigFile=c,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const w=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let C=0,U=w.length;C<U;C++){const N=w[C];if(N.id===l.data.vscodeScheduleAsyncWork){w.splice(C,1),N.callback();return}}});let S=0;return l=>{const C=++S;w.push({id:C,callback:l}),e.globals.postMessage({vscodeScheduleAsyncWork:C},"*")}}return w=>setTimeout(w)})();var n;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=T||I?2:O?1:3;let i=!0,r=!1;function a(){if(!r){r=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,i=new Uint16Array(w.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ce[37],le([0,1,6]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let O;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.process<"u"){const T=k.globals.vscode.process;O={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.platform=O.platform,e.arch=O.arch}),define(ce[16],le([0,1,37]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const O=65,T=97,A=90,_=122,R=46,P=47,m=92,I=58,y=63;class g extends Error{constructor(o,s,n){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${i} of type ${s}`;a+=`. Received type ${typeof n}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,o){if(t===null||typeof t!="object")throw new g(o,"Object",t)}function f(t,o){if(typeof t!="string")throw new g(o,"string",t)}const E=k.platform==="win32";function c(t){return t===P||t===m}function u(t){return t===P}function d(t){return t>=O&&t<=A||t>=T&&t<=_}function v(t,o,s,n){let i="",r=0,a=-1,w=0,S=0;for(let l=0;l<=t.length;++l){if(l<t.length)S=t.charCodeAt(l);else{if(n(S))break;S=P}if(n(S)){if(!(a===l-1||w===1))if(w===2){if(i.length<2||r!==2||i.charCodeAt(i.length-1)!==R||i.charCodeAt(i.length-2)!==R){if(i.length>2){const C=i.lastIndexOf(s);C===-1?(i="",r=0):(i=i.slice(0,C),r=i.length-1-i.lastIndexOf(s)),a=l,w=0;continue}else if(i.length!==0){i="",r=0,a=l,w=0;continue}}o&&(i+=i.length>0?`${s}..`:"..",r=2)}else i.length>0?i+=`${s}${t.slice(a+1,l)}`:i=t.slice(a+1,l),r=l-a-1;a=l,w=0}else S===R&&w!==-1?++w:w=-1}return i}function p(t,o){h(o,"pathObject");const s=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${n}`:`${s}${t}${n}`:n}e.win32={resolve(...t){let o="",s="",n=!1;for(let i=t.length-1;i>=-1;i--){let r;if(i>=0){if(r=t[i],f(r,"path"),r.length===0)continue}else o.length===0?r=k.cwd():(r=k.env[`=${o}`]||k.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===m)&&(r=`${o}\\`));const a=r.length;let w=0,S="",l=!1;const C=r.charCodeAt(0);if(a===1)c(C)&&(w=1,l=!0);else if(c(C))if(l=!0,c(r.charCodeAt(1))){let U=2,N=U;for(;U<a&&!c(r.charCodeAt(U));)U++;if(U<a&&U!==N){const F=r.slice(N,U);for(N=U;U<a&&c(r.charCodeAt(U));)U++;if(U<a&&U!==N){for(N=U;U<a&&!c(r.charCodeAt(U));)U++;(U===a||U!==N)&&(S=`\\\\${F}\\${r.slice(N,U)}`,w=U)}}}else w=1;else d(C)&&r.charCodeAt(1)===I&&(S=r.slice(0,2),w=2,a>2&&c(r.charCodeAt(2))&&(l=!0,w=3));if(S.length>0)if(o.length>0){if(S.toLowerCase()!==o.toLowerCase())continue}else o=S;if(n){if(o.length>0)break}else if(s=`${r.slice(w)}\\${s}`,n=l,l&&o.length>0)break}return s=v(s,!n,"\\",c),n?`${o}\\${s}`:`${o}${s}`||"."},normalize(t){f(t,"path");const o=t.length;if(o===0)return".";let s=0,n,i=!1;const r=t.charCodeAt(0);if(o===1)return u(r)?"\\":t;if(c(r))if(i=!0,c(t.charCodeAt(1))){let w=2,S=w;for(;w<o&&!c(t.charCodeAt(w));)w++;if(w<o&&w!==S){const l=t.slice(S,w);for(S=w;w<o&&c(t.charCodeAt(w));)w++;if(w<o&&w!==S){for(S=w;w<o&&!c(t.charCodeAt(w));)w++;if(w===o)return`\\\\${l}\\${t.slice(S)}\\`;w!==S&&(n=`\\\\${l}\\${t.slice(S,w)}`,s=w)}}}else s=1;else d(r)&&t.charCodeAt(1)===I&&(n=t.slice(0,2),s=2,o>2&&c(t.charCodeAt(2))&&(i=!0,s=3));let a=s<o?v(t.slice(s),!i,"\\",c):"";return a.length===0&&!i&&(a="."),a.length>0&&c(t.charCodeAt(o-1))&&(a+="\\"),n===void 0?i?`\\${a}`:a:i?`${n}\\${a}`:`${n}${a}`},isAbsolute(t){f(t,"path");const o=t.length;if(o===0)return!1;const s=t.charCodeAt(0);return c(s)||o>2&&d(s)&&t.charCodeAt(1)===I&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,s;for(let r=0;r<t.length;++r){const a=t[r];f(a,"path"),a.length>0&&(o===void 0?o=s=a:o+=`\\${a}`)}if(o===void 0)return".";let n=!0,i=0;if(typeof s=="string"&&c(s.charCodeAt(0))){++i;const r=s.length;r>1&&c(s.charCodeAt(1))&&(++i,r>2&&(c(s.charCodeAt(2))?++i:n=!1))}if(n){for(;i<o.length&&c(o.charCodeAt(i));)i++;i>=2&&(o=`\\${o.slice(i)}`)}return e.win32.normalize(o)},relative(t,o){if(f(t,"from"),f(o,"to"),t===o)return"";const s=e.win32.resolve(t),n=e.win32.resolve(o);if(s===n||(t=s.toLowerCase(),o=n.toLowerCase(),t===o))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===m;)i++;let r=t.length;for(;r-1>i&&t.charCodeAt(r-1)===m;)r--;const a=r-i;let w=0;for(;w<o.length&&o.charCodeAt(w)===m;)w++;let S=o.length;for(;S-1>w&&o.charCodeAt(S-1)===m;)S--;const l=S-w,C=a<l?a:l;let U=-1,N=0;for(;N<C;N++){const $=t.charCodeAt(i+N);if($!==o.charCodeAt(w+N))break;$===m&&(U=N)}if(N!==C){if(U===-1)return n}else{if(l>C){if(o.charCodeAt(w+N)===m)return n.slice(w+N+1);if(N===2)return n.slice(w+N)}a>C&&(t.charCodeAt(i+N)===m?U=N:N===2&&(U=3)),U===-1&&(U=0)}let F="";for(N=i+U+1;N<=r;++N)(N===r||t.charCodeAt(N)===m)&&(F+=F.length===0?"..":"\\..");return w+=U,F.length>0?`${F}${n.slice(w,S)}`:(n.charCodeAt(w)===m&&++w,n.slice(w,S))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.win32.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===m){if(o.charCodeAt(1)===m){const s=o.charCodeAt(2);if(s!==y&&s!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===I&&o.charCodeAt(2)===m)return`\\\\?\\${o}`;return t},dirname(t){f(t,"path");const o=t.length;if(o===0)return".";let s=-1,n=0;const i=t.charCodeAt(0);if(o===1)return c(i)?t:".";if(c(i)){if(s=n=1,c(t.charCodeAt(1))){let w=2,S=w;for(;w<o&&!c(t.charCodeAt(w));)w++;if(w<o&&w!==S){for(S=w;w<o&&c(t.charCodeAt(w));)w++;if(w<o&&w!==S){for(S=w;w<o&&!c(t.charCodeAt(w));)w++;if(w===o)return t;w!==S&&(s=n=w+1)}}}}else d(i)&&t.charCodeAt(1)===I&&(s=o>2&&c(t.charCodeAt(2))?3:2,n=s);let r=-1,a=!0;for(let w=o-1;w>=n;--w)if(c(t.charCodeAt(w))){if(!a){r=w;break}}else a=!1;if(r===-1){if(s===-1)return".";r=s}return t.slice(0,r)},basename(t,o){o!==void 0&&f(o,"ext"),f(t,"path");let s=0,n=-1,i=!0,r;if(t.length>=2&&d(t.charCodeAt(0))&&t.charCodeAt(1)===I&&(s=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let a=o.length-1,w=-1;for(r=t.length-1;r>=s;--r){const S=t.charCodeAt(r);if(c(S)){if(!i){s=r+1;break}}else w===-1&&(i=!1,w=r+1),a>=0&&(S===o.charCodeAt(a)?--a===-1&&(n=r):(a=-1,n=w))}return s===n?n=w:n===-1&&(n=t.length),t.slice(s,n)}for(r=t.length-1;r>=s;--r)if(c(t.charCodeAt(r))){if(!i){s=r+1;break}}else n===-1&&(i=!1,n=r+1);return n===-1?"":t.slice(s,n)},extname(t){f(t,"path");let o=0,s=-1,n=0,i=-1,r=!0,a=0;t.length>=2&&t.charCodeAt(1)===I&&d(t.charCodeAt(0))&&(o=n=2);for(let w=t.length-1;w>=o;--w){const S=t.charCodeAt(w);if(c(S)){if(!r){n=w+1;break}continue}i===-1&&(r=!1,i=w+1),S===R?s===-1?s=w:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||i===-1||a===0||a===1&&s===i-1&&s===n+1?"":t.slice(s,i)},format:p.bind(null,"\\"),parse(t){f(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.length;let n=0,i=t.charCodeAt(0);if(s===1)return c(i)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(c(i)){if(n=1,c(t.charCodeAt(1))){let U=2,N=U;for(;U<s&&!c(t.charCodeAt(U));)U++;if(U<s&&U!==N){for(N=U;U<s&&c(t.charCodeAt(U));)U++;if(U<s&&U!==N){for(N=U;U<s&&!c(t.charCodeAt(U));)U++;U===s?n=U:U!==N&&(n=U+1)}}}}else if(d(i)&&t.charCodeAt(1)===I){if(s<=2)return o.root=o.dir=t,o;if(n=2,c(t.charCodeAt(2))){if(s===3)return o.root=o.dir=t,o;n=3}}n>0&&(o.root=t.slice(0,n));let r=-1,a=n,w=-1,S=!0,l=t.length-1,C=0;for(;l>=n;--l){if(i=t.charCodeAt(l),c(i)){if(!S){a=l+1;break}continue}w===-1&&(S=!1,w=l+1),i===R?r===-1?r=l:C!==1&&(C=1):r!==-1&&(C=-1)}return w!==-1&&(r===-1||C===0||C===1&&r===w-1&&r===a+1?o.base=o.name=t.slice(a,w):(o.name=t.slice(a,r),o.base=t.slice(a,w),o.ext=t.slice(r,w))),a>0&&a!==n?o.dir=t.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const L=(()=>{if(E){const t=/\\/g;return()=>{const o=k.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>k.cwd()})();e.posix={resolve(...t){let o="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const i=n>=0?t[n]:L();f(i,"path"),i.length!==0&&(o=`${i}/${o}`,s=i.charCodeAt(0)===P)}return o=v(o,!s,"/",u),s?`/${o}`:o.length>0?o:"."},normalize(t){if(f(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===P,s=t.charCodeAt(t.length-1)===P;return t=v(t,!o,"/",u),t.length===0?o?"/":s?"./":".":(s&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return f(t,"path"),t.length>0&&t.charCodeAt(0)===P},join(...t){if(t.length===0)return".";let o;for(let s=0;s<t.length;++s){const n=t[s];f(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.posix.normalize(o)},relative(t,o){if(f(t,"from"),f(o,"to"),t===o||(t=e.posix.resolve(t),o=e.posix.resolve(o),t===o))return"";const s=1,n=t.length,i=n-s,r=1,a=o.length-r,w=i<a?i:a;let S=-1,l=0;for(;l<w;l++){const U=t.charCodeAt(s+l);if(U!==o.charCodeAt(r+l))break;U===P&&(S=l)}if(l===w)if(a>w){if(o.charCodeAt(r+l)===P)return o.slice(r+l+1);if(l===0)return o.slice(r+l)}else i>w&&(t.charCodeAt(s+l)===P?S=l:l===0&&(S=0));let C="";for(l=s+S+1;l<=n;++l)(l===n||t.charCodeAt(l)===P)&&(C+=C.length===0?"..":"/..");return`${C}${o.slice(r+S)}`},toNamespacedPath(t){return t},dirname(t){if(f(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===P;let s=-1,n=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===P){if(!n){s=i;break}}else n=!1;return s===-1?o?"/":".":o&&s===1?"//":t.slice(0,s)},basename(t,o){o!==void 0&&f(o,"ext"),f(t,"path");let s=0,n=-1,i=!0,r;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let a=o.length-1,w=-1;for(r=t.length-1;r>=0;--r){const S=t.charCodeAt(r);if(S===P){if(!i){s=r+1;break}}else w===-1&&(i=!1,w=r+1),a>=0&&(S===o.charCodeAt(a)?--a===-1&&(n=r):(a=-1,n=w))}return s===n?n=w:n===-1&&(n=t.length),t.slice(s,n)}for(r=t.length-1;r>=0;--r)if(t.charCodeAt(r)===P){if(!i){s=r+1;break}}else n===-1&&(i=!1,n=r+1);return n===-1?"":t.slice(s,n)},extname(t){f(t,"path");let o=-1,s=0,n=-1,i=!0,r=0;for(let a=t.length-1;a>=0;--a){const w=t.charCodeAt(a);if(w===P){if(!i){s=a+1;break}continue}n===-1&&(i=!1,n=a+1),w===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||n===-1||r===0||r===1&&o===n-1&&o===s+1?"":t.slice(o,n)},format:p.bind(null,"/"),parse(t){f(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.charCodeAt(0)===P;let n;s?(o.root="/",n=1):n=0;let i=-1,r=0,a=-1,w=!0,S=t.length-1,l=0;for(;S>=n;--S){const C=t.charCodeAt(S);if(C===P){if(!w){r=S+1;break}continue}a===-1&&(w=!1,a=S+1),C===R?i===-1?i=S:l!==1&&(l=1):i!==-1&&(l=-1)}if(a!==-1){const C=r===0&&s?1:r;i===-1||l===0||l===1&&i===a-1&&i===r+1?o.base=o.name=t.slice(C,a):(o.name=t.slice(C,i),o.base=t.slice(C,a),o.ext=t.slice(i,a))}return r>0?o.dir=t.slice(0,r-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E?e.win32.normalize:e.posix.normalize,e.isAbsolute=E?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E?e.win32.join:e.posix.join,e.resolve=E?e.win32.resolve:e.posix.resolve,e.relative=E?e.win32.relative:e.posix.relative,e.dirname=E?e.win32.dirname:e.posix.dirname,e.basename=E?e.win32.basename:e.posix.basename,e.extname=E?e.win32.extname:e.posix.extname,e.format=E?e.win32.format:e.posix.format,e.parse=E?e.win32.parse:e.posix.parse,e.toNamespacedPath=E?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E?e.win32.sep:e.posix.sep,e.delimiter=E?e.win32.delimiter:e.posix.delimiter}),define(ce[48],le([0,1,16,6,28,11]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(r){return r===47||r===92}e.isPathSeparator=_;function R(r){return r.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=R;function P(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=P;function m(r,a=k.posix.sep){if(!r)return"";const w=r.length,S=r.charCodeAt(0);if(_(S)){if(_(r.charCodeAt(1))&&!_(r.charCodeAt(2))){let C=3;const U=C;for(;C<w&&!_(r.charCodeAt(C));C++);if(U!==C&&!_(r.charCodeAt(C+1))){for(C+=1;C<w;C++)if(_(r.charCodeAt(C)))return r.slice(0,C+1).replace(/[\\/]/g,a)}}return a}else if(u(S)&&r.charCodeAt(1)===58)return _(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let l=r.indexOf("://");if(l!==-1){for(l+=3;l<w;l++)if(_(r.charCodeAt(l)))return r.slice(0,l+1)}return""}e.getRoot=m;function I(r){if(!O.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let w=2;const S=w;for(;w<r.length&&(a=r.charCodeAt(w),a!==92);w++);return!(S===w||(a=r.charCodeAt(w+1),isNaN(a)||a===92))}e.isUNC=I;const y=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,a=O.isWindows){const w=a?y:g;return!(!r||r.length===0||/^\s+$/.test(r)||(w.lastIndex=0,w.test(r))||a&&h.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function E(r,a,w){const S=r===a;return!w||S?S:!r||!a?!1:(0,T.equalsIgnoreCase)(r,a)}e.isEqual=E;function c(r,a,w,S=k.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(w){if(!(0,T.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let C=a.length;return a.charAt(a.length-1)===S&&C--,r.charAt(C)===S}return a.charAt(a.length-1)!==S&&(a+=S),r.indexOf(a)===0}e.isEqualOrParent=c;function u(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=u;function d(r,a){return O.isWindows&&r.endsWith(":")&&(r+=k.sep),(0,k.isAbsolute)(r)||(r=(0,k.join)(a,r)),r=(0,k.normalize)(r),O.isWindows?(r=(0,T.rtrim)(r,k.sep),r.endsWith(":")&&(r+=k.sep)):(r=(0,T.rtrim)(r,k.sep),r||(r=k.sep)),r}e.sanitizeFilePath=d;function v(r){const a=(0,k.normalize)(r);return O.isWindows?r.length>3?!1:p(a)&&(r.length===2||a.charCodeAt(2)===92):a===k.posix.sep}e.isRootOrDriveLetter=v;function p(r,a=O.isWindows){return a?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function L(r,a=O.isWindows){return p(r,a)?r[0]:void 0}e.getDriveLetter=L;function t(r,a,w){return a.length>r.length?-1:r===a?0:(w&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=t;function o(r){const a=r.split(":");let w,S,l;for(const C of a){const U=Number(C);(0,A.isNumber)(U)?S===void 0?S=U:l===void 0&&(l=U):w=w?[w,C].join(":"):C}if(!w)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:w,line:S!==void 0?S:void 0,column:l!==void 0?l:S!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(r,a,w=8){let S="";for(let C=0;C<w;C++){let U;C===0&&O.isWindows&&!a&&(w===3||w===4)?U=n:U=s,S+=U.charAt(Math.floor(Math.random()*U.length))}let l;return a?l=`${a}-${S}`:l=S,r?(0,k.join)(r,l):l}e.randomPath=i}),define(ce[139],le([0,1,16]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(I){const y=(0,k.extname)(I),g=O[y.toLowerCase()];return g!==void 0?g:_(I)}e.getMediaOrTextMime=A;function _(I){const y=(0,k.extname)(I);return T[y.toLowerCase()]}e.getMediaMime=_;function R(I){for(const y in T)if(T[y]===I)return y}e.getExtensionForMimeType=R;const P=/^(.+)\/(.+?)(;.+)?$/;function m(I,y){const g=P.exec(I);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:y?void 0:I}e.normalizeMimeType=m}),define(ce[90],le([0,1,6]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(O||(e.Source=O={}));var T;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(T||(e.TerminateResponseCode=T={}));function A(R,...P){const m=P.reduce((g,h)=>(g[h]=!0,g),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(g=>!m[g]).forEach(g=>{for(let h=0;h<I.length;h++)if(g.search(I[h])!==-1){delete R[g];break}})}e.sanitizeProcessEnvironment=A;function _(R){R&&(delete R.DEBUG,k.isMacintosh&&delete R.DYLD_LIBRARY_PATH,k.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=_}),define(ce[10],le([0,1,16,6]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,A=/^\//,_=/^\/\//;function R(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!T.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!A.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(n,i){return!n&&!i?"file":n}function m(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==y&&(i=y+i):i=y;break}return i}const I="",y="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,a,w,S,l=!1){typeof i=="object"?(this.scheme=i.scheme||I,this.authority=i.authority||I,this.path=i.path||I,this.query=i.query||I,this.fragment=i.fragment||I):(this.scheme=P(i,l),this.authority=r||I,this.path=m(this.scheme,a||I),this.query=w||I,this.fragment=S||I,R(this,l))}get fsPath(){return p(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:a,path:w,query:S,fragment:l}=i;return r===void 0?r=this.scheme:r===null&&(r=I),a===void 0?a=this.authority:a===null&&(a=I),w===void 0?w=this.path:w===null&&(w=I),S===void 0?S=this.query:S===null&&(S=I),l===void 0?l=this.fragment:l===null&&(l=I),r===this.scheme&&a===this.authority&&w===this.path&&S===this.query&&l===this.fragment?this:new c(r,a,w,S,l)}static parse(i,r=!1){const a=g.exec(i);return a?new c(a[2]||I,s(a[4]||I),s(a[5]||I),s(a[7]||I),s(a[9]||I),r):new c(I,I,I,I,I)}static file(i){let r=I;if(O.isWindows&&(i=i.replace(/\\/g,y)),i[0]===y&&i[1]===y){const a=i.indexOf(y,2);a===-1?(r=i.substring(2),i=y):(r=i.substring(2,a),i=i.substring(a)||y)}return new c("file",r,i,I,I)}static from(i,r){return new c(i.scheme,i.authority,i.path,i.query,i.fragment,r)}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return O.isWindows&&i.scheme==="file"?a=h.file(k.win32.join(p(i,!0),...r)).path:a=k.posix.join(i.path,...r),i.with({path:a})}toString(i=!1){return L(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const r=new c(i);return r._formatted=i.external??null,r._fsPath=i._sep===E?i.fsPath??null:null,r}}else return i}}e.URI=h;function f(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.isUriComponents=f;const E=O.isWindows?1:void 0;class c extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(i=!1){return i?L(this,!0):(this._formatted||(this._formatted=L(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=E),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(n,i,r){let a,w=-1;for(let S=0;S<n.length;S++){const l=n.charCodeAt(S);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||i&&l===47||r&&l===91||r&&l===93||r&&l===58)w!==-1&&(a+=encodeURIComponent(n.substring(w,S)),w=-1),a!==void 0&&(a+=n.charAt(S));else{a===void 0&&(a=n.substr(0,S));const C=u[l];C!==void 0?(w!==-1&&(a+=encodeURIComponent(n.substring(w,S)),w=-1),a+=C):w===-1&&(w=S)}}return w!==-1&&(a+=encodeURIComponent(n.substring(w))),a!==void 0?a:n}function v(n){let i;for(let r=0;r<n.length;r++){const a=n.charCodeAt(r);a===35||a===63?(i===void 0&&(i=n.substr(0,r)),i+=u[a]):i!==void 0&&(i+=n[r])}return i!==void 0?i:n}function p(n,i){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,O.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=p;function L(n,i){const r=i?v:d;let a="",{scheme:w,authority:S,path:l,query:C,fragment:U}=n;if(w&&(a+=w,a+=":"),(S||w==="file")&&(a+=y,a+=y),S){let N=S.indexOf("@");if(N!==-1){const F=S.substr(0,N);S=S.substr(N+1),N=F.lastIndexOf(":"),N===-1?a+=r(F,!1,!1):(a+=r(F.substr(0,N),!1,!1),a+=":",a+=r(F.substr(N+1),!1,!0)),a+="@"}S=S.toLowerCase(),N=S.lastIndexOf(":"),N===-1?a+=r(S,!1,!0):(a+=r(S.substr(0,N),!1,!0),a+=S.substr(N))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const N=l.charCodeAt(1);N>=65&&N<=90&&(l=`/${String.fromCharCode(N+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const N=l.charCodeAt(0);N>=65&&N<=90&&(l=`${String.fromCharCode(N+32)}:${l.substr(2)}`)}a+=r(l,!0,!1)}return C&&(a+="?",a+=r(C,!1,!1)),U&&(a+="#",a+=i?U:d(U,!1,!1)),a}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(o)?n.replace(o,i=>t(i)):n}}),define(ce[140],le([0,1,10]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(m){const I=m;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=O;function T(m){const I=[];let y;try{const g=JSON.parse(m.arguments),h=g[g.length-1];h&&h.__$stack&&(g.pop(),y=h.__$stack),I.push(...g)}catch{I.push("Unable to log remote console arguments",m.arguments)}return{args:I,stack:y}}e.parse=T;function A(m){if(typeof m!="string")return A(T(m).stack);const I=m;if(I){const y=_(I),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(g&&g.length===4)return{uri:k.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=A;function _(m){if(!m)return m;const I=m.indexOf(`
`);return I===-1?m:m.substring(0,I)}function R(m,I){const{args:y,stack:g}=T(m),h=typeof y[0]=="string"&&y.length===1;let f=_(g);f&&(f=`(${f.trim()})`);let E=[];if(typeof y[0]=="string"?f&&h?E=[`%c[${I}] %c${y[0]} %c${f}`,P("blue"),P(""),P("grey")]:E=[`%c[${I}] %c${y[0]}`,P("blue"),P(""),...y.slice(1)]:E=[`%c[${I}]%`,P("blue"),...y],f&&!h&&E.push(f),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,E)}e.log=R;function P(m){return`color: ${m}`}}),define(ce[63],le([0,1,14,10]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(P){return JSON.stringify(P,_)}e.stringify=T;function A(P){let m=JSON.parse(P);return m=R(m),m}e.parse=A;function _(P,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:m.flags}:m}function R(P,m=0){if(!P||m>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return O.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 16:return new Date(P.source)}if(P instanceof k.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let I=0;I<P.length;++I)P[I]=R(P[I],m+1);else for(const I in P)Object.hasOwnProperty.call(P,I)&&(P[I]=R(P[I],m+1))}return P}e.revive=R}),define(ce[26],le([0,1,8,6,10]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(I){this._preferredWebSchema=I}setDelegate(I){this._delegate=I}setServerRootPath(I){this._remoteResourcesPath=`${I}/${A.vscodeRemoteResource}`}set(I,y,g){this._hosts[I]=y,this._ports[I]=g}setConnectionToken(I,y){this._connectionTokens[I]=y}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(I){if(this._delegate)try{return this._delegate(I)}catch(c){return k.onUnexpectedError(c),I}const y=I.authority;let g=this._hosts[y];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const h=this._ports[y],f=this._connectionTokens[y];let E=`path=${encodeURIComponent(I.path)}`;return typeof f=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),T.URI.from({scheme:O.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${g}:${h}`,path:this._remoteResourcesPath,query:E})}}e.RemoteAuthorities=new _,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(I){const y=this.toUri(I,ie);return this.uriToBrowserUri(y)}uriToBrowserUri(I){return I.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===A.file&&(O.isNative||O.isWebWorker&&O.globals.origin===`${A.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?I.with({scheme:A.vscodeFileResource,authority:I.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(I){const y=this.toUri(I,ie);return this.uriToFileUri(y)}uriToFileUri(I){return I.scheme===A.vscodeFileResource?I.with({scheme:A.file,authority:I.authority!==R.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(I,y){return T.URI.isUri(I)?I:T.URI.parse(y.toUrl(I))}}e.FileAccess=new R;var P;(function(m){const I=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(I.get("3"));const y="vscode-coi";function g(f){let E;typeof f=="string"?E=new URL(f).searchParams:f instanceof URL?E=f.searchParams:T.URI.isUri(f)&&(E=new URL(f.toString(!0)).searchParams);const c=E?.get(y);if(c)return I.get(c)}m.getHeadersFromQuery=g;function h(f,E,c){if(!globalThis.crossOriginIsolated)return;const u=E&&c?"3":c?"2":"1";f instanceof URLSearchParams?f.set(y,u):f[y]=u}m.addSearchParam=h})(P||(e.COI=P={}))}),define(ce[141],le([0,1,124,26,6,10]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class _{constructor(g,h,f){this.id=g,this.dependencies=h,this.callback=f}}class R{static{this.INSTANCE=new R}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(g,h,f)=>{typeof g!="string"&&(f=h,h=g,g=null),(typeof h!="object"||!Array.isArray(h))&&(f=h,h=null),this._defineCalls.push(new _(g,h,f))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this._initialize();const h=await(this._isWebWorker?this._workerLoadScript(g):this._isRenderer?this._rendererLoadScript(g):this._nodeJSLoadScript(g));if(!h)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}_rendererLoadScript(g){return new Promise((h,f)=>{const E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript");const c=()=>{E.removeEventListener("load",u),E.removeEventListener("error",d)},u=v=>{c(),h(this._defineCalls.pop())},d=v=>{c(),f(v)};E.addEventListener("load",u),E.addEventListener("error",d),this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),E.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(E)})}_workerLoadScript(g){return new Promise((h,f)=>{try{this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),importScripts(g),h(this._defineCalls.pop())}catch(E){f(E)}})}async _nodeJSLoadScript(g){try{const h=globalThis._VSCODE_NODE_MODULES.fs,f=globalThis._VSCODE_NODE_MODULES.vm,E=globalThis._VSCODE_NODE_MODULES.module,c=A.URI.parse(g).fsPath,u=h.readFileSync(c).toString(),d=E.wrap(u.replace(/^#!.*/,""));return new f.Script(d).runInThisContext().apply(),this._defineCalls.pop()}catch(h){throw h}}}const P=new Map;let m={};typeof globalThis.require=="object"&&(m=globalThis.require.paths??{});async function I(y,g,h){if(k.isESM){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),m[y]&&(y=m[y]);const f=`${y}/${g}`;if(P.has(f))return P.get(f);let E;if(/^\w[\w\d+.-]*:\/\//.test(f))E=f;else{const v=`${h&&!T.isWeb?O.nodeModulesAsarPath:O.nodeModulesPath}/${f}`;E=O.FileAccess.asBrowserUri(v).toString(!0)}const c=R.INSTANCE.load(E);return P.set(f,c),c}else return await new Promise((f,E)=>{ie([y],f,E)})}e.importAMDNodeModule=I}),define(ce[22],le([0,1,48,26,16,6,28,10]),function(ie,e,k,O,T,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function P(h){return(0,R.uriToFsPath)(h,!0)}e.originalFSPath=P;class m{constructor(f){this._ignorePathCasing=f}compare(f,E,c=!1){return f===E?0:(0,_.compare)(this.getComparisonKey(f,c),this.getComparisonKey(E,c))}isEqual(f,E,c=!1){return f===E?!0:!f||!E?!1:this.getComparisonKey(f,c)===this.getComparisonKey(E,c)}getComparisonKey(f,E=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,E,c=!1){if(f.scheme===E.scheme){if(f.scheme===O.Schemas.file)return k.isEqualOrParent(P(f),P(E),this._ignorePathCasing(f))&&f.query===E.query&&(c||f.fragment===E.fragment);if((0,e.isEqualAuthority)(f.authority,E.authority))return k.isEqualOrParent(f.path,E.path,this._ignorePathCasing(f),"/")&&f.query===E.query&&(c||f.fragment===E.fragment)}return!1}joinPath(f,...E){return R.URI.joinPath(f,...E)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return T.posix.basename(f.path)}extname(f){return T.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let E;return f.scheme===O.Schemas.file?E=R.URI.file(T.dirname(P(f))).path:(E=T.posix.dirname(f.path),f.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),E="/")),f.with({path:E})}normalizePath(f){if(!f.path.length)return f;let E;return f.scheme===O.Schemas.file?E=R.URI.file(T.normalize(P(f))).path:E=T.posix.normalize(f.path),f.with({path:E})}relativePath(f,E){if(f.scheme!==E.scheme||!(0,e.isEqualAuthority)(f.authority,E.authority))return;if(f.scheme===O.Schemas.file){const d=T.relative(P(f),P(E));return A.isWindows?k.toSlashes(d):d}let c=f.path||"/";const u=E.path||"/";if(this._ignorePathCasing(f)){let d=0;for(const v=Math.min(c.length,u.length);d<v&&!(c.charCodeAt(d)!==u.charCodeAt(d)&&c.charAt(d).toLowerCase()!==u.charAt(d).toLowerCase());d++);c=u.substr(0,d)+c.substr(d)}return T.posix.relative(c,u)}resolvePath(f,E){if(f.scheme===O.Schemas.file){const c=R.URI.file(T.resolve(P(f),E));return f.with({authority:c.authority,path:c.path})}return E=k.toPosixPath(E),f.with({path:T.posix.resolve(f.path,E)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,E){return f===E||f!==void 0&&E!==void 0&&(0,_.equalsIgnoreCase)(f,E)}hasTrailingPathSeparator(f,E=T.sep){if(f.scheme===O.Schemas.file){const c=P(f);return c.length>k.getRoot(c).length&&c[c.length-1]===E}else{const c=f.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,E=T.sep){return(0,e.hasTrailingPathSeparator)(f,E)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,E=T.sep){let c=!1;if(f.scheme===O.Schemas.file){const u=P(f);c=u!==void 0&&u.length===k.getRoot(u).length&&u[u.length-1]===E}else{E="/";const u=f.path;c=u.length===1&&u.charCodeAt(u.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(f,E)?f.with({path:f.path+"/"}):f}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(h=>h.scheme===O.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new m(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(h,f){const E=[];for(let c=0;c<h.length;c++){const u=f(h[c]);h.some((d,v)=>v===c?!1:(0,e.isEqualOrParent)(u,f(d)))||E.push(h[c])}return E}e.distinctParents=I;var y;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function f(E){const c=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(v=>{const[p,L]=v.split(":");p&&L&&c.set(p,L)});const d=E.path.substring(0,E.path.indexOf(";"));return d&&c.set(h.META_DATA_MIME,d),c}h.parseMetaData=f})(y||(e.DataUri=y={}));function g(h,f,E){if(f){let c=h.path;return c&&c[0]!==T.posix.sep&&(c=T.posix.sep+c),h.with({scheme:E,authority:f,path:c})}return h.with({scheme:E})}e.toLocalResource=g}),define(ce[5],le([0,1,25,8,3,2,22,6,128]),function(ie,e,k,O,T,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(b){return!!b&&typeof b.then=="function"}e.isThenable=m;function I(b){const D=new k.CancellationTokenSource,M=b(D.token),V=new Promise((ee,ne)=>{const de=D.token.onCancellationRequested(()=>{de.dispose(),D.dispose(),ne(new O.CancellationError)});Promise.resolve(M).then(X=>{de.dispose(),D.dispose(),ee(X)},X=>{de.dispose(),D.dispose(),ne(X)})});return new class{cancel(){D.cancel()}then(ee,ne){return V.then(ee,ne)}catch(ee){return this.then(void 0,ee)}finally(ee){return V.finally(ee)}}}e.createCancelablePromise=I;function y(b,D,M){return new Promise((V,ee)=>{const ne=D.onCancellationRequested(()=>{ne.dispose(),V(M)});b.then(V,ee).finally(()=>ne.dispose())})}e.raceCancellation=y;function g(b,D){return new Promise((M,V)=>{const ee=D.onCancellationRequested(()=>{ee.dispose(),V(new O.CancellationError)});b.then(M,V).finally(()=>ee.dispose())})}e.raceCancellationError=g;async function h(b){let D=-1;const M=b.map((V,ee)=>V.then(ne=>(D=ee,ne)));try{return await Promise.race(M)}finally{b.forEach((V,ee)=>{ee!==D&&V.cancel()})}}e.raceCancellablePromises=h;function f(b,D,M){let V;const ee=setTimeout(()=>{V?.(void 0),M?.()},D);return Promise.race([b.finally(()=>clearTimeout(ee)),new Promise(ne=>V=ne)])}e.raceTimeout=f;function E(b){return new Promise((D,M)=>{const V=b();m(V)?V.then(D,M):D(V)})}e.asPromise=E;class c{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(D){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=D,!this.queuedPromise){const M=()=>{if(this.queuedPromise=null,this.isDisposed)return;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(M,M).then(V)})}return new Promise((M,V)=>{this.queuedPromise.then(M,V)})}return this.activePromise=D(),new Promise((M,V)=>{this.activePromise.then(ee=>{this.activePromise=null,M(ee)},ee=>{this.activePromise=null,V(ee)})})}dispose(){this.isDisposed=!0}}e.Throttler=c;class u{constructor(){this.current=Promise.resolve(null)}queue(D){return this.current=this.current.then(()=>D(),()=>D())}}e.Sequencer=u;class d{constructor(){this.promiseMap=new Map}queue(D,M){const ee=(this.promiseMap.get(D)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(D)===ee&&this.promiseMap.delete(D)});return this.promiseMap.set(D,ee),ee}}e.SequencerByKey=d;const v=(b,D)=>{let M=!0;const V=setTimeout(()=>{M=!1,D()},b);return{isTriggered:()=>M,dispose:()=>{clearTimeout(V),M=!1}}},p=b=>{let D=!0;return queueMicrotask(()=>{D&&(D=!1,b())}),{isTriggered:()=>D,dispose:()=>{D=!1}}};class L{constructor(D){this.defaultDelay=D,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(D,M=this.defaultDelay){this.task=D,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ee,ne)=>{this.doResolve=ee,this.doReject=ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ee=this.task;return this.task=null,ee()}}));const V=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=M===P.MicrotaskDelay?p(V):v(M,V),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new O.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=L;class t{constructor(D){this.delayer=new L(D),this.throttler=new c}trigger(D,M){return this.delayer.trigger(()=>this.throttler.queue(D),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=t;class o{constructor(){this._isOpen=!1,this._promise=new Promise((D,M)=>{this._completePromise=D})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class s extends o{constructor(D){super(),this._timeout=setTimeout(()=>this.open(),D)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function n(b,D){return D?new Promise((M,V)=>{const ee=setTimeout(()=>{ne.dispose(),M()},b),ne=D.onCancellationRequested(()=>{clearTimeout(ee),ne.dispose(),V(new O.CancellationError)})}):I(M=>n(b,M))}e.timeout=n;function i(b,D=0){const M=setTimeout(b,D);return(0,A.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=i;function r(b){const D=[];let M=0;const V=b.length;function ee(){return M<V?b[M++]():null}function ne(de){de!=null&&D.push(de);const X=ee();return X?X.then(ne):Promise.resolve(D)}return Promise.resolve(null).then(ne)}e.sequence=r;function a(b,D=V=>!!V,M=null){let V=0;const ee=b.length,ne=()=>{if(V>=ee)return Promise.resolve(M);const de=b[V++];return Promise.resolve(de()).then(se=>D(se)?Promise.resolve(se):ne())};return ne()}e.first=a;function w(b,D=V=>!!V,M=null){if(b.length===0)return Promise.resolve(M);let V=b.length;const ee=()=>{V=-1;for(const ne of b)ne.cancel?.()};return new Promise((ne,de)=>{for(const X of b)X.then(se=>{--V>=0&&D(se)?(ee(),ne(se)):V===0&&ne(M)}).catch(se=>{--V>=0&&(ee(),de(se))})})}e.firstParallel=w;class S{constructor(D){this._size=0,this.maxDegreeOfParalellism=D,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new T.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(D){return this._size++,new Promise((M,V)=>{this.outstandingPromises.push({factory:D,c:M,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const D=this.outstandingPromises.shift();this.runningPromises++;const M=D.factory();M.then(D.c,D.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=S;class l extends S{constructor(){super(1)}}e.Queue=l;class C{constructor(){this.sequentializer=new Y,this.tasks=0}queue(D){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,D())):this.sequentializer.run(this.tasks++,D())}}e.LimitedQueue=C;class U{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const D=new q;return this.drainers.add(D),D.p}isDrained(){for(const[,D]of this.queues)if(D.size>0)return!1;return!0}queueFor(D,M=_.extUri){const V=M.getComparisonKey(D);let ee=this.queues.get(V);return ee||(ee=new l,T.Event.once(ee.onDrained)(()=>{ee?.dispose(),this.queues.delete(V),this.onDidQueueDrain()}),this.queues.set(V,ee)),ee}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const D of this.drainers)D.complete();this.drainers.clear()}dispose(){for(const[,D]of this.queues)D.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=U;class N{constructor(D,M){this._token=-1,typeof D=="function"&&typeof M=="number"&&this.setIfNotSet(D,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(D,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,D()},M)}setIfNotSet(D,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,D()},M))}}e.TimeoutTimer=N;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(D,M){this.cancel(),this._token=setInterval(()=>{D()},M)}}e.IntervalTimer=F;class ${constructor(D,M){this.timeoutToken=-1,this.runner=D,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(D=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,D)}get delay(){return this.timeout}set delay(D){this.timeout=D}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=$;class z{constructor(D,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.runner=D,this.timeout=M,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(D=this.timeout){D%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${D}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(D/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=z;class J extends ${constructor(D,M){super(D,M),this.units=[]}work(D){this.units.push(D),this.isScheduled()||this.schedule()}doRun(){const D=this.units;this.units=[],this.runner?.(D)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=J;class H extends A.Disposable{constructor(D,M){super(),this.options=D,this.handler=M,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(D){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+D.length>this.options.maxBufferedWork)return!1}else if(this.pending+D.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const M of D)this.pendingWork.push(M);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new $(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=b=>{(0,R.setTimeout0)(()=>{if(D)return;const M=Date.now()+15;b(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let D=!1;return{dispose(){D||(D=!0)}}}:e.runWhenIdle=(b,D)=>{const M=requestIdleCallback(b,typeof D=="number"?{timeout:D}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(M))}}}}();class Q{constructor(D){this._didRun=!1,this._executor=()=>{try{this._value=D()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=Q;async function B(b,D,M){let V;for(let ee=0;ee<M;ee++)try{return await b()}catch(ne){V=ne,await n(D)}throw V}e.retry=B;class Y{isRunning(D){return typeof D=="number"?this._running?.taskId===D:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(D,M,V){return this._running={taskId:D,cancel:()=>V?.(),promise:M},M.then(()=>this.doneRunning(D),()=>this.doneRunning(D)),M}doneRunning(D){this._running&&D===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const D=this._queued;this._queued=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}queue(D){if(this._queued)this._queued.run=D;else{let M,V;const ee=new Promise((ne,de)=>{M=ne,V=de});this._queued={run:D,promise:ee,promiseResolve:M,promiseReject:V}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Y;class x{constructor(D,M=()=>Date.now()){this.interval=D,this.nowFn=M,this.lastIncrementTime=0,this.value=0}increment(){const D=this.nowFn();return D-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=D,this.value=0),this.value++,this.value}}e.IntervalCounter=x;var j;(function(b){b[b.Resolved=0]="Resolved",b[b.Rejected=1]="Rejected"})(j||(j={}));class q{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((D,M)=>{this.completeCallback=D,this.errorCallback=M})}complete(D){return new Promise(M=>{this.completeCallback(D),this.outcome={outcome:0,value:D},M()})}error(D){return new Promise(M=>{this.errorCallback(D),this.outcome={outcome:1,value:D},M()})}cancel(){return this.error(new O.CancellationError)}}e.DeferredPromise=q;var Z;(function(b){async function D(V){let ee;const ne=await Promise.all(V.map(de=>de.then(X=>X,X=>{ee||(ee=X)})));if(typeof ee<"u")throw ee;return ne}b.settled=D;function M(V){return new Promise(async(ee,ne)=>{try{await V(ee,ne)}catch(de){ne(de)}})}b.withAsyncBody=M})(Z||(e.Promises=Z={}));var oe;(function(b){b[b.Initial=0]="Initial",b[b.DoneOK=1]="DoneOK",b[b.DoneError=2]="DoneError"})(oe||(oe={}));class ae{static fromArray(D){return new ae(M=>{M.emitMany(D)})}static fromPromise(D){return new ae(async M=>{M.emitMany(await D)})}static fromPromises(D){return new ae(async M=>{await Promise.all(D.map(async V=>M.emitOne(await V)))})}static merge(D){return new ae(async M=>{await Promise.all(D.map(async V=>{for await(const ee of V)M.emitOne(ee)}))})}static{this.EMPTY=ae.fromArray([])}constructor(D){this._state=0,this._results=[],this._error=null,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const M={emitOne:V=>this.emitOne(V),emitMany:V=>this.emitMany(V),reject:V=>this.reject(V)};try{await Promise.resolve(D(M)),this.resolve()}catch(V){this.reject(V)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let D=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(D<this._results.length)return{done:!1,value:this._results[D++]};if(this._state===1)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(D,M){return new ae(async V=>{for await(const ee of D)V.emitOne(M(ee))})}map(D){return ae.map(this,D)}static filter(D,M){return new ae(async V=>{for await(const ee of D)M(ee)&&V.emitOne(ee)})}filter(D){return ae.filter(this,D)}static coalesce(D){return ae.filter(D,M=>!!M)}coalesce(){return ae.coalesce(this)}static async toPromise(D){const M=[];for await(const V of D)M.push(V);return M}toPromise(){return ae.toPromise(this)}emitOne(D){this._state===0&&(this._results.push(D),this._onStateChanged.fire())}emitMany(D){this._state===0&&(this._results=this._results.concat(D),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(D){this._state===0&&(this._state=2,this._error=D,this._onStateChanged.fire())}}e.AsyncIterableObject=ae;class G extends ae{constructor(D,M){super(M),this._source=D}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=G;function W(b){const D=new k.CancellationTokenSource,M=b(D.token);return new G(D,async V=>{const ee=D.token.onCancellationRequested(()=>{ee.dispose(),D.dispose(),V.reject(new O.CancellationError)});try{for await(const ne of M){if(D.token.isCancellationRequested)return;V.emitOne(ne)}ee.dispose(),D.dispose()}catch(ne){ee.dispose(),D.dispose(),V.reject(ne)}})}e.createCancelableAsyncIterable=W}),define(ce[91],le([0,1,20,5,48,35,16,6,28]),function(ie,e,k,O,T,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",y="[^/\\\\]",g=/\//g;function h(Y,x){switch(Y){case 0:return"";case 1:return`${y}*?`;default:return`(?:${I}|${y}+${I}${x?`|${I}${y}+`:""})*?`}}function f(Y,x){if(!Y)return[];const j=[];let q=!1,Z=!1,oe="";for(const ae of Y){switch(ae){case x:if(!q&&!Z){j.push(oe),oe="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}oe+=ae}return oe&&j.push(oe),j}e.splitGlobAware=f;function E(Y){if(!Y)return"";let x="";const j=f(Y,e.GLOB_SPLIT);if(j.every(q=>q===e.GLOBSTAR))x=".*";else{let q=!1;j.forEach((Z,oe)=>{if(Z===e.GLOBSTAR){if(q)return;x+=h(2,oe===j.length-1)}else{let ae=!1,G="",W=!1,b="";for(const D of Z){if(D!=="}"&&ae){G+=D;continue}if(W&&(D!=="]"||!b)){let M;D==="-"?M=D:(D==="^"||D==="!")&&!b?M="^":D===e.GLOB_SPLIT?M="":M=(0,P.escapeRegExpCharacters)(D),b+=M;continue}switch(D){case"{":ae=!0;continue;case"[":W=!0;continue;case"}":{const V=`(?:${f(G,",").map(ee=>E(ee)).join("|")})`;x+=V,ae=!1,G="";break}case"]":{x+="["+b+"]",W=!1,b="";break}case"?":x+=y;continue;case"*":x+=h(1);continue;default:x+=(0,P.escapeRegExpCharacters)(D)}}oe<j.length-1&&(j[oe+1]!==e.GLOBSTAR||oe+2<j.length)&&(x+=I)}q=Z===e.GLOBSTAR})}return x}const c=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,L=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),o=function(){return!1},s=function(){return null};function n(Y,x){if(!Y)return s;let j;typeof Y!="string"?j=Y.pattern:j=Y,j=j.trim();const q=`${j}_${!!x.trimForExclusions}`;let Z=t.get(q);if(Z)return i(Z,Y);let oe;return c.test(j)?Z=a(j.substr(4),j):(oe=u.exec(r(j,x)))?Z=w(oe[1],j):(x.trimForExclusions?v:d).test(j)?Z=S(j,x):(oe=p.exec(r(j,x)))?Z=l(oe[1].substr(1),j,!0):(oe=L.exec(r(j,x)))?Z=l(oe[1],j,!1):Z=C(j),t.set(q,Z),i(Z,Y)}function i(Y,x){if(typeof x=="string")return Y;const j=function(q,Z){return(0,T.isEqualOrParent)(q,x.base,!R.isLinux)?Y((0,P.ltrim)(q.substr(x.base.length),_.sep),Z):null};return j.allBasenames=Y.allBasenames,j.allPaths=Y.allPaths,j.basenames=Y.basenames,j.patterns=Y.patterns,j}function r(Y,x){return x.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function a(Y,x){return function(j,q){return typeof j=="string"&&j.endsWith(Y)?x:null}}function w(Y,x){const j=`/${Y}`,q=`\\${Y}`,Z=function(ae,G){return typeof ae!="string"?null:G?G===Y?x:null:ae===Y||ae.endsWith(j)||ae.endsWith(q)?x:null},oe=[Y];return Z.basenames=oe,Z.patterns=[x],Z.allBasenames=oe,Z}function S(Y,x){const j=Q(Y.slice(1,-1).split(",").map(G=>n(G,x)).filter(G=>G!==s),Y),q=j.length;if(!q)return s;if(q===1)return j[0];const Z=function(G,W){for(let b=0,D=j.length;b<D;b++)if(j[b](G,W))return Y;return null},oe=j.find(G=>!!G.allBasenames);oe&&(Z.allBasenames=oe.allBasenames);const ae=j.reduce((G,W)=>W.allPaths?G.concat(W.allPaths):G,[]);return ae.length&&(Z.allPaths=ae),Z}function l(Y,x,j){const q=_.sep===_.posix.sep,Z=q?Y:Y.replace(g,_.sep),oe=_.sep+Z,ae=_.posix.sep+Y;let G;return j?G=function(W,b){return typeof W=="string"&&(W===Z||W.endsWith(oe)||!q&&(W===Y||W.endsWith(ae)))?x:null}:G=function(W,b){return typeof W=="string"&&(W===Z||!q&&W===Y)?x:null},G.allPaths=[(j?"*/":"./")+Y],G}function C(Y){try{const x=new RegExp(`^${E(Y)}$`);return function(j){return x.lastIndex=0,typeof j=="string"&&x.test(j)?Y:null}}catch{return s}}function U(Y,x,j){return!Y||typeof x!="string"?!1:N(Y)(x,void 0,j)}e.match=U;function N(Y,x={}){if(!Y)return o;if(typeof Y=="string"||F(Y)){const j=n(Y,x);if(j===s)return o;const q=function(Z,oe){return!!j(Z,oe)};return j.allBasenames&&(q.allBasenames=j.allBasenames),j.allPaths&&(q.allPaths=j.allPaths),q}return J(Y,x)}e.parse=N;function F(Y){const x=Y;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=F;function $(Y){return Y.allBasenames||[]}e.getBasenameTerms=$;function z(Y){return Y.allPaths||[]}e.getPathTerms=z;function J(Y,x){const j=Q(Object.getOwnPropertyNames(Y).map(G=>H(G,Y[G],x)).filter(G=>G!==s)),q=j.length;if(!q)return s;if(!j.some(G=>!!G.requiresSiblings)){if(q===1)return j[0];const G=function(D,M){let V;for(let ee=0,ne=j.length;ee<ne;ee++){const de=j[ee](D,M);if(typeof de=="string")return de;(0,O.isThenable)(de)&&(V||(V=[]),V.push(de))}return V?(async()=>{for(const ee of V){const ne=await ee;if(typeof ne=="string")return ne}return null})():null},W=j.find(D=>!!D.allBasenames);W&&(G.allBasenames=W.allBasenames);const b=j.reduce((D,M)=>M.allPaths?D.concat(M.allPaths):D,[]);return b.length&&(G.allPaths=b),G}const Z=function(G,W,b){let D,M;for(let V=0,ee=j.length;V<ee;V++){const ne=j[V];ne.requiresSiblings&&b&&(W||(W=(0,_.basename)(G)),D||(D=W.substr(0,W.length-(0,_.extname)(G).length)));const de=ne(G,W,D,b);if(typeof de=="string")return de;(0,O.isThenable)(de)&&(M||(M=[]),M.push(de))}return M?(async()=>{for(const V of M){const ee=await V;if(typeof ee=="string")return ee}return null})():null},oe=j.find(G=>!!G.allBasenames);oe&&(Z.allBasenames=oe.allBasenames);const ae=j.reduce((G,W)=>W.allPaths?G.concat(W.allPaths):G,[]);return ae.length&&(Z.allPaths=ae),Z}function H(Y,x,j){if(x===!1)return s;const q=n(Y,j);if(q===s)return s;if(typeof x=="boolean")return q;if(x){const Z=x.when;if(typeof Z=="string"){const oe=(ae,G,W,b)=>{if(!b||!q(ae,G))return null;const D=Z.replace("$(basename)",()=>W),M=b(D);return(0,O.isThenable)(M)?M.then(V=>V?Y:null):M?Y:null};return oe.requiresSiblings=!0,oe}}return q}function Q(Y,x){const j=Y.filter(G=>!!G.basenames);if(j.length<2)return Y;const q=j.reduce((G,W)=>{const b=W.basenames;return b?G.concat(b):G},[]);let Z;if(x){Z=[];for(let G=0,W=q.length;G<W;G++)Z.push(x)}else Z=j.reduce((G,W)=>{const b=W.patterns;return b?G.concat(b):G},[]);const oe=function(G,W){if(typeof G!="string")return null;if(!W){let D;for(D=G.length;D>0;D--){const M=G.charCodeAt(D-1);if(M===47||M===92)break}W=G.substr(D)}const b=q.indexOf(W);return b!==-1?Z[b]:null};oe.basenames=q,oe.patterns=Z,oe.allBasenames=q;const ae=Y.filter(G=>!G.basenames);return ae.push(oe),ae}function B(Y,x){return(0,k.equals)(Y,x,(j,q)=>typeof j=="string"&&typeof q=="string"?j===q:typeof j!="string"&&typeof q!="string"?j.base===q.base&&j.pattern===q.pattern:!1)}e.patternsEquals=B}),define(ce[92],le([0,1,14,10]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(y){return y.toJSON()}class A{constructor(g){this._uriTransformer=g}transformIncoming(g){const h=this._uriTransformer.transformIncoming(g);return h===g?g:T(O.URI.from(h))}transformOutgoing(g){const h=this._uriTransformer.transformOutgoing(g);return h===g?g:T(O.URI.from(h))}transformOutgoingURI(g){const h=this._uriTransformer.transformOutgoing(g);return h===g?g:O.URI.from(h)}transformOutgoingScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function _(y,g,h){if(!y||h>200)return null;if(typeof y=="object"){if(y instanceof O.URI)return g.transformOutgoing(y);for(const f in y)if(Object.hasOwnProperty.call(y,f)){const E=_(y[f],g,h+1);E!==null&&(y[f]=E)}}return null}function R(y,g){const h=_(y,g,0);return h===null?y:h}e.transformOutgoingURIs=R;function P(y,g,h,f){if(!y||f>200)return null;if(typeof y=="object"){if(y.$mid===1)return h?O.URI.revive(g.transformIncoming(y)):g.transformIncoming(y);if(y instanceof k.VSBuffer)return null;for(const E in y)if(Object.hasOwnProperty.call(y,E)){const c=P(y[E],g,h,f+1);c!==null&&(y[E]=c)}}return null}function m(y,g){const h=P(y,g,!1,0);return h===null?y:h}e.transformIncomingURIs=m;function I(y,g){const h=P(y,g,!0,0);return h===null?y:h}e.transformAndReviveIncomingURIs=I}),define(ce[31],le([0,1,52,36,267,5,48,88,16,6,22,10]),function(ie,e,k,O,T,A,_,R,P,m,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function h(H,Q=g.UNLINK,B){if((0,_.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");return Q===g.UNLINK?E(H):f(H,B)}async function f(H,Q=(0,_.randomPath)((0,O.tmpdir)())){try{try{await k.promises.rename(H,Q)}catch(B){return B.code==="ENOENT"?void 0:E(H)}E(Q).catch(B=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function E(H){return(0,T.promisify)(k.rm)(H,{recursive:!0,force:!0,maxRetries:3})}function c(H){if((0,_.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(H,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function u(H,Q){return p(await(Q?d(H):(0,T.promisify)(k.readdir)(H)))}async function d(H){try{return await(0,T.promisify)(k.readdir)(H,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const Q=[],B=await u(H);for(const Y of B){let x=!1,j=!1,q=!1;try{const Z=await e.Promises.lstat((0,P.join)(H,Y));x=Z.isFile(),j=Z.isDirectory(),q=Z.isSymbolicLink()}catch(Z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Z)}Q.push({name:Y,isFile:()=>x,isDirectory:()=>j,isSymbolicLink:()=>q})}return Q}function v(H){return p(k.readdirSync(H))}e.readdirSync=v;function p(H){return H.map(Q=>typeof Q=="string"?m.isMacintosh?(0,R.normalizeNFC)(Q):Q:(Q.name=m.isMacintosh?(0,R.normalizeNFC)(Q.name):Q.name,Q))}async function L(H){const Q=await u(H),B=[];for(const Y of Q)await o.existsDirectory((0,P.join)(H,Y))&&B.push(Y);return B}function t(H,Q=1e3){return new Promise(B=>{let Y=!1;const x=setInterval(()=>{Y||(Y=!0,k.access(H,j=>{Y=!1,j&&(clearInterval(x),B(void 0))}))},Q)})}e.whenDeleted=t;var o;(function(H){async function Q(x){let j;try{if(j=await e.Promises.lstat(x),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(m.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(Z){if(Z.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw Z}throw q}}H.stat=Q;async function B(x){try{const{stat:j,symbolicLink:q}=await H.stat(x);return j.isFile()&&q?.dangling!==!0}catch{}return!1}H.existsFile=B;async function Y(x){try{const{stat:j,symbolicLink:q}=await H.stat(x);return j.isDirectory()&&q?.dangling!==!0}catch{}return!1}H.existsDirectory=Y})(o||(e.SymlinkSupport=o={}));const s=new A.ResourceQueue;function n(H,Q,B){return s.queueFor(y.URI.file(H),I.extUriBiasedIgnorePathCase).queue(()=>{const Y=S(B);return new Promise((x,j)=>a(H,Q,Y,q=>q?j(q):x()))})}let i=!0;function r(H){i=H}e.configureFlushOnWrite=r;function a(H,Q,B,Y){if(!i)return k.writeFile(H,Q,{mode:B.mode,flag:B.flag},Y);k.open(H,B.flag,B.mode,(x,j)=>{if(x)return Y(x);k.writeFile(j,Q,q=>{if(q)return k.close(j,()=>Y(q));k.fdatasync(j,Z=>(Z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Z),r(!1)),k.close(j,oe=>Y(oe))))})})}function w(H,Q,B){const Y=S(B);if(!i)return k.writeFileSync(H,Q,{mode:Y.mode,flag:Y.flag});const x=k.openSync(H,Y.flag,Y.mode);try{k.writeFileSync(x,Q);try{k.fdatasyncSync(x)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),r(!1)}}finally{k.closeSync(x)}}e.writeFileSync=w;function S(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function l(H,Q,B=6e4){if(H!==Q)try{m.isWindows&&typeof B=="number"?await C(H,Q,Date.now(),B):await(0,T.promisify)(k.rename)(H,Q)}catch(Y){if(H.toLowerCase()!==Q.toLowerCase()&&Y.code==="EXDEV"||H.endsWith("."))await U(H,Q,{preserveSymlinks:!1}),await h(H,g.MOVE);else throw Y}}async function C(H,Q,B,Y,x=0){try{return await(0,T.promisify)(k.rename)(H,Q)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-B>=Y)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${j}`),j;if(x===0){let q=!1;try{const{stat:Z}=await o.stat(Q);Z.isFile()||(q=!0)}catch{}if(q)throw j}return await(0,A.timeout)(Math.min(100,x*10)),C(H,Q,B,Y,x+1)}}async function U(H,Q,B){return F(H,Q,{root:{source:H,target:Q},options:B,handledSourcePaths:new Set})}const N=511;async function F(H,Q,B){if(B.handledSourcePaths.has(H))return;B.handledSourcePaths.add(H);const{stat:Y,symbolicLink:x}=await o.stat(H);if(x){if(B.options.preserveSymlinks)try{return await J(H,Q,B)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(x.dangling)return}return Y.isDirectory()?$(H,Q,Y.mode&N,B):z(H,Q,Y.mode&N)}async function $(H,Q,B,Y){await e.Promises.mkdir(Q,{recursive:!0,mode:B});const x=await u(H);for(const j of x)await F((0,P.join)(H,j),(0,P.join)(Q,j),Y)}async function z(H,Q,B){await e.Promises.copyFile(H,Q),await e.Promises.chmod(Q,B)}async function J(H,Q,B){let Y=await e.Promises.readlink(H);(0,_.isEqualOrParent)(Y,B.root.source,!m.isLinux)&&(Y=(0,P.join)(B.root.target,Y.substr(B.root.source.length+1))),await e.Promises.symlink(Y,Q)}e.Promises=new class{get access(){return(0,T.promisify)(k.access)}get stat(){return(0,T.promisify)(k.stat)}get lstat(){return(0,T.promisify)(k.lstat)}get utimes(){return(0,T.promisify)(k.utimes)}get read(){return(H,Q,B,Y,x)=>new Promise((j,q)=>{k.read(H,Q,B,Y,x,(Z,oe,ae)=>Z?q(Z):j({bytesRead:oe,buffer:ae}))})}get readFile(){return(0,T.promisify)(k.readFile)}get write(){return(H,Q,B,Y,x)=>new Promise((j,q)=>{k.write(H,Q,B,Y,x,(Z,oe,ae)=>Z?q(Z):j({bytesWritten:oe,buffer:ae}))})}get appendFile(){return(0,T.promisify)(k.appendFile)}get fdatasync(){return(0,T.promisify)(k.fdatasync)}get truncate(){return(0,T.promisify)(k.truncate)}get copyFile(){return(0,T.promisify)(k.copyFile)}get open(){return(0,T.promisify)(k.open)}get close(){return(0,T.promisify)(k.close)}get symlink(){return(0,T.promisify)(k.symlink)}get readlink(){return(0,T.promisify)(k.readlink)}get chmod(){return(0,T.promisify)(k.chmod)}get mkdir(){return(0,T.promisify)(k.mkdir)}get unlink(){return(0,T.promisify)(k.unlink)}get rmdir(){return(0,T.promisify)(k.rmdir)}get realpath(){return(0,T.promisify)(k.realpath)}async exists(H){try{return await e.Promises.access(H),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return L}get writeFile(){return n}get rm(){return h}get rename(){return l}get copy(){return U}}}),define(ce[142],le([0,1,52,16,6,28,31]),function(ie,e,k,O,T,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(g){if(T.isLinux)return g;const h=(0,O.dirname)(g);if(g===h)return g;const f=((0,O.basename)(g)||g).toLowerCase();try{const c=(0,_.readdirSync)(h).filter(u=>u.toLowerCase()===f);if(c.length===1){const u=R(h);if(u)return(0,O.join)(u,c[0])}else if(c.length>1){const u=c.indexOf(f);if(u>=0){const d=R(h);if(d)return(0,O.join)(d,c[u])}}}catch{}return null}e.realcaseSync=R;async function P(g){if(T.isLinux)return g;const h=(0,O.dirname)(g);if(g===h)return g;const f=((0,O.basename)(g)||g).toLowerCase();try{const c=(await _.Promises.readdir(h)).filter(u=>u.toLowerCase()===f);if(c.length===1){const u=await P(h);if(u)return(0,O.join)(u,c[0])}else if(c.length>1){const u=c.indexOf(f);if(u>=0){const d=await P(h);if(d)return(0,O.join)(d,c[u])}}}catch{}return null}e.realcase=P;async function m(g){try{return await _.Promises.realpath(g)}catch{const f=y(g);return await _.Promises.access(f,k.constants.R_OK),f}}e.realpath=m;function I(g){try{return k.realpathSync(g)}catch{const f=y(g);return k.accessSync(f,k.constants.R_OK),f}}e.realpathSync=I;function y(g){return(0,A.rtrim)((0,O.normalize)(g),O.sep)}}),define(ce[143],le([0,1,16,6,37,90,11,31]),function(ie,e,k,O,T,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function P(y=T.env){return y.comspec||"cmd.exe"}e.getWindowsShell=P;function m(y){let g=[],h=!1;const f=function(E){if(h){g.push(E);return}(!y.send(E,u=>{if(u&&console.error(u),h=!1,g.length>0){const d=g.slice(0);g=[],d.forEach(v=>f(v))}})||O.isWindows)&&(h=!0)};return{send:f}}e.createQueuedSender=m;var I;(function(y){async function g(h,f,E){if(k.isAbsolute(h))return h;if(f===void 0&&(f=T.cwd()),k.dirname(h)!=="."||(E===void 0&&_.isString(T.env.PATH)&&(E=T.env.PATH.split(k.delimiter)),E===void 0||E.length===0))return k.join(f,h);async function u(d){if(await R.Promises.exists(d)){let v;try{v=await R.Promises.stat(d)}catch(p){p.message.startsWith("EACCES")&&(v=await R.Promises.lstat(d))}return v?!v.isDirectory():!1}return!1}for(const d of E){let v;if(k.isAbsolute(d)?v=k.join(d,h):v=k.join(f,d,h),await u(v))return v;let p=v+".com";if(await u(p)||(p=v+".exe",await u(p)))return p}return k.join(f,h)}y.findExecutable=g})(I||(e.win32=I={}))}),define(ce[144],le([0,1,64,26]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function T(_){return new Promise((R,P)=>{let m;const I=new Map;function y(h,f,E,c,u){const d=I.get(f);if(h===_||d){const v={name:g(E),cmd:E,pid:h,ppid:f,load:c,mem:u};I.set(h,v),h===_&&(m=v),d&&(d.children||(d.children=[]),d.children.push(v),d.children.length>1&&(d.children=d.children.sort((p,L)=>p.pid-L.pid)))}}function g(h){const f=/--utility-sub-type=network/i,E=/--ms-enable-electron-run-as-node/i,c=/--crashes-directory/i,u=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,v=/--type=([a-zA-Z-]+)/;if(c.exec(h))return"electron-crash-reporter";if(u.exec(h))return"winpty-agent";if(d.exec(h))return"conpty-agent";let p=v.exec(h);if(p&&p.length===2)return p[1]==="renderer"?"window":p[1]==="utility"?f.exec(h)?"utility-network-service":"utility-process":p[1]==="extensionHost"?"extension-host":p[1];const L=/[a-zA-Z-]+\.js/g;let t="";do p=L.exec(h),p&&(t+=p+" ");while(p);return t&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${t})`:E.exec(h)?`electron-nodejs (${h})`:h}if(process.platform==="win32"){const h=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,E)=>{ie(["@vscode/windows-process-tree"],f,E)}).then(f=>{f.getProcessList(_,E=>{if(!E){P(new Error(`Root process ${_} not found`));return}f.getProcessCpuUsage(E,c=>{const u=new Map;c.forEach(d=>{const v=h(d.commandLine||"");u.set(d.pid,{name:g(v),cmd:v,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),m=u.get(_),m?(u.forEach(d=>{const v=u.get(d.ppid);v&&(v.children||(v.children=[]),v.children.push(d))}),u.forEach(d=>{d.children&&(d.children=d.children.sort((v,p)=>v.pid-p.pid))}),R(m)):P(new Error(`Root process ${_} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let h=function(){let f=[m];const E=[];for(;f.length;){const u=f.shift();u&&(E.push(u.pid),u.children&&(f=f.concat(u.children)))}let c=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+E.join(" "),(0,k.exec)(c,{},(u,d,v)=>{if(u||v)P(u||new Error(v.toString()));else{const p=d.toString().split(`
`);for(let L=0;L<E.length;L++){const t=I.get(E[L]);t.load=parseFloat(p[L])}if(!m){P(new Error(`Root process ${_} not found`));return}R(m)}})};(0,k.exec)("which ps",{},(f,E,c)=>{if(f||c)if(process.platform!=="linux")P(f||new Error(c.toString()));else{const u=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(u,{},(d,v,p)=>{d||p?P(d||new Error(p.toString())):(A(v,y),h())})}else{const u=E.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${u} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,p,L)=>{v||L&&!L.includes("screen size is bogus")?P(v||new Error(L.toString())):(A(p,y),process.platform==="linux"?h():m?R(m):P(new Error(`Root process ${_} not found`)))})}})}})}e.listProcesses=T;function A(_,R){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=_.toString().split(`
`);for(const I of m){const y=P.exec(I.trim());y&&y.length===6&&R(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}});var ye=this&&this.__decorate||function(ie,e,k,O){var T=arguments.length,A=T<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,k):O,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ie,e,k,O);else for(var R=ie.length-1;R>=0;R--)(_=ie[R])&&(A=(T<3?_(A):T>3?_(e,k,A):_(e,k))||A);return T>3&&A&&Object.defineProperty(e,k,A),A};define(ce[43],le([0,1,20,5,14,25,83,8,3,2,63,28,11]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var h;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(h||(h={}));function f(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(E||(E={}));function c(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(u||(u={}));function d(x){let j=0;for(let q=0;;q+=7){const Z=x.read(1);if(j|=(Z.buffer[0]&127)<<q,!(Z.buffer[0]&128))return j}}const v=s(0);function p(x,j){if(j===0){x.write(v);return}let q=0;for(let oe=j;oe!==0;oe=oe>>>7)q++;const Z=T.VSBuffer.alloc(q);for(let oe=0;j!==0;oe++)Z.buffer[oe]=j&127,j=j>>>7,j>0&&(Z.buffer[oe]|=128);x.write(Z)}class L{constructor(j){this.buffer=j,this.pos=0}read(j){const q=this.buffer.slice(this.pos,this.pos+j);return this.pos+=q.byteLength,q}}e.BufferReader=L;class t{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}e.BufferWriter=t;var o;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(o||(o={}));function s(x){const j=T.VSBuffer.alloc(1);return j.writeUInt8(x,0),j}const n={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},i=typeof Buffer<"u";function r(x,j){if(typeof j>"u")x.write(n.Undefined);else if(typeof j=="string"){const q=T.VSBuffer.fromString(j);x.write(n.String),p(x,q.byteLength),x.write(q)}else if(i&&Buffer.isBuffer(j)){const q=T.VSBuffer.wrap(j);x.write(n.Buffer),p(x,q.byteLength),x.write(q)}else if(j instanceof T.VSBuffer)x.write(n.VSBuffer),p(x,j.byteLength),x.write(j);else if(Array.isArray(j)){x.write(n.Array),p(x,j.length);for(const q of j)r(x,q)}else if(typeof j=="number"&&(j|0)===j)x.write(n.Uint),p(x,j);else{const q=T.VSBuffer.fromString(JSON.stringify(j));x.write(n.Object),p(x,q.byteLength),x.write(q)}}e.serialize=r;function a(x){switch(x.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return x.read(d(x)).toString();case o.Buffer:return x.read(d(x)).buffer;case o.VSBuffer:return x.read(d(x));case o.Array:{const q=d(x),Z=[];for(let oe=0;oe<q;oe++)Z.push(a(x));return Z}case o.Object:return JSON.parse(x.read(d(x)).toString());case o.Int:return d(x)}}e.deserialize=a;class w{constructor(j,q,Z=null,oe=1e3){this.protocol=j,this.ctx=q,this.logger=Z,this.timeoutDelay=oe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ae=>this.onRawMessage(ae)),this.sendResponse({type:200})}registerChannel(j,q){this.channels.set(j,q),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const q=this.send([j.type]);this.logger?.logOutgoing(q,0,1,c(j.type));return}case 201:case 202:case 204:case 203:{const q=this.send([j.type,j.id],j.data);this.logger?.logOutgoing(q,j.id,1,c(j.type),j.data);return}}}send(j,q=void 0){const Z=new t;return r(Z,j),r(Z,q),this.sendBuffer(Z.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onRawMessage(j){const q=new L(j),Z=a(q),oe=a(q),ae=Z[0];switch(ae){case 100:return this.logger?.logIncoming(j.byteLength,Z[1],1,`${f(ae)}: ${Z[2]}.${Z[3]}`,oe),this.onPromise({type:ae,id:Z[1],channelName:Z[2],name:Z[3],arg:oe});case 102:return this.logger?.logIncoming(j.byteLength,Z[1],1,`${f(ae)}: ${Z[2]}.${Z[3]}`,oe),this.onEventListen({type:ae,id:Z[1],channelName:Z[2],name:Z[3],arg:oe});case 101:return this.logger?.logIncoming(j.byteLength,Z[1],1,`${f(ae)}`),this.disposeActiveRequest({type:ae,id:Z[1]});case 103:return this.logger?.logIncoming(j.byteLength,Z[1],1,`${f(ae)}`),this.disposeActiveRequest({type:ae,id:Z[1]})}}onPromise(j){const q=this.channels.get(j.channelName);if(!q){this.collectPendingRequest(j);return}const Z=new A.CancellationTokenSource;let oe;try{oe=q.call(this.ctx,j.name,j.arg,Z.token)}catch(W){oe=Promise.reject(W)}const ae=j.id;oe.then(W=>{this.sendResponse({id:ae,data:W,type:201}),this.activeRequests.delete(j.id)},W=>{W instanceof Error?this.sendResponse({id:ae,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split?W.stack.split(`
`):W.stack:void 0},type:202}):this.sendResponse({id:ae,data:W,type:203}),this.activeRequests.delete(j.id)});const G=(0,m.toDisposable)(()=>Z.cancel());this.activeRequests.set(j.id,G)}onEventListen(j){const q=this.channels.get(j.channelName);if(!q){this.collectPendingRequest(j);return}const Z=j.id,ae=q.listen(this.ctx,j.name,j.arg)(G=>this.sendResponse({id:Z,data:G,type:204}));this.activeRequests.set(j.id,ae)}disposeActiveRequest(j){const q=this.activeRequests.get(j.id);q&&(q.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let q=this.pendingRequests.get(j.channelName);q||(q=[],this.pendingRequests.set(j.channelName,q));const Z=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:j,timeoutTimer:Z})}flushPendingRequests(j){const q=this.pendingRequests.get(j);if(q){for(const Z of q)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.onPromise(Z.request);break;case 102:this.onEventListen(Z.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=w;var S;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class l{constructor(j,q=null){this.protocol=j,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new P.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Z=>this.onBuffer(Z)),this.logger=q}getChannel(j){const q=this;return{call(Z,oe,ae){return q.isDisposed?Promise.reject(new R.CancellationError):q.requestPromise(j,Z,oe,ae)},listen(Z,oe){return q.isDisposed?P.Event.None:q.requestEvent(j,Z,oe)}}}requestPromise(j,q,Z,oe=A.CancellationToken.None){const ae=this.lastRequestId++,W={id:ae,type:100,channelName:j,name:q,arg:Z};if(oe.isCancellationRequested)return Promise.reject(new R.CancellationError);let b;return new Promise((M,V)=>{if(oe.isCancellationRequested)return V(new R.CancellationError);const ee=()=>{const se=te=>{switch(te.type){case 201:this.handlers.delete(ae),M(te.data);break;case 202:{this.handlers.delete(ae);const he=new Error(te.data.message);he.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,he.name=te.data.name,V(he);break}case 203:this.handlers.delete(ae),V(te.data);break}};this.handlers.set(ae,se),this.sendRequest(W)};let ne=null;this.state===u.Idle?ee():(ne=(0,O.createCancelablePromise)(se=>this.whenInitialized()),ne.then(()=>{ne=null,ee()}));const de=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:ae,type:101}),V(new R.CancellationError)},X=oe.onCancellationRequested(de);b=(0,m.combinedDisposable)((0,m.toDisposable)(de),X),this.activeRequests.add(b)}).finally(()=>{this.activeRequests.delete(b)})}requestEvent(j,q,Z){const oe=this.lastRequestId++,G={id:oe,type:102,channelName:j,name:q,arg:Z};let W=null;const b=new P.Emitter({onWillAddFirstListener:()=>{W=(0,O.createCancelablePromise)(M=>this.whenInitialized()),W.then(()=>{W=null,this.activeRequests.add(b),this.sendRequest(G)})},onDidRemoveLastListener:()=>{W?(W.cancel(),W=null):(this.activeRequests.delete(b),this.sendRequest({id:oe,type:103}))}}),D=M=>b.fire(M.data);return this.handlers.set(oe,D),b.event}sendRequest(j){switch(j.type){case 100:case 102:{const q=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger?.logOutgoing(q,j.id,0,`${f(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const q=this.send([j.type,j.id]);this.logger?.logOutgoing(q,j.id,0,f(j.type));return}}}send(j,q=void 0){const Z=new t;return r(Z,j),r(Z,q),this.sendBuffer(Z.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onBuffer(j){const q=new L(j),Z=a(q),oe=a(q),ae=Z[0];switch(ae){case 200:return this.logger?.logIncoming(j.byteLength,0,0,c(ae)),this.onResponse({type:Z[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(j.byteLength,Z[1],0,c(ae),oe),this.onResponse({type:Z[0],id:Z[1],data:oe})}}onResponse(j){if(j.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(j.id)?.(j)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=l,ye([_.memoize],l.prototype,"onDidInitializePromise",null);class C{get connections(){const j=[];return this._connections.forEach(q=>j.push(q)),j}constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new P.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new P.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:q,onDidClientDisconnect:Z})=>{P.Event.once(q.onMessage)(ae=>{const G=new L(ae),W=a(G),b=new w(q,W),D=new l(q);this.channels.forEach((V,ee)=>b.registerChannel(ee,V));const M={channelServer:b,channelClient:D,ctx:W};this._connections.add(M),this._onDidAddConnection.fire(M),Z(()=>{b.dispose(),D.dispose(),this._connections.delete(M),this._onDidRemoveConnection.fire(M)})})})}getChannel(j,q){const Z=this;return{call(oe,ae,G){let W;if((0,g.isFunction)(q)){const D=(0,k.getRandomElement)(Z.connections.filter(q));W=D?Promise.resolve(D):P.Event.toPromise(P.Event.filter(Z.onDidAddConnection,q))}else W=q.routeCall(Z,oe,ae);const b=W.then(D=>D.channelClient.getChannel(j));return N(b).call(oe,ae,G)},listen(oe,ae){if((0,g.isFunction)(q))return Z.getMulticastEvent(j,q,oe,ae);const G=q.routeEvent(Z,oe,ae).then(W=>W.channelClient.getChannel(j));return N(G).listen(oe,ae)}}}getMulticastEvent(j,q,Z,oe){const ae=this;let G=new m.DisposableStore;const W=new P.Emitter({onWillAddFirstListener:()=>{G=new m.DisposableStore;const b=new P.EventMultiplexer,D=new Map,M=ee=>{const de=ee.channelClient.getChannel(j).listen(Z,oe),X=b.add(de);D.set(ee,X)},V=ee=>{const ne=D.get(ee);ne&&(ne.dispose(),D.delete(ee))};ae.connections.filter(q).forEach(M),P.Event.filter(ae.onDidAddConnection,q)(M,void 0,G),ae.onDidRemoveConnection(V,void 0,G),b.event(W.fire,W,G),G.add(b)},onDidRemoveLastListener:()=>{G.dispose()}});return W.event}registerChannel(j,q){this.channels.set(j,q),this._connections.forEach(Z=>{Z.channelServer.registerChannel(j,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=C;class U{constructor(j,q,Z=null){const oe=new t;r(oe,q),j.send(oe.buffer),this.channelClient=new l(j,Z),this.channelServer=new w(j,q,Z)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,q){this.channelServer.registerChannel(j,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function N(x){return{call(j,q,Z){return x.then(oe=>oe.call(j,q,Z))},listen(j,q){const Z=new P.Relay;return x.then(oe=>Z.input=oe.listen(j,q)),Z.event}}}e.getDelayedChannel=N;function F(x){let j=!1;return{call(q,Z,oe){return j?x.call(q,Z,oe):(0,O.timeout)(0).then(()=>j=!0).then(()=>x.call(q,Z,oe))},listen(q,Z){if(j)return x.listen(q,Z);const oe=new P.Relay;return(0,O.timeout)(0).then(()=>j=!0).then(()=>oe.input=x.listen(q,Z)),oe.event}}}e.getNextTickChannel=F;class ${constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const q of j.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await P.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=$;var z;(function(x){function j(ae,G){const W=ae,b=G&&G.disableMarshalling,D=new Map;for(const M in W)Z(M)&&D.set(M,P.Event.buffer(W[M],!0));return new class{listen(M,V,ee){const ne=D.get(V);if(ne)return ne;if(oe(V)){const de=W[V];if(typeof de=="function")return de.call(W,ee)}throw new R.ErrorNoTelemetry(`Event not found: ${V}`)}call(M,V,ee){const ne=W[V];if(typeof ne=="function"){if(!b&&Array.isArray(ee))for(let de=0;de<ee.length;de++)ee[de]=(0,I.revive)(ee[de]);return ne.apply(W,ee)}throw new R.ErrorNoTelemetry(`Method not found: ${V}`)}}}x.fromService=j;function q(ae,G){const W=G&&G.disableMarshalling;return new Proxy({},{get(b,D){if(typeof D=="string")return G?.properties?.has(D)?G.properties.get(D):oe(D)?function(M){return ae.listen(D,M)}:Z(D)?ae.listen(D):async function(...M){let V;G&&!(0,g.isUndefinedOrNull)(G.context)?V=[G.context,...M]:V=M;const ee=await ae.call(D,V);return W?ee:(0,I.revive)(ee)};throw new R.ErrorNoTelemetry(`Property not found: ${String(D)}`)}})}x.toService=q;function Z(ae){return ae[0]==="o"&&ae[1]==="n"&&y.isUpperAsciiLetter(ae.charCodeAt(2))}function oe(ae){return/^onDynamic/.test(ae)&&y.isUpperAsciiLetter(ae.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const j=x.toString();if(j!=="[object Object]")return j}return x}function Q(x){return Array.isArray(x)?x.map(H):H(x)}function B(x,j,q,Z,oe,ae,G){G=Q(G);const W=J[oe],b=W[Z%W.length];let D=[`%c[${x}]%c[${String(j).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${b}`];/\($/.test(ae)?(D=D.concat(G),D.push(")")):D.push(G),console.log.apply(console,D)}class Y{constructor(j,q){this._outgoingPrefix=j,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,q,Z,oe,ae){this._totalOutgoing+=j,B(this._outgoingPrefix,this._totalOutgoing,j,q,Z,oe,ae)}logIncoming(j,q,Z,oe,ae){this._totalIncoming+=j,B(this._incomingPrefix,this._totalIncoming,j,q,Z,oe,ae)}}e.IPCLogger=Y}),define(ce[65],le([0,1,14,3,2,43]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var _;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(_||(e.SocketDiagnosticsEventType=_={}));var R;(function(n){n.enableDiagnostics=!1,n.records=[];const i=new WeakMap;let r=0;function a(S,l){if(!i.has(S)){const C=String(++r);i.set(S,C)}return i.get(S)}function w(S,l,C,U){if(!n.enableDiagnostics)return;const N=a(S,l);if(U instanceof k.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const F=k.VSBuffer.alloc(U.byteLength);F.set(U),n.records.push({timestamp:Date.now(),id:N,label:l,type:C,buff:F})}else n.records.push({timestamp:Date.now(),id:N,label:l,type:C,data:U})}n.traceSocketEvent=w})(R||(e.SocketDiagnostics=R={}));var P;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P||(e.SocketCloseEventType=P={}));let m=null;function I(){return m||(m=k.VSBuffer.alloc(0)),m}class y{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,r){if(i===0)return I();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const l=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=i),l}if(this._chunks[0].byteLength>i){const l=this._chunks[0].slice(0,i);return r&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),l}const a=k.VSBuffer.alloc(i);let w=0,S=0;for(;i>0;){const l=this._chunks[S];if(l.byteLength>i){const C=l.slice(0,i);a.set(C,w),w+=i,r&&(this._chunks[S]=l.slice(i),this._totalLength-=i),i-=i}else a.set(l,w),w+=l.byteLength,r?(this._chunks.shift(),this._totalLength-=l.byteLength):S++,i-=l.byteLength}return a}}e.ChunkStream=y;var g;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(g||(g={}));function h(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class E{constructor(i,r,a,w){this.type=i,this.id=r,this.ack=a,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends T.Disposable{constructor(i){super(),this._onMessage=this._register(new O.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:h(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,w=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",r),this._onMessage.fire(new E(a,w,S,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(i){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=k.VSBuffer.alloc(13);r.writeUInt8(i.type,0),r.writeUInt32BE(i.id,1),r.writeUInt32BE(i.ack,5),r.writeUInt32BE(i.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:h(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",i.data),this._writeSoon(r,i.data)}_bufferAdd(i,r){const a=this._totalLength===0;return this._data.push(i,r),this._totalLength+=i.byteLength+r.byteLength,a}_bufferTake(){const i=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,r){this._bufferAdd(i,r)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const i=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this._socket.write(i)}}class d extends T.Disposable{constructor(i){super(),this._onMessage=new O.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new O.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new c(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new E(1,0,0,i))}}e.Protocol=d;class v extends A.IPCClient{static fromSocket(i,r){return new v(new d(i),r)}get onDidDispose(){return this.protocol.onDidDispose}constructor(i,r,a=null){super(i,r,a),this.protocol=i}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=v;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new O.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class L{constructor(i){this.data=i,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let i=0,r=this._first;for(;r;)r=r.next,i++;return i}peek(){return this._first?this._first.data:null}toArray(){const i=[];let r=0,a=this._first;for(;a;)i[r++]=a.data,a=a.next;return i}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const r=new L(i);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class o{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const i=Date.now();for(let r=0;r<o._HISTORY_LENGTH;r++)this.lastRuns[r]=i-1e3*r;setInterval(()=>{for(let r=o._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}load(){const i=Date.now(),r=(1+o._HISTORY_LENGTH)*1e3;let a=0;for(let w=0;w<o._HISTORY_LENGTH;w++)i-this.lastRuns[w]<=r&&a++;return 1-a/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(i){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=i.loadEstimator??o.getInstance(),this._shouldSendKeepAlive=i.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new T.DisposableStore,this._socket=i.socket,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new c(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.add(this._socket.onClose(r=>this._onSocketClose.fire(r))),i.initialChunk&&this._socketReader.acceptChunk(i.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new E(5,0,0,I());this._socketWriter.write(i),this._socketWriter.flush()}sendPause(){const i=new E(7,0,0,I());this._socketWriter.write(i)}sendResume(){const i=new E(8,0,0,I());this._socketWriter.write(i)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,r){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new T.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=i,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new c(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.add(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const i=new E(3,0,this._incomingAckId,I());this._socketWriter.write(i);const r=this._outgoingUnackMsg.toArray();for(let a=0,w=r.length;a<w;a++)this._socketWriter.write(r[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new E(6,0,0,I())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data);break}case 2:{this._onControlMessage.fire(i.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const r=this._outgoingUnackMsg.toArray();for(let a=0,w=r.length;a<w;a++)this._socketWriter.write(r[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new E(1,r,this._incomingAckId,i);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(i){const r=new E(2,0,0,i);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),r=Date.now()-i.writtenTime,a=Date.now()-this._socketReader.lastReadTime,w=Date.now()-this._lastSocketTimeoutTime;if(r>=2e4&&a>=2e4&&w>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const S=Math.max(2e4-r,2e4-a,2e4-w,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},S)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new E(3,0,this._incomingAckId,I());this._socketWriter.write(i)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const i=new E(9,0,this._incomingAckId,I());this._socketWriter.write(i)}}e.PersistentProtocol=s}),define(ce[93],le([0,1,64,5,14,25,140,8,3,2,30,143,90,43]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends h.ChannelServer{constructor(u){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",d=>T.VSBuffer.wrap(Buffer.from(d,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=f;class E{constructor(u,d){this.modulePath=u,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new O.Delayer(v),this.child=null,this._client=null}getChannel(u){const d=this;return{call(v,p,L){return d.requestPromise(u,v,p,L)},listen(v,p){return d.requestEvent(u,v,p)}}}requestPromise(u,d,v,p=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const L=this.getCachedChannel(u),t=(0,O.createCancelablePromise)(n=>L.call(d,v,n)),o=p.onCancellationRequested(()=>t.cancel()),s=(0,m.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{o.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(u,d,v){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let p;const L=new P.Emitter({onWillAddFirstListener:()=>{p=this.getCachedChannel(u).listen(d,v)(L.fire,L),this.activeRequests.add(p)},onDidRemoveLastListener:()=>{this.activeRequests.delete(p),p.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return L.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,g.removeDangerousEnvVariables)(d.env),this.child=(0,k.fork)(this.modulePath,u,d);const v=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,_.isRemoteConsoleLog)(i)){(0,_.log)(i,`IPC Library: ${this.options.serverName}`);return}v.fire(T.VSBuffer.wrap(Buffer.from(i,"base64")))});const L=this.options.useQueue?(0,y.createQueuedSender)(this.child):this.child,t=i=>this.child&&this.child.connected&&L.send(i.buffer.toString("base64")),o=v.event,s={send:t,onMessage:o};this._client=new h.ChannelClient(s);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,r)=>{process.removeListener("exit",n),this.activeRequests.forEach(a=>(0,m.dispose)(a)),this.activeRequests.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+r),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:r})})}return this._client}getCachedChannel(u){let d=this.channels.get(u);return d||(d=this.client.getChannel(u),this.channels.set(u,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(ce[145],le([0,1,133,14,43,3,11,20]),function(ie,e,k,O,T,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class P{constructor(g){this.port=g,this.onMessage=A.Event.fromNodeEventEmitter(this.port,"message",h=>O.VSBuffer.wrap(h.data)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}class m extends T.IPCServer{static getOnDidClientConnect(g){(0,_.assertType)((0,k.isUtilityProcess)(process),"Electron Utility Process");const h=new A.Emitter;return process.parentPort.on("message",f=>{if(g?.handledClientConnection(f))return;const E=(0,R.firstOrDefault)(f.ports);E&&h.fire(E)}),A.Event.map(h.event,f=>({protocol:new P(f),onDidClientDisconnect:A.Event.fromNodeEventEmitter(f,"close")}))}constructor(g){super(m.getOnDidClientConnect(g))}}e.Server=m;function I(y,g,h){const f=E=>{E.data===g&&(y.removeListener("message",f),h())};y.on("message",f)}e.once=I}),define(ce[66],le([0,1,5,3,2,63,11]),function(ie,e,k,O,T,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var R;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function P(g){const h=g;return h?.changed instanceof Map||h?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var m;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(m||(e.StorageState=m={}));class I extends T.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(h,f=Object.create(null)){super(),this.database=h,this.options=f,this._onDidChangeStorage=this._register(new O.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=m.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){this._onDidChangeStorage.pause();try{h.changed?.forEach((f,E)=>this.acceptExternal(E,f)),h.deleted?.forEach(f=>this.acceptExternal(f,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(h,f){if(this.state===m.Closed)return;let E=!1;(0,_.isUndefinedOrNull)(f)?E=this.cache.delete(h):this.cache.get(h)!==f&&(this.cache.set(h,f),E=!0),E&&this._onDidChangeStorage.fire({key:h,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===m.None&&(this.state=m.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,f){const E=this.cache.get(h);return(0,_.isUndefinedOrNull)(E)?f:E}getBoolean(h,f){const E=this.get(h);return(0,_.isUndefinedOrNull)(E)?f:E==="true"}getNumber(h,f){const E=this.get(h);return(0,_.isUndefinedOrNull)(E)?f:parseInt(E,10)}getObject(h,f){const E=this.get(h);return(0,_.isUndefinedOrNull)(E)?f:(0,A.parse)(E)}async set(h,f,E=!1){if(this.state===m.Closed)return;if((0,_.isUndefinedOrNull)(f))return this.delete(h,E);const c=(0,_.isObject)(f)||Array.isArray(f)?(0,A.stringify)(f):String(f);if(this.cache.get(h)!==c)return this.cache.set(h,c),this.pendingInserts.set(h,c),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire({key:h,external:E}),this.doFlush()}async delete(h,f=!1){if(!(this.state===m.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire({key:h,external:f}),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=m.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=I;class y{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((f,E)=>this.items.set(E,f)),h.delete?.forEach(f=>this.items.delete(f))}async close(){}}e.InMemoryStorageDatabase=y}),define(ce[146],le([12,9]),function(ie,e){return ie.create("vs/base/node/zip",e)}),define(ce[147],le([12,9]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ce[148],le([12,9]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(ce[149],le([12,9]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(ce[150],le([12,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ce[151],le([12,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ce[152],le([12,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ce[153],le([12,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ce[154],le([12,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ce[155],le([12,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ce[156],le([12,9]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(ce[157],le([12,9]),function(ie,e){return ie.create("vs/platform/files/common/fileService",e)}),define(ce[158],le([12,9]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(ce[159],le([12,9]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(ce[160],le([12,9]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ce[161],le([12,9]),function(ie,e){return ie.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ce[162],le([12,9]),function(ie,e){return ie.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ce[163],le([12,9]),function(ie,e){return ie.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ce[164],le([12,9]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(ce[165],le([12,9]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ce[166],le([12,9]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryService",e)}),define(ce[167],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ce[168],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ce[169],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ce[170],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ce[171],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ce[172],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ce[173],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ce[174],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ce[175],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ce[176],le([12,9]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(ce[177],le([0,1,8,149]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var T;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(T||(e.TokenType=T={}));function A(...m){switch(m.length){case 1:return(0,O.localize)(0,null,m[0]);case 2:return(0,O.localize)(1,null,m[0],m[1]);case 3:return(0,O.localize)(2,null,m[0],m[1],m[2]);default:return}}const _=(0,O.localize)(3,null),R=(0,O.localize)(4,null);class P{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(I){switch(I.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return I.isTripleEq?"===":"==";case 4:return I.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return I.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return I.lexeme;case 18:return I.lexeme;case 19:return I.lexeme;case 20:return"EOF";default:throw(0,k.illegalState)(`unhandled token type: ${JSON.stringify(I)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(I=>I.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(I){return this._input=I,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const y=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:y})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const y=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:y})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(I){return this._isAtEnd()||this._input.charCodeAt(this._current)!==I?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(I){this._tokens.push({type:I,offset:this._start})}_error(I){const y=this._start,g=this._input.substring(this._start,this._current),h={type:19,offset:this._start,lexeme:g};this._errors.push({offset:y,lexeme:g,additionalInfo:I}),this._tokens.push(h)}_string(){this.stringRe.lastIndex=this._start;const I=this.stringRe.exec(this._input);if(I){this._current=this._start+I[0].length;const y=this._input.substring(this._start,this._current),g=P._keywords.get(y);g?this._addToken(g):this._tokens.push({type:17,lexeme:y,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(_);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let I=this._current,y=!1,g=!1;for(;;){if(I>=this._input.length){this._current=I,this._error(R);return}const f=this._input.charCodeAt(I);if(y)y=!1;else if(f===47&&!g){I++;break}else f===91?g=!0:f===92?y=!0:f===93&&(g=!1);I++}for(;I<this._input.length&&P._regexFlags.has(this._input.charCodeAt(I));)I++;this._current=I;const h=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:h,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=P}),define(ce[178],le([0,1,62,83,26,16,37,22,10]),function(ie,e,k,O,T,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,A.dirname)(T.FileAccess.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:T.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",h)}return P.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(P.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=_.env.VSCODE_PORTABLE;return h?P.URI.file((0,A.join)(h,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,A.resolve)(h):(0,A.normalize)((0,A.join)(T.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?P.URI.file((0,A.resolve)(h)):P.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,A.resolve)(h);const f=_.env.VSCODE_EXTENSIONS;if(f)return f;const E=_.env.VSCODE_PORTABLE;return E?(0,A.join)(E,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(f=>/^[^:/?#]+?:\/\//.test(f)?P.URI.parse(f):P.URI.file((0,A.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?P.URI.parse(h):P.URI.file((0,A.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!_.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const f of this.args.log||[]){const E=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(f);E&&E[1]&&E[2]&&h.push([E[1],E[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get disableKeytar(){return!!this.args["disable-keytar"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=_.env.VSCODE_PORTABLE;return h?P.URI.file((0,A.join)(h,"policy.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this._args}constructor(h,f,E){this._args=h,this.paths=f,this.productService=E,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=m,ye([O.memoize],m.prototype,"appRoot",null),ye([O.memoize],m.prototype,"userHome",null),ye([O.memoize],m.prototype,"userDataPath",null),ye([O.memoize],m.prototype,"appSettingsHome",null),ye([O.memoize],m.prototype,"tmpDir",null),ye([O.memoize],m.prototype,"cacheHome",null),ye([O.memoize],m.prototype,"stateResource",null),ye([O.memoize],m.prototype,"userRoamingDataHome",null),ye([O.memoize],m.prototype,"userDataSyncHome",null),ye([O.memoize],m.prototype,"sync",null),ye([O.memoize],m.prototype,"machineSettingsResource",null),ye([O.memoize],m.prototype,"workspaceStorageHome",null),ye([O.memoize],m.prototype,"localHistoryHome",null),ye([O.memoize],m.prototype,"keyboardLayoutResource",null),ye([O.memoize],m.prototype,"argvResource",null),ye([O.memoize],m.prototype,"isExtensionDevelopment",null),ye([O.memoize],m.prototype,"untitledWorkspacesHome",null),ye([O.memoize],m.prototype,"builtinExtensionsPath",null),ye([O.memoize],m.prototype,"extensionsPath",null),ye([O.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ye([O.memoize],m.prototype,"extensionDevelopmentKind",null),ye([O.memoize],m.prototype,"extensionTestsLocationURI",null),ye([O.memoize],m.prototype,"debugExtensionHost",null),ye([O.memoize],m.prototype,"logLevel",null),ye([O.memoize],m.prototype,"extensionLogLevel",null),ye([O.memoize],m.prototype,"serviceMachineIdResource",null),ye([O.memoize],m.prototype,"disableTelemetry",null),ye([O.memoize],m.prototype,"disableWorkspaceTrust",null),ye([O.memoize],m.prototype,"disableKeytar",null),ye([O.memoize],m.prototype,"policyFile",null);function I(g,h){return y(g["inspect-extensions"],g["inspect-brk-extensions"],5870,h,g.debugId,g.extensionEnvironment)}e.parseExtensionHostDebugPort=I;function y(g,h,f,E,c,u){const v=Number(h||g)||(E?null:f),p=v?!!h:!1;let L;if(u)try{L=JSON.parse(u)}catch{}return{port:v,break:p,debugId:c,env:L}}e.parseDebugParams=y}),function(){"use strict";function ie(e,k,O){function T(_,R){const P=A(_,R),m=[P];return e.isAbsolute(P)||m.unshift(O),e.resolve(...m)}function A(_,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,R);const I=_["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(y,"AppData","Roaming")}break;case"darwin":m=e.join(k.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,R)}return{getUserDataPath:T}}if(typeof define=="function")define(ce[179],le([268,36,37]),function(e,k,O){return ie(e,k,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=ie(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[180],le([0,1,36,178,179]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends O.AbstractNativeEnvironmentService{constructor(m,I){super(m,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,T.getUserDataPath)(m,I.nameShort)},I)}}e.NativeEnvironmentService=A;function _(P,m){return(0,O.parseDebugParams)(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,m,P.extensionEnvironment)}e.parsePtyHostDebugPort=_;function R(P,m){return(0,O.parseDebugParams)(P["inspect-sharedprocess"],P["inspect-brk-sharedprocess"],5879,m,P.extensionEnvironment)}e.parseSharedProcessDebugPort=R}),define(ce[181],le([0,1,11,152]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function T(_,R,P){try{A(_,R,P)}catch(m){console.error(m?.message??m)}return _}e.localizeManifest=T;function A(_,R,P){const m=(I,y,g)=>{const h=I[y];if((0,k.isString)(h)){const f=h,E=f.length;if(E>1&&f[0]==="%"&&f[E-1]==="%"){const c=f.substr(1,E-2);let u=R[c];u===void 0&&P&&(u=P[c]);const d=typeof u=="string"?u:u?.message,v=P?.[c],p=typeof v=="string"?v:v?.message;if(!d){p||console.warn(`[${_.name}]: ${(0,O.localize)(0,null,c)}`);return}if(g&&(y==="title"||y==="category")&&p&&p!==d){const L={value:d,original:p};I[y]=L}else I[y]=d}}else if((0,k.isObject)(h))for(const f in h)h.hasOwnProperty(f)&&(f==="commands"?m(h,f,!0):m(h,f,g));else if(Array.isArray(h))for(let f=0;f<h.length;f++)m(h,f,g)};for(const I in _)_.hasOwnProperty(I)&&m(_,I)}}),define(ce[182],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.channel.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class O{constructor(A){this.service=A}listen(A,_){throw new Error(`Event not found: ${_}`)}call(A,_,R){switch(_){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${_}`)}}e.ExtensionRecommendationNotificationServiceChannel=O}),define(ce[67],le([0,1,22,89,156,53]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function P(u){return u=u.trim(),u==="*"||_.test(u)}e.isValidVersionStr=P;function m(u){if(!P(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=u.match(_);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=m;function I(u){if(!u)return null;const d=u.majorBase,v=u.majorMustEqual,p=u.minorBase;let L=u.minorMustEqual;const t=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(d===0||(L=!1),o=!1);let s=0;if(u.preRelease){const n=R.exec(u.preRelease);if(n){const[,i,r,a]=n;s=Date.UTC(Number(i),Number(r)-1,Number(a))}}return{majorBase:d,majorMustEqual:v,minorBase:p,minorMustEqual:L,patchBase:t,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:s}}e.normalizeVersion=I;function y(u,d,v){let p;typeof u=="string"?p=I(m(u)):p=u;let L;d instanceof Date?L=d.getTime():typeof d=="string"&&(L=new Date(d).getTime());let t;if(typeof v=="string"?t=I(m(v)):t=v,!p||!t)return!1;const o=p.majorBase,s=p.minorBase,n=p.patchBase;let i=t.majorBase,r=t.minorBase,a=t.patchBase;const w=t.notBefore;let S=t.majorMustEqual,l=t.minorMustEqual,C=t.patchMustEqual;return t.isMinimum?o>i?!0:o<i?!1:s>r?!0:s<r||L&&L<w?!1:n>=a:(o===1&&i===0&&(!S||!l||!C)&&(i=1,r=0,a=0,S=!0,l=!1,C=!1),o<i?!1:o>i?!S:s<r?!1:s>r?!l:n<a?!1:n>a?!C:!(L&&L<w))}e.isValidVersion=y;function g(u,d,v,p,L){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([O.default.Error,T.localize(0,null)]),t;if(typeof p.name!="string")return t.push([O.default.Error,T.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([O.default.Error,T.localize(2,null,"version")]),t;if(!p.engines)return t.push([O.default.Error,T.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([O.default.Error,T.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!c(p.extensionDependencies))return t.push([O.default.Error,T.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!c(p.activationEvents))return t.push([O.default.Error,T.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([O.default.Error,T.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([O.default.Warning,T.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([O.default.Error,T.localize(9,null,"main")]),t;{const n=(0,k.joinPath)(v,p.main);(0,k.isEqualOrParent)(n,v)||t.push([O.default.Warning,T.localize(10,null,n.path,v.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([O.default.Error,T.localize(11,null,"browser")]),t;{const n=(0,k.joinPath)(v,p.browser);(0,k.isEqualOrParent)(n,v)||t.push([O.default.Warning,T.localize(12,null,n.path,v.path)])}}if(!A.valid(p.version))return t.push([O.default.Error,T.localize(13,null)]),t;const o=[];if(!h(u,d,p,L,o))for(const n of o)t.push([O.default.Error,n]);return t}e.validateExtensionManifest=g;function h(u,d,v,p,L){return p||typeof v.main>"u"&&typeof v.browser>"u"?!0:E(u,d,v.engines.vscode,L)}e.isValidExtensionVersion=h;function f(u,d,v){return u==="*"||E(d,v,u)}e.isEngineValid=f;function E(u,d,v,p=[]){const L=I(m(v));if(!L)return p.push(T.localize(14,null,v)),!1;if(L.majorBase===0){if(!L.majorMustEqual||!L.minorMustEqual)return p.push(T.localize(15,null,v)),!1}else if(!L.majorMustEqual)return p.push(T.localize(16,null,v)),!1;return y(u,d,L)?!0:(p.push(T.localize(17,null,u,v)),!1)}function c(u){if(!Array.isArray(u))return!1;for(let d=0,v=u.length;d<v;d++)if(typeof u[d]!="string")return!1;return!0}}),define(ce[44],le([0,1,14,32]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function T(A,_,R){let P=R&&R.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const I=(await _.readFile(A.serviceMachineIdResource)).value.toString();P=(0,O.isUUID)(I)?I:null}catch{P=null}if(!P){P=(0,O.generateUuid)();try{await _.writeFile(A.serviceMachineIdResource,k.VSBuffer.fromString(P))}catch{}}return R?.store("storage.serviceMachineId",P,-1,1),P}e.getServiceMachineId=T}),define(ce[68],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(T,A=[],_=!1){this.ctor=T,this.staticArguments=A,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=k}),define(ce[183],le([0,1,68]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var T;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(T||(e.InstantiationType=T={}));function A(R,P,m){P instanceof k.SyncDescriptor||(P=new k.SyncDescriptor(P,[],!!m)),O.push([R,P])}e.registerSingleton=A;function _(){return O}e.getSingletonServiceDescriptors=_}),define(ce[184],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(A,_){this.key=A,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=k;class O{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const _ of this._nodes.values())_.outgoing.size===0&&A.push(_);return A}insertEdge(A,_){const R=this.lookupOrInsertNode(A),P=this.lookupOrInsertNode(_);R.outgoing.set(P.key,P),P.incoming.set(R.key,R)}removeNode(A){const _=this._hashFn(A);this._nodes.delete(_);for(const R of this._nodes.values())R.outgoing.delete(_),R.incoming.delete(_)}lookupOrInsertNode(A){const _=this._hashFn(A);let R=this._nodes.get(_);return R||(R=new k(_,A),this._nodes.set(_,R)),R}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[_,R]of this._nodes)A.push(`${_}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,_]of this._nodes){const R=new Set([A]),P=this._findCycle(_,R);if(P)return P}}_findCycle(A,_){for(const[R,P]of A.outgoing){if(_.has(R))return[..._,R].join(" -> ");_.add(R);const m=this._findCycle(P,_);if(m)return m;_.delete(R)}}}e.Graph=O}),define(ce[4],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function R(P){return P[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=R})(k||(e._util=k={})),e.IInstantiationService=T("instantiationService");function O(_,R,P){R[k.DI_TARGET]===R?R[k.DI_DEPENDENCIES].push({id:_,index:P}):(R[k.DI_DEPENDENCIES]=[{id:_,index:P}],R[k.DI_TARGET]=R)}function T(_){if(k.serviceIds.has(_))return k.serviceIds.get(_);const R=function(P,m,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(R,P,I)};return R.toString=()=>_,k.serviceIds.set(_,R),R}e.createDecorator=T;function A(_){return _}e.refineServiceDecorator=A}),define(ce[185],le([0,1,4]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(ce[18],le([0,1,11,10,4]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof O.URI)}e.isConfigurationOverrides=A;function _(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=_;var R;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function P(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=P;function m(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.isConfigured=m;function I(u,d){const v=Object.create(null);for(const p in u)y(v,p,u[p],d);return v}e.toValuesTree=I;function y(u,d,v,p){const L=d.split("."),t=L.pop();let o=u;for(let s=0;s<L.length;s++){const n=L[s];let i=o[n];switch(typeof i){case"undefined":i=o[n]=Object.create(null);break;case"object":break;default:p(`Ignoring ${d} as ${L.slice(0,s+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[t]=v}catch{p(`Ignoring ${d} as ${L.join(".")} is ${JSON.stringify(o)}`)}else p(`Ignoring ${d} as ${L.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=y;function g(u,d){const v=d.split(".");h(u,v)}e.removeFromValueTree=g;function h(u,d){const v=d.shift();if(d.length===0){delete u[v];return}if(Object.keys(u).indexOf(v)!==-1){const p=u[v];typeof p=="object"&&!Array.isArray(p)&&(h(p,d),Object.keys(p).length===0&&delete u[v])}}function f(u,d,v){function p(o,s){let n=o;for(const i of s){if(typeof n!="object"||n===null)return;n=n[i]}return n}const L=d.split("."),t=p(u,L);return typeof t>"u"?v:t}e.getConfigurationValue=f;function E(u,d,v){Object.keys(d).forEach(p=>{p!=="__proto__"&&(p in u?k.isObject(u[p])&&k.isObject(d[p])?E(u[p],d[p],v):v&&(u[p]=d[p]):u[p]=d[p])})}e.merge=E;function c(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=c}),define(ce[94],le([0,1,6,28,177,4,148,8]),function(ie,e,k,O,T,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",k.isMacintosh),P.set("isLinux",k.isLinux),P.set("isWindows",k.isWindows),P.set("isWeb",k.isWeb),P.set("isMacNative",k.isMacintosh&&!k.isWeb),P.set("isEdge",k.isEdge),P.set("isFirefox",k.isFirefox),P.set("isChrome",k.isChrome),P.set("isSafari",k.isSafari);function m(W,b){if(P.get(W)!==void 0)throw(0,R.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");P.set(W,b)}e.setConstant=m;const I=Object.prototype.hasOwnProperty;var y;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const g={regexParsingWithErrorRecovery:!0},h=(0,_.localize)(0,null),f=(0,_.localize)(1,null),E=(0,_.localize)(2,null),c=(0,_.localize)(3,null),u=(0,_.localize)(4,null),d=(0,_.localize)(5,null),v=(0,_.localize)(6,null),p=(0,_.localize)(7,null);class L{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(b=g){this._config=b,this._scanner=new T.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(b){if(b===""){this._parsingErrors.push({message:h,offset:0,lexeme:"",additionalInfo:f});return}this._tokens=this._scanner.reset(b).scan(),this._current=0,this._parsingErrors=[];try{const D=this._expr();if(!this._isAtEnd()){const M=this._peek(),V=M.type===17?d:void 0;throw this._parsingErrors.push({message:u,offset:M.offset,lexeme:T.Scanner.getLexeme(M),additionalInfo:V}),L._parseError}return D}catch(D){if(D!==L._parseError)throw D;return}}_expr(){return this._or()}_or(){const b=[this._and()];for(;this._matchOne(16);){const D=this._and();b.push(D)}return b.length===1?b[0]:t.or(...b)}_and(){const b=[this._term()];for(;this._matchOne(15);){const D=this._term();b.push(D)}return b.length===1?b[0]:t.and(...b)}_term(){if(this._matchOne(2)){const b=this._peek();switch(b.type){case 11:return this._advance(),i.INSTANCE;case 12:return this._advance(),r.INSTANCE;case 0:{this._advance();const D=this._expr();return this._consume(1,c),D?.negate()}case 17:return this._advance(),U.create(b.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",b)}}return this._primary()}_primary(){const b=this._peek();switch(b.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const D=this._expr();return this._consume(1,c),D}case 17:{const D=b.lexeme;if(this._advance(),this._matchOne(9)){const V=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),V.type!==10)throw this._errExpectedButGot("REGEX",V);const ee=V.lexeme,ne=ee.lastIndexOf("/"),de=ne===ee.length-1?void 0:this._removeFlagsGY(ee.substring(ne+1));let X;try{X=new RegExp(ee.substring(1,ne),de)}catch{throw this._errExpectedButGot("REGEX",V)}return H.create(D,X)}switch(V.type){case 10:case 19:{const ee=[V.lexeme];this._advance();let ne=this._peek(),de=0;for(let fe=0;fe<V.lexeme.length;fe++)V.lexeme.charCodeAt(fe)===40?de++:V.lexeme.charCodeAt(fe)===41&&de--;for(;!this._isAtEnd()&&ne.type!==15&&ne.type!==16;){switch(ne.type){case 0:de++;break;case 1:de--;break;case 10:case 18:for(let fe=0;fe<ne.lexeme.length;fe++)ne.lexeme.charCodeAt(fe)===40?de++:V.lexeme.charCodeAt(fe)===41&&de--}if(de<0)break;ee.push(T.Scanner.getLexeme(ne)),this._advance(),ne=this._peek()}const X=ee.join(""),se=X.lastIndexOf("/"),te=se===X.length-1?void 0:this._removeFlagsGY(X.substring(se+1));let he;try{he=new RegExp(X.substring(1,se),te)}catch{throw this._errExpectedButGot("REGEX",V)}return t.regex(D,he)}case 18:{const ee=V.lexeme;this._advance();let ne=null;if(!(0,O.isFalsyOrWhitespace)(ee)){const de=ee.indexOf("/"),X=ee.lastIndexOf("/");if(de!==X&&de>=0){const se=ee.slice(de+1,X),te=ee[X+1]==="i"?"i":"";try{ne=new RegExp(se,te)}catch{throw this._errExpectedButGot("REGEX",V)}}}if(ne===null)throw this._errExpectedButGot("REGEX",V);return H.create(D,ne)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,E);const V=this._value();return t.notIn(D,V)}switch(this._peek().type){case 3:{this._advance();const V=this._value();if(this._previous().type===18)return t.equals(D,V);switch(V){case"true":return t.has(D);case"false":return t.not(D);default:return t.equals(D,V)}}case 4:{this._advance();const V=this._value();if(this._previous().type===18)return t.notEquals(D,V);switch(V){case"true":return t.not(D);case"false":return t.has(D);default:return t.notEquals(D,V)}}case 5:return this._advance(),z.create(D,this._value());case 6:return this._advance(),J.create(D,this._value());case 7:return this._advance(),F.create(D,this._value());case 8:return this._advance(),$.create(D,this._value());case 13:return this._advance(),t.in(D,this._value());default:return t.has(D)}}case 20:throw this._parsingErrors.push({message:v,offset:b.offset,lexeme:"",additionalInfo:p}),L._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const b=this._peek();switch(b.type){case 17:case 18:return this._advance(),b.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(b){return b.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(b){return this._check(b)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(b,D){if(this._check(b))return this._advance();throw this._errExpectedButGot(D,this._peek())}_errExpectedButGot(b,D,M){const V=(0,_.localize)(8,null,b,T.Scanner.getLexeme(D)),ee=D.offset,ne=T.Scanner.getLexeme(D);return this._parsingErrors.push({message:V,offset:ee,lexeme:ne,additionalInfo:M}),L._parseError}_check(b){return this._peek().type===b}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=L;class t{static false(){return i.INSTANCE}static true(){return r.INSTANCE}static has(b){return a.create(b)}static equals(b,D){return w.create(b,D)}static notEquals(b,D){return C.create(b,D)}static regex(b,D){return H.create(b,D)}static in(b,D){return S.create(b,D)}static notIn(b,D){return l.create(b,D)}static not(b){return U.create(b)}static and(...b){return Y.create(b,null,!0)}static or(...b){return x.create(b,null,!0)}static greater(b,D){return F.create(b,D)}static greaterEquals(b,D){return $.create(b,D)}static smaller(b,D){return z.create(b,D)}static smallerEquals(b,D){return J.create(b,D)}static{this._parser=new L({regexParsingWithErrorRecovery:!1})}static deserialize(b){return b==null?void 0:this._parser.parse(b)}}e.ContextKeyExpr=t;function o(W){const b=new L({regexParsingWithErrorRecovery:!1});return W.map(D=>(b.parse(D),b.lexingErrors.length>0?b.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,_.localize)(9,null,M.additionalInfo):(0,_.localize)(10,null),offset:M.offset,length:M.lexeme.length})):b.parsingErrors.length>0?b.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}e.validateWhenClauses=o;function s(W,b){const D=W?W.substituteConstants():void 0,M=b?b.substituteConstants():void 0;return!D&&!M?!0:!D||!M?!1:D.equals(M)}e.expressionsAreEqualWithConstantSubstitution=s;function n(W,b){return W.cmp(b)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return r.INSTANCE}}e.ContextKeyFalseExpr=i;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return i.INSTANCE}}e.ContextKeyTrueExpr=r;class a{static create(b,D=null){const M=P.get(b);return typeof M=="boolean"?M?r.INSTANCE:i.INSTANCE:new a(b,D)}constructor(b,D){this.key=b,this.negated=D,this.type=2}cmp(b){return b.type!==this.type?this.type-b.type:q(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}substituteConstants(){const b=P.get(this.key);return typeof b=="boolean"?b?r.INSTANCE:i.INSTANCE:this}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return this.negated||(this.negated=U.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=a;class w{static create(b,D,M=null){if(typeof D=="boolean")return D?a.create(b,M):U.create(b,M);const V=P.get(b);return typeof V=="boolean"?D===(V?"true":"false")?r.INSTANCE:i.INSTANCE:new w(b,D,M)}constructor(b,D,M){this.key=b,this.value=D,this.negated=M,this.type=4}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){const b=P.get(this.key);if(typeof b=="boolean"){const D=b?"true":"false";return this.value===D?r.INSTANCE:i.INSTANCE}return this}evaluate(b){return b.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(b){return b.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class S{static create(b,D){return new S(b,D)}constructor(b,D){this.key=b,this.valueKey=D,this.type=10,this.negated=null}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.key,this.valueKey,b.key,b.valueKey)}equals(b){return b.type===this.type?this.key===b.key&&this.valueKey===b.valueKey:!1}substituteConstants(){return this}evaluate(b){const D=b.getValue(this.valueKey),M=b.getValue(this.key);return Array.isArray(D)?D.includes(M):typeof M=="string"&&typeof D=="object"&&D!==null?I.call(D,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(b){return b.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=l.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=S;class l{static create(b,D){return new l(b,D)}constructor(b,D){this.key=b,this.valueKey=D,this.type=11,this._negated=S.create(b,D)}cmp(b){return b.type!==this.type?this.type-b.type:this._negated.cmp(b._negated)}equals(b){return b.type===this.type?this._negated.equals(b._negated):!1}substituteConstants(){return this}evaluate(b){return!this._negated.evaluate(b)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(b){return b.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=l;class C{static create(b,D,M=null){if(typeof D=="boolean")return D?U.create(b,M):a.create(b,M);const V=P.get(b);return typeof V=="boolean"?D===(V?"true":"false")?i.INSTANCE:r.INSTANCE:new C(b,D,M)}constructor(b,D,M){this.key=b,this.value=D,this.negated=M,this.type=5}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){const b=P.get(this.key);if(typeof b=="boolean"){const D=b?"true":"false";return this.value===D?i.INSTANCE:r.INSTANCE}return this}evaluate(b){return b.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(b){return b.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=C;class U{static create(b,D=null){const M=P.get(b);return typeof M=="boolean"?M?i.INSTANCE:r.INSTANCE:new U(b,D)}constructor(b,D){this.key=b,this.negated=D,this.type=3}cmp(b){return b.type!==this.type?this.type-b.type:q(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}substituteConstants(){const b=P.get(this.key);return typeof b=="boolean"?b?i.INSTANCE:r.INSTANCE:this}evaluate(b){return!b.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(b){return b.mapNot(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=U;function N(W,b){if(typeof W=="string"){const D=parseFloat(W);isNaN(D)||(W=D)}return typeof W=="string"||typeof W=="number"?b(W):i.INSTANCE}class F{static create(b,D,M=null){return N(D,V=>new F(b,V,M))}constructor(b,D,M){this.key=b,this.value=D,this.negated=M,this.type=12}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){return this}evaluate(b){return typeof this.value=="string"?!1:parseFloat(b.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=J.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=F;class ${static create(b,D,M=null){return N(D,V=>new $(b,V,M))}constructor(b,D,M){this.key=b,this.value=D,this.negated=M,this.type=13}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){return this}evaluate(b){return typeof this.value=="string"?!1:parseFloat(b.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=$;class z{static create(b,D,M=null){return N(D,V=>new z(b,V,M))}constructor(b,D,M){this.key=b,this.value=D,this.negated=M,this.type=14}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){return this}evaluate(b){return typeof this.value=="string"?!1:parseFloat(b.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=z;class J{static create(b,D,M=null){return N(D,V=>new J(b,V,M))}constructor(b,D,M){this.key=b,this.value=D,this.negated=M,this.type=15}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){return this}evaluate(b){return typeof this.value=="string"?!1:parseFloat(b.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=J;class H{static create(b,D){return new H(b,D)}constructor(b,D){this.key=b,this.regexp=D,this.type=7,this.negated=null}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.key<b.key)return-1;if(this.key>b.key)return 1;const D=this.regexp?this.regexp.source:"",M=b.regexp?b.regexp.source:"";return D<M?-1:D>M?1:0}equals(b){if(b.type===this.type){const D=this.regexp?this.regexp.source:"",M=b.regexp?b.regexp.source:"";return this.key===b.key&&D===M}return!1}substituteConstants(){return this}evaluate(b){const D=b.getValue(this.key);return this.regexp?this.regexp.test(D):!1}serialize(){const b=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${b}`}keys(){return[this.key]}map(b){return b.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=Q.create(this)),this.negated}}e.ContextKeyRegexExpr=H;class Q{static create(b){return new Q(b)}constructor(b){this._actual=b,this.type=8}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}substituteConstants(){return this}evaluate(b){return!this._actual.evaluate(b)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(b){return new Q(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=Q;function B(W){let b=null;for(let D=0,M=W.length;D<M;D++){const V=W[D].substituteConstants();if(W[D]!==V&&b===null){b=[];for(let ee=0;ee<D;ee++)b[ee]=W[ee]}b!==null&&(b[D]=V)}return b===null?W:b}class Y{static create(b,D,M){return Y._normalizeArr(b,D,M)}constructor(b,D){this.expr=b,this.negated=D,this.type=6}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let D=0,M=this.expr.length;D<M;D++){const V=n(this.expr[D],b.expr[D]);if(V!==0)return V}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let D=0,M=this.expr.length;D<M;D++)if(!this.expr[D].equals(b.expr[D]))return!1;return!0}return!1}substituteConstants(){const b=B(this.expr);return b===this.expr?this:Y.create(b,this.negated,!1)}evaluate(b){for(let D=0,M=this.expr.length;D<M;D++)if(!this.expr[D].evaluate(b))return!1;return!0}static _normalizeArr(b,D,M){const V=[];let ee=!1;for(const ne of b)if(ne){if(ne.type===1){ee=!0;continue}if(ne.type===0)return i.INSTANCE;if(ne.type===6){V.push(...ne.expr);continue}V.push(ne)}if(V.length===0&&ee)return r.INSTANCE;if(V.length!==0){if(V.length===1)return V[0];V.sort(n);for(let ne=1;ne<V.length;ne++)V[ne-1].equals(V[ne])&&(V.splice(ne,1),ne--);if(V.length===1)return V[0];for(;V.length>1;){const ne=V[V.length-1];if(ne.type!==9)break;V.pop();const de=V.pop(),X=V.length===0,se=x.create(ne.expr.map(te=>Y.create([te,de],null,M)),null,X);se&&(V.push(se),V.sort(n))}if(V.length===1)return V[0];if(M){for(let ne=0;ne<V.length;ne++)for(let de=ne+1;de<V.length;de++)if(V[ne].negate().equals(V[de]))return i.INSTANCE;if(V.length===1)return V[0]}return new Y(V,D)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(const D of this.expr)b.push(...D.keys());return b}map(b){return new Y(this.expr.map(D=>D.map(b)),null)}negate(){if(!this.negated){const b=[];for(const D of this.expr)b.push(D.negate());this.negated=x.create(b,this,!0)}return this.negated}}e.ContextKeyAndExpr=Y;class x{static create(b,D,M){return x._normalizeArr(b,D,M)}constructor(b,D){this.expr=b,this.negated=D,this.type=9}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let D=0,M=this.expr.length;D<M;D++){const V=n(this.expr[D],b.expr[D]);if(V!==0)return V}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let D=0,M=this.expr.length;D<M;D++)if(!this.expr[D].equals(b.expr[D]))return!1;return!0}return!1}substituteConstants(){const b=B(this.expr);return b===this.expr?this:x.create(b,this.negated,!1)}evaluate(b){for(let D=0,M=this.expr.length;D<M;D++)if(this.expr[D].evaluate(b))return!0;return!1}static _normalizeArr(b,D,M){let V=[],ee=!1;if(b){for(let ne=0,de=b.length;ne<de;ne++){const X=b[ne];if(X){if(X.type===0){ee=!0;continue}if(X.type===1)return r.INSTANCE;if(X.type===9){V=V.concat(X.expr);continue}V.push(X)}}if(V.length===0&&ee)return i.INSTANCE;V.sort(n)}if(V.length!==0){if(V.length===1)return V[0];for(let ne=1;ne<V.length;ne++)V[ne-1].equals(V[ne])&&(V.splice(ne,1),ne--);if(V.length===1)return V[0];if(M){for(let ne=0;ne<V.length;ne++)for(let de=ne+1;de<V.length;de++)if(V[ne].negate().equals(V[de]))return r.INSTANCE;if(V.length===1)return V[0]}return new x(V,D)}}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(const D of this.expr)b.push(...D.keys());return b}map(b){return new x(this.expr.map(D=>D.map(b)),null)}negate(){if(!this.negated){const b=[];for(const D of this.expr)b.push(D.negate());for(;b.length>1;){const D=b.shift(),M=b.shift(),V=[];for(const ee of G(D))for(const ne of G(M))V.push(Y.create([ee,ne],null,!1));b.unshift(x.create(V,null,!1))}this.negated=x.create(b,this,!0)}return this.negated}}e.ContextKeyOrExpr=x;class j extends a{static{this._info=[]}static all(){return j._info.values()}constructor(b,D,M){super(b,null),this._defaultValue=D,typeof M=="object"?j._info.push({...M,key:b}):M!==!0&&j._info.push({key:b,description:M,type:D!=null?typeof D:void 0})}bindTo(b){return b.createKey(this.key,this._defaultValue)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(b){return w.create(this.key,b)}notEqualsTo(b){return C.create(this.key,b)}}e.RawContextKey=j,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function q(W,b){return W<b?-1:W>b?1:0}function Z(W,b,D,M){return W<D?-1:W>D?1:b<M?-1:b>M?1:0}function oe(W,b){if(W.type===0||b.type===1)return!0;if(W.type===9)return b.type===9?ae(W.expr,b.expr):!1;if(b.type===9){for(const D of b.expr)if(oe(W,D))return!0;return!1}if(W.type===6){if(b.type===6)return ae(b.expr,W.expr);for(const D of W.expr)if(oe(D,b))return!0;return!1}return W.equals(b)}e.implies=oe;function ae(W,b){let D=0,M=0;for(;D<W.length&&M<b.length;){const V=W[D].cmp(b[M]);if(V<0)return!1;V===0&&D++,M++}return D===W.length}function G(W){return W.type===9?W.expr:[W]}}),define(ce[95],le([0,1,4]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function O(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=O;class T{async getPerformanceInfo(_,R){return{}}async getSystemInfo(_,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(_,R){return""}async getWorkspaceFileExtensions(_){return{extensions:[]}}async reportWorkspaceStats(_){}}e.NullDiagnosticsService=T}),define(ce[96],le([0,1,4]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(ce[15],le([0,1,4]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(ce[29],le([0,1,151,4]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function T(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function A(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function _(d,v){switch(d){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":v==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function R(d,v){return v==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function P(d,v,p){return R(v,p)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===p?!0:m(p).includes(d)}e.isTargetPlatformCompatible=P;function m(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function I(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=I;var y;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var g;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var h;(function(d){d.Install="install",d.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var f;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var E;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var c;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class u extends Error{constructor(v,p){super(v),this.code=p,this.name=p}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,k.localize)(1,null),original:"Preferences"}}),define(ce[186],le([0,1,3,2,30,10,92,29]),function(ie,e,k,O,T,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(c,u){return c?A.URI.revive(u?u.transformIncoming(c):c):void 0}function m(c,u){return u?u.transformOutgoingURI(c):c}function I(c,u){u=u||_.DefaultURITransformer;const d=c.manifest;return{...(0,_.transformAndReviveIncomingURIs)({...c,manifest:void 0},u),manifest:d}}function y(c,u){return c?.profileLocation?(0,_.transformAndReviveIncomingURIs)(c,u??_.DefaultURITransformer):c}function g(c,u){return u?(0,T.cloneAndChange)(c,d=>d instanceof A.URI?u.transformOutgoingURI(d):void 0):c}class h{constructor(u,d){this.service=u,this.getUriTransformer=d,this.onInstallExtension=k.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=k.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,d){const v=this.getUriTransformer(u);switch(d){case"onInstallExtension":return k.Event.map(this.onInstallExtension,p=>({...p,profileLocation:p.profileLocation?m(p.profileLocation,v):p.profileLocation}));case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,p=>p.map(L=>({...L,local:L.local?g(L.local,v):L.local,profileLocation:L.profileLocation?m(L.profileLocation,v):L.profileLocation})));case"onUninstallExtension":return k.Event.map(this.onUninstallExtension,p=>({...p,profileLocation:p.profileLocation?m(p.profileLocation,v):p.profileLocation}));case"onDidUninstallExtension":return k.Event.map(this.onDidUninstallExtension,p=>({...p,profileLocation:p.profileLocation?m(p.profileLocation,v):p.profileLocation}));case"onDidUpdateExtensionMetadata":return k.Event.map(this.onDidUpdateExtensionMetadata,p=>g(p,v))}throw new Error("Invalid listen")}async call(u,d,v){const p=this.getUriTransformer(u);switch(d){case"zip":{const L=I(v[0],p),t=await this.service.zip(L);return m(t,p)}case"unzip":return this.service.unzip(P(v[0],p));case"install":return this.service.install(P(v[0],p),y(v[1],p));case"installFromLocation":return this.service.installFromLocation(P(v[0],p),P(v[1],p));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(v[0],P(v[1],p),P(v[2],p));case"getManifest":return this.service.getManifest(P(v[0],p));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(v[0]);case"installFromGallery":return this.service.installFromGallery(v[0],y(v[1],p));case"installGalleryExtensions":{const L=v[0];return this.service.installGalleryExtensions(L.map(({extension:t,options:o})=>({extension:t,options:y(o,p)??{}})))}case"uninstall":return this.service.uninstall(I(v[0],p),y(v[1],p));case"reinstallFromGallery":return this.service.reinstallFromGallery(I(v[0],p));case"getInstalled":return(await this.service.getInstalled(v[0],P(v[1],p))).map(t=>g(t,p));case"toggleAppliationScope":{const L=await this.service.toggleAppliationScope(I(v[0],p),P(v[1],p));return g(L,p)}case"copyExtensions":return this.service.copyExtensions(P(v[0],p),P(v[1],p));case"updateMetadata":{const L=await this.service.updateMetadata(I(v[0],p),v[1],P(v[2],p));return g(L,p)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(v[0],v[1],v[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=h;class f extends O.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(u){super(),this.channel=u,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._onDidUpdateExtensionMetadata=this._register(new k.Emitter),this._register(this.channel.listen("onInstallExtension")(d=>this.fireEvent(this._onInstallExtension,{...d,source:this.isUriComponents(d.source)?A.URI.revive(d.source):d.source,profileLocation:A.URI.revive(d.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(d=>this.fireEvent(this._onDidInstallExtensions,d.map(v=>({...v,local:v.local?I(v.local,null):v.local,source:this.isUriComponents(v.source)?A.URI.revive(v.source):v.source,profileLocation:A.URI.revive(v.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(d=>this.fireEvent(this._onUninstallExtension,{...d,profileLocation:A.URI.revive(d.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(d=>this.fireEvent(this._onDidUninstallExtension,{...d,profileLocation:A.URI.revive(d.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(d=>this._onDidUpdateExtensionMetadata.fire(I(d,null))))}fireEvent(u,d){u.fire(d)}isUriComponents(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(u){const d=await this.getTargetPlatform();return u.allTargetPlatforms.some(v=>(0,R.isTargetPlatformCompatible)(v,u.allTargetPlatforms,d))}zip(u){return Promise.resolve(this.channel.call("zip",[u]).then(d=>A.URI.revive(d)))}unzip(u){return Promise.resolve(this.channel.call("unzip",[u]))}install(u,d){return Promise.resolve(this.channel.call("install",[u,d])).then(v=>I(v,null))}installFromLocation(u,d){return Promise.resolve(this.channel.call("installFromLocation",[u,d])).then(v=>I(v,null))}async installExtensionsFromProfile(u,d,v){return(await this.channel.call("installExtensionsFromProfile",[u,d,v])).map(L=>I(L,null))}getManifest(u){return Promise.resolve(this.channel.call("getManifest",[u]))}installFromGallery(u,d){return Promise.resolve(this.channel.call("installFromGallery",[u,d])).then(v=>I(v,null))}async installGalleryExtensions(u){return(await this.channel.call("installGalleryExtensions",[u])).map(v=>({...v,local:v.local?I(v.local,null):v.local,source:this.isUriComponents(v.source)?A.URI.revive(v.source):v.source,profileLocation:A.URI.revive(v.profileLocation)}))}uninstall(u,d){return Promise.resolve(this.channel.call("uninstall",[u,d]))}reinstallFromGallery(u){return Promise.resolve(this.channel.call("reinstallFromGallery",[u])).then(d=>I(d,null))}getInstalled(u=null,d){return Promise.resolve(this.channel.call("getInstalled",[u,d])).then(v=>v.map(p=>I(p,null)))}updateMetadata(u,d,v){return Promise.resolve(this.channel.call("updateMetadata",[u,d,v])).then(p=>I(p,null))}toggleAppliationScope(u,d){return this.channel.call("toggleAppliationScope",[u,d]).then(v=>I(v,null))}copyExtensions(u,d){return this.channel.call("copyExtensions",[u,d])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(u,d,v){const p=await this.channel.call("download",[u,d,v]);return A.URI.revive(p)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class E{constructor(u){this.service=u}listen(u,d){throw new Error("Invalid listen")}call(u,d,v){switch(d){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(v[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=E}),define(ce[97],le([0,1,4]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,k.createDecorator)("IExtensionSignatureVerificationService");class O{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((A,_)=>ie(["node-vsce-sign"],async R=>A(R),_))),this.moduleLoadingPromise}async verify(A,_,R){let P;try{P=await this.vsceSign()}catch{return!1}return P.verify(A,_,R)}}e.ExtensionSignatureVerificationService=O}),define(ce[98],le([0,1,4]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var O;(function(_){_[_.FILE=1]="FILE",_[_.WORKSPACE=2]="WORKSPACE",_[_.EXE=3]="EXE"})(O||(e.RecommendationSource=O={}));function T(_){switch(_){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=T;var A;(function(_){_.Ignored="ignored",_.Cancelled="cancelled",_.TooMany="toomany",_.IncompatibleWindow="incompatibleWindow",_.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(ce[13],le([0,1,47,16,28,11,10,158,4,6,26]),function(ie,e,k,O,T,A,_,R,P,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function y(q){return q.create===!0}e.isFileOpenForWriteOptions=y;var g;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var h;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var f;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function E(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=E;function c(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=c;function u(q){return!!(q.capabilities&131072)}e.hasFileCloneCapability=u;function d(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function v(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=v;function p(q){return E(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;function L(q){return E(q)?!!(q.capabilities&32768):!1}e.hasFileAtomicWriteCapability=L;function t(q){return!!(q.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;function o(q){return!!(q.capabilities&2048)}e.hasReadonlyCapability=o;var s;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class n extends Error{static create(Z,oe){const ae=new n(Z.toString(),oe);return a(ae,oe),ae}constructor(Z,oe){super(Z),this.code=oe}}e.FileSystemProviderError=n;function i(q,Z){return n.create(q,Z)}e.createFileSystemProviderError=i;function r(q){return q||i((0,R.localize)(0,null),s.Unknown)}e.ensureFileSystemProviderError=r;function a(q,Z){return q.name=Z?`${Z} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=a;function w(q){if(!q)return s.Unknown;if(q instanceof n)return q.code;const Z=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!Z)return s.Unknown;switch(Z[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.toFileSystemProviderErrorCode=w;function S(q){if(q instanceof $)return q.fileOperationResult;switch(w(q)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=S;var l;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(l||(e.FileOperation=l={}));class C{constructor(Z,oe,ae){this.resource=Z,this.operation=oe,this.target=ae}isOperation(Z){return this.operation===Z}}e.FileOperationEvent=C;var U;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class N{constructor(Z,oe){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ae=new Map;for(const G of Z){const W=ae.get(G.type);switch(W?W.push([G.resource,G]):ae.set(G.type,[[G.resource,G]]),G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}}for(const[G,W]of ae)switch(G){case 1:this.added=k.TernarySearchTree.forUris(()=>oe),this.added.fill(W);break;case 0:this.updated=k.TernarySearchTree.forUris(()=>oe),this.updated.fill(W);break;case 2:this.deleted=k.TernarySearchTree.forUris(()=>oe),this.deleted.fill(W);break}}contains(Z,...oe){return this.doContains(Z,{includeChildren:!1},...oe)}affects(Z,...oe){return this.doContains(Z,{includeChildren:!0},...oe)}doContains(Z,oe,...ae){if(!Z)return!1;const G=ae.length>0;return!!((!G||ae.includes(1))&&(this.added?.get(Z)||oe.includeChildren&&this.added?.findSuperstr(Z))||(!G||ae.includes(0))&&(this.updated?.get(Z)||oe.includeChildren&&this.updated?.findSuperstr(Z))||(!G||ae.includes(2))&&(this.deleted?.findSubstr(Z)||oe.includeChildren&&this.deleted?.findSuperstr(Z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=N;function F(q,Z,oe){return!q||!Z||q===Z||Z.length>q.length?!1:(Z.charAt(Z.length-1)!==O.sep&&(Z+=O.sep),oe?(0,T.startsWithIgnoreCase)(q,Z):q.indexOf(Z)===0)}e.isParent=F;class $ extends Error{constructor(Z,oe,ae){super(Z),this.fileOperationResult=oe,this.options=ae}}e.FileOperationError=$;class z extends ${constructor(Z,oe,ae,G){super(Z,oe,G),this.fileOperationResult=oe,this.size=ae}}e.TooLargeFileOperationError=z;class J extends ${constructor(Z,oe,ae){super(Z,2,ae),this.stat=oe}}e.NotModifiedSinceFileOperationError=J;var H;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(H||(e.FileOperationResult=H={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Q;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.ETAG_DISABLED="";function B(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=B;async function Y(q,Z){if(!Z.hasProvider(_.URI.from({scheme:q.scheme})))return new Promise(oe=>{const ae=Z.onDidChangeFileSystemProviderRegistrations(G=>{G.scheme===q.scheme&&G.added&&(ae.dispose(),oe())})})}e.whenProviderRegistered=Y;class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(Z){return(0,A.isNumber)(Z)||(Z=0),Z<x.KB?(0,R.localize)(1,null,Z.toFixed(0)):Z<x.MB?(0,R.localize)(2,null,(Z/x.KB).toFixed(2)):Z<x.GB?(0,R.localize)(3,null,(Z/x.MB).toFixed(2)):Z<x.TB?(0,R.localize)(4,null,(Z/x.GB).toFixed(2)):(0,R.localize)(5,null,(Z/x.TB).toFixed(2))}}e.ByteSize=x;function j(q){const Z=typeof q=="string"||q?.scheme===I.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===I.Schemas.file?1024*x.MB:Z?10*x.MB:m.isWeb?50*x.MB:1024*x.MB}e.getLargeFileConfirmationLimit=j});var K=this&&this.__param||function(ie,e){return function(k,O){e(k,O,ie)}};define(ce[187],le([0,1,69,42,13]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(R){this.fileService=R}async checksum(R){const P=(await this.fileService.readFileStream(R)).value;return new Promise((m,I)=>{const y=(0,k.createHash)("md5");(0,O.listenStream)(P,{onData:g=>y.update(g.buffer),onError:g=>I(g),onEnd:()=>m(y.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=A,e.ChecksumService=A=ye([K(0,T.IFileService)],A)}),define(ce[188],le([0,1,14,38,8,3,2,42,10,32,13]),function(ie,e,k,O,T,A,_,R,P,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends _.Disposable{constructor(h,f){super(),this.channel=h,this.extraCapabilities=f,this.onDidChangeCapabilities=A.Event.None,this._onDidChange=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,m.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(h){return this.channel.call("stat",[h])}readdir(h){return this.channel.call("readdir",[h])}async readFile(h,f){const{buffer:E}=await this.channel.call("readFile",[h,f]);return E}readFileStream(h,f,E){const c=(0,R.newWriteableStream)(d=>k.VSBuffer.concat(d.map(v=>k.VSBuffer.wrap(v))).buffer),u=this.channel.listen("readFileStream",[h,f])(d=>{if(d instanceof k.VSBuffer)c.write(d.buffer);else{if(d==="end")c.end();else{let v;if(d instanceof Error)v=d;else{const p=d;v=(0,I.createFileSystemProviderError)(p.message??(0,O.toErrorMessage)(p),p.code??I.FileSystemProviderErrorCode.Unknown)}c.error(v),c.end()}u.dispose()}});return E.onCancellationRequested(()=>{c.error((0,T.canceled)()),c.end(),u.dispose()}),c}writeFile(h,f,E){return this.channel.call("writeFile",[h,k.VSBuffer.wrap(f),E])}open(h,f){return this.channel.call("open",[h,f])}close(h){return this.channel.call("close",[h])}async read(h,f,E,c,u){const[d,v]=await this.channel.call("read",[h,f,u]);return E.set(d.buffer.slice(0,v),c),v}write(h,f,E,c,u){return this.channel.call("write",[h,f,k.VSBuffer.wrap(E),c,u])}mkdir(h){return this.channel.call("mkdir",[h])}delete(h,f){return this.channel.call("delete",[h,f])}rename(h,f,E){return this.channel.call("rename",[h,f,E])}copy(h,f,E){return this.channel.call("copy",[h,f,E])}cloneFile(h,f){return this.channel.call("cloneFile",[h,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(h=>{if(Array.isArray(h)){const f=h;this._onDidChange.fire(f.map(E=>({resource:P.URI.revive(E.resource),type:E.type})))}else{const f=h;this._onDidWatchError.fire(f)}}))}watch(h,f){const E=(0,m.generateUuid)();return this.channel.call("watch",[this.sessionId,E,h,f]),(0,_.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,E]))}}e.DiskFileSystemProviderClient=y}),define(ce[99],le([0,1,14,8,159,13]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function _(I,y,g,h,f,E){let c;try{await R(I,y,g,h,f,E)}catch(u){c=u}finally{c&&f.errorTransformer&&(c=f.errorTransformer(c)),typeof c<"u"&&g.error(c),g.end()}}e.readFileIntoStream=_;async function R(I,y,g,h,f,E){P(E);const c=await I.open(y,{create:!1});try{P(E);let u=0,d=0,v=f&&typeof f.length=="number"?f.length:void 0,p=k.VSBuffer.alloc(Math.min(f.bufferSize,typeof v=="number"?v:f.bufferSize)),L=f&&typeof f.position=="number"?f.position:0,t=0;do d=await I.read(c,L,p.buffer,t,p.byteLength-t),L+=d,t+=d,u+=d,typeof v=="number"&&(v-=d),t===p.byteLength&&(await g.write(h(p)),p=k.VSBuffer.alloc(Math.min(f.bufferSize,typeof v=="number"?v:f.bufferSize)),t=0);while(d>0&&(typeof v!="number"||v>0)&&P(E)&&m(u,f));if(t>0){let o=t;typeof v=="number"&&(o=Math.min(t,v)),g.write(h(p.slice(0,o)))}}catch(u){throw(0,A.ensureFileSystemProviderError)(u)}finally{await I.close(c)}}function P(I){if(I.isCancellationRequested)throw(0,O.canceled)();return!0}function m(I,y){if(typeof y?.limits?.size=="number"&&I>y.limits.size)throw(0,A.createFileSystemProviderError)((0,T.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[54],le([0,1,91,2,16,6,10,13]),function(ie,e,k,O,T,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(u){return u.recursive===!0}e.isRecursiveWatchRequest=P;class m extends O.Disposable{static{this.MAX_RESTARTS=5}constructor(d,v,p,L){super(),this.onFileChanges=d,this.onLogMessage=v,this.verboseLogging=p,this.options=L,this.watcherDisposables=this._register(new O.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new O.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(v=>this.onFileChanges(v))),d.add(this.watcher.onDidLogMessage(v=>this.onLogMessage(v))),d.add(this.watcher.onDidError(v=>this.onError(v)))}onError(d){this.options.restartOnError?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}trace(d){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m;class I extends m{constructor(d,v,p){super(d,v,p,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class y extends m{constructor(d,v,p){super(d,v,p,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function g(u){return u.map(d=>({type:d.type,resource:_.URI.file(d.path)}))}e.toFileChanges=g;function h(u){const d=new c;for(const v of u)d.processEvent(v);return d.coalesce()}e.coalesceEvents=h;function f(u,d){return typeof d=="string"&&!d.startsWith(k.GLOBSTAR)&&!(0,T.isAbsolute)(d)?{base:u,pattern:d}:d}e.normalizeWatcherPattern=f;function E(u,d){const v=[];for(const p of d)v.push((0,k.parse)(f(u,p)));return v}e.parseWatcherPatterns=E;class c{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return A.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const v=this.mapPathToChange.get(this.toKey(d));let p=!1;if(v){const L=v.type,t=d.type;v.path!==d.path&&(d.type===2||d.type===1)?p=!0:L===1&&t===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(v)):L===2&&t===1?v.type=0:L===1&&t===0||(v.type=t)}else p=!0;p&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],v=[];return Array.from(this.coalesced).filter(p=>p.type!==2?(d.push(p),!1):!0).sort((p,L)=>p.path.length-L.path.length).filter(p=>v.some(L=>(0,R.isParent)(p.path,L,!A.isLinux))?!1:(v.push(p.path),!0)).concat(d)}}}),define(ce[189],le([0,1,52,5,25,48,2,88,16,6,142,31,54]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends _.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(c,u,d,v){super(),this.request=c,this.onDidFilesChange=u,this.onLogMessage=d,this.verboseLogging=v,this.throttledFileChangesEmitter=this._register(new O.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},p=>this.onDidFilesChange(p))),this.fileChangesAggregator=this._register(new O.RunOnceWorker(p=>this.handleFileChanges(p),h.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,g.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,g.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new T.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const c=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const u=await y.Promises.stat(c);this._register(await this.doWatch(c,u.isDirectory()))}catch(c){c.code!=="ENOENT"?this.error(c):this.trace(c)}}async normalizePath(c){let u=c.path;try{u=await y.Promises.realpath(c.path),c.path===u&&(u=await(0,I.realcase)(c.path)??c.path),c.path!==u&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${u})`)}catch{}return u}async doWatch(c,u){if(m.isMacintosh&&(0,A.isEqualOrParent)(c,"/Volumes/",!0))return this.error(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),_.Disposable.None;const d=new T.CancellationTokenSource(this.cts.token),v=new _.DisposableStore;try{const p=(0,P.basename)(c),L=(0,k.watch)(c);v.add((0,_.toDisposable)(()=>{L.removeAllListeners(),L.close()})),this.trace(`Started watching: '${c}'`);const t=new Set;if(u)try{for(const s of await y.Promises.readdir(c))t.add(s)}catch(s){this.error(s)}const o=new Map;v.add((0,_.toDisposable)(()=>{for(const[,s]of o)s.dispose();o.clear()})),L.on("error",(s,n)=>{this.error(`Failed to watch ${c} for changes using fs.watch() (${s}, ${n})`),this.dispose()}),L.on("change",(s,n)=>{if(d.token.isCancellationRequested)return;this.trace(`[raw] ["${s}"] ${n}`);let i="";if(n&&(i=n.toString(),m.isMacintosh&&(i=(0,R.normalizeNFC)(i))),!(!i||s!=="change"&&s!=="rename"))if(u)if(s==="rename"){o.get(i)?.dispose();const r=setTimeout(async()=>{if(o.delete(i),i===p&&!await y.Promises.exists(c)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,P.join)(c,i));if(d.token.isCancellationRequested)return;let w;a?t.has(i)?w=0:(w=1,t.add(i)):(t.delete(i),w=2),this.onFileChange({path:(0,P.join)(this.request.path,i),type:w})},h.FILE_DELETE_HANDLER_DELAY);o.set(i,(0,_.toDisposable)(()=>clearTimeout(r)))}else{let r;t.has(i)?r=0:(r=1,t.add(i)),this.onFileChange({path:(0,P.join)(this.request.path,i),type:r})}else if(s==="rename"||i!==p){const r=setTimeout(async()=>{const a=await y.Promises.exists(c);d.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),v.add(await this.doWatch(c,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},h.FILE_DELETE_HANDLER_DELAY);v.clear(),v.add((0,_.toDisposable)(()=>clearTimeout(r)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(p){await y.Promises.exists(c)&&!d.token.isCancellationRequested&&this.error(`Failed to watch ${c} for changes using fs.watch() (${p.toString()})`)}return(0,_.toDisposable)(()=>{d.dispose(!0),v.dispose()})}onFileChange(c,u=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!u&&this.excludes.some(d=>d(c.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${c.path}`):!u&&this.includes&&this.includes.length>0&&!this.includes.some(d=>d(c.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${c.path}`):this.fileChangesAggregator.work(c))}handleFileChanges(c){const u=(0,g.coalesceEvents)(c);if(u.length>0){if(this.verboseLogging)for(const v of u)this.trace(`>> normalized ${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`);this.throttledFileChangesEmitter.work(u)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(c){if(m.isLinux)return y.Promises.exists(c);try{const u=(0,P.basename)(c);return(await y.Promises.readdir((0,P.dirname)(c))).some(v=>v===u)}catch(u){return this.trace(u),!1}}setVerboseLogging(c){this.verboseLogging=c}error(c){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}warn(c){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}trace(c){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=h;async function f(E,c,u,d,v=512){const p=await y.Promises.open(E,"r"),L=Buffer.allocUnsafe(v),t=new T.CancellationTokenSource(d);let o,s=!1;const n={path:E,excludes:[],recursive:!1},i=new h(n,r=>{(async()=>{for(const{type:a}of r)if(a===0){if(s)return;s=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:w}=await y.Promises.read(p,L,0,v,null);if(!w||t.token.isCancellationRequested)break;c(L.slice(0,w))}}catch(w){o=new Error(w),t.dispose(!0)}finally{s=!1}}})()});return await i.ready,u(),new Promise((r,a)=>{t.token.onCancellationRequested(async()=>{i.dispose();try{await y.Promises.close(p)}catch(w){o=new Error(w)}o?a(o):r()})})}e.watchFileContents=f}),define(ce[190],le([0,1,3,91,2,6,189]),function(ie,e,k,O,T,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends T.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new k.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=k.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const I=this.normalizeRequests(m),y=I.filter(h=>{const f=this.watchers.get(h.path);return f?!(0,O.patternsEquals)(f.request.excludes,h.excludes)||!(0,O.patternsEquals)(f.request.includes,h.includes):!0}),g=Array.from(this.watchers.values()).filter(({request:h})=>!I.find(f=>f.path===h.path&&(0,O.patternsEquals)(f.excludes,h.excludes)&&(0,O.patternsEquals)(f.includes,h.includes))).map(({request:h})=>h.path);y.length&&this.trace(`Request to start watching: ${y.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),g.length&&this.trace(`Request to stop watching: ${g.join(",")}`);for(const h of g)this.stopWatching(h);for(const h of y)this.startWatching(h)}startWatching(m){const I=new _.NodeJSFileWatcherLibrary(m,g=>this._onDidChangeFile.fire(g),g=>this._onDidLogMessage.fire(g),this.verboseLogging),y={request:m,instance:I};this.watchers.set(m.path,y)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const I=this.watchers.get(m);I&&(this.watchers.delete(m),I.instance.dispose())}normalizeRequests(m){const I=new Map;for(const y of m){const g=A.isLinux?y.path:y.path.toLowerCase();I.set(g,y)}return Array.from(I.values())}async setVerboseLogging(m){this.verboseLogging=m;for(const[,I]of this.watchers)I.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,I){return I?`[File Watcher (node.js)] ${m} (path: ${I.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=R}),define(ce[191],le([0,1,54,190]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class T extends k.AbstractNonRecursiveWatcherClient{constructor(_,R,P){super(_,R,P),this.init()}createWatcher(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=T}),define(ce[192],le([0,1,26,43,93,54]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class _ extends A.AbstractUniversalWatcherClient{constructor(P,m,I){super(P,m,I),this.init()}createWatcher(P){const m=P.add(new T.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(m.onDidProcessExit(({code:I,signal:y})=>this.onError(`terminated by itself with code ${I}, signal: ${y}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=_}),define(ce[70],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...T){this._entries=new Map;for(const[A,_]of T)this.set(A,_)}set(T,A){const _=this._entries.get(T);return this._entries.set(T,A),_}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=k}),define(ce[193],le([0,1,5,8,2,68,184,4,70,87]),function(ie,e,k,O,T,A,_,R,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class y extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class g{constructor(c=new P.ServiceCollection,u=!1,d,v=I){this._services=c,this._strict=u,this._parent=d,this._enableTracing=v,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=v?d?._globalGraph??new _.Graph(p=>p):void 0}createChild(c){return new g(c,this._strict,this,this._enableTracing)}invokeFunction(c,...u){const d=f.traceInvocation(this._enableTracing,c);let v=!1;try{return c({get:L=>{if(v)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(L,d);if(!t)throw new Error(`[invokeFunction] unknown service '${L}'`);return t}},...u)}finally{v=!0,d.stop()}}createInstance(c,...u){let d,v;return c instanceof A.SyncDescriptor?(d=f.traceCreation(this._enableTracing,c.ctor),v=this._createInstance(c.ctor,c.staticArguments.concat(u),d)):(d=f.traceCreation(this._enableTracing,c),v=this._createInstance(c,u,d)),d.stop(),v}_createInstance(c,u=[],d){const v=R._util.getServiceDependencies(c).sort((t,o)=>t.index-o.index),p=[];for(const t of v){const o=this._getOrCreateServiceInstance(t.id,d);o||this._throwIfStrict(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(o)}const L=v.length>0?v[0].index:u.length;if(u.length!==L){console.trace(`[createInstance] First service dependency of ${c.name} at position ${L+1} conflicts with ${u.length} static arguments`);const t=L-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,L)}return Reflect.construct(c,u.concat(p))}_setServiceInstance(c,u){if(this._services.get(c)instanceof A.SyncDescriptor)this._services.set(c,u);else if(this._parent)this._parent._setServiceInstance(c,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){const u=this._services.get(c);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):u}_getOrCreateServiceInstance(c,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(c));const d=this._getServiceInstanceOrDescriptor(c);return d instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,d,u.branch(c,!0)):(u.branch(c,!1),d)}_safeCreateAndCacheServiceInstance(c,u,d){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,u,d)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,u,d){const v=new _.Graph(t=>t.id.toString());let p=0;const L=[{id:c,desc:u,_trace:d}];for(;L.length;){const t=L.pop();if(v.lookupOrInsertNode(t),p++>1e3)throw new y(v);for(const o of R._util.getServiceDependencies(t.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(o.id);if(s||this._throwIfStrict(`[createInstance] ${c} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),s instanceof A.SyncDescriptor){const n={id:o.id,desc:s,_trace:t._trace.branch(o.id,!0)};v.insertEdge(t,n),L.push(n)}}}for(;;){const t=v.roots();if(t.length===0){if(!v.isEmpty())throw new y(v);break}for(const{data:o}of t){if(this._getServiceInstanceOrDescriptor(o.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,n)}v.removeNode(o)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,u,d=[],v,p){if(this._services.get(c)instanceof A.SyncDescriptor)return this._createServiceInstance(c,u,d,v,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,u,d,v,p);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(c,u,d=[],v,p){if(v){const L=new g(void 0,this._strict,this,this._enableTracing);L._globalGraphImplicitDependency=String(c);const t=new Map,o=new k.IdleValue(()=>{const s=L._createInstance(u,d,p);for(const[n,i]of t){const r=s[n];if(typeof r=="function")for(const a of i)r.apply(s,a)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,n){if(!o.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=t.get(n);return a||(a=new m.LinkedList,t.set(n,a)),(S,l,C)=>{const U=a.push([S,l,C]);return(0,T.toDisposable)(U)}}if(n in s)return s[n];const i=o.value;let r=i[n];return typeof r!="function"||(r=r.bind(i),s[n]=r),r},set(s,n,i){return o.value[n]=i,!0},getPrototypeOf(s){return u.prototype}})}else return this._createInstance(u,d,p)}_throwIfStrict(c,u){if(u&&console.warn(c),this._strict)throw new Error(c)}}e.InstantiationService=g;var h;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(h||(h={}));class f{static{this.all=new Set}static{this._None=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,u){return c?new f(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f._None}static traceCreation(c,u){return c?new f(1,u.name):f._None}static{this._totals=0}constructor(c,u){this.type=c,this.name=u,this._start=Date.now(),this._dep=[]}branch(c,u){const d=new f(3,c.toString());return this._dep.push([c,u,d]),d}stop(){const c=Date.now()-this._start;f._totals+=c;let u=!1;function d(p,L){const t=[],o=new Array(p+1).join("	");for(const[s,n,i]of L._dep)if(n&&i){u=!0,t.push(`${o}CREATES -> ${s}`);const r=d(p+1,i);r&&t.push(r)}else t.push(`${o}uses -> ${s}`);return t.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(c>2||u)&&f.all.add(v.join(`
`))}}e.Trace=f}),define(ce[71],le([0,1,4]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,k.createDecorator)("mainProcessService");class O{constructor(A,_){this.server=A,this.router=_}getChannel(A){return this.server.getChannel(A,this.router)}registerChannel(A,_){this.server.registerChannel(A,_)}}e.MainProcessService=O}),define(ce[72],le([0,1,25,2,6,161,29,4]),function(ie,e,k,O,T,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function P(I){return I.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=P,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let m=class extends O.Disposable{constructor(y){super(),this.extensionGalleryService=y}async getAvailableLanguages(){const y=new k.CancellationTokenSource;setTimeout(()=>y.cancel(),1e3);let g;try{g=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const f=g.firstPage.filter(E=>E.properties.localizedLanguages?.length&&E.tags.some(c=>c.startsWith("lp-"))).map(E=>{const c=E.properties.localizedLanguages?.[0],u=P(E);return{...this.createQuickPickItem(u,c,E),extensionId:E.identifier.id,galleryExtension:E}});return f.push(this.createQuickPickItem("en","English")),f}createQuickPickItem(y,g,h){const f=g??y;let E;if(f!==y&&(E=`(${y})`),y.toLowerCase()===T.language.toLowerCase()&&(E??="",E+=(0,A.localize)(0,null)),h?.installCount){E??="";const c=h.installCount;let u;c>1e6?u=`${Math.floor(c/1e5)/10}M`:c>1e3?u=`${Math.floor(c/1e3)}K`:u=String(c),E+=` $(cloud-download) ${u}`}return{id:y,label:f,description:E}}};e.LanguagePackBaseService=m,e.LanguagePackBaseService=m=ye([K(0,_.IExtensionGalleryService)],m)}),define(ce[194],le([0,1,2,72]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let T=class extends k.Disposable{constructor(_){super(),this.localizationsService=_,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=T,e.LocalizationsUpdater=T=ye([K(0,O.ILanguagePackService)],T)}),define(ce[7],le([0,1,38,3,51,2,35,6,22,11,10,94,4]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function h(){return new Date().toISOString()}function f(S){return(0,m.isNumber)(S)}e.isLogLevel=f;var E;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(E||(e.LogLevel=E={})),e.DEFAULT_LOG_LEVEL=E.Info;function c(S,l,C){switch(l){case E.Trace:S.trace(C);break;case E.Debug:S.debug(C);break;case E.Info:S.info(C);break;case E.Warning:S.warn(C);break;case E.Error:S.error(C);break;case E.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=c;function u(S,l=!1){let C="";for(let U=0;U<S.length;U++){let N=S[U];if(N instanceof Error&&(N=(0,k.toErrorMessage)(N,l)),typeof N=="object")try{N=JSON.stringify(N)}catch{}C+=(U>0?" ":"")+N}return C}class d extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(l){this.level!==l&&(this.level=l,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(l){return this.level!==E.Off&&this.level<=l}}e.AbstractLogger=d;class v extends d{constructor(l){super(),this.logAlways=l}checkLogLevel(l){return this.logAlways||super.checkLogLevel(l)}trace(l,...C){this.checkLogLevel(E.Trace)&&this.log(E.Trace,u([l,...C],!0))}debug(l,...C){this.checkLogLevel(E.Debug)&&this.log(E.Debug,u([l,...C]))}info(l,...C){this.checkLogLevel(E.Info)&&this.log(E.Info,u([l,...C]))}warn(l,...C){this.checkLogLevel(E.Warning)&&this.log(E.Warning,u([l,...C]))}error(l,...C){if(this.checkLogLevel(E.Error))if(l instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=l.stack,this.log(E.Error,u(U))}else this.log(E.Error,u([l,...C]))}flush(){}}e.AbstractMessageLogger=v;class p extends d{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.useColors=!R.isWindows}trace(l,...C){this.checkLogLevel(E.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,l,...C):console.log(`[main ${h()}]`,l,...C))}debug(l,...C){this.checkLogLevel(E.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,l,...C):console.log(`[main ${h()}]`,l,...C))}info(l,...C){this.checkLogLevel(E.Info)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,l,...C):console.log(`[main ${h()}]`,l,...C))}warn(l,...C){this.checkLogLevel(E.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,l,...C):console.warn(`[main ${h()}]`,l,...C))}error(l,...C){this.checkLogLevel(E.Error)&&(this.useColors?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,l,...C):console.error(`[main ${h()}]`,l,...C))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class L extends d{constructor(l=e.DEFAULT_LOG_LEVEL,C=!0){super(),this.useColors=C,this.setLevel(l)}trace(l,...C){this.checkLogLevel(E.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",l,...C):console.log(l,...C))}debug(l,...C){this.checkLogLevel(E.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",l,...C):console.log(l,...C))}info(l,...C){this.checkLogLevel(E.Info)&&(this.useColors?console.log("%c INFO","color: #33f",l,...C):console.log(l,...C))}warn(l,...C){this.checkLogLevel(E.Warning)&&(this.useColors?console.log("%c WARN","color: #993",l,...C):console.log(l,...C))}error(l,...C){this.checkLogLevel(E.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",l,...C):console.error(l,...C))}dispose(){}flush(){}}e.ConsoleLogger=L;class t extends d{constructor(l,C=e.DEFAULT_LOG_LEVEL){super(),this.adapter=l,this.setLevel(C)}trace(l,...C){this.checkLogLevel(E.Trace)&&this.adapter.log(E.Trace,[this.extractMessage(l),...C])}debug(l,...C){this.checkLogLevel(E.Debug)&&this.adapter.log(E.Debug,[this.extractMessage(l),...C])}info(l,...C){this.checkLogLevel(E.Info)&&this.adapter.log(E.Info,[this.extractMessage(l),...C])}warn(l,...C){this.checkLogLevel(E.Warning)&&this.adapter.log(E.Warning,[this.extractMessage(l),...C])}error(l,...C){this.checkLogLevel(E.Error)&&this.adapter.log(E.Error,[this.extractMessage(l),...C])}extractMessage(l){return typeof l=="string"?l:(0,k.toErrorMessage)(l,this.checkLogLevel(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class o extends d{constructor(l){super(),this.loggers=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const C of this.loggers)C.setLevel(l);super.setLevel(l)}trace(l,...C){for(const U of this.loggers)U.trace(l,...C)}debug(l,...C){for(const U of this.loggers)U.debug(l,...C)}info(l,...C){for(const U of this.loggers)U.info(l,...C)}warn(l,...C){for(const U of this.loggers)U.warn(l,...C)}error(l,...C){for(const U of this.loggers)U.error(l,...C)}flush(){for(const l of this.loggers)l.flush()}dispose(){for(const l of this.loggers)l.dispose()}}e.MultiplexLogger=o;class s extends A.Disposable{constructor(l,C,U){if(super(),this.logLevel=l,this.logsHome=C,this._loggers=new _.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,U)for(const N of U)this._loggers.set(N.resource,{logger:void 0,info:N})}getLoggerEntry(l){return(0,m.isString)(l)?[...this._loggers.values()].find(C=>C.info.id===l):this._loggers.get(l)}getLogger(l){return this.getLoggerEntry(l)?.logger}createLogger(l,C){const U=this.toResource(l),N=(0,m.isString)(l)?l:C?.id??(0,T.hash)(U.toString()).toString(16);let F=this._loggers.get(U)?.logger;const $=C?.logLevel==="always"?E.Trace:C?.logLevel;F||(F=this.doCreateLogger(U,$??this.getLogLevel(U)??this.logLevel,{...C,id:N}));const z={logger:F,info:{resource:U,id:N,logLevel:$,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(z.info),this._loggers.set(U,z),F}toResource(l){return(0,m.isString)(l)?(0,P.joinPath)(this.logsHome,`${l}.log`):l}setLogLevel(l,C){if(I.URI.isUri(l)){const U=l,N=C,F=this._loggers.get(U);F&&N!==F.info.logLevel&&(F.info.logLevel=N===this.logLevel?void 0:N,F.logger?.setLevel(N),this._loggers.set(F.info.resource,F),this._onDidChangeLogLevel.fire([U,N]))}else{this.logLevel=l;for(const[U,N]of this._loggers.entries())this._loggers.get(U)?.info.logLevel===void 0&&N.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(l,C){const U=this.getLoggerEntry(l);U&&C!==!U.info.hidden&&(U.info.hidden=!C,this._loggers.set(U.info.resource,U),this._onDidChangeVisibility.fire([U.info.resource,C]))}getLogLevel(l){let C;return l&&(C=this._loggers.get(l)?.info.logLevel),C??this.logLevel}registerLogger(l){const C=this._loggers.get(l.resource);C?C.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this._loggers.set(l.resource,{info:l,logger:void 0}),this._onDidChangeLoggers.fire({added:[l],removed:[]}))}deregisterLogger(l){const C=this._loggers.get(l);C&&(C.logger&&C.logger.dispose(),this._loggers.delete(l),this._onDidChangeLoggers.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const l of this._loggers.values())yield l.info}getRegisteredLogger(l){return this._loggers.get(l)?.info}dispose(){this._loggers.forEach(l=>l.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class n{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(l){}getLevel(){return E.Info}trace(l,...C){}debug(l,...C){}info(l,...C){}warn(l,...C){}error(l,...C){}critical(l,...C){}dispose(){}flush(){}}e.NullLogger=n;class i extends n{}e.NullLogService=i;function r(S){if(S.verbose)return E.Trace;if(typeof S.logLevel=="string"){const l=w(S.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function a(S){switch(S){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=a;function w(S){switch(S){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=w,e.CONTEXT_LOG_LEVEL=new y.RawContextKey("logLevel",a(E.Info))}),define(ce[195],le([0,1,5,8,2,22,31,15,7]),function(ie,e,k,O,T,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let m=class extends T.Disposable{constructor(y,g){super(),this.environmentService=y,this.logService=g,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const y=(0,A.basename)(this.environmentService.logsHome),g=(0,A.dirname)(this.environmentService.logsHome),E=(await _.Promises.readdir(g.fsPath)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==y),c=E.slice(0,Math.max(0,E.length-9));c.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${c.join(", ")}'`),await Promise.all(c.map(u=>_.Promises.rm((0,A.joinPath)(g,u).fsPath))))}catch(y){(0,O.onUnexpectedError)(y)}}};e.LogsDataCleaner=m,e.LogsDataCleaner=m=ye([K(0,R.IEnvironmentService),K(1,P.ILogService)],m)}),define(ce[196],le([0,1,20,5,8,3,2,16,54,7]),function(ie,e,k,O,T,A,_,R,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends _.Disposable{constructor(g,h){super(),this.logService=g,this.options=h,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(g,h){return h.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(g,h):this.watchNonRecursive(g,h)}watchUniversal(g,h){const f={path:this.toFilePath(g),excludes:h.excludes,includes:h.includes,recursive:h.recursive},E=(0,k.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,_.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(g=>(0,T.onUnexpectedError)(g))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(h=>this._onDidChangeFile.fire((0,P.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const g=this.options?.watcher?.recursive?.usePolling;if(g===!0)for(const h of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const h of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(h)&&g.includes(h.path)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(g,h){const f={path:this.toFilePath(g),excludes:h.excludes,includes:h.includes,recursive:!1},E=(0,k.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,_.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(g=>(0,T.onUnexpectedError)(g))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(g=>this._onDidChangeFile.fire((0,P.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,R.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(ce[197],le([0,1,20,5,14,25,3,51,59,2,47,26,100,22,42,157,13,99,7,8]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=class extends m.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new _.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new _.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new _.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new _.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new _.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(t,o){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${t}`);const s=new m.DisposableStore;return this.provider.set(t,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:o}),s.add(o.onDidChangeFile(n=>this._onDidFilesChange.fire(new c.FileChangesEvent(n,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&s.add(o.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),s.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:t}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:o}),this.provider.delete(t),(0,m.dispose)(s)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(s){o.push(s)}}),!this.provider.has(t)&&await O.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,o){const s=this.provider.get(t.scheme);return!!(s&&s.capabilities&o)}listCapabilities(){return P.Iterable.map(this.provider,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async withProvider(t){if(!(0,h.isAbsolutePath)(t))throw new c.FileOperationError((0,E.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const o=this.provider.get(t.scheme);if(!o){const s=new v.ErrorNoTelemetry;throw s.message=(0,E.localize)(1,null,t.toString()),s}return o}async withReadProvider(t){const o=await this.withProvider(t);if((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasReadWriteCapability)(o)||(0,c.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const o=await this.withProvider(t);if((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.doResolveFile(t,o)}catch(s){throw(0,c.toFileSystemProviderErrorCode)(s)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,E.localize)(2,null,this.resourceForError(t)),1):(0,c.ensureFileSystemProviderError)(s)}}async doResolveFile(t,o){const s=await this.withProvider(t),n=this.isPathCaseSensitive(s),i=o?.resolveTo,r=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,w=await s.stat(t);let S;return this.toFileStat(s,t,w,void 0,!!a,(l,C)=>(S||(S=I.TernarySearchTree.forUris(()=>!n),S.set(t,!0),i&&S.fill(!0,i)),S.get(l.resource)||S.findSuperstr(l.resource.with({query:null,fragment:null}))?!0:l.isDirectory&&r?C===1:!1))}async toFileStat(t,o,s,n,i,r){const{providerExtUri:a}=this.getExtUri(t),w={resource:o,name:a.basename(o),isFile:(s.type&c.FileType.File)!==0,isDirectory:(s.type&c.FileType.Directory)!==0,isSymbolicLink:(s.type&c.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&c.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((s.permissions??0)&c.FilePermission.Locked),etag:(0,c.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(w.isDirectory&&r(w,n)){try{const S=await t.readdir(o),l=await O.Promises.settled(S.map(async([C,U])=>{try{const N=a.joinPath(o,C),F=i?await t.stat(N):{type:U};return await this.toFileStat(t,N,F,S.length,i,r)}catch(N){return this.logService.trace(N),null}}));w.children=(0,k.coalesce)(l)}catch(S){this.logService.trace(S),w.children=[]}return w}return w}async resolveAll(t){return O.Promises.settled(t.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.withProvider(t),s=await o.stat(t);return this.toFileStat(o,t,s,void 0,!0,()=>!1)}async exists(t){const o=await this.withProvider(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.doValidateCreateFile(t,o)}catch(s){return s}return!0}async doValidateCreateFile(t,o){if(!o?.overwrite&&await this.exists(t))throw new c.FileOperationError((0,E.localize)(3,null,this.resourceForError(t)),3,o)}async createFile(t,o=T.VSBuffer.fromString(""),s){await this.doValidateCreateFile(t,s);const n=await this.writeFile(t,o);return this._onDidRunOperation.fire(new c.FileOperationEvent(t,0,n)),n}async writeFile(t,o,s){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:i}=this.getExtUri(n);try{await this.validateWriteFile(n,t,s)||await this.mkdirp(n,i.dirname(t));let a;if((0,c.hasReadWriteCapability)(n)&&!(o instanceof T.VSBuffer))if((0,f.isReadableStream)(o)){const w=await(0,f.peekStream)(o,3);w.ended?a=T.VSBuffer.concat(w.buffer):a=w}else a=(0,f.peekReadable)(o,w=>T.VSBuffer.concat(w),3);else a=o;if(!(0,c.hasOpenReadWriteCloseCapability)(n)||(0,c.hasReadWriteCapability)(n)&&a instanceof T.VSBuffer)await this.doWriteUnbuffered(n,t,s,a);else{const w=a instanceof T.VSBuffer?(0,T.bufferToReadable)(a):a;s?.atomic!==!1&&s?.atomic?.postfix?await this.doWriteBufferedAtomic(n,t,(0,h.joinPath)((0,h.dirname)(t),`${(0,h.basename)(t)}${s.atomic.postfix}`),s,w):await this.doWriteBuffered(n,t,s,w)}this._onDidRunOperation.fire(new c.FileOperationEvent(t,4))}catch(r){throw new c.FileOperationError((0,E.localize)(4,null,this.resourceForError(t),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),s)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,o,s){const n=!!s?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(o)));if(!!s?.atomic){if(!(t.capabilities&32768))throw new Error((0,E.localize)(6,null,this.resourceForError(o)));if(n)throw new Error((0,E.localize)(7,null,this.resourceForError(o)))}let r;try{r=await t.stat(o)}catch{return}if(r.type&c.FileType.Directory)throw new c.FileOperationError((0,E.localize)(8,null,this.resourceForError(o)),0,s);if(this.throwIfFileIsReadonly(o,r),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==c.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&s.mtime<r.mtime&&s.etag!==(0,c.etag)({mtime:s.mtime,size:r.size}))throw new c.FileOperationError((0,E.localize)(9,null),3,s);return r}async readFile(t,o,s){const n=await this.withReadProvider(t);return o?.atomic?this.doReadFileAtomic(n,t,o,s):this.doReadFile(n,t,o,s)}async doReadFileAtomic(t,o,s,n){return new Promise((i,r)=>{this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(t,o,s,n);i(a)}catch(a){r(a)}})})}async doReadFile(t,o,s,n){const i=await this.doReadFileStream(t,o,{...s,preferUnbuffered:!0},n);return{...i,value:await(0,T.streamToBuffer)(i.value)}}async readFileStream(t,o,s){const n=await this.withReadProvider(t);return this.doReadFileStream(n,t,o,s)}async doReadFileStream(t,o,s,n){const i=new A.CancellationTokenSource(n),r=this.validateReadFile(o,s).then(w=>w,w=>{throw i.cancel(),w});let a;try{return typeof s?.etag=="string"&&s.etag!==c.ETAG_DISABLED&&await r,s?.atomic&&(0,c.hasFileAtomicReadCapability)(t)||!((0,c.hasOpenReadWriteCloseCapability)(t)||(0,c.hasFileReadStreamCapability)(t))||(0,c.hasReadWriteCapability)(t)&&s?.preferUnbuffered?a=this.readFileUnbuffered(t,o,s):(0,c.hasFileReadStreamCapability)(t)?a=this.readFileStreamed(t,o,i.token,s):a=this.readFileBuffered(t,o,i.token,s),{...await r,value:a}}catch(w){throw a&&await(0,f.consumeStream)(a),this.restoreReadError(w,o,s)}}restoreReadError(t,o,s){const n=(0,E.localize)(10,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(t).toString());return t instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(n,t.stat,s):t instanceof c.TooLargeFileOperationError?new c.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new c.FileOperationError(n,(0,c.toFileOperationResult)(t),s)}readFileStreamed(t,o,s,n=Object.create(null)){const i=t.readFileStream(o,n,s);return(0,f.transform)(i,{data:r=>r instanceof T.VSBuffer?r:T.VSBuffer.wrap(r),error:r=>this.restoreReadError(r,o,n)},r=>T.VSBuffer.concat(r))}readFileBuffered(t,o,s,n=Object.create(null)){const i=(0,T.newWriteableBufferStream)();return(0,u.readFileIntoStream)(t,o,i,r=>r,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>this.restoreReadError(r,o,n)},s),i}readFileUnbuffered(t,o,s){const n=(0,f.newWriteableStream)(i=>T.VSBuffer.concat(i));return(async()=>{try{let i;s?.atomic&&(0,c.hasFileAtomicReadCapability)(t)?i=await t.readFile(o,{atomic:!0}):i=await t.readFile(o),typeof s?.position=="number"&&(i=i.slice(s.position)),typeof s?.length=="number"&&(i=i.slice(0,s.length)),this.validateReadFileLimits(o,i.byteLength,s),n.end(T.VSBuffer.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async validateReadFile(t,o){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new c.FileOperationError((0,E.localize)(11,null,this.resourceForError(t)),0,o);if(typeof o?.etag=="string"&&o.etag!==c.ETAG_DISABLED&&o.etag===s.etag)throw new c.NotModifiedSinceFileOperationError((0,E.localize)(12,null),s,o);return this.validateReadFileLimits(t,s.size,o),s}validateReadFileLimits(t,o,s){if(typeof s?.limits?.size=="number"&&o>s.limits.size)throw new c.TooLargeFileOperationError((0,E.localize)(13,null,this.resourceForError(t)),7,o,s)}async canMove(t,o,s){return this.doCanMoveCopy(t,o,"move",s)}async canCopy(t,o,s){return this.doCanMoveCopy(t,o,"copy",s)}async doCanMoveCopy(t,o,s,n){if(t.toString()!==o.toString())try{const i=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,t,r,o,s,n)}catch(i){return i}return!0}async move(t,o,s){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(n,t,i,o,"move",!!s),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(t,r==="move"?2:3,a)),a}async copy(t,o,s){const n=await this.withReadProvider(t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(n,t,i,o,"copy",!!s),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(t,r==="copy"?3:2,a)),a}async doMoveCopy(t,o,s,n,i,r){if(o.toString()===n.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:w}=await this.doValidateMoveCopy(t,o,s,n,i,r);if(a&&!w&&r&&await this.del(n,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(n)),i==="copy"){if(t===s&&(0,c.hasFileFolderCopyCapability)(t))await t.copy(o,n,{overwrite:r});else{const S=await this.resolve(o);S.isDirectory?await this.doCopyFolder(t,S,s,n):await this.doCopyFile(t,o,s,n)}return i}else return t===s?(await t.rename(o,n,{overwrite:r}),i):(await this.doMoveCopy(t,o,s,n,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(t,o,s,n){if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(t,o,s,n);if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(t,o,s,n);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(t,o,s,n);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasReadWriteCapability)(s))return this.doPipeUnbuffered(t,o,s,n)}async doCopyFolder(t,o,s,n){await s.mkdir(n),Array.isArray(o.children)&&await O.Promises.settled(o.children.map(async i=>{const r=this.getExtUri(s).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.doCopyFolder(t,await this.resolve(i.resource),s,r):this.doCopyFile(t,i.resource,s,r)}))}async doValidateMoveCopy(t,o,s,n,i,r){let a=!1;if(t===s){const{providerExtUri:S,isPathCaseSensitive:l}=this.getExtUri(t);if(l||(a=S.isEqual(o,n)),a&&i==="copy")throw new Error((0,E.localize)(14,null,this.resourceForError(o),this.resourceForError(n)));if(!a&&S.isEqualOrParent(n,o))throw new Error((0,E.localize)(15,null,this.resourceForError(o),this.resourceForError(n)))}const w=await this.exists(n);if(w&&!a){if(!r)throw new c.FileOperationError((0,E.localize)(16,null,this.resourceForError(o),this.resourceForError(n)),4);if(t===s){const{providerExtUri:S}=this.getExtUri(t);if(S.isEqualOrParent(o,n))throw new Error((0,E.localize)(17,null,this.resourceForError(o),this.resourceForError(n)))}}return{exists:w,isSameResourceWithDifferentPathCase:a}}getExtUri(t){const o=this.isPathCaseSensitive(t);return{providerExtUri:o?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(o,t);const s=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(t,0,s)),s}async mkdirp(t,o){const s=[],{providerExtUri:n}=this.getExtUri(t);for(;!n.isEqual(o,n.dirname(o));)try{if(!((await t.stat(o)).type&c.FileType.Directory))throw new Error((0,E.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,c.toFileSystemProviderErrorCode)(i)!==c.FileSystemProviderErrorCode.FileNotFound)throw i;s.push(n.basename(o)),o=n.dirname(o)}for(let i=s.length-1;i>=0;i--){o=n.joinPath(o,s[i]);try{await t.mkdir(o)}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,o){try{await this.doValidateDelete(t,o)}catch(s){return s}return!0}async doValidateDelete(t,o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),n=!!o?.useTrash;if(n&&!(s.capabilities&4096))throw new Error((0,E.localize)(19,null,this.resourceForError(t)));const i=o?.atomic;if(i&&!(s.capabilities&65536))throw new Error((0,E.localize)(20,null,this.resourceForError(t)));if(n&&i)throw new Error((0,E.localize)(21,null,this.resourceForError(t)));let r;try{r=await s.stat(t)}catch{}if(r)this.throwIfFileIsReadonly(t,r);else throw new c.FileOperationError((0,E.localize)(22,null,this.resourceForError(t)),1);if(!!!o?.recursive){const w=await this.resolve(t);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,E.localize)(23,null,this.resourceForError(t)))}return s}async del(t,o){const s=await this.doValidateDelete(t,o),n=!!o?.useTrash,i=!!o?.recursive,r=o?.atomic??!1;await s.delete(t,{recursive:i,useTrash:n,atomic:r}),this._onDidRunOperation.fire(new c.FileOperationEvent(t,1))}async cloneFile(t,o){const s=await this.withProvider(t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(s===n&&this.getExtUri(s).providerExtUri.isEqual(t,o))return;if(s===n&&(0,c.hasFileCloneCapability)(s))return s.cloneFile(t,o);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(o));const i=this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri);return s===n&&(0,c.hasFileFolderCopyCapability)(s)?i.queue(()=>s.copy(t,o,{overwrite:!0})):i.queue(()=>this.doCopyFile(s,t,n,o))}watch(t,o={recursive:!1,excludes:[]}){const s=new m.DisposableStore;let n=!1,i=()=>{n=!0};return s.add((0,m.toDisposable)(()=>i())),(async()=>{try{const r=await this.doWatch(t,o);n?(0,m.dispose)(r):i=()=>(0,m.dispose)(r)}catch(r){this.logService.error(r)}})(),s}async doWatch(t,o){const s=await this.withProvider(t),n=(0,R.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(t),o]);let i=this.activeWatchers.get(n);return i||(i={count:0,disposable:s.watch(t,o)},this.activeWatchers.set(n,i)),i.count+=1,(0,m.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,m.dispose)(i.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,m.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBufferedAtomic(t,o,s,n,i){await this.doWriteBuffered(t,s,n,i);try{await t.rename(s,o,{overwrite:!0})}catch(r){try{await t.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async doWriteBuffered(t,o,s,n){return this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(async()=>{const i=await t.open(o,{create:!0,unlock:s?.unlock??!1});try{(0,f.isReadableStream)(n)||(0,f.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(t,i,n):await this.doWriteReadableBufferedQueued(t,i,n)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await t.close(i)}})}async doWriteStreamBufferedQueued(t,o,s){let n=0,i;if((0,f.isReadableBufferedStream)(s)){if(s.buffer.length>0){const r=T.VSBuffer.concat(s.buffer);await this.doWriteBuffer(t,o,r,r.byteLength,n,0),n+=r.byteLength}if(s.ended)return;i=s.stream}else i=s;return new Promise((r,a)=>{(0,f.listenStream)(i,{onData:async w=>{i.pause();try{await this.doWriteBuffer(t,o,w,w.byteLength,n,0)}catch(S){return a(S)}n+=w.byteLength,setTimeout(()=>i.resume())},onError:w=>a(w),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(t,o,s){let n=0,i;for(;(i=s.read())!==null;)await this.doWriteBuffer(t,o,i,i.byteLength,n,0),n+=i.byteLength}async doWriteBuffer(t,o,s,n,i,r){let a=0;for(;a<n;){const w=await t.write(o,i+a,s.buffer,r+a,n-a);a+=w}}async doWriteUnbuffered(t,o,s,n){return this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,o,s,n))}async doWriteUnbufferedQueued(t,o,s,n){let i;n instanceof T.VSBuffer?i=n:(0,f.isReadableStream)(n)?i=await(0,T.streamToBuffer)(n):(0,f.isReadableBufferedStream)(n)?i=await(0,T.bufferedStreamToBuffer)(n):i=(0,T.readableToBuffer)(n),await t.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async doPipeBuffered(t,o,s,n){return this.writeQueue.queueFor(n,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,o,s,n))}async doPipeBufferedQueued(t,o,s,n){let i,r;try{i=await t.open(o,{create:!1}),r=await s.open(n,{create:!0,unlock:!1});const a=T.VSBuffer.alloc(this.BUFFER_SIZE);let w=0,S=0,l=0;do l=await t.read(i,w,a.buffer,S,a.byteLength-S),await this.doWriteBuffer(s,r,a,l,w,S),w+=l,S+=l,S===a.byteLength&&(S=0);while(l>0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await O.Promises.settled([typeof i=="number"?t.close(i):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async doPipeUnbuffered(t,o,s,n){return this.writeQueue.queueFor(n,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,o,s,n))}async doPipeUnbufferedQueued(t,o,s,n){return s.writeFile(n,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,o,s,n){return this.writeQueue.queueFor(n,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,o,s,n))}async doPipeUnbufferedToBufferedQueued(t,o,s,n){const i=await s.open(n,{create:!0,unlock:!1});try{const r=await t.readFile(o);await this.doWriteBuffer(s,i,T.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await s.close(i)}}async doPipeBufferedToUnbuffered(t,o,s,n){const i=await(0,T.streamToBuffer)(this.readFileBuffered(t,o,A.CancellationToken.None));await this.doWriteUnbuffered(s,n,void 0,i)}throwIfFileSystemIsReadonly(t,o){if(t.capabilities&2048)throw new c.FileOperationError((0,E.localize)(24,null,this.resourceForError(o)),6);return t}throwIfFileIsReadonly(t,o){if((o.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,E.localize)(25,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===y.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=p,e.FileService=p=ye([K(0,d.ILogService)],p)}),define(ce[198],le([0,1,52,269,5,35,14,3,48,2,16,6,22,42,31,160,13,99,196,38,192,191]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d,v,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(k)}catch(o){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(o)}`)}})();class t extends d.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new A.ResourceMap(i=>g.extUriBiasedIgnorePathCase.getComparisonKey(i)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,y.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:n,symbolicLink:i}=await f.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(n,i),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:c.FilePermission.Locked}}catch(n){throw this.toFileSystemProviderError(n)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await f.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),i=[];return await Promise.all(n.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,g.joinPath)(s,r.name))).type:a=this.toType(r),i.push([r.name,a])}catch(a){this.logService.trace(a)}})),i}catch(n){throw this.toFileSystemProviderError(n)}}toType(s,n){let i;return n?.dangling?i=c.FileType.Unknown:s.isFile()?i=c.FileType.File:s.isDirectory()?i=c.FileType.Directory:i=c.FileType.Unknown,n&&(i|=c.FileType.SymbolicLink),i}async createResourceLock(s){const n=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let i;for(;i=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await i.wait();const r=new T.Barrier;return this.resourceLocks.set(s,r),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,m.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(s)===r&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),r.open()})}async readFile(s,n){let i;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),i=await this.createResourceLock(s));const r=this.toFilePath(s);return await f.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}finally{i?.dispose()}}traceLock(s){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,n,i){const r=(0,h.newWriteableStream)(a=>_.VSBuffer.concat(a.map(w=>_.VSBuffer.wrap(w))).buffer);return(0,u.readFileIntoStream)(this,s,r,a=>a.buffer,{...n,bufferSize:256*1024},i),r}async writeFile(s,n,i){return i?.atomic!==!1&&i?.atomic?.postfix?this.doWriteFileAtomic(s,(0,g.joinPath)((0,g.dirname)(s),`${(0,g.basename)(s)}${i.atomic.postfix}`),n,i):this.doWriteFile(s,n,i)}async doWriteFileAtomic(s,n,i,r){await this.doWriteFile(n,i,r);try{await this.rename(n,s,{overwrite:!0})}catch(a){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async doWriteFile(s,n,i){let r;try{const a=this.toFilePath(s);if(!i.create||!i.overwrite){if(await f.Promises.exists(a)){if(!i.overwrite)throw(0,c.createFileSystemProviderError)((0,E.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,c.createFileSystemProviderError)((0,E.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(s,{create:!0,unlock:i.unlock}),await this.write(r,0,n,0,n.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(s,a)}finally{typeof r=="number"&&await this.close(r)}}static{this.canFlush=!0}static configureFlushOnWrite(s){t.canFlush=s}async open(s,n){const i=this.toFilePath(s);let r;(0,c.isFileOpenForWriteOptions)(n)&&(r=await this.createResourceLock(s));let a;try{if((0,c.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:S}=await f.SymlinkSupport.stat(i);S.mode&128||await f.Promises.chmod(i,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}let w;if((0,c.isFileOpenForWriteOptions)(n)){if(y.isWindows)try{await f.Promises.truncate(i,0),w="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}w||(w="w")}else w="r";a=await f.Promises.open(i,w)}catch(w){throw r?.dispose(),(0,c.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(s,w):this.toFileSystemProviderError(w)}if(this.mapHandleToPos.set(a,0),(0,c.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(a,s),r){const w=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${i})`),this.mapHandleToLock.set(a,r),w&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${i})`),w.dispose())}return a}async close(s){const n=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&t.canFlush)try{await f.Promises.fdatasync(s)}catch(i){t.configureFlushOnWrite(!1),this.logService.error(i)}return await f.Promises.close(s)}catch(i){throw this.toFileSystemProviderError(i)}finally{n&&(this.mapHandleToLock.get(s)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,i,r,a){const w=this.normalizePos(s,n);let S=null;try{S=(await f.Promises.read(s,i,r,a,w)).bytesRead}catch(l){throw this.toFileSystemProviderError(l)}finally{this.updatePos(s,w,S)}return S}normalizePos(s,n){return n===this.mapHandleToPos.get(s)?null:n}updatePos(s,n,i){const r=this.mapHandleToPos.get(s);typeof r=="number"&&(typeof n=="number"||(typeof i=="number"?this.mapHandleToPos.set(s,r+i):this.mapHandleToPos.delete(s)))}async write(s,n,i,r,a){return(0,T.retry)(()=>this.doWrite(s,n,i,r,a),100,3)}async doWrite(s,n,i,r,a){const w=this.normalizePos(s,n);let S=null;try{S=(await f.Promises.write(s,i,r,a,w)).bytesWritten}catch(l){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),l)}finally{this.updatePos(s,w,S)}return S}async mkdir(s){try{await f.Promises.mkdir(this.toFilePath(s))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(s,n){try{const i=this.toFilePath(s);if(n.recursive){let r;n?.atomic!==!1&&n.atomic.postfix&&(r=(0,I.join)((0,I.dirname)(i),`${(0,I.basename)(i)}${n.atomic.postfix}`)),await f.Promises.rm(i,f.RimRafMode.MOVE,r)}else try{await f.Promises.unlink(i)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:w,symbolicLink:S}=await f.SymlinkSupport.stat(i);a=w.isDirectory()&&!S}catch{}if(a)await f.Promises.rmdir(i);else throw r}else throw r}}catch(i){throw this.toFileSystemProviderError(i)}}async rename(s,n,i){const r=this.toFilePath(s),a=this.toFilePath(n);if(r!==a)try{await this.validateMoveCopy(s,n,"move",i.overwrite),await f.Promises.rename(r,a)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,E.localize)(2,null,(0,I.basename)(r),(0,I.basename)((0,I.dirname)(a)),w.toString()))),this.toFileSystemProviderError(w)}}async copy(s,n,i){const r=this.toFilePath(s),a=this.toFilePath(n);if(r!==a)try{await this.validateMoveCopy(s,n,"copy",i.overwrite),await f.Promises.copy(r,a,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,E.localize)(3,null,(0,I.basename)(r),(0,I.basename)((0,I.dirname)(a)),w.toString()))),this.toFileSystemProviderError(w)}}async validateMoveCopy(s,n,i,r){const a=this.toFilePath(s),w=this.toFilePath(n);let S=!1;if(!!(this.capabilities&1024)||(S=(0,P.isEqual)(a,w,!0)),S){if(i==="copy")throw(0,c.createFileSystemProviderError)((0,E.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const C=await this.statIgnoreError(s);if(!C)throw(0,c.createFileSystemProviderError)((0,E.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const U=await this.statIgnoreError(n);if(U){if(!r)throw(0,c.createFileSystemProviderError)((0,E.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);C.type&c.FileType.File&&U.type&c.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.doCloneFile(s,n,!1)}async doCloneFile(s,n,i){const r=this.toFilePath(s),a=this.toFilePath(n),w=!!(this.capabilities&1024);if((0,P.isEqual)(r,a,!w))return;const S=new m.DisposableStore;try{const[l,C]=await Promise.all([this.createResourceLock(s),this.createResourceLock(n)]);S.add(l),S.add(C),i&&await f.Promises.mkdir((0,I.dirname)(a),{recursive:!0}),await f.Promises.copyFile(r,a)}catch(l){if(l.code==="ENOENT"&&!i)return this.doCloneFile(s,n,!0);throw this.toFileSystemProviderError(l)}finally{S.dispose()}}createUniversalWatcher(s,n,i){return new p.UniversalWatcherClient(r=>s(r),r=>n(r),i)}createNonRecursiveWatcher(s,n,i){return new L.NodeJSWatcherClient(r=>s(r),r=>n(r),i)}toFileSystemProviderError(s){if(s instanceof c.FileSystemProviderError)return s;let n=s,i;switch(s.code){case"ENOENT":i=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=c.FileSystemProviderErrorCode.Unknown;break;default:i=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(n,i)}async toFileSystemProviderWriteError(s,n){let i=this.toFileSystemProviderError(n);if(s&&i.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await f.SymlinkSupport.stat(this.toFilePath(s));r.mode&128||(i=(0,c.createFileSystemProviderError)(n,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.logService.trace(r)}return i}}e.DiskFileSystemProvider=t}),define(ce[101],le([0,1,3,2,4,7]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,T.createDecorator)("sharedProcessLifecycleService");let _=class extends O.Disposable{constructor(P){super(),this.logService=P,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=_,e.SharedProcessLifecycleService=_=ye([K(0,A.ILogService)],_)}),define(ce[199],le([0,1,10,3,7,2]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class _ extends T.AbstractLoggerService{constructor(y,g,h,f,E){super(g,h,f),this.windowId=y,this.channel=E,this._register(E.listen("onDidChangeLogLevel",y)(c=>{(0,T.isLogLevel)(c)?super.setLogLevel(c):super.setLogLevel(k.URI.revive(c[0]),c[1])})),this._register(E.listen("onDidChangeVisibility",y)(([c,u])=>super.setVisibility(k.URI.revive(c),u))),this._register(E.listen("onDidChangeLoggers",y)(({added:c,removed:u})=>{for(const d of c)super.registerLogger({...d,resource:k.URI.revive(d.resource)});for(const d of u)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new T.AdapterLogger({log:(y,g)=>{this.channel.call("consoleLog",[y,g])}})}registerLogger(y){super.registerLogger(y),this.channel.call("registerLogger",[y,this.windowId])}deregisterLogger(y){super.deregisterLogger(y),this.channel.call("deregisterLogger",[y,this.windowId])}setLogLevel(y,g){super.setLogLevel(y,g),this.channel.call("setLogLevel",[y,g])}setVisibility(y,g){super.setVisibility(y,g),this.channel.call("setVisibility",[this.toResource(y),g])}doCreateLogger(y,g,h){return new R(this.channel,y,g,h,this.windowId)}static setLogLevel(y,g,h){return y.call("setLogLevel",[g,h])}}e.LoggerChannelClient=_;class R extends T.AbstractMessageLogger{constructor(y,g,h,f,E){super(f?.logLevel==="always"),this.channel=y,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[g,f,E]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,g){const h=[[y,g]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(y){this.channel.call("log",[this.file,y])}}class P{constructor(y,g){this.loggerService=y,this.getUriTransformer=g}listen(y,g){const h=this.getUriTransformer(y);switch(g){case"onDidChangeLoggers":return O.Event.map(this.loggerService.onDidChangeLoggers,f=>({added:[...f.added].map(E=>this.transformLogger(E,h)),removed:[...f.removed].map(E=>this.transformLogger(E,h))}));case"onDidChangeVisibility":return O.Event.map(this.loggerService.onDidChangeVisibility,f=>[h.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return O.Event.map(this.loggerService.onDidChangeLogLevel,f=>(0,T.isLogLevel)(f)?f:[h.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${g}`)}async call(y,g,h){const f=this.getUriTransformer(y);switch(g){case"setLogLevel":return(0,T.isLogLevel)(h[0])?this.loggerService.setLogLevel(h[0]):this.loggerService.setLogLevel(k.URI.revive(f.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(E=>this.transformLogger(E,f)))}throw new Error(`Call not found: ${g}`)}transformLogger(y,g){return{...y,resource:g.transformOutgoingURI(y.resource)}}}e.LoggerChannel=P;class m extends A.Disposable{constructor(y,g){super(),g.call("setLogLevel",[y.getLogLevel()]),this._register(y.onDidChangeLogLevel(h=>g.call("setLogLevel",[h]))),g.call("getRegisteredLoggers").then(h=>{for(const f of h)y.registerLogger({...f,resource:k.URI.revive(f.resource)})}),this._register(g.listen("onDidChangeVisibility")(([h,f])=>y.setVisibility(k.URI.revive(h),f))),this._register(g.listen("onDidChangeLoggers")(({added:h,removed:f})=>{for(const E of h)y.registerLogger({...E,resource:k.URI.revive(E.resource)});for(const E of f)y.deregisterLogger(E.resource)}))}}e.RemoteLoggerChannelClient=m}),define(ce[200],le([0,1,2,7]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class T extends k.Disposable{constructor(_,R=[]){super(),this.logger=new O.MultiplexLogger([_,...R]),this._register(_.onDidChangeLogLevel(P=>this.setLevel(P)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(_){this.logger.setLevel(_)}getLevel(){return this.logger.getLevel()}trace(_,...R){this.logger.trace(_,...R)}debug(_,...R){this.logger.debug(_,...R)}info(_,...R){this.logger.info(_,...R)}warn(_,...R){this.logger.warn(_,...R)}error(_,...R){this.logger.error(_,...R)}flush(){this.logger.flush()}}e.LogService=T}),define(ce[55],le([0,1,4]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(ce[56],le([0,1,3,59,2,4]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class _ extends T.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(m){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...m,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(m),O.Iterable.reduce(this.policies.entries(),(y,[g,h])=>({...y,[g]:h}),{})}getPolicyValue(m){return this.policies.get(m)}serialize(){return O.Iterable.reduce(Object.entries(this.policyDefinitions),(m,[I,y])=>({...m,[I]:{definition:y,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=_;class R{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(ce[201],le([0,1,3,2,56]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(P){this.service=P,this.disposables=new O.DisposableStore}listen(P,m){switch(m){case"onDidChange":return k.Event.map(this.service.onDidChange,I=>I.reduce((y,g)=>({...y,[g]:this.service.getPolicyValue(g)??null}),{}),this.disposables)}throw new Error(`Event not found: ${m}`)}call(P,m,I){switch(m){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(I)}throw new Error(`Call not found: ${m}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=A;class _ extends T.AbstractPolicyService{constructor(P,m){super(),this.channel=m;for(const I in P){const{definition:y,value:g}=P[I];this.policyDefinitions[I]=y,g!==void 0&&this.policies.set(I,g)}this.channel.listen("onDidChange")(I=>{for(const y in I){const g=I[y];g===null?this.policies.delete(y):this.policies.set(y,g)}this._onDidChange.fire(Object.keys(I))})}async _updatePolicyDefinitions(P){const m=await this.channel.call("updatePolicyDefinitions",P);for(const I in m)this.policies.set(I,m[I])}}e.PolicyChannelClient=_}),define(ce[102],le([0,1,6,37]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.context<"u"){const A=k.globals.vscode.context.configuration();if(A)T=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){T=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:_,itemUrl:R,controlUrl:P}=T.extensionsGallery||{};Object.assign(T,{extensionsGallery:{serviceUrl:O.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:O.env.VSCODE_GALLERY_SEARCH_URL||_,itemUrl:O.env.VSCODE_GALLERY_ITEM_URL||R,controlUrl:O.env.VSCODE_GALLERY_CONTROL_URL||P}});try{const m=(...y)=>y.reduce((g,h)=>(Object.keys(h).forEach(f=>{Array.isArray(g[f])&&Array.isArray(h[f])?g[f]=h[f]:typeof g[f]=="object"&&typeof h[f]=="object"?g[f]=m(g[f],h[f]):g[f]=h[f]}),g),{}),I=globalThis._VSCODE_USER_PRODUCT_JSON||{};T=m(T,I)}catch{}if(O.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const m=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:m.version,release:m.release})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ce[23],le([0,1,4]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ce[202],le([0,1,5,8,2,16,31,7,23]),function(ie,e,k,O,T,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let m=class extends T.Disposable{constructor(y,g,h){super(),this.productService=g,this.logService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,y&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(y)},3e4)).schedule()}async cleanUpCodeCaches(y){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),h=(0,A.dirname)(y),f=(0,A.basename)(y),E=await _.Promises.readdir(h);await Promise.all(E.map(async c=>{if(c===f)return;const u=(0,A.join)(h,c),d=await _.Promises.stat(u);if(d.isDirectory()&&g-d.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${c}.`),_.Promises.rm(u)}))}catch(g){(0,O.onUnexpectedError)(g)}}};e.CodeCacheCleaner=m,e.CodeCacheCleaner=m=ye([K(1,P.IProductService),K(2,R.ILogService)],m)}),define(ce[203],le([0,1,5,8,2,16,31,15,7,23]),function(ie,e,k,O,T,A,_,R,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends T.Disposable{constructor(g,h,f){super(),this.environmentService=g,this.logService=h,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),h=JSON.parse(await _.Promises.readFile((0,A.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(h)){const v=h[d];g[`${v.hash}.${d}`]=!0}const f=(0,A.join)(this.environmentService.userDataPath,"clp");if(!await _.Promises.exists(f))return;const c=await _.Promises.readdir(f);for(const d of c){if(g[d]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await _.Promises.rm((0,A.join)(f,d))}const u=Date.now();for(const d of Object.keys(g)){const v=(0,A.join)(f,d),p=await _.Promises.readdir(v);for(const L of p){if(L==="tcf.json")continue;const t=(0,A.join)(v,L),o=await _.Promises.stat(t);o.isDirectory()&&u-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(d,L)}`),await _.Promises.rm(t))}}}catch(g){(0,O.onUnexpectedError)(g)}}};e.LanguagePackCachedDataCleaner=I,e.LanguagePackCachedDataCleaner=I=ye([K(0,R.INativeEnvironmentService),K(1,P.ILogService),K(2,m.IProductService)],I)}),define(ce[204],le([0,1,16,4]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,O.createDecorator)("IV8InspectProfilingService");var T;(function(A){function _(P){return!!(P.samples&&P.timeDeltas)}A.isValidProfile=_;function R(P,m="noAbsolutePaths"){for(const I of P.nodes)I.callFrame&&I.callFrame.url&&((0,k.isAbsolute)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(I.callFrame.url))&&(I.callFrame.url=(0,k.join)(m,(0,k.basename)(I.callFrame.url)));return P}A.rewriteAbsolutePaths=R})(T||(e.Utils=T={}))}),define(ce[205],le([0,1,32]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class O{constructor(){this._sessions=new Map}async startProfiling(A){const R=await(await new Promise((m,I)=>{ie(["v8-inspect-profiler"],m,I)})).startProfiling({port:A.port,checkForPaused:!0}),P=(0,k.generateUuid)();return this._sessions.set(P,R),P}async stopProfiling(A){const _=this._sessions.get(A);if(!_)throw new Error(`UNKNOWN session '${A}'`);const R=await _.stop();return this._sessions.delete(A),R.profile}}e.InspectProfilingService=O}),define(ce[40],le([0,1,125,11]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(_,R){k.ok(O.isString(_)),k.ok(O.isObject(R)),k.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,R)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new T}),define(ce[103],le([0,1,3,40]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(P,m){this.schemasById[T(P)]=m,this._onDidChangeSchema.fire(P)}notifySchemaChanged(P){this._onDidChangeSchema.fire(P)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new A;O.Registry.add(e.Extensions.JSONContribution,_)}),define(ce[49],le([0,1,20,3,11,147,18,103,40]),function(ie,e,k,O,T,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(L){L.Multiline="multilineText",L.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(L){L[L.APPLICATION=1]="APPLICATION",L[L.MACHINE=2]="MACHINE",L[L.WINDOW=3]="WINDOW",L[L.RESOURCE=4]="RESOURCE",L[L.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",L[L.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=P.Registry.as(R.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const s=new Set;this.doRegisterConfigurations(t,o,s),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(t){const o=new Set;this.doDeregisterConfigurations(t,o),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:t,remove:o}){const s=new Set;this.doDeregisterConfigurations(o,s),this.doRegisterConfigurations(t,!1,s),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(t){const o=new Set;this.doRegisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,o){const s=[];for(const{overrides:n,source:i}of t)for(const r in n)if(o.add(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const a=this.configurationDefaultsOverrides.get(r),w=a?.valuesSources??new Map;if(i)for(const U of Object.keys(n[r]))w.set(U,i);const S={...a?.value||{},...n[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:S,valuesSources:w});const l=(0,_.getLanguageTagSettingPlainKey)(r),C={type:"object",default:S,description:A.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:T.isString(i)?void 0:i,defaultValueSource:i};s.push(...E(r)),this.configurationProperties[r]=C,this.defaultLanguageConfigurationOverridesNode.properties[r]=C}else{this.configurationDefaultsOverrides.set(r,{value:n[r],source:i});const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(t){const o=new Set;this.doDeregisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,o){for(const{overrides:s,source:n}of t)for(const i in s){const r=this.configurationDefaultsOverrides.get(i),a=T.isString(n)?n:n?.id,w=T.isString(r?.source)?r?.source:r?.source?.id;if(a===w)if(o.add(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const S=this.configurationProperties[i];S&&(this.updatePropertyDefaultValue(i,S),this.updateSchema(i,S))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let o=!1;const s=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,s),o=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,s),o=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,s),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const o of t)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,o,s){t.forEach(n=>{this.validateAndRegisterProperties(n,o,n.extensionInfo,n.restrictedProperties,void 0,s),this.configurationContributors.push(n),this.registerJSONConfiguration(n)})}doDeregisterConfigurations(t,o){const s=n=>{if(n.properties)for(const i in n.properties){o.add(i);const r=this.configurationProperties[i];r?.policy?.name&&this.policyConfigurations.delete(r.policy.name),delete this.configurationProperties[i],this.removeFromSchema(i,n.properties[i])}n.allOf?.forEach(i=>s(i))};for(const n of t){s(n);const i=this.configurationContributors.indexOf(n);i!==-1&&this.configurationContributors.splice(i,1)}}validateAndRegisterProperties(t,o=!0,s,n,i=3,r){i=T.isUndefinedOrNull(t.scope)?i:t.scope;const a=t.properties;if(a)for(const S in a){const l=a[S];if(o&&v(S,l)){delete a[S];continue}if(l.source=s,l.defaultDefaultValue=a[S].default,this.updatePropertyDefaultValue(S,l),e.OVERRIDE_PROPERTY_REGEX.test(S)?l.scope=void 0:(l.scope=T.isUndefinedOrNull(l.scope)?i:l.scope,l.restricted=T.isUndefinedOrNull(l.restricted)?!!n?.includes(S):l.restricted),a[S].hasOwnProperty("included")&&!a[S].included){this.excludedConfigurationProperties[S]=a[S],delete a[S];continue}else this.configurationProperties[S]=a[S],a[S].policy?.name&&this.policyConfigurations.set(a[S].policy.name,S);!a[S].deprecationMessage&&a[S].markdownDeprecationMessage&&(a[S].deprecationMessage=a[S].markdownDeprecationMessage),r.add(S)}const w=t.allOf;if(w)for(const S of w)this.validateAndRegisterProperties(S,o,s,n,i,r)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const o=s=>{const n=s.properties;if(n)for(const r in n)this.updateSchema(r,n[r]);s.allOf?.forEach(o)};o(t)}updateSchema(t,o){switch(e.allSettings.properties[t]=o,o.scope){case 1:e.applicationSettings.properties[t]=o;break;case 2:e.machineSettings.properties[t]=o;break;case 6:e.machineOverridableSettings.properties[t]=o;break;case 3:e.windowSettings.properties[t]=o;break;case 4:e.resourceSettings.properties[t]=o;break;case 5:e.resourceSettings.properties[t]=o,this.resourceLanguageSettingsSchema.properties[t]=o;break}}removeFromSchema(t,o){switch(delete e.allSettings.properties[t],o.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const o=`[${t}]`,s={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}registerOverridePropertyPatternKey(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,o){const s=this.configurationDefaultsOverrides.get(t);let n=s?.value,i=s?.source;T.isUndefined(n)&&(n=o.defaultDefaultValue,i=void 0),T.isUndefined(n)&&(n=u(o.type)),o.default=n,o.defaultValueSource=i}}const h="\\[([^\\]]+)\\]",f=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(L){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(L)){let o=f.exec(L);for(;o?.length;){const s=o[1].trim();s&&t.push(s),o=f.exec(L)}}return(0,k.distinct)(t)}e.overrideIdentifiersFromKey=E;function c(L){return L.reduce((t,o)=>`${t}[${o}]`,"")}e.keyFromOverrideIdentifiers=c;function u(L){switch(Array.isArray(L)?L[0]:L){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const d=new g;P.Registry.add(e.Extensions.Configuration,d);function v(L,t){return L.trim()?e.OVERRIDE_PROPERTY_REGEX.test(L)?A.localize(7,null,L):d.getConfigurationProperties()[L]!==void 0?A.localize(8,null,L):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,L,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=v;function p(){const L=[],t=d.getConfigurationProperties();for(const o of Object.keys(t))L.push([o,t[o].scope]);return L.push(["launch",4]),L.push(["task",4]),L}e.getScopes=p}),define(ce[73],le([0,1,20,3,34,2,35,30,11,10,18,49,40]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function h(o){return Object.isFrozen(o)?o:R.deepFreeze(o)}class f{constructor(s={},n=[],i=[],r){this._contents=s,this._keys=n,this._overrides=i,this.raw=r,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof f)return n;const i=new E("");return i.parseRaw(n),i.configurationModel});this._rawConfiguration=s.reduce((n,i)=>i===n?i:n.merge(i),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,I.getConfigurationValue)(this.contents,s):this.contents}inspect(s,n){const i=this.rawConfiguration.getValue(s),r=n?this.rawConfiguration.getOverrideValue(s,n):void 0,a=n?this.rawConfiguration.override(n).getValue(s):i;return{value:i,override:r,merged:a}}getOverrideValue(s,n){const i=this.getContentsForOverrideIdentifer(n);return i?s?(0,I.getConfigurationValue)(i,s):i:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const i of this.overrides)i.identifiers.includes(s)&&n.push(...i.keys);return k.distinct(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return k.distinct(s)}override(s){let n=this.overrideConfigurations.get(s);return n||(n=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,n)),n}merge(...s){const n=R.deepClone(this.contents),i=R.deepClone(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const w of s)if(a.push(...w.raw?.length?w.raw:[w]),!w.isEmpty()){this.mergeContents(n,w.contents);for(const S of w.overrides){const[l]=i.filter(C=>k.equals(C.identifiers,S.identifiers));l?(this.mergeContents(l.contents,S.contents),l.keys.push(...S.keys),l.keys=k.distinct(l.keys)):i.push(R.deepClone(S))}for(const S of w.keys)r.indexOf(S)===-1&&r.push(S)}return new f(n,r,i,a.every(w=>w instanceof f)?void 0:a)}createOverrideConfigurationModel(s){const n=this.getContentsForOverrideIdentifer(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const r of k.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[r];const w=n[r];w&&(typeof a=="object"&&typeof w=="object"?(a=R.deepClone(a),this.mergeContents(a,w)):a=w),i[r]=a}return new f(i,this.keys,this.overrides)}mergeContents(s,n){for(const i of Object.keys(n)){if(i in s&&P.isObject(s[i])&&P.isObject(n[i])){this.mergeContents(s[i],n[i]);continue}s[i]=R.deepClone(n[i])}}getContentsForOverrideIdentifer(s){let n=null,i=null;const r=a=>{a&&(i?this.mergeContents(i,a):i=R.deepClone(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===s?n=a.contents:a.identifiers.includes(s)&&r(a.contents);return r(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.updateValue(s,n,!0)}setValue(s,n){this.updateValue(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,I.removeFromValueTree)(this.contents,s),y.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(i=>k.equals(i.identifiers,(0,y.overrideIdentifiersFromKey)(s))),1))}updateValue(s,n,i){(0,I.addToValueTree)(this.contents,s,n,r=>console.error(r)),i=i||this.keys.indexOf(s)===-1,i&&this.keys.push(s),y.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,I.toValuesTree)(this.contents[s],r=>console.error(r))})}}e.ConfigurationModel=f;class E{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,n){if(!P.isUndefinedOrNull(s)){const i=this.doParseContent(s);this.parseRaw(i,n)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,n){this._raw=s;const{contents:i,keys:r,overrides:a,restricted:w,hasExcludedProperties:S}=this.doParseRaw(s,n);this._configurationModel=new f(i,r,a,S?[s]:void 0),this._restrictedConfigurations=w||[]}doParseContent(s){let n={},i=null,r=[];const a=[],w=[];function S(C){Array.isArray(r)?r.push(C):i!==null&&(r[i]=C)}const l={onObjectBegin:()=>{const C={};S(C),a.push(r),r=C,i=null},onObjectProperty:C=>{i=C},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const C=[];S(C),a.push(r),r=C,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:S,onError:(C,U,N)=>{w.push({error:C,offset:U,length:N})}};if(s)try{T.visit(s,l),n=r[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return n}doParseRaw(s,n){const i=g.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),r=this.filter(s,i,!0,n);s=r.raw;const a=(0,I.toValuesTree)(s,l=>console.error(`Conflict in settings file ${this._name}: ${l}`)),w=Object.keys(s),S=this.toOverrides(s,l=>console.error(`Conflict in settings file ${this._name}: ${l}`));return{contents:a,keys:w,overrides:S,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(s,n,i,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:a};const w={},S=[];for(const l in s)if(y.OVERRIDE_PROPERTY_REGEX.test(l)&&i){const C=this.filter(s[l],n,!1,r);w[l]=C.raw,a=a||C.hasExcludedProperties,S.push(...C.restricted)}else{const C=n[l],U=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&S.push(l),!r.exclude?.includes(l)&&(r.include?.includes(l)||(U===void 0||r.scopes===void 0||r.scopes.includes(U))&&!(r.skipRestricted&&C?.restricted))?w[l]=s[l]:a=!0}return{raw:w,restricted:S,hasExcludedProperties:a}}toOverrides(s,n){const i=[];for(const r of Object.keys(s))if(y.OVERRIDE_PROPERTY_REGEX.test(r)){const a={};for(const w in s[r])a[w]=s[r][w];i.push({identifiers:(0,y.overrideIdentifiersFromKey)(r),keys:Object.keys(a),contents:(0,I.toValuesTree)(a,n)})}return i}}e.ConfigurationModelParser=E;class c extends A.Disposable{constructor(s,n,i,r){super(),this.userSettingsResource=s,this.parseOptions=n,this.fileService=r,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&i.isEqual(a.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new f}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=c;class u{constructor(s,n,i,r,a,w,S,l,C,U,N,F,$){this.key=s,this.overrides=n,this._value=i,this.overrideIdentifiers=r,this.defaultConfiguration=a,this.policyConfiguration=w,this.applicationConfiguration=S,this.userConfiguration=l,this.localUserConfiguration=C,this.remoteUserConfiguration=U,this.workspaceConfiguration=N,this.folderConfigurationModel=F,this.memoryConfigurationModel=$}get value(){return h(this._value)}inspect(s,n,i){const r=s.inspect(n,i);return{get value(){return h(r.value)},get override(){return h(r.override)},get merged(){return h(r.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class d{constructor(s,n,i,r,a=new f,w=new f,S=new _.ResourceMap,l=new f,C=new _.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=n,this._applicationConfiguration=i,this._localUserConfiguration=r,this._remoteUserConfiguration=a,this._workspaceConfiguration=w,this._folderConfigurations=S,this._memoryConfiguration=l,this._memoryConfigurationByResource=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(s,n,i){return this.getConsolidatedConfigurationModel(s,n,i).getValue(s)}updateValue(s,n,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new f,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(s):r.setValue(s,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,n,i){const r=this.getConsolidatedConfigurationModel(s,n,i),a=this.getFolderConfigurationModelForResource(n.resource,i),w=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,S=new Set;for(const l of r.overrides)for(const C of l.identifiers)r.getOverrideValue(s,C)!==void 0&&S.add(C);return new u(s,n,r.getValue(s),S.size?[...S]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this._workspaceConfiguration:void 0,a||void 0,w)}keys(s){const n=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,n){this._folderConfigurations.set(s,n),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const i=[];if(!n){const{added:r,updated:a,removed:w}=L(this._defaultConfiguration,s);n=[...r,...a,...w]}for(const r of n)for(const a of(0,y.overrideIdentifiersFromKey)(r)){const w=this._defaultConfiguration.getKeysForOverrideIdentifier(a),S=s.getKeysForOverrideIdentifier(a),l=[...S.filter(C=>w.indexOf(C)===-1),...w.filter(C=>S.indexOf(C)===-1),...w.filter(C=>!R.equals(this._defaultConfiguration.override(a).getValue(C),s.override(a).getValue(C)))];i.push([a,l])}return this.updateDefaultConfiguration(s),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:i,removed:r}=L(this._policyConfiguration,s),a=[...n,...i,...r];return a.length&&this.updatePolicyConfiguration(s),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:i,removed:r,overrides:a}=L(this.applicationConfiguration,s),w=[...n,...i,...r];return w.length&&this.updateApplicationConfiguration(s),{keys:w,overrides:a}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:i,removed:r,overrides:a}=L(this.localUserConfiguration,s),w=[...n,...i,...r];return w.length&&this.updateLocalUserConfiguration(s),{keys:w,overrides:a}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:i,removed:r,overrides:a}=L(this.remoteUserConfiguration,s),w=[...n,...i,...r];return w.length&&this.updateRemoteUserConfiguration(s),{keys:w,overrides:a}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:i,removed:r,overrides:a}=L(this.workspaceConfiguration,s),w=[...n,...i,...r];return w.length&&this.updateWorkspaceConfiguration(s),{keys:w,overrides:a}}compareAndUpdateFolderConfiguration(s,n){const i=this.folderConfigurations.get(s),{added:r,updated:a,removed:w,overrides:S}=L(i,n),l=[...r,...a,...w];return(l.length||!i)&&this.updateFolderConfiguration(s,n),{keys:l,overrides:S}}compareAndDeleteFolderConfiguration(s){const n=this.folderConfigurations.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:i,updated:r,removed:a,overrides:w}=L(n,void 0);return{keys:[...i,...r,...a],overrides:w}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,n,i){let r=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:s},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&s){const r=n.getFolder(s);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const a=this._memoryConfigurationByResource.get(s);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let n=this._foldersConsolidatedConfigurations.get(s);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(s);r?(n=i.merge(r),this._foldersConsolidatedConfigurations.set(s,n)):n=i}return n}getFolderConfigurationModelForResource(s,n){if(n&&s){const i=n.getFolder(s);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,n)=>{const{contents:i,overrides:r,keys:a}=this._folderConfigurations.get(n);return s.push([n,{contents:i,overrides:r,keys:a}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this._workspaceConfiguration.keys.forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(i=>s.add(i))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(i=>s.add(i))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r))),[...n.values()]}static parse(s){const n=this.parseConfigurationModel(s.defaults),i=this.parseConfigurationModel(s.policy),r=this.parseConfigurationModel(s.application),a=this.parseConfigurationModel(s.user),w=this.parseConfigurationModel(s.workspace),S=s.folders.reduce((l,C)=>(l.set(m.URI.revive(C[0]),this.parseConfigurationModel(C[1])),l),new _.ResourceMap);return new d(n,i,r,a,new f,w,S,new f,new _.ResourceMap)}static parseConfigurationModel(s){return new f(s.contents,s.keys,s.overrides)}}e.Configuration=d;function v(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,n=new Map;for(const r of o)r.keys.forEach(a=>s.add(a)),r.overrides.forEach(([a,w])=>{const S=(0,_.getOrSet)(n,a,new Set);w.forEach(l=>S.add(l))});const i=[];return n.forEach((r,a)=>i.push([a,[...r.values()]])),{keys:[...s.values()],overrides:i}}e.mergeChanges=v;class p{constructor(s,n,i,r){this.change=s,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=r,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const a of s.keys)this.affectedKeys.add(a);for(const[,a]of s.overrides)for(const w of a)this.affectedKeys.add(w);this._affectsConfigStr=this._marker;for(const a of this.affectedKeys)this._affectsConfigStr+=a+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,n){const i=this._marker+s,r=this._affectsConfigStr.indexOf(i);if(r<0)return!1;const a=r+i.length;if(a>=this._affectsConfigStr.length)return!1;const w=this._affectsConfigStr.charCodeAt(a);if(w!==this._markerCode1&&w!==this._markerCode2)return!1;if(n){const S=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(s,n,this.currentWorkspace);return!R.equals(S,l)}return!0}}e.ConfigurationChangeEvent=p;function L(o,s){const{added:n,removed:i,updated:r}=t(s?.rawConfiguration,o?.rawConfiguration),a=[],w=o?.getAllOverrideIdentifiers()||[],S=s?.getAllOverrideIdentifiers()||[];if(s){const l=S.filter(C=>!w.includes(C));for(const C of l)a.push([C,s.getKeysForOverrideIdentifier(C)])}if(o){const l=w.filter(C=>!S.includes(C));for(const C of l)a.push([C,o.getKeysForOverrideIdentifier(C)])}if(s&&o){for(const l of w)if(S.includes(l)){const C=t({contents:o.getOverrideValue(void 0,l)||{},keys:o.getKeysForOverrideIdentifier(l)},{contents:s.getOverrideValue(void 0,l)||{},keys:s.getKeysForOverrideIdentifier(l)});a.push([l,[...C.added,...C.removed,...C.updated]])}}return{added:n,removed:i,updated:r,overrides:a}}function t(o,s){const n=o?s?o.keys.filter(a=>s.keys.indexOf(a)===-1):[...o.keys]:[],i=s?o?s.keys.filter(a=>o.keys.indexOf(a)===-1):[...s.keys]:[],r=[];if(o&&s){for(const a of s.keys)if(o.keys.indexOf(a)!==-1){const w=(0,I.getConfigurationValue)(s.contents,a),S=(0,I.getConfigurationValue)(o.contents,a);R.equals(w,S)||r.push(a)}}return{added:n,removed:i,updated:r}}}),define(ce[206],le([0,1,20,3,2,30,11,73,49,7,56,40]),function(ie,e,k,O,T,A,_,R,P,m,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class g extends T.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new R.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(y.Registry.as(P.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:u})=>this.onDidUpdateConfiguration(Array.from(c),u))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(c,u){this.updateConfigurationModel(c,y.Registry.as(P.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:c})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new R.ConfigurationModel;const c=y.Registry.as(P.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(c),c)}updateConfigurationModel(c,u){const d=this.getConfigurationDefaultOverrides();for(const v of c){const p=d[v],L=u[v];p!==void 0?this._configurationModel.addValue(v,p):L?this._configurationModel.addValue(v,L.default):this._configurationModel.removeValue(v)}}}e.DefaultConfiguration=g;class h{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=h;let f=class extends T.Disposable{get configurationModel(){return this._configurationModel}constructor(c,u,d){super(),this.defaultConfiguration=c,this.policyService=u,this.logService=d,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new R.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(c=>this.onDidChangePolicies(c))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:c})=>this.update(await this.updatePolicyDefinitions(c),!0))),this._configurationModel}async updatePolicyDefinitions(c){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",c);const u={},d=[],v=y.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(const p of c){const L=v[p];if(!L){d.push(p);continue}if(L.policy){if(L.type!=="string"&&L.type!=="number"){this.logService.warn(`Policy ${L.policy.name} has unsupported type ${L.type}`);continue}d.push(p),u[L.policy.name]={type:L.type}}}return(0,_.isEmptyObject)(u)||await this.policyService.updatePolicyDefinitions(u),d}onDidChangePolicies(c){this.logService.trace("PolicyConfiguration#onDidChangePolicies",c);const u=y.Registry.as(P.Extensions.Configuration).getPolicyConfigurations(),d=(0,k.coalesce)(c.map(v=>u.get(v)));this.update(d,!0)}update(c,u){this.logService.trace("PolicyConfiguration#update",c);const d=y.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),v=[],p=this._configurationModel.isEmpty();for(const L of c){const t=d[L]?.policy?.name;if(t){const o=this.policyService.getPolicyValue(t);(p?o!==void 0:!(0,A.equals)(this._configurationModel.getValue(L),o))&&v.push([L,o])}else this._configurationModel.getValue(L)!==void 0&&v.push([L,void 0])}if(v.length){this.logService.trace("PolicyConfiguration#changed",v);const L=this._configurationModel;this._configurationModel=new R.ConfigurationModel;for(const t of L.keys)this._configurationModel.setValue(t,L.getValue(t));for(const[t,o]of v)o===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,o);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=f,e.PolicyConfiguration=f=ye([K(1,I.IPolicyService),K(2,m.ILogService)],f)}),define(ce[207],le([0,1,5,3,2,22,18,73,206,56]),function(ie,e,k,O,T,A,_,R,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends T.Disposable{constructor(g,h,f,E){super(),this.settingsResource=g,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new P.DefaultConfiguration),this.policyConfiguration=f instanceof m.NullPolicyService?new P.NullPolicyConfiguration:this._register(new P.PolicyConfiguration(this.defaultConfiguration,f,E)),this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,{},A.extUriBiasedIgnorePathCase,h)),this.configuration=new R.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:c,properties:u})=>this.onDidDefaultConfigurationChange(c,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(c=>this.onDidPolicyConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[g,h,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new R.Configuration(g,h,new R.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(g,h){const f=typeof g=="string"?g:void 0,E=(0,_.isConfigurationOverrides)(g)?g:(0,_.isConfigurationOverrides)(h)?h:{};return this.configuration.getValue(f,E,void 0)}updateValue(g,h,f,E){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const h=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(f,h,2)}onDidDefaultConfigurationChange(g,h){const f=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(g,h);this.trigger(E,f,7)}onDidPolicyConfigurationChange(g){const h=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(g);this.trigger(f,h,7)}trigger(g,h,f){const E=new R.ConfigurationChangeEvent(g,{data:h},this.configuration);E.source=f,E.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(g){switch(g){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(ce[208],le([0,1,14,3,2,65]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.connectManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const _=(m,I,y)=>{const g=new Uint8Array(16);for(let E=0;E<16;E++)g[E]=Math.round(Math.random()*256);const h=(0,k.encodeBase64)(k.VSBuffer.wrap(g));return[`GET ws://localhost${m}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=_,e.socketRawEndHeaderSequence=k.VSBuffer.fromString(`\r
\r
`);async function R(m,I,y,g,h){m.write(k.VSBuffer.fromString((0,e.makeRawSocketHeaders)(I,y,g)));const f=new T.DisposableStore;try{return await new Promise((E,c)=>{let u;f.add(m.onData(d=>{u?u=k.VSBuffer.concat([u,d],u.byteLength+d.byteLength):u=d;const v=u.indexOf(e.socketRawEndHeaderSequence);if(v===-1)return;E(m),m.pauseData();const p=u.slice(v+e.socketRawEndHeaderSequence.byteLength);p.byteLength&&h.onData.fire(p)})),f.add(m.onClose(d=>c(d??new Error("socket closed")))),f.add(m.onEnd(()=>c(new Error("socket ended"))))})}catch(E){throw m.dispose(),E}finally{f.dispose()}}e.connectManagedSocket=R;class P extends T.Disposable{constructor(I,y){super(),this.debugLabel=I,this.pausableDataEmitter=this._register(new O.PauseableEmitter),this.onData=(...g)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...g)),this.didDisposeEmitter=this._register(new O.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(y.onData),this._register(y.onData.event(g=>this.pausableDataEmitter.fire(g))),this.onClose=this._register(y.onClose).event,this.onEnd=this._register(y.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(I,y){A.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,I,y)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=P}),define(ce[209],le([0,1,8,4]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var T;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(T||(e.RemoteConnectionType=T={}));class A{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class _{constructor(y,g){this.host=y,this.port=g,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=_;var R;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class P extends k.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof P&&y._code===R.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof P&&y._code===R.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof P&&y._code===R.NoResolverFound}static isInvalidAuthority(y){return y instanceof P&&y._code===R.InvalidAuthority}static isHandled(y){return y instanceof P&&y.isHandled}constructor(y,g=R.Unknown,h){super(y),this._message=y,this._code=g,this._detail=h,this.isHandled=g===R.NotAvailable&&h===!0,Object.setPrototypeOf(this,P.prototype)}}e.RemoteAuthorityResolverError=P;function m(I){const y=I.indexOf("+");return y===-1?I:I.substring(0,y)}e.getRemoteAuthorityPrefix=m}),define(ce[74],le([0,1,26]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(m){return m.scheme===k.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=O;function T(m){if(!m)return;const I=m.indexOf("+");return I<0?m:m.substr(0,I)}e.getRemoteName=T;function A(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=A;function _(m){const{host:I,port:y}=P(m);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:y}}e.parseAuthorityWithPort=_;function R(m,I){let{host:y,port:g}=P(m);return typeof g>"u"&&(g=I),{host:y,port:g}}e.parseAuthorityWithOptionalPort=R;function P(m){const I=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const y=m.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const g=m.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:m,port:void 0}}}),define(ce[45],le([0,1,28,4,74]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(_||(e.ExtensionType=_={}));var R;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.LINUX_PPC64LE="linux-ppc64le",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class P{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,u){if(typeof c>"u"||c===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof c=="string"||typeof u=="string"){const d=typeof c=="string"?c:c.value,v=typeof u=="string"?u:u.value;return k.equalsIgnoreCase(d,v)}return c._lower===u._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.ExtensionIdentifier=P;class m{get size(){return this._set.size}constructor(c){if(this._set=new Set,c)for(const u of c)this.add(u)}add(c){this._set.add(P.toKey(c))}delete(c){return this._set.delete(P.toKey(c))}has(c){return this._set.has(P.toKey(c))}}e.ExtensionIdentifierSet=m;class I{constructor(){this._map=new Map}clear(){this._map.clear()}delete(c){this._map.delete(P.toKey(c))}get(c){return this._map.get(P.toKey(c))}has(c){return this._map.has(P.toKey(c))}set(c,u){this._map.set(P.toKey(c),u)}values(){return this._map.values()}forEach(c){this._map.forEach(c)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=I;function y(E){return g(E)}e.isApplicationScopedExtension=y;function g(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=g;function h(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=h;function f(E,c){if(c){const u=`onResolveRemoteAuthority:${(0,T.getRemoteName)(c)}`;return!!E.activationEvents?.includes(u)}return!1}e.isResolverExtension=f,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(ce[210],le([0,1,2,45,13]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends k.Disposable{constructor(R,P,m,I,y){super(),this.userDataProfilesService=R,this.fileService=P,this.uriIdentityService=m,this.logService=y,this._register(I.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(I.onDidUninstallExtension(g=>this.onDidUnInstallExtension(g)))}onDidInstallExtensions(R){for(const P of R)P.local&&this.invalidate(P.profileLocation)}onDidUnInstallExtension(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const P of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(P.extensionsResource,R)&&await this.deleteUserCacheFile(P);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(R){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(R.cacheHome,O.USER_MANIFEST_CACHE_FILE))}catch(P){(0,T.toFileOperationResult)(P)!==1&&this.logService.error(P)}}}e.ExtensionsManifestCache=A}),define(ce[211],le([0,1,5,14,25,8,3,2,100,60,32,65,209,74]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const f=30*1e3;var E;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(E||(e.ConnectionType=E={}));function c(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(W){const b=new T.CancellationTokenSource;return setTimeout(()=>b.cancel(),W),b.token}function d(W,b){if(W.isCancellationRequested||b.isCancellationRequested)return T.CancellationToken.Cancelled;const D=new T.CancellationTokenSource;return W.onCancellationRequested(()=>D.cancel()),b.onCancellationRequested(()=>D.cancel()),D.token}class v{get didTimeout(){return this._state==="timedout"}constructor(b){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((D,M)=>{this._resolvePromise=D,this._rejectPromise=M}),b.isCancellationRequested?this._timeout():this._disposables.add(b.onCancellationRequested(()=>this._timeout()))}registerDisposable(b){this._state==="pending"?this._disposables.add(b):b.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const b=new Error("Time limit reached");return b.code="ETIMEDOUT",b.syscall="connect",b}resolve(b){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(b))}reject(b){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(b))}}function p(W,b){const D=new v(b);return D.registerDisposable(W.onControlMessage(M=>{const V=JSON.parse(M.toString()),ee=j(V);ee?D.reject(ee):D.resolve(V)})),D.promise}function L(W,b,D,M,V,ee,ne,de){const X=new v(de),se=m.StopWatch.create(!1);return W.info(`Creating a socket (${ne})...`),P.mark(`code/willCreateSocket/${ee}`),b.connect(D,M,V,ne).then(te=>{X.didTimeout?(P.mark(`code/didCreateSocketError/${ee}`),W.info(`Creating a socket (${ne}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(P.mark(`code/didCreateSocketOK/${ee}`),W.info(`Creating a socket (${ne}) was successful after ${se.elapsed()} ms.`),X.resolve(te))},te=>{P.mark(`code/didCreateSocketError/${ee}`),W.info(`Creating a socket (${ne}) returned an error after ${se.elapsed()} ms.`),W.error(te),X.reject(te)}),X.promise}function t(W,b){const D=new v(b);return W.then(M=>{D.didTimeout||D.resolve(M)},M=>{D.didTimeout||D.reject(M)}),D.promise}async function o(W,b,D,M){const V=ae(W,b);W.logService.trace(`${V} 1/6. invoking socketFactory.connect().`);let ee;try{ee=await L(W.logService,W.remoteSocketFactoryService,W.connectTo,(0,h.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,c(b),`renderer-${c(b)}-${W.reconnectionToken}`,M)}catch(te){throw W.logService.error(`${V} socketFactory.connect() failed or timed out. Error:`),W.logService.error(te),te}W.logService.trace(`${V} 2/6. socketFactory.connect() was successful.`);let ne,de;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(ee,null),ne=W.reconnectionProtocol,de=!1):(ne=new y.PersistentProtocol({socket:ee}),de=!0),W.logService.trace(`${V} 3/6. sending AuthRequest control message.`);const X=await t(W.signService.createNewMessage((0,I.generateUuid)()),M),se={type:"auth",auth:W.connectionToken||"00000000000000000000",data:X.data};ne.sendControl(O.VSBuffer.fromString(JSON.stringify(se)));try{const te=await p(ne,d(M,u(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(W.logService.trace(`${V} 4/6. received SignRequest control message.`),!await t(W.signService.validate(X,te.signedData),M)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const fe=await t(W.signService.sign(te.data),M),pe={type:"connectionType",commit:W.commit,signedData:fe,desiredConnectionType:b};return D&&(pe.args=D),W.logService.trace(`${V} 5/6. sending ConnectionTypeRequest control message.`),ne.sendControl(O.VSBuffer.fromString(JSON.stringify(pe))),{protocol:ne,ownsProtocol:de}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(W.logService.error(`${V} the handshake timed out. Error:`),W.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${V} received error control message when negotiating connection. Error:`),W.logService.error(te)),de&&x(ne),te}}async function s(W,b,D,M){const V=Date.now(),ee=ae(W,b),{protocol:ne,ownsProtocol:de}=await o(W,b,D,M),X=new v(M);return X.registerDisposable(ne.onControlMessage(se=>{const te=JSON.parse(se.toString()),he=j(te);he?(W.logService.error(`${ee} received error control message when negotiating connection. Error:`),W.logService.error(he),de&&x(ne),X.reject(he)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${G(V)}!`),X.resolve({protocol:ne,firstMessage:te}))})),X.promise}async function n(W,b){const{protocol:D}=await s(W,1,void 0,b);return{protocol:D}}async function i(W,b,D){const{protocol:M,firstMessage:V}=await s(W,2,b,D),ee=V&&V.debugPort;return{protocol:M,debugPort:ee}}async function r(W,b,D){const M=Date.now(),V=ae(W,3),{protocol:ee}=await o(W,3,b,D);return W.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${G(M)}!`),ee}async function a(W,b,D){const{connectTo:M,connectionToken:V}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,connectTo:M,connectionToken:V,reconnectionToken:b,reconnectionProtocol:D,remoteSocketFactoryService:W.remoteSocketFactoryService,signService:W.signService,logService:W.logService}}async function w(W,b,D){return l(W,async M=>{const{protocol:V}=await n(M,T.CancellationToken.None);return new B(W,b,D,M.reconnectionToken,V)})}e.connectRemoteAgentManagement=w;async function S(W,b){return l(W,async D=>{const{protocol:M,debugPort:V}=await i(D,b,T.CancellationToken.None);return new Y(W,b,D.reconnectionToken,M,V)})}e.connectRemoteAgentExtensionHost=S;async function l(W,b){for(let M=1;;M++)try{const V=(0,I.generateUuid)(),ee=await a(W,V,null);return await b(ee)}catch(V){if(M<5)W.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(V);else throw W.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(V),Q.triggerPermanentFailure(0,0,g.RemoteAuthorityResolverError.isHandled(V)),V}}async function C(W,b,D){const M=await a(W,(0,I.generateUuid)(),null);return await r(M,{host:b,port:D},T.CancellationToken.None)}e.connectRemoteAgentTunnel=C;function U(W){return(0,k.createCancelablePromise)(b=>new Promise((D,M)=>{const V=setTimeout(D,W*1e3);b.onCancellationRequested(()=>{clearTimeout(V),D()})}))}var N;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class F{constructor(b,D){this.reconnectionToken=b,this.millisSinceLastIncomingData=D,this.type=0}}e.ConnectionLostEvent=F;class ${constructor(b,D,M,V){this.reconnectionToken=b,this.millisSinceLastIncomingData=D,this.durationSeconds=M,this.cancellableTimer=V,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=$;class z{constructor(b,D,M){this.reconnectionToken=b,this.millisSinceLastIncomingData=D,this.attempt=M,this.type=2}}e.ReconnectionRunningEvent=z;class J{constructor(b,D,M){this.reconnectionToken=b,this.millisSinceLastIncomingData=D,this.attempt=M,this.type=4}}e.ConnectionGainEvent=J;class H{constructor(b,D,M,V){this.reconnectionToken=b,this.millisSinceLastIncomingData=D,this.attempt=M,this.handled=V,this.type=3}}e.ReconnectionPermanentFailureEvent=H;class Q extends R.Disposable{static triggerPermanentFailure(b,D,M){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=b,this._permanentFailureAttempt=D,this._permanentFailureHandled=M,this._instances.forEach(V=>V._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(b=>b._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(b=>b._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||Q._permanentFailure}constructor(b,D,M,V,ee){super(),this._connectionType=b,this._options=D,this.reconnectionToken=M,this.protocol=V,this._reconnectionFailureIsFatal=ee,this._onDidStateChange=this._register(new _.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new J(this.reconnectionToken,0,0)),this._register(V.onSocketClose(ne=>{const de=oe(this._connectionType,this.reconnectionToken,!0);ne?ne.type===0?(this._options.logService.info(`${de} received socket close event (hadError: ${ne.hadError}).`),ne.error&&this._options.logService.error(ne.error)):(this._options.logService.info(`${de} received socket close event (wasClean: ${ne.wasClean}, code: ${ne.code}, reason: ${ne.reason}).`),ne.event&&this._options.logService.error(ne.event)):this._options.logService.info(`${de} received socket close event.`),this._beginReconnecting()})),this._register(V.onSocketTimeout(ne=>{const de=oe(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${de} received socket timeout event (unacknowledgedMsgCount: ${ne.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ne.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ne.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),Q._instances.push(this),this._register((0,R.toDisposable)(()=>{const ne=Q._instances.indexOf(this);ne>=0&&Q._instances.splice(ne,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(Q._permanentFailureMillisSinceLastIncomingData,Q._permanentFailureAttempt,Q._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const b=oe(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${b} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const V=M<D.length?D[M]:D[D.length-1];try{if(V>0){const ne=U(V);this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V,ne)),this._options.logService.info(`${b} waiting for ${V} seconds before reconnecting...`);try{await ne}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${b} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this._options.logService.info(`${b} resolving connection...`);const ee=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${b} connecting to ${ee.connectTo}...`),await this._reconnect(ee,u(f)),this._options.logService.info(`${b} reconnected!`),this._onDidStateChange.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${b} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ee),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this._options.logService.error(`${b} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ee),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(g.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ee)){this._options.logService.info(`${b} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this._options.logService.info(`${b} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((0,A.isCancellationError)(ee)){this._options.logService.info(`${b} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if(ee instanceof g.RemoteAuthorityResolverError){this._options.logService.error(`${b} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ee),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,g.RemoteAuthorityResolverError.isHandled(ee));break}this._options.logService.error(`${b} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ee),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(b,D,M){this._reconnectionFailureIsFatal?Q.triggerPermanentFailure(b,D,M):this._gotoPermanentFailure(b,D,M)}_gotoPermanentFailure(b,D,M){this._onDidStateChange.fire(new H(this.reconnectionToken,b,D,M)),x(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=Q;class B extends Q{constructor(b,D,M,V,ee){super(1,b,V,ee,!0),this.client=this._register(new y.Client(ee,{remoteAuthority:D,clientId:M},b.ipcLogger))}async _reconnect(b,D){await n(b,D)}}e.ManagementPersistentConnection=B;class Y extends Q{constructor(b,D,M,V,ee){super(2,b,M,V,!1),this._startArguments=D,this.debugPort=ee}async _reconnect(b,D){await i(b,this._startArguments,D)}}e.ExtensionHostPersistentConnection=Y;function x(W){try{W.acceptDisconnect();const b=W.getSocket();W.dispose(),b.dispose()}catch(b){(0,A.onUnexpectedError)(b)}}function j(W){if(W&&W.type==="error"){const b=new Error(`Connection error: ${W.reason}`);return b.code="VSCODE_CONNECTION_ERROR",b}return null}function q(W,b){for(;W.length<b;)W+=" ";return W}function Z(W,b){return`[remote-connection][${q(c(W),13)}][${b.substr(0,5)}\u2026]`}function oe(W,b,D){return`${Z(W,b)}[${D?"reconnect":"initial"}]`}function ae(W,b){return`${oe(b,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.connectTo}]`}function G(W){return`${Date.now()-W} ms`}}),define(ce[104],le([0,1,2,4]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,O.createDecorator)("remoteSocketFactoryService");class T{constructor(){this.factories={}}register(_,R){return this.factories[_]??=[],this.factories[_].push(R),(0,k.toDisposable)(()=>{const P=this.factories[_]?.indexOf(R);typeof P=="number"&&P>=0&&this.factories[_]?.splice(P,1)})}getSocketFactory(_){return(this.factories[_.type]||[]).find(P=>P.supports(_))}connect(_,R,P,m){const I=this.getSocketFactory(_);if(!I)throw new Error(`No socket factory found for ${_}`);return I.connect(_,R,P,m)}}e.RemoteSocketFactoryService=T}),define(ce[212],le([0,1,4]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ce[105],le([0,1,4,162]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.INACTIVE_TUNNEL_MODE=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,k.createDecorator)("IRemoteTunnelService"),e.INACTIVE_TUNNEL_MODE={active:!1};var T;(function(A){A.disconnected=_=>({type:"disconnected",onTokenFailed:_}),A.connected=(_,R)=>({type:"connected",info:_,serviceInstallFailed:R}),A.connecting=_=>({type:"connecting",progress:_}),A.uninitialized={type:"uninitialized"}})(T||(e.TunnelStates=T={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,O.localize)(0,null)}),define(ce[57],le([0,1,14,8,2,164,49,4,7,40]),function(ie,e,k,O,T,A,_,R,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");class I{constructor(L){this.original=L}toJSON(){if(!this.headers){const L=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?L[t]="*****":L[t]=this.original[t];this.headers=L}return this.headers}}class y extends T.Disposable{constructor(L){super(),this.counter=0,this.logger=L.createLogger("network",{name:(0,A.localize)(0,null),when:P.CONTEXT_LOG_LEVEL.isEqualTo((0,P.LogLevelToString)(P.LogLevel.Trace)).serialize()})}async logAndRequest(L,t,o){const s=`${L} #${++this.counter}: ${t.url}`;this.logger.trace(`${s} - begin`,t.type,new I(t.headers??{}));try{const n=await o();return this.logger.trace(`${s} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.logger.error(`${s} - error`,t.type,(0,O.getErrorMessage)(n)),n}}}e.AbstractRequestService=y;function g(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=g;function h(p){return p.res.statusCode===204}async function f(p){return h(p)?null:(await(0,k.streamToBuffer)(p.stream)).toString()}e.asText=f;async function E(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);return f(p)}e.asTextOrError=E;async function c(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);if(h(p))return null;const t=(await(0,k.streamToBuffer)(p.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.asJson=c;function u(p){v(p)}e.updateProxyConfigurationsScope=u;let d;function v(p){const L=m.Registry.as(_.Extensions.Configuration),t=d;d={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},L.updateConfigurations({add:[d],remove:t?[t]:[]})}v(1)}),define(ce[213],le([0,1,25,26,13,57]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let _=class{constructor(P,m){this.requestService=P,this.fileService=m}async download(P,m,I=k.CancellationToken.None){if(P.scheme===O.Schemas.file||P.scheme===O.Schemas.vscodeRemote){await this.fileService.copy(P,m);return}const y={type:"GET",url:P.toString(!0)},g=await this.requestService.request(y,I);if(g.res.statusCode===200)await this.fileService.writeFile(m,g.stream);else{const h=await(0,A.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${h}`)}}};e.DownloadService=_,e.DownloadService=_=ye([K(0,A.IRequestService),K(1,T.IFileService)],_)}),define(ce[214],le([0,1,14,25]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class T{constructor(R){this.service=R}listen(R,P){throw new Error("Invalid listen")}call(R,P,m,I=O.CancellationToken.None){switch(P){case"request":return this.service.request(m[0],I).then(async({res:y,stream:g})=>{const h=await(0,k.streamToBuffer)(g);return[{statusCode:y.statusCode,headers:y.headers},h]});case"resolveProxy":return this.service.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=T;class A{constructor(R){this.channel=R}async request(R,P){const[m,I]=await this.channel.call("request",[R],P);return{res:m,stream:(0,k.bufferToStream)(I)}}async resolveProxy(R){return this.channel.call("resolveProxy",[R])}}e.RequestChannelClient=A}),define(ce[215],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ce[216],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class k{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(T){try{const A=await this.getValidator();if(A){const _=String(k._nextId++);return this.validators.set(_,A),{id:_,data:A.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,A){if(!T.id)return!0;const _=this.validators.get(T.id);if(!_)return!1;this.validators.delete(T.id);try{return _.validate(A)==="ok"}catch{return!1}finally{_.dispose?.()}}async sign(T){try{return await this.signValue(T)}catch{}return T}}e.AbstractSignService=k}),define(ce[106],le([0,1,4]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(ce[217],le([0,1,216]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class O extends k.AbstractSignService{getValidator(){return this.vsda().then(A=>new A.validator)}signValue(A){return this.vsda().then(_=>new _.signer().sign(A))}vsda(){return new Promise((A,_)=>ie(["vsda"],A,_))}}e.SignService=O}),define(ce[75],le([0,1,3,2]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class T extends O.Disposable{constructor(y,g,h){super(),this.channel=y,this.profile=g,this.workspace=h}async getItems(){const y={profile:this.profile,workspace:this.workspace},g=await this.channel.call("getItems",y);return new Map(g)}updateItems(y){const g={profile:this.profile,workspace:this.workspace};return y.insert&&(g.insert=Array.from(y.insert.entries())),y.delete&&(g.delete=Array.from(y.delete.values())),this.channel.call("updateItems",g)}}class A extends T{constructor(y,g){super(y,g,void 0),this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(y=>this.onDidChangeStorage(y)))}onDidChangeStorage(y){(Array.isArray(y.changed)||Array.isArray(y.deleted))&&this._onDidChangeItemsExternal.fire({changed:y.changed?new Map(y.changed):void 0,deleted:y.deleted?new Set(y.deleted):void 0})}}class _ extends A{constructor(y){super(y,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=_;class R extends A{constructor(y,g){super(y,g)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class P extends T{constructor(y,g){super(y,void 0,g),this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P;class m{constructor(y){this.channel=y}isUsed(y){const g={payload:y,profile:void 0,workspace:void 0};return this.channel.call("isUsed",g)}}e.StorageClient=m}),define(ce[107],le([0,1,6,37,32]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(P){if(k.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}function _(P,m,I,y,g,h,f,E){const c=Object.create(null);c["common.machineId"]=h,c.sessionID=(0,T.generateUuid)()+Date.now(),c.commitHash=y,c.version=g,c["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,k.PlatformToString)(k.platform),c["common.nodePlatform"]=O.platform,c["common.nodeArch"]=I,c["common.product"]=E||"desktop",f&&(c["common.msftInternal"]=f);let u=0;const d=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),k.isLinuxSnap&&(c["common.snap"]="true");const v=A(m);return v&&(c["common.platformDetail"]=v),c}e.resolveCommonProperties=_;function R(P){const m=O.env.USERDNSDOMAIN;if(!m)return!1;const I=m.toLowerCase();return P.some(y=>I===y)}e.verifyMicrosoftInternalDomain=R}),define(ce[21],le([0,1,4]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var T;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(T||(e.TelemetryConfiguration=T={}))}),define(ce[218],le([0,1,36,5,34,26,16,6,10,130,31,144,95,13,23,21]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const c=new Map;async function u(t,o){const s=`${t}::${o.join(":")}`,n=c.get(s);if(n)return n;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,w=2e4;function S(C,U,N,F){const $=U.substring(C.length+1);return O.Promises.withAsyncBody(async z=>{let J;try{J=await I.Promises.readdir(U,{withFileTypes:!0})}catch{z();return}if(F.count>=w){F.count+=J.length,F.maxReached=!0,z();return}let H=J.length;if(H===0){z();return}let Q=J;F.count+J.length>w&&(F.maxReached=!0,H=w-F.count,Q=J.slice(0,H)),F.count+=J.length;for(const B of Q)if(B.isDirectory()){if(N.includes(B.name)||await S(C,(0,_.join)(U,B.name),N,F),--H===0){z();return}}else{const Y=B.name.lastIndexOf(".");if(Y>=0){const x=B.name.substring(Y+1);x&&r.set(x,(r.get(x)??0)+1)}for(const x of i)x.relativePathPattern?.test($)!==!1&&x.filePattern.test(B.name)&&a.set(x.tag,(a.get(x.tag)??0)+1);if(--H===0){z();return}}})}const l=O.Promises.withAsyncBody(async C=>{const U={count:0,maxReached:!1};await S(t,t,o,U);const N=await p(t);C({configFiles:d(a),fileTypes:d(r),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:N})});return c.set(s,l),l}e.collectWorkspaceStats=u;function d(t){return Array.from(t.entries(),([o,s])=>({name:o,count:s})).sort((o,s)=>s.count-o.count)}function v(){const t={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},o=k.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.getMachineInfo=v;async function p(t){try{const o=new Map,s=(0,_.join)(t,".vscode","launch.json"),n=await I.Promises.readFile(s),i=[],r=(0,T.parse)(n.toString(),i);if(i.length)return console.log(`Unable to parse ${s}`),[];if((0,T.getNodeType)(r)==="object"&&r.configurations)for(const a of r.configurations){const w=a.type;w&&(o.has(w)?o.set(w,o.get(w)+1):o.set(w,1))}return d(o)}catch{return[]}}e.collectLaunchConfigs=p;let L=class{constructor(o,s){this.telemetryService=o,this.productService=s}formatMachineInfo(o){const s=[];return s.push(`OS Version:       ${o.os}`),s.push(`CPUs:             ${o.cpus}`),s.push(`Memory (System):  ${o.memory}`),s.push(`VM:               ${o.vmHint}`),s.join(`
`)}formatEnvironment(o){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const n=k.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||s.push(`Load (avg):       ${k.loadavg().map(i=>Math.round(i)).join(", ")}`),s.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${o.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(o,s){return Promise.all([(0,y.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async n=>{let[i,r]=n,a=this.formatProcessList(o,i);return s.forEach(w=>{if((0,g.isRemoteDiagnosticError)(w))a+=`
${w.errorMessage}`,r+=`
${w.errorMessage}`;else if(a+=`

Remote: ${w.hostName}`,w.processes&&(a+=`
${this.formatProcessList(o,w.processes)}`),w.workspaceMetadata){r+=`
|  Remote: ${w.hostName}`;for(const S of Object.keys(w.workspaceMetadata)){const l=w.workspaceMetadata[S];let C=`${l.fileCount} files`;l.maxFilesReached&&(C=`more than ${C}`),r+=`|    Folder (${S}): ${C}`,r+=this.formatWorkspaceStats(l)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,s){const{memory:n,vmHint:i,os:r,cpus:a}=v(),w={os:r,memory:n,cpus:a,vmHint:i,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:s};return R.isWindows||(w.load=`${k.loadavg().map(S=>Math.round(S)).join(", ")}`),R.isLinux&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(o,s){const n=[];return(0,y.listProcesses)(o.mainPID).then(async i=>(n.push(""),n.push(this.formatEnvironment(o)),n.push(""),n.push(this.formatProcessList(o,i)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(o))),s.forEach(r=>{if((0,g.isRemoteDiagnosticError)(r))n.push(`
${r.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${r.hostName}`),n.push(this.formatMachineInfo(r.machineInfo)),r.processes&&n.push(this.formatProcessList(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const w=r.workspaceMetadata[a];let S=`${w.fileCount} files`;w.maxFilesReached&&(S=`more than ${S}`),n.push(`Folder (${a}): ${S}`),n.push(this.formatWorkspaceStats(w))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(o){const s=[];let i=0;const r=(l,C)=>{const U=` ${l}(${C})`;i+U.length>60?(s.push(a),a="|                 ",i=a.length):i+=U.length,a+=U};let a="|      File types:";const w=10,S=o.fileTypes.length>w?w:o.fileTypes.length;for(let l=0;l<S;l++){const C=o.fileTypes[l];r(C.name,C.count)}if(s.push(a),o.configFiles.length>=0&&(a="|      Conf files:",i=0,o.configFiles.forEach(l=>{r(l.name,l.count)}),s.push(a)),o.launchConfigFiles.length>0){let l="|      Launch Configs:";o.launchConfigFiles.forEach(C=>{const U=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;l+=U}),s.push(l)}return s.join(`
`)}expandGPUFeatures(o){const s=Math.max(...Object.keys(o).map(n=>n.length));return Object.keys(o).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${o[n]}`).join(`
                  `)}formatWorkspaceMetadata(o){const s=[],n=[];return o.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(s.push(`|  Window (${i.title})`),i.folderURIs.forEach(r=>{const a=P.URI.revive(r);if(a.scheme===A.Schemas.file){const w=a.fsPath;n.push(u(w,["node_modules",".git"]).then(S=>{let l=`${S.fileCount} files`;S.maxFilesReached&&(l=`more than ${l}`),s.push(`|    Folder (${(0,_.basename)(w)}): ${l}`),s.push(this.formatWorkspaceStats(S))}).catch(S=>{s.push(`|      Error: Unable to collect workspace stats for folder ${w} (${S.toString()})`)}))}else s.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(i=>s.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}formatProcessList(o,s){const n=new Map;o.windows.forEach(r=>n.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>n.set(r,a));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(o.mainPID,n,i,s,0),i.join(`
`)}formatProcessItem(o,s,n,i,r){const a=r===0;let w;a?w=i.pid===o?`${this.productService.applicationName} main`:"remote agent":s.has(i.pid)?w=s.get(i.pid):w=`${"  ".repeat(r)} ${i.name}`;const S=process.platform==="win32"?i.mem:k.totalmem()*(i.mem/100);n.push(`${i.load.toFixed(0).padStart(5," ")}	${(S/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(i.children)&&i.children.forEach(l=>this.formatProcessItem(o,s,n,l,r+1))}async getWorkspaceFileExtensions(o){const s=new Set;for(const{uri:n}of o.folders){const i=P.URI.revive(n);if(i.scheme!==A.Schemas.file)continue;const r=i.fsPath;try{(await u(r,["node_modules",".git"])).fileTypes.forEach(w=>s.add(w.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(o){for(const{uri:s}of o.folders){const n=P.URI.revive(s);if(n.scheme!==A.Schemas.file)continue;const i=n.fsPath;try{const r=await u(i,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.DiagnosticsService=L,e.DiagnosticsService=L=ye([K(0,E.ITelemetryService),K(1,f.IProductService)],L)}),define(ce[108],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(A){this.appenders=A}listen(A,_){throw new Error(`Event not found: ${_}`)}call(A,_,{eventName:R,data:P}){return this.appenders.forEach(m=>m.log(R,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class O{constructor(A){this.channel=A}log(A,_){return this.channel.call("log",{eventName:A,data:_}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=O}),define(ce[46],le([0,1,30,11,3,18,74,107,21]),function(ie,e,k,O,T,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=m;class I{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class y{async publicLog(i,r,a){}async publicLogError(i,r,a){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(n,i){return T.Event.debounce(i.onDidChangeConfiguration,(a,w)=>{const S=a?new Set([...a.affectedKeys,...w.affectedKeys]):w.affectedKeys;return{...w,affectedKeys:S}},1e3,!0)(a=>{a.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.configurationTelemetry=g;function h(n,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!n.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=h;function f(n,i){return!(i.isBuilt||i.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.isLoggingOnly=f;function E(n){const i=n.getValue(P.TELEMETRY_SETTING_ID),r=n.getValue(P.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(n.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function c(n){const i={},r={},a={};v(n,a);for(let w in a){w=w.length>150?w.substr(w.length-149):w;const S=a[w];typeof S=="number"?r[w]=S:typeof S=="boolean"?r[w]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${S.length}`),i[w]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(i[w]=S)}return{properties:i,measurements:r}}e.validateTelemetryData=c;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(n){if(!n)return"none";const i=(0,_.getRemoteName)(n);return u.has(i)?i:"other"}e.cleanRemoteAuthority=d;function v(n,i,r=0,a){if(n)for(const w of Object.getOwnPropertyNames(n)){const S=n[w],l=a?a+w:w;Array.isArray(S)?i[l]=(0,k.safeStringify)(S):S instanceof Date?i[l]=S.toISOString():(0,O.isObject)(S)?r<2?v(S,i,r+1,l+"."):i[l]=(0,k.safeStringify)(S):i[l]=S}}function p(n,i){const r=n.msftInternalDomains||[],a=i.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(r)||a}e.isInternalTelemetry=p;function L(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=L;function t(n,i){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let r=n;const a=[];for(const C of i)for(;;){const U=C.exec(n);if(!U)break;a.push([U.index,C.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(r="";;){const C=S.exec(n);if(!C)break;const U=a.some(([N,F])=>C.index<F&&N<S.lastIndex);!w.test(C[0])&&!U&&(r+=n.substring(l,C.index)+"<REDACTED: user-file-path>",l=S.lastIndex)}return l<n.length&&(r+=n.substr(l)),r}function o(n){if(!n)return n;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of i)if(r.regex.test(n))return`<REDACTED: ${r.label}>`;return n}function s(n,i){return(0,k.cloneAndChange)(n,r=>{if(r instanceof m||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=t(a,i);for(const w of i)a=a.replace(w,"");return a=o(a),a}})}e.cleanData=s}),define(ce[33],le([0,1,28,29,45,6,10,8,37,46]),function(ie,e,k,O,T,A,_,R,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,k.compareIgnoreCase)(s.id,n.id)===0}e.areSameExtensions=I;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(n){const i=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new g(n.identifier,i,r)}static parse(n){const i=y.exec(n);return i&&i[1]&&i[2]?new g({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof g?I(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=g;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(s){const n=h.exec(s);return n&&n[1]?[c(n[1]),n[2]]:[c(s),void 0]}e.getIdAndVersion=f;function E(s,n){return`${s}.${n}`}e.getExtensionId=E;function c(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=c;function u(s,n){return c(E(s??T.UNDEFINED_PUBLISHER,n))}e.getGalleryExtensionId=u;function d(s,n){const i=[],r=a=>{for(const w of i)if(w.some(S=>I(n(S),n(a))))return w;return null};for(const a of s){const w=r(a);w?w.push(a):i.push([a])}return i}e.groupByExtension=d;function v(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function p(s){return{id:new m.TelemetryTrustedValue(s.identifier.id),name:new m.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function L(s,n){const i=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&i.every(w=>!I(w.identifier,{id:a}))){const w=s.filter(S=>I(S.identifier,{id:a}));w.length===1&&(i.push(w[0]),r.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=L;async function t(s,n){if(!A.isLinux)return!1;let i;try{i=(await s.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await s.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,n){const i=await t(s,n),r=(0,O.getTargetPlatform)(i?"alpine":A.platform,P.arch);return n.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=o}),define(ce[219],le([0,1,20,2,22,10,13,23,5,3,16,6,37,33]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let f=class extends O.Disposable{constructor(v,p){super(),this.fileService=v,this.productService=p,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,L])=>this.allConfigBasedTips.set(L.configPath,L))}getConfigBasedTips(v){return this.getValidConfigBasedTips(v)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(v){const p=[];for(const[L,t]of this.allConfigBasedTips)if(!(t.configScheme&&t.configScheme!==v.scheme))try{const o=(await this.fileService.readFile((0,T.joinPath)(v,L))).value.toString();for(const[s,n]of Object.entries(t.recommendations))(!n.contentPattern||new RegExp(n.contentPattern,"mig").test(o))&&p.push({extensionId:s,extensionName:n.name,configName:t.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack,whenNotInstalled:n.whenNotInstalled})}catch{}return p}};e.ExtensionTipsService=f,e.ExtensionTipsService=f=ye([K(0,_.IFileService),K(1,R.IProductService)],f);const E="extensionTips/promptedExecutableTips",c="extensionTips/lastPromptedMediumImpExeTime";class u extends f{constructor(v,p,L,t,o,s,n,i){super(n,i),this.userHome=v,this.windowEvents=p,this.telemetryService=L,this.extensionManagementService=t,this.storageService=o,this.extensionRecommendationNotificationService=s,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([r,a])=>{const w=[],S=[],l=[];Object.entries(a.recommendations).forEach(([C,U])=>{U.important?a.important?w.push({extensionId:C,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):S.push({extensionId:C,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):l.push({extensionId:C,extensionName:U.name,isExtensionPack:!!U.isExtensionPack})}),w.length&&this.highImportanceExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w}),S.length&&this.mediumImportanceExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:S}),l.length&&this.allOtherExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:l})}),(0,P.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const v=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),p=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...v,...p]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const v=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),p=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),L=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(v,L),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(p,L)}groupImportantTipsByExe(v,p){const L=new Map;v.forEach(i=>L.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:o}=this.groupByInstalled([...L.keys()],p);for(const i of t){const r=L.get(i);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:r.exeName})}for(const i of o){const r=L.get(i);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:r.exeName})}const s=this.getPromptedExecutableTips(),n=new Map;for(const i of o){const r=L.get(i);if(r&&(!s[r.exeName]||!s[r.exeName].includes(r.extensionId))){let a=n.get(r.exeName);a||(a=[],n.set(r.exeName,a)),a.push(r)}}return n}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[v,p]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(p).then(L=>{switch(L){case"reacted":this.addToRecommendedExecutables(p[0].exeName,p);break;case"ignored":this.highImportanceTipsByExe.delete(v);break;case"incompatibleWindow":{const t=m.Event.once(m.Event.latch(m.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(t(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const t=this._register((0,P.disposableTimeout)(()=>{t.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const v=this.getLastPromptedMediumExeTime(),p=Date.now()-v,L=7*24*60*60*1e3;if(p<L){const s=this._register((0,P.disposableTimeout)(()=>{s.dispose(),this.promptMediumImportanceExeBasedTip()},L-p));return}const[t,o]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(s=>{switch(s){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(t),this.addToRecommendedExecutables(o[0].exeName,o);const n=this._register((0,P.disposableTimeout)(()=>{n.dispose(),this.promptMediumImportanceExeBasedTip()},L));break}case"ignored":this.mediumImportanceTipsByExe.delete(t),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const n=m.Event.once(m.Event.latch(m.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(n(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const n=this._register((0,P.disposableTimeout)(()=>{n.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(v){const p=await this.extensionManagementService.getInstalled(1),L=v.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(o=>p.every(s=>!(0,h.areSameExtensions)(s.identifier,{id:o})))).map(({extensionId:t})=>t.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:L,source:3,name:v[0].exeFriendlyName,searchValue:`@exe:"${v[0].exeName}"`})}getLastPromptedMediumExeTime(){let v=this.storageService.getNumber(c,-1);return v||(v=Date.now(),this.updateLastPromptedMediumExeTime(v)),v}updateLastPromptedMediumExeTime(v){this.storageService.store(c,v,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(E,-1,"{}"))}addToRecommendedExecutables(v,p){const L=this.getPromptedExecutableTips();L[v]=p.map(({extensionId:t})=>t.toLowerCase()),this.storageService.store(E,JSON.stringify(L),-1,0)}groupByInstalled(v,p){const L=[],t=[],o=p.reduce((s,n)=>(s.add(n.identifier.id.toLowerCase()),s),new Set);return v.forEach(s=>{o.has(s.toLowerCase())?L.push(s):t.push(s)}),{installed:L,uninstalled:t}}async getValidExecutableBasedExtensionTips(v){const p=[],L=new Map;for(const t of v.keys()){const o=v.get(t);if(!o||!(0,k.isNonEmptyArray)(o.recommendations))continue;const s=[];y.isWindows?o.windowsPath&&s.push(o.windowsPath.replace("%USERPROFILE%",()=>g.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>g.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>g.env.ProgramFiles).replace("%APPDATA%",()=>g.env.APPDATA).replace("%WINDIR%",()=>g.env.WINDIR)):(s.push((0,I.join)("/usr/local/bin",t)),s.push((0,I.join)("/usr/bin",t)),s.push((0,I.join)(this.userHome.fsPath,t)));for(const n of s){let i=L.get(n);if(i===void 0&&(i=await this.fileService.exists(A.URI.file(n)),L.set(n,i)),i)for(const{extensionId:r,extensionName:a,isExtensionPack:w,whenNotInstalled:S}of o.recommendations)p.push({extensionId:r,extensionName:a,isExtensionPack:w,exeName:t,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:S})}}return p}}e.AbstractNativeExtensionTipsService=u}),define(ce[220],le([0,1,25,33]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function T(A,_,R,P,m){try{const I=await A.getExtensionsControlManifest();if(!I.deprecated)return;const y=await A.getInstalled(1);for(const[g,h]of Object.entries(I.deprecated)){if(!h?.extension)continue;const{id:f,autoMigrate:E,preRelease:c}=h.extension;if(!E)continue;const u=y.find(v=>(0,O.areSameExtensions)(v.identifier,{id:g}));if(!u)continue;const d=(await _.getExtensions([{id:f,preRelease:c}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!d){m.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{m.info(`Migrating '${u.identifier.id}' extension to '${f}' extension...`);const v=!P.getDisabledExtensions().some(L=>(0,O.areSameExtensions)(L,u.identifier));await A.uninstall(u),m.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let p=y.find(L=>(0,O.areSameExtensions)(L.identifier,{id:f}));(!p||!p.isPreReleaseVersion&&v)&&(p=await A.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),m.info(`Installed the pre-release extension '${p.identifier.id}'`),v||(await P.disableExtension(p.identifier),m.info(`Disabled the pre-release extension '${p.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),E.storage&&(R.addToMigrationList((0,O.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,O.getExtensionId)(p.manifest.publisher,p.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${u.identifier.id}' extension to '${f}' extension.`)}catch(v){m.error(v)}}}catch(I){m.error(I)}}e.migrateUnsupportedExtensions=T}),define(ce[221],le([0,1,3,2,35,33,45]),function(ie,e,k,O,T,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends O.Disposable{constructor(m,I,y,g,h,f,E){super(),this.extensionManagementService=m,this.extensionsScannerService=I,this.userDataProfilesService=y,this.extensionsProfileScannerService=g,this.uriIdentityService=h,this.fileService=f,this.logService=E,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new O.DisposableMap),this.initialize().then(null,c=>E.error(c))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(m=>this.onDidChangeProfiles(m.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(m=>this.onAddExtensions(m))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(m=>this.onDidAddExtensions(m))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(m=>this.onRemoveExtensions(m))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(m=>this.onDidRemoveExtensions(m))),this._register(this.fileService.onDidFilesChange(m=>this.onDidFilesChange(m)))}async onDidChangeProfiles(m){try{m.length&&await Promise.all(m.map(I=>(this.extensionsProfileWatchDisposables.set(I.id,(0,O.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(I.extensionsResource)),this.fileService.watch(I.extensionsResource))),this.populateExtensionsFromProfile(I.extensionsResource))))}catch(I){throw this.logService.error(I),I}}async onAddExtensions(m){for(const I of m.extensions)this.addExtensionWithKey(this.getKey(I.identifier,I.version),m.profileLocation)}async onDidAddExtensions(m){for(const I of m.extensions){const y=this.getKey(I.identifier,I.version);m.error?this.removeExtensionWithKey(y,m.profileLocation):this.addExtensionWithKey(y,m.profileLocation)}}async onRemoveExtensions(m){for(const I of m.extensions)this.removeExtensionWithKey(this.getKey(I.identifier,I.version),m.profileLocation)}async onDidRemoveExtensions(m){const I=[],y=[];for(const g of m.extensions){const h=this.getKey(g.identifier,g.version);m.error?this.addExtensionWithKey(h,m.profileLocation):(this.removeExtensionWithKey(h,m.profileLocation),this.allExtensions.has(h)||(this.logService.debug("Extension is removed from all profiles",g.identifier.id,g.version),y.push(this.extensionManagementService.scanInstalledExtensionAtLocation(g.location).then(f=>{f?I.push(f):this.logService.info("Extension not found at the location",g.location.toString())},f=>this.logService.error(f)))))}try{await Promise.all(y),I.length&&await this.uninstallExtensionsNotInProfiles(I)}catch(g){this.logService.error(g)}}onDidFilesChange(m){for(const I of this.userDataProfilesService.profiles)m.contains(I.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(I.extensionsResource)}async onDidExtensionsProfileChange(m){const I=[],y=[],g=await this.extensionsProfileScannerService.scanProfileExtensions(m),h=new Set,f=new Set;for(const[E,c]of this.allExtensions)c.has(m)&&f.add(E);for(const E of g){const c=this.getKey(E.identifier,E.version);h.add(c),f.has(c)||(I.push(E.identifier),this.addExtensionWithKey(c,m))}for(const E of f)if(!h.has(E)){const c=this.fromKey(E);c&&(y.push(c.identifier),this.removeExtensionWithKey(E,m))}(I.length||y.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:I.length?{extensions:I,profileLocation:m}:void 0,removed:y.length?{extensions:y,profileLocation:m}:void 0})}async populateExtensionsFromProfile(m){const I=await this.extensionsProfileScannerService.scanProfileExtensions(m);for(const y of I)this.addExtensionWithKey(this.getKey(y.identifier,y.version),m)}async uninstallExtensionsNotInProfiles(m){m||(m=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(y=>!this.allExtensions.has(this.getKey(y.identifier,y.manifest.version)))),m.length&&await this.extensionManagementService.markAsUninstalled(...m)}addExtensionWithKey(m,I){let y=this.allExtensions.get(m);y||this.allExtensions.set(m,y=new T.ResourceSet(g=>this.uriIdentityService.extUri.getComparisonKey(g))),y.add(I)}removeExtensionWithKey(m,I){const y=this.allExtensions.get(m);y&&y.delete(I),y?.size||this.allExtensions.delete(m)}getKey(m,I){return`${_.ExtensionIdentifier.toKey(m.id)}@${I}`}fromKey(m){const[I,y]=(0,A.getIdAndVersion)(m);return y?{identifier:{id:I},version:y}:void 0}}e.ExtensionsWatcher=R}),define(ce[222],le([0,1,44,46]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function T(A,_,R,P,m,I,y){const g={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${_.nameShort})`};if((0,O.supportsTelemetry)(_,R)&&(0,O.getTelemetryLevel)(P)===3){const h=await(0,k.getServiceMachineId)(R,m,I);g["X-Market-User-Id"]=h,g["VSCode-SessionId"]=y.machineId||h}return g}e.resolveMarketplaceHeaders=T}),define(ce[223],le([0,1,69,20,5,2,26,16,31,15,29,33,7,72,10]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=class extends h.LanguagePackBaseService{constructor(v,p,L,t){super(L),this.extensionManagementService=v,this.logService=t,this.cache=this._register(new c(p,t)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getBuiltInExtensionTranslationsUri(v,p){const t=(await this.cache.getLanguagePacks())[p];if(!t){this.logService.warn(`No language pack found for ${p}`);return}const o=t.translations[v];return o?f.URI.file(o):void 0}async getInstalledLanguages(){const v=await this.cache.getLanguagePacks(),p=Object.keys(v).map(L=>{const t=v[L];return{...this.createQuickPickItem(L,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.createQuickPickItem("en","English")),p.sort((L,t)=>L.label.localeCompare(t.label)),p}async postInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",v.identifier.id),await this.update())}async postUninstallExtension(v){const p=await this.cache.getLanguagePacks();Object.keys(p).some(L=>p[L]&&p[L].extensions.some(t=>(0,y.areSameExtensions)(t.extensionIdentifier,v.identifier)))&&(this.logService.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),L=await this.cache.update(p);return!(0,O.equals)(Object.keys(v),Object.keys(L))}};e.NativeLanguagePackService=E,e.NativeLanguagePackService=E=ye([K(0,I.IExtensionManagementService),K(1,m.INativeEnvironmentService),K(2,I.IExtensionGalleryService),K(3,g.ILogService)],E);let c=class extends A.Disposable{constructor(v,p){super(),this.logService=p,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new T.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(p=>{Object.keys(p).forEach(L=>delete p[L]),this.createLanguagePacksFromExtensions(p,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...p){for(const L of p)L&&L.manifest&&L.manifest.contributes&&L.manifest.contributes.localizations&&L.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,L);Object.keys(v).forEach(L=>this.updateHash(v[L]))}createLanguagePacksFromExtension(v,p){const L=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of t)if(p.location.scheme===_.Schemas.file&&u(o)){let s=v[o.languageId];s||(s={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},v[o.languageId]=s);const n=s.extensions.filter(i=>(0,y.areSameExtensions)(i.extensionIdentifier,L))[0];n?n.version=p.manifest.version:s.extensions.push({extensionIdentifier:L,version:p.manifest.version});for(const i of o.translations)s.translations[i.id]=(0,R.join)(p.location.fsPath,i.path)}}updateHash(v){if(v){const p=(0,k.createHash)("md5");for(const L of v.extensions)p.update(L.extensionIdentifier.uuid||L.extensionIdentifier.id).update(L.version);v.hash=p.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return P.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,L=>L.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(L)).then(L=>{try{return JSON.parse(L)}catch{return{}}}).then(L=>(p=v(L),L)).then(L=>{for(const o of Object.keys(L))L[o]||delete L[o];this.languagePacks=L,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),P.Promises.writeFile(this.languagePacksFilePath,t)}).then(()=>p,L=>this.logService.error(L))})}};c=ye([K(0,m.INativeEnvironmentService),K(1,g.ILogService)],c);function u(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const v of d.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(ce[224],le([0,1,141,8,30,46]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const _="https://0.0.0.0/OneCollector/1.0",R="https://0.0.0.0/ping";async function P(I,y,g){const h=await(0,k.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),f=await(0,k.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),E=new h.AppInsightsCore,c=new f.PostChannel,u={instrumentationKey:I,endpointUrl:_,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[c]]};if(g){u.extensionConfig={};const d={alwaysUseXhrOverride:!0,httpXHROverride:g};u.extensionConfig[c.identifier]=d}return E.initialize(u,[]),E.addTelemetryInitializer(d=>{y&&(d.ext=d.ext??{},d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),E}class m{constructor(y,g,h,f,E){this._isInternalTelemetry=y,this._eventPrefix=g,this._defaultData=h,this._xhrOverride=E,this.endPointUrl=_,this.endPointHealthUrl=R,this._defaultData||(this._defaultData={}),typeof f=="function"?this._aiCoreOrKey=f():this._aiCoreOrKey=f,this._asyncAiCore=null}_withAIClient(y){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){y(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=P(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(g=>{y(g)},g=>{(0,O.onUnexpectedError)(g),console.error(g)})}}log(y,g){if(!this._aiCoreOrKey)return;g=(0,T.mixin)(g,this._defaultData),g=(0,A.validateTelemetryData)(g);const h=this._eventPrefix+"/"+y;try{this._withAIClient(f=>{f.pluginVersionString=g?.properties.version??"Unknown",f.track({name:h,baseData:{name:h,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(y=>{this._withAIClient(g=>{g.unload(!0,()=>{this._aiCoreOrKey=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=m}),define(ce[109],le([0,1,2,165,15,7,23,46]),function(ie,e,k,O,T,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let P=class extends k.Disposable{constructor(I,y,g,h,f=""){super(),this.prefix=f;const E=y.getLogger(R.telemetryLogId);if(E)this.logger=this._register(E);else{const u=(0,R.isLoggingOnly)(h,g)?" (Not Sent)":"",d=()=>(0,R.supportsTelemetry)(h,g)&&I.getLevel()===A.LogLevel.Trace;this.logger=this._register(y.createLogger(R.telemetryLogId,{name:(0,O.localize)(0,null,u),hidden:!d()})),this._register(I.onDidChangeLogLevel(()=>y.setVisibility(R.telemetryLogId,d()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(I,y){this.logger.trace(`${this.prefix}telemetry/${I}`,(0,R.validateTelemetryData)(y))}};e.TelemetryLogAppender=P,e.TelemetryLogAppender=P=ye([K(0,A.ILogService),K(1,A.ILoggerService),K(2,T.IEnvironmentService),K(3,_.IProductService)],P)}),define(ce[110],le([0,1,2,30,6,28,166,18,49,102,23,40,21,46]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,d,v){this._configurationService=d,this._productService=v,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=u.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(p=>{(p.affectsConfiguration(g.TELEMETRY_SETTING_ID)||p.affectsConfiguration(g.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(g.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(u,d){this._experimentProperties[u]=d}_updateTelemetryLevel(){let u=(0,h.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const v=d.usage?3:d.error?2:0;u=Math.min(u,v)}this._telemetryLevel=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(u,d,v){this._telemetryLevel<d||(v=(0,O.mixin)(v,this._experimentProperties),v=(0,h.cleanData)(v,this._cleanupPatterns),v=(0,O.mixin)(v,this._commonProperties),this._appenders.forEach(p=>p.log(u,v)))}publicLog(u,d){this._log(u,3,d)}publicLog2(u,d){this.publicLog(u,d)}publicLogError(u,d){this._sendErrorTelemetry&&this._log(u,2,d)}publicLogError2(u,d){this.publicLogError(u,d)}};e.TelemetryService=f,e.TelemetryService=f=ye([K(1,R.IConfigurationService),K(2,I.IProductService)],f);function E(){const c=(0,_.localize)(0,null,m.default.nameLong),u=m.default.privacyStatementUrl?(0,_.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,_.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=T.isWeb?"":(0,_.localize)(3,null),v=(0,_.localize)(4,null),p=(0,_.localize)(5,null),L=(0,_.localize)(6,null),t=(0,_.localize)(7,null),o=`
|       | ${v} | ${p} | ${L} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,_.localize)(8,null);return`
${c} ${u} ${d}

&nbsp;

${t}
${o}

&nbsp;

${s}
`}y.Registry.as(P.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,_.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,_.localize)(10,null),(0,_.localize)(11,null),(0,_.localize)(12,null),(0,_.localize)(13,null)],markdownDescription:E(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(P.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,_.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,_.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,_.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,_.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[225],le([0,1,14,25,270,224]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function _(I,y){const g=await y.request(I,O.CancellationToken.None),h=(await(0,k.streamToBuffer)(g.stream)).toString(),f=g.res.statusCode??200;return{headers:g.res.headers,statusCode:f,responseData:h}}async function R(I){const y={method:I.type,headers:I.headers};return new Promise((h,f)=>{const E=T.request(I.url??"",y,c=>{c.on("data",function(u){h({headers:c.headers,statusCode:c.statusCode??200,responseData:u.toString()})}),c.on("error",function(u){f(u)})});E.write(I.data,c=>{c&&f(c)}),E.end()})}async function P(I,y,g){const h=typeof y.data=="string"?y.data:new TextDecoder().decode(y.data),f={type:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data).toString()},url:y.urlString,data:h};try{const E=I?await _(f,I):await R(f);g(E.statusCode,E.headers,E.responseData)}catch{g(0,{})}}class m extends A.AbstractOneDataSystemAppender{constructor(y,g,h,f,E){const c={sendPOST:(u,d)=>{P(y,u,d)}};super(g,h,f,E,c)}}e.OneDataSystemAppender=m}),define(ce[226],le([0,1,26,93,18,15,7,23,21,108,109,110]),function(ie,e,k,O,T,A,_,R,P,m,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let g=class{constructor(f,E,c,u,d,v){this.configurationService=f,this.telemetryService=E,this.logService=c,this.loggerService=u,this.environmentService=d,this.productService=v,this.customTelemetryServices=new Map}getCustomTelemetryService(f){if(!this.customTelemetryServices.has(f.id)){const E=Object.create(null);E["common.vscodemachineid"]=this.telemetryService.machineId,E["common.vscodesessionid"]=this.telemetryService.sessionId;const c=[f.id,JSON.stringify(E),f.aiKey],d=new O.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:c,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),v=[new m.TelemetryAppenderClient(d),new I.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${f.id}] `)];this.customTelemetryServices.set(f.id,new y.TelemetryService({appenders:v,sendErrorTelemetry:f.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(f.id)}publicLog(f,E,c){this.getCustomTelemetryService(f).publicLog(E,c)}publicLogError(f,E,c){this.getCustomTelemetryService(f).publicLogError(E,c)}};e.CustomEndpointTelemetryService=g,e.CustomEndpointTelemetryService=g=ye([K(0,T.IConfigurationService),K(1,P.ITelemetryService),K(2,_.ILogService),K(3,_.ILoggerService),K(4,A.IEnvironmentService),K(5,R.IProductService)],g)}),define(ce[76],le([0,1,3,18,4,7]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,T.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,T.createDecorator)("sharedTunnelsService");var _;(function(c){c.Http="http",c.Https="https"})(_||(e.TunnelProtocol=_={}));var R;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(R||(e.TunnelPrivacyId=R={}));function P(c){return!!c.forwardPort}e.isTunnelProvider=P;var m;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function I(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(c){return e.LOCALHOST_ADDRESSES.indexOf(c)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(c){return e.ALL_INTERFACES_ADDRESSES.indexOf(c)>=0}e.isAllInterfaces=g;function h(c,u,d,v){if(d===1)return!1;if(d===2&&g(u)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(p?.length===4&&parseInt(p[1])>=18)return!1}return c<1024}e.isPortPrivileged=h;class f{constructor(u,d,v){this.remoteAddress=u,this.localAddress=d,this._dispose=v,this._onDispose=new k.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let E=class{constructor(u,d){this.logService=u,this.configurationService=d,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const u=this.configurationService.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this._tunnelProvider=u,u?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],d=Array.from(this._tunnels.values());for(const v of d){const p=Array.from(v.values());for(const L of p){const t=await L.value;t&&typeof t!="string"&&u.push(t)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:d}of u.values())await d.then(v=>typeof v!="string"?v?.dispose():void 0);u.clear()}this._tunnels.clear()}setEnvironmentTunnel(u,d,v,p,L){this.addTunnelToMap(u,d,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:d,localAddress:v,privacy:p,protocol:L,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,d){(g(u)||y(u))&&(u=e.LOCALHOST_ADDRESSES[0]);const v=this.getTunnelFromMap(u,d);if(v)return++v.refcount,v.value}openTunnel(u,d,v,p,L,t=!1,o,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${v} on local port ${L}.`);const n=this._tunnelProvider??u;if(!n)return;if(d||(d="localhost"),p||(p=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.retainOrCreateTunnel(n,d,v,p,L,t,o,s);return i?i.then(r=>{if(r){if(typeof r=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(d,v),r}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(d,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(r);return(r.tunnelRemoteHost!==d||r.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const d=this._tunnels.get(u.tunnelRemoteHost);if(d){const v=d.get(u.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,v))}}}}async tryDisposeTunnel(u,d,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${d}.`);const p=v.value.then(async L=>{L&&typeof L!="string"&&(await L.dispose(!0),this._onTunnelClosed.fire({host:L.tunnelRemoteHost,port:L.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(d),p}}async closeTunnel(u,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${d} `);const v=this._tunnels.get(u);if(v&&v.has(d)){const p=v.get(d);p.refcount=0,await this.tryDisposeTunnel(u,d,p)}}addTunnelToMap(u,d,v){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(d,{refcount:1,value:v})}async removeEmptyOrErrorTunnelFromMap(u,d){const v=this._tunnels.get(u);if(v){const p=v.get(d),L=p?await p.value:void 0;(!L||typeof L=="string")&&v.delete(d),v.size===0&&this._tunnels.delete(u)}}getTunnelFromMap(u,d){const v=[u];y(u)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):g(u)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const p=v.map(L=>this._tunnels.get(L));for(const L of p){const t=L?.get(d);if(t)return t}}canTunnel(u){return!!I(u)}createWithProvider(u,d,v,p,L,t,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${v} on local port ${p}.`);const s=v;this._factoryInProgress.add(s);const n=p===void 0?v:p,i={elevationRequired:L?this.isPortPrivileged(n):!1},r={remoteAddress:{host:d,port:v},localAddressPort:p,privacy:t,public:t?t!==R.Private:void 0,protocol:o},a=u.forwardPort(r,i);return a?(this.addTunnelToMap(d,v,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),a}};e.AbstractTunnelService=E,e.AbstractTunnelService=E=ye([K(0,A.ILogService),K(1,O.IConfigurationService)],E)}),define(ce[227],le([0,1,7,76,2,8,5]),function(ie,e,k,O,T,A,_){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends T.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new _.DeferredPromise),this._addressPromise.p)}setAddress(y){this._address=y,this._addressPromise&&(this._addressPromise.complete(y),this._addressPromise=null)}setTunnel(y){this._register(y)}}let m=class extends T.Disposable{static{R=this}static{this._lastId=0}constructor(y,g){super(),this._tunnelService=y,this._logService=g,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(y=>y.dispose())}async createTunnel(){return{id:String(++R._lastId)}}async startTunnel(y,g,h,f,E,c,u){const d=new P,v=await Promise.resolve(this._tunnelService.openTunnel(y,d,h,f,E,c,u));if(!v||typeof v=="string")throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${h}:${f} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(g))throw this._disposedTunnels.delete(g),d.dispose(),await v.dispose(),(0,A.canceled)();return d.setTunnel(v),this._tunnels.set(g,d),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${g}: ${v.localAddress} (local) to ${h}:${f} (remote).`),{tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress}}async setAddress(y,g){const h=this._tunnels.get(y);h&&h.setAddress(g)}async destroyTunnel(y){const g=this._tunnels.get(y);if(g){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${y}.`),this._tunnels.delete(y),await g.dispose();return}this._disposedTunnels.add(y)}};e.SharedProcessTunnelService=m,e.SharedProcessTunnelService=m=R=ye([K(0,O.ISharedTunnelsService),K(1,k.ILogService)],m)}),define(ce[27],le([0,1,4]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(ce[228],le([0,1,27,183,13,22,126,3,2]),function(ie,e,k,O,T,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{static{this._clock=0}constructor(g){this.uri=g,this.time=m._clock++}touch(){return this.time=m._clock++,this}}let I=class{constructor(g){this._fileService=g,this._dispooables=new P.DisposableStore,this._limit=2**16;const h=new Map,f=E=>{let c=h.get(E.scheme);return c===void 0&&(c=g.hasProvider(E)&&!this._fileService.hasCapability(E,1024),h.set(E.scheme,c)),c};this._dispooables.add(R.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(E=>{h.delete(E.scheme)})),this.extUri=new A.ExtUri(f),this._canonicalUris=new _.SkipList((E,c)=>this.extUri.compare(E,c,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,A.normalizePath)(g));const h=this._canonicalUris.get(g);return h?h.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new m(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((f,E)=>f[1].time<E[1].time?1:f[1].time>E[1].time?-1:0);m._clock=0,this._canonicalUris.clear();const h=this._limit*.5;for(let f=0;f<h;f++)this._canonicalUris.set(g[f][0],g[f][1].touch())}};e.UriIdentityService=I,e.UriIdentityService=I=ye([K(0,T.IFileService)],I),(0,O.registerSingleton)(k.IUriIdentityService,I,1)}),define(ce[229],le([0,1,3,2,13,42,47,14]),function(ie,e,k,O,T,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends O.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(I,y,g,h){super(),this.fileSystemScheme=I,this.fileSystemProvider=y,this.userDataScheme=g,this.logService=h,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=_.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(f=>this.handleFileChanges(f)))}watch(I,y){this.watchResources.set(I,I);const g=this.fileSystemProvider.watch(this.toFileSystemResource(I),y);return(0,O.toDisposable)(()=>{this.watchResources.delete(I),g.dispose()})}stat(I){return this.fileSystemProvider.stat(this.toFileSystemResource(I))}mkdir(I){return this.fileSystemProvider.mkdir(this.toFileSystemResource(I))}rename(I,y,g){return this.fileSystemProvider.rename(this.toFileSystemResource(I),this.toFileSystemResource(y),g)}readFile(I){return this.fileSystemProvider.readFile(this.toFileSystemResource(I),{atomic:!0})}readFileStream(I,y,g){const h=(0,A.newWriteableStream)(f=>R.VSBuffer.concat(f.map(E=>R.VSBuffer.wrap(E))).buffer);return(async()=>{try{const f=await this.readFile(I);h.end(f)}catch(f){h.error(f),h.end()}})(),h}readdir(I){return this.fileSystemProvider.readdir(this.toFileSystemResource(I))}writeFile(I,y,g){return this.fileSystemProvider.writeFile(this.toFileSystemResource(I),y,g)}delete(I,y){return this.fileSystemProvider.delete(this.toFileSystemResource(I),y)}copy(I,y,g){if((0,T.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(I),this.toFileSystemResource(y),g);throw new Error("copy not supported")}handleFileChanges(I){const y=[];for(const g of I){if(g.resource.scheme!==this.fileSystemScheme)continue;const h=this.toUserDataResource(g.resource);this.watchResources.findSubstr(h)&&y.push({resource:h,type:g.type})}y.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(y))}toFileSystemResource(I){return I.with({scheme:this.fileSystemScheme})}toUserDataResource(I){return I.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(ce[77],le([0,1,85]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function O(_,R,P,m){const I=(0,k.setProperty)(_,R,P,m)[0];return I&&(_=_.substring(0,I.offset)+I.content+_.substring(I.offset+I.length)),_}e.edit=O;function T(_,R,P){let m=P;for(;m>=0;){if(_.charAt(m)===R.charAt(R.length-1)&&R.length===1)return m+1;if(m--,R.length===2&&m>=0&&_.charAt(m)===R.charAt(0))return m+2}return 0}e.getLineStartOffset=T;function A(_,R,P){let m=P;for(;m>=0;)if(_.charAt(m)===R.charAt(R.length-1)&&R.length===1||(m++,R.length===2&&m>=0&&_.charAt(m)===R.charAt(1)))return m;return _.length-1}e.getLineEndOffset=A}),define(ce[230],le([0,1,30,53,11]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(h,f,E,c,u,d){const v=[],p=[],L=[];if(!f){const z=h.filter(({identifier:J})=>u.every(H=>H.toLowerCase()!==J.id.toLowerCase()));return{local:{added:v,removed:p,updated:L},remote:z.length>0?{added:z,updated:[],removed:[],all:z}:null}}h=h.map(y),f=f.map(y),E=E?E.map(y):null;const t=new Map,o=z=>{z.uuid&&t.set(z.id.toLowerCase(),z.uuid)};h.forEach(({identifier:z})=>o(z)),f.forEach(({identifier:z})=>o(z)),E?.forEach(({identifier:z})=>o(z));const s=z=>{const J=z.identifier.uuid||t.get(z.identifier.id.toLowerCase());return J?`uuid:${J}`:`id:${z.identifier.id.toLowerCase()}`},n=(z,J)=>(z.set(s(J),J),z),i=h.reduce(n,new Map),r=f.reduce(n,new Map),a=f.reduce((z,J)=>n(z,(0,k.deepClone)(J)),new Map),w=E?E.reduce(n,new Map):null,S=c.reduce(n,new Map),l=u.reduce((z,J)=>{const H=t.get(J.toLowerCase());return z.add(H?`uuid:${H}`:`id:${J.toLowerCase()}`)},new Set),C=d?d.reduce((z,{id:J,uuid:H})=>(H=H??t.get(J.toLowerCase()),z.add(H?`uuid:${H}`:`id:${J.toLowerCase()}`)),new Set):null,U=_(i,r,l,!1);if(U.added.size>0||U.removed.size>0||U.updated.size>0){const z=_(w,i,l,!1),J=_(w,r,l,!0),H=(Q,B,Y,x)=>{let j,q,Z;return B.installed?(j=x.pinned,Z=x.preRelease,j&&(q=x.version)):(j=Y.pinned,Z=Y.preRelease,j&&(q=Y.version)),j===void 0&&(j=B.pinned,j&&(q=B.version)),Z===void 0&&(Z=B.preRelease),{...x,installed:B.installed||Y.installed,pinned:j,preRelease:Z,version:q??(Y.version&&(!B.installed||O.gt(Y.version,B.version))?Y.version:B.version),state:P(B,Y,w?.get(Q))}};for(const Q of J.removed.values()){const B=i.get(Q);if(!B)continue;const Y=(0,T.assertIsDefined)(w?.get(Q)),x=C&&!C.has(Q)&&Y.installed;B.installed&&x?p.push(B.identifier):a.set(Q,B)}for(const Q of J.added.values()){const B=(0,T.assertIsDefined)(r.get(Q)),Y=i.get(Q);if(Y){if(U.updated.has(Q)){const x=H(Q,Y,B,B);R(Y,B,!1,!1)||L.push(g(x,Q)),a.set(Q,x)}}else B.installed&&v.push(g(B,Q))}for(const Q of J.updated.values()){const B=(0,T.assertIsDefined)(r.get(Q)),Y=(0,T.assertIsDefined)(w?.get(Q)),x=i.get(Q);if(x)if(C&&!C.has(Q)&&Y.installed&&x.installed&&!B.installed)p.push(x.identifier);else{const q=H(Q,x,B,B);L.push(g(q,Q)),a.set(Q,q)}else B.installed&&v.push(g(B,Q))}for(const Q of z.added.values())J.added.has(Q)||a.set(Q,(0,T.assertIsDefined)(i.get(Q)));for(const Q of z.updated.values()){if(J.removed.has(Q)||J.updated.has(Q))continue;const B=(0,T.assertIsDefined)(i.get(Q)),Y=(0,T.assertIsDefined)(r.get(Q));a.set(Q,H(Q,B,Y,B))}for(const Q of z.removed.values())J.updated.has(Q)||J.removed.has(Q)||S.has(Q)||(0,T.assertIsDefined)(r.get(Q)).installed&&C&&(C.has(Q)||!(0,T.assertIsDefined)(w?.get(Q)).installed||a.delete(Q))}const N=[],F=_(r,a,new Set,!0),$=F.added.size>0||F.updated.size>0||F.removed.size>0;return $&&a.forEach((z,J)=>N.push(g(z,J))),{local:{added:v,removed:p,updated:L},remote:$?{added:[...F.added].map(z=>a.get(z)),updated:[...F.updated].map(z=>a.get(z)),removed:[...F.removed].map(z=>r.get(z)),all:N}:null}}e.merge=A;function _(h,f,E,c){const u=h?[...h.keys()].filter(t=>!E.has(t)):[],d=[...f.keys()].filter(t=>!E.has(t)),v=d.filter(t=>!u.includes(t)).reduce((t,o)=>(t.add(o),t),new Set),p=u.filter(t=>!d.includes(t)).reduce((t,o)=>(t.add(o),t),new Set),L=new Set;for(const t of u){if(p.has(t))continue;const o=h.get(t),s=f.get(t);(!s||!R(o,s,c,!0))&&L.add(t)}return{added:v,removed:p,updated:L}}function R(h,f,E,c){return!(h.disabled!==f.disabled||!!h.isApplicationScoped!=!!f.isApplicationScoped||c&&h.installed!==f.installed||h.installed&&f.installed&&(h.preRelease!==f.preRelease||h.pinned!==f.pinned||f.pinned&&h.version!==f.version)||!I(h.state,f.state)||E&&h.version!==f.version)}function P(h,f,E){const c=h.state,u=f.state,d=E?.state;if(!f.version||c&&O.gt(h.version,f.version))return c;if(u&&O.gt(f.version,h.version)||!c)return u;if(!u)return c;const v=(0,k.deepClone)(c),p=d?m(d,u):{added:Object.keys(u).reduce((t,o)=>(t.add(o),t),new Set),removed:new Set,updated:new Set},L=d?m(d,c):{added:Object.keys(c).reduce((t,o)=>(t.add(o),t),new Set),removed:new Set,updated:new Set};for(const t of[...p.added.values(),...p.updated.values()])v[t]=u[t];for(const t of p.removed.values())L.updated.has(t)||delete v[t];return v}function m(h,f){const E=Object.keys(h),c=Object.keys(f),u=c.filter(p=>!E.includes(p)).reduce((p,L)=>(p.add(L),p),new Set),d=E.filter(p=>!c.includes(p)).reduce((p,L)=>(p.add(L),p),new Set),v=new Set;for(const p of E){if(d.has(p))continue;const L=h[p],t=f[p];(0,k.equals)(L,t)||v.add(p)}return{added:u,removed:d,updated:v}}function I(h={},f={}){const{added:E,removed:c,updated:u}=m(h,f);return E.size===0&&c.size===0&&u.size===0}function y(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function g(h,f){const E={...h,identifier:{id:h.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled||delete E.disabled,h.installed||delete E.installed,h.state||delete E.state,h.isApplicationScoped||delete E.isApplicationScoped,E}}),define(ce[111],le([0,1,20,18,4]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,T.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,P){let m=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return m=m.filter(I=>I!==R&&I!==`-${R}`),P&&m.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}updateSynchronizedExtensions(R,P){let m=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return m=m.filter(I=>I!==R&&I!==`-${R}`),P&&m.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}getIgnoredExtensions(R){const P=R.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),m=this.getConfiguredIgnoredExtensions().map(g=>g.toLowerCase()),I=[],y=[];if(Array.isArray(m))for(const g of m)g.startsWith("-")?y.push(g.substring(1)):I.push(g);return(0,k.distinct)([...P,...I].filter(g=>!y.includes(g)))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};e.IgnoredExtensionsManagementService=A,e.IgnoredExtensionsManagementService=A=ye([K(0,O.IConfigurationService)],A)}),define(ce[231],le([0,1,20,34,30,94,77]),function(ie,e,k,O,T,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(p){return(0,O.parse)(p)||[]}async function P(p,L,t,o,s){const n=R(p),i=R(L),r=t?R(t):null,a=[...n,...i,...r||[]].map(H=>H.key),w=await s.resolveUserBindings(a),S=I(n,i,r,w);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:L,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const l=g(n),C=g(i),U=r?g(r):null,N=f(l,C,w),F=U?f(U,l,w):{added:[...l.keys()].reduce((H,Q)=>(H.add(Q),H),new Set),removed:new Set,updated:new Set},$=U?f(U,C,w):{added:[...C.keys()].reduce((H,Q)=>(H.add(Q),H),new Set),removed:new Set,updated:new Set},z=m(N,F,$);let J=p;for(const H of z.removed.values())z.conflicts.has(H)||(J=d(J,H,o));for(const H of z.added.values()){if(z.conflicts.has(H))continue;const Q=C.get(H);if(Q.some(B=>B.command!==`-${H}`&&S.conflicts.has(w[B.key]))){z.conflicts.add(H);continue}J=u(J,Q,o)}for(const H of z.updated.values()){if(z.conflicts.has(H))continue;const Q=C.get(H);if(Q.some(B=>B.command!==`-${H}`&&S.conflicts.has(w[B.key]))){z.conflicts.add(H);continue}J=v(J,H,Q,o)}return{mergeContent:J,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.merge=P;function m(p,L,t){const o=new Set,s=new Set,n=new Set,i=new Set;for(const r of L.removed.values())t.updated.has(r)&&i.add(r);for(const r of t.removed.values())i.has(r)||(L.updated.has(r)?i.add(r):s.add(r));for(const r of L.added.values())i.has(r)||t.added.has(r)&&p.updated.has(r)&&i.add(r);for(const r of t.added.values())i.has(r)||(L.added.has(r)?p.updated.has(r)&&i.add(r):o.add(r));for(const r of L.updated.values())i.has(r)||t.updated.has(r)&&p.updated.has(r)&&i.add(r);for(const r of t.updated.values())i.has(r)||(L.updated.has(r)?p.updated.has(r)&&i.add(r):n.add(r));return{added:o,removed:s,updated:n,conflicts:i}}function I(p,L,t,o){const s=new Set,n=y(p,o),i=y(L,o),r=t?y(t,o):null,a=h(n,i);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const w=r?h(r,n):{added:[...n.keys()].reduce((F,$)=>(F.add($),F),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:s,removed:s,updated:s,conflicts:s};const S=r?h(r,i):{added:[...i.keys()].reduce((F,$)=>(F.add($),F),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const{added:l,removed:C,updated:U,conflicts:N}=m(a,w,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:l,removed:C,updated:U,conflicts:N}}function y(p,L){const t=new Map;for(const o of p){const s=L[o.key];let n=t.get(s);n||(n=[],t.set(s,n)),n.push(o)}return t}function g(p){const L=new Map;for(const t of p){const o=t.command[0]==="-"?t.command.substring(1):t.command;let s=L.get(o);s||(s=[],L.set(o,s)),s.push(t)}return L}function h(p,L){const t=[...p.keys()],o=[...L.keys()],s=o.filter(r=>!t.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),n=t.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=new Set;for(const r of t){if(n.has(r))continue;const a=p.get(r).map(S=>({...S,key:r})),w=L.get(r).map(S=>({...S,key:r}));(0,k.equals)(a,w,(S,l)=>c(S,l))||i.add(r)}return{added:s,removed:n,updated:i}}function f(p,L,t){const o=[...p.keys()],s=[...L.keys()],n=s.filter(a=>!o.includes(a)).reduce((a,w)=>(a.add(w),a),new Set),i=o.filter(a=>!s.includes(a)).reduce((a,w)=>(a.add(w),a),new Set),r=new Set;for(const a of o){if(i.has(a))continue;const w=p.get(a).map(l=>({...l,key:t[l.key]})),S=L.get(a).map(l=>({...l,key:t[l.key]}));E(w,S)||r.add(a)}return{added:n,removed:i,updated:r}}function E(p,L){return!(!(0,k.equals)(p.filter(({command:t})=>t[0]!=="-"),L.filter(({command:t})=>t[0]!=="-"),(t,o)=>c(t,o))||!(0,k.equals)(p.filter(({command:t})=>t[0]==="-"),L.filter(({command:t})=>t[0]==="-"),(t,o)=>c(t,o)))}function c(p,L){if(p.command!==L.command||p.key!==L.key)return!1;const t=A.ContextKeyExpr.deserialize(p.when),o=A.ContextKeyExpr.deserialize(L.when);return!(t&&!o||!t&&o||t&&o&&!t.equals(o)||!T.equals(p.args,L.args))}function u(p,L,t){for(const o of L)p=_.edit(p,[-1],o,t);return p}function d(p,L,t){const o=R(p);for(let s=o.length-1;s>=0;s--)(o[s].command===L||o[s].command===`-${L}`)&&(p=_.edit(p,[s],void 0,t));return p}function v(p,L,t,o){const s=R(p),n=s.findIndex(i=>i.command===L||i.command===`-${L}`);for(let i=s.length-1;i>=0;i--)(s[i].command===L||s[i].command===`-${L}`)&&(p=_.edit(p,[i],void 0,o));for(let i=t.length-1;i>=0;i--)p=_.edit(p,[n],t[i],o);return p}}),define(ce[232],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(A,_,R){const P={},m={},I=new Set;if(!_)return{local:{added:P,updated:m,removed:[...I.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const y=O(A,_);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:P,updated:m,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=O(R,A),h=O(R,_),f={},E={},c=new Set,u=new Set;for(const d of g.removed.values())h.updated.has(d)?P[d]=_[d]:c.add(d);for(const d of h.removed.values())u.has(d)||(g.updated.has(d)?u.add(d):I.add(d));for(const d of g.updated.values())u.has(d)||(h.updated.has(d)?y.updated.has(d)&&u.add(d):E[d]=A[d]);for(const d of h.updated.values())u.has(d)||(g.updated.has(d)?y.updated.has(d)&&u.add(d):A[d]!==void 0&&(m[d]=_[d]));for(const d of g.added.values())u.has(d)||(h.added.has(d)?y.updated.has(d)&&u.add(d):f[d]=A[d]);for(const d of h.added.values())u.has(d)||(g.added.has(d)?y.updated.has(d)&&u.add(d):P[d]=_[d]);return{local:{added:P,removed:[...I.values()],updated:m},remote:{added:f,removed:[...c.values()],updated:E},conflicts:[...u.values()]}}e.merge=k;function O(A,_){const R=A?Object.keys(A):[],P=_?Object.keys(_):[],m=P.filter(g=>!R.includes(g)).reduce((g,h)=>(g.add(h),g),new Set),I=R.filter(g=>!P.includes(g)).reduce((g,h)=>(g.add(h),g),new Set),y=new Set;for(const g of R){if(I.has(g))continue;const h=A[g],f=_[g];h!==f&&y.add(g)}return{added:m,removed:I,updated:y}}function T(A,_){const{added:R,removed:P,updated:m}=O(A,_);return R.size===0&&P.size===0&&m.size===0}e.areSame=T}),define(ce[233],le([0,1,30]),function(ie,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function O(A,_,R,P){const m={added:[],removed:[],updated:[]};let I={added:[],removed:[],updated:[]};if(!_){const g=A.filter(({id:h})=>!P.includes(h));return g.length?I.added=g:I=null,{local:m,remote:I}}const y=T(A,_,P);if(y.added.length>0||y.removed.length>0||y.updated.length>0){const g=T(R,A,P),h=T(R,_,P);for(const f of h.removed){const E=A.find(c=>c.id===f);E&&m.removed.push(E)}for(const f of h.added){const E=_.find(c=>c.id===f);g.added.includes(f)?y.updated.includes(f)&&m.updated.push(E):m.added.push(E)}for(const f of h.updated)m.updated.push(_.find(E=>E.id===f));for(const f of g.added)h.added.includes(f)||I.added.push(A.find(E=>E.id===f));for(const f of g.updated)h.removed.includes(f)||h.updated.includes(f)||I.updated.push(A.find(E=>E.id===f));for(const f of g.removed){const E=_.find(c=>c.id===f);E&&I.removed.push(E)}}return I.added.length===0&&I.removed.length===0&&I.updated.length===0&&(I=null),{local:m,remote:I}}e.merge=O;function T(A,_,R){A=A?A.filter(({id:h})=>!R.includes(h)):[],_=_.filter(({id:h})=>!R.includes(h));const P=A.map(({id:h})=>h),m=_.map(({id:h})=>h),I=m.filter(h=>!P.includes(h)),y=P.filter(h=>!m.includes(h)),g=[];for(const{id:h,name:f,shortName:E,useDefaultFlags:c}of A){if(y.includes(h))continue;const u=_.find(d=>d.id===h);(!u||u.name!==f||u.shortName!==E||!(0,k.equals)(u.useDefaultFlags,c))&&g.push(h)}return{added:I,removed:y,updated:g}}}),define(ce[24],le([0,1,20,11,172,49,29,4,103,40]),function(ie,e,k,O,T,A,_,R,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=void 0;function I(){const i=m.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(i).filter(r=>!!i[r].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function y(){const i=m.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i).filter(S=>!!i[S].ignoreSync),a=Object.keys(i).filter(S=>i[S].scope===2||i[S].scope===6),w=I();return(0,k.distinct)([...r,...a,...w])}e.getDefaultIgnoredSettings=y,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function g(){const i="vscode://schemas/ignoredSettings",r=m.Registry.as(A.Extensions.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:_.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=m.Registry.as(P.Extensions.JSONContribution),w=()=>{const S=I(),l=y(),C=Object.keys(A.allSettings.properties).filter(F=>!l.includes(F)),U=l.filter(F=>!S.includes(F)),N={items:{type:"string",enum:[...C,...U.map(F=>`-${F}`)]}};a.registerSchema(i,N)};return r.onDidUpdateConfiguration(()=>w())}e.registerConfiguration=g;function h(i){return i&&(0,O.isObject)(i)&&(0,O.isString)(i.id)&&Array.isArray(i.scopes)}e.isAuthenticationProvider=h;var f;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(f||(e.SyncResource=f={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function E(i,...r){return i?[i,...r]:r}e.getPathSegments=E;function c(i,r,a,w){return w.joinPath(a.userDataSyncHome,...E(i,r,`lastSync${r}.json`))}e.getLastSyncResourceUri=c,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,R.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(i){const r={};return r[e.HEADER_EXECUTION_ID]=i,r}e.createSyncHeaders=u;var d;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(d||(e.UserDataSyncErrorCode=d={}));class v extends Error{constructor(r,a,w,S){super(r),this.code=a,this.resource=w,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=v;class p extends v{constructor(r,a,w,S,l){super(r,w,void 0,l),this.url=a,this.serverCode=S}}e.UserDataSyncStoreError=p;class L extends v{constructor(r,a){super(r,a)}}e.UserDataAutoSyncError=L,function(i){function r(a){if(a instanceof i)return a;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(w&&w[1]){const S=w[2]==="unknown"?void 0:w[2],l=w[3]==="unknown"?void 0:w[3];return new i(a.message,w[1],S,l)}return new i(a.message,"Unknown")}i.toUserDataSyncError=r}(v||(e.UserDataSyncError=v={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var o;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(o||(e.Change=o={}));var s;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(s||(e.MergeState=s={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(i){return`sync.enable.${i}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(ce[234],le([0,1,30,24]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(_,R,P,m,I){if(!R)return{remote:{added:Object.keys(_),removed:[],updated:[],all:Object.keys(_).length>0?_:null},local:{added:{},removed:[],updated:{}}};const y=A(_,R);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const g=P?A(P,R):{added:Object.keys(R).reduce((d,v)=>(d.add(v),d),new Set),removed:new Set,updated:new Set},h=P?A(P,_):{added:Object.keys(_).reduce((d,v)=>(d.add(v),d),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},E=k.deepClone(R),c=!P;for(const d of h.added.values())d!==O.SYNC_SERVICE_URL_TYPE&&c&&g.added.has(d)||(E[d]=_[d]);for(const d of h.updated.values())E[d]=_[d];for(const d of h.removed.values())m.unregistered.includes(d)||delete E[d];for(const d of g.added.values()){const v=R[d];if(m.machine.includes(d)){I.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(P&&h.added.has(d))continue;const p=_[d];p&&p.value===v.value||d===O.SYNC_SERVICE_URL_TYPE&&c&&h.added.has(d)||(p?f.updated[d]=v:f.added[d]=v)}for(const d of g.updated.values()){const v=R[d];if(m.machine.includes(d)){I.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(d)||h.removed.has(d))continue;const p=_[d];p&&p.value===v.value||(f.updated[d]=v)}for(const d of g.removed.values()){if(m.machine.includes(d)){I.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}h.updated.has(d)||h.removed.has(d)||f.removed.push(d)}const u=A(R,E);return{local:f,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:E}}}e.merge=T;function A(_,R){const P=Object.keys(_),m=Object.keys(R),I=m.filter(h=>!P.includes(h)).reduce((h,f)=>(h.add(f),h),new Set),y=P.filter(h=>!m.includes(h)).reduce((h,f)=>(h.add(f),h),new Set),g=new Set;for(const h of P){if(y.has(h))continue;const f=_[h],E=R[h];k.equals(f,E)||g.add(h)}return{added:I,removed:y,updated:g}}}),define(ce[235],le([0,1,20,34,85,41,30,77,24]),function(ie,e,k,O,T,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function m(a,w,S){let l=[];S?l=y(S):l=I(w);const C=[],U=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(l))for(const N of l)N.startsWith("-")?U.push(N.substring(1)):C.push(N);return(0,k.distinct)([...a,...C].filter(N=>!U.includes(N)))}e.getIgnoredSettings=m;function I(a){let w=a.inspect("settingsSync.ignoredSettings").userValue;return w!==void 0||(w=a.inspect("sync.ignoredSettings").userValue,w!==void 0)?w:a.getValue("settingsSync.ignoredSettings")||[]}function y(a){const w=(0,O.parse)(a);return w?w["settingsSync.ignoredSettings"]||w["sync.ignoredSettings"]||[]:[]}function g(a,w){const S=(0,O.parse)(a)||{};let l="{}";for(const C of Object.keys(S)){const U=(0,T.setProperty)(l,[C],S[C],w);l=(0,T.applyEdits)(l,U)}return l}e.removeComments=g;function h(a,w,S,l){if(S.length){const C=r(w),U=(0,O.parse)(w)||{},N=(0,O.parse)(a);if(!N)return a;const F=[];for(const $ of S){const z=U[$],J=N[$];z===void 0?a=R.edit(a,[$],void 0,l):J!==void 0?a=R.edit(a,[$],z,l):F.push(t($,C))}F.sort(($,z)=>$.startOffset-z.startOffset),F.forEach($=>a=d($.setting.key,w,a,l))}return a}e.updateIgnoredSettings=h;function f(a,w,S,l,C,U){const N=h(a,w,l,U),F=S!==N,$=S!==w;if(!F&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!$)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if($&&!F)return{conflictsSettings:[],localContent:h(w,a,l,U),remoteContent:null,hasConflicts:!1};if(S===null&&c(a)){const D=E(a,w,l)?null:h(w,a,l,U);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let z=a,J=w;const H=(0,O.parse)(a),Q=(0,O.parse)(w),B=S?(0,O.parse)(S):null,Y=l.reduce((D,M)=>(D.add(M),D),new Set),x=u(H,Q,Y),j=u(B,H,Y),q=u(B,Q,Y),Z=new Map,oe=new Set,ae=D=>{oe.add(D);const M=C.filter(({key:V})=>V===D)[0];M?(z=R.edit(z,[D],M.value,U),J=R.edit(J,[D],M.value,U)):Z.set(D,{key:D,localValue:H[D],remoteValue:Q[D]})};for(const D of j.removed.values())q.updated.has(D)?ae(D):J=R.edit(J,[D],void 0,U);for(const D of q.removed.values())oe.has(D)||(j.updated.has(D)?ae(D):z=R.edit(z,[D],void 0,U));for(const D of j.updated.values())oe.has(D)||(q.updated.has(D)?x.updated.has(D)&&ae(D):J=R.edit(J,[D],H[D],U));for(const D of q.updated.values())oe.has(D)||(j.updated.has(D)?x.updated.has(D)&&ae(D):z=R.edit(z,[D],Q[D],U));for(const D of j.added.values())oe.has(D)||(q.added.has(D)?x.updated.has(D)&&ae(D):J=d(D,z,J,U));for(const D of q.added.values())oe.has(D)||(j.added.has(D)?x.updated.has(D)&&ae(D):z=d(D,J,z,U));const G=Z.size>0||!E(z,J,l),W=G||!E(z,a,[]),b=G||!E(J,w,[]);return{localContent:W?z:null,remoteContent:b?J:null,conflictsSettings:[...Z.values()],hasConflicts:G}}e.merge=f;function E(a,w,S){if(a===w)return!0;const l=(0,O.parse)(a),C=(0,O.parse)(w),U=S.reduce(($,z)=>($.add(z),$),new Set),N=r(a).filter($=>!($.setting&&U.has($.setting.key))),F=r(w).filter($=>!($.setting&&U.has($.setting.key)));if(N.length!==F.length)return!1;for(let $=0;$<N.length;$++){const z=N[$],J=F[$];if(z.setting&&J.setting){if(z.setting.key!==J.setting.key||!_.equals(l[z.setting.key],C[z.setting.key]))return!1}else if(!z.setting&&!J.setting){if(z.value!==J.value)return!1}else return!1}return!0}function c(a){return a?r(a).length===0:!0}e.isEmpty=c;function u(a,w,S){const l=a?Object.keys(a).filter($=>!S.has($)):[],C=Object.keys(w).filter($=>!S.has($)),U=C.filter($=>!l.includes($)).reduce(($,z)=>($.add(z),$),new Set),N=l.filter($=>!C.includes($)).reduce(($,z)=>($.add(z),$),new Set),F=new Set;if(a)for(const $ of l){if(N.has($))continue;const z=a[$],J=w[$];_.equals(z,J)||F.add($)}return{added:U,removed:N,updated:F}}function d(a,w,S,l){const C=(0,O.parse)(w),U=r(w),N=r(S),F=v(a,U,N);return p(S,a,C[a],F,N,l)}e.addSetting=d;function v(a,w,S){const l=w.findIndex(U=>U.setting?.key===a),C=w[l-1];if(C){if(C.setting){const N=t(C.setting.key,S);if(N)return{index:S.indexOf(N),insertAfter:!0}}else{const N=o(l,w);if(N){const F=t(N.setting.key,S);if(F){const $=s(S.indexOf(F),S),z=n(w,N,w[l]);if($){const J=n(S,F,$),H=i(z,J);return H?{index:S.indexOf(H),insertAfter:!0}:{index:S.indexOf($),insertAfter:!1}}else{const J=n(S,F,S[S.length-1]),H=i(z,J);return H?{index:S.indexOf(H),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const U=w[l+1];if(U)if(U.setting){const N=t(U.setting.key,S);if(N)return{index:S.indexOf(N),insertAfter:!1}}else{const N=s(l,w);if(N){const F=t(N.setting.key,S);if(F){const $=o(S.indexOf(F),S),z=n(w,w[l],N);if($){const J=n(S,$,F),H=i(z.reverse(),J.reverse());return H?{index:S.indexOf(H),insertAfter:!1}:{index:S.indexOf($),insertAfter:!0}}else{const J=n(S,S[0],F),H=i(z.reverse(),J.reverse());return H?{index:S.indexOf(H),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function p(a,w,S,l,C,U){let N;return l.index===-1?N=(0,T.setProperty)(a,[w],S,U):N=L(a,w,S,l,C,U).map(F=>(0,T.withFormatting)(a,F,U)[0]),(0,T.applyEdits)(a,N)}function L(a,w,S,l,C,U){const N=`${JSON.stringify(w)}: ${JSON.stringify(S)}`,F=(0,A.getEOL)(U,a),$=C[l.index];if(l.insertAfter){const z=[];if($.setting)z.push({offset:$.endOffset,length:0,content:","+N});else{const J=s(l.index,C),H=o(l.index,C),Q=H?.setting?.commaOffset;H&&Q===void 0&&z.push({offset:H.endOffset,length:0,content:","});const B=Q!==void 0&&Q>$.endOffset;z.push({offset:B?Q+1:$.endOffset,length:0,content:J?F+N+",":F+N})}return z}else{if($.setting)return[{offset:$.startOffset,length:0,content:N+","}];const z=(C[l.index-1]&&!C[l.index-1].setting?F:"")+N+(s(l.index,C)?",":"")+F;return[{offset:$.startOffset,length:0,content:z}]}}function t(a,w){return w.filter(S=>S.setting?.key===a)[0]}function o(a,w){for(let S=a-1;S>=0;S--)if(w[S].setting)return w[S]}function s(a,w){for(let S=a+1;S<w.length;S++)if(w[S].setting)return w[S]}function n(a,w,S){const l=a.indexOf(w),C=a.indexOf(S);return a.filter((U,N)=>l<N&&N<C)}function i(a,w){if(a.length&&w.length){let S=0;for(;S<w.length&&S<a.length;S++)if(a[S].value!==w[S].value)return w[S-1];return w[S-1]}}function r(a){const w=[];let S=-1,l,C;const U={onObjectBegin:N=>{S++},onObjectProperty:(N,F,$)=>{S===0&&(l=F,C=N)},onObjectEnd:(N,F)=>{S--,S===0&&w.push({startOffset:l,endOffset:N+F,value:a.substring(l,N+F),setting:{key:C,commaOffset:void 0}})},onArrayBegin:(N,F)=>{S++},onArrayEnd:(N,F)=>{S--,S===0&&w.push({startOffset:l,endOffset:N+F,value:a.substring(l,N+F),setting:{key:C,commaOffset:void 0}})},onLiteralValue:(N,F,$)=>{S===0&&w.push({startOffset:l,endOffset:F+$,value:a.substring(l,F+$),setting:{key:C,commaOffset:void 0}})},onSeparator:(N,F,$)=>{if(S===0&&N===","){let z=w.length-1;for(;z>=0&&!w[z].setting;z--);const J=w[z];J&&w.splice(z,1,{startOffset:J.startOffset,endOffset:J.endOffset,value:J.value,setting:{key:J.setting.key,commaOffset:F}})}},onComment:(N,F)=>{S===0&&w.push({startOffset:N,endOffset:N+F,value:a.substring(N,N+F)})}};return(0,O.visit)(a,U),w}}),define(ce[78],le([0,1,3,2,4,24]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,T.createDecorator)("IUserDataSyncAccountService");let _=class extends O.Disposable{get account(){return this._account}constructor(P,m){super(),this.userDataSyncStoreService=P,this.logService=m,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(P.onTokenFailed(I=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,I),this.updateAccount(void 0),I==="Forbidden"?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(P.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(P){(P&&this._account?P.token!==this._account.token||P.authenticationProviderId!==this._account.authenticationProviderId:P!==this._account)&&(this._account=P,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(P))}};e.UserDataSyncAccountService=_,e.UserDataSyncAccountService=_=ye([K(0,A.IUserDataSyncStoreService),K(1,A.IUserDataSyncLogService)],_)}),define(ce[236],le([0,1,2,10]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class T{constructor(g){this.service=g}listen(g,h){switch(h){case"onError":return this.service.onError}throw new Error(`Event not found: ${h}`)}call(g,h,f){switch(h){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=T;class A{constructor(g){this.service=g}listen(g,h){throw new Error(`Event not found: ${h}`)}call(g,h,f){switch(h){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(O.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class _{constructor(g){this.channel=g}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.channel.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.channel.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=_;class R{constructor(g){this.service=g}listen(g,h){switch(h){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${h}`)}async call(g,h,f){switch(h){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablements":return this.service.setEnablements(f)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class P{constructor(g){this.service=g}listen(g,h){switch(h){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${h}`)}call(g,h,f){switch(h){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=P;class m{constructor(g){this.service=g}listen(g,h){switch(h){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${h}`)}call(g,h,f){switch(h){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=m;class I extends k.Disposable{constructor(g){super(),this.channel=g,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.channel.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(g)}revive(g){return{url:O.URI.revive(g.url),type:g.type,defaultUrl:O.URI.revive(g.defaultUrl),insidersUrl:O.URI.revive(g.insidersUrl),stableUrl:O.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(ce[237],le([0,1,173,7,24]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let A=class extends O.AbstractLogger{constructor(R){super(),this.logger=this._register(R.createLogger(T.USER_DATA_SYNC_LOG_ID,{name:(0,k.localize)(0,null)}))}trace(R,...P){this.logger.trace(R,...P)}debug(R,...P){this.logger.debug(R,...P)}info(R,...P){this.logger.info(R,...P)}warn(R,...P){this.logger.warn(R,...P)}error(R,...P){this.logger.error(R,...P)}flush(){this.logger.flush()}};e.UserDataSyncLogService=A,e.UserDataSyncLogService=A=ye([K(0,O.ILoggerService)],A)}),define(ce[112],le([0,1,7,4,23]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VoiceRecognitionService=e.IVoiceRecognitionService=void 0,e.IVoiceRecognitionService=(0,O.createDecorator)("voiceRecognitionService");let A=class{constructor(R,P){this.logService=R,this.productService=P}async transcribe(R,P){this.logService.info(`[voice] transcribe(${R.length}): Begin`);const m=process.env.VSCODE_VOICE_MODULE_PATH;if(!m||this.productService.quality==="stable")throw this.logService.error(`[voice] transcribe(${R.length}): Voice recognition not yet supported`),new Error("Voice recognition not yet supported!");const I=Date.now();this.logService.info(`[voice] transcribe(${R.length}): Getting module from ${m}`);try{const y=ie.__$__nodeRequire(m),g=new AbortController;P.onCancellationRequested(()=>g.abort());const h=await y.transcribe({samplingRate:16e3,bitDepth:16,channelCount:1,channelData:R},{language:"en",suppressNonSpeechTokens:!0,signal:g.signal});return this.logService.info(`[voice] transcribe(${R.length}): End (text: "${h}", took: ${Date.now()-I}ms)`),h}catch(y){throw this.logService.error(`[voice] transcribe(${R.length}): Failed (error: "${y}", took: ${Date.now()-I}ms)`),y}}};e.VoiceRecognitionService=A,e.VoiceRecognitionService=A=ye([K(0,k.ILogService),K(1,T.IProductService)],A)}),define(ce[238],le([0,1,2,112,7,25,5]),function(ie,e,k,O,T,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VoiceTranscriptionManager=void 0;let R=class extends k.Disposable{constructor(I,y,g){super(),this.onDidWindowConnectRaw=I,this.voiceRecognitionService=y,this.logService=g,this.registerListeners()}registerListeners(){this._register(this.onDidWindowConnectRaw(I=>{this._register(new P(I,this.voiceRecognitionService,this.logService))}))}};e.VoiceTranscriptionManager=R,e.VoiceTranscriptionManager=R=ye([K(1,O.IVoiceRecognitionService),K(2,T.ILogService)],R);class P extends k.Disposable{static{this.MAX_DATA_LENGTH=30*16e3*16*1/8}constructor(I,y,g){super(),this.port=I,this.voiceRecognitionService=y,this.logService=g,this.transcriptionQueue=new _.LimitedQueue,this.data=void 0,this.registerListeners()}registerListeners(){this.logService.info("[voice] transcriber: new connection");const I=new A.CancellationTokenSource;this._register((0,k.toDisposable)(()=>I.dispose(!0)));const y=g=>this.handleRequest(g,I.token);this.port.on("message",y),this._register((0,k.toDisposable)(()=>this.port.off("message",y))),this.port.start(),this._register((0,k.toDisposable)(()=>this.port.close())),this.port.on("close",()=>{this.logService.info("[voice] transcriber: closed connection"),I.dispose(!0)})}async handleRequest(I,y){if(!Array.isArray(I.data))return;const g=[];for(const f of I.data)f instanceof Float32Array&&g.push(f);const h=this.joinFloat32Arrays(this.data?[this.data,...g]:g);if(h.length>P.MAX_DATA_LENGTH){this.logService.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}this.data=h,this.transcriptionQueue.queue(()=>this.transcribe(y))}async transcribe(I){if(I.isCancellationRequested)return;const y=this.data?.slice(0);if(!y)return;const g=await this.voiceRecognitionService.transcribe(y,I);I.isCancellationRequested||this.port.postMessage(g)}joinFloat32Arrays(I){const y=new Float32Array(I.reduce((h,f)=>h+f.length,0));let g=0;for(const h of I)y.set(h,g),g+=h.length;return y}}}),define(ce[239],le([0,1,5,3,2]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends T.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:P,getActiveWindowId:m}){super(),this.disposables=this._register(new T.DisposableStore),O.Event.latch(O.Event.any(R,P))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>m()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(ce[113],le([0,1,176,16,47,22,10,4,26]),function(ie,e,k,O,T,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function m(n){const i=n;return typeof i?.id=="string"&&_.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=m;function I(n){return typeof n?.id=="string"&&!m(n)&&!g(n)}e.isEmptyWorkspaceIdentifier=I,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,O.basename)(n)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=n;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=y;function g(n){const i=n;return typeof i?.id=="string"&&_.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=g;function h(n){const i=n;if(i?.uri)return{id:i.id,uri:_.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:_.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=h;var f;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function E(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=E;function c(n){const i=n;return!!(i&&typeof i=="object"&&_.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=c;class u{constructor(i,r,a,w,S){this._id=i,this._transient=a,this._configuration=w,this._ignorePathCasing=S,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class d{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,A.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function v(n){return new d({uri:n,index:0,name:(0,A.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(n,i){return A.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function L(n){let i;return _.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===P.Schemas.tmp}e.isTemporaryWorkspace=L,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function o(n,i){return!p(n,i)&&!L(n)}e.isSavedWorkspace=o;function s(n){return(typeof n=="string"?(0,O.extname)(n):(0,A.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ce[17],le([0,1,51,3,2,22,10,167,15,13,4,7,113,35,27,5,32,28,11]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var v;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(v||(e.ProfileResourceType=v={}));function p(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&_.URI.isUri(i.location)&&_.URI.isUri(i.globalStorageHome)&&_.URI.isUri(i.settingsResource)&&_.URI.isUri(i.keybindingsResource)&&_.URI.isUri(i.tasksResource)&&_.URI.isUri(i.snippetsHome)&&_.URI.isUri(i.extensionsResource))}e.isUserDataProfile=p,e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function L(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:_.URI.revive(n.location).with({scheme:i}),globalStorageHome:_.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:_.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:_.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:_.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:_.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:_.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:_.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=L;function t(n,i,r,a,w,S){return{id:n,name:i,location:r,isDefault:!1,shortName:w?.shortName,globalStorageHome:S&&w?.useDefaultFlags?.globalState?S.globalStorageHome:(0,A.joinPath)(r,"globalStorage"),settingsResource:S&&w?.useDefaultFlags?.settings?S.settingsResource:(0,A.joinPath)(r,"settings.json"),keybindingsResource:S&&w?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,A.joinPath)(r,"keybindings.json"),tasksResource:S&&w?.useDefaultFlags?.tasks?S.tasksResource:(0,A.joinPath)(r,"tasks.json"),snippetsHome:S&&w?.useDefaultFlags?.snippets?S.snippetsHome:(0,A.joinPath)(r,"snippets"),extensionsResource:S&&w?.useDefaultFlags?.extensions?S.extensionsResource:(0,A.joinPath)(r,"extensions.json"),cacheHome:(0,A.joinPath)(a,n),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}e.toUserDataProfile=t;let o=class extends T.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,r,a,w){super(),this.environmentService=i,this.fileService=r,this.uriIdentityService=a,this.logService=w,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=this.createDefaultProfile(),r=[i];if(this.enabled)try{for(const S of this.getStoredProfiles()){if(!S.name||!(0,d.isString)(S.name)||!S.location){this.logService.warn("Skipping the invalid stored profile",S.location||S.name);continue}r.push(t((0,A.basename)(S.location),S.name,S.location,this.profilesCacheHome,{shortName:S.shortName,useDefaultFlags:S.useDefaultFlags},i))}}catch(S){this.logService.error(S)}const a=new h.ResourceMap,w=new Map;if(r.length)try{const S=this.getStoredProfileAssociations();if(S.workspaces)for(const[l,C]of Object.entries(S.workspaces)){const U=_.URI.parse(l),N=r.find(F=>F.id===C);N&&a.set(U,N)}if(S.emptyWindows)for(const[l,C]of Object.entries(S.emptyWindows)){const U=r.find(N=>N.id===C);U&&w.set(l,U)}}catch(S){this.logService.error(S)}this._profilesObject={profiles:r,workspaces:a,emptyWindows:w}}return this._profilesObject}createDefaultProfile(){const i=t("__default__profile__",(0,R.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...i,extensionsResource:this.getDefaultProfileExtensionsLocation()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const r="Temp",a=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let w=0;for(const l of this.profiles){const C=a.exec(l.name),U=C?parseInt(C[1]):0;w=U>w?U:w}const S=`${r} ${w+1}`;return this.createProfile((0,k.hash)((0,c.generateUuid)()).toString(16),S,{transient:!0},i)}async createNamedProfile(i,r,a){return this.createProfile((0,k.hash)((0,c.generateUuid)()).toString(16),i,r,a)}async createProfile(i,r,a,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const S=await this.doCreateProfile(i,r,a);return w&&await this.setProfileForWorkspace(w,S),S}async doCreateProfile(i,r,a){if(!(0,d.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.profileCreationPromises.get(r);return w||(w=(async()=>{try{const S=this.profiles.find(U=>U.name===r||U.id===i);if(S)return S;const l=t(i,r,(0,A.joinPath)(this.profilesHome,i),this.profilesCacheHome,a,this.defaultProfile);await this.fileService.createFolder(l.location);const C=[];return this._onWillCreateProfile.fire({profile:l,join(U){C.push(U)}}),await E.Promises.settled(C),this.updateProfiles([l],[],[]),l}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,w)),w}async updateProfile(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(w=>w.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=t(a.id,r.name??a.name,a.location,this.profilesCacheHome,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[a]),a}async removeProfile(i){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(w=>w.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this._onWillRemoveProfile.fire({profile:r,join(w){a.push(w)}});try{await Promise.allSettled(a)}catch(w){this.logService.error(w)}for(const w of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(w)?.id&&this.profilesObject.emptyWindows.delete(w);for(const w of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(w)?.id&&this.profilesObject.workspaces.delete(w);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{await this.fileService.del(r.cacheHome,{recursive:!0})}catch(w){(0,m.toFileOperationResult)(w)!==1&&this.logService.error(w)}}async setProfileForWorkspace(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(w=>w.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,a)}unsetWorkspace(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(i,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.uriIdentityService.extUri.isEqual(a.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.getWorkspace(i);return _.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(i){return(0,g.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,g.isWorkspaceIdentifier)(i)?i.configPath:i.id}isProfileAssociatedToWorkspace(i){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location)))}updateProfiles(i,r,a){const w=[...this.profiles,...i],S=[];this.transientProfilesObject.profiles=[];for(let l of w)l.isDefault||r.some(C=>l.id===C.id)||(l=a.find(C=>l.id===C.id)??l,l.isTransient?this.transientProfilesObject.profiles.push(l):S.push({location:l.location,name:l.name,shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}));this.saveStoredProfiles(S),this._profilesObject=void 0,this.triggerProfilesChanges(i,r,a)}triggerProfilesChanges(i,r,a){this._onDidChangeProfiles.fire({added:i,removed:r,updated:a,all:this.profiles})}updateWorkspaceAssociation(i,r,a){a=r?.isTransient?!0:a,a||this.updateWorkspaceAssociation(i,void 0,!0);const w=this.getWorkspace(i),S=a?this.transientProfilesObject:this.profilesObject;_.URI.isUri(w)?(S.workspaces.delete(w),r&&S.workspaces.set(w,r)):(S.emptyWindows.delete(w),r&&S.emptyWindows.set(w,r)),a||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[a,w]of this.profilesObject.workspaces.entries())i[a.toString()]=w.id;const r={};for(const[a,w]of this.profilesObject.emptyWindows.entries())r[a.toString()]=w.id;this.saveStoredProfileAssociations({workspaces:i,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(i){const r={},a=this.createDefaultProfile();if(i.workspaces)for(const[S,l]of Object.entries(i.workspaces)){const C=_.URI.parse(l);r[S]=this.uriIdentityService.extUri.isEqual(C,a.location)?a.id:this.uriIdentityService.extUri.basename(C)}const w={};if(i.emptyWindows)for(const[S,l]of Object.entries(i.emptyWindows)){const C=_.URI.parse(l);w[S]=this.uriIdentityService.extUri.isEqual(C,a.location)?a.id:this.uriIdentityService.extUri.basename(C)}return{workspaces:r,emptyWindows:w}}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=o,e.UserDataProfilesService=o=ye([K(0,P.IEnvironmentService),K(1,m.IFileService),K(2,f.IUriIdentityService),K(3,y.ILogService)],o);class s extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=s}),define(ce[240],le([0,1,5,2,17]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let A=class extends O.Disposable{constructor(R){super(),this._register(new k.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=A,e.UserDataProfilesCleaner=A=ye([K(0,T.IUserDataProfilesService)],A)}),define(ce[241],le([0,1,20,5,25,8,3,2,6,11,10,150,29,33,45,7,23,21,27,17]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let p=class extends R.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(i,r,a,w,S,l){super(),this.galleryService=i,this.telemetryService=r,this.uriIdentityService=a,this.logService=w,this.productService=S,this.userDataProfilesService=l,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new _.Emitter),this._onDidInstallExtensions=this._register(new _.Emitter),this._onUninstallExtension=this._register(new _.Emitter),this._onDidUninstallExtension=this._register(new _.Emitter),this._onDidUpdateExtensionMetadata=this._register(new _.Emitter),this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(({task:C})=>C.cancel()),this.uninstallingExtensions.forEach(C=>C.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(a=>(0,g.isTargetPlatformCompatible)(a,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{const w=(await this.installGalleryExtensions([{extension:i,options:r}])).find(({identifier:S})=>(0,h.areSameExtensions)(S,i.identifier));if(w?.local)return w?.local;throw w?.error?w.error:t(new Error(`Unknown error while installing extension ${i.identifier.id}`))}catch(a){throw t(a)}}async installGalleryExtensions(i){if(!this.galleryService.isEnabled())throw new g.ExtensionManagementError(y.localize(0,null),g.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(i.map(async({extension:w,options:S})=>{try{const l=await this.checkAndGetCompatibleVersion(w,!!S?.installGivenVersion,!!S?.installPreReleaseVersion);a.push({...l,options:S})}catch(l){r.push({identifier:w.identifier,operation:2,source:w,error:l})}})),a.length&&r.push(...await this.installExtensions(a));for(const w of r)w.error&&(this.logService.error("Failed to install extension.",w.identifier.id),this.logService.error(w.error),w.source&&!I.URI.isUri(w.source)&&o(this.telemetryService,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(w.source),error:w.error}));return r}async uninstall(i,r={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,r)}async toggleAppliationScope(i,r){if((0,f.isApplicationScopedExtension)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let a=await this.updateMetadata(i,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)||(a=await this.copyExtension(i,this.userDataProfilesService.defaultProfile.extensionsResource,r));for(const w of this.userDataProfilesService.profiles){const S=(await this.getInstalled(1,w.extensionsResource)).find(l=>(0,h.areSameExtensions)(l.identifier,i.identifier));S?this._onDidUpdateExtensionMetadata.fire(S):this._onDidUninstallExtension.fire({identifier:i.identifier,profileLocation:w.extensionsResource})}return a}else{const a=this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(i,r,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtensions(i){const r=[];return await Promise.allSettled(i.map(async a=>{try{const w=await this.installExtension(a);r.push(...w)}catch(w){r.push({identifier:{id:(0,h.getGalleryExtensionId)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:w})}})),this._onDidInstallExtensions.fire(r),r}async installExtension({manifest:i,extension:r,options:a}){const w=a.isApplicationScoped||a.isBuiltin||(0,f.isApplicationScopedExtension)(i),S={...a,installOnlyNewlyAddedFromExtensionPack:I.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:w,profileLocation:w?this.userDataProfilesService.defaultProfile.extensionsResource:a.profileLocation??this.getCurrentExtensionsManifestLocation()},l=z=>`${h.ExtensionKey.create(z).toString()}${S.profileLocation?`-${S.profileLocation.toString()}`:""}`;if(!I.URI.isUri(r)){const z=this.installingExtensions.get(l(r));if(z)return this.logService.info("Extensions is already requested to install",r.identifier.id),await z.task.waitUntilTaskIsFinished(),[]}const C=[],U=[],N=[],F=this.createInstallExtensionTask(i,r,S);I.URI.isUri(r)||this.installingExtensions.set(l(r),{task:F,waitingTasks:[]}),this._onInstallExtension.fire({identifier:F.identifier,source:r,profileLocation:S.profileLocation}),this.logService.info("Installing extension:",F.identifier.id),C.push({task:F,manifest:i});let $=!1;try{if(S.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",F.identifier.id);else try{const J=await this.getAllDepsAndPackExtensions(F.identifier,i,!!S.installOnlyNewlyAddedFromExtensionPack,!!S.installPreReleaseVersion,S.profileLocation),H=await this.getInstalled(void 0,S.profileLocation),Q={...S,donotIncludePackAndDependencies:!0,context:{...S.context,[g.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:B,manifest:Y}of(0,k.distinct)(J,({gallery:x})=>x.identifier.id)){$=$||!!Y.extensionDependencies?.some(q=>(0,h.areSameExtensions)({id:q},F.identifier));const x=l(B),j=this.installingExtensions.get(x);if(j){if(this.canWaitForTask(F,j.task)){const q=j.task.identifier;this.logService.info("Waiting for already requested installing extension",q.id,F.identifier.id),j.waitingTasks.push(F),U.push(_.Event.toPromise(_.Event.filter(this.onDidInstallExtensions,Z=>Z.some(oe=>(0,h.areSameExtensions)(oe.identifier,q)))).then(Z=>{if(this.logService.info("Finished waiting for already requested installing extension",q.id,F.identifier.id),!Z.find(ae=>(0,h.areSameExtensions)(ae.identifier,q))?.local)throw new Error(`Extension ${q.id} is not installed`)}))}}else if(!H.some(({identifier:q})=>(0,h.areSameExtensions)(q,B.identifier))){const q=this.createInstallExtensionTask(Y,B,Q);this.installingExtensions.set(x,{task:q,waitingTasks:[F]}),this._onInstallExtension.fire({identifier:q.identifier,source:B,profileLocation:S.profileLocation}),this.logService.info("Installing extension:",q.identifier.id,F.identifier.id),C.push({task:q,manifest:Y})}}}catch(J){if(I.URI.isUri(F.source))(0,k.isNonEmptyArray)(i.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",F.identifier.id,J.message),(0,k.isNonEmptyArray)(i.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",F.identifier.id,J.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",F.identifier.id),J}const z=C.reduce((J,{task:H,manifest:Q})=>(J.set(H.identifier.id.toLowerCase(),{task:H,manifest:Q}),J),new Map);for(;z.size;){let J;const H=[...z.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(B=>z.has(B.toLowerCase())));H.length?J=z.size===1?H:H.filter(({task:Q})=>!(Q===F&&!$)):(this.logService.info("Found extensions with circular dependencies",H.map(({task:Q})=>Q.identifier.id)),J=[...z.values()]),await this.joinAllSettled(J.map(async({task:Q})=>{const B=new Date().getTime();try{const Y=await Q.run();if(await this.joinAllSettled(this.participants.map(x=>x.postInstall(Y,Q.source,S,T.CancellationToken.None))),!I.URI.isUri(Q.source)){const x=Q.operation===3,j=x?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(o(this.telemetryService,x?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-B,durationSinceUpdate:j}),P.isWeb&&Q.operation!==3)try{await this.galleryService.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,"install")}catch{}}N.push({local:Y,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:Q.options.context,profileLocation:Q.profileLocation,applicationScoped:Y.isApplicationScoped})}catch(Y){throw I.URI.isUri(Q.source)||o(this.telemetryService,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-B,error:Y}),this.logService.error("Error while installing the extension:",Q.identifier.id),Y}finally{z.delete(Q.identifier.id.toLowerCase())}}))}return U.length&&await this.joinAllSettled(U),N.forEach(({identifier:J})=>this.logService.info("Extension installed successfully:",J.id)),N}catch(z){if(C.forEach(({task:J})=>J.cancel()),N.length)try{const J=await Promise.allSettled(N.map(({local:H})=>this.createUninstallExtensionTask(H,{versionOnly:!0,profileLocation:S.profileLocation}).run()));for(let H=0;H<J.length;H++){const Q=J[H],{identifier:B}=N[H];Q.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",B.id):this.logService.warn("Rollback: Error while uninstalling extension",B.id,(0,A.getErrorMessage)(Q.reason))}}catch(J){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(J),N.map(({identifier:H})=>H.id))}return C.map(({task:J})=>({identifier:J.identifier,operation:2,source:J.source,context:S.context,profileLocation:S.profileLocation,error:z}))}finally{for(const{task:z}of C)z.source&&!I.URI.isUri(z.source)&&this.installingExtensions.delete(l(z.source))}}canWaitForTask(i,r){for(const[,{task:a,waitingTasks:w}]of this.installingExtensions.entries())if(a===i&&(w.includes(r)||w.some(S=>this.canWaitForTask(S,r)))||a===r&&w[0]&&!this.canWaitForTask(i,w[0]))return!1;return!0}async joinAllSettled(i){const r=[],a=[],w=await Promise.allSettled(i);for(const S of w)S.status==="fulfilled"?r.push(S.value):a.push(S.reason);if(a.length)throw L(a);return r}async getAllDepsAndPackExtensions(i,r,a,w,S){if(!this.galleryService.isEnabled())return[];const l=await this.getInstalled(void 0,S),C=[],U=[],N=async(F,$)=>{C.push(F);const z=$.extensionDependencies||[],J=[...z];if($.extensionPack){const H=a?l.find(Q=>(0,h.areSameExtensions)(Q.identifier,F)):void 0;for(const Q of $.extensionPack)H&&H.manifest.extensionPack&&H.manifest.extensionPack.some(B=>(0,h.areSameExtensions)({id:B},{id:Q}))||J.every(B=>!(0,h.areSameExtensions)({id:B},{id:Q}))&&J.push(Q)}if(J.length){const H=J.filter(Q=>C.every(B=>!(0,h.areSameExtensions)(B,{id:Q})));if(H.length){const Q=await this.galleryService.getExtensions(H.map(B=>({id:B,preRelease:w})),T.CancellationToken.None);for(const B of Q){if(C.find(j=>(0,h.areSameExtensions)(j,B.identifier)))continue;const Y=z.some(j=>(0,h.areSameExtensions)({id:j},B.identifier));let x;try{x=await this.checkAndGetCompatibleVersion(B,!1,w)}catch(j){if(Y)throw j;this.logService.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,A.getErrorMessage)(j));continue}U.push({gallery:x.extension,manifest:x.manifest}),await N(x.extension.identifier,x.manifest)}}}};return await N(i,r),U}async checkAndGetCompatibleVersion(i,r,a){let w;const S=await this.getExtensionsControlManifest();if(S.malicious.some(U=>(0,h.areSameExtensions)(i.identifier,U)))throw new g.ExtensionManagementError(y.localize(1,null,i.identifier.id),g.ExtensionManagementErrorCode.Malicious);const l=S.deprecated[i.identifier.id.toLowerCase()];if(l?.extension?.autoMigrate){if(this.logService.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${l.extension.id}' extension instead.`),w=(await this.galleryService.getExtensions([{id:l.extension.id,preRelease:l.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},T.CancellationToken.None))[0],!w)throw new g.ExtensionManagementError(y.localize(2,null,i.identifier.id,l.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const U=await this.getTargetPlatform();throw new g.ExtensionManagementError(y.localize(3,null,i.identifier.id,this.productService.nameLong,(0,g.TargetPlatformToString)(U)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(w=await this.getCompatibleVersion(i,r,a),!w)throw!a&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],T.CancellationToken.None))[0]?new g.ExtensionManagementError(y.localize(4,null,i.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.ExtensionManagementError(y.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",w.identifier.id);const C=await this.galleryService.getManifest(w,T.CancellationToken.None);if(C===null)throw new g.ExtensionManagementError(`Missing manifest for extension ${w.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(C.version!==w.version)throw new g.ExtensionManagementError(`Cannot install '${w.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:w,manifest:C}}async getCompatibleVersion(i,r,a){const w=await this.getTargetPlatform();let S=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==a&&(S=(await this.galleryService.getExtensions([{...i.identifier,preRelease:a}],{targetPlatform:w,compatible:!0},T.CancellationToken.None))[0]||null),!S&&await this.galleryService.isExtensionCompatible(i,a,w)&&(S=i),S||(r?S=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:w,compatible:!0},T.CancellationToken.None))[0]||null:S=await this.galleryService.getCompatibleExtension(i,a,w)),S}async uninstallExtension(i,r){const a={...r,profileLocation:i.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},w=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${i.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,S=this.uninstallingExtensions.get(w(i.identifier));if(S)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),S.waitUntilTaskIsFinished();const l=F=>{const $=this.createUninstallExtensionTask(F,a);return this.uninstallingExtensions.set(w($.extension.identifier),$),a.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this._onUninstallExtension.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),$},C=(F,$)=>{$?a.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),$.message):this.logService.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,$.message):a.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),o(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(F),error:$}),this._onDidUninstallExtension.fire({identifier:F.identifier,error:$?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},U=[],N=[];try{U.push(l(i));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const $=this.getAllPackExtensionsToUninstall(i,F);for(const z of $)this.uninstallingExtensions.has(w(z.identifier))?this.logService.info("Extensions is already requested to uninstall",z.identifier.id):U.push(l(z))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(U.map($=>$.extension),F,i),await this.joinAllSettled(U.map(async $=>{try{if(await $.run(),await this.joinAllSettled(this.participants.map(z=>z.postUninstall($.extension,a,T.CancellationToken.None))),$.extension.identifier.uuid)try{await this.galleryService.reportStatistic($.extension.manifest.publisher,$.extension.manifest.name,$.extension.manifest.version,"uninstall")}catch{}C($.extension)}catch(z){const J=z instanceof g.ExtensionManagementError?z:new g.ExtensionManagementError((0,A.getErrorMessage)(z),g.ExtensionManagementErrorCode.Internal);throw C($.extension,J),J}finally{N.push($)}}))}catch(F){const $=F instanceof g.ExtensionManagementError?F:new g.ExtensionManagementError((0,A.getErrorMessage)(F),g.ExtensionManagementErrorCode.Internal);for(const z of U){try{z.cancel()}catch{}N.includes(z)||C(z.extension,$)}throw $}finally{for(const F of U)this.uninstallingExtensions.delete(w(F.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}checkForDependents(i,r,a){for(const w of i){const S=this.getDependents(w,r);if(S.length){const l=S.filter(C=>!i.some(U=>(0,h.areSameExtensions)(U.identifier,C.identifier)));if(l.length)throw new Error(this.getDependentsErrorMessage(w,l,a))}}}getDependentsErrorMessage(i,r,a){return a===i?r.length===1?y.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?y.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):y.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?y.localize(9,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?y.localize(10,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):y.localize(11,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(i,r,a=[]){if(a.indexOf(i)!==-1)return[];a.push(i);const w=i.manifest.extensionPack?i.manifest.extensionPack:[];if(w.length){const S=r.filter(C=>!C.isBuiltin&&w.some(U=>(0,h.areSameExtensions)({id:U},C.identifier))),l=[];for(const C of S)l.push(...this.getAllPackExtensionsToUninstall(C,r,a));return[...S,...l]}return[]}getDependents(i,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(w=>(0,h.areSameExtensions)({id:w},i.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const i=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=p,e.AbstractExtensionManagementService=p=ye([K(0,g.IExtensionGalleryService),K(1,u.ITelemetryService),K(2,d.IUriIdentityService),K(3,E.ILogService),K(4,c.IProductService),K(5,v.IUserDataProfilesService)],p);function L(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=L;function t(n){if(n instanceof g.ExtensionManagementError)return n;const i=new g.ExtensionManagementError(n.message,g.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}e.toExtensionManagementError=t;function o(n,i,{extensionData:r,verificationStatus:a,duration:w,error:S,durationSinceUpdate:l}){let C,U;(0,m.isDefined)(a)&&(a===!0?a="Verified":(a===!1||(C=g.ExtensionManagementErrorCode.Signature,U=a),a="Unverified")),S&&(S instanceof g.ExtensionManagementError?(C=S.code,S.code===g.ExtensionManagementErrorCode.Signature&&(U=S.message)):C=g.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,verificationStatus:a,success:!S,duration:w,errorcode:C,errorcodeDetail:U,durationSinceUpdate:l})}class s{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(i=>new Promise((r,a)=>{const w=i.onCancellationRequested(()=>{w.dispose(),a(new A.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=s}),define(ce[50],le([0,1,5,14,2,3,35,10,29,33,13,4,7,17,27,11,8,21]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class v extends Error{constructor(s,n){super(s),this.code=n}}e.ExtensionsProfileScanningError=v,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let p=class extends T.Disposable{constructor(s,n,i,r,a,w){super(),this.extensionsLocation=s,this.fileService=n,this.userDataProfilesService=i,this.uriIdentityService=r,this.telemetryService=a,this.logService=w,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new _.ResourceMap}scanProfileExtensions(s,n){return this.withProfileExtensions(s,void 0,n)}async addExtensionsToProfile(s,n){const i=[],r=[];try{return await this.withProfileExtensions(n,a=>{const w=[];for(const S of a)s.some(([l])=>(0,m.areSameExtensions)(l.identifier,S.identifier)&&l.manifest.version!==S.version)?i.push(S):w.push(S);for(const[S,l]of s){const C=w.findIndex(N=>(0,m.areSameExtensions)(N.identifier,S.identifier)&&N.version===S.manifest.version),U={identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:l};C===-1?(r.push(U),w.push(U)):w.splice(C,1,U)}return r.length&&this._onAddExtensions.fire({extensions:r,profileLocation:n}),i.length&&this._onRemoveExtensions.fire({extensions:i,profileLocation:n}),w}),r.length&&this._onDidAddExtensions.fire({extensions:r,profileLocation:n}),i.length&&this._onDidRemoveExtensions.fire({extensions:i,profileLocation:n}),r}catch(a){throw r.length&&this._onDidAddExtensions.fire({extensions:r,error:a,profileLocation:n}),i.length&&this._onDidRemoveExtensions.fire({extensions:i,error:a,profileLocation:n}),a}}async updateMetadata(s,n){const i=[];return await this.withProfileExtensions(n,r=>{const a=[];for(const w of r){const S=s.find(([l])=>(0,m.areSameExtensions)(l.identifier,w.identifier)&&l.manifest.version===w.version);S&&(w.metadata={...w.metadata,...S[1]},i.push(w)),a.push(w)}return a}),i}async removeExtensionFromProfile(s,n){const i=[];try{await this.withProfileExtensions(n,r=>{const a=[];for(const w of r)(0,m.areSameExtensions)(w.identifier,s.identifier)?i.push(w):a.push(w);return i.length&&this._onRemoveExtensions.fire({extensions:i,profileLocation:n}),a}),i.length&&this._onDidRemoveExtensions.fire({extensions:i,profileLocation:n})}catch(r){throw i.length&&this._onDidRemoveExtensions.fire({extensions:i,error:r,profileLocation:n}),r}}async withProfileExtensions(s,n,i){return this.getResourceAccessQueue(s).queue(async()=>{let r=[],a;try{const w=await this.fileService.readFile(s);a=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,I.toFileOperationResult)(w)!==1)throw w;if(this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)&&(a=await this.migrateFromOldDefaultProfileExtensionsLocation()),!a&&i?.bailOutWhenFileNotFound)throw new v((0,c.getErrorMessage)(w),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.reportAndThrowInvalidConentError(s);let w=!1;for(const S of a){L(S)||this.reportAndThrowInvalidConentError(s);let l;if((0,E.isString)(S.relativeLocation)&&S.relativeLocation)l=this.resolveExtensionLocation(S.relativeLocation);else if((0,E.isString)(S.location))l=this.resolveExtensionLocation(S.location),w=!0,S.relativeLocation=S.location,S.location=l.toJSON();else{l=R.URI.revive(S.location);const C=this.toRelativePath(l);C&&(w=!0,S.relativeLocation=C)}r.push({identifier:S.identifier,location:l,version:S.version,metadata:S.metadata})}w&&await this.fileService.writeFile(s,O.VSBuffer.fromString(JSON.stringify(a)))}if(n){r=n(r);const w=r.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.toRelativePath(S.location),metadata:S.metadata}));await this.fileService.writeFile(s,O.VSBuffer.fromString(JSON.stringify(w)))}return r})}reportAndThrowInvalidConentError(s){const n=new v(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}toRelativePath(s){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(s),this.extensionsLocation)?this.uriIdentityService.extUri.basename(s):void 0}resolveExtensionLocation(s){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,s)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const s=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),n=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let i;try{i=(await this.fileService.readFile(s)).value.toString()}catch(a){if((0,I.toFileOperationResult)(a)===1)return;throw a}this.logService.info("Migrating extensions from old default profile location",s.toString());let r;try{const a=JSON.parse(i);Array.isArray(a)&&a.every(w=>L(w))?r=a:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.logService.error(a)}if(r)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(a){if((0,I.toFileOperationResult)(a)===3)this.logService.info("Migration from old default profile location to new location is done by another window",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw a}try{await this.fileService.del(s)}catch(a){(0,I.toFileOperationResult)(a)!==1&&this.logService.error(a)}try{await this.fileService.del(n)}catch(a){(0,I.toFileOperationResult)(a)!==1&&this.logService.error(a)}return r})()),this._migrationPromise}getResourceAccessQueue(s){let n=this.resourcesAccessQueueMap.get(s);return n||(n=new k.Queue,this.resourcesAccessQueueMap.set(s,n)),n}};e.AbstractExtensionsProfileScannerService=p,e.AbstractExtensionsProfileScannerService=p=ye([K(1,I.IFileService),K(2,h.IUserDataProfilesService),K(3,f.IUriIdentityService),K(4,u.ITelemetryService),K(5,g.ILogService)],p);function L(o){return(0,E.isObject)(o)&&(0,P.isIExtensionIdentifier)(o.identifier)&&(t(o.location)||(0,E.isString)(o.location)&&o.location)&&((0,E.isUndefined)(o.relativeLocation)||(0,E.isString)(o.relativeLocation))&&o.version&&(0,E.isString)(o.version)}function t(o){return o?(0,E.isString)(o.path)&&(0,E.isString)(o.scheme):!1}}),define(ce[79],le([0,1,20,5,30,14,8,34,137,2,26,16,6,22,53,89,11,10,153,15,33,45,67,13,4,7,23,3,63,50,17,27,181]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d,v,p,L,t,o,s,n,i,r,a,w,S,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var U;(function(Q){function B(Y,x){if(Y===x)return!0;const j=Object.keys(Y),q=new Set;for(const Z of Object.keys(x))q.add(Z);if(j.length!==q.size)return!1;for(const Z of j){if(Y[Z]!==x[Z])return!1;q.delete(Z)}return q.size===0}Q.equals=B})(U||(e.Translations=U={})),e.IExtensionsScannerService=(0,s.createDecorator)("IExtensionsScannerService");let N=class extends m.Disposable{constructor(B,Y,x,j,q,Z,oe,ae,G,W,b,D){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=Y,this.extensionsControlLocation=x,this.currentProfile=j,this.userDataProfilesService=q,this.extensionsProfileScannerService=Z,this.fileService=oe,this.logService=ae,this.environmentService=G,this.productService=W,this.uriIdentityService=b,this.instantiationService=D,this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance($,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,p.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(B,Y,x){const[j,q]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(Y)]),Z=x?await this.scanExtensionsUnderDevelopment(B,[...j,...q]):[];return this.dedupExtensions(j,q,Z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const Y=[];Y.push(this.scanDefaultSystemExtensions(!!B.useCache,B.language)),Y.push(this.scanDevSystemExtensions(B.language,!!B.checkControlFile));const[x,j]=await Promise.all(Y);return this.applyScanOptions([...x,...j],0,B,!1)}async scanUserExtensions(B){const Y=B.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Y);const x=this.uriIdentityService.extUri.isEqual(B.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.createExtensionScannerInput(Y,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,x),q=B.useCache&&!j.devMode&&j.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let Z;try{Z=await q.scanExtensions(j)}catch(oe){if(oe instanceof w.ExtensionsProfileScanningError&&oe.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),Z=await q.scanExtensions(j);else throw oe}return Z=await this.applyScanOptions(Z,1,B,!0),this.logService.trace("Scanned user extensions:",Z.length),Z}async scanExtensionsUnderDevelopment(B,Y){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(j=>j.scheme===I.Schemas.file).map(async j=>{const q=await this.createExtensionScannerInput(j,!1,1,!0,B.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(q)).map(oe=>(oe.type=Y.find(ae=>(0,p.areSameExtensions)(ae.identifier,oe.identifier))?.type??oe.type,this.extensionsScanner.validate(oe,q)))}))).flat();return this.applyScanOptions(x,"development",B,!0)}return[]}async scanExistingExtension(B,Y,x){const j=await this.createExtensionScannerInput(B,!1,Y,!0,x.language,!0,void 0),q=await this.extensionsScanner.scanExtension(j);return!q||!x.includeInvalid&&!q.isValid?null:q}async scanOneOrMultipleExtensions(B,Y,x){const j=await this.createExtensionScannerInput(B,!1,Y,!0,x.language,!0,void 0),q=await this.extensionsScanner.scanOneOrMultipleExtensions(j);return this.applyScanOptions(q,Y,x,!0)}async scanMetadata(B){const Y=(0,h.joinPath)(B,"package.json"),x=(await this.fileService.readFile(Y)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(B,Y){const x=(0,h.joinPath)(B,"package.json"),j=(await this.fileService.readFile(x)).value.toString(),q=JSON.parse(j);Y.isMachineScoped=Y.isMachineScoped||void 0,Y.isBuiltin=Y.isBuiltin||void 0,q.__metadata={...q.__metadata,...Y},await this.fileService.writeFile((0,h.joinPath)(B,"package.json"),A.VSBuffer.fromString(JSON.stringify(q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof w.ExtensionsProfileScanningError&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw B}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.extensionsProfileScannerService.addExtensionsToProfile(B.map(Y=>[Y,Y.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(Y){(0,o.toFileOperationResult)(Y)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,_.getErrorMessage)(Y))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.logService.error(B)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(B,Y,x,j){return x.includeAllVersions||(B=this.dedupExtensions(Y===0?B:void 0,Y===1?B:void 0,Y==="development"?B:void 0,await this.getTargetPlatform(),j)),x.includeInvalid||(B=B.filter(q=>q.isValid)),B.sort((q,Z)=>{const oe=y.basename(q.location.fsPath),ae=y.basename(Z.location.fsPath);return oe<ae?-1:oe>ae?1:0})}dedupExtensions(B,Y,x,j,q){const Z=(ae,G,W)=>{if(ae.isValid&&!G.isValid)return!1;if(ae.isValid===G.isValid){if(q&&f.gt(ae.manifest.version,G.manifest.version))return this.logService.debug(`Skipping extension ${G.location.path} with lower version ${G.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(f.eq(ae.manifest.version,G.manifest.version)){if(ae.type===0)return this.logService.debug(`Skipping extension ${G.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===j)return this.logService.debug(`Skipping extension ${G.location.path} from different target platform ${G.targetPlatform}`),!1}}return W?this.logService.warn(`Overwriting user extension ${ae.location.path} with ${G.location.path}.`):this.logService.debug(`Overwriting user extension ${ae.location.path} with ${G.location.path}.`),!0},oe=new L.ExtensionIdentifierMap;return B?.forEach(ae=>{const G=oe.get(ae.identifier.id);(!G||Z(G,ae,!1))&&oe.set(ae.identifier.id,ae)}),Y?.forEach(ae=>{const G=oe.get(ae.identifier.id);if(!G&&B&&ae.type===0){this.logService.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!G||Z(G,ae,!1))&&oe.set(ae.identifier.id,ae)}),x?.forEach(ae=>{const G=oe.get(ae.identifier.id);(!G||Z(G,ae,!0))&&oe.set(ae.identifier.id,ae),oe.set(ae.identifier.id,ae)}),[...oe.values()]}async scanDefaultSystemExtensions(B,Y){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),q=await(B&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",q.length),q}async scanDevSystemExtensions(B,Y){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const j=Y?await this.getBuiltInExtensionControl():{},q=[],Z=u.URI.file(y.normalize(y.join(I.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of x){const G=j[ae.name]||"marketplace";switch(G){case"disabled":break;case"marketplace":q.push((0,h.joinPath)(Z,ae.name));break;default:q.push(u.URI.file(G));break}}const oe=await Promise.all(q.map(async ae=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ae,!1,0,!0,B,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",oe.length),(0,k.coalesce)(oe)}async getBuiltInExtensionControl(){try{const B=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(B.value.toString())}catch{return{}}}async createExtensionScannerInput(B,Y,x,j,q,Z,oe){const ae=await this.getTranslations(q??g.language),G=await this.getMtime(B),W=Y&&!this.uriIdentityService.extUri.isEqual(B,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,b=W?await this.getMtime(W):void 0;return new F(B,G,W,b,Y,oe,x,j,Z,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,q,ae)}async getMtime(B){try{const Y=await this.fileService.stat(B);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.AbstractExtensionsScannerService=N,e.AbstractExtensionsScannerService=N=ye([K(4,S.IUserDataProfilesService),K(5,w.IExtensionsProfileScannerService),K(6,o.IFileService),K(7,n.ILogService),K(8,v.IEnvironmentService),K(9,i.IProductService),K(10,l.IUriIdentityService),K(11,s.IInstantiationService)],N);class F{constructor(B,Y,x,j,q,Z,oe,ae,G,W,b,D,M,V,ee){this.location=B,this.mtime=Y,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=j,this.profile=q,this.profileScanOptions=Z,this.type=oe,this.excludeObsolete=ae,this.validate=G,this.productVersion=W,this.productDate=b,this.productCommit=D,this.devMode=M,this.language=V,this.translations=ee}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,Y){return(0,h.isEqual)(B.location,Y.location)&&B.mtime===Y.mtime&&(0,h.isEqual)(B.applicationExtensionslocation,Y.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&B.profile===Y.profile&&T.equals(B.profileScanOptions,Y.profileScanOptions)&&B.type===Y.type&&B.excludeObsolete===Y.excludeObsolete&&B.validate===Y.validate&&B.productVersion===Y.productVersion&&B.productDate===Y.productDate&&B.productCommit===Y.productCommit&&B.devMode===Y.devMode&&B.language===Y.language&&U.equals(B.translations,Y.translations)}}e.ExtensionScannerInput=F;let $=class extends m.Disposable{constructor(B,Y,x,j,q){super(),this.obsoleteFile=B,this.extensionsProfileScannerService=Y,this.uriIdentityService=x,this.fileService=j,this.logService=q}async scanExtensions(B){const Y=B.profile?await this.scanExtensionsFromProfile(B):await this.scanExtensionsFromLocation(B);let x={};if(B.excludeObsolete&&B.type===1)try{const j=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(j)}catch{}return(0,c.isEmptyObject)(x)?Y:Y.filter(j=>!x[p.ExtensionKey.create(j).toString()])}async scanExtensionsFromLocation(B){const Y=await this.fileService.resolve(B.location);if(!Y.children?.length)return[];const x=await Promise.all(Y.children.map(async j=>{if(!j.isDirectory||B.type===1&&(0,h.basename)(j.resource).indexOf(".")===0)return null;const q=new F(j.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(q)}));return(0,k.coalesce)(x).sort((j,q)=>j.location.path<q.location.path?-1:1)}async scanExtensionsFromProfile(B){let Y=await this.scanExtensionsFromProfileResource(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(B.location,B.applicationExtensionslocation)){Y=Y.filter(j=>!j.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(B.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,B);Y.push(...x)}return Y}async scanExtensionsFromProfileResource(B,Y,x){const j=await this.extensionsProfileScannerService.scanProfileExtensions(B,x.profileScanOptions);if(!j.length)return[];const q=await Promise.all(j.map(async Z=>{if(Y(Z)){const oe=new F(Z.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(oe,Z.metadata)}return null}));return(0,k.coalesce)(q)}async scanOneOrMultipleExtensions(B){try{if(await this.fileService.exists((0,h.joinPath)(B.location,"package.json"))){const Y=await this.scanExtension(B);return Y?[Y]:[]}else return await this.scanExtensions(B)}catch(Y){return this.logService.error(`Error scanning extensions at ${B.location.path}:`,(0,_.getErrorMessage)(Y)),[]}}async scanExtension(B,Y){try{let x=await this.scanExtensionManifest(B.location);if(x){x.publisher||(x.publisher=L.UNDEFINED_PUBLISHER),Y=Y??x.__metadata,delete x.__metadata;const j=(0,p.getGalleryExtensionId)(x.publisher,x.name),q=Y?.id?{id:j,uuid:Y.id}:{id:j},Z=Y?.isSystem?0:B.type,oe=Z===0||!!Y?.isBuiltin;x=await this.translateManifest(B.location,x,F.createNlsConfiguration(B));const ae={type:Z,identifier:q,manifest:x,location:B.location,isBuiltin:oe,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return B.validate?this.validate(ae,B):ae}}catch(x){B.type!==0&&this.logService.error(x)}return null}validate(B,Y){let x=!0;const j=(0,t.validateExtensionManifest)(Y.productVersion,Y.productDate,Y.location,B.manifest,B.isBuiltin);for(const[q,Z]of j)q===E.default.Error&&(x=!1,this.logService.error(this.formatMessage(Y.location,Z)));return B.isValid=x,B.validations=j,B}async scanExtensionManifest(B){const Y=(0,h.joinPath)(B,"package.json");let x;try{x=(await this.fileService.readFile(Y)).value.toString()}catch(q){return(0,o.toFileOperationResult)(q)!==1&&this.logService.error(this.formatMessage(B,(0,d.localize)(0,null,Y.path,q.message))),null}let j;try{j=JSON.parse(x)}catch{const Z=[];(0,R.parse)(x,Z);for(const oe of Z)this.logService.error(this.formatMessage(B,(0,d.localize)(1,null,Y.path,oe.offset,oe.length,(0,P.getParseErrorMessage)(oe.error))));return null}return(0,R.getNodeType)(j)!=="object"?(this.logService.error(this.formatMessage(B,(0,d.localize)(2,null,Y.path))),null):j}async translateManifest(B,Y,x){const j=await this.getLocalizedMessages(B,Y,x);if(j)try{const q=[],Z=await this.resolveOriginalMessageBundle(j.default,q);if(q.length>0)return q.forEach(ae=>{this.logService.error(this.formatMessage(B,(0,d.localize)(3,null,j.default?.path,(0,P.getParseErrorMessage)(ae.error))))}),Y;if((0,R.getNodeType)(j)!=="object")return this.logService.error(this.formatMessage(B,(0,d.localize)(4,null,j.default?.path))),Y;const oe=j.values||Object.create(null);return(0,C.localizeManifest)(Y,oe,Z)}catch{}return Y}async getLocalizedMessages(B,Y,x){const j=(0,h.joinPath)(B,"package.nls.json"),q=(G,W)=>{W.forEach(b=>{this.logService.error(this.formatMessage(B,(0,d.localize)(5,null,G?.path,(0,P.getParseErrorMessage)(b.error))))})},Z=G=>{this.logService.error(this.formatMessage(B,(0,d.localize)(6,null,G?.path)))},oe=`${Y.publisher}.${Y.name}`,ae=x.translations[oe];if(ae)try{const G=u.URI.file(ae),W=(await this.fileService.readFile(G)).value.toString(),b=[],D=(0,R.parse)(W,b);return b.length>0?(q(G,b),{values:void 0,default:j}):(0,R.getNodeType)(D)!=="object"?(Z(G),{values:void 0,default:j}):{values:D.contents?D.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.fileService.exists(j))return;let W;try{W=await this.findMessageBundles(B,x)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const b=(await this.fileService.readFile(W.localized)).value.toString(),D=[],M=(0,R.parse)(b,D);return D.length>0?(q(W.localized,D),{values:void 0,default:W.original}):(0,R.getNodeType)(M)!=="object"?(Z(W.localized),{values:void 0,default:W.original}):{values:M,default:W.original}}catch{return{values:void 0,default:W.original}}}}async resolveOriginalMessageBundle(B,Y){if(B)try{const x=(await this.fileService.readFile(B)).value.toString();return(0,R.parse)(x,Y)}catch{}}findMessageBundles(B,Y){return new Promise((x,j)=>{const q=Z=>{const oe=(0,h.joinPath)(B,`package.nls.${Z}.json`);this.fileService.exists(oe).then(ae=>{ae&&x({localized:oe,original:(0,h.joinPath)(B,"package.nls.json")});const G=Z.lastIndexOf("-");G===-1?x({localized:(0,h.joinPath)(B,"package.nls.json"),original:null}):(Z=Z.substring(0,G),q(Z))})};if(Y.devMode||Y.pseudo||!Y.language)return x({localized:(0,h.joinPath)(B,"package.nls.json"),original:null});q(Y.language)})}formatMessage(B,Y){return`[${B.path}]: ${Y}`}};$=ye([K(1,w.IExtensionsProfileScannerService),K(2,l.IUriIdentityService),K(3,o.IFileService),K(4,n.ILogService)],$);let z=class extends ${constructor(B,Y,x,j,q,Z,oe){super(Y,j,q,Z,oe),this.currentProfile=B,this.userDataProfilesService=x,this.cacheValidatorThrottler=this._register(new O.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(B){const Y=this.getCacheFile(B),x=await this.readExtensionCache(Y);if(this.input=B,x&&x.input&&F.equals(x.input,this.input))return this.logService.debug("Using cached extensions scan result",B.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),x.result.map(q=>(q.location=u.URI.revive(q.location),q));const j=await super.scanExtensions(B);return await this.writeExtensionCache(Y,{input:B,result:j}),j}async readExtensionCache(B){try{const Y=await this.fileService.readFile(B),x=JSON.parse(Y.value.toString());return{result:x.result,input:(0,a.revive)(x.input)}}catch(Y){this.logService.debug("Error while reading the extension cache file:",B.path,(0,_.getErrorMessage)(Y))}return null}async writeExtensionCache(B,Y){try{await this.fileService.writeFile(B,A.VSBuffer.fromString(JSON.stringify(Y)))}catch(x){this.logService.debug("Error while writing the extension cache file:",B.path,(0,_.getErrorMessage)(x))}}async validateCache(){if(!this.input)return;const B=this.getCacheFile(this.input),Y=await this.readExtensionCache(B);if(!Y)return;const x=Y.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!T.equals(j,x))try{this.logService.info("Invalidating Cache",x,j),await this.fileService.del(B),this._onDidChangeCache.fire()}catch(q){this.logService.error(q)}}getCacheFile(B){const Y=this.getProfile(B);return this.uriIdentityService.extUri.joinPath(Y.cacheHome,B.type===0?L.BUILTIN_MANIFEST_CACHE_FILE:L.USER_MANIFEST_CACHE_FILE)}getProfile(B){return B.type===0?this.userDataProfilesService.defaultProfile:B.profile?this.uriIdentityService.extUri.isEqual(B.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Y=>this.uriIdentityService.extUri.isEqual(B.location,Y.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};z=ye([K(2,S.IUserDataProfilesService),K(3,w.IExtensionsProfileScannerService),K(4,l.IUriIdentityService),K(5,o.IFileService),K(6,n.ILogService)],z);function J(Q,B){const Y=(0,p.getExtensionId)(Q.manifest.publisher,Q.manifest.name);return{id:Y,identifier:new L.ExtensionIdentifier(Y),isBuiltin:Q.type===0,isUserBuiltin:Q.type===1&&Q.isBuiltin,isUnderDevelopment:B,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,...Q.manifest}}e.toExtensionDescription=J;class H extends N{constructor(B,Y,x,j,q,Z,oe,ae,G,W,b,D){super(B,Y,(0,h.joinPath)(x,".vscode-oss-dev","extensions","control.json"),j,q,Z,oe,ae,G,W,b,D),this.translationsPromise=(async()=>{if(g.translationsConfigFile)try{const M=await this.fileService.readFile(u.URI.file(g.translationsConfigFile));return JSON.parse(M.value.toString())}catch{}return Object.create(null)})()}getTranslations(B){return this.translationsPromise}}e.NativeExtensionsScannerService=H}),define(ce[242],le([0,1,64,5,38,3,2,26,16,31,7,17]),function(ie,e,k,O,T,A,_,R,P,m,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends _.Disposable{constructor(f,E){super(),this.userDataProfilesService=f,this.logService=E,this.processesLimiter=new O.Limiter(5)}async postUninstall(f){const E=this.parseScript(f,"uninstall");E&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(E.script,"uninstall",E.args,!0,f),this.logService.info("Finished running post uninstall script",f.identifier.id,f.manifest.version)}catch(c){this.logService.error("Failed to run post uninstall script",f.identifier.id,f.manifest.version),this.logService.error(c)}}));try{await m.Promises.rm(this.getExtensionStoragePath(f))}catch(c){this.logService.error("Error while removing extension storage path",f.identifier.id),this.logService.error(c)}}parseScript(f,E){const c=`vscode:${E}`;if(f.location.scheme===R.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[c]=="string"){const u=f.manifest.scripts[c].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${c} should be a node script`),null):{script:(0,P.join)(f.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}runLifecycleHook(f,E,c,u,d){return new Promise((v,p)=>{const L=this.start(f,E,c,d);let t;const o=s=>{t&&(clearTimeout(t),t=null),s?p(s):v(void 0)};L.on("error",s=>{o((0,T.toErrorMessage)(s)||"Unknown")}),L.on("exit",(s,n)=>{o(s?`post-${E} process exited with code ${s}`:void 0)}),u&&(t=setTimeout(()=>{t=null,L.kill(),p("timed out")},5e3))})}start(f,E,c,u){const d={silent:!0,execArgv:void 0},v=(0,k.fork)(f,[`--type=extension-post-${E}`,...c],d);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(v.stdout,"data"),L=A.Event.fromNodeEventEmitter(v.stderr,"data");p(s=>this.logService.info(u.identifier.id,u.manifest.version,`post-${E}`,s)),L(s=>this.logService.error(u.identifier.id,u.manifest.version,`post-${E}`,s));const t=A.Event.any(A.Event.map(p,s=>({data:`%c${s}`,format:[""]})),A.Event.map(L,s=>({data:`%c${s}`,format:["color: red"]})));return A.Event.debounce(t,(s,n)=>s?{data:s.data+n.data,format:[...s.format,...n.format]}:{data:n.data,format:n.format},100)(s=>{console.group(u.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),v}getExtensionStoragePath(f){return(0,P.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=g,e.ExtensionsLifecycle=g=ye([K(0,y.IUserDataProfilesService),K(1,I.ILogService)],g)}),define(ce[243],le([0,1,7,17,27,21,50,13,15,10]),function(ie,e,k,O,T,A,_,R,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let I=class extends _.AbstractExtensionsProfileScannerService{constructor(g,h,f,E,c,u){super(m.URI.file(g.extensionsPath),h,f,E,c,u)}};e.ExtensionsProfileScannerService=I,e.ExtensionsProfileScannerService=I=ye([K(0,P.INativeEnvironmentService),K(1,R.IFileService),K(2,O.IUserDataProfilesService),K(3,T.IUriIdentityService),K(4,A.ITelemetryService),K(5,k.ILogService)],I)}),define(ce[244],le([0,1,10,15,50,79,13,4,7,23,27,17]),function(ie,e,k,O,T,A,_,R,P,m,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends A.NativeExtensionsScannerService{constructor(f,E,c,u,d,v,p,L){super(k.URI.file(d.builtinExtensionsPath),k.URI.file(d.extensionsPath),d.userHome,f.defaultProfile,f,E,c,u,d,v,p,L)}};e.ExtensionsScannerService=g,e.ExtensionsScannerService=g=ye([K(0,y.IUserDataProfilesService),K(1,T.IExtensionsProfileScannerService),K(2,_.IFileService),K(3,P.ILogService),K(4,O.INativeEnvironmentService),K(5,m.IProductService),K(6,I.IUriIdentityService),K(7,R.IInstantiationService)],g)}),define(ce[19],le([0,1,5,3,2,100,11,66,4,17]),function(ie,e,k,O,T,A,_,R,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,P.createDecorator)("storageService");var I;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var y;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var g;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function h(d){const v=d.get(e.TARGET_KEY);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}e.loadKeyTargets=h;class f extends T.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(v={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=v,this._onDidChangeValue=this._register(new O.PauseableEmitter),this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new T.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(v,p,L){return O.Event.filter(this._onDidChangeValue.event,t=>t.scope===v&&(p===void 0||t.key===p),L)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,T.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,p){const{key:L,external:t}=p;if(L===e.TARGET_KEY){switch(v){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:v})}else this._onDidChangeValue.fire({scope:v,key:L,target:this.getKeyTargets(v)[L],external:t})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,p,L){return this.getStorage(p)?.get(v,L)}getBoolean(v,p,L){return this.getStorage(p)?.getBoolean(v,L)}getNumber(v,p,L){return this.getStorage(p)?.getNumber(v,L)}getObject(v,p,L){return this.getStorage(p)?.getObject(v,L)}storeAll(v,p){this.withPausedEmitters(()=>{for(const L of v)this.store(L.key,L.value,L.scope,L.target,p)})}store(v,p,L,t,o=!1){if((0,_.isUndefinedOrNull)(p)){this.remove(v,L,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,L,t),this.getStorage(L)?.set(v,p,o)})}remove(v,p,L=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(v,p,void 0),this.getStorage(p)?.delete(v,L)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,p){const L=[],t=this.getKeyTargets(v);for(const o of Object.keys(t))t[o]===p&&L.push(o);return L}updateKeyTarget(v,p,L,t=!1){const o=this.getKeyTargets(p);typeof L=="number"?o[v]!==L&&(o[v]=L,this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(o),t)):typeof o[v]=="number"&&(delete o[v],this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(o),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(v){switch(v){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(v){const p=this.getStorage(v);return p?h(p):Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=I.NONE){this._onWillSaveState.fire({reason:v});const p=this.getStorage(-1),L=this.getStorage(0),t=this.getStorage(1);switch(v){case I.NONE:await k.Promises.settled([p?.whenFlushed()??Promise.resolve(),L?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await k.Promises.settled([p?.flush(0)??Promise.resolve(),L?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.getStorage(-1)?.items??new Map,p=this.getStorage(0)?.items??new Map,L=this.getStorage(1)?.items??new Map;return u(v,p,L,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(v,p){return this.emitWillSaveState(I.NONE),(0,m.isUserDataProfile)(v)?this.switchToProfile(v,p):this.switchToWorkspace(v,p)}canSwitchProfile(v,p){return!(v.id===p.id||E(p)&&E(v))}switchData(v,p,L){this.withPausedEmitters(()=>{const t=new Set;for(const[o,s]of v)t.add(o),p.get(o)!==s&&this.emitDidChangeValue(L,{key:o,external:!0});for(const[o]of p.items)t.has(o)||this.emitDidChangeValue(L,{key:o,external:!0})})}}e.AbstractStorageService=f;function E(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=E;class c extends f{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.profileStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),this._register(this.applicationStorage.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v)))}getStorage(v){switch(v){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(v){return!1}}e.InMemoryStorageService=c;async function u(d,v,p,L,t,o){const s=U=>{try{return JSON.parse(U)}catch{return U}},n=new Map,i=new Map;d.forEach((U,N)=>{n.set(N,U),i.set(N,s(U))});const r=new Map,a=new Map;v.forEach((U,N)=>{r.set(N,U),a.set(N,s(U))});const w=new Map,S=new Map;p.forEach((U,N)=>{w.set(N,U),S.set(N,s(U))}),console.group(L!==t?`Storage: Application (path: ${L})`:`Storage: Application & Profile (path: ${L}, default profile)`);const l=[];if(n.forEach((U,N)=>{l.push({key:N,value:U})}),console.table(l),console.groupEnd(),console.log(i),L!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const U=[];r.forEach((N,F)=>{U.push({key:F,value:N})}),console.table(U),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const C=[];w.forEach((U,N)=>{C.push({key:N,value:U})}),console.table(C),console.groupEnd(),console.log(S)}e.logStorage=u}),define(ce[114],le([0,1,3,2,11,29,33,19]),function(ie,e,k,O,T,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends O.Disposable{constructor(y,g){super(),this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new m(y)),this._register(this.storageManger.onDidChange(h=>this._onDidChangeEnablement.fire({extensions:h,source:"storage"}))),this._register(g.onDidInstallExtensions(h=>h.forEach(({local:f,operation:E})=>{f&&E===4&&this._removeFromDisabledExtensions(f.identifier)})))}async enableExtension(y,g){return this._removeFromDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:g}),!0):!1}async disableExtension(y,g){return this._addToDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:g}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(y){const g=this.getDisabledExtensions();return g.every(h=>!(0,_.areSameExtensions)(h,y))?(g.push(y),this._setDisabledExtensions(g),!0):!1}_removeFromDisabledExtensions(y){const g=this.getDisabledExtensions();for(let h=0;h<g.length;h++){const f=g[h];if((0,_.areSameExtensions)(f,y))return g.splice(h,1),this._setDisabledExtensions(g),!0}return!1}_setDisabledExtensions(y){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,y)}_getExtensions(y){return this.storageManger.get(y,0)}_setExtensions(y,g){this.storageManger.set(y,g,0)}};e.GlobalExtensionEnablementService=P,e.GlobalExtensionEnablementService=P=ye([K(0,R.IStorageService),K(1,A.IExtensionManagementService)],P);class m extends O.Disposable{constructor(y){super(),this.storageService=y,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(y.onDidChangeValue(0,void 0,this._register(new O.DisposableStore))(g=>this.onDidStorageChange(g)))}get(y,g){let h;return g===0?((0,T.isUndefinedOrNull)(this.storage[y])&&(this.storage[y]=this._get(y,g)),h=this.storage[y]):h=this._get(y,g),JSON.parse(h)}set(y,g,h){const f=JSON.stringify(g.map(({id:c,uuid:u})=>({id:c,uuid:u})));this._get(y,h)!==f&&(h===0&&(g.length?this.storage[y]=f:delete this.storage[y]),this._set(y,g.length?f:void 0,h))}onDidStorageChange(y){if(!(0,T.isUndefinedOrNull)(this.storage[y.key])&&this._get(y.key,y.scope)!==this.storage[y.key]){const h=this.get(y.key,y.scope);delete this.storage[y.key];const f=this.get(y.key,y.scope),E=h.filter(u=>!f.some(d=>(0,_.areSameExtensions)(u,d))),c=f.filter(u=>!h.some(d=>(0,_.areSameExtensions)(d,u)));(E.length||c.length)&&this._onDidChange.fire([...E,...c])}}_get(y,g){return this.storageService.get(y,g,"[]")}_set(y,g,h){g?this.storageService.store(y,g,h,1):this.storageService.remove(y,h)}}e.StorageManager=m}),define(ce[245],le([0,1,20,25,8,6,37,11,10,18,15,29,33,67,13,7,23,57,222,19,21,60]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d,v,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=A.isWeb?"web":(0,y.getTargetPlatform)(A.platform,_.arch),o="X-Market-Search-Activity-Id";var s;(function(b){b[b.None=0]="None",b[b.IncludeVersions=1]="IncludeVersions",b[b.IncludeFiles=2]="IncludeFiles",b[b.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",b[b.IncludeSharedAccounts=8]="IncludeSharedAccounts",b[b.IncludeVersionProperties=16]="IncludeVersionProperties",b[b.ExcludeNonValidated=32]="ExcludeNonValidated",b[b.IncludeInstallationTargets=64]="IncludeInstallationTargets",b[b.IncludeAssetUri=128]="IncludeAssetUri",b[b.IncludeStatistics=256]="IncludeStatistics",b[b.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",b[b.Unpublished=4096]="Unpublished",b[b.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function n(...b){return String(b.reduce((D,M)=>D|M,0))}var i;(function(b){b[b.Tag=1]="Tag",b[b.ExtensionId=4]="ExtensionId",b[b.Category=5]="Category",b[b.ExtensionName=7]="ExtensionName",b[b.Target=8]="Target",b[b.Featured=9]="Featured",b[b.SearchText=10]="SearchText",b[b.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class l{constructor(D=S){this.state=D}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(D,M=this.state.pageSize){return new l({...this.state,pageNumber:D,pageSize:M})}withFilter(D,...M){const V=[...this.state.criteria,...M.length?M.map(ee=>({filterType:D,value:ee})):[{filterType:D}]];return new l({...this.state,criteria:V})}withSortBy(D){return new l({...this.state,sortBy:D})}withSortOrder(D){return new l({...this.state,sortOrder:D})}withFlags(...D){return new l({...this.state,flags:D.reduce((M,V)=>M|V,0)})}withAssetTypes(...D){return new l({...this.state,assetTypes:D})}withSource(D){return new l({...this.state,source:D})}get raw(){const{criteria:D,pageNumber:M,pageSize:V,sortBy:ee,sortOrder:ne,flags:de,assetTypes:X}=this.state;return{filters:[{criteria:D,pageNumber:M,pageSize:V,sortBy:ee,sortOrder:ne}],assetTypes:X,flags:de}}get searchText(){const D=this.state.criteria.filter(M=>M.filterType===i.SearchText)[0];return D&&D.value?D.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(D=>String(D.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function C(b,D){const M=(b||[]).filter(V=>V.statisticName===D)[0];return M?M.value:0}function U(b){const D="Microsoft.VisualStudio.Code.Translation.";return b.files.filter(V=>V.assetType.indexOf(D)===0).reduce((V,ee)=>{const ne=$(b,ee.assetType);return ne&&V.push([ee.assetType.substring(D.length),ne]),V},[])}function N(b){if(b.properties){const D=b.properties.filter(ee=>ee.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=D.filter(ee=>M.test(ee.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return $(b,r.Repository)}function F(b){return{uri:`${b.fallbackAssetUri}/${r.VSIX}?redirect=true${b.targetPlatform?`&targetPlatform=${b.targetPlatform}`:""}`,fallbackUri:`${b.fallbackAssetUri}/${r.VSIX}${b.targetPlatform?`?targetPlatform=${b.targetPlatform}`:""}`}}function $(b,D){return b.files.filter(V=>V.assetType===D)[0]?{uri:`${b.assetUri}/${D}${b.targetPlatform?`?targetPlatform=${b.targetPlatform}`:""}`,fallbackUri:`${b.fallbackAssetUri}/${D}${b.targetPlatform?`?targetPlatform=${b.targetPlatform}`:""}`}:null}function z(b,D){const M=b.properties?b.properties.filter(ee=>ee.key===D):[],V=M.length>0&&M[0].value;return V?V.split(",").map(ee=>(0,g.adoptToGalleryExtensionId)(ee)):[]}function J(b){const D=b.properties?b.properties.filter(M=>M.key===a.Engine):[];return D.length>0&&D[0].value||""}function H(b){const D=b.properties?b.properties.filter(M=>M.key===a.PreRelease):[];return D.length>0&&D[0].value==="true"}function Q(b){const D=b.properties?b.properties.filter(V=>V.key===a.LocalizedLanguages):[],M=D.length>0&&D[0].value||"";return M?M.split(","):[]}function B(b){return b.properties?.find(D=>D.key===a.SponsorLink)?.value}function Y(b){return b.indexOf("preview")!==-1}function x(b){return b.targetPlatform?(0,y.toTargetPlatform)(b.targetPlatform):"undefined"}function j(b){const D=(0,k.distinct)(b.versions.map(x)),M=!!b.tags?.includes(y.WEB_EXTENSION_TAG),V=D.indexOf("web");return M?V===-1&&D.push("web"):V!==-1&&D.splice(V,1),D}function q(b,D){const M=(0,y.getFallbackTargetPlarforms)(D);for(let V=0;V<b.length;V++){const ee=b[V];if(ee.version===b[V-1]?.version){let ne=V;const de=x(ee);if(de===D)for(;ne>0&&b[ne-1].version===ee.version;)ne--;else if(M.includes(de))for(;ne>0&&b[ne-1].version===ee.version&&x(b[ne-1])!==D;)ne--;ne!==V&&(b.splice(V,1),b.splice(ne,0,ee))}}return b}e.sortExtensionVersions=q;function Z(b,D,M){b.telemetryData={index:D,querySource:M,queryActivityId:b.queryContext?.[o]}}function oe(b,D,M,V){const ee=b.versions[0],ne={manifest:$(D,r.Manifest),readme:$(D,r.Details),changelog:$(D,r.Changelog),license:$(D,r.License),repository:N(D),download:F(D),icon:$(D,r.Icon),signature:$(D,r.Signature),coreTranslations:U(D)};return{identifier:{id:(0,g.getGalleryExtensionId)(b.publisher.publisherName,b.extensionName),uuid:b.extensionId},name:b.extensionName,version:D.version,displayName:b.displayName,publisherId:b.publisher.publisherId,publisher:b.publisher.publisherName,publisherDisplayName:b.publisher.displayName,publisherDomain:b.publisher.domain?{link:b.publisher.domain,verified:!!b.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(ee),description:b.shortDescription||"",installCount:C(b.statistics,"install"),rating:C(b.statistics,"averagerating"),ratingCount:C(b.statistics,"ratingcount"),categories:b.categories||[],tags:b.tags||[],releaseDate:Date.parse(b.releaseDate),lastUpdated:Date.parse(b.lastUpdated),allTargetPlatforms:M,assets:ne,properties:{dependencies:z(D,a.Dependency),extensionPack:z(D,a.ExtensionPack),engine:J(D),localizedLanguages:Q(D),targetPlatform:x(D),isPreReleaseVersion:H(D)},hasPreReleaseVersion:H(ee),hasReleaseVersion:!0,preview:Y(b.flags),isSigned:!!ne.signature,queryContext:V}}let ae=class{constructor(D,M,V,ee,ne,de,X,se){this.requestService=M,this.logService=V,this.environmentService=ee,this.telemetryService=ne,this.fileService=de,this.productService=X,this.configurationService=se;const te=X.extensionsGallery,he=te?.servicePPEUrl&&se.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=he?te.servicePPEUrl:te?.serviceUrl,this.extensionsGallerySearchUrl=he?void 0:te?.searchUrl,this.extensionsControlUrl=te?.controlUrl,this.commonHeadersPromise=(0,d.resolveMarketplaceHeaders)(X.version,X,this.environmentService,this.configurationService,this.fileService,D,this.telemetryService)}api(D=""){return`${this.extensionsGalleryUrl}${D}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(D,M,V){const ee=O.CancellationToken.isCancellationToken(M)?{}:M,ne=O.CancellationToken.isCancellationToken(M)?M:V,de=[],X=[],se=[],te=[];let he=!0;for(const Ce of D){Ce.uuid?X.push(Ce.uuid):de.push(Ce.id);const ke=!!(Ce.version||Ce.preRelease);se.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:ke}),Ce.version&&te.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),he=he&&!!Ce.hasPreRelease&&!ke}if(!X.length&&!de.length)return[];let fe=new l().withPage(1,D.length);X.length&&(fe=fe.withFilter(i.ExtensionId,...X)),de.length&&(fe=fe.withFilter(i.ExtensionName,...de)),(ee.queryAllVersions||he)&&(fe=fe.withFlags(fe.flags,s.IncludeVersions)),ee.source&&(fe=fe.withSource(ee.source));const{extensions:pe}=await this.queryGalleryExtensions(fe,{targetPlatform:ee.targetPlatform??t,includePreRelease:se,versions:te,compatible:!!ee.compatible},ne);return ee.source&&pe.forEach((Ce,ke)=>Z(Ce,ke,ee.source)),pe}async getCompatibleExtension(D,M,V){if((0,y.isNotWebExtensionInWebTargetPlatform)(D.allTargetPlatforms,V))return null;if(await this.isExtensionCompatible(D,M,V))return D;const ee=new l().withFlags(s.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,D.identifier.uuid),{extensions:ne}=await this.queryGalleryExtensions(ee,{targetPlatform:V,compatible:!0,includePreRelease:M},O.CancellationToken.None);return ne[0]||null}async isExtensionCompatible(D,M,V){if(!(0,y.isTargetPlatformCompatible)(D.properties.targetPlatform,D.allTargetPlatforms,V)||!M&&D.properties.isPreReleaseVersion)return!1;let ee=D.properties.engine;if(!ee){const ne=await this.getManifest(D,O.CancellationToken.None);if(!ne)throw new Error("Manifest was not found");ee=ne.engines.vscode}return(0,h.isEngineValid)(ee,this.productService.version,this.productService.date)}async isValidVersion(D,M,V,ee,ne){if(!(0,y.isTargetPlatformCompatible)(x(D),ee,ne)||M!=="any"&&H(D)!==(M==="prerelease"))return!1;if(V)try{const de=await this.getEngine(D);if(!(0,h.isEngineValid)(de,this.productService.version,this.productService.date))return!1}catch(de){return this.logService.error(`Error while getting the engine for the version ${D.version}.`,(0,T.getErrorMessage)(de)),!1}return!0}async query(D,M){let V=D.text||"";const ee=D.pageSize??50;let ne=new l().withPage(1,ee);V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,fe,pe)=>(ne=ne.withFilter(i.Category,pe||fe),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,fe,pe)=>(ne=ne.withFilter(i.Tag,pe||fe),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(ne=ne.withFilter(i.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),ne=ne.withFilter(i.SearchText,V)),ne=ne.withSortBy(0)):D.ids?ne=ne.withFilter(i.ExtensionId,...D.ids):D.names?ne=ne.withFilter(i.ExtensionName,...D.names):ne=ne.withSortBy(4),typeof D.sortBy=="number"&&(ne=ne.withSortBy(D.sortBy)),typeof D.sortOrder=="number"&&(ne=ne.withSortOrder(D.sortOrder)),D.source&&(ne=ne.withSource(D.source));const de=async(he,fe)=>{const{extensions:pe,total:Ce}=await this.queryGalleryExtensions(he,{targetPlatform:t,compatible:!1,includePreRelease:!!D.includePreRelease},fe);return pe.forEach((ke,_e)=>Z(ke,(he.pageNumber-1)*he.pageSize+_e,D.source)),{extensions:pe,total:Ce}},{extensions:X,total:se}=await de(ne,M),te=async(he,fe)=>{if(fe.isCancellationRequested)throw new T.CancellationError;const{extensions:pe}=await de(ne.withPage(he+1),fe);return pe};return{firstPage:X,total:se,pageSize:ne.pageSize,getPage:te}}async queryGalleryExtensions(D,M,V){const ee=D.flags;D.flags&s.IncludeLatestVersionOnly&&D.flags&s.IncludeVersions&&(D=D.withFlags(D.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(D.flags&s.IncludeLatestVersionOnly)&&!(D.flags&s.IncludeVersions)&&(D=D.withFlags(D.flags,s.IncludeLatestVersionOnly)),M.versions?.length&&(D=D.withFlags(D.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),D=D.withFlags(D.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:ne,total:de,context:X}=await this.queryRawGalleryExtensions(D,V);if(!(D.flags&s.IncludeLatestVersionOnly)){const fe=[];for(const pe of ne){const Ce=await this.toGalleryExtensionWithCriteria(pe,M,X);Ce&&fe.push(Ce)}return{extensions:fe,total:de}}const te=[],he=new Map;for(let fe=0;fe<ne.length;fe++){const pe=ne[fe],Ce={id:(0,g.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},ke=(0,R.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Fe=>(0,g.areSameExtensions)(Fe,Ce))?.includePreRelease;if(M.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(j(pe),M.targetPlatform))continue;const _e=await this.toGalleryExtensionWithCriteria(pe,M,X);!_e||_e.properties.isPreReleaseVersion&&(!ke||!_e.hasReleaseVersion)||!_e.properties.isPreReleaseVersion&&_e.properties.targetPlatform!==M.targetPlatform&&_e.hasPreReleaseVersion?he.set(pe.extensionId,fe):te.push([fe,_e])}if(he.size){const fe=new L.StopWatch,pe=new l().withFlags(ee&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,he.size).withFilter(i.ExtensionId,...he.keys()),{extensions:Ce}=await this.queryGalleryExtensions(pe,M,V);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:he.size});for(const ke of Ce){const _e=he.get(ke.identifier.uuid);te.push([_e,ke])}}return{extensions:te.sort((fe,pe)=>fe[0]-pe[0]).map(([,fe])=>fe),total:de}}async toGalleryExtensionWithCriteria(D,M,V){const ee={id:(0,g.getGalleryExtensionId)(D.publisher.publisherName,D.extensionName),uuid:D.extensionId},ne=M.versions?.find(te=>(0,g.areSameExtensions)(te,ee))?.version,de=(0,R.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(te=>(0,g.areSameExtensions)(te,ee))?.includePreRelease,X=j(D),se=q(D.versions,M.targetPlatform);if(M.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(X,M.targetPlatform))return null;for(let te=0;te<se.length;te++){const he=se[te];if(!(ne&&he.version!==ne)){if(await this.isValidVersion(he,de?"any":"release",M.compatible,X,M.targetPlatform))return oe(D,he,X,V);if(ne&&he.version===ne)return null}}return ne||M.compatible?null:oe(D,D.versions[0],X)}async queryRawGalleryExtensions(D,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");D=D.withFlags(D.flags,s.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(s.Unpublished));const V=await this.commonHeadersPromise,ee=JSON.stringify(D.raw),ne={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},de=new L.StopWatch;let X,se,te=0;try{if(X=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&D.criteria.some(fe=>fe.filterType===i.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:ee,headers:ne},M),X.res.statusCode&&X.res.statusCode>=400&&X.res.statusCode<500)return{galleryExtensions:[],total:te};const he=await(0,u.asJson)(X);if(he){const fe=he.results[0],pe=fe.extensions,Ce=fe.resultMetadata&&fe.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return te=Ce&&Ce.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:te,context:{[o]:X.res.headers.activityid}}}return{galleryExtensions:[],total:te}}catch(he){throw se=he,he}finally{this.telemetryService.publicLog2("galleryService:query",{...D.telemetryData,requestBodySize:String(ee.length),duration:de.elapsed(),success:!!X&&(0,u.isSuccess)(X),responseBodySize:X?.res.headers["Content-Length"],statusCode:X?String(X.res.statusCode):void 0,errorCode:se?(0,T.isCancellationError)(se)?"canceled":(0,T.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(te)})}}async reportStatistic(D,M,V,ee){if(!this.isEnabled())return;const ne=A.isWeb?this.api(`/itemName/${D}.${M}/version/${V}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${D}/extensions/${M}/${V}/stats?statType=${ee}`),de=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:ne,headers:se},O.CancellationToken.None)}catch{}}async download(D,M,V){this.logService.trace("ExtensionGalleryService#download",D.identifier.id);const ee=(0,g.getGalleryExtensionTelemetryData)(D),ne=new Date().getTime(),de=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ee,duration:fe}),X=V===2?"install":V===3?"update":"",se=X?{uri:`${D.assets.download.uri}${P.URI.parse(D.assets.download.uri).query?"&":"?"}${X}=true`,fallbackUri:`${D.assets.download.fallbackUri}${P.URI.parse(D.assets.download.fallbackUri).query?"&":"?"}${X}=true`}:D.assets.download,te=D.queryContext?.[o]?{[o]:D.queryContext[o]}:void 0,he=await this.getAsset(se,te?{headers:te}:void 0);await this.fileService.writeFile(M,he.stream),de(new Date().getTime()-ne)}async downloadSignatureArchive(D,M){if(!D.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",D.identifier.id);const V=await this.getAsset(D.assets.signature);await this.fileService.writeFile(M,V.stream)}async getReadme(D,M){if(D.assets.readme){const V=await this.getAsset(D.assets.readme,{},M);return await(0,u.asTextOrError)(V)||""}return""}async getManifest(D,M){if(D.assets.manifest){const V=await this.getAsset(D.assets.manifest,{},M),ee=await(0,u.asTextOrError)(V);return ee?JSON.parse(ee):null}return null}async getManifestFromRawExtensionVersion(D,M){const V=$(D,r.Manifest);if(!V)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},ne=await this.getAsset(V,{headers:ee});return await(0,u.asJson)(ne)}async getCoreTranslation(D,M){const V=D.assets.coreTranslations.filter(ee=>ee[0]===M.toUpperCase())[0];if(V){const ee=await this.getAsset(V[1]),ne=await(0,u.asTextOrError)(ee);return ne?JSON.parse(ne):null}return null}async getChangelog(D,M){if(D.assets.changelog){const V=await this.getAsset(D.assets.changelog,{},M);return await(0,u.asTextOrError)(V)||""}return""}async getAllCompatibleVersions(D,M,V){let ee=new l().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);D.identifier.uuid?ee=ee.withFilter(i.ExtensionId,D.identifier.uuid):ee=ee.withFilter(i.ExtensionName,D.identifier.id);const{galleryExtensions:ne}=await this.queryRawGalleryExtensions(ee,O.CancellationToken.None);if(!ne.length)return[];const de=j(ne[0]);if((0,y.isNotWebExtensionInWebTargetPlatform)(de,V))return[];const X=[];await Promise.all(ne[0].versions.map(async he=>{try{await this.isValidVersion(he,M?"any":"release",!0,de,V)&&X.push(he)}catch{}}));const se=[],te=new Set;for(const he of q(X,V))te.has(he.version)||(te.add(he.version),se.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:H(he)}));return se}async getAsset(D,M={},V=O.CancellationToken.None){const ee=await this.commonHeadersPromise,ne={type:"GET"},de={...ee,...M.headers||{}};M={...M,...ne,headers:de};const X=D.uri,se=D.fallbackUri,te={...M,url:X};try{const he=await this.requestService.request(te,V);if(he.res.statusCode===200)return he;const fe=await(0,u.asTextOrError)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${fe}`)}catch(he){if((0,T.isCancellationError)(he))throw he;const fe=(0,T.getErrorMessage)(he);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:X,message:fe});const pe={...M,url:se};return this.requestService.request(pe,V)}}async getEngine(D){let M=J(D);if(!M){const V=await this.getManifestFromRawExtensionVersion(D,O.CancellationToken.None);if(!V)throw new Error("Manifest was not found");M=V.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const D=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(D.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,u.asJson)(D),V=[],ee={},ne=[];if(M){for(const de of M.malicious)V.push({id:de});if(M.migrateToPreRelease)for(const[de,X]of Object.entries(M.migrateToPreRelease))(!X.engine||(0,h.isEngineValid)(X.engine,this.productService.version,this.productService.date))&&(ee[de.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[de,X]of Object.entries(M.deprecated))X&&(ee[de.toLowerCase()]=(0,R.isBoolean)(X)?{}:X);if(M.search)for(const de of M.search)ne.push(de)}return{malicious:V,deprecated:ee,search:ne}}};ae=ye([K(1,u.IRequestService),K(2,E.ILogService),K(3,I.IEnvironmentService),K(4,p.ITelemetryService),K(5,f.IFileService),K(6,c.IProductService),K(7,m.IConfigurationService)],ae);let G=class extends ae{constructor(D,M,V,ee,ne,de,X,se){super(D,M,V,ee,ne,de,X,se)}};e.ExtensionGalleryService=G,e.ExtensionGalleryService=G=ye([K(0,v.IStorageService),K(1,u.IRequestService),K(2,E.ILogService),K(3,I.IEnvironmentService),K(4,p.ITelemetryService),K(5,f.IFileService),K(6,c.IProductService),K(7,m.IConfigurationService)],G);let W=class extends ae{constructor(D,M,V,ee,ne,de,X){super(void 0,D,M,V,ee,ne,de,X)}};e.ExtensionGalleryServiceWithNoStorageService=W,e.ExtensionGalleryServiceWithNoStorageService=W=ye([K(0,u.IRequestService),K(1,E.ILogService),K(2,I.IEnvironmentService),K(3,p.ITelemetryService),K(4,f.IFileService),K(5,c.IProductService),K(6,m.IConfigurationService)],W)}),define(ce[80],le([0,1,4,3,2,19,33,23,20,7,11]),function(ie,e,k,O,T,A,_,R,P,m,I){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const g=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let h=class extends T.Disposable{static{y=this}static{this.LARGE_STATE_WARNING_THRESHOLD=512*1024}static toKey(E){return`extensionKeys/${(0,_.adoptToGalleryExtensionId)(E.id)}@${E.version}`}static fromKey(E){const c=g.exec(E);if(c&&c[1])return{id:c[1],version:c[2]}}static async removeOutdatedExtensionVersions(E,c){const u=await E.getInstalled(),d=[];for(const[v,p]of y.readAllExtensionsWithKeysForSync(c)){const L=u.find(t=>(0,_.areSameExtensions)(t.identifier,{id:v}))?.manifest.version;for(const t of p)L!==t&&d.push(y.toKey({id:v,version:t}))}for(const v of d)c.remove(v,0)}static readAllExtensionsWithKeysForSync(E){const c=new Map,u=E.keys(0,1);for(const d of u){const v=y.fromKey(d);if(v){let p=c.get(v.id.toLowerCase());p||c.set(v.id.toLowerCase(),p=[]),p.push(v.version)}}return c}constructor(E,c,u){super(),this.storageService=E,this.productService=c,this.logService=u,this._onDidChangeExtensionStorageToSync=this._register(new O.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=y.readAllExtensionsWithKeysForSync(E),this._register(this.storageService.onDidChangeValue(0,void 0,this._register(new T.DisposableStore))(d=>this.onDidChangeStorageValue(d)))}onDidChangeStorageValue(E){if(this.extensionsWithKeysForSync.has(E.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const c=y.fromKey(E.key);if(c){if(this.storageService.get(E.key,0)===void 0)this.extensionsWithKeysForSync.delete(c.id.toLowerCase());else{let u=this.extensionsWithKeysForSync.get(c.id.toLowerCase());u||this.extensionsWithKeysForSync.set(c.id.toLowerCase(),u=[]),u.push(c.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(E){if((0,I.isString)(E))return E;const c=E.manifest?E.manifest.publisher:E.publisher,u=E.manifest?E.manifest.name:E.name;return(0,_.getExtensionId)(c,u)}getExtensionState(E,c){const u=this.getExtensionId(E),d=this.getExtensionStateRaw(E,c);if(d)try{return JSON.parse(d)}catch(v){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${u}, global: ${c}): ${v}`)}}getExtensionStateRaw(E,c){const u=this.getExtensionId(E),d=this.storageService.get(u,c?0:1);return d&&d?.length>y.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${u}, global: ${c}): ${d.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),d}setExtensionState(E,c,u){const d=this.getExtensionId(E);c===void 0?this.storageService.remove(d,u?0:1):this.storageService.store(d,JSON.stringify(c),u?0:1,1)}setKeysForSync(E,c){this.storageService.store(y.toKey(E),JSON.stringify(c),0,1)}getKeysForSync(E){const c=this.productService.extensionSyncedKeys?.[E.id.toLowerCase()],u=this.storageService.get(y.toKey(E),0),d=u?JSON.parse(u):void 0;return d&&c?(0,P.distinct)([...d,...c]):d||c}addToMigrationList(E,c){if(E!==c){const u=this.migrationList.filter(d=>!d.includes(E)&&!d.includes(c));u.push([E,c]),this.migrationList=u}}getSourceExtensionToMigrate(E){const c=this.migrationList.find(([,u])=>E===u);return c?c[0]:void 0}get migrationList(){const E=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const c=JSON.parse(E);if(Array.isArray(c))return c}catch{}return[]}set migrationList(E){E.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(E),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};e.ExtensionStorageService=h,e.ExtensionStorageService=h=y=ye([K(0,A.IStorageService),K(1,R.IProductService),K(2,m.ILogService)],h)}),define(ce[246],le([0,1,29,13,23,15,98,55,19,21,219]),function(ie,e,k,O,T,A,_,R,P,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let y=class extends I.AbstractNativeExtensionTipsService{constructor(h,f,E,c,u,d,v,p){super(h.userHome,u,f,E,c,d,v,p)}};e.ExtensionTipsService=y,e.ExtensionTipsService=y=ye([K(0,A.INativeEnvironmentService),K(1,m.ITelemetryService),K(2,k.IExtensionManagementService),K(3,P.IStorageService),K(4,R.INativeHostService),K(5,_.IExtensionRecommendationNotificationService),K(6,O.IFileService),K(7,T.IProductService)],y)}),define(ce[247],le([0,1,105,3,21,15,2,7,16,64,23,6,5,101,18,163,36,19,11,131]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const p=[k.CONFIGURATION_KEY_HOST_NAME,k.CONFIGURATION_KEY_PREVENT_SLEEP],L="remoteTunnelSession",t="remoteTunnelIsService";let o=class extends _.Disposable{constructor(r,a,w,S,l,C,U){super(),this.telemetryService=r,this.productService=a,this.environmentService=w,this.configurationService=C,this.storageService=U,this._onDidTokenFailedEmitter=new O.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new O.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeModeEmitter=new O.Emitter,this.onDidChangeMode=this._onDidChangeModeEmitter.event,this._mode=k.INACTIVE_TUNNEL_MODE,this._initialized=!1,this.defaultOnOutput=(N,F)=>{F?this._logger.error(N):this._logger.info(N)},this._logger=this._register(S.createLogger(k.LOG_ID,{name:k.LOGGER_NAME})),this._startTunnelProcessDelayer=new g.Delayer(100),this._register(this._logger.onDidChangeLogLevel(N=>this._logger.info("Log level changed to "+(0,R.LogLevelToString)(N)))),this._register(l.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(C.onDidChangeConfiguration(N=>{p.some(F=>N.affectsConfiguration(F))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._mode=this._restoreMode(),this._tunnelStatus=k.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(r){this._tunnelStatus=r,this._onDidChangeTunnelStatusEmitter.fire(r)}setMode(r){n(this._mode,r)||(this._mode=r,this._storeMode(r),this._onDidChangeModeEmitter.fire(this._mode),r.active?(this._logger.info(`Session updated: ${r.session.accountLabel} (${r.session.providerId}) (service=${r.asService})`),r.session.token&&this._logger.info(`Session token updated: ${r.session.accountLabel} (${r.session.providerId})`)):this._logger.info("Session reset"))}getMode(){return Promise.resolve(this._mode)}async initialize(r){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setMode(r);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(a){this._logger.error(a)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let r;y.isMacintosh?r=this.environmentService.appRoot:r=(0,P.dirname)((0,P.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,P.join)(r,"bin",`${this.productService.tunnelApplicationName}${y.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(r){if(n(this._mode,r)&&this._tunnelStatus.type!=="disconnected")return this._tunnelStatus;this.setMode(r);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(a){this._logger.error(a)}return this._tunnelStatus}async stopTunnel(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),!this._mode.active)return;const r=this._mode.asService;this.setMode(k.INACTIVE_TUNNEL_MODE);try{r&&this.runCodeTunnelCommand("uninstallService",["service","uninstall"])}catch(a){this._logger.error(a)}try{await this.runCodeTunnelCommand("stop",["kill"])}catch(a){this._logger.error(a)}this.setTunnelStatus(k.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:this._mode.active,service:this._mode.active&&this._mode.asService}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let r="",a=!1;const w=(F,$)=>{$?this._logger.error(F):r+=F,!this.environmentService.isBuilt&&F.startsWith("   Compiling")&&this.setTunnelStatus(k.TunnelStates.connecting((0,E.localize)(0,null)))},S=this.runCodeTunnelCommand("status",["status"],w);this._tunnelProcess=S;try{if(await S,this._tunnelProcess!==S)return;const F=JSON.parse(r.trim().split(`
`).find($=>$.startsWith("{")));if(a=F.service_installed,this._logger.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this._mode.active){this.setTunnelStatus(k.TunnelStates.disconnected());return}}catch(F){this._logger.error(F),this.setTunnelStatus(k.TunnelStates.disconnected());return}finally{this._tunnelProcess===S&&(this._tunnelProcess=void 0)}const l=this._mode.active?this._mode.session:void 0;if(l&&l.token){const F=l.token;this.setTunnelStatus(k.TunnelStates.connecting((0,E.localize)(1,null,l.accountLabel,l.providerId)));const $=(J,H)=>{J=J.replaceAll(F,"*".repeat(4)),w(J,H)},z=this.runCodeTunnelCommand("login",["user","login","--provider",l.providerId,"--access-token",F,"--log",(0,R.LogLevelToString)(this._logger.getLevel())],$);this._tunnelProcess=z;try{if(await z,this._tunnelProcess!==z)return}catch(J){this._logger.error(J),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(l),this.setTunnelStatus(k.TunnelStates.disconnected(l));return}}const C=this._getTunnelName();C?this.setTunnelStatus(k.TunnelStates.connecting((0,E.localize)(2,null,C))):this.setTunnelStatus(k.TunnelStates.connecting((0,E.localize)(3,null)));const U=["--accept-server-license-terms","--log",(0,R.LogLevelToString)(this._logger.getLevel())];C?U.push("--name",C):U.push("--random-name");let N=!1;return this._mode.active&&this._mode.asService&&!a&&(N=await this.installTunnelService(U)===!1),this.serverOrAttachTunnel(l,U,N)}async installTunnelService(r){let a;try{a=await this.runCodeTunnelCommand("serviceInstall",["service","install",...r])}catch(w){this._logger.error(w),a=1}if(a!==0){const w=(0,E.localize)(4,null);return this._logger.warn(w),this.setTunnelStatus(k.TunnelStates.connecting(w)),!1}return!0}async serverOrAttachTunnel(r,a,w){a.push("--parent-process-id",String(process.pid)),this._preventSleep()&&a.push("--no-sleep");let S=!1;const l=this.runCodeTunnelCommand("tunnel",a,(C,U)=>{U?this._logger.error(C):this._logger.info(C),C.includes("Connected to an existing tunnel process")&&(S=!0);const N=C.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(N){const F={link:N[1],domain:N[2],tunnelName:N[4],isAttached:S};this.setTunnelStatus(k.TunnelStates.connected(F,w))}else C.match(/error refreshing token/)&&(l.cancel(),this._onDidTokenFailedEmitter.fire(r),this.setTunnelStatus(k.TunnelStates.disconnected(r)))});this._tunnelProcess=l,l.finally(()=>{l===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._mode=k.INACTIVE_TUNNEL_MODE,this.setTunnelStatus(k.TunnelStates.disconnected()))})}runCodeTunnelCommand(r,a,w=this.defaultOnOutput){return(0,g.createCancelablePromise)(S=>new Promise((l,C)=>{S.isCancellationRequested&&l(-1);let U;const N=["ignore","pipe","pipe"];if(S.onCancellationRequested(()=>{U&&(this._logger.info(`${r} terminating(${U.pid})`),U.kill())}),!this.environmentService.isBuilt)w(`Building tunnel CLI from sources and run
`,!1),w(`${r} Spawning: cargo run -- tunnel ${a.join(" ")}
`,!1),U=(0,m.spawn)("cargo",["run","--","tunnel",...a],{cwd:(0,P.join)(this.environmentService.appRoot,"cli"),stdio:N});else{w(`Running tunnel CLI
`,!1);const F=this.getTunnelCommandLocation();w(`${r} Spawning: ${F} tunnel ${a.join(" ")}
`,!1),U=(0,m.spawn)(F,["tunnel",...a],{cwd:(0,c.homedir)(),stdio:N})}U.stdout.pipe(new v.StreamSplitter(`
`)).on("data",F=>{if(U){const $=F.toString();w($,!1)}}),U.stderr.pipe(new v.StreamSplitter(`
`)).on("data",F=>{if(U){const $=F.toString();w($,!0)}}),U.on("exit",F=>{U&&(w(`${r} exit(${U.pid}): + ${F} `,!1),U=void 0,l(F||0))}),U.on("error",F=>{U&&(w(`${r} error(${U.pid}): + ${F} `,!0),U=void 0,C())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(k.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let r=this.configurationService.getValue(k.CONFIGURATION_KEY_HOST_NAME)||(0,c.hostname)();return r=r.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),r||void 0}_restoreMode(){try{const r=this.storageService.get(L,-1),a=this.storageService.getBoolean(t,-1,!1);if(r){const w=JSON.parse(r);if(w&&(0,d.isString)(w.accountLabel)&&(0,d.isString)(w.sessionId)&&(0,d.isString)(w.providerId))return{active:!0,session:w,asService:a};this._logger.error("Problems restoring session from storage, invalid format",w)}}catch(r){this._logger.error("Problems restoring session from storage",r)}return k.INACTIVE_TUNNEL_MODE}_storeMode(r){if(r.active){const a={providerId:r.session.providerId,sessionId:r.session.sessionId,accountLabel:r.session.accountLabel};this.storageService.store(L,JSON.stringify(a),-1,1),this.storageService.store(t,r.asService,-1,1)}else this.storageService.remove(L,-1),this.storageService.remove(t,-1)}};e.RemoteTunnelService=o,e.RemoteTunnelService=o=ye([K(0,T.ITelemetryService),K(1,I.IProductService),K(2,A.INativeEnvironmentService),K(3,R.ILoggerService),K(4,h.ISharedProcessLifecycleService),K(5,f.IConfigurationService),K(6,u.IStorageService)],o);function s(i,r){return i&&r?i.sessionId===r.sessionId&&i.providerId===r.providerId&&i.token===r.token:i===r}const n=(i,r)=>i.active!==r.active?!1:i.active&&r.active?i.asService===r.asService&&s(i.session,r.session):!0}),define(ce[248],le([0,1,5,2,22,66,19,75,17]),function(ie,e,k,O,T,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class m extends _.AbstractStorageService{constructor(y,g,h,f){super(),this.initialWorkspace=y,this.initialProfiles=g,this.remoteService=h,this.environmentService=f,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new O.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new O.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const y=this._register(new R.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),g=this._register(new A.Storage(y));return this._register(g.onDidChangeStorage(h=>this.emitDidChangeValue(-1,h))),g}createProfileStorage(y){this.profileStorageDisposables.clear(),this.profileStorageProfile=y;let g;if((0,_.isProfileUsingDefaultStorage)(y))g=this.applicationStorage;else{const h=this.profileStorageDisposables.add(new R.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),y));g=this.profileStorageDisposables.add(new A.Storage(h))}return this.profileStorageDisposables.add(g.onDidChangeStorage(h=>this.emitDidChangeValue(0,h))),g}createWorkspaceStorage(y){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=y?.id;let g;if(y){const h=this.workspaceStorageDisposables.add(new R.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),y));g=this.workspaceStorageDisposables.add(new A.Storage(h)),this.workspaceStorageDisposables.add(g.onDidChangeStorage(f=>this.emitDidChangeValue(1,f)))}return g}async doInitialize(){await k.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(y){switch(y){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(y){switch(y){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(_.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(y){if(!this.canSwitchProfile(this.profileStorageProfile,y))return;const g=this.profileStorage,h=g.items;g!==this.applicationStorage&&await g.close(),this.profileStorage=this.createProfileStorage(y),await this.profileStorage.init(),this.switchData(h,this.profileStorage,0)}async switchToWorkspace(y,g){const h=this.workspaceStorage,f=h?.items??new Map;await h?.close(),this.workspaceStorage=this.createWorkspaceStorage(y),await this.workspaceStorage.init(),this.switchData(f,this.workspaceStorage,1)}hasScope(y){return(0,P.isUserDataProfile)(y)?this.profileStorageProfile.id===y.id:this.workspaceStorageId===y.id}}e.RemoteStorageService=m}),define(ce[249],le([0,1,3,2,17,92]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class _{constructor(m,I){this.service=m,this.getUriTransformer=I}listen(m,I){const y=this.getUriTransformer(m);switch(I){case"onDidChangeProfiles":return k.Event.map(this.service.onDidChangeProfiles,g=>({all:g.all.map(h=>(0,A.transformOutgoingURIs)({...h},y)),added:g.added.map(h=>(0,A.transformOutgoingURIs)({...h},y)),removed:g.removed.map(h=>(0,A.transformOutgoingURIs)({...h},y)),updated:g.updated.map(h=>(0,A.transformOutgoingURIs)({...h},y))}))}throw new Error(`Invalid listen ${I}`)}async call(m,I,y){const g=this.getUriTransformer(m);switch(I){case"createProfile":{const h=await this.service.createProfile(y[0],y[1],y[2]);return(0,A.transformOutgoingURIs)({...h},g)}case"updateProfile":{let h=(0,T.reviveProfile)((0,A.transformIncomingURIs)(y[0],g),this.service.profilesHome.scheme);return h=await this.service.updateProfile(h,y[1]),(0,A.transformOutgoingURIs)({...h},g)}case"removeProfile":{const h=(0,T.reviveProfile)((0,A.transformIncomingURIs)(y[0],g),this.service.profilesHome.scheme);return this.service.removeProfile(h)}}throw new Error(`Invalid call ${I}`)}}e.RemoteUserDataProfilesServiceChannel=_;class R extends O.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(m,I,y){super(),this.profilesHome=I,this.channel=y,this._profiles=[],this._onDidChangeProfiles=this._register(new k.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=m.map(g=>(0,T.reviveProfile)(g,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(g=>{const h=g.added.map(c=>(0,T.reviveProfile)(c,this.profilesHome.scheme)),f=g.removed.map(c=>(0,T.reviveProfile)(c,this.profilesHome.scheme)),E=g.updated.map(c=>(0,T.reviveProfile)(c,this.profilesHome.scheme));this._profiles=g.all.map(c=>(0,T.reviveProfile)(c,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:h,removed:f,updated:E,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(m){this.enabled=m}isEnabled(){return this.enabled}async createNamedProfile(m,I,y){const g=await this.channel.call("createNamedProfile",[m,I,y]);return(0,T.reviveProfile)(g,this.profilesHome.scheme)}async createProfile(m,I,y,g){const h=await this.channel.call("createProfile",[m,I,y,g]);return(0,T.reviveProfile)(h,this.profilesHome.scheme)}async createTransientProfile(m){const I=await this.channel.call("createTransientProfile",[m]);return(0,T.reviveProfile)(I,this.profilesHome.scheme)}async setProfileForWorkspace(m,I){await this.channel.call("setProfileForWorkspace",[m,I])}removeProfile(m){return this.channel.call("removeProfile",[m])}async updateProfile(m,I){const y=await this.channel.call("updateProfile",[m,I]);return(0,T.reviveProfile)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=R}),define(ce[58],le([0,1,2,66,4,19,3,75,17]),function(ie,e,k,O,T,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,T.createDecorator)("IUserDataProfileStorageService");let m=class extends k.Disposable{constructor(h){super(),this.storageService=h}async readStorageData(h){return this.withProfileScopedStorageService(h,async f=>this.getItems(f))}async updateStorageData(h,f,E){return this.withProfileScopedStorageService(h,async c=>this.writeItems(c,f,E))}async withProfileScopedStorageService(h,f){if(this.storageService.hasScope(h))return f(this.storageService);const E=await this.createStorageDatabase(h),c=new y(E);try{await c.initialize();const u=await f(c);return await c.flush(),u}finally{c.dispose(),await this.closeAndDispose(E)}}getItems(h){const f=new Map,E=c=>{for(const u of h.keys(0,c))f.set(u,{value:h.get(u,0),target:c})};return E(0),E(1),f}writeItems(h,f,E){h.storeAll(Array.from(f.entries()).map(([c,u])=>({key:c,value:u,scope:0,target:E})),!0)}async closeAndDispose(h){try{await h.close()}finally{(0,k.isDisposable)(h)&&h.dispose()}}};e.AbstractUserDataProfileStorageService=m,e.AbstractUserDataProfileStorageService=m=ye([K(0,A.IStorageService)],m);class I extends m{constructor(h,f,E,c){super(E),this.remoteService=h;const u=h.getChannel("profileStorageListener"),d=this._register(new k.MutableDisposable);this._onDidChange=this._register(new _.Emitter({onWillAddFirstListener:()=>{d.value=u.listen("onDidChange")(v=>{c.trace("profile storage changes",v),this._onDidChange.fire({targetChanges:v.targetChanges.map(p=>(0,P.reviveProfile)(p,f.profilesHome.scheme)),valueChanges:v.valueChanges.map(p=>({...p,profile:(0,P.reviveProfile)(p.profile,f.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(h){const f=this.remoteService.getChannel("storage");return(0,A.isProfileUsingDefaultStorage)(h)?new R.ApplicationStorageDatabaseClient(f):new R.ProfileStorageDatabaseClient(f,h)}}e.RemoteUserDataProfileStorageService=I;class y extends A.AbstractStorageService{constructor(h){super({flushInterval:100}),this.profileStorage=this._register(new O.Storage(h))}doInitialize(){return this.profileStorage.init()}getStorage(h){return h===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(ce[250],le([0,1,19,7,17,71,58]),function(ie,e,k,O,T,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let R=class extends _.RemoteUserDataProfileStorageService{constructor(m,I,y,g){super(m,I,y,g)}};e.NativeUserDataProfileStorageService=R,e.NativeUserDataProfileStorageService=R=ye([K(0,A.IMainProcessService),K(1,T.IUserDataProfilesService),K(2,k.IStorageService),K(3,O.ILogService)],R)}),define(ce[39],le([0,1,20,5,14,25,3,34,2,28,11,168,18,15,13,7,44,19,21,27,24,17]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d,v,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function t(w){return!!(w&&w.ref!==void 0&&typeof w.ref=="string"&&w.ref!==""&&w.syncData!==void 0&&(w.syncData===null||o(w.syncData)))}e.isRemoteUserData=t;function o(w){return!!(w&&w.version!==void 0&&typeof w.version=="number"&&w.content!==void 0&&typeof w.content=="string"&&(Object.keys(w).length===2||Object.keys(w).length===3&&w.machineId!==void 0&&typeof w.machineId=="string"))}e.isSyncData=o;function s(w,S){return`${(0,m.uppercaseFirstLetter)(w)}${S.isDefault?"":` (${S.name})`}`}e.getSyncResourceLogLabel=s;let n=class extends P.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(S,l,C,U,N,F,$,z,J,H,Q,B){super(),this.syncResource=S,this.collection=l,this.fileService=C,this.environmentService=U,this.storageService=N,this.userDataSyncStoreService=F,this.userDataSyncBackupStoreService=$,this.userDataSyncEnablementService=z,this.telemetryService=J,this.logService=H,this.configurationService=Q,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new O.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=s(S.syncResource,S.profile),this.extUri=B.extUri,this.syncFolder=this.extUri.joinPath(U.userDataSyncHome,...(0,p.getPathSegments)(S.profile.isDefault?void 0:S.profile.id,S.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,p.PREVIEW_DIR_NAME),this.lastSyncResource=(0,p.getLastSyncResourceUri)(S.profile.isDefault?void 0:S.profile.id,S.syncResource,U,this.extUri),this.currentMachineIdPromise=(0,c.getServiceMachineId)(U,C,N)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const S=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(S.remoteUserData,S.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const S=await this.getLastSyncUserData();(S?await this.hasRemoteChanged(S):!0)&&this._onDidChangeLocal.fire()}}setStatus(S){this._status!==S&&(this._status=S,this._onDidChangStatus.fire(S))}async sync(S,l={}){await this._sync(S,!0,this.getUserDataSyncConfiguration(),l)}async preview(S,l,C={}){return this._sync(S,!1,l,C)}async apply(S,l={}){try{this.syncHeaders={...l};const C=await this.doApply(S);return this.setStatus(C),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(S,l,C,U){try{if(this.syncHeaders={...U},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let N="idle";try{const F=await this.getLastSyncUserData(),$=await this.getLatestRemoteUserData(S,F);return N=await this.performSync($,F,l,C),N==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(N)}}finally{this.syncHeaders={}}}async replace(S){const l=this.parseSyncData(S);if(!l)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const C=await this.getLastSyncUserData(),U=await this.getLatestRemoteUserData(null,C),N=await this.isRemoteDataFromCurrentMachine(U),F=await this.generateSyncPreview({ref:U.ref,syncData:l},C,N,this.getUserDataSyncConfiguration(),A.CancellationToken.None),$=[];for(const z of F){const J=await this.getAcceptResult(z,z.remoteResource,void 0,A.CancellationToken.None),{remoteChange:H}=await this.getAcceptResult(z,z.previewResource,z.remoteContent,A.CancellationToken.None);$.push([z,{...J,remoteChange:H!==0?H:2}])}await this.applyResult(U,C,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(S){const l=await this.currentMachineIdPromise;return!!S.syncData?.machineId&&S.syncData.machineId===l}async getLatestRemoteUserData(S,l){if(l){const C=S?S[this.resource]:void 0;if(l.ref===C||C===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(S,l,C,U){if(S.syncData&&S.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new p.UserDataSyncError((0,y.localize)(0,null,this.resource,this.version,S.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(S,l,C,U)}catch(N){if(N instanceof p.UserDataSyncError)switch(N.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(S,l,C,U);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),S=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(S,l,C,U)}throw N}}async doSync(S,l,C,U){try{const N=await this.isRemoteDataFromCurrentMachine(S),F=!N&&l===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,$=C&&!F;this.syncPreviewPromise||(this.syncPreviewPromise=(0,O.createCancelablePromise)(J=>this.doGenerateSyncResourcePreview(S,l,N,$,U,J)));let z=await this.syncPreviewPromise;if(C&&F){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const J of z.resourcePreviews)z=await this.accept(J.remoteResource)||z}return this.updateConflicts(z.resourcePreviews),z.resourcePreviews.some(({mergeState:J})=>J==="conflict")?"hasConflicts":C?await this.doApply(!1):"syncing"}catch(N){throw this.syncPreviewPromise=null,N}}async merge(S){return await this.updateSyncResourcePreview(S,async l=>{const C=await this.getMergeResult(l,A.CancellationToken.None);await this.fileService.writeFile(l.previewResource,T.VSBuffer.fromString(C?.content||""));const U=C&&!C.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,A.CancellationToken.None):void 0;return l.acceptResult=U,l.mergeState=C.hasConflicts?"conflict":U?"accepted":"preview",l.localChange=U?U.localChange:C.localChange,l.remoteChange=U?U.remoteChange:C.remoteChange,l}),this.syncPreviewPromise}async accept(S,l){return await this.updateSyncResourcePreview(S,async C=>{const U=await this.getAcceptResult(C,S,l,A.CancellationToken.None);return C.acceptResult=U,C.mergeState="accepted",C.localChange=U.localChange,C.remoteChange=U.remoteChange,C}),this.syncPreviewPromise}async discard(S){return await this.updateSyncResourcePreview(S,async l=>{const C=await this.getMergeResult(l,A.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,T.VSBuffer.fromString(C.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=C.localChange,l.remoteChange=C.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(S,l){if(!this.syncPreviewPromise)return;let C=await this.syncPreviewPromise;const U=C.resourcePreviews.findIndex(({localResource:N,remoteResource:F,previewResource:$})=>this.extUri.isEqual(N,S)||this.extUri.isEqual(F,S)||this.extUri.isEqual($,S));U!==-1&&(this.syncPreviewPromise=(0,O.createCancelablePromise)(async N=>{const F=[...C.resourcePreviews];return F[U]=await l(F[U]),{...C,resourcePreviews:F}}),C=await this.syncPreviewPromise,this.updateConflicts(C.resourcePreviews),C.resourcePreviews.some(({mergeState:N})=>N==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(S){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:C})=>C==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:C})=>C!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(C=>[C,C.acceptResult]),S),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(S){const l=S.filter(({mergeState:C})=>C==="conflict");(0,k.equals)(this._conflicts,l,(C,U)=>this.extUri.isEqual(C.previewResource,U.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const S=await this.getLastSyncUserData();return!!S&&S.syncData!==null}async resolvePreviewContent(S){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const C of l.resourcePreviews){if(this.extUri.isEqual(C.acceptedResource,S))return C.acceptResult?C.acceptResult.content:null;if(this.extUri.isEqual(C.remoteResource,S))return C.remoteContent;if(this.extUri.isEqual(C.localResource,S))return C.localContent;if(this.extUri.isEqual(C.baseResource,S))return C.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(S){(0,f.toFileOperationResult)(S)!==1&&this.logService.error(S)}}async doGenerateSyncResourcePreview(S,l,C,U,N,F){const $=await this.generateSyncPreview(S,l,C,N,F),z=[];for(const J of $){const H=J.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(J.localChange===0&&J.remoteChange===0)z.push({...J,acceptedResource:H,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Q=U?await this.getMergeResult(J,F):void 0;if(F.isCancellationRequested)break;await this.fileService.writeFile(J.previewResource,T.VSBuffer.fromString(Q?.content||""));const B=Q&&!Q.hasConflicts?await this.getAcceptResult(J,J.previewResource,void 0,F):void 0;z.push({...J,acceptResult:B,mergeState:Q?.hasConflicts?"conflict":B?"accepted":"preview",localChange:B?B.localChange:Q?Q.localChange:J.localChange,remoteChange:B?B.remoteChange:Q?Q.remoteChange:J.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:S,lastSyncUserData:l,resourcePreviews:z,isLastSyncFromCurrentMachine:C}}async getLastSyncUserData(){let S=this.getStoredLastSyncUserDataStateContent();if(S||(S=await this.migrateLastSyncUserData()),!S)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const l=JSON.parse(S),C=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!l.version&&!!C&&l.version!==C,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${C}.`),await this.resetLocal(),null;let U,N=1;for(;U===void 0&&N++<6;)try{const F=await this.readLastSyncStoredRemoteUserData();F&&(F.ref===l.ref?U=F.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof f.FileOperationError&&F.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(F instanceof p.UserDataSyncError)throw F;this.logService.error(F,N)}}if(U===void 0)try{const F=await this.userDataSyncStoreService.resolveResourceContent(this.resource,l.ref,this.collection,this.syncHeaders);U=F===null?null:this.parseSyncData(F),await this.writeLastSyncStoredRemoteUserData({ref:l.ref,syncData:U})}catch(F){if(F instanceof p.UserDataSyncError&&F.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw F}return U===void 0?null:{...l,syncData:U}}async updateLastSyncUserData(S,l={}){if(l.ref||l.version)throw new Error("Cannot have core properties as additional");const C=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),U={ref:S.ref,version:C,...l};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(U),-1,1),await this.writeLastSyncStoredRemoteUserData(S)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const S=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const l=S?JSON.parse(S):void 0;if(t(l))return l}catch(l){this.logService.error(l)}}async writeLastSyncStoredRemoteUserData(S){await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(S)))}async migrateLastSyncUserData(){try{const S=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(S.value.toString());await this.fileService.del(this.lastSyncResource),l.ref&&l.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...l,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:l.ref,syncData:l.content===null?null:JSON.parse(l.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,l)}catch(S){S instanceof f.FileOperationError&&S.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(S)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(S){const{ref:l,content:C}=await this.getUserData(S);let U=null;return C!==null&&(U=this.parseSyncData(C)),{ref:l,syncData:U}}parseSyncData(S){try{const l=JSON.parse(S);if(o(l))return l}catch(l){this.logService.error(l)}throw new p.UserDataSyncError((0,y.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(S){const l=S?{ref:S.ref,content:S.syncData?JSON.stringify(S.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,l,this.collection,this.syncHeaders)}async updateRemoteUserData(S,l){const C=await this.currentMachineIdPromise,U={version:this.version,machineId:C,content:S};try{return l=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(U),l,this.collection,this.syncHeaders),{ref:l,syncData:U}}catch(N){throw N instanceof p.UserDataSyncError&&N.code==="TooLarge"&&(N=new p.UserDataSyncError(N.message,N.code,this.resource)),N}}async backupLocal(S){const l={version:this.version,content:S};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=n,e.AbstractSynchroniser=n=ye([K(2,f.IFileService),K(3,h.IEnvironmentService),K(4,u.IStorageService),K(5,p.IUserDataSyncStoreService),K(6,p.IUserDataSyncBackupStoreService),K(7,p.IUserDataSyncEnablementService),K(8,d.ITelemetryService),K(9,p.IUserDataSyncLogService),K(10,g.IConfigurationService),K(11,v.IUriIdentityService)],n);let i=class extends n{constructor(S,l,C,U,N,F,$,z,J,H,Q,B,Y){super(l,C,U,N,F,$,z,J,H,Q,B,Y),this.file=S,this._register(this.fileService.watch(this.extUri.dirname(S))),this._register(this.fileService.onDidFilesChange(x=>this.onFileChanges(x)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(S,l,C){try{l?await this.fileService.writeFile(this.file,T.VSBuffer.fromString(S),C?void 0:l):await this.fileService.createFile(this.file,T.VSBuffer.fromString(S),{overwrite:C})}catch(U){throw U instanceof f.FileOperationError&&U.fileOperationResult===1||U instanceof f.FileOperationError&&U.fileOperationResult===3?new p.UserDataSyncError(U.message,"LocalPreconditionFailed"):U}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(S){if(!(S instanceof f.FileOperationError&&S.fileOperationResult===1))throw S}}onFileChanges(S){S.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=i,e.AbstractFileSynchroniser=i=ye([K(3,f.IFileService),K(4,h.IEnvironmentService),K(5,u.IStorageService),K(6,p.IUserDataSyncStoreService),K(7,p.IUserDataSyncBackupStoreService),K(8,p.IUserDataSyncEnablementService),K(9,d.ITelemetryService),K(10,p.IUserDataSyncLogService),K(11,g.IConfigurationService),K(12,v.IUriIdentityService)],i);let r=class extends i{constructor(S,l,C,U,N,F,$,z,J,H,Q,B,Y,x){super(S,l,C,U,N,F,$,z,J,H,Q,Y,x),this.userDataSyncUtilService=B,this._formattingOptions=void 0}hasErrors(S,l){const C=[],U=(0,R.parse)(S,C,{allowEmptyContent:!0,allowTrailingComma:!0});return C.length>0||!(0,I.isUndefined)(U)&&l!==Array.isArray(U)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=r,e.AbstractJsonFileSynchroniser=r=ye([K(3,f.IFileService),K(4,h.IEnvironmentService),K(5,u.IStorageService),K(6,p.IUserDataSyncStoreService),K(7,p.IUserDataSyncBackupStoreService),K(8,p.IUserDataSyncEnablementService),K(9,d.ITelemetryService),K(10,p.IUserDataSyncLogService),K(11,p.IUserDataSyncUtilService),K(12,g.IConfigurationService),K(13,v.IUriIdentityService)],r);let a=class{constructor(S,l,C,U,N,F,$){this.resource=S,this.userDataProfilesService=l,this.environmentService=C,this.logService=U,this.fileService=N,this.storageService=F,this.extUri=$.extUri,this.lastSyncResource=(0,p.getLastSyncResourceUri)(void 0,this.resource,C,this.extUri)}async initialize({ref:S,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const C=this.parseSyncData(l);if(C)try{await this.doInitialize({ref:S,syncData:C})}catch(U){this.logService.error(U)}}parseSyncData(S){try{const l=JSON.parse(S);if(o(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(S,l={}){if(l.ref||l.version)throw new Error("Cannot have core properties as additional");const C={ref:S.ref,version:void 0,...l};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(C),-1,1),await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(S)))}};e.AbstractInitializer=a,e.AbstractInitializer=a=ye([K(1,L.IUserDataProfilesService),K(2,h.IEnvironmentService),K(3,E.ILogService),K(4,f.IFileService),K(5,u.IStorageService),K(6,v.IUriIdentityService)],a)}),define(ce[115],le([0,1,5,25,8,3,41,2,28,18,15,114,29,33,80,45,13,4,70,7,19,21,27,17,39,230,111,24,58]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d,v,p,L,t,o,s,n,i,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function w(F,$){const z=JSON.parse(F.content);if(F.version===1||F.version===2){const J=(await $.getInstalled(0)).filter(H=>H.isBuiltin);for(const H of z)F.version===1&&(H.enabled===!1&&(H.disabled=!0),delete H.enabled),F.version===2&&J.every(Q=>!(0,h.areSameExtensions)(Q.identifier,H.identifier))&&(H.installed=!0)}return z}function S(F){return JSON.parse(F.content)}e.parseExtensions=S;function l(F,$){return F.sort((z,J)=>!z.identifier.uuid&&J.identifier.uuid?-1:z.identifier.uuid&&!J.identifier.uuid?1:(0,P.compare)(z.identifier.id,J.identifier.id)),$?(0,_.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=l;let C=class extends s.AbstractSynchroniser{constructor($,z,J,H,Q,B,Y,x,j,q,Z,oe,ae,G,W,b,D){super({syncResource:"extensions",profile:$},z,H,J,Q,B,Y,oe,ae,q,Z,W),this.extensionManagementService=x,this.ignoredExtensionsManagementService=j,this.instantiationService=D,this.version=6,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(U),this._register(A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,M=>M.some(({local:V})=>!!V)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,M=>!M.error),A.Event.filter(b.onDidChange,M=>M.valueChanges.some(({profile:V,changes:ee})=>this.syncResource.profile.id===V.id&&ee.some(ne=>ne.key===g.DISABLED_EXTENSIONS_STORAGE_PATH))),G.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview($,z){const J=$.syncData?await w($.syncData,this.extensionManagementService):null,H=z?.skippedExtensions??[],Q=z?.builtinExtensions??null,B=z?.syncData?await w(z.syncData,this.extensionManagementService):null,{localExtensions:Y,ignoredExtensions:x}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);J?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:j,remote:q}=(0,n.merge)(Y,J,B,H,x,Q),Z={local:j,remote:q,content:this.getPreviewContent(Y,j.added,j.updated,j.removed),localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:q!==null?2:0},oe=this.stringify(Y,!1);return[{skippedExtensions:H,builtinExtensions:Q,baseResource:this.baseResource,baseContent:B?this.stringify(B,!1):oe,localResource:this.localResource,localContent:oe,localExtensions:Y,remoteResource:this.remoteResource,remoteExtensions:J,remoteContent:J?this.stringify(J,!1):null,previewResource:this.previewResource,previewResult:Z,localChange:Z.localChange,remoteChange:Z.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged($){const z=$.syncData?await w($.syncData,this.extensionManagementService):null,{localExtensions:J,ignoredExtensions:H}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,n.merge)(J,z,z,$.skippedExtensions||[],H,$.builtinExtensions||[]);return Q!==null}getPreviewContent($,z,J,H){const Q=[...z,...J],B=new Set,Y=x=>{B.add(x.id.toLowerCase()),x.uuid&&B.add(x.uuid)};Q.forEach(({identifier:x})=>Y(x)),H.forEach(Y);for(const x of $)B.has(x.identifier.id.toLowerCase())||x.identifier.uuid&&B.has(x.identifier.uuid)||Q.push(x);return this.stringify(Q,!1)}async getMergeResult($,z){return{...$.previewResult,hasConflicts:!1}}async getAcceptResult($,z,J,H){if(this.extUri.isEqual(z,this.localResource))return this.acceptLocal($);if(this.extUri.isEqual(z,this.remoteResource))return this.acceptRemote($);if(this.extUri.isEqual(z,this.previewResource))return $.previewResult;throw new Error(`Invalid Resource: ${z.toString()}`)}async acceptLocal($){const z=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),J=this.ignoredExtensionsManagementService.getIgnoredExtensions(z),H=(0,n.merge)($.localExtensions,null,null,$.skippedExtensions,J,$.builtinExtensions),{local:Q,remote:B}=H;return{content:$.localContent,local:Q,remote:B,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:B!==null?2:0}}async acceptRemote($){const z=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),J=this.ignoredExtensionsManagementService.getIgnoredExtensions(z),H=$.remoteContent?JSON.parse($.remoteContent):null;if(H!==null){const Q=(0,n.merge)($.localExtensions,H,$.localExtensions,[],J,$.builtinExtensions),{local:B,remote:Y}=Q;return{content:$.remoteContent,local:B,remote:Y,localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:Y!==null?2:0}}else return{content:$.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult($,z,J,H){let{skippedExtensions:Q,builtinExtensions:B,localExtensions:Y}=J[0][0];const{local:x,remote:j,localChange:q,remoteChange:Z}=J[0][1];if(q===0&&Z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),q!==0&&(await this.backupLocal(JSON.stringify(Y)),Q=await this.localExtensionsProvider.updateLocalExtensions(x.added,x.removed,x.updated,Q,this.syncResource.profile)),j){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const oe=JSON.stringify(j.all);$=await this.updateRemoteUserData(oe,H?null:$.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${j.added.length?` Added: ${JSON.stringify(j.added.map(ae=>ae.identifier.id))}.`:""}${j.updated.length?` Updated: ${JSON.stringify(j.updated.map(ae=>ae.identifier.id))}.`:""}${j.removed.length?` Removed: ${JSON.stringify(j.removed.map(ae=>ae.identifier.id))}.`:""}`)}z?.ref!==$.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),B=this.computeBuiltinExtensions(Y,B),await this.updateLastSyncUserData($,{skippedExtensions:Q,builtinExtensions:B}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(oe=>oe.identifier.id))}.`:""}`))}computeBuiltinExtensions($,z){const J=new Set,H=[];for(const Q of $)J.add(Q.identifier.id.toLowerCase()),Q.installed||H.push(Q.identifier);if(z)for(const Q of z)J.has(Q.id.toLowerCase())||H.push(Q);return H}async resolveContent($){if(this.extUri.isEqual(this.remoteResource,$)||this.extUri.isEqual(this.baseResource,$)||this.extUri.isEqual(this.localResource,$)||this.extUri.isEqual(this.acceptedResource,$)){const z=await this.resolvePreviewContent($);return z&&this.stringify(JSON.parse(z),!0)}return null}stringify($,z){return l($,z)}async hasLocalData(){try{const{localExtensions:$}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if($.some(z=>z.installed||z.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=C,e.ExtensionsSynchroniser=C=ye([K(2,I.IEnvironmentService),K(3,c.IFileService),K(4,p.IStorageService),K(5,r.IUserDataSyncStoreService),K(6,r.IUserDataSyncBackupStoreService),K(7,g.IExtensionManagementService),K(8,i.IIgnoredExtensionsManagementService),K(9,r.IUserDataSyncLogService),K(10,m.IConfigurationService),K(11,r.IUserDataSyncEnablementService),K(12,L.ITelemetryService),K(13,f.IExtensionStorageService),K(14,t.IUriIdentityService),K(15,a.IUserDataProfileStorageService),K(16,u.IInstantiationService)],C);let U=class{constructor($,z,J,H,Q,B){this.extensionManagementService=$,this.userDataProfileStorageService=z,this.extensionGalleryService=J,this.ignoredExtensionsManagementService=H,this.instantiationService=Q,this.logService=B}async getLocalExtensions($){const z=await this.extensionManagementService.getInstalled(void 0,$.extensionsResource),J=this.ignoredExtensionsManagementService.getIgnoredExtensions(z);return{localExtensions:await this.withProfileScopedServices($,async(Q,B)=>{const Y=Q.getDisabledExtensions();return z.map(x=>{const{identifier:j,isBuiltin:q,manifest:Z,preRelease:oe,pinned:ae,isApplicationScoped:G}=x,W={identifier:j,preRelease:oe,version:Z.version,pinned:!!ae};G&&!(0,E.isApplicationScopedExtension)(Z)&&(W.isApplicationScoped=G),Y.some(b=>(0,h.areSameExtensions)(b,j))&&(W.disabled=!0),q||(W.installed=!0);try{const b=B.getKeysForSync({id:j.id,version:Z.version});if(b){const D=B.getExtensionState(x,!0)||{};W.state=Object.keys(D).reduce((M,V)=>(b.includes(V)&&(M[V]=D[V]),M),{})}}catch(b){this.logService.info(`${(0,s.getSyncResourceLogLabel)("extensions",$)}: Error while parsing extension state`,(0,T.getErrorMessage)(b))}return W})}),ignoredExtensions:J}}async updateLocalExtensions($,z,J,H,Q){const B=(0,s.getSyncResourceLogLabel)("extensions",Q),Y=[],x=new Map,j=[],q=[],Z=await this.extensionManagementService.getInstalled(void 0,Q.extensionsResource);if(($.length||J.length)&&await this.withProfileScopedServices(Q,async(G,W)=>{await k.Promises.settled([...$,...J].map(async b=>{const D=Z.find(ee=>(0,h.areSameExtensions)(ee.identifier,b.identifier));if(D&&D.isBuiltin){b.state&&D.manifest.version===b.version&&this.updateExtensionState(b.state,D,D.manifest.version,W),G.getDisabledExtensions().some(ne=>(0,h.areSameExtensions)(ne,b.identifier))!==!!b.disabled&&(b.disabled?(this.logService.trace(`${B}: Disabling extension...`,b.identifier.id),await G.disableExtension(b.identifier),this.logService.info(`${B}: Disabled extension`,b.identifier.id)):(this.logService.trace(`${B}: Enabling extension...`,b.identifier.id),await G.enableExtension(b.identifier),this.logService.info(`${B}: Enabled extension`,b.identifier.id))),j.push(b.identifier);return}const M=b.pinned?b.version:void 0,V=(await this.extensionGalleryService.getExtensions([{...b.identifier,version:M,preRelease:M?void 0:b.preRelease}],O.CancellationToken.None))[0];if(b.state&&(D?D.manifest.version===b.version:V)&&this.updateExtensionState(b.state,D||V,D?.manifest.version,W),V)try{G.getDisabledExtensions().some(ne=>(0,h.areSameExtensions)(ne,b.identifier))!==!!b.disabled&&(b.disabled?(this.logService.trace(`${B}: Disabling extension...`,b.identifier.id,V.version),await G.disableExtension(V.identifier),this.logService.info(`${B}: Disabled extension`,b.identifier.id,V.version)):(this.logService.trace(`${B}: Enabling extension...`,b.identifier.id,V.version),await G.enableExtension(V.identifier),this.logService.info(`${B}: Enabled extension`,b.identifier.id,V.version))),(!D||D.preRelease!==b.preRelease||D.pinned!==b.pinned||M&&D.manifest.version!==M)&&(await this.extensionManagementService.canInstall(V)?(Y.push({extension:V,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:b.pinned&&!!b.version,installPreReleaseVersion:b.preRelease,profileLocation:Q.extensionsResource,isApplicationScoped:b.isApplicationScoped,context:{[g.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[g.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}}),x.set(V.identifier.id.toLowerCase(),b)):(this.logService.info(`${B}: Skipped synchronizing extension because it cannot be installed.`,V.displayName||V.identifier.id),q.push(b)))}catch(ee){q.push(b),this.logService.error(ee),this.logService.info(`${B}: Skipped synchronizing extension`,V.displayName||V.identifier.id)}else q.push(b),this.logService.info(`${B}: Skipped synchronizing extension because the extension is not found.`,b.identifier.id)}))}),z.length){const G=Z.filter(({identifier:W,isBuiltin:b})=>!b&&z.some(D=>(0,h.areSameExtensions)(W,D)));await k.Promises.settled(G.map(async W=>{this.logService.trace(`${B}: Uninstalling local extension...`,W.identifier.id),await this.extensionManagementService.uninstall(W,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.logService.info(`${B}: Uninstalled local extension.`,W.identifier.id),j.push(W.identifier)}))}const oe=await this.extensionManagementService.installGalleryExtensions(Y);for(const{identifier:G,local:W,error:b,source:D}of oe){const M=D;if(W)this.logService.info(`${B}: Installed extension.`,G.id,M.version),j.push(G);else{const V=x.get(G.id.toLowerCase());V&&(q.push(V),this.logService.info(`${B}: Skipped synchronizing extension`,M.displayName||M.identifier.id)),b instanceof g.ExtensionManagementError&&[g.ExtensionManagementErrorCode.Incompatible,g.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(b.code)?this.logService.info(`${B}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):b&&this.logService.error(b)}}const ae=[];for(const G of H)j.some(W=>(0,h.areSameExtensions)(W,G.identifier))||ae.push(G);for(const G of q)ae.some(W=>(0,h.areSameExtensions)(W.identifier,G.identifier))||ae.push(G);return ae}updateExtensionState($,z,J,H){const Q=H.getExtensionState(z,!0)||{},B=J?H.getKeysForSync({id:z.identifier.id,version:J}):void 0;B?B.forEach(Y=>{Q[Y]=$[Y]}):Object.keys($).forEach(Y=>Q[Y]=$[Y]),H.setExtensionState(z,Q,!0)}async withProfileScopedServices($,z){return this.userDataProfileStorageService.withProfileScopedStorageService($,async J=>{const H=new R.DisposableStore,Q=this.instantiationService.createChild(new d.ServiceCollection([p.IStorageService,J])),B=H.add(Q.createInstance(y.GlobalExtensionEnablementService)),Y=H.add(Q.createInstance(f.ExtensionStorageService));try{return await z(B,Y)}finally{H.dispose()}})}};e.LocalExtensionsProvider=U,e.LocalExtensionsProvider=U=ye([K(0,g.IExtensionManagementService),K(1,a.IUserDataProfileStorageService),K(2,g.IExtensionGalleryService),K(3,i.IIgnoredExtensionsManagementService),K(4,u.IInstantiationService),K(5,r.IUserDataSyncLogService)],U);let N=class extends s.AbstractInitializer{constructor($,z,J,H,Q,B,Y,x){super("extensions",H,Q,B,J,Y,x),this.extensionManagementService=$,this.ignoredExtensionsManagementService=z}async parseExtensions($){return $.syncData?await w($.syncData,this.extensionManagementService):null}generatePreview($,z){const J=[],H=[],Q=[];for(const B of $){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(B.identifier.id))continue;const Y=z.find(x=>(0,h.areSameExtensions)(x.identifier,B.identifier));Y?(J.push(Y),B.disabled&&Q.push(B.identifier)):B.installed&&(H.push({...B.identifier,preRelease:!!B.preRelease}),B.disabled&&Q.push(B.identifier))}return{installedExtensions:J,newExtensions:H,disabledExtensions:Q,remoteExtensions:$}}};e.AbstractExtensionsInitializer=N,e.AbstractExtensionsInitializer=N=ye([K(0,g.IExtensionManagementService),K(1,i.IIgnoredExtensionsManagementService),K(2,c.IFileService),K(3,o.IUserDataProfilesService),K(4,I.IEnvironmentService),K(5,v.ILogService),K(6,p.IStorageService),K(7,t.IUriIdentityService)],N)}),define(ce[116],le([0,1,14,8,3,34,41,6,32,18,15,13,7,44,19,21,27,39,77,234,24,17,58,4]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d,v,p,L,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const s="globalState.argv.",n=["locale"];function i(C,U){const N=C.storage?Object.keys(C.storage).sort():[],F={};return N.forEach($=>F[$]=C.storage[$]),C.storage=F,U?(0,_.toFormattedString)(C,{}):JSON.stringify(C)}e.stringify=i;const r=1;let a=class extends u.AbstractSynchroniser{constructor(U,N,F,$,z,J,H,Q,B,Y,x,j,q,Z){super({syncResource:"globalState",profile:U},N,$,Q,j,z,J,B,Y,H,x,q),this.userDataProfileStorageService=F,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=Z.createInstance(w),this._register($.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(T.Event.any(T.Event.filter($.onDidFilesChange,oe=>oe.contains(this.environmentService.argvResource)),T.Event.filter(F.onDidChange,oe=>!!(oe.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||oe.valueChanges.some(({profile:ae,changes:G})=>this.syncResource.profile.id===ae.id&&G.some(W=>W.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(U,N,F){const $=U.syncData?JSON.parse(U.syncData.content):null;N=N===null&&F?U:N;const z=N&&N.syncData?JSON.parse(N.syncData.content):null,J=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);$?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=await this.getStorageKeys(z),{local:Q,remote:B}=(0,v.merge)(J.storage,$?$.storage:null,z?z.storage:null,H,this.logService),Y={content:null,local:Q,remote:B,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?2:0,remoteChange:B.all!==null?2:0},x=i(J,!1);return[{baseResource:this.baseResource,baseContent:z?i(z,!1):x,localResource:this.localResource,localContent:x,localUserData:J,remoteResource:this.remoteResource,remoteContent:$?i($,!1):null,previewResource:this.previewResource,previewResult:Y,localChange:Y.localChange,remoteChange:Y.remoteChange,acceptedResource:this.acceptedResource,storageKeys:H}]}async hasRemoteChanged(U){const N=U.syncData?JSON.parse(U.syncData.content):null;if(N===null)return!0;const F=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),$=await this.getStorageKeys(N),{remote:z}=(0,v.merge)(F.storage,N.storage,N.storage,$,this.logService);return z.all!==null}async getMergeResult(U,N){return{...U.previewResult,hasConflicts:!1}}async getAcceptResult(U,N,F,$){if(this.extUri.isEqual(N,this.localResource))return this.acceptLocal(U);if(this.extUri.isEqual(N,this.remoteResource))return this.acceptRemote(U);if(this.extUri.isEqual(N,this.previewResource))return U.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async acceptLocal(U){return{content:U.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(U.localUserData.storage),removed:[],updated:[],all:U.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(U){if(U.remoteContent!==null){const N=JSON.parse(U.remoteContent),{local:F,remote:$}=(0,v.merge)(U.localUserData.storage,N.storage,null,U.storageKeys,this.logService);return{content:U.remoteContent,local:F,remote:$,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:$!==null?2:0}}else return{content:U.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(U,N,F,$){const{localUserData:z}=F[0][0],{local:J,remote:H,localChange:Q,remoteChange:B}=F[0][1];if(Q===0&&B===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),Q!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(z)),await this.localGlobalStateProvider.writeLocalGlobalState(J,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),B!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const Y=JSON.stringify({storage:H.all});U=await this.updateRemoteUserData(Y,$?null:U.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${H.added.length?` Added: ${H.added}.`:""}${H.updated.length?` Updated: ${H.updated}.`:""}${H.removed.length?` Removed: ${H.removed}.`:""}`)}N?.ref!==U.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(U),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(U){if(this.extUri.isEqual(this.remoteResource,U)||this.extUri.isEqual(this.baseResource,U)||this.extUri.isEqual(this.localResource,U)||this.extUri.isEqual(this.acceptedResource,U)){const N=await this.resolvePreviewContent(U);return N&&i(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:U}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(U).length>1||U[`${s}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(U){const N=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),F=[],$=[];for(const[H,Q]of N)Q.target===0?F.push(H):Q.target===1&&$.push(H);const z=[...F,...$],J=U?.storage?Object.keys(U.storage).filter(H=>!H.startsWith(s)&&!z.includes(H)&&N.get(H)!==void 0):[];if(!R.isWeb){const H=[...p.ALL_SYNC_RESOURCES.map(Q=>(0,p.getEnablementKey)(Q)),p.SYNC_SERVICE_URL_TYPE];J.push(...H),$.push(...H)}return{user:F,machine:$,unregistered:J}}};e.GlobalStateSynchroniser=a,e.GlobalStateSynchroniser=a=ye([K(2,t.IUserDataProfileStorageService),K(3,y.IFileService),K(4,p.IUserDataSyncStoreService),K(5,p.IUserDataSyncBackupStoreService),K(6,p.IUserDataSyncLogService),K(7,I.IEnvironmentService),K(8,p.IUserDataSyncEnablementService),K(9,E.ITelemetryService),K(10,m.IConfigurationService),K(11,f.IStorageService),K(12,c.IUriIdentityService),K(13,o.IInstantiationService)],a);let w=class{constructor(U,N,F,$){this.fileService=U,this.environmentService=N,this.userDataProfileStorageService=F,this.logService=$}async getLocalGlobalState(U){const N={};if(U.isDefault){const $=await this.getLocalArgvContent(),z=(0,A.parse)($);for(const J of n)z[J]!==void 0&&(N[`${s}${J}`]={version:1,value:z[J]})}const F=await this.userDataProfileStorageService.readStorageData(U);for(const[$,z]of F)z.value&&z.target===0&&(N[$]={version:1,value:z.value});return{storage:N}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const U=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),U.value.toString()}catch(U){this.logService.debug((0,O.getErrorMessage)(U))}return"{}"}async writeLocalGlobalState({added:U,removed:N,updated:F},$){const z=(0,u.getSyncResourceLogLabel)("globalState",$),J={},H=new Map,Q=await this.userDataProfileStorageService.readStorageData($),B=(Y,x)=>{for(const j of Y){if(j.startsWith(s)){J[j.substring(s.length)]=x?x[j].value:void 0;continue}if(x){const q=x[j];q.value!==Q.get(j)?.value&&H.set(j,q.value)}else Q.get(j)!==void 0&&H.set(j,void 0)}};if(B(Object.keys(U),U),B(Object.keys(F),F),B(N),Object.keys(J).length){this.logService.trace(`${z}: Updating locale...`);const Y=await this.getLocalArgvContent();let x=Y;for(const j of Object.keys(J))x=(0,d.edit)(x,[j],J[j],{});Y!==x&&(this.logService.trace(`${z}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(x)),this.logService.info(`${z}: Updated locale.`)),this.logService.info(`${z}: Updated locale`)}H.size&&(this.logService.trace(`${z}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData($,H,0),this.logService.info(`${z}: Updated global state`,[...H.keys()]))}};e.LocalGlobalStateProvider=w,e.LocalGlobalStateProvider=w=ye([K(0,y.IFileService),K(1,I.IEnvironmentService),K(2,t.IUserDataProfileStorageService),K(3,p.IUserDataSyncLogService)],w);let S=class extends u.AbstractInitializer{constructor(U,N,F,$,z,J){super("globalState",F,$,z,N,U,J)}async doInitialize(U){const N=U.syncData?JSON.parse(U.syncData.content):null;if(!N){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const F={},$={};for(const z of Object.keys(N.storage))z.startsWith(s)?F[z.substring(s.length)]=N.storage[z].value:this.storageService.get(z,0)===void 0&&($[z]=N.storage[z].value);if(Object.keys(F).length){let z="{}";try{z=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const J of Object.keys(F))z=(0,d.edit)(z,[J],F[J],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(z))}if(Object.keys($).length){const z=[];for(const J of Object.keys($))z.push({key:J,value:$[J],scope:0,target:0});this.storageService.storeAll(z,!0)}}};e.GlobalStateInitializer=S,e.GlobalStateInitializer=S=ye([K(0,f.IStorageService),K(1,y.IFileService),K(2,L.IUserDataProfilesService),K(3,I.IEnvironmentService),K(4,p.IUserDataSyncLogService),K(5,c.IUriIdentityService)],S);let l=class{constructor(U,N,F,$,z){this.userDataSyncStoreClient=U,this.storageService=N,this.environmentService=F,this.fileService=$,this.logService=z}getSyncStoreType(U){return this.parseGlobalState(U)?.storage[p.SYNC_SERVICE_URL_TYPE]?.value}async sync(U){const N=(0,p.createSyncHeaders)((0,P.generateUuid)());try{return await this.doSync(U,N)}catch(F){if(F instanceof p.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(U,N)}throw F}}async doSync(U,N){const F=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,N),$=this.parseGlobalState(F)||{storage:{}};$.storage[p.SYNC_SERVICE_URL_TYPE]={value:U,version:r};const z=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),J={version:r,machineId:z,content:i($,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(J),F.ref,void 0,N)}parseGlobalState({content:U}){if(!U)return null;const N=JSON.parse(U);if((0,u.isSyncData)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=l,e.UserDataSyncStoreTypeSynchronizer=l=ye([K(1,f.IStorageService),K(2,I.IEnvironmentService),K(3,y.IFileService),K(4,g.ILogService)],l)}),define(ce[117],le([0,1,20,14,3,34,6,11,169,18,15,13,19,21,27,17,39,231,24]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function v(t,o,s){try{const n=JSON.parse(t);if(!o)return(0,R.isUndefined)(n.all)?null:n.all;switch(_.OS){case 2:return(0,R.isUndefined)(n.mac)?null:n.mac;case 3:return(0,R.isUndefined)(n.linux)?null:n.linux;case 1:return(0,R.isUndefined)(n.windows)?null:n.windows}}catch(n){return s.error(n),null}}e.getKeybindingsContentFromSyncContent=v;let p=class extends c.AbstractJsonFileSynchroniser{constructor(o,s,n,i,r,a,w,S,l,C,U,N,F){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},s,S,l,C,n,i,w,N,r,U,a,F),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.filter(a.onDidChangeConfiguration,$=>$.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,s,n,i){const r=o.syncData?v(o.syncData.content,i.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;s=s===null&&n?o:s;const a=s?this.getKeybindingsContentFromLastSyncUserData(s):null,w=await this.getLocalFileContent(),S=await this.getFormattingOptions();let l=null,C=!1,U=!1,N=!1;if(r){let z=w?w.value.toString():"[]";if(z=z||"[]",this.hasErrors(z,!0))throw new d.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==z||a!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const J=await(0,u.merge)(z,r,a,S,this.userDataSyncUtilService);J.hasChanges&&(l=J.mergeContent,N=J.hasConflicts,C=N||J.mergeContent!==z,U=N||J.mergeContent!==r)}}else w&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),l=w.value.toString(),U=!0);const F={content:N?a:l,localChange:C?w?2:1:0,remoteChange:U?2:0,hasConflicts:N},$=w?w.value.toString():null;return[{fileContent:w,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:$,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const s=this.getKeybindingsContentFromLastSyncUserData(o);if(s===null)return!0;const n=await this.getLocalFileContent(),i=n?n.value.toString():"",r=await this.getFormattingOptions(),a=await(0,u.merge)(i||"[]",s,s,r,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==s}async getMergeResult(o,s){return o.previewResult}async getAcceptResult(o,s,n,i){if(this.extUri.isEqual(s,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(s,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(s,this.previewResource))return n===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async applyResult(o,s,n,i){const{fileContent:r}=n[0][0];let{content:a,localChange:w,remoteChange:S}=n[0][1];if(w===0&&S===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new d.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(w!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(a||"[]",r,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),S!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const l=this.toSyncContent(a||"[]",o.syncData?.content);o=await this.updateRemoteUserData(l,i?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}s?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const s=(0,A.parse)(o.value.toString());if((0,k.isNonEmptyArray)(s))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)?this.resolvePreviewContent(o):null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:v(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,s){let n={};try{n=JSON.parse(s||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=o,_.OS){case 2:n.mac=o;break;case 3:n.linux=o;break;case 1:n.windows=o;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(d.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=p,e.KeybindingsSynchroniser=p=ye([K(2,d.IUserDataSyncStoreService),K(3,d.IUserDataSyncBackupStoreService),K(4,d.IUserDataSyncLogService),K(5,m.IConfigurationService),K(6,d.IUserDataSyncEnablementService),K(7,y.IFileService),K(8,I.IEnvironmentService),K(9,g.IStorageService),K(10,d.IUserDataSyncUtilService),K(11,h.ITelemetryService),K(12,f.IUriIdentityService)],p);let L=class extends c.AbstractInitializer{constructor(o,s,n,i,r,a){super("keybindings",s,n,i,o,r,a)}async doInitialize(o){const s=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!s){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,O.VSBuffer.fromString(s)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),s=(0,A.parse)(o.value.toString());return!(0,k.isNonEmptyArray)(s)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return v(o,!0,this.logService)}catch(s){return this.logService.error(s),null}}};e.KeybindingsInitializer=L,e.KeybindingsInitializer=L=ye([K(0,y.IFileService),K(1,E.IUserDataProfilesService),K(2,I.IEnvironmentService),K(3,d.IUserDataSyncLogService),K(4,g.IStorageService),K(5,f.IUriIdentityService)],L)}),define(ce[118],le([0,1,14,3,170,18,73,15,29,13,19,21,27,17,39,235,24]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function u(L){return L&&L.settings&&typeof L.settings=="string"&&Object.keys(L).length===1}function d(L){const t=JSON.parse(L);return u(t)?t:{settings:L}}e.parseSettingsSyncContent=d;let v=class extends f.AbstractJsonFileSynchroniser{constructor(t,o,s,n,i,r,a,w,S,l,C,U,N,F){super(t.settingsResource,{syncResource:"settings",profile:t},o,s,n,i,r,a,C,U,w,S,l,F),this.extensionManagementService=N,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const o=await this.getLastSyncUserData(),s=await this.getLatestRemoteUserData(t,o),n=this.getSettingsSyncContent(s),i=new _.ConfigurationModelParser(c.USER_DATA_SYNC_CONFIGURATION_SCOPE);return n?.settings&&i.parse(n.settings),i.configurationModel.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,o,s){const n=await this.getLocalFileContent(),i=await this.getFormattingOptions(),r=this.getSettingsSyncContent(t);o=o===null&&s?t:o;const a=o?this.getSettingsSyncContent(o):null,w=await this.getIgnoredSettings();let S=null,l=!1,C=!1,U=!1;if(r){let z=n?n.value.toString().trim():"{}";z=z||"{}",this.validateContent(z),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const J=(0,E.merge)(z,r.settings,a?a.settings:null,w,[],i);S=J.localContent||J.remoteContent,l=J.localContent!==null,C=J.remoteContent!==null,U=J.hasConflicts}else n&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),S=n.value.toString().trim()||"{}",this.validateContent(S),C=!0);const N=n?n.value.toString():null,F=a?.settings??null,$={content:U?F:S,localChange:l?2:0,remoteChange:C?2:0,hasConflicts:U};return[{fileContent:n,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:N,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(t){const o=this.getSettingsSyncContent(t);if(o===null)return!0;const s=await this.getLocalFileContent(),n=s?s.value.toString().trim():"",i=await this.getIgnoredSettings(),r=await this.getFormattingOptions();return(0,E.merge)(n||"{}",o.settings,o.settings,i,[],r).remoteContent!==null}async getMergeResult(t,o){const s=await this.getFormattingOptions(),n=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,E.updateIgnoredSettings)(t.previewResult.content,"{}",n,s):null}}async getAcceptResult(t,o,s,n){const i=await this.getFormattingOptions(),r=await this.getIgnoredSettings();if(this.extUri.isEqual(o,this.localResource))return{content:t.fileContent?(0,E.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",r,i):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(o,this.remoteResource))return{content:t.remoteContent!==null?(0,E.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(o,this.previewResource))return s===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:s!==null?(0,E.updateIgnoredSettings)(s,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async applyResult(t,o,s,n){const{fileContent:i}=s[0][0];let{content:r,localChange:a,remoteChange:w}=s[0][1];if(a===0&&w===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.validateContent(r),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),i&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(i.value.toString()))),await this.updateLocalFileContent(r,i,n),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),w!==0){const S=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t),C=await this.getIgnoredSettings(r);r=(0,E.updateIgnoredSettings)(r,l?l.settings:"{}",C,S),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(r)),n?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}o?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t)return!(0,E.isEmpty)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t)||this.extUri.isEqual(this.baseResource,t)?this.resolvePreviewContent(t):null}async resolvePreviewContent(t){let o=await super.resolvePreviewContent(t);if(o){const s=await this.getFormattingOptions(),n=await this.getIgnoredSettings();o=(0,E.updateIgnoredSettings)(o,"{}",n,s)}return o}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return d(t)}catch(o){this.logService.error(o)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const s=O.Event.any(O.Event.filter(this.extensionManagementService.onDidInstallExtensions,n=>n.some(({local:i})=>!!i)),O.Event.filter(this.extensionManagementService.onDidUninstallExtension,n=>!n.error))(()=>{s.dispose(),this._defaultIgnoredSettings=void 0})}const o=await this._defaultIgnoredSettings;return(0,E.getIgnoredSettings)(o,this.configurationService,t)}validateContent(t){if(this.hasErrors(t,!1))throw new c.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=v,e.SettingsSynchroniser=v=ye([K(2,m.IFileService),K(3,R.IEnvironmentService),K(4,I.IStorageService),K(5,c.IUserDataSyncStoreService),K(6,c.IUserDataSyncBackupStoreService),K(7,c.IUserDataSyncLogService),K(8,c.IUserDataSyncUtilService),K(9,A.IConfigurationService),K(10,c.IUserDataSyncEnablementService),K(11,y.ITelemetryService),K(12,P.IExtensionManagementService),K(13,g.IUriIdentityService)],v);let p=class extends f.AbstractInitializer{constructor(t,o,s,n,i,r){super("settings",o,s,n,t,i,r)}async doInitialize(t){const o=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!o){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,k.VSBuffer.fromString(o.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,E.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return d(t)}catch(o){this.logService.error(o)}return null}};e.SettingsInitializer=p,e.SettingsInitializer=p=ye([K(0,m.IFileService),K(1,h.IUserDataProfilesService),K(2,R.IEnvironmentService),K(3,c.IUserDataSyncLogService),K(4,I.IStorageService),K(5,g.IUriIdentityService)],p)}),define(ce[119],le([0,1,14,3,30,18,15,13,19,21,27,17,39,232,24]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function E(d){return JSON.parse(d.content)}e.parseSnippets=E;let c=class extends g.AbstractSynchroniser{constructor(v,p,L,t,o,s,n,i,r,a,w,S){super({syncResource:"snippets",profile:v},p,t,L,o,s,n,a,w,i,r,S),this.version=1,this.snippetsFolder=v.snippetsHome,this._register(this.fileService.watch(L.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(O.Event.filter(this.fileService.onDidFilesChange,l=>l.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(v,p,L){const t=await this.getSnippetsFileContents(),o=this.toSnippetsContents(t),s=v.syncData?this.parseSnippets(v.syncData):null;p=p===null&&L?v:p;const n=p&&p.syncData?this.parseSnippets(p.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,h.merge)(o,s,n);return this.getResourcePreviews(i,t,s||{},n||{})}async hasRemoteChanged(v){const p=v.syncData?this.parseSnippets(v.syncData):null;if(p===null)return!0;const L=await this.getSnippetsFileContents(),t=this.toSnippetsContents(L),o=(0,h.merge)(t,p,p);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async getMergeResult(v,p){return v.previewResult}async getAcceptResult(v,p,L,t){if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:v.fileContent?v.fileContent.value.toString():null,localChange:0,remoteChange:v.fileContent?v.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:v.remoteContent,localChange:v.remoteContent!==null?v.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder))return L===void 0?{content:v.previewResult.content,localChange:v.previewResult.localChange,remoteChange:v.previewResult.remoteChange}:{content:L,localChange:L===null?v.fileContent!==null?3:0:2,remoteChange:L===null?v.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async applyResult(v,p,L,t){const o=L.map(([s,n])=>({...s,acceptResult:n}));o.every(({localChange:s,remoteChange:n})=>s===0&&n===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,t)),o.some(({remoteChange:s})=>s!==0)&&(v=await this.updateRemoteSnippets(o,v,t)),p?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of o)try{await this.fileService.del(s)}catch{}}getResourcePreviews(v,p,L,t){const o=new Map;for(const s of Object.keys(v.local.added)){const n={content:v.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(v.local.updated)){const n={content:v.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},i=p[s]?p[s].value.toString():null;o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[s],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of v.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=p[s]?p[s].value.toString():null;o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[s],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(v.remote.added)){const n={content:v.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},i=p[s]?p[s].value.toString():null;o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[s],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(v.remote.updated)){const n={content:v.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},i=p[s]?p[s].value.toString():null;o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[s],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of v.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of v.conflicts){const n={content:t[s]??null,hasConflicts:!0,localChange:p[s]?2:1,remoteChange:L[s]?2:1},i=p[s]?p[s].value.toString():null;o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[s]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(p))if(!o.has(s)){const n={content:p[s]?p[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=p[s]?p[s].value.toString():null;o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[s]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(v){return this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(v):null}async hasLocalData(){try{const v=await this.getSnippetsFileContents();if(Object.keys(v).length)return!0}catch{}return!1}async updateLocalBackup(v){const p={};for(const L of v)L.fileContent&&(p[this.extUri.basename(L.localResource)]=L.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(p)))}async updateLocalSnippets(v,p){for(const{fileContent:L,acceptResult:t,localResource:o,remoteResource:s,localChange:n}of v)if(n!==0){const i=s?this.extUri.basename(s):this.extUri.basename(o),r=this.extUri.joinPath(this.snippetsFolder,i);n===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):n===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,k.VSBuffer.fromString(t.content),{overwrite:p}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,k.VSBuffer.fromString(t.content),p?void 0:L),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(v,p,L){const t=p.syncData?this.parseSnippets(p.syncData):{},o=(0,T.deepClone)(t);for(const{acceptResult:s,localResource:n,remoteResource:i,remoteChange:r}of v)if(r!==0){const a=n?this.extUri.basename(n):this.extUri.basename(i);r===3?delete o[a]:o[a]=s.content}return(0,h.areSame)(t,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),p=await this.updateRemoteUserData(JSON.stringify(o),L?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),p}parseSnippets(v){return E(v)}toSnippetsContents(v){const p={};for(const L of Object.keys(v))p[L]=v[L].value.toString();return p}async getSnippetsFileContents(){const v={};let p;try{p=await this.fileService.resolve(this.snippetsFolder)}catch(L){if(L instanceof R.FileOperationError&&L.fileOperationResult===1)return v;throw L}for(const L of p.children||[]){const t=L.resource,o=this.extUri.extname(t);if(o===".json"||o===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,t),n=await this.fileService.readFile(t);v[s]=n}}return v}};e.SnippetsSynchroniser=c,e.SnippetsSynchroniser=c=ye([K(2,_.IEnvironmentService),K(3,R.IFileService),K(4,P.IStorageService),K(5,f.IUserDataSyncStoreService),K(6,f.IUserDataSyncBackupStoreService),K(7,f.IUserDataSyncLogService),K(8,A.IConfigurationService),K(9,f.IUserDataSyncEnablementService),K(10,m.ITelemetryService),K(11,I.IUriIdentityService)],c);let u=class extends g.AbstractInitializer{constructor(v,p,L,t,o,s){super("snippets",p,L,t,v,o,s)}async doInitialize(v){const p=v.syncData?JSON.parse(v.syncData.content):null;if(!p){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(p)){const o=p[t];if(o){const s=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,t);await this.fileService.createFile(s,k.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(v)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(v){return v.fileOperationResult===1}}};e.SnippetsInitializer=u,e.SnippetsInitializer=u=ye([K(0,R.IFileService),K(1,y.IUserDataProfilesService),K(2,_.IEnvironmentService),K(3,f.IUserDataSyncLogService),K(4,P.IStorageService),K(5,I.IUriIdentityService)],u)}),define(ce[120],le([0,1,14,18,15,13,19,21,27,17,39,24]),function(ie,e,k,O,T,A,_,R,P,m,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function g(c,u){try{return JSON.parse(c).tasks??null}catch(d){return u.error(d),null}}e.getTasksContentFromSyncContent=g;let h=class extends I.AbstractFileSynchroniser{constructor(u,d,v,p,L,t,o,s,n,i,r,a){super(u.tasksResource,{syncResource:"tasks",profile:u},d,s,n,i,v,p,o,r,L,t,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(u,d,v,p){const L=u.syncData?g(u.syncData.content,this.logService):null;d=d===null&&v?u:d;const t=d?.syncData?g(d.syncData.content,this.logService):null,o=await this.getLocalFileContent();let s=null,n=!1,i=!1,r=!1;if(u.syncData){const S=o?o.value.toString():null;if(!t||t!==S||t!==L){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const l=E(S,L,t);s=l.content,r=l.hasConflicts,n=l.hasLocalChanged,i=l.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),s=o.value.toString(),i=!0);const a={content:r?t:s,localChange:n?o?2:1:0,remoteChange:i?2:0,hasConflicts:r},w=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:t,localResource:this.localResource,localContent:w,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:L,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const d=u?.syncData?g(u.syncData.content,this.logService):null;if(d===null)return!0;const v=await this.getLocalFileContent(),p=v?v.value.toString():null,L=E(p,d,d);return L.hasLocalChanged||L.hasRemoteChanged}async getMergeResult(u,d){return u.previewResult}async getAcceptResult(u,d,v,p){if(this.extUri.isEqual(d,this.localResource))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(d,this.remoteResource))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(d,this.previewResource))return v===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:v,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async applyResult(u,d,v,p){const{fileContent:L}=v[0][0],{content:t,localChange:o,remoteChange:s}=v[0][1];if(o===0&&s===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),L&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(L.value.toString()))),t?await this.updateLocalFileContent(t,L,p):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),s!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const n=JSON.stringify(this.toTasksSyncContent(t));u=await this.updateRemoteUserData(n,p?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}d?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(u){return this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)?this.resolvePreviewContent(u):null}toTasksSyncContent(u){return u?{tasks:u}:{}}};e.TasksSynchroniser=h,e.TasksSynchroniser=h=ye([K(2,y.IUserDataSyncStoreService),K(3,y.IUserDataSyncBackupStoreService),K(4,y.IUserDataSyncLogService),K(5,O.IConfigurationService),K(6,y.IUserDataSyncEnablementService),K(7,A.IFileService),K(8,T.IEnvironmentService),K(9,_.IStorageService),K(10,R.ITelemetryService),K(11,P.IUriIdentityService)],h);let f=class extends I.AbstractInitializer{constructor(u,d,v,p,L,t){super("tasks",d,v,p,u,L,t),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(u){const d=u.syncData?g(u.syncData.content,this.logService):null;if(!d){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,k.VSBuffer.fromString(d)),await this.updateLastSyncUserData(u)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=f,e.TasksInitializer=f=ye([K(0,A.IFileService),K(1,m.IUserDataProfilesService),K(2,T.IEnvironmentService),K(3,y.IUserDataSyncLogService),K(4,_.IStorageService),K(5,P.IUriIdentityService)],f);function E(c,u,d){if(c===null&&u===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(c===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const v=d!==c,p=d!==u;return!v&&!p?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:v&&!p?{content:c,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:p&&!v?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:c,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ce[121],le([0,1,41,18,15,13,19,21,27,17,39,233,24]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let h=class extends I.AbstractSynchroniser{constructor(u,d,v,p,L,t,o,s,n,i,r,a,w){super({syncResource:"profiles",profile:u},d,p,L,t,o,s,r,a,n,i,w),this.userDataProfilesService=v,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(v.onDidChangeProfiles(()=>this.triggerLocalChange()))}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?E(u.syncData):null}async getRemoteSyncedProfiles(u){const d=await this.getLastSyncUserData(),v=await this.getLatestRemoteUserData(u,d);return v?.syncData?E(v.syncData):null}async generateSyncPreview(u,d,v){if(!this.userDataProfilesService.isEnabled())throw new g.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const p=u.syncData?E(u.syncData):null,L=d?.syncData?E(d.syncData):null,t=this.getLocalUserDataProfiles(),{local:o,remote:s}=(0,y.merge)(t,p,L,[]),n={local:o,remote:s,content:L?this.stringifyRemoteProfiles(L):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:s!==null?2:0},i=f(t,!1);return[{baseResource:this.baseResource,baseContent:L?this.stringifyRemoteProfiles(L):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:p?this.stringifyRemoteProfiles(p):null,remoteProfiles:p,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const d=u?.syncData?E(u.syncData):null,v=this.getLocalUserDataProfiles(),{remote:p}=(0,y.merge)(v,d,d,[]);return!!p?.added.length||!!p?.removed.length||!!p?.updated.length}async getMergeResult(u,d){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,d,v,p){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(u){const d=this.getLocalUserDataProfiles(),v=(0,y.merge)(d,null,null,[]),{local:p,remote:L}=v;return{content:u.localContent,local:p,remote:L,localChange:p.added.length>0||p.removed.length>0||p.updated.length>0?2:0,remoteChange:L!==null?2:0}}async acceptRemote(u){const d=u.remoteContent?JSON.parse(u.remoteContent):null,v=[],p=[];for(const L of this.getLocalUserDataProfiles()){const t=d?.find(o=>o.id===L.id);t&&(v.push({id:L.id,name:L.name,collection:t.collection}),p.push(L))}if(d!==null){const L=(0,y.merge)(p,d,v,[]),{local:t,remote:o}=L;return{content:u.remoteContent,local:t,remote:o,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,d,v,p){const{local:L,remote:t,localChange:o,remoteChange:s}=v[0][1];o===0&&s===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const n=v[0][0].remoteProfiles||[];if(n.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new g.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.backupLocal(f(this.getLocalUserDataProfiles(),!1));const i=[];for(const r of L.added)i.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${r.name}' profile...`),await this.userDataProfilesService.createProfile(r.id,r.name,{shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${r.name}'.`)})());for(const r of L.removed)i.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${r.name}' profile...`),await this.userDataProfilesService.removeProfile(r),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${r.name}'.`)})());for(const r of L.updated){const a=this.userDataProfilesService.profiles.find(w=>w.id===r.id);a?i.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${r.name}' profile...`),await this.userDataProfilesService.updateProfile(a,{name:r.name,shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${r.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(i)}if(s!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const i=[],r=n.length+(t?.added.length??0)<=20;if(r)for(const a of t?.added||[]){const w=await this.userDataSyncStoreService.createCollection(this.syncHeaders);i.push(w),n.push({id:a.id,name:a.name,collection:w,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const a of t?.removed||[])n.splice(n.findIndex(({id:w})=>a.id===w),1);for(const a of t?.updated||[]){const w=n.find(({id:S})=>a.id===S);w&&n.splice(n.indexOf(w),1,{...w,id:a.id,name:a.name,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}try{u=await this.updateRemoteProfiles(n,p?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${r&&t?.added.length?` Added: ${JSON.stringify(t.added.map(a=>a.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(a=>a.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(a=>a.name))}.`:""}`)}catch(a){if(i.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const w of i)await this.userDataSyncStoreService.deleteCollection(w,this.syncHeaders)}throw a}for(const a of t?.removed||[])await this.userDataSyncStoreService.deleteCollection(a.collection,this.syncHeaders)}d?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,d){return this.updateRemoteUserData(this.stringifyRemoteProfiles(u),d)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(u){if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)){const d=await this.resolvePreviewContent(u);return d&&(0,k.toFormattedString)(JSON.parse(d),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(u=>!u.isDefault&&!u.isTransient)}stringifyRemoteProfiles(u){return JSON.stringify([...u].sort((d,v)=>d.name.localeCompare(v.name)))}};e.UserDataProfilesManifestSynchroniser=h,e.UserDataProfilesManifestSynchroniser=h=ye([K(2,m.IUserDataProfilesService),K(3,A.IFileService),K(4,T.IEnvironmentService),K(5,_.IStorageService),K(6,g.IUserDataSyncStoreService),K(7,g.IUserDataSyncBackupStoreService),K(8,g.IUserDataSyncLogService),K(9,O.IConfigurationService),K(10,g.IUserDataSyncEnablementService),K(11,R.ITelemetryService),K(12,P.IUriIdentityService)],h);function f(c,u){const d=[...c].sort((v,p)=>v.name.localeCompare(p.name)).map(v=>({id:v.id,name:v.name}));return u?(0,k.toFormattedString)(d,{}):JSON.stringify(d)}e.stringifyLocalProfiles=f;function E(c){return JSON.parse(c.content)}e.parseUserDataProfilesManifest=E}),define(ce[251],le([0,1,5,14,62,2,22,18,15,13,17,24]),function(ie,e,k,O,T,A,_,R,P,m,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let g=class extends A.Disposable{constructor(f,E,c,u,d){super(),this.environmentService=f,this.fileService=E,this.configurationService=c,this.logService=u,this.userDataProfilesService=d,this.cleanUp()}async cleanUp(){for(const E of this.userDataProfilesService.profiles)for(const c of y.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(E,c))}catch(u){this.logService.error(u)}let f;try{f=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(E){(0,m.toFileOperationResult)(E)!==1&&this.logService.error(E);return}if(f.children){for(const E of f.children)if(E.isDirectory&&!this.userDataProfilesService.profiles.some(c=>c.id===E.name))try{this.logService.info("Deleting non existing profile from backup",E.resource.path),await this.fileService.del(E.resource,{recursive:!0})}catch(c){this.logService.error(c)}}}async getAllRefs(f,E){const c=this.getResourceBackupHome(f,E);try{const u=await this.fileService.resolve(c);if(u.children)return u.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort().reverse().map(v=>({ref:v.name,created:this.getCreationTime(v)}))}catch(u){if((0,m.toFileOperationResult)(u)!==1)throw u}return[]}async resolveContent(f,E,c){const u=this.getResourceBackupHome(f,E),d=(0,_.joinPath)(u,c);try{return(await this.fileService.readFile(d)).value.toString()}catch(v){return this.logService.error(v),null}}async backup(f,E,c){const u=this.getResourceBackupHome(f,E),d=(0,_.joinPath)(u,`${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(d,O.VSBuffer.fromString(c))}catch(v){this.logService.error(v)}try{this.cleanUpBackup(u)}catch{}}getResourceBackupHome(f,E){return(0,_.joinPath)(this.environmentService.userDataSyncHome,...f.isDefault?[E]:[f.id,E])}async cleanUpBackup(f){try{try{if(!await this.fileService.exists(f))return}catch{return}const E=await this.fileService.resolve(f);if(E.children){const c=E.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),u=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let d=c.filter(p=>Date.now()-this.getCreationTime(p)>u);const v=c.length-d.length;v<10&&(d=d.slice(10-v)),await k.Promises.settled(d.map(async p=>{this.logService.info("Deleting from backup",p.resource.path),await this.fileService.del(p.resource)}))}}catch(E){this.logService.error(E)}}getCreationTime(f){return f.ctime||new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};e.UserDataSyncBackupStoreService=g,e.UserDataSyncBackupStoreService=g=ye([K(0,P.IEnvironmentService),K(1,m.IFileService),K(2,R.IConfigurationService),K(3,y.IUserDataSyncLogService),K(4,I.IUserDataProfilesService)],g)}),define(ce[252],le([0,1,3,2,6,15,19,21,24]),function(ie,e,k,O,T,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const m="sync.enable";let I=class extends O.Disposable{constructor(g,h,f,E){super(),this.storageService=g,this.telemetryService=h,this.environmentService=f,this.userDataSyncStoreManagementService=E,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(g.onDidChangeValue(-1,void 0,this._register(new O.DisposableStore))(c=>this.onDidStorageChange(c)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(m,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(g){g&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(m,{enabled:g}),this.storageService.store(m,g,-1,1))}isResourceEnabled(g){return this.storageService.getBoolean((0,P.getEnablementKey)(g),-1,!0)}setResourceEnablement(g,h){if(this.isResourceEnabled(g)!==h){const f=(0,P.getEnablementKey)(g);this.storeResourceEnablement(f,h)}}getResourceSyncStateVersion(g){}storeResourceEnablement(g,h){this.storageService.store(g,h,-1,T.isWeb?0:1)}onDidStorageChange(g){if(m===g.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const h=P.ALL_SYNC_RESOURCES.filter(f=>(0,P.getEnablementKey)(f)===g.key)[0];if(h){this._onDidChangeResourceEnablement.fire([h,this.isResourceEnabled(h)]);return}}};e.UserDataSyncEnablementService=I,e.UserDataSyncEnablementService=I=ye([K(0,_.IStorageService),K(1,R.ITelemetryService),K(2,A.IEnvironmentService),K(3,P.IUserDataSyncStoreManagementService)],I)}),define(ce[81],le([0,1,3,2,6,28,174,15,13,4,23,44,19,24]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,m.createDecorator)("IUserDataSyncMachinesService");const E="sync.currentMachineName",c="Safari",u="Chrome",d="Edge",v="Firefox",p="Android";function L(s){switch(s){case c:case u:case d:case v:case p:case(0,T.PlatformToString)(0):return!0}return!1}e.isWebPlatform=L;function t(){return T.isSafari?c:T.isChrome?u:T.isEdge?d:T.isFirefox?v:T.isAndroid?p:(0,T.PlatformToString)(T.isWeb?0:T.platform)}let o=class extends O.Disposable{static{f=this}static{this.VERSION=1}static{this.RESOURCE="machines"}constructor(n,i,r,a,w,S){super(),this.storageService=r,this.userDataSyncStoreService=a,this.logService=w,this.productService=S,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,y.getServiceMachineId)(n,i,r)}async getMachines(n){const i=await this.currentMachineIdPromise;return(await this.readMachinesData(n)).machines.map(a=>({...a,isCurrent:a.id===i}))}async addCurrentMachine(n){const i=await this.currentMachineIdPromise,r=await this.readMachinesData(n);r.machines.some(({id:a})=>a===i)||(r.machines.push({id:i,name:this.computeCurrentMachineName(r.machines),platform:t()}),await this.writeMachinesData(r))}async removeCurrentMachine(n){const i=await this.currentMachineIdPromise,r=await this.readMachinesData(n),a=r.machines.filter(({id:w})=>w!==i);a.length!==r.machines.length&&(r.machines=a,await this.writeMachinesData(r))}async renameMachine(n,i,r){const a=await this.readMachinesData(r),w=a.machines.find(({id:S})=>S===n);if(w){w.name=i,await this.writeMachinesData(a);const S=await this.currentMachineIdPromise;n===S&&this.storageService.store(E,i,-1,1)}}async setEnablements(n){const i=await this.readMachinesData();for(const[r,a]of n){const w=i.machines.find(S=>S.id===r);w&&(w.disabled=a?void 0:!0)}await this.writeMachinesData(i)}computeCurrentMachineName(n){const i=this.storageService.get(E,-1);if(i)return i;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${t()} (${this.productService.nameShort})`,a=new RegExp(`${(0,A.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let w=0;for(const S of n){const l=a.exec(S.name),C=l?parseInt(l[1]):0;w=C>w?C:w}return`${r} #${w+1}`}async readMachinesData(n){this.userData=await this.readUserData(n);const i=this.parse(this.userData);if(i.version!==f.VERSION)throw new Error((0,_.localize)(0,null,this.productService.nameLong));return i}async writeMachinesData(n){const i=JSON.stringify(n),r=await this.userDataSyncStoreService.writeResource(f.RESOURCE,i,this.userData?.ref||null);this.userData={ref:r,content:i},this._onDidChange.fire()}async readUserData(n){if(this.userData){const i=n&&n.latest?n.latest[f.RESOURCE]:void 0;if(this.userData.ref===i)return this.userData;if(i===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(f.RESOURCE,this.userData)}parse(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(i){this.logService.error(i)}return{version:f.VERSION,machines:[]}}};e.UserDataSyncMachinesService=o,e.UserDataSyncMachinesService=o=f=ye([K(0,R.IEnvironmentService),K(1,P.IFileService),K(2,g.IStorageService),K(3,h.IUserDataSyncStoreService),K(4,h.IUserDataSyncLogService),K(5,I.IProductService)],o)}),define(ce[253],le([0,1,5,62,38,8,3,2,6,22,10,171,23,19,21,24,78,81]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const d="sync.disableMachineEventually",v="sync.sessionId",p="sync.storeUrl",L="sync.productQuality";let t=class extends R.Disposable{get syncUrl(){const n=this.storageService.get(p,-1);return n?I.URI.parse(n):void 0}set syncUrl(n){n?this.storageService.store(p,n.toString(),-1,1):this.storageService.remove(p,-1)}get productQuality(){return this.storageService.get(L,-1)}set productQuality(n){n?this.storageService.store(L,n,-1,1):this.storageService.remove(L,-1)}constructor(n,i,r,a,w,S,l,C,U,N){super(),this.userDataSyncStoreManagementService=i,this.userDataSyncStoreService=r,this.userDataSyncEnablementService=a,this.userDataSyncService=w,this.logService=S,this.userDataSyncAccountService=l,this.telemetryService=C,this.userDataSyncMachinesService=U,this.storageService=N,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new k.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=i.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=n.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(i.onDidChangeUserDataSyncStore(()=>{(0,m.isEqual)(this.syncUrl,i.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=i.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(l.onDidChangeAccount(()=>this.updateAutoSync())),this._register(r.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(w.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this._register(_.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:n,message:i}=this.isAutoSyncEnabled();n?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(r=>this.onDidFinishSync(r))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(i&&this.logService.info(i),this.autoSync.clear()):i&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(i))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,O.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(n,i,r){try{this.userDataSyncAccountService.account&&!r&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(v,-1),n?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),i)this.updateEnablement(!1);else throw a}}updateEnablement(n){this.userDataSyncEnablementService.isEnabled()!==n&&(this.userDataSyncEnablementService.setEnablement(n),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(n){if(!n){this.successiveFailures=0;return}const i=E.UserDataSyncError.toUserDataSyncError(n);i instanceof E.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:i.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?P.isWeb&&i.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(i),this.successiveFailures++),this._onError.fire(i)}async disableMachineEventually(){this.storageService.store(d,!0,-1,1),await(0,k.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(d,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(d,-1)}async triggerSync(n,i,r){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(i&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...n),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const a=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:a}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",r)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=t,e.UserDataAutoSyncService=t=ye([K(0,g.IProductService),K(1,E.IUserDataSyncStoreManagementService),K(2,E.IUserDataSyncStoreService),K(3,E.IUserDataSyncEnablementService),K(4,E.IUserDataSyncService),K(5,E.IUserDataSyncLogService),K(6,c.IUserDataSyncAccountService),K(7,f.ITelemetryService),K(8,u.IUserDataSyncMachinesService),K(9,h.IStorageService)],t);class o extends R.Disposable{static{this.INTERVAL_SYNCING="Interval"}constructor(n,i,r,a,w,S,l,C,U){super(),this.lastSyncUrl=n,this.interval=i,this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=a,this.userDataSyncService=w,this.userDataSyncMachinesService=S,this.logService=l,this.telemetryService=C,this.storageService=U,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new _.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new _.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(n,i){const r=(0,k.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(w){if((0,A.isCancellationError)(w))return}return this.doSync(n,i,a)});return this.syncPromise=r,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,m.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const n=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),i=this.userDataSyncStoreManagementService.userDataSyncStore;return!!i&&!!n&&(!(0,m.isEqual)(i.defaultUrl,n.defaultUrl)||!(0,m.isEqual)(i.insidersUrl,n.insidersUrl)||!(0,m.isEqual)(i.stableUrl,n.stableUrl))}async doSync(n,i,r){this.logService.info(`Auto Sync: Triggered by ${n}`),this._onDidStartSync.fire();let a;try{await this.createAndRunSyncTask(i,r)}catch(w){if(this.logService.error(w),a=w,E.UserDataSyncError.toUserDataSyncError(w).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(i,r),a=void 0}catch(S){this.logService.error(S),a=S}}this._onDidFinishSync.fire(a)}async createAndRunSyncTask(n,i){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,n),i.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new E.UserDataAutoSyncError((0,y.localize)(0,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,y.localize)(1,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,y.localize)(2,null),"TurnedOff");const r=this.storageService.get(v,-1);if(r&&this.manifest&&r!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new E.UserDataAutoSyncError((0,y.localize)(3,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,y.localize)(4,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,y.localize)(5,null),"SessionExpired");const a=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(i.isCancellationRequested)return;const w=a.find(l=>l.isCurrent);if(w?.disabled)throw new E.UserDataAutoSyncError((0,y.localize)(6,null),"TurnedOff");const S=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-S}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(l){throw new E.UserDataAutoSyncError((0,T.toErrorMessage)(l),l instanceof E.UserDataSyncError?l.code:"Unknown")}this.manifest&&this.manifest.session!==r&&this.storageService.store(v,this.manifest.session,-1,1),!i.isCancellationRequested&&(w||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(n){return super._register(n)}}}),define(ce[254],le([0,1,10,175,15,13,44,19,27,24,17,39,119,118,117,18,120,115,116,4,121,41]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d,v,p,L){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let o=class{static{t=this}static{this.NOT_EXISTING_RESOURCE="not-existing-resource"}static{this.REMOTE_BACKUP_AUTHORITY="remote-backup"}static{this.LOCAL_BACKUP_AUTHORITY="local-backup"}constructor(n,i,r,a,w,S,l,C,U,N){this.userDataSyncStoreService=n,this.userDataSyncBackupStoreService=i,this.logService=r,this.environmentService=w,this.storageService=S,this.fileService=l,this.userDataProfilesService=C,this.configurationService=U,this.instantiationService=N,this.extUri=a.extUri}async getRemoteSyncedProfiles(){const n=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(n.content){const i=this.parseSyncData(n.content,"profiles");return(0,p.parseUserDataProfilesManifest)(i)}return[]}async getRemoteSyncResourceHandles(n,i){return(await this.userDataSyncStoreService.getAllResourceRefs(n,i?.collection)).map(({created:a,ref:w})=>({created:a,uri:this.toUri({remote:!0,syncResource:n,profile:i?.id??this.userDataProfilesService.defaultProfile.id,collection:i?.collection,ref:w,node:void 0})}))}async getLocalSyncResourceHandles(n,i){return(await this.userDataSyncBackupStoreService.getAllRefs(i,n)).map(({created:a,ref:w})=>({created:a,uri:this.toUri({remote:!1,syncResource:n,profile:i.id,collection:void 0,ref:w,node:void 0})}))}resolveUserDataSyncResource({uri:n}){const i=this.resolveUri(n),r=i?this.userDataProfilesService.profiles.find(a=>a.id===i.profile):void 0;return i&&r?{profile:r,syncResource:i?.syncResource}:void 0}async getAssociatedResources({uri:n}){const i=this.resolveUri(n);if(!i)return[];const r=this.userDataProfilesService.profiles.find(a=>a.id===i.profile);switch(i.syncResource){case"settings":return this.getSettingsAssociatedResources(n,r);case"keybindings":return this.getKeybindingsAssociatedResources(n,r);case"tasks":return this.getTasksAssociatedResources(n,r);case"snippets":return this.getSnippetsAssociatedResources(n,r);case"globalState":return this.getGlobalStateAssociatedResources(n,r);case"extensions":return this.getExtensionsAssociatedResources(n,r);case"profiles":return this.getProfilesAssociatedResources(n,r);case"workspaceState":return[]}}async getMachineId({uri:n}){const i=this.resolveUri(n);if(i){if(i.remote){if(i.ref){const{content:r}=await this.getUserData(i.syncResource,i.ref,i.collection);if(r)return this.parseSyncData(r,i.syncResource)?.machineId}return}return(0,_.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(n){const i=this.resolveUri(n);if(!i||i.node===t.NOT_EXISTING_RESOURCE)return null;if(i.ref){const r=await this.getContentFromStore(i.remote,i.syncResource,i.profile,i.collection,i.ref);return i.node&&r?this.resolveNodeContent(i.syncResource,r,i.node):r}return!i.remote&&!i.node?this.resolveLatestContent(i.syncResource,i.profile):null}async getContentFromStore(n,i,r,a,w){if(n){const{content:l}=await this.getUserData(i,w,a);return l}const S=this.userDataProfilesService.profiles.find(l=>l.id===r);return S?this.userDataSyncBackupStoreService.resolveContent(S,i,w):null}resolveNodeContent(n,i,r){const a=this.parseSyncData(i,n);switch(n){case"settings":return this.resolveSettingsNodeContent(a,r);case"keybindings":return this.resolveKeybindingsNodeContent(a,r);case"tasks":return this.resolveTasksNodeContent(a,r);case"snippets":return this.resolveSnippetsNodeContent(a,r);case"globalState":return this.resolveGlobalStateNodeContent(a,r);case"extensions":return this.resolveExtensionsNodeContent(a,r);case"profiles":return this.resolveProfileNodeContent(a,r);case"workspaceState":return null}}async resolveLatestContent(n,i){const r=this.userDataProfilesService.profiles.find(a=>a.id===i);if(!r)return null;switch(n){case"globalState":return this.resolveLatestGlobalStateContent(r);case"extensions":return this.resolveLatestExtensionsContent(r);case"profiles":return this.resolveLatestProfilesContent(r);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}getSettingsAssociatedResources(n,i){const r=this.extUri.joinPath(n,"settings.json"),a=i?i.settingsResource:this.extUri.joinPath(n,t.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveSettingsNodeContent(n,i){switch(i){case"settings.json":return(0,h.parseSettingsSyncContent)(n.content).settings}return null}getKeybindingsAssociatedResources(n,i){const r=this.extUri.joinPath(n,"keybindings.json"),a=i?i.keybindingsResource:this.extUri.joinPath(n,t.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveKeybindingsNodeContent(n,i){switch(i){case"keybindings.json":return(0,f.getKeybindingsContentFromSyncContent)(n.content,!!this.configurationService.getValue(m.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(n,i){const r=this.extUri.joinPath(n,"tasks.json"),a=i?i.tasksResource:this.extUri.joinPath(n,t.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveTasksNodeContent(n,i){switch(i){case"tasks.json":return(0,c.getTasksContentFromSyncContent)(n.content,this.logService)}return null}async getSnippetsAssociatedResources(n,i){const r=await this.resolveContent(n);if(r){const a=this.parseSyncData(r,"snippets");if(a){const w=(0,g.parseSnippets)(a),S=[];for(const l of Object.keys(w)){const C=this.extUri.joinPath(n,l),U=i?this.extUri.joinPath(i.snippetsHome,l):this.extUri.joinPath(n,t.NOT_EXISTING_RESOURCE);S.push({resource:C,comparableResource:U})}return S}}return[]}resolveSnippetsNodeContent(n,i){return(0,g.parseSnippets)(n)[i]||null}getExtensionsAssociatedResources(n,i){const r=this.extUri.joinPath(n,"extensions.json"),a=i?this.toUri({remote:!1,syncResource:"extensions",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(n,t.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveExtensionsNodeContent(n,i){switch(i){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(n),!0)}return null}async resolveLatestExtensionsContent(n){const{localExtensions:i}=await this.instantiationService.createInstance(u.LocalExtensionsProvider).getLocalExtensions(n);return(0,u.stringify)(i,!0)}getGlobalStateAssociatedResources(n,i){const r=this.extUri.joinPath(n,"globalState.json"),a=i?this.toUri({remote:!1,syncResource:"globalState",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(n,t.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveGlobalStateNodeContent(n,i){switch(i){case"globalState.json":return(0,d.stringify)(JSON.parse(n.content),!0)}return null}async resolveLatestGlobalStateContent(n){const i=await this.instantiationService.createInstance(d.LocalGlobalStateProvider).getLocalGlobalState(n);return(0,d.stringify)(i,!0)}getProfilesAssociatedResources(n,i){const r=this.extUri.joinPath(n,"profiles.json"),a=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:r,comparableResource:a}]}resolveProfileNodeContent(n,i){switch(i){case"profiles.json":return(0,L.toFormattedString)(JSON.parse(n.content),{})}return null}async resolveLatestProfilesContent(n){return(0,p.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(i=>!i.isDefault&&!i.isTransient),!0)}toUri(n){const i=n.remote?t.REMOTE_BACKUP_AUTHORITY:t.LOCAL_BACKUP_AUTHORITY,r=[n.syncResource,n.profile];return n.collection&&r.push(`collection:${n.collection}`),n.ref&&r.push(`ref:${n.ref}`),n.node&&r.push(n.node),this.extUri.joinPath(k.URI.from({scheme:m.USER_DATA_SYNC_SCHEME,authority:i,path:"/"}),...r)}resolveUri(n){if(n.scheme!==m.USER_DATA_SYNC_SCHEME||n.authority!==t.LOCAL_BACKUP_AUTHORITY&&n.authority!==t.REMOTE_BACKUP_AUTHORITY)return;const i=[];for(;n.path!=="/";)i.unshift(this.extUri.basename(n)),n=this.extUri.dirname(n);if(i.length<2)return;const r=n.authority===t.REMOTE_BACKUP_AUTHORITY,a=i.shift(),w=i.shift();let S,l,C;for(;i.length;){const U=i.shift();U.startsWith("collection:")?S=U.substring(11):U.startsWith("ref:")?l=U.substring(4):C=U}return{remote:r,syncResource:a,profile:w,collection:S,ref:l,node:C}}parseSyncData(n,i){try{const r=JSON.parse(n);if((0,y.isSyncData)(r))return r}catch(r){this.logService.error(r)}throw new m.UserDataSyncError((0,O.localize)(0,null),"IncompatibleRemoteContent",i)}async getUserData(n,i,r){const a=await this.userDataSyncStoreService.resolveResourceContent(n,i,r);return{ref:i,content:a}}};e.UserDataSyncResourceProviderService=o,e.UserDataSyncResourceProviderService=o=t=ye([K(0,m.IUserDataSyncStoreService),K(1,m.IUserDataSyncBackupStoreService),K(2,m.IUserDataSyncLogService),K(3,P.IUriIdentityService),K(4,T.IEnvironmentService),K(5,R.IStorageService),K(6,A.IFileService),K(7,I.IUserDataProfilesService),K(8,E.IConfigurationService),K(9,v.IInstantiationService)],o)}),define(ce[255],le([0,1,20,5,25,38,3,2,22,11,32,18,29,4,19,21,17,115,116,117,118,119,120,121,24]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d,v,p,L,t,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let i=class extends R.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(l,C,U,N,F,$,z,J,H){super(),this.userDataSyncStoreService=l,this.userDataSyncStoreManagementService=C,this.instantiationService=U,this.logService=N,this.telemetryService=F,this.storageService=$,this.userDataSyncEnablementService=z,this.userDataProfilesService=J,this.userDataSyncResourceProviderService=H,this._status="uninitialized",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new _.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new _.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new _.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new _.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=C.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(n,-1,void 0),this._register((0,R.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(l,C){this.checkEnablement(),this.logService.info("Sync started.");const U=new Date().getTime(),N=(0,I.generateUuid)();try{const J=(0,s.createSyncHeaders)(N);C&&(J["Cache-Control"]="no-cache"),l=await this.userDataSyncStoreService.manifest(l,J)}catch(J){const H=s.UserDataSyncError.toUserDataSyncError(J);throw w(H,N,this.userDataSyncStoreManagementService,this.telemetryService),H}const F=!1,$=this;let z;return{manifest:l,async run(){if(F)throw new Error("Can run a task only once");z=(0,O.createCancelablePromise)(J=>$.sync(l,!1,N,J)),await z.finally(()=>z=void 0),$.logService.info(`Sync done. Took ${new Date().getTime()-U}ms`),$.updateLastSyncTime()},stop(){return z?.cancel(),$.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new s.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const l=new Date().getTime(),C=(0,I.generateUuid)(),U=(0,s.createSyncHeaders)(C);let N;try{N=await this.userDataSyncStoreService.manifest(null,U)}catch(z){const J=s.UserDataSyncError.toUserDataSyncError(z);throw w(J,C,this.userDataSyncStoreManagementService,this.telemetryService),J}await this.resetLocal();const F=this,$=new T.CancellationTokenSource;return{id:C,async merge(){return F.sync(N,!0,C,$.token)},async apply(){try{try{await F.applyManualSync(N,C,$.token)}catch(z){if(s.UserDataSyncError.toUserDataSyncError(z).code==="MethodNotFound")F.logService.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.logService.info("Applying manual sync again..."),await F.applyManualSync(N,C,$.token);else throw z}}catch(z){throw F.logService.error(z),z}F.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),F.updateLastSyncTime()},async stop(){$.cancel(),await F.stop(),await F.resetLocal()}}}async sync(l,C,U,N){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(F,l,C,U,N));const $=F.enabled.find(z=>z.resource==="profiles");if($){const z=await $.getLastSyncedProfiles()||[];if(N.isCancellationRequested)return;await this.syncRemoteProfiles(z,l,C,U,N)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(l,C,U,N,F){for(const $ of l){if(F.isCancellationRequested)return;const z=this.userDataProfilesService.profiles.find(H=>H.id===$.id);if(!z){this.logService.error(`Profile with id:${$.id} and name: ${$.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",$.name);const J=this.getOrCreateActiveProfileSynchronizer(z,$);this._syncErrors.push(...await this.syncProfile(J,C,U,N,F))}for(const[$,z]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(J=>J.id===z[0].profile.id)||(z[1].dispose(),this.activeProfileSynchronizers.delete($))}async applyManualSync(l,C,U){const N=this.getActiveProfileSynchronizers();for(const H of N){if(U.isCancellationRequested)return;await H.apply(C,U)}const F=N.find(H=>H.profile.isDefault);if(!F)return;const $=F.enabled.find(H=>H.resource==="profiles");if(!$)return;const J=(await $.getRemoteSyncedProfiles(l?.latest??null)||[]).filter(H=>N.every(Q=>Q.profile.id!==H.id));J.length&&await this.syncRemoteProfiles(J,l,!1,C,U)}async syncProfile(l,C,U,N,F){return(await l.sync(C,U,N,F)).map(([z,J])=>({profile:l.profile,syncResource:z,error:J}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(l=>l.stop()))}async resolveContent(l){const C=await this.userDataSyncResourceProviderService.resolveContent(l);if(C)return C;for(const U of this.getActiveProfileSynchronizers())for(const N of U.enabled){const F=await N.resolveContent(l);if(F)return F}return null}async replace(l){this.checkEnablement();const C=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(l);if(!C)return;const U=await this.resolveContent(l.uri);U&&await this.performAction(C.profile,async N=>{if(C.syncResource===N.resource)return await N.replace(U),!0})}async accept(l,C,U,N){this.checkEnablement(),await this.performAction(l.profile,async F=>{if(l.syncResource===F.resource)return await F.accept(C,U),N&&await F.apply((0,m.isBoolean)(N)?!1:N.force,(0,s.createSyncHeaders)((0,I.generateUuid)())),!0})}getRemoteProfiles(){return this.userDataSyncResourceProviderService.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(l,C){return this.userDataSyncResourceProviderService.getRemoteSyncResourceHandles(l,C)}async getLocalSyncResourceHandles(l,C){return this.userDataSyncResourceProviderService.getLocalSyncResourceHandles(l,C??this.userDataProfilesService.defaultProfile)}async getAssociatedResources(l){return this.userDataSyncResourceProviderService.getAssociatedResources(l)}async getMachineId(l){return this.userDataSyncResourceProviderService.getMachineId(l)}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async C=>{if(C.resource!=="globalState"&&await C.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async C=>{if(await C.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(l){this.logService.error(l)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(n,-1);for(const[l]of this.activeProfileSynchronizers.values())try{await l.resetLocal()}catch(C){this.logService.error(C)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const l=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),C=l.map($=>$.collection),U=await this.userDataSyncStoreService.getAllCollections(),N=U.filter($=>!C.includes($));N.length&&(this.logService.info(`Deleting ${N.length} redundant collections on server`),await Promise.allSettled(N.map($=>this.userDataSyncStoreService.deleteCollection($))),this.logService.info("Deleted redundant collections on server"));const F=l.filter($=>U.includes($.collection));if(F.length!==l.length){const $=this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{this.logService.info("Resetting the last synced state of profiles"),await $.resetLocal(),this.logService.info("Did reset the last synced state of profiles"),this.logService.info("Updating remote profiles with invalid collections on server"),await $.updateRemoteProfiles(F,null),this.logService.info("Updated remote profiles on server")}finally{$.dispose()}}}async performAction(l,C){const U=new R.DisposableStore;try{const N=this.activeProfileSynchronizers.get(l.id);if(N){const H=await this.performActionWithProfileSynchronizer(N[0],C,U);return(0,m.isUndefined)(H)?null:H}if(l.isDefault){const H=U.add(this.instantiationService.createInstance(r,l,void 0)),Q=await this.performActionWithProfileSynchronizer(H,C,U);return(0,m.isUndefined)(Q)?null:Q}if(this.userDataProfilesService.isEnabled())return null;const F=U.add(this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,l,void 0)),$=await this.userDataSyncStoreService.manifest(null),J=(await F.getRemoteSyncedProfiles($?.latest??null)||[]).find(H=>H.id===l.id);if(J){const H=U.add(this.instantiationService.createInstance(r,l,J.collection)),Q=await this.performActionWithProfileSynchronizer(H,C,U);return(0,m.isUndefined)(Q)?null:Q}return null}finally{U.dispose()}}async performActionWithProfileSynchronizer(l,C,U){const N=[...l.enabled,...l.disabled.reduce((F,$)=>($!=="workspaceState"&&F.push(U.add(l.createSynchronizer($))),F),[])];for(const F of N){const $=await C(F);if(!(0,m.isUndefined)($))return $}}setStatus(l){const C=this._status;this._status!==l&&(this._status=l,this._onDidChangeStatus.fire(l),C==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const l=this.getActiveProfileSynchronizers().map(C=>C.conflicts).flat();(0,k.equals)(this._conflicts,l,(C,U)=>C.profile.id===U.profile.id&&C.syncResource===U.syncResource&&(0,k.equals)(C.conflicts,U.conflicts,(N,F)=>(0,P.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(n,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(l,C){let U=this.activeProfileSynchronizers.get(l.id);if(U&&U[0].collection!==C?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),U[1].dispose(),U=void 0,this.activeProfileSynchronizers.delete(l.id)),!U){const N=new R.DisposableStore,F=N.add(this.instantiationService.createInstance(r,l,C?.collection));N.add(F.onDidChangeStatus($=>this.setStatus($))),N.add(F.onDidChangeConflicts($=>this.updateConflicts())),N.add(F.onDidChangeLocal($=>this._onDidChangeLocal.fire($))),this.activeProfileSynchronizers.set(l.id,U=[F,N])}return U[0]}getActiveProfileSynchronizers(){const l=[];for(const[C]of this.activeProfileSynchronizers.values())l.push(C);return l}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,l])=>l.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=i,e.UserDataSyncService=i=ye([K(0,s.IUserDataSyncStoreService),K(1,s.IUserDataSyncStoreManagementService),K(2,h.IInstantiationService),K(3,s.IUserDataSyncLogService),K(4,E.ITelemetryService),K(5,f.IStorageService),K(6,s.IUserDataSyncEnablementService),K(7,c.IUserDataProfilesService),K(8,s.IUserDataSyncResourceProviderService)],i);let r=class extends R.Disposable{get enabled(){return this._enabled.sort((l,C)=>l[1]-C[1]).map(([l])=>l)}get disabled(){return s.ALL_SYNC_RESOURCES.filter(l=>!this.userDataSyncEnablementService.isResourceEnabled(l))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(l,C,U,N,F,$,z,J,H,Q){super(),this.profile=l,this.collection=C,this.userDataSyncEnablementService=U,this.instantiationService=N,this.extensionGalleryService=F,this.userDataSyncStoreManagementService=$,this.telemetryService=z,this.logService=J,this.userDataProfilesService=H,this.configurationService=Q,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(U.onDidChangeResourceEnablement(([B,Y])=>this.onDidChangeResourceEnablement(B,Y))),this._register((0,R.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,B])=>B.dispose())));for(const B of s.ALL_SYNC_RESOURCES)U.isResourceEnabled(B)&&this.registerSynchronizer(B)}onDidChangeResourceEnablement(l,C){C?this.registerSynchronizer(l):this.deRegisterSynchronizer(l)}registerSynchronizer(l){if(this._enabled.some(([F])=>F.resource===l))return;if(l==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(l==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||l==="workspaceState")return;if(l!=="profiles"&&this.profile.useDefaultFlags?.[l]){this.logService.debug(`Skipping syncing ${l} in ${this.profile.name} because it is already synced by default profile`);return}const C=new R.DisposableStore,U=C.add(this.createSynchronizer(l));C.add(U.onDidChangeStatus(()=>this.updateStatus())),C.add(U.onDidChangeConflicts(()=>this.updateConflicts())),C.add(U.onDidChangeLocal(()=>this._onDidChangeLocal.fire(l)));const N=this.getOrder(l);this._enabled.push([U,N,C])}deRegisterSynchronizer(l){const C=this._enabled.findIndex(([U])=>U.resource===l);if(C!==-1){const[[U,,N]]=this._enabled.splice(C,1);N.dispose(),this.updateStatus(),Promise.allSettled([U.stop(),U.resetLocal()]).then(null,F=>this.logService.error(F))}}createSynchronizer(l){switch(l){case"settings":return this.instantiationService.createInstance(p.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(v.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(L.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(t.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(d.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(u.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(l,C,U,N){if(N.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const $=[],z=(0,s.createSyncHeaders)(U),J=(this.collection?l?.collections?.[this.collection]?.latest:l?.latest)??null,H=C?await this.getUserDataSyncConfiguration(J):{};for(const Q of F){if(N.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(Q.resource))return[];try{if(C){const B=await Q.preview(J,H,z);if(B)for(const Y of B.resourcePreviews)(Y.localChange!==0||Y.remoteChange!==0)&&Y.mergeState==="preview"&&await Q.merge(Y.previewResource)}else await Q.sync(J,z)}catch(B){const Y=s.UserDataSyncError.toUserDataSyncError(B);if(w(Y,U,this.userDataSyncStoreManagementService,this.telemetryService),a(B))throw Y;this.logService.error(B),this.logService.error(`${Q.resource}: ${(0,A.toErrorMessage)(B)}`),$.push([Q.resource,Y])}}return $}finally{this.updateStatus()}}async apply(l,C){const U=(0,s.createSyncHeaders)(l);for(const N of this.enabled){if(C.isCancellationRequested)return;try{await N.apply(!1,U)}catch(F){const $=s.UserDataSyncError.toUserDataSyncError(F);if(w($,l,this.userDataSyncStoreManagementService,this.telemetryService),a(F))throw $;this.logService.error(F),this.logService.error(`${N.resource}: ${(0,A.toErrorMessage)(F)}`)}}}async stop(){for(const l of this.enabled)try{l.status!=="idle"&&await l.stop()}catch(C){this.logService.error(C)}}async resetLocal(){for(const l of this.enabled)try{await l.resetLocal()}catch(C){this.logService.error(`${l.resource}: ${(0,A.toErrorMessage)(C)}`),this.logService.error(C)}}async getUserDataSyncConfiguration(l){if(!this.profile.isDefault)return{};const C=this.configurationService.getValue(s.USER_DATA_SYNC_CONFIGURATION_SCOPE),U=this.enabled.find(N=>N instanceof p.SettingsSynchroniser);if(U){const N=await U.getRemoteUserDataSyncConfiguration(l);return{...C,...N}}return C}setStatus(l){this._status!==l&&(this._status=l,this._onDidChangeStatus.fire(l))}updateStatus(){return this.updateConflicts(),this.enabled.some(l=>l.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(l=>l.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const l=this.enabled.filter(C=>C.status==="hasConflicts").filter(C=>C.conflicts.conflicts.length>0).map(C=>C.conflicts);(0,k.equals)(this._conflicts,l,(C,U)=>C.syncResource===U.syncResource&&(0,k.equals)(C.conflicts,U.conflicts,(N,F)=>(0,P.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}getOrder(l){switch(l){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};r=ye([K(2,s.IUserDataSyncEnablementService),K(3,h.IInstantiationService),K(4,g.IExtensionGalleryService),K(5,s.IUserDataSyncStoreManagementService),K(6,E.ITelemetryService),K(7,s.IUserDataSyncLogService),K(8,c.IUserDataProfilesService),K(9,y.IConfigurationService)],r);function a(S){if(S instanceof s.UserDataSyncError)switch(S.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function w(S,l,C,U){U.publicLog2("sync/error",{code:S.code,serverCode:S instanceof s.UserDataSyncStoreError?String(S.serverCode):void 0,url:S instanceof s.UserDataSyncStoreError?S.url:void 0,resource:S.resource,executionId:l,service:C.userDataSyncStore.url.toString()})}}),define(ce[256],le([0,1,3,2,10,17,24]),function(ie,e,k,O,T,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(g,h){return{...g,profile:(0,A.reviveProfile)(g.profile,h.profilesHome.scheme)}}function P(g){return{created:g.created,uri:T.URI.revive(g.uri)}}class m{constructor(h,f,E){this.service=h,this.userDataProfilesService=f,this.logService=E,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(h,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(h,f,E){try{return await this._call(h,f,E)}catch(c){throw this.logService.error(c),c}}async _call(h,f,E){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(T.URI.revive(E[0]));case"accept":return this.service.accept(R(E[0],this.userDataProfilesService),T.URI.revive(E[1]),E[2],E[3]);case"getRemoteProfiles":return this.service.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(E[0],E[1]?(0,A.reviveProfile)(E[1],this.userDataProfilesService.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(E[0],E[1]);case"replace":return this.service.replace(P(E[0]));case"getAssociatedResources":return this.service.getAssociatedResources(P(E[0]));case"getMachineId":return this.service.getMachineId(P(E[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const c=f.substring(11),u=E[0],d=this.getManualSyncTask(u);switch(E=E.slice(1),c){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.manualSyncTasks.delete(this.createKey(d.id)));case"stop":return d.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(d.id)))}}throw new Error("Invalid call")}getManualSyncTask(h){const f=this.manualSyncTasks.get(this.createKey(h));if(!f)throw new Error(`Manual sync taks not found: ${h}`);return f}async createManualSyncTask(){const h=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(h.id),h),h.id}createKey(h){return`manualSyncTask-${h}`}}e.UserDataSyncChannel=m;let I=class extends O.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(h,f){super(),this.userDataProfilesService=f,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(E,c,u){return h.call(E,c,u).then(null,d=>{throw _.UserDataSyncError.toUserDataSyncError(d)})},listen(E,c){return h.listen(E,c)}},this.channel.call("_getInitialData").then(([E,c,u])=>{this.updateStatus(E),this.updateConflicts(c),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(d=>this.updateStatus(d))),this._register(this.channel.listen("onDidChangeLastSyncTime")(d=>this.updateLastSyncTime(d)))}),this._register(this.channel.listen("onDidChangeConflicts")(E=>this.updateConflicts(E))),this._register(this.channel.listen("onSyncErrors")(E=>this._onSyncErrors.fire(E.map(c=>({...c,error:_.UserDataSyncError.toUserDataSyncError(c.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.channel.call("createManualSyncTask"),f=this;return new y(h,{async call(c,u,d){return f.channel.call(`manualSync/${c}`,[h,...Array.isArray(u)?u:[u]],d)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(h,f,E,c){return this.channel.call("accept",[h,f,E,c])}resolveContent(h){return this.channel.call("resolveContent",[h])}getRemoteProfiles(){return this.channel.call("getRemoteProfiles")}async getLocalSyncResourceHandles(h,f){return(await this.channel.call("getLocalSyncResourceHandles",[h,f])).map(({created:c,uri:u})=>({created:c,uri:T.URI.revive(u)}))}async getRemoteSyncResourceHandles(h,f){return(await this.channel.call("getRemoteSyncResourceHandles",[h,f])).map(({created:c,uri:u})=>({created:c,uri:T.URI.revive(u)}))}async getAssociatedResources(h){return(await this.channel.call("getAssociatedResources",[h])).map(({resource:E,comparableResource:c})=>({resource:T.URI.revive(E),comparableResource:T.URI.revive(c)}))}getMachineId(h){return this.channel.call("getMachineId",[h])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(h){return this.channel.call("replace",[h])}async updateStatus(h){this._status=h,this._onDidChangeStatus.fire(h)}async updateConflicts(h){this._conflicts=h.map(f=>({syncResource:f.syncResource,profile:(0,A.reviveProfile)(f.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:f.conflicts.map(E=>({...E,baseResource:T.URI.revive(E.baseResource),localResource:T.URI.revive(E.localResource),remoteResource:T.URI.revive(E.remoteResource),previewResource:T.URI.revive(E.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(h){this._lastSyncTime!==h&&(this._lastSyncTime=h,this._onDidChangeLastSyncTime.fire(h))}};e.UserDataSyncChannelClient=I,e.UserDataSyncChannelClient=I=ye([K(1,A.IUserDataProfilesService)],I);class y extends O.Disposable{constructor(h,f){super(),this.id=h,this.channel=f}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(ce[257],le([0,1,5,25,8,3,2,139,6,22,11,10,32,18,15,13,23,57,44,19,24]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const L="configurationSync.store",t="sync.previous.store",o="sync.donot-make-requests-until",s="sync.user-session-id",n="sync.machine-session-id",i=100,r=1e3*60*5;let a=class extends _.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(p.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(N){this.storageService.store(p.SYNC_SERVICE_URL_TYPE,N,-1,P.isWeb?0:1)}constructor(N,F,$){super(),this.productService=N,this.configurationService=F,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new A.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore();const z=this._register(new _.DisposableStore);this._register(A.Event.filter($.onDidChangeValue(-1,p.SYNC_SERVICE_URL_TYPE,z),()=>this.userDataSyncStoreType!==this.userDataSyncStore?.type,z)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[L]),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(N){if(N&&(N=P.isWeb&&N.web?{...N,...N.web}:N,(0,I.isString)(N.url)&&(0,I.isObject)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(F=>Array.isArray(N.authenticationProviders[F].scopes)))){const F=N,$=!!F.canSwitch,z=F.url===F.insidersUrl?"insiders":"stable",J=($?this.userDataSyncStoreType:void 0)||z,H=J==="insiders"?F.insidersUrl:J==="stable"?F.stableUrl:F.url;return{url:y.URI.parse(H),type:J,defaultType:z,defaultUrl:y.URI.parse(F.url),stableUrl:y.URI.parse(F.stableUrl),insidersUrl:y.URI.parse(F.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(F.authenticationProviders).reduce((Q,B)=>(Q.push({id:B,scopes:F.authenticationProviders[B].scopes}),Q),[])}}}};e.AbstractUserDataSyncStoreManagementService=a,e.AbstractUserDataSyncStoreManagementService=a=ye([K(0,c.IProductService),K(1,h.IConfigurationService),K(2,v.IStorageService)],a);let w=class extends a{constructor(N,F,$){super(N,F,$);const z=this.storageService.get(t,-1);z&&(this.previousConfigurationSyncStore=JSON.parse(z));const J=this.productService[L];J?this.storageService.store(t,JSON.stringify(J),-1,1):this.storageService.remove(t,-1)}async switch(N){N!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=N,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=w,e.UserDataSyncStoreManagementService=w=ye([K(0,c.IProductService),K(1,h.IConfigurationService),K(2,v.IStorageService)],w);let S=class extends _.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(N,F,$,z,J,H,Q){super(),this.requestService=$,this.logService=z,this.storageService=Q,this._onTokenFailed=this._register(new A.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new A.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(N),this.commonHeadersPromise=(0,d.getServiceMachineId)(J,H,Q).then(B=>{const Y={"X-Client-Name":`${F.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(Y["X-Client-Commit"]=F.commit),Y}),this.session=new C(i,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,_.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(N,F){this.authToken={token:N,type:F}}updateUserDataSyncStoreUrl(N){this.userDataSyncStoreUrl=N?(0,m.joinPath)(N,"v1"):void 0}initDonotMakeRequestsUntil(){const N=this.storageService.getNumber(o,-1);N&&Date.now()<N&&this.setDonotMakeRequestsUntil(new Date(N))}setDonotMakeRequestsUntil(N){this._donotMakeRequestsUntil?.getTime()!==N?.getTime()&&(this._donotMakeRequestsUntil=N,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(o,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(F=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(o,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,m.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},N["Content-Type"]="application/json";const $=await this.request(F,{type:"GET",headers:N},[],O.CancellationToken.None);return(await(0,u.asJson)($))?.map(({id:z})=>z)||[]}async createCollection(N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,m.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},N["Content-Type"]=R.Mimes.text;const $=await this.request(F,{type:"POST",headers:N},[],O.CancellationToken.None),z=await(0,u.asTextOrError)($);if(!z)throw new p.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",$.res.statusCode,$.res.headers[p.HEADER_OPERATION_ID]);return z}async deleteCollection(N,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=N?(0,m.joinPath)(this.userDataSyncStoreUrl,"collection",N).toString():(0,m.joinPath)(this.userDataSyncStoreUrl,"collection").toString();F={...F},await this.request($,{type:"DELETE",headers:F},[],O.CancellationToken.None)}async getAllResourceRefs(N,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=this.getResourceUrl(this.userDataSyncStoreUrl,F,N),z={},J=await this.request($.toString(),{type:"GET",headers:z},[],O.CancellationToken.None);return(await(0,u.asJson)(J)||[]).map(({url:Q,created:B})=>({ref:(0,m.relativePath)($,$.with({path:Q})),created:B*1e3}))}async resolveResourceContent(N,F,$,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const J=(0,m.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,$,N),F).toString();z={...z},z["Cache-Control"]="no-cache";const H=await this.request(J,{type:"GET",headers:z},[],O.CancellationToken.None);return await(0,u.asTextOrError)(H)}async deleteResource(N,F,$){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=F!==null?(0,m.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,$,N),F).toString():this.getResourceUrl(this.userDataSyncStoreUrl,$,N).toString(),J={};await this.request(z,{type:"DELETE",headers:J},[],O.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,m.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":R.Mimes.text};await this.request(N,{type:"DELETE",headers:F},[],O.CancellationToken.None)}async readResource(N,F,$,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const J=(0,m.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,$,N),"latest").toString();z={...z},z["Cache-Control"]="no-cache",F&&(z["If-None-Match"]=F.ref);const H=await this.request(J,{type:"GET",headers:z},[304],O.CancellationToken.None);let Q=null;if(H.res.statusCode===304&&(Q=F),Q===null){const B=H.res.headers.etag;if(!B)throw new p.UserDataSyncStoreError("Server did not return the ref",J,"NoRef",H.res.statusCode,H.res.headers[p.HEADER_OPERATION_ID]);const Y=await(0,u.asTextOrError)(H);if(!Y&&H.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",J,"EmptyResponse",H.res.statusCode,H.res.headers[p.HEADER_OPERATION_ID]);Q={ref:B,content:Y}}return Q}async writeResource(N,F,$,z,J={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=this.getResourceUrl(this.userDataSyncStoreUrl,z,N).toString();J={...J},J["Content-Type"]=R.Mimes.text,$&&(J["If-Match"]=$);const Q=await this.request(H,{type:"POST",data:F,headers:J},[],O.CancellationToken.None),B=Q.res.headers.etag;if(!B)throw new p.UserDataSyncStoreError("Server did not return the ref",H,"NoRef",Q.res.statusCode,Q.res.headers[p.HEADER_OPERATION_ID]);return B}async manifest(N,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,m.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",N&&(F["If-None-Match"]=N.ref);const z=await this.request($,{type:"GET",headers:F},[304],O.CancellationToken.None);let J=null;if(z.res.statusCode===304&&(J=N),!J){const Q=z.res.headers.etag;if(!Q)throw new p.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",z.res.statusCode,z.res.headers[p.HEADER_OPERATION_ID]);const B=await(0,u.asTextOrError)(z);if(!B&&z.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",$,"EmptyResponse",z.res.statusCode,z.res.headers[p.HEADER_OPERATION_ID]);B&&(J={...JSON.parse(B),ref:Q})}const H=this.storageService.get(s,-1);return H&&J&&H!==J.session&&this.clearSession(),J===null&&H&&this.clearSession(),J&&this.storageService.store(s,J.session,-1,1),J}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}getResourceUrl(N,F,$){return F?(0,m.joinPath)(N,"collection",F,"resource",$):(0,m.joinPath)(N,"resource",$)}clearSession(){this.storageService.remove(s,-1),this.storageService.remove(n,-1)}async request(N,F,$,z){if(!this.authToken)throw new p.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new p.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const J=await this.commonHeadersPromise;F.headers={...F.headers||{},...J,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:N,type:F.type,headers:{...F.headers,authorization:void 0}});let H;try{H=await this.session.request(N,F,z)}catch(j){if(!(j instanceof p.UserDataSyncStoreError)){let q="RequestFailed";const Z=(0,T.getErrorMessage)(j).toLowerCase();Z.includes("xhr timeout")?q="RequestTimeout":Z.includes("protocol")&&Z.includes("not supported")?q="RequestProtocolNotSupported":Z.includes("request path contains unescaped characters")?q="RequestPathNotEscaped":Z.includes("headers must be an object")?q="RequestHeadersNotObject":(0,T.isCancellationError)(j)&&(q="RequestCanceled"),j=new p.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,q,void 0,void 0)}throw this.logService.info("Request failed",N),j}const Q=H.res.headers[p.HEADER_OPERATION_ID],B={url:N,status:H.res.statusCode,"execution-id":F.headers[p.HEADER_EXECUTION_ID],"operation-id":Q},Y=(0,u.isSuccess)(H)||H.res.statusCode&&$.includes(H.res.statusCode);let x="";if(Y?this.logService.trace("Request succeeded",B):(x=await(0,u.asText)(H)||"",this.logService.info("Request failed",B,x)),H.res.statusCode===401||H.res.statusCode===403){if(this.authToken=void 0,H.res.statusCode===401)throw this._onTokenFailed.fire("Unauthorized"),new p.UserDataSyncStoreError(`${F.type} request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",H.res.statusCode,Q);if(H.res.statusCode===403)throw this._onTokenFailed.fire("Forbidden"),new p.UserDataSyncStoreError(`${F.type} request '${N}' failed because the access is forbidden (403).`,N,"Forbidden",H.res.statusCode,Q)}if(this._onTokenSucceed.fire(),H.res.statusCode===404)throw new p.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",H.res.statusCode,Q);if(H.res.statusCode===405)throw new p.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested endpoint is not found (405). ${x}`,N,"MethodNotFound",H.res.statusCode,Q);if(H.res.statusCode===409)throw new p.UserDataSyncStoreError(`${F.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",H.res.statusCode,Q);if(H.res.statusCode===410)throw new p.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",H.res.statusCode,Q);if(H.res.statusCode===412)throw new p.UserDataSyncStoreError(`${F.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",H.res.statusCode,Q);if(H.res.statusCode===413)throw new p.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",H.res.statusCode,Q);if(H.res.statusCode===426)throw new p.UserDataSyncStoreError(`${F.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",H.res.statusCode,Q);if(H.res.statusCode===429){const j=H.res.headers["retry-after"];throw j?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(j)*1e3)),new p.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",H.res.statusCode,Q)):new p.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",H.res.statusCode,Q)}if(!Y)throw new p.UserDataSyncStoreError("Server returned "+H.res.statusCode,N,"Unknown",H.res.statusCode,Q);return H}addSessionHeaders(N){let F=this.storageService.get(n,-1);F===void 0&&(F=(0,g.generateUuid)(),this.storageService.store(n,F,-1,1)),N["X-Machine-Session-Id"]=F;const $=this.storageService.get(s,-1);$!==void 0&&(N["X-User-Session-Id"]=$)}};e.UserDataSyncStoreClient=S,e.UserDataSyncStoreClient=S=ye([K(1,c.IProductService),K(2,u.IRequestService),K(3,p.IUserDataSyncLogService),K(4,f.IEnvironmentService),K(5,E.IFileService),K(6,v.IStorageService)],S);let l=class extends S{constructor(N,F,$,z,J,H,Q){super(N.userDataSyncStore?.url,F,$,z,J,H,Q),this._register(N.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(N.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=l,e.UserDataSyncStoreService=l=ye([K(0,p.IUserDataSyncStoreManagementService),K(1,c.IProductService),K(2,u.IRequestService),K(3,p.IUserDataSyncLogService),K(4,f.IEnvironmentService),K(5,E.IFileService),K(6,v.IStorageService)],l);class C{constructor(N,F,$,z){this.limit=N,this.interval=F,this.requestService=$,this.logService=z,this.requests=[],this.startTime=void 0}request(N,F,$){if(this.isExpired()&&this.reset(),F.url=N,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new p.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(N),this.requestService.request(F,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=C}),define(ce[258],le([0,1,3,55,23,19,21,253,24,78,81]),function(ie,e,k,O,T,A,_,R,P,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let y=class extends R.UserDataAutoSyncService{constructor(h,f,E,c,u,d,v,p,L,t,o){super(h,f,E,c,u,v,p,L,t,o),this._register(k.Event.debounce(k.Event.any(k.Event.map(d.onDidFocusWindow,()=>"windowFocus"),k.Event.map(d.onDidOpenWindow,()=>"windowOpen")),(s,n)=>s?[...s,n]:[n],1e3)(s=>this.triggerSync(s,!0,!1)))}};e.UserDataAutoSyncService=y,e.UserDataAutoSyncService=y=ye([K(0,T.IProductService),K(1,P.IUserDataSyncStoreManagementService),K(2,P.IUserDataSyncStoreService),K(3,P.IUserDataSyncEnablementService),K(4,P.IUserDataSyncService),K(5,O.INativeHostService),K(6,P.IUserDataSyncLogService),K(7,m.IUserDataSyncAccountService),K(8,_.ITelemetryService),K(9,I.IUserDataSyncMachinesService),K(10,A.IStorageService)],y)}),define(ce[259],le([0,1,69,26,6,22]),function(ie,e,k,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function _(m){function I(){let y=m.scheme===O.Schemas.file?(0,A.originalFSPath)(m):m.toString();return T.isLinux||(y=y.toLowerCase()),(0,k.createHash)("md5").update(y).digest("hex")}return{id:I(),configPath:m}}e.getWorkspaceIdentifier=_;function R(m,I){function y(){if(m.scheme!==O.Schemas.file)return(0,k.createHash)("md5").update(m.toString()).digest("hex");if(!I)return;let h;return T.isLinux?h=I.ino:T.isMacintosh?h=I.birthtime.getTime():T.isWindows&&(typeof I.birthtimeMs=="number"?h=Math.floor(I.birthtimeMs):h=I.birthtime.getTime()),(0,k.createHash)("md5").update(m.fsPath).update(h?String(h):"").digest("hex")}const g=y();if(typeof g=="string")return{id:g,uri:m}}e.getSingleFolderWorkspaceIdentifier=R;function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=P}),define(ce[260],le([0,1,5,8,2,16,31,15,7,75,113,259,55,71]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let f=class extends T.Disposable{constructor(c,u,d,v){super(),this.environmentService=c,this.logService=u,this.nativeHostService=d,this.mainProcessService=v,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=await _.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),u=new m.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(c.map(async d=>{const v=(0,A.join)(this.environmentService.workspaceStorageHome.fsPath,d);d.length===y.NON_EMPTY_WORKSPACE_ID_LENGTH||d===I.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(t=>t.workspace?.id===d)||await u.isUsed(v)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await _.Promises.rm(v))}))}catch(c){(0,O.onUnexpectedError)(c)}}};e.UnusedWorkspaceStorageDataCleaner=f,e.UnusedWorkspaceStorageDataCleaner=f=ye([K(0,R.INativeEnvironmentService),K(1,P.ILogService),K(2,g.INativeHostService),K(3,h.IMainProcessService)],f)}),define(ce[82],le([0,1,52,5,16,11,31,146,271,272]),function(ie,e,k,O,T,A,_,R,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const I=new RegExp(e.CorruptZipMessage);class y extends Error{constructor(o,s){let n=s.message;switch(o){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=o,this.cause=s}}e.ExtractError=y;function g(t){const o=t.externalFileAttributes>>16||33188;return[448,56,7].map(s=>o&s).reduce((s,n)=>s+n,o&61440)}function h(t){if(t instanceof y)return t;let o;return I.test(t.message)&&(o="CorruptZip"),new y(o,t)}function f(t,o,s,n,i,r){const a=T.dirname(o),w=T.join(n,a);if(!w.startsWith(n))return Promise.reject(new Error(R.localize(0,null,o)));const S=T.join(n,o);let l;return r.onCancellationRequested(()=>{l?.destroy()}),Promise.resolve(_.Promises.mkdir(w,{recursive:!0})).then(()=>new Promise((C,U)=>{if(!r.isCancellationRequested)try{l=(0,k.createWriteStream)(S,{mode:s}),l.once("close",()=>C()),l.once("error",U),t.once("error",U),t.pipe(l)}catch(N){U(N)}}))}function E(t,o,s,n){let i=(0,O.createCancelablePromise)(()=>Promise.resolve()),r=0;return n.onCancellationRequested(()=>{i.cancel(),t.close()}),new Promise((a,w)=>{const S=new O.Sequencer,l=C=>{C.isCancellationRequested||(r++,t.readEntry())};t.once("error",w),t.once("close",()=>i.then(()=>{n.isCancellationRequested||t.entryCount===r?a():w(new y("Incomplete",new Error(R.localize(1,null,r,t.entryCount))))},w)),t.readEntry(),t.on("entry",C=>{if(n.isCancellationRequested)return;if(!s.sourcePathRegex.test(C.fileName)){l(n);return}const U=C.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(U)){const $=T.join(o,U);i=(0,O.createCancelablePromise)(z=>_.Promises.mkdir($,{recursive:!0}).then(()=>l(z)).then(void 0,w));return}const N=u(t,C),F=g(C);i=(0,O.createCancelablePromise)($=>S.queue(()=>N.then(z=>f(z,U,F,o,s,$).then(()=>l($)))).then(null,w))})})}function c(t,o=!1){return new Promise((s,n)=>{(0,P.open)(t,o?{lazyEntries:!0}:void 0,(i,r)=>{i?n(h(i)):s((0,A.assertIsDefined)(r))})})}function u(t,o){return new Promise((s,n)=>{t.openReadStream(o,(i,r)=>{i?n(h(i)):s((0,A.assertIsDefined)(r))})})}function d(t,o){return new Promise((s,n)=>{const i=new m.ZipFile;o.forEach(a=>{a.contents?i.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&i.addFile(a.localPath,a.path)}),i.end();const r=(0,k.createWriteStream)(t);i.outputStream.pipe(r),i.outputStream.once("error",n),r.once("error",n),r.once("finish",()=>s(t))})}e.zip=d;function v(t,o,s={},n){const i=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=c(t,!0);return s.overwrite&&(r=r.then(a=>_.Promises.rm(o).then(()=>a))),r.then(a=>E(a,o,{sourcePathRegex:i},n))}e.extract=v;function p(t,o){return c(t).then(s=>new Promise((n,i)=>{s.on("entry",r=>{r.fileName===o&&u(s,r).then(a=>n(a),a=>i(a))}),s.once("close",()=>i(new Error(R.localize(2,null,o))))}))}function L(t,o){return p(t,o).then(s=>new Promise((n,i)=>{const r=[];s.once("error",i),s.on("data",a=>r.push(a)),s.on("end",()=>n(Buffer.concat(r)))}))}e.buffer=L}),define(ce[261],le([0,1,5,8,2,26,22,53,11,32,31,82,18,15,29,33,97,13,7]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=class extends T.Disposable{static{v=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(t,o,s,n,i,r){super(),this.fileService=o,this.extensionGalleryService=s,this.configurationService=n,this.extensionSignatureVerificationService=i,this.logService=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(t,o,s){await this.cleanUpPromise;const n=(0,_.joinPath)(this.extensionsDownloadDir,this.getName(t));try{await this.downloadFile(t,n,r=>this.extensionGalleryService.download(t,r,o))}catch(r){throw new f.ExtensionManagementError(r.message,f.ExtensionManagementErrorCode.Download)}let i=!1;if(s&&this.shouldVerifySignature(t)){const r=await this.downloadSignatureArchive(t);try{i=await this.extensionSignatureVerificationService.verify(n.fsPath,r.fsPath,this.logService.getLevel()===d.LogLevel.Trace)}catch(a){const w=a;if(i=w.code,w.output&&this.logService.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${w.output}`),i===f.ExtensionSignaturetErrorCode.PackageIsInvalidZip||i===f.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new f.ExtensionManagementError(y.CorruptZipMessage,f.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(a){this.logService.error(a)}}}return i===!0?this.logService.info(`Extension signature is verified: ${t.identifier.id}`):i===!1?this.logService.info(`Extension signature verification is not done: ${t.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${i}': ${t.identifier.id}`),{location:n,verificationStatus:i}}shouldVerifySignature(t){if(!t.isSigned)return!1;const o=this.configurationService.getValue("extensions.verifySignature");return(0,P.isBoolean)(o)?o:!0}async downloadSignatureArchive(t){await this.cleanUpPromise;const o=(0,_.joinPath)(this.extensionsDownloadDir,`${this.getName(t)}${v.SignatureArchiveExtension}`);return await this.downloadFile(t,o,s=>this.extensionGalleryService.downloadSignatureArchive(t,s)),o}async downloadFile(t,o,s){if(await this.fileService.exists(o))return;if(o.scheme!==A.Schemas.file){await s(o);return}const n=(0,_.joinPath)(this.extensionsDownloadDir,`.${(0,m.generateUuid)()}`);await this.fileService.exists(n)||await s(n);try{await I.Promises.rename(n.fsPath,o.fsPath,2*60*1e3)}catch(i){try{await this.fileService.del(n)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,o.path);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(i)}. Deleted the file from downloaded location`,n.path),i}}async delete(t){await this.cleanUpPromise,await this.fileService.del(t)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const o=[],s=[],n=[];for(const a of t.children)if(a.name.endsWith(v.SignatureArchiveExtension))n.push(a.resource);else{const w=E.ExtensionKey.parse(a.name);w&&s.push([w,a])}const i=(0,E.groupByExtension)(s,([a])=>a),r=[];for(const a of i)a.sort((w,S)=>R.rcompare(w[0].version,S[0].version)),o.push(...a.slice(1).map(w=>w[1].resource)),r.push(a[0][1]);r.sort((a,w)=>a.mtime-w.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(a=>a.resource)),o.push(...n),await k.Promises.settled(o.map(a=>(this.logService.trace("Deleting from cache",a.path),this.fileService.del(a))))}}catch(t){this.logService.error(t)}}getName(t){return this.cache?E.ExtensionKey.create(t).toString().toLowerCase():(0,m.generateUuid)()}};e.ExtensionsDownloader=p,e.ExtensionsDownloader=p=v=ye([K(0,h.INativeEnvironmentService),K(1,u.IFileService),K(2,f.IExtensionGalleryService),K(3,g.IConfigurationService),K(4,c.IExtensionSignatureVerificationService),K(5,d.ILogService)],p)}),define(ce[262],le([0,1,82,155]),function(ie,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function T(A){return(0,k.buffer)(A,"extension/package.json").then(_=>{try{return JSON.parse(_.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=T}),define(ce[122],le([0,1,5,14,25,38,8,3,51,2,35,26,16,22,53,11,10,32,31,82,154,96,15,241,29,33,50,79,261,242,262,210,221,67,13,4,7,23,21,27,17]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d,v,p,L,t,o,s,n,i,r,a,w,S,l,C,U,N,F,$,z,J,H,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,F.refineServiceDecorator)(s.IExtensionManagementService);const B=".vsctmp";let Y=class extends o.AbstractExtensionManagementService{constructor(G,W,b,D,M,V,ee,ne,de,X,se,te){super(G,W,se,b,X,te),this.extensionsScannerService=M,this.extensionsProfileScannerService=V,this.downloadService=ee,this.fileService=de,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new I.ResourceSet;const he=this._register(ne.createInstance(w.ExtensionsLifecycle));this.extensionsScanner=this._register(ne.createInstance(x,pe=>he.postUninstall(pe))),this.manifestCache=this._register(new l.ExtensionsManifestCache(te,de,se,this,this.logService)),this.extensionsDownloader=this._register(ne.createInstance(a.ExtensionsDownloader));const fe=this._register(new C.ExtensionsWatcher(this,this.extensionsScannerService,te,V,se,de,b));this._register(fe.onDidChangeExtensionsByAnotherSource(pe=>this.onDidChangeExtensionsFromAnotherSource(pe))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,n.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(G){this.logService.trace("ExtensionManagementService#zip",G.identifier.id);const W=await this.collectFiles(G),b=await(0,v.zip)((0,h.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,W);return c.URI.file(b)}async unzip(G){return this.logService.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const{location:W,cleanup:b}=await this.downloadVsix(G),D=g.resolve(W.fsPath);try{return await(0,S.getManifest)(D)}finally{await b()}}getInstalled(G,W=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(G??null,W)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(G){return this.extensionsScanner.scanUserExtensionAtLocation(G)}async install(G,W={}){this.logService.trace("ExtensionManagementService#install",G.toString());const{location:b,cleanup:D}=await this.downloadVsix(G);try{const M=await(0,S.getManifest)(g.resolve(b.fsPath)),V=(0,n.getGalleryExtensionId)(M.publisher,M.name);if(M.engines&&M.engines.vscode&&!(0,U.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(p.localize(0,null,V,this.productService.version));const ne=(await this.installExtensions([{manifest:M,extension:b,options:W}])).find(({identifier:de})=>(0,n.areSameExtensions)(de,{id:V}));if(ne?.local)return ne.local;throw ne?.error?ne.error:(0,o.toExtensionManagementError)(new Error(`Unknown error while installing extension ${V}`))}finally{await D()}}async installFromLocation(G,W){this.logService.trace("ExtensionManagementService#installFromLocation",G.toString());const b=await this.extensionsScanner.scanUserExtensionAtLocation(G);if(!b)throw new Error(`Cannot find a valid extension from the location ${G.toString()}`);return await this.addExtensionsToProfile([[b,void 0]],W),this.logService.info("Successfully installed extension",b.identifier.id,W.toString()),b}async installExtensionsFromProfile(G,W,b){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",G,W.toString(),b.toString());const D=(await this.extensionsScanner.scanExtensions(1,W)).filter(M=>G.some(V=>(0,n.areSameExtensions)(V,M.identifier)));if(D.length){const M=await Promise.all(D.map(V=>this.extensionsScanner.scanMetadata(V,W)));await this.addExtensionsToProfile(D.map((V,ee)=>[V,M[ee]]),b),this.logService.info("Successfully installed extensions",D.map(V=>V.identifier.id),b.toString())}return D}async updateMetadata(G,W,b=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",G.identifier.id),W.isPreReleaseVersion&&(W.preRelease=!0),W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.pinned=W.pinned||void 0,G=await this.extensionsScanner.updateMetadata(G,W,b),this.manifestCache.invalidate(b),this._onDidUpdateExtensionMetadata.fire(G),G}async reinstallFromGallery(G){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",G.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(1,null));const W=await this.getTargetPlatform(),[b]=await this.galleryService.getExtensions([{...G.identifier,preRelease:G.preRelease}],{targetPlatform:W,compatible:!0},T.CancellationToken.None);if(!b)throw new Error(p.localize(2,null));await this.extensionsScanner.setUninstalled(G);try{await this.extensionsScanner.removeUninstalledExtension(G)}catch(D){throw new Error(p.localize(3,null,(0,A.toErrorMessage)(D)))}return this.installFromGallery(b)}copyExtension(G,W,b,D){return this.extensionsScanner.copyExtension(G,W,b,D)}copyExtensions(G,W){return this.extensionsScanner.copyExtensions(G,W)}markAsUninstalled(...G){return this.extensionsScanner.setUninstalled(...G)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(G){this.logService.error(G)}}async download(G,W,b){const{location:D}=await this.extensionsDownloader.download(G,W,!b);return D}async downloadVsix(G){if(G.scheme===y.Schemas.file)return{location:G,async cleanup(){}};this.logService.trace("Downloading extension from",G.toString());const W=(0,h.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,u.generateUuid)());return await this.downloadService.download(G,W),this.logService.info("Downloaded extension to",W.toString()),{location:W,cleanup:async()=>{try{await this.fileService.del(W)}catch(D){this.logService.error(D)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(G,W,b){if(c.URI.isUri(W))return new Z(G,W,b,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const D=n.ExtensionKey.create(W).toString();let M=this.installGalleryExtensionsTasks.get(D);return M||(this.installGalleryExtensionsTasks.set(D,M=new q(G,W,b,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),M.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(D))),M}createUninstallExtensionTask(G,W){return new oe(G,W.profileLocation,this.extensionsProfileScannerService)}async collectFiles(G){const W=async D=>{let M=await d.Promises.readdir(D);M=M.map(ne=>g.join(D,ne));const V=await Promise.all(M.map(ne=>d.Promises.stat(ne)));let ee=Promise.resolve([]);return V.forEach((ne,de)=>{const X=M[de];ne.isFile()&&(ee=ee.then(se=>[...se,X])),ne.isDirectory()&&(ee=ee.then(se=>W(X).then(te=>[...se,...te])))}),ee};return(await W(G.location.fsPath)).map(D=>({path:`extension/${g.relative(G.location.fsPath,D)}`,localPath:D}))}async onDidChangeExtensionsFromAnotherSource({added:G,removed:W}){if(W)for(const b of W.extensions)this.logService.info("Extensions removed from another source",b.id,W.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:b,profileLocation:W.profileLocation});if(G){const D=(await this.extensionsScanner.scanExtensions(1,G.profileLocation)).filter(M=>G.extensions.some(V=>(0,n.areSameExtensions)(V,M.identifier)));this._onDidInstallExtensions.fire(D.map(M=>(this.logService.info("Extensions added from another source",M.identifier.id,G.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:G.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(W=>this.knownDirectories.add(W)));const G=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const W of G.children??[])W.isDirectory&&this.knownDirectories.add(W.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(W=>this.onDidFilesChange(W)))}async onDidFilesChange(G){if(!G.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const W=[];for(const b of G.rawAdded){if(this.knownDirectories.has(b)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(b),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(b,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(b).startsWith(".")||!(await this.fileService.stat(b)).isDirectory)continue;const D=await this.extensionsScanner.scanUserExtensionAtLocation(b);D&&D.installedTimestamp===void 0&&(this.knownDirectories.add(b),W.push(D))}W.length&&(await this.addExtensionsToProfile(W.map(b=>[b,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",W.map(b=>b.identifier.id)))}async addExtensionsToProfile(G,W){const b=G.map(D=>D[0]);await this.setInstalled(b),await this.extensionsProfileScannerService.addExtensionsToProfile(G,W),this._onDidInstallExtensions.fire(b.map(D=>({local:D,identifier:D.identifier,operation:1,profileLocation:W})))}async setInstalled(G){const W=await this.extensionsScanner.getUninstalledExtensions();for(const b of G){const D=n.ExtensionKey.create(b);W[D.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",D.id),await this.extensionsScanner.setInstalled(D),this.logService.info("Removed the extension from uninstalled list:",D.id))}}};e.ExtensionManagementService=Y,e.ExtensionManagementService=Y=ye([K(0,s.IExtensionGalleryService),K(1,J.ITelemetryService),K(2,$.ILogService),K(3,t.INativeEnvironmentService),K(4,r.IExtensionsScannerService),K(5,i.IExtensionsProfileScannerService),K(6,L.IDownloadService),K(7,F.IInstantiationService),K(8,N.IFileService),K(9,z.IProductService),K(10,H.IUriIdentityService),K(11,Q.IUserDataProfilesService)],Y);let x=class extends m.Disposable{constructor(G,W,b,D,M,V){super(),this.beforeRemovingExtension=G,this.fileService=W,this.extensionsScannerService=b,this.extensionsProfileScannerService=D,this.uriIdentityService=M,this.logService=V,this._onExtract=this._register(new R.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,h.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new k.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(G,W){const b={includeInvalid:!0,profileLocation:W};let D=[];return G===null||G===0?D.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},b,!1)):G===1&&D.push(...await this.extensionsScannerService.scanUserExtensions(b)),D=G!==null?D.filter(M=>M.type===G):D,Promise.all(D.map(M=>this.toLocalExtension(M)))}async scanAllUserExtensions(G){const W=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!G,includeInvalid:!0});return Promise.all(W.map(b=>this.toLocalExtension(b)))}async scanUserExtensionAtLocation(G){try{const W=await this.extensionsScannerService.scanExistingExtension(G,1,{includeInvalid:!0});if(W)return await this.toLocalExtension(W)}catch(W){this.logService.error(W)}return null}async extractUserExtension(G,W,b,D,M){const V=G.toString(),ee=c.URI.file(g.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`)),ne=c.URI.file(g.join(this.extensionsScannerService.userExtensionsLocation.fsPath,V));let de=await this.fileService.exists(ne);if(de&&D){try{await this.deleteExtensionFromLocation(G.id,ne,"removeExisting")}catch{throw new s.ExtensionManagementError(p.localize(4,null,ne.fsPath,G.id),s.ExtensionManagementErrorCode.Delete)}de=!1}if(!de)try{try{this.logService.trace(`Started extracting the extension from ${W} to ${ne.fsPath}`),await(0,v.extract)(W,ee.fsPath,{sourcePath:"extension",overwrite:!0},M),this.logService.info(`Extracted extension to ${ne}:`,G.id)}catch(X){let se=s.ExtensionManagementErrorCode.Extract;throw X instanceof v.ExtractError&&(X.type==="CorruptZip"?se=s.ExtensionManagementErrorCode.CorruptZip:X.type==="Incomplete"&&(se=s.ExtensionManagementErrorCode.IncompleteZip)),new s.ExtensionManagementError(X.message,se)}await this.extensionsScannerService.updateMetadata(ee,b);try{this.logService.trace(`Started renaming the extension from ${ee.fsPath} to ${ne.fsPath}`),await this.rename(ee.fsPath,ne.fsPath),this.logService.info("Renamed to",ne.fsPath)}catch(X){if(X.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",G.id);else throw this.logService.info(`Rename failed because of ${(0,_.getErrorMessage)(X)}. Deleted from extracted location`,ee),X}this._onExtract.fire(ne)}catch(X){try{await this.fileService.del(ee,{recursive:!0})}catch{}throw X}return this.scanLocalExtension(ne,1)}async scanMetadata(G,W){return W?(await this.getScannedExtension(G,W))?.metadata:this.extensionsScannerService.scanMetadata(G.location)}async getScannedExtension(G,W){return(await this.extensionsProfileScannerService.scanProfileExtensions(W)).find(D=>(0,n.areSameExtensions)(D.identifier,G.identifier))}async updateMetadata(G,W,b){return b?await this.extensionsProfileScannerService.updateMetadata([[G,W]],b):await this.extensionsScannerService.updateMetadata(G.location,W),this.scanLocalExtension(G.location,G.type,b)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...G){const W=G.map(b=>n.ExtensionKey.create(b));await this.withUninstalledExtensions(b=>W.forEach(D=>{b[D.toString()]=!0,this.logService.info("Marked extension as uninstalled",D.toString())}))}async setInstalled(G){await this.withUninstalledExtensions(W=>delete W[G.toString()])}async removeExtension(G,W){if(this.uriIdentityService.extUri.isEqualOrParent(G.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(G.identifier.id,G.location,W)}async removeUninstalledExtension(G){await this.removeExtension(G,"uninstalled"),await this.withUninstalledExtensions(W=>delete W[n.ExtensionKey.create(G).toString()])}async copyExtension(G,W,b,D){const M=await this.getScannedExtension(G,W),V=await this.getScannedExtension(G,b);return D={...M?.metadata,...D},V?await this.extensionsProfileScannerService.updateMetadata([[G,{...V.metadata,...D}]],b):await this.extensionsProfileScannerService.addExtensionsToProfile([[G,D]],b),this.scanLocalExtension(G.location,G.type,b)}async copyExtensions(G,W){const b=await this.scanExtensions(1,G),D=await Promise.all(b.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,G)]));await this.extensionsProfileScannerService.addExtensionsToProfile(D,W)}async deleteExtensionFromLocation(G,W,b){this.logService.trace(`Deleting ${b} extension from disk`,G,W.fsPath);const D=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(W),`${this.uriIdentityService.extUri.basename(W)}.${(0,P.hash)((0,u.generateUuid)()).toString(16)}${B}`);await this.rename(W.fsPath,D.fsPath),await this.fileService.del(D,{recursive:!0}),this.logService.info(`Deleted ${b} extension from disk`,G,W.fsPath)}async withUninstalledExtensions(G){return this.uninstalledFileLimiter.queue(async()=>{let W;try{W=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(D){if((0,N.toFileOperationResult)(D)!==1)throw D}let b={};if(W)try{b=JSON.parse(W)}catch{}return G&&(G(b),Object.keys(b).length?await this.fileService.writeFile(this.uninstalledResource,O.VSBuffer.fromString(JSON.stringify(b))):await this.fileService.del(this.uninstalledResource)),b})}async rename(G,W){try{await d.Promises.rename(G,W,2*60*1e3)}catch(b){throw new s.ExtensionManagementError(b.message||p.localize(5,null,G,W),b.code||s.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(G,W,b){if(b){const M=(await this.extensionsScannerService.scanUserExtensions({profileLocation:b})).find(V=>this.uriIdentityService.extUri.isEqual(V.location,G));if(M)return this.toLocalExtension(M)}else{const D=await this.extensionsScannerService.scanExistingExtension(G,W,{includeInvalid:!0});if(D)return this.toLocalExtension(D)}throw new Error(p.localize(6,null,G.path))}async toLocalExtension(G){const W=await this.fileService.resolve(G.location);let b,D;return W.children&&(b=W.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,D=W.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:G.identifier,type:G.type,isBuiltin:G.isBuiltin||!!G.metadata?.isBuiltin,location:G.location,manifest:G.manifest,targetPlatform:G.targetPlatform,validations:G.validations,isValid:G.isValid,readmeUrl:b,changelogUrl:D,publisherDisplayName:G.metadata?.publisherDisplayName||null,publisherId:G.metadata?.publisherId||null,isApplicationScoped:!!G.metadata?.isApplicationScoped,isMachineScoped:!!G.metadata?.isMachineScoped,isPreReleaseVersion:!!G.metadata?.isPreReleaseVersion,preRelease:!!G.metadata?.preRelease,installedTimestamp:G.metadata?.installedTimestamp,updated:!!G.metadata?.updated,pinned:!!G.metadata?.pinned}}async removeUninstalledExtensions(){const G=await this.getUninstalledExtensions();if(Object.keys(G).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(G));const W=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),b=new Set;for(const M of W)G[n.ExtensionKey.create(M).toString()]||b.add(M.identifier.id.toLowerCase());try{const M=(0,n.groupByExtension)(W,V=>V.identifier);await k.Promises.settled(M.map(async V=>{const ee=V.sort((ne,de)=>f.rcompare(ne.manifest.version,de.manifest.version))[0];b.has(ee.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(ee))}))}catch(M){this.logService.error(M)}const D=W.filter(M=>M.metadata&&G[n.ExtensionKey.create(M).toString()]);await Promise.allSettled(D.map(M=>this.removeUninstalledExtension(M)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let G;try{G=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(W){(0,N.toFileOperationResult)(W)!==1&&this.logService.error(W);return}if(G?.children)try{await Promise.allSettled(G.children.map(async W=>{if(!(!W.isDirectory||!W.name.endsWith(B))){this.logService.trace("Deleting the temporarily deleted folder",W.resource.toString());try{await this.fileService.del(W.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",W.resource.toString())}catch(b){(0,N.toFileOperationResult)(b)!==1&&this.logService.error(b)}}}))}catch{}}};e.ExtensionsScanner=x,e.ExtensionsScanner=x=ye([K(1,N.IFileService),K(2,r.IExtensionsScannerService),K(3,i.IExtensionsProfileScannerService),K(4,H.IUriIdentityService),K(5,$.ILogService)],x);class j extends o.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,E.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(G,W,b,D,M,V,ee,ne,de){super(),this.identifier=G,this.source=W,this.options=b,this.extensionsScanner=D,this.uriIdentityService=M,this.userDataProfilesService=V,this.extensionsScannerService=ee,this.extensionsProfileScannerService=ne,this.logService=de,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(G){const[W,b]=await this.install(G);return this._profileLocation=W.isBuiltin||W.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[W,b]],this._profileLocation),W}async extractExtension({zipPath:G,key:W,metadata:b},D,M){let V=await this.unsetIfUninstalled(W);return V||(this.logService.trace("Extracting extension...",W.id),V=await this.extensionsScanner.extractUserExtension(W,G,b,D,M),this.logService.info("Extracting extension completed.",W.id)),V}async unsetIfUninstalled(G){return await this.isUninstalled(G)?(this.logService.trace("Removing the extension from uninstalled list:",G.id),await this.extensionsScanner.setInstalled(G),this.logService.info("Removed the extension from uninstalled list:",G.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(D=>n.ExtensionKey.create(D).equals(G))):void 0}async isUninstalled(G){return!!(await this.extensionsScanner.getUninstalledExtensions())[G.toString()]}}class q extends j{constructor(G,W,b,D,M,V,ee,ne,de,X){super(W.identifier,W,b,M,V,ee,ne,de,X),this.gallery=W,this.extensionsDownloader=D}async install(G){const b=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(ee=>(0,n.areSameExtensions)(ee.identifier,this.gallery.identifier));b&&(this._operation=3);const D={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||b?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||b?.isMachineScoped,isBuiltin:this.options.isBuiltin||b?.isBuiltin,isSystem:b?.type===0?!0:void 0,updated:!!b,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,E.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:b?.preRelease)};if(b?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(b,D),D];const{location:M,verificationStatus:V}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=V,this.validateManifest(M.fsPath),[await this.extractExtension({zipPath:M.fsPath,key:n.ExtensionKey.create(this.gallery),metadata:D},!1,G),D]}catch(ee){try{await this.extensionsDownloader.delete(M)}catch(ne){this.logService.warn("Error while deleting the downloaded file",M.toString(),(0,_.getErrorMessage)(ne))}throw ee}}async validateManifest(G){try{await(0,S.getManifest)(G)}catch(W){throw new s.ExtensionManagementError((0,o.joinErrors)(W).message,s.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=q;class Z extends j{constructor(G,W,b,D,M,V,ee,ne,de,X){super({id:(0,n.getGalleryExtensionId)(G.publisher,G.name)},W,b,M,V,ee,ne,de,X),this.manifest=G,this.location=W,this.galleryService=D}async doRun(G){const W=await super.doRun(G);return this.updateMetadata(W,G),W}async install(G){const W=new n.ExtensionKey(this.identifier,this.manifest.version),D=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(ee=>(0,n.areSameExtensions)(this.identifier,ee.identifier)),M={isApplicationScoped:this.options.isApplicationScoped||D?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||D?.isMachineScoped,isBuiltin:this.options.isBuiltin||D?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(D)if(this._operation=3,W.equals(new n.ExtensionKey(D.identifier,D.manifest.version)))try{await this.extensionsScanner.removeExtension(D,"existing")}catch{throw new Error(p.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&f.gt(D.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(D);else{const ee=await this.unsetIfUninstalled(W);if(ee)try{await this.extensionsScanner.removeExtension(ee,"existing")}catch{throw new Error(p.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:g.resolve(this.location.fsPath),key:W,metadata:M},!0,G),M]}async updateMetadata(G,W){try{let[b]=await this.galleryService.getExtensions([{id:G.identifier.id,version:G.manifest.version}],W);if(b||([b]=await this.galleryService.getExtensions([{id:G.identifier.id}],W)),b){const D={id:b.identifier.uuid,publisherDisplayName:b.publisherDisplayName,publisherId:b.publisherId,isPreReleaseVersion:b.properties.isPreReleaseVersion,preRelease:b.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(G,D,this.options.profileLocation)}}catch{}}}class oe extends o.AbstractExtensionTask{constructor(G,W,b){super(),this.extension=G,this.profileLocation=W,this.extensionsProfileScannerService=b}async doRun(G){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(ce[263],le([0,1,2,29,80,220,122,7,19]),function(ie,e,k,O,T,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let m=class extends k.Disposable{constructor(y,g,h,f,E,c){super(),y.cleanUp(),(0,A.migrateUnsupportedExtensions)(y,g,h,f,c),T.ExtensionStorageService.removeOutdatedExtensionVersions(y,E)}};e.ExtensionsContributions=m,e.ExtensionsContributions=m=ye([K(0,_.INativeServerExtensionManagementService),K(1,O.IExtensionGalleryService),K(2,T.IExtensionStorageService),K(3,O.IGlobalExtensionEnablementService),K(4,P.IStorageService),K(5,R.ILogService)],m)}),define(ce[123],le([0,1,69,61,36,273,14,8,3,2,16,6,32,43,65]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class E{traceSocketEvent(l,C){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,C)}constructor(l,C=""){this._canWrite=!0,this.debugLabel=C,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,R.onUnexpectedError)(U)}},this.socket.on("error",this._errorListener),this._closeListener=U=>{this.traceSocketEvent("close",{hadError:U}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(l){const C=U=>{this.traceSocketEvent("read",U),l(_.VSBuffer.wrap(U))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(l){const C=U=>{l({type:0,hadError:U,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(l){const C=()=>{l()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(l){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,R.onUnexpectedError)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,R.onUnexpectedError)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.NodeSocket=E;var c;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize",S[S.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(c||(c={}));var u;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(u||(u={}));class d extends m.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,C){this.socket.traceSocketEvent(l,C)}constructor(l,C,U,N){super(),this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:U?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new v(this,C,U,N,this._onData,(F,$)=>this._write(F,$))),this._register(this._flowManager.onError(F=>{console.error(F),(0,R.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})})),this._incomingData=new f.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(async F=>{this._flowManager.isProcessingReadQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(F)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){let C=0;for(;C<l.byteLength;)this._flowManager.writeMessage(l.slice(C,Math.min(C+262144,l.byteLength))),C+=262144}_write(l,C){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let U=2;l.byteLength<126?U+=0:l.byteLength<2**16?U+=2:U+=8;const N=_.VSBuffer.alloc(U);if(C?N.writeUInt8(194,0):N.writeUInt8(130,0),l.byteLength<126)N.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){N.writeUInt8(126,1);let F=1;N.writeUInt8(l.byteLength>>>8&255,++F),N.writeUInt8(l.byteLength>>>0&255,++F)}else{N.writeUInt8(127,1);let F=1;N.writeUInt8(0,++F),N.writeUInt8(0,++F),N.writeUInt8(0,++F),N.writeUInt8(0,++F),N.writeUInt8(l.byteLength>>>24&255,++F),N.writeUInt8(l.byteLength>>>16&255,++F),N.writeUInt8(l.byteLength>>>8&255,++F),N.writeUInt8(l.byteLength>>>0&255,++F)}this.socket.write(_.VSBuffer.concat([N,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const C=this._incomingData.peek(this._state.readLen),U=C.readUInt8(0),N=(U&128)>>>7,F=(U&64)>>>6,$=C.readUInt8(1),z=($&128)>>>7,J=$&127;this._state.state=2,this._state.readLen=2+(z?4:0)+(J===126?2:0)+(J===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=!!F),this._state.firstFrameOfMessage=!!N,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const C=this._incomingData.read(this._state.readLen),U=C.readUInt8(1),N=(U&128)>>>7;let F=U&127,$=1;F===126?F=C.readUInt8(++$)*2**8+C.readUInt8(++$):F===127&&(F=C.readUInt8(++$)*0+C.readUInt8(++$)*0+C.readUInt8(++$)*0+C.readUInt8(++$)*0+C.readUInt8(++$)*2**24+C.readUInt8(++$)*2**16+C.readUInt8(++$)*2**8+C.readUInt8(++$));let z=0;N&&(z=C.readUInt8(++$)*2**24+C.readUInt8(++$)*2**16+C.readUInt8(++$)*2**8+C.readUInt8(++$)),this._state.state=3,this._state.readLen=F,this._state.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const C=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),t(C,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(C,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class v extends m.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}constructor(l,C,U,N,F,$){super(),this._tracer=l,this._onData=F,this._writeFn=$,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new P.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,C?(this._zlibInflateStream=this._register(new p(this._tracer,N,U,{windowBits:15})),this._zlibDeflateStream=this._register(new L(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(z=>this._onError.fire(z))),this._register(this._zlibDeflateStream.onError(z=>this._onError.fire(z)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(l){this._writeQueue.push(l),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const l=this._writeQueue.shift();if(this._zlibDeflateStream){const C=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(C,!0)}else this._writeFn(l,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,C){return new Promise((U,N)=>{l.write(C),l.flush(F=>U(F))})}acceptFrame(l,C,U){this._readQueue.push({data:l,isCompressed:C,isLastFrameOfMessage:U}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const C=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(C)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(l,C,U){return new Promise((N,F)=>{l.write(C),U&&l.write(_.VSBuffer.fromByteArray([0,0,255,255])),l.flush($=>N($))})}}class p extends m.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}constructor(l,C,U,N){super(),this._tracer=l,this._recordInflateBytes=C,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(N),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent("zlibInflateData",F),this._pendingInflateData.push(_.VSBuffer.wrap(F))}),U&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this._zlibInflate.write(U.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const C=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(C)})}}class L extends m.Disposable{constructor(l,C){super(),this._tracer=l,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",U=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibDeflate.on("data",U=>{this._tracer.traceSocketEvent("zlibDeflateData",U),this._pendingDeflateData.push(_.VSBuffer.wrap(U))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let C=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,C=C.slice(0,C.byteLength-4),l(C)})}}function t(S,l){if(l===0)return;const C=S.byteLength>>>2;for(let J=0;J<C;J++){const H=S.readUInt32BE(J*4);S.writeUInt32BE(H^l,J*4)}const U=C*4,N=S.byteLength-U,F=l>>>24&255,$=l>>>16&255,z=l>>>8&255;N>=1&&S.writeUInt8(S.readUInt8(U)^F,U),N>=2&&S.writeUInt8(S.readUInt8(U+1)^$,U+1),N>=3&&S.writeUInt8(S.readUInt8(U+2)^z,U+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function s(){const S=(0,g.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;const l=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,T.tmpdir)(),C=(0,I.join)(l,`vscode-ipc-${S}.sock`);return i(C),C}e.createRandomIPCHandle=s;function n(S,l,C){const U=(0,k.createHash)("md5").update(S).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${C}-${l}-sock`;const N=C.substr(0,4),F=l.substr(0,6),$=U.substr(0,8);let z;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?z=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${$}-${N}-${F}.sock`):z=(0,I.join)(S,`${N}-${F}.sock`),i(z),z}e.createStaticIPCHandle=n;function i(S){const l=o[y.platform];typeof l=="number"&&S.length>=l&&console.warn(`WARNING: IPC handle "${S}" is longer than ${l} chars, try a shorter --user-data-dir`)}class r extends h.IPCServer{static toClientConnectionEvent(l){const C=P.Event.fromNodeEventEmitter(l,"connection");return P.Event.map(C,U=>({protocol:new f.Protocol(new E(U,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(U,"close"))}))}constructor(l){super(r.toClientConnectionEvent(l)),this.server=l}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function a(S){return new Promise((l,C)=>{const U=(0,O.createServer)();U.on("error",C),U.listen(S,()=>{U.removeListener("error",C),l(new r(U))})})}e.serve=a;function w(S,l){return new Promise((C,U)=>{const N=(0,O.createConnection)(S,()=>{N.removeListener("error",U),C(f.Client.fromSocket(new E(N,`ipc-client${l}`),l))});N.once("error",U)})}e.connect=w}),define(ce[264],le([0,1,61,123,208]),function(ie,e,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{supports(A){return!0}connect({host:A,port:_},R,P,m){return new Promise((I,y)=>{const g=k.createConnection({host:A,port:_},()=>{g.removeListener("error",y),g.write((0,T.makeRawSocketHeaders)(R,P,m));const h=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(g.off("data",h),I(new O.NodeSocket(g,m)))};g.on("data",h)});g.setNoDelay(!0),g.once("error",y)})}}}),define(ce[265],le([0,1,61,36,132,123,5,2,6,18,7,23,211,104,106,76,14]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function u(t,o,s,n,i){let r;for(let a=3;a&&(r?.dispose(),r=await new d(t,o,s,n,i).waitForReady(),!(i&&T.BROWSER_RESTRICTED_PORTS[i]||!T.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));a--);return r}class d extends R.Disposable{constructor(o,s,n,i,r){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=r,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=o,this._server=k.createServer(),this._barrier=new _.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){const o=this.suggestedLocalPort??this.tunnelRemotePort,s=(0,E.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let n=await(0,T.findFreePortFaster)(o,2,1e3,s),i=null;return this._server.listen(n,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address(),i||(n=0,this._server.listen(n,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async _onConnection(o){o.pause();const s=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,g.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),i=n.getSocket(),r=n.readEntireBuffer();n.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),i.end()}),o.on("close",()=>i.end()),o.on("error",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),i instanceof A.NodeSocket?i.socket.destroy():i.end()}),i instanceof A.NodeSocket?this._mirrorNodeSocket(o,i):this._mirrorGenericSocket(o,i),o.localAddress&&this._socketsDispose.set(o.localAddress,()=>{o.end(),i.end()})}_mirrorGenericSocket(o,s){s.onClose(()=>o.destroy()),s.onEnd(()=>o.end()),s.onData(n=>o.write(n.buffer)),o.on("data",n=>s.write(c.VSBuffer.wrap(n))),o.resume()}_mirrorNodeSocket(o,s){const n=s.socket;n.on("end",()=>o.end()),n.on("close",()=>o.end()),n.on("error",()=>{o.destroy()}),n.pipe(o),o.pipe(n)}}e.NodeRemoteTunnel=d;let v=class extends E.AbstractTunnelService{constructor(o,s,n,i,r){super(s,r),this.remoteSocketFactoryService=o,this.signService=n,this.productService=i}isPortPrivileged(o){return(0,E.isPortPrivileged)(o,this.defaultTunnelHost,P.OS,O.release())}retainOrCreateTunnel(o,s,n,i,r,a,w,S){const l=this.getTunnelFromMap(s,n);if(l)return++l.refcount,l.value;if((0,E.isTunnelProvider)(o))return this.createWithProvider(o,s,n,r,a,w,S);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${n} on local port ${r}.`);const C={commit:this.productService.commit,quality:this.productService.quality,addressProvider:o,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},U=u(C,i,s,n,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,n,U),U}}};e.BaseTunnelService=v,e.BaseTunnelService=v=ye([K(0,h.IRemoteSocketFactoryService),K(1,I.ILogService),K(2,f.ISignService),K(3,y.IProductService),K(4,m.IConfigurationService)],v);let p=class extends v{constructor(o,s,n,i,r){super(o,s,n,i,r)}};e.TunnelService=p,e.TunnelService=p=ye([K(0,h.IRemoteSocketFactoryService),K(1,I.ILogService),K(2,f.ISignService),K(3,y.IProductService),K(4,m.IConfigurationService)],p);let L=class extends R.Disposable{constructor(o,s,n,i,r){super(),this.remoteSocketFactoryService=o,this.logService=s,this.productService=n,this.signService=i,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(o,s,n,i,r,a,w,S,l){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${i} on local port ${a}.`),!this._tunnelServices.has(o)){const C=new p(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(C),this._tunnelServices.set(o,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this._tunnelServices.delete(o))})}return this._tunnelServices.get(o).openTunnel(s,n,i,r,a,w,S,l)}};e.SharedTunnelsService=L,e.SharedTunnelsService=L=ye([K(0,h.IRemoteSocketFactoryService),K(1,I.ILogService),K(2,y.IProductService),K(3,f.ISignService),K(4,m.IConfigurationService)],L)}),define(ce[274],le([0,1,36,38,8,2,26,10,20,3,43,145,202,203,194,195,260,185,187,18,207,95,218,96,213,15,114,245,29,97,186,122,98,13,197,198,68,4,193,70,72,223,7,199,102,23,57,19,107,21,108,109,110,46,226,80,111,24,78,251,236,237,81,252,255,256,257,58,250,239,106,217,76,265,212,227,27,228,6,229,188,205,204,79,244,17,50,201,56,249,225,240,105,254,263,9,200,101,247,243,214,182,55,258,246,71,248,104,264,180,112,238,215]),function(ie,e,k,O,T,A,_,R,P,m,I,y,g,h,f,E,c,u,d,v,p,L,t,o,s,n,i,r,a,w,S,l,C,U,N,F,$,z,J,H,Q,B,Y,x,j,q,Z,oe,ae,G,W,b,D,M,V,ee,ne,de,X,se,te,he,fe,pe,Ce,ke,_e,Fe,ue,me,ve,Pe,De,We,Ae,$e,Ne,re,ge,Se,Ee,be,Re,Ie,Le,Te,Ue,Oe,qe,je,ze,Xe,ut,Et,wt,Ct,bt,ht,Pt,It,Dt,Rt,Lt,kt,_t,dt,Tt,ft,At,Ut,gt,Ot,tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Nt extends A.Disposable{constructor(we){super(),this.configuration=we,this.server=this._register(new y.Server(this)),this.lifecycleService=void 0,this.onDidWindowConnectRaw=this._register(new m.Emitter),this.registerListeners()}registerListeners(){let we=!1;const Me=()=>{we||(we=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Me),(0,y.once)(process.parentPort,tt.SharedProcessLifecycle.exit,Me)}async init(){const we=await this.initServices();(0,de.registerConfiguration)(),we.invokeFunction(Me=>{const Ge=Me.get(Y.ILogService);Ge.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(Ge)}),this._register((0,A.combinedDisposable)(we.createInstance(g.CodeCacheCleaner,this.configuration.codeCachePath),we.createInstance(h.LanguagePackCachedDataCleaner),we.createInstance(c.UnusedWorkspaceStorageDataCleaner),we.createInstance(E.LogsDataCleaner),we.createInstance(f.LocalizationsUpdater),we.createInstance(wt.ExtensionsContributions),we.createInstance(Xe.UserDataProfilesCleaner),we.createInstance(Ot.VoiceTranscriptionManager,this.onDidWindowConnectRaw.event)))}async initServices(){const we=new H.ServiceCollection,Me={_serviceBrand:void 0,...j.default};we.set(q.IProductService,Me);const Ge=new I.StaticRouter(xe=>xe==="main"),Ve=new dt.MainProcessService(this.server,Ge);we.set(dt.IMainProcessService,Ve);const nt=this.configuration.policiesData?new Oe.PolicyChannelClient(this.configuration.policiesData,Ve.getChannel("policy")):new qe.NullPolicyService;we.set(qe.IPolicyService,nt);const Be=new Ut.NativeEnvironmentService(this.configuration.args,Me);we.set(n.INativeEnvironmentService,Be);const Je=new x.LoggerChannelClient(void 0,this.configuration.logLevel,Be.logsHome,this.configuration.loggers.map(xe=>({...xe,resource:R.URI.revive(xe.resource)})),Ve.getChannel("logger"));we.set(Y.ILoggerService,Je);const st=this._register(Je.createLogger("sharedprocess",{name:(0,Ct.localize)(0,null)})),at=this._register(new Y.ConsoleLogger(st.getLevel())),He=this._register(new bt.LogService(st,[at]));we.set(Y.ILogService,He),this.lifecycleService=this._register(new ht.SharedProcessLifecycleService(He)),we.set(ht.ISharedProcessLifecycleService,this.lifecycleService);const Ke=this._register(new N.FileService(He));we.set(U.IFileService,Ke);const ct=this._register(new F.DiskFileSystemProvider(He));Ke.registerProvider(_.Schemas.file,ct);const lt=this._register(new Se.FileUserDataProvider(_.Schemas.file,this._register(new Ee.DiskFileSystemProviderClient(Ve.getChannel(Ee.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:ge.isLinux})),_.Schemas.vscodeUserData,He));Ke.registerProvider(_.Schemas.vscodeUserData,lt);const Qe=this._register(new je.UserDataProfilesService(this.configuration.profiles.all,R.URI.revive(this.configuration.profiles.home).with({scheme:Be.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));we.set(Te.IUserDataProfilesService,Qe);const Ye=this._register(new p.ConfigurationService(Qe.defaultProfile.settingsResource,Ke,nt,He));we.set(v.IConfigurationService,Ye);const Ze=new Tt.RemoteStorageService(void 0,{defaultProfile:Qe.defaultProfile,currentProfile:Qe.defaultProfile},Ve,Be);we.set(oe.IStorageService,Ze),this._register((0,A.toDisposable)(()=>Ze.flush())),await Promise.all([Ye.initialize(),Ze.initialize()]);const Ft=new re.UriIdentityService(Ke);we.set(Ne.IUriIdentityService,Ft);const St=new Dt.RequestChannelClient(Ve.getChannel("request"));we.set(Z.IRequestService,St),we.set(u.IChecksumService,new $.SyncDescriptor(d.ChecksumService,void 0,!1)),we.set(Re.IV8InspectProfilingService,new $.SyncDescriptor(be.InspectProfilingService,void 0,!1));const vt=I.ProxyChannel.toService(Ve.getChannel("nativeHost"));we.set(Lt.INativeHostService,vt),we.set(o.IDownloadService,new $.SyncDescriptor(s.DownloadService,void 0,!0));const Mt=this._register(new me.ActiveWindowManager(vt)),$t=new I.StaticRouter(xe=>Mt.getActiveClientId().then(ot=>xe===ot));we.set(C.IExtensionRecommendationNotificationService,new Rt.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",$t)));let rt;const et=[],pt=(0,M.isInternalTelemetry)(Me,Ye);if((0,M.supportsTelemetry)(Me,Be)){const xe=new b.TelemetryLogAppender(He,Je,Be,Me);if(et.push(xe),Me.aiConfig?.ariaKey){const ot=new ze.OneDataSystemAppender(St,pt,"monacoworkbench",null,Me.aiConfig.ariaKey);this._register((0,A.toDisposable)(()=>ot.flush())),et.push(ot)}rt=new D.TelemetryService({appenders:et,commonProperties:(0,ae.resolveCommonProperties)((0,k.release)(),(0,k.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,pt),sendErrorTelemetry:!0,piiPaths:(0,M.getPiiPathsFromEnvironment)(Be)},Ye,Me)}else{rt=M.NullTelemetryService;const xe=M.NullAppender;et.push(xe)}this.server.registerChannel("telemetryAppender",new W.TelemetryAppenderChannel(et)),we.set(G.ITelemetryService,rt);const Wt=new V.CustomEndpointTelemetryService(Ye,rt,He,Je,Be,Me);we.set(G.ICustomEndpointTelemetryService,Wt),we.set(Ue.IExtensionsProfileScannerService,new $.SyncDescriptor(It.ExtensionsProfileScannerService,void 0,!0)),we.set(Ie.IExtensionsScannerService,new $.SyncDescriptor(Le.ExtensionsScannerService,void 0,!0)),we.set(w.IExtensionSignatureVerificationService,new $.SyncDescriptor(w.ExtensionSignatureVerificationService,void 0,!0)),we.set(l.INativeServerExtensionManagementService,new $.SyncDescriptor(l.ExtensionManagementService,void 0,!0)),we.set(a.IExtensionGalleryService,new $.SyncDescriptor(r.ExtensionGalleryService,void 0,!0)),we.set(a.IExtensionTipsService,new $.SyncDescriptor(_t.ExtensionTipsService,void 0,!1)),we.set(Q.ILanguagePackService,new $.SyncDescriptor(B.NativeLanguagePackService,void 0,!1)),we.set(L.IDiagnosticsService,new $.SyncDescriptor(t.DiagnosticsService,void 0,!1)),we.set(X.IUserDataSyncAccountService,new $.SyncDescriptor(X.UserDataSyncAccountService,void 0,!0)),we.set(de.IUserDataSyncLogService,new $.SyncDescriptor(he.UserDataSyncLogService,void 0,!0)),we.set(de.IUserDataSyncUtilService,new te.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",xe=>xe.ctx!=="main"))),we.set(a.IGlobalExtensionEnablementService,new $.SyncDescriptor(i.GlobalExtensionEnablementService,void 0,!1)),we.set(ne.IIgnoredExtensionsManagementService,new $.SyncDescriptor(ne.IgnoredExtensionsManagementService,void 0,!0)),we.set(ee.IExtensionStorageService,new $.SyncDescriptor(ee.ExtensionStorageService)),we.set(de.IUserDataSyncStoreManagementService,new $.SyncDescriptor(_e.UserDataSyncStoreManagementService,void 0,!0)),we.set(de.IUserDataSyncStoreService,new $.SyncDescriptor(_e.UserDataSyncStoreService,void 0,!0)),we.set(fe.IUserDataSyncMachinesService,new $.SyncDescriptor(fe.UserDataSyncMachinesService,void 0,!0)),we.set(de.IUserDataSyncBackupStoreService,new $.SyncDescriptor(se.UserDataSyncBackupStoreService,void 0,!1)),we.set(de.IUserDataSyncEnablementService,new $.SyncDescriptor(pe.UserDataSyncEnablementService,void 0,!0)),we.set(de.IUserDataSyncService,new $.SyncDescriptor(Ce.UserDataSyncService,void 0,!1)),we.set(Fe.IUserDataProfileStorageService,new $.SyncDescriptor(ue.NativeUserDataProfileStorageService,void 0,!0)),we.set(de.IUserDataSyncResourceProviderService,new $.SyncDescriptor(Et.UserDataSyncResourceProviderService,void 0,!0)),we.set(ve.ISignService,new $.SyncDescriptor(Pe.SignService,void 0,!1));const yt=new ft.RemoteSocketFactoryService;return we.set(ft.IRemoteSocketFactoryService,yt),yt.register(0,At.nodeSocketFactory),we.set(De.ISharedTunnelsService,new $.SyncDescriptor(We.SharedTunnelsService)),we.set(Ae.ISharedProcessTunnelService,new $.SyncDescriptor($e.SharedProcessTunnelService)),we.set(ut.IRemoteTunnelService,new $.SyncDescriptor(Pt.RemoteTunnelService)),we.set(gt.IVoiceRecognitionService,new $.SyncDescriptor(gt.VoiceRecognitionService)),new J.InstantiationService(we)}initChannels(we){const Me=new S.ExtensionManagementChannel(we.get(a.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const Ge=I.ProxyChannel.fromService(we.get(Q.ILanguagePackService));this.server.registerChannel("languagePacks",Ge);const Ve=I.ProxyChannel.fromService(we.get(L.IDiagnosticsService));this.server.registerChannel("diagnostics",Ve);const nt=new S.ExtensionTipsChannel(we.get(a.IExtensionTipsService));this.server.registerChannel("extensionTipsService",nt);const Be=I.ProxyChannel.fromService(we.get(u.IChecksumService));this.server.registerChannel("checksum",Be);const Je=I.ProxyChannel.fromService(we.get(Re.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Je);const st=new te.UserDataSyncMachinesServiceChannel(we.get(fe.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",st);const at=I.ProxyChannel.fromService(we.get(G.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const He=new te.UserDataSyncAccountServiceChannel(we.get(X.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",He);const Ke=new te.UserDataSyncStoreManagementServiceChannel(we.get(de.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ke);const ct=new ke.UserDataSyncChannel(we.get(de.IUserDataSyncService),we.get(Te.IUserDataProfilesService),we.get(Y.ILogService));this.server.registerChannel("userDataSync",ct);const lt=this._register(we.get(z.IInstantiationService).createInstance(kt.UserDataAutoSyncService)),Qe=new te.UserDataAutoSyncChannel(lt);this.server.registerChannel("userDataAutoSync",Qe);const Ye=I.ProxyChannel.fromService(we.get(Ae.ISharedProcessTunnelService));this.server.registerChannel(Ae.ipcSharedProcessTunnelChannelName,Ye);const Ze=I.ProxyChannel.fromService(we.get(ut.IRemoteTunnelService));this.server.registerChannel("remoteTunnel",Ze)}registerErrorHandler(we){process.on("uncaughtException",Me=>(0,T.onUnexpectedError)(Me)),process.on("unhandledRejection",Me=>(0,T.onUnexpectedError)(Me)),(0,T.setUnexpectedErrorHandler)(Me=>{const Ge=(0,O.toErrorMessage)(Me,!0);Ge&&we.error(`[uncaught exception in sharedProcess]: ${Ge}`)})}handledClientConnection(we){if(we.data!==tt.SharedProcessRawConnection.response)return!1;const Me=(0,P.firstOrDefault)(we.ports);return Me?(this.onDidWindowConnectRaw.fire(Me),!0):!1}}async function mt(it){const we=new Nt(it);process.parentPort.postMessage(tt.SharedProcessLifecycle.ipcReady),await we.init(),process.parentPort.postMessage(tt.SharedProcessLifecycle.initDone)}e.main=mt,process.parentPort.once("message",it=>{mt(it.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a5004432af6600c99fa4f918a3f2f8df44df71e6/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
