/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/base/common/arrays","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/severity","vs/base/common/process","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","child_process","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","fs","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","net","vs/editor/common/core/position","os","vs/platform/remote/common/remoteHosts","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/labels","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(me){for(var e=[],C=0,L=me.length;C<L;C++)e[C]=Ce[me[C]];return e};define(Ce[153],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class C{static get(){const d=new Map,A=new Map,T=new Map,f=new Map;function w(_,D){_.has(D.detail)||_.set(D.detail,-D.timestamp)}function g(_,D){const y=_.get(D.detail);y&&(y>=0||_.set(D.detail,y+D.timestamp))}let P=[];typeof me=="function"&&typeof me.getStats=="function"&&(P=me.getStats().slice(0).sort((_,D)=>_.timestamp-D.timestamp));for(const _ of P)switch(_.type){case 10:w(d,_);break;case 11:case 12:g(d,_);break;case 21:w(A,_);break;case 22:g(A,_);break;case 33:w(T,_);break;case 34:g(T,_);break;case 31:w(f,_);break;case 32:g(f,_);break}let k=0;T.forEach(_=>k+=_);function p(_){const D=[];return _.forEach((y,n)=>D.push([n,y])),D}return{amdLoad:p(d),amdInvoke:p(A),nodeRequire:p(T),nodeEval:p(f),nodeRequireTotal:k}}static toMarkdownTable(d,A){let T="";const f=[];return d.forEach((w,g)=>{f[g]=w.length}),A.forEach(w=>{w.forEach((g,P)=>{typeof g>"u"&&(g=w[P]="-");const k=g.toString().length;f[P]=Math.max(k,f[P])})}),d.forEach((w,g)=>{T+=`| ${w+" ".repeat(f[g]-w.toString().length)} `}),T+=`|
`,d.forEach((w,g)=>{T+=`| ${"-".repeat(f[g])} `}),T+=`|
`,A.forEach(w=>{w.forEach((g,P)=>{typeof g<"u"&&(T+=`| ${g+" ".repeat(f[P]-g.toString().length)} `)}),T+=`|
`}),T}}e.LoaderStats=C}),define(Ce[69],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function C(T,f){const w=Object.create(null);for(const g of T){const P=f(g);let k=w[P];k||(k=w[P]=[]),k.push(g)}return w}e.groupBy=C;function L(T,f){const w=[],g=[];for(const P of T)f.has(P)||w.push(P);for(const P of f)T.has(P)||g.push(P);return{removed:w,added:g}}e.diffSets=L;function d(T,f){const w=[],g=[];for(const[P,k]of T)f.has(P)||w.push(k);for(const[P,k]of f)T.has(P)||g.push(k);return{removed:w,added:g}}e.diffMaps=d;class A{constructor(){this.map=new Map}add(f,w){let g=this.map.get(f);g||(g=new Set,this.map.set(f,g)),g.add(w)}delete(f,w){const g=this.map.get(f);g&&(g.delete(w),g.size===0&&this.map.delete(f))}forEach(f,w){const g=this.map.get(f);g&&g.forEach(w)}get(f){const w=this.map.get(f);return w||new Set}}e.SetMap=A}),define(Ce[70],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function C(T){return(f,w,g)=>{let P=null,k=null;if(typeof g.value=="function"?(P="value",k=g.value):typeof g.get=="function"&&(P="get",k=g.get),!k)throw new Error("not supported");g[P]=T(k,w)}}function L(T,f,w){let g=null,P=null;if(typeof w.value=="function"?(g="value",P=w.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(g="get",P=w.get),!P)throw new Error("not supported");const k=`$memoize$${f}`;w[g]=function(...p){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,p)}),this[k]}}e.memoize=L;function d(T,f,w){return C((g,P)=>{const k=`$debounce$${P}`,p=`$debounce$result$${P}`;return function(..._){this[p]||(this[p]=w?w():void 0),clearTimeout(this[k]),f&&(this[p]=f(this[p],..._),_=[this[p]]),this[k]=setTimeout(()=>{g.apply(this,_),this[p]=w?w():void 0},T)}})}e.debounce=d;function A(T,f,w){return C((g,P)=>{const k=`$throttle$timer$${P}`,p=`$throttle$result$${P}`,_=`$throttle$lastRun$${P}`,D=`$throttle$pending$${P}`;return function(...y){if(this[p]||(this[p]=w?w():void 0),(this[_]===null||this[_]===void 0)&&(this[_]=-Number.MAX_VALUE),f&&(this[p]=f(this[p],...y)),this[D])return;const n=this[_]+T;n<=Date.now()?(this[_]=Date.now(),g.apply(this,[this[p]]),this[p]=w?w():void 0):(this[D]=!0,this[k]=setTimeout(()=>{this[D]=!1,this[_]=Date.now(),g.apply(this,[this[p]]),this[p]=w?w():void 0},n-Date.now()))}})}e.throttle=A}),define(Ce[8],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class C{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?b.isErrorNoTelemetry(r)?new b(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(s=>{s(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=C,e.errorHandler=new C;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function d(t){if(!t||typeof t!="object")return!1;const r=t;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=d;function A(t){g(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=A;function T(t){g(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=T;function f(t){if(t instanceof Error){const{name:r,message:s}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:r,message:s,stack:i,noTelemetry:b.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=f;const w="Canceled";function g(t){return t instanceof P?!0:t instanceof Error&&t.name===w&&t.message===w}e.isCancellationError=g;class P extends Error{constructor(){super(w),this.name=this.message}}e.CancellationError=P;function k(){const t=new Error(w);return t.name=t.message,t}e.canceled=k;function p(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=p;function _(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=_;function D(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=D;function y(t){const r=new Error(`${t} has been disposed`);return r.name="DISPOSED",r}e.disposed=y;function n(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=n;class o extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=o;class a extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=a;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=m;class b extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof b)return r;const s=new b;return s.message=r.message,s.stack=r.stack,s}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=b;class I extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,I.prototype)}}e.BugIndicatingError=I}),define(Ce[18],De([1,0,8]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMaxIdxBy=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.findLastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(V,ee=0){return V[V.length-(1+ee)]}e.tail=L;function d(V){if(V.length===0)throw new Error("Invalid tail call");return[V.slice(0,V.length-1),V[V.length-1]]}e.tail2=d;function A(V,ee,G=(Y,de)=>Y===de){if(V===ee)return!0;if(!V||!ee||V.length!==ee.length)return!1;for(let Y=0,de=V.length;Y<de;Y++)if(!G(V[Y],ee[Y]))return!1;return!0}e.equals=A;function T(V,ee){const G=V.length-1;ee<G&&(V[ee]=V[G]),V.pop()}e.removeFastWithoutKeepingOrder=T;function f(V,ee,G){return w(V.length,Y=>G(V[Y],ee))}e.binarySearch=f;function w(V,ee){let G=0,Y=V-1;for(;G<=Y;){const de=(G+Y)/2|0,ke=ee(de);if(ke<0)G=de+1;else if(ke>0)Y=de-1;else return de}return-(G+1)}e.binarySearch2=w;function g(V,ee){let G=0,Y=V.length;if(Y===0)return 0;for(;G<Y;){const de=Math.floor((G+Y)/2);ee(V[de])?Y=de:G=de+1}return G}e.findFirstInSorted=g;function P(V,ee,G){if(V=V|0,V>=ee.length)throw new TypeError("invalid index");const Y=ee[Math.floor(ee.length*Math.random())],de=[],ke=[],B=[];for(const X of ee){const Z=G(X,Y);Z<0?de.push(X):Z>0?ke.push(X):B.push(X)}return V<de.length?P(V,de,G):V<de.length+B.length?B[0]:P(V-(de.length+B.length),ke,G)}e.quickSelect=P;function k(V,ee){const G=[];let Y;for(const de of V.slice(0).sort(ee))!Y||ee(Y[0],de)!==0?(Y=[de],G.push(Y)):Y.push(de);return G}e.groupBy=k;function p(V,ee,G){const Y=[];function de(X,Z,oe){if(Z===0&&oe.length===0)return;const Q=Y[Y.length-1];Q&&Q.start+Q.deleteCount===X?(Q.deleteCount+=Z,Q.toInsert.push(...oe)):Y.push({start:X,deleteCount:Z,toInsert:oe})}let ke=0,B=0;for(;;){if(ke===V.length){de(ke,0,ee.slice(B));break}if(B===ee.length){de(ke,V.length-ke,[]);break}const X=V[ke],Z=ee[B],oe=G(X,Z);oe===0?(ke+=1,B+=1):oe<0?(de(ke,1,[]),ke+=1):oe>0&&(de(ke,0,[Z]),B+=1)}return Y}e.sortedDiff=p;function _(V,ee,G){const Y=p(V,ee,G),de=[],ke=[];for(const B of Y)de.push(...V.slice(B.start,B.start+B.deleteCount)),ke.push(...B.toInsert);return{removed:de,added:ke}}e.delta=_;function D(V,ee,G){if(G===0)return[];const Y=V.slice(0,G).sort(ee);return n(V,ee,Y,G,V.length),Y}e.top=D;function y(V,ee,G,Y,de){return G===0?Promise.resolve([]):new Promise((ke,B)=>{(async()=>{const X=V.length,Z=V.slice(0,G).sort(ee);for(let oe=G,Q=Math.min(G+Y,X);oe<X;oe=Q,Q=Math.min(Q+Y,X)){if(oe>G&&await new Promise(ue=>setTimeout(ue)),de&&de.isCancellationRequested)throw new C.CancellationError;n(V,ee,Z,oe,Q)}return Z})().then(ke,B)})}e.topAsync=y;function n(V,ee,G,Y,de){for(const ke=G.length;Y<de;Y++){const B=V[Y];if(ee(B,G[ke-1])<0){G.pop();const X=g(G,Z=>ee(B,Z)<0);G.splice(X,0,B)}}}function o(V){return V.filter(ee=>!!ee)}e.coalesce=o;function a(V){let ee=0;for(let G=0;G<V.length;G++)V[G]&&(V[ee]=V[G],ee+=1);V.length=ee}e.coalesceInPlace=a;function m(V,ee,G){V.splice(G,0,V.splice(ee,1)[0])}e.move=m;function b(V){return!Array.isArray(V)||V.length===0}e.isFalsyOrEmpty=b;function I(V){return Array.isArray(V)&&V.length>0}e.isNonEmptyArray=I;function t(V,ee=G=>G){const G=new Set;return V.filter(Y=>{const de=ee(Y);return G.has(de)?!1:(G.add(de),!0)})}e.distinct=t;function r(V){const ee=new Set;return G=>{const Y=V(G);return ee.has(Y)?!1:(ee.add(Y),!0)}}e.uniqueFilter=r;function s(V,ee){const G=i(V,ee);if(G!==-1)return V[G]}e.findLast=s;function i(V,ee){for(let G=V.length-1;G>=0;G--){const Y=V[G];if(ee(Y))return G}return-1}e.findLastIndex=i;function c(V,ee){return V.length>0?V[0]:ee}e.firstOrDefault=c;function u(V,ee){return V.length>0?V[V.length-1]:ee}e.lastOrDefault=u;function v(V,ee,G=(Y,de)=>Y===de){let Y=0;for(let de=0,ke=Math.min(V.length,ee.length);de<ke&&G(V[de],ee[de]);de++)Y++;return Y}e.commonPrefixLength=v;function S(V){return[].concat(...V)}e.flatten=S;function l(V,ee){let G=typeof ee=="number"?V:0;typeof ee=="number"?G=V:(G=0,ee=V);const Y=[];if(G<=ee)for(let de=G;de<ee;de++)Y.push(de);else for(let de=G;de>ee;de--)Y.push(de);return Y}e.range=l;function h(V,ee,G){return V.reduce((Y,de)=>(Y[ee(de)]=G?G(de):de,Y),Object.create(null))}e.index=h;function E(V,ee){return V.push(ee),()=>R(V,ee)}e.insert=E;function R(V,ee){const G=V.indexOf(ee);if(G>-1)return V.splice(G,1),ee}e.remove=R;function M(V,ee,G){const Y=V.slice(0,ee),de=V.slice(ee);return Y.concat(G,de)}e.arrayInsert=M;function U(V,ee){let G;if(typeof ee=="number"){let Y=ee;G=()=>{const de=Math.sin(Y++)*179426549;return de-Math.floor(de)}}else G=Math.random;for(let Y=V.length-1;Y>0;Y-=1){const de=Math.floor(G()*(Y+1)),ke=V[Y];V[Y]=V[de],V[de]=ke}}e.shuffle=U;function F(V,ee){const G=V.indexOf(ee);G>-1&&(V.splice(G,1),V.unshift(ee))}e.pushToStart=F;function x(V,ee){const G=V.indexOf(ee);G>-1&&(V.splice(G,1),V.push(ee))}e.pushToEnd=x;function $(V,ee){for(const G of ee)V.push(G)}e.pushMany=$;function O(V,ee){return Array.isArray(V)?V.map(ee):ee(V)}e.mapArrayOrNot=O;function K(V){return Array.isArray(V)?V:[V]}e.asArray=K;function q(V){return V[Math.floor(Math.random()*V.length)]}e.getRandomElement=q;function fe(V,ee){for(const G of V){const Y=ee(G);if(Y!==void 0)return Y}}e.mapFind=fe;function se(V,ee,G){const Y=H(V,ee),de=V.length,ke=G.length;V.length=de+ke;for(let B=de-1;B>=Y;B--)V[B+ke]=V[B];for(let B=0;B<ke;B++)V[B+Y]=G[B]}e.insertInto=se;function ie(V,ee,G,Y){const de=H(V,ee),ke=V.splice(de,G);return se(V,de,Y),ke}e.splice=ie;function H(V,ee){return ee<0?Math.max(ee+V.length,0):Math.min(ee,V.length)}var re;(function(V){function ee(ke){return ke<0}V.isLessThan=ee;function G(ke){return ke<=0}V.isLessThanOrEqual=G;function Y(ke){return ke>0}V.isGreaterThan=Y;function de(ke){return ke===0}V.isNeitherLessOrGreaterThan=de,V.greaterThan=1,V.lessThan=-1,V.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function Ee(V,ee){return(G,Y)=>ee(V(G),V(Y))}e.compareBy=Ee;function ae(...V){return(ee,G)=>{for(const Y of V){const de=Y(ee,G);if(!re.isNeitherLessOrGreaterThan(de))return de}return re.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const ne=(V,ee)=>V-ee;e.numberComparator=ne;const J=(V,ee)=>(0,e.numberComparator)(V?1:0,ee?1:0);e.booleanComparator=J;function N(V){return(ee,G)=>-V(ee,G)}e.reverseOrder=N;function W(V,ee){if(V.length===0)return;let G=V[0];for(let Y=1;Y<V.length;Y++){const de=V[Y];ee(de,G)>0&&(G=de)}return G}e.findMaxBy=W;function he(V,ee){if(V.length===0)return;let G=V[0];for(let Y=1;Y<V.length;Y++){const de=V[Y];ee(de,G)>=0&&(G=de)}return G}e.findLastMaxBy=he;function Se(V,ee){return W(V,(G,Y)=>-ee(G,Y))}e.findMinBy=Se;function be(V,ee){if(V.length===0)return-1;let G=0;for(let Y=1;Y<V.length;Y++){const de=V[Y];ee(de,V[G])>0&&(G=Y)}return G}e.findMaxIdxBy=be;class we{constructor(ee){this.items=ee,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ee){let G=this.firstIdx;for(;G<this.items.length&&ee(this.items[G]);)G++;const Y=G===this.firstIdx?null:this.items.slice(this.firstIdx,G);return this.firstIdx=G,Y}takeFromEndWhile(ee){let G=this.lastIdx;for(;G>=0&&ee(this.items[G]);)G--;const Y=G===this.lastIdx?null:this.items.slice(G+1,this.lastIdx+1);return this.lastIdx=G,Y}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ee=this.items[this.firstIdx];return this.firstIdx++,ee}removeLast(){const ee=this.items[this.lastIdx];return this.lastIdx--,ee}takeCount(ee){const G=this.items.slice(this.firstIdx,this.firstIdx+ee);return this.firstIdx+=ee,G}}e.ArrayQueue=we;class ye{static{this.empty=new ye(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(G=>(ee(G),!0))}toArray(){const ee=[];return this.iterate(G=>(ee.push(G),!0)),ee}filter(ee){return new ye(G=>this.iterate(Y=>ee(Y)?G(Y):!0))}map(ee){return new ye(G=>this.iterate(Y=>G(ee(Y))))}some(ee){let G=!1;return this.iterate(Y=>(G=ee(Y),!G)),G}findFirst(ee){let G;return this.iterate(Y=>ee(Y)?(G=Y,!1):!0),G}findLast(ee){let G;return this.iterate(Y=>(ee(Y)&&(G=Y),!0)),G}findLastMaxBy(ee){let G,Y=!0;return this.iterate(de=>((Y||re.isGreaterThan(ee(de,G)))&&(Y=!1,G=de),!0)),G}}e.CallbackIterable=ye}),define(Ce[54],De([1,0,8]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(w,g){if(!w)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=L;function d(w,g="Unreachable"){throw new Error(g)}e.assertNever=d;function A(w){if(!w)throw new C.BugIndicatingError("Assertion Failed")}e.assert=A;function T(w){if(!w()){debugger;w(),(0,C.onUnexpectedError)(new C.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function f(w,g){let P=0;for(;P<w.length-1;){const k=w[P],p=w[P+1];if(!g(k,p))return!1;P++}return!0}e.checkAdjacentItems=f}),define(Ce[71],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function C(L){const d=this;let A=!1,T;return function(){return A||(A=!0,T=L.apply(d,arguments)),T}}e.once=C}),define(Ce[117],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class C{constructor(d){this._prefix=d,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=C,e.defaultGenerator=new C("id#")}),define(Ce[48],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(L){function d(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}L.is=d;const A=Object.freeze([]);function T(){return A}L.empty=T;function*f(b){yield b}L.single=f;function w(b){return d(b)?b:f(b)}L.wrap=w;function g(b){return b||A}L.from=g;function P(b){return!b||b[Symbol.iterator]().next().done===!0}L.isEmpty=P;function k(b){return b[Symbol.iterator]().next().value}L.first=k;function p(b,I){for(const t of b)if(I(t))return!0;return!1}L.some=p;function _(b,I){for(const t of b)if(I(t))return t}L.find=_;function*D(b,I){for(const t of b)I(t)&&(yield t)}L.filter=D;function*y(b,I){let t=0;for(const r of b)yield I(r,t++)}L.map=y;function*n(...b){for(const I of b)for(const t of I)yield t}L.concat=n;function o(b,I,t){let r=t;for(const s of b)r=I(r,s);return r}L.reduce=o;function*a(b,I,t=b.length){for(I<0&&(I+=b.length),t<0?t+=b.length:t>b.length&&(t=b.length);I<t;I++)yield b[I]}L.slice=a;function m(b,I=Number.POSITIVE_INFINITY){const t=[];if(I===0)return[t,b];const r=b[Symbol.iterator]();for(let s=0;s<I;s++){const i=r.next();if(i.done)return[t,L.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return r}}]}L.consume=m})(C||(e.Iterable=C={}))}),define(Ce[154],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var d;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(d||(e.ParseErrorCode=d={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function T(t,r=!1){let s=0;const i=t.length;let c="",u=0,v=16,S=0;function l(x){let $=0,O=0;for(;$<x;){const K=t.charCodeAt(s);if(K>=48&&K<=57)O=O*16+K-48;else if(K>=65&&K<=70)O=O*16+K-65+10;else if(K>=97&&K<=102)O=O*16+K-97+10;else break;s++,$++}return $<x&&(O=-1),O}function h(x){s=x,c="",u=0,v=16,S=0}function E(){const x=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&g(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&g(t.charCodeAt(s)))for(s++;s<t.length&&g(t.charCodeAt(s));)s++;else return S=3,t.substring(x,s);let $=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&g(t.charCodeAt(s))){for(s++;s<t.length&&g(t.charCodeAt(s));)s++;$=s}else S=3;return t.substring(x,$)}function R(){let x="",$=s;for(;;){if(s>=i){x+=t.substring($,s),S=2;break}const O=t.charCodeAt(s);if(O===34){x+=t.substring($,s),s++;break}if(O===92){if(x+=t.substring($,s),s++,s>=i){S=2;break}switch(t.charCodeAt(s++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const q=l(4);q>=0?x+=String.fromCharCode(q):S=4;break}default:S=5}$=s;continue}if(O>=0&&O<=31)if(w(O)){x+=t.substring($,s),S=2;break}else S=6;s++}return x}function M(){if(c="",S=0,u=s,s>=i)return u=i,v=17;let x=t.charCodeAt(s);if(f(x)){do s++,c+=String.fromCharCode(x),x=t.charCodeAt(s);while(f(x));return v=15}if(w(x))return s++,c+=String.fromCharCode(x),x===13&&t.charCodeAt(s)===10&&(s++,c+=`
`),v=14;switch(x){case 123:return s++,v=1;case 125:return s++,v=2;case 91:return s++,v=3;case 93:return s++,v=4;case 58:return s++,v=6;case 44:return s++,v=5;case 34:return s++,c=R(),v=10;case 47:{const $=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!w(t.charCodeAt(s));)s++;return c=t.substring($,s),v=12}if(t.charCodeAt(s+1)===42){s+=2;const O=i-1;let K=!1;for(;s<O;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,K=!0;break}s++}return K||(s++,S=1),c=t.substring($,s),v=13}return c+=String.fromCharCode(x),s++,v=16}case 45:if(c+=String.fromCharCode(x),s++,s===i||!g(t.charCodeAt(s)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=E(),v=11;default:for(;s<i&&U(x);)s++,x=t.charCodeAt(s);if(u!==s){switch(c=t.substring(u,s),c){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return c+=String.fromCharCode(x),s++,v=16}}function U(x){if(f(x)||w(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let x;do x=M();while(x>=12&&x<=15);return x}return{setPosition:h,getPosition:()=>s,scan:r?F:M,getToken:()=>v,getTokenValue:()=>c,getTokenOffset:()=>u,getTokenLength:()=>s-u,getTokenError:()=>S}}e.createScanner=T;function f(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function k(t,r){const s=[],i=new Object;let c;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function S(l,h,E,R){u.value=l,u.offset=h,u.length=E,u.type=R,u.colonOffset=void 0,c=u}try{m(t,{onObjectBegin:(l,h)=>{if(r<=l)throw i;c=void 0,v=r>l,s.push("")},onObjectProperty:(l,h,E)=>{if(r<h||(S(l,h,E,"property"),s[s.length-1]=l,r<=h+E))throw i},onObjectEnd:(l,h)=>{if(r<=l)throw i;c=void 0,s.pop()},onArrayBegin:(l,h)=>{if(r<=l)throw i;c=void 0,s.push(0)},onArrayEnd:(l,h)=>{if(r<=l)throw i;c=void 0,s.pop()},onLiteralValue:(l,h,E)=>{if(r<h||(S(l,h,E,I(l)),r<=h+E))throw i},onSeparator:(l,h,E)=>{if(r<=h)throw i;if(l===":"&&c&&c.type==="property")c.colonOffset=h,v=!1,c=void 0;else if(l===","){const R=s[s.length-1];typeof R=="number"?s[s.length-1]=R+1:(v=!0,s[s.length-1]=""),c=void 0}}})}catch(l){if(l!==i)throw l}return{path:s,previousNode:c,isAtPropertyKey:v,matches:l=>{let h=0;for(let E=0;h<l.length&&E<s.length;E++)if(l[h]===s[E]||l[h]==="*")h++;else if(l[h]!=="**")return!1;return h===l.length}}}e.getLocation=k;function p(t,r=[],s=A.DEFAULT){let i=null,c=[];const u=[];function v(l){Array.isArray(c)?c.push(l):i!==null&&(c[i]=l)}return m(t,{onObjectBegin:()=>{const l={};v(l),u.push(c),c=l,i=null},onObjectProperty:l=>{i=l},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const l=[];v(l),u.push(c),c=l,i=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:v,onError:(l,h,E)=>{r.push({error:l,offset:h,length:E})}},s),c[0]}e.parse=p;function _(t,r=[],s=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(l){i.type==="property"&&(i.length=l-i.offset,i=i.parent)}function u(l){return i.children.push(l),l}m(t,{onObjectBegin:l=>{i=u({type:"object",offset:l,length:-1,parent:i,children:[]})},onObjectProperty:(l,h,E)=>{i=u({type:"property",offset:h,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:l,offset:h,length:E,parent:i})},onObjectEnd:(l,h)=>{i.length=l+h-i.offset,i=i.parent,c(l+h)},onArrayBegin:(l,h)=>{i=u({type:"array",offset:l,length:-1,parent:i,children:[]})},onArrayEnd:(l,h)=>{i.length=l+h-i.offset,i=i.parent,c(l+h)},onLiteralValue:(l,h,E)=>{u({type:I(l),offset:h,length:E,parent:i,value:l}),c(h+E)},onSeparator:(l,h,E)=>{i.type==="property"&&(l===":"?i.colonOffset=h:l===","&&c(h))},onError:(l,h,E)=>{r.push({error:l,offset:h,length:E})}},s);const S=i.children[0];return S&&delete S.parent,S}e.parseTree=_;function D(t,r){if(!t)return;let s=t;for(const i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let c=!1;for(const u of s.children)if(Array.isArray(u.children)&&u.children[0].value===i){s=u.children[1],c=!0;break}if(!c)return}else{const c=i;if(s.type!=="array"||c<0||!Array.isArray(s.children)||c>=s.children.length)return;s=s.children[c]}return s}e.findNodeAtLocation=D;function y(t){if(!t.parent||!t.parent.children)return[];const r=y(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=y;function n(t){switch(t.type){case"array":return t.children.map(n);case"object":{const r=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=n(i))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=n;function o(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=o;function a(t,r,s=!1){if(o(t,r,s)){const i=t.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=r;c++){const u=a(i[c],r,s);if(u)return u}return t}}e.findNodeAtOffset=a;function m(t,r,s=A.DEFAULT){const i=T(t,!1);function c(Ee){return Ee?()=>Ee(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(Ee){return Ee?ae=>Ee(ae,i.getTokenOffset(),i.getTokenLength()):()=>!0}const v=c(r.onObjectBegin),S=u(r.onObjectProperty),l=c(r.onObjectEnd),h=c(r.onArrayBegin),E=c(r.onArrayEnd),R=u(r.onLiteralValue),M=u(r.onSeparator),U=c(r.onComment),F=u(r.onError),x=s&&s.disallowComments,$=s&&s.allowTrailingComma;function O(){for(;;){const Ee=i.scan();switch(i.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:x||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(Ee){case 12:case 13:x?K(10):U();break;case 16:K(1);break;case 15:case 14:break;default:return Ee}}}function K(Ee,ae=[],ne=[]){if(F(Ee),ae.length+ne.length>0){let J=i.getToken();for(;J!==17;){if(ae.indexOf(J)!==-1){O();break}else if(ne.indexOf(J)!==-1)break;J=O()}}}function q(Ee){const ae=i.getTokenValue();return Ee?R(ae):S(ae),O(),!0}function fe(){switch(i.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(i.getTokenValue()),typeof Ee!="number"&&(K(2),Ee=0)}catch{K(2)}R(Ee);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return O(),!0}function se(){return i.getToken()!==10?(K(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(M(":"),O(),re()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function ie(){v(),O();let Ee=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Ee||K(4,[],[]),M(","),O(),i.getToken()===2&&$)break}else Ee&&K(6,[],[]);se()||K(4,[],[2,5]),Ee=!0}return l(),i.getToken()!==2?K(7,[2],[]):O(),!0}function H(){h(),O();let Ee=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Ee||K(4,[],[]),M(","),O(),i.getToken()===4&&$)break}else Ee&&K(6,[],[]);re()||K(4,[],[4,5]),Ee=!0}return E(),i.getToken()!==4?K(8,[4],[]):O(),!0}function re(){switch(i.getToken()){case 3:return H();case 1:return ie();case 10:return q(!0);default:return fe()}}return O(),i.getToken()===17?s.allowEmptyContent?!0:(K(4,[],[]),!1):re()?(i.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=m;function b(t,r){const s=T(t),i=[];let c,u=0,v;do switch(v=s.getPosition(),c=s.scan(),c){case 12:case 13:case 17:u!==v&&i.push(t.substring(u,v)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),u=s.getPosition();break}while(c!==17);return i.join("")}e.stripComments=b;function I(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=I}),define(Ce[55],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class C{constructor(d){this.executor=d,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(d){this._error=d}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=C}),define(Ce[3],De([1,0,71,48]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const d=!1;let A=null;function T(u){A=u}if(e.setDisposableTracker=T,d){const u="__is_disposable_tracked__";T(new class{trackDisposable(v){const S=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[u]||console.log(S)},3e3)}setParent(v,S){if(v&&v!==a.None)try{v[u]=!0}catch{}}markAsDisposed(v){if(v&&v!==a.None)try{v[u]=!0}catch{}}markAsSingleton(v){}})}function f(u){return A?.trackDisposable(u),u}function w(u){A?.markAsDisposed(u)}function g(u,v){A?.setParent(u,v)}function P(u,v){if(A)for(const S of u)A.setParent(S,v)}function k(u){return A?.markAsSingleton(u),u}e.markAsSingleton=k;function p(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=p;function _(u){if(L.Iterable.is(u)){const v=[];for(const S of u)if(S)try{S.dispose()}catch(l){v.push(l)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.dispose=_;function D(u){for(const v of u)p(v)&&v.dispose();return[]}e.disposeIfDisposable=D;function y(...u){const v=n(()=>_(u));return P(u,v),v}e.combinedDisposable=y;function n(u){const v=f({dispose:(0,C.once)(()=>{w(v),u()})});return v}e.toDisposable=n;class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,f(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{_(this._toDispose)}finally{this._toDispose.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return g(v,this),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(v),v}}e.DisposableStore=o;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new o,f(this),g(this._store,this)}dispose(){w(this),this._store.dispose()}_register(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(v)}}e.Disposable=a;class m{constructor(){this._isDisposed=!1,f(this)}get value(){return this._isDisposed?void 0:this._value}set value(v){this._isDisposed||v===this._value||(this._value?.dispose(),v&&g(v,this),this._value=v)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const v=this._value;return this._value=void 0,v&&g(v,null),v}}e.MutableDisposable=m;class b{constructor(v){this._disposable=v,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=b;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,f(this)}set(v){let S=v;return this.unset=()=>S=void 0,this.isset=()=>S!==void 0,this.dispose=()=>{S&&(S(),S=void 0,w(this))},this}}e.SafeDisposable=I;class t{constructor(){this.references=new Map}acquire(v,...S){let l=this.references.get(v);l||(l={counter:0,object:this.createReferencedObject(v,...S)},this.references.set(v,l));const{object:h}=l,E=(0,C.once)(()=>{--l.counter===0&&(this.destroyReferencedObject(v,l.object),this.references.delete(v))});return l.counter++,{object:h,dispose:E}}}e.ReferenceCollection=t;class r{constructor(v){this.referenceCollection=v}async acquire(v,...S){const l=this.referenceCollection.acquire(v,...S);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=r;class s{constructor(v){this.object=v}dispose(){}}e.ImmortalReference=s;function i(u){const v=new o;try{u(v)}finally{v.dispose()}}e.disposeOnReturn=i;class c{constructor(){this._store=new Map,this._isDisposed=!1,f(this)}dispose(){w(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{_(this._store.values())}finally{this._store.clear()}}has(v){return this._store.has(v)}get(v){return this._store.get(v)}set(v,S,l=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),l||this._store.get(v)?.dispose(),this._store.set(v,S)}deleteAndDispose(v){this._store.get(v)?.dispose(),this._store.delete(v)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=c}),define(Ce[72],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class C{static{this.Undefined=new C(void 0)}constructor(A){this.element=A,this.next=C.Undefined,this.prev=C.Undefined}}class L{constructor(){this._first=C.Undefined,this._last=C.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===C.Undefined}clear(){let A=this._first;for(;A!==C.Undefined;){const T=A.next;A.prev=C.Undefined,A.next=C.Undefined,A=T}this._first=C.Undefined,this._last=C.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,T){const f=new C(A);if(this._first===C.Undefined)this._first=f,this._last=f;else if(T){const g=this._last;this._last=f,f.prev=g,g.next=f}else{const g=this._first;this._first=f,f.next=g,g.prev=f}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(f))}}shift(){if(this._first!==C.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==C.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==C.Undefined&&A.next!==C.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===C.Undefined&&A.next===C.Undefined?(this._first=C.Undefined,this._last=C.Undefined):A.next===C.Undefined?(this._last=this._last.prev,this._last.next=C.Undefined):A.prev===C.Undefined&&(this._first=this._first.next,this._first.prev=C.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==C.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),define(Ce[28],De([1,0]),function(me,e){"use strict";var C,L,d;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(y,n,o){let a=y.get(n);return a===void 0&&(a=o,y.set(n,a)),a}e.getOrSet=A;function T(y){const n=[];return y.forEach((o,a)=>{n.push(`${a} => ${o}`)}),`Map(${y.size}) {${n.join(", ")}}`}e.mapToString=T;function f(y){const n=[];return y.forEach(o=>{n.push(o)}),`Set(${y.size}) {${n.join(", ")}}`}e.setToString=f;class w{constructor(n,o){this.uri=n,this.value=o}}class g{static{this.defaultToKey=n=>n.toString()}constructor(n,o){this[C]="ResourceMap",n instanceof g?(this.map=new Map(n.map),this.toKey=o??g.defaultToKey):(this.map=new Map,this.toKey=n??g.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new w(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[a,m]of this.map)n(m.value,m.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=g;class P{constructor(n,o){this[L]="ResourceSet",!n||typeof n=="function"?this._map=new g(n):(this._map=new g(o),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,o){this._map.forEach((a,m)=>n.call(o,m,m,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=P;var k;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class p{constructor(){this[d]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const a=this._map.get(n);if(a)return o!==0&&this.touch(a,o),a.value}set(n,o,a=0){let m=this._map.get(n);if(m)m.value=o,a!==0&&this.touch(m,a);else{switch(m={key:n,value:o,next:void 0,previous:void 0},a){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(n,m),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const a=this._state;let m=this._head;for(;m;){if(o?n.bind(o)(m.value,m.key,this):n(m.value,m.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const n=this,o=this._state;let a=this._head;const m={[Symbol.iterator](){return m},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const b={value:a.key,done:!1};return a=a.next,b}else return{value:void 0,done:!0}}};return m}values(){const n=this,o=this._state;let a=this._head;const m={[Symbol.iterator](){return m},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const b={value:a.value,done:!1};return a=a.next,b}else return{value:void 0,done:!0}}};return m}entries(){const n=this,o=this._state;let a=this._head;const m={[Symbol.iterator](){return m},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const b={value:[a.key,a.value],done:!1};return a=a.next,b}else return{value:void 0,done:!0}}};return m}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,a=this.size;for(;o&&a>n;)this._map.delete(o.key),o=o.next,a--;this._head=o,this._size=a,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,a=n.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const a=n.next,m=n.previous;n===this._tail?(m.next=void 0,this._tail=m):(a.previous=m,m.next=a),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const a=n.next,m=n.previous;n===this._head?(a.previous=void 0,this._head=a):(a.previous=m,m.next=a),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,a)=>{n.push([a,o])}),n}fromJSON(n){this.clear();for(const[o,a]of n)this.set(o,a)}}e.LinkedMap=p;class _ extends p{constructor(n,o=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=_;class D{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let o=this.map.get(n)||0;return o===0?!1:(o--,o===0?this.map.delete(n):this.map.set(n,o),!0)}has(n){return this.map.has(n)}}e.CounterSet=D}),function(me,e){typeof define=="function"&&define.amd?define(Ce[155],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(be,we){for(var ye=0;ye<we.length;ye++){var V=we[ye];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(be,V.key,V)}}function C(be,we,ye){return we&&e(be.prototype,we),ye&&e(be,ye),Object.defineProperty(be,"prototype",{writable:!1}),be}function L(be,we){if(be){if(typeof be=="string")return d(be,we);var ye=Object.prototype.toString.call(be).slice(8,-1);if(ye==="Object"&&be.constructor&&(ye=be.constructor.name),ye==="Map"||ye==="Set")return Array.from(be);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return d(be,we)}}function d(be,we){(we==null||we>be.length)&&(we=be.length);for(var ye=0,V=new Array(we);ye<we;ye++)V[ye]=be[ye];return V}function A(be,we){var ye=typeof Symbol<"u"&&be[Symbol.iterator]||be["@@iterator"];if(ye)return(ye=ye.call(be)).next.bind(ye);if(Array.isArray(be)||(ye=L(be))||we&&be&&typeof be.length=="number"){ye&&(be=ye);var V=0;return function(){return V>=be.length?{done:!0}:{done:!1,value:be[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=T();function f(be){me.defaults=be}var w=/[&<>"']/,g=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},_=function(we){return p[we]};function D(be,we){if(we){if(w.test(be))return be.replace(g,_)}else if(P.test(be))return be.replace(k,_);return be}var y=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(be){return be.replace(y,function(we,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var o=/(^|[^\[])\^/g;function a(be,we){be=typeof be=="string"?be:be.source,we=we||"";var ye={replace:function(ee,G){return G=G.source||G,G=G.replace(o,"$1"),be=be.replace(ee,G),ye},getRegex:function(){return new RegExp(be,we)}};return ye}var m=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function I(be,we,ye){if(be){var V;try{V=decodeURIComponent(n(ye)).replace(m,"").toLowerCase()}catch{return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}we&&!b.test(ye)&&(ye=c(we,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var t={},r=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(be,we){t[" "+be]||(r.test(be)?t[" "+be]=be+"/":t[" "+be]=l(be,"/",!0)),be=t[" "+be];var ye=be.indexOf(":")===-1;return we.substring(0,2)==="//"?ye?we:be.replace(s,"$1")+we:we.charAt(0)==="/"?ye?we:be.replace(i,"$1")+we:be+we}var u={exec:function(){}};function v(be){for(var we=1,ye,V;we<arguments.length;we++){ye=arguments[we];for(V in ye)Object.prototype.hasOwnProperty.call(ye,V)&&(be[V]=ye[V])}return be}function S(be,we){var ye=be.replace(/\|/g,function(G,Y,de){for(var ke=!1,B=Y;--B>=0&&de[B]==="\\";)ke=!ke;return ke?"|":" |"}),V=ye.split(/ \|/),ee=0;if(V[0].trim()||V.shift(),V.length>0&&!V[V.length-1].trim()&&V.pop(),V.length>we)V.splice(we);else for(;V.length<we;)V.push("");for(;ee<V.length;ee++)V[ee]=V[ee].trim().replace(/\\\|/g,"|");return V}function l(be,we,ye){var V=be.length;if(V===0)return"";for(var ee=0;ee<V;){var G=be.charAt(V-ee-1);if(G===we&&!ye)ee++;else if(G!==we&&ye)ee++;else break}return be.slice(0,V-ee)}function h(be,we){if(be.indexOf(we[1])===-1)return-1;for(var ye=be.length,V=0,ee=0;ee<ye;ee++)if(be[ee]==="\\")ee++;else if(be[ee]===we[0])V++;else if(be[ee]===we[1]&&(V--,V<0))return ee;return-1}function E(be){be&&be.sanitize&&!be.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(be,we){if(we<1)return"";for(var ye="";we>1;)we&1&&(ye+=be),we>>=1,be+=be;return ye+be}function M(be,we,ye,V){var ee=we.href,G=we.title?D(we.title):null,Y=be[1].replace(/\\([\[\]])/g,"$1");if(be[0].charAt(0)!=="!"){V.state.inLink=!0;var de={type:"link",raw:ye,href:ee,title:G,text:Y,tokens:V.inlineTokens(Y)};return V.state.inLink=!1,de}return{type:"image",raw:ye,href:ee,title:G,text:D(Y)}}function U(be,we){var ye=be.match(/^(\s+)(?:```)/);if(ye===null)return we;var V=ye[1];return we.split(`
`).map(function(ee){var G=ee.match(/^\s+/);if(G===null)return ee;var Y=G[0];return Y.length>=V.length?ee.slice(V.length):ee}).join(`
`)}var F=function(){function be(ye){this.options=ye||me.defaults}var we=be.prototype;return we.space=function(V){var ee=this.rules.block.newline.exec(V);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},we.code=function(V){var ee=this.rules.block.code.exec(V);if(ee){var G=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?G:l(G,`
`)}}},we.fences=function(V){var ee=this.rules.block.fences.exec(V);if(ee){var G=ee[0],Y=U(G,ee[3]||"");return{type:"code",raw:G,lang:ee[2]?ee[2].trim():ee[2],text:Y}}},we.heading=function(V){var ee=this.rules.block.heading.exec(V);if(ee){var G=ee[2].trim();if(/#$/.test(G)){var Y=l(G,"#");(this.options.pedantic||!Y||/ $/.test(Y))&&(G=Y.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:G,tokens:this.lexer.inline(G)}}},we.hr=function(V){var ee=this.rules.block.hr.exec(V);if(ee)return{type:"hr",raw:ee[0]}},we.blockquote=function(V){var ee=this.rules.block.blockquote.exec(V);if(ee){var G=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},we.list=function(V){var ee=this.rules.block.list.exec(V);if(ee){var G,Y,de,ke,B,X,Z,oe,Q,ue,ve,xe,We=ee[1].trim(),Ze=We.length>1,Qe={type:"list",raw:"",ordered:Ze,start:Ze?+We.slice(0,-1):"",loose:!1,items:[]};We=Ze?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=Ze?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");V&&(xe=!1,!(!(ee=it.exec(V))||this.rules.block.hr.test(V)));){if(G=ee[0],V=V.substring(G.length),oe=ee[2].split(`
`,1)[0],Q=V.split(`
`,1)[0],this.options.pedantic?(ke=2,ve=oe.trimLeft()):(ke=ee[2].search(/[^ ]/),ke=ke>4?1:ke,ve=oe.slice(ke),ke+=ee[1].length),X=!1,!oe&&/^ *$/.test(Q)&&(G+=Q+`
`,V=V.substring(Q.length+1),xe=!0),!xe)for(var et=new RegExp("^ {0,"+Math.min(3,ke-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Pe=new RegExp("^ {0,"+Math.min(3,ke-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,ke-1)+"}(?:```|~~~)"),ze=new RegExp("^ {0,"+Math.min(3,ke-1)+"}#");V&&(ue=V.split(`
`,1)[0],oe=ue,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(oe)||ze.test(oe)||et.test(oe)||Pe.test(V)));){if(oe.search(/[^ ]/)>=ke||!oe.trim())ve+=`
`+oe.slice(ke);else if(!X)ve+=`
`+oe;else break;!X&&!oe.trim()&&(X=!0),G+=ue+`
`,V=V.substring(ue.length+1)}Qe.loose||(Z?Qe.loose=!0:/\n *\n *$/.test(G)&&(Z=!0)),this.options.gfm&&(Y=/^\[[ xX]\] /.exec(ve),Y&&(de=Y[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:G,task:!!Y,checked:de,loose:!1,text:ve}),Qe.raw+=G}Qe.items[Qe.items.length-1].raw=G.trimRight(),Qe.items[Qe.items.length-1].text=ve.trimRight(),Qe.raw=Qe.raw.trimRight();var Re=Qe.items.length;for(B=0;B<Re;B++){this.lexer.state.top=!1,Qe.items[B].tokens=this.lexer.blockTokens(Qe.items[B].text,[]);var Xe=Qe.items[B].tokens.filter(function(ce){return ce.type==="space"}),le=Xe.every(function(ce){for(var Ie=ce.raw.split(""),He=0,Ue=A(Ie),Ye;!(Ye=Ue()).done;){var rt=Ye.value;if(rt===`
`&&(He+=1),He>1)return!0}return!1});!Qe.loose&&Xe.length&&le&&(Qe.loose=!0,Qe.items[B].loose=!0)}return Qe}},we.html=function(V){var ee=this.rules.block.html.exec(V);if(ee){var G={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var Y=this.options.sanitizer?this.options.sanitizer(ee[0]):D(ee[0]);G.type="paragraph",G.text=Y,G.tokens=this.lexer.inline(Y)}return G}},we.def=function(V){var ee=this.rules.block.def.exec(V);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var G=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:ee[0],href:ee[2],title:ee[3]}}},we.table=function(V){var ee=this.rules.block.table.exec(V);if(ee){var G={type:"table",header:S(ee[1]).map(function(Z){return{text:Z}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=ee[0];var Y=G.align.length,de,ke,B,X;for(de=0;de<Y;de++)/^ *-+: *$/.test(G.align[de])?G.align[de]="right":/^ *:-+: *$/.test(G.align[de])?G.align[de]="center":/^ *:-+ *$/.test(G.align[de])?G.align[de]="left":G.align[de]=null;for(Y=G.rows.length,de=0;de<Y;de++)G.rows[de]=S(G.rows[de],G.header.length).map(function(Z){return{text:Z}});for(Y=G.header.length,ke=0;ke<Y;ke++)G.header[ke].tokens=this.lexer.inline(G.header[ke].text);for(Y=G.rows.length,ke=0;ke<Y;ke++)for(X=G.rows[ke],B=0;B<X.length;B++)X[B].tokens=this.lexer.inline(X[B].text);return G}}},we.lheading=function(V){var ee=this.rules.block.lheading.exec(V);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},we.paragraph=function(V){var ee=this.rules.block.paragraph.exec(V);if(ee){var G=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:G,tokens:this.lexer.inline(G)}}},we.text=function(V){var ee=this.rules.block.text.exec(V);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},we.escape=function(V){var ee=this.rules.inline.escape.exec(V);if(ee)return{type:"escape",raw:ee[0],text:D(ee[1])}},we.tag=function(V){var ee=this.rules.inline.tag.exec(V);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):D(ee[0]):ee[0]}},we.link=function(V){var ee=this.rules.inline.link.exec(V);if(ee){var G=ee[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var Y=l(G.slice(0,-1),"\\");if((G.length-Y.length)%2===0)return}else{var de=h(ee[2],"()");if(de>-1){var ke=ee[0].indexOf("!")===0?5:4,B=ke+ee[1].length+de;ee[2]=ee[2].substring(0,de),ee[0]=ee[0].substring(0,B).trim(),ee[3]=""}}var X=ee[2],Z="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);oe&&(X=oe[1],Z=oe[3])}else Z=ee[3]?ee[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(G)?X=X.slice(1):X=X.slice(1,-1)),M(ee,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:Z&&Z.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},we.reflink=function(V,ee){var G;if((G=this.rules.inline.reflink.exec(V))||(G=this.rules.inline.nolink.exec(V))){var Y=(G[2]||G[1]).replace(/\s+/g," ");if(Y=ee[Y.toLowerCase()],!Y||!Y.href){var de=G[0].charAt(0);return{type:"text",raw:de,text:de}}return M(G,Y,G[0],this.lexer)}},we.emStrong=function(V,ee,G){G===void 0&&(G="");var Y=this.rules.inline.emStrong.lDelim.exec(V);if(Y&&!(Y[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var de=Y[1]||Y[2]||"";if(!de||de&&(G===""||this.rules.inline.punctuation.exec(G))){var ke=Y[0].length-1,B,X,Z=ke,oe=0,Q=Y[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Q.lastIndex=0,ee=ee.slice(-1*V.length+ke);(Y=Q.exec(ee))!=null;)if(B=Y[1]||Y[2]||Y[3]||Y[4]||Y[5]||Y[6],!!B){if(X=B.length,Y[3]||Y[4]){Z+=X;continue}else if((Y[5]||Y[6])&&ke%3&&!((ke+X)%3)){oe+=X;continue}if(Z-=X,!(Z>0)){if(X=Math.min(X,X+Z+oe),Math.min(ke,X)%2){var ue=V.slice(1,ke+Y.index+X);return{type:"em",raw:V.slice(0,ke+Y.index+X+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}var ve=V.slice(2,ke+Y.index+X-1);return{type:"strong",raw:V.slice(0,ke+Y.index+X+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},we.codespan=function(V){var ee=this.rules.inline.code.exec(V);if(ee){var G=ee[2].replace(/\n/g," "),Y=/[^ ]/.test(G),de=/^ /.test(G)&&/ $/.test(G);return Y&&de&&(G=G.substring(1,G.length-1)),G=D(G,!0),{type:"codespan",raw:ee[0],text:G}}},we.br=function(V){var ee=this.rules.inline.br.exec(V);if(ee)return{type:"br",raw:ee[0]}},we.del=function(V){var ee=this.rules.inline.del.exec(V);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},we.autolink=function(V,ee){var G=this.rules.inline.autolink.exec(V);if(G){var Y,de;return G[2]==="@"?(Y=D(this.options.mangle?ee(G[1]):G[1]),de="mailto:"+Y):(Y=D(G[1]),de=Y),{type:"link",raw:G[0],text:Y,href:de,tokens:[{type:"text",raw:Y,text:Y}]}}},we.url=function(V,ee){var G;if(G=this.rules.inline.url.exec(V)){var Y,de;if(G[2]==="@")Y=D(this.options.mangle?ee(G[0]):G[0]),de="mailto:"+Y;else{var ke;do ke=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(ke!==G[0]);Y=D(G[0]),G[1]==="www."?de="http://"+Y:de=Y}return{type:"link",raw:G[0],text:Y,href:de,tokens:[{type:"text",raw:Y,text:Y}]}}},we.inlineText=function(V,ee){var G=this.rules.inline.text.exec(V);if(G){var Y;return this.lexer.state.inRawBlock?Y=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):D(G[0]):G[0]:Y=D(this.options.smartypants?ee(G[0]):G[0]),{type:"text",raw:G[0],text:Y}}},be}(),x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=a(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.listItemStart=a(/^( *)(bull) */).replace("bull",x.bullet).getRegex(),x.list=a(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=a(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=a(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.blockquote=a(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=v({},x),x.gfm=v({},x.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.table=a(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.gfm.paragraph=a(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",x.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.pedantic=v({},x.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:a(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var $={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};$._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",$.punctuation=a($.punctuation).replace(/punctuation/g,$._punctuation).getRegex(),$.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,$.escapedEmSt=/\\\*|\\_/g,$._comment=a(x._comment).replace("(?:-->|$)","-->").getRegex(),$.emStrong.lDelim=a($.emStrong.lDelim).replace(/punct/g,$._punctuation).getRegex(),$.emStrong.rDelimAst=a($.emStrong.rDelimAst,"g").replace(/punct/g,$._punctuation).getRegex(),$.emStrong.rDelimUnd=a($.emStrong.rDelimUnd,"g").replace(/punct/g,$._punctuation).getRegex(),$._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,$._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,$._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,$.autolink=a($.autolink).replace("scheme",$._scheme).replace("email",$._email).getRegex(),$._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,$.tag=a($.tag).replace("comment",$._comment).replace("attribute",$._attribute).getRegex(),$._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,$._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,$._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,$.link=a($.link).replace("label",$._label).replace("href",$._href).replace("title",$._title).getRegex(),$.reflink=a($.reflink).replace("label",$._label).replace("ref",x._label).getRegex(),$.nolink=a($.nolink).replace("ref",x._label).getRegex(),$.reflinkSearch=a($.reflinkSearch,"g").replace("reflink",$.reflink).replace("nolink",$.nolink).getRegex(),$.normal=v({},$),$.pedantic=v({},$.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",$._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",$._label).getRegex()}),$.gfm=v({},$.normal,{escape:a($.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),$.gfm.url=a($.gfm.url,"i").replace("email",$.gfm._extended_email).getRegex(),$.breaks=v({},$.gfm,{br:a($.br).replace("{2,}","*").getRegex(),text:a($.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(be){return be.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(be){var we="",ye,V,ee=be.length;for(ye=0;ye<ee;ye++)V=be.charCodeAt(ye),Math.random()>.5&&(V="x"+V.toString(16)),we+="&#"+V+";";return we}var q=function(){function be(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||me.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var V={block:x.normal,inline:$.normal};this.options.pedantic?(V.block=x.pedantic,V.inline=$.pedantic):this.options.gfm&&(V.block=x.gfm,this.options.breaks?V.inline=$.breaks:V.inline=$.gfm),this.tokenizer.rules=V}be.lex=function(V,ee){var G=new be(ee);return G.lex(V)},be.lexInline=function(V,ee){var G=new be(ee);return G.inlineTokens(V)};var we=be.prototype;return we.lex=function(V){V=V.replace(/\r\n|\r/g,`
`),this.blockTokens(V,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},we.blockTokens=function(V,ee){var G=this;ee===void 0&&(ee=[]),this.options.pedantic?V=V.replace(/\t/g,"    ").replace(/^ +$/gm,""):V=V.replace(/^( *)(\t+)/gm,function(Z,oe,Q){return oe+"    ".repeat(Q.length)});for(var Y,de,ke,B;V;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Z){return(Y=Z.call({lexer:G},V,ee))?(V=V.substring(Y.raw.length),ee.push(Y),!0):!1}))){if(Y=this.tokenizer.space(V)){V=V.substring(Y.raw.length),Y.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(Y);continue}if(Y=this.tokenizer.code(V)){V=V.substring(Y.raw.length),de=ee[ee.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+Y.raw,de.text+=`
`+Y.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):ee.push(Y);continue}if(Y=this.tokenizer.fences(V)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(Y=this.tokenizer.heading(V)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(Y=this.tokenizer.hr(V)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(Y=this.tokenizer.blockquote(V)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(Y=this.tokenizer.list(V)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(Y=this.tokenizer.html(V)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(Y=this.tokenizer.def(V)){V=V.substring(Y.raw.length),de=ee[ee.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+Y.raw,de.text+=`
`+Y.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[Y.tag]||(this.tokens.links[Y.tag]={href:Y.href,title:Y.title});continue}if(Y=this.tokenizer.table(V)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(Y=this.tokenizer.lheading(V)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(ke=V,this.options.extensions&&this.options.extensions.startBlock&&function(){var Z=1/0,oe=V.slice(1),Q=void 0;G.options.extensions.startBlock.forEach(function(ue){Q=ue.call({lexer:this},oe),typeof Q=="number"&&Q>=0&&(Z=Math.min(Z,Q))}),Z<1/0&&Z>=0&&(ke=V.substring(0,Z+1))}(),this.state.top&&(Y=this.tokenizer.paragraph(ke))){de=ee[ee.length-1],B&&de.type==="paragraph"?(de.raw+=`
`+Y.raw,de.text+=`
`+Y.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):ee.push(Y),B=ke.length!==V.length,V=V.substring(Y.raw.length);continue}if(Y=this.tokenizer.text(V)){V=V.substring(Y.raw.length),de=ee[ee.length-1],de&&de.type==="text"?(de.raw+=`
`+Y.raw,de.text+=`
`+Y.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):ee.push(Y);continue}if(V){var X="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,ee},we.inline=function(V,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:V,tokens:ee}),ee},we.inlineTokens=function(V,ee){var G=this;ee===void 0&&(ee=[]);var Y,de,ke,B=V,X,Z,oe;if(this.tokens.links){var Q=Object.keys(this.tokens.links);if(Q.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)Q.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,X.index)+"["+R("a",X[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,X.index)+"["+R("a",X[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,X.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;)if(Z||(oe=""),Z=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(Y=ve.call({lexer:G},V,ee))?(V=V.substring(Y.raw.length),ee.push(Y),!0):!1}))){if(Y=this.tokenizer.escape(V)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(Y=this.tokenizer.tag(V)){V=V.substring(Y.raw.length),de=ee[ee.length-1],de&&Y.type==="text"&&de.type==="text"?(de.raw+=Y.raw,de.text+=Y.text):ee.push(Y);continue}if(Y=this.tokenizer.link(V)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(Y=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(Y.raw.length),de=ee[ee.length-1],de&&Y.type==="text"&&de.type==="text"?(de.raw+=Y.raw,de.text+=Y.text):ee.push(Y);continue}if(Y=this.tokenizer.emStrong(V,B,oe)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(Y=this.tokenizer.codespan(V)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(Y=this.tokenizer.br(V)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(Y=this.tokenizer.del(V)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(Y=this.tokenizer.autolink(V,K)){V=V.substring(Y.raw.length),ee.push(Y);continue}if(!this.state.inLink&&(Y=this.tokenizer.url(V,K))){V=V.substring(Y.raw.length),ee.push(Y);continue}if(ke=V,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,xe=V.slice(1),We=void 0;G.options.extensions.startInline.forEach(function(Ze){We=Ze.call({lexer:this},xe),typeof We=="number"&&We>=0&&(ve=Math.min(ve,We))}),ve<1/0&&ve>=0&&(ke=V.substring(0,ve+1))}(),Y=this.tokenizer.inlineText(ke,O)){V=V.substring(Y.raw.length),Y.raw.slice(-1)!=="_"&&(oe=Y.raw.slice(-1)),Z=!0,de=ee[ee.length-1],de&&de.type==="text"?(de.raw+=Y.raw,de.text+=Y.text):ee.push(Y);continue}if(V){var ue="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return ee},C(be,null,[{key:"rules",get:function(){return{block:x,inline:$}}}]),be}(),fe=function(){function be(ye){this.options=ye||me.defaults}var we=be.prototype;return we.code=function(V,ee,G){var Y=(ee||"").match(/\S*/)[0];if(this.options.highlight){var de=this.options.highlight(V,Y);de!=null&&de!==V&&(G=!0,V=de)}return V=V.replace(/\n$/,"")+`
`,Y?'<pre><code class="'+this.options.langPrefix+D(Y,!0)+'">'+(G?V:D(V,!0))+`</code></pre>
`:"<pre><code>"+(G?V:D(V,!0))+`</code></pre>
`},we.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},we.html=function(V){return V},we.heading=function(V,ee,G,Y){if(this.options.headerIds){var de=this.options.headerPrefix+Y.slug(G);return"<h"+ee+' id="'+de+'">'+V+"</h"+ee+`>
`}return"<h"+ee+">"+V+"</h"+ee+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(V,ee,G){var Y=ee?"ol":"ul",de=ee&&G!==1?' start="'+G+'"':"";return"<"+Y+de+`>
`+V+"</"+Y+`>
`},we.listitem=function(V){return"<li>"+V+`</li>
`},we.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(V){return"<p>"+V+`</p>
`},we.table=function(V,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+ee+`</table>
`},we.tablerow=function(V){return`<tr>
`+V+`</tr>
`},we.tablecell=function(V,ee){var G=ee.header?"th":"td",Y=ee.align?"<"+G+' align="'+ee.align+'">':"<"+G+">";return Y+V+("</"+G+`>
`)},we.strong=function(V){return"<strong>"+V+"</strong>"},we.em=function(V){return"<em>"+V+"</em>"},we.codespan=function(V){return"<code>"+V+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(V){return"<del>"+V+"</del>"},we.link=function(V,ee,G){if(V=I(this.options.sanitize,this.options.baseUrl,V),V===null)return G;var Y='<a href="'+D(V)+'"';return ee&&(Y+=' title="'+ee+'"'),Y+=">"+G+"</a>",Y},we.image=function(V,ee,G){if(V=I(this.options.sanitize,this.options.baseUrl,V),V===null)return G;var Y='<img src="'+V+'" alt="'+G+'"';return ee&&(Y+=' title="'+ee+'"'),Y+=this.options.xhtml?"/>":">",Y},we.text=function(V){return V},be}(),se=function(){function be(){}var we=be.prototype;return we.strong=function(V){return V},we.em=function(V){return V},we.codespan=function(V){return V},we.del=function(V){return V},we.html=function(V){return V},we.text=function(V){return V},we.link=function(V,ee,G){return""+G},we.image=function(V,ee,G){return""+G},we.br=function(){return""},be}(),ie=function(){function be(){this.seen={}}var we=be.prototype;return we.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(V,ee){var G=V,Y=0;if(this.seen.hasOwnProperty(G)){Y=this.seen[V];do Y++,G=V+"-"+Y;while(this.seen.hasOwnProperty(G))}return ee||(this.seen[V]=Y,this.seen[G]=0),G},we.slug=function(V,ee){ee===void 0&&(ee={});var G=this.serialize(V);return this.getNextSafeSlug(G,ee.dryrun)},be}(),H=function(){function be(ye){this.options=ye||me.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new se,this.slugger=new ie}be.parse=function(V,ee){var G=new be(ee);return G.parse(V)},be.parseInline=function(V,ee){var G=new be(ee);return G.parseInline(V)};var we=be.prototype;return we.parse=function(V,ee){ee===void 0&&(ee=!0);var G="",Y,de,ke,B,X,Z,oe,Q,ue,ve,xe,We,Ze,Qe,it,et,Pe,Me,ze,Re=V.length;for(Y=0;Y<Re;Y++){if(ve=V[Y],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(ze=this.options.extensions.renderers[ve.type].call({parser:this},ve),ze!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){G+=ze||"";continue}switch(ve.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,n(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Q="",oe="",B=ve.header.length,de=0;de<B;de++)oe+=this.renderer.tablecell(this.parseInline(ve.header[de].tokens),{header:!0,align:ve.align[de]});for(Q+=this.renderer.tablerow(oe),ue="",B=ve.rows.length,de=0;de<B;de++){for(Z=ve.rows[de],oe="",X=Z.length,ke=0;ke<X;ke++)oe+=this.renderer.tablecell(this.parseInline(Z[ke].tokens),{header:!1,align:ve.align[ke]});ue+=this.renderer.tablerow(oe)}G+=this.renderer.table(Q,ue);continue}case"blockquote":{ue=this.parse(ve.tokens),G+=this.renderer.blockquote(ue);continue}case"list":{for(xe=ve.ordered,We=ve.start,Ze=ve.loose,B=ve.items.length,ue="",de=0;de<B;de++)it=ve.items[de],et=it.checked,Pe=it.task,Qe="",it.task&&(Me=this.renderer.checkbox(et),Ze?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Me+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Me+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Me}):Qe+=Me),Qe+=this.parse(it.tokens,Ze),ue+=this.renderer.listitem(Qe,Pe,et);G+=this.renderer.list(ue,xe,We);continue}case"html":{G+=this.renderer.html(ve.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(ue=ve.tokens?this.parseInline(ve.tokens):ve.text;Y+1<Re&&V[Y+1].type==="text";)ve=V[++Y],ue+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);G+=ee?this.renderer.paragraph(ue):ue;continue}default:{var Xe='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return G},we.parseInline=function(V,ee){ee=ee||this.renderer;var G="",Y,de,ke,B=V.length;for(Y=0;Y<B;Y++){if(de=V[Y],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(ke=this.options.extensions.renderers[de.type].call({parser:this},de),ke!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type))){G+=ke||"";continue}switch(de.type){case"escape":{G+=ee.text(de.text);break}case"html":{G+=ee.html(de.text);break}case"link":{G+=ee.link(de.href,de.title,this.parseInline(de.tokens,ee));break}case"image":{G+=ee.image(de.href,de.title,de.text);break}case"strong":{G+=ee.strong(this.parseInline(de.tokens,ee));break}case"em":{G+=ee.em(this.parseInline(de.tokens,ee));break}case"codespan":{G+=ee.codespan(de.text);break}case"br":{G+=ee.br();break}case"del":{G+=ee.del(this.parseInline(de.tokens,ee));break}case"text":{G+=ee.text(de.text);break}default:{var X='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return G},be}();function re(be,we,ye){if(typeof be>"u"||be===null)throw new Error("marked(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");if(typeof we=="function"&&(ye=we,we=null),we=v({},re.defaults,we||{}),E(we),ye){var V=we.highlight,ee;try{ee=q.lex(be,we)}catch(B){return ye(B)}var G=function(X){var Z;if(!X)try{we.walkTokens&&re.walkTokens(ee,we.walkTokens),Z=H.parse(ee,we)}catch(oe){X=oe}return we.highlight=V,X?ye(X):ye(null,Z)};if(!V||V.length<3||(delete we.highlight,!ee.length))return G();var Y=0;re.walkTokens(ee,function(B){B.type==="code"&&(Y++,setTimeout(function(){V(B.text,B.lang,function(X,Z){if(X)return G(X);Z!=null&&Z!==B.text&&(B.text=Z,B.escaped=!0),Y--,Y===0&&G()})},0))}),Y===0&&G();return}function de(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+D(B.message+"",!0)+"</pre>";throw B}try{var ke=q.lex(be,we);if(we.walkTokens){if(we.async)return Promise.all(re.walkTokens(ke,we.walkTokens)).then(function(){return H.parse(ke,we)}).catch(de);re.walkTokens(ke,we.walkTokens)}return H.parse(ke,we)}catch(B){de(B)}}re.options=re.setOptions=function(be){return v(re.defaults,be),f(re.defaults),re},re.getDefaults=T,re.defaults=me.defaults,re.use=function(){for(var be=arguments.length,we=new Array(be),ye=0;ye<be;ye++)we[ye]=arguments[ye];var V=v.apply(void 0,[{}].concat(we)),ee=re.defaults.extensions||{renderers:{},childTokens:{}},G;we.forEach(function(Y){if(Y.extensions&&(G=!0,Y.extensions.forEach(function(ke){if(!ke.name)throw new Error("extension name required");if(ke.renderer){var B=ee.renderers?ee.renderers[ke.name]:null;B?ee.renderers[ke.name]=function(){for(var X=arguments.length,Z=new Array(X),oe=0;oe<X;oe++)Z[oe]=arguments[oe];var Q=ke.renderer.apply(this,Z);return Q===!1&&(Q=B.apply(this,Z)),Q}:ee.renderers[ke.name]=ke.renderer}if(ke.tokenizer){if(!ke.level||ke.level!=="block"&&ke.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[ke.level]?ee[ke.level].unshift(ke.tokenizer):ee[ke.level]=[ke.tokenizer],ke.start&&(ke.level==="block"?ee.startBlock?ee.startBlock.push(ke.start):ee.startBlock=[ke.start]:ke.level==="inline"&&(ee.startInline?ee.startInline.push(ke.start):ee.startInline=[ke.start]))}ke.childTokens&&(ee.childTokens[ke.name]=ke.childTokens)})),Y.renderer&&function(){var ke=re.defaults.renderer||new fe,B=function(oe){var Q=ke[oe];ke[oe]=function(){for(var ue=arguments.length,ve=new Array(ue),xe=0;xe<ue;xe++)ve[xe]=arguments[xe];var We=Y.renderer[oe].apply(ke,ve);return We===!1&&(We=Q.apply(ke,ve)),We}};for(var X in Y.renderer)B(X);V.renderer=ke}(),Y.tokenizer&&function(){var ke=re.defaults.tokenizer||new F,B=function(oe){var Q=ke[oe];ke[oe]=function(){for(var ue=arguments.length,ve=new Array(ue),xe=0;xe<ue;xe++)ve[xe]=arguments[xe];var We=Y.tokenizer[oe].apply(ke,ve);return We===!1&&(We=Q.apply(ke,ve)),We}};for(var X in Y.tokenizer)B(X);V.tokenizer=ke}(),Y.walkTokens){var de=re.defaults.walkTokens;V.walkTokens=function(ke){var B=[];return B.push(Y.walkTokens.call(this,ke)),de&&(B=B.concat(de.call(this,ke))),B}}G&&(V.extensions=ee),re.setOptions(V)})},re.walkTokens=function(be,we){for(var ye=[],V=function(){var de=G.value;switch(ye=ye.concat(we.call(re,de)),de.type){case"table":{for(var ke=A(de.header),B;!(B=ke()).done;){var X=B.value;ye=ye.concat(re.walkTokens(X.tokens,we))}for(var Z=A(de.rows),oe;!(oe=Z()).done;)for(var Q=oe.value,ue=A(Q),ve;!(ve=ue()).done;){var xe=ve.value;ye=ye.concat(re.walkTokens(xe.tokens,we))}break}case"list":{ye=ye.concat(re.walkTokens(de.items,we));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[de.type]?re.defaults.extensions.childTokens[de.type].forEach(function(We){ye=ye.concat(re.walkTokens(de[We],we))}):de.tokens&&(ye=ye.concat(re.walkTokens(de.tokens,we)))}},ee=A(be),G;!(G=ee()).done;)V();return ye},re.parseInline=function(be,we){if(typeof be>"u"||be===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");we=v({},re.defaults,we||{}),E(we);try{var ye=q.lexInline(be,we);return we.walkTokens&&re.walkTokens(ye,we.walkTokens),H.parseInline(ye,we)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+D(V.message+"",!0)+"</pre>";throw V}},re.Parser=H,re.parser=H.parse,re.Renderer=fe,re.TextRenderer=se,re.Lexer=q,re.lexer=q.lex,re.Tokenizer=F,re.Slugger=ie,re.parse=re;var Ee=re.options,ae=re.setOptions,ne=re.use,J=re.walkTokens,N=re.parseInline,W=re,he=H.parse,Se=q.lex;me.Lexer=q,me.Parser=H,me.Renderer=fe,me.Slugger=ie,me.TextRenderer=se,me.Tokenizer=F,me.getDefaults=T,me.lexer=Se,me.marked=re,me.options=Ee,me.parse=W,me.parseInline=N,me.parser=he,me.setOptions=ae,me.use=ne,me.walkTokens=J,Object.defineProperty(me,"__esModule",{value:!0})}),define(Ce[73],De([1,0,28]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new C.LRUCache(1e4);function d(g){return w(g,"NFC",L)}e.normalizeNFC=d;const A=new C.LRUCache(1e4);function T(g){return w(g,"NFD",A)}e.normalizeNFD=T;const f=/[^\u0000-\u0080]/;function w(g,P,k){if(!g)return g;const p=k.get(g);if(p)return p;let _;return f.test(g)?_=g.normalize(P):_=g,k.set(g,_),_}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(P){return T(P).replace(g,"")}}()}),define(Ce[118],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function C(f,w,g){return Math.min(Math.max(f,w),g)}e.clamp=C;function L(f,w){return(w+f%w)%w}e.rot=L;class d{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=d;class A{constructor(){this._n=1,this._val=0}update(w){return this._val=this._val+(w-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class T{constructor(w){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(w),this._values.fill(0,0,w)}update(w){const g=this._values[this._index];return this._values[this._index]=w,this._index=(this._index+1)%this._values.length,this._sum-=g,this._sum+=w,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function me(d){const A=[];typeof d=="number"&&A.push("code/timeOrigin",d);function T(w){A.push(w,Date.now())}function f(){const w=[];for(let g=0;g<A.length;g+=2)w.push({name:A[g],startTime:A[g+1]});return w}return{mark:T,getMarks:f}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(d){performance.mark(d)},getMarks(){let d=performance.timeOrigin;typeof d!="number"&&(d=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(d)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(d+T.startTime)});return A}};if(typeof process=="object"){const d=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(d)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function C(d){return d.MonacoPerformanceMarks||(d.MonacoPerformanceMarks=e()),d.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=C(L))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var L in C)(typeof exports=="object"?exports:me)[L]=C[L]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function C(L){if(e[L])return e[L].exports;var d=e[L]={i:L,l:!1,exports:{}};return me[L].call(d.exports,d,d.exports,C),d.l=!0,d.exports}return C.m=me,C.c=e,C.d=function(L,d,A){C.o(L,d)||Object.defineProperty(L,d,{enumerable:!0,get:A})},C.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},C.t=function(L,d){if(1&d&&(L=C(L)),8&d||4&d&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(C.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&d&&typeof L!="string")for(var T in L)C.d(A,T,function(f){return L[f]}.bind(null,T));return A},C.n=function(L){var d=L&&L.__esModule?function(){return L.default}:function(){return L};return C.d(d,"a",d),d},C.o=function(L,d){return Object.prototype.hasOwnProperty.call(L,d)},C.p="",C(C.s=0)}([function(me,e,C){(function(L){var d;e=me.exports=ne,d=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,f=e.re=[],w=e.src=[],g=0,P=g++;w[P]="0|[1-9]\\d*";var k=g++;w[k]="[0-9]+";var p=g++;w[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var _=g++;w[_]="("+w[P]+")\\.("+w[P]+")\\.("+w[P]+")";var D=g++;w[D]="("+w[k]+")\\.("+w[k]+")\\.("+w[k]+")";var y=g++;w[y]="(?:"+w[P]+"|"+w[p]+")";var n=g++;w[n]="(?:"+w[k]+"|"+w[p]+")";var o=g++;w[o]="(?:-("+w[y]+"(?:\\."+w[y]+")*))";var a=g++;w[a]="(?:-?("+w[n]+"(?:\\."+w[n]+")*))";var m=g++;w[m]="[0-9A-Za-z-]+";var b=g++;w[b]="(?:\\+("+w[m]+"(?:\\."+w[m]+")*))";var I=g++,t="v?"+w[_]+w[o]+"?"+w[b]+"?";w[I]="^"+t+"$";var r="[v=\\s]*"+w[D]+w[a]+"?"+w[b]+"?",s=g++;w[s]="^"+r+"$";var i=g++;w[i]="((?:<|>)?=?)";var c=g++;w[c]=w[k]+"|x|X|\\*";var u=g++;w[u]=w[P]+"|x|X|\\*";var v=g++;w[v]="[v=\\s]*("+w[u]+")(?:\\.("+w[u]+")(?:\\.("+w[u]+")(?:"+w[o]+")?"+w[b]+"?)?)?";var S=g++;w[S]="[v=\\s]*("+w[c]+")(?:\\.("+w[c]+")(?:\\.("+w[c]+")(?:"+w[a]+")?"+w[b]+"?)?)?";var l=g++;w[l]="^"+w[i]+"\\s*"+w[v]+"$";var h=g++;w[h]="^"+w[i]+"\\s*"+w[S]+"$";var E=g++;w[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=g++;w[R]="(?:~>?)";var M=g++;w[M]="(\\s*)"+w[R]+"\\s+",f[M]=new RegExp(w[M],"g");var U=g++;w[U]="^"+w[R]+w[v]+"$";var F=g++;w[F]="^"+w[R]+w[S]+"$";var x=g++;w[x]="(?:\\^)";var $=g++;w[$]="(\\s*)"+w[x]+"\\s+",f[$]=new RegExp(w[$],"g");var O=g++;w[O]="^"+w[x]+w[v]+"$";var K=g++;w[K]="^"+w[x]+w[S]+"$";var q=g++;w[q]="^"+w[i]+"\\s*("+r+")$|^$";var fe=g++;w[fe]="^"+w[i]+"\\s*("+t+")$|^$";var se=g++;w[se]="(\\s*)"+w[i]+"\\s*("+r+"|"+w[v]+")",f[se]=new RegExp(w[se],"g");var ie=g++;w[ie]="^\\s*("+w[v]+")\\s+-\\s+("+w[v]+")\\s*$";var H=g++;w[H]="^\\s*("+w[S]+")\\s+-\\s+("+w[S]+")\\s*$";var re=g++;w[re]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)d(Ee,w[Ee]),f[Ee]||(f[Ee]=new RegExp(w[Ee]));function ae(Q,ue){if(Q instanceof ne)return Q;if(typeof Q!="string"||Q.length>A||!(ue?f[s]:f[I]).test(Q))return null;try{return new ne(Q,ue)}catch{return null}}function ne(Q,ue){if(Q instanceof ne){if(Q.loose===ue)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof ne))return new ne(Q,ue);d("SemVer",Q,ue),this.loose=ue;var ve=Q.trim().match(ue?f[s]:f[I]);if(!ve)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(xe){if(/^[0-9]+$/.test(xe)){var We=+xe;if(We>=0&&We<T)return We}return xe}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=ae,e.valid=function(Q,ue){var ve=ae(Q,ue);return ve?ve.version:null},e.clean=function(Q,ue){var ve=ae(Q.trim().replace(/^[=v]+/,""),ue);return ve?ve.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(Q){return d("SemVer.compare",this.version,this.loose,Q),Q instanceof ne||(Q=new ne(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},ne.prototype.compareMain=function(Q){return Q instanceof ne||(Q=new ne(Q,this.loose)),N(this.major,Q.major)||N(this.minor,Q.minor)||N(this.patch,Q.patch)},ne.prototype.comparePre=function(Q){if(Q instanceof ne||(Q=new ne(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var ue=0;do{var ve=this.prerelease[ue],xe=Q.prerelease[ue];if(d("prerelease compare",ue,ve,xe),ve===void 0&&xe===void 0)return 0;if(xe===void 0)return 1;if(ve===void 0)return-1;if(ve!==xe)return N(ve,xe)}while(++ue)},ne.prototype.inc=function(Q,ue){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,ue,ve,xe){typeof ve=="string"&&(xe=ve,ve=void 0);try{return new ne(Q,ve).inc(ue,xe).version}catch{return null}},e.diff=function(Q,ue){if(be(Q,ue))return null;var ve=ae(Q),xe=ae(ue);if(ve.prerelease.length||xe.prerelease.length){for(var We in ve)if((We==="major"||We==="minor"||We==="patch")&&ve[We]!==xe[We])return"pre"+We;return"prerelease"}for(var We in ve)if((We==="major"||We==="minor"||We==="patch")&&ve[We]!==xe[We])return We},e.compareIdentifiers=N;var J=/^[0-9]+$/;function N(Q,ue){var ve=J.test(Q),xe=J.test(ue);return ve&&xe&&(Q=+Q,ue=+ue),ve&&!xe?-1:xe&&!ve?1:Q<ue?-1:Q>ue?1:0}function W(Q,ue,ve){return new ne(Q,ve).compare(new ne(ue,ve))}function he(Q,ue,ve){return W(Q,ue,ve)>0}function Se(Q,ue,ve){return W(Q,ue,ve)<0}function be(Q,ue,ve){return W(Q,ue,ve)===0}function we(Q,ue,ve){return W(Q,ue,ve)!==0}function ye(Q,ue,ve){return W(Q,ue,ve)>=0}function V(Q,ue,ve){return W(Q,ue,ve)<=0}function ee(Q,ue,ve,xe){var We;switch(ue){case"===":typeof Q=="object"&&(Q=Q.version),typeof ve=="object"&&(ve=ve.version),We=Q===ve;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof ve=="object"&&(ve=ve.version),We=Q!==ve;break;case"":case"=":case"==":We=be(Q,ve,xe);break;case"!=":We=we(Q,ve,xe);break;case">":We=he(Q,ve,xe);break;case">=":We=ye(Q,ve,xe);break;case"<":We=Se(Q,ve,xe);break;case"<=":We=V(Q,ve,xe);break;default:throw new TypeError("Invalid operator: "+ue)}return We}function G(Q,ue){if(Q instanceof G){if(Q.loose===ue)return Q;Q=Q.value}if(!(this instanceof G))return new G(Q,ue);d("comparator",Q,ue),this.loose=ue,this.parse(Q),this.semver===Y?this.value="":this.value=this.operator+this.semver.version,d("comp",this)}e.rcompareIdentifiers=function(Q,ue){return N(ue,Q)},e.major=function(Q,ue){return new ne(Q,ue).major},e.minor=function(Q,ue){return new ne(Q,ue).minor},e.patch=function(Q,ue){return new ne(Q,ue).patch},e.compare=W,e.compareLoose=function(Q,ue){return W(Q,ue,!0)},e.rcompare=function(Q,ue,ve){return W(ue,Q,ve)},e.sort=function(Q,ue){return Q.sort(function(ve,xe){return e.compare(ve,xe,ue)})},e.rsort=function(Q,ue){return Q.sort(function(ve,xe){return e.rcompare(ve,xe,ue)})},e.gt=he,e.lt=Se,e.eq=be,e.neq=we,e.gte=ye,e.lte=V,e.cmp=ee,e.Comparator=G;var Y={};function de(Q,ue){if(Q instanceof de)return Q.loose===ue?Q:new de(Q.raw,ue);if(Q instanceof G)return new de(Q.value,ue);if(!(this instanceof de))return new de(Q,ue);if(this.loose=ue,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function ke(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function B(Q,ue,ve,xe,We,Ze,Qe,it,et,Pe,Me,ze,Re){return((ue=ke(ve)?"":ke(xe)?">="+ve+".0.0":ke(We)?">="+ve+"."+xe+".0":">="+ue)+" "+(it=ke(et)?"":ke(Pe)?"<"+(+et+1)+".0.0":ke(Me)?"<"+et+"."+(+Pe+1)+".0":ze?"<="+et+"."+Pe+"."+Me+"-"+ze:"<="+it)).trim()}function X(Q,ue){for(var ve=0;ve<Q.length;ve++)if(!Q[ve].test(ue))return!1;if(ue.prerelease.length){for(ve=0;ve<Q.length;ve++)if(d(Q[ve].semver),Q[ve].semver!==Y&&Q[ve].semver.prerelease.length>0){var xe=Q[ve].semver;if(xe.major===ue.major&&xe.minor===ue.minor&&xe.patch===ue.patch)return!0}return!1}return!0}function Z(Q,ue,ve){try{ue=new de(ue,ve)}catch{return!1}return ue.test(Q)}function oe(Q,ue,ve,xe){var We,Ze,Qe,it,et;switch(Q=new ne(Q,xe),ue=new de(ue,xe),ve){case">":We=he,Ze=V,Qe=Se,it=">",et=">=";break;case"<":We=Se,Ze=ye,Qe=he,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Z(Q,ue,xe))return!1;for(var Pe=0;Pe<ue.set.length;++Pe){var Me=ue.set[Pe],ze=null,Re=null;if(Me.forEach(function(Xe){Xe.semver===Y&&(Xe=new G(">=0.0.0")),ze=ze||Xe,Re=Re||Xe,We(Xe.semver,ze.semver,xe)?ze=Xe:Qe(Xe.semver,Re.semver,xe)&&(Re=Xe)}),ze.operator===it||ze.operator===et||(!Re.operator||Re.operator===it)&&Ze(Q,Re.semver)||Re.operator===et&&Qe(Q,Re.semver))return!1}return!0}G.prototype.parse=function(Q){var ue=this.loose?f[q]:f[fe],ve=Q.match(ue);if(!ve)throw new TypeError("Invalid comparator: "+Q);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new ne(ve[2],this.loose):this.semver=Y},G.prototype.toString=function(){return this.value},G.prototype.test=function(Q){return d("Comparator.test",Q,this.loose),this.semver===Y||(typeof Q=="string"&&(Q=new ne(Q,this.loose)),ee(Q,this.operator,this.semver,this.loose))},G.prototype.intersects=function(Q,ue){if(!(Q instanceof G))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new de(Q.value,ue),Z(this.value,ve,ue);if(Q.operator==="")return ve=new de(this.value,ue),Z(Q.semver,ve,ue);var xe=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Ze=this.semver.version===Q.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),it=ee(this.semver,"<",Q.semver,ue)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),et=ee(this.semver,">",Q.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return xe||We||Ze&&Qe||it||et},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(Q){var ue=this.loose;Q=Q.trim(),d("range",Q,ue);var ve=ue?f[H]:f[ie];Q=Q.replace(ve,B),d("hyphen replace",Q),Q=Q.replace(f[se],"$1$2$3"),d("comparator trim",Q,f[se]),Q=(Q=(Q=Q.replace(f[M],"$1~")).replace(f[$],"$1^")).split(/\s+/).join(" ");var xe=ue?f[q]:f[fe],We=Q.split(" ").map(function(Ze){return function(Qe,it){return d("comp",Qe),Qe=function(et,Pe){return et.trim().split(/\s+/).map(function(Me){return function(ze,Re){d("caret",ze,Re);var Xe=Re?f[K]:f[O];return ze.replace(Xe,function(le,ce,Ie,He,Ue){var Ye;return d("caret",ze,le,ce,Ie,He,Ue),ke(ce)?Ye="":ke(Ie)?Ye=">="+ce+".0.0 <"+(+ce+1)+".0.0":ke(He)?Ye=ce==="0"?">="+ce+"."+Ie+".0 <"+ce+"."+(+Ie+1)+".0":">="+ce+"."+Ie+".0 <"+(+ce+1)+".0.0":Ue?(d("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ye=ce==="0"?Ie==="0"?">="+ce+"."+Ie+"."+He+Ue+" <"+ce+"."+Ie+"."+(+He+1):">="+ce+"."+Ie+"."+He+Ue+" <"+ce+"."+(+Ie+1)+".0":">="+ce+"."+Ie+"."+He+Ue+" <"+(+ce+1)+".0.0"):(d("no pr"),Ye=ce==="0"?Ie==="0"?">="+ce+"."+Ie+"."+He+" <"+ce+"."+Ie+"."+(+He+1):">="+ce+"."+Ie+"."+He+" <"+ce+"."+(+Ie+1)+".0":">="+ce+"."+Ie+"."+He+" <"+(+ce+1)+".0.0"),d("caret return",Ye),Ye})}(Me,Pe)}).join(" ")}(Qe,it),d("caret",Qe),Qe=function(et,Pe){return et.trim().split(/\s+/).map(function(Me){return function(ze,Re){var Xe=Re?f[F]:f[U];return ze.replace(Xe,function(le,ce,Ie,He,Ue){var Ye;return d("tilde",ze,le,ce,Ie,He,Ue),ke(ce)?Ye="":ke(Ie)?Ye=">="+ce+".0.0 <"+(+ce+1)+".0.0":ke(He)?Ye=">="+ce+"."+Ie+".0 <"+ce+"."+(+Ie+1)+".0":Ue?(d("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ye=">="+ce+"."+Ie+"."+He+Ue+" <"+ce+"."+(+Ie+1)+".0"):Ye=">="+ce+"."+Ie+"."+He+" <"+ce+"."+(+Ie+1)+".0",d("tilde return",Ye),Ye})}(Me,Pe)}).join(" ")}(Qe,it),d("tildes",Qe),Qe=function(et,Pe){return d("replaceXRanges",et,Pe),et.split(/\s+/).map(function(Me){return function(ze,Re){ze=ze.trim();var Xe=Re?f[h]:f[l];return ze.replace(Xe,function(le,ce,Ie,He,Ue,Ye){d("xRange",ze,le,ce,Ie,He,Ue,Ye);var rt=ke(Ie),ot=rt||ke(He),pt=ot||ke(Ue);return ce==="="&&pt&&(ce=""),rt?le=ce===">"||ce==="<"?"<0.0.0":"*":ce&&pt?(ot&&(He=0),pt&&(Ue=0),ce===">"?(ce=">=",ot?(Ie=+Ie+1,He=0,Ue=0):pt&&(He=+He+1,Ue=0)):ce==="<="&&(ce="<",ot?Ie=+Ie+1:He=+He+1),le=ce+Ie+"."+He+"."+Ue):ot?le=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":pt&&(le=">="+Ie+"."+He+".0 <"+Ie+"."+(+He+1)+".0"),d("xRange return",le),le})}(Me,Pe)}).join(" ")}(Qe,it),d("xrange",Qe),Qe=function(et,Pe){return d("replaceStars",et,Pe),et.trim().replace(f[re],"")}(Qe,it),d("stars",Qe),Qe}(Ze,ue)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(Ze){return!!Ze.match(xe)})),We=We.map(function(Ze){return new G(Ze,ue)})},de.prototype.intersects=function(Q,ue){if(!(Q instanceof de))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(xe){return Q.set.some(function(We){return We.every(function(Ze){return xe.intersects(Ze,ue)})})})})},e.toComparators=function(Q,ue){return new de(Q,ue).set.map(function(ve){return ve.map(function(xe){return xe.value}).join(" ").trim().split(" ")})},de.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new ne(Q,this.loose));for(var ue=0;ue<this.set.length;ue++)if(X(this.set[ue],Q))return!0;return!1},e.satisfies=Z,e.maxSatisfying=function(Q,ue,ve){var xe=null,We=null;try{var Ze=new de(ue,ve)}catch{return null}return Q.forEach(function(Qe){Ze.test(Qe)&&(xe&&We.compare(Qe)!==-1||(We=new ne(xe=Qe,ve)))}),xe},e.minSatisfying=function(Q,ue,ve){var xe=null,We=null;try{var Ze=new de(ue,ve)}catch{return null}return Q.forEach(function(Qe){Ze.test(Qe)&&(xe&&We.compare(Qe)!==1||(We=new ne(xe=Qe,ve)))}),xe},e.validRange=function(Q,ue){try{return new de(Q,ue).range||"*"}catch{return null}},e.ltr=function(Q,ue,ve){return oe(Q,ue,"<",ve)},e.gtr=function(Q,ue,ve){return oe(Q,ue,">",ve)},e.outside=oe,e.prerelease=function(Q,ue){var ve=ae(Q,ue);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(Q,ue,ve){return Q=new de(Q,ve),ue=new de(ue,ve),Q.intersects(ue)},e.coerce=function(Q){if(Q instanceof ne)return Q;if(typeof Q!="string")return null;var ue=Q.match(f[E]);return ue==null?null:ae((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,C(1))},function(me,e){var C,L,d=me.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function f(n){if(C===setTimeout)return setTimeout(n,0);if((C===A||!C)&&setTimeout)return C=setTimeout,setTimeout(n,0);try{return C(n,0)}catch{try{return C.call(null,n,0)}catch{return C.call(this,n,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:A}catch{C=A}try{L=typeof clearTimeout=="function"?clearTimeout:T}catch{L=T}})();var w,g=[],P=!1,k=-1;function p(){P&&w&&(P=!1,w.length?g=w.concat(g):k=-1,g.length&&_())}function _(){if(!P){var n=f(p);P=!0;for(var o=g.length;o;){for(w=g,g=[];++k<o;)w&&w[k].run();k=-1,o=g.length}w=null,P=!1,function(a){if(L===clearTimeout)return clearTimeout(a);if((L===T||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(a);try{L(a)}catch{try{return L.call(null,a)}catch{return L.call(this,a)}}}(n)}}function D(n,o){this.fun=n,this.array=o}function y(){}d.nextTick=function(n){var o=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)o[a-1]=arguments[a];g.push(new D(n,o)),g.length!==1||P||f(_)},D.prototype.run=function(){this.fun.apply(null,this.array)},d.title="browser",d.browser=!0,d.env={},d.argv=[],d.version="",d.versions={},d.on=y,d.addListener=y,d.once=y,d.off=y,d.removeListener=y,d.removeAllListeners=y,d.emit=y,d.prependListener=y,d.prependOnceListener=y,d.listeners=function(n){return[]},d.binding=function(n){throw new Error("process.binding is not supported")},d.cwd=function(){return"/"},d.chdir=function(n){throw new Error("process.chdir is not supported")},d.umask=function(){return 0}}])}),define(Ce[37],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(A){return new L(A)}constructor(A){this._now=C&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=L}),define(Ce[4],De([1,0,8,71,3,72,37]),function(me,e,C,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const f=!1,w=!1;var g;(function(l){l.None=()=>d.Disposable.None;function h(ye){if(w){const{onDidAddListener:V}=ye,ee=D.create();let G=0;ye.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),V?.()}}}function E(ye,V){return q(ye,()=>{},0,void 0,!0,void 0,V)}l.defer=E;function R(ye){return(V,ee=null,G)=>{let Y=!1,de;return de=ye(ke=>{if(!Y)return de?de.dispose():Y=!0,V.call(ee,ke)},null,G),Y&&de.dispose(),de}}l.once=R;function M(ye,V,ee){return K((G,Y=null,de)=>ye(ke=>G.call(Y,V(ke)),null,de),ee)}l.map=M;function U(ye,V,ee){return K((G,Y=null,de)=>ye(ke=>{V(ke),G.call(Y,ke)},null,de),ee)}l.forEach=U;function F(ye,V,ee){return K((G,Y=null,de)=>ye(ke=>V(ke)&&G.call(Y,ke),null,de),ee)}l.filter=F;function x(ye){return ye}l.signal=x;function $(...ye){return(V,ee=null,G)=>(0,d.combinedDisposable)(...ye.map(Y=>Y(de=>V.call(ee,de),null,G)))}l.any=$;function O(ye,V,ee,G){let Y=ee;return M(ye,de=>(Y=V(Y,de),Y),G)}l.reduce=O;function K(ye,V){let ee;const G={onWillAddFirstListener(){ee=ye(Y.fire,Y)},onDidRemoveLastListener(){ee?.dispose()}};V||h(G);const Y=new m(G);return V?.add(Y),Y.event}function q(ye,V,ee=100,G=!1,Y=!1,de,ke){let B,X,Z,oe=0,Q;const ue={leakWarningThreshold:de,onWillAddFirstListener(){B=ye(xe=>{oe++,X=V(X,xe),G&&!Z&&(ve.fire(X),X=void 0),Q=()=>{const We=X;X=void 0,Z=void 0,(!G||oe>1)&&ve.fire(We),oe=0},typeof ee=="number"?(clearTimeout(Z),Z=setTimeout(Q,ee)):Z===void 0&&(Z=0,queueMicrotask(Q))})},onWillRemoveListener(){Y&&oe>0&&Q?.()},onDidRemoveLastListener(){Q=void 0,B.dispose()}};ke||h(ue);const ve=new m(ue);return ke?.add(ve),ve.event}l.debounce=q;function fe(ye,V=0,ee){return l.debounce(ye,(G,Y)=>G?(G.push(Y),G):[Y],V,void 0,!0,void 0,ee)}l.accumulate=fe;function se(ye,V=(G,Y)=>G===Y,ee){let G=!0,Y;return F(ye,de=>{const ke=G||!V(de,Y);return G=!1,Y=de,ke},ee)}l.latch=se;function ie(ye,V,ee){return[l.filter(ye,V,ee),l.filter(ye,G=>!V(G),ee)]}l.split=ie;function H(ye,V=!1,ee=[]){let G=ee.slice(),Y=ye(B=>{G?G.push(B):ke.fire(B)});const de=()=>{G?.forEach(B=>ke.fire(B)),G=null},ke=new m({onWillAddFirstListener(){Y||(Y=ye(B=>ke.fire(B)))},onDidAddFirstListener(){G&&(V?setTimeout(de):de())},onDidRemoveLastListener(){Y&&Y.dispose(),Y=null}});return ke.event}l.buffer=H;class re{constructor(V){this.event=V,this.disposables=new d.DisposableStore}map(V){return new re(M(this.event,V,this.disposables))}forEach(V){return new re(U(this.event,V,this.disposables))}filter(V){return new re(F(this.event,V,this.disposables))}reduce(V,ee){return new re(O(this.event,V,ee,this.disposables))}latch(){return new re(se(this.event,void 0,this.disposables))}debounce(V,ee=100,G=!1,Y=!1,de){return new re(q(this.event,V,ee,G,Y,de,this.disposables))}on(V,ee,G){return this.event(V,ee,G)}once(V,ee,G){return R(this.event)(V,ee,G)}dispose(){this.disposables.dispose()}}function Ee(ye){return new re(ye)}l.chain=Ee;function ae(ye,V,ee=G=>G){const G=(...B)=>ke.fire(ee(...B)),Y=()=>ye.on(V,G),de=()=>ye.removeListener(V,G),ke=new m({onWillAddFirstListener:Y,onDidRemoveLastListener:de});return ke.event}l.fromNodeEventEmitter=ae;function ne(ye,V,ee=G=>G){const G=(...B)=>ke.fire(ee(...B)),Y=()=>ye.addEventListener(V,G),de=()=>ye.removeEventListener(V,G),ke=new m({onWillAddFirstListener:Y,onDidRemoveLastListener:de});return ke.event}l.fromDOMEventEmitter=ne;function J(ye){return new Promise(V=>R(ye)(V))}l.toPromise=J;function N(ye){const V=new m;return ye.then(ee=>{V.fire(ee)},()=>{V.fire(void 0)}).finally(()=>{V.dispose()}),V.event}l.fromPromise=N;function W(ye,V){return V(void 0),ye(ee=>V(ee))}l.runAndSubscribe=W;function he(ye,V){let ee=null;function G(de){ee?.dispose(),ee=new d.DisposableStore,V(de,ee)}G(void 0);const Y=ye(de=>G(de));return(0,d.toDisposable)(()=>{Y.dispose(),ee?.dispose()})}l.runAndSubscribeWithStore=he;class Se{constructor(V,ee){this._observable=V,this._counter=0,this._hasChanged=!1;const G={onWillAddFirstListener:()=>{V.addObserver(this)},onDidRemoveLastListener:()=>{V.removeObserver(this)}};ee||h(G),this.emitter=new m(G),ee&&ee.add(this.emitter)}beginUpdate(V){this._counter++}handlePossibleChange(V){}handleChange(V,ee){this._hasChanged=!0}endUpdate(V){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function be(ye,V){return new Se(ye,V).emitter.event}l.fromObservable=be;function we(ye){return V=>{let ee=0,G=!1;const Y={beginUpdate(){ee++},endUpdate(){ee--,ee===0&&(ye.reportChanges(),G&&(G=!1,V()))},handlePossibleChange(){},handleChange(){G=!0}};return ye.addObserver(Y),ye.reportChanges(),{dispose(){ye.removeObserver(Y)}}}}l.fromObservableLight=we})(g||(e.Event=g={}));class P{static{this.all=new Set}static{this._idPool=0}constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${P._idPool++}`,P.all.add(this)}start(h){this._stopWatch=new T.StopWatch,this.listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=P;let k=-1;function p(l){const h=k;return k=l,{dispose(){k=h}}}e.setGlobalLeakWarningThreshold=p;class _{constructor(h,E=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=E,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(h,E){const R=this.threshold;if(R<=0||E<R)return;this._stacks||(this._stacks=new Map);const M=this._stacks.get(h.value)||0;if(this._stacks.set(h.value,M+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=R*.5;let U,F=0;for(const[x,$]of this._stacks)(!U||F<$)&&(U=x,F=$);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${F}):`),console.warn(U)}return()=>{const U=this._stacks.get(h.value)||0;this._stacks.set(h.value,U-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class n{constructor(h){this.value=h,this.id=y++}}const o=2,a=(l,h)=>{if(l instanceof n)h(l);else for(let E=0;E<l.length;E++){const R=l[E];R&&h(R)}};class m{constructor(h){this._size=0,this._options=h,this._leakageMon=k>0||this._options?.leakWarningThreshold?new _(this._options?.leakWarningThreshold??k):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(f){const h=this._listeners;queueMicrotask(()=>{a(h,E=>E.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(h,E,R)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),d.Disposable.None;if(this._disposed)return d.Disposable.None;E&&(h=h.bind(E));const M=new n(h);let U,F;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(M.stack=D.create(),U=this._leakageMon.check(M.stack,this._size+1)),f&&(M.stack=F??D.create()),this._listeners?this._listeners instanceof n?(this._deliveryQueue??=new I,this._listeners=[this._listeners,M]):this._listeners.push(M):(this._options?.onWillAddFirstListener?.(this),this._listeners=M,this._options?.onDidAddFirstListener?.(this)),this._size++;const x=(0,d.toDisposable)(()=>{U?.(),this._removeListener(M)});return R instanceof d.DisposableStore?R.add(x):Array.isArray(R)&&R.push(x),x},this._event}_removeListener(h){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const E=this._listeners,R=E.indexOf(h);if(R===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,E[R]=void 0;const M=this._deliveryQueue.current===this;if(this._size*o<=E.length){let U=0;for(let F=0;F<E.length;F++)E[F]?E[U++]=E[F]:M&&(this._deliveryQueue.end--,U<this._deliveryQueue.i&&this._deliveryQueue.i--);E.length=U}}_deliver(h,E){if(!h)return;const R=this._options?.onListenerError||C.onUnexpectedError;if(!R){h.value(E);return}try{h.value(E)}catch(M){R(M)}}_deliverQueue(h){const E=h.current._listeners;for(;h.i<h.end;)this._deliver(E[h.i++],h.value);h.reset()}fire(h){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof n)this._deliver(this._listeners,h);else{const E=this._deliveryQueue;E.enqueue(this,h,this._listeners.length),this._deliverQueue(E)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=m;const b=()=>new I;e.createEventDeliveryQueue=b;class I{constructor(){this.i=-1,this.end=0}enqueue(h,E,R){this.i=0,this.end=R,this.current=h,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends m{async fireAsync(h,E,R){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),a(this._listeners,M=>this._asyncDeliveryQueue.push([M.value,h]));this._asyncDeliveryQueue.size>0&&!E.isCancellationRequested;){const[M,U]=this._asyncDeliveryQueue.shift(),F=[],x={...U,token:E,waitUntil:$=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");R&&($=R($,M)),F.push($)}};try{M(x)}catch($){(0,C.onUnexpectedError)($);continue}Object.freeze(F),await Promise.allSettled(F).then($=>{for(const O of $)O.status==="rejected"&&(0,C.onUnexpectedError)(O.reason)})}}}e.AsyncEmitter=t;class r extends m{get isPaused(){return this._isPaused!==0}constructor(h){super(h),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._size&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}e.PauseableEmitter=r;class s extends r{constructor(h){super(h),this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}e.DebounceEmitter=s;class i extends m{constructor(h){super(h),this._queuedEvents=[],this._mergeFn=h?.merge}fire(h){this.hasListeners()&&(this._queuedEvents.push(h),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(E=>super.fire(E)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=i;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const E={event:h,listener:null};this.events.push(E),this.hasListeners&&this.hook(E);const R=()=>{this.hasListeners&&this.unhook(E);const M=this.events.indexOf(E);this.events.splice(M,1)};return(0,d.toDisposable)((0,L.once)(R))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(E=>this.emitter.fire(E))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class u{constructor(h,E,R,M){this._store=new d.DisposableStore;const U=this._store.add(new c),F=this._store.add(new d.DisposableMap);function x($){F.set($,U.add(M($)))}for(const $ of h)x($);this._store.add(E($=>{x($)})),this._store.add(R($=>{F.deleteAndDispose($)})),this.event=U.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=u;class v{constructor(){this.buffers=[]}wrapEvent(h){return(E,R,M)=>h(U=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>E.call(R,U)):E.call(R,U)},void 0,M)}bufferEvents(h){const E=[];this.buffers.push(E);const R=h();return this.buffers.pop(),E.forEach(M=>M()),R}}e.EventBufferer=v;class S{constructor(){this.listening=!1,this.inputEvent=g.None,this.inputEventListener=d.Disposable.None,this.emitter=new m({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(Ce[22],De([1,0,4]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(f,w){const g=setTimeout(f.bind(w),0);return{dispose(){clearTimeout(g)}}});var d;(function(f){function w(g){return g===f.None||g===f.Cancelled||g instanceof A?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}f.isCancellationToken=w,f.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),f.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(d||(e.CancellationToken=d={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new C.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=d.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=d.None}}e.CancellationTokenSource=T}),define(Ce[156],De([1,0,22]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(f){this.task=f,this.result=null}get(){if(this.result)return this.result;const f=new C.CancellationTokenSource,w=this.task(f.token);return this.result={promise:w,dispose:()=>{this.result=null,f.cancel(),f.dispose()}},this.result}}e.Cache=L;class d{constructor(f){this.fn=f,this.lastCache=void 0,this.lastArgKey=void 0}get(f){const w=JSON.stringify(f);return this.lastArgKey!==w&&(this.lastArgKey=w,this.lastCache=this.fn(f)),this.lastCache}}e.LRUCachedFunction=d;class A{get cachedValues(){return this._map}constructor(f){this.fn=f,this._map=new Map}get(f){if(this._map.has(f))return this._map.get(f);const w=this.fn(f);return this._map.set(f,w),w}}e.CachedFunction=A}),define(Ce[96],De([1,0,8,3]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function d(b){const I=b;return I?typeof I.read=="function":!1}e.isReadable=d;function A(b){const I=b;return I?[I.on,I.pause,I.resume,I.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function T(b){const I=b;return I?A(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.isReadableBufferedStream=T;function f(b,I){return new w(b,I)}e.newWriteableStream=f;class w{constructor(I,t){this.reducer=I,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(I){if(!this.state.destroyed){if(this.state.flowing)this.emitData(I);else if(this.buffer.data.push(I),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(I){this.state.destroyed||(this.state.flowing?this.emitError(I):this.buffer.error.push(I))}end(I){this.state.destroyed||(typeof I<"u"&&this.write(I),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(I){this.listeners.data.slice(0).forEach(t=>t(I))}emitError(I){this.listeners.error.length===0?(0,C.onUnexpectedError)(I):this.listeners.error.slice(0).forEach(t=>t(I))}emitEnd(){this.listeners.end.slice(0).forEach(I=>I())}on(I,t){if(!this.state.destroyed)switch(I){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(I,t){if(this.state.destroyed)return;let r;switch(I){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const s=r.indexOf(t);s>=0&&r.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const I=this.reducer(this.buffer.data);this.emitData(I),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const I of this.buffer.error)this.emitError(I);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(b,I){const t=[];let r;for(;(r=b.read())!==null;)t.push(r);return I(t)}e.consumeReadable=g;function P(b,I,t){const r=[];let s;for(;(s=b.read())!==null&&r.length<t;)r.push(s);return s===null&&r.length>0?I(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return b.read()}}}e.peekReadable=P;function k(b,I){return new Promise((t,r)=>{const s=[];p(b,{onData:i=>{I&&s.push(i)},onError:i=>{I?r(i):t(void 0)},onEnd:()=>{t(I?I(s):void 0)}})})}e.consumeStream=k;function p(b,I,t){b.on("error",r=>{t?.isCancellationRequested||I.onError(r)}),b.on("end",()=>{t?.isCancellationRequested||I.onEnd()}),b.on("data",r=>{t?.isCancellationRequested||I.onData(r)})}e.listenStream=p;function _(b,I){return new Promise((t,r)=>{const s=new L.DisposableStore,i=[],c=S=>{if(i.push(S),i.length>I)return s.dispose(),b.pause(),t({stream:b,buffer:i,ended:!1})},u=S=>r(S),v=()=>t({stream:b,buffer:i,ended:!0});s.add((0,L.toDisposable)(()=>b.removeListener("error",u))),b.on("error",u),s.add((0,L.toDisposable)(()=>b.removeListener("end",v))),b.on("end",v),s.add((0,L.toDisposable)(()=>b.removeListener("data",c))),b.on("data",c)})}e.peekStream=_;function D(b,I){const t=f(I);return t.end(b),t}e.toStream=D;function y(){const b=f(()=>{throw new Error("not supported")});return b.end(),b}e.emptyStream=y;function n(b){let I=!1;return{read:()=>I?null:(I=!0,b)}}e.toReadable=n;function o(b,I,t){const r=f(t);return p(b,{onData:s=>r.write(I.data(s)),onError:s=>r.error(I.error?I.error(s):s),onEnd:()=>r.end()}),r}e.transform=o;function a(b,I,t){let r=!1;return{read:()=>{const s=I.read();return r?s:(r=!0,s!==null?t([b,s]):b)}}}e.prefixedReadable=a;function m(b,I,t){let r=!1;const s=f(t);return p(I,{onData:i=>r?s.write(i):(r=!0,s.write(t([b,i]))),onError:i=>s.error(i),onEnd:()=>{r||(r=!0,s.write(b)),s.end()}}),s}e.prefixedStream=m}),define(Ce[21],De([1,0,55,96]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const d=typeof Buffer<"u",A=new C.Lazy(()=>new Uint8Array(256));let T,f;class w{static alloc(E){return d?new w(Buffer.allocUnsafe(E)):new w(new Uint8Array(E))}static wrap(E){return d&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new w(E)}static fromString(E,R){return!(R?.dontUseNodeBuffer||!1)&&d?new w(Buffer.from(E)):(T||(T=new TextEncoder),new w(T.encode(E)))}static fromByteArray(E){const R=w.alloc(E.length);for(let M=0,U=E.length;M<U;M++)R.buffer[M]=E[M];return R}static concat(E,R){if(typeof R>"u"){R=0;for(let F=0,x=E.length;F<x;F++)R+=E[F].byteLength}const M=w.alloc(R);let U=0;for(let F=0,x=E.length;F<x;F++){const $=E[F];M.set($,U),U+=$.byteLength}return M}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=w.alloc(this.byteLength);return E.set(this),E}toString(){return d?this.buffer.toString():(f||(f=new TextDecoder),f.decode(this.buffer))}slice(E,R){return new w(this.buffer.subarray(E,R))}set(E,R){if(E instanceof w)this.buffer.set(E.buffer,R);else if(E instanceof Uint8Array)this.buffer.set(E,R);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),R);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return p(this.buffer,E)}writeUInt32BE(E,R){_(this.buffer,E,R)}readUInt32LE(E){return D(this.buffer,E)}writeUInt32LE(E,R){y(this.buffer,E,R)}readUInt8(E){return n(this.buffer,E)}writeUInt8(E,R){o(this.buffer,E,R)}indexOf(E,R=0){return g(this.buffer,E instanceof w?E.buffer:E,R)}}e.VSBuffer=w;function g(h,E,R=0){const M=E.byteLength,U=h.byteLength;if(M===0)return 0;if(M===1)return h.indexOf(E[0]);if(M>U-R)return-1;const F=A.value;F.fill(E.length);for(let K=0;K<E.length;K++)F[E[K]]=E.length-K-1;let x=R+E.length-1,$=x,O=-1;for(;x<U;)if(h[x]===E[$]){if($===0){O=x;break}x--,$--}else x+=Math.max(E.length-$,F[h[x]]),$=E.length-1;return O}e.binaryIndexOf=g;function P(h,E){return h[E+0]<<0>>>0|h[E+1]<<8>>>0}e.readUInt16LE=P;function k(h,E,R){h[R+0]=E&255,E=E>>>8,h[R+1]=E&255}e.writeUInt16LE=k;function p(h,E){return h[E]*2**24+h[E+1]*2**16+h[E+2]*2**8+h[E+3]}e.readUInt32BE=p;function _(h,E,R){h[R+3]=E,E=E>>>8,h[R+2]=E,E=E>>>8,h[R+1]=E,E=E>>>8,h[R]=E}e.writeUInt32BE=_;function D(h,E){return h[E+0]<<0>>>0|h[E+1]<<8>>>0|h[E+2]<<16>>>0|h[E+3]<<24>>>0}e.readUInt32LE=D;function y(h,E,R){h[R+0]=E&255,E=E>>>8,h[R+1]=E&255,E=E>>>8,h[R+2]=E&255,E=E>>>8,h[R+3]=E&255}e.writeUInt32LE=y;function n(h,E){return h[E]}e.readUInt8=n;function o(h,E,R){h[R]=E}e.writeUInt8=o;function a(h){return L.consumeReadable(h,E=>w.concat(E))}e.readableToBuffer=a;function m(h){return L.toReadable(h)}e.bufferToReadable=m;function b(h){return L.consumeStream(h,E=>w.concat(E))}e.streamToBuffer=b;async function I(h){return h.ended?w.concat(h.buffer):w.concat([...h.buffer,await b(h.stream)])}e.bufferedStreamToBuffer=I;function t(h){return L.toStream(h,E=>w.concat(E))}e.bufferToStream=t;function r(h){return L.transform(h,{data:E=>typeof E=="string"?w.fromString(E):w.wrap(E)},E=>w.concat(E))}e.streamToBufferReadableStream=r;function s(h){return L.newWriteableStream(E=>w.concat(E),h)}e.newWriteableBufferStream=s;function i(h,E){return L.prefixedReadable(h,E,R=>w.concat(R))}e.prefixedBufferReadable=i;function c(h,E){return L.prefixedStream(h,E,R=>w.concat(R))}e.prefixedBufferStream=c;function u(h){let E=0,R=0,M=0;const U=new Uint8Array(Math.floor(h.length/4*3)),F=$=>{switch(R){case 3:U[M++]=E|$,R=0;break;case 2:U[M++]=E|$>>>2,E=$<<6,R=3;break;case 1:U[M++]=E|$>>>4,E=$<<4,R=2;break;default:E=$<<2,R=1}};for(let $=0;$<h.length;$++){const O=h.charCodeAt($);if(O>=65&&O<=90)F(O-65);else if(O>=97&&O<=122)F(O-97+26);else if(O>=48&&O<=57)F(O-48+52);else if(O===43||O===45)F(62);else if(O===47||O===95)F(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${h[$]}`)}}const x=M;for(;R>0;)F(0);return w.wrap(U).slice(0,x)}e.decodeBase64=u;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:h},E=!0,R=!1){const M=R?S:v;let U="";const F=h.byteLength%3;let x=0;for(;x<h.byteLength-F;x+=3){const $=h[x+0],O=h[x+1],K=h[x+2];U+=M[$>>>2],U+=M[($<<4|O>>>4)&63],U+=M[(O<<2|K>>>6)&63],U+=M[K&63]}if(F===1){const $=h[x+0];U+=M[$>>>2],U+=M[$<<4&63],E&&(U+="==")}else if(F===2){const $=h[x+0],O=h[x+1];U+=M[$>>>2],U+=M[($<<4|O>>>4)&63],U+=M[O<<2&63],E&&(U+="=")}return U}e.encodeBase64=l}),define(Ce[15],De([1,0,156,55]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function d(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}e.isFalsyOrWhitespace=d;const A=/{(\d+)}/g;function T(Pe,...Me){return Me.length===0?Pe:Pe.replace(A,function(ze,Re){const Xe=parseInt(Re,10);return isNaN(Xe)||Xe<0||Xe>=Me.length?ze:Me[Xe]})}e.format=T;const f=/{([^}]+)}/g;function w(Pe,Me){return Pe.replace(f,(ze,Re)=>Me[Re]??ze)}e.format2=w;function g(Pe){return Pe.replace(/[<>&]/g,function(Me){switch(Me){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Me}})}e.escape=g;function P(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function k(Pe,Me){let ze=0;const Re=Me.charCodeAt(0);for(let Xe=Pe.length-1;Xe>=0;Xe--)Pe.charCodeAt(Xe)===Re&&ze++;return ze}e.count=k;function p(Pe,Me,ze="\u2026"){return Pe.length<=Me?Pe:`${Pe.substr(0,Me)}${ze}`}e.truncate=p;function _(Pe,Me=" "){const ze=D(Pe,Me);return y(ze,Me)}e.trim=_;function D(Pe,Me){if(!Pe||!Me)return Pe;const ze=Me.length;if(ze===0||Pe.length===0)return Pe;let Re=0;for(;Pe.indexOf(Me,Re)===Re;)Re=Re+ze;return Pe.substring(Re)}e.ltrim=D;function y(Pe,Me){if(!Pe||!Me)return Pe;const ze=Me.length,Re=Pe.length;if(ze===0||Re===0)return Pe;let Xe=Re,le=-1;for(;le=Pe.lastIndexOf(Me,Xe-1),!(le===-1||le+ze!==Xe);){if(le===0)return"";Xe=le}return Pe.substring(0,Xe)}e.rtrim=y;function n(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=n;function o(Pe){return Pe.replace(/\*/g,"")}e.stripWildcards=o;function a(Pe,Me,ze={}){if(!Pe)throw new Error("Cannot create regex from empty string");Me||(Pe=P(Pe)),ze.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Re="";return ze.global&&(Re+="g"),ze.matchCase||(Re+="i"),ze.multiline&&(Re+="m"),ze.unicode&&(Re+="u"),new RegExp(Pe,Re)}e.createRegExp=a;function m(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function b(Pe){return Pe.split(/\r\n|\r|\n/)}e.splitLines=b;function I(Pe){for(let Me=0,ze=Pe.length;Me<ze;Me++){const Re=Pe.charCodeAt(Me);if(Re!==32&&Re!==9)return Me}return-1}e.firstNonWhitespaceIndex=I;function t(Pe,Me=0,ze=Pe.length){for(let Re=Me;Re<ze;Re++){const Xe=Pe.charCodeAt(Re);if(Xe!==32&&Xe!==9)return Pe.substring(Me,Re)}return Pe.substring(Me,ze)}e.getLeadingWhitespace=t;function r(Pe,Me=Pe.length-1){for(let ze=Me;ze>=0;ze--){const Re=Pe.charCodeAt(ze);if(Re!==32&&Re!==9)return ze}return-1}e.lastNonWhitespaceIndex=r;function s(Pe,Me,ze){const Re=[];let Xe=0;for(const le of Pe.matchAll(Me)){if(Re.push(Pe.slice(Xe,le.index)),le.index===void 0)throw new Error("match.index should be defined");Xe=le.index+le[0].length,Re.push(ze(le[0],...le.slice(1),le.index,Pe,le.groups))}return Re.push(Pe.slice(Xe)),Promise.all(Re).then(le=>le.join(""))}e.replaceAsync=s;function i(Pe,Me){return Pe<Me?-1:Pe>Me?1:0}e.compare=i;function c(Pe,Me,ze=0,Re=Pe.length,Xe=0,le=Me.length){for(;ze<Re&&Xe<le;ze++,Xe++){const He=Pe.charCodeAt(ze),Ue=Me.charCodeAt(Xe);if(He<Ue)return-1;if(He>Ue)return 1}const ce=Re-ze,Ie=le-Xe;return ce<Ie?-1:ce>Ie?1:0}e.compareSubstring=c;function u(Pe,Me){return v(Pe,Me,0,Pe.length,0,Me.length)}e.compareIgnoreCase=u;function v(Pe,Me,ze=0,Re=Pe.length,Xe=0,le=Me.length){for(;ze<Re&&Xe<le;ze++,Xe++){let He=Pe.charCodeAt(ze),Ue=Me.charCodeAt(Xe);if(He===Ue)continue;if(He>=128||Ue>=128)return c(Pe.toLowerCase(),Me.toLowerCase(),ze,Re,Xe,le);l(He)&&(He-=32),l(Ue)&&(Ue-=32);const Ye=He-Ue;if(Ye!==0)return Ye}const ce=Re-ze,Ie=le-Xe;return ce<Ie?-1:ce>Ie?1:0}e.compareSubstringIgnoreCase=v;function S(Pe){return Pe>=48&&Pe<=57}e.isAsciiDigit=S;function l(Pe){return Pe>=97&&Pe<=122}e.isLowerAsciiLetter=l;function h(Pe){return Pe>=65&&Pe<=90}e.isUpperAsciiLetter=h;function E(Pe,Me){return Pe.length===Me.length&&v(Pe,Me)===0}e.equalsIgnoreCase=E;function R(Pe,Me){const ze=Me.length;return Me.length>Pe.length?!1:v(Pe,Me,0,ze)===0}e.startsWithIgnoreCase=R;function M(Pe,Me){const ze=Math.min(Pe.length,Me.length);let Re;for(Re=0;Re<ze;Re++)if(Pe.charCodeAt(Re)!==Me.charCodeAt(Re))return Re;return ze}e.commonPrefixLength=M;function U(Pe,Me){const ze=Math.min(Pe.length,Me.length);let Re;const Xe=Pe.length-1,le=Me.length-1;for(Re=0;Re<ze;Re++)if(Pe.charCodeAt(Xe-Re)!==Me.charCodeAt(le-Re))return Re;return ze}e.commonSuffixLength=U;function F(Pe){return 55296<=Pe&&Pe<=56319}e.isHighSurrogate=F;function x(Pe){return 56320<=Pe&&Pe<=57343}e.isLowSurrogate=x;function $(Pe,Me){return(Pe-55296<<10)+(Me-56320)+65536}e.computeCodePoint=$;function O(Pe,Me,ze){const Re=Pe.charCodeAt(ze);if(F(Re)&&ze+1<Me){const Xe=Pe.charCodeAt(ze+1);if(x(Xe))return $(Re,Xe)}return Re}e.getNextCodePoint=O;function K(Pe,Me){const ze=Pe.charCodeAt(Me-1);if(x(ze)&&Me>1){const Re=Pe.charCodeAt(Me-2);if(F(Re))return $(Re,ze)}return ze}class q{get offset(){return this._offset}constructor(Me,ze=0){this._str=Me,this._len=Me.length,this._offset=ze}setOffset(Me){this._offset=Me}prevCodePoint(){const Me=K(this._str,this._offset);return this._offset-=Me>=65536?2:1,Me}nextCodePoint(){const Me=O(this._str,this._len,this._offset);return this._offset+=Me>=65536?2:1,Me}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class fe{get offset(){return this._iterator.offset}constructor(Me,ze=0){this._iterator=new q(Me,ze)}nextGraphemeLength(){const Me=ue.getInstance(),ze=this._iterator,Re=ze.offset;let Xe=Me.getGraphemeBreakType(ze.nextCodePoint());for(;!ze.eol();){const le=ze.offset,ce=Me.getGraphemeBreakType(ze.nextCodePoint());if(oe(Xe,ce)){ze.setOffset(le);break}Xe=ce}return ze.offset-Re}prevGraphemeLength(){const Me=ue.getInstance(),ze=this._iterator,Re=ze.offset;let Xe=Me.getGraphemeBreakType(ze.prevCodePoint());for(;ze.offset>0;){const le=ze.offset,ce=Me.getGraphemeBreakType(ze.prevCodePoint());if(oe(ce,Xe)){ze.setOffset(le);break}Xe=ce}return Re-ze.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=fe;function se(Pe,Me){return new fe(Pe,Me).nextGraphemeLength()}e.nextCharLength=se;function ie(Pe,Me){return new fe(Pe,Me).prevGraphemeLength()}e.prevCharLength=ie;function H(Pe,Me){Me>0&&x(Pe.charCodeAt(Me))&&Me--;const ze=Me+se(Pe,Me);return[ze-ie(Pe,ze),ze]}e.getCharContainingOffset=H;function re(Pe){const Me=new fe(Pe);let ze=0;for(;!Me.eol();)ze++,Me.nextGraphemeLength();return ze}e.charCount=re;let Ee;function ae(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ne(Pe){return Ee||(Ee=ae()),Ee.test(Pe)}e.containsRTL=ne;const J=/^[\t\n\r\x20-\x7E]*$/;function N(Pe){return J.test(Pe)}e.isBasicASCII=N,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function W(Pe){return e.UNUSUAL_LINE_TERMINATORS.test(Pe)}e.containsUnusualLineTerminators=W;function he(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}e.isFullWidthCharacter=he;function Se(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}e.isEmojiImprecise=Se;function be(Pe,Me){if(Pe.length<Me)return Pe;const ze=/\b/g;let Re=0;for(;ze.test(Pe)&&!(Pe.length-ze.lastIndex<Me);)Re=ze.lastIndex,ze.lastIndex+=1;return Pe.substring(Re).replace(/^\s/,"")}e.lcut=be;const we=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ye=/\x1b\].*?\x07/g;function V(Pe){return Pe&&(Pe=Pe.replace(we,"").replace(ye,"")),Pe}e.removeAnsiEscapeCodes=V,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ee(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ee;function G(Pe){return ee(Pe)?Pe.substr(1):Pe}e.stripUTF8BOM=G;function Y(Pe,Me){if(!Pe||!Me||Pe.length<Me.length)return!1;const ze=Me.length,Re=Pe.toLowerCase();let Xe=0,le=-1;for(;Xe<ze;){const ce=Re.indexOf(Me[Xe],le+1);if(ce<0)return!1;le=ce,Xe++}return!0}e.fuzzyContains=Y;function de(Pe,Me=!1){return Pe?(Me&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}e.containsUppercaseCharacter=de;function ke(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}e.uppercaseFirstLetter=ke;function B(Pe,Me=1){if(Me===0)return"";let ze=-1;do ze=Pe.indexOf(`
`,ze+1),Me--;while(Me>0&&ze>=0);return ze===-1?Pe:(Pe[ze-1]==="\r"&&ze--,Pe.substr(0,ze))}e.getNLines=B;function X(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}e.singleLetterHash=X;function Z(Pe){return ue.getInstance().getGraphemeBreakType(Pe)}e.getGraphemeBreakType=Z;function oe(Pe,Me){return Pe===0?Me!==5&&Me!==7:Pe===2&&Me===3?!1:Pe===4||Pe===2||Pe===3||Me===4||Me===2||Me===3?!0:!(Pe===8&&(Me===8||Me===9||Me===11||Me===12)||(Pe===11||Pe===9)&&(Me===9||Me===10)||(Pe===12||Pe===10)&&Me===10||Me===5||Me===13||Me===7||Pe===1||Pe===13&&Me===14||Pe===6&&Me===6)}var Q;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Q||(e.GraphemeBreakType=Q={}));class ue{static{this._INSTANCE=null}static getInstance(){return ue._INSTANCE||(ue._INSTANCE=new ue),ue._INSTANCE}constructor(){this._data=ve()}getGraphemeBreakType(Me){if(Me<32)return Me===10?3:Me===13?2:4;if(Me<127)return 0;const ze=this._data,Re=ze.length/3;let Xe=1;for(;Xe<=Re;)if(Me<ze[3*Xe])Xe=2*Xe;else if(Me>ze[3*Xe+1])Xe=2*Xe+1;else return ze[3*Xe+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(Pe,Me){if(Pe===0)return 0;const ze=We(Pe,Me);if(ze!==void 0)return ze;const Re=new q(Me,Pe);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=xe;function We(Pe,Me){const ze=new q(Me,Pe);let Re=ze.prevCodePoint();for(;Ze(Re)||Re===65039||Re===8419;){if(ze.offset===0)return;Re=ze.prevCodePoint()}if(!Se(Re))return;let Xe=ze.offset;return Xe>0&&ze.prevCodePoint()===8205&&(Xe=ze.offset),Xe}function Ze(Pe){return 127995<=Pe&&Pe<=127999}var Qe;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class it{static{this.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new C.LRUCachedFunction(Me=>{function ze(Ye){const rt=new Map;for(let ot=0;ot<Ye.length;ot+=2)rt.set(Ye[ot],Ye[ot+1]);return rt}function Re(Ye,rt){const ot=new Map(Ye);for(const[pt,It]of rt)ot.set(pt,It);return ot}function Xe(Ye,rt){if(!Ye)return rt;const ot=new Map;for(const[pt,It]of Ye)rt.has(pt)&&ot.set(pt,It);return ot}const le=this.ambiguousCharacterData.value;let ce=Me.filter(Ye=>!Ye.startsWith("_")&&Ye in le);ce.length===0&&(ce=["_default"]);let Ie;for(const Ye of ce){const rt=ze(le[Ye]);Ie=Xe(Ie,rt)}const He=ze(le._common),Ue=Re(He,Ie);return new it(Ue)})}static getInstance(Me){return it.cache.get(Array.from(Me))}static{this._locales=new L.Lazy(()=>Object.keys(it.ambiguousCharacterData.value).filter(Me=>!Me.startsWith("_")))}static getLocales(){return it._locales.value}constructor(Me){this.confusableDictionary=Me}isAmbiguous(Me){return this.confusableDictionary.has(Me)}getPrimaryConfusable(Me){return this.confusableDictionary.get(Me)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=it;class et{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(et.getRawData())),this._data}static isInvisibleCharacter(Me){return et.getData().has(Me)}static get codePoints(){return et.getData()}}e.InvisibleCharacters=et}),define(Ce[119],De([1,0,28,15]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function d(...G){return function(Y,de){for(let ke=0,B=G.length;ke<B;ke++){const X=G[ke](Y,de);if(X)return X}return null}}e.or=d,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(G,Y,de){if(!de||de.length<Y.length)return null;let ke;return G?ke=L.startsWithIgnoreCase(de,Y):ke=de.indexOf(Y)===0,ke?Y.length>0?[{start:0,end:Y.length}]:[]:null}function T(G,Y){const de=Y.toLowerCase().indexOf(G.toLowerCase());return de===-1?null:[{start:de,end:de+G.length}]}e.matchesContiguousSubString=T;function f(G,Y){return w(G.toLowerCase(),Y.toLowerCase(),0,0)}e.matchesSubString=f;function w(G,Y,de,ke){if(de===G.length)return[];if(ke===Y.length)return null;if(G[de]===Y[ke]){let B=null;return(B=w(G,Y,de+1,ke+1))?o({start:ke,end:ke+1},B):null}return w(G,Y,de,ke+1)}function g(G){return 97<=G&&G<=122}function P(G){return 65<=G&&G<=90}e.isUpper=P;function k(G){return 48<=G&&G<=57}function p(G){return G===32||G===9||G===10||G===13}const _=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>_.add(G.charCodeAt(0)));function D(G){return p(G)||_.has(G)}function y(G,Y){return G===Y||D(G)&&D(Y)}function n(G){return g(G)||P(G)||k(G)}function o(G,Y){return Y.length===0?Y=[G]:G.end===Y[0].start?Y[0].start=G.start:Y.unshift(G),Y}function a(G,Y){for(let de=Y;de<G.length;de++){const ke=G.charCodeAt(de);if(P(ke)||k(ke)||de>0&&!n(G.charCodeAt(de-1)))return de}return G.length}function m(G,Y,de,ke){if(de===G.length)return[];if(ke===Y.length)return null;if(G[de]!==Y[ke].toLowerCase())return null;{let B=null,X=ke+1;for(B=m(G,Y,de+1,ke+1);!B&&(X=a(Y,X))<Y.length;)B=m(G,Y,de+1,X),X++;return B===null?null:o({start:ke,end:ke+1},B)}}function b(G){let Y=0,de=0,ke=0,B=0,X=0;for(let ve=0;ve<G.length;ve++)X=G.charCodeAt(ve),P(X)&&Y++,g(X)&&de++,n(X)&&ke++,k(X)&&B++;const Z=Y/G.length,oe=de/G.length,Q=ke/G.length,ue=B/G.length;return{upperPercent:Z,lowerPercent:oe,alphaPercent:Q,numericPercent:ue}}function I(G){const{upperPercent:Y,lowerPercent:de}=G;return de===0&&Y>.6}function t(G){const{upperPercent:Y,lowerPercent:de,alphaPercent:ke,numericPercent:B}=G;return de>.2&&Y<.8&&ke>.6&&B<.2}function r(G){let Y=0,de=0,ke=0,B=0;for(let X=0;X<G.length;X++)ke=G.charCodeAt(X),P(ke)&&Y++,g(ke)&&de++,p(ke)&&B++;return(Y===0||de===0)&&B===0?G.length<=30:Y<=5}function s(G,Y){if(!Y||(Y=Y.trim(),Y.length===0)||!r(G)||Y.length>60)return null;const de=b(Y);if(!t(de)){if(!I(de))return null;Y=Y.toLowerCase()}let ke=null,B=0;for(G=G.toLowerCase();B<Y.length&&(ke=m(G,Y,0,B))===null;)B=a(Y,B+1);return ke}e.matchesCamelCase=s;function i(G,Y,de=!1){if(!Y||Y.length===0)return null;let ke=null,B=0;for(G=G.toLowerCase(),Y=Y.toLowerCase();B<Y.length&&(ke=c(G,Y,0,B,de))===null;)B=u(Y,B+1);return ke}e.matchesWords=i;function c(G,Y,de,ke,B){if(de===G.length)return[];if(ke===Y.length)return null;if(y(G.charCodeAt(de),Y.charCodeAt(ke))){let X=null,Z=ke+1;if(X=c(G,Y,de+1,ke+1,B),!B)for(;!X&&(Z=u(Y,Z))<Y.length;)X=c(G,Y,de+1,Z,B),Z++;return X?G.charCodeAt(de)!==Y.charCodeAt(ke)?X:o({start:ke,end:ke+1},X):null}else return null}function u(G,Y){for(let de=Y;de<G.length;de++)if(D(G.charCodeAt(de))||de>0&&D(G.charCodeAt(de-1)))return de;return G.length}const v=d(e.matchesPrefix,s,T),S=d(e.matchesPrefix,s,f),l=new C.LRUCache(1e4);function h(G,Y,de=!1){if(typeof G!="string"||typeof Y!="string")return null;let ke=l.get(G);ke||(ke=new RegExp(L.convertSimple2RegExpPattern(G),"i"),l.set(G,ke));const B=ke.exec(Y);return B?[{start:B.index,end:B.index+B[0].length}]:de?S(G,Y):v(G,Y)}e.matchesFuzzy=h;function E(G,Y){const de=he(G,G.toLowerCase(),0,Y,Y.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return de?M(de):null}e.matchesFuzzy2=E;function R(G,Y,de,ke,B,X){const Z=Math.min(13,G.length);for(;de<Z;de++){const oe=he(G,Y,de,ke,B,X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,X]}e.anyScore=R;function M(G){if(typeof G>"u")return[];const Y=[],de=G[1];for(let ke=G.length-1;ke>1;ke--){const B=G[ke]+de,X=Y[Y.length-1];X&&X.end===B?X.end=B+1:Y.push({start:B,end:B+1})}return Y}e.createMatches=M;const U=128;function F(){const G=[],Y=[];for(let de=0;de<=U;de++)Y[de]=0;for(let de=0;de<=U;de++)G.push(Y.slice(0));return G}function x(G){const Y=[];for(let de=0;de<=G;de++)Y[de]=0;return Y}const $=x(2*U),O=x(2*U),K=F(),q=F(),fe=F(),se=!1;function ie(G,Y,de,ke,B){function X(oe,Q,ue=" "){for(;oe.length<Q;)oe=ue+oe;return oe}let Z=` |   |${ke.split("").map(oe=>X(oe,3)).join("|")}
`;for(let oe=0;oe<=de;oe++)oe===0?Z+=" |":Z+=`${Y[oe-1]}|`,Z+=G[oe].slice(0,B+1).map(Q=>X(Q.toString(),3)).join("|")+`
`;return Z}function H(G,Y,de,ke){G=G.substr(Y),de=de.substr(ke),console.log(ie(q,G,G.length,de,de.length)),console.log(ie(fe,G,G.length,de,de.length)),console.log(ie(K,G,G.length,de,de.length))}function re(G,Y){if(Y<0||Y>=G.length)return!1;const de=G.codePointAt(Y);switch(de){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(de)}}function Ee(G,Y){if(Y<0||Y>=G.length)return!1;switch(G.charCodeAt(Y)){case 32:case 9:return!0;default:return!1}}function ae(G,Y,de){return Y[G]!==de[G]}function ne(G,Y,de,ke,B,X,Z=!1){for(;Y<de&&B<X;)G[Y]===ke[B]&&(Z&&($[Y]=B),Y+=1),B+=1;return Y===de}e.isPatternInWord=ne;var J;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(J||(J={}));var N;(function(G){G.Default=[-100,0];function Y(de){return!de||de.length===2&&de[0]===-100&&de[1]===0}G.isDefault=Y})(N||(e.FuzzyScore=N={}));class W{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Y,de){this.firstMatchCanBeWeak=Y,this.boostFullMatch=de}}e.FuzzyScoreOptions=W;function he(G,Y,de,ke,B,X,Z=W.default){const oe=G.length>U?U:G.length,Q=ke.length>U?U:ke.length;if(de>=oe||X>=Q||oe-de>Q-X||!ne(Y,de,oe,B,X,Q,!0))return;Se(oe,Q,de,X,Y,B);let ue=1,ve=1,xe=de,We=X;const Ze=[!1];for(ue=1,xe=de;xe<oe;ue++,xe++){const Me=$[xe],ze=O[xe],Re=xe+1<oe?O[xe+1]:Q;for(ve=Me-X+1,We=Me;We<Re;ve++,We++){let Xe=Number.MIN_SAFE_INTEGER,le=!1;We<=ze&&(Xe=be(G,Y,xe,de,ke,B,We,Q,X,K[ue-1][ve-1]===0,Ze));let ce=0;Xe!==Number.MAX_SAFE_INTEGER&&(le=!0,ce=Xe+q[ue-1][ve-1]);const Ie=We>Me,He=Ie?q[ue][ve-1]+(K[ue][ve-1]>0?-5:0):0,Ue=We>Me+1&&K[ue][ve-1]>0,Ye=Ue?q[ue][ve-2]+(K[ue][ve-2]>0?-5:0):0;if(Ue&&(!Ie||Ye>=He)&&(!le||Ye>=ce))q[ue][ve]=Ye,fe[ue][ve]=3,K[ue][ve]=0;else if(Ie&&(!le||He>=ce))q[ue][ve]=He,fe[ue][ve]=2,K[ue][ve]=0;else if(le)q[ue][ve]=ce,fe[ue][ve]=1,K[ue][ve]=K[ue-1][ve-1]+1;else throw new Error("not possible")}}if(se&&H(G,de,ke,X),!Ze[0]&&!Z.firstMatchCanBeWeak)return;ue--,ve--;const Qe=[q[ue][ve],X];let it=0,et=0;for(;ue>=1;){let Me=ve;do{const ze=fe[ue][Me];if(ze===3)Me=Me-2;else if(ze===2)Me=Me-1;else break}while(Me>=1);it>1&&Y[de+ue-1]===B[X+ve-1]&&!ae(Me+X-1,ke,B)&&it+1>K[ue][Me]&&(Me=ve),Me===ve?it++:it=1,et||(et=Me),ue--,ve=Me-1,Qe.push(ve)}Q===oe&&Z.boostFullMatch&&(Qe[0]+=2);const Pe=et-oe;return Qe[0]-=Pe,Qe}e.fuzzyScore=he;function Se(G,Y,de,ke,B,X){let Z=G-1,oe=Y-1;for(;Z>=de&&oe>=ke;)B[Z]===X[oe]&&(O[Z]=oe,Z--),oe--}function be(G,Y,de,ke,B,X,Z,oe,Q,ue,ve){if(Y[de]!==X[Z])return Number.MIN_SAFE_INTEGER;let xe=1,We=!1;return Z===de-ke?xe=G[de]===B[Z]?7:5:ae(Z,B,X)&&(Z===0||!ae(Z-1,B,X))?(xe=G[de]===B[Z]?7:5,We=!0):re(X,Z)&&(Z===0||!re(X,Z-1))?xe=5:(re(X,Z-1)||Ee(X,Z-1))&&(xe=5,We=!0),xe>1&&de===ke&&(ve[0]=!0),We||(We=ae(Z,B,X)||re(X,Z-1)||Ee(X,Z-1)),de===ke?Z>Q&&(xe-=We?3:5):ue?xe+=We?2:0:xe+=We?0:1,Z+1===oe&&(xe-=We?3:5),xe}function we(G,Y,de,ke,B,X,Z){return V(G,Y,de,ke,B,X,!0,Z)}e.fuzzyScoreGracefulAggressive=we;function ye(G,Y,de,ke,B,X,Z){return V(G,Y,de,ke,B,X,!1,Z)}e.fuzzyScoreGraceful=ye;function V(G,Y,de,ke,B,X,Z,oe){let Q=he(G,Y,de,ke,B,X,oe);if(Q&&!Z)return Q;if(G.length>=3){const ue=Math.min(7,G.length-1);for(let ve=de+1;ve<ue;ve++){const xe=ee(G,ve);if(xe){const We=he(xe,xe.toLowerCase(),de,ke,B,X,oe);We&&(We[0]-=3,(!Q||We[0]>Q[0])&&(Q=We))}}}return Q}function ee(G,Y){if(Y+1>=G.length)return;const de=G[Y],ke=G[Y+1];if(de!==ke)return G.slice(0,Y)+ke+de+G.slice(Y+2)}}),define(Ce[74],De([1,0,15]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(o){return d(o,0)}e.hash=L;function d(o,a){switch(typeof o){case"object":return o===null?A(349,a):Array.isArray(o)?w(o,a):g(o,a);case"string":return f(o,a);case"boolean":return T(o,a);case"number":return A(o,a);case"undefined":return A(937,a);default:return A(617,a)}}e.doHash=d;function A(o,a){return(a<<5)-a+o|0}e.numberHash=A;function T(o,a){return A(o?433:863,a)}function f(o,a){a=A(149417,a);for(let m=0,b=o.length;m<b;m++)a=A(o.charCodeAt(m),a);return a}e.stringHash=f;function w(o,a){return a=A(104579,a),o.reduce((m,b)=>d(b,m),a)}function g(o,a){return a=A(181387,a),Object.keys(o).sort().reduce((m,b)=>(m=f(b,m),d(o[b],m)),a)}class P{constructor(){this._value=0}get value(){return this._value}hash(a){return this._value=d(a,this._value),this._value}}e.Hasher=P;var k;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function p(o,a,m=32){const b=m-a,I=~((1<<b)-1);return(o<<a|(I&o)>>>b)>>>0}function _(o,a=0,m=o.byteLength,b=0){for(let I=0;I<m;I++)o[a+I]=b}function D(o,a,m="0"){for(;o.length<a;)o=m+o;return o}function y(o,a=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(m=>m.toString(16).padStart(2,"0")).join(""):D((o>>>0).toString(16),a/4)}e.toHexString=y;class n{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(a){const m=a.length;if(m===0)return;const b=this._buff;let I=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=a.charCodeAt(0),s=0);;){let i=r;if(C.isHighSurrogate(r))if(s+1<m){const c=a.charCodeAt(s+1);C.isLowSurrogate(c)?(s++,i=C.computeCodePoint(r,c)):i=65533}else{t=r;break}else C.isLowSurrogate(r)&&(i=65533);if(I=this._push(b,I,i),s++,s<m)r=a.charCodeAt(s);else break}this._buffLen=I,this._leftoverHighSurrogate=t}_push(a,m,b){return b<128?a[m++]=b:b<2048?(a[m++]=192|(b&1984)>>>6,a[m++]=128|(b&63)>>>0):b<65536?(a[m++]=224|(b&61440)>>>12,a[m++]=128|(b&4032)>>>6,a[m++]=128|(b&63)>>>0):(a[m++]=240|(b&1835008)>>>18,a[m++]=128|(b&258048)>>>12,a[m++]=128|(b&4032)>>>6,a[m++]=128|(b&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,_(this._buff,this._buffLen),this._buffLen>56&&(this._step(),_(this._buff));const a=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(a/4294967296),!1),this._buffDV.setUint32(60,a%4294967296,!1),this._step()}_step(){const a=n._bigBlock32,m=this._buffDV;for(let v=0;v<64;v+=4)a.setUint32(v,m.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)a.setUint32(v,p(a.getUint32(v-12,!1)^a.getUint32(v-32,!1)^a.getUint32(v-56,!1)^a.getUint32(v-64,!1),1),!1);let b=this._h0,I=this._h1,t=this._h2,r=this._h3,s=this._h4,i,c,u;for(let v=0;v<80;v++)v<20?(i=I&t|~I&r,c=1518500249):v<40?(i=I^t^r,c=1859775393):v<60?(i=I&t|I&r|t&r,c=2400959708):(i=I^t^r,c=3395469782),u=p(b,5)+i+s+c+a.getUint32(v*4,!1)&4294967295,s=r,r=t,t=p(I,30),I=b,b=u;this._h0=this._h0+b&4294967295,this._h1=this._h1+I&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=n}),define(Ce[40],De([1,0,15]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(d){d[d.Ignore=0]="Ignore",d[d.Info=1]="Info",d[d.Warning=2]="Warning",d[d.Error=3]="Error"})(L||(L={})),function(d){const A="error",T="warning",f="warn",w="info",g="ignore";function P(p){return p?C.equalsIgnoreCase(A,p)?d.Error:C.equalsIgnoreCase(T,p)||C.equalsIgnoreCase(f,p)?d.Warning:C.equalsIgnoreCase(w,p)?d.Info:d.Ignore:d.Ignore}d.fromValue=P;function k(p){switch(p){case d.Error:return A;case d.Warning:return T;case d.Info:return w;default:return g}}d.toString=k}(L||(L={})),e.default=L}),define(Ce[157],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ce[75],De([1,0,18,15]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class d{constructor(){this._value="",this._pos=0}reset(_){return this._value=_,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(_){const D=_.charCodeAt(0),y=this._value.charCodeAt(this._pos);return D-y}value(){return this._value[this._pos]}}e.StringIterator=d;class A{constructor(_=!0){this._caseSensitive=_}reset(_){return this._value=_,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let _=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(_)this._from++;else break;else _=!1;return this}cmp(_){return this._caseSensitive?(0,L.compareSubstring)(_,this._value,0,_.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(_,this._value,0,_.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class T{constructor(_=!0,D=!0){this._splitOnBackslash=_,this._caseSensitive=D}reset(_){this._from=0,this._to=0,this._value=_,this._valueLen=_.length;for(let D=_.length-1;D>=0;D--,this._valueLen--){const y=this._value.charCodeAt(D);if(!(y===47||this._splitOnBackslash&&y===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let _=!0;for(;this._to<this._valueLen;this._to++){const D=this._value.charCodeAt(this._to);if(D===47||this._splitOnBackslash&&D===92)if(_)this._from++;else break;else _=!1}return this}cmp(_){return this._caseSensitive?(0,L.compareSubstring)(_,this._value,0,_.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(_,this._value,0,_.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var f;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(f||(f={}));class w{constructor(_,D){this._ignorePathCasing=_,this._ignoreQueryAndFragment=D,this._states=[],this._stateIdx=0}reset(_){return this._value=_,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(_)),this._pathIterator.reset(_.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(_)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(_){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(_,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(_,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(_);if(this._states[this._stateIdx]===4)return(0,L.compare)(_,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(_,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=w;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const _=this.right;return this.right=_.left,_.left=this,this.updateHeight(),_.updateHeight(),_}rotateRight(){const _=this.left;return this.left=_.right,_.right=this,this.updateHeight(),_.updateHeight(),_}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(P||(P={}));class k{static forUris(_=()=>!1,D=()=>!1){return new k(new w(_,D))}static forPaths(_=!1){return new k(new T(void 0,!_))}static forStrings(){return new k(new d)}static forConfigKeys(){return new k(new A)}constructor(_){this._iter=_}clear(){this._root=void 0}fill(_,D){if(D){const y=D.slice(0);(0,C.shuffle)(y);for(const n of y)this.set(n,_)}else{const y=_.slice(0);(0,C.shuffle)(y);for(const n of y)this.set(n[0],n[1])}}set(_,D){const y=this._iter.reset(_);let n;this._root||(this._root=new g,this._root.segment=y.value());const o=[];for(n=this._root;;){const m=y.cmp(n.segment);if(m>0)n.left||(n.left=new g,n.left.segment=y.value()),o.push([-1,n]),n=n.left;else if(m<0)n.right||(n.right=new g,n.right.segment=y.value()),o.push([1,n]),n=n.right;else if(y.hasNext())y.next(),n.mid||(n.mid=new g,n.mid.segment=y.value()),o.push([0,n]),n=n.mid;else break}const a=n.value;n.value=D,n.key=_;for(let m=o.length-1;m>=0;m--){const b=o[m][1];b.updateHeight();const I=b.balanceFactor();if(I<-1||I>1){const t=o[m][0],r=o[m+1][0];if(t===1&&r===1)o[m][1]=b.rotateLeft();else if(t===-1&&r===-1)o[m][1]=b.rotateRight();else if(t===1&&r===-1)b.right=o[m+1][1]=o[m+1][1].rotateRight(),o[m][1]=b.rotateLeft();else if(t===-1&&r===1)b.left=o[m+1][1]=o[m+1][1].rotateLeft(),o[m][1]=b.rotateRight();else throw new Error;if(m>0)switch(o[m-1][0]){case-1:o[m-1][1].left=o[m][1];break;case 1:o[m-1][1].right=o[m][1];break;case 0:o[m-1][1].mid=o[m][1];break}else this._root=o[0][1]}}return a}get(_){return this._getNode(_)?.value}_getNode(_){const D=this._iter.reset(_);let y=this._root;for(;y;){const n=D.cmp(y.segment);if(n>0)y=y.left;else if(n<0)y=y.right;else if(D.hasNext())D.next(),y=y.mid;else break}return y}has(_){const D=this._getNode(_);return!(D?.value===void 0&&D?.mid===void 0)}delete(_){return this._delete(_,!1)}deleteSuperstr(_){return this._delete(_,!0)}_delete(_,D){const y=this._iter.reset(_),n=[];let o=this._root;for(;o;){const a=y.cmp(o.segment);if(a>0)n.push([-1,o]),o=o.left;else if(a<0)n.push([1,o]),o=o.right;else if(y.hasNext())y.next(),n.push([0,o]),o=o.mid;else break}if(o){if(D?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const a=this._min(o.right);if(a.key){const{key:m,value:b,segment:I}=a;this._delete(a.key,!1),o.key=m,o.value=b,o.segment=I}}else{const a=o.left??o.right;if(n.length>0){const[m,b]=n[n.length-1];switch(m){case-1:b.left=a;break;case 0:b.mid=a;break;case 1:b.right=a;break}}else this._root=a}for(let a=n.length-1;a>=0;a--){const m=n[a][1];m.updateHeight();const b=m.balanceFactor();if(b>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),n[a][1]=m.rotateLeft()):b<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),n[a][1]=m.rotateRight()),a>0)switch(n[a-1][0]){case-1:n[a-1][1].left=n[a][1];break;case 1:n[a-1][1].right=n[a][1];break;case 0:n[a-1][1].mid=n[a][1];break}else this._root=n[0][1]}}}_min(_){for(;_.left;)_=_.left;return _}findSubstr(_){const D=this._iter.reset(_);let y=this._root,n;for(;y;){const o=D.cmp(y.segment);if(o>0)y=y.left;else if(o<0)y=y.right;else if(D.hasNext())D.next(),n=y.value||n,y=y.mid;else break}return y&&y.value||n}findSuperstr(_){return this._findSuperstrOrElement(_,!1)}_findSuperstrOrElement(_,D){const y=this._iter.reset(_);let n=this._root;for(;n;){const o=y.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(y.hasNext())y.next(),n=n.mid;else return n.mid?this._entries(n.mid):D?n.value:void 0}}hasElementOrSubtree(_){return this._findSuperstrOrElement(_,!0)!==void 0}forEach(_){for(const[D,y]of this)_(y,D)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(_){const D=[];return this._dfsEntries(_,D),D[Symbol.iterator]()}_dfsEntries(_,D){_&&(_.left&&this._dfsEntries(_.left,D),_.value&&D.push([_.key,_.value]),_.mid&&this._dfsEntries(_.mid,D),_.right&&this._dfsEntries(_.right,D))}_isBalanced(){const _=D=>{if(!D)return!0;const y=D.balanceFactor();return y<-1||y>1?!1:_(D.left)&&_(D.right)};return _(this._root)}}e.TernarySearchTree=k}),define(Ce[19],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function C(I){return typeof I=="string"}e.isString=C;function L(I){return Array.isArray(I)&&I.every(t=>C(t))}e.isStringArray=L;function d(I){return typeof I=="object"&&I!==null&&!Array.isArray(I)&&!(I instanceof RegExp)&&!(I instanceof Date)}e.isObject=d;function A(I){const t=Object.getPrototypeOf(Uint8Array);return typeof I=="object"&&I instanceof t}e.isTypedArray=A;function T(I){return typeof I=="number"&&!isNaN(I)}e.isNumber=T;function f(I){return!!I&&typeof I[Symbol.iterator]=="function"}e.isIterable=f;function w(I){return I===!0||I===!1}e.isBoolean=w;function g(I){return typeof I>"u"}e.isUndefined=g;function P(I){return!k(I)}e.isDefined=P;function k(I){return g(I)||I===null}e.isUndefinedOrNull=k;function p(I,t){if(!I)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=p;function _(I){if(k(I))throw new Error("Assertion Failed: argument is undefined or null");return I}e.assertIsDefined=_;function D(...I){const t=[];for(let r=0;r<I.length;r++){const s=I[r];if(k(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(s)}return t}e.assertAllDefined=D;const y=Object.prototype.hasOwnProperty;function n(I){if(!d(I))return!1;for(const t in I)if(y.call(I,t))return!1;return!0}e.isEmptyObject=n;function o(I){return typeof I=="function"}e.isFunction=o;function a(...I){return I.length>0&&I.every(o)}e.areFunctions=a;function m(I,t){const r=Math.min(I.length,t.length);for(let s=0;s<r;s++)b(I[s],t[s])}e.validateConstraints=m;function b(I,t){if(C(t)){if(typeof I!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(I instanceof t)return}catch{}if(!k(I)&&I.constructor===t||t.length===1&&t.call(void 0,I)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=b}),define(Ce[76],De([1,0,19]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function d(f,w){if((0,C.isString)(w)){const g=L[w];if(g===void 0)throw new Error(`${f} references an unknown codicon: ${w}`);w=g}return L[f]=w,{id:f}}function A(){return L}e.getCodiconFontCharacters=A;function T(){return Object.values(e.Codicon)}e.getAllCodicons=T,e.Codicon={add:d("add",6e4),plus:d("plus",6e4),gistNew:d("gist-new",6e4),repoCreate:d("repo-create",6e4),lightbulb:d("lightbulb",60001),lightBulb:d("light-bulb",60001),repo:d("repo",60002),repoDelete:d("repo-delete",60002),gistFork:d("gist-fork",60003),repoForked:d("repo-forked",60003),gitPullRequest:d("git-pull-request",60004),gitPullRequestAbandoned:d("git-pull-request-abandoned",60004),recordKeys:d("record-keys",60005),keyboard:d("keyboard",60005),tag:d("tag",60006),tagAdd:d("tag-add",60006),tagRemove:d("tag-remove",60006),gitPullRequestLabel:d("git-pull-request-label",60006),person:d("person",60007),personFollow:d("person-follow",60007),personOutline:d("person-outline",60007),personFilled:d("person-filled",60007),gitBranch:d("git-branch",60008),gitBranchCreate:d("git-branch-create",60008),gitBranchDelete:d("git-branch-delete",60008),sourceControl:d("source-control",60008),mirror:d("mirror",60009),mirrorPublic:d("mirror-public",60009),star:d("star",60010),starAdd:d("star-add",60010),starDelete:d("star-delete",60010),starEmpty:d("star-empty",60010),comment:d("comment",60011),commentAdd:d("comment-add",60011),alert:d("alert",60012),warning:d("warning",60012),search:d("search",60013),searchSave:d("search-save",60013),logOut:d("log-out",60014),signOut:d("sign-out",60014),logIn:d("log-in",60015),signIn:d("sign-in",60015),eye:d("eye",60016),eyeUnwatch:d("eye-unwatch",60016),eyeWatch:d("eye-watch",60016),circleFilled:d("circle-filled",60017),primitiveDot:d("primitive-dot",60017),closeDirty:d("close-dirty",60017),debugBreakpoint:d("debug-breakpoint",60017),debugBreakpointDisabled:d("debug-breakpoint-disabled",60017),debugHint:d("debug-hint",60017),primitiveSquare:d("primitive-square",60018),edit:d("edit",60019),pencil:d("pencil",60019),info:d("info",60020),issueOpened:d("issue-opened",60020),gistPrivate:d("gist-private",60021),gitForkPrivate:d("git-fork-private",60021),lock:d("lock",60021),mirrorPrivate:d("mirror-private",60021),close:d("close",60022),removeClose:d("remove-close",60022),x:d("x",60022),repoSync:d("repo-sync",60023),sync:d("sync",60023),clone:d("clone",60024),desktopDownload:d("desktop-download",60024),beaker:d("beaker",60025),microscope:d("microscope",60025),vm:d("vm",60026),deviceDesktop:d("device-desktop",60026),file:d("file",60027),fileText:d("file-text",60027),more:d("more",60028),ellipsis:d("ellipsis",60028),kebabHorizontal:d("kebab-horizontal",60028),mailReply:d("mail-reply",60029),reply:d("reply",60029),organization:d("organization",60030),organizationFilled:d("organization-filled",60030),organizationOutline:d("organization-outline",60030),newFile:d("new-file",60031),fileAdd:d("file-add",60031),newFolder:d("new-folder",60032),fileDirectoryCreate:d("file-directory-create",60032),trash:d("trash",60033),trashcan:d("trashcan",60033),history:d("history",60034),clock:d("clock",60034),folder:d("folder",60035),fileDirectory:d("file-directory",60035),symbolFolder:d("symbol-folder",60035),logoGithub:d("logo-github",60036),markGithub:d("mark-github",60036),github:d("github",60036),terminal:d("terminal",60037),console:d("console",60037),repl:d("repl",60037),zap:d("zap",60038),symbolEvent:d("symbol-event",60038),error:d("error",60039),stop:d("stop",60039),variable:d("variable",60040),symbolVariable:d("symbol-variable",60040),array:d("array",60042),symbolArray:d("symbol-array",60042),symbolModule:d("symbol-module",60043),symbolPackage:d("symbol-package",60043),symbolNamespace:d("symbol-namespace",60043),symbolObject:d("symbol-object",60043),symbolMethod:d("symbol-method",60044),symbolFunction:d("symbol-function",60044),symbolConstructor:d("symbol-constructor",60044),symbolBoolean:d("symbol-boolean",60047),symbolNull:d("symbol-null",60047),symbolNumeric:d("symbol-numeric",60048),symbolNumber:d("symbol-number",60048),symbolStructure:d("symbol-structure",60049),symbolStruct:d("symbol-struct",60049),symbolParameter:d("symbol-parameter",60050),symbolTypeParameter:d("symbol-type-parameter",60050),symbolKey:d("symbol-key",60051),symbolText:d("symbol-text",60051),symbolReference:d("symbol-reference",60052),goToFile:d("go-to-file",60052),symbolEnum:d("symbol-enum",60053),symbolValue:d("symbol-value",60053),symbolRuler:d("symbol-ruler",60054),symbolUnit:d("symbol-unit",60054),activateBreakpoints:d("activate-breakpoints",60055),archive:d("archive",60056),arrowBoth:d("arrow-both",60057),arrowDown:d("arrow-down",60058),arrowLeft:d("arrow-left",60059),arrowRight:d("arrow-right",60060),arrowSmallDown:d("arrow-small-down",60061),arrowSmallLeft:d("arrow-small-left",60062),arrowSmallRight:d("arrow-small-right",60063),arrowSmallUp:d("arrow-small-up",60064),arrowUp:d("arrow-up",60065),bell:d("bell",60066),bold:d("bold",60067),book:d("book",60068),bookmark:d("bookmark",60069),debugBreakpointConditionalUnverified:d("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:d("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:d("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:d("debug-breakpoint-data-unverified",60072),debugBreakpointData:d("debug-breakpoint-data",60073),debugBreakpointDataDisabled:d("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:d("debug-breakpoint-log-unverified",60074),debugBreakpointLog:d("debug-breakpoint-log",60075),debugBreakpointLogDisabled:d("debug-breakpoint-log-disabled",60075),briefcase:d("briefcase",60076),broadcast:d("broadcast",60077),browser:d("browser",60078),bug:d("bug",60079),calendar:d("calendar",60080),caseSensitive:d("case-sensitive",60081),check:d("check",60082),checklist:d("checklist",60083),chevronDown:d("chevron-down",60084),dropDownButton:d("drop-down-button",60084),chevronLeft:d("chevron-left",60085),chevronRight:d("chevron-right",60086),chevronUp:d("chevron-up",60087),chromeClose:d("chrome-close",60088),chromeMaximize:d("chrome-maximize",60089),chromeMinimize:d("chrome-minimize",60090),chromeRestore:d("chrome-restore",60091),circle:d("circle",60092),circleOutline:d("circle-outline",60092),debugBreakpointUnverified:d("debug-breakpoint-unverified",60092),circleSlash:d("circle-slash",60093),circuitBoard:d("circuit-board",60094),clearAll:d("clear-all",60095),clippy:d("clippy",60096),closeAll:d("close-all",60097),cloudDownload:d("cloud-download",60098),cloudUpload:d("cloud-upload",60099),code:d("code",60100),collapseAll:d("collapse-all",60101),colorMode:d("color-mode",60102),commentDiscussion:d("comment-discussion",60103),compareChanges:d("compare-changes",60157),creditCard:d("credit-card",60105),dash:d("dash",60108),dashboard:d("dashboard",60109),database:d("database",60110),debugContinue:d("debug-continue",60111),debugDisconnect:d("debug-disconnect",60112),debugPause:d("debug-pause",60113),debugRestart:d("debug-restart",60114),debugStart:d("debug-start",60115),debugStepInto:d("debug-step-into",60116),debugStepOut:d("debug-step-out",60117),debugStepOver:d("debug-step-over",60118),debugStop:d("debug-stop",60119),debug:d("debug",60120),deviceCameraVideo:d("device-camera-video",60121),deviceCamera:d("device-camera",60122),deviceMobile:d("device-mobile",60123),diffAdded:d("diff-added",60124),diffIgnored:d("diff-ignored",60125),diffModified:d("diff-modified",60126),diffRemoved:d("diff-removed",60127),diffRenamed:d("diff-renamed",60128),diff:d("diff",60129),discard:d("discard",60130),editorLayout:d("editor-layout",60131),emptyWindow:d("empty-window",60132),exclude:d("exclude",60133),extensions:d("extensions",60134),eyeClosed:d("eye-closed",60135),fileBinary:d("file-binary",60136),fileCode:d("file-code",60137),fileMedia:d("file-media",60138),filePdf:d("file-pdf",60139),fileSubmodule:d("file-submodule",60140),fileSymlinkDirectory:d("file-symlink-directory",60141),fileSymlinkFile:d("file-symlink-file",60142),fileZip:d("file-zip",60143),files:d("files",60144),filter:d("filter",60145),flame:d("flame",60146),foldDown:d("fold-down",60147),foldUp:d("fold-up",60148),fold:d("fold",60149),folderActive:d("folder-active",60150),folderOpened:d("folder-opened",60151),gear:d("gear",60152),gift:d("gift",60153),gistSecret:d("gist-secret",60154),gist:d("gist",60155),gitCommit:d("git-commit",60156),gitCompare:d("git-compare",60157),gitMerge:d("git-merge",60158),githubAction:d("github-action",60159),githubAlt:d("github-alt",60160),globe:d("globe",60161),grabber:d("grabber",60162),graph:d("graph",60163),gripper:d("gripper",60164),heart:d("heart",60165),home:d("home",60166),horizontalRule:d("horizontal-rule",60167),hubot:d("hubot",60168),inbox:d("inbox",60169),issueClosed:d("issue-closed",60324),issueReopened:d("issue-reopened",60171),issues:d("issues",60172),italic:d("italic",60173),jersey:d("jersey",60174),json:d("json",60175),bracket:d("bracket",60175),kebabVertical:d("kebab-vertical",60176),key:d("key",60177),law:d("law",60178),lightbulbAutofix:d("lightbulb-autofix",60179),linkExternal:d("link-external",60180),link:d("link",60181),listOrdered:d("list-ordered",60182),listUnordered:d("list-unordered",60183),liveShare:d("live-share",60184),loading:d("loading",60185),location:d("location",60186),mailRead:d("mail-read",60187),mail:d("mail",60188),markdown:d("markdown",60189),megaphone:d("megaphone",60190),mention:d("mention",60191),milestone:d("milestone",60192),gitPullRequestMilestone:d("git-pull-request-milestone",60192),mortarBoard:d("mortar-board",60193),move:d("move",60194),multipleWindows:d("multiple-windows",60195),mute:d("mute",60196),noNewline:d("no-newline",60197),note:d("note",60198),octoface:d("octoface",60199),openPreview:d("open-preview",60200),package_:d("package",60201),paintcan:d("paintcan",60202),pin:d("pin",60203),play:d("play",60204),run:d("run",60204),plug:d("plug",60205),preserveCase:d("preserve-case",60206),preview:d("preview",60207),project:d("project",60208),pulse:d("pulse",60209),question:d("question",60210),quote:d("quote",60211),radioTower:d("radio-tower",60212),reactions:d("reactions",60213),references:d("references",60214),refresh:d("refresh",60215),regex:d("regex",60216),remoteExplorer:d("remote-explorer",60217),remote:d("remote",60218),remove:d("remove",60219),replaceAll:d("replace-all",60220),replace:d("replace",60221),repoClone:d("repo-clone",60222),repoForcePush:d("repo-force-push",60223),repoPull:d("repo-pull",60224),repoPush:d("repo-push",60225),report:d("report",60226),requestChanges:d("request-changes",60227),rocket:d("rocket",60228),rootFolderOpened:d("root-folder-opened",60229),rootFolder:d("root-folder",60230),rss:d("rss",60231),ruby:d("ruby",60232),saveAll:d("save-all",60233),saveAs:d("save-as",60234),save:d("save",60235),screenFull:d("screen-full",60236),screenNormal:d("screen-normal",60237),searchStop:d("search-stop",60238),server:d("server",60240),settingsGear:d("settings-gear",60241),settings:d("settings",60242),shield:d("shield",60243),smiley:d("smiley",60244),sortPrecedence:d("sort-precedence",60245),splitHorizontal:d("split-horizontal",60246),splitVertical:d("split-vertical",60247),squirrel:d("squirrel",60248),starFull:d("star-full",60249),starHalf:d("star-half",60250),symbolClass:d("symbol-class",60251),symbolColor:d("symbol-color",60252),symbolCustomColor:d("symbol-customcolor",60252),symbolConstant:d("symbol-constant",60253),symbolEnumMember:d("symbol-enum-member",60254),symbolField:d("symbol-field",60255),symbolFile:d("symbol-file",60256),symbolInterface:d("symbol-interface",60257),symbolKeyword:d("symbol-keyword",60258),symbolMisc:d("symbol-misc",60259),symbolOperator:d("symbol-operator",60260),symbolProperty:d("symbol-property",60261),wrench:d("wrench",60261),wrenchSubaction:d("wrench-subaction",60261),symbolSnippet:d("symbol-snippet",60262),tasklist:d("tasklist",60263),telescope:d("telescope",60264),textSize:d("text-size",60265),threeBars:d("three-bars",60266),thumbsdown:d("thumbsdown",60267),thumbsup:d("thumbsup",60268),tools:d("tools",60269),triangleDown:d("triangle-down",60270),triangleLeft:d("triangle-left",60271),triangleRight:d("triangle-right",60272),triangleUp:d("triangle-up",60273),twitter:d("twitter",60274),unfold:d("unfold",60275),unlock:d("unlock",60276),unmute:d("unmute",60277),unverified:d("unverified",60278),verified:d("verified",60279),versions:d("versions",60280),vmActive:d("vm-active",60281),vmOutline:d("vm-outline",60282),vmRunning:d("vm-running",60283),watch:d("watch",60284),whitespace:d("whitespace",60285),wholeWord:d("whole-word",60286),window:d("window",60287),wordWrap:d("word-wrap",60288),zoomIn:d("zoom-in",60289),zoomOut:d("zoom-out",60290),listFilter:d("list-filter",60291),listFlat:d("list-flat",60292),listSelection:d("list-selection",60293),selection:d("selection",60293),listTree:d("list-tree",60294),debugBreakpointFunctionUnverified:d("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:d("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:d("debug-breakpoint-function-disabled",60296),debugStackframeActive:d("debug-stackframe-active",60297),circleSmallFilled:d("circle-small-filled",60298),debugStackframeDot:d("debug-stackframe-dot",60298),debugStackframe:d("debug-stackframe",60299),debugStackframeFocused:d("debug-stackframe-focused",60299),debugBreakpointUnsupported:d("debug-breakpoint-unsupported",60300),symbolString:d("symbol-string",60301),debugReverseContinue:d("debug-reverse-continue",60302),debugStepBack:d("debug-step-back",60303),debugRestartFrame:d("debug-restart-frame",60304),callIncoming:d("call-incoming",60306),callOutgoing:d("call-outgoing",60307),menu:d("menu",60308),expandAll:d("expand-all",60309),feedback:d("feedback",60310),gitPullRequestReviewer:d("git-pull-request-reviewer",60310),groupByRefType:d("group-by-ref-type",60311),ungroupByRefType:d("ungroup-by-ref-type",60312),account:d("account",60313),gitPullRequestAssignee:d("git-pull-request-assignee",60313),bellDot:d("bell-dot",60314),debugConsole:d("debug-console",60315),library:d("library",60316),output:d("output",60317),runAll:d("run-all",60318),syncIgnored:d("sync-ignored",60319),pinned:d("pinned",60320),githubInverted:d("github-inverted",60321),debugAlt:d("debug-alt",60305),serverProcess:d("server-process",60322),serverEnvironment:d("server-environment",60323),pass:d("pass",60324),stopCircle:d("stop-circle",60325),playCircle:d("play-circle",60326),record:d("record",60327),debugAltSmall:d("debug-alt-small",60328),vmConnect:d("vm-connect",60329),cloud:d("cloud",60330),merge:d("merge",60331),exportIcon:d("export",60332),graphLeft:d("graph-left",60333),magnet:d("magnet",60334),notebook:d("notebook",60335),redo:d("redo",60336),checkAll:d("check-all",60337),pinnedDirty:d("pinned-dirty",60338),passFilled:d("pass-filled",60339),circleLargeFilled:d("circle-large-filled",60340),circleLarge:d("circle-large",60341),circleLargeOutline:d("circle-large-outline",60341),combine:d("combine",60342),gather:d("gather",60342),table:d("table",60343),variableGroup:d("variable-group",60344),typeHierarchy:d("type-hierarchy",60345),typeHierarchySub:d("type-hierarchy-sub",60346),typeHierarchySuper:d("type-hierarchy-super",60347),gitPullRequestCreate:d("git-pull-request-create",60348),runAbove:d("run-above",60349),runBelow:d("run-below",60350),notebookTemplate:d("notebook-template",60351),debugRerun:d("debug-rerun",60352),workspaceTrusted:d("workspace-trusted",60353),workspaceUntrusted:d("workspace-untrusted",60354),workspaceUnspecified:d("workspace-unspecified",60355),terminalCmd:d("terminal-cmd",60356),terminalDebian:d("terminal-debian",60357),terminalLinux:d("terminal-linux",60358),terminalPowershell:d("terminal-powershell",60359),terminalTmux:d("terminal-tmux",60360),terminalUbuntu:d("terminal-ubuntu",60361),terminalBash:d("terminal-bash",60362),arrowSwap:d("arrow-swap",60363),copy:d("copy",60364),personAdd:d("person-add",60365),filterFilled:d("filter-filled",60366),wand:d("wand",60367),debugLineByLine:d("debug-line-by-line",60368),inspect:d("inspect",60369),layers:d("layers",60370),layersDot:d("layers-dot",60371),layersActive:d("layers-active",60372),compass:d("compass",60373),compassDot:d("compass-dot",60374),compassActive:d("compass-active",60375),azure:d("azure",60376),issueDraft:d("issue-draft",60377),gitPullRequestClosed:d("git-pull-request-closed",60378),gitPullRequestDraft:d("git-pull-request-draft",60379),debugAll:d("debug-all",60380),debugCoverage:d("debug-coverage",60381),runErrors:d("run-errors",60382),folderLibrary:d("folder-library",60383),debugContinueSmall:d("debug-continue-small",60384),beakerStop:d("beaker-stop",60385),graphLine:d("graph-line",60386),graphScatter:d("graph-scatter",60387),pieChart:d("pie-chart",60388),bracketDot:d("bracket-dot",60389),bracketError:d("bracket-error",60390),lockSmall:d("lock-small",60391),azureDevops:d("azure-devops",60392),verifiedFilled:d("verified-filled",60393),newLine:d("newline",60394),layout:d("layout",60395),layoutActivitybarLeft:d("layout-activitybar-left",60396),layoutActivitybarRight:d("layout-activitybar-right",60397),layoutPanelLeft:d("layout-panel-left",60398),layoutPanelCenter:d("layout-panel-center",60399),layoutPanelJustify:d("layout-panel-justify",60400),layoutPanelRight:d("layout-panel-right",60401),layoutPanel:d("layout-panel",60402),layoutSidebarLeft:d("layout-sidebar-left",60403),layoutSidebarRight:d("layout-sidebar-right",60404),layoutStatusbar:d("layout-statusbar",60405),layoutMenubar:d("layout-menubar",60406),layoutCentered:d("layout-centered",60407),layoutSidebarRightOff:d("layout-sidebar-right-off",60416),layoutPanelOff:d("layout-panel-off",60417),layoutSidebarLeftOff:d("layout-sidebar-left-off",60418),target:d("target",60408),indent:d("indent",60409),recordSmall:d("record-small",60410),errorSmall:d("error-small",60411),arrowCircleDown:d("arrow-circle-down",60412),arrowCircleLeft:d("arrow-circle-left",60413),arrowCircleRight:d("arrow-circle-right",60414),arrowCircleUp:d("arrow-circle-up",60415),heartFilled:d("heart-filled",60420),map:d("map",60421),mapFilled:d("map-filled",60422),circleSmall:d("circle-small",60423),bellSlash:d("bell-slash",60424),bellSlashDot:d("bell-slash-dot",60425),commentUnresolved:d("comment-unresolved",60426),gitPullRequestGoToChanges:d("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:d("git-pull-request-new-changes",60428),searchFuzzy:d("search-fuzzy",60429),commentDraft:d("comment-draft",60430),send:d("send",60431),sparkle:d("sparkle",60432),insert:d("insert",60433),mic:d("mic",60434),dialogError:d("dialog-error","error"),dialogWarning:d("dialog-warning","warning"),dialogInfo:d("dialog-info","info"),dialogClose:d("dialog-close","close"),treeItemExpanded:d("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:d("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:d("tree-filter-on-type-off","list-selection"),treeFilterClear:d("tree-filter-clear","close"),treeItemLoading:d("tree-item-loading","loading"),menuSelection:d("menu-selection","check"),menuSubmenu:d("menu-submenu","chevron-right"),menuBarMore:d("menubar-more","more"),scrollbarButtonLeft:d("scrollbar-button-left","triangle-left"),scrollbarButtonRight:d("scrollbar-button-right","triangle-right"),scrollbarButtonUp:d("scrollbar-button-up","triangle-up"),scrollbarButtonDown:d("scrollbar-button-down","triangle-down"),toolBarMore:d("toolbar-more","more"),quickInputBack:d("quick-input-back","arrow-left")}}),define(Ce[23],De([1,0,19]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const a=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([m,b])=>{a[m]=b&&typeof b=="object"?L(b):b}),a}e.deepClone=L;function d(o){if(!o||typeof o!="object")return o;const a=[o];for(;a.length>0;){const m=a.shift();Object.freeze(m);for(const b in m)if(A.call(m,b)){const I=m[b];typeof I=="object"&&!Object.isFrozen(I)&&!(0,C.isTypedArray)(I)&&a.push(I)}}return o}e.deepFreeze=d;const A=Object.prototype.hasOwnProperty;function T(o,a){return f(o,a,new Set)}e.cloneAndChange=T;function f(o,a,m){if((0,C.isUndefinedOrNull)(o))return o;const b=a(o);if(typeof b<"u")return b;if(Array.isArray(o)){const I=[];for(const t of o)I.push(f(t,a,m));return I}if((0,C.isObject)(o)){if(m.has(o))throw new Error("Cannot clone recursive data-structure");m.add(o);const I={};for(const t in o)A.call(o,t)&&(I[t]=f(o[t],a,m));return m.delete(o),I}return o}function w(o,a,m=!0){return(0,C.isObject)(o)?((0,C.isObject)(a)&&Object.keys(a).forEach(b=>{b in o?m&&((0,C.isObject)(o[b])&&(0,C.isObject)(a[b])?w(o[b],a[b],m):o[b]=a[b]):o[b]=a[b]}),o):a}e.mixin=w;function g(o,a){if(o===a)return!0;if(o==null||a===null||a===void 0||typeof o!=typeof a||typeof o!="object"||Array.isArray(o)!==Array.isArray(a))return!1;let m,b;if(Array.isArray(o)){if(o.length!==a.length)return!1;for(m=0;m<o.length;m++)if(!g(o[m],a[m]))return!1}else{const I=[];for(b in o)I.push(b);I.sort();const t=[];for(b in a)t.push(b);if(t.sort(),!g(I,t))return!1;for(m=0;m<I.length;m++)if(!g(o[I[m]],a[I[m]]))return!1}return!0}e.equals=g;function P(o){const a=new Set;return JSON.stringify(o,(m,b)=>{if((0,C.isObject)(b)||Array.isArray(b)){if(a.has(b))return"[Circular]";a.add(b)}return b})}e.safeStringify=P;function k(o,a){const m=Object.create(null);return!o||!a||Object.keys(a).forEach(I=>{const t=o[I],r=a[I];g(t,r)||(m[I]=r)}),m}e.distinct=k;function p(o,a){const m=a.toLowerCase(),b=Object.keys(o).find(I=>I.toLowerCase()===m);return b?o[b]:o[a]}e.getCaseInsensitive=p;function _(o,a){const m=Object.create(null);for(const[b,I]of Object.entries(o))a(b,I)&&(m[b]=I);return m}e.filter=_;function D(o){let a=[];for(;Object.prototype!==o;)a=a.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return a}e.getAllPropertyNames=D;function y(o){const a=[];for(const m of D(o))typeof o[m]=="function"&&a.push(m);return a}e.getAllMethodNames=y;function n(o,a){const m=I=>function(){const t=Array.prototype.slice.call(arguments,0);return a(I,t)},b={};for(const I of o)b[I]=m(I);return b}e.createProxyObject=n}),define(Ce[56],De([1,0,76]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(T){function f(w){return w&&typeof w=="object"&&typeof w.id=="string"}T.isThemeColor=f})(L||(e.ThemeColor=L={}));function d(T){return{id:T}}e.themeColorFromId=d;var A;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const f=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function w(a){const m=f.exec(a.id);if(!m)return w(C.Codicon.error);const[,b,I]=m,t=["codicon","codicon-"+b];return I&&t.push("codicon-modifier-"+I.substring(1)),t}T.asClassNameArray=w;function g(a){return w(a).join(" ")}T.asClassName=g;function P(a){return"."+w(a).join(".")}T.asCSSSelector=P;function k(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||L.isThemeColor(a.color))}T.isThemeIcon=k;const p=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function _(a){const m=p.exec(a);if(!m)return;const[,b]=m;return{id:b}}T.fromString=_;function D(a){return{id:a}}T.fromId=D;function y(a,m){let b=a.id;const I=b.lastIndexOf("~");return I!==-1&&(b=b.substring(0,I)),m&&(b=`${b}~${m}`),{id:b}}T.modify=y;function n(a){const m=a.id.lastIndexOf("~");if(m!==-1)return a.id.substring(m+1)}T.getModifier=n;function o(a,m){return a.id===m.id&&a.color?.id===m.color?.id}T.isEqual=o})(A||(e.ThemeIcon=A={}))}),define(Ce[158],De([1,0,119,15,56]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",T=new RegExp(`\\$\\(${d.ThemeIcon.iconNameExpression}(?:${d.ThemeIcon.iconModifierExpression})?\\)`,"g"),f=new RegExp(`(\\\\)?${T.source}`,"g");function w(o){return o.replace(f,(a,m)=>m?a:`\\${a}`)}e.escapeIcons=w;const g=new RegExp(`\\\\${T.source}`,"g");function P(o){return o.replace(g,a=>`\\${a}`)}e.markdownEscapeEscapedIcons=P;const k=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function p(o){return o.indexOf(A)===-1?o:o.replace(k,(a,m,b,I)=>b?a:m||I||"")}e.stripIcons=p;function _(o){return o?o.replace(/\$\((.*?)\)/g,(a,m)=>` ${m} `).trim():""}e.getCodiconAriaLabel=_;const D=new RegExp(`\\$\\(${d.ThemeIcon.iconNameCharacter}+\\)`,"g");function y(o){D.lastIndex=0;let a="";const m=[];let b=0;for(;;){const I=D.lastIndex,t=D.exec(o),r=o.substring(I,t?.index);if(r.length>0){a+=r;for(let s=0;s<r.length;s++)m.push(b)}if(!t)break;b+=t[0].length}return{text:a,iconOffsets:m}}e.parseLabelWithIcons=y;function n(o,a,m=!1){const{text:b,iconOffsets:I}=a;if(!I||I.length===0)return(0,C.matchesFuzzy)(o,b,m);const t=(0,L.ltrim)(b," "),r=b.length-t.length,s=(0,C.matchesFuzzy)(o,t,m);if(s)for(const i of s){const c=I[i.start+r]+r;i.start+=c,i.end+=c}return s}e.matchesFuzzyIconAware=n}),define(Ce[120],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var C;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function L(A){return A<0?0:A>255?255:A|0}e.toUint8=L;function d(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=d}),define(Ce[31],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(d){return C.test(d)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let d;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?d=crypto.getRandomValues.bind(crypto):d=function(f){for(let w=0;w<f.length;w++)f[w]=Math.floor(Math.random()*256);return f};const A=new Uint8Array(16),T=[];for(let f=0;f<256;f++)T.push(f.toString(16).padStart(2,"0"));return function(){d(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let w=0,g="";return g+=T[A[w++]],g+=T[A[w++]],g+=T[A[w++]],g+=T[A[w++]],g+="-",g+=T[A[w++]],g+=T[A[w++]],g+="-",g+=T[A[w++]],g+=T[A[w++]],g+="-",g+=T[A[w++]],g+=T[A[w++]],g+="-",g+=T[A[w++]],g+=T[A[w++]],g+=T[A[w++]],g+=T[A[w++]],g+=T[A[w++]],g+=T[A[w++]],g}}()}),define(Ce[159],De([1,0,18,48,31]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function A(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.createStringDataTransferItem=A;function T(k,p,_){const D={id:(0,d.generateUuid)(),name:k,uri:p,data:_};return{asString:async()=>"",asFile:()=>D,value:void 0}}e.createFileDataTransferItem=T;class f{constructor(){this._entries=new Map}get size(){let p=0;for(const _ of this._entries)p++;return p}has(p){return this._entries.has(this.toKey(p))}matches(p){const _=[...this._entries.keys()];return L.Iterable.some(this,([D,y])=>y.asFile())&&_.push("files"),P(w(p),_)}get(p){return this._entries.get(this.toKey(p))?.[0]}append(p,_){const D=this._entries.get(p);D?D.push(_):this._entries.set(this.toKey(p),[_])}replace(p,_){this._entries.set(this.toKey(p),[_])}delete(p){this._entries.delete(this.toKey(p))}*[Symbol.iterator](){for(const[p,_]of this._entries)for(const D of _)yield[p,D]}toKey(p){return w(p)}}e.VSDataTransfer=f;function w(k){return k.toLowerCase()}function g(k,p){return P(w(k),p.map(w))}e.matchesMimeType=g;function P(k,p){if(k==="*/*")return p.length>0;if(p.includes(k))return!0;const _=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!_)return!1;const[D,y,n]=_;return n==="*"?p.some(o=>o.startsWith(y+"/")):!1}e.UriList=Object.freeze({create:k=>(0,C.distinct)(k.map(p=>p.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.UriList.split(k).filter(p=>!p.startsWith("#"))})}),define(Ce[160],De([1,0,57]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(f,w,g,P=1){let k=!1;return new Promise(p=>{const _=setTimeout(()=>{if(!k)return k=!0,p(0)},g);d(f,w,P,D=>{if(!k)return k=!0,clearTimeout(_),p(D)})})}e.findFreePort=L;function d(f,w,g,P){if(w===0)return P(0);const k=new C.Socket;k.once("connect",()=>(T(k),d(f+g,w-1,g,P))),k.once("data",()=>{}),k.once("error",p=>(T(k),p.code!=="ECONNREFUSED"?d(f+g,w-1,g,P):P(f))),k.connect(f,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(f,w,g,P="127.0.0.1"){let k=!1,p,_=1;const D=C.createServer({pauseOnConnect:!0});function y(n,o){k||(k=!0,D.removeAllListeners(),D.close(),p&&clearTimeout(p),o(n))}return new Promise(n=>{p=setTimeout(()=>{y(0,n)},g),D.on("listening",()=>{y(f,n)}),D.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&_<w?(f++,_++,D.listen(f,P)):y(0,n)}),D.on("close",()=>{y(0,n)}),D.listen(f,P)})}e.findFreePortFaster=A;function T(f){try{f.removeAllListeners("connect"),f.removeAllListeners("error"),f.end(),f.destroy(),f.unref()}catch(w){console.error(w)}}}),define(Ce[121],De([1,0,120]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(f){const w=(0,C.toUint8)(f);this._defaultValue=w,this._asciiMap=L._createAsciiMap(w),this._map=new Map}static _createAsciiMap(f){const w=new Uint8Array(256);return w.fill(f),w}set(f,w){const g=(0,C.toUint8)(w);f>=0&&f<256?this._asciiMap[f]=g:this._map.set(f,g)}get(f){return f>=0&&f<256?this._asciiMap[f]:this._map.get(f)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=L;var d;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(d||(d={}));class A{constructor(){this._actual=new L(0)}add(f){this._actual.set(f,1)}has(f){return this._actual.get(f)===1}clear(){return this._actual.clear()}}e.CharacterSet=A}),define(Ce[58],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class C{constructor(d,A){this.lineNumber=d,this.column=A}with(d=this.lineNumber,A=this.column){return d===this.lineNumber&&A===this.column?this:new C(d,A)}delta(d=0,A=0){return this.with(this.lineNumber+d,this.column+A)}equals(d){return C.equals(this,d)}static equals(d,A){return!d&&!A?!0:!!d&&!!A&&d.lineNumber===A.lineNumber&&d.column===A.column}isBefore(d){return C.isBefore(this,d)}static isBefore(d,A){return d.lineNumber<A.lineNumber?!0:A.lineNumber<d.lineNumber?!1:d.column<A.column}isBeforeOrEqual(d){return C.isBeforeOrEqual(this,d)}static isBeforeOrEqual(d,A){return d.lineNumber<A.lineNumber?!0:A.lineNumber<d.lineNumber?!1:d.column<=A.column}static compare(d,A){const T=d.lineNumber|0,f=A.lineNumber|0;if(T===f){const w=d.column|0,g=A.column|0;return w-g}return T-f}clone(){return new C(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(d){return new C(d.lineNumber,d.column)}static isIPosition(d){return d&&typeof d.lineNumber=="number"&&typeof d.column=="number"}}e.Position=C}),define(Ce[34],De([1,0,58]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(A,T,f,w){A>f||A===f&&T>w?(this.startLineNumber=f,this.startColumn=w,this.endLineNumber=A,this.endColumn=T):(this.startLineNumber=A,this.startColumn=T,this.endLineNumber=f,this.endColumn=w)}isEmpty(){return L.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return L.containsPosition(this,A)}static containsPosition(A,T){return!(T.lineNumber<A.startLineNumber||T.lineNumber>A.endLineNumber||T.lineNumber===A.startLineNumber&&T.column<A.startColumn||T.lineNumber===A.endLineNumber&&T.column>A.endColumn)}static strictContainsPosition(A,T){return!(T.lineNumber<A.startLineNumber||T.lineNumber>A.endLineNumber||T.lineNumber===A.startLineNumber&&T.column<=A.startColumn||T.lineNumber===A.endLineNumber&&T.column>=A.endColumn)}containsRange(A){return L.containsRange(this,A)}static containsRange(A,T){return!(T.startLineNumber<A.startLineNumber||T.endLineNumber<A.startLineNumber||T.startLineNumber>A.endLineNumber||T.endLineNumber>A.endLineNumber||T.startLineNumber===A.startLineNumber&&T.startColumn<A.startColumn||T.endLineNumber===A.endLineNumber&&T.endColumn>A.endColumn)}strictContainsRange(A){return L.strictContainsRange(this,A)}static strictContainsRange(A,T){return!(T.startLineNumber<A.startLineNumber||T.endLineNumber<A.startLineNumber||T.startLineNumber>A.endLineNumber||T.endLineNumber>A.endLineNumber||T.startLineNumber===A.startLineNumber&&T.startColumn<=A.startColumn||T.endLineNumber===A.endLineNumber&&T.endColumn>=A.endColumn)}plusRange(A){return L.plusRange(this,A)}static plusRange(A,T){let f,w,g,P;return T.startLineNumber<A.startLineNumber?(f=T.startLineNumber,w=T.startColumn):T.startLineNumber===A.startLineNumber?(f=T.startLineNumber,w=Math.min(T.startColumn,A.startColumn)):(f=A.startLineNumber,w=A.startColumn),T.endLineNumber>A.endLineNumber?(g=T.endLineNumber,P=T.endColumn):T.endLineNumber===A.endLineNumber?(g=T.endLineNumber,P=Math.max(T.endColumn,A.endColumn)):(g=A.endLineNumber,P=A.endColumn),new L(f,w,g,P)}intersectRanges(A){return L.intersectRanges(this,A)}static intersectRanges(A,T){let f=A.startLineNumber,w=A.startColumn,g=A.endLineNumber,P=A.endColumn;const k=T.startLineNumber,p=T.startColumn,_=T.endLineNumber,D=T.endColumn;return f<k?(f=k,w=p):f===k&&(w=Math.max(w,p)),g>_?(g=_,P=D):g===_&&(P=Math.min(P,D)),f>g||f===g&&w>P?null:new L(f,w,g,P)}equalsRange(A){return L.equalsRange(this,A)}static equalsRange(A,T){return!A&&!T?!0:!!A&&!!T&&A.startLineNumber===T.startLineNumber&&A.startColumn===T.startColumn&&A.endLineNumber===T.endLineNumber&&A.endColumn===T.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(A){return new C.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(A){return new C.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,T){return new L(this.startLineNumber,this.startColumn,A,T)}setStartPosition(A,T){return new L(A,T,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(A){return new L(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return L.collapseToEnd(this)}static collapseToEnd(A){return new L(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new L(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,T=A){return new L(A.lineNumber,A.column,T.lineNumber,T.column)}static lift(A){return A?new L(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,T){return!(A.endLineNumber<T.startLineNumber||A.endLineNumber===T.startLineNumber&&A.endColumn<T.startColumn||T.endLineNumber<A.startLineNumber||T.endLineNumber===A.startLineNumber&&T.endColumn<A.startColumn)}static areIntersecting(A,T){return!(A.endLineNumber<T.startLineNumber||A.endLineNumber===T.startLineNumber&&A.endColumn<=T.startColumn||T.endLineNumber<A.startLineNumber||T.endLineNumber===A.startLineNumber&&T.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,T){if(A&&T){const g=A.startLineNumber|0,P=T.startLineNumber|0;if(g===P){const k=A.startColumn|0,p=T.startColumn|0;if(k===p){const _=A.endLineNumber|0,D=T.endLineNumber|0;if(_===D){const y=A.endColumn|0,n=T.endColumn|0;return y-n}return _-D}return k-p}return g-P}return(A?1:0)-(T?1:0)}static compareRangesUsingEnds(A,T){return A.endLineNumber===T.endLineNumber?A.endColumn===T.endColumn?A.startLineNumber===T.startLineNumber?A.startColumn-T.startColumn:A.startLineNumber-T.startLineNumber:A.endColumn-T.endColumn:A.endLineNumber-T.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=L}),define(Ce[161],De([1,0,34]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class L{static insert(A,T){return{range:new C.Range(A.lineNumber,A.column,A.lineNumber,A.column),text:T,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,T){return{range:A,text:T}}static replaceMove(A,T){return{range:A,text:T,forceMoveMarkers:!0}}}e.EditOperation=L}),define(Ce[162],De([1,0,58,34]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var d;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(d||(e.SelectionDirection=d={}));class A extends L.Range{constructor(f,w,g,P){super(f,w,g,P),this.selectionStartLineNumber=f,this.selectionStartColumn=w,this.positionLineNumber=g,this.positionColumn=P}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(f){return A.selectionsEqual(this,f)}static selectionsEqual(f,w){return f.selectionStartLineNumber===w.selectionStartLineNumber&&f.selectionStartColumn===w.selectionStartColumn&&f.positionLineNumber===w.positionLineNumber&&f.positionColumn===w.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(f,w){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,f,w):new A(f,w,this.startLineNumber,this.startColumn)}getPosition(){return new C.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new C.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(f,w){return this.getDirection()===0?new A(f,w,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,f,w)}static fromPositions(f,w=f){return new A(f.lineNumber,f.column,w.lineNumber,w.column)}static fromRange(f,w){return w===0?new A(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):new A(f.endLineNumber,f.endColumn,f.startLineNumber,f.startColumn)}static liftSelection(f){return new A(f.selectionStartLineNumber,f.selectionStartColumn,f.positionLineNumber,f.positionColumn)}static selectionsArrEqual(f,w){if(f&&!w||!f&&w)return!1;if(!f&&!w)return!0;if(f.length!==w.length)return!1;for(let g=0,P=f.length;g<P;g++)if(!this.selectionsEqual(f[g],w[g]))return!1;return!0}static isISelection(f){return f&&typeof f.selectionStartLineNumber=="number"&&typeof f.selectionStartColumn=="number"&&typeof f.positionLineNumber=="number"&&typeof f.positionColumn=="number"}static createWithDirection(f,w,g,P,k){return k===0?new A(f,w,g,P):new A(g,P,f,w)}}e.Selection=A}),define(Ce[163],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[164],De([1,0,121]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class d extends C.CharacterClassifier{constructor(f){super(0);for(let w=0,g=f.length;w<g;w++)this.set(f.charCodeAt(w),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=d;function A(T){const f={};return w=>(f.hasOwnProperty(w)||(f[w]=T(w)),f[w])}e.getMapForWordSeparators=A(T=>new d(T))}),define(Ce[122],De([1,0,48,3,72]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(k=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const _ of e.USUAL_WORD_SEPARATORS)k.indexOf(_)>=0||(p+="\\"+_);return p+="\\s]+)",new RegExp(p,"g")}e.DEFAULT_WORD_REGEXP=A();function T(k){let p=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)p=k;else{let _="g";k.ignoreCase&&(_+="i"),k.multiline&&(_+="m"),k.unicode&&(_+="u"),p=new RegExp(k.source,_)}return p.lastIndex=0,p}e.ensureValidWordDefinition=T;const f=new d.LinkedList;f.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function w(k){const p=f.unshift(k);return(0,L.toDisposable)(p)}e.setDefaultGetWordAtTextConfig=w;function g(k,p,_,D,y){if(y||(y=C.Iterable.first(f)),_.length>y.maxLen){let b=k-y.maxLen/2;return b<0?b=0:D+=b,_=_.substring(b,k+y.maxLen/2),g(k,p,_,D,y)}const n=Date.now(),o=k-1-D;let a=-1,m=null;for(let b=1;!(Date.now()-n>=y.timeBudget);b++){const I=o-y.windowSize*b;p.lastIndex=Math.max(0,I);const t=P(p,_,o,a);if(!t&&m||(m=t,I<=0))break;a=I}if(m){const b={word:m[0],startColumn:D+1+m.index,endColumn:D+1+m.index+m[0].length};return p.lastIndex=0,b}return null}e.getWordAtText=g;function P(k,p,_,D){let y;for(;y=k.exec(p);){const n=y.index||0;if(n<=_&&k.lastIndex>=_)return y;if(D>0&&n>D)return null}return null}}),define(Ce[165],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var C;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class L{constructor(f){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=f.open,this.close=f.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(f.notIn))for(let w=0,g=f.notIn.length;w<g;w++)switch(f.notIn[w]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(f){switch(f){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(f,w){if(f.getTokenCount()===0)return!0;const g=f.findTokenIndexAtOffset(w-2),P=f.getStandardTokenType(g);return this.isOK(P)}_findNeutralCharacterInRange(f,w){for(let g=f;g<=w;g++){const P=String.fromCharCode(g);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=L;class d{constructor(f){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of f)A(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),A(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),A(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),A(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&A(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.AutoClosingPairs=d;function A(T,f,w){T.has(f)?T.get(f).push(w):T.set(f,[w])}}),define(Ce[166],De([1,0,121]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var L;(function(_){_[_.Invalid=0]="Invalid",_[_.Start=1]="Start",_[_.H=2]="H",_[_.HT=3]="HT",_[_.HTT=4]="HTT",_[_.HTTP=5]="HTTP",_[_.F=6]="F",_[_.FI=7]="FI",_[_.FIL=8]="FIL",_[_.BeforeColon=9]="BeforeColon",_[_.AfterColon=10]="AfterColon",_[_.AlmostThere=11]="AlmostThere",_[_.End=12]="End",_[_.Accept=13]="Accept",_[_.LastKnownState=14]="LastKnownState"})(L||(e.State=L={}));class d{constructor(D,y,n){const o=new Uint8Array(D*y);for(let a=0,m=D*y;a<m;a++)o[a]=n;this._data=o,this.rows=D,this.cols=y}get(D,y){return this._data[D*this.cols+y]}set(D,y,n){this._data[D*this.cols+y]=n}}class A{constructor(D){let y=0,n=0;for(let a=0,m=D.length;a<m;a++){const[b,I,t]=D[a];I>y&&(y=I),b>n&&(n=b),t>n&&(n=t)}y++,n++;const o=new d(n,y,0);for(let a=0,m=D.length;a<m;a++){const[b,I,t]=D[a];o.set(b,I,t)}this._states=o,this._maxCharCode=y}nextState(D,y){return y<0||y>=this._maxCharCode?0:this._states.get(D,y)}}e.StateMachine=A;let T=null;function f(){return T===null&&(T=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var w;(function(_){_[_.None=0]="None",_[_.ForceTermination=1]="ForceTermination",_[_.CannotEndIn=2]="CannotEndIn"})(w||(w={}));let g=null;function P(){if(g===null){g=new C.CharacterClassifier(0);const _=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let y=0;y<_.length;y++)g.set(_.charCodeAt(y),1);const D=".,;:";for(let y=0;y<D.length;y++)g.set(D.charCodeAt(y),2)}return g}class k{static _createLink(D,y,n,o,a){let m=a-1;do{const b=y.charCodeAt(m);if(D.get(b)!==2)break;m--}while(m>o);if(o>0){const b=y.charCodeAt(o-1),I=y.charCodeAt(m);(b===40&&I===41||b===91&&I===93||b===123&&I===125)&&m--}return{range:{startLineNumber:n,startColumn:o+1,endLineNumber:n,endColumn:m+2},url:y.substring(o,m+1)}}static computeLinks(D,y=f()){const n=P(),o=[];for(let a=1,m=D.getLineCount();a<=m;a++){const b=D.getLineContent(a),I=b.length;let t=0,r=0,s=0,i=1,c=!1,u=!1,v=!1,S=!1;for(;t<I;){let l=!1;const h=b.charCodeAt(t);if(i===13){let E;switch(h){case 40:c=!0,E=0;break;case 41:E=c?0:1;break;case 91:v=!0,u=!0,E=0;break;case 93:v=!1,E=u?0:1;break;case 123:S=!0,E=0;break;case 125:E=S?0:1;break;case 39:case 34:case 96:s===h?E=1:s===39||s===34||s===96?E=0:E=1;break;case 42:E=s===42?1:0;break;case 124:E=s===124?1:0;break;case 32:E=v?0:1;break;default:E=n.get(h)}E===1&&(o.push(k._createLink(n,b,a,r,t)),l=!0)}else if(i===12){let E;h===91?(u=!0,E=0):E=n.get(h),E===1?l=!0:i=13}else i=y.nextState(i,h),i===0&&(l=!0);l&&(i=1,c=!1,u=!1,S=!1,r=t+1,s=h),t++}i===13&&o.push(k._createLink(n,b,a,r,I))}return o}}e.LinkComputer=k;function p(_){return!_||typeof _.getLineCount!="function"||typeof _.getLineContent!="function"?[]:k.computeLinks(_)}e.computeLinks=p}),define(Ce[123],De([1,0,23]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var L;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(L||(e.OverviewRulerLane=L={}));var d;(function(b){b[b.Left=1]="Left",b[b.Right=2]="Right"})(d||(e.GlyphMarginLane=d={}));var A;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var T;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(T||(e.InjectedTextCursorStops=T={}));var f;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(f||(e.EndOfLinePreference=f={}));var w;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(w||(e.DefaultEndOfLine=w={}));var g;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(g||(e.EndOfLineSequence=g={}));class P{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(I){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,I.tabSize|0),I.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,I.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!I.insertSpaces,this.defaultEOL=I.defaultEOL|0,this.trimAutoWhitespace=!!I.trimAutoWhitespace,this.bracketPairColorizationOptions=I.bracketPairColorizationOptions}equals(I){return this.tabSize===I.tabSize&&this._indentSizeIsTabSize===I._indentSizeIsTabSize&&this.indentSize===I.indentSize&&this.insertSpaces===I.insertSpaces&&this.defaultEOL===I.defaultEOL&&this.trimAutoWhitespace===I.trimAutoWhitespace&&(0,C.equals)(this.bracketPairColorizationOptions,I.bracketPairColorizationOptions)}createChangeEvent(I){return{tabSize:this.tabSize!==I.tabSize,indentSize:this.indentSize!==I.indentSize,insertSpaces:this.insertSpaces!==I.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==I.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class k{constructor(I,t){this._findMatchBrand=void 0,this.range=I,this.matches=t}}e.FindMatch=k;var p;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(p||(e.TrackedRangeStickiness=p={}));function _(b){return b&&typeof b.read=="function"}e.isITextSnapshot=_;var D;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(D||(e.PositionAffinity=D={}));var y;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(y||(e.ModelConstants=y={}));class n{constructor(I,t,r,s,i,c){this.identifier=I,this.range=t,this.text=r,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=i,this._isTracked=c}}e.ValidAnnotatedEditOperation=n;class o{constructor(I,t,r){this.regex=I,this.wordSeparators=t,this.simpleSearch=r}}e.SearchData=o;class a{constructor(I,t,r){this.reverseEdits=I,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.ApplyEditsResult=a;function m(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=m}),define(Ce[167],De([1,0,18,120]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class d{constructor(w){this.values=w,this.prefixSum=new Uint32Array(w.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(w,g){w=(0,L.toUint32)(w);const P=this.values,k=this.prefixSum,p=g.length;return p===0?!1:(this.values=new Uint32Array(P.length+p),this.values.set(P.subarray(0,w),0),this.values.set(P.subarray(w),w+p),this.values.set(g,w),w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(w,g){return w=(0,L.toUint32)(w),g=(0,L.toUint32)(g),this.values[w]===g?!1:(this.values[w]=g,w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),!0)}removeValues(w,g){w=(0,L.toUint32)(w),g=(0,L.toUint32)(g);const P=this.values,k=this.prefixSum;if(w>=P.length)return!1;const p=P.length-w;return g>=p&&(g=p),g===0?!1:(this.values=new Uint32Array(P.length-g),this.values.set(P.subarray(0,w),0),this.values.set(P.subarray(w+g),w),this.prefixSum=new Uint32Array(this.values.length),w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(w){return w<0?0:(w=(0,L.toUint32)(w),this._getPrefixSum(w))}_getPrefixSum(w){if(w<=this.prefixSumValidIndex[0])return this.prefixSum[w];let g=this.prefixSumValidIndex[0]+1;g===0&&(this.prefixSum[0]=this.values[0],g++),w>=this.values.length&&(w=this.values.length-1);for(let P=g;P<=w;P++)this.prefixSum[P]=this.prefixSum[P-1]+this.values[P];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],w),this.prefixSum[w]}getIndexOf(w){w=Math.floor(w),this.getTotalSum();let g=0,P=this.values.length-1,k=0,p=0,_=0;for(;g<=P;)if(k=g+(P-g)/2|0,p=this.prefixSum[k],_=p-this.values[k],w<_)P=k-1;else if(w>=p)g=k+1;else break;return new T(k,w-_)}}e.PrefixSumComputer=d;class A{constructor(w){this._values=w,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(w){return this._ensureValid(),w===0?0:this._prefixSum[w-1]}getIndexOf(w){this._ensureValid();const g=this._indexBySum[w],P=g>0?this._prefixSum[g-1]:0;return new T(g,w-P)}removeValues(w,g){this._values.splice(w,g),this._invalidate(w)}insertValues(w,g){this._values=(0,C.arrayInsert)(this._values,w,g),this._invalidate(w)}_invalidate(w){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,w-1)}_ensureValid(){if(!this._isValid){for(let w=this._validEndIndex+1,g=this._values.length;w<g;w++){const P=this._values[w],k=w>0?this._prefixSum[w-1]:0;this._prefixSum[w]=k+P;for(let p=0;p<P;p++)this._indexBySum[k+p]=w}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(w,g){this._values[w]!==g&&(this._values[w]=g,this._invalidate(w))}}e.ConstantTimePrefixSumComputer=A;class T{constructor(w,g){this.index=w,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=w,this.remainder=g}}e.PrefixSumIndexOfResult=T}),define(Ce[168],De([1,0,15,58,167]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(f,w,g,P){this._uri=f,this._lines=w,this._eol=g,this._versionId=P,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(f){f.eol&&f.eol!==this._eol&&(this._eol=f.eol,this._lineStarts=null);const w=f.changes;for(const g of w)this._acceptDeleteRange(g.range),this._acceptInsertText(new L.Position(g.range.startLineNumber,g.range.startColumn),g.text);this._versionId=f.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const f=this._eol.length,w=this._lines.length,g=new Uint32Array(w);for(let P=0;P<w;P++)g[P]=this._lines[P].length+f;this._lineStarts=new d.PrefixSumComputer(g)}}_setLineText(f,w){this._lines[f]=w,this._lineStarts&&this._lineStarts.setValue(f,this._lines[f].length+this._eol.length)}_acceptDeleteRange(f){if(f.startLineNumber===f.endLineNumber){if(f.startColumn===f.endColumn)return;this._setLineText(f.startLineNumber-1,this._lines[f.startLineNumber-1].substring(0,f.startColumn-1)+this._lines[f.startLineNumber-1].substring(f.endColumn-1));return}this._setLineText(f.startLineNumber-1,this._lines[f.startLineNumber-1].substring(0,f.startColumn-1)+this._lines[f.endLineNumber-1].substring(f.endColumn-1)),this._lines.splice(f.startLineNumber,f.endLineNumber-f.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(f.startLineNumber,f.endLineNumber-f.startLineNumber)}_acceptInsertText(f,w){if(w.length===0)return;const g=(0,C.splitLines)(w);if(g.length===1){this._setLineText(f.lineNumber-1,this._lines[f.lineNumber-1].substring(0,f.column-1)+g[0]+this._lines[f.lineNumber-1].substring(f.column-1));return}g[g.length-1]+=this._lines[f.lineNumber-1].substring(f.column-1),this._setLineText(f.lineNumber-1,this._lines[f.lineNumber-1].substring(0,f.column-1)+g[0]);const P=new Uint32Array(g.length-1);for(let k=1;k<g.length;k++)this._lines.splice(f.lineNumber+k-1,0,g[k]),P[k-1]=g[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(f.lineNumber,P)}}e.MirrorTextModel=A}),define(Ce[169],De([1,0,15,164,58,34,123]),function(me,e,C,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const f=999;class w{constructor(a,m,b,I){this.searchString=a,this.isRegex=m,this.matchCase=b,this.wordSeparators=I}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=g(this.searchString):a=this.searchString.indexOf(`
`)>=0;let m=null;try{m=C.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch{return null}if(!m)return null;let b=!this.isRegex&&!a;return b&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(b=this.matchCase),new T.SearchData(m,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,b?this.searchString:null)}}e.SearchParams=w;function g(o){if(!o||o.length===0)return!1;for(let a=0,m=o.length;a<m;a++){const b=o.charCodeAt(a);if(b===10)return!0;if(b===92){if(a++,a>=m)break;const I=o.charCodeAt(a);if(I===110||I===114||I===87)return!0}}return!1}e.isMultilineRegexSource=g;function P(o,a,m){if(!m)return new T.FindMatch(o,null);const b=[];for(let I=0,t=a.length;I<t;I++)b[I]=a[I];return new T.FindMatch(o,b)}e.createFindMatch=P;class k{constructor(a){const m=[];let b=0;for(let I=0,t=a.length;I<t;I++)a.charCodeAt(I)===10&&(m[b++]=I);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(a){const m=this._lineFeedsOffsets;let b=0,I=m.length-1;if(I===-1||a<=m[0])return 0;for(;b<I;){const t=b+((I-b)/2>>0);m[t]>=a?I=t-1:m[t+1]>=a?(b=t,I=t):b=t+1}return b+1}}class p{static findMatches(a,m,b,I,t){const r=m.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(a,b,new n(r.wordSeparators,r.regex),I,t):this._doFindMatchesLineByLine(a,b,r,I,t):[]}static _getMultilineMatchRange(a,m,b,I,t,r){let s,i=0;I?(i=I.findLineFeedCountBeforeOffset(t),s=m+t+i):s=m+t;let c;if(I){const l=I.findLineFeedCountBeforeOffset(t+r.length)-i;c=s+r.length+l}else c=s+r.length;const u=a.getPositionAt(s),v=a.getPositionAt(c);return new A.Range(u.lineNumber,u.column,v.lineNumber,v.column)}static _doFindMatchesMultiline(a,m,b,I,t){const r=a.getOffsetAt(m.getStartPosition()),s=a.getValueInRange(m,1),i=a.getEOL()===`\r
`?new k(s):null,c=[];let u=0,v;for(b.reset(0);v=b.next(s);)if(c[u++]=P(this._getMultilineMatchRange(a,r,s,i,v.index,v[0]),v,I),u>=t)return c;return c}static _doFindMatchesLineByLine(a,m,b,I,t){const r=[];let s=0;if(m.startLineNumber===m.endLineNumber){const c=a.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return s=this._findMatchesInLine(b,c,m.startLineNumber,m.startColumn-1,s,r,I,t),r}const i=a.getLineContent(m.startLineNumber).substring(m.startColumn-1);s=this._findMatchesInLine(b,i,m.startLineNumber,m.startColumn-1,s,r,I,t);for(let c=m.startLineNumber+1;c<m.endLineNumber&&s<t;c++)s=this._findMatchesInLine(b,a.getLineContent(c),c,0,s,r,I,t);if(s<t){const c=a.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);s=this._findMatchesInLine(b,c,m.endLineNumber,0,s,r,I,t)}return r}static _findMatchesInLine(a,m,b,I,t,r,s,i){const c=a.wordSeparators;if(!s&&a.simpleSearch){const S=a.simpleSearch,l=S.length,h=m.length;let E=-l;for(;(E=m.indexOf(S,E+l))!==-1;)if((!c||y(c,m,h,E,l))&&(r[t++]=new T.FindMatch(new A.Range(b,E+1+I,b,E+1+l+I),null),t>=i))return t;return t}const u=new n(a.wordSeparators,a.regex);let v;u.reset(0);do if(v=u.next(m),v&&(r[t++]=P(new A.Range(b,v.index+1+I,b,v.index+1+v[0].length+I),v,s),t>=i))return t;while(v);return t}static findNextMatch(a,m,b,I){const t=m.parseSearchRequest();if(!t)return null;const r=new n(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindNextMatchMultiline(a,b,r,I):this._doFindNextMatchLineByLine(a,b,r,I)}static _doFindNextMatchMultiline(a,m,b,I){const t=new d.Position(m.lineNumber,1),r=a.getOffsetAt(t),s=a.getLineCount(),i=a.getValueInRange(new A.Range(t.lineNumber,t.column,s,a.getLineMaxColumn(s)),1),c=a.getEOL()===`\r
`?new k(i):null;b.reset(m.column-1);const u=b.next(i);return u?P(this._getMultilineMatchRange(a,r,i,c,u.index,u[0]),u,I):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(a,new d.Position(1,1),b,I):null}static _doFindNextMatchLineByLine(a,m,b,I){const t=a.getLineCount(),r=m.lineNumber,s=a.getLineContent(r),i=this._findFirstMatchInLine(b,s,r,m.column,I);if(i)return i;for(let c=1;c<=t;c++){const u=(r+c-1)%t,v=a.getLineContent(u+1),S=this._findFirstMatchInLine(b,v,u+1,1,I);if(S)return S}return null}static _findFirstMatchInLine(a,m,b,I,t){a.reset(I-1);const r=a.next(m);return r?P(new A.Range(b,r.index+1,b,r.index+1+r[0].length),r,t):null}static findPreviousMatch(a,m,b,I){const t=m.parseSearchRequest();if(!t)return null;const r=new n(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindPreviousMatchMultiline(a,b,r,I):this._doFindPreviousMatchLineByLine(a,b,r,I)}static _doFindPreviousMatchMultiline(a,m,b,I){const t=this._doFindMatchesMultiline(a,new A.Range(1,1,m.lineNumber,m.column),b,I,10*f);if(t.length>0)return t[t.length-1];const r=a.getLineCount();return m.lineNumber!==r||m.column!==a.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(a,new d.Position(r,a.getLineMaxColumn(r)),b,I):null}static _doFindPreviousMatchLineByLine(a,m,b,I){const t=a.getLineCount(),r=m.lineNumber,s=a.getLineContent(r).substring(0,m.column-1),i=this._findLastMatchInLine(b,s,r,I);if(i)return i;for(let c=1;c<=t;c++){const u=(t+r-c-1)%t,v=a.getLineContent(u+1),S=this._findLastMatchInLine(b,v,u+1,I);if(S)return S}return null}static _findLastMatchInLine(a,m,b,I){let t=null,r;for(a.reset(0);r=a.next(m);)t=P(new A.Range(b,r.index+1,b,r.index+1+r[0].length),r,I);return t}}e.TextModelSearch=p;function _(o,a,m,b,I){if(b===0)return!0;const t=a.charCodeAt(b-1);if(o.get(t)!==0||t===13||t===10)return!0;if(I>0){const r=a.charCodeAt(b);if(o.get(r)!==0)return!0}return!1}function D(o,a,m,b,I){if(b+I===m)return!0;const t=a.charCodeAt(b+I);if(o.get(t)!==0||t===13||t===10)return!0;if(I>0){const r=a.charCodeAt(b+I-1);if(o.get(r)!==0)return!0}return!1}function y(o,a,m,b,I){return _(o,a,m,b,I)&&D(o,a,m,b,I)}e.isValidMatch=y;class n{constructor(a,m){this._wordSeparators=a,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const m=a.length;let b;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(b=this._searchRegex.exec(a),!b))return null;const I=b.index,t=b[0].length;if(I===this._prevMatchStartIndex&&t===this._prevMatchLength){if(t===0){C.getNextCodePoint(a,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=I,this._prevMatchLength=t,!this._wordSeparators||y(this._wordSeparators,a,m,I,t))return b}while(b);return null}}e.Searcher=n}),define(Ce[170],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class C{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(A){if(A&&this._dragOperations.has(A)){const T=this._dragOperations.get(A);return this._dragOperations.delete(A),T}}addDragOperationTransfer(A,T){this._dragOperations.set(A,T)}}e.TreeViewsDnDService=C;class L{constructor(A){this.identifier=A}}e.DraggedTreeItemsIdentifier=L}),define(Ce[171],De([1,0,4,3]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class d{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(f){this._onDidChange.fire({changedLanguages:f,changedColorMap:!1})}register(f,w){return this._tokenizationSupports.set(f,w),this.handleChange([f]),(0,L.toDisposable)(()=>{this._tokenizationSupports.get(f)===w&&(this._tokenizationSupports.delete(f),this.handleChange([f]))})}get(f){return this._tokenizationSupports.get(f)||null}registerFactory(f,w){this._factories.get(f)?.dispose();const g=new A(this,f,w);return this._factories.set(f,g),(0,L.toDisposable)(()=>{const P=this._factories.get(f);!P||P!==g||(this._factories.delete(f),P.dispose())})}async getOrCreate(f){const w=this.get(f);if(w)return w;const g=this._factories.get(f);return!g||g.isResolved?null:(await g.resolve(),this.get(f))}isResolved(f){if(this.get(f))return!0;const g=this._factories.get(f);return!!(!g||g.isResolved)}setColorMap(f){this._colorMap=f,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=d;class A extends L.Disposable{get isResolved(){return this._isResolved}constructor(f,w,g){super(),this._registry=f,this._languageId=w,this._factory=g,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const f=await this._factory.tokenizationSupport;this._isResolved=!0,f&&!this._isDisposed&&this._register(this._registry.register(this._languageId,f))}}}),define(Ce[172],De([11,12]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Ce[173],De([1,0,4,3,172]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class A extends L.Disposable{constructor(p,_="",D="",y=!0,n){super(),this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=p,this._label=_,this._cssClass=D,this._enabled=y,this._actionCallback=n}get id(){return this._id}get label(){return this._label}set label(p){this._setLabel(p)}_setLabel(p){this._label!==p&&(this._label=p,this._onDidChange.fire({label:p}))}get tooltip(){return this._tooltip||""}set tooltip(p){this._setTooltip(p)}_setTooltip(p){this._tooltip!==p&&(this._tooltip=p,this._onDidChange.fire({tooltip:p}))}get class(){return this._cssClass}set class(p){this._setClass(p)}_setClass(p){this._cssClass!==p&&(this._cssClass=p,this._onDidChange.fire({class:p}))}get enabled(){return this._enabled}set enabled(p){this._setEnabled(p)}_setEnabled(p){this._enabled!==p&&(this._enabled=p,this._onDidChange.fire({enabled:p}))}get checked(){return this._checked}set checked(p){this._setChecked(p)}_setChecked(p){this._checked!==p&&(this._checked=p,this._onDidChange.fire({checked:p}))}async run(p,_){this._actionCallback&&await this._actionCallback(p)}}e.Action=A;class T extends L.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new C.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new C.Emitter),this.onDidRun=this._onDidRun.event}async run(p,_){if(!p.enabled)return;this._onWillRun.fire({action:p});let D;try{await this.runAction(p,_)}catch(y){D=y}this._onDidRun.fire({action:p,error:D})}async runAction(p,_){await p.run(_)}}e.ActionRunner=T;class f{constructor(){this.id=f.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let _=[];for(const D of p)D.length&&(_.length?_=[..._,new f,...D]:_=D);return _}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=f;class w{get actions(){return this._actions}constructor(p,_,D,y){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=_,this.class=y,this._actions=D}async run(){}}e.SubmenuAction=w;class g extends A{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,d.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=g;function P(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async()=>k.run(),tooltip:k.label}}e.toAction=P}),define(Ce[174],De([11,12]),function(me,e){return me.create("vs/base/common/date",e)}),define(Ce[175],De([1,0,174]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,d=L*60,A=d*24,T=A*7,f=A*30,w=A*365;function g(k,p,_,D){typeof k!="number"&&(k=k.getTime());const y=Math.round((new Date().getTime()-k)/1e3);if(y<-30)return(0,C.localize)(0,null,g(new Date().getTime()+y*1e3,!1));if(!D&&y<30)return(0,C.localize)(1,null);let n;return y<L?(n=y,p?n===1?_?(0,C.localize)(2,null,n):(0,C.localize)(3,null,n):_?(0,C.localize)(4,null,n):(0,C.localize)(5,null,n):n===1?_?(0,C.localize)(6,null,n):(0,C.localize)(7,null,n):_?(0,C.localize)(8,null,n):(0,C.localize)(9,null,n)):y<d?(n=Math.floor(y/L),p?n===1?_?(0,C.localize)(10,null,n):(0,C.localize)(11,null,n):_?(0,C.localize)(12,null,n):(0,C.localize)(13,null,n):n===1?_?(0,C.localize)(14,null,n):(0,C.localize)(15,null,n):_?(0,C.localize)(16,null,n):(0,C.localize)(17,null,n)):y<A?(n=Math.floor(y/d),p?n===1?_?(0,C.localize)(18,null,n):(0,C.localize)(19,null,n):_?(0,C.localize)(20,null,n):(0,C.localize)(21,null,n):n===1?_?(0,C.localize)(22,null,n):(0,C.localize)(23,null,n):_?(0,C.localize)(24,null,n):(0,C.localize)(25,null,n)):y<T?(n=Math.floor(y/A),p?n===1?(0,C.localize)(26,null,n):(0,C.localize)(27,null,n):n===1?(0,C.localize)(28,null,n):(0,C.localize)(29,null,n)):y<f?(n=Math.floor(y/T),p?n===1?_?(0,C.localize)(30,null,n):(0,C.localize)(31,null,n):_?(0,C.localize)(32,null,n):(0,C.localize)(33,null,n):n===1?_?(0,C.localize)(34,null,n):(0,C.localize)(35,null,n):_?(0,C.localize)(36,null,n):(0,C.localize)(37,null,n)):y<w?(n=Math.floor(y/f),p?n===1?_?(0,C.localize)(38,null,n):(0,C.localize)(39,null,n):_?(0,C.localize)(40,null,n):(0,C.localize)(41,null,n):n===1?_?(0,C.localize)(42,null,n):(0,C.localize)(43,null,n):_?(0,C.localize)(44,null,n):(0,C.localize)(45,null,n)):(n=Math.floor(y/w),p?n===1?_?(0,C.localize)(46,null,n):(0,C.localize)(47,null,n):_?(0,C.localize)(48,null,n):(0,C.localize)(49,null,n):n===1?_?(0,C.localize)(50,null,n):(0,C.localize)(51,null,n):_?(0,C.localize)(52,null,n):(0,C.localize)(53,null,n))}e.fromNow=g;function P(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(Ce[176],De([11,12]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Ce[45],De([1,0,18,19,176]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(k,p){return p&&(k.stack||k.stacktrace)?d.localize(0,null,f(k),T(k.stack)||T(k.stacktrace)):f(k)}function T(k){return Array.isArray(k)?k.join(`
`):k}function f(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?d.localize(1,null,k.message):k.message||d.localize(2,null)}function w(k=null,p=!1){if(!k)return d.localize(3,null);if(Array.isArray(k)){const _=C.coalesce(k),D=w(_[0],p);return _.length>1?d.localize(4,null,D,_.length):D}if(L.isString(k))return k;if(k.detail){const _=k.detail;if(_.error)return A(_.error,p);if(_.exception)return A(_.exception,p)}return k.stack?A(k,p):k.message?k.message:d.localize(5,null)}e.toErrorMessage=w;function g(k){const p=k;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=g;function P(k,p){let _;return typeof k=="string"?_=new Error(k):_=k,_.actions=p,_}e.createErrorWithActions=P}),define(Ce[177],De([11,12]),function(me,e){return me.create("vs/base/common/platform",e)}),define(Ce[9],De([1,0,177]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,d=!1,A=!1,T=!1,f=!1,w=!1,g=!1,P=!1,k=!1,p=!1,_,D=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT,n,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?a=e.globals.vscode.process:typeof process<"u"&&(a=process);const m=typeof a?.versions?.electron=="string",b=m&&a?.type==="renderer";if(typeof navigator=="object"&&!b)o=navigator.userAgent,L=o.indexOf("Windows")>=0,d=o.indexOf("Macintosh")>=0,P=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=o.indexOf("Linux")>=0,p=o?.indexOf("Mobi")>=0,w=!0,_=C.getConfiguredDefaultLocale(C.localize(0,null))||e.LANGUAGE_DEFAULT,D=_,y=navigator.language;else if(typeof a=="object"){L=a.platform==="win32",d=a.platform==="darwin",A=a.platform==="linux",T=A&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,g=m,k=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,_=e.LANGUAGE_DEFAULT,D=e.LANGUAGE_DEFAULT;const S=a.env.VSCODE_NLS_CONFIG;if(S)try{const l=JSON.parse(S),h=l.availableLanguages["*"];_=l.locale,y=l.osLocale,D=h||e.LANGUAGE_DEFAULT,n=l._translationsConfigFile}catch{}f=!0}else console.error("Unable to resolve platform.");var I;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(I||(e.Platform=I={}));function t(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let r=0;d?r=1:L?r=3:A&&(r=2),e.isWindows=L,e.isMacintosh=d,e.isLinux=A,e.isLinuxSnap=T,e.isNative=f,e.isElectron=g,e.isWeb=w,e.isWebWorker=w&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isMobile=p,e.isCI=k,e.platform=r,e.userAgent=o,e.language=D;var s;(function(S){function l(){return e.language}S.value=l;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}S.isDefaultVariant=h;function E(){return e.language==="en"}S.isDefault=E})(s||(e.Language=s={})),e.locale=_,e.platformLocale=y,e.translationsConfigFile=n,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const S=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let E=0,R=S.length;E<R;E++){const M=S[E];if(M.id===h.data.vscodeScheduleAsyncWork){S.splice(E,1),M.callback();return}}});let l=0;return h=>{const E=++l;S.push({id:E,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return S=>setTimeout(S)})();var i;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=d||P?2:L?1:3;let c=!0,u=!1;function v(){if(!u){u=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,c=new Uint16Array(S.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=v,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ce[41],De([1,0,9]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof C.globals.vscode<"u"&&typeof C.globals.vscode.process<"u"){const d=C.globals.vscode.process;L={get platform(){return d.platform},get arch(){return d.arch},get env(){return d.env},cwd(){return d.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return C.isWindows?"win32":C.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(Ce[14],De([1,0,41]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,d=97,A=90,T=122,f=46,w=47,g=92,P=58,k=63;class p extends Error{constructor(r,s,i){let c;typeof s=="string"&&s.indexOf("not ")===0?(c="must not be",s=s.replace(/^not /,"")):c="must be";const u=r.indexOf(".")!==-1?"property":"argument";let v=`The "${r}" ${u} ${c} of type ${s}`;v+=`. Received type ${typeof i}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function _(t,r){if(t===null||typeof t!="object")throw new p(r,"Object",t)}function D(t,r){if(typeof t!="string")throw new p(r,"string",t)}const y=C.platform==="win32";function n(t){return t===w||t===g}function o(t){return t===w}function a(t){return t>=L&&t<=A||t>=d&&t<=T}function m(t,r,s,i){let c="",u=0,v=-1,S=0,l=0;for(let h=0;h<=t.length;++h){if(h<t.length)l=t.charCodeAt(h);else{if(i(l))break;l=w}if(i(l)){if(!(v===h-1||S===1))if(S===2){if(c.length<2||u!==2||c.charCodeAt(c.length-1)!==f||c.charCodeAt(c.length-2)!==f){if(c.length>2){const E=c.lastIndexOf(s);E===-1?(c="",u=0):(c=c.slice(0,E),u=c.length-1-c.lastIndexOf(s)),v=h,S=0;continue}else if(c.length!==0){c="",u=0,v=h,S=0;continue}}r&&(c+=c.length>0?`${s}..`:"..",u=2)}else c.length>0?c+=`${s}${t.slice(v+1,h)}`:c=t.slice(v+1,h),u=h-v-1;v=h,S=0}else l===f&&S!==-1?++S:S=-1}return c}function b(t,r){_(r,"pathObject");const s=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${i}`:`${s}${t}${i}`:i}e.win32={resolve(...t){let r="",s="",i=!1;for(let c=t.length-1;c>=-1;c--){let u;if(c>=0){if(u=t[c],D(u,"path"),u.length===0)continue}else r.length===0?u=C.cwd():(u=C.env[`=${r}`]||C.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==r.toLowerCase()&&u.charCodeAt(2)===g)&&(u=`${r}\\`));const v=u.length;let S=0,l="",h=!1;const E=u.charCodeAt(0);if(v===1)n(E)&&(S=1,h=!0);else if(n(E))if(h=!0,n(u.charCodeAt(1))){let R=2,M=R;for(;R<v&&!n(u.charCodeAt(R));)R++;if(R<v&&R!==M){const U=u.slice(M,R);for(M=R;R<v&&n(u.charCodeAt(R));)R++;if(R<v&&R!==M){for(M=R;R<v&&!n(u.charCodeAt(R));)R++;(R===v||R!==M)&&(l=`\\\\${U}\\${u.slice(M,R)}`,S=R)}}}else S=1;else a(E)&&u.charCodeAt(1)===P&&(l=u.slice(0,2),S=2,v>2&&n(u.charCodeAt(2))&&(h=!0,S=3));if(l.length>0)if(r.length>0){if(l.toLowerCase()!==r.toLowerCase())continue}else r=l;if(i){if(r.length>0)break}else if(s=`${u.slice(S)}\\${s}`,i=h,h&&r.length>0)break}return s=m(s,!i,"\\",n),i?`${r}\\${s}`:`${r}${s}`||"."},normalize(t){D(t,"path");const r=t.length;if(r===0)return".";let s=0,i,c=!1;const u=t.charCodeAt(0);if(r===1)return o(u)?"\\":t;if(n(u))if(c=!0,n(t.charCodeAt(1))){let S=2,l=S;for(;S<r&&!n(t.charCodeAt(S));)S++;if(S<r&&S!==l){const h=t.slice(l,S);for(l=S;S<r&&n(t.charCodeAt(S));)S++;if(S<r&&S!==l){for(l=S;S<r&&!n(t.charCodeAt(S));)S++;if(S===r)return`\\\\${h}\\${t.slice(l)}\\`;S!==l&&(i=`\\\\${h}\\${t.slice(l,S)}`,s=S)}}}else s=1;else a(u)&&t.charCodeAt(1)===P&&(i=t.slice(0,2),s=2,r>2&&n(t.charCodeAt(2))&&(c=!0,s=3));let v=s<r?m(t.slice(s),!c,"\\",n):"";return v.length===0&&!c&&(v="."),v.length>0&&n(t.charCodeAt(r-1))&&(v+="\\"),i===void 0?c?`\\${v}`:v:c?`${i}\\${v}`:`${i}${v}`},isAbsolute(t){D(t,"path");const r=t.length;if(r===0)return!1;const s=t.charCodeAt(0);return n(s)||r>2&&a(s)&&t.charCodeAt(1)===P&&n(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,s;for(let u=0;u<t.length;++u){const v=t[u];D(v,"path"),v.length>0&&(r===void 0?r=s=v:r+=`\\${v}`)}if(r===void 0)return".";let i=!0,c=0;if(typeof s=="string"&&n(s.charCodeAt(0))){++c;const u=s.length;u>1&&n(s.charCodeAt(1))&&(++c,u>2&&(n(s.charCodeAt(2))?++c:i=!1))}if(i){for(;c<r.length&&n(r.charCodeAt(c));)c++;c>=2&&(r=`\\${r.slice(c)}`)}return e.win32.normalize(r)},relative(t,r){if(D(t,"from"),D(r,"to"),t===r)return"";const s=e.win32.resolve(t),i=e.win32.resolve(r);if(s===i||(t=s.toLowerCase(),r=i.toLowerCase(),t===r))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===g;)c++;let u=t.length;for(;u-1>c&&t.charCodeAt(u-1)===g;)u--;const v=u-c;let S=0;for(;S<r.length&&r.charCodeAt(S)===g;)S++;let l=r.length;for(;l-1>S&&r.charCodeAt(l-1)===g;)l--;const h=l-S,E=v<h?v:h;let R=-1,M=0;for(;M<E;M++){const F=t.charCodeAt(c+M);if(F!==r.charCodeAt(S+M))break;F===g&&(R=M)}if(M!==E){if(R===-1)return i}else{if(h>E){if(r.charCodeAt(S+M)===g)return i.slice(S+M+1);if(M===2)return i.slice(S+M)}v>E&&(t.charCodeAt(c+M)===g?R=M:M===2&&(R=3)),R===-1&&(R=0)}let U="";for(M=c+R+1;M<=u;++M)(M===u||t.charCodeAt(M)===g)&&(U+=U.length===0?"..":"\\..");return S+=R,U.length>0?`${U}${i.slice(S,l)}`:(i.charCodeAt(S)===g&&++S,i.slice(S,l))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.win32.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===g){if(r.charCodeAt(1)===g){const s=r.charCodeAt(2);if(s!==k&&s!==f)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(a(r.charCodeAt(0))&&r.charCodeAt(1)===P&&r.charCodeAt(2)===g)return`\\\\?\\${r}`;return t},dirname(t){D(t,"path");const r=t.length;if(r===0)return".";let s=-1,i=0;const c=t.charCodeAt(0);if(r===1)return n(c)?t:".";if(n(c)){if(s=i=1,n(t.charCodeAt(1))){let S=2,l=S;for(;S<r&&!n(t.charCodeAt(S));)S++;if(S<r&&S!==l){for(l=S;S<r&&n(t.charCodeAt(S));)S++;if(S<r&&S!==l){for(l=S;S<r&&!n(t.charCodeAt(S));)S++;if(S===r)return t;S!==l&&(s=i=S+1)}}}}else a(c)&&t.charCodeAt(1)===P&&(s=r>2&&n(t.charCodeAt(2))?3:2,i=s);let u=-1,v=!0;for(let S=r-1;S>=i;--S)if(n(t.charCodeAt(S))){if(!v){u=S;break}}else v=!1;if(u===-1){if(s===-1)return".";u=s}return t.slice(0,u)},basename(t,r){r!==void 0&&D(r,"ext"),D(t,"path");let s=0,i=-1,c=!0,u;if(t.length>=2&&a(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(s=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let v=r.length-1,S=-1;for(u=t.length-1;u>=s;--u){const l=t.charCodeAt(u);if(n(l)){if(!c){s=u+1;break}}else S===-1&&(c=!1,S=u+1),v>=0&&(l===r.charCodeAt(v)?--v===-1&&(i=u):(v=-1,i=S))}return s===i?i=S:i===-1&&(i=t.length),t.slice(s,i)}for(u=t.length-1;u>=s;--u)if(n(t.charCodeAt(u))){if(!c){s=u+1;break}}else i===-1&&(c=!1,i=u+1);return i===-1?"":t.slice(s,i)},extname(t){D(t,"path");let r=0,s=-1,i=0,c=-1,u=!0,v=0;t.length>=2&&t.charCodeAt(1)===P&&a(t.charCodeAt(0))&&(r=i=2);for(let S=t.length-1;S>=r;--S){const l=t.charCodeAt(S);if(n(l)){if(!u){i=S+1;break}continue}c===-1&&(u=!1,c=S+1),l===f?s===-1?s=S:v!==1&&(v=1):s!==-1&&(v=-1)}return s===-1||c===-1||v===0||v===1&&s===c-1&&s===i+1?"":t.slice(s,c)},format:b.bind(null,"\\"),parse(t){D(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.length;let i=0,c=t.charCodeAt(0);if(s===1)return n(c)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(n(c)){if(i=1,n(t.charCodeAt(1))){let R=2,M=R;for(;R<s&&!n(t.charCodeAt(R));)R++;if(R<s&&R!==M){for(M=R;R<s&&n(t.charCodeAt(R));)R++;if(R<s&&R!==M){for(M=R;R<s&&!n(t.charCodeAt(R));)R++;R===s?i=R:R!==M&&(i=R+1)}}}}else if(a(c)&&t.charCodeAt(1)===P){if(s<=2)return r.root=r.dir=t,r;if(i=2,n(t.charCodeAt(2))){if(s===3)return r.root=r.dir=t,r;i=3}}i>0&&(r.root=t.slice(0,i));let u=-1,v=i,S=-1,l=!0,h=t.length-1,E=0;for(;h>=i;--h){if(c=t.charCodeAt(h),n(c)){if(!l){v=h+1;break}continue}S===-1&&(l=!1,S=h+1),c===f?u===-1?u=h:E!==1&&(E=1):u!==-1&&(E=-1)}return S!==-1&&(u===-1||E===0||E===1&&u===S-1&&u===v+1?r.base=r.name=t.slice(v,S):(r.name=t.slice(v,u),r.base=t.slice(v,S),r.ext=t.slice(u,S))),v>0&&v!==i?r.dir=t.slice(0,v-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const I=(()=>{if(y){const t=/\\/g;return()=>{const r=C.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>C.cwd()})();e.posix={resolve(...t){let r="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const c=i>=0?t[i]:I();D(c,"path"),c.length!==0&&(r=`${c}/${r}`,s=c.charCodeAt(0)===w)}return r=m(r,!s,"/",o),s?`/${r}`:r.length>0?r:"."},normalize(t){if(D(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===w,s=t.charCodeAt(t.length-1)===w;return t=m(t,!r,"/",o),t.length===0?r?"/":s?"./":".":(s&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return D(t,"path"),t.length>0&&t.charCodeAt(0)===w},join(...t){if(t.length===0)return".";let r;for(let s=0;s<t.length;++s){const i=t[s];D(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.posix.normalize(r)},relative(t,r){if(D(t,"from"),D(r,"to"),t===r||(t=e.posix.resolve(t),r=e.posix.resolve(r),t===r))return"";const s=1,i=t.length,c=i-s,u=1,v=r.length-u,S=c<v?c:v;let l=-1,h=0;for(;h<S;h++){const R=t.charCodeAt(s+h);if(R!==r.charCodeAt(u+h))break;R===w&&(l=h)}if(h===S)if(v>S){if(r.charCodeAt(u+h)===w)return r.slice(u+h+1);if(h===0)return r.slice(u+h)}else c>S&&(t.charCodeAt(s+h)===w?l=h:h===0&&(l=0));let E="";for(h=s+l+1;h<=i;++h)(h===i||t.charCodeAt(h)===w)&&(E+=E.length===0?"..":"/..");return`${E}${r.slice(u+l)}`},toNamespacedPath(t){return t},dirname(t){if(D(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===w;let s=-1,i=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===w){if(!i){s=c;break}}else i=!1;return s===-1?r?"/":".":r&&s===1?"//":t.slice(0,s)},basename(t,r){r!==void 0&&D(r,"ext"),D(t,"path");let s=0,i=-1,c=!0,u;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let v=r.length-1,S=-1;for(u=t.length-1;u>=0;--u){const l=t.charCodeAt(u);if(l===w){if(!c){s=u+1;break}}else S===-1&&(c=!1,S=u+1),v>=0&&(l===r.charCodeAt(v)?--v===-1&&(i=u):(v=-1,i=S))}return s===i?i=S:i===-1&&(i=t.length),t.slice(s,i)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===w){if(!c){s=u+1;break}}else i===-1&&(c=!1,i=u+1);return i===-1?"":t.slice(s,i)},extname(t){D(t,"path");let r=-1,s=0,i=-1,c=!0,u=0;for(let v=t.length-1;v>=0;--v){const S=t.charCodeAt(v);if(S===w){if(!c){s=v+1;break}continue}i===-1&&(c=!1,i=v+1),S===f?r===-1?r=v:u!==1&&(u=1):r!==-1&&(u=-1)}return r===-1||i===-1||u===0||u===1&&r===i-1&&r===s+1?"":t.slice(r,i)},format:b.bind(null,"/"),parse(t){D(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.charCodeAt(0)===w;let i;s?(r.root="/",i=1):i=0;let c=-1,u=0,v=-1,S=!0,l=t.length-1,h=0;for(;l>=i;--l){const E=t.charCodeAt(l);if(E===w){if(!S){u=l+1;break}continue}v===-1&&(S=!1,v=l+1),E===f?c===-1?c=l:h!==1&&(h=1):c!==-1&&(h=-1)}if(v!==-1){const E=u===0&&s?1:u;c===-1||h===0||h===1&&c===v-1&&c===u+1?r.base=r.name=t.slice(E,v):(r.name=t.slice(E,c),r.base=t.slice(E,v),r.ext=t.slice(c,v))}return u>0?r.dir=t.slice(0,u-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y?e.win32.normalize:e.posix.normalize,e.isAbsolute=y?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y?e.win32.join:e.posix.join,e.resolve=y?e.win32.resolve:e.posix.resolve,e.relative=y?e.win32.relative:e.posix.relative,e.dirname=y?e.win32.dirname:e.posix.dirname,e.basename=y?e.win32.basename:e.posix.basename,e.extname=y?e.win32.extname:e.posix.extname,e.format=y?e.win32.format:e.posix.format,e.parse=y?e.win32.parse:e.posix.parse,e.toNamespacedPath=y?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y?e.win32.sep:e.posix.sep,e.delimiter=y?e.win32.delimiter:e.posix.delimiter}),define(Ce[124],De([1,0,55,14]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const d=new C.Lazy(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),A=new C.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new C.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function f(S,l,h=!1){const E=S||"",R=l||"",M=d.value.collator.compare(E,R);return d.value.collatorIsNumeric&&M===0&&E!==R?E<R?-1:1:M}e.compareFileNames=f;function w(S,l){const h=A.value.collator;return S=S||"",l=l||"",b(h,S,l)}e.compareFileNamesDefault=w;function g(S,l){const h=A.value.collator;return S=S||"",l=l||"",s(S,l)||b(h,S,l)}e.compareFileNamesUpper=g;function P(S,l){const h=A.value.collator;return S=S||"",l=l||"",r(S,l)||b(h,S,l)}e.compareFileNamesLower=P;function k(S,l){return S=S||"",l=l||"",S===l?0:S<l?-1:1}e.compareFileNamesUnicode=k;function p(S,l){const[h,E]=a(S),[R,M]=a(l);let U=d.value.collator.compare(E,M);if(U===0){if(d.value.collatorIsNumeric&&E!==M)return E<M?-1:1;if(U=d.value.collator.compare(h,R),d.value.collatorIsNumeric&&U===0&&h!==R)return h<R?-1:1}return U}e.compareFileExtensions=p;function _(S,l){S=S||"",l=l||"";const h=m(S),E=m(l),R=A.value.collator,M=T.value.collator;return b(M,h,E)||b(R,S,l)}e.compareFileExtensionsDefault=_;function D(S,l){S=S||"",l=l||"";const h=m(S),E=m(l),R=A.value.collator,M=T.value.collator;return b(M,h,E)||s(S,l)||b(R,S,l)}e.compareFileExtensionsUpper=D;function y(S,l){S=S||"",l=l||"";const h=m(S),E=m(l),R=A.value.collator,M=T.value.collator;return b(M,h,E)||r(S,l)||b(R,S,l)}e.compareFileExtensionsLower=y;function n(S,l){S=S||"",l=l||"";const h=m(S).toLowerCase(),E=m(l).toLowerCase();return h!==E?h<E?-1:1:S!==l?S<l?-1:1:0}e.compareFileExtensionsUnicode=n;const o=/^(.*?)(\.([^.]*))?$/;function a(S,l=!1){const h=S?o.exec(S):[];let E=[h&&h[1]||"",h&&h[3]||""];return l&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function m(S){const l=S?o.exec(S):[];return l&&l[1]&&l[1].charAt(0)!=="."&&l[3]||""}function b(S,l,h){const E=S.compare(l,h);return E!==0?E:l.length!==h.length?l.length<h.length?-1:1:0}function I(S){const l=S.charAt(0);return l.toLocaleUpperCase()!==l}function t(S){const l=S.charAt(0);return l.toLocaleLowerCase()!==l}function r(S,l){return I(S)&&t(l)?-1:t(S)&&I(l)?1:0}function s(S,l){return t(S)&&I(l)?-1:I(S)&&t(l)?1:0}function i(S,l,h=!1){return h||(S=S&&S.toLowerCase(),l=l&&l.toLowerCase()),S===l?0:S<l?-1:1}function c(S,l,h=!1){const E=S.split(L.sep),R=l.split(L.sep),M=E.length-1,U=R.length-1;let F,x;for(let $=0;;$++){if(F=M===$,x=U===$,F&&x)return f(E[$],R[$],h);if(F)return-1;if(x)return 1;const O=i(E[$],R[$],h);if(O!==0)return O}}e.comparePaths=c;function u(S,l,h){const E=S.toLowerCase(),R=l.toLowerCase(),M=v(S,l,h);if(M)return M;const U=E.endsWith(h),F=R.endsWith(h);if(U!==F)return U?-1:1;const x=f(E,R);return x!==0?x:E.localeCompare(R)}e.compareAnything=u;function v(S,l,h){const E=S.toLowerCase(),R=l.toLowerCase(),M=E.startsWith(h),U=R.startsWith(h);if(M!==U)return M?-1:1;if(M&&U){if(E.length<R.length)return-1;if(E.length>R.length)return 1}return 0}e.compareByPrefix=v}),define(Ce[32],De([1,0,14,9,15,19]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(u){return u===47||u===92}e.isPathSeparator=T;function f(u){return u.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=f;function w(u){return u.indexOf("/")===-1&&(u=f(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.toPosixPath=w;function g(u,v=C.posix.sep){if(!u)return"";const S=u.length,l=u.charCodeAt(0);if(T(l)){if(T(u.charCodeAt(1))&&!T(u.charCodeAt(2))){let E=3;const R=E;for(;E<S&&!T(u.charCodeAt(E));E++);if(R!==E&&!T(u.charCodeAt(E+1))){for(E+=1;E<S;E++)if(T(u.charCodeAt(E)))return u.slice(0,E+1).replace(/[\\/]/g,v)}}return v}else if(o(l)&&u.charCodeAt(1)===58)return T(u.charCodeAt(2))?u.slice(0,2)+v:u.slice(0,2);let h=u.indexOf("://");if(h!==-1){for(h+=3;h<S;h++)if(T(u.charCodeAt(h)))return u.slice(0,h+1)}return""}e.getRoot=g;function P(u){if(!L.isWindows||!u||u.length<5)return!1;let v=u.charCodeAt(0);if(v!==92||(v=u.charCodeAt(1),v!==92))return!1;let S=2;const l=S;for(;S<u.length&&(v=u.charCodeAt(S),v!==92);S++);return!(l===S||(v=u.charCodeAt(S+1),isNaN(v)||v===92))}e.isUNC=P;const k=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,_=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(u,v=L.isWindows){const S=v?k:p;return!(!u||u.length===0||/^\s+$/.test(u)||(S.lastIndex=0,S.test(u))||v&&_.test(u)||u==="."||u===".."||v&&u[u.length-1]==="."||v&&u.length!==u.trim().length||u.length>255)}e.isValidBasename=D;function y(u,v,S){const l=u===v;return!S||l?l:!u||!v?!1:(0,d.equalsIgnoreCase)(u,v)}e.isEqual=y;function n(u,v,S,l=C.sep){if(u===v)return!0;if(!u||!v||v.length>u.length)return!1;if(S){if(!(0,d.startsWithIgnoreCase)(u,v))return!1;if(v.length===u.length)return!0;let E=v.length;return v.charAt(v.length-1)===l&&E--,u.charAt(E)===l}return v.charAt(v.length-1)!==l&&(v+=l),u.indexOf(v)===0}e.isEqualOrParent=n;function o(u){return u>=65&&u<=90||u>=97&&u<=122}e.isWindowsDriveLetter=o;function a(u,v){return L.isWindows&&u.endsWith(":")&&(u+=C.sep),(0,C.isAbsolute)(u)||(u=(0,C.join)(v,u)),u=(0,C.normalize)(u),L.isWindows?(u=(0,d.rtrim)(u,C.sep),u.endsWith(":")&&(u+=C.sep)):(u=(0,d.rtrim)(u,C.sep),u||(u=C.sep)),u}e.sanitizeFilePath=a;function m(u){const v=(0,C.normalize)(u);return L.isWindows?u.length>3?!1:b(v)&&(u.length===2||v.charCodeAt(2)===92):v===C.posix.sep}e.isRootOrDriveLetter=m;function b(u,v=L.isWindows){return v?o(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.hasDriveLetter=b;function I(u,v=L.isWindows){return b(u,v)?u[0]:void 0}e.getDriveLetter=I;function t(u,v,S){return v.length>u.length?-1:u===v?0:(S&&(u=u.toLowerCase(),v=v.toLowerCase()),u.indexOf(v))}e.indexOfPath=t;function r(u){const v=u.split(":");let S,l,h;for(const E of v){const R=Number(E);(0,A.isNumber)(R)?l===void 0?l=R:h===void 0&&(h=R):S=S?[S,E].join(":"):E}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(u,v,S=8){let l="";for(let E=0;E<S;E++){let R;E===0&&L.isWindows&&!v&&(S===3||S===4)?R=i:R=s,l+=R.charAt(Math.floor(Math.random()*R.length))}let h;return v?h=`${v}-${l}`:h=l,u?(0,C.join)(u,h):h}e.randomPath=c}),define(Ce[125],De([1,0,124,119,74,14,9,15]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const w=0,g=[w,[]];function P(K,q,fe,se){if(!K||!q)return g;const ie=K.length,H=q.length;if(ie<H)return g;const re=K.toLowerCase();return k(q,fe,H,K,re,ie,se)}e.scoreFuzzy=P;function k(K,q,fe,se,ie,H,re){const Ee=[],ae=[];for(let W=0;W<fe;W++){const he=W*H,Se=he-H,be=W>0,we=K[W],ye=q[W];for(let V=0;V<H;V++){const ee=V>0,G=he+V,Y=G-1,de=Se+V-1,ke=ee?Ee[Y]:0,B=be&&ee?Ee[de]:0,X=be&&ee?ae[de]:0;let Z;!B&&be?Z=0:Z=p(we,ye,se,ie,V,X),Z&&B+Z>=ke&&(re||be||ie.startsWith(q,V))?(ae[G]=X+1,Ee[G]=B+Z):(ae[G]=w,Ee[G]=ke)}}const ne=[];let J=fe-1,N=H-1;for(;J>=0&&N>=0;){const W=J*H+N;ae[W]===w||(ne.push(N),J--),N--}return[Ee[fe*H-1],ne.reverse()]}function p(K,q,fe,se,ie,H){let re=0;if(!_(q,se[ie]))return re;if(re+=1,H>0&&(re+=H*5),K===fe[ie]&&(re+=1),ie===0)re+=8;else{const Ee=D(fe.charCodeAt(ie-1));Ee?re+=Ee:(0,L.isUpper)(fe.charCodeAt(ie))&&H===0&&(re+=2)}return re}function _(K,q){return K===q?!0:K==="/"||K==="\\"?q==="/"||q==="\\":!1}function D(K){switch(K){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const y=[void 0,[]];function n(K,q,fe=0,se=0){const ie=q;return ie.values&&ie.values.length>1?o(K,ie.values,fe,se):a(K,q,fe,se)}e.scoreFuzzy2=n;function o(K,q,fe,se){let ie=0;const H=[];for(const re of q){const[Ee,ae]=a(K,re,fe,se);if(typeof Ee!="number")return y;ie+=Ee,H.push(...ae)}return[ie,S(H)]}function a(K,q,fe,se){const ie=(0,L.fuzzyScore)(q.original,q.originalLowercase,fe,K,K.toLowerCase(),se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ie?[ie[0],(0,L.createMatches)(ie)]:y}const m=Object.freeze({score:0}),b=1<<18,I=1<<17,t=1<<16;function r(K,q,fe,se){const ie=se.values?se.values:[se];return(0,d.hash)({[se.normalized]:{values:ie.map(re=>({value:re.normalized,expectContiguousMatch:re.expectContiguousMatch})),label:K,description:q,allowNonContiguousMatches:fe}})}function s(K,q,fe,se,ie){if(!K||!q.normalized)return m;const H=se.getItemLabel(K);if(!H)return m;const re=se.getItemDescription(K),Ee=r(H,re,fe,q),ae=ie[Ee];if(ae)return ae;const ne=i(H,re,se.getItemPath(K),q,fe);return ie[Ee]=ne,ne}e.scoreItemFuzzy=s;function i(K,q,fe,se,ie){const H=!fe||!se.containsPathSeparator;return fe&&(T.isLinux?se.pathNormalized===fe:(0,f.equalsIgnoreCase)(se.pathNormalized,fe))?{score:b,labelMatch:[{start:0,end:K.length}],descriptionMatch:q?[{start:0,end:q.length}]:void 0}:se.values&&se.values.length>1?c(K,q,fe,se.values,H,ie):u(K,q,fe,se,H,ie)}function c(K,q,fe,se,ie,H){let re=0;const Ee=[],ae=[];for(const ne of se){const{score:J,labelMatch:N,descriptionMatch:W}=u(K,q,fe,ne,ie,H);if(J===w)return m;re+=J,N&&Ee.push(...N),W&&ae.push(...W)}return{score:re,labelMatch:S(Ee),descriptionMatch:S(ae)}}function u(K,q,fe,se,ie,H){if(ie||!q){const[re,Ee]=P(K,se.normalized,se.normalizedLowercase,H&&!se.expectContiguousMatch);if(re){const ae=(0,L.matchesPrefix)(se.normalized,K);let ne;if(ae){ne=I;const J=Math.round(se.normalized.length/K.length*100);ne+=J}else ne=t;return{score:ne+re,labelMatch:ae||v(Ee)}}}if(q){let re=q;fe&&(re=`${q}${A.sep}`);const Ee=re.length,ae=`${re}${K}`,[ne,J]=P(ae,se.normalized,se.normalizedLowercase,H&&!se.expectContiguousMatch);if(ne){const N=v(J),W=[],he=[];return N.forEach(Se=>{Se.start<Ee&&Se.end>Ee?(W.push({start:0,end:Se.end-Ee}),he.push({start:Se.start,end:Ee})):Se.start>=Ee?W.push({start:Se.start-Ee,end:Se.end-Ee}):he.push(Se)}),{score:ne,labelMatch:W,descriptionMatch:he}}}return m}function v(K){const q=[];if(!K)return q;let fe;for(const se of K)fe&&fe.end===se?fe.end+=1:(fe={start:se,end:se+1},q.push(fe));return q}function S(K){const q=K.sort((ie,H)=>ie.start-H.start),fe=[];let se;for(const ie of q)!se||!l(se,ie)?(se=ie,fe.push(ie)):(se.start=Math.min(se.start,ie.start),se.end=Math.max(se.end,ie.end));return fe}function l(K,q){return!(K.end<q.start||q.end<K.start)}function h(K,q,fe,se,ie,H){const re=s(K,fe,se,ie,H),Ee=s(q,fe,se,ie,H),ae=re.score,ne=Ee.score;if((ae===b||ne===b)&&ae!==ne)return ae===b?-1:1;if(ae>t||ne>t){if(ae!==ne)return ae>ne?-1:1;if(ae<I&&ne<I){const we=R(re.labelMatch,Ee.labelMatch);if(we!==0)return we}const Se=ie.getItemLabel(K)||"",be=ie.getItemLabel(q)||"";if(Se.length!==be.length)return Se.length-be.length}if(ae!==ne)return ae>ne?-1:1;const J=Array.isArray(re.labelMatch)&&re.labelMatch.length>0,N=Array.isArray(Ee.labelMatch)&&Ee.labelMatch.length>0;if(J&&!N)return-1;if(N&&!J)return 1;const W=E(K,re,ie),he=E(q,Ee,ie);return W&&he&&W!==he?he>W?-1:1:M(K,q,fe,ie)}e.compareItemsByFuzzyScore=h;function E(K,q,fe){let se=-1,ie=-1;if(q.descriptionMatch&&q.descriptionMatch.length?se=q.descriptionMatch[0].start:q.labelMatch&&q.labelMatch.length&&(se=q.labelMatch[0].start),q.labelMatch&&q.labelMatch.length){if(ie=q.labelMatch[q.labelMatch.length-1].end,q.descriptionMatch&&q.descriptionMatch.length){const H=fe.getItemDescription(K);H&&(ie+=H.length)}}else q.descriptionMatch&&q.descriptionMatch.length&&(ie=q.descriptionMatch[q.descriptionMatch.length-1].end);return ie-se}function R(K,q){if(!K&&!q||(!K||!K.length)&&(!q||!q.length))return 0;if(!q||!q.length)return-1;if(!K||!K.length)return 1;const fe=K[0].start,ie=K[K.length-1].end-fe,H=q[0].start,Ee=q[q.length-1].end-H;return ie===Ee?0:Ee<ie?1:-1}function M(K,q,fe,se){const ie=se.getItemLabel(K)||"",H=se.getItemLabel(q)||"",re=se.getItemDescription(K),Ee=se.getItemDescription(q),ae=ie.length+(re?re.length:0),ne=H.length+(Ee?Ee.length:0);if(ae!==ne)return ae-ne;const J=se.getItemPath(K),N=se.getItemPath(q);return J&&N&&J.length!==N.length?J.length-N.length:ie!==H?(0,C.compareAnything)(ie,H,fe.normalized):re&&Ee&&re!==Ee?(0,C.compareAnything)(re,Ee,fe.normalized):J&&N&&J!==N?(0,C.compareAnything)(J,N,fe.normalized):0}function U(K){return K.startsWith('"')&&K.endsWith('"')}const F=" ";function x(K){typeof K!="string"&&(K="");const q=K.toLowerCase(),{pathNormalized:fe,normalized:se,normalizedLowercase:ie}=$(K),H=fe.indexOf(A.sep)>=0,re=U(K);let Ee;const ae=K.split(F);if(ae.length>1)for(const ne of ae){const J=U(ne),{pathNormalized:N,normalized:W,normalizedLowercase:he}=$(ne);W&&(Ee||(Ee=[]),Ee.push({original:ne,originalLowercase:ne.toLowerCase(),pathNormalized:N,normalized:W,normalizedLowercase:he,expectContiguousMatch:J}))}return{original:K,originalLowercase:q,pathNormalized:fe,normalized:se,normalizedLowercase:ie,values:Ee,containsPathSeparator:H,expectContiguousMatch:re}}e.prepareQuery=x;function $(K){let q;T.isWindows?q=K.replace(/\//g,A.sep):q=K.replace(/\\/g,A.sep);const fe=(0,f.stripWildcards)(q).replace(/\s|"/g,"");return{pathNormalized:q,normalized:fe,normalizedLowercase:fe.toLowerCase()}}function O(K){return Array.isArray(K)?x(K.map(q=>q.original).join(F)):x(K.original)}e.pieceToQuery=O}),define(Ce[97],De([1,0,14]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},d={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(P){const k=(0,C.extname)(P),p=L[k.toLowerCase()];return p!==void 0?p:T(P)}e.getMediaOrTextMime=A;function T(P){const k=(0,C.extname)(P);return d[k.toLowerCase()]}e.getMediaMime=T;function f(P){for(const k in d)if(d[k]===P)return k}e.getExtensionForMimeType=f;const w=/^(.+)\/(.+?)(;.+)?$/;function g(P,k){const p=w.exec(P);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:k?void 0:P}e.normalizeMimeType=g}),define(Ce[98],De([1,0,9]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(f){f[f.stdout=0]="stdout",f[f.stderr=1]="stderr"})(L||(e.Source=L={}));var d;(function(f){f[f.Success=0]="Success",f[f.Unknown=1]="Unknown",f[f.AccessDenied=2]="AccessDenied",f[f.ProcessNotFound=3]="ProcessNotFound"})(d||(e.TerminateResponseCode=d={}));function A(f,...w){const g=w.reduce((p,_)=>(p[_]=!0,p),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(f).filter(p=>!g[p]).forEach(p=>{for(let _=0;_<P.length;_++)if(p.search(P[_])!==-1){delete f[p];break}})}e.sanitizeProcessEnvironment=A;function T(f){f&&(delete f.DEBUG,C.isMacintosh&&delete f.DYLD_LIBRARY_PATH,C.isLinux&&delete f.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(Ce[2],De([1,0,14,9]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const d=/^\w[\w\d+.-]*$/,A=/^\//,T=/^\/\//;function f(i,c){if(!i.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!d.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(i,c){return!i&&!c?"file":i}function g(i,c){switch(i){case"https":case"http":case"file":c?c[0]!==k&&(c=k+c):c=k;break}return c}const P="",k="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class _{static isUri(c){return c instanceof _?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,u,v,S,l,h=!1){typeof c=="object"?(this.scheme=c.scheme||P,this.authority=c.authority||P,this.path=c.path||P,this.query=c.query||P,this.fragment=c.fragment||P):(this.scheme=w(c,h),this.authority=u||P,this.path=g(this.scheme,v||P),this.query=S||P,this.fragment=l||P,f(this,h))}get fsPath(){return b(this,!1)}with(c){if(!c)return this;let{scheme:u,authority:v,path:S,query:l,fragment:h}=c;return u===void 0?u=this.scheme:u===null&&(u=P),v===void 0?v=this.authority:v===null&&(v=P),S===void 0?S=this.path:S===null&&(S=P),l===void 0?l=this.query:l===null&&(l=P),h===void 0?h=this.fragment:h===null&&(h=P),u===this.scheme&&v===this.authority&&S===this.path&&l===this.query&&h===this.fragment?this:new n(u,v,S,l,h)}static parse(c,u=!1){const v=p.exec(c);return v?new n(v[2]||P,s(v[4]||P),s(v[5]||P),s(v[7]||P),s(v[9]||P),u):new n(P,P,P,P,P)}static file(c){let u=P;if(L.isWindows&&(c=c.replace(/\\/g,k)),c[0]===k&&c[1]===k){const v=c.indexOf(k,2);v===-1?(u=c.substring(2),c=k):(u=c.substring(2,v),c=c.substring(v)||k)}return new n("file",u,c,P,P)}static from(c,u){return new n(c.scheme,c.authority,c.path,c.query,c.fragment,u)}static joinPath(c,...u){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return L.isWindows&&c.scheme==="file"?v=_.file(C.win32.join(b(c,!0),...u)).path:v=C.posix.join(c.path,...u),c.with({path:v})}toString(c=!1){return I(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof _)return c;{const u=new n(c);return u._formatted=c.external??null,u._fsPath=c._sep===y?c.fsPath??null:null,u}}else return c}}e.URI=_;function D(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=D;const y=L.isWindows?1:void 0;class n extends _{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(c=!1){return c?I(this,!0):(this._formatted||(this._formatted=I(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=y),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(i,c,u){let v,S=-1;for(let l=0;l<i.length;l++){const h=i.charCodeAt(l);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||c&&h===47||u&&h===91||u&&h===93||u&&h===58)S!==-1&&(v+=encodeURIComponent(i.substring(S,l)),S=-1),v!==void 0&&(v+=i.charAt(l));else{v===void 0&&(v=i.substr(0,l));const E=o[h];E!==void 0?(S!==-1&&(v+=encodeURIComponent(i.substring(S,l)),S=-1),v+=E):S===-1&&(S=l)}}return S!==-1&&(v+=encodeURIComponent(i.substring(S))),v!==void 0?v:i}function m(i){let c;for(let u=0;u<i.length;u++){const v=i.charCodeAt(u);v===35||v===63?(c===void 0&&(c=i.substr(0,u)),c+=o[v]):c!==void 0&&(c+=i[u])}return c!==void 0?c:i}function b(i,c){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?c?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,L.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=b;function I(i,c){const u=c?m:a;let v="",{scheme:S,authority:l,path:h,query:E,fragment:R}=i;if(S&&(v+=S,v+=":"),(l||S==="file")&&(v+=k,v+=k),l){let M=l.indexOf("@");if(M!==-1){const U=l.substr(0,M);l=l.substr(M+1),M=U.lastIndexOf(":"),M===-1?v+=u(U,!1,!1):(v+=u(U.substr(0,M),!1,!1),v+=":",v+=u(U.substr(M+1),!1,!0)),v+="@"}l=l.toLowerCase(),M=l.lastIndexOf(":"),M===-1?v+=u(l,!1,!0):(v+=u(l.substr(0,M),!1,!0),v+=l.substr(M))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const M=h.charCodeAt(1);M>=65&&M<=90&&(h=`/${String.fromCharCode(M+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const M=h.charCodeAt(0);M>=65&&M<=90&&(h=`${String.fromCharCode(M+32)}:${h.substr(2)}`)}v+=u(h,!0,!1)}return E&&(v+="?",v+=u(E,!1,!1)),R&&(v+="#",v+=c?R:a(R,!1,!1)),v}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(r)?i.replace(r,c=>t(c)):i}}),define(Ce[178],De([1,0,2]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(g){const P=g;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=L;function d(g){const P=[];let k;try{const p=JSON.parse(g.arguments),_=p[p.length-1];_&&_.__$stack&&(p.pop(),k=_.__$stack),P.push(...p)}catch{P.push("Unable to log remote console arguments",g.arguments)}return{args:P,stack:k}}e.parse=d;function A(g){if(typeof g!="string")return A(d(g).stack);const P=g;if(P){const k=T(P),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(p&&p.length===4)return{uri:C.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=A;function T(g){if(!g)return g;const P=g.indexOf(`
`);return P===-1?g:g.substring(0,P)}function f(g,P){const{args:k,stack:p}=d(g),_=typeof k[0]=="string"&&k.length===1;let D=T(p);D&&(D=`(${D.trim()})`);let y=[];if(typeof k[0]=="string"?D&&_?y=[`%c[${P}] %c${k[0]} %c${D}`,w("blue"),w(""),w("grey")]:y=[`%c[${P}] %c${k[0]}`,w("blue"),w(""),...k.slice(1)]:y=[`%c[${P}]%`,w("blue"),...k],D&&!_&&y.push(D),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,y)}e.log=f;function w(g){return`color: ${g}`}}),define(Ce[77],De([1,0,21,2]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function d(w){return JSON.stringify(w,T)}e.stringify=d;function A(w){let g=JSON.parse(w);return g=f(g),g}e.parse=A;function T(w,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function f(w,g=0){if(!w||g>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return L.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 16:return new Date(w.source)}if(w instanceof C.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let P=0;P<w.length;++P)w[P]=f(w[P],g+1);else for(const P in w)Object.hasOwnProperty.call(w,P)&&(w[P]=f(w[P],g+1))}return w}e.revive=f}),define(Ce[16],De([1,0,8,9,2]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${A.vscodeRemoteResource}`}set(P,k,p){this._hosts[P]=k,this._ports[P]=p}setConnectionToken(P,k){this._connectionTokens[P]=k}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)try{return this._delegate(P)}catch(n){return C.onUnexpectedError(n),P}const k=P.authority;let p=this._hosts[k];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const _=this._ports[k],D=this._connectionTokens[k];let y=`path=${encodeURIComponent(P.path)}`;return typeof D=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(D)}`),d.URI.from({scheme:L.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${p}:${_}`,path:this._remoteResourcesPath,query:y})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class f{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(P){const k=this.toUri(P,me);return this.uriToBrowserUri(k)}uriToBrowserUri(P){return P.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===A.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${A.vscodeFileResource}://${f.FALLBACK_AUTHORITY}`)?P.with({scheme:A.vscodeFileResource,authority:P.authority||f.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(P){const k=this.toUri(P,me);return this.uriToFileUri(k)}uriToFileUri(P){return P.scheme===A.vscodeFileResource?P.with({scheme:A.file,authority:P.authority!==f.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(P,k){return d.URI.isUri(P)?P:d.URI.parse(k.toUrl(P))}}e.FileAccess=new f;var w;(function(g){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(P.get("3"));const k="vscode-coi";function p(D){let y;typeof D=="string"?y=new URL(D).searchParams:D instanceof URL?y=D.searchParams:d.URI.isUri(D)&&(y=new URL(D.toString(!0)).searchParams);const n=y?.get(k);if(n)return P.get(n)}g.getHeadersFromQuery=p;function _(D,y,n){if(!globalThis.crossOriginIsolated)return;const o=y&&n?"3":n?"2":"1";D instanceof URLSearchParams?D.set(k,o):D[k]=o}g.addSearchParam=_})(w||(e.COI=w={}))}),define(Ce[179],De([1,0,153,16,9,2]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class T{constructor(p,_,D){this.id=p,this.dependencies=_,this.callback=D}}class f{static{this.INSTANCE=new f}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(p,_,D)=>{typeof p!="string"&&(D=_,_=p,p=null),(typeof _!="object"||!Array.isArray(_))&&(D=_,_=null),this._defineCalls.push(new T(p,_,D))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this._initialize();const _=await(this._isWebWorker?this._workerLoadScript(p):this._isRenderer?this._rendererLoadScript(p):this._nodeJSLoadScript(p));if(!_)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(_.dependencies)&&_.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${_.dependencies.join(", ")}`);return typeof _.callback=="function"?_.callback([]):_.callback}_rendererLoadScript(p){return new Promise((_,D)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const n=()=>{y.removeEventListener("load",o),y.removeEventListener("error",a)},o=m=>{n(),_(this._defineCalls.pop())},a=m=>{n(),D(m)};y.addEventListener("load",o),y.addEventListener("error",a),this._amdPolicy&&(p=this._amdPolicy.createScriptURL(p)),y.setAttribute("src",p),document.getElementsByTagName("head")[0].appendChild(y)})}_workerLoadScript(p){return new Promise((_,D)=>{try{this._amdPolicy&&(p=this._amdPolicy.createScriptURL(p)),importScripts(p),_(this._defineCalls.pop())}catch(y){D(y)}})}async _nodeJSLoadScript(p){try{const _=globalThis._VSCODE_NODE_MODULES.fs,D=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,n=A.URI.parse(p).fsPath,o=_.readFileSync(n).toString(),a=y.wrap(o.replace(/^#!.*/,""));return new D.Script(a).runInThisContext().apply(),this._defineCalls.pop()}catch(_){throw _}}}const w=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function P(k,p,_){if(C.isESM){_===void 0&&(_=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[k]&&(k=g[k]);const D=`${k}/${p}`;if(w.has(D))return w.get(D);let y;if(/^\w[\w\d+.-]*:\/\//.test(D))y=D;else{const m=`${_&&!d.isWeb?L.nodeModulesAsarPath:L.nodeModulesPath}/${D}`;y=L.FileAccess.asBrowserUri(m).toString(!0)}const n=f.INSTANCE.load(y);return w.set(D,n),n}else return await new Promise((D,y)=>{me([k],D,y)})}e.importAMDNodeModule=P}),define(Ce[24],De([1,0,32,16,14,9,15,2]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(_){return(0,f.uriToFsPath)(_,!0)}e.originalFSPath=w;class g{constructor(D){this._ignorePathCasing=D}compare(D,y,n=!1){return D===y?0:(0,T.compare)(this.getComparisonKey(D,n),this.getComparisonKey(y,n))}isEqual(D,y,n=!1){return D===y?!0:!D||!y?!1:this.getComparisonKey(D,n)===this.getComparisonKey(y,n)}getComparisonKey(D,y=!1){return D.with({path:this._ignorePathCasing(D)?D.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(D){return this._ignorePathCasing(D)}isEqualOrParent(D,y,n=!1){if(D.scheme===y.scheme){if(D.scheme===L.Schemas.file)return C.isEqualOrParent(w(D),w(y),this._ignorePathCasing(D))&&D.query===y.query&&(n||D.fragment===y.fragment);if((0,e.isEqualAuthority)(D.authority,y.authority))return C.isEqualOrParent(D.path,y.path,this._ignorePathCasing(D),"/")&&D.query===y.query&&(n||D.fragment===y.fragment)}return!1}joinPath(D,...y){return f.URI.joinPath(D,...y)}basenameOrAuthority(D){return(0,e.basename)(D)||D.authority}basename(D){return d.posix.basename(D.path)}extname(D){return d.posix.extname(D.path)}dirname(D){if(D.path.length===0)return D;let y;return D.scheme===L.Schemas.file?y=f.URI.file(d.dirname(w(D))).path:(y=d.posix.dirname(D.path),D.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),y="/")),D.with({path:y})}normalizePath(D){if(!D.path.length)return D;let y;return D.scheme===L.Schemas.file?y=f.URI.file(d.normalize(w(D))).path:y=d.posix.normalize(D.path),D.with({path:y})}relativePath(D,y){if(D.scheme!==y.scheme||!(0,e.isEqualAuthority)(D.authority,y.authority))return;if(D.scheme===L.Schemas.file){const a=d.relative(w(D),w(y));return A.isWindows?C.toSlashes(a):a}let n=D.path||"/";const o=y.path||"/";if(this._ignorePathCasing(D)){let a=0;for(const m=Math.min(n.length,o.length);a<m&&!(n.charCodeAt(a)!==o.charCodeAt(a)&&n.charAt(a).toLowerCase()!==o.charAt(a).toLowerCase());a++);n=o.substr(0,a)+n.substr(a)}return d.posix.relative(n,o)}resolvePath(D,y){if(D.scheme===L.Schemas.file){const n=f.URI.file(d.resolve(w(D),y));return D.with({authority:n.authority,path:n.path})}return y=C.toPosixPath(y),D.with({path:d.posix.resolve(D.path,y)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,y){return D===y||D!==void 0&&y!==void 0&&(0,T.equalsIgnoreCase)(D,y)}hasTrailingPathSeparator(D,y=d.sep){if(D.scheme===L.Schemas.file){const n=w(D);return n.length>C.getRoot(n).length&&n[n.length-1]===y}else{const n=D.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,y=d.sep){return(0,e.hasTrailingPathSeparator)(D,y)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,y=d.sep){let n=!1;if(D.scheme===L.Schemas.file){const o=w(D);n=o!==void 0&&o.length===C.getRoot(o).length&&o[o.length-1]===y}else{y="/";const o=D.path;n=o.length===1&&o.charCodeAt(o.length-1)===47}return!n&&!(0,e.hasTrailingPathSeparator)(D,y)?D.with({path:D.path+"/"}):D}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(_=>_.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new g(_=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(_,D){const y=[];for(let n=0;n<_.length;n++){const o=D(_[n]);_.some((a,m)=>m===n?!1:(0,e.isEqualOrParent)(o,D(a)))||y.push(_[n])}return y}e.distinctParents=P;var k;(function(_){_.META_DATA_LABEL="label",_.META_DATA_DESCRIPTION="description",_.META_DATA_SIZE="size",_.META_DATA_MIME="mime";function D(y){const n=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(m=>{const[b,I]=m.split(":");b&&I&&n.set(b,I)});const a=y.path.substring(0,y.path.indexOf(";"));return a&&n.set(_.META_DATA_MIME,a),n}_.parseMetaData=D})(k||(e.DataUri=k={}));function p(_,D,y){if(D){let n=_.path;return n&&n[0]!==d.posix.sep&&(n=d.posix.sep+n),_.with({scheme:y,authority:D,path:n})}return _.with({scheme:y})}e.toLocalResource=p}),define(Ce[13],De([1,0,22,8,4,3,24,9,157]),function(me,e,C,L,d,A,T,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(N){return!!N&&typeof N.then=="function"}e.isThenable=g;function P(N){const W=new C.CancellationTokenSource,he=N(W.token),Se=new Promise((be,we)=>{const ye=W.token.onCancellationRequested(()=>{ye.dispose(),W.dispose(),we(new L.CancellationError)});Promise.resolve(he).then(V=>{ye.dispose(),W.dispose(),be(V)},V=>{ye.dispose(),W.dispose(),we(V)})});return new class{cancel(){W.cancel()}then(be,we){return Se.then(be,we)}catch(be){return this.then(void 0,be)}finally(be){return Se.finally(be)}}}e.createCancelablePromise=P;function k(N,W,he){return new Promise((Se,be)=>{const we=W.onCancellationRequested(()=>{we.dispose(),Se(he)});N.then(Se,be).finally(()=>we.dispose())})}e.raceCancellation=k;function p(N,W){return new Promise((he,Se)=>{const be=W.onCancellationRequested(()=>{be.dispose(),Se(new L.CancellationError)});N.then(he,Se).finally(()=>be.dispose())})}e.raceCancellationError=p;async function _(N){let W=-1;const he=N.map((Se,be)=>Se.then(we=>(W=be,we)));try{return await Promise.race(he)}finally{N.forEach((Se,be)=>{be!==W&&Se.cancel()})}}e.raceCancellablePromises=_;function D(N,W,he){let Se;const be=setTimeout(()=>{Se?.(void 0),he?.()},W);return Promise.race([N.finally(()=>clearTimeout(be)),new Promise(we=>Se=we)])}e.raceTimeout=D;function y(N){return new Promise((W,he)=>{const Se=N();g(Se)?Se.then(W,he):W(Se)})}e.asPromise=y;class n{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const he=()=>{if(this.queuedPromise=null,this.isDisposed)return;const Se=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Se};this.queuedPromise=new Promise(Se=>{this.activePromise.then(he,he).then(Se)})}return new Promise((he,Se)=>{this.queuedPromise.then(he,Se)})}return this.activePromise=W(),new Promise((he,Se)=>{this.activePromise.then(be=>{this.activePromise=null,he(be)},be=>{this.activePromise=null,Se(be)})})}dispose(){this.isDisposed=!0}}e.Throttler=n;class o{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=o;class a{constructor(){this.promiseMap=new Map}queue(W,he){const be=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(he).finally(()=>{this.promiseMap.get(W)===be&&this.promiseMap.delete(W)});return this.promiseMap.set(W,be),be}}e.SequencerByKey=a;const m=(N,W)=>{let he=!0;const Se=setTimeout(()=>{he=!1,W()},N);return{isTriggered:()=>he,dispose:()=>{clearTimeout(Se),he=!1}}},b=N=>{let W=!0;return queueMicrotask(()=>{W&&(W=!1,N())}),{isTriggered:()=>W,dispose:()=>{W=!1}}};class I{constructor(W){this.defaultDelay=W,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,he=this.defaultDelay){this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((be,we)=>{this.doResolve=be,this.doReject=we}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const be=this.task;return this.task=null,be()}}));const Se=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=he===w.MicrotaskDelay?b(Se):m(he,Se),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=I;class t{constructor(W){this.delayer=new I(W),this.throttler=new n}trigger(W,he){return this.delayer.trigger(()=>this.throttler.queue(W),he)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=t;class r{constructor(){this._isOpen=!1,this._promise=new Promise((W,he)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class s extends r{constructor(W){super(),this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function i(N,W){return W?new Promise((he,Se)=>{const be=setTimeout(()=>{we.dispose(),he()},N),we=W.onCancellationRequested(()=>{clearTimeout(be),we.dispose(),Se(new L.CancellationError)})}):P(he=>i(N,he))}e.timeout=i;function c(N,W=0){const he=setTimeout(N,W);return(0,A.toDisposable)(()=>clearTimeout(he))}e.disposableTimeout=c;function u(N){const W=[];let he=0;const Se=N.length;function be(){return he<Se?N[he++]():null}function we(ye){ye!=null&&W.push(ye);const V=be();return V?V.then(we):Promise.resolve(W)}return Promise.resolve(null).then(we)}e.sequence=u;function v(N,W=Se=>!!Se,he=null){let Se=0;const be=N.length,we=()=>{if(Se>=be)return Promise.resolve(he);const ye=N[Se++];return Promise.resolve(ye()).then(ee=>W(ee)?Promise.resolve(ee):we())};return we()}e.first=v;function S(N,W=Se=>!!Se,he=null){if(N.length===0)return Promise.resolve(he);let Se=N.length;const be=()=>{Se=-1;for(const we of N)we.cancel?.()};return new Promise((we,ye)=>{for(const V of N)V.then(ee=>{--Se>=0&&W(ee)?(be(),we(ee)):Se===0&&we(he)}).catch(ee=>{--Se>=0&&(be(),ye(ee))})})}e.firstParallel=S;class l{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new d.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(W){return this._size++,new Promise((he,Se)=>{this.outstandingPromises.push({factory:W,c:he,e:Se}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const he=W.factory();he.then(W.c,W.e),he.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class h extends l{constructor(){super(1)}}e.Queue=h;class E{constructor(){this.sequentializer=new fe,this.tasks=0}queue(W){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,W())):this.sequentializer.run(this.tasks++,W())}}e.LimitedQueue=E;class R{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const W=new H;return this.drainers.add(W),W.p}isDrained(){for(const[,W]of this.queues)if(W.size>0)return!1;return!0}queueFor(W,he=T.extUri){const Se=he.getComparisonKey(W);let be=this.queues.get(Se);return be||(be=new h,d.Event.once(be.onDrained)(()=>{be?.dispose(),this.queues.delete(Se),this.onDidQueueDrain()}),this.queues.set(Se,be)),be}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const W of this.drainers)W.complete();this.drainers.clear()}dispose(){for(const[,W]of this.queues)W.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=R;class M{constructor(W,he){this._token=-1,typeof W=="function"&&typeof he=="number"&&this.setIfNotSet(W,he)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,he){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},he)}setIfNotSet(W,he){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},he))}}e.TimeoutTimer=M;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,he){this.cancel(),this._token=setInterval(()=>{W()},he)}}e.IntervalTimer=U;class F{constructor(W,he){this.timeoutToken=-1,this.runner=W,this.timeout=he,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=F;class x{constructor(W,he){he%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${he}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=he,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=x;class $ extends F{constructor(W,he){super(W,he),this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner?.(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=$;class O extends A.Disposable{constructor(W,he){super(),this.options=W,this.handler=he,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.options.maxBufferedWork)return!1}else if(this.pending+W.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const he of W)this.pendingWork.push(he);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{(0,f.setTimeout0)(()=>{if(W)return;const he=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e.runWhenIdle=(N,W)=>{const he=requestIdleCallback(N,typeof W=="number"?{timeout:W}:void 0);let Se=!1;return{dispose(){Se||(Se=!0,cancelIdleCallback(he))}}}}();class K{constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(he){this._error=he}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=K;async function q(N,W,he){let Se;for(let be=0;be<he;be++)try{return await N()}catch(we){Se=we,await i(W)}throw Se}e.retry=q;class fe{isRunning(W){return typeof W=="number"?this._running?.taskId===W:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(W,he,Se){return this._running={taskId:W,cancel:()=>Se?.(),promise:he},he.then(()=>this.doneRunning(W),()=>this.doneRunning(W)),he}doneRunning(W){this._running&&W===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const W=this._queued;this._queued=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}queue(W){if(this._queued)this._queued.run=W;else{let he,Se;const be=new Promise((we,ye)=>{he=we,Se=ye});this._queued={run:W,promise:be,promiseResolve:he,promiseReject:Se}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=fe;class se{constructor(W,he=()=>Date.now()){this.interval=W,this.nowFn=he,this.lastIncrementTime=0,this.value=0}increment(){const W=this.nowFn();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=se;var ie;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(ie||(ie={}));class H{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((W,he)=>{this.completeCallback=W,this.errorCallback=he})}complete(W){return new Promise(he=>{this.completeCallback(W),this.outcome={outcome:0,value:W},he()})}error(W){return new Promise(he=>{this.errorCallback(W),this.outcome={outcome:1,value:W},he()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=H;var re;(function(N){async function W(Se){let be;const we=await Promise.all(Se.map(ye=>ye.then(V=>V,V=>{be||(be=V)})));if(typeof be<"u")throw be;return we}N.settled=W;function he(Se){return new Promise(async(be,we)=>{try{await Se(be,we)}catch(ye){we(ye)}})}N.withAsyncBody=he})(re||(e.Promises=re={}));var Ee;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(Ee||(Ee={}));class ae{static fromArray(W){return new ae(he=>{he.emitMany(W)})}static fromPromise(W){return new ae(async he=>{he.emitMany(await W)})}static fromPromises(W){return new ae(async he=>{await Promise.all(W.map(async Se=>he.emitOne(await Se)))})}static merge(W){return new ae(async he=>{await Promise.all(W.map(async Se=>{for await(const be of Se)he.emitOne(be)}))})}static{this.EMPTY=ae.fromArray([])}constructor(W){this._state=0,this._results=[],this._error=null,this._onStateChanged=new d.Emitter,queueMicrotask(async()=>{const he={emitOne:Se=>this.emitOne(Se),emitMany:Se=>this.emitMany(Se),reject:Se=>this.reject(Se)};try{await Promise.resolve(W(he)),this.resolve()}catch(Se){this.reject(Se)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let W=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(W<this._results.length)return{done:!1,value:this._results[W++]};if(this._state===1)return{done:!0,value:void 0};await d.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(W,he){return new ae(async Se=>{for await(const be of W)Se.emitOne(he(be))})}map(W){return ae.map(this,W)}static filter(W,he){return new ae(async Se=>{for await(const be of W)he(be)&&Se.emitOne(be)})}filter(W){return ae.filter(this,W)}static coalesce(W){return ae.filter(W,he=>!!he)}coalesce(){return ae.coalesce(this)}static async toPromise(W){const he=[];for await(const Se of W)he.push(Se);return he}toPromise(){return ae.toPromise(this)}emitOne(W){this._state===0&&(this._results.push(W),this._onStateChanged.fire())}emitMany(W){this._state===0&&(this._results=this._results.concat(W),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(W){this._state===0&&(this._state=2,this._error=W,this._onStateChanged.fire())}}e.AsyncIterableObject=ae;class ne extends ae{constructor(W,he){super(he),this._source=W}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ne;function J(N){const W=new C.CancellationTokenSource,he=N(W.token);return new ne(W,async Se=>{const be=W.token.onCancellationRequested(()=>{be.dispose(),W.dispose(),Se.reject(new L.CancellationError)});try{for await(const we of he){if(W.token.isCancellationRequested)return;Se.emitOne(we)}be.dispose(),W.dispose()}catch(we){be.dispose(),W.dispose(),Se.reject(we)}})}e.createCancelableAsyncIterable=J}),define(Ce[35],De([1,0,18,13,32,28,14,9,15]),function(me,e,C,L,d,A,T,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",k="[^/\\\\]",p=/\//g;function _(fe,se){switch(fe){case 0:return"";case 1:return`${k}*?`;default:return`(?:${P}|${k}+${P}${se?`|${P}${k}+`:""})*?`}}function D(fe,se){if(!fe)return[];const ie=[];let H=!1,re=!1,Ee="";for(const ae of fe){switch(ae){case se:if(!H&&!re){ie.push(Ee),Ee="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":re=!0;break;case"]":re=!1;break}Ee+=ae}return Ee&&ie.push(Ee),ie}e.splitGlobAware=D;function y(fe){if(!fe)return"";let se="";const ie=D(fe,e.GLOB_SPLIT);if(ie.every(H=>H===e.GLOBSTAR))se=".*";else{let H=!1;ie.forEach((re,Ee)=>{if(re===e.GLOBSTAR){if(H)return;se+=_(2,Ee===ie.length-1)}else{let ae=!1,ne="",J=!1,N="";for(const W of re){if(W!=="}"&&ae){ne+=W;continue}if(J&&(W!=="]"||!N)){let he;W==="-"?he=W:(W==="^"||W==="!")&&!N?he="^":W===e.GLOB_SPLIT?he="":he=(0,w.escapeRegExpCharacters)(W),N+=he;continue}switch(W){case"{":ae=!0;continue;case"[":J=!0;continue;case"}":{const Se=`(?:${D(ne,",").map(be=>y(be)).join("|")})`;se+=Se,ae=!1,ne="";break}case"]":{se+="["+N+"]",J=!1,N="";break}case"?":se+=k;continue;case"*":se+=_(1);continue;default:se+=(0,w.escapeRegExpCharacters)(W)}}Ee<ie.length-1&&(ie[Ee+1]!==e.GLOBSTAR||Ee+2<ie.length)&&(se+=P)}H=re===e.GLOBSTAR})}return se}const n=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),r=function(){return!1},s=function(){return null};function i(fe,se){if(!fe)return s;let ie;typeof fe!="string"?ie=fe.pattern:ie=fe,ie=ie.trim();const H=`${ie}_${!!se.trimForExclusions}`;let re=t.get(H);if(re)return c(re,fe);let Ee;return n.test(ie)?re=v(ie.substr(4),ie):(Ee=o.exec(u(ie,se)))?re=S(Ee[1],ie):(se.trimForExclusions?m:a).test(ie)?re=l(ie,se):(Ee=b.exec(u(ie,se)))?re=h(Ee[1].substr(1),ie,!0):(Ee=I.exec(u(ie,se)))?re=h(Ee[1],ie,!1):re=E(ie),t.set(H,re),c(re,fe)}function c(fe,se){if(typeof se=="string")return fe;const ie=function(H,re){return(0,d.isEqualOrParent)(H,se.base,!f.isLinux)?fe((0,w.ltrim)(H.substr(se.base.length),T.sep),re):null};return ie.allBasenames=fe.allBasenames,ie.allPaths=fe.allPaths,ie.basenames=fe.basenames,ie.patterns=fe.patterns,ie}function u(fe,se){return se.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function v(fe,se){return function(ie,H){return typeof ie=="string"&&ie.endsWith(fe)?se:null}}function S(fe,se){const ie=`/${fe}`,H=`\\${fe}`,re=function(ae,ne){return typeof ae!="string"?null:ne?ne===fe?se:null:ae===fe||ae.endsWith(ie)||ae.endsWith(H)?se:null},Ee=[fe];return re.basenames=Ee,re.patterns=[se],re.allBasenames=Ee,re}function l(fe,se){const ie=K(fe.slice(1,-1).split(",").map(ne=>i(ne,se)).filter(ne=>ne!==s),fe),H=ie.length;if(!H)return s;if(H===1)return ie[0];const re=function(ne,J){for(let N=0,W=ie.length;N<W;N++)if(ie[N](ne,J))return fe;return null},Ee=ie.find(ne=>!!ne.allBasenames);Ee&&(re.allBasenames=Ee.allBasenames);const ae=ie.reduce((ne,J)=>J.allPaths?ne.concat(J.allPaths):ne,[]);return ae.length&&(re.allPaths=ae),re}function h(fe,se,ie){const H=T.sep===T.posix.sep,re=H?fe:fe.replace(p,T.sep),Ee=T.sep+re,ae=T.posix.sep+fe;let ne;return ie?ne=function(J,N){return typeof J=="string"&&(J===re||J.endsWith(Ee)||!H&&(J===fe||J.endsWith(ae)))?se:null}:ne=function(J,N){return typeof J=="string"&&(J===re||!H&&J===fe)?se:null},ne.allPaths=[(ie?"*/":"./")+fe],ne}function E(fe){try{const se=new RegExp(`^${y(fe)}$`);return function(ie){return se.lastIndex=0,typeof ie=="string"&&se.test(ie)?fe:null}}catch{return s}}function R(fe,se,ie){return!fe||typeof se!="string"?!1:M(fe)(se,void 0,ie)}e.match=R;function M(fe,se={}){if(!fe)return r;if(typeof fe=="string"||U(fe)){const ie=i(fe,se);if(ie===s)return r;const H=function(re,Ee){return!!ie(re,Ee)};return ie.allBasenames&&(H.allBasenames=ie.allBasenames),ie.allPaths&&(H.allPaths=ie.allPaths),H}return $(fe,se)}e.parse=M;function U(fe){const se=fe;return se?typeof se.base=="string"&&typeof se.pattern=="string":!1}e.isRelativePattern=U;function F(fe){return fe.allBasenames||[]}e.getBasenameTerms=F;function x(fe){return fe.allPaths||[]}e.getPathTerms=x;function $(fe,se){const ie=K(Object.getOwnPropertyNames(fe).map(ne=>O(ne,fe[ne],se)).filter(ne=>ne!==s)),H=ie.length;if(!H)return s;if(!ie.some(ne=>!!ne.requiresSiblings)){if(H===1)return ie[0];const ne=function(W,he){let Se;for(let be=0,we=ie.length;be<we;be++){const ye=ie[be](W,he);if(typeof ye=="string")return ye;(0,L.isThenable)(ye)&&(Se||(Se=[]),Se.push(ye))}return Se?(async()=>{for(const be of Se){const we=await be;if(typeof we=="string")return we}return null})():null},J=ie.find(W=>!!W.allBasenames);J&&(ne.allBasenames=J.allBasenames);const N=ie.reduce((W,he)=>he.allPaths?W.concat(he.allPaths):W,[]);return N.length&&(ne.allPaths=N),ne}const re=function(ne,J,N){let W,he;for(let Se=0,be=ie.length;Se<be;Se++){const we=ie[Se];we.requiresSiblings&&N&&(J||(J=(0,T.basename)(ne)),W||(W=J.substr(0,J.length-(0,T.extname)(ne).length)));const ye=we(ne,J,W,N);if(typeof ye=="string")return ye;(0,L.isThenable)(ye)&&(he||(he=[]),he.push(ye))}return he?(async()=>{for(const Se of he){const be=await Se;if(typeof be=="string")return be}return null})():null},Ee=ie.find(ne=>!!ne.allBasenames);Ee&&(re.allBasenames=Ee.allBasenames);const ae=ie.reduce((ne,J)=>J.allPaths?ne.concat(J.allPaths):ne,[]);return ae.length&&(re.allPaths=ae),re}function O(fe,se,ie){if(se===!1)return s;const H=i(fe,ie);if(H===s)return s;if(typeof se=="boolean")return H;if(se){const re=se.when;if(typeof re=="string"){const Ee=(ae,ne,J,N)=>{if(!N||!H(ae,ne))return null;const W=re.replace("$(basename)",()=>J),he=N(W);return(0,L.isThenable)(he)?he.then(Se=>Se?fe:null):he?fe:null};return Ee.requiresSiblings=!0,Ee}}return H}function K(fe,se){const ie=fe.filter(ne=>!!ne.basenames);if(ie.length<2)return fe;const H=ie.reduce((ne,J)=>{const N=J.basenames;return N?ne.concat(N):ne},[]);let re;if(se){re=[];for(let ne=0,J=H.length;ne<J;ne++)re.push(se)}else re=ie.reduce((ne,J)=>{const N=J.patterns;return N?ne.concat(N):ne},[]);const Ee=function(ne,J){if(typeof ne!="string")return null;if(!J){let W;for(W=ne.length;W>0;W--){const he=ne.charCodeAt(W-1);if(he===47||he===92)break}J=ne.substr(W)}const N=H.indexOf(J);return N!==-1?re[N]:null};Ee.basenames=H,Ee.patterns=re,Ee.allBasenames=H;const ae=fe.filter(ne=>!ne.basenames);return ae.push(Ee),ae}function q(fe,se){return(0,C.equals)(fe,se,(ie,H)=>typeof ie=="string"&&typeof H=="string"?ie===H:typeof ie!="string"&&typeof H!="string"?ie.base===H.base&&ie.pattern===H.pattern:!1)}e.patternsEquals=q}),define(Ce[78],De([1,0,8,158,24,15,2]),function(me,e,C,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var f;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(f||(e.MarkdownStringTextNewlineStyle=f={}));class w{constructor(o="",a=!1){if(this.value=o,typeof this.value!="string")throw(0,C.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(o,a=0){return this.value+=p(this.supportThemeIcons?(0,L.escapeIcons)(o):o).replace(/([ \t]+)/g,(m,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,a){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}appendLink(o,a,m){return this.value+="[",this.value+=this._escape(a,"]"),this.value+="](",this.value+=this._escape(String(o),")"),m&&(this.value+=` "${this._escape(this._escape(m,'"'),")")}"`),this.value+=")",this}_escape(o,a){const m=new RegExp((0,A.escapeRegExpCharacters)(a),"g");return o.replace(m,(b,I)=>o.charAt(I-1)!=="\\"?`\\${b}`:b)}}e.MarkdownString=w;function g(n){return P(n)?!n.value:Array.isArray(n)?n.every(g):!0}e.isEmptyMarkdownString=g;function P(n){return n instanceof w?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||typeof n.isTrusted=="object"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function k(n,o){return n===o?!0:!n||!o?!1:n.value===o.value&&n.isTrusted===o.isTrusted&&n.supportThemeIcons===o.supportThemeIcons&&n.supportHtml===o.supportHtml&&(n.baseUri===o.baseUri||!!n.baseUri&&!!o.baseUri&&(0,d.isEqual)(T.URI.from(n.baseUri),T.URI.from(o.baseUri)))}e.markdownStringEqual=k;function p(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=p;function _(n){return n.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=_;function D(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=D;function y(n){const o=[],a=n.split("|").map(b=>b.trim());n=a[0];const m=a[1];if(m){const b=/height=(\d+)/.exec(m),I=/width=(\d+)/.exec(m),t=b?b[1]:"",r=I?I[1]:"",s=isFinite(parseInt(r)),i=isFinite(parseInt(t));s&&o.push(`width="${r}"`),i&&o.push(`height="${t}"`)}return{href:n,dimensions:o}}e.parseHrefAndDimensions=y}),define(Ce[126],De([1,0,18,32,14,9,24,15]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(i,c){const{os:u,tildify:v,relative:S}=c;if(S){const E=g(i,S,u);if(typeof E=="string")return E}let l=i.fsPath;if(u===1&&!A.isWindows?l=l.replace(/\//g,"\\"):u!==1&&A.isWindows&&(l=l.replace(/\\/g,"/")),u!==1&&v?.userHome){const E=v.userHome.fsPath;let R;i.scheme!==v.userHome.scheme&&i.path.startsWith(d.posix.sep)?R=v.userHome.with({path:i.path}).fsPath:R=i.fsPath,l=p(R,E,u)}return(u===1?d.win32:d.posix).normalize(P(l,u===1))}e.getPathLabel=w;function g(i,c,u){const v=u===1?d.win32:d.posix,S=u===3?T.extUri:T.extUriIgnorePathCase,l=c.getWorkspace(),h=(0,C.firstOrDefault)(l.folders);if(!h)return;i.scheme!==h.uri.scheme&&i.path.startsWith(d.posix.sep)&&(i=h.uri.with({path:i.path}));const E=c.getWorkspaceFolder(i);if(!E)return;let R;if(S.isEqual(E.uri,i)?R="":R=S.relativePath(E.uri,i)??"",R&&(R=v.normalize(R)),l.folders.length>1&&!c.noPrefix){const M=E.name?E.name:S.basenameOrAuthority(E.uri);R=R?`${M} \u2022 ${R}`:M}return R}function P(i,c=A.isWindows){return(0,L.hasDriveLetter)(i,c)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=P;let k=Object.create(null);function p(i,c,u=A.OS){if(u===1||!i||!c)return i;let v=k.original===c?k.normalized:void 0;v||(v=c,A.isWindows&&(v=(0,L.toSlashes)(v)),v=`${(0,f.rtrim)(v,d.posix.sep)}${d.posix.sep}`,k={original:c,normalized:v});let S=i;return A.isWindows&&(S=(0,L.toSlashes)(S)),(u===3?S.startsWith(v):(0,f.startsWithIgnoreCase)(S,v))?`~/${S.substr(v.length)}`:i}e.tildify=p;function _(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=_;const D="\u2026",y="\\\\",n="~";function o(i,c=d.sep){const u=new Array(i.length);let v=!1;for(let S=0;S<i.length;S++){const l=i[S];if(l===""){u[S]=`.${c}`;continue}if(!l){u[S]=l;continue}v=!0;let h="",E=l;E.indexOf(y)===0?(h=E.substr(0,E.indexOf(y)+y.length),E=E.substr(E.indexOf(y)+y.length)):E.indexOf(c)===0?(h=E.substr(0,E.indexOf(c)+c.length),E=E.substr(E.indexOf(c)+c.length)):E.indexOf(n)===0&&(h=E.substr(0,E.indexOf(n)+n.length),E=E.substr(E.indexOf(n)+n.length));const R=E.split(c);for(let M=1;v&&M<=R.length;M++)for(let U=R.length-M;v&&U>=0;U--){v=!1;let F=R.slice(U,U+M).join(c);for(let x=0;!v&&x<i.length;x++)if(x!==S&&i[x]&&i[x].indexOf(F)>-1){const $=U+M===R.length,O=U>0&&i[x].indexOf(c)>-1?c+F:F,K=i[x].endsWith(O);v=!$||K}if(!v){let x="";(R[0].endsWith(":")||h!=="")&&(U===1&&(U=0,M++,F=R[0]+c+F),U>0&&(x=R[0]+c),x=h+x),U>0&&(x=x+D+c),x=x+F,U+M<R.length&&(x=x+c+D),u[S]=x}}v&&(u[S]=l)}return u}e.shorten=o;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function m(i,c=Object.create(null)){const u=[];let v=!1,S="";for(const l of i)if(l==="$"||v&&l==="{")S&&u.push({value:S,type:a.TEXT}),S="",v=!0;else if(l==="}"&&v){const h=c[S];if(typeof h=="string")h.length&&u.push({value:h,type:a.VARIABLE});else if(h){const E=u[u.length-1];(!E||E.type!==a.SEPARATOR)&&u.push({value:h.label,type:a.SEPARATOR})}S="",v=!1}else S+=l;return S&&!v&&u.push({value:S,type:a.TEXT}),u.filter((l,h)=>{if(l.type===a.SEPARATOR){const E=u[h-1],R=u[h+1];return[E,R].every(M=>M&&(M.type===a.VARIABLE||M.type===a.TEXT)&&M.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=m;function b(i,c){return A.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=b;function I(i,c){return A.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=I;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function r(i){if(i.endsWith("]")){const c=i.lastIndexOf(" [",i.length-2);if(c!==-1){const u=s(i.substring(0,c));return{name:u.name,parentPath:u.parentPath+i.substring(c)}}}return s(i)}e.splitRecentLabel=r;function s(i){const c=i.indexOf("/")!==-1?d.posix:d.win32,u=c.basename(i),v=c.dirname(i);return u.length?{name:u,parentPath:v}:{name:v,parentPath:""}}}),define(Ce[127],De([1,0,21,2]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function d(k){return k.toJSON()}class A{constructor(p){this._uriTransformer=p}transformIncoming(p){const _=this._uriTransformer.transformIncoming(p);return _===p?p:d(L.URI.from(_))}transformOutgoing(p){const _=this._uriTransformer.transformOutgoing(p);return _===p?p:d(L.URI.from(_))}transformOutgoingURI(p){const _=this._uriTransformer.transformOutgoing(p);return _===p?p:L.URI.from(_)}transformOutgoingScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function T(k,p,_){if(!k||_>200)return null;if(typeof k=="object"){if(k instanceof L.URI)return p.transformOutgoing(k);for(const D in k)if(Object.hasOwnProperty.call(k,D)){const y=T(k[D],p,_+1);y!==null&&(k[D]=y)}}return null}function f(k,p){const _=T(k,p,0);return _===null?k:_}e.transformOutgoingURIs=f;function w(k,p,_,D){if(!k||D>200)return null;if(typeof k=="object"){if(k.$mid===1)return _?L.URI.revive(p.transformIncoming(k)):p.transformIncoming(k);if(k instanceof C.VSBuffer)return null;for(const y in k)if(Object.hasOwnProperty.call(k,y)){const n=w(k[y],p,_,D+1);n!==null&&(k[y]=n)}}return null}function g(k,p){const _=w(k,p,!1,0);return _===null?k:_}e.transformIncomingURIs=g;function P(k,p){const _=w(k,p,!0,0);return _===null?k:_}e.transformAndReviveIncomingURIs=P}),define(Ce[29],De([1,0,49,59,360,13,32,73,14,9,24,2]),function(me,e,C,L,d,A,T,f,w,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function _(O,K=p.UNLINK,q){if((0,T.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return K===p.UNLINK?y(O):D(O,q)}async function D(O,K=(0,T.randomPath)((0,L.tmpdir)())){try{try{await C.promises.rename(O,K)}catch(q){return q.code==="ENOENT"?void 0:y(O)}y(K).catch(q=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function y(O){return(0,d.promisify)(C.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function n(O){if((0,T.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=n;async function o(O,K){return b(await(K?a(O):(0,d.promisify)(C.readdir)(O)))}async function a(O){try{return await(0,d.promisify)(C.readdir)(O,{withFileTypes:!0})}catch(fe){console.warn("[node.js fs] readdir with filetypes failed with error: ",fe)}const K=[],q=await o(O);for(const fe of q){let se=!1,ie=!1,H=!1;try{const re=await e.Promises.lstat((0,w.join)(O,fe));se=re.isFile(),ie=re.isDirectory(),H=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}K.push({name:fe,isFile:()=>se,isDirectory:()=>ie,isSymbolicLink:()=>H})}return K}function m(O){return b(C.readdirSync(O))}e.readdirSync=m;function b(O){return O.map(K=>typeof K=="string"?g.isMacintosh?(0,f.normalizeNFC)(K):K:(K.name=g.isMacintosh?(0,f.normalizeNFC)(K.name):K.name,K))}async function I(O){const K=await o(O),q=[];for(const fe of K)await r.existsDirectory((0,w.join)(O,fe))&&q.push(fe);return q}function t(O,K=1e3){return new Promise(q=>{let fe=!1;const se=setInterval(()=>{fe||(fe=!0,C.access(O,ie=>{fe=!1,ie&&(clearInterval(se),q(void 0))}))},K)})}e.whenDeleted=t;var r;(function(O){async function K(se){let ie;try{if(ie=await e.Promises.lstat(se),!ie.isSymbolicLink())return{stat:ie}}catch{}try{return{stat:await e.Promises.stat(se),symbolicLink:ie?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};if(g.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(se)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};throw re}throw H}}O.stat=K;async function q(se){try{const{stat:ie,symbolicLink:H}=await O.stat(se);return ie.isFile()&&H?.dangling!==!0}catch{}return!1}O.existsFile=q;async function fe(se){try{const{stat:ie,symbolicLink:H}=await O.stat(se);return ie.isDirectory()&&H?.dangling!==!0}catch{}return!1}O.existsDirectory=fe})(r||(e.SymlinkSupport=r={}));const s=new A.ResourceQueue;function i(O,K,q){return s.queueFor(k.URI.file(O),P.extUriBiasedIgnorePathCase).queue(()=>{const fe=l(q);return new Promise((se,ie)=>v(O,K,fe,H=>H?ie(H):se()))})}let c=!0;function u(O){c=O}e.configureFlushOnWrite=u;function v(O,K,q,fe){if(!c)return C.writeFile(O,K,{mode:q.mode,flag:q.flag},fe);C.open(O,q.flag,q.mode,(se,ie)=>{if(se)return fe(se);C.writeFile(ie,K,H=>{if(H)return C.close(ie,()=>fe(H));C.fdatasync(ie,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),u(!1)),C.close(ie,Ee=>fe(Ee))))})})}function S(O,K,q){const fe=l(q);if(!c)return C.writeFileSync(O,K,{mode:fe.mode,flag:fe.flag});const se=C.openSync(O,fe.flag,fe.mode);try{C.writeFileSync(se,K);try{C.fdatasyncSync(se)}catch(ie){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ie),u(!1)}}finally{C.closeSync(se)}}e.writeFileSync=S;function l(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function h(O,K,q=6e4){if(O!==K)try{g.isWindows&&typeof q=="number"?await E(O,K,Date.now(),q):await(0,d.promisify)(C.rename)(O,K)}catch(fe){if(O.toLowerCase()!==K.toLowerCase()&&fe.code==="EXDEV"||O.endsWith("."))await R(O,K,{preserveSymlinks:!1}),await _(O,p.MOVE);else throw fe}}async function E(O,K,q,fe,se=0){try{return await(0,d.promisify)(C.rename)(O,K)}catch(ie){if(ie.code!=="EACCES"&&ie.code!=="EPERM"&&ie.code!=="EBUSY")throw ie;if(Date.now()-q>=fe)throw console.error(`[node.js fs] rename failed after ${se} retries with error: ${ie}`),ie;if(se===0){let H=!1;try{const{stat:re}=await r.stat(K);re.isFile()||(H=!0)}catch{}if(H)throw ie}return await(0,A.timeout)(Math.min(100,se*10)),E(O,K,q,fe,se+1)}}async function R(O,K,q){return U(O,K,{root:{source:O,target:K},options:q,handledSourcePaths:new Set})}const M=511;async function U(O,K,q){if(q.handledSourcePaths.has(O))return;q.handledSourcePaths.add(O);const{stat:fe,symbolicLink:se}=await r.stat(O);if(se){if(q.options.preserveSymlinks)try{return await $(O,K,q)}catch(ie){console.warn("[node.js fs] copy of symlink failed: ",ie)}if(se.dangling)return}return fe.isDirectory()?F(O,K,fe.mode&M,q):x(O,K,fe.mode&M)}async function F(O,K,q,fe){await e.Promises.mkdir(K,{recursive:!0,mode:q});const se=await o(O);for(const ie of se)await U((0,w.join)(O,ie),(0,w.join)(K,ie),fe)}async function x(O,K,q){await e.Promises.copyFile(O,K),await e.Promises.chmod(K,q)}async function $(O,K,q){let fe=await e.Promises.readlink(O);(0,T.isEqualOrParent)(fe,q.root.source,!g.isLinux)&&(fe=(0,w.join)(q.root.target,fe.substr(q.root.source.length+1))),await e.Promises.symlink(fe,K)}e.Promises=new class{get access(){return(0,d.promisify)(C.access)}get stat(){return(0,d.promisify)(C.stat)}get lstat(){return(0,d.promisify)(C.lstat)}get utimes(){return(0,d.promisify)(C.utimes)}get read(){return(O,K,q,fe,se)=>new Promise((ie,H)=>{C.read(O,K,q,fe,se,(re,Ee,ae)=>re?H(re):ie({bytesRead:Ee,buffer:ae}))})}get readFile(){return(0,d.promisify)(C.readFile)}get write(){return(O,K,q,fe,se)=>new Promise((ie,H)=>{C.write(O,K,q,fe,se,(re,Ee,ae)=>re?H(re):ie({bytesWritten:Ee,buffer:ae}))})}get appendFile(){return(0,d.promisify)(C.appendFile)}get fdatasync(){return(0,d.promisify)(C.fdatasync)}get truncate(){return(0,d.promisify)(C.truncate)}get copyFile(){return(0,d.promisify)(C.copyFile)}get open(){return(0,d.promisify)(C.open)}get close(){return(0,d.promisify)(C.close)}get symlink(){return(0,d.promisify)(C.symlink)}get readlink(){return(0,d.promisify)(C.readlink)}get chmod(){return(0,d.promisify)(C.chmod)}get mkdir(){return(0,d.promisify)(C.mkdir)}get unlink(){return(0,d.promisify)(C.unlink)}get rmdir(){return(0,d.promisify)(C.rmdir)}get realpath(){return(0,d.promisify)(C.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return I}get writeFile(){return i}get rm(){return _}get rename(){return h}get copy(){return R}}}),define(Ce[99],De([1,0,49,14,9,15,29]),function(me,e,C,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function f(p){if(d.isLinux)return p;const _=(0,L.dirname)(p);if(p===_)return p;const D=((0,L.basename)(p)||p).toLowerCase();try{const n=(0,T.readdirSync)(_).filter(o=>o.toLowerCase()===D);if(n.length===1){const o=f(_);if(o)return(0,L.join)(o,n[0])}else if(n.length>1){const o=n.indexOf(D);if(o>=0){const a=f(_);if(a)return(0,L.join)(a,n[o])}}}catch{}return null}e.realcaseSync=f;async function w(p){if(d.isLinux)return p;const _=(0,L.dirname)(p);if(p===_)return p;const D=((0,L.basename)(p)||p).toLowerCase();try{const n=(await T.Promises.readdir(_)).filter(o=>o.toLowerCase()===D);if(n.length===1){const o=await w(_);if(o)return(0,L.join)(o,n[0])}else if(n.length>1){const o=n.indexOf(D);if(o>=0){const a=await w(_);if(a)return(0,L.join)(a,n[o])}}}catch{}return null}e.realcase=w;async function g(p){try{return await T.Promises.realpath(p)}catch{const D=k(p);return await T.Promises.access(D,C.constants.R_OK),D}}e.realpath=g;function P(p){try{return C.realpathSync(p)}catch{const D=k(p);return C.accessSync(D,C.constants.R_OK),D}}e.realpathSync=P;function k(p){return(0,A.rtrim)((0,L.normalize)(p),L.sep)}}),define(Ce[100],De([1,0,14,9,41,98,19,29]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function w(k=d.env){return k.comspec||"cmd.exe"}e.getWindowsShell=w;function g(k){let p=[],_=!1;const D=function(y){if(_){p.push(y);return}(!k.send(y,o=>{if(o&&console.error(o),_=!1,p.length>0){const a=p.slice(0);p=[],a.forEach(m=>D(m))}})||L.isWindows)&&(_=!0)};return{send:D}}e.createQueuedSender=g;var P;(function(k){async function p(_,D,y){if(C.isAbsolute(_))return _;if(D===void 0&&(D=d.cwd()),C.dirname(_)!=="."||(y===void 0&&T.isString(d.env.PATH)&&(y=d.env.PATH.split(C.delimiter)),y===void 0||y.length===0))return C.join(D,_);async function o(a){if(await f.Promises.exists(a)){let m;try{m=await f.Promises.stat(a)}catch(b){b.message.startsWith("EACCES")&&(m=await f.Promises.lstat(a))}return m?!m.isDirectory():!1}return!1}for(const a of y){let m;if(C.isAbsolute(a)?m=C.join(a,_):m=C.join(D,a,_),await o(m))return m;let b=m+".com";if(await o(b)||(b=m+".exe",await o(b)))return b}return C.join(D,_)}k.findExecutable=p})(P||(e.win32=P={}))});var qe=this&&this.__decorate||function(me,e,C,L){var d=arguments.length,A=d<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,C):L,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(me,e,C,L);else for(var f=me.length-1;f>=0;f--)(T=me[f])&&(A=(d<3?T(A):d>3?T(e,C,A):T(e,C))||A);return d>3&&A&&Object.defineProperty(e,C,A),A};define(Ce[79],De([1,0,18,13,21,22,70,8,4,3,77,15,19]),function(me,e,C,L,d,A,T,f,w,g,P,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var _;(function(se){se[se.Promise=100]="Promise",se[se.PromiseCancel=101]="PromiseCancel",se[se.EventListen=102]="EventListen",se[se.EventDispose=103]="EventDispose"})(_||(_={}));function D(se){switch(se){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(se){se[se.Initialize=200]="Initialize",se[se.PromiseSuccess=201]="PromiseSuccess",se[se.PromiseError=202]="PromiseError",se[se.PromiseErrorObj=203]="PromiseErrorObj",se[se.EventFire=204]="EventFire"})(y||(y={}));function n(se){switch(se){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(se){se[se.Uninitialized=0]="Uninitialized",se[se.Idle=1]="Idle"})(o||(o={}));function a(se){let ie=0;for(let H=0;;H+=7){const re=se.read(1);if(ie|=(re.buffer[0]&127)<<H,!(re.buffer[0]&128))return ie}}const m=s(0);function b(se,ie){if(ie===0){se.write(m);return}let H=0;for(let Ee=ie;Ee!==0;Ee=Ee>>>7)H++;const re=d.VSBuffer.alloc(H);for(let Ee=0;ie!==0;Ee++)re.buffer[Ee]=ie&127,ie=ie>>>7,ie>0&&(re.buffer[Ee]|=128);se.write(re)}class I{constructor(ie){this.buffer=ie,this.pos=0}read(ie){const H=this.buffer.slice(this.pos,this.pos+ie);return this.pos+=H.byteLength,H}}e.BufferReader=I;class t{constructor(){this.buffers=[]}get buffer(){return d.VSBuffer.concat(this.buffers)}write(ie){this.buffers.push(ie)}}e.BufferWriter=t;var r;(function(se){se[se.Undefined=0]="Undefined",se[se.String=1]="String",se[se.Buffer=2]="Buffer",se[se.VSBuffer=3]="VSBuffer",se[se.Array=4]="Array",se[se.Object=5]="Object",se[se.Int=6]="Int"})(r||(r={}));function s(se){const ie=d.VSBuffer.alloc(1);return ie.writeUInt8(se,0),ie}const i={Undefined:s(r.Undefined),String:s(r.String),Buffer:s(r.Buffer),VSBuffer:s(r.VSBuffer),Array:s(r.Array),Object:s(r.Object),Uint:s(r.Int)},c=typeof Buffer<"u";function u(se,ie){if(typeof ie>"u")se.write(i.Undefined);else if(typeof ie=="string"){const H=d.VSBuffer.fromString(ie);se.write(i.String),b(se,H.byteLength),se.write(H)}else if(c&&Buffer.isBuffer(ie)){const H=d.VSBuffer.wrap(ie);se.write(i.Buffer),b(se,H.byteLength),se.write(H)}else if(ie instanceof d.VSBuffer)se.write(i.VSBuffer),b(se,ie.byteLength),se.write(ie);else if(Array.isArray(ie)){se.write(i.Array),b(se,ie.length);for(const H of ie)u(se,H)}else if(typeof ie=="number"&&(ie|0)===ie)se.write(i.Uint),b(se,ie);else{const H=d.VSBuffer.fromString(JSON.stringify(ie));se.write(i.Object),b(se,H.byteLength),se.write(H)}}e.serialize=u;function v(se){switch(se.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return se.read(a(se)).toString();case r.Buffer:return se.read(a(se)).buffer;case r.VSBuffer:return se.read(a(se));case r.Array:{const H=a(se),re=[];for(let Ee=0;Ee<H;Ee++)re.push(v(se));return re}case r.Object:return JSON.parse(se.read(a(se)).toString());case r.Int:return a(se)}}e.deserialize=v;class S{constructor(ie,H,re=null,Ee=1e3){this.protocol=ie,this.ctx=H,this.logger=re,this.timeoutDelay=Ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ae=>this.onRawMessage(ae)),this.sendResponse({type:200})}registerChannel(ie,H){this.channels.set(ie,H),setTimeout(()=>this.flushPendingRequests(ie),0)}sendResponse(ie){switch(ie.type){case 200:{const H=this.send([ie.type]);this.logger?.logOutgoing(H,0,1,n(ie.type));return}case 201:case 202:case 204:case 203:{const H=this.send([ie.type,ie.id],ie.data);this.logger?.logOutgoing(H,ie.id,1,n(ie.type),ie.data);return}}}send(ie,H=void 0){const re=new t;return u(re,ie),u(re,H),this.sendBuffer(re.buffer)}sendBuffer(ie){try{return this.protocol.send(ie),ie.byteLength}catch{return 0}}onRawMessage(ie){const H=new I(ie),re=v(H),Ee=v(H),ae=re[0];switch(ae){case 100:return this.logger?.logIncoming(ie.byteLength,re[1],1,`${D(ae)}: ${re[2]}.${re[3]}`,Ee),this.onPromise({type:ae,id:re[1],channelName:re[2],name:re[3],arg:Ee});case 102:return this.logger?.logIncoming(ie.byteLength,re[1],1,`${D(ae)}: ${re[2]}.${re[3]}`,Ee),this.onEventListen({type:ae,id:re[1],channelName:re[2],name:re[3],arg:Ee});case 101:return this.logger?.logIncoming(ie.byteLength,re[1],1,`${D(ae)}`),this.disposeActiveRequest({type:ae,id:re[1]});case 103:return this.logger?.logIncoming(ie.byteLength,re[1],1,`${D(ae)}`),this.disposeActiveRequest({type:ae,id:re[1]})}}onPromise(ie){const H=this.channels.get(ie.channelName);if(!H){this.collectPendingRequest(ie);return}const re=new A.CancellationTokenSource;let Ee;try{Ee=H.call(this.ctx,ie.name,ie.arg,re.token)}catch(J){Ee=Promise.reject(J)}const ae=ie.id;Ee.then(J=>{this.sendResponse({id:ae,data:J,type:201}),this.activeRequests.delete(ie.id)},J=>{J instanceof Error?this.sendResponse({id:ae,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.sendResponse({id:ae,data:J,type:203}),this.activeRequests.delete(ie.id)});const ne=(0,g.toDisposable)(()=>re.cancel());this.activeRequests.set(ie.id,ne)}onEventListen(ie){const H=this.channels.get(ie.channelName);if(!H){this.collectPendingRequest(ie);return}const re=ie.id,ae=H.listen(this.ctx,ie.name,ie.arg)(ne=>this.sendResponse({id:re,data:ne,type:204}));this.activeRequests.set(ie.id,ae)}disposeActiveRequest(ie){const H=this.activeRequests.get(ie.id);H&&(H.dispose(),this.activeRequests.delete(ie.id))}collectPendingRequest(ie){let H=this.pendingRequests.get(ie.channelName);H||(H=[],this.pendingRequests.set(ie.channelName,H));const re=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.sendResponse({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:ie,timeoutTimer:re})}flushPendingRequests(ie){const H=this.pendingRequests.get(ie);if(H){for(const re of H)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.onPromise(re.request);break;case 102:this.onEventListen(re.request);break}this.pendingRequests.delete(ie)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=S;var l;(function(se){se[se.LocalSide=0]="LocalSide",se[se.OtherSide=1]="OtherSide"})(l||(e.RequestInitiator=l={}));class h{constructor(ie,H=null){this.protocol=ie,this.isDisposed=!1,this.state=o.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(re=>this.onBuffer(re)),this.logger=H}getChannel(ie){const H=this;return{call(re,Ee,ae){return H.isDisposed?Promise.reject(new f.CancellationError):H.requestPromise(ie,re,Ee,ae)},listen(re,Ee){return H.isDisposed?w.Event.None:H.requestEvent(ie,re,Ee)}}}requestPromise(ie,H,re,Ee=A.CancellationToken.None){const ae=this.lastRequestId++,J={id:ae,type:100,channelName:ie,name:H,arg:re};if(Ee.isCancellationRequested)return Promise.reject(new f.CancellationError);let N;return new Promise((he,Se)=>{if(Ee.isCancellationRequested)return Se(new f.CancellationError);const be=()=>{const ee=G=>{switch(G.type){case 201:this.handlers.delete(ae),he(G.data);break;case 202:{this.handlers.delete(ae);const Y=new Error(G.data.message);Y.stack=Array.isArray(G.data.stack)?G.data.stack.join(`
`):G.data.stack,Y.name=G.data.name,Se(Y);break}case 203:this.handlers.delete(ae),Se(G.data);break}};this.handlers.set(ae,ee),this.sendRequest(J)};let we=null;this.state===o.Idle?be():(we=(0,L.createCancelablePromise)(ee=>this.whenInitialized()),we.then(()=>{we=null,be()}));const ye=()=>{we?(we.cancel(),we=null):this.sendRequest({id:ae,type:101}),Se(new f.CancellationError)},V=Ee.onCancellationRequested(ye);N=(0,g.combinedDisposable)((0,g.toDisposable)(ye),V),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(ie,H,re){const Ee=this.lastRequestId++,ne={id:Ee,type:102,channelName:ie,name:H,arg:re};let J=null;const N=new w.Emitter({onWillAddFirstListener:()=>{J=(0,L.createCancelablePromise)(he=>this.whenInitialized()),J.then(()=>{J=null,this.activeRequests.add(N),this.sendRequest(ne)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.activeRequests.delete(N),this.sendRequest({id:Ee,type:103}))}}),W=he=>N.fire(he.data);return this.handlers.set(Ee,W),N.event}sendRequest(ie){switch(ie.type){case 100:case 102:{const H=this.send([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.logger?.logOutgoing(H,ie.id,0,`${D(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const H=this.send([ie.type,ie.id]);this.logger?.logOutgoing(H,ie.id,0,D(ie.type));return}}}send(ie,H=void 0){const re=new t;return u(re,ie),u(re,H),this.sendBuffer(re.buffer)}sendBuffer(ie){try{return this.protocol.send(ie),ie.byteLength}catch{return 0}}onBuffer(ie){const H=new I(ie),re=v(H),Ee=v(H),ae=re[0];switch(ae){case 200:return this.logger?.logIncoming(ie.byteLength,0,0,n(ae)),this.onResponse({type:re[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(ie.byteLength,re[1],0,n(ae),Ee),this.onResponse({type:re[0],id:re[1],data:Ee})}}onResponse(ie){if(ie.type===200){this.state=o.Idle,this._onDidInitialize.fire();return}this.handlers.get(ie.id)?.(ie)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=h,qe([T.memoize],h.prototype,"onDidInitializePromise",null);class E{get connections(){const ie=[];return this._connections.forEach(H=>ie.push(H)),ie}constructor(ie){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,ie(({protocol:H,onDidClientDisconnect:re})=>{w.Event.once(H.onMessage)(ae=>{const ne=new I(ae),J=v(ne),N=new S(H,J),W=new h(H);this.channels.forEach((Se,be)=>N.registerChannel(be,Se));const he={channelServer:N,channelClient:W,ctx:J};this._connections.add(he),this._onDidAddConnection.fire(he),re(()=>{N.dispose(),W.dispose(),this._connections.delete(he),this._onDidRemoveConnection.fire(he)})})})}getChannel(ie,H){const re=this;return{call(Ee,ae,ne){let J;if((0,p.isFunction)(H)){const W=(0,C.getRandomElement)(re.connections.filter(H));J=W?Promise.resolve(W):w.Event.toPromise(w.Event.filter(re.onDidAddConnection,H))}else J=H.routeCall(re,Ee,ae);const N=J.then(W=>W.channelClient.getChannel(ie));return M(N).call(Ee,ae,ne)},listen(Ee,ae){if((0,p.isFunction)(H))return re.getMulticastEvent(ie,H,Ee,ae);const ne=H.routeEvent(re,Ee,ae).then(J=>J.channelClient.getChannel(ie));return M(ne).listen(Ee,ae)}}}getMulticastEvent(ie,H,re,Ee){const ae=this;let ne=new g.DisposableStore;const J=new w.Emitter({onWillAddFirstListener:()=>{ne=new g.DisposableStore;const N=new w.EventMultiplexer,W=new Map,he=be=>{const ye=be.channelClient.getChannel(ie).listen(re,Ee),V=N.add(ye);W.set(be,V)},Se=be=>{const we=W.get(be);we&&(we.dispose(),W.delete(be))};ae.connections.filter(H).forEach(he),w.Event.filter(ae.onDidAddConnection,H)(he,void 0,ne),ae.onDidRemoveConnection(Se,void 0,ne),N.event(J.fire,J,ne),ne.add(N)},onDidRemoveLastListener:()=>{ne.dispose()}});return J.event}registerChannel(ie,H){this.channels.set(ie,H),this._connections.forEach(re=>{re.channelServer.registerChannel(ie,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class R{constructor(ie,H,re=null){const Ee=new t;u(Ee,H),ie.send(Ee.buffer),this.channelClient=new h(ie,re),this.channelServer=new S(ie,H,re)}getChannel(ie){return this.channelClient.getChannel(ie)}registerChannel(ie,H){this.channelServer.registerChannel(ie,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function M(se){return{call(ie,H,re){return se.then(Ee=>Ee.call(ie,H,re))},listen(ie,H){const re=new w.Relay;return se.then(Ee=>re.input=Ee.listen(ie,H)),re.event}}}e.getDelayedChannel=M;function U(se){let ie=!1;return{call(H,re,Ee){return ie?se.call(H,re,Ee):(0,L.timeout)(0).then(()=>ie=!0).then(()=>se.call(H,re,Ee))},listen(H,re){if(ie)return se.listen(H,re);const Ee=new w.Relay;return(0,L.timeout)(0).then(()=>ie=!0).then(()=>Ee.input=se.listen(H,re)),Ee.event}}}e.getNextTickChannel=U;class F{constructor(ie){this.fn=ie}routeCall(ie){return this.route(ie)}routeEvent(ie){return this.route(ie)}async route(ie){for(const H of ie.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await w.Event.toPromise(ie.onDidAddConnection),await this.route(ie)}}e.StaticRouter=F;var x;(function(se){function ie(ae,ne){const J=ae,N=ne&&ne.disableMarshalling,W=new Map;for(const he in J)re(he)&&W.set(he,w.Event.buffer(J[he],!0));return new class{listen(he,Se,be){const we=W.get(Se);if(we)return we;if(Ee(Se)){const ye=J[Se];if(typeof ye=="function")return ye.call(J,be)}throw new f.ErrorNoTelemetry(`Event not found: ${Se}`)}call(he,Se,be){const we=J[Se];if(typeof we=="function"){if(!N&&Array.isArray(be))for(let ye=0;ye<be.length;ye++)be[ye]=(0,P.revive)(be[ye]);return we.apply(J,be)}throw new f.ErrorNoTelemetry(`Method not found: ${Se}`)}}}se.fromService=ie;function H(ae,ne){const J=ne&&ne.disableMarshalling;return new Proxy({},{get(N,W){if(typeof W=="string")return ne?.properties?.has(W)?ne.properties.get(W):Ee(W)?function(he){return ae.listen(W,he)}:re(W)?ae.listen(W):async function(...he){let Se;ne&&!(0,p.isUndefinedOrNull)(ne.context)?Se=[ne.context,...he]:Se=he;const be=await ae.call(W,Se);return J?be:(0,P.revive)(be)};throw new f.ErrorNoTelemetry(`Property not found: ${String(W)}`)}})}se.toService=H;function re(ae){return ae[0]==="o"&&ae[1]==="n"&&k.isUpperAsciiLetter(ae.charCodeAt(2))}function Ee(ae){return/^onDynamic/.test(ae)&&k.isUpperAsciiLetter(ae.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(se){if(Array.isArray(se))return se;if(se&&typeof se=="object"&&typeof se.toString=="function"){const ie=se.toString();if(ie!=="[object Object]")return ie}return se}function K(se){return Array.isArray(se)?se.map(O):O(se)}function q(se,ie,H,re,Ee,ae,ne){ne=K(ne);const J=$[Ee],N=J[re%J.length];let W=[`%c[${se}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(ae)?(W=W.concat(ne),W.push(")")):W.push(ne),console.log.apply(console,W)}class fe{constructor(ie,H){this._outgoingPrefix=ie,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(ie,H,re,Ee,ae){this._totalOutgoing+=ie,q(this._outgoingPrefix,this._totalOutgoing,ie,H,re,Ee,ae)}logIncoming(ie,H,re,Ee,ae){this._totalIncoming+=ie,q(this._incomingPrefix,this._totalIncoming,ie,H,re,Ee,ae)}}e.IPCLogger=fe}),define(Ce[80],De([1,0,21,4,3,79]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var f;(function(i){i.enableDiagnostics=!1,i.records=[];const c=new WeakMap;let u=0;function v(l,h){if(!c.has(l)){const E=String(++u);c.set(l,E)}return c.get(l)}function S(l,h,E,R){if(!i.enableDiagnostics)return;const M=v(l,h);if(R instanceof C.VSBuffer||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const U=C.VSBuffer.alloc(R.byteLength);U.set(R),i.records.push({timestamp:Date.now(),id:M,label:h,type:E,buff:U})}else i.records.push({timestamp:Date.now(),id:M,label:h,type:E,data:R})}i.traceSocketEvent=S})(f||(e.SocketDiagnostics=f={}));var w;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w||(e.SocketCloseEventType=w={}));let g=null;function P(){return g||(g=C.VSBuffer.alloc(0)),g}class k{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(c){this._chunks.push(c),this._totalLength+=c.byteLength}read(c){return this._read(c,!0)}peek(c){return this._read(c,!1)}_read(c,u){if(c===0)return P();if(c>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===c){const h=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=c),h}if(this._chunks[0].byteLength>c){const h=this._chunks[0].slice(0,c);return u&&(this._chunks[0]=this._chunks[0].slice(c),this._totalLength-=c),h}const v=C.VSBuffer.alloc(c);let S=0,l=0;for(;c>0;){const h=this._chunks[l];if(h.byteLength>c){const E=h.slice(0,c);v.set(E,S),S+=c,u&&(this._chunks[l]=h.slice(c),this._totalLength-=c),c-=c}else v.set(h,S),S+=h.byteLength,u?(this._chunks.shift(),this._totalLength-=h.byteLength):l++,c-=h.byteLength}return v}}e.ChunkStream=k;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function _(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var D;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(D||(e.ProtocolConstants=D={}));class y{constructor(c,u,v,S){this.type=c,this.id=u,this.ack=v,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class n extends d.Disposable{constructor(c){super(),this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=c,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:_(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const v=this._state.messageType,S=this._state.id,l=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new y(v,S,l,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class o{constructor(c){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=c,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(c){if(this._isDisposed)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=C.VSBuffer.alloc(13);u.writeUInt8(c.type,0),u.writeUInt32BE(c.id,1),u.writeUInt32BE(c.ack,5),u.writeUInt32BE(c.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:_(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",c.data),this._writeSoon(u,c.data)}_bufferAdd(c,u){const v=this._totalLength===0;return this._data.push(c,u),this._totalLength+=c.byteLength+u.byteLength,v}_bufferTake(){const c=C.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,c}_writeSoon(c,u){this._bufferAdd(c,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const c=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this._socket.write(c)}}class a extends d.Disposable{constructor(c){super(),this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=c,this._socketWriter=this._register(new o(this._socket)),this._socketReader=this._register(new n(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(c){this._socketWriter.write(new y(1,0,0,c))}}e.Protocol=a;class m extends A.IPCClient{static fromSocket(c,u){return new m(new a(c),u)}get onDidDispose(){return this.protocol.onDidDispose}constructor(c,u,v=null){super(c,u,v),this.protocol=c}dispose(){super.dispose();const c=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),c.end()}}e.Client=m;class b{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(c){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(c):this._emitter.fire(c):this._bufferedMessages.push(c)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=b;class I{constructor(c){this.data=c,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let c=0,u=this._first;for(;u;)u=u.next,c++;return c}peek(){return this._first?this._first.data:null}toArray(){const c=[];let u=0,v=this._first;for(;v;)c[u++]=v.data,v=v.next;return c}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(c){const u=new I(c);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class r{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const c=Date.now();for(let u=0;u<r._HISTORY_LENGTH;u++)this.lastRuns[u]=c-1e3*u;setInterval(()=>{for(let u=r._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}load(){const c=Date.now(),u=(1+r._HISTORY_LENGTH)*1e3;let v=0;for(let S=0;S<r._HISTORY_LENGTH;S++)c-this.lastRuns[S]<=u&&v++;return 1-v/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(c){this._onControlMessage=new b,this.onControlMessage=this._onControlMessage.event,this._onMessage=new b,this.onMessage=this._onMessage.event,this._onDidDispose=new b,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new b,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new b,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c.loadEstimator??r.getInstance(),this._shouldSendKeepAlive=c.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new d.DisposableStore,this._socket=c.socket,this._socketWriter=this._socketDisposables.add(new o(this._socket)),this._socketReader=this._socketDisposables.add(new n(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.add(this._socket.onClose(u=>this._onSocketClose.fire(u))),c.initialChunk&&this._socketReader.acceptChunk(c.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const c=new y(5,0,0,P());this._socketWriter.write(c),this._socketWriter.flush()}sendPause(){const c=new y(7,0,0,P());this._socketWriter.write(c)}sendResume(){const c=new y(8,0,0,P());this._socketWriter.write(c)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(c,u){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new d.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=c,this._socketWriter=this._socketDisposables.add(new o(this._socket)),this._socketReader=this._socketDisposables.add(new n(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.add(this._socket.onClose(v=>this._onSocketClose.fire(v))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const c=new y(3,0,this._incomingAckId,P());this._socketWriter.write(c);const u=this._outgoingUnackMsg.toArray();for(let v=0,S=u.length;v<S;v++)this._socketWriter.write(u[v]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(c){if(c.ack>this._outgoingAckId){this._outgoingAckId=c.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=c.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this._incomingMsgId)if(c.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new y(6,0,0,P())))}else this._incomingMsgId=c.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(c.data);break}case 2:{this._onControlMessage.fire(c.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let v=0,S=u.length;v<S;v++)this._socketWriter.write(u[v]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(c){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const v=new y(1,u,this._incomingAckId,c);this._outgoingUnackMsg.push(v),this._isReconnecting||(this._socketWriter.write(v),this._recvAckCheck())}sendControl(c){const u=new y(2,0,0,c);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const c=Date.now()-this._incomingMsgLastTime;if(c>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-c+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const c=this._outgoingUnackMsg.peek(),u=Date.now()-c.writtenTime,v=Date.now()-this._socketReader.lastReadTime,S=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&v>=2e4&&S>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:v});return}const l=Math.max(2e4-u,2e4-v,2e4-S,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},l)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const c=new y(3,0,this._incomingAckId,P());this._socketWriter.write(c)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const c=new y(9,0,this._incomingAckId,P());this._socketWriter.write(c)}}e.PersistentProtocol=s}),define(Ce[180],De([1,0,46,13,21,22,178,8,4,3,23,100,98,79]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class D extends _.ChannelServer{constructor(o){super({send:a=>{try{process.send?.(a.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",a=>d.VSBuffer.wrap(Buffer.from(a,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.Server=D;class y{constructor(o,a){this.modulePath=o,this.options=a,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new w.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=a&&a.timeout?a.timeout:6e4;this.disposeDelayer=new L.Delayer(m),this.child=null,this._client=null}getChannel(o){const a=this;return{call(m,b,I){return a.requestPromise(o,m,b,I)},listen(m,b){return a.requestEvent(o,m,b)}}}requestPromise(o,a,m,b=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(f.canceled());this.disposeDelayer.cancel();const I=this.getCachedChannel(o),t=(0,L.createCancelablePromise)(i=>I.call(a,m,i)),r=b.onCancellationRequested(()=>t.cancel()),s=(0,g.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{r.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(o,a,m){if(!this.disposeDelayer)return w.Event.None;this.disposeDelayer.cancel();let b;const I=new w.Emitter({onWillAddFirstListener:()=>{b=this.getCachedChannel(o).listen(a,m)(I.fire,I),this.activeRequests.add(b)},onDidRemoveLastListener:()=>{this.activeRequests.delete(b),b.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return I.event}get client(){if(!this._client){const o=this.options&&this.options.args?this.options.args:[],a=Object.create(null);a.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(a.env={...a.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(a.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,p.removeDangerousEnvVariables)(a.env),this.child=(0,C.fork)(this.modulePath,o,a);const m=new w.Emitter;w.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,T.isRemoteConsoleLog)(c)){(0,T.log)(c,`IPC Library: ${this.options.serverName}`);return}m.fire(d.VSBuffer.wrap(Buffer.from(c,"base64")))});const I=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,t=c=>this.child&&this.child.connected&&I.send(c.buffer.toString("base64")),r=m.event,s={send:t,onMessage:r};this._client=new _.ChannelClient(s);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,u)=>{process.removeListener("exit",i),this.activeRequests.forEach(v=>(0,g.dispose)(v)),this.activeRequests.clear(),c!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+u),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:u})})}return this._client}getCachedChannel(o){let a=this.channels.get(o);return a||(a=this.client.getChannel(o),this.channels.set(o,a)),a}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(Ce[181],De([1,0,35,14]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function d(A,T,f,w,g,P){if(Array.isArray(A)){let k=0;for(const p of A){const _=d(p,T,f,w,g,P);if(_===10)return _;_>k&&(k=_)}return k}else{if(typeof A=="string")return w?A==="*"?5:A===f?10:0:0;if(A){const{language:k,pattern:p,scheme:_,hasAccessToAllModels:D,notebookType:y}=A;if(!w&&!D)return 0;y&&g&&(T=g);let n=0;if(_)if(_===T.scheme)n=10;else if(_==="*")n=5;else return 0;if(k)if(k===f)n=10;else if(k==="*")n=Math.max(n,5);else return 0;if(y)if(y===P)n=10;else if(y==="*"&&P!==void 0)n=Math.max(n,5);else return 0;if(p){let o;if(typeof p=="string"?o=p:o={...p,base:(0,L.normalize)(p.base)},o===T.fsPath||(0,C.match)(o,T.fsPath))n=10;else return 0}return n}else return 0}}e.score=d}),define(Ce[128],De([1,0,21,9]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var d;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(d||(d={}));function A(k){for(let p=0,_=k.length;p<_;p+=4){const D=k[p+0],y=k[p+1],n=k[p+2],o=k[p+3];k[p+0]=o,k[p+1]=n,k[p+2]=y,k[p+3]=D}}function T(k){const p=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return L.isLittleEndian()||A(p),C.VSBuffer.wrap(p)}function f(k){const p=k.buffer;if(L.isLittleEndian()||A(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const _=new Uint8Array(p.byteLength);return _.set(p),new Uint32Array(_.buffer,_.byteOffset,_.length/4)}}function w(k){const p=new Uint32Array(g(k));let _=0;if(p[_++]=k.id,k.type==="full")p[_++]=1,p[_++]=k.data.length,p.set(k.data,_),_+=k.data.length;else{p[_++]=2,p[_++]=k.deltas.length;for(const D of k.deltas)p[_++]=D.start,p[_++]=D.deleteCount,D.data?(p[_++]=D.data.length,p.set(D.data,_),_+=D.data.length):p[_++]=0}return T(p)}e.encodeSemanticTokensDto=w;function g(k){let p=0;if(p+=1+1,k.type==="full")p+=1+k.data.length;else{p+=1,p+=(1+1+1)*k.deltas.length;for(const _ of k.deltas)_.data&&(p+=_.data.length)}return p}function P(k){const p=f(k);let _=0;const D=p[_++];if(p[_++]===1){const a=p[_++],m=p.subarray(_,_+a);return _+=a,{id:D,type:"full",data:m}}const n=p[_++],o=[];for(let a=0;a<n;a++){const m=p[_++],b=p[_++],I=p[_++];let t;I>0&&(t=p.subarray(_,_+I),_+=I),o[a]={start:m,deleteCount:b,data:t}}return{id:D,type:"delta",deltas:o}}e.decodeSemanticTokensDto=P}),define(Ce[182],De([11,12]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Ce[129],De([1,0,18,23,9,163,122,182]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(le){le[le.None=0]="None",le[le.Keep=1]="Keep",le[le.Brackets=2]="Brackets",le[le.Advanced=3]="Advanced",le[le.Full=4]="Full"})(w||(e.EditorAutoIndentStrategy=w={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(ce){this._values=ce}hasChanged(ce){return this._values[ce]}}e.ConfigurationChangedEvent=g;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class k{constructor(ce,Ie,He,Ue){this.id=ce,this.name=Ie,this.defaultValue=He,this.schema=Ue}applyUpdate(ce,Ie){return _(ce,Ie)}compute(ce,Ie,He){return He}}class p{constructor(ce,Ie){this.newValue=ce,this.didChange=Ie}}e.ApplyUpdateResult=p;function _(le,ce){if(typeof le!="object"||typeof ce!="object"||!le||!ce)return new p(ce,le!==ce);if(Array.isArray(le)||Array.isArray(ce)){const He=Array.isArray(le)&&Array.isArray(ce)&&C.equals(le,ce);return new p(ce,!He)}let Ie=!1;for(const He in ce)if(ce.hasOwnProperty(He)){const Ue=_(le[He],ce[He]);Ue.didChange&&(le[He]=Ue.newValue,Ie=!0)}return new p(le,Ie)}class D{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,Ie){return _(ce,Ie)}validate(ce){return this.defaultValue}}class y{constructor(ce,Ie,He,Ue){this.id=ce,this.name=Ie,this.defaultValue=He,this.schema=Ue}applyUpdate(ce,Ie){return _(ce,Ie)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,Ie,He){return He}}function n(le,ce){return typeof le>"u"?ce:le==="false"?!1:!!le}e.boolean=n;class o extends y{constructor(ce,Ie,He,Ue=void 0){typeof Ue<"u"&&(Ue.type="boolean",Ue.default=He),super(ce,Ie,He,Ue)}validate(ce){return n(ce,this.defaultValue)}}function a(le,ce,Ie,He){if(typeof le>"u")return ce;let Ue=parseInt(le,10);return isNaN(Ue)?ce:(Ue=Math.max(Ie,Ue),Ue=Math.min(He,Ue),Ue|0)}e.clampedInt=a;class m extends y{static clampedInt(ce,Ie,He,Ue){return a(ce,Ie,He,Ue)}constructor(ce,Ie,He,Ue,Ye,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=He,rt.minimum=Ue,rt.maximum=Ye),super(ce,Ie,He,rt),this.minimum=Ue,this.maximum=Ye}validate(ce){return m.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function b(le,ce,Ie,He){if(typeof le>"u")return ce;const Ue=I.float(le,ce);return I.clamp(Ue,Ie,He)}e.clampedFloat=b;class I extends y{static clamp(ce,Ie,He){return ce<Ie?Ie:ce>He?He:ce}static float(ce,Ie){if(typeof ce=="number")return ce;if(typeof ce>"u")return Ie;const He=parseFloat(ce);return isNaN(He)?Ie:He}constructor(ce,Ie,He,Ue,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=He),super(ce,Ie,He,Ye),this.validationFn=Ue}validate(ce){return this.validationFn(I.float(ce,this.defaultValue))}}class t extends y{static string(ce,Ie){return typeof ce!="string"?Ie:ce}constructor(ce,Ie,He,Ue=void 0){typeof Ue<"u"&&(Ue.type="string",Ue.default=He),super(ce,Ie,He,Ue)}validate(ce){return t.string(ce,this.defaultValue)}}function r(le,ce,Ie,He){return typeof le!="string"?ce:He&&le in He?He[le]:Ie.indexOf(le)===-1?ce:le}e.stringSet=r;class s extends y{constructor(ce,Ie,He,Ue,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=Ue,Ye.default=He),super(ce,Ie,He,Ye),this._allowedValues=Ue}validate(ce){return r(ce,this.defaultValue,this._allowedValues)}}class i extends k{constructor(ce,Ie,He,Ue,Ye,rt,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=Ye,ot.default=Ue),super(ce,Ie,He,ot),this._allowedValues=Ye,this._convert=rt}validate(ce){return typeof ce!="string"?this.defaultValue:this._allowedValues.indexOf(ce)===-1?this.defaultValue:this._convert(ce)}}function c(le){switch(le){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",tags:["accessibility"],description:f.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,Ie,He){return He===0?ce.accessibilitySupport:He}}class v extends k{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(22,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:f.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{insertSpace:n(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(le){le[le.Hidden=0]="Hidden",le[le.Blink=1]="Blink",le[le.Smooth=2]="Smooth",le[le.Phase=3]="Phase",le[le.Expand=4]="Expand",le[le.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function l(le){switch(le){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(le){le[le.Line=1]="Line",le[le.Block=2]="Block",le[le.Underline=3]="Underline",le[le.LineThin=4]="LineThin",le[le.BlockOutline=5]="BlockOutline",le[le.UnderlineThin=6]="UnderlineThin"})(h||(e.TextEditorCursorStyle=h={}));function E(le){switch(le){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function R(le){switch(le){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class M extends D{constructor(){super(139)}compute(ce,Ie,He){const Ue=["monaco-editor"];return Ie.get(38)&&Ue.push(Ie.get(38)),ce.extraEditorClassName&&Ue.push(ce.extraEditorClassName),Ie.get(72)==="default"?Ue.push("mouse-default"):Ie.get(72)==="copy"&&Ue.push("mouse-copy"),Ie.get(109)&&Ue.push("showUnused"),Ie.get(137)&&Ue.push("showDeprecated"),Ue.join(" ")}}class U extends o{constructor(){super(36,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(ce,Ie,He){return He&&ce.emptySelectionClipboard}}class F extends k{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(40,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:f.localize(16,null),included:d.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:f.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{cursorMoveOnType:n(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":r(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":r(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(Ie.loop,this.defaultValue.loop)}}}class x extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(50,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?x.OFF:ce==="true"?x.ON:ce:ce?x.ON:x.OFF}}e.EditorFontLigatures=x;class $ extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(53,"fontVariations",$.OFF,{anyOf:[{type:"boolean",description:f.localize(22,null)},{type:"string",description:f.localize(23,null)}],description:f.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?$.OFF:ce==="true"?$.TRANSLATE:ce:ce?$.TRANSLATE:$.OFF}compute(ce,Ie,He){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=$;class O extends D{constructor(){super(49)}compute(ce,Ie,He){return ce.fontInfo}}class K extends y{constructor(){super(51,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(25,null)})}validate(ce){const Ie=I.float(ce,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:I.clamp(Ie,6,100)}compute(ce,Ie,He){return ce.fontInfo.fontSize}}class q extends k{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(52,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.MINIMUM_VALUE,maximum:q.MAXIMUM_VALUE,errorMessage:f.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(m.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,q.MINIMUM_VALUE,q.MAXIMUM_VALUE))}}class fe extends k{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[f.localize(28,null),f.localize(29,null),f.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(57,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:f.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:f.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:f.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:He,description:f.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:He,description:f.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:He,description:f.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:He,description:f.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:He,description:f.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{multiple:r(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??r(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??r(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??r(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??r(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??r(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class se extends k{constructor(){const ce={enabled:!0,delay:300,sticky:!0,above:!0};super(59,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:f.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:f.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:f.localize(44,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:f.localize(45,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:n(Ie.enabled,this.defaultValue.enabled),delay:m.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:n(Ie.sticky,this.defaultValue.sticky),above:n(Ie.above,this.defaultValue.above)}}}var ie;(function(le){le[le.None=0]="None",le[le.Text=1]="Text",le[le.Blocks=2]="Blocks"})(ie||(e.RenderMinimap=ie={}));class H extends D{constructor(){super(142)}compute(ce,Ie,He){return H.computeLayout(Ie,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const Ie=ce.height/ce.lineHeight,He=Math.floor(ce.paddingTop/ce.lineHeight);let Ue=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(Ue=Math.max(Ue,Ie-1));const Ye=(He+ce.viewLineCount+Ue)/(ce.pixelRatio*ce.height),rt=Math.floor(ce.viewLineCount/Ye);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Ue,desiredRatio:Ye,minimapLineCount:rt}}static _computeMinimapLayout(ce,Ie){const He=ce.outerWidth,Ue=ce.outerHeight,Ye=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const rt=Ie.stableMinimapLayoutInput,ot=rt&&ce.outerHeight===rt.outerHeight&&ce.lineHeight===rt.lineHeight&&ce.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&ce.pixelRatio===rt.pixelRatio&&ce.scrollBeyondLastLine===rt.scrollBeyondLastLine&&ce.paddingTop===rt.paddingTop&&ce.paddingBottom===rt.paddingBottom&&ce.minimap.enabled===rt.minimap.enabled&&ce.minimap.side===rt.minimap.side&&ce.minimap.size===rt.minimap.size&&ce.minimap.showSlider===rt.minimap.showSlider&&ce.minimap.renderCharacters===rt.minimap.renderCharacters&&ce.minimap.maxColumn===rt.minimap.maxColumn&&ce.minimap.scale===rt.minimap.scale&&ce.verticalScrollbarWidth===rt.verticalScrollbarWidth&&ce.isViewportWrapping===rt.isViewportWrapping,pt=ce.lineHeight,It=ce.typicalHalfwidthCharacterWidth,Xt=ce.scrollBeyondLastLine,Wt=ce.minimap.renderCharacters;let bt=Ye>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const Ot=ce.minimap.maxColumn,Nt=ce.minimap.size,qt=ce.minimap.side,At=ce.verticalScrollbarWidth,Rt=ce.viewLineCount,xt=ce.remainingWidth,Bt=ce.isViewportWrapping,Ht=Wt?2:3;let $t=Math.floor(Ye*Ue);const ct=$t/Ye;let dt=!1,jt=!1,Tt=Ht*bt,_t=bt/Ye,ft=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Te,extraLinesBeforeFirstLine:te,extraLinesBeyondLastLine:Oe,desiredRatio:Ve,minimapLineCount:Je}=H.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Xt,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:Ue,lineHeight:pt,pixelRatio:Ye});if(Rt/Je>1)dt=!0,jt=!0,bt=1,Tt=1,_t=bt/Ye;else{let nt=!1,vt=bt+1;if(Nt==="fit"){const yt=Math.ceil((te+Rt+Oe)*Tt);Bt&&ot&&xt<=Ie.stableFitRemainingWidth?(nt=!0,vt=Ie.stableFitMaxMinimapScale):nt=yt>$t}if(Nt==="fill"||nt){dt=!0;const yt=bt;Tt=Math.min(pt*Ye,Math.max(1,Math.floor(1/Ve))),Bt&&ot&&xt<=Ie.stableFitRemainingWidth&&(vt=Ie.stableFitMaxMinimapScale),bt=Math.min(vt,Math.max(1,Math.floor(Tt/Ht))),bt>yt&&(ft=Math.min(2,bt/yt)),_t=bt/Ye/ft,$t=Math.ceil(Math.max(Te,te+Rt+Oe)*Tt),Bt?(Ie.stableMinimapLayoutInput=ce,Ie.stableFitRemainingWidth=xt,Ie.stableFitMaxMinimapScale=bt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const kt=Math.floor(Ot*_t),Mt=Math.min(kt,Math.max(0,Math.floor((xt-At-2)*_t/(It+_t)))+e.MINIMAP_GUTTER_WIDTH);let St=Math.floor(Ye*Mt);const je=St/Ye;St=Math.floor(St*ft);const Le=Wt?1:2,Fe=qt==="left"?0:He-Mt-At;return{renderMinimap:Le,minimapLeft:Fe,minimapWidth:Mt,minimapHeightIsEditorHeight:dt,minimapIsSampling:jt,minimapScale:bt,minimapLineHeight:Tt,minimapCanvasInnerWidth:St,minimapCanvasInnerHeight:$t,minimapCanvasOuterWidth:je,minimapCanvasOuterHeight:ct}}static computeLayout(ce,Ie){const He=Ie.outerWidth|0,Ue=Ie.outerHeight|0,Ye=Ie.lineHeight|0,rt=Ie.lineNumbersDigitCount|0,ot=Ie.typicalHalfwidthCharacterWidth,pt=Ie.maxDigitWidth,It=Ie.pixelRatio,Xt=Ie.viewLineCount,Wt=ce.get(134),bt=Wt==="inherit"?ce.get(133):Wt,Ot=bt==="inherit"?ce.get(129):bt,Nt=ce.get(132),qt=Ie.isDominatedByLongLines,At=ce.get(56),Rt=ce.get(66).renderType!==0,xt=ce.get(67),Bt=ce.get(103),Ht=ce.get(82),$t=ce.get(71),ct=ce.get(101),dt=ct.verticalScrollbarSize,jt=ct.verticalHasArrows,Tt=ct.arrowSize,_t=ct.horizontalScrollbarSize,ft=ce.get(42),kt=ce.get(108)!=="never";let Mt=ce.get(64);ft&&kt&&(Mt+=16);let St=0;if(Rt){const lt=Math.max(rt,xt);St=Math.round(lt*pt)}let je=0;At&&(je=Ye*Ie.glyphMarginDecorationLaneCount);let Le=0,Fe=Le+je,Te=Fe+St,te=Te+Mt;const Oe=He-je-St-Mt;let Ve=!1,Je=!1,Ge=-1;bt==="inherit"&&qt?(Ve=!0,Je=!0):Ot==="on"||Ot==="bounded"?Je=!0:Ot==="wordWrapColumn"&&(Ge=Nt);const nt=H._computeMinimapLayout({outerWidth:He,outerHeight:Ue,lineHeight:Ye,typicalHalfwidthCharacterWidth:ot,pixelRatio:It,scrollBeyondLastLine:Bt,paddingTop:Ht.top,paddingBottom:Ht.bottom,minimap:$t,verticalScrollbarWidth:dt,viewLineCount:Xt,remainingWidth:Oe,isViewportWrapping:Je},Ie.memory||new P);nt.renderMinimap!==0&&nt.minimapLeft===0&&(Le+=nt.minimapWidth,Fe+=nt.minimapWidth,Te+=nt.minimapWidth,te+=nt.minimapWidth);const vt=Oe-nt.minimapWidth,yt=Math.max(1,Math.floor((vt-dt-2)/ot)),Et=jt?Tt:0;return Je&&(Ge=Math.max(1,yt),Ot==="bounded"&&(Ge=Math.min(Ge,Nt))),{width:He,height:Ue,glyphMarginLeft:Le,glyphMarginWidth:je,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Fe,lineNumbersWidth:St,decorationsLeft:Te,decorationsWidth:Mt,contentLeft:te,contentWidth:vt,minimap:nt,viewportColumn:yt,isWordWrapMinified:Ve,isViewportWrapping:Je,wrappingColumn:Ge,verticalScrollbarWidth:dt,horizontalScrollbarHeight:_t,overviewRuler:{top:Et,width:dt,height:Ue-2*Et,right:0}}}}e.EditorLayoutInfoComputer=H;class re extends k{constructor(){super(136,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[f.localize(46,null),f.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:f.localize(48,null)}})}validate(ce){return r(ce,"simple",["simple","advanced"])}compute(ce,Ie,He){return Ie.get(2)===2?"advanced":He}}class Ee extends k{constructor(){const ce={enabled:!0};super(63,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"boolean",default:ce.enabled,description:f.localize(49,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:n(ce.enabled,this.defaultValue.enabled)}}}class ae extends k{constructor(){const ce={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(113,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:f.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:10,description:f.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:f.localize(52,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:f.localize(53,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:n(Ie.enabled,this.defaultValue.enabled),maxLineCount:m.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends k{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(138,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:f.localize(54,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[f.localize(55,null),f.localize(56,null,d.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),f.localize(57,null,d.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),f.localize(58,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:f.localize(59,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:f.localize(60,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:f.localize(61,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:r(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:m.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:n(Ie.padding,this.defaultValue.padding)}}}class J extends k{constructor(){super(64,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):m.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,Ie,He){return He<0?m.clampedInt(-He*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class N extends I{constructor(){super(65,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>I.clamp(ce,0,150),{markdownDescription:f.localize(62,null)})}compute(ce,Ie,He){return ce.fontInfo.lineHeight}}class W extends k{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(71,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:f.localize(63,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:f.localize(64,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(65,null),f.localize(66,null),f.localize(67,null)],default:ce.size,description:f.localize(68,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:f.localize(69,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:f.localize(70,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(71,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:f.localize(72,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:f.localize(73,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:n(Ie.enabled,this.defaultValue.enabled),autohide:n(Ie.autohide,this.defaultValue.autohide),size:r(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Ie.side,this.defaultValue.side,["right","left"]),showSlider:r(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt(Ie.scale,1,1,3),maxColumn:m.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function he(le){return le==="ctrlCmd"?d.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Se extends k{constructor(){super(82,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(74,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(75,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{top:m.clampedInt(Ie.top,0,0,1e3),bottom:m.clampedInt(Ie.bottom,0,0,1e3)}}}class be extends k{constructor(){const ce={enabled:!0,cycle:!0};super(84,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:f.localize(76,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:f.localize(77,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:n(Ie.enabled,this.defaultValue.enabled),cycle:n(Ie.cycle,this.defaultValue.cycle)}}}class we extends D{constructor(){super(140)}compute(ce,Ie,He){return ce.pixelRatio}}class ye extends k{constructor(){const ce={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[f.localize(78,null),f.localize(79,null),f.localize(80,null)]}];super(87,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ce.strings,description:f.localize(81,null)},comments:{anyOf:Ie,default:ce.comments,description:f.localize(82,null)},other:{anyOf:Ie,default:ce.other,description:f.localize(83,null)}},default:ce,markdownDescription:f.localize(84,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const It=ce?"on":"off";return{comments:It,strings:It,other:It}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:Ie,comments:He,strings:Ue}=ce,Ye=["on","inline","off"];let rt,ot,pt;return typeof Ie=="boolean"?rt=Ie?"on":"off":rt=r(Ie,this.defaultValue.other,Ye),typeof He=="boolean"?ot=He?"on":"off":ot=r(He,this.defaultValue.comments,Ye),typeof Ue=="boolean"?pt=Ue?"on":"off":pt=r(Ue,this.defaultValue.strings,Ye),{other:rt,comments:ot,strings:pt}}}var V;(function(le){le[le.Off=0]="Off",le[le.On=1]="On",le[le.Relative=2]="Relative",le[le.Interval=3]="Interval",le[le.Custom=4]="Custom"})(V||(e.RenderLineNumbersType=V={}));class ee extends k{constructor(){super(66,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(85,null),f.localize(86,null),f.localize(87,null),f.localize(88,null)],default:"on",description:f.localize(89,null)})}validate(ce){let Ie=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(Ie=4,He=ce):ce==="interval"?Ie=3:ce==="relative"?Ie=2:ce==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:He}}}function G(le){const ce=le.get(96);return ce==="editable"?le.get(89):ce!=="on"}e.filterValidationDecorations=G;class Y extends k{constructor(){const ce=[],Ie={type:"number",description:f.localize(90,null)};super(100,"rulers",ce,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:f.localize(91,null),format:"color-hex"}}}]},default:ce,description:f.localize(92,null)})}validate(ce){if(Array.isArray(ce)){const Ie=[];for(const He of ce)if(typeof He=="number")Ie.push({column:m.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Ue=He;Ie.push({column:m.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return Ie.sort((He,Ue)=>He.column-Ue.column),Ie}return this.defaultValue}}class de extends k{constructor(){super(90,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function ke(le,ce){if(typeof le!="string")return ce;switch(le){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends k{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(101,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(93,null),f.localize(94,null),f.localize(95,null)],default:"auto",description:f.localize(96,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(97,null),f.localize(98,null),f.localize(99,null)],default:"auto",description:f.localize(100,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:f.localize(101,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:f.localize(102,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:f.localize(103,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce,He=m.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=m.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ke(Ie.vertical,this.defaultValue.vertical),horizontal:ke(Ie.horizontal,this.defaultValue.horizontal),useShadows:n(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:m.clampedInt(Ie.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:m.clampedInt(Ie.verticalSliderSize,Ue,0,1e3),scrollByPage:n(Ie.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class X extends k{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(123,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:f.localize(104,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:f.localize(105,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:f.localize(106,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:f.localize(107,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:f.localize(108,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:f.localize(109,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:f.localize(110,null)}})}applyUpdate(ce,Ie){let He=!1;Ie.allowedCharacters&&ce&&(L.equals(ce.allowedCharacters,Ie.allowedCharacters)||(ce={...ce,allowedCharacters:Ie.allowedCharacters},He=!0)),Ie.allowedLocales&&ce&&(L.equals(ce.allowedLocales,Ie.allowedLocales)||(ce={...ce,allowedLocales:Ie.allowedLocales},He=!0));const Ue=super.applyUpdate(ce,Ie);return He?new p(Ue.newValue,!0):Ue}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{nonBasicASCII:ue(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ue(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ue(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ce.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ce,Ie){if(typeof ce!="object"||!ce)return Ie;const He={};for(const[Ue,Ye]of Object.entries(ce))Ye===!0&&(He[Ue]=!0);return He}}class Z extends k{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(61,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:f.localize(111,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover"],enumDescriptions:[f.localize(112,null),f.localize(113,null)],description:f.localize(114,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:f.localize(115,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:n(Ie.enabled,this.defaultValue.enabled),mode:r(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:n(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends k{constructor(){const ce={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(14,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:f.localize(116,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:f.localize(117,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:n(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends k{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(15,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(118,null),f.localize(119,null),f.localize(120,null)],default:ce.bracketPairs,description:f.localize(121,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(122,null),f.localize(123,null),f.localize(124,null)],default:ce.bracketPairsHorizontal,description:f.localize(125,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:f.localize(126,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:f.localize(127,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[f.localize(128,null),f.localize(129,null),f.localize(130,null)],default:ce.highlightActiveIndentation,description:f.localize(131,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{bracketPairs:ue(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ue(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:ue(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ue(le,ce,Ie){const He=Ie.indexOf(le);return He===-1?ce:Ie[He]}class ve extends k{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(116,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(132,null),f.localize(133,null)],default:ce.insertMode,description:f.localize(134,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:f.localize(135,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:f.localize(136,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:f.localize(137,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[f.localize(138,null),f.localize(139,null),f.localize(140,null),f.localize(141,null)],default:ce.selectionMode,markdownDescription:f.localize(142,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:f.localize(143,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:f.localize(144,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:f.localize(145,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:f.localize(146,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:f.localize(147,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(148,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(149,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(150,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(151,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(152,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(153,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:f.localize(154,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(155,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(156,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(157,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(158,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(159,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(160,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(161,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(162,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(163,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(164,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(165,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(166,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(167,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(168,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(169,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(170,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(171,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(172,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(173,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(174,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(175,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(176,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(177,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(178,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(179,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{insertMode:r(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:n(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:n(Ie.preview,this.defaultValue.preview),previewMode:r(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(Ie.showMethods,this.defaultValue.showMethods),showFunctions:n(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:n(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(Ie.showFields,this.defaultValue.showFields),showVariables:n(Ie.showVariables,this.defaultValue.showVariables),showClasses:n(Ie.showClasses,this.defaultValue.showClasses),showStructs:n(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:n(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:n(Ie.showModules,this.defaultValue.showModules),showProperties:n(Ie.showProperties,this.defaultValue.showProperties),showEvents:n(Ie.showEvents,this.defaultValue.showEvents),showOperators:n(Ie.showOperators,this.defaultValue.showOperators),showUnits:n(Ie.showUnits,this.defaultValue.showUnits),showValues:n(Ie.showValues,this.defaultValue.showValues),showConstants:n(Ie.showConstants,this.defaultValue.showConstants),showEnums:n(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:n(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(Ie.showKeywords,this.defaultValue.showKeywords),showWords:n(Ie.showWords,this.defaultValue.showWords),showColors:n(Ie.showColors,this.defaultValue.showColors),showFiles:n(Ie.showFiles,this.defaultValue.showFiles),showReferences:n(Ie.showReferences,this.defaultValue.showReferences),showFolders:n(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:n(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:n(Ie.showUsers,this.defaultValue.showUsers),showIssues:n(Ie.showIssues,this.defaultValue.showIssues)}}}class xe extends k{constructor(){super(111,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(180,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:f.localize(181,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(ce.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(le){le[le.None=0]="None",le[le.Same=1]="Same",le[le.Indent=2]="Indent",le[le.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class Ze extends k{constructor(){super(135,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[f.localize(182,null),f.localize(183,null),f.localize(184,null),f.localize(185,null)],description:f.localize(186,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,Ie,He){return Ie.get(2)===2?0:He}}class Qe extends D{constructor(){super(143)}compute(ce,Ie,He){const Ue=Ie.get(142);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}class it extends k{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(35,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:f.localize(187,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:f.localize(188,null),enum:["afterDrop","never"],enumDescriptions:[f.localize(189,null),f.localize(190,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:n(Ie.enabled,this.defaultValue.enabled),showDropSelector:r(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends k{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(83,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:f.localize(191,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:f.localize(192,null),enum:["afterPaste","never"],enumDescriptions:[f.localize(193,null),f.localize(194,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:n(Ie.enabled,this.defaultValue.enabled),showPasteSelector:r(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",Me="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:d.isMacintosh?Me:d.isLinux?ze:Pe,fontWeight:"normal",fontSize:d.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(le){return e.editorOptionsRegistry[le.id]=le,le}var Xe;(function(le){le[le.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",le[le.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",le[le.accessibilitySupport=2]="accessibilitySupport",le[le.accessibilityPageSize=3]="accessibilityPageSize",le[le.ariaLabel=4]="ariaLabel",le[le.ariaRequired=5]="ariaRequired",le[le.autoClosingBrackets=6]="autoClosingBrackets",le[le.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",le[le.autoClosingDelete=8]="autoClosingDelete",le[le.autoClosingOvertype=9]="autoClosingOvertype",le[le.autoClosingQuotes=10]="autoClosingQuotes",le[le.autoIndent=11]="autoIndent",le[le.automaticLayout=12]="automaticLayout",le[le.autoSurround=13]="autoSurround",le[le.bracketPairColorization=14]="bracketPairColorization",le[le.guides=15]="guides",le[le.codeLens=16]="codeLens",le[le.codeLensFontFamily=17]="codeLensFontFamily",le[le.codeLensFontSize=18]="codeLensFontSize",le[le.colorDecorators=19]="colorDecorators",le[le.colorDecoratorsLimit=20]="colorDecoratorsLimit",le[le.columnSelection=21]="columnSelection",le[le.comments=22]="comments",le[le.contextmenu=23]="contextmenu",le[le.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",le[le.cursorBlinking=25]="cursorBlinking",le[le.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",le[le.cursorStyle=27]="cursorStyle",le[le.cursorSurroundingLines=28]="cursorSurroundingLines",le[le.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",le[le.cursorWidth=30]="cursorWidth",le[le.disableLayerHinting=31]="disableLayerHinting",le[le.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",le[le.domReadOnly=33]="domReadOnly",le[le.dragAndDrop=34]="dragAndDrop",le[le.dropIntoEditor=35]="dropIntoEditor",le[le.emptySelectionClipboard=36]="emptySelectionClipboard",le[le.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",le[le.extraEditorClassName=38]="extraEditorClassName",le[le.fastScrollSensitivity=39]="fastScrollSensitivity",le[le.find=40]="find",le[le.fixedOverflowWidgets=41]="fixedOverflowWidgets",le[le.folding=42]="folding",le[le.foldingStrategy=43]="foldingStrategy",le[le.foldingHighlight=44]="foldingHighlight",le[le.foldingImportsByDefault=45]="foldingImportsByDefault",le[le.foldingMaximumRegions=46]="foldingMaximumRegions",le[le.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",le[le.fontFamily=48]="fontFamily",le[le.fontInfo=49]="fontInfo",le[le.fontLigatures=50]="fontLigatures",le[le.fontSize=51]="fontSize",le[le.fontWeight=52]="fontWeight",le[le.fontVariations=53]="fontVariations",le[le.formatOnPaste=54]="formatOnPaste",le[le.formatOnType=55]="formatOnType",le[le.glyphMargin=56]="glyphMargin",le[le.gotoLocation=57]="gotoLocation",le[le.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",le[le.hover=59]="hover",le[le.inDiffEditor=60]="inDiffEditor",le[le.inlineSuggest=61]="inlineSuggest",le[le.letterSpacing=62]="letterSpacing",le[le.lightbulb=63]="lightbulb",le[le.lineDecorationsWidth=64]="lineDecorationsWidth",le[le.lineHeight=65]="lineHeight",le[le.lineNumbers=66]="lineNumbers",le[le.lineNumbersMinChars=67]="lineNumbersMinChars",le[le.linkedEditing=68]="linkedEditing",le[le.links=69]="links",le[le.matchBrackets=70]="matchBrackets",le[le.minimap=71]="minimap",le[le.mouseStyle=72]="mouseStyle",le[le.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",le[le.mouseWheelZoom=74]="mouseWheelZoom",le[le.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",le[le.multiCursorModifier=76]="multiCursorModifier",le[le.multiCursorPaste=77]="multiCursorPaste",le[le.multiCursorLimit=78]="multiCursorLimit",le[le.occurrencesHighlight=79]="occurrencesHighlight",le[le.overviewRulerBorder=80]="overviewRulerBorder",le[le.overviewRulerLanes=81]="overviewRulerLanes",le[le.padding=82]="padding",le[le.pasteAs=83]="pasteAs",le[le.parameterHints=84]="parameterHints",le[le.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",le[le.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",le[le.quickSuggestions=87]="quickSuggestions",le[le.quickSuggestionsDelay=88]="quickSuggestionsDelay",le[le.readOnly=89]="readOnly",le[le.readOnlyMessage=90]="readOnlyMessage",le[le.renameOnType=91]="renameOnType",le[le.renderControlCharacters=92]="renderControlCharacters",le[le.renderFinalNewline=93]="renderFinalNewline",le[le.renderLineHighlight=94]="renderLineHighlight",le[le.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",le[le.renderValidationDecorations=96]="renderValidationDecorations",le[le.renderWhitespace=97]="renderWhitespace",le[le.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",le[le.roundedSelection=99]="roundedSelection",le[le.rulers=100]="rulers",le[le.scrollbar=101]="scrollbar",le[le.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",le[le.scrollBeyondLastLine=103]="scrollBeyondLastLine",le[le.scrollPredominantAxis=104]="scrollPredominantAxis",le[le.selectionClipboard=105]="selectionClipboard",le[le.selectionHighlight=106]="selectionHighlight",le[le.selectOnLineNumbers=107]="selectOnLineNumbers",le[le.showFoldingControls=108]="showFoldingControls",le[le.showUnused=109]="showUnused",le[le.snippetSuggestions=110]="snippetSuggestions",le[le.smartSelect=111]="smartSelect",le[le.smoothScrolling=112]="smoothScrolling",le[le.stickyScroll=113]="stickyScroll",le[le.stickyTabStops=114]="stickyTabStops",le[le.stopRenderingLineAfter=115]="stopRenderingLineAfter",le[le.suggest=116]="suggest",le[le.suggestFontSize=117]="suggestFontSize",le[le.suggestLineHeight=118]="suggestLineHeight",le[le.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",le[le.suggestSelection=120]="suggestSelection",le[le.tabCompletion=121]="tabCompletion",le[le.tabIndex=122]="tabIndex",le[le.unicodeHighlighting=123]="unicodeHighlighting",le[le.unusualLineTerminators=124]="unusualLineTerminators",le[le.useShadowDOM=125]="useShadowDOM",le[le.useTabStops=126]="useTabStops",le[le.wordBreak=127]="wordBreak",le[le.wordSeparators=128]="wordSeparators",le[le.wordWrap=129]="wordWrap",le[le.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",le[le.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",le[le.wordWrapColumn=132]="wordWrapColumn",le[le.wordWrapOverride1=133]="wordWrapOverride1",le[le.wordWrapOverride2=134]="wordWrapOverride2",le[le.wrappingIndent=135]="wrappingIndent",le[le.wrappingStrategy=136]="wrappingStrategy",le[le.showDeprecated=137]="showDeprecated",le[le.inlayHints=138]="inlayHints",le[le.editorClassName=139]="editorClassName",le[le.pixelRatio=140]="pixelRatio",le[le.tabFocusMode=141]="tabFocusMode",le[le.layoutInfo=142]="layoutInfo",le[le.wrappingInfo=143]="wrappingInfo",le[le.defaultColorDecorators=144]="defaultColorDecorators",le[le.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn",le[le.inlineCompletionsAccessibilityVerbose=146]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(195,null)})),acceptSuggestionOnEnter:Re(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(196,null),""],markdownDescription:f.localize(197,null)})),accessibilitySupport:Re(new u),accessibilityPageSize:Re(new m(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(198,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",f.localize(199,null))),ariaRequired:Re(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new o(7,"screenReaderAnnounceInlineSuggestion",!0,{description:f.localize(200,null),tags:["accessibility"]})),autoClosingBrackets:Re(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(201,null),f.localize(202,null),""],description:f.localize(203,null)})),autoClosingDelete:Re(new s(8,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(204,null),""],description:f.localize(205,null)})),autoClosingOvertype:Re(new s(9,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(206,null),""],description:f.localize(207,null)})),autoClosingQuotes:Re(new s(10,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(208,null),f.localize(209,null),""],description:f.localize(210,null)})),autoIndent:Re(new i(11,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[f.localize(211,null),f.localize(212,null),f.localize(213,null),f.localize(214,null),f.localize(215,null)],description:f.localize(216,null)})),automaticLayout:Re(new o(12,"automaticLayout",!1)),autoSurround:Re(new s(13,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(217,null),f.localize(218,null),f.localize(219,null),""],description:f.localize(220,null)})),bracketPairColorization:Re(new oe),bracketPairGuides:Re(new Q),stickyTabStops:Re(new o(114,"stickyTabStops",!1,{description:f.localize(221,null)})),codeLens:Re(new o(16,"codeLens",!0,{description:f.localize(222,null)})),codeLensFontFamily:Re(new t(17,"codeLensFontFamily","",{description:f.localize(223,null)})),codeLensFontSize:Re(new m(18,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(224,null)})),colorDecorators:Re(new o(19,"colorDecorators",!0,{description:f.localize(225,null)})),colorDecoratorActivatedOn:Re(new s(145,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[f.localize(226,null),f.localize(227,null),f.localize(228,null)],description:f.localize(229,null)})),colorDecoratorsLimit:Re(new m(20,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:f.localize(230,null)})),columnSelection:Re(new o(21,"columnSelection",!1,{description:f.localize(231,null)})),comments:Re(new v),contextmenu:Re(new o(23,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new o(24,"copyWithSyntaxHighlighting",!0,{description:f.localize(232,null)})),cursorBlinking:Re(new i(25,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:f.localize(233,null)})),cursorSmoothCaretAnimation:Re(new s(26,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[f.localize(234,null),f.localize(235,null),f.localize(236,null)],description:f.localize(237,null)})),cursorStyle:Re(new i(27,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:f.localize(238,null)})),cursorSurroundingLines:Re(new m(28,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(239,null)})),cursorSurroundingLinesStyle:Re(new s(29,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(240,null),f.localize(241,null)],description:f.localize(242,null)})),cursorWidth:Re(new m(30,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(243,null)})),disableLayerHinting:Re(new o(31,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new o(32,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new o(33,"domReadOnly",!1)),dragAndDrop:Re(new o(34,"dragAndDrop",!0,{description:f.localize(244,null)})),emptySelectionClipboard:Re(new U),dropIntoEditor:Re(new it),stickyScroll:Re(new ae),experimentalWhitespaceRendering:Re(new s(37,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[f.localize(245,null),f.localize(246,null),f.localize(247,null)],description:f.localize(248,null)})),extraEditorClassName:Re(new t(38,"extraEditorClassName","")),fastScrollSensitivity:Re(new I(39,"fastScrollSensitivity",5,le=>le<=0?5:le,{markdownDescription:f.localize(249,null)})),find:Re(new F),fixedOverflowWidgets:Re(new o(41,"fixedOverflowWidgets",!1)),folding:Re(new o(42,"folding",!0,{description:f.localize(250,null)})),foldingStrategy:Re(new s(43,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(251,null),f.localize(252,null)],description:f.localize(253,null)})),foldingHighlight:Re(new o(44,"foldingHighlight",!0,{description:f.localize(254,null)})),foldingImportsByDefault:Re(new o(45,"foldingImportsByDefault",!1,{description:f.localize(255,null)})),foldingMaximumRegions:Re(new m(46,"foldingMaximumRegions",5e3,10,65e3,{description:f.localize(256,null)})),unfoldOnClickAfterEndOfLine:Re(new o(47,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(257,null)})),fontFamily:Re(new t(48,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(258,null)})),fontInfo:Re(new O),fontLigatures2:Re(new x),fontSize:Re(new K),fontWeight:Re(new q),fontVariations:Re(new $),formatOnPaste:Re(new o(54,"formatOnPaste",!1,{description:f.localize(259,null)})),formatOnType:Re(new o(55,"formatOnType",!1,{description:f.localize(260,null)})),glyphMargin:Re(new o(56,"glyphMargin",!0,{description:f.localize(261,null)})),gotoLocation:Re(new fe),hideCursorInOverviewRuler:Re(new o(58,"hideCursorInOverviewRuler",!1,{description:f.localize(262,null)})),hover:Re(new se),inDiffEditor:Re(new o(60,"inDiffEditor",!1)),letterSpacing:Re(new I(62,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,le=>I.clamp(le,-5,20),{description:f.localize(263,null)})),lightbulb:Re(new Ee),lineDecorationsWidth:Re(new J),lineHeight:Re(new N),lineNumbers:Re(new ee),lineNumbersMinChars:Re(new m(67,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new o(68,"linkedEditing",!1,{description:f.localize(264,null)})),links:Re(new o(69,"links",!0,{description:f.localize(265,null)})),matchBrackets:Re(new s(70,"matchBrackets","always",["always","near","never"],{description:f.localize(266,null)})),minimap:Re(new W),mouseStyle:Re(new s(72,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new I(73,"mouseWheelScrollSensitivity",1,le=>le===0?1:le,{markdownDescription:f.localize(267,null)})),mouseWheelZoom:Re(new o(74,"mouseWheelZoom",!1,{markdownDescription:f.localize(268,null)})),multiCursorMergeOverlapping:Re(new o(75,"multiCursorMergeOverlapping",!0,{description:f.localize(269,null)})),multiCursorModifier:Re(new i(76,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[f.localize(270,null),f.localize(271,null)],markdownDescription:f.localize(272,null)})),multiCursorPaste:Re(new s(77,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(273,null),f.localize(274,null)],markdownDescription:f.localize(275,null)})),multiCursorLimit:Re(new m(78,"multiCursorLimit",1e4,1,1e5,{markdownDescription:f.localize(276,null)})),occurrencesHighlight:Re(new o(79,"occurrencesHighlight",!0,{description:f.localize(277,null)})),overviewRulerBorder:Re(new o(80,"overviewRulerBorder",!0,{description:f.localize(278,null)})),overviewRulerLanes:Re(new m(81,"overviewRulerLanes",3,0,3)),padding:Re(new Se),pasteAs:Re(new et),parameterHints:Re(new be),peekWidgetDefaultFocus:Re(new s(85,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(279,null),f.localize(280,null)],description:f.localize(281,null)})),definitionLinkOpensInPeek:Re(new o(86,"definitionLinkOpensInPeek",!1,{description:f.localize(282,null)})),quickSuggestions:Re(new ye),quickSuggestionsDelay:Re(new m(88,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(283,null)})),readOnly:Re(new o(89,"readOnly",!1)),readOnlyMessage:Re(new de),renameOnType:Re(new o(91,"renameOnType",!1,{description:f.localize(284,null),markdownDeprecationMessage:f.localize(285,null)})),renderControlCharacters:Re(new o(92,"renderControlCharacters",!0,{description:f.localize(286,null),restricted:!0})),renderFinalNewline:Re(new s(93,"renderFinalNewline",d.isLinux?"dimmed":"on",["off","on","dimmed"],{description:f.localize(287,null)})),renderLineHighlight:Re(new s(94,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(288,null)],description:f.localize(289,null)})),renderLineHighlightOnlyWhenFocus:Re(new o(95,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(290,null)})),renderValidationDecorations:Re(new s(96,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new s(97,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(291,null),f.localize(292,null),f.localize(293,null),""],description:f.localize(294,null)})),revealHorizontalRightPadding:Re(new m(98,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new o(99,"roundedSelection",!0,{description:f.localize(295,null)})),rulers:Re(new Y),scrollbar:Re(new B),scrollBeyondLastColumn:Re(new m(102,"scrollBeyondLastColumn",4,0,1073741824,{description:f.localize(296,null)})),scrollBeyondLastLine:Re(new o(103,"scrollBeyondLastLine",!0,{description:f.localize(297,null)})),scrollPredominantAxis:Re(new o(104,"scrollPredominantAxis",!0,{description:f.localize(298,null)})),selectionClipboard:Re(new o(105,"selectionClipboard",!0,{description:f.localize(299,null),included:d.isLinux})),selectionHighlight:Re(new o(106,"selectionHighlight",!0,{description:f.localize(300,null)})),selectOnLineNumbers:Re(new o(107,"selectOnLineNumbers",!0)),showFoldingControls:Re(new s(108,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[f.localize(301,null),f.localize(302,null),f.localize(303,null)],description:f.localize(304,null)})),showUnused:Re(new o(109,"showUnused",!0,{description:f.localize(305,null)})),showDeprecated:Re(new o(137,"showDeprecated",!0,{description:f.localize(306,null)})),inlayHints:Re(new ne),snippetSuggestions:Re(new s(110,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(307,null),f.localize(308,null),f.localize(309,null),f.localize(310,null)],description:f.localize(311,null)})),smartSelect:Re(new xe),smoothScrolling:Re(new o(112,"smoothScrolling",!1,{description:f.localize(312,null)})),stopRenderingLineAfter:Re(new m(115,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new ve),inlineSuggest:Re(new Z),inlineCompletionsAccessibilityVerbose:Re(new o(146,"inlineCompletionsAccessibilityVerbose",!1,{description:f.localize(313,null)})),suggestFontSize:Re(new m(117,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(314,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new m(118,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(315,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new o(119,"suggestOnTriggerCharacters",!0,{description:f.localize(316,null)})),suggestSelection:Re(new s(120,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(317,null),f.localize(318,null),f.localize(319,null)],description:f.localize(320,null)})),tabCompletion:Re(new s(121,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(321,null),f.localize(322,null),f.localize(323,null)],description:f.localize(324,null)})),tabIndex:Re(new m(122,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new X),unusualLineTerminators:Re(new s(124,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(325,null),f.localize(326,null),f.localize(327,null)],description:f.localize(328,null)})),useShadowDOM:Re(new o(125,"useShadowDOM",!0)),useTabStops:Re(new o(126,"useTabStops",!0,{description:f.localize(329,null)})),wordBreak:Re(new s(127,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[f.localize(330,null),f.localize(331,null)],description:f.localize(332,null)})),wordSeparators:Re(new t(128,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:f.localize(333,null)})),wordWrap:Re(new s(129,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(334,null),f.localize(335,null),f.localize(336,null),f.localize(337,null)],description:f.localize(338,null)})),wordWrapBreakAfterCharacters:Re(new t(130,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(131,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new m(132,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(339,null)})),wordWrapOverride1:Re(new s(133,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new s(134,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new M),defaultColorDecorators:Re(new o(144,"defaultColorDecorators",!1,{markdownDescription:f.localize(340,null)})),pixelRatio:Re(new we),tabFocusMode:Re(new o(141,"tabFocusMode",!1,{markdownDescription:f.localize(341,null)})),layoutInfo:Re(new H),wrappingInfo:Re(new Qe),wrappingIndent:Re(new Ze),wrappingStrategy:Re(new re)}}),define(Ce[183],De([11,12]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(Ce[81],De([1,0,76,2,161,34,171,183]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.getAriaLabelForSymbol=e.symbolKindNames=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class w{constructor(x,$,O){this.offset=x,this.type=$,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=w;class g{constructor(x,$){this.tokens=x,this.endState=$,this._tokenizationResultBrand=void 0}}e.TokenizationResult=g;class P{constructor(x,$){this.tokens=x,this.endState=$,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=P;var k;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(k||(e.CompletionItemKind=k={}));var p;(function(F){const x=new Map;x.set(0,C.Codicon.symbolMethod),x.set(1,C.Codicon.symbolFunction),x.set(2,C.Codicon.symbolConstructor),x.set(3,C.Codicon.symbolField),x.set(4,C.Codicon.symbolVariable),x.set(5,C.Codicon.symbolClass),x.set(6,C.Codicon.symbolStruct),x.set(7,C.Codicon.symbolInterface),x.set(8,C.Codicon.symbolModule),x.set(9,C.Codicon.symbolProperty),x.set(10,C.Codicon.symbolEvent),x.set(11,C.Codicon.symbolOperator),x.set(12,C.Codicon.symbolUnit),x.set(13,C.Codicon.symbolValue),x.set(15,C.Codicon.symbolEnum),x.set(14,C.Codicon.symbolConstant),x.set(15,C.Codicon.symbolEnum),x.set(16,C.Codicon.symbolEnumMember),x.set(17,C.Codicon.symbolKeyword),x.set(27,C.Codicon.symbolSnippet),x.set(18,C.Codicon.symbolText),x.set(19,C.Codicon.symbolColor),x.set(20,C.Codicon.symbolFile),x.set(21,C.Codicon.symbolReference),x.set(22,C.Codicon.symbolCustomColor),x.set(23,C.Codicon.symbolFolder),x.set(24,C.Codicon.symbolTypeParameter),x.set(25,C.Codicon.account),x.set(26,C.Codicon.issues);function $(q){let fe=x.get(q);return fe||(console.info("No codicon found for CompletionItemKind "+q),fe=C.Codicon.symbolProperty),fe}F.toIcon=$;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function K(q,fe){let se=O.get(q);return typeof se>"u"&&!fe&&(se=9),se}F.fromString=K})(p||(e.CompletionItemKinds=p={}));var _;(function(F){F[F.Deprecated=1]="Deprecated"})(_||(e.CompletionItemTag=_={}));var D;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(D||(e.CompletionItemInsertTextRule=D={}));var y;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y||(e.CompletionTriggerKind=y={}));var n;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(n||(e.InlineCompletionTriggerKind=n={}));class o{constructor(x,$,O,K){this.range=x,this.text=$,this.completionKind=O,this.isSnippetText=K}equals(x){return A.Range.lift(this.range).equalsRange(x.range)&&this.text===x.text&&this.completionKind===x.completionKind&&this.isSnippetText===x.isSnippetText}}e.SelectedSuggestionInfo=o;var a;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(a||(e.CodeActionTriggerType=a={}));var m;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(m||(e.SignatureHelpTriggerKind=m={}));var b;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(b||(e.DocumentHighlightKind=b={}));function I(F){return F&&L.URI.isUri(F.uri)&&A.Range.isIRange(F.range)&&(A.Range.isIRange(F.originSelectionRange)||A.Range.isIRange(F.targetSelectionRange))}e.isLocationLink=I;var t;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.symbolKindNames={[17]:(0,f.localize)(0,null),[16]:(0,f.localize)(1,null),[4]:(0,f.localize)(2,null),[13]:(0,f.localize)(3,null),[8]:(0,f.localize)(4,null),[9]:(0,f.localize)(5,null),[21]:(0,f.localize)(6,null),[23]:(0,f.localize)(7,null),[7]:(0,f.localize)(8,null),[0]:(0,f.localize)(9,null),[11]:(0,f.localize)(10,null),[10]:(0,f.localize)(11,null),[19]:(0,f.localize)(12,null),[5]:(0,f.localize)(13,null),[1]:(0,f.localize)(14,null),[2]:(0,f.localize)(15,null),[20]:(0,f.localize)(16,null),[15]:(0,f.localize)(17,null),[18]:(0,f.localize)(18,null),[24]:(0,f.localize)(19,null),[3]:(0,f.localize)(20,null),[6]:(0,f.localize)(21,null),[14]:(0,f.localize)(22,null),[22]:(0,f.localize)(23,null),[25]:(0,f.localize)(24,null),[12]:(0,f.localize)(25,null)};function r(F,x){return(0,f.localize)(26,null,F,e.symbolKindNames[x])}e.getAriaLabelForSymbol=r;var s;(function(F){F[F.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var i;(function(F){const x=new Map;x.set(0,C.Codicon.symbolFile),x.set(1,C.Codicon.symbolModule),x.set(2,C.Codicon.symbolNamespace),x.set(3,C.Codicon.symbolPackage),x.set(4,C.Codicon.symbolClass),x.set(5,C.Codicon.symbolMethod),x.set(6,C.Codicon.symbolProperty),x.set(7,C.Codicon.symbolField),x.set(8,C.Codicon.symbolConstructor),x.set(9,C.Codicon.symbolEnum),x.set(10,C.Codicon.symbolInterface),x.set(11,C.Codicon.symbolFunction),x.set(12,C.Codicon.symbolVariable),x.set(13,C.Codicon.symbolConstant),x.set(14,C.Codicon.symbolString),x.set(15,C.Codicon.symbolNumber),x.set(16,C.Codicon.symbolBoolean),x.set(17,C.Codicon.symbolArray),x.set(18,C.Codicon.symbolObject),x.set(19,C.Codicon.symbolKey),x.set(20,C.Codicon.symbolNull),x.set(21,C.Codicon.symbolEnumMember),x.set(22,C.Codicon.symbolStruct),x.set(23,C.Codicon.symbolEvent),x.set(24,C.Codicon.symbolOperator),x.set(25,C.Codicon.symbolTypeParameter);function $(O){let K=x.get(O);return K||(console.info("No codicon found for SymbolKind "+O),K=C.Codicon.symbolProperty),K}F.toIcon=$})(i||(e.SymbolKinds=i={}));class c{static asEditOperation(x){return d.EditOperation.replace(A.Range.lift(x.range),x.text)}}e.TextEdit=c;class u{static{this.Comment=new u("comment")}static{this.Imports=new u("imports")}static{this.Region=new u("region")}static fromValue(x){switch(x){case"comment":return u.Comment;case"imports":return u.Imports;case"region":return u.Region}return new u(x)}constructor(x){this.value=x}}e.FoldingRangeKind=u;var v;(function(F){function x($){return!$||typeof $!="object"?!1:typeof $.id=="string"&&typeof $.title=="string"}F.is=x})(v||(e.Command=v={}));var S;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(S||(e.CommentThreadCollapsibleState=S={}));var l;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(l||(e.CommentThreadState=l={}));var h;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(h||(e.CommentMode=h={}));var E;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(E||(e.CommentState=E={}));var R;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(R||(e.InlayHintKind=R={}));class M{constructor(x){this.createSupport=x,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(x=>{x&&x.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=M,e.TokenizationRegistry=new T.TokenizationRegistry;var U;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(U||(e.ExternalUriOpenerPriority=U={}))}),define(Ce[184],De([11,12]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[185],De([11,12]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[186],De([11,12]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[187],De([11,12]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[188],De([11,12]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[189],De([11,12]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ce[190],De([11,12]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Ce[191],De([11,12]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(Ce[192],De([11,12]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ce[193],De([11,12]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Ce[194],De([11,12]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[195],De([11,12]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Ce[196],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostChat",e)}),define(Ce[197],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[198],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[199],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[200],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[201],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[202],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[203],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[204],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[205],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[206],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[207],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[208],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[209],De([11,12]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ce[210],De([11,12]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Ce[211],De([11,12]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Ce[212],De([11,12]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[213],De([11,12]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[214],De([11,12]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ce[215],De([11,12]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[216],De([11,12]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[217],De([11,12]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[218],De([11,12]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[219],De([11,12]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[220],De([1,0,8,186]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var d;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(d||(e.TokenType=d={}));function A(...g){switch(g.length){case 1:return(0,L.localize)(0,null,g[0]);case 2:return(0,L.localize)(1,null,g[0],g[1]);case 3:return(0,L.localize)(2,null,g[0],g[1],g[2]);default:return}}const T=(0,L.localize)(3,null),f=(0,L.localize)(4,null);class w{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,C.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(P){return this._input=P,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const k=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:k})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const k=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:k})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(P){return this._isAtEnd()||this._input.charCodeAt(this._current)!==P?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(P){this._tokens.push({type:P,offset:this._start})}_error(P){const k=this._start,p=this._input.substring(this._start,this._current),_={type:19,offset:this._start,lexeme:p};this._errors.push({offset:k,lexeme:p,additionalInfo:P}),this._tokens.push(_)}_string(){this.stringRe.lastIndex=this._start;const P=this.stringRe.exec(this._input);if(P){this._current=this._start+P[0].length;const k=this._input.substring(this._start,this._current),p=w._keywords.get(k);p?this._addToken(p):this._tokens.push({type:17,lexeme:k,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let P=this._current,k=!1,p=!1;for(;;){if(P>=this._input.length){this._current=P,this._error(f);return}const D=this._input.charCodeAt(P);if(k)k=!1;else if(D===47&&!p){P++;break}else D===91?p=!0:D===92?k=!0:D===93&&(p=!1);P++}for(;P<this._input.length&&w._regexFlags.has(this._input.charCodeAt(P));)P++;this._current=P;const _=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:_,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=w}),define(Ce[221],De([1,0,24,40,188,361]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,f=/^-(\d{4})(\d{2})(\d{2})$/;function w(o){return o=o.trim(),o==="*"||T.test(o)}e.isValidVersionStr=w;function g(o){if(!w(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=o.match(T);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.parseVersion=g;function P(o){if(!o)return null;const a=o.majorBase,m=o.majorMustEqual,b=o.minorBase;let I=o.minorMustEqual;const t=o.patchBase;let r=o.patchMustEqual;o.hasCaret&&(a===0||(I=!1),r=!1);let s=0;if(o.preRelease){const i=f.exec(o.preRelease);if(i){const[,c,u,v]=i;s=Date.UTC(Number(c),Number(u)-1,Number(v))}}return{majorBase:a,majorMustEqual:m,minorBase:b,minorMustEqual:I,patchBase:t,patchMustEqual:r,isMinimum:o.hasGreaterEquals,notBefore:s}}e.normalizeVersion=P;function k(o,a,m){let b;typeof o=="string"?b=P(g(o)):b=o;let I;a instanceof Date?I=a.getTime():typeof a=="string"&&(I=new Date(a).getTime());let t;if(typeof m=="string"?t=P(g(m)):t=m,!b||!t)return!1;const r=b.majorBase,s=b.minorBase,i=b.patchBase;let c=t.majorBase,u=t.minorBase,v=t.patchBase;const S=t.notBefore;let l=t.majorMustEqual,h=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?r>c?!0:r<c?!1:s>u?!0:s<u||I&&I<S?!1:i>=v:(r===1&&c===0&&(!l||!h||!E)&&(c=1,u=0,v=0,l=!0,h=!1,E=!1),r<c?!1:r>c?!l:s<u?!1:s>u?!h:i<v?!1:i>v?!E:!(I&&I<S))}e.isValidVersion=k;function p(o,a,m,b,I){const t=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return t.push([L.default.Error,d.localize(0,null)]),t;if(typeof b.name!="string")return t.push([L.default.Error,d.localize(1,null,"name")]),t;if(typeof b.version!="string")return t.push([L.default.Error,d.localize(2,null,"version")]),t;if(!b.engines)return t.push([L.default.Error,d.localize(3,null,"engines")]),t;if(typeof b.engines.vscode!="string")return t.push([L.default.Error,d.localize(4,null,"engines.vscode")]),t;if(typeof b.extensionDependencies<"u"&&!n(b.extensionDependencies))return t.push([L.default.Error,d.localize(5,null,"extensionDependencies")]),t;if(typeof b.activationEvents<"u"){if(!n(b.activationEvents))return t.push([L.default.Error,d.localize(6,null,"activationEvents")]),t;if(typeof b.main>"u"&&typeof b.browser>"u")return t.push([L.default.Error,d.localize(7,null,"activationEvents","main","browser")]),t}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&t.push([L.default.Warning,d.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return t.push([L.default.Error,d.localize(9,null,"main")]),t;{const i=(0,C.joinPath)(m,b.main);(0,C.isEqualOrParent)(i,m)||t.push([L.default.Warning,d.localize(10,null,i.path,m.path)])}}if(typeof b.browser<"u"){if(typeof b.browser!="string")return t.push([L.default.Error,d.localize(11,null,"browser")]),t;{const i=(0,C.joinPath)(m,b.browser);(0,C.isEqualOrParent)(i,m)||t.push([L.default.Warning,d.localize(12,null,i.path,m.path)])}}if(!A.valid(b.version))return t.push([L.default.Error,d.localize(13,null)]),t;const r=[];if(!_(o,a,b,I,r))for(const i of r)t.push([L.default.Error,i]);return t}e.validateExtensionManifest=p;function _(o,a,m,b,I){return b||typeof m.main>"u"&&typeof m.browser>"u"?!0:y(o,a,m.engines.vscode,I)}e.isValidExtensionVersion=_;function D(o,a,m){return o==="*"||y(a,m,o)}e.isEngineValid=D;function y(o,a,m,b=[]){const I=P(g(m));if(!I)return b.push(d.localize(14,null,m)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return b.push(d.localize(15,null,m)),!1}else if(!I.majorMustEqual)return b.push(d.localize(16,null,m)),!1;return k(o,a,I)?!0:(b.push(d.localize(17,null,o,m)),!1)}function n(o){if(!Array.isArray(o))return!1;for(let a=0,m=o.length;a<m;a++)if(typeof o[a]!="string")return!1;return!0}}),define(Ce[101],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class C{constructor(d,A=[],T=!1){this.ctor=d,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=C}),define(Ce[102],De([1,0,101]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var d;(function(f){f[f.Eager=0]="Eager",f[f.Delayed=1]="Delayed"})(d||(e.InstantiationType=d={}));function A(f,w,g){w instanceof C.SyncDescriptor||(w=new C.SyncDescriptor(w,[],!!g)),L.push([f,w])}e.registerSingleton=A;function T(){return L}e.getSingletonServiceDescriptors=T}),define(Ce[222],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class C{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=C;class L{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const f=this.lookupOrInsertNode(A),w=this.lookupOrInsertNode(T);f.outgoing.set(w.key,w),w.incoming.set(f.key,f)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(const f of this._nodes.values())f.outgoing.delete(T),f.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let f=this._nodes.get(T);return f||(f=new C(T,A),this._nodes.set(T,f)),f}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[T,f]of this._nodes)A.push(`${T}
	(-> incoming)[${[...f.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...f.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this._nodes){const f=new Set([A]),w=this._findCycle(T,f);if(w)return w}}_findCycle(A,T){for(const[f,w]of A.outgoing){if(T.has(f))return[...T,f].join(" -> ");T.add(f);const g=this._findCycle(w,T);if(g)return g;T.delete(f)}}}e.Graph=L}),define(Ce[6],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var C;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function f(w){return w[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=f})(C||(e._util=C={})),e.IInstantiationService=d("instantiationService");function L(T,f,w){f[C.DI_TARGET]===f?f[C.DI_DEPENDENCIES].push({id:T,index:w}):(f[C.DI_DEPENDENCIES]=[{id:T,index:w}],f[C.DI_TARGET]=f)}function d(T){if(C.serviceIds.has(T))return C.serviceIds.get(T);const f=function(w,g,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(f,w,P)};return f.toString=()=>T,C.serviceIds.set(T,f),f}e.createDecorator=d;function A(T){return T}e.refineServiceDecorator=A}),define(Ce[50],De([1,0,19,2,6]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,d.createDecorator)("configurationService");function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof L.URI)}e.isConfigurationOverrides=A;function T(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=T;var f;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(f||(e.ConfigurationTarget=f={}));function w(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function g(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.isConfigured=g;function P(o,a){const m=Object.create(null);for(const b in o)k(m,b,o[b],a);return m}e.toValuesTree=P;function k(o,a,m,b){const I=a.split("."),t=I.pop();let r=o;for(let s=0;s<I.length;s++){const i=I[s];let c=r[i];switch(typeof c){case"undefined":c=r[i]=Object.create(null);break;case"object":break;default:b(`Ignoring ${a} as ${I.slice(0,s+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[t]=m}catch{b(`Ignoring ${a} as ${I.join(".")} is ${JSON.stringify(r)}`)}else b(`Ignoring ${a} as ${I.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=k;function p(o,a){const m=a.split(".");_(o,m)}e.removeFromValueTree=p;function _(o,a){const m=a.shift();if(a.length===0){delete o[m];return}if(Object.keys(o).indexOf(m)!==-1){const b=o[m];typeof b=="object"&&!Array.isArray(b)&&(_(b,a),Object.keys(b).length===0&&delete o[m])}}function D(o,a,m){function b(r,s){let i=r;for(const c of s){if(typeof i!="object"||i===null)return;i=i[c]}return i}const I=a.split("."),t=b(o,I);return typeof t>"u"?m:t}e.getConfigurationValue=D;function y(o,a,m){Object.keys(a).forEach(b=>{b!=="__proto__"&&(b in o?C.isObject(o[b])&&C.isObject(a[b])?y(o[b],a[b],m):m&&(o[b]=a[b]):o[b]=a[b])})}e.merge=y;function n(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=n}),define(Ce[47],De([1,0,9,15,220,6,185,8]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const w=new Map;w.set("false",!1),w.set("true",!0),w.set("isMac",C.isMacintosh),w.set("isLinux",C.isLinux),w.set("isWindows",C.isWindows),w.set("isWeb",C.isWeb),w.set("isMacNative",C.isMacintosh&&!C.isWeb),w.set("isEdge",C.isEdge),w.set("isFirefox",C.isFirefox),w.set("isChrome",C.isChrome),w.set("isSafari",C.isSafari);function g(J,N){if(w.get(J)!==void 0)throw(0,f.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");w.set(J,N)}e.setConstant=g;const P=Object.prototype.hasOwnProperty;var k;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const p={regexParsingWithErrorRecovery:!0},_=(0,T.localize)(0,null),D=(0,T.localize)(1,null),y=(0,T.localize)(2,null),n=(0,T.localize)(3,null),o=(0,T.localize)(4,null),a=(0,T.localize)(5,null),m=(0,T.localize)(6,null),b=(0,T.localize)(7,null);class I{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(N=p){this._config=N,this._scanner=new d.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(N){if(N===""){this._parsingErrors.push({message:_,offset:0,lexeme:"",additionalInfo:D});return}this._tokens=this._scanner.reset(N).scan(),this._current=0,this._parsingErrors=[];try{const W=this._expr();if(!this._isAtEnd()){const he=this._peek(),Se=he.type===17?a:void 0;throw this._parsingErrors.push({message:o,offset:he.offset,lexeme:d.Scanner.getLexeme(he),additionalInfo:Se}),I._parseError}return W}catch(W){if(W!==I._parseError)throw W;return}}_expr(){return this._or()}_or(){const N=[this._and()];for(;this._matchOne(16);){const W=this._and();N.push(W)}return N.length===1?N[0]:t.or(...N)}_and(){const N=[this._term()];for(;this._matchOne(15);){const W=this._term();N.push(W)}return N.length===1?N[0]:t.and(...N)}_term(){if(this._matchOne(2)){const N=this._peek();switch(N.type){case 11:return this._advance(),c.INSTANCE;case 12:return this._advance(),u.INSTANCE;case 0:{this._advance();const W=this._expr();return this._consume(1,n),W?.negate()}case 17:return this._advance(),R.create(N.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",N)}}return this._primary()}_primary(){const N=this._peek();switch(N.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const W=this._expr();return this._consume(1,n),W}case 17:{const W=N.lexeme;if(this._advance(),this._matchOne(9)){const Se=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Se.type!==10)throw this._errExpectedButGot("REGEX",Se);const be=Se.lexeme,we=be.lastIndexOf("/"),ye=we===be.length-1?void 0:this._removeFlagsGY(be.substring(we+1));let V;try{V=new RegExp(be.substring(1,we),ye)}catch{throw this._errExpectedButGot("REGEX",Se)}return O.create(W,V)}switch(Se.type){case 10:case 19:{const be=[Se.lexeme];this._advance();let we=this._peek(),ye=0;for(let de=0;de<Se.lexeme.length;de++)Se.lexeme.charCodeAt(de)===40?ye++:Se.lexeme.charCodeAt(de)===41&&ye--;for(;!this._isAtEnd()&&we.type!==15&&we.type!==16;){switch(we.type){case 0:ye++;break;case 1:ye--;break;case 10:case 18:for(let de=0;de<we.lexeme.length;de++)we.lexeme.charCodeAt(de)===40?ye++:Se.lexeme.charCodeAt(de)===41&&ye--}if(ye<0)break;be.push(d.Scanner.getLexeme(we)),this._advance(),we=this._peek()}const V=be.join(""),ee=V.lastIndexOf("/"),G=ee===V.length-1?void 0:this._removeFlagsGY(V.substring(ee+1));let Y;try{Y=new RegExp(V.substring(1,ee),G)}catch{throw this._errExpectedButGot("REGEX",Se)}return t.regex(W,Y)}case 18:{const be=Se.lexeme;this._advance();let we=null;if(!(0,L.isFalsyOrWhitespace)(be)){const ye=be.indexOf("/"),V=be.lastIndexOf("/");if(ye!==V&&ye>=0){const ee=be.slice(ye+1,V),G=be[V+1]==="i"?"i":"";try{we=new RegExp(ee,G)}catch{throw this._errExpectedButGot("REGEX",Se)}}}if(we===null)throw this._errExpectedButGot("REGEX",Se);return O.create(W,we)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,y);const Se=this._value();return t.notIn(W,Se)}switch(this._peek().type){case 3:{this._advance();const Se=this._value();if(this._previous().type===18)return t.equals(W,Se);switch(Se){case"true":return t.has(W);case"false":return t.not(W);default:return t.equals(W,Se)}}case 4:{this._advance();const Se=this._value();if(this._previous().type===18)return t.notEquals(W,Se);switch(Se){case"true":return t.not(W);case"false":return t.has(W);default:return t.notEquals(W,Se)}}case 5:return this._advance(),x.create(W,this._value());case 6:return this._advance(),$.create(W,this._value());case 7:return this._advance(),U.create(W,this._value());case 8:return this._advance(),F.create(W,this._value());case 13:return this._advance(),t.in(W,this._value());default:return t.has(W)}}case 20:throw this._parsingErrors.push({message:m,offset:N.offset,lexeme:"",additionalInfo:b}),I._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const N=this._peek();switch(N.type){case 17:case 18:return this._advance(),N.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(N){return N.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(N){return this._check(N)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(N,W){if(this._check(N))return this._advance();throw this._errExpectedButGot(W,this._peek())}_errExpectedButGot(N,W,he){const Se=(0,T.localize)(8,null,N,d.Scanner.getLexeme(W)),be=W.offset,we=d.Scanner.getLexeme(W);return this._parsingErrors.push({message:Se,offset:be,lexeme:we,additionalInfo:he}),I._parseError}_check(N){return this._peek().type===N}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=I;class t{static false(){return c.INSTANCE}static true(){return u.INSTANCE}static has(N){return v.create(N)}static equals(N,W){return S.create(N,W)}static notEquals(N,W){return E.create(N,W)}static regex(N,W){return O.create(N,W)}static in(N,W){return l.create(N,W)}static notIn(N,W){return h.create(N,W)}static not(N){return R.create(N)}static and(...N){return fe.create(N,null,!0)}static or(...N){return se.create(N,null,!0)}static greater(N,W){return U.create(N,W)}static greaterEquals(N,W){return F.create(N,W)}static smaller(N,W){return x.create(N,W)}static smallerEquals(N,W){return $.create(N,W)}static{this._parser=new I({regexParsingWithErrorRecovery:!1})}static deserialize(N){return N==null?void 0:this._parser.parse(N)}}e.ContextKeyExpr=t;function r(J){const N=new I({regexParsingWithErrorRecovery:!1});return J.map(W=>(N.parse(W),N.lexingErrors.length>0?N.lexingErrors.map(he=>({errorMessage:he.additionalInfo?(0,T.localize)(9,null,he.additionalInfo):(0,T.localize)(10,null),offset:he.offset,length:he.lexeme.length})):N.parsingErrors.length>0?N.parsingErrors.map(he=>({errorMessage:he.additionalInfo?`${he.message}. ${he.additionalInfo}`:he.message,offset:he.offset,length:he.lexeme.length})):[]))}e.validateWhenClauses=r;function s(J,N){const W=J?J.substituteConstants():void 0,he=N?N.substituteConstants():void 0;return!W&&!he?!0:!W||!he?!1:W.equals(he)}e.expressionsAreEqualWithConstantSubstitution=s;function i(J,N){return J.cmp(N)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=c;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return c.INSTANCE}}e.ContextKeyTrueExpr=u;class v{static create(N,W=null){const he=w.get(N);return typeof he=="boolean"?he?u.INSTANCE:c.INSTANCE:new v(N,W)}constructor(N,W){this.key=N,this.negated=W,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:H(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=w.get(this.key);return typeof N=="boolean"?N?u.INSTANCE:c.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.negated||(this.negated=R.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class S{static create(N,W,he=null){if(typeof W=="boolean")return W?v.create(N,he):R.create(N,he);const Se=w.get(N);return typeof Se=="boolean"?W===(Se?"true":"false")?u.INSTANCE:c.INSTANCE:new S(N,W,he)}constructor(N,W,he){this.key=N,this.value=W,this.negated=he,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:re(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){const N=w.get(this.key);if(typeof N=="boolean"){const W=N?"true":"false";return this.value===W?u.INSTANCE:c.INSTANCE}return this}evaluate(N){return N.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(N){return N.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=S;class l{static create(N,W){return new l(N,W)}constructor(N,W){this.key=N,this.valueKey=W,this.type=10,this.negated=null}cmp(N){return N.type!==this.type?this.type-N.type:re(this.key,this.valueKey,N.key,N.valueKey)}equals(N){return N.type===this.type?this.key===N.key&&this.valueKey===N.valueKey:!1}substituteConstants(){return this}evaluate(N){const W=N.getValue(this.valueKey),he=N.getValue(this.key);return Array.isArray(W)?W.includes(he):typeof he=="string"&&typeof W=="object"&&W!==null?P.call(W,he):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(N){return N.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=h.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=l;class h{static create(N,W){return new h(N,W)}constructor(N,W){this.key=N,this.valueKey=W,this.type=11,this._negated=l.create(N,W)}cmp(N){return N.type!==this.type?this.type-N.type:this._negated.cmp(N._negated)}equals(N){return N.type===this.type?this._negated.equals(N._negated):!1}substituteConstants(){return this}evaluate(N){return!this._negated.evaluate(N)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(N){return N.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=h;class E{static create(N,W,he=null){if(typeof W=="boolean")return W?R.create(N,he):v.create(N,he);const Se=w.get(N);return typeof Se=="boolean"?W===(Se?"true":"false")?c.INSTANCE:u.INSTANCE:new E(N,W,he)}constructor(N,W,he){this.key=N,this.value=W,this.negated=he,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:re(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){const N=w.get(this.key);if(typeof N=="boolean"){const W=N?"true":"false";return this.value===W?c.INSTANCE:u.INSTANCE}return this}evaluate(N){return N.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(N){return N.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=E;class R{static create(N,W=null){const he=w.get(N);return typeof he=="boolean"?he?c.INSTANCE:u.INSTANCE:new R(N,W)}constructor(N,W){this.key=N,this.negated=W,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:H(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=w.get(this.key);return typeof N=="boolean"?N?c.INSTANCE:u.INSTANCE:this}evaluate(N){return!N.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(N){return N.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=R;function M(J,N){if(typeof J=="string"){const W=parseFloat(J);isNaN(W)||(J=W)}return typeof J=="string"||typeof J=="number"?N(J):c.INSTANCE}class U{static create(N,W,he=null){return M(W,Se=>new U(N,Se,he))}constructor(N,W,he){this.key=N,this.value=W,this.negated=he,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:re(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(N){return N.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=U;class F{static create(N,W,he=null){return M(W,Se=>new F(N,Se,he))}constructor(N,W,he){this.key=N,this.value=W,this.negated=he,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:re(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(N){return N.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=F;class x{static create(N,W,he=null){return M(W,Se=>new x(N,Se,he))}constructor(N,W,he){this.key=N,this.value=W,this.negated=he,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:re(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(N){return N.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=x;class ${static create(N,W,he=null){return M(W,Se=>new $(N,Se,he))}constructor(N,W,he){this.key=N,this.value=W,this.negated=he,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:re(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(N){return N.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=$;class O{static create(N,W){return new O(N,W)}constructor(N,W){this.key=N,this.regexp=W,this.type=7,this.negated=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.key<N.key)return-1;if(this.key>N.key)return 1;const W=this.regexp?this.regexp.source:"",he=N.regexp?N.regexp.source:"";return W<he?-1:W>he?1:0}equals(N){if(N.type===this.type){const W=this.regexp?this.regexp.source:"",he=N.regexp?N.regexp.source:"";return this.key===N.key&&W===he}return!1}substituteConstants(){return this}evaluate(N){const W=N.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const N=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${N}`}keys(){return[this.key]}map(N){return N.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=K.create(this)),this.negated}}e.ContextKeyRegexExpr=O;class K{static create(N){return new K(N)}constructor(N){this._actual=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this._actual.cmp(N._actual)}equals(N){return N.type===this.type?this._actual.equals(N._actual):!1}substituteConstants(){return this}evaluate(N){return!this._actual.evaluate(N)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(N){return new K(this._actual.map(N))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=K;function q(J){let N=null;for(let W=0,he=J.length;W<he;W++){const Se=J[W].substituteConstants();if(J[W]!==Se&&N===null){N=[];for(let be=0;be<W;be++)N[be]=J[be]}N!==null&&(N[W]=Se)}return N===null?J:N}class fe{static create(N,W,he){return fe._normalizeArr(N,W,he)}constructor(N,W){this.expr=N,this.negated=W,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let W=0,he=this.expr.length;W<he;W++){const Se=i(this.expr[W],N.expr[W]);if(Se!==0)return Se}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let W=0,he=this.expr.length;W<he;W++)if(!this.expr[W].equals(N.expr[W]))return!1;return!0}return!1}substituteConstants(){const N=q(this.expr);return N===this.expr?this:fe.create(N,this.negated,!1)}evaluate(N){for(let W=0,he=this.expr.length;W<he;W++)if(!this.expr[W].evaluate(N))return!1;return!0}static _normalizeArr(N,W,he){const Se=[];let be=!1;for(const we of N)if(we){if(we.type===1){be=!0;continue}if(we.type===0)return c.INSTANCE;if(we.type===6){Se.push(...we.expr);continue}Se.push(we)}if(Se.length===0&&be)return u.INSTANCE;if(Se.length!==0){if(Se.length===1)return Se[0];Se.sort(i);for(let we=1;we<Se.length;we++)Se[we-1].equals(Se[we])&&(Se.splice(we,1),we--);if(Se.length===1)return Se[0];for(;Se.length>1;){const we=Se[Se.length-1];if(we.type!==9)break;Se.pop();const ye=Se.pop(),V=Se.length===0,ee=se.create(we.expr.map(G=>fe.create([G,ye],null,he)),null,V);ee&&(Se.push(ee),Se.sort(i))}if(Se.length===1)return Se[0];if(he){for(let we=0;we<Se.length;we++)for(let ye=we+1;ye<Se.length;ye++)if(Se[we].negate().equals(Se[ye]))return c.INSTANCE;if(Se.length===1)return Se[0]}return new fe(Se,W)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const W of this.expr)N.push(...W.keys());return N}map(N){return new fe(this.expr.map(W=>W.map(N)),null)}negate(){if(!this.negated){const N=[];for(const W of this.expr)N.push(W.negate());this.negated=se.create(N,this,!0)}return this.negated}}e.ContextKeyAndExpr=fe;class se{static create(N,W,he){return se._normalizeArr(N,W,he)}constructor(N,W){this.expr=N,this.negated=W,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let W=0,he=this.expr.length;W<he;W++){const Se=i(this.expr[W],N.expr[W]);if(Se!==0)return Se}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let W=0,he=this.expr.length;W<he;W++)if(!this.expr[W].equals(N.expr[W]))return!1;return!0}return!1}substituteConstants(){const N=q(this.expr);return N===this.expr?this:se.create(N,this.negated,!1)}evaluate(N){for(let W=0,he=this.expr.length;W<he;W++)if(this.expr[W].evaluate(N))return!0;return!1}static _normalizeArr(N,W,he){let Se=[],be=!1;if(N){for(let we=0,ye=N.length;we<ye;we++){const V=N[we];if(V){if(V.type===0){be=!0;continue}if(V.type===1)return u.INSTANCE;if(V.type===9){Se=Se.concat(V.expr);continue}Se.push(V)}}if(Se.length===0&&be)return c.INSTANCE;Se.sort(i)}if(Se.length!==0){if(Se.length===1)return Se[0];for(let we=1;we<Se.length;we++)Se[we-1].equals(Se[we])&&(Se.splice(we,1),we--);if(Se.length===1)return Se[0];if(he){for(let we=0;we<Se.length;we++)for(let ye=we+1;ye<Se.length;ye++)if(Se[we].negate().equals(Se[ye]))return u.INSTANCE;if(Se.length===1)return Se[0]}return new se(Se,W)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const W of this.expr)N.push(...W.keys());return N}map(N){return new se(this.expr.map(W=>W.map(N)),null)}negate(){if(!this.negated){const N=[];for(const W of this.expr)N.push(W.negate());for(;N.length>1;){const W=N.shift(),he=N.shift(),Se=[];for(const be of ne(W))for(const we of ne(he))Se.push(fe.create([be,we],null,!1));N.unshift(se.create(Se,null,!1))}this.negated=se.create(N,this,!0)}return this.negated}}e.ContextKeyOrExpr=se;class ie extends v{static{this._info=[]}static all(){return ie._info.values()}constructor(N,W,he){super(N,null),this._defaultValue=W,typeof he=="object"?ie._info.push({...he,key:N}):he!==!0&&ie._info.push({key:N,description:he,type:W!=null?typeof W:void 0})}bindTo(N){return N.createKey(this.key,this._defaultValue)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return S.create(this.key,N)}notEqualsTo(N){return E.create(this.key,N)}}e.RawContextKey=ie,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function H(J,N){return J<N?-1:J>N?1:0}function re(J,N,W,he){return J<W?-1:J>W?1:N<he?-1:N>he?1:0}function Ee(J,N){if(J.type===0||N.type===1)return!0;if(J.type===9)return N.type===9?ae(J.expr,N.expr):!1;if(N.type===9){for(const W of N.expr)if(Ee(J,W))return!0;return!1}if(J.type===6){if(N.type===6)return ae(N.expr,J.expr);for(const W of J.expr)if(Ee(W,N))return!0;return!1}return J.equals(N)}e.implies=Ee;function ae(J,N){let W=0,he=0;for(;W<J.length&&he<N.length;){const Se=J[W].cmp(N[he]);if(Se<0)return!1;Se===0&&W++,he++}return W===J.length}function ne(J){return J.type===9?J.expr:[J]}}),define(Ce[223],De([1,0,6]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,C.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,C.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[130],De([1,0,187,6]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function d(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=d;function A(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function T(a,m){switch(a){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":m==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function f(a,m){return m==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function w(a,m,b){return f(m,b)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===b?!0:g(b).includes(a)}e.isTargetPlatformCompatible=w;function g(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=g;function P(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=P;var k;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var p;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var _;(function(a){a.Install="install",a.Uninstall="uninstall"})(_||(e.StatisticType=_={}));var D;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(D||(e.InstallOperation=D={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var y;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var n;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n||(e.ExtensionSignaturetErrorCode=n={}));class o extends Error{constructor(m,b){super(m),this.code=b,this.name=b}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,C.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,C.localize)(1,null),original:"Preferences"}}),define(Ce[224],De([1,0,6]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,C.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,C.createDecorator)("externalTerminal")}),define(Ce[225],De([1,0,46,16,14,9,98,29,100,189,224]),function(me,e,C,L,d,A,T,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=g.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:_.getDefaultTerminalWindows(),linux:await y.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class _ extends p{static{this.CMD="cmd.exe"}openTerminal(b,I){return this.spawnTerminal(C,b,w.getWindowsShell(),I)}spawnTerminal(b,I,t,r){const s=I.windowsExec||_.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const i=d.basename(s,".exe").toLowerCase();if(i==="cmder")return b.spawn(s,r?[r]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return s.indexOf(" ")>=0&&c.push('""'),c.push(s),i==="wt"&&c.push("-d ."),new Promise((u,v)=>{const S=n(process),l=b.spawn(t,c,{cwd:r,env:S});l.on("error",v),l.on("exit",()=>u())})}runInTerminal(b,I,t,r,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:_.getDefaultTerminalWindows();return new Promise((c,u)=>{const v=`"${I} - ${k}"`,S=`""${t.join('" "')}" & pause"`,l=Object.assign({},n(process),r);Object.keys(l).filter(U=>l[U]===null).forEach(U=>delete l[U]);const h={cwd:I,env:l,windowsVerbatimArguments:!0};let E,R;d.basename(i,".exe")==="wt"?(E=i,R=["-d",".",_.CMD,"/c",S]):(E=_.CMD,R=["/c","start",v,"/wait",i,"/c",S]),C.spawn(E,R,h).on("error",U=>{u(o(U))}),c(void 0)})}static getDefaultTerminalWindows(){if(!_._DEFAULT_TERMINAL_WINDOWS){const b=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");_._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${b?"Sysnative":"System32"}\\cmd.exe`}return _._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=_;class D extends p{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(b,I){return this.spawnTerminal(C,b,I)}runInTerminal(b,I,t,r,s){const i=s.osxExec||P.DEFAULT_TERMINAL_OSX;return new Promise((c,u)=>{if(i===P.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const v=i===P.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",l=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${v}.scpt`).fsPath,"-t",b||k,"-w",I];for(const R of t)l.push("-a"),l.push(R);if(r){const R=Object.assign({},n(process),r);for(const M in R){const U=R[M];U===null?(l.push("-u"),l.push(M)):(l.push("-e"),l.push(`${M}=${U}`))}}let h="";const E=C.spawn(D.OSASCRIPT,l);E.on("error",R=>{u(o(R))}),E.stderr.on("data",R=>{h+=R.toString()}),E.on("exit",R=>{if(R===0)c(void 0);else if(h){const M=h.split(`
`,1);u(new Error(M[0]))}else u(new Error(g.localize(1,null,v,R)))})}else u(new Error(g.localize(2,null,i)))})}spawnTerminal(b,I,t){const r=I.osxExec||P.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const c=["-a",r];t&&c.push(t);const u=n(process),v=b.spawn("/usr/bin/open",c,{cwd:t,env:u});v.on("error",i),v.on("exit",()=>s())})}}e.MacExternalTerminalService=D;class y extends p{static{this.WAIT_MESSAGE=g.localize(3,null)}openTerminal(b,I){return this.spawnTerminal(C,b,I)}runInTerminal(b,I,t,r,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((c,u)=>{const v=[];i.then(S=>{S.indexOf("gnome-terminal")>=0?v.push("-x"):v.push("-e"),v.push("bash"),v.push("-c");const l=`${a(t)}; echo; read -p "${y.WAIT_MESSAGE}" -n1;`;v.push(`''${l}''`);const h=Object.assign({},n(process),r);Object.keys(h).filter(U=>h[U]===null).forEach(U=>delete h[U]);const E={cwd:I,env:h};let R="";const M=C.spawn(S,v,E);M.on("error",U=>{u(o(U))}),M.stderr.on("data",U=>{R+=U.toString()}),M.on("exit",U=>{if(U===0)c(void 0);else if(R){const F=R.split(`
`,1);u(new Error(F[0]))}else u(new Error(g.localize(4,null,S,U)))})})})}static async getDefaultTerminalLinuxReady(){if(!y._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)y._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const b=await f.Promises.exists("/etc/debian_version");y._DEFAULT_TERMINAL_LINUX_READY=new Promise(I=>{b?I("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?I("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?I("konsole"):process.env.COLORTERM?I(process.env.COLORTERM):process.env.TERM?I(process.env.TERM):I("xterm")})}return y._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(b,I,t){const r=I.linuxExec?Promise.resolve(I.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{r.then(c=>{const u=n(process),v=b.spawn(c,[],{cwd:t,env:u});v.on("error",i),v.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=y;function n(m){const b={...m.env};return(0,T.sanitizeProcessEnvironment)(b),b}function o(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(g.localize(5,null,m.path)):m}function a(m){let b="";for(const I of m)I.indexOf(" ")>=0?b+='"'+I+'"':b+=I,b+=" ";return b}}),define(Ce[30],De([1,0,75,14,15,19,2,190,6,9,16]),function(me,e,C,L,d,A,T,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function k(H){return H.create===!0}e.isFileOpenForWriteOptions=k;var p;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var _;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(_||(e.FilePermission=_={}));var D;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(D||(e.FileSystemProviderCapabilities=D={}));function y(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=y;function n(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=n;function o(H){return!!(H.capabilities&131072)}e.hasFileCloneCapability=o;function a(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function m(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=m;function b(H){return y(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;function I(H){return y(H)?!!(H.capabilities&32768):!1}e.hasFileAtomicWriteCapability=I;function t(H){return!!(H.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;function r(H){return!!(H.capabilities&2048)}e.hasReadonlyCapability=r;var s;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class i extends Error{static create(re,Ee){const ae=new i(re.toString(),Ee);return v(ae,Ee),ae}constructor(re,Ee){super(re),this.code=Ee}}e.FileSystemProviderError=i;function c(H,re){return i.create(H,re)}e.createFileSystemProviderError=c;function u(H){return H||c((0,f.localize)(0,null),s.Unknown)}e.ensureFileSystemProviderError=u;function v(H,re){return H.name=re?`${re} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=v;function S(H){if(!H)return s.Unknown;if(H instanceof i)return H.code;const re=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!re)return s.Unknown;switch(re[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.toFileSystemProviderErrorCode=S;function l(H){if(H instanceof F)return H.fileOperationResult;switch(S(H)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=l;var h;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(h||(e.FileOperation=h={}));class E{constructor(re,Ee,ae){this.resource=re,this.operation=Ee,this.target=ae}isOperation(re){return this.operation===re}}e.FileOperationEvent=E;var R;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(R||(e.FileChangeType=R={}));class M{constructor(re,Ee){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ae=new Map;for(const ne of re){const J=ae.get(ne.type);switch(J?J.push([ne.resource,ne]):ae.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,J]of ae)switch(ne){case 1:this.added=C.TernarySearchTree.forUris(()=>Ee),this.added.fill(J);break;case 0:this.updated=C.TernarySearchTree.forUris(()=>Ee),this.updated.fill(J);break;case 2:this.deleted=C.TernarySearchTree.forUris(()=>Ee),this.deleted.fill(J);break}}contains(re,...Ee){return this.doContains(re,{includeChildren:!1},...Ee)}affects(re,...Ee){return this.doContains(re,{includeChildren:!0},...Ee)}doContains(re,Ee,...ae){if(!re)return!1;const ne=ae.length>0;return!!((!ne||ae.includes(1))&&(this.added?.get(re)||Ee.includeChildren&&this.added?.findSuperstr(re))||(!ne||ae.includes(0))&&(this.updated?.get(re)||Ee.includeChildren&&this.updated?.findSuperstr(re))||(!ne||ae.includes(2))&&(this.deleted?.findSubstr(re)||Ee.includeChildren&&this.deleted?.findSuperstr(re)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=M;function U(H,re,Ee){return!H||!re||H===re||re.length>H.length?!1:(re.charAt(re.length-1)!==L.sep&&(re+=L.sep),Ee?(0,d.startsWithIgnoreCase)(H,re):H.indexOf(re)===0)}e.isParent=U;class F extends Error{constructor(re,Ee,ae){super(re),this.fileOperationResult=Ee,this.options=ae}}e.FileOperationError=F;class x extends F{constructor(re,Ee,ae,ne){super(re,Ee,ne),this.fileOperationResult=Ee,this.size=ae}}e.TooLargeFileOperationError=x;class $ extends F{constructor(re,Ee,ae){super(re,2,ae),this.stat=Ee}}e.NotModifiedSinceFileOperationError=$;var O;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(O||(e.FileOperationResult=O={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var K;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.ETAG_DISABLED="";function q(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=q;async function fe(H,re){if(!re.hasProvider(T.URI.from({scheme:H.scheme})))return new Promise(Ee=>{const ae=re.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===H.scheme&&ne.added&&(ae.dispose(),Ee())})})}e.whenProviderRegistered=fe;class se{static{this.KB=1024}static{this.MB=se.KB*se.KB}static{this.GB=se.MB*se.KB}static{this.TB=se.GB*se.KB}static formatSize(re){return(0,A.isNumber)(re)||(re=0),re<se.KB?(0,f.localize)(1,null,re.toFixed(0)):re<se.MB?(0,f.localize)(2,null,(re/se.KB).toFixed(2)):re<se.GB?(0,f.localize)(3,null,(re/se.MB).toFixed(2)):re<se.TB?(0,f.localize)(4,null,(re/se.GB).toFixed(2)):(0,f.localize)(5,null,(re/se.TB).toFixed(2))}}e.ByteSize=se;function ie(H){const re=typeof H=="string"||H?.scheme===P.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===P.Schemas.file?1024*se.MB:re?10*se.MB:g.isWeb?50*se.MB:1024*se.MB}e.getLargeFileConfirmationLimit=ie}),define(Ce[226],De([1,0,21,8,191,30]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(P,k,p,_,D,y){let n;try{await f(P,k,p,_,D,y)}catch(o){n=o}finally{n&&D.errorTransformer&&(n=D.errorTransformer(n)),typeof n<"u"&&p.error(n),p.end()}}e.readFileIntoStream=T;async function f(P,k,p,_,D,y){w(y);const n=await P.open(k,{create:!1});try{w(y);let o=0,a=0,m=D&&typeof D.length=="number"?D.length:void 0,b=C.VSBuffer.alloc(Math.min(D.bufferSize,typeof m=="number"?m:D.bufferSize)),I=D&&typeof D.position=="number"?D.position:0,t=0;do a=await P.read(n,I,b.buffer,t,b.byteLength-t),I+=a,t+=a,o+=a,typeof m=="number"&&(m-=a),t===b.byteLength&&(await p.write(_(b)),b=C.VSBuffer.alloc(Math.min(D.bufferSize,typeof m=="number"?m:D.bufferSize)),t=0);while(a>0&&(typeof m!="number"||m>0)&&w(y)&&g(o,D));if(t>0){let r=t;typeof m=="number"&&(r=Math.min(t,m)),p.write(_(b.slice(0,r)))}}catch(o){throw(0,A.ensureFileSystemProviderError)(o)}finally{await P.close(n)}}function w(P){if(P.isCancellationRequested)throw(0,L.canceled)();return!0}function g(P,k){if(typeof k?.limits?.size=="number"&&P>k.limits.size)throw(0,A.createFileSystemProviderError)((0,d.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ce[82],De([1,0,35,3,14,9,2,30]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function w(o){return o.recursive===!0}e.isRecursiveWatchRequest=w;class g extends L.Disposable{static{this.MAX_RESTARTS=5}constructor(a,m,b,I){super(),this.onFileChanges=a,this.onLogMessage=m,this.verboseLogging=b,this.options=I,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const a=new L.DisposableStore;this.watcherDisposables.value=a,this.watcher=this.createWatcher(a),this.watcher.setVerboseLogging(this.verboseLogging),a.add(this.watcher.onDidChangeFile(m=>this.onFileChanges(m))),a.add(this.watcher.onDidLogMessage(m=>this.onLogMessage(m))),a.add(this.watcher.onDidError(m=>this.onError(m)))}onError(a){this.options.restartOnError?this.restartCounter<g.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${a}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${a}`):this.error(a)}restart(a){this.restartCounter++,this.init(),this.watch(a)}async watch(a){this.requests=a,await this.watcher?.watch(a)}async setVerboseLogging(a){this.verboseLogging=a,await this.watcher?.setVerboseLogging(a)}error(a){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${a}`})}trace(a){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${a}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=g;class P extends g{constructor(a,m,b){super(a,m,b,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class k extends g{constructor(a,m,b){super(a,m,b,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=k;function p(o){return o.map(a=>({type:a.type,resource:T.URI.file(a.path)}))}e.toFileChanges=p;function _(o){const a=new n;for(const m of o)a.processEvent(m);return a.coalesce()}e.coalesceEvents=_;function D(o,a){return typeof a=="string"&&!a.startsWith(C.GLOBSTAR)&&!(0,d.isAbsolute)(a)?{base:o,pattern:a}:a}e.normalizeWatcherPattern=D;function y(o,a){const m=[];for(const b of a)m.push((0,C.parse)(D(o,b)));return m}e.parseWatcherPatterns=y;class n{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(a){return A.isLinux?a.path:a.path.toLowerCase()}processEvent(a){const m=this.mapPathToChange.get(this.toKey(a));let b=!1;if(m){const I=m.type,t=a.type;m.path!==a.path&&(a.type===2||a.type===1)?b=!0:I===1&&t===2?(this.mapPathToChange.delete(this.toKey(a)),this.coalesced.delete(m)):I===2&&t===1?m.type=0:I===1&&t===0||(m.type=t)}else b=!0;b&&(this.coalesced.add(a),this.mapPathToChange.set(this.toKey(a),a))}coalesce(){const a=[],m=[];return Array.from(this.coalesced).filter(b=>b.type!==2?(a.push(b),!1):!0).sort((b,I)=>b.path.length-I.path.length).filter(b=>m.some(I=>(0,f.isParent)(b.path,I,!A.isLinux))?!1:(m.push(b.path),!0)).concat(a)}}}),define(Ce[227],De([1,0,49,13,22,32,3,73,14,9,99,29,82]),function(me,e,C,L,d,A,T,f,w,g,P,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class _ extends T.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(n,o,a,m){super(),this.request=n,this.onDidFilesChange=o,this.onLogMessage=a,this.verboseLogging=m,this.throttledFileChangesEmitter=this._register(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},b=>this.onDidFilesChange(b))),this.fileChangesAggregator=this._register(new L.RunOnceWorker(b=>this.handleFileChanges(b),_.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new d.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const n=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const o=await k.Promises.stat(n);this._register(await this.doWatch(n,o.isDirectory()))}catch(n){n.code!=="ENOENT"?this.error(n):this.trace(n)}}async normalizePath(n){let o=n.path;try{o=await k.Promises.realpath(n.path),n.path===o&&(o=await(0,P.realcase)(n.path)??n.path),n.path!==o&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${o})`)}catch{}return o}async doWatch(n,o){if(g.isMacintosh&&(0,A.isEqualOrParent)(n,"/Volumes/",!0))return this.error(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const a=new d.CancellationTokenSource(this.cts.token),m=new T.DisposableStore;try{const b=(0,w.basename)(n),I=(0,C.watch)(n);m.add((0,T.toDisposable)(()=>{I.removeAllListeners(),I.close()})),this.trace(`Started watching: '${n}'`);const t=new Set;if(o)try{for(const s of await k.Promises.readdir(n))t.add(s)}catch(s){this.error(s)}const r=new Map;m.add((0,T.toDisposable)(()=>{for(const[,s]of r)s.dispose();r.clear()})),I.on("error",(s,i)=>{this.error(`Failed to watch ${n} for changes using fs.watch() (${s}, ${i})`),this.dispose()}),I.on("change",(s,i)=>{if(a.token.isCancellationRequested)return;this.trace(`[raw] ["${s}"] ${i}`);let c="";if(i&&(c=i.toString(),g.isMacintosh&&(c=(0,f.normalizeNFC)(c))),!(!c||s!=="change"&&s!=="rename"))if(o)if(s==="rename"){r.get(c)?.dispose();const u=setTimeout(async()=>{if(r.delete(c),c===b&&!await k.Promises.exists(n)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const v=await this.existsChildStrictCase((0,w.join)(n,c));if(a.token.isCancellationRequested)return;let S;v?t.has(c)?S=0:(S=1,t.add(c)):(t.delete(c),S=2),this.onFileChange({path:(0,w.join)(this.request.path,c),type:S})},_.FILE_DELETE_HANDLER_DELAY);r.set(c,(0,T.toDisposable)(()=>clearTimeout(u)))}else{let u;t.has(c)?u=0:(u=1,t.add(c)),this.onFileChange({path:(0,w.join)(this.request.path,c),type:u})}else if(s==="rename"||c!==b){const u=setTimeout(async()=>{const v=await k.Promises.exists(n);a.token.isCancellationRequested||(v?(this.onFileChange({path:this.request.path,type:0},!0),m.add(await this.doWatch(n,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},_.FILE_DELETE_HANDLER_DELAY);m.clear(),m.add((0,T.toDisposable)(()=>clearTimeout(u)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(b){await k.Promises.exists(n)&&!a.token.isCancellationRequested&&this.error(`Failed to watch ${n} for changes using fs.watch() (${b.toString()})`)}return(0,T.toDisposable)(()=>{a.dispose(!0),m.dispose()})}onFileChange(n,o=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.path}`),!o&&this.excludes.some(a=>a(n.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${n.path}`):!o&&this.includes&&this.includes.length>0&&!this.includes.some(a=>a(n.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${n.path}`):this.fileChangesAggregator.work(n))}handleFileChanges(n){const o=(0,p.coalesceEvents)(n);if(o.length>0){if(this.verboseLogging)for(const m of o)this.trace(`>> normalized ${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`);this.throttledFileChangesEmitter.work(o)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${o[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(n){if(g.isLinux)return k.Promises.exists(n);try{const o=(0,w.basename)(n);return(await k.Promises.readdir((0,w.dirname)(n))).some(m=>m===o)}catch(o){return this.trace(o),!1}}setVerboseLogging(n){this.verboseLogging=n}error(n){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}warn(n){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}trace(n){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=_;async function D(y,n,o,a,m=512){const b=await k.Promises.open(y,"r"),I=Buffer.allocUnsafe(m),t=new d.CancellationTokenSource(a);let r,s=!1;const i={path:y,excludes:[],recursive:!1},c=new _(i,u=>{(async()=>{for(const{type:v}of u)if(v===0){if(s)return;s=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:S}=await k.Promises.read(b,I,0,m,null);if(!S||t.token.isCancellationRequested)break;n(I.slice(0,S))}}catch(S){r=new Error(S),t.dispose(!0)}finally{s=!1}}})()});return await c.ready,o(),new Promise((u,v)=>{t.token.onCancellationRequested(async()=>{c.dispose();try{await k.Promises.close(b)}catch(S){r=new Error(S)}r?v(r):u()})})}e.watchFileContents=D}),define(Ce[228],De([1,0,4,35,3,9,227]),function(me,e,C,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class f extends d.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new C.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=C.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(g){const P=this.normalizeRequests(g),k=P.filter(_=>{const D=this.watchers.get(_.path);return D?!(0,L.patternsEquals)(D.request.excludes,_.excludes)||!(0,L.patternsEquals)(D.request.includes,_.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:_})=>!P.find(D=>D.path===_.path&&(0,L.patternsEquals)(D.excludes,_.excludes)&&(0,L.patternsEquals)(D.includes,_.includes))).map(({request:_})=>_.path);k.length&&this.trace(`Request to start watching: ${k.map(_=>`${_.path} (excludes: ${_.excludes.length>0?_.excludes:"<none>"}, includes: ${_.includes&&_.includes.length>0?JSON.stringify(_.includes):"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const _ of p)this.stopWatching(_);for(const _ of k)this.startWatching(_)}startWatching(g){const P=new T.NodeJSFileWatcherLibrary(g,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),k={request:g,instance:P};this.watchers.set(g.path,k)}async stop(){for(const[g]of this.watchers)this.stopWatching(g);this.watchers.clear()}stopWatching(g){const P=this.watchers.get(g);P&&(this.watchers.delete(g),P.instance.dispose())}normalizeRequests(g){const P=new Map;for(const k of g){const p=A.isLinux?k.path:k.path.toLowerCase();P.set(p,k)}return Array.from(P.values())}async setVerboseLogging(g){this.verboseLogging=g;for(const[,P]of this.watchers)P.instance.setVerboseLogging(g)}trace(g){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(g)})}toMessage(g,P){return P?`[File Watcher (node.js)] ${g} (path: ${P.request.path})`:`[File Watcher (node.js)] ${g}`}}e.NodeJSWatcher=f}),define(Ce[229],De([1,0,82,228]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class d extends C.AbstractNonRecursiveWatcherClient{constructor(T,f,w){super(T,f,w),this.init()}createWatcher(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=d}),define(Ce[230],De([1,0,16,79,180,82]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends A.AbstractUniversalWatcherClient{constructor(w,g,P){super(w,g,P),this.init()}createWatcher(w){const g=w.add(new d.Client(C.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(g.onDidProcessExit(({code:P,signal:k})=>this.onError(`terminated by itself with code ${P}, signal: ${k}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(g.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(Ce[103],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class C{constructor(...d){this._entries=new Map;for(const[A,T]of d)this.set(A,T)}set(d,A){const T=this._entries.get(d);return this._entries.set(d,A),T}has(d){return this._entries.has(d)}get(d){return this._entries.get(d)}}e.ServiceCollection=C}),define(Ce[231],De([1,0,13,8,3,101,222,6,103,72]),function(me,e,C,L,d,A,T,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class k extends Error{constructor(n){super("cyclic dependency between services"),this.message=n.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${n.toString()}`}}class p{constructor(n=new w.ServiceCollection,o=!1,a,m=P){this._services=n,this._strict=o,this._parent=a,this._enableTracing=m,this._activeInstantiations=new Set,this._services.set(f.IInstantiationService,this),this._globalGraph=m?a?._globalGraph??new T.Graph(b=>b):void 0}createChild(n){return new p(n,this._strict,this,this._enableTracing)}invokeFunction(n,...o){const a=D.traceInvocation(this._enableTracing,n);let m=!1;try{return n({get:I=>{if(m)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(I,a);if(!t)throw new Error(`[invokeFunction] unknown service '${I}'`);return t}},...o)}finally{m=!0,a.stop()}}createInstance(n,...o){let a,m;return n instanceof A.SyncDescriptor?(a=D.traceCreation(this._enableTracing,n.ctor),m=this._createInstance(n.ctor,n.staticArguments.concat(o),a)):(a=D.traceCreation(this._enableTracing,n),m=this._createInstance(n,o,a)),a.stop(),m}_createInstance(n,o=[],a){const m=f._util.getServiceDependencies(n).sort((t,r)=>t.index-r.index),b=[];for(const t of m){const r=this._getOrCreateServiceInstance(t.id,a);r||this._throwIfStrict(`[createInstance] ${n.name} depends on UNKNOWN service ${t.id}.`,!1),b.push(r)}const I=m.length>0?m[0].index:o.length;if(o.length!==I){console.trace(`[createInstance] First service dependency of ${n.name} at position ${I+1} conflicts with ${o.length} static arguments`);const t=I-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,I)}return Reflect.construct(n,o.concat(b))}_setServiceInstance(n,o){if(this._services.get(n)instanceof A.SyncDescriptor)this._services.set(n,o);else if(this._parent)this._parent._setServiceInstance(n,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(n){const o=this._services.get(n);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(n):o}_getOrCreateServiceInstance(n,o){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(n));const a=this._getServiceInstanceOrDescriptor(n);return a instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(n,a,o.branch(n,!0)):(o.branch(n,!1),a)}_safeCreateAndCacheServiceInstance(n,o,a){if(this._activeInstantiations.has(n))throw new Error(`illegal state - RECURSIVELY instantiating service '${n}'`);this._activeInstantiations.add(n);try{return this._createAndCacheServiceInstance(n,o,a)}finally{this._activeInstantiations.delete(n)}}_createAndCacheServiceInstance(n,o,a){const m=new T.Graph(t=>t.id.toString());let b=0;const I=[{id:n,desc:o,_trace:a}];for(;I.length;){const t=I.pop();if(m.lookupOrInsertNode(t),b++>1e3)throw new k(m);for(const r of f._util.getServiceDependencies(t.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(r.id);if(s||this._throwIfStrict(`[createInstance] ${n} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),s instanceof A.SyncDescriptor){const i={id:r.id,desc:s,_trace:t._trace.branch(r.id,!0)};m.insertEdge(t,i),I.push(i)}}}for(;;){const t=m.roots();if(t.length===0){if(!m.isEmpty())throw new k(m);break}for(const{data:r}of t){if(this._getServiceInstanceOrDescriptor(r.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}m.removeNode(r)}}return this._getServiceInstanceOrDescriptor(n)}_createServiceInstanceWithOwner(n,o,a=[],m,b){if(this._services.get(n)instanceof A.SyncDescriptor)return this._createServiceInstance(n,o,a,m,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(n,o,a,m,b);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(n,o,a=[],m,b){if(m){const I=new p(void 0,this._strict,this,this._enableTracing);I._globalGraphImplicitDependency=String(n);const t=new Map,r=new C.IdleValue(()=>{const s=I._createInstance(o,a,b);for(const[i,c]of t){const u=s[i];if(typeof u=="function")for(const v of c)u.apply(s,v)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,i){if(!r.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let v=t.get(i);return v||(v=new g.LinkedList,t.set(i,v)),(l,h,E)=>{const R=v.push([l,h,E]);return(0,d.toDisposable)(R)}}if(i in s)return s[i];const c=r.value;let u=c[i];return typeof u!="function"||(u=u.bind(c),s[i]=u),u},set(s,i,c){return r.value[i]=c,!0},getPrototypeOf(s){return o.prototype}})}else return this._createInstance(o,a,b)}_throwIfStrict(n,o){if(o&&console.warn(n),this._strict)throw new Error(n)}}e.InstantiationService=p;var _;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(_||(_={}));class D{static{this.all=new Set}static{this._None=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(n,o){return n?new D(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D._None}static traceCreation(n,o){return n?new D(1,o.name):D._None}static{this._totals=0}constructor(n,o){this.type=n,this.name=o,this._start=Date.now(),this._dep=[]}branch(n,o){const a=new D(3,n.toString());return this._dep.push([n,o,a]),a}stop(){const n=Date.now()-this._start;D._totals+=n;let o=!1;function a(b,I){const t=[],r=new Array(b+1).join("	");for(const[s,i,c]of I._dep)if(i&&c){o=!0,t.push(`${r}CREATES -> ${s}`);const u=a(b+1,c);u&&t.push(u)}else t.push(`${r}uses -> ${s}`);return t.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${n.toFixed(2)}ms (grand total ${D._totals.toFixed(2)}ms)`];(n>2||o)&&D.all.add(m.join(`
`))}}e.Trace=D}),define(Ce[17],De([1,0,45,4,74,3,28,9,24,19,2,47,6]),function(me,e,C,L,d,A,T,f,w,g,P,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function _(){return new Date().toISOString()}function D(l){return(0,g.isNumber)(l)}e.isLogLevel=D;var y;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(y||(e.LogLevel=y={})),e.DEFAULT_LOG_LEVEL=y.Info;function n(l,h,E){switch(h){case y.Trace:l.trace(E);break;case y.Debug:l.debug(E);break;case y.Info:l.info(E);break;case y.Warning:l.warn(E);break;case y.Error:l.error(E);break;case y.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=n;function o(l,h=!1){let E="";for(let R=0;R<l.length;R++){let M=l[R];if(M instanceof Error&&(M=(0,C.toErrorMessage)(M,h)),typeof M=="object")try{M=JSON.stringify(M)}catch{}E+=(R>0?" ":"")+M}return E}class a extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(h){this.level!==h&&(this.level=h,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(h){return this.level!==y.Off&&this.level<=h}}e.AbstractLogger=a;class m extends a{constructor(h){super(),this.logAlways=h}checkLogLevel(h){return this.logAlways||super.checkLogLevel(h)}trace(h,...E){this.checkLogLevel(y.Trace)&&this.log(y.Trace,o([h,...E],!0))}debug(h,...E){this.checkLogLevel(y.Debug)&&this.log(y.Debug,o([h,...E]))}info(h,...E){this.checkLogLevel(y.Info)&&this.log(y.Info,o([h,...E]))}warn(h,...E){this.checkLogLevel(y.Warning)&&this.log(y.Warning,o([h,...E]))}error(h,...E){if(this.checkLogLevel(y.Error))if(h instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=h.stack,this.log(y.Error,o(R))}else this.log(y.Error,o([h,...E]))}flush(){}}e.AbstractMessageLogger=m;class b extends a{constructor(h=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(h),this.useColors=!f.isWindows}trace(h,...E){this.checkLogLevel(y.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${_()}]\x1B[0m`,h,...E):console.log(`[main ${_()}]`,h,...E))}debug(h,...E){this.checkLogLevel(y.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${_()}]\x1B[0m`,h,...E):console.log(`[main ${_()}]`,h,...E))}info(h,...E){this.checkLogLevel(y.Info)&&(this.useColors?console.log(`\x1B[90m[main ${_()}]\x1B[0m`,h,...E):console.log(`[main ${_()}]`,h,...E))}warn(h,...E){this.checkLogLevel(y.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${_()}]\x1B[0m`,h,...E):console.warn(`[main ${_()}]`,h,...E))}error(h,...E){this.checkLogLevel(y.Error)&&(this.useColors?console.error(`\x1B[91m[main ${_()}]\x1B[0m`,h,...E):console.error(`[main ${_()}]`,h,...E))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class I extends a{constructor(h=e.DEFAULT_LOG_LEVEL,E=!0){super(),this.useColors=E,this.setLevel(h)}trace(h,...E){this.checkLogLevel(y.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",h,...E):console.log(h,...E))}debug(h,...E){this.checkLogLevel(y.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",h,...E):console.log(h,...E))}info(h,...E){this.checkLogLevel(y.Info)&&(this.useColors?console.log("%c INFO","color: #33f",h,...E):console.log(h,...E))}warn(h,...E){this.checkLogLevel(y.Warning)&&(this.useColors?console.log("%c WARN","color: #993",h,...E):console.log(h,...E))}error(h,...E){this.checkLogLevel(y.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",h,...E):console.error(h,...E))}dispose(){}flush(){}}e.ConsoleLogger=I;class t extends a{constructor(h,E=e.DEFAULT_LOG_LEVEL){super(),this.adapter=h,this.setLevel(E)}trace(h,...E){this.checkLogLevel(y.Trace)&&this.adapter.log(y.Trace,[this.extractMessage(h),...E])}debug(h,...E){this.checkLogLevel(y.Debug)&&this.adapter.log(y.Debug,[this.extractMessage(h),...E])}info(h,...E){this.checkLogLevel(y.Info)&&this.adapter.log(y.Info,[this.extractMessage(h),...E])}warn(h,...E){this.checkLogLevel(y.Warning)&&this.adapter.log(y.Warning,[this.extractMessage(h),...E])}error(h,...E){this.checkLogLevel(y.Error)&&this.adapter.log(y.Error,[this.extractMessage(h),...E])}extractMessage(h){return typeof h=="string"?h:(0,C.toErrorMessage)(h,this.checkLogLevel(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class r extends a{constructor(h){super(),this.loggers=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const E of this.loggers)E.setLevel(h);super.setLevel(h)}trace(h,...E){for(const R of this.loggers)R.trace(h,...E)}debug(h,...E){for(const R of this.loggers)R.debug(h,...E)}info(h,...E){for(const R of this.loggers)R.info(h,...E)}warn(h,...E){for(const R of this.loggers)R.warn(h,...E)}error(h,...E){for(const R of this.loggers)R.error(h,...E)}flush(){for(const h of this.loggers)h.flush()}dispose(){for(const h of this.loggers)h.dispose()}}e.MultiplexLogger=r;class s extends A.Disposable{constructor(h,E,R){if(super(),this.logLevel=h,this.logsHome=E,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,R)for(const M of R)this._loggers.set(M.resource,{logger:void 0,info:M})}getLoggerEntry(h){return(0,g.isString)(h)?[...this._loggers.values()].find(E=>E.info.id===h):this._loggers.get(h)}getLogger(h){return this.getLoggerEntry(h)?.logger}createLogger(h,E){const R=this.toResource(h),M=(0,g.isString)(h)?h:E?.id??(0,d.hash)(R.toString()).toString(16);let U=this._loggers.get(R)?.logger;const F=E?.logLevel==="always"?y.Trace:E?.logLevel;U||(U=this.doCreateLogger(R,F??this.getLogLevel(R)??this.logLevel,{...E,id:M}));const x={logger:U,info:{resource:R,id:M,logLevel:F,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(x.info),this._loggers.set(R,x),U}toResource(h){return(0,g.isString)(h)?(0,w.joinPath)(this.logsHome,`${h}.log`):h}setLogLevel(h,E){if(P.URI.isUri(h)){const R=h,M=E,U=this._loggers.get(R);U&&M!==U.info.logLevel&&(U.info.logLevel=M===this.logLevel?void 0:M,U.logger?.setLevel(M),this._loggers.set(U.info.resource,U),this._onDidChangeLogLevel.fire([R,M]))}else{this.logLevel=h;for(const[R,M]of this._loggers.entries())this._loggers.get(R)?.info.logLevel===void 0&&M.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(h,E){const R=this.getLoggerEntry(h);R&&E!==!R.info.hidden&&(R.info.hidden=!E,this._loggers.set(R.info.resource,R),this._onDidChangeVisibility.fire([R.info.resource,E]))}getLogLevel(h){let E;return h&&(E=this._loggers.get(h)?.info.logLevel),E??this.logLevel}registerLogger(h){const E=this._loggers.get(h.resource);E?E.info.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this._loggers.set(h.resource,{info:h,logger:void 0}),this._onDidChangeLoggers.fire({added:[h],removed:[]}))}deregisterLogger(h){const E=this._loggers.get(h);E&&(E.logger&&E.logger.dispose(),this._loggers.delete(h),this._onDidChangeLoggers.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const h of this._loggers.values())yield h.info}getRegisteredLogger(h){return this._loggers.get(h)?.info}dispose(){this._loggers.forEach(h=>h.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class i{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(h){}getLevel(){return y.Info}trace(h,...E){}debug(h,...E){}info(h,...E){}warn(h,...E){}error(h,...E){}critical(h,...E){}dispose(){}flush(){}}e.NullLogger=i;class c extends i{}e.NullLogService=c;function u(l){if(l.verbose)return y.Trace;if(typeof l.logLevel=="string"){const h=S(l.logLevel.toLowerCase());if(h!==void 0)return h}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function v(l){switch(l){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=v;function S(l){switch(l){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=S,e.CONTEXT_LOG_LEVEL=new k.RawContextKey("logLevel",v(y.Info))}),define(Ce[232],De([1,0,18,13,8,4,3,14,82,17]),function(me,e,C,L,d,A,T,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends T.Disposable{constructor(p,_){super(),this.logService=p,this.options=_,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new L.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(p,_){return _.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,_):this.watchNonRecursive(p,_)}watchUniversal(p,_){const D={path:this.toFilePath(p),excludes:_.excludes,includes:_.includes,recursive:_.recursive},y=(0,C.insert)(this.universalPathsToWatch,D);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,d.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(_=>this._onDidChangeFile.fire((0,w.toFileChanges)(_)),_=>this.onWatcherLogMessage(_),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const _ of this.universalPathsToWatch)(0,w.isRecursiveWatchRequest)(_)&&(_.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const _ of this.universalPathsToWatch)(0,w.isRecursiveWatchRequest)(_)&&p.includes(_.path)&&(_.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,_){const D={path:this.toFilePath(p),excludes:_.excludes,includes:_.includes,recursive:!1},y=(0,C.insert)(this.nonRecursivePathsToWatch,D);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,d.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,w.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,f.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(Ce[233],De([1,0,49,362,13,28,21,4,32,3,14,9,24,96,29,192,30,226,232,45,230,229]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(C)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(r)}`)}})();class t extends a.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=f.Event.None,this.resourceLocks=new A.ResourceMap(c=>p.extUriBiasedIgnorePathCase.getComparisonKey(c)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:c}=await D.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,c),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:n.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await D.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),c=[];return await Promise.all(i.map(async u=>{try{let v;u.isSymbolicLink()?v=(await this.stat((0,p.joinPath)(s,u.name))).type:v=this.toType(u),c.push([u.name,v])}catch(v){this.logService.trace(v)}})),c}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let c;return i?.dangling?c=n.FileType.Unknown:s.isFile()?c=n.FileType.File:s.isDirectory()?c=n.FileType.Directory:c=n.FileType.Unknown,i&&(c|=n.FileType.SymbolicLink),c}async createResourceLock(s){const i=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let c;for(;c=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await c.wait();const u=new d.Barrier;return this.resourceLocks.set(s,u),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,g.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(s)===u&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),u.open()})}async readFile(s,i){let c;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),c=await this.createResourceLock(s));const u=this.toFilePath(s);return await D.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{c?.dispose()}}traceLock(s){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,i,c){const u=(0,_.newWriteableStream)(v=>T.VSBuffer.concat(v.map(S=>T.VSBuffer.wrap(S))).buffer);return(0,o.readFileIntoStream)(this,s,u,v=>v.buffer,{...i,bufferSize:256*1024},c),u}async writeFile(s,i,c){return c?.atomic!==!1&&c?.atomic?.postfix?this.doWriteFileAtomic(s,(0,p.joinPath)((0,p.dirname)(s),`${(0,p.basename)(s)}${c.atomic.postfix}`),i,c):this.doWriteFile(s,i,c)}async doWriteFileAtomic(s,i,c,u){await this.doWriteFile(i,c,u);try{await this.rename(i,s,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}async doWriteFile(s,i,c){let u;try{const v=this.toFilePath(s);if(!c.create||!c.overwrite){if(await D.Promises.exists(v)){if(!c.overwrite)throw(0,n.createFileSystemProviderError)((0,y.localize)(0,null),n.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,n.createFileSystemProviderError)((0,y.localize)(1,null),n.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(s,{create:!0,unlock:c.unlock}),await this.write(u,0,i,0,i.byteLength)}catch(v){throw await this.toFileSystemProviderWriteError(s,v)}finally{typeof u=="number"&&await this.close(u)}}static{this.canFlush=!0}static configureFlushOnWrite(s){t.canFlush=s}async open(s,i){const c=this.toFilePath(s);let u;(0,n.isFileOpenForWriteOptions)(i)&&(u=await this.createResourceLock(s));let v;try{if((0,n.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:l}=await D.SymlinkSupport.stat(c);l.mode&128||await D.Promises.chmod(c,l.mode|128)}catch(l){l.code!=="ENOENT"&&this.logService.trace(l)}let S;if((0,n.isFileOpenForWriteOptions)(i)){if(k.isWindows)try{await D.Promises.truncate(c,0),S="r+"}catch(l){l.code!=="ENOENT"&&this.logService.trace(l)}S||(S="w")}else S="r";v=await D.Promises.open(c,S)}catch(S){throw u?.dispose(),(0,n.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,S):this.toFileSystemProviderError(S)}if(this.mapHandleToPos.set(v,0),(0,n.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(v,s),u){const S=this.mapHandleToLock.get(v);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${c})`),this.mapHandleToLock.set(v,u),S&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${c})`),S.dispose())}return v}async close(s){const i=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&t.canFlush)try{await D.Promises.fdatasync(s)}catch(c){t.configureFlushOnWrite(!1),this.logService.error(c)}return await D.Promises.close(s)}catch(c){throw this.toFileSystemProviderError(c)}finally{i&&(this.mapHandleToLock.get(s)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,c,u,v){const S=this.normalizePos(s,i);let l=null;try{l=(await D.Promises.read(s,c,u,v,S)).bytesRead}catch(h){throw this.toFileSystemProviderError(h)}finally{this.updatePos(s,S,l)}return l}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,c){const u=this.mapHandleToPos.get(s);typeof u=="number"&&(typeof i=="number"||(typeof c=="number"?this.mapHandleToPos.set(s,u+c):this.mapHandleToPos.delete(s)))}async write(s,i,c,u,v){return(0,d.retry)(()=>this.doWrite(s,i,c,u,v),100,3)}async doWrite(s,i,c,u,v){const S=this.normalizePos(s,i);let l=null;try{l=(await D.Promises.write(s,c,u,v,S)).bytesWritten}catch(h){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),h)}finally{this.updatePos(s,S,l)}return l}async mkdir(s){try{await D.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const c=this.toFilePath(s);if(i.recursive){let u;i?.atomic!==!1&&i.atomic.postfix&&(u=(0,P.join)((0,P.dirname)(c),`${(0,P.basename)(c)}${i.atomic.postfix}`)),await D.Promises.rm(c,D.RimRafMode.MOVE,u)}else try{await D.Promises.unlink(c)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let v=!1;try{const{stat:S,symbolicLink:l}=await D.SymlinkSupport.stat(c);v=S.isDirectory()&&!l}catch{}if(v)await D.Promises.rmdir(c);else throw u}else throw u}}catch(c){throw this.toFileSystemProviderError(c)}}async rename(s,i,c){const u=this.toFilePath(s),v=this.toFilePath(i);if(u!==v)try{await this.validateMoveCopy(s,i,"move",c.overwrite),await D.Promises.rename(u,v)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,y.localize)(2,null,(0,P.basename)(u),(0,P.basename)((0,P.dirname)(v)),S.toString()))),this.toFileSystemProviderError(S)}}async copy(s,i,c){const u=this.toFilePath(s),v=this.toFilePath(i);if(u!==v)try{await this.validateMoveCopy(s,i,"copy",c.overwrite),await D.Promises.copy(u,v,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,y.localize)(3,null,(0,P.basename)(u),(0,P.basename)((0,P.dirname)(v)),S.toString()))),this.toFileSystemProviderError(S)}}async validateMoveCopy(s,i,c,u){const v=this.toFilePath(s),S=this.toFilePath(i);let l=!1;if(!!(this.capabilities&1024)||(l=(0,w.isEqual)(v,S,!0)),l){if(c==="copy")throw(0,n.createFileSystemProviderError)((0,y.localize)(4,null),n.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const E=await this.statIgnoreError(s);if(!E)throw(0,n.createFileSystemProviderError)((0,y.localize)(5,null),n.FileSystemProviderErrorCode.FileNotFound);const R=await this.statIgnoreError(i);if(R){if(!u)throw(0,n.createFileSystemProviderError)((0,y.localize)(6,null),n.FileSystemProviderErrorCode.FileExists);E.type&n.FileType.File&&R.type&n.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.doCloneFile(s,i,!1)}async doCloneFile(s,i,c){const u=this.toFilePath(s),v=this.toFilePath(i),S=!!(this.capabilities&1024);if((0,w.isEqual)(u,v,!S))return;const l=new g.DisposableStore;try{const[h,E]=await Promise.all([this.createResourceLock(s),this.createResourceLock(i)]);l.add(h),l.add(E),c&&await D.Promises.mkdir((0,P.dirname)(v),{recursive:!0}),await D.Promises.copyFile(u,v)}catch(h){if(h.code==="ENOENT"&&!c)return this.doCloneFile(s,i,!0);throw this.toFileSystemProviderError(h)}finally{l.dispose()}}createUniversalWatcher(s,i,c){return new b.UniversalWatcherClient(u=>s(u),u=>i(u),c)}createNonRecursiveWatcher(s,i,c){return new I.NodeJSWatcherClient(u=>s(u),u=>i(u),c)}toFileSystemProviderError(s){if(s instanceof n.FileSystemProviderError)return s;let i=s,c;switch(s.code){case"ENOENT":c=n.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=n.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=n.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=n.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=n.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=n.FileSystemProviderErrorCode.Unknown;break;default:c=n.FileSystemProviderErrorCode.Unknown}return(0,n.createFileSystemProviderError)(i,c)}async toFileSystemProviderWriteError(s,i){let c=this.toFileSystemProviderError(i);if(s&&c.code===n.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await D.SymlinkSupport.stat(this.toFilePath(s));u.mode&128||(c=(0,n.createFileSystemProviderError)(i,n.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return c}}e.DiskFileSystemProvider=t}),define(Ce[234],De([1,0,3,17]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class d extends C.Disposable{constructor(T,f=[]){super(),this.logger=new L.MultiplexLogger([T,...f]),this._register(T.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...f){this.logger.trace(T,...f)}debug(T,...f){this.logger.debug(T,...f)}info(T,...f){this.logger.info(T,...f)}warn(T,...f){this.logger.warn(T,...f)}error(T,...f){this.logger.error(T,...f)}flush(){this.logger.flush()}}e.LogService=d}),define(Ce[235],De([1,0,30,17]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var d;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(d||(d={}));async function A(g,P,k,p,_){try{const D=await new Promise((n,o)=>{me(["@vscode/spdlog"],n,o)});D.setFlushOn(d.Trace);const y=await D.createAsyncRotatingLogger(g,P,k,p);return _?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(D){console.error(D)}return null}function T(g,P,k){switch(P){case L.LogLevel.Trace:g.trace(k);break;case L.LogLevel.Debug:g.debug(k);break;case L.LogLevel.Info:g.info(k);break;case L.LogLevel.Warning:g.warn(k);break;case L.LogLevel.Error:g.error(k);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function f(g,P){switch(P){case L.LogLevel.Trace:g.setLevel(d.Trace);break;case L.LogLevel.Debug:g.setLevel(d.Debug);break;case L.LogLevel.Info:g.setLevel(d.Info);break;case L.LogLevel.Warning:g.setLevel(d.Warning);break;case L.LogLevel.Error:g.setLevel(d.Error);break;case L.LogLevel.Off:g.setLevel(d.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class w extends L.AbstractMessageLogger{constructor(P,k,p,_,D){super(),this.buffer=[],this.setLevel(D),this._loggerCreationPromise=this._createSpdLogLogger(P,k,p,_),this._register(this.onDidChangeLogLevel(y=>{this._logger&&f(this._logger,y)}))}async _createSpdLogLogger(P,k,p,_){const D=p?6:1,y=30/D*C.ByteSize.MB,n=await A(P,k,y,D,_);if(n){this._logger=n,f(this._logger,this.getLevel());for(const{level:o,message:a}of this.buffer)T(this._logger,o,a);this.buffer=[]}}log(P,k){this._logger?T(this._logger,P,k):this.getLevel()<=P&&this.buffer.push({level:P,message:k})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=w}),define(Ce[131],De([1,0,40,193,6]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var T;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(w){function g(D,y){return y-D}w.compare=g;const P=Object.create(null);P[w.Error]=(0,L.localize)(0,null),P[w.Warning]=(0,L.localize)(1,null),P[w.Info]=(0,L.localize)(2,null);function k(D){return P[D]||""}w.toString=k;function p(D){switch(D){case C.default.Error:return w.Error;case C.default.Warning:return w.Warning;case C.default.Info:return w.Info;case C.default.Ignore:return w.Hint}}w.fromSeverity=p;function _(D){switch(D){case w.Error:return C.default.Error;case w.Warning:return C.default.Warning;case w.Info:return C.default.Info;case w.Hint:return C.default.Ignore}}w.toSeverity=_}(T||(e.MarkerSeverity=T={}));var f;(function(w){const g="";function P(p){return k(p,!0)}w.makeKey=P;function k(p,_){const D=[g];return p.source?D.push(p.source.replace("\xA6","\\\xA6")):D.push(g),p.code?typeof p.code=="string"?D.push(p.code.replace("\xA6","\\\xA6")):D.push(p.code.value.replace("\xA6","\\\xA6")):D.push(g),p.severity!==void 0&&p.severity!==null?D.push(T.toString(p.severity)):D.push(g),p.message&&_?D.push(p.message.replace("\xA6","\\\xA6")):D.push(g),p.startLineNumber!==void 0&&p.startLineNumber!==null?D.push(p.startLineNumber.toString()):D.push(g),p.startColumn!==void 0&&p.startColumn!==null?D.push(p.startColumn.toString()):D.push(g),p.endLineNumber!==void 0&&p.endLineNumber!==null?D.push(p.endLineNumber.toString()):D.push(g),p.endColumn!==void 0&&p.endColumn!==null?D.push(p.endColumn.toString()):D.push(g),D.push(g),D.join("\xA6")}w.makeKeyOptionalMessage=k})(f||(e.IMarkerData=f={})),e.IMarkerService=(0,d.createDecorator)("markerService")}),define(Ce[236],De([1,0,4,40,6]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,d.createDecorator)("notificationService");var A;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var T;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));var f;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(f||(e.NotificationsFilter=f={}));class w{constructor(){this.progress=new g,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.NoOpNotification=w;class g{infinite(){}done(){}total(k){}worked(k){}}e.NoOpProgress=g}),define(Ce[132],De([1,0,15,2,6]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,d.createDecorator)("openerService");function A(g,P){return L.URI.isUri(g)?(0,C.equalsIgnoreCase)(g.scheme,P):(0,C.startsWithIgnoreCase)(g,P+":")}e.matchesScheme=A;function T(g,...P){return P.some(k=>A(g,k))}e.matchesSomeScheme=T;function f(g,P){return g.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.withSelection=f;function w(g){let P;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return k&&(P={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},g=g.with({fragment:""})),{selection:P,uri:g}}e.extractSelection=w}),define(Ce[237],De([1,0,9,41]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let d;if(typeof C.globals.vscode<"u"&&typeof C.globals.vscode.context<"u"){const A=C.globals.vscode.context.configuration();if(A)d=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){d=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:T,itemUrl:f,controlUrl:w}=d.extensionsGallery||{};Object.assign(d,{extensionsGallery:{serviceUrl:L.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:L.env.VSCODE_GALLERY_SEARCH_URL||T,itemUrl:L.env.VSCODE_GALLERY_ITEM_URL||f,controlUrl:L.env.VSCODE_GALLERY_CONTROL_URL||w}});try{const g=(...k)=>k.reduce((p,_)=>(Object.keys(_).forEach(D=>{Array.isArray(p[D])&&Array.isArray(_[D])?p[D]=_[D]:typeof p[D]=="object"&&typeof _[D]=="object"?p[D]=g(p[D],_[D]):p[D]=_[D]}),p),{}),P=globalThis._VSCODE_USER_PRODUCT_JSON||{};d=g(d,P)}catch{}if(L.env.VSCODE_DEV&&Object.assign(d,{nameShort:`${d.nameShort} Dev`,nameLong:`${d.nameLong} Dev`,dataFolderName:`${d.dataFolderName}-dev`,serverDataFolderName:d.serverDataFolderName?`${d.serverDataFolderName}-dev`:void 0}),!d.version){const g=globalThis._VSCODE_PACKAGE_JSON;Object.assign(d,{version:g.version,release:g.release})}}else d={},Object.keys(d).length===0&&Object.assign(d,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=d}),define(Ce[133],De([1,0,6]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,C.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__param||function(me,e){return function(C,L){e(C,L,me)}};define(Ce[83],De([1,0,13,22,3,6]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var T;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class f{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(k,p){this.callback=k,this.report=p?.async?this._reportAsync.bind(this):this._reportSync.bind(this)}_reportSync(k){this._value=k,this.callback(this._value)}_reportAsync(k){Promise.resolve(this._lastTask).finally(()=>{this._value=k;const p=this.callback(this._value);this._lastTask=Promise.resolve(p).finally(()=>this._lastTask=void 0)})}}e.Progress=f;let w=class extends d.Disposable{constructor(k,p){super(),this.deferred=new C.DeferredPromise,p.withProgress(k,_=>(this.reporter=_,this.lastStep&&_.report(this.lastStep),this.deferred.p)),this._register((0,d.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};e.UnmanagedProgress=w,e.UnmanagedProgress=w=qe([$e(1,e.IProgressService)],w);class g extends d.Disposable{constructor(k){super(),this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new d.DisposableStore)}start(k){this.stop();const p=++this.currentOperationId,_=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{p===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,d.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,d.toDisposable)(()=>_.cancel())),this.currentOperationDisposables.add((0,d.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:p,token:_.token,stop:()=>this.doStop(p),isCurrent:()=>this.currentOperationId===p}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=g,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(Ce[42],De([1,0,54,19]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class d{constructor(){this.data=new Map}add(T,f){C.ok(L.isString(T)),C.ok(L.isObject(f)),C.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,f)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new d}),define(Ce[104],De([1,0,4,42]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function d(f){return f.length>0&&f.charAt(f.length-1)==="#"?f.substring(0,f.length-1):f}class A{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,g){this.schemasById[d(w)]=g,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;L.Registry.add(e.Extensions.JSONContribution,T)}),define(Ce[134],De([1,0,18,4,19,184,50,104,42]),function(me,e,C,L,d,A,T,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=w.Registry.as(f.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const s=new Set;this.doRegisterConfigurations(t,r,s),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(t){const r=new Set;this.doDeregisterConfigurations(t,r),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:t,remove:r}){const s=new Set;this.doDeregisterConfigurations(r,s),this.doRegisterConfigurations(t,!1,s),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(t){const r=new Set;this.doRegisterDefaultConfigurations(t,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,r){const s=[];for(const{overrides:i,source:c}of t)for(const u in i)if(r.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const v=this.configurationDefaultsOverrides.get(u),S=v?.valuesSources??new Map;if(c)for(const R of Object.keys(i[u]))S.set(R,c);const l={...v?.value||{},...i[u]};this.configurationDefaultsOverrides.set(u,{source:c,value:l,valuesSources:S});const h=(0,T.getLanguageTagSettingPlainKey)(u),E={type:"object",default:l,description:A.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:l,source:d.isString(c)?void 0:c,defaultValueSource:c};s.push(...y(u)),this.configurationProperties[u]=E,this.defaultLanguageConfigurationOverridesNode.properties[u]=E}else{this.configurationDefaultsOverrides.set(u,{value:i[u],source:c});const v=this.configurationProperties[u];v&&(this.updatePropertyDefaultValue(u,v),this.updateSchema(u,v))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(t){const r=new Set;this.doDeregisterDefaultConfigurations(t,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,r){for(const{overrides:s,source:i}of t)for(const c in s){const u=this.configurationDefaultsOverrides.get(c),v=d.isString(i)?i:i?.id,S=d.isString(u?.source)?u?.source:u?.source?.id;if(v===S)if(r.add(c),this.configurationDefaultsOverrides.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const l=this.configurationProperties[c];l&&(this.updatePropertyDefaultValue(c,l),this.updateSchema(c,l))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let r=!1;const s=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,s),r=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,s),r=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,s),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const r of t)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,r,s){t.forEach(i=>{this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties,void 0,s),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,r){const s=i=>{if(i.properties)for(const c in i.properties){r.add(c);const u=this.configurationProperties[c];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[c],this.removeFromSchema(c,i.properties[c])}i.allOf?.forEach(c=>s(c))};for(const i of t){s(i);const c=this.configurationContributors.indexOf(i);c!==-1&&this.configurationContributors.splice(c,1)}}validateAndRegisterProperties(t,r=!0,s,i,c=3,u){c=d.isUndefinedOrNull(t.scope)?c:t.scope;const v=t.properties;if(v)for(const l in v){const h=v[l];if(r&&m(l,h)){delete v[l];continue}if(h.source=s,h.defaultDefaultValue=v[l].default,this.updatePropertyDefaultValue(l,h),e.OVERRIDE_PROPERTY_REGEX.test(l)?h.scope=void 0:(h.scope=d.isUndefinedOrNull(h.scope)?c:h.scope,h.restricted=d.isUndefinedOrNull(h.restricted)?!!i?.includes(l):h.restricted),v[l].hasOwnProperty("included")&&!v[l].included){this.excludedConfigurationProperties[l]=v[l],delete v[l];continue}else this.configurationProperties[l]=v[l],v[l].policy?.name&&this.policyConfigurations.set(v[l].policy.name,l);!v[l].deprecationMessage&&v[l].markdownDeprecationMessage&&(v[l].deprecationMessage=v[l].markdownDeprecationMessage),u.add(l)}const S=t.allOf;if(S)for(const l of S)this.validateAndRegisterProperties(l,r,s,i,c,u)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const r=s=>{const i=s.properties;if(i)for(const u in i)this.updateSchema(u,i[u]);s.allOf?.forEach(r)};r(t)}updateSchema(t,r){switch(e.allSettings.properties[t]=r,r.scope){case 1:e.applicationSettings.properties[t]=r;break;case 2:e.machineSettings.properties[t]=r;break;case 6:e.machineOverridableSettings.properties[t]=r;break;case 3:e.windowSettings.properties[t]=r;break;case 4:e.resourceSettings.properties[t]=r;break;case 5:e.resourceSettings.properties[t]=r,this.resourceLanguageSettingsSchema.properties[t]=r;break}}removeFromSchema(t,r){switch(delete e.allSettings.properties[t],r.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const r=`[${t}]`,s={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,s),e.allSettings.properties[r]=s,e.applicationSettings.properties[r]=s,e.machineSettings.properties[r]=s,e.machineOverridableSettings.properties[r]=s,e.windowSettings.properties[r]=s,e.resourceSettings.properties[r]=s}}registerOverridePropertyPatternKey(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,r){const s=this.configurationDefaultsOverrides.get(t);let i=s?.value,c=s?.source;d.isUndefined(i)&&(i=r.defaultDefaultValue,c=void 0),d.isUndefined(i)&&(i=o(r.type)),r.default=i,r.defaultValueSource=c}}const _="\\[([^\\]]+)\\]",D=new RegExp(_,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${_})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(I){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(I)){let r=D.exec(I);for(;r?.length;){const s=r[1].trim();s&&t.push(s),r=D.exec(I)}}return(0,C.distinct)(t)}e.overrideIdentifiersFromKey=y;function n(I){return I.reduce((t,r)=>`${t}[${r}]`,"")}e.keyFromOverrideIdentifiers=n;function o(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const a=new p;w.Registry.add(e.Extensions.Configuration,a);function m(I,t){return I.trim()?e.OVERRIDE_PROPERTY_REGEX.test(I)?A.localize(7,null,I):a.getConfigurationProperties()[I]!==void 0?A.localize(8,null,I):t.policy?.name&&a.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,I,t.policy?.name,a.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=m;function b(){const I=[],t=a.getConfigurationProperties();for(const r of Object.keys(t))I.push([r,t[r].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=b}),define(Ce[238],De([1,0,18,4,154,3,28,23,19,2,50,134,42]),function(me,e,C,L,d,A,T,f,w,g,P,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function _(r){return Object.isFrozen(r)?r:f.deepFreeze(r)}class D{constructor(s={},i=[],c=[],u){this._contents=s,this._keys=i,this._overrides=c,this.raw=u,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof D)return i;const c=new y("");return c.parseRaw(i),c.configurationModel});this._rawConfiguration=s.reduce((i,c)=>c===i?c:i.merge(c),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,P.getConfigurationValue)(this.contents,s):this.contents}inspect(s,i){const c=this.rawConfiguration.getValue(s),u=i?this.rawConfiguration.getOverrideValue(s,i):void 0,v=i?this.rawConfiguration.override(i).getValue(s):c;return{value:c,override:u,merged:v}}getOverrideValue(s,i){const c=this.getContentsForOverrideIdentifer(i);return c?s?(0,P.getConfigurationValue)(c,s):c:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const c of this.overrides)c.identifiers.includes(s)&&i.push(...c.keys);return C.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return C.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=f.deepClone(this.contents),c=f.deepClone(this.overrides),u=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const S of s)if(v.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.mergeContents(i,S.contents);for(const l of S.overrides){const[h]=c.filter(E=>C.equals(E.identifiers,l.identifiers));h?(this.mergeContents(h.contents,l.contents),h.keys.push(...l.keys),h.keys=C.distinct(h.keys)):c.push(f.deepClone(l))}for(const l of S.keys)u.indexOf(l)===-1&&u.push(l)}return new D(i,u,c,v.every(S=>S instanceof D)?void 0:v)}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const c={};for(const u of C.distinct([...Object.keys(this.contents),...Object.keys(i)])){let v=this.contents[u];const S=i[u];S&&(typeof v=="object"&&typeof S=="object"?(v=f.deepClone(v),this.mergeContents(v,S)):v=S),c[u]=v}return new D(c,this.keys,this.overrides)}mergeContents(s,i){for(const c of Object.keys(i)){if(c in s&&w.isObject(s[c])&&w.isObject(i[c])){this.mergeContents(s[c],i[c]);continue}s[c]=f.deepClone(i[c])}}getContentsForOverrideIdentifer(s){let i=null,c=null;const u=v=>{v&&(c?this.mergeContents(c,v):c=f.deepClone(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===s?i=v.contents:v.identifiers.includes(s)&&u(v.contents);return u(i),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.updateValue(s,i,!0)}setValue(s,i){this.updateValue(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,P.removeFromValueTree)(this.contents,s),k.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(c=>C.equals(c.identifiers,(0,k.overrideIdentifiersFromKey)(s))),1))}updateValue(s,i,c){(0,P.addToValueTree)(this.contents,s,i,u=>console.error(u)),c=c||this.keys.indexOf(s)===-1,c&&this.keys.push(s),k.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,k.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,P.toValuesTree)(this.contents[s],u=>console.error(u))})}}e.ConfigurationModel=D;class y{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new D}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!w.isUndefinedOrNull(s)){const c=this.doParseContent(s);this.parseRaw(c,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:c,keys:u,overrides:v,restricted:S,hasExcludedProperties:l}=this.doParseRaw(s,i);this._configurationModel=new D(c,u,v,l?[s]:void 0),this._restrictedConfigurations=S||[]}doParseContent(s){let i={},c=null,u=[];const v=[],S=[];function l(E){Array.isArray(u)?u.push(E):c!==null&&(u[c]=E)}const h={onObjectBegin:()=>{const E={};l(E),v.push(u),u=E,c=null},onObjectProperty:E=>{c=E},onObjectEnd:()=>{u=v.pop()},onArrayBegin:()=>{const E=[];l(E),v.push(u),u=E,c=null},onArrayEnd:()=>{u=v.pop()},onLiteralValue:l,onError:(E,R,M)=>{S.push({error:E,offset:R,length:M})}};if(s)try{d.visit(s,h),i=u[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return i}doParseRaw(s,i){const c=p.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),u=this.filter(s,c,!0,i);s=u.raw;const v=(0,P.toValuesTree)(s,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),S=Object.keys(s),l=this.toOverrides(s,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:v,keys:S,overrides:l,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}filter(s,i,c,u){let v=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:v};const S={},l=[];for(const h in s)if(k.OVERRIDE_PROPERTY_REGEX.test(h)&&c){const E=this.filter(s[h],i,!1,u);S[h]=E.raw,v=v||E.hasExcludedProperties,l.push(...E.restricted)}else{const E=i[h],R=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&l.push(h),!u.exclude?.includes(h)&&(u.include?.includes(h)||(R===void 0||u.scopes===void 0||u.scopes.includes(R))&&!(u.skipRestricted&&E?.restricted))?S[h]=s[h]:v=!0}return{raw:S,restricted:l,hasExcludedProperties:v}}toOverrides(s,i){const c=[];for(const u of Object.keys(s))if(k.OVERRIDE_PROPERTY_REGEX.test(u)){const v={};for(const S in s[u])v[S]=s[u][S];c.push({identifiers:(0,k.overrideIdentifiersFromKey)(u),keys:Object.keys(v),contents:(0,P.toValuesTree)(v,i)})}return c}}e.ConfigurationModelParser=y;class n extends A.Disposable{constructor(s,i,c,u){super(),this.userSettingsResource=s,this.parseOptions=i,this.fileService=u,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this._register(this.fileService.watch(c.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,v=>v.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&c.isEqual(v.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new D}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=n;class o{constructor(s,i,c,u,v,S,l,h,E,R,M,U,F){this.key=s,this.overrides=i,this._value=c,this.overrideIdentifiers=u,this.defaultConfiguration=v,this.policyConfiguration=S,this.applicationConfiguration=l,this.userConfiguration=h,this.localUserConfiguration=E,this.remoteUserConfiguration=R,this.workspaceConfiguration=M,this.folderConfigurationModel=U,this.memoryConfigurationModel=F}get value(){return _(this._value)}inspect(s,i,c){const u=s.inspect(i,c);return{get value(){return _(u.value)},get override(){return _(u.override)},get merged(){return _(u.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class a{constructor(s,i,c,u,v=new D,S=new D,l=new T.ResourceMap,h=new D,E=new T.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=i,this._applicationConfiguration=c,this._localUserConfiguration=u,this._remoteUserConfiguration=v,this._workspaceConfiguration=S,this._folderConfigurations=l,this._memoryConfiguration=h,this._memoryConfigurationByResource=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(s,i,c){return this.getConsolidatedConfigurationModel(s,i,c).getValue(s)}updateValue(s,i,c={}){let u;c.resource?(u=this._memoryConfigurationByResource.get(c.resource),u||(u=new D,this._memoryConfigurationByResource.set(c.resource,u))):u=this._memoryConfiguration,i===void 0?u.removeValue(s):u.setValue(s,i),c.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,c){const u=this.getConsolidatedConfigurationModel(s,i,c),v=this.getFolderConfigurationModelForResource(i.resource,c),S=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,l=new Set;for(const h of u.overrides)for(const E of h.identifiers)u.getOverrideValue(s,E)!==void 0&&l.add(E);return new o(s,i,u.getValue(s),l.size?[...l]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this._workspaceConfiguration:void 0,v||void 0,S)}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const c=[];if(!i){const{added:u,updated:v,removed:S}=I(this._defaultConfiguration,s);i=[...u,...v,...S]}for(const u of i)for(const v of(0,k.overrideIdentifiersFromKey)(u)){const S=this._defaultConfiguration.getKeysForOverrideIdentifier(v),l=s.getKeysForOverrideIdentifier(v),h=[...l.filter(E=>S.indexOf(E)===-1),...S.filter(E=>l.indexOf(E)===-1),...S.filter(E=>!f.equals(this._defaultConfiguration.override(v).getValue(E),s.override(v).getValue(E)))];c.push([v,h])}return this.updateDefaultConfiguration(s),{keys:i,overrides:c}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:c,removed:u}=I(this._policyConfiguration,s),v=[...i,...c,...u];return v.length&&this.updatePolicyConfiguration(s),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:c,removed:u,overrides:v}=I(this.applicationConfiguration,s),S=[...i,...c,...u];return S.length&&this.updateApplicationConfiguration(s),{keys:S,overrides:v}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:c,removed:u,overrides:v}=I(this.localUserConfiguration,s),S=[...i,...c,...u];return S.length&&this.updateLocalUserConfiguration(s),{keys:S,overrides:v}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:c,removed:u,overrides:v}=I(this.remoteUserConfiguration,s),S=[...i,...c,...u];return S.length&&this.updateRemoteUserConfiguration(s),{keys:S,overrides:v}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:c,removed:u,overrides:v}=I(this.workspaceConfiguration,s),S=[...i,...c,...u];return S.length&&this.updateWorkspaceConfiguration(s),{keys:S,overrides:v}}compareAndUpdateFolderConfiguration(s,i){const c=this.folderConfigurations.get(s),{added:u,updated:v,removed:S,overrides:l}=I(c,i),h=[...u,...v,...S];return(h.length||!c)&&this.updateFolderConfiguration(s,i),{keys:h,overrides:l}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:c,updated:u,removed:v,overrides:S}=I(i,void 0);return{keys:[...c,...u,...v],overrides:S}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,i,c){let u=this.getConsolidatedConfigurationModelForResource(i,c);return i.overrideIdentifier&&(u=u.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(u=u.merge(this._policyConfiguration)),u}getConsolidatedConfigurationModelForResource({resource:s},i){let c=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const u=i.getFolder(s);u&&(c=this.getFolderConsolidatedConfiguration(u.uri)||c);const v=this._memoryConfigurationByResource.get(s);v&&(c=c.merge(v))}return c}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const c=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(s);u?(i=c.merge(u),this._foldersConsolidatedConfigurations.set(s,i)):i=c}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const c=i.getFolder(s);if(c)return this._folderConfigurations.get(c.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:c,overrides:u,keys:v}=this._folderConfigurations.get(i);return s.push([i,{contents:c,overrides:u,keys:v}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this._workspaceConfiguration.keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(c=>s.add(c))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(c=>s.add(c))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(c=>i.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(c=>i.add(c)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(c=>i.add(c)),this._folderConfigurations.forEach(c=>c.getKeysForOverrideIdentifier(s).forEach(u=>i.add(u))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),c=this.parseConfigurationModel(s.policy),u=this.parseConfigurationModel(s.application),v=this.parseConfigurationModel(s.user),S=this.parseConfigurationModel(s.workspace),l=s.folders.reduce((h,E)=>(h.set(g.URI.revive(E[0]),this.parseConfigurationModel(E[1])),h),new T.ResourceMap);return new a(i,c,u,v,new D,S,l,new D,new T.ResourceMap)}static parseConfigurationModel(s){return new D(s.contents,s.keys,s.overrides)}}e.Configuration=a;function m(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,i=new Map;for(const u of r)u.keys.forEach(v=>s.add(v)),u.overrides.forEach(([v,S])=>{const l=(0,T.getOrSet)(i,v,new Set);S.forEach(h=>l.add(h))});const c=[];return i.forEach((u,v)=>c.push([v,[...u.values()]])),{keys:[...s.values()],overrides:c}}e.mergeChanges=m;class b{constructor(s,i,c,u){this.change=s,this.previous=i,this.currentConfiguraiton=c,this.currentWorkspace=u,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const v of s.keys)this.affectedKeys.add(v);for(const[,v]of s.overrides)for(const S of v)this.affectedKeys.add(S);this._affectsConfigStr=this._marker;for(const v of this.affectedKeys)this._affectsConfigStr+=v+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=a.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){const c=this._marker+s,u=this._affectsConfigStr.indexOf(c);if(u<0)return!1;const v=u+c.length;if(v>=this._affectsConfigStr.length)return!1;const S=this._affectsConfigStr.charCodeAt(v);if(S!==this._markerCode1&&S!==this._markerCode2)return!1;if(i){const l=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!f.equals(l,h)}return!0}}e.ConfigurationChangeEvent=b;function I(r,s){const{added:i,removed:c,updated:u}=t(s?.rawConfiguration,r?.rawConfiguration),v=[],S=r?.getAllOverrideIdentifiers()||[],l=s?.getAllOverrideIdentifiers()||[];if(s){const h=l.filter(E=>!S.includes(E));for(const E of h)v.push([E,s.getKeysForOverrideIdentifier(E)])}if(r){const h=S.filter(E=>!l.includes(E));for(const E of h)v.push([E,r.getKeysForOverrideIdentifier(E)])}if(s&&r){for(const h of S)if(l.includes(h)){const E=t({contents:r.getOverrideValue(void 0,h)||{},keys:r.getKeysForOverrideIdentifier(h)},{contents:s.getOverrideValue(void 0,h)||{},keys:s.getKeysForOverrideIdentifier(h)});v.push([h,[...E.added,...E.removed,...E.updated]])}}return{added:i,removed:c,updated:u,overrides:v}}function t(r,s){const i=r?s?r.keys.filter(v=>s.keys.indexOf(v)===-1):[...r.keys]:[],c=s?r?s.keys.filter(v=>r.keys.indexOf(v)===-1):[...s.keys]:[],u=[];if(r&&s){for(const v of s.keys)if(r.keys.indexOf(v)!==-1){const S=(0,P.getConfigurationValue)(s.contents,v),l=(0,P.getConfigurationValue)(r.contents,v);f.equals(S,l)||u.push(v)}}return{added:i,removed:c,updated:u}}}),define(Ce[239],De([1,0,21,4,3,80]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.connectManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const T=(g,P,k)=>{const p=new Uint8Array(16);for(let y=0;y<16;y++)p[y]=Math.round(Math.random()*256);const _=(0,C.encodeBase64)(C.VSBuffer.wrap(p));return[`GET ws://localhost${g}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${_}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=T,e.socketRawEndHeaderSequence=C.VSBuffer.fromString(`\r
\r
`);async function f(g,P,k,p,_){g.write(C.VSBuffer.fromString((0,e.makeRawSocketHeaders)(P,k,p)));const D=new d.DisposableStore;try{return await new Promise((y,n)=>{let o;D.add(g.onData(a=>{o?o=C.VSBuffer.concat([o,a],o.byteLength+a.byteLength):o=a;const m=o.indexOf(e.socketRawEndHeaderSequence);if(m===-1)return;y(g),g.pauseData();const b=o.slice(m+e.socketRawEndHeaderSequence.byteLength);b.byteLength&&_.onData.fire(b)})),D.add(g.onClose(a=>n(a??new Error("socket closed")))),D.add(g.onEnd(()=>n(new Error("socket ended"))))})}catch(y){throw g.dispose(),y}finally{D.dispose()}}e.connectManagedSocket=f;class w extends d.Disposable{constructor(P,k){super(),this.debugLabel=P,this.pausableDataEmitter=this._register(new L.PauseableEmitter),this.onData=(...p)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...p)),this.didDisposeEmitter=this._register(new L.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(k.onData),this._register(k.onData.event(p=>this.pausableDataEmitter.fire(p))),this.onClose=this._register(k.onClose).event,this.onEnd=this._register(k.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(P,k){A.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,P,k)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=w}),define(Ce[84],De([1,0,8,6]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var d;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(d||(e.RemoteConnectionType=d={}));class A{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class T{constructor(k,p){this.host=k,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=T;var f;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(f||(e.RemoteAuthorityResolverErrorCode=f={}));class w extends C.ErrorNoTelemetry{static isNotAvailable(k){return k instanceof w&&k._code===f.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof w&&k._code===f.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof w&&k._code===f.NoResolverFound}static isInvalidAuthority(k){return k instanceof w&&k._code===f.InvalidAuthority}static isHandled(k){return k instanceof w&&k.isHandled}constructor(k,p=f.Unknown,_){super(k),this._message=k,this._code=p,this._detail=_,this.isHandled=p===f.NotAvailable&&_===!0,Object.setPrototypeOf(this,w.prototype)}}e.RemoteAuthorityResolverError=w;function g(P){const k=P.indexOf("+");return k===-1?P:P.substring(0,k)}e.getRemoteAuthorityPrefix=g}),define(Ce[60],De([1,0,16]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(g){return g.scheme===C.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=L;function d(g){if(!g)return;const P=g.indexOf("+");return P<0?g:g.substr(0,P)}e.getRemoteName=d;function A(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.getRemoteServerRootPath=A;function T(g){const{host:P,port:k}=w(g);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:k}}e.parseAuthorityWithPort=T;function f(g,P){let{host:k,port:p}=w(g);return typeof p>"u"&&(p=P),{host:k,port:p}}e.parseAuthorityWithOptionalPort=f;function w(g){const P=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const k=g.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const p=g.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:g,port:void 0}}}),define(Ce[25],De([1,0,15,6,60]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(T||(e.ExtensionType=T={}));var f;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.LINUX_PPC64LE="linux-ppc64le",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(f||(e.TargetPlatform=f={}));class w{constructor(n){this.value=n,this._lower=n.toLowerCase()}static equals(n,o){if(typeof n>"u"||n===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof n=="string"||typeof o=="string"){const a=typeof n=="string"?n:n.value,m=typeof o=="string"?o:o.value;return C.equalsIgnoreCase(a,m)}return n._lower===o._lower}static toKey(n){return typeof n=="string"?n.toLowerCase():n._lower}}e.ExtensionIdentifier=w;class g{get size(){return this._set.size}constructor(n){if(this._set=new Set,n)for(const o of n)this.add(o)}add(n){this._set.add(w.toKey(n))}delete(n){return this._set.delete(w.toKey(n))}has(n){return this._set.has(w.toKey(n))}}e.ExtensionIdentifierSet=g;class P{constructor(){this._map=new Map}clear(){this._map.clear()}delete(n){this._map.delete(w.toKey(n))}get(n){return this._map.get(w.toKey(n))}has(n){return this._map.has(w.toKey(n))}set(n,o){this._map.set(w.toKey(n),o)}values(){return this._map.values()}forEach(n){this._map.forEach(n)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function k(y){return p(y)}e.isApplicationScopedExtension=k;function p(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function _(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=_;function D(y,n){if(n){const o=`onResolveRemoteAuthority:${(0,d.getRemoteName)(n)}`;return!!y.activationEvents?.includes(o)}return!1}e.isResolverExtension=D,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[135],De([1,0,8,25]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class d{constructor(){this._generators=new Map,this._cache=new WeakMap}register(T,f){this._generators.set(T,f)}readActivationEvents(T){return this._cache.has(T)||this._cache.set(T,this._readActivationEvents(T)),this._cache.get(T)}createActivationEventsMap(T){const f=Object.create(null);for(const w of T){const g=this.readActivationEvents(w);g.length>0&&(f[L.ExtensionIdentifier.toKey(w.identifier)]=g)}return f}_readActivationEvents(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const f=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];if(!T.contributes)return f;for(const w in T.contributes){const g=this._generators.get(w);if(!g)continue;const P=T.contributes[w],k=Array.isArray(P)?P:[P];try{g(k,f)}catch(p){(0,C.onUnexpectedError)(p)}}return f}}e.ImplicitActivationEventsImpl=d,e.ImplicitActivationEvents=new d}),define(Ce[240],De([1,0,13,21,22,8,4,3,61,37,31,80,84,60]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const D=30*1e3;var y;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function n(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(J){const N=new d.CancellationTokenSource;return setTimeout(()=>N.cancel(),J),N.token}function a(J,N){if(J.isCancellationRequested||N.isCancellationRequested)return d.CancellationToken.Cancelled;const W=new d.CancellationTokenSource;return J.onCancellationRequested(()=>W.cancel()),N.onCancellationRequested(()=>W.cancel()),W.token}class m{get didTimeout(){return this._state==="timedout"}constructor(N){this._state="pending",this._disposables=new f.DisposableStore,this.promise=new Promise((W,he)=>{this._resolvePromise=W,this._rejectPromise=he}),N.isCancellationRequested?this._timeout():this._disposables.add(N.onCancellationRequested(()=>this._timeout()))}registerDisposable(N){this._state==="pending"?this._disposables.add(N):N.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const N=new Error("Time limit reached");return N.code="ETIMEDOUT",N.syscall="connect",N}resolve(N){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(N))}reject(N){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(N))}}function b(J,N){const W=new m(N);return W.registerDisposable(J.onControlMessage(he=>{const Se=JSON.parse(he.toString()),be=ie(Se);be?W.reject(be):W.resolve(Se)})),W.promise}function I(J,N,W,he,Se,be,we,ye){const V=new m(ye),ee=g.StopWatch.create(!1);return J.info(`Creating a socket (${we})...`),w.mark(`code/willCreateSocket/${be}`),N.connect(W,he,Se,we).then(G=>{V.didTimeout?(w.mark(`code/didCreateSocketError/${be}`),J.info(`Creating a socket (${we}) finished after ${ee.elapsed()} ms, but this is too late and has timed out already.`),G?.dispose()):(w.mark(`code/didCreateSocketOK/${be}`),J.info(`Creating a socket (${we}) was successful after ${ee.elapsed()} ms.`),V.resolve(G))},G=>{w.mark(`code/didCreateSocketError/${be}`),J.info(`Creating a socket (${we}) returned an error after ${ee.elapsed()} ms.`),J.error(G),V.reject(G)}),V.promise}function t(J,N){const W=new m(N);return J.then(he=>{W.didTimeout||W.resolve(he)},he=>{W.didTimeout||W.reject(he)}),W.promise}async function r(J,N,W,he){const Se=ae(J,N);J.logService.trace(`${Se} 1/6. invoking socketFactory.connect().`);let be;try{be=await I(J.logService,J.remoteSocketFactoryService,J.connectTo,(0,_.getRemoteServerRootPath)(J),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,n(N),`renderer-${n(N)}-${J.reconnectionToken}`,he)}catch(G){throw J.logService.error(`${Se} socketFactory.connect() failed or timed out. Error:`),J.logService.error(G),G}J.logService.trace(`${Se} 2/6. socketFactory.connect() was successful.`);let we,ye;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(be,null),we=J.reconnectionProtocol,ye=!1):(we=new k.PersistentProtocol({socket:be}),ye=!0),J.logService.trace(`${Se} 3/6. sending AuthRequest control message.`);const V=await t(J.signService.createNewMessage((0,P.generateUuid)()),he),ee={type:"auth",auth:J.connectionToken||"00000000000000000000",data:V.data};we.sendControl(L.VSBuffer.fromString(JSON.stringify(ee)));try{const G=await b(we,a(he,o(1e4)));if(G.type!=="sign"||typeof G.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(J.logService.trace(`${Se} 4/6. received SignRequest control message.`),!await t(J.signService.validate(V,G.signedData),he)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const de=await t(J.signService.sign(G.data),he),ke={type:"connectionType",commit:J.commit,signedData:de,desiredConnectionType:N};return W&&(ke.args=W),J.logService.trace(`${Se} 5/6. sending ConnectionTypeRequest control message.`),we.sendControl(L.VSBuffer.fromString(JSON.stringify(ke))),{protocol:we,ownsProtocol:ye}}catch(G){throw G&&G.code==="ETIMEDOUT"&&(J.logService.error(`${Se} the handshake timed out. Error:`),J.logService.error(G)),G&&G.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${Se} received error control message when negotiating connection. Error:`),J.logService.error(G)),ye&&se(we),G}}async function s(J,N,W,he){const Se=Date.now(),be=ae(J,N),{protocol:we,ownsProtocol:ye}=await r(J,N,W,he),V=new m(he);return V.registerDisposable(we.onControlMessage(ee=>{const G=JSON.parse(ee.toString()),Y=ie(G);Y?(J.logService.error(`${be} received error control message when negotiating connection. Error:`),J.logService.error(Y),ye&&se(we),V.reject(Y)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${be} 6/6. handshake finished, connection is up and running after ${ne(Se)}!`),V.resolve({protocol:we,firstMessage:G}))})),V.promise}async function i(J,N){const{protocol:W}=await s(J,1,void 0,N);return{protocol:W}}async function c(J,N,W){const{protocol:he,firstMessage:Se}=await s(J,2,N,W),be=Se&&Se.debugPort;return{protocol:he,debugPort:be}}async function u(J,N,W){const he=Date.now(),Se=ae(J,3),{protocol:be}=await r(J,3,N,W);return J.logService.trace(`${Se} 6/6. handshake finished, connection is up and running after ${ne(he)}!`),be}async function v(J,N,W){const{connectTo:he,connectionToken:Se}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:he,connectionToken:Se,reconnectionToken:N,reconnectionProtocol:W,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function S(J,N,W){return h(J,async he=>{const{protocol:Se}=await i(he,d.CancellationToken.None);return new q(J,N,W,he.reconnectionToken,Se)})}e.connectRemoteAgentManagement=S;async function l(J,N){return h(J,async W=>{const{protocol:he,debugPort:Se}=await c(W,N,d.CancellationToken.None);return new fe(J,N,W.reconnectionToken,he,Se)})}e.connectRemoteAgentExtensionHost=l;async function h(J,N){for(let he=1;;he++)try{const Se=(0,P.generateUuid)(),be=await v(J,Se,null);return await N(be)}catch(Se){if(he<5)J.logService.error(`[remote-connection][attempt ${he}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(Se);else throw J.logService.error(`[remote-connection][attempt ${he}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(Se),K.triggerPermanentFailure(0,0,p.RemoteAuthorityResolverError.isHandled(Se)),Se}}async function E(J,N,W){const he=await v(J,(0,P.generateUuid)(),null);return await u(he,{host:N,port:W},d.CancellationToken.None)}e.connectRemoteAgentTunnel=E;function R(J){return(0,C.createCancelablePromise)(N=>new Promise((W,he)=>{const Se=setTimeout(W,J*1e3);N.onCancellationRequested(()=>{clearTimeout(Se),W()})}))}var M;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class U{constructor(N,W){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=U;class F{constructor(N,W,he,Se){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.durationSeconds=he,this.cancellableTimer=Se,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class x{constructor(N,W,he){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.attempt=he,this.type=2}}e.ReconnectionRunningEvent=x;class ${constructor(N,W,he){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.attempt=he,this.type=4}}e.ConnectionGainEvent=$;class O{constructor(N,W,he,Se){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.attempt=he,this.handled=Se,this.type=3}}e.ReconnectionPermanentFailureEvent=O;class K extends f.Disposable{static triggerPermanentFailure(N,W,he){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=N,this._permanentFailureAttempt=W,this._permanentFailureHandled=he,this._instances.forEach(Se=>Se._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(N=>N._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(N=>N._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||K._permanentFailure}constructor(N,W,he,Se,be){super(),this._connectionType=N,this._options=W,this.reconnectionToken=he,this.protocol=Se,this._reconnectionFailureIsFatal=be,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new $(this.reconnectionToken,0,0)),this._register(Se.onSocketClose(we=>{const ye=Ee(this._connectionType,this.reconnectionToken,!0);we?we.type===0?(this._options.logService.info(`${ye} received socket close event (hadError: ${we.hadError}).`),we.error&&this._options.logService.error(we.error)):(this._options.logService.info(`${ye} received socket close event (wasClean: ${we.wasClean}, code: ${we.code}, reason: ${we.reason}).`),we.event&&this._options.logService.error(we.event)):this._options.logService.info(`${ye} received socket close event.`),this._beginReconnecting()})),this._register(Se.onSocketTimeout(we=>{const ye=Ee(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ye} received socket timeout event (unacknowledgedMsgCount: ${we.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${we.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${we.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),K._instances.push(this),this._register((0,f.toDisposable)(()=>{const we=K._instances.indexOf(this);we>=0&&K._instances.splice(we,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(K._permanentFailureMillisSinceLastIncomingData,K._permanentFailureAttempt,K._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const N=Ee(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${N} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let he=-1;do{he++;const Se=he<W.length?W[he]:W[W.length-1];try{if(Se>0){const we=R(Se);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Se,we)),this._options.logService.info(`${N} waiting for ${Se} seconds before reconnecting...`);try{await we}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${N} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),he+1)),this._options.logService.info(`${N} resolving connection...`);const be=await v(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${N} connecting to ${be.connectTo}...`),await this._reconnect(be,o(D)),this._options.logService.info(`${N} reconnected!`),this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),he+1));break}catch(be){if(be.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${N} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(be),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),he+1,!1);break}if(he>360){this._options.logService.error(`${N} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(be),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),he+1,!1);break}if(p.RemoteAuthorityResolverError.isTemporarilyNotAvailable(be)){this._options.logService.info(`${N} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(be);continue}if((be.code==="ETIMEDOUT"||be.code==="ENETUNREACH"||be.code==="ECONNREFUSED"||be.code==="ECONNRESET")&&be.syscall==="connect"){this._options.logService.info(`${N} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(be);continue}if((0,A.isCancellationError)(be)){this._options.logService.info(`${N} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(be);continue}if(be instanceof p.RemoteAuthorityResolverError){this._options.logService.error(`${N} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(be),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),he+1,p.RemoteAuthorityResolverError.isHandled(be));break}this._options.logService.error(`${N} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(be),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),he+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(N,W,he){this._reconnectionFailureIsFatal?K.triggerPermanentFailure(N,W,he):this._gotoPermanentFailure(N,W,he)}_gotoPermanentFailure(N,W,he){this._onDidStateChange.fire(new O(this.reconnectionToken,N,W,he)),se(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=K;class q extends K{constructor(N,W,he,Se,be){super(1,N,Se,be,!0),this.client=this._register(new k.Client(be,{remoteAuthority:W,clientId:he},N.ipcLogger))}async _reconnect(N,W){await i(N,W)}}e.ManagementPersistentConnection=q;class fe extends K{constructor(N,W,he,Se,be){super(2,N,he,Se,!1),this._startArguments=W,this.debugPort=be}async _reconnect(N,W){await c(N,this._startArguments,W)}}e.ExtensionHostPersistentConnection=fe;function se(J){try{J.acceptDisconnect();const N=J.getSocket();J.dispose(),N.dispose()}catch(N){(0,A.onUnexpectedError)(N)}}function ie(J){if(J&&J.type==="error"){const N=new Error(`Connection error: ${J.reason}`);return N.code="VSCODE_CONNECTION_ERROR",N}return null}function H(J,N){for(;J.length<N;)J+=" ";return J}function re(J,N){return`[remote-connection][${H(n(J),13)}][${N.substr(0,5)}\u2026]`}function Ee(J,N,W){return`${re(J,N)}[${W?"reconnect":"initial"}]`}function ae(J,N){return`${Ee(N,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function ne(J){return`${Date.now()-J} ms`}}),define(Ce[241],De([1,0,3,6]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,L.createDecorator)("remoteSocketFactoryService");class d{constructor(){this.factories={}}register(T,f){return this.factories[T]??=[],this.factories[T].push(f),(0,C.toDisposable)(()=>{const w=this.factories[T]?.indexOf(f);typeof w=="number"&&w>=0&&this.factories[T]?.splice(w,1)})}getSocketFactory(T){return(this.factories[T.type]||[]).find(w=>w.supports(T))}connect(T,f,w,g){const P=this.getSocketFactory(T);if(!P)throw new Error(`No socket factory found for ${T}`);return P.connect(T,f,w,g)}}e.RemoteSocketFactoryService=d}),define(Ce[242],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class C{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(d){try{const A=await this.getValidator();if(A){const T=String(C._nextId++);return this.validators.set(T,A),{id:T,data:A.createNewMessage(d)}}}catch{}return{id:"",data:d}}async validate(d,A){if(!d.id)return!0;const T=this.validators.get(d.id);if(!T)return!1;this.validators.delete(d.id);try{return T.validate(A)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(d){try{return await this.signValue(d)}catch{}return d}}e.AbstractSignService=C}),define(Ce[105],De([1,0,6]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,C.createDecorator)(e.SIGN_SERVICE_ID)}),define(Ce[136],De([1,0,242]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L extends C.AbstractSignService{getValidator(){return this.vsda().then(A=>new A.validator)}signValue(A){return this.vsda().then(T=>new T.signer().sign(A))}vsda(){return new Promise((A,T)=>me(["vsda"],A,T))}}e.SignService=L}),define(Ce[243],De([1,0,9,41,31]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(w){if(C.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}function T(w,g,P,k,p,_,D,y){const n=Object.create(null);n["common.machineId"]=_,n.sessionID=(0,d.generateUuid)()+Date.now(),n.commitHash=k,n.version=p,n["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),n["common.platform"]=(0,C.PlatformToString)(C.platform),n["common.nodePlatform"]=L.platform,n["common.nodeArch"]=P,n["common.product"]=y||"desktop",D&&(n["common.msftInternal"]=D);let o=0;const a=Date.now();Object.defineProperties(n,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),C.isLinuxSnap&&(n["common.snap"]="true");const m=A(g);return m&&(n["common.platformDetail"]=m),n}e.resolveCommonProperties=T;function f(w){const g=L.env.USERDNSDOMAIN;if(!g)return!1;const P=g.toLowerCase();return w.some(k=>P===k)}e.verifyMicrosoftInternalDomain=f}),define(Ce[244],De([1,0,6]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,C.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var d;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(d||(e.TelemetryConfiguration=d={}))}),define(Ce[85],De([1,0,23,19,4,50,60,243,244]),function(me,e,C,L,d,A,T,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class g{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=g;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class k{async publicLog(c,u,v){}async publicLogError(c,u,v){}}e.NullEndpointTelemetryService=k,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,c){return d.Event.debounce(c.onDidChangeConfiguration,(v,S)=>{const l=v?new Set([...v.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:l}},1e3,!0)(v=>{v.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(v.source),configurationKeys:Array.from(v.affectedKeys)})})}e.configurationTelemetry=p;function _(i,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!i.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=_;function D(i,c){return!(c.isBuilt||c.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=D;function y(i){const c=i.getValue(w.TELEMETRY_SETTING_ID),u=i.getValue(w.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(w.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function n(i){const c={},u={},v={};m(i,v);for(let S in v){S=S.length>150?S.substr(S.length-149):S;const l=v[S];typeof l=="number"?u[S]=l:typeof l=="boolean"?u[S]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${l.length}`),c[S]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(c[S]=l)}return{properties:c,measurements:u}}e.validateTelemetryData=n;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(i){if(!i)return"none";const c=(0,T.getRemoteName)(i);return o.has(c)?c:"other"}e.cleanRemoteAuthority=a;function m(i,c,u=0,v){if(i)for(const S of Object.getOwnPropertyNames(i)){const l=i[S],h=v?v+S:S;Array.isArray(l)?c[h]=(0,C.safeStringify)(l):l instanceof Date?c[h]=l.toISOString():(0,L.isObject)(l)?u<2?m(l,c,u+1,h+"."):c[h]=(0,C.safeStringify)(l):c[h]=l}}function b(i,c){const u=i.msftInternalDomains||[],v=c.getValue("telemetry.internalTesting");return(0,f.verifyMicrosoftInternalDomain)(u)||v}e.isInternalTelemetry=b;function I(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=I;function t(i,c){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let u=i;const v=[];for(const E of c)for(;;){const R=E.exec(i);if(!R)break;v.push([R.index,E.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(u="";;){const E=l.exec(i);if(!E)break;const R=v.some(([M,U])=>E.index<U&&M<l.lastIndex);!S.test(E[0])&&!R&&(u+=i.substring(h,E.index)+"<REDACTED: user-file-path>",h=l.lastIndex)}return h<i.length&&(u+=i.substr(h)),u}function r(i){if(!i)return i;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of c)if(u.regex.test(i))return`<REDACTED: ${u.label}>`;return i}function s(i,c){return(0,C.cloneAndChange)(i,u=>{if(u instanceof g||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let v=u.replaceAll("%20"," ");v=t(v,c);for(const S of c)v=v.replace(S,"");return v=r(v),v}})}e.cleanData=s}),define(Ce[245],De([1,0,15,130,25,9,2,8,41,85]),function(me,e,C,L,d,A,T,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,C.compareIgnoreCase)(s.id,i.id)===0}e.areSameExtensions=P;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const c=i.manifest?i.manifest.version:i.version,u=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,c,u)}static parse(i){const c=k.exec(i);return c&&c[1]&&c[2]?new p({id:c[1]},c[2],c[4]||void 0):null}constructor(i,c,u="undefined"){this.version=c,this.targetPlatform=u,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=p;const _=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(s){const i=_.exec(s);return i&&i[1]?[n(i[1]),i[2]]:[n(s),void 0]}e.getIdAndVersion=D;function y(s,i){return`${s}.${i}`}e.getExtensionId=y;function n(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=n;function o(s,i){return n(y(s??d.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=o;function a(s,i){const c=[],u=v=>{for(const S of c)if(S.some(l=>P(i(l),i(v))))return S;return null};for(const v of s){const S=u(v);S?S.push(v):c.push([v])}return c}e.groupByExtension=a;function m(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function b(s){return{id:new g.TelemetryTrustedValue(s.identifier.id),name:new g.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new d.ExtensionIdentifier("pprice.better-merge");function I(s,i){const c=[],u=i.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const v=u.shift();if(v&&c.every(S=>!P(S.identifier,{id:v}))){const S=s.filter(l=>P(l.identifier,{id:v}));S.length===1&&(c.push(S[0]),u.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=I;async function t(s,i){if(!A.isLinux)return!1;let c;try{c=(await s.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await s.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){i.debug("Error while getting the os-release file.",(0,f.getErrorMessage)(v))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,i){const c=await t(s,i),u=(0,L.getTargetPlatform)(c?"alpine":A.platform,w.arch);return i.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=r}),define(Ce[246],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function C(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=C;function L(w){return w?[...w.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function d(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=d;function A(w){return new Map(w??[])}e.deserializeEnvironmentDescriptionMap=A;function T(w){return Array.from(w.entries()).map(g=>[g[0],C(g[1].map),L(g[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=T;function f(w){return new Map(w.map(g=>[g[0],{map:d(g[1]),descriptionMap:A(g[2])}]))}e.deserializeEnvironmentVariableCollections=f}),define(Ce[247],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class C{constructor(d){this._callback=d,this._terminalBufferMap=new Map}dispose(){for(const d of this._terminalBufferMap.values())d.dispose()}startBuffering(d,A,T=5){const f=A(w=>{const g=typeof w=="string"?w:w.data;let P=this._terminalBufferMap.get(d);if(P){P.data.push(g);return}const k=setTimeout(()=>this.flushBuffer(d),T);P={data:[g],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(d),f.dispose()}},this._terminalBufferMap.set(d,P)});return f}stopBuffering(d){this._terminalBufferMap.get(d)?.dispose()}flushBuffer(d){const A=this._terminalBufferMap.get(d);A&&(this._terminalBufferMap.delete(d),this._callback(d,A.data.join("")))}}e.TerminalDataBufferer=C}),define(Ce[248],De([1,0,13,76,56,4,19,2,194,104,42]),function(me,e,C,L,d,A,T,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var k;(function(b){function I(t,r){let s=t.defaults;for(;d.ThemeIcon.isThemeIcon(s);){const i=D.getIcon(s.id);if(!i)return;s=i.defaults}return s}b.getDefinition=I})(k||(e.IconContribution=k={}));var p;(function(b){function I(r){return{weight:r.weight,style:r.style,src:r.src.map(s=>({format:s.format,location:s.location.toString()}))}}b.toJSONObject=I;function t(r){const s=i=>(0,T.isString)(i)?i:void 0;if(r&&Array.isArray(r.src)&&r.src.every(i=>(0,T.isString)(i.format)&&(0,T.isString)(i.location)))return{weight:s(r.weight),style:s(r.style),src:r.src.map(i=>({format:i.format,location:f.URI.parse(i.location)}))}}b.fromJSONObject=t})(p||(e.IconFontDefinition=p={}));class _{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${d.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(I,t,r,s){const i=this.iconsById[I];if(i){if(r&&!i.description){i.description=r,this.iconSchema.properties[I].markdownDescription=`${r} $(${I})`;const v=this.iconReferenceSchema.enum.indexOf(I);v!==-1&&(this.iconReferenceSchema.enumDescriptions[v]=r),this._onDidChange.fire()}return i}const c={id:I,description:r,defaults:t,deprecationMessage:s};this.iconsById[I]=c;const u={$ref:"#/definitions/icons"};return s&&(u.deprecationMessage=s),r&&(u.markdownDescription=`${r}: $(${I})`),this.iconSchema.properties[I]=u,this.iconReferenceSchema.enum.push(I),this.iconReferenceSchema.enumDescriptions.push(r||""),this._onDidChange.fire(),{id:I}}deregisterIcon(I){delete this.iconsById[I],delete this.iconSchema.properties[I];const t=this.iconReferenceSchema.enum.indexOf(I);t!==-1&&(this.iconReferenceSchema.enum.splice(t,1),this.iconReferenceSchema.enumDescriptions.splice(t,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(I=>this.iconsById[I])}getIcon(I){return this.iconsById[I]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(I,t){const r=this.iconFontsById[I];return r||(this.iconFontsById[I]=t,this._onDidChange.fire(),t)}deregisterIconFont(I){delete this.iconFontsById[I]}getIconFont(I){return this.iconFontsById[I]}toString(){const I=(i,c)=>i.id.localeCompare(c.id),t=i=>{for(;d.ThemeIcon.isThemeIcon(i.defaults);)i=this.iconsById[i.defaults.id];return`codicon codicon-${i?i.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.iconsById).map(i=>this.iconsById[i]);for(const i of s.filter(c=>!!c.description).sort(I))r.push(`|<i class="${t(i)}"></i>|${i.id}|${d.ThemeIcon.isThemeIcon(i.defaults)?i.defaults.id:i.id}|${i.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const i of s.filter(c=>!d.ThemeIcon.isThemeIcon(c.defaults)).sort(I))r.push(`|<i class="${t(i)}"></i>|${i.id}|`);return r.join(`
`)}}const D=new _;P.Registry.add(e.Extensions.IconContribution,D);function y(b,I,t,r){return D.registerIcon(b,I,t,r)}e.registerIcon=y;function n(){return D}e.getIconRegistry=n;function o(){const b=(0,L.getCodiconFontCharacters)();for(const I in b){const t="\\"+b[I].toString(16);D.registerIcon(I,{fontCharacter:t})}}o(),e.iconsSchemaId="vscode://schemas/icons";const a=P.Registry.as(g.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,D.getIconSchema());const m=new C.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);D.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.widgetClose=y("widget-close",L.Codicon.close,(0,w.localize)(2,null)),e.gotoPreviousLocation=y("goto-previous-location",L.Codicon.arrowUp,(0,w.localize)(3,null)),e.gotoNextLocation=y("goto-next-location",L.Codicon.arrowDown,(0,w.localize)(4,null)),e.syncing=d.ThemeIcon.modify(L.Codicon.sync,"spin"),e.spinningLoading=d.ThemeIcon.modify(L.Codicon.loading,"spin")}),define(Ce[106],De([1,0,4,50,6,17]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,d.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,d.createDecorator)("sharedTunnelsService");var T;(function(n){n.Http="http",n.Https="https"})(T||(e.TunnelProtocol=T={}));var f;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(f||(e.TunnelPrivacyId=f={}));function w(n){return!!n.forwardPort}e.isTunnelProvider=w;var g;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function P(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(n){return e.LOCALHOST_ADDRESSES.indexOf(n)>=0}e.isLocalhost=k,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(n){return e.ALL_INTERFACES_ADDRESSES.indexOf(n)>=0}e.isAllInterfaces=p;function _(n,o,a,m){if(a===1)return!1;if(a===2&&p(o)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(b?.length===4&&parseInt(b[1])>=18)return!1}return n<1024}e.isPortPrivileged=_;class D{constructor(o,a,m){this.remoteAddress=o,this.localAddress=a,this._dispose=m,this._onDispose=new C.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=D;let y=class{constructor(o,a){this.logService=o,this.configurationService=a,this._onTunnelOpened=new C.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new C.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new C.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const o=this.configurationService.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this._tunnelProvider=o,o?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this._canElevate=o.elevation,this._privacyOptions=o.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const o=[],a=Array.from(this._tunnels.values());for(const m of a){const b=Array.from(m.values());for(const I of b){const t=await I.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this._tunnels.values()){for(const{value:a}of o.values())await a.then(m=>typeof m!="string"?m?.dispose():void 0);o.clear()}this._tunnels.clear()}setEnvironmentTunnel(o,a,m,b,I){this.addTunnelToMap(o,a,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:a,localAddress:m,privacy:b,protocol:I,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,a){(p(o)||k(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const m=this.getTunnelFromMap(o,a);if(m)return++m.refcount,m.value}openTunnel(o,a,m,b,I,t=!1,r,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${m} on local port ${I}.`);const i=this._tunnelProvider??o;if(!i)return;if(a||(a="localhost"),b||(b=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(m)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.retainOrCreateTunnel(i,a,m,b,I,t,r,s);return c?c.then(u=>{if(u){if(typeof u=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(a,m),u}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(a,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.makeTunnel(u);return(u.tunnelRemoteHost!==a||u.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&u.privacy!==r&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(v),v}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const a=this._tunnels.get(o.tunnelRemoteHost);if(a){const m=a.get(o.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,m))}}}}async tryDisposeTunnel(o,a,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${a}.`);const b=m.value.then(async I=>{I&&typeof I!="string"&&(await I.dispose(!0),this._onTunnelClosed.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(a),b}}async closeTunnel(o,a){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${a} `);const m=this._tunnels.get(o);if(m&&m.has(a)){const b=m.get(a);b.refcount=0,await this.tryDisposeTunnel(o,a,b)}}addTunnelToMap(o,a,m){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(a,{refcount:1,value:m})}async removeEmptyOrErrorTunnelFromMap(o,a){const m=this._tunnels.get(o);if(m){const b=m.get(a),I=b?await b.value:void 0;(!I||typeof I=="string")&&m.delete(a),m.size===0&&this._tunnels.delete(o)}}getTunnelFromMap(o,a){const m=[o];k(o)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):p(o)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const b=m.map(I=>this._tunnels.get(I));for(const I of b){const t=I?.get(a);if(t)return t}}canTunnel(o){return!!P(o)}createWithProvider(o,a,m,b,I,t,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${m} on local port ${b}.`);const s=m;this._factoryInProgress.add(s);const i=b===void 0?m:b,c={elevationRequired:I?this.isPortPrivileged(i):!1},u={remoteAddress:{host:a,port:m},localAddressPort:b,privacy:t,public:t?t!==f.Private:void 0,protocol:r},v=o.forwardPort(u,c);return v?(this.addTunnelToMap(a,m,v),v.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),v}};e.AbstractTunnelService=y,e.AbstractTunnelService=y=qe([$e(0,A.ILogService),$e(1,L.IConfigurationService)],y)}),define(Ce[249],De([1,0,6]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,C.createDecorator)("editSessionIdentityService");var L;(function(d){d[d.Complete=100]="Complete",d[d.Partial=50]="Partial",d[d.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(Ce[250],De([1,0,16]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function L(w){return w.scheme!==C.Schemas.file&&w.scheme!==C.Schemas.vscodeRemote}e.isVirtualResource=L;function d(w){if(w.folders.length)return w.folders.every(g=>L(g.uri))?w.folders[0].uri:void 0;if(w.configuration&&L(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=d;function A(w){return d(w)?.scheme}e.getVirtualWorkspaceScheme=A;function T(w){return d(w)?.authority}e.getVirtualWorkspaceAuthority=T;function f(w){return d(w)!==void 0}e.isVirtualWorkspace=f}),define(Ce[51],De([1,0,195,14,75,24,2,6,16]),function(me,e,C,L,d,A,T,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,f.createDecorator)("contextService");function g(i){const c=i;return typeof c?.id=="string"&&T.URI.isUri(c.uri)}e.isSingleFolderWorkspaceIdentifier=g;function P(i){return typeof i?.id=="string"&&!g(i)&&!p(i)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function k(i,c){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.basename)(i)}:c?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const u=i;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}e.toWorkspaceIdentifier=k;function p(i){const c=i;return typeof c?.id=="string"&&T.URI.isUri(c.configPath)}e.isWorkspaceIdentifier=p;function _(i){const c=i;if(c?.uri)return{id:c.id,uri:T.URI.revive(c.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:T.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=_;var D;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(D||(e.WorkbenchState=D={}));function y(i){const c=i;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.isWorkspace=y;function n(i){const c=i;return!!(c&&typeof c=="object"&&T.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.isWorkspaceFolder=n;class o{constructor(c,u,v,S,l){this._id=c,this._transient=v,this._configuration=S,this._ignorePathCasing=l,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=u}update(c){this._id=c.id,this._configuration=c.configuration,this._transient=c.transient,this._ignorePathCasing=c._ignorePathCasing,this.folders=c.folders}get folders(){return this._folders}set folders(c){this._folders=c,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(c){this._configuration=c}getFolder(c){return c&&this._foldersMap.findSubstr(c)||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const c of this.folders)this._foldersMap.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class a{constructor(c,u){this.raw=u,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,A.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=a;function m(i){return new a({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=m,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(i,c){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,c.untitledWorkspacesHome)}e.isUntitledWorkspace=b;function I(i){let c;return T.URI.isUri(i)?c=i:c=i.configuration,c?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=I,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function r(i,c){return!b(i,c)&&!I(i)}e.isSavedWorkspace=r;function s(i){return(typeof i=="string"?(0,L.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Ce[86],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class C{static{this.enableDebugLogging=!1}constructor(d){this.id=d,this._data=new Map,this._idPool=1}add(d){const A=this._idPool++;return this._data.set(A,d),this.logDebugInfo(),A}get(d,A){return this._data.has(d)?this._data.get(d)[A]:void 0}delete(d){this._data.delete(d),this.logDebugInfo()}logDebugInfo(){C.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=C}),define(Ce[52],De([1,0,16,24,6]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(C.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(f=>{const w=this._providerInfo.get(f.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(f,w){w===null?this._providerInfo.delete(f.scheme):this._providerInfo.set(f.scheme,w)}isFreeScheme(f){return!this._providerInfo.has(f)&&!this._systemSchemes.has(f)}getCapabilities(f){return this._providerInfo.get(f)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,d.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[26],De([1,0,6]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,C.createDecorator)("IExtHostInitDataService")}),define(Ce[251],De([1,0,200,17,234,26]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends d.LogService{constructor(w,g,P){const k=P.remote.isRemote?"remoteexthost":w?"workerexthost":"exthost",p=P.remote.isRemote?(0,C.localize)(0,null):w?(0,C.localize)(1,null):(0,C.localize)(2,null);super(g.createLogger(k,{name:p}))}};e.ExtHostLogService=T,e.ExtHostLogService=T=qe([$e(1,L.ILoggerService),$e(2,A.IExtHostInitDataService)],T)}),define(Ce[252],De([1,0,13]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(T,f,w){this._deferredPromises=new Map,this._id=T,this._shared=f,this._storage=w,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(g=>(this._value=g,this)),this._storageListener=this._storage.onDidChangeStorage(g=>{g.shared===this._shared&&g.key===this._id&&(this._value=g.value)}),this._scheduler=new C.RunOnceScheduler(()=>{const g=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const P of g.values())P.complete()}catch(P){for(const k of g.values())k.error(P)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,f){let w=this._value[T];return typeof w>"u"&&(w=f),w}update(T,f){this._value[T]=f;const w=this._deferredPromises.get(T);if(w!==void 0)return w.p;const g=new C.DeferredPromise;return this._deferredPromises.set(T,g),this._scheduler.isScheduled()||this._scheduler.schedule(),g.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class d extends L{setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}constructor(T,f){super(T.identifier.value,!0,f),this._extension=T}}e.ExtensionGlobalMemento=d}),define(Ce[253],De([1,0,4,2]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class d{constructor(T){this._notebooksAndEditors=T,this._onDidSaveNotebookDocument=new C.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new C.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(T,f,w,g){const k=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(T)).acceptModelChanged(f.value,w,g);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(T,f){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(T)).acceptDirty(f)}$acceptModelSaved(T){const f=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(T));this._onDidSaveNotebookDocument.fire(f.apiNotebook)}}e.ExtHostNotebookDocuments=d}),define(Ce[20],De([1,0,6]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,C.createDecorator)("IExtHostRpcService");class L{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=L}),define(Ce[254],De([1,0,25,4]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class d{#e;constructor(T,f){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=C.ExtensionIdentifier.toKey(T.identifier),this.#e=f,this.#e.onDidChangePassword(w=>{w.extensionId===this._id&&this._onDidChange.fire({key:w.key})})}get(T){return this.#e.get(this._id,T)}store(T,f){return this.#e.store(this._id,T,f)}delete(T){return this.#e.delete(this._id,T)}}e.ExtensionSecrets=d}),define(Ce[62],De([1,0,6]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,C.createDecorator)("IURITransformerService");class L{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=L}),define(Ce[255],De([1,0,21]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(w){let g=this.buffers.indexOf(w);return g<0&&(g=this.buffers.length,this.buffers.push(w)),g}}function d(f,w){if(w.serializeBuffersForPostMessage){const g=new L,k=JSON.stringify(f,(_,D)=>{if(D instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(D)};if(ArrayBuffer.isView(D)){const y=A(D);if(y)return{$$vscode_array_buffer_reference$$:!0,index:g.add(D.buffer),view:{type:y,byteLength:D.byteLength,byteOffset:D.byteOffset}}}return D}),p=g.buffers.map(_=>{const D=new Uint8Array(_);return C.VSBuffer.wrap(D)});return{message:k,buffers:p}}else return{message:JSON.stringify(f),buffers:[]}}e.serializeWebviewMessage=d;function A(f){switch(f.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(f,w){const g=w.map(p=>{const _=new ArrayBuffer(p.byteLength);return new Uint8Array(_).set(p.buffer),_}),P=w.length?(p,_)=>{if(_&&typeof _=="object"&&_.$$vscode_array_buffer_reference$$){const D=_,{index:y}=D,n=g[y];if(D.view)switch(D.view.type){case 1:return new Int8Array(n,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(n,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(n,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(n,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(n,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(n,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(n,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(n,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(n,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(n,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(n,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return n}return _}:void 0;return{message:JSON.parse(f,P),arrayBuffers:g}}e.deserializeWebviewMessage=T}),define(Ce[256],De([1,0,257,363,364,57,2,365]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;const w=!1;function g(a,m,b,I,t,r){const s=r.environment.useHostProxy,i=typeof s=="boolean"?s:!r.remote.isRemote,c={resolveProxy:S=>a.resolveProxy(S),lookupProxyAuthorization:y.bind(void 0,I,t,m,{},r.remote.isRemote),getProxyURL:()=>m.getConfiguration("http").get("proxy"),getProxySupport:()=>m.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>k(m),getSystemCertificatesV2:()=>p(m),log:(S,l,...h)=>{switch(S){case f.LogLevel.Trace:I.trace(l,...h);break;case f.LogLevel.Debug:I.debug(l,...h);break;case f.LogLevel.Info:I.info(l,...h);break;case f.LogLevel.Warning:I.warn(l,...h);break;case f.LogLevel.Error:I.error(l,...h);break;case f.LogLevel.Critical:I.error(l,...h);break;case f.LogLevel.Off:break;default:E(S,l,h);break}function E(R,M,...U){I.error("Unknown log level",R),I.error(M,...U)}},getLogLevel:()=>I.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:i,addCertificates:[],env:process.env},u=(0,f.createProxyResolver)(c),v=P(c,u);return D(b,v)}e.connectProxyResolver=g;function P(a,m){return{http:Object.assign(C,(0,f.createHttpPatch)(a,C,m)),https:Object.assign(L,(0,f.createHttpPatch)(a,L,m)),net:Object.assign(A,(0,f.createNetPatch)(a,A)),tls:Object.assign(d,(0,f.createTlsPatch)(a,d))}}function k(a){const m=a.getConfiguration("http");return!m.get("experimental.systemCertificatesV2",w)&&!!m.get("systemCertificates")}function p(a){const m=a.getConfiguration("http");return!!m.get("experimental.systemCertificatesV2",w)&&!!m.get("systemCertificates")}const _=new Map;function D(a,m){return a.getExtensionPathIndex().then(b=>{const I=globalThis._VSCODE_NODE_MODULES.module,t=I._load;I._load=function(s,i,c){if(s==="net")return m.net;if(s==="tls")return m.tls;if(s!=="http"&&s!=="https")return t.apply(this,arguments);const u=b.findSubstr(T.URI.file(i.filename));let v=_.get(u);if(v||_.set(u,v={}),!v[s]){const S=m[s];v[s]={...S}}return v[s]}})}async function y(a,m,b,I,t,r,s,i){const c=I[r];s&&(I[r]=s),a.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${r}`,`proxyAuthenticate:${s}`,`proxyAuthenticateCache:${c}`);const u=s||c,v=Array.isArray(u)?u:typeof u=="string"?[u]:[];if(o(m,v,t),v.some(S=>/^(Negotiate|Kerberos)( |$)/i.test(S))&&!i.kerberosRequested)try{i.kerberosRequested=!0;const S=await new Promise((M,U)=>{me(["kerberos"],M,U)}),l=new URL(r),h=b.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${l.hostname}`:`HTTP@${l.hostname}`);return a.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${r}`,`spn:${h}`),"Negotiate "+await(await S.initializeClient(h)).step("")}catch(S){a.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",S)}}let n=!1;function o(a,m,b){n||!m.length||(n=!0,a.$publicLog2("proxyAuthenticationRequest",{authenticationType:m.map(I=>I.split(" ")[0]).join(","),extensionHostType:b?"remote":"local"}))}}),define(Ce[258],De([1,0,127]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function L(A){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:A,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function d(A){return new C.URITransformer(L(A))}e.createURITransformer=d}),define(Ce[137],De([1,0,210,19,2,3,6,42,30,16,45,173,40]),function(me,e,C,L,d,A,T,f,w,g,P,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.preventEditorClose=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var _;(function(ae){ae[ae.PROGRAMMATIC=1]="PROGRAMMATIC",ae[ae.USER=2]="USER",ae[ae.EDIT=3]="EDIT",ae[ae.NAVIGATION=4]="NAVIGATION",ae[ae.JUMP=5]="JUMP"})(_||(e.EditorPaneSelectionChangeReason=_={}));var D;(function(ae){ae[ae.IDENTICAL=1]="IDENTICAL",ae[ae.SIMILAR=2]="SIMILAR",ae[ae.DIFFERENT=3]="DIFFERENT"})(D||(e.EditorPaneSelectionCompareResult=D={}));function y(ae){const ne=ae;return!!ne&&typeof ne.getSelection=="function"&&!!ne.onDidChangeSelection}e.isEditorPaneWithSelection=y;function n(ae,ne,J){for(const N of J.visibleEditorPanes)if(N.group.id===ne&&ae.matches(N.input))return N.getViewState()}e.findViewStateForEditor=n;function o(ae){if(u(ae))return!1;const ne=ae;return d.URI.isUri(ne?.resource)}e.isResourceEditorInput=o;function a(ae){if(u(ae))return!1;const ne=ae;return ne?.original!==void 0&&ne.modified!==void 0}e.isResourceDiffEditorInput=a;function m(ae){if(u(ae)||a(ae))return!1;const ne=ae;return ne?.primary!==void 0&&ne.secondary!==void 0}e.isResourceSideBySideEditorInput=m;function b(ae){if(u(ae))return!1;const ne=ae;return ne?ne.resource===void 0||ne.resource.scheme===g.Schemas.untitled||ne.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=b;function I(ae){if(u(ae))return!1;const ne=ae;return d.URI.isUri(ne?.base?.resource)&&d.URI.isUri(ne?.input1?.resource)&&d.URI.isUri(ne?.input2?.resource)&&d.URI.isUri(ne?.result?.resource)}e.isResourceMergeEditorInput=I;var t;(function(ae){ae[ae.SHORT=0]="SHORT",ae[ae.MEDIUM=1]="MEDIUM",ae[ae.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var r;(function(ae){ae[ae.EXPLICIT=1]="EXPLICIT",ae[ae.AUTO=2]="AUTO",ae[ae.FOCUS_CHANGE=3]="FOCUS_CHANGE",ae[ae.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class s{constructor(){this.mapIdToSaveSource=new Map}registerSource(ne,J){let N=this.mapIdToSaveSource.get(ne);return N||(N={source:ne,label:J},this.mapIdToSaveSource.set(ne,N)),N.source}getSourceLabel(ne){return this.mapIdToSaveSource.get(ne)?.label??ne}}e.SaveSourceRegistry=new s;var i;(function(ae){ae[ae.None=0]="None",ae[ae.Readonly=2]="Readonly",ae[ae.Untitled=4]="Untitled",ae[ae.Singleton=8]="Singleton",ae[ae.RequiresTrust=16]="RequiresTrust",ae[ae.CanSplitInGroup=32]="CanSplitInGroup",ae[ae.ForceDescription=64]="ForceDescription",ae[ae.CanDropIntoEditor=128]="CanDropIntoEditor",ae[ae.MultipleEditors=256]="MultipleEditors",ae[ae.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class c extends A.Disposable{}e.AbstractEditorInput=c;function u(ae){return ae instanceof c}e.isEditorInput=u;function v(ae){const ne=ae;return d.URI.isUri(ne?.preferredResource)}function S(ae){const ne=ae;return u(ne?.primary)&&u(ne?.secondary)}e.isSideBySideEditorInput=S;function l(ae){const ne=ae;return u(ne?.modified)&&u(ne?.original)}e.isDiffEditorInput=l;function h(ae,ne,J,N,W){return Ee(N,[(0,k.toAction)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const he={...J,limits:{size:Number.MAX_VALUE}};ae.openEditor(ne,he)}}),(0,k.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>W.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}e.createTooLargeFileError=h;function E(ae){return u(ae?.editor)}e.isEditorInputWithOptions=E;function R(ae){const ne=ae;return E(ae)&&ne?.group!==void 0}e.isEditorInputWithOptionsAndGroup=R;function M(ae){const ne=ae;return typeof ne?.groupId=="number"&&u(ne.editor)}e.isEditorIdentifier=M;var U;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.REPLACE=1]="REPLACE",ae[ae.MOVE=2]="MOVE",ae[ae.UNPIN=3]="UNPIN"})(U||(e.EditorCloseContext=U={}));var F;(function(ae){ae[ae.GROUP_ACTIVE=0]="GROUP_ACTIVE",ae[ae.GROUP_INDEX=1]="GROUP_INDEX",ae[ae.GROUP_LOCKED=2]="GROUP_LOCKED",ae[ae.EDITOR_OPEN=3]="EDITOR_OPEN",ae[ae.EDITOR_CLOSE=4]="EDITOR_CLOSE",ae[ae.EDITOR_MOVE=5]="EDITOR_MOVE",ae[ae.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ae[ae.EDITOR_LABEL=7]="EDITOR_LABEL",ae[ae.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ae[ae.EDITOR_PIN=9]="EDITOR_PIN",ae[ae.EDITOR_STICKY=10]="EDITOR_STICKY",ae[ae.EDITOR_DIRTY=11]="EDITOR_DIRTY",ae[ae.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var x;(function(ae){ae[ae.PRIMARY=1]="PRIMARY",ae[ae.SECONDARY=2]="SECONDARY",ae[ae.BOTH=3]="BOTH",ae[ae.ANY=4]="ANY"})(x||(e.SideBySideEditor=x={}));class ${getOriginalUri(ne,J){if(!ne)return;if(I(ne))return e.EditorResourceAccessor.getOriginalUri(ne.result,J);if(J?.supportSideBySide){const{primary:W,secondary:he}=this.getSideEditors(ne);if(W&&he){if(J?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(W,{filterByScheme:J.filterByScheme}),secondary:this.getOriginalUri(he,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===x.ANY)return this.getOriginalUri(W,{filterByScheme:J.filterByScheme})??this.getOriginalUri(he,{filterByScheme:J.filterByScheme});ne=J.supportSideBySide===x.PRIMARY?W:he}}if(a(ne)||m(ne)||I(ne))return;const N=v(ne)?ne.preferredResource:ne.resource;return!N||!J||!J.filterByScheme?N:this.filterUri(N,J.filterByScheme)}getSideEditors(ne){return S(ne)||m(ne)?{primary:ne.primary,secondary:ne.secondary}:l(ne)||a(ne)?{primary:ne.modified,secondary:ne.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ne,J){if(!ne)return;if(I(ne))return e.EditorResourceAccessor.getCanonicalUri(ne.result,J);if(J?.supportSideBySide){const{primary:W,secondary:he}=this.getSideEditors(ne);if(W&&he){if(J?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(W,{filterByScheme:J.filterByScheme}),secondary:this.getCanonicalUri(he,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===x.ANY)return this.getCanonicalUri(W,{filterByScheme:J.filterByScheme})??this.getCanonicalUri(he,{filterByScheme:J.filterByScheme});ne=J.supportSideBySide===x.PRIMARY?W:he}}if(a(ne)||m(ne)||I(ne))return;const N=ne.resource;return!N||!J||!J.filterByScheme?N:this.filterUri(N,J.filterByScheme)}filterUri(ne,J){if(Array.isArray(J)){if(J.some(N=>ne.scheme===N))return ne}else if(J===ne.scheme)return ne}}var O;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.KEYBOARD=1]="KEYBOARD",ae[ae.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function K(ae,ne,J,N){if(!ae.isSticky(ne))return!1;switch(N.preventPinnedEditorClose){case"keyboardAndMouse":return J===O.MOUSE||J===O.KEYBOARD;case"mouse":return J===O.MOUSE;case"keyboard":return J===O.KEYBOARD}return!1}e.preventEditorClose=K,e.EditorResourceAccessor=new $;var q;(function(ae){ae[ae.LEFT=0]="LEFT",ae[ae.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class fe{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ne){const J=this.instantiationService=ne.get(T.IInstantiationService);for(const[N,W]of this.editorSerializerConstructors)this.createEditorSerializer(N,W,J);this.editorSerializerConstructors.clear()}createEditorSerializer(ne,J,N){const W=N.createInstance(J);this.editorSerializerInstances.set(ne,W)}registerFileEditorFactory(ne){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ne}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ne,J){if(this.editorSerializerConstructors.has(ne)||this.editorSerializerInstances.has(ne))throw new Error(`A editor serializer with type ID '${ne}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ne,J,this.instantiationService):this.editorSerializerConstructors.set(ne,J),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(ne),this.editorSerializerInstances.delete(ne)})}getEditorSerializer(ne){return this.editorSerializerInstances.get(typeof ne=="string"?ne:ne.typeId)}}f.Registry.add(e.EditorExtensions.EditorFactory,new fe);async function se(ae,ne,J){return!ae||!ae.length?[]:await Promise.all(ae.map(async N=>{const W=d.URI.revive(N.fileUri);if(!W){J.info("Cannot resolve the path because it is not valid.",N);return}if(!await ne.canHandleResource(W)){J.info("Cannot resolve the path because it cannot be handled",N);return}let Se=N.exists,be=N.type;if(typeof Se!="boolean"||typeof be!="number")try{be=(await ne.stat(W)).isDirectory?w.FileType.Directory:w.FileType.Unknown,Se=!0}catch(ye){J.error(ye),Se=!1}if(!Se&&N.openOnlyIfExists){J.info("Cannot resolve the path because it does not exist",N);return}if(be===w.FileType.Directory){J.info("Cannot resolve the path because it is a directory",N);return}const we={...N.options,pinned:!0};return Se?{resource:W,options:we}:{resource:W,options:we,forceUntitled:!0}}))}e.pathsToEditors=se;var ie;(function(ae){ae[ae.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ae[ae.SEQUENTIAL=1]="SEQUENTIAL"})(ie||(e.EditorsOrder=ie={}));function H(ae){const ne=ae;if(!ne)return!1;const J=ne;if(J.modified)return H(J.modified);const N=ne;return!!(N.contributionsState&&N.viewState&&Array.isArray(N.cursorState))}e.isTextEditorViewState=H;function re(ae){return(0,P.isErrorWithActions)(ae)}e.isEditorOpenError=re;function Ee(ae,ne,J){const N=(0,P.createErrorWithActions)(ae,ne);return N.forceMessage=J?.forceMessage,N.forceSeverity=J?.forceSeverity,N.allowDialog=J?.allowDialog,N}e.createEditorOpenError=Ee}),define(Ce[259],De([1,0,4,211,6,3,28,42,18,69,23,76,248]),function(me,e,C,L,d,A,T,f,w,g,P,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,p.registerIcon)("default-view-icon",k.Codicon.window,(0,L.localize)(0,null));var _;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(_||(e.Extensions=_={}));var D;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(D||(e.ViewContainerLocation=D={})),e.ViewContainerLocations=[0,1,2];function y(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=y;class n extends A.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new C.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new C.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,w.flatten)([...this.viewContainers.values()])}registerViewContainer(i,c,u){const v=this.get(i.id);if(v)return v;const S=i;return S.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,T.getOrSet)(this.viewContainers,c,[]).push(S),u?.isDefault&&this.defaultViewContainers.push(S),this._onDidRegister.fire({viewContainer:S,viewContainerLocation:c}),S}deregisterViewContainer(i){for(const c of this.viewContainers.keys()){const u=this.viewContainers.get(c),v=u?.indexOf(i);if(v!==-1){u?.splice(v,1),u.length===0&&this.viewContainers.delete(c),this._onDidDeregister.fire({viewContainer:i,viewContainerLocation:c});return}}}get(i){return this.all.filter(c=>c.id===i)[0]}getViewContainers(i){return[...this.viewContainers.get(i)||[]]}getViewContainerLocation(i){return[...this.viewContainers.keys()].filter(c=>this.getViewContainers(c).filter(u=>u?.id===i.id).length>0)[0]}getDefaultViewContainer(i){return this.defaultViewContainers.find(c=>this.getViewContainerLocation(c)===i)}}f.Registry.add(_.ViewContainersRegistry,new n);var o;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(o||(e.ViewContentGroups=o={}));function a(s,i){const c=s.group??o.More,u=i.group??o.More;return c!==u?c.localeCompare(u):(s.order??5)-(i.order??5)}class m extends A.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new C.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new C.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new C.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new C.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new g.SetMap}registerViews(i,c){this.registerViews2([{views:i,viewContainer:c}])}registerViews2(i){i.forEach(({views:c,viewContainer:u})=>this.addViews(c,u)),this._onViewsRegistered.fire(i)}deregisterViews(i,c){const u=this.removeViews(i,c);u.length&&this._onViewsDeregistered.fire({views:u,viewContainer:c})}moveViews(i,c){for(const u of this._views.keys())if(u!==c){const v=this.removeViews(i,u);v.length&&(this.addViews(v,c),this._onDidChangeContainer.fire({views:v,from:u,to:c}))}}getViews(i){return this._views.get(i)||[]}getView(i){for(const c of this._viewContainers){const u=(this._views.get(c)||[]).filter(v=>v.id===i)[0];if(u)return u}return null}getViewContainer(i){for(const c of this._viewContainers)if((this._views.get(c)||[]).filter(v=>v.id===i)[0])return c;return null}registerViewWelcomeContent(i,c){return this._viewWelcomeContents.add(i,c),this._onDidChangeViewWelcomeContent.fire(i),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(i,c),this._onDidChangeViewWelcomeContent.fire(i)})}registerViewWelcomeContent2(i,c){const u=new Map;for(const[v,S]of c)this._viewWelcomeContents.add(i,S),u.set(v,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(i,S),this._onDidChangeViewWelcomeContent.fire(i)}));return this._onDidChangeViewWelcomeContent.fire(i),u}getViewWelcomeContent(i){const c=[];return this._viewWelcomeContents.forEach(i,u=>c.push(u)),c.sort(a)}addViews(i,c){let u=this._views.get(c);u||(u=[],this._views.set(c,u),this._viewContainers.push(c));for(const v of i){if(this.getView(v.id)!==null)throw new Error((0,L.localize)(1,null,v.id));u.push(v)}}removeViews(i,c){const u=this._views.get(c);if(!u)return[];const v=[],S=[];for(const l of u)i.includes(l)?v.push(l):S.push(l);return v.length&&(S.length?this._views.set(c,S):(this._views.delete(c),this._viewContainers.splice(this._viewContainers.indexOf(c),1))),v}}f.Registry.add(_.ViewsRegistry,new m),e.IViewsService=(0,d.createDecorator)("viewsService"),e.IViewDescriptorService=(0,d.createDecorator)("viewDescriptorService");var b;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(b||(e.ViewVisibilityState=b={}));var I;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(I||(e.TreeItemCollapsibleState=I={}));class t{constructor(i,c){this.resolved=!1,this._hasResolve=!1,(0,P.mixin)(this,i),this._hasResolve=!!c,this.resolve=async u=>{if(c&&!this.resolved){const v=await c(u);v&&(this.tooltip=this.tooltip??v.tooltip,this.command=this.command??v.command)}u.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class r extends Error{constructor(i){super((0,L.localize)(2,null,i)),this.name="NoTreeViewError"}static is(i){return i.name==="NoTreeViewError"}}e.NoTreeViewError=r}),define(Ce[138],De([1,0,4,13,212]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new C.Emitter,this._onExit=new C.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(f){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=f}onEvent(f){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=f}onRequest(f){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=f}sendResponse(f){f.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${f.command}`)):this.internalSend("response",f)}sendRequest(f,w,g,P){const k={command:f};if(w&&Object.keys(w).length>0&&(k.arguments=w),this.internalSend("request",k),typeof P=="number"){const p=setTimeout(()=>{clearTimeout(p);const _=this.pendingRequests.get(k.seq);if(_){this.pendingRequests.delete(k.seq);const D={type:"response",seq:0,request_seq:k.seq,success:!1,command:f,message:(0,d.localize)(0,null,P,f)};_(D)}},P)}return g&&this.pendingRequests.set(k.seq,g),k.seq}acceptMessage(f){this.messageCallback?this.messageCallback(f):(this.queue.push(f),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(f,w){return f.type!=="event"||w.type!=="event"}async processQueue(){let f;for(;this.queue.length;){if((!f||this.needsTaskBoundaryBetween(this.queue[0],f))&&await(0,L.timeout)(0),f=this.queue.shift(),!f)return;switch(f.type){case"event":this.eventCallback?.(f);break;case"request":this.requestCallback?.(f);break;case"response":{const w=f,g=this.pendingRequests.get(w.request_seq);g&&(this.pendingRequests.delete(w.request_seq),g(w));break}}}}internalSend(f,w){w.type=f,w.seq=this.sequence++,this.sendMessage(w)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const f=new Map;this.pendingRequests.forEach((w,g)=>f.set(g,w)),await(0,L.timeout)(500),f.forEach((w,g)=>{w({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(g)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(Ce[260],De([1,0,213,47,6]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new L.RawContextKey("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new L.RawContextKey("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new L.RawContextKey("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new L.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:C.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new L.RawContextKey("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new L.RawContextKey("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new L.RawContextKey("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new L.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new L.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new L.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new L.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new L.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new L.RawContextKey("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new L.RawContextKey("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new L.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new L.RawContextKey("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new L.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new L.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new L.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new L.RawContextKey("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new L.RawContextKey("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new L.RawContextKey("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new L.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new L.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new L.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:C.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new L.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new L.RawContextKey("stepBackSupported",!1,{type:"boolean",description:C.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new L.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:C.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new L.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new L.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new L.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new L.RawContextKey("breakpointsExist",!1,{type:"boolean",description:C.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new L.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:C.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new L.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new L.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new L.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new L.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new L.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new L.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new L.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new L.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new L.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new L.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new L.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:C.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new L.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new L.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:C.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new L.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:C.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new L.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new L.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new L.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new L.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(50,null)});const A=p=>C.localize(51,null,p);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(52,null)};var T;(function(p){p[p.Inactive=0]="Inactive",p[p.Initializing=1]="Initializing",p[p.Stopped=2]="Stopped",p[p.Running=3]="Running"})(T||(e.State=T={}));function f(p){switch(p){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=f;var w;(function(p){p[p.Valid=0]="Valid",p[p.Unreadable=1]="Unreadable",p[p.Error=2]="Error"})(w||(e.MemoryRangeType=w={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var g;(function(p){p[p.Initial=1]="Initial",p[p.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var P;(function(p){p.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.IDebugService=(0,d.createDecorator)("debugService");var k;(function(p){p[p.CONDITION=0]="CONDITION",p[p.HIT_COUNT=1]="HIT_COUNT",p[p.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Ce[261],De([1,0,15,2,14,23,16,34,22,18]),function(me,e,C,L,d,A,T,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function k(v,S,l){return v.replace(P,function(h,E){return S&&E.length>0&&E[0]!=="_"?h:l&&l.hasOwnProperty(E)?l[E]:h})}e.formatPII=k;function p(v){const S={};for(const l of Object.keys(v))l.startsWith("!")||(S[l]=v[l]);return S}e.filterExceptionsFromTelemetry=p;function _(v){return v.configuration.request==="attach"&&!D(v)&&(!v.parentSession||_(v.parentSession))}e.isSessionAttach=_;function D(v){let S=v.configuration.type;if(S)return S==="vslsShare"&&(S=v.configuration.adapterProxy.configuration.type),(0,C.equalsIgnoreCase)(S,"extensionhost")||(0,C.equalsIgnoreCase)(S,"pwa-extensionhost")?v:v.parentSession?D(v.parentSession):void 0}e.getExtensionHostDebugSession=D;function y(v){return v.type&&(v.label||v.program||v.runtime)}e.isDebuggerMainContribution=y;function n(v,S,l){let h,E=0;const R=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let M=null;for(;M=R.exec(v);){const U=M.index+1,F=U+M[0].length;if(U<=S&&F>=l){h=M[0],E=U;break}}if(h){const U=/\w+/g;let F=null;for(;(F=U.exec(h))&&!(F.index+1+E+F[0].length>=l););F&&(h=h.substring(0,U.lastIndex))}return h?{start:E,end:E+h.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=n;async function o(v,S,l,h){if(v.evaluatableExpressionProvider.has(S)){const E=v.evaluatableExpressionProvider.ordered(S),R=(0,g.coalesce)(await Promise.all(E.map(async M=>{try{return await M.provideEvaluatableExpression(S,l,h??w.CancellationToken.None)}catch{return}})));if(R.length>0){let M=R[0].expression;const U=R[0].range;return M||(M=S.getLineContent(l.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:M}}}else{const E=S.getLineContent(l.lineNumber),{start:R,end:M}=n(E,l.column,l.column),U=E.substring(R-1,M);return{matchingExpression:U,range:new f.Range(l.lineNumber,R,l.lineNumber,R+U.length)}}return null}e.getEvaluatableExpressionAtPosition=o;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(v){return!!(v&&v.match(a))}e.isUri=m;function b(v){if(typeof v.path=="string"&&!(typeof v.sourceReference=="number"&&v.sourceReference>0)){if(m(v.path))return L.URI.parse(v.path);if((0,d.isAbsolute)(v.path))return L.URI.file(v.path)}return v.path}function I(v){if(typeof v.path=="object"){const S=L.URI.revive(v.path);if(S)return S.scheme===T.Schemas.file?S.fsPath:S.toString()}return v.path}function t(v,S){const l=S?b:I,h=(0,A.deepClone)(v);return s(h,(E,R)=>{E&&R&&(R.path=l(R))}),h}e.convertToDAPaths=t;function r(v,S){const l=S?b:I,h=(0,A.deepClone)(v);return s(h,(E,R)=>{!E&&R&&(R.path=l(R))}),h}e.convertToVSCPaths=r;function s(v,S){switch(v.type){case"event":{const l=v;switch(l.event){case"output":S(!1,l.body.source);break;case"loadedSource":S(!1,l.body.source);break;case"breakpoint":S(!1,l.body.breakpoint.source);break;default:break}break}case"request":{const l=v;switch(l.command){case"setBreakpoints":S(!0,l.arguments.source);break;case"breakpointLocations":S(!0,l.arguments.source);break;case"source":S(!0,l.arguments.source);break;case"gotoTargets":S(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(h=>S(!1,h));break;default:break}break}case"response":{const l=v;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(h=>S(!1,h.source));break;case"loadedSources":l.body.sources.forEach(h=>S(!1,h));break;case"scopes":l.body.scopes.forEach(h=>S(!1,h.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(h=>S(!1,h.source));break;case"setBreakpoints":l.body.breakpoints.forEach(h=>S(!1,h.source));break;case"disassemble":l.body?.instructions.forEach(E=>S(!1,E.location));break;default:break}break}}}function i(v){return v.filter(S=>!S.presentation?.hidden).sort((S,l)=>S.presentation?l.presentation?S.presentation.group?l.presentation.group?S.presentation.group!==l.presentation.group?S.presentation.group.localeCompare(l.presentation.group):c(S.presentation.order,l.presentation.order):-1:l.presentation.group?1:c(S.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=i;function c(v,S){return typeof v!="number"?typeof S!="number"?0:1:typeof S!="number"?-1:v-S}async function u(v,S){const l=v.getValue("debug.saveBeforeStart",{overrideIdentifier:S.activeTextEditorLanguageId});if(l!=="none"&&(await S.saveAll(),l==="allEditorsInActiveGroup")){const h=S.activeEditorPane;h&&h.input.resource?.scheme===T.Schemas.untitled&&await S.save({editor:h.input,groupId:h.group.id})}await v.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(Ce[262],De([1,0,46,57,23,14,9,15,29,214,138]),function(me,e,C,L,d,A,T,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends P.AbstractDebugAdapter{static{this.TWO_CRLF=`\r
\r
`}static{this.HEADER_LINESEPARATOR=/\r?\n/}static{this.HEADER_FIELDSEPARATOR=/: */}constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(o,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,o.on("data",m=>this.handleData(m))}sendMessage(o){if(this.outputStream){const a=JSON.stringify(o);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${k.TWO_CRLF}${a}`,"utf8")}}handleData(o){for(this.rawData=Buffer.concat([this.rawData,o]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(m){this._onError.fire(new Error((m.message||m)+`
`+a))}continue}}else{const a=this.rawData.indexOf(k.TWO_CRLF);if(a!==-1){const b=this.rawData.toString("utf8",0,a).split(k.HEADER_LINESEPARATOR);for(const I of b){const t=I.split(k.HEADER_FIELDSEPARATOR);t[0]==="Content-Length"&&(this.contentLength=Number(t[1]))}this.rawData=this.rawData.slice(a+k.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=k;class p extends k{startSession(){return new Promise((o,a)=>{let m=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),o(),m=!0}),this.socket.on("close",()=>{m?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",b=>{m?this._onError.fire(b):a(b)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class _ extends p{constructor(o){super(),this.adapterServer=o}createConnection(o){return L.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",o)}}e.SocketDebugAdapter=_;class D extends p{constructor(o){super(),this.adapterServer=o}createConnection(o){return L.createConnection(this.adapterServer.path,o)}}e.NamedPipeDebugAdapter=D;class y extends k{constructor(o,a){super(),this.adapterExecutable=o,this.debugType=a}async startSession(){const o=this.adapterExecutable.command,a=this.adapterExecutable.args,m=this.adapterExecutable.options||{};try{if(o)if(A.isAbsolute(o)){if(!await w.Promises.exists(o))throw new Error(g.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(g.localize(1,null,this.debugType));let b=process.env;if(m.env&&Object.keys(m.env).length>0&&(b=d.mixin(d.deepClone(process.env),m.env)),o==="node")if(Array.isArray(a)&&a.length>0){const I=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:b,execArgv:I?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};m.cwd&&(t.cwd=m.cwd);const r=C.fork(a[0],a.slice(1),t);if(!r.pid)throw new Error(g.localize(2,null,a[0]));this.serverProcess=r}else throw new Error(g.localize(3,null));else{const I={env:b};m.cwd&&(I.cwd=m.cwd),this.serverProcess=C.spawn(o,a,I)}this.serverProcess.on("error",I=>{this._onError.fire(I)}),this.serverProcess.on("exit",(I,t)=>{this._onExit.fire(I)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",I=>{this._onError.fire(I)}),this.serverProcess.stdin.on("error",I=>{this._onError.fire(I)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(b){this._onError.fire(b)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),T.isWindows?new Promise((o,a)=>{const m=C.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(b,I,t){if(b)return a(b)});m.on("exit",o),m.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(o,a){if(!o)return;const m=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?m.runtime=A.join(a,o.runtime):m.runtime=o.runtime),o.runtimeArgs&&(m.runtimeArgs=o.runtimeArgs),o.program&&(A.isAbsolute(o.program)?m.program=o.program:m.program=A.join(a,o.program)),o.args&&(m.args=o.args);const b=o;return b.win&&(m.win=y.extract(b.win,a)),b.winx86&&(m.winx86=y.extract(b.winx86,a)),b.windows&&(m.windows=y.extract(b.windows,a)),b.osx&&(m.osx=y.extract(b.osx,a)),b.linux&&(m.linux=y.extract(b.linux,a)),m}static platformAdapterExecutable(o,a){let m=Object.create(null);a=a.toLowerCase();for(const i of o)if(i.contributes){const c=i.contributes.debuggers;c&&c.length>0&&c.filter(u=>typeof u.type=="string"&&f.equalsIgnoreCase(u.type,a)).forEach(u=>{const v=y.extract(u,i.extensionLocation.fsPath);m=d.mixin(m,v,i.isBuiltin)})}let b;T.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?b=m.winx86||m.win||m.windows:T.isWindows?b=m.win||m.windows:T.isMacintosh?b=m.osx:T.isLinux&&(b=m.linux),b=b||m;const I=b.program||m.program,t=b.args||m.args,r=b.runtime||m.runtime,s=b.runtimeArgs||m.runtimeArgs;if(r)return{type:"executable",command:r,args:(s||[]).concat(typeof I=="string"?[I]:[]).concat(t||[])};if(I)return{type:"executable",command:I,args:t||[]}}}e.ExecutableDebugAdapter=y}),define(Ce[263],De([1,0,46,32,9]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(g,P){return new Promise((k,p)=>{let _="";const D=C.spawn(g,P);D.pid&&D.stdout.on("data",y=>{_+=y.toString()}),D.on("error",y=>{p(y)}),D.on("close",y=>{k(_)})})}async function T(g){if(g)if(d.isWindows){const P=await new Promise((k,p)=>{me(["@vscode/windows-process-tree"],k,p)});return new Promise(k=>{P.getProcessTree(g,p=>{k(!!p&&p.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(g)]).then(P=>{const k=P.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},P=>!0);return Promise.resolve(!0)}e.hasChildProcesses=T;var f;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(f||(f={}));function w(g,P,k,p,_){g=g.trim().toLowerCase();let D;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?D=1:g.indexOf("cmd.exe")>=0?D=0:g.indexOf("bash")>=0?D=2:d.isWindows?D=0:D=2;let y,n=" ";switch(D){case 1:if(y=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),p){const o=(0,L.getDriveLetter)(p);o&&(n+=`${o}:; `),n+=`cd ${y(p)}; `}if(_)for(const o in _){const a=_[o];a===null?n+=`Remove-Item env:${o}; `:n+=`\${env:${o}}='${a}'; `}if(P.length>0){const o=P.shift(),a=k?o:y(o);n+=a[0]==="'"?`& ${a} `:`${a} `;for(const m of P)n+=m==="<"||m===">"||k?m:y(m),n+=" "}break;case 0:if(y=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(a=>o.includes(a))||o.length===0?`"${o}"`:o),p){const o=(0,L.getDriveLetter)(p);o&&(n+=`${o}: && `),n+=`cd ${y(p)} && `}if(_){n+='cmd /C "';for(const o in _){let a=_[o];a===null?n+=`set "${o}=" && `:(a=a.replace(/[&^|<>]/g,m=>`^${m}`),n+=`set "${o}=${a}" && `)}}for(const o of P)n+=o==="<"||o===">"||k?o:y(o),n+=" ";_&&(n+='"');break;case 2:{y=a=>(a=a.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),a.length===0?'""':a);const o=a=>/[^\w@%\/+=,.:^-]/.test(a)?`'${a.replace(/'/g,"'\\''")}'`:a;if(p&&(n+=`cd ${y(p)} ; `),_){n+="/usr/bin/env";for(const a in _){const m=_[a];m===null?n+=` -u ${o(a)}`:n+=` ${o(`${a}=${m}`)}`}n+=" "}for(const a of P)n+=a==="<"||a===">"||k?a:y(a),n+=" ";break}}return n}e.prepareCommand=w}),define(Ce[107],De([1,0,21,35,48,97,16,14,9,47]),function(me,e,C,L,d,A,T,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var P;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(P||(e.CellKind=P={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var p;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(p||(e.NotebookCellExecutionState=p={}));var _;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(_||(e.NotebookExecutionState=_={}));var D;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(D||(e.NotebookRendererMatch=D={}));var y;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(y||(e.RendererMessagingSpec=y={}));var n;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(n||(e.NotebookCellsChangeType=n={}));var o;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var a;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(a||(e.CellEditType=a={}));var m;(function(O){O.scheme=T.Schemas.vscodeNotebookCell;const K=["W","X","Y","Z","a","b","c","d","e","f"],q=new RegExp(`^[${K.join("")}]+`),fe=7;function se(ne,J){const N=J.toString(fe),he=`${N.length<K.length?K[N.length-1]:"z"}${N}s${(0,C.encodeBase64)(C.VSBuffer.fromString(ne.scheme),!0,!0)}`;return ne.with({scheme:O.scheme,fragment:he})}O.generate=se;function ie(ne){if(ne.scheme!==O.scheme)return;const J=ne.fragment.indexOf("s");if(J<0)return;const N=parseInt(ne.fragment.substring(0,J).replace(q,""),fe),W=(0,C.decodeBase64)(ne.fragment.substring(J+1)).toString();if(!isNaN(N))return{handle:N,notebook:ne.with({scheme:W,fragment:null})}}O.parse=ie;function H(ne,J){return ne.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${J??""},${ne.scheme!==T.Schemas.file?ne.scheme:""}`})}O.generateCellOutputUri=H;function re(ne){if(ne.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const J=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!J)return;const N=J[1]&&J[1]!==""?J[1]:void 0,W=J[2];return{outputId:N,notebook:ne.with({scheme:W||T.Schemas.file,fragment:null})}}O.parseCellOutputUri=re;function Ee(ne,J,N){return O.generate(ne,J).with({scheme:N})}O.generateCellPropertyUri=Ee;function ae(ne,J){if(ne.scheme===J)return O.parse(ne.with({scheme:O.scheme}))}O.parseCellPropertyUri=ae})(m||(e.CellUri=m={}));const b=O=>w.isWindows?O.replace(/\//g,"\\"):O;class I{constructor(K=[],q=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=q,this.order=[...new Set(K)].map(fe=>({pattern:fe,matches:L.parse(b(fe))}))}sort(K){const q=new Map(d.Iterable.map(K,se=>[se,b(se)]));let fe=[];for(const{matches:se}of this.order)for(const[ie,H]of q)if(se(H)){fe.push(ie),q.delete(ie);break}return q.size&&(fe=fe.concat([...q.keys()].sort((se,ie)=>this.defaultOrder.indexOf(se)-this.defaultOrder.indexOf(ie)))),fe}prioritize(K,q){const fe=this.findIndex(K);if(fe===-1){this.order.unshift({pattern:K,matches:L.parse(b(K))});return}const se=new Set(q.map(H=>this.findIndex(H,fe)));se.delete(-1);const ie=Array.from(se).sort();this.order.splice(fe+1,0,...ie.map(H=>this.order[H]));for(let H=ie.length-1;H>=0;H--)this.order.splice(ie[H],1)}toArray(){return this.order.map(K=>K.pattern)}findIndex(K,q=this.order.length){const fe=b(K);for(let se=0;se<q;se++)if(this.order[se].matches(fe))return se;return-1}}e.MimeTypeDisplayOrder=I;function t(O,K,q,fe=(se,ie)=>se===ie){const se=[];function ie(Ee,ae,ne){if(ae===0&&ne.length===0)return;const J=se[se.length-1];J&&J.start+J.deleteCount===Ee?(J.deleteCount+=ae,J.toInsert.push(...ne)):se.push({start:Ee,deleteCount:ae,toInsert:ne})}let H=0,re=0;for(;;){if(H===O.length){ie(H,0,K.slice(re));break}if(re===K.length){ie(H,O.length-H,[]);break}const Ee=O[H],ae=K[re];if(fe(Ee,ae)){H+=1,re+=1;continue}q(ae)?(ie(H,1,[]),H+=1):(ie(H,0,[ae]),re+=1)}return se}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new g.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new g.RawContextKey("notebookEditorCursorAtLineBoundary","none");var r;(function(O){O.default="default",O.option="option"})(r||(e.NotebookEditorPriority=r={}));function s(O){const K=O;return!!((typeof K.include=="string"||L.isRelativePattern(K.include))&&(typeof K.exclude=="string"||L.isRelativePattern(K.exclude)))}e.isDocumentExcludePattern=s;function i(O,K,q){if(Array.isArray(O.viewType)&&O.viewType.indexOf(K)>=0||O.viewType===K)return!0;if(O.filenamePattern){const fe=s(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,se=s(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(L.match(fe,(0,f.basename)(q.fsPath).toLowerCase()))return!(se&&L.match(se,(0,f.basename)(q.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var c;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class u{static{this._prefix="notebook/"}static create(K){return`${u._prefix}${K}`}static parse(K){if(K.startsWith(u._prefix))return K.substring(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u;function v(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.isTextStreamMime=v;const S=new TextDecoder;function l(O){const K=[];let q=!1;for(const H of O)(K.length===0||q)&&(K.push(H),q=!0);let fe=R(K);const se=C.VSBuffer.concat(K.map(H=>C.VSBuffer.wrap(H))),ie=$(se);return fe=fe||ie.byteLength!==se.byteLength,{data:ie,didCompression:fe}}e.compressOutputItemStreams=l,e.MOVE_CURSOR_1_LINE_COMMAND=`${String.fromCharCode(27)}[A`;const h=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(O=>O.charCodeAt(0)),E=10;function R(O){let K=!1;return O.forEach((q,fe)=>{if(fe===0||q.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const se=O[fe-1],ie=q.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(ie[0]===h[0]&&ie[1]===h[1]&&ie[2]===h[2]){const H=se.lastIndexOf(E);if(H===-1)return;K=!0,O[fe-1]=se.subarray(0,H),O[fe]=q.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),K}function M(O){let K=O;do O=K,K=O.replace(/[^\n]\x08/gm,"");while(K.length<O.length);return O}function U(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const K=O.match(/^(.*)\r+/m)[1];let q=O.match(/\r+(.*)$/m)[1];q=q+K.slice(q.length,K.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return O}const F="\b".charCodeAt(0),x="\r".charCodeAt(0);function $(O){return!O.buffer.includes(F)&&!O.buffer.includes(x)?O:C.VSBuffer.fromString(U(M(S.decode(O.buffer))))}}),define(Ce[7],De([1,0,18,8,78,28,97,15,19,2,31,25,30,84,107]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D){"use strict";var y,n,o,a,m,b,I,t,r,s,i,c,u,v,S,l,h,E;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.ChatMessage=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.NotebookCodeActionKind=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function R(j){return Object.assign(j,{apply:function(){const pe=arguments.length===1?[]:arguments[1];return Reflect.construct(j,pe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(j,[]);{const[pe,...Ae]=arguments;return Reflect.construct(j,Ae,pe.constructor)}}})}var M;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(M||(e.TerminalOutputAnchor=M={}));var U;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(U||(e.TerminalQuickFixType=U={}));let F=y=class{static from(...z){let pe=z;return new y(function(){if(pe){for(const Ae of pe)Ae&&typeof Ae.dispose=="function"&&Ae.dispose();pe=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=F,e.Disposable=F=y=qe([R],F);let x=n=class{static Min(...z){if(z.length===0)throw new TypeError;let pe=z[0];for(let Ae=1;Ae<z.length;Ae++){const Ke=z[Ae];Ke.isBefore(pe)&&(pe=Ke)}return pe}static Max(...z){if(z.length===0)throw new TypeError;let pe=z[0];for(let Ae=1;Ae<z.length;Ae++){const Ke=z[Ae];Ke.isAfter(pe)&&(pe=Ke)}return pe}static isPosition(z){if(!z)return!1;if(z instanceof n)return!0;const{line:pe,character:Ae}=z;return typeof pe=="number"&&typeof Ae=="number"}static of(z){if(z instanceof n)return z;if(this.isPosition(z))return new n(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(z,pe){if(z<0)throw(0,L.illegalArgument)("line must be non-negative");if(pe<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=z,this._character=pe}isBefore(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<z._character}isBeforeOrEqual(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<=z._character}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this._line===z._line&&this._character===z._character}compareTo(z){return this._line<z._line?-1:this._line>z.line?1:this._character<z._character?-1:this._character>z._character?1:0}translate(z,pe=0){if(z===null||pe===null)throw(0,L.illegalArgument)();let Ae;return typeof z>"u"?Ae=0:typeof z=="number"?Ae=z:(Ae=typeof z.lineDelta=="number"?z.lineDelta:0,pe=typeof z.characterDelta=="number"?z.characterDelta:0),Ae===0&&pe===0?this:new n(this.line+Ae,this.character+pe)}with(z,pe=this.character){if(z===null||pe===null)throw(0,L.illegalArgument)();let Ae;return typeof z>"u"?Ae=this.line:typeof z=="number"?Ae=z:(Ae=typeof z.line=="number"?z.line:this.line,pe=typeof z.character=="number"?z.character:this.character),Ae===this.line&&pe===this.character?this:new n(Ae,pe)}toJSON(){return{line:this.line,character:this.character}}};e.Position=x,e.Position=x=n=qe([R],x);let $=o=class{static isRange(z){return z instanceof o?!0:z?x.isPosition(z.start)&&x.isPosition(z.end):!1}static of(z){if(z instanceof o)return z;if(this.isRange(z))return new o(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(z,pe,Ae,Ke){let tt,at;if(typeof z=="number"&&typeof pe=="number"&&typeof Ae=="number"&&typeof Ke=="number"?(tt=new x(z,pe),at=new x(Ae,Ke)):x.isPosition(z)&&x.isPosition(pe)&&(tt=x.of(z),at=x.of(pe)),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}contains(z){return o.isRange(z)?this.contains(z.start)&&this.contains(z.end):x.isPosition(z)?!(x.of(z).isBefore(this._start)||this._end.isBefore(z)):!1}isEqual(z){return this._start.isEqual(z._start)&&this._end.isEqual(z._end)}intersection(z){const pe=x.Max(z.start,this._start),Ae=x.Min(z.end,this._end);if(!pe.isAfter(Ae))return new o(pe,Ae)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const pe=x.Min(z.start,this._start),Ae=x.Max(z.end,this.end);return new o(pe,Ae)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(z,pe=this.end){if(z===null||pe===null)throw(0,L.illegalArgument)();let Ae;return z?x.isPosition(z)?Ae=z:(Ae=z.start||this.start,pe=z.end||this.end):Ae=this.start,Ae.isEqual(this._start)&&pe.isEqual(this.end)?this:new o(Ae,pe)}toJSON(){return[this.start,this.end]}};e.Range=$,e.Range=$=o=qe([R],$);let O=a=class extends ${static isSelection(z){return z instanceof a?!0:z?$.isRange(z)&&x.isPosition(z.anchor)&&x.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(z,pe,Ae,Ke){let tt,at;if(typeof z=="number"&&typeof pe=="number"&&typeof Ae=="number"&&typeof Ke=="number"?(tt=new x(z,pe),at=new x(Ae,Ke)):x.isPosition(z)&&x.isPosition(pe)&&(tt=x.of(z),at=x.of(pe)),!tt||!at)throw new Error("Invalid arguments");super(tt,at),this._anchor=tt,this._active=at}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=O,e.Selection=O=a=qe([R],O);const K=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,L.illegalArgument)("connectionToken")};class q{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,pe,Ae){if(typeof z!="string"||z.length===0)throw(0,L.illegalArgument)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,L.illegalArgument)("port");typeof Ae<"u"&&K(Ae),this.host=z,this.port=Math.round(pe),this.connectionToken=Ae}}e.ResolvedAuthority=q;class fe{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,pe){this.makeConnection=z,this.connectionToken=pe,typeof pe<"u"&&K(pe)}}e.ManagedResolvedAuthority=fe;class se extends Error{static NotAvailable(z,pe){return new se(z,_.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(z){return new se(z,_.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,pe=_.RemoteAuthorityResolverErrorCode.Unknown,Ae){super(z),this._message=z,this._code=pe,this._detail=Ae,Object.setPrototypeOf(this,se.prototype)}}e.RemoteAuthorityResolverError=se;var ie;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ie||(e.EndOfLine=ie={}));var H;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(H||(e.EnvironmentVariableMutatorType=H={}));let re=m=class{static isTextEdit(z){return z instanceof m?!0:z?$.isRange(z)&&typeof z.newText=="string":!1}static replace(z,pe){return new m(z,pe)}static insert(z,pe){return m.replace(new $(z,z),pe)}static delete(z){return m.replace(z,"")}static setEndOfLine(z){const pe=new m(new $(new x(0,0),new x(0,0)),"");return pe.newEol=z,pe}get range(){return this._range}set range(z){if(z&&!$.isRange(z))throw(0,L.illegalArgument)("range");this._range=z}get newText(){return this._newText||""}set newText(z){if(z&&typeof z!="string")throw(0,L.illegalArgument)("newText");this._newText=z}get newEol(){return this._newEol}set newEol(z){if(z&&typeof z!="number")throw(0,L.illegalArgument)("newEol");this._newEol=z}constructor(z,pe){this._range=z,this._newText=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=re,e.TextEdit=re=m=qe([R],re);let Ee=b=class{static isNotebookCellEdit(z){return z instanceof b?!0:z?Yt.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,pe){return new b(z,pe)}static insertCells(z,pe){return new b(new Yt(z,z),pe)}static deleteCells(z){return new b(z,[])}static updateCellMetadata(z,pe){const Ae=new b(new Yt(z,z),[]);return Ae.newCellMetadata=pe,Ae}static updateNotebookMetadata(z){const pe=new b(new Yt(0,0),[]);return pe.newNotebookMetadata=z,pe}constructor(z,pe){this.range=z,this.newCells=pe}};e.NotebookEdit=Ee,e.NotebookEdit=Ee=b=qe([R],Ee);class ae{static isSnippetTextEdit(z){return z instanceof ae?!0:z?$.isRange(z.range)&&N.isSnippetString(z.snippet):!1}static replace(z,pe){return new ae(z,pe)}static insert(z,pe){return ae.replace(new $(z,z),pe)}constructor(z,pe){this.range=z,this.snippet=pe}}e.SnippetTextEdit=ae;var ne;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(ne||(e.FileEditType=ne={}));let J=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(z,pe,Ae,Ke){this._edits.push({_type:1,from:z,to:pe,options:Ae,metadata:Ke})}createFile(z,pe,Ae){this._edits.push({_type:1,from:void 0,to:z,options:pe,metadata:Ae})}deleteFile(z,pe,Ae){this._edits.push({_type:1,from:z,to:void 0,options:pe,metadata:Ae})}replaceNotebookMetadata(z,pe,Ae){this._edits.push({_type:3,metadata:Ae,uri:z,edit:{editType:5,metadata:pe},notebookMetadata:pe})}replaceNotebookCells(z,pe,Ae,Ke){const tt=pe.start,at=pe.end;(tt!==at||Ae.length>0)&&this._edits.push({_type:5,uri:z,index:tt,count:at-tt,cells:Ae,metadata:Ke})}replaceNotebookCellMetadata(z,pe,Ae,Ke){this._edits.push({_type:3,metadata:Ke,uri:z,edit:{editType:3,index:pe,metadata:Ae}})}replace(z,pe,Ae,Ke){this._edits.push({_type:2,uri:z,edit:new re(pe,Ae),metadata:Ke})}insert(z,pe,Ae,Ke){this.replace(z,new $(pe,pe),Ae,Ke)}delete(z,pe,Ae){this.replace(z,pe,"",Ae)}has(z){return this._edits.some(pe=>pe._type===2&&pe.uri.toString()===z.toString())}set(z,pe){if(pe)for(const Ae of pe){if(!Ae)continue;let Ke,tt;Array.isArray(Ae)?(Ke=Ae[0],tt=Ae[1]):Ke=Ae,Ee.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.replaceNotebookCellMetadata(z,Ke.range.start,Ke.newCellMetadata,tt):Ke.newNotebookMetadata?this.replaceNotebookMetadata(z,Ke.newNotebookMetadata,tt):this.replaceNotebookCells(z,Ke.range,Ke.newCells,tt):ae.isSnippetTextEdit(Ke)?this._edits.push({_type:6,uri:z,range:Ke.range,edit:Ke.snippet,metadata:tt}):this._edits.push({_type:2,uri:z,edit:Ke,metadata:tt})}else{for(let Ae=0;Ae<this._edits.length;Ae++){const Ke=this._edits[Ae];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===z.toString()&&(this._edits[Ae]=void 0);break}}(0,C.coalesceInPlace)(this._edits)}}get(z){const pe=[];for(const Ae of this._edits)Ae._type===2&&Ae.uri.toString()===z.toString()&&pe.push(Ae.edit);return pe}entries(){const z=new A.ResourceMap;for(const pe of this._edits)if(pe._type===2){let Ae=z.get(pe.uri);Ae||(Ae=[pe.uri,[]],z.set(pe.uri,Ae)),Ae[1].push(pe.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=J,e.WorkspaceEdit=J=qe([R],J);let N=I=class{static isSnippetString(z){return z instanceof I?!0:z?typeof z.value=="string":!1}static _escape(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this._tabstop=1,this.value=z||""}appendText(z){return this.value+=I._escape(z),this}appendTabstop(z=this._tabstop++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,pe=this._tabstop++){if(typeof z=="function"){const Ae=new I;Ae._tabstop=this._tabstop,z(Ae),this._tabstop=Ae._tabstop,z=Ae.value}else z=I._escape(z);return this.value+="${",this.value+=pe,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,pe=this._tabstop++){const Ae=z.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Ae,this.value+="|}",this}appendVariable(z,pe){if(typeof pe=="function"){const Ae=new I;Ae._tabstop=this._tabstop,pe(Ae),this._tabstop=Ae._tabstop,pe=Ae.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.SnippetString=N,e.SnippetString=N=I=qe([R],N);var W;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var he;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(he||(e.DiagnosticSeverity=he={}));let Se=t=class{static isLocation(z){return z instanceof t?!0:z?$.isRange(z.range)&&g.URI.isUri(z.uri):!1}constructor(z,pe){if(this.uri=z,pe)if($.isRange(pe))this.range=$.of(pe);else if(x.isPosition(pe))this.range=new $(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Se,e.Location=Se=t=qe([R],Se);let be=class{static is(z){return z?typeof z.message=="string"&&z.location&&$.isRange(z.location.range)&&g.URI.isUri(z.location.uri):!1}constructor(z,pe){this.location=z,this.message=pe}static isEqual(z,pe){return z===pe?!0:!z||!pe?!1:z.message===pe.message&&z.location.range.isEqual(pe.location.range)&&z.location.uri.toString()===pe.location.uri.toString()}};e.DiagnosticRelatedInformation=be,e.DiagnosticRelatedInformation=be=qe([R],be);let we=class{constructor(z,pe,Ae=he.Error){if(!$.isRange(z))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=z,this.message=pe,this.severity=Ae}toJSON(){return{severity:he[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,pe){return z===pe?!0:!z||!pe?!1:z.message===pe.message&&z.severity===pe.severity&&z.code===pe.code&&z.severity===pe.severity&&z.source===pe.source&&z.range.isEqual(pe.range)&&(0,C.equals)(z.tags,pe.tags)&&(0,C.equals)(z.relatedInformation,pe.relatedInformation,be.isEqual)}};e.Diagnostic=we,e.Diagnostic=we=qe([R],we);let ye=class{constructor(z,pe){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=pe}};e.Hover=ye,e.Hover=ye=qe([R],ye);var V;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(V||(e.DocumentHighlightKind=V={}));let ee=class{constructor(z,pe=V.Text){this.range=z,this.kind=pe}toJSON(){return{range:this.range,kind:V[this.kind]}}};e.DocumentHighlight=ee,e.DocumentHighlight=ee=qe([R],ee);var G;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(G||(e.SymbolKind=G={}));var Y;(function(j){j[j.Deprecated=1]="Deprecated"})(Y||(e.SymbolTag=Y={}));let de=r=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,pe,Ae,Ke,tt){this.name=z,this.kind=pe,this.containerName=tt,typeof Ae=="string"&&(this.containerName=Ae),Ke instanceof Se?this.location=Ke:Ae instanceof $&&(this.location=new Se(Ke,Ae)),r.validate(this)}toJSON(){return{name:this.name,kind:G[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=de,e.SymbolInformation=de=r=qe([R],de);let ke=s=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(s.validate)}constructor(z,pe,Ae,Ke,tt){this.name=z,this.detail=pe,this.kind=Ae,this.range=Ke,this.selectionRange=tt,this.children=[],s.validate(this)}};e.DocumentSymbol=ke,e.DocumentSymbol=ke=s=qe([R],ke);var B;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let X=class{constructor(z,pe){this.title=z,this.kind=pe}};e.CodeAction=X,e.CodeAction=X=qe([R],X);let Z=class{static{i=this}static{this.sep="."}constructor(z){this.value=z}append(z){return new i(this.value?this.value+i.sep+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+i.sep)}};e.CodeActionKind=Z,e.CodeActionKind=Z=i=qe([R],Z);class oe extends Z{constructor(z){super(z),this.value=z}}e.NotebookCodeActionKind=oe,Z.Empty=new Z(""),Z.QuickFix=Z.Empty.append("quickfix"),Z.Refactor=Z.Empty.append("refactor"),Z.RefactorExtract=Z.Refactor.append("extract"),Z.RefactorInline=Z.Refactor.append("inline"),Z.RefactorMove=Z.Refactor.append("move"),Z.RefactorRewrite=Z.Refactor.append("rewrite"),Z.Source=Z.Empty.append("source"),Z.SourceOrganizeImports=Z.Source.append("organizeImports"),Z.SourceFixAll=Z.Source.append("fixAll"),Z.Notebook=Z.Empty.append("notebook");let Q=class{constructor(z,pe){if(this.range=z,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=Q,e.SelectionRange=Q=qe([R],Q);class ue{constructor(z,pe,Ae,Ke,tt,at){this.kind=z,this.name=pe,this.detail=Ae,this.uri=Ke,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=ue;class ve{constructor(z,pe){this.fromRanges=pe,this.from=z}}e.CallHierarchyIncomingCall=ve;class xe{constructor(z,pe){this.fromRanges=pe,this.to=z}}e.CallHierarchyOutgoingCall=xe;var We;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(We||(e.LanguageStatusSeverity=We={}));let Ze=class{constructor(z,pe){this.range=z,this.command=pe}get isResolved(){return!!this.command}};e.CodeLens=Ze,e.CodeLens=Ze=qe([R],Ze);let Qe=c=class{#e;static isMarkdownString(z){return z instanceof c?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,pe=!1){this.#e=new d.MarkdownString(z,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,pe){return this.#e.appendCodeblock(pe??"",z),this}};e.MarkdownString=Qe,e.MarkdownString=Qe=c=qe([R],Qe);let it=class{constructor(z,pe){this.label=z,this.documentation=pe}};e.ParameterInformation=it,e.ParameterInformation=it=qe([R],it);let et=class{constructor(z,pe){this.label=z,this.documentation=pe,this.parameters=[]}};e.SignatureInformation=et,e.SignatureInformation=et=qe([R],et);let Pe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Pe,e.SignatureHelp=Pe=qe([R],Pe);var Me;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(Me||(e.SignatureHelpTriggerKind=Me={}));var ze;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(ze||(e.InlayHintKind=ze={}));let Re=class{constructor(z){this.value=z}};e.InlayHintLabelPart=Re,e.InlayHintLabelPart=Re=qe([R],Re);let Xe=class{constructor(z,pe,Ae){this.position=z,this.label=pe,this.kind=Ae}};e.InlayHint=Xe,e.InlayHint=Xe=qe([R],Xe);var le;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(le||(e.CompletionTriggerKind=le={}));var ce;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(ce||(e.CompletionItemKind=ce={}));var Ie;(function(j){j[j.Deprecated=1]="Deprecated"})(Ie||(e.CompletionItemTag=Ie={}));let He=class{constructor(z,pe){this.label=z,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=He,e.CompletionItem=He=qe([R],He);let Ue=class{constructor(z=[],pe=!1){this.items=z,this.isIncomplete=pe}};e.CompletionList=Ue,e.CompletionList=Ue=qe([R],Ue);let Ye=class{constructor(z,pe,Ae){this.insertText=z,this.range=pe,this.command=Ae}};e.InlineSuggestion=Ye,e.InlineSuggestion=Ye=qe([R],Ye);let rt=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.InlineSuggestionList=rt,e.InlineSuggestionList=rt=qe([R],rt);var ot;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(ot||(e.ViewColumn=ot={}));var pt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(pt||(e.StatusBarAlignment=pt={}));function It(j,z){return`${k.ExtensionIdentifier.toKey(j)}.${z}`}e.asStatusBarItemIdentifier=It;var Xt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Xt||(e.TextEditorLineNumbersStyle=Xt={}));var Wt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Wt||(e.TextDocumentSaveReason=Wt={}));var bt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(bt||(e.TextEditorRevealType=bt={}));var Ot;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var Nt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Nt||(e.TextDocumentChangeReason=Nt={}));var qt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(qt||(e.DecorationRangeBehavior=qt={})),function(j){function z(pe){switch(pe){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=z}(Ot||(e.TextEditorSelectionChangeKind=Ot={}));let At=class{constructor(z,pe){if(pe&&!g.URI.isUri(pe))throw(0,L.illegalArgument)("target");if(!$.isRange(z)||z.isEmpty)throw(0,L.illegalArgument)("range");this.range=z,this.target=pe}};e.DocumentLink=At,e.DocumentLink=At=qe([R],At);let Rt=class{constructor(z,pe,Ae,Ke){this.red=z,this.green=pe,this.blue=Ae,this.alpha=Ke}};e.Color=Rt,e.Color=Rt=qe([R],Rt);let xt=class{constructor(z,pe){if(pe&&!(pe instanceof Rt))throw(0,L.illegalArgument)("color");if(!$.isRange(z)||z.isEmpty)throw(0,L.illegalArgument)("range");this.range=z,this.color=pe}};e.ColorInformation=xt,e.ColorInformation=xt=qe([R],xt);let Bt=class{constructor(z){if(!z||typeof z!="string")throw(0,L.illegalArgument)("label");this.label=z}};e.ColorPresentation=Bt,e.ColorPresentation=Bt=qe([R],Bt);var Ht;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var $t;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})($t||(e.SourceControlInputBoxValidationType=$t={}));var ct;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(ct||(e.TerminalExitReason=ct={}));class dt{constructor(z,pe,Ae){if(this.startIndex=z,this.length=pe,this.tooltip=Ae,typeof z!="number"||z<0)throw(0,L.illegalArgument)("startIndex");if(typeof pe!="number"||pe<1)throw(0,L.illegalArgument)("length");if(Ae!==void 0&&typeof Ae!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=dt;class jt{constructor(z){this.uri=z}}e.TerminalQuickFixOpener=jt;class Tt{constructor(z){this.terminalCommand=z}}e.TerminalQuickFixCommand=Tt;var _t;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(_t||(e.TerminalLocation=_t={}));class ft{constructor(z){if(this.options=z,typeof z!="object")throw(0,L.illegalArgument)("options")}}e.TerminalProfile=ft;var kt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(kt||(e.TaskRevealKind=kt={}));var Mt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Mt||(e.TaskPanelKind=Mt={}));let St=class{static{u=this}static{this.Clean=new u("clean","Clean")}static{this.Build=new u("build","Build")}static{this.Rebuild=new u("rebuild","Rebuild")}static{this.Test=new u("test","Test")}static from(z){switch(z){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}constructor(z,pe){if(this.label=pe,typeof z!="string"||typeof pe!="string")throw(0,L.illegalArgument)("name");this._id=z}get id(){return this._id}};e.TaskGroup=St,e.TaskGroup=St=u=qe([R],St);function je(j){let z="";for(let pe=0;pe<j.length;pe++)z+=j[pe].replace(/,/g,",,")+",";return z}let Le=class{constructor(z,pe,Ae){if(typeof z!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=z,pe!==void 0&&(Array.isArray(pe)?(this._args=pe,this._options=Ae):this._options=pe)}get process(){return this._process}set process(z){if(typeof z!="string")throw(0,L.illegalArgument)("process");this._process=z}get args(){return this._args}set args(z){Array.isArray(z)||(z=[]),this._args=z}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("process"),this._process!==void 0&&z.push(this._process),this._args&&this._args.length>0)for(const pe of this._args)z.push(pe);return je(z)}};e.ProcessExecution=Le,e.ProcessExecution=Le=qe([R],Le);let Fe=class{constructor(z,pe,Ae){if(this._args=[],Array.isArray(pe)){if(!z)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,L.illegalArgument)("command");this._command=z,this._args=pe,this._options=Ae}else{if(typeof z!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=z,this._options=pe}}get commandLine(){return this._commandLine}set commandLine(z){if(typeof z!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=z}get command(){return this._command?this._command:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,L.illegalArgument)("command");this._command=z}get args(){return this._args}set args(z){this._args=z||[]}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("shell"),this._commandLine!==void 0&&z.push(this._commandLine),this._command!==void 0&&z.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const pe of this._args)z.push(typeof pe=="string"?pe:pe.value);return je(z)}};e.ShellExecution=Fe,e.ShellExecution=Fe=qe([R],Fe);var Te;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Te||(e.ShellQuoting=Te={}));var te;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(te||(e.TaskScope=te={}));class Oe{constructor(z){this._callback=z}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(z){this._callback=z}get callback(){return this._callback}}e.CustomExecution=Oe;let Ve=class{static{v=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(z,pe,Ae,Ke,tt,at){this.__deprecated=!1,this._definition=this.definition=z;let ht;typeof pe=="string"?(this._name=this.name=pe,this._source=this.source=Ae,this.execution=Ke,ht=tt,this.__deprecated=!0):pe===te.Global||pe===te.Workspace?(this.target=pe,this._name=this.name=Ae,this._source=this.source=Ke,this.execution=tt,ht=at):(this.target=pe,this._name=this.name=Ae,this._source=this.source=Ke,this.execution=tt,ht=at),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(z){this.__id=z}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Le?this._definition={type:v.ProcessType,id:this._execution.computeId()}:this._execution instanceof Fe?this._definition={type:v.ShellType,id:this._execution.computeId()}:this._execution instanceof Oe?this._definition={type:v.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:v.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(z){if(z==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=z}get scope(){return this._scope}set target(z){this.clear(),this._scope=z}get name(){return this._name}set name(z){if(typeof z!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=z}get execution(){return this._execution}set execution(z){z===null&&(z=void 0),this.clear(),this._execution=z;const pe=this._definition.type;(v.EmptyType===pe||v.ProcessType===pe||v.ShellType===pe||v.ExtensionCallbackType===pe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(z){if(Array.isArray(z))this.clear(),this._problemMatchers=z,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.clear(),this._isBackground=z}get source(){return this._source}set source(z){if(typeof z!="string"||z.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=z}get group(){return this._group}set group(z){z===null&&(z=void 0),this.clear(),this._group=z}get detail(){return this._detail}set detail(z){z===null&&(z=void 0),this._detail=z}get presentationOptions(){return this._presentationOptions}set presentationOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._presentationOptions=z}get runOptions(){return this._runOptions}set runOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._runOptions=z}};e.Task=Ve,e.Task=Ve=v=qe([R],Ve);var Je;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Je||(e.ProgressLocation=Je={}));var Ge;(function(j){function z(pe){const Ae=pe;return(0,w.isNumber)(Ae.value)?Ae.tooltip&&!(0,w.isString)(Ae.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ae.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ae.value),!1)}j.isViewBadge=z})(Ge||(e.ViewBadge=Ge={}));let nt=S=class{static isTreeItem(z,pe){const Ae=z;if(Ae.checkboxState!==void 0){const Ke=(0,w.isNumber)(Ae.checkboxState)?Ae.checkboxState:(0,w.isObject)(Ae.checkboxState)&&(0,w.isNumber)(Ae.checkboxState.state)?Ae.checkboxState.state:void 0,tt=!(0,w.isNumber)(Ae.checkboxState)&&(0,w.isObject)(Ae.checkboxState)?Ae.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==yt.Checked&&Ke!==yt.Unchecked||tt!==void 0&&!(0,w.isString)(tt))return console.log("INVALID tree item, invalid checkboxState",Ae.checkboxState),!1}if(z instanceof S)return!0;if(Ae.label!==void 0&&!(0,w.isString)(Ae.label)&&!Ae.label?.label)return console.log("INVALID tree item, invalid label",Ae.label),!1;if(Ae.id!==void 0&&!(0,w.isString)(Ae.id))return console.log("INVALID tree item, invalid id",Ae.id),!1;if(Ae.iconPath!==void 0&&!(0,w.isString)(Ae.iconPath)&&!g.URI.isUri(Ae.iconPath)&&(!Ae.iconPath||!(0,w.isString)(Ae.iconPath.id))){const Ke=Ae.iconPath;if(!Ke||!(0,w.isString)(Ke.light)&&!g.URI.isUri(Ke.light)&&!(0,w.isString)(Ke.dark)&&!g.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ae.iconPath),!1}return Ae.description!==void 0&&!(0,w.isString)(Ae.description)&&typeof Ae.description!="boolean"?(console.log("INVALID tree item, invalid description",Ae.description),!1):Ae.resourceUri!==void 0&&!g.URI.isUri(Ae.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ae.resourceUri),!1):Ae.tooltip!==void 0&&!(0,w.isString)(Ae.tooltip)&&!(Ae.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",Ae.tooltip),!1):Ae.command!==void 0&&!Ae.command.command?(console.log("INVALID tree item, invalid command",Ae.command),!1):Ae.collapsibleState!==void 0&&Ae.collapsibleState<vt.None&&Ae.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ae.collapsibleState),!1):Ae.contextValue!==void 0&&!(0,w.isString)(Ae.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ae.contextValue),!1):Ae.accessibilityInformation!==void 0&&!Ae.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ae.accessibilityInformation),!1):!0}constructor(z,pe=vt.None){this.collapsibleState=pe,g.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.TreeItem=nt,e.TreeItem=nt=S=qe([R],nt);var vt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var yt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(yt||(e.TreeItemCheckboxState=yt={}));let Et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.DataTransferItem=Et,e.DataTransferItem=Et=qe([R],Et);class lt extends Et{}e.InternalDataTransferItem=lt;class gt extends lt{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.InternalFileDataTransferItem=gt;class Ct{constructor(z,pe,Ae,Ke){this.name=z,this.uri=pe,this._itemId=Ae,this._getData=Ke}data(){return this._getData()}}e.DataTransferFile=Ct;let mi=class{#e=new Map;constructor(z){for(const[pe,Ae]of z??[]){const Ke=this.#e.get(this.#t(pe));Ke?Ke.push(Ae):this.#e.set(this.#t(pe),[Ae])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,pe){this.#e.set(this.#t(z),[pe])}forEach(z,pe){for(const[Ae,Ke]of this.#e)for(const tt of Ke)z.call(pe,tt,Ae,this)}*[Symbol.iterator](){for(const[z,pe]of this.#e)for(const Ae of pe)yield[z,Ae]}#t(z){return z.toLowerCase()}};e.DataTransfer=mi,e.DataTransfer=mi=qe([R],mi);let Vt=class{constructor(z){this.insertText=z}};e.DocumentDropEdit=Vt,e.DocumentDropEdit=Vt=qe([R],Vt);let yi=class{constructor(z,pe){this.label=pe,this.insertText=z}};e.DocumentPasteEdit=yi,e.DocumentPasteEdit=yi=qe([R],yi);let zt=class{constructor(z,pe){this.id=z,this.color=pe}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.ThemeIcon=zt,e.ThemeIcon=zt=qe([R],zt),zt.File=new zt("file"),zt.Folder=new zt("folder");let gi=class{constructor(z){this.id=z}};e.ThemeColor=gi,e.ThemeColor=gi=qe([R],gi);var Pt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Pt||(e.ConfigurationTarget=Pt={}));let _i=class{get base(){return this._base}set base(z){this._base=z,this._baseUri=g.URI.file(z)}get baseUri(){return this._baseUri}set baseUri(z){this._baseUri=z,this._base=z.fsPath}constructor(z,pe){if(typeof z!="string"&&(!z||!g.URI.isUri(z)&&!g.URI.isUri(z.uri)))throw(0,L.illegalArgument)("base");if(typeof pe!="string")throw(0,L.illegalArgument)("pattern");typeof z=="string"?this.baseUri=g.URI.file(z):g.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=_i,e.RelativePattern=_i=qe([R],_i);const Wi=new WeakMap;function Dt(j,z){Wi.set(j,z)}e.setBreakpointId=Dt;let ti=class{constructor(z,pe,Ae,Ke){this.enabled=typeof z=="boolean"?z:!0,typeof pe=="string"&&(this.condition=pe),typeof Ae=="string"&&(this.hitCondition=Ae),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=Wi.get(this)??(0,P.generateUuid)()),this._id}};e.Breakpoint=ti,e.Breakpoint=ti=qe([R],ti);let pi=class extends ti{constructor(z,pe,Ae,Ke,tt){if(super(pe,Ae,Ke,tt),z===null)throw(0,L.illegalArgument)("location");this.location=z}};e.SourceBreakpoint=pi,e.SourceBreakpoint=pi=qe([R],pi);let si=class extends ti{constructor(z,pe,Ae,Ke,tt){super(pe,Ae,Ke,tt),this.functionName=z}};e.FunctionBreakpoint=si,e.FunctionBreakpoint=si=qe([R],si);let Ci=class extends ti{constructor(z,pe,Ae,Ke,tt,at,ht){if(super(Ke,tt,at,ht),!pe)throw(0,L.illegalArgument)("dataId");this.label=z,this.dataId=pe,this.canPersist=Ae}};e.DataBreakpoint=Ci,e.DataBreakpoint=Ci=qe([R],Ci);let Di=class{constructor(z,pe,Ae){this.command=z,this.args=pe||[],this.options=Ae}};e.DebugAdapterExecutable=Di,e.DebugAdapterExecutable=Di=qe([R],Di);let Lt=class{constructor(z,pe){this.port=z,this.host=pe}};e.DebugAdapterServer=Lt,e.DebugAdapterServer=Lt=qe([R],Lt);let vi=class{constructor(z){this.path=z}};e.DebugAdapterNamedPipeServer=vi,e.DebugAdapterNamedPipeServer=vi=qe([R],vi);let Ii=class{constructor(z){this.implementation=z}};e.DebugAdapterInlineImplementation=Ii,e.DebugAdapterInlineImplementation=Ii=qe([R],Ii);let oi=class{constructor(z,pe,Ae){this.session=z,this.threadId=pe,this.frameId=Ae}};e.StackFrameFocus=oi,e.StackFrameFocus=oi=qe([R],oi);let ai=class{constructor(z,pe){this.session=z,this.threadId=pe}};e.ThreadFocus=ai,e.ThreadFocus=ai=qe([R],ai);let ut=class{constructor(z,pe){this.range=z,this.expression=pe}};e.EvaluatableExpression=ut,e.EvaluatableExpression=ut=qe([R],ut);var Hi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Hi||(e.InlineCompletionTriggerKind=Hi={}));let Qt=class{constructor(z,pe){this.range=z,this.text=pe}};e.InlineValueText=Qt,e.InlineValueText=Qt=qe([R],Qt);let ii=class{constructor(z,pe,Ae=!0){this.range=z,this.variableName=pe,this.caseSensitiveLookup=Ae}};e.InlineValueVariableLookup=ii,e.InlineValueVariableLookup=ii=qe([R],ii);let Ei=class{constructor(z,pe){this.range=z,this.expression=pe}};e.InlineValueEvaluatableExpression=Ei,e.InlineValueEvaluatableExpression=Ei=qe([R],Ei);let ki=class{constructor(z,pe){this.frameId=z,this.stoppedLocation=pe}};e.InlineValueContext=ki,e.InlineValueContext=ki=qe([R],ki);var Vi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Vi||(e.FileChangeType=Vi={}));let Pi=l=class extends Error{static FileExists(z){return new l(z,p.FileSystemProviderErrorCode.FileExists,l.FileExists)}static FileNotFound(z){return new l(z,p.FileSystemProviderErrorCode.FileNotFound,l.FileNotFound)}static FileNotADirectory(z){return new l(z,p.FileSystemProviderErrorCode.FileNotADirectory,l.FileNotADirectory)}static FileIsADirectory(z){return new l(z,p.FileSystemProviderErrorCode.FileIsADirectory,l.FileIsADirectory)}static NoPermissions(z){return new l(z,p.FileSystemProviderErrorCode.NoPermissions,l.NoPermissions)}static Unavailable(z){return new l(z,p.FileSystemProviderErrorCode.Unavailable,l.Unavailable)}constructor(z,pe=p.FileSystemProviderErrorCode.Unknown,Ae){super(g.URI.isUri(z)?z.toString(!0):z),this.code=Ae?.name??"Unknown",(0,p.markAsFileSystemProviderError)(this,pe),Object.setPrototypeOf(this,l.prototype),typeof Error.captureStackTrace=="function"&&typeof Ae=="function"&&Error.captureStackTrace(this,Ae)}};e.FileSystemError=Pi,e.FileSystemError=Pi=l=qe([R],Pi);let bi=class{constructor(z,pe,Ae){this.start=z,this.end=pe,this.kind=Ae}};e.FoldingRange=bi,e.FoldingRange=bi=qe([R],bi);var qi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(qi||(e.FoldingRangeKind=qi={}));var Ti;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ti||(e.CommentThreadCollapsibleState=Ti={}));var ci;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var ji;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(ji||(e.CommentState=ji={}));var wi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ai{constructor(z,pe=[]){this.tokenTypes=z,this.tokenModifiers=pe}}e.SemanticTokensLegend=Ai;function cn(j){return typeof j>"u"||(0,w.isStringArray)(j)}class Ri{constructor(z){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,z){this._hasLegend=!0;for(let pe=0,Ae=z.tokenTypes.length;pe<Ae;pe++)this._tokenTypeStrToInt.set(z.tokenTypes[pe],pe);for(let pe=0,Ae=z.tokenModifiers.length;pe<Ae;pe++)this._tokenModifierStrToInt.set(z.tokenModifiers[pe],pe)}}push(z,pe,Ae,Ke,tt){if(typeof z=="number"&&typeof pe=="number"&&typeof Ae=="number"&&typeof Ke=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this._pushEncoded(z,pe,Ae,Ke,tt);if($.isRange(z)&&typeof pe=="string"&&cn(Ae))return this._push(z,pe,Ae);throw(0,L.illegalArgument)()}_push(z,pe,Ae){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(pe))throw new Error("`tokenType` is not in the provided legend");const Ke=z.start.line,tt=z.start.character,at=z.end.character-z.start.character,ht=this._tokenTypeStrToInt.get(pe);let Ut=0;if(Ae)for(const Kt of Ae){if(!this._tokenModifierStrToInt.has(Kt))throw new Error("`tokenModifier` is not in the provided legend");const Zt=this._tokenModifierStrToInt.get(Kt);Ut|=1<<Zt>>>0}this._pushEncoded(Ke,tt,at,ht,Ut)}_pushEncoded(z,pe,Ae,Ke,tt){if(this._dataIsSortedAndDeltaEncoded&&(z<this._prevLine||z===this._prevLine&&pe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ut=this._data.length/5|0;let Kt=0,Zt=0;for(let ei=0;ei<Ut;ei++){let ri=this._data[5*ei],$i=this._data[5*ei+1];ri===0?(ri=Kt,$i+=Zt):ri+=Kt,this._data[5*ei]=ri,this._data[5*ei+1]=$i,Kt=ri,Zt=$i}}let at=z,ht=pe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Ae,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=tt,this._prevLine=z,this._prevChar=pe}static _sortAndDeltaEncode(z){const pe=[],Ae=z.length/5|0;for(let ht=0;ht<Ae;ht++)pe[ht]=ht;pe.sort((ht,Ut)=>{const Kt=z[5*ht],Zt=z[5*Ut];if(Kt===Zt){const ei=z[5*ht+1],ri=z[5*Ut+1];return ei-ri}return Kt-Zt});const Ke=new Uint32Array(z.length);let tt=0,at=0;for(let ht=0;ht<Ae;ht++){const Ut=5*pe[ht],Kt=z[Ut+0],Zt=z[Ut+1],ei=z[Ut+2],ri=z[Ut+3],$i=z[Ut+4],wn=Kt-tt,Rn=wn===0?Zt-at:Zt,zi=5*ht;Ke[zi+0]=wn,Ke[zi+1]=Rn,Ke[zi+2]=ei,Ke[zi+3]=ri,Ke[zi+4]=$i,tt=Kt,at=Zt}return Ke}build(z){return this._dataIsSortedAndDeltaEncoded?new ni(new Uint32Array(this._data),z):new ni(Ri._sortAndDeltaEncode(this._data),z)}}e.SemanticTokensBuilder=Ri;class ni{constructor(z,pe){this.resultId=pe,this.data=z}}e.SemanticTokens=ni;class ln{constructor(z,pe,Ae){this.start=z,this.deleteCount=pe,this.data=Ae}}e.SemanticTokensEdit=ln;class un{constructor(z,pe){this.resultId=pe,this.edits=z}}e.SemanticTokensEdits=un;var Gi;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new zt("arrow-left")}}constructor(){}};e.QuickInputButtons=fi,e.QuickInputButtons=fi=qe([R],fi);var Ki;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Ki||(e.QuickPickItemKind=Ki={}));var Xi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var li;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(li||(e.ExtensionKind=li={}));class Qi{static validate(z){if(typeof z.badge=="string"){let pe=(0,f.nextCharLength)(z.badge,0);if(pe<z.badge.length&&(pe+=(0,f.nextCharLength)(z.badge,pe)),z.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!zt.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,pe,Ae){this.badge=z,this.tooltip=pe,this.color=Ae}}e.FileDecoration=Qi;let Li=class{constructor(z){this.kind=z}};e.ColorTheme=Li,e.ColorTheme=Li=qe([R],Li);var Yi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Yi||(e.ColorThemeKind=Yi={}));class Yt{static isNotebookRange(z){return z instanceof Yt?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(z,pe){if(z<0)throw(0,L.illegalArgument)("start must be positive");if(pe<0)throw(0,L.illegalArgument)("end must be positive");z<=pe?(this._start=z,this._end=pe):(this._start=pe,this._end=z)}with(z){let pe=this._start,Ae=this._end;return z.start!==void 0&&(pe=z.start),z.end!==void 0&&(Ae=z.end),pe===this._start&&Ae===this._end?this:new Yt(pe,Ae)}}e.NotebookRange=Yt;class Si{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(pe=>Si.isNotebookCellData(pe))}static isNotebookCellData(z){return!0}constructor(z,pe,Ae,Ke,tt,at,ht){this.kind=z,this.value=pe,this.languageId=Ae,this.mime=Ke,this.outputs=tt??[],this.metadata=at,this.executionSummary=ht,Si.validate(this)}}e.NotebookCellData=Si;class dn{constructor(z){this.cells=z}}e.NotebookData=dn;class Gt{static isNotebookCellOutputItem(z){return z instanceof Gt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const pe={name:z.name,message:z.message,stack:z.stack};return Gt.json(pe,"application/vnd.code.notebook.error")}static stdout(z){return Gt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Gt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,pe="application/octet-stream"){return new Gt(z,pe)}static#e=new TextEncoder;static text(z,pe=T.Mimes.text){const Ae=Gt.#e.encode(String(z));return new Gt(Ae,pe)}static json(z,pe="text/x-json"){const Ae=JSON.stringify(z,void 0,"	");return Gt.text(Ae,pe)}constructor(z,pe){this.data=z,this.mime=pe;const Ae=(0,T.normalizeMimeType)(pe,!0);if(!Ae)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ae}}e.NotebookCellOutputItem=Gt;class ui{static isNotebookCellOutput(z){return z instanceof ui?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,pe=!1){const Ae=new Set,Ke=new Set;for(let tt=0;tt<z.length;tt++){const at=z[tt],ht=(0,T.normalizeMimeType)(at.mime);if(!Ae.has(ht)||(0,D.isTextStreamMime)(ht)){Ae.add(ht);continue}Ke.add(tt),pe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?z:z.filter((tt,at)=>!Ke.has(at))}constructor(z,pe,Ae){this.items=ui.ensureUniqueMimeTypes(z,!0),typeof pe=="string"?(this.id=pe,this.metadata=Ae):(this.id=(0,P.generateUuid)(),this.metadata=pe??Ae)}}e.NotebookCellOutput=ui;var Fi;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Fi||(e.NotebookCellKind=Fi={}));var Be;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Be||(e.NotebookCellExecutionState=Be={}));var Jt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Jt||(e.NotebookCellStatusBarAlignment=Jt={}));var Oi;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Oi||(e.NotebookEditorRevealType=Oi={}));class mt{constructor(z,pe){this.text=z,this.alignment=pe}}e.NotebookCellStatusBarItem=mt;var Ji;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Ji||(e.NotebookControllerAffinity=Ji={}));var Zi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(Zi||(e.NotebookControllerAffinity2=Zi={}));class en{constructor(z,pe=[]){this.uri=z,this.provides=(0,C.asArray)(pe)}}e.NotebookRendererScript=en;class hn{constructor(z){this.label=z}}e.NotebookKernelSourceAction=hn;let di=class{constructor(z,pe){this.label=z,this.timestamp=pe}};e.TimelineItem=di,e.TimelineItem=di=qe([R],di);var tn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(z,pe){this.ranges=z,this.wordPattern=pe}}e.LinkedEditingRanges=sn;class fn{constructor(z){this._autoForwardAction=z}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=fn;var on;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Mi=class{constructor(z=void 0,pe=void 0,Ae=void 0,Ke=!1){this.include=z,this.exclude=pe,this.profile=Ae,this.continuous=Ke}};e.TestRunRequest=Mi,e.TestRunRequest=Mi=qe([R],Mi);let Ni=h=class{static diff(z,pe,Ae){const Ke=new h(z);return Ke.expectedOutput=pe,Ke.actualOutput=Ae,Ke}constructor(z){this.message=z}};e.TestMessage=Ni,e.TestMessage=Ni=h=qe([R],Ni);let xi=class{constructor(z){this.id=z}};e.TestTag=xi,e.TestTag=xi=qe([R],xi);let hi=class{constructor(z,pe){this.covered=z,this.total=pe}};e.CoveredCount=hi,e.CoveredCount=hi=qe([R],hi);let Ui=E=class{static fromDetails(z,pe){const Ae=new hi(0,0),Ke=new hi(0,0),tt=new hi(0,0);for(const ht of pe)if("branches"in ht){Ae.total+=1,Ae.covered+=ht.executionCount>0?1:0;for(const Ut of ht.branches)Ke.total+=1,Ke.covered+=Ut.executionCount>0?1:0}else tt.total+=1,tt.covered+=ht.executionCount>0?1:0;const at=new E(z,Ae,Ke.total>0?Ke:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=pe,at}constructor(z,pe,Ae,Ke){this.uri=z,this.statementCoverage=pe,this.branchCoverage=Ae,this.functionCoverage=Ke}};e.FileCoverage=Ui,e.FileCoverage=Ui=E=qe([R],Ui);let Bi=class{constructor(z,pe,Ae=[]){this.executionCount=z,this.location=pe,this.branches=Ae}};e.StatementCoverage=Bi,e.StatementCoverage=Bi=qe([R],Bi);let ge=class{constructor(z,pe){this.executionCount=z,this.location=pe}};e.BranchCoverage=ge,e.BranchCoverage=ge=qe([R],ge);let _e=class{constructor(z,pe){this.executionCount=z,this.location=pe}};e.FunctionCoverage=_e,e.FunctionCoverage=_e=qe([R],_e);var Ne;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Ne||(e.ExternalUriOpenerPriority=Ne={}));var st;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(st||(e.WorkspaceTrustState=st={}));var wt;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(wt||(e.PortAutoForwardAction=wt={}));class Ft{constructor(z,pe,Ae,Ke,tt,at){this.kind=z,this.name=pe,this.detail=Ae,this.uri=Ke,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=Ft;class Sn{constructor(z){this.uri=z}}e.TextTabInput=Sn;class yn{constructor(z,pe){this.original=z,this.modified=pe}}e.TextDiffTabInput=yn;class _n{constructor(z,pe,Ae,Ke){this.base=z,this.input1=pe,this.input2=Ae,this.result=Ke}}e.TextMergeTabInput=_n;class Cn{constructor(z,pe){this.uri=z,this.viewType=pe}}e.CustomEditorTabInput=Cn;class Dn{constructor(z){this.viewType=z}}e.WebviewEditorTabInput=Dn;class In{constructor(z,pe){this.uri=z,this.notebookType=pe}}e.NotebookEditorTabInput=In;class kn{constructor(z,pe,Ae){this.original=z,this.modified=pe,this.notebookType=Ae}}e.NotebookDiffEditorTabInput=kn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class Tn{constructor(z,pe){this.uri=z,this.inputBoxUri=pe}}e.InteractiveWindowInput=Tn;var mn;(function(j){j[j.Up=1]="Up",j[j.Down=2]="Down"})(mn||(e.InteractiveSessionVoteDirection=mn={}));var gn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(gn||(e.InteractiveSessionCopyKind=gn={}));var pn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})(pn||(e.InteractiveEditorResponseFeedbackKind=pn={}));var vn;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(vn||(e.ChatMessageRole=vn={}));var En;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class An{constructor(z,pe){this.role=z,this.content=pe}}e.ChatMessage=An;var bn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(bn||(e.RelatedInformationType=bn={}))}),define(Ce[139],De([1,0,54,16,15,168,122,7,18]),function(me,e,C,L,d,A,T,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const g=new Map;function P(D,y){y?g.set(D,y):g.delete(D)}e.setWordDefinitionFor=P;function k(D){return g.get(D)}class p extends A.MirrorTextModel{constructor(y,n,o,a,m,b,I,t){super(n,o,a,m),this._proxy=y,this._languageId=b,this._isDirty=I,this.notebook=t,this._isDisposed=!1}dispose(){(0,C.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(y){return(0,w.equals)(this._lines,y)}get document(){if(!this._document){const y=this;this._document={get uri(){return y._uri},get fileName(){return y._uri.fsPath},get isUntitled(){return y._uri.scheme===L.Schemas.untitled},get languageId(){return y._languageId},get version(){return y._versionId},get isClosed(){return y._isDisposed},get isDirty(){return y._isDirty},save(){return y._save()},getText(n){return n?y._getTextInRange(n):y.getText()},get eol(){return y._eol===`
`?f.EndOfLine.LF:f.EndOfLine.CRLF},get lineCount(){return y._lines.length},lineAt(n){return y._lineAt(n)},offsetAt(n){return y._offsetAt(n)},positionAt(n){return y._positionAt(n)},validateRange(n){return y._validateRange(n)},validatePosition(n){return y._validatePosition(n)},getWordRangeAtPosition(n,o){return y._getWordRangeAtPosition(n,o)}}}return Object.freeze(this._document)}_acceptLanguageId(y){(0,C.ok)(!this._isDisposed),this._languageId=y}_acceptIsDirty(y){(0,C.ok)(!this._isDisposed),this._isDirty=y}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(y){const n=this._validateRange(y);if(n.isEmpty)return"";if(n.isSingleLine)return this._lines[n.start.line].substring(n.start.character,n.end.character);const o=this._eol,a=n.start.line,m=n.end.line,b=[];b.push(this._lines[a].substring(n.start.character));for(let I=a+1;I<m;I++)b.push(this._lines[I]);return b.push(this._lines[m].substring(0,n.end.character)),b.join(o)}_lineAt(y){let n;if(y instanceof f.Position?n=y.line:typeof y=="number"&&(n=y),typeof n!="number"||n<0||n>=this._lines.length||Math.floor(n)!==n)throw new Error("Illegal value for `line`");return new _(n,this._lines[n],n===this._lines.length-1)}_offsetAt(y){return y=this._validatePosition(y),this._ensureLineStarts(),this._lineStarts.getPrefixSum(y.line-1)+y.character}_positionAt(y){y=Math.floor(y),y=Math.max(0,y),this._ensureLineStarts();const n=this._lineStarts.getIndexOf(y),o=this._lines[n.index].length;return new f.Position(n.index,Math.min(n.remainder,o))}_validateRange(y){if(!(y instanceof f.Range))throw new Error("Invalid argument");const n=this._validatePosition(y.start),o=this._validatePosition(y.end);return n===y.start&&o===y.end?y:new f.Range(n.line,n.character,o.line,o.character)}_validatePosition(y){if(!(y instanceof f.Position))throw new Error("Invalid argument");if(this._lines.length===0)return y.with(0,0);let{line:n,character:o}=y,a=!1;if(n<0)n=0,o=0,a=!0;else if(n>=this._lines.length)n=this._lines.length-1,o=this._lines[n].length,a=!0;else{const m=this._lines[n].length;o<0?(o=0,a=!0):o>m&&(o=m,a=!0)}return a?new f.Position(n,o):y}_getWordRangeAtPosition(y,n){const o=this._validatePosition(y);if(!n)n=k(this._languageId);else if((0,d.regExpLeadsToEndlessLoop)(n))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${n.source}' because it matches the empty string.`);const a=(0,T.getWordAtText)(o.character+1,(0,T.ensureValidWordDefinition)(n),this._lines[o.line],0);if(a)return new f.Range(o.line,a.startColumn-1,o.line,a.endColumn-1)}}e.ExtHostDocumentData=p;class _{constructor(y,n,o){this._line=y,this._text=n,this._isLastLine=o}get lineNumber(){return this._line}get text(){return this._text}get range(){return new f.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new f.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=_}),define(Ce[264],De([1,0,7,20,4]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(f){this._actual=new C.ColorTheme(C.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new d.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(f){let w;switch(f){case"light":w=C.ColorThemeKind.Light;break;case"hcDark":w=C.ColorThemeKind.HighContrast;break;case"hcLight":w=C.ColorThemeKind.HighContrastLight;break;default:w=C.ColorThemeKind.Dark}this._actual=new C.ColorTheme(w),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=A,e.ExtHostTheming=A=qe([$e(0,L.IExtHostRpcService)],A)}),define(Ce[265],De([1,0,6]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(d){d[d.Output=1]="Output",d[d.OutputItems=2]="OutputItems",d[d.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.INotebookExecutionService=(0,C.createDecorator)("INotebookExecutionService")}),define(Ce[63],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(A){A.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var L;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class d{static fromExtHostTestItem(T,f,w=T.parent){if(T._isRoot)return new d([f]);const g=[T.id];for(let P=w;P&&P.id!==f;P=P.parent)g.push(P.id);return g.push(f),new d(g.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const f=T.indexOf("\0");return f===-1?T:T.slice(0,f)}static fromString(T){return new d(T.split("\0"))}static join(T,f){return new d([...T.path,f])}static joinToString(T,f){return T.toString()+"\0"+f}static parentId(T){const f=T.lastIndexOf("\0");return f===-1?void 0:T.slice(0,f)}static localId(T){const f=T.lastIndexOf("\0");return f===-1?T:T.slice(f+1)}static isChild(T,f){return f.startsWith(T)&&f[T.length]==="\0"}static compare(T,f){return T===f?0:d.isChild(T,f)?2:d.isChild(f,T)?3:1}constructor(T,f=T.length){if(this.path=T,this.viewEnd=f,T.length===0||f<1)throw new Error("cannot create test with empty path")}get rootId(){return new d(this.path,1)}get parentId(){return this.viewEnd>1?new d(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new d(this.path,T)}*idsToRoot(){for(let T=this.viewEnd;T>0;T--)yield new d(this.path,T)}compare(T){if(typeof T=="string")return d.compare(this.toString(),T);for(let f=0;f<T.viewEnd&&f<this.viewEnd;f++)if(T.path[f]!==this.path[f])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=d}),define(Ce[87],De([1,0,2,34,63]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var T;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var f;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const w=S=>"runId"in S;e.isStartControllerTests=w;var g;(function(S){S.serialize=l=>({range:l.range.toJSON(),uri:l.uri.toJSON()}),S.deserialize=l=>({range:L.Range.lift(l.range),uri:C.URI.revive(l.uri)})})(g||(e.IRichLocation=g={}));var P;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(P||(e.TestMessageType=P={}));var k;(function(S){S.serialize=l=>({message:l.message,type:0,expected:l.expected,actual:l.actual,contextValue:l.contextValue,location:l.location&&g.serialize(l.location)}),S.deserialize=l=>({message:l.message,type:0,expected:l.expected,actual:l.actual,contextValue:l.contextValue,location:l.location&&g.deserialize(l.location)})})(k||(e.ITestErrorMessage=k={}));const p=(S,l)=>`${l?"s":"e"}${S}`;e.getMarkId=p;var _;(function(S){S.serialize=l=>({message:l.message,type:1,offset:l.offset,length:l.length,location:l.location&&g.serialize(l.location)}),S.deserialize=l=>({message:l.message,type:1,offset:l.offset,length:l.length,location:l.location&&g.deserialize(l.location)})})(_||(e.ITestOutputMessage=_={}));var D;(function(S){S.serialize=l=>l.type===0?k.serialize(l):_.serialize(l),S.deserialize=l=>l.type===0?k.deserialize(l):_.deserialize(l)})(D||(e.ITestMessage=D={}));var y;(function(S){S.serializeWithoutMessages=l=>({state:l.state,duration:l.duration,messages:[]}),S.serialize=l=>({state:l.state,duration:l.duration,messages:l.messages.map(D.serialize)}),S.deserialize=l=>({state:l.state,duration:l.duration,messages:l.messages.map(D.deserialize)})})(y||(e.ITestTaskState=y={}));const n="\0",o=(S,l)=>S+n+l;e.namespaceTestTag=o;const a=S=>{const l=S.indexOf(n);return{ctrlId:S.slice(0,l),tagId:S.slice(l+1)}};e.denamespaceTestTag=a;var m;(function(S){S.serialize=l=>({extId:l.extId,label:l.label,tags:l.tags,busy:l.busy,children:void 0,uri:l.uri?.toJSON(),range:l.range?.toJSON()||null,description:l.description,error:l.error,sortText:l.sortText}),S.deserialize=l=>({extId:l.extId,label:l.label,tags:l.tags,busy:l.busy,children:void 0,uri:l.uri?C.URI.revive(l.uri):void 0,range:l.range?L.Range.lift(l.range):null,description:l.description,error:l.error,sortText:l.sortText})})(m||(e.ITestItem=m={}));var b;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(b||(e.TestItemExpandState=b={}));var I;(function(S){S.serialize=l=>({expand:l.expand,item:m.serialize(l.item)}),S.deserialize=l=>({controllerId:d.TestId.root(l.item.extId),expand:l.expand,item:m.deserialize(l.item)})})(I||(e.InternalTestItem=I={}));var t;(function(S){S.serialize=l=>{let h;return l.item&&(h={},l.item.label!==void 0&&(h.label=l.item.label),l.item.tags!==void 0&&(h.tags=l.item.tags),l.item.busy!==void 0&&(h.busy=l.item.busy),l.item.uri!==void 0&&(h.uri=l.item.uri?.toJSON()),l.item.range!==void 0&&(h.range=l.item.range?.toJSON()),l.item.description!==void 0&&(h.description=l.item.description),l.item.error!==void 0&&(h.error=l.item.error),l.item.sortText!==void 0&&(h.sortText=l.item.sortText)),{extId:l.extId,expand:l.expand,item:h}},S.deserialize=l=>{let h;return l.item&&(h={},l.item.label!==void 0&&(h.label=l.item.label),l.item.tags!==void 0&&(h.tags=l.item.tags),l.item.busy!==void 0&&(h.busy=l.item.busy),l.item.range!==void 0&&(h.range=l.item.range?L.Range.lift(l.item.range):null),l.item.description!==void 0&&(h.description=l.item.description),l.item.error!==void 0&&(h.error=l.item.error),l.item.sortText!==void 0&&(h.sortText=l.item.sortText)),{extId:l.extId,expand:l.expand,item:h}}})(t||(e.ITestItemUpdate=t={}));const r=(S,l)=>{l.expand!==void 0&&(S.expand=l.expand),l.item!==void 0&&(S.item=S.item?Object.assign(S.item,l.item):l.item)};e.applyTestItemUpdate=r;var s;(function(S){S.serializeWithoutMessages=l=>({...I.serialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(y.serializeWithoutMessages)}),S.serialize=l=>({...I.serialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(y.serialize)}),S.deserialize=l=>({...I.deserialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(y.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var i;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(i||(e.DetailType=i={}));var c;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(c||(e.TestDiffOpType=c={}));var u;(function(S){S.deserialize=l=>l.op===0?{op:l.op,item:I.deserialize(l.item)}:l.op===1?{op:l.op,item:t.deserialize(l.item)}:l.op===2?{op:l.op,uri:C.URI.revive(l.uri),docv:l.docv}:l,S.serialize=l=>l.op===0?{op:l.op,item:I.serialize(l.item)}:l.op===1?{op:l.op,item:t.serialize(l.item)}:l})(u||(e.TestsDiffOp=u={}));class v{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(l){const h=this.createChangeCollector();for(const E of l)switch(E.op){case 0:this.add(I.deserialize(E.item),h);break;case 1:this.update(t.deserialize(E.item),h);break;case 3:this.remove(E.itemId,h);break;case 5:this.retireTest(E.itemId);break;case 4:this.updatePendingRoots(E.amount);break;case 6:this._tags.set(E.tag.id,E.tag);break;case 7:this._tags.delete(E.id);break}h.complete?.()}add(l,h){const E=d.TestId.parentId(l.item.extId)?.toString();let R;if(!E)R=this.createItem(l),this.roots.add(R),this.items.set(l.item.extId,R);else if(this.items.has(E)){const M=this.items.get(E);M.children.add(l.item.extId),R=this.createItem(l,M),this.items.set(l.item.extId,R)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(l)}`);return}return h.add?.(R),l.expand===2&&this.busyControllerCount++,R}update(l,h){const E=this.items.get(l.extId);if(E)return l.expand!==void 0&&(E.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(E,l),h.update?.(E),E}remove(l,h){const E=this.items.get(l);if(!E)return;const R=d.TestId.parentId(E.item.extId)?.toString();R?this.items.get(R).children.delete(E.item.extId):this.roots.delete(E);const M=[[l]];for(;M.length;)for(const U of M.pop()){const F=this.items.get(U);F&&(M.push(F.children),this.items.delete(U),h.remove?.(F,F!==E),F.expand===2&&this.busyControllerCount--)}}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=v}),define(Ce[108],De([1,0,13,4,3,54,87,63]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(w||(e.TestItemEventOp=w={}));const g=(a,m)=>a===m,k=Object.entries({range:(a,m)=>a===m?!0:!a||!m?!1:a.equalsRange(m),busy:g,label:g,description:g,error:g,sortText:g,tags:(a,m)=>!(a.length!==m.length||a.some(b=>!m.includes(b)))}),p=(a,m)=>{let b;for(const[I,t]of k)t(a[I],m[I])||(b?b[I]=m[I]:b={[I]:m[I]});return b};class _ extends d.Disposable{get root(){return this.options.root}constructor(m){super(),this.options=m,this.debounceSendDiff=this._register(new C.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(m){this._resolveHandler=m;for(const b of this.tree.values())this.updateExpandability(b)}get resolveHandler(){return this._resolveHandler}collectDiff(){const m=this.diff;return this.diff=[],m}pushDiff(m){switch(m.op){case 2:{for(const b of this.diff)if(b.op===2&&b.uri===m.uri){b.docv=m.docv;return}break}case 1:{const b=this.diff[this.diff.length-1];if(b){if(b.op===1&&b.item.extId===m.item.extId){(0,T.applyTestItemUpdate)(b.item,m.item);return}if(b.op===0&&b.item.item.extId===m.item.extId){(0,T.applyTestItemUpdate)(b.item,m.item);return}}break}}this.diff.push(m),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(m,b){const I=this.tree.get(m);if(I){if((I.expandLevels===void 0||b>I.expandLevels)&&(I.expandLevels=b),I.expand===1){const t=this.resolveChildren(I);return t.isOpen()?this.expandChildren(I,b-1):t.wait().then(()=>this.expandChildren(I,b-1))}else if(I.expand===3)return I.resolveBarrier?.isOpen()===!1?I.resolveBarrier.wait().then(()=>this.expandChildren(I,b-1)):this.expandChildren(I,b-1)}}dispose(){for(const m of this.tree.values())this.options.getApiFor(m.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(m,b){switch(b.op){case 3:this.removeItem(f.TestId.joinToString(m.fullId,b.id));break;case 0:this.upsertItem(b.item,m);break;case 5:for(const I of b.ops)this.onTestItemEvent(m,I);break;case 1:this.diffTagRefs(b.new,b.old,m.fullId.toString());break;case 2:this.updateExpandability(m);break;case 4:this.pushDiff({op:1,item:{extId:m.fullId.toString(),item:b.update}});break;case 6:this.documentSynced(m.actual.uri);break;default:(0,A.assertNever)(b)}}documentSynced(m){m&&this.pushDiff({op:2,uri:m,docv:this.options.getDocumentVersion(m)})}upsertItem(m,b){const I=f.TestId.fromExtHostTestItem(m,this.root.id,b?.actual),t=this.options.getApiFor(m);t.parent&&t.parent!==b?.actual&&this.options.getChildren(t.parent).delete(m.id);let r=this.tree.get(I.toString());if(!r){r={fullId:I,actual:m,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:0},m.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(m,b),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(m)}}),this.connectItemAndChildren(m,r,b);return}if(r.actual===m){this.connectItem(m,r,b);return}if(r.actual.uri?.toString()!==m.uri?.toString())return this.removeItem(I.toString()),this.upsertItem(m,b);const s=this.options.getChildren(r.actual),i=r.actual,c=p(this.options.toITestItem(i),this.options.toITestItem(m));this.options.getApiFor(i).listener=void 0,r.actual=m,r.expand=0,c&&(c.hasOwnProperty("tags")&&(this.diffTagRefs(m.tags,i.tags,I.toString()),delete c.tags),this.onTestItemEvent(r,{op:4,update:c})),this.connectItemAndChildren(m,r,b);for(const[u,v]of s)this.options.getChildren(m).get(v.id)||this.removeItem(f.TestId.joinToString(I,v.id));this.documentSynced(r.actual.uri)}diffTagRefs(m,b,I){const t=new Set(b.map(r=>r.id));for(const r of m)t.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:1,item:{extId:I,item:{tags:m.map(r=>(0,T.namespaceTestTag)(this.options.controllerId,r.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(m){const b=this.tags.get(m.id);b?b.refCount++:(this.tags.set(m.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,m.id)}}))}decrementTagRefs(m){const b=this.tags.get(m);b&&!--b.refCount&&(this.tags.delete(m),this.pushDiff({op:7,id:(0,T.namespaceTestTag)(this.options.controllerId,m)}))}setItemParent(m,b){this.options.getApiFor(m).parent=b&&b.actual!==this.root?b.actual:void 0}connectItem(m,b,I){this.setItemParent(m,I);const t=this.options.getApiFor(m);t.parent=I?.actual,t.listener=r=>this.onTestItemEvent(b,r),this.updateExpandability(b)}connectItemAndChildren(m,b,I){this.connectItem(m,b,I);for(const[t,r]of this.options.getChildren(m))this.upsertItem(r,b)}updateExpandability(m){let b;this._resolveHandler?m.resolveBarrier?b=m.resolveBarrier.isOpen()?3:2:b=m.actual.canResolveChildren?1:0:b=0,b!==m.expand&&(m.expand=b,this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:b}}),b===1&&m.expandLevels!==void 0&&this.resolveChildren(m))}expandChildren(m,b){if(b<0)return;const I=[];for(const[t,r]of this.options.getChildren(m.actual)){const s=this.expand(f.TestId.joinToString(m.fullId,r.id),b);(0,C.isThenable)(s)&&I.push(s)}if(I.length)return Promise.all(I).then(()=>{})}resolveChildren(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this._resolveHandler){const r=new C.Barrier;return r.open(),r}m.expand=2,this.pushExpandStateUpdate(m);const b=m.resolveBarrier=new C.Barrier,I=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let t;try{t=this._resolveHandler(m.actual===this.root?void 0:m.actual)}catch(r){I(r)}return(0,C.isThenable)(t)?t.catch(I).then(()=>{b.open(),this.updateExpandability(m)}):(b.open(),this.updateExpandability(m)),m.resolveBarrier}pushExpandStateUpdate(m){this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:m.expand}})}removeItem(m){const b=this.tree.get(m);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:m});const I=[b];for(;I.length;){const t=I.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(t.fullId.toString());for(const[r,s]of this.options.getChildren(t.actual))I.push(this.tree.get(f.TestId.joinToString(t.fullId,s.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.diffOpEmitter.fire(m)}}e.TestItemCollection=_;class D extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.DuplicateTestItemError=D;class y extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=y;class n extends Error{constructor(m,b,I){super(`TestItem with ID "${m}" is from controller "${b}" and cannot be added as a child of an item from controller "${I}".`)}}e.MixedTestItemController=n;const o=(a,m,b)=>{let I=new Map;return{get size(){return I.size},forEach(t,r){for(const s of I.values())t.call(r,s,this)},[Symbol.iterator](){return I.entries()},replace(t){const r=new Map,s=new Set(I.keys()),i={op:5,ops:[]};for(const c of t){if(!(c instanceof b))throw new y(c.id);const u=m(c).controllerId;if(u!==a.controllerId)throw new n(c.id,u,a.controllerId);if(r.has(c.id))throw new D(c.id);r.set(c.id,c),s.delete(c.id),i.ops.push({op:0,item:c})}for(const c of s.keys())i.ops.push({op:3,id:c});a.listener?.(i),I=r},add(t){if(!(t instanceof b))throw new y(t.id);I.set(t.id,t),a.listener?.({op:0,item:t})},delete(t){I.delete(t)&&a.listener?.({op:3,id:t})},get(t){return I.get(t)},toJSON(){return Array.from(I.values())}}};e.createTestItemChildren=o}),define(Ce[140],De([1,0,108]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const L=new WeakMap,d=(T,f)=>{const w={controllerId:f};return L.set(T,w),w};e.createPrivateApiFor=d;const A=T=>{const f=L.get(T);if(!f)throw new C.InvalidTestItemError(T?.id||"<unknown>");return f};e.getPrivateApiFor=A}),define(Ce[109],De([1,0,16,2]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function d(f,w){return f.scheme===C.Schemas.http||f.scheme===C.Schemas.https?f:(w&&w.authority&&w.isRemote&&f.scheme===C.Schemas.file&&(f=L.URI.from({scheme:C.Schemas.vscodeRemote,authority:w.authority,path:f.path})),L.URI.from({scheme:C.Schemas.https,authority:`${f.scheme}+${A(f.authority)}.${e.webviewRootResourceAuthority}`,path:f.path,fragment:f.fragment,query:f.query}))}e.asWebviewUri=d;function A(f){return f.replace(/./g,w=>{const g=w.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?w:"-"+g.toString(16).padStart(4,"0")})}function T(f){return f.replace(/-([0-9a-f]{4})/g,(w,g)=>String.fromCharCode(parseInt(g,16)))}e.decodeAuthority=T}),define(Ce[266],De([1,0,4,3,109]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(f,w,g){this._proxy=f,this._editors=w,this._remoteInfo=g,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(w.onDidChangeVisibleTextEditors(()=>{const P=w.getVisibleTextEditors();for(const k of this._insets.values())P.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(f=>f.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(f,w,g,P,k){let p;for(const m of this._editors.getVisibleTextEditors(!0))if(m.value===f){p=m;break}if(!p)throw new Error("not a visible editor");const _=this,D=this._handlePool++,y=new C.Emitter,n=new C.Emitter,o=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(m){return(0,d.asWebviewUri)(m,_._remoteInfo)}get cspSource(){return d.webviewGenericCspSource}set options(m){this._options=m,_._proxy.$setOptions(D,m)}get options(){return this._options}set html(m){this._html=m,_._proxy.$setHtml(D,m)}get html(){return this._html}get onDidReceiveMessage(){return y.event}postMessage(m){return _._proxy.$postMessage(D,m)}},a=new class{constructor(){this.editor=f,this.line=w,this.height=g,this.webview=o,this.onDidDispose=n.event}dispose(){_._insets.has(D)&&(_._insets.delete(D),_._proxy.$disposeEditorInset(D),n.fire(),n.dispose(),y.dispose())}};return this._proxy.$createEditorInset(D,p.id,p.value.document.uri,w+1,g,P||{},k.identifier,k.extensionLocation),this._insets.set(D,{editor:f,inset:a,onDidReceiveMessage:y}),a}$onDidDispose(f){const w=this._insets.get(f);w&&w.inset.dispose()}$onDidReceiveMessage(f,w){this._insets.get(f)?.onDidReceiveMessage.fire(w)}}e.ExtHostEditorInsets=A}),define(Ce[267],De([1,0,6]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,C.createDecorator)("configurationResolverService");var L;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(L||(e.VariableKind=L={}));class d extends Error{constructor(T,f){super(f),this.variable=T}}e.VariableError=d}),define(Ce[268],De([1,0,14,41,19,23,9,126,217,267,15]),function(me,e,C,L,d,A,T,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(_,D,y,n){this._contributedVariables=new Map,this._context=_,this._labelService=D,this._userHomePromise=y,n&&(this._envVariablesPromise=n.then(o=>this.prepareEnv(o)))}prepareEnv(_){if(T.isWindows){const D=Object.create(null);return Object.keys(_).forEach(y=>{D[y.toLowerCase()]=_[y]}),D}return _}resolveWithEnvironment(_,D,y){return this.recursiveResolve({env:this.prepareEnv(_),userHome:void 0},D?D.uri:void 0,y)}async resolveAsync(_,D){const y={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(y,_?_.uri:void 0,D)}async resolveAnyBase(_,D,y,n){const o=A.deepClone(D);T.isWindows&&o.windows?Object.keys(o.windows).forEach(m=>o[m]=o.windows[m]):T.isMacintosh&&o.osx?Object.keys(o.osx).forEach(m=>o[m]=o.osx[m]):T.isLinux&&o.linux&&Object.keys(o.linux).forEach(m=>o[m]=o.linux[m]),delete o.windows,delete o.osx,delete o.linux;const a={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(a,_?_.uri:void 0,o,y,n)}async resolveAnyAsync(_,D,y){return this.resolveAnyBase(_,D,y)}async resolveAnyMap(_,D,y){const n=new Map;return{newConfig:await this.resolveAnyBase(_,D,y,n),resolvedVariables:n}}resolveWithInteractionReplace(_,D,y,n){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,D,y,n){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,D){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,D)}async recursiveResolve(_,D,y,n,o){if(d.isString(y))return this.resolveString(_,D,y,n,o);if(Array.isArray(y))return Promise.all(y.map(a=>this.recursiveResolve(_,D,a,n,o)));if(d.isObject(y)){const a=Object.create(null),m=await Promise.all(Object.keys(y).map(async b=>[await this.resolveString(_,D,b,n,o),await this.recursiveResolve(_,D,y[b],n,o)]));for(const[b,I]of m)a[b]=I;return a}return y}resolveString(_,D,y,n,o){return(0,P.replaceAsync)(y,k.VARIABLE_REGEXP,async(a,m)=>{if(m.includes(k.VARIABLE_LHS))return a;let b=await this.evaluateSingleVariable(_,a,m,D,n);return o?.set(m,b),b!==a&&d.isString(b)&&b.match(k.VARIABLE_REGEXP)&&(b=await this.resolveString(_,D,b,n,o)),b})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}async evaluateSingleVariable(_,D,y,n,o){let a;const m=y.split(":");m.length>1&&(y=m[0],a=m[1]);const b=r=>{const s=this._context.getFilePath();if(s)return(0,f.normalizeDriveLetter)(s);throw new g.VariableError(r,(0,w.localize)(0,null,D))},I=r=>{const s=b(r);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return(0,f.normalizeDriveLetter)(i)}throw new g.VariableError(r,(0,w.localize)(1,null,D,C.basename(s)))},t=r=>{if(a){const s=this._context.getFolderUri(a);if(s)return s;throw new g.VariableError(r,(0,w.localize)(2,null,D,a))}if(n)return n;throw this._context.getWorkspaceFolderCount()>1?new g.VariableError(r,(0,w.localize)(3,null,D)):new g.VariableError(r,(0,w.localize)(4,null,D))};switch(y){case"env":if(a){if(_.env){const r=_.env[T.isWindows?a.toLowerCase():a];if(d.isString(r))return r}return""}throw new g.VariableError(g.VariableKind.Env,(0,w.localize)(5,null,D));case"config":if(a){const r=this._context.getConfigurationValue(n,a);if(d.isUndefinedOrNull(r))throw new g.VariableError(g.VariableKind.Config,(0,w.localize)(6,null,D,a));if(d.isObject(r))throw new g.VariableError(g.VariableKind.Config,(0,w.localize)(7,null,D,a));return r}throw new g.VariableError(g.VariableKind.Config,(0,w.localize)(8,null,D));case"command":return this.resolveFromMap(g.VariableKind.Command,D,a,o,"command");case"input":return this.resolveFromMap(g.VariableKind.Input,D,a,o,"input");case"extensionInstallFolder":if(a){const r=await this._context.getExtension(a);if(!r)throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,D,a));return this.fsPath(r.extensionLocation)}throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,D));default:switch(y){case"workspaceRoot":case"workspaceFolder":return(0,f.normalizeDriveLetter)(this.fsPath(t(g.VariableKind.WorkspaceFolder)));case"cwd":return n||a?(0,f.normalizeDriveLetter)(this.fsPath(t(g.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,f.normalizeDriveLetter)(C.basename(this.fsPath(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(_.userHome)return _.userHome;throw new g.VariableError(g.VariableKind.UserHome,(0,w.localize)(11,null,D))}case"lineNumber":{const r=this._context.getLineNumber();if(r)return r;throw new g.VariableError(g.VariableKind.LineNumber,(0,w.localize)(12,null,D))}case"selectedText":{const r=this._context.getSelectedText();if(r)return r;throw new g.VariableError(g.VariableKind.SelectedText,(0,w.localize)(13,null,D))}case"file":return b(g.VariableKind.File);case"fileWorkspaceFolder":return I(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return n||a?C.relative(this.fsPath(t(g.VariableKind.RelativeFile)),b(g.VariableKind.RelativeFile)):b(g.VariableKind.RelativeFile);case"relativeFileDirname":{const r=C.dirname(b(g.VariableKind.RelativeFileDirname));if(n||a){const s=C.relative(this.fsPath(t(g.VariableKind.RelativeFileDirname)),r);return s.length===0?".":s}return r}case"fileDirname":return C.dirname(b(g.VariableKind.FileDirname));case"fileExtname":return C.extname(b(g.VariableKind.FileExtname));case"fileBasename":return C.basename(b(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=C.basename(b(g.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-C.extname(r).length)}case"fileDirnameBasename":return C.basename(C.dirname(b(g.VariableKind.FileDirnameBasename)));case"execPath":{const r=this._context.getExecPath();return r||D}case"execInstallFolder":{const r=this._context.getAppRoot();return r||D}case"pathSeparator":return C.sep;default:try{const r=a?`${y}:${a}`:y;return this.resolveFromMap(g.VariableKind.Unknown,D,r,o,void 0)}catch{return D}}}}resolveFromMap(_,D,y,n,o){if(y&&n){const a=o===void 0?n[y]:n[o+":"+y];if(typeof a=="string")return a;throw new g.VariableError(_,(0,w.localize)(14,null,D))}return D}}e.AbstractVariableResolverService=k}),define(Ce[141],De([1,0,6,137]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,C.createDecorator)("editorGroupsService");var d;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(d||(e.GroupDirection=d={}));var A;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var T;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var f;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EVEN=1]="EVEN",D[D.TOGGLE=2]="TOGGLE"})(f||(e.GroupsArrangement=f={}));var w;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(w||(e.MergeGroupMode=w={}));function g(D){const y=D;return(0,L.isEditorInput)(y?.editor)&&(0,L.isEditorInput)(y?.replacement)}e.isEditorReplacement=g;var P;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var k;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function p(D){const y=D;return!!y&&typeof y.id=="number"&&Array.isArray(y.editors)}e.isEditorGroup=p;function _(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=_}),define(Ce[269],De([1,0,6,141]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,C.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function d(A){const T=A;return typeof A=="number"||(0,L.isEditorGroup)(T)}e.isPreferredGroup=d}),define(Ce[10],De([1,0,18,21,159,71,78,28,155,77,97,23,19,2,34,81,131,140,137,107,63,87,269,7]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m,b,I,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Le){function Fe(te){const{selectionStartLineNumber:Oe,selectionStartColumn:Ve,positionLineNumber:Je,positionColumn:Ge}=te,nt=new r.Position(Oe-1,Ve-1),vt=new r.Position(Je-1,Ge-1);return new r.Selection(nt,vt)}Le.to=Fe;function Te(te){const{anchor:Oe,active:Ve}=te;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Le.from=Te})(s||(e.Selection=s={}));var i;(function(Le){function Fe(te){if(!te)return;const{start:Oe,end:Ve}=te;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Le.from=Fe;function Te(te){if(!te)return;const{startLineNumber:Oe,startColumn:Ve,endLineNumber:Je,endColumn:Ge}=te;return new r.Range(Oe-1,Ve-1,Je-1,Ge-1)}Le.to=Te})(i||(e.Range=i={}));var c;(function(Le){function Fe(Te){switch(Te){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Le.to=Fe})(c||(e.TokenType=c={}));var u;(function(Le){function Fe(te){return new r.Position(te.lineNumber-1,te.column-1)}Le.to=Fe;function Te(te){return{lineNumber:te.line+1,column:te.character+1}}Le.from=Te})(u||(e.Position=u={}));var v;(function(Le){function Fe(Oe,Ve,Je){return(0,C.coalesce)((0,C.asArray)(Oe).map(Ge=>Te(Ge,Ve,Je)))}Le.from=Fe;function Te(Oe,Ve,Je){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:Je?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:te(Oe.scheme,Ve),pattern:Xe.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:Je?.isBuiltin}}function te(Oe,Ve){return Ve&&typeof Oe=="string"?Ve.transformOutgoingScheme(Oe):Oe}})(v||(e.DocumentSelector=v={}));var S;(function(Le){function Fe(te){switch(te){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Le.from=Fe;function Te(te){switch(te){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Le.to=Te})(S||(e.DiagnosticTag=S={}));var l;(function(Le){function Fe(te){let Oe;return te.code&&((0,p.isString)(te.code)||(0,p.isNumber)(te.code)?Oe=String(te.code):Oe={value:String(te.code.value),target:te.code.target}),{...i.from(te.range),message:te.message,source:te.source,code:Oe,severity:E.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(h.from),tags:Array.isArray(te.tags)?(0,C.coalesce)(te.tags.map(S.from)):void 0}}Le.from=Fe;function Te(te){const Oe=new r.Diagnostic(i.to(te),te.message,E.to(te.severity));return Oe.source=te.source,Oe.code=(0,p.isString)(te.code)?te.code:te.code?.value,Oe.relatedInformation=te.relatedInformation&&te.relatedInformation.map(h.to),Oe.tags=te.tags&&(0,C.coalesce)(te.tags.map(S.to)),Oe}Le.to=Te})(l||(e.Diagnostic=l={}));var h;(function(Le){function Fe(te){return{...i.from(te.location.range),message:te.message,resource:te.location.uri}}Le.from=Fe;function Te(te){return new r.DiagnosticRelatedInformation(new r.Location(te.resource,i.to(te)),te.message)}Le.to=Te})(h||(e.DiagnosticRelatedInformation=h={}));var E;(function(Le){function Fe(te){switch(te){case r.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Le.from=Fe;function Te(te){switch(te){case n.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Le.to=Te})(E||(e.DiagnosticSeverity=E={}));var R;(function(Le){function Fe(te){return typeof te=="number"&&te>=r.ViewColumn.One?te-1:te===r.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Le.from=Fe;function Te(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=Te})(R||(e.ViewColumn=R={}));function M(Le){return typeof Le.range<"u"}function U(Le){return Le.length===0?!0:!!M(Le[0])}e.isDecorationOptionsArr=U;var F;(function(Le){function Fe(Ge){return Ge.map(Le.from)}Le.fromMany=Fe;function Te(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function te(Ge){let nt;if(Te(Ge)){const{language:lt,value:gt}=Ge;nt={value:"```"+lt+`
`+gt+"\n```\n"}}else r.MarkdownString.isMarkdownString(Ge)?nt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?nt={value:Ge}:nt={value:""};const vt=Object.create(null);nt.uris=vt;const yt=lt=>{try{let gt=_.URI.parse(lt,!0);gt=gt.with({query:Oe(gt.query,vt)}),vt[lt]=gt}catch{}return""},Et=new w.marked.Renderer;return Et.link=yt,Et.image=lt=>typeof lt=="string"?yt(T.parseHrefAndDimensions(lt).href):"",(0,w.marked)(nt.value,{renderer:Et}),nt}Le.from=te;function Oe(Ge,nt){if(!Ge)return Ge;let vt;try{vt=(0,g.parse)(Ge)}catch{}if(!vt)return Ge;let yt=!1;return vt=(0,k.cloneAndChange)(vt,Et=>{if(_.URI.isUri(Et)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[lt]=Et,yt=!0,lt}else return}),yt?JSON.stringify(vt):Ge}function Ve(Ge){const nt=new r.MarkdownString(Ge.value,Ge.supportThemeIcons);return nt.isTrusted=Ge.isTrusted,nt.supportHtml=Ge.supportHtml,nt.baseUri=Ge.baseUri?_.URI.from(Ge.baseUri):void 0,nt}Le.to=Ve;function Je(Ge){if(Ge)return typeof Ge=="string"?Ge:Le.from(Ge)}Le.fromStrict=Je})(F||(e.MarkdownString=F={}));function x(Le){return U(Le)?Le.map(Fe=>({range:i.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?F.fromMany(Fe.hoverMessage):Fe.hoverMessage?F.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Le.map(Fe=>({range:i.from(Fe)}))}e.fromRangeOrRangeWithMessage=x;function $(Le){return typeof Le>"u"?Le:typeof Le=="string"?_.URI.file(Le):Le}e.pathOrURIToURI=$;var O;(function(Le){function Fe(Te){return typeof Te>"u"?Te:{contentText:Te.contentText,contentIconPath:Te.contentIconPath?$(Te.contentIconPath):void 0,border:Te.border,borderColor:Te.borderColor,fontStyle:Te.fontStyle,fontWeight:Te.fontWeight,textDecoration:Te.textDecoration,color:Te.color,backgroundColor:Te.backgroundColor,margin:Te.margin,width:Te.width,height:Te.height}}Le.from=Fe})(O||(e.ThemableDecorationAttachmentRenderOptions=O={}));var K;(function(Le){function Fe(Te){return typeof Te>"u"?Te:{backgroundColor:Te.backgroundColor,outline:Te.outline,outlineColor:Te.outlineColor,outlineStyle:Te.outlineStyle,outlineWidth:Te.outlineWidth,border:Te.border,borderColor:Te.borderColor,borderRadius:Te.borderRadius,borderSpacing:Te.borderSpacing,borderStyle:Te.borderStyle,borderWidth:Te.borderWidth,fontStyle:Te.fontStyle,fontWeight:Te.fontWeight,textDecoration:Te.textDecoration,cursor:Te.cursor,color:Te.color,opacity:Te.opacity,letterSpacing:Te.letterSpacing,gutterIconPath:Te.gutterIconPath?$(Te.gutterIconPath):void 0,gutterIconSize:Te.gutterIconSize,overviewRulerColor:Te.overviewRulerColor,before:Te.before?O.from(Te.before):void 0,after:Te.after?O.from(Te.after):void 0}}Le.from=Fe})(K||(e.ThemableDecorationRenderOptions=K={}));var q;(function(Le){function Fe(Te){if(typeof Te>"u")return Te;switch(Te){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Fe})(q||(e.DecorationRangeBehavior=q={}));var fe;(function(Le){function Fe(Te){return{isWholeLine:Te.isWholeLine,rangeBehavior:Te.rangeBehavior?q.from(Te.rangeBehavior):void 0,overviewRulerLane:Te.overviewRulerLane,light:Te.light?K.from(Te.light):void 0,dark:Te.dark?K.from(Te.dark):void 0,backgroundColor:Te.backgroundColor,outline:Te.outline,outlineColor:Te.outlineColor,outlineStyle:Te.outlineStyle,outlineWidth:Te.outlineWidth,border:Te.border,borderColor:Te.borderColor,borderRadius:Te.borderRadius,borderSpacing:Te.borderSpacing,borderStyle:Te.borderStyle,borderWidth:Te.borderWidth,fontStyle:Te.fontStyle,fontWeight:Te.fontWeight,textDecoration:Te.textDecoration,cursor:Te.cursor,color:Te.color,opacity:Te.opacity,letterSpacing:Te.letterSpacing,gutterIconPath:Te.gutterIconPath?$(Te.gutterIconPath):void 0,gutterIconSize:Te.gutterIconSize,overviewRulerColor:Te.overviewRulerColor,before:Te.before?O.from(Te.before):void 0,after:Te.after?O.from(Te.after):void 0}}Le.from=Fe})(fe||(e.DecorationRenderOptions=fe={}));var se;(function(Le){function Fe(te){return{text:te.newText,eol:te.newEol&&et.from(te.newEol),range:i.from(te.range)}}Le.from=Fe;function Te(te){const Oe=new r.TextEdit(i.to(te.range),te.text);return Oe.newEol=typeof te.eol>"u"?void 0:et.to(te.eol),Oe}Le.to=Te})(se||(e.TextEdit=se={}));var ie;(function(Le){function Fe(te,Oe){const Ve={edits:[]};if(te instanceof r.WorkspaceEdit){const Je=new f.ResourceSet;for(const Ge of te._allEntries())Ge._type===1&&_.URI.isUri(Ge.to)&&Ge.from===void 0&&Je.add(Ge.to);for(const Ge of te._allEntries())if(Ge._type===1){let nt;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?nt={type:"base64",value:(0,L.encodeBase64)(L.VSBuffer.wrap(Ge.options.contents))}:nt={type:"dataTransferItem",id:Ge.options.contents._itemId}),Ve.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:nt},metadata:Ge.metadata})}else Ge._type===2?Ve.edits.push({resource:Ge.uri,textEdit:se.from(Ge.edit),versionId:Je.has(Ge.uri)?void 0:Oe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Ve.edits.push({resource:Ge.uri,textEdit:{range:i.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Je.has(Ge.uri)?void 0:Oe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(ot.from)}})}return Ve}Le.from=Fe;function Te(te){const Oe=new r.WorkspaceEdit,Ve=new f.ResourceMap;for(const Je of te.edits)if(Je.textEdit){const Ge=Je,nt=_.URI.revive(Ge.resource),vt=i.to(Ge.textEdit.range),yt=Ge.textEdit.text,Et=Ge.textEdit.insertAsSnippet;let lt;Et?lt=r.SnippetTextEdit.replace(vt,new r.SnippetString(yt)):lt=r.TextEdit.replace(vt,yt);const gt=Ve.get(nt);gt?gt.push(lt):Ve.set(nt,[lt])}else Oe.renameFile(_.URI.revive(Je.oldResource),_.URI.revive(Je.newResource),Je.options);for(const[Je,Ge]of Ve)Oe.set(Je,Ge);return Oe}Le.to=Te})(ie||(e.WorkspaceEdit=ie={}));var H;(function(Le){const Fe=Object.create(null);Fe[r.SymbolKind.File]=0,Fe[r.SymbolKind.Module]=1,Fe[r.SymbolKind.Namespace]=2,Fe[r.SymbolKind.Package]=3,Fe[r.SymbolKind.Class]=4,Fe[r.SymbolKind.Method]=5,Fe[r.SymbolKind.Property]=6,Fe[r.SymbolKind.Field]=7,Fe[r.SymbolKind.Constructor]=8,Fe[r.SymbolKind.Enum]=9,Fe[r.SymbolKind.Interface]=10,Fe[r.SymbolKind.Function]=11,Fe[r.SymbolKind.Variable]=12,Fe[r.SymbolKind.Constant]=13,Fe[r.SymbolKind.String]=14,Fe[r.SymbolKind.Number]=15,Fe[r.SymbolKind.Boolean]=16,Fe[r.SymbolKind.Array]=17,Fe[r.SymbolKind.Object]=18,Fe[r.SymbolKind.Key]=19,Fe[r.SymbolKind.Null]=20,Fe[r.SymbolKind.EnumMember]=21,Fe[r.SymbolKind.Struct]=22,Fe[r.SymbolKind.Event]=23,Fe[r.SymbolKind.Operator]=24,Fe[r.SymbolKind.TypeParameter]=25;function Te(Oe){return typeof Fe[Oe]=="number"?Fe[Oe]:6}Le.from=Te;function te(Oe){for(const Ve in Fe)if(Fe[Ve]===Oe)return Number(Ve);return r.SymbolKind.Property}Le.to=te})(H||(e.SymbolKind=H={}));var re;(function(Le){function Fe(te){switch(te){case r.SymbolTag.Deprecated:return 1}}Le.from=Fe;function Te(te){switch(te){case 1:return r.SymbolTag.Deprecated}}Le.to=Te})(re||(e.SymbolTag=re={}));var Ee;(function(Le){function Fe(te){return{name:te.name,kind:H.from(te.kind),tags:te.tags&&te.tags.map(re.from),containerName:te.containerName,location:W.from(te.location)}}Le.from=Fe;function Te(te){const Oe=new r.SymbolInformation(te.name,H.to(te.kind),te.containerName,W.to(te.location));return Oe.tags=te.tags&&te.tags.map(re.to),Oe}Le.to=Te})(Ee||(e.WorkspaceSymbol=Ee={}));var ae;(function(Le){function Fe(te){const Oe={name:te.name||"!!MISSING: name!!",detail:te.detail,range:i.from(te.range),selectionRange:i.from(te.selectionRange),kind:H.from(te.kind),tags:te.tags?.map(re.from)??[]};return te.children&&(Oe.children=te.children.map(Fe)),Oe}Le.from=Fe;function Te(te){const Oe=new r.DocumentSymbol(te.name,te.detail,H.to(te.kind),i.to(te.range),i.to(te.selectionRange));return(0,C.isNonEmptyArray)(te.tags)&&(Oe.tags=te.tags.map(re.to)),te.children&&(Oe.children=te.children.map(Te)),Oe}Le.to=Te})(ae||(e.DocumentSymbol=ae={}));var ne;(function(Le){function Fe(te){const Oe=new r.CallHierarchyItem(H.to(te.kind),te.name,te.detail||"",_.URI.revive(te.uri),i.to(te.range),i.to(te.selectionRange));return Oe._sessionId=te._sessionId,Oe._itemId=te._itemId,Oe}Le.to=Fe;function Te(te,Oe,Ve){if(Oe=Oe??te._sessionId,Ve=Ve??te._itemId,Oe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ve,name:te.name,detail:te.detail,kind:H.from(te.kind),uri:te.uri,range:i.from(te.range),selectionRange:i.from(te.selectionRange),tags:te.tags?.map(re.from)}}Le.from=Te})(ne||(e.CallHierarchyItem=ne={}));var J;(function(Le){function Fe(Te){return new r.CallHierarchyIncomingCall(ne.to(Te.from),Te.fromRanges.map(te=>i.to(te)))}Le.to=Fe})(J||(e.CallHierarchyIncomingCall=J={}));var N;(function(Le){function Fe(Te){return new r.CallHierarchyOutgoingCall(ne.to(Te.to),Te.fromRanges.map(te=>i.to(te)))}Le.to=Fe})(N||(e.CallHierarchyOutgoingCall=N={}));var W;(function(Le){function Fe(te){return{range:te.range&&i.from(te.range),uri:te.uri}}Le.from=Fe;function Te(te){return new r.Location(_.URI.revive(te.uri),i.to(te.range))}Le.to=Te})(W||(e.location=W={}));var he;(function(Le){function Fe(te){const Oe=te,Ve=te;return{originSelectionRange:Oe.originSelectionRange?i.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Ve.uri,range:i.from(Oe.targetRange?Oe.targetRange:Ve.range),targetSelectionRange:Oe.targetSelectionRange?i.from(Oe.targetSelectionRange):void 0}}Le.from=Fe;function Te(te){return{targetUri:_.URI.revive(te.uri),targetRange:i.to(te.range),targetSelectionRange:te.targetSelectionRange?i.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?i.to(te.originSelectionRange):void 0}}Le.to=Te})(he||(e.DefinitionLink=he={}));var Se;(function(Le){function Fe(te){return{range:i.from(te.range),contents:F.fromMany(te.contents)}}Le.from=Fe;function Te(te){return new r.Hover(te.contents.map(F.to),i.to(te.range))}Le.to=Te})(Se||(e.Hover=Se={}));var be;(function(Le){function Fe(te){return{range:i.from(te.range),expression:te.expression}}Le.from=Fe;function Te(te){return new r.EvaluatableExpression(i.to(te.range),te.expression)}Le.to=Te})(be||(e.EvaluatableExpression=be={}));var we;(function(Le){function Fe(te){if(te instanceof r.InlineValueText)return{type:"text",range:i.from(te.range),text:te.text};if(te instanceof r.InlineValueVariableLookup)return{type:"variable",range:i.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:i.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Fe;function Te(te){switch(te.type){case"text":return{range:i.to(te.range),text:te.text};case"variable":return{range:i.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:i.to(te.range),expression:te.expression}}}Le.to=Te})(we||(e.InlineValue=we={}));var ye;(function(Le){function Fe(te){return{frameId:te.frameId,stoppedLocation:i.from(te.stoppedLocation)}}Le.from=Fe;function Te(te){return new r.InlineValueContext(te.frameId,i.to(te.stoppedLocation))}Le.to=Te})(ye||(e.InlineValueContext=ye={}));var V;(function(Le){function Fe(te){return{range:i.from(te.range),kind:te.kind}}Le.from=Fe;function Te(te){return new r.DocumentHighlight(i.to(te.range),te.kind)}Le.to=Te})(V||(e.DocumentHighlight=V={}));var ee;(function(Le){function Fe(Te){switch(Te){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Le.to=Fe})(ee||(e.CompletionTriggerKind=ee={}));var G;(function(Le){function Fe(Te){return{triggerKind:ee.to(Te.triggerKind),triggerCharacter:Te.triggerCharacter}}Le.to=Fe})(G||(e.CompletionContext=G={}));var Y;(function(Le){function Fe(te){switch(te){case r.CompletionItemTag.Deprecated:return 1}}Le.from=Fe;function Te(te){switch(te){case 1:return r.CompletionItemTag.Deprecated}}Le.to=Te})(Y||(e.CompletionItemTag=Y={}));var de;(function(Le){const Fe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Te(Ve){return Fe.get(Ve)??9}Le.from=Te;const te=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Oe(Ve){return te.get(Ve)??r.CompletionItemKind.Property}Le.to=Oe})(de||(e.CompletionItemKind=de={}));var ke;(function(Le){function Fe(Te,te){const Oe=new r.CompletionItem(Te.label);return Oe.insertText=Te.insertText,Oe.kind=de.to(Te.kind),Oe.tags=Te.tags?.map(Y.to),Oe.detail=Te.detail,Oe.documentation=T.isMarkdownString(Te.documentation)?F.to(Te.documentation):Te.documentation,Oe.sortText=Te.sortText,Oe.filterText=Te.filterText,Oe.preselect=Te.preselect,Oe.commitCharacters=Te.commitCharacters,D.Range.isIRange(Te.range)?Oe.range=i.to(Te.range):typeof Te.range=="object"&&(Oe.range={inserting:i.to(Te.range.insert),replacing:i.to(Te.range.replace)}),Oe.keepWhitespace=typeof Te.insertTextRules>"u"?!1:!!(Te.insertTextRules&1),typeof Te.insertTextRules<"u"&&Te.insertTextRules&4?Oe.insertText=new r.SnippetString(Te.insertText):(Oe.insertText=Te.insertText,Oe.textEdit=Oe.range instanceof r.Range?new r.TextEdit(Oe.range,Oe.insertText):void 0),Te.additionalTextEdits&&Te.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Te.additionalTextEdits.map(Ve=>se.to(Ve))),Oe.command=te&&Te.command?te.fromInternal(Te.command):void 0,Oe}Le.to=Fe})(ke||(e.CompletionItem=ke={}));var B;(function(Le){function Fe(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:F.fromStrict(te.documentation)}}Le.from=Fe;function Te(te){return{label:te.label,documentation:T.isMarkdownString(te.documentation)?F.to(te.documentation):te.documentation}}Le.to=Te})(B||(e.ParameterInformation=B={}));var X;(function(Le){function Fe(te){return{label:te.label,documentation:F.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(B.from):[],activeParameter:te.activeParameter}}Le.from=Fe;function Te(te){return{label:te.label,documentation:T.isMarkdownString(te.documentation)?F.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(B.to):[],activeParameter:te.activeParameter}}Le.to=Te})(X||(e.SignatureInformation=X={}));var Z;(function(Le){function Fe(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(X.from):[]}}Le.from=Fe;function Te(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(X.to):[]}}Le.to=Te})(Z||(e.SignatureHelp=Z={}));var oe;(function(Le){function Fe(Te,te){const Oe=new r.InlayHint(u.to(te.position),typeof te.label=="string"?te.label:te.label.map(Q.to.bind(void 0,Te)),te.kind&&ue.to(te.kind));return Oe.textEdits=te.textEdits&&te.textEdits.map(se.to),Oe.tooltip=T.isMarkdownString(te.tooltip)?F.to(te.tooltip):te.tooltip,Oe.paddingLeft=te.paddingLeft,Oe.paddingRight=te.paddingRight,Oe}Le.to=Fe})(oe||(e.InlayHint=oe={}));var Q;(function(Le){function Fe(Te,te){const Oe=new r.InlayHintLabelPart(te.label);return Oe.tooltip=T.isMarkdownString(te.tooltip)?F.to(te.tooltip):te.tooltip,y.Command.is(te.command)&&(Oe.command=Te.fromInternal(te.command)),te.location&&(Oe.location=W.to(te.location)),Oe}Le.to=Fe})(Q||(e.InlayHintLabelPart=Q={}));var ue;(function(Le){function Fe(te){return te}Le.from=Fe;function Te(te){return te}Le.to=Te})(ue||(e.InlayHintKind=ue={}));var ve;(function(Le){function Fe(te){return{range:i.from(te.range),url:te.target,tooltip:te.tooltip}}Le.from=Fe;function Te(te){let Oe;if(te.url)try{Oe=typeof te.url=="string"?_.URI.parse(te.url,!0):_.URI.revive(te.url)}catch{}return new r.DocumentLink(i.to(te.range),Oe)}Le.to=Te})(ve||(e.DocumentLink=ve={}));var xe;(function(Le){function Fe(te){const Oe=new r.ColorPresentation(te.label);return te.textEdit&&(Oe.textEdit=se.to(te.textEdit)),te.additionalTextEdits&&(Oe.additionalTextEdits=te.additionalTextEdits.map(Ve=>se.to(Ve))),Oe}Le.to=Fe;function Te(te){return{label:te.label,textEdit:te.textEdit?se.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Oe=>se.from(Oe)):void 0}}Le.from=Te})(xe||(e.ColorPresentation=xe={}));var We;(function(Le){function Fe(te){return new r.Color(te[0],te[1],te[2],te[3])}Le.to=Fe;function Te(te){return[te.red,te.green,te.blue,te.alpha]}Le.from=Te})(We||(e.Color=We={}));var Ze;(function(Le){function Fe(te){return{range:i.from(te.range)}}Le.from=Fe;function Te(te){return new r.SelectionRange(i.to(te.range))}Le.to=Te})(Ze||(e.SelectionRange=Ze={}));var Qe;(function(Le){function Fe(Te){switch(Te){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Le.to=Fe})(Qe||(e.TextDocumentSaveReason=Qe={}));var it;(function(Le){function Fe(te){switch(te){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Fe;function Te(te){switch(te){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Le.to=Te})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Le){function Fe(te){if(te===r.EndOfLine.CRLF)return 1;if(te===r.EndOfLine.LF)return 0}Le.from=Fe;function Te(te){if(te===1)return r.EndOfLine.CRLF;if(te===0)return r.EndOfLine.LF}Le.to=Te})(et||(e.EndOfLine=et={}));var Pe;(function(Le){function Fe(Te){if(typeof Te=="object")return Te.viewId;switch(Te){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Fe})(Pe||(e.ProgressLocation=Pe={}));var Me;(function(Le){function Fe(te){const Oe={start:te.start+1,end:te.end+1};return te.kind&&(Oe.kind=ze.from(te.kind)),Oe}Le.from=Fe;function Te(te){const Oe={start:te.start-1,end:te.end-1};return te.kind&&(Oe.kind=ze.to(te.kind)),Oe}Le.to=Te})(Me||(e.FoldingRange=Me={}));var ze;(function(Le){function Fe(te){if(te)switch(te){case r.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}Le.from=Fe;function Te(te){if(te)switch(te.value){case y.FoldingRangeKind.Comment.value:return r.FoldingRangeKind.Comment;case y.FoldingRangeKind.Imports.value:return r.FoldingRangeKind.Imports;case y.FoldingRangeKind.Region.value:return r.FoldingRangeKind.Region}}Le.to=Te})(ze||(e.FoldingRangeKind=ze={}));var Re;(function(Le){function Fe(Te){if(Te)return{pinned:typeof Te.preview=="boolean"?!Te.preview:void 0,inactive:Te.background,preserveFocus:Te.preserveFocus,selection:typeof Te.selection=="object"?i.from(Te.selection):void 0,override:typeof Te.override=="boolean"?a.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Le.from=Fe})(Re||(e.TextEditorOpenOptions=Re={}));var Xe;(function(Le){function Fe(Ve){return Ve instanceof r.RelativePattern?Ve.toJSON():typeof Ve=="string"?Ve:Te(Ve)||te(Ve)?new r.RelativePattern(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Le.from=Fe;function Te(Ve){const Je=Ve;return Je?_.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function te(Ve){const Je=Ve;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Oe(Ve){return typeof Ve=="string"?Ve:new r.RelativePattern(_.URI.revive(Ve.baseUri),Ve.pattern)}Le.to=Oe})(Xe||(e.GlobPattern=Xe={}));var le;(function(Le){function Fe(Te){if(Te){if(Array.isArray(Te))return Te.map(Fe);if(typeof Te=="string")return Te;{const te=Te;return{language:te.language,scheme:te.scheme,pattern:Xe.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Le.from=Fe})(le||(e.LanguageSelector=le={}));var ce;(function(Le){function Fe(te){return!!te&&typeof te=="object"&&"selections"in te&&Array.isArray(te.selections)&&te.selections.every(Oe=>Oe instanceof r.Selection)&&"related"in te&&Array.isArray(te.related)&&te.related.every(Oe=>Oe&&typeof Oe=="object"&&_.URI.isUri(Oe.uri)&&Oe.range instanceof r.Range)}Le.is=Fe;function Te(te){return{selections:te.selections.map(Oe=>s.from(Oe)),related:te.related.map(Oe=>({uri:_.URI.from(Oe.uri),range:i.from(Oe.range)}))}}Le.from=Te})(ce||(e.MappedEditsContext=ce={}));var Ie;(function(Le){function Fe(te){return{start:te.start,end:te.end}}Le.from=Fe;function Te(te){return new r.NotebookRange(te.start,te.end)}Le.to=Te})(Ie||(e.NotebookRange=Ie={}));var He;(function(Le){function Fe(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Le.to=Fe;function Te(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Le.from=Te})(He||(e.NotebookCellExecutionSummary=He={}));var Ue;(function(Le){function Fe(Te){if(Te===m.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Te===m.NotebookCellExecutionState.Pending)return;if(Te===m.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Te}`)}Le.to=Fe})(Ue||(e.NotebookCellExecutionState=Ue={}));var Ye;(function(Le){function Fe(te){switch(te){case r.NotebookCellKind.Markup:return m.CellKind.Markup;case r.NotebookCellKind.Code:default:return m.CellKind.Code}}Le.from=Fe;function Te(te){switch(te){case m.CellKind.Markup:return r.NotebookCellKind.Markup;case m.CellKind.Code:default:return r.NotebookCellKind.Code}}Le.to=Te})(Ye||(e.NotebookCellKind=Ye={}));var rt;(function(Le){function Fe(te){const Oe={metadata:te.metadata??Object.create(null),cells:[]};for(const Ve of te.cells)r.NotebookCellData.validate(Ve),Oe.cells.push(ot.from(Ve));return Oe}Le.from=Fe;function Te(te){const Oe=new r.NotebookData(te.cells.map(ot.to));return(0,p.isEmptyObject)(te.metadata)||(Oe.metadata=te.metadata),Oe}Le.to=Te})(rt||(e.NotebookData=rt={}));var ot;(function(Le){function Fe(te){return{cellKind:Ye.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:He.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(It.from):[]}}Le.from=Fe;function Te(te){return new r.NotebookCellData(Ye.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(It.to):void 0,te.metadata,te.internalMetadata?He.to(te.internalMetadata):void 0)}Le.to=Te})(ot||(e.NotebookCellData=ot={}));var pt;(function(Le){function Fe(te){return{mime:te.mime,valueBytes:L.VSBuffer.wrap(te.data)}}Le.from=Fe;function Te(te){return new r.NotebookCellOutputItem(te.valueBytes.buffer,te.mime)}Le.to=Te})(pt||(e.NotebookCellOutputItem=pt={}));var It;(function(Le){function Fe(te){return{outputId:te.id,items:te.items.map(pt.from),metadata:te.metadata}}Le.from=Fe;function Te(te){const Oe=te.items.map(pt.to);return new r.NotebookCellOutput(Oe,te.outputId,te.metadata)}Le.to=Te})(It||(e.NotebookCellOutput=It={}));var Xt;(function(Le){function Fe(Oe){return te(Oe)?{include:Xe.from(Oe.include)??void 0,exclude:Xe.from(Oe.exclude)??void 0}:Xe.from(Oe)??void 0}Le.from=Fe;function Te(Oe){return te(Oe)?{include:Xe.to(Oe.include),exclude:Xe.to(Oe.exclude)}:Xe.to(Oe)}Le.to=Te;function te(Oe){const Ve=Oe;return Ve?!(0,p.isUndefinedOrNull)(Ve.include)&&!(0,p.isUndefinedOrNull)(Ve.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var Wt;(function(Le){function Fe(Te,te,Oe){const Ve=typeof Te.command=="string"?{title:"",command:Te.command}:Te.command;return{alignment:Te.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(Ve,Oe),text:Te.text,tooltip:Te.tooltip,accessibilityInformation:Te.accessibilityInformation,priority:Te.priority}}Le.from=Fe})(Wt||(e.NotebookStatusBarItem=Wt={}));var bt;(function(Le){function Fe(Te,te,Oe){const Ve=typeof Te.command=="string"?{title:"",command:Te.command}:Te.command;return{command:te.toInternal(Ve,Oe),label:Te.label,description:Te.description,detail:Te.detail,documentation:Te.documentation}}Le.from=Fe})(bt||(e.NotebookKernelSourceAction=bt={}));var Ot;(function(Le){function Fe(Te){return{transientOutputs:Te?.transientOutputs??!1,transientCellMetadata:Te?.transientCellMetadata??{},transientDocumentMetadata:Te?.transientDocumentMetadata??{},cellContentMetadata:Te?.cellContentMetadata??{}}}Le.from=Fe})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Nt;(function(Le){function Fe(te){return{uri:te.uri,provides:te.provides}}Le.from=Fe;function Te(te){return new r.NotebookRendererScript(_.URI.revive(te.uri),te.provides)}Le.to=Te})(Nt||(e.NotebookRendererScript=Nt={}));var qt;(function(Le){function Fe(te){return{message:F.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:i.from(te.location.range),uri:te.location.uri}}}Le.from=Fe;function Te(te){const Oe=new r.TestMessage(typeof te.message=="string"?te.message:F.to(te.message));return Oe.actualOutput=te.actual,Oe.expectedOutput=te.expected,Oe.contextValue=te.contextValue,Oe.location=te.location?W.to(te.location):void 0,Oe}Le.to=Te})(qt||(e.TestMessage=qt={}));var At;(function(Le){Le.namespace=I.namespaceTestTag,Le.denamespace=I.denamespaceTestTag})(At||(e.TestTag=At={}));var Rt;(function(Le){function Fe(te){const Oe=(0,o.getPrivateApiFor)(te).controllerId;return{extId:b.TestId.fromExtHostTestItem(te,Oe).toString(),label:te.label,uri:_.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(Ve=>At.namespace(Oe,Ve.id)),range:D.Range.lift(i.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&F.fromStrict(te.error)||null}}Le.from=Fe;function Te(te){return{parent:void 0,error:void 0,id:b.TestId.fromString(te.extId).localId,label:te.label,uri:_.URI.revive(te.uri),tags:(te.tags||[]).map(Oe=>{const{tagId:Ve}=At.denamespace(Oe);return new r.TestTag(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Le.toPlain=Te})(Rt||(e.TestItem=Rt={})),function(Le){function Fe(te){return{id:te.id}}Le.from=Fe;function Te(te){return new r.TestTag(te.id)}Le.to=Te}(At||(e.TestTag=At={}));var xt;(function(Le){const Fe=(te,Oe)=>{const Ve=[];for(const[Ge,nt]of Oe)b.TestId.compare(nt.item.extId,Ge)===2&&(Oe.delete(Ge),Ve.push(nt));const Je={...Rt.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(nt=>nt.type===0).map(qt.to)})),children:Ve.map(Ge=>Fe(Ge,Oe))};for(const Ge of Je.children)Ge.parent=Je;return Je};function Te(te){const Oe=[],Ve=new Map;for(const Je of te.items){Ve.set(Je.item.extId,Je);const Ge=b.TestId.root(Je.item.extId);te.request.targets.some(nt=>nt.controllerId===Ge&&nt.testIds.includes(Je.item.extId))&&Oe.push(Je)}return{completedAt:te.completedAt,results:Oe.map(Je=>Fe(Je,Ve))}}Le.to=Te})(xt||(e.TestResults=xt={}));var Bt;(function(Le){function Fe(Ve){return{covered:Ve.covered,total:Ve.covered}}function Te(Ve){return"line"in Ve?u.from(Ve):i.from(Ve)}function te(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Te(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Je=>({count:Je.executionCount,location:Je.location&&Te(Je.location)})):void 0}:{type:0,count:Ve.executionCount,location:Te(Ve.location)}}Le.fromDetailed=te;function Oe(Ve){return{uri:Ve.uri,statement:Fe(Ve.statementCoverage),branch:Ve.branchCoverage&&Fe(Ve.branchCoverage),function:Ve.functionCoverage&&Fe(Ve.functionCoverage),details:Ve.detailedCoverage?.map(te)}}Le.fromFile=Oe})(Bt||(e.TestCoverage=Bt={}));var Ht;(function(Le){function Fe(Te){switch(Te){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Le.to=Fe})(Ht||(e.CodeActionTriggerKind=Ht={}));var $t;(function(Le){function Fe(te){const Oe=new r.TypeHierarchyItem(H.to(te.kind),te.name,te.detail||"",_.URI.revive(te.uri),i.to(te.range),i.to(te.selectionRange));return Oe._sessionId=te._sessionId,Oe._itemId=te._itemId,Oe}Le.to=Fe;function Te(te,Oe,Ve){if(Oe=Oe??te._sessionId,Ve=Ve??te._itemId,Oe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ve,kind:H.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:i.from(te.range),selectionRange:i.from(te.selectionRange),tags:te.tags?.map(re.from)}}Le.from=Te})($t||(e.TypeHierarchyItem=$t={}));var ct;(function(Le){function Fe(Te){if(Te)return{value:Te.value,tooltip:Te.tooltip}}Le.from=Fe})(ct||(e.ViewBadge=ct={}));var dt;(function(Le){function Fe(Ve,Je,Ge){const nt=Je.fileData;return nt?new r.InternalFileDataTransferItem(new r.DataTransferFile(nt.name,_.URI.revive(nt.uri),nt.id,(0,A.once)(()=>Ge(nt.id)))):Ve===P.Mimes.uriList&&Je.uriListData?new r.InternalDataTransferItem(Oe(Je.uriListData)):new r.InternalDataTransferItem(Je.asString)}Le.to=Fe;async function Te(Ve,Je){const Ge=await Je.asString();if(Ve===P.Mimes.uriList)return{asString:Ge,fileData:void 0,uriListData:te(Ge)};const nt=Je.asFile();return{asString:Ge,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Le.from=Te;function te(Ve){return d.UriList.split(Ve).map(Je=>{if(Je.startsWith("#"))return Je;try{return _.URI.parse(Je)}catch{}return Je})}function Oe(Ve){return d.UriList.create(Ve.map(Je=>typeof Je=="string"?Je:_.URI.revive(Je)))}})(dt||(e.DataTransferItem=dt={}));var jt;(function(Le){function Fe(te,Oe){const Ve=te.items.map(([Je,Ge])=>[Je,dt.to(Je,Ge,Oe)]);return new r.DataTransfer(Ve)}Le.toDataTransfer=Fe;async function Te(te){const Oe={items:[]},Ve=[];for(const[Je,Ge]of te)Ve.push((async()=>{Oe.items.push([Je,await dt.from(Je,Ge)])})());return await Promise.all(Ve),Oe}Le.from=Te})(jt||(e.DataTransfer=jt={}));var Tt;(function(Le){function Fe(te){return{message:te.message,metadata:te.metadata,title:te.title,tooltip:te.tooltip}}Le.to=Fe;function Te(te){return{kind:"reply",message:te.message,metadata:te.metadata,title:te.title,tooltip:te.tooltip}}Le.from=Te})(Tt||(e.ChatReplyFollowup=Tt={}));var _t;(function(Le){function Fe(Te){return typeof Te=="string"?{title:Te,message:Te,kind:"reply"}:"commandId"in Te?{kind:"command",title:Te.title??"",commandId:Te.commandId??"",when:Te.when??"",args:Te.args}:Tt.from(Te)}Le.from=Fe})(_t||(e.ChatFollowup=_t={}));var ft;(function(Le){function Fe(te){const Oe=new r.ChatMessage(kt.to(te.role),te.content);return Oe.name=te.name,Oe}Le.to=Fe;function Te(te){return{role:kt.from(te.role),content:te.content,name:te.name}}Le.from=Te})(ft||(e.ChatMessage=ft={}));var kt;(function(Le){function Fe(te){switch(te){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Le.to=Fe;function Te(te){switch(te){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Le.from=Te})(kt||(e.ChatMessageRole=kt={}));var Mt;(function(Le){function Fe(te){return{level:St.to(te.level),value:te.value,description:te.description}}Le.to=Fe;function Te(te){return{level:St.from(te.level),value:te.value,description:te.description}}Le.from=Te})(Mt||(e.ChatVariable=Mt={}));var St;(function(Le){function Fe(te){switch(te){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Le.to=Fe;function Te(te){switch(te){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Le.from=Te})(St||(e.ChatVariableLevel=St={}));var je;(function(Le){function Fe(Te,te,Oe){return"terminalCommand"in Te?{terminalCommand:Te.terminalCommand}:"uri"in Te?{uri:Te.uri}:te.toInternal(Te,Oe)}Le.from=Fe})(je||(e.TerminalQuickFix=je={}))}),define(Ce[270],De([1,0,2,8,7,10,72]),function(me,e,C,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class f{constructor(g,P,k,p={timeout:1500,errors:3}){this._logService=g,this._documents=P,this._mainThreadBulkEdits=k,this._thresholds=p,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(g){return(P,k,p)=>{const D={dispose:this._callbacks.push([P,k,g])};return Array.isArray(p)&&p.push(D),D}}async $participateInSave(g,P){const k=C.URI.revive(g);let p=!1;const _=setTimeout(()=>p=!0,this._thresholds.timeout),D=[];try{for(const y of[...this._callbacks]){if(p)break;const n=this._documents.getDocument(k),o=await this._deliverEventAsyncAndBlameBadListeners(y,{document:n,reason:A.TextDocumentSaveReason.to(P)});D.push(o)}}finally{clearTimeout(_)}return D}_deliverEventAsyncAndBlameBadListeners([g,P,k],p){const _=this._badListeners.get(g);return typeof _=="number"&&_>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,g,P,p).then(()=>!0,D=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const y=this._badListeners.get(g);this._badListeners.set(g,y?y+1:1),typeof y=="number"&&y>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(g,P,k,p){const _=[],D=Date.now(),{document:y,reason:n}=p,{version:o}=y,a=Object.freeze({document:y,reason:n,waitUntil(m){if(Object.isFrozen(_))throw(0,L.illegalState)("waitUntil can not be called async");_.push(Promise.resolve(m))}});try{P.apply(k,[a])}catch(m){return Promise.reject(m)}return Object.freeze(_),new Promise((m,b)=>{const I=setTimeout(()=>b(new Error("timeout")),this._thresholds.timeout);return Promise.all(_).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(I),m(t)}).catch(t=>{clearTimeout(I),b(t)})}).then(m=>{const b={edits:[]};for(const I of m)if(Array.isArray(I)&&I.every(t=>t instanceof d.TextEdit))for(const{newText:t,newEol:r,range:s}of I)b.edits.push({resource:y.uri,versionId:void 0,textEdit:{range:s&&A.Range.from(s),text:t,eol:r&&A.EndOfLine.from(r)}});if(b.edits.length!==0)return o===y.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(b):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=f}),define(Ce[271],De([1,0,16,2,10,7,107]),function(me,e,C,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class f{constructor(k,p,_,D){this.start=k,this.deletedCount=p,this.deletedItems=_,this.items=D}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class w{static asModelAddData(k,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,p,_){this.notebook=k,this._extHostDocument=p,this._cellData=_,this.handle=_.handle,this.uri=L.URI.revive(_.uri),this.cellKind=_.cellKind,this._outputs=_.outputs.map(d.NotebookCellOutput.to),this._internalMetadata=_.internalMetadata??{},this._metadata=Object.freeze(_.metadata??{}),this._previousResult=Object.freeze(d.NotebookCellExecutionSummary.to(_.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const _={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:d.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return k._mime},set mime(D){k._mime=D},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(_)}return this._apiCell}setOutputs(k){this._outputs=k.map(d.NotebookCellOutput.to)}setOutputItems(k,p,_){const D=_.map(d.NotebookCellOutputItem.to),y=this._outputs.find(n=>n.id===k);if(y&&(p||(y.items.length=0),y.items.push(...D),y.items.length>1&&y.items.every(n=>T.isTextStreamMime(n.mime)))){const n=new Map,o=[];y.items.forEach(a=>{let m;n.has(a.mime)?m=n.get(a.mime):(m=[],n.set(a.mime,m),o.push(a.mime)),m.push(a.data)}),y.items.length=0,o.forEach(a=>{const m=T.compressOutputItemStreams(n.get(a));y.items.push({mime:a,data:m.data.buffer})})}}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(d.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=w;class g{static{this._handlePool=0}constructor(k,p,_,D,y){this._proxy=k,this._textDocumentsAndEditors=p,this._textDocuments=_,this.uri=D,this.handle=g._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=y.viewType,this._metadata=Object.freeze(y.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,y.cells]],!0,void 0),this._versionId=y.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const k=this,p={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===C.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(_){return _=k._validateIndex(_),k._cells[_].apiCell},getCells(_){return(_?k._getCells(_):k._cells).map(y=>y.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(p)}return this._notebook}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,p,_){this._versionId=k.versionId,this._isDirty=p,this.acceptDocumentPropertiesChanged({metadata:_});const D={notebook:this.apiNotebook,metadata:_,cellChanges:[],contentChanges:[]},y=[];for(const o of k.rawEvents)o.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1,D.contentChanges):o.kind===T.NotebookCellsChangeType.Move?this._moveCells(o.index,o.length,o.newIdx,D.contentChanges):o.kind===T.NotebookCellsChangeType.Output?(this._setCellOutputs(o.index,o.outputs),y.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===T.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems),y.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(o.index,o.language),y.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document})):o.kind===T.NotebookCellsChangeType.ChangeCellContent?y.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document}):o.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(o.index,o.metadata),y.push({cell:this._cells[o.index].apiCell,metadata:this._cells[o.index].apiCell.metadata})):o.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(o.index,o.internalMetadata),y.push({cell:this._cells[o.index].apiCell,executionSummary:this._cells[o.index].apiCell.executionSummary}));const n=new Map;for(let o=0;o<y.length;o++){const a=y[o],m=n.get(a.cell);if(m===void 0){const b=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});n.set(a.cell,b-1)}else D.cellChanges[m]={...D.cellChanges[m],...a}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let p=k.start|0,_=k.end|0;return p<0&&(p=0),_>this._cells.length&&(_=this._cells.length),k.with({start:p,end:_})}_getCells(k){k=this._validateRange(k);const p=[];for(let _=k.start;_<k.end;_++)p.push(this._cells[_]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,p,_){if(this._disposed)return;const D=[],y=[],n=[];if(k.reverse().forEach(o=>{const m=o[2].map(t=>{const r=new w(this,this._textDocumentsAndEditors,t);return p||y.push(w.asModelAddData(this.apiNotebook,t)),r}),b=new f(o[0],o[1],[],m),I=this._cells.splice(o[0],o[1],...m);for(const t of I)n.push(t.uri),b.deletedItems.push(t.apiCell);D.push(b)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:y,removedDocuments:n}),_)for(const o of D)_.push(o.asApiEvent())}_moveCells(k,p,_,D){const y=this._cells.splice(k,p);this._cells.splice(_,0,...y);const n=[new f(k,p,y.map(o=>o.apiCell),[]),new f(_,0,[],y)];for(const o of n)D.push(o.asApiEvent())}_setCellOutputs(k,p){this._cells[k].setOutputs(p)}_setCellOutputItems(k,p,_,D){this._cells[k].setOutputItems(p,_,D)}_changeCellLanguage(k,p){const _=this._cells[k];_.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelLanguageChanged(_.uri,p)}_changeCellMime(k,p){const _=this._cells[k];_.apiCell.mime=p}_changeCellMetadata(k,p){this._cells[k].setMetadata(p)}_changeCellInternalMetadata(k,p){this._cells[k].setInternalMetadata(p)}getCellFromApiCell(k){return this._cells.find(p=>p.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(p=>p.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=g}),define(Ce[272],De([1,0,4,2,10,7]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class T{constructor(w,g,P,k={timeout:1500,errors:3}){this._logService=w,this._notebooksAndEditors=g,this._mainThreadBulkEdits=P,this._thresholds=k,this._onWillSaveNotebookDocumentEvent=new C.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(w){return(g,P,k)=>{const p=function(D){g.call(P,D)};return p.extension=w,this._onWillSaveNotebookDocumentEvent.event(p,void 0,k)}}async $participateInSave(w,g,P){const k=L.URI.revive(w),p=this._notebooksAndEditors.getNotebookDocument(k);if(!p)throw new Error("Unable to resolve notebook document");const _=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:p.apiNotebook,reason:d.TextDocumentSaveReason.to(g)},P,async(y,n)=>{const o=Date.now(),a=await await Promise.resolve(y);Date.now()-o>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier),!P.isCancellationRequested&&a&&(a instanceof A.WorkspaceEdit?_.push(a):this._logService.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(_.length===0)return!0;const D={edits:[]};for(const y of _){const{edits:n}=d.WorkspaceEdit.from(y);D.edits=D.edits.concat(n)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(D)}}e.ExtHostNotebookDocumentSaveParticipant=T}),define(Ce[142],De([1,0,8,10,7]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(f,w,g,P,k,p){this.id=f,this._proxy=w,this.notebookData=g,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=k,this._visibleRanges=P,this._viewColumn=p}get apiEditor(){if(!this._editor){const f=this;this._editor={get notebook(){return f.notebookData.apiNotebook},get selection(){return f._selections[0]},set selection(w){this.selections=[w]},get selections(){return f._selections},set selections(w){if(!Array.isArray(w)||!w.every(d.NotebookRange.isNotebookRange))throw(0,C.illegalArgument)("selections");f._selections=w,f._trySetSelections(w)},get visibleRanges(){return f._visibleRanges},revealRange(w,g){f._proxy.$tryRevealRange(f.id,L.NotebookRange.from(w),g??d.NotebookEditorRevealType.Default)},get viewColumn(){return f._viewColumn}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(f){this._visible=f}_acceptVisibleRanges(f){this._visibleRanges=f}_acceptSelections(f){this._selections=f}_trySetSelections(f){this._proxy.$trySetSelections(this.id,f.map(L.NotebookRange.from))}_acceptViewColumn(f){this._viewColumn=f}}e.ExtHostNotebookEditor=A}),define(Ce[273],De([1,0,8,4,17,10]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let T=class{constructor(w,g){this._logService=w,this._notebooksAndEditors=g,this._onDidChangeNotebookEditorSelection=new L.Emitter({onListenerError:C.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new L.Emitter({onListenerError:C.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(w,g){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,g);const P=this._notebooksAndEditors.getEditorById(w);g.visibleRanges&&P._acceptVisibleRanges(g.visibleRanges.ranges.map(A.NotebookRange.to)),g.selections&&P._acceptSelections(g.selections.selections.map(A.NotebookRange.to)),g.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),g.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const g in w)this._notebooksAndEditors.getEditorById(g)._acceptViewColumn(A.ViewColumn.to(w[g]))}};e.ExtHostNotebookEditors=T,e.ExtHostNotebookEditors=T=qe([$e(0,d.ILogService)],T)}),define(Ce[274],De([1,0,10,83,202,22,70,8]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class w{constructor(p){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=p}async withProgress(p,_,D){const y=this._handles++,{title:n,location:o,cancellable:a}=_,m={label:(0,d.localize)(0,null,p.displayName||p.name),id:p.identifier.value};return this._proxy.$startProgress(y,{location:C.ProgressLocation.from(o),title:n,source:m,cancellable:a},p.isUnderDevelopment?void 0:p.identifier.value).catch(f.onUnexpectedExternalError),this._withProgress(y,D,!!a)}_withProgress(p,_,D){let y;D&&(y=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(p,y));const n=a=>{this._proxy.$progressEnd(a),this._mapHandleToCancellationSource.delete(a),y?.dispose()};let o;try{o=_(new P(this._proxy,p),D&&y?y.token:A.CancellationToken.None)}catch(a){throw n(p),a}return o.then(a=>n(p),a=>n(p)),o}$acceptProgressCanceled(p){const _=this._mapHandleToCancellationSource.get(p);_&&(_.cancel(),this._mapHandleToCancellationSource.delete(p))}}e.ExtHostProgress=w;function g(k,p){return k.message=p.message,typeof p.increment=="number"&&(typeof k.increment=="number"?k.increment+=p.increment:k.increment=p.increment),k}class P extends L.Progress{constructor(p,_){super(D=>this.throttledReport(D)),this._proxy=p,this._handle=_}throttledReport(p){this._proxy.$progressReport(this._handle,p)}}qe([(0,T.throttle)(100,(k,p)=>g(k,p),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Ce[143],De([1,0,34,140,63,108,87,10,2]),function(me,e,C,L,d,A,T,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const g=(m,b,I,t)=>{let r=b;return{enumerable:!0,configurable:!1,get(){return r},set(s){if(!I(r,s)){const i=r;r=s,m.listener?.(t(s,i))}}}},P=(m,b)=>m===b,k={range:(m,b)=>m===b?!0:!m||!b?!1:m.isEqual(b),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(m,b)=>!(m.length!==b.length||m.some(I=>!b.find(t=>I.id===t.id)))},p=m=>b=>({op:4,update:m(b)}),_=(m,b)=>({range:(()=>{let I;const t=p(r=>({range:C.Range.lift(f.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return I},set(r){m.listener?.({op:6}),k.range(I,r)||(I=r,m.listener?.(t(r)))}}})(),label:g(m,b,k.label,p(I=>({label:I}))),description:g(m,void 0,k.description,p(I=>({description:I}))),sortText:g(m,void 0,k.sortText,p(I=>({sortText:I}))),canResolveChildren:g(m,!1,k.canResolveChildren,I=>({op:2,state:I})),busy:g(m,!1,k.busy,p(I=>({busy:I}))),error:g(m,void 0,k.error,p(I=>({error:f.MarkdownString.fromStrict(I)||null}))),tags:g(m,[],k.tags,(I,t)=>({op:1,new:I.map(f.TestTag.from),old:t.map(f.TestTag.from)}))}),D=m=>{const b=d.TestId.fromString(m.extId),I=new n(b.controllerId,b.localId,m.label,w.URI.revive(m.uri)||void 0);return I.range=f.Range.to(m.range||void 0),I.description=m.description||void 0,I.sortText=m.sortText||void 0,I.tags=m.tags.map(t=>f.TestTag.to({id:(0,T.denamespaceTestTag)(t).tagId})),I},y=m=>{let b;for(const I of m.tests){const t=D(I.item);(0,L.getPrivateApiFor)(t).parent=b,b=t}return b};e.toItemFromContext=y;class n{constructor(b,I,t,r){if(I.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(I)} symbol`);const s=(0,L.createPrivateApiFor)(this,b);Object.defineProperties(this,{id:{value:I,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof o?void 0:s.parent}},children:{value:(0,A.createTestItemChildren)(s,L.getPrivateApiFor,n),enumerable:!0,writable:!1},..._(s,t)})}}e.TestItemImpl=n;class o extends n{constructor(b,I){super(b,b,I,void 0),this._isRoot=!0}}e.TestItemRootImpl=o;class a extends A.TestItemCollection{constructor(b,I,t){super({controllerId:b,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:L.getPrivateApiFor,getChildren:r=>r.children,root:new o(b,I),toITestItem:f.TestItem.from})}}e.ExtHostTestItemCollection=a}),define(Ce[144],De([1,0,54,8,117,10,7]),function(me,e,C,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class f{static{this._Keys=new d.IdGenerator("TextEditorDecorationType")}constructor(p,_,D){const y=f._Keys.nextId();p.$registerTextEditorDecorationType(_.identifier,y,A.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:y,dispose(){p.$removeTextEditorDecorationType(y)}})}}e.TextEditorDecorationType=f;class w{constructor(p,_){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=p,this._documentVersionId=p.version,this._undoStopBefore=_.undoStopBefore,this._undoStopAfter=_.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(p,_){this._throwIfFinalized();let D=null;if(p instanceof T.Position)D=new T.Range(p,p);else if(p instanceof T.Range)D=p;else throw new Error("Unrecognized location");this._pushEdit(D,_,!1)}insert(p,_){this._throwIfFinalized(),this._pushEdit(new T.Range(p,p),_,!0)}delete(p){this._throwIfFinalized();let _=null;if(p instanceof T.Range)_=p;else throw new Error("Unrecognized location");this._pushEdit(_,null,!0)}_pushEdit(p,_,D){const y=this._document.validateRange(p);this._collectedEdits.push({range:y,text:_,forceMoveMarkers:D})}setEndOfLine(p){if(this._throwIfFinalized(),p!==T.EndOfLine.LF&&p!==T.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=p}}class g{constructor(p,_,D,y){this._proxy=p,this._id=_,this._accept(D),this._logService=y;const n=this;this.value={get tabSize(){return n._tabSize},set tabSize(o){n._setTabSize(o)},get indentSize(){return n._indentSize},set indentSize(o){n._setIndentSize(o)},get insertSpaces(){return n._insertSpaces},set insertSpaces(o){n._setInsertSpaces(o)},get cursorStyle(){return n._cursorStyle},set cursorStyle(o){n._setCursorStyle(o)},get lineNumbers(){return n._lineNumbers},set lineNumbers(o){n._setLineNumbers(o)}}}_accept(p){this._tabSize=p.tabSize,this._indentSize=p.indentSize,this._insertSpaces=p.insertSpaces,this._cursorStyle=p.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(p.lineNumbers)}_validateTabSize(p){if(p==="auto")return"auto";if(typeof p=="number"){const _=Math.floor(p);return _>0?_:null}if(typeof p=="string"){const _=parseInt(p,10);return isNaN(_)?null:_>0?_:null}return null}_setTabSize(p){const _=this._validateTabSize(p);if(_!==null){if(typeof _=="number"){if(this._tabSize===_)return;this._tabSize=_}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:_}))}}_validateIndentSize(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const _=Math.floor(p);return _>0?_:null}if(typeof p=="string"){const _=parseInt(p,10);return isNaN(_)?null:_>0?_:null}return null}_setIndentSize(p){const _=this._validateIndentSize(p);if(_!==null){if(typeof _=="number"){if(this._indentSize===_)return;this._indentSize=_}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:_}))}}_validateInsertSpaces(p){return p==="auto"?"auto":p==="false"?!1:!!p}_setInsertSpaces(p){const _=this._validateInsertSpaces(p);if(typeof _=="boolean"){if(this._insertSpaces===_)return;this._insertSpaces=_}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:_}))}_setCursorStyle(p){this._cursorStyle!==p&&(this._cursorStyle=p,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:p})))}_setLineNumbers(p){this._lineNumbers!==p&&(this._lineNumbers=p,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(p)})))}assign(p){const _={};let D=!1;if(typeof p.tabSize<"u"){const y=this._validateTabSize(p.tabSize);y==="auto"?(D=!0,_.tabSize=y):typeof y=="number"&&this._tabSize!==y&&(this._tabSize=y,D=!0,_.tabSize=y)}if(typeof p.indentSize<"u"){const y=this._validateIndentSize(p.indentSize);y==="tabSize"?(D=!0,_.indentSize=y):typeof y=="number"&&this._indentSize!==y&&(this._indentSize=y,D=!0,_.indentSize=y)}if(typeof p.insertSpaces<"u"){const y=this._validateInsertSpaces(p.insertSpaces);y==="auto"?(D=!0,_.insertSpaces=y):this._insertSpaces!==y&&(this._insertSpaces=y,D=!0,_.insertSpaces=y)}typeof p.cursorStyle<"u"&&this._cursorStyle!==p.cursorStyle&&(this._cursorStyle=p.cursorStyle,D=!0,_.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this._lineNumbers!==p.lineNumbers&&(this._lineNumbers=p.lineNumbers,D=!0,_.lineNumbers=A.TextEditorLineNumbersStyle.from(p.lineNumbers)),D&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,_))}_warnOnError(p,_){_.catch(D=>{this._logService.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this._logService.warn(D)})}}e.ExtHostTextEditorOptions=g;class P{constructor(p,_,D,y,n,o,a,m){this.id=p,this._proxy=_,this._logService=D,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._options=new g(this._proxy,this.id,o,D),this._visibleRanges=a,this._viewColumn=m;const b=this;this.value=Object.freeze({get document(){return y.value},set document(I){throw(0,L.readonly)("document")},get selection(){return b._selections&&b._selections[0]},set selection(I){if(!(I instanceof T.Selection))throw(0,L.illegalArgument)("selection");b._selections=[I],b._trySetSelection()},get selections(){return b._selections},set selections(I){if(!Array.isArray(I)||I.some(t=>!(t instanceof T.Selection)))throw(0,L.illegalArgument)("selections");b._selections=I,b._trySetSelection()},get visibleRanges(){return b._visibleRanges},set visibleRanges(I){throw(0,L.readonly)("visibleRanges")},get options(){return b._options.value},set options(I){b._disposed||b._options.assign(I)},get viewColumn(){return b._viewColumn},set viewColumn(I){throw(0,L.readonly)("viewColumn")},edit(I,t={undoStopBefore:!0,undoStopAfter:!0}){if(b._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new w(y.value,t);return I(r),b._applyEdit(r)},insertSnippet(I,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(b._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=b._selections.map(i=>A.Range.from(i));else if(t instanceof T.Position){const{lineNumber:i,column:c}=A.Position.from(t);s=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(t instanceof T.Range)s=[A.Range.from(t)];else{s=[];for(const i of t)if(i instanceof T.Range)s.push(A.Range.from(i));else{const{lineNumber:c,column:u}=A.Position.from(i);s.push({startLineNumber:c,startColumn:u,endLineNumber:c,endColumn:u})}}return _.$tryInsertSnippet(p,y.value.version,I.value,s,r)},setDecorations(I,t){const r=t.length===0;r&&!b._hasDecorationsForKey.has(I.key)||(r?b._hasDecorationsForKey.delete(I.key):b._hasDecorationsForKey.add(I.key),b._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return _.$trySetDecorations(p,I.key,A.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let i=0,c=t.length;i<c;i++){const u=t[i];s[4*i]=u.start.line+1,s[4*i+1]=u.start.character+1,s[4*i+2]=u.end.line+1,s[4*i+3]=u.end.character+1}return _.$trySetDecorationsFast(p,I.key,s)}}))},revealRange(I,t){b._runOnProxy(()=>_.$tryRevealRange(p,A.Range.from(I),t||T.TextEditorRevealType.Default))},show(I){_.$tryShowEditor(p,A.ViewColumn.from(I))},hide(){_.$tryHideEditor(p)}})}dispose(){(0,C.ok)(!this._disposed),this._disposed=!0}_acceptOptions(p){(0,C.ok)(!this._disposed),this._options._accept(p)}_acceptVisibleRanges(p){(0,C.ok)(!this._disposed),this._visibleRanges=p}_acceptViewColumn(p){(0,C.ok)(!this._disposed),this._viewColumn=p}_acceptSelections(p){(0,C.ok)(!this._disposed),this._selections=p}async _trySetSelection(){const p=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,p)),this.value}_applyEdit(p){const _=p.finalize();if(_.edits.length===0&&!_.setEndOfLine)return Promise.resolve(!0);const D=_.edits.map(n=>n.range);D.sort((n,o)=>n.end.line===o.end.line?n.end.character===o.end.character?n.start.line===o.start.line?n.start.character-o.start.character:n.start.line-o.start.line:n.end.character-o.end.character:n.end.line-o.end.line);for(let n=0,o=D.length-1;n<o;n++){const a=D[n].end;if(D[n+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const y=_.edits.map(n=>({range:A.Range.from(n.range),text:n.text,forceMoveMarkers:n.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,y,{setEndOfLine:typeof _.setEndOfLine=="number"?A.EndOfLine.from(_.setEndOfLine):void 0,undoStopBefore:_.undoStopBefore,undoStopAfter:_.undoStopAfter})}_runOnProxy(p){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,_=>(_ instanceof Error&&_.name==="DISPOSED"||this._logService.warn(_),null))}}e.ExtHostTextEditor=P}),define(Ce[275],De([1,0,6,223]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,C.refineServiceDecorator)(L.IEnvironmentService)}),define(Ce[145],De([1,0,25,4,14,3]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=T;class f{static isHostExtension(n,o,a){if(o.getExtensionDescription(n))return!1;const m=a.getExtensionDescription(n);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(n,o){this._activationEventsReader=n,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=o,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new C.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this._extensionsMap.set(n.identifier,n),this._extensionsArr.push(n);const o=this._activationEventsReader.readActivationEvents(n);if(Array.isArray(o))for(let a of o)a==="onUri"&&(a=`onUri:${C.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(a)||this._activationMap.set(a,[]),this._activationMap.get(a).push(n)}}set(n){this._extensionDescriptions=n,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,o){this._extensionDescriptions=D(this._extensionDescriptions,o),this._extensionDescriptions=this._extensionDescriptions.concat(n);const a=f._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=D(this._extensionDescriptions,a.map(m=>m.identifier)),this._initialize(),this._onDidChange.fire(void 0),new T(a)}static _findLoopingExtensions(n){const o=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(t){this._nodesSet.has(t)||(this._nodesSet.add(t),this._nodesArr.push(t))}addArc(t,r){this.addNode(t),this.addNode(r),this._arcs.has(t)?this._arcs.get(t).push(r):this._arcs.set(t,[r])}getArcs(t){return this._arcs.has(t)?this._arcs.get(t):[]}hasOnlyGoodArcs(t,r){const s=o.getArcs(t);for(let i=0;i<s.length;i++)if(!r.has(s[i]))return!1;return!0}getNodes(){return this._nodesArr}},a=new C.ExtensionIdentifierMap;for(const t of n)if(a.set(t.identifier,t),t.extensionDependencies)for(const r of t.extensionDependencies)o.addArc(C.ExtensionIdentifier.toKey(t.identifier),C.ExtensionIdentifier.toKey(r));const m=new Set;o.getNodes().filter(t=>o.getArcs(t).length===0).forEach(t=>m.add(t));const b=o.getNodes().filter(t=>!m.has(t));let I;do{I=!1;for(let t=0;t<b.length;t++){const r=b[t];o.hasOnlyGoodArcs(r,m)&&(b.splice(t,1),t--,m.add(r),I=!0)}}while(I);return b.map(t=>a.get(t))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(n)}getExtensionDescriptionsForActivationEvent(n){const o=this._activationMap.get(n);return o?o.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const o=this._extensionsMap.get(n);return o||void 0}getExtensionDescriptionByUUID(n){for(const o of this._extensionsArr)if(o.uuid===n)return o}getExtensionDescriptionByIdOrUUID(n,o){return this.getExtensionDescription(n)??(o?this.getExtensionDescriptionByUUID(o):void 0)}}e.ExtensionDescriptionRegistry=f,e.basicActivationEventsReader={readActivationEvents:y=>y.activationEvents};class w{constructor(n){this._lock=new k,this._actual=new f(n,[])}async acquireLock(n){const o=await this._lock.acquire(n);return new g(this,o)}deltaExtensions(n,o,a){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(o,a)}containsActivationEvent(n){return this._actual.containsActivationEvent(n)}containsExtension(n){return this._actual.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this._actual.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getExtensionDescription(n){return this._actual.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this._actual.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,o){return this._actual.getExtensionDescriptionByIdOrUUID(n,o)}}e.LockableExtensionDescriptionRegistry=w;class g extends A.Disposable{constructor(n,o){super(),this._registry=n,this._isDisposed=!1,this._register(o)}isAcquiredFor(n){return!this._isDisposed&&this._registry===n}}e.ExtensionDescriptionRegistryLock=g;class P{constructor(n){this.name=n,this.promise=new Promise((o,a)=>{this._resolve=o})}resolve(n){this._resolve(n)}}class k{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(n){const o=new P(n);return this._pendingCustomers.push(o),this._advance(),o.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const n=this._pendingCustomers.shift();this._isLocked=!0;let o=!0;const a=setTimeout(()=>{o&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),m=()=>{o&&(clearTimeout(a),o=!1,this._isLocked=!1,this._advance())};n.resolve((0,A.toDisposable)(m))}}var p;(function(y){y[y.Builtin=0]="Builtin",y[y.User=1]="User",y[y.Dev=2]="Dev"})(p||(p={}));function _(y,n){const o=y.isBuiltin?0:y.isUnderDevelopment?2:1,a=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(o!==a)return o-a;const m=d.posix.basename(y.extensionLocation.path),b=d.posix.basename(n.extensionLocation.path);return m<b?-1:m>b?1:0}function D(y,n){const o=new C.ExtensionIdentifierSet(n);return y.filter(a=>!o.has(a.identifier))}}),define(Ce[276],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var C;(function(P){P[P.IPC=1]="IPC",P[P.Socket=2]="Socket",P[P.MessagePort=3]="MessagePort"})(C||(e.ExtHostConnectionType=C={}));class L{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(k){this.pipeName=k,this.type=1}serialize(k){k[L.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=L;class d{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(k){k[d.ENV_KEY]="1"}}e.SocketExtHostConnection=d;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(k){k[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A;function T(P){delete P[L.ENV_KEY],delete P[d.ENV_KEY],delete P[A.ENV_KEY]}function f(P,k){T(k),P.serialize(k)}e.writeExtHostConnection=f;function w(P){if(P[L.ENV_KEY])return g(P,new L(P[L.ENV_KEY]));if(P[d.ENV_KEY])return g(P,new d);if(P[A.ENV_KEY])return g(P,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=w;function g(P,k){return T(P),k}}),define(Ce[110],De([1,0,21]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(L||(e.UIKind=L={}));var d;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(d||(e.ExtensionHostExitCode=d={}));var A;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function T(g){const P=C.VSBuffer.alloc(1);switch(g){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.createMessageOfType=T;function f(g,P){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.isMessageOfType=f;var w;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(w||(e.NativeLogMarkers=w={}))}),define(Ce[88],De([1,0,6,4,17,26,110,60,85,23,2,3,204]),function(me,e,C,L,d,A,T,f,w,g,P,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let _=class extends k.Disposable{constructor(o,a){super(),this.initData=o,this.loggerService=a,this._onDidChangeTelemetryEnabled=this._register(new L.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new L.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=P.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=a.createLogger(this.extHostTelemetryLogFile,{id:w.extensionTelemetryLogChannelId,name:(0,p.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(a.onDidChangeLogLevel(m=>{(0,d.isLogLevel)(m)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===d.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(o,a,m){const b=this.getTelemetryDetails(),I=new D(a,m,o,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(o),{isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled}),t=this._telemetryLoggers.get(o.identifier.value)??[];return this._telemetryLoggers.set(o.identifier.value,[...t,I]),I.apiTelemetryLogger}$initializeTelemetryLevel(o,a,m){this._level=o,this._telemetryIsSupported=a,this._productConfig=m??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(o){const a=Object.create(null);switch(a["common.extname"]=`${o.publisher}.${o.name}`,a["common.extversion"]=o.version,a["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,a["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,a["common.vscodeversion"]=this.initData.version,a["common.isnewappinstall"]=y(this.initData.telemetryInfo.firstSessionDate),a["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case T.UIKind.Web:a["common.uikind"]="web";break;case T.UIKind.Desktop:a["common.uikind"]="desktop";break;default:a["common.uikind"]="unknown"}return a["common.remotename"]=(0,f.getRemoteName)((0,w.cleanRemoteAuthority)(this.initData.remote.authority)),a}$onDidChangeTelemetryLevel(o){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=o;const a=this.getTelemetryDetails();this._telemetryLoggers.forEach((m,b)=>{const I=m.filter(t=>!t.isDisposed);I.length===0?this._telemetryLoggers.delete(b):this._telemetryLoggers.set(b,I)}),this._telemetryLoggers.forEach(m=>{for(const b of m)b.updateTelemetryEnablements(a.isUsageEnabled,a.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(o,a){const b=this._telemetryLoggers.get(o.value)?.filter(t=>!t.isDisposed);if(!b)return this._telemetryLoggers.delete(o.value),!1;let I=!1;for(const t of b)t.ignoreUnhandledExtHostErrors||(t.logError(a),I=!0);return I}};e.ExtHostTelemetry=_,e.ExtHostTelemetry=_=qe([$e(0,A.IExtHostInitDataService),$e(1,d.ILoggerService)],_);class D{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,a,m,b,I,t,r){this._extension=m,this._logger=b,this._inLoggingOnlyMode=I,this._commonProperties=t,this._onDidChangeEnableStates=new L.Emitter,this.ignoreUnhandledExtHostErrors=a?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=a?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=a?.additionalCommonProperties,this._sender=o,this._telemetryEnablements={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(o,a){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:o,isErrorsEnabled:a},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(o){let a="properties"in o?o.properties??{}:o;return a=(0,w.cleanData)(a,[]),this._additionalCommonProperties&&(a=(0,g.mixin)(a,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(a=(0,g.mixin)(a,this._commonProperties)),"properties"in o?o.properties=a:o=a,o}logEvent(o,a){this._sender&&(this._extension.publisher==="vscode"?o=this._extension.name+"/"+o:o=this._extension.identifier.value+"/"+o,a=this.mixInCommonPropsAndCleanData(a||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(o,a),this._logger.trace(o,a))}logUsage(o,a){this._telemetryEnablements.isUsageEnabled&&this.logEvent(o,a)}logError(o,a){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof o=="string")this.logEvent(o,a);else{const m={name:o.name,message:o.message,stack:o.stack,cause:o.cause},b=(0,w.cleanData)(m,[]),I=new Error(b.message,{cause:b.cause});I.stack=b.stack,I.name=b.name,a=this.mixInCommonPropsAndCleanData(a||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(I,a),this._logger.trace("exception",a)}}get apiTelemetryLogger(){if(!this._apiObject){const o=this,a={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return o._telemetryEnablements.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o._onDidChangeEnableStates.event.bind(o)};this._apiObject=Object.freeze(a)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let o=this._sender;this._sender=void 0,Promise.resolve(o.flush()).then(o=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=D;function y(n){const o=Date.now()-new Date(n).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.isNewAppInstall=y,e.IExtHostTelemetry=(0,C.createDecorator)("IExtHostTelemetry")}),define(Ce[27],De([1,0,4,2,245,135,25,6]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,f.createDecorator)("extensionService");class w{constructor(I){this.dependency=I}}e.MissingExtensionDependency=w;var g;(function(b){b[b.EagerAutoStart=1]="EagerAutoStart",b[b.EagerManualStart=2]="EagerManualStart",b[b.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class P{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,addActivationEvents:A.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions),myToRemove:[],myToAdd:this._myExtensions}}set(I,t){const r=[],s=[],i=[],c=[],u=k(this._allExtensions),v=k(I),S=(M,U)=>M.extensionLocation.toString()===U.extensionLocation.toString()||M.isBuiltin===U.isBuiltin||M.isUserBuiltin===U.isUserBuiltin||M.isUnderDevelopment===U.isUnderDevelopment;for(const M of this._allExtensions){const U=v.get(M.identifier);if(!U){r.push(M.identifier),u.delete(M.identifier);continue}if(!S(M,U)){r.push(M.identifier),u.delete(M.identifier);continue}}for(const M of I){const U=u.get(M.identifier);if(!U){s.push(M);continue}if(!S(U,M)){r.push(U.identifier),u.delete(U.identifier);continue}}const l=new T.ExtensionIdentifierSet(this._myExtensions),h=new T.ExtensionIdentifierSet(t);for(const M of this._myExtensions)h.has(M)||i.push(M);for(const M of t)l.has(M)||c.push(M);const E=A.ImplicitActivationEvents.createActivationEventsMap(s),R={toRemove:r,toAdd:s,addActivationEvents:E,myToRemove:i,myToAdd:c};return this.delta(R),R}delta(I){const{toRemove:t,toAdd:r,myToRemove:s,myToAdd:i}=I,c=new T.ExtensionIdentifierSet(t),u=new T.ExtensionIdentifierSet(s);for(let v=0;v<this._allExtensions.length;v++)c.has(this._allExtensions[v].identifier)&&(this._allExtensions.splice(v,1),v--);for(let v=0;v<this._myExtensions.length;v++)u.has(this._myExtensions[v])&&(this._myExtensions.splice(v,1),v--);for(const v of r)this._allExtensions.push(v);for(const v of i)this._myExtensions.push(v)}containsExtension(I){for(const t of this._myExtensions)if(T.ExtensionIdentifier.equals(t,I))return!0;return!1}}e.ExtensionHostExtensions=P;function k(b){const I=new T.ExtensionIdentifierMap;for(const t of b)I.set(t.identifier,t);return I}function p(b,I){return b.enabledApiProposals?b.enabledApiProposals.includes(I):!1}e.isProposedApiEnabled=p;function _(b,I){if(!p(b,I))throw new Error(`Extension '${b.identifier.value}' CANNOT use API proposal: ${I}.
Its package.json#enabledApiProposals-property declares: ${b.enabledApiProposals?.join(", ")??"[]"} but NOT ${I}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.checkProposedApiEnabled=_;class D{constructor(I,t,r,s){this.codeLoadingTime=I,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=s}}e.ActivationTimes=D;class y{constructor(I,t){this.description=I,this.value=t}}e.ExtensionPointContribution=y;var n;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(n||(e.ActivationKind=n={}));function o(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,d.getGalleryExtensionId)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation,targetPlatform:b.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function a(b,I){return{identifier:new T.ExtensionIdentifier((0,d.getExtensionId)(b.manifest.publisher,b.manifest.name)),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!I,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid,targetPlatform:b.targetPlatform}}e.toExtensionDescription=a;class m{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(I){return Promise.resolve(void 0)}activationEventIsDone(I){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(I){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(I,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(I){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=m}),define(Ce[277],De([1,0,8,145,25,27,17,13]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class w{static{this.NONE=new w(!1,-1,-1,-1)}constructor(o,a,m,b){this.startup=o,this.codeLoadingTime=a,this.activateCallTime=m,this.activateResolvedTime=b}}e.ExtensionActivationTimes=w;class g{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,a){return o===-1||a===-1?-1:a-o}build(){return new w(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=g;class P{constructor(o,a,m,b,I,t){this.activationFailed=o,this.activationFailedError=a,this.activationTimes=m,this.module=b,this.exports=I,this.subscriptions=t}}e.ActivatedExtension=P;class k extends P{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class p extends P{constructor(){super(!1,null,w.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=p;class _ extends P{constructor(o){super(!0,o,w.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(o,a,m,b){this._logService=b,this._registry=o,this._globalRegistry=a,this._host=m,this._operations=new d.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[o,a]of this._operations)a.dispose()}async waitForActivatingExtensions(){const o=[];for(const[a,m]of this._operations)o.push(m.wait());await Promise.all(o)}isActivated(o){const a=this._operations.get(o);return!!(a&&a.value)}getActivatedExtension(o){const a=this._operations.get(o);if(!a||!a.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return a.value}async activateByEvent(o,a){if(this._alreadyActivatedEvents[o])return;const m=this._registry.getExtensionDescriptionsForActivationEvent(o);await this._activateExtensions(m.map(b=>({id:b.identifier,reason:{startup:a,extensionId:b.identifier,activationEvent:o}}))),this._alreadyActivatedEvents[o]=!0}activateById(o,a){const m=this._registry.getExtensionDescription(o);if(!m)throw new Error(`Extension '${o}' is not known`);return this._activateExtensions([{id:m.identifier,reason:a}])}async _activateExtensions(o){const a=o.filter(m=>!this.isActivated(m.id)).map(m=>this._handleActivationRequest(m));await Promise.all(a.map(m=>m.wait()))}_handleActivationRequest(o){if(this._operations.has(o.id))return this._operations.get(o.id);if(this._isHostExtension(o.id))return this._createAndSaveOperation(o,null,[],null);const a=this._registry.getExtensionDescription(o.id);if(!a){const I=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this._createAndSaveOperation(o,null,[],new _(I));return this._host.onExtensionActivationError(o.id,I,new A.MissingExtensionDependency(o.id.value)),t}const m=[],b=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const I of b){if(this._isResolvedExtension(I))continue;const t=this._operations.get(I);if(t){m.push(t);continue}if(this._isHostExtension(I)){m.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(I).identifier,reason:o.reason}));continue}const r=this._registry.getExtensionDescription(I);if(r){if(!r.main&&!r.browser)continue;m.push(this._handleActivationRequest({id:r.identifier,reason:o.reason}));continue}const s=a.displayName||a.identifier.value,i=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${I}'`),c=this._createAndSaveOperation(o,a.displayName,[],new _(i));return this._host.onExtensionActivationError(a.identifier,i,new A.MissingExtensionDependency(I)),c}return this._createAndSaveOperation(o,a.displayName,m,null)}_createAndSaveOperation(o,a,m,b){const I=new y(o.id,a,o.reason,m,b,this._host,this._logService);return this._operations.set(o.id,I),I}_isHostExtension(o){return L.ExtensionDescriptionRegistry.isHostExtension(o,this._registry,this._globalRegistry)}_isResolvedExtension(o){const a=this._globalRegistry.getExtensionDescription(o);return a?!a.main&&!a.browser:!1}};e.ExtensionsActivator=D,e.ExtensionsActivator=D=qe([$e(3,T.ILogService)],D);let y=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(o,a,m,b,I,t,r){this._id=o,this._displayName=a,this._reason=m,this._deps=b,this._value=I,this._host=t,this._logService=r,this._barrier=new f.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let o=0;o<this._deps.length;o++){const a=this._deps[o];if(a.value&&!a.value.activationFailed){this._deps.splice(o,1),o--;continue}if(a.value&&a.value.activationFailed){const m=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);m.detail=a.value.activationFailedError,this._value=new _(m),this._host.onExtensionActivationError(this._id,m,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(o=>o.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(o){const a=new Error;if(o&&o.name&&(a.name=o.name),o&&o.message?a.message=`Activating extension '${this._id.value}' failed: ${o.message}.`:a.message=`Activating extension '${this._id.value}' failed: ${o}.`,o&&o.stack&&(a.stack=o.stack),this._value=new _(a),this._isDisposed&&C.isCancellationError(o))return;this._host.onExtensionActivationError(this._id,a,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(o)}}};y=qe([$e(6,T.ILogService)],y)}),define(Ce[278],De([1,0,206,7,24,2,4,3,259,13,7,19,18,10,78,22,170,27]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(I,t){if((0,k.isString)(I))return{label:I};if(I&&typeof I=="object"&&typeof I.label=="string"){let r;return Array.isArray(I.highlights)&&(r=I.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),r=r.length?r:void 0),{label:I.label,highlights:r}}}class m{constructor(t,r,s){this._proxy=t,this.commands=r,this.logService=s,this.treeViews=new Map,this.treeDragAndDropService=new n.TreeViewsDnDService;function i(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:c=>i(c)?this.convertArgument(c):Array.isArray(c)&&c.length>0?c.map(u=>i(u)?this.convertArgument(u):u):c})}registerTreeDataProvider(t,r,s){const i=this.createTreeView(t,{treeDataProvider:r},s);return{dispose:()=>i.dispose()}}createTreeView(t,r,s){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=r.dragAndDropController?.dropMimeTypes??[],c=r.dragAndDropController?.dragMimeTypes??[],u=!!r.dragAndDropController?.handleDrag,v=!!r.dragAndDropController?.handleDrop,S=this.createExtHostTreeView(t,r,s),l={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:i,dragMimeTypes:c,hasHandleDrag:u,hasHandleDrop:v,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},h=this._proxy.$registerTreeViewDataProvider(t,l);return{get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,o.checkProposedApiEnabled)(s,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,o.checkProposedApiEnabled)(s,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(R){(0,D.isMarkdownString)(R)&&(0,o.checkProposedApiEnabled)(s,"treeViewMarkdownMessage"),S.message=R},get title(){return S.title},set title(R){S.title=R},get description(){return S.description},set description(R){S.description=R},get badge(){return S.badge},set badge(R){R!==void 0&&P.ViewBadge.isViewBadge(R)?S.badge={value:Math.floor(Math.abs(R.value)),tooltip:R.tooltip}:R===void 0&&(S.badge=void 0)},reveal:(R,M)=>S.reveal(R,M),dispose:async()=>{await h,this.treeViews.delete(t),S.dispose()}}}$getChildren(t,r){const s=this.treeViews.get(t);return s?s.getChildren(r):Promise.reject(new w.NoTreeViewError(t))}async $handleDrop(t,r,s,i,c,u,v,S){const l=this.treeViews.get(t);if(!l)return Promise.reject(new w.NoTreeViewError(t));const h=_.DataTransfer.toDataTransfer(s,async E=>(await this._proxy.$resolveDropFileData(t,r,E)).buffer);return v===t&&S&&await this.addAdditionalTransferItems(h,l,S,c,u),l.onDrop(h,i,c)}async addAdditionalTransferItems(t,r,s,i,c){const u=this.treeDragAndDropService.removeDragOperationTransfer(c);if(u)(await u)?.forEach((v,S)=>{v&&t.set(S,v)});else if(c&&r.handleDrag){const v=r.handleDrag(s,t,i);this.treeDragAndDropService.addDragOperationTransfer(c,v),await v}return t}async $handleDrag(t,r,s,i){const c=this.treeViews.get(t);if(!c)return Promise.reject(new w.NoTreeViewError(t));const u=await this.addAdditionalTransferItems(new L.DataTransfer,c,r,i,s);if(!(!u||i.isCancellationRequested))return _.DataTransfer.from(u)}async $hasResolve(t){const r=this.treeViews.get(t);if(!r)throw new w.NoTreeViewError(t);return r.hasResolve}$resolve(t,r,s){const i=this.treeViews.get(t);if(!i)throw new w.NoTreeViewError(t);return i.resolveTreeItem(r,s)}$setExpanded(t,r,s){const i=this.treeViews.get(t);if(!i)throw new w.NoTreeViewError(t);i.setExpanded(r,s)}$setSelectionAndFocus(t,r,s){const i=this.treeViews.get(t);if(!i)throw new w.NoTreeViewError(t);i.setSelectionAndFocus(r,s)}$setVisible(t,r){const s=this.treeViews.get(t);if(!s){if(!r)return;throw new w.NoTreeViewError(t)}s.setVisible(r)}$changeCheckboxState(t,r){const s=this.treeViews.get(t);if(!s)throw new w.NoTreeViewError(t);s.setCheckboxState(r)}createExtHostTreeView(t,r,s){const i=new b(t,r,this._proxy,this.commands.converter,this.logService,s);return this.treeViews.set(t,i),i}convertArgument(t){const r=this.treeViews.get(t.$treeViewId);return r&&"$treeItemHandle"in t?r.getExtensionElement(t.$treeItemHandle):r&&"$focusedTreeItem"in t&&t.$focusedTreeItem?r.focusedElement:null}}e.ExtHostTreeViews=m;class b extends f.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(t=>this.getExtensionElement(t)).filter(t=>!(0,k.isUndefinedOrNull)(t))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(t,r,s,i,c,u){if(super(),this.viewId=t,this.proxy=s,this.commands=i,this.logService=c,this.extension=u,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new T.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new T.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new y.CancellationTokenSource,u.contributes&&u.contributes.views)for(const l in u.contributes.views)for(const h of u.contributes.views[l])h.id===t&&(this._title=h.name);this.dataProvider=r.treeDataProvider,this.dndController=r.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let v,S;this._register(T.Event.debounce(this._onDidChangeData.event,(l,h)=>(l||(l={message:!1,elements:[]}),h.element!==!1&&(v||(v=new Promise(E=>S=E),this.refreshPromise=this.refreshPromise.then(()=>v)),Array.isArray(h.element)?l.elements.push(...h.element):l.elements.push(h.element)),h.message&&(l.message=!0),l),200,!0)(({message:l,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const E=S;return v=null,this.refresh(h).then(()=>E())})),l&&this.proxy.$setMessage(this.viewId,_.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(t){const r=t?this.getExtensionElement(t):void 0;if(t&&!r)return this.logService.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let s=this.getChildrenNodes(t);return s||(s=await this.fetchChildrenNodes(r)),s?s.map(i=>i.item):void 0}getExtensionElement(t){return this.elements.get(t)}reveal(t,r){r=r||{select:!0,focus:!1};const s=(0,k.isUndefinedOrNull)(r.select)?!0:r.select,i=(0,k.isUndefinedOrNull)(r.focus)?!1:r.focus,c=(0,k.isUndefinedOrNull)(r.expand)?!1:r.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.refreshPromise.then(()=>this.resolveUnknownParentChain(t)).then(u=>this.resolveTreeNode(t,u[u.length-1]).then(v=>this.proxy.$reveal(this.viewId,{item:v.item,parentChain:u.map(S=>S.item)},{select:s,focus:i,expand:c})),u=>this.logService.error(u)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:i,expand:c})}get message(){return this._message}set message(t){this._message=t,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(t){this._title=t,this.proxy.$setTitle(this.viewId,t,this._description)}get description(){return this._description}set description(t){this._description=t,this.proxy.$setTitle(this.viewId,this._title,t)}get badge(){return this._badge}set badge(t){this._badge?.value===t?.value&&this._badge?.tooltip===t?.tooltip||(this._badge=_.ViewBadge.from(t),this.proxy.$setBadge(this.viewId,t))}setExpanded(t,r){const s=this.getExtensionElement(t);s&&(r?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelectionAndFocus(t,r){const s=!(0,p.equals)(this._selectedHandles,t);this._selectedHandles=t;const i=this._focusedHandle!==r;this._focusedHandle=r,s&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),i&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this._visible&&(this._visible=t,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(t){const r=(await Promise.all(t.map(async s=>{const i=this.getExtensionElement(s.treeItemHandle);return i?{extensionItem:i,treeItem:await this.dataProvider.getTreeItem(i),newState:s.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);r.forEach(s=>{s.treeItem.checkboxState=s.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:r.map(s=>[s.extensionItem,s.newState])})}async handleDrag(t,r,s){const i=[];for(const c of t){const u=this.getExtensionElement(c);u&&i.push(u)}if(!(!this.dndController?.handleDrag||i.length===0))return await this.dndController.handleDrag(i,r,s),r}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(t,r,s){const i=r?this.getExtensionElement(r):void 0;if(!(!i&&r||!this.dndController?.handleDrop))return(0,g.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(i,t,s):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(t,r){if(!this.dataProvider.resolveTreeItem)return;const s=this.elements.get(t);if(s){const i=this.nodes.get(s);if(i){const c=await this.dataProvider.resolveTreeItem(i.extensionItem,s,r)??i.extensionItem;return this.validateTreeItem(c),i.item.tooltip=this.getTooltip(c.tooltip),i.item.command=this.getCommand(i.disposableStore,c.command),i.item}}}resolveUnknownParentChain(t){return this.resolveParent(t).then(r=>r?this.resolveUnknownParentChain(r).then(s=>this.resolveTreeNode(r,s[s.length-1]).then(i=>(s.push(i),s))):Promise.resolve([]))}resolveParent(t){const r=this.nodes.get(t);return r?Promise.resolve(r.parent?this.elements.get(r.parent.item.handle):void 0):(0,g.asPromise)(()=>this.dataProvider.getParent(t))}resolveTreeNode(t,r){const s=this.nodes.get(t);return s?Promise.resolve(s):(0,g.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(i=>this.createHandle(t,i,r,!0)).then(i=>this.getChildren(r?r.item.handle:void 0).then(()=>{const c=this.getExtensionElement(i);if(c){const u=this.nodes.get(c);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${i} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(t){if(t){let r;if(typeof t=="string"){const s=this.getExtensionElement(t);r=s?this.nodes.get(s):void 0}else r=t;return r&&r.children||void 0}return this.roots}async fetchChildrenNodes(t){this.clearChildren(t);const r=new y.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=t?this.nodes.get(t):void 0,i=await this.dataProvider.getChildren(t);if(r.token.isCancellationRequested)return;const c=await Promise.all((0,p.coalesce)(i||[]).map(async u=>{const v=await this.dataProvider.getTreeItem(u);return v&&!r.token.isCancellationRequested?this.createAndRegisterTreeNode(u,v,s):null}));return r.token.isCancellationRequested?void 0:(0,p.coalesce)(c)}finally{r.dispose()}}refresh(t){if(t.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new y.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(t);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(t){const r=new Set,s=t.map(c=>this.nodes.get(c));for(const c of s)if(c&&!r.has(c.item.handle)){let u=c;for(;u&&u.parent&&s.findIndex(v=>u&&u.parent&&v&&v.item.handle===u.parent.item.handle)===-1;){const v=this.elements.get(u.parent.item.handle);u=v?this.nodes.get(v):void 0}u&&!u.parent&&r.add(c.item.handle)}const i=[];return r.forEach(c=>{const u=this.elements.get(c);if(u){const v=this.nodes.get(u);v&&(!v.parent||!r.has(v.parent.item.handle))&&i.push(c)}}),i}refreshHandles(t){const r={};return Promise.all(t.map(s=>this.refreshNode(s).then(i=>{i&&(r[s]=i.item)}))).then(()=>Object.keys(r).length?this.proxy.$refresh(this.viewId,r):void 0)}refreshNode(t){const r=this.getExtensionElement(t);if(r){const s=this.nodes.get(r);if(s)return this.clearChildren(r),(0,g.asPromise)(()=>this.dataProvider.getTreeItem(r)).then(i=>{if(i){const c=this.createTreeNode(r,i,s.parent);return this.updateNodeCache(r,c,s,s.parent),s.dispose(),c}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(t,r,s){const i=this.createTreeNode(t,r,s);if(r.id&&this.elements.has(i.item.handle))throw new Error((0,C.localize)(0,null,r.id));return this.addNodeToCache(t,i),this.addNodeToParentCache(i,s),i}getTooltip(t){return P.MarkdownString.isMarkdownString(t)?_.MarkdownString.from(t):t}getCommand(t,r){return r?{...this.commands.toInternal(r,t),originalId:r.command}:void 0}getCheckbox(t){if(t.checkboxState===void 0)return;let r,s,i;return typeof t.checkboxState=="number"?r=t.checkboxState:(r=t.checkboxState.state,s=t.checkboxState.tooltip,i=t.checkboxState.accessibilityInformation),{isChecked:r===P.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:i}}validateTreeItem(t){if(!P.TreeItem.isTreeItem(t,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(t,r,s){this.validateTreeItem(r);const i=new f.DisposableStore,c=this.createHandle(t,r,s),u=this.getLightIconPath(r);return{item:{handle:c,parentHandle:s?s.item.handle:void 0,label:a(r.label,this.extension),description:r.description,resourceUri:r.resourceUri,tooltip:this.getTooltip(r.tooltip),command:this.getCommand(i,r.command),contextValue:r.contextValue,icon:u,iconDark:this.getDarkIconPath(r)||u,themeIcon:this.getThemeIcon(r),collapsibleState:(0,k.isUndefinedOrNull)(r.collapsibleState)?P.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.getCheckbox(r)},extensionItem:r,parent:s,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(t){return t.iconPath instanceof P.ThemeIcon?t.iconPath:void 0}createHandle(t,{id:r,label:s,resourceUri:i},c,u){if(r)return`${b.ID_HANDLE_PREFIX}/${r}`;const v=a(s,this.extension),S=c?c.item.handle:b.LABEL_HANDLE_PREFIX;let l=v?v.label:i?(0,d.basename)(i):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const h=this.nodes.has(t)?this.nodes.get(t).item.handle:void 0,E=this.getChildrenNodes(c)||[];let R,M=0;do{if(R=`${S}/${M}:${l}`,u||!this.elements.has(R)||h===R)break;M++}while(M<=E.length);return R}getLightIconPath(t){if(t.iconPath&&!(t.iconPath instanceof P.ThemeIcon))return typeof t.iconPath=="string"||A.URI.isUri(t.iconPath)?this.getIconPath(t.iconPath):this.getIconPath(t.iconPath.light)}getDarkIconPath(t){if(t.iconPath&&!(t.iconPath instanceof P.ThemeIcon)&&t.iconPath.dark)return this.getIconPath(t.iconPath.dark)}getIconPath(t){return A.URI.isUri(t)?t:A.URI.file(t)}addNodeToCache(t,r){this.elements.set(r.item.handle,t),this.nodes.set(t,r)}updateNodeCache(t,r,s,i){this.elements.delete(r.item.handle),this.nodes.delete(t),r.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(t,r);const c=this.getChildrenNodes(i)||[],u=c.filter(v=>v.item.handle===s.item.handle)[0];u&&c.splice(c.indexOf(u),1,r)}addNodeToParentCache(t,r){r?(r.children||(r.children=[]),r.children.push(t)):(this.roots||(this.roots=[]),this.roots.push(t))}clearChildren(t){if(t){const r=this.nodes.get(t);if(r){if(r.children)for(const s of r.children){const i=this.elements.get(s.item.handle);i&&this.clear(i)}r.children=void 0}}else this.clearAll()}clear(t){const r=this.nodes.get(t);if(r){if(r.children)for(const s of r.children){const i=this.elements.get(s.item.handle);i&&this.clear(i)}this.nodes.delete(t),this.elements.delete(r.item.handle),r.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(t=>t.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Ce[279],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalContextMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalContextMenu.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[280],De([1,0,218,8,40,130,104,42,25,279,133,135]),function(me,e,C,L,d,A,T,f,w,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const p=f.Registry.as(T.Extensions.JSONContribution);class _{constructor(I,t,r){this._messageHandler=I,this._extension=t,this._extensionPointId=r}_msg(I,t){this._messageHandler({type:I,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(I){this._msg(d.default.Error,I)}warn(I){this._msg(d.default.Warning,I)}info(I){this._msg(d.default.Info,I)}}e.ExtensionMessageCollector=_;class D{static _toSet(I){const t=new w.ExtensionIdentifierSet;for(let r=0,s=I.length;r<s;r++)t.add(I[r].description.identifier);return t}static compute(I,t){if(!I||!I.length)return new D(t,[]);if(!t||!t.length)return new D([],I);const r=this._toSet(I),s=this._toSet(t),i=t.filter(u=>!r.has(u.description.identifier)),c=I.filter(u=>!s.has(u.description.identifier));return new D(i,c)}constructor(I,t){this.added=I,this.removed=t}}e.ExtensionPointUserDelta=D;class y{constructor(I,t){this.name=I,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(I){if(this._handler!==null)throw new Error("Handler already set!");this._handler=I,this._handle()}acceptUsers(I){this._delta=D.compute(this._users,I),this._users=I,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(I){(0,L.onUnexpectedError)(I)}}}e.ExtensionPoint=y;const n={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:w.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"*",description:C.localize(42,null),body:"*"}]}},badges:{type:"array",description:C.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(44,null)},href:{type:"string",description:C.localize(45,null)},description:{type:"string",description:C.localize(46,null)}}}},markdown:{type:"string",description:C.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:C.localize(51,null),type:"array",items:n,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(52,null)},{body:["workspace"],description:C.localize(53,null)},{body:["ui","workspace"],description:C.localize(54,null)},{body:["workspace","ui"],description:C.localize(55,null)},{body:[],description:C.localize(56,null)}]},capabilities:{description:C.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(60,null),C.localize(61,null),C.localize(62,null)]},description:{type:"string",markdownDescription:C.localize(63,null)}}},untrustedWorkspaces:{description:C.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(66,null),C.localize(67,null),C.localize(68,null)]},restrictedConfigurations:{description:C.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(70,null)}}}}},sponsor:{description:C.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(73,null),type:"string"},"vscode:uninstall":{description:C.localize(74,null),type:"string"}}},icon:{type:"string",description:C.localize(75,null)},l10n:{type:"string",description:C.localize(76,null)},pricing:{type:"string",markdownDescription:C.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class a{constructor(){this._extensionPoints=new Map}registerExtensionPoint(I){if(this._extensionPoints.has(I.extensionPoint))throw new Error("Duplicate extension point: "+I.extensionPoint);const t=new y(I.extensionPoint,I.defaultExtensionKind);return this._extensionPoints.set(I.extensionPoint,t),I.activationEventsGenerator&&k.ImplicitActivationEvents.register(I.extensionPoint,I.activationEventsGenerator),e.schema.properties.contributes.properties[I.extensionPoint]=I.jsonSchema,p.registerSchema(o,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=a;const m={ExtensionsRegistry:"ExtensionsRegistry"};f.Registry.add(m.ExtensionsRegistry,new a),e.ExtensionsRegistry=f.Registry.as(m.ExtensionsRegistry),p.registerSchema(o,e.schema),p.registerSchema(P.productSchemaId,{properties:{extensionEnabledApiProposals:{description:C.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Ce[281],De([1,0,215,19,23,280,47,4]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const w={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var g;(function(p){function _(D,y,n){if(!D)return;const o=L.isString(D.type)?D.type:void 0;if(!o||o.length===0){n.error(C.localize(3,null));return}const a=[];if(Array.isArray(D.required))for(const m of D.required)L.isString(m)&&a.push(m);return{extensionId:y.value,taskType:o,required:a,properties:D.properties?d.deepClone(D.properties):{},when:D.when?T.ContextKeyExpr.deserialize(D.when):void 0}}p.from=_})(g||(g={}));const P=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,_)=>{for(const D of p)D.type&&_.push(`onTaskType:${D.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:w}});class k{constructor(){this._onDefinitionsChanged=new f.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((_,D)=>{P.setHandler((y,n)=>{this._schema=void 0;try{for(const o of n.removed){const a=o.value;for(const m of a)this.taskTypes&&m.type&&this.taskTypes[m.type]&&delete this.taskTypes[m.type]}for(const o of n.added){const a=o.value;for(const m of a){const b=g.from(m,o.description.identifier,o.collector);b&&(this.taskTypes[b.taskType]=b)}}(n.removed.length>0||n.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}_(void 0)})})}onReady(){return this.readyPromise}get(_){return this.taskTypes[_]}all(){return Object.keys(this.taskTypes).map(_=>this.taskTypes[_])}getJsonSchema(){if(this._schema===void 0){const _=[];for(const D of this.all()){const y={type:"object",additionalProperties:!1};D.required.length>0&&(y.required=D.required.slice(0)),D.properties!==void 0?y.properties=d.deepClone(D.properties):y.properties=Object.create(null),y.properties.type={type:"string",enum:[D.taskType]},_.push(y)}this._schema={oneOf:_}}return this._schema}}e.TaskDefinitionRegistry=new k}),define(Ce[282],De([1,0,216,19,24,23,47,281]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new T.RawContextKey("taskRunning",!1,C.localize(0,null)),e.TASKS_CATEGORY={value:C.localize(1,null),original:"Tasks"};var w;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(w||(e.ShellQuoting=w={})),e.CUSTOMIZED_TASK_TYPE="$customized",function($){function O(K){if(!K)return $.Strong;switch(K.toLowerCase()){case"escape":return $.Escape;case"strong":return $.Strong;case"weak":return $.Weak;default:return $.Strong}}$.from=O}(w||(e.ShellQuoting=w={}));var g;(function($){$.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var P;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(P||(e.RevealKind=P={})),function($){function O(K){switch(K.toLowerCase()){case"always":return $.Always;case"silent":return $.Silent;case"never":return $.Never;default:return $.Always}}$.fromString=O}(P||(e.RevealKind=P={}));var k;(function($){$[$.Never=1]="Never",$[$.OnProblem=2]="OnProblem",$[$.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function($){function O(K){switch(K.toLowerCase()){case"always":return $.Always;case"never":return $.Never;case"onproblem":return $.OnProblem;default:return $.OnProblem}}$.fromString=O}(k||(e.RevealProblemKind=k={}));var p;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(p||(e.PanelKind=p={})),function($){function O(K){switch(K.toLowerCase()){case"shared":return $.Shared;case"dedicated":return $.Dedicated;case"new":return $.New;default:return $.Shared}}$.fromString=O}(p||(e.PanelKind=p={}));var _;(function($){$.defaults={echo:!0,reveal:P.Always,revealProblems:k.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(_||(e.PresentationOptions=_={}));var D;(function($){$[$.Shell=1]="Shell",$[$.Process=2]="Process",$[$.CustomExecution=3]="CustomExecution"})(D||(e.RuntimeType=D={})),function($){function O(q){switch(q.toLowerCase()){case"shell":return $.Shell;case"process":return $.Process;case"customExecution":return $.CustomExecution;default:return $.Process}}$.fromString=O;function K(q){switch(q){case $.Shell:return"shell";case $.Process:return"process";case $.CustomExecution:return"customExecution";default:return"process"}}$.toString=K}(D||(e.RuntimeType=D={}));var y;(function($){function O(K){return L.isString(K)?K:K.value}$.value=O})(y||(e.CommandString=y={}));var n;(function($){$.Clean={_id:"clean",isDefault:!1},$.Build={_id:"build",isDefault:!1},$.Rebuild={_id:"rebuild",isDefault:!1},$.Test={_id:"test",isDefault:!1};function O(q){return q===$.Clean._id||q===$.Build._id||q===$.Rebuild._id||q===$.Test._id}$.is=O;function K(q){if(q!==void 0)return L.isString(q)?O(q)?{_id:q,isDefault:!1}:void 0:q}$.from=K})(n||(e.TaskGroup=n={}));var o;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var a;(function($){$.Workspace="workspace",$.Extension="extension",$.InMemory="inMemory",$.WorkspaceFile="workspaceFile",$.User="user";function O(K){switch(K){case $.User:return 2;case $.WorkspaceFile:return 5;default:return 6}}$.toConfigurationTarget=O})(a||(e.TaskSourceKind=a={}));var m;(function($){$.parallel="parallel",$.sequence="sequence"})(m||(e.DependsOrder=m={}));var b;(function($){$[$.default=1]="default",$[$.folderOpen=2]="folderOpen"})(b||(e.RunOnOptions=b={}));var I;(function($){$.defaults={reevaluateOnRerun:!0,runOn:b.default,instanceLimit:1}})(I||(e.RunOptions=I={}));class t{constructor(O,K,q,fe,se,ie){this._label="",this._id=O,K&&(this._label=K),q&&(this.type=q),this.runOptions=fe,this.configurationProperties=se,this._source=ie}getDefinition(O){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const O={folder:this.getFolderId(),id:this._id};return JSON.stringify(O)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,K=!1){if(O===void 0)return!1;if(L.isString(O))return O===this._label||O===this.configurationProperties.identifier||K&&O===this._id;const q=this.getDefinition(!0);return q!==void 0&&q._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),O&&(this._taskLoadMessages=this._taskLoadMessages.concat(O))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class r extends t{constructor(O,K,q,fe,se,ie,H,re){super(O,q,void 0,H,re,K),this.command={},this._source=K,this.hasDefinedMatchers=ie,se&&(this.command=se)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case D.Shell:K="shell";break;case D.Process:K="process";break;case D.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(O){return O instanceof r}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===a.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const O=this.getFolderId();if(!O)return;let K=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(K+=this._source.kind);const q={type:e.CUSTOMIZED_TASK_TYPE,folder:O,id:K};return JSON.stringify(q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(O){return new r(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.CustomTask=r;class s extends t{constructor(O,K,q,fe,se,ie,H){super(O,q,fe,ie,H,K),this._source=K,this.configures=se}static is(O){return O instanceof s}fromObject(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===a.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const O=this.getFolderId();if(!O)return;let K=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(K+=this._source.kind);const q={type:e.CUSTOMIZED_TASK_TYPE,folder:O,id:K};return JSON.stringify(q)}}e.ConfiguringTask=s;class i extends t{constructor(O,K,q,fe,se,ie,H,re,Ee){super(O,q,fe,re,Ee,K),this.defines=se,this.hasDefinedMatchers=H,this.command=ie,this.icon=Ee.icon,this.hide=Ee.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof i}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.getFolderId(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(O){return new i(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.ContributedTask=i;class c extends t{constructor(O,K,q,fe,se,ie){super(O,q,fe,se,ie,K),this._source=K}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(O){return new c(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.InMemoryTask=c;var u;(function($){$[$.Process=1]="Process",$[$.Terminal=2]="Terminal"})(u||(e.ExecutionEngine=u={})),function($){$._default=$.Terminal}(u||(e.ExecutionEngine=u={}));var v;(function($){$[$.V0_1_0=1]="V0_1_0",$[$.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class S{constructor(O){this._order=new Map;for(let K=0;K<O.length;K++)this._order.set(O[K].uri.toString(),K)}compare(O,K){const q=O.getWorkspaceFolder(),fe=K.getWorkspaceFolder();if(q&&fe){let se=this._order.get(q.uri.toString());se=se===void 0?0:se+1;let ie=this._order.get(fe.uri.toString());return ie=ie===void 0?0:ie+1,se===ie?O._label.localeCompare(K._label):se-ie}else return!q&&fe?-1:q&&!fe?1:0}}e.TaskSorter=S;var l;(function($){$.DependsOnStarted="dependsOnStarted",$.AcquiredInput="acquiredInput",$.Start="start",$.ProcessStarted="processStarted",$.Active="active",$.Inactive="inactive",$.Changed="changed",$.Terminated="terminated",$.ProcessEnded="processEnded",$.End="end"})(l||(e.TaskEventKind=l={}));var h;(function($){$.SingleRun="singleRun",$.Background="background"})(h||(e.TaskRunType=h={}));var E;(function($){$[$.System=0]="System",$[$.User=1]="User",$[$.FolderOpen=2]="FolderOpen",$[$.ConfigurationChange=3]="ConfigurationChange",$[$.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var R;(function($){function O(K,q,fe,se){if(q){const ie={kind:K,taskId:q._id,taskName:q.configurationProperties.name,runType:q.configurationProperties.isBackground?"background":"singleRun",group:q.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:fe,__task:q};return K==="start"?ie.resolvedVariables=se:K==="processStarted"?ie.processId=se:K==="processEnded"&&(ie.exitCode=se),Object.freeze(ie)}else return Object.freeze({kind:"changed"})}$.create=O})(R||(e.TaskEvent=R={}));var M;(function($){function O(q){const fe=Object.keys(q).sort();let se="";for(const ie of fe){let H=q[ie];H instanceof Object?H=O(H):typeof H=="string"&&(H=H.replace(/,/g,",,")),se+=ie+","+H+","}return se}function K(q){const se={_key:O(q),type:q.taskType};return Object.assign(se,q),se}$.create=K})(M||(e.KeyedTaskIdentifier=M={}));var U;(function($){$.AutoDetect="task.autoDetect",$.SaveBeforeRun="task.saveBeforeRun",$.ShowDecorations="task.showDecorations",$.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",$.SlowProviderWarning="task.slowProviderWarning",$.QuickOpenHistory="task.quickOpen.history",$.QuickOpenDetail="task.quickOpen.detail",$.QuickOpenSkip="task.quickOpen.skip",$.QuickOpenShowAll="task.quickOpen.showAll",$.AllowAutomaticTasks="task.allowAutomaticTasks",$.Reconnection="task.reconnection"})(U||(e.TaskSettingId=U={}));var F;(function($){$.Tasks="tasks",$.SuppressTaskName="tasks.suppressTaskName",$.Windows="tasks.windows",$.Osx="tasks.osx",$.Linux="tasks.linux",$.ShowOutput="tasks.showOutput",$.IsShellCommand="tasks.isShellCommand",$.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var x;(function($){function O(K,q){const fe=f.TaskDefinitionRegistry.get(K.type);if(fe===void 0){const re=A.deepClone(K);return delete re._key,M.create(re)}const se=Object.create(null);se.type=fe.taskType;const ie=new Set;fe.required.forEach(re=>ie.add(re));const H=fe.properties;for(const re of Object.keys(H)){const Ee=K[re];if(Ee!=null)se[re]=Ee;else if(ie.has(re)){const ae=H[re];if(ae.default!==void 0)se[re]=A.deepClone(ae.default);else switch(ae.type){case"boolean":se[re]=!1;break;case"number":case"integer":se[re]=0;break;case"string":se[re]="";break;default:q.error(C.localize(2,null,JSON.stringify(K,void 0,0),re));return}}}return M.create(se)}$.createTaskIdentifier=O})(x||(e.TaskDefinition=x={}))}),define(Ce[283],De([1,0,8]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,f)=>{this._actualOk=T,this._actualErr=f,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,C.onUnexpectedError)(T))}then(T,f){return this._ensureActual().then(T,f)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=L;class d extends L{constructor(){super(),this._hasErr=!0,this._err=new C.CancellationError}}e.CanceledLazyPromise=d}),define(Ce[64],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class C{static{this.count=0}constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++C.count}}e.ProxyIdentifier=C;const L=[];function d(f){const w=new C(f);return L[w.nid]=w,w}e.createProxyIdentifier=d;function A(f){return L[f].sid}e.getStringIdentifierForProxy=A;class T{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=T}),define(Ce[5],De([1,0,64]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var d;(function(y){y[y.UnknownInput=0]="UnknownInput",y[y.TextInput=1]="TextInput",y[y.TextDiffInput=2]="TextDiffInput",y[y.TextMergeInput=3]="TextMergeInput",y[y.NotebookInput=4]="NotebookInput",y[y.NotebookDiffInput=5]="NotebookDiffInput",y[y.CustomEditorInput=6]="CustomEditorInput",y[y.WebviewEditorInput=7]="WebviewEditorInput",y[y.TerminalEditorInput=8]="TerminalEditorInput",y[y.InteractiveEditorInput=9]="InteractiveEditorInput"})(d||(e.TabInputKind=d={}));var A;(function(y){y[y.TAB_OPEN=0]="TAB_OPEN",y[y.TAB_CLOSE=1]="TAB_CLOSE",y[y.TAB_UPDATE=2]="TAB_UPDATE",y[y.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var T;(function(y){y[y.Editable=0]="Editable",y[y.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var f;(function(y){y[y.Int8Array=1]="Int8Array",y[y.Uint8Array=2]="Uint8Array",y[y.Uint8ClampedArray=3]="Uint8ClampedArray",y[y.Int16Array=4]="Int16Array",y[y.Uint16Array=5]="Uint16Array",y[y.Int32Array=6]="Int32Array",y[y.Uint32Array=7]="Uint32Array",y[y.Float32Array=8]="Float32Array",y[y.Float64Array=9]="Float64Array",y[y.BigInt64Array=10]="BigInt64Array",y[y.BigUint64Array=11]="BigUint64Array"})(f||(e.WebviewMessageArrayBufferViewType=f={}));var w;(function(y){y[y.Text=1]="Text",y[y.Error=2]="Error",y[y.Rich=3]="Rich"})(w||(e.CellOutputKind=w={}));var g;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var P;(function(y){y[y.None=0]="None",y[y.Process=1]="Process",y[y.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class k{static{this._n=0}static mixin(n){return n._id=k._n++,n}}e.IdObject=k;var p;(function(y){y.label="a",y.kind="b",y.detail="c",y.documentation="d",y.sortText="e",y.filterText="f",y.preselect="g",y.insertText="h",y.insertTextRules="i",y.range="j",y.commitCharacters="k",y.additionalTextEdits="l",y.kindModifier="m",y.commandIdent="n",y.commandId="o",y.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var _;(function(y){y.defaultRanges="a",y.completions="b",y.isIncomplete="c",y.duration="d"})(_||(e.ISuggestResultDtoField=_={}));var D;(function(y){y[y.Workspace=0]="Workspace",y[y.TextDocument=1]="TextDocument"})(D||(e.ExtHostTestingResource=D={})),e.MainContext={MainThreadAuthentication:(0,C.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadChatProvider:(0,C.createProxyIdentifier)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,C.createProxyIdentifier)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,C.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,C.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,C.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,C.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,C.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,C.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,C.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,C.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,C.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,C.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,C.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,C.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,C.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,C.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,C.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,C.createProxyIdentifier)("ExtHostChat"),ExtHostChatSlashCommands:(0,C.createProxyIdentifier)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,C.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.createProxyIdentifier)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,C.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,C.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,C.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Ce[284],De([1,0,5,7]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class d{constructor(T){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(C.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,f,w){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const g=this._relatedInformationProviders.get(T);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(f,w)??[]}getRelatedInformation(T,f,w){return this._proxy.$getAiRelatedInformation(f,w)}registerRelatedInformationProvider(T,f,w){const g=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(g,w),this._proxy.$registerAiRelatedInformationProvider(g,f),new L.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(g),this._relatedInformationProviders.delete(g)})}}e.ExtHostRelatedInformation=d}),define(Ce[89],De([1,0,6,17,5,20]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,C.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(w,g){this._extHostLogService=g,this._reportedUsages=new Set,this._telemetryShape=w.getProxy(d.MainContext.MainThreadTelemetry)}report(w,g,P){const k=this.getUsageKey(w,g);this._reportedUsages.has(k)||(this._reportedUsages.add(k),g.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${w}' is deprecated. ${P}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:w}))}getUsageKey(w,g){return`${w}-${g.identifier.value}`}};e.ExtHostApiDeprecationService=T,e.ExtHostApiDeprecationService=T=qe([$e(0,A.IExtHostRpcService),$e(1,L.ILogService)],T),e.NullApiDeprecationService=Object.freeze(new class{report(f,w,g){}})}),define(Ce[285],De([1,0,4,5,7,25]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(g){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new C.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new f,this._getSessionsTaskSingler=new f,this._proxy=g.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(g){return this._providers=g,Promise.resolve()}async getSession(g,P,k,p={}){const _=A.ExtensionIdentifier.toKey(g.identifier),D=[...k].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${_} ${P} ${D}`,async()=>{await this._proxy.$ensureProvider(P);const y=g.displayName||g.name;return this._proxy.$getSession(P,k,_,y,p)})}async getSessions(g,P,k){const p=A.ExtensionIdentifier.toKey(g.identifier),_=[...k].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${p} ${_}`,async()=>{await this._proxy.$ensureProvider(P);const D=g.displayName||g.name;return this._proxy.$getSessions(P,k,p,D)})}async removeSession(g,P){const k=this._authenticationProviders.get(g);return k?k.provider.removeSession(P):this._proxy.$removeSession(g,P)}registerAuthenticationProvider(g,P,k,p){if(this._authenticationProviders.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this._authenticationProviders.set(g,{label:P,provider:k,options:p??{supportsMultipleAccounts:!1}}),this._providers.find(D=>D.id===g)||this._providers.push({id:g,label:P});const _=k.onDidChangeSessions(D=>{this._proxy.$sendDidChangeSessions(g,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this._proxy.$registerAuthenticationProvider(g,P,p?.supportsMultipleAccounts??!1),new d.Disposable(()=>{_.dispose(),this._authenticationProviders.delete(g);const D=this._providers.findIndex(y=>y.id===g);D>-1&&this._providers.splice(D),this._proxy.$unregisterAuthenticationProvider(g)})}$createSession(g,P,k){const p=this._authenticationProviders.get(g);if(p)return Promise.resolve(p.provider.createSession(P,k));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,P){const k=this._authenticationProviders.get(g);if(k)return Promise.resolve(k.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,P){const k=this._authenticationProviders.get(g);if(k)return Promise.resolve(k.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,P){return this._onDidChangeSessions.fire({provider:{id:g,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=T;class f{constructor(){this._inFlightPromises=new Map}getOrCreate(g,P){const k=this._inFlightPromises.get(g);if(k)return k;const p=P().finally(()=>this._inFlightPromises.delete(g));return this._inFlightPromises.set(g,p),p}}}),define(Ce[286],De([1,0,5,20,10]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(f,w){this._proxy=f.getProxy(C.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:g=>w.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(f,w,g){const P=d.WorkspaceEdit.from(f,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(P,void 0,g?.isRefactoring??!1)}};e.ExtHostBulkEdits=A,e.ExtHostBulkEdits=A=qe([$e(0,L.IExtHostRpcService)],A)}),define(Ce[287],De([1,0,13,4,48,3,37,196,5,10]),function(me,e,C,L,d,A,T,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class P{static{this._pool=0}constructor(_,D){this.extension=_,this.provider=D,this.handle=P._pool++}}class k{static{this._nextId=0}constructor(_,D){this.logService=D,this._chatProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new L.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=_.getProxy(w.MainContext.MainThreadChat)}registerChatProvider(_,D,y){const n=new P(_,y);return this._chatProvider.set(n.handle,n),this._proxy.$registerChatProvider(n.handle,D),(0,A.toDisposable)(()=>{this._proxy.$unregisterChatProvider(n.handle),this._chatProvider.delete(n.handle)})}transferChatSession(_,D){const y=d.Iterable.find(this._chatSessions.keys(),n=>this._chatSessions.get(n)===_)??0;typeof y=="number"&&this._proxy.$transferChatSession(y,D)}addChatRequest(_){this._proxy.$addRequest(_)}sendInteractiveRequestToProvider(_,D){this._proxy.$sendRequestToProvider(_,D)}async $prepareChat(_,D,y){const n=this._chatProvider.get(_);if(!n)return;const o=await n.provider.prepareSession(D,y);if(!o)return;const a=k._nextId++;return this._chatSessions.set(a,o),{id:a,requesterUsername:o.requester?.name,requesterAvatarIconUri:o.requester?.icon,responderUsername:o.responder?.name,responderAvatarIconUri:o.responder?.icon,inputPlaceholder:o.inputPlaceholder}}async $resolveRequest(_,D,y,n){const o=this._chatProvider.get(_);if(!o)return;const a=this._chatSessions.get(D);if(!a||!o.provider.resolveRequest)return;const m=await o.provider.resolveRequest(a,y,n);if(m)return{message:typeof m.message=="string"?m.message:g.ChatReplyFollowup.from(m.message)}}async $provideWelcomeMessage(_,D){const y=this._chatProvider.get(_);if(!y||!y.provider.provideWelcomeMessage)return;const n=await y.provider.provideWelcomeMessage(D);if(n)return n.map(o=>typeof o=="string"?o:o.map(a=>g.ChatReplyFollowup.from(a)))}async $provideFollowups(_,D,y){const n=this._chatProvider.get(_);if(!n)return;const o=this._chatSessions.get(D);return!o||!n.provider.provideFollowups?void 0:(await n.provider.provideFollowups(o,y))?.map(m=>g.ChatFollowup.from(m))}$removeRequest(_,D,y){const n=this._chatProvider.get(_);if(!n)return;const o=this._chatSessions.get(D);o&&n.provider.removeRequest&&n.provider.removeRequest(o,y)}async $provideReply(_,D,y,n){const o=this._chatProvider.get(_);if(!o)return;const a=this._chatSessions.get(D);if(!a)return;const m={session:a,message:typeof y.message=="string"?y.message:g.ChatReplyFollowup.to(y.message),variables:{}};if(y.variables)for(const i of Object.keys(y.variables))m.variables[i]=y.variables[i].map(g.ChatVariable.to);const b=T.StopWatch.create(!1);let I;const t={report:i=>{if(!n.isCancellationRequested)if(typeof I>"u"&&(I=b.elapsed()),"responseId"in i)this._proxy.$acceptResponseProgress(_,D,{requestId:i.responseId});else if("placeholder"in i&&"resolvedContent"in i){const c=Promise.all([this._proxy.$acceptResponseProgress(_,D,{placeholder:i.placeholder}),i.resolvedContent]);(0,C.raceCancellation)(c,n).then(u=>{if(!u)return;const[v,S]=u;this._proxy.$acceptResponseProgress(_,D,S,v??void 0)})}else"content"in i?this._proxy.$acceptResponseProgress(_,D,{content:typeof i.content=="string"?i.content:g.MarkdownString.from(i.content)}):this._proxy.$acceptResponseProgress(_,D,i)}};let r;try{r=await o.provider.provideResponseWithProgress(m,t,n),r||(r={errorDetails:{message:(0,f.localize)(0,null)}})}catch(i){r={errorDetails:{message:(0,f.localize)(1,null,i.message),responseIsIncomplete:!0}},this.logService.error(i)}try{if(a.saveState&&this._chatSessions.has(D)){const i=a.saveState();this._proxy.$acceptChatState(D,i)}}catch(i){this.logService.warn(i)}const s={firstProgress:I??0,totalElapsed:b.elapsed()};return{errorDetails:r.errorDetails,timings:s}}async $provideSlashCommands(_,D,y){const n=this._chatProvider.get(_);if(!n)return;const o=this._chatSessions.get(D);return!o||!n.provider.provideSlashCommands?void 0:(await n.provider.provideSlashCommands(o,y))?.map(m=>({...m,kind:g.CompletionItemKind.from(m.kind)}))}$releaseSession(_){this._chatSessions.delete(_)}async $onDidPerformUserAction(_){this._onDidPerformUserAction.fire(_)}}e.ExtHostChat=k}),define(Ce[288],De([1,0,3,5,10,83,25]),function(me,e,C,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatProvider=void 0;class f{static{this._idPool=1}constructor(g,P){this._logService=P,this._providers=new Map,this._pendingRequest=new Map,this._chatAccessAllowList=new T.ExtensionIdentifierMap,this._proxy=g.getProxy(L.MainContext.MainThreadChatProvider)}registerProvider(g,P,k,p){const _=f._idPool++;return this._providers.set(_,{extension:g,provider:k}),this._proxy.$registerProvider(_,P,{extension:g,displayName:p.name??g.value}),(0,C.toDisposable)(()=>{this._proxy.$unregisterProvider(_),this._providers.delete(_)})}async $provideChatResponse(g,P,k,p,_){const D=this._providers.get(g);if(!D)return;const y=new A.Progress(async n=>{if(_.isCancellationRequested){this._logService.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this._proxy.$handleProgressChunk(P,{index:n.index,part:n.part})},{async:!0});return D.provider.provideChatResponse(k.map(d.ChatMessage.to),p,y,_)}allowListExtensionWhile(g,P){this._chatAccessAllowList.set(g,P),P.finally(()=>this._chatAccessAllowList.delete(g))}async requestChatResponseProvider(g,P){if(!this._chatAccessAllowList.has(g))throw new Error("Extension is NOT allowed to make chat requests");const k=this;return{get isRevoked(){return!k._chatAccessAllowList.has(g)},async makeRequest(p,_,D,y){if(!k._chatAccessAllowList.has(g))throw new Error("Access to chat has been revoked");const n=Math.random()*1e6|0;k._pendingRequest.set(n,D);try{await k._proxy.$fetchResponse(g,P,n,p.map(d.ChatMessage.from),_,y)}finally{k._pendingRequest.delete(n)}}}}async $handleResponseFragment(g,P){this._pendingRequest.get(g)?.report(P)}}e.ExtHostChatProvider=f}),define(Ce[289],De([1,0,3,5,7,10,83,13]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatSlashCommands=void 0;class w{static{this._idPool=0}constructor(P,k,p){this._extHostChatProvider=k,this._logService=p,this._commands=new Map,this._proxy=P.getProxy(L.MainContext.MainThreadChatSlashCommands)}registerCommand(P,k,p,_){const D=w._idPool++;return this._commands.set(D,{extension:P,command:p}),this._proxy.$registerCommand(D,k,_.description),(0,C.toDisposable)(()=>{this._proxy.$unregisterCommand(D),this._commands.delete(D)})}async $executeCommand(P,k,p,_,D){const y=this._commands.get(P);if(!y){this._logService.warn(`[CHAT](${P}) CANNOT execute command because the command is not registered`);return}let n=!1;function o(){if(n)throw new Error("Only valid while executing the command")}const a=new f.DeferredPromise;D.onCancellationRequested(()=>a.complete()),setTimeout(()=>a.complete(),3*1e3),this._extHostChatProvider.allowListExtensionWhile(y.extension,a.p);const m=y.command({role:d.ChatMessageRole.User,content:p},{history:_.history.map(A.ChatMessage.to)},new T.Progress(b=>{o(),this._proxy.$handleProgressChunk(k,{content:b.message.value})}),D);try{await(0,f.raceCancellation)(Promise.resolve(m),D)}finally{n=!0,a.complete()}}}e.ExtHostChatSlashCommands=w}),define(Ce[290],De([1,0,3,5,8,10]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class T{static{this._idPool=0}constructor(w){this._resolver=new Map,this._proxy=w.getProxy(L.MainContext.MainThreadChatVariables)}async $resolveVariable(w,g,P){const k=this._resolver.get(w);if(k)try{const p=await k.resolver.resolve(k.data.name,{message:g},P);if(p)return p.map(A.ChatVariable.from)}catch(p){(0,d.onUnexpectedExternalError)(p)}}registerVariableResolver(w,g,P,k){const p=T._idPool++;return this._resolver.set(p,{extension:w.identifier,data:{name:g,description:P},resolver:k}),this._proxy.$registerVariable(p,{name:g,description:P}),(0,C.toDisposable)(()=>{this._resolver.delete(p),this._proxy.$unregisterVariable(p)})}}e.ExtHostChatVariables=T}),define(Ce[291],De([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(A){const T=A.getProxy(C.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(f){return T.$writeText(f)}})}}e.ExtHostClipboard=L}),define(Ce[33],De([1,0,19,7,10,23,5,18,17,77,34,58,2,3,6,20,143,21,64,45,37,85,88]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m,b,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{#e;#t;#i;constructor(S,l,h){this._commands=new Map,this._apiCommands=new Map,this.#e=S.getProxy(T.MainContext.MainThreadCommands),this._logService=l,this.#i=h,this.#t=S.getProxy(T.MainContext.MainThreadTelemetry),this.converter=new s(this,E=>{const R=this._apiCommands.get(E);return R?.result===c.Void?R:void 0},l),this._argumentProcessors=[{processArgument(E){return(0,g.revive)(E)}},{processArgument(E){return(0,A.cloneAndChange)(E,function(R){if(P.Range.isIRange(R))return d.Range.to(R);if(k.Position.isIPosition(R))return d.Position.to(R);if(P.Range.isIRange(R.range)&&p.URI.isUri(R.uri))return d.location.to(R);if(R instanceof o.VSBuffer)return R.buffer.buffer;if(!Array.isArray(R))return R})}}]}registerArgumentProcessor(S){this._argumentProcessors.push(S)}registerApiCommand(S){const l=this.registerCommand(!1,S.id,async(...h)=>{const E=S.args.map((M,U)=>{if(!M.validate(h[U]))throw new Error(`Invalid argument '${M.name}' when running '${S.id}', received: ${h[U]}`);return M.convert(h[U])}),R=await this.executeCommand(S.internalId,...E);return S.result.convert(R,h,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this._apiCommands.set(S.id,S),new L.Disposable(()=>{l.dispose(),this._apiCommands.delete(S.id)})}registerCommand(S,l,h,E,R,M){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:h,thisArg:E,description:R,extension:M}),S&&this.#e.$registerCommand(l),new L.Disposable(()=>{this._commands.delete(l)&&S&&this.#e.$unregisterCommand(l)})}executeCommand(S,...l){return this._logService.trace("ExtHostCommands#executeCommand",S),this._doExecuteCommand(S,l,!0)}async _doExecuteCommand(S,l,h){if(this._commands.has(S))return this.#e.$fireCommandActivationEvent(S),this._executeContributedCommand(S,l,!1);{let E=!1;const R=(0,A.cloneAndChange)(l,function(M){if(M instanceof L.Position)return d.Position.from(M);if(M instanceof L.Range)return d.Range.from(M);if(M instanceof L.Location)return d.location.from(M);if(L.NotebookRange.isNotebookRange(M))return d.NotebookRange.from(M);if(M instanceof ArrayBuffer)return E=!0,o.VSBuffer.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return E=!0,o.VSBuffer.wrap(M);if(M instanceof o.VSBuffer)return E=!0,M;if(!Array.isArray(M))return M});try{const M=await this.#e.$executeCommand(S,E?new a.SerializableObjectWithBuffers(R):R,h);return(0,g.revive)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this._doExecuteCommand(S,l,!1);throw M}}}async _executeContributedCommand(S,l,h){const E=this._commands.get(S);if(!E)throw new Error("Unknown command");const{callback:R,thisArg:M,description:U}=E;if(U)for(let x=0;x<U.args.length;x++)try{(0,C.validateConstraint)(l[x],U.args[x].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${U.args[x].name}' - ${U.args[x].description}`)}const F=b.StopWatch.create();try{return await R.apply(M,l)}catch(x){if(S===this.converter.delegatingCommandId){const $=this.converter.getActualCommand(...l);$&&(S=$.command)}if(this._logService.error(x,S,E.extension?.identifier),!h)throw x;if(E.extension?.identifier){const $=this.#i.onExtensionError(E.extension.identifier,x);this._logService.trace("forwarded error to extension?",$,E.extension?.identifier)}throw new class extends Error{constructor(){super((0,m.toErrorMessage)(x)),this.id=S,this.source=E.extension?.displayName??E.extension?.name}}}finally{this._reportTelemetry(E,S,F.elapsed())}}_reportTelemetry(S,l,h){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new I.TelemetryTrustedValue(l),duration:h})}$executeContributedCommand(S,...l){this._logService.trace("ExtHostCommands#$executeContributedCommand",S);const h=this._commands.get(S);return h?(l=l.map(E=>this._argumentProcessors.reduce((R,M)=>M.processArgument(R,h.extension?.identifier),E)),this._executeContributedCommand(S,l,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this._logService.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(l=>(S&&(l=l.filter(h=>h[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const S=Object.create(null);for(const[l,h]of this._commands){const{description:E}=h;E&&(S[l]=E)}return Promise.resolve(S)}};e.ExtHostCommands=r,e.ExtHostCommands=r=qe([$e(0,y.IExtHostRpcService),$e(1,w.ILogService),$e(2,t.IExtHostTelemetry)],r),e.IExtHostCommands=(0,D.createDecorator)("IExtHostCommands");class s{constructor(S,l,h){this._commands=S,this._lookupApiCommand=l,this._logService=h,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(S,l){if(!S)return;const h={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return h;const E=this._lookupApiCommand(S.command);if(E)h.id=E.internalId,h.arguments=E.args.map((R,M)=>R.convert(S.arguments&&S.arguments[M]));else if((0,f.isNonEmptyArray)(S.arguments)){const R=`${S.command}/${++this._cachIdPool}`;this._cache.set(R,S),l.add((0,_.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),h.$ident=R,h.id=this.delegatingCommandId,h.arguments=[R],this._logService.trace("CommandsConverter#CREATE",S.command,R)}return h}fromInternal(S){return typeof S.$ident=="string"?this._cache.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this._cache.get(S[0])}_executeConvertedCommand(...S){const l=this.getActualCommand(...S);return this._logService.trace("CommandsConverter#EXECUTE",S[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.CommandsConverter=s;class i{static{this.Uri=new i("uri","Uri of a text document",S=>p.URI.isUri(S),S=>S)}static{this.Position=new i("position","A position in a text document",S=>L.Position.isPosition(S),d.Position.from)}static{this.Range=new i("range","A range in a text document",S=>L.Range.isRange(S),d.Range.from)}static{this.Selection=new i("selection","A selection in a text document",S=>L.Selection.isSelection(S),d.Selection.from)}static{this.Number=new i("number","",S=>typeof S=="number",S=>S)}static{this.String=new i("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=i.Arr(i.String)}static Arr(S){return new i(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,l=>Array.isArray(l)&&l.every(h=>S.validate(h)),l=>l.map(h=>S.convert(h)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",S=>S instanceof L.CallHierarchyItem,d.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",S=>S instanceof L.TypeHierarchyItem,d.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VSCodium TestItem",S=>S instanceof n.TestItemImpl,d.TestItem.from)}constructor(S,l,h,E){this.name=S,this.description=l,this.validate=h,this.convert=E}optional(){return new i(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,l){return new i(S??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i;class c{static{this.Void=new c("no result",S=>S)}constructor(S,l){this.description=S,this.convert=l}}e.ApiCommandResult=c;class u{constructor(S,l,h,E,R){this.id=S,this.internalId=l,this.description=h,this.args=E,this.result=R}}e.ApiCommand=u}),define(Ce[292],De([1,0,18,16,2,81,128,47,132,33,10,7]),function(me,e,C,L,d,A,T,f,w,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const p=[new g.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",D(P.DocumentHighlight.to))),new g.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,C.isFalsyOrEmpty)(n))return;class a extends k.SymbolInformation{static to(b){const I=new a(b.name,P.SymbolKind.to(b.kind),b.containerName||"",new k.Location(o[0],P.Range.to(b.range)));return I.detail=b.detail,I.range=I.location.range,I.selectionRange=P.Range.to(b.selectionRange),I.children=b.children?b.children.map(a.to):[],I}}return n.map(a.to)})),new g.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(P.TextEdit.to))),new g.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range,new g.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(P.TextEdit.to))),new g.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,new g.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new g.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(P.TextEdit.to))),new g.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new g.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new g.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new g.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new g.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location-instances.",D(P.location.to))),new g.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Hover-instances.",D(P.Hover.to))),new g.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>k.Position.isPosition(o)),n=>n.map(P.Position.from))],new g.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(o=>{let a;for(const m of o.reverse())a=new k.SelectionRange(P.Range.to(m),a);return a}))),new g.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.ApiCommandArgument.String.with("query","Search string")],new g.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(P.WorkspaceSymbol.to))),new g.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(P.CallHierarchyItem.to))),new g.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.ApiCommandArgument.CallHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(P.CallHierarchyIncomingCall.to))),new g.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.ApiCommandArgument.CallHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(P.CallHierarchyOutgoingCall.to))),new g.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:P.Range.to(n.range),placeholder:n.text}})),new g.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("newName","The new symbol name")],new g.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return P.WorkspaceEdit.to(n)}})),new g.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(P.DocumentLink.to))),new g.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new k.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new g.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,T.decodeSemanticTokensDto)(n);if(o.type==="full")return new k.SemanticTokens(o.data,void 0)})),new g.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range.optional()],new g.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new k.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new g.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,T.decodeSemanticTokensDto)(n);if(o.type==="full")return new k.SemanticTokens(o.data,void 0)})),new g.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,o,a)=>{if(!n)return new k.CompletionList([]);const m=n.suggestions.map(b=>P.CompletionItem.to(b,a));return new k.CompletionList(m,n.incomplete)})),new g.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return P.SignatureHelp.to(n)})),new g.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,o,a)=>D(m=>new k.CodeLens(P.Range.to(m.range),m.command&&a.fromInternal(m.command)))(n))),new g.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>k.Range.isRange(n),n=>k.Selection.isSelection(n)?P.Selection.from(n):P.Range.from(n)),g.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),g.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,o,a)=>D(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(m.command)}else{const b=new k.CodeAction(m.title,m.kind?new k.CodeActionKind(m.kind):void 0);return m.edit&&(b.edit=P.WorkspaceEdit.to(m.edit)),m.command&&(b.command=a.fromInternal(m.command)),b.isPreferred=m.isPreferred,b}})(n))),new g.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new k.ColorInformation(P.Range.to(o.range),P.Color.to(o.color))):[])),new g.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.ApiCommandArgument("color","The color to show and insert",n=>n instanceof k.Color,P.Color.from),new g.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:P.Range.from(n.range)}))],new g.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(P.ColorPresentation.to):[])),new g.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to an array of Inlay objects",(n,o,a)=>n.map(P.InlayHint.to.bind(void 0,a)))),new g.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(P.FoldingRange.to)})),new g.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",D(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>P.NotebookExclusiveDocumentPattern.to(o))})))),new g.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(P.InlineValue.to))),new g.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",n=>d.URI.isUri(n)||typeof n=="string"&&(0,w.matchesSomeScheme)(n,L.Schemas.http,L.Schemas.https),n=>n),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[P.ViewColumn.from(n),void 0]:[P.ViewColumn.from(n.viewColumn),P.TextEditorOpenOptions.from(n)])).optional(),g.ApiCommandArgument.String.with("label","").optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.ApiCommandArgument.Uri.with("resource","Resource to open"),g.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VSCodium's default editor"),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[P.ViewColumn.from(n),void 0]:[P.ViewColumn.from(n.viewColumn),P.TextEditorOpenOptions.from(n)])).optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),g.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),g.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[P.ViewColumn.from(n.viewColumn),P.TextEditorOpenOptions.from(n)]).optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(P.TypeHierarchyItem.to))),new g.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.ApiCommandArgument.TypeHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(P.TypeHierarchyItem.to))),new g.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.ApiCommandArgument.TypeHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(P.TypeHierarchyItem.to))),new g.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.ApiCommandArgument.TestItem],g.ApiCommandResult.Void),new g.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.ApiCommandResult.Void),new g.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.ApiCommandArgument.String.with("name","The context key name"),new g.ApiCommandArgument("value","The context key value",()=>!0,n=>n)],g.ApiCommandResult.Void),new g.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.StringArray,new g.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",n=>P.MappedEditsContext.is(n),n=>P.MappedEditsContext.from(n))],new g.ApiCommandResult("A promise that resolves to a workspace edit or null",n=>n?P.WorkspaceEdit.to(n):null))];class _{static register(o){p.forEach(o.registerApiCommand,o),this._registerValidateWhenClausesCommand(o)}static _registerValidateWhenClausesCommand(o){o.registerCommand(!1,"_validateWhenClauses",f.validateWhenClauses)}}e.ExtHostApiCommands=_;function D(n){return o=>{if(Array.isArray(o))return o.map(n)}}function y(n){if(!Array.isArray(n))return;const o=[];for(const a of n)A.isLocationLink(a)?o.push(P.DefinitionLink.to(a)):o.push(P.location.to(a));return o}}),define(Ce[293],De([1,0,13,70,4,3,2,81,25,10,7,5,27]),function(me,e,C,L,d,A,T,f,w,g,P,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function _(D,y,n){const o=D.getProxy(k.MainContext.MainThreadComments);class a{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new w.ExtensionIdentifierMap,y.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const v=this._commentControllers.get(u.handle);return v?v.value:u}else if(u&&u.$mid===7){const v=this._commentControllers.get(u.commentControlHandle);if(!v)return u;const S=v.getCommentThread(u.commentThreadHandle);return S?S.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const v=this._commentControllers.get(u.thread.commentControlHandle);if(!v)return u;const S=v.getCommentThread(u.thread.commentThreadHandle);return S?u.$mid===8?S.value:{thread:S.value,text:u.text}:u}else if(u&&u.$mid===10){const v=this._commentControllers.get(u.thread.commentControlHandle);if(!v)return u;const S=v.getCommentThread(u.thread.commentThreadHandle);if(!S)return u;const l=u.commentUniqueId,h=S.getCommentByUniqueId(l);return h||u}else if(u&&u.$mid===11){const v=this._commentControllers.get(u.thread.commentControlHandle);if(!v)return u;const S=v.getCommentThread(u.thread.commentThreadHandle);if(!S)return u;const l=u.text,h=u.commentUniqueId,E=S.getCommentByUniqueId(h);return E?(typeof E.body=="string"?E.body=l:E.body=new P.MarkdownString(l),E):u}return u}})}createCommentController(u,v,S){const l=a.handlePool++,h=new b(u,l,v,S);this._commentControllers.set(h.handle,h);const E=this._commentControllersByExtension.get(u.identifier)||[];return E.push(h),this._commentControllersByExtension.set(u.identifier,E),h.value}$createCommentThreadTemplate(u,v,S){const l=this._commentControllers.get(u);l&&l.$createCommentThreadTemplate(v,S)}async $updateCommentThreadTemplate(u,v,S){const l=this._commentControllers.get(u);l&&l.$updateCommentThreadTemplate(v,S)}$deleteCommentThread(u,v){this._commentControllers.get(u)?.$deleteCommentThread(v)}$provideCommentingRanges(u,v,S){const l=this._commentControllers.get(u);if(!l||!l.commentingRangeProvider)return Promise.resolve(void 0);const h=n.getDocument(T.URI.revive(v));return(0,C.asPromise)(async()=>{const E=await l.commentingRangeProvider.provideCommentingRanges(h,S);let R;return Array.isArray(E)?R={ranges:E,fileComments:!1}:E?R={ranges:E.ranges||[],fileComments:E.fileComments||!1}:R=E??void 0,R}).then(E=>{let R;return E&&(R={ranges:E.ranges.map(M=>g.Range.from(M)),fileComments:E.fileComments}),R})}$toggleReaction(u,v,S,l,h){const E=this._commentControllers.get(u);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,C.asPromise)(()=>{const R=E.getCommentThread(v);if(R){const M=R.getCommentByUniqueId(l.uniqueIdInThread);if(E!==void 0&&M&&E.reactionHandler)return E.reactionHandler(M,r(h))}return Promise.resolve(void 0)})}}class m{static{this._handlePool=0}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){(u===void 0!=(this._range===void 0)||!u||!this._range||!u.isEqual(this._range))&&(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(u){this._state=u,this.modifications.state=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(u,v,S,l,h,E,R,M){this._commentControllerHandle=v,this._id=S,this._uri=l,this._range=h,this._comments=E,this.extensionDescription=R,this._isTemplate=M,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new d.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${u}.${this.handle}`),o.$createCommentThread(v,this.handle,this._id,this._uri,g.Range.from(this._range),R.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{o.$deleteCommentThread(v,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(F){U.range=F},get comments(){return U.comments},set comments(F){U.comments=F},get collapsibleState(){return U.collapsibleState},set collapsibleState(F){U.collapsibleState=F},get canReply(){return U.canReply},set canReply(F){U.canReply=F},get contextValue(){return U.contextValue},set contextValue(F){U.contextValue=F},get label(){return U.label},set label(F){U.label=F},get state(){return U.state},set state(F){U.state=F},dispose:()=>{U.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const u=S=>Object.prototype.hasOwnProperty.call(this.modifications,S),v={};u("range")&&(v.range=g.Range.from(this._range)),u("label")&&(v.label=this.label),u("contextValue")&&(v.contextValue=this.contextValue??null),u("comments")&&(v.comments=this._comments.map(S=>I(this,S,this._commentsMap,this.extensionDescription))),u("collapsibleState")&&(v.collapseState=s(this._collapseState)),u("canReply")&&(v.canReply=this.canReply),u("state")&&(v.state=i(this._state)),u("isTemplate")&&(v.isTemplate=this._isTemplate),this.modifications={},o.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,v)}getCommentByUniqueId(u){for(const v of this._commentsMap){const S=v[0],l=v[1];if(u===l)return S}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose())}}qe([(0,L.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(u){this._commentingRangeProvider=u,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,o.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(u,v,S,l){this._extension=u,this._handle=v,this._id=S,this._label=l,this._threads=new Map,o.$registerCommentController(this.handle,S,l);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(E){h.options=E},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(E){h.commentingRangeProvider=E},get reactionHandler(){return h.reactionHandler},set reactionHandler(E){h.reactionHandler=E},createCommentThread(E,R,M){return h.createCommentThread(E,R,M).value},dispose:()=>{h.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(u,v,S){v===void 0&&(0,p.checkProposedApiEnabled)(this._extension,"fileComments");const l=new m(this.id,this.handle,void 0,u,v,S,this._extension,!1);return this._threads.set(l.handle,l),l}$createCommentThreadTemplate(u,v){const S=new m(this.id,this.handle,void 0,T.URI.revive(u),g.Range.to(v),[],this._extension,!0);return S.collapsibleState=f.CommentThreadCollapsibleState.Expanded,this._threads.set(S.handle,S),S}$updateCommentThreadTemplate(u,v){const S=this._threads.get(u);S&&(S.range=g.Range.to(v))}$deleteCommentThread(u){this._threads.get(u)?.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._localDisposables.forEach(u=>u.dispose())}}function I(c,u,v,S){let l=v.get(u);return l||(l=++c.commentHandle,v.set(u,l)),u.state!==void 0&&(0,p.checkProposedApiEnabled)(S,"commentsDraftState"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:l,body:typeof u.body=="string"?u.body:g.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(h=>t(h)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?g.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?T.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function s(c){if(c!==void 0)switch(c){case P.CommentThreadCollapsibleState.Expanded:return f.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return f.CommentThreadCollapsibleState.Collapsed}return f.CommentThreadCollapsibleState.Collapsed}function i(c){if(c!==void 0)switch(c){case P.CommentThreadState.Unresolved:return f.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return f.CommentThreadState.Resolved}return f.CommentThreadState.Unresolved}return new a}e.createExtHostComments=_}),define(Ce[294],De([1,0,23,5,26,20]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let T=class{constructor(P,k){this._mainThreadConsole=P.getProxy(L.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(P,k){const p=this,_=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){p._handleConsoleCall(P,k,_,arguments)}})}_handleConsoleCall(P,k,p,_){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:w(_,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(P,p,_)}};e.AbstractExtHostConsoleForwarder=T,e.AbstractExtHostConsoleForwarder=T=qe([$e(0,A.IExtHostRpcService),$e(1,d.IExtHostInitDataService)],T);const f=1e5;function w(g,P){const k=[];if(g.length)for(let p=0;p<g.length;p++){let _=g[p];if(typeof _>"u")_="undefined";else if(_ instanceof Error){const D=_;D.stack?_=D.stack:_=D.toString()}k.push(_)}if(P){const p=new Error().stack;p&&k.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,C.safeStringify)(k);return p.length>f?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(Ce[146],De([1,0,2,5,7,6,20,17,18,15,14,27]),function(me,e,C,L,d,A,T,f,w,g,P,k){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class{static{p=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(y,n){this._logService=n,this._provider=new Map,this._proxy=y.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(y,n){const o=p._handlePool++;this._provider.set(o,{provider:y,extensionDescription:n}),this._proxy.$registerDecorationProvider(o,n.identifier.value);const a=y.onDidChangeFileDecorations&&y.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(o,null);return}const b=(0,w.asArray)(m);if(b.length<=p._maxEventSize){this._proxy.$onDidChange(o,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",n.identifier.value,b.length);const I=b.map(s=>({uri:s,rank:(0,g.count)(s.path,"/")})),t=(0,w.groupBy)(I,(s,i)=>s.rank-i.rank||(0,g.compare)(s.uri.path,i.uri.path)),r=[];e:for(const s of t){let i;for(const c of s){const u=(0,P.dirname)(c.uri.path);if(i!==u&&(i=u,r.push(c.uri)>=p._maxEventSize))break e}}this._proxy.$onDidChange(o,r)});return new d.Disposable(()=>{a?.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(y,n,o){if(!this._provider.has(y))return Object.create(null);const a=Object.create(null),{provider:m,extensionDescription:b}=this._provider.get(y);return await Promise.all(n.map(async I=>{try{const{uri:t,id:r}=I,s=await Promise.resolve(m.provideFileDecoration(C.URI.revive(t),o));if(!s)return;try{d.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,k.checkProposedApiEnabled)(b,"codiconDecoration"),a[r]=[s.propagate,s.tooltip,s.badge,s.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${b.identifier.value}': ${i}`)}}catch(t){this._logService.error(t)}})),a}};e.ExtHostDecorations=_,e.ExtHostDecorations=_=p=qe([$e(0,T.IExtHostRpcService),$e(1,f.ILogService)],_),e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(Ce[295],De([1,0,197,131,2,5,7,10,4,17,28,52]),function(me,e,C,L,d,A,T,f,w,g,P,k){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class _{#e;#t;#i;constructor(n,o,a,m,b,I,t,r){this._name=n,this._owner=o,this._maxDiagnosticsTotal=a,this._maxDiagnosticsPerFile=m,this._modelVersionIdProvider=b,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(m,a),this.#i=new P.ResourceMap(s=>I.getComparisonKey(s)),this.#e=t,this.#t=r}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(n,o){if(!n){this.clear();return}this._checkDisposed();let a=[];if(d.URI.isUri(n)){if(!o){this.delete(n);return}this.#i.set(n,o.slice()),a=[n]}else if(Array.isArray(n)){a=[];let I;n=[...n].sort(_._compareIndexedTuplesByUri);for(const t of n){const[r,s]=t;if((!I||r.toString()!==I.toString())&&(I&&this.#i.get(I).length===0&&this.#i.delete(I),I=r,a.push(r),this.#i.set(r,[])),s)this.#i.get(r)?.push(...s);else{const i=this.#i.get(r);i&&(i.length=0)}}}if(this.#t.fire(a),!this.#e)return;const m=[];let b=0;for(const I of a){let t=[];const r=this.#i.get(I);if(r)if(r.length>this._maxDiagnosticsPerFile){t=[];const s=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const c of r)if(c.severity===s[i]&&t.push({...f.Diagnostic.from(c),modelVersionId:this._modelVersionIdProvider(I)})===this._maxDiagnosticsPerFile)break e;t.push({severity:L.MarkerSeverity.Info,message:(0,C.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(s=>({...f.Diagnostic.from(s),modelVersionId:this._modelVersionIdProvider(I)}));if(m.push([I,t]),b+=t.length,b>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,m)}delete(n){this._checkDisposed(),this.#t.fire([n]),this.#i.delete(n),this.#e?.$changeMany(this._owner,[[n,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(n,o){this._checkDisposed();for(const[a,m]of this)n.call(o,a,m,this)}*[Symbol.iterator](){this._checkDisposed();for(const n of this.#i.keys())yield[n,this.get(n)]}get(n){this._checkDisposed();const o=this.#i.get(n);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(n){return this._checkDisposed(),Array.isArray(this.#i.get(n))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(n,o){return n[0].toString()<o[0].toString()?-1:n[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=_;let D=class{static{p=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*p._maxDiagnosticsPerFile}static _mapper(n){const o=new P.ResourceMap;for(const a of n)o.set(a,a);return{uris:Object.freeze(Array.from(o.values()))}}constructor(n,o,a,m){this._logService=o,this._fileSystemInfoService=a,this._extHostDocumentsAndEditors=m,this._collections=new Map,this._onDidChangeDiagnostics=new w.DebounceEmitter({merge:b=>b.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this._onDidChangeDiagnostics.event,p._mapper),this._proxy=n.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(n,o){const{_collections:a,_proxy:m,_onDidChangeDiagnostics:b,_logService:I,_fileSystemInfoService:t,_extHostDocumentsAndEditors:r}=this,s=new class{$changeMany(u,v){m.$changeMany(u,v),I.trace("[DiagnosticCollection] change many (extension, owner, uris)",n.value,u,v.length===0?"CLEARING":v)}$clear(u){m.$clear(u),I.trace("[DiagnosticCollection] remove all (extension, owner)",n.value,u)}dispose(){m.dispose()}};let i;if(!o)o="_generated_diagnostic_collection_name_#"+p._idPool++,i=o;else if(!a.has(o))i=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do i=o+p._idPool++;while(a.has(i))}return new class extends _{constructor(){super(o,i,p._maxDiagnosticsTotal,p._maxDiagnosticsPerFile,u=>r.getDocument(u)?.version,t.extUri,s,b),a.set(i,this)}dispose(){super.dispose(),a.delete(i)}}}getDiagnostics(n){if(n)return this._getDiagnostics(n);{const o=new Map,a=[];for(const m of this._collections.values())m.forEach((b,I)=>{let t=o.get(b.toString());typeof t>"u"&&(t=a.length,o.set(b.toString(),t),a.push([b,[]])),a[t][1]=a[t][1].concat(...I)});return a}}_getDiagnostics(n){let o=[];for(const a of this._collections.values())a.has(n)&&(o=o.concat(a.get(n)));return o}$acceptMarkersChange(n){if(!this._mirrorCollection){const o="_generated_mirror",a=new _(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,m=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,a),this._mirrorCollection=a}for(const[o,a]of n)this._mirrorCollection.set(d.URI.revive(o),a.map(f.Diagnostic.to))}};e.ExtHostDiagnostics=D,e.ExtHostDiagnostics=D=p=qe([$e(1,g.ILogService),$e(2,k.IExtHostFileSystemInfo)],D)}),define(Ce[296],De([1,0,2,5,27]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(f){this._proxy=f.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(f,w){return w?.allowUIResources&&(0,d.checkProposedApiEnabled)(f,"showLocal"),this._proxy.$showOpenDialog(w).then(g=>g?g.map(P=>C.URI.revive(P)):void 0)}showSaveDialog(f){return this._proxy.$showSaveDialog(f).then(w=>w?C.URI.revive(w):void 0)}}e.ExtHostDialogs=A}),define(Ce[297],De([1,0,8,2,7,5,16,22,15]),function(me,e,C,L,d,A,T,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class g{static{this._handlePool=0}constructor(k,p,_){this._documentsAndEditors=p,this._logService=_,this._documentContentProviders=new Map,this._proxy=k.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,p){if(Object.keys(T.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const _=g._handlePool++;this._documentContentProviders.set(_,p),this._proxy.$registerTextContentProvider(_,k);let D;return typeof p.onDidChange=="function"&&(D=p.onDidChange(y=>{if(y.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${y.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(y)&&this.$provideTextDocumentContent(_,y).then(n=>{if(!n&&typeof n!="string")return;const o=this._documentsAndEditors.getDocument(y);if(!o)return;const a=(0,w.splitLines)(n);if(!o.equalLines(a))return this._proxy.$onVirtualDocumentChange(y,n)},C.onUnexpectedError)})),new d.Disposable(()=>{this._documentContentProviders.delete(_)&&this._proxy.$unregisterTextContentProvider(_),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(k,p){const _=this._documentContentProviders.get(k);return _?Promise.resolve(_.provideTextDocumentContent(L.URI.revive(p),f.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.ExtHostDocumentContentProvider=g}),define(Ce[298],De([1,0,4,3,2,5,139,10,19,23,7,8]),function(me,e,C,L,d,A,T,f,w,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class p{constructor(D,y){this._onDidAddDocument=new C.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidRemoveDocument=new C.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidChangeDocument=new C.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidSaveDocument=new C.Emitter({onListenerError:k.onUnexpectedExternalError}),this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=y,this._documentsAndEditors.onDidRemoveDocuments(n=>{for(const o of n)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(n=>{for(const o of n)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(D){if(!D)return;const y=this._documentsAndEditors.getDocument(D);if(y)return y}getDocument(D){const y=this.getDocumentData(D);if(!y?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return y.document}ensureDocumentData(D){const y=this._documentsAndEditors.getDocument(D);if(y)return Promise.resolve(y);let n=this._documentLoader.get(D.toString());return n||(n=this._proxy.$tryOpenDocument(D).then(o=>{this._documentLoader.delete(D.toString());const a=d.URI.revive(o);return(0,w.assertIsDefined)(this._documentsAndEditors.getDocument(a))},o=>(this._documentLoader.delete(D.toString()),Promise.reject(o))),this._documentLoader.set(D.toString(),n)),n}createDocumentData(D){return this._proxy.$tryCreateDocument(D).then(y=>d.URI.revive(y))}$acceptModelLanguageChanged(D,y){const n=d.URI.revive(D),o=this._documentsAndEditors.getDocument(n);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(y),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(D){const y=d.URI.revive(D),n=this._documentsAndEditors.getDocument(y);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this._onDidSaveDocument.fire(n.document)}$acceptDirtyStateChanged(D,y){const n=d.URI.revive(D),o=this._documentsAndEditors.getDocument(n);if(!o)throw new Error("unknown document");o._acceptIsDirty(y),this._onDidChangeDocument.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,y,n){const o=d.URI.revive(D),a=this._documentsAndEditors.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(n),a.onEvents(y);let m;y.isUndoing?m=P.TextDocumentChangeReason.Undo:y.isRedoing&&(m=P.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,g.deepFreeze)({document:a.document,contentChanges:y.changes.map(b=>({range:f.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:m}))}setWordDefinitionFor(D,y){(0,T.setWordDefinitionFor)(D,y)}}e.ExtHostDocuments=p}),define(Ce[65],De([1,0,54,4,3,2,6,5,139,20,144,10,17,28,16,48,55]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class o{constructor(b){this.value=b,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let a=class{constructor(b,I){this._extHostRpc=b,this._logService=I,this._activeEditorId=null,this._editors=new Map,this._documents=new _.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(b){this.acceptDocumentsAndEditorsDelta(b)}acceptDocumentsAndEditorsDelta(b){const I=[],t=[],r=[];if(b.removedDocuments)for(const s of b.removedDocuments){const i=A.URI.revive(s),c=this._documents.get(i);c?.unref()&&(this._documents.delete(i),I.push(c.value))}if(b.addedDocuments)for(const s of b.addedDocuments){const i=A.URI.revive(s.uri);let c=this._documents.get(i);if(c&&i.scheme!==D.Schemas.vscodeNotebookCell&&i.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new o(new w.ExtHostDocumentData(this._extHostRpc.getProxy(f.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(i,c),t.push(c.value)),c.ref()}if(b.removedEditors)for(const s of b.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&r.push(i)}if(b.addedEditors)for(const s of b.addedEditors){const i=A.URI.revive(s.documentUri);C.ok(this._documents.has(i),`document '${i}' does not exist`),C.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const c=this._documents.get(i).value,u=new P.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(f.MainContext.MainThreadTextEditors),this._logService,new n.Lazy(()=>c.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(v=>k.Range.to(v)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,u)}b.newActiveEditor!==void 0&&(C.ok(b.newActiveEditor===null||this._editors.has(b.newActiveEditor),`active editor '${b.newActiveEditor}' does not exist`),this._activeEditorId=b.newActiveEditor),(0,d.dispose)(I),(0,d.dispose)(r),b.removedDocuments&&this._onDidRemoveDocuments.fire(I),b.addedDocuments&&this._onDidAddDocuments.fire(t),(b.removedEditors||b.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),b.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(b){return this._documents.get(b)?.value}allDocuments(){return y.Iterable.map(this._documents.values(),b=>b.value)}getEditor(b){return this._editors.get(b)}activeEditor(b){if(!this._activeEditorId)return;const I=this._editors.get(this._activeEditorId);return b?I:I?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=a,e.ExtHostDocumentsAndEditors=a=qe([$e(0,g.IExtHostRpcService),$e(1,p.ILogService)],a),e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[66],De([1,0,10,5,2,4,6,7,20,19,69]),function(me,e,C,L,d,A,T,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class k{constructor(n,o,a){this._activeTabIdGetter=a,this._parentGroup=o,this.acceptDtoUpdate(n)}get apiObject(){if(!this._apiObject){const n=this,o={get isActive(){return n._dto.id===n._activeTabIdGetter()},get label(){return n._dto.label},get input(){return n._input},get isDirty(){return n._dto.isDirty},get isPinned(){return n._dto.isPinned},get isPreview(){return n._dto.isPreview},get group(){return n._parentGroup.apiObject}};this._apiObject=Object.freeze(o)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(n){this._dto=n,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new f.TextTabInput(d.URI.revive(this._dto.input.uri));case 2:return new f.TextDiffTabInput(d.URI.revive(this._dto.input.original),d.URI.revive(this._dto.input.modified));case 3:return new f.TextMergeTabInput(d.URI.revive(this._dto.input.base),d.URI.revive(this._dto.input.input1),d.URI.revive(this._dto.input.input2),d.URI.revive(this._dto.input.result));case 6:return new f.CustomEditorTabInput(d.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new f.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new f.NotebookEditorTabInput(d.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new f.NotebookDiffEditorTabInput(d.URI.revive(this._dto.input.original),d.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new f.TerminalEditorTabInput;case 9:return new f.InteractiveWindowInput(d.URI.revive(this._dto.input.uri),d.URI.revive(this._dto.input.inputBoxUri));default:return}}}class p{constructor(n,o){this._tabs=[],this._activeTabId="",this._dto=n,this._activeGroupIdGetter=o;for(const a of n.tabs)a.isActive&&(this._activeTabId=a.id),this._tabs.push(new k(a,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const n=this,o={get isActive(){return n._dto.groupId===n._activeGroupIdGetter()},get viewColumn(){return C.ViewColumn.to(n._dto.viewColumn)},get activeTab(){return n._tabs.find(a=>a.tabId===n._activeTabId)?.apiObject},get tabs(){return Object.freeze(n._tabs.map(a=>a.apiObject))}};this._apiObject=Object.freeze(o)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(n){this._dto=n}acceptTabOperation(n){if(n.kind===0){const a=new k(n.tabDto,this,()=>this.activeTabId());return this._tabs.splice(n.index,0,a),n.tabDto.isActive&&(this._activeTabId=a.tabId),a}else if(n.kind===1){const a=this._tabs.splice(n.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${n.index} which does not exist`);return a.tabId===this._activeTabId&&(this._activeTabId=""),a}else if(n.kind===3){if(n.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this._tabs.splice(n.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${n.oldIndex} which does not exist`);return this._tabs.splice(n.index,0,a),a}const o=this._tabs.find(a=>a.tabId===n.tabDto.id);if(!o)throw new Error("INVALID tab");return n.tabDto.isActive?this._activeTabId=n.tabDto.id:this._activeTabId===n.tabDto.id&&!n.tabDto.isActive&&(this._activeTabId=""),o.acceptDtoUpdate(n.tabDto),o}activeTabId(){return this._activeTabId}}let _=class{constructor(n){this._onDidChangeTabs=new A.Emitter,this._onDidChangeTabGroups=new A.Emitter,this._extHostTabGroups=[],this._proxy=n.getProxy(L.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const n=this,o={onDidChangeTabGroups:n._onDidChangeTabGroups.event,onDidChangeTabs:n._onDidChangeTabs.event,get all(){return Object.freeze(n._extHostTabGroups.map(a=>a.apiObject))},get activeTabGroup(){const a=n._activeGroupId;return(0,g.assertIsDefined)(n._extHostTabGroups.find(b=>b.groupId===a)?.apiObject)},close:async(a,m)=>{const b=Array.isArray(a)?a:[a];return b.length?D(b[0])?this._closeGroups(b,m):this._closeTabs(b,m):!0}};this._apiObject=Object.freeze(o)}return this._apiObject}$acceptEditorTabModel(n){const o=new Set(this._extHostTabGroups.map(s=>s.groupId)),a=new Set(n.map(s=>s.groupId)),m=(0,P.diffSets)(o,a),b=this._extHostTabGroups.filter(s=>m.removed.includes(s.groupId)).map(s=>s.apiObject),I=[],t=[];this._extHostTabGroups=n.map(s=>{const i=new p(s,()=>this._activeGroupId);return m.added.includes(i.groupId)?I.push(i.apiObject):t.push(i.apiObject),i});const r=(0,g.assertIsDefined)(n.find(s=>s.isActive===!0)?.groupId);r!==void 0&&this._activeGroupId!==r&&(this._activeGroupId=r),this._onDidChangeTabGroups.fire(Object.freeze({opened:I,closed:b,changed:t}))}$acceptTabGroupUpdate(n){const o=this._extHostTabGroups.find(a=>a.groupId===n.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(n),n.isActive&&(this._activeGroupId=n.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(n){const o=this._extHostTabGroups.find(m=>m.groupId===n.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const a=o.acceptTabOperation(n);switch(n.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}_findExtHostTabFromApi(n){for(const o of this._extHostTabGroups)for(const a of o.tabs)if(a.apiObject===n)return a}_findExtHostTabGroupFromApi(n){return this._extHostTabGroups.find(o=>o.apiObject===n)}async _closeTabs(n,o){const a=[];for(const m of n){const b=this._findExtHostTabFromApi(m);if(!b)throw new Error("Tab close: Invalid tab not found!");a.push(b.tabId)}return this._proxy.$closeTab(a,o)}async _closeGroups(n,o){const a=[];for(const m of n){const b=this._findExtHostTabGroupFromApi(m);if(!b)throw new Error("Group close: Invalid group not found!");a.push(b.groupId)}return this._proxy.$closeGroup(a,o)}};e.ExtHostEditorTabs=_,e.ExtHostEditorTabs=_=qe([$e(0,w.IExtHostRpcService)],_);function D(y){return y.tabs!==void 0}}),define(Ce[299],De([1,0,5,7]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class d{constructor(T){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(C.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,f,w){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const g=this._AiEmbeddingVectorProviders.get(T);if(!g)throw new Error("Embedding vector provider not found");const P=await g.provideEmbeddingVector(f,w);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(T,f,w){const g=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(g,w),this._proxy.$registerAiEmbeddingVectorProvider(f,g),new L.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(g),this._AiEmbeddingVectorProviders.delete(g)})}}e.ExtHostAiEmbeddingVector=d}),define(Ce[300],De([1,0,2,5,3,7,10,166,15,21,27,78]),function(me,e,C,L,d,A,T,f,w,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class p{constructor(){this._schemes=[]}add(y){this._stateMachine=void 0,this._schemes.push(y)}delete(y){const n=this._schemes.indexOf(y);n>=0&&(this._schemes.splice(n,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const y=this._schemes.sort(),n=[];let o,a,m=14,b=14;for(const I of y){let t=o?(0,w.commonPrefixLength)(o,I):0;for(t===0?a=1:a=b;t<I.length;t++)t+1===I.length?(m=b,b=9):b+=1,n.push([a,I.toUpperCase().charCodeAt(t),b]),n.push([a,I.toLowerCase().charCodeAt(t),b]),a=b;o=I,b=m}n.push([9,58,10]),n.push([10,47,12]),this._stateMachine=new f.StateMachine(n)}}provideDocumentLinks(y){this._initStateMachine();const n=[],o=f.LinkComputer.computeLinks({getLineContent(a){return y.lineAt(a-1).text},getLineCount(){return y.lineCount}},this._stateMachine);for(const a of o){const m=T.DocumentLink.to(a);m.target&&n.push(m)}return n}}class _{constructor(y,n){this._extHostLanguageFeatures=n,this._linkProvider=new p,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=y.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(y,n,o,a={}){if(_._validateFileSystemProvider(o),this._registeredSchemes.has(n))throw new Error(`a provider for the scheme '${n}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(y,"*",this._linkProvider));const m=this._handlePool++;this._linkProvider.add(n),this._registeredSchemes.add(n),this._fsProvider.set(m,o);let b=2;a.isCaseSensitive&&(b+=1024),a.isReadonly&&(b+=2048),typeof o.copy=="function"&&(b+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,P.checkProposedApiEnabled)(y,"fsChunks"),b+=4);let I;a.isReadonly&&(0,k.isMarkdownString)(a.isReadonly)&&((0,P.checkProposedApiEnabled)(y,"readonlyMessage"),I={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this._proxy.$registerFileSystemProvider(m,n,b,I).catch(r=>{console.error(`FAILED to register filesystem provider of ${y.identifier.value}-extension for the scheme ${n}`),console.error(r)});const t=o.onDidChangeFile(r=>{const s=[];for(const i of r){const{uri:c,type:u}=i;if(c.scheme!==n)continue;let v;switch(u){case A.FileChangeType.Changed:v=0;break;case A.FileChangeType.Created:v=1;break;case A.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:c,type:v})}this._proxy.$onFileSystemChange(m,s)});return(0,d.toDisposable)(()=>{t.dispose(),this._linkProvider.delete(n),this._registeredSchemes.delete(n),this._fsProvider.delete(m),this._proxy.$unregisterProvider(m)})}static _validateFileSystemProvider(y){if(!y)throw new Error("MISSING provider");if(typeof y.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof y.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof y.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof y.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof y.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof y.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof y.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof y.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(y){const{type:n,ctime:o,mtime:a,size:m,permissions:b}=y;return{type:n,ctime:o,mtime:a,size:m,permissions:b}}$stat(y,n){return Promise.resolve(this._getFsProvider(y).stat(C.URI.revive(n))).then(o=>_._asIStat(o))}$readdir(y,n){return Promise.resolve(this._getFsProvider(y).readDirectory(C.URI.revive(n)))}$readFile(y,n){return Promise.resolve(this._getFsProvider(y).readFile(C.URI.revive(n))).then(o=>g.VSBuffer.wrap(o))}$writeFile(y,n,o,a){return Promise.resolve(this._getFsProvider(y).writeFile(C.URI.revive(n),o.buffer,a))}$delete(y,n,o){return Promise.resolve(this._getFsProvider(y).delete(C.URI.revive(n),o))}$rename(y,n,o,a){return Promise.resolve(this._getFsProvider(y).rename(C.URI.revive(n),C.URI.revive(o),a))}$copy(y,n,o,a){const m=this._getFsProvider(y);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(C.URI.revive(n),C.URI.revive(o),a))}$mkdir(y,n){return Promise.resolve(this._getFsProvider(y).createDirectory(C.URI.revive(n)))}$watch(y,n,o,a){const m=this._getFsProvider(y).watch(C.URI.revive(o),a);this._watches.set(n,m)}$unwatch(y,n){const o=this._watches.get(n);o&&(o.dispose(),this._watches.delete(n))}$open(y,n,o){const a=this._getFsProvider(y);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(C.URI.revive(n),o))}$close(y,n){const o=this._getFsProvider(y);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(n))}$read(y,n,o,a){const m=this._getFsProvider(y);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const b=g.VSBuffer.alloc(a);return Promise.resolve(m.read(n,o,b.buffer,0,a)).then(I=>b.slice(0,I))}$write(y,n,o,a){const m=this._getFsProvider(y);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(n,o,a.buffer,0,a.byteLength))}_getFsProvider(y){const n=this._fsProvider.get(y);if(!n){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return n}}e.ExtHostFileSystem=_}),define(Ce[67],De([1,0,5,30,7,21,6,20,52,3,13,24,16]),function(me,e,C,L,d,A,T,f,w,g,P,k,p){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let D=_=class{constructor(n,o){this._fileSystemProvider=new Map,this._writeQueue=new P.ResourceQueue,this._proxy=n.getProxy(C.MainContext.MainThreadFileSystem);const a=this;this.value=Object.freeze({async stat(m){try{let b;const I=a._fileSystemProvider.get(m.scheme);return I?(await a._proxy.$ensureActivation(m.scheme),b=await I.impl.stat(m)):b=await a._proxy.$stat(m),{type:b.type,ctime:b.ctime,mtime:b.mtime,size:b.size,permissions:b.permissions===L.FilePermission.Readonly?1:void 0}}catch(b){_._handleError(b)}},async readDirectory(m){try{const b=a._fileSystemProvider.get(m.scheme);return b?(await a._proxy.$ensureActivation(m.scheme),(await b.impl.readDirectory(m)).slice()):await a._proxy.$readdir(m)}catch(b){return _._handleError(b)}},async createDirectory(m){try{const b=a._fileSystemProvider.get(m.scheme);return b&&!b.isReadonly?(await a._proxy.$ensureActivation(m.scheme),await a.mkdirp(b.impl,b.extUri,m)):await a._proxy.$mkdir(m)}catch(b){return _._handleError(b)}},async readFile(m){try{const b=a._fileSystemProvider.get(m.scheme);return b?(await a._proxy.$ensureActivation(m.scheme),(await b.impl.readFile(m)).slice()):(await a._proxy.$readFile(m)).buffer}catch(b){return _._handleError(b)}},async writeFile(m,b){try{const I=a._fileSystemProvider.get(m.scheme);return I&&!I.isReadonly?(await a._proxy.$ensureActivation(m.scheme),await a.mkdirp(I.impl,I.extUri,I.extUri.dirname(m)),await a._writeQueue.queueFor(m).queue(()=>Promise.resolve(I.impl.writeFile(m,b,{create:!0,overwrite:!0})))):await a._proxy.$writeFile(m,A.VSBuffer.wrap(b))}catch(I){return _._handleError(I)}},async delete(m,b){try{const I=a._fileSystemProvider.get(m.scheme);return I&&!I.isReadonly?(await a._proxy.$ensureActivation(m.scheme),await I.impl.delete(m,{recursive:!1,...b})):await a._proxy.$delete(m,{recursive:!1,useTrash:!1,atomic:!1,...b})}catch(I){return _._handleError(I)}},async rename(m,b,I){try{return await a._proxy.$rename(m,b,{overwrite:!1,...I})}catch(t){return _._handleError(t)}},async copy(m,b,I){try{return await a._proxy.$copy(m,b,{overwrite:!1,...I})}catch(t){return _._handleError(t)}},isWritableFileSystem(m){const b=o.getCapabilities(m);if(typeof b=="number")return!(b&2048)}})}async mkdirp(n,o,a){const m=[];for(;!o.isEqual(a,o.dirname(a));)try{if(!((await n.stat(a)).type&L.FileType.Directory))throw d.FileSystemError.FileExists(`Unable to create folder '${a.scheme===p.Schemas.file?a.fsPath:a.toString(!0)}' that already exists but is not a directory`);break}catch(b){if(L.toFileSystemProviderErrorCode(b)!==L.FileSystemProviderErrorCode.FileNotFound)throw b;m.push(o.basename(a)),a=o.dirname(a)}for(let b=m.length-1;b>=0;b--){a=o.joinPath(a,m[b]);try{await n.createDirectory(a)}catch(I){if(L.toFileSystemProviderErrorCode(I)!==L.FileSystemProviderErrorCode.FileExists)throw I}}}static _handleError(n){if(n instanceof d.FileSystemError)throw n;if(n instanceof L.FileSystemProviderError)switch(n.code){case L.FileSystemProviderErrorCode.FileExists:throw d.FileSystemError.FileExists(n.message);case L.FileSystemProviderErrorCode.FileNotFound:throw d.FileSystemError.FileNotFound(n.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw d.FileSystemError.FileNotADirectory(n.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw d.FileSystemError.FileIsADirectory(n.message);case L.FileSystemProviderErrorCode.NoPermissions:throw d.FileSystemError.NoPermissions(n.message);case L.FileSystemProviderErrorCode.Unavailable:throw d.FileSystemError.Unavailable(n.message);default:throw new d.FileSystemError(n.message,n.name)}if(!(n instanceof Error))throw new d.FileSystemError(String(n));if(n.name==="ENOPRO"||n.message.includes("ENOPRO"))throw d.FileSystemError.Unavailable(n.message);switch(n.name){case L.FileSystemProviderErrorCode.FileExists:throw d.FileSystemError.FileExists(n.message);case L.FileSystemProviderErrorCode.FileNotFound:throw d.FileSystemError.FileNotFound(n.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw d.FileSystemError.FileNotADirectory(n.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw d.FileSystemError.FileIsADirectory(n.message);case L.FileSystemProviderErrorCode.NoPermissions:throw d.FileSystemError.NoPermissions(n.message);case L.FileSystemProviderErrorCode.Unavailable:throw d.FileSystemError.Unavailable(n.message);default:throw new d.FileSystemError(n.message,n.name)}}addFileSystemProvider(n,o,a){return this._fileSystemProvider.set(n,{impl:o,extUri:a?.isCaseSensitive?k.extUri:k.extUriIgnorePathCase,isReadonly:!!a?.isReadonly}),(0,g.toDisposable)(()=>this._fileSystemProvider.delete(n))}getFileSystemProviderExtUri(n){return this._fileSystemProvider.get(n)?.extUri??k.extUri}};e.ExtHostConsumerFileSystem=D,e.ExtHostConsumerFileSystem=D=_=qe([$e(0,f.IExtHostRpcService),$e(1,w.IExtHostFileSystemInfo)],D),e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[301],De([1,0,4,35,2,5,10,7]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class w{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(k,p,_,D,y,n,o,a){this._onDidCreate=new C.Emitter,this._onDidChange=new C.Emitter,this._onDidDelete=new C.Emitter;const m=this.ensureWatching(k,_,y);this._config=0,n&&(this._config+=1),o&&(this._config+=2),a&&(this._config+=4);const b=(0,L.parse)(y),I=typeof y=="string",t=D(r=>{if(!n)for(const s of r.created){const i=d.URI.revive(s);b(i.fsPath)&&(!I||p.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!o)for(const s of r.changed){const i=d.URI.revive(s);b(i.fsPath)&&(!I||p.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!a)for(const s of r.deleted){const i=d.URI.revive(s);b(i.fsPath)&&(!I||p.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=f.Disposable.from(m,this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(k,p,_){const D=f.Disposable.from();if(typeof _=="string")return D;const y=k.getProxy(A.MainContext.MainThreadFileSystem);let n=!1;(_.pattern.includes(L.GLOBSTAR)||_.pattern.includes(L.GLOB_SPLIT))&&(n=!0);const o=Math.random();return y.$watch(p.identifier.value,o,_.baseUri,{recursive:n,excludes:[]}),f.Disposable.from({dispose:()=>y.$unwatch(o)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class g{constructor(k,p,_){this._mainContext=k,this._logService=p,this._extHostDocumentsAndEditors=_,this._onFileSystemEvent=new C.Emitter,this._onDidRenameFile=new C.Emitter,this._onDidCreateFile=new C.Emitter,this._onDidDeleteFile=new C.Emitter,this._onWillRenameFile=new C.AsyncEmitter,this._onWillCreateFile=new C.AsyncEmitter,this._onWillDeleteFile=new C.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,p,_,D,y,n){return new w(this._mainContext,k,p,this._onFileSystemEvent.event,T.GlobPattern.from(_),D,y,n)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,p){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:p.map(_=>({oldUri:d.URI.revive(_.source),newUri:d.URI.revive(_.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:p.map(_=>d.URI.revive(_.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:p.map(_=>d.URI.revive(_.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,p){return(_,D,y)=>{const n=function(a){_.call(D,a)};return n.extension=k,p.event(n,void 0,y)}}async $onWillRunFileOperation(k,p,_,D){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:p.map(y=>({oldUri:d.URI.revive(y.source),newUri:d.URI.revive(y.target)}))},_,D);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:p.map(y=>d.URI.revive(y.target))},_,D);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:p.map(y=>d.URI.revive(y.target))},_,D)}}async _fireWillEvent(k,p,_,D){const y=new Set,n=[];if(await k.fireAsync(p,D,async(a,m)=>{const b=Date.now(),I=await Promise.resolve(a);I instanceof f.WorkspaceEdit&&(n.push([m.extension,I]),y.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-b>_&&this._logService.warn("SLOW file-participant",m.extension.identifier)}),D.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,a]of n){const{edits:m}=T.WorkspaceEdit.from(a,{getTextDocumentVersion:b=>this._extHostDocumentsAndEditors.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(m)}return{edit:o,extensionNames:Array.from(y)}}}e.ExtHostFileSystemEventService=g}),define(Ce[302],De([1,0,3,2,5,10,7,33]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class w{static{this._pool=0}constructor(p,_){this.extension=p,this.provider=_,this.handle=w._pool++}}class g{constructor(p){this.session=p,this.responses=[]}}class P{static{this._nextId=0}constructor(p,_,D,y){this._documents=D,this._logService=y,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=p.getProxy(d.MainContext.MainThreadInlineChat),_.registerApiCommand(new f.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new f.ApiCommandArgument("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?A.Range.from(n.initialRange):void 0,initialSelection:n.initialSelection?A.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?A.Position.from(n.position):void 0}})],f.ApiCommandResult.Void))}registerProvider(p,_){const D=new w(p,_);return this._inputProvider.set(D.handle,D),this._proxy.$registerInteractiveEditorProvider(D.handle,_.label,p.identifier.value,typeof _.handleInteractiveEditorResponseFeedback=="function"),(0,C.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(D.handle),this._inputProvider.delete(D.handle)})}async $prepareSession(p,_,D,y){const n=this._inputProvider.get(p);if(!n){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const o=this._documents.getDocument(L.URI.revive(_)),a=A.Selection.to(D),m=await n.provider.prepareInteractiveEditorSession({document:o,selection:a},y);if(!m)return;if(m.wholeRange&&!m.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const b=P._nextId++;return this._inputSessions.set(b,new g(m)),{id:b,placeholder:m.placeholder,slashCommands:m.slashCommands?.map(I=>({command:I.command,detail:I.detail,refer:I.refer,executeImmediately:I.executeImmediately})),wholeRange:A.Range.from(m.wholeRange),message:m.message}}async $provideResponse(p,_,D,y){const n=this._inputProvider.get(p);if(!n)return;const o=this._inputSessions.get(_.id);if(!o)return;const a={session:o.session,prompt:D.prompt,selection:A.Selection.to(D.selection),wholeRange:A.Range.to(D.wholeRange),attempt:D.attempt,live:D.live};let m=!1;const b={report:r=>{if(!D.live)throw new Error("Progress reporting is only supported for live sessions");m||y.isCancellationRequested||!r.message&&!r.edits||this._proxy.$handleProgressChunk(D.requestId,{message:r.message,edits:r.edits?.map(A.TextEdit.from)})}},I=typeof n.provider.provideInteractiveEditorResponse2=="function"?n.provider.provideInteractiveEditorResponse2(a,b,y):n.provider.provideInteractiveEditorResponse(a,y);Promise.resolve(I).finally(()=>m=!0);const t=await I;if(t){const r=o.responses.push(t)-1,s={wholeRange:A.Range.from(t.wholeRange),placeholder:t.placeholder};if(P._isMessageResponse(t))return{...s,id:r,type:"message",message:A.MarkdownString.from(t.contents)};const{edits:i}=t;if(i instanceof T.WorkspaceEdit)return{...s,id:r,type:"bulkEdit",edits:A.WorkspaceEdit.from(i)};if(Array.isArray(i))return{...s,id:r,type:"editorEdit",edits:i.map(A.TextEdit.from)}}}$handleFeedback(p,_,D,y){const n=this._inputProvider.get(p),o=this._inputSessions.get(_),a=o?.responses[D];if(n&&a){let m;switch(y){case 1:m=T.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:m=T.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:m=T.InteractiveEditorResponseFeedbackKind.Undone;break;case 3:m=T.InteractiveEditorResponseFeedbackKind.Accepted;break}n.provider.handleInteractiveEditorResponseFeedback?.(o.session,a,m)}}$releaseSession(p,_){const D=this._inputSessions.get(_),y=this._inputProvider.get(p);D&&y&&y.provider.releaseInteractiveEditorSession?.(D.session),this._inputSessions.delete(_)}static _isMessageResponse(p){return typeof p=="object"&&typeof p.contents=="object"}}e.ExtHostInteractiveEditor=P}),define(Ce[303],De([1,0,2,33]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class d{constructor(T,f,w,g,P){this._extHostNotebooks=f,this._textDocumentsAndEditors=w,this._commands=g;const k=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",p=>!0,p=>p),new L.ApiCommandArgument("resource","Interactive resource Uri",p=>!0,p=>p),new L.ApiCommandArgument("controllerId","Notebook controller Id",p=>!0,p=>p),new L.ApiCommandArgument("title","Interactive editor title",p=>!0,p=>p)],new L.ApiCommandResult("Notebook and input URI",p=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const _=this._extHostNotebooks.getEditorById(p.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",_.id),{notebookUri:C.URI.revive(p.notebookUri),inputUri:C.URI.revive(p.inputUri),notebookEditor:_.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:C.URI.revive(p.notebookUri),inputUri:C.URI.revive(p.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(T,f,w,g){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:f,lines:[""],languageId:w,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(C.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,f){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=d}),define(Ce[304],De([1,0,5,7]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class d{constructor(T){this._IssueUriRequestHandlers=new Map,this._proxy=T.getProxy(C.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(T,f){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const w=this._IssueUriRequestHandlers.get(T);if(!w)throw new Error("Issue request handler not found");const g=await w.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(T,f){const w=T.identifier.value;return this._IssueUriRequestHandlers.set(w,f),this._proxy.$registerIssueUriRequestHandler(w),new L.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(w),this._IssueUriRequestHandlers.delete(w)})}}e.ExtHostIssueReporter=d}),define(Ce[305],De([1,0,3,5]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class d{constructor(T){this._handlePool=0,this._proxy=T.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const f=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(f,T),(0,C.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(f)})}}e.ExtHostLabelService=d}),define(Ce[306],De([1,0,2,23,10,7,81,5,15,34,18,19,162,22,25,3,128,117,86,37,8,13,27,199]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m,b,I,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(B,X){this._documents=B,this._provider=X}async provideDocumentSymbols(B,X){const Z=this._documents.getDocument(B),oe=await this._provider.provideDocumentSymbols(Z,X);if(!(0,P.isFalsyOrEmpty)(oe))return oe[0]instanceof A.DocumentSymbol?oe.map(d.DocumentSymbol.from):s._asDocumentSymbolTree(oe)}static _asDocumentSymbolTree(B){B=B.slice(0).sort((oe,Q)=>{let ue=oe.location.range.start.compareTo(Q.location.range.start);return ue===0&&(ue=Q.location.range.end.compareTo(oe.location.range.end)),ue});const X=[],Z=[];for(const oe of B){const Q={name:oe.name||"!!MISSING: name!!",kind:d.SymbolKind.from(oe.kind),tags:oe.tags?.map(d.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:d.Range.from(oe.location.range),selectionRange:d.Range.from(oe.location.range),children:[]};for(;;){if(Z.length===0){Z.push(Q),X.push(Q);break}const ue=Z[Z.length-1];if(g.Range.containsRange(ue.range,Q.range)&&!g.Range.equalsRange(ue.range,Q.range)){ue.children?.push(Q),Z.push(Q);break}Z.pop()}}return X}}class i{static{this._badCmd={command:"missing",title:"!!MISSING: command!!"}}constructor(B,X,Z){this._documents=B,this._commands=X,this._provider=Z,this._cache=new a.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,X){const Z=this._documents.getDocument(B),oe=await this._provider.provideCodeLenses(Z,X);if(!oe||X.isCancellationRequested)return;const Q=this._cache.add(oe),ue=new y.DisposableStore;this._disposables.set(Q,ue);const ve={cacheId:Q,lenses:[]};for(let xe=0;xe<oe.length;xe++)ve.lenses.push({cacheId:[Q,xe],range:d.Range.from(oe[xe].range),command:this._commands.toInternal(oe[xe].command,ue)});return ve}async resolveCodeLens(B,X){const Z=B.cacheId&&this._cache.get(...B.cacheId);if(!Z)return;let oe;if(typeof this._provider.resolveCodeLens!="function"||Z.isResolved?oe=Z:oe=await this._provider.resolveCodeLens(Z,X),oe||(oe=Z),X.isCancellationRequested)return;const Q=B.cacheId&&this._disposables.get(B.cacheId[0]);if(Q)return B.command=this._commands.toInternal(oe.command??i._badCmd,Q),B}releaseCodeLenses(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}}function c(ke){return Array.isArray(ke)?ke.map(d.DefinitionLink.from):ke?[d.DefinitionLink.from(ke)]:[]}class u{constructor(B,X){this._documents=B,this._provider=X}async provideDefinition(B,X,Z){const oe=this._documents.getDocument(B),Q=d.Position.to(X),ue=await this._provider.provideDefinition(oe,Q,Z);return c(ue)}}class v{constructor(B,X){this._documents=B,this._provider=X}async provideDeclaration(B,X,Z){const oe=this._documents.getDocument(B),Q=d.Position.to(X),ue=await this._provider.provideDeclaration(oe,Q,Z);return c(ue)}}class S{constructor(B,X){this._documents=B,this._provider=X}async provideImplementation(B,X,Z){const oe=this._documents.getDocument(B),Q=d.Position.to(X),ue=await this._provider.provideImplementation(oe,Q,Z);return c(ue)}}class l{constructor(B,X){this._documents=B,this._provider=X}async provideTypeDefinition(B,X,Z){const oe=this._documents.getDocument(B),Q=d.Position.to(X),ue=await this._provider.provideTypeDefinition(oe,Q,Z);return c(ue)}}class h{constructor(B,X){this._documents=B,this._provider=X}async provideHover(B,X,Z){const oe=this._documents.getDocument(B),Q=d.Position.to(X),ue=await this._provider.provideHover(oe,Q,Z);if(!(!ue||(0,P.isFalsyOrEmpty)(ue.contents)))return ue.range||(ue.range=oe.getWordRangeAtPosition(Q)),ue.range||(ue.range=new A.Range(Q,Q)),d.Hover.from(ue)}}class E{constructor(B,X){this._documents=B,this._provider=X}async provideEvaluatableExpression(B,X,Z){const oe=this._documents.getDocument(B),Q=d.Position.to(X),ue=await this._provider.provideEvaluatableExpression(oe,Q,Z);if(ue)return d.EvaluatableExpression.from(ue)}}class R{constructor(B,X){this._documents=B,this._provider=X}async provideInlineValues(B,X,Z,oe){const Q=this._documents.getDocument(B),ue=await this._provider.provideInlineValues(Q,d.Range.to(X),d.InlineValueContext.to(Z),oe);if(Array.isArray(ue))return ue.map(ve=>d.InlineValue.from(ve))}}class M{constructor(B,X){this._documents=B,this._provider=X}async provideDocumentHighlights(B,X,Z){const oe=this._documents.getDocument(B),Q=d.Position.to(X),ue=await this._provider.provideDocumentHighlights(oe,Q,Z);if(Array.isArray(ue))return ue.map(d.DocumentHighlight.from)}}class U{constructor(B,X){this._documents=B,this._provider=X}async provideLinkedEditingRanges(B,X,Z){const oe=this._documents.getDocument(B),Q=d.Position.to(X),ue=await this._provider.provideLinkedEditingRanges(oe,Q,Z);if(ue&&Array.isArray(ue.ranges))return{ranges:(0,P.coalesce)(ue.ranges.map(d.Range.from)),wordPattern:ue.wordPattern}}}class F{constructor(B,X){this._documents=B,this._provider=X}async provideReferences(B,X,Z,oe){const Q=this._documents.getDocument(B),ue=d.Position.to(X),ve=await this._provider.provideReferences(Q,ue,Z,oe);if(Array.isArray(ve))return ve.map(d.location.from)}}class x{static{this._maxCodeActionsPerFile=1e3}constructor(B,X,Z,oe,Q,ue,ve){this._documents=B,this._commands=X,this._diagnostics=Z,this._provider=oe,this._logService=Q,this._extension=ue,this._apiDeprecation=ve,this._cache=new a.Cache("CodeAction"),this._disposables=new Map,this.nbKind=new A.CodeActionKind("notebook")}async provideCodeActions(B,X,Z,oe){const Q=this._documents.getDocument(B),ue=p.Selection.isISelection(X)?d.Selection.to(X):d.Range.to(X),ve=[];for(const et of this._diagnostics.getDiagnostics(B))if(ue.intersection(et.range)&&ve.push(et)>x._maxCodeActionsPerFile)break;const xe={diagnostics:ve,only:Z.only?new A.CodeActionKind(Z.only):void 0,triggerKind:d.CodeActionTriggerKind.to(Z.trigger)},We=await this._provider.provideCodeActions(Q,ue,xe,oe);if(!(0,P.isNonEmptyArray)(We)||oe.isCancellationRequested)return;const Ze=this._cache.add(We),Qe=new y.DisposableStore;this._disposables.set(Ze,Qe);const it=[];for(let et=0;et<We.length;et++){const Pe=We[et];if(Pe)if(x._isCommand(Pe))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Pe.title,command:this._commands.toInternal(Pe,Qe)});else{if(xe.triggerKind!==A.CodeActionTriggerKind.Invoke&&Pe.kind&&this.nbKind.contains(Pe.kind))continue;xe.only&&(Pe.kind?xe.only.contains(Pe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value} 'requested but returned code action is of kind '${Pe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[Ze,et],title:Pe.title,command:Pe.command&&this._commands.toInternal(Pe.command,Qe),diagnostics:Pe.diagnostics&&Pe.diagnostics.map(d.Diagnostic.from),edit:Pe.edit&&d.WorkspaceEdit.from(Pe.edit,void 0),kind:Pe.kind&&Pe.kind.value,isPreferred:Pe.isPreferred,disabled:Pe.disabled?.reason})}}return{cacheId:Ze,actions:it}}async resolveCodeAction(B,X){const[Z,oe]=B,Q=this._cache.get(Z,oe);if(!Q||x._isCommand(Q))return{};if(!this._provider.resolveCodeAction)return{};const ue=await this._provider.resolveCodeAction(Q,X)??Q;let ve;ue.edit&&(ve=d.WorkspaceEdit.from(ue.edit,void 0));let xe;if(ue.command){const We=this._disposables.get(Z);We&&(xe=this._commands.toInternal(ue.command,We))}return{edit:ve,command:xe}}releaseCodeActions(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}class ${static toInternalProviderId(B,X){return B+"."+X}constructor(B,X,Z,oe,Q){this._proxy=B,this._documents=X,this._provider=Z,this._handle=oe,this._extension=Q}async prepareDocumentPaste(B,X,Z,oe){if(!this._provider.prepareDocumentPaste)return;const Q=this._documents.getDocument(B),ue=X.map(We=>d.Range.to(We)),ve=d.DataTransfer.toDataTransfer(Z,()=>{throw new b.NotImplementedError});if(await this._provider.prepareDocumentPaste(Q,ue,ve,oe),oe.isCancellationRequested)return;const xe=Array.from(ve).filter(([,We])=>!(We instanceof A.InternalDataTransferItem));return d.DataTransfer.from(xe)}async providePasteEdits(B,X,Z,oe,Q){if(!this._provider.provideDocumentPasteEdits)return;const ue=this._documents.getDocument(X),ve=Z.map(Ze=>d.Range.to(Ze)),xe=d.DataTransfer.toDataTransfer(oe,async Ze=>(await this._proxy.$resolvePasteFileData(this._handle,B,Ze)).buffer),We=await this._provider.provideDocumentPasteEdits(ue,ve,xe,Q);if(We)return{label:We.label??(0,r.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,yieldTo:We.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:$.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?d.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class O{constructor(B,X){this._documents=B,this._provider=X}async provideDocumentFormattingEdits(B,X,Z){const oe=this._documents.getDocument(B),Q=await this._provider.provideDocumentFormattingEdits(oe,X,Z);if(Array.isArray(Q))return Q.map(d.TextEdit.from)}}class K{constructor(B,X){this._documents=B,this._provider=X}async provideDocumentRangeFormattingEdits(B,X,Z,oe){const Q=this._documents.getDocument(B),ue=d.Range.to(X),ve=await this._provider.provideDocumentRangeFormattingEdits(Q,ue,Z,oe);if(Array.isArray(ve))return ve.map(d.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,X,Z,oe){(0,k.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Q=this._documents.getDocument(B),ue=X.map(d.Range.to),ve=await this._provider.provideDocumentRangesFormattingEdits(Q,ue,Z,oe);if(Array.isArray(ve))return ve.map(d.TextEdit.from)}}class q{constructor(B,X){this._documents=B,this._provider=X,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,X,Z,oe,Q){const ue=this._documents.getDocument(B),ve=d.Position.to(X),xe=await this._provider.provideOnTypeFormattingEdits(ue,ve,Z,oe,Q);if(Array.isArray(xe))return xe.map(d.TextEdit.from)}}class fe{constructor(B,X){this._provider=B,this._logService=X,this._cache=new a.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(B,X){const Z=await this._provider.provideWorkspaceSymbols(B,X);if(!(0,P.isNonEmptyArray)(Z))return{symbols:[]};const oe=this._cache.add(Z),Q={cacheId:oe,symbols:[]};for(let ue=0;ue<Z.length;ue++){const ve=Z[ue];if(!ve||!ve.name){this._logService.warn("INVALID SymbolInformation",ve);continue}Q.symbols.push({...d.WorkspaceSymbol.from(ve),cacheId:[oe,ue]})}return Q}async resolveWorkspaceSymbol(B,X){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const Z=this._cache.get(...B.cacheId);if(Z){const oe=await this._provider.resolveWorkspaceSymbol(Z,X);return oe&&(0,L.mixin)(B,d.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(B){this._cache.delete(B)}}class se{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,X,Z){this._documents=B,this._provider=X,this._logService=Z}async provideRenameEdits(B,X,Z,oe){const Q=this._documents.getDocument(B),ue=d.Position.to(X);try{const ve=await this._provider.provideRenameEdits(Q,ue,Z,oe);return ve?d.WorkspaceEdit.from(ve):void 0}catch(ve){const xe=se._asMessage(ve);return xe?{rejectReason:xe,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(B,X,Z){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(B),Q=d.Position.to(X);try{const ue=await this._provider.prepareRename(oe,Q,Z);let ve,xe;if(A.Range.isRange(ue)?(ve=ue,xe=oe.getText(ue)):(0,k.isObject)(ue)&&(ve=ue.range,xe=ue.placeholder),!ve||!xe)return;if(ve.start.line>Q.line||ve.end.line<Q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:d.Range.from(ve),text:xe}}catch(ue){const ve=se._asMessage(ue);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(ue)}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class ie{constructor(B,X){this.resultId=B,this.tokens=X}}class H{constructor(B,X){this._documents=B,this._provider=X,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(B,X,Z){const oe=this._documents.getDocument(B),Q=X!==0?this._previousResults.get(X):null;let ue=typeof Q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(oe,Q.resultId,Z):await this._provider.provideDocumentSemanticTokens(oe,Z);return Q&&this._previousResults.delete(X),ue?(ue=H._fixProvidedSemanticTokens(ue),this._send(H._convertToEdits(Q,ue),ue)):null}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return H._isSemanticTokens(B)?H._isCorrectSemanticTokens(B)?B:new A.SemanticTokens(new Uint32Array(B.data),B.resultId):H._isSemanticTokensEdits(B)?H._isCorrectSemanticTokensEdits(B)?B:new A.SemanticTokensEdits(B.edits.map(X=>new A.SemanticTokensEdit(X.start,X.deleteCount,X.data?new Uint32Array(X.data):X.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const X of B.edits)if(!(X.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,X){if(!H._isSemanticTokens(X)||!B||!B.tokens)return X;const Z=B.tokens,oe=Z.length,Q=X.data,ue=Q.length;let ve=0;const xe=Math.min(oe,ue);for(;ve<xe&&Z[ve]===Q[ve];)ve++;if(ve===oe&&ve===ue)return new A.SemanticTokensEdits([],X.resultId);let We=0;const Ze=xe-ve;for(;We<Ze&&Z[oe-We-1]===Q[ue-We-1];)We++;return new A.SemanticTokensEdits([{start:ve,deleteCount:oe-ve-We,data:Q.subarray(ve,ue-We)}],X.resultId)}_send(B,X){if(H._isSemanticTokens(B)){const Z=this._nextResultId++;return this._previousResults.set(Z,new ie(B.resultId,B.data)),(0,n.encodeSemanticTokensDto)({id:Z,type:"full",data:B.data})}if(H._isSemanticTokensEdits(B)){const Z=this._nextResultId++;return H._isSemanticTokens(X)?this._previousResults.set(Z,new ie(X.resultId,X.data)):this._previousResults.set(Z,new ie(B.resultId)),(0,n.encodeSemanticTokensDto)({id:Z,type:"delta",deltas:(B.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}class re{constructor(B,X){this._documents=B,this._provider=X}async provideDocumentRangeSemanticTokens(B,X,Z){const oe=this._documents.getDocument(B),Q=await this._provider.provideDocumentRangeSemanticTokens(oe,d.Range.to(X),Z);return Q?this._send(Q):null}_send(B){return(0,n.encodeSemanticTokensDto)({id:0,type:"full",data:B.data})}}class Ee{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,X,Z,oe,Q){this._documents=B,this._commands=X,this._provider=Z,this._apiDeprecation=oe,this._extension=Q,this._cache=new a.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(B,X,Z,oe){const Q=this._documents.getDocument(B),ue=d.Position.to(X),ve=Q.getWordRangeAtPosition(ue)||new A.Range(ue,ue),xe=ve.with({end:ue}),We=new m.StopWatch,Ze=await this._provider.provideCompletionItems(Q,ue,oe,d.CompletionContext.to(Z));if(!Ze||oe.isCancellationRequested)return;const Qe=Array.isArray(Ze)?new A.CompletionList(Ze):Ze,it=Ee.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),et=new y.DisposableStore;this._disposables.set(it,et);const Pe=[],Me={x:it,b:Pe,a:{replace:d.Range.from(ve),insert:d.Range.from(xe)},c:Qe.isIncomplete||void 0,d:We.elapsed()};for(let ze=0;ze<Qe.items.length;ze++){const Re=Qe.items[ze],Xe=this._convertCompletionItem(Re,[it,ze],xe,ve);Pe.push(Xe)}return Me}async resolveCompletionItem(B,X){if(typeof this._provider.resolveCompletionItem!="function")return;const Z=this._cache.get(...B);if(!Z)return;const oe=this._convertCompletionItem(Z,B),Q=await this._provider.resolveCompletionItem(Z,X);if(!Q)return;const ue=this._convertCompletionItem(Q,B);return(oe.h!==ue.h||oe.i!==ue.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(oe.n!==ue.n||oe.o!==ue.o||!(0,L.equals)(oe.p,ue.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...oe,d:ue.d,c:ue.c,l:ue.l,h:ue.h,i:ue.i,n:ue.n,o:ue.o,p:ue.p}}releaseCompletionItems(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,X,Z,oe){const Q=this._disposables.get(X[0]);if(!Q)throw Error("DisposableStore is missing...");const ue=this._commands.toInternal(B.command,Q),ve={x:X,a:B.label,b:B.kind!==void 0?d.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(d.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:d.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(d.TextEdit.from),n:ue?.$ident,o:ue?.id,p:ue?.$ident?void 0:ue?.arguments};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ve.h=B.textEdit.newText):typeof B.insertText=="string"?ve.h=B.insertText:B.insertText instanceof A.SnippetString&&(ve.h=B.insertText.value,ve.i|=4);let xe;return B.textEdit?xe=B.textEdit.range:B.range&&(xe=B.range),A.Range.isRange(xe)?ve.j=d.Range.from(xe):xe&&(!Z?.isEqual(xe.inserting)||!oe?.isEqual(xe.replacing))&&(ve.j={insert:d.Range.from(xe.inserting),replace:d.Range.from(xe.replacing)}),ve}}class ae{async provideInlineCompletions(B,X,Z,oe){}disposeCompletions(B){}handleDidShowCompletionItem(B,X,Z){}handlePartialAccept(B,X,Z){}}class ne extends ae{constructor(B,X,Z,oe){super(),this._extension=B,this._documents=X,this._provider=Z,this._commands=oe,this._references=new J,this._isAdditionsProposedApiEnabled=(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[T.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[T.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,X,Z,oe){const Q=this._documents.getDocument(B),ue=d.Position.to(X),ve=await this._provider.provideInlineCompletionItems(Q,ue,{selectedCompletionInfo:Z.selectedSuggestionInfo?{range:d.Range.to(Z.selectedSuggestionInfo.range),text:Z.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[Z.triggerKind]},oe);if(!ve||oe.isCancellationRequested)return;const xe=Array.isArray(ve)?ve:ve.items,We=this._isAdditionsProposedApiEnabled?Array.isArray(ve)?[]:ve.commands||[]:[],Ze=this._isAdditionsProposedApiEnabled&&!Array.isArray(ve)?ve.enableForwardStability:void 0;let Qe;return{pid:this._references.createReferenceId({dispose(){Qe?.dispose()},items:xe}),items:xe.map((et,Pe)=>{let Me;et.command&&(Qe||(Qe=new y.DisposableStore),Me=this._commands.toInternal(et.command,Qe));const ze=et.insertText;return{insertText:typeof ze=="string"?ze:{snippet:ze.value},filterText:et.filterText,range:et.range?d.Range.from(et.range):void 0,command:Me,idx:Pe,completeBracketPairs:this._isAdditionsProposedApiEnabled?et.completeBracketPairs:!1}}),commands:We.map(et=>(Qe||(Qe=new y.DisposableStore),this._commands.toInternal(et,Qe))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(B){this._references.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,X,Z){const oe=this._references.get(B)?.items[X];oe&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(oe,Z)}handlePartialAccept(B,X,Z){const oe=this._references.get(B)?.items[X];oe&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(oe,Z)}}class J{constructor(){this._references=new Map,this._idPool=1}createReferenceId(B){const X=this._idPool++;return this._references.set(X,B),X}disposeReferenceId(B){const X=this._references.get(B);return this._references.delete(B),X}get(B){return this._references.get(B)}}class N{constructor(B,X){this._documents=B,this._provider=X,this._cache=new a.Cache("SignatureHelp")}async provideSignatureHelp(B,X,Z,oe){const Q=this._documents.getDocument(B),ue=d.Position.to(X),ve=this.reviveContext(Z),xe=await this._provider.provideSignatureHelp(Q,ue,oe,ve);if(xe){const We=this._cache.add([xe]);return{...d.SignatureHelp.from(xe),id:We}}}reviveContext(B){let X;if(B.activeSignatureHelp){const Z=d.SignatureHelp.to(B.activeSignatureHelp),oe=this._cache.get(B.activeSignatureHelp.id,0);oe?(X=oe,X.activeSignature=Z.activeSignature,X.activeParameter=Z.activeParameter):X=Z}return{...B,activeSignatureHelp:X}}releaseSignatureHelp(B){this._cache.delete(B)}}class W{constructor(B,X,Z,oe,Q){this._documents=B,this._commands=X,this._provider=Z,this._logService=oe,this._extension=Q,this._cache=new a.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(B,X,Z){const oe=this._documents.getDocument(B),Q=d.Range.to(X),ue=await this._provider.provideInlayHints(oe,Q,Z);if(!Array.isArray(ue)||ue.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${X}`);return}if(Z.isCancellationRequested)return;const ve=this._cache.add(ue);this._disposables.set(ve,new y.DisposableStore);const xe={hints:[],cacheId:ve};for(let We=0;We<ue.length;We++)this._isValidInlayHint(ue[We],Q)&&xe.hints.push(this._convertInlayHint(ue[We],[ve,We]));return this._logService.trace(`[InlayHints] ${xe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${X}`),xe}async resolveInlayHint(B,X){if(typeof this._provider.resolveInlayHint!="function")return;const Z=this._cache.get(...B);if(!Z)return;const oe=await this._provider.resolveInlayHint(Z,X);if(oe&&this._isValidInlayHint(oe))return this._convertInlayHint(oe,B)}releaseHints(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_isValidInlayHint(B,X){return B.label.length===0||Array.isArray(B.label)&&B.label.every(Z=>Z.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(X&&!X.contains(B.position))}_convertInlayHint(B,X){const Z=this._disposables.get(X[0]);if(!Z)throw Error("DisposableStore is missing...");const oe={label:"",cacheId:X,tooltip:d.MarkdownString.fromStrict(B.tooltip),position:d.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(d.TextEdit.from),kind:B.kind&&d.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?oe.label=B.label:oe.label=B.label.map(Q=>{const ue={label:Q.value};return ue.tooltip=d.MarkdownString.fromStrict(Q.tooltip),A.Location.isLocation(Q.location)&&(ue.location=d.location.from(Q.location)),Q.command&&(ue.command=this._commands.toInternal(Q.command,Z)),ue}),oe}}class he{constructor(B,X){this._documents=B,this._provider=X,this._cache=new a.Cache("DocumentLink")}async provideLinks(B,X){const Z=this._documents.getDocument(B),oe=await this._provider.provideDocumentLinks(Z,X);if(!(!Array.isArray(oe)||oe.length===0)&&!X.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.filter(he._validateLink).map(d.DocumentLink.from)};{const Q=this._cache.add(oe),ue={links:[],cacheId:Q};for(let ve=0;ve<oe.length;ve++){if(!he._validateLink(oe[ve]))continue;const xe=d.DocumentLink.from(oe[ve]);xe.cacheId=[Q,ve],ue.links.push(xe)}return ue}}}static _validateLink(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,X){if(typeof this._provider.resolveDocumentLink!="function")return;const Z=this._cache.get(...B);if(!Z)return;const oe=await this._provider.resolveDocumentLink(Z,X);if(!(!oe||!he._validateLink(oe)))return d.DocumentLink.from(oe)}releaseLinks(B){this._cache.delete(B)}}class Se{constructor(B,X){this._documents=B,this._provider=X}async provideColors(B,X){const Z=this._documents.getDocument(B),oe=await this._provider.provideDocumentColors(Z,X);return Array.isArray(oe)?oe.map(ue=>({color:d.Color.from(ue.color),range:d.Range.from(ue.range)})):[]}async provideColorPresentations(B,X,Z){const oe=this._documents.getDocument(B),Q=d.Range.to(X.range),ue=d.Color.to(X.color),ve=await this._provider.provideColorPresentations(ue,{document:oe,range:Q},Z);if(Array.isArray(ve))return ve.map(d.ColorPresentation.from)}}class be{constructor(B,X){this._documents=B,this._provider=X}async provideFoldingRanges(B,X,Z){const oe=this._documents.getDocument(B),Q=await this._provider.provideFoldingRanges(oe,X,Z);if(Array.isArray(Q))return Q.map(d.FoldingRange.from)}}class we{constructor(B,X,Z){this._documents=B,this._provider=X,this._logService=Z}async provideSelectionRanges(B,X,Z){const oe=this._documents.getDocument(B),Q=X.map(d.Position.to),ue=await this._provider.provideSelectionRanges(oe,Q,Z);if(!(0,P.isNonEmptyArray)(ue))return[];if(ue.length!==Q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let xe=0;xe<Q.length;xe++){const We=[];ve.push(We);let Ze=Q[xe],Qe=ue[xe];for(;;){if(!Qe.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(We.push(d.SelectionRange.from(Qe)),!Qe.parent)break;Ze=Qe.range,Qe=Qe.parent}}return ve}}class ye{constructor(B,X){this._documents=B,this._provider=X,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(B,X,Z){const oe=this._documents.getDocument(B),Q=d.Position.to(X),ue=await this._provider.prepareCallHierarchy(oe,Q,Z);if(!ue)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ue)?ue.map(xe=>this._cacheAndConvertItem(ve,xe)):[this._cacheAndConvertItem(ve,ue)]}async provideCallsTo(B,X,Z){const oe=this._itemFromCache(B,X);if(!oe)throw new Error("missing call hierarchy item");const Q=await this._provider.provideCallHierarchyIncomingCalls(oe,Z);if(Q)return Q.map(ue=>({from:this._cacheAndConvertItem(B,ue.from),fromRanges:ue.fromRanges.map(ve=>d.Range.from(ve))}))}async provideCallsFrom(B,X,Z){const oe=this._itemFromCache(B,X);if(!oe)throw new Error("missing call hierarchy item");const Q=await this._provider.provideCallHierarchyOutgoingCalls(oe,Z);if(Q)return Q.map(ue=>({to:this._cacheAndConvertItem(B,ue.to),fromRanges:ue.fromRanges.map(ve=>d.Range.from(ve))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,X){const Z=this._cache.get(B),oe=d.CallHierarchyItem.from(X,B,Z.size.toString(36));return Z.set(oe._itemId,X),oe}_itemFromCache(B,X){return this._cache.get(B)?.get(X)}}class V{constructor(B,X){this._documents=B,this._provider=X,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(B,X,Z){const oe=this._documents.getDocument(B),Q=d.Position.to(X),ue=await this._provider.prepareTypeHierarchy(oe,Q,Z);if(!ue)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ue)?ue.map(xe=>this._cacheAndConvertItem(ve,xe)):[this._cacheAndConvertItem(ve,ue)]}async provideSupertypes(B,X,Z){const oe=this._itemFromCache(B,X);if(!oe)throw new Error("missing type hierarchy item");const Q=await this._provider.provideTypeHierarchySupertypes(oe,Z);if(Q)return Q.map(ue=>this._cacheAndConvertItem(B,ue))}async provideSubtypes(B,X,Z){const oe=this._itemFromCache(B,X);if(!oe)throw new Error("missing type hierarchy item");const Q=await this._provider.provideTypeHierarchySubtypes(oe,Z);if(Q)return Q.map(ue=>this._cacheAndConvertItem(B,ue))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,X){const Z=this._cache.get(B),oe=d.TypeHierarchyItem.from(X,B,Z.size.toString(36));return Z.set(oe._itemId,X),oe}_itemFromCache(B,X){return this._cache.get(B)?.get(X)}}class ee{static toInternalProviderId(B,X){return B+"."+X}constructor(B,X,Z,oe,Q){this._proxy=B,this._documents=X,this._provider=Z,this._handle=oe,this._extension=Q}async provideDocumentOnDropEdits(B,X,Z,oe,Q){const ue=this._documents.getDocument(X),ve=d.Position.to(Z),xe=d.DataTransfer.toDataTransfer(oe,async Ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,B,Ze)).buffer),We=await this._provider.provideDocumentDropEdits(ue,ve,xe,Q);if(We)return{label:We.label??(0,r.localize)(1,null,this._extension.displayName||this._extension.name),yieldTo:We.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:ee.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?d.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class G{constructor(B,X){this._documents=B,this._provider=X}async provideMappedEdits(B,X,Z,oe){const Q=C.URI.revive(B),ue=this._documents.getDocument(Q),ve={selections:Z.selections.map(We=>d.Selection.to(We)),related:Z.related.map(We=>({uri:C.URI.revive(We.uri),range:d.Range.to(We.range)}))},xe=await this._provider.provideMappedEdits(ue,X,ve,oe);return xe?d.WorkspaceEdit.from(xe):null}}class Y{constructor(B,X){this.adapter=B,this.extension=X}}class de{static{this._handlePool=0}constructor(B,X,Z,oe,Q,ue,ve,xe){this._uriTransformer=X,this._documents=Z,this._commands=oe,this._diagnostics=Q,this._logService=ue,this._apiDeprecation=ve,this._extensionTelemetry=xe,this._adapter=new Map,this._proxy=B.getProxy(f.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(B,X){return d.DocumentSelector.from(B,this._uriTransformer,X)}_createDisposable(B){return new A.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return de._handlePool++}async _withAdapter(B,X,Z,oe,Q,ue=!1){const ve=this._adapter.get(B);if(!ve||!(ve.adapter instanceof X))return oe;const xe=Date.now();ue||this._logService.trace(`[${ve.extension.identifier.value}] INVOKE provider '${Z.toString().replace(/[\r\n]/g,"")}'`);const We=Z(ve.adapter,ve.extension);return Promise.resolve(We).catch(Ze=>{(0,b.isCancellationError)(Ze)||(this._logService.error(`[${ve.extension.identifier.value}] provider FAILED`),this._logService.error(Ze),this._extensionTelemetry.onExtensionError(ve.extension.identifier,Ze))}).finally(()=>{ue||this._logService.trace(`[${ve.extension.identifier.value}] provider DONE after ${Date.now()-xe}ms`)}),_.CancellationToken.isCancellationToken(Q)?(0,I.raceCancellationError)(We,Q):We}_addNewAdapter(B,X){const Z=this._nextHandle();return this._adapter.set(Z,new Y(B,X)),Z}static _extLabel(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,X,Z,oe){const Q=this._addNewAdapter(new s(this._documents,Z),B),ue=oe&&oe.label||de._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(Q,this._transformDocumentSelector(X,B),ue),this._createDisposable(Q)}$provideDocumentSymbols(B,X,Z){return this._withAdapter(B,s,oe=>oe.provideDocumentSymbols(C.URI.revive(X),Z),void 0,Z)}registerCodeLensProvider(B,X,Z){const oe=this._nextHandle(),Q=typeof Z.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Y(new i(this._documents,this._commands.converter,Z),B)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(X,B),Q);let ue=this._createDisposable(oe);if(Q!==void 0){const ve=Z.onDidChangeCodeLenses(xe=>this._proxy.$emitCodeLensEvent(Q));ue=A.Disposable.from(ue,ve)}return ue}$provideCodeLenses(B,X,Z){return this._withAdapter(B,i,oe=>oe.provideCodeLenses(C.URI.revive(X),Z),void 0,Z)}$resolveCodeLens(B,X,Z){return this._withAdapter(B,i,oe=>oe.resolveCodeLens(X,Z),void 0,void 0)}$releaseCodeLenses(B,X){this._withAdapter(B,i,Z=>Promise.resolve(Z.releaseCodeLenses(X)),void 0,void 0)}registerDefinitionProvider(B,X,Z){const oe=this._addNewAdapter(new u(this._documents,Z),B);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(X,B)),this._createDisposable(oe)}$provideDefinition(B,X,Z,oe){return this._withAdapter(B,u,Q=>Q.provideDefinition(C.URI.revive(X),Z,oe),[],oe)}registerDeclarationProvider(B,X,Z){const oe=this._addNewAdapter(new v(this._documents,Z),B);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(X,B)),this._createDisposable(oe)}$provideDeclaration(B,X,Z,oe){return this._withAdapter(B,v,Q=>Q.provideDeclaration(C.URI.revive(X),Z,oe),[],oe)}registerImplementationProvider(B,X,Z){const oe=this._addNewAdapter(new S(this._documents,Z),B);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(X,B)),this._createDisposable(oe)}$provideImplementation(B,X,Z,oe){return this._withAdapter(B,S,Q=>Q.provideImplementation(C.URI.revive(X),Z,oe),[],oe)}registerTypeDefinitionProvider(B,X,Z){const oe=this._addNewAdapter(new l(this._documents,Z),B);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(X,B)),this._createDisposable(oe)}$provideTypeDefinition(B,X,Z,oe){return this._withAdapter(B,l,Q=>Q.provideTypeDefinition(C.URI.revive(X),Z,oe),[],oe)}registerHoverProvider(B,X,Z,oe){const Q=this._addNewAdapter(new h(this._documents,Z),B);return this._proxy.$registerHoverProvider(Q,this._transformDocumentSelector(X,B)),this._createDisposable(Q)}$provideHover(B,X,Z,oe){return this._withAdapter(B,h,Q=>Q.provideHover(C.URI.revive(X),Z,oe),void 0,oe)}registerEvaluatableExpressionProvider(B,X,Z,oe){const Q=this._addNewAdapter(new E(this._documents,Z),B);return this._proxy.$registerEvaluatableExpressionProvider(Q,this._transformDocumentSelector(X,B)),this._createDisposable(Q)}$provideEvaluatableExpression(B,X,Z,oe){return this._withAdapter(B,E,Q=>Q.provideEvaluatableExpression(C.URI.revive(X),Z,oe),void 0,oe)}registerInlineValuesProvider(B,X,Z,oe){const Q=typeof Z.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ue=this._addNewAdapter(new R(this._documents,Z),B);this._proxy.$registerInlineValuesProvider(ue,this._transformDocumentSelector(X,B),Q);let ve=this._createDisposable(ue);if(Q!==void 0){const xe=Z.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(Q));ve=A.Disposable.from(ve,xe)}return ve}$provideInlineValues(B,X,Z,oe,Q){return this._withAdapter(B,R,ue=>ue.provideInlineValues(C.URI.revive(X),Z,oe,Q),void 0,Q)}registerDocumentHighlightProvider(B,X,Z){const oe=this._addNewAdapter(new M(this._documents,Z),B);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(X,B)),this._createDisposable(oe)}$provideDocumentHighlights(B,X,Z,oe){return this._withAdapter(B,M,Q=>Q.provideDocumentHighlights(C.URI.revive(X),Z,oe),void 0,oe)}registerLinkedEditingRangeProvider(B,X,Z){const oe=this._addNewAdapter(new U(this._documents,Z),B);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(X,B)),this._createDisposable(oe)}$provideLinkedEditingRanges(B,X,Z,oe){return this._withAdapter(B,U,async Q=>{const ue=await Q.provideLinkedEditingRanges(C.URI.revive(X),Z,oe);if(ue)return{ranges:ue.ranges,wordPattern:ue.wordPattern?de._serializeRegExp(ue.wordPattern):void 0}},void 0,oe)}registerReferenceProvider(B,X,Z){const oe=this._addNewAdapter(new F(this._documents,Z),B);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(X,B)),this._createDisposable(oe)}$provideReferences(B,X,Z,oe,Q){return this._withAdapter(B,F,ue=>ue.provideReferences(C.URI.revive(X),Z,oe,Q),void 0,Q)}registerCodeActionProvider(B,X,Z,oe){const Q=new y.DisposableStore,ue=this._addNewAdapter(new x(this._documents,this._commands.converter,this._diagnostics,Z,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerQuickFixSupport(ue,this._transformDocumentSelector(X,B),{providedKinds:oe?.providedCodeActionKinds?.map(ve=>ve.value),documentation:oe?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,Q)}))},de._extLabel(B),!!Z.resolveCodeAction),Q.add(this._createDisposable(ue)),Q}$provideCodeActions(B,X,Z,oe,Q){return this._withAdapter(B,x,ue=>ue.provideCodeActions(C.URI.revive(X),Z,oe,Q),void 0,Q)}$resolveCodeAction(B,X,Z){return this._withAdapter(B,x,oe=>oe.resolveCodeAction(X,Z),{},void 0)}$releaseCodeActions(B,X){this._withAdapter(B,x,Z=>Promise.resolve(Z.releaseCodeActions(X)),void 0,void 0)}registerDocumentFormattingEditProvider(B,X,Z){const oe=this._addNewAdapter(new O(this._documents,Z),B);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(X,B),B.identifier,B.displayName||B.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(B,X,Z,oe){return this._withAdapter(B,O,Q=>Q.provideDocumentFormattingEdits(C.URI.revive(X),Z,oe),void 0,oe)}registerDocumentRangeFormattingEditProvider(B,X,Z){const oe=typeof Z.provideDocumentRangesFormattingEdits=="function",Q=this._addNewAdapter(new K(this._documents,Z),B);return this._proxy.$registerRangeFormattingSupport(Q,this._transformDocumentSelector(X,B),B.identifier,B.displayName||B.name,oe),this._createDisposable(Q)}$provideDocumentRangeFormattingEdits(B,X,Z,oe,Q){return this._withAdapter(B,K,ue=>ue.provideDocumentRangeFormattingEdits(C.URI.revive(X),Z,oe,Q),void 0,Q)}$provideDocumentRangesFormattingEdits(B,X,Z,oe,Q){return this._withAdapter(B,K,ue=>ue.provideDocumentRangesFormattingEdits(C.URI.revive(X),Z,oe,Q),void 0,Q)}registerOnTypeFormattingEditProvider(B,X,Z,oe){const Q=this._addNewAdapter(new q(this._documents,Z),B);return this._proxy.$registerOnTypeFormattingSupport(Q,this._transformDocumentSelector(X,B),oe,B.identifier),this._createDisposable(Q)}$provideOnTypeFormattingEdits(B,X,Z,oe,Q,ue){return this._withAdapter(B,q,ve=>ve.provideOnTypeFormattingEdits(C.URI.revive(X),Z,oe,Q,ue),void 0,ue)}registerWorkspaceSymbolProvider(B,X){const Z=this._addNewAdapter(new fe(X,this._logService),B);return this._proxy.$registerNavigateTypeSupport(Z,typeof X.resolveWorkspaceSymbol=="function"),this._createDisposable(Z)}$provideWorkspaceSymbols(B,X,Z){return this._withAdapter(B,fe,oe=>oe.provideWorkspaceSymbols(X,Z),{symbols:[]},Z)}$resolveWorkspaceSymbol(B,X,Z){return this._withAdapter(B,fe,oe=>oe.resolveWorkspaceSymbol(X,Z),void 0,void 0)}$releaseWorkspaceSymbols(B,X){this._withAdapter(B,fe,Z=>Z.releaseWorkspaceSymbols(X),void 0,void 0)}registerRenameProvider(B,X,Z){const oe=this._addNewAdapter(new se(this._documents,Z,this._logService),B);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(X,B),se.supportsResolving(Z)),this._createDisposable(oe)}$provideRenameEdits(B,X,Z,oe,Q){return this._withAdapter(B,se,ue=>ue.provideRenameEdits(C.URI.revive(X),Z,oe,Q),void 0,Q)}$resolveRenameLocation(B,X,Z,oe){return this._withAdapter(B,se,Q=>Q.resolveRenameLocation(C.URI.revive(X),Z,oe),void 0,oe)}registerDocumentSemanticTokensProvider(B,X,Z,oe){const Q=this._addNewAdapter(new H(this._documents,Z),B),ue=typeof Z.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(Q,this._transformDocumentSelector(X,B),oe,ue);let ve=this._createDisposable(Q);if(ue){const xe=Z.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(ue));ve=A.Disposable.from(ve,xe)}return ve}$provideDocumentSemanticTokens(B,X,Z,oe){return this._withAdapter(B,H,Q=>Q.provideDocumentSemanticTokens(C.URI.revive(X),Z,oe),null,oe)}$releaseDocumentSemanticTokens(B,X){this._withAdapter(B,H,Z=>Z.releaseDocumentSemanticColoring(X),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,X,Z,oe){const Q=this._addNewAdapter(new re(this._documents,Z),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Q,this._transformDocumentSelector(X,B),oe),this._createDisposable(Q)}$provideDocumentRangeSemanticTokens(B,X,Z,oe){return this._withAdapter(B,re,Q=>Q.provideDocumentRangeSemanticTokens(C.URI.revive(X),Z,oe),null,oe)}registerCompletionItemProvider(B,X,Z,oe){const Q=this._addNewAdapter(new Ee(this._documents,this._commands.converter,Z,this._apiDeprecation,B),B);return this._proxy.$registerCompletionsProvider(Q,this._transformDocumentSelector(X,B),oe,Ee.supportsResolving(Z),B.identifier),this._createDisposable(Q)}$provideCompletionItems(B,X,Z,oe,Q){return this._withAdapter(B,Ee,ue=>ue.provideCompletionItems(C.URI.revive(X),Z,oe,Q),void 0,Q)}$resolveCompletionItem(B,X,Z){return this._withAdapter(B,Ee,oe=>oe.resolveCompletionItem(X,Z),void 0,Z)}$releaseCompletionItems(B,X){this._withAdapter(B,Ee,Z=>Z.releaseCompletionItems(X),void 0,void 0)}registerInlineCompletionsProvider(B,X,Z,oe){const Q=new ne(B,this._documents,Z,this._commands.converter),ue=this._addNewAdapter(Q,B);return this._proxy.$registerInlineCompletionsSupport(ue,this._transformDocumentSelector(X,B),Q.supportsHandleEvents,D.ExtensionIdentifier.toKey(B.identifier.value),oe?.yieldTo?.map(ve=>D.ExtensionIdentifier.toKey(ve))||[]),this._createDisposable(ue)}$provideInlineCompletions(B,X,Z,oe,Q){return this._withAdapter(B,ae,ue=>ue.provideInlineCompletions(C.URI.revive(X),Z,oe,Q),void 0,Q)}$handleInlineCompletionDidShow(B,X,Z,oe){this._withAdapter(B,ae,async Q=>{Q.handleDidShowCompletionItem(X,Z,oe)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,X,Z,oe){this._withAdapter(B,ae,async Q=>{Q.handlePartialAccept(X,Z,oe)},void 0,void 0)}$freeInlineCompletionsList(B,X){this._withAdapter(B,ae,async Z=>{Z.disposeCompletions(X)},void 0,void 0)}registerSignatureHelpProvider(B,X,Z,oe){const Q=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ue=this._addNewAdapter(new N(this._documents,Z),B);return this._proxy.$registerSignatureHelpProvider(ue,this._transformDocumentSelector(X,B),Q),this._createDisposable(ue)}$provideSignatureHelp(B,X,Z,oe,Q){return this._withAdapter(B,N,ue=>ue.provideSignatureHelp(C.URI.revive(X),Z,oe,Q),void 0,Q)}$releaseSignatureHelp(B,X){this._withAdapter(B,N,Z=>Z.releaseSignatureHelp(X),void 0,void 0)}registerInlayHintsProvider(B,X,Z){const oe=typeof Z.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Q=this._addNewAdapter(new W(this._documents,this._commands.converter,Z,this._logService,B),B);this._proxy.$registerInlayHintsProvider(Q,this._transformDocumentSelector(X,B),typeof Z.resolveInlayHint=="function",oe,de._extLabel(B));let ue=this._createDisposable(Q);if(oe!==void 0){const ve=Z.onDidChangeInlayHints(xe=>this._proxy.$emitInlayHintsEvent(oe));ue=A.Disposable.from(ue,ve)}return ue}$provideInlayHints(B,X,Z,oe){return this._withAdapter(B,W,Q=>Q.provideInlayHints(C.URI.revive(X),Z,oe),void 0,oe)}$resolveInlayHint(B,X,Z){return this._withAdapter(B,W,oe=>oe.resolveInlayHint(X,Z),void 0,Z)}$releaseInlayHints(B,X){this._withAdapter(B,W,Z=>Z.releaseHints(X),void 0,void 0)}registerDocumentLinkProvider(B,X,Z){const oe=this._addNewAdapter(new he(this._documents,Z),B);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(X,B),typeof Z.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(B,X,Z){return this._withAdapter(B,he,oe=>oe.provideLinks(C.URI.revive(X),Z),void 0,Z,X.scheme==="output")}$resolveDocumentLink(B,X,Z){return this._withAdapter(B,he,oe=>oe.resolveLink(X,Z),void 0,void 0,!0)}$releaseDocumentLinks(B,X){this._withAdapter(B,he,Z=>Z.releaseLinks(X),void 0,void 0,!0)}registerColorProvider(B,X,Z){const oe=this._addNewAdapter(new Se(this._documents,Z),B);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(X,B)),this._createDisposable(oe)}$provideDocumentColors(B,X,Z){return this._withAdapter(B,Se,oe=>oe.provideColors(C.URI.revive(X),Z),[],Z)}$provideColorPresentations(B,X,Z,oe){return this._withAdapter(B,Se,Q=>Q.provideColorPresentations(C.URI.revive(X),Z,oe),void 0,oe)}registerFoldingRangeProvider(B,X,Z){const oe=this._nextHandle(),Q=typeof Z.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Y(new be(this._documents,Z),B)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(X,B),B.identifier,Q);let ue=this._createDisposable(oe);if(Q!==void 0){const ve=Z.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Q));ue=A.Disposable.from(ue,ve)}return ue}$provideFoldingRanges(B,X,Z,oe){return this._withAdapter(B,be,Q=>Q.provideFoldingRanges(C.URI.revive(X),Z,oe),void 0,oe)}registerSelectionRangeProvider(B,X,Z){const oe=this._addNewAdapter(new we(this._documents,Z,this._logService),B);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(X,B)),this._createDisposable(oe)}$provideSelectionRanges(B,X,Z,oe){return this._withAdapter(B,we,Q=>Q.provideSelectionRanges(C.URI.revive(X),Z,oe),[],oe)}registerCallHierarchyProvider(B,X,Z){const oe=this._addNewAdapter(new ye(this._documents,Z),B);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(X,B)),this._createDisposable(oe)}$prepareCallHierarchy(B,X,Z,oe){return this._withAdapter(B,ye,Q=>Promise.resolve(Q.prepareSession(C.URI.revive(X),Z,oe)),void 0,oe)}$provideCallHierarchyIncomingCalls(B,X,Z,oe){return this._withAdapter(B,ye,Q=>Q.provideCallsTo(X,Z,oe),void 0,oe)}$provideCallHierarchyOutgoingCalls(B,X,Z,oe){return this._withAdapter(B,ye,Q=>Q.provideCallsFrom(X,Z,oe),void 0,oe)}$releaseCallHierarchy(B,X){this._withAdapter(B,ye,Z=>Promise.resolve(Z.releaseSession(X)),void 0,void 0)}registerTypeHierarchyProvider(B,X,Z){const oe=this._addNewAdapter(new V(this._documents,Z),B);return this._proxy.$registerTypeHierarchyProvider(oe,this._transformDocumentSelector(X,B)),this._createDisposable(oe)}$prepareTypeHierarchy(B,X,Z,oe){return this._withAdapter(B,V,Q=>Promise.resolve(Q.prepareSession(C.URI.revive(X),Z,oe)),void 0,oe)}$provideTypeHierarchySupertypes(B,X,Z,oe){return this._withAdapter(B,V,Q=>Q.provideSupertypes(X,Z,oe),void 0,oe)}$provideTypeHierarchySubtypes(B,X,Z,oe){return this._withAdapter(B,V,Q=>Q.provideSubtypes(X,Z,oe),void 0,oe)}$releaseTypeHierarchy(B,X){this._withAdapter(B,V,Z=>Promise.resolve(Z.releaseSession(X)),void 0,void 0)}registerDocumentOnDropEditProvider(B,X,Z,oe){const Q=this._nextHandle();this._adapter.set(Q,new Y(new ee(this._proxy,this._documents,Z,Q,B),B));const ue=(0,t.isProposedApiEnabled)(B,"dropMetadata")&&oe?ee.toInternalProviderId(B.identifier.value,oe.id):void 0;return this._proxy.$registerDocumentOnDropEditProvider(Q,this._transformDocumentSelector(X,B),ue,(0,t.isProposedApiEnabled)(B,"dropMetadata")?oe:void 0),this._createDisposable(Q)}$provideDocumentOnDropEdits(B,X,Z,oe,Q,ue){return this._withAdapter(B,ee,ve=>Promise.resolve(ve.provideDocumentOnDropEdits(X,C.URI.revive(Z),oe,Q,ue)),void 0,void 0)}registerMappedEditsProvider(B,X,Z){const oe=this._addNewAdapter(new G(this._documents,Z),B);return this._proxy.$registerMappedEditsProvider(oe,this._transformDocumentSelector(X,B)),this._createDisposable(oe)}$provideMappedEdits(B,X,Z,oe,Q){return this._withAdapter(B,G,ue=>Promise.resolve(ue.provideMappedEdits(X,Z,oe,Q)),null,Q)}registerDocumentPasteEditProvider(B,X,Z,oe){const Q=this._nextHandle();this._adapter.set(Q,new Y(new $(this._proxy,this._documents,Z,Q,B),B));const ue=$.toInternalProviderId(B.identifier.value,oe.id);return this._proxy.$registerPasteEditProvider(Q,this._transformDocumentSelector(X,B),ue,{supportsCopy:!!Z.prepareDocumentPaste,supportsPaste:!!Z.provideDocumentPasteEdits,copyMimeTypes:oe.copyMimeTypes,pasteMimeTypes:oe.pasteMimeTypes}),this._createDisposable(Q)}$prepareDocumentPaste(B,X,Z,oe,Q){return this._withAdapter(B,$,ue=>ue.prepareDocumentPaste(C.URI.revive(X),Z,oe,Q),void 0,Q)}$providePasteEdits(B,X,Z,oe,Q,ue){return this._withAdapter(B,$,ve=>ve.providePasteEdits(X,C.URI.revive(Z),oe,Q,ue),void 0,ue)}static _serializeRegExp(B){return{pattern:B.source,flags:B.flags}}static _serializeIndentationRule(B){return{decreaseIndentPattern:de._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:de._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?de._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?de._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:de._serializeRegExp(B.beforeText),afterText:B.afterText?de._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?de._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(de._serializeOnEnterRule)}setLanguageConfiguration(B,X,Z){const{wordPattern:oe}=Z;if(oe&&(0,w.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(X,oe):this._documents.setWordDefinitionFor(X,void 0),Z.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),Z.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use."),Z.autoClosingPairs&&(0,t.checkProposedApiEnabled)(B,"languageConfigurationAutoClosingPairs");const Q=this._nextHandle(),ue={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?de._serializeRegExp(Z.wordPattern):void 0,indentationRules:Z.indentationRules?de._serializeIndentationRule(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?de._serializeOnEnterRules(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport,autoClosingPairs:Z.autoClosingPairs};return this._proxy.$setLanguageConfiguration(Q,X,ue),this._createDisposable(Q)}$setWordDefinitions(B){for(const X of B)this._documents.setWordDefinitionFor(X.languageId,new RegExp(X.regexSource,X.regexFlags))}}e.ExtHostLanguageFeatures=de}),define(Ce[307],De([1,0,5,10,7,40,13,3]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(P,k,p,_){this._documents=k,this._commands=p,this._uriTransformer=_,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=P.getProxy(C.MainContext.MainThreadLanguages)}$acceptLanguageIds(P){this._languageIds=P}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(P,k){await this._proxy.$changeLanguage(P,k);const p=this._documents.getDocumentData(P);if(!p)throw new Error(`document '${P.toString()}' NOT found`);return p.document}async tokenAtPosition(P,k){const p=P.version,_=L.Position.from(k),D=await this._proxy.$tokensAtPosition(P.uri,_),y={type:d.StandardTokenType.Other,range:P.getWordRangeAtPosition(k)??new d.Range(k.line,k.character,k.line,k.character)};if(!D)return y;const n={range:L.Range.to(D.range),type:L.TokenType.to(D.type)};return!n.range.contains(k)||p!==P.version?y:n}createLanguageStatusItem(P,k,p){const _=this._handlePool++,D=this._proxy,y=this._ids,n=`${P.identifier.value}/${k}`;if(y.has(n))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);y.add(n);const o={selector:p,id:k,name:P.displayName??P.name,severity:d.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const m=new f.DisposableStore,b=()=>{if(a?.dispose(),!y.has(n)){console.warn(`LanguageStatusItem (${k}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,T.disposableTimeout)(()=>{m.clear(),this._proxy.$setLanguageStatus(_,{id:n,name:o.name??P.displayName??P.name,source:P.displayName??P.name,selector:L.DocumentSelector.from(o.selector,this._uriTransformer),label:o.text,detail:o.detail??"",severity:o.severity===d.LanguageStatusSeverity.Error?A.default.Error:o.severity===d.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:o.command&&this._commands.toInternal(o.command,m),accessibilityInfo:o.accessibilityInformation,busy:o.busy})},0)},I={dispose(){m.dispose(),a?.dispose(),D.$removeLanguageStatus(_),y.delete(n)},get id(){return o.id},get name(){return o.name},set name(t){o.name=t,b()},get selector(){return o.selector},set selector(t){o.selector=t,b()},get text(){return o.text},set text(t){o.text=t,b()},get detail(){return o.detail},set detail(t){o.detail=t,b()},get severity(){return o.severity},set severity(t){o.severity=t,b()},get accessibilityInformation(){return o.accessibilityInformation},set accessibilityInformation(t){o.accessibilityInformation=t,b()},get command(){return o.command},set command(t){o.command=t,b()},get busy(){return o.busy},set busy(t){o.busy=t,b()}};return b(),I}}e.ExtHostLanguages=w}),define(Ce[111],De([1,0,9,15,2,6,17,5,26,20]),function(me,e,C,L,d,A,T,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let P=class{constructor(p,_,D){this.logService=D,this.bundleCache=new Map,this._proxy=_.getProxy(f.MainContext.MainThreadLocalization),this.currentLanguage=p.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===C.LANGUAGE_DEFAULT}getMessage(p,_){const{message:D,args:y,comment:n}=_;if(this.isDefaultLanguage)return(0,L.format2)(D,y??{});let o=D;n&&n.length>0&&(o+=`/${Array.isArray(n)?n.join(""):n}`);const a=this.bundleCache.get(p)?.contents[o];return a||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,L.format2)(a??D,y??{})}getBundle(p){return this.bundleCache.get(p)?.contents}getBundleUri(p){return this.bundleCache.get(p)?.uri}async initializeLocalizedMessages(p){if(this.isDefaultLanguage||!p.l10n&&!p.isBuiltin||this.bundleCache.has(p.identifier.value))return;let _;const D=await this.getBundleLocation(p);if(!D){this.logService.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const y=await this._proxy.$fetchBundleContents(D),n=JSON.parse(y);_=p.isBuiltin?n.contents?.bundle:n}catch(y){this.logService.error(`Failed to load translations for ${p.identifier.value} from ${D}: ${y.message}`);return}_&&this.bundleCache.set(p.identifier.value,{contents:_,uri:D})}async getBundleLocation(p){if(p.isBuiltin){const _=await this._proxy.$fetchBuiltInBundleUri(p.identifier.value,this.currentLanguage);return d.URI.revive(_)}return p.l10n?d.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=P,e.ExtHostLocalizationService=P=qe([$e(0,w.IExtHostInitDataService),$e(1,g.IExtHostRpcService),$e(2,T.ILogService)],P),e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(Ce[147],De([1,0,17,5,26,20,2,77]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let w=class extends C.AbstractLoggerService{constructor(k,p){super(p.logLevel,p.logsLocation,p.loggers.map(_=>(0,f.revive)(_))),this._proxy=k.getProxy(L.MainContext.MainThreadLogger)}$setLogLevel(k,p){p?this.setLogLevel(T.URI.revive(p),k):this.setLogLevel(k)}setVisibility(k,p){super.setVisibility(k,p),this._proxy.$setVisibility(k,p)}doCreateLogger(k,p,_){return new g(this._proxy,k,p,_)}};e.ExtHostLoggerService=w,e.ExtHostLoggerService=w=qe([$e(0,A.IExtHostRpcService),$e(1,d.IExtHostInitDataService)],w);class g extends C.AbstractMessageLogger{constructor(k,p,_,D){super(D?.logLevel==="always"),this.proxy=k,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(_),this.proxy.$createLogger(p,D).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(k,p){const _=[[k,p]];this.isLoggerCreated?this.doLog(_):this.buffer.push(..._)}doLog(k){this.proxy.$log(this.file,k)}flush(){this.proxy.$flush(this.file)}}}),define(Ce[112],De([1,0,5,6,3,20,21]),function(me,e,C,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,L.createDecorator)("IExtHostManagedSockets");let f=class{constructor(k){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=k.getProxy(C.MainContext.MainThreadManagedSockets)}setFactory(k,p){for(const _ of this._managedRemoteSockets.values())_.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new w(k,p),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(k){if(!this._factory||this._factory.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const p=++this._remoteSocketIdCounter,_=await this._factory.makeConnection(),D=new d.DisposableStore;return this._managedRemoteSockets.set(p,new g(p,_,D)),D.add((0,d.toDisposable)(()=>this._managedRemoteSockets.delete(p))),D.add(_.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(p),D.dispose()})),D.add(_.onDidClose(y=>{this._proxy.$onDidManagedSocketClose(p,y?.stack??y?.message),D.dispose()})),D.add(_.onDidReceiveMessage(y=>this._proxy.$onDidManagedSocketHaveData(p,T.VSBuffer.wrap(y)))),p}$remoteSocketWrite(k,p){this._managedRemoteSockets.get(k)?.actual.send(p.buffer)}$remoteSocketEnd(k){const p=this._managedRemoteSockets.get(k);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(k){await this._managedRemoteSockets.get(k)?.actual.drain?.()}};e.ExtHostManagedSockets=f,e.ExtHostManagedSockets=f=qe([$e(0,A.IExtHostRpcService)],f);class w{constructor(k,p){this.socketFactoryId=k,this.makeConnection=p}}class g extends d.Disposable{constructor(k,p,_){super(),this.socketId=k,this.actual=p,this._register(_)}}}),define(Ce[308],De([1,0,5,17,27]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(f){return f&&f.title}let T=class{constructor(w,g){this._logService=g,this._proxy=w.getProxy(C.MainContext.MainThreadMessageService)}showMessage(w,g,P,k,p){const _={source:{identifier:w.identifier,label:w.displayName||w.name}};let D;typeof k=="string"||A(k)?D=[k,...p]:(_.modal=k?.modal,_.useCustom=k?.useCustom,_.detail=k?.detail,D=p),_.useCustom&&(0,d.checkProposedApiEnabled)(w,"resolvers");const y=[];for(let n=0;n<D.length;n++){const o=D[n];if(typeof o=="string")y.push({title:o,handle:n,isCloseAffordance:!1});else if(typeof o=="object"){const{title:a,isCloseAffordance:m}=o;y.push({title:a,isCloseAffordance:!!m,handle:n})}else this._logService.warn("Invalid message item:",o)}return this._proxy.$showMessage(g,P,_,y).then(n=>{if(typeof n=="number")return D[n]})}};e.ExtHostMessageService=T,e.ExtHostMessageService=T=qe([$e(1,L.ILogService)],T)}),define(Ce[309],De([1,0,201,21,4,3,28,15,19,2,30,86,5,33,10,7,64,271,142,8,23,16]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class t{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}constructor(s,i,c,u,v){this._textDocumentsAndEditors=c,this._textDocuments=u,this._extHostFileSystem=v,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new d.Emitter({onListenerError:m.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new d.Emitter({onListenerError:m.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new d.Emitter({onListenerError:m.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new d.Emitter({onListenerError:m.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new k.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=s.getProxy(p.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(p.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(p.MainContext.MainThreadNotebookEditors),this._commandsConverter=i.converter,i.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const l=S.notebookEditor?.notebookUri,h=S.cell.handle,R=this._documents.get(l)?.getCell(h);if(R)return R.apiCell}if(S&&S.$mid===14){const l=S.uri,h=this._documents.get(l);if(h)return h.apiNotebook}return S}}),t._registerApiCommands(i)}getEditorById(s){const i=this._editors.get(s);if(!i)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return i}getIdByEditor(s){for(const[i,c]of this._editors)if(c.apiEditor===s)return i}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,i){const c=this._documents.get(s);if(!c&&!i)throw new Error(`NO notebook document for '${s}'`);return c}static _convertNotebookRegistrationData(s,i){if(!i)return;const c=i.filenamePattern.map(u=>D.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(i.filenamePattern&&!c){console.warn(`Notebook content provider view options file name pattern is invalid ${i.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:i.displayName,filenamePattern:c,exclusive:i.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,i,c){const u=t._notebookStatusBarItemProviderHandlePool++,v=typeof c.onDidChangeCellStatusBarItems=="function"?t._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(u,c),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(u,v,i);let S;return v!==void 0&&(S=c.onDidChangeCellStatusBarItems(l=>this._notebookProxy.$emitCellStatusBarEvent(v))),new y.Disposable(()=>{this._notebookStatusBarItemProviders.delete(u),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(u,v),S?.dispose()})}async createNotebookDocument(s){const i=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&D.NotebookData.from(s.content)});return g.URI.revive(i)}async openNotebookDocument(s){const i=this._documents.get(s);if(i)return i.apiNotebook;const c=await this._notebookDocumentsProxy.$tryOpenNotebook(s),u=this._documents.get(g.URI.revive(c));return(0,w.assertIsDefined)(u?.apiNotebook)}async showNotebookDocument(s,i){g.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let c;typeof i=="object"?c={position:D.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(D.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:c={preserveFocus:!1};const u=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,c),v=u&&this._editors.get(u)?.apiEditor;if(v)return v;throw u?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,i,c,u){const v=this._notebookStatusBarItemProviders.get(s),S=g.URI.revive(i),l=this._documents.get(S);if(!l||!v)return;const h=l.getCellFromIndex(c);if(!h)return;const E=await v.provideCellStatusBarItems(h.apiCell,u);if(!E)return;const R=new A.DisposableStore,M=this._statusBarCache.add([R]),F=(Array.isArray(E)?E:[E]).map(x=>D.NotebookStatusBarItem.from(x,this._commandsConverter,R));return{cacheId:M,items:F}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,i,c,u,v){if((0,f.isFalsyOrWhitespace)(i))throw new Error("viewType cannot be empty or just whitespace");const S=this._handlePool++;return this._notebookSerializer.set(S,{viewType:i,serializer:c,options:u}),this._notebookProxy.$registerNotebookSerializer(S,{id:s.identifier,location:s.extensionLocation},i,D.NotebookDocumentContentOptions.from(u),t._convertNotebookRegistrationData(s,v)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(S)})}async $dataToNotebook(s,i,c){const u=this._notebookSerializer.get(s);if(!u)throw new Error("NO serializer found");const v=await u.serializer.deserializeNotebook(i.buffer,c);return new n.SerializableObjectWithBuffers(D.NotebookData.from(v))}async $notebookToData(s,i,c){const u=this._notebookSerializer.get(s);if(!u)throw new Error("NO serializer found");const v=await u.serializer.serializeNotebook(D.NotebookData.to(i.value),c);return L.VSBuffer.wrap(v)}async $saveNotebook(s,i,c,u,v){const S=g.URI.revive(i),l=this._notebookSerializer.get(s);if(!l)throw new Error("NO serializer found");const h=this._documents.get(S);if(!h)throw new Error("Document NOT found");if(h.versionId!==c)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(S.scheme))throw new P.FileOperationError((0,C.localize)(0,null,this._resourceForError(S)),6);await this._validateWriteFile(S,u);const E={metadata:(0,b.filter)(h.apiNotebook.metadata,x=>!(l.options?.transientDocumentMetadata??{})[x]),cells:[]};for(const x of h.apiNotebook.getCells()){const $=new y.NotebookCellData(x.kind,x.document.getText(),x.document.languageId,x.mime,l.options?.transientOutputs?[]:[...x.outputs],x.metadata,x.executionSummary);$.metadata=(0,b.filter)(x.metadata,O=>!(l.options?.transientCellMetadata??{})[O]),E.cells.push($)}const R=await l.serializer.serializeNotebook(E,v);await this._extHostFileSystem.value.writeFile(S,R);const M=this._extHostFileSystem.getFileSystemProviderExtUri(S.scheme),U=await this._extHostFileSystem.value.stat(S);return{name:M.basename(S),isFile:(U.type&P.FileType.File)!==0,isDirectory:(U.type&P.FileType.Directory)!==0,isSymbolicLink:(U.type&P.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&P.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(S.scheme),locked:!!((U.permissions??0)&P.FilePermission.Locked),etag:P.etag({mtime:U.mtime,size:U.size}),children:void 0}}async _validateWriteFile(s,i){const c=await this._extHostFileSystem.value.stat(s);if(typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==P.ETAG_DISABLED&&typeof c.mtime=="number"&&typeof c.size=="number"&&i.mtime<c.mtime&&i.etag!==P.etag({mtime:i.mtime,size:c.size}))throw new P.FileOperationError((0,C.localize)(1,null),3,i)}_resourceForError(s){return s.scheme===I.Schemas.file?s.fsPath:s.toString()}_createExtHostEditor(s,i,c){if(this._editors.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const u=new a.ExtHostNotebookEditor(i,this._notebookEditorsProxy,s,c.visibleRanges.map(D.NotebookRange.to),c.selections.map(D.NotebookRange.to),typeof c.viewColumn=="number"?D.ViewColumn.to(c.viewColumn):void 0);this._editors.set(i,u)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const c of s.value.removedDocuments){const u=g.URI.revive(c),v=this._documents.get(u);v&&(v.dispose(),this._documents.delete(u),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(S=>S.document.uri)}),this._onDidCloseNotebookDocument.fire(v.apiNotebook));for(const S of this._editors.values())S.notebookData.uri.toString()===u.toString()&&this._editors.delete(S.id)}if(s.value.addedDocuments){const c=[];for(const u of s.value.addedDocuments){const v=g.URI.revive(u.uri);if(this._documents.has(v))throw new Error(`adding EXISTING notebook ${v} `);const S=new o.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,v,u);c.push(...u.cells.map(l=>o.ExtHostCell.asModelAddData(S.apiNotebook,l))),this._documents.get(v)?.dispose(),this._documents.set(v,S),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:c}),this._onDidOpenNotebookDocument.fire(S.apiNotebook)}}if(s.value.addedEditors)for(const c of s.value.addedEditors){if(this._editors.has(c.id))return;const u=g.URI.revive(c.documentUri),v=this._documents.get(u);v&&this._createExtHostEditor(v,c.id,c)}const i=[];if(s.value.removedEditors)for(const c of s.value.removedEditors){const u=this._editors.get(c);u&&(this._editors.delete(c),this._activeNotebookEditor?.id===u.id&&(this._activeNotebookEditor=void 0),i.push(u))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(u=>this._editors.get(u)).filter(u=>!!u);const c=new Set;this._visibleNotebookEditors.forEach(u=>c.add(u.id));for(const u of this._editors.values()){const v=c.has(u.id);u._acceptVisibility(v)}this._visibleNotebookEditors=[...this._editors.values()].map(u=>u).filter(u=>u.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._editors.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(s){const i=_.ApiCommandArgument.String.with("notebookType","A notebook type"),c=new _.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[i,new _.ApiCommandArgument("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>L.VSBuffer.wrap(v))],new _.ApiCommandResult("Notebook Data",v=>D.NotebookData.to(v.value))),u=new _.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[i,new _.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new n.SerializableObjectWithBuffers(D.NotebookData.from(v)))],new _.ApiCommandResult("Bytes",v=>v.buffer));s.registerApiCommand(c),s.registerApiCommand(u)}}e.ExtHostNotebookController=t}),define(Ce[310],De([1,0,18,13,22,4,3,28,2,25,17,86,5,33,10,7,109,265,27,64]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let b=class{constructor(v,S,l,h,E){this._initData=S,this._extHostNotebook=l,this._commands=h,this._logService=E,this._activeExecutions=new f.ResourceMap,this._activeNotebookExecutions=new f.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new k.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=v.getProxy(p.MainContext.MainThreadNotebookKernels);const R=new _.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new _.ApiCommandArgument("options","Select kernel options",M=>!0,M=>{if(M&&"notebookEditor"in M&&"id"in M){const U=this._extHostNotebook.getIdByEditor(M.notebookEditor);return{id:M.id,extension:M.extension,notebookEditorId:U}}else if(M&&"notebookEditor"in M){const U=this._extHostNotebook.getIdByEditor(M.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${M.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:U}}return M})],_.ApiCommandResult.Void);this._commands.registerApiCommand(R)}createNotebookController(v,S,l,h,E,R){for(const ae of this._kernelData.values())if(ae.controller.id===S&&g.ExtensionIdentifier.equals(v.identifier,ae.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const M=this._handlePool++,U=this;this._logService.trace(`NotebookController[${M}], CREATED by ${v.identifier.value}, ${S}`);const F=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${v.identifier}'`);let x=!1;const $=new T.DisposableStore,O=new A.Emitter,K=new A.Emitter,q={id:c(v.identifier,S),notebookType:l,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:h||v.identifier.value,preloads:R?R.map(D.NotebookRendererScript.from):[]};let fe=E??F,se;this._proxy.$addKernel(M,q).catch(ae=>{console.log(ae),x=!0});let ie=0;const H=()=>{if(x)return;const ae=++ie;Promise.resolve().then(()=>{ae===ie&&this._proxy.$updateKernel(M,q)})},re=new f.ResourceMap,Ee={get id(){return S},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return q.label},set label(ae){q.label=ae??v.displayName??v.name,H()},get detail(){return q.detail??""},set detail(ae){q.detail=ae,H()},get description(){return q.description??""},set description(ae){q.description=ae,H()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(ae){q.supportedLanguages=ae,H()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){q.supportsExecutionOrder=ae,H()},get rendererScripts(){return q.preloads?q.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return fe},set executeHandler(ae){fe=ae??F},get interruptHandler(){return se},set interruptHandler(ae){se=ae,q.supportsInterrupt=!!ae,H()},createNotebookCellExecution(ae){if(x)throw new Error("notebook controller is DISPOSED");if(!re.has(ae.notebook.uri))throw U._logService.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return U._createNotebookCellExecution(ae,c(v.identifier,this.id))},createNotebookExecution(ae){if((0,a.checkProposedApiEnabled)(v,"notebookExecution"),x)throw new Error("notebook controller is DISPOSED");if(!re.has(ae.uri))throw U._logService.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return U._createNotebookExecution(ae,c(v.identifier,this.id))},dispose:()=>{x||(this._logService.trace(`NotebookController[${M}], DISPOSED`),x=!0,this._kernelData.delete(M),$.dispose(),O.dispose(),K.dispose(),this._proxy.$removeKernel(M))},updateNotebookAffinity(ae,ne){ne===y.NotebookControllerAffinity2.Hidden&&(0,a.checkProposedApiEnabled)(v,"notebookControllerAffinityHidden"),U._proxy.$updateNotebookPriority(M,ae.uri,ne)},onDidReceiveMessage:K.event,postMessage(ae,ne){return(0,a.checkProposedApiEnabled)(v,"notebookMessaging"),U._proxy.$postMessage(M,ne&&U._extHostNotebook.getIdByEditor(ne),ae)},asWebviewUri(ae){return(0,a.checkProposedApiEnabled)(v,"notebookMessaging"),(0,n.asWebviewUri)(ae,U._initData.remote)}};return this._kernelData.set(M,{extensionId:v.identifier,controller:Ee,onDidReceiveMessage:K,onDidChangeSelection:O,associatedNotebooks:re}),Ee}getIdByController(v){for(const[S,l]of this._kernelData)if(l.controller===v)return c(l.extensionId,v.id);return null}createNotebookControllerDetectionTask(v,S){const l=this._kernelDetectionTaskHandlePool++,h=this;this._logService.trace(`NotebookControllerDetectionTask[${l}], CREATED by ${v.identifier.value}`),this._proxy.$addKernelDetectionTask(l,S);const E={dispose:()=>{this._kernelDetectionTask.delete(l),h._proxy.$removeKernelDetectionTask(l)}};return this._kernelDetectionTask.set(l,E),E}registerKernelSourceActionProvider(v,S,l){const h=this._kernelSourceActionProviderHandlePool++,E=typeof l.onDidChangeNotebookKernelSourceActions=="function"?h:void 0,R=this;this._kernelSourceActionProviders.set(h,l),this._logService.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${v.identifier.value}`),this._proxy.$addKernelSourceActionProvider(h,h,S);let M;return E!==void 0&&(M=l.onDidChangeNotebookKernelSourceActions(U=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(E))),{dispose:()=>{this._kernelSourceActionProviders.delete(h),R._proxy.$removeKernelSourceActionProvider(h,h),M?.dispose()}}}async $provideKernelSourceActions(v,S){const l=this._kernelSourceActionProviders.get(v);if(l){const h=new T.DisposableStore;return this._kernelSourceActionProviderCache.add([h]),(await l.provideNotebookKernelSourceActions(S)??[]).map(R=>D.NotebookKernelSourceAction.from(R,this._commands.converter,h))}return[]}$acceptNotebookAssociation(v,S,l){const h=this._kernelData.get(v);if(h){const E=this._extHostNotebook.getNotebookDocument(w.URI.revive(S));l?h.associatedNotebooks.set(E.uri,!0):h.associatedNotebooks.delete(E.uri),this._logService.trace(`NotebookController[${v}] ASSOCIATE notebook`,E.uri.toString(),l),h.onDidChangeSelection.fire({selected:l,notebook:E.apiNotebook})}}async $executeCells(v,S,l){const h=this._kernelData.get(v);if(!h)return;const E=this._extHostNotebook.getNotebookDocument(w.URI.revive(S)),R=[];for(const M of l){const U=E.getCell(M);U&&R.push(U.apiCell)}try{this._logService.trace(`NotebookController[${v}] EXECUTE cells`,E.uri.toString(),R.length),await h.controller.executeHandler.call(h.controller,R,E.apiNotebook,h.controller)}catch(M){this._logService.error(`NotebookController[${v}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(v,S,l){const h=this._kernelData.get(v);if(!h)return;const E=this._extHostNotebook.getNotebookDocument(w.URI.revive(S));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,E.apiNotebook);else for(const R of l){const M=E.getCell(R);M&&this._activeExecutions.get(M.uri)?.cancel()}if(h.controller.interruptHandler){const R=this._activeNotebookExecutions.get(E.uri);l.length&&Array.isArray(R)&&R.length&&R.forEach(M=>M.dispose())}}$acceptKernelMessageFromRenderer(v,S,l){const h=this._kernelData.get(v);if(!h)return;const E=this._extHostNotebook.getEditorById(S);h.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:l}))}$cellExecutionChanged(v,S,l){const E=this._extHostNotebook.getNotebookDocument(w.URI.revive(v)).getCell(S);if(E){const R=l?D.NotebookCellExecutionState.to(l):y.NotebookCellExecutionState.Idle;R!==void 0&&this._onDidChangeCellExecutionState.fire({cell:E.apiCell,state:R})}}_createNotebookCellExecution(v,S){if(v.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this._extHostNotebook.getNotebookDocument(v.notebook.uri).getCellFromApiCell(v);if(!h)throw new Error("invalid cell");if(this._activeExecutions.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const E=new t(S,h,this._proxy);this._activeExecutions.set(h.uri,E);const R=E.onDidChangeState(()=>{E.state===I.Resolved&&(E.dispose(),R.dispose(),this._activeExecutions.delete(h.uri))});return E.asApiObject()}_createNotebookExecution(v,S){const l=this._extHostNotebook.getNotebookDocument(v.uri),h=v.getCells().find(M=>{const U=l.getCellFromApiCell(M);return U&&this._activeExecutions.has(U.uri)});if(h)throw new Error(`duplicate cell execution for ${h.document.uri}`);if(this._activeNotebookExecutions.has(l.uri))throw new Error(`duplicate notebook execution for ${l.uri}`);const E=new s(S,l,this._proxy),R=E.onDidChangeState(()=>{E.state===r.Resolved&&(E.dispose(),R.dispose(),this._activeNotebookExecutions.delete(l.uri))});return this._activeNotebookExecutions.set(l.uri,[E,R]),E.asApiObject()}};e.ExtHostNotebookKernels=b,e.ExtHostNotebookKernels=b=qe([$e(4,P.ILogService)],b);var I;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(I||(I={}));class t extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(v,S,l){super(),this._cell=S,this._proxy=l,this._handle=t.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=I.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._collector=new i(10,h=>this.update(h)),this._executionOrder=S.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,v,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(v){await this._collector.addItem(v)}async update(v){const S=Array.isArray(v)?v:[v];return this._proxy.$updateExecution(this._handle,new m.SerializableObjectWithBuffers(S))}verifyStateForOutput(){if(this._state===I.Init)throw new Error("Must call start before modifying cell output");if(this._state===I.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(v){let S=this._cell;if(v&&(S=this._cell.notebook.getCellFromApiCell(v)),!S)throw new Error("INVALID cell");return S.handle}validateAndConvertOutputs(v){return v.map(S=>{const l=y.NotebookCellOutput.ensureUniqueMimeTypes(S.items,!0);return l===S.items?D.NotebookCellOutput.from(S):D.NotebookCellOutput.from({items:l,id:S.id,metadata:S.metadata})})}async updateOutputs(v,S,l){const h=this.cellIndexToHandle(S),E=this.validateAndConvertOutputs((0,C.asArray)(v));return this.updateSoon({editType:o.CellExecutionUpdateType.Output,cellHandle:h,append:l,outputs:E})}async updateOutputItems(v,S,l){return v=y.NotebookCellOutput.ensureUniqueMimeTypes((0,C.asArray)(v),!0),this.updateSoon({editType:o.CellExecutionUpdateType.OutputItems,items:v.map(D.NotebookCellOutputItem.from),outputId:S.id,append:l})}asApiObject(){const v=this;return Object.freeze({get token(){return v._tokenSource.token},get cell(){return v._cell.apiCell},get executionOrder(){return v._executionOrder},set executionOrder(l){v._executionOrder=l,v.update([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:v._executionOrder}])},start(l){if(v._state===I.Resolved||v._state===I.Started)throw new Error("Cannot call start again");v._state=I.Started,v._onDidChangeState.fire(),v.update({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:l})},end(l,h){if(v._state===I.Resolved)throw new Error("Cannot call resolve twice");v._state=I.Resolved,v._onDidChangeState.fire(),v._collector.flush(),v._proxy.$completeExecution(v._handle,new m.SerializableObjectWithBuffers({runEndTime:h,lastRunSuccess:l}))},clearOutput(l){return v.verifyStateForOutput(),v.updateOutputs([],l,!1)},appendOutput(l,h){return v.verifyStateForOutput(),v.updateOutputs(l,h,!0)},replaceOutput(l,h){return v.verifyStateForOutput(),v.updateOutputs(l,h,!1)},appendOutputItems(l,h){return v.verifyStateForOutput(),v.updateOutputItems(l,h,!0)},replaceOutputItems(l,h){return v.verifyStateForOutput(),v.updateOutputItems(l,h,!1)}})}}var r;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(r||(r={}));class s extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(v,S,l){super(),this._notebook=S,this._proxy=l,this._handle=s.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,v,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===r.Resolved||this._state===r.Started)throw new Error("Cannot call start again");this._state=r.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===r.Resolved)throw new Error("Cannot call resolve twice");this._state=r.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class i{constructor(v,S){this.delay=v,this.callback=S,this.batch=[],this.startedTimer=Date.now()}addItem(v){return this.batch.push(v),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const v=this.currentDeferred;this.currentDeferred=void 0;const S=this.batch;return this.batch=[],this.callback(S).finally(()=>v.complete())}}function c(u,v){return`${u.value}/${v}`}e.createKernelId=c}),define(Ce[311],De([1,0,4,5,142]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(f,w){this._extHostNotebook=w,this._rendererMessageEmitters=new Map,this.proxy=f.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(f,w,g){const P=this._extHostNotebook.getEditorById(f);this._rendererMessageEmitters.get(w)?.fire({editor:P.apiEditor,message:g})}createRendererMessaging(f,w){if(!f.contributes?.notebookRenderer?.some(P=>P.id===w))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${w})`);return{onDidReceiveMessage:(P,k,p)=>this.getOrCreateEmitterFor(w).event(P,k,p),postMessage:(P,k)=>{d.ExtHostNotebookEditor.apiEditorsToExtHost.has(P)&&([P,k]=[k,P]);const p=k&&d.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(p?.id,w,P)}}}getOrCreateEmitterFor(f){let w=this._rendererMessageEmitters.get(f);return w||(w=new C.Emitter({onDidRemoveLastListener:()=>{w?.dispose(),this._rendererMessageEmitters.delete(f)}}),this._rendererMessageEmitters.set(f,w),w)}}e.ExtHostNotebookRenderers=A}),define(Ce[312],De([1,0,3,19,2,27,5]),function(me,e,C,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class f{constructor(g){this.handlers=new Map,this.proxy=g.getProxy(T.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,P,k){if((0,A.checkProposedApiEnabled)(g,"profileContentHandlers"),this.handlers.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.handlers.set(P,k),this.proxy.$registerProfileContentHandler(P,k.name,k.description,g.identifier.value),(0,C.toDisposable)(()=>{this.handlers.delete(P),this.proxy.$unregisterProfileContentHandler(P)})}async $saveProfile(g,P,k,p){const _=this.handlers.get(g);if(!_)throw new Error(`Unknown handler with id: ${g}`);return _.saveProfile(P,k,p)}async $readProfile(g,P,k){const p=this.handlers.get(g);if(!p)throw new Error(`Unknown handler with id: ${g}`);return p.readProfile((0,L.isString)(P)?P:d.URI.revive(P),k)}}e.ExtHostProfileContentHandlers=f}),define(Ce[313],De([1,0,2,5,13,10]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class T{static{this.handlePool=0}constructor(w,g){this.uriTransformer=g,this.providers=new Map,this.proxy=w.getProxy(L.MainContext.MainThreadQuickDiff)}$provideOriginalResource(w,g,P){const k=C.URI.revive(g),p=this.providers.get(w);return p?(0,d.asPromise)(()=>p.provideOriginalResource(k,P)).then(_=>_||null):Promise.resolve(null)}registerQuickDiffProvider(w,g,P,k){const p=T.handlePool++;return this.providers.set(p,g),this.proxy.$registerQuickDiffProvider(p,A.DocumentSelector.from(w,this.uriTransformer),P,k),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(p),this.providers.delete(p)}}}}e.ExtHostQuickDiff=T}),define(Ce[314],De([1,0,22,4,3,5,2,7,8,18,40,56,27,10]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function D(y,n,o){const a=y.getProxy(A.MainContext.MainThreadQuickOpen);class m{constructor(v,S){this._sessions=new Map,this._instances=0,this._workspace=v,this._commands=S}showQuickPick(v,S,l,h=C.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(S),R=++this._instances,M=a.$show(R,{title:l?.title,placeHolder:l?.placeHolder,matchOnDescription:l?.matchOnDescription,matchOnDetail:l?.matchOnDetail,ignoreFocusLost:l?.ignoreFocusOut,canPickMany:l?.canPickMany},h),U={},F=M.then(()=>U);return Promise.race([F,E]).then(x=>{if(x===U)return;const $=(0,p.isProposedApiEnabled)(v,"quickPickItemTooltip");return E.then(O=>{const K=[];for(let q=0;q<O.length;q++){const fe=O[q];if(typeof fe=="string")K.push({label:fe,handle:q});else if(fe.kind===f.QuickPickItemKind.Separator)K.push({type:"separator",label:fe.label});else{fe.tooltip&&!$&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const se=fe.iconPath?s(fe.iconPath):void 0;K.push({label:fe.label,iconPath:se?.iconPath,iconClass:se?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:$?_.MarkdownString.fromStrict(fe.tooltip):void 0,handle:q})}}return l&&typeof l.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{l.onDidSelectItem(O[q])}),a.$setItems(R,K),M.then(q=>{if(typeof q=="number")return O[q];if(Array.isArray(q))return q.map(fe=>O[fe])})})}).then(void 0,x=>{if(!(0,w.isCancellationError)(x))return a.$setError(R,x),Promise.reject(x)})}$onItemSelected(v){this._onDidSelectItem?.(v)}showInput(v,S=C.CancellationToken.None){return this._validateInput=v?.validateInput,a.$input(v,typeof this._validateInput=="function",S).then(void 0,l=>{if(!(0,w.isCancellationError)(l))return Promise.reject(l)})}async $validateInput(v){if(!this._validateInput)return;const S=await this._validateInput(v);if(!S||typeof S=="string")return S;let l;switch(S.severity){case f.InputBoxValidationSeverity.Info:l=P.default.Info;break;case f.InputBoxValidationSeverity.Warning:l=P.default.Warning;break;case f.InputBoxValidationSeverity.Error:l=P.default.Error;break;default:l=S.message?P.default.Error:P.default.Ignore;break}return{content:S.message,severity:l}}async showWorkspaceFolderPick(v,S=C.CancellationToken.None){const l=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!l)return;const h=await this._workspace.getWorkspaceFolders2();if(h)return h.find(E=>E.uri.toString()===l.uri.toString())}createQuickPick(v){const S=new i(v,()=>this._sessions.delete(S._id));return this._sessions.set(S._id,S),S}createInputBox(v){const S=new c(v,()=>this._sessions.delete(S._id));return this._sessions.set(S._id,S),S}$onDidChangeValue(v,S){this._sessions.get(v)?._fireDidChangeValue(S)}$onDidAccept(v){this._sessions.get(v)?._fireDidAccept()}$onDidChangeActive(v,S){const l=this._sessions.get(v);l instanceof i&&l._fireDidChangeActive(S)}$onDidChangeSelection(v,S){const l=this._sessions.get(v);l instanceof i&&l._fireDidChangeSelection(S)}$onDidTriggerButton(v,S){this._sessions.get(v)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(v,S,l){const h=this._sessions.get(v);h instanceof i&&h._fireDidTriggerItemButton(S,l)}$onDidHide(v){this._sessions.get(v)?._fireDidHide()}}class b{static{this._nextId=1}constructor(v,S){this._extensionId=v,this._onDidDispose=S,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new L.Emitter,this._onDidChangeValueEmitter=new L.Emitter,this._onDidTriggerButtonEmitter=new L.Emitter,this._onDidHideEmitter=new L.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(v){this._title=v,this.update({title:v})}get step(){return this._steps}set step(v){this._steps=v,this.update({step:v})}get totalSteps(){return this._totalSteps}set totalSteps(v){this._totalSteps=v,this.update({totalSteps:v})}get enabled(){return this._enabled}set enabled(v){this._enabled=v,this.update({enabled:v})}get busy(){return this._busy}set busy(v){this._busy=v,this.update({busy:v})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(v){this._ignoreFocusOut=v,this.update({ignoreFocusOut:v})}get value(){return this._value}set value(v){this._value=v,this.update({value:v})}get placeholder(){return this._placeholder}set placeholder(v){this._placeholder=v,this.update({placeholder:v})}get buttons(){return this._buttons}set buttons(v){this._buttons=v.slice(),this._handlesToButtons.clear(),v.forEach((S,l)=>{const h=S===f.QuickInputButtons.Back?-1:l;this._handlesToButtons.set(h,S)}),this.update({buttons:v.map((S,l)=>({...s(S.iconPath),tooltip:S.tooltip,handle:S===f.QuickInputButtons.Back?-1:l}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(v){this._value=v,this._onDidChangeValueEmitter.fire(v)}_fireDidTriggerButton(v){const S=this._handlesToButtons.get(v);S&&this._onDidTriggerButtonEmitter.fire(S)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,d.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),a.$dispose(this._id))}update(v){if(!this._disposed){for(const S of Object.keys(v)){const l=v[S];this._pendingUpdate[S]=l===void 0?null:l}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){a.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function I(u){if(u instanceof f.ThemeIcon)return{id:u.id};const v=r(u),S=t(u);return{dark:typeof v=="string"?T.URI.file(v):v,light:typeof S=="string"?T.URI.file(S):S}}function t(u){return typeof u=="object"&&"light"in u?u.light:u}function r(u){return typeof u=="object"&&"dark"in u?u.dark:u}function s(u){const v=I(u);let S,l;return"id"in v?l=k.ThemeIcon.asClassName(v):S=v,{iconPath:S,iconClass:l}}class i extends b{constructor(v,S){super(v.identifier,S),this.extension=v,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new L.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new L.Emitter,this._onDidTriggerItemButtonEmitter=new L.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(v){this._items=v.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),v.forEach((h,E)=>{this._handlesToItems.set(E,h),this._itemsToHandles.set(h,E)});const S=(0,p.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),l=[];for(let h=0;h<v.length;h++){const E=v[h];if(E.kind===f.QuickPickItemKind.Separator)l.push({type:"separator",label:E.label});else{E.tooltip&&!S&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const R=E.iconPath?s(E.iconPath):void 0;l.push({handle:h,label:E.label,iconPath:R?.iconPath,iconClass:R?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:S?_.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((M,U)=>({...s(M.iconPath),tooltip:M.tooltip,handle:U}))})}}this.update({items:l})}get canSelectMany(){return this._canSelectMany}set canSelectMany(v){this._canSelectMany=v,this.update({canSelectMany:v})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(v){this._matchOnDescription=v,this.update({matchOnDescription:v})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(v){this._matchOnDetail=v,this.update({matchOnDetail:v})}get sortByLabel(){return this._sortByLabel}set sortByLabel(v){this._sortByLabel=v,this.update({sortByLabel:v})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(v){this._keepScrollPosition=v,this.update({keepScrollPosition:v})}get activeItems(){return this._activeItems}set activeItems(v){this._activeItems=v.filter(S=>this._itemsToHandles.has(S)),this.update({activeItems:this._activeItems.map(S=>this._itemsToHandles.get(S))})}get selectedItems(){return this._selectedItems}set selectedItems(v){this._selectedItems=v.filter(S=>this._itemsToHandles.has(S)),this.update({selectedItems:this._selectedItems.map(S=>this._itemsToHandles.get(S))})}_fireDidChangeActive(v){const S=(0,g.coalesce)(v.map(l=>this._handlesToItems.get(l)));this._activeItems=S,this._onDidChangeActiveEmitter.fire(S)}_fireDidChangeSelection(v){const S=(0,g.coalesce)(v.map(l=>this._handlesToItems.get(l)));this._selectedItems=S,this._onDidChangeSelectionEmitter.fire(S)}_fireDidTriggerItemButton(v,S){const l=this._handlesToItems.get(v);if(!l||!l.buttons||!l.buttons.length)return;const h=l.buttons[S];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:l})}}class c extends b{constructor(v,S){super(v.identifier,S),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(v){this._password=v,this.update({password:v})}get prompt(){return this._prompt}set prompt(v){this._prompt=v,this.update({prompt:v})}get valueSelection(){return this._valueSelection}set valueSelection(v){this._valueSelection=v,this.update({valueSelection:v})}get validationMessage(){return this._validationMessage}set validationMessage(v){this._validationMessage=v,v?typeof v=="string"?this.update({validationMessage:v,severity:P.default.Error}):this.update({validationMessage:v.message,severity:v.severity??P.default.Error}):this.update({validationMessage:void 0,severity:P.default.Ignore})}}return new m(n,o)}e.createExtHostQuickOpen=D}),define(Ce[315],De([1,0,2,4,70,3,13,5,18,124,17,25,56,10,27,16]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function o(S){if(S)return typeof S.iconPath=="string"?C.URI.file(S.iconPath):C.URI.isUri(S.iconPath)||p.ThemeIcon.isThemeIcon(S.iconPath)?S.iconPath:void 0}function a(S,l){if(!S.iconPath&&!l.iconPath)return 0;if(S.iconPath){if(!l.iconPath)return 1}else return-1;const h=typeof S.iconPath=="string"?S.iconPath:C.URI.isUri(S.iconPath)?S.iconPath.fsPath:S.iconPath.id,E=typeof l.iconPath=="string"?l.iconPath:C.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id;return(0,g.comparePaths)(h,E)}function m(S,l){let h=0;if(S.strikeThrough!==l.strikeThrough)return S.strikeThrough?1:-1;if(S.faded!==l.faded)return S.faded?1:-1;if(S.tooltip!==l.tooltip)return(S.tooltip||"").localeCompare(l.tooltip||"");if(h=a(S,l),h!==0)return h;if(S.light&&l.light)h=a(S.light,l.light);else{if(S.light)return 1;if(l.light)return-1}if(h!==0)return h;if(S.dark&&l.dark)h=a(S.dark,l.dark);else{if(S.dark)return 1;if(l.dark)return-1}return h}function b(S,l){if(S.command!==l.command)return S.command<l.command?-1:1;if(S.title!==l.title)return S.title<l.title?-1:1;if(S.tooltip!==l.tooltip){if(S.tooltip!==void 0&&l.tooltip!==void 0)return S.tooltip<l.tooltip?-1:1;if(S.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(S.arguments===l.arguments)return 0;if(S.arguments)if(l.arguments){if(S.arguments.length!==l.arguments.length)return S.arguments.length-l.arguments.length}else return 1;else return-1;for(let h=0;h<S.arguments.length;h++){const E=S.arguments[h],R=l.arguments[h];if(E!==R)return E<R?-1:1}return 0}function I(S,l){let h=(0,g.comparePaths)(S.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(h!==0)return h;if(S.command&&l.command)h=b(S.command,l.command);else{if(S.command)return 1;if(l.command)return-1}if(h!==0)return h;if(S.decorations&&l.decorations)h=m(S.decorations,l.decorations);else{if(S.decorations)return 1;if(l.decorations)return-1}return h}function t(S,l){for(let h=0;h<S.length;h++)if(S[h]!==l[h])return!1;return!0}function r(S,l){return S.command===l.command&&S.title===l.title&&S.tooltip===l.tooltip&&(S.arguments&&l.arguments?t(S.arguments,l.arguments):S.arguments===l.arguments)}function s(S,l){return(0,w.equals)(S,l,r)}class i{#e;#t;get value(){return this._value}set value(l){l=l??"",this.#e.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return(0,D.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(l){if((0,D.checkProposedApiEnabled)(this._extension,"scmValidation"),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get enabled(){return this._enabled}set enabled(l){l=!!l,this._enabled!==l&&(this._enabled=l,this.#e.$setInputBoxEnablement(this._sourceControlHandle,l))}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this.#e.$setInputBoxVisibility(this._sourceControlHandle,l))}get document(){return(0,D.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(l,h,E,R,M){this._extension=l,this._sourceControlHandle=R,this._documentUri=M,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=h,this.#e=E}showValidationMessage(l,h){(0,D.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,l,h)}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=i;class c{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}constructor(l,h,E,R,M){this._proxy=l,this._commands=h,this._sourceControlHandle=E,this._id=R,this._label=M,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=c._handlePool++}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,h){const E=this._resourceStatesCommandsMap.get(l);return E?(0,T.asPromise)(()=>this._commands.executeCommand(E.command,...E.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const l=[...this._resourceStates].sort(I),E=(0,w.sortedDiff)(this._resourceSnapshot,l,I).map(U=>{const F=U.toInsert.map(x=>{const $=this._resourceHandlePool++;this._resourceStatesMap.set($,x);const O=x.resourceUri;let K;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const J=new A.DisposableStore;K=this._commands.converter.toInternal(x.command,J),this._resourceStatesDisposablesMap.set($,J)}else this._resourceStatesCommandsMap.set($,x.command);const q=o(x.decorations),fe=x.decorations&&o(x.decorations.light)||q,se=x.decorations&&o(x.decorations.dark)||q,ie=[fe,se],H=x.decorations&&x.decorations.tooltip||"",re=x.decorations&&!!x.decorations.strikeThrough,Ee=x.decorations&&!!x.decorations.faded,ae=x.contextValue||"";return{rawResource:[$,O,ie,H,re,Ee,ae,K],handle:$}});return{start:U.start,deleteCount:U.deleteCount,toInsert:F}}),R=E.map(({start:U,deleteCount:F,toInsert:x})=>[U,F,x.map($=>$.rawResource)]),M=E.reverse();for(const{start:U,deleteCount:F,toInsert:x}of M){const $=x.map(K=>K.handle),O=this._handlesSnapshot.splice(U,F,...$);for(const K of O)this._resourceStatesMap.delete(K),this._resourceStatesCommandsMap.delete(K),this._resourceStatesDisposablesMap.get(K)?.dispose(),this._resourceStatesDisposablesMap.delete(K)}return this._resourceSnapshot=l,R}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class u{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this.#e.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l;let h;(0,D.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(h=l?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l,quickDiffLabel:h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this.#e.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=l;const h=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:h})}get actionButton(){return(0,D.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(l){(0,D.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=l;const h=l!==void 0?{command:this._commands.converter.toInternal(l.command,this._actionButtonDisposables.value),secondaryCommands:l.secondaryCommands?.map(E=>E.map(R=>this._commands.converter.toInternal(R,this._actionButtonDisposables.value))),description:l.description,enabled:l.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:h??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(this._statusBarCommands&&l&&s(this._statusBarCommands,l))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=l;const h=(l||[]).map(E=>this._commands.converter.toInternal(E,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:h})}get selected(){return this._selected}constructor(l,h,E,R,M,U,F){this._extension=l,this._commands=R,this._id=M,this._label=U,this._rootUri=F,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=u._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=E;const x=C.URI.from({scheme:y.Schemas.vscodeSourceControl,path:`${M}/scm${this.handle}/input`,query:F?`rootUri=${encodeURIComponent(F.toString())}`:void 0});this._inputBox=new i(l,h,this.#e,this.handle,x),this.#e.$registerSourceControl(this.handle,M,U,F,x)}createResourceGroup(l,h){const E=new c(this.#e,this._commands,this.handle,l,h),R=L.Event.once(E.onDidDispose)(()=>this.createdResourceGroups.delete(E));return this.createdResourceGroups.set(E,R),this.eventuallyAddResourceGroups(),E}eventuallyAddResourceGroups(){const l=[],h=[];for(const[E,R]of this.createdResourceGroups){R.dispose();const M=E.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(E),this.eventuallyUpdateResourceStates()});L.Event.once(E.onDidDispose)(()=>{this.updatedResourceGroups.delete(E),M.dispose(),this._groups.delete(E.handle),this.#e.$unregisterGroup(this.handle,E.handle)}),l.push([E.handle,E.id,E.label,E.features]);const U=E._takeResourceStateSnapshot();U.length>0&&h.push([E.handle,U]),this._groups.set(E.handle,E)}this.#e.$registerGroups(this.handle,l,h),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(h=>{const E=h._takeResourceStateSnapshot();E.length!==0&&l.push([h.handle,E])}),l.length>0&&this.#e.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this.#e.$unregisterSourceControl(this.handle)}}qe([(0,d.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),qe([(0,d.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let v=class{static{n=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(l,h,E,R){this._commands=h,this._extHostDocuments=E,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new k.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=l.getProxy(f.MainContext.MainThreadSCM),this._telemetry=l.getProxy(f.MainContext.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const U=this._sourceControls.get(M.sourceControlHandle);if(!U)return M;const F=U.getResourceGroup(M.groupHandle);return F?F.getResourceState(M.handle):M}else if(M&&M.$mid===4){const U=this._sourceControls.get(M.sourceControlHandle);return U?U.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const U=this._sourceControls.get(M.handle);return U||M}return M}})}createSourceControl(l,h,E,R){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,h,E,R),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const M=n._handlePool++,U=new u(l,this._extHostDocuments,this._proxy,this._commands,h,E,R);this._sourceControls.set(M,U);const F=this._sourceControlsByExtension.get(l.identifier)||[];return F.push(U),this._sourceControlsByExtension.set(l.identifier,F),U}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const h=this._sourceControlsByExtension.get(l.identifier),E=h&&h[h.length-1];return E&&E.inputBox}$provideOriginalResource(l,h,E){const R=C.URI.revive(h);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,R.toString());const M=this._sourceControls.get(l);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>M.quickDiffProvider.provideOriginalResource(R,E)).then(U=>U||null)}$onInputBoxValueChange(l,h){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const E=this._sourceControls.get(l);return E&&E.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(l,h,E,R){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,h,E);const M=this._sourceControls.get(l);if(!M)return Promise.resolve(void 0);const U=M.getResourceGroup(h);return U?U.$executeResourceCommand(E,R):Promise.resolve(void 0)}$validateInput(l,h,E){this.logService.trace("ExtHostSCM#$validateInput",l);const R=this._sourceControls.get(l);return!R||!R.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>R.inputBox.validateInput(h,E)).then(M=>{if(!M)return Promise.resolve(void 0);const U=_.MarkdownString.fromStrict(M.message);return U?Promise.resolve([U,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(l){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&this._sourceControls.get(l)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};e.ExtHostSCM=v,e.ExtHostSCM=v=n=qe([$e(3,P.ILogService)],v)}),define(Ce[113],De([1,0,5,4,6]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(f){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=f.getProxy(C.MainContext.MainThreadSecretState)}async $onDidChangePassword(f){this._onDidChangePassword.fire(f)}get(f,w){return this._proxy.$getPassword(f,w)}store(f,w,g){return this._proxy.$setPassword(f,w,g)}delete(f,w){return this._proxy.$deletePassword(f,w)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,d.createDecorator)("IExtHostSecretState")}),define(Ce[316],De([1,0,5,10,2]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class A{static{this.handlePool=0}constructor(f,w){this.uriTransformer=w,this.providers=new Map,this.proxy=f.getProxy(C.MainContext.MainThreadShare)}async $provideShare(f,w,g){return await this.providers.get(f)?.provideShare({selection:L.Range.to(w.selection),resourceUri:d.URI.revive(w.resourceUri)},g)??void 0}registerShareProvider(f,w){const g=A.handlePool++;return this.providers.set(g,w),this.proxy.$registerShareProvider(g,L.DocumentSelector.from(f,this.uriTransformer),w.id,w.label,w.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(g),this.providers.delete(g)}}}}e.ExtHostShare=A}),define(Ce[317],De([1,0,7,5,203,3,10,19]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class w{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new C.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(p,_,D,y,n,o=C.StatusBarAlignment.Left,a){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new A.DisposableStore,this.#e=p,this.#t=_,n&&y){this._entryId=(0,C.asStatusBarItemIdentifier)(y.identifier,n);const m=D.get(this._entryId);m&&(o=m.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,a=m.priority,this._visible=!0,this.name=m.name,this.text=m.text,this.tooltip=m.tooltip,this.command=m.command,this.accessibilityInformation=m.accessibilityInformation)}else this._entryId=String(w.ID_GEN++);this._extension=y,this._id=n,this._alignment=o,this._priority=this.validatePriority(a)}validatePriority(p){if((0,f.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!w.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new A.DisposableStore,typeof p=="string"?this._command={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this._latestCommandRegistration)}:p?this._command={fromApi:p,internal:this.#t.toInternal(p,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let _;this._name?_=this._name:_=(0,d.localize)(0,null,this._extension.displayName||this._extension.name);let D=this._color;this._backgroundColor&&(D=w.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const y=T.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,p,this._extension?.identifier.value,_,this._text,y,this._command?.internal,D,this._backgroundColor,this._alignment===C.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=w;class g{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,d.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const _={message:p};return this._messages.unshift(_),this._update(),new C.Disposable(()=>{const D=this._messages.indexOf(_);D>=0&&(this._messages.splice(D,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class P{constructor(p,_){this._existingItems=new Map,this._proxy=p.getProxy(L.MainContext.MainThreadStatusBar),this._commands=_,this._statusMessage=new g(this)}$acceptStaticEntries(p){for(const _ of p)this._existingItems.set(_.entryId,_)}createStatusBarEntry(p,_,D,y){return new w(this._proxy,this._commands,this._existingItems,p,_,D,y)}setStatusBarMessage(p,_){const D=this._statusMessage.setMessage(p);let y;return typeof _=="number"?y=setTimeout(()=>D.dispose(),_):typeof _<"u"&&_.then(()=>D.dispose(),()=>D.dispose()),new C.Disposable(()=>{D.dispose(),clearTimeout(y)})}}e.ExtHostStatusBar=P}),define(Ce[114],De([1,0,5,4,6]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(f,w){this._logService=w,this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=f.getProxy(C.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(f,w){this._proxy.$registerExtensionStorageKeysToSync(f,w)}async initializeExtensionStorage(f,w,g){const P=await this._proxy.$initializeExtensionStorage(f,w);let k;return P&&(k=this.safeParseValue(f,w,P)),k||g}setValue(f,w,g){return this._proxy.$setValue(f,w,g)}$acceptValue(f,w,g){const P=this.safeParseValue(f,w,g);P&&this._onDidChangeStorage.fire({shared:f,key:w,value:P})}safeParseValue(f,w,g){try{return JSON.parse(g)}catch(P){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${f}): ${P}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,d.createDecorator)("IExtHostStorage")}),define(Ce[90],De([1,0,6,26,17,67,2]),function(me,e,C,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,C.createDecorator)("IExtensionStoragePaths");let f=class{constructor(g,P,k){this._logService=P,this._extHostFileSystem=k,this._workspace=g.workspace??void 0,this._environment=g.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getWorkspaceStorageURI(g){return T.URI.joinPath(this._environment.workspaceStorageHome,g)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const g=this._workspace.id,P=await this._getWorkspaceStorageURI(g);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),P}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(g){if(this._value)return T.URI.joinPath(this._value,g.identifier.value)}globalValue(g){return T.URI.joinPath(this._environment.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=f,e.ExtensionStoragePaths=f=qe([$e(0,L.IExtHostInitDataService),$e(1,d.ILogService),$e(2,A.IExtHostConsumerFileSystem)],f)}),define(Ce[43],De([1,0,4,5,6,2,20,3,7,205,8,246,22,31,247,56,13,10,33]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,d.createDecorator)("IExtHostTerminalService");class m{constructor(l,h,E,R){this._proxy=l,this._id=h,this._creationOptions=E,this._name=R,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(U=>this._pidPromiseComplete=U);const M=this;this.value={get name(){return M._name||""},get processId(){return M._pidPromise},get creationOptions(){return M._creationOptions},get exitStatus(){return M._exitStatus},get state(){return M._state},get selection(){return M._selection},sendText(U,F=!0){M._checkDisposed(),M._proxy.$sendText(M._id,U,F)},show(U){M._checkDisposed(),M._proxy.$show(M._id,U)},hide(){M._checkDisposed(),M._proxy.$hide(M._id)},dispose(){M._disposed||(M._disposed=!0,M._proxy.$dispose(M._id))},get dimensions(){if(!(M._cols===void 0||M._rows===void 0))return{columns:M._cols,rows:M._rows}}}}async create(l,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:l.shellPath??void 0,shellArgs:l.shellArgs??void 0,cwd:l.cwd??void 0,env:l.env??void 0,icon:c(l.iconPath)??void 0,color:y.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:l.message??void 0,strictEnv:l.strictEnv??void 0,hideFromUser:l.hideFromUser??void 0,isFeatureTerminal:h?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:h?.useShellEnvironment??void 0,location:h?.location||this._serializeParentTerminal(l.location,h?.resolvedExtHostIdentifier),isTransient:l.isTransient??void 0})}async createExtensionTerminal(l,h,E,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:E,color:y.ThemeColor.isThemeColor(R)?R.id:void 0,location:this._serializeParentTerminal(l,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,h){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in l?{viewColumn:o.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus}:void 0:l}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitStatus(l,h){this._exitStatus=Object.freeze({code:l,reason:h})}setDimensions(l,h){return l===this._cols&&h===this._rows||l===0||h===0?!1:(this._cols=l,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(l){this._selection=l}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=m;class b{get onProcessReady(){return this._onProcessReady.event}constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._onProcessData=new C.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new C.Emitter,this._onDidChangeProperty=new C.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new C.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(l){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${l}`)}updateProperty(l,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${l}, value: ${h}`)}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput?.(l)}resize(l,h){this._pty.setDimensions?.({columns:l,rows:h})}clearBuffer(){}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(l){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose?.((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions?.(h=>{h&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this._pty.onDidChangeName?.(h=>{this._onDidChangeProperty.fire({type:"title",value:h})}),this._pty.open(l||void 0),l&&this._pty.setDimensions?.(l),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let I=1,t=class extends f.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}constructor(l,h,E){super(),this._extHostCommands=h,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new f.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new C.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new C.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new C.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new C.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new C.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new C.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new C.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new C.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=E.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new D.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[R,M]of this._terminalProcesses)M.shutdown(!0)}})}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,h){const E=new m(this._proxy,(0,_.generateUuid)(),l,l.name),R=new b(l.pty);return E.createExtensionTerminal(l.location,this._serializeParentTerminal(l,h).resolvedExtHostIdentifier,c(l.iconPath),u(l.color)).then(M=>{const U=this._setupExtHostProcessListeners(M,R);this._terminalProcessDisposables[M]=U}),this._terminals.push(E),E.value}_serializeParentTerminal(l,h){if(h=h||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const E=l.location.parentTerminal;if(E){const R=this._terminals.find(M=>M.value===E);R&&(h.resolvedExtHostIdentifier=R._id)}}else l.location&&typeof l.location!="object"?h.location=l.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(l,h){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const R=new b(h),M=this._setupExtHostProcessListeners(l,R);this._terminalProcessDisposables[l]=M}async $acceptActiveTerminalChanged(l){const h=this._activeTerminal;if(l===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const E=this._getTerminalById(l);E&&(this._activeTerminal=E,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,h){const E=this._getTerminalById(l);E&&this._onDidWriteTerminalData.fire({terminal:E.value,data:h})}async $acceptTerminalDimensions(l,h,E){const R=this._getTerminalById(l);R&&R.setDimensions(h,E)&&this._onDidChangeTerminalDimensions.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptDidExecuteCommand(l,h){const E=this._getTerminalById(l);E&&this._onDidExecuteCommand.fire({terminal:E.value,...h})}async $acceptTerminalMaximumDimensions(l,h,E){this._terminalProcesses.get(l)?.resize(h,E)}async $acceptTerminalTitleChange(l,h){const E=this._getTerminalById(l);E&&(E.name=h)}async $acceptTerminalClosed(l,h,E){const R=this._getTerminalObjectIndexById(this._terminals,l);if(R!==null){const M=this._terminals.splice(R,1)[0];M.setExitStatus(h,E),this._onDidCloseTerminal.fire(M.value)}}$acceptTerminalOpened(l,h,E,R){if(h){const F=this._getTerminalObjectIndexById(this._terminals,h);if(F!==null){this._terminals[F]._id=l,this._onDidOpenTerminal.fire(this.terminals[F]),this._terminals[F].isOpen=!0;return}}const M={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:A.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},U=new m(this._proxy,l,M,E);this._terminals.push(U),this._onDidOpenTerminal.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(l,h){this._getTerminalById(l)?._setProcessId(h)}async $startExtensionTerminal(l,h){const E=this._getTerminalById(l);if(!E)return{message:(0,g.localize)(0,null,l)};E.isOpen||await new Promise(M=>{const U=this.onDidOpenTerminal(async F=>{F===E.value&&(U.dispose(),M())})});const R=this._terminalProcesses.get(l);R?R.startSendingEvents(h):this._extensionTerminalAwaitingStart[l]={initialDimensions:h}}_setupExtHostProcessListeners(l,h){const E=new f.DisposableStore;E.add(h.onProcessReady(M=>this._proxy.$sendProcessReady(l,M.pid,M.cwd,M.windowsPty))),E.add(h.onDidChangeProperty(M=>this._proxy.$sendProcessProperty(l,M))),this._bufferer.startBuffering(l,h.onProcessData),E.add(h.onProcessExit(M=>this._onProcessExit(l,M))),this._terminalProcesses.set(l,h);const R=this._extensionTerminalAwaitingStart[l];return R&&h instanceof b&&(h.startSendingEvents(R.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),E}$acceptProcessAckDataEvent(l,h){this._terminalProcesses.get(l)?.acknowledgeDataEvent(h)}$acceptProcessInput(l,h){this._terminalProcesses.get(l)?.input(h)}$acceptTerminalInteraction(l){const h=this._getTerminalById(l);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptTerminalSelection(l,h){this._getTerminalById(l)?.setSelection(h)}$acceptProcessResize(l,h,E){try{this._terminalProcesses.get(l)?.resize(h,E)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(l,h){this._terminalProcesses.get(l)?.shutdown(h)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(h=>this._proxy.$sendProcessProperty(l,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(h=>this._proxy.$sendProcessProperty(l,{type:"cwd",value:h}))}$acceptProcessRequestLatency(l){return Promise.resolve(l)}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new w.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,h,E){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,E),this._proxy.$registerProfileProvider(h,l.identifier.value),new w.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}registerTerminalQuickFixProvider(l,h,E){if(this._quickFixProviders.has(l))throw new Error(`Terminal quick fix provider "${l}" is already registered`);return this._quickFixProviders.set(l,E),this._proxy.$registerQuickFixProvider(l,h),new w.Disposable(()=>{this._quickFixProviders.delete(l),this._proxy.$unregisterQuickFixProvider(l)})}async $provideTerminalQuickFixes(l,h){const E=new p.CancellationTokenSource().token;if(E.isCancellationRequested)return;const R=this._quickFixProviders.get(l);if(!R)return;const M=await R.provideTerminalQuickFixes(h,E);if(M===null||Array.isArray(M)&&M.length===0)return;const U=new f.DisposableStore;if(this._lastQuickFixCommands.value=U,!Array.isArray(M))return M?o.TerminalQuickFix.from(M,this._extHostCommands.converter,U):void 0;const F=[];for(const x of M){const $=o.TerminalQuickFix.from(x,this._extHostCommands.converter,U);$&&F.push($)}return F}async $createContributedProfileTerminal(l,h){const E=new p.CancellationTokenSource().token;let R=await this._profileProviders.get(l)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(R&&!("options"in R)&&(R={options:R}),!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,h);return}this.createTerminalFromOptions(R.options,h)}}async $provideLinks(l,h){const E=this._getTerminalById(l);if(!E)return[];this._terminalLinkCache.delete(l),this._terminalLinkCancellationSource.get(l)?.dispose(!0);const M=new p.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,M);const U=[],F={terminal:E.value,line:h},x=[];for(const K of this._linkProviders)x.push(n.Promises.withAsyncBody(async q=>{M.token.onCancellationRequested(()=>q({provider:K,links:[]}));const fe=await K.provideTerminalLinks(F,M.token)||[];M.token.isCancellationRequested||q({provider:K,links:fe})}));const $=await Promise.all(x);if(M.token.isCancellationRequested)return[];const O=new Map;for(const K of $)K&&K.links.length>0&&U.push(...K.links.map(q=>{const fe={id:I++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return O.set(fe.id,{provider:K.provider,link:q}),fe}));return this._terminalLinkCache.set(l,O),U}$activateLink(l,h){const E=this._terminalLinkCache.get(l)?.get(h);E&&E.provider.handleTerminalLink(E.link)}_onProcessExit(l,h){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const E=this._terminalProcessDisposables[l];E&&(E.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,h)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,h){const E=this._getTerminalObjectIndexById(l,h);return E!==null?l[E]:null}_getTerminalObjectIndexById(l,h){const E=l.findIndex(R=>R._id===h);return E===-1?null:E}getEnvironmentVariableCollection(l){let h=this._environmentVariableCollections.get(l.identifier.value);return h||(h=new r,this._setEnvironmentVariableCollection(l.identifier.value,h)),h.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(l,h){const E=(0,k.serializeEnvironmentVariableCollection)(h.map),R=(0,k.serializeEnvironmentDescriptionMap)(h.descriptionMap);this._proxy.$setEnvironmentVariableCollection(l,h.persistent,E.length===0?void 0:E,R)}$initEnvironmentVariableCollections(l){l.forEach(h=>{const E=h[0],R=new r(h[1]);this._setEnvironmentVariableCollection(E,R)})}$acceptDefaultProfile(l,h){const E=this._defaultProfile;this._defaultProfile=l,this._defaultAutomationProfile=h,E?.path!==l.path&&this._onDidChangeShell.fire(l.path)}_setEnvironmentVariableCollection(l,h){this._environmentVariableCollections.set(l,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,h)})}};e.BaseExtHostTerminalService=t,e.BaseExtHostTerminalService=t=qe([$e(1,a.IExtHostCommands),$e(2,T.IExtHostRpcService)],t);class r{get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(l){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new C.Emitter,this.map=new Map(l)}getScopedEnvironmentVariableCollection(l){const h=this.getScopeKey(l);let E=this.scopedCollections.get(h);return E||(E=new s(this,l),this.scopedCollections.set(h,E),E.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),E}replace(l,h,E,R){this._setIfDiffers(l,{value:h,type:w.EnvironmentVariableMutatorType.Replace,options:E??{applyAtProcessCreation:!0},scope:R})}append(l,h,E,R){this._setIfDiffers(l,{value:h,type:w.EnvironmentVariableMutatorType.Append,options:E??{applyAtProcessCreation:!0},scope:R})}prepend(l,h,E,R){this._setIfDiffers(l,{value:h,type:w.EnvironmentVariableMutatorType.Prepend,options:E??{applyAtProcessCreation:!0},scope:R})}_setIfDiffers(l,h){if(h.options&&h.options.applyAtProcessCreation===!1&&!h.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const E=this.getKey(l,h.scope),R=this.map.get(E),M=h.options?{applyAtProcessCreation:h.options.applyAtProcessCreation??!1,applyAtShellIntegration:h.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!R||R.value!==h.value||R.type!==h.type||R.options?.applyAtProcessCreation!==M.applyAtProcessCreation||R.options?.applyAtShellIntegration!==M.applyAtShellIntegration||R.scope?.workspaceFolder?.index!==h.scope?.workspaceFolder?.index){const U=this.getKey(l,h.scope),F={variable:l,...h,options:M};this.map.set(U,F),this._onDidChangeCollection.fire()}}get(l,h){const E=this.getKey(l,h),R=this.map.get(E);return R?v(R):void 0}getKey(l,h){const E=this.getScopeKey(h);return E.length?`${l}:::${E}`:l}getScopeKey(l){return this.getWorkspaceKey(l?.workspaceFolder)??""}getWorkspaceKey(l){return l?l.uri.toString():void 0}getVariableMap(l){const h=new Map;for(const[E,R]of this.map)this.getScopeKey(R.scope)===this.getScopeKey(l)&&h.set(R.variable,v(R));return h}delete(l,h){const E=this.getKey(l,h);this.map.delete(E),this._onDidChangeCollection.fire()}clear(l){if(l?.workspaceFolder){for(const[h,E]of this.map)E.scope?.workspaceFolder?.index===l.workspaceFolder.index&&this.map.delete(h);this.clearDescription(l)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(l,h){const E=this.getScopeKey(h),R=this.descriptionMap.get(E);if(!R||R.description!==l){let M;typeof l=="string"?M=l:M=l?.value.split(`

`)[0];const U={description:M,scope:h};this.descriptionMap.set(E,U),this._onDidChangeCollection.fire()}}getDescription(l){const h=this.getScopeKey(l);return this.descriptionMap.get(h)?.description}clearDescription(l){const h=this.getScopeKey(l);this.descriptionMap.delete(h)}}class s{get persistent(){return this.collection.persistent}set persistent(l){this.collection.persistent=l}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(l,h){this.collection=l,this.scope=h,this._onDidChangeCollection=new C.Emitter}getScoped(l){return this.collection.getScopedEnvironmentVariableCollection(l)}replace(l,h,E){this.collection.replace(l,h,E,this.scope)}append(l,h,E){this.collection.append(l,h,E,this.scope)}prepend(l,h,E){this.collection.prepend(l,h,E,this.scope)}get(l){return this.collection.get(l,this.scope)}forEach(l,h){this.collection.getVariableMap(this.scope).forEach((E,R)=>l.call(h,R,E,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(l){this.collection.delete(l,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(l){this.collection.setDescription(l,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let i=class extends t{constructor(l,h){super(!1,l,h)}createTerminal(l,h,E){throw new P.NotSupportedError}createTerminalFromOptions(l,h){throw new P.NotSupportedError}};e.WorkerExtHostTerminalService=i,e.WorkerExtHostTerminalService=i=qe([$e(0,a.IExtHostCommands),$e(1,T.IExtHostRpcService)],i);function c(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function u(S){return y.ThemeColor.isThemeColor(S)?S:void 0}function v(S){const l={...S};return delete l.scope,l.options=l.options??void 0,delete l.variable,l}}),define(Ce[318],De([1,0,18,13,21,22,4,71,74,3,23,19,31,5,20,143,10,7,63,108,87,27]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class{constructor(F,x,$){this.editors=$,this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(_.MainContext.MainThreadTesting),this.observer=new E(this.proxy),this.runTracker=new c(this.proxy),x.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 15:{const K=O,q=K.tests[K.tests.length-1].item.extId;return this.controllers.get(a.TestId.root(q))?.collection.tree.get(q)?.actual??(0,y.toItemFromContext)(O)}case 17:{const{extId:K,message:q}=O;return{test:this.controllers.get(a.TestId.root(K))?.collection.tree.get(K)?.actual,message:n.TestMessage.to(q)}}default:return O}}}),x.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await x.executeCommand("_testing.getExplorerSelection"),K=q=>{const fe=this.controllers.get(a.TestId.root(q));if(fe)return a.TestId.isRoot(q)?fe.controller:fe.collection.tree.get(q)?.actual};return{include:O?.include.map(K).filter(k.isDefined)||[],exclude:O?.exclude.map(K).filter(k.isDefined)||[]}})}createTestController(F,x,$,O){if(this.controllers.has(x))throw new Error(`Attempt to insert a duplicate controller with ID "${x}"`);const K=new g.DisposableStore,q=K.add(new y.ExtHostTestItemCollection(x,$,this.editors));q.root.label=$;const fe=new Map,se=this.proxy,ie={items:q.root.children,get label(){return $},set label(re){$=re,q.root.label=re,se.$updateController(x,{label:$})},get refreshHandler(){return O},set refreshHandler(re){O=re,se.$updateController(x,{canRefresh:!!re})},get id(){return x},createRunProfile:(re,Ee,ae,ne,J,N)=>{let W=(0,w.hash)(re);for(;fe.has(W);)W++;return new R(this.proxy,fe,x,W,re,Ee,ae,ne,J,N)},createTestItem(re,Ee,ae){return new y.TestItemImpl(x,re,Ee,ae)},createTestRun:(re,Ee,ae=!0)=>this.runTracker.createTestRun(F,x,q,re,Ee,ae),invalidateTestResults:re=>{if(re===void 0)this.proxy.$markTestRetired(void 0);else{const Ee=re instanceof Array?re:[re];this.proxy.$markTestRetired(Ee.map(ae=>a.TestId.fromExtHostTestItem(ae,x).toString()))}},set resolveHandler(re){q.resolveHandler=re},get resolveHandler(){return q.resolveHandler},dispose:()=>{K.dispose()}};se.$registerTestController(x,$,!!O),K.add((0,g.toDisposable)(()=>se.$unregisterTestController(x)));const H={controller:ie,collection:q,profiles:fe,extension:F};return this.controllers.set(x,H),K.add((0,g.toDisposable)(()=>this.controllers.delete(x))),K.add(q.onDidGenerateDiff(re=>se.$publishDiff(x,re.map(b.TestsDiffOp.serialize)))),ie}createTestObserver(){return this.observer.checkout()}async runTests(F,x=A.CancellationToken.None){const $=u(F);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.controllers.get($.controllerId);if(!O)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(K=>a.TestId.fromExtHostTestItem(K,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:M[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:F.exclude?.map(K=>K.id)},x)}$syncTests(){for(const{collection:F}of this.controllers.values())F.flushDiff();return Promise.resolve()}$provideFileCoverage(F,x,$){return(0,C.mapFind)(this.runTracker.trackers,K=>K.id===F?K.getCoverage(x):void 0)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(F,x,$,O){return(0,C.mapFind)(this.runTracker.trackers,q=>q.id===F?q.getCoverage(x):void 0)?.resolveFileCoverage($,O)??Promise.resolve([])}$configureRunProfile(F,x){this.controllers.get(F)?.profiles.get(x)?.configureHandler?.()}async $refreshTests(F,x){await this.controllers.get(F)?.controller.refreshHandler?.(x)}$publishTestResults(F){this.results=Object.freeze(F.map(x=>(0,P.deepFreeze)(n.TestResults.to(x))).concat(this.results).sort((x,$)=>$.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(F,x){const $=this.controllers.get(a.TestId.fromString(F).controllerId)?.collection;$&&(await $.expand(F,x<0?1/0:x),$.flushDiff())}$acceptDiff(F){this.observer.applyDiff(F.map(b.TestsDiffOp.deserialize))}async $runControllerTests(F,x){return Promise.all(F.map($=>this.runControllerTestRequest($,!1,x)))}async $startContinuousRun(F,x){const $=new A.CancellationTokenSource(x),O=await Promise.all(F.map(K=>this.runControllerTestRequest(K,!0,$.token)));return!x.isCancellationRequested&&!O.some(K=>K.error)&&await new Promise(K=>x.onCancellationRequested(K)),$.dispose(!0),O}async runControllerTestRequest(F,x,$){const O=this.controllers.get(F.controllerId);if(!O)return{};const{collection:K,profiles:q,extension:fe}=O,se=q.get(F.profileId);if(!se)return{};const ie=F.testIds.map(ae=>K.tree.get(ae)).filter(k.isDefined),H=F.excludeExtIds.map(ae=>O.collection.tree.get(ae)).filter(k.isDefined).filter(ae=>ie.some(ne=>ne.fullId.compare(ae.fullId)===2));if(!ie.length)return{};const re=new o.TestRunRequest(ie.some(ae=>ae.actual instanceof y.TestItemRootImpl)?void 0:ie.map(ae=>ae.actual),H.map(ae=>ae.actual),se,x),Ee=(0,b.isStartControllerTests)(F)&&this.runTracker.prepareForMainThreadTestRun(re,v.fromInternal(F,O.collection),fe,$);try{return await se.runHandler(re,$),{}}catch(ae){return{error:String(ae)}}finally{Ee&&(Ee.hasRunningTasks&&!$.isCancellationRequested&&await T.Event.toPromise(Ee.onEnd),Ee.dispose())}}$cancelExtensionTestRun(F){F===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(F)}};e.ExtHostTesting=t,e.ExtHostTesting=t=qe([$e(0,D.IExtHostRpcService)],t);const r=1e4;var s;(function(U){U[U.Running=0]="Running",U[U.Cancelling=1]="Cancelling",U[U.Ended=2]="Ended"})(s||(s={}));class i extends g.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(F,x,$,O){super(),this.dto=F,this.proxy=x,this.extension=$,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new A.CancellationTokenSource(O));const K=this._register(new L.RunOnceScheduler(()=>this.forciblyEndTasks(),r));this._register(this.cts.token.onCancellationRequested(()=>K.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(F){return this.tasks.get(F)?.coverage}createRun(F){const x=this.dto.id,$=this.dto.controllerId,O=(0,p.generateUuid)(),K=new S(this.proxy,x,O),q=H=>(re,...Ee)=>{if(se){console.warn(`Setting the state of test "${re.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(re)&&(this.ensureTestIsKnown(re),H(re,...Ee))},fe=(H,re)=>{const Ee=re instanceof Array?re.map(n.TestMessage.from):[n.TestMessage.from(re)];if(Ee.some(ae=>ae.contextValue!==void 0)&&(0,I.checkProposedApiEnabled)(this.extension,"testMessageContextValue"),H.uri&&H.range){const ae={range:n.Range.from(H.range),uri:H.uri};for(const ne of Ee)ne.location=ne.location||ae}this.proxy.$appendTestMessagesInRun(x,O,a.TestId.fromExtHostTestItem(H,$).toString(),Ee)};let se=!1;const ie={isPersisted:this.dto.isPersisted,token:this.cts.token,name:F,get coverageProvider(){return K.coverageProvider},set coverageProvider(H){K.coverageProvider=H},enqueued:q(H=>{this.proxy.$updateTestStateInRun(x,O,a.TestId.fromExtHostTestItem(H,$).toString(),1)}),skipped:q(H=>{this.proxy.$updateTestStateInRun(x,O,a.TestId.fromExtHostTestItem(H,$).toString(),5)}),started:q(H=>{this.proxy.$updateTestStateInRun(x,O,a.TestId.fromExtHostTestItem(H,$).toString(),2)}),errored:q((H,re,Ee)=>{fe(H,re),this.proxy.$updateTestStateInRun(x,O,a.TestId.fromExtHostTestItem(H,$).toString(),6,Ee)}),failed:q((H,re,Ee)=>{fe(H,re),this.proxy.$updateTestStateInRun(x,O,a.TestId.fromExtHostTestItem(H,$).toString(),4,Ee)}),passed:q((H,re)=>{this.proxy.$updateTestStateInRun(x,O,a.TestId.fromExtHostTestItem(H,this.dto.controllerId).toString(),3,re)}),appendOutput:(H,re,Ee)=>{se||(Ee&&(this.dto.isIncluded(Ee)?this.ensureTestIsKnown(Ee):Ee=void 0),this.proxy.$appendOutputToRun(x,O,d.VSBuffer.fromString(H),re&&n.location.from(re),Ee&&a.TestId.fromExtHostTestItem(Ee,$).toString()))},end:()=>{se||(se=!0,this.proxy.$finishedTestRunTask(x,O),this.tasks.delete(O),this.tasks.size||this.markEnded())}};return this.tasks.set(O,{run:ie,coverage:K}),this.proxy.$startedTestRunTask(x,{id:O,name:F,running:!0}),ie}forciblyEndTasks(){for(const{run:F}of this.tasks.values())F.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(F){if(!(F instanceof y.TestItemImpl))throw new m.InvalidTestItemError(F.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(F,this.dto.controllerId).toString()))return;const x=[],$=this.dto.colllection.root;for(;;){const O=n.TestItem.from(F);if(x.unshift(O),this.sharedTestIds.has(O.extId)||(this.sharedTestIds.add(O.extId),F===$))break;F=F.parent||$}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,x)}}class c{get trackers(){return this.tracked.values()}constructor(F){this.proxy=F,this.tracked=new Map}prepareForMainThreadTestRun(F,x,$,O){return this.getTracker(F,x,$,O)}cancelRunById(F){for(const x of this.tracked.values())if(x.id===F){x.cancel();return}}cancelAllRuns(){for(const F of this.tracked.values())F.cancel()}createTestRun(F,x,$,O,K,q){const fe=this.tracked.get(O);if(fe)return fe.createRun(K);const se=v.fromPublic(x,$,O,q),ie=u(O);this.proxy.$startedExtensionTestRun({controllerId:x,continuous:!!O.continuous,profile:ie&&{group:M[ie.kind],id:ie.profileId},exclude:O.exclude?.map(re=>a.TestId.fromExtHostTestItem(re,$.root.id).toString())??[],id:se.id,include:O.include?.map(re=>a.TestId.fromExtHostTestItem(re,$.root.id).toString())??[$.root.id],persist:q});const H=this.getTracker(O,se,F);return H.onEnd(()=>{this.proxy.$finishedExtensionTestRun(se.id),H.dispose()}),H.createRun(K)}getTracker(F,x,$,O){const K=new i(x,this.proxy,$,O);return this.tracked.set(F,K),K.onEnd(()=>this.tracked.delete(F)),K}}e.TestRunCoordinator=c;const u=U=>{if(U.profile){if(!(U.profile instanceof R))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return U.profile}};class v{static fromPublic(F,x,$,O){return new v(F,(0,p.generateUuid)(),$.include?.map(K=>a.TestId.fromExtHostTestItem(K,F).toString())??[F],$.exclude?.map(K=>a.TestId.fromExtHostTestItem(K,F).toString())??[],O,x)}static fromInternal(F,x){return new v(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,x)}constructor(F,x,$,O,K,q){this.controllerId=F,this.id=x,this.isPersisted=K,this.colllection=q,this.includePrefix=$.map(fe=>fe+"\0"),this.excludePrefix=O.map(fe=>fe+"\0")}isIncluded(F){const x=a.TestId.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const $ of this.excludePrefix)if(x===$||x.startsWith($))return!1;for(const $ of this.includePrefix)if(x===$||x.startsWith($))return!0;return!1}}e.TestRunDto=v;class S{set coverageProvider(F){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");F&&(this._coverageProvider=F,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(F,x,$){this.proxy=F,this.runId=x,this.taskId=$}async provideFileCoverage(F){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(F))());try{return(await this.fileCoverage)?.map(n.TestCoverage.fromFile)??[]}catch(x){throw this.fileCoverage=void 0,x}}async resolveFileCoverage(F,x){const $=await this.fileCoverage;let O=$?.[F];return!this._coverageProvider||!$||!O?[]:(O.detailedCoverage||(O=$[F]=await this._coverageProvider.resolveFileCoverage?.(O,x)??O),O.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class l{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(F){this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(F){this.added.add(F)}update(F){Object.assign(F.revived,n.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}this.updated.delete(F);const x=a.TestId.parentId(F.item.extId);if(x&&this.alreadyRemoved.has(x.toString())){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:x,removed:$}=this;return{get added(){return[...F].map(O=>O.revived)},get updated(){return[...x].map(O=>O.revived)},get removed(){return[...$].map(O=>O.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,x){return{...F,revived:n.TestItem.toPlain(F.item),depth:x?x.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}class E{constructor(F){this.proxy=F}checkout(){this.current||(this.current=this.createObserverData());const F=this.current;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(x=>x.revived)},dispose:(0,f.once)(()=>{--F.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(F){return this.current?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.current?.tests.apply(F)}createObserverData(){const F=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:F}}}class R{#e;#t;get label(){return this._label}set label(F){F!==this._label&&(this._label=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(F){F!==this._supportsContinuousRun&&(this._supportsContinuousRun=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:F}))}get isDefault(){return this._isDefault}set isDefault(F){F!==this._isDefault&&(this._isDefault=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:F?n.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(F){F!==this._configureHandler&&(this._configureHandler=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}constructor(F,x,$,O,K,q,fe,se=!1,ie=void 0,H=!1){this.controllerId=$,this.profileId=O,this._label=K,this.kind=q,this.runHandler=fe,this._isDefault=se,this._tag=ie,this._supportsContinuousRun=H,this.#e=F,this.#t=x,x.set(O,this);const re=M[q];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${q}`);this.#e.$publishTestRunProfile({profileId:O,controllerId:$,tag:ie?n.TestTag.namespace(this.controllerId,ie.id):null,label:K,group:re,isDefault:se,hasConfigurationHandler:!1,supportsContinuousRun:H})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=R;const M={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ce[319],De([1,0,18,8,4,5,144,10,7]),function(me,e,C,L,d,A,T,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class g{constructor(k,p){this._extHostDocumentsAndEditors=p,this._onDidChangeTextEditorSelection=new d.Emitter({onListenerError:L.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new d.Emitter({onListenerError:L.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new d.Emitter({onListenerError:L.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new d.Emitter({onListenerError:L.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new d.Emitter({onListenerError:L.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new d.Emitter({onListenerError:L.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=k.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(_=>this._onDidChangeVisibleTextEditors.fire(_)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(_=>this._onDidChangeActiveTextEditor.fire(_))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(k){const p=this._extHostDocumentsAndEditors.allEditors();return k?p:p.map(_=>_.value)}async showTextDocument(k,p,_){let D;typeof p=="number"?D={position:f.ViewColumn.from(p),preserveFocus:_}:typeof p=="object"?D={position:f.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selection:typeof p.selection=="object"?f.Range.from(p.selection):void 0,pinned:typeof p.preview=="boolean"?!p.preview:void 0}:D={preserveFocus:!1};const y=await this._proxy.$tryShowTextDocument(k.uri,D),n=y&&this._extHostDocumentsAndEditors.getEditor(y);if(n)return n.value;throw y?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,p){return new T.TextEditorDecorationType(this._proxy,k,p).value}$acceptEditorPropertiesChanged(k,p){const _=this._extHostDocumentsAndEditors.getEditor(k);if(!_)throw new Error("unknown text editor");if(p.options&&_._acceptOptions(p.options),p.selections){const D=p.selections.selections.map(f.Selection.to);_._acceptSelections(D)}if(p.visibleRanges){const D=C.coalesce(p.visibleRanges.map(f.Range.to));_._acceptVisibleRanges(D)}if(p.options&&this._onDidChangeTextEditorOptions.fire({textEditor:_.value,options:{...p.options,lineNumbers:f.TextEditorLineNumbersStyle.to(p.options.lineNumbers)}}),p.selections){const D=w.TextEditorSelectionChangeKind.fromValue(p.selections.source),y=p.selections.selections.map(f.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:_.value,selections:y,kind:D})}if(p.visibleRanges){const D=C.coalesce(p.visibleRanges.map(f.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:_.value,visibleRanges:D})}}$acceptEditorPositionData(k){for(const p in k){const _=this._extHostDocumentsAndEditors.getEditor(p);if(!_)throw new Error("Unknown text editor");const D=f.ViewColumn.to(k[p]);_.value.viewColumn!==D&&(_._acceptViewColumn(D),this._onDidChangeTextEditorViewColumn.fire({textEditor:_.value,viewColumn:D}))}}getDiffInformation(k){return Promise.resolve(this._proxy.$getDiffInformation(k))}}e.ExtHostEditors=g}),define(Ce[320],De([1,0,2,6,5,3,7,10,25,19]),function(me,e,C,L,d,A,T,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class P{constructor(_,D){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=_.getProxy(d.MainContext.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(y,n)=>{if(y&&y.$mid===12)if(this._providers.get(y.source)&&w.ExtensionIdentifier.equals(n,this._providers.get(y.source)?.extension)){const o=y.uri===void 0?void 0:C.URI.revive(y.uri);return this._itemsBySourceAndUriMap.get(y.source)?.get(k(o))?.get(y.handle)}else return;return y}})}async $getTimeline(_,D,y,n){return this._providers.get(_)?.provider.provideTimeline(C.URI.revive(D),y,n)}registerTimelineProvider(_,D,y,n){const o=new A.DisposableStore,a=this.convertTimelineItem(D.id,n,o).bind(this);let m;D.onDidChange&&(m=D.onDidChange(I=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...I,id:D.id}),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...D,scheme:_,onDidChange:void 0,async provideTimeline(I,t,r){t?.resetCache&&(o.clear(),b.get(D.id)?.clear());const s=await D.provideTimeline(I,t,r);if(s==null)return;const i=a(I,t);return{...s,source:D.id,items:s.items.map(i)}},dispose(){for(const I of b.values())I.get(D.id)?.clear();m?.dispose(),o.dispose()}},y)}convertTimelineItem(_,D,y){return(n,o)=>{let a;if(o?.cacheResults){let m=this._itemsBySourceAndUriMap.get(_);m===void 0&&(m=new Map,this._itemsBySourceAndUriMap.set(_,m));const b=k(n);a=m.get(b),a===void 0&&(a=new Map,m.set(b,a))}return m=>{const{iconPath:b,...I}=m,t=`${_}|${m.id??m.timestamp}`;a?.set(t,m);let r,s,i;m.iconPath&&(b instanceof T.ThemeIcon?i={id:b.id,color:b.color}:C.URI.isUri(b)?(r=b,s=b):{light:r,dark:s}=b);let c;return T.MarkdownString.isMarkdownString(I.tooltip)?c=f.MarkdownString.from(I.tooltip):(0,g.isString)(I.tooltip)?c=I.tooltip:T.MarkdownString.isMarkdownString(I.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=f.MarkdownString.from(I.detail)):(0,g.isString)(I.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=I.detail),{...I,id:I.id??void 0,handle:t,source:_,command:m.command?D.toInternal(m.command,y):void 0,icon:r,iconDark:s,themeIcon:i,tooltip:c,accessibilityInformation:m.accessibilityInformation}}}}registerTimelineProviderCore(_,D){if(this._providers.get(_.id))throw new Error(`Timeline Provider ${_.id} already exists.`);return this._proxy.$registerTimelineProvider({id:_.id,label:_.label,scheme:_.scheme}),this._providers.set(_.id,{provider:_,extension:D}),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(_.id)?.clear();this._providers.delete(_.id),this._proxy.$unregisterTimelineProvider(_.id),_.dispose()})}}e.ExtHostTimeline=P;function k(p){return p?.toString()}}),define(Ce[68],De([1,0,22,4,3,207,6,17,106,5,26,20,7]),function(me,e,C,L,d,A,T,f,w,g,P,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class _ extends w.DisposableTunnel{}var D;(function(n){function o(m){return{remoteAddress:m.remoteAddress,localAddress:m.localAddress,public:!!m.public,privacy:m.privacy??(m.public?w.TunnelPrivacyId.Public:w.TunnelPrivacyId.Private),protocol:m.protocol}}n.fromApiTunnel=o;function a(m){return{remoteAddress:{host:m.tunnelRemoteHost,port:m.tunnelRemotePort},localAddress:m.localAddress,public:m.privacy!==w.TunnelPrivacyId.ConstantPrivate&&m.privacy!==w.TunnelPrivacyId.ConstantPrivate,privacy:m.privacy,protocol:m.protocol}}n.fromServiceTunnel=a})(D||(e.TunnelDtoConverter=D={})),e.IExtHostTunnelService=(0,T.createDecorator)("IExtHostTunnelService");let y=class extends d.Disposable{constructor(o,a,m){super(),this.logService=m,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new L.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=o.getProxy(g.MainContext.MainThreadTunnelService)}async openTunnel(o,a){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const m=await this._proxy.$openTunnel(a,o.displayName);if(m){const b=new _(m.remoteAddress,m.localAddress,()=>this._proxy.$closeTunnel(m.remoteAddress));return this._register(b),b}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(o,a){const m=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(m,{selector:o,provider:a}),this._proxy.$registerPortsAttributesProvider(o,m),new p.Disposable(()=>{this._portAttributesProviders.delete(m),this._proxy.$unregisterPortsAttributesProvider(m)})}async $providePortAttributes(o,a,m,b,I){const t=[];for(const s of o){const i=this._portAttributesProviders.get(s);if(!i)return[];t.push(...await Promise.all(a.map(async c=>{let u;try{u=await i.provider.providePortAttributes({port:c,pid:m,commandLine:b},I)}catch{u=await i.provider.providePortAttributes(c,m,b,I)}return{providedAttributes:u,port:c}})))}const r=t.filter(s=>!!s.providedAttributes);return r.length>0?r.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,a){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(b,I)=>await o.provideTunnel(b,I,new C.CancellationTokenSource().token)??void 0;const m=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,privacyOptions:a.tunnelFeatures?.privacyOptions}:void 0;return this._proxy.$setTunnelProvider(m),Promise.resolve((0,d.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,a){if(o){o.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this._showCandidatePort=o.showCandidatePort,this._proxy.$setCandidateFilter());const m=o.tunnelFactory??(a?this.makeManagedTunnelFactory(a):void 0);if(m){this._forwardPortProvider=m;let b=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&b.length===0&&(b=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const I=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:b}:void 0;this._proxy.$setTunnelProvider(I)}}else this._forwardPortProvider=void 0;return(0,d.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(o){}async $closeTunnel(o,a){if(this._extensionTunnels.has(o.host)){const m=this._extensionTunnels.get(o.host);m.has(o.port)&&(a&&m.get(o.port).disposeListener.dispose(),await m.get(o.port).tunnel.dispose(),m.delete(o.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(o,a){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const m=this._forwardPortProvider(o,a);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),m!==void 0){const b=await m;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),b===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(o.remoteAddress.host)||this._extensionTunnels.set(o.remoteAddress.host,new Map);const I=this._register(b.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(b.remoteAddress))));return this._extensionTunnels.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:b,disposeListener:I}),D.fromApiTunnel(b)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(m){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),m instanceof Error)return m.message}}async $applyCandidateFilter(o){const a=await Promise.all(o.map(b=>this._showCandidatePort(b.host,b.port,b.detail??""))),m=o.filter((b,I)=>a[I]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(b=>b.port).join(", ")} to ${m.map(b=>b.port).join(", ")}`),m}};e.ExtHostTunnelService=y,e.ExtHostTunnelService=y=qe([$e(0,k.IExtHostRpcService),$e(1,P.IExtHostInitDataService),$e(2,f.ILogService)],y)}),define(Ce[321],De([1,0,3,16,2,5]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{static{this.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}constructor(w){this._openers=new Map,this._proxy=w.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(w,g,P,k){if(this._openers.has(g))throw new Error(`Opener with id '${g}' already registered`);const p=k.schemes.find(_=>!T.supportedSchemes.has(_));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this._openers.set(g,P),this._proxy.$registerUriOpener(g,k.schemes,w,k.label),(0,C.toDisposable)(()=>{this._openers.delete(g),this._proxy.$unregisterUriOpener(g)})}async $canOpenUri(w,g,P){const k=this._openers.get(w);if(!k)throw new Error(`Unknown opener with id: ${w}`);const p=d.URI.revive(g);return k.canOpenExternalUri(p,P)}async $openUri(w,g,P){const k=this._openers.get(w);if(!k)throw new Error(`Unknown opener id: '${w}'`);return k.openExternalUri(d.URI.revive(g.resolvedUri),{sourceUri:d.URI.revive(g.sourceUri)},P)}}e.ExtHostUriOpeners=T}),define(Ce[322],De([1,0,5,2,3,8,25]),function(me,e,C,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class f{static{this.HandlePool=0}constructor(g){this.handles=new T.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=g.getProxy(C.MainContext.MainThreadUrls)}registerUriHandler(g,P){const k=g.identifier;if(this.handles.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const p=f.HandlePool++;return this.handles.add(k),this.handlers.set(p,P),this._proxy.$registerUriHandler(p,k,g.displayName||g.name),(0,d.toDisposable)(()=>{this.handles.delete(k),this.handlers.delete(p),this._proxy.$unregisterUriHandler(p)})}$handleExternalUri(g,P){const k=this.handlers.get(g);if(!k)return Promise.resolve(void 0);try{k.handleUri(L.URI.revive(P))}catch(p){(0,A.onUnexpectedError)(p)}return Promise.resolve(void 0)}async createAppUri(g){return L.URI.revive(await this._proxy.$createAppUri(g))}}e.ExtHostUrls=f}),define(Ce[91],De([1,0,4,16,23,2,221,255,109,5]),function(me,e,C,L,d,A,T,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class P{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;constructor(m,b,I,t,r,s,i){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new C.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new C.Emitter,this._onDidDispose=this.#d.event,this.#e=m,this.#t=b,this.#r=I,this.#u=t,this.#l=r,this.#n=s,this.#c=k(s),this.#h=p(s),this.#i=i}#d;dispose(){this.#o=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return this.#a=!0,(0,w.asWebviewUri)(m,this.#u)}get cspSource(){const m=this.#n.extensionLocation;if(m.scheme===L.Schemas.https||m.scheme===L.Schemas.http){let b=m.toString();return b.endsWith("/")||(b+="/"),b+" "+w.webviewGenericCspSource}return w.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#s}set html(m){this.assertNotDisposed(),this.#s!==m&&(this.#s=m,this.#h&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(m)))}get options(){return this.assertNotDisposed(),this.#r}set options(m){this.assertNotDisposed(),d.equals(this.#r,m)||this.#t.$setOptions(this.#e,y(this.#n,this.#l,m)),this.#r=m}async postMessage(m){if(this.#o)return!1;const b=(0,f.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,b.message,...b.buffers)}assertNotDisposed(){if(this.#o)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(m){if(!this.#h)return m;const b=this.#n.extensionLocation?.scheme===L.Schemas.vscodeRemote,I=this.#n.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return m.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(t,r,s,i,c,u)=>{const v=A.URI.from({scheme:i||"file",path:decodeURIComponent(c)}),S=(0,w.asWebviewUri)(v,{isRemote:b,authority:I}).toString();return`${r}${S}${u}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(t,r,s,i,c,u)=>{const v=A.URI.from({scheme:i||"file",path:decodeURIComponent(c)}),S=(0,w.asWebviewUri)(v,{isRemote:b,authority:I}).toString();return`${r}${S}${u}`})}}e.ExtHostWebview=P;function k(a){try{const m=(0,T.normalizeVersion)((0,T.parseVersion)(a.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=k;function p(a){try{const m=(0,T.normalizeVersion)((0,T.parseVersion)(a.engines.vscode));return m?m.majorBase<1||m.majorBase===1&&m.minorBase<60:!1}catch{return!1}}class _{constructor(m,b,I,t,r){this.remoteInfo=b,this.workspace=I,this._logService=t,this._deprecationService=r,this._webviews=new Map,this._webviewProxy=m.getProxy(g.MainContext.MainThreadWebviews)}$onMessage(m,b,I){const t=this.getWebview(m);if(t){const{message:r}=(0,f.deserializeWebviewMessage)(b,I.value);t._onMessageEmitter.fire(r)}}$onMissingCsp(m,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,b,I){const t=new P(m,this._webviewProxy,n(b),this.remoteInfo,this.workspace,I,this._deprecationService);return this._webviews.set(m,t),t._onDidDispose(()=>{this._webviews.delete(m)}),t}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=_;function D(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=D;function y(a,m,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||o(a,m)}}e.serializeWebviewOptions=y;function n(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(m=>A.URI.from(m))}}function o(a,m){return[...(m?.getWorkspaceFolders()||[]).map(b=>b.uri),a.extensionLocation]}}),define(Ce[323],De([1,0,22,74,3,16,24,2,10,91,86,5,7]),function(me,e,C,L,d,A,T,f,w,g,P,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class _{constructor(r,s){this.document=r,this._storagePath=s,this._backupCounter=1,this._edits=new P.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,s){await this.getEdit(r).undo(),s||this.disposeBackup()}async redo(r,s){await this.getEdit(r).redo(),s||this.disposeBackup()}disposeEdits(r){for(const s of r)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=I(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const s=this._edits.get(r,0);if(!s)throw new Error("No edit found");return s}}class D{constructor(){this._documents=new Map}get(r,s){return this._documents.get(this.key(r,s))}add(r,s,i){const c=this.key(r,s.uri);if(this._documents.has(c))throw new Error(`Document already exists for viewType:${r} resource:${s.uri}`);const u=new _(s,i);return this._documents.set(c,u),u}delete(r,s){const i=this.key(r,s.uri);this._documents.delete(i)}key(r,s){return`${r}@@@${s}`}}var y;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(y||(y={}));class n{constructor(){this._providers=new Map}addTextProvider(r,s,i){return this.add(0,r,s,i)}addCustomProvider(r,s,i){return this.add(1,r,s,i)}get(r){return this._providers.get(r)}add(r,s,i,c){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:r,extension:i,provider:c}),new p.Disposable(()=>this._providers.delete(s))}}class o{constructor(r,s,i,c,u){this._extHostDocuments=s,this._extensionStoragePaths=i,this._extHostWebview=c,this._extHostWebviewPanels=u,this._editorProviders=new n,this._documents=new D,this._proxy=r.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,s,i,c){const u=new d.DisposableStore;return m(i)?(u.add(this._editorProviders.addTextProvider(s,r,i)),this._proxy.$registerTextEditorProvider((0,g.toExtensionData)(r),s,c.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,g.shouldSerializeBuffersForPostMessage)(r))):(u.add(this._editorProviders.addCustomProvider(s,r,i)),a(i)&&u.add(i.onDidChangeCustomDocument(v=>{const S=this.getCustomDocumentEntry(s,v.document.uri);if(b(v)){const l=S.addEdit(v);this._proxy.$onDidEdit(v.document.uri,s,l,v.label)}else this._proxy.$onContentChange(v.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,g.toExtensionData)(r),s,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,g.shouldSerializeBuffersForPostMessage)(r))),p.Disposable.from(u,new p.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(r,s,i,c,u){const v=this._editorProviders.get(s);if(!v)throw new Error(`No provider found for '${s}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${s}'`);const S=f.URI.revive(r),l=await v.provider.openCustomDocument(S,{backupId:i,untitledDocumentData:c?.buffer},u);let h;return a(v.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(v.extension)??this._extensionStoragePaths.globalValue(v.extension)),this._documents.add(s,l,h),{editable:a(v.provider)}}async $disposeCustomDocument(r,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${s}'`);const c=f.URI.revive(r),{document:u}=this.getCustomDocumentEntry(s,c);this._documents.delete(s,u),u.dispose()}async $resolveCustomEditor(r,s,i,c,u,v){const S=this._editorProviders.get(i);if(!S)throw new Error(`No provider found for '${i}'`);const l=w.ViewColumn.to(u),h=this._extHostWebview.createNewWebview(s,c.contentOptions,S.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(s,i,c.title,l,c.options,h,c.active),R=f.URI.revive(r);switch(S.type){case 1:{const{document:M}=this.getCustomDocumentEntry(i,R);return S.provider.resolveCustomEditor(M,E,v)}case 0:{const M=this._extHostDocuments.getDocument(R);return S.provider.resolveCustomTextEditor(M,E,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,s,i){this.getCustomDocumentEntry(s,r).disposeEdits(i)}async $onMoveCustomEditor(r,s,i){const c=this._editorProviders.get(i);if(!c)throw new Error(`No provider found for '${i}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const u=this._extHostWebviewPanels.getWebviewPanel(r);if(!u)throw new Error("No webview found");const v=f.URI.revive(s),S=this._extHostDocuments.getDocument(v);await c.provider.moveCustomTextEditor(S,u,C.CancellationToken.None)}async $undo(r,s,i,c){return this.getCustomDocumentEntry(s,r).undo(i,c)}async $redo(r,s,i,c){return this.getCustomDocumentEntry(s,r).redo(i,c)}async $revert(r,s,i){const c=this.getCustomDocumentEntry(s,r);await this.getCustomEditorProvider(s).revertCustomDocument(c.document,i),c.disposeBackup()}async $onSave(r,s,i){const c=this.getCustomDocumentEntry(s,r);await this.getCustomEditorProvider(s).saveCustomDocument(c.document,i),c.disposeBackup()}async $onSaveAs(r,s,i,c){const u=this.getCustomDocumentEntry(s,r);return this.getCustomEditorProvider(s).saveCustomDocumentAs(u.document,f.URI.revive(i),c)}async $backup(r,s,i){const c=this.getCustomDocumentEntry(s,r),v=await this.getCustomEditorProvider(s).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},i);return c.updateBackup(v),v.id}getCustomDocumentEntry(r,s){const i=this._documents.get(r,f.URI.revive(s));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(r){const i=this._editorProviders.get(r)?.provider;if(!i||!a(i))throw new Error("Custom document is not editable");return i}}e.ExtHostCustomEditors=o;function a(t){return!!t.onDidChangeCustomDocument}function m(t){return typeof t.resolveCustomTextEditor=="function"}function b(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function I(t){const r=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,L.hash)(r)+""}}),define(Ce[324],De([1,0,4,3,2,31,10,91,5,7]),function(me,e,C,L,d,A,T,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class P extends L.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;#d;constructor(D,y,n,o){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#h=this._register(new C.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new C.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=D,this.#t=y,this.#u=n,this.#i=o.viewType,this.#l=o.panelOptions,this.#r=o.viewColumn,this.#n=o.title,this.#a=o.active}dispose(){this.#c||(this.#c=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#u.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#u}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#n}set title(D){this.assertNotDisposed(),this.#n!==D&&(this.#n=D,this.#t.$setTitle(this.#e,D))}get iconPath(){return this.assertNotDisposed(),this.#s}set iconPath(D){this.assertNotDisposed(),this.#s!==D&&(this.#s=D,this.#t.$setIconPath(this.#e,d.URI.isUri(D)?{light:D,dark:D}:D))}get options(){return this.#l}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.assertNotDisposed(),this.#a}get visible(){return this.assertNotDisposed(),this.#o}_updateViewState(D){this.#c||(this.active!==D.active||this.visible!==D.visible||this.viewColumn!==D.viewColumn)&&(this.#a=D.active,this.#o=D.visible,this.#r=D.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(D,y){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof D>"u"?void 0:T.ViewColumn.from(D),preserveFocus:!!y})}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}}class k{static newHandle(){return(0,A.generateUuid)()}constructor(D,y,n){this.webviews=y,this.workspace=n,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=D.getProxy(w.MainContext.MainThreadWebviewPanels)}createWebviewPanel(D,y,n,o,a={}){const m=typeof o=="object"?o.viewColumn:o,b={viewColumn:T.ViewColumn.from(m),preserveFocus:typeof o=="object"&&!!o.preserveFocus},I=(0,f.shouldSerializeBuffersForPostMessage)(D),t=k.newHandle();this._proxy.$createWebviewPanel((0,f.toExtensionData)(D),t,y,{title:n,panelOptions:p(a),webviewOptions:(0,f.serializeWebviewOptions)(D,this.workspace,a),serializeBuffersForPostMessage:I},b);const r=this.webviews.createNewWebview(t,a,D);return this.createNewWebviewPanel(t,y,n,m,a,r,!0)}$onDidChangeWebviewPanelViewStates(D){const y=Object.keys(D);y.sort((n,o)=>{const a=D[n],m=D[o];return a.active?1:m.active?-1:+a.visible-+m.visible});for(const n of y){const o=this.getWebviewPanel(n);if(!o)continue;const a=D[n];o._updateViewState({active:a.active,visible:a.visible,viewColumn:T.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(D){this.getWebviewPanel(D)?.dispose(),this._webviewPanels.delete(D),this.webviews.deleteWebview(D)}registerWebviewPanelSerializer(D,y,n){if(this._serializers.has(y))throw new Error(`Serializer for '${y}' already registered`);return this._serializers.set(y,{serializer:n,extension:D}),this._proxy.$registerSerializer(y,{serializeBuffersForPostMessage:(0,f.shouldSerializeBuffersForPostMessage)(D)}),new g.Disposable(()=>{this._serializers.delete(y),this._proxy.$unregisterSerializer(y)})}async $deserializeWebviewPanel(D,y,n,o){const a=this._serializers.get(y);if(!a)throw new Error(`No serializer found for '${y}'`);const{serializer:m,extension:b}=a,I=this.webviews.createNewWebview(D,n.webviewOptions,b),t=this.createNewWebviewPanel(D,y,n.title,o,n.panelOptions,I,n.active);await m.deserializeWebviewPanel(t,n.state)}createNewWebviewPanel(D,y,n,o,a,m,b){const I=new P(D,this._proxy,m,{viewType:y,title:n,viewColumn:o,panelOptions:a,active:b});return this._webviewPanels.set(D,I),I}getWebviewPanel(D){return this._webviewPanels.get(D)}}e.ExtHostWebviewPanels=k;function p(_){return{enableFindWidget:_.enableFindWidget,retainContextWhenHidden:_.retainContextWhenHidden}}}),define(Ce[325],De([1,0,4,3,91,10,5,7]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends L.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;constructor(k,p,_,D,y,n){super(),this.#l=!1,this.#a=this._register(new C.Emitter),this.onDidChangeVisibility=this.#a.event,this.#c=this._register(new C.Emitter),this.onDidDispose=this.#c.event,this.#i=_,this.#s=D,this.#e=k,this.#t=p,this.#u=y,this.#n=n}dispose(){this.#l||(this.#l=!0,this.#c.fire(),this.#u.dispose(),super.dispose())}#a;#c;get title(){return this.assertNotDisposed(),this.#s}set title(k){this.assertNotDisposed(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.assertNotDisposed(),this.#r}set description(k){this.assertNotDisposed(),this.#r!==k&&(this.#r=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#u}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#l||(this.#n=k,this.#a.fire())}get badge(){return this.assertNotDisposed(),this.#o}set badge(k){this.assertNotDisposed(),!(k?.value===this.#o?.value&&k?.tooltip===this.#o?.tooltip)&&(this.#o=A.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.assertNotDisposed(),this.#t.$show(this.#e,!!k)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}}class g{constructor(k,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=k.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(k,p,_,D){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:_,extension:k}),this._proxy.$registerWebviewViewProvider((0,d.toExtensionData)(k),p,{retainContextWhenHidden:D?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,d.shouldSerializeBuffersForPostMessage)(k)}),new f.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(k,p,_,D,y){const n=this._viewProviders.get(p);if(!n)throw new Error(`No view provider found for '${p}'`);const{provider:o,extension:a}=n,m=this._extHostWebview.createNewWebview(k,{},a),b=new w(k,this._proxy,p,_,m,!0);this._webviewViews.set(k,b),await o.resolveWebviewView(b,{state:D},y)}async $onDidChangeWebviewViewVisibility(k,p){this.getWebviewView(k)._setVisible(p)}async $disposeWebviewView(k){const p=this.getWebviewView(k);this._webviewViews.delete(k),p.dispose(),this._extHostWebview.deleteWebview(k)}getWebviewView(k){const p=this._webviewViews.get(k);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=g}),define(Ce[148],De([1,0,4,5,2,16,15,6,20,27]),function(me,e,C,L,d,A,T,f,w,g){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class{static{P=this}static{this.InitialState={focused:!0,active:!0}}getState(_){const D=this._state;return{get focused(){return D.focused},get active(){return(0,g.checkProposedApiEnabled)(_,"windowActivity"),D.active}}}constructor(_){this._onDidChangeWindowState=new C.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=P.InitialState,this._proxy=_.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:D,isActive:y})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",y)})}$onDidChangeWindowFocus(_){this.onDidChangeWindowProperty("focused",_)}$onDidChangeWindowActive(_){this.onDidChangeWindowProperty("active",_)}onDidChangeWindowProperty(_,D){D!==this._state[_]&&(this._state={...this._state,[_]:D},this._onDidChangeWindowState.fire(this._state))}openUri(_,D){let y;if(typeof _=="string"){y=_;try{_=d.URI.parse(_)}catch{return Promise.reject(`Invalid uri - '${_}'`)}}return(0,T.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,y,D)}async asExternalUri(_,D){if((0,T.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const y=await this._proxy.$asExternalUri(_,D);return d.URI.from(y)}};e.ExtHostWindow=k,e.ExtHostWindow=k=P=qe([$e(0,w.IExtHostRpcService)],k),e.IExtHostWindow=(0,f.createDecorator)("IExtHostWindow")}),define(Ce[326],De([1,0,294,26,20]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let T=class extends C.AbstractExtHostConsoleForwarder{constructor(w,g){super(w,g),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(w,g,P){const k=w==="error"||w==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),g.apply(console,P),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(w,g){const P=process[w],k=P.write;let p="";Object.defineProperty(P,"write",{set:()=>{},get:()=>(_,D,y)=>{if(!this._isMakingConsoleCall){p+=_.toString(D);const n=p.length>A?p.length:p.lastIndexOf(`
`);n!==-1&&(console[g](p.slice(0,n)),p=p.slice(n+1))}k.call(P,_,D,y)}})}};e.ExtHostConsoleForwarder=T,e.ExtHostConsoleForwarder=T=qe([$e(0,d.IExtHostRpcService),$e(1,L.IExtHostInitDataService)],T)}),define(Ce[327],De([1,0,67,16,17,233,30,9]),function(me,e,C,L,d,A,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let w=class{constructor(k,p){k.addFileSystemProvider(L.Schemas.file,new g(p),{isCaseSensitive:f.isLinux})}};e.ExtHostDiskFileSystemProvider=w,e.ExtHostDiskFileSystemProvider=w=qe([$e(0,C.IExtHostConsumerFileSystem),$e(1,d.ILogService)],w);class g{constructor(k){this.logService=k,this.impl=new A.DiskFileSystemProvider(this.logService)}async stat(k){const p=await this.impl.stat(k);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===T.FilePermission.Readonly?1:void 0}}readDirectory(k){return this.impl.readdir(k)}createDirectory(k){return this.impl.mkdir(k)}readFile(k){return this.impl.readFile(k)}writeFile(k,p,_){return this.impl.writeFile(k,p,{..._,unlock:!1,atomic:!1})}delete(k,p){return this.impl.delete(k,{...p,useTrash:!1,atomic:!1})}rename(k,p,_){return this.impl.rename(k,p,_)}copy(k,p,_){return this.impl.copy(k,p,_)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(k,p){throw new Error("Method not implemented.")}}}),define(Ce[328],De([1,0,14,59,31,33,3,5,2,20]),function(me,e,C,L,d,A,T,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let P=class extends T.Disposable{constructor(p,_){super();const D=p.getProxy(f.MainContext.MainThreadDownloadService);_.registerCommand(!1,"_workbench.downloadResource",async y=>{const n=w.URI.file((0,C.join)((0,L.tmpdir)(),(0,d.generateUuid)()));return await D.$download(y,n),n})}};e.ExtHostDownloadService=P,e.ExtHostDownloadService=P=qe([$e(0,g.IExtHostRpcService),$e(1,A.IExtHostCommands)],P)}),define(Ce[329],De([1,0,147,16,235,31]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class T extends C.ExtHostLoggerService{doCreateLogger(w,g,P){return w.scheme===L.Schemas.file?new d.SpdLogLogger(P?.name||(0,A.generateUuid)(),w.fsPath,!P?.donotRotate,!!P?.donotUseFormatters,g):super.doCreateLogger(w,g,P)}registerLogger(w){super.registerLogger(w),this._proxy.$registerLogger(w)}deregisterLogger(w){super.deregisterLogger(w),this._proxy.$deregisterLogger(w)}}e.ExtHostLoggerService=T}),define(Ce[330],De([1,0,49,14,2,90,3,16,13,29]),function(me,e,C,L,d,A,T,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class P extends A.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(t){const r=await super._getWorkspaceStorageURI(t);if(r.scheme!==f.Schemas.file)return r;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const s=r.fsPath;let i=0;do{let c;i===0?c=s:c=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${i}`:`${s}-${i}`,await k(c);const u=L.join(c,"vscode.lock"),v=await y(this._logService,u,!1);if(v)return this._workspaceStorageLock=v,process.on("exit",()=>{v.dispose()}),d.URI.file(c);i++}while(i<10);return r}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=P;async function k(I){try{await g.Promises.stat(I);return}catch{}try{await g.Promises.mkdir(I,{recursive:!0})}catch{}}const p=1e3,_=10*60*1e3;class D extends T.Disposable{constructor(t,r){super(),this.logService=t,this.filename=r,this._timer=this._register(new w.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await n(t,r);(!s||s.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this._timer.cancel());try{await g.Promises.utimes(r,new Date,new Date)}catch(i){t.error(i),t.info(`Lock '${r}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{C.unlinkSync(this.filename)}catch{}}async setWillRelease(t){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await g.Promises.writeFile(this.filename,JSON.stringify(r),{flag:"w"})}catch(r){this.logService.error(r)}}}async function y(I,t,r){try{const i={pid:process.pid,willReleaseAt:0};await g.Promises.writeFile(t,JSON.stringify(i),{flag:"wx"})}catch(i){I.error(i)}const s=await n(I,t);return!s||s.pid!==process.pid?r?(I.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(I.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),m(I,t)):(I.info(`Lock '${t}': Lock acquired.`),new D(I,t))}async function n(I,t){let r;try{r=await g.Promises.readFile(t)}catch(s){return I.error(s),null}try{return JSON.parse(String(r))}catch(s){return I.error(s),null}}async function o(I,t){let r;try{r=await g.Promises.stat(t)}catch(s){return I.error(s),0}return r.mtime.getTime()}function a(I){try{return process.kill(I,0),!0}catch{return!1}}async function m(I,t){const r=await n(I,t);if(!r)return I.info(`Lock '${t}': Could not read pid of lock holder.`),b(I,t);if(r.willReleaseAt){let v=r.willReleaseAt-Date.now();if(v<5e3){for(v>0?I.info(`Lock '${t}': The lockfile is scheduled to be released in ${v} ms.`):I.info(`Lock '${t}': The lockfile is scheduled to have been released.`);v>0;){if(await(0,w.timeout)(Math.min(100,v)),await o(I,t)===0)return b(I,t);v=r.willReleaseAt-Date.now()}return b(I,t)}}if(!a(r.pid))return I.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),b(I,t);const s=await o(I,t),i=Date.now()-s;if(i<=_)return I.info(`Lock '${t}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;I.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,w.timeout)(2e3);const c=await o(I,t),u=Date.now()-c;return u<=_?(I.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(I.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),b(I,t))}async function b(I,t){I.info(`Lock '${t}': Deleting a stale lock.`);try{await g.Promises.unlink(t)}catch{}return y(I,t,!0)}}),define(Ce[331],De([1,0,31,20,43,33]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let T=class extends d.BaseExtHostTerminalService{constructor(w,g){super(!0,w,g)}createTerminal(w,g,P){return this.createTerminalFromOptions({name:w,shellPath:g,shellArgs:P})}createTerminalFromOptions(w,g){const P=new d.ExtHostTerminal(this._proxy,(0,C.generateUuid)(),w,w.name);return this._terminals.push(P),P.create(w,this._serializeParentTerminal(w,g)),P.value}};e.ExtHostTerminalService=T,e.ExtHostTerminalService=T=qe([$e(0,A.IExtHostCommands),$e(1,L.IExtHostRpcService)],T)}),define(Ce[332],De([1,0,13,21,22,8,4,3,127,283,64]),function(me,e,C,L,d,A,T,f,w,g,P){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function p(h,E){try{return JSON.stringify(h,E)}catch{return"null"}}const _="$$ref$$",D={[_]:-1};class y{constructor(E,R){this.jsonString=E,this.referencedBuffers=R}}function n(h,E=null,R=!1){const M=[];return{jsonString:(R?p:JSON.stringify)(h,(F,x)=>{if(typeof x>"u")return D;if(typeof x=="object"){if(x instanceof L.VSBuffer){const $=M.push(x)-1;return{[_]:$}}if(E)return E(F,x)}return x}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=n;function o(h,E,R){return JSON.parse(h,(M,U)=>{if(U){const F=U[_];if(typeof F=="number")return E[F];if(R&&U.$mid===1)return R.transformIncoming(U)}return U})}e.parseJsonAndRestoreBufferRefs=o;function a(h,E){return JSON.stringify(h,E)}function m(h){return h?(E,R)=>R&&R.$mid===1?h.transformOutgoing(R):R:null}var b;(function(h){h[h.LocalSide=0]="LocalSide",h[h.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));var I;(function(h){h[h.Responsive=0]="Responsive",h[h.Unresponsive=1]="Unresponsive"})(I||(e.ResponsiveState=I={}));const t=()=>{},r=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class i extends f.Disposable{static{k=r}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(E,R=null,M=null){super(),this[k]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=E,this._logger=R,this._uriTransformer=M,this._uriReplacer=m(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let U=0,F=P.ProxyIdentifier.count;U<F;U++)this._locals[U]=null,this._proxies[U]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new C.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(U=>this._receiveOneMessage(U))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(E=>{this._pendingRPCReplies[E].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(E){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(E){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(E){this._responsiveState!==E&&(this._responsiveState=E,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(E){return this._uriTransformer?(0,w.transformIncomingURIs)(E,this._uriTransformer):E}getProxy(E){const{nid:R,sid:M}=E;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,M)),this._proxies[R]}_createProxy(E,R){const M={get:(U,F)=>(typeof F=="string"&&!U[F]&&F.charCodeAt(0)===36&&(U[F]=(...x)=>this._remoteCall(E,F,x)),F===s?R:U[F])};return new Proxy(Object.create(null),M)}set(E,R){return this._locals[E.nid]=R,R}assertRegistered(E){for(let R=0,M=E.length;R<M;R++){const U=E[R];if(!this._locals[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}_receiveOneMessage(E){if(this._isDisposed)return;const R=E.byteLength,M=c.read(E,0),U=M.readUInt8(),F=M.readUInt32();switch(U){case 1:case 2:{let{rpcId:x,method:$,args:O}=v.deserializeRequestJSONArgs(M);this._uriTransformer&&(O=(0,w.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(R,F,x,$,O,U===2);break}case 3:case 4:{let{rpcId:x,method:$,args:O}=v.deserializeRequestMixedArgs(M);this._uriTransformer&&(O=(0,w.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(R,F,x,$,O,U===4);break}case 5:{this._logger?.logIncoming(R,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(R,F);break}case 7:{this._receiveReply(R,F,void 0);break}case 9:{let x=v.deserializeReplyOKJSON(M);this._uriTransformer&&(x=(0,w.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(R,F,x);break}case 10:{const x=v.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(R,F,x);break}case 8:{const x=v.deserializeReplyOKVSBuffer(M);this._receiveReply(R,F,x);break}case 11:{let x=v.deserializeReplyErrError(M);this._uriTransformer&&(x=(0,w.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(R,F,x);break}case 12:{this._receiveReplyErr(R,F,void 0);break}default:console.error("received unexpected message"),console.error(E)}}_receiveRequest(E,R,M,U,F,x){this._logger?.logIncoming(E,R,1,`receiveRequest ${(0,P.getStringIdentifierForProxy)(M)}.${U}(`,F);const $=String(R);let O,K;if(x){const fe=new d.CancellationTokenSource;F.push(fe.token),O=this._invokeHandler(M,U,F),K=()=>fe.cancel()}else O=this._invokeHandler(M,U,F),K=t;this._cancelInvokedHandlers[$]=K;const q=v.serializeAcknowledged(R);this._logger?.logOutgoing(q.byteLength,R,1,"ack"),this._protocol.send(q),O.then(fe=>{delete this._cancelInvokedHandlers[$];const se=v.serializeReplyOK(R,fe,this._uriReplacer);this._logger?.logOutgoing(se.byteLength,R,1,"reply:",fe),this._protocol.send(se)},fe=>{delete this._cancelInvokedHandlers[$];const se=v.serializeReplyErr(R,fe);this._logger?.logOutgoing(se.byteLength,R,1,"replyErr:",fe),this._protocol.send(se)})}_receiveCancel(E,R){this._logger?.logIncoming(E,R,1,"receiveCancel");const M=String(R);this._cancelInvokedHandlers[M]?.()}_receiveReply(E,R,M){this._logger?.logIncoming(E,R,0,"receiveReply:",M);const U=String(R);if(!this._pendingRPCReplies.hasOwnProperty(U))return;const F=this._pendingRPCReplies[U];delete this._pendingRPCReplies[U],F.resolveOk(M)}_receiveReplyErr(E,R,M){this._logger?.logIncoming(E,R,0,"receiveReplyErr:",M);const U=String(R);if(!this._pendingRPCReplies.hasOwnProperty(U))return;const F=this._pendingRPCReplies[U];delete this._pendingRPCReplies[U];let x;M&&(M.$isError?(x=new Error,x.name=M.name,x.message=M.message,x.stack=M.stack):x=M),F.resolveErr(x)}_invokeHandler(E,R,M){try{return Promise.resolve(this._doInvokeHandler(E,R,M))}catch(U){return Promise.reject(U)}}_doInvokeHandler(E,R,M){const U=this._locals[E];if(!U)throw new Error("Unknown actor "+(0,P.getStringIdentifierForProxy)(E));const F=U[R];if(typeof F!="function")throw new Error("Unknown method "+R+" on actor "+(0,P.getStringIdentifierForProxy)(E));return F.apply(U,M)}_remoteCall(E,R,M){if(this._isDisposed)return new g.CanceledLazyPromise;let U=null;if(M.length>0&&d.CancellationToken.isCancellationToken(M[M.length-1])&&(U=M.pop()),U&&U.isCancellationRequested)return Promise.reject(A.canceled());const F=v.serializeRequestArguments(M,this._uriReplacer),x=++this._lastMessageId,$=String(x),O=new g.LazyPromise;U&&U.onCancellationRequested(()=>{const q=v.serializeCancel(x);this._logger?.logOutgoing(q.byteLength,x,0,"cancel"),this._protocol.send(v.serializeCancel(x))}),this._pendingRPCReplies[$]=O,this._onWillSendRequest(x);const K=v.serializeRequest(x,E,R,F,!!U);return this._logger?.logOutgoing(K.byteLength,x,0,`request: ${(0,P.getStringIdentifierForProxy)(E)}.${R}(`,M),this._protocol.send(K),O}}e.RPCProtocol=i;class c{static alloc(E,R,M){const U=new c(L.VSBuffer.alloc(M+1+4),0);return U.writeUInt8(E),U.writeUInt32(R),U}static read(E,R){return new c(E,R)}get buffer(){return this._buff}constructor(E,R){this._buff=E,this._offset=R}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(E){this._buff.writeUInt8(E,this._offset),this._offset+=1}readUInt8(){const E=this._buff.readUInt8(this._offset);return this._offset+=1,E}writeUInt32(E){this._buff.writeUInt32BE(E,this._offset),this._offset+=4}readUInt32(){const E=this._buff.readUInt32BE(this._offset);return this._offset+=4,E}static sizeShortString(E){return 1+E.byteLength}writeShortString(E){this._buff.writeUInt8(E.byteLength,this._offset),this._offset+=1,this._buff.set(E,this._offset),this._offset+=E.byteLength}readShortString(){const E=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+E).toString();return this._offset+=E,M}static sizeLongString(E){return 4+E.byteLength}writeLongString(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}readLongString(){const E=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+E).toString();return this._offset+=E,M}writeBuffer(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}static sizeVSBuffer(E){return 4+E.byteLength}writeVSBuffer(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}readVSBuffer(){const E=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+E);return this._offset+=E,R}static sizeMixedArray(E){let R=0;R+=1;for(let M=0,U=E.length;M<U;M++){const F=E[M];switch(R+=1,F.type){case 1:R+=this.sizeLongString(F.value);break;case 2:R+=this.sizeVSBuffer(F.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(F.value);for(let x=0;x<F.buffers.length;++x)R+=this.sizeVSBuffer(F.buffers[x]);break;case 4:break}}return R}writeMixedArray(E){this._buff.writeUInt8(E.length,this._offset),this._offset+=1;for(let R=0,M=E.length;R<M;R++){const U=E[R];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let F=0;F<U.buffers.length;++F)this.writeBuffer(U.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const E=this._buff.readUInt8(this._offset);this._offset+=1;const R=new Array(E);for(let M=0;M<E;M++)switch(this.readUInt8()){case 1:R[M]=this.readLongString();break;case 2:R[M]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),x=this.readLongString(),$=[];for(let O=0;O<F;++O)$.push(this.readVSBuffer());R[M]=new P.SerializableObjectWithBuffers(o(x,$,null));break}case 4:R[M]=void 0;break}return R}}var u;(function(h){h[h.Simple=0]="Simple",h[h.Mixed=1]="Mixed"})(u||(u={}));class v{static _useMixedArgSerialization(E){for(let R=0,M=E.length;R<M;R++)if(E[R]instanceof L.VSBuffer||E[R]instanceof P.SerializableObjectWithBuffers||typeof E[R]>"u")return!0;return!1}static serializeRequestArguments(E,R){if(this._useMixedArgSerialization(E)){const M=[];for(let U=0,F=E.length;U<F;U++){const x=E[U];if(x instanceof L.VSBuffer)M[U]={type:2,value:x};else if(typeof x>"u")M[U]={type:4};else if(x instanceof P.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:O}=n(x.value,R);M[U]={type:3,value:L.VSBuffer.fromString($),buffers:O}}else M[U]={type:1,value:L.VSBuffer.fromString(a(x,R))}}return{type:1,args:M}}return{type:0,args:a(E,R)}}static serializeRequest(E,R,M,U,F){switch(U.type){case 0:return this._requestJSONArgs(E,R,M,U.args,F);case 1:return this._requestMixedArgs(E,R,M,U.args,F)}}static _requestJSONArgs(E,R,M,U,F){const x=L.VSBuffer.fromString(M),$=L.VSBuffer.fromString(U);let O=0;O+=c.sizeUInt8(),O+=c.sizeShortString(x),O+=c.sizeLongString($);const K=c.alloc(F?2:1,E,O);return K.writeUInt8(R),K.writeShortString(x),K.writeLongString($),K.buffer}static deserializeRequestJSONArgs(E){const R=E.readUInt8(),M=E.readShortString(),U=E.readLongString();return{rpcId:R,method:M,args:JSON.parse(U)}}static _requestMixedArgs(E,R,M,U,F){const x=L.VSBuffer.fromString(M);let $=0;$+=c.sizeUInt8(),$+=c.sizeShortString(x),$+=c.sizeMixedArray(U);const O=c.alloc(F?4:3,E,$);return O.writeUInt8(R),O.writeShortString(x),O.writeMixedArray(U),O.buffer}static deserializeRequestMixedArgs(E){const R=E.readUInt8(),M=E.readShortString(),U=E.readMixedArray(),F=new Array(U.length);for(let x=0,$=U.length;x<$;x++){const O=U[x];typeof O=="string"?F[x]=JSON.parse(O):F[x]=O}return{rpcId:R,method:M,args:F}}static serializeAcknowledged(E){return c.alloc(5,E,0).buffer}static serializeCancel(E){return c.alloc(6,E,0).buffer}static serializeReplyOK(E,R,M){if(typeof R>"u")return this._serializeReplyOKEmpty(E);if(R instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(E,R);if(R instanceof P.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:F}=n(R.value,M,!0);return this._serializeReplyOKJSONWithBuffers(E,U,F)}else return this._serializeReplyOKJSON(E,p(R,M))}static _serializeReplyOKEmpty(E){return c.alloc(7,E,0).buffer}static _serializeReplyOKVSBuffer(E,R){let M=0;M+=c.sizeVSBuffer(R);const U=c.alloc(8,E,M);return U.writeVSBuffer(R),U.buffer}static deserializeReplyOKVSBuffer(E){return E.readVSBuffer()}static _serializeReplyOKJSON(E,R){const M=L.VSBuffer.fromString(R);let U=0;U+=c.sizeLongString(M);const F=c.alloc(9,E,U);return F.writeLongString(M),F.buffer}static _serializeReplyOKJSONWithBuffers(E,R,M){const U=L.VSBuffer.fromString(R);let F=0;F+=c.sizeUInt32,F+=c.sizeLongString(U);for(const $ of M)F+=c.sizeVSBuffer($);const x=c.alloc(10,E,F);x.writeUInt32(M.length),x.writeLongString(U);for(const $ of M)x.writeBuffer($);return x.buffer}static deserializeReplyOKJSON(E){const R=E.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(E,R){const M=E.readUInt32(),U=E.readLongString(),F=[];for(let x=0;x<M;++x)F.push(E.readVSBuffer());return new P.SerializableObjectWithBuffers(o(U,F,R))}static serializeReplyErr(E,R){const M=R?p(A.transformErrorForSerialization(R),null):void 0;if(typeof M!="string")return this._serializeReplyErrEmpty(E);const U=L.VSBuffer.fromString(M);let F=0;F+=c.sizeLongString(U);const x=c.alloc(11,E,F);return x.writeLongString(U),x.buffer}static deserializeReplyErrError(E){const R=E.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(E){return c.alloc(12,E,0).buffer}}var S;(function(h){h[h.RequestJSONArgs=1]="RequestJSONArgs",h[h.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",h[h.RequestMixedArgs=3]="RequestMixedArgs",h[h.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",h[h.Acknowledged=5]="Acknowledged",h[h.Cancel=6]="Cancel",h[h.ReplyOKEmpty=7]="ReplyOKEmpty",h[h.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",h[h.ReplyOKJSON=9]="ReplyOKJSON",h[h.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",h[h.ReplyErrError=11]="ReplyErrError",h[h.ReplyErrEmpty=12]="ReplyErrEmpty"})(S||(S={}));var l;(function(h){h[h.String=1]="String",h[h.VSBuffer=2]="VSBuffer",h[h.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",h[h.Undefined=4]="Undefined"})(l||(l={}))}),define(Ce[333],De([1,0,4,42,47,6]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new d.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new d.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new d.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)("outputService");var T;(function(w){w[w.Append=1]="Append",w[w.Replace=2]="Replace",w[w.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class f{constructor(){this.channels=new Map,this._onDidRegisterChannel=new C.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new C.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(g){this.channels.has(g.id)||(this.channels.set(g.id,g),this._onDidRegisterChannel.fire(g.id))}getChannels(){const g=[];return this.channels.forEach(P=>g.push(P)),g}getChannel(g){return this.channels.get(g)}removeChannel(g){this.channels.delete(g),this._onDidRemoveChannel.fire(g)}}L.Registry.add(e.Extensions.OutputChannels,new f),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new d.RawContextKey("activeOutputChannel","")}),define(Ce[149],De([1,0,5,6,20,25,17,333,67,26,52,175,21,19,30,4,3]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class o extends T.AbstractMessageLogger{get disposed(){return this._disposed}constructor(I,t,r,s,i){super(),this.id=I,this.name=t,this.logger=r,this.proxy=s,this.extension=i,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(r.getLevel()),this._register(r.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(I){this.append(I+`
`)}append(I){this.info(I)}clear(){const I=this.offset;this.logger.flush(),this.proxy.$update(this.id,f.OutputChannelUpdateMode.Clear,I)}replace(I){const t=this.offset;this.info(I),this.proxy.$update(this.id,f.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(I,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof I=="boolean"?I:t))}hide(){this.proxy.$close(this.id)}log(I,t){this.offset+=p.VSBuffer.fromString(t).byteLength,(0,T.log)(this.logger,I,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,f.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class a extends o{appendLine(I){this.append(I)}}let m=class{constructor(I,t,r,s,i,c){this.initData=t,this.extHostFileSystem=r,this.extHostFileSystemInfo=s,this.loggerService=i,this.logService=c,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=I.getProxy(C.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(I){this.visibleChannelId=I;for(const[t,r]of this.channels)r.visible=t===this.visibleChannelId}createOutputChannel(I,t,r){if(I=I.trim(),!I)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,i=(0,_.isString)(t)?t:void 0;if((0,_.isString)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const u=this.initData.environment.extensionLogLevel?.find(([S])=>A.ExtensionIdentifier.equals(r.identifier,S))?.[1];u&&(c=(0,T.parseLogLevel)(u));const v=s?this.doCreateLogOutputChannel(I,c,r):this.doCreateOutputChannel(I,i,r);return v.then(S=>{this.channels.set(S.id,S),S.visible=S.id===this.visibleChannelId}),s?this.createExtHostLogOutputChannel(I,c??this.logService.getLevel(),v):this.createExtHostOutputChannel(I,v)}async doCreateOutputChannel(I,t,r){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const s=await this.outputDirectoryPromise,i=this.extHostFileSystemInfo.extUri.joinPath(s,`${this.namePool++}-${I.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.loggerService.createLogger(i,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),u=await this.proxy.$register(I,i,t,r.identifier.value);return new o(u,I,c,this.proxy,r)}async doCreateLogOutputChannel(I,t,r){const s=await this.createExtensionLogDirectory(r),i=I.replace(/[\\/:\*\?"<>\|]/g,""),c=this.extHostFileSystemInfo.extUri.joinPath(s,`${i}.log`),u=`${r.identifier.value}.${i}`,v=this.loggerService.createLogger(c,{id:u,name:I,logLevel:t,extensionId:r.identifier.value});return new a(u,I,v,this.proxy,r)}createExtensionLogDirectory(I){let t=this.extensionLogDirectoryPromise.get(I.identifier.value);if(!t){const r=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,I.identifier.value);this.extensionLogDirectoryPromise.set(I.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(r)}catch(s){if((0,D.toFileSystemProviderErrorCode)(s)!==D.FileSystemProviderErrorCode.FileExists)throw s}return r})())}return t}createExtHostOutputChannel(I,t){let r=!1;const s=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return I},append(i){s(),t.then(c=>c.append(i))},appendLine(i){s(),t.then(c=>c.appendLine(i))},clear(){s(),t.then(i=>i.clear())},replace(i){s(),t.then(c=>c.replace(i))},show(i,c){s(),t.then(u=>u.show(i,c))},hide(){s(),t.then(i=>i.hide())},dispose(){r=!0,t.then(i=>i.dispose())}}}createExtHostLogOutputChannel(I,t,r){const s=new n.DisposableStore,i=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},c=s.add(new y.Emitter);function u(v){t=v,c.fire(v)}return r.then(v=>{s.add(v),v.logLevel!==t&&u(v.logLevel),s.add(v.onDidChangeLogLevel(S=>u(S)))}),{...this.createExtHostOutputChannel(I,r),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(v,...S){i(),r.then(l=>l.trace(v,...S))},debug(v,...S){i(),r.then(l=>l.debug(v,...S))},info(v,...S){i(),r.then(l=>l.info(v,...S))},warn(v,...S){i(),r.then(l=>l.warn(v,...S))},error(v,...S){i(),r.then(l=>l.error(v,...S))},dispose(){s.dispose()}}}};e.ExtHostOutputService=m,e.ExtHostOutputService=m=qe([$e(0,d.IExtHostRpcService),$e(1,g.IExtHostInitDataService),$e(2,w.IExtHostConsumerFileSystem),$e(3,P.IExtHostFileSystemInfo),$e(4,T.ILoggerService),$e(5,T.ILogService)],m),e.IExtHostOutputService=(0,L.createDecorator)("IExtHostOutputService")}),define(Ce[334],De([1,0,6,13]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,C.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(d){let A=1/0;for(let f=0;f<this.maxSampleCount;f++){const w=await d.getRoundTripTime();if(w===void 0)return;A=Math.min(A,w/2),await(0,L.timeout)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(A):T=this.initial.reduce((f,w)=>f+w,0)/this.initial.length,this.lastMeasurement={initial:T,current:A,average:this.average.reduce((f,w)=>f+w,0)/this.average.length,high:(()=>typeof T>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>T*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ce[335],De([1,0,32,16,14,9,24,2,6,250,51,275,334]),function(me,e,C,L,d,A,T,f,w,g,P,k,p){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,w.createDecorator)("pathService");let D=_=class{constructor(n,o,a,m){this.localUserHome=n,this.remoteAgentService=o,this.environmentService=a,this.contextService=m,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome??n})()}hasValidBasename(n,o,a){return typeof o=="string"||typeof o>"u"?this.resolveOS.then(m=>this.doHasValidBasename(n,m,o)):this.doHasValidBasename(n,o,a)}doHasValidBasename(n,o,a){return n.scheme===L.Schemas.file||n.scheme===L.Schemas.vscodeRemote?(0,C.isValidBasename)(a??(0,T.basename)(n),o===1):!0}get defaultUriScheme(){return _.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(n,o){if(n.remoteAuthority)return L.Schemas.vscodeRemote;const a=(0,g.getVirtualWorkspaceScheme)(o.getWorkspace());if(a)return a;const m=o.getWorkspace().folders[0];if(m)return m.uri.scheme;const b=o.getWorkspace().configuration;return b?b.scheme:L.Schemas.file}userHome(n){return n?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(n=>n===1?d.win32:d.posix)}async fileURI(n){let o="";if(await this.resolveOS===1&&(n=n.replace(/\\/g,"/")),n[0]==="/"&&n[1]==="/"){const m=n.indexOf("/",2);m===-1?(o=n.substring(2),n="/"):(o=n.substring(2,m),n=n.substring(m)||"/")}return f.URI.from({scheme:L.Schemas.file,authority:o,path:n,query:"",fragment:""})}};e.AbstractPathService=D,e.AbstractPathService=D=_=qe([$e(1,p.IRemoteAgentService),$e(2,k.IWorkbenchEnvironmentService),$e(3,P.IWorkspaceContextService)],D)}),define(Ce[92],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class C{constructor(T,f){this.line=T,this.character=f}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,f){return new C(0,0)}with(T){return new C(0,0)}}e.Position=C;class L{constructor(T,f,w,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(T,f),this.end=new C(w,g)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new L(0,0,0,0)}with(T){return new L(0,0,0,0)}}e.Range=L;var d;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(d||(e.TextSearchCompleteMessageType=d={}))}),define(Ce[36],De([1,0,18,35,23,32,15,6,14,8,92,13]),function(me,e,C,L,d,A,T,f,w,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const p="\u27EA ",_=" characters skipped \u27EB",D=(p.length+_.length+5)*2;e.ISearchService=(0,f.createDecorator)("searchService");var y;(function(H){H[H.file=0]="file",H[H.text=1]="text"})(y||(e.SearchProviderType=y={}));var n;(function(H){H[H.File=1]="File",H[H.Text=2]="Text"})(n||(e.QueryType=n={}));function o(H){return!!H.preview}e.resultIsMatch=o;function a(H){return!!H.resource}e.isFileMatch=a;function m(H){return!!H.message}e.isProgressMessage=m;var b;(function(H){H[H.Normal=0]="Normal",H[H.NewSearchStarted=1]="NewSearchStarted"})(b||(e.SearchCompletionExitCode=b={}));class I{constructor(re){this.resource=re,this.results=[]}}e.FileMatch=I;class t{constructor(re,Ee,ae,ne){this.ranges=Ee,this.webviewIndex=ne;const J=Array.isArray(Ee)?Ee:[Ee];if(ae&&ae.matchLines===1&&r(J)){re=(0,T.getNLines)(re,ae.matchLines);let N="",W=0,he=0;const Se=Math.floor(ae.charsPerLine/5),be=[];for(const we of J){const ye=Math.max(we.startColumn-Se,0),V=we.startColumn+ae.charsPerLine;if(ye>he+Se+D){const ee=p+(ye-he)+_;N+=ee+re.slice(ye,V),W+=ye-(he+ee.length)}else N+=re.slice(he,V);be.push(new i(0,we.startColumn-W,we.endColumn-W)),he=V}this.preview={text:N,matches:Array.isArray(this.ranges)?be:be[0]}}else{const N=Array.isArray(Ee)?Ee[0].startLineNumber:Ee.startLineNumber;this.preview={text:re,matches:(0,C.mapArrayOrNot)(Ee,W=>new s(W.startLineNumber-N,W.startColumn,W.endLineNumber-N,W.endColumn))}}}}e.TextSearchMatch=t;function r(H){const re=H[0].startLineNumber;for(const Ee of H)if(Ee.startLineNumber!==re||Ee.endLineNumber!==re)return!1;return!0}class s{constructor(re,Ee,ae,ne){this.startLineNumber=re,this.startColumn=Ee,this.endLineNumber=ae,this.endColumn=ne}}e.SearchRange=s;class i extends s{constructor(re,Ee,ae){super(re,Ee,re,ae)}}e.OneLineRange=i;var c;(function(H){H.List="list",H.Tree="tree"})(c||(e.ViewMode=c={}));var u;(function(H){H.Default="default",H.FileNames="fileNames",H.Type="type",H.Modified="modified",H.CountDescending="countDescending",H.CountAscending="countAscending"})(u||(e.SearchSortOrder=u={}));function v(H,re=!0){const Ee=H&&H.files&&H.files.exclude,ae=re&&H&&H.search&&H.search.exclude;if(!Ee&&!ae)return;if(!Ee||!ae)return Ee||ae;let ne=Object.create(null);return ne=d.mixin(ne,d.deepClone(Ee)),ne=d.mixin(ne,d.deepClone(ae),!0),ne}e.getExcludes=v;function S(H,re){return H.excludePattern&&L.match(H.excludePattern,re)?!1:H.includePattern||H.usingSearchPaths?H.includePattern&&L.match(H.includePattern,re)?!0:H.usingSearchPaths?!!H.folderQueries&&H.folderQueries.some(Ee=>{const ae=Ee.folder.fsPath;if(A.isEqualOrParent(re,ae)){const ne=w.relative(ae,re);return!Ee.includePattern||!!L.match(Ee.includePattern,ne)}else return!1}):!1:!0}e.pathIncludedInQuery=S;var l;(function(H){H[H.unknownEncoding=1]="unknownEncoding",H[H.regexParseError=2]="regexParseError",H[H.globParseError=3]="globParseError",H[H.invalidLiteral=4]="invalidLiteral",H[H.rgProcessError=5]="rgProcessError",H[H.other=6]="other",H[H.canceled=7]="canceled"})(l||(e.SearchErrorCode=l={}));class h extends Error{constructor(re,Ee){super(re),this.code=Ee}}e.SearchError=h;function E(H){const re=H.message;if((0,g.isCancellationError)(H))return new h(re,l.canceled);try{const Ee=JSON.parse(re);return new h(Ee.message,Ee.code)}catch{return new h(re,l.other)}}e.deserializeSearchError=E;function R(H){const re={message:H.message,code:H.code};return new Error(JSON.stringify(re))}e.serializeSearchError=R;function M(H){return H.type==="error"?!0:H.type==="success"}e.isSerializedSearchComplete=M;function U(H){return H.type==="success"}e.isSerializedSearchSuccess=U;function F(H){return!!H.path}e.isSerializedFileMatch=F;function x(H,re){const Ee=H.searchPath?H.searchPath:H.relativePath;return(0,T.fuzzyContains)(Ee,re)}e.isFilePatternMatch=x;class ${constructor(re){this.path=re,this.results=[]}addMatch(re){this.results.push(re)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function O(H,re){const Ee={...H||{},...re||{}};return Object.keys(Ee).filter(ae=>{const ne=Ee[ae];return typeof ne=="boolean"&&ne})}e.resolvePatternsForProvider=O;class K{constructor(re,Ee){this._parsedIncludeExpression=null,this._excludeExpression={...re.excludePattern||{},...Ee.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let ae=re.includePattern;Ee.includePattern&&(ae?ae={...ae,...Ee.includePattern}:ae=Ee.includePattern),ae&&(this._parsedIncludeExpression=L.parse(ae))}matchesExcludesSync(re,Ee,ae){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(re,Ee,ae))}includedInQuerySync(re,Ee,ae){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(re,Ee,ae)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(re,Ee,ae))}includedInQuery(re,Ee,ae){const ne=this._parsedExcludeExpression(re,Ee,ae),J=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(re,Ee,ae):!0;return(0,k.isThenable)(ne)?ne.then(N=>N?!1:J()):J()}hasSiblingExcludeClauses(){return q(this._excludeExpression)}}e.QueryGlobTester=K;function q(H){for(const re in H)if(typeof H[re]!="boolean")return!0;return!1}function fe(H){if(!H)return;let re;return Ee=>(re||(re=(H()||Promise.resolve([])).then(ae=>ae?ie(ae):{})),re.then(ae=>!!ae[Ee]))}e.hasSiblingPromiseFn=fe;function se(H){if(!H)return;let re;return Ee=>{if(!re){const ae=H();re=ae?ie(ae):{}}return!!re[Ee]}}e.hasSiblingFn=se;function ie(H){const re={};for(const Ee of H)re[Ee]=!0;return re}}),define(Ce[38],De([1,0,18,13,22,4,3,75,16,118,24,15,2,208,6,17,236,51,52,26,20,10,7,62,36,5]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m,b,I,t,r,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function c(M,U,F){return new P.ExtUri(x=>l(x,F)).isEqual(M,U)}function u(M,U,F){return c(M.uri,U.uri,F)?0:(0,k.compare)(M.uri.toString(),U.uri.toString())}function v(M,U,F){return M.index!==U.index?M.index<U.index?-1:1:c(M.uri,U.uri,F)?(0,k.compare)(M.name,U.name):(0,k.compare)(M.uri.toString(),U.uri.toString())}function S(M,U,F,x){const $=M.slice(0).sort((K,q)=>F(K,q,x)),O=U.slice(0).sort((K,q)=>F(K,q,x));return(0,C.delta)($,O,(K,q)=>F(K,q,x))}function l(M,U){const F=U.getCapabilities(M.scheme);return!(F&&F&1024)}class h extends o.Workspace{static toExtHostWorkspace(U,F,x,$){if(!U)return{workspace:null,added:[],removed:[]};const{id:O,name:K,folders:q,configuration:fe,transient:se,isUntitled:ie}=U,H=[],re=F;F?q.forEach((J,N)=>{const W=p.URI.revive(J.uri),he=h._findFolder(x||F,W,$);he?(he.name=J.name,he.index=J.index,H.push(he)):H.push({uri:W,name:J.name,index:N})}):H.push(...q.map(({uri:J,name:N,index:W})=>({uri:p.URI.revive(J),name:N,index:W}))),H.sort((J,N)=>J.index<N.index?-1:1);const Ee=new h(O,K,H,!!se,fe?p.URI.revive(fe):null,!!ie,J=>l(J,$)),{added:ae,removed:ne}=S(re?re.workspaceFolders:[],Ee.workspaceFolders,u,$);return{workspace:Ee,added:ae,removed:ne}}static _findFolder(U,F,x){for(let $=0;$<U.folders.length;$++){const O=U.workspaceFolders[$];if(c(O.uri,F,x))return O}}constructor(U,F,x,$,O,K,q){super(U,x.map(fe=>new o.WorkspaceFolder(fe)),$,O,q),this._name=F,this._isUntitled=K,this._workspaceFolders=[],this._structure=f.TernarySearchTree.forUris(q),x.forEach(fe=>{this._workspaceFolders.push(fe),this._structure.set(fe.uri,fe)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(U,F){return F&&this._structure.get(U)&&(U=(0,P.dirname)(U)),this._structure.findSubstr(U)}resolveWorkspaceFolder(U){return this._structure.get(U)}}let E=class{constructor(U,F,x,$,O){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new A.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=$,this._extHostFileSystemInfo=x,this._uriTransformerService=O,this._requestIdProvider=new g.Counter,this._barrier=new L.Barrier,this._proxy=U.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=U.getProxy(i.MainContext.MainThreadMessageService);const K=F.workspace;this._confirmedWorkspace=K?new h(K.id,K.name,[],!!K.transient,K.configuration?p.URI.revive(K.configuration):null,!!K.isUntitled,q=>l(q,x)):void 0}$initializeWorkspace(U,F){this._trusted=F,this.$acceptWorkspaceData(U),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?p.URI.from({scheme:w.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(U,F,x,...$){const O=[];if(Array.isArray($)&&$.forEach(ie=>{p.URI.isUri(ie.uri)&&!O.some(H=>c(H.uri,ie.uri,this._extHostFileSystemInfo))&&O.push({uri:ie.uri,name:ie.name||(0,P.basenameOrAuthority)(ie.uri)})}),this._unconfirmedWorkspace||[F,x].some(ie=>typeof ie!="number"||ie<0)||x===0&&O.length===0)return!1;const K=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+x>K.length)return!1;const q=K.slice(0);q.splice(F,x,...O.map(ie=>({uri:ie.uri,name:ie.name||(0,P.basenameOrAuthority)(ie.uri),index:void 0})));for(let ie=0;ie<q.length;ie++){const H=q[ie];if(q.some((re,Ee)=>Ee!==ie&&c(H.uri,re.uri,this._extHostFileSystemInfo)))return!1}q.forEach((ie,H)=>ie.index=H);const{added:fe,removed:se}=S(K,q,v,this._extHostFileSystemInfo);if(fe.length===0&&se.length===0)return!1;if(this._proxy){const ie=U.displayName||U.name;this._proxy.$updateWorkspaceFolders(ie,F,x,O).then(void 0,H=>{this._unconfirmedWorkspace=void 0;const re={source:{identifier:U.identifier,label:U.displayName||U.name}};this._messageService.$showMessage(n.Severity.Error,(0,_.localize)(0,null,ie,H.toString()),re,[])})}return this.trySetWorkspaceFolders(q),!0}getWorkspaceFolder(U,F){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(U,F)}async getWorkspaceFolder2(U,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(U,F)}async resolveWorkspaceFolder(U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(U)}getPath(){if(!this._actualWorkspace)return;const{folders:U}=this._actualWorkspace;if(U.length!==0)return U[0].uri.fsPath}getRelativePath(U,F){let x,$="";if(typeof U=="string"?(x=p.URI.file(U),$=U):typeof U<"u"&&(x=U,$=U.fsPath),!x)return $;const O=this.getWorkspaceFolder(x,!0);if(!O)return $;typeof F>"u"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let K=(0,P.relativePath)(O.uri,x);return F&&O.name&&(K=`${O.name}/${K}`),K}trySetWorkspaceFolders(U){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:U,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(U){const{workspace:F,added:x,removed:$}=h.toExtHostWorkspace(U,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:x,removed:$}))}findFiles(U,F,x,$,O=d.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let K;if(F===null?K=!1:F&&(typeof F=="string"?K=F:K=F.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:q,folder:fe}=R(I.GlobPattern.from(U));return this._proxy.$startFileSearch(q??null,fe??null,K??null,x??null,O).then(se=>Array.isArray(se)?se.map(ie=>p.URI.revive(ie)):[])}async findTextInFiles(U,F,x,$,O=d.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const K=this._requestIdProvider.getNext(),q=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:fe,folder:se}=R(I.GlobPattern.from(F.include)),ie=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,H={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:q,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:fe,excludePattern:ie},re=!1;if(this._activeSearchCallbacks[K]=Ee=>{if(re)return;const ae=p.URI.revive(Ee.resource);Ee.results.forEach(ne=>{(0,s.resultIsMatch)(ne)?x({uri:ae,preview:{text:ne.preview.text,matches:(0,C.mapArrayOrNot)(ne.preview.matches,J=>new t.Range(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn))},ranges:(0,C.mapArrayOrNot)(ne.ranges,J=>new t.Range(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn))}):x({uri:ae,text:ne.text,lineNumber:ne.lineNumber})})},O.isCancellationRequested)return{};try{const Ee=await this._proxy.$startTextSearch(U,se??null,H,K,O);return delete this._activeSearchCallbacks[K],Ee||{}}catch(Ee){throw delete this._activeSearchCallbacks[K],Ee}}$handleTextSearchResult(U,F){this._activeSearchCallbacks[F]?.(U)}async save(U){const F=await this._proxy.$save(U,{saveAs:!1});return p.URI.revive(F)}async saveAs(U){const F=await this._proxy.$save(U,{saveAs:!0});return p.URI.revive(F)}saveAll(U){return this._proxy.$saveAll(U)}resolveProxy(U){return this._proxy.$resolveProxy(U)}get trusted(){return this._trusted}requestWorkspaceTrust(U){return this._proxy.$requestWorkspaceTrust(U)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(U,F){if(this._editSessionIdentityProviders.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this._editSessionIdentityProviders.set(U,F);const x=this._uriTransformerService.transformOutgoingScheme(U),$=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider($,x),(0,T.toDisposable)(()=>{this._editSessionIdentityProviders.delete(U),this._proxy.$unregisterEditSessionIdentityProvider($)})}async $getEditSessionIdentifier(U,F){this._logService.info("Getting edit session identifier for workspaceFolder",U);const x=await this.resolveWorkspaceFolder(p.URI.revive(U));if(!x){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",x);const $=this._editSessionIdentityProviders.get(x.uri.scheme);if(this._logService.info(`Provider for scheme ${x.uri.scheme} is defined: `,!!$),!$)return;const O=await $.provideEditSessionIdentity(x,F);if(this._logService.info("Provider returned edit session identifier: ",O),!!O)return O}async $provideEditSessionIdentityMatch(U,F,x,$){this._logService.info("Getting edit session identifier for workspaceFolder",U);const O=await this.resolveWorkspaceFolder(p.URI.revive(U));if(!O){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const K=this._editSessionIdentityProviders.get(O.uri.scheme);if(this._logService.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!K),!K)return;const q=await K.provideEditSessionIdentityMatch?.(F,x,$);if(this._logService.info("Provider returned edit session identifier match result: ",q),!!q)return q}getOnWillCreateEditSessionIdentityEvent(U){return(F,x,$)=>{const O=function(q){F.call(x,q)};return O.extension=U,this._onWillCreateEditSessionIdentityEvent.event(O,void 0,$)}}async $onWillCreateEditSessionIdentity(U,F,x){const $=await this.resolveWorkspaceFolder(p.URI.revive(U));if($===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:$},F,async(O,K)=>{const q=Date.now();await Promise.resolve(O),Date.now()-q>x&&this._logService.warn("SLOW edit session create-participant",K.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(U,F){if(this._canonicalUriProviders.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this._canonicalUriProviders.set(U,F);const x=this._uriTransformerService.transformOutgoingScheme(U),$=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider($,x),(0,T.toDisposable)(()=>{this._canonicalUriProviders.delete(U),this._proxy.$unregisterCanonicalUriProvider($)})}async provideCanonicalUri(U,F,x){const $=this._canonicalUriProviders.get(U.scheme);if(!$)return;const O=await $.provideCanonicalUri?.(p.URI.revive(U),F,x);if(O)return O}async $provideCanonicalUri(U,F,x){return this.provideCanonicalUri(p.URI.revive(U),{targetScheme:F},x)}};e.ExtHostWorkspace=E,e.ExtHostWorkspace=E=qe([$e(0,b.IExtHostRpcService),$e(1,m.IExtHostInitDataService),$e(2,a.IExtHostFileSystemInfo),$e(3,y.ILogService),$e(4,r.IURITransformerService)],E),e.IExtHostWorkspace=(0,D.createDecorator)("IExtHostWorkspace");function R(M){let U,F;return M&&(typeof M=="string"?U=M:(U=M.pattern,F=p.URI.revive(M.baseUri))),{includePattern:U,folder:F}}}),define(Ce[39],De([1,0,23,4,38,5,7,238,134,19,13,6,20,17,2]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function y(r,s){if(s){const i=s.split(".");let c=r;for(let u=0;c&&u<i.length;u++)c=c[i[u]];return c}}function n(r){return r instanceof D.URI}function o(r){return r&&r.uri instanceof D.URI&&r.languageId&&typeof r.languageId=="string"}function a(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function m(r){return r&&r.uri instanceof D.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function b(r){if(n(r))return{resource:r};if(o(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(a(r))return{overrideIdentifier:r.languageId};if(m(r))return{resource:r.uri};if(r===null)return{resource:null}}let I=class{constructor(s,i,c){this._proxy=s.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=c,this._barrier=new P.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(s,i))}};e.ExtHostConfiguration=I,e.ExtHostConfiguration=I=qe([$e(0,p.IExtHostRpcService),$e(1,d.IExtHostWorkspace),$e(2,_.ILogService)],I);class t{constructor(s,i,c,u){this._onDidChangeConfiguration=new L.Emitter,this._proxy=s,this._logService=u,this._extHostWorkspace=i,this._configuration=f.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=f.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,c))}getConfiguration(s,i,c){const u=b(i)||{},v=this._toReadonlyValue(s?y(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,u,c?.identifier);function S(h){if(h==null)return null;if(typeof h=="boolean")return h?2:5;switch(h){case T.ConfigurationTarget.Global:return 2;case T.ConfigurationTarget.Workspace:return 5;case T.ConfigurationTarget.WorkspaceFolder:return 6}}const l={has(h){return typeof y(v,h)<"u"},get:(h,E)=>{this._validateConfigurationAccess(s?`${s}.${h}`:h,u,c?.identifier);let R=y(v,h);if(typeof R>"u")R=E;else{let M;const U=(F,x)=>{if((0,g.isObject)(F)){let $;const O=()=>{M=M||(0,C.deepClone)(v),$=$||y(M,x)};return new Proxy(F,{get:(K,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return O(),()=>$;if(M)return $=$||y(M,x),$[q];const fe=K[q];return typeof q=="string"?U(fe,`${x}.${q}`):fe},set:(K,q,fe)=>(O(),$&&($[q]=fe),!0),deleteProperty:(K,q)=>(O(),$&&delete $[q],!0),defineProperty:(K,q,fe)=>(O(),$&&Object.defineProperty($,q,fe),!0)})}return Array.isArray(F)?(0,C.deepClone)(F):F};R=U(R,h)}return R},update:(h,E,R,M)=>{h=s?`${s}.${h}`:h;const U=S(R);return E!==void 0?this._proxy.$updateConfigurationOption(U,h,E,u,M):this._proxy.$removeConfigurationOption(U,h,u,M)},inspect:h=>{h=s?`${s}.${h}`:h;const E=this._configuration.inspect(h,u,this._extHostWorkspace.workspace);if(E)return{key:h,defaultValue:(0,C.deepClone)(E.policy?.value??E.default?.value),globalValue:(0,C.deepClone)(E.user?.value??E.application?.value),workspaceValue:(0,C.deepClone)(E.workspace?.value),workspaceFolderValue:(0,C.deepClone)(E.workspaceFolder?.value),defaultLanguageValue:(0,C.deepClone)(E.default?.override),globalLanguageValue:(0,C.deepClone)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,C.deepClone)(E.workspace?.override),workspaceFolderLanguageValue:(0,C.deepClone)(E.workspaceFolder?.override),languageIds:(0,C.deepClone)(E.overrideIdentifiers)}}};return typeof v=="object"&&(0,C.mixin)(l,v,!1),Object.freeze(l)}_toReadonlyValue(s){const i=c=>(0,g.isObject)(c)?new Proxy(c,{get:(u,v)=>i(u[v]),set:(u,v,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(u,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(u,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(s)}_validateConfigurationAccess(s,i,c){const u=w.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),v=c?`[${c.value}] `:"";if(u===4){typeof i?.resource>"u"&&this._logService.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){i?.resource&&this._logService.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const c=new f.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,v)=>c.affectsConfiguration(u,b(v))})}_toMap(s){return s.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")}),define(Ce[93],De([1,0,2,13,4,5,7,38,65,39,22,43,20,26,6,16,9,17,89,282,8]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var I;(function(U){function F($){if($!=null)return $}U.from=F;function x($){if($!=null)return $}U.to=x})(I||(I={}));var t;(function(U){function F($){if($!=null)return $}U.from=F;function x($){if($!=null)return $}U.to=x})(t||(t={}));var r;(function(U){function F($){if($!=null)return $}U.from=F;function x($){if($!=null)return $}U.to=x})(r||(r={}));var s;(function(U){function F(O){if(O){const K=O;return K&&!!K.process}else return!1}U.is=F;function x(O){if(O==null)return;const K={process:O.process,args:O.args};return O.options&&(K.options=r.from(O.options)),K}U.from=x;function $(O){if(O!=null)return new T.ProcessExecution(O.process,O.args,O.options)}U.to=$})(s||(s={}));var i;(function(U){function F($){if($!=null)return $}U.from=F;function x($){if($!=null)return $}U.to=x})(i||(i={}));var c;(function(U){function F(O){if(O){const K=O;return K&&(!!K.commandLine||!!K.command)}else return!1}U.is=F;function x(O){if(O==null)return;const K={};return O.commandLine!==void 0?K.commandLine=O.commandLine:(K.command=O.command,K.args=O.args),O.options&&(K.options=i.from(O.options)),K}U.from=x;function $(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new T.ShellExecution(O.commandLine,O.options):new T.ShellExecution(O.command,O.args?O.args:[],O.options)}U.to=$})(c||(c={}));var u;(function(U){function F(O){if(O){const K=O;return K&&K.customExecution==="customExecution"}else return!1}U.is=F;function x(O){return{customExecution:"customExecution"}}U.from=x;function $(O,K){return K.get(O)}U.to=$})(u||(e.CustomExecutionDTO=u={}));var v;(function(U){function F(x,$){let O;return x.scope!==void 0&&typeof x.scope!="number"?O=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===T.TaskScope.Workspace&&$&&$.workspaceFile?O=$.workspaceFile:O=m.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:O}}U.from=F})(v||(e.TaskHandleDTO=v={}));var S;(function(U){function F(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}U.from=F})(S||(S={}));var l;(function(U){function F(O,K){if(O==null)return[];const q=[];for(const fe of O){const se=x(fe,K);se&&q.push(se)}return q}U.fromMany=F;function x(O,K){if(O==null)return;let q;O.execution instanceof T.ProcessExecution?q=s.from(O.execution):O.execution instanceof T.ShellExecution?q=c.from(O.execution):O.execution&&O.execution instanceof T.CustomExecution&&(q=u.from(O.execution));const fe=I.from(O.definition);let se;return O.scope?typeof O.scope=="number"?se=O.scope:se=O.scope.uri:se=T.TaskScope.Workspace,!fe||!se?void 0:{_id:O._id,definition:fe,name:O.name,source:{extensionId:K.identifier.value,label:O.source,scope:se},execution:q,isBackground:O.isBackground,group:S.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}U.from=x;async function $(O,K,q){if(O==null)return;let fe;s.is(O.execution)?fe=s.to(O.execution):c.is(O.execution)?fe=c.to(O.execution):u.is(O.execution)&&(fe=u.to(O._id,q));const se=I.to(O.definition);let ie;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?ie=O.source.scope:ie=await K.resolveWorkspaceFolder(C.URI.revive(O.source.scope)):ie=T.TaskScope.Workspace),!se||!ie)return;const H=new T.Task(se,ie,O.name,O.source.label,fe,O.problemMatchers);return O.isBackground!==void 0&&(H.isBackground=O.isBackground),O.group!==void 0&&(H.group=T.TaskGroup.from(O.group._id),H.group&&O.group.isDefault&&(H.group=new T.TaskGroup(H.group.id,H.group.label),O.group.isDefault===!0&&(H.group.isDefault=O.group.isDefault))),O.presentationOptions&&(H.presentationOptions=t.to(O.presentationOptions)),O._id&&(H._id=O._id),O.detail&&(H.detail=O.detail),H}U.to=$})(l||(e.TaskDTO=l={}));var h;(function(U){function F($){return $}U.from=F;function x($){if($)return Object.assign(Object.create(null),$)}U.to=x})(h||(h={}));class E{#e;constructor(F,x,$){this._id=x,this._task=$,this.#e=F}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let R=class{constructor(F,x,$,O,K,q,fe,se){this._onDidExecuteTask=new d.Emitter,this._onDidTerminateTask=new d.Emitter,this._onDidTaskProcessStarted=new d.Emitter,this._onDidTaskProcessEnded=new d.Emitter,this._proxy=F.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=O,this._configurationService=K,this._terminalService=q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=fe,this._deprecationService=se,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(F,x,$){if(!$)return new T.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:x,provider:$,extension:F}),this._proxy.$registerTaskProvider(O,x),new T.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(F,x){this._proxy.$registerTaskSystem(F,x)}fetchTasks(F){return this._proxy.$fetchTasks(h.from(F)).then(async x=>{const $=[];for(const O of x){const K=await l.to(O,this._workspaceProvider,this._providedCustomExecutions2);K&&$.push(K)}return $})}get taskExecutions(){const F=[];return this._taskExecutions.forEach(x=>F.push(x)),F}terminateTask(F){if(!(F instanceof E))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(F._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(F,x,$){const O=this._providedCustomExecutions2.get(F.id);O&&(this._activeCustomExecutions2.set(F.id,O),this._terminalService.attachPtyToTerminal(x,await O.callback($))),this._lastStartedTask=F.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(F)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(F){const x=await this.getTaskExecution(F);this._taskExecutionPromises.delete(F.id),this._taskExecutions.delete(F.id),this.customExecutionComplete(F),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(F){const x=await this.getTaskExecution(F.id);this._onDidTaskProcessStarted.fire({execution:x,processId:F.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(F){const x=await this.getTaskExecution(F.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:F.exitCode})}$provideTasks(F,x){const $=this._handlers.get(F);if(!$)return Promise.reject(new Error("no handler found"));const O=[],K=(0,L.asPromise)(()=>$.provider.provideTasks(P.CancellationToken.None)).then(q=>this.provideTasksInternal(x,O,$,q));return new Promise(q=>{K.then(fe=>{Promise.all(O).then(()=>{q(fe)})})})}async $resolveTask(F,x){const $=this._handlers.get(F);if(!$)return Promise.reject(new Error("no handler found"));if(x.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${$.type}].`);const O=await l.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const K=await $.provider.resolveTask(O,P.CancellationToken.None);if(!K)return;this.checkDeprecation(K,$);const q=l.from(K,$.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(q.execution)&&await this.addCustomExecution(q,K,!0),await this.resolveTaskInternal(q)}nextHandle(){return this._handleCounter++}async addCustomExecution(F,x,$){const O=await this._proxy.$createTaskId(F);!$&&!this._providedCustomExecutions2.has(O)&&(this._notProvidedCustomExecutions.add(O),this._activeCustomExecutions2.set(O,x.execution)),this._providedCustomExecutions2.set(O,x.execution)}async getTaskExecution(F,x){if(typeof F=="string"){const K=this._taskExecutionPromises.get(F);if(!K)throw new b.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return K}const $=this._taskExecutionPromises.get(F.id);if($)return $;const O=new Promise((K,q)=>{function fe(se,ie,H){H?K(new E(se,ie.id,H)):q("Unexpected: Task does not exist.")}x?fe(this,F,x):l.to(F.task,this._workspaceProvider,this._providedCustomExecutions2).then(se=>fe(this,F,se))});return this._taskExecutionPromises.set(F.id,O),O.then(K=>(this._taskExecutions.set(F.id,K),K),K=>Promise.reject(K))}checkDeprecation(F,x){F._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(F){this._activeCustomExecutions2.get(F.id)&&this._activeCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.has(F.id)&&this._lastStartedTask!==F.id&&(this._providedCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.delete(F.id));const $=this._notProvidedCustomExecutions.values();let O=$.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=$.next()}};e.ExtHostTaskBase=R,e.ExtHostTaskBase=R=qe([$e(0,p.IExtHostRpcService),$e(1,_.IExtHostInitDataService),$e(2,f.IExtHostWorkspace),$e(3,w.IExtHostDocumentsAndEditors),$e(4,g.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,o.ILogService),$e(7,a.IExtHostApiDeprecationService)],R);let M=class extends R{constructor(F,x,$,O,K,q,fe,se){super(F,x,$,O,K,q,fe,se),this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:"",platform:n.PlatformToString(0)})}async executeTask(F,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const $=l.from(x,F);if($===void 0)throw new Error("Task is not valid");if(u.is($.execution))await this.addCustomExecution($,x,!1);else throw new b.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution($),x);return this._proxy.$executeTask($).catch(K=>{throw new Error(K)}),O}provideTasksInternal(F,x,$,O){const K=[];if(O)for(const q of O){this.checkDeprecation(q,$),(!q.definition||!F[q.definition.type])&&this._logService.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const fe=l.from(q,$.extension);fe&&u.is(fe.execution)?(K.push(fe),x.push(this.addCustomExecution(fe,q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:K,extension:$.extension}}async resolveTaskInternal(F){if(u.is(F.execution))return F;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(F,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,x,$){}};e.WorkerExtHostTask=M,e.WorkerExtHostTask=M=qe([$e(0,p.IExtHostRpcService),$e(1,_.IExtHostInitDataService),$e(2,f.IExtHostWorkspace),$e(3,w.IExtHostDocumentsAndEditors),$e(4,g.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,o.ILogService),$e(7,a.IExtHostApiDeprecationService)],M),e.IExtHostTask=(0,D.createDecorator)("IExtHostTask")}),define(Ce[336],De([1,0,14,22,45,35,24,37,36]),function(me,e,C,L,d,A,T,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class g{constructor(p,_,D){this.config=p,this.provider=_,this.sessionToken=D,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=p.filePattern,this.includePattern=p.includePattern&&A.parse(p.includePattern),this.maxResults=p.maxResults||void 0,this.exists=p.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=p.excludePattern&&A.parse(p.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(p=>p.cancel()),this.activeCancellationTokens=new Set}search(p){const _=this.config.folderQueries||[];return new Promise((D,y)=>{const n=o=>{this.resultCount++,p(o)};if(this.isCanceled)return D({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(o=>{const a=o.toString(),m=C.basename(a);this.globalExcludePattern&&this.globalExcludePattern(a,m)||this.matchFile(n,{base:o,basename:m})}),Promise.all(_.map(o=>this.searchInFolder(o,n))).then(o=>{D({limitHit:this.isLimitHit,stats:o[0]||void 0})},o=>{y(new Error((0,d.toErrorMessage)(o)))})})}async searchInFolder(p,_){const D=new L.CancellationTokenSource,y=this.getSearchOptionsForFolder(p),n=this.initDirectoryTree(),o=new w.QueryGlobTester(this.config,p),a=!o.hasSiblingExcludeClauses();let m;try{this.activeCancellationTokens.add(D),m=f.StopWatch.create();const b=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},y,D.token),I=m.elapsed(),t=f.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(b&&b.forEach(r=>{const s=C.posix.relative(p.folder.path,r.path);if(a){const i=C.basename(r.path);this.matchFile(_,{base:p.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(n,p.folder,s,_)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(n,o,_),{providerTime:I,postProcessTime:t.elapsed()})}finally{D.dispose(),this.activeCancellationTokens.delete(D)}}getSearchOptionsForFolder(p){const _=(0,w.resolvePatternsForProvider)(this.config.includePattern,p.includePattern),D=(0,w.resolvePatternsForProvider)(this.config.excludePattern,p.excludePattern);return{folder:p.folder,excludes:D,includes:_,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}addDirectoryEntries({pathToEntries:p},_,D,y){if(D===this.filePattern){const o=C.basename(this.filePattern);this.matchFile(y,{base:_,relativePath:this.filePattern,basename:o})}function n(o){const a=C.basename(o),m=C.dirname(o);let b=p[m];b||(b=p[m]=[],n(m)),b.push({base:_,relativePath:o,basename:a})}n(D)}matchDirectoryTree({rootEntries:p,pathToEntries:_},D,y){const n=this,o=this.filePattern;function a(m){const b=(0,w.hasSiblingFn)(()=>m.map(I=>I.basename));for(let I=0,t=m.length;I<t;I++){const r=m[I],{relativePath:s,basename:i}=r;if(D.matchesExcludesSync(s,i,o!==i?b:void 0))continue;const c=_[s];if(c)a(c);else{if(s===o)continue;n.matchFile(y,r)}if(n.isLimitHit)break}}a(p)}matchFile(p,_){(!this.includePattern||_.relativePath&&this.includePattern(_.relativePath,_.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||p(_))}}class P{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(p,_,D,y){const n=this.getSessionTokenSource(p.cacheKey),o=new g(p,_,n&&n.token);let a=0;const m=b=>{a+=b.length,D(b.map(I=>this.rawMatchToSearchItem(I)))};return this.doSearch(o,P.BATCH_SIZE,m,y).then(b=>({limitHit:b.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:a,detailStats:b.stats}}))}clearCache(p){this.getSessionTokenSource(p)?.cancel()}getSessionTokenSource(p){if(p)return this.sessions.has(p)||this.sessions.set(p,new L.CancellationTokenSource),this.sessions.get(p)}rawMatchToSearchItem(p){return p.relativePath?{resource:T.joinPath(p.base,p.relativePath)}:{resource:p.base}}doSearch(p,_,D,y){y.onCancellationRequested(()=>{p.cancel()});const n=a=>{a&&(o.push(a),_>0&&o.length>=_&&(D(o),o=[]))};let o=[];return p.search(n).then(a=>(o.length&&D(o),a),a=>(o.length&&D(o),Promise.reject(a)))}}e.FileSearchManager=P}),define(Ce[337],De([1,0,18,69,35,126,28,16,14,24,15,19,2,169,219,50,17,51,141,335,36]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let I=class{constructor(h,E,R,M,U){this.configurationService=h,this.workspaceContextService=E,this.editorGroupsService=R,this.logService=M,this.pathService=U}text(h,E,R={}){h=this.getContentPattern(h,R);const M=this.configurationService.getValue(),U=E&&E.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(E?.map(o.toWorkspaceFolder),R),type:2,contentPattern:h,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:M.search.usePCRE2||U||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(h,E){const R=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const M={...h,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(h,E)&&(M.isCaseSensitive=!0),this.isMultiline(h)&&(M.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),M}file(h,E={}){return{...this.commonQuery(h,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(h,E){return h?(h=Array.isArray(h)?h.map(c):c(h),E?this.parseSearchPaths(h):{pattern:r(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],E={}){const R=this.handleIncludeExclude(E.includePattern,E.expandPatterns),M=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),U=h.length>1,F=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,E,M)):h.map(O=>this.getFolderQueryForRoot(O,E,M,U))).filter(O=>!!O),x={_reason:E._reason,folderQueries:F,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:M.pattern,includePattern:R.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const O=C.coalesce(C.flatten(this.editorGroupsService.groups.map(fe=>fe.editors.map(se=>se.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const K=O.filter(fe=>(0,b.pathIncludedInQuery)(x,fe.fsPath)),q=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(q)),{...x,...q}}const $=E.extraFileResources&&E.extraFileResources.filter(O=>(0,b.pathIncludedInQuery)(x,O.fsPath));return x.extraFileResources=$&&$.length?$:void 0,x}commonQueryFromFileList(h){const E=[],R=new T.ResourceMap,M={};let U=!1;return h.forEach(F=>{if(F.scheme===f.Schemas.walkThrough)return;if((0,g.isAbsolutePath)(F)){const $=this.workspaceContextService.getWorkspaceFolder(F)?.uri??F.with({path:w.dirname(F.fsPath)});let O=R.get($);O||(U=!0,O={folder:$,includePattern:{}},E.push(O),R.set($,O));const K=w.relative($.fsPath,F.fsPath);(0,k.assertIsDefined)(O.includePattern)[K.replace(/\\/g,"/")]=!0}else F.fsPath&&(U=!0,M[F.fsPath]=!0)}),{folderQueries:E,includePattern:M,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}isCaseSensitive(h,E){if(E.isSmartCase){if(h.isRegExp){if(P.containsUppercaseCharacter(h.pattern,!0))return!0}else if(P.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,_.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const E=q=>w.isAbsolute(q)||/^\.\.?([\/\\]|$)/.test(q),M=(Array.isArray(h)?h:s(h)).map(q=>{const fe=this.pathService.resolvedUserHome;return fe?(0,A.untildify)(q,fe.scheme===f.Schemas.file?fe.fsPath:fe.path):q}),U=L.groupBy(M,q=>E(q)?"searchPaths":"exprSegments"),F=(U.exprSegments||[]).map(q=>P.rtrim(q,"/")).map(q=>P.rtrim(q,"\\")).map(q=>(q[0]==="."&&(q="*"+q),i(q))),x={},$=this.expandSearchPathPatterns(U.searchPaths||[]);$&&$.length&&(x.searchPaths=$);const O=C.flatten(F),K=r(...O);return K&&(x.pattern=K),x}getExcludesForFolder(h,E){return E.disregardExcludeSettings?void 0:(0,b.getExcludes)(h,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const E=h.flatMap(M=>{let{pathPortion:U,globPortion:F}=t(M);return F&&(F=u(F)),this.expandOneSearchPath(U).flatMap($=>this.resolveOneSearchPathPattern($,F))}),R=new Map;return E.forEach(M=>{const U=M.searchPath.toString(),F=R.get(U);F?M.pattern&&(F.pattern=F.pattern||{},F.pattern[M.pattern]=!0):R.set(U,{searchPath:M.searchPath,pattern:M.pattern?r(M.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(h){if(w.isAbsolute(h)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==f.Schemas.file?[{searchPath:E[0].uri.with({path:h})}]:[{searchPath:p.URI.file(w.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=c(h),h.startsWith("../")||h===".."){const M=w.posix.resolve(E.path,h);return[{searchPath:E.with({path:M})}]}const R=u(h);return[{searchPath:E,pattern:R}]}else{if(h==="./"||h===".\\")return[];{const E=h.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(U=>{const F=E.match(new RegExp(`^${P.escapeRegExpCharacters(U.name)}(?:/(.*)|$)`));return F?{match:F,folder:U}:null}).filter(k.isDefined);if(M.length)return M.map(U=>{const F=U.match[1];return{searchPath:U.folder.uri,pattern:F&&u(F)}});{const U=h.match(/\.[\/\\](.+)[\/\\]?/),F=U?U[1]:h,x=D.localize(0,null,F);throw new Error(x)}}}}resolveOneSearchPathPattern(h,E){const R=h.pattern&&E?`${h.pattern}/${E}`:h.pattern||E,M=[{searchPath:h.searchPath,pattern:R}];return R&&!R.endsWith("**")&&M.push({searchPath:h.searchPath,pattern:R+"/**"}),M}getFolderQueryForSearchPath(h,E,R){const M=this.getFolderQueryForRoot((0,o.toWorkspaceFolder)(h.searchPath),E,R,!1);return M?{...M,includePattern:h.pattern}:null}getFolderQueryForRoot(h,E,R,M){let U;const F=p.URI.isUri(h)?h:h.uri;if(R.searchPaths){const q=R.searchPaths.filter(fe=>(0,g.isEqual)(fe.searchPath,F))[0];if(q&&!q.pattern)return null;q&&(U=q.pattern)}const x=this.configurationService.getValue({resource:F}),O={...this.getExcludesForFolder(x,E)||{},...U||{}},K=p.URI.isUri(h)?(0,g.basename)(h):h.name;return{folder:F,folderName:M?K:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!x.search.followSymlinks}}};e.QueryBuilder=I,e.QueryBuilder=I=qe([$e(0,y.IConfigurationService),$e(1,o.IWorkspaceContextService),$e(2,a.IEditorGroupsService),$e(3,n.ILogService),$e(4,m.IPathService)],I);function t(l){const h=l.match(/[\*\{\}\(\)\[\]\?]/);if(h){const E=h.index,R=l.substr(0,E).match(/[/|\\][^/\\]*$/);if(R){let M=l.substr(0,R.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:l.substr((R.index||0)+1)}}}return{pathPortion:l}}function r(...l){return l.length?l.reduce((h,E)=>(h[E]=!0,h),Object.create(null)):void 0}function s(l){return d.splitGlobAware(l,",").map(h=>h.trim()).filter(h=>!!h.length)}function i(l){return[`**/${l}/**`,`**/${l}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function c(l){return l.replace(/\\/g,"/")}function u(l){return c(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(l){return l.replace(/([?*[\]])/g,"[$1]")}function S(l,h){l=C.distinct(l,M=>M.toString());const E=[],R=h.getWorkspace();return l&&l.forEach(M=>{let U;if(h.getWorkbenchState()===2)U=(0,g.relativePath)(R.folders[0].uri,M),U&&U!=="."&&(U="./"+U);else{const F=h.getWorkspaceFolder(M);if(F){const x=F.name;if(R.folders.filter(O=>O.name===x).length===1){const O=(0,g.relativePath)(F.uri,M);O===""?U=`./${F.name}`:U=`./${F.name}/${O}`}else U=M.fsPath}}U&&E.push(v(U))}),E}e.resolveResourcesForSearchIncludes=S}),define(Ce[338],De([1,0,24,2,22,8,6,337,36,51]),function(me,e,C,L,d,A,T,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const P=7e3;function k(y,n){const o=n.activationEvents;if(!o)return Promise.resolve(void 0);const a=[],m=[];for(const i of o)if(/^workspaceContains:/.test(i)){const c=i.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||y.forceUsingSearch?m.push(c):a.push(c)}if(a.length===0&&m.length===0)return Promise.resolve(void 0);let b;const I=new Promise((i,c)=>{b=i}),t=i=>b({activationEvent:i}),r=Promise.all(a.map(i=>p(y,i,t))).then(()=>{}),s=_(y,n.identifier,m,t);return Promise.all([r,s]).then(()=>{b(void 0)}),I}e.checkActivateWorkspaceContainsExtension=k;async function p(y,n,o){for(const a of y.folders)if(await y.exists(C.joinPath(L.URI.revive(a),n))){o(`workspaceContains:${n}`);return}}async function _(y,n,o,a){if(o.length===0)return Promise.resolve(void 0);const m=new d.CancellationTokenSource,b=y.checkExists(y.folders,o,m.token),I=setTimeout(async()=>{m.cancel(),y.logService.info(`Not activating extension '${n.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},P);let t=!1;try{t=await b}catch(r){A.isCancellationError(r)||A.onUnexpectedError(r)}m.dispose(),clearTimeout(I),t&&a(`workspaceContains:${o.join(",")}`)}function D(y,n,o,a){const m=y.get(T.IInstantiationService),b=y.get(w.ISearchService),t=m.createInstance(f.QueryBuilder).file(n.map(r=>(0,g.toWorkspaceFolder)(L.URI.revive(r))),{_reason:"checkExists",includePattern:o,exists:!0});return b.fileSearch(t,a).then(r=>!!r.limitHit,r=>A.isCancellationError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=D}),define(Ce[44],De([1,0,198,14,61,24,13,3,75,2,17,5,39,277,114,38,27,145,8,25,21,252,7,84,6,26,90,20,103,68,43,4,338,113,254,16,111,37,9,112]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m,b,I,t,r,s,i,c,u,v,S,l,h,E,R,M,U,F,x,$,O){"use strict";var K;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let q=K=class extends f.Disposable{constructor(ne,J,N,W,he,Se,be,we,ye,V,ee,G){super(),this._extHostManagedSockets=G,this._onDidChangeRemoteConnectionData=this._register(new h.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=J,this._extHostContext=N,this._initData=be,this._extHostWorkspace=W,this._extHostConfiguration=he,this._logService=Se,this._extHostTunnelService=ye,this._extHostTerminalService=V,this._extHostLocalizationService=ee,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._activationEventsReader=new Ee(this._initData.activationEvents),this._globalRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.allExtensions);const Y=new m.ExtensionIdentifierSet(this._initData.myExtensions);this._myRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,H(this._globalRegistry,Y)),this._storage=new D.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=we,this._instaService=ne.createChild(new v.ServiceCollection([D.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState])),this._activator=this._register(new _.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(de,ke,B)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(de,a.transformErrorForSerialization(ke),B)},actualActivateExtension:async(de,ke)=>{if(o.ExtensionDescriptionRegistry.isHostExtension(de,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(de,ke),new _.HostExtension;const B=this._myRegistry.getExtensionDescription(de);return this._activateExtension(B,ke)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),d.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ne){a.onUnexpectedError(ne)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ne=[];try{ne=this._myRegistry.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this._deactivate(he))}catch{}await Promise.all(ne)}terminate(ne,J=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ne}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),a.setUnexpectedErrorHandler(W=>{this._logService.error(W)}),this._extHostContext.dispose();const N=this._deactivateAll();Promise.race([(0,T.timeout)(5e3),N]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${J}`):this._logService.info(`Extension host exiting with code ${J}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(J)})}isActivated(ne){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ne):!1}async getExtension(ne){const J=await this._mainThreadExtensionsProxy.$getExtension(ne);return J&&{...J,identifier:new m.ExtensionIdentifier(J.identifier.value),extensionLocation:g.URI.revive(J.extensionLocation)}}_activateByEvent(ne,J){return this._activator.activateByEvent(ne,J)}_activateById(ne,J){return this._activator.activateById(ne,J)}activateByIdWithErrors(ne,J){return this._activateById(ne,J).then(()=>{const N=this._activator.getActivatedExtension(ne);if(N.activationFailed)return Promise.reject(N.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ne=>this._myRegistry)}getExtensionExports(ne){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(ne).exports;try{return this._activator.getActivatedExtension(ne).exports}catch{return null}}async _realPathExtensionUri(ne){if(ne.scheme===U.Schemas.file&&this._hostUtils.fsRealpath){const J=await this._hostUtils.fsRealpath(ne.fsPath);return g.URI.file(J)}return ne}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ne=>new re(ne))),this._extensionPathIndex}async _createExtensionPathIndex(ne){const J=w.TernarySearchTree.forUris(N=>A.extUriBiasedIgnorePathCase.ignorePathCasing(N));return await Promise.all(ne.map(async N=>{if(this._getEntryPoint(N)){const W=await this._realPathExtensionUri(N.extensionLocation);J.set(W,N)}})),J}_deactivate(ne){let J=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ne))return J;const N=this._activator.getActivatedExtension(ne);if(!N)return J;try{typeof N.module.deactivate=="function"&&(J=Promise.resolve(N.module.deactivate()).then(void 0,W=>(this._logService.error(W),Promise.resolve(void 0))))}catch(W){this._logService.error(`An error occurred when deactivating the extension '${ne.value}':`),this._logService.error(W)}try{(0,f.dispose)(N.subscriptions)}catch(W){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ne.value}':`),this._logService.error(W)}return J}async _activateExtension(ne,J){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ne.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ne.identifier),this._doActivateExtension(ne,J).then(N=>{const W=N.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ne.identifier,W.codeLoadingTime,W.activateCallTime,W.activateResolvedTime,J),this._logExtensionActivationTimes(ne,J,"success",W),N},N=>{throw this._logExtensionActivationTimes(ne,J,"failure"),N})}_logExtensionActivationTimes(ne,J,N,W){const he=se(ne,J);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...he,...W||{},outcome:N})}_doActivateExtension(ne,J){const N=se(ne,J);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",N);const W=this._getEntryPoint(ne);if(!W)return Promise.resolve(new _.EmptyExtension(_.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ne.identifier.value}, startup: ${J.startup}, activationEvent: '${J.activationEvent}'${ne.identifier.value!==J.extensionId.value?`, root cause: ${J.extensionId.value}`:""}`),this._logService.flush();const he=new _.ExtensionActivationTimesBuilder(J.startup);return Promise.all([this._loadCommonJSModule(ne,(0,A.joinPath)(ne.extensionLocation,W),he),this._loadExtensionContext(ne)]).then(Se=>(d.mark(`code/extHost/willActivateExtension/${ne.identifier.value}`),K._callActivate(this._logService,ne.identifier,Se[0],Se[1],he))).then(Se=>(d.mark(`code/extHost/didActivateExtension/${ne.identifier.value}`),Se))}_loadExtensionContext(ne){const J=new I.ExtensionGlobalMemento(ne,this._storage),N=new I.ExtensionMemento(ne.identifier.value,!1,this._storage),W=new M.ExtensionSecrets(ne,this._secretState),he=ne.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Se=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ne.identifier.value}`),Promise.all([J.whenReady,N.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let we,ye;const V=(0,n.isProposedApiEnabled)(ne,"ipc")?this._initData.messagePorts?.get(m.ExtensionIdentifier.toKey(ne.identifier)):void 0;return Object.freeze({globalState:J,workspaceState:N,secrets:W,subscriptions:[],get extensionUri(){return ne.extensionLocation},get extensionPath(){return ne.extensionLocation.fsPath},asAbsolutePath(ee){return L.join(ne.extensionLocation.fsPath,ee)},get storagePath(){return be._storagePath.workspaceValue(ne)?.fsPath},get globalStoragePath(){return be._storagePath.globalValue(ne).fsPath},get logPath(){return L.join(be._initData.logsLocation.fsPath,ne.identifier.value)},get logUri(){return g.URI.joinPath(be._initData.logsLocation,ne.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(ne)},get globalStorageUri(){return be._storagePath.globalValue(ne)},get extensionMode(){return he},get extension(){return we===void 0&&(we=new ie(be,ne.identifier,ne,Se,!1)),we},get extensionRuntime(){return(0,n.checkProposedApiEnabled)(ne,"extensionRuntime"),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(ne)},get messagePassingProtocol(){if(!ye){if(!V)return;const ee=h.Event.buffer(h.Event.fromDOMEventEmitter(V,"message",G=>G.data));V.start(),ye={onDidReceiveMessage:ee,postMessage:V.postMessage.bind(V)}}return ye}})})}static _callActivate(ne,J,N,W,he){return N=N||{activate:void 0,deactivate:void 0},this._callActivateOptional(ne,J,N,W,he).then(Se=>new _.ActivatedExtension(!1,null,he.build(),N,Se,W.subscriptions))}static _callActivateOptional(ne,J,N,W,he){if(typeof N.activate=="function")try{he.activateCallStart(),ne.trace(`ExtensionService#_callActivateOptional ${J.value}`);const Se=typeof global=="object"?global:self,be=N.activate.apply(Se,[W]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(be).then(we=>(he.activateResolveStop(),we))}catch(Se){return Promise.reject(Se)}else return Promise.resolve(N)}_activateOneStartupFinished(ne,J){this._activateById(ne.identifier,{startup:!1,extensionId:ne.identifier,activationEvent:J}).then(void 0,N=>{this._logService.error(N)})}_activateAllStartupFinishedDeferred(ne,J=0){const W=Date.now();(0,$.setTimeout0)(()=>{for(let he=J;he<ne.length;he+=1){const Se=ne[he];for(const be of Se.activationEvents??[])if(be==="onStartupFinished")if(Date.now()-W>50){this._activateAllStartupFinishedDeferred(ne,he);break}else this._activateOneStartupFinished(Se,be)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(d.getMarks()),this._extHostConfiguration.getConfigProvider().then(ne=>{const J=ne.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),N=this._myRegistry.getAllExtensionDescriptions();if(J)this._activateAllStartupFinishedDeferred(N);else for(const W of N)if(W.activationEvents)for(const he of W.activationEvents)he==="onStartupFinished"&&this._activateOneStartupFinished(W,he)})}_handleEagerExtensions(){const ne=this._activateByEvent("*",!0).then(void 0,Se=>{this._logService.error(Se)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Se=>this._handleWorkspaceContainsEagerExtensions(Se.added)));const J=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],N=this._handleWorkspaceContainsEagerExtensions(J),W=this._handleRemoteResolverEagerExtensions(),he=Promise.all([W,ne,N]).then(()=>{});return Promise.race([he,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),he}_handleWorkspaceContainsEagerExtensions(ne){return ne.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(J=>this._handleWorkspaceContainsEagerExtension(ne,J))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ne,J){if(this.isActivated(J.identifier))return;const N=!this._initData.remote.isRemote&&!!this._initData.remote.authority,W={logService:this._logService,folders:ne.map(Se=>Se.uri),forceUsingSearch:N||!this._hostUtils.fsExists,exists:Se=>this._hostUtils.fsExists(Se.fsPath),checkExists:(Se,be,we)=>this._mainThreadWorkspaceProxy.$checkExists(Se,be,we)},he=await(0,E.checkActivateWorkspaceContainsExtension)(W,J);if(he)return this._activateById(J.identifier,{startup:!0,extensionId:J.identifier,activationEvent:he.activationEvent}).then(void 0,Se=>this._logService.error(Se))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ne){throw console.error(ne),ne}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ne,extensionTestsLocationURI:J}=this._initData.environment;if(!ne||!J)throw new Error(C.localize(0,null));const N=await this._loadCommonJSModule(null,J,new _.ExtensionActivationTimesBuilder(!1));if(!N||typeof N.run!="function")throw new Error(C.localize(1,null,J.toString()));return new Promise((W,he)=>{const Se=(ye,V)=>{ye?he(ye):W(typeof V=="number"&&V>0?1:0)},be=(0,A.originalFSPath)(J),we=N.run(be,Se);we&&we.then&&we.then(()=>{W(0)}).catch(ye=>{he(ye instanceof Error&&ye.stack?ye.stack:String(ye))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,T.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ne,J){return this._resolvers[ne]=J,(0,f.toDisposable)(()=>{delete this._resolvers[ne]})}async getRemoteExecServer(ne){const{resolver:J}=await this._activateAndGetResolver(ne);return J?.resolveExecServer?.(ne,{resolveAttempt:0})}async _activateAndGetResolver(ne){const J=ne.indexOf("+");if(J===-1)throw new t.RemoteAuthorityResolverError("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const N=ne.substr(0,J);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${N}`,!1),{authorityPrefix:N,resolver:this._resolvers[N]}}async $resolveAuthority(ne,J){const N=x.StopWatch.create(!1),W=()=>`[resolveAuthority(${(0,r.getRemoteAuthorityPrefix)(ne)},${J})][${N.elapsed()}ms] `,he=Z=>this._logService.info(`${W()}${Z}`),Se=Z=>this._logService.warn(`${W()}${Z}`),be=(Z,oe=void 0)=>this._logService.error(`${W()}${Z}`,oe),we=Z=>{if(Z instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Z._code,message:Z._message,detail:Z._detail}};throw Z},ye=async Z=>{he(`activating resolver for ${Z}...`);const{resolver:oe,authorityPrefix:Q}=await this._activateAndGetResolver(Z);if(!oe)throw be(`no resolver for ${Q}`),new t.RemoteAuthorityResolverError(`No remote extension installed to resolve ${Q}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:oe,authorityPrefix:Q,remoteAuthority:Z}},V=ne.split(/@|%40/g).reverse();he(`activating remote resolvers ${V.join(" -> ")}`);let ee;try{ee=await Promise.all(V.map(ye)).catch(async Z=>{if(!(Z instanceof t.RemoteAuthorityResolverError)||Z._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Z;return Se(`resolving nested authorities failed: ${Z.message}`),[await ye(ne)]})}catch(Z){return we(Z)}const G=new T.IntervalTimer;G.cancelAndSet(()=>he("waiting..."),1e3);let Y,de;for(const[Z,{authorityPrefix:oe,resolver:Q,remoteAuthority:ue}]of ee.entries())try{if(Z===ee.length-1)he("invoking final resolve()..."),d.mark(`code/extHost/willResolveAuthority/${oe}`),Y=await Q.resolve(ue,{resolveAttempt:J,execServer:de}),d.mark(`code/extHost/didResolveAuthorityOK/${oe}`),he("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(Q,t.ManagedResolvedAuthority.isManagedResolvedAuthority(Y)?Y:void 0));else{if(he(`invoking resolveExecServer() for ${ue}`),d.mark(`code/extHost/willResolveExecServer/${oe}`),de=await Q.resolveExecServer?.(ue,{resolveAttempt:J,execServer:de}),!de)throw new t.RemoteAuthorityResolverError(`Exec server was not available for ${ue}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);d.mark(`code/extHost/didResolveExecServerOK/${oe}`)}}catch(ve){return d.mark(`code/extHost/didResolveAuthorityError/${oe}`),be("returned an error",ve),G.dispose(),we(ve)}G.dispose();const ke={environmentTunnels:Y.environmentTunnels,features:Y.tunnelFeatures},B={extensionHostEnv:Y.extensionHostEnv,isTrusted:Y.isTrusted,authenticationSession:Y.authenticationSessionForInitializingExtensions?{id:Y.authenticationSessionForInitializingExtensions.id,providerId:Y.authenticationSessionForInitializingExtensions.providerId}:void 0};he(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(Y)?"managed authority":`${Y.host}:${Y.port}`}`);let X;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(Y)){const Z=J;this._extHostManagedSockets.setFactory(Z,Y.makeConnection),X={authority:ne,connectTo:new r.ManagedRemoteConnection(Z),connectionToken:Y.connectionToken}}else X={authority:ne,connectTo:new r.WebSocketRemoteConnection(Y.host,Y.port),connectionToken:Y.connectionToken};return{type:"ok",value:{authority:X,options:B,tunnelInformation:ke}}}async $getCanonicalURI(ne,J){this._logService.info(`$getCanonicalURI invoked for authority (${(0,r.getRemoteAuthorityPrefix)(ne)})`);const{resolver:N}=await this._activateAndGetResolver(ne);if(!N)return null;const W=g.URI.revive(J);if(typeof N.getCanonicalURI>"u")return W;const he=await(0,T.asPromise)(()=>N.getCanonicalURI(W));return he||W}$startExtensionHost(ne){ne.toAdd.forEach(W=>W.extensionLocation=g.URI.revive(W.extensionLocation));const{globalRegistry:J,myExtensions:N}=fe(this._activationEventsReader,this._globalRegistry,this._myRegistry,ne);return this._globalRegistry.set(J.getAllExtensionDescriptions()),this._myRegistry.set(N),this._startExtensionHost()}$activateByEvent(ne,J){return J===1?this._almostReadyToRunExtensions.wait().then(N=>this._activateByEvent(ne,!1)):this._readyToRunExtensions.wait().then(N=>this._activateByEvent(ne,!1))}async $activate(ne,J){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ne)?(await this._activateById(ne,J),!0):!1}async $deltaExtensions(ne){ne.toAdd.forEach(Se=>Se.extensionLocation=g.URI.revive(Se.extensionLocation));const{globalRegistry:J,myExtensions:N}=fe(this._activationEventsReader,this._globalRegistry,this._myRegistry,ne),W=await this._createExtensionPathIndex(N);return(await this.getExtensionPathIndex()).setSearchTree(W),this._globalRegistry.set(J.getAllExtensionDescriptions()),this._myRegistry.set(N),Promise.resolve(void 0)}async $test_latency(ne){return ne}async $test_up(ne){return ne.byteLength}async $test_down(ne){const J=b.VSBuffer.alloc(ne),N=Math.random()%256;for(let W=0;W<ne;W++)J.writeUInt8(N,W);return J}async $updateRemoteConnectionData(ne){this._remoteConnectionData=ne,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=q,e.AbstractExtHostExtensionService=q=K=qe([$e(0,s.IInstantiationService),$e(1,e.IHostUtils),$e(2,u.IExtHostRpcService),$e(3,y.IExtHostWorkspace),$e(4,p.IExtHostConfiguration),$e(5,P.ILogService),$e(6,i.IExtHostInitDataService),$e(7,c.IExtensionStoragePaths),$e(8,S.IExtHostTunnelService),$e(9,l.IExtHostTerminalService),$e(10,F.IExtHostLocalizationService),$e(11,O.IExtHostManagedSockets)],q);function fe(ae,ne,J,N){ae.addActivationEvents(N.addActivationEvents);const W=new o.ExtensionDescriptionRegistry(ae,ne.getAllExtensionDescriptions());W.deltaExtensions(N.toAdd,N.toRemove);const he=new m.ExtensionIdentifierSet(J.getAllExtensionDescriptions().map(be=>be.identifier));for(const be of N.myToRemove)he.delete(be);for(const be of N.myToAdd)he.add(be);const Se=H(W,he);return{globalRegistry:W,myExtensions:Se}}function se(ae,ne){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:ne.activationEvent,reasonId:ne.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class ie{#e;#t;#i;constructor(ne,J,N,W,he){this.#e=ne,this.#t=J,this.#i=N.identifier,this.id=N.identifier.value,this.extensionUri=N.extensionLocation,this.extensionPath=L.normalize((0,A.originalFSPath)(N.extensionLocation)),this.packageJSON=N,this.extensionKind=W,this.isFromDifferentExtensionHost=he}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=ie;function H(ae,ne){return ae.getAllExtensionDescriptions().filter(J=>ne.has(J.identifier))}class re{constructor(ne){this._searchTree=ne}setSearchTree(ne){this._searchTree=ne}findSubstr(ne){return this._searchTree.findSubstr(ne)}forEach(ne){return this._searchTree.forEach(ne)}}e.ExtensionPaths=re;class Ee{constructor(ne){this._map=new m.ExtensionIdentifierMap,this.addActivationEvents(ne)}readActivationEvents(ne){return this._map.get(ne.identifier)}addActivationEvents(ne){for(const J of Object.keys(ne))this._map.set(J,ne[J])}}}),define(Ce[339],De([1,0,61,2,5,39,27,25,20,26,6,44,41,17,15]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let n=class{constructor(t,r,s,i,c,u,v){this._apiFactory=t,this._extensionRegistry=r,this._instaService=s,this._extHostConfiguration=i,this._extHostExtensionService=c,this._initData=u,this._logService=v,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),C.mark("code/extHost/willWaitForConfig");const t=await this._extHostConfiguration.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,r,this._extensionRegistry,t,this._logService)),this.register(this._instaService.createInstance(m,r)),this.register(this._instaService.createInstance(o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,r,this._initData.environment.appUriScheme))}register(t){if("nodeModuleName"in t)if(Array.isArray(t.nodeModuleName))for(const r of t.nodeModuleName)this._factories.set(r,t);else this._factories.set(t.nodeModuleName,t);typeof t.alternativeModuleName=="function"&&this._alternatives.push(r=>t.alternativeModuleName(r))}};e.RequireInterceptor=n,e.RequireInterceptor=n=qe([$e(2,P.IInstantiationService),$e(3,A.IExtHostConfiguration),$e(4,k.IExtHostExtensionService),$e(5,g.IExtHostInitDataService),$e(6,_.ILogService)],n);let o=class{static{y=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(t){if(t.environment.appRoot&&y.aliased.size){const r=(0,D.escapeRegExpCharacters)(this.forceForwardSlashes(t.environment.appRoot.fsPath)),s="[a-z0-9_.-]",i=`@${s}+\\/${s}+|${s}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${r}/${c}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(t){if(!this.re)return;const r=this.re.exec(this.forceForwardSlashes(t));if(!r)return;const[,s,i,c]=r,u=y.aliased.get(i);if(u!==void 0)return console.warn(`${i} as been renamed to ${u}, please update your imports`),s+u+c}forceForwardSlashes(t){return t.replace(/\\/g,"/")}};o=y=qe([$e(0,g.IExtHostInitDataService)],o);class a{constructor(t,r,s,i,c){this._apiFactory=t,this._extensionPaths=r,this._extensionRegistry=s,this._configProvider=i,this._logService=c,this.nodeModuleName="vscode",this._extApiImpl=new f.ExtensionIdentifierMap}load(t,r){const s=this._extensionPaths.findSubstr(r);if(s){let i=this._extApiImpl.get(s.identifier);return i||(i=this._apiFactory(s,this._extensionRegistry,this._configProvider),this._extApiImpl.set(s.identifier,i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((c,u)=>i+=`	${u} -> ${c.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let m=class{constructor(t,r,s){this._extensionPaths=t,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(d.MainContext.MainThreadTelemetry);const{environment:i}=s,c=r.getProxy(d.MainContext.MainThreadKeytar);if(i.appRoot){let u=i.appRoot.fsPath;p.platform==="win32"&&(u=u.replace(/\\/g,"/")),u[u.length-1]==="/"&&(u=u.substr(0,u.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${u}/node_modules.asar/keytar`),this.alternativeNames.add(`${u}/node_modules/keytar`)}this._impl={getPassword:(u,v)=>c.$getPassword(u,v),setPassword:(u,v,S)=>c.$setPassword(u,v,S),deletePassword:(u,v)=>c.$deletePassword(u,v),findPassword:u=>c.$findPassword(u),findCredentials(u){return c.$findCredentials(u)}}}load(t,r){const s=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(t){const r=t.length;if(r<=7||!this.alternativeNames)return;const s=r-7;if((t.charAt(s)==="/"||t.charAt(s)==="\\")&&t.endsWith("keytar")&&(t=t.replace(/\\/g,"/"),this.alternativeNames.has(t)))return"keytar"}};m=qe([$e(1,w.IExtHostRpcService),$e(2,g.IExtHostInitDataService)],m);let b=class{constructor(t,r,s){this._extensionPaths=t,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=s.getProxy(d.MainContext.MainThreadTelemetry);const i=s.getProxy(d.MainContext.MainThreadWindow);this._impl=(c,u)=>{const v=L.URI.parse(c);return u?this.callOriginal(c,u):v.scheme==="http"||v.scheme==="https"?i.$openUri(v,c,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this._appUriScheme?i.$openUri(v,c,{}):this.callOriginal(c,u)}}load(t,r,s){const i=this._extensionPaths.findSubstr(r);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=s(t),this._impl}callOriginal(t,r){return this.sendNoForwardTelemetry(),this._original(t,r)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=qe([$e(2,w.IExtHostRpcService)],b)}),define(Ce[53],De([1,0,55,3,14,41,6,65,66,44,7,38,268,39]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,T.createDecorator)("IExtHostVariableResolverProvider");class D extends p.AbstractVariableResolverService{constructor(o,a,m,b,I,t,r){function s(){if(m){const i=m.activeEditor();if(i)return i.document.uri;const c=b.tabGroups.all.find(u=>u.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof P.TextDiffTabInput||c.input instanceof P.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof P.TextTabInput||c.input instanceof P.NotebookEditorTabInput||c.input instanceof P.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:i=>{const c=t.folders.filter(u=>u.name===i);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,c)=>I.getConfiguration(void 0,i).get(c),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=s();if(i)return d.normalize(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const i=s();if(i){const c=a.getWorkspaceFolder(i);if(c)return d.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(m){const i=m.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(m){const i=m.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>o.getExtension(i)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(A.env))}}let y=class extends L.Disposable{constructor(o,a,m,b,I){super(),this.extensionService=o,this.workspaceService=a,this.editorService=m,this.configurationService=b,this.editorTabs=I,this._resolver=new C.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),s={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async i=>{s.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new D(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,s,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=y,e.ExtHostVariableResolverProviderService=y=qe([$e(0,g.IExtHostExtensionService),$e(1,k.IExtHostWorkspace),$e(2,f.IExtHostDocumentsAndEditors),$e(3,_.IExtHostConfiguration),$e(4,w.IExtHostEditorTabs)],y)}),define(Ce[94],De([1,0,13,4,2,6,5,66,44,20,7,38,138,261,39,53]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,A.createDecorator)("IExtHostDebugService");let n=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(r,s,i,c,u,v){this._workspaceService=s,this._extensionService=i,this._configurationService=c,this._editorTabs=u,this._variableResolver=v,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new L.Emitter,this._onDidTerminateDebugSession=new L.Emitter,this._onDidChangeActiveDebugSession=new L.Emitter,this._onDidReceiveDebugSessionCustomEvent=new L.Emitter,this._debugServiceProxy=r.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new L.Emitter,this._onDidChangeStackFrameFocus=new L.Emitter,this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(S=>{S.onDidChange(l=>{this.registerAllDebugTypes(S)}),this.registerAllDebugTypes(S)})}asDebugSourceUri(r,s){const i=r;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let c=`debug:${encodeURIComponent(i.path||"")}`,u="?";return s&&(c+=`${u}session=${encodeURIComponent(s.id)}`,u="&"),c+=`${u}ref=${i.sourceReference}`,d.URI.parse(c)}else{if(i.path)return d.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const s=[];for(const i of r.getAllExtensionDescriptions())if(i.contributes){const c=i.contributes.debuggers;if(c&&c.length>0)for(const u of c)(0,_.isDebuggerMainContribution)(u)&&s.push(u.type)}this._debugServiceProxy.$registerDebugTypes(s)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const r=[];return this._breakpoints.forEach(s=>r.push(s)),r}addBreakpoints(r){const s=r.filter(u=>{const v=u.id;return this._breakpoints.has(v)?!1:(this._breakpoints.set(v,u),!0)});this.fireBreakpointChanges(s,[],[]);const i=[],c=new Map;for(const u of s)if(u instanceof P.SourceBreakpoint){let v=c.get(u.location.uri.toString());v||(v={type:"sourceMulti",uri:u.location.uri,lines:[]},c.set(u.location.uri.toString(),v),i.push(v)),v.lines.push({id:u.id,enabled:u.enabled,condition:u.condition,hitCondition:u.hitCondition,logMessage:u.logMessage,line:u.location.range.start.line,character:u.location.range.start.character})}else u instanceof P.FunctionBreakpoint&&i.push({type:"function",id:u.id,enabled:u.enabled,hitCondition:u.hitCondition,logMessage:u.logMessage,condition:u.condition,functionName:u.functionName});return this._debugServiceProxy.$registerBreakpoints(i)}removeBreakpoints(r){const s=r.filter(v=>this._breakpoints.delete(v.id));this.fireBreakpointChanges([],s,[]);const i=s.filter(v=>v instanceof P.SourceBreakpoint).map(v=>v.id),c=s.filter(v=>v instanceof P.FunctionBreakpoint).map(v=>v.id),u=s.filter(v=>v instanceof P.DataBreakpoint).map(v=>v.id);return this._debugServiceProxy.$unregisterBreakpoints(i,c,u)}startDebugging(r,s,i){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,s,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,i){if(!s)return new P.Disposable(()=>{});const c=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:c,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,i,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,c),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(u=>u.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(r,s,i){if(!i)return new P.Disposable(()=>{});if(!this.definesDebugType(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:c,factory:i}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,c),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(u=>u.factory!==i),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new P.Disposable(()=>{});const i=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:i,factory:s}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(c=>c.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let i;const c=await this.getFolder(r);return c&&(i={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(i,s)}createDebugAdapter(r,s){if(r.type==="implementation")return new b(r.implementation)}createSignService(){}async $startDASession(r,s){const i=this,c=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(c.type),c).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const v=this.convertToDto(u),S=this.createDebugAdapter(v,c);if(!S)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const l=S;return this._debugAdapters.set(r,l),this.getDebugAdapterTrackers(c).then(h=>(h&&this._debugAdaptersTrackers.set(r,h),l.onMessage(async E=>{if(E.type==="request"&&E.command==="handshake"){const R=E,M={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(R.arguments.value);M.body={signature:U},l.sendResponse(M)}else throw new Error("no signer")}catch(U){M.success=!1,M.message=U.message,l.sendResponse(M)}}else h&&h.onDidSendMessage&&h.onDidSendMessage(E),E=(0,_.convertToVSCPaths)(E,!0),i._debugServiceProxy.$acceptDAMessage(r,E)}),l.onError(E=>{h&&h.onError&&h.onError(E),this._debugServiceProxy.$acceptDAError(r,E.name,E.message,E.stack)}),l.onExit(E=>{h&&h.onExit&&h.onExit(E??void 0,void 0),this._debugServiceProxy.$acceptDAExit(r,E??void 0,void 0)}),h&&h.onWillStartSession&&h.onWillStartSession(),l.startSession()))})}$sendDAMessage(r,s){s=(0,_.convertToDAPaths)(s,!1);const i=this._debugAdaptersTrackers.get(r);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(s),this._debugAdapters.get(r)?.sendMessage(s)}$stopDASession(r){const s=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const i=this._debugAdapters.get(r);return this._debugAdapters.delete(r),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],i=[],c=[];if(r.added)for(const u of r.added){const v=u.id;if(v&&!this._breakpoints.has(v)){let S;if(u.type==="function")S=new P.FunctionBreakpoint(u.functionName,u.enabled,u.condition,u.hitCondition,u.logMessage);else if(u.type==="data")S=new P.DataBreakpoint(u.label,u.dataId,u.canPersist,u.enabled,u.hitCondition,u.condition,u.logMessage);else{const l=d.URI.revive(u.uri);S=new P.SourceBreakpoint(new P.Location(l,new P.Position(u.line,u.character)),u.enabled,u.condition,u.hitCondition,u.logMessage)}(0,P.setBreakpointId)(S,v),this._breakpoints.set(v,S),s.push(S)}}if(r.removed)for(const u of r.removed){const v=this._breakpoints.get(u);v&&(this._breakpoints.delete(u),i.push(v))}if(r.changed){for(const u of r.changed)if(u.id){const v=this._breakpoints.get(u.id);if(v){if(v instanceof P.FunctionBreakpoint&&u.type==="function"){const S=v;S.enabled=u.enabled,S.condition=u.condition,S.hitCondition=u.hitCondition,S.logMessage=u.logMessage,S.functionName=u.functionName}else if(v instanceof P.SourceBreakpoint&&u.type==="source"){const S=v;S.enabled=u.enabled,S.condition=u.condition,S.hitCondition=u.hitCondition,S.logMessage=u.logMessage,S.location=new P.Location(d.URI.revive(u.uri),new P.Position(u.line,u.character))}c.push(v)}}}this.fireBreakpointChanges(s,i,c)}async $acceptStackFrameFocus(r){let s;const i=r.sessionId?await this.getSession(r.sessionId):void 0;if(!i)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?s=new P.ThreadFocus(i,r.threadId):s=new P.StackFrameFocus(i,r.threadId,r.frameId),this._stackFrameFocus=s,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(r,s,i){return(0,C.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const u=await this.getFolder(s);return c.provideDebugConfigurations(u,i)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(r,s,i,c){return(0,C.asPromise)(async()=>{const u=this.getConfigProviderByHandle(r);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const v=await this.getFolder(s);return u.resolveDebugConfiguration(v,i,c)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,i,c){return(0,C.asPromise)(async()=>{const u=this.getConfigProviderByHandle(r);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const v=await this.getFolder(s);return u.resolveDebugConfigurationWithSubstitutedVariables(v,i,c)})}async $provideDebugAdapter(r,s){const i=this.getAdapterDescriptorFactoryByHandle(r);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.getSession(s);return this.getAdapterDescriptor(i,c).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.convertToDto(u)})}async $acceptDebugSessionStarted(r){const s=await this.getSession(r);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.getSession(r);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,s){(await this.getSession(r))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const c={session:await this.getSession(r),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(c)}convertToDto(r){if(r instanceof P.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof P.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const s=this._adapterFactories.filter(i=>i.type===r);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(r){const s=this._adapterFactories.filter(i=>i.handle===r);if(s.length>0)return s[0].factory}getConfigProviderByHandle(r){const s=this._configProviders.filter(i=>i.handle===r);if(s.length>0)return s[0].provider}definesDebugType(r,s){if(r.contributes){const i=r.contributes.debuggers;if(i&&i.length>0){for(const c of i)if(c.label&&c.type&&c.type===s)return!0}}return!1}getDebugAdapterTrackers(r){const i=r.configuration.type,c=this._trackerFactories.filter(u=>u.type===i||u.type==="*").map(u=>(0,C.asPromise)(()=>u.factory.createDebugAdapterTracker(r)).then(v=>v,v=>null));return Promise.race([Promise.all(c).then(u=>{const v=u.filter(S=>!!S);if(v.length>0)return new m(v)}),new Promise(u=>setTimeout(()=>u(void 0),1e3))]).catch(u=>{})}async getAdapterDescriptor(r,s){const i=s.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new P.DebugAdapterServer(i));if(r){const u=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>r.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,u))).then(v=>{if(v)return v})}const c=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,c))}daExecutableFromPackage(r,s){}fireBreakpointChanges(r,s,i){(r.length>0||s.length>0||i.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:s,changed:i}))}async getSession(r){if(r)if(typeof r=="string"){const s=this._debugSessions.get(r);if(s)return s}else{let s=this._debugSessions.get(r.id);if(!s){const i=await this.getFolder(r.folderUri),c=r.parent?this._debugSessions.get(r.parent):void 0;s=new o(this._debugServiceProxy,r.id,r.type,r.name,i,r.configuration,c),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(r){if(r){const s=d.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=n,e.ExtHostDebugServiceBase=n=qe([$e(0,g.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,w.IExtHostExtensionService),$e(3,D.IExtHostConfiguration),$e(4,f.IExtHostEditorTabs),$e(5,y.IExtHostVariableResolverProvider)],n);class o{constructor(r,s,i,c,u,v,S){this._debugServiceProxy=r,this._id=s,this._type=i,this._name=c,this._workspaceFolder=u,this._configuration=v,this._parentSession=S}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,s)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=o;class a{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=a;class m{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.trackers.forEach(i=>i.onExit?i.onExit(r,s):void 0)}}class b extends p.AbstractDebugAdapter{constructor(r){super(),this.implementation=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let I=class extends n{constructor(r,s,i,c,u,v){super(r,s,i,c,u,v)}};e.WorkerExtHostDebugService=I,e.WorkerExtHostDebugService=I=qe([$e(0,g.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,w.IExtHostExtensionService),$e(3,D.IExtHostConfiguration),$e(4,f.IExtHostEditorTabs),$e(5,y.IExtHostVariableResolverProvider)],I)}),define(Ce[340],De([1,0,8,61,2,5,332,17,102,103,26,231,20,62,44,88]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class n{static async installEarlyHandler(m){Error.stackTraceLimit=100;const b=m.get(f.ILogService),t=m.get(p.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);C.setUnexpectedErrorHandler(r=>{b.error(r);const s=C.transformErrorForSerialization(r);t.$onUnexpectedError(s)})}static async installFullHandler(m){const b=m.get(f.ILogService),I=m.get(p.IExtHostRpcService),t=m.get(D.IExtHostExtensionService),r=m.get(y.IExtHostTelemetry),s=I.getProxy(A.MainContext.MainThreadExtensionService),i=I.getProxy(A.MainContext.MainThreadErrors),c=await t.getExtensionPathIndex(),u=new WeakMap;function v(h,E){if(u.has(h))return u.get(h).stack;let R="",M,U;for(const x of E)R+=`
	at ${x.toString()}`,U=x.getFileName(),!M&&U&&(M=c.findSubstr(d.URI.file(U)));const F=`${h.name||"Error"}: ${h.message||""}${R}`;return u.set(h,{extensionIdentifier:M?.identifier,stack:F}),F}const S=Symbol("prepareStackTrace wrapped");let l=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return l},set(h){if(h===v||!h||h[S]){l=h||v;return}l=function(E,R){return v(E,R),h.call(Error,E,R)},Object.assign(l,{[S]:!0})}}),C.setUnexpectedErrorHandler(h=>{b.error(h);const E=C.transformErrorForSerialization(h),R=u.get(h);if(!R?.extensionIdentifier){i.$onUnexpectedError(E);return}s.$onExtensionRuntimeError(R.extensionIdentifier,E);const M=r.onExtensionError(R.extensionIdentifier,h);b.trace("forwarded error to extension?",M,R)})}}e.ErrorHandler=n;class o{constructor(m,b,I,t,r){this._hostUtils=I,this._rpcProtocol=new T.RPCProtocol(m,null,t),b=o._transform(b,this._rpcProtocol);const s=new g.ServiceCollection(...(0,w.getSingletonServiceDescriptors)());s.set(P.IExtHostInitDataService,{_serviceBrand:void 0,...b,messagePorts:r}),s.set(p.IExtHostRpcService,new p.ExtHostRpcService(this._rpcProtocol)),s.set(_.IURITransformerService,new _.URITransformerService(t)),s.set(D.IHostUtils,I);const i=new k.InstantiationService(s,!0);i.invokeFunction(n.installEarlyHandler),this._logService=i.invokeFunction(c=>c.get(f.ILogService)),L.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",b),this._extensionService=i.invokeFunction(c=>c.get(D.IExtHostExtensionService)),this._extensionService.initialize(),i.invokeFunction(n.installFullHandler)}async asBrowserUri(m){const b=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return d.URI.revive(await b.$asBrowserUri(m))}terminate(m){this._extensionService.terminate(m)}static _transform(m,b){m.allExtensions.forEach(t=>{t.extensionLocation=d.URI.revive(b.transformIncomingURIs(t.extensionLocation))}),m.environment.appRoot=d.URI.revive(b.transformIncomingURIs(m.environment.appRoot));const I=m.environment.extensionDevelopmentLocationURI;return I&&(m.environment.extensionDevelopmentLocationURI=I.map(t=>d.URI.revive(b.transformIncomingURIs(t)))),m.environment.extensionTestsLocationURI=d.URI.revive(b.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=d.URI.revive(b.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=d.URI.revive(b.transformIncomingURIs(m.environment.workspaceStorageHome)),m.environment.extensionTelemetryLogResource=d.URI.revive(b.transformIncomingURIs(m.environment.extensionTelemetryLogResource)),m.nlsBaseUrl=d.URI.revive(b.transformIncomingURIs(m.nlsBaseUrl)),m.logsLocation=d.URI.revive(b.transformIncomingURIs(m.logsLocation)),m.workspace=b.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=o}),define(Ce[341],De([1,0,13,9,209,225,136,94,66,44,20,43,7,53,38,262,263,39]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let a=class extends f.ExtHostDebugServiceBase{constructor(r,s,i,c,u,v,S){super(r,s,i,c,v,S),this._terminalService=u,this._integratedTerminalInstances=new I}createDebugAdapter(r,s){switch(r.type){case"server":return new y.SocketDebugAdapter(r);case"pipeServer":return new y.NamedPipeDebugAdapter(r);case"executable":return new y.ExecutableDebugAdapter(r,s.type)}return super.createDebugAdapter(r,s)}daExecutableFromPackage(r,s){const i=y.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),r.type);if(i)return new p.DebugAdapterExecutable(i.command,i.args,i.options)}createSignService(){return new T.SignService}async $runInTerminal(r,s){if(r.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(F=>{this._integratedTerminalInstances.onTerminalClosed(F)}));const i=await this._configurationService.getConfigProvider(),c=this._terminalService.getDefaultShell(!0),u=this._terminalService.getDefaultShellArgs(!0),v=r.title||d.localize(0,null),S=JSON.stringify({shell:c,shellArgs:u});let l=await this._integratedTerminalInstances.checkout(S,v),h,E=!1;if(l)h=r.cwd;else{const F={shellPath:c,shellArgs:u,cwd:r.cwd,name:v,iconPath:new p.ThemeIcon("debug")};E=!0,l=this._terminalService.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(l,S)}l.show(!0);const R=await l.processId;E?await new Promise(F=>setTimeout(F,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?l.sendText("cls"):c.indexOf("bash")>=0?l.sendText("clear"):L.isWindows?l.sendText("cls"):l.sendText("clear"));const M=(0,n.prepareCommand)(c,r.args,!!r.argsCanBeInterpretedByShell,h,r.env);l.sendText(M);const U=this.onDidTerminateDebugSession(F=>{F.id===s&&(this._integratedTerminalInstances.free(l),U.dispose())});return R}else if(r.kind==="external")return b(r,await this._configurationService.getConfigProvider());return super.$runInTerminal(r,s)}};e.ExtHostDebugService=a,e.ExtHostDebugService=a=qe([$e(0,P.IExtHostRpcService),$e(1,D.IExtHostWorkspace),$e(2,g.IExtHostExtensionService),$e(3,o.IExtHostConfiguration),$e(4,k.IExtHostTerminalService),$e(5,w.IExtHostEditorTabs),$e(6,_.IExtHostVariableResolverProvider)],a);let m;function b(t,r){if(!m)if(L.isWindows)m=new A.WindowsExternalTerminalService;else if(L.isMacintosh)m=new A.MacExternalTerminalService;else if(L.isLinux)m=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=r.getConfiguration("terminal");return m.runInTerminal(t.title,t.cwd,t.args,t.env||{},s.external||{})}class I{constructor(){this._terminalInstances=new Map}static{this.minUseDelay=1e3}async checkout(r,s){const c=[...this._terminalInstances.entries()].map(([u,v])=>(0,C.createCancelablePromise)(async S=>{if(u.name!==s||v.lastUsedAt!==-1&&await(0,n.hasChildProcesses)(await u.processId))return null;const l=Date.now();return v.lastUsedAt+I.minUseDelay>l||S.isCancellationRequested||v.config!==r?null:(v.lastUsedAt=l,u)}));return await(0,C.firstParallel)(c,u=>!!u)}insert(r,s){this._terminalInstances.set(r,{lastUsedAt:Date.now(),config:s})}free(r){const s=this._terminalInstances.get(r);s&&(s.lastUsedAt=-1)}onTerminalClosed(r){this._terminalInstances.delete(r)}}}),define(Ce[342],De([1,0,14,2,100,38,65,39,51,43,20,26,93,16,17,89,24,59,53]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let m=class extends p.ExtHostTaskBase{constructor(I,t,r,s,i,c,u,v,S){super(I,t,r,s,i,c,u,v),this.workspaceService=r,this.variableResolver=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(_.Schemas.vscodeRemote,{scheme:_.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(_.Schemas.file,{scheme:_.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(I,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const s=p.TaskHandleDTO.from(r,this.workspaceService),i=await this._proxy.$getTaskExecution(s);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.getTaskExecution(i,t);return this._proxy.$executeTask(s).catch(()=>{}),c}else{const s=p.TaskDTO.from(t,I);if(s===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(s.execution)&&await this.addCustomExecution(s,t,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(s),t);return this._proxy.$executeTask(s).catch(()=>{}),i}}provideTasksInternal(I,t,r,s){const i=[];if(s)for(const c of s){this.checkDeprecation(c,r),(!c.definition||!I[c.definition.type])&&this._logService.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const u=p.TaskDTO.from(c,r.extension);u&&(i.push(u),p.CustomExecutionDTO.is(u.execution)&&t.push(this.addCustomExecution(u,c,!0)))}return{tasks:i,extension:r.extension}}async resolveTaskInternal(I){return I}async getAFolder(I){let t=I&&I.length>0?I[0]:void 0;if(!t){const r=L.URI.file((0,o.homedir)());t=new w.WorkspaceFolder({uri:r,name:n.basename(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(I,t){const r=L.URI.revive(I),s={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(r),c=await this._workspaceProvider.getWorkspaceFolders2()??[],u=await this.variableResolver.getResolver(),v=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(c);for(const S of t.variables)s.variables[S]=await u.resolveAsync(v,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(C.delimiter);for(let l=0;l<S.length;l++)S[l]=await u.resolveAsync(v,S[l])}s.process=await d.win32.findExecutable(await u.resolveAsync(v,t.process.name),t.process.cwd!==void 0?await u.resolveAsync(v,t.process.cwd):void 0,S)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(I,t,r){return d.win32.findExecutable(I,t,r)}};e.ExtHostTask=m,e.ExtHostTask=m=qe([$e(0,P.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,T.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,g.IExtHostTerminalService),$e(6,D.ILogService),$e(7,y.IExtHostApiDeprecationService),$e(8,a.IExtHostVariableResolverProvider)],m)}),define(Ce[343],De([1,0,59,53]),function(me,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class d extends L.ExtHostVariableResolverProviderService{homeDir(){return(0,C.homedir)()}}e.NodeExtHostVariableResolverProviderService=d}),define(Ce[150],De([1,0,18,13,22,45,16,14,24,2,36]),function(me,e,C,L,d,A,T,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(a,m,b,I){this.query=a,this.provider=m,this.fileUtils=b,this.processType=I,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,m){const b=this.query.folderQueries||[],I=new d.CancellationTokenSource;return m.onCancellationRequested(()=>I.cancel()),new Promise((t,r)=>{this.collector=new _(a);let s=!1;const i=(c,u)=>{if(!s&&!this.isLimitHit){const v=this.resultSize(c);y(c)&&typeof this.query.maxResults=="number"&&this.resultCount+v>this.query.maxResults&&(this.isLimitHit=!0,s=!0,I.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const S=this.resultSize(c);this.resultCount+=S,(S>0||!y(c))&&this.collector.add(c,u)}};Promise.all(b.map((c,u)=>this.searchInFolder(c,v=>i(v,u),I.token))).then(c=>{I.dispose(),this.collector.flush();const u=c.some(v=>!!v&&!!v.limitHit);t({limitHit:this.isLimitHit||u,messages:(0,C.flatten)(c.map(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[])),stats:{type:this.processType}})},c=>{I.dispose();const u=(0,A.toErrorMessage)(c);r(new Error(u))})})}resultSize(a){return y(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,m){const b=Array.isArray(a.ranges)?a.ranges:[a.ranges],I=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:b.slice(0,m),preview:{matches:I.slice(0,m),text:a.preview.text},uri:a.uri}}async searchInFolder(a,m,b){const I=new P.QueryGlobTester(this.query,a),t=[],r={report:c=>{if(!this.validateProviderResult(c))return;const u=a.folder.scheme===T.Schemas.file?(0,P.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(w.dirname(c.uri))):void 0,v=w.relativePath(a.folder,c.uri);if(v){const S=I.includedInQuery(v,f.basename(v),u);(0,L.isThenable)(S)?t.push(S.then(l=>{l&&m(c)})):S&&m(c)}}},s=this.getSearchOptionsForFolder(a),i=await this.provider.provideTextSearchResults(p(this.query.contentPattern),s,r,b);return t.length&&await Promise.all(t),i}validateProviderResult(a){if(y(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const m=(0,P.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),b=(0,P.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),I={folder:g.URI.from(a.folder),excludes:b,includes:m,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return I.usePCRE2=this.query.usePCRE2,I}}e.TextSearchManager=k;function p(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class _{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new n(512,m=>this.sendItems(m))}add(a,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!w.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(D(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=_;function D(o){return y(o)?{preview:{matches:(0,C.mapArrayOrNot)(o.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:o.preview.text},ranges:(0,C.mapArrayOrNot)(o.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function y(o){return!!o.preview}e.extensionResultIsMatch=y;class n{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(a,m){this.maxBatchSize=a,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,m){a&&this.addItemToBatch(a,m)}addItems(a,m){a&&this.addItemsToBatch(a,m)}addItemToBatch(a,m){this.batch.push(a),this.batchSize+=m,this.onUpdate()}addItemsToBatch(a,m){this.batch=this.batch.concat(a),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<n.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},n.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=n}),define(Ce[95],De([1,0,3,5,6,336,20,62,17,2,150]),function(me,e,C,L,d,A,T,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,d.createDecorator)("IExtHostSearch");let k=class{constructor(y,n,o){this.extHostRpc=y,this._uriTransformer=n,this._logService=o,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}registerTextSearchProvider(y,n){if(this._textSearchUsedSchemes.has(y))throw new Error(`a text search provider for the scheme '${y}' is already registered`);this._textSearchUsedSchemes.add(y);const o=this._handlePool++;return this._textSearchProvider.set(o,n),this._proxy.$registerTextSearchProvider(o,this._transformScheme(y)),(0,C.toDisposable)(()=>{this._textSearchUsedSchemes.delete(y),this._textSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}registerFileSearchProvider(y,n){if(this._fileSearchUsedSchemes.has(y))throw new Error(`a file search provider for the scheme '${y}' is already registered`);this._fileSearchUsedSchemes.add(y);const o=this._handlePool++;return this._fileSearchProvider.set(o,n),this._proxy.$registerFileSearchProvider(o,this._transformScheme(y)),(0,C.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(y),this._fileSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(y,n,o,a){const m=p(o),b=this._fileSearchProvider.get(y);if(b)return this._fileSearchManager.fileSearch(m,b,I=>{this._proxy.$handleFileMatch(y,n,I.map(t=>t.resource))},a);throw new Error("unknown provider: "+y)}$clearCache(y){return this._fileSearchManager.clearCache(y),Promise.resolve(void 0)}$provideTextSearchResults(y,n,o,a){const m=this._textSearchProvider.get(y);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${y}`);const b=p(o);return this.createTextSearchManager(b,m).search(t=>this._proxy.$handleTextMatch(y,n,t),a)}$enableExtensionHostSearch(){}createTextSearchManager(y,n){return new P.TextSearchManager(y,n,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.ExtHostSearch=k,e.ExtHostSearch=k=qe([$e(0,T.IExtHostRpcService),$e(1,f.IURITransformerService),$e(2,w.ILogService)],k);function p(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(_),extraFileResources:D.extraFileResources&&D.extraFileResources.map(y=>g.URI.revive(y))}}e.reviveQuery=p;function _(D){return{...D,folder:g.URI.revive(D.folder)}}}),define(Ce[344],De([1,0,22,8,4,40,2,129,123,165,181,30,5,110,292,291,33,293,39,295,296,297,270,298,65,44,300,301,306,307,308,149,274,314,315,317,114,43,319,278,10,7,85,322,91,148,38,25,266,305,60,146,93,94,95,17,62,20,26,309,264,68,89,285,320,90,67,325,323,324,286,52,318,321,113,66,88,310,92,311,16,132,273,253,303,3,27,260,111,249,312,313,287,302,272,304,112,316,288,289,290,284,299]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m,b,I,t,r,s,i,c,u,v,S,l,h,E,R,M,U,F,x,$,O,K,q,fe,se,ie,H,re,Ee,ae,ne,J,N,W,he,Se,be,we,ye,V,ee,G,Y,de,ke,B,X,Z,oe,Q,ue,ve,xe,We,Ze,Qe,it,et,Pe,Me,ze,Re,Xe,le,ce,Ie,He,Ue,Ye,rt,ot,pt,It,Xt,Wt,bt,Ot,Nt,qt,At,Rt,xt,Bt,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function $t(ct){const dt=ct.get(V.IExtHostInitDataService),jt=ct.get(xe.IExtHostFileSystemInfo),Tt=ct.get(Z.IExtHostConsumerFileSystem),_t=ct.get(i.IExtHostExtensionService),ft=ct.get(re.IExtHostWorkspace),kt=ct.get(et.IExtHostTelemetry),Mt=ct.get(a.IExtHostConfiguration),St=ct.get(we.IURITransformerService),je=ct.get(ye.IExtHostRpcService),Le=ct.get(F.IExtHostStorage),Fe=ct.get(X.IExtensionStoragePaths),Te=ct.get(be.ILoggerService),te=ct.get(be.ILogService),Oe=ct.get(Y.IExtHostTunnelService),Ve=ct.get(de.IExtHostApiDeprecationService),Je=ct.get(H.IExtHostWindow),Ge=ct.get(Qe.IExtHostSecretState),nt=ct.get(it.IExtHostEditorTabs),vt=ct.get(Nt.IExtHostManagedSockets);je.set(p.ExtHostContext.ExtHostFileSystemInfo,jt),je.set(p.ExtHostContext.ExtHostLogLevelServiceShape,Te),je.set(p.ExtHostContext.ExtHostWorkspace,ft),je.set(p.ExtHostContext.ExtHostConfiguration,Mt),je.set(p.ExtHostContext.ExtHostExtensionService,_t),je.set(p.ExtHostContext.ExtHostStorage,Le),je.set(p.ExtHostContext.ExtHostTunnelService,Oe),je.set(p.ExtHostContext.ExtHostWindow,Je),je.set(p.ExtHostContext.ExtHostSecretState,Ge),je.set(p.ExtHostContext.ExtHostTelemetry,kt),je.set(p.ExtHostContext.ExtHostEditorTabs,nt),je.set(p.ExtHostContext.ExtHostManagedSockets,vt);const yt=je.set(p.ExtHostContext.ExtHostDecorations,ct.get(N.IExtHostDecorations)),Et=je.set(p.ExtHostContext.ExtHostDocumentsAndEditors,ct.get(s.IExtHostDocumentsAndEditors)),lt=je.set(p.ExtHostContext.ExtHostCommands,ct.get(n.IExtHostCommands)),gt=je.set(p.ExtHostContext.ExtHostTerminalService,ct.get(x.IExtHostTerminalService)),Ct=je.set(p.ExtHostContext.ExtHostDebugService,ct.get(he.IExtHostDebugService)),mi=je.set(p.ExtHostContext.ExtHostSearch,ct.get(Se.IExtHostSearch)),Vt=je.set(p.ExtHostContext.ExtHostTask,ct.get(W.IExtHostTask)),yi=je.set(p.ExtHostContext.ExtHostOutputService,ct.get(h.IExtHostOutputService)),zt=je.set(p.ExtHostContext.ExtHostLocalization,ct.get(rt.IExtHostLocalizationService)),gi=je.set(p.ExtHostContext.ExtHostUrls,new se.ExtHostUrls(je)),Pt=je.set(p.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(je,Et)),_i=je.set(p.ExtHostContext.ExtHostDocumentContentProviders,new I.ExtHostDocumentContentProvider(je,Et,te)),Wi=je.set(p.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(te,Pt,je.getProxy(p.MainContext.MainThreadBulkEdits))),Dt=je.set(p.ExtHostContext.ExtHostNotebook,new ee.ExtHostNotebookController(je,lt,Et,Pt,Tt)),ti=je.set(p.ExtHostContext.ExtHostNotebookDocuments,new ce.ExtHostNotebookDocuments(Dt)),pi=je.set(p.ExtHostContext.ExtHostNotebookEditors,new le.ExtHostNotebookEditors(te,Dt)),si=je.set(p.ExtHostContext.ExtHostNotebookKernels,new Pe.ExtHostNotebookKernels(je,dt,Dt,lt,te)),Ci=je.set(p.ExtHostContext.ExtHostNotebookRenderers,new ze.ExtHostNotebookRenderers(je,Dt)),Di=je.set(p.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new bt.ExtHostNotebookDocumentSaveParticipant(te,Dt,je.getProxy(p.MainContext.MainThreadBulkEdits))),Lt=je.set(p.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(je,Et)),vi=je.set(p.ExtHostContext.ExtHostTreeViews,new O.ExtHostTreeViews(je.getProxy(p.MainContext.MainThreadTreeViews),lt,te)),Ii=je.set(p.ExtHostContext.ExtHostEditorInsets,new ae.ExtHostEditorInsets(je.getProxy(p.MainContext.MainThreadEditorInsets),Lt,dt.remote)),oi=je.set(p.ExtHostContext.ExtHostDiagnostics,new m.ExtHostDiagnostics(je,te,jt,Et)),ai=je.set(p.ExtHostContext.ExtHostLanguages,new S.ExtHostLanguages(je,Pt,lt.converter,St)),ut=je.set(p.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(je,St,Pt,lt,oi,te,Ve,kt)),Hi=je.set(p.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(je,ut)),Qt=je.set(p.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(je,te,Et)),ii=je.set(p.ExtHostContext.ExtHostQuickOpen,(0,R.createExtHostQuickOpen)(je,ft,lt)),Ei=je.set(p.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(je,lt,Pt,te)),ki=je.set(p.ExtHostContext.ExtHostQuickDiff,new It.ExtHostQuickDiff(je,St)),Vi=je.set(p.ExtHostContext.ExtHostShare,new qt.ExtHostShare(je,St)),Pi=je.set(p.ExtHostContext.ExtHostComments,(0,o.createExtHostComments)(je,lt,Pt)),bi=je.set(p.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(je.getProxy(p.MainContext.MainThreadProgress))),qi=je.set(p.ExtHostContext.ExtHosLabelService,new ne.ExtHostLabelService(je)),Ti=je.set(p.ExtHostContext.ExtHostTheming,new G.ExtHostTheming(je)),ci=je.set(p.ExtHostContext.ExtHostAuthentication,new ke.ExtHostAuthentication(je)),ji=je.set(p.ExtHostContext.ExtHostTimeline,new B.ExtHostTimeline(je,lt)),wi=je.set(p.ExtHostContext.ExtHostWebviews,new ie.ExtHostWebviews(je,dt.remote,ft,te,Ve)),Ai=je.set(p.ExtHostContext.ExtHostWebviewPanels,new ue.ExtHostWebviewPanels(je,wi,ft)),cn=je.set(p.ExtHostContext.ExtHostCustomEditors,new Q.ExtHostCustomEditors(je,Pt,Fe,wi,Ai)),Ri=je.set(p.ExtHostContext.ExtHostWebviewViews,new oe.ExtHostWebviewViews(je,wi)),ni=je.set(p.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(je,lt,Et)),ln=je.set(p.ExtHostContext.ExtHostUriOpeners,new Ze.ExtHostUriOpeners(je)),un=je.set(p.ExtHostContext.ExtHostProfileContentHandlers,new pt.ExtHostProfileContentHandlers(je));je.set(p.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(je,Dt,Et,lt,te));const Gi=je.set(p.ExtHostContext.ExtHostInlineChat,new Wt.ExtHostInteractiveEditor(je,lt,Pt,te)),fi=je.set(p.ExtHostContext.ExtHostChatProvider,new At.ExtHostChatProvider(je,te)),Ki=je.set(p.ExtHostContext.ExtHostChatSlashCommands,new Rt.ExtHostChatSlashCommands(je,fi,te)),Xi=je.set(p.ExtHostContext.ExtHostChatVariables,new xt.ExtHostChatVariables(je)),li=je.set(p.ExtHostContext.ExtHostChat,new Xt.ExtHostChat(je,te)),Qi=je.set(p.ExtHostContext.ExtHostAiRelatedInformation,new Bt.ExtHostRelatedInformation(je)),Li=je.set(p.ExtHostContext.ExtHostAiEmbeddingVector,new Ht.ExtHostAiEmbeddingVector(je)),Yi=je.set(p.ExtHostContext.ExtHostIssueReporter,new Ot.ExtHostIssueReporter(je)),Yt=je.set(p.ExtHostContext.ExtHostStatusBar,new U.ExtHostStatusBar(je,lt.converter)),Si=Object.values(p.ExtHostContext);je.assertRegistered(Si);const dn=new ve.ExtHostBulkEdits(je,Et),Gt=new y.ExtHostClipboard(je),ui=new l.ExtHostMessageService(je,te),Fi=new b.ExtHostDialogs(je);return D.ExtHostApiCommands.register(lt),function(Be,Jt,Oi){const mt=function(){let ge=!Be.isUnderDevelopment;function _e(){ge||(te.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Ne(st){if(Array.isArray(st))st.forEach(Ne);else if(typeof st=="string")_e();else{const wt=st;typeof wt.scheme>"u"&&_e(),typeof wt.exclusive=="boolean"&&(0,Ue.checkProposedApiEnabled)(Be,"documentFiltersExclusive")}return st}}(),Ji={getSession(ge,_e,Ne){return ci.getSession(Be,ge,_e,Ne)},getSessions(ge,_e){return(0,Ue.checkProposedApiEnabled)(Be,"authGetSessions"),ci.getSessions(Be,ge,_e)},async hasSession(ge,_e){return(0,Ue.checkProposedApiEnabled)(Be,"authSession"),!!await ci.getSession(Be,ge,_e,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(ge,_e,Ne,st){return ci.registerAuthenticationProvider(ge,_e,Ne,st)}},Zi={registerCommand(ge,_e,Ne){return lt.registerCommand(!0,ge,_e,Ne,void 0,Be)},registerTextEditorCommand(ge,_e,Ne){return lt.registerCommand(!0,ge,(...st)=>{const wt=Lt.getActiveTextEditor();if(!wt){te.warn("Cannot execute "+ge+" because there is no active text editor.");return}return wt.edit(Ft=>{_e.apply(Ne,[wt,Ft,...st])}).then(Ft=>{Ft||te.warn("Edits from command "+ge+" were not applied.")},Ft=>{te.warn("An error occurred while running command "+ge,Ft)})},void 0,void 0,Be)},registerDiffInformationCommand:(ge,_e,Ne)=>((0,Ue.checkProposedApiEnabled)(Be,"diffCommand"),lt.registerCommand(!0,ge,async(...st)=>{const wt=Et.activeEditor(!0);if(!wt){te.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Ft=await Lt.getDiffInformation(wt.id);_e.apply(Ne,[Ft,...st])},void 0,void 0,Be)),executeCommand(ge,..._e){return lt.executeCommand(ge,..._e)},getCommands(ge=!1){return lt.getCommands(ge)}},en={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ue.checkProposedApiEnabled)(Be,"envShellEvent"),gt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ue.checkProposedApiEnabled)(Be,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ue.checkProposedApiEnabled)(Be,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,_e){return et.ExtHostTelemetryLogger.validateSender(ge),kt.instantiateLogger(Be,ge,_e)},openExternal(ge,_e){return Je.openUri(ge,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:_e?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===dt.environment.appUriScheme)return gi.createAppUri(ge);try{return await Je.asExternalUri(ge,{allowTunneling:!!dt.remote.authority})}catch(_e){if((0,Xe.matchesScheme)(ge,Re.Schemas.http)||(0,Xe.matchesScheme)(ge,Re.Schemas.https))return ge;throw _e}},get remoteName(){return(0,J.getRemoteName)(dt.remote.authority)},get remoteAuthority(){return(0,Ue.checkProposedApiEnabled)(Be,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind},get logLevel(){return te.getLevel()},get onDidChangeLogLevel(){return te.onDidChangeLogLevel},registerIssueUriRequestHandler(ge){return(0,Ue.checkProposedApiEnabled)(Be,"handleIssueUri"),Yi.registerIssueUriRequestHandler(Be,ge)},get appQuality(){return(0,Ue.checkProposedApiEnabled)(Be,"resolvers"),dt.quality},get appCommit(){return(0,Ue.checkProposedApiEnabled)(Be,"resolvers"),dt.commit}};dt.environment.extensionTestsLocationURI||Object.freeze(en);const hn={createTestController(ge,_e,Ne){return ni.createTestController(Be,ge,_e,Ne)},createTestObserver(){return(0,Ue.checkProposedApiEnabled)(Be,"testObserver"),ni.createTestObserver()},runTests(ge){return(0,Ue.checkProposedApiEnabled)(Be,"testObserver"),ni.runTests(ge)},get onDidChangeTestResults(){return(0,Ue.checkProposedApiEnabled)(Be,"testObserver"),ni.onResultsChanged},get testResults(){return(0,Ue.checkProposedApiEnabled)(Be,"testObserver"),ni.results}},di=dt.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,tn={getExtension(ge,_e){(0,Ue.isProposedApiEnabled)(Be,"extensionsAny")||(_e=!1);const Ne=Jt.mine.getExtensionDescription(ge);if(Ne)return new i.Extension(_t,Be.identifier,Ne,di,!1);if(_e){const st=Jt.all.getExtensionDescription(ge);if(st)return new i.Extension(_t,Be.identifier,st,di,!0)}},get all(){const ge=[];for(const _e of Jt.mine.getAllExtensionDescriptions())ge.push(new i.Extension(_t,Be.identifier,_e,di,!1));return ge},get allAcrossExtensionHosts(){(0,Ue.checkProposedApiEnabled)(Be,"extensionsAny");const ge=new Ee.ExtensionIdentifierSet(Jt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),_e=[];for(const Ne of Jt.all.getAllExtensionDescriptions()){const st=!ge.has(Ne.identifier);_e.push(new i.Extension(_t,Be.identifier,Ne,di,st))}return _e},get onDidChange(){return(0,Ue.isProposedApiEnabled)(Be,"extensionsAny")?d.Event.any(Jt.mine.onDidChange,Jt.all.onDidChange):Jt.mine.onDidChange}},nn={createDiagnosticCollection(ge){return oi.createDiagnosticCollection(Be.identifier,ge)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:ge=>oi.getDiagnostics(ge),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(ge,_e){return ai.changeLanguage(ge.uri,_e)},match(ge,_e){const Ne=Pt.getDocumentData(_e.uri)?.notebook;return(0,P.score)(K.LanguageSelector.from(ge),_e.uri,_e.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(ge,_e,Ne){return ut.registerCodeActionProvider(Be,mt(ge),_e,Ne)},registerDocumentPasteEditProvider(ge,_e,Ne){return(0,Ue.checkProposedApiEnabled)(Be,"documentPaste"),ut.registerDocumentPasteEditProvider(Be,mt(ge),_e,Ne)},registerCodeLensProvider(ge,_e){return ut.registerCodeLensProvider(Be,mt(ge),_e)},registerDefinitionProvider(ge,_e){return ut.registerDefinitionProvider(Be,mt(ge),_e)},registerDeclarationProvider(ge,_e){return ut.registerDeclarationProvider(Be,mt(ge),_e)},registerImplementationProvider(ge,_e){return ut.registerImplementationProvider(Be,mt(ge),_e)},registerTypeDefinitionProvider(ge,_e){return ut.registerTypeDefinitionProvider(Be,mt(ge),_e)},registerHoverProvider(ge,_e){return ut.registerHoverProvider(Be,mt(ge),_e,Be.identifier)},registerEvaluatableExpressionProvider(ge,_e){return ut.registerEvaluatableExpressionProvider(Be,mt(ge),_e,Be.identifier)},registerInlineValuesProvider(ge,_e){return ut.registerInlineValuesProvider(Be,mt(ge),_e,Be.identifier)},registerDocumentHighlightProvider(ge,_e){return ut.registerDocumentHighlightProvider(Be,mt(ge),_e)},registerLinkedEditingRangeProvider(ge,_e){return ut.registerLinkedEditingRangeProvider(Be,mt(ge),_e)},registerReferenceProvider(ge,_e){return ut.registerReferenceProvider(Be,mt(ge),_e)},registerRenameProvider(ge,_e){return ut.registerRenameProvider(Be,mt(ge),_e)},registerDocumentSymbolProvider(ge,_e,Ne){return ut.registerDocumentSymbolProvider(Be,mt(ge),_e,Ne)},registerWorkspaceSymbolProvider(ge){return ut.registerWorkspaceSymbolProvider(Be,ge)},registerDocumentFormattingEditProvider(ge,_e){return ut.registerDocumentFormattingEditProvider(Be,mt(ge),_e)},registerDocumentRangeFormattingEditProvider(ge,_e){return ut.registerDocumentRangeFormattingEditProvider(Be,mt(ge),_e)},registerOnTypeFormattingEditProvider(ge,_e,Ne,...st){return ut.registerOnTypeFormattingEditProvider(Be,mt(ge),_e,[Ne].concat(st))},registerDocumentSemanticTokensProvider(ge,_e,Ne){return ut.registerDocumentSemanticTokensProvider(Be,mt(ge),_e,Ne)},registerDocumentRangeSemanticTokensProvider(ge,_e,Ne){return ut.registerDocumentRangeSemanticTokensProvider(Be,mt(ge),_e,Ne)},registerSignatureHelpProvider(ge,_e,Ne,...st){return typeof Ne=="object"?ut.registerSignatureHelpProvider(Be,mt(ge),_e,Ne):ut.registerSignatureHelpProvider(Be,mt(ge),_e,typeof Ne>"u"?[]:[Ne,...st])},registerCompletionItemProvider(ge,_e,...Ne){return ut.registerCompletionItemProvider(Be,mt(ge),_e,Ne)},registerInlineCompletionItemProvider(ge,_e,Ne){return _e.handleDidShowCompletionItem&&(0,Ue.checkProposedApiEnabled)(Be,"inlineCompletionsAdditions"),_e.handleDidPartiallyAcceptCompletionItem&&(0,Ue.checkProposedApiEnabled)(Be,"inlineCompletionsAdditions"),Ne&&(0,Ue.checkProposedApiEnabled)(Be,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Be,mt(ge),_e,Ne)},registerDocumentLinkProvider(ge,_e){return ut.registerDocumentLinkProvider(Be,mt(ge),_e)},registerColorProvider(ge,_e){return ut.registerColorProvider(Be,mt(ge),_e)},registerFoldingRangeProvider(ge,_e){return ut.registerFoldingRangeProvider(Be,mt(ge),_e)},registerSelectionRangeProvider(ge,_e){return ut.registerSelectionRangeProvider(Be,ge,_e)},registerCallHierarchyProvider(ge,_e){return ut.registerCallHierarchyProvider(Be,ge,_e)},registerTypeHierarchyProvider(ge,_e){return ut.registerTypeHierarchyProvider(Be,ge,_e)},setLanguageConfiguration:(ge,_e)=>ut.setLanguageConfiguration(Be,ge,_e),getTokenInformationAtPosition(ge,_e){return(0,Ue.checkProposedApiEnabled)(Be,"tokenInformation"),ai.tokenAtPosition(ge,_e)},registerInlayHintsProvider(ge,_e){return ut.registerInlayHintsProvider(Be,ge,_e)},createLanguageStatusItem(ge,_e){return ai.createLanguageStatusItem(Be,ge,_e)},registerDocumentDropEditProvider(ge,_e,Ne){return ut.registerDocumentOnDropEditProvider(Be,ge,_e,(0,Ue.isProposedApiEnabled)(Be,"dropMetadata")?Ne:void 0)}},rn={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(ge,_e,Ne){const st=await(T.URI.isUri(ge)?Promise.resolve(sn.openTextDocument(ge)):Promise.resolve(ge));return Lt.showTextDocument(st,_e,Ne)},createTextEditorDecorationType(ge){return Lt.createTextEditorDecorationType(Be,ge)},onDidChangeActiveTextEditor(ge,_e,Ne){return Lt.onDidChangeActiveTextEditor(ge,_e,Ne)},onDidChangeVisibleTextEditors(ge,_e,Ne){return Lt.onDidChangeVisibleTextEditors(ge,_e,Ne)},onDidChangeTextEditorSelection(ge,_e,Ne){return Lt.onDidChangeTextEditorSelection(ge,_e,Ne)},onDidChangeTextEditorOptions(ge,_e,Ne){return Lt.onDidChangeTextEditorOptions(ge,_e,Ne)},onDidChangeTextEditorVisibleRanges(ge,_e,Ne){return Lt.onDidChangeTextEditorVisibleRanges(ge,_e,Ne)},onDidChangeTextEditorViewColumn(ge,_e,Ne){return Lt.onDidChangeTextEditorViewColumn(ge,_e,Ne)},onDidCloseTerminal(ge,_e,Ne){return gt.onDidCloseTerminal(ge,_e,Ne)},onDidOpenTerminal(ge,_e,Ne){return gt.onDidOpenTerminal(ge,_e,Ne)},onDidChangeActiveTerminal(ge,_e,Ne){return gt.onDidChangeActiveTerminal(ge,_e,Ne)},onDidChangeTerminalDimensions(ge,_e,Ne){return(0,Ue.checkProposedApiEnabled)(Be,"terminalDimensions"),gt.onDidChangeTerminalDimensions(ge,_e,Ne)},onDidChangeTerminalState(ge,_e,Ne){return gt.onDidChangeTerminalState(ge,_e,Ne)},onDidWriteTerminalData(ge,_e,Ne){return(0,Ue.checkProposedApiEnabled)(Be,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(ge,_e,Ne)},onDidExecuteTerminalCommand(ge,_e,Ne){return(0,Ue.checkProposedApiEnabled)(Be,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(ge,_e,Ne)},get state(){return Je.getState(Be)},onDidChangeWindowState(ge,_e,Ne){return Je.onDidChangeWindowState(ge,_e,Ne)},showInformationMessage(ge,..._e){return ui.showMessage(Be,A.default.Info,ge,_e[0],_e.slice(1))},showWarningMessage(ge,..._e){return ui.showMessage(Be,A.default.Warning,ge,_e[0],_e.slice(1))},showErrorMessage(ge,..._e){return ui.showMessage(Be,A.default.Error,ge,_e[0],_e.slice(1))},showQuickPick(ge,_e,Ne){return ii.showQuickPick(Be,ge,_e,Ne)},showWorkspaceFolderPick(ge){return ii.showWorkspaceFolderPick(ge)},showInputBox(ge,_e){return ii.showInput(ge,_e)},showOpenDialog(ge){return Fi.showOpenDialog(Be,ge)},showSaveDialog(ge){return Fi.showSaveDialog(ge)},createStatusBarItem(ge,_e,Ne){let st,wt,Ft;return typeof ge=="string"?(st=ge,wt=_e,Ft=Ne):(wt=ge,Ft=_e),Yt.createStatusBarEntry(Be,st,wt,Ft)},setStatusBarMessage(ge,_e){return Yt.setStatusBarMessage(ge,_e)},withScmProgress(ge){return Ve.report("window.withScmProgress",Be,"Use 'withProgress' instead."),bi.withProgress(Be,{location:q.ProgressLocation.SourceControl},(_e,Ne)=>ge({report(st){}}))},withProgress(ge,_e){return bi.withProgress(Be,ge,_e)},createOutputChannel(ge,_e){return yi.createOutputChannel(ge,_e,Be)},createWebviewPanel(ge,_e,Ne,st){return Ai.createWebviewPanel(Be,ge,_e,Ne,st)},createWebviewTextEditorInset(ge,_e,Ne,st){return(0,Ue.checkProposedApiEnabled)(Be,"editorInsets"),Ii.createWebviewEditorInset(ge,_e,Ne,st,Be)},createTerminal(ge,_e,Ne){return typeof ge=="object"?"pty"in ge?gt.createExtensionTerminal(ge):gt.createTerminalFromOptions(ge):gt.createTerminal(ge,_e,Ne)},registerTerminalLinkProvider(ge){return gt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,_e){return gt.registerProfileProvider(Be,ge,_e)},registerTerminalQuickFixProvider(ge,_e){return(0,Ue.checkProposedApiEnabled)(Be,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(ge,Be.identifier.value,_e)},registerTreeDataProvider(ge,_e){return vi.registerTreeDataProvider(ge,_e,Be)},createTreeView(ge,_e){return vi.createTreeView(ge,_e,Be)},registerWebviewPanelSerializer:(ge,_e)=>Ai.registerWebviewPanelSerializer(Be,ge,_e),registerCustomEditorProvider:(ge,_e,Ne={})=>cn.registerCustomEditorProvider(Be,ge,_e,Ne),registerFileDecorationProvider(ge){return yt.registerFileDecorationProvider(ge,Be)},registerUriHandler(ge){return gi.registerUriHandler(Be,ge)},createQuickPick(){return ii.createQuickPick(Be)},createInputBox(){return ii.createInputBox(Be)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(ge,_e,Ne){return Ti.onDidChangeActiveColorTheme(ge,_e,Ne)},registerWebviewViewProvider(ge,_e,Ne){return Ri.registerWebviewViewProvider(Be,ge,_e,Ne?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,_e,Ne){return Dt.onDidChangeActiveNotebookEditor(ge,_e,Ne)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,_e,Ne){return pi.onDidChangeNotebookEditorSelection(ge,_e,Ne)},onDidChangeNotebookEditorVisibleRanges(ge,_e,Ne){return pi.onDidChangeNotebookEditorVisibleRanges(ge,_e,Ne)},showNotebookDocument(ge,_e){return Dt.showNotebookDocument(ge,_e)},registerExternalUriOpener(ge,_e,Ne){return(0,Ue.checkProposedApiEnabled)(Be,"externalUriOpener"),ln.registerExternalUriOpener(Be.identifier,ge,_e,Ne)},registerProfileContentHandler(ge,_e){return(0,Ue.checkProposedApiEnabled)(Be,"profileContentHandlers"),un.registrProfileContentHandler(Be,ge,_e)},registerQuickDiffProvider(ge,_e,Ne,st){return(0,Ue.checkProposedApiEnabled)(Be,"quickDiffProvider"),ki.registerQuickDiffProvider(mt(ge),_e,Ne,st)},get tabGroups(){return nt.tabGroups},registerShareProvider(ge,_e){return(0,Ue.checkProposedApiEnabled)(Be,"shareProvider"),Vi.registerShareProvider(mt(ge),_e)}},sn={get rootPath(){return Ve.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ge){throw L.readonly()},getWorkspaceFolder(ge){return ft.getWorkspaceFolder(ge)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ge){throw L.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ge){throw L.readonly()},updateWorkspaceFolders:(ge,_e,...Ne)=>ft.updateWorkspaceFolders(Be,ge,_e||0,...Ne),onDidChangeWorkspaceFolders:function(ge,_e,Ne){return ft.onDidChangeWorkspace(ge,_e,Ne)},asRelativePath:(ge,_e)=>ft.getRelativePath(ge,_e),findFiles:(ge,_e,Ne,st)=>ft.findFiles(ge,_e,Ne,Be.identifier,st),findTextInFiles:(ge,_e,Ne,st)=>{(0,Ue.checkProposedApiEnabled)(Be,"findTextInFiles");let wt,Ft;return typeof _e=="object"?(wt=_e,Ft=Ne):(wt={},Ft=_e,st=Ne),ft.findTextInFiles(ge,wt||{},Ft,Be.identifier,st)},save:ge=>((0,Ue.checkProposedApiEnabled)(Be,"saveEditor"),ft.save(ge)),saveAs:ge=>((0,Ue.checkProposedApiEnabled)(Be,"saveEditor"),ft.saveAs(ge)),saveAll:ge=>ft.saveAll(ge),applyEdit(ge,_e){return dn.applyWorkspaceEdit(ge,Be,_e)},createFileSystemWatcher:(ge,_e,Ne,st)=>Qt.createFileSystemWatcher(ft,Be,ge,_e,Ne,st),get textDocuments(){return Pt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw L.readonly()},openTextDocument(ge){let _e;const Ne=ge;if(typeof ge=="string")_e=Promise.resolve(T.URI.file(ge));else if(T.URI.isUri(ge))_e=Promise.resolve(ge);else if(!Ne||typeof Ne=="object")_e=Pt.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return _e.then(st=>Pt.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(ge,_e,Ne)=>Pt.onDidAddDocument(ge,_e,Ne),onDidCloseTextDocument:(ge,_e,Ne)=>Pt.onDidRemoveDocument(ge,_e,Ne),onDidChangeTextDocument:(ge,_e,Ne)=>Pt.onDidChangeDocument(ge,_e,Ne),onDidSaveTextDocument:(ge,_e,Ne)=>Pt.onDidSaveDocument(ge,_e,Ne),onWillSaveTextDocument:(ge,_e,Ne)=>Wi.getOnWillSaveTextDocumentEvent(Be)(ge,_e,Ne),get notebookDocuments(){return Dt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,_e){let Ne;if(T.URI.isUri(ge))Ne=ge,await Dt.openNotebookDocument(ge);else if(typeof ge=="string")Ne=T.URI.revive(await Dt.createNotebookDocument({viewType:ge,content:_e}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ge,_e,Ne){return ti.onDidSaveNotebookDocument(ge,_e,Ne)},onDidChangeNotebookDocument(ge,_e,Ne){return ti.onDidChangeNotebookDocument(ge,_e,Ne)},onWillSaveNotebookDocument(ge,_e,Ne){return Di.getOnWillSaveNotebookDocumentEvent(Be)(ge,_e,Ne)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,_e,Ne,st){return Dt.registerNotebookSerializer(Be,ge,_e,Ne,(0,Ue.isProposedApiEnabled)(Be,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(ge,_e,Ne)=>Oi.onDidChangeConfiguration(ge,_e,Ne),getConfiguration(ge,_e){return _e=arguments.length===1?void 0:_e,Oi.getConfiguration(ge,_e,Be)},registerTextDocumentContentProvider(ge,_e){return _i.registerTextDocumentContentProvider(ge,_e)},registerTaskProvider:(ge,_e)=>(Ve.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),Vt.registerTaskProvider(Be,ge,_e)),registerFileSystemProvider(ge,_e,Ne){return(0,He.combinedDisposable)(Hi.registerFileSystemProvider(Be,ge,_e,Ne),Tt.addFileSystemProvider(ge,_e,Ne))},get fs(){return Tt.value},registerFileSearchProvider:(ge,_e)=>((0,Ue.checkProposedApiEnabled)(Be,"fileSearchProvider"),mi.registerFileSearchProvider(ge,_e)),registerTextSearchProvider:(ge,_e)=>((0,Ue.checkProposedApiEnabled)(Be,"textSearchProvider"),mi.registerTextSearchProvider(ge,_e)),registerRemoteAuthorityResolver:(ge,_e)=>((0,Ue.checkProposedApiEnabled)(Be,"resolvers"),_t.registerRemoteAuthorityResolver(ge,_e)),registerResourceLabelFormatter:ge=>((0,Ue.checkProposedApiEnabled)(Be,"resolvers"),qi.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,Ue.checkProposedApiEnabled)(Be,"resolvers"),_t.getRemoteExecServer(ge)),onDidCreateFiles:(ge,_e,Ne)=>Qt.onDidCreateFile(ge,_e,Ne),onDidDeleteFiles:(ge,_e,Ne)=>Qt.onDidDeleteFile(ge,_e,Ne),onDidRenameFiles:(ge,_e,Ne)=>Qt.onDidRenameFile(ge,_e,Ne),onWillCreateFiles:(ge,_e,Ne)=>Qt.getOnWillCreateFileEvent(Be)(ge,_e,Ne),onWillDeleteFiles:(ge,_e,Ne)=>Qt.getOnWillDeleteFileEvent(Be)(ge,_e,Ne),onWillRenameFiles:(ge,_e,Ne)=>Qt.getOnWillRenameFileEvent(Be)(ge,_e,Ne),openTunnel:ge=>((0,Ue.checkProposedApiEnabled)(Be,"tunnels"),Oe.openTunnel(Be,ge).then(_e=>{if(!_e)throw new Error("cannot open tunnel");return _e})),get tunnels(){return(0,Ue.checkProposedApiEnabled)(Be,"tunnels"),Oe.getTunnels()},onDidChangeTunnels:(ge,_e,Ne)=>((0,Ue.checkProposedApiEnabled)(Be,"tunnels"),Oe.onDidChangeTunnels(ge,_e,Ne)),registerPortAttributesProvider:(ge,_e)=>((0,Ue.checkProposedApiEnabled)(Be,"portsAttributes"),Oe.registerPortsAttributesProvider(ge,_e)),registerTunnelProvider:(ge,_e)=>((0,Ue.checkProposedApiEnabled)(Be,"tunnelFactory"),Oe.registerTunnelProvider(ge,_e)),registerTimelineProvider:(ge,_e)=>((0,Ue.checkProposedApiEnabled)(Be,"timeline"),ji.registerTimelineProvider(ge,_e,Be.identifier,lt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ge=>((0,Ue.checkProposedApiEnabled)(Be,"workspaceTrust"),ft.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,_e,Ne)=>ft.onDidGrantWorkspaceTrust(ge,_e,Ne),registerEditSessionIdentityProvider:(ge,_e)=>((0,Ue.checkProposedApiEnabled)(Be,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ge,_e)),onWillCreateEditSessionIdentity:(ge,_e,Ne)=>((0,Ue.checkProposedApiEnabled)(Be,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Be)(ge,_e,Ne)),registerCanonicalUriProvider:(ge,_e)=>((0,Ue.checkProposedApiEnabled)(Be,"canonicalUriProvider"),ft.registerCanonicalUriProvider(ge,_e)),getCanonicalUri:(ge,_e,Ne)=>((0,Ue.checkProposedApiEnabled)(Be,"canonicalUriProvider"),ft.provideCanonicalUri(ge,_e,Ne))},fn={get inputBox(){return Ve.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),Ei.getLastInputBox(Be)},createSourceControl(ge,_e,Ne){return Ei.createSourceControl(Be,ge,_e,Ne)}},on={createCommentController(ge,_e){return Pi.createCommentController(Be,ge,_e)}},an={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},get stackFrameFocus(){return Ct.stackFrameFocus},onDidStartDebugSession(ge,_e,Ne){return Ct.onDidStartDebugSession(ge,_e,Ne)},onDidTerminateDebugSession(ge,_e,Ne){return Ct.onDidTerminateDebugSession(ge,_e,Ne)},onDidChangeActiveDebugSession(ge,_e,Ne){return Ct.onDidChangeActiveDebugSession(ge,_e,Ne)},onDidReceiveDebugSessionCustomEvent(ge,_e,Ne){return Ct.onDidReceiveDebugSessionCustomEvent(ge,_e,Ne)},onDidChangeBreakpoints(ge,_e,Ne){return Ct.onDidChangeBreakpoints(ge,_e,Ne)},onDidChangeStackFrameFocus(ge,_e,Ne){return(0,Ue.checkProposedApiEnabled)(Be,"debugFocus"),Ct.onDidChangeStackFrameFocus(ge,_e,Ne)},registerDebugConfigurationProvider(ge,_e,Ne){return Ct.registerDebugConfigurationProvider(ge,_e,Ne||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,_e){return Ct.registerDebugAdapterDescriptorFactory(Be,ge,_e)},registerDebugAdapterTrackerFactory(ge,_e){return Ct.registerDebugAdapterTrackerFactory(ge,_e)},startDebugging(ge,_e,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?Ct.startDebugging(ge,_e,{parentSession:Ne}):Ct.startDebugging(ge,_e,Ne||{})},stopDebugging(ge){return Ct.stopDebugging(ge)},addBreakpoints(ge){return Ct.addBreakpoints(ge)},removeBreakpoints(ge){return Ct.removeBreakpoints(ge)},asDebugSourceUri(ge,_e){return Ct.asDebugSourceUri(ge,_e)}},Mi={registerTaskProvider:(ge,_e)=>Vt.registerTaskProvider(Be,ge,_e),fetchTasks:ge=>Vt.fetchTasks(ge),executeTask:ge=>Vt.executeTask(Be,ge),get taskExecutions(){return Vt.taskExecutions},onDidStartTask:(ge,_e,Ne)=>Vt.onDidStartTask(ge,_e,Ne),onDidEndTask:(ge,_e,Ne)=>Vt.onDidEndTask(ge,_e,Ne),onDidStartTaskProcess:(ge,_e,Ne)=>Vt.onDidStartTaskProcess(ge,_e,Ne),onDidEndTaskProcess:(ge,_e,Ne)=>Vt.onDidEndTaskProcess(ge,_e,Ne)},Ni={createNotebookController(ge,_e,Ne,st,wt){return si.createNotebookController(Be,ge,_e,Ne,st,(0,Ue.isProposedApiEnabled)(Be,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,_e)=>Dt.registerNotebookCellStatusBarItemProvider(Be,ge,_e),createRendererMessaging(ge){return Ci.createRendererMessaging(Be,ge)},createNotebookControllerDetectionTask(ge){return(0,Ue.checkProposedApiEnabled)(Be,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Be,ge)},registerKernelSourceActionProvider(ge,_e){return(0,Ue.checkProposedApiEnabled)(Be,"notebookKernelSource"),si.registerKernelSourceActionProvider(Be,ge,_e)},onDidChangeNotebookCellExecutionState(ge,_e,Ne){return(0,Ue.checkProposedApiEnabled)(Be,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(ge,_e,Ne)}},xi={t(...ge){if(typeof ge[0]=="string"){const _e=ge.shift(),Ne=!ge||typeof ge[0]!="object"?ge:ge[0];return zt.getMessage(Be.identifier.value,{message:_e,args:Ne})}return zt.getMessage(Be.identifier.value,ge[0])},get bundle(){return zt.getBundle(Be.identifier.value)},get uri(){return zt.getBundleUri(Be.identifier.value)}},hi={_version:1,registerInteractiveEditorSessionProvider(ge){return(0,Ue.checkProposedApiEnabled)(Be,"interactive"),Gi.registerProvider(Be,ge)},registerInteractiveSessionProvider(ge,_e){return(0,Ue.checkProposedApiEnabled)(Be,"interactive"),li.registerChatProvider(Be,ge,_e)},addInteractiveRequest(ge){return(0,Ue.checkProposedApiEnabled)(Be,"interactive"),li.addChatRequest(ge)},sendInteractiveRequestToProvider(ge,_e){return(0,Ue.checkProposedApiEnabled)(Be,"interactive"),li.sendInteractiveRequestToProvider(ge,_e)},get onDidPerformUserAction(){return(0,Ue.checkProposedApiEnabled)(Be,"interactiveUserActions"),li.onDidPerformUserAction},transferChatSession(ge,_e){return(0,Ue.checkProposedApiEnabled)(Be,"interactive"),li.transferChatSession(ge,_e)}},Ui={getRelatedInformation(ge,_e){return(0,Ue.checkProposedApiEnabled)(Be,"aiRelatedInformation"),Qi.getRelatedInformation(Be,ge,_e)},registerRelatedInformationProvider(ge,_e){return(0,Ue.checkProposedApiEnabled)(Be,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Be,ge,_e)},registerEmbeddingVectorProvider(ge,_e){return(0,Ue.checkProposedApiEnabled)(Be,"aiRelatedInformation"),Li.registerEmbeddingVectorProvider(Be,ge,_e)}},Bi={registerChatResponseProvider(ge,_e,Ne){return(0,Ue.checkProposedApiEnabled)(Be,"chatProvider"),fi.registerProvider(Be.identifier,ge,_e,Ne)},registerSlashCommand(ge,_e,Ne){return(0,Ue.checkProposedApiEnabled)(Be,"chatSlashCommands"),Ki.registerCommand(Be.identifier,ge,_e,Ne??{description:""})},requestChatAccess(ge){return(0,Ue.checkProposedApiEnabled)(Be,"chatRequestAccess"),fi.requestChatResponseProvider(Be.identifier,ge)},registerVariable(ge,_e,Ne){return(0,Ue.checkProposedApiEnabled)(Be,"chatVariables"),Xi.registerVariableResolver(Be,ge,_e,Ne)},registerMappedEditsProvider(ge,_e){return(0,Ue.checkProposedApiEnabled)(Be,"mappedEditsProvider"),ut.registerMappedEditsProvider(Be,ge,_e)}};return{version:dt.version,ai:Ui,authentication:Ji,commands:Zi,comments:on,chat:Bi,debug:an,env:en,extensions:tn,interactive:hi,l10n:xi,languages:nn,notebooks:Ni,scm:fn,tasks:Mi,tests:hn,window:rn,workspace:sn,Breakpoint:q.Breakpoint,TerminalOutputAnchor:q.TerminalOutputAnchor,ChatMessage:q.ChatMessage,ChatMessageRole:q.ChatMessageRole,ChatVariableLevel:q.ChatVariableLevel,CallHierarchyIncomingCall:q.CallHierarchyIncomingCall,CallHierarchyItem:q.CallHierarchyItem,CallHierarchyOutgoingCall:q.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:C.CancellationTokenSource,CandidatePortSource:p.CandidatePortSource,CodeAction:q.CodeAction,CodeActionKind:q.CodeActionKind,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.CodeLens,Color:q.Color,ColorInformation:q.ColorInformation,ColorPresentation:q.ColorPresentation,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentState:q.CommentState,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CompletionItem:q.CompletionItem,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.CompletionList,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.CustomExecution,DebugAdapterExecutable:q.DebugAdapterExecutable,DebugAdapterInlineImplementation:q.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:q.DebugAdapterNamedPipeServer,DebugAdapterServer:q.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.Diagnostic,DiagnosticRelatedInformation:q.DiagnosticRelatedInformation,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.Disposable,DocumentHighlight:q.DocumentHighlight,DocumentHighlightKind:q.DocumentHighlightKind,DocumentLink:q.DocumentLink,DocumentSymbol:q.DocumentSymbol,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.EvaluatableExpression,InlineValueText:q.InlineValueText,InlineValueVariableLookup:q.InlineValueVariableLookup,InlineValueEvaluatableExpression:q.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:d.Emitter,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.FileDecoration,FileDecoration2:q.FileDecoration,FileSystemError:q.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:q.FoldingRange,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.FunctionBreakpoint,InlineCompletionItem:q.InlineSuggestion,InlineCompletionList:q.InlineSuggestionList,Hover:q.Hover,IndentAction:g.IndentAction,Location:q.Location,MarkdownString:q.MarkdownString,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:q.ParameterInformation,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.Position,ProcessExecution:q.ProcessExecution,ProgressLocation:q.ProgressLocation,QuickInputButtons:q.QuickInputButtons,Range:q.Range,RelativePattern:q.RelativePattern,Selection:q.Selection,SelectionRange:q.SelectionRange,SemanticTokens:q.SemanticTokens,SemanticTokensBuilder:q.SemanticTokensBuilder,SemanticTokensEdit:q.SemanticTokensEdit,SemanticTokensEdits:q.SemanticTokensEdits,SemanticTokensLegend:q.SemanticTokensLegend,ShellExecution:q.ShellExecution,ShellQuoting:q.ShellQuoting,SignatureHelp:q.SignatureHelp,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.SignatureInformation,SnippetString:q.SnippetString,SourceBreakpoint:q.SourceBreakpoint,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.SymbolInformation,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.Task,TaskGroup:q.TaskGroup,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.TerminalLink,TerminalQuickFixExecuteTerminalCommand:q.TerminalQuickFixCommand,TerminalQuickFixOpener:q.TerminalQuickFixOpener,TerminalLocation:q.TerminalLocation,TerminalProfile:q.TerminalProfile,TerminalExitReason:q.TerminalExitReason,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.TextEdit,SnippetTextEdit:q.SnippetTextEdit,TextEditorCursorStyle:f.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.ThemeColor,ThemeIcon:q.ThemeIcon,TreeItem:q.TreeItem,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.TypeHierarchyItem,UIKind:_.UIKind,Uri:T.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.WorkspaceEdit,DocumentDropEdit:q.DocumentDropEdit,DocumentPasteEdit:q.DocumentPasteEdit,InlayHint:q.InlayHint,InlayHintLabelPart:q.InlayHintLabelPart,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.RemoteAuthorityResolverError,ResolvedAuthority:q.ResolvedAuthority,ManagedResolvedAuthority:q.ManagedResolvedAuthority,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.TimelineItem,NotebookRange:q.NotebookRange,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.NotebookCellData,NotebookData:q.NotebookData,NotebookRendererScript:q.NotebookRendererScript,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.NotebookCellOutput,NotebookCellOutputItem:q.NotebookCellOutputItem,NotebookCellStatusBarItem:q.NotebookCellStatusBarItem,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.NotebookEdit,NotebookKernelSourceAction:q.NotebookKernelSourceAction,PortAttributes:q.PortAttributes,LinkedEditingRanges:q.LinkedEditingRanges,TestResultState:q.TestResultState,TestRunRequest:q.TestRunRequest,TestMessage:q.TestMessage,TestMessage2:q.TestMessage,TestTag:q.TestTag,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:Me.TextSearchCompleteMessageType,DataTransfer:q.DataTransfer,DataTransferItem:q.DataTransferItem,CoveredCount:q.CoveredCount,FileCoverage:q.FileCoverage,StatementCoverage:q.StatementCoverage,BranchCoverage:q.BranchCoverage,FunctionCoverage:q.FunctionCoverage,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.TextTabInput,TabInputTextDiff:q.TextDiffTabInput,TabInputTextMerge:q.TextMergeTabInput,TabInputCustom:q.CustomEditorTabInput,TabInputNotebook:q.NotebookEditorTabInput,TabInputNotebookDiff:q.NotebookDiffEditorTabInput,TabInputWebview:q.WebviewEditorTabInput,TabInputTerminal:q.TerminalEditorTabInput,TabInputInteractiveWindow:q.InteractiveWindowInput,TelemetryTrustedValue:fe.TelemetryTrustedValue,LogLevel:be.LogLevel,EditSessionIdentityMatch:ot.EditSessionIdentityMatch,InteractiveSessionVoteDirection:q.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:q.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:q.InteractiveEditorResponseFeedbackKind,StackFrameFocus:q.StackFrameFocus,ThreadFocus:q.ThreadFocus,NotebookCodeActionKind:q.NotebookCodeActionKind,RelatedInformationType:q.RelatedInformationType}}}e.createApiFactoryAndRegisterActors=$t}),define(Ce[345],De([1,0,102,149,38,146,39,33,65,43,93,94,95,114,68,89,148,67,52,113,88,66,147,17,53,111,112]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m,b,I,t,r,s,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.registerSingleton)(i.IExtHostLocalizationService,i.ExtHostLocalizationService,1),(0,C.registerSingleton)(r.ILoggerService,t.ExtHostLoggerService,1),(0,C.registerSingleton)(y.IExtHostApiDeprecationService,y.ExtHostApiDeprecationService,1),(0,C.registerSingleton)(f.IExtHostCommands,f.ExtHostCommands,0),(0,C.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration,0),(0,C.registerSingleton)(o.IExtHostConsumerFileSystem,o.ExtHostConsumerFileSystem,0),(0,C.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,0),(0,C.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,C.registerSingleton)(w.IExtHostDocumentsAndEditors,w.ExtHostDocumentsAndEditors,0),(0,C.registerSingleton)(c.IExtHostManagedSockets,c.ExtHostManagedSockets,0),(0,C.registerSingleton)(a.IExtHostFileSystemInfo,a.ExtHostFileSystemInfo,0),(0,C.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService,1),(0,C.registerSingleton)(p.IExtHostSearch,p.ExtHostSearch,0),(0,C.registerSingleton)(_.IExtHostStorage,_.ExtHostStorage,0),(0,C.registerSingleton)(P.IExtHostTask,P.WorkerExtHostTask,0),(0,C.registerSingleton)(g.IExtHostTerminalService,g.WorkerExtHostTerminalService,0),(0,C.registerSingleton)(D.IExtHostTunnelService,D.ExtHostTunnelService,0),(0,C.registerSingleton)(n.IExtHostWindow,n.ExtHostWindow,0),(0,C.registerSingleton)(d.IExtHostWorkspace,d.ExtHostWorkspace,0),(0,C.registerSingleton)(m.IExtHostSecretState,m.ExtHostSecretState,0),(0,C.registerSingleton)(b.IExtHostTelemetry,b.ExtHostTelemetry,0),(0,C.registerSingleton)(I.IExtHostEditorTabs,I.ExtHostEditorTabs,0),(0,C.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService,0)}),define(Ce[115],De([1,0,18,17,36,92]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=T;function f(k,p,_,D){const y=(0,C.mapArrayOrNot)(_,w),n=new d.TextSearchMatch(p,y,D),o=n.preview.matches;return{ranges:(0,C.mapArrayOrNot)(y,g),uri:k,preview:{text:n.preview.text,matches:(0,C.mapArrayOrNot)(o,g)}}}e.createTextSearchResult=f;function w(k){return new d.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function g(k){return new A.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let P=class{constructor(p,_){this.prefix=p,this.logService=_}appendLine(p){this.logService.debug(`${this.prefix}#search`,p)}};e.OutputChannel=P,e.OutputChannel=P=qe([$e(1,L.ILogService)],P)}),define(Ce[346],De([1,0,46,14,73,32,9,15,115,347]),function(me,e,C,L,d,A,T,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const P=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(m,b,I,t){const r=p(m,b,I,t),s=b.folder.fsPath;return{cmd:C.spawn(P,r.args,{cwd:s}),rgDiskPath:P,siblingClauses:r.siblingClauses,rgArgs:r,cwd:s}}e.spawnRipgrepCmd=k;function p(m,b,I,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];D([b],I,!1).forEach(i=>{const c=(0,w.anchorGlob)(i);if(r.push("-g",c),T.isMacintosh){const u=(0,d.normalizeNFD)(c);u!==c&&r.push("-g",u)}});const s=_([b],t,void 0,!1);return s.globArgs.forEach(i=>{const c=`!${(0,w.anchorGlob)(i)}`;if(r.push("-g",c),T.isMacintosh){const u=(0,d.normalizeNFD)(c);u!==c&&r.push("-g",u)}}),b.disregardIgnoreFiles!==!1?r.push("--no-ignore"):b.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),b.ignoreSymlinks||r.push("--follow"),m.exists&&r.push("--quiet"),r.push("--no-config"),b.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:s.siblingClauses}}function _(m,b,I,t=!0){const r=[];let s={};return m.forEach(i=>{const c=Object.assign({},i.excludePattern||{},b||{}),u=y(c,t?i.folder.fsPath:void 0,I);r.push(...u.globArgs),u.siblingClauses&&(s=Object.assign(s,u.siblingClauses))}),{globArgs:r,siblingClauses:s}}function D(m,b,I=!0){const t=[];return m.forEach(r=>{const s=Object.assign({},b||{},r.includePattern||{}),i=y(s,I?r.folder.fsPath:void 0);t.push(...i.globArgs)}),t}function y(m,b,I){const t=[],r={};return Object.keys(m).forEach(s=>{if(I&&I.has(s)||!s)return;const i=m[s];s=o(b?n(b,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof i=="boolean"&&i?(s.startsWith("\\\\")&&(s+="**"),t.push(a(s))):i&&i.when&&(r[s]=i)}),{globArgs:t,siblingClauses:r}}function n(m,b){return L.isAbsolute(b)?b:L.join(m,b)}e.getAbsoluteGlob=n;function o(m){return m=f.rtrim(m,"\\"),f.rtrim(m,"/")}function a(m){return A.getRoot(m).toLowerCase()==="c:/"?m.replace(/^c:[/\\]/i,"/"):m}e.fixDriveC=a}),define(Ce[348],De([1,0,46,49,14,349,18,45,35,73,32,9,37,15,19,29,36,346,125]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const m=new Set;process.on("exit",()=>{m.forEach(s=>s())});class b{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&w.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,a.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&w.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(c=>{const u=Object.assign({},c.excludePattern||{},this.config.excludePattern||{}),v=c.folder.fsPath;i.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==v).forEach(S=>{(0,P.isEqualOrParent)(S,v)&&(u[d.relative(v,S)]=!0)}),this.folderExcludePatterns.set(v,new t(u,v))})}cancel(){this.isCanceled=!0,m.forEach(i=>i())}walk(i,c,u,v,S){if(this.fileWalkSW=p.StopWatch.create(!1),this.isCanceled)return S(null,this.isLimitHit);c.forEach(l=>{const h=d.basename(l.fsPath);this.globalExcludePattern&&this.globalExcludePattern(l.fsPath,h)||this.matchFile(u,{relativePath:l.fsPath,searchPath:void 0})}),this.cmdSW=p.StopWatch.create(!1),this.parallel(i,(l,h)=>{this.call(this.cmdTraversal,this,l,u,v,E=>{if(E){const R=(0,f.toErrorMessage)(E);console.error(R),this.errors.push(R),h(E,void 0)}else h(null,void 0)})},(l,h)=>{this.fileWalkSW.stop();const E=l?T.coalesce(l)[0]:null;S(E,this.isLimitHit)})}parallel(i,c,u){const v=new Array(i.length),S=new Array(i.length);let l=!1,h=0;if(i.length===0)return u(null,[]);i.forEach((E,R)=>{c(E,(M,U)=>{if(M?(l=!0,v[R]=null,S[R]=M):(v[R]=U,S[R]=null),++h===i.length)return u(l?S:null,v)})})}call(i,c,...u){try{i.apply(c,u)}catch(v){u[u.length-1](v)}}cmdTraversal(i,c,u,v){const S=i.folder.fsPath,l=k.isMacintosh,h=()=>F&&F.kill();m.add(h);let E=K=>{m.delete(h),E=()=>{},v(K)},R="";const M=this.initDirectoryTree(),U=(0,o.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression),F=U.cmd,x=!Object.keys(U.siblingClauses).length,$=U.rgArgs.args.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");let O=`${U.rgDiskPath} ${$}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),u({message:O}),this.cmdResultCount=0,this.collectStdout(F,"utf8",u,(K,q,fe)=>{if(K){E(K);return}if(this.isLimitHit){E();return}const ie=(R+(l?g.normalizeNFC(q||""):q)).split(`
`);if(fe){const H=ie.length;ie[H-1]=ie[H-1].trim(),ie[H-1]||ie.pop()}else R=ie.pop()||"";if(ie.length&&ie[0].indexOf(`
`)!==-1){E(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=ie.length,x){for(const H of ie)if(this.matchFile(c,{base:S,relativePath:H,searchPath:this.getSearchPath(i,H)}),this.isLimitHit){h();break}(fe||this.isLimitHit)&&E();return}this.addDirectoryEntries(i,M,S,ie,c),fe&&(this.matchDirectoryTree(M,S,c),E())})}spawnFindCmd(i){const c=this.folderExcludePatterns.get(i.folder.fsPath),u=c.getBasenameTerms(),v=c.getPathTerms(),S=["-L","."];if(u.length||v.length){S.push("-not","(","(");for(const l of u)S.push("-name",l),S.push("-o");for(const l of v)S.push("-path",l),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),C.spawn("find",S,{cwd:i.folder.fsPath})}readStdout(i,c,u){let v="";this.collectStdout(i,c,()=>{},(S,l,h)=>{if(S){u(S);return}v+=l,h&&u(null,v)})}collectStdout(i,c,u,v){let S=(E,R,M)=>{(E||M)&&(S=()=>{},this.cmdSW?.stop()),v(E,R,M)},l=!1;i.stdout?(this.forwardData(i.stdout,c,S),i.stdout.once("data",()=>l=!0)):u({message:"stdout is null"});let h;i.stderr?h=this.collectData(i.stderr):u({message:"stderr is null"}),i.on("error",E=>{S(E)}),i.on("close",E=>{let R;!l&&(R=this.decodeData(h,c))&&r(R)?S(new Error(`command failed with error code ${E}: ${this.decodeData(h,c)}`)):(this.exists&&E===0&&(this.isLimitHit=!0),S(null,"",!0))})}forwardData(i,c,u){const v=new A.StringDecoder(c);return i.on("data",S=>{u(null,v.write(S))}),v}collectData(i){const c=[];return i.on("data",u=>{c.push(u)}),c}decodeData(i,c){const u=new A.StringDecoder(c);return i.map(v=>u.write(v)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:c},u,v,S){v.indexOf(this.filePattern)!==-1&&this.matchFile(S,{base:u,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const l=h=>{const E=d.basename(h),R=d.dirname(h);let M=c[R];M||(M=c[R]=[],l(R)),M.push({base:u,relativePath:h,basename:E,searchPath:this.getSearchPath(i,h)})};v.forEach(l)}matchDirectoryTree({rootEntries:i,pathToEntries:c},u,v){const S=this,l=this.folderExcludePatterns.get(u),h=this.filePattern;function E(R){S.directoriesWalked++;const M=(0,n.hasSiblingFn)(()=>R.map(U=>U.basename));for(let U=0,F=R.length;U<F;U++){const x=R[U],{relativePath:$,basename:O}=x;if(l.test($,O,h!==O?M:void 0))continue;const K=c[$];if(K)E(K);else{if(S.filesWalked++,$===h)continue;S.matchFile(v,x)}if(S.isLimitHit)break}}E(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,c,u,v,S){const l=i.folder,h=(0,n.hasSiblingFn)(()=>u);this.parallel(u,(E,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const M=c?[c,E].join(d.sep):E;if(this.folderExcludePatterns.get(i.folder.fsPath).test(M,E,this.config.filePattern!==E?h:void 0))return R(null);const U=[l.fsPath,M].join(d.sep);L.lstat(U,(F,x)=>{if(F||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(U,x,($,O)=>$||this.isCanceled||this.isLimitHit?R(null):O.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(U,x,(K,q)=>K||this.isCanceled||this.isLimitHit||(q=q||"",this.walkedPaths[q])?R(null):(this.walkedPaths[q]=!0,y.Promises.readdir(U).then(fe=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(i,M,fe,v,se=>R(se||null))},fe=>{R(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&D.isNumber(O.size)&&O.size>this.maxFilesize||this.matchFile(v,{base:l.fsPath,relativePath:M,searchPath:this.getSearchPath(i,M)}),R(null,void 0)))})},E=>{const R=E&&T.coalesce(E);return S(R&&R.length>0?R[0]:void 0)})}matchFile(i,c){this.isFileMatch(c)&&(!this.includePattern||this.includePattern(c.relativePath,d.basename(c.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(c))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,n.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,c,u){return c.isSymbolicLink()?L.stat(i,u):u(null,c)}realPathIfNeeded(i,c,u){return c.isSymbolicLink()?L.realpath(i,(v,S)=>v?u(v):u(null,S)):u(null,i)}getSearchPath(i,c){return i.folderName?d.join(i.folderName,c):c}}e.FileWalker=b;class I{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new b(i)}search(i,c,u){this.walker.walk(this.folderQueries,this.extraFiles,i,c,(v,S)=>{u(v,{limitHit:S,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=I;class t{constructor(i,c){this.expression=i,this.root=c,this.init(i)}init(i){let c,u;Object.keys(i).filter(v=>i[v]).forEach(v=>{d.isAbsolute(v)?(c=c||w.getEmptyExpression(),c[v]=i[v]):(u=u||w.getEmptyExpression(),u[v]=i[v])}),this.absoluteParsedExpr=c&&w.parse(c,{trimForExclusions:!0}),this.relativeParsedExpr=u&&w.parse(u,{trimForExclusions:!0})}test(i,c,u){return this.relativeParsedExpr&&this.relativeParsedExpr(i,c,u)||this.absoluteParsedExpr&&this.absoluteParsedExpr(d.join(this.root,i),c,u)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...w.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...w.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...w.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...w.getPathTerms(this.relativeParsedExpr)),i}}function r(s){const i=s.trim().split(`
`),c=i[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return _.uppercaseFirstLetter(i[i.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(Ce[350],De([1,0,96,21,179,22]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(c){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(u=>u===c)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const f=512,w=512,g=512*8,P=512*128;var k;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(k||(e.DecodeStreamErrorKind=k={}));class p extends Error{constructor(u,v){super(u),this.decodeStreamErrorKind=v}}e.DecodeStreamError=p;class _{static async create(u){let v;if(u!==e.UTF8)v=(await(0,d.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(u));else{const S=new TextDecoder;v={write(l){return S.decode(l,{stream:!0})},end(){return S.decode()}}}return new _(v)}constructor(u){this.iconvLiteDecoder=u}write(u){return this.iconvLiteDecoder.write(u)}end(){return this.iconvLiteDecoder.end()}}function D(c,u){const v=u.minBytesRequiredForDetection??u.guessEncoding?g:w;return new Promise((S,l)=>{const h=(0,C.newWriteableStream)(x=>x.join("")),E=[];let R=0,M;const U=new A.CancellationTokenSource,F=async()=>{try{const x=await i({buffer:L.VSBuffer.concat(E),bytesRead:R},u.guessEncoding);if(x.seemsBinary&&u.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);x.encoding=await u.overwriteEncoding(x.encoding),M=await _.create(x.encoding);const $=M.write(L.VSBuffer.concat(E).buffer);h.write($),E.length=0,R=0,S({stream:h,detected:x})}catch(x){U.cancel(),h.destroy(),l(x)}};(0,C.listenStream)(c,{onData:async x=>{M?h.write(M.write(x.buffer)):(E.push(x),R+=x.byteLength,R>=v&&(c.pause(),await F(),setTimeout(()=>c.resume())))},onError:x=>h.error(x),onEnd:async()=>{M||await F(),h.end(M?.end())}},U.token)})}e.toDecodeStream=D;async function y(c,u,v){const l=(await(0,d.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(u),v);let h=!1,E=!1;return{read(){if(E)return null;const R=c.read();if(typeof R!="string"){if(E=!0,!h&&v?.addBOM)switch(u){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const M=l.end();return M&&M.length>0?(h=!0,L.VSBuffer.wrap(M)):null}return h=!0,L.VSBuffer.wrap(l.write(R))}}}e.toEncodeReadable=y;async function n(c){return(await(0,d.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(c))}e.encodingExists=n;function o(c){return c===e.UTF8_with_bom||c===null?e.UTF8:c}e.toNodeEncoding=o;function a(c,u){if(!c||u<e.UTF16be_BOM.length)return null;const v=c.readUInt8(0),S=c.readUInt8(1);if(v===e.UTF16be_BOM[0]&&S===e.UTF16be_BOM[1])return e.UTF16be;if(v===e.UTF16le_BOM[0]&&S===e.UTF16le_BOM[1])return e.UTF16le;if(u<e.UTF8_BOM.length)return null;const l=c.readUInt8(2);return v===e.UTF8_BOM[0]&&S===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const m=["ascii","utf-16","utf-32"];async function b(c){const u=await(0,d.importAMDNodeModule)("jschardet","dist/jschardet.min.js"),v=c.slice(0,P),S=r(v.buffer),l=u.detect(S);if(!l||!l.encoding)return null;const h=l.encoding.toLowerCase();return 0<=m.indexOf(h)?null:t(l.encoding)}const I={ibm866:"cp866",big5:"cp950"};function t(c){const u=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return I[u]||u}function r(c){let u="";for(let v=0;v<c.length;v++)u+=String.fromCharCode(c[v]);return u}function s(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=c.match(/windows(\d+)/);return u?"windows-"+u[1]:c}}}e.toCanonicalName=s;function i({buffer:c,bytesRead:u},v){let S=a(c,u),l=!1;if(S!==e.UTF16be&&S!==e.UTF16le&&c){let h=!0,E=!0,R=!1;for(let M=0;M<u&&M<f;M++){const U=M%2===1,F=c.readUInt8(M)===0;if(F&&(R=!0),h&&(U&&!F||!U&&F)&&(h=!1),E&&(U&&F||!U&&!F)&&(E=!1),F&&!h&&!E)break}R&&(h?S=e.UTF16le:E?S=e.UTF16be:l=!0)}return v&&!l&&!S&&c?b(c.slice(0,u)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:l,encoding:S}}e.detectEncodingFromBuffer=i,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ce[151],De([1,0,350,29,150]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends d.TextSearchManager{constructor(f,w,g=L,P="searchProcess"){super(f,w,{readdir:k=>g.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,C.toCanonicalName)(k)},P)}}e.NativeTextSearchManager=A}),define(Ce[152],De([1,0,46,366,349,18,69,35,14,15,2,36,92,367,347,115]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const n=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class o{constructor(E){this.outputChannel=E}provideTextSearchResults(E,R,M,U){return this.outputChannel.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...R,folder:R.folder.toString()})}`),new Promise((F,x)=>{U.onCancellationRequested(()=>H());const $=r(E,R),O=R.folder.fsPath,K=$.map(J=>J.match(/^-/)?J:`'${J}'`).join(" ");this.outputChannel.appendLine(`${n} ${K}
 - cwd: ${O}`);let q=C.spawn(n,$,{cwd:O});q.on("error",J=>{console.error(J),this.outputChannel.appendLine("Error: "+(J&&J.message)),x((0,k.serializeSearchError)(new k.SearchError(J&&J.message,k.SearchErrorCode.rgProcessError)))});let fe=!1;const se=new b(R.maxResults,O,R.previewOptions);se.on("result",J=>{fe=!0,Ee="",M.report(J)});let ie=!1;const H=()=>{ie=!0,q?.kill(),se?.cancel()};let re=!1;se.on("hitLimit",()=>{re=!0,H()});let Ee="";q.stdout.on("data",J=>{se.handleData(J),fe||(Ee+=J)});let ae=!1;q.stdout.once("data",()=>ae=!0);let ne="";q.stderr.on("data",J=>{const N=J.toString();this.outputChannel.appendLine(N),ne.length+N.length<1e6&&(ne+=N)}),q.on("close",()=>{if(this.outputChannel.appendLine(ae?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(fe?"Got result from parser":"No result from parser"),Ee&&this.outputChannel.appendLine(`Got data without result: ${Ee}`),this.outputChannel.appendLine(""),ie)F({limitHit:re});else{se.flush(),q=null;let J;ne&&!ae&&(J=a(ne))?x((0,k.serializeSearchError)(new k.SearchError(J.message,J.code))):F({limitHit:re})}})})}}e.RipgrepTextSearchEngine=o;function a(h){const E=h.split(`
`),R=E[0].trim();if(E.some(U=>U.startsWith("regex parse error")))return new k.SearchError(m(E),k.SearchErrorCode.regexParseError);const M=R.match(/grep config error: unknown encoding: (.*)/);if(M)return new k.SearchError(`Unknown encoding: ${M[1]}`,k.SearchErrorCode.unknownEncoding);if(R.startsWith("error parsing glob"))return new k.SearchError(R.charAt(0).toUpperCase()+R.substr(1),k.SearchErrorCode.globParseError);if(R.startsWith("the literal"))return new k.SearchError(R.charAt(0).toUpperCase()+R.substr(1),k.SearchErrorCode.invalidLiteral);if(R.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(R,k.SearchErrorCode.regexParseError)}function m(h){const E=["Regex parse error"],R=h.filter(M=>M.startsWith("PCRE2:"));if(R.length>=1){const M=R[0].replace("PCRE2:","");if(M.indexOf(":")!==-1&&M.split(":").length>=2){const U=M.split(":")[1];E.push(":"+U)}}return E.join("")}class b extends L.EventEmitter{constructor(E,R,M){super(),this.maxResults=E,this.rootFolder=R,this.previewOptions=M,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new d.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(E,R){return super.on(E,R),this}handleData(E){if(this.isDone)return;const R=typeof E=="string"?E:this.stringDecoder.write(E);this.handleDecodedData(R)}handleDecodedData(E){let R=E.indexOf(`
`);const M=this.remainder+E;if(R>=0)R+=this.remainder.length;else{this.remainder=M;return}let U=0;for(;R>=0;)this.handleLine(M.substring(U,R).trim()),U=R+1,R=M.indexOf(`
`,U);this.remainder=M.substring(U)}handleLine(E){if(this.isDone||!E)return;let R;try{R=JSON.parse(E)}catch{throw new Error(`malformed line from rg: ${E}`)}if(R.type==="match"){const M=I(R.data.path),U=P.URI.file(w.join(this.rootFolder,M)),F=this.createTextSearchMatch(R.data,U);this.onResult(F),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(R.type==="context"){const M=I(R.data.path),U=P.URI.file(w.join(this.rootFolder,M));this.createTextSearchContext(R.data,U).forEach(x=>this.onResult(x))}}createTextSearchMatch(E,R){const M=E.line_number-1,U=I(E.lines),F=Buffer.from(U);let x=0,$=0,O=M;E.submatches.length===0&&E.submatches.push(U.length?{start:0,end:1,match:{text:U[0]}}:{start:0,end:0,match:{text:""}});const K=(0,A.coalesce)(E.submatches.map((q,fe)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const se=I(q.match),ie=F.slice(x,q.start).toString(),H=t(ie),re=H.numLines>0?H.lastLineLength:H.lastLineLength+$,Ee=t(se),ae=H.numLines+O,ne=Ee.numLines+ae,J=Ee.numLines>0?Ee.lastLineLength:Ee.lastLineLength+re;return x=q.end,$=J,O=ne,new p.Range(ae,re,ne,J)}));return(0,y.createTextSearchResult)(R,U,K,this.previewOptions)}createTextSearchContext(E,R){const M=I(E.lines),U=E.line_number;return M.replace(/\r?\n$/,"").split(`
`).map((F,x)=>({text:F,uri:R,lineNumber:U+x}))}onResult(E){this.emit("result",E)}}e.RipgrepParser=b;function I(h){return h.bytes?Buffer.from(h.bytes,"base64").toString():h.text}function t(h){const E=/\n/g;let R=0,M=-1,U;for(;U=E.exec(h);)R++,M=U.index;const F=M>=0?h.length-M-1:h.length;return{numLines:R,lastLineLength:F}}function r(h,E){const R=["--hidden","--no-require-git"];R.push(h.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:M,otherIncludes:U}=(0,T.groupBy)(E.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(U&&U.length){const x=new Set;U.forEach($=>{x.add($)}),R.push("-g","!*"),x.forEach($=>{s($).map(y.anchorGlob).forEach(O=>{R.push("-g",O)})})}M&&M.length&&M.forEach(x=>{R.push("-g",x)}),E.excludes.map(y.anchorGlob).forEach(x=>R.push("-g",`!${x}`)),E.maxFileSize&&R.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?E.useParentIgnoreFiles||R.push("--no-ignore-parent"):R.push("--no-ignore"),E.followSymlinks&&R.push("--follow"),E.encoding&&E.encoding!=="utf8"&&R.push("--encoding",E.encoding),h.pattern==="--"&&(h.isRegExp=!0,h.pattern="\\-\\-"),h.isMultiline&&!h.isRegExp&&(h.pattern=(0,g.escapeRegExpCharacters)(h.pattern),h.isRegExp=!0),E.usePCRE2&&R.push("--pcre2"),R.push("--crlf"),h.isRegExp&&(h.pattern=i(h.pattern),R.push("--engine","auto"));let F;if(h.isWordMatch){const $=(0,g.createRegExp)(h.pattern,!!h.isRegExp,{wholeWord:h.isWordMatch}).source.replace(/\\\//g,"/");R.push("--regexp",$)}else if(h.isRegExp){let x=u(h.pattern);x=v(x),R.push("--regexp",x)}else F=h.pattern,R.push("--fixed-strings");return R.push("--no-config"),E.useGlobalIgnoreFiles||R.push("--no-ignore-global"),R.push("--json"),h.isMultiline&&R.push("--multiline"),E.beforeContext&&R.push("--before-context",E.beforeContext+""),E.afterContext&&R.push("--after-context",E.afterContext+""),R.push("--"),F&&R.push(F),R.push("."),R}e.getRgArgs=r;function s(h){return l(h).flatMap(R=>{const M=(0,f.splitGlobAware)(R,"/");return M.map((U,F)=>M.slice(0,F+1).join("/"))})}function i(h){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;h.match(E);)h=h.replace(E,"$1\\x{$2}");const R=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;h.match(R);)h=h.replace(R,"$1\\x{$2}");return h}e.unicodeEscapesToPCRE2=i;const c=h=>h.type==="Assertion"&&h.kind==="lookbehind";function u(h){let E;try{E=new _.RegExpParser().parsePattern(h)}catch{return h}let R="",M=0;const U=($,O,K)=>{R+=h.slice(M,$)+K,M=O},F=[];return new _.RegExpVisitor({onCharacterEnter($){if($.raw!=="\\n")return;const O=F[0];if(!O)U($.start,$.end,"\\r?\\n");else if(!F.some(c))if(O.type==="CharacterClass")if(O.negate){const K=h.slice(O.start+2,$.start)+h.slice($.end,O.end-1);O.parent?.type==="Quantifier"?U(O.start,O.end,K?`[^${K}]`:"."):U(O.start,O.end,"(?!\\r?\\n"+(K?`|[${K}]`:"")+")")}else{const K=h.slice(O.start+1,$.start)+h.slice($.end,O.end-1);U(O.start,O.end,K===""?"\\r?\\n":`(?:[${K}]|\\r?\\n)`)}else O.type==="Quantifier"&&U($.start,$.end,"(?:\\r?\\n)")},onQuantifierEnter($){F.unshift($)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter($){F.unshift($)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter($){F.unshift($)},onCharacterClassLeave(){F.shift()},onAssertionEnter($){c($)&&F.push($)},onAssertionLeave($){F[0]===$&&F.shift()}}).visit(E),R+=h.slice(M),R}e.fixRegexNewline=u;function v(h){return h.replace(/\n/g,"\\r?\\n")}e.fixNewline=v;function S(h){let E=!1,R=!1,M="",U="";for(let F=0;F<h.length;F++){const x=h[F];switch(x){case"\\":R?(E?U+="\\"+x:M+="\\"+x,R=!1):R=!0;break;case"{":if(R)E?U+=x:M+=x,R=!1;else{if(E)return{strInBraces:M+"{"+U+"{"+h.substring(F+1)};E=!0}break;case"}":if(R)E?U+=x:M+=x,R=!1;else{if(E)return{fixedStart:M,strInBraces:U,fixedEnd:h.substring(F+1)};M+=x}break;default:E?U+=(R?"\\":"")+x:M+=(R?"\\":"")+x,R=!1;break}}return{strInBraces:M+(E?"{"+U:"")}}function l(h){const{fixedStart:E,strInBraces:R,fixedEnd:M}=S(h);if(E===void 0||M===void 0)return[R];let U=(0,f.splitGlobAware)(R,",");U.length||(U=[""]);const F=l(M);return U.flatMap(x=>{const $=E+x;return F.map(O=>$+O)})}e.performBraceExpansionForRipgrep=l}),define(Ce[351],De([1,0,22,152,83,16]),function(me,e,C,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(g){this.outputChannel=g,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(g,P,k,p){const _=new L.RipgrepTextSearchEngine(this.outputChannel);if(P.folder.scheme===A.Schemas.vscodeUserData){const D={...P,folder:P.folder.with({scheme:A.Schemas.file})},y=new d.Progress(n=>k.report({...n,uri:n.uri.with({scheme:P.folder.scheme})}));return this.withToken(p,n=>_.provideTextSearchResults(g,D,y,n))}else return this.withToken(p,D=>_.provideTextSearchResults(g,P,k,D))}async withToken(g,P){const k=f(g);this.inProgress.add(k);const p=await P(k.token);return this.inProgress.delete(k),p}dispose(){this.inProgress.forEach(g=>g.cancel())}}e.RipgrepSearchProvider=T;function f(w){const g=new C.CancellationTokenSource;return w.onCancellationRequested(()=>g.cancel()),g}}),define(Ce[352],De([1,0,29,152,151]),function(me,e,C,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(w){this.query=w}search(w,g,P){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(_){P({message:_})}},p=new d.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(k),C);return new Promise((_,D)=>p.search(y=>{g(y.map(T))},w).then(y=>_({limitHit:y.limitHit,type:"success",stats:y.stats}),D))}}e.TextSearchEngineAdapter=A;function T(f){return{path:f.resource&&f.resource.fsPath,results:f.results,numMatches:(f.results||[]).reduce((w,g)=>{if(g.ranges){const P=g;return w+(Array.isArray(P.ranges)?P.ranges.length:1)}else return w+1},0)}}}),define(Ce[353],De([1,0,18,13,8,4,125,14,37,2,30,36,348,352]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class D{static{this.BATCH_SIZE=512}constructor(b="searchProcess"){this.processType=b,this.caches=Object.create(null)}fileSearch(b){let I;const t=o(b),r=new A.Emitter({onDidAddFirstListener:()=>{I=(0,L.createCancelablePromise)(s=>this.doFileSearchWithEngine(p.Engine,t,i=>r.fire(i),s)),I.then(s=>r.fire(s),s=>r.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{I.cancel()}});return r.event}textSearch(b){let I;const t=o(b),r=new A.Emitter({onDidAddFirstListener:()=>{I=(0,L.createCancelablePromise)(s=>this.ripgrepTextSearch(t,i=>r.fire(i),s)),I.then(s=>r.fire(s),s=>r.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{I.cancel()}});return r.event}ripgrepTextSearch(b,I,t){return b.maxFileSize=this.getPlatformFileLimits().maxFileSize,new _.TextSearchEngineAdapter(b).search(t,I,I)}getPlatformFileLimits(){return{maxFileSize:process.arch==="ia32"?300*P.ByteSize.MB:16*P.ByteSize.GB}}doFileSearch(b,I,t){return this.doFileSearchWithEngine(p.Engine,b,I,t)}doFileSearchWithEngine(b,I,t,r,s=D.BATCH_SIZE){let i=0;const c=v=>{Array.isArray(v)?(i+=v.length,t(v.map(S=>this.rawMatchToSearchItem(S)))):v.relativePath?(i++,t(this.rawMatchToSearchItem(v))):t(v)};if(I.sortByScore){let v=this.trySortedSearchFromCache(I,c,r);if(!v){const S=I.maxResults?Object.assign({},I,{maxResults:null}):I,l=new b(S);v=this.doSortedSearch(l,I,t,c,r)}return new Promise((S,l)=>{v.then(([h,E])=>{const R=E.map(M=>this.rawMatchToSearchItem(M));this.sendProgress(R,t,s),S(h)},l)})}const u=new b(I);return this.doSearch(u,c,s,r).then(v=>({limitHit:v.limitHit,type:"success",stats:{detailStats:v.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(b){return{path:b.base?(0,f.join)(b.base,b.relativePath):b.relativePath}}doSortedSearch(b,I,t,r,s){const i=new A.Emitter;let c=(0,L.createCancelablePromise)(v=>{let S=[];const l=h=>{Array.isArray(h)?S=h:(r(h),i.fire(h))};return this.doSearch(b,l,-1,v).then(h=>[h,S])}),u;if(I.cacheKey){u=this.getOrCreateCache(I.cacheKey);const v={promise:c,event:i.event,resolved:!1};u.resultsToSearchCache[I.filePattern||""]=v,c.then(()=>{v.resolved=!0},S=>{delete u.resultsToSearchCache[I.filePattern||""]}),c=this.preventCancellation(c)}return c.then(([v,S])=>{const l=u?u.scorerCache:Object.create(null),h=(typeof I.maxResults!="number"||I.maxResults>0)&&w.StopWatch.create(!1);return this.sortResults(I,S,l,s).then(E=>{const R=h?h.elapsed():-1;return[{type:"success",stats:{detailStats:v.stats,sortingTime:R,fromCache:!1,type:this.processType,workspaceFolderCount:I.folderQueries.length,resultCount:E.length},messages:v.messages,limitHit:v.limitHit||typeof I.maxResults=="number"&&S.length>I.maxResults},E]})})}getOrCreateCache(b){const I=this.caches[b];return I||(this.caches[b]=new y)}trySortedSearchFromCache(b,I,t){const r=b.cacheKey&&this.caches[b.cacheKey];if(!r)return;const s=this.getResultsFromCache(r,b.filePattern||"",I,t);if(s)return s.then(([i,c,u])=>{const v=w.StopWatch.create(!1);return this.sortResults(b,c,r.scorerCache,t).then(S=>{const l=v.elapsed(),h={fromCache:!0,detailStats:u,type:this.processType,resultCount:c.length,sortingTime:l};return[{type:"success",limitHit:i.limitHit||typeof b.maxResults=="number"&&c.length>b.maxResults,stats:h},S]})})}sortResults(b,I,t,r){const s=(0,T.prepareQuery)(b.filePattern||""),i=(u,v)=>(0,T.compareItemsByFuzzyScore)(u,v,s,!0,n,t),c=typeof b.maxResults=="number"?b.maxResults:Number.MAX_VALUE;return C.topAsync(I,i,c,1e4,r)}sendProgress(b,I,t){if(t&&t>0)for(let r=0;r<b.length;r+=t)I(b.slice(r,r+t));else I(b)}getResultsFromCache(b,I,t,r){const s=w.StopWatch.create(!1),i=I.indexOf(f.sep)>=0;let c;for(const l in b.resultsToSearchCache)if(I.startsWith(l)){if(i&&l.indexOf(f.sep)<0&&l!=="")continue;const h=b.resultsToSearchCache[l];c={promise:this.preventCancellation(h.promise),event:h.event,resolved:h.resolved};break}if(!c)return null;const u=s.elapsed(),v=w.StopWatch.create(!1),S=c.event(t);return r&&r.onCancellationRequested(()=>{S.dispose()}),c.promise.then(([l,h])=>{if(r&&r.isCancellationRequested)throw(0,d.canceled)();const E=[],R=(0,T.prepareQuery)(I).normalizedLowercase;for(const M of h)(0,k.isFilePatternMatch)(M,R)&&E.push(M);return[l,E,{cacheWasResolved:c.resolved,cacheLookupTime:u,cacheFilterTime:v.elapsed(),cacheEntryCount:h.length}]})}doSearch(b,I,t,r){return new Promise((s,i)=>{let c=[];r?.onCancellationRequested(()=>b.cancel()),b.search(u=>{u&&(t?(c.push(u),t>0&&c.length>=t&&(I(c),c=[])):I(u))},u=>{I(u)},(u,v)=>{c.length&&I(c),u?i(u):s(v)})})}clearCache(b){return delete this.caches[b],Promise.resolve(void 0)}preventCancellation(b){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(I,t){return b.then(I,t)}catch(I){return this.then(void 0,I)}finally(I){return b.finally(I)}}}}e.SearchService=D;class y{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const n=new class{getItemLabel(m){return(0,f.basename)(m.relativePath)}getItemDescription(m){return(0,f.dirname)(m.relativePath)}getItemPath(m){return m.relativePath}};function o(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(a),extraFileResources:m.extraFileResources&&m.extraFileResources.map(b=>g.URI.revive(b))}}function a(m){return{...m,folder:g.URI.revive(m.folder)}}}),define(Ce[354],De([1,0,3,16,2,29,17,26,20,95,62,36,353,351,115,151]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let n=class extends g.ExtHostSearch{constructor(a,m,b,I){super(a,b,I),this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const t=new D.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.vscodeUserData,new _.RipgrepSearchProvider(t)),m.remote.isRemote&&m.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const a=new D.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new _.RipgrepSearchProvider(a)),this.registerInternalFileSearchProvider(L.Schemas.file,new p.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(a,m){const b=this._handlePool++;return this._internalFileSearchProvider=m,this._internalFileSearchHandle=b,this._proxy.$registerFileSearchProvider(b,this._transformScheme(a)),(0,C.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(b)})}$provideFileSearchResults(a,m,b,I){const t=(0,g.reviveQuery)(b);return a===this._internalFileSearchHandle?this.doInternalFileSearch(a,m,t,I):super.$provideFileSearchResults(a,m,b,I)}doInternalFileSearch(a,m,b,I){const t=r=>{if((0,k.isSerializedFileMatch)(r)&&(r=[r]),Array.isArray(r)){this._proxy.$handleFileMatch(a,m,r.map(s=>d.URI.file(s.path)));return}r.message&&this._logService.debug("ExtHostSearch",r.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(b,t,I)}$clearCache(a){return this._internalFileSearchProvider?.clearCache(a),super.$clearCache(a)}createTextSearchManager(a,m){return new y.NativeTextSearchManager(a,m,void 0,"textSearchProvider")}};e.NativeExtHostSearch=n,e.NativeExtHostSearch=n=qe([$e(0,w.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,P.IURITransformerService),$e(3,T.ILogService)],n)}),define(Ce[116],De([1,0,368,57,59,369,21,8,4,3,14,9,31,79,80]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class y{traceSocketEvent(h,E){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,h,E)}constructor(h,E=""){this._canWrite=!0,this.debugLabel=E,this.socket=h,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=R=>{if(this.traceSocketEvent("error",{code:R?.code,message:R?.message}),R){if(R.code==="EPIPE")return;(0,f.onUnexpectedError)(R)}},this.socket.on("error",this._errorListener),this._closeListener=R=>{this.traceSocketEvent("close",{hadError:R}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(h){const E=R=>{this.traceSocketEvent("read",R),h(T.VSBuffer.wrap(R))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(h){const E=R=>{h({type:0,hadError:R,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(h){const E=()=>{h()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(h){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",h),this.socket.write(h.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,f.onUnexpectedError)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,f.onUnexpectedError)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((h,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),h();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),this.traceSocketEvent("nodeDrainEnd"),h()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=y;var n;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize",l[l.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(n||(n={}));var o;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(o||(o={}));class a extends g.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(h,E){this.socket.traceSocketEvent(h,E)}constructor(h,E,R,M){super(),this._onData=this._register(new w.Emitter),this._onClose=this._register(new w.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=h,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:R?.byteLength||0,recordInflateBytes:M}),this._flowManager=this._register(new m(this,E,R,M,this._onData,(U,F)=>this._write(U,F))),this._register(this._flowManager.onError(U=>{console.error(U),(0,f.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})})),this._incomingData=new D.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(async U=>{this._flowManager.isProcessingReadQueue()&&await w.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(U)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){let E=0;for(;E<h.byteLength;)this._flowManager.writeMessage(h.slice(E,Math.min(E+262144,h.byteLength))),E+=262144}_write(h,E){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",h);let R=2;h.byteLength<126?R+=0:h.byteLength<2**16?R+=2:R+=8;const M=T.VSBuffer.alloc(R);if(E?M.writeUInt8(194,0):M.writeUInt8(130,0),h.byteLength<126)M.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){M.writeUInt8(126,1);let U=1;M.writeUInt8(h.byteLength>>>8&255,++U),M.writeUInt8(h.byteLength>>>0&255,++U)}else{M.writeUInt8(127,1);let U=1;M.writeUInt8(0,++U),M.writeUInt8(0,++U),M.writeUInt8(0,++U),M.writeUInt8(0,++U),M.writeUInt8(h.byteLength>>>24&255,++U),M.writeUInt8(h.byteLength>>>16&255,++U),M.writeUInt8(h.byteLength>>>8&255,++U),M.writeUInt8(h.byteLength>>>0&255,++U)}this.socket.write(T.VSBuffer.concat([M,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const E=this._incomingData.peek(this._state.readLen),R=E.readUInt8(0),M=(R&128)>>>7,U=(R&64)>>>6,F=E.readUInt8(1),x=(F&128)>>>7,$=F&127;this._state.state=2,this._state.readLen=2+(x?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=M,this._state.firstFrameOfMessage&&(this._state.compressed=!!U),this._state.firstFrameOfMessage=!!M,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const E=this._incomingData.read(this._state.readLen),R=E.readUInt8(1),M=(R&128)>>>7;let U=R&127,F=1;U===126?U=E.readUInt8(++F)*2**8+E.readUInt8(++F):U===127&&(U=E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F));let x=0;M&&(x=E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F)),this._state.state=3,this._state.readLen=U,this._state.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const E=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),t(E,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(E,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await w.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=a;class m extends g.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}constructor(h,E,R,M,U,F){super(),this._tracer=h,this._onData=U,this._writeFn=F,this._onError=this._register(new w.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new w.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new w.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,E?(this._zlibInflateStream=this._register(new b(this._tracer,M,R,{windowBits:15})),this._zlibDeflateStream=this._register(new I(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(x=>this._onError.fire(x))),this._register(this._zlibDeflateStream.onError(x=>this._onError.fire(x)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(h){this._writeQueue.push(h),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const h=this._writeQueue.shift();if(this._zlibDeflateStream){const E=await this._deflateMessage(this._zlibDeflateStream,h);this._writeFn(E,!0)}else this._writeFn(h,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(h,E){return new Promise((R,M)=>{h.write(E),h.flush(U=>R(U))})}acceptFrame(h,E,R){this._readQueue.push({data:h,isCompressed:E,isLastFrameOfMessage:R}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const h=this._readQueue.shift();if(this._zlibInflateStream&&h.isCompressed){const E=await this._inflateFrame(this._zlibInflateStream,h.data,h.isLastFrameOfMessage);this._onData.fire(E)}else this._onData.fire(h.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(h,E,R){return new Promise((M,U)=>{h.write(E),R&&h.write(T.VSBuffer.fromByteArray([0,0,255,255])),h.flush(F=>M(F))})}}class b extends g.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}constructor(h,E,R,M){super(),this._tracer=h,this._recordInflateBytes=E,this._onError=this._register(new w.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(M),this._zlibInflate.on("error",U=>{this._tracer.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibInflate.on("data",U=>{this._tracer.traceSocketEvent("zlibInflateData",U),this._pendingInflateData.push(T.VSBuffer.wrap(U))}),R&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",R.buffer),this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(h){this._recordInflateBytes&&this._recordedInflateBytes.push(h.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",h),this._zlibInflate.write(h.buffer)}flush(h){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const E=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,h(E)})}}class I extends g.Disposable{constructor(h,E){super(),this._tracer=h,this._onError=this._register(new w.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",R=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibDeflate.on("data",R=>{this._tracer.traceSocketEvent("zlibDeflateData",R),this._pendingDeflateData.push(T.VSBuffer.wrap(R))})}write(h){this._tracer.traceSocketEvent("zlibDeflateWrite",h.buffer),this._zlibDeflate.write(h.buffer)}flush(h){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let E=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.byteLength-4),h(E)})}}function t(l,h){if(h===0)return;const E=l.byteLength>>>2;for(let $=0;$<E;$++){const O=l.readUInt32BE($*4);l.writeUInt32BE(O^h,$*4)}const R=E*4,M=l.byteLength-R,U=h>>>24&255,F=h>>>16&255,x=h>>>8&255;M>=1&&l.writeUInt8(l.readUInt8(R)^U,R),M>=2&&l.writeUInt8(l.readUInt8(R+1)^F,R+1),M>=3&&l.writeUInt8(l.readUInt8(R+2)^x,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function s(){const l=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;const h=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,d.tmpdir)(),E=(0,P.join)(h,`vscode-ipc-${l}.sock`);return c(E),E}e.createRandomIPCHandle=s;function i(l,h,E){const R=(0,C.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${E}-${h}-sock`;const M=E.substr(0,4),U=h.substr(0,6),F=R.substr(0,8);let x;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?x=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${F}-${M}-${U}.sock`):x=(0,P.join)(l,`${M}-${U}.sock`),c(x),x}e.createStaticIPCHandle=i;function c(l){const h=r[k.platform];typeof h=="number"&&l.length>=h&&console.warn(`WARNING: IPC handle "${l}" is longer than ${h} chars, try a shorter --user-data-dir`)}class u extends _.IPCServer{static toClientConnectionEvent(h){const E=w.Event.fromNodeEventEmitter(h,"connection");return w.Event.map(E,R=>({protocol:new D.Protocol(new y(R,"ipc-server-connection")),onDidClientDisconnect:w.Event.once(w.Event.fromNodeEventEmitter(R,"close"))}))}constructor(h){super(u.toClientConnectionEvent(h)),this.server=h}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function v(l){return new Promise((h,E)=>{const R=(0,L.createServer)();R.on("error",E),R.listen(l,()=>{R.removeListener("error",E),h(new u(R))})})}e.serve=v;function S(l,h){return new Promise((E,R)=>{const M=(0,L.createConnection)(l,()=>{M.removeListener("error",R),E(D.Client.fromSocket(new y(M,`ipc-client${h}`),h))});M.once("error",R)})}e.connect=S}),define(Ce[355],De([1,0,57,59,160,116,13,3,9,50,17,133,240,241,105,106,21]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function o(t,r,s,i,c){let u;for(let v=3;v&&(u?.dispose(),u=await new a(t,r,s,i,c).waitForReady(),!(c&&d.BROWSER_RESTRICTED_PORTS[c]||!d.BROWSER_RESTRICTED_PORTS[u.tunnelLocalPort]));v--);return u}class a extends f.Disposable{constructor(r,s,i,c,u){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=u,this.privacy=y.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=r,this._server=C.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=v=>this._onConnection(v),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){const r=this.suggestedLocalPort??this.tunnelRemotePort,s=(0,y.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let i=await(0,d.findFreePortFaster)(r,2,1e3,s),c=null;return this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(i=0,this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(r){r.pause();const s=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,p.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),c=i.getSocket(),u=i.readEntireBuffer();i.dispose(),u.byteLength>0&&r.write(u.buffer),r.on("end",()=>{r.localAddress&&this._socketsDispose.delete(r.localAddress),c.end()}),r.on("close",()=>c.end()),r.on("error",()=>{r.localAddress&&this._socketsDispose.delete(r.localAddress),c instanceof A.NodeSocket?c.socket.destroy():c.end()}),c instanceof A.NodeSocket?this._mirrorNodeSocket(r,c):this._mirrorGenericSocket(r,c),r.localAddress&&this._socketsDispose.set(r.localAddress,()=>{r.end(),c.end()})}_mirrorGenericSocket(r,s){s.onClose(()=>r.destroy()),s.onEnd(()=>r.end()),s.onData(i=>r.write(i.buffer)),r.on("data",i=>s.write(n.VSBuffer.wrap(i))),r.resume()}_mirrorNodeSocket(r,s){const i=s.socket;i.on("end",()=>r.end()),i.on("close",()=>r.end()),i.on("error",()=>{r.destroy()}),i.pipe(r),r.pipe(i)}}e.NodeRemoteTunnel=a;let m=class extends y.AbstractTunnelService{constructor(r,s,i,c,u){super(s,u),this.remoteSocketFactoryService=r,this.signService=i,this.productService=c}isPortPrivileged(r){return(0,y.isPortPrivileged)(r,this.defaultTunnelHost,w.OS,L.release())}retainOrCreateTunnel(r,s,i,c,u,v,S,l){const h=this.getTunnelFromMap(s,i);if(h)return++h.refcount,h.value;if((0,y.isTunnelProvider)(r))return this.createWithProvider(r,s,i,u,v,S,l);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${u}.`);const E={commit:this.productService.commit,quality:this.productService.quality,addressProvider:r,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},R=o(E,c,s,i,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,i,R),R}}};e.BaseTunnelService=m,e.BaseTunnelService=m=qe([$e(0,_.IRemoteSocketFactoryService),$e(1,P.ILogService),$e(2,D.ISignService),$e(3,k.IProductService),$e(4,g.IConfigurationService)],m);let b=class extends m{constructor(r,s,i,c,u){super(r,s,i,c,u)}};e.TunnelService=b,e.TunnelService=b=qe([$e(0,_.IRemoteSocketFactoryService),$e(1,P.ILogService),$e(2,D.ISignService),$e(3,k.IProductService),$e(4,g.IConfigurationService)],b);let I=class extends f.Disposable{constructor(r,s,i,c,u){super(),this.remoteSocketFactoryService=r,this.logService=s,this.productService=i,this.signService=c,this.configurationService=u,this._tunnelServices=new Map}async openTunnel(r,s,i,c,u,v,S,l,h){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${c} on local port ${v}.`),!this._tunnelServices.has(r)){const E=new b(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(E),this._tunnelServices.set(r,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this._tunnelServices.delete(r))})}return this._tunnelServices.get(r).openTunnel(s,i,c,u,v,S,l,h)}};e.SharedTunnelsService=I,e.SharedTunnelsService=I=qe([$e(0,_.IRemoteSocketFactoryService),$e(1,P.ILogService),$e(2,k.IProductService),$e(3,D.ISignService),$e(4,g.IConfigurationService)],I)}),define(Ce[356],De([1,0,116,257,49,33,2,17,51]),function(me,e,C,L,d,A,T,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class g{constructor(p,_,D){this._commands=p,this.logService=_,this._ipcHandlePath=D,this._server=L.createServer((y,n)=>this.onRequest(y,n)),this.setup().catch(y=>(_.error(y),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",p=>this.logService.error(p))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(p,_){const D=(n,o)=>{_.writeHead(n,{"content-type":"application/json"}),_.end(JSON.stringify(o||null),a=>a&&this.logService.error(a))},y=[];p.setEncoding("utf8"),p.on("data",n=>y.push(n)),p.on("end",async()=>{try{const n=JSON.parse(y.join(""));let o;switch(n.type){case"open":o=await this.open(n);break;case"openExternal":o=await this.openExternal(n);break;case"status":o=await this.getStatus(n);break;case"extensionManagement":o=await this.manageExtensions(n);break;default:D(404,`Unknown message type: ${n.type}`);break}D(200,o)}catch(n){const o=n instanceof Error?n.message:JSON.stringify(n);D(500,o),this.logService.error("Error while processing pipe request",n)}})}async open(p){const{fileURIs:_,folderURIs:D,forceNewWindow:y,diffMode:n,mergeMode:o,addMode:a,forceReuseWindow:m,gotoLineMode:b,waitMarkerFilePath:I,remoteAuthority:t}=p,r=[];if(Array.isArray(D))for(const u of D)try{r.push({folderUri:T.URI.parse(u)})}catch{}if(Array.isArray(_))for(const u of _)try{(0,w.hasWorkspaceFileExtension)(u)?r.push({workspaceUri:T.URI.parse(u)}):r.push({fileUri:T.URI.parse(u)})}catch{}const s=I?T.URI.file(I):void 0,c={forceNewWindow:y,diffMode:n,mergeMode:o,addMode:a,gotoLineMode:b,forceReuseWindow:m,preferNewWindow:!m&&!s&&!a,waitMarkerFileURI:s,remoteAuthority:t};this._commands.executeCommand("_remoteCLI.windowOpen",r,c)}async openExternal(p){for(const _ of p.uris){const D=T.URI.parse(_),y=D.scheme==="file"?D:_;await this._commands.executeCommand("_remoteCLI.openExternal",y)}}async manageExtensions(p){const _=y=>y?.map(n=>/\.vsix$/i.test(n)?T.URI.parse(n):n),D={list:p.list,install:_(p.install),uninstall:_(p.uninstall),force:p.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",D)}async getStatus(p){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&d.existsSync(this._ipcHandlePath)&&d.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=g;let P=class extends g{constructor(p,_){super(p,_,(0,C.createRandomIPCHandle)())}};e.CLIServer=P,e.CLIServer=P=qe([$e(0,A.IExtHostCommands),$e(1,f.ILogService)],P)}),define(Ce[357],De([1,0,61,344,339,256,44,328,2,16,7,356,99,326,327]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class y extends d.RequireInterceptor{_installInterceptor(){const a=this,m=globalThis._VSCODE_NODE_MODULES.module,b=m._load;m._load=function(s,i,c){return s=t(s),a._factories.has(s)?a._factories.get(s).load(s,w.URI.file((0,p.realpathSync)(i.filename)),u=>b.apply(this,[u,i,c])):b.apply(this,arguments)};const I=m._resolveLookupPaths;m._resolveLookupPaths=(r,s)=>I.call(this,t(r),s);const t=r=>{for(const s of a._alternatives){const i=s(r);if(i){r=i;break}}return r}}}class n extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(_.ExtHostConsoleForwarder);const a=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(f.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const I=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=I.ipcHandlePath}this._instaService.createInstance(D.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(y,a,{mine:this._myRegistry,all:this._globalRegistry}).install(),C.mark("code/extHost/didInitAPI");const b=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,b,this,this._logService,this._mainThreadTelemetryProxy,this._initData),C.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(a){return a.main}async _loadCommonJSModule(a,m,b){if(m.scheme!==g.Schemas.file)throw new Error(`Cannot load URI: '${m}', must be of file-scheme`);let I=null;b.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${m.toString(!0)}`),this._logService.flush();const t=a?.identifier.value;a&&await this._extHostLocalizationService.initializeLocalizedMessages(a);try{t&&C.mark(`code/extHost/willLoadExtensionCode/${t}`),I=me.__$__nodeRequire(m.fsPath)}finally{t&&C.mark(`code/extHost/didLoadExtensionCode/${t}`),b.codeLoadingStop()}return I}async $setRemoteEnvironment(a){if(this._initData.remote.isRemote)for(const m in a){const b=a[m];b===null?delete process.env[m]:process.env[m]=b}}}e.ExtHostExtensionService=n}),define(Ce[358],De([1,0,46,21,4,3,118,9,24,2,29,17,239,84,105,106,355,26,20,68]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;function b(l){const h=l.trim().split(`
`),E=[];return h.forEach(M=>{const U=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(M);U&&U.length>=3&&E.push({pid:parseInt(U[1],10),socket:parseInt(U[2],10)})}),E.reduce((M,U)=>(M[U.socket]=U,M),{})}e.getSockets=b;function I(...l){const h=[].concat(...l.map(r));return[...new Map(h.filter(E=>E.st==="0A").map(E=>{const R=E.local_address.split(":");return{socket:parseInt(E.inode,10),ip:t(R[0]),port:parseInt(R[1],16)}}).map(E=>[E.ip+":"+E.port,E])).values()]}e.loadListeningPorts=I;function t(l){let h="";if(l.length===8)for(let E=l.length-2;E>=0;E-=2)h+=parseInt(l.substr(E,2),16),E!==0&&(h+=".");else for(let E=0;E<l.length;E+=8){const R=l.substring(E,E+8);let M="";for(let U=8;U>=2;U-=2)M+=R.substring(U-2,U),(U===6||U===2)&&(M=parseInt(M,16).toString(16),h+=`${M}`,M="",E+U!==l.length-6&&(h+=":"))}return h}e.parseIpAddress=t;function r(l){const h=l.trim().split(`
`),E=h.shift().trim().split(/\s+/).filter(M=>M!=="rx_queue"&&M!=="tm->when");return h.map(M=>M.trim().split(/\s+/).reduce((U,F,x)=>(U[E[x]||x]=F,U),{}))}e.loadConnectionTable=r;function s(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/server-main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function i(l){const h=l.trim().split(`
`),E=[];return h.forEach(R=>{const M=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(R);M&&M.length>=4&&E.push({pid:parseInt(M[1],10),ppid:parseInt(M[2]),cmd:M[3]})}),E}e.getRootProcesses=i;async function c(l,h,E){const R=E.reduce((U,F)=>(U[F.pid]=F,U),{}),M=[];return l.forEach(({socket:U,ip:F,port:x})=>{const $=h[U]?h[U].pid:void 0,O=$?R[$]?.cmd:void 0;$&&O&&!s(O)&&M.push({host:F,port:x,detail:O,pid:$})}),M}e.findPorts=c;function u(l,h,E){const R=new Map,M=i(h);for(const U of l){const F=E.get(U.port);if(F){R.set(U.port,F);continue}const x=M.find($=>$.cmd.includes(`${U.port}`));if(x){let $=x,O;do O=M.find(K=>K.ppid===$.pid),O&&($=O);while(O);R.set(U.port,{host:U.ip,port:U.port,pid:$.pid,detail:$.cmd,ppid:$.ppid})}else R.set(U.port,{host:U.ip,port:U.port,ppid:Number.MAX_VALUE})}return R}e.tryFindRootPorts=u;let v=class extends m.ExtHostTunnelService{constructor(h,E,R,M){super(h,E,R),this.initData=E,this.signService=M,this._initialCandidates=void 0,this._foundRootPorts=new Map,this._candidateFindingEnabled=!1,f.isLinux&&E.remote.isRemote&&E.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async $registerCandidateFinder(h){if(h&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=h;let E;this._initialCandidates&&(E=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const R=new T.MovingAverage;let M=0;for(;this._candidateFindingEnabled;){const U=new Date().getTime(),F=(await this.findCandidatePorts()).filter(O=>(0,y.isLocalhost)(O.host)||(0,y.isAllInterfaces)(O.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(O=>O.port).join(", ")}`);const x=new Date().getTime()-U;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${x} ms.`),M++>3&&R.update(x),(!E||JSON.stringify(E)!==JSON.stringify(F))&&(E=F,await this._proxy.$onFoundNewCandidates(E));const $=this.calculateDelay(R.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${$} ms.`),await new Promise(O=>setTimeout(()=>O(),$))}}calculateDelay(h){return Math.max(h*20,2e3)}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(h=>h.port).join(", ")}`)}async findCandidatePorts(){let h="",E="";try{h=await P.Promises.readFile("/proc/net/tcp","utf8"),E=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const R=I(h,E),M=await new Promise(fe=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(se,ie,H)=>{fe(ie)})}),U=b(M),F=await P.Promises.readdir("/proc"),x=[];for(const fe of F)try{const se=Number(fe),ie=w.joinPath(g.URI.file("/proc"),fe);if((await P.Promises.stat(ie.fsPath)).isDirectory()&&!isNaN(se)){const re=await P.Promises.readlink(w.joinPath(ie,"cwd").fsPath),Ee=await P.Promises.readFile(w.joinPath(ie,"cmdline").fsPath,"utf8");x.push({pid:se,cwd:re,cmd:Ee})}}catch{}const $=[],O=R.filter(fe=>{const se=U[fe.socket];return se||$.push(fe),se}),K=c(O,U,x);let q;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${$.length}`),$.length>0){const fe=await new Promise(se=>{(0,C.exec)("ps -F -A -l | grep root",(ie,H,re)=>{se(H)})});this._foundRootPorts=u($,fe,this._foundRootPorts),q=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${q.map(se=>se.port).join(", ")}`)}return K.then(fe=>q?fe.concat(q):fe)}makeManagedTunnelFactory(h){return async E=>{const R=new n.NodeRemoteTunnel({commit:this.initData.commit,quality:this.initData.quality,logService:this.logService,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(U,F,x,$){const O=await h.makeConnection();return S.connect(O,F,x,$)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new _.ManagedRemoteConnection(0),connectionToken:h.connectionToken})}},signService:this.signService},"localhost",E.remoteAddress.host||"localhost",E.remoteAddress.port,E.localAddressPort);await R.waitForReady();const M=new d.Emitter;return{localAddress:R.localAddress,remoteAddress:{port:R.tunnelRemotePort,host:R.tunnelRemoteHost},onDidDispose:M.event,dispose:()=>{R.dispose(),M.fire(),M.dispose()}}}}};e.NodeExtHostTunnelService=v,e.NodeExtHostTunnelService=v=qe([$e(0,a.IExtHostRpcService),$e(1,o.IExtHostInitDataService),$e(2,k.ILogService),$e(3,D.ISignService)],v);class S extends p.ManagedSocket{static connect(h,E,R,M){const U=new A.DisposableStore,F={onClose:U.add(new d.Emitter),onData:U.add(new d.Emitter),onEnd:U.add(new d.Emitter)};U.add(h.onDidReceiveMessage($=>F.onData.fire(L.VSBuffer.wrap($)))),U.add(h.onDidEnd(()=>F.onEnd.fire())),U.add(h.onDidClose($=>F.onClose.fire({type:0,error:$,hadError:!!$})));const x=new S(h,M,F);return x._register(U),(0,p.connectManagedSocket)(x,E,R,M,F)}constructor(h,E,R){super(E,R),this.passing=h}write(h){this.passing.send(h.buffer)}closeRemote(){this.passing.end()}async drain(){await this.passing.drain?.()}}}),define(Ce[359],De([1,0,102,331,342,341,354,357,358,94,44,95,93,43,68,90,330,329,17,343,53,251,101,105,136]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o,a,m,b,I,t,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.registerSingleton)(P.IExtHostExtensionService,f.ExtHostExtensionService,0),(0,C.registerSingleton)(a.ILoggerService,o.ExtHostLoggerService,1),(0,C.registerSingleton)(a.ILogService,new t.SyncDescriptor(I.ExtHostLogService,[!1],!0)),(0,C.registerSingleton)(r.ISignService,s.SignService,1),(0,C.registerSingleton)(y.IExtensionStoragePaths,n.ExtensionStoragePaths,0),(0,C.registerSingleton)(g.IExtHostDebugService,A.ExtHostDebugService,0),(0,C.registerSingleton)(k.IExtHostSearch,T.NativeExtHostSearch,0),(0,C.registerSingleton)(p.IExtHostTask,d.ExtHostTask,0),(0,C.registerSingleton)(_.IExtHostTerminalService,L.ExtHostTerminalService,0),(0,C.registerSingleton)(D.IExtHostTunnelService,w.NodeExtHostTunnelService,0),(0,C.registerSingleton)(b.IExtHostVariableResolverProvider,m.NodeExtHostVariableResolverProviderService,0)}),define(Ce[370],De([1,0,57,371,61,8,80,116,237,110,340,21,29,99,13,129,258,276,345,359]),function(me,e,C,L,d,A,T,f,w,g,P,k,p,_,D,y,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}();const a=L(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,u=c._load;c._load=function(v){if(v==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return u.apply(this,arguments)}})();const m=process.exit.bind(process);function b(c){process.exit=function(u){if(c)m(u);else{const v=new Error("An extension called process.exit() and this was prevented.");console.warn(v.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let I=function(c){m()};function t(){const c=(0,o.readExtHostConnection)(process.env);if(c.type===3)return new Promise((u,v)=>{const S=l=>{const h=l[0],E=new T.BufferedEmitter;h.on("message",R=>E.fire(k.VSBuffer.wrap(R.data))),h.on("close",()=>{I("renderer closed the MessagePort")}),h.start(),u({onMessage:E.event,send:R=>h.postMessage(R.buffer)})};process.parentPort.on("message",l=>S(l.ports))});if(c.type===2)return new Promise((u,v)=>{let S=null;const l=setTimeout(()=>{I("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),h=108e5,E=3e5,R=new D.ProcessTimeRunOnceScheduler(()=>I("renderer disconnected for too long (1)"),h),M=new D.ProcessTimeRunOnceScheduler(()=>I("renderer disconnected for too long (2)"),E);process.on("message",(F,x)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){x.setNoDelay(!0);const $=k.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let O;if(F.skipWebSocketFrames)O=new f.NodeSocket(x,"extHost-socket");else{const K=k.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));O=new f.WebSocketNodeSocket(new f.NodeSocket(x,"extHost-socket"),F.permessageDeflate,K,!1)}S?(R.cancel(),M.cancel(),S.beginAcceptReconnection(O,$),S.endAcceptReconnection(),S.sendResume()):(clearTimeout(l),S=new T.PersistentProtocol({socket:O,initialChunk:$}),S.sendResume(),S.onDidDispose(()=>I("renderer disconnected")),u(S),S.onSocketClose(()=>{R.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(M.isScheduled())return;R.isScheduled()&&M.schedule()}});const U={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(U)});{const u=c.pipeName;return new Promise((v,S)=>{const l=C.createConnection(u,()=>{l.removeListener("error",S);const h=new T.PersistentProtocol({socket:new f.NodeSocket(l,"extHost-renderer")});h.sendResume(),v(h)});l.once("error",S),l.on("close",()=>{I("renderer closed the socket")})})}}async function r(){const c=await t();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,c.onMessage(u=>{(0,g.isMessageOfType)(u,2)?(this._terminating=!0,I("received terminate message from renderer")):this._onMessage.fire(u)})}send(u){this._terminating||c.send(u)}async drain(){if(c.drain)return c.drain()}}}function s(c){return new Promise(u=>{const v=c.onMessage(S=>{v.dispose();const l=JSON.parse(S.toString()),h=l.commit,E=w.default.commit;if(h&&E&&h!==E&&m(55),l.parentPid){let R=0;setInterval(function(){try{process.kill(l.parentPid,0),R=0}catch(U){U&&U.code==="EPERM"?(R++,R>=3&&I(`parent process ${l.parentPid} does not exist anymore (3 x EPERM): ${U.message} (code: ${U.code}) (errno: ${U.errno})`)):I(`parent process ${l.parentPid} does not exist anymore: ${U.message} (code: ${U.code}) (errno: ${U.errno})`)}},1e3);let M;try{M=globalThis._VSCODE_NODE_MODULES["native-watchdog"],M.start(l.parentPid)}catch(U){(0,A.onUnexpectedError)(U)}}c.send((0,g.createMessageOfType)(0)),u({protocol:c,initData:l})});c.send((0,g.createMessageOfType)(1))})}async function i(){const c=[];process.on("unhandledRejection",(R,M)=>{c.push(M),setTimeout(()=>{const U=c.indexOf(M);U>=0&&M.catch(F=>{c.splice(U,1),(0,A.isCancellationError)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),R&&(0,A.onUnexpectedError)(R))})},1e3)}),process.on("rejectionHandled",R=>{const M=c.indexOf(R);M>=0&&c.splice(M,1)}),process.on("uncaughtException",function(R){(0,A.isSigPipeError)(R)||(0,A.onUnexpectedError)(R)}),d.mark("code/extHost/willConnectToRenderer");const u=await r();d.mark("code/extHost/didConnectToRenderer");const v=await s(u);d.mark("code/extHost/didWaitForInitData");const{initData:S}=v;b(!!S.environment.extensionTestsLocationURI),S.environment.useHostProxy=a.useHostProxy!==void 0?a.useHostProxy!=="false":void 0,S.environment.skipWorkspaceStorageLock=(0,y.boolean)(a.skipWorkspaceStorageLock,!1);const l=new class{constructor(){this.pid=process.pid}exit(M){m(M)}fsExists(M){return p.Promises.exists(M)}fsRealpath(M){return(0,_.realpath)(M)}};let h=null;S.remote.authority&&a.transformURIs&&(h=(0,n.createURITransformer)(S.remote.authority));const E=new P.ExtensionHostMain(v.protocol,S,l,h);I=R=>E.terminate(R)}i().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a5004432af6600c99fa4f918a3f2f8df44df71e6/core/vs/workbench/api/node/extensionHostProcess.js.map
