/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/base/common/collections","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Te=function(ve){for(var e=[],S=0,A=ve.length;S<A;S++)e[S]=Pe[ve[S]];return e};define(Pe[65],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function S(T){return(h,y,m)=>{let P=null,D=null;if(typeof m.value=="function"?(P="value",D=m.value):typeof m.get=="function"&&(P="get",D=m.get),!D)throw new Error("not supported");m[P]=T(D,y)}}function A(T,h,y){let m=null,P=null;if(typeof y.value=="function"?(m="value",P=y.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(m="get",P=y.get),!P)throw new Error("not supported");const D=`$memoize$${h}`;y[m]=function(...l){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,l)}),this[D]}}e.memoize=A;function I(T,h,y){return S((m,P)=>{const D=`$debounce$${P}`,l=`$debounce$result$${P}`;return function(...E){this[l]||(this[l]=y?y():void 0),clearTimeout(this[D]),h&&(this[l]=h(this[l],...E),E=[this[l]]),this[D]=setTimeout(()=>{m.apply(this,E),this[l]=y?y():void 0},T)}})}e.debounce=I;function L(T,h,y){return S((m,P)=>{const D=`$throttle$timer$${P}`,l=`$throttle$result$${P}`,E=`$throttle$lastRun$${P}`,v=`$throttle$pending$${P}`;return function(...d){if(this[l]||(this[l]=y?y():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),h&&(this[l]=h(this[l],...d)),this[v])return;const t=this[E]+T;t<=Date.now()?(this[E]=Date.now(),m.apply(this,[this[l]]),this[l]=y?y():void 0):(this[v]=!0,this[D]=setTimeout(()=>{this[v]=!1,this[E]=Date.now(),m.apply(this,[this[l]]),this[l]=y?y():void 0},t-Date.now()))}})}e.throttle=L}),define(Pe[88],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class S{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=S,e.defaultGenerator=new S("id#")}),define(Pe[116],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var A;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var I;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function T(n,a=!1){let r=0;const s=n.length;let b="",p=0,w=16,_=0;function o($){let x=0,M=0;for(;x<$;){const ne=n.charCodeAt(r);if(ne>=48&&ne<=57)M=M*16+ne-48;else if(ne>=65&&ne<=70)M=M*16+ne-65+10;else if(ne>=97&&ne<=102)M=M*16+ne-97+10;else break;r++,x++}return x<$&&(M=-1),M}function u($){r=$,b="",p=0,w=16,_=0}function g(){const $=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&m(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&m(n.charCodeAt(r)))for(r++;r<n.length&&m(n.charCodeAt(r));)r++;else return _=3,n.substring($,r);let x=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&m(n.charCodeAt(r))){for(r++;r<n.length&&m(n.charCodeAt(r));)r++;x=r}else _=3;return n.substring($,x)}function O(){let $="",x=r;for(;;){if(r>=s){$+=n.substring(x,r),_=2;break}const M=n.charCodeAt(r);if(M===34){$+=n.substring(x,r),r++;break}if(M===92){if($+=n.substring(x,r),r++,r>=s){_=2;break}switch(n.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const Q=o(4);Q>=0?$+=String.fromCharCode(Q):_=4;break}default:_=5}x=r;continue}if(M>=0&&M<=31)if(y(M)){$+=n.substring(x,r),_=2;break}else _=6;r++}return $}function z(){if(b="",_=0,p=r,r>=s)return p=s,w=17;let $=n.charCodeAt(r);if(h($)){do r++,b+=String.fromCharCode($),$=n.charCodeAt(r);while(h($));return w=15}if(y($))return r++,b+=String.fromCharCode($),$===13&&n.charCodeAt(r)===10&&(r++,b+=`
`),w=14;switch($){case 123:return r++,w=1;case 125:return r++,w=2;case 91:return r++,w=3;case 93:return r++,w=4;case 58:return r++,w=6;case 44:return r++,w=5;case 34:return r++,b=O(),w=10;case 47:{const x=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<s&&!y(n.charCodeAt(r));)r++;return b=n.substring(x,r),w=12}if(n.charCodeAt(r+1)===42){r+=2;const M=s-1;let ne=!1;for(;r<M;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,ne=!0;break}r++}return ne||(r++,_=1),b=n.substring(x,r),w=13}return b+=String.fromCharCode($),r++,w=16}case 45:if(b+=String.fromCharCode($),r++,r===s||!m(n.charCodeAt(r)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=g(),w=11;default:for(;r<s&&H($);)r++,$=n.charCodeAt(r);if(p!==r){switch(b=n.substring(p,r),b){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return b+=String.fromCharCode($),r++,w=16}}function H($){if(h($)||y($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let $;do $=z();while($>=12&&$<=15);return $}return{setPosition:u,getPosition:()=>r,scan:a?B:z,getToken:()=>w,getTokenValue:()=>b,getTokenOffset:()=>p,getTokenLength:()=>r-p,getTokenError:()=>_}}e.createScanner=T;function h(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function y(n){return n===10||n===13||n===8232||n===8233}function m(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function D(n,a){const r=[],s=new Object;let b;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function _(o,u,g,O){p.value=o,p.offset=u,p.length=g,p.type=O,p.colonOffset=void 0,b=p}try{f(n,{onObjectBegin:(o,u)=>{if(a<=o)throw s;b=void 0,w=a>o,r.push("")},onObjectProperty:(o,u,g)=>{if(a<u||(_(o,u,g,"property"),r[r.length-1]=o,a<=u+g))throw s},onObjectEnd:(o,u)=>{if(a<=o)throw s;b=void 0,r.pop()},onArrayBegin:(o,u)=>{if(a<=o)throw s;b=void 0,r.push(0)},onArrayEnd:(o,u)=>{if(a<=o)throw s;b=void 0,r.pop()},onLiteralValue:(o,u,g)=>{if(a<u||(_(o,u,g,k(o)),a<=u+g))throw s},onSeparator:(o,u,g)=>{if(a<=u)throw s;if(o===":"&&b&&b.type==="property")b.colonOffset=u,w=!1,b=void 0;else if(o===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(w=!0,r[r.length-1]=""),b=void 0}}})}catch(o){if(o!==s)throw o}return{path:r,previousNode:b,isAtPropertyKey:w,matches:o=>{let u=0;for(let g=0;u<o.length&&g<r.length;g++)if(o[u]===r[g]||o[u]==="*")u++;else if(o[u]!=="**")return!1;return u===o.length}}}e.getLocation=D;function l(n,a=[],r=L.DEFAULT){let s=null,b=[];const p=[];function w(o){Array.isArray(b)?b.push(o):s!==null&&(b[s]=o)}return f(n,{onObjectBegin:()=>{const o={};w(o),p.push(b),b=o,s=null},onObjectProperty:o=>{s=o},onObjectEnd:()=>{b=p.pop()},onArrayBegin:()=>{const o=[];w(o),p.push(b),b=o,s=null},onArrayEnd:()=>{b=p.pop()},onLiteralValue:w,onError:(o,u,g)=>{a.push({error:o,offset:u,length:g})}},r),b[0]}e.parse=l;function E(n,a=[],r=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(o){s.type==="property"&&(s.length=o-s.offset,s=s.parent)}function p(o){return s.children.push(o),o}f(n,{onObjectBegin:o=>{s=p({type:"object",offset:o,length:-1,parent:s,children:[]})},onObjectProperty:(o,u,g)=>{s=p({type:"property",offset:u,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:o,offset:u,length:g,parent:s})},onObjectEnd:(o,u)=>{s.length=o+u-s.offset,s=s.parent,b(o+u)},onArrayBegin:(o,u)=>{s=p({type:"array",offset:o,length:-1,parent:s,children:[]})},onArrayEnd:(o,u)=>{s.length=o+u-s.offset,s=s.parent,b(o+u)},onLiteralValue:(o,u,g)=>{p({type:k(o),offset:u,length:g,parent:s,value:o}),b(u+g)},onSeparator:(o,u,g)=>{s.type==="property"&&(o===":"?s.colonOffset=u:o===","&&b(u))},onError:(o,u,g)=>{a.push({error:o,offset:u,length:g})}},r);const _=s.children[0];return _&&delete _.parent,_}e.parseTree=E;function v(n,a){if(!n)return;let r=n;for(const s of a)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let b=!1;for(const p of r.children)if(Array.isArray(p.children)&&p.children[0].value===s){r=p.children[1],b=!0;break}if(!b)return}else{const b=s;if(r.type!=="array"||b<0||!Array.isArray(r.children)||b>=r.children.length)return;r=r.children[b]}return r}e.findNodeAtLocation=v;function d(n){if(!n.parent||!n.parent.children)return[];const a=d(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;a.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&a.push(r)}return a}e.getNodePath=d;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const a=Object.create(null);for(const r of n.children){const s=r.children[1];s&&(a[r.children[0].value]=t(s))}return a}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=t;function i(n,a,r=!1){return a>=n.offset&&a<n.offset+n.length||r&&a===n.offset+n.length}e.contains=i;function c(n,a,r=!1){if(i(n,a,r)){const s=n.children;if(Array.isArray(s))for(let b=0;b<s.length&&s[b].offset<=a;b++){const p=c(s[b],a,r);if(p)return p}return n}}e.findNodeAtOffset=c;function f(n,a,r=L.DEFAULT){const s=T(n,!1);function b(ke){return ke?()=>ke(s.getTokenOffset(),s.getTokenLength()):()=>!0}function p(ke){return ke?ae=>ke(ae,s.getTokenOffset(),s.getTokenLength()):()=>!0}const w=b(a.onObjectBegin),_=p(a.onObjectProperty),o=b(a.onObjectEnd),u=b(a.onArrayBegin),g=b(a.onArrayEnd),O=p(a.onLiteralValue),z=p(a.onSeparator),H=b(a.onComment),B=p(a.onError),$=r&&r.disallowComments,x=r&&r.allowTrailingComma;function M(){for(;;){const ke=s.scan();switch(s.getTokenError()){case 4:ne(14);break;case 5:ne(15);break;case 3:ne(13);break;case 1:$||ne(11);break;case 2:ne(12);break;case 6:ne(16);break}switch(ke){case 12:case 13:$?ne(10):H();break;case 16:ne(1);break;case 15:case 14:break;default:return ke}}}function ne(ke,ae=[],J=[]){if(B(ke),ae.length+J.length>0){let le=s.getToken();for(;le!==17;){if(ae.indexOf(le)!==-1){M();break}else if(J.indexOf(le)!==-1)break;le=M()}}}function Q(ke){const ae=s.getTokenValue();return ke?O(ae):_(ae),M(),!0}function we(){switch(s.getToken()){case 11:{let ke=0;try{ke=JSON.parse(s.getTokenValue()),typeof ke!="number"&&(ne(2),ke=0)}catch{ne(2)}O(ke);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return M(),!0}function _e(){return s.getToken()!==10?(ne(3,[],[2,5]),!1):(Q(!1),s.getToken()===6?(z(":"),M(),he()||ne(4,[],[2,5])):ne(5,[],[2,5]),!0)}function Ae(){w(),M();let ke=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ke||ne(4,[],[]),z(","),M(),s.getToken()===2&&x)break}else ke&&ne(6,[],[]);_e()||ne(4,[],[2,5]),ke=!0}return o(),s.getToken()!==2?ne(7,[2],[]):M(),!0}function Y(){u(),M();let ke=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ke||ne(4,[],[]),z(","),M(),s.getToken()===4&&x)break}else ke&&ne(6,[],[]);he()||ne(4,[],[4,5]),ke=!0}return g(),s.getToken()!==4?ne(8,[4],[]):M(),!0}function he(){switch(s.getToken()){case 3:return Y();case 1:return Ae();case 10:return Q(!0);default:return we()}}return M(),s.getToken()===17?r.allowEmptyContent?!0:(ne(4,[],[]),!1):he()?(s.getToken()!==17&&ne(9,[],[]),!0):(ne(4,[],[]),!1)}e.visit=f;function C(n,a){const r=T(n),s=[];let b,p=0,w;do switch(w=r.getPosition(),b=r.scan(),b){case 12:case 13:case 17:p!==w&&s.push(n.substring(p,w)),a!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,a)),p=r.getPosition();break}while(b!==17);return s.join("")}e.stripComments=C;function k(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(Pe[28],Te([1,0]),function(ve,e){"use strict";var S,A,I;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(d,t,i){let c=d.get(t);return c===void 0&&(c=i,d.set(t,c)),c}e.getOrSet=L;function T(d){const t=[];return d.forEach((i,c)=>{t.push(`${c} => ${i}`)}),`Map(${d.size}) {${t.join(", ")}}`}e.mapToString=T;function h(d){const t=[];return d.forEach(i=>{t.push(i)}),`Set(${d.size}) {${t.join(", ")}}`}e.setToString=h;class y{constructor(t,i){this.uri=t,this.value=i}}class m{static{this.defaultToKey=t=>t.toString()}constructor(t,i){this[S]="ResourceMap",t instanceof m?(this.map=new Map(t.map),this.toKey=i??m.defaultToKey):(this.map=new Map,this.toKey=t??m.defaultToKey)}set(t,i){return this.map.set(this.toKey(t),new y(t,i)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,i){typeof i<"u"&&(t=t.bind(i));for(const[c,f]of this.map)t(f.value,f.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=m;class P{constructor(t,i){this[A]="ResourceSet",!t||typeof t=="function"?this._map=new m(t):(this._map=new m(i),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,i){this._map.forEach((c,f)=>t.call(i,f,f,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=P;var D;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(D||(e.Touch=D={}));class l{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,i=0){const c=this._map.get(t);if(c)return i!==0&&this.touch(c,i),c.value}set(t,i,c=0){let f=this._map.get(t);if(f)f.value=i,c!==0&&this.touch(f,c);else{switch(f={key:t,value:i,next:void 0,previous:void 0},c){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(t,f),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const i=this._map.get(t);if(i)return this._map.delete(t),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,i){const c=this._state;let f=this._head;for(;f;){if(i?t.bind(i)(f.value,f.key,this):t(f.value,f.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const t=this,i=this._state;let c=this._head;const f={[Symbol.iterator](){return f},next(){if(t._state!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:c.key,done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return f}values(){const t=this,i=this._state;let c=this._head;const f={[Symbol.iterator](){return f},next(){if(t._state!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:c.value,done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return f}entries(){const t=this,i=this._state;let c=this._head;const f={[Symbol.iterator](){return f},next(){if(t._state!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:[c.key,c.value],done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return f}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let i=this._head,c=this.size;for(;i&&c>t;)this._map.delete(i.key),i=i.next,c--;this._head=i,this._size=c,i&&(i.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const i=t.next,c=t.previous;if(!i||!c)throw new Error("Invalid list");i.previous=c,c.next=i}t.next=void 0,t.previous=void 0,this._state++}touch(t,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(t===this._head)return;const c=t.next,f=t.previous;t===this._tail?(f.next=void 0,this._tail=f):(c.previous=f,f.next=c),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(i===2){if(t===this._tail)return;const c=t.next,f=t.previous;t===this._head?(c.previous=void 0,this._head=c):(c.previous=f,f.next=c),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((i,c)=>{t.push([c,i])}),t}fromJSON(t){this.clear();for(const[i,c]of t)this.set(i,c)}}e.LinkedMap=l;class E extends l{constructor(t,i=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,i=2){return super.get(t,i)}peek(t){return super.get(t,0)}set(t,i){return super.set(t,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=E;class v{constructor(){this.map=new Map}add(t){return this.map.set(t,(this.map.get(t)||0)+1),this}delete(t){let i=this.map.get(t)||0;return i===0?!1:(i--,i===0?this.map.delete(t):this.map.set(t,i),!0)}has(t){return this.map.has(t)}}e.CounterSet=v}),function(ve,e){typeof define=="function"&&define.amd?define(Pe[117],Te([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ve=typeof globalThis<"u"?globalThis:ve||self,e(ve.marked={}))}(this,function(ve){"use strict";function e(be,Ee){for(var ye=0;ye<Ee.length;ye++){var oe=Ee[ye];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(be,oe.key,oe)}}function S(be,Ee,ye){return Ee&&e(be.prototype,Ee),ye&&e(be,ye),Object.defineProperty(be,"prototype",{writable:!1}),be}function A(be,Ee){if(be){if(typeof be=="string")return I(be,Ee);var ye=Object.prototype.toString.call(be).slice(8,-1);if(ye==="Object"&&be.constructor&&(ye=be.constructor.name),ye==="Map"||ye==="Set")return Array.from(be);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return I(be,Ee)}}function I(be,Ee){(Ee==null||Ee>be.length)&&(Ee=be.length);for(var ye=0,oe=new Array(Ee);ye<Ee;ye++)oe[ye]=be[ye];return oe}function L(be,Ee){var ye=typeof Symbol<"u"&&be[Symbol.iterator]||be["@@iterator"];if(ye)return(ye=ye.call(be)).next.bind(ye);if(Array.isArray(be)||(ye=A(be))||Ee&&be&&typeof be.length=="number"){ye&&(be=ye);var oe=0;return function(){return oe>=be.length?{done:!0}:{done:!1,value:be[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ve.defaults=T();function h(be){ve.defaults=be}var y=/[&<>"']/,m=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(Ee){return l[Ee]};function v(be,Ee){if(Ee){if(y.test(be))return be.replace(m,E)}else if(P.test(be))return be.replace(D,E);return be}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(be){return be.replace(d,function(Ee,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var i=/(^|[^\[])\^/g;function c(be,Ee){be=typeof be=="string"?be:be.source,Ee=Ee||"";var ye={replace:function(de,re){return re=re.source||re,re=re.replace(i,"$1"),be=be.replace(de,re),ye},getRegex:function(){return new RegExp(be,Ee)}};return ye}var f=/[^\w:]/g,C=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function k(be,Ee,ye){if(be){var oe;try{oe=decodeURIComponent(t(ye)).replace(f,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}Ee&&!C.test(ye)&&(ye=b(Ee,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var n={},a=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(be,Ee){n[" "+be]||(a.test(be)?n[" "+be]=be+"/":n[" "+be]=o(be,"/",!0)),be=n[" "+be];var ye=be.indexOf(":")===-1;return Ee.substring(0,2)==="//"?ye?Ee:be.replace(r,"$1")+Ee:Ee.charAt(0)==="/"?ye?Ee:be.replace(s,"$1")+Ee:be+Ee}var p={exec:function(){}};function w(be){for(var Ee=1,ye,oe;Ee<arguments.length;Ee++){ye=arguments[Ee];for(oe in ye)Object.prototype.hasOwnProperty.call(ye,oe)&&(be[oe]=ye[oe])}return be}function _(be,Ee){var ye=be.replace(/\|/g,function(re,ie,me){for(var Ce=!1,R=ie;--R>=0&&me[R]==="\\";)Ce=!Ce;return Ce?"|":" |"}),oe=ye.split(/ \|/),de=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>Ee)oe.splice(Ee);else for(;oe.length<Ee;)oe.push("");for(;de<oe.length;de++)oe[de]=oe[de].trim().replace(/\\\|/g,"|");return oe}function o(be,Ee,ye){var oe=be.length;if(oe===0)return"";for(var de=0;de<oe;){var re=be.charAt(oe-de-1);if(re===Ee&&!ye)de++;else if(re!==Ee&&ye)de++;else break}return be.slice(0,oe-de)}function u(be,Ee){if(be.indexOf(Ee[1])===-1)return-1;for(var ye=be.length,oe=0,de=0;de<ye;de++)if(be[de]==="\\")de++;else if(be[de]===Ee[0])oe++;else if(be[de]===Ee[1]&&(oe--,oe<0))return de;return-1}function g(be){be&&be.sanitize&&!be.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(be,Ee){if(Ee<1)return"";for(var ye="";Ee>1;)Ee&1&&(ye+=be),Ee>>=1,be+=be;return ye+be}function z(be,Ee,ye,oe){var de=Ee.href,re=Ee.title?v(Ee.title):null,ie=be[1].replace(/\\([\[\]])/g,"$1");if(be[0].charAt(0)!=="!"){oe.state.inLink=!0;var me={type:"link",raw:ye,href:de,title:re,text:ie,tokens:oe.inlineTokens(ie)};return oe.state.inLink=!1,me}return{type:"image",raw:ye,href:de,title:re,text:v(ie)}}function H(be,Ee){var ye=be.match(/^(\s+)(?:```)/);if(ye===null)return Ee;var oe=ye[1];return Ee.split(`
`).map(function(de){var re=de.match(/^\s+/);if(re===null)return de;var ie=re[0];return ie.length>=oe.length?de.slice(oe.length):de}).join(`
`)}var B=function(){function be(ye){this.options=ye||ve.defaults}var Ee=be.prototype;return Ee.space=function(oe){var de=this.rules.block.newline.exec(oe);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},Ee.code=function(oe){var de=this.rules.block.code.exec(oe);if(de){var re=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?re:o(re,`
`)}}},Ee.fences=function(oe){var de=this.rules.block.fences.exec(oe);if(de){var re=de[0],ie=H(re,de[3]||"");return{type:"code",raw:re,lang:de[2]?de[2].trim():de[2],text:ie}}},Ee.heading=function(oe){var de=this.rules.block.heading.exec(oe);if(de){var re=de[2].trim();if(/#$/.test(re)){var ie=o(re,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(re=ie.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:re,tokens:this.lexer.inline(re)}}},Ee.hr=function(oe){var de=this.rules.block.hr.exec(oe);if(de)return{type:"hr",raw:de[0]}},Ee.blockquote=function(oe){var de=this.rules.block.blockquote.exec(oe);if(de){var re=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(re,[]),text:re}}},Ee.list=function(oe){var de=this.rules.block.list.exec(oe);if(de){var re,ie,me,Ce,R,W,K,G,V,ee,ce,Me,xe=de[1].trim(),Ge=xe.length>1,je={type:"list",raw:"",ordered:Ge,start:Ge?+xe.slice(0,-1):"",loose:!1,items:[]};xe=Ge?"\\d{1,9}\\"+xe.slice(-1):"\\"+xe,this.options.pedantic&&(xe=Ge?xe:"[*+-]");for(var et=new RegExp("^( {0,3}"+xe+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(Me=!1,!(!(de=et.exec(oe))||this.rules.block.hr.test(oe)));){if(re=de[0],oe=oe.substring(re.length),G=de[2].split(`
`,1)[0],V=oe.split(`
`,1)[0],this.options.pedantic?(Ce=2,ce=G.trimLeft()):(Ce=de[2].search(/[^ ]/),Ce=Ce>4?1:Ce,ce=G.slice(Ce),Ce+=de[1].length),W=!1,!G&&/^ *$/.test(V)&&(re+=V+`
`,oe=oe.substring(V.length+1),Me=!0),!Me)for(var Ye=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ze=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}#");oe&&(ee=oe.split(`
`,1)[0],G=ee,this.options.pedantic&&(G=G.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(G)||tt.test(G)||Ye.test(G)||Ze.test(oe)));){if(G.search(/[^ ]/)>=Ce||!G.trim())ce+=`
`+G.slice(Ce);else if(!W)ce+=`
`+G;else break;!W&&!G.trim()&&(W=!0),re+=ee+`
`,oe=oe.substring(ee.length+1)}je.loose||(K?je.loose=!0:/\n *\n *$/.test(re)&&(K=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(ce),ie&&(me=ie[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:re,task:!!ie,checked:me,loose:!1,text:ce}),je.raw+=re}je.items[je.items.length-1].raw=re.trimRight(),je.items[je.items.length-1].text=ce.trimRight(),je.raw=je.raw.trimRight();var Ue=je.items.length;for(R=0;R<Ue;R++){this.lexer.state.top=!1,je.items[R].tokens=this.lexer.blockTokens(je.items[R].text,[]);var st=je.items[R].tokens.filter(function(X){return X.type==="space"}),Z=st.every(function(X){for(var pe=X.raw.split(""),$e=0,Ne=L(pe),Xe;!(Xe=Ne()).done;){var nt=Xe.value;if(nt===`
`&&($e+=1),$e>1)return!0}return!1});!je.loose&&st.length&&Z&&(je.loose=!0,je.items[R].loose=!0)}return je}},Ee.html=function(oe){var de=this.rules.block.html.exec(oe);if(de){var re={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(de[0]):v(de[0]);re.type="paragraph",re.text=ie,re.tokens=this.lexer.inline(ie)}return re}},Ee.def=function(oe){var de=this.rules.block.def.exec(oe);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var re=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:re,raw:de[0],href:de[2],title:de[3]}}},Ee.table=function(oe){var de=this.rules.block.table.exec(oe);if(de){var re={type:"table",header:_(de[1]).map(function(K){return{text:K}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(re.header.length===re.align.length){re.raw=de[0];var ie=re.align.length,me,Ce,R,W;for(me=0;me<ie;me++)/^ *-+: *$/.test(re.align[me])?re.align[me]="right":/^ *:-+: *$/.test(re.align[me])?re.align[me]="center":/^ *:-+ *$/.test(re.align[me])?re.align[me]="left":re.align[me]=null;for(ie=re.rows.length,me=0;me<ie;me++)re.rows[me]=_(re.rows[me],re.header.length).map(function(K){return{text:K}});for(ie=re.header.length,Ce=0;Ce<ie;Ce++)re.header[Ce].tokens=this.lexer.inline(re.header[Ce].text);for(ie=re.rows.length,Ce=0;Ce<ie;Ce++)for(W=re.rows[Ce],R=0;R<W.length;R++)W[R].tokens=this.lexer.inline(W[R].text);return re}}},Ee.lheading=function(oe){var de=this.rules.block.lheading.exec(oe);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},Ee.paragraph=function(oe){var de=this.rules.block.paragraph.exec(oe);if(de){var re=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:re,tokens:this.lexer.inline(re)}}},Ee.text=function(oe){var de=this.rules.block.text.exec(oe);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},Ee.escape=function(oe){var de=this.rules.inline.escape.exec(oe);if(de)return{type:"escape",raw:de[0],text:v(de[1])}},Ee.tag=function(oe){var de=this.rules.inline.tag.exec(oe);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):v(de[0]):de[0]}},Ee.link=function(oe){var de=this.rules.inline.link.exec(oe);if(de){var re=de[2].trim();if(!this.options.pedantic&&/^</.test(re)){if(!/>$/.test(re))return;var ie=o(re.slice(0,-1),"\\");if((re.length-ie.length)%2===0)return}else{var me=u(de[2],"()");if(me>-1){var Ce=de[0].indexOf("!")===0?5:4,R=Ce+de[1].length+me;de[2]=de[2].substring(0,me),de[0]=de[0].substring(0,R).trim(),de[3]=""}}var W=de[2],K="";if(this.options.pedantic){var G=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(W);G&&(W=G[1],K=G[3])}else K=de[3]?de[3].slice(1,-1):"";return W=W.trim(),/^</.test(W)&&(this.options.pedantic&&!/>$/.test(re)?W=W.slice(1):W=W.slice(1,-1)),z(de,{href:W&&W.replace(this.rules.inline._escapes,"$1"),title:K&&K.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},Ee.reflink=function(oe,de){var re;if((re=this.rules.inline.reflink.exec(oe))||(re=this.rules.inline.nolink.exec(oe))){var ie=(re[2]||re[1]).replace(/\s+/g," ");if(ie=de[ie.toLowerCase()],!ie||!ie.href){var me=re[0].charAt(0);return{type:"text",raw:me,text:me}}return z(re,ie,re[0],this.lexer)}},Ee.emStrong=function(oe,de,re){re===void 0&&(re="");var ie=this.rules.inline.emStrong.lDelim.exec(oe);if(ie&&!(ie[3]&&re.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var me=ie[1]||ie[2]||"";if(!me||me&&(re===""||this.rules.inline.punctuation.exec(re))){var Ce=ie[0].length-1,R,W,K=Ce,G=0,V=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,de=de.slice(-1*oe.length+Ce);(ie=V.exec(de))!=null;)if(R=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!R){if(W=R.length,ie[3]||ie[4]){K+=W;continue}else if((ie[5]||ie[6])&&Ce%3&&!((Ce+W)%3)){G+=W;continue}if(K-=W,!(K>0)){if(W=Math.min(W,W+K+G),Math.min(Ce,W)%2){var ee=oe.slice(1,Ce+ie.index+W);return{type:"em",raw:oe.slice(0,Ce+ie.index+W+1),text:ee,tokens:this.lexer.inlineTokens(ee)}}var ce=oe.slice(2,Ce+ie.index+W-1);return{type:"strong",raw:oe.slice(0,Ce+ie.index+W+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},Ee.codespan=function(oe){var de=this.rules.inline.code.exec(oe);if(de){var re=de[2].replace(/\n/g," "),ie=/[^ ]/.test(re),me=/^ /.test(re)&&/ $/.test(re);return ie&&me&&(re=re.substring(1,re.length-1)),re=v(re,!0),{type:"codespan",raw:de[0],text:re}}},Ee.br=function(oe){var de=this.rules.inline.br.exec(oe);if(de)return{type:"br",raw:de[0]}},Ee.del=function(oe){var de=this.rules.inline.del.exec(oe);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},Ee.autolink=function(oe,de){var re=this.rules.inline.autolink.exec(oe);if(re){var ie,me;return re[2]==="@"?(ie=v(this.options.mangle?de(re[1]):re[1]),me="mailto:"+ie):(ie=v(re[1]),me=ie),{type:"link",raw:re[0],text:ie,href:me,tokens:[{type:"text",raw:ie,text:ie}]}}},Ee.url=function(oe,de){var re;if(re=this.rules.inline.url.exec(oe)){var ie,me;if(re[2]==="@")ie=v(this.options.mangle?de(re[0]):re[0]),me="mailto:"+ie;else{var Ce;do Ce=re[0],re[0]=this.rules.inline._backpedal.exec(re[0])[0];while(Ce!==re[0]);ie=v(re[0]),re[1]==="www."?me="http://"+ie:me=ie}return{type:"link",raw:re[0],text:ie,href:me,tokens:[{type:"text",raw:ie,text:ie}]}}},Ee.inlineText=function(oe,de){var re=this.rules.inline.text.exec(oe);if(re){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):v(re[0]):re[0]:ie=v(this.options.smartypants?de(re[0]):re[0]),{type:"text",raw:re[0],text:ie}}},be}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=c($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=c(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=c($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=c($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=c($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=c($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=w({},$),$.gfm=w({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=c($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=c($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=w({},$.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:c($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var x={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};x._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",x.punctuation=c(x.punctuation).replace(/punctuation/g,x._punctuation).getRegex(),x.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,x.escapedEmSt=/\\\*|\\_/g,x._comment=c($._comment).replace("(?:-->|$)","-->").getRegex(),x.emStrong.lDelim=c(x.emStrong.lDelim).replace(/punct/g,x._punctuation).getRegex(),x.emStrong.rDelimAst=c(x.emStrong.rDelimAst,"g").replace(/punct/g,x._punctuation).getRegex(),x.emStrong.rDelimUnd=c(x.emStrong.rDelimUnd,"g").replace(/punct/g,x._punctuation).getRegex(),x._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,x._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,x._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,x.autolink=c(x.autolink).replace("scheme",x._scheme).replace("email",x._email).getRegex(),x._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,x.tag=c(x.tag).replace("comment",x._comment).replace("attribute",x._attribute).getRegex(),x._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,x._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,x._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,x.link=c(x.link).replace("label",x._label).replace("href",x._href).replace("title",x._title).getRegex(),x.reflink=c(x.reflink).replace("label",x._label).replace("ref",$._label).getRegex(),x.nolink=c(x.nolink).replace("ref",$._label).getRegex(),x.reflinkSearch=c(x.reflinkSearch,"g").replace("reflink",x.reflink).replace("nolink",x.nolink).getRegex(),x.normal=w({},x),x.pedantic=w({},x.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",x._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",x._label).getRegex()}),x.gfm=w({},x.normal,{escape:c(x.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),x.gfm.url=c(x.gfm.url,"i").replace("email",x.gfm._extended_email).getRegex(),x.breaks=w({},x.gfm,{br:c(x.br).replace("{2,}","*").getRegex(),text:c(x.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(be){return be.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ne(be){var Ee="",ye,oe,de=be.length;for(ye=0;ye<de;ye++)oe=be.charCodeAt(ye),Math.random()>.5&&(oe="x"+oe.toString(16)),Ee+="&#"+oe+";";return Ee}var Q=function(){function be(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||ve.defaults,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:$.normal,inline:x.normal};this.options.pedantic?(oe.block=$.pedantic,oe.inline=x.pedantic):this.options.gfm&&(oe.block=$.gfm,this.options.breaks?oe.inline=x.breaks:oe.inline=x.gfm),this.tokenizer.rules=oe}be.lex=function(oe,de){var re=new be(de);return re.lex(oe)},be.lexInline=function(oe,de){var re=new be(de);return re.inlineTokens(oe)};var Ee=be.prototype;return Ee.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},Ee.blockTokens=function(oe,de){var re=this;de===void 0&&(de=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(K,G,V){return G+"    ".repeat(V.length)});for(var ie,me,Ce,R;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(K){return(ie=K.call({lexer:re},oe,de))?(oe=oe.substring(ie.raw.length),de.push(ie),!0):!1}))){if(ie=this.tokenizer.space(oe)){oe=oe.substring(ie.raw.length),ie.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ie);continue}if(ie=this.tokenizer.code(oe)){oe=oe.substring(ie.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ie.raw,me.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ie);continue}if(ie=this.tokenizer.fences(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.heading(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.hr(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.blockquote(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.list(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.html(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.def(oe)){oe=oe.substring(ie.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ie.raw,me.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=me.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.lheading(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(Ce=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var K=1/0,G=oe.slice(1),V=void 0;re.options.extensions.startBlock.forEach(function(ee){V=ee.call({lexer:this},G),typeof V=="number"&&V>=0&&(K=Math.min(K,V))}),K<1/0&&K>=0&&(Ce=oe.substring(0,K+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(Ce))){me=de[de.length-1],R&&me.type==="paragraph"?(me.raw+=`
`+ie.raw,me.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ie),R=Ce.length!==oe.length,oe=oe.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(oe)){oe=oe.substring(ie.raw.length),me=de[de.length-1],me&&me.type==="text"?(me.raw+=`
`+ie.raw,me.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ie);continue}if(oe){var W="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(W);break}else throw new Error(W)}}return this.state.top=!0,de},Ee.inline=function(oe,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:oe,tokens:de}),de},Ee.inlineTokens=function(oe,de){var re=this;de===void 0&&(de=[]);var ie,me,Ce,R=oe,W,K,G;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(W=this.tokenizer.rules.inline.reflinkSearch.exec(R))!=null;)V.includes(W[0].slice(W[0].lastIndexOf("[")+1,-1))&&(R=R.slice(0,W.index)+"["+O("a",W[0].length-2)+"]"+R.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(W=this.tokenizer.rules.inline.blockSkip.exec(R))!=null;)R=R.slice(0,W.index)+"["+O("a",W[0].length-2)+"]"+R.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(W=this.tokenizer.rules.inline.escapedEmSt.exec(R))!=null;)R=R.slice(0,W.index)+"++"+R.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(K||(G=""),K=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(ie=ce.call({lexer:re},oe,de))?(oe=oe.substring(ie.raw.length),de.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.tag(oe)){oe=oe.substring(ie.raw.length),me=de[de.length-1],me&&ie.type==="text"&&me.type==="text"?(me.raw+=ie.raw,me.text+=ie.text):de.push(ie);continue}if(ie=this.tokenizer.link(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ie.raw.length),me=de[de.length-1],me&&ie.type==="text"&&me.type==="text"?(me.raw+=ie.raw,me.text+=ie.text):de.push(ie);continue}if(ie=this.tokenizer.emStrong(oe,R,G)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.codespan(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.br(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.del(oe)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(ie=this.tokenizer.autolink(oe,ne)){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(oe,ne))){oe=oe.substring(ie.raw.length),de.push(ie);continue}if(Ce=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,Me=oe.slice(1),xe=void 0;re.options.extensions.startInline.forEach(function(Ge){xe=Ge.call({lexer:this},Me),typeof xe=="number"&&xe>=0&&(ce=Math.min(ce,xe))}),ce<1/0&&ce>=0&&(Ce=oe.substring(0,ce+1))}(),ie=this.tokenizer.inlineText(Ce,M)){oe=oe.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(G=ie.raw.slice(-1)),K=!0,me=de[de.length-1],me&&me.type==="text"?(me.raw+=ie.raw,me.text+=ie.text):de.push(ie);continue}if(oe){var ee="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return de},S(be,null,[{key:"rules",get:function(){return{block:$,inline:x}}}]),be}(),we=function(){function be(ye){this.options=ye||ve.defaults}var Ee=be.prototype;return Ee.code=function(oe,de,re){var ie=(de||"").match(/\S*/)[0];if(this.options.highlight){var me=this.options.highlight(oe,ie);me!=null&&me!==oe&&(re=!0,oe=me)}return oe=oe.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+v(ie,!0)+'">'+(re?oe:v(oe,!0))+`</code></pre>
`:"<pre><code>"+(re?oe:v(oe,!0))+`</code></pre>
`},Ee.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},Ee.html=function(oe){return oe},Ee.heading=function(oe,de,re,ie){if(this.options.headerIds){var me=this.options.headerPrefix+ie.slug(re);return"<h"+de+' id="'+me+'">'+oe+"</h"+de+`>
`}return"<h"+de+">"+oe+"</h"+de+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(oe,de,re){var ie=de?"ol":"ul",me=de&&re!==1?' start="'+re+'"':"";return"<"+ie+me+`>
`+oe+"</"+ie+`>
`},Ee.listitem=function(oe){return"<li>"+oe+`</li>
`},Ee.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(oe){return"<p>"+oe+`</p>
`},Ee.table=function(oe,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+de+`</table>
`},Ee.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},Ee.tablecell=function(oe,de){var re=de.header?"th":"td",ie=de.align?"<"+re+' align="'+de.align+'">':"<"+re+">";return ie+oe+("</"+re+`>
`)},Ee.strong=function(oe){return"<strong>"+oe+"</strong>"},Ee.em=function(oe){return"<em>"+oe+"</em>"},Ee.codespan=function(oe){return"<code>"+oe+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(oe){return"<del>"+oe+"</del>"},Ee.link=function(oe,de,re){if(oe=k(this.options.sanitize,this.options.baseUrl,oe),oe===null)return re;var ie='<a href="'+v(oe)+'"';return de&&(ie+=' title="'+de+'"'),ie+=">"+re+"</a>",ie},Ee.image=function(oe,de,re){if(oe=k(this.options.sanitize,this.options.baseUrl,oe),oe===null)return re;var ie='<img src="'+oe+'" alt="'+re+'"';return de&&(ie+=' title="'+de+'"'),ie+=this.options.xhtml?"/>":">",ie},Ee.text=function(oe){return oe},be}(),_e=function(){function be(){}var Ee=be.prototype;return Ee.strong=function(oe){return oe},Ee.em=function(oe){return oe},Ee.codespan=function(oe){return oe},Ee.del=function(oe){return oe},Ee.html=function(oe){return oe},Ee.text=function(oe){return oe},Ee.link=function(oe,de,re){return""+re},Ee.image=function(oe,de,re){return""+re},Ee.br=function(){return""},be}(),Ae=function(){function be(){this.seen={}}var Ee=be.prototype;return Ee.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(oe,de){var re=oe,ie=0;if(this.seen.hasOwnProperty(re)){ie=this.seen[oe];do ie++,re=oe+"-"+ie;while(this.seen.hasOwnProperty(re))}return de||(this.seen[oe]=ie,this.seen[re]=0),re},Ee.slug=function(oe,de){de===void 0&&(de={});var re=this.serialize(oe);return this.getNextSafeSlug(re,de.dryrun)},be}(),Y=function(){function be(ye){this.options=ye||ve.defaults,this.options.renderer=this.options.renderer||new we,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _e,this.slugger=new Ae}be.parse=function(oe,de){var re=new be(de);return re.parse(oe)},be.parseInline=function(oe,de){var re=new be(de);return re.parseInline(oe)};var Ee=be.prototype;return Ee.parse=function(oe,de){de===void 0&&(de=!0);var re="",ie,me,Ce,R,W,K,G,V,ee,ce,Me,xe,Ge,je,et,Ye,Ze,it,tt,Ue=oe.length;for(ie=0;ie<Ue;ie++){if(ce=oe[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){re+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{re+=this.renderer.hr();continue}case"heading":{re+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,t(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{re+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(V="",G="",R=ce.header.length,me=0;me<R;me++)G+=this.renderer.tablecell(this.parseInline(ce.header[me].tokens),{header:!0,align:ce.align[me]});for(V+=this.renderer.tablerow(G),ee="",R=ce.rows.length,me=0;me<R;me++){for(K=ce.rows[me],G="",W=K.length,Ce=0;Ce<W;Ce++)G+=this.renderer.tablecell(this.parseInline(K[Ce].tokens),{header:!1,align:ce.align[Ce]});ee+=this.renderer.tablerow(G)}re+=this.renderer.table(V,ee);continue}case"blockquote":{ee=this.parse(ce.tokens),re+=this.renderer.blockquote(ee);continue}case"list":{for(Me=ce.ordered,xe=ce.start,Ge=ce.loose,R=ce.items.length,ee="",me=0;me<R;me++)et=ce.items[me],Ye=et.checked,Ze=et.task,je="",et.task&&(it=this.renderer.checkbox(Ye),Ge?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=it+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=it+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:it}):je+=it),je+=this.parse(et.tokens,Ge),ee+=this.renderer.listitem(je,Ze,Ye);re+=this.renderer.list(ee,Me,xe);continue}case"html":{re+=this.renderer.html(ce.text);continue}case"paragraph":{re+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(ee=ce.tokens?this.parseInline(ce.tokens):ce.text;ie+1<Ue&&oe[ie+1].type==="text";)ce=oe[++ie],ee+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);re+=de?this.renderer.paragraph(ee):ee;continue}default:{var st='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return re},Ee.parseInline=function(oe,de){de=de||this.renderer;var re="",ie,me,Ce,R=oe.length;for(ie=0;ie<R;ie++){if(me=oe[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(Ce=this.options.extensions.renderers[me.type].call({parser:this},me),Ce!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(me.type))){re+=Ce||"";continue}switch(me.type){case"escape":{re+=de.text(me.text);break}case"html":{re+=de.html(me.text);break}case"link":{re+=de.link(me.href,me.title,this.parseInline(me.tokens,de));break}case"image":{re+=de.image(me.href,me.title,me.text);break}case"strong":{re+=de.strong(this.parseInline(me.tokens,de));break}case"em":{re+=de.em(this.parseInline(me.tokens,de));break}case"codespan":{re+=de.codespan(me.text);break}case"br":{re+=de.br();break}case"del":{re+=de.del(this.parseInline(me.tokens,de));break}case"text":{re+=de.text(me.text);break}default:{var W='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(W);return}else throw new Error(W)}}}return re},be}();function he(be,Ee,ye){if(typeof be>"u"||be===null)throw new Error("marked(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");if(typeof Ee=="function"&&(ye=Ee,Ee=null),Ee=w({},he.defaults,Ee||{}),g(Ee),ye){var oe=Ee.highlight,de;try{de=Q.lex(be,Ee)}catch(R){return ye(R)}var re=function(W){var K;if(!W)try{Ee.walkTokens&&he.walkTokens(de,Ee.walkTokens),K=Y.parse(de,Ee)}catch(G){W=G}return Ee.highlight=oe,W?ye(W):ye(null,K)};if(!oe||oe.length<3||(delete Ee.highlight,!de.length))return re();var ie=0;he.walkTokens(de,function(R){R.type==="code"&&(ie++,setTimeout(function(){oe(R.text,R.lang,function(W,K){if(W)return re(W);K!=null&&K!==R.text&&(R.text=K,R.escaped=!0),ie--,ie===0&&re()})},0))}),ie===0&&re();return}function me(R){if(R.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+v(R.message+"",!0)+"</pre>";throw R}try{var Ce=Q.lex(be,Ee);if(Ee.walkTokens){if(Ee.async)return Promise.all(he.walkTokens(Ce,Ee.walkTokens)).then(function(){return Y.parse(Ce,Ee)}).catch(me);he.walkTokens(Ce,Ee.walkTokens)}return Y.parse(Ce,Ee)}catch(R){me(R)}}he.options=he.setOptions=function(be){return w(he.defaults,be),h(he.defaults),he},he.getDefaults=T,he.defaults=ve.defaults,he.use=function(){for(var be=arguments.length,Ee=new Array(be),ye=0;ye<be;ye++)Ee[ye]=arguments[ye];var oe=w.apply(void 0,[{}].concat(Ee)),de=he.defaults.extensions||{renderers:{},childTokens:{}},re;Ee.forEach(function(ie){if(ie.extensions&&(re=!0,ie.extensions.forEach(function(Ce){if(!Ce.name)throw new Error("extension name required");if(Ce.renderer){var R=de.renderers?de.renderers[Ce.name]:null;R?de.renderers[Ce.name]=function(){for(var W=arguments.length,K=new Array(W),G=0;G<W;G++)K[G]=arguments[G];var V=Ce.renderer.apply(this,K);return V===!1&&(V=R.apply(this,K)),V}:de.renderers[Ce.name]=Ce.renderer}if(Ce.tokenizer){if(!Ce.level||Ce.level!=="block"&&Ce.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Ce.level]?de[Ce.level].unshift(Ce.tokenizer):de[Ce.level]=[Ce.tokenizer],Ce.start&&(Ce.level==="block"?de.startBlock?de.startBlock.push(Ce.start):de.startBlock=[Ce.start]:Ce.level==="inline"&&(de.startInline?de.startInline.push(Ce.start):de.startInline=[Ce.start]))}Ce.childTokens&&(de.childTokens[Ce.name]=Ce.childTokens)})),ie.renderer&&function(){var Ce=he.defaults.renderer||new we,R=function(G){var V=Ce[G];Ce[G]=function(){for(var ee=arguments.length,ce=new Array(ee),Me=0;Me<ee;Me++)ce[Me]=arguments[Me];var xe=ie.renderer[G].apply(Ce,ce);return xe===!1&&(xe=V.apply(Ce,ce)),xe}};for(var W in ie.renderer)R(W);oe.renderer=Ce}(),ie.tokenizer&&function(){var Ce=he.defaults.tokenizer||new B,R=function(G){var V=Ce[G];Ce[G]=function(){for(var ee=arguments.length,ce=new Array(ee),Me=0;Me<ee;Me++)ce[Me]=arguments[Me];var xe=ie.tokenizer[G].apply(Ce,ce);return xe===!1&&(xe=V.apply(Ce,ce)),xe}};for(var W in ie.tokenizer)R(W);oe.tokenizer=Ce}(),ie.walkTokens){var me=he.defaults.walkTokens;oe.walkTokens=function(Ce){var R=[];return R.push(ie.walkTokens.call(this,Ce)),me&&(R=R.concat(me.call(this,Ce))),R}}re&&(oe.extensions=de),he.setOptions(oe)})},he.walkTokens=function(be,Ee){for(var ye=[],oe=function(){var me=re.value;switch(ye=ye.concat(Ee.call(he,me)),me.type){case"table":{for(var Ce=L(me.header),R;!(R=Ce()).done;){var W=R.value;ye=ye.concat(he.walkTokens(W.tokens,Ee))}for(var K=L(me.rows),G;!(G=K()).done;)for(var V=G.value,ee=L(V),ce;!(ce=ee()).done;){var Me=ce.value;ye=ye.concat(he.walkTokens(Me.tokens,Ee))}break}case"list":{ye=ye.concat(he.walkTokens(me.items,Ee));break}default:he.defaults.extensions&&he.defaults.extensions.childTokens&&he.defaults.extensions.childTokens[me.type]?he.defaults.extensions.childTokens[me.type].forEach(function(xe){ye=ye.concat(he.walkTokens(me[xe],Ee))}):me.tokens&&(ye=ye.concat(he.walkTokens(me.tokens,Ee)))}},de=L(be),re;!(re=de()).done;)oe();return ye},he.parseInline=function(be,Ee){if(typeof be>"u"||be===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");Ee=w({},he.defaults,Ee||{}),g(Ee);try{var ye=Q.lexInline(be,Ee);return Ee.walkTokens&&he.walkTokens(ye,Ee.walkTokens),Y.parseInline(ye,Ee)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+v(oe.message+"",!0)+"</pre>";throw oe}},he.Parser=Y,he.parser=Y.parse,he.Renderer=we,he.TextRenderer=_e,he.Lexer=Q,he.lexer=Q.lex,he.Tokenizer=B,he.Slugger=Ae,he.parse=he;var ke=he.options,ae=he.setOptions,J=he.use,le=he.walkTokens,N=he.parseInline,q=he,ue=Y.parse,Se=Q.lex;ve.Lexer=Q,ve.Parser=Y,ve.Renderer=we,ve.Slugger=Ae,ve.TextRenderer=_e,ve.Tokenizer=B,ve.getDefaults=T,ve.lexer=Se,ve.marked=he,ve.options=ke,ve.parse=q,ve.parseInline=N,ve.parser=ue,ve.setOptions=ae,ve.use=J,ve.walkTokens=le,Object.defineProperty(ve,"__esModule",{value:!0})}),define(Pe[118],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function S(h,y,m){return Math.min(Math.max(h,y),m)}e.clamp=S;function A(h,y){return(y+h%y)%y}e.rot=A;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class L{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=L;class T{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const m=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=m,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function ve(I){const L=[];typeof I=="number"&&L.push("code/timeOrigin",I);function T(y){L.push(y,Date.now())}function h(){const y=[];for(let m=0;m<L.length;m+=2)y.push({name:L[m],startTime:L[m+1]});return y}return{mark:T,getMarks:h}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ve():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const T of performance.getEntriesByType("mark"))L.push({name:T.name,startTime:Math.round(I+T.startTime)});return L}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ve(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ve()}function S(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=S(A))}(),function(ve,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var A in S)(typeof exports=="object"?exports:ve)[A]=S[A]}}(typeof self<"u"?self:this,function(){return function(ve){var e={};function S(A){if(e[A])return e[A].exports;var I=e[A]={i:A,l:!1,exports:{}};return ve[A].call(I.exports,I,I.exports,S),I.l=!0,I.exports}return S.m=ve,S.c=e,S.d=function(A,I,L){S.o(A,I)||Object.defineProperty(A,I,{enumerable:!0,get:L})},S.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},S.t=function(A,I){if(1&I&&(A=S(A)),8&I||4&I&&typeof A=="object"&&A&&A.__esModule)return A;var L=Object.create(null);if(S.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:A}),2&I&&typeof A!="string")for(var T in A)S.d(L,T,function(h){return A[h]}.bind(null,T));return L},S.n=function(A){var I=A&&A.__esModule?function(){return A.default}:function(){return A};return S.d(I,"a",I),I},S.o=function(A,I){return Object.prototype.hasOwnProperty.call(A,I)},S.p="",S(S.s=0)}([function(ve,e,S){(function(A){var I;e=ve.exports=J,I=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,h=e.re=[],y=e.src=[],m=0,P=m++;y[P]="0|[1-9]\\d*";var D=m++;y[D]="[0-9]+";var l=m++;y[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=m++;y[E]="("+y[P]+")\\.("+y[P]+")\\.("+y[P]+")";var v=m++;y[v]="("+y[D]+")\\.("+y[D]+")\\.("+y[D]+")";var d=m++;y[d]="(?:"+y[P]+"|"+y[l]+")";var t=m++;y[t]="(?:"+y[D]+"|"+y[l]+")";var i=m++;y[i]="(?:-("+y[d]+"(?:\\."+y[d]+")*))";var c=m++;y[c]="(?:-?("+y[t]+"(?:\\."+y[t]+")*))";var f=m++;y[f]="[0-9A-Za-z-]+";var C=m++;y[C]="(?:\\+("+y[f]+"(?:\\."+y[f]+")*))";var k=m++,n="v?"+y[E]+y[i]+"?"+y[C]+"?";y[k]="^"+n+"$";var a="[v=\\s]*"+y[v]+y[c]+"?"+y[C]+"?",r=m++;y[r]="^"+a+"$";var s=m++;y[s]="((?:<|>)?=?)";var b=m++;y[b]=y[D]+"|x|X|\\*";var p=m++;y[p]=y[P]+"|x|X|\\*";var w=m++;y[w]="[v=\\s]*("+y[p]+")(?:\\.("+y[p]+")(?:\\.("+y[p]+")(?:"+y[i]+")?"+y[C]+"?)?)?";var _=m++;y[_]="[v=\\s]*("+y[b]+")(?:\\.("+y[b]+")(?:\\.("+y[b]+")(?:"+y[c]+")?"+y[C]+"?)?)?";var o=m++;y[o]="^"+y[s]+"\\s*"+y[w]+"$";var u=m++;y[u]="^"+y[s]+"\\s*"+y[_]+"$";var g=m++;y[g]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=m++;y[O]="(?:~>?)";var z=m++;y[z]="(\\s*)"+y[O]+"\\s+",h[z]=new RegExp(y[z],"g");var H=m++;y[H]="^"+y[O]+y[w]+"$";var B=m++;y[B]="^"+y[O]+y[_]+"$";var $=m++;y[$]="(?:\\^)";var x=m++;y[x]="(\\s*)"+y[$]+"\\s+",h[x]=new RegExp(y[x],"g");var M=m++;y[M]="^"+y[$]+y[w]+"$";var ne=m++;y[ne]="^"+y[$]+y[_]+"$";var Q=m++;y[Q]="^"+y[s]+"\\s*("+a+")$|^$";var we=m++;y[we]="^"+y[s]+"\\s*("+n+")$|^$";var _e=m++;y[_e]="(\\s*)"+y[s]+"\\s*("+a+"|"+y[w]+")",h[_e]=new RegExp(y[_e],"g");var Ae=m++;y[Ae]="^\\s*("+y[w]+")\\s+-\\s+("+y[w]+")\\s*$";var Y=m++;y[Y]="^\\s*("+y[_]+")\\s+-\\s+("+y[_]+")\\s*$";var he=m++;y[he]="(<|>)?=?\\s*\\*";for(var ke=0;ke<35;ke++)I(ke,y[ke]),h[ke]||(h[ke]=new RegExp(y[ke]));function ae(V,ee){if(V instanceof J)return V;if(typeof V!="string"||V.length>L||!(ee?h[r]:h[k]).test(V))return null;try{return new J(V,ee)}catch{return null}}function J(V,ee){if(V instanceof J){if(V.loose===ee)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof J))return new J(V,ee);I("SemVer",V,ee),this.loose=ee;var ce=V.trim().match(ee?h[r]:h[k]);if(!ce)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var xe=+Me;if(xe>=0&&xe<T)return xe}return Me}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=ae,e.valid=function(V,ee){var ce=ae(V,ee);return ce?ce.version:null},e.clean=function(V,ee){var ce=ae(V.trim().replace(/^[=v]+/,""),ee);return ce?ce.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(V){return I("SemVer.compare",this.version,this.loose,V),V instanceof J||(V=new J(V,this.loose)),this.compareMain(V)||this.comparePre(V)},J.prototype.compareMain=function(V){return V instanceof J||(V=new J(V,this.loose)),N(this.major,V.major)||N(this.minor,V.minor)||N(this.patch,V.patch)},J.prototype.comparePre=function(V){if(V instanceof J||(V=new J(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var ee=0;do{var ce=this.prerelease[ee],Me=V.prerelease[ee];if(I("prerelease compare",ee,ce,Me),ce===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ce===void 0)return-1;if(ce!==Me)return N(ce,Me)}while(++ee)},J.prototype.inc=function(V,ee){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,ee,ce,Me){typeof ce=="string"&&(Me=ce,ce=void 0);try{return new J(V,ce).inc(ee,Me).version}catch{return null}},e.diff=function(V,ee){if(be(V,ee))return null;var ce=ae(V),Me=ae(ee);if(ce.prerelease.length||Me.prerelease.length){for(var xe in ce)if((xe==="major"||xe==="minor"||xe==="patch")&&ce[xe]!==Me[xe])return"pre"+xe;return"prerelease"}for(var xe in ce)if((xe==="major"||xe==="minor"||xe==="patch")&&ce[xe]!==Me[xe])return xe},e.compareIdentifiers=N;var le=/^[0-9]+$/;function N(V,ee){var ce=le.test(V),Me=le.test(ee);return ce&&Me&&(V=+V,ee=+ee),ce&&!Me?-1:Me&&!ce?1:V<ee?-1:V>ee?1:0}function q(V,ee,ce){return new J(V,ce).compare(new J(ee,ce))}function ue(V,ee,ce){return q(V,ee,ce)>0}function Se(V,ee,ce){return q(V,ee,ce)<0}function be(V,ee,ce){return q(V,ee,ce)===0}function Ee(V,ee,ce){return q(V,ee,ce)!==0}function ye(V,ee,ce){return q(V,ee,ce)>=0}function oe(V,ee,ce){return q(V,ee,ce)<=0}function de(V,ee,ce,Me){var xe;switch(ee){case"===":typeof V=="object"&&(V=V.version),typeof ce=="object"&&(ce=ce.version),xe=V===ce;break;case"!==":typeof V=="object"&&(V=V.version),typeof ce=="object"&&(ce=ce.version),xe=V!==ce;break;case"":case"=":case"==":xe=be(V,ce,Me);break;case"!=":xe=Ee(V,ce,Me);break;case">":xe=ue(V,ce,Me);break;case">=":xe=ye(V,ce,Me);break;case"<":xe=Se(V,ce,Me);break;case"<=":xe=oe(V,ce,Me);break;default:throw new TypeError("Invalid operator: "+ee)}return xe}function re(V,ee){if(V instanceof re){if(V.loose===ee)return V;V=V.value}if(!(this instanceof re))return new re(V,ee);I("comparator",V,ee),this.loose=ee,this.parse(V),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(V,ee){return N(ee,V)},e.major=function(V,ee){return new J(V,ee).major},e.minor=function(V,ee){return new J(V,ee).minor},e.patch=function(V,ee){return new J(V,ee).patch},e.compare=q,e.compareLoose=function(V,ee){return q(V,ee,!0)},e.rcompare=function(V,ee,ce){return q(ee,V,ce)},e.sort=function(V,ee){return V.sort(function(ce,Me){return e.compare(ce,Me,ee)})},e.rsort=function(V,ee){return V.sort(function(ce,Me){return e.rcompare(ce,Me,ee)})},e.gt=ue,e.lt=Se,e.eq=be,e.neq=Ee,e.gte=ye,e.lte=oe,e.cmp=de,e.Comparator=re;var ie={};function me(V,ee){if(V instanceof me)return V.loose===ee?V:new me(V.raw,ee);if(V instanceof re)return new me(V.value,ee);if(!(this instanceof me))return new me(V,ee);if(this.loose=ee,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Ce(V){return!V||V.toLowerCase()==="x"||V==="*"}function R(V,ee,ce,Me,xe,Ge,je,et,Ye,Ze,it,tt,Ue){return((ee=Ce(ce)?"":Ce(Me)?">="+ce+".0.0":Ce(xe)?">="+ce+"."+Me+".0":">="+ee)+" "+(et=Ce(Ye)?"":Ce(Ze)?"<"+(+Ye+1)+".0.0":Ce(it)?"<"+Ye+"."+(+Ze+1)+".0":tt?"<="+Ye+"."+Ze+"."+it+"-"+tt:"<="+et)).trim()}function W(V,ee){for(var ce=0;ce<V.length;ce++)if(!V[ce].test(ee))return!1;if(ee.prerelease.length){for(ce=0;ce<V.length;ce++)if(I(V[ce].semver),V[ce].semver!==ie&&V[ce].semver.prerelease.length>0){var Me=V[ce].semver;if(Me.major===ee.major&&Me.minor===ee.minor&&Me.patch===ee.patch)return!0}return!1}return!0}function K(V,ee,ce){try{ee=new me(ee,ce)}catch{return!1}return ee.test(V)}function G(V,ee,ce,Me){var xe,Ge,je,et,Ye;switch(V=new J(V,Me),ee=new me(ee,Me),ce){case">":xe=ue,Ge=oe,je=Se,et=">",Ye=">=";break;case"<":xe=Se,Ge=ye,je=ue,et="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(K(V,ee,Me))return!1;for(var Ze=0;Ze<ee.set.length;++Ze){var it=ee.set[Ze],tt=null,Ue=null;if(it.forEach(function(st){st.semver===ie&&(st=new re(">=0.0.0")),tt=tt||st,Ue=Ue||st,xe(st.semver,tt.semver,Me)?tt=st:je(st.semver,Ue.semver,Me)&&(Ue=st)}),tt.operator===et||tt.operator===Ye||(!Ue.operator||Ue.operator===et)&&Ge(V,Ue.semver)||Ue.operator===Ye&&je(V,Ue.semver))return!1}return!0}re.prototype.parse=function(V){var ee=this.loose?h[Q]:h[we],ce=V.match(ee);if(!ce)throw new TypeError("Invalid comparator: "+V);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new J(ce[2],this.loose):this.semver=ie},re.prototype.toString=function(){return this.value},re.prototype.test=function(V){return I("Comparator.test",V,this.loose),this.semver===ie||(typeof V=="string"&&(V=new J(V,this.loose)),de(V,this.operator,this.semver,this.loose))},re.prototype.intersects=function(V,ee){if(!(V instanceof re))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new me(V.value,ee),K(this.value,ce,ee);if(V.operator==="")return ce=new me(this.value,ee),K(V.semver,ce,ee);var Me=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Ge=this.semver.version===V.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),et=de(this.semver,"<",V.semver,ee)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ye=de(this.semver,">",V.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return Me||xe||Ge&&je||et||Ye},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(V){var ee=this.loose;V=V.trim(),I("range",V,ee);var ce=ee?h[Y]:h[Ae];V=V.replace(ce,R),I("hyphen replace",V),V=V.replace(h[_e],"$1$2$3"),I("comparator trim",V,h[_e]),V=(V=(V=V.replace(h[z],"$1~")).replace(h[x],"$1^")).split(/\s+/).join(" ");var Me=ee?h[Q]:h[we],xe=V.split(" ").map(function(Ge){return function(je,et){return I("comp",je),je=function(Ye,Ze){return Ye.trim().split(/\s+/).map(function(it){return function(tt,Ue){I("caret",tt,Ue);var st=Ue?h[ne]:h[M];return tt.replace(st,function(Z,X,pe,$e,Ne){var Xe;return I("caret",tt,Z,X,pe,$e,Ne),Ce(X)?Xe="":Ce(pe)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Ce($e)?Xe=X==="0"?">="+X+"."+pe+".0 <"+X+"."+(+pe+1)+".0":">="+X+"."+pe+".0 <"+(+X+1)+".0.0":Ne?(I("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=X==="0"?pe==="0"?">="+X+"."+pe+"."+$e+Ne+" <"+X+"."+pe+"."+(+$e+1):">="+X+"."+pe+"."+$e+Ne+" <"+X+"."+(+pe+1)+".0":">="+X+"."+pe+"."+$e+Ne+" <"+(+X+1)+".0.0"):(I("no pr"),Xe=X==="0"?pe==="0"?">="+X+"."+pe+"."+$e+" <"+X+"."+pe+"."+(+$e+1):">="+X+"."+pe+"."+$e+" <"+X+"."+(+pe+1)+".0":">="+X+"."+pe+"."+$e+" <"+(+X+1)+".0.0"),I("caret return",Xe),Xe})}(it,Ze)}).join(" ")}(je,et),I("caret",je),je=function(Ye,Ze){return Ye.trim().split(/\s+/).map(function(it){return function(tt,Ue){var st=Ue?h[B]:h[H];return tt.replace(st,function(Z,X,pe,$e,Ne){var Xe;return I("tilde",tt,Z,X,pe,$e,Ne),Ce(X)?Xe="":Ce(pe)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Ce($e)?Xe=">="+X+"."+pe+".0 <"+X+"."+(+pe+1)+".0":Ne?(I("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=">="+X+"."+pe+"."+$e+Ne+" <"+X+"."+(+pe+1)+".0"):Xe=">="+X+"."+pe+"."+$e+" <"+X+"."+(+pe+1)+".0",I("tilde return",Xe),Xe})}(it,Ze)}).join(" ")}(je,et),I("tildes",je),je=function(Ye,Ze){return I("replaceXRanges",Ye,Ze),Ye.split(/\s+/).map(function(it){return function(tt,Ue){tt=tt.trim();var st=Ue?h[u]:h[o];return tt.replace(st,function(Z,X,pe,$e,Ne,Xe){I("xRange",tt,Z,X,pe,$e,Ne,Xe);var nt=Ce(pe),ft=nt||Ce($e),Et=ft||Ce(Ne);return X==="="&&Et&&(X=""),nt?Z=X===">"||X==="<"?"<0.0.0":"*":X&&Et?(ft&&($e=0),Et&&(Ne=0),X===">"?(X=">=",ft?(pe=+pe+1,$e=0,Ne=0):Et&&($e=+$e+1,Ne=0)):X==="<="&&(X="<",ft?pe=+pe+1:$e=+$e+1),Z=X+pe+"."+$e+"."+Ne):ft?Z=">="+pe+".0.0 <"+(+pe+1)+".0.0":Et&&(Z=">="+pe+"."+$e+".0 <"+pe+"."+(+$e+1)+".0"),I("xRange return",Z),Z})}(it,Ze)}).join(" ")}(je,et),I("xrange",je),je=function(Ye,Ze){return I("replaceStars",Ye,Ze),Ye.trim().replace(h[he],"")}(je,et),I("stars",je),je}(Ge,ee)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(Ge){return!!Ge.match(Me)})),xe=xe.map(function(Ge){return new re(Ge,ee)})},me.prototype.intersects=function(V,ee){if(!(V instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(Me){return V.set.some(function(xe){return xe.every(function(Ge){return Me.intersects(Ge,ee)})})})})},e.toComparators=function(V,ee){return new me(V,ee).set.map(function(ce){return ce.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},me.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new J(V,this.loose));for(var ee=0;ee<this.set.length;ee++)if(W(this.set[ee],V))return!0;return!1},e.satisfies=K,e.maxSatisfying=function(V,ee,ce){var Me=null,xe=null;try{var Ge=new me(ee,ce)}catch{return null}return V.forEach(function(je){Ge.test(je)&&(Me&&xe.compare(je)!==-1||(xe=new J(Me=je,ce)))}),Me},e.minSatisfying=function(V,ee,ce){var Me=null,xe=null;try{var Ge=new me(ee,ce)}catch{return null}return V.forEach(function(je){Ge.test(je)&&(Me&&xe.compare(je)!==1||(xe=new J(Me=je,ce)))}),Me},e.validRange=function(V,ee){try{return new me(V,ee).range||"*"}catch{return null}},e.ltr=function(V,ee,ce){return G(V,ee,"<",ce)},e.gtr=function(V,ee,ce){return G(V,ee,">",ce)},e.outside=G,e.prerelease=function(V,ee){var ce=ae(V,ee);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(V,ee,ce){return V=new me(V,ce),ee=new me(ee,ce),V.intersects(ee)},e.coerce=function(V){if(V instanceof J)return V;if(typeof V!="string")return null;var ee=V.match(h[g]);return ee==null?null:ae((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,S(1))},function(ve,e){var S,A,I=ve.exports={};function L(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function h(t){if(S===setTimeout)return setTimeout(t,0);if((S===L||!S)&&setTimeout)return S=setTimeout,setTimeout(t,0);try{return S(t,0)}catch{try{return S.call(null,t,0)}catch{return S.call(this,t,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:L}catch{S=L}try{A=typeof clearTimeout=="function"?clearTimeout:T}catch{A=T}})();var y,m=[],P=!1,D=-1;function l(){P&&y&&(P=!1,y.length?m=y.concat(m):D=-1,m.length&&E())}function E(){if(!P){var t=h(l);P=!0;for(var i=m.length;i;){for(y=m,m=[];++D<i;)y&&y[D].run();D=-1,i=m.length}y=null,P=!1,function(c){if(A===clearTimeout)return clearTimeout(c);if((A===T||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(c);try{A(c)}catch{try{return A.call(null,c)}catch{return A.call(this,c)}}}(t)}}function v(t,i){this.fun=t,this.array=i}function d(){}I.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)i[c-1]=arguments[c];m.push(new v(t,i)),m.length!==1||P||h(E)},v.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=d,I.addListener=d,I.once=d,I.off=d,I.removeListener=d,I.removeAllListeners=d,I.emit=d,I.prependListener=d,I.prependOnceListener=d,I.listeners=function(t){return[]},I.binding=function(t){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(t){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Pe[119],Te([1,0,9,6]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(C){const k=C;return k?typeof k.read=="function":!1}e.isReadable=I;function L(C){const k=C;return k?[k.on,k.pause,k.resume,k.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=L;function T(C){const k=C;return k?L(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.isReadableBufferedStream=T;function h(C,k){return new y(C,k)}e.newWriteableStream=h;class y{constructor(k,n){this.reducer=k,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(k){if(!this.state.destroyed){if(this.state.flowing)this.emitData(k);else if(this.buffer.data.push(k),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(k){this.state.destroyed||(this.state.flowing?this.emitError(k):this.buffer.error.push(k))}end(k){this.state.destroyed||(typeof k<"u"&&this.write(k),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(k){this.listeners.data.slice(0).forEach(n=>n(k))}emitError(k){this.listeners.error.length===0?(0,S.onUnexpectedError)(k):this.listeners.error.slice(0).forEach(n=>n(k))}emitEnd(){this.listeners.end.slice(0).forEach(k=>k())}on(k,n){if(!this.state.destroyed)switch(k){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(k,n){if(this.state.destroyed)return;let a;switch(k){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const r=a.indexOf(n);r>=0&&a.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const k=this.reducer(this.buffer.data);this.emitData(k),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const k of this.buffer.error)this.emitError(k);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(C,k){const n=[];let a;for(;(a=C.read())!==null;)n.push(a);return k(n)}e.consumeReadable=m;function P(C,k,n){const a=[];let r;for(;(r=C.read())!==null&&a.length<n;)a.push(r);return r===null&&a.length>0?k(a):{read:()=>{if(a.length>0)return a.shift();if(typeof r<"u"){const s=r;return r=void 0,s}return C.read()}}}e.peekReadable=P;function D(C,k){return new Promise((n,a)=>{const r=[];l(C,{onData:s=>{k&&r.push(s)},onError:s=>{k?a(s):n(void 0)},onEnd:()=>{n(k?k(r):void 0)}})})}e.consumeStream=D;function l(C,k,n){C.on("error",a=>{n?.isCancellationRequested||k.onError(a)}),C.on("end",()=>{n?.isCancellationRequested||k.onEnd()}),C.on("data",a=>{n?.isCancellationRequested||k.onData(a)})}e.listenStream=l;function E(C,k){return new Promise((n,a)=>{const r=new A.DisposableStore,s=[],b=_=>{if(s.push(_),s.length>k)return r.dispose(),C.pause(),n({stream:C,buffer:s,ended:!1})},p=_=>a(_),w=()=>n({stream:C,buffer:s,ended:!0});r.add((0,A.toDisposable)(()=>C.removeListener("error",p))),C.on("error",p),r.add((0,A.toDisposable)(()=>C.removeListener("end",w))),C.on("end",w),r.add((0,A.toDisposable)(()=>C.removeListener("data",b))),C.on("data",b)})}e.peekStream=E;function v(C,k){const n=h(k);return n.end(C),n}e.toStream=v;function d(){const C=h(()=>{throw new Error("not supported")});return C.end(),C}e.emptyStream=d;function t(C){let k=!1;return{read:()=>k?null:(k=!0,C)}}e.toReadable=t;function i(C,k,n){const a=h(n);return l(C,{onData:r=>a.write(k.data(r)),onError:r=>a.error(k.error?k.error(r):r),onEnd:()=>a.end()}),a}e.transform=i;function c(C,k,n){let a=!1;return{read:()=>{const r=k.read();return a?r:(a=!0,r!==null?n([C,r]):C)}}}e.prefixedReadable=c;function f(C,k,n){let a=!1;const r=h(n);return l(k,{onData:s=>a?r.write(s):(a=!0,r.write(n([C,s]))),onError:s=>r.error(s),onEnd:()=>{a||(a=!0,r.write(C)),r.end()}}),r}e.prefixedStream=f}),define(Pe[25],Te([1,0,66,119]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const I=typeof Buffer<"u",L=new S.Lazy(()=>new Uint8Array(256));let T,h;class y{static alloc(g){return I?new y(Buffer.allocUnsafe(g)):new y(new Uint8Array(g))}static wrap(g){return I&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new y(g)}static fromString(g,O){return!(O?.dontUseNodeBuffer||!1)&&I?new y(Buffer.from(g)):(T||(T=new TextEncoder),new y(T.encode(g)))}static fromByteArray(g){const O=y.alloc(g.length);for(let z=0,H=g.length;z<H;z++)O.buffer[z]=g[z];return O}static concat(g,O){if(typeof O>"u"){O=0;for(let B=0,$=g.length;B<$;B++)O+=g[B].byteLength}const z=y.alloc(O);let H=0;for(let B=0,$=g.length;B<$;B++){const x=g[B];z.set(x,H),H+=x.byteLength}return z}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=y.alloc(this.byteLength);return g.set(this),g}toString(){return I?this.buffer.toString():(h||(h=new TextDecoder),h.decode(this.buffer))}slice(g,O){return new y(this.buffer.subarray(g,O))}set(g,O){if(g instanceof y)this.buffer.set(g.buffer,O);else if(g instanceof Uint8Array)this.buffer.set(g,O);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),O);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return l(this.buffer,g)}writeUInt32BE(g,O){E(this.buffer,g,O)}readUInt32LE(g){return v(this.buffer,g)}writeUInt32LE(g,O){d(this.buffer,g,O)}readUInt8(g){return t(this.buffer,g)}writeUInt8(g,O){i(this.buffer,g,O)}indexOf(g,O=0){return m(this.buffer,g instanceof y?g.buffer:g,O)}}e.VSBuffer=y;function m(u,g,O=0){const z=g.byteLength,H=u.byteLength;if(z===0)return 0;if(z===1)return u.indexOf(g[0]);if(z>H-O)return-1;const B=L.value;B.fill(g.length);for(let ne=0;ne<g.length;ne++)B[g[ne]]=g.length-ne-1;let $=O+g.length-1,x=$,M=-1;for(;$<H;)if(u[$]===g[x]){if(x===0){M=$;break}$--,x--}else $+=Math.max(g.length-x,B[u[$]]),x=g.length-1;return M}e.binaryIndexOf=m;function P(u,g){return u[g+0]<<0>>>0|u[g+1]<<8>>>0}e.readUInt16LE=P;function D(u,g,O){u[O+0]=g&255,g=g>>>8,u[O+1]=g&255}e.writeUInt16LE=D;function l(u,g){return u[g]*2**24+u[g+1]*2**16+u[g+2]*2**8+u[g+3]}e.readUInt32BE=l;function E(u,g,O){u[O+3]=g,g=g>>>8,u[O+2]=g,g=g>>>8,u[O+1]=g,g=g>>>8,u[O]=g}e.writeUInt32BE=E;function v(u,g){return u[g+0]<<0>>>0|u[g+1]<<8>>>0|u[g+2]<<16>>>0|u[g+3]<<24>>>0}e.readUInt32LE=v;function d(u,g,O){u[O+0]=g&255,g=g>>>8,u[O+1]=g&255,g=g>>>8,u[O+2]=g&255,g=g>>>8,u[O+3]=g&255}e.writeUInt32LE=d;function t(u,g){return u[g]}e.readUInt8=t;function i(u,g,O){u[O]=g}e.writeUInt8=i;function c(u){return A.consumeReadable(u,g=>y.concat(g))}e.readableToBuffer=c;function f(u){return A.toReadable(u)}e.bufferToReadable=f;function C(u){return A.consumeStream(u,g=>y.concat(g))}e.streamToBuffer=C;async function k(u){return u.ended?y.concat(u.buffer):y.concat([...u.buffer,await C(u.stream)])}e.bufferedStreamToBuffer=k;function n(u){return A.toStream(u,g=>y.concat(g))}e.bufferToStream=n;function a(u){return A.transform(u,{data:g=>typeof g=="string"?y.fromString(g):y.wrap(g)},g=>y.concat(g))}e.streamToBufferReadableStream=a;function r(u){return A.newWriteableStream(g=>y.concat(g),u)}e.newWriteableBufferStream=r;function s(u,g){return A.prefixedReadable(u,g,O=>y.concat(O))}e.prefixedBufferReadable=s;function b(u,g){return A.prefixedStream(u,g,O=>y.concat(O))}e.prefixedBufferStream=b;function p(u){let g=0,O=0,z=0;const H=new Uint8Array(Math.floor(u.length/4*3)),B=x=>{switch(O){case 3:H[z++]=g|x,O=0;break;case 2:H[z++]=g|x>>>2,g=x<<6,O=3;break;case 1:H[z++]=g|x>>>4,g=x<<4,O=2;break;default:g=x<<2,O=1}};for(let x=0;x<u.length;x++){const M=u.charCodeAt(x);if(M>=65&&M<=90)B(M-65);else if(M>=97&&M<=122)B(M-97+26);else if(M>=48&&M<=57)B(M-48+52);else if(M===43||M===45)B(62);else if(M===47||M===95)B(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${u[x]}`)}}const $=z;for(;O>0;)B(0);return y.wrap(H).slice(0,$)}e.decodeBase64=p;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",_="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:u},g=!0,O=!1){const z=O?_:w;let H="";const B=u.byteLength%3;let $=0;for(;$<u.byteLength-B;$+=3){const x=u[$+0],M=u[$+1],ne=u[$+2];H+=z[x>>>2],H+=z[(x<<4|M>>>4)&63],H+=z[(M<<2|ne>>>6)&63],H+=z[ne&63]}if(B===1){const x=u[$+0];H+=z[x>>>2],H+=z[x<<4&63],g&&(H+="==")}else if(B===2){const x=u[$+0],M=u[$+1];H+=z[x>>>2],H+=z[(x<<4|M>>>4)&63],H+=z[M<<2&63],g&&(H+="=")}return H}e.encodeBase64=o}),define(Pe[120],Te([1,0,28,15]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...re){return function(ie,me){for(let Ce=0,R=re.length;Ce<R;Ce++){const W=re[Ce](ie,me);if(W)return W}return null}}e.or=I,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(re,ie,me){if(!me||me.length<ie.length)return null;let Ce;return re?Ce=A.startsWithIgnoreCase(me,ie):Ce=me.indexOf(ie)===0,Ce?ie.length>0?[{start:0,end:ie.length}]:[]:null}function T(re,ie){const me=ie.toLowerCase().indexOf(re.toLowerCase());return me===-1?null:[{start:me,end:me+re.length}]}e.matchesContiguousSubString=T;function h(re,ie){return y(re.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=h;function y(re,ie,me,Ce){if(me===re.length)return[];if(Ce===ie.length)return null;if(re[me]===ie[Ce]){let R=null;return(R=y(re,ie,me+1,Ce+1))?i({start:Ce,end:Ce+1},R):null}return y(re,ie,me,Ce+1)}function m(re){return 97<=re&&re<=122}function P(re){return 65<=re&&re<=90}e.isUpper=P;function D(re){return 48<=re&&re<=57}function l(re){return re===32||re===9||re===10||re===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(re=>E.add(re.charCodeAt(0)));function v(re){return l(re)||E.has(re)}function d(re,ie){return re===ie||v(re)&&v(ie)}function t(re){return m(re)||P(re)||D(re)}function i(re,ie){return ie.length===0?ie=[re]:re.end===ie[0].start?ie[0].start=re.start:ie.unshift(re),ie}function c(re,ie){for(let me=ie;me<re.length;me++){const Ce=re.charCodeAt(me);if(P(Ce)||D(Ce)||me>0&&!t(re.charCodeAt(me-1)))return me}return re.length}function f(re,ie,me,Ce){if(me===re.length)return[];if(Ce===ie.length)return null;if(re[me]!==ie[Ce].toLowerCase())return null;{let R=null,W=Ce+1;for(R=f(re,ie,me+1,Ce+1);!R&&(W=c(ie,W))<ie.length;)R=f(re,ie,me+1,W),W++;return R===null?null:i({start:Ce,end:Ce+1},R)}}function C(re){let ie=0,me=0,Ce=0,R=0,W=0;for(let ce=0;ce<re.length;ce++)W=re.charCodeAt(ce),P(W)&&ie++,m(W)&&me++,t(W)&&Ce++,D(W)&&R++;const K=ie/re.length,G=me/re.length,V=Ce/re.length,ee=R/re.length;return{upperPercent:K,lowerPercent:G,alphaPercent:V,numericPercent:ee}}function k(re){const{upperPercent:ie,lowerPercent:me}=re;return me===0&&ie>.6}function n(re){const{upperPercent:ie,lowerPercent:me,alphaPercent:Ce,numericPercent:R}=re;return me>.2&&ie<.8&&Ce>.6&&R<.2}function a(re){let ie=0,me=0,Ce=0,R=0;for(let W=0;W<re.length;W++)Ce=re.charCodeAt(W),P(Ce)&&ie++,m(Ce)&&me++,l(Ce)&&R++;return(ie===0||me===0)&&R===0?re.length<=30:ie<=5}function r(re,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!a(re)||ie.length>60)return null;const me=C(ie);if(!n(me)){if(!k(me))return null;ie=ie.toLowerCase()}let Ce=null,R=0;for(re=re.toLowerCase();R<ie.length&&(Ce=f(re,ie,0,R))===null;)R=c(ie,R+1);return Ce}e.matchesCamelCase=r;function s(re,ie,me=!1){if(!ie||ie.length===0)return null;let Ce=null,R=0;for(re=re.toLowerCase(),ie=ie.toLowerCase();R<ie.length&&(Ce=b(re,ie,0,R,me))===null;)R=p(ie,R+1);return Ce}e.matchesWords=s;function b(re,ie,me,Ce,R){if(me===re.length)return[];if(Ce===ie.length)return null;if(d(re.charCodeAt(me),ie.charCodeAt(Ce))){let W=null,K=Ce+1;if(W=b(re,ie,me+1,Ce+1,R),!R)for(;!W&&(K=p(ie,K))<ie.length;)W=b(re,ie,me+1,K,R),K++;return W?re.charCodeAt(me)!==ie.charCodeAt(Ce)?W:i({start:Ce,end:Ce+1},W):null}else return null}function p(re,ie){for(let me=ie;me<re.length;me++)if(v(re.charCodeAt(me))||me>0&&v(re.charCodeAt(me-1)))return me;return re.length}const w=I(e.matchesPrefix,r,T),_=I(e.matchesPrefix,r,h),o=new S.LRUCache(1e4);function u(re,ie,me=!1){if(typeof re!="string"||typeof ie!="string")return null;let Ce=o.get(re);Ce||(Ce=new RegExp(A.convertSimple2RegExpPattern(re),"i"),o.set(re,Ce));const R=Ce.exec(ie);return R?[{start:R.index,end:R.index+R[0].length}]:me?_(re,ie):w(re,ie)}e.matchesFuzzy=u;function g(re,ie){const me=ue(re,re.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return me?z(me):null}e.matchesFuzzy2=g;function O(re,ie,me,Ce,R,W){const K=Math.min(13,re.length);for(;me<K;me++){const G=ue(re,ie,me,Ce,R,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(G)return G}return[0,W]}e.anyScore=O;function z(re){if(typeof re>"u")return[];const ie=[],me=re[1];for(let Ce=re.length-1;Ce>1;Ce--){const R=re[Ce]+me,W=ie[ie.length-1];W&&W.end===R?W.end=R+1:ie.push({start:R,end:R+1})}return ie}e.createMatches=z;const H=128;function B(){const re=[],ie=[];for(let me=0;me<=H;me++)ie[me]=0;for(let me=0;me<=H;me++)re.push(ie.slice(0));return re}function $(re){const ie=[];for(let me=0;me<=re;me++)ie[me]=0;return ie}const x=$(2*H),M=$(2*H),ne=B(),Q=B(),we=B(),_e=!1;function Ae(re,ie,me,Ce,R){function W(G,V,ee=" "){for(;G.length<V;)G=ee+G;return G}let K=` |   |${Ce.split("").map(G=>W(G,3)).join("|")}
`;for(let G=0;G<=me;G++)G===0?K+=" |":K+=`${ie[G-1]}|`,K+=re[G].slice(0,R+1).map(V=>W(V.toString(),3)).join("|")+`
`;return K}function Y(re,ie,me,Ce){re=re.substr(ie),me=me.substr(Ce),console.log(Ae(Q,re,re.length,me,me.length)),console.log(Ae(we,re,re.length,me,me.length)),console.log(Ae(ne,re,re.length,me,me.length))}function he(re,ie){if(ie<0||ie>=re.length)return!1;const me=re.codePointAt(ie);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(me)}}function ke(re,ie){if(ie<0||ie>=re.length)return!1;switch(re.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function ae(re,ie,me){return ie[re]!==me[re]}function J(re,ie,me,Ce,R,W,K=!1){for(;ie<me&&R<W;)re[ie]===Ce[R]&&(K&&(x[ie]=R),ie+=1),R+=1;return ie===me}e.isPatternInWord=J;var le;(function(re){re[re.Diag=1]="Diag",re[re.Left=2]="Left",re[re.LeftLeft=3]="LeftLeft"})(le||(le={}));var N;(function(re){re.Default=[-100,0];function ie(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}re.isDefault=ie})(N||(e.FuzzyScore=N={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ie,me){this.firstMatchCanBeWeak=ie,this.boostFullMatch=me}}e.FuzzyScoreOptions=q;function ue(re,ie,me,Ce,R,W,K=q.default){const G=re.length>H?H:re.length,V=Ce.length>H?H:Ce.length;if(me>=G||W>=V||G-me>V-W||!J(ie,me,G,R,W,V,!0))return;Se(G,V,me,W,ie,R);let ee=1,ce=1,Me=me,xe=W;const Ge=[!1];for(ee=1,Me=me;Me<G;ee++,Me++){const it=x[Me],tt=M[Me],Ue=Me+1<G?M[Me+1]:V;for(ce=it-W+1,xe=it;xe<Ue;ce++,xe++){let st=Number.MIN_SAFE_INTEGER,Z=!1;xe<=tt&&(st=be(re,ie,Me,me,Ce,R,xe,V,W,ne[ee-1][ce-1]===0,Ge));let X=0;st!==Number.MAX_SAFE_INTEGER&&(Z=!0,X=st+Q[ee-1][ce-1]);const pe=xe>it,$e=pe?Q[ee][ce-1]+(ne[ee][ce-1]>0?-5:0):0,Ne=xe>it+1&&ne[ee][ce-1]>0,Xe=Ne?Q[ee][ce-2]+(ne[ee][ce-2]>0?-5:0):0;if(Ne&&(!pe||Xe>=$e)&&(!Z||Xe>=X))Q[ee][ce]=Xe,we[ee][ce]=3,ne[ee][ce]=0;else if(pe&&(!Z||$e>=X))Q[ee][ce]=$e,we[ee][ce]=2,ne[ee][ce]=0;else if(Z)Q[ee][ce]=X,we[ee][ce]=1,ne[ee][ce]=ne[ee-1][ce-1]+1;else throw new Error("not possible")}}if(_e&&Y(re,me,Ce,W),!Ge[0]&&!K.firstMatchCanBeWeak)return;ee--,ce--;const je=[Q[ee][ce],W];let et=0,Ye=0;for(;ee>=1;){let it=ce;do{const tt=we[ee][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);et>1&&ie[me+ee-1]===R[W+ce-1]&&!ae(it+W-1,Ce,R)&&et+1>ne[ee][it]&&(it=ce),it===ce?et++:et=1,Ye||(Ye=it),ee--,ce=it-1,je.push(ce)}V===G&&K.boostFullMatch&&(je[0]+=2);const Ze=Ye-G;return je[0]-=Ze,je}e.fuzzyScore=ue;function Se(re,ie,me,Ce,R,W){let K=re-1,G=ie-1;for(;K>=me&&G>=Ce;)R[K]===W[G]&&(M[K]=G,K--),G--}function be(re,ie,me,Ce,R,W,K,G,V,ee,ce){if(ie[me]!==W[K])return Number.MIN_SAFE_INTEGER;let Me=1,xe=!1;return K===me-Ce?Me=re[me]===R[K]?7:5:ae(K,R,W)&&(K===0||!ae(K-1,R,W))?(Me=re[me]===R[K]?7:5,xe=!0):he(W,K)&&(K===0||!he(W,K-1))?Me=5:(he(W,K-1)||ke(W,K-1))&&(Me=5,xe=!0),Me>1&&me===Ce&&(ce[0]=!0),xe||(xe=ae(K,R,W)||he(W,K-1)||ke(W,K-1)),me===Ce?K>V&&(Me-=xe?3:5):ee?Me+=xe?2:0:Me+=xe?0:1,K+1===G&&(Me-=xe?3:5),Me}function Ee(re,ie,me,Ce,R,W,K){return oe(re,ie,me,Ce,R,W,!0,K)}e.fuzzyScoreGracefulAggressive=Ee;function ye(re,ie,me,Ce,R,W,K){return oe(re,ie,me,Ce,R,W,!1,K)}e.fuzzyScoreGraceful=ye;function oe(re,ie,me,Ce,R,W,K,G){let V=ue(re,ie,me,Ce,R,W,G);if(V&&!K)return V;if(re.length>=3){const ee=Math.min(7,re.length-1);for(let ce=me+1;ce<ee;ce++){const Me=de(re,ce);if(Me){const xe=ue(Me,Me.toLowerCase(),me,Ce,R,W,G);xe&&(xe[0]-=3,(!V||xe[0]>V[0])&&(V=xe))}}}return V}function de(re,ie){if(ie+1>=re.length)return;const me=re[ie],Ce=re[ie+1];if(me!==Ce)return re.slice(0,ie)+Ce+me+re.slice(ie+2)}}),define(Pe[29],Te([1,0,15]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(A||(A={})),function(I){const L="error",T="warning",h="warn",y="info",m="ignore";function P(l){return l?S.equalsIgnoreCase(L,l)?I.Error:S.equalsIgnoreCase(T,l)||S.equalsIgnoreCase(h,l)?I.Warning:S.equalsIgnoreCase(y,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=P;function D(l){switch(l){case I.Error:return L;case I.Warning:return T;case I.Info:return y;default:return m}}I.toString=D}(A||(A={})),e.default=A}),define(Pe[121],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Pe[48],Te([1,0,18,15]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class I{constructor(){this._value="",this._pos=0}reset(E){return this._value=E,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(E){const v=E.charCodeAt(0),d=this._value.charCodeAt(this._pos);return v-d}value(){return this._value[this._pos]}}e.StringIterator=I;class L{constructor(E=!0){this._caseSensitive=E}reset(E){return this._value=E,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let E=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(E)this._from++;else break;else E=!1;return this}cmp(E){return this._caseSensitive?(0,A.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=L;class T{constructor(E=!0,v=!0){this._splitOnBackslash=E,this._caseSensitive=v}reset(E){this._from=0,this._to=0,this._value=E,this._valueLen=E.length;for(let v=E.length-1;v>=0;v--,this._valueLen--){const d=this._value.charCodeAt(v);if(!(d===47||this._splitOnBackslash&&d===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let E=!0;for(;this._to<this._valueLen;this._to++){const v=this._value.charCodeAt(this._to);if(v===47||this._splitOnBackslash&&v===92)if(E)this._from++;else break;else E=!1}return this}cmp(E){return this._caseSensitive?(0,A.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var h;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(h||(h={}));class y{constructor(E,v){this._ignorePathCasing=E,this._ignoreQueryAndFragment=v,this._states=[],this._stateIdx=0}reset(E){return this._value=E,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(E)),this._pathIterator.reset(E.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(E)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(E){if(this._states[this._stateIdx]===1)return(0,A.compareIgnoreCase)(E,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,A.compareIgnoreCase)(E,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(E);if(this._states[this._stateIdx]===4)return(0,A.compare)(E,this._value.query);if(this._states[this._stateIdx]===5)return(0,A.compare)(E,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(P||(P={}));class D{static forUris(E=()=>!1,v=()=>!1){return new D(new y(E,v))}static forPaths(E=!1){return new D(new T(void 0,!E))}static forStrings(){return new D(new I)}static forConfigKeys(){return new D(new L)}constructor(E){this._iter=E}clear(){this._root=void 0}fill(E,v){if(v){const d=v.slice(0);(0,S.shuffle)(d);for(const t of d)this.set(t,E)}else{const d=E.slice(0);(0,S.shuffle)(d);for(const t of d)this.set(t[0],t[1])}}set(E,v){const d=this._iter.reset(E);let t;this._root||(this._root=new m,this._root.segment=d.value());const i=[];for(t=this._root;;){const f=d.cmp(t.segment);if(f>0)t.left||(t.left=new m,t.left.segment=d.value()),i.push([-1,t]),t=t.left;else if(f<0)t.right||(t.right=new m,t.right.segment=d.value()),i.push([1,t]),t=t.right;else if(d.hasNext())d.next(),t.mid||(t.mid=new m,t.mid.segment=d.value()),i.push([0,t]),t=t.mid;else break}const c=t.value;t.value=v,t.key=E;for(let f=i.length-1;f>=0;f--){const C=i[f][1];C.updateHeight();const k=C.balanceFactor();if(k<-1||k>1){const n=i[f][0],a=i[f+1][0];if(n===1&&a===1)i[f][1]=C.rotateLeft();else if(n===-1&&a===-1)i[f][1]=C.rotateRight();else if(n===1&&a===-1)C.right=i[f+1][1]=i[f+1][1].rotateRight(),i[f][1]=C.rotateLeft();else if(n===-1&&a===1)C.left=i[f+1][1]=i[f+1][1].rotateLeft(),i[f][1]=C.rotateRight();else throw new Error;if(f>0)switch(i[f-1][0]){case-1:i[f-1][1].left=i[f][1];break;case 1:i[f-1][1].right=i[f][1];break;case 0:i[f-1][1].mid=i[f][1];break}else this._root=i[0][1]}}return c}get(E){return this._getNode(E)?.value}_getNode(E){const v=this._iter.reset(E);let d=this._root;for(;d;){const t=v.cmp(d.segment);if(t>0)d=d.left;else if(t<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else break}return d}has(E){const v=this._getNode(E);return!(v?.value===void 0&&v?.mid===void 0)}delete(E){return this._delete(E,!1)}deleteSuperstr(E){return this._delete(E,!0)}_delete(E,v){const d=this._iter.reset(E),t=[];let i=this._root;for(;i;){const c=d.cmp(i.segment);if(c>0)t.push([-1,i]),i=i.left;else if(c<0)t.push([1,i]),i=i.right;else if(d.hasNext())d.next(),t.push([0,i]),i=i.mid;else break}if(i){if(v?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const c=this._min(i.right);if(c.key){const{key:f,value:C,segment:k}=c;this._delete(c.key,!1),i.key=f,i.value=C,i.segment=k}}else{const c=i.left??i.right;if(t.length>0){const[f,C]=t[t.length-1];switch(f){case-1:C.left=c;break;case 0:C.mid=c;break;case 1:C.right=c;break}}else this._root=c}for(let c=t.length-1;c>=0;c--){const f=t[c][1];f.updateHeight();const C=f.balanceFactor();if(C>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),t[c][1]=f.rotateLeft()):C<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),t[c][1]=f.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this._root=t[0][1]}}}_min(E){for(;E.left;)E=E.left;return E}findSubstr(E){const v=this._iter.reset(E);let d=this._root,t;for(;d;){const i=v.cmp(d.segment);if(i>0)d=d.left;else if(i<0)d=d.right;else if(v.hasNext())v.next(),t=d.value||t,d=d.mid;else break}return d&&d.value||t}findSuperstr(E){return this._findSuperstrOrElement(E,!1)}_findSuperstrOrElement(E,v){const d=this._iter.reset(E);let t=this._root;for(;t;){const i=d.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(d.hasNext())d.next(),t=t.mid;else return t.mid?this._entries(t.mid):v?t.value:void 0}}hasElementOrSubtree(E){return this._findSuperstrOrElement(E,!0)!==void 0}forEach(E){for(const[v,d]of this)E(d,v)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(E){const v=[];return this._dfsEntries(E,v),v[Symbol.iterator]()}_dfsEntries(E,v){E&&(E.left&&this._dfsEntries(E.left,v),E.value&&v.push([E.key,E.value]),E.mid&&this._dfsEntries(E.mid,v),E.right&&this._dfsEntries(E.right,v))}_isBalanced(){const E=v=>{if(!v)return!0;const d=v.balanceFactor();return d<-1||d>1?!1:E(v.left)&&E(v.right)};return E(this._root)}}e.TernarySearchTree=D}),define(Pe[40],Te([1,0,89]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(T){function h(y){return y&&typeof y=="object"&&typeof y.id=="string"}T.isThemeColor=h})(A||(e.ThemeColor=A={}));function I(T){return{id:T}}e.themeColorFromId=I;var L;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const h=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function y(c){const f=h.exec(c.id);if(!f)return y(S.Codicon.error);const[,C,k]=f,n=["codicon","codicon-"+C];return k&&n.push("codicon-modifier-"+k.substring(1)),n}T.asClassNameArray=y;function m(c){return y(c).join(" ")}T.asClassName=m;function P(c){return"."+y(c).join(".")}T.asCSSSelector=P;function D(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||A.isThemeColor(c.color))}T.isThemeIcon=D;const l=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function E(c){const f=l.exec(c);if(!f)return;const[,C]=f;return{id:C}}T.fromString=E;function v(c){return{id:c}}T.fromId=v;function d(c,f){let C=c.id;const k=C.lastIndexOf("~");return k!==-1&&(C=C.substring(0,k)),f&&(C=`${C}~${f}`),{id:C}}T.modify=d;function t(c){const f=c.id.lastIndexOf("~");if(f!==-1)return c.id.substring(f+1)}T.getModifier=t;function i(c,f){return c.id===f.id&&c.color?.id===f.color?.id}T.isEqual=i})(L||(e.ThemeIcon=L={}))}),define(Pe[122],Te([1,0,120,15,40]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",T=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),h=new RegExp(`(\\\\)?${T.source}`,"g");function y(i){return i.replace(h,(c,f)=>f?c:`\\${c}`)}e.escapeIcons=y;const m=new RegExp(`\\\\${T.source}`,"g");function P(i){return i.replace(m,c=>`\\${c}`)}e.markdownEscapeEscapedIcons=P;const D=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function l(i){return i.indexOf(L)===-1?i:i.replace(D,(c,f,C,k)=>C?c:f||k||"")}e.stripIcons=l;function E(i){return i?i.replace(/\$\((.*?)\)/g,(c,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=E;const v=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(i){v.lastIndex=0;let c="";const f=[];let C=0;for(;;){const k=v.lastIndex,n=v.exec(i),a=i.substring(k,n?.index);if(a.length>0){c+=a;for(let r=0;r<a.length;r++)f.push(C)}if(!n)break;C+=n[0].length}return{text:c,iconOffsets:f}}e.parseLabelWithIcons=d;function t(i,c,f=!1){const{text:C,iconOffsets:k}=c;if(!k||k.length===0)return(0,S.matchesFuzzy)(i,C,f);const n=(0,A.ltrim)(C," "),a=C.length-n.length,r=(0,S.matchesFuzzy)(i,n,f);if(r)for(const s of r){const b=k[s.start+a]+a;s.start+=b,s.end+=b}return r}e.matchesFuzzyIconAware=t}),define(Pe[36],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(I){return S.test(I)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(h){for(let y=0;y<h.length;y++)h[y]=Math.floor(Math.random()*256);return h};const L=new Uint8Array(16),T=[];for(let h=0;h<256;h++)T.push(h.toString(16).padStart(2,"0"));return function(){I(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let y=0,m="";return m+=T[L[y++]],m+=T[L[y++]],m+=T[L[y++]],m+=T[L[y++]],m+="-",m+=T[L[y++]],m+=T[L[y++]],m+="-",m+=T[L[y++]],m+=T[L[y++]],m+="-",m+=T[L[y++]],m+=T[L[y++]],m+="-",m+=T[L[y++]],m+=T[L[y++]],m+=T[L[y++]],m+=T[L[y++]],m+=T[L[y++]],m+=T[L[y++]],m}}()}),define(Pe[123],Te([1,0,18,67,36]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function L(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.createStringDataTransferItem=L;function T(D,l,E){const v={id:(0,I.generateUuid)(),name:D,uri:l,data:E};return{asString:async()=>"",asFile:()=>v,value:void 0}}e.createFileDataTransferItem=T;class h{constructor(){this._entries=new Map}get size(){let l=0;for(const E of this._entries)l++;return l}has(l){return this._entries.has(this.toKey(l))}matches(l){const E=[...this._entries.keys()];return A.Iterable.some(this,([v,d])=>d.asFile())&&E.push("files"),P(y(l),E)}get(l){return this._entries.get(this.toKey(l))?.[0]}append(l,E){const v=this._entries.get(l);v?v.push(E):this._entries.set(this.toKey(l),[E])}replace(l,E){this._entries.set(this.toKey(l),[E])}delete(l){this._entries.delete(this.toKey(l))}*[Symbol.iterator](){for(const[l,E]of this._entries)for(const v of E)yield[l,v]}toKey(l){return y(l)}}e.VSDataTransfer=h;function y(D){return D.toLowerCase()}function m(D,l){return P(y(D),l.map(y))}e.matchesMimeType=m;function P(D,l){if(D==="*/*")return l.length>0;if(l.includes(D))return!0;const E=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[v,d,t]=E;return t==="*"?l.some(i=>i.startsWith(d+"/")):!1}e.UriList=Object.freeze({create:D=>(0,S.distinct)(D.map(l=>l.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.UriList.split(D).filter(l=>!l.startsWith("#"))})}),define(Pe[124],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[125],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var S;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class A{constructor(h){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=h.open,this.close=h.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(h.notIn))for(let y=0,m=h.notIn.length;y<m;y++)switch(h.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(h){switch(h){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(h,y){if(h.getTokenCount()===0)return!0;const m=h.findTokenIndexAtOffset(y-2),P=h.getStandardTokenType(m);return this.isOK(P)}_findNeutralCharacterInRange(h,y){for(let m=h;m<=y;m++){const P=String.fromCharCode(m);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=A;class I{constructor(h){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of h)L(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),L(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),L(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),L(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&L(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=I;function L(T,h,y){T.has(h)?T.get(h).push(y):T.set(h,[y])}}),define(Pe[126],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class S{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(L){if(L&&this._dragOperations.has(L)){const T=this._dragOperations.get(L);return this._dragOperations.delete(L),T}}addDragOperationTransfer(L,T){this._dragOperations.set(L,T)}}e.TreeViewsDnDService=S;class A{constructor(L){this.identifier=L}}e.DraggedTreeItemsIdentifier=A}),define(Pe[127],Te([10,11]),function(ve,e){return ve.create("vs/base/common/actions",e)}),define(Pe[128],Te([1,0,5,6,127]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class L extends A.Disposable{constructor(l,E="",v="",d=!0,t){super(),this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=l,this._label=E,this._cssClass=v,this._enabled=d,this._actionCallback=t}get id(){return this._id}get label(){return this._label}set label(l){this._setLabel(l)}_setLabel(l){this._label!==l&&(this._label=l,this._onDidChange.fire({label:l}))}get tooltip(){return this._tooltip||""}set tooltip(l){this._setTooltip(l)}_setTooltip(l){this._tooltip!==l&&(this._tooltip=l,this._onDidChange.fire({tooltip:l}))}get class(){return this._cssClass}set class(l){this._setClass(l)}_setClass(l){this._cssClass!==l&&(this._cssClass=l,this._onDidChange.fire({class:l}))}get enabled(){return this._enabled}set enabled(l){this._setEnabled(l)}_setEnabled(l){this._enabled!==l&&(this._enabled=l,this._onDidChange.fire({enabled:l}))}get checked(){return this._checked}set checked(l){this._setChecked(l)}_setChecked(l){this._checked!==l&&(this._checked=l,this._onDidChange.fire({checked:l}))}async run(l,E){this._actionCallback&&await this._actionCallback(l)}}e.Action=L;class T extends A.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new S.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new S.Emitter),this.onDidRun=this._onDidRun.event}async run(l,E){if(!l.enabled)return;this._onWillRun.fire({action:l});let v;try{await this.runAction(l,E)}catch(d){v=d}this._onDidRun.fire({action:l,error:v})}async runAction(l,E){await l.run(E)}}e.ActionRunner=T;class h{constructor(){this.id=h.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let E=[];for(const v of l)v.length&&(E.length?E=[...E,new h,...v]:E=v);return E}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=h;class y{get actions(){return this._actions}constructor(l,E,v,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=E,this.class=d,this._actions=v}async run(){}}e.SubmenuAction=y;class m extends L{static{this.ID="vs.actions.empty"}constructor(){super(m.ID,I.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=m;function P(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async()=>D.run(),tooltip:D.label}}e.toAction=P}),define(Pe[129],Te([10,11]),function(ve,e){return ve.create("vs/base/common/date",e)}),define(Pe[130],Te([1,0,129]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,I=A*60,L=I*24,T=L*7,h=L*30,y=L*365;function m(D,l,E,v){typeof D!="number"&&(D=D.getTime());const d=Math.round((new Date().getTime()-D)/1e3);if(d<-30)return(0,S.localize)(0,null,m(new Date().getTime()+d*1e3,!1));if(!v&&d<30)return(0,S.localize)(1,null);let t;return d<A?(t=d,l?t===1?E?(0,S.localize)(2,null,t):(0,S.localize)(3,null,t):E?(0,S.localize)(4,null,t):(0,S.localize)(5,null,t):t===1?E?(0,S.localize)(6,null,t):(0,S.localize)(7,null,t):E?(0,S.localize)(8,null,t):(0,S.localize)(9,null,t)):d<I?(t=Math.floor(d/A),l?t===1?E?(0,S.localize)(10,null,t):(0,S.localize)(11,null,t):E?(0,S.localize)(12,null,t):(0,S.localize)(13,null,t):t===1?E?(0,S.localize)(14,null,t):(0,S.localize)(15,null,t):E?(0,S.localize)(16,null,t):(0,S.localize)(17,null,t)):d<L?(t=Math.floor(d/I),l?t===1?E?(0,S.localize)(18,null,t):(0,S.localize)(19,null,t):E?(0,S.localize)(20,null,t):(0,S.localize)(21,null,t):t===1?E?(0,S.localize)(22,null,t):(0,S.localize)(23,null,t):E?(0,S.localize)(24,null,t):(0,S.localize)(25,null,t)):d<T?(t=Math.floor(d/L),l?t===1?(0,S.localize)(26,null,t):(0,S.localize)(27,null,t):t===1?(0,S.localize)(28,null,t):(0,S.localize)(29,null,t)):d<h?(t=Math.floor(d/T),l?t===1?E?(0,S.localize)(30,null,t):(0,S.localize)(31,null,t):E?(0,S.localize)(32,null,t):(0,S.localize)(33,null,t):t===1?E?(0,S.localize)(34,null,t):(0,S.localize)(35,null,t):E?(0,S.localize)(36,null,t):(0,S.localize)(37,null,t)):d<y?(t=Math.floor(d/h),l?t===1?E?(0,S.localize)(38,null,t):(0,S.localize)(39,null,t):E?(0,S.localize)(40,null,t):(0,S.localize)(41,null,t):t===1?E?(0,S.localize)(42,null,t):(0,S.localize)(43,null,t):E?(0,S.localize)(44,null,t):(0,S.localize)(45,null,t)):(t=Math.floor(d/y),l?t===1?E?(0,S.localize)(46,null,t):(0,S.localize)(47,null,t):E?(0,S.localize)(48,null,t):(0,S.localize)(49,null,t):t===1?E?(0,S.localize)(50,null,t):(0,S.localize)(51,null,t):E?(0,S.localize)(52,null,t):(0,S.localize)(53,null,t))}e.fromNow=m;function P(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(Pe[131],Te([10,11]),function(ve,e){return ve.create("vs/base/common/errorMessage",e)}),define(Pe[41],Te([1,0,18,16,131]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(D,l){return l&&(D.stack||D.stacktrace)?I.localize(0,null,h(D),T(D.stack)||T(D.stacktrace)):h(D)}function T(D){return Array.isArray(D)?D.join(`
`):D}function h(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?I.localize(1,null,D.message):D.message||I.localize(2,null)}function y(D=null,l=!1){if(!D)return I.localize(3,null);if(Array.isArray(D)){const E=S.coalesce(D),v=y(E[0],l);return E.length>1?I.localize(4,null,v,E.length):v}if(A.isString(D))return D;if(D.detail){const E=D.detail;if(E.error)return L(E.error,l);if(E.exception)return L(E.exception,l)}return D.stack?L(D,l):D.message?D.message:I.localize(5,null)}e.toErrorMessage=y;function m(D){const l=D;return l instanceof Error&&Array.isArray(l.actions)}e.isErrorWithActions=m;function P(D,l){let E;return typeof D=="string"?E=new Error(D):E=D,E.actions=l,E}e.createErrorWithActions=P}),define(Pe[132],Te([1,0,66,19]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new S.Lazy(()=>{const _=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:_,collatorIsNumeric:_.resolvedOptions().numeric}}),L=new S.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new S.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function h(_,o,u=!1){const g=_||"",O=o||"",z=I.value.collator.compare(g,O);return I.value.collatorIsNumeric&&z===0&&g!==O?g<O?-1:1:z}e.compareFileNames=h;function y(_,o){const u=L.value.collator;return _=_||"",o=o||"",C(u,_,o)}e.compareFileNamesDefault=y;function m(_,o){const u=L.value.collator;return _=_||"",o=o||"",r(_,o)||C(u,_,o)}e.compareFileNamesUpper=m;function P(_,o){const u=L.value.collator;return _=_||"",o=o||"",a(_,o)||C(u,_,o)}e.compareFileNamesLower=P;function D(_,o){return _=_||"",o=o||"",_===o?0:_<o?-1:1}e.compareFileNamesUnicode=D;function l(_,o){const[u,g]=c(_),[O,z]=c(o);let H=I.value.collator.compare(g,z);if(H===0){if(I.value.collatorIsNumeric&&g!==z)return g<z?-1:1;if(H=I.value.collator.compare(u,O),I.value.collatorIsNumeric&&H===0&&u!==O)return u<O?-1:1}return H}e.compareFileExtensions=l;function E(_,o){_=_||"",o=o||"";const u=f(_),g=f(o),O=L.value.collator,z=T.value.collator;return C(z,u,g)||C(O,_,o)}e.compareFileExtensionsDefault=E;function v(_,o){_=_||"",o=o||"";const u=f(_),g=f(o),O=L.value.collator,z=T.value.collator;return C(z,u,g)||r(_,o)||C(O,_,o)}e.compareFileExtensionsUpper=v;function d(_,o){_=_||"",o=o||"";const u=f(_),g=f(o),O=L.value.collator,z=T.value.collator;return C(z,u,g)||a(_,o)||C(O,_,o)}e.compareFileExtensionsLower=d;function t(_,o){_=_||"",o=o||"";const u=f(_).toLowerCase(),g=f(o).toLowerCase();return u!==g?u<g?-1:1:_!==o?_<o?-1:1:0}e.compareFileExtensionsUnicode=t;const i=/^(.*?)(\.([^.]*))?$/;function c(_,o=!1){const u=_?i.exec(_):[];let g=[u&&u[1]||"",u&&u[3]||""];return o&&(!g[0]&&g[1]||g[0]&&g[0].charAt(0)===".")&&(g=[g[0]+"."+g[1],""]),g}function f(_){const o=_?i.exec(_):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function C(_,o,u){const g=_.compare(o,u);return g!==0?g:o.length!==u.length?o.length<u.length?-1:1:0}function k(_){const o=_.charAt(0);return o.toLocaleUpperCase()!==o}function n(_){const o=_.charAt(0);return o.toLocaleLowerCase()!==o}function a(_,o){return k(_)&&n(o)?-1:n(_)&&k(o)?1:0}function r(_,o){return n(_)&&k(o)?-1:k(_)&&n(o)?1:0}function s(_,o,u=!1){return u||(_=_&&_.toLowerCase(),o=o&&o.toLowerCase()),_===o?0:_<o?-1:1}function b(_,o,u=!1){const g=_.split(A.sep),O=o.split(A.sep),z=g.length-1,H=O.length-1;let B,$;for(let x=0;;x++){if(B=z===x,$=H===x,B&&$)return h(g[x],O[x],u);if(B)return-1;if($)return 1;const M=s(g[x],O[x],u);if(M!==0)return M}}e.comparePaths=b;function p(_,o,u){const g=_.toLowerCase(),O=o.toLowerCase(),z=w(_,o,u);if(z)return z;const H=g.endsWith(u),B=O.endsWith(u);if(H!==B)return H?-1:1;const $=h(g,O);return $!==0?$:g.localeCompare(O)}e.compareAnything=p;function w(_,o,u){const g=_.toLowerCase(),O=o.toLowerCase(),z=g.startsWith(u),H=O.startsWith(u);if(z!==H)return z?-1:1;if(z&&H){if(g.length<O.length)return-1;if(g.length>O.length)return 1}return 0}e.compareByPrefix=w}),define(Pe[42],Te([1,0,19,22,15,16]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(p){return p===47||p===92}e.isPathSeparator=T;function h(p){return p.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=h;function y(p){return p.indexOf("/")===-1&&(p=h(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}e.toPosixPath=y;function m(p,w=S.posix.sep){if(!p)return"";const _=p.length,o=p.charCodeAt(0);if(T(o)){if(T(p.charCodeAt(1))&&!T(p.charCodeAt(2))){let g=3;const O=g;for(;g<_&&!T(p.charCodeAt(g));g++);if(O!==g&&!T(p.charCodeAt(g+1))){for(g+=1;g<_;g++)if(T(p.charCodeAt(g)))return p.slice(0,g+1).replace(/[\\/]/g,w)}}return w}else if(i(o)&&p.charCodeAt(1)===58)return T(p.charCodeAt(2))?p.slice(0,2)+w:p.slice(0,2);let u=p.indexOf("://");if(u!==-1){for(u+=3;u<_;u++)if(T(p.charCodeAt(u)))return p.slice(0,u+1)}return""}e.getRoot=m;function P(p){if(!A.isWindows||!p||p.length<5)return!1;let w=p.charCodeAt(0);if(w!==92||(w=p.charCodeAt(1),w!==92))return!1;let _=2;const o=_;for(;_<p.length&&(w=p.charCodeAt(_),w!==92);_++);return!(o===_||(w=p.charCodeAt(_+1),isNaN(w)||w===92))}e.isUNC=P;const D=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(p,w=A.isWindows){const _=w?D:l;return!(!p||p.length===0||/^\s+$/.test(p)||(_.lastIndex=0,_.test(p))||w&&E.test(p)||p==="."||p===".."||w&&p[p.length-1]==="."||w&&p.length!==p.trim().length||p.length>255)}e.isValidBasename=v;function d(p,w,_){const o=p===w;return!_||o?o:!p||!w?!1:(0,I.equalsIgnoreCase)(p,w)}e.isEqual=d;function t(p,w,_,o=S.sep){if(p===w)return!0;if(!p||!w||w.length>p.length)return!1;if(_){if(!(0,I.startsWithIgnoreCase)(p,w))return!1;if(w.length===p.length)return!0;let g=w.length;return w.charAt(w.length-1)===o&&g--,p.charAt(g)===o}return w.charAt(w.length-1)!==o&&(w+=o),p.indexOf(w)===0}e.isEqualOrParent=t;function i(p){return p>=65&&p<=90||p>=97&&p<=122}e.isWindowsDriveLetter=i;function c(p,w){return A.isWindows&&p.endsWith(":")&&(p+=S.sep),(0,S.isAbsolute)(p)||(p=(0,S.join)(w,p)),p=(0,S.normalize)(p),A.isWindows?(p=(0,I.rtrim)(p,S.sep),p.endsWith(":")&&(p+=S.sep)):(p=(0,I.rtrim)(p,S.sep),p||(p=S.sep)),p}e.sanitizeFilePath=c;function f(p){const w=(0,S.normalize)(p);return A.isWindows?p.length>3?!1:C(w)&&(p.length===2||w.charCodeAt(2)===92):w===S.posix.sep}e.isRootOrDriveLetter=f;function C(p,w=A.isWindows){return w?i(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}e.hasDriveLetter=C;function k(p,w=A.isWindows){return C(p,w)?p[0]:void 0}e.getDriveLetter=k;function n(p,w,_){return w.length>p.length?-1:p===w?0:(_&&(p=p.toLowerCase(),w=w.toLowerCase()),p.indexOf(w))}e.indexOfPath=n;function a(p){const w=p.split(":");let _,o,u;for(const g of w){const O=Number(g);(0,L.isNumber)(O)?o===void 0?o=O:u===void 0&&(u=O):_=_?[_,g].join(":"):g}if(!_)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:_,line:o!==void 0?o:void 0,column:u!==void 0?u:o!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(p,w,_=8){let o="";for(let g=0;g<_;g++){let O;g===0&&A.isWindows&&!w&&(_===3||_===4)?O=s:O=r,o+=O.charAt(Math.floor(Math.random()*O.length))}let u;return w?u=`${w}-${o}`:u=o,p?(0,S.join)(p,u):u}e.randomPath=b}),define(Pe[68],Te([1,0,19]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const D=(0,S.extname)(P),l=A[D.toLowerCase()];return l!==void 0?l:T(P)}e.getMediaOrTextMime=L;function T(P){const D=(0,S.extname)(P);return I[D.toLowerCase()]}e.getMediaMime=T;function h(P){for(const D in I)if(I[D]===P)return D}e.getExtensionForMimeType=h;const y=/^(.+)\/(.+?)(;.+)?$/;function m(P,D){const l=y.exec(P);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:D?void 0:P}e.normalizeMimeType=m}),define(Pe[69],Te([1,0,25,2]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function I(y){return JSON.stringify(y,T)}e.stringify=I;function L(y){let m=JSON.parse(y);return m=h(m),m}e.parse=L;function T(y,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:m.flags}:m}function h(y,m=0){if(!y||m>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return A.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 16:return new Date(y.source)}if(y instanceof S.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let P=0;P<y.length;++P)y[P]=h(y[P],m+1);else for(const P in y)Object.hasOwnProperty.call(y,P)&&(y[P]=h(y[P],m+1))}return y}e.revive=h}),define(Pe[12],Te([1,0,9,22,2]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${L.vscodeRemoteResource}`}set(P,D,l){this._hosts[P]=D,this._ports[P]=l}setConnectionToken(P,D){this._connectionTokens[P]=D}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)try{return this._delegate(P)}catch(t){return S.onUnexpectedError(t),P}const D=P.authority;let l=this._hosts[D];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const E=this._ports[D],v=this._connectionTokens[D];let d=`path=${encodeURIComponent(P.path)}`;return typeof v=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),I.URI.from({scheme:A.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${l}:${E}`,path:this._remoteResourcesPath,query:d})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class h{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(P){const D=this.toUri(P,ve);return this.uriToBrowserUri(D)}uriToBrowserUri(P){return P.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===L.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${L.vscodeFileResource}://${h.FALLBACK_AUTHORITY}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||h.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(P){const D=this.toUri(P,ve);return this.uriToFileUri(D)}uriToFileUri(P){return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==h.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(P,D){return I.URI.isUri(P)?P:I.URI.parse(D.toUrl(P))}}e.FileAccess=new h;var y;(function(m){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(P.get("3"));const D="vscode-coi";function l(v){let d;typeof v=="string"?d=new URL(v).searchParams:v instanceof URL?d=v.searchParams:I.URI.isUri(v)&&(d=new URL(v.toString(!0)).searchParams);const t=d?.get(D);if(t)return P.get(t)}m.getHeadersFromQuery=l;function E(v,d,t){if(!globalThis.crossOriginIsolated)return;const i=d&&t?"3":t?"2":"1";v instanceof URLSearchParams?v.set(D,i):v[D]=i}m.addSearchParam=E})(y||(e.COI=y={}))}),define(Pe[23],Te([1,0,42,12,19,22,15,2]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(E){return(0,h.uriToFsPath)(E,!0)}e.originalFSPath=y;class m{constructor(v){this._ignorePathCasing=v}compare(v,d,t=!1){return v===d?0:(0,T.compare)(this.getComparisonKey(v,t),this.getComparisonKey(d,t))}isEqual(v,d,t=!1){return v===d?!0:!v||!d?!1:this.getComparisonKey(v,t)===this.getComparisonKey(d,t)}getComparisonKey(v,d=!1){return v.with({path:this._ignorePathCasing(v)?v.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(v){return this._ignorePathCasing(v)}isEqualOrParent(v,d,t=!1){if(v.scheme===d.scheme){if(v.scheme===A.Schemas.file)return S.isEqualOrParent(y(v),y(d),this._ignorePathCasing(v))&&v.query===d.query&&(t||v.fragment===d.fragment);if((0,e.isEqualAuthority)(v.authority,d.authority))return S.isEqualOrParent(v.path,d.path,this._ignorePathCasing(v),"/")&&v.query===d.query&&(t||v.fragment===d.fragment)}return!1}joinPath(v,...d){return h.URI.joinPath(v,...d)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return I.posix.basename(v.path)}extname(v){return I.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let d;return v.scheme===A.Schemas.file?d=h.URI.file(I.dirname(y(v))).path:(d=I.posix.dirname(v.path),v.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),d="/")),v.with({path:d})}normalizePath(v){if(!v.path.length)return v;let d;return v.scheme===A.Schemas.file?d=h.URI.file(I.normalize(y(v))).path:d=I.posix.normalize(v.path),v.with({path:d})}relativePath(v,d){if(v.scheme!==d.scheme||!(0,e.isEqualAuthority)(v.authority,d.authority))return;if(v.scheme===A.Schemas.file){const c=I.relative(y(v),y(d));return L.isWindows?S.toSlashes(c):c}let t=v.path||"/";const i=d.path||"/";if(this._ignorePathCasing(v)){let c=0;for(const f=Math.min(t.length,i.length);c<f&&!(t.charCodeAt(c)!==i.charCodeAt(c)&&t.charAt(c).toLowerCase()!==i.charAt(c).toLowerCase());c++);t=i.substr(0,c)+t.substr(c)}return I.posix.relative(t,i)}resolvePath(v,d){if(v.scheme===A.Schemas.file){const t=h.URI.file(I.resolve(y(v),d));return v.with({authority:t.authority,path:t.path})}return d=S.toPosixPath(d),v.with({path:I.posix.resolve(v.path,d)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,d){return v===d||v!==void 0&&d!==void 0&&(0,T.equalsIgnoreCase)(v,d)}hasTrailingPathSeparator(v,d=I.sep){if(v.scheme===A.Schemas.file){const t=y(v);return t.length>S.getRoot(t).length&&t[t.length-1]===d}else{const t=v.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,d=I.sep){return(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,d=I.sep){let t=!1;if(v.scheme===A.Schemas.file){const i=y(v);t=i!==void 0&&i.length===S.getRoot(i).length&&i[i.length-1]===d}else{d="/";const i=v.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path+"/"}):v}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(E=>E.scheme===A.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new m(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(E,v){const d=[];for(let t=0;t<E.length;t++){const i=v(E[t]);E.some((c,f)=>f===t?!1:(0,e.isEqualOrParent)(i,v(c)))||d.push(E[t])}return d}e.distinctParents=P;var D;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function v(d){const t=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(f=>{const[C,k]=f.split(":");C&&k&&t.set(C,k)});const c=d.path.substring(0,d.path.indexOf(";"));return c&&t.set(E.META_DATA_MIME,c),t}E.parseMetaData=v})(D||(e.DataUri=D={}));function l(E,v,d){if(v){let t=E.path;return t&&t[0]!==I.posix.sep&&(t=I.posix.sep+t),E.with({scheme:d,authority:v,path:t})}return E.with({scheme:d})}e.toLocalResource=l}),define(Pe[13],Te([1,0,21,9,5,6,23,22,121]),function(ve,e,S,A,I,L,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(N){return!!N&&typeof N.then=="function"}e.isThenable=m;function P(N){const q=new S.CancellationTokenSource,ue=N(q.token),Se=new Promise((be,Ee)=>{const ye=q.token.onCancellationRequested(()=>{ye.dispose(),q.dispose(),Ee(new A.CancellationError)});Promise.resolve(ue).then(oe=>{ye.dispose(),q.dispose(),be(oe)},oe=>{ye.dispose(),q.dispose(),Ee(oe)})});return new class{cancel(){q.cancel()}then(be,Ee){return Se.then(be,Ee)}catch(be){return this.then(void 0,be)}finally(be){return Se.finally(be)}}}e.createCancelablePromise=P;function D(N,q,ue){return new Promise((Se,be)=>{const Ee=q.onCancellationRequested(()=>{Ee.dispose(),Se(ue)});N.then(Se,be).finally(()=>Ee.dispose())})}e.raceCancellation=D;function l(N,q){return new Promise((ue,Se)=>{const be=q.onCancellationRequested(()=>{be.dispose(),Se(new A.CancellationError)});N.then(ue,Se).finally(()=>be.dispose())})}e.raceCancellationError=l;async function E(N){let q=-1;const ue=N.map((Se,be)=>Se.then(Ee=>(q=be,Ee)));try{return await Promise.race(ue)}finally{N.forEach((Se,be)=>{be!==q&&Se.cancel()})}}e.raceCancellablePromises=E;function v(N,q,ue){let Se;const be=setTimeout(()=>{Se?.(void 0),ue?.()},q);return Promise.race([N.finally(()=>clearTimeout(be)),new Promise(Ee=>Se=Ee)])}e.raceTimeout=v;function d(N){return new Promise((q,ue)=>{const Se=N();m(Se)?Se.then(q,ue):q(Se)})}e.asPromise=d;class t{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(q){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=q,!this.queuedPromise){const ue=()=>{if(this.queuedPromise=null,this.isDisposed)return;const Se=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Se};this.queuedPromise=new Promise(Se=>{this.activePromise.then(ue,ue).then(Se)})}return new Promise((ue,Se)=>{this.queuedPromise.then(ue,Se)})}return this.activePromise=q(),new Promise((ue,Se)=>{this.activePromise.then(be=>{this.activePromise=null,ue(be)},be=>{this.activePromise=null,Se(be)})})}dispose(){this.isDisposed=!0}}e.Throttler=t;class i{constructor(){this.current=Promise.resolve(null)}queue(q){return this.current=this.current.then(()=>q(),()=>q())}}e.Sequencer=i;class c{constructor(){this.promiseMap=new Map}queue(q,ue){const be=(this.promiseMap.get(q)??Promise.resolve()).catch(()=>{}).then(ue).finally(()=>{this.promiseMap.get(q)===be&&this.promiseMap.delete(q)});return this.promiseMap.set(q,be),be}}e.SequencerByKey=c;const f=(N,q)=>{let ue=!0;const Se=setTimeout(()=>{ue=!1,q()},N);return{isTriggered:()=>ue,dispose:()=>{clearTimeout(Se),ue=!1}}},C=N=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,N())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class k{constructor(q){this.defaultDelay=q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(q,ue=this.defaultDelay){this.task=q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((be,Ee)=>{this.doResolve=be,this.doReject=Ee}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const be=this.task;return this.task=null,be()}}));const Se=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ue===y.MicrotaskDelay?C(Se):f(ue,Se),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new A.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=k;class n{constructor(q){this.delayer=new k(q),this.throttler=new t}trigger(q,ue){return this.delayer.trigger(()=>this.throttler.queue(q),ue)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=n;class a{constructor(){this._isOpen=!1,this._promise=new Promise((q,ue)=>{this._completePromise=q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class r extends a{constructor(q){super(),this._timeout=setTimeout(()=>this.open(),q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function s(N,q){return q?new Promise((ue,Se)=>{const be=setTimeout(()=>{Ee.dispose(),ue()},N),Ee=q.onCancellationRequested(()=>{clearTimeout(be),Ee.dispose(),Se(new A.CancellationError)})}):P(ue=>s(N,ue))}e.timeout=s;function b(N,q=0){const ue=setTimeout(N,q);return(0,L.toDisposable)(()=>clearTimeout(ue))}e.disposableTimeout=b;function p(N){const q=[];let ue=0;const Se=N.length;function be(){return ue<Se?N[ue++]():null}function Ee(ye){ye!=null&&q.push(ye);const oe=be();return oe?oe.then(Ee):Promise.resolve(q)}return Promise.resolve(null).then(Ee)}e.sequence=p;function w(N,q=Se=>!!Se,ue=null){let Se=0;const be=N.length,Ee=()=>{if(Se>=be)return Promise.resolve(ue);const ye=N[Se++];return Promise.resolve(ye()).then(de=>q(de)?Promise.resolve(de):Ee())};return Ee()}e.first=w;function _(N,q=Se=>!!Se,ue=null){if(N.length===0)return Promise.resolve(ue);let Se=N.length;const be=()=>{Se=-1;for(const Ee of N)Ee.cancel?.()};return new Promise((Ee,ye)=>{for(const oe of N)oe.then(de=>{--Se>=0&&q(de)?(be(),Ee(de)):Se===0&&Ee(ue)}).catch(de=>{--Se>=0&&(be(),ye(de))})})}e.firstParallel=_;class o{constructor(q){this._size=0,this.maxDegreeOfParalellism=q,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new I.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(q){return this._size++,new Promise((ue,Se)=>{this.outstandingPromises.push({factory:q,c:ue,e:Se}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const q=this.outstandingPromises.shift();this.runningPromises++;const ue=q.factory();ue.then(q.c,q.e),ue.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=o;class u extends o{constructor(){super(1)}}e.Queue=u;class g{constructor(){this.sequentializer=new we,this.tasks=0}queue(q){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,q())):this.sequentializer.run(this.tasks++,q())}}e.LimitedQueue=g;class O{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const q=new Y;return this.drainers.add(q),q.p}isDrained(){for(const[,q]of this.queues)if(q.size>0)return!1;return!0}queueFor(q,ue=T.extUri){const Se=ue.getComparisonKey(q);let be=this.queues.get(Se);return be||(be=new u,I.Event.once(be.onDrained)(()=>{be?.dispose(),this.queues.delete(Se),this.onDidQueueDrain()}),this.queues.set(Se,be)),be}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const q of this.drainers)q.complete();this.drainers.clear()}dispose(){for(const[,q]of this.queues)q.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=O;class z{constructor(q,ue){this._token=-1,typeof q=="function"&&typeof ue=="number"&&this.setIfNotSet(q,ue)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(q,ue){this.cancel(),this._token=setTimeout(()=>{this._token=-1,q()},ue)}setIfNotSet(q,ue){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,q()},ue))}}e.TimeoutTimer=z;class H{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(q,ue){this.cancel(),this._token=setInterval(()=>{q()},ue)}}e.IntervalTimer=H;class B{constructor(q,ue){this.timeoutToken=-1,this.runner=q,this.timeout=ue,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,q)}get delay(){return this.timeout}set delay(q){this.timeout=q}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=B;class ${constructor(q,ue){ue%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ue}ms is not a multiple of 1000ms.`),this.runner=q,this.timeout=ue,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(q=this.timeout){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=$;class x extends B{constructor(q,ue){super(q,ue),this.units=[]}work(q){this.units.push(q),this.isScheduled()||this.schedule()}doRun(){const q=this.units;this.units=[],this.runner?.(q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class M extends L.Disposable{constructor(q,ue){super(),this.options=q,this.handler=ue,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+q.length>this.options.maxBufferedWork)return!1}else if(this.pending+q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ue of q)this.pendingWork.push(ue);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new B(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{(0,h.setTimeout0)(()=>{if(q)return;const ue=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.runWhenIdle=(N,q)=>{const ue=requestIdleCallback(N,typeof q=="number"?{timeout:q}:void 0);let Se=!1;return{dispose(){Se||(Se=!0,cancelIdleCallback(ue))}}}}();class ne{constructor(q){this._didRun=!1,this._executor=()=>{try{this._value=q()}catch(ue){this._error=ue}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ne;async function Q(N,q,ue){let Se;for(let be=0;be<ue;be++)try{return await N()}catch(Ee){Se=Ee,await s(q)}throw Se}e.retry=Q;class we{isRunning(q){return typeof q=="number"?this._running?.taskId===q:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(q,ue,Se){return this._running={taskId:q,cancel:()=>Se?.(),promise:ue},ue.then(()=>this.doneRunning(q),()=>this.doneRunning(q)),ue}doneRunning(q){this._running&&q===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const q=this._queued;this._queued=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this._queued)this._queued.run=q;else{let ue,Se;const be=new Promise((Ee,ye)=>{ue=Ee,Se=ye});this._queued={run:q,promise:be,promiseResolve:ue,promiseReject:Se}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=we;class _e{constructor(q,ue=()=>Date.now()){this.interval=q,this.nowFn=ue,this.lastIncrementTime=0,this.value=0}increment(){const q=this.nowFn();return q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=q,this.value=0),this.value++,this.value}}e.IntervalCounter=_e;var Ae;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(Ae||(Ae={}));class Y{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((q,ue)=>{this.completeCallback=q,this.errorCallback=ue})}complete(q){return new Promise(ue=>{this.completeCallback(q),this.outcome={outcome:0,value:q},ue()})}error(q){return new Promise(ue=>{this.errorCallback(q),this.outcome={outcome:1,value:q},ue()})}cancel(){return this.error(new A.CancellationError)}}e.DeferredPromise=Y;var he;(function(N){async function q(Se){let be;const Ee=await Promise.all(Se.map(ye=>ye.then(oe=>oe,oe=>{be||(be=oe)})));if(typeof be<"u")throw be;return Ee}N.settled=q;function ue(Se){return new Promise(async(be,Ee)=>{try{await Se(be,Ee)}catch(ye){Ee(ye)}})}N.withAsyncBody=ue})(he||(e.Promises=he={}));var ke;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(ke||(ke={}));class ae{static fromArray(q){return new ae(ue=>{ue.emitMany(q)})}static fromPromise(q){return new ae(async ue=>{ue.emitMany(await q)})}static fromPromises(q){return new ae(async ue=>{await Promise.all(q.map(async Se=>ue.emitOne(await Se)))})}static merge(q){return new ae(async ue=>{await Promise.all(q.map(async Se=>{for await(const be of Se)ue.emitOne(be)}))})}static{this.EMPTY=ae.fromArray([])}constructor(q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const ue={emitOne:Se=>this.emitOne(Se),emitMany:Se=>this.emitMany(Se),reject:Se=>this.reject(Se)};try{await Promise.resolve(q(ue)),this.resolve()}catch(Se){this.reject(Se)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(q<this._results.length)return{done:!1,value:this._results[q++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(q,ue){return new ae(async Se=>{for await(const be of q)Se.emitOne(ue(be))})}map(q){return ae.map(this,q)}static filter(q,ue){return new ae(async Se=>{for await(const be of q)ue(be)&&Se.emitOne(be)})}filter(q){return ae.filter(this,q)}static coalesce(q){return ae.filter(q,ue=>!!ue)}coalesce(){return ae.coalesce(this)}static async toPromise(q){const ue=[];for await(const Se of q)ue.push(Se);return ue}toPromise(){return ae.toPromise(this)}emitOne(q){this._state===0&&(this._results.push(q),this._onStateChanged.fire())}emitMany(q){this._state===0&&(this._results=this._results.concat(q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(q){this._state===0&&(this._state=2,this._error=q,this._onStateChanged.fire())}}e.AsyncIterableObject=ae;class J extends ae{constructor(q,ue){super(ue),this._source=q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function le(N){const q=new S.CancellationTokenSource,ue=N(q.token);return new J(q,async Se=>{const be=q.token.onCancellationRequested(()=>{be.dispose(),q.dispose(),Se.reject(new A.CancellationError)});try{for await(const Ee of ue){if(q.token.isCancellationRequested)return;Se.emitOne(Ee)}be.dispose(),q.dispose()}catch(Ee){be.dispose(),q.dispose(),Se.reject(Ee)}})}e.createCancelableAsyncIterable=le}),define(Pe[37],Te([1,0,18,13,42,28,19,22,15]),function(ve,e,S,A,I,L,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",D="[^/\\\\]",l=/\//g;function E(we,_e){switch(we){case 0:return"";case 1:return`${D}*?`;default:return`(?:${P}|${D}+${P}${_e?`|${P}${D}+`:""})*?`}}function v(we,_e){if(!we)return[];const Ae=[];let Y=!1,he=!1,ke="";for(const ae of we){switch(ae){case _e:if(!Y&&!he){Ae.push(ke),ke="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":he=!0;break;case"]":he=!1;break}ke+=ae}return ke&&Ae.push(ke),Ae}e.splitGlobAware=v;function d(we){if(!we)return"";let _e="";const Ae=v(we,e.GLOB_SPLIT);if(Ae.every(Y=>Y===e.GLOBSTAR))_e=".*";else{let Y=!1;Ae.forEach((he,ke)=>{if(he===e.GLOBSTAR){if(Y)return;_e+=E(2,ke===Ae.length-1)}else{let ae=!1,J="",le=!1,N="";for(const q of he){if(q!=="}"&&ae){J+=q;continue}if(le&&(q!=="]"||!N)){let ue;q==="-"?ue=q:(q==="^"||q==="!")&&!N?ue="^":q===e.GLOB_SPLIT?ue="":ue=(0,y.escapeRegExpCharacters)(q),N+=ue;continue}switch(q){case"{":ae=!0;continue;case"[":le=!0;continue;case"}":{const Se=`(?:${v(J,",").map(be=>d(be)).join("|")})`;_e+=Se,ae=!1,J="";break}case"]":{_e+="["+N+"]",le=!1,N="";break}case"?":_e+=D;continue;case"*":_e+=E(1);continue;default:_e+=(0,y.escapeRegExpCharacters)(q)}}ke<Ae.length-1&&(Ae[ke+1]!==e.GLOBSTAR||ke+2<Ae.length)&&(_e+=P)}Y=he===e.GLOBSTAR})}return _e}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,C=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.LRUCache(1e4),a=function(){return!1},r=function(){return null};function s(we,_e){if(!we)return r;let Ae;typeof we!="string"?Ae=we.pattern:Ae=we,Ae=Ae.trim();const Y=`${Ae}_${!!_e.trimForExclusions}`;let he=n.get(Y);if(he)return b(he,we);let ke;return t.test(Ae)?he=w(Ae.substr(4),Ae):(ke=i.exec(p(Ae,_e)))?he=_(ke[1],Ae):(_e.trimForExclusions?f:c).test(Ae)?he=o(Ae,_e):(ke=C.exec(p(Ae,_e)))?he=u(ke[1].substr(1),Ae,!0):(ke=k.exec(p(Ae,_e)))?he=u(ke[1],Ae,!1):he=g(Ae),n.set(Y,he),b(he,we)}function b(we,_e){if(typeof _e=="string")return we;const Ae=function(Y,he){return(0,I.isEqualOrParent)(Y,_e.base,!h.isLinux)?we((0,y.ltrim)(Y.substr(_e.base.length),T.sep),he):null};return Ae.allBasenames=we.allBasenames,Ae.allPaths=we.allPaths,Ae.basenames=we.basenames,Ae.patterns=we.patterns,Ae}function p(we,_e){return _e.trimForExclusions&&we.endsWith("/**")?we.substr(0,we.length-2):we}function w(we,_e){return function(Ae,Y){return typeof Ae=="string"&&Ae.endsWith(we)?_e:null}}function _(we,_e){const Ae=`/${we}`,Y=`\\${we}`,he=function(ae,J){return typeof ae!="string"?null:J?J===we?_e:null:ae===we||ae.endsWith(Ae)||ae.endsWith(Y)?_e:null},ke=[we];return he.basenames=ke,he.patterns=[_e],he.allBasenames=ke,he}function o(we,_e){const Ae=ne(we.slice(1,-1).split(",").map(J=>s(J,_e)).filter(J=>J!==r),we),Y=Ae.length;if(!Y)return r;if(Y===1)return Ae[0];const he=function(J,le){for(let N=0,q=Ae.length;N<q;N++)if(Ae[N](J,le))return we;return null},ke=Ae.find(J=>!!J.allBasenames);ke&&(he.allBasenames=ke.allBasenames);const ae=Ae.reduce((J,le)=>le.allPaths?J.concat(le.allPaths):J,[]);return ae.length&&(he.allPaths=ae),he}function u(we,_e,Ae){const Y=T.sep===T.posix.sep,he=Y?we:we.replace(l,T.sep),ke=T.sep+he,ae=T.posix.sep+we;let J;return Ae?J=function(le,N){return typeof le=="string"&&(le===he||le.endsWith(ke)||!Y&&(le===we||le.endsWith(ae)))?_e:null}:J=function(le,N){return typeof le=="string"&&(le===he||!Y&&le===we)?_e:null},J.allPaths=[(Ae?"*/":"./")+we],J}function g(we){try{const _e=new RegExp(`^${d(we)}$`);return function(Ae){return _e.lastIndex=0,typeof Ae=="string"&&_e.test(Ae)?we:null}}catch{return r}}function O(we,_e,Ae){return!we||typeof _e!="string"?!1:z(we)(_e,void 0,Ae)}e.match=O;function z(we,_e={}){if(!we)return a;if(typeof we=="string"||H(we)){const Ae=s(we,_e);if(Ae===r)return a;const Y=function(he,ke){return!!Ae(he,ke)};return Ae.allBasenames&&(Y.allBasenames=Ae.allBasenames),Ae.allPaths&&(Y.allPaths=Ae.allPaths),Y}return x(we,_e)}e.parse=z;function H(we){const _e=we;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}e.isRelativePattern=H;function B(we){return we.allBasenames||[]}e.getBasenameTerms=B;function $(we){return we.allPaths||[]}e.getPathTerms=$;function x(we,_e){const Ae=ne(Object.getOwnPropertyNames(we).map(J=>M(J,we[J],_e)).filter(J=>J!==r)),Y=Ae.length;if(!Y)return r;if(!Ae.some(J=>!!J.requiresSiblings)){if(Y===1)return Ae[0];const J=function(q,ue){let Se;for(let be=0,Ee=Ae.length;be<Ee;be++){const ye=Ae[be](q,ue);if(typeof ye=="string")return ye;(0,A.isThenable)(ye)&&(Se||(Se=[]),Se.push(ye))}return Se?(async()=>{for(const be of Se){const Ee=await be;if(typeof Ee=="string")return Ee}return null})():null},le=Ae.find(q=>!!q.allBasenames);le&&(J.allBasenames=le.allBasenames);const N=Ae.reduce((q,ue)=>ue.allPaths?q.concat(ue.allPaths):q,[]);return N.length&&(J.allPaths=N),J}const he=function(J,le,N){let q,ue;for(let Se=0,be=Ae.length;Se<be;Se++){const Ee=Ae[Se];Ee.requiresSiblings&&N&&(le||(le=(0,T.basename)(J)),q||(q=le.substr(0,le.length-(0,T.extname)(J).length)));const ye=Ee(J,le,q,N);if(typeof ye=="string")return ye;(0,A.isThenable)(ye)&&(ue||(ue=[]),ue.push(ye))}return ue?(async()=>{for(const Se of ue){const be=await Se;if(typeof be=="string")return be}return null})():null},ke=Ae.find(J=>!!J.allBasenames);ke&&(he.allBasenames=ke.allBasenames);const ae=Ae.reduce((J,le)=>le.allPaths?J.concat(le.allPaths):J,[]);return ae.length&&(he.allPaths=ae),he}function M(we,_e,Ae){if(_e===!1)return r;const Y=s(we,Ae);if(Y===r)return r;if(typeof _e=="boolean")return Y;if(_e){const he=_e.when;if(typeof he=="string"){const ke=(ae,J,le,N)=>{if(!N||!Y(ae,J))return null;const q=he.replace("$(basename)",()=>le),ue=N(q);return(0,A.isThenable)(ue)?ue.then(Se=>Se?we:null):ue?we:null};return ke.requiresSiblings=!0,ke}}return Y}function ne(we,_e){const Ae=we.filter(J=>!!J.basenames);if(Ae.length<2)return we;const Y=Ae.reduce((J,le)=>{const N=le.basenames;return N?J.concat(N):J},[]);let he;if(_e){he=[];for(let J=0,le=Y.length;J<le;J++)he.push(_e)}else he=Ae.reduce((J,le)=>{const N=le.patterns;return N?J.concat(N):J},[]);const ke=function(J,le){if(typeof J!="string")return null;if(!le){let q;for(q=J.length;q>0;q--){const ue=J.charCodeAt(q-1);if(ue===47||ue===92)break}le=J.substr(q)}const N=Y.indexOf(le);return N!==-1?he[N]:null};ke.basenames=Y,ke.patterns=he,ke.allBasenames=Y;const ae=we.filter(J=>!J.basenames);return ae.push(ke),ae}function Q(we,_e){return(0,S.equals)(we,_e,(Ae,Y)=>typeof Ae=="string"&&typeof Y=="string"?Ae===Y:typeof Ae!="string"&&typeof Y!="string"?Ae.base===Y.base&&Ae.pattern===Y.pattern:!1)}e.patternsEquals=Q}),define(Pe[49],Te([1,0,9,122,23,15,2]),function(ve,e,S,A,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var h;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(h||(e.MarkdownStringTextNewlineStyle=h={}));class y{constructor(i="",c=!1){if(this.value=i,typeof this.value!="string")throw(0,S.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(i,c=0){return this.value+=l(this.supportThemeIcons?(0,A.escapeIcons)(i):i).replace(/([ \t]+)/g,(f,C)=>"&nbsp;".repeat(C.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,c){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(i,c,f){return this.value+="[",this.value+=this._escape(c,"]"),this.value+="](",this.value+=this._escape(String(i),")"),f&&(this.value+=` "${this._escape(this._escape(f,'"'),")")}"`),this.value+=")",this}_escape(i,c){const f=new RegExp((0,L.escapeRegExpCharacters)(c),"g");return i.replace(f,(C,k)=>i.charAt(k-1)!=="\\"?`\\${C}`:C)}}e.MarkdownString=y;function m(t){return P(t)?!t.value:Array.isArray(t)?t.every(m):!0}e.isEmptyMarkdownString=m;function P(t){return t instanceof y?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function D(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,I.isEqual)(T.URI.from(t.baseUri),T.URI.from(i.baseUri)))}e.markdownStringEqual=D;function l(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=l;function E(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=E;function v(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=v;function d(t){const i=[],c=t.split("|").map(C=>C.trim());t=c[0];const f=c[1];if(f){const C=/height=(\d+)/.exec(f),k=/width=(\d+)/.exec(f),n=C?C[1]:"",a=k?k[1]:"",r=isFinite(parseInt(a)),s=isFinite(parseInt(n));r&&i.push(`width="${a}"`),s&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.parseHrefAndDimensions=d}),define(Pe[90],Te([1,0,18,42,19,22,23,15]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(s,b){const{os:p,tildify:w,relative:_}=b;if(_){const g=m(s,_,p);if(typeof g=="string")return g}let o=s.fsPath;if(p===1&&!L.isWindows?o=o.replace(/\//g,"\\"):p!==1&&L.isWindows&&(o=o.replace(/\\/g,"/")),p!==1&&w?.userHome){const g=w.userHome.fsPath;let O;s.scheme!==w.userHome.scheme&&s.path.startsWith(I.posix.sep)?O=w.userHome.with({path:s.path}).fsPath:O=s.fsPath,o=l(O,g,p)}return(p===1?I.win32:I.posix).normalize(P(o,p===1))}e.getPathLabel=y;function m(s,b,p){const w=p===1?I.win32:I.posix,_=p===3?T.extUri:T.extUriIgnorePathCase,o=b.getWorkspace(),u=(0,S.firstOrDefault)(o.folders);if(!u)return;s.scheme!==u.uri.scheme&&s.path.startsWith(I.posix.sep)&&(s=u.uri.with({path:s.path}));const g=b.getWorkspaceFolder(s);if(!g)return;let O;if(_.isEqual(g.uri,s)?O="":O=_.relativePath(g.uri,s)??"",O&&(O=w.normalize(O)),o.folders.length>1&&!b.noPrefix){const z=g.name?g.name:_.basenameOrAuthority(g.uri);O=O?`${z} \u2022 ${O}`:z}return O}function P(s,b=L.isWindows){return(0,A.hasDriveLetter)(s,b)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=P;let D=Object.create(null);function l(s,b,p=L.OS){if(p===1||!s||!b)return s;let w=D.original===b?D.normalized:void 0;w||(w=b,L.isWindows&&(w=(0,A.toSlashes)(w)),w=`${(0,h.rtrim)(w,I.posix.sep)}${I.posix.sep}`,D={original:b,normalized:w});let _=s;return L.isWindows&&(_=(0,A.toSlashes)(_)),(p===3?_.startsWith(w):(0,h.startsWithIgnoreCase)(_,w))?`~/${_.substr(w.length)}`:s}e.tildify=l;function E(s,b){return s.replace(/^~($|\/|\\)/,`${b}$1`)}e.untildify=E;const v="\u2026",d="\\\\",t="~";function i(s,b=I.sep){const p=new Array(s.length);let w=!1;for(let _=0;_<s.length;_++){const o=s[_];if(o===""){p[_]=`.${b}`;continue}if(!o){p[_]=o;continue}w=!0;let u="",g=o;g.indexOf(d)===0?(u=g.substr(0,g.indexOf(d)+d.length),g=g.substr(g.indexOf(d)+d.length)):g.indexOf(b)===0?(u=g.substr(0,g.indexOf(b)+b.length),g=g.substr(g.indexOf(b)+b.length)):g.indexOf(t)===0&&(u=g.substr(0,g.indexOf(t)+t.length),g=g.substr(g.indexOf(t)+t.length));const O=g.split(b);for(let z=1;w&&z<=O.length;z++)for(let H=O.length-z;w&&H>=0;H--){w=!1;let B=O.slice(H,H+z).join(b);for(let $=0;!w&&$<s.length;$++)if($!==_&&s[$]&&s[$].indexOf(B)>-1){const x=H+z===O.length,M=H>0&&s[$].indexOf(b)>-1?b+B:B,ne=s[$].endsWith(M);w=!x||ne}if(!w){let $="";(O[0].endsWith(":")||u!=="")&&(H===1&&(H=0,z++,B=O[0]+b+B),H>0&&($=O[0]+b),$=u+$),H>0&&($=$+v+b),$=$+B,H+z<O.length&&($=$+b+v),p[_]=$}}w&&(p[_]=o)}return p}e.shorten=i;var c;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function f(s,b=Object.create(null)){const p=[];let w=!1,_="";for(const o of s)if(o==="$"||w&&o==="{")_&&p.push({value:_,type:c.TEXT}),_="",w=!0;else if(o==="}"&&w){const u=b[_];if(typeof u=="string")u.length&&p.push({value:u,type:c.VARIABLE});else if(u){const g=p[p.length-1];(!g||g.type!==c.SEPARATOR)&&p.push({value:u.label,type:c.SEPARATOR})}_="",w=!1}else _+=o;return _&&!w&&p.push({value:_,type:c.TEXT}),p.filter((o,u)=>{if(o.type===c.SEPARATOR){const g=p[u-1],O=p[u+1];return[g,O].every(z=>z&&(z.type===c.VARIABLE||z.type===c.TEXT)&&z.value.length>0)}return!0}).map(o=>o.value).join("")}e.template=f;function C(s,b){return L.isMacintosh||b?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):s.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=C;function k(s,b){return L.isMacintosh||b?s.replace(/\(&&\w\)|&&/g,""):L.isWindows?s.replace(/&&|&/g,p=>p==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=k;function n(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=n;function a(s){if(s.endsWith("]")){const b=s.lastIndexOf(" [",s.length-2);if(b!==-1){const p=r(s.substring(0,b));return{name:p.name,parentPath:p.parentPath+s.substring(b)}}}return r(s)}e.splitRecentLabel=a;function r(s){const b=s.indexOf("/")!==-1?I.posix:I.win32,p=b.basename(s),w=b.dirname(s);return p.length?{name:p,parentPath:w}:{name:w,parentPath:""}}}),define(Pe[133],Te([1,0,25,2]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(D){return D.toJSON()}class L{constructor(l){this._uriTransformer=l}transformIncoming(l){const E=this._uriTransformer.transformIncoming(l);return E===l?l:I(A.URI.from(E))}transformOutgoing(l){const E=this._uriTransformer.transformOutgoing(l);return E===l?l:I(A.URI.from(E))}transformOutgoingURI(l){const E=this._uriTransformer.transformOutgoing(l);return E===l?l:A.URI.from(E)}transformOutgoingScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function T(D,l,E){if(!D||E>200)return null;if(typeof D=="object"){if(D instanceof A.URI)return l.transformOutgoing(D);for(const v in D)if(Object.hasOwnProperty.call(D,v)){const d=T(D[v],l,E+1);d!==null&&(D[v]=d)}}return null}function h(D,l){const E=T(D,l,0);return E===null?D:E}e.transformOutgoingURIs=h;function y(D,l,E,v){if(!D||v>200)return null;if(typeof D=="object"){if(D.$mid===1)return E?A.URI.revive(l.transformIncoming(D)):l.transformIncoming(D);if(D instanceof S.VSBuffer)return null;for(const d in D)if(Object.hasOwnProperty.call(D,d)){const t=y(D[d],l,E,v+1);t!==null&&(D[d]=t)}}return null}function m(D,l){const E=y(D,l,!1,0);return E===null?D:E}e.transformIncomingURIs=m;function P(D,l){const E=y(D,l,!0,0);return E===null?D:E}e.transformAndReviveIncomingURIs=P}),define(Pe[134],Te([1,0,37,19]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(L,T,h,y,m,P){if(Array.isArray(L)){let D=0;for(const l of L){const E=I(l,T,h,y,m,P);if(E===10)return E;E>D&&(D=E)}return D}else{if(typeof L=="string")return y?L==="*"?5:L===h?10:0:0;if(L){const{language:D,pattern:l,scheme:E,hasAccessToAllModels:v,notebookType:d}=L;if(!y&&!v)return 0;d&&m&&(T=m);let t=0;if(E)if(E===T.scheme)t=10;else if(E==="*")t=5;else return 0;if(D)if(D===h)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(d)if(d===P)t=10;else if(d==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(l){let i;if(typeof l=="string"?i=l:i={...l,base:(0,A.normalize)(l.base)},i===T.fsPath||(0,S.match)(i,T.fsPath))t=10;else return 0}return t}else return 0}}e.score=I}),define(Pe[91],Te([1,0,25,22]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(I||(I={}));function L(D){for(let l=0,E=D.length;l<E;l+=4){const v=D[l+0],d=D[l+1],t=D[l+2],i=D[l+3];D[l+0]=i,D[l+1]=t,D[l+2]=d,D[l+3]=v}}function T(D){const l=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return A.isLittleEndian()||L(l),S.VSBuffer.wrap(l)}function h(D){const l=D.buffer;if(A.isLittleEndian()||L(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const E=new Uint8Array(l.byteLength);return E.set(l),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function y(D){const l=new Uint32Array(m(D));let E=0;if(l[E++]=D.id,D.type==="full")l[E++]=1,l[E++]=D.data.length,l.set(D.data,E),E+=D.data.length;else{l[E++]=2,l[E++]=D.deltas.length;for(const v of D.deltas)l[E++]=v.start,l[E++]=v.deleteCount,v.data?(l[E++]=v.data.length,l.set(v.data,E),E+=v.data.length):l[E++]=0}return T(l)}e.encodeSemanticTokensDto=y;function m(D){let l=0;if(l+=1+1,D.type==="full")l+=1+D.data.length;else{l+=1,l+=(1+1+1)*D.deltas.length;for(const E of D.deltas)E.data&&(l+=E.data.length)}return l}function P(D){const l=h(D);let E=0;const v=l[E++];if(l[E++]===1){const c=l[E++],f=l.subarray(E,E+c);return E+=c,{id:v,type:"full",data:f}}const t=l[E++],i=[];for(let c=0;c<t;c++){const f=l[E++],C=l[E++],k=l[E++];let n;k>0&&(n=l.subarray(E,E+k),E+=k),i[c]={start:f,deleteCount:C,data:n}}return{id:v,type:"delta",deltas:i}}e.decodeSemanticTokensDto=P}),define(Pe[135],Te([10,11]),function(ve,e){return ve.create("vs/editor/common/config/editorOptions",e)}),define(Pe[136],Te([1,0,18,24,22,124,137,135]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=m;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class D{constructor(X,pe,$e,Ne){this.id=X,this.name=pe,this.defaultValue=$e,this.schema=Ne}applyUpdate(X,pe){return E(X,pe)}compute(X,pe,$e){return $e}}class l{constructor(X,pe){this.newValue=X,this.didChange=pe}}e.ApplyUpdateResult=l;function E(Z,X){if(typeof Z!="object"||typeof X!="object"||!Z||!X)return new l(X,Z!==X);if(Array.isArray(Z)||Array.isArray(X)){const $e=Array.isArray(Z)&&Array.isArray(X)&&S.equals(Z,X);return new l(X,!$e)}let pe=!1;for(const $e in X)if(X.hasOwnProperty($e)){const Ne=E(Z[$e],X[$e]);Ne.didChange&&(Z[$e]=Ne.newValue,pe=!0)}return new l(Z,pe)}class v{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,pe){return E(X,pe)}validate(X){return this.defaultValue}}class d{constructor(X,pe,$e,Ne){this.id=X,this.name=pe,this.defaultValue=$e,this.schema=Ne}applyUpdate(X,pe){return E(X,pe)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,pe,$e){return $e}}function t(Z,X){return typeof Z>"u"?X:Z==="false"?!1:!!Z}e.boolean=t;class i extends d{constructor(X,pe,$e,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=$e),super(X,pe,$e,Ne)}validate(X){return t(X,this.defaultValue)}}function c(Z,X,pe,$e){if(typeof Z>"u")return X;let Ne=parseInt(Z,10);return isNaN(Ne)?X:(Ne=Math.max(pe,Ne),Ne=Math.min($e,Ne),Ne|0)}e.clampedInt=c;class f extends d{static clampedInt(X,pe,$e,Ne){return c(X,pe,$e,Ne)}constructor(X,pe,$e,Ne,Xe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=$e,nt.minimum=Ne,nt.maximum=Xe),super(X,pe,$e,nt),this.minimum=Ne,this.maximum=Xe}validate(X){return f.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function C(Z,X,pe,$e){if(typeof Z>"u")return X;const Ne=k.float(Z,X);return k.clamp(Ne,pe,$e)}e.clampedFloat=C;class k extends d{static clamp(X,pe,$e){return X<pe?pe:X>$e?$e:X}static float(X,pe){if(typeof X=="number")return X;if(typeof X>"u")return pe;const $e=parseFloat(X);return isNaN($e)?pe:$e}constructor(X,pe,$e,Ne,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=$e),super(X,pe,$e,Xe),this.validationFn=Ne}validate(X){return this.validationFn(k.float(X,this.defaultValue))}}class n extends d{static string(X,pe){return typeof X!="string"?pe:X}constructor(X,pe,$e,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=$e),super(X,pe,$e,Ne)}validate(X){return n.string(X,this.defaultValue)}}function a(Z,X,pe,$e){return typeof Z!="string"?X:$e&&Z in $e?$e[Z]:pe.indexOf(Z)===-1?X:Z}e.stringSet=a;class r extends d{constructor(X,pe,$e,Ne,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Ne,Xe.default=$e),super(X,pe,$e,Xe),this._allowedValues=Ne}validate(X){return a(X,this.defaultValue,this._allowedValues)}}class s extends D{constructor(X,pe,$e,Ne,Xe,nt,ft=void 0){typeof ft<"u"&&(ft.type="string",ft.enum=Xe,ft.default=Ne),super(X,pe,$e,ft),this._allowedValues=Xe,this._convert=nt}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function b(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",tags:["accessibility"],description:h.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,pe,$e){return $e===0?X.accessibilitySupport:$e}}class w extends D{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(22,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:h.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertSpace:t(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var _;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(_||(e.TextEditorCursorBlinkingStyle=_={}));function o(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(u||(e.TextEditorCursorStyle=u={}));function g(Z){switch(Z){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=g;function O(Z){switch(Z){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class z extends v{constructor(){super(139)}compute(X,pe,$e){const Ne=["monaco-editor"];return pe.get(38)&&Ne.push(pe.get(38)),X.extraEditorClassName&&Ne.push(X.extraEditorClassName),pe.get(72)==="default"?Ne.push("mouse-default"):pe.get(72)==="copy"&&Ne.push("mouse-copy"),pe.get(109)&&Ne.push("showUnused"),pe.get(137)&&Ne.push("showDeprecated"),Ne.join(" ")}}class H extends i{constructor(){super(36,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(X,pe,$e){return $e&&X.emptySelectionClipboard}}class B extends D{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(40,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:h.localize(16,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:h.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{cursorMoveOnType:t(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":a(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":a(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(pe.loop,this.defaultValue.loop)}}}class $ extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(50,"fontLigatures",$.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?$.OFF:X==="true"?$.ON:X:X?$.ON:$.OFF}}e.EditorFontLigatures=$;class x extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(53,"fontVariations",x.OFF,{anyOf:[{type:"boolean",description:h.localize(22,null)},{type:"string",description:h.localize(23,null)}],description:h.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?x.OFF:X==="true"?x.TRANSLATE:X:X?x.TRANSLATE:x.OFF}compute(X,pe,$e){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=x;class M extends v{constructor(){super(49)}compute(X,pe,$e){return X.fontInfo}}class ne extends d{constructor(){super(51,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(25,null)})}validate(X){const pe=k.float(X,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:k.clamp(pe,6,100)}compute(X,pe,$e){return X.fontInfo.fontSize}}class Q extends D{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(52,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Q.MINIMUM_VALUE,maximum:Q.MAXIMUM_VALUE,errorMessage:h.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Q.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(f.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,Q.MINIMUM_VALUE,Q.MAXIMUM_VALUE))}}class we extends D{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[h.localize(28,null),h.localize(29,null),h.localize(30,null)]},$e=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(57,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:h.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:h.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:h.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:$e,description:h.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:$e,description:h.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:$e,description:h.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:$e,description:h.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:$e,description:h.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{multiple:a(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??a(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??a(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??a(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??a(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??a(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class _e extends D{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(59,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:h.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:h.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:h.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:h.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),delay:f.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:t(pe.sticky,this.defaultValue.sticky),above:t(pe.above,this.defaultValue.above)}}}var Ae;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Ae||(e.RenderMinimap=Ae={}));class Y extends v{constructor(){super(142)}compute(X,pe,$e){return Y.computeLayout(pe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const pe=X.height/X.lineHeight,$e=Math.floor(X.paddingTop/X.lineHeight);let Ne=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Ne=Math.max(Ne,pe-1));const Xe=($e+X.viewLineCount+Ne)/(X.pixelRatio*X.height),nt=Math.floor(X.viewLineCount/Xe);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:$e,extraLinesBeyondLastLine:Ne,desiredRatio:Xe,minimapLineCount:nt}}static _computeMinimapLayout(X,pe){const $e=X.outerWidth,Ne=X.outerHeight,Xe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const nt=pe.stableMinimapLayoutInput,ft=nt&&X.outerHeight===nt.outerHeight&&X.lineHeight===nt.lineHeight&&X.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&X.pixelRatio===nt.pixelRatio&&X.scrollBeyondLastLine===nt.scrollBeyondLastLine&&X.paddingTop===nt.paddingTop&&X.paddingBottom===nt.paddingBottom&&X.minimap.enabled===nt.minimap.enabled&&X.minimap.side===nt.minimap.side&&X.minimap.size===nt.minimap.size&&X.minimap.showSlider===nt.minimap.showSlider&&X.minimap.renderCharacters===nt.minimap.renderCharacters&&X.minimap.maxColumn===nt.minimap.maxColumn&&X.minimap.scale===nt.minimap.scale&&X.verticalScrollbarWidth===nt.verticalScrollbarWidth&&X.isViewportWrapping===nt.isViewportWrapping,Et=X.lineHeight,Ft=X.typicalHalfwidthCharacterWidth,Xt=X.scrollBeyondLastLine,Ht=X.minimap.renderCharacters;let bt=Xe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Lt=X.minimap.maxColumn,Nt=X.minimap.size,qt=X.minimap.side,Tt=X.verticalScrollbarWidth,At=X.viewLineCount,Ut=X.remainingWidth,$t=X.isViewportWrapping,Wt=Ht?2:3;let Bt=Math.floor(Xe*Ne);const at=Bt/Xe;let ut=!1,jt=!1,Pt=Wt*bt,yt=bt/Xe,ht=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:j,extraLinesBeyondLastLine:Oe,desiredRatio:Be,minimapLineCount:Ke}=Y.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Xt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Ne,lineHeight:Et,pixelRatio:Xe});if(At/Ke>1)ut=!0,jt=!0,bt=1,Pt=1,yt=bt/Xe;else{let Je=!1,pt=bt+1;if(Nt==="fit"){const _t=Math.ceil((j+At+Oe)*Pt);$t&&ft&&Ut<=pe.stableFitRemainingWidth?(Je=!0,pt=pe.stableFitMaxMinimapScale):Je=_t>Bt}if(Nt==="fill"||Je){ut=!0;const _t=bt;Pt=Math.min(Et*Xe,Math.max(1,Math.floor(1/Be))),$t&&ft&&Ut<=pe.stableFitRemainingWidth&&(pt=pe.stableFitMaxMinimapScale),bt=Math.min(pt,Math.max(1,Math.floor(Pt/Wt))),bt>_t&&(ht=Math.min(2,bt/_t)),yt=bt/Xe/ht,Bt=Math.ceil(Math.max(ge,j+At+Oe)*Pt),$t?(pe.stableMinimapLayoutInput=X,pe.stableFitRemainingWidth=Ut,pe.stableFitMaxMinimapScale=bt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const It=Math.floor(Lt*yt),Mt=Math.min(It,Math.max(0,Math.floor((Ut-Tt-2)*yt/(Ft+yt)))+e.MINIMAP_GUTTER_WIDTH);let St=Math.floor(Xe*Mt);const He=St/Xe;St=Math.floor(St*ht);const Ie=Ht?1:2,Re=qt==="left"?0:$e-Mt-Tt;return{renderMinimap:Ie,minimapLeft:Re,minimapWidth:Mt,minimapHeightIsEditorHeight:ut,minimapIsSampling:jt,minimapScale:bt,minimapLineHeight:Pt,minimapCanvasInnerWidth:St,minimapCanvasInnerHeight:Bt,minimapCanvasOuterWidth:He,minimapCanvasOuterHeight:at}}static computeLayout(X,pe){const $e=pe.outerWidth|0,Ne=pe.outerHeight|0,Xe=pe.lineHeight|0,nt=pe.lineNumbersDigitCount|0,ft=pe.typicalHalfwidthCharacterWidth,Et=pe.maxDigitWidth,Ft=pe.pixelRatio,Xt=pe.viewLineCount,Ht=X.get(134),bt=Ht==="inherit"?X.get(133):Ht,Lt=bt==="inherit"?X.get(129):bt,Nt=X.get(132),qt=pe.isDominatedByLongLines,Tt=X.get(56),At=X.get(66).renderType!==0,Ut=X.get(67),$t=X.get(103),Wt=X.get(82),Bt=X.get(71),at=X.get(101),ut=at.verticalScrollbarSize,jt=at.verticalHasArrows,Pt=at.arrowSize,yt=at.horizontalScrollbarSize,ht=X.get(42),It=X.get(108)!=="never";let Mt=X.get(64);ht&&It&&(Mt+=16);let St=0;if(At){const ct=Math.max(nt,Ut);St=Math.round(ct*Et)}let He=0;Tt&&(He=Xe*pe.glyphMarginDecorationLaneCount);let Ie=0,Re=Ie+He,ge=Re+St,j=ge+Mt;const Oe=$e-He-St-Mt;let Be=!1,Ke=!1,We=-1;bt==="inherit"&&qt?(Be=!0,Ke=!0):Lt==="on"||Lt==="bounded"?Ke=!0:Lt==="wordWrapColumn"&&(We=Nt);const Je=Y._computeMinimapLayout({outerWidth:$e,outerHeight:Ne,lineHeight:Xe,typicalHalfwidthCharacterWidth:ft,pixelRatio:Ft,scrollBeyondLastLine:$t,paddingTop:Wt.top,paddingBottom:Wt.bottom,minimap:Bt,verticalScrollbarWidth:ut,viewLineCount:Xt,remainingWidth:Oe,isViewportWrapping:Ke},pe.memory||new P);Je.renderMinimap!==0&&Je.minimapLeft===0&&(Ie+=Je.minimapWidth,Re+=Je.minimapWidth,ge+=Je.minimapWidth,j+=Je.minimapWidth);const pt=Oe-Je.minimapWidth,_t=Math.max(1,Math.floor((pt-ut-2)/ft)),vt=jt?Pt:0;return Ke&&(We=Math.max(1,_t),Lt==="bounded"&&(We=Math.min(We,Nt))),{width:$e,height:Ne,glyphMarginLeft:Ie,glyphMarginWidth:He,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Re,lineNumbersWidth:St,decorationsLeft:ge,decorationsWidth:Mt,contentLeft:j,contentWidth:pt,minimap:Je,viewportColumn:_t,isWordWrapMinified:Be,isViewportWrapping:Ke,wrappingColumn:We,verticalScrollbarWidth:ut,horizontalScrollbarHeight:yt,overviewRuler:{top:vt,width:ut,height:Ne-2*vt,right:0}}}}e.EditorLayoutInfoComputer=Y;class he extends D{constructor(){super(136,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[h.localize(46,null),h.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:h.localize(48,null)}})}validate(X){return a(X,"simple",["simple","advanced"])}compute(X,pe,$e){return pe.get(2)===2?"advanced":$e}}class ke extends D{constructor(){const X={enabled:!0};super(63,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:h.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:t(X.enabled,this.defaultValue.enabled)}}}class ae extends D{constructor(){const X={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(113,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:h.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:h.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:h.localize(52,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:h.localize(53,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),maxLineCount:f.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class J extends D{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(138,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:h.localize(54,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[h.localize(55,null),h.localize(56,null,I.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),h.localize(57,null,I.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),h.localize(58,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:h.localize(59,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:h.localize(60,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:h.localize(61,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:a(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:f.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(pe.fontFamily,this.defaultValue.fontFamily),padding:t(pe.padding,this.defaultValue.padding)}}}class le extends D{constructor(){super(64,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):f.clampedInt(X,this.defaultValue,0,1e3)}compute(X,pe,$e){return $e<0?f.clampedInt(-$e*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):$e}}class N extends k{constructor(){super(65,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>k.clamp(X,0,150),{markdownDescription:h.localize(62,null)})}compute(X,pe,$e){return X.fontInfo.lineHeight}}class q extends D{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(71,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:h.localize(63,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:h.localize(64,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(65,null),h.localize(66,null),h.localize(67,null)],default:X.size,description:h.localize(68,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:h.localize(69,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:h.localize(70,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(71,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:h.localize(72,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:h.localize(73,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),autohide:t(pe.autohide,this.defaultValue.autohide),size:a(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(pe.side,this.defaultValue.side,["right","left"]),showSlider:a(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(pe.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(pe.scale,1,1,3),maxColumn:f.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ue(Z){return Z==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Se extends D{constructor(){super(82,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(74,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(75,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{top:f.clampedInt(pe.top,0,0,1e3),bottom:f.clampedInt(pe.bottom,0,0,1e3)}}}class be extends D{constructor(){const X={enabled:!0,cycle:!0};super(84,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:h.localize(76,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:h.localize(77,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),cycle:t(pe.cycle,this.defaultValue.cycle)}}}class Ee extends v{constructor(){super(140)}compute(X,pe,$e){return X.pixelRatio}}class ye extends D{constructor(){const X={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[h.localize(78,null),h.localize(79,null),h.localize(80,null)]}];super(87,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:X.strings,description:h.localize(81,null)},comments:{anyOf:pe,default:X.comments,description:h.localize(82,null)},other:{anyOf:pe,default:X.other,description:h.localize(83,null)}},default:X,markdownDescription:h.localize(84,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Ft=X?"on":"off";return{comments:Ft,strings:Ft,other:Ft}}if(!X||typeof X!="object")return this.defaultValue;const{other:pe,comments:$e,strings:Ne}=X,Xe=["on","inline","off"];let nt,ft,Et;return typeof pe=="boolean"?nt=pe?"on":"off":nt=a(pe,this.defaultValue.other,Xe),typeof $e=="boolean"?ft=$e?"on":"off":ft=a($e,this.defaultValue.comments,Xe),typeof Ne=="boolean"?Et=Ne?"on":"off":Et=a(Ne,this.defaultValue.strings,Xe),{other:nt,comments:ft,strings:Et}}}var oe;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(oe||(e.RenderLineNumbersType=oe={}));class de extends D{constructor(){super(66,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(85,null),h.localize(86,null),h.localize(87,null),h.localize(88,null)],default:"on",description:h.localize(89,null)})}validate(X){let pe=this.defaultValue.renderType,$e=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(pe=4,$e=X):X==="interval"?pe=3:X==="relative"?pe=2:X==="on"?pe=1:pe=0),{renderType:pe,renderFn:$e}}}function re(Z){const X=Z.get(96);return X==="editable"?Z.get(89):X!=="on"}e.filterValidationDecorations=re;class ie extends D{constructor(){const X=[],pe={type:"number",description:h.localize(90,null)};super(100,"rulers",X,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:h.localize(91,null),format:"color-hex"}}}]},default:X,description:h.localize(92,null)})}validate(X){if(Array.isArray(X)){const pe=[];for(const $e of X)if(typeof $e=="number")pe.push({column:f.clampedInt($e,0,0,1e4),color:null});else if($e&&typeof $e=="object"){const Ne=$e;pe.push({column:f.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return pe.sort(($e,Ne)=>$e.column-Ne.column),pe}return this.defaultValue}}class me extends D{constructor(){super(90,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Ce(Z,X){if(typeof Z!="string")return X;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class R extends D{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(101,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(93,null),h.localize(94,null),h.localize(95,null)],default:"auto",description:h.localize(96,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(97,null),h.localize(98,null),h.localize(99,null)],default:"auto",description:h.localize(100,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:h.localize(101,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:h.localize(102,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:h.localize(103,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X,$e=f.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=f.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(pe.vertical,this.defaultValue.vertical),horizontal:Ce(pe.horizontal,this.defaultValue.horizontal),useShadows:t(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:$e,horizontalSliderSize:f.clampedInt(pe.horizontalSliderSize,$e,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:f.clampedInt(pe.verticalSliderSize,Ne,0,1e3),scrollByPage:t(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends D{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(123,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:h.localize(104,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:h.localize(105,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:h.localize(106,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:h.localize(107,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:h.localize(108,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:h.localize(109,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:h.localize(110,null)}})}applyUpdate(X,pe){let $e=!1;pe.allowedCharacters&&X&&(A.equals(X.allowedCharacters,pe.allowedCharacters)||(X={...X,allowedCharacters:pe.allowedCharacters},$e=!0)),pe.allowedLocales&&X&&(A.equals(X.allowedLocales,pe.allowedLocales)||(X={...X,allowedLocales:pe.allowedLocales},$e=!0));const Ne=super.applyUpdate(X,pe);return $e?new l(Ne.newValue,!0):Ne}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{nonBasicASCII:ee(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,pe){if(typeof X!="object"||!X)return pe;const $e={};for(const[Ne,Xe]of Object.entries(X))Xe===!0&&($e[Ne]=!0);return $e}}class K extends D{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(61,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:h.localize(111,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[h.localize(112,null),h.localize(113,null)],description:h.localize(114,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:h.localize(115,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),mode:a(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class G extends D{constructor(){const X={enabled:L.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(14,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:h.localize(116,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:h.localize(117,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class V extends D{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(15,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(118,null),h.localize(119,null),h.localize(120,null)],default:X.bracketPairs,description:h.localize(121,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(122,null),h.localize(123,null),h.localize(124,null)],default:X.bracketPairsHorizontal,description:h.localize(125,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:h.localize(126,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:h.localize(127,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[h.localize(128,null),h.localize(129,null),h.localize(130,null)],default:X.highlightActiveIndentation,description:h.localize(131,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{bracketPairs:ee(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Z,X,pe){const $e=pe.indexOf(Z);return $e===-1?X:pe[$e]}class ce extends D{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(116,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(132,null),h.localize(133,null)],default:X.insertMode,description:h.localize(134,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:h.localize(135,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:h.localize(136,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:h.localize(137,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[h.localize(138,null),h.localize(139,null),h.localize(140,null),h.localize(141,null)],default:X.selectionMode,markdownDescription:h.localize(142,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:h.localize(143,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:h.localize(144,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:h.localize(145,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:h.localize(146,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:h.localize(147,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(148,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(149,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(150,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(151,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(152,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(153,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:h.localize(154,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(155,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(156,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(157,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(158,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(159,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(160,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(161,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(162,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(163,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(164,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(165,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(166,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(167,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(168,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(169,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(170,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(171,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(172,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(173,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(174,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(175,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(176,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(177,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(178,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(179,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertMode:a(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(pe.showIcons,this.defaultValue.showIcons),showStatusBar:t(pe.showStatusBar,this.defaultValue.showStatusBar),preview:t(pe.preview,this.defaultValue.preview),previewMode:a(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(pe.showMethods,this.defaultValue.showMethods),showFunctions:t(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:t(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(pe.showFields,this.defaultValue.showFields),showVariables:t(pe.showVariables,this.defaultValue.showVariables),showClasses:t(pe.showClasses,this.defaultValue.showClasses),showStructs:t(pe.showStructs,this.defaultValue.showStructs),showInterfaces:t(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:t(pe.showModules,this.defaultValue.showModules),showProperties:t(pe.showProperties,this.defaultValue.showProperties),showEvents:t(pe.showEvents,this.defaultValue.showEvents),showOperators:t(pe.showOperators,this.defaultValue.showOperators),showUnits:t(pe.showUnits,this.defaultValue.showUnits),showValues:t(pe.showValues,this.defaultValue.showValues),showConstants:t(pe.showConstants,this.defaultValue.showConstants),showEnums:t(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:t(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(pe.showKeywords,this.defaultValue.showKeywords),showWords:t(pe.showWords,this.defaultValue.showWords),showColors:t(pe.showColors,this.defaultValue.showColors),showFiles:t(pe.showFiles,this.defaultValue.showFiles),showReferences:t(pe.showReferences,this.defaultValue.showReferences),showFolders:t(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:t(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(pe.showSnippets,this.defaultValue.showSnippets),showUsers:t(pe.showUsers,this.defaultValue.showUsers),showIssues:t(pe.showIssues,this.defaultValue.showIssues)}}}class Me extends D{constructor(){super(111,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(180,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:h.localize(181,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(X.selectSubwords,this.defaultValue.selectSubwords)}}}var xe;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(xe||(e.WrappingIndent=xe={}));class Ge extends D{constructor(){super(135,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[h.localize(182,null),h.localize(183,null),h.localize(184,null),h.localize(185,null)],description:h.localize(186,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,pe,$e){return pe.get(2)===2?0:$e}}class je extends v{constructor(){super(143)}compute(X,pe,$e){const Ne=pe.get(142);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class et extends D{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(35,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:h.localize(187,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:h.localize(188,null),enum:["afterDrop","never"],enumDescriptions:[h.localize(189,null),h.localize(190,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),showDropSelector:a(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends D{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(83,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:h.localize(191,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:h.localize(192,null),enum:["afterPaste","never"],enumDescriptions:[h.localize(193,null),h.localize(194,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),showPasteSelector:a(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ze="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?it:I.isLinux?tt:Ze,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var st;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=8]="autoClosingDelete",Z[Z.autoClosingOvertype=9]="autoClosingOvertype",Z[Z.autoClosingQuotes=10]="autoClosingQuotes",Z[Z.autoIndent=11]="autoIndent",Z[Z.automaticLayout=12]="automaticLayout",Z[Z.autoSurround=13]="autoSurround",Z[Z.bracketPairColorization=14]="bracketPairColorization",Z[Z.guides=15]="guides",Z[Z.codeLens=16]="codeLens",Z[Z.codeLensFontFamily=17]="codeLensFontFamily",Z[Z.codeLensFontSize=18]="codeLensFontSize",Z[Z.colorDecorators=19]="colorDecorators",Z[Z.colorDecoratorsLimit=20]="colorDecoratorsLimit",Z[Z.columnSelection=21]="columnSelection",Z[Z.comments=22]="comments",Z[Z.contextmenu=23]="contextmenu",Z[Z.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=25]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=27]="cursorStyle",Z[Z.cursorSurroundingLines=28]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=30]="cursorWidth",Z[Z.disableLayerHinting=31]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",Z[Z.domReadOnly=33]="domReadOnly",Z[Z.dragAndDrop=34]="dragAndDrop",Z[Z.dropIntoEditor=35]="dropIntoEditor",Z[Z.emptySelectionClipboard=36]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=38]="extraEditorClassName",Z[Z.fastScrollSensitivity=39]="fastScrollSensitivity",Z[Z.find=40]="find",Z[Z.fixedOverflowWidgets=41]="fixedOverflowWidgets",Z[Z.folding=42]="folding",Z[Z.foldingStrategy=43]="foldingStrategy",Z[Z.foldingHighlight=44]="foldingHighlight",Z[Z.foldingImportsByDefault=45]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=46]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=48]="fontFamily",Z[Z.fontInfo=49]="fontInfo",Z[Z.fontLigatures=50]="fontLigatures",Z[Z.fontSize=51]="fontSize",Z[Z.fontWeight=52]="fontWeight",Z[Z.fontVariations=53]="fontVariations",Z[Z.formatOnPaste=54]="formatOnPaste",Z[Z.formatOnType=55]="formatOnType",Z[Z.glyphMargin=56]="glyphMargin",Z[Z.gotoLocation=57]="gotoLocation",Z[Z.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",Z[Z.hover=59]="hover",Z[Z.inDiffEditor=60]="inDiffEditor",Z[Z.inlineSuggest=61]="inlineSuggest",Z[Z.letterSpacing=62]="letterSpacing",Z[Z.lightbulb=63]="lightbulb",Z[Z.lineDecorationsWidth=64]="lineDecorationsWidth",Z[Z.lineHeight=65]="lineHeight",Z[Z.lineNumbers=66]="lineNumbers",Z[Z.lineNumbersMinChars=67]="lineNumbersMinChars",Z[Z.linkedEditing=68]="linkedEditing",Z[Z.links=69]="links",Z[Z.matchBrackets=70]="matchBrackets",Z[Z.minimap=71]="minimap",Z[Z.mouseStyle=72]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=74]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=76]="multiCursorModifier",Z[Z.multiCursorPaste=77]="multiCursorPaste",Z[Z.multiCursorLimit=78]="multiCursorLimit",Z[Z.occurrencesHighlight=79]="occurrencesHighlight",Z[Z.overviewRulerBorder=80]="overviewRulerBorder",Z[Z.overviewRulerLanes=81]="overviewRulerLanes",Z[Z.padding=82]="padding",Z[Z.pasteAs=83]="pasteAs",Z[Z.parameterHints=84]="parameterHints",Z[Z.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=87]="quickSuggestions",Z[Z.quickSuggestionsDelay=88]="quickSuggestionsDelay",Z[Z.readOnly=89]="readOnly",Z[Z.readOnlyMessage=90]="readOnlyMessage",Z[Z.renameOnType=91]="renameOnType",Z[Z.renderControlCharacters=92]="renderControlCharacters",Z[Z.renderFinalNewline=93]="renderFinalNewline",Z[Z.renderLineHighlight=94]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=96]="renderValidationDecorations",Z[Z.renderWhitespace=97]="renderWhitespace",Z[Z.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",Z[Z.roundedSelection=99]="roundedSelection",Z[Z.rulers=100]="rulers",Z[Z.scrollbar=101]="scrollbar",Z[Z.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=103]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=104]="scrollPredominantAxis",Z[Z.selectionClipboard=105]="selectionClipboard",Z[Z.selectionHighlight=106]="selectionHighlight",Z[Z.selectOnLineNumbers=107]="selectOnLineNumbers",Z[Z.showFoldingControls=108]="showFoldingControls",Z[Z.showUnused=109]="showUnused",Z[Z.snippetSuggestions=110]="snippetSuggestions",Z[Z.smartSelect=111]="smartSelect",Z[Z.smoothScrolling=112]="smoothScrolling",Z[Z.stickyScroll=113]="stickyScroll",Z[Z.stickyTabStops=114]="stickyTabStops",Z[Z.stopRenderingLineAfter=115]="stopRenderingLineAfter",Z[Z.suggest=116]="suggest",Z[Z.suggestFontSize=117]="suggestFontSize",Z[Z.suggestLineHeight=118]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",Z[Z.suggestSelection=120]="suggestSelection",Z[Z.tabCompletion=121]="tabCompletion",Z[Z.tabIndex=122]="tabIndex",Z[Z.unicodeHighlighting=123]="unicodeHighlighting",Z[Z.unusualLineTerminators=124]="unusualLineTerminators",Z[Z.useShadowDOM=125]="useShadowDOM",Z[Z.useTabStops=126]="useTabStops",Z[Z.wordBreak=127]="wordBreak",Z[Z.wordSeparators=128]="wordSeparators",Z[Z.wordWrap=129]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=132]="wordWrapColumn",Z[Z.wordWrapOverride1=133]="wordWrapOverride1",Z[Z.wordWrapOverride2=134]="wordWrapOverride2",Z[Z.wrappingIndent=135]="wrappingIndent",Z[Z.wrappingStrategy=136]="wrappingStrategy",Z[Z.showDeprecated=137]="showDeprecated",Z[Z.inlayHints=138]="inlayHints",Z[Z.editorClassName=139]="editorClassName",Z[Z.pixelRatio=140]="pixelRatio",Z[Z.tabFocusMode=141]="tabFocusMode",Z[Z.layoutInfo=142]="layoutInfo",Z[Z.wrappingInfo=143]="wrappingInfo",Z[Z.defaultColorDecorators=144]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=146]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(195,null)})),acceptSuggestionOnEnter:Ue(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(196,null),""],markdownDescription:h.localize(197,null)})),accessibilitySupport:Ue(new p),accessibilityPageSize:Ue(new f(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(198,null),tags:["accessibility"]})),ariaLabel:Ue(new n(4,"ariaLabel",h.localize(199,null))),ariaRequired:Ue(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new i(7,"screenReaderAnnounceInlineSuggestion",!0,{description:h.localize(200,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(201,null),h.localize(202,null),""],description:h.localize(203,null)})),autoClosingDelete:Ue(new r(8,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(204,null),""],description:h.localize(205,null)})),autoClosingOvertype:Ue(new r(9,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(206,null),""],description:h.localize(207,null)})),autoClosingQuotes:Ue(new r(10,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(208,null),h.localize(209,null),""],description:h.localize(210,null)})),autoIndent:Ue(new s(11,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[h.localize(211,null),h.localize(212,null),h.localize(213,null),h.localize(214,null),h.localize(215,null)],description:h.localize(216,null)})),automaticLayout:Ue(new i(12,"automaticLayout",!1)),autoSurround:Ue(new r(13,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(217,null),h.localize(218,null),h.localize(219,null),""],description:h.localize(220,null)})),bracketPairColorization:Ue(new G),bracketPairGuides:Ue(new V),stickyTabStops:Ue(new i(114,"stickyTabStops",!1,{description:h.localize(221,null)})),codeLens:Ue(new i(16,"codeLens",!0,{description:h.localize(222,null)})),codeLensFontFamily:Ue(new n(17,"codeLensFontFamily","",{description:h.localize(223,null)})),codeLensFontSize:Ue(new f(18,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(224,null)})),colorDecorators:Ue(new i(19,"colorDecorators",!0,{description:h.localize(225,null)})),colorDecoratorActivatedOn:Ue(new r(145,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[h.localize(226,null),h.localize(227,null),h.localize(228,null)],description:h.localize(229,null)})),colorDecoratorsLimit:Ue(new f(20,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:h.localize(230,null)})),columnSelection:Ue(new i(21,"columnSelection",!1,{description:h.localize(231,null)})),comments:Ue(new w),contextmenu:Ue(new i(23,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new i(24,"copyWithSyntaxHighlighting",!0,{description:h.localize(232,null)})),cursorBlinking:Ue(new s(25,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:h.localize(233,null)})),cursorSmoothCaretAnimation:Ue(new r(26,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[h.localize(234,null),h.localize(235,null),h.localize(236,null)],description:h.localize(237,null)})),cursorStyle:Ue(new s(27,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:h.localize(238,null)})),cursorSurroundingLines:Ue(new f(28,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(239,null)})),cursorSurroundingLinesStyle:Ue(new r(29,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(240,null),h.localize(241,null)],description:h.localize(242,null)})),cursorWidth:Ue(new f(30,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(243,null)})),disableLayerHinting:Ue(new i(31,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new i(32,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new i(33,"domReadOnly",!1)),dragAndDrop:Ue(new i(34,"dragAndDrop",!0,{description:h.localize(244,null)})),emptySelectionClipboard:Ue(new H),dropIntoEditor:Ue(new et),stickyScroll:Ue(new ae),experimentalWhitespaceRendering:Ue(new r(37,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[h.localize(245,null),h.localize(246,null),h.localize(247,null)],description:h.localize(248,null)})),extraEditorClassName:Ue(new n(38,"extraEditorClassName","")),fastScrollSensitivity:Ue(new k(39,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:h.localize(249,null)})),find:Ue(new B),fixedOverflowWidgets:Ue(new i(41,"fixedOverflowWidgets",!1)),folding:Ue(new i(42,"folding",!0,{description:h.localize(250,null)})),foldingStrategy:Ue(new r(43,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(251,null),h.localize(252,null)],description:h.localize(253,null)})),foldingHighlight:Ue(new i(44,"foldingHighlight",!0,{description:h.localize(254,null)})),foldingImportsByDefault:Ue(new i(45,"foldingImportsByDefault",!1,{description:h.localize(255,null)})),foldingMaximumRegions:Ue(new f(46,"foldingMaximumRegions",5e3,10,65e3,{description:h.localize(256,null)})),unfoldOnClickAfterEndOfLine:Ue(new i(47,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(257,null)})),fontFamily:Ue(new n(48,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(258,null)})),fontInfo:Ue(new M),fontLigatures2:Ue(new $),fontSize:Ue(new ne),fontWeight:Ue(new Q),fontVariations:Ue(new x),formatOnPaste:Ue(new i(54,"formatOnPaste",!1,{description:h.localize(259,null)})),formatOnType:Ue(new i(55,"formatOnType",!1,{description:h.localize(260,null)})),glyphMargin:Ue(new i(56,"glyphMargin",!0,{description:h.localize(261,null)})),gotoLocation:Ue(new we),hideCursorInOverviewRuler:Ue(new i(58,"hideCursorInOverviewRuler",!1,{description:h.localize(262,null)})),hover:Ue(new _e),inDiffEditor:Ue(new i(60,"inDiffEditor",!1)),letterSpacing:Ue(new k(62,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>k.clamp(Z,-5,20),{description:h.localize(263,null)})),lightbulb:Ue(new ke),lineDecorationsWidth:Ue(new le),lineHeight:Ue(new N),lineNumbers:Ue(new de),lineNumbersMinChars:Ue(new f(67,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new i(68,"linkedEditing",!1,{description:h.localize(264,null)})),links:Ue(new i(69,"links",!0,{description:h.localize(265,null)})),matchBrackets:Ue(new r(70,"matchBrackets","always",["always","near","never"],{description:h.localize(266,null)})),minimap:Ue(new q),mouseStyle:Ue(new r(72,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new k(73,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:h.localize(267,null)})),mouseWheelZoom:Ue(new i(74,"mouseWheelZoom",!1,{markdownDescription:h.localize(268,null)})),multiCursorMergeOverlapping:Ue(new i(75,"multiCursorMergeOverlapping",!0,{description:h.localize(269,null)})),multiCursorModifier:Ue(new s(76,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[h.localize(270,null),h.localize(271,null)],markdownDescription:h.localize(272,null)})),multiCursorPaste:Ue(new r(77,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(273,null),h.localize(274,null)],markdownDescription:h.localize(275,null)})),multiCursorLimit:Ue(new f(78,"multiCursorLimit",1e4,1,1e5,{markdownDescription:h.localize(276,null)})),occurrencesHighlight:Ue(new i(79,"occurrencesHighlight",!0,{description:h.localize(277,null)})),overviewRulerBorder:Ue(new i(80,"overviewRulerBorder",!0,{description:h.localize(278,null)})),overviewRulerLanes:Ue(new f(81,"overviewRulerLanes",3,0,3)),padding:Ue(new Se),pasteAs:Ue(new Ye),parameterHints:Ue(new be),peekWidgetDefaultFocus:Ue(new r(85,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(279,null),h.localize(280,null)],description:h.localize(281,null)})),definitionLinkOpensInPeek:Ue(new i(86,"definitionLinkOpensInPeek",!1,{description:h.localize(282,null)})),quickSuggestions:Ue(new ye),quickSuggestionsDelay:Ue(new f(88,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(283,null)})),readOnly:Ue(new i(89,"readOnly",!1)),readOnlyMessage:Ue(new me),renameOnType:Ue(new i(91,"renameOnType",!1,{description:h.localize(284,null),markdownDeprecationMessage:h.localize(285,null)})),renderControlCharacters:Ue(new i(92,"renderControlCharacters",!0,{description:h.localize(286,null),restricted:!0})),renderFinalNewline:Ue(new r(93,"renderFinalNewline",I.isLinux?"dimmed":"on",["off","on","dimmed"],{description:h.localize(287,null)})),renderLineHighlight:Ue(new r(94,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(288,null)],description:h.localize(289,null)})),renderLineHighlightOnlyWhenFocus:Ue(new i(95,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(290,null)})),renderValidationDecorations:Ue(new r(96,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new r(97,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(291,null),h.localize(292,null),h.localize(293,null),""],description:h.localize(294,null)})),revealHorizontalRightPadding:Ue(new f(98,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new i(99,"roundedSelection",!0,{description:h.localize(295,null)})),rulers:Ue(new ie),scrollbar:Ue(new R),scrollBeyondLastColumn:Ue(new f(102,"scrollBeyondLastColumn",4,0,1073741824,{description:h.localize(296,null)})),scrollBeyondLastLine:Ue(new i(103,"scrollBeyondLastLine",!0,{description:h.localize(297,null)})),scrollPredominantAxis:Ue(new i(104,"scrollPredominantAxis",!0,{description:h.localize(298,null)})),selectionClipboard:Ue(new i(105,"selectionClipboard",!0,{description:h.localize(299,null),included:I.isLinux})),selectionHighlight:Ue(new i(106,"selectionHighlight",!0,{description:h.localize(300,null)})),selectOnLineNumbers:Ue(new i(107,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new r(108,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[h.localize(301,null),h.localize(302,null),h.localize(303,null)],description:h.localize(304,null)})),showUnused:Ue(new i(109,"showUnused",!0,{description:h.localize(305,null)})),showDeprecated:Ue(new i(137,"showDeprecated",!0,{description:h.localize(306,null)})),inlayHints:Ue(new J),snippetSuggestions:Ue(new r(110,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(307,null),h.localize(308,null),h.localize(309,null),h.localize(310,null)],description:h.localize(311,null)})),smartSelect:Ue(new Me),smoothScrolling:Ue(new i(112,"smoothScrolling",!1,{description:h.localize(312,null)})),stopRenderingLineAfter:Ue(new f(115,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new ce),inlineSuggest:Ue(new K),inlineCompletionsAccessibilityVerbose:Ue(new i(146,"inlineCompletionsAccessibilityVerbose",!1,{description:h.localize(313,null)})),suggestFontSize:Ue(new f(117,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(314,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new f(118,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(315,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new i(119,"suggestOnTriggerCharacters",!0,{description:h.localize(316,null)})),suggestSelection:Ue(new r(120,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(317,null),h.localize(318,null),h.localize(319,null)],description:h.localize(320,null)})),tabCompletion:Ue(new r(121,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(321,null),h.localize(322,null),h.localize(323,null)],description:h.localize(324,null)})),tabIndex:Ue(new f(122,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new W),unusualLineTerminators:Ue(new r(124,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(325,null),h.localize(326,null),h.localize(327,null)],description:h.localize(328,null)})),useShadowDOM:Ue(new i(125,"useShadowDOM",!0)),useTabStops:Ue(new i(126,"useTabStops",!0,{description:h.localize(329,null)})),wordBreak:Ue(new r(127,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[h.localize(330,null),h.localize(331,null)],description:h.localize(332,null)})),wordSeparators:Ue(new n(128,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:h.localize(333,null)})),wordWrap:Ue(new r(129,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(334,null),h.localize(335,null),h.localize(336,null),h.localize(337,null)],description:h.localize(338,null)})),wordWrapBreakAfterCharacters:Ue(new n(130,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new n(131,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new f(132,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(339,null)})),wordWrapOverride1:Ue(new r(133,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new r(134,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new z),defaultColorDecorators:Ue(new i(144,"defaultColorDecorators",!1,{markdownDescription:h.localize(340,null)})),pixelRatio:Ue(new Ee),tabFocusMode:Ue(new i(141,"tabFocusMode",!1,{markdownDescription:h.localize(341,null)})),layoutInfo:Ue(new Y),wrappingInfo:Ue(new je),wrappingIndent:Ue(new Ge),wrappingStrategy:Ue(new he)}}),define(Pe[138],Te([10,11]),function(ve,e){return ve.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[139],Te([10,11]),function(ve,e){return ve.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[140],Te([10,11]),function(ve,e){return ve.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[141],Te([10,11]),function(ve,e){return ve.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[142],Te([10,11]),function(ve,e){return ve.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[143],Te([10,11]),function(ve,e){return ve.create("vs/platform/files/common/files",e)}),define(Pe[144],Te([10,11]),function(ve,e){return ve.create("vs/platform/markers/common/markers",e)}),define(Pe[145],Te([10,11]),function(ve,e){return ve.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[146],Te([10,11]),function(ve,e){return ve.create("vs/platform/workspace/common/workspace",e)}),define(Pe[147],Te([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostChat",e)}),define(Pe[148],Te([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[149],Te([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[150],Te([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[151],Te([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[152],Te([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[153],Te([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[154],Te([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[155],Te([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[156],Te([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[157],Te([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[158],Te([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[159],Te([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[160],Te([10,11]),function(ve,e){return ve.create("vs/workbench/common/editor",e)}),define(Pe[161],Te([10,11]),function(ve,e){return ve.create("vs/workbench/common/views",e)}),define(Pe[162],Te([10,11]),function(ve,e){return ve.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[163],Te([10,11]),function(ve,e){return ve.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[164],Te([10,11]),function(ve,e){return ve.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[165],Te([10,11]),function(ve,e){return ve.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[166],Te([10,11]),function(ve,e){return ve.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[167],Te([10,11]),function(ve,e){return ve.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[168],Te([10,11]),function(ve,e){return ve.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[169],Te([1,0,9,140]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var I;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(I||(e.TokenType=I={}));function L(...m){switch(m.length){case 1:return(0,A.localize)(0,null,m[0]);case 2:return(0,A.localize)(1,null,m[0],m[1]);case 3:return(0,A.localize)(2,null,m[0],m[1],m[2]);default:return}}const T=(0,A.localize)(3,null),h=(0,A.localize)(4,null);class y{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,S.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(P){return this._input=P,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const D=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:D})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const D=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:D})}else this._match(126)?this._addToken(9):this._error(L("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(L("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(P){return this._isAtEnd()||this._input.charCodeAt(this._current)!==P?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(P){this._tokens.push({type:P,offset:this._start})}_error(P){const D=this._start,l=this._input.substring(this._start,this._current),E={type:19,offset:this._start,lexeme:l};this._errors.push({offset:D,lexeme:l,additionalInfo:P}),this._tokens.push(E)}_string(){this.stringRe.lastIndex=this._start;const P=this.stringRe.exec(this._input);if(P){this._current=this._start+P[0].length;const D=this._input.substring(this._start,this._current),l=y._keywords.get(D);l?this._addToken(l):this._tokens.push({type:17,lexeme:D,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let P=this._current,D=!1,l=!1;for(;;){if(P>=this._input.length){this._current=P,this._error(h);return}const v=this._input.charCodeAt(P);if(D)D=!1;else if(v===47&&!l){P++;break}else v===91?l=!0:v===92?D=!0:v===93&&(l=!1);P++}for(;P<this._input.length&&y._regexFlags.has(this._input.charCodeAt(P));)P++;this._current=P;const E=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:E,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=y}),define(Pe[170],Te([1,0,23,29,142,276]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,h=/^-(\d{4})(\d{2})(\d{2})$/;function y(i){return i=i.trim(),i==="*"||T.test(i)}e.isValidVersionStr=y;function m(i){if(!y(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=i.match(T);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.parseVersion=m;function P(i){if(!i)return null;const c=i.majorBase,f=i.majorMustEqual,C=i.minorBase;let k=i.minorMustEqual;const n=i.patchBase;let a=i.patchMustEqual;i.hasCaret&&(c===0||(k=!1),a=!1);let r=0;if(i.preRelease){const s=h.exec(i.preRelease);if(s){const[,b,p,w]=s;r=Date.UTC(Number(b),Number(p)-1,Number(w))}}return{majorBase:c,majorMustEqual:f,minorBase:C,minorMustEqual:k,patchBase:n,patchMustEqual:a,isMinimum:i.hasGreaterEquals,notBefore:r}}e.normalizeVersion=P;function D(i,c,f){let C;typeof i=="string"?C=P(m(i)):C=i;let k;c instanceof Date?k=c.getTime():typeof c=="string"&&(k=new Date(c).getTime());let n;if(typeof f=="string"?n=P(m(f)):n=f,!C||!n)return!1;const a=C.majorBase,r=C.minorBase,s=C.patchBase;let b=n.majorBase,p=n.minorBase,w=n.patchBase;const _=n.notBefore;let o=n.majorMustEqual,u=n.minorMustEqual,g=n.patchMustEqual;return n.isMinimum?a>b?!0:a<b?!1:r>p?!0:r<p||k&&k<_?!1:s>=w:(a===1&&b===0&&(!o||!u||!g)&&(b=1,p=0,w=0,o=!0,u=!1,g=!1),a<b?!1:a>b?!o:r<p?!1:r>p?!u:s<w?!1:s>w?!g:!(k&&k<_))}e.isValidVersion=D;function l(i,c,f,C,k){const n=[];if(typeof C.publisher<"u"&&typeof C.publisher!="string")return n.push([A.default.Error,I.localize(0,null)]),n;if(typeof C.name!="string")return n.push([A.default.Error,I.localize(1,null,"name")]),n;if(typeof C.version!="string")return n.push([A.default.Error,I.localize(2,null,"version")]),n;if(!C.engines)return n.push([A.default.Error,I.localize(3,null,"engines")]),n;if(typeof C.engines.vscode!="string")return n.push([A.default.Error,I.localize(4,null,"engines.vscode")]),n;if(typeof C.extensionDependencies<"u"&&!t(C.extensionDependencies))return n.push([A.default.Error,I.localize(5,null,"extensionDependencies")]),n;if(typeof C.activationEvents<"u"){if(!t(C.activationEvents))return n.push([A.default.Error,I.localize(6,null,"activationEvents")]),n;if(typeof C.main>"u"&&typeof C.browser>"u")return n.push([A.default.Error,I.localize(7,null,"activationEvents","main","browser")]),n}if(typeof C.extensionKind<"u"&&typeof C.main>"u"&&n.push([A.default.Warning,I.localize(8,null,"extensionKind")]),typeof C.main<"u"){if(typeof C.main!="string")return n.push([A.default.Error,I.localize(9,null,"main")]),n;{const s=(0,S.joinPath)(f,C.main);(0,S.isEqualOrParent)(s,f)||n.push([A.default.Warning,I.localize(10,null,s.path,f.path)])}}if(typeof C.browser<"u"){if(typeof C.browser!="string")return n.push([A.default.Error,I.localize(11,null,"browser")]),n;{const s=(0,S.joinPath)(f,C.browser);(0,S.isEqualOrParent)(s,f)||n.push([A.default.Warning,I.localize(12,null,s.path,f.path)])}}if(!L.valid(C.version))return n.push([A.default.Error,I.localize(13,null)]),n;const a=[];if(!E(i,c,C,k,a))for(const s of a)n.push([A.default.Error,s]);return n}e.validateExtensionManifest=l;function E(i,c,f,C,k){return C||typeof f.main>"u"&&typeof f.browser>"u"?!0:d(i,c,f.engines.vscode,k)}e.isValidExtensionVersion=E;function v(i,c,f){return i==="*"||d(c,f,i)}e.isEngineValid=v;function d(i,c,f,C=[]){const k=P(m(f));if(!k)return C.push(I.localize(14,null,f)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return C.push(I.localize(15,null,f)),!1}else if(!k.majorMustEqual)return C.push(I.localize(16,null,f)),!1;return D(i,c,k)?!0:(C.push(I.localize(17,null,i,f)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let c=0,f=i.length;c<f;c++)if(typeof i[c]!="string")return!1;return!0}}),define(Pe[70],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(I,L=[],T=!1){this.ctor=I,this.staticArguments=L,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=S}),define(Pe[71],Te([1,0,70]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var I;(function(h){h[h.Eager=0]="Eager",h[h.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function L(h,y,m){y instanceof S.SyncDescriptor||(y=new S.SyncDescriptor(y,[],!!m)),A.push([h,y])}e.registerSingleton=L;function T(){return A}e.getSingletonServiceDescriptors=T}),define(Pe[171],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(L,T){this.key=L,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=S;class A{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const T of this._nodes.values())T.outgoing.size===0&&L.push(T);return L}insertEdge(L,T){const h=this.lookupOrInsertNode(L),y=this.lookupOrInsertNode(T);h.outgoing.set(y.key,y),y.incoming.set(h.key,h)}removeNode(L){const T=this._hashFn(L);this._nodes.delete(T);for(const h of this._nodes.values())h.outgoing.delete(T),h.incoming.delete(T)}lookupOrInsertNode(L){const T=this._hashFn(L);let h=this._nodes.get(T);return h||(h=new S(T,L),this._nodes.set(T,h)),h}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[T,h]of this._nodes)L.push(`${T}
	(-> incoming)[${[...h.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...h.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,T]of this._nodes){const h=new Set([L]),y=this._findCycle(T,h);if(y)return y}}_findCycle(L,T){for(const[h,y]of L.outgoing){if(T.has(h))return[...T,h].join(" -> ");T.add(h);const m=this._findCycle(y,T);if(m)return m;T.delete(h)}}}e.Graph=A}),define(Pe[4],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function h(y){return y[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=h})(S||(e._util=S={})),e.IInstantiationService=I("instantiationService");function A(T,h,y){h[S.DI_TARGET]===h?h[S.DI_DEPENDENCIES].push({id:T,index:y}):(h[S.DI_DEPENDENCIES]=[{id:T,index:y}],h[S.DI_TARGET]=h)}function I(T){if(S.serviceIds.has(T))return S.serviceIds.get(T);const h=function(y,m,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(h,y,P)};return h.toString=()=>T,S.serviceIds.set(T,h),h}e.createDecorator=I;function L(T){return T}e.refineServiceDecorator=L}),define(Pe[43],Te([1,0,16,2,4]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function L(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof A.URI)}e.isConfigurationOverrides=L;function T(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=T;var h;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(h||(e.ConfigurationTarget=h={}));function y(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function m(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.isConfigured=m;function P(i,c){const f=Object.create(null);for(const C in i)D(f,C,i[C],c);return f}e.toValuesTree=P;function D(i,c,f,C){const k=c.split("."),n=k.pop();let a=i;for(let r=0;r<k.length;r++){const s=k[r];let b=a[s];switch(typeof b){case"undefined":b=a[s]=Object.create(null);break;case"object":break;default:C(`Ignoring ${c} as ${k.slice(0,r+1).join(".")} is ${JSON.stringify(b)}`);return}a=b}if(typeof a=="object"&&a!==null)try{a[n]=f}catch{C(`Ignoring ${c} as ${k.join(".")} is ${JSON.stringify(a)}`)}else C(`Ignoring ${c} as ${k.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=D;function l(i,c){const f=c.split(".");E(i,f)}e.removeFromValueTree=l;function E(i,c){const f=c.shift();if(c.length===0){delete i[f];return}if(Object.keys(i).indexOf(f)!==-1){const C=i[f];typeof C=="object"&&!Array.isArray(C)&&(E(C,c),Object.keys(C).length===0&&delete i[f])}}function v(i,c,f){function C(a,r){let s=a;for(const b of r){if(typeof s!="object"||s===null)return;s=s[b]}return s}const k=c.split("."),n=C(i,k);return typeof n>"u"?f:n}e.getConfigurationValue=v;function d(i,c,f){Object.keys(c).forEach(C=>{C!=="__proto__"&&(C in i?S.isObject(i[C])&&S.isObject(c[C])?d(i[C],c[C],f):f&&(i[C]=c[C]):i[C]=c[C])})}e.merge=d;function t(i){return i.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=t}),define(Pe[32],Te([1,0,22,15,169,4,139,9]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",S.isMacintosh),y.set("isLinux",S.isLinux),y.set("isWindows",S.isWindows),y.set("isWeb",S.isWeb),y.set("isMacNative",S.isMacintosh&&!S.isWeb),y.set("isEdge",S.isEdge),y.set("isFirefox",S.isFirefox),y.set("isChrome",S.isChrome),y.set("isSafari",S.isSafari);function m(le,N){if(y.get(le)!==void 0)throw(0,h.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(le,N)}e.setConstant=m;const P=Object.prototype.hasOwnProperty;var D;(function(le){le[le.False=0]="False",le[le.True=1]="True",le[le.Defined=2]="Defined",le[le.Not=3]="Not",le[le.Equals=4]="Equals",le[le.NotEquals=5]="NotEquals",le[le.And=6]="And",le[le.Regex=7]="Regex",le[le.NotRegex=8]="NotRegex",le[le.Or=9]="Or",le[le.In=10]="In",le[le.NotIn=11]="NotIn",le[le.Greater=12]="Greater",le[le.GreaterEquals=13]="GreaterEquals",le[le.Smaller=14]="Smaller",le[le.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const l={regexParsingWithErrorRecovery:!0},E=(0,T.localize)(0,null),v=(0,T.localize)(1,null),d=(0,T.localize)(2,null),t=(0,T.localize)(3,null),i=(0,T.localize)(4,null),c=(0,T.localize)(5,null),f=(0,T.localize)(6,null),C=(0,T.localize)(7,null);class k{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(N=l){this._config=N,this._scanner=new I.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(N){if(N===""){this._parsingErrors.push({message:E,offset:0,lexeme:"",additionalInfo:v});return}this._tokens=this._scanner.reset(N).scan(),this._current=0,this._parsingErrors=[];try{const q=this._expr();if(!this._isAtEnd()){const ue=this._peek(),Se=ue.type===17?c:void 0;throw this._parsingErrors.push({message:i,offset:ue.offset,lexeme:I.Scanner.getLexeme(ue),additionalInfo:Se}),k._parseError}return q}catch(q){if(q!==k._parseError)throw q;return}}_expr(){return this._or()}_or(){const N=[this._and()];for(;this._matchOne(16);){const q=this._and();N.push(q)}return N.length===1?N[0]:n.or(...N)}_and(){const N=[this._term()];for(;this._matchOne(15);){const q=this._term();N.push(q)}return N.length===1?N[0]:n.and(...N)}_term(){if(this._matchOne(2)){const N=this._peek();switch(N.type){case 11:return this._advance(),b.INSTANCE;case 12:return this._advance(),p.INSTANCE;case 0:{this._advance();const q=this._expr();return this._consume(1,t),q?.negate()}case 17:return this._advance(),O.create(N.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",N)}}return this._primary()}_primary(){const N=this._peek();switch(N.type){case 11:return this._advance(),n.true();case 12:return this._advance(),n.false();case 0:{this._advance();const q=this._expr();return this._consume(1,t),q}case 17:{const q=N.lexeme;if(this._advance(),this._matchOne(9)){const Se=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Se.type!==10)throw this._errExpectedButGot("REGEX",Se);const be=Se.lexeme,Ee=be.lastIndexOf("/"),ye=Ee===be.length-1?void 0:this._removeFlagsGY(be.substring(Ee+1));let oe;try{oe=new RegExp(be.substring(1,Ee),ye)}catch{throw this._errExpectedButGot("REGEX",Se)}return M.create(q,oe)}switch(Se.type){case 10:case 19:{const be=[Se.lexeme];this._advance();let Ee=this._peek(),ye=0;for(let me=0;me<Se.lexeme.length;me++)Se.lexeme.charCodeAt(me)===40?ye++:Se.lexeme.charCodeAt(me)===41&&ye--;for(;!this._isAtEnd()&&Ee.type!==15&&Ee.type!==16;){switch(Ee.type){case 0:ye++;break;case 1:ye--;break;case 10:case 18:for(let me=0;me<Ee.lexeme.length;me++)Ee.lexeme.charCodeAt(me)===40?ye++:Se.lexeme.charCodeAt(me)===41&&ye--}if(ye<0)break;be.push(I.Scanner.getLexeme(Ee)),this._advance(),Ee=this._peek()}const oe=be.join(""),de=oe.lastIndexOf("/"),re=de===oe.length-1?void 0:this._removeFlagsGY(oe.substring(de+1));let ie;try{ie=new RegExp(oe.substring(1,de),re)}catch{throw this._errExpectedButGot("REGEX",Se)}return n.regex(q,ie)}case 18:{const be=Se.lexeme;this._advance();let Ee=null;if(!(0,A.isFalsyOrWhitespace)(be)){const ye=be.indexOf("/"),oe=be.lastIndexOf("/");if(ye!==oe&&ye>=0){const de=be.slice(ye+1,oe),re=be[oe+1]==="i"?"i":"";try{Ee=new RegExp(de,re)}catch{throw this._errExpectedButGot("REGEX",Se)}}}if(Ee===null)throw this._errExpectedButGot("REGEX",Se);return M.create(q,Ee)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,d);const Se=this._value();return n.notIn(q,Se)}switch(this._peek().type){case 3:{this._advance();const Se=this._value();if(this._previous().type===18)return n.equals(q,Se);switch(Se){case"true":return n.has(q);case"false":return n.not(q);default:return n.equals(q,Se)}}case 4:{this._advance();const Se=this._value();if(this._previous().type===18)return n.notEquals(q,Se);switch(Se){case"true":return n.not(q);case"false":return n.has(q);default:return n.notEquals(q,Se)}}case 5:return this._advance(),$.create(q,this._value());case 6:return this._advance(),x.create(q,this._value());case 7:return this._advance(),H.create(q,this._value());case 8:return this._advance(),B.create(q,this._value());case 13:return this._advance(),n.in(q,this._value());default:return n.has(q)}}case 20:throw this._parsingErrors.push({message:f,offset:N.offset,lexeme:"",additionalInfo:C}),k._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const N=this._peek();switch(N.type){case 17:case 18:return this._advance(),N.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(N){return N.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(N){return this._check(N)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(N,q){if(this._check(N))return this._advance();throw this._errExpectedButGot(q,this._peek())}_errExpectedButGot(N,q,ue){const Se=(0,T.localize)(8,null,N,I.Scanner.getLexeme(q)),be=q.offset,Ee=I.Scanner.getLexeme(q);return this._parsingErrors.push({message:Se,offset:be,lexeme:Ee,additionalInfo:ue}),k._parseError}_check(N){return this._peek().type===N}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=k;class n{static false(){return b.INSTANCE}static true(){return p.INSTANCE}static has(N){return w.create(N)}static equals(N,q){return _.create(N,q)}static notEquals(N,q){return g.create(N,q)}static regex(N,q){return M.create(N,q)}static in(N,q){return o.create(N,q)}static notIn(N,q){return u.create(N,q)}static not(N){return O.create(N)}static and(...N){return we.create(N,null,!0)}static or(...N){return _e.create(N,null,!0)}static greater(N,q){return H.create(N,q)}static greaterEquals(N,q){return B.create(N,q)}static smaller(N,q){return $.create(N,q)}static smallerEquals(N,q){return x.create(N,q)}static{this._parser=new k({regexParsingWithErrorRecovery:!1})}static deserialize(N){return N==null?void 0:this._parser.parse(N)}}e.ContextKeyExpr=n;function a(le){const N=new k({regexParsingWithErrorRecovery:!1});return le.map(q=>(N.parse(q),N.lexingErrors.length>0?N.lexingErrors.map(ue=>({errorMessage:ue.additionalInfo?(0,T.localize)(9,null,ue.additionalInfo):(0,T.localize)(10,null),offset:ue.offset,length:ue.lexeme.length})):N.parsingErrors.length>0?N.parsingErrors.map(ue=>({errorMessage:ue.additionalInfo?`${ue.message}. ${ue.additionalInfo}`:ue.message,offset:ue.offset,length:ue.lexeme.length})):[]))}e.validateWhenClauses=a;function r(le,N){const q=le?le.substituteConstants():void 0,ue=N?N.substituteConstants():void 0;return!q&&!ue?!0:!q||!ue?!1:q.equals(ue)}e.expressionsAreEqualWithConstantSubstitution=r;function s(le,N){return le.cmp(N)}class b{static{this.INSTANCE=new b}constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=b;class p{static{this.INSTANCE=new p}constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=p;class w{static create(N,q=null){const ue=y.get(N);return typeof ue=="boolean"?ue?p.INSTANCE:b.INSTANCE:new w(N,q)}constructor(N,q){this.key=N,this.negated=q,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:Y(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=y.get(this.key);return typeof N=="boolean"?N?p.INSTANCE:b.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.negated||(this.negated=O.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=w;class _{static create(N,q,ue=null){if(typeof q=="boolean")return q?w.create(N,ue):O.create(N,ue);const Se=y.get(N);return typeof Se=="boolean"?q===(Se?"true":"false")?p.INSTANCE:b.INSTANCE:new _(N,q,ue)}constructor(N,q,ue){this.key=N,this.value=q,this.negated=ue,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:he(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){const N=y.get(this.key);if(typeof N=="boolean"){const q=N?"true":"false";return this.value===q?p.INSTANCE:b.INSTANCE}return this}evaluate(N){return N.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(N){return N.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=_;class o{static create(N,q){return new o(N,q)}constructor(N,q){this.key=N,this.valueKey=q,this.type=10,this.negated=null}cmp(N){return N.type!==this.type?this.type-N.type:he(this.key,this.valueKey,N.key,N.valueKey)}equals(N){return N.type===this.type?this.key===N.key&&this.valueKey===N.valueKey:!1}substituteConstants(){return this}evaluate(N){const q=N.getValue(this.valueKey),ue=N.getValue(this.key);return Array.isArray(q)?q.includes(ue):typeof ue=="string"&&typeof q=="object"&&q!==null?P.call(q,ue):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(N){return N.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=u.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=o;class u{static create(N,q){return new u(N,q)}constructor(N,q){this.key=N,this.valueKey=q,this.type=11,this._negated=o.create(N,q)}cmp(N){return N.type!==this.type?this.type-N.type:this._negated.cmp(N._negated)}equals(N){return N.type===this.type?this._negated.equals(N._negated):!1}substituteConstants(){return this}evaluate(N){return!this._negated.evaluate(N)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(N){return N.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=u;class g{static create(N,q,ue=null){if(typeof q=="boolean")return q?O.create(N,ue):w.create(N,ue);const Se=y.get(N);return typeof Se=="boolean"?q===(Se?"true":"false")?b.INSTANCE:p.INSTANCE:new g(N,q,ue)}constructor(N,q,ue){this.key=N,this.value=q,this.negated=ue,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:he(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){const N=y.get(this.key);if(typeof N=="boolean"){const q=N?"true":"false";return this.value===q?b.INSTANCE:p.INSTANCE}return this}evaluate(N){return N.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(N){return N.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class O{static create(N,q=null){const ue=y.get(N);return typeof ue=="boolean"?ue?b.INSTANCE:p.INSTANCE:new O(N,q)}constructor(N,q){this.key=N,this.negated=q,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:Y(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=y.get(this.key);return typeof N=="boolean"?N?b.INSTANCE:p.INSTANCE:this}evaluate(N){return!N.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(N){return N.mapNot(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=O;function z(le,N){if(typeof le=="string"){const q=parseFloat(le);isNaN(q)||(le=q)}return typeof le=="string"||typeof le=="number"?N(le):b.INSTANCE}class H{static create(N,q,ue=null){return z(q,Se=>new H(N,Se,ue))}constructor(N,q,ue){this.key=N,this.value=q,this.negated=ue,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:he(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(N){return N.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=H;class B{static create(N,q,ue=null){return z(q,Se=>new B(N,Se,ue))}constructor(N,q,ue){this.key=N,this.value=q,this.negated=ue,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:he(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(N){return N.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=B;class ${static create(N,q,ue=null){return z(q,Se=>new $(N,Se,ue))}constructor(N,q,ue){this.key=N,this.value=q,this.negated=ue,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:he(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(N){return N.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=$;class x{static create(N,q,ue=null){return z(q,Se=>new x(N,Se,ue))}constructor(N,q,ue){this.key=N,this.value=q,this.negated=ue,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:he(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(N){return N.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=x;class M{static create(N,q){return new M(N,q)}constructor(N,q){this.key=N,this.regexp=q,this.type=7,this.negated=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.key<N.key)return-1;if(this.key>N.key)return 1;const q=this.regexp?this.regexp.source:"",ue=N.regexp?N.regexp.source:"";return q<ue?-1:q>ue?1:0}equals(N){if(N.type===this.type){const q=this.regexp?this.regexp.source:"",ue=N.regexp?N.regexp.source:"";return this.key===N.key&&q===ue}return!1}substituteConstants(){return this}evaluate(N){const q=N.getValue(this.key);return this.regexp?this.regexp.test(q):!1}serialize(){const N=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${N}`}keys(){return[this.key]}map(N){return N.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ne.create(this)),this.negated}}e.ContextKeyRegexExpr=M;class ne{static create(N){return new ne(N)}constructor(N){this._actual=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this._actual.cmp(N._actual)}equals(N){return N.type===this.type?this._actual.equals(N._actual):!1}substituteConstants(){return this}evaluate(N){return!this._actual.evaluate(N)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(N){return new ne(this._actual.map(N))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ne;function Q(le){let N=null;for(let q=0,ue=le.length;q<ue;q++){const Se=le[q].substituteConstants();if(le[q]!==Se&&N===null){N=[];for(let be=0;be<q;be++)N[be]=le[be]}N!==null&&(N[q]=Se)}return N===null?le:N}class we{static create(N,q,ue){return we._normalizeArr(N,q,ue)}constructor(N,q){this.expr=N,this.negated=q,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let q=0,ue=this.expr.length;q<ue;q++){const Se=s(this.expr[q],N.expr[q]);if(Se!==0)return Se}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].equals(N.expr[q]))return!1;return!0}return!1}substituteConstants(){const N=Q(this.expr);return N===this.expr?this:we.create(N,this.negated,!1)}evaluate(N){for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].evaluate(N))return!1;return!0}static _normalizeArr(N,q,ue){const Se=[];let be=!1;for(const Ee of N)if(Ee){if(Ee.type===1){be=!0;continue}if(Ee.type===0)return b.INSTANCE;if(Ee.type===6){Se.push(...Ee.expr);continue}Se.push(Ee)}if(Se.length===0&&be)return p.INSTANCE;if(Se.length!==0){if(Se.length===1)return Se[0];Se.sort(s);for(let Ee=1;Ee<Se.length;Ee++)Se[Ee-1].equals(Se[Ee])&&(Se.splice(Ee,1),Ee--);if(Se.length===1)return Se[0];for(;Se.length>1;){const Ee=Se[Se.length-1];if(Ee.type!==9)break;Se.pop();const ye=Se.pop(),oe=Se.length===0,de=_e.create(Ee.expr.map(re=>we.create([re,ye],null,ue)),null,oe);de&&(Se.push(de),Se.sort(s))}if(Se.length===1)return Se[0];if(ue){for(let Ee=0;Ee<Se.length;Ee++)for(let ye=Ee+1;ye<Se.length;ye++)if(Se[Ee].negate().equals(Se[ye]))return b.INSTANCE;if(Se.length===1)return Se[0]}return new we(Se,q)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const q of this.expr)N.push(...q.keys());return N}map(N){return new we(this.expr.map(q=>q.map(N)),null)}negate(){if(!this.negated){const N=[];for(const q of this.expr)N.push(q.negate());this.negated=_e.create(N,this,!0)}return this.negated}}e.ContextKeyAndExpr=we;class _e{static create(N,q,ue){return _e._normalizeArr(N,q,ue)}constructor(N,q){this.expr=N,this.negated=q,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let q=0,ue=this.expr.length;q<ue;q++){const Se=s(this.expr[q],N.expr[q]);if(Se!==0)return Se}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].equals(N.expr[q]))return!1;return!0}return!1}substituteConstants(){const N=Q(this.expr);return N===this.expr?this:_e.create(N,this.negated,!1)}evaluate(N){for(let q=0,ue=this.expr.length;q<ue;q++)if(this.expr[q].evaluate(N))return!0;return!1}static _normalizeArr(N,q,ue){let Se=[],be=!1;if(N){for(let Ee=0,ye=N.length;Ee<ye;Ee++){const oe=N[Ee];if(oe){if(oe.type===0){be=!0;continue}if(oe.type===1)return p.INSTANCE;if(oe.type===9){Se=Se.concat(oe.expr);continue}Se.push(oe)}}if(Se.length===0&&be)return b.INSTANCE;Se.sort(s)}if(Se.length!==0){if(Se.length===1)return Se[0];for(let Ee=1;Ee<Se.length;Ee++)Se[Ee-1].equals(Se[Ee])&&(Se.splice(Ee,1),Ee--);if(Se.length===1)return Se[0];if(ue){for(let Ee=0;Ee<Se.length;Ee++)for(let ye=Ee+1;ye<Se.length;ye++)if(Se[Ee].negate().equals(Se[ye]))return p.INSTANCE;if(Se.length===1)return Se[0]}return new _e(Se,q)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const q of this.expr)N.push(...q.keys());return N}map(N){return new _e(this.expr.map(q=>q.map(N)),null)}negate(){if(!this.negated){const N=[];for(const q of this.expr)N.push(q.negate());for(;N.length>1;){const q=N.shift(),ue=N.shift(),Se=[];for(const be of J(q))for(const Ee of J(ue))Se.push(we.create([be,Ee],null,!1));N.unshift(_e.create(Se,null,!1))}this.negated=_e.create(N,this,!0)}return this.negated}}e.ContextKeyOrExpr=_e;class Ae extends w{static{this._info=[]}static all(){return Ae._info.values()}constructor(N,q,ue){super(N,null),this._defaultValue=q,typeof ue=="object"?Ae._info.push({...ue,key:N}):ue!==!0&&Ae._info.push({key:N,description:ue,type:q!=null?typeof q:void 0})}bindTo(N){return N.createKey(this.key,this._defaultValue)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return _.create(this.key,N)}notEqualsTo(N){return g.create(this.key,N)}}e.RawContextKey=Ae,e.IContextKeyService=(0,L.createDecorator)("contextKeyService");function Y(le,N){return le<N?-1:le>N?1:0}function he(le,N,q,ue){return le<q?-1:le>q?1:N<ue?-1:N>ue?1:0}function ke(le,N){if(le.type===0||N.type===1)return!0;if(le.type===9)return N.type===9?ae(le.expr,N.expr):!1;if(N.type===9){for(const q of N.expr)if(ke(le,q))return!0;return!1}if(le.type===6){if(N.type===6)return ae(N.expr,le.expr);for(const q of le.expr)if(ke(q,N))return!0;return!1}return le.equals(N)}e.implies=ke;function ae(le,N){let q=0,ue=0;for(;q<le.length&&ue<N.length;){const Se=le[q].cmp(N[ue]);if(Se<0)return!1;Se===0&&q++,ue++}return q===le.length}function J(le){return le.type===9?le.expr:[le]}}),define(Pe[172],Te([1,0,4]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(Pe[92],Te([1,0,141,4]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function I(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function L(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function T(c,f){switch(c){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":f==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function h(c,f){return f==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=h;function y(c,f,C){return h(f,C)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===C?!0:m(C).includes(c)}e.isTargetPlatformCompatible=y;function m(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=P;var D;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var l;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var E;(function(c){c.Install="install",c.Uninstall="uninstall"})(E||(e.StatisticType=E={}));var v;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var d;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(f,C){super(f),this.code=C,this.name=C}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,S.localize)(1,null),original:"Preferences"}}),define(Pe[38],Te([1,0,48,19,15,16,2,143,4,22,12]),function(ve,e,S,A,I,L,T,h,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function D(Y){return Y.create===!0}e.isFileOpenForWriteOptions=D;var l;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var E;(function(Y){Y[Y.Readonly=1]="Readonly",Y[Y.Locked=2]="Locked"})(E||(e.FilePermission=E={}));var v;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileAtomicWrite=32768]="FileAtomicWrite",Y[Y.FileAtomicDelete=65536]="FileAtomicDelete",Y[Y.FileClone=131072]="FileClone"})(v||(e.FileSystemProviderCapabilities=v={}));function d(Y){return!!(Y.capabilities&2)}e.hasReadWriteCapability=d;function t(Y){return!!(Y.capabilities&8)}e.hasFileFolderCopyCapability=t;function i(Y){return!!(Y.capabilities&131072)}e.hasFileCloneCapability=i;function c(Y){return!!(Y.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function f(Y){return!!(Y.capabilities&16)}e.hasFileReadStreamCapability=f;function C(Y){return d(Y)?!!(Y.capabilities&16384):!1}e.hasFileAtomicReadCapability=C;function k(Y){return d(Y)?!!(Y.capabilities&32768):!1}e.hasFileAtomicWriteCapability=k;function n(Y){return!!(Y.capabilities&65536)}e.hasFileAtomicDeleteCapability=n;function a(Y){return!!(Y.capabilities&2048)}e.hasReadonlyCapability=a;var r;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsStorageQuota="EntryExceedsStorageQuota",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class s extends Error{static create(he,ke){const ae=new s(he.toString(),ke);return w(ae,ke),ae}constructor(he,ke){super(he),this.code=ke}}e.FileSystemProviderError=s;function b(Y,he){return s.create(Y,he)}e.createFileSystemProviderError=b;function p(Y){return Y||b((0,h.localize)(0,null),r.Unknown)}e.ensureFileSystemProviderError=p;function w(Y,he){return Y.name=he?`${he} (FileSystemError)`:"FileSystemError",Y}e.markAsFileSystemProviderError=w;function _(Y){if(!Y)return r.Unknown;if(Y instanceof s)return Y.code;const he=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!he)return r.Unknown;switch(he[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.toFileSystemProviderErrorCode=_;function o(Y){if(Y instanceof B)return Y.fileOperationResult;switch(_(Y)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=o;var u;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(u||(e.FileOperation=u={}));class g{constructor(he,ke,ae){this.resource=he,this.operation=ke,this.target=ae}isOperation(he){return this.operation===he}}e.FileOperationEvent=g;var O;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class z{constructor(he,ke){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ae=new Map;for(const J of he){const le=ae.get(J.type);switch(le?le.push([J.resource,J]):ae.set(J.type,[[J.resource,J]]),J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}}for(const[J,le]of ae)switch(J){case 1:this.added=S.TernarySearchTree.forUris(()=>ke),this.added.fill(le);break;case 0:this.updated=S.TernarySearchTree.forUris(()=>ke),this.updated.fill(le);break;case 2:this.deleted=S.TernarySearchTree.forUris(()=>ke),this.deleted.fill(le);break}}contains(he,...ke){return this.doContains(he,{includeChildren:!1},...ke)}affects(he,...ke){return this.doContains(he,{includeChildren:!0},...ke)}doContains(he,ke,...ae){if(!he)return!1;const J=ae.length>0;return!!((!J||ae.includes(1))&&(this.added?.get(he)||ke.includeChildren&&this.added?.findSuperstr(he))||(!J||ae.includes(0))&&(this.updated?.get(he)||ke.includeChildren&&this.updated?.findSuperstr(he))||(!J||ae.includes(2))&&(this.deleted?.findSubstr(he)||ke.includeChildren&&this.deleted?.findSuperstr(he)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=z;function H(Y,he,ke){return!Y||!he||Y===he||he.length>Y.length?!1:(he.charAt(he.length-1)!==A.sep&&(he+=A.sep),ke?(0,I.startsWithIgnoreCase)(Y,he):Y.indexOf(he)===0)}e.isParent=H;class B extends Error{constructor(he,ke,ae){super(he),this.fileOperationResult=ke,this.options=ae}}e.FileOperationError=B;class $ extends B{constructor(he,ke,ae,J){super(he,ke,J),this.fileOperationResult=ke,this.size=ae}}e.TooLargeFileOperationError=$;class x extends B{constructor(he,ke,ae){super(he,2,ae),this.stat=ke}}e.NotModifiedSinceFileOperationError=x;var M;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(M||(e.FileOperationResult=M={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ne;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne||(e.FileKind=ne={})),e.ETAG_DISABLED="";function Q(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}e.etag=Q;async function we(Y,he){if(!he.hasProvider(T.URI.from({scheme:Y.scheme})))return new Promise(ke=>{const ae=he.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===Y.scheme&&J.added&&(ae.dispose(),ke())})})}e.whenProviderRegistered=we;class _e{static{this.KB=1024}static{this.MB=_e.KB*_e.KB}static{this.GB=_e.MB*_e.KB}static{this.TB=_e.GB*_e.KB}static formatSize(he){return(0,L.isNumber)(he)||(he=0),he<_e.KB?(0,h.localize)(1,null,he.toFixed(0)):he<_e.MB?(0,h.localize)(2,null,(he/_e.KB).toFixed(2)):he<_e.GB?(0,h.localize)(3,null,(he/_e.MB).toFixed(2)):he<_e.TB?(0,h.localize)(4,null,(he/_e.GB).toFixed(2)):(0,h.localize)(5,null,(he/_e.TB).toFixed(2))}}e.ByteSize=_e;function Ae(Y){const he=typeof Y=="string"||Y?.scheme===P.Schemas.vscodeRemote;return typeof Y!="string"&&Y?.scheme===P.Schemas.file?1024*_e.MB:he?10*_e.MB:m.isWeb?50*_e.MB:1024*_e.MB}e.getLargeFileConfirmationLimit=Ae}),define(Pe[72],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...I){this._entries=new Map;for(const[L,T]of I)this.set(L,T)}set(I,L){const T=this._entries.get(I);return this._entries.set(I,L),T}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=S}),define(Pe[173],Te([1,0,13,9,6,70,171,4,72,174]),function(ve,e,S,A,I,L,T,h,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class l{constructor(t=new y.ServiceCollection,i=!1,c,f=P){this._services=t,this._strict=i,this._parent=c,this._enableTracing=f,this._activeInstantiations=new Set,this._services.set(h.IInstantiationService,this),this._globalGraph=f?c?._globalGraph??new T.Graph(C=>C):void 0}createChild(t){return new l(t,this._strict,this,this._enableTracing)}invokeFunction(t,...i){const c=v.traceInvocation(this._enableTracing,t);let f=!1;try{return t({get:k=>{if(f)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(k,c);if(!n)throw new Error(`[invokeFunction] unknown service '${k}'`);return n}},...i)}finally{f=!0,c.stop()}}createInstance(t,...i){let c,f;return t instanceof L.SyncDescriptor?(c=v.traceCreation(this._enableTracing,t.ctor),f=this._createInstance(t.ctor,t.staticArguments.concat(i),c)):(c=v.traceCreation(this._enableTracing,t),f=this._createInstance(t,i,c)),c.stop(),f}_createInstance(t,i=[],c){const f=h._util.getServiceDependencies(t).sort((n,a)=>n.index-a.index),C=[];for(const n of f){const a=this._getOrCreateServiceInstance(n.id,c);a||this._throwIfStrict(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),C.push(a)}const k=f.length>0?f[0].index:i.length;if(i.length!==k){console.trace(`[createInstance] First service dependency of ${t.name} at position ${k+1} conflicts with ${i.length} static arguments`);const n=k-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,k)}return Reflect.construct(t,i.concat(C))}_setServiceInstance(t,i){if(this._services.get(t)instanceof L.SyncDescriptor)this._services.set(t,i);else if(this._parent)this._parent._setServiceInstance(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){const i=this._services.get(t);return!i&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):i}_getOrCreateServiceInstance(t,i){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(t));const c=this._getServiceInstanceOrDescriptor(t);return c instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,c,i.branch(t,!0)):(i.branch(t,!1),c)}_safeCreateAndCacheServiceInstance(t,i,c){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,i,c)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,i,c){const f=new T.Graph(n=>n.id.toString());let C=0;const k=[{id:t,desc:i,_trace:c}];for(;k.length;){const n=k.pop();if(f.lookupOrInsertNode(n),C++>1e3)throw new D(f);for(const a of h._util.getServiceDependencies(n.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(a.id);if(r||this._throwIfStrict(`[createInstance] ${t} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(a.id)),r instanceof L.SyncDescriptor){const s={id:a.id,desc:r,_trace:n._trace.branch(a.id,!0)};f.insertEdge(n,s),k.push(s)}}}for(;;){const n=f.roots();if(n.length===0){if(!f.isEmpty())throw new D(f);break}for(const{data:a}of n){if(this._getServiceInstanceOrDescriptor(a.id)instanceof L.SyncDescriptor){const s=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,s)}f.removeNode(a)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,i,c=[],f,C){if(this._services.get(t)instanceof L.SyncDescriptor)return this._createServiceInstance(t,i,c,f,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,i,c,f,C);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}_createServiceInstance(t,i,c=[],f,C){if(f){const k=new l(void 0,this._strict,this,this._enableTracing);k._globalGraphImplicitDependency=String(t);const n=new Map,a=new S.IdleValue(()=>{const r=k._createInstance(i,c,C);for(const[s,b]of n){const p=r[s];if(typeof p=="function")for(const w of b)p.apply(r,w)}return n.clear(),r});return new Proxy(Object.create(null),{get(r,s){if(!a.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let w=n.get(s);return w||(w=new m.LinkedList,n.set(s,w)),(o,u,g)=>{const O=w.push([o,u,g]);return(0,I.toDisposable)(O)}}if(s in r)return r[s];const b=a.value;let p=b[s];return typeof p!="function"||(p=p.bind(b),r[s]=p),p},set(r,s,b){return a.value[s]=b,!0},getPrototypeOf(r){return i.prototype}})}else return this._createInstance(i,c,C)}_throwIfStrict(t,i){if(i&&console.warn(t),this._strict)throw new Error(t)}}e.InstantiationService=l;var E;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(E||(E={}));class v{static{this.all=new Set}static{this._None=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new v(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v._None}static traceCreation(t,i){return t?new v(1,i.name):v._None}static{this._totals=0}constructor(t,i){this.type=t,this.name=i,this._start=Date.now(),this._dep=[]}branch(t,i){const c=new v(3,t.toString());return this._dep.push([t,i,c]),c}stop(){const t=Date.now()-this._start;v._totals+=t;let i=!1;function c(C,k){const n=[],a=new Array(C+1).join("	");for(const[r,s,b]of k._dep)if(s&&b){i=!0,n.push(`${a}CREATES -> ${r}`);const p=c(C+1,b);p&&n.push(p)}else n.push(`${a}uses -> ${r}`);return n.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(t>2||i)&&v.all.add(f.join(`
`))}}e.Trace=v}),define(Pe[14],Te([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,l.createDecorator)("logService"),e.ILoggerService=(0,l.createDecorator)("loggerService");function E(){return new Date().toISOString()}function v(o){return(0,m.isNumber)(o)}e.isLogLevel=v;var d;(function(o){o[o.Off=0]="Off",o[o.Trace=1]="Trace",o[o.Debug=2]="Debug",o[o.Info=3]="Info",o[o.Warning=4]="Warning",o[o.Error=5]="Error"})(d||(e.LogLevel=d={})),e.DEFAULT_LOG_LEVEL=d.Info;function t(o,u,g){switch(u){case d.Trace:o.trace(g);break;case d.Debug:o.debug(g);break;case d.Info:o.info(g);break;case d.Warning:o.warn(g);break;case d.Error:o.error(g);break;case d.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=t;function i(o,u=!1){let g="";for(let O=0;O<o.length;O++){let z=o[O];if(z instanceof Error&&(z=(0,S.toErrorMessage)(z,u)),typeof z=="object")try{z=JSON.stringify(z)}catch{}g+=(O>0?" ":"")+z}return g}class c extends L.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(u){this.level!==u&&(this.level=u,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(u){return this.level!==d.Off&&this.level<=u}}e.AbstractLogger=c;class f extends c{constructor(u){super(),this.logAlways=u}checkLogLevel(u){return this.logAlways||super.checkLogLevel(u)}trace(u,...g){this.checkLogLevel(d.Trace)&&this.log(d.Trace,i([u,...g],!0))}debug(u,...g){this.checkLogLevel(d.Debug)&&this.log(d.Debug,i([u,...g]))}info(u,...g){this.checkLogLevel(d.Info)&&this.log(d.Info,i([u,...g]))}warn(u,...g){this.checkLogLevel(d.Warning)&&this.log(d.Warning,i([u,...g]))}error(u,...g){if(this.checkLogLevel(d.Error))if(u instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=u.stack,this.log(d.Error,i(O))}else this.log(d.Error,i([u,...g]))}flush(){}}e.AbstractMessageLogger=f;class C extends c{constructor(u=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(u),this.useColors=!h.isWindows}trace(u,...g){this.checkLogLevel(d.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,u,...g):console.log(`[main ${E()}]`,u,...g))}debug(u,...g){this.checkLogLevel(d.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,u,...g):console.log(`[main ${E()}]`,u,...g))}info(u,...g){this.checkLogLevel(d.Info)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,u,...g):console.log(`[main ${E()}]`,u,...g))}warn(u,...g){this.checkLogLevel(d.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,u,...g):console.warn(`[main ${E()}]`,u,...g))}error(u,...g){this.checkLogLevel(d.Error)&&(this.useColors?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,u,...g):console.error(`[main ${E()}]`,u,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class k extends c{constructor(u=e.DEFAULT_LOG_LEVEL,g=!0){super(),this.useColors=g,this.setLevel(u)}trace(u,...g){this.checkLogLevel(d.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",u,...g):console.log(u,...g))}debug(u,...g){this.checkLogLevel(d.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",u,...g):console.log(u,...g))}info(u,...g){this.checkLogLevel(d.Info)&&(this.useColors?console.log("%c INFO","color: #33f",u,...g):console.log(u,...g))}warn(u,...g){this.checkLogLevel(d.Warning)&&(this.useColors?console.log("%c WARN","color: #993",u,...g):console.log(u,...g))}error(u,...g){this.checkLogLevel(d.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",u,...g):console.error(u,...g))}dispose(){}flush(){}}e.ConsoleLogger=k;class n extends c{constructor(u,g=e.DEFAULT_LOG_LEVEL){super(),this.adapter=u,this.setLevel(g)}trace(u,...g){this.checkLogLevel(d.Trace)&&this.adapter.log(d.Trace,[this.extractMessage(u),...g])}debug(u,...g){this.checkLogLevel(d.Debug)&&this.adapter.log(d.Debug,[this.extractMessage(u),...g])}info(u,...g){this.checkLogLevel(d.Info)&&this.adapter.log(d.Info,[this.extractMessage(u),...g])}warn(u,...g){this.checkLogLevel(d.Warning)&&this.adapter.log(d.Warning,[this.extractMessage(u),...g])}error(u,...g){this.checkLogLevel(d.Error)&&this.adapter.log(d.Error,[this.extractMessage(u),...g])}extractMessage(u){return typeof u=="string"?u:(0,S.toErrorMessage)(u,this.checkLogLevel(d.Trace))}dispose(){}flush(){}}e.AdapterLogger=n;class a extends c{constructor(u){super(),this.loggers=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const g of this.loggers)g.setLevel(u);super.setLevel(u)}trace(u,...g){for(const O of this.loggers)O.trace(u,...g)}debug(u,...g){for(const O of this.loggers)O.debug(u,...g)}info(u,...g){for(const O of this.loggers)O.info(u,...g)}warn(u,...g){for(const O of this.loggers)O.warn(u,...g)}error(u,...g){for(const O of this.loggers)O.error(u,...g)}flush(){for(const u of this.loggers)u.flush()}dispose(){for(const u of this.loggers)u.dispose()}}e.MultiplexLogger=a;class r extends L.Disposable{constructor(u,g,O){if(super(),this.logLevel=u,this.logsHome=g,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new A.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,O)for(const z of O)this._loggers.set(z.resource,{logger:void 0,info:z})}getLoggerEntry(u){return(0,m.isString)(u)?[...this._loggers.values()].find(g=>g.info.id===u):this._loggers.get(u)}getLogger(u){return this.getLoggerEntry(u)?.logger}createLogger(u,g){const O=this.toResource(u),z=(0,m.isString)(u)?u:g?.id??(0,I.hash)(O.toString()).toString(16);let H=this._loggers.get(O)?.logger;const B=g?.logLevel==="always"?d.Trace:g?.logLevel;H||(H=this.doCreateLogger(O,B??this.getLogLevel(O)??this.logLevel,{...g,id:z}));const $={logger:H,info:{resource:O,id:z,logLevel:B,name:g?.name,hidden:g?.hidden,extensionId:g?.extensionId,when:g?.when}};return this.registerLogger($.info),this._loggers.set(O,$),H}toResource(u){return(0,m.isString)(u)?(0,y.joinPath)(this.logsHome,`${u}.log`):u}setLogLevel(u,g){if(P.URI.isUri(u)){const O=u,z=g,H=this._loggers.get(O);H&&z!==H.info.logLevel&&(H.info.logLevel=z===this.logLevel?void 0:z,H.logger?.setLevel(z),this._loggers.set(H.info.resource,H),this._onDidChangeLogLevel.fire([O,z]))}else{this.logLevel=u;for(const[O,z]of this._loggers.entries())this._loggers.get(O)?.info.logLevel===void 0&&z.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(u,g){const O=this.getLoggerEntry(u);O&&g!==!O.info.hidden&&(O.info.hidden=!g,this._loggers.set(O.info.resource,O),this._onDidChangeVisibility.fire([O.info.resource,g]))}getLogLevel(u){let g;return u&&(g=this._loggers.get(u)?.info.logLevel),g??this.logLevel}registerLogger(u){const g=this._loggers.get(u.resource);g?g.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this._loggers.set(u.resource,{info:u,logger:void 0}),this._onDidChangeLoggers.fire({added:[u],removed:[]}))}deregisterLogger(u){const g=this._loggers.get(u);g&&(g.logger&&g.logger.dispose(),this._loggers.delete(u),this._onDidChangeLoggers.fire({added:[],removed:[g.info]}))}*getRegisteredLoggers(){for(const u of this._loggers.values())yield u.info}getRegisteredLogger(u){return this._loggers.get(u)?.info}dispose(){this._loggers.forEach(u=>u.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=r;class s{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(u){}getLevel(){return d.Info}trace(u,...g){}debug(u,...g){}info(u,...g){}warn(u,...g){}error(u,...g){}critical(u,...g){}dispose(){}flush(){}}e.NullLogger=s;class b extends s{}e.NullLogService=b;function p(o){if(o.verbose)return d.Trace;if(typeof o.logLevel=="string"){const u=_(o.logLevel.toLowerCase());if(u!==void 0)return u}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function w(o){switch(o){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.LogLevelToString=w;function _(o){switch(o){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.parseLogLevel=_,e.CONTEXT_LOG_LEVEL=new D.RawContextKey("logLevel",w(d.Info))}),define(Pe[175],Te([1,0,6,14]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class I extends S.Disposable{constructor(T,h=[]){super(),this.logger=new A.MultiplexLogger([T,...h]),this._register(T.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...h){this.logger.trace(T,...h)}debug(T,...h){this.logger.debug(T,...h)}info(T,...h){this.logger.info(T,...h)}warn(T,...h){this.logger.warn(T,...h)}error(T,...h){this.logger.error(T,...h)}flush(){this.logger.flush()}}e.LogService=I}),define(Pe[94],Te([1,0,29,144,4]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var T;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(y){function m(v,d){return d-v}y.compare=m;const P=Object.create(null);P[y.Error]=(0,A.localize)(0,null),P[y.Warning]=(0,A.localize)(1,null),P[y.Info]=(0,A.localize)(2,null);function D(v){return P[v]||""}y.toString=D;function l(v){switch(v){case S.default.Error:return y.Error;case S.default.Warning:return y.Warning;case S.default.Info:return y.Info;case S.default.Ignore:return y.Hint}}y.fromSeverity=l;function E(v){switch(v){case y.Error:return S.default.Error;case y.Warning:return S.default.Warning;case y.Info:return S.default.Info;case y.Hint:return S.default.Ignore}}y.toSeverity=E}(T||(e.MarkerSeverity=T={}));var h;(function(y){const m="";function P(l){return D(l,!0)}y.makeKey=P;function D(l,E){const v=[m];return l.source?v.push(l.source.replace("\xA6","\\\xA6")):v.push(m),l.code?typeof l.code=="string"?v.push(l.code.replace("\xA6","\\\xA6")):v.push(l.code.value.replace("\xA6","\\\xA6")):v.push(m),l.severity!==void 0&&l.severity!==null?v.push(T.toString(l.severity)):v.push(m),l.message&&E?v.push(l.message.replace("\xA6","\\\xA6")):v.push(m),l.startLineNumber!==void 0&&l.startLineNumber!==null?v.push(l.startLineNumber.toString()):v.push(m),l.startColumn!==void 0&&l.startColumn!==null?v.push(l.startColumn.toString()):v.push(m),l.endLineNumber!==void 0&&l.endLineNumber!==null?v.push(l.endLineNumber.toString()):v.push(m),l.endColumn!==void 0&&l.endColumn!==null?v.push(l.endColumn.toString()):v.push(m),v.push(m),v.join("\xA6")}y.makeKeyOptionalMessage=D})(h||(e.IMarkerData=h={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(Pe[176],Te([1,0,5,29,4]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,I.createDecorator)("notificationService");var L;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var T;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));var h;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(h||(e.NotificationsFilter=h={}));class y{constructor(){this.progress=new m,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.NoOpNotification=y;class m{infinite(){}done(){}total(D){}worked(D){}}e.NoOpProgress=m}),define(Pe[95],Te([1,0,15,2,4]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,I.createDecorator)("openerService");function L(m,P){return A.URI.isUri(m)?(0,S.equalsIgnoreCase)(m.scheme,P):(0,S.startsWithIgnoreCase)(m,P+":")}e.matchesScheme=L;function T(m,...P){return P.some(D=>L(m,D))}e.matchesSomeScheme=T;function h(m,P){return m.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.withSelection=h;function y(m){let P;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(m.fragment);return D&&(P={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},m=m.with({fragment:""})),{selection:P,uri:m}}e.extractSelection=y}),define(Pe[177],Te([1,0,4]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ve=this&&this.__decorate||function(ve,e,S,A){var I=arguments.length,L=I<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,S):A,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ve,e,S,A);else for(var h=ve.length-1;h>=0;h--)(T=ve[h])&&(L=(I<3?T(L):I>3?T(e,S,L):T(e,S))||L);return I>3&&L&&Object.defineProperty(e,S,L),L},ze=this&&this.__param||function(ve,e){return function(S,A){e(S,A,ve)}};define(Pe[73],Te([1,0,13,21,6,4]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var T;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class h{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(D,l){this.callback=D,this.report=l?.async?this._reportAsync.bind(this):this._reportSync.bind(this)}_reportSync(D){this._value=D,this.callback(this._value)}_reportAsync(D){Promise.resolve(this._lastTask).finally(()=>{this._value=D;const l=this.callback(this._value);this._lastTask=Promise.resolve(l).finally(()=>this._lastTask=void 0)})}}e.Progress=h;let y=class extends I.Disposable{constructor(D,l){super(),this.deferred=new S.DeferredPromise,l.withProgress(D,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(D){this.reporter?this.reporter.report(D):this.lastStep=D}};e.UnmanagedProgress=y,e.UnmanagedProgress=y=Ve([ze(1,e.IProgressService)],y);class m extends I.Disposable{constructor(D){super(),this.progressIndicator=D,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(D){this.stop();const l=++this.currentOperationId,E=new A.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},D),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:E.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(D){this.currentOperationId===D&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=m,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(Pe[30],Te([1,0,50,16]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(T,h){S.ok(A.isString(T)),S.ok(A.isObject(h)),S.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,h)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new I}),define(Pe[74],Te([1,0,5,30]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(h){return h.length>0&&h.charAt(h.length-1)==="#"?h.substring(0,h.length-1):h}class L{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,m){this.schemasById[I(y)]=m,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new L;A.Registry.add(e.Extensions.JSONContribution,T)}),define(Pe[96],Te([1,0,18,5,16,138,43,74,30]),function(ve,e,S,A,I,L,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=y.Registry.as(h.Extensions.JSONContribution);class l{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,a=!0){this.registerConfigurations([n],a)}registerConfigurations(n,a=!0){const r=new Set;this.doRegisterConfigurations(n,a,r),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(n){const a=new Set;this.doDeregisterConfigurations(n,a),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:n,remove:a}){const r=new Set;this.doDeregisterConfigurations(a,r),this.doRegisterConfigurations(n,!1,r),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(n){const a=new Set;this.doRegisterDefaultConfigurations(n,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doRegisterDefaultConfigurations(n,a){const r=[];for(const{overrides:s,source:b}of n)for(const p in s)if(a.add(p),e.OVERRIDE_PROPERTY_REGEX.test(p)){const w=this.configurationDefaultsOverrides.get(p),_=w?.valuesSources??new Map;if(b)for(const O of Object.keys(s[p]))_.set(O,b);const o={...w?.value||{},...s[p]};this.configurationDefaultsOverrides.set(p,{source:b,value:o,valuesSources:_});const u=(0,T.getLanguageTagSettingPlainKey)(p),g={type:"object",default:o,description:L.localize(1,null,u),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:I.isString(b)?void 0:b,defaultValueSource:b};r.push(...d(p)),this.configurationProperties[p]=g,this.defaultLanguageConfigurationOverridesNode.properties[p]=g}else{this.configurationDefaultsOverrides.set(p,{value:s[p],source:b});const w=this.configurationProperties[p];w&&(this.updatePropertyDefaultValue(p,w),this.updateSchema(p,w))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(n){const a=new Set;this.doDeregisterDefaultConfigurations(n,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(n,a){for(const{overrides:r,source:s}of n)for(const b in r){const p=this.configurationDefaultsOverrides.get(b),w=I.isString(s)?s:s?.id,_=I.isString(p?.source)?p?.source:p?.source?.id;if(w===_)if(a.add(b),this.configurationDefaultsOverrides.delete(b),e.OVERRIDE_PROPERTY_REGEX.test(b))delete this.configurationProperties[b],delete this.defaultLanguageConfigurationOverridesNode.properties[b];else{const o=this.configurationProperties[b];o&&(this.updatePropertyDefaultValue(b,o),this.updateSchema(b,o))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(n){let a=!1;const r=new Set;n.removedDefaults&&(this.doDeregisterDefaultConfigurations(n.removedDefaults,r),a=!0),n.addedDefaults&&(this.doRegisterDefaultConfigurations(n.addedDefaults,r),a=!0),n.removedConfigurations&&this.doDeregisterConfigurations(n.removedConfigurations,r),n.addedConfigurations&&this.doRegisterConfigurations(n.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){this.doRegisterOverrideIdentifiers(n),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(n){for(const a of n)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,a,r){n.forEach(s=>{this.validateAndRegisterProperties(s,a,s.extensionInfo,s.restrictedProperties,void 0,r),this.configurationContributors.push(s),this.registerJSONConfiguration(s)})}doDeregisterConfigurations(n,a){const r=s=>{if(s.properties)for(const b in s.properties){a.add(b);const p=this.configurationProperties[b];p?.policy?.name&&this.policyConfigurations.delete(p.policy.name),delete this.configurationProperties[b],this.removeFromSchema(b,s.properties[b])}s.allOf?.forEach(b=>r(b))};for(const s of n){r(s);const b=this.configurationContributors.indexOf(s);b!==-1&&this.configurationContributors.splice(b,1)}}validateAndRegisterProperties(n,a=!0,r,s,b=3,p){b=I.isUndefinedOrNull(n.scope)?b:n.scope;const w=n.properties;if(w)for(const o in w){const u=w[o];if(a&&f(o,u)){delete w[o];continue}if(u.source=r,u.defaultDefaultValue=w[o].default,this.updatePropertyDefaultValue(o,u),e.OVERRIDE_PROPERTY_REGEX.test(o)?u.scope=void 0:(u.scope=I.isUndefinedOrNull(u.scope)?b:u.scope,u.restricted=I.isUndefinedOrNull(u.restricted)?!!s?.includes(o):u.restricted),w[o].hasOwnProperty("included")&&!w[o].included){this.excludedConfigurationProperties[o]=w[o],delete w[o];continue}else this.configurationProperties[o]=w[o],w[o].policy?.name&&this.policyConfigurations.set(w[o].policy.name,o);!w[o].deprecationMessage&&w[o].markdownDeprecationMessage&&(w[o].deprecationMessage=w[o].markdownDeprecationMessage),p.add(o)}const _=n.allOf;if(_)for(const o of _)this.validateAndRegisterProperties(o,a,r,s,b,p)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const a=r=>{const s=r.properties;if(s)for(const p in s)this.updateSchema(p,s[p]);r.allOf?.forEach(a)};a(n)}updateSchema(n,a){switch(e.allSettings.properties[n]=a,a.scope){case 1:e.applicationSettings.properties[n]=a;break;case 2:e.machineSettings.properties[n]=a;break;case 6:e.machineOverridableSettings.properties[n]=a;break;case 3:e.windowSettings.properties[n]=a;break;case 4:e.resourceSettings.properties[n]=a;break;case 5:e.resourceSettings.properties[n]=a,this.resourceLanguageSettingsSchema.properties[n]=a;break}}removeFromSchema(n,a){switch(delete e.allSettings.properties[n],a.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const a=`[${n}]`,r={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,r),e.allSettings.properties[a]=r,e.applicationSettings.properties[a]=r,e.machineSettings.properties[a]=r,e.machineOverridableSettings.properties[a]=r,e.windowSettings.properties[a]=r,e.resourceSettings.properties[a]=r}}registerOverridePropertyPatternKey(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,a){const r=this.configurationDefaultsOverrides.get(n);let s=r?.value,b=r?.source;I.isUndefined(s)&&(s=a.defaultDefaultValue,b=void 0),I.isUndefined(s)&&(s=i(a.type)),a.default=s,a.defaultValueSource=b}}const E="\\[([^\\]]+)\\]",v=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(k){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(k)){let a=v.exec(k);for(;a?.length;){const r=a[1].trim();r&&n.push(r),a=v.exec(k)}}return(0,S.distinct)(n)}e.overrideIdentifiersFromKey=d;function t(k){return k.reduce((n,a)=>`${n}[${a}]`,"")}e.keyFromOverrideIdentifiers=t;function i(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=i;const c=new l;y.Registry.add(e.Extensions.Configuration,c);function f(k,n){return k.trim()?e.OVERRIDE_PROPERTY_REGEX.test(k)?L.localize(7,null,k):c.getConfigurationProperties()[k]!==void 0?L.localize(8,null,k):n.policy?.name&&c.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,k,n.policy?.name,c.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}e.validateProperty=f;function C(){const k=[],n=c.getConfigurationProperties();for(const a of Object.keys(n))k.push([a,n[a].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=C}),define(Pe[178],Te([1,0,18,5,116,6,28,24,16,2,43,96,30]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function E(a){return Object.isFrozen(a)?a:h.deepFreeze(a)}class v{constructor(r={},s=[],b=[],p){this._contents=r,this._keys=s,this._overrides=b,this.raw=p,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(s=>{if(s instanceof v)return s;const b=new d("");return b.parseRaw(s),b.configurationModel});this._rawConfiguration=r.reduce((s,b)=>b===s?b:s.merge(b),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,P.getConfigurationValue)(this.contents,r):this.contents}inspect(r,s){const b=this.rawConfiguration.getValue(r),p=s?this.rawConfiguration.getOverrideValue(r,s):void 0,w=s?this.rawConfiguration.override(s).getValue(r):b;return{value:b,override:p,merged:w}}getOverrideValue(r,s){const b=this.getContentsForOverrideIdentifer(s);return b?r?(0,P.getConfigurationValue)(b,r):b:void 0}getKeysForOverrideIdentifier(r){const s=[];for(const b of this.overrides)b.identifiers.includes(r)&&s.push(...b.keys);return S.distinct(s)}getAllOverrideIdentifiers(){const r=[];for(const s of this.overrides)r.push(...s.identifiers);return S.distinct(r)}override(r){let s=this.overrideConfigurations.get(r);return s||(s=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,s)),s}merge(...r){const s=h.deepClone(this.contents),b=h.deepClone(this.overrides),p=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const _ of r)if(w.push(..._.raw?.length?_.raw:[_]),!_.isEmpty()){this.mergeContents(s,_.contents);for(const o of _.overrides){const[u]=b.filter(g=>S.equals(g.identifiers,o.identifiers));u?(this.mergeContents(u.contents,o.contents),u.keys.push(...o.keys),u.keys=S.distinct(u.keys)):b.push(h.deepClone(o))}for(const o of _.keys)p.indexOf(o)===-1&&p.push(o)}return new v(s,p,b,w.every(_=>_ instanceof v)?void 0:w)}createOverrideConfigurationModel(r){const s=this.getContentsForOverrideIdentifer(r);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const b={};for(const p of S.distinct([...Object.keys(this.contents),...Object.keys(s)])){let w=this.contents[p];const _=s[p];_&&(typeof w=="object"&&typeof _=="object"?(w=h.deepClone(w),this.mergeContents(w,_)):w=_),b[p]=w}return new v(b,this.keys,this.overrides)}mergeContents(r,s){for(const b of Object.keys(s)){if(b in r&&y.isObject(r[b])&&y.isObject(s[b])){this.mergeContents(r[b],s[b]);continue}r[b]=h.deepClone(s[b])}}getContentsForOverrideIdentifer(r){let s=null,b=null;const p=w=>{w&&(b?this.mergeContents(b,w):b=h.deepClone(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===r?s=w.contents:w.identifiers.includes(r)&&p(w.contents);return p(s),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,s){this.updateValue(r,s,!0)}setValue(r,s){this.updateValue(r,s,!1)}removeValue(r){const s=this.keys.indexOf(r);s!==-1&&(this.keys.splice(s,1),(0,P.removeFromValueTree)(this.contents,r),D.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(b=>S.equals(b.identifiers,(0,D.overrideIdentifiersFromKey)(r))),1))}updateValue(r,s,b){(0,P.addToValueTree)(this.contents,r,s,p=>console.error(p)),b=b||this.keys.indexOf(r)===-1,b&&this.keys.push(r),D.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,D.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,P.toValuesTree)(this.contents[r],p=>console.error(p))})}}e.ConfigurationModel=v;class d{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,s){if(!y.isUndefinedOrNull(r)){const b=this.doParseContent(r);this.parseRaw(b,s)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,s){this._raw=r;const{contents:b,keys:p,overrides:w,restricted:_,hasExcludedProperties:o}=this.doParseRaw(r,s);this._configurationModel=new v(b,p,w,o?[r]:void 0),this._restrictedConfigurations=_||[]}doParseContent(r){let s={},b=null,p=[];const w=[],_=[];function o(g){Array.isArray(p)?p.push(g):b!==null&&(p[b]=g)}const u={onObjectBegin:()=>{const g={};o(g),w.push(p),p=g,b=null},onObjectProperty:g=>{b=g},onObjectEnd:()=>{p=w.pop()},onArrayBegin:()=>{const g=[];o(g),w.push(p),p=g,b=null},onArrayEnd:()=>{p=w.pop()},onLiteralValue:o,onError:(g,O,z)=>{_.push({error:g,offset:O,length:z})}};if(r)try{I.visit(r,u),s=p[0]||{}}catch(g){console.error(`Error while parsing settings file ${this._name}: ${g}`),this._parseErrors=[g]}return s}doParseRaw(r,s){const b=l.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),p=this.filter(r,b,!0,s);r=p.raw;const w=(0,P.toValuesTree)(r,u=>console.error(`Conflict in settings file ${this._name}: ${u}`)),_=Object.keys(r),o=this.toOverrides(r,u=>console.error(`Conflict in settings file ${this._name}: ${u}`));return{contents:w,keys:_,overrides:o,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}filter(r,s,b,p){let w=!1;if(!p?.scopes&&!p?.skipRestricted&&!p?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:w};const _={},o=[];for(const u in r)if(D.OVERRIDE_PROPERTY_REGEX.test(u)&&b){const g=this.filter(r[u],s,!1,p);_[u]=g.raw,w=w||g.hasExcludedProperties,o.push(...g.restricted)}else{const g=s[u],O=g?typeof g.scope<"u"?g.scope:3:void 0;g?.restricted&&o.push(u),!p.exclude?.includes(u)&&(p.include?.includes(u)||(O===void 0||p.scopes===void 0||p.scopes.includes(O))&&!(p.skipRestricted&&g?.restricted))?_[u]=r[u]:w=!0}return{raw:_,restricted:o,hasExcludedProperties:w}}toOverrides(r,s){const b=[];for(const p of Object.keys(r))if(D.OVERRIDE_PROPERTY_REGEX.test(p)){const w={};for(const _ in r[p])w[_]=r[p][_];b.push({identifiers:(0,D.overrideIdentifiersFromKey)(p),keys:Object.keys(w),contents:(0,P.toValuesTree)(w,s)})}return b}}e.ConfigurationModelParser=d;class t extends L.Disposable{constructor(r,s,b,p){super(),this.userSettingsResource=r,this.parseOptions=s,this.fileService=p,this._onDidChange=this._register(new A.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this._register(this.fileService.watch(b.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(A.Event.any(A.Event.filter(this.fileService.onDidFilesChange,w=>w.contains(this.userSettingsResource)),A.Event.filter(this.fileService.onDidRunOperation,w=>(w.isOperation(0)||w.isOperation(3)||w.isOperation(1)||w.isOperation(4))&&b.isEqual(w.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(r){return r&&(this.parseOptions=r),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=t;class i{constructor(r,s,b,p,w,_,o,u,g,O,z,H,B){this.key=r,this.overrides=s,this._value=b,this.overrideIdentifiers=p,this.defaultConfiguration=w,this.policyConfiguration=_,this.applicationConfiguration=o,this.userConfiguration=u,this.localUserConfiguration=g,this.remoteUserConfiguration=O,this.workspaceConfiguration=z,this.folderConfigurationModel=H,this.memoryConfigurationModel=B}get value(){return E(this._value)}inspect(r,s,b){const p=r.inspect(s,b);return{get value(){return E(p.value)},get override(){return E(p.override)},get merged(){return E(p.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class c{constructor(r,s,b,p,w=new v,_=new v,o=new T.ResourceMap,u=new v,g=new T.ResourceMap){this._defaultConfiguration=r,this._policyConfiguration=s,this._applicationConfiguration=b,this._localUserConfiguration=p,this._remoteUserConfiguration=w,this._workspaceConfiguration=_,this._folderConfigurations=o,this._memoryConfiguration=u,this._memoryConfigurationByResource=g,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(r,s,b){return this.getConsolidatedConfigurationModel(r,s,b).getValue(r)}updateValue(r,s,b={}){let p;b.resource?(p=this._memoryConfigurationByResource.get(b.resource),p||(p=new v,this._memoryConfigurationByResource.set(b.resource,p))):p=this._memoryConfiguration,s===void 0?p.removeValue(r):p.setValue(r,s),b.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,s,b){const p=this.getConsolidatedConfigurationModel(r,s,b),w=this.getFolderConfigurationModelForResource(s.resource,b),_=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,o=new Set;for(const u of p.overrides)for(const g of u.identifiers)p.getOverrideValue(r,g)!==void 0&&o.add(g);return new i(r,s,p.getValue(r),o.size?[...o]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this._workspaceConfiguration:void 0,w||void 0,_)}keys(r){const s=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,s){this._folderConfigurations.set(r,s),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,s){const b=[];if(!s){const{added:p,updated:w,removed:_}=k(this._defaultConfiguration,r);s=[...p,...w,..._]}for(const p of s)for(const w of(0,D.overrideIdentifiersFromKey)(p)){const _=this._defaultConfiguration.getKeysForOverrideIdentifier(w),o=r.getKeysForOverrideIdentifier(w),u=[...o.filter(g=>_.indexOf(g)===-1),..._.filter(g=>o.indexOf(g)===-1),..._.filter(g=>!h.equals(this._defaultConfiguration.override(w).getValue(g),r.override(w).getValue(g)))];b.push([w,u])}return this.updateDefaultConfiguration(r),{keys:s,overrides:b}}compareAndUpdatePolicyConfiguration(r){const{added:s,updated:b,removed:p}=k(this._policyConfiguration,r),w=[...s,...b,...p];return w.length&&this.updatePolicyConfiguration(r),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:s,updated:b,removed:p,overrides:w}=k(this.applicationConfiguration,r),_=[...s,...b,...p];return _.length&&this.updateApplicationConfiguration(r),{keys:_,overrides:w}}compareAndUpdateLocalUserConfiguration(r){const{added:s,updated:b,removed:p,overrides:w}=k(this.localUserConfiguration,r),_=[...s,...b,...p];return _.length&&this.updateLocalUserConfiguration(r),{keys:_,overrides:w}}compareAndUpdateRemoteUserConfiguration(r){const{added:s,updated:b,removed:p,overrides:w}=k(this.remoteUserConfiguration,r),_=[...s,...b,...p];return _.length&&this.updateRemoteUserConfiguration(r),{keys:_,overrides:w}}compareAndUpdateWorkspaceConfiguration(r){const{added:s,updated:b,removed:p,overrides:w}=k(this.workspaceConfiguration,r),_=[...s,...b,...p];return _.length&&this.updateWorkspaceConfiguration(r),{keys:_,overrides:w}}compareAndUpdateFolderConfiguration(r,s){const b=this.folderConfigurations.get(r),{added:p,updated:w,removed:_,overrides:o}=k(b,s),u=[...p,...w,..._];return(u.length||!b)&&this.updateFolderConfiguration(r,s),{keys:u,overrides:o}}compareAndDeleteFolderConfiguration(r){const s=this.folderConfigurations.get(r);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:b,updated:p,removed:w,overrides:_}=k(s,void 0);return{keys:[...b,...p,...w],overrides:_}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,s,b){let p=this.getConsolidatedConfigurationModelForResource(s,b);return s.overrideIdentifier&&(p=p.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(p=p.merge(this._policyConfiguration)),p}getConsolidatedConfigurationModelForResource({resource:r},s){let b=this.getWorkspaceConsolidatedConfiguration();if(s&&r){const p=s.getFolder(r);p&&(b=this.getFolderConsolidatedConfiguration(p.uri)||b);const w=this._memoryConfigurationByResource.get(r);w&&(b=b.merge(w))}return b}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let s=this._foldersConsolidatedConfigurations.get(r);if(!s){const b=this.getWorkspaceConsolidatedConfiguration(),p=this._folderConfigurations.get(r);p?(s=b.merge(p),this._foldersConsolidatedConfigurations.set(r,s)):s=b}return s}getFolderConfigurationModelForResource(r,s){if(s&&r){const b=s.getFolder(r);if(b)return this._folderConfigurations.get(b.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,s)=>{const{contents:b,overrides:p,keys:w}=this._folderConfigurations.get(s);return r.push([s,{contents:b,overrides:p,keys:w}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(s=>r.add(s)),this.userConfiguration.keys.forEach(s=>r.add(s)),this._workspaceConfiguration.keys.forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(b=>r.add(b))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(b=>r.add(b))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(b=>s.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(b=>s.add(b)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(b=>s.add(b)),this._folderConfigurations.forEach(b=>b.getKeysForOverrideIdentifier(r).forEach(p=>s.add(p))),[...s.values()]}static parse(r){const s=this.parseConfigurationModel(r.defaults),b=this.parseConfigurationModel(r.policy),p=this.parseConfigurationModel(r.application),w=this.parseConfigurationModel(r.user),_=this.parseConfigurationModel(r.workspace),o=r.folders.reduce((u,g)=>(u.set(m.URI.revive(g[0]),this.parseConfigurationModel(g[1])),u),new T.ResourceMap);return new c(s,b,p,w,new v,_,o,new v,new T.ResourceMap)}static parseConfigurationModel(r){return new v(r.contents,r.keys,r.overrides)}}e.Configuration=c;function f(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const r=new Set,s=new Map;for(const p of a)p.keys.forEach(w=>r.add(w)),p.overrides.forEach(([w,_])=>{const o=(0,T.getOrSet)(s,w,new Set);_.forEach(u=>o.add(u))});const b=[];return s.forEach((p,w)=>b.push([w,[...p.values()]])),{keys:[...r.values()],overrides:b}}e.mergeChanges=f;class C{constructor(r,s,b,p){this.change=r,this.previous=s,this.currentConfiguraiton=b,this.currentWorkspace=p,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const w of r.keys)this.affectedKeys.add(w);for(const[,w]of r.overrides)for(const _ of w)this.affectedKeys.add(_);this._affectsConfigStr=this._marker;for(const w of this.affectedKeys)this._affectsConfigStr+=w+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=c.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,s){const b=this._marker+r,p=this._affectsConfigStr.indexOf(b);if(p<0)return!1;const w=p+b.length;if(w>=this._affectsConfigStr.length)return!1;const _=this._affectsConfigStr.charCodeAt(w);if(_!==this._markerCode1&&_!==this._markerCode2)return!1;if(s){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,s,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(r,s,this.currentWorkspace);return!h.equals(o,u)}return!0}}e.ConfigurationChangeEvent=C;function k(a,r){const{added:s,removed:b,updated:p}=n(r?.rawConfiguration,a?.rawConfiguration),w=[],_=a?.getAllOverrideIdentifiers()||[],o=r?.getAllOverrideIdentifiers()||[];if(r){const u=o.filter(g=>!_.includes(g));for(const g of u)w.push([g,r.getKeysForOverrideIdentifier(g)])}if(a){const u=_.filter(g=>!o.includes(g));for(const g of u)w.push([g,a.getKeysForOverrideIdentifier(g)])}if(r&&a){for(const u of _)if(o.includes(u)){const g=n({contents:a.getOverrideValue(void 0,u)||{},keys:a.getKeysForOverrideIdentifier(u)},{contents:r.getOverrideValue(void 0,u)||{},keys:r.getKeysForOverrideIdentifier(u)});w.push([u,[...g.added,...g.removed,...g.updated]])}}return{added:s,removed:b,updated:p,overrides:w}}function n(a,r){const s=a?r?a.keys.filter(w=>r.keys.indexOf(w)===-1):[...a.keys]:[],b=r?a?r.keys.filter(w=>a.keys.indexOf(w)===-1):[...r.keys]:[],p=[];if(a&&r){for(const w of r.keys)if(a.keys.indexOf(w)!==-1){const _=(0,P.getConfigurationValue)(r.contents,w),o=(0,P.getConfigurationValue)(a.contents,w);h.equals(_,o)||p.push(w)}}return{added:s,removed:b,updated:p}}}),define(Pe[97],Te([1,0,9,4]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var I;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class L{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=L;class T{constructor(D,l){this.host=D,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=T;var h;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(h||(e.RemoteAuthorityResolverErrorCode=h={}));class y extends S.ErrorNoTelemetry{static isNotAvailable(D){return D instanceof y&&D._code===h.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof y&&D._code===h.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof y&&D._code===h.NoResolverFound}static isInvalidAuthority(D){return D instanceof y&&D._code===h.InvalidAuthority}static isHandled(D){return D instanceof y&&D.isHandled}constructor(D,l=h.Unknown,E){super(D),this._message=D,this._code=l,this._detail=E,this.isHandled=l===h.NotAvailable&&E===!0,Object.setPrototypeOf(this,y.prototype)}}e.RemoteAuthorityResolverError=y;function m(P){const D=P.indexOf("+");return D===-1?P:P.substring(0,D)}e.getRemoteAuthorityPrefix=m}),define(Pe[51],Te([1,0,12]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(m){return m.scheme===S.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=A;function I(m){if(!m)return;const P=m.indexOf("+");return P<0?m:m.substr(0,P)}e.getRemoteName=I;function L(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=L;function T(m){const{host:P,port:D}=y(m);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:D}}e.parseAuthorityWithPort=T;function h(m,P){let{host:D,port:l}=y(m);return typeof l>"u"&&(l=P),{host:D,port:l}}e.parseAuthorityWithOptionalPort=h;function y(m){const P=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const D=m.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const l=m.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:m,port:void 0}}}),define(Pe[20],Te([1,0,15,4,51]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(T||(e.ExtensionType=T={}));var h;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.LINUX_PPC64LE="linux-ppc64le",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(h||(e.TargetPlatform=h={}));class y{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const c=typeof t=="string"?t:t.value,f=typeof i=="string"?i:i.value;return S.equalsIgnoreCase(c,f)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.ExtensionIdentifier=y;class m{get size(){return this._set.size}constructor(t){if(this._set=new Set,t)for(const i of t)this.add(i)}add(t){this._set.add(y.toKey(t))}delete(t){return this._set.delete(y.toKey(t))}has(t){return this._set.has(y.toKey(t))}}e.ExtensionIdentifierSet=m;class P{constructor(){this._map=new Map}clear(){this._map.clear()}delete(t){this._map.delete(y.toKey(t))}get(t){return this._map.get(y.toKey(t))}has(t){return this._map.has(y.toKey(t))}set(t,i){this._map.set(y.toKey(t),i)}values(){return this._map.values()}forEach(t){this._map.forEach(t)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function D(d){return l(d)}e.isApplicationScopedExtension=D;function l(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=l;function E(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function v(d,t){if(t){const i=`onResolveRemoteAuthority:${(0,I.getRemoteName)(t)}`;return!!d.activationEvents?.includes(i)}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(Pe[98],Te([1,0,9,20]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class I{constructor(){this._generators=new Map,this._cache=new WeakMap}register(T,h){this._generators.set(T,h)}readActivationEvents(T){return this._cache.has(T)||this._cache.set(T,this._readActivationEvents(T)),this._cache.get(T)}createActivationEventsMap(T){const h=Object.create(null);for(const y of T){const m=this.readActivationEvents(y);m.length>0&&(h[A.ExtensionIdentifier.toKey(y.identifier)]=m)}return h}_readActivationEvents(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const h=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];if(!T.contributes)return h;for(const y in T.contributes){const m=this._generators.get(y);if(!m)continue;const P=T.contributes[y],D=Array.isArray(P)?P:[P];try{m(D,h)}catch(l){(0,S.onUnexpectedError)(l)}}return h}}e.ImplicitActivationEventsImpl=I,e.ImplicitActivationEvents=new I}),define(Pe[179],Te([1,0,22,52,36]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(y){if(S.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function T(y,m,P,D,l,E,v,d){const t=Object.create(null);t["common.machineId"]=E,t.sessionID=(0,I.generateUuid)()+Date.now(),t.commitHash=D,t.version=l,t["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,S.PlatformToString)(S.platform),t["common.nodePlatform"]=A.platform,t["common.nodeArch"]=P,t["common.product"]=d||"desktop",v&&(t["common.msftInternal"]=v);let i=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),S.isLinuxSnap&&(t["common.snap"]="true");const f=L(m);return f&&(t["common.platformDetail"]=f),t}e.resolveCommonProperties=T;function h(y){const m=A.env.USERDNSDOMAIN;if(!m)return!1;const P=m.toLowerCase();return y.some(D=>P===D)}e.verifyMicrosoftInternalDomain=h}),define(Pe[180],Te([1,0,4]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var I;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Pe[53],Te([1,0,24,16,5,43,51,179,180]),function(ve,e,S,A,I,L,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=m;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class D{async publicLog(b,p,w){}async publicLogError(b,p,w){}}e.NullEndpointTelemetryService=D,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(s,b){return I.Event.debounce(b.onDidChangeConfiguration,(w,_)=>{const o=w?new Set([...w.affectedKeys,..._.affectedKeys]):_.affectedKeys;return{..._,affectedKeys:o}},1e3,!0)(w=>{w.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(w.source),configurationKeys:Array.from(w.affectedKeys)})})}e.configurationTelemetry=l;function E(s,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!s.enableTelemetry||b.extensionTestsLocationURI)}e.supportsTelemetry=E;function v(s,b){return!(b.isBuilt||b.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=v;function d(s){const b=s.getValue(y.TELEMETRY_SETTING_ID),p=s.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(s.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||p===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=d;function t(s){const b={},p={},w={};f(s,w);for(let _ in w){_=_.length>150?_.substr(_.length-149):_;const o=w[_];typeof o=="number"?p[_]=o:typeof o=="boolean"?p[_]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${_} has been trimmed to 8192, the original length is ${o.length}`),b[_]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(b[_]=o)}return{properties:b,measurements:p}}e.validateTelemetryData=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(s){if(!s)return"none";const b=(0,T.getRemoteName)(s);return i.has(b)?b:"other"}e.cleanRemoteAuthority=c;function f(s,b,p=0,w){if(s)for(const _ of Object.getOwnPropertyNames(s)){const o=s[_],u=w?w+_:_;Array.isArray(o)?b[u]=(0,S.safeStringify)(o):o instanceof Date?b[u]=o.toISOString():(0,A.isObject)(o)?p<2?f(o,b,p+1,u+"."):b[u]=(0,S.safeStringify)(o):b[u]=o}}function C(s,b){const p=s.msftInternalDomains||[],w=b.getValue("telemetry.internalTesting");return(0,h.verifyMicrosoftInternalDomain)(p)||w}e.isInternalTelemetry=C;function k(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=k;function n(s,b){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let p=s;const w=[];for(const g of b)for(;;){const O=g.exec(s);if(!O)break;w.push([O.index,g.lastIndex])}const _=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(p="";;){const g=o.exec(s);if(!g)break;const O=w.some(([z,H])=>g.index<H&&z<o.lastIndex);!_.test(g[0])&&!O&&(p+=s.substring(u,g.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<s.length&&(p+=s.substr(u)),p}function a(s){if(!s)return s;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const p of b)if(p.regex.test(s))return`<REDACTED: ${p.label}>`;return s}function r(s,b){return(0,S.cloneAndChange)(s,p=>{if(p instanceof m||Object.hasOwnProperty.call(p,"isTrustedTelemetryValue"))return p.value;if(typeof p=="string"){let w=p.replaceAll("%20"," ");w=n(w,b);for(const _ of b)w=w.replace(_,"");return w=a(w),w}})}e.cleanData=r}),define(Pe[181],Te([1,0,15,92,20,22,2,9,52,53]),function(ve,e,S,A,I,L,T,h,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(r,s){return r.uuid&&s.uuid?r.uuid===s.uuid:r.id===s.id?!0:(0,S.compareIgnoreCase)(r.id,s.id)===0}e.areSameExtensions=P;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(s){const b=s.manifest?s.manifest.version:s.version,p=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new l(s.identifier,b,p)}static parse(s){const b=D.exec(s);return b&&b[1]&&b[2]?new l({id:b[1]},b[2],b[4]||void 0):null}constructor(s,b,p="undefined"){this.version=b,this.targetPlatform=p,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof l?P(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=l;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const s=E.exec(r);return s&&s[1]?[t(s[1]),s[2]]:[t(r),void 0]}e.getIdAndVersion=v;function d(r,s){return`${r}.${s}`}e.getExtensionId=d;function t(r){return r.toLowerCase()}e.adoptToGalleryExtensionId=t;function i(r,s){return t(d(r??I.UNDEFINED_PUBLISHER,s))}e.getGalleryExtensionId=i;function c(r,s){const b=[],p=w=>{for(const _ of b)if(_.some(o=>P(s(o),s(w))))return _;return null};for(const w of r){const _=p(w);_?_.push(w):b.push([w])}return b}e.groupByExtension=c;function f(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=f;function C(r){return{id:new m.TelemetryTrustedValue(r.identifier.id),name:new m.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function k(r,s){const b=[],p=s.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const w=p.shift();if(w&&b.every(_=>!P(_.identifier,{id:w}))){const _=r.filter(o=>P(o.identifier,{id:w}));_.length===1&&(b.push(_[0]),p.push(..._[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=k;async function n(r,s){if(!L.isLinux)return!1;let b;try{b=(await r.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await r.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(w){s.debug("Error while getting the os-release file.",(0,h.getErrorMessage)(w))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(r,s){const b=await n(r,s),p=(0,A.getTargetPlatform)(b?"alpine":L.platform,y.arch);return s.debug("ComputeTargetPlatform:",p),p}e.computeTargetPlatform=a}),define(Pe[182],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function S(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=S;function A(y){return y?[...y.entries()]:[]}e.serializeEnvironmentDescriptionMap=A;function I(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=I;function L(y){return new Map(y??[])}e.deserializeEnvironmentDescriptionMap=L;function T(y){return Array.from(y.entries()).map(m=>[m[0],S(m[1].map),A(m[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=T;function h(y){return new Map(y.map(m=>[m[0],{map:I(m[1]),descriptionMap:L(m[2])}]))}e.deserializeEnvironmentVariableCollections=h}),define(Pe[183],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class S{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,L,T=5){const h=L(y=>{const m=typeof y=="string"?y:y.data;let P=this._terminalBufferMap.get(I);if(P){P.data.push(m);return}const D=setTimeout(()=>this.flushBuffer(I),T);P={data:[m],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(I),h.dispose()}},this._terminalBufferMap.set(I,P)});return h}stopBuffering(I){this._terminalBufferMap.get(I)?.dispose()}flushBuffer(I){const L=this._terminalBufferMap.get(I);L&&(this._terminalBufferMap.delete(I),this._callback(I,L.data.join("")))}}e.TerminalDataBufferer=S}),define(Pe[184],Te([1,0,13,89,40,5,16,2,145,74,30]),function(ve,e,S,A,I,L,T,h,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var D;(function(C){function k(n,a){let r=n.defaults;for(;I.ThemeIcon.isThemeIcon(r);){const s=v.getIcon(r.id);if(!s)return;r=s.defaults}return r}C.getDefinition=k})(D||(e.IconContribution=D={}));var l;(function(C){function k(a){return{weight:a.weight,style:a.style,src:a.src.map(r=>({format:r.format,location:r.location.toString()}))}}C.toJSONObject=k;function n(a){const r=s=>(0,T.isString)(s)?s:void 0;if(a&&Array.isArray(a.src)&&a.src.every(s=>(0,T.isString)(s.format)&&(0,T.isString)(s.location)))return{weight:r(a.weight),style:r(a.style),src:a.src.map(s=>({format:s.format,location:h.URI.parse(s.location)}))}}C.fromJSONObject=n})(l||(e.IconFontDefinition=l={}));class E{constructor(){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(k,n,a,r){const s=this.iconsById[k];if(s){if(a&&!s.description){s.description=a,this.iconSchema.properties[k].markdownDescription=`${a} $(${k})`;const w=this.iconReferenceSchema.enum.indexOf(k);w!==-1&&(this.iconReferenceSchema.enumDescriptions[w]=a),this._onDidChange.fire()}return s}const b={id:k,description:a,defaults:n,deprecationMessage:r};this.iconsById[k]=b;const p={$ref:"#/definitions/icons"};return r&&(p.deprecationMessage=r),a&&(p.markdownDescription=`${a}: $(${k})`),this.iconSchema.properties[k]=p,this.iconReferenceSchema.enum.push(k),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:k}}deregisterIcon(k){delete this.iconsById[k],delete this.iconSchema.properties[k];const n=this.iconReferenceSchema.enum.indexOf(k);n!==-1&&(this.iconReferenceSchema.enum.splice(n,1),this.iconReferenceSchema.enumDescriptions.splice(n,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(k=>this.iconsById[k])}getIcon(k){return this.iconsById[k]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(k,n){const a=this.iconFontsById[k];return a||(this.iconFontsById[k]=n,this._onDidChange.fire(),n)}deregisterIconFont(k){delete this.iconFontsById[k]}getIconFont(k){return this.iconFontsById[k]}toString(){const k=(s,b)=>s.id.localeCompare(b.id),n=s=>{for(;I.ThemeIcon.isThemeIcon(s.defaults);)s=this.iconsById[s.defaults.id];return`codicon codicon-${s?s.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.iconsById).map(s=>this.iconsById[s]);for(const s of r.filter(b=>!!b.description).sort(k))a.push(`|<i class="${n(s)}"></i>|${s.id}|${I.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const s of r.filter(b=>!I.ThemeIcon.isThemeIcon(b.defaults)).sort(k))a.push(`|<i class="${n(s)}"></i>|${s.id}|`);return a.join(`
`)}}const v=new E;P.Registry.add(e.Extensions.IconContribution,v);function d(C,k,n,a){return v.registerIcon(C,k,n,a)}e.registerIcon=d;function t(){return v}e.getIconRegistry=t;function i(){const C=(0,A.getCodiconFontCharacters)();for(const k in C){const n="\\"+C[k].toString(16);v.registerIcon(k,{fontCharacter:n})}}i(),e.iconsSchemaId="vscode://schemas/icons";const c=P.Registry.as(m.Extensions.JSONContribution);c.registerSchema(e.iconsSchemaId,v.getIconSchema());const f=new S.RunOnceScheduler(()=>c.notifySchemaChanged(e.iconsSchemaId),200);v.onDidChange(()=>{f.isScheduled()||f.schedule()}),e.widgetClose=d("widget-close",A.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=d("goto-previous-location",A.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=d("goto-next-location",A.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=I.ThemeIcon.modify(A.Codicon.sync,"spin"),e.spinningLoading=I.ThemeIcon.modify(A.Codicon.loading,"spin")}),define(Pe[185],Te([1,0,5,43,4,14]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var T;(function(t){t.Http="http",t.Https="https"})(T||(e.TunnelProtocol=T={}));var h;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(h||(e.TunnelPrivacyId=h={}));function y(t){return!!t.forwardPort}e.isTunnelProvider=y;var m;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=D,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=l;function E(t,i,c,f){if(c===1)return!1;if(c===2&&l(i)){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(C?.length===4&&parseInt(C[1])>=18)return!1}return t<1024}e.isPortPrivileged=E;class v{constructor(i,c,f){this.remoteAddress=i,this.localAddress=c,this._dispose=f,this._onDispose=new S.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=v;let d=class{constructor(i,c){this.logService=i,this.configurationService=c,this._onTunnelOpened=new S.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new S.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new S.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const i=this.configurationService.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this._tunnelProvider=i,i?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this._canElevate=i.elevation,this._privacyOptions=i.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const i=[],c=Array.from(this._tunnels.values());for(const f of c){const C=Array.from(f.values());for(const k of C){const n=await k.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this._tunnels.values()){for(const{value:c}of i.values())await c.then(f=>typeof f!="string"?f?.dispose():void 0);i.clear()}this._tunnels.clear()}setEnvironmentTunnel(i,c,f,C,k){this.addTunnelToMap(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:f,privacy:C,protocol:k,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(l(i)||D(i))&&(i=e.LOCALHOST_ADDRESSES[0]);const f=this.getTunnelFromMap(i,c);if(f)return++f.refcount,f.value}openTunnel(i,c,f,C,k,n=!1,a,r){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${f} on local port ${k}.`);const s=this._tunnelProvider??i;if(!s)return;if(c||(c="localhost"),C||(C=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(f)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.retainOrCreateTunnel(s,c,f,C,k,n,a,r);return b?b.then(p=>{if(p){if(typeof p=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(c,f),p}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(c,f);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.makeTunnel(p);return(p.tunnelRemoteHost!==c||p.tunnelRemotePort!==f)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&p.privacy!==a&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(w),w}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}makeTunnel(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this._tunnels.get(i.tunnelRemoteHost);if(c){const f=c.get(i.tunnelRemotePort);f&&(f.refcount--,await this.tryDisposeTunnel(i.tunnelRemoteHost,i.tunnelRemotePort,f))}}}}async tryDisposeTunnel(i,c,f){if(f.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const C=f.value.then(async k=>{k&&typeof k!="string"&&(await k.dispose(!0),this._onTunnelClosed.fire({host:k.tunnelRemoteHost,port:k.tunnelRemotePort}))});return this._tunnels.has(i)&&this._tunnels.get(i).delete(c),C}}async closeTunnel(i,c){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const f=this._tunnels.get(i);if(f&&f.has(c)){const C=f.get(c);C.refcount=0,await this.tryDisposeTunnel(i,c,C)}}addTunnelToMap(i,c,f){this._tunnels.has(i)||this._tunnels.set(i,new Map),this._tunnels.get(i).set(c,{refcount:1,value:f})}async removeEmptyOrErrorTunnelFromMap(i,c){const f=this._tunnels.get(i);if(f){const C=f.get(c),k=C?await C.value:void 0;(!k||typeof k=="string")&&f.delete(c),f.size===0&&this._tunnels.delete(i)}}getTunnelFromMap(i,c){const f=[i];D(i)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):l(i)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const C=f.map(k=>this._tunnels.get(k));for(const k of C){const n=k?.get(c);if(n)return n}}canTunnel(i){return!!P(i)}createWithProvider(i,c,f,C,k,n,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${f} on local port ${C}.`);const r=f;this._factoryInProgress.add(r);const s=C===void 0?f:C,b={elevationRequired:k?this.isPortPrivileged(s):!1},p={remoteAddress:{host:c,port:f},localAddressPort:C,privacy:n,public:n?n!==h.Private:void 0,protocol:a},w=i.forwardPort(p,b);return w?(this.addTunnelToMap(c,f,w),w.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),w}};e.AbstractTunnelService=d,e.AbstractTunnelService=d=Ve([ze(0,L.ILogService),ze(1,A.IConfigurationService)],d)}),define(Pe[186],Te([1,0,4]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,S.createDecorator)("editSessionIdentityService");var A;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(A||(e.EditSessionIdentityMatch=A={}))}),define(Pe[187],Te([1,0,12]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(y){return y.scheme!==S.Schemas.file&&y.scheme!==S.Schemas.vscodeRemote}e.isVirtualResource=A;function I(y){if(y.folders.length)return y.folders.every(m=>A(m.uri))?y.folders[0].uri:void 0;if(y.configuration&&A(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=I;function L(y){return I(y)?.scheme}e.getVirtualWorkspaceScheme=L;function T(y){return I(y)?.authority}e.getVirtualWorkspaceAuthority=T;function h(y){return I(y)!==void 0}e.isVirtualWorkspace=h}),define(Pe[54],Te([1,0,146,19,48,23,2,4,12]),function(ve,e,S,A,I,L,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,h.createDecorator)("contextService");function m(s){const b=s;return typeof b?.id=="string"&&T.URI.isUri(b.uri)}e.isSingleFolderWorkspaceIdentifier=m;function P(s){return typeof s?.id=="string"&&!m(s)&&!l(s)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function D(s,b){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,A.basename)(s)}:b?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const p=s;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}e.toWorkspaceIdentifier=D;function l(s){const b=s;return typeof b?.id=="string"&&T.URI.isUri(b.configPath)}e.isWorkspaceIdentifier=l;function E(s){const b=s;if(b?.uri)return{id:b.id,uri:T.URI.revive(b.uri)};const p=s;if(p?.configPath)return{id:p.id,configPath:T.URI.revive(p.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=E;var v;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function d(s){const b=s;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=d;function t(s){const b=s;return!!(b&&typeof b=="object"&&T.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=t;class i{constructor(b,p,w,_,o){this._id=b,this._transient=w,this._configuration=_,this._ignorePathCasing=o,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=p}update(b){this._id=b.id,this._configuration=b.configuration,this._transient=b.transient,this._ignorePathCasing=b._ignorePathCasing,this.folders=b.folders}get folders(){return this._folders}set folders(b){this._folders=b,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(b){this._configuration=b}getFolder(b){return b&&this._foldersMap.findSubstr(b)||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const b of this.folders)this._foldersMap.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=i;class c{constructor(b,p){this.raw=p,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,L.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function f(s){return new c({uri:s,index:0,name:(0,L.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=f,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function C(s,b){return L.extUriBiasedIgnorePathCase.isEqualOrParent(s,b.untitledWorkspacesHome)}e.isUntitledWorkspace=C;function k(s){let b;return T.URI.isUri(s)?b=s:b=s.configuration,b?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=k,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=n;function a(s,b){return!C(s,b)&&!k(s)}e.isSavedWorkspace=a;function r(s){return(typeof s=="string"?(0,A.extname)(s):(0,L.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Pe[55],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class S{static{this.enableDebugLogging=!1}constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const L=this._idPool++;return this._data.set(L,I),this.logDebugInfo(),L}get(I,L){return this._data.has(I)?this._data.get(I)[L]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){S.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=S}),define(Pe[39],Te([1,0,12,23,4]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this._systemSchemes=new Set(Object.keys(S.Schemas)),this._providerInfo=new Map,this.extUri=new A.ExtUri(h=>{const y=this._providerInfo.get(h.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(h,y){y===null?this._providerInfo.delete(h.scheme):this._providerInfo.set(h.scheme,y)}isFreeScheme(h){return!this._providerInfo.has(h)&&!this._systemSchemes.has(h)}getCapabilities(h){return this._providerInfo.get(h)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(Pe[27],Te([1,0,4]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,S.createDecorator)("IExtHostInitDataService")}),define(Pe[188],Te([1,0,151,14,175,27]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends I.LogService{constructor(y,m,P){const D=P.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",l=P.remote.isRemote?(0,S.localize)(0,null):y?(0,S.localize)(1,null):(0,S.localize)(2,null);super(m.createLogger(D,{name:l}))}};e.ExtHostLogService=T,e.ExtHostLogService=T=Ve([ze(1,A.ILoggerService),ze(2,L.IExtHostInitDataService)],T)}),define(Pe[189],Te([1,0,13]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(T,h,y){this._deferredPromises=new Map,this._id=T,this._shared=h,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(m=>(this._value=m,this)),this._storageListener=this._storage.onDidChangeStorage(m=>{m.shared===this._shared&&m.key===this._id&&(this._value=m.value)}),this._scheduler=new S.RunOnceScheduler(()=>{const m=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const P of m.values())P.complete()}catch(P){for(const D of m.values())D.error(P)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,h){let y=this._value[T];return typeof y>"u"&&(y=h),y}update(T,h){this._value[T]=h;const y=this._deferredPromises.get(T);if(y!==void 0)return y.p;const m=new S.DeferredPromise;return this._deferredPromises.set(T,m),this._scheduler.isScheduled()||this._scheduler.schedule(),m.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=A;class I extends A{setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}constructor(T,h){super(T.identifier.value,!0,h),this._extension=T}}e.ExtensionGlobalMemento=I}),define(Pe[190],Te([1,0,5,2]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class I{constructor(T){this._notebooksAndEditors=T,this._onDidSaveNotebookDocument=new S.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new S.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(T,h,y,m){const D=this._notebooksAndEditors.getNotebookDocument(A.URI.revive(T)).acceptModelChanged(h.value,y,m);this._onDidChangeNotebookDocument.fire(D)}$acceptDirtyStateChanged(T,h){this._notebooksAndEditors.getNotebookDocument(A.URI.revive(T)).acceptDirty(h)}$acceptModelSaved(T){const h=this._notebooksAndEditors.getNotebookDocument(A.URI.revive(T));this._onDidSaveNotebookDocument.fire(h.apiNotebook)}}e.ExtHostNotebookDocuments=I}),define(Pe[17],Te([1,0,4]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,S.createDecorator)("IExtHostRpcService");class A{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=A}),define(Pe[191],Te([1,0,20,5]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class I{#e;constructor(T,h){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this._id=S.ExtensionIdentifier.toKey(T.identifier),this.#e=h,this.#e.onDidChangePassword(y=>{y.extensionId===this._id&&this._onDidChange.fire({key:y.key})})}get(T){return this.#e.get(this._id,T)}store(T,h){return this.#e.store(this._id,T,h)}delete(T){return this.#e.delete(this._id,T)}}e.ExtensionSecrets=I}),define(Pe[56],Te([1,0,4]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,S.createDecorator)("IURITransformerService");class A{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=A}),define(Pe[192],Te([1,0,25]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(y){let m=this.buffers.indexOf(y);return m<0&&(m=this.buffers.length,this.buffers.push(y)),m}}function I(h,y){if(y.serializeBuffersForPostMessage){const m=new A,D=JSON.stringify(h,(E,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:m.add(v)};if(ArrayBuffer.isView(v)){const d=L(v);if(d)return{$$vscode_array_buffer_reference$$:!0,index:m.add(v.buffer),view:{type:d,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),l=m.buffers.map(E=>{const v=new Uint8Array(E);return S.VSBuffer.wrap(v)});return{message:D,buffers:l}}else return{message:JSON.stringify(h),buffers:[]}}e.serializeWebviewMessage=I;function L(h){switch(h.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(h,y){const m=y.map(l=>{const E=new ArrayBuffer(l.byteLength);return new Uint8Array(E).set(l.buffer),E}),P=y.length?(l,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const v=E,{index:d}=v,t=m[d];if(v.view)switch(v.view.type){case 1:return new Int8Array(t,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return E}:void 0;return{message:JSON.parse(h,P),arrayBuffers:m}}e.deserializeWebviewMessage=T}),define(Pe[99],Te([1,0,160,16,2,6,4,30,38,12,41,128,29]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.preventEditorClose=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var E;(function(ae){ae[ae.PROGRAMMATIC=1]="PROGRAMMATIC",ae[ae.USER=2]="USER",ae[ae.EDIT=3]="EDIT",ae[ae.NAVIGATION=4]="NAVIGATION",ae[ae.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var v;(function(ae){ae[ae.IDENTICAL=1]="IDENTICAL",ae[ae.SIMILAR=2]="SIMILAR",ae[ae.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function d(ae){const J=ae;return!!J&&typeof J.getSelection=="function"&&!!J.onDidChangeSelection}e.isEditorPaneWithSelection=d;function t(ae,J,le){for(const N of le.visibleEditorPanes)if(N.group.id===J&&ae.matches(N.input))return N.getViewState()}e.findViewStateForEditor=t;function i(ae){if(p(ae))return!1;const J=ae;return I.URI.isUri(J?.resource)}e.isResourceEditorInput=i;function c(ae){if(p(ae))return!1;const J=ae;return J?.original!==void 0&&J.modified!==void 0}e.isResourceDiffEditorInput=c;function f(ae){if(p(ae)||c(ae))return!1;const J=ae;return J?.primary!==void 0&&J.secondary!==void 0}e.isResourceSideBySideEditorInput=f;function C(ae){if(p(ae))return!1;const J=ae;return J?J.resource===void 0||J.resource.scheme===m.Schemas.untitled||J.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=C;function k(ae){if(p(ae))return!1;const J=ae;return I.URI.isUri(J?.base?.resource)&&I.URI.isUri(J?.input1?.resource)&&I.URI.isUri(J?.input2?.resource)&&I.URI.isUri(J?.result?.resource)}e.isResourceMergeEditorInput=k;var n;(function(ae){ae[ae.SHORT=0]="SHORT",ae[ae.MEDIUM=1]="MEDIUM",ae[ae.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var a;(function(ae){ae[ae.EXPLICIT=1]="EXPLICIT",ae[ae.AUTO=2]="AUTO",ae[ae.FOCUS_CHANGE=3]="FOCUS_CHANGE",ae[ae.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class r{constructor(){this.mapIdToSaveSource=new Map}registerSource(J,le){let N=this.mapIdToSaveSource.get(J);return N||(N={source:J,label:le},this.mapIdToSaveSource.set(J,N)),N.source}getSourceLabel(J){return this.mapIdToSaveSource.get(J)?.label??J}}e.SaveSourceRegistry=new r;var s;(function(ae){ae[ae.None=0]="None",ae[ae.Readonly=2]="Readonly",ae[ae.Untitled=4]="Untitled",ae[ae.Singleton=8]="Singleton",ae[ae.RequiresTrust=16]="RequiresTrust",ae[ae.CanSplitInGroup=32]="CanSplitInGroup",ae[ae.ForceDescription=64]="ForceDescription",ae[ae.CanDropIntoEditor=128]="CanDropIntoEditor",ae[ae.MultipleEditors=256]="MultipleEditors",ae[ae.Scratchpad=512]="Scratchpad"})(s||(e.EditorInputCapabilities=s={}));class b extends L.Disposable{}e.AbstractEditorInput=b;function p(ae){return ae instanceof b}e.isEditorInput=p;function w(ae){const J=ae;return I.URI.isUri(J?.preferredResource)}function _(ae){const J=ae;return p(J?.primary)&&p(J?.secondary)}e.isSideBySideEditorInput=_;function o(ae){const J=ae;return p(J?.modified)&&p(J?.original)}e.isDiffEditorInput=o;function u(ae,J,le,N,q){return ke(N,[(0,D.toAction)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const ue={...le,limits:{size:Number.MAX_VALUE}};ae.openEditor(J,ue)}}),(0,D.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.createTooLargeFileError=u;function g(ae){return p(ae?.editor)}e.isEditorInputWithOptions=g;function O(ae){const J=ae;return g(ae)&&J?.group!==void 0}e.isEditorInputWithOptionsAndGroup=O;function z(ae){const J=ae;return typeof J?.groupId=="number"&&p(J.editor)}e.isEditorIdentifier=z;var H;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.REPLACE=1]="REPLACE",ae[ae.MOVE=2]="MOVE",ae[ae.UNPIN=3]="UNPIN"})(H||(e.EditorCloseContext=H={}));var B;(function(ae){ae[ae.GROUP_ACTIVE=0]="GROUP_ACTIVE",ae[ae.GROUP_INDEX=1]="GROUP_INDEX",ae[ae.GROUP_LOCKED=2]="GROUP_LOCKED",ae[ae.EDITOR_OPEN=3]="EDITOR_OPEN",ae[ae.EDITOR_CLOSE=4]="EDITOR_CLOSE",ae[ae.EDITOR_MOVE=5]="EDITOR_MOVE",ae[ae.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ae[ae.EDITOR_LABEL=7]="EDITOR_LABEL",ae[ae.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ae[ae.EDITOR_PIN=9]="EDITOR_PIN",ae[ae.EDITOR_STICKY=10]="EDITOR_STICKY",ae[ae.EDITOR_DIRTY=11]="EDITOR_DIRTY",ae[ae.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(B||(e.GroupModelChangeKind=B={}));var $;(function(ae){ae[ae.PRIMARY=1]="PRIMARY",ae[ae.SECONDARY=2]="SECONDARY",ae[ae.BOTH=3]="BOTH",ae[ae.ANY=4]="ANY"})($||(e.SideBySideEditor=$={}));class x{getOriginalUri(J,le){if(!J)return;if(k(J))return e.EditorResourceAccessor.getOriginalUri(J.result,le);if(le?.supportSideBySide){const{primary:q,secondary:ue}=this.getSideEditors(J);if(q&&ue){if(le?.supportSideBySide===$.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:le.filterByScheme}),secondary:this.getOriginalUri(ue,{filterByScheme:le.filterByScheme})};if(le?.supportSideBySide===$.ANY)return this.getOriginalUri(q,{filterByScheme:le.filterByScheme})??this.getOriginalUri(ue,{filterByScheme:le.filterByScheme});J=le.supportSideBySide===$.PRIMARY?q:ue}}if(c(J)||f(J)||k(J))return;const N=w(J)?J.preferredResource:J.resource;return!N||!le||!le.filterByScheme?N:this.filterUri(N,le.filterByScheme)}getSideEditors(J){return _(J)||f(J)?{primary:J.primary,secondary:J.secondary}:o(J)||c(J)?{primary:J.modified,secondary:J.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(J,le){if(!J)return;if(k(J))return e.EditorResourceAccessor.getCanonicalUri(J.result,le);if(le?.supportSideBySide){const{primary:q,secondary:ue}=this.getSideEditors(J);if(q&&ue){if(le?.supportSideBySide===$.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:le.filterByScheme}),secondary:this.getCanonicalUri(ue,{filterByScheme:le.filterByScheme})};if(le?.supportSideBySide===$.ANY)return this.getCanonicalUri(q,{filterByScheme:le.filterByScheme})??this.getCanonicalUri(ue,{filterByScheme:le.filterByScheme});J=le.supportSideBySide===$.PRIMARY?q:ue}}if(c(J)||f(J)||k(J))return;const N=J.resource;return!N||!le||!le.filterByScheme?N:this.filterUri(N,le.filterByScheme)}filterUri(J,le){if(Array.isArray(le)){if(le.some(N=>J.scheme===N))return J}else if(le===J.scheme)return J}}var M;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.KEYBOARD=1]="KEYBOARD",ae[ae.MOUSE=2]="MOUSE"})(M||(e.EditorCloseMethod=M={}));function ne(ae,J,le,N){if(!ae.isSticky(J))return!1;switch(N.preventPinnedEditorClose){case"keyboardAndMouse":return le===M.MOUSE||le===M.KEYBOARD;case"mouse":return le===M.MOUSE;case"keyboard":return le===M.KEYBOARD}return!1}e.preventEditorClose=ne,e.EditorResourceAccessor=new x;var Q;(function(ae){ae[ae.LEFT=0]="LEFT",ae[ae.RIGHT=1]="RIGHT"})(Q||(e.CloseDirection=Q={}));class we{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(J){const le=this.instantiationService=J.get(T.IInstantiationService);for(const[N,q]of this.editorSerializerConstructors)this.createEditorSerializer(N,q,le);this.editorSerializerConstructors.clear()}createEditorSerializer(J,le,N){const q=N.createInstance(le);this.editorSerializerInstances.set(J,q)}registerFileEditorFactory(J){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=J}getFileEditorFactory(){return(0,A.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(J,le){if(this.editorSerializerConstructors.has(J)||this.editorSerializerInstances.has(J))throw new Error(`A editor serializer with type ID '${J}' was already registered.`);return this.instantiationService?this.createEditorSerializer(J,le,this.instantiationService):this.editorSerializerConstructors.set(J,le),(0,L.toDisposable)(()=>{this.editorSerializerConstructors.delete(J),this.editorSerializerInstances.delete(J)})}getEditorSerializer(J){return this.editorSerializerInstances.get(typeof J=="string"?J:J.typeId)}}h.Registry.add(e.EditorExtensions.EditorFactory,new we);async function _e(ae,J,le){return!ae||!ae.length?[]:await Promise.all(ae.map(async N=>{const q=I.URI.revive(N.fileUri);if(!q){le.info("Cannot resolve the path because it is not valid.",N);return}if(!await J.canHandleResource(q)){le.info("Cannot resolve the path because it cannot be handled",N);return}let Se=N.exists,be=N.type;if(typeof Se!="boolean"||typeof be!="number")try{be=(await J.stat(q)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Se=!0}catch(ye){le.error(ye),Se=!1}if(!Se&&N.openOnlyIfExists){le.info("Cannot resolve the path because it does not exist",N);return}if(be===y.FileType.Directory){le.info("Cannot resolve the path because it is a directory",N);return}const Ee={...N.options,pinned:!0};return Se?{resource:q,options:Ee}:{resource:q,options:Ee,forceUntitled:!0}}))}e.pathsToEditors=_e;var Ae;(function(ae){ae[ae.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ae[ae.SEQUENTIAL=1]="SEQUENTIAL"})(Ae||(e.EditorsOrder=Ae={}));function Y(ae){const J=ae;if(!J)return!1;const le=J;if(le.modified)return Y(le.modified);const N=J;return!!(N.contributionsState&&N.viewState&&Array.isArray(N.cursorState))}e.isTextEditorViewState=Y;function he(ae){return(0,P.isErrorWithActions)(ae)}e.isEditorOpenError=he;function ke(ae,J,le){const N=(0,P.createErrorWithActions)(ae,J);return N.forceMessage=le?.forceMessage,N.forceSeverity=le?.forceSeverity,N.allowDialog=le?.allowDialog,N}e.createEditorOpenError=ke}),define(Pe[193],Te([1,0,5,161,4,6,28,30,18,100,24,89,184]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,l.registerIcon)("default-view-icon",D.Codicon.window,(0,A.localize)(0,null));var E;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(E||(e.Extensions=E={}));var v;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.ViewContainerLocations=[0,1,2];function d(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=d;class t extends L.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new S.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new S.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,y.flatten)([...this.viewContainers.values()])}registerViewContainer(s,b,p){const w=this.get(s.id);if(w)return w;const _=s;return _.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:_.openCommandActionDescriptor??{id:_.id},(0,T.getOrSet)(this.viewContainers,b,[]).push(_),p?.isDefault&&this.defaultViewContainers.push(_),this._onDidRegister.fire({viewContainer:_,viewContainerLocation:b}),_}deregisterViewContainer(s){for(const b of this.viewContainers.keys()){const p=this.viewContainers.get(b),w=p?.indexOf(s);if(w!==-1){p?.splice(w,1),p.length===0&&this.viewContainers.delete(b),this._onDidDeregister.fire({viewContainer:s,viewContainerLocation:b});return}}}get(s){return this.all.filter(b=>b.id===s)[0]}getViewContainers(s){return[...this.viewContainers.get(s)||[]]}getViewContainerLocation(s){return[...this.viewContainers.keys()].filter(b=>this.getViewContainers(b).filter(p=>p?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.defaultViewContainers.find(b=>this.getViewContainerLocation(b)===s)}}h.Registry.add(E.ViewContainersRegistry,new t);var i;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(i||(e.ViewContentGroups=i={}));function c(r,s){const b=r.group??i.More,p=s.group??i.More;return b!==p?b.localeCompare(p):(r.order??5)-(s.order??5)}class f extends L.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new S.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new S.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new S.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new S.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new m.SetMap}registerViews(s,b){this.registerViews2([{views:s,viewContainer:b}])}registerViews2(s){s.forEach(({views:b,viewContainer:p})=>this.addViews(b,p)),this._onViewsRegistered.fire(s)}deregisterViews(s,b){const p=this.removeViews(s,b);p.length&&this._onViewsDeregistered.fire({views:p,viewContainer:b})}moveViews(s,b){for(const p of this._views.keys())if(p!==b){const w=this.removeViews(s,p);w.length&&(this.addViews(w,b),this._onDidChangeContainer.fire({views:w,from:p,to:b}))}}getViews(s){return this._views.get(s)||[]}getView(s){for(const b of this._viewContainers){const p=(this._views.get(b)||[]).filter(w=>w.id===s)[0];if(p)return p}return null}getViewContainer(s){for(const b of this._viewContainers)if((this._views.get(b)||[]).filter(w=>w.id===s)[0])return b;return null}registerViewWelcomeContent(s,b){return this._viewWelcomeContents.add(s,b),this._onDidChangeViewWelcomeContent.fire(s),(0,L.toDisposable)(()=>{this._viewWelcomeContents.delete(s,b),this._onDidChangeViewWelcomeContent.fire(s)})}registerViewWelcomeContent2(s,b){const p=new Map;for(const[w,_]of b)this._viewWelcomeContents.add(s,_),p.set(w,(0,L.toDisposable)(()=>{this._viewWelcomeContents.delete(s,_),this._onDidChangeViewWelcomeContent.fire(s)}));return this._onDidChangeViewWelcomeContent.fire(s),p}getViewWelcomeContent(s){const b=[];return this._viewWelcomeContents.forEach(s,p=>b.push(p)),b.sort(c)}addViews(s,b){let p=this._views.get(b);p||(p=[],this._views.set(b,p),this._viewContainers.push(b));for(const w of s){if(this.getView(w.id)!==null)throw new Error((0,A.localize)(1,null,w.id));p.push(w)}}removeViews(s,b){const p=this._views.get(b);if(!p)return[];const w=[],_=[];for(const o of p)s.includes(o)?w.push(o):_.push(o);return w.length&&(_.length?this._views.set(b,_):(this._views.delete(b),this._viewContainers.splice(this._viewContainers.indexOf(b),1))),w}}h.Registry.add(E.ViewsRegistry,new f),e.IViewsService=(0,I.createDecorator)("viewsService"),e.IViewDescriptorService=(0,I.createDecorator)("viewDescriptorService");var C;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(C||(e.ViewVisibilityState=C={}));var k;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(k||(e.TreeItemCollapsibleState=k={}));class n{constructor(s,b){this.resolved=!1,this._hasResolve=!1,(0,P.mixin)(this,s),this._hasResolve=!!b,this.resolve=async p=>{if(b&&!this.resolved){const w=await b(p);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}p.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n;class a extends Error{constructor(s){super((0,A.localize)(2,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.NoTreeViewError=a}),define(Pe[194],Te([1,0,5,13,162]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new S.Emitter,this._onExit=new S.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(h){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=h}onEvent(h){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=h}onRequest(h){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=h}sendResponse(h){h.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${h.command}`)):this.internalSend("response",h)}sendRequest(h,y,m,P){const D={command:h};if(y&&Object.keys(y).length>0&&(D.arguments=y),this.internalSend("request",D),typeof P=="number"){const l=setTimeout(()=>{clearTimeout(l);const E=this.pendingRequests.get(D.seq);if(E){this.pendingRequests.delete(D.seq);const v={type:"response",seq:0,request_seq:D.seq,success:!1,command:h,message:(0,I.localize)(0,null,P,h)};E(v)}},P)}return m&&this.pendingRequests.set(D.seq,m),D.seq}acceptMessage(h){this.messageCallback?this.messageCallback(h):(this.queue.push(h),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(h,y){return h.type!=="event"||y.type!=="event"}async processQueue(){let h;for(;this.queue.length;){if((!h||this.needsTaskBoundaryBetween(this.queue[0],h))&&await(0,A.timeout)(0),h=this.queue.shift(),!h)return;switch(h.type){case"event":this.eventCallback?.(h);break;case"request":this.requestCallback?.(h);break;case"response":{const y=h,m=this.pendingRequests.get(y.request_seq);m&&(this.pendingRequests.delete(y.request_seq),m(y));break}}}}internalSend(h,y){y.type=h,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const h=new Map;this.pendingRequests.forEach((y,m)=>h.set(m,y)),await(0,A.timeout)(500),h.forEach((y,m)=>{y({type:"response",seq:0,request_seq:m,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(m)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=L}),define(Pe[195],Te([1,0,163,32,4]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new A.RawContextKey("debugType",void 0,{type:"string",description:S.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new A.RawContextKey("debugConfigurationType",void 0,{type:"string",description:S.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new A.RawContextKey("debugState","inactive",{type:"string",description:S.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new A.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:S.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new A.RawContextKey("hasDebugged",!1,{type:"boolean",description:S.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new A.RawContextKey("inDebugMode",!1,{type:"boolean",description:S.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new A.RawContextKey("inDebugRepl",!1,{type:"boolean",description:S.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new A.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:S.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new A.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:S.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new A.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:S.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new A.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:S.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new A.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:S.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new A.RawContextKey("variablesFocused",!0,{type:"boolean",description:S.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new A.RawContextKey("expressionSelected",!1,{type:"boolean",description:S.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new A.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:S.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new A.RawContextKey("callStackItemType",void 0,{type:"string",description:S.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new A.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:S.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new A.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:S.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new A.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:S.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new A.RawContextKey("watchItemType",void 0,{type:"string",description:S.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new A.RawContextKey("canViewMemory",void 0,{type:"boolean",description:S.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new A.RawContextKey("breakpointItemType",void 0,{type:"string",description:S.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new A.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:S.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new A.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:S.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new A.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:S.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new A.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:S.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new A.RawContextKey("stepBackSupported",!1,{type:"boolean",description:S.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new A.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:S.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new A.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:S.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new A.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:S.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new A.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:S.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new A.RawContextKey("breakpointsExist",!1,{type:"boolean",description:S.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new A.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:S.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new A.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:S.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new A.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:S.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new A.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:S.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new A.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:S.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new A.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:S.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new A.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:S.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new A.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:S.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new A.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:S.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new A.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:S.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new A.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:S.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new A.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:S.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new A.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:S.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new A.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:S.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new A.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:S.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new A.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:S.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new A.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:S.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new A.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:S.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new A.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:S.localize(50,null)});const L=l=>S.localize(51,null,l);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:S.localize(52,null)};var T;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(T||(e.State=T={}));function h(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=h;var y;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var m;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var P;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.IDebugService=(0,I.createDecorator)("debugService");var D;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Pe[196],Te([1,0,15,2,19,24,12,44,21,18]),function(ve,e,S,A,I,L,T,h,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function D(w,_,o){return w.replace(P,function(u,g){return _&&g.length>0&&g[0]!=="_"?u:o&&o.hasOwnProperty(g)?o[g]:u})}e.formatPII=D;function l(w){const _={};for(const o of Object.keys(w))o.startsWith("!")||(_[o]=w[o]);return _}e.filterExceptionsFromTelemetry=l;function E(w){return w.configuration.request==="attach"&&!v(w)&&(!w.parentSession||E(w.parentSession))}e.isSessionAttach=E;function v(w){let _=w.configuration.type;if(_)return _==="vslsShare"&&(_=w.configuration.adapterProxy.configuration.type),(0,S.equalsIgnoreCase)(_,"extensionhost")||(0,S.equalsIgnoreCase)(_,"pwa-extensionhost")?w:w.parentSession?v(w.parentSession):void 0}e.getExtensionHostDebugSession=v;function d(w){return w.type&&(w.label||w.program||w.runtime)}e.isDebuggerMainContribution=d;function t(w,_,o){let u,g=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=O.exec(w);){const H=z.index+1,B=H+z[0].length;if(H<=_&&B>=o){u=z[0],g=H;break}}if(u){const H=/\w+/g;let B=null;for(;(B=H.exec(u))&&!(B.index+1+g+B[0].length>=o););B&&(u=u.substring(0,H.lastIndex))}return u?{start:g,end:g+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function i(w,_,o,u){if(w.evaluatableExpressionProvider.has(_)){const g=w.evaluatableExpressionProvider.ordered(_),O=(0,m.coalesce)(await Promise.all(g.map(async z=>{try{return await z.provideEvaluatableExpression(_,o,u??y.CancellationToken.None)}catch{return}})));if(O.length>0){let z=O[0].expression;const H=O[0].range;return z||(z=_.getLineContent(o.lineNumber).substring(H.startColumn-1,H.endColumn-1)),{range:H,matchingExpression:z}}}else{const g=_.getLineContent(o.lineNumber),{start:O,end:z}=t(g,o.column,o.column),H=g.substring(O-1,z);return{matchingExpression:H,range:new h.Range(o.lineNumber,O,o.lineNumber,O+H.length)}}return null}e.getEvaluatableExpressionAtPosition=i;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(w){return!!(w&&w.match(c))}e.isUri=f;function C(w){if(typeof w.path=="string"&&!(typeof w.sourceReference=="number"&&w.sourceReference>0)){if(f(w.path))return A.URI.parse(w.path);if((0,I.isAbsolute)(w.path))return A.URI.file(w.path)}return w.path}function k(w){if(typeof w.path=="object"){const _=A.URI.revive(w.path);if(_)return _.scheme===T.Schemas.file?_.fsPath:_.toString()}return w.path}function n(w,_){const o=_?C:k,u=(0,L.deepClone)(w);return r(u,(g,O)=>{g&&O&&(O.path=o(O))}),u}e.convertToDAPaths=n;function a(w,_){const o=_?C:k,u=(0,L.deepClone)(w);return r(u,(g,O)=>{!g&&O&&(O.path=o(O))}),u}e.convertToVSCPaths=a;function r(w,_){switch(w.type){case"event":{const o=w;switch(o.event){case"output":_(!1,o.body.source);break;case"loadedSource":_(!1,o.body.source);break;case"breakpoint":_(!1,o.body.breakpoint.source);break;default:break}break}case"request":{const o=w;switch(o.command){case"setBreakpoints":_(!0,o.arguments.source);break;case"breakpointLocations":_(!0,o.arguments.source);break;case"source":_(!0,o.arguments.source);break;case"gotoTargets":_(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(u=>_(!1,u));break;default:break}break}case"response":{const o=w;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(u=>_(!1,u.source));break;case"loadedSources":o.body.sources.forEach(u=>_(!1,u));break;case"scopes":o.body.scopes.forEach(u=>_(!1,u.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(u=>_(!1,u.source));break;case"setBreakpoints":o.body.breakpoints.forEach(u=>_(!1,u.source));break;case"disassemble":o.body?.instructions.forEach(g=>_(!1,g.location));break;default:break}break}}}function s(w){return w.filter(_=>!_.presentation?.hidden).sort((_,o)=>_.presentation?o.presentation?_.presentation.group?o.presentation.group?_.presentation.group!==o.presentation.group?_.presentation.group.localeCompare(o.presentation.group):b(_.presentation.order,o.presentation.order):-1:o.presentation.group?1:b(_.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=s;function b(w,_){return typeof w!="number"?typeof _!="number"?0:1:typeof _!="number"?-1:w-_}async function p(w,_){const o=w.getValue("debug.saveBeforeStart",{overrideIdentifier:_.activeTextEditorLanguageId});if(o!=="none"&&(await _.saveAll(),o==="allEditorsInActiveGroup")){const u=_.activeEditorPane;u&&u.input.resource?.scheme===T.Schemas.untitled&&await _.save({editor:u.input,groupId:u.group.id})}await w.reloadConfiguration()}e.saveAllBeforeDebugStart=p}),define(Pe[75],Te([1,0,25,37,67,68,12,19,22,32]),function(ve,e,S,A,I,L,T,h,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var P;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(P||(e.CellKind=P={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var l;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var E;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(E||(e.NotebookExecutionState=E={}));var v;(function(M){M[M.WithHardKernelDependency=0]="WithHardKernelDependency",M[M.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",M[M.Pure=2]="Pure",M[M.Never=3]="Never"})(v||(e.NotebookRendererMatch=v={}));var d;(function(M){M.Always="always",M.Never="never",M.Optional="optional"})(d||(e.RendererMessagingSpec=d={}));var t;(function(M){M[M.ModelChange=1]="ModelChange",M[M.Move=2]="Move",M[M.ChangeCellLanguage=5]="ChangeCellLanguage",M[M.Initialize=6]="Initialize",M[M.ChangeCellMetadata=7]="ChangeCellMetadata",M[M.Output=8]="Output",M[M.OutputItem=9]="OutputItem",M[M.ChangeCellContent=10]="ChangeCellContent",M[M.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",M[M.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",M[M.ChangeCellMime=13]="ChangeCellMime",M[M.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(M){M[M.Handle=0]="Handle",M[M.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var c;(function(M){M[M.Replace=1]="Replace",M[M.Output=2]="Output",M[M.Metadata=3]="Metadata",M[M.CellLanguage=4]="CellLanguage",M[M.DocumentMetadata=5]="DocumentMetadata",M[M.Move=6]="Move",M[M.OutputItems=7]="OutputItems",M[M.PartialMetadata=8]="PartialMetadata",M[M.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var f;(function(M){M.scheme=T.Schemas.vscodeNotebookCell;const ne=["W","X","Y","Z","a","b","c","d","e","f"],Q=new RegExp(`^[${ne.join("")}]+`),we=7;function _e(J,le){const N=le.toString(we),ue=`${N.length<ne.length?ne[N.length-1]:"z"}${N}s${(0,S.encodeBase64)(S.VSBuffer.fromString(J.scheme),!0,!0)}`;return J.with({scheme:M.scheme,fragment:ue})}M.generate=_e;function Ae(J){if(J.scheme!==M.scheme)return;const le=J.fragment.indexOf("s");if(le<0)return;const N=parseInt(J.fragment.substring(0,le).replace(Q,""),we),q=(0,S.decodeBase64)(J.fragment.substring(le+1)).toString();if(!isNaN(N))return{handle:N,notebook:J.with({scheme:q,fragment:null})}}M.parse=Ae;function Y(J,le){return J.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${le??""},${J.scheme!==T.Schemas.file?J.scheme:""}`})}M.generateCellOutputUri=Y;function he(J){if(J.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const le=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(J.fragment);if(!le)return;const N=le[1]&&le[1]!==""?le[1]:void 0,q=le[2];return{outputId:N,notebook:J.with({scheme:q||T.Schemas.file,fragment:null})}}M.parseCellOutputUri=he;function ke(J,le,N){return M.generate(J,le).with({scheme:N})}M.generateCellPropertyUri=ke;function ae(J,le){if(J.scheme===le)return M.parse(J.with({scheme:M.scheme}))}M.parseCellPropertyUri=ae})(f||(e.CellUri=f={}));const C=M=>y.isWindows?M.replace(/\//g,"\\"):M;class k{constructor(ne=[],Q=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=Q,this.order=[...new Set(ne)].map(we=>({pattern:we,matches:A.parse(C(we))}))}sort(ne){const Q=new Map(I.Iterable.map(ne,_e=>[_e,C(_e)]));let we=[];for(const{matches:_e}of this.order)for(const[Ae,Y]of Q)if(_e(Y)){we.push(Ae),Q.delete(Ae);break}return Q.size&&(we=we.concat([...Q.keys()].sort((_e,Ae)=>this.defaultOrder.indexOf(_e)-this.defaultOrder.indexOf(Ae)))),we}prioritize(ne,Q){const we=this.findIndex(ne);if(we===-1){this.order.unshift({pattern:ne,matches:A.parse(C(ne))});return}const _e=new Set(Q.map(Y=>this.findIndex(Y,we)));_e.delete(-1);const Ae=Array.from(_e).sort();this.order.splice(we+1,0,...Ae.map(Y=>this.order[Y]));for(let Y=Ae.length-1;Y>=0;Y--)this.order.splice(Ae[Y],1)}toArray(){return this.order.map(ne=>ne.pattern)}findIndex(ne,Q=this.order.length){const we=C(ne);for(let _e=0;_e<Q;_e++)if(this.order[_e].matches(we))return _e;return-1}}e.MimeTypeDisplayOrder=k;function n(M,ne,Q,we=(_e,Ae)=>_e===Ae){const _e=[];function Ae(ke,ae,J){if(ae===0&&J.length===0)return;const le=_e[_e.length-1];le&&le.start+le.deleteCount===ke?(le.deleteCount+=ae,le.toInsert.push(...J)):_e.push({start:ke,deleteCount:ae,toInsert:J})}let Y=0,he=0;for(;;){if(Y===M.length){Ae(Y,0,ne.slice(he));break}if(he===ne.length){Ae(Y,M.length-Y,[]);break}const ke=M[Y],ae=ne[he];if(we(ke,ae)){Y+=1,he+=1;continue}Q(ae)?(Ae(Y,1,[]),Y+=1):(Ae(Y,0,[ae]),he+=1)}return _e}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtLineBoundary","none");var a;(function(M){M.default="default",M.option="option"})(a||(e.NotebookEditorPriority=a={}));function r(M){const ne=M;return!!((typeof ne.include=="string"||A.isRelativePattern(ne.include))&&(typeof ne.exclude=="string"||A.isRelativePattern(ne.exclude)))}e.isDocumentExcludePattern=r;function s(M,ne,Q){if(Array.isArray(M.viewType)&&M.viewType.indexOf(ne)>=0||M.viewType===ne)return!0;if(M.filenamePattern){const we=r(M.filenamePattern)?M.filenamePattern.include:M.filenamePattern,_e=r(M.filenamePattern)?M.filenamePattern.exclude:void 0;if(A.match(we,(0,h.basename)(Q.fsPath).toLowerCase()))return!(_e&&A.match(_e,(0,h.basename)(Q.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var b;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(b||(e.CellStatusbarAlignment=b={}));class p{static{this._prefix="notebook/"}static create(ne){return`${p._prefix}${ne}`}static parse(ne){if(ne.startsWith(p._prefix))return ne.substring(p._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=p;function w(M){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(M)}e.isTextStreamMime=w;const _=new TextDecoder;function o(M){const ne=[];let Q=!1;for(const Y of M)(ne.length===0||Q)&&(ne.push(Y),Q=!0);let we=O(ne);const _e=S.VSBuffer.concat(ne.map(Y=>S.VSBuffer.wrap(Y))),Ae=x(_e);return we=we||Ae.byteLength!==_e.byteLength,{data:Ae,didCompression:we}}e.compressOutputItemStreams=o,e.MOVE_CURSOR_1_LINE_COMMAND=`${String.fromCharCode(27)}[A`;const u=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(M=>M.charCodeAt(0)),g=10;function O(M){let ne=!1;return M.forEach((Q,we)=>{if(we===0||Q.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const _e=M[we-1],Ae=Q.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(Ae[0]===u[0]&&Ae[1]===u[1]&&Ae[2]===u[2]){const Y=_e.lastIndexOf(g);if(Y===-1)return;ne=!0,M[we-1]=_e.subarray(0,Y),M[we]=Q.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),ne}function z(M){let ne=M;do M=ne,ne=M.replace(/[^\n]\x08/gm,"");while(ne.length<M.length);return M}function H(M){for(M=M.replace(/\r+\n/gm,`
`);M.search(/\r[^$]/g)>-1;){const ne=M.match(/^(.*)\r+/m)[1];let Q=M.match(/\r+(.*)$/m)[1];Q=Q+ne.slice(Q.length,ne.length),M=M.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Q)}return M}const B="\b".charCodeAt(0),$="\r".charCodeAt(0);function x(M){return!M.buffer.includes(B)&&!M.buffer.includes($)?M:S.VSBuffer.fromString(H(z(_.decode(M.buffer))))}}),define(Pe[7],Te([1,0,18,9,49,28,68,15,16,2,36,20,38,97,75]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v){"use strict";var d,t,i,c,f,C,k,n,a,r,s,b,p,w,_,o,u,g;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.ChatMessage=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.NotebookCodeActionKind=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(U){return Object.assign(U,{apply:function(){const se=arguments.length===1?[]:arguments[1];return Reflect.construct(U,se,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(U,[]);{const[se,...De]=arguments;return Reflect.construct(U,De,se.constructor)}}})}var z;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(z||(e.TerminalOutputAnchor=z={}));var H;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(H||(e.TerminalQuickFixType=H={}));let B=d=class{static from(...F){let se=F;return new d(function(){if(se){for(const De of se)De&&typeof De.dispose=="function"&&De.dispose();se=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=B,e.Disposable=B=d=Ve([O],B);let $=t=class{static Min(...F){if(F.length===0)throw new TypeError;let se=F[0];for(let De=1;De<F.length;De++){const qe=F[De];qe.isBefore(se)&&(se=qe)}return se}static Max(...F){if(F.length===0)throw new TypeError;let se=F[0];for(let De=1;De<F.length;De++){const qe=F[De];qe.isAfter(se)&&(se=qe)}return se}static isPosition(F){if(!F)return!1;if(F instanceof t)return!0;const{line:se,character:De}=F;return typeof se=="number"&&typeof De=="number"}static of(F){if(F instanceof t)return F;if(this.isPosition(F))return new t(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(F,se){if(F<0)throw(0,A.illegalArgument)("line must be non-negative");if(se<0)throw(0,A.illegalArgument)("character must be non-negative");this._line=F,this._character=se}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,se=0){if(F===null||se===null)throw(0,A.illegalArgument)();let De;return typeof F>"u"?De=0:typeof F=="number"?De=F:(De=typeof F.lineDelta=="number"?F.lineDelta:0,se=typeof F.characterDelta=="number"?F.characterDelta:0),De===0&&se===0?this:new t(this.line+De,this.character+se)}with(F,se=this.character){if(F===null||se===null)throw(0,A.illegalArgument)();let De;return typeof F>"u"?De=this.line:typeof F=="number"?De=F:(De=typeof F.line=="number"?F.line:this.line,se=typeof F.character=="number"?F.character:this.character),De===this.line&&se===this.character?this:new t(De,se)}toJSON(){return{line:this.line,character:this.character}}};e.Position=$,e.Position=$=t=Ve([O],$);let x=i=class{static isRange(F){return F instanceof i?!0:F?$.isPosition(F.start)&&$.isPosition(F.end):!1}static of(F){if(F instanceof i)return F;if(this.isRange(F))return new i(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(F,se,De,qe){let Qe,ot;if(typeof F=="number"&&typeof se=="number"&&typeof De=="number"&&typeof qe=="number"?(Qe=new $(F,se),ot=new $(De,qe)):$.isPosition(F)&&$.isPosition(se)&&(Qe=$.of(F),ot=$.of(se)),!Qe||!ot)throw new Error("Invalid arguments");Qe.isBefore(ot)?(this._start=Qe,this._end=ot):(this._start=ot,this._end=Qe)}contains(F){return i.isRange(F)?this.contains(F.start)&&this.contains(F.end):$.isPosition(F)?!($.of(F).isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const se=$.Max(F.start,this._start),De=$.Min(F.end,this._end);if(!se.isAfter(De))return new i(se,De)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const se=$.Min(F.start,this._start),De=$.Max(F.end,this.end);return new i(se,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,se=this.end){if(F===null||se===null)throw(0,A.illegalArgument)();let De;return F?$.isPosition(F)?De=F:(De=F.start||this.start,se=F.end||this.end):De=this.start,De.isEqual(this._start)&&se.isEqual(this.end)?this:new i(De,se)}toJSON(){return[this.start,this.end]}};e.Range=x,e.Range=x=i=Ve([O],x);let M=c=class extends x{static isSelection(F){return F instanceof c?!0:F?x.isRange(F)&&$.isPosition(F.anchor)&&$.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(F,se,De,qe){let Qe,ot;if(typeof F=="number"&&typeof se=="number"&&typeof De=="number"&&typeof qe=="number"?(Qe=new $(F,se),ot=new $(De,qe)):$.isPosition(F)&&$.isPosition(se)&&(Qe=$.of(F),ot=$.of(se)),!Qe||!ot)throw new Error("Invalid arguments");super(Qe,ot),this._anchor=Qe,this._active=ot}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=M,e.Selection=M=c=Ve([O],M);const ne=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,A.illegalArgument)("connectionToken")};class Q{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,se,De){if(typeof F!="string"||F.length===0)throw(0,A.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,A.illegalArgument)("port");typeof De<"u"&&ne(De),this.host=F,this.port=Math.round(se),this.connectionToken=De}}e.ResolvedAuthority=Q;class we{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,se){this.makeConnection=F,this.connectionToken=se,typeof se<"u"&&ne(se)}}e.ManagedResolvedAuthority=we;class _e extends Error{static NotAvailable(F,se){return new _e(F,E.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(F){return new _e(F,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,se=E.RemoteAuthorityResolverErrorCode.Unknown,De){super(F),this._message=F,this._code=se,this._detail=De,Object.setPrototypeOf(this,_e.prototype)}}e.RemoteAuthorityResolverError=_e;var Ae;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(Ae||(e.EndOfLine=Ae={}));var Y;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(Y||(e.EnvironmentVariableMutatorType=Y={}));let he=f=class{static isTextEdit(F){return F instanceof f?!0:F?x.isRange(F)&&typeof F.newText=="string":!1}static replace(F,se){return new f(F,se)}static insert(F,se){return f.replace(new x(F,F),se)}static delete(F){return f.replace(F,"")}static setEndOfLine(F){const se=new f(new x(new $(0,0),new $(0,0)),"");return se.newEol=F,se}get range(){return this._range}set range(F){if(F&&!x.isRange(F))throw(0,A.illegalArgument)("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw(0,A.illegalArgument)("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw(0,A.illegalArgument)("newEol");this._newEol=F}constructor(F,se){this._range=F,this._newText=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=he,e.TextEdit=he=f=Ve([O],he);let ke=C=class{static isNotebookCellEdit(F){return F instanceof C?!0:F?Yt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,se){return new C(F,se)}static insertCells(F,se){return new C(new Yt(F,F),se)}static deleteCells(F){return new C(F,[])}static updateCellMetadata(F,se){const De=new C(new Yt(F,F),[]);return De.newCellMetadata=se,De}static updateNotebookMetadata(F){const se=new C(new Yt(0,0),[]);return se.newNotebookMetadata=F,se}constructor(F,se){this.range=F,this.newCells=se}};e.NotebookEdit=ke,e.NotebookEdit=ke=C=Ve([O],ke);class ae{static isSnippetTextEdit(F){return F instanceof ae?!0:F?x.isRange(F.range)&&N.isSnippetString(F.snippet):!1}static replace(F,se){return new ae(F,se)}static insert(F,se){return ae.replace(new x(F,F),se)}constructor(F,se){this.range=F,this.snippet=se}}e.SnippetTextEdit=ae;var J;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(J||(e.FileEditType=J={}));let le=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,se,De,qe){this._edits.push({_type:1,from:F,to:se,options:De,metadata:qe})}createFile(F,se,De){this._edits.push({_type:1,from:void 0,to:F,options:se,metadata:De})}deleteFile(F,se,De){this._edits.push({_type:1,from:F,to:void 0,options:se,metadata:De})}replaceNotebookMetadata(F,se,De){this._edits.push({_type:3,metadata:De,uri:F,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(F,se,De,qe){const Qe=se.start,ot=se.end;(Qe!==ot||De.length>0)&&this._edits.push({_type:5,uri:F,index:Qe,count:ot-Qe,cells:De,metadata:qe})}replaceNotebookCellMetadata(F,se,De,qe){this._edits.push({_type:3,metadata:qe,uri:F,edit:{editType:3,index:se,metadata:De}})}replace(F,se,De,qe){this._edits.push({_type:2,uri:F,edit:new he(se,De),metadata:qe})}insert(F,se,De,qe){this.replace(F,new x(se,se),De,qe)}delete(F,se,De){this.replace(F,se,"",De)}has(F){return this._edits.some(se=>se._type===2&&se.uri.toString()===F.toString())}set(F,se){if(se)for(const De of se){if(!De)continue;let qe,Qe;Array.isArray(De)?(qe=De[0],Qe=De[1]):qe=De,ke.isNotebookCellEdit(qe)?qe.newCellMetadata?this.replaceNotebookCellMetadata(F,qe.range.start,qe.newCellMetadata,Qe):qe.newNotebookMetadata?this.replaceNotebookMetadata(F,qe.newNotebookMetadata,Qe):this.replaceNotebookCells(F,qe.range,qe.newCells,Qe):ae.isSnippetTextEdit(qe)?this._edits.push({_type:6,uri:F,range:qe.range,edit:qe.snippet,metadata:Qe}):this._edits.push({_type:2,uri:F,edit:qe,metadata:Qe})}else{for(let De=0;De<this._edits.length;De++){const qe=this._edits[De];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===F.toString()&&(this._edits[De]=void 0);break}}(0,S.coalesceInPlace)(this._edits)}}get(F){const se=[];for(const De of this._edits)De._type===2&&De.uri.toString()===F.toString()&&se.push(De.edit);return se}entries(){const F=new L.ResourceMap;for(const se of this._edits)if(se._type===2){let De=F.get(se.uri);De||(De=[se.uri,[]],F.set(se.uri,De)),De[1].push(se.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=le,e.WorkspaceEdit=le=Ve([O],le);let N=k=class{static isSnippetString(F){return F instanceof k?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this._tabstop=1,this.value=F||""}appendText(F){return this.value+=k._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,se=this._tabstop++){if(typeof F=="function"){const De=new k;De._tabstop=this._tabstop,F(De),this._tabstop=De._tabstop,F=De.value}else F=k._escape(F);return this.value+="${",this.value+=se,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,se=this._tabstop++){const De=F.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(F,se){if(typeof se=="function"){const De=new k;De._tabstop=this._tabstop,se(De),this._tabstop=De._tabstop,se=De.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.SnippetString=N,e.SnippetString=N=k=Ve([O],N);var q;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var ue;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ue||(e.DiagnosticSeverity=ue={}));let Se=n=class{static isLocation(F){return F instanceof n?!0:F?x.isRange(F.range)&&m.URI.isUri(F.uri):!1}constructor(F,se){if(this.uri=F,se)if(x.isRange(se))this.range=x.of(se);else if($.isPosition(se))this.range=new x(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Se,e.Location=Se=n=Ve([O],Se);let be=class{static is(F){return F?typeof F.message=="string"&&F.location&&x.isRange(F.location.range)&&m.URI.isUri(F.location.uri):!1}constructor(F,se){this.location=F,this.message=se}static isEqual(F,se){return F===se?!0:!F||!se?!1:F.message===se.message&&F.location.range.isEqual(se.location.range)&&F.location.uri.toString()===se.location.uri.toString()}};e.DiagnosticRelatedInformation=be,e.DiagnosticRelatedInformation=be=Ve([O],be);let Ee=class{constructor(F,se,De=ue.Error){if(!x.isRange(F))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=F,this.message=se,this.severity=De}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,se){return F===se?!0:!F||!se?!1:F.message===se.message&&F.severity===se.severity&&F.code===se.code&&F.severity===se.severity&&F.source===se.source&&F.range.isEqual(se.range)&&(0,S.equals)(F.tags,se.tags)&&(0,S.equals)(F.relatedInformation,se.relatedInformation,be.isEqual)}};e.Diagnostic=Ee,e.Diagnostic=Ee=Ve([O],Ee);let ye=class{constructor(F,se){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=se}};e.Hover=ye,e.Hover=ye=Ve([O],ye);var oe;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let de=class{constructor(F,se=oe.Text){this.range=F,this.kind=se}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.DocumentHighlight=de,e.DocumentHighlight=de=Ve([O],de);var re;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(re||(e.SymbolKind=re={}));var ie;(function(U){U[U.Deprecated=1]="Deprecated"})(ie||(e.SymbolTag=ie={}));let me=a=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,se,De,qe,Qe){this.name=F,this.kind=se,this.containerName=Qe,typeof De=="string"&&(this.containerName=De),qe instanceof Se?this.location=qe:De instanceof x&&(this.location=new Se(qe,De)),a.validate(this)}toJSON(){return{name:this.name,kind:re[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=me,e.SymbolInformation=me=a=Ve([O],me);let Ce=r=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(r.validate)}constructor(F,se,De,qe,Qe){this.name=F,this.detail=se,this.kind=De,this.range=qe,this.selectionRange=Qe,this.children=[],r.validate(this)}};e.DocumentSymbol=Ce,e.DocumentSymbol=Ce=r=Ve([O],Ce);var R;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(R||(e.CodeActionTriggerKind=R={}));let W=class{constructor(F,se){this.title=F,this.kind=se}};e.CodeAction=W,e.CodeAction=W=Ve([O],W);let K=class{static{s=this}static{this.sep="."}constructor(F){this.value=F}append(F){return new s(this.value?this.value+s.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+s.sep)}};e.CodeActionKind=K,e.CodeActionKind=K=s=Ve([O],K);class G extends K{constructor(F){super(F),this.value=F}}e.NotebookCodeActionKind=G,K.Empty=new K(""),K.QuickFix=K.Empty.append("quickfix"),K.Refactor=K.Empty.append("refactor"),K.RefactorExtract=K.Refactor.append("extract"),K.RefactorInline=K.Refactor.append("inline"),K.RefactorMove=K.Refactor.append("move"),K.RefactorRewrite=K.Refactor.append("rewrite"),K.Source=K.Empty.append("source"),K.SourceOrganizeImports=K.Source.append("organizeImports"),K.SourceFixAll=K.Source.append("fixAll"),K.Notebook=K.Empty.append("notebook");let V=class{constructor(F,se){if(this.range=F,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=V,e.SelectionRange=V=Ve([O],V);class ee{constructor(F,se,De,qe,Qe,ot){this.kind=F,this.name=se,this.detail=De,this.uri=qe,this.range=Qe,this.selectionRange=ot}}e.CallHierarchyItem=ee;class ce{constructor(F,se){this.fromRanges=se,this.from=F}}e.CallHierarchyIncomingCall=ce;class Me{constructor(F,se){this.fromRanges=se,this.to=F}}e.CallHierarchyOutgoingCall=Me;var xe;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(xe||(e.LanguageStatusSeverity=xe={}));let Ge=class{constructor(F,se){this.range=F,this.command=se}get isResolved(){return!!this.command}};e.CodeLens=Ge,e.CodeLens=Ge=Ve([O],Ge);let je=b=class{#e;static isMarkdownString(F){return F instanceof b?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,se=!1){this.#e=new I.MarkdownString(F,{supportThemeIcons:se})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,se){return this.#e.appendCodeblock(se??"",F),this}};e.MarkdownString=je,e.MarkdownString=je=b=Ve([O],je);let et=class{constructor(F,se){this.label=F,this.documentation=se}};e.ParameterInformation=et,e.ParameterInformation=et=Ve([O],et);let Ye=class{constructor(F,se){this.label=F,this.documentation=se,this.parameters=[]}};e.SignatureInformation=Ye,e.SignatureInformation=Ye=Ve([O],Ye);let Ze=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Ze,e.SignatureHelp=Ze=Ve([O],Ze);var it;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var tt;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let Ue=class{constructor(F){this.value=F}};e.InlayHintLabelPart=Ue,e.InlayHintLabelPart=Ue=Ve([O],Ue);let st=class{constructor(F,se,De){this.position=F,this.label=se,this.kind=De}};e.InlayHint=st,e.InlayHint=st=Ve([O],st);var Z;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Z||(e.CompletionTriggerKind=Z={}));var X;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(X||(e.CompletionItemKind=X={}));var pe;(function(U){U[U.Deprecated=1]="Deprecated"})(pe||(e.CompletionItemTag=pe={}));let $e=class{constructor(F,se){this.label=F,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&X[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=$e,e.CompletionItem=$e=Ve([O],$e);let Ne=class{constructor(F=[],se=!1){this.items=F,this.isIncomplete=se}};e.CompletionList=Ne,e.CompletionList=Ne=Ve([O],Ne);let Xe=class{constructor(F,se,De){this.insertText=F,this.range=se,this.command=De}};e.InlineSuggestion=Xe,e.InlineSuggestion=Xe=Ve([O],Xe);let nt=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.InlineSuggestionList=nt,e.InlineSuggestionList=nt=Ve([O],nt);var ft;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(ft||(e.ViewColumn=ft={}));var Et;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Et||(e.StatusBarAlignment=Et={}));function Ft(U,F){return`${D.ExtensionIdentifier.toKey(U)}.${F}`}e.asStatusBarItemIdentifier=Ft;var Xt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Xt||(e.TextEditorLineNumbersStyle=Xt={}));var Ht;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Ht||(e.TextDocumentSaveReason=Ht={}));var bt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(bt||(e.TextEditorRevealType=bt={}));var Lt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Lt||(e.TextEditorSelectionChangeKind=Lt={}));var Nt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(Nt||(e.TextDocumentChangeReason=Nt={}));var qt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(qt||(e.DecorationRangeBehavior=qt={})),function(U){function F(se){switch(se){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=F}(Lt||(e.TextEditorSelectionChangeKind=Lt={}));let Tt=class{constructor(F,se){if(se&&!m.URI.isUri(se))throw(0,A.illegalArgument)("target");if(!x.isRange(F)||F.isEmpty)throw(0,A.illegalArgument)("range");this.range=F,this.target=se}};e.DocumentLink=Tt,e.DocumentLink=Tt=Ve([O],Tt);let At=class{constructor(F,se,De,qe){this.red=F,this.green=se,this.blue=De,this.alpha=qe}};e.Color=At,e.Color=At=Ve([O],At);let Ut=class{constructor(F,se){if(se&&!(se instanceof At))throw(0,A.illegalArgument)("color");if(!x.isRange(F)||F.isEmpty)throw(0,A.illegalArgument)("range");this.range=F,this.color=se}};e.ColorInformation=Ut,e.ColorInformation=Ut=Ve([O],Ut);let $t=class{constructor(F){if(!F||typeof F!="string")throw(0,A.illegalArgument)("label");this.label=F}};e.ColorPresentation=$t,e.ColorPresentation=$t=Ve([O],$t);var Wt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Wt||(e.ColorFormat=Wt={}));var Bt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Bt||(e.SourceControlInputBoxValidationType=Bt={}));var at;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(at||(e.TerminalExitReason=at={}));class ut{constructor(F,se,De){if(this.startIndex=F,this.length=se,this.tooltip=De,typeof F!="number"||F<0)throw(0,A.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,A.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=ut;class jt{constructor(F){this.uri=F}}e.TerminalQuickFixOpener=jt;class Pt{constructor(F){this.terminalCommand=F}}e.TerminalQuickFixCommand=Pt;var yt;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(yt||(e.TerminalLocation=yt={}));class ht{constructor(F){if(this.options=F,typeof F!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=ht;var It;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(It||(e.TaskRevealKind=It={}));var Mt;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(Mt||(e.TaskPanelKind=Mt={}));let St=class{static{p=this}static{this.Clean=new p("clean","Clean")}static{this.Build=new p("build","Build")}static{this.Rebuild=new p("rebuild","Rebuild")}static{this.Test=new p("test","Test")}static from(F){switch(F){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}constructor(F,se){if(this.label=se,typeof F!="string"||typeof se!="string")throw(0,A.illegalArgument)("name");this._id=F}get id(){return this._id}};e.TaskGroup=St,e.TaskGroup=St=p=Ve([O],St);function He(U){let F="";for(let se=0;se<U.length;se++)F+=U[se].replace(/,/g,",,")+",";return F}let Ie=class{constructor(F,se,De){if(typeof F!="string")throw(0,A.illegalArgument)("process");this._args=[],this._process=F,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=De):this._options=se)}get process(){return this._process}set process(F){if(typeof F!="string")throw(0,A.illegalArgument)("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(const se of this._args)F.push(se);return He(F)}};e.ProcessExecution=Ie,e.ProcessExecution=Ie=Ve([O],Ie);let Re=class{constructor(F,se,De){if(this._args=[],Array.isArray(se)){if(!F)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,A.illegalArgument)("command");this._command=F,this._args=se,this._options=De}else{if(typeof F!="string")throw(0,A.illegalArgument)("commandLine");this._commandLine=F,this._options=se}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw(0,A.illegalArgument)("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,A.illegalArgument)("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const se of this._args)F.push(typeof se=="string"?se:se.value);return He(F)}};e.ShellExecution=Re,e.ShellExecution=Re=Ve([O],Re);var ge;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ge||(e.ShellQuoting=ge={}));var j;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(j||(e.TaskScope=j={}));class Oe{constructor(F){this._callback=F}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=Oe;let Be=class{static{w=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(F,se,De,qe,Qe,ot){this.__deprecated=!1,this._definition=this.definition=F;let dt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=De,this.execution=qe,dt=Qe,this.__deprecated=!0):se===j.Global||se===j.Workspace?(this.target=se,this._name=this.name=De,this._source=this.source=qe,this.execution=Qe,dt=ot):(this.target=se,this._name=this.name=De,this._source=this.source=qe,this.execution=Qe,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ie?this._definition={type:w.ProcessType,id:this._execution.computeId()}:this._execution instanceof Re?this._definition={type:w.ShellType,id:this._execution.computeId()}:this._execution instanceof Oe?this._definition={type:w.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:w.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(F){if(F==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw(0,A.illegalArgument)("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const se=this._definition.type;(w.EmptyType===se||w.ProcessType===se||w.ShellType===se||w.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};e.Task=Be,e.Task=Be=w=Ve([O],Be);var Ke;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(Ke||(e.ProgressLocation=Ke={}));var We;(function(U){function F(se){const De=se;return(0,y.isNumber)(De.value)?De.tooltip&&!(0,y.isString)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}U.isViewBadge=F})(We||(e.ViewBadge=We={}));let Je=_=class{static isTreeItem(F,se){const De=F;if(De.checkboxState!==void 0){const qe=(0,y.isNumber)(De.checkboxState)?De.checkboxState:(0,y.isObject)(De.checkboxState)&&(0,y.isNumber)(De.checkboxState.state)?De.checkboxState.state:void 0,Qe=!(0,y.isNumber)(De.checkboxState)&&(0,y.isObject)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(qe===void 0||qe!==_t.Checked&&qe!==_t.Unchecked||Qe!==void 0&&!(0,y.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(F instanceof _)return!0;if(De.label!==void 0&&!(0,y.isString)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,y.isString)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,y.isString)(De.iconPath)&&!m.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,y.isString)(De.iconPath.id))){const qe=De.iconPath;if(!qe||!(0,y.isString)(qe.light)&&!m.URI.isUri(qe.light)&&!(0,y.isString)(qe.dark)&&!m.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,y.isString)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!m.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,y.isString)(De.tooltip)&&!(De.tooltip instanceof je)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<pt.None&&De.collapsibleState>pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,y.isString)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(F,se=pt.None){this.collapsibleState=se,m.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.TreeItem=Je,e.TreeItem=Je=_=Ve([O],Je);var pt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(pt||(e.TreeItemCollapsibleState=pt={}));var _t;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(_t||(e.TreeItemCheckboxState=_t={}));let vt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.DataTransferItem=vt,e.DataTransferItem=vt=Ve([O],vt);class ct extends vt{}e.InternalDataTransferItem=ct;class gt extends ct{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.InternalFileDataTransferItem=gt;class Dt{constructor(F,se,De,qe){this.name=F,this.uri=se,this._itemId=De,this._getData=qe}data(){return this._getData()}}e.DataTransferFile=Dt;let mi=class{#e=new Map;constructor(F){for(const[se,De]of F??[]){const qe=this.#e.get(this.#t(se));qe?qe.push(De):this.#e.set(this.#t(se),[De])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,se){this.#e.set(this.#t(F),[se])}forEach(F,se){for(const[De,qe]of this.#e)for(const Qe of qe)F.call(se,Qe,De,this)}*[Symbol.iterator](){for(const[F,se]of this.#e)for(const De of se)yield[F,De]}#t(F){return F.toLowerCase()}};e.DataTransfer=mi,e.DataTransfer=mi=Ve([O],mi);let Vt=class{constructor(F){this.insertText=F}};e.DocumentDropEdit=Vt,e.DocumentDropEdit=Vt=Ve([O],Vt);let _i=class{constructor(F,se){this.label=se,this.insertText=F}};e.DocumentPasteEdit=_i,e.DocumentPasteEdit=_i=Ve([O],_i);let zt=class{constructor(F,se){this.id=F,this.color=se}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.ThemeIcon=zt,e.ThemeIcon=zt=Ve([O],zt),zt.File=new zt("file"),zt.Folder=new zt("folder");let gi=class{constructor(F){this.id=F}};e.ThemeColor=gi,e.ThemeColor=gi=Ve([O],gi);var kt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(kt||(e.ConfigurationTarget=kt={}));let yi=class{get base(){return this._base}set base(F){this._base=F,this._baseUri=m.URI.file(F)}get baseUri(){return this._baseUri}set baseUri(F){this._baseUri=F,this._base=F.fsPath}constructor(F,se){if(typeof F!="string"&&(!F||!m.URI.isUri(F)&&!m.URI.isUri(F.uri)))throw(0,A.illegalArgument)("base");if(typeof se!="string")throw(0,A.illegalArgument)("pattern");typeof F=="string"?this.baseUri=m.URI.file(F):m.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=yi,e.RelativePattern=yi=Ve([O],yi);const Hi=new WeakMap;function Ct(U,F){Hi.set(U,F)}e.setBreakpointId=Ct;let ti=class{constructor(F,se,De,qe){this.enabled=typeof F=="boolean"?F:!0,typeof se=="string"&&(this.condition=se),typeof De=="string"&&(this.hitCondition=De),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=Hi.get(this)??(0,P.generateUuid)()),this._id}};e.Breakpoint=ti,e.Breakpoint=ti=Ve([O],ti);let pi=class extends ti{constructor(F,se,De,qe,Qe){if(super(se,De,qe,Qe),F===null)throw(0,A.illegalArgument)("location");this.location=F}};e.SourceBreakpoint=pi,e.SourceBreakpoint=pi=Ve([O],pi);let si=class extends ti{constructor(F,se,De,qe,Qe){super(se,De,qe,Qe),this.functionName=F}};e.FunctionBreakpoint=si,e.FunctionBreakpoint=si=Ve([O],si);let Di=class extends ti{constructor(F,se,De,qe,Qe,ot,dt){if(super(qe,Qe,ot,dt),!se)throw(0,A.illegalArgument)("dataId");this.label=F,this.dataId=se,this.canPersist=De}};e.DataBreakpoint=Di,e.DataBreakpoint=Di=Ve([O],Di);let Ci=class{constructor(F,se,De){this.command=F,this.args=se||[],this.options=De}};e.DebugAdapterExecutable=Ci,e.DebugAdapterExecutable=Ci=Ve([O],Ci);let Rt=class{constructor(F,se){this.port=F,this.host=se}};e.DebugAdapterServer=Rt,e.DebugAdapterServer=Rt=Ve([O],Rt);let vi=class{constructor(F){this.path=F}};e.DebugAdapterNamedPipeServer=vi,e.DebugAdapterNamedPipeServer=vi=Ve([O],vi);let Ii=class{constructor(F){this.implementation=F}};e.DebugAdapterInlineImplementation=Ii,e.DebugAdapterInlineImplementation=Ii=Ve([O],Ii);let oi=class{constructor(F,se,De){this.session=F,this.threadId=se,this.frameId=De}};e.StackFrameFocus=oi,e.StackFrameFocus=oi=Ve([O],oi);let ai=class{constructor(F,se){this.session=F,this.threadId=se}};e.ThreadFocus=ai,e.ThreadFocus=ai=Ve([O],ai);let lt=class{constructor(F,se){this.range=F,this.expression=se}};e.EvaluatableExpression=lt,e.EvaluatableExpression=lt=Ve([O],lt);var Wi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Wi||(e.InlineCompletionTriggerKind=Wi={}));let Qt=class{constructor(F,se){this.range=F,this.text=se}};e.InlineValueText=Qt,e.InlineValueText=Qt=Ve([O],Qt);let ii=class{constructor(F,se,De=!0){this.range=F,this.variableName=se,this.caseSensitiveLookup=De}};e.InlineValueVariableLookup=ii,e.InlineValueVariableLookup=ii=Ve([O],ii);let Ei=class{constructor(F,se){this.range=F,this.expression=se}};e.InlineValueEvaluatableExpression=Ei,e.InlineValueEvaluatableExpression=Ei=Ve([O],Ei);let ki=class{constructor(F,se){this.frameId=F,this.stoppedLocation=se}};e.InlineValueContext=ki,e.InlineValueContext=ki=Ve([O],ki);var Vi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Vi||(e.FileChangeType=Vi={}));let Pi=o=class extends Error{static FileExists(F){return new o(F,l.FileSystemProviderErrorCode.FileExists,o.FileExists)}static FileNotFound(F){return new o(F,l.FileSystemProviderErrorCode.FileNotFound,o.FileNotFound)}static FileNotADirectory(F){return new o(F,l.FileSystemProviderErrorCode.FileNotADirectory,o.FileNotADirectory)}static FileIsADirectory(F){return new o(F,l.FileSystemProviderErrorCode.FileIsADirectory,o.FileIsADirectory)}static NoPermissions(F){return new o(F,l.FileSystemProviderErrorCode.NoPermissions,o.NoPermissions)}static Unavailable(F){return new o(F,l.FileSystemProviderErrorCode.Unavailable,o.Unavailable)}constructor(F,se=l.FileSystemProviderErrorCode.Unknown,De){super(m.URI.isUri(F)?F.toString(!0):F),this.code=De?.name??"Unknown",(0,l.markAsFileSystemProviderError)(this,se),Object.setPrototypeOf(this,o.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.FileSystemError=Pi,e.FileSystemError=Pi=o=Ve([O],Pi);let bi=class{constructor(F,se,De){this.start=F,this.end=se,this.kind=De}};e.FoldingRange=bi,e.FoldingRange=bi=Ve([O],bi);var qi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(qi||(e.FoldingRangeKind=qi={}));var Ti;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ti||(e.CommentThreadCollapsibleState=Ti={}));var ci;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var ji;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(ji||(e.CommentState=ji={}));var wi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ai{constructor(F,se=[]){this.tokenTypes=F,this.tokenModifiers=se}}e.SemanticTokensLegend=Ai;function cn(U){return typeof U>"u"||(0,y.isStringArray)(U)}class Ri{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let se=0,De=F.tokenTypes.length;se<De;se++)this._tokenTypeStrToInt.set(F.tokenTypes[se],se);for(let se=0,De=F.tokenModifiers.length;se<De;se++)this._tokenModifierStrToInt.set(F.tokenModifiers[se],se)}}push(F,se,De,qe,Qe){if(typeof F=="number"&&typeof se=="number"&&typeof De=="number"&&typeof qe=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this._pushEncoded(F,se,De,qe,Qe);if(x.isRange(F)&&typeof se=="string"&&cn(De))return this._push(F,se,De);throw(0,A.illegalArgument)()}_push(F,se,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const qe=F.start.line,Qe=F.start.character,ot=F.end.character-F.start.character,dt=this._tokenTypeStrToInt.get(se);let xt=0;if(De)for(const Gt of De){if(!this._tokenModifierStrToInt.has(Gt))throw new Error("`tokenModifier` is not in the provided legend");const Zt=this._tokenModifierStrToInt.get(Gt);xt|=1<<Zt>>>0}this._pushEncoded(qe,Qe,ot,dt,xt)}_pushEncoded(F,se,De,qe,Qe){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const xt=this._data.length/5|0;let Gt=0,Zt=0;for(let ei=0;ei<xt;ei++){let ri=this._data[5*ei],Bi=this._data[5*ei+1];ri===0?(ri=Gt,Bi+=Zt):ri+=Gt,this._data[5*ei]=ri,this._data[5*ei+1]=Bi,Gt=ri,Zt=Bi}}let ot=F,dt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Qe,this._prevLine=F,this._prevChar=se}static _sortAndDeltaEncode(F){const se=[],De=F.length/5|0;for(let dt=0;dt<De;dt++)se[dt]=dt;se.sort((dt,xt)=>{const Gt=F[5*dt],Zt=F[5*xt];if(Gt===Zt){const ei=F[5*dt+1],ri=F[5*xt+1];return ei-ri}return Gt-Zt});const qe=new Uint32Array(F.length);let Qe=0,ot=0;for(let dt=0;dt<De;dt++){const xt=5*se[dt],Gt=F[xt+0],Zt=F[xt+1],ei=F[xt+2],ri=F[xt+3],Bi=F[xt+4],wn=Gt-Qe,Rn=wn===0?Zt-ot:Zt,zi=5*dt;qe[zi+0]=wn,qe[zi+1]=Rn,qe[zi+2]=ei,qe[zi+3]=ri,qe[zi+4]=Bi,Qe=Gt,ot=Zt}return qe}build(F){return this._dataIsSortedAndDeltaEncoded?new ni(new Uint32Array(this._data),F):new ni(Ri._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=Ri;class ni{constructor(F,se){this.resultId=se,this.data=F}}e.SemanticTokens=ni;class ln{constructor(F,se,De){this.start=F,this.deleteCount=se,this.data=De}}e.SemanticTokensEdit=ln;class un{constructor(F,se){this.resultId=se,this.edits=F}}e.SemanticTokensEdits=un;var Ki;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Ki||(e.DebugConsoleMode=Ki={}));let fi=class{static{this.Back={iconPath:new zt("arrow-left")}}constructor(){}};e.QuickInputButtons=fi,e.QuickInputButtons=fi=Ve([O],fi);var Gi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Gi||(e.QuickPickItemKind=Gi={}));var Xi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var li;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(li||(e.ExtensionKind=li={}));class Qi{static validate(F){if(typeof F.badge=="string"){let se=(0,h.nextCharLength)(F.badge,0);if(se<F.badge.length&&(se+=(0,h.nextCharLength)(F.badge,se)),F.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!zt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,se,De){this.badge=F,this.tooltip=se,this.color=De}}e.FileDecoration=Qi;let Oi=class{constructor(F){this.kind=F}};e.ColorTheme=Oi,e.ColorTheme=Oi=Ve([O],Oi);var Yi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(Yi||(e.ColorThemeKind=Yi={}));class Yt{static isNotebookRange(F){return F instanceof Yt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(F,se){if(F<0)throw(0,A.illegalArgument)("start must be positive");if(se<0)throw(0,A.illegalArgument)("end must be positive");F<=se?(this._start=F,this._end=se):(this._start=se,this._end=F)}with(F){let se=this._start,De=this._end;return F.start!==void 0&&(se=F.start),F.end!==void 0&&(De=F.end),se===this._start&&De===this._end?this:new Yt(se,De)}}e.NotebookRange=Yt;class Si{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(se=>Si.isNotebookCellData(se))}static isNotebookCellData(F){return!0}constructor(F,se,De,qe,Qe,ot,dt){this.kind=F,this.value=se,this.languageId=De,this.mime=qe,this.outputs=Qe??[],this.metadata=ot,this.executionSummary=dt,Si.validate(this)}}e.NotebookCellData=Si;class dn{constructor(F){this.cells=F}}e.NotebookData=dn;class Kt{static isNotebookCellOutputItem(F){return F instanceof Kt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const se={name:F.name,message:F.message,stack:F.stack};return Kt.json(se,"application/vnd.code.notebook.error")}static stdout(F){return Kt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return Kt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,se="application/octet-stream"){return new Kt(F,se)}static#e=new TextEncoder;static text(F,se=T.Mimes.text){const De=Kt.#e.encode(String(F));return new Kt(De,se)}static json(F,se="text/x-json"){const De=JSON.stringify(F,void 0,"	");return Kt.text(De,se)}constructor(F,se){this.data=F,this.mime=se;const De=(0,T.normalizeMimeType)(se,!0);if(!De)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.NotebookCellOutputItem=Kt;class ui{static isNotebookCellOutput(F){return F instanceof ui?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,se=!1){const De=new Set,qe=new Set;for(let Qe=0;Qe<F.length;Qe++){const ot=F[Qe],dt=(0,T.normalizeMimeType)(ot.mime);if(!De.has(dt)||(0,v.isTextStreamMime)(dt)){De.add(dt);continue}qe.add(Qe),se&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return qe.size===0?F:F.filter((Qe,ot)=>!qe.has(ot))}constructor(F,se,De){this.items=ui.ensureUniqueMimeTypes(F,!0),typeof se=="string"?(this.id=se,this.metadata=De):(this.id=(0,P.generateUuid)(),this.metadata=se??De)}}e.NotebookCellOutput=ui;var Fi;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Fi||(e.NotebookCellKind=Fi={}));var Le;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(Le||(e.NotebookCellExecutionState=Le={}));var Jt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Jt||(e.NotebookCellStatusBarAlignment=Jt={}));var Li;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Li||(e.NotebookEditorRevealType=Li={}));class mt{constructor(F,se){this.text=F,this.alignment=se}}e.NotebookCellStatusBarItem=mt;var Ji;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Ji||(e.NotebookControllerAffinity=Ji={}));var Zi;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(Zi||(e.NotebookControllerAffinity2=Zi={}));class en{constructor(F,se=[]){this.uri=F,this.provides=(0,S.asArray)(se)}}e.NotebookRendererScript=en;class hn{constructor(F){this.label=F}}e.NotebookKernelSourceAction=hn;let di=class{constructor(F,se){this.label=F,this.timestamp=se}};e.TimelineItem=di,e.TimelineItem=di=Ve([O],di);var tn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(F,se){this.ranges=F,this.wordPattern=se}}e.LinkedEditingRanges=sn;class fn{constructor(F){this._autoForwardAction=F}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=fn;var on;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Mi=class{constructor(F=void 0,se=void 0,De=void 0,qe=!1){this.include=F,this.exclude=se,this.profile=De,this.continuous=qe}};e.TestRunRequest=Mi,e.TestRunRequest=Mi=Ve([O],Mi);let Ni=u=class{static diff(F,se,De){const qe=new u(F);return qe.expectedOutput=se,qe.actualOutput=De,qe}constructor(F){this.message=F}};e.TestMessage=Ni,e.TestMessage=Ni=u=Ve([O],Ni);let Ui=class{constructor(F){this.id=F}};e.TestTag=Ui,e.TestTag=Ui=Ve([O],Ui);let hi=class{constructor(F,se){this.covered=F,this.total=se}};e.CoveredCount=hi,e.CoveredCount=hi=Ve([O],hi);let xi=g=class{static fromDetails(F,se){const De=new hi(0,0),qe=new hi(0,0),Qe=new hi(0,0);for(const dt of se)if("branches"in dt){De.total+=1,De.covered+=dt.executionCount>0?1:0;for(const xt of dt.branches)qe.total+=1,qe.covered+=xt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=dt.executionCount>0?1:0;const ot=new g(F,De,qe.total>0?qe:void 0,Qe.total>0?Qe:void 0);return ot.detailedCoverage=se,ot}constructor(F,se,De,qe){this.uri=F,this.statementCoverage=se,this.branchCoverage=De,this.functionCoverage=qe}};e.FileCoverage=xi,e.FileCoverage=xi=g=Ve([O],xi);let $i=class{constructor(F,se,De=[]){this.executionCount=F,this.location=se,this.branches=De}};e.StatementCoverage=$i,e.StatementCoverage=$i=Ve([O],$i);let te=class{constructor(F,se){this.executionCount=F,this.location=se}};e.BranchCoverage=te,e.BranchCoverage=te=Ve([O],te);let fe=class{constructor(F,se){this.executionCount=F,this.location=se}};e.FunctionCoverage=fe,e.FunctionCoverage=fe=Ve([O],fe);var Fe;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Fe||(e.ExternalUriOpenerPriority=Fe={}));var rt;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(rt||(e.WorkspaceTrustState=rt={}));var wt;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(wt||(e.PortAutoForwardAction=wt={}));class Ot{constructor(F,se,De,qe,Qe,ot){this.kind=F,this.name=se,this.detail=De,this.uri=qe,this.range=Qe,this.selectionRange=ot}}e.TypeHierarchyItem=Ot;class Sn{constructor(F){this.uri=F}}e.TextTabInput=Sn;class _n{constructor(F,se){this.original=F,this.modified=se}}e.TextDiffTabInput=_n;class yn{constructor(F,se,De,qe){this.base=F,this.input1=se,this.input2=De,this.result=qe}}e.TextMergeTabInput=yn;class Dn{constructor(F,se){this.uri=F,this.viewType=se}}e.CustomEditorTabInput=Dn;class Cn{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=Cn;class In{constructor(F,se){this.uri=F,this.notebookType=se}}e.NotebookEditorTabInput=In;class kn{constructor(F,se,De){this.original=F,this.modified=se,this.notebookType=De}}e.NotebookDiffEditorTabInput=kn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class Tn{constructor(F,se){this.uri=F,this.inputBoxUri=se}}e.InteractiveWindowInput=Tn;var mn;(function(U){U[U.Up=1]="Up",U[U.Down=2]="Down"})(mn||(e.InteractiveSessionVoteDirection=mn={}));var gn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(gn||(e.InteractiveSessionCopyKind=gn={}));var pn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted"})(pn||(e.InteractiveEditorResponseFeedbackKind=pn={}));var vn;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(vn||(e.ChatMessageRole=vn={}));var En;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class An{constructor(F,se){this.role=F,this.content=se}}e.ChatMessage=An;var bn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(bn||(e.RelatedInformationType=bn={}))}),define(Pe[101],Te([1,0,50,12,15,277,137,7,18]),function(ve,e,S,A,I,L,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const m=new Map;function P(v,d){d?m.set(v,d):m.delete(v)}e.setWordDefinitionFor=P;function D(v){return m.get(v)}class l extends L.MirrorTextModel{constructor(d,t,i,c,f,C,k,n){super(t,i,c,f),this._proxy=d,this._languageId=C,this._isDirty=k,this.notebook=n,this._isDisposed=!1}dispose(){(0,S.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,y.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===A.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},save(){return d._save()},getText(t){return t?d._getTextInRange(t):d.getText()},get eol(){return d._eol===`
`?h.EndOfLine.LF:h.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(t){return d._lineAt(t)},offsetAt(t){return d._offsetAt(t)},positionAt(t){return d._positionAt(t)},validateRange(t){return d._validateRange(t)},validatePosition(t){return d._validatePosition(t)},getWordRangeAtPosition(t,i){return d._getWordRangeAtPosition(t,i)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,S.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,S.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const t=this._validateRange(d);if(t.isEmpty)return"";if(t.isSingleLine)return this._lines[t.start.line].substring(t.start.character,t.end.character);const i=this._eol,c=t.start.line,f=t.end.line,C=[];C.push(this._lines[c].substring(t.start.character));for(let k=c+1;k<f;k++)C.push(this._lines[k]);return C.push(this._lines[f].substring(0,t.end.character)),C.join(i)}_lineAt(d){let t;if(d instanceof h.Position?t=d.line:typeof d=="number"&&(t=d),typeof t!="number"||t<0||t>=this._lines.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new E(t,this._lines[t],t===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const t=this._lineStarts.getIndexOf(d),i=this._lines[t.index].length;return new h.Position(t.index,Math.min(t.remainder,i))}_validateRange(d){if(!(d instanceof h.Range))throw new Error("Invalid argument");const t=this._validatePosition(d.start),i=this._validatePosition(d.end);return t===d.start&&i===d.end?d:new h.Range(t.line,t.character,i.line,i.character)}_validatePosition(d){if(!(d instanceof h.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:t,character:i}=d,c=!1;if(t<0)t=0,i=0,c=!0;else if(t>=this._lines.length)t=this._lines.length-1,i=this._lines[t].length,c=!0;else{const f=this._lines[t].length;i<0?(i=0,c=!0):i>f&&(i=f,c=!0)}return c?new h.Position(t,i):d}_getWordRangeAtPosition(d,t){const i=this._validatePosition(d);if(!t)t=D(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,T.getWordAtText)(i.character+1,(0,T.ensureValidWordDefinition)(t),this._lines[i.line],0);if(c)return new h.Range(i.line,c.startColumn-1,i.line,c.endColumn-1)}}e.ExtHostDocumentData=l;class E{constructor(d,t,i){this._line=d,this._text=t,this._isLastLine=i}get lineNumber(){return this._line}get text(){return this._text}get range(){return new h.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new h.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(Pe[197],Te([1,0,7,17,5]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(h){this._actual=new S.ColorTheme(S.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(h){let y;switch(h){case"light":y=S.ColorThemeKind.Light;break;case"hcDark":y=S.ColorThemeKind.HighContrast;break;case"hcLight":y=S.ColorThemeKind.HighContrastLight;break;default:y=S.ColorThemeKind.Dark}this._actual=new S.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=L,e.ExtHostTheming=L=Ve([ze(0,A.IExtHostRpcService)],L)}),define(Pe[198],Te([1,0,4]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(A||(e.CellExecutionUpdateType=A={})),e.INotebookExecutionService=(0,S.createDecorator)("INotebookExecutionService")}),define(Pe[45],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(L){L.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var A;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(A||(e.TestPosition=A={}));class I{static fromExtHostTestItem(T,h,y=T.parent){if(T._isRoot)return new I([h]);const m=[T.id];for(let P=y;P&&P.id!==h;P=P.parent)m.push(P.id);return m.push(h),new I(m.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const h=T.indexOf("\0");return h===-1?T:T.slice(0,h)}static fromString(T){return new I(T.split("\0"))}static join(T,h){return new I([...T.path,h])}static joinToString(T,h){return T.toString()+"\0"+h}static parentId(T){const h=T.lastIndexOf("\0");return h===-1?void 0:T.slice(0,h)}static localId(T){const h=T.lastIndexOf("\0");return h===-1?T:T.slice(h+1)}static isChild(T,h){return h.startsWith(T)&&h[T.length]==="\0"}static compare(T,h){return T===h?0:I.isChild(T,h)?2:I.isChild(h,T)?3:1}constructor(T,h=T.length){if(this.path=T,this.viewEnd=h,T.length===0||h<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new I(this.path,T)}*idsToRoot(){for(let T=this.viewEnd;T>0;T--)yield new I(this.path,T)}compare(T){if(typeof T=="string")return I.compare(this.toString(),T);for(let h=0;h<T.viewEnd&&h<this.viewEnd;h++)if(T.path[h]!==this.path[h])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=I}),define(Pe[57],Te([1,0,2,44,45]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var T;(function(_){_[_.Run=1]="Run",_[_.Debug=2]="Debug",_[_.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var h;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable",_[_.SupportsContinuousRun=64]="SupportsContinuousRun"})(h||(e.TestRunProfileBitset=h={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=_=>"runId"in _;e.isStartControllerTests=y;var m;(function(_){_.serialize=o=>({range:o.range.toJSON(),uri:o.uri.toJSON()}),_.deserialize=o=>({range:A.Range.lift(o.range),uri:S.URI.revive(o.uri)})})(m||(e.IRichLocation=m={}));var P;(function(_){_[_.Error=0]="Error",_[_.Output=1]="Output"})(P||(e.TestMessageType=P={}));var D;(function(_){_.serialize=o=>({message:o.message,type:0,expected:o.expected,actual:o.actual,contextValue:o.contextValue,location:o.location&&m.serialize(o.location)}),_.deserialize=o=>({message:o.message,type:0,expected:o.expected,actual:o.actual,contextValue:o.contextValue,location:o.location&&m.deserialize(o.location)})})(D||(e.ITestErrorMessage=D={}));const l=(_,o)=>`${o?"s":"e"}${_}`;e.getMarkId=l;var E;(function(_){_.serialize=o=>({message:o.message,type:1,offset:o.offset,length:o.length,location:o.location&&m.serialize(o.location)}),_.deserialize=o=>({message:o.message,type:1,offset:o.offset,length:o.length,location:o.location&&m.deserialize(o.location)})})(E||(e.ITestOutputMessage=E={}));var v;(function(_){_.serialize=o=>o.type===0?D.serialize(o):E.serialize(o),_.deserialize=o=>o.type===0?D.deserialize(o):E.deserialize(o)})(v||(e.ITestMessage=v={}));var d;(function(_){_.serializeWithoutMessages=o=>({state:o.state,duration:o.duration,messages:[]}),_.serialize=o=>({state:o.state,duration:o.duration,messages:o.messages.map(v.serialize)}),_.deserialize=o=>({state:o.state,duration:o.duration,messages:o.messages.map(v.deserialize)})})(d||(e.ITestTaskState=d={}));const t="\0",i=(_,o)=>_+t+o;e.namespaceTestTag=i;const c=_=>{const o=_.indexOf(t);return{ctrlId:_.slice(0,o),tagId:_.slice(o+1)}};e.denamespaceTestTag=c;var f;(function(_){_.serialize=o=>({extId:o.extId,label:o.label,tags:o.tags,busy:o.busy,children:void 0,uri:o.uri?.toJSON(),range:o.range?.toJSON()||null,description:o.description,error:o.error,sortText:o.sortText}),_.deserialize=o=>({extId:o.extId,label:o.label,tags:o.tags,busy:o.busy,children:void 0,uri:o.uri?S.URI.revive(o.uri):void 0,range:o.range?A.Range.lift(o.range):null,description:o.description,error:o.error,sortText:o.sortText})})(f||(e.ITestItem=f={}));var C;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(C||(e.TestItemExpandState=C={}));var k;(function(_){_.serialize=o=>({expand:o.expand,item:f.serialize(o.item)}),_.deserialize=o=>({controllerId:I.TestId.root(o.item.extId),expand:o.expand,item:f.deserialize(o.item)})})(k||(e.InternalTestItem=k={}));var n;(function(_){_.serialize=o=>{let u;return o.item&&(u={},o.item.label!==void 0&&(u.label=o.item.label),o.item.tags!==void 0&&(u.tags=o.item.tags),o.item.busy!==void 0&&(u.busy=o.item.busy),o.item.uri!==void 0&&(u.uri=o.item.uri?.toJSON()),o.item.range!==void 0&&(u.range=o.item.range?.toJSON()),o.item.description!==void 0&&(u.description=o.item.description),o.item.error!==void 0&&(u.error=o.item.error),o.item.sortText!==void 0&&(u.sortText=o.item.sortText)),{extId:o.extId,expand:o.expand,item:u}},_.deserialize=o=>{let u;return o.item&&(u={},o.item.label!==void 0&&(u.label=o.item.label),o.item.tags!==void 0&&(u.tags=o.item.tags),o.item.busy!==void 0&&(u.busy=o.item.busy),o.item.range!==void 0&&(u.range=o.item.range?A.Range.lift(o.item.range):null),o.item.description!==void 0&&(u.description=o.item.description),o.item.error!==void 0&&(u.error=o.item.error),o.item.sortText!==void 0&&(u.sortText=o.item.sortText)),{extId:o.extId,expand:o.expand,item:u}}})(n||(e.ITestItemUpdate=n={}));const a=(_,o)=>{o.expand!==void 0&&(_.expand=o.expand),o.item!==void 0&&(_.item=_.item?Object.assign(_.item,o.item):o.item)};e.applyTestItemUpdate=a;var r;(function(_){_.serializeWithoutMessages=o=>({...k.serialize(o),ownComputedState:o.ownComputedState,computedState:o.computedState,tasks:o.tasks.map(d.serializeWithoutMessages)}),_.serialize=o=>({...k.serialize(o),ownComputedState:o.ownComputedState,computedState:o.computedState,tasks:o.tasks.map(d.serialize)}),_.deserialize=o=>({...k.deserialize(o),ownComputedState:o.ownComputedState,computedState:o.computedState,tasks:o.tasks.map(d.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var s;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(s||(e.DetailType=s={}));var b;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.DocumentSynced=2]="DocumentSynced",_[_.Remove=3]="Remove",_[_.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",_[_.Retire=5]="Retire",_[_.AddTag=6]="AddTag",_[_.RemoveTag=7]="RemoveTag"})(b||(e.TestDiffOpType=b={}));var p;(function(_){_.deserialize=o=>o.op===0?{op:o.op,item:k.deserialize(o.item)}:o.op===1?{op:o.op,item:n.deserialize(o.item)}:o.op===2?{op:o.op,uri:S.URI.revive(o.uri),docv:o.docv}:o,_.serialize=o=>o.op===0?{op:o.op,item:k.serialize(o.item)}:o.op===1?{op:o.op,item:n.serialize(o.item)}:o})(p||(e.TestsDiffOp=p={}));class w{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(o){const u=this.createChangeCollector();for(const g of o)switch(g.op){case 0:this.add(k.deserialize(g.item),u);break;case 1:this.update(n.deserialize(g.item),u);break;case 3:this.remove(g.itemId,u);break;case 5:this.retireTest(g.itemId);break;case 4:this.updatePendingRoots(g.amount);break;case 6:this._tags.set(g.tag.id,g.tag);break;case 7:this._tags.delete(g.id);break}u.complete?.()}add(o,u){const g=I.TestId.parentId(o.item.extId)?.toString();let O;if(!g)O=this.createItem(o),this.roots.add(O),this.items.set(o.item.extId,O);else if(this.items.has(g)){const z=this.items.get(g);z.children.add(o.item.extId),O=this.createItem(o,z),this.items.set(o.item.extId,O)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(o)}`);return}return u.add?.(O),o.expand===2&&this.busyControllerCount++,O}update(o,u){const g=this.items.get(o.extId);if(g)return o.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,o.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,o),u.update?.(g),g}remove(o,u){const g=this.items.get(o);if(!g)return;const O=I.TestId.parentId(g.item.extId)?.toString();O?this.items.get(O).children.delete(g.item.extId):this.roots.delete(g);const z=[[o]];for(;z.length;)for(const H of z.pop()){const B=this.items.get(H);B&&(z.push(B.children),this.items.delete(H),u.remove?.(B,B!==g),B.expand===2&&this.busyControllerCount--)}}retireTest(o){}updatePendingRoots(o){this.pendingRootCount+=o}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=w}),define(Pe[76],Te([1,0,13,5,6,50,57,45]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const m=(c,f)=>c===f,D=Object.entries({range:(c,f)=>c===f?!0:!c||!f?!1:c.equalsRange(f),busy:m,label:m,description:m,error:m,sortText:m,tags:(c,f)=>!(c.length!==f.length||c.some(C=>!f.includes(C)))}),l=(c,f)=>{let C;for(const[k,n]of D)n(c[k],f[k])||(C?C[k]=f[k]:C={[k]:f[k]});return C};class E extends I.Disposable{get root(){return this.options.root}constructor(f){super(),this.options=f,this.debounceSendDiff=this._register(new S.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new A.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(f){this._resolveHandler=f;for(const C of this.tree.values())this.updateExpandability(C)}get resolveHandler(){return this._resolveHandler}collectDiff(){const f=this.diff;return this.diff=[],f}pushDiff(f){switch(f.op){case 2:{for(const C of this.diff)if(C.op===2&&C.uri===f.uri){C.docv=f.docv;return}break}case 1:{const C=this.diff[this.diff.length-1];if(C){if(C.op===1&&C.item.extId===f.item.extId){(0,T.applyTestItemUpdate)(C.item,f.item);return}if(C.op===0&&C.item.item.extId===f.item.extId){(0,T.applyTestItemUpdate)(C.item,f.item);return}}break}}this.diff.push(f),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(f,C){const k=this.tree.get(f);if(k){if((k.expandLevels===void 0||C>k.expandLevels)&&(k.expandLevels=C),k.expand===1){const n=this.resolveChildren(k);return n.isOpen()?this.expandChildren(k,C-1):n.wait().then(()=>this.expandChildren(k,C-1))}else if(k.expand===3)return k.resolveBarrier?.isOpen()===!1?k.resolveBarrier.wait().then(()=>this.expandChildren(k,C-1)):this.expandChildren(k,C-1)}}dispose(){for(const f of this.tree.values())this.options.getApiFor(f.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(f,C){switch(C.op){case 3:this.removeItem(h.TestId.joinToString(f.fullId,C.id));break;case 0:this.upsertItem(C.item,f);break;case 5:for(const k of C.ops)this.onTestItemEvent(f,k);break;case 1:this.diffTagRefs(C.new,C.old,f.fullId.toString());break;case 2:this.updateExpandability(f);break;case 4:this.pushDiff({op:1,item:{extId:f.fullId.toString(),item:C.update}});break;case 6:this.documentSynced(f.actual.uri);break;default:(0,L.assertNever)(C)}}documentSynced(f){f&&this.pushDiff({op:2,uri:f,docv:this.options.getDocumentVersion(f)})}upsertItem(f,C){const k=h.TestId.fromExtHostTestItem(f,this.root.id,C?.actual),n=this.options.getApiFor(f);n.parent&&n.parent!==C?.actual&&this.options.getChildren(n.parent).delete(f.id);let a=this.tree.get(k.toString());if(!a){a={fullId:k,actual:f,expandLevels:C?.expandLevels?C.expandLevels-1:void 0,expand:0},f.tags.forEach(this.incrementTagRefs,this),this.tree.set(a.fullId.toString(),a),this.setItemParent(f,C),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:a.expand,item:this.options.toITestItem(f)}}),this.connectItemAndChildren(f,a,C);return}if(a.actual===f){this.connectItem(f,a,C);return}if(a.actual.uri?.toString()!==f.uri?.toString())return this.removeItem(k.toString()),this.upsertItem(f,C);const r=this.options.getChildren(a.actual),s=a.actual,b=l(this.options.toITestItem(s),this.options.toITestItem(f));this.options.getApiFor(s).listener=void 0,a.actual=f,a.expand=0,b&&(b.hasOwnProperty("tags")&&(this.diffTagRefs(f.tags,s.tags,k.toString()),delete b.tags),this.onTestItemEvent(a,{op:4,update:b})),this.connectItemAndChildren(f,a,C);for(const[p,w]of r)this.options.getChildren(f).get(w.id)||this.removeItem(h.TestId.joinToString(k,w.id));this.documentSynced(a.actual.uri)}diffTagRefs(f,C,k){const n=new Set(C.map(a=>a.id));for(const a of f)n.delete(a.id)||this.incrementTagRefs(a);this.pushDiff({op:1,item:{extId:k,item:{tags:f.map(a=>(0,T.namespaceTestTag)(this.options.controllerId,a.id))}}}),n.forEach(this.decrementTagRefs,this)}incrementTagRefs(f){const C=this.tags.get(f.id);C?C.refCount++:(this.tags.set(f.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,f.id)}}))}decrementTagRefs(f){const C=this.tags.get(f);C&&!--C.refCount&&(this.tags.delete(f),this.pushDiff({op:7,id:(0,T.namespaceTestTag)(this.options.controllerId,f)}))}setItemParent(f,C){this.options.getApiFor(f).parent=C&&C.actual!==this.root?C.actual:void 0}connectItem(f,C,k){this.setItemParent(f,k);const n=this.options.getApiFor(f);n.parent=k?.actual,n.listener=a=>this.onTestItemEvent(C,a),this.updateExpandability(C)}connectItemAndChildren(f,C,k){this.connectItem(f,C,k);for(const[n,a]of this.options.getChildren(f))this.upsertItem(a,C)}updateExpandability(f){let C;this._resolveHandler?f.resolveBarrier?C=f.resolveBarrier.isOpen()?3:2:C=f.actual.canResolveChildren?1:0:C=0,C!==f.expand&&(f.expand=C,this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:C}}),C===1&&f.expandLevels!==void 0&&this.resolveChildren(f))}expandChildren(f,C){if(C<0)return;const k=[];for(const[n,a]of this.options.getChildren(f.actual)){const r=this.expand(h.TestId.joinToString(f.fullId,a.id),C);(0,S.isThenable)(r)&&k.push(r)}if(k.length)return Promise.all(k).then(()=>{})}resolveChildren(f){if(f.resolveBarrier)return f.resolveBarrier;if(!this._resolveHandler){const a=new S.Barrier;return a.open(),a}f.expand=2,this.pushExpandStateUpdate(f);const C=f.resolveBarrier=new S.Barrier,k=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,a)};let n;try{n=this._resolveHandler(f.actual===this.root?void 0:f.actual)}catch(a){k(a)}return(0,S.isThenable)(n)?n.catch(k).then(()=>{C.open(),this.updateExpandability(f)}):(C.open(),this.updateExpandability(f)),f.resolveBarrier}pushExpandStateUpdate(f){this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:f.expand}})}removeItem(f){const C=this.tree.get(f);if(!C)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:f});const k=[C];for(;k.length;){const n=k.pop();if(n){this.options.getApiFor(n.actual).listener=void 0;for(const a of n.actual.tags)this.decrementTagRefs(a.id);this.tree.delete(n.fullId.toString());for(const[a,r]of this.options.getChildren(n.actual))k.push(this.tree.get(h.TestId.joinToString(n.fullId,r.id)))}}}flushDiff(){const f=this.collectDiff();f.length&&this.diffOpEmitter.fire(f)}}e.TestItemCollection=E;class v extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=v;class d extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class t extends Error{constructor(f,C,k){super(`TestItem with ID "${f}" is from controller "${C}" and cannot be added as a child of an item from controller "${k}".`)}}e.MixedTestItemController=t;const i=(c,f,C)=>{let k=new Map;return{get size(){return k.size},forEach(n,a){for(const r of k.values())n.call(a,r,this)},[Symbol.iterator](){return k.entries()},replace(n){const a=new Map,r=new Set(k.keys()),s={op:5,ops:[]};for(const b of n){if(!(b instanceof C))throw new d(b.id);const p=f(b).controllerId;if(p!==c.controllerId)throw new t(b.id,p,c.controllerId);if(a.has(b.id))throw new v(b.id);a.set(b.id,b),r.delete(b.id),s.ops.push({op:0,item:b})}for(const b of r.keys())s.ops.push({op:3,id:b});c.listener?.(s),k=a},add(n){if(!(n instanceof C))throw new d(n.id);k.set(n.id,n),c.listener?.({op:0,item:n})},delete(n){k.delete(n)&&c.listener?.({op:3,id:n})},get(n){return k.get(n)},toJSON(){return Array.from(k.values())}}};e.createTestItemChildren=i}),define(Pe[102],Te([1,0,76]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,I=(T,h)=>{const y={controllerId:h};return A.set(T,y),y};e.createPrivateApiFor=I;const L=T=>{const h=A.get(T);if(!h)throw new S.InvalidTestItemError(T?.id||"<unknown>");return h};e.getPrivateApiFor=L}),define(Pe[77],Te([1,0,12,2]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function I(h,y){return h.scheme===S.Schemas.http||h.scheme===S.Schemas.https?h:(y&&y.authority&&y.isRemote&&h.scheme===S.Schemas.file&&(h=A.URI.from({scheme:S.Schemas.vscodeRemote,authority:y.authority,path:h.path})),A.URI.from({scheme:S.Schemas.https,authority:`${h.scheme}+${L(h.authority)}.${e.webviewRootResourceAuthority}`,path:h.path,fragment:h.fragment,query:h.query}))}e.asWebviewUri=I;function L(h){return h.replace(/./g,y=>{const m=y.charCodeAt(0);return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57?y:"-"+m.toString(16).padStart(4,"0")})}function T(h){return h.replace(/-([0-9a-f]{4})/g,(y,m)=>String.fromCharCode(parseInt(m,16)))}e.decodeAuthority=T}),define(Pe[199],Te([1,0,5,6,77]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(h,y,m){this._proxy=h,this._editors=y,this._remoteInfo=m,this._handlePool=0,this._disposables=new A.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const P=y.getVisibleTextEditors();for(const D of this._insets.values())P.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this._insets.forEach(h=>h.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(h,y,m,P,D){let l;for(const f of this._editors.getVisibleTextEditors(!0))if(f.value===h){l=f;break}if(!l)throw new Error("not a visible editor");const E=this,v=this._handlePool++,d=new S.Emitter,t=new S.Emitter,i=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(f){return(0,I.asWebviewUri)(f,E._remoteInfo)}get cspSource(){return I.webviewGenericCspSource}set options(f){this._options=f,E._proxy.$setOptions(v,f)}get options(){return this._options}set html(f){this._html=f,E._proxy.$setHtml(v,f)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(f){return E._proxy.$postMessage(v,f)}},c=new class{constructor(){this.editor=h,this.line=y,this.height=m,this.webview=i,this.onDidDispose=t.event}dispose(){E._insets.has(v)&&(E._insets.delete(v),E._proxy.$disposeEditorInset(v),t.fire(),t.dispose(),d.dispose())}};return this._proxy.$createEditorInset(v,l.id,l.value.document.uri,y+1,m,P||{},D.identifier,D.extensionLocation),this._insets.set(v,{editor:h,inset:c,onDidReceiveMessage:d}),c}$onDidDispose(h){const y=this._insets.get(h);y&&y.inset.dispose()}$onDidReceiveMessage(h,y){this._insets.get(h)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=L}),define(Pe[200],Te([1,0,4]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,S.createDecorator)("configurationResolverService");var A;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(A||(e.VariableKind=A={}));class I extends Error{constructor(T,h){super(h),this.variable=T}}e.VariableError=I}),define(Pe[201],Te([1,0,19,52,16,24,22,90,166,200,15]),function(ve,e,S,A,I,L,T,h,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,v,d,t){this._contributedVariables=new Map,this._context=E,this._labelService=v,this._userHomePromise=d,t&&(this._envVariablesPromise=t.then(i=>this.prepareEnv(i)))}prepareEnv(E){if(T.isWindows){const v=Object.create(null);return Object.keys(E).forEach(d=>{v[d.toLowerCase()]=E[d]}),v}return E}resolveWithEnvironment(E,v,d){return this.recursiveResolve({env:this.prepareEnv(E),userHome:void 0},v?v.uri:void 0,d)}async resolveAsync(E,v){const d={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(d,E?E.uri:void 0,v)}async resolveAnyBase(E,v,d,t){const i=L.deepClone(v);T.isWindows&&i.windows?Object.keys(i.windows).forEach(f=>i[f]=i.windows[f]):T.isMacintosh&&i.osx?Object.keys(i.osx).forEach(f=>i[f]=i.osx[f]):T.isLinux&&i.linux&&Object.keys(i.linux).forEach(f=>i[f]=i.linux[f]),delete i.windows,delete i.osx,delete i.linux;const c={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(c,E?E.uri:void 0,i,d,t)}async resolveAnyAsync(E,v,d){return this.resolveAnyBase(E,v,d)}async resolveAnyMap(E,v,d){const t=new Map;return{newConfig:await this.resolveAnyBase(E,v,d,t),resolvedVariables:t}}resolveWithInteractionReplace(E,v,d,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,v,d,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,v){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,v)}async recursiveResolve(E,v,d,t,i){if(I.isString(d))return this.resolveString(E,v,d,t,i);if(Array.isArray(d))return Promise.all(d.map(c=>this.recursiveResolve(E,v,c,t,i)));if(I.isObject(d)){const c=Object.create(null),f=await Promise.all(Object.keys(d).map(async C=>[await this.resolveString(E,v,C,t,i),await this.recursiveResolve(E,v,d[C],t,i)]));for(const[C,k]of f)c[C]=k;return c}return d}resolveString(E,v,d,t,i){return(0,P.replaceAsync)(d,D.VARIABLE_REGEXP,async(c,f)=>{if(f.includes(D.VARIABLE_LHS))return c;let C=await this.evaluateSingleVariable(E,c,f,v,t);return i?.set(f,C),C!==c&&I.isString(C)&&C.match(D.VARIABLE_REGEXP)&&(C=await this.resolveString(E,v,C,t,i)),C})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}async evaluateSingleVariable(E,v,d,t,i){let c;const f=d.split(":");f.length>1&&(d=f[0],c=f[1]);const C=a=>{const r=this._context.getFilePath();if(r)return(0,h.normalizeDriveLetter)(r);throw new m.VariableError(a,(0,y.localize)(0,null,v))},k=a=>{const r=C(a);if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return(0,h.normalizeDriveLetter)(s)}throw new m.VariableError(a,(0,y.localize)(1,null,v,S.basename(r)))},n=a=>{if(c){const r=this._context.getFolderUri(c);if(r)return r;throw new m.VariableError(a,(0,y.localize)(2,null,v,c))}if(t)return t;throw this._context.getWorkspaceFolderCount()>1?new m.VariableError(a,(0,y.localize)(3,null,v)):new m.VariableError(a,(0,y.localize)(4,null,v))};switch(d){case"env":if(c){if(E.env){const a=E.env[T.isWindows?c.toLowerCase():c];if(I.isString(a))return a}return""}throw new m.VariableError(m.VariableKind.Env,(0,y.localize)(5,null,v));case"config":if(c){const a=this._context.getConfigurationValue(t,c);if(I.isUndefinedOrNull(a))throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(6,null,v,c));if(I.isObject(a))throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(7,null,v,c));return a}throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(8,null,v));case"command":return this.resolveFromMap(m.VariableKind.Command,v,c,i,"command");case"input":return this.resolveFromMap(m.VariableKind.Input,v,c,i,"input");case"extensionInstallFolder":if(c){const a=await this._context.getExtension(c);if(!a)throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,v,c));return this.fsPath(a.extensionLocation)}throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,v));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,h.normalizeDriveLetter)(this.fsPath(n(m.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,h.normalizeDriveLetter)(this.fsPath(n(m.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,h.normalizeDriveLetter)(S.basename(this.fsPath(n(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new m.VariableError(m.VariableKind.UserHome,(0,y.localize)(11,null,v))}case"lineNumber":{const a=this._context.getLineNumber();if(a)return a;throw new m.VariableError(m.VariableKind.LineNumber,(0,y.localize)(12,null,v))}case"selectedText":{const a=this._context.getSelectedText();if(a)return a;throw new m.VariableError(m.VariableKind.SelectedText,(0,y.localize)(13,null,v))}case"file":return C(m.VariableKind.File);case"fileWorkspaceFolder":return k(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?S.relative(this.fsPath(n(m.VariableKind.RelativeFile)),C(m.VariableKind.RelativeFile)):C(m.VariableKind.RelativeFile);case"relativeFileDirname":{const a=S.dirname(C(m.VariableKind.RelativeFileDirname));if(t||c){const r=S.relative(this.fsPath(n(m.VariableKind.RelativeFileDirname)),a);return r.length===0?".":r}return a}case"fileDirname":return S.dirname(C(m.VariableKind.FileDirname));case"fileExtname":return S.extname(C(m.VariableKind.FileExtname));case"fileBasename":return S.basename(C(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=S.basename(C(m.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-S.extname(a).length)}case"fileDirnameBasename":return S.basename(S.dirname(C(m.VariableKind.FileDirnameBasename)));case"execPath":{const a=this._context.getExecPath();return a||v}case"execInstallFolder":{const a=this._context.getAppRoot();return a||v}case"pathSeparator":return S.sep;default:try{const a=c?`${d}:${c}`:d;return this.resolveFromMap(m.VariableKind.Unknown,v,a,i,void 0)}catch{return v}}}}resolveFromMap(E,v,d,t,i){if(d&&t){const c=i===void 0?t[d]:t[i+":"+d];if(typeof c=="string")return c;throw new m.VariableError(E,(0,y.localize)(14,null,v))}return v}}e.AbstractVariableResolverService=D}),define(Pe[103],Te([1,0,4,99]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,S.createDecorator)("editorGroupsService");var I;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var L;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var T;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var h;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(h||(e.GroupsArrangement=h={}));var y;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function m(v){const d=v;return(0,A.isEditorInput)(d?.editor)&&(0,A.isEditorInput)(d?.replacement)}e.isEditorReplacement=m;var P;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var D;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function l(v){const d=v;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=l;function E(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(Pe[202],Te([1,0,4,103]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,S.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(L){const T=L;return typeof L=="number"||(0,A.isEditorGroup)(T)}e.isPreferredGroup=I}),define(Pe[8],Te([1,0,18,25,123,203,49,28,117,69,68,24,16,2,44,78,94,102,99,75,45,57,202,7]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t,i,c,f,C,k,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Ie){function Re(j){const{selectionStartLineNumber:Oe,selectionStartColumn:Be,positionLineNumber:Ke,positionColumn:We}=j,Je=new a.Position(Oe-1,Be-1),pt=new a.Position(Ke-1,We-1);return new a.Selection(Je,pt)}Ie.to=Re;function ge(j){const{anchor:Oe,active:Be}=j;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ie.from=ge})(r||(e.Selection=r={}));var s;(function(Ie){function Re(j){if(!j)return;const{start:Oe,end:Be}=j;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ie.from=Re;function ge(j){if(!j)return;const{startLineNumber:Oe,startColumn:Be,endLineNumber:Ke,endColumn:We}=j;return new a.Range(Oe-1,Be-1,Ke-1,We-1)}Ie.to=ge})(s||(e.Range=s={}));var b;(function(Ie){function Re(ge){switch(ge){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Ie.to=Re})(b||(e.TokenType=b={}));var p;(function(Ie){function Re(j){return new a.Position(j.lineNumber-1,j.column-1)}Ie.to=Re;function ge(j){return{lineNumber:j.line+1,column:j.character+1}}Ie.from=ge})(p||(e.Position=p={}));var w;(function(Ie){function Re(Oe,Be,Ke){return(0,S.coalesce)((0,S.asArray)(Oe).map(We=>ge(We,Be,Ke)))}Ie.from=Re;function ge(Oe,Be,Ke){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:Ke?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:j(Oe.scheme,Be),pattern:st.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:Ke?.isBuiltin}}function j(Oe,Be){return Be&&typeof Oe=="string"?Be.transformOutgoingScheme(Oe):Oe}})(w||(e.DocumentSelector=w={}));var _;(function(Ie){function Re(j){switch(j){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Ie.from=Re;function ge(j){switch(j){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Ie.to=ge})(_||(e.DiagnosticTag=_={}));var o;(function(Ie){function Re(j){let Oe;return j.code&&((0,l.isString)(j.code)||(0,l.isNumber)(j.code)?Oe=String(j.code):Oe={value:String(j.code.value),target:j.code.target}),{...s.from(j.range),message:j.message,source:j.source,code:Oe,severity:g.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(u.from),tags:Array.isArray(j.tags)?(0,S.coalesce)(j.tags.map(_.from)):void 0}}Ie.from=Re;function ge(j){const Oe=new a.Diagnostic(s.to(j),j.message,g.to(j.severity));return Oe.source=j.source,Oe.code=(0,l.isString)(j.code)?j.code:j.code?.value,Oe.relatedInformation=j.relatedInformation&&j.relatedInformation.map(u.to),Oe.tags=j.tags&&(0,S.coalesce)(j.tags.map(_.to)),Oe}Ie.to=ge})(o||(e.Diagnostic=o={}));var u;(function(Ie){function Re(j){return{...s.from(j.location.range),message:j.message,resource:j.location.uri}}Ie.from=Re;function ge(j){return new a.DiagnosticRelatedInformation(new a.Location(j.resource,s.to(j)),j.message)}Ie.to=ge})(u||(e.DiagnosticRelatedInformation=u={}));var g;(function(Ie){function Re(j){switch(j){case a.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ie.from=Re;function ge(j){switch(j){case t.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Ie.to=ge})(g||(e.DiagnosticSeverity=g={}));var O;(function(Ie){function Re(j){return typeof j=="number"&&j>=a.ViewColumn.One?j-1:j===a.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}Ie.from=Re;function ge(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}Ie.to=ge})(O||(e.ViewColumn=O={}));function z(Ie){return typeof Ie.range<"u"}function H(Ie){return Ie.length===0?!0:!!z(Ie[0])}e.isDecorationOptionsArr=H;var B;(function(Ie){function Re(We){return We.map(Ie.from)}Ie.fromMany=Re;function ge(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function j(We){let Je;if(ge(We)){const{language:ct,value:gt}=We;Je={value:"```"+ct+`
`+gt+"\n```\n"}}else a.MarkdownString.isMarkdownString(We)?Je={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?Je={value:We}:Je={value:""};const pt=Object.create(null);Je.uris=pt;const _t=ct=>{try{let gt=E.URI.parse(ct,!0);gt=gt.with({query:Oe(gt.query,pt)}),pt[ct]=gt}catch{}return""},vt=new y.marked.Renderer;return vt.link=_t,vt.image=ct=>typeof ct=="string"?_t(T.parseHrefAndDimensions(ct).href):"",(0,y.marked)(Je.value,{renderer:vt}),Je}Ie.from=j;function Oe(We,Je){if(!We)return We;let pt;try{pt=(0,m.parse)(We)}catch{}if(!pt)return We;let _t=!1;return pt=(0,D.cloneAndChange)(pt,vt=>{if(E.URI.isUri(vt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return Je[ct]=vt,_t=!0,ct}else return}),_t?JSON.stringify(pt):We}function Be(We){const Je=new a.MarkdownString(We.value,We.supportThemeIcons);return Je.isTrusted=We.isTrusted,Je.supportHtml=We.supportHtml,Je.baseUri=We.baseUri?E.URI.from(We.baseUri):void 0,Je}Ie.to=Be;function Ke(We){if(We)return typeof We=="string"?We:Ie.from(We)}Ie.fromStrict=Ke})(B||(e.MarkdownString=B={}));function $(Ie){return H(Ie)?Ie.map(Re=>({range:s.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?B.fromMany(Re.hoverMessage):Re.hoverMessage?B.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):Ie.map(Re=>({range:s.from(Re)}))}e.fromRangeOrRangeWithMessage=$;function x(Ie){return typeof Ie>"u"?Ie:typeof Ie=="string"?E.URI.file(Ie):Ie}e.pathOrURIToURI=x;var M;(function(Ie){function Re(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?x(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ie.from=Re})(M||(e.ThemableDecorationAttachmentRenderOptions=M={}));var ne;(function(Ie){function Re(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?x(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?M.from(ge.before):void 0,after:ge.after?M.from(ge.after):void 0}}Ie.from=Re})(ne||(e.ThemableDecorationRenderOptions=ne={}));var Q;(function(Ie){function Re(ge){if(typeof ge>"u")return ge;switch(ge){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Ie.from=Re})(Q||(e.DecorationRangeBehavior=Q={}));var we;(function(Ie){function Re(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?Q.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?ne.from(ge.light):void 0,dark:ge.dark?ne.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?x(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?M.from(ge.before):void 0,after:ge.after?M.from(ge.after):void 0}}Ie.from=Re})(we||(e.DecorationRenderOptions=we={}));var _e;(function(Ie){function Re(j){return{text:j.newText,eol:j.newEol&&Ye.from(j.newEol),range:s.from(j.range)}}Ie.from=Re;function ge(j){const Oe=new a.TextEdit(s.to(j.range),j.text);return Oe.newEol=typeof j.eol>"u"?void 0:Ye.to(j.eol),Oe}Ie.to=ge})(_e||(e.TextEdit=_e={}));var Ae;(function(Ie){function Re(j,Oe){const Be={edits:[]};if(j instanceof a.WorkspaceEdit){const Ke=new h.ResourceSet;for(const We of j._allEntries())We._type===1&&E.URI.isUri(We.to)&&We.from===void 0&&Ke.add(We.to);for(const We of j._allEntries())if(We._type===1){let Je;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?Je={type:"base64",value:(0,A.encodeBase64)(A.VSBuffer.wrap(We.options.contents))}:Je={type:"dataTransferItem",id:We.options.contents._itemId}),Be.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:Je},metadata:We.metadata})}else We._type===2?Be.edits.push({resource:We.uri,textEdit:_e.from(We.edit),versionId:Ke.has(We.uri)?void 0:Oe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Be.edits.push({resource:We.uri,textEdit:{range:s.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ke.has(We.uri)?void 0:Oe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Be.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Be.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(ft.from)}})}return Be}Ie.from=Re;function ge(j){const Oe=new a.WorkspaceEdit,Be=new h.ResourceMap;for(const Ke of j.edits)if(Ke.textEdit){const We=Ke,Je=E.URI.revive(We.resource),pt=s.to(We.textEdit.range),_t=We.textEdit.text,vt=We.textEdit.insertAsSnippet;let ct;vt?ct=a.SnippetTextEdit.replace(pt,new a.SnippetString(_t)):ct=a.TextEdit.replace(pt,_t);const gt=Be.get(Je);gt?gt.push(ct):Be.set(Je,[ct])}else Oe.renameFile(E.URI.revive(Ke.oldResource),E.URI.revive(Ke.newResource),Ke.options);for(const[Ke,We]of Be)Oe.set(Ke,We);return Oe}Ie.to=ge})(Ae||(e.WorkspaceEdit=Ae={}));var Y;(function(Ie){const Re=Object.create(null);Re[a.SymbolKind.File]=0,Re[a.SymbolKind.Module]=1,Re[a.SymbolKind.Namespace]=2,Re[a.SymbolKind.Package]=3,Re[a.SymbolKind.Class]=4,Re[a.SymbolKind.Method]=5,Re[a.SymbolKind.Property]=6,Re[a.SymbolKind.Field]=7,Re[a.SymbolKind.Constructor]=8,Re[a.SymbolKind.Enum]=9,Re[a.SymbolKind.Interface]=10,Re[a.SymbolKind.Function]=11,Re[a.SymbolKind.Variable]=12,Re[a.SymbolKind.Constant]=13,Re[a.SymbolKind.String]=14,Re[a.SymbolKind.Number]=15,Re[a.SymbolKind.Boolean]=16,Re[a.SymbolKind.Array]=17,Re[a.SymbolKind.Object]=18,Re[a.SymbolKind.Key]=19,Re[a.SymbolKind.Null]=20,Re[a.SymbolKind.EnumMember]=21,Re[a.SymbolKind.Struct]=22,Re[a.SymbolKind.Event]=23,Re[a.SymbolKind.Operator]=24,Re[a.SymbolKind.TypeParameter]=25;function ge(Oe){return typeof Re[Oe]=="number"?Re[Oe]:6}Ie.from=ge;function j(Oe){for(const Be in Re)if(Re[Be]===Oe)return Number(Be);return a.SymbolKind.Property}Ie.to=j})(Y||(e.SymbolKind=Y={}));var he;(function(Ie){function Re(j){switch(j){case a.SymbolTag.Deprecated:return 1}}Ie.from=Re;function ge(j){switch(j){case 1:return a.SymbolTag.Deprecated}}Ie.to=ge})(he||(e.SymbolTag=he={}));var ke;(function(Ie){function Re(j){return{name:j.name,kind:Y.from(j.kind),tags:j.tags&&j.tags.map(he.from),containerName:j.containerName,location:q.from(j.location)}}Ie.from=Re;function ge(j){const Oe=new a.SymbolInformation(j.name,Y.to(j.kind),j.containerName,q.to(j.location));return Oe.tags=j.tags&&j.tags.map(he.to),Oe}Ie.to=ge})(ke||(e.WorkspaceSymbol=ke={}));var ae;(function(Ie){function Re(j){const Oe={name:j.name||"!!MISSING: name!!",detail:j.detail,range:s.from(j.range),selectionRange:s.from(j.selectionRange),kind:Y.from(j.kind),tags:j.tags?.map(he.from)??[]};return j.children&&(Oe.children=j.children.map(Re)),Oe}Ie.from=Re;function ge(j){const Oe=new a.DocumentSymbol(j.name,j.detail,Y.to(j.kind),s.to(j.range),s.to(j.selectionRange));return(0,S.isNonEmptyArray)(j.tags)&&(Oe.tags=j.tags.map(he.to)),j.children&&(Oe.children=j.children.map(ge)),Oe}Ie.to=ge})(ae||(e.DocumentSymbol=ae={}));var J;(function(Ie){function Re(j){const Oe=new a.CallHierarchyItem(Y.to(j.kind),j.name,j.detail||"",E.URI.revive(j.uri),s.to(j.range),s.to(j.selectionRange));return Oe._sessionId=j._sessionId,Oe._itemId=j._itemId,Oe}Ie.to=Re;function ge(j,Oe,Be){if(Oe=Oe??j._sessionId,Be=Be??j._itemId,Oe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Be,name:j.name,detail:j.detail,kind:Y.from(j.kind),uri:j.uri,range:s.from(j.range),selectionRange:s.from(j.selectionRange),tags:j.tags?.map(he.from)}}Ie.from=ge})(J||(e.CallHierarchyItem=J={}));var le;(function(Ie){function Re(ge){return new a.CallHierarchyIncomingCall(J.to(ge.from),ge.fromRanges.map(j=>s.to(j)))}Ie.to=Re})(le||(e.CallHierarchyIncomingCall=le={}));var N;(function(Ie){function Re(ge){return new a.CallHierarchyOutgoingCall(J.to(ge.to),ge.fromRanges.map(j=>s.to(j)))}Ie.to=Re})(N||(e.CallHierarchyOutgoingCall=N={}));var q;(function(Ie){function Re(j){return{range:j.range&&s.from(j.range),uri:j.uri}}Ie.from=Re;function ge(j){return new a.Location(E.URI.revive(j.uri),s.to(j.range))}Ie.to=ge})(q||(e.location=q={}));var ue;(function(Ie){function Re(j){const Oe=j,Be=j;return{originSelectionRange:Oe.originSelectionRange?s.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Be.uri,range:s.from(Oe.targetRange?Oe.targetRange:Be.range),targetSelectionRange:Oe.targetSelectionRange?s.from(Oe.targetSelectionRange):void 0}}Ie.from=Re;function ge(j){return{targetUri:E.URI.revive(j.uri),targetRange:s.to(j.range),targetSelectionRange:j.targetSelectionRange?s.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?s.to(j.originSelectionRange):void 0}}Ie.to=ge})(ue||(e.DefinitionLink=ue={}));var Se;(function(Ie){function Re(j){return{range:s.from(j.range),contents:B.fromMany(j.contents)}}Ie.from=Re;function ge(j){return new a.Hover(j.contents.map(B.to),s.to(j.range))}Ie.to=ge})(Se||(e.Hover=Se={}));var be;(function(Ie){function Re(j){return{range:s.from(j.range),expression:j.expression}}Ie.from=Re;function ge(j){return new a.EvaluatableExpression(s.to(j.range),j.expression)}Ie.to=ge})(be||(e.EvaluatableExpression=be={}));var Ee;(function(Ie){function Re(j){if(j instanceof a.InlineValueText)return{type:"text",range:s.from(j.range),text:j.text};if(j instanceof a.InlineValueVariableLookup)return{type:"variable",range:s.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}Ie.from=Re;function ge(j){switch(j.type){case"text":return{range:s.to(j.range),text:j.text};case"variable":return{range:s.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:s.to(j.range),expression:j.expression}}}Ie.to=ge})(Ee||(e.InlineValue=Ee={}));var ye;(function(Ie){function Re(j){return{frameId:j.frameId,stoppedLocation:s.from(j.stoppedLocation)}}Ie.from=Re;function ge(j){return new a.InlineValueContext(j.frameId,s.to(j.stoppedLocation))}Ie.to=ge})(ye||(e.InlineValueContext=ye={}));var oe;(function(Ie){function Re(j){return{range:s.from(j.range),kind:j.kind}}Ie.from=Re;function ge(j){return new a.DocumentHighlight(s.to(j.range),j.kind)}Ie.to=ge})(oe||(e.DocumentHighlight=oe={}));var de;(function(Ie){function Re(ge){switch(ge){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Ie.to=Re})(de||(e.CompletionTriggerKind=de={}));var re;(function(Ie){function Re(ge){return{triggerKind:de.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ie.to=Re})(re||(e.CompletionContext=re={}));var ie;(function(Ie){function Re(j){switch(j){case a.CompletionItemTag.Deprecated:return 1}}Ie.from=Re;function ge(j){switch(j){case 1:return a.CompletionItemTag.Deprecated}}Ie.to=ge})(ie||(e.CompletionItemTag=ie={}));var me;(function(Ie){const Re=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ge(Be){return Re.get(Be)??9}Ie.from=ge;const j=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Oe(Be){return j.get(Be)??a.CompletionItemKind.Property}Ie.to=Oe})(me||(e.CompletionItemKind=me={}));var Ce;(function(Ie){function Re(ge,j){const Oe=new a.CompletionItem(ge.label);return Oe.insertText=ge.insertText,Oe.kind=me.to(ge.kind),Oe.tags=ge.tags?.map(ie.to),Oe.detail=ge.detail,Oe.documentation=T.isMarkdownString(ge.documentation)?B.to(ge.documentation):ge.documentation,Oe.sortText=ge.sortText,Oe.filterText=ge.filterText,Oe.preselect=ge.preselect,Oe.commitCharacters=ge.commitCharacters,v.Range.isIRange(ge.range)?Oe.range=s.to(ge.range):typeof ge.range=="object"&&(Oe.range={inserting:s.to(ge.range.insert),replacing:s.to(ge.range.replace)}),Oe.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Oe.insertText=new a.SnippetString(ge.insertText):(Oe.insertText=ge.insertText,Oe.textEdit=Oe.range instanceof a.Range?new a.TextEdit(Oe.range,Oe.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Oe.additionalTextEdits=ge.additionalTextEdits.map(Be=>_e.to(Be))),Oe.command=j&&ge.command?j.fromInternal(ge.command):void 0,Oe}Ie.to=Re})(Ce||(e.CompletionItem=Ce={}));var R;(function(Ie){function Re(j){if(typeof j.label!="string"&&!Array.isArray(j.label))throw new TypeError("Invalid label");return{label:j.label,documentation:B.fromStrict(j.documentation)}}Ie.from=Re;function ge(j){return{label:j.label,documentation:T.isMarkdownString(j.documentation)?B.to(j.documentation):j.documentation}}Ie.to=ge})(R||(e.ParameterInformation=R={}));var W;(function(Ie){function Re(j){return{label:j.label,documentation:B.fromStrict(j.documentation),parameters:Array.isArray(j.parameters)?j.parameters.map(R.from):[],activeParameter:j.activeParameter}}Ie.from=Re;function ge(j){return{label:j.label,documentation:T.isMarkdownString(j.documentation)?B.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(R.to):[],activeParameter:j.activeParameter}}Ie.to=ge})(W||(e.SignatureInformation=W={}));var K;(function(Ie){function Re(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(W.from):[]}}Ie.from=Re;function ge(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(W.to):[]}}Ie.to=ge})(K||(e.SignatureHelp=K={}));var G;(function(Ie){function Re(ge,j){const Oe=new a.InlayHint(p.to(j.position),typeof j.label=="string"?j.label:j.label.map(V.to.bind(void 0,ge)),j.kind&&ee.to(j.kind));return Oe.textEdits=j.textEdits&&j.textEdits.map(_e.to),Oe.tooltip=T.isMarkdownString(j.tooltip)?B.to(j.tooltip):j.tooltip,Oe.paddingLeft=j.paddingLeft,Oe.paddingRight=j.paddingRight,Oe}Ie.to=Re})(G||(e.InlayHint=G={}));var V;(function(Ie){function Re(ge,j){const Oe=new a.InlayHintLabelPart(j.label);return Oe.tooltip=T.isMarkdownString(j.tooltip)?B.to(j.tooltip):j.tooltip,d.Command.is(j.command)&&(Oe.command=ge.fromInternal(j.command)),j.location&&(Oe.location=q.to(j.location)),Oe}Ie.to=Re})(V||(e.InlayHintLabelPart=V={}));var ee;(function(Ie){function Re(j){return j}Ie.from=Re;function ge(j){return j}Ie.to=ge})(ee||(e.InlayHintKind=ee={}));var ce;(function(Ie){function Re(j){return{range:s.from(j.range),url:j.target,tooltip:j.tooltip}}Ie.from=Re;function ge(j){let Oe;if(j.url)try{Oe=typeof j.url=="string"?E.URI.parse(j.url,!0):E.URI.revive(j.url)}catch{}return new a.DocumentLink(s.to(j.range),Oe)}Ie.to=ge})(ce||(e.DocumentLink=ce={}));var Me;(function(Ie){function Re(j){const Oe=new a.ColorPresentation(j.label);return j.textEdit&&(Oe.textEdit=_e.to(j.textEdit)),j.additionalTextEdits&&(Oe.additionalTextEdits=j.additionalTextEdits.map(Be=>_e.to(Be))),Oe}Ie.to=Re;function ge(j){return{label:j.label,textEdit:j.textEdit?_e.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Oe=>_e.from(Oe)):void 0}}Ie.from=ge})(Me||(e.ColorPresentation=Me={}));var xe;(function(Ie){function Re(j){return new a.Color(j[0],j[1],j[2],j[3])}Ie.to=Re;function ge(j){return[j.red,j.green,j.blue,j.alpha]}Ie.from=ge})(xe||(e.Color=xe={}));var Ge;(function(Ie){function Re(j){return{range:s.from(j.range)}}Ie.from=Re;function ge(j){return new a.SelectionRange(s.to(j.range))}Ie.to=ge})(Ge||(e.SelectionRange=Ge={}));var je;(function(Ie){function Re(ge){switch(ge){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Ie.to=Re})(je||(e.TextDocumentSaveReason=je={}));var et;(function(Ie){function Re(j){switch(j){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Ie.from=Re;function ge(j){switch(j){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Ie.to=ge})(et||(e.TextEditorLineNumbersStyle=et={}));var Ye;(function(Ie){function Re(j){if(j===a.EndOfLine.CRLF)return 1;if(j===a.EndOfLine.LF)return 0}Ie.from=Re;function ge(j){if(j===1)return a.EndOfLine.CRLF;if(j===0)return a.EndOfLine.LF}Ie.to=ge})(Ye||(e.EndOfLine=Ye={}));var Ze;(function(Ie){function Re(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ie.from=Re})(Ze||(e.ProgressLocation=Ze={}));var it;(function(Ie){function Re(j){const Oe={start:j.start+1,end:j.end+1};return j.kind&&(Oe.kind=tt.from(j.kind)),Oe}Ie.from=Re;function ge(j){const Oe={start:j.start-1,end:j.end-1};return j.kind&&(Oe.kind=tt.to(j.kind)),Oe}Ie.to=ge})(it||(e.FoldingRange=it={}));var tt;(function(Ie){function Re(j){if(j)switch(j){case a.FoldingRangeKind.Comment:return d.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return d.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return d.FoldingRangeKind.Region}}Ie.from=Re;function ge(j){if(j)switch(j.value){case d.FoldingRangeKind.Comment.value:return a.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports.value:return a.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region.value:return a.FoldingRangeKind.Region}}Ie.to=ge})(tt||(e.FoldingRangeKind=tt={}));var Ue;(function(Ie){function Re(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?s.from(ge.selection):void 0,override:typeof ge.override=="boolean"?c.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ie.from=Re})(Ue||(e.TextEditorOpenOptions=Ue={}));var st;(function(Ie){function Re(Be){return Be instanceof a.RelativePattern?Be.toJSON():typeof Be=="string"?Be:ge(Be)||j(Be)?new a.RelativePattern(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ie.from=Re;function ge(Be){const Ke=Be;return Ke?E.URI.isUri(Ke.baseUri)&&typeof Ke.pattern=="string":!1}function j(Be){const Ke=Be;return Ke?typeof Ke.base=="string"&&typeof Ke.pattern=="string":!1}function Oe(Be){return typeof Be=="string"?Be:new a.RelativePattern(E.URI.revive(Be.baseUri),Be.pattern)}Ie.to=Oe})(st||(e.GlobPattern=st={}));var Z;(function(Ie){function Re(ge){if(ge){if(Array.isArray(ge))return ge.map(Re);if(typeof ge=="string")return ge;{const j=ge;return{language:j.language,scheme:j.scheme,pattern:st.from(j.pattern),exclusive:j.exclusive,notebookType:j.notebookType}}}else return}Ie.from=Re})(Z||(e.LanguageSelector=Z={}));var X;(function(Ie){function Re(j){return!!j&&typeof j=="object"&&"selections"in j&&Array.isArray(j.selections)&&j.selections.every(Oe=>Oe instanceof a.Selection)&&"related"in j&&Array.isArray(j.related)&&j.related.every(Oe=>Oe&&typeof Oe=="object"&&E.URI.isUri(Oe.uri)&&Oe.range instanceof a.Range)}Ie.is=Re;function ge(j){return{selections:j.selections.map(Oe=>r.from(Oe)),related:j.related.map(Oe=>({uri:E.URI.from(Oe.uri),range:s.from(Oe.range)}))}}Ie.from=ge})(X||(e.MappedEditsContext=X={}));var pe;(function(Ie){function Re(j){return{start:j.start,end:j.end}}Ie.from=Re;function ge(j){return new a.NotebookRange(j.start,j.end)}Ie.to=ge})(pe||(e.NotebookRange=pe={}));var $e;(function(Ie){function Re(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}Ie.to=Re;function ge(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}Ie.from=ge})($e||(e.NotebookCellExecutionSummary=$e={}));var Ne;(function(Ie){function Re(ge){if(ge===f.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(ge===f.NotebookCellExecutionState.Pending)return;if(ge===f.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ie.to=Re})(Ne||(e.NotebookCellExecutionState=Ne={}));var Xe;(function(Ie){function Re(j){switch(j){case a.NotebookCellKind.Markup:return f.CellKind.Markup;case a.NotebookCellKind.Code:default:return f.CellKind.Code}}Ie.from=Re;function ge(j){switch(j){case f.CellKind.Markup:return a.NotebookCellKind.Markup;case f.CellKind.Code:default:return a.NotebookCellKind.Code}}Ie.to=ge})(Xe||(e.NotebookCellKind=Xe={}));var nt;(function(Ie){function Re(j){const Oe={metadata:j.metadata??Object.create(null),cells:[]};for(const Be of j.cells)a.NotebookCellData.validate(Be),Oe.cells.push(ft.from(Be));return Oe}Ie.from=Re;function ge(j){const Oe=new a.NotebookData(j.cells.map(ft.to));return(0,l.isEmptyObject)(j.metadata)||(Oe.metadata=j.metadata),Oe}Ie.to=ge})(nt||(e.NotebookData=nt={}));var ft;(function(Ie){function Re(j){return{cellKind:Xe.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:$e.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(Ft.from):[]}}Ie.from=Re;function ge(j){return new a.NotebookCellData(Xe.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(Ft.to):void 0,j.metadata,j.internalMetadata?$e.to(j.internalMetadata):void 0)}Ie.to=ge})(ft||(e.NotebookCellData=ft={}));var Et;(function(Ie){function Re(j){return{mime:j.mime,valueBytes:A.VSBuffer.wrap(j.data)}}Ie.from=Re;function ge(j){return new a.NotebookCellOutputItem(j.valueBytes.buffer,j.mime)}Ie.to=ge})(Et||(e.NotebookCellOutputItem=Et={}));var Ft;(function(Ie){function Re(j){return{outputId:j.id,items:j.items.map(Et.from),metadata:j.metadata}}Ie.from=Re;function ge(j){const Oe=j.items.map(Et.to);return new a.NotebookCellOutput(Oe,j.outputId,j.metadata)}Ie.to=ge})(Ft||(e.NotebookCellOutput=Ft={}));var Xt;(function(Ie){function Re(Oe){return j(Oe)?{include:st.from(Oe.include)??void 0,exclude:st.from(Oe.exclude)??void 0}:st.from(Oe)??void 0}Ie.from=Re;function ge(Oe){return j(Oe)?{include:st.to(Oe.include),exclude:st.to(Oe.exclude)}:st.to(Oe)}Ie.to=ge;function j(Oe){const Be=Oe;return Be?!(0,l.isUndefinedOrNull)(Be.include)&&!(0,l.isUndefinedOrNull)(Be.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var Ht;(function(Ie){function Re(ge,j,Oe){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal(Be,Oe),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ie.from=Re})(Ht||(e.NotebookStatusBarItem=Ht={}));var bt;(function(Ie){function Re(ge,j,Oe){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:j.toInternal(Be,Oe),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ie.from=Re})(bt||(e.NotebookKernelSourceAction=bt={}));var Lt;(function(Ie){function Re(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ie.from=Re})(Lt||(e.NotebookDocumentContentOptions=Lt={}));var Nt;(function(Ie){function Re(j){return{uri:j.uri,provides:j.provides}}Ie.from=Re;function ge(j){return new a.NotebookRendererScript(E.URI.revive(j.uri),j.provides)}Ie.to=ge})(Nt||(e.NotebookRendererScript=Nt={}));var qt;(function(Ie){function Re(j){return{message:B.fromStrict(j.message)||"",type:0,expected:j.expectedOutput,actual:j.actualOutput,contextValue:j.contextValue,location:j.location&&{range:s.from(j.location.range),uri:j.location.uri}}}Ie.from=Re;function ge(j){const Oe=new a.TestMessage(typeof j.message=="string"?j.message:B.to(j.message));return Oe.actualOutput=j.actual,Oe.expectedOutput=j.expected,Oe.contextValue=j.contextValue,Oe.location=j.location?q.to(j.location):void 0,Oe}Ie.to=ge})(qt||(e.TestMessage=qt={}));var Tt;(function(Ie){Ie.namespace=k.namespaceTestTag,Ie.denamespace=k.denamespaceTestTag})(Tt||(e.TestTag=Tt={}));var At;(function(Ie){function Re(j){const Oe=(0,i.getPrivateApiFor)(j).controllerId;return{extId:C.TestId.fromExtHostTestItem(j,Oe).toString(),label:j.label,uri:E.URI.revive(j.uri),busy:j.busy,tags:j.tags.map(Be=>Tt.namespace(Oe,Be.id)),range:v.Range.lift(s.from(j.range)),description:j.description||null,sortText:j.sortText||null,error:j.error&&B.fromStrict(j.error)||null}}Ie.from=Re;function ge(j){return{parent:void 0,error:void 0,id:C.TestId.fromString(j.extId).localId,label:j.label,uri:E.URI.revive(j.uri),tags:(j.tags||[]).map(Oe=>{const{tagId:Be}=Tt.denamespace(Oe);return new a.TestTag(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:s.to(j.range||void 0),canResolveChildren:!1,busy:j.busy,description:j.description||void 0,sortText:j.sortText||void 0}}Ie.toPlain=ge})(At||(e.TestItem=At={})),function(Ie){function Re(j){return{id:j.id}}Ie.from=Re;function ge(j){return new a.TestTag(j.id)}Ie.to=ge}(Tt||(e.TestTag=Tt={}));var Ut;(function(Ie){const Re=(j,Oe)=>{const Be=[];for(const[We,Je]of Oe)C.TestId.compare(Je.item.extId,We)===2&&(Oe.delete(We),Be.push(Je));const Ke={...At.toPlain(j.item),parent:void 0,taskStates:j.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(Je=>Je.type===0).map(qt.to)})),children:Be.map(We=>Re(We,Oe))};for(const We of Ke.children)We.parent=Ke;return Ke};function ge(j){const Oe=[],Be=new Map;for(const Ke of j.items){Be.set(Ke.item.extId,Ke);const We=C.TestId.root(Ke.item.extId);j.request.targets.some(Je=>Je.controllerId===We&&Je.testIds.includes(Ke.item.extId))&&Oe.push(Ke)}return{completedAt:j.completedAt,results:Oe.map(Ke=>Re(Ke,Be))}}Ie.to=ge})(Ut||(e.TestResults=Ut={}));var $t;(function(Ie){function Re(Be){return{covered:Be.covered,total:Be.covered}}function ge(Be){return"line"in Be?p.from(Be):s.from(Be)}function j(Be){return"branches"in Be?{count:Be.executionCount,location:ge(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ke=>({count:Ke.executionCount,location:Ke.location&&ge(Ke.location)})):void 0}:{type:0,count:Be.executionCount,location:ge(Be.location)}}Ie.fromDetailed=j;function Oe(Be){return{uri:Be.uri,statement:Re(Be.statementCoverage),branch:Be.branchCoverage&&Re(Be.branchCoverage),function:Be.functionCoverage&&Re(Be.functionCoverage),details:Be.detailedCoverage?.map(j)}}Ie.fromFile=Oe})($t||(e.TestCoverage=$t={}));var Wt;(function(Ie){function Re(ge){switch(ge){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Ie.to=Re})(Wt||(e.CodeActionTriggerKind=Wt={}));var Bt;(function(Ie){function Re(j){const Oe=new a.TypeHierarchyItem(Y.to(j.kind),j.name,j.detail||"",E.URI.revive(j.uri),s.to(j.range),s.to(j.selectionRange));return Oe._sessionId=j._sessionId,Oe._itemId=j._itemId,Oe}Ie.to=Re;function ge(j,Oe,Be){if(Oe=Oe??j._sessionId,Be=Be??j._itemId,Oe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Be,kind:Y.from(j.kind),name:j.name,detail:j.detail??"",uri:j.uri,range:s.from(j.range),selectionRange:s.from(j.selectionRange),tags:j.tags?.map(he.from)}}Ie.from=ge})(Bt||(e.TypeHierarchyItem=Bt={}));var at;(function(Ie){function Re(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}Ie.from=Re})(at||(e.ViewBadge=at={}));var ut;(function(Ie){function Re(Be,Ke,We){const Je=Ke.fileData;return Je?new a.InternalFileDataTransferItem(new a.DataTransferFile(Je.name,E.URI.revive(Je.uri),Je.id,(0,L.once)(()=>We(Je.id)))):Be===P.Mimes.uriList&&Ke.uriListData?new a.InternalDataTransferItem(Oe(Ke.uriListData)):new a.InternalDataTransferItem(Ke.asString)}Ie.to=Re;async function ge(Be,Ke){const We=await Ke.asString();if(Be===P.Mimes.uriList)return{asString:We,fileData:void 0,uriListData:j(We)};const Je=Ke.asFile();return{asString:We,fileData:Je?{name:Je.name,uri:Je.uri,id:Je._itemId??Je.id}:void 0}}Ie.from=ge;function j(Be){return I.UriList.split(Be).map(Ke=>{if(Ke.startsWith("#"))return Ke;try{return E.URI.parse(Ke)}catch{}return Ke})}function Oe(Be){return I.UriList.create(Be.map(Ke=>typeof Ke=="string"?Ke:E.URI.revive(Ke)))}})(ut||(e.DataTransferItem=ut={}));var jt;(function(Ie){function Re(j,Oe){const Be=j.items.map(([Ke,We])=>[Ke,ut.to(Ke,We,Oe)]);return new a.DataTransfer(Be)}Ie.toDataTransfer=Re;async function ge(j){const Oe={items:[]},Be=[];for(const[Ke,We]of j)Be.push((async()=>{Oe.items.push([Ke,await ut.from(Ke,We)])})());return await Promise.all(Be),Oe}Ie.from=ge})(jt||(e.DataTransfer=jt={}));var Pt;(function(Ie){function Re(j){return{message:j.message,metadata:j.metadata,title:j.title,tooltip:j.tooltip}}Ie.to=Re;function ge(j){return{kind:"reply",message:j.message,metadata:j.metadata,title:j.title,tooltip:j.tooltip}}Ie.from=ge})(Pt||(e.ChatReplyFollowup=Pt={}));var yt;(function(Ie){function Re(ge){return typeof ge=="string"?{title:ge,message:ge,kind:"reply"}:"commandId"in ge?{kind:"command",title:ge.title??"",commandId:ge.commandId??"",when:ge.when??"",args:ge.args}:Pt.from(ge)}Ie.from=Re})(yt||(e.ChatFollowup=yt={}));var ht;(function(Ie){function Re(j){const Oe=new a.ChatMessage(It.to(j.role),j.content);return Oe.name=j.name,Oe}Ie.to=Re;function ge(j){return{role:It.from(j.role),content:j.content,name:j.name}}Ie.from=ge})(ht||(e.ChatMessage=ht={}));var It;(function(Ie){function Re(j){switch(j){case 0:return a.ChatMessageRole.System;case 1:return a.ChatMessageRole.User;case 2:return a.ChatMessageRole.Assistant;case 3:return a.ChatMessageRole.Function}}Ie.to=Re;function ge(j){switch(j){case a.ChatMessageRole.System:return 0;case a.ChatMessageRole.Assistant:return 2;case a.ChatMessageRole.Function:return 3;case a.ChatMessageRole.User:default:return 1}}Ie.from=ge})(It||(e.ChatMessageRole=It={}));var Mt;(function(Ie){function Re(j){return{level:St.to(j.level),value:j.value,description:j.description}}Ie.to=Re;function ge(j){return{level:St.from(j.level),value:j.value,description:j.description}}Ie.from=ge})(Mt||(e.ChatVariable=Mt={}));var St;(function(Ie){function Re(j){switch(j){case"short":return a.ChatVariableLevel.Short;case"medium":return a.ChatVariableLevel.Medium;case"full":default:return a.ChatVariableLevel.Full}}Ie.to=Re;function ge(j){switch(j){case a.ChatVariableLevel.Short:return"short";case a.ChatVariableLevel.Medium:return"medium";case a.ChatVariableLevel.Full:default:return"full"}}Ie.from=ge})(St||(e.ChatVariableLevel=St={}));var He;(function(Ie){function Re(ge,j,Oe){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand}:"uri"in ge?{uri:ge.uri}:j.toInternal(ge,Oe)}Ie.from=Re})(He||(e.TerminalQuickFix=He={}))}),define(Pe[204],Te([1,0,2,9,7,8,174]),function(ve,e,S,A,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class h{constructor(m,P,D,l={timeout:1500,errors:3}){this._logService=m,this._documents=P,this._mainThreadBulkEdits=D,this._thresholds=l,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(m){return(P,D,l)=>{const v={dispose:this._callbacks.push([P,D,m])};return Array.isArray(l)&&l.push(v),v}}async $participateInSave(m,P){const D=S.URI.revive(m);let l=!1;const E=setTimeout(()=>l=!0,this._thresholds.timeout),v=[];try{for(const d of[...this._callbacks]){if(l)break;const t=this._documents.getDocument(D),i=await this._deliverEventAsyncAndBlameBadListeners(d,{document:t,reason:L.TextDocumentSaveReason.to(P)});v.push(i)}}finally{clearTimeout(E)}return v}_deliverEventAsyncAndBlameBadListeners([m,P,D],l){const E=this._badListeners.get(m);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(D,m,P,l).then(()=>!0,v=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this._logService.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const d=this._badListeners.get(m);this._badListeners.set(m,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(m,P,D,l){const E=[],v=Date.now(),{document:d,reason:t}=l,{version:i}=d,c=Object.freeze({document:d,reason:t,waitUntil(f){if(Object.isFrozen(E))throw(0,A.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(f))}});try{P.apply(D,[c])}catch(f){return Promise.reject(f)}return Object.freeze(E),new Promise((f,C)=>{const k=setTimeout(()=>C(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(k),f(n)}).catch(n=>{clearTimeout(k),C(n)})}).then(f=>{const C={edits:[]};for(const k of f)if(Array.isArray(k)&&k.every(n=>n instanceof I.TextEdit))for(const{newText:n,newEol:a,range:r}of k)C.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:r&&L.Range.from(r),text:n,eol:a&&L.EndOfLine.from(a)}});if(C.edits.length!==0)return i===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(C):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=h}),define(Pe[205],Te([1,0,12,2,8,7,75]),function(ve,e,S,A,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class h{constructor(D,l,E,v){this.start=D,this.deletedCount=l,this.deletedItems=E,this.items=v}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(D,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,l,E){this.notebook=D,this._extHostDocument=l,this._cellData=E,this.handle=E.handle,this.uri=A.URI.revive(E.uri),this.cellKind=E.cellKind,this._outputs=E.outputs.map(I.NotebookCellOutput.to),this._internalMetadata=E.internalMetadata??{},this._metadata=Object.freeze(E.metadata??{}),this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const D=this,l=this._extHostDocument.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:l.document,get mime(){return D._mime},set mime(v){D._mime=v},get outputs(){return D._outputs.slice(0)},get metadata(){return D._metadata},get executionSummary(){return D._previousResult}};this._apiCell=Object.freeze(E)}return this._apiCell}setOutputs(D){this._outputs=D.map(I.NotebookCellOutput.to)}setOutputItems(D,l,E){const v=E.map(I.NotebookCellOutputItem.to),d=this._outputs.find(t=>t.id===D);if(d&&(l||(d.items.length=0),d.items.push(...v),d.items.length>1&&d.items.every(t=>T.isTextStreamMime(t.mime)))){const t=new Map,i=[];d.items.forEach(c=>{let f;t.has(c.mime)?f=t.get(c.mime):(f=[],t.set(c.mime,f),i.push(c.mime)),f.push(c.data)}),d.items.length=0,i.forEach(c=>{const f=T.compressOutputItemStreams(t.get(c));d.items.push({mime:c,data:f.data.buffer})})}}setMetadata(D){this._metadata=Object.freeze(D)}setInternalMetadata(D){this._internalMetadata=D,this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=y;class m{static{this._handlePool=0}constructor(D,l,E,v,d){this._proxy=D,this._textDocumentsAndEditors=l,this._textDocuments=E,this.uri=v,this.handle=m._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=d.viewType,this._metadata=Object.freeze(d.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,d.cells]],!0,void 0),this._versionId=d.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const D=this,l={get uri(){return D.uri},get version(){return D._versionId},get notebookType(){return D._notebookType},get isDirty(){return D._isDirty},get isUntitled(){return D.uri.scheme===S.Schemas.untitled},get isClosed(){return D._disposed},get metadata(){return D._metadata},get cellCount(){return D._cells.length},cellAt(E){return E=D._validateIndex(E),D._cells[E].apiCell},getCells(E){return(E?D._getCells(E):D._cells).map(d=>d.apiCell)},save(){return D._save()}};this._notebook=Object.freeze(l)}return this._notebook}acceptDocumentPropertiesChanged(D){D.metadata&&(this._metadata=Object.freeze({...this._metadata,...D.metadata}))}acceptDirty(D){this._isDirty=D}acceptModelChanged(D,l,E){this._versionId=D.versionId,this._isDirty=l,this.acceptDocumentPropertiesChanged({metadata:E});const v={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},d=[];for(const i of D.rawEvents)i.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(i.changes,!1,v.contentChanges):i.kind===T.NotebookCellsChangeType.Move?this._moveCells(i.index,i.length,i.newIdx,v.contentChanges):i.kind===T.NotebookCellsChangeType.Output?(this._setCellOutputs(i.index,i.outputs),d.push({cell:this._cells[i.index].apiCell,outputs:this._cells[i.index].apiCell.outputs})):i.kind===T.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(i.index,i.outputId,i.append,i.outputItems),d.push({cell:this._cells[i.index].apiCell,outputs:this._cells[i.index].apiCell.outputs})):i.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(i.index,i.language),d.push({cell:this._cells[i.index].apiCell,document:this._cells[i.index].apiCell.document})):i.kind===T.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this._cells[i.index].apiCell,document:this._cells[i.index].apiCell.document}):i.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(i.index,i.mime):i.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(i.index,i.metadata),d.push({cell:this._cells[i.index].apiCell,metadata:this._cells[i.index].apiCell.metadata})):i.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(i.index,i.internalMetadata),d.push({cell:this._cells[i.index].apiCell,executionSummary:this._cells[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<d.length;i++){const c=d[i],f=t.get(c.cell);if(f===void 0){const C=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,C-1)}else v.cellChanges[f]={...v.cellChanges[f],...c}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}_validateIndex(D){return D=D|0,D<0?0:D>=this._cells.length?this._cells.length-1:D}_validateRange(D){let l=D.start|0,E=D.end|0;return l<0&&(l=0),E>this._cells.length&&(E=this._cells.length),D.with({start:l,end:E})}_getCells(D){D=this._validateRange(D);const l=[];for(let E=D.start;E<D.end;E++)l.push(this._cells[E]);return l}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(D,l,E){if(this._disposed)return;const v=[],d=[],t=[];if(D.reverse().forEach(i=>{const f=i[2].map(n=>{const a=new y(this,this._textDocumentsAndEditors,n);return l||d.push(y.asModelAddData(this.apiNotebook,n)),a}),C=new h(i[0],i[1],[],f),k=this._cells.splice(i[0],i[1],...f);for(const n of k)t.push(n.uri),C.deletedItems.push(n.apiCell);v.push(C)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:t}),E)for(const i of v)E.push(i.asApiEvent())}_moveCells(D,l,E,v){const d=this._cells.splice(D,l);this._cells.splice(E,0,...d);const t=[new h(D,l,d.map(i=>i.apiCell),[]),new h(E,0,[],d)];for(const i of t)v.push(i.asApiEvent())}_setCellOutputs(D,l){this._cells[D].setOutputs(l)}_setCellOutputItems(D,l,E,v){this._cells[D].setOutputItems(l,E,v)}_changeCellLanguage(D,l){const E=this._cells[D];E.apiCell.document.languageId!==l&&this._textDocuments.$acceptModelLanguageChanged(E.uri,l)}_changeCellMime(D,l){const E=this._cells[D];E.apiCell.mime=l}_changeCellMetadata(D,l){this._cells[D].setMetadata(l)}_changeCellInternalMetadata(D,l){this._cells[D].setInternalMetadata(l)}getCellFromApiCell(D){return this._cells.find(l=>l.apiCell===D)}getCellFromIndex(D){return this._cells[D]}getCell(D){return this._cells.find(l=>l.handle===D)}getCellIndex(D){return this._cells.indexOf(D)}}e.ExtHostNotebookDocument=m}),define(Pe[206],Te([1,0,5,2,8,7]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class T{constructor(y,m,P,D={timeout:1500,errors:3}){this._logService=y,this._notebooksAndEditors=m,this._mainThreadBulkEdits=P,this._thresholds=D,this._onWillSaveNotebookDocumentEvent=new S.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(m,P,D)=>{const l=function(v){m.call(P,v)};return l.extension=y,this._onWillSaveNotebookDocumentEvent.event(l,void 0,D)}}async $participateInSave(y,m,P){const D=A.URI.revive(y),l=this._notebooksAndEditors.getNotebookDocument(D);if(!l)throw new Error("Unable to resolve notebook document");const E=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:l.apiNotebook,reason:I.TextDocumentSaveReason.to(m)},P,async(d,t)=>{const i=Date.now(),c=await await Promise.resolve(d);Date.now()-i>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&c&&(c instanceof L.WorkspaceEdit?E.push(c):this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(E.length===0)return!0;const v={edits:[]};for(const d of E){const{edits:t}=I.WorkspaceEdit.from(d);v.edits=v.edits.concat(t)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(v)}}e.ExtHostNotebookDocumentSaveParticipant=T}),define(Pe[104],Te([1,0,9,8,7]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(h,y,m,P,D,l){this.id=h,this._proxy=y,this.notebookData=m,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=D,this._visibleRanges=P,this._viewColumn=l}get apiEditor(){if(!this._editor){const h=this;this._editor={get notebook(){return h.notebookData.apiNotebook},get selection(){return h._selections[0]},set selection(y){this.selections=[y]},get selections(){return h._selections},set selections(y){if(!Array.isArray(y)||!y.every(I.NotebookRange.isNotebookRange))throw(0,S.illegalArgument)("selections");h._selections=y,h._trySetSelections(y)},get visibleRanges(){return h._visibleRanges},revealRange(y,m){h._proxy.$tryRevealRange(h.id,A.NotebookRange.from(y),m??I.NotebookEditorRevealType.Default)},get viewColumn(){return h._viewColumn}},L.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(h){this._visible=h}_acceptVisibleRanges(h){this._visibleRanges=h}_acceptSelections(h){this._selections=h}_trySetSelections(h){this._proxy.$trySetSelections(this.id,h.map(A.NotebookRange.from))}_acceptViewColumn(h){this._viewColumn=h}}e.ExtHostNotebookEditor=L}),define(Pe[207],Te([1,0,9,5,14,8]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let T=class{constructor(y,m){this._logService=y,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new A.Emitter({onListenerError:S.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new A.Emitter({onListenerError:S.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(y,m){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,m);const P=this._notebooksAndEditors.getEditorById(y);m.visibleRanges&&P._acceptVisibleRanges(m.visibleRanges.ranges.map(L.NotebookRange.to)),m.selections&&P._acceptSelections(m.selections.selections.map(L.NotebookRange.to)),m.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),m.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const m in y)this._notebooksAndEditors.getEditorById(m)._acceptViewColumn(L.ViewColumn.to(y[m]))}};e.ExtHostNotebookEditors=T,e.ExtHostNotebookEditors=T=Ve([ze(0,I.ILogService)],T)}),define(Pe[208],Te([1,0,8,73,153,21,65,9]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(l){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=l}async withProgress(l,E,v){const d=this._handles++,{title:t,location:i,cancellable:c}=E,f={label:(0,I.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this._proxy.$startProgress(d,{location:S.ProgressLocation.from(i),title:t,source:f,cancellable:c},l.isUnderDevelopment?void 0:l.identifier.value).catch(h.onUnexpectedExternalError),this._withProgress(d,v,!!c)}_withProgress(l,E,v){let d;v&&(d=new L.CancellationTokenSource,this._mapHandleToCancellationSource.set(l,d));const t=c=>{this._proxy.$progressEnd(c),this._mapHandleToCancellationSource.delete(c),d?.dispose()};let i;try{i=E(new P(this._proxy,l),v&&d?d.token:L.CancellationToken.None)}catch(c){throw t(l),c}return i.then(c=>t(l),c=>t(l)),i}$acceptProgressCanceled(l){const E=this._mapHandleToCancellationSource.get(l);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(l))}}e.ExtHostProgress=y;function m(D,l){return D.message=l.message,typeof l.increment=="number"&&(typeof D.increment=="number"?D.increment+=l.increment:D.increment=l.increment),D}class P extends A.Progress{constructor(l,E){super(v=>this.throttledReport(v)),this._proxy=l,this._handle=E}throttledReport(l){this._proxy.$progressReport(this._handle,l)}}Ve([(0,T.throttle)(100,(D,l)=>m(D,l),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Pe[105],Te([1,0,44,102,45,76,57,8,2]),function(ve,e,S,A,I,L,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const m=(f,C,k,n)=>{let a=C;return{enumerable:!0,configurable:!1,get(){return a},set(r){if(!k(a,r)){const s=a;a=r,f.listener?.(n(r,s))}}}},P=(f,C)=>f===C,D={range:(f,C)=>f===C?!0:!f||!C?!1:f.isEqual(C),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(f,C)=>!(f.length!==C.length||f.some(k=>!C.find(n=>k.id===n.id)))},l=f=>C=>({op:4,update:f(C)}),E=(f,C)=>({range:(()=>{let k;const n=l(a=>({range:S.Range.lift(h.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return k},set(a){f.listener?.({op:6}),D.range(k,a)||(k=a,f.listener?.(n(a)))}}})(),label:m(f,C,D.label,l(k=>({label:k}))),description:m(f,void 0,D.description,l(k=>({description:k}))),sortText:m(f,void 0,D.sortText,l(k=>({sortText:k}))),canResolveChildren:m(f,!1,D.canResolveChildren,k=>({op:2,state:k})),busy:m(f,!1,D.busy,l(k=>({busy:k}))),error:m(f,void 0,D.error,l(k=>({error:h.MarkdownString.fromStrict(k)||null}))),tags:m(f,[],D.tags,(k,n)=>({op:1,new:k.map(h.TestTag.from),old:n.map(h.TestTag.from)}))}),v=f=>{const C=I.TestId.fromString(f.extId),k=new t(C.controllerId,C.localId,f.label,y.URI.revive(f.uri)||void 0);return k.range=h.Range.to(f.range||void 0),k.description=f.description||void 0,k.sortText=f.sortText||void 0,k.tags=f.tags.map(n=>h.TestTag.to({id:(0,T.denamespaceTestTag)(n).tagId})),k},d=f=>{let C;for(const k of f.tests){const n=v(k.item);(0,A.getPrivateApiFor)(n).parent=C,C=n}return C};e.toItemFromContext=d;class t{constructor(C,k,n,a){if(k.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(k)} symbol`);const r=(0,A.createPrivateApiFor)(this,C);Object.defineProperties(this,{id:{value:k,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof i?void 0:r.parent}},children:{value:(0,L.createTestItemChildren)(r,A.getPrivateApiFor,t),enumerable:!0,writable:!1},...E(r,n)})}}e.TestItemImpl=t;class i extends t{constructor(C,k){super(C,C,k,void 0),this._isRoot=!0}}e.TestItemRootImpl=i;class c extends L.TestItemCollection{constructor(C,k,n){super({controllerId:C,getDocumentVersion:a=>a&&n.getDocument(a)?.version,getApiFor:A.getPrivateApiFor,getChildren:a=>a.children,root:new i(C,k),toITestItem:h.TestItem.from})}}e.ExtHostTestItemCollection=c}),define(Pe[106],Te([1,0,50,9,88,8,7]),function(ve,e,S,A,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class h{static{this._Keys=new I.IdGenerator("TextEditorDecorationType")}constructor(l,E,v){const d=h._Keys.nextId();l.$registerTextEditorDecorationType(E.identifier,d,L.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:d,dispose(){l.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=h;class y{constructor(l,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,E){this._throwIfFinalized();let v=null;if(l instanceof T.Position)v=new T.Range(l,l);else if(l instanceof T.Range)v=l;else throw new Error("Unrecognized location");this._pushEdit(v,E,!1)}insert(l,E){this._throwIfFinalized(),this._pushEdit(new T.Range(l,l),E,!0)}delete(l){this._throwIfFinalized();let E=null;if(l instanceof T.Range)E=l;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(l,E,v){const d=this._document.validateRange(l);this._collectedEdits.push({range:d,text:E,forceMoveMarkers:v})}setEndOfLine(l){if(this._throwIfFinalized(),l!==T.EndOfLine.LF&&l!==T.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this._setEndOfLine=l}}class m{constructor(l,E,v,d){this._proxy=l,this._id=E,this._accept(v),this._logService=d;const t=this;this.value={get tabSize(){return t._tabSize},set tabSize(i){t._setTabSize(i)},get indentSize(){return t._indentSize},set indentSize(i){t._setIndentSize(i)},get insertSpaces(){return t._insertSpaces},set insertSpaces(i){t._setInsertSpaces(i)},get cursorStyle(){return t._cursorStyle},set cursorStyle(i){t._setCursorStyle(i)},get lineNumbers(){return t._lineNumbers},set lineNumbers(i){t._setLineNumbers(i)}}}_accept(l){this._tabSize=l.tabSize,this._indentSize=l.indentSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=L.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const E=Math.floor(l);return E>0?E:null}if(typeof l=="string"){const E=parseInt(l,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(l){const E=this._validateTabSize(l);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateIndentSize(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const E=Math.floor(l);return E>0?E:null}if(typeof l=="string"){const E=parseInt(l,10);return isNaN(E)?null:E>0?E:null}return null}_setIndentSize(l){const E=this._validateIndentSize(l);if(E!==null){if(typeof E=="number"){if(this._indentSize===E)return;this._indentSize=E}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:E}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:!!l}_setInsertSpaces(l){const E=this._validateInsertSpaces(l);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:L.TextEditorLineNumbersStyle.from(l)})))}assign(l){const E={};let v=!1;if(typeof l.tabSize<"u"){const d=this._validateTabSize(l.tabSize);d==="auto"?(v=!0,E.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,v=!0,E.tabSize=d)}if(typeof l.indentSize<"u"){const d=this._validateIndentSize(l.indentSize);d==="tabSize"?(v=!0,E.indentSize=d):typeof d=="number"&&this._indentSize!==d&&(this._indentSize=d,v=!0,E.indentSize=d)}if(typeof l.insertSpaces<"u"){const d=this._validateInsertSpaces(l.insertSpaces);d==="auto"?(v=!0,E.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,v=!0,E.insertSpaces=d)}typeof l.cursorStyle<"u"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,v=!0,E.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,v=!0,E.lineNumbers=L.TextEditorLineNumbersStyle.from(l.lineNumbers)),v&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(l,E){E.catch(v=>{this._logService.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this._logService.warn(v)})}}e.ExtHostTextEditorOptions=m;class P{constructor(l,E,v,d,t,i,c,f){this.id=l,this._proxy=E,this._logService=v,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=t,this._options=new m(this._proxy,this.id,i,v),this._visibleRanges=c,this._viewColumn=f;const C=this;this.value=Object.freeze({get document(){return d.value},set document(k){throw(0,A.readonly)("document")},get selection(){return C._selections&&C._selections[0]},set selection(k){if(!(k instanceof T.Selection))throw(0,A.illegalArgument)("selection");C._selections=[k],C._trySetSelection()},get selections(){return C._selections},set selections(k){if(!Array.isArray(k)||k.some(n=>!(n instanceof T.Selection)))throw(0,A.illegalArgument)("selections");C._selections=k,C._trySetSelection()},get visibleRanges(){return C._visibleRanges},set visibleRanges(k){throw(0,A.readonly)("visibleRanges")},get options(){return C._options.value},set options(k){C._disposed||C._options.assign(k)},get viewColumn(){return C._viewColumn},set viewColumn(k){throw(0,A.readonly)("viewColumn")},edit(k,n={undoStopBefore:!0,undoStopAfter:!0}){if(C._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new y(d.value,n);return k(a),C._applyEdit(a)},insertSnippet(k,n,a={undoStopBefore:!0,undoStopAfter:!0}){if(C._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!n||Array.isArray(n)&&n.length===0)r=C._selections.map(s=>L.Range.from(s));else if(n instanceof T.Position){const{lineNumber:s,column:b}=L.Position.from(n);r=[{startLineNumber:s,startColumn:b,endLineNumber:s,endColumn:b}]}else if(n instanceof T.Range)r=[L.Range.from(n)];else{r=[];for(const s of n)if(s instanceof T.Range)r.push(L.Range.from(s));else{const{lineNumber:b,column:p}=L.Position.from(s);r.push({startLineNumber:b,startColumn:p,endLineNumber:b,endColumn:p})}}return E.$tryInsertSnippet(l,d.value.version,k.value,r,a)},setDecorations(k,n){const a=n.length===0;a&&!C._hasDecorationsForKey.has(k.key)||(a?C._hasDecorationsForKey.delete(k.key):C._hasDecorationsForKey.add(k.key),C._runOnProxy(()=>{if(L.isDecorationOptionsArr(n))return E.$trySetDecorations(l,k.key,L.fromRangeOrRangeWithMessage(n));{const r=new Array(4*n.length);for(let s=0,b=n.length;s<b;s++){const p=n[s];r[4*s]=p.start.line+1,r[4*s+1]=p.start.character+1,r[4*s+2]=p.end.line+1,r[4*s+3]=p.end.character+1}return E.$trySetDecorationsFast(l,k.key,r)}}))},revealRange(k,n){C._runOnProxy(()=>E.$tryRevealRange(l,L.Range.from(k),n||T.TextEditorRevealType.Default))},show(k){E.$tryShowEditor(l,L.ViewColumn.from(k))},hide(){E.$tryHideEditor(l)}})}dispose(){(0,S.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,S.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,S.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,S.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,S.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(L.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const E=l.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const v=E.edits.map(t=>t.range);v.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=v.length-1;t<i;t++){const c=v[t].end;if(v[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=E.edits.map(t=>({range:L.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,d,{setEndOfLine:typeof E.setEndOfLine=="number"?L.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=P}),define(Pe[209],Te([1,0,4,172]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,S.refineServiceDecorator)(A.IEnvironmentService)}),define(Pe[107],Te([1,0,20,5,19,6]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=T;class h{static isHostExtension(t,i,c){if(i.getExtensionDescription(t))return!1;const f=c.getExtensionDescription(t);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(t,i){this._activationEventsReader=t,this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new S.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this._extensionsMap.set(t.identifier,t),this._extensionsArr.push(t);const i=this._activationEventsReader.readActivationEvents(t);if(Array.isArray(i))for(let c of i)c==="onUri"&&(c=`onUri:${S.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(c)||this._activationMap.set(c,[]),this._activationMap.get(c).push(t)}}set(t){this._extensionDescriptions=t,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,i){this._extensionDescriptions=v(this._extensionDescriptions,i),this._extensionDescriptions=this._extensionDescriptions.concat(t);const c=h._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=v(this._extensionDescriptions,c.map(f=>f.identifier)),this._initialize(),this._onDidChange.fire(void 0),new T(c)}static _findLoopingExtensions(t){const i=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(n){this._nodesSet.has(n)||(this._nodesSet.add(n),this._nodesArr.push(n))}addArc(n,a){this.addNode(n),this.addNode(a),this._arcs.has(n)?this._arcs.get(n).push(a):this._arcs.set(n,[a])}getArcs(n){return this._arcs.has(n)?this._arcs.get(n):[]}hasOnlyGoodArcs(n,a){const r=i.getArcs(n);for(let s=0;s<r.length;s++)if(!a.has(r[s]))return!1;return!0}getNodes(){return this._nodesArr}},c=new S.ExtensionIdentifierMap;for(const n of t)if(c.set(n.identifier,n),n.extensionDependencies)for(const a of n.extensionDependencies)i.addArc(S.ExtensionIdentifier.toKey(n.identifier),S.ExtensionIdentifier.toKey(a));const f=new Set;i.getNodes().filter(n=>i.getArcs(n).length===0).forEach(n=>f.add(n));const C=i.getNodes().filter(n=>!f.has(n));let k;do{k=!1;for(let n=0;n<C.length;n++){const a=C[n];i.hasOnlyGoodArcs(a,f)&&(C.splice(n,1),n--,f.add(a),k=!0)}}while(k);return C.map(n=>c.get(n))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(t)}getExtensionDescriptionsForActivationEvent(t){const i=this._activationMap.get(t);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const i=this._extensionsMap.get(t);return i||void 0}getExtensionDescriptionByUUID(t){for(const i of this._extensionsArr)if(i.uuid===t)return i}getExtensionDescriptionByIdOrUUID(t,i){return this.getExtensionDescription(t)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.ExtensionDescriptionRegistry=h,e.basicActivationEventsReader={readActivationEvents:d=>d.activationEvents};class y{constructor(t){this._lock=new D,this._actual=new h(t,[])}async acquireLock(t){const i=await this._lock.acquire(t);return new m(this,i)}deltaExtensions(t,i,c){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(i,c)}containsActivationEvent(t){return this._actual.containsActivationEvent(t)}containsExtension(t){return this._actual.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this._actual.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getExtensionDescription(t){return this._actual.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this._actual.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,i){return this._actual.getExtensionDescriptionByIdOrUUID(t,i)}}e.LockableExtensionDescriptionRegistry=y;class m extends L.Disposable{constructor(t,i){super(),this._registry=t,this._isDisposed=!1,this._register(i)}isAcquiredFor(t){return!this._isDisposed&&this._registry===t}}e.ExtensionDescriptionRegistryLock=m;class P{constructor(t){this.name=t,this.promise=new Promise((i,c)=>{this._resolve=i})}resolve(t){this._resolve(t)}}class D{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(t){const i=new P(t);return this._pendingCustomers.push(i),this._advance(),i.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const t=this._pendingCustomers.shift();this._isLocked=!0;let i=!0;const c=setTimeout(()=>{i&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),f=()=>{i&&(clearTimeout(c),i=!1,this._isLocked=!1,this._advance())};t.resolve((0,L.toDisposable)(f))}}var l;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(l||(l={}));function E(d,t){const i=d.isBuiltin?0:d.isUnderDevelopment?2:1,c=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(i!==c)return i-c;const f=I.posix.basename(d.extensionLocation.path),C=I.posix.basename(t.extensionLocation.path);return f<C?-1:f>C?1:0}function v(d,t){const i=new S.ExtensionIdentifierSet(t);return d.filter(c=>!i.has(c.identifier))}}),define(Pe[79],Te([1,0,25]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(A||(e.UIKind=A={}));var I;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var L;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function T(m){const P=S.VSBuffer.alloc(1);switch(m){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.createMessageOfType=T;function h(m,P){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.isMessageOfType=h;var y;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(Pe[58],Te([1,0,4,5,14,27,79,51,53,24,2,6,155]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let E=class extends D.Disposable{constructor(i,c){super(),this.initData=i,this.loggerService=c,this._onDidChangeTelemetryEnabled=this._register(new A.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new A.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=P.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=c.createLogger(this.extHostTelemetryLogFile,{id:y.extensionTelemetryLogChannelId,name:(0,l.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(c.onDidChangeLogLevel(f=>{(0,I.isLogLevel)(f)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(i,c,f){const C=this.getTelemetryDetails(),k=new v(c,f,i,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(i),{isUsageEnabled:C.isUsageEnabled,isErrorsEnabled:C.isErrorsEnabled}),n=this._telemetryLoggers.get(i.identifier.value)??[];return this._telemetryLoggers.set(i.identifier.value,[...n,k]),k.apiTelemetryLogger}$initializeTelemetryLevel(i,c,f){this._level=i,this._telemetryIsSupported=c,this._productConfig=f??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(i){const c=Object.create(null);switch(c["common.extname"]=`${i.publisher}.${i.name}`,c["common.extversion"]=i.version,c["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,c["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,c["common.vscodeversion"]=this.initData.version,c["common.isnewappinstall"]=d(this.initData.telemetryInfo.firstSessionDate),c["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case T.UIKind.Web:c["common.uikind"]="web";break;case T.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,h.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),c}$onDidChangeTelemetryLevel(i){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=i;const c=this.getTelemetryDetails();this._telemetryLoggers.forEach((f,C)=>{const k=f.filter(n=>!n.isDisposed);k.length===0?this._telemetryLoggers.delete(C):this._telemetryLoggers.set(C,k)}),this._telemetryLoggers.forEach(f=>{for(const C of f)C.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(i,c){const C=this._telemetryLoggers.get(i.value)?.filter(n=>!n.isDisposed);if(!C)return this._telemetryLoggers.delete(i.value),!1;let k=!1;for(const n of C)n.ignoreUnhandledExtHostErrors||(n.logError(c),k=!0);return k}};e.ExtHostTelemetry=E,e.ExtHostTelemetry=E=Ve([ze(0,L.IExtHostInitDataService),ze(1,I.ILoggerService)],E);class v{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,c,f,C,k,n,a){this._extension=f,this._logger=C,this._inLoggingOnlyMode=k,this._commonProperties=n,this._onDidChangeEnableStates=new A.Emitter,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=c?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=c?.additionalCommonProperties,this._sender=i,this._telemetryEnablements={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(i,c){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:i,isErrorsEnabled:c},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(i){let c="properties"in i?i.properties??{}:i;return c=(0,y.cleanData)(c,[]),this._additionalCommonProperties&&(c=(0,m.mixin)(c,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(c=(0,m.mixin)(c,this._commonProperties)),"properties"in i?i.properties=c:i=c,i}logEvent(i,c){this._sender&&(this._extension.publisher==="vscode"?i=this._extension.name+"/"+i:i=this._extension.identifier.value+"/"+i,c=this.mixInCommonPropsAndCleanData(c||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(i,c),this._logger.trace(i,c))}logUsage(i,c){this._telemetryEnablements.isUsageEnabled&&this.logEvent(i,c)}logError(i,c){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof i=="string")this.logEvent(i,c);else{const f={name:i.name,message:i.message,stack:i.stack,cause:i.cause},C=(0,y.cleanData)(f,[]),k=new Error(C.message,{cause:C.cause});k.stack=C.stack,k.name=C.name,c=this.mixInCommonPropsAndCleanData(c||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(k,c),this._logger.trace("exception",c)}}get apiTelemetryLogger(){if(!this._apiObject){const i=this,c={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return i._telemetryEnablements.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i._onDidChangeEnableStates.event.bind(i)};this._apiObject=Object.freeze(c)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let i=this._sender;this._sender=void 0,Promise.resolve(i.flush()).then(i=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=v;function d(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.isNewAppInstall=d,e.IExtHostTelemetry=(0,S.createDecorator)("IExtHostTelemetry")}),define(Pe[26],Te([1,0,5,2,181,98,20,4]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,h.createDecorator)("extensionService");class y{constructor(k){this.dependency=k}}e.MissingExtensionDependency=y;var m;(function(C){C[C.EagerAutoStart=1]="EagerAutoStart",C[C.EagerManualStart=2]="EagerManualStart",C[C.Lazy=3]="Lazy"})(m||(e.ExtensionHostStartup=m={}));class P{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,addActivationEvents:L.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions),myToRemove:[],myToAdd:this._myExtensions}}set(k,n){const a=[],r=[],s=[],b=[],p=D(this._allExtensions),w=D(k),_=(z,H)=>z.extensionLocation.toString()===H.extensionLocation.toString()||z.isBuiltin===H.isBuiltin||z.isUserBuiltin===H.isUserBuiltin||z.isUnderDevelopment===H.isUnderDevelopment;for(const z of this._allExtensions){const H=w.get(z.identifier);if(!H){a.push(z.identifier),p.delete(z.identifier);continue}if(!_(z,H)){a.push(z.identifier),p.delete(z.identifier);continue}}for(const z of k){const H=p.get(z.identifier);if(!H){r.push(z);continue}if(!_(H,z)){a.push(H.identifier),p.delete(H.identifier);continue}}const o=new T.ExtensionIdentifierSet(this._myExtensions),u=new T.ExtensionIdentifierSet(n);for(const z of this._myExtensions)u.has(z)||s.push(z);for(const z of n)o.has(z)||b.push(z);const g=L.ImplicitActivationEvents.createActivationEventsMap(r),O={toRemove:a,toAdd:r,addActivationEvents:g,myToRemove:s,myToAdd:b};return this.delta(O),O}delta(k){const{toRemove:n,toAdd:a,myToRemove:r,myToAdd:s}=k,b=new T.ExtensionIdentifierSet(n),p=new T.ExtensionIdentifierSet(r);for(let w=0;w<this._allExtensions.length;w++)b.has(this._allExtensions[w].identifier)&&(this._allExtensions.splice(w,1),w--);for(let w=0;w<this._myExtensions.length;w++)p.has(this._myExtensions[w])&&(this._myExtensions.splice(w,1),w--);for(const w of a)this._allExtensions.push(w);for(const w of s)this._myExtensions.push(w)}containsExtension(k){for(const n of this._myExtensions)if(T.ExtensionIdentifier.equals(n,k))return!0;return!1}}e.ExtensionHostExtensions=P;function D(C){const k=new T.ExtensionIdentifierMap;for(const n of C)k.set(n.identifier,n);return k}function l(C,k){return C.enabledApiProposals?C.enabledApiProposals.includes(k):!1}e.isProposedApiEnabled=l;function E(C,k){if(!l(C,k))throw new Error(`Extension '${C.identifier.value}' CANNOT use API proposal: ${k}.
Its package.json#enabledApiProposals-property declares: ${C.enabledApiProposals?.join(", ")??"[]"} but NOT ${k}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${C.identifier.value}`)}e.checkProposedApiEnabled=E;class v{constructor(k,n,a,r){this.codeLoadingTime=k,this.activateCallTime=n,this.activateResolvedTime=a,this.activationReason=r}}e.ActivationTimes=v;class d{constructor(k,n){this.description=k,this.value=n}}e.ExtensionPointContribution=d;var t;(function(C){C[C.Normal=0]="Normal",C[C.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(C){return{type:C.isBuiltin?0:1,isBuiltin:C.isBuiltin||C.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(C.publisher,C.name),uuid:C.uuid},manifest:C,location:C.extensionLocation,targetPlatform:C.targetPlatform,validations:[],isValid:!0}}e.toExtension=i;function c(C,k){return{identifier:new T.ExtensionIdentifier((0,I.getExtensionId)(C.manifest.publisher,C.manifest.name)),isBuiltin:C.type===0,isUserBuiltin:C.type===1&&C.isBuiltin,isUnderDevelopment:!!k,extensionLocation:C.location,...C.manifest,uuid:C.identifier.uuid,targetPlatform:C.targetPlatform}}e.toExtensionDescription=c;class f{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(k){return Promise.resolve(void 0)}activationEventIsDone(k){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(k){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(k,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(k){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=f}),define(Pe[210],Te([1,0,9,107,20,26,14,13]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{static{this.NONE=new y(!1,-1,-1,-1)}constructor(i,c,f,C){this.startup=i,this.codeLoadingTime=c,this.activateCallTime=f,this.activateResolvedTime=C}}e.ExtensionActivationTimes=y;class m{constructor(i){this._startup=i,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(i,c){return i===-1||c===-1?-1:c-i}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=m;class P{constructor(i,c,f,C,k,n){this.activationFailed=i,this.activationFailedError=c,this.activationTimes=f,this.module=C,this.exports=k,this.subscriptions=n}}e.ActivatedExtension=P;class D extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class l extends P{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=l;class E extends P{constructor(i){super(!0,i,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(i,c,f,C){this._logService=C,this._registry=i,this._globalRegistry=c,this._host=f,this._operations=new I.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[i,c]of this._operations)c.dispose()}async waitForActivatingExtensions(){const i=[];for(const[c,f]of this._operations)i.push(f.wait());await Promise.all(i)}isActivated(i){const c=this._operations.get(i);return!!(c&&c.value)}getActivatedExtension(i){const c=this._operations.get(i);if(!c||!c.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return c.value}async activateByEvent(i,c){if(this._alreadyActivatedEvents[i])return;const f=this._registry.getExtensionDescriptionsForActivationEvent(i);await this._activateExtensions(f.map(C=>({id:C.identifier,reason:{startup:c,extensionId:C.identifier,activationEvent:i}}))),this._alreadyActivatedEvents[i]=!0}activateById(i,c){const f=this._registry.getExtensionDescription(i);if(!f)throw new Error(`Extension '${i}' is not known`);return this._activateExtensions([{id:f.identifier,reason:c}])}async _activateExtensions(i){const c=i.filter(f=>!this.isActivated(f.id)).map(f=>this._handleActivationRequest(f));await Promise.all(c.map(f=>f.wait()))}_handleActivationRequest(i){if(this._operations.has(i.id))return this._operations.get(i.id);if(this._isHostExtension(i.id))return this._createAndSaveOperation(i,null,[],null);const c=this._registry.getExtensionDescription(i.id);if(!c){const k=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this._createAndSaveOperation(i,null,[],new E(k));return this._host.onExtensionActivationError(i.id,k,new L.MissingExtensionDependency(i.id.value)),n}const f=[],C=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const k of C){if(this._isResolvedExtension(k))continue;const n=this._operations.get(k);if(n){f.push(n);continue}if(this._isHostExtension(k)){f.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(k).identifier,reason:i.reason}));continue}const a=this._registry.getExtensionDescription(k);if(a){if(!a.main&&!a.browser)continue;f.push(this._handleActivationRequest({id:a.identifier,reason:i.reason}));continue}const r=c.displayName||c.identifier.value,s=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${k}'`),b=this._createAndSaveOperation(i,c.displayName,[],new E(s));return this._host.onExtensionActivationError(c.identifier,s,new L.MissingExtensionDependency(k)),b}return this._createAndSaveOperation(i,c.displayName,f,null)}_createAndSaveOperation(i,c,f,C){const k=new d(i.id,c,i.reason,f,C,this._host,this._logService);return this._operations.set(i.id,k),k}_isHostExtension(i){return A.ExtensionDescriptionRegistry.isHostExtension(i,this._registry,this._globalRegistry)}_isResolvedExtension(i){const c=this._globalRegistry.getExtensionDescription(i);return c?!c.main&&!c.browser:!1}};e.ExtensionsActivator=v,e.ExtensionsActivator=v=Ve([ze(3,T.ILogService)],v);let d=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(i,c,f,C,k,n,a){this._id=i,this._displayName=c,this._reason=f,this._deps=C,this._value=k,this._host=n,this._logService=a,this._barrier=new h.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let i=0;i<this._deps.length;i++){const c=this._deps[i];if(c.value&&!c.value.activationFailed){this._deps.splice(i,1),i--;continue}if(c.value&&c.value.activationFailed){const f=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);f.detail=c.value.activationFailedError,this._value=new E(f),this._host.onExtensionActivationError(this._id,f,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(i=>i.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(i){const c=new Error;if(i&&i.name&&(c.name=i.name),i&&i.message?c.message=`Activating extension '${this._id.value}' failed: ${i.message}.`:c.message=`Activating extension '${this._id.value}' failed: ${i}.`,i&&i.stack&&(c.stack=i.stack),this._value=new E(c),this._isDisposed&&S.isCancellationError(i))return;this._host.onExtensionActivationError(this._id,c,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(i)}}};d=Ve([ze(6,T.ILogService)],d)}),define(Pe[211],Te([1,0,157,7,23,2,5,6,193,13,7,16,18,8,49,21,126,26]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function c(k,n){if((0,D.isString)(k))return{label:k};if(k&&typeof k=="object"&&typeof k.label=="string"){let a;return Array.isArray(k.highlights)&&(a=k.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),a=a.length?a:void 0),{label:k.label,highlights:a}}}class f{constructor(n,a,r){this._proxy=n,this.commands=a,this.logService=r,this.treeViews=new Map,this.treeDragAndDropService=new t.TreeViewsDnDService;function s(b){return b&&b.$treeViewId&&(b.$treeItemHandle||b.$selectedTreeItems||b.$focusedTreeItem)}a.registerArgumentProcessor({processArgument:b=>s(b)?this.convertArgument(b):Array.isArray(b)&&b.length>0?b.map(p=>s(p)?this.convertArgument(p):p):b})}registerTreeDataProvider(n,a,r){const s=this.createTreeView(n,{treeDataProvider:a},r);return{dispose:()=>s.dispose()}}createTreeView(n,a,r){if(!a||!a.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=a.dragAndDropController?.dropMimeTypes??[],b=a.dragAndDropController?.dragMimeTypes??[],p=!!a.dragAndDropController?.handleDrag,w=!!a.dragAndDropController?.handleDrop,_=this.createExtHostTreeView(n,a,r),o={showCollapseAll:!!a.showCollapseAll,canSelectMany:!!a.canSelectMany,dropMimeTypes:s,dragMimeTypes:b,hasHandleDrag:p,hasHandleDrop:w,manuallyManageCheckboxes:!!a.manageCheckboxStateManually},u=this._proxy.$registerTreeViewDataProvider(n,o);return{get onDidCollapseElement(){return _.onDidCollapseElement},get onDidExpandElement(){return _.onDidExpandElement},get selection(){return _.selectedElements},get onDidChangeSelection(){return _.onDidChangeSelection},get activeItem(){return(0,i.checkProposedApiEnabled)(r,"treeViewActiveItem"),_.focusedElement},get onDidChangeActiveItem(){return(0,i.checkProposedApiEnabled)(r,"treeViewActiveItem"),_.onDidChangeActiveItem},get visible(){return _.visible},get onDidChangeVisibility(){return _.onDidChangeVisibility},get onDidChangeCheckboxState(){return _.onDidChangeCheckboxState},get message(){return _.message},set message(O){(0,v.isMarkdownString)(O)&&(0,i.checkProposedApiEnabled)(r,"treeViewMarkdownMessage"),_.message=O},get title(){return _.title},set title(O){_.title=O},get description(){return _.description},set description(O){_.description=O},get badge(){return _.badge},set badge(O){O!==void 0&&P.ViewBadge.isViewBadge(O)?_.badge={value:Math.floor(Math.abs(O.value)),tooltip:O.tooltip}:O===void 0&&(_.badge=void 0)},reveal:(O,z)=>_.reveal(O,z),dispose:async()=>{await u,this.treeViews.delete(n),_.dispose()}}}$getChildren(n,a){const r=this.treeViews.get(n);return r?r.getChildren(a):Promise.reject(new y.NoTreeViewError(n))}async $handleDrop(n,a,r,s,b,p,w,_){const o=this.treeViews.get(n);if(!o)return Promise.reject(new y.NoTreeViewError(n));const u=E.DataTransfer.toDataTransfer(r,async g=>(await this._proxy.$resolveDropFileData(n,a,g)).buffer);return w===n&&_&&await this.addAdditionalTransferItems(u,o,_,b,p),o.onDrop(u,s,b)}async addAdditionalTransferItems(n,a,r,s,b){const p=this.treeDragAndDropService.removeDragOperationTransfer(b);if(p)(await p)?.forEach((w,_)=>{w&&n.set(_,w)});else if(b&&a.handleDrag){const w=a.handleDrag(r,n,s);this.treeDragAndDropService.addDragOperationTransfer(b,w),await w}return n}async $handleDrag(n,a,r,s){const b=this.treeViews.get(n);if(!b)return Promise.reject(new y.NoTreeViewError(n));const p=await this.addAdditionalTransferItems(new A.DataTransfer,b,a,s,r);if(!(!p||s.isCancellationRequested))return E.DataTransfer.from(p)}async $hasResolve(n){const a=this.treeViews.get(n);if(!a)throw new y.NoTreeViewError(n);return a.hasResolve}$resolve(n,a,r){const s=this.treeViews.get(n);if(!s)throw new y.NoTreeViewError(n);return s.resolveTreeItem(a,r)}$setExpanded(n,a,r){const s=this.treeViews.get(n);if(!s)throw new y.NoTreeViewError(n);s.setExpanded(a,r)}$setSelectionAndFocus(n,a,r){const s=this.treeViews.get(n);if(!s)throw new y.NoTreeViewError(n);s.setSelectionAndFocus(a,r)}$setVisible(n,a){const r=this.treeViews.get(n);if(!r){if(!a)return;throw new y.NoTreeViewError(n)}r.setVisible(a)}$changeCheckboxState(n,a){const r=this.treeViews.get(n);if(!r)throw new y.NoTreeViewError(n);r.setCheckboxState(a)}createExtHostTreeView(n,a,r){const s=new C(n,a,this._proxy,this.commands.converter,this.logService,r);return this.treeViews.set(n,s),s}convertArgument(n){const a=this.treeViews.get(n.$treeViewId);return a&&"$treeItemHandle"in n?a.getExtensionElement(n.$treeItemHandle):a&&"$focusedTreeItem"in n&&n.$focusedTreeItem?a.focusedElement:null}}e.ExtHostTreeViews=f;class C extends h.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(n=>this.getExtensionElement(n)).filter(n=>!(0,D.isUndefinedOrNull)(n))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(n,a,r,s,b,p){if(super(),this.viewId=n,this.proxy=r,this.commands=s,this.logService=b,this.extension=p,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new T.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new T.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,p.contributes&&p.contributes.views)for(const o in p.contributes.views)for(const u of p.contributes.views[o])u.id===n&&(this._title=u.name);this.dataProvider=a.treeDataProvider,this.dndController=a.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let w,_;this._register(T.Event.debounce(this._onDidChangeData.event,(o,u)=>(o||(o={message:!1,elements:[]}),u.element!==!1&&(w||(w=new Promise(g=>_=g),this.refreshPromise=this.refreshPromise.then(()=>w)),Array.isArray(u.element)?o.elements.push(...u.element):o.elements.push(u.element)),u.message&&(o.message=!0),o),200,!0)(({message:o,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=_;return w=null,this.refresh(u).then(()=>g())})),o&&this.proxy.$setMessage(this.viewId,E.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(n){const a=n?this.getExtensionElement(n):void 0;if(n&&!a)return this.logService.error(`No tree item with id '${n}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(n);return r||(r=await this.fetchChildrenNodes(a)),r?r.map(s=>s.item):void 0}getExtensionElement(n){return this.elements.get(n)}reveal(n,a){a=a||{select:!0,focus:!1};const r=(0,D.isUndefinedOrNull)(a.select)?!0:a.select,s=(0,D.isUndefinedOrNull)(a.focus)?!1:a.focus,b=(0,D.isUndefinedOrNull)(a.expand)?!1:a.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):n?this.refreshPromise.then(()=>this.resolveUnknownParentChain(n)).then(p=>this.resolveTreeNode(n,p[p.length-1]).then(w=>this.proxy.$reveal(this.viewId,{item:w.item,parentChain:p.map(_=>_.item)},{select:r,focus:s,expand:b})),p=>this.logService.error(p)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:s,expand:b})}get message(){return this._message}set message(n){this._message=n,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(n){this._title=n,this.proxy.$setTitle(this.viewId,n,this._description)}get description(){return this._description}set description(n){this._description=n,this.proxy.$setTitle(this.viewId,this._title,n)}get badge(){return this._badge}set badge(n){this._badge?.value===n?.value&&this._badge?.tooltip===n?.tooltip||(this._badge=E.ViewBadge.from(n),this.proxy.$setBadge(this.viewId,n))}setExpanded(n,a){const r=this.getExtensionElement(n);r&&(a?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelectionAndFocus(n,a){const r=!(0,l.equals)(this._selectedHandles,n);this._selectedHandles=n;const s=this._focusedHandle!==a;this._focusedHandle=a,r&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),s&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(n){n!==this._visible&&(this._visible=n,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(n){const a=(await Promise.all(n.map(async r=>{const s=this.getExtensionElement(r.treeItemHandle);return s?{extensionItem:s,treeItem:await this.dataProvider.getTreeItem(s),newState:r.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);a.forEach(r=>{r.treeItem.checkboxState=r.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:a.map(r=>[r.extensionItem,r.newState])})}async handleDrag(n,a,r){const s=[];for(const b of n){const p=this.getExtensionElement(b);p&&s.push(p)}if(!(!this.dndController?.handleDrag||s.length===0))return await this.dndController.handleDrag(s,a,r),a}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(n,a,r){const s=a?this.getExtensionElement(a):void 0;if(!(!s&&a||!this.dndController?.handleDrop))return(0,m.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(s,n,r):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(n,a){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(n);if(r){const s=this.nodes.get(r);if(s){const b=await this.dataProvider.resolveTreeItem(s.extensionItem,r,a)??s.extensionItem;return this.validateTreeItem(b),s.item.tooltip=this.getTooltip(b.tooltip),s.item.command=this.getCommand(s.disposableStore,b.command),s.item}}}resolveUnknownParentChain(n){return this.resolveParent(n).then(a=>a?this.resolveUnknownParentChain(a).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(s=>(r.push(s),r))):Promise.resolve([]))}resolveParent(n){const a=this.nodes.get(n);return a?Promise.resolve(a.parent?this.elements.get(a.parent.item.handle):void 0):(0,m.asPromise)(()=>this.dataProvider.getParent(n))}resolveTreeNode(n,a){const r=this.nodes.get(n);return r?Promise.resolve(r):(0,m.asPromise)(()=>this.dataProvider.getTreeItem(n)).then(s=>this.createHandle(n,s,a,!0)).then(s=>this.getChildren(a?a.item.handle:void 0).then(()=>{const b=this.getExtensionElement(s);if(b){const p=this.nodes.get(b);if(p)return Promise.resolve(p)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(n){if(n){let a;if(typeof n=="string"){const r=this.getExtensionElement(n);a=r?this.nodes.get(r):void 0}else a=n;return a&&a.children||void 0}return this.roots}async fetchChildrenNodes(n){this.clearChildren(n);const a=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=n?this.nodes.get(n):void 0,s=await this.dataProvider.getChildren(n);if(a.token.isCancellationRequested)return;const b=await Promise.all((0,l.coalesce)(s||[]).map(async p=>{const w=await this.dataProvider.getTreeItem(p);return w&&!a.token.isCancellationRequested?this.createAndRegisterTreeNode(p,w,r):null}));return a.token.isCancellationRequested?void 0:(0,l.coalesce)(b)}finally{a.dispose()}}refresh(n){if(n.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(n);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(n){const a=new Set,r=n.map(b=>this.nodes.get(b));for(const b of r)if(b&&!a.has(b.item.handle)){let p=b;for(;p&&p.parent&&r.findIndex(w=>p&&p.parent&&w&&w.item.handle===p.parent.item.handle)===-1;){const w=this.elements.get(p.parent.item.handle);p=w?this.nodes.get(w):void 0}p&&!p.parent&&a.add(b.item.handle)}const s=[];return a.forEach(b=>{const p=this.elements.get(b);if(p){const w=this.nodes.get(p);w&&(!w.parent||!a.has(w.parent.item.handle))&&s.push(b)}}),s}refreshHandles(n){const a={};return Promise.all(n.map(r=>this.refreshNode(r).then(s=>{s&&(a[r]=s.item)}))).then(()=>Object.keys(a).length?this.proxy.$refresh(this.viewId,a):void 0)}refreshNode(n){const a=this.getExtensionElement(n);if(a){const r=this.nodes.get(a);if(r)return this.clearChildren(a),(0,m.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(s=>{if(s){const b=this.createTreeNode(a,s,r.parent);return this.updateNodeCache(a,b,r,r.parent),r.dispose(),b}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(n,a,r){const s=this.createTreeNode(n,a,r);if(a.id&&this.elements.has(s.item.handle))throw new Error((0,S.localize)(0,null,a.id));return this.addNodeToCache(n,s),this.addNodeToParentCache(s,r),s}getTooltip(n){return P.MarkdownString.isMarkdownString(n)?E.MarkdownString.from(n):n}getCommand(n,a){return a?{...this.commands.toInternal(a,n),originalId:a.command}:void 0}getCheckbox(n){if(n.checkboxState===void 0)return;let a,r,s;return typeof n.checkboxState=="number"?a=n.checkboxState:(a=n.checkboxState.state,r=n.checkboxState.tooltip,s=n.checkboxState.accessibilityInformation),{isChecked:a===P.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:s}}validateTreeItem(n){if(!P.TreeItem.isTreeItem(n,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(n,a,r){this.validateTreeItem(a);const s=new h.DisposableStore,b=this.createHandle(n,a,r),p=this.getLightIconPath(a);return{item:{handle:b,parentHandle:r?r.item.handle:void 0,label:c(a.label,this.extension),description:a.description,resourceUri:a.resourceUri,tooltip:this.getTooltip(a.tooltip),command:this.getCommand(s,a.command),contextValue:a.contextValue,icon:p,iconDark:this.getDarkIconPath(a)||p,themeIcon:this.getThemeIcon(a),collapsibleState:(0,D.isUndefinedOrNull)(a.collapsibleState)?P.TreeItemCollapsibleState.None:a.collapsibleState,accessibilityInformation:a.accessibilityInformation,checkbox:this.getCheckbox(a)},extensionItem:a,parent:r,children:void 0,disposableStore:s,dispose(){s.dispose()}}}getThemeIcon(n){return n.iconPath instanceof P.ThemeIcon?n.iconPath:void 0}createHandle(n,{id:a,label:r,resourceUri:s},b,p){if(a)return`${C.ID_HANDLE_PREFIX}/${a}`;const w=c(r,this.extension),_=b?b.item.handle:C.LABEL_HANDLE_PREFIX;let o=w?w.label:s?(0,I.basename)(s):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const u=this.nodes.has(n)?this.nodes.get(n).item.handle:void 0,g=this.getChildrenNodes(b)||[];let O,z=0;do{if(O=`${_}/${z}:${o}`,p||!this.elements.has(O)||u===O)break;z++}while(z<=g.length);return O}getLightIconPath(n){if(n.iconPath&&!(n.iconPath instanceof P.ThemeIcon))return typeof n.iconPath=="string"||L.URI.isUri(n.iconPath)?this.getIconPath(n.iconPath):this.getIconPath(n.iconPath.light)}getDarkIconPath(n){if(n.iconPath&&!(n.iconPath instanceof P.ThemeIcon)&&n.iconPath.dark)return this.getIconPath(n.iconPath.dark)}getIconPath(n){return L.URI.isUri(n)?n:L.URI.file(n)}addNodeToCache(n,a){this.elements.set(a.item.handle,n),this.nodes.set(n,a)}updateNodeCache(n,a,r,s){this.elements.delete(a.item.handle),this.nodes.delete(n),a.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(n,a);const b=this.getChildrenNodes(s)||[],p=b.filter(w=>w.item.handle===r.item.handle)[0];p&&b.splice(b.indexOf(p),1,a)}addNodeToParentCache(n,a){a?(a.children||(a.children=[]),a.children.push(n)):(this.roots||(this.roots=[]),this.roots.push(n))}clearChildren(n){if(n){const a=this.nodes.get(n);if(a){if(a.children)for(const r of a.children){const s=this.elements.get(r.item.handle);s&&this.clear(s)}a.children=void 0}}else this.clearAll()}clear(n){const a=this.nodes.get(n);if(a){if(a.children)for(const r of a.children){const s=this.elements.get(r.item.handle);s&&this.clear(s)}this.nodes.delete(n),this.elements.delete(a.item.handle),a.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(n=>n.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Pe[212],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalContextMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalContextMenu.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[213],Te([1,0,167,9,29,92,74,30,20,212,177,98]),function(ve,e,S,A,I,L,T,h,y,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const l=h.Registry.as(T.Extensions.JSONContribution);class E{constructor(k,n,a){this._messageHandler=k,this._extension=n,this._extensionPointId=a}_msg(k,n){this._messageHandler({type:k,message:n,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(k){this._msg(I.default.Error,k)}warn(k){this._msg(I.default.Warning,k)}info(k){this._msg(I.default.Info,k)}}e.ExtensionMessageCollector=E;class v{static _toSet(k){const n=new y.ExtensionIdentifierSet;for(let a=0,r=k.length;a<r;a++)n.add(k[a].description.identifier);return n}static compute(k,n){if(!k||!k.length)return new v(n,[]);if(!n||!n.length)return new v([],k);const a=this._toSet(k),r=this._toSet(n),s=n.filter(p=>!a.has(p.description.identifier)),b=k.filter(p=>!r.has(p.description.identifier));return new v(s,b)}constructor(k,n){this.added=k,this.removed=n}}e.ExtensionPointUserDelta=v;class d{constructor(k,n){this.name=k,this.defaultExtensionKind=n,this._handler=null,this._users=null,this._delta=null}setHandler(k){if(this._handler!==null)throw new Error("Handler already set!");this._handler=k,this._handle()}acceptUsers(k){this._delta=v.compute(this._users,k),this._users=k,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(k){(0,A.onUnexpectedError)(k)}}}e.ExtensionPoint=d;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"*",description:S.localize(42,null),body:"*"}]}},badges:{type:"array",description:S.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(44,null)},href:{type:"string",description:S.localize(45,null)},description:{type:"string",description:S.localize(46,null)}}}},markdown:{type:"string",description:S.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:S.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(52,null)},{body:["workspace"],description:S.localize(53,null)},{body:["ui","workspace"],description:S.localize(54,null)},{body:["workspace","ui"],description:S.localize(55,null)},{body:[],description:S.localize(56,null)}]},capabilities:{description:S.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(60,null),S.localize(61,null),S.localize(62,null)]},description:{type:"string",markdownDescription:S.localize(63,null)}}},untrustedWorkspaces:{description:S.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(66,null),S.localize(67,null),S.localize(68,null)]},restrictedConfigurations:{description:S.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(70,null)}}}}},sponsor:{description:S.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(73,null),type:"string"},"vscode:uninstall":{description:S.localize(74,null),type:"string"}}},icon:{type:"string",description:S.localize(75,null)},l10n:{type:"string",description:S.localize(76,null)},pricing:{type:"string",markdownDescription:S.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this._extensionPoints=new Map}registerExtensionPoint(k){if(this._extensionPoints.has(k.extensionPoint))throw new Error("Duplicate extension point: "+k.extensionPoint);const n=new d(k.extensionPoint,k.defaultExtensionKind);return this._extensionPoints.set(k.extensionPoint,n),k.activationEventsGenerator&&D.ImplicitActivationEvents.register(k.extensionPoint,k.activationEventsGenerator),e.schema.properties.contributes.properties[k.extensionPoint]=k.jsonSchema,l.registerSchema(i,e.schema),n}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=c;const f={ExtensionsRegistry:"ExtensionsRegistry"};h.Registry.add(f.ExtensionsRegistry,new c),e.ExtensionsRegistry=h.Registry.as(f.ExtensionsRegistry),l.registerSchema(i,e.schema),l.registerSchema(P.productSchemaId,{properties:{extensionEnabledApiProposals:{description:S.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}}]}}}})}),define(Pe[214],Te([1,0,164,16,24,213,32,5]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var m;(function(l){function E(v,d,t){if(!v)return;const i=A.isString(v.type)?v.type:void 0;if(!i||i.length===0){t.error(S.localize(3,null));return}const c=[];if(Array.isArray(v.required))for(const f of v.required)A.isString(f)&&c.push(f);return{extensionId:d.value,taskType:i,required:c,properties:v.properties?I.deepClone(v.properties):{},when:v.when?T.ContextKeyExpr.deserialize(v.when):void 0}}l.from=E})(m||(m={}));const P=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,E)=>{for(const v of l)v.type&&E.push(`onTaskType:${v.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:y}});class D{constructor(){this._onDefinitionsChanged=new h.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((E,v)=>{P.setHandler((d,t)=>{this._schema=void 0;try{for(const i of t.removed){const c=i.value;for(const f of c)this.taskTypes&&f.type&&this.taskTypes[f.type]&&delete this.taskTypes[f.type]}for(const i of t.added){const c=i.value;for(const f of c){const C=m.from(f,i.description.identifier,i.collector);C&&(this.taskTypes[C.taskType]=C)}}(t.removed.length>0||t.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}E(void 0)})})}onReady(){return this.readyPromise}get(E){return this.taskTypes[E]}all(){return Object.keys(this.taskTypes).map(E=>this.taskTypes[E])}getJsonSchema(){if(this._schema===void 0){const E=[];for(const v of this.all()){const d={type:"object",additionalProperties:!1};v.required.length>0&&(d.required=v.required.slice(0)),v.properties!==void 0?d.properties=I.deepClone(v.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[v.taskType]},E.push(d)}this._schema={oneOf:E}}return this._schema}}e.TaskDefinitionRegistry=new D}),define(Pe[215],Te([1,0,165,16,23,24,32,214]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new T.RawContextKey("taskRunning",!1,S.localize(0,null)),e.TASKS_CATEGORY={value:S.localize(1,null),original:"Tasks"};var y;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(x){function M(ne){if(!ne)return x.Strong;switch(ne.toLowerCase()){case"escape":return x.Escape;case"strong":return x.Strong;case"weak":return x.Weak;default:return x.Strong}}x.from=M}(y||(e.ShellQuoting=y={}));var m;(function(x){x.defaults={cwd:"${workspaceFolder}"}})(m||(e.CommandOptions=m={}));var P;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(P||(e.RevealKind=P={})),function(x){function M(ne){switch(ne.toLowerCase()){case"always":return x.Always;case"silent":return x.Silent;case"never":return x.Never;default:return x.Always}}x.fromString=M}(P||(e.RevealKind=P={}));var D;(function(x){x[x.Never=1]="Never",x[x.OnProblem=2]="OnProblem",x[x.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(x){function M(ne){switch(ne.toLowerCase()){case"always":return x.Always;case"never":return x.Never;case"onproblem":return x.OnProblem;default:return x.OnProblem}}x.fromString=M}(D||(e.RevealProblemKind=D={}));var l;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(l||(e.PanelKind=l={})),function(x){function M(ne){switch(ne.toLowerCase()){case"shared":return x.Shared;case"dedicated":return x.Dedicated;case"new":return x.New;default:return x.Shared}}x.fromString=M}(l||(e.PanelKind=l={}));var E;(function(x){x.defaults={echo:!0,reveal:P.Always,revealProblems:D.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var v;(function(x){x[x.Shell=1]="Shell",x[x.Process=2]="Process",x[x.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(x){function M(Q){switch(Q.toLowerCase()){case"shell":return x.Shell;case"process":return x.Process;case"customExecution":return x.CustomExecution;default:return x.Process}}x.fromString=M;function ne(Q){switch(Q){case x.Shell:return"shell";case x.Process:return"process";case x.CustomExecution:return"customExecution";default:return"process"}}x.toString=ne}(v||(e.RuntimeType=v={}));var d;(function(x){function M(ne){return A.isString(ne)?ne:ne.value}x.value=M})(d||(e.CommandString=d={}));var t;(function(x){x.Clean={_id:"clean",isDefault:!1},x.Build={_id:"build",isDefault:!1},x.Rebuild={_id:"rebuild",isDefault:!1},x.Test={_id:"test",isDefault:!1};function M(Q){return Q===x.Clean._id||Q===x.Build._id||Q===x.Rebuild._id||Q===x.Test._id}x.is=M;function ne(Q){if(Q!==void 0)return A.isString(Q)?M(Q)?{_id:Q,isDefault:!1}:void 0:Q}x.from=ne})(t||(e.TaskGroup=t={}));var i;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var c;(function(x){x.Workspace="workspace",x.Extension="extension",x.InMemory="inMemory",x.WorkspaceFile="workspaceFile",x.User="user";function M(ne){switch(ne){case x.User:return 2;case x.WorkspaceFile:return 5;default:return 6}}x.toConfigurationTarget=M})(c||(e.TaskSourceKind=c={}));var f;(function(x){x.parallel="parallel",x.sequence="sequence"})(f||(e.DependsOrder=f={}));var C;(function(x){x[x.default=1]="default",x[x.folderOpen=2]="folderOpen"})(C||(e.RunOnOptions=C={}));var k;(function(x){x.defaults={reevaluateOnRerun:!0,runOn:C.default,instanceLimit:1}})(k||(e.RunOptions=k={}));class n{constructor(M,ne,Q,we,_e,Ae){this._label="",this._id=M,ne&&(this._label=ne),Q&&(this.type=Q),this.runOptions=we,this.configurationProperties=_e,this._source=Ae}getDefinition(M){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const M={folder:this.getFolderId(),id:this._id};return JSON.stringify(M)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,ne=!1){if(M===void 0)return!1;if(A.isString(M))return M===this._label||M===this.configurationProperties.identifier||ne&&M===this._id;const Q=this.getDefinition(!0);return Q!==void 0&&Q._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),M&&(this._taskLoadMessages=this._taskLoadMessages.concat(M))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=n;class a extends n{constructor(M,ne,Q,we,_e,Ae,Y,he){super(M,Q,void 0,Y,he,ne),this.command={},this._source=ne,this.hasDefinedMatchers=Ae,_e&&(this.command=_e)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let ne;switch(this.command?this.command.runtime:void 0){case v.Shell:ne="shell";break;case v.Process:ne="process";break;case v.CustomExecution:ne="customExecution";break;case void 0:ne="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ne,_key:this._id,id:this._id}}}static is(M){return M instanceof a}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===c.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const M=this.getFolderId();if(!M)return;let ne=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ne+=this._source.kind);const Q={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:ne};return JSON.stringify(Q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(M){return new a(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.CustomTask=a;class r extends n{constructor(M,ne,Q,we,_e,Ae,Y){super(M,Q,we,Ae,Y,ne),this._source=ne,this.configures=_e}static is(M){return M instanceof r}fromObject(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===c.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const M=this.getFolderId();if(!M)return;let ne=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ne+=this._source.kind);const Q={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:ne};return JSON.stringify(Q)}}e.ConfiguringTask=r;class s extends n{constructor(M,ne,Q,we,_e,Ae,Y,he,ke){super(M,Q,we,he,ke,ne),this.defines=_e,this.hasDefinedMatchers=Y,this.command=Ae,this.icon=ke.icon,this.hide=ke.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof s}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.getFolderId(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(M){return new s(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.ContributedTask=s;class b extends n{constructor(M,ne,Q,we,_e,Ae){super(M,Q,we,_e,Ae,ne),this._source=ne}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(M){return new b(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.InMemoryTask=b;var p;(function(x){x[x.Process=1]="Process",x[x.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(x){x._default=x.Terminal}(p||(e.ExecutionEngine=p={}));var w;(function(x){x[x.V0_1_0=1]="V0_1_0",x[x.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class _{constructor(M){this._order=new Map;for(let ne=0;ne<M.length;ne++)this._order.set(M[ne].uri.toString(),ne)}compare(M,ne){const Q=M.getWorkspaceFolder(),we=ne.getWorkspaceFolder();if(Q&&we){let _e=this._order.get(Q.uri.toString());_e=_e===void 0?0:_e+1;let Ae=this._order.get(we.uri.toString());return Ae=Ae===void 0?0:Ae+1,_e===Ae?M._label.localeCompare(ne._label):_e-Ae}else return!Q&&we?-1:Q&&!we?1:0}}e.TaskSorter=_;var o;(function(x){x.DependsOnStarted="dependsOnStarted",x.AcquiredInput="acquiredInput",x.Start="start",x.ProcessStarted="processStarted",x.Active="active",x.Inactive="inactive",x.Changed="changed",x.Terminated="terminated",x.ProcessEnded="processEnded",x.End="end"})(o||(e.TaskEventKind=o={}));var u;(function(x){x.SingleRun="singleRun",x.Background="background"})(u||(e.TaskRunType=u={}));var g;(function(x){x[x.System=0]="System",x[x.User=1]="User",x[x.FolderOpen=2]="FolderOpen",x[x.ConfigurationChange=3]="ConfigurationChange",x[x.Reconnect=4]="Reconnect"})(g||(e.TaskRunSource=g={}));var O;(function(x){function M(ne,Q,we,_e){if(Q){const Ae={kind:ne,taskId:Q._id,taskName:Q.configurationProperties.name,runType:Q.configurationProperties.isBackground?"background":"singleRun",group:Q.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:we,__task:Q};return ne==="start"?Ae.resolvedVariables=_e:ne==="processStarted"?Ae.processId=_e:ne==="processEnded"&&(Ae.exitCode=_e),Object.freeze(Ae)}else return Object.freeze({kind:"changed"})}x.create=M})(O||(e.TaskEvent=O={}));var z;(function(x){function M(Q){const we=Object.keys(Q).sort();let _e="";for(const Ae of we){let Y=Q[Ae];Y instanceof Object?Y=M(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),_e+=Ae+","+Y+","}return _e}function ne(Q){const _e={_key:M(Q),type:Q.taskType};return Object.assign(_e,Q),_e}x.create=ne})(z||(e.KeyedTaskIdentifier=z={}));var H;(function(x){x.AutoDetect="task.autoDetect",x.SaveBeforeRun="task.saveBeforeRun",x.ShowDecorations="task.showDecorations",x.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",x.SlowProviderWarning="task.slowProviderWarning",x.QuickOpenHistory="task.quickOpen.history",x.QuickOpenDetail="task.quickOpen.detail",x.QuickOpenSkip="task.quickOpen.skip",x.QuickOpenShowAll="task.quickOpen.showAll",x.AllowAutomaticTasks="task.allowAutomaticTasks",x.Reconnection="task.reconnection"})(H||(e.TaskSettingId=H={}));var B;(function(x){x.Tasks="tasks",x.SuppressTaskName="tasks.suppressTaskName",x.Windows="tasks.windows",x.Osx="tasks.osx",x.Linux="tasks.linux",x.ShowOutput="tasks.showOutput",x.IsShellCommand="tasks.isShellCommand",x.ServiceTestSetting="tasks.service.testSetting"})(B||(e.TasksSchemaProperties=B={}));var $;(function(x){function M(ne,Q){const we=h.TaskDefinitionRegistry.get(ne.type);if(we===void 0){const he=L.deepClone(ne);return delete he._key,z.create(he)}const _e=Object.create(null);_e.type=we.taskType;const Ae=new Set;we.required.forEach(he=>Ae.add(he));const Y=we.properties;for(const he of Object.keys(Y)){const ke=ne[he];if(ke!=null)_e[he]=ke;else if(Ae.has(he)){const ae=Y[he];if(ae.default!==void 0)_e[he]=L.deepClone(ae.default);else switch(ae.type){case"boolean":_e[he]=!1;break;case"number":case"integer":_e[he]=0;break;case"string":_e[he]="";break;default:Q.error(S.localize(2,null,JSON.stringify(ne,void 0,0),he));return}}}return z.create(_e)}x.createTaskIdentifier=M})($||(e.TaskDefinition=$={}))}),define(Pe[216],Te([1,0,9]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class A{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,h)=>{this._actualOk=T,this._actualErr=h,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,S.onUnexpectedError)(T))}then(T,h){return this._ensureActual().then(T,h)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=A;class I extends A{constructor(){super(),this._hasErr=!0,this._err=new S.CancellationError}}e.CanceledLazyPromise=I}),define(Pe[46],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class S{static{this.count=0}constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++S.count}}e.ProxyIdentifier=S;const A=[];function I(h){const y=new S(h);return A[y.nid]=y,y}e.createProxyIdentifier=I;function L(h){return A[h].sid}e.getStringIdentifierForProxy=L;class T{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=T}),define(Pe[3],Te([1,0,46]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(A||(e.TextEditorRevealType=A={}));var I;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(I||(e.TabInputKind=I={}));var L;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var T;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var h;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(h||(e.WebviewMessageArrayBufferViewType=h={}));var y;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var m;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(m||(e.NotebookEditorRevealType=m={}));var P;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class D{static{this._n=0}static mixin(t){return t._id=D._n++,t}}e.IdObject=D;var l;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var E;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.MainContext={MainThreadAuthentication:(0,S.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadChatProvider:(0,S.createProxyIdentifier)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,S.createProxyIdentifier)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,S.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,S.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,S.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,S.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,S.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,S.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,S.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,S.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,S.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,S.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,S.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,S.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,S.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,S.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,S.createProxyIdentifier)("ExtHostChat"),ExtHostChatSlashCommands:(0,S.createProxyIdentifier)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,S.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.createProxyIdentifier)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,S.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,S.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Pe[217],Te([1,0,3,7]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class I{constructor(T){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(S.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,h,y){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const m=this._relatedInformationProviders.get(T);if(!m)throw new Error("related information provider not found");return await m.provideRelatedInformation(h,y)??[]}getRelatedInformation(T,h,y){return this._proxy.$getAiRelatedInformation(h,y)}registerRelatedInformationProvider(T,h,y){const m=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(m,y),this._proxy.$registerAiRelatedInformationProvider(m,h),new A.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(m),this._relatedInformationProviders.delete(m)})}}e.ExtHostRelatedInformation=I}),define(Pe[80],Te([1,0,4,14,3,17]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,S.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(y,m){this._extHostLogService=m,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(I.MainContext.MainThreadTelemetry)}report(y,m,P){const D=this.getUsageKey(y,m);this._reportedUsages.has(D)||(this._reportedUsages.add(D),m.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${P}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:m.identifier.value,apiId:y}))}getUsageKey(y,m){return`${y}-${m.identifier.value}`}};e.ExtHostApiDeprecationService=T,e.ExtHostApiDeprecationService=T=Ve([ze(0,L.IExtHostRpcService),ze(1,A.ILogService)],T),e.NullApiDeprecationService=Object.freeze(new class{report(h,y,m){}})}),define(Pe[218],Te([1,0,5,3,7,20]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(m){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new S.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new h,this._getSessionsTaskSingler=new h,this._proxy=m.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(m){return this._providers=m,Promise.resolve()}async getSession(m,P,D,l={}){const E=L.ExtensionIdentifier.toKey(m.identifier),v=[...D].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${E} ${P} ${v}`,async()=>{await this._proxy.$ensureProvider(P);const d=m.displayName||m.name;return this._proxy.$getSession(P,D,E,d,l)})}async getSessions(m,P,D){const l=L.ExtensionIdentifier.toKey(m.identifier),E=[...D].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${l} ${E}`,async()=>{await this._proxy.$ensureProvider(P);const v=m.displayName||m.name;return this._proxy.$getSessions(P,D,l,v)})}async removeSession(m,P){const D=this._authenticationProviders.get(m);return D?D.provider.removeSession(P):this._proxy.$removeSession(m,P)}registerAuthenticationProvider(m,P,D,l){if(this._authenticationProviders.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this._authenticationProviders.set(m,{label:P,provider:D,options:l??{supportsMultipleAccounts:!1}}),this._providers.find(v=>v.id===m)||this._providers.push({id:m,label:P});const E=D.onDidChangeSessions(v=>{this._proxy.$sendDidChangeSessions(m,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this._proxy.$registerAuthenticationProvider(m,P,l?.supportsMultipleAccounts??!1),new I.Disposable(()=>{E.dispose(),this._authenticationProviders.delete(m);const v=this._providers.findIndex(d=>d.id===m);v>-1&&this._providers.splice(v),this._proxy.$unregisterAuthenticationProvider(m)})}$createSession(m,P,D){const l=this._authenticationProviders.get(m);if(l)return Promise.resolve(l.provider.createSession(P,D));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,P){const D=this._authenticationProviders.get(m);if(D)return Promise.resolve(D.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,P){const D=this._authenticationProviders.get(m);if(D)return Promise.resolve(D.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,P){return this._onDidChangeSessions.fire({provider:{id:m,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=T;class h{constructor(){this._inFlightPromises=new Map}getOrCreate(m,P){const D=this._inFlightPromises.get(m);if(D)return D;const l=P().finally(()=>this._inFlightPromises.delete(m));return this._inFlightPromises.set(m,l),l}}}),define(Pe[219],Te([1,0,3,17,8]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(h,y){this._proxy=h.getProxy(S.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:m=>y.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(h,y,m){const P=I.WorkspaceEdit.from(h,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(P,void 0,m?.isRefactoring??!1)}};e.ExtHostBulkEdits=L,e.ExtHostBulkEdits=L=Ve([ze(0,A.IExtHostRpcService)],L)}),define(Pe[220],Te([1,0,13,5,67,6,59,147,3,8]),function(ve,e,S,A,I,L,T,h,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class P{static{this._pool=0}constructor(E,v){this.extension=E,this.provider=v,this.handle=P._pool++}}class D{static{this._nextId=0}constructor(E,v){this.logService=v,this._chatProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new A.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=E.getProxy(y.MainContext.MainThreadChat)}registerChatProvider(E,v,d){const t=new P(E,d);return this._chatProvider.set(t.handle,t),this._proxy.$registerChatProvider(t.handle,v),(0,L.toDisposable)(()=>{this._proxy.$unregisterChatProvider(t.handle),this._chatProvider.delete(t.handle)})}transferChatSession(E,v){const d=I.Iterable.find(this._chatSessions.keys(),t=>this._chatSessions.get(t)===E)??0;typeof d=="number"&&this._proxy.$transferChatSession(d,v)}addChatRequest(E){this._proxy.$addRequest(E)}sendInteractiveRequestToProvider(E,v){this._proxy.$sendRequestToProvider(E,v)}async $prepareChat(E,v,d){const t=this._chatProvider.get(E);if(!t)return;const i=await t.provider.prepareSession(v,d);if(!i)return;const c=D._nextId++;return this._chatSessions.set(c,i),{id:c,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $resolveRequest(E,v,d,t){const i=this._chatProvider.get(E);if(!i)return;const c=this._chatSessions.get(v);if(!c||!i.provider.resolveRequest)return;const f=await i.provider.resolveRequest(c,d,t);if(f)return{message:typeof f.message=="string"?f.message:m.ChatReplyFollowup.from(f.message)}}async $provideWelcomeMessage(E,v){const d=this._chatProvider.get(E);if(!d||!d.provider.provideWelcomeMessage)return;const t=await d.provider.provideWelcomeMessage(v);if(t)return t.map(i=>typeof i=="string"?i:i.map(c=>m.ChatReplyFollowup.from(c)))}async $provideFollowups(E,v,d){const t=this._chatProvider.get(E);if(!t)return;const i=this._chatSessions.get(v);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,d))?.map(f=>m.ChatFollowup.from(f))}$removeRequest(E,v,d){const t=this._chatProvider.get(E);if(!t)return;const i=this._chatSessions.get(v);i&&t.provider.removeRequest&&t.provider.removeRequest(i,d)}async $provideReply(E,v,d,t){const i=this._chatProvider.get(E);if(!i)return;const c=this._chatSessions.get(v);if(!c)return;const f={session:c,message:typeof d.message=="string"?d.message:m.ChatReplyFollowup.to(d.message),variables:{}};if(d.variables)for(const s of Object.keys(d.variables))f.variables[s]=d.variables[s].map(m.ChatVariable.to);const C=T.StopWatch.create(!1);let k;const n={report:s=>{if(!t.isCancellationRequested)if(typeof k>"u"&&(k=C.elapsed()),"responseId"in s)this._proxy.$acceptResponseProgress(E,v,{requestId:s.responseId});else if("placeholder"in s&&"resolvedContent"in s){const b=Promise.all([this._proxy.$acceptResponseProgress(E,v,{placeholder:s.placeholder}),s.resolvedContent]);(0,S.raceCancellation)(b,t).then(p=>{if(!p)return;const[w,_]=p;this._proxy.$acceptResponseProgress(E,v,_,w??void 0)})}else"content"in s?this._proxy.$acceptResponseProgress(E,v,{content:typeof s.content=="string"?s.content:m.MarkdownString.from(s.content)}):this._proxy.$acceptResponseProgress(E,v,s)}};let a;try{a=await i.provider.provideResponseWithProgress(f,n,t),a||(a={errorDetails:{message:(0,h.localize)(0,null)}})}catch(s){a={errorDetails:{message:(0,h.localize)(1,null,s.message),responseIsIncomplete:!0}},this.logService.error(s)}try{if(c.saveState&&this._chatSessions.has(v)){const s=c.saveState();this._proxy.$acceptChatState(v,s)}}catch(s){this.logService.warn(s)}const r={firstProgress:k??0,totalElapsed:C.elapsed()};return{errorDetails:a.errorDetails,timings:r}}async $provideSlashCommands(E,v,d){const t=this._chatProvider.get(E);if(!t)return;const i=this._chatSessions.get(v);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,d))?.map(f=>({...f,kind:m.CompletionItemKind.from(f.kind)}))}$releaseSession(E){this._chatSessions.delete(E)}async $onDidPerformUserAction(E){this._onDidPerformUserAction.fire(E)}}e.ExtHostChat=D}),define(Pe[221],Te([1,0,6,3,8,73,20]),function(ve,e,S,A,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatProvider=void 0;class h{static{this._idPool=1}constructor(m,P){this._logService=P,this._providers=new Map,this._pendingRequest=new Map,this._chatAccessAllowList=new T.ExtensionIdentifierMap,this._proxy=m.getProxy(A.MainContext.MainThreadChatProvider)}registerProvider(m,P,D,l){const E=h._idPool++;return this._providers.set(E,{extension:m,provider:D}),this._proxy.$registerProvider(E,P,{extension:m,displayName:l.name??m.value}),(0,S.toDisposable)(()=>{this._proxy.$unregisterProvider(E),this._providers.delete(E)})}async $provideChatResponse(m,P,D,l,E){const v=this._providers.get(m);if(!v)return;const d=new L.Progress(async t=>{if(E.isCancellationRequested){this._logService.warn(`[CHAT](${v.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this._proxy.$handleProgressChunk(P,{index:t.index,part:t.part})},{async:!0});return v.provider.provideChatResponse(D.map(I.ChatMessage.to),l,d,E)}allowListExtensionWhile(m,P){this._chatAccessAllowList.set(m,P),P.finally(()=>this._chatAccessAllowList.delete(m))}async requestChatResponseProvider(m,P){if(!this._chatAccessAllowList.has(m))throw new Error("Extension is NOT allowed to make chat requests");const D=this;return{get isRevoked(){return!D._chatAccessAllowList.has(m)},async makeRequest(l,E,v,d){if(!D._chatAccessAllowList.has(m))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;D._pendingRequest.set(t,v);try{await D._proxy.$fetchResponse(m,P,t,l.map(I.ChatMessage.from),E,d)}finally{D._pendingRequest.delete(t)}}}}async $handleResponseFragment(m,P){this._pendingRequest.get(m)?.report(P)}}e.ExtHostChatProvider=h}),define(Pe[222],Te([1,0,6,3,7,8,73,13]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatSlashCommands=void 0;class y{static{this._idPool=0}constructor(P,D,l){this._extHostChatProvider=D,this._logService=l,this._commands=new Map,this._proxy=P.getProxy(A.MainContext.MainThreadChatSlashCommands)}registerCommand(P,D,l,E){const v=y._idPool++;return this._commands.set(v,{extension:P,command:l}),this._proxy.$registerCommand(v,D,E.description),(0,S.toDisposable)(()=>{this._proxy.$unregisterCommand(v),this._commands.delete(v)})}async $executeCommand(P,D,l,E,v){const d=this._commands.get(P);if(!d){this._logService.warn(`[CHAT](${P}) CANNOT execute command because the command is not registered`);return}let t=!1;function i(){if(t)throw new Error("Only valid while executing the command")}const c=new h.DeferredPromise;v.onCancellationRequested(()=>c.complete()),setTimeout(()=>c.complete(),3*1e3),this._extHostChatProvider.allowListExtensionWhile(d.extension,c.p);const f=d.command({role:I.ChatMessageRole.User,content:l},{history:E.history.map(L.ChatMessage.to)},new T.Progress(C=>{i(),this._proxy.$handleProgressChunk(D,{content:C.message.value})}),v);try{await(0,h.raceCancellation)(Promise.resolve(f),v)}finally{t=!0,c.complete()}}}e.ExtHostChatSlashCommands=y}),define(Pe[223],Te([1,0,6,3,9,8]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class T{static{this._idPool=0}constructor(y){this._resolver=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadChatVariables)}async $resolveVariable(y,m,P){const D=this._resolver.get(y);if(D)try{const l=await D.resolver.resolve(D.data.name,{message:m},P);if(l)return l.map(L.ChatVariable.from)}catch(l){(0,I.onUnexpectedExternalError)(l)}}registerVariableResolver(y,m,P,D){const l=T._idPool++;return this._resolver.set(l,{extension:y.identifier,data:{name:m,description:P},resolver:D}),this._proxy.$registerVariable(l,{name:m,description:P}),(0,S.toDisposable)(()=>{this._resolver.delete(l),this._proxy.$unregisterVariable(l)})}}e.ExtHostChatVariables=T}),define(Pe[224],Te([1,0,3]),function(ve,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(L){const T=L.getProxy(S.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(h){return T.$writeText(h)}})}}e.ExtHostClipboard=A}),define(Pe[31],Te([1,0,16,7,8,24,3,18,14,69,44,278,2,6,4,17,105,25,46,41,59,53,58]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t,i,c,f,C,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{#e;#t;#i;constructor(_,o,u){this._commands=new Map,this._apiCommands=new Map,this.#e=_.getProxy(T.MainContext.MainThreadCommands),this._logService=o,this.#i=u,this.#t=_.getProxy(T.MainContext.MainThreadTelemetry),this.converter=new r(this,g=>{const O=this._apiCommands.get(g);return O?.result===b.Void?O:void 0},o),this._argumentProcessors=[{processArgument(g){return(0,m.revive)(g)}},{processArgument(g){return(0,L.cloneAndChange)(g,function(O){if(P.Range.isIRange(O))return I.Range.to(O);if(D.Position.isIPosition(O))return I.Position.to(O);if(P.Range.isIRange(O.range)&&l.URI.isUri(O.uri))return I.location.to(O);if(O instanceof i.VSBuffer)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(_){this._argumentProcessors.push(_)}registerApiCommand(_){const o=this.registerCommand(!1,_.id,async(...u)=>{const g=_.args.map((z,H)=>{if(!z.validate(u[H]))throw new Error(`Invalid argument '${z.name}' when running '${_.id}', received: ${u[H]}`);return z.convert(u[H])}),O=await this.executeCommand(_.internalId,...g);return _.result.convert(O,u,this.converter)},void 0,{description:_.description,args:_.args,returns:_.result.description});return this._apiCommands.set(_.id,_),new A.Disposable(()=>{o.dispose(),this._apiCommands.delete(_.id)})}registerCommand(_,o,u,g,O,z){if(this._logService.trace("ExtHostCommands#registerCommand",o),!o.trim().length)throw new Error("invalid id");if(this._commands.has(o))throw new Error(`command '${o}' already exists`);return this._commands.set(o,{callback:u,thisArg:g,description:O,extension:z}),_&&this.#e.$registerCommand(o),new A.Disposable(()=>{this._commands.delete(o)&&_&&this.#e.$unregisterCommand(o)})}executeCommand(_,...o){return this._logService.trace("ExtHostCommands#executeCommand",_),this._doExecuteCommand(_,o,!0)}async _doExecuteCommand(_,o,u){if(this._commands.has(_))return this.#e.$fireCommandActivationEvent(_),this._executeContributedCommand(_,o,!1);{let g=!1;const O=(0,L.cloneAndChange)(o,function(z){if(z instanceof A.Position)return I.Position.from(z);if(z instanceof A.Range)return I.Range.from(z);if(z instanceof A.Location)return I.location.from(z);if(A.NotebookRange.isNotebookRange(z))return I.NotebookRange.from(z);if(z instanceof ArrayBuffer)return g=!0,i.VSBuffer.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return g=!0,i.VSBuffer.wrap(z);if(z instanceof i.VSBuffer)return g=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(_,g?new c.SerializableObjectWithBuffers(O):O,u);return(0,m.revive)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this._doExecuteCommand(_,o,!1);throw z}}}async _executeContributedCommand(_,o,u){const g=this._commands.get(_);if(!g)throw new Error("Unknown command");const{callback:O,thisArg:z,description:H}=g;if(H)for(let $=0;$<H.args.length;$++)try{(0,S.validateConstraint)(o[$],H.args[$].constraint)}catch{throw new Error(`Running the contributed command: '${_}' failed. Illegal argument '${H.args[$].name}' - ${H.args[$].description}`)}const B=C.StopWatch.create();try{return await O.apply(z,o)}catch($){if(_===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...o);x&&(_=x.command)}if(this._logService.error($,_,g.extension?.identifier),!u)throw $;if(g.extension?.identifier){const x=this.#i.onExtensionError(g.extension.identifier,$);this._logService.trace("forwarded error to extension?",x,g.extension?.identifier)}throw new class extends Error{constructor(){super((0,f.toErrorMessage)($)),this.id=_,this.source=g.extension?.displayName??g.extension?.name}}}finally{this._reportTelemetry(g,_,B.elapsed())}}_reportTelemetry(_,o,u){_.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:_.extension.identifier.value,id:new k.TelemetryTrustedValue(o),duration:u})}$executeContributedCommand(_,...o){this._logService.trace("ExtHostCommands#$executeContributedCommand",_);const u=this._commands.get(_);return u?(o=o.map(g=>this._argumentProcessors.reduce((O,z)=>z.processArgument(O,u.extension?.identifier),g)),this._executeContributedCommand(_,o,!0)):Promise.reject(new Error(`Contributed command '${_}' does not exist.`))}getCommands(_=!1){return this._logService.trace("ExtHostCommands#getCommands",_),this.#e.$getCommands().then(o=>(_&&(o=o.filter(u=>u[0]!=="_")),o))}$getContributedCommandHandlerDescriptions(){const _=Object.create(null);for(const[o,u]of this._commands){const{description:g}=u;g&&(_[o]=g)}return Promise.resolve(_)}};e.ExtHostCommands=a,e.ExtHostCommands=a=Ve([ze(0,d.IExtHostRpcService),ze(1,y.ILogService),ze(2,n.IExtHostTelemetry)],a),e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class r{constructor(_,o,u){this._commands=_,this._lookupApiCommand=o,this._logService=u,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(_,o){if(!_)return;const u={$ident:void 0,id:_.command,title:_.title,tooltip:_.tooltip};if(!_.command)return u;const g=this._lookupApiCommand(_.command);if(g)u.id=g.internalId,u.arguments=g.args.map((O,z)=>O.convert(_.arguments&&_.arguments[z]));else if((0,h.isNonEmptyArray)(_.arguments)){const O=`${_.command}/${++this._cachIdPool}`;this._cache.set(O,_),o.add((0,E.toDisposable)(()=>{this._cache.delete(O),this._logService.trace("CommandsConverter#DISPOSE",O)})),u.$ident=O,u.id=this.delegatingCommandId,u.arguments=[O],this._logService.trace("CommandsConverter#CREATE",_.command,O)}return u}fromInternal(_){return typeof _.$ident=="string"?this._cache.get(_.$ident):{command:_.id,title:_.title,arguments:_.arguments}}getActualCommand(..._){return this._cache.get(_[0])}_executeConvertedCommand(..._){const o=this.getActualCommand(..._);return this._logService.trace("CommandsConverter#EXECUTE",_[0],o?o.command:"MISSING"),o?this._commands.executeCommand(o.command,...o.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${_[0]}`)}}e.CommandsConverter=r;class s{static{this.Uri=new s("uri","Uri of a text document",_=>l.URI.isUri(_),_=>_)}static{this.Position=new s("position","A position in a text document",_=>A.Position.isPosition(_),I.Position.from)}static{this.Range=new s("range","A range in a text document",_=>A.Range.isRange(_),I.Range.from)}static{this.Selection=new s("selection","A selection in a text document",_=>A.Selection.isSelection(_),I.Selection.from)}static{this.Number=new s("number","",_=>typeof _=="number",_=>_)}static{this.String=new s("string","",_=>typeof _=="string",_=>_)}static{this.StringArray=s.Arr(s.String)}static Arr(_){return new s(`${_.name}_array`,`Array of ${_.name}, ${_.description}`,o=>Array.isArray(o)&&o.every(u=>_.validate(u)),o=>o.map(u=>_.convert(u)))}static{this.CallHierarchyItem=new s("item","A call hierarchy item",_=>_ instanceof A.CallHierarchyItem,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new s("item","A type hierarchy item",_=>_ instanceof A.TypeHierarchyItem,I.TypeHierarchyItem.from)}static{this.TestItem=new s("testItem","A VSCodium TestItem",_=>_ instanceof t.TestItemImpl,I.TestItem.from)}constructor(_,o,u,g){this.name=_,this.description=o,this.validate=u,this.convert=g}optional(){return new s(this.name,`(optional) ${this.description}`,_=>_==null||this.validate(_),_=>_===void 0?void 0:_===null?null:this.convert(_))}with(_,o){return new s(_??this.name,o??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s;class b{static{this.Void=new b("no result",_=>_)}constructor(_,o){this.description=_,this.convert=o}}e.ApiCommandResult=b;class p{constructor(_,o,u,g,O){this.id=_,this.internalId=o,this.description=u,this.args=g,this.result=O}}e.ApiCommand=p}),define(Pe[225],Te([1,0,18,12,2,78,91,32,95,31,8,7]),function(ve,e,S,A,I,L,T,h,y,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const l=[new m.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",v(P.DocumentHighlight.to))),new m.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,S.isFalsyOrEmpty)(t))return;class c extends D.SymbolInformation{static to(C){const k=new c(C.name,P.SymbolKind.to(C.kind),C.containerName||"",new D.Location(i[0],P.Range.to(C.range)));return k.detail=C.detail,k.range=k.location.range,k.selectionRange=P.Range.to(C.selectionRange),k.children=C.children?C.children.map(c.to):[],k}}return t.map(c.to)})),new m.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(P.TextEdit.to))),new m.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(P.TextEdit.to))),new m.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,new m.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(P.TextEdit.to))),new m.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new m.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new m.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new m.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new m.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location-instances.",v(P.location.to))),new m.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Hover-instances.",v(P.Hover.to))),new m.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>D.Position.isPosition(i)),t=>t.map(P.Position.from))],new m.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(i=>{let c;for(const f of i.reverse())c=new D.SelectionRange(P.Range.to(f),c);return c}))),new m.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.ApiCommandArgument.String.with("query","Search string")],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new m.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new m.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new m.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new m.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new m.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("newName","The new symbol name")],new m.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new m.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new m.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,T.decodeSemanticTokensDto)(t);if(i.type==="full")return new D.SemanticTokens(i.data,void 0)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range.optional()],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,T.decodeSemanticTokensDto)(t);if(i.type==="full")return new D.SemanticTokens(i.data,void 0)})),new m.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,i,c)=>{if(!t)return new D.CompletionList([]);const f=t.suggestions.map(C=>P.CompletionItem.to(C,c));return new D.CompletionList(f,t.incomplete)})),new m.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new m.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,i,c)=>v(f=>new D.CodeLens(P.Range.to(f.range),f.command&&c.fromInternal(f.command)))(t))),new m.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.Range.isRange(t),t=>D.Selection.isSelection(t)?P.Selection.from(t):P.Range.from(t)),m.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,i,c)=>v(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(f.command)}else{const C=new D.CodeAction(f.title,f.kind?new D.CodeActionKind(f.kind):void 0);return f.edit&&(C.edit=P.WorkspaceEdit.to(f.edit)),f.command&&(C.command=c.fromInternal(f.command)),C.isPreferred=f.isPreferred,C}})(t))),new m.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new D.ColorInformation(P.Range.to(i.range),P.Color.to(i.color))):[])),new m.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.ApiCommandArgument("color","The color to show and insert",t=>t instanceof D.Color,P.Color.from),new m.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new m.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new m.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,i,c)=>t.map(P.InlayHint.to.bind(void 0,c)))),new m.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(P.FoldingRange.to)})),new m.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",v(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new m.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new m.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>I.URI.isUri(t)||typeof t=="string"&&(0,y.matchesSomeScheme)(t,A.Schemas.http,A.Schemas.https),t=>t),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),m.ApiCommandArgument.String.with("label","").optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.ApiCommandArgument.Uri.with("resource","Resource to open"),m.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VSCodium's default editor"),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),m.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),m.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new m.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.ApiCommandArgument.TestItem],m.ApiCommandResult.Void),new m.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.ApiCommandResult.Void),new m.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.ApiCommandArgument.String.with("name","The context key name"),new m.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],m.ApiCommandResult.Void),new m.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.StringArray,new m.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new m.ApiCommandResult("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class E{static register(i){l.forEach(i.registerApiCommand,i),this._registerValidateWhenClausesCommand(i)}static _registerValidateWhenClausesCommand(i){i.registerCommand(!1,"_validateWhenClauses",h.validateWhenClauses)}}e.ExtHostApiCommands=E;function v(t){return i=>{if(Array.isArray(i))return i.map(t)}}function d(t){if(!Array.isArray(t))return;const i=[];for(const c of t)L.isLocationLink(c)?i.push(P.DefinitionLink.to(c)):i.push(P.location.to(c));return i}}),define(Pe[226],Te([1,0,13,65,5,6,2,78,20,8,7,3,26]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function E(v,d,t){const i=v.getProxy(D.MainContext.MainThreadComments);class c{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new y.ExtensionIdentifierMap,d.registerArgumentProcessor({processArgument:p=>{if(p&&p.$mid===6){const w=this._commentControllers.get(p.handle);return w?w.value:p}else if(p&&p.$mid===7){const w=this._commentControllers.get(p.commentControlHandle);if(!w)return p;const _=w.getCommentThread(p.commentThreadHandle);return _?_.value:p}else if(p&&(p.$mid===9||p.$mid===8)){const w=this._commentControllers.get(p.thread.commentControlHandle);if(!w)return p;const _=w.getCommentThread(p.thread.commentThreadHandle);return _?p.$mid===8?_.value:{thread:_.value,text:p.text}:p}else if(p&&p.$mid===10){const w=this._commentControllers.get(p.thread.commentControlHandle);if(!w)return p;const _=w.getCommentThread(p.thread.commentThreadHandle);if(!_)return p;const o=p.commentUniqueId,u=_.getCommentByUniqueId(o);return u||p}else if(p&&p.$mid===11){const w=this._commentControllers.get(p.thread.commentControlHandle);if(!w)return p;const _=w.getCommentThread(p.thread.commentThreadHandle);if(!_)return p;const o=p.text,u=p.commentUniqueId,g=_.getCommentByUniqueId(u);return g?(typeof g.body=="string"?g.body=o:g.body=new P.MarkdownString(o),g):p}return p}})}createCommentController(p,w,_){const o=c.handlePool++,u=new C(p,o,w,_);this._commentControllers.set(u.handle,u);const g=this._commentControllersByExtension.get(p.identifier)||[];return g.push(u),this._commentControllersByExtension.set(p.identifier,g),u.value}$createCommentThreadTemplate(p,w,_){const o=this._commentControllers.get(p);o&&o.$createCommentThreadTemplate(w,_)}async $updateCommentThreadTemplate(p,w,_){const o=this._commentControllers.get(p);o&&o.$updateCommentThreadTemplate(w,_)}$deleteCommentThread(p,w){this._commentControllers.get(p)?.$deleteCommentThread(w)}$provideCommentingRanges(p,w,_){const o=this._commentControllers.get(p);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const u=t.getDocument(T.URI.revive(w));return(0,S.asPromise)(async()=>{const g=await o.commentingRangeProvider.provideCommentingRanges(u,_);let O;return Array.isArray(g)?O={ranges:g,fileComments:!1}:g?O={ranges:g.ranges||[],fileComments:g.fileComments||!1}:O=g??void 0,O}).then(g=>{let O;return g&&(O={ranges:g.ranges.map(z=>m.Range.from(z)),fileComments:g.fileComments}),O})}$toggleReaction(p,w,_,o,u){const g=this._commentControllers.get(p);return!g||!g.reactionHandler?Promise.resolve(void 0):(0,S.asPromise)(()=>{const O=g.getCommentThread(w);if(O){const z=O.getCommentByUniqueId(o.uniqueIdInThread);if(g!==void 0&&z&&g.reactionHandler)return g.reactionHandler(z,a(u))}return Promise.resolve(void 0)})}}class f{static{this._handlePool=0}set threadId(p){this._id=p}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(p){(p===void 0!=(this._range===void 0)||!p||!this._range||!p.isEqual(this._range))&&(this._range=p,this.modifications.range=p,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(p){this._canReply!==p&&(this._canReply=p,this.modifications.canReply=p,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(p){this._label=p,this.modifications.label=p,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(p){this._contextValue=p,this.modifications.contextValue=p,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(p){this._comments=p,this.modifications.comments=p,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(p){this._collapseState=p,this.modifications.collapsibleState=p,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(p){this._state=p,this.modifications.state=p,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(p,w,_,o,u,g,O,z){this._commentControllerHandle=w,this._id=_,this._uri=o,this._range=u,this._comments=g,this.extensionDescription=O,this._isTemplate=z,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputDisposables.value=new L.DisposableStore,this._id===void 0&&(this._id=`${p}.${this.handle}`),i.$createCommentThread(w,this.handle,this._id,this._uri,m.Range.from(this._range),O.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=g,this._localDisposables.push({dispose:()=>{i.$deleteCommentThread(w,this.handle)}});const H=this;this.value={get uri(){return H.uri},get range(){return H.range},set range(B){H.range=B},get comments(){return H.comments},set comments(B){H.comments=B},get collapsibleState(){return H.collapsibleState},set collapsibleState(B){H.collapsibleState=B},get canReply(){return H.canReply},set canReply(B){H.canReply=B},get contextValue(){return H.contextValue},set contextValue(B){H.contextValue=B},get label(){return H.label},set label(B){H.label=B},get state(){return H.state},set state(B){H.state=B},dispose:()=>{H.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new L.DisposableStore);const p=_=>Object.prototype.hasOwnProperty.call(this.modifications,_),w={};p("range")&&(w.range=m.Range.from(this._range)),p("label")&&(w.label=this.label),p("contextValue")&&(w.contextValue=this.contextValue??null),p("comments")&&(w.comments=this._comments.map(_=>k(this,_,this._commentsMap,this.extensionDescription))),p("collapsibleState")&&(w.collapseState=r(this._collapseState)),p("canReply")&&(w.canReply=this.canReply),p("state")&&(w.state=s(this._state)),p("isTemplate")&&(w.isTemplate=this._isTemplate),this.modifications={},i.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,w)}getCommentByUniqueId(p){for(const w of this._commentsMap){const _=w[0],o=w[1];if(p===o)return _}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(p=>p.dispose())}}Ve([(0,A.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class C{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(p){this._commentingRangeProvider=p,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(p){this._reactionHandler=p,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!p})}get options(){return this._options}set options(p){this._options=p,i.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(p,w,_,o){this._extension=p,this._handle=w,this._id=_,this._label=o,this._threads=new Map,i.$registerCommentController(this.handle,_,o);const u=this;this.value=Object.freeze({id:u.id,label:u.label,get options(){return u.options},set options(g){u.options=g},get commentingRangeProvider(){return u.commentingRangeProvider},set commentingRangeProvider(g){u.commentingRangeProvider=g},get reactionHandler(){return u.reactionHandler},set reactionHandler(g){u.reactionHandler=g},createCommentThread(g,O,z){return u.createCommentThread(g,O,z).value},dispose:()=>{u.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(p,w,_){w===void 0&&(0,l.checkProposedApiEnabled)(this._extension,"fileComments");const o=new f(this.id,this.handle,void 0,p,w,_,this._extension,!1);return this._threads.set(o.handle,o),o}$createCommentThreadTemplate(p,w){const _=new f(this.id,this.handle,void 0,T.URI.revive(p),m.Range.to(w),[],this._extension,!0);return _.collapsibleState=h.CommentThreadCollapsibleState.Expanded,this._threads.set(_.handle,_),_}$updateCommentThreadTemplate(p,w){const _=this._threads.get(p);_&&(_.range=m.Range.to(w))}$deleteCommentThread(p){this._threads.get(p)?.dispose(),this._threads.delete(p)}getCommentThread(p){return this._threads.get(p)}dispose(){this._threads.forEach(p=>{p.dispose()}),this._localDisposables.forEach(p=>p.dispose())}}function k(b,p,w,_){let o=w.get(p);return o||(o=++b.commentHandle,w.set(p,o)),p.state!==void 0&&(0,l.checkProposedApiEnabled)(_,"commentsDraftState"),{mode:p.mode,contextValue:p.contextValue,uniqueIdInThread:o,body:typeof p.body=="string"?p.body:m.MarkdownString.from(p.body),userName:p.author.name,userIconPath:p.author.iconPath,label:p.label,commentReactions:p.reactions?p.reactions.map(u=>n(u)):void 0,state:p.state,timestamp:p.timestamp?.toJSON()}}function n(b){return{label:b.label,iconPath:b.iconPath?m.pathOrURIToURI(b.iconPath):void 0,count:b.count,hasReacted:b.authorHasReacted}}function a(b){return{label:b.label||"",count:b.count||0,iconPath:b.iconPath?T.URI.revive(b.iconPath):"",authorHasReacted:b.hasReacted||!1}}function r(b){if(b!==void 0)switch(b){case P.CommentThreadCollapsibleState.Expanded:return h.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return h.CommentThreadCollapsibleState.Collapsed}return h.CommentThreadCollapsibleState.Collapsed}function s(b){if(b!==void 0)switch(b){case P.CommentThreadState.Unresolved:return h.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return h.CommentThreadState.Resolved}return h.CommentThreadState.Unresolved}return new c}e.createExtHostComments=E}),define(Pe[227],Te([1,0,24,3,27,17]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let T=class{constructor(P,D){this._mainThreadConsole=P.getProxy(A.MainContext.MainThreadConsole),this._includeStack=D.consoleForward.includeStack,this._logNative=D.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(P,D){const l=this,E=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){l._handleConsoleCall(P,D,E,arguments)}})}_handleConsoleCall(P,D,l,E){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:D,arguments:y(E,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(P,l,E)}};e.AbstractExtHostConsoleForwarder=T,e.AbstractExtHostConsoleForwarder=T=Ve([ze(0,L.IExtHostRpcService),ze(1,I.IExtHostInitDataService)],T);const h=1e5;function y(m,P){const D=[];if(m.length)for(let l=0;l<m.length;l++){let E=m[l];if(typeof E>"u")E="undefined";else if(E instanceof Error){const v=E;v.stack?E=v.stack:E=v.toString()}D.push(E)}if(P){const l=new Error().stack;l&&D.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,S.safeStringify)(D);return l.length>h?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[108],Te([1,0,2,3,7,4,17,14,18,15,19,26]),function(ve,e,S,A,I,L,T,h,y,m,P,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class{static{l=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(d,t){this._logService=t,this._provider=new Map,this._proxy=d.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,t){const i=l._handlePool++;this._provider.set(i,{provider:d,extensionDescription:t}),this._proxy.$registerDecorationProvider(i,t.identifier.value);const c=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(f=>{if(!f){this._proxy.$onDidChange(i,null);return}const C=(0,y.asArray)(f);if(C.length<=l._maxEventSize){this._proxy.$onDidChange(i,C);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,C.length);const k=C.map(r=>({uri:r,rank:(0,m.count)(r.path,"/")})),n=(0,y.groupBy)(k,(r,s)=>r.rank-s.rank||(0,m.compare)(r.uri.path,s.uri.path)),a=[];e:for(const r of n){let s;for(const b of r){const p=(0,P.dirname)(b.uri.path);if(s!==p&&(s=p,a.push(b.uri)>=l._maxEventSize))break e}}this._proxy.$onDidChange(i,a)});return new I.Disposable(()=>{c?.dispose(),this._proxy.$unregisterDecorationProvider(i),this._provider.delete(i)})}async $provideDecorations(d,t,i){if(!this._provider.has(d))return Object.create(null);const c=Object.create(null),{provider:f,extensionDescription:C}=this._provider.get(d);return await Promise.all(t.map(async k=>{try{const{uri:n,id:a}=k,r=await Promise.resolve(f.provideFileDecoration(S.URI.revive(n),i));if(!r)return;try{I.FileDecoration.validate(r),r.badge&&typeof r.badge!="string"&&(0,D.checkProposedApiEnabled)(C,"codiconDecoration"),c[a]=[r.propagate,r.tooltip,r.badge,r.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${C.identifier.value}': ${s}`)}}catch(n){this._logService.error(n)}})),c}};e.ExtHostDecorations=E,e.ExtHostDecorations=E=l=Ve([ze(0,T.IExtHostRpcService),ze(1,h.ILogService)],E),e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")}),define(Pe[228],Te([1,0,148,94,2,3,7,8,5,14,28,39]),function(ve,e,S,A,I,L,T,h,y,m,P,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class E{#e;#t;#i;constructor(t,i,c,f,C,k,n,a){this._name=t,this._owner=i,this._maxDiagnosticsTotal=c,this._maxDiagnosticsPerFile=f,this._modelVersionIdProvider=C,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(f,c),this.#i=new P.ResourceMap(r=>k.getComparisonKey(r)),this.#e=n,this.#t=a}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(t,i){if(!t){this.clear();return}this._checkDisposed();let c=[];if(I.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),c=[t]}else if(Array.isArray(t)){c=[];let k;t=[...t].sort(E._compareIndexedTuplesByUri);for(const n of t){const[a,r]=n;if((!k||a.toString()!==k.toString())&&(k&&this.#i.get(k).length===0&&this.#i.delete(k),k=a,c.push(a),this.#i.set(a,[])),r)this.#i.get(a)?.push(...r);else{const s=this.#i.get(a);s&&(s.length=0)}}}if(this.#t.fire(c),!this.#e)return;const f=[];let C=0;for(const k of c){let n=[];const a=this.#i.get(k);if(a)if(a.length>this._maxDiagnosticsPerFile){n=[];const r=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const b of a)if(b.severity===r[s]&&n.push({...h.Diagnostic.from(b),modelVersionId:this._modelVersionIdProvider(k)})===this._maxDiagnosticsPerFile)break e;n.push({severity:A.MarkerSeverity.Info,message:(0,S.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=a.map(r=>({...h.Diagnostic.from(r),modelVersionId:this._modelVersionIdProvider(k)}));if(f.push([k,n]),C+=n.length,C>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,f)}delete(t){this._checkDisposed(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this._owner,[[t,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(t,i){this._checkDisposed();for(const[c,f]of this)t.call(i,c,f,this)}*[Symbol.iterator](){this._checkDisposed();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this._checkDisposed();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this._checkDisposed(),Array.isArray(this.#i.get(t))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.DiagnosticCollection=E;let v=class{static{l=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*l._maxDiagnosticsPerFile}static _mapper(t){const i=new P.ResourceMap;for(const c of t)i.set(c,c);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,c,f){this._logService=i,this._fileSystemInfoService=c,this._extHostDocumentsAndEditors=f,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:C=>C.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,l._mapper),this._proxy=t.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{_collections:c,_proxy:f,_onDidChangeDiagnostics:C,_logService:k,_fileSystemInfoService:n,_extHostDocumentsAndEditors:a}=this,r=new class{$changeMany(p,w){f.$changeMany(p,w),k.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,p,w.length===0?"CLEARING":w)}$clear(p){f.$clear(p),k.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,p)}dispose(){f.dispose()}};let s;if(!i)i="_generated_diagnostic_collection_name_#"+l._idPool++,s=i;else if(!c.has(i))s=i;else{this._logService.warn(`DiagnosticCollection with name '${i}' does already exist.`);do s=i+l._idPool++;while(c.has(s))}return new class extends E{constructor(){super(i,s,l._maxDiagnosticsTotal,l._maxDiagnosticsPerFile,p=>a.getDocument(p)?.version,n.extUri,r,C),c.set(s,this)}dispose(){super.dispose(),c.delete(s)}}}getDiagnostics(t){if(t)return this._getDiagnostics(t);{const i=new Map,c=[];for(const f of this._collections.values())f.forEach((C,k)=>{let n=i.get(C.toString());typeof n>"u"&&(n=c.length,i.set(C.toString(),n),c.push([C,[]])),c[n][1]=c[n][1].concat(...k)});return c}}_getDiagnostics(t){let i=[];for(const c of this._collections.values())c.has(t)&&(i=i.concat(c.get(t)));return i}$acceptMarkersChange(t){if(!this._mirrorCollection){const i="_generated_mirror",c=new E(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,f=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(i,c),this._mirrorCollection=c}for(const[i,c]of t)this._mirrorCollection.set(I.URI.revive(i),c.map(h.Diagnostic.to))}};e.ExtHostDiagnostics=v,e.ExtHostDiagnostics=v=l=Ve([ze(1,m.ILogService),ze(2,D.IExtHostFileSystemInfo)],v)}),define(Pe[229],Te([1,0,2,3,26]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class L{constructor(h){this._proxy=h.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(h,y){return y?.allowUIResources&&(0,I.checkProposedApiEnabled)(h,"showLocal"),this._proxy.$showOpenDialog(y).then(m=>m?m.map(P=>S.URI.revive(P)):void 0)}showSaveDialog(h){return this._proxy.$showSaveDialog(h).then(y=>y?S.URI.revive(y):void 0)}}e.ExtHostDialogs=L}),define(Pe[230],Te([1,0,9,2,7,3,12,21,15]),function(ve,e,S,A,I,L,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class m{static{this._handlePool=0}constructor(D,l,E){this._documentsAndEditors=l,this._logService=E,this._documentContentProviders=new Map,this._proxy=D.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,l){if(Object.keys(T.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const E=m._handlePool++;this._documentContentProviders.set(E,l),this._proxy.$registerTextContentProvider(E,D);let v;return typeof l.onDidChange=="function"&&(v=l.onDidChange(d=>{if(d.scheme!==D){this._logService.warn(`Provider for scheme '${D}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(E,d).then(t=>{if(!t&&typeof t!="string")return;const i=this._documentsAndEditors.getDocument(d);if(!i)return;const c=(0,y.splitLines)(t);if(!i.equalLines(c))return this._proxy.$onVirtualDocumentChange(d,t)},S.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(D,l){const E=this._documentContentProviders.get(D);return E?Promise.resolve(E.provideTextDocumentContent(A.URI.revive(l),h.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=m}),define(Pe[231],Te([1,0,5,6,2,3,101,8,16,24,7,9]),function(ve,e,S,A,I,L,T,h,y,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class l{constructor(v,d){this._onDidAddDocument=new S.Emitter({onListenerError:D.onUnexpectedExternalError}),this._onDidRemoveDocument=new S.Emitter({onListenerError:D.onUnexpectedExternalError}),this._onDidChangeDocument=new S.Emitter({onListenerError:D.onUnexpectedExternalError}),this._onDidSaveDocument=new S.Emitter({onListenerError:D.onUnexpectedExternalError}),this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new A.DisposableStore,this._documentLoader=new Map,this._proxy=v.getProxy(L.MainContext.MainThreadDocuments),this._documentsAndEditors=d,this._documentsAndEditors.onDidRemoveDocuments(t=>{for(const i of t)this._onDidRemoveDocument.fire(i.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(t=>{for(const i of t)this._onDidAddDocument.fire(i.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(v){if(!v)return;const d=this._documentsAndEditors.getDocument(v);if(d)return d}getDocument(v){const d=this.getDocumentData(v);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return d.document}ensureDocumentData(v){const d=this._documentsAndEditors.getDocument(v);if(d)return Promise.resolve(d);let t=this._documentLoader.get(v.toString());return t||(t=this._proxy.$tryOpenDocument(v).then(i=>{this._documentLoader.delete(v.toString());const c=I.URI.revive(i);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(c))},i=>(this._documentLoader.delete(v.toString()),Promise.reject(i))),this._documentLoader.set(v.toString(),t)),t}createDocumentData(v){return this._proxy.$tryCreateDocument(v).then(d=>I.URI.revive(d))}$acceptModelLanguageChanged(v,d){const t=I.URI.revive(v),i=this._documentsAndEditors.getDocument(t);if(!i)throw new Error("unknown document");this._onDidRemoveDocument.fire(i.document),i._acceptLanguageId(d),this._onDidAddDocument.fire(i.document)}$acceptModelSaved(v){const d=I.URI.revive(v),t=this._documentsAndEditors.getDocument(d);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this._onDidSaveDocument.fire(t.document)}$acceptDirtyStateChanged(v,d){const t=I.URI.revive(v),i=this._documentsAndEditors.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(d),this._onDidChangeDocument.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,d,t){const i=I.URI.revive(v),c=this._documentsAndEditors.getDocument(i);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(d);let f;d.isUndoing?f=P.TextDocumentChangeReason.Undo:d.isRedoing&&(f=P.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,m.deepFreeze)({document:c.document,contentChanges:d.changes.map(C=>({range:h.Range.to(C.range),rangeOffset:C.rangeOffset,rangeLength:C.rangeLength,text:C.text})),reason:f}))}setWordDefinitionFor(v,d){(0,T.setWordDefinitionFor)(v,d)}}e.ExtHostDocuments=l}),define(Pe[60],Te([1,0,50,5,6,2,4,3,101,17,106,8,14,28,12,67,66]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class i{constructor(C){this.value=C,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let c=class{constructor(C,k){this._extHostRpc=C,this._logService=k,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new A.Emitter,this._onDidRemoveDocuments=new A.Emitter,this._onDidChangeVisibleTextEditors=new A.Emitter,this._onDidChangeActiveTextEditor=new A.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(C){this.acceptDocumentsAndEditorsDelta(C)}acceptDocumentsAndEditorsDelta(C){const k=[],n=[],a=[];if(C.removedDocuments)for(const r of C.removedDocuments){const s=L.URI.revive(r),b=this._documents.get(s);b?.unref()&&(this._documents.delete(s),k.push(b.value))}if(C.addedDocuments)for(const r of C.addedDocuments){const s=L.URI.revive(r.uri);let b=this._documents.get(s);if(b&&s.scheme!==v.Schemas.vscodeNotebookCell&&s.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);b||(b=new i(new y.ExtHostDocumentData(this._extHostRpc.getProxy(h.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(s,b),n.push(b.value)),b.ref()}if(C.removedEditors)for(const r of C.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&a.push(s)}if(C.addedEditors)for(const r of C.addedEditors){const s=L.URI.revive(r.documentUri);S.ok(this._documents.has(s),`document '${s}' does not exist`),S.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const b=this._documents.get(s).value,p=new P.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(h.MainContext.MainThreadTextEditors),this._logService,new t.Lazy(()=>b.document),r.selections.map(D.Selection.to),r.options,r.visibleRanges.map(w=>D.Range.to(w)),typeof r.editorPosition=="number"?D.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,p)}C.newActiveEditor!==void 0&&(S.ok(C.newActiveEditor===null||this._editors.has(C.newActiveEditor),`active editor '${C.newActiveEditor}' does not exist`),this._activeEditorId=C.newActiveEditor),(0,I.dispose)(k),(0,I.dispose)(a),C.removedDocuments&&this._onDidRemoveDocuments.fire(k),C.addedDocuments&&this._onDidAddDocuments.fire(n),(C.removedEditors||C.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),C.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(C){return this._documents.get(C)?.value}allDocuments(){return d.Iterable.map(this._documents.values(),C=>C.value)}getEditor(C){return this._editors.get(C)}activeEditor(C){if(!this._activeEditorId)return;const k=this._editors.get(this._activeEditorId);return C?k:k?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=c,e.ExtHostDocumentsAndEditors=c=Ve([ze(0,m.IExtHostRpcService),ze(1,l.ILogService)],c),e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(Pe[61],Te([1,0,8,3,2,5,4,7,17,16,100]),function(ve,e,S,A,I,L,T,h,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class D{constructor(t,i,c){this._activeTabIdGetter=c,this._parentGroup=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this._apiObject){const t=this,i={get isActive(){return t._dto.id===t._activeTabIdGetter()},get label(){return t._dto.label},get input(){return t._input},get isDirty(){return t._dto.isDirty},get isPinned(){return t._dto.isPinned},get isPreview(){return t._dto.isPreview},get group(){return t._parentGroup.apiObject}};this._apiObject=Object.freeze(i)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(t){this._dto=t,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new h.TextTabInput(I.URI.revive(this._dto.input.uri));case 2:return new h.TextDiffTabInput(I.URI.revive(this._dto.input.original),I.URI.revive(this._dto.input.modified));case 3:return new h.TextMergeTabInput(I.URI.revive(this._dto.input.base),I.URI.revive(this._dto.input.input1),I.URI.revive(this._dto.input.input2),I.URI.revive(this._dto.input.result));case 6:return new h.CustomEditorTabInput(I.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new h.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new h.NotebookEditorTabInput(I.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new h.NotebookDiffEditorTabInput(I.URI.revive(this._dto.input.original),I.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new h.TerminalEditorTabInput;case 9:return new h.InteractiveWindowInput(I.URI.revive(this._dto.input.uri),I.URI.revive(this._dto.input.inputBoxUri));default:return}}}class l{constructor(t,i){this._tabs=[],this._activeTabId="",this._dto=t,this._activeGroupIdGetter=i;for(const c of t.tabs)c.isActive&&(this._activeTabId=c.id),this._tabs.push(new D(c,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const t=this,i={get isActive(){return t._dto.groupId===t._activeGroupIdGetter()},get viewColumn(){return S.ViewColumn.to(t._dto.viewColumn)},get activeTab(){return t._tabs.find(c=>c.tabId===t._activeTabId)?.apiObject},get tabs(){return Object.freeze(t._tabs.map(c=>c.apiObject))}};this._apiObject=Object.freeze(i)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(t){this._dto=t}acceptTabOperation(t){if(t.kind===0){const c=new D(t.tabDto,this,()=>this.activeTabId());return this._tabs.splice(t.index,0,c),t.tabDto.isActive&&(this._activeTabId=c.tabId),c}else if(t.kind===1){const c=this._tabs.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this._activeTabId&&(this._activeTabId=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this._tabs.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this._tabs.splice(t.index,0,c),c}const i=this._tabs.find(c=>c.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this._activeTabId=t.tabDto.id:this._activeTabId===t.tabDto.id&&!t.tabDto.isActive&&(this._activeTabId=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this._activeTabId}}let E=class{constructor(t){this._onDidChangeTabs=new L.Emitter,this._onDidChangeTabGroups=new L.Emitter,this._extHostTabGroups=[],this._proxy=t.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const t=this,i={onDidChangeTabGroups:t._onDidChangeTabGroups.event,onDidChangeTabs:t._onDidChangeTabs.event,get all(){return Object.freeze(t._extHostTabGroups.map(c=>c.apiObject))},get activeTabGroup(){const c=t._activeGroupId;return(0,m.assertIsDefined)(t._extHostTabGroups.find(C=>C.groupId===c)?.apiObject)},close:async(c,f)=>{const C=Array.isArray(c)?c:[c];return C.length?v(C[0])?this._closeGroups(C,f):this._closeTabs(C,f):!0}};this._apiObject=Object.freeze(i)}return this._apiObject}$acceptEditorTabModel(t){const i=new Set(this._extHostTabGroups.map(r=>r.groupId)),c=new Set(t.map(r=>r.groupId)),f=(0,P.diffSets)(i,c),C=this._extHostTabGroups.filter(r=>f.removed.includes(r.groupId)).map(r=>r.apiObject),k=[],n=[];this._extHostTabGroups=t.map(r=>{const s=new l(r,()=>this._activeGroupId);return f.added.includes(s.groupId)?k.push(s.apiObject):n.push(s.apiObject),s});const a=(0,m.assertIsDefined)(t.find(r=>r.isActive===!0)?.groupId);a!==void 0&&this._activeGroupId!==a&&(this._activeGroupId=a),this._onDidChangeTabGroups.fire(Object.freeze({opened:k,closed:C,changed:n}))}$acceptTabGroupUpdate(t){const i=this._extHostTabGroups.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this._activeGroupId=t.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this._extHostTabGroups.find(f=>f.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const c=i.acceptTabOperation(t);switch(t.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}_findExtHostTabFromApi(t){for(const i of this._extHostTabGroups)for(const c of i.tabs)if(c.apiObject===t)return c}_findExtHostTabGroupFromApi(t){return this._extHostTabGroups.find(i=>i.apiObject===t)}async _closeTabs(t,i){const c=[];for(const f of t){const C=this._findExtHostTabFromApi(f);if(!C)throw new Error("Tab close: Invalid tab not found!");c.push(C.tabId)}return this._proxy.$closeTab(c,i)}async _closeGroups(t,i){const c=[];for(const f of t){const C=this._findExtHostTabGroupFromApi(f);if(!C)throw new Error("Group close: Invalid group not found!");c.push(C.groupId)}return this._proxy.$closeGroup(c,i)}};e.ExtHostEditorTabs=E,e.ExtHostEditorTabs=E=Ve([ze(0,y.IExtHostRpcService)],E);function v(d){return d.tabs!==void 0}}),define(Pe[232],Te([1,0,3,7]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class I{constructor(T){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(S.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,h,y){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const m=this._AiEmbeddingVectorProviders.get(T);if(!m)throw new Error("Embedding vector provider not found");const P=await m.provideEmbeddingVector(h,y);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(T,h,y){const m=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(m,y),this._proxy.$registerAiEmbeddingVectorProvider(h,m),new A.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(m),this._AiEmbeddingVectorProviders.delete(m)})}}e.ExtHostAiEmbeddingVector=I}),define(Pe[233],Te([1,0,2,3,6,7,8,279,15,25,26,49]),function(ve,e,S,A,I,L,T,h,y,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class l{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const t=this._schemes.indexOf(d);t>=0&&(this._schemes.splice(t,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),t=[];let i,c,f=14,C=14;for(const k of d){let n=i?(0,y.commonPrefixLength)(i,k):0;for(n===0?c=1:c=C;n<k.length;n++)n+1===k.length?(f=C,C=9):C+=1,t.push([c,k.toUpperCase().charCodeAt(n),C]),t.push([c,k.toLowerCase().charCodeAt(n),C]),c=C;i=k,C=f}t.push([9,58,10]),t.push([10,47,12]),this._stateMachine=new h.StateMachine(t)}}provideDocumentLinks(d){this._initStateMachine();const t=[],i=h.LinkComputer.computeLinks({getLineContent(c){return d.lineAt(c-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const c of i){const f=T.DocumentLink.to(c);f.target&&t.push(f)}return t}}class E{constructor(d,t){this._extHostLanguageFeatures=t,this._linkProvider=new l,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=d.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(d,t,i,c={}){if(E._validateFileSystemProvider(i),this._registeredSchemes.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(d,"*",this._linkProvider));const f=this._handlePool++;this._linkProvider.add(t),this._registeredSchemes.add(t),this._fsProvider.set(f,i);let C=2;c.isCaseSensitive&&(C+=1024),c.isReadonly&&(C+=2048),typeof i.copy=="function"&&(C+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.checkProposedApiEnabled)(d,"fsChunks"),C+=4);let k;c.isReadonly&&(0,D.isMarkdownString)(c.isReadonly)&&((0,P.checkProposedApiEnabled)(d,"readonlyMessage"),k={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this._proxy.$registerFileSystemProvider(f,t,C,k).catch(a=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${t}`),console.error(a)});const n=i.onDidChangeFile(a=>{const r=[];for(const s of a){const{uri:b,type:p}=s;if(b.scheme!==t)continue;let w;switch(p){case L.FileChangeType.Changed:w=0;break;case L.FileChangeType.Created:w=1;break;case L.FileChangeType.Deleted:w=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:b,type:w})}this._proxy.$onFileSystemChange(f,r)});return(0,I.toDisposable)(()=>{n.dispose(),this._linkProvider.delete(t),this._registeredSchemes.delete(t),this._fsProvider.delete(f),this._proxy.$unregisterProvider(f)})}static _validateFileSystemProvider(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(d){const{type:t,ctime:i,mtime:c,size:f,permissions:C}=d;return{type:t,ctime:i,mtime:c,size:f,permissions:C}}$stat(d,t){return Promise.resolve(this._getFsProvider(d).stat(S.URI.revive(t))).then(i=>E._asIStat(i))}$readdir(d,t){return Promise.resolve(this._getFsProvider(d).readDirectory(S.URI.revive(t)))}$readFile(d,t){return Promise.resolve(this._getFsProvider(d).readFile(S.URI.revive(t))).then(i=>m.VSBuffer.wrap(i))}$writeFile(d,t,i,c){return Promise.resolve(this._getFsProvider(d).writeFile(S.URI.revive(t),i.buffer,c))}$delete(d,t,i){return Promise.resolve(this._getFsProvider(d).delete(S.URI.revive(t),i))}$rename(d,t,i,c){return Promise.resolve(this._getFsProvider(d).rename(S.URI.revive(t),S.URI.revive(i),c))}$copy(d,t,i,c){const f=this._getFsProvider(d);if(!f.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(f.copy(S.URI.revive(t),S.URI.revive(i),c))}$mkdir(d,t){return Promise.resolve(this._getFsProvider(d).createDirectory(S.URI.revive(t)))}$watch(d,t,i,c){const f=this._getFsProvider(d).watch(S.URI.revive(i),c);this._watches.set(t,f)}$unwatch(d,t){const i=this._watches.get(t);i&&(i.dispose(),this._watches.delete(t))}$open(d,t,i){const c=this._getFsProvider(d);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(S.URI.revive(t),i))}$close(d,t){const i=this._getFsProvider(d);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(d,t,i,c){const f=this._getFsProvider(d);if(!f.read)throw new Error('FileSystemProvider does not implement "read"');const C=m.VSBuffer.alloc(c);return Promise.resolve(f.read(t,i,C.buffer,0,c)).then(k=>C.slice(0,k))}$write(d,t,i,c){const f=this._getFsProvider(d);if(!f.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(f.write(t,i,c.buffer,0,c.byteLength))}_getFsProvider(d){const t=this._fsProvider.get(d);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.ExtHostFileSystem=E}),define(Pe[62],Te([1,0,3,38,7,25,4,17,39,6,13,23,12]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let v=E=class{constructor(t,i){this._fileSystemProvider=new Map,this._writeQueue=new P.ResourceQueue,this._proxy=t.getProxy(S.MainContext.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(f){try{let C;const k=c._fileSystemProvider.get(f.scheme);return k?(await c._proxy.$ensureActivation(f.scheme),C=await k.impl.stat(f)):C=await c._proxy.$stat(f),{type:C.type,ctime:C.ctime,mtime:C.mtime,size:C.size,permissions:C.permissions===A.FilePermission.Readonly?1:void 0}}catch(C){E._handleError(C)}},async readDirectory(f){try{const C=c._fileSystemProvider.get(f.scheme);return C?(await c._proxy.$ensureActivation(f.scheme),(await C.impl.readDirectory(f)).slice()):await c._proxy.$readdir(f)}catch(C){return E._handleError(C)}},async createDirectory(f){try{const C=c._fileSystemProvider.get(f.scheme);return C&&!C.isReadonly?(await c._proxy.$ensureActivation(f.scheme),await c.mkdirp(C.impl,C.extUri,f)):await c._proxy.$mkdir(f)}catch(C){return E._handleError(C)}},async readFile(f){try{const C=c._fileSystemProvider.get(f.scheme);return C?(await c._proxy.$ensureActivation(f.scheme),(await C.impl.readFile(f)).slice()):(await c._proxy.$readFile(f)).buffer}catch(C){return E._handleError(C)}},async writeFile(f,C){try{const k=c._fileSystemProvider.get(f.scheme);return k&&!k.isReadonly?(await c._proxy.$ensureActivation(f.scheme),await c.mkdirp(k.impl,k.extUri,k.extUri.dirname(f)),await c._writeQueue.queueFor(f).queue(()=>Promise.resolve(k.impl.writeFile(f,C,{create:!0,overwrite:!0})))):await c._proxy.$writeFile(f,L.VSBuffer.wrap(C))}catch(k){return E._handleError(k)}},async delete(f,C){try{const k=c._fileSystemProvider.get(f.scheme);return k&&!k.isReadonly?(await c._proxy.$ensureActivation(f.scheme),await k.impl.delete(f,{recursive:!1,...C})):await c._proxy.$delete(f,{recursive:!1,useTrash:!1,atomic:!1,...C})}catch(k){return E._handleError(k)}},async rename(f,C,k){try{return await c._proxy.$rename(f,C,{overwrite:!1,...k})}catch(n){return E._handleError(n)}},async copy(f,C,k){try{return await c._proxy.$copy(f,C,{overwrite:!1,...k})}catch(n){return E._handleError(n)}},isWritableFileSystem(f){const C=i.getCapabilities(f);if(typeof C=="number")return!(C&2048)}})}async mkdirp(t,i,c){const f=[];for(;!i.isEqual(c,i.dirname(c));)try{if(!((await t.stat(c)).type&A.FileType.Directory))throw I.FileSystemError.FileExists(`Unable to create folder '${c.scheme===l.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(C){if(A.toFileSystemProviderErrorCode(C)!==A.FileSystemProviderErrorCode.FileNotFound)throw C;f.push(i.basename(c)),c=i.dirname(c)}for(let C=f.length-1;C>=0;C--){c=i.joinPath(c,f[C]);try{await t.createDirectory(c)}catch(k){if(A.toFileSystemProviderErrorCode(k)!==A.FileSystemProviderErrorCode.FileExists)throw k}}}static _handleError(t){if(t instanceof I.FileSystemError)throw t;if(t instanceof A.FileSystemProviderError)switch(t.code){case A.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(t.message);case A.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(t.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(t.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(t.message);case A.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(t.message);case A.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(t.message);default:throw new I.FileSystemError(t.message,t.name)}if(!(t instanceof Error))throw new I.FileSystemError(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw I.FileSystemError.Unavailable(t.message);switch(t.name){case A.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(t.message);case A.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(t.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(t.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(t.message);case A.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(t.message);case A.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(t.message);default:throw new I.FileSystemError(t.message,t.name)}}addFileSystemProvider(t,i,c){return this._fileSystemProvider.set(t,{impl:i,extUri:c?.isCaseSensitive?D.extUri:D.extUriIgnorePathCase,isReadonly:!!c?.isReadonly}),(0,m.toDisposable)(()=>this._fileSystemProvider.delete(t))}getFileSystemProviderExtUri(t){return this._fileSystemProvider.get(t)?.extUri??D.extUri}};e.ExtHostConsumerFileSystem=v,e.ExtHostConsumerFileSystem=v=E=Ve([ze(0,h.IExtHostRpcService),ze(1,y.IExtHostFileSystemInfo)],v),e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(Pe[234],Te([1,0,5,37,2,3,8,7]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(D,l,E,v,d,t,i,c){this._onDidCreate=new S.Emitter,this._onDidChange=new S.Emitter,this._onDidDelete=new S.Emitter;const f=this.ensureWatching(D,E,d);this._config=0,t&&(this._config+=1),i&&(this._config+=2),c&&(this._config+=4);const C=(0,A.parse)(d),k=typeof d=="string",n=v(a=>{if(!t)for(const r of a.created){const s=I.URI.revive(r);C(s.fsPath)&&(!k||l.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!i)for(const r of a.changed){const s=I.URI.revive(r);C(s.fsPath)&&(!k||l.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!c)for(const r of a.deleted){const s=I.URI.revive(r);C(s.fsPath)&&(!k||l.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=h.Disposable.from(f,this._onDidCreate,this._onDidChange,this._onDidDelete,n)}ensureWatching(D,l,E){const v=h.Disposable.from();if(typeof E=="string")return v;const d=D.getProxy(L.MainContext.MainThreadFileSystem);let t=!1;(E.pattern.includes(A.GLOBSTAR)||E.pattern.includes(A.GLOB_SPLIT))&&(t=!0);const i=Math.random();return d.$watch(l.identifier.value,i,E.baseUri,{recursive:t,excludes:[]}),h.Disposable.from({dispose:()=>d.$unwatch(i)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class m{constructor(D,l,E){this._mainContext=D,this._logService=l,this._extHostDocumentsAndEditors=E,this._onFileSystemEvent=new S.Emitter,this._onDidRenameFile=new S.Emitter,this._onDidCreateFile=new S.Emitter,this._onDidDeleteFile=new S.Emitter,this._onWillRenameFile=new S.AsyncEmitter,this._onWillCreateFile=new S.AsyncEmitter,this._onWillDeleteFile=new S.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(D,l,E,v,d,t){return new y(this._mainContext,D,l,this._onFileSystemEvent.event,T.GlobPattern.from(E),v,d,t)}$onFileEvent(D){this._onFileSystemEvent.fire(D)}$onDidRunFileOperation(D,l){switch(D){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(E=>({oldUri:I.URI.revive(E.source),newUri:I.URI.revive(E.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(E=>I.URI.revive(E.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:l.map(E=>I.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(D){return this._createWillExecuteEvent(D,this._onWillRenameFile)}getOnWillCreateFileEvent(D){return this._createWillExecuteEvent(D,this._onWillCreateFile)}getOnWillDeleteFileEvent(D){return this._createWillExecuteEvent(D,this._onWillDeleteFile)}_createWillExecuteEvent(D,l){return(E,v,d)=>{const t=function(c){E.call(v,c)};return t.extension=D,l.event(t,void 0,d)}}async $onWillRunFileOperation(D,l,E,v){switch(D){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(d=>({oldUri:I.URI.revive(d.source),newUri:I.URI.revive(d.target)}))},E,v);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(d=>I.URI.revive(d.target))},E,v);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(d=>I.URI.revive(d.target))},E,v)}}async _fireWillEvent(D,l,E,v){const d=new Set,t=[];if(await D.fireAsync(l,v,async(c,f)=>{const C=Date.now(),k=await Promise.resolve(c);k instanceof h.WorkspaceEdit&&(t.push([f.extension,k]),d.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-C>E&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),v.isCancellationRequested||t.length===0)return;const i={edits:[]};for(const[,c]of t){const{edits:f}=T.WorkspaceEdit.from(c,{getTextDocumentVersion:C=>this._extHostDocumentsAndEditors.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(f)}return{edit:i,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=m}),define(Pe[235],Te([1,0,6,2,3,8,7,31]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class y{static{this._pool=0}constructor(l,E){this.extension=l,this.provider=E,this.handle=y._pool++}}class m{constructor(l){this.session=l,this.responses=[]}}class P{static{this._nextId=0}constructor(l,E,v,d){this._documents=v,this._logService=d,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=l.getProxy(I.MainContext.MainThreadInlineChat),E.registerApiCommand(new h.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new h.ApiCommandArgument("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?L.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?L.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?L.Position.from(t.position):void 0}})],h.ApiCommandResult.Void))}registerProvider(l,E){const v=new y(l,E);return this._inputProvider.set(v.handle,v),this._proxy.$registerInteractiveEditorProvider(v.handle,E.label,l.identifier.value,typeof E.handleInteractiveEditorResponseFeedback=="function"),(0,S.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(v.handle),this._inputProvider.delete(v.handle)})}async $prepareSession(l,E,v,d){const t=this._inputProvider.get(l);if(!t){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this._documents.getDocument(A.URI.revive(E)),c=L.Selection.to(v),f=await t.provider.prepareInteractiveEditorSession({document:i,selection:c},d);if(!f)return;if(f.wholeRange&&!f.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const C=P._nextId++;return this._inputSessions.set(C,new m(f)),{id:C,placeholder:f.placeholder,slashCommands:f.slashCommands?.map(k=>({command:k.command,detail:k.detail,refer:k.refer,executeImmediately:k.executeImmediately})),wholeRange:L.Range.from(f.wholeRange),message:f.message}}async $provideResponse(l,E,v,d){const t=this._inputProvider.get(l);if(!t)return;const i=this._inputSessions.get(E.id);if(!i)return;const c={session:i.session,prompt:v.prompt,selection:L.Selection.to(v.selection),wholeRange:L.Range.to(v.wholeRange),attempt:v.attempt,live:v.live};let f=!1;const C={report:a=>{if(!v.live)throw new Error("Progress reporting is only supported for live sessions");f||d.isCancellationRequested||!a.message&&!a.edits||this._proxy.$handleProgressChunk(v.requestId,{message:a.message,edits:a.edits?.map(L.TextEdit.from)})}},k=typeof t.provider.provideInteractiveEditorResponse2=="function"?t.provider.provideInteractiveEditorResponse2(c,C,d):t.provider.provideInteractiveEditorResponse(c,d);Promise.resolve(k).finally(()=>f=!0);const n=await k;if(n){const a=i.responses.push(n)-1,r={wholeRange:L.Range.from(n.wholeRange),placeholder:n.placeholder};if(P._isMessageResponse(n))return{...r,id:a,type:"message",message:L.MarkdownString.from(n.contents)};const{edits:s}=n;if(s instanceof T.WorkspaceEdit)return{...r,id:a,type:"bulkEdit",edits:L.WorkspaceEdit.from(s)};if(Array.isArray(s))return{...r,id:a,type:"editorEdit",edits:s.map(L.TextEdit.from)}}}$handleFeedback(l,E,v,d){const t=this._inputProvider.get(l),i=this._inputSessions.get(E),c=i?.responses[v];if(t&&c){let f;switch(d){case 1:f=T.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:f=T.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:f=T.InteractiveEditorResponseFeedbackKind.Undone;break;case 3:f=T.InteractiveEditorResponseFeedbackKind.Accepted;break}t.provider.handleInteractiveEditorResponseFeedback?.(i.session,c,f)}}$releaseSession(l,E){const v=this._inputSessions.get(E),d=this._inputProvider.get(l);v&&d&&d.provider.releaseInteractiveEditorSession?.(v.session),this._inputSessions.delete(E)}static _isMessageResponse(l){return typeof l=="object"&&typeof l.contents=="object"}}e.ExtHostInteractiveEditor=P}),define(Pe[236],Te([1,0,2,31]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(T,h,y,m,P){this._extHostNotebooks=h,this._textDocumentsAndEditors=y,this._commands=m;const D=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",l=>!0,l=>l),new A.ApiCommandArgument("resource","Interactive resource Uri",l=>!0,l=>l),new A.ApiCommandArgument("controllerId","Notebook controller Id",l=>!0,l=>l),new A.ApiCommandArgument("title","Interactive editor title",l=>!0,l=>l)],new A.ApiCommandResult("Notebook and input URI",l=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const E=this._extHostNotebooks.getEditorById(l.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri),notebookEditor:E.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri)}}));this._commands.registerApiCommand(D)}$willAddInteractiveDocument(T,h,y,m){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:h,lines:[""],languageId:y,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(S.URI.revive(m))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,h){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=I}),define(Pe[237],Te([1,0,3,7]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class I{constructor(T){this._IssueUriRequestHandlers=new Map,this._proxy=T.getProxy(S.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(T,h){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const y=this._IssueUriRequestHandlers.get(T);if(!y)throw new Error("Issue request handler not found");const m=await y.handleIssueUrlRequest();if(!m)throw new Error("Issue request handler returned no result");return m}registerIssueUriRequestHandler(T,h){const y=T.identifier.value;return this._IssueUriRequestHandlers.set(y,h),this._proxy.$registerIssueUriRequestHandler(y),new A.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(y),this._IssueUriRequestHandlers.delete(y)})}}e.ExtHostIssueReporter=I}),define(Pe[238],Te([1,0,6,3]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(T){this._handlePool=0,this._proxy=T.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const h=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(h,T),(0,S.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(h)})}}e.ExtHostLabelService=I}),define(Pe[239],Te([1,0,2,24,8,7,78,3,15,44,18,16,280,21,20,6,91,88,55,59,9,13,26,150]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t,i,c,f,C,k,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class r{constructor(R,W){this._documents=R,this._provider=W}async provideDocumentSymbols(R,W){const K=this._documents.getDocument(R),G=await this._provider.provideDocumentSymbols(K,W);if(!(0,P.isFalsyOrEmpty)(G))return G[0]instanceof L.DocumentSymbol?G.map(I.DocumentSymbol.from):r._asDocumentSymbolTree(G)}static _asDocumentSymbolTree(R){R=R.slice(0).sort((G,V)=>{let ee=G.location.range.start.compareTo(V.location.range.start);return ee===0&&(ee=V.location.range.end.compareTo(G.location.range.end)),ee});const W=[],K=[];for(const G of R){const V={name:G.name||"!!MISSING: name!!",kind:I.SymbolKind.from(G.kind),tags:G.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:I.Range.from(G.location.range),selectionRange:I.Range.from(G.location.range),children:[]};for(;;){if(K.length===0){K.push(V),W.push(V);break}const ee=K[K.length-1];if(m.Range.containsRange(ee.range,V.range)&&!m.Range.equalsRange(ee.range,V.range)){ee.children?.push(V),K.push(V);break}K.pop()}}return W}}class s{static{this._badCmd={command:"missing",title:"!!MISSING: command!!"}}constructor(R,W,K){this._documents=R,this._commands=W,this._provider=K,this._cache=new c.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(R,W){const K=this._documents.getDocument(R),G=await this._provider.provideCodeLenses(K,W);if(!G||W.isCancellationRequested)return;const V=this._cache.add(G),ee=new d.DisposableStore;this._disposables.set(V,ee);const ce={cacheId:V,lenses:[]};for(let Me=0;Me<G.length;Me++)ce.lenses.push({cacheId:[V,Me],range:I.Range.from(G[Me].range),command:this._commands.toInternal(G[Me].command,ee)});return ce}async resolveCodeLens(R,W){const K=R.cacheId&&this._cache.get(...R.cacheId);if(!K)return;let G;if(typeof this._provider.resolveCodeLens!="function"||K.isResolved?G=K:G=await this._provider.resolveCodeLens(K,W),G||(G=K),W.isCancellationRequested)return;const V=R.cacheId&&this._disposables.get(R.cacheId[0]);if(V)return R.command=this._commands.toInternal(G.command??s._badCmd,V),R}releaseCodeLenses(R){this._disposables.get(R)?.dispose(),this._disposables.delete(R),this._cache.delete(R)}}function b(Ce){return Array.isArray(Ce)?Ce.map(I.DefinitionLink.from):Ce?[I.DefinitionLink.from(Ce)]:[]}class p{constructor(R,W){this._documents=R,this._provider=W}async provideDefinition(R,W,K){const G=this._documents.getDocument(R),V=I.Position.to(W),ee=await this._provider.provideDefinition(G,V,K);return b(ee)}}class w{constructor(R,W){this._documents=R,this._provider=W}async provideDeclaration(R,W,K){const G=this._documents.getDocument(R),V=I.Position.to(W),ee=await this._provider.provideDeclaration(G,V,K);return b(ee)}}class _{constructor(R,W){this._documents=R,this._provider=W}async provideImplementation(R,W,K){const G=this._documents.getDocument(R),V=I.Position.to(W),ee=await this._provider.provideImplementation(G,V,K);return b(ee)}}class o{constructor(R,W){this._documents=R,this._provider=W}async provideTypeDefinition(R,W,K){const G=this._documents.getDocument(R),V=I.Position.to(W),ee=await this._provider.provideTypeDefinition(G,V,K);return b(ee)}}class u{constructor(R,W){this._documents=R,this._provider=W}async provideHover(R,W,K){const G=this._documents.getDocument(R),V=I.Position.to(W),ee=await this._provider.provideHover(G,V,K);if(!(!ee||(0,P.isFalsyOrEmpty)(ee.contents)))return ee.range||(ee.range=G.getWordRangeAtPosition(V)),ee.range||(ee.range=new L.Range(V,V)),I.Hover.from(ee)}}class g{constructor(R,W){this._documents=R,this._provider=W}async provideEvaluatableExpression(R,W,K){const G=this._documents.getDocument(R),V=I.Position.to(W),ee=await this._provider.provideEvaluatableExpression(G,V,K);if(ee)return I.EvaluatableExpression.from(ee)}}class O{constructor(R,W){this._documents=R,this._provider=W}async provideInlineValues(R,W,K,G){const V=this._documents.getDocument(R),ee=await this._provider.provideInlineValues(V,I.Range.to(W),I.InlineValueContext.to(K),G);if(Array.isArray(ee))return ee.map(ce=>I.InlineValue.from(ce))}}class z{constructor(R,W){this._documents=R,this._provider=W}async provideDocumentHighlights(R,W,K){const G=this._documents.getDocument(R),V=I.Position.to(W),ee=await this._provider.provideDocumentHighlights(G,V,K);if(Array.isArray(ee))return ee.map(I.DocumentHighlight.from)}}class H{constructor(R,W){this._documents=R,this._provider=W}async provideLinkedEditingRanges(R,W,K){const G=this._documents.getDocument(R),V=I.Position.to(W),ee=await this._provider.provideLinkedEditingRanges(G,V,K);if(ee&&Array.isArray(ee.ranges))return{ranges:(0,P.coalesce)(ee.ranges.map(I.Range.from)),wordPattern:ee.wordPattern}}}class B{constructor(R,W){this._documents=R,this._provider=W}async provideReferences(R,W,K,G){const V=this._documents.getDocument(R),ee=I.Position.to(W),ce=await this._provider.provideReferences(V,ee,K,G);if(Array.isArray(ce))return ce.map(I.location.from)}}class ${static{this._maxCodeActionsPerFile=1e3}constructor(R,W,K,G,V,ee,ce){this._documents=R,this._commands=W,this._diagnostics=K,this._provider=G,this._logService=V,this._extension=ee,this._apiDeprecation=ce,this._cache=new c.Cache("CodeAction"),this._disposables=new Map,this.nbKind=new L.CodeActionKind("notebook")}async provideCodeActions(R,W,K,G){const V=this._documents.getDocument(R),ee=l.Selection.isISelection(W)?I.Selection.to(W):I.Range.to(W),ce=[];for(const Ye of this._diagnostics.getDiagnostics(R))if(ee.intersection(Ye.range)&&ce.push(Ye)>$._maxCodeActionsPerFile)break;const Me={diagnostics:ce,only:K.only?new L.CodeActionKind(K.only):void 0,triggerKind:I.CodeActionTriggerKind.to(K.trigger)},xe=await this._provider.provideCodeActions(V,ee,Me,G);if(!(0,P.isNonEmptyArray)(xe)||G.isCancellationRequested)return;const Ge=this._cache.add(xe),je=new d.DisposableStore;this._disposables.set(Ge,je);const et=[];for(let Ye=0;Ye<xe.length;Ye++){const Ze=xe[Ye];if(Ze)if($._isCommand(Ze))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Ze.title,command:this._commands.toInternal(Ze,je)});else{if(Me.triggerKind!==L.CodeActionTriggerKind.Invoke&&Ze.kind&&this.nbKind.contains(Ze.kind))continue;Me.only&&(Ze.kind?Me.only.contains(Ze.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${Ze.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[Ge,Ye],title:Ze.title,command:Ze.command&&this._commands.toInternal(Ze.command,je),diagnostics:Ze.diagnostics&&Ze.diagnostics.map(I.Diagnostic.from),edit:Ze.edit&&I.WorkspaceEdit.from(Ze.edit,void 0),kind:Ze.kind&&Ze.kind.value,isPreferred:Ze.isPreferred,disabled:Ze.disabled?.reason})}}return{cacheId:Ge,actions:et}}async resolveCodeAction(R,W){const[K,G]=R,V=this._cache.get(K,G);if(!V||$._isCommand(V))return{};if(!this._provider.resolveCodeAction)return{};const ee=await this._provider.resolveCodeAction(V,W)??V;let ce;ee.edit&&(ce=I.WorkspaceEdit.from(ee.edit,void 0));let Me;if(ee.command){const xe=this._disposables.get(K);xe&&(Me=this._commands.toInternal(ee.command,xe))}return{edit:ce,command:Me}}releaseCodeActions(R){this._disposables.get(R)?.dispose(),this._disposables.delete(R),this._cache.delete(R)}static _isCommand(R){return typeof R.command=="string"&&typeof R.title=="string"}}class x{static toInternalProviderId(R,W){return R+"."+W}constructor(R,W,K,G,V){this._proxy=R,this._documents=W,this._provider=K,this._handle=G,this._extension=V}async prepareDocumentPaste(R,W,K,G){if(!this._provider.prepareDocumentPaste)return;const V=this._documents.getDocument(R),ee=W.map(xe=>I.Range.to(xe)),ce=I.DataTransfer.toDataTransfer(K,()=>{throw new C.NotImplementedError});if(await this._provider.prepareDocumentPaste(V,ee,ce,G),G.isCancellationRequested)return;const Me=Array.from(ce).filter(([,xe])=>!(xe instanceof L.InternalDataTransferItem));return I.DataTransfer.from(Me)}async providePasteEdits(R,W,K,G,V){if(!this._provider.provideDocumentPasteEdits)return;const ee=this._documents.getDocument(W),ce=K.map(Ge=>I.Range.to(Ge)),Me=I.DataTransfer.toDataTransfer(G,async Ge=>(await this._proxy.$resolvePasteFileData(this._handle,R,Ge)).buffer),xe=await this._provider.provideDocumentPasteEdits(ee,ce,Me,V);if(xe)return{label:xe.label??(0,a.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,yieldTo:xe.yieldTo?.map(Ge=>"mimeType"in Ge?Ge:{providerId:x.toInternalProviderId(Ge.extensionId,Ge.providerId)}),insertText:typeof xe.insertText=="string"?xe.insertText:{snippet:xe.insertText.value},additionalEdit:xe.additionalEdit?I.WorkspaceEdit.from(xe.additionalEdit,void 0):void 0}}}class M{constructor(R,W){this._documents=R,this._provider=W}async provideDocumentFormattingEdits(R,W,K){const G=this._documents.getDocument(R),V=await this._provider.provideDocumentFormattingEdits(G,W,K);if(Array.isArray(V))return V.map(I.TextEdit.from)}}class ne{constructor(R,W){this._documents=R,this._provider=W}async provideDocumentRangeFormattingEdits(R,W,K,G){const V=this._documents.getDocument(R),ee=I.Range.to(W),ce=await this._provider.provideDocumentRangeFormattingEdits(V,ee,K,G);if(Array.isArray(ce))return ce.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(R,W,K,G){(0,D.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const V=this._documents.getDocument(R),ee=W.map(I.Range.to),ce=await this._provider.provideDocumentRangesFormattingEdits(V,ee,K,G);if(Array.isArray(ce))return ce.map(I.TextEdit.from)}}class Q{constructor(R,W){this._documents=R,this._provider=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(R,W,K,G,V){const ee=this._documents.getDocument(R),ce=I.Position.to(W),Me=await this._provider.provideOnTypeFormattingEdits(ee,ce,K,G,V);if(Array.isArray(Me))return Me.map(I.TextEdit.from)}}class we{constructor(R,W){this._provider=R,this._logService=W,this._cache=new c.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(R,W){const K=await this._provider.provideWorkspaceSymbols(R,W);if(!(0,P.isNonEmptyArray)(K))return{symbols:[]};const G=this._cache.add(K),V={cacheId:G,symbols:[]};for(let ee=0;ee<K.length;ee++){const ce=K[ee];if(!ce||!ce.name){this._logService.warn("INVALID SymbolInformation",ce);continue}V.symbols.push({...I.WorkspaceSymbol.from(ce),cacheId:[G,ee]})}return V}async resolveWorkspaceSymbol(R,W){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!R.cacheId)return R;const K=this._cache.get(...R.cacheId);if(K){const G=await this._provider.resolveWorkspaceSymbol(K,W);return G&&(0,A.mixin)(R,I.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(R){this._cache.delete(R)}}class _e{static supportsResolving(R){return typeof R.prepareRename=="function"}constructor(R,W,K){this._documents=R,this._provider=W,this._logService=K}async provideRenameEdits(R,W,K,G){const V=this._documents.getDocument(R),ee=I.Position.to(W);try{const ce=await this._provider.provideRenameEdits(V,ee,K,G);return ce?I.WorkspaceEdit.from(ce):void 0}catch(ce){const Me=_e._asMessage(ce);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(R,W,K){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const G=this._documents.getDocument(R),V=I.Position.to(W);try{const ee=await this._provider.prepareRename(G,V,K);let ce,Me;if(L.Range.isRange(ee)?(ce=ee,Me=G.getText(ee)):(0,D.isObject)(ee)&&(ce=ee.range,Me=ee.placeholder),!ce||!Me)return;if(ce.start.line>V.line||ce.end.line<V.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ce),text:Me}}catch(ee){const ce=_e._asMessage(ee);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(ee)}}static _asMessage(R){return typeof R=="string"?R:R instanceof Error&&typeof R.message=="string"?R.message:void 0}}class Ae{constructor(R,W){this.resultId=R,this.tokens=W}}class Y{constructor(R,W){this._documents=R,this._provider=W,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(R,W,K){const G=this._documents.getDocument(R),V=W!==0?this._previousResults.get(W):null;let ee=typeof V?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(G,V.resultId,K):await this._provider.provideDocumentSemanticTokens(G,K);return V&&this._previousResults.delete(W),ee?(ee=Y._fixProvidedSemanticTokens(ee),this._send(Y._convertToEdits(V,ee),ee)):null}async releaseDocumentSemanticColoring(R){this._previousResults.delete(R)}static _fixProvidedSemanticTokens(R){return Y._isSemanticTokens(R)?Y._isCorrectSemanticTokens(R)?R:new L.SemanticTokens(new Uint32Array(R.data),R.resultId):Y._isSemanticTokensEdits(R)?Y._isCorrectSemanticTokensEdits(R)?R:new L.SemanticTokensEdits(R.edits.map(W=>new L.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),R.resultId):R}static _isSemanticTokens(R){return R&&!!R.data}static _isCorrectSemanticTokens(R){return R.data instanceof Uint32Array}static _isSemanticTokensEdits(R){return R&&Array.isArray(R.edits)}static _isCorrectSemanticTokensEdits(R){for(const W of R.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(R,W){if(!Y._isSemanticTokens(W)||!R||!R.tokens)return W;const K=R.tokens,G=K.length,V=W.data,ee=V.length;let ce=0;const Me=Math.min(G,ee);for(;ce<Me&&K[ce]===V[ce];)ce++;if(ce===G&&ce===ee)return new L.SemanticTokensEdits([],W.resultId);let xe=0;const Ge=Me-ce;for(;xe<Ge&&K[G-xe-1]===V[ee-xe-1];)xe++;return new L.SemanticTokensEdits([{start:ce,deleteCount:G-ce-xe,data:V.subarray(ce,ee-xe)}],W.resultId)}_send(R,W){if(Y._isSemanticTokens(R)){const K=this._nextResultId++;return this._previousResults.set(K,new Ae(R.resultId,R.data)),(0,t.encodeSemanticTokensDto)({id:K,type:"full",data:R.data})}if(Y._isSemanticTokensEdits(R)){const K=this._nextResultId++;return Y._isSemanticTokens(W)?this._previousResults.set(K,new Ae(W.resultId,W.data)):this._previousResults.set(K,new Ae(R.resultId)),(0,t.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(R.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class he{constructor(R,W){this._documents=R,this._provider=W}async provideDocumentRangeSemanticTokens(R,W,K){const G=this._documents.getDocument(R),V=await this._provider.provideDocumentRangeSemanticTokens(G,I.Range.to(W),K);return V?this._send(V):null}_send(R){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:R.data})}}class ke{static supportsResolving(R){return typeof R.resolveCompletionItem=="function"}constructor(R,W,K,G,V){this._documents=R,this._commands=W,this._provider=K,this._apiDeprecation=G,this._extension=V,this._cache=new c.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(R,W,K,G){const V=this._documents.getDocument(R),ee=I.Position.to(W),ce=V.getWordRangeAtPosition(ee)||new L.Range(ee,ee),Me=ce.with({end:ee}),xe=new f.StopWatch,Ge=await this._provider.provideCompletionItems(V,ee,G,I.CompletionContext.to(K));if(!Ge||G.isCancellationRequested)return;const je=Array.isArray(Ge)?new L.CompletionList(Ge):Ge,et=ke.supportsResolving(this._provider)?this._cache.add(je.items):this._cache.add([]),Ye=new d.DisposableStore;this._disposables.set(et,Ye);const Ze=[],it={x:et,b:Ze,a:{replace:I.Range.from(ce),insert:I.Range.from(Me)},c:je.isIncomplete||void 0,d:xe.elapsed()};for(let tt=0;tt<je.items.length;tt++){const Ue=je.items[tt],st=this._convertCompletionItem(Ue,[et,tt],Me,ce);Ze.push(st)}return it}async resolveCompletionItem(R,W){if(typeof this._provider.resolveCompletionItem!="function")return;const K=this._cache.get(...R);if(!K)return;const G=this._convertCompletionItem(K,R),V=await this._provider.resolveCompletionItem(K,W);if(!V)return;const ee=this._convertCompletionItem(V,R);return(G.h!==ee.h||G.i!==ee.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(G.n!==ee.n||G.o!==ee.o||!(0,A.equals)(G.p,ee.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...G,d:ee.d,c:ee.c,l:ee.l,h:ee.h,i:ee.i,n:ee.n,o:ee.o,p:ee.p}}releaseCompletionItems(R){this._disposables.get(R)?.dispose(),this._disposables.delete(R),this._cache.delete(R)}_convertCompletionItem(R,W,K,G){const V=this._disposables.get(W[0]);if(!V)throw Error("DisposableStore is missing...");const ee=this._commands.toInternal(R.command,V),ce={x:W,a:R.label,b:R.kind!==void 0?I.CompletionItemKind.from(R.kind):void 0,m:R.tags&&R.tags.map(I.CompletionItemTag.from),c:R.detail,d:typeof R.documentation>"u"?void 0:I.MarkdownString.fromStrict(R.documentation),e:R.sortText!==R.label?R.sortText:void 0,f:R.filterText!==R.label?R.filterText:void 0,g:R.preselect||void 0,i:R.keepWhitespace?1:0,k:R.commitCharacters?.join(""),l:R.additionalTextEdits&&R.additionalTextEdits.map(I.TextEdit.from),n:ee?.$ident,o:ee?.id,p:ee?.$ident?void 0:ee?.arguments};R.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=R.textEdit.newText):typeof R.insertText=="string"?ce.h=R.insertText:R.insertText instanceof L.SnippetString&&(ce.h=R.insertText.value,ce.i|=4);let Me;return R.textEdit?Me=R.textEdit.range:R.range&&(Me=R.range),L.Range.isRange(Me)?ce.j=I.Range.from(Me):Me&&(!K?.isEqual(Me.inserting)||!G?.isEqual(Me.replacing))&&(ce.j={insert:I.Range.from(Me.inserting),replace:I.Range.from(Me.replacing)}),ce}}class ae{async provideInlineCompletions(R,W,K,G){}disposeCompletions(R){}handleDidShowCompletionItem(R,W,K){}handlePartialAccept(R,W,K){}}class J extends ae{constructor(R,W,K,G){super(),this._extension=R,this._documents=W,this._provider=K,this._commands=G,this._references=new le,this._isAdditionsProposedApiEnabled=(0,n.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[T.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[T.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(R,W,K,G){const V=this._documents.getDocument(R),ee=I.Position.to(W),ce=await this._provider.provideInlineCompletionItems(V,ee,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:I.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[K.triggerKind]},G);if(!ce||G.isCancellationRequested)return;const Me=Array.isArray(ce)?ce:ce.items,xe=this._isAdditionsProposedApiEnabled?Array.isArray(ce)?[]:ce.commands||[]:[],Ge=this._isAdditionsProposedApiEnabled&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let je;return{pid:this._references.createReferenceId({dispose(){je?.dispose()},items:Me}),items:Me.map((Ye,Ze)=>{let it;Ye.command&&(je||(je=new d.DisposableStore),it=this._commands.toInternal(Ye.command,je));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?I.Range.from(Ye.range):void 0,command:it,idx:Ze,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:xe.map(Ye=>(je||(je=new d.DisposableStore),this._commands.toInternal(Ye,je))),suppressSuggestions:!1,enableForwardStability:Ge}}disposeCompletions(R){this._references.disposeReferenceId(R)?.dispose()}handleDidShowCompletionItem(R,W,K){const G=this._references.get(R)?.items[W];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G,K)}handlePartialAccept(R,W,K){const G=this._references.get(R)?.items[W];G&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(G,K)}}class le{constructor(){this._references=new Map,this._idPool=1}createReferenceId(R){const W=this._idPool++;return this._references.set(W,R),W}disposeReferenceId(R){const W=this._references.get(R);return this._references.delete(R),W}get(R){return this._references.get(R)}}class N{constructor(R,W){this._documents=R,this._provider=W,this._cache=new c.Cache("SignatureHelp")}async provideSignatureHelp(R,W,K,G){const V=this._documents.getDocument(R),ee=I.Position.to(W),ce=this.reviveContext(K),Me=await this._provider.provideSignatureHelp(V,ee,G,ce);if(Me){const xe=this._cache.add([Me]);return{...I.SignatureHelp.from(Me),id:xe}}}reviveContext(R){let W;if(R.activeSignatureHelp){const K=I.SignatureHelp.to(R.activeSignatureHelp),G=this._cache.get(R.activeSignatureHelp.id,0);G?(W=G,W.activeSignature=K.activeSignature,W.activeParameter=K.activeParameter):W=K}return{...R,activeSignatureHelp:W}}releaseSignatureHelp(R){this._cache.delete(R)}}class q{constructor(R,W,K,G,V){this._documents=R,this._commands=W,this._provider=K,this._logService=G,this._extension=V,this._cache=new c.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(R,W,K){const G=this._documents.getDocument(R),V=I.Range.to(W),ee=await this._provider.provideInlayHints(G,V,K);if(!Array.isArray(ee)||ee.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${W}`);return}if(K.isCancellationRequested)return;const ce=this._cache.add(ee);this._disposables.set(ce,new d.DisposableStore);const Me={hints:[],cacheId:ce};for(let xe=0;xe<ee.length;xe++)this._isValidInlayHint(ee[xe],V)&&Me.hints.push(this._convertInlayHint(ee[xe],[ce,xe]));return this._logService.trace(`[InlayHints] ${Me.hints.length} inlay hints from '${this._extension.identifier.value}' for ${W}`),Me}async resolveInlayHint(R,W){if(typeof this._provider.resolveInlayHint!="function")return;const K=this._cache.get(...R);if(!K)return;const G=await this._provider.resolveInlayHint(K,W);if(G&&this._isValidInlayHint(G))return this._convertInlayHint(G,R)}releaseHints(R){this._disposables.get(R)?.dispose(),this._disposables.delete(R),this._cache.delete(R)}_isValidInlayHint(R,W){return R.label.length===0||Array.isArray(R.label)&&R.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",R),!1):!(W&&!W.contains(R.position))}_convertInlayHint(R,W){const K=this._disposables.get(W[0]);if(!K)throw Error("DisposableStore is missing...");const G={label:"",cacheId:W,tooltip:I.MarkdownString.fromStrict(R.tooltip),position:I.Position.from(R.position),textEdits:R.textEdits&&R.textEdits.map(I.TextEdit.from),kind:R.kind&&I.InlayHintKind.from(R.kind),paddingLeft:R.paddingLeft,paddingRight:R.paddingRight};return typeof R.label=="string"?G.label=R.label:G.label=R.label.map(V=>{const ee={label:V.value};return ee.tooltip=I.MarkdownString.fromStrict(V.tooltip),L.Location.isLocation(V.location)&&(ee.location=I.location.from(V.location)),V.command&&(ee.command=this._commands.toInternal(V.command,K)),ee}),G}}class ue{constructor(R,W){this._documents=R,this._provider=W,this._cache=new c.Cache("DocumentLink")}async provideLinks(R,W){const K=this._documents.getDocument(R),G=await this._provider.provideDocumentLinks(K,W);if(!(!Array.isArray(G)||G.length===0)&&!W.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:G.filter(ue._validateLink).map(I.DocumentLink.from)};{const V=this._cache.add(G),ee={links:[],cacheId:V};for(let ce=0;ce<G.length;ce++){if(!ue._validateLink(G[ce]))continue;const Me=I.DocumentLink.from(G[ce]);Me.cacheId=[V,ce],ee.links.push(Me)}return ee}}}static _validateLink(R){return R.target&&R.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(R,W){if(typeof this._provider.resolveDocumentLink!="function")return;const K=this._cache.get(...R);if(!K)return;const G=await this._provider.resolveDocumentLink(K,W);if(!(!G||!ue._validateLink(G)))return I.DocumentLink.from(G)}releaseLinks(R){this._cache.delete(R)}}class Se{constructor(R,W){this._documents=R,this._provider=W}async provideColors(R,W){const K=this._documents.getDocument(R),G=await this._provider.provideDocumentColors(K,W);return Array.isArray(G)?G.map(ee=>({color:I.Color.from(ee.color),range:I.Range.from(ee.range)})):[]}async provideColorPresentations(R,W,K){const G=this._documents.getDocument(R),V=I.Range.to(W.range),ee=I.Color.to(W.color),ce=await this._provider.provideColorPresentations(ee,{document:G,range:V},K);if(Array.isArray(ce))return ce.map(I.ColorPresentation.from)}}class be{constructor(R,W){this._documents=R,this._provider=W}async provideFoldingRanges(R,W,K){const G=this._documents.getDocument(R),V=await this._provider.provideFoldingRanges(G,W,K);if(Array.isArray(V))return V.map(I.FoldingRange.from)}}class Ee{constructor(R,W,K){this._documents=R,this._provider=W,this._logService=K}async provideSelectionRanges(R,W,K){const G=this._documents.getDocument(R),V=W.map(I.Position.to),ee=await this._provider.provideSelectionRanges(G,V,K);if(!(0,P.isNonEmptyArray)(ee))return[];if(ee.length!==V.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Me=0;Me<V.length;Me++){const xe=[];ce.push(xe);let Ge=V[Me],je=ee[Me];for(;;){if(!je.range.contains(Ge))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(I.SelectionRange.from(je)),!je.parent)break;Ge=je.range,je=je.parent}}return ce}}class ye{constructor(R,W){this._documents=R,this._provider=W,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(R,W,K){const G=this._documents.getDocument(R),V=I.Position.to(W),ee=await this._provider.prepareCallHierarchy(G,V,K);if(!ee)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(ee)?ee.map(Me=>this._cacheAndConvertItem(ce,Me)):[this._cacheAndConvertItem(ce,ee)]}async provideCallsTo(R,W,K){const G=this._itemFromCache(R,W);if(!G)throw new Error("missing call hierarchy item");const V=await this._provider.provideCallHierarchyIncomingCalls(G,K);if(V)return V.map(ee=>({from:this._cacheAndConvertItem(R,ee.from),fromRanges:ee.fromRanges.map(ce=>I.Range.from(ce))}))}async provideCallsFrom(R,W,K){const G=this._itemFromCache(R,W);if(!G)throw new Error("missing call hierarchy item");const V=await this._provider.provideCallHierarchyOutgoingCalls(G,K);if(V)return V.map(ee=>({to:this._cacheAndConvertItem(R,ee.to),fromRanges:ee.fromRanges.map(ce=>I.Range.from(ce))}))}releaseSession(R){this._cache.delete(R)}_cacheAndConvertItem(R,W){const K=this._cache.get(R),G=I.CallHierarchyItem.from(W,R,K.size.toString(36));return K.set(G._itemId,W),G}_itemFromCache(R,W){return this._cache.get(R)?.get(W)}}class oe{constructor(R,W){this._documents=R,this._provider=W,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(R,W,K){const G=this._documents.getDocument(R),V=I.Position.to(W),ee=await this._provider.prepareTypeHierarchy(G,V,K);if(!ee)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(ee)?ee.map(Me=>this._cacheAndConvertItem(ce,Me)):[this._cacheAndConvertItem(ce,ee)]}async provideSupertypes(R,W,K){const G=this._itemFromCache(R,W);if(!G)throw new Error("missing type hierarchy item");const V=await this._provider.provideTypeHierarchySupertypes(G,K);if(V)return V.map(ee=>this._cacheAndConvertItem(R,ee))}async provideSubtypes(R,W,K){const G=this._itemFromCache(R,W);if(!G)throw new Error("missing type hierarchy item");const V=await this._provider.provideTypeHierarchySubtypes(G,K);if(V)return V.map(ee=>this._cacheAndConvertItem(R,ee))}releaseSession(R){this._cache.delete(R)}_cacheAndConvertItem(R,W){const K=this._cache.get(R),G=I.TypeHierarchyItem.from(W,R,K.size.toString(36));return K.set(G._itemId,W),G}_itemFromCache(R,W){return this._cache.get(R)?.get(W)}}class de{static toInternalProviderId(R,W){return R+"."+W}constructor(R,W,K,G,V){this._proxy=R,this._documents=W,this._provider=K,this._handle=G,this._extension=V}async provideDocumentOnDropEdits(R,W,K,G,V){const ee=this._documents.getDocument(W),ce=I.Position.to(K),Me=I.DataTransfer.toDataTransfer(G,async Ge=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,R,Ge)).buffer),xe=await this._provider.provideDocumentDropEdits(ee,ce,Me,V);if(xe)return{label:xe.label??(0,a.localize)(1,null,this._extension.displayName||this._extension.name),yieldTo:xe.yieldTo?.map(Ge=>"mimeType"in Ge?Ge:{providerId:de.toInternalProviderId(Ge.extensionId,Ge.providerId)}),insertText:typeof xe.insertText=="string"?xe.insertText:{snippet:xe.insertText.value},additionalEdit:xe.additionalEdit?I.WorkspaceEdit.from(xe.additionalEdit,void 0):void 0}}}class re{constructor(R,W){this._documents=R,this._provider=W}async provideMappedEdits(R,W,K,G){const V=S.URI.revive(R),ee=this._documents.getDocument(V),ce={selections:K.selections.map(xe=>I.Selection.to(xe)),related:K.related.map(xe=>({uri:S.URI.revive(xe.uri),range:I.Range.to(xe.range)}))},Me=await this._provider.provideMappedEdits(ee,W,ce,G);return Me?I.WorkspaceEdit.from(Me):null}}class ie{constructor(R,W){this.adapter=R,this.extension=W}}class me{static{this._handlePool=0}constructor(R,W,K,G,V,ee,ce,Me){this._uriTransformer=W,this._documents=K,this._commands=G,this._diagnostics=V,this._logService=ee,this._apiDeprecation=ce,this._extensionTelemetry=Me,this._adapter=new Map,this._proxy=R.getProxy(h.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(R,W){return I.DocumentSelector.from(R,this._uriTransformer,W)}_createDisposable(R){return new L.Disposable(()=>{this._adapter.delete(R),this._proxy.$unregister(R)})}_nextHandle(){return me._handlePool++}async _withAdapter(R,W,K,G,V,ee=!1){const ce=this._adapter.get(R);if(!ce||!(ce.adapter instanceof W))return G;const Me=Date.now();ee||this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const xe=K(ce.adapter,ce.extension);return Promise.resolve(xe).catch(Ge=>{(0,C.isCancellationError)(Ge)||(this._logService.error(`[${ce.extension.identifier.value}] provider FAILED`),this._logService.error(Ge),this._extensionTelemetry.onExtensionError(ce.extension.identifier,Ge))}).finally(()=>{ee||this._logService.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Me}ms`)}),E.CancellationToken.isCancellationToken(V)?(0,k.raceCancellationError)(xe,V):xe}_addNewAdapter(R,W){const K=this._nextHandle();return this._adapter.set(K,new ie(R,W)),K}static _extLabel(R){return R.displayName||R.name}registerDocumentSymbolProvider(R,W,K,G){const V=this._addNewAdapter(new r(this._documents,K),R),ee=G&&G.label||me._extLabel(R);return this._proxy.$registerDocumentSymbolProvider(V,this._transformDocumentSelector(W,R),ee),this._createDisposable(V)}$provideDocumentSymbols(R,W,K){return this._withAdapter(R,r,G=>G.provideDocumentSymbols(S.URI.revive(W),K),void 0,K)}registerCodeLensProvider(R,W,K){const G=this._nextHandle(),V=typeof K.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(G,new ie(new s(this._documents,this._commands.converter,K),R)),this._proxy.$registerCodeLensSupport(G,this._transformDocumentSelector(W,R),V);let ee=this._createDisposable(G);if(V!==void 0){const ce=K.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(V));ee=L.Disposable.from(ee,ce)}return ee}$provideCodeLenses(R,W,K){return this._withAdapter(R,s,G=>G.provideCodeLenses(S.URI.revive(W),K),void 0,K)}$resolveCodeLens(R,W,K){return this._withAdapter(R,s,G=>G.resolveCodeLens(W,K),void 0,void 0)}$releaseCodeLenses(R,W){this._withAdapter(R,s,K=>Promise.resolve(K.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(R,W,K){const G=this._addNewAdapter(new p(this._documents,K),R);return this._proxy.$registerDefinitionSupport(G,this._transformDocumentSelector(W,R)),this._createDisposable(G)}$provideDefinition(R,W,K,G){return this._withAdapter(R,p,V=>V.provideDefinition(S.URI.revive(W),K,G),[],G)}registerDeclarationProvider(R,W,K){const G=this._addNewAdapter(new w(this._documents,K),R);return this._proxy.$registerDeclarationSupport(G,this._transformDocumentSelector(W,R)),this._createDisposable(G)}$provideDeclaration(R,W,K,G){return this._withAdapter(R,w,V=>V.provideDeclaration(S.URI.revive(W),K,G),[],G)}registerImplementationProvider(R,W,K){const G=this._addNewAdapter(new _(this._documents,K),R);return this._proxy.$registerImplementationSupport(G,this._transformDocumentSelector(W,R)),this._createDisposable(G)}$provideImplementation(R,W,K,G){return this._withAdapter(R,_,V=>V.provideImplementation(S.URI.revive(W),K,G),[],G)}registerTypeDefinitionProvider(R,W,K){const G=this._addNewAdapter(new o(this._documents,K),R);return this._proxy.$registerTypeDefinitionSupport(G,this._transformDocumentSelector(W,R)),this._createDisposable(G)}$provideTypeDefinition(R,W,K,G){return this._withAdapter(R,o,V=>V.provideTypeDefinition(S.URI.revive(W),K,G),[],G)}registerHoverProvider(R,W,K,G){const V=this._addNewAdapter(new u(this._documents,K),R);return this._proxy.$registerHoverProvider(V,this._transformDocumentSelector(W,R)),this._createDisposable(V)}$provideHover(R,W,K,G){return this._withAdapter(R,u,V=>V.provideHover(S.URI.revive(W),K,G),void 0,G)}registerEvaluatableExpressionProvider(R,W,K,G){const V=this._addNewAdapter(new g(this._documents,K),R);return this._proxy.$registerEvaluatableExpressionProvider(V,this._transformDocumentSelector(W,R)),this._createDisposable(V)}$provideEvaluatableExpression(R,W,K,G){return this._withAdapter(R,g,V=>V.provideEvaluatableExpression(S.URI.revive(W),K,G),void 0,G)}registerInlineValuesProvider(R,W,K,G){const V=typeof K.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ee=this._addNewAdapter(new O(this._documents,K),R);this._proxy.$registerInlineValuesProvider(ee,this._transformDocumentSelector(W,R),V);let ce=this._createDisposable(ee);if(V!==void 0){const Me=K.onDidChangeInlineValues(xe=>this._proxy.$emitInlineValuesEvent(V));ce=L.Disposable.from(ce,Me)}return ce}$provideInlineValues(R,W,K,G,V){return this._withAdapter(R,O,ee=>ee.provideInlineValues(S.URI.revive(W),K,G,V),void 0,V)}registerDocumentHighlightProvider(R,W,K){const G=this._addNewAdapter(new z(this._documents,K),R);return this._proxy.$registerDocumentHighlightProvider(G,this._transformDocumentSelector(W,R)),this._createDisposable(G)}$provideDocumentHighlights(R,W,K,G){return this._withAdapter(R,z,V=>V.provideDocumentHighlights(S.URI.revive(W),K,G),void 0,G)}registerLinkedEditingRangeProvider(R,W,K){const G=this._addNewAdapter(new H(this._documents,K),R);return this._proxy.$registerLinkedEditingRangeProvider(G,this._transformDocumentSelector(W,R)),this._createDisposable(G)}$provideLinkedEditingRanges(R,W,K,G){return this._withAdapter(R,H,async V=>{const ee=await V.provideLinkedEditingRanges(S.URI.revive(W),K,G);if(ee)return{ranges:ee.ranges,wordPattern:ee.wordPattern?me._serializeRegExp(ee.wordPattern):void 0}},void 0,G)}registerReferenceProvider(R,W,K){const G=this._addNewAdapter(new B(this._documents,K),R);return this._proxy.$registerReferenceSupport(G,this._transformDocumentSelector(W,R)),this._createDisposable(G)}$provideReferences(R,W,K,G,V){return this._withAdapter(R,B,ee=>ee.provideReferences(S.URI.revive(W),K,G,V),void 0,V)}registerCodeActionProvider(R,W,K,G){const V=new d.DisposableStore,ee=this._addNewAdapter(new $(this._documents,this._commands.converter,this._diagnostics,K,this._logService,R,this._apiDeprecation),R);return this._proxy.$registerQuickFixSupport(ee,this._transformDocumentSelector(W,R),{providedKinds:G?.providedCodeActionKinds?.map(ce=>ce.value),documentation:G?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,V)}))},me._extLabel(R),!!K.resolveCodeAction),V.add(this._createDisposable(ee)),V}$provideCodeActions(R,W,K,G,V){return this._withAdapter(R,$,ee=>ee.provideCodeActions(S.URI.revive(W),K,G,V),void 0,V)}$resolveCodeAction(R,W,K){return this._withAdapter(R,$,G=>G.resolveCodeAction(W,K),{},void 0)}$releaseCodeActions(R,W){this._withAdapter(R,$,K=>Promise.resolve(K.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(R,W,K){const G=this._addNewAdapter(new M(this._documents,K),R);return this._proxy.$registerDocumentFormattingSupport(G,this._transformDocumentSelector(W,R),R.identifier,R.displayName||R.name),this._createDisposable(G)}$provideDocumentFormattingEdits(R,W,K,G){return this._withAdapter(R,M,V=>V.provideDocumentFormattingEdits(S.URI.revive(W),K,G),void 0,G)}registerDocumentRangeFormattingEditProvider(R,W,K){const G=typeof K.provideDocumentRangesFormattingEdits=="function",V=this._addNewAdapter(new ne(this._documents,K),R);return this._proxy.$registerRangeFormattingSupport(V,this._transformDocumentSelector(W,R),R.identifier,R.displayName||R.name,G),this._createDisposable(V)}$provideDocumentRangeFormattingEdits(R,W,K,G,V){return this._withAdapter(R,ne,ee=>ee.provideDocumentRangeFormattingEdits(S.URI.revive(W),K,G,V),void 0,V)}$provideDocumentRangesFormattingEdits(R,W,K,G,V){return this._withAdapter(R,ne,ee=>ee.provideDocumentRangesFormattingEdits(S.URI.revive(W),K,G,V),void 0,V)}registerOnTypeFormattingEditProvider(R,W,K,G){const V=this._addNewAdapter(new Q(this._documents,K),R);return this._proxy.$registerOnTypeFormattingSupport(V,this._transformDocumentSelector(W,R),G,R.identifier),this._createDisposable(V)}$provideOnTypeFormattingEdits(R,W,K,G,V,ee){return this._withAdapter(R,Q,ce=>ce.provideOnTypeFormattingEdits(S.URI.revive(W),K,G,V,ee),void 0,ee)}registerWorkspaceSymbolProvider(R,W){const K=this._addNewAdapter(new we(W,this._logService),R);return this._proxy.$registerNavigateTypeSupport(K,typeof W.resolveWorkspaceSymbol=="function"),this._createDisposable(K)}$provideWorkspaceSymbols(R,W,K){return this._withAdapter(R,we,G=>G.provideWorkspaceSymbols(W,K),{symbols:[]},K)}$resolveWorkspaceSymbol(R,W,K){return this._withAdapter(R,we,G=>G.resolveWorkspaceSymbol(W,K),void 0,void 0)}$releaseWorkspaceSymbols(R,W){this._withAdapter(R,we,K=>K.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(R,W,K){const G=this._addNewAdapter(new _e(this._documents,K,this._logService),R);return this._proxy.$registerRenameSupport(G,this._transformDocumentSelector(W,R),_e.supportsResolving(K)),this._createDisposable(G)}$provideRenameEdits(R,W,K,G,V){return this._withAdapter(R,_e,ee=>ee.provideRenameEdits(S.URI.revive(W),K,G,V),void 0,V)}$resolveRenameLocation(R,W,K,G){return this._withAdapter(R,_e,V=>V.resolveRenameLocation(S.URI.revive(W),K,G),void 0,G)}registerDocumentSemanticTokensProvider(R,W,K,G){const V=this._addNewAdapter(new Y(this._documents,K),R),ee=typeof K.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(V,this._transformDocumentSelector(W,R),G,ee);let ce=this._createDisposable(V);if(ee){const Me=K.onDidChangeSemanticTokens(xe=>this._proxy.$emitDocumentSemanticTokensEvent(ee));ce=L.Disposable.from(ce,Me)}return ce}$provideDocumentSemanticTokens(R,W,K,G){return this._withAdapter(R,Y,V=>V.provideDocumentSemanticTokens(S.URI.revive(W),K,G),null,G)}$releaseDocumentSemanticTokens(R,W){this._withAdapter(R,Y,K=>K.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(R,W,K,G){const V=this._addNewAdapter(new he(this._documents,K),R);return this._proxy.$registerDocumentRangeSemanticTokensProvider(V,this._transformDocumentSelector(W,R),G),this._createDisposable(V)}$provideDocumentRangeSemanticTokens(R,W,K,G){return this._withAdapter(R,he,V=>V.provideDocumentRangeSemanticTokens(S.URI.revive(W),K,G),null,G)}registerCompletionItemProvider(R,W,K,G){const V=this._addNewAdapter(new ke(this._documents,this._commands.converter,K,this._apiDeprecation,R),R);return this._proxy.$registerCompletionsProvider(V,this._transformDocumentSelector(W,R),G,ke.supportsResolving(K),R.identifier),this._createDisposable(V)}$provideCompletionItems(R,W,K,G,V){return this._withAdapter(R,ke,ee=>ee.provideCompletionItems(S.URI.revive(W),K,G,V),void 0,V)}$resolveCompletionItem(R,W,K){return this._withAdapter(R,ke,G=>G.resolveCompletionItem(W,K),void 0,K)}$releaseCompletionItems(R,W){this._withAdapter(R,ke,K=>K.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(R,W,K,G){const V=new J(R,this._documents,K,this._commands.converter),ee=this._addNewAdapter(V,R);return this._proxy.$registerInlineCompletionsSupport(ee,this._transformDocumentSelector(W,R),V.supportsHandleEvents,v.ExtensionIdentifier.toKey(R.identifier.value),G?.yieldTo?.map(ce=>v.ExtensionIdentifier.toKey(ce))||[]),this._createDisposable(ee)}$provideInlineCompletions(R,W,K,G,V){return this._withAdapter(R,ae,ee=>ee.provideInlineCompletions(S.URI.revive(W),K,G,V),void 0,V)}$handleInlineCompletionDidShow(R,W,K,G){this._withAdapter(R,ae,async V=>{V.handleDidShowCompletionItem(W,K,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(R,W,K,G){this._withAdapter(R,ae,async V=>{V.handlePartialAccept(W,K,G)},void 0,void 0)}$freeInlineCompletionsList(R,W){this._withAdapter(R,ae,async K=>{K.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(R,W,K,G){const V=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,ee=this._addNewAdapter(new N(this._documents,K),R);return this._proxy.$registerSignatureHelpProvider(ee,this._transformDocumentSelector(W,R),V),this._createDisposable(ee)}$provideSignatureHelp(R,W,K,G,V){return this._withAdapter(R,N,ee=>ee.provideSignatureHelp(S.URI.revive(W),K,G,V),void 0,V)}$releaseSignatureHelp(R,W){this._withAdapter(R,N,K=>K.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(R,W,K){const G=typeof K.onDidChangeInlayHints=="function"?this._nextHandle():void 0,V=this._addNewAdapter(new q(this._documents,this._commands.converter,K,this._logService,R),R);this._proxy.$registerInlayHintsProvider(V,this._transformDocumentSelector(W,R),typeof K.resolveInlayHint=="function",G,me._extLabel(R));let ee=this._createDisposable(V);if(G!==void 0){const ce=K.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(G));ee=L.Disposable.from(ee,ce)}return ee}$provideInlayHints(R,W,K,G){return this._withAdapter(R,q,V=>V.provideInlayHints(S.URI.revive(W),K,G),void 0,G)}$resolveInlayHint(R,W,K){return this._withAdapter(R,q,G=>G.resolveInlayHint(W,K),void 0,K)}$releaseInlayHints(R,W){this._withAdapter(R,q,K=>K.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(R,W,K){const G=this._addNewAdapter(new ue(this._documents,K),R);return this._proxy.$registerDocumentLinkProvider(G,this._transformDocumentSelector(W,R),typeof K.resolveDocumentLink=="function"),this._createDisposable(G)}$provideDocumentLinks(R,W,K){return this._withAdapter(R,ue,G=>G.provideLinks(S.URI.revive(W),K),void 0,K,W.scheme==="output")}$resolveDocumentLink(R,W,K){return this._withAdapter(R,ue,G=>G.resolveLink(W,K),void 0,void 0,!0)}$releaseDocumentLinks(R,W){this._withAdapter(R,ue,K=>K.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(R,W,K){const G=this._addNewAdapter(new Se(this._documents,K),R);return this._proxy.$registerDocumentColorProvider(G,this._transformDocumentSelector(W,R)),this._createDisposable(G)}$provideDocumentColors(R,W,K){return this._withAdapter(R,Se,G=>G.provideColors(S.URI.revive(W),K),[],K)}$provideColorPresentations(R,W,K,G){return this._withAdapter(R,Se,V=>V.provideColorPresentations(S.URI.revive(W),K,G),void 0,G)}registerFoldingRangeProvider(R,W,K){const G=this._nextHandle(),V=typeof K.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(G,new ie(new be(this._documents,K),R)),this._proxy.$registerFoldingRangeProvider(G,this._transformDocumentSelector(W,R),R.identifier,V);let ee=this._createDisposable(G);if(V!==void 0){const ce=K.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(V));ee=L.Disposable.from(ee,ce)}return ee}$provideFoldingRanges(R,W,K,G){return this._withAdapter(R,be,V=>V.provideFoldingRanges(S.URI.revive(W),K,G),void 0,G)}registerSelectionRangeProvider(R,W,K){const G=this._addNewAdapter(new Ee(this._documents,K,this._logService),R);return this._proxy.$registerSelectionRangeProvider(G,this._transformDocumentSelector(W,R)),this._createDisposable(G)}$provideSelectionRanges(R,W,K,G){return this._withAdapter(R,Ee,V=>V.provideSelectionRanges(S.URI.revive(W),K,G),[],G)}registerCallHierarchyProvider(R,W,K){const G=this._addNewAdapter(new ye(this._documents,K),R);return this._proxy.$registerCallHierarchyProvider(G,this._transformDocumentSelector(W,R)),this._createDisposable(G)}$prepareCallHierarchy(R,W,K,G){return this._withAdapter(R,ye,V=>Promise.resolve(V.prepareSession(S.URI.revive(W),K,G)),void 0,G)}$provideCallHierarchyIncomingCalls(R,W,K,G){return this._withAdapter(R,ye,V=>V.provideCallsTo(W,K,G),void 0,G)}$provideCallHierarchyOutgoingCalls(R,W,K,G){return this._withAdapter(R,ye,V=>V.provideCallsFrom(W,K,G),void 0,G)}$releaseCallHierarchy(R,W){this._withAdapter(R,ye,K=>Promise.resolve(K.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(R,W,K){const G=this._addNewAdapter(new oe(this._documents,K),R);return this._proxy.$registerTypeHierarchyProvider(G,this._transformDocumentSelector(W,R)),this._createDisposable(G)}$prepareTypeHierarchy(R,W,K,G){return this._withAdapter(R,oe,V=>Promise.resolve(V.prepareSession(S.URI.revive(W),K,G)),void 0,G)}$provideTypeHierarchySupertypes(R,W,K,G){return this._withAdapter(R,oe,V=>V.provideSupertypes(W,K,G),void 0,G)}$provideTypeHierarchySubtypes(R,W,K,G){return this._withAdapter(R,oe,V=>V.provideSubtypes(W,K,G),void 0,G)}$releaseTypeHierarchy(R,W){this._withAdapter(R,oe,K=>Promise.resolve(K.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(R,W,K,G){const V=this._nextHandle();this._adapter.set(V,new ie(new de(this._proxy,this._documents,K,V,R),R));const ee=(0,n.isProposedApiEnabled)(R,"dropMetadata")&&G?de.toInternalProviderId(R.identifier.value,G.id):void 0;return this._proxy.$registerDocumentOnDropEditProvider(V,this._transformDocumentSelector(W,R),ee,(0,n.isProposedApiEnabled)(R,"dropMetadata")?G:void 0),this._createDisposable(V)}$provideDocumentOnDropEdits(R,W,K,G,V,ee){return this._withAdapter(R,de,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(W,S.URI.revive(K),G,V,ee)),void 0,void 0)}registerMappedEditsProvider(R,W,K){const G=this._addNewAdapter(new re(this._documents,K),R);return this._proxy.$registerMappedEditsProvider(G,this._transformDocumentSelector(W,R)),this._createDisposable(G)}$provideMappedEdits(R,W,K,G,V){return this._withAdapter(R,re,ee=>Promise.resolve(ee.provideMappedEdits(W,K,G,V)),null,V)}registerDocumentPasteEditProvider(R,W,K,G){const V=this._nextHandle();this._adapter.set(V,new ie(new x(this._proxy,this._documents,K,V,R),R));const ee=x.toInternalProviderId(R.identifier.value,G.id);return this._proxy.$registerPasteEditProvider(V,this._transformDocumentSelector(W,R),ee,{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,copyMimeTypes:G.copyMimeTypes,pasteMimeTypes:G.pasteMimeTypes}),this._createDisposable(V)}$prepareDocumentPaste(R,W,K,G,V){return this._withAdapter(R,x,ee=>ee.prepareDocumentPaste(S.URI.revive(W),K,G,V),void 0,V)}$providePasteEdits(R,W,K,G,V,ee){return this._withAdapter(R,x,ce=>ce.providePasteEdits(W,S.URI.revive(K),G,V,ee),void 0,ee)}static _serializeRegExp(R){return{pattern:R.source,flags:R.flags}}static _serializeIndentationRule(R){return{decreaseIndentPattern:me._serializeRegExp(R.decreaseIndentPattern),increaseIndentPattern:me._serializeRegExp(R.increaseIndentPattern),indentNextLinePattern:R.indentNextLinePattern?me._serializeRegExp(R.indentNextLinePattern):void 0,unIndentedLinePattern:R.unIndentedLinePattern?me._serializeRegExp(R.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(R){return{beforeText:me._serializeRegExp(R.beforeText),afterText:R.afterText?me._serializeRegExp(R.afterText):void 0,previousLineText:R.previousLineText?me._serializeRegExp(R.previousLineText):void 0,action:R.action}}static _serializeOnEnterRules(R){return R.map(me._serializeOnEnterRule)}setLanguageConfiguration(R,W,K){const{wordPattern:G}=K;if(G&&(0,y.regExpLeadsToEndlessLoop)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this._documents.setWordDefinitionFor(W,G):this._documents.setWordDefinitionFor(W,void 0),K.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",R,"Do not use."),K.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",R,"Do not use."),K.autoClosingPairs&&(0,n.checkProposedApiEnabled)(R,"languageConfigurationAutoClosingPairs");const V=this._nextHandle(),ee={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?me._serializeRegExp(K.wordPattern):void 0,indentationRules:K.indentationRules?me._serializeIndentationRule(K.indentationRules):void 0,onEnterRules:K.onEnterRules?me._serializeOnEnterRules(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs};return this._proxy.$setLanguageConfiguration(V,W,ee),this._createDisposable(V)}$setWordDefinitions(R){for(const W of R)this._documents.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=me}),define(Pe[240],Te([1,0,3,8,7,29,13,6]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(P,D,l,E){this._documents=D,this._commands=l,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=P.getProxy(S.MainContext.MainThreadLanguages)}$acceptLanguageIds(P){this._languageIds=P}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(P,D){await this._proxy.$changeLanguage(P,D);const l=this._documents.getDocumentData(P);if(!l)throw new Error(`document '${P.toString()}' NOT found`);return l.document}async tokenAtPosition(P,D){const l=P.version,E=A.Position.from(D),v=await this._proxy.$tokensAtPosition(P.uri,E),d={type:I.StandardTokenType.Other,range:P.getWordRangeAtPosition(D)??new I.Range(D.line,D.character,D.line,D.character)};if(!v)return d;const t={range:A.Range.to(v.range),type:A.TokenType.to(v.type)};return!t.range.contains(D)||l!==P.version?d:t}createLanguageStatusItem(P,D,l){const E=this._handlePool++,v=this._proxy,d=this._ids,t=`${P.identifier.value}/${D}`;if(d.has(t))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);d.add(t);const i={selector:l,id:D,name:P.displayName??P.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const f=new h.DisposableStore,C=()=>{if(c?.dispose(),!d.has(t)){console.warn(`LanguageStatusItem (${D}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,T.disposableTimeout)(()=>{f.clear(),this._proxy.$setLanguageStatus(E,{id:t,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:A.DocumentSelector.from(i.selector,this._uriTransformer),label:i.text,detail:i.detail??"",severity:i.severity===I.LanguageStatusSeverity.Error?L.default.Error:i.severity===I.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this._commands.toInternal(i.command,f),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},k={dispose(){f.dispose(),c?.dispose(),v.$removeLanguageStatus(E),d.delete(t)},get id(){return i.id},get name(){return i.name},set name(n){i.name=n,C()},get selector(){return i.selector},set selector(n){i.selector=n,C()},get text(){return i.text},set text(n){i.text=n,C()},get detail(){return i.detail},set detail(n){i.detail=n,C()},get severity(){return i.severity},set severity(n){i.severity=n,C()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(n){i.accessibilityInformation=n,C()},get command(){return i.command},set command(n){i.command=n,C()},get busy(){return i.busy},set busy(n){i.busy=n,C()}};return C(),k}}e.ExtHostLanguages=y}),define(Pe[81],Te([1,0,22,15,2,4,14,3,27,17]),function(ve,e,S,A,I,L,T,h,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let P=class{constructor(l,E,v){this.logService=v,this.bundleCache=new Map,this._proxy=E.getProxy(h.MainContext.MainThreadLocalization),this.currentLanguage=l.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===S.LANGUAGE_DEFAULT}getMessage(l,E){const{message:v,args:d,comment:t}=E;if(this.isDefaultLanguage)return(0,A.format2)(v,d??{});let i=v;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.bundleCache.get(l)?.contents[i];return c||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,A.format2)(c??v,d??{})}getBundle(l){return this.bundleCache.get(l)?.contents}getBundleUri(l){return this.bundleCache.get(l)?.uri}async initializeLocalizedMessages(l){if(this.isDefaultLanguage||!l.l10n&&!l.isBuiltin||this.bundleCache.has(l.identifier.value))return;let E;const v=await this.getBundleLocation(l);if(!v){this.logService.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const d=await this._proxy.$fetchBundleContents(v),t=JSON.parse(d);E=l.isBuiltin?t.contents?.bundle:t}catch(d){this.logService.error(`Failed to load translations for ${l.identifier.value} from ${v}: ${d.message}`);return}E&&this.bundleCache.set(l.identifier.value,{contents:E,uri:v})}async getBundleLocation(l){if(l.isBuiltin){const E=await this._proxy.$fetchBuiltInBundleUri(l.identifier.value,this.currentLanguage);return I.URI.revive(E)}return l.l10n?I.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=P,e.ExtHostLocalizationService=P=Ve([ze(0,y.IExtHostInitDataService),ze(1,m.IExtHostRpcService),ze(2,T.ILogService)],P),e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(Pe[241],Te([1,0,14,3,27,17,2,69]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends S.AbstractLoggerService{constructor(D,l){super(l.logLevel,l.logsLocation,l.loggers.map(E=>(0,h.revive)(E))),this._proxy=D.getProxy(A.MainContext.MainThreadLogger)}$setLogLevel(D,l){l?this.setLogLevel(T.URI.revive(l),D):this.setLogLevel(D)}setVisibility(D,l){super.setVisibility(D,l),this._proxy.$setVisibility(D,l)}doCreateLogger(D,l,E){return new m(this._proxy,D,l,E)}};e.ExtHostLoggerService=y,e.ExtHostLoggerService=y=Ve([ze(0,L.IExtHostRpcService),ze(1,I.IExtHostInitDataService)],y);class m extends S.AbstractMessageLogger{constructor(D,l,E,v){super(v?.logLevel==="always"),this.proxy=D,this.file=l,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(E),this.proxy.$createLogger(l,v).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(D,l){const E=[[D,l]];this.isLoggerCreated?this.doLog(E):this.buffer.push(...E)}doLog(D){this.proxy.$log(this.file,D)}flush(){this.proxy.$flush(this.file)}}}),define(Pe[82],Te([1,0,3,4,6,17,25]),function(ve,e,S,A,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,A.createDecorator)("IExtHostManagedSockets");let h=class{constructor(D){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=D.getProxy(S.MainContext.MainThreadManagedSockets)}setFactory(D,l){for(const E of this._managedRemoteSockets.values())E.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new y(D,l),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(D){if(!this._factory||this._factory.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const l=++this._remoteSocketIdCounter,E=await this._factory.makeConnection(),v=new I.DisposableStore;return this._managedRemoteSockets.set(l,new m(l,E,v)),v.add((0,I.toDisposable)(()=>this._managedRemoteSockets.delete(l))),v.add(E.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(l),v.dispose()})),v.add(E.onDidClose(d=>{this._proxy.$onDidManagedSocketClose(l,d?.stack??d?.message),v.dispose()})),v.add(E.onDidReceiveMessage(d=>this._proxy.$onDidManagedSocketHaveData(l,T.VSBuffer.wrap(d)))),l}$remoteSocketWrite(D,l){this._managedRemoteSockets.get(D)?.actual.send(l.buffer)}$remoteSocketEnd(D){const l=this._managedRemoteSockets.get(D);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(D){await this._managedRemoteSockets.get(D)?.actual.drain?.()}};e.ExtHostManagedSockets=h,e.ExtHostManagedSockets=h=Ve([ze(0,L.IExtHostRpcService)],h);class y{constructor(D,l){this.socketFactoryId=D,this.makeConnection=l}}class m extends I.Disposable{constructor(D,l,E){super(),this.socketId=D,this.actual=l,this._register(E)}}}),define(Pe[242],Te([1,0,3,14,26]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(h){return h&&h.title}let T=class{constructor(y,m){this._logService=m,this._proxy=y.getProxy(S.MainContext.MainThreadMessageService)}showMessage(y,m,P,D,l){const E={source:{identifier:y.identifier,label:y.displayName||y.name}};let v;typeof D=="string"||L(D)?v=[D,...l]:(E.modal=D?.modal,E.useCustom=D?.useCustom,E.detail=D?.detail,v=l),E.useCustom&&(0,I.checkProposedApiEnabled)(y,"resolvers");const d=[];for(let t=0;t<v.length;t++){const i=v[t];if(typeof i=="string")d.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:c,isCloseAffordance:f}=i;d.push({title:c,isCloseAffordance:!!f,handle:t})}else this._logService.warn("Invalid message item:",i)}return this._proxy.$showMessage(m,P,E,d).then(t=>{if(typeof t=="number")return v[t]})}};e.ExtHostMessageService=T,e.ExtHostMessageService=T=Ve([ze(1,A.ILogService)],T)}),define(Pe[243],Te([1,0,152,25,5,6,28,15,16,2,38,55,3,31,8,7,46,205,104,9,24,12]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t,i,c,f,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class n{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(r=>r.apiEditor)}constructor(r,s,b,p,w){this._textDocumentsAndEditors=b,this._textDocuments=p,this._extHostFileSystem=w,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new I.Emitter({onListenerError:f.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter({onListenerError:f.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter({onListenerError:f.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter({onListenerError:f.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new D.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=r.getProxy(l.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=r.getProxy(l.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=r.getProxy(l.MainContext.MainThreadNotebookEditors),this._commandsConverter=s.converter,s.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===13){const o=_.notebookEditor?.notebookUri,u=_.cell.handle,O=this._documents.get(o)?.getCell(u);if(O)return O.apiCell}if(_&&_.$mid===14){const o=_.uri,u=this._documents.get(o);if(u)return u.apiNotebook}return _}}),n._registerApiCommands(s)}getEditorById(r){const s=this._editors.get(r);if(!s)throw new Error(`unknown text editor: ${r}. known editors: ${[...this._editors.keys()]} `);return s}getIdByEditor(r){for(const[s,b]of this._editors)if(b.apiEditor===r)return s}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(r,s){const b=this._documents.get(r);if(!b&&!s)throw new Error(`NO notebook document for '${r}'`);return b}static _convertNotebookRegistrationData(r,s){if(!s)return;const b=s.filenamePattern.map(p=>v.NotebookExclusiveDocumentPattern.from(p)).filter(p=>p!==void 0);if(s.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:r.identifier,providerDisplayName:r.displayName||r.name,displayName:s.displayName,filenamePattern:b,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(r,s,b){const p=n._notebookStatusBarItemProviderHandlePool++,w=typeof b.onDidChangeCellStatusBarItems=="function"?n._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(p,b),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(p,w,s);let _;return w!==void 0&&(_=b.onDidChangeCellStatusBarItems(o=>this._notebookProxy.$emitCellStatusBarEvent(w))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(p),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(p,w),_?.dispose()})}async createNotebookDocument(r){const s=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:r.viewType,content:r.content&&v.NotebookData.from(r.content)});return m.URI.revive(s)}async openNotebookDocument(r){const s=this._documents.get(r);if(s)return s.apiNotebook;const b=await this._notebookDocumentsProxy.$tryOpenNotebook(r),p=this._documents.get(m.URI.revive(b));return(0,y.assertIsDefined)(p?.apiNotebook)}async showNotebookDocument(r,s){m.URI.isUri(r)&&(r=await this.openNotebookDocument(r));let b;typeof s=="object"?b={position:v.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(v.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:b={preserveFocus:!1};const p=await this._notebookEditorsProxy.$tryShowNotebookDocument(r.uri,r.notebookType,b),w=p&&this._editors.get(p)?.apiEditor;if(w)return w;throw p?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(r,s,b,p){const w=this._notebookStatusBarItemProviders.get(r),_=m.URI.revive(s),o=this._documents.get(_);if(!o||!w)return;const u=o.getCellFromIndex(b);if(!u)return;const g=await w.provideCellStatusBarItems(u.apiCell,p);if(!g)return;const O=new L.DisposableStore,z=this._statusBarCache.add([O]),B=(Array.isArray(g)?g:[g]).map($=>v.NotebookStatusBarItem.from($,this._commandsConverter,O));return{cacheId:z,items:B}}$releaseNotebookCellStatusBarItems(r){this._statusBarCache.delete(r)}registerNotebookSerializer(r,s,b,p,w){if((0,h.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");const _=this._handlePool++;return this._notebookSerializer.set(_,{viewType:s,serializer:b,options:p}),this._notebookProxy.$registerNotebookSerializer(_,{id:r.identifier,location:r.extensionLocation},s,v.NotebookDocumentContentOptions.from(p),n._convertNotebookRegistrationData(r,w)),(0,L.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(_)})}async $dataToNotebook(r,s,b){const p=this._notebookSerializer.get(r);if(!p)throw new Error("NO serializer found");const w=await p.serializer.deserializeNotebook(s.buffer,b);return new t.SerializableObjectWithBuffers(v.NotebookData.from(w))}async $notebookToData(r,s,b){const p=this._notebookSerializer.get(r);if(!p)throw new Error("NO serializer found");const w=await p.serializer.serializeNotebook(v.NotebookData.to(s.value),b);return A.VSBuffer.wrap(w)}async $saveNotebook(r,s,b,p,w){const _=m.URI.revive(s),o=this._notebookSerializer.get(r);if(!o)throw new Error("NO serializer found");const u=this._documents.get(_);if(!u)throw new Error("Document NOT found");if(u.versionId!==b)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(_.scheme))throw new P.FileOperationError((0,S.localize)(0,null,this._resourceForError(_)),6);await this._validateWriteFile(_,p);const g={metadata:(0,C.filter)(u.apiNotebook.metadata,$=>!(o.options?.transientDocumentMetadata??{})[$]),cells:[]};for(const $ of u.apiNotebook.getCells()){const x=new d.NotebookCellData($.kind,$.document.getText(),$.document.languageId,$.mime,o.options?.transientOutputs?[]:[...$.outputs],$.metadata,$.executionSummary);x.metadata=(0,C.filter)($.metadata,M=>!(o.options?.transientCellMetadata??{})[M]),g.cells.push(x)}const O=await o.serializer.serializeNotebook(g,w);await this._extHostFileSystem.value.writeFile(_,O);const z=this._extHostFileSystem.getFileSystemProviderExtUri(_.scheme),H=await this._extHostFileSystem.value.stat(_);return{name:z.basename(_),isFile:(H.type&P.FileType.File)!==0,isDirectory:(H.type&P.FileType.Directory)!==0,isSymbolicLink:(H.type&P.FileType.SymbolicLink)!==0,mtime:H.mtime,ctime:H.ctime,size:H.size,readonly:!!((H.permissions??0)&P.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(_.scheme),locked:!!((H.permissions??0)&P.FilePermission.Locked),etag:P.etag({mtime:H.mtime,size:H.size}),children:void 0}}async _validateWriteFile(r,s){const b=await this._extHostFileSystem.value.stat(r);if(typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==P.ETAG_DISABLED&&typeof b.mtime=="number"&&typeof b.size=="number"&&s.mtime<b.mtime&&s.etag!==P.etag({mtime:s.mtime,size:b.size}))throw new P.FileOperationError((0,S.localize)(1,null),3,s)}_resourceForError(r){return r.scheme===k.Schemas.file?r.fsPath:r.toString()}_createExtHostEditor(r,s,b){if(this._editors.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const p=new c.ExtHostNotebookEditor(s,this._notebookEditorsProxy,r,b.visibleRanges.map(v.NotebookRange.to),b.selections.map(v.NotebookRange.to),typeof b.viewColumn=="number"?v.ViewColumn.to(b.viewColumn):void 0);this._editors.set(s,p)}$acceptDocumentAndEditorsDelta(r){if(r.value.removedDocuments)for(const b of r.value.removedDocuments){const p=m.URI.revive(b),w=this._documents.get(p);w&&(w.dispose(),this._documents.delete(p),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(_=>_.document.uri)}),this._onDidCloseNotebookDocument.fire(w.apiNotebook));for(const _ of this._editors.values())_.notebookData.uri.toString()===p.toString()&&this._editors.delete(_.id)}if(r.value.addedDocuments){const b=[];for(const p of r.value.addedDocuments){const w=m.URI.revive(p.uri);if(this._documents.has(w))throw new Error(`adding EXISTING notebook ${w} `);const _=new i.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,w,p);b.push(...p.cells.map(o=>i.ExtHostCell.asModelAddData(_.apiNotebook,o))),this._documents.get(w)?.dispose(),this._documents.set(w,_),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this._onDidOpenNotebookDocument.fire(_.apiNotebook)}}if(r.value.addedEditors)for(const b of r.value.addedEditors){if(this._editors.has(b.id))return;const p=m.URI.revive(b.documentUri),w=this._documents.get(p);w&&this._createExtHostEditor(w,b.id,b)}const s=[];if(r.value.removedEditors)for(const b of r.value.removedEditors){const p=this._editors.get(b);p&&(this._editors.delete(b),this._activeNotebookEditor?.id===p.id&&(this._activeNotebookEditor=void 0),s.push(p))}if(r.value.visibleEditors){this._visibleNotebookEditors=r.value.visibleEditors.map(p=>this._editors.get(p)).filter(p=>!!p);const b=new Set;this._visibleNotebookEditors.forEach(p=>b.add(p.id));for(const p of this._editors.values()){const w=b.has(p.id);p._acceptVisibility(w)}this._visibleNotebookEditors=[...this._editors.values()].map(p=>p).filter(p=>p.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}r.value.newActiveEditor===null?this._activeNotebookEditor=void 0:r.value.newActiveEditor&&(this._editors.get(r.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${r.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(r.value.newActiveEditor)),r.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(r){const s=E.ApiCommandArgument.String.with("notebookType","A notebook type"),b=new E.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[s,new E.ApiCommandArgument("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>A.VSBuffer.wrap(w))],new E.ApiCommandResult("Notebook Data",w=>v.NotebookData.to(w.value))),p=new E.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[s,new E.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new t.SerializableObjectWithBuffers(v.NotebookData.from(w)))],new E.ApiCommandResult("Bytes",w=>w.buffer));r.registerApiCommand(b),r.registerApiCommand(p)}}e.ExtHostNotebookController=n}),define(Pe[244],Te([1,0,18,13,21,5,6,28,2,20,14,55,3,31,8,7,77,198,26,46]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t,i,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let C=class{constructor(w,_,o,u,g){this._initData=_,this._extHostNotebook=o,this._commands=u,this._logService=g,this._activeExecutions=new h.ResourceMap,this._activeNotebookExecutions=new h.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new D.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=w.getProxy(l.MainContext.MainThreadNotebookKernels);const O=new E.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new E.ApiCommandArgument("options","Select kernel options",z=>!0,z=>{if(z&&"notebookEditor"in z&&"id"in z){const H=this._extHostNotebook.getIdByEditor(z.notebookEditor);return{id:z.id,extension:z.extension,notebookEditorId:H}}else if(z&&"notebookEditor"in z){const H=this._extHostNotebook.getIdByEditor(z.notebookEditor);if(H===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${z.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:H}}return z})],E.ApiCommandResult.Void);this._commands.registerApiCommand(O)}createNotebookController(w,_,o,u,g,O){for(const ae of this._kernelData.values())if(ae.controller.id===_&&m.ExtensionIdentifier.equals(w.identifier,ae.extensionId))throw new Error(`notebook controller with id '${_}' ALREADY exist`);const z=this._handlePool++,H=this;this._logService.trace(`NotebookController[${z}], CREATED by ${w.identifier.value}, ${_}`);const B=()=>console.warn(`NO execute handler from notebook controller '${Q.id}' of extension: '${w.identifier}'`);let $=!1;const x=new T.DisposableStore,M=new L.Emitter,ne=new L.Emitter,Q={id:b(w.identifier,_),notebookType:o,extensionId:w.identifier,extensionLocation:w.extensionLocation,label:u||w.identifier.value,preloads:O?O.map(v.NotebookRendererScript.from):[]};let we=g??B,_e;this._proxy.$addKernel(z,Q).catch(ae=>{console.log(ae),$=!0});let Ae=0;const Y=()=>{if($)return;const ae=++Ae;Promise.resolve().then(()=>{ae===Ae&&this._proxy.$updateKernel(z,Q)})},he=new h.ResourceMap,ke={get id(){return _},get notebookType(){return Q.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return Q.label},set label(ae){Q.label=ae??w.displayName??w.name,Y()},get detail(){return Q.detail??""},set detail(ae){Q.detail=ae,Y()},get description(){return Q.description??""},set description(ae){Q.description=ae,Y()},get supportedLanguages(){return Q.supportedLanguages},set supportedLanguages(ae){Q.supportedLanguages=ae,Y()},get supportsExecutionOrder(){return Q.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){Q.supportsExecutionOrder=ae,Y()},get rendererScripts(){return Q.preloads?Q.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return we},set executeHandler(ae){we=ae??B},get interruptHandler(){return _e},set interruptHandler(ae){_e=ae,Q.supportsInterrupt=!!ae,Y()},createNotebookCellExecution(ae){if($)throw new Error("notebook controller is DISPOSED");if(!he.has(ae.notebook.uri))throw H._logService.trace(`NotebookController[${z}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(he.keys()).map(J=>J.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return H._createNotebookCellExecution(ae,b(w.identifier,this.id))},createNotebookExecution(ae){if((0,c.checkProposedApiEnabled)(w,"notebookExecution"),$)throw new Error("notebook controller is DISPOSED");if(!he.has(ae.uri))throw H._logService.trace(`NotebookController[${z}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(he.keys()).map(J=>J.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return H._createNotebookExecution(ae,b(w.identifier,this.id))},dispose:()=>{$||(this._logService.trace(`NotebookController[${z}], DISPOSED`),$=!0,this._kernelData.delete(z),x.dispose(),M.dispose(),ne.dispose(),this._proxy.$removeKernel(z))},updateNotebookAffinity(ae,J){J===d.NotebookControllerAffinity2.Hidden&&(0,c.checkProposedApiEnabled)(w,"notebookControllerAffinityHidden"),H._proxy.$updateNotebookPriority(z,ae.uri,J)},onDidReceiveMessage:ne.event,postMessage(ae,J){return(0,c.checkProposedApiEnabled)(w,"notebookMessaging"),H._proxy.$postMessage(z,J&&H._extHostNotebook.getIdByEditor(J),ae)},asWebviewUri(ae){return(0,c.checkProposedApiEnabled)(w,"notebookMessaging"),(0,t.asWebviewUri)(ae,H._initData.remote)}};return this._kernelData.set(z,{extensionId:w.identifier,controller:ke,onDidReceiveMessage:ne,onDidChangeSelection:M,associatedNotebooks:he}),ke}getIdByController(w){for(const[_,o]of this._kernelData)if(o.controller===w)return b(o.extensionId,w.id);return null}createNotebookControllerDetectionTask(w,_){const o=this._kernelDetectionTaskHandlePool++,u=this;this._logService.trace(`NotebookControllerDetectionTask[${o}], CREATED by ${w.identifier.value}`),this._proxy.$addKernelDetectionTask(o,_);const g={dispose:()=>{this._kernelDetectionTask.delete(o),u._proxy.$removeKernelDetectionTask(o)}};return this._kernelDetectionTask.set(o,g),g}registerKernelSourceActionProvider(w,_,o){const u=this._kernelSourceActionProviderHandlePool++,g=typeof o.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,O=this;this._kernelSourceActionProviders.set(u,o),this._logService.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${w.identifier.value}`),this._proxy.$addKernelSourceActionProvider(u,u,_);let z;return g!==void 0&&(z=o.onDidChangeNotebookKernelSourceActions(H=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(g))),{dispose:()=>{this._kernelSourceActionProviders.delete(u),O._proxy.$removeKernelSourceActionProvider(u,u),z?.dispose()}}}async $provideKernelSourceActions(w,_){const o=this._kernelSourceActionProviders.get(w);if(o){const u=new T.DisposableStore;return this._kernelSourceActionProviderCache.add([u]),(await o.provideNotebookKernelSourceActions(_)??[]).map(O=>v.NotebookKernelSourceAction.from(O,this._commands.converter,u))}return[]}$acceptNotebookAssociation(w,_,o){const u=this._kernelData.get(w);if(u){const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(_));o?u.associatedNotebooks.set(g.uri,!0):u.associatedNotebooks.delete(g.uri),this._logService.trace(`NotebookController[${w}] ASSOCIATE notebook`,g.uri.toString(),o),u.onDidChangeSelection.fire({selected:o,notebook:g.apiNotebook})}}async $executeCells(w,_,o){const u=this._kernelData.get(w);if(!u)return;const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(_)),O=[];for(const z of o){const H=g.getCell(z);H&&O.push(H.apiCell)}try{this._logService.trace(`NotebookController[${w}] EXECUTE cells`,g.uri.toString(),O.length),await u.controller.executeHandler.call(u.controller,O,g.apiNotebook,u.controller)}catch(z){this._logService.error(`NotebookController[${w}] execute cells FAILED`,z),console.error(z)}}async $cancelCells(w,_,o){const u=this._kernelData.get(w);if(!u)return;const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(_));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,g.apiNotebook);else for(const O of o){const z=g.getCell(O);z&&this._activeExecutions.get(z.uri)?.cancel()}if(u.controller.interruptHandler){const O=this._activeNotebookExecutions.get(g.uri);o.length&&Array.isArray(O)&&O.length&&O.forEach(z=>z.dispose())}}$acceptKernelMessageFromRenderer(w,_,o){const u=this._kernelData.get(w);if(!u)return;const g=this._extHostNotebook.getEditorById(_);u.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:o}))}$cellExecutionChanged(w,_,o){const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(w)).getCell(_);if(g){const O=o?v.NotebookCellExecutionState.to(o):d.NotebookCellExecutionState.Idle;O!==void 0&&this._onDidChangeCellExecutionState.fire({cell:g.apiCell,state:O})}}_createNotebookCellExecution(w,_){if(w.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this._extHostNotebook.getNotebookDocument(w.notebook.uri).getCellFromApiCell(w);if(!u)throw new Error("invalid cell");if(this._activeExecutions.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const g=new n(_,u,this._proxy);this._activeExecutions.set(u.uri,g);const O=g.onDidChangeState(()=>{g.state===k.Resolved&&(g.dispose(),O.dispose(),this._activeExecutions.delete(u.uri))});return g.asApiObject()}_createNotebookExecution(w,_){const o=this._extHostNotebook.getNotebookDocument(w.uri),u=w.getCells().find(z=>{const H=o.getCellFromApiCell(z);return H&&this._activeExecutions.has(H.uri)});if(u)throw new Error(`duplicate cell execution for ${u.document.uri}`);if(this._activeNotebookExecutions.has(o.uri))throw new Error(`duplicate notebook execution for ${o.uri}`);const g=new r(_,o,this._proxy),O=g.onDidChangeState(()=>{g.state===a.Resolved&&(g.dispose(),O.dispose(),this._activeNotebookExecutions.delete(o.uri))});return this._activeNotebookExecutions.set(o.uri,[g,O]),g.asApiObject()}};e.ExtHostNotebookKernels=C,e.ExtHostNotebookKernels=C=Ve([ze(4,P.ILogService)],C);var k;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(k||(k={}));class n extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(w,_,o){super(),this._cell=_,this._proxy=o,this._handle=n.HANDLE++,this._onDidChangeState=new L.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=k.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new s(10,u=>this.update(u)),this._executionOrder=_.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,w,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(w){await this._collector.addItem(w)}async update(w){const _=Array.isArray(w)?w:[w];return this._proxy.$updateExecution(this._handle,new f.SerializableObjectWithBuffers(_))}verifyStateForOutput(){if(this._state===k.Init)throw new Error("Must call start before modifying cell output");if(this._state===k.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(w){let _=this._cell;if(w&&(_=this._cell.notebook.getCellFromApiCell(w)),!_)throw new Error("INVALID cell");return _.handle}validateAndConvertOutputs(w){return w.map(_=>{const o=d.NotebookCellOutput.ensureUniqueMimeTypes(_.items,!0);return o===_.items?v.NotebookCellOutput.from(_):v.NotebookCellOutput.from({items:o,id:_.id,metadata:_.metadata})})}async updateOutputs(w,_,o){const u=this.cellIndexToHandle(_),g=this.validateAndConvertOutputs((0,S.asArray)(w));return this.updateSoon({editType:i.CellExecutionUpdateType.Output,cellHandle:u,append:o,outputs:g})}async updateOutputItems(w,_,o){return w=d.NotebookCellOutput.ensureUniqueMimeTypes((0,S.asArray)(w),!0),this.updateSoon({editType:i.CellExecutionUpdateType.OutputItems,items:w.map(v.NotebookCellOutputItem.from),outputId:_.id,append:o})}asApiObject(){const w=this;return Object.freeze({get token(){return w._tokenSource.token},get cell(){return w._cell.apiCell},get executionOrder(){return w._executionOrder},set executionOrder(o){w._executionOrder=o,w.update([{editType:i.CellExecutionUpdateType.ExecutionState,executionOrder:w._executionOrder}])},start(o){if(w._state===k.Resolved||w._state===k.Started)throw new Error("Cannot call start again");w._state=k.Started,w._onDidChangeState.fire(),w.update({editType:i.CellExecutionUpdateType.ExecutionState,runStartTime:o})},end(o,u){if(w._state===k.Resolved)throw new Error("Cannot call resolve twice");w._state=k.Resolved,w._onDidChangeState.fire(),w._collector.flush(),w._proxy.$completeExecution(w._handle,new f.SerializableObjectWithBuffers({runEndTime:u,lastRunSuccess:o}))},clearOutput(o){return w.verifyStateForOutput(),w.updateOutputs([],o,!1)},appendOutput(o,u){return w.verifyStateForOutput(),w.updateOutputs(o,u,!0)},replaceOutput(o,u){return w.verifyStateForOutput(),w.updateOutputs(o,u,!1)},appendOutputItems(o,u){return w.verifyStateForOutput(),w.updateOutputItems(o,u,!0)},replaceOutputItems(o,u){return w.verifyStateForOutput(),w.updateOutputItems(o,u,!1)}})}}var a;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(a||(a={}));class r extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(w,_,o){super(),this._notebook=_,this._proxy=o,this._handle=r.HANDLE++,this._onDidChangeState=new L.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,w,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===a.Resolved||this._state===a.Started)throw new Error("Cannot call start again");this._state=a.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===a.Resolved)throw new Error("Cannot call resolve twice");this._state=a.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class s{constructor(w,_){this.delay=w,this.callback=_,this.batch=[],this.startedTimer=Date.now()}addItem(w){return this.batch.push(w),this.currentDeferred||(this.currentDeferred=new A.DeferredPromise,this.startedTimer=Date.now(),(0,A.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const w=this.currentDeferred;this.currentDeferred=void 0;const _=this.batch;return this.batch=[],this.callback(_).finally(()=>w.complete())}}function b(p,w){return`${p.value}/${w}`}e.createKernelId=b}),define(Pe[245],Te([1,0,5,3,104]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(h,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=h.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(h,y,m){const P=this._extHostNotebook.getEditorById(h);this._rendererMessageEmitters.get(y)?.fire({editor:P.apiEditor,message:m})}createRendererMessaging(h,y){if(!h.contributes?.notebookRenderer?.some(P=>P.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(P,D,l)=>this.getOrCreateEmitterFor(y).event(P,D,l),postMessage:(P,D)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(P)&&([P,D]=[D,P]);const l=D&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.proxy.$postMessage(l?.id,y,P)}}}getOrCreateEmitterFor(h){let y=this._rendererMessageEmitters.get(h);return y||(y=new S.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this._rendererMessageEmitters.delete(h)}}),this._rendererMessageEmitters.set(h,y),y)}}e.ExtHostNotebookRenderers=L}),define(Pe[246],Te([1,0,6,16,2,26,3]),function(ve,e,S,A,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class h{constructor(m){this.handlers=new Map,this.proxy=m.getProxy(T.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(m,P,D){if((0,L.checkProposedApiEnabled)(m,"profileContentHandlers"),this.handlers.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.handlers.set(P,D),this.proxy.$registerProfileContentHandler(P,D.name,D.description,m.identifier.value),(0,S.toDisposable)(()=>{this.handlers.delete(P),this.proxy.$unregisterProfileContentHandler(P)})}async $saveProfile(m,P,D,l){const E=this.handlers.get(m);if(!E)throw new Error(`Unknown handler with id: ${m}`);return E.saveProfile(P,D,l)}async $readProfile(m,P,D){const l=this.handlers.get(m);if(!l)throw new Error(`Unknown handler with id: ${m}`);return l.readProfile((0,A.isString)(P)?P:I.URI.revive(P),D)}}e.ExtHostProfileContentHandlers=h}),define(Pe[247],Te([1,0,2,3,13,8]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class T{static{this.handlePool=0}constructor(y,m){this.uriTransformer=m,this.providers=new Map,this.proxy=y.getProxy(A.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,m,P){const D=S.URI.revive(m),l=this.providers.get(y);return l?(0,I.asPromise)(()=>l.provideOriginalResource(D,P)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(y,m,P,D){const l=T.handlePool++;return this.providers.set(l,m),this.proxy.$registerQuickDiffProvider(l,L.DocumentSelector.from(y,this.uriTransformer),P,D),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(l),this.providers.delete(l)}}}}e.ExtHostQuickDiff=T}),define(Pe[248],Te([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function v(d,t,i){const c=d.getProxy(L.MainContext.MainThreadQuickOpen);class f{constructor(w,_){this._sessions=new Map,this._instances=0,this._workspace=w,this._commands=_}showQuickPick(w,_,o,u=S.CancellationToken.None){this._onDidSelectItem=void 0;const g=Promise.resolve(_),O=++this._instances,z=c.$show(O,{title:o?.title,placeHolder:o?.placeHolder,matchOnDescription:o?.matchOnDescription,matchOnDetail:o?.matchOnDetail,ignoreFocusLost:o?.ignoreFocusOut,canPickMany:o?.canPickMany},u),H={},B=z.then(()=>H);return Promise.race([B,g]).then($=>{if($===H)return;const x=(0,l.isProposedApiEnabled)(w,"quickPickItemTooltip");return g.then(M=>{const ne=[];for(let Q=0;Q<M.length;Q++){const we=M[Q];if(typeof we=="string")ne.push({label:we,handle:Q});else if(we.kind===h.QuickPickItemKind.Separator)ne.push({type:"separator",label:we.label});else{we.tooltip&&!x&&console.warn(`Extension '${w.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`);const _e=we.iconPath?r(we.iconPath):void 0;ne.push({label:we.label,iconPath:_e?.iconPath,iconClass:_e?.iconClass,description:we.description,detail:we.detail,picked:we.picked,alwaysShow:we.alwaysShow,tooltip:x?E.MarkdownString.fromStrict(we.tooltip):void 0,handle:Q})}}return o&&typeof o.onDidSelectItem=="function"&&(this._onDidSelectItem=Q=>{o.onDidSelectItem(M[Q])}),c.$setItems(O,ne),z.then(Q=>{if(typeof Q=="number")return M[Q];if(Array.isArray(Q))return Q.map(we=>M[we])})})}).then(void 0,$=>{if(!(0,y.isCancellationError)($))return c.$setError(O,$),Promise.reject($)})}$onItemSelected(w){this._onDidSelectItem?.(w)}showInput(w,_=S.CancellationToken.None){return this._validateInput=w?.validateInput,c.$input(w,typeof this._validateInput=="function",_).then(void 0,o=>{if(!(0,y.isCancellationError)(o))return Promise.reject(o)})}async $validateInput(w){if(!this._validateInput)return;const _=await this._validateInput(w);if(!_||typeof _=="string")return _;let o;switch(_.severity){case h.InputBoxValidationSeverity.Info:o=P.default.Info;break;case h.InputBoxValidationSeverity.Warning:o=P.default.Warning;break;case h.InputBoxValidationSeverity.Error:o=P.default.Error;break;default:o=_.message?P.default.Error:P.default.Ignore;break}return{content:_.message,severity:o}}async showWorkspaceFolderPick(w,_=S.CancellationToken.None){const o=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[w]);if(!o)return;const u=await this._workspace.getWorkspaceFolders2();if(u)return u.find(g=>g.uri.toString()===o.uri.toString())}createQuickPick(w){const _=new s(w,()=>this._sessions.delete(_._id));return this._sessions.set(_._id,_),_}createInputBox(w){const _=new b(w,()=>this._sessions.delete(_._id));return this._sessions.set(_._id,_),_}$onDidChangeValue(w,_){this._sessions.get(w)?._fireDidChangeValue(_)}$onDidAccept(w){this._sessions.get(w)?._fireDidAccept()}$onDidChangeActive(w,_){const o=this._sessions.get(w);o instanceof s&&o._fireDidChangeActive(_)}$onDidChangeSelection(w,_){const o=this._sessions.get(w);o instanceof s&&o._fireDidChangeSelection(_)}$onDidTriggerButton(w,_){this._sessions.get(w)?._fireDidTriggerButton(_)}$onDidTriggerItemButton(w,_,o){const u=this._sessions.get(w);u instanceof s&&u._fireDidTriggerItemButton(_,o)}$onDidHide(w){this._sessions.get(w)?._fireDidHide()}}class C{static{this._nextId=1}constructor(w,_){this._extensionId=w,this._onDidDispose=_,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(w){this._title=w,this.update({title:w})}get step(){return this._steps}set step(w){this._steps=w,this.update({step:w})}get totalSteps(){return this._totalSteps}set totalSteps(w){this._totalSteps=w,this.update({totalSteps:w})}get enabled(){return this._enabled}set enabled(w){this._enabled=w,this.update({enabled:w})}get busy(){return this._busy}set busy(w){this._busy=w,this.update({busy:w})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(w){this._ignoreFocusOut=w,this.update({ignoreFocusOut:w})}get value(){return this._value}set value(w){this._value=w,this.update({value:w})}get placeholder(){return this._placeholder}set placeholder(w){this._placeholder=w,this.update({placeholder:w})}get buttons(){return this._buttons}set buttons(w){this._buttons=w.slice(),this._handlesToButtons.clear(),w.forEach((_,o)=>{const u=_===h.QuickInputButtons.Back?-1:o;this._handlesToButtons.set(u,_)}),this.update({buttons:w.map((_,o)=>({...r(_.iconPath),tooltip:_.tooltip,handle:_===h.QuickInputButtons.Back?-1:o}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(w){this._value=w,this._onDidChangeValueEmitter.fire(w)}_fireDidTriggerButton(w){const _=this._handlesToButtons.get(w);_&&this._onDidTriggerButtonEmitter.fire(_)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),c.$dispose(this._id))}update(w){if(!this._disposed){for(const _ of Object.keys(w)){const o=w[_];this._pendingUpdate[_]=o===void 0?null:o}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){c.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function k(p){if(p instanceof h.ThemeIcon)return{id:p.id};const w=a(p),_=n(p);return{dark:typeof w=="string"?T.URI.file(w):w,light:typeof _=="string"?T.URI.file(_):_}}function n(p){return typeof p=="object"&&"light"in p?p.light:p}function a(p){return typeof p=="object"&&"dark"in p?p.dark:p}function r(p){const w=k(p);let _,o;return"id"in w?o=D.ThemeIcon.asClassName(w):_=w,{iconPath:_,iconClass:o}}class s extends C{constructor(w,_){super(w.identifier,_),this.extension=w,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this._onDidTriggerItemButtonEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(w){this._items=w.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),w.forEach((u,g)=>{this._handlesToItems.set(g,u),this._itemsToHandles.set(u,g)});const _=(0,l.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),o=[];for(let u=0;u<w.length;u++){const g=w[u];if(g.kind===h.QuickPickItemKind.Separator)o.push({type:"separator",label:g.label});else{g.tooltip&&!_&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const O=g.iconPath?r(g.iconPath):void 0;o.push({handle:u,label:g.label,iconPath:O?.iconPath,iconClass:O?.iconClass,description:g.description,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,tooltip:_?E.MarkdownString.fromStrict(g.tooltip):void 0,buttons:g.buttons?.map((z,H)=>({...r(z.iconPath),tooltip:z.tooltip,handle:H}))})}}this.update({items:o})}get canSelectMany(){return this._canSelectMany}set canSelectMany(w){this._canSelectMany=w,this.update({canSelectMany:w})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(w){this._matchOnDescription=w,this.update({matchOnDescription:w})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(w){this._matchOnDetail=w,this.update({matchOnDetail:w})}get sortByLabel(){return this._sortByLabel}set sortByLabel(w){this._sortByLabel=w,this.update({sortByLabel:w})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(w){this._keepScrollPosition=w,this.update({keepScrollPosition:w})}get activeItems(){return this._activeItems}set activeItems(w){this._activeItems=w.filter(_=>this._itemsToHandles.has(_)),this.update({activeItems:this._activeItems.map(_=>this._itemsToHandles.get(_))})}get selectedItems(){return this._selectedItems}set selectedItems(w){this._selectedItems=w.filter(_=>this._itemsToHandles.has(_)),this.update({selectedItems:this._selectedItems.map(_=>this._itemsToHandles.get(_))})}_fireDidChangeActive(w){const _=(0,m.coalesce)(w.map(o=>this._handlesToItems.get(o)));this._activeItems=_,this._onDidChangeActiveEmitter.fire(_)}_fireDidChangeSelection(w){const _=(0,m.coalesce)(w.map(o=>this._handlesToItems.get(o)));this._selectedItems=_,this._onDidChangeSelectionEmitter.fire(_)}_fireDidTriggerItemButton(w,_){const o=this._handlesToItems.get(w);if(!o||!o.buttons||!o.buttons.length)return;const u=o.buttons[_];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:o})}}class b extends C{constructor(w,_){super(w.identifier,_),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(w){this._password=w,this.update({password:w})}get prompt(){return this._prompt}set prompt(w){this._prompt=w,this.update({prompt:w})}get valueSelection(){return this._valueSelection}set valueSelection(w){this._valueSelection=w,this.update({valueSelection:w})}get validationMessage(){return this._validationMessage}set validationMessage(w){this._validationMessage=w,w?typeof w=="string"?this.update({validationMessage:w,severity:P.default.Error}):this.update({validationMessage:w.message,severity:w.severity??P.default.Error}):this.update({validationMessage:void 0,severity:P.default.Ignore})}}return new f(t,i)}e.createExtHostQuickOpen=v}),define(Pe[249],Te([1,0,2,5,65,6,13,3,18,132,14,20,40,8,26,12]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function i(_){if(_)return typeof _.iconPath=="string"?S.URI.file(_.iconPath):S.URI.isUri(_.iconPath)||l.ThemeIcon.isThemeIcon(_.iconPath)?_.iconPath:void 0}function c(_,o){if(!_.iconPath&&!o.iconPath)return 0;if(_.iconPath){if(!o.iconPath)return 1}else return-1;const u=typeof _.iconPath=="string"?_.iconPath:S.URI.isUri(_.iconPath)?_.iconPath.fsPath:_.iconPath.id,g=typeof o.iconPath=="string"?o.iconPath:S.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id;return(0,m.comparePaths)(u,g)}function f(_,o){let u=0;if(_.strikeThrough!==o.strikeThrough)return _.strikeThrough?1:-1;if(_.faded!==o.faded)return _.faded?1:-1;if(_.tooltip!==o.tooltip)return(_.tooltip||"").localeCompare(o.tooltip||"");if(u=c(_,o),u!==0)return u;if(_.light&&o.light)u=c(_.light,o.light);else{if(_.light)return 1;if(o.light)return-1}if(u!==0)return u;if(_.dark&&o.dark)u=c(_.dark,o.dark);else{if(_.dark)return 1;if(o.dark)return-1}return u}function C(_,o){if(_.command!==o.command)return _.command<o.command?-1:1;if(_.title!==o.title)return _.title<o.title?-1:1;if(_.tooltip!==o.tooltip){if(_.tooltip!==void 0&&o.tooltip!==void 0)return _.tooltip<o.tooltip?-1:1;if(_.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(_.arguments===o.arguments)return 0;if(_.arguments)if(o.arguments){if(_.arguments.length!==o.arguments.length)return _.arguments.length-o.arguments.length}else return 1;else return-1;for(let u=0;u<_.arguments.length;u++){const g=_.arguments[u],O=o.arguments[u];if(g!==O)return g<O?-1:1}return 0}function k(_,o){let u=(0,m.comparePaths)(_.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(u!==0)return u;if(_.command&&o.command)u=C(_.command,o.command);else{if(_.command)return 1;if(o.command)return-1}if(u!==0)return u;if(_.decorations&&o.decorations)u=f(_.decorations,o.decorations);else{if(_.decorations)return 1;if(o.decorations)return-1}return u}function n(_,o){for(let u=0;u<_.length;u++)if(_[u]!==o[u])return!1;return!0}function a(_,o){return _.command===o.command&&_.title===o.title&&_.tooltip===o.tooltip&&(_.arguments&&o.arguments?n(_.arguments,o.arguments):_.arguments===o.arguments)}function r(_,o){return(0,y.equals)(_,o,a)}class s{#e;#t;get value(){return this._value}set value(o){o=o??"",this.#e.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(o){if((0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get enabled(){return this._enabled}set enabled(o){o=!!o,this._enabled!==o&&(this._enabled=o,this.#e.$setInputBoxEnablement(this._sourceControlHandle,o))}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this.#e.$setInputBoxVisibility(this._sourceControlHandle,o))}get document(){return(0,v.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(o,u,g,O,z){this._extension=o,this._sourceControlHandle=O,this._documentUri=z,this._value="",this._onDidChange=new A.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=u,this.#e=g}showValidationMessage(o,u){(0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,o,u)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=s;class b{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}constructor(o,u,g,O,z){this._proxy=o,this._commands=u,this._sourceControlHandle=g,this._id=O,this._label=z,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new A.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new A.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=b._handlePool++}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,u){const g=this._resourceStatesCommandsMap.get(o);return g?(0,T.asPromise)(()=>this._commands.executeCommand(g.command,...g.arguments||[],u)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const o=[...this._resourceStates].sort(k),g=(0,y.sortedDiff)(this._resourceSnapshot,o,k).map(H=>{const B=H.toInsert.map($=>{const x=this._resourceHandlePool++;this._resourceStatesMap.set(x,$);const M=$.resourceUri;let ne;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const le=new L.DisposableStore;ne=this._commands.converter.toInternal($.command,le),this._resourceStatesDisposablesMap.set(x,le)}else this._resourceStatesCommandsMap.set(x,$.command);const Q=i($.decorations),we=$.decorations&&i($.decorations.light)||Q,_e=$.decorations&&i($.decorations.dark)||Q,Ae=[we,_e],Y=$.decorations&&$.decorations.tooltip||"",he=$.decorations&&!!$.decorations.strikeThrough,ke=$.decorations&&!!$.decorations.faded,ae=$.contextValue||"";return{rawResource:[x,M,Ae,Y,he,ke,ae,ne],handle:x}});return{start:H.start,deleteCount:H.deleteCount,toInsert:B}}),O=g.map(({start:H,deleteCount:B,toInsert:$})=>[H,B,$.map(x=>x.rawResource)]),z=g.reverse();for(const{start:H,deleteCount:B,toInsert:$}of z){const x=$.map(ne=>ne.handle),M=this._handlesSnapshot.splice(H,B,...x);for(const ne of M)this._resourceStatesMap.delete(ne),this._resourceStatesCommandsMap.delete(ne),this._resourceStatesDisposablesMap.get(ne)?.dispose(),this._resourceStatesDisposablesMap.delete(ne)}return this._resourceSnapshot=o,O}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class p{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this.#e.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o;let u;(0,v.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(u=o?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o,quickDiffLabel:u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this.#e.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new L.DisposableStore,this._acceptInputCommand=o;const u=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:u})}get actionButton(){return(0,v.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(o){(0,v.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new L.DisposableStore,this._actionButton=o;const u=o!==void 0?{command:this._commands.converter.toInternal(o.command,this._actionButtonDisposables.value),secondaryCommands:o.secondaryCommands?.map(g=>g.map(O=>this._commands.converter.toInternal(O,this._actionButtonDisposables.value))),description:o.description,enabled:o.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:u??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&r(this._statusBarCommands,o))return;this._statusBarDisposables.value=new L.DisposableStore,this._statusBarCommands=o;const u=(o||[]).map(g=>this._commands.converter.toInternal(g,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:u})}get selected(){return this._selected}constructor(o,u,g,O,z,H,B){this._extension=o,this._commands=O,this._id=z,this._label=H,this._rootUri=B,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new L.MutableDisposable,this._statusBarDisposables=new L.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new A.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=p._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=g;const $=S.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${z}/scm${this.handle}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this._inputBox=new s(o,u,this.#e,this.handle,$),this.#e.$registerSourceControl(this.handle,z,H,B,$)}createResourceGroup(o,u){const g=new b(this.#e,this._commands,this.handle,o,u),O=A.Event.once(g.onDidDispose)(()=>this.createdResourceGroups.delete(g));return this.createdResourceGroups.set(g,O),this.eventuallyAddResourceGroups(),g}eventuallyAddResourceGroups(){const o=[],u=[];for(const[g,O]of this.createdResourceGroups){O.dispose();const z=g.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(g),this.eventuallyUpdateResourceStates()});A.Event.once(g.onDidDispose)(()=>{this.updatedResourceGroups.delete(g),z.dispose(),this._groups.delete(g.handle),this.#e.$unregisterGroup(this.handle,g.handle)}),o.push([g.handle,g.id,g.label,g.features]);const H=g._takeResourceStateSnapshot();H.length>0&&u.push([g.handle,H]),this._groups.set(g.handle,g)}this.#e.$registerGroups(this.handle,o,u),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(u=>{const g=u._takeResourceStateSnapshot();g.length!==0&&o.push([u.handle,g])}),o.length>0&&this.#e.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Ve([(0,I.debounce)(100)],p.prototype,"eventuallyAddResourceGroups",null),Ve([(0,I.debounce)(100)],p.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{t=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(o,u,g,O){this._commands=u,this._extHostDocuments=g,this.logService=O,this._sourceControls=new Map,this._sourceControlsByExtension=new D.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new A.Emitter,this._proxy=o.getProxy(h.MainContext.MainThreadSCM),this._telemetry=o.getProxy(h.MainContext.MainThreadTelemetry),u.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const H=this._sourceControls.get(z.sourceControlHandle);if(!H)return z;const B=H.getResourceGroup(z.groupHandle);return B?B.getResourceState(z.handle):z}else if(z&&z.$mid===4){const H=this._sourceControls.get(z.sourceControlHandle);return H?H.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const H=this._sourceControls.get(z.handle);return H||z}return z}})}createSourceControl(o,u,g,O){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,u,g,O),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const z=t._handlePool++,H=new p(o,this._extHostDocuments,this._proxy,this._commands,u,g,O);this._sourceControls.set(z,H);const B=this._sourceControlsByExtension.get(o.identifier)||[];return B.push(H),this._sourceControlsByExtension.set(o.identifier,B),H}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const u=this._sourceControlsByExtension.get(o.identifier),g=u&&u[u.length-1];return g&&g.inputBox}$provideOriginalResource(o,u,g){const O=S.URI.revive(u);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,O.toString());const z=this._sourceControls.get(o);return!z||!z.quickDiffProvider||!z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>z.quickDiffProvider.provideOriginalResource(O,g)).then(H=>H||null)}$onInputBoxValueChange(o,u){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const g=this._sourceControls.get(o);return g&&g.inputBox.$onInputBoxValueChange(u),Promise.resolve(void 0)}$executeResourceCommand(o,u,g,O){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,u,g);const z=this._sourceControls.get(o);if(!z)return Promise.resolve(void 0);const H=z.getResourceGroup(u);return H?H.$executeResourceCommand(g,O):Promise.resolve(void 0)}$validateInput(o,u,g){this.logService.trace("ExtHostSCM#$validateInput",o);const O=this._sourceControls.get(o);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>O.inputBox.validateInput(u,g)).then(z=>{if(!z)return Promise.resolve(void 0);const H=E.MarkdownString.fromStrict(z.message);return H?Promise.resolve([H,z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(o){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&this._sourceControls.get(o)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};e.ExtHostSCM=w,e.ExtHostSCM=w=t=Ve([ze(3,P.ILogService)],w)}),define(Pe[83],Te([1,0,3,5,4]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(h){this._onDidChangePassword=new A.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=h.getProxy(S.MainContext.MainThreadSecretState)}async $onDidChangePassword(h){this._onDidChangePassword.fire(h)}get(h,y){return this._proxy.$getPassword(h,y)}store(h,y,m){return this._proxy.$setPassword(h,y,m)}delete(h,y){return this._proxy.$deletePassword(h,y)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(Pe[250],Te([1,0,3,8,2]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class L{static{this.handlePool=0}constructor(h,y){this.uriTransformer=y,this.providers=new Map,this.proxy=h.getProxy(S.MainContext.MainThreadShare)}async $provideShare(h,y,m){return await this.providers.get(h)?.provideShare({selection:A.Range.to(y.selection),resourceUri:I.URI.revive(y.resourceUri)},m)??void 0}registerShareProvider(h,y){const m=L.handlePool++;return this.providers.set(m,y),this.proxy.$registerShareProvider(m,A.DocumentSelector.from(h,this.uriTransformer),y.id,y.label,y.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(m),this.providers.delete(m)}}}}e.ExtHostShare=L}),define(Pe[251],Te([1,0,7,3,154,6,8,16]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new S.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(l,E,v,d,t,i=S.StatusBarAlignment.Left,c){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new L.DisposableStore,this.#e=l,this.#t=E,t&&d){this._entryId=(0,S.asStatusBarItemIdentifier)(d.identifier,t);const f=v.get(this._entryId);f&&(i=f.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,c=f.priority,this._visible=!0,this.name=f.name,this.text=f.text,this.tooltip=f.tooltip,this.command=f.command,this.accessibilityInformation=f.accessibilityInformation)}else this._entryId=String(y.ID_GEN++);this._extension=d,this._id=t,this._alignment=i,this._priority=this.validatePriority(c)}validatePriority(l){if((0,h.isNumber)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(l){this._text=l,this.update()}set name(l){this._name=l,this.update()}set tooltip(l){this._tooltip=l,this.update()}set color(l){this._color=l,this.update()}set backgroundColor(l){l&&!y.ALLOWED_BACKGROUND_COLORS.has(l.id)&&(l=void 0),this._backgroundColor=l,this.update()}set command(l){this._command?.fromApi!==l&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new L.DisposableStore,typeof l=="string"?this._command={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this._latestCommandRegistration)}:l?this._command={fromApi:l,internal:this.#t.toInternal(l,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(l){this._accessibilityInformation=l,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let l;this._extension?this._id?l=`${this._extension.identifier.value}.${this._id}`:l=this._extension.identifier.value:l=this._id;let E;this._name?E=this._name:E=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const d=T.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,l,this._extension?.identifier.value,E,this._text,d,this._command?.internal,v,this._backgroundColor,this._alignment===S.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y;class m{constructor(l){this._messages=[],this._item=l.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(l){const E={message:l};return this._messages.unshift(E),this._update(),new S.Disposable(()=>{const v=this._messages.indexOf(E);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class P{constructor(l,E){this._existingItems=new Map,this._proxy=l.getProxy(A.MainContext.MainThreadStatusBar),this._commands=E,this._statusMessage=new m(this)}$acceptStaticEntries(l){for(const E of l)this._existingItems.set(E.entryId,E)}createStatusBarEntry(l,E,v,d){return new y(this._proxy,this._commands,this._existingItems,l,E,v,d)}setStatusBarMessage(l,E){const v=this._statusMessage.setMessage(l);let d;return typeof E=="number"?d=setTimeout(()=>v.dispose(),E):typeof E<"u"&&E.then(()=>v.dispose(),()=>v.dispose()),new S.Disposable(()=>{v.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=P}),define(Pe[84],Te([1,0,3,5,4]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(h,y){this._logService=y,this._onDidChangeStorage=new A.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=h.getProxy(S.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(h,y){this._proxy.$registerExtensionStorageKeysToSync(h,y)}async initializeExtensionStorage(h,y,m){const P=await this._proxy.$initializeExtensionStorage(h,y);let D;return P&&(D=this.safeParseValue(h,y,P)),D||m}setValue(h,y,m){return this._proxy.$setValue(h,y,m)}$acceptValue(h,y,m){const P=this.safeParseValue(h,y,m);P&&this._onDidChangeStorage.fire({shared:h,key:y,value:P})}safeParseValue(h,y,m){try{return JSON.parse(m)}catch(P){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${h}): ${P}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(Pe[85],Te([1,0,4,27,14,62,2]),function(ve,e,S,A,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,S.createDecorator)("IExtensionStoragePaths");let h=class{constructor(m,P,D){this._logService=P,this._extHostFileSystem=D,this._workspace=m.workspace??void 0,this._environment=m.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(m){return T.URI.joinPath(this._environment.workspaceStorageHome,m)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const m=this._workspace.id,P=await this._getWorkspaceStorageURI(m);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),P}catch(D){this._logService.error("[ExtHostStorage]",D);return}}workspaceValue(m){if(this._value)return T.URI.joinPath(this._value,m.identifier.value)}globalValue(m){return T.URI.joinPath(this._environment.globalStorageHome,m.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=h,e.ExtensionStoragePaths=h=Ve([ze(0,A.IExtHostInitDataService),ze(1,I.ILogService),ze(2,L.IExtHostConsumerFileSystem)],h)}),define(Pe[63],Te([1,0,5,3,4,2,17,6,7,156,9,182,21,36,183,40,13,8,31]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class f{constructor(o,u,g,O){this._proxy=o,this._id=u,this._creationOptions=g,this._name=O,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(H=>this._pidPromiseComplete=H);const z=this;this.value={get name(){return z._name||""},get processId(){return z._pidPromise},get creationOptions(){return z._creationOptions},get exitStatus(){return z._exitStatus},get state(){return z._state},get selection(){return z._selection},sendText(H,B=!0){z._checkDisposed(),z._proxy.$sendText(z._id,H,B)},show(H){z._checkDisposed(),z._proxy.$show(z._id,H)},hide(){z._checkDisposed(),z._proxy.$hide(z._id)},dispose(){z._disposed||(z._disposed=!0,z._proxy.$dispose(z._id))},get dimensions(){if(!(z._cols===void 0||z._rows===void 0))return{columns:z._cols,rows:z._rows}}}}async create(o,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:o.shellPath??void 0,shellArgs:o.shellArgs??void 0,cwd:o.cwd??void 0,env:o.env??void 0,icon:b(o.iconPath)??void 0,color:d.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:o.message??void 0,strictEnv:o.strictEnv??void 0,hideFromUser:o.hideFromUser??void 0,isFeatureTerminal:u?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:u?.useShellEnvironment??void 0,location:u?.location||this._serializeParentTerminal(o.location,u?.resolvedExtHostIdentifier),isTransient:o.isTransient??void 0})}async createExtensionTerminal(o,u,g,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:g,color:d.ThemeColor.isThemeColor(O)?O.id:void 0,location:this._serializeParentTerminal(o,u),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,u){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&u?{parentTerminal:u}:"viewColumn"in o?{viewColumn:i.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitStatus(o,u){this._exitStatus=Object.freeze({code:o,reason:u})}setDimensions(o,u){return o===this._cols&&u===this._rows||o===0||u===0?!1:(this._cols=o,this._rows=u,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(o){this._selection=o}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(u=>{u!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=f;class C{get onProcessReady(){return this._onProcessReady.event}constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._onProcessData=new S.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new S.Emitter,this._onDidChangeProperty=new S.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new S.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,u){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${u}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput?.(o)}resize(o,u){this._pty.setDimensions?.({columns:o,rows:u})}clearBuffer(){}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(o){this._pty.onDidWrite(u=>this._onProcessData.fire(u)),this._pty.onDidClose?.((u=void 0)=>{this._onProcessExit.fire(u===void 0?void 0:u)}),this._pty.onDidOverrideDimensions?.(u=>{u&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:u.columns,rows:u.rows}})}),this._pty.onDidChangeName?.(u=>{this._onDidChangeProperty.fire({type:"title",value:u})}),this._pty.open(o||void 0),o&&this._pty.setDimensions?.(o),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let k=1,n=class extends h.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}constructor(o,u,g){super(),this._extHostCommands=u,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new h.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new S.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new S.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new S.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new S.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new S.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new S.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new S.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new S.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=g.getProxy(A.MainContext.MainThreadTerminalService),this._bufferer=new v.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[O,z]of this._terminalProcesses)z.shutdown(!0)}})}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,u){const g=new f(this._proxy,(0,E.generateUuid)(),o,o.name),O=new C(o.pty);return g.createExtensionTerminal(o.location,this._serializeParentTerminal(o,u).resolvedExtHostIdentifier,b(o.iconPath),p(o.color)).then(z=>{const H=this._setupExtHostProcessListeners(z,O);this._terminalProcessDisposables[z]=H}),this._terminals.push(g),g.value}_serializeParentTerminal(o,u){if(u=u||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const g=o.location.parentTerminal;if(g){const O=this._terminals.find(z=>z.value===g);O&&(u.resolvedExtHostIdentifier=O._id)}}else o.location&&typeof o.location!="object"?u.location=o.location:u.location&&typeof u.location=="object"&&"splitActiveTerminal"in u.location&&(u.location={splitActiveTerminal:!0});return u}attachPtyToTerminal(o,u){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const O=new C(u),z=this._setupExtHostProcessListeners(o,O);this._terminalProcessDisposables[o]=z}async $acceptActiveTerminalChanged(o){const u=this._activeTerminal;if(o===null){this._activeTerminal=void 0,u!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const g=this._getTerminalById(o);g&&(this._activeTerminal=g,u!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,u){const g=this._getTerminalById(o);g&&this._onDidWriteTerminalData.fire({terminal:g.value,data:u})}async $acceptTerminalDimensions(o,u,g){const O=this._getTerminalById(o);O&&O.setDimensions(u,g)&&this._onDidChangeTerminalDimensions.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptDidExecuteCommand(o,u){const g=this._getTerminalById(o);g&&this._onDidExecuteCommand.fire({terminal:g.value,...u})}async $acceptTerminalMaximumDimensions(o,u,g){this._terminalProcesses.get(o)?.resize(u,g)}async $acceptTerminalTitleChange(o,u){const g=this._getTerminalById(o);g&&(g.name=u)}async $acceptTerminalClosed(o,u,g){const O=this._getTerminalObjectIndexById(this._terminals,o);if(O!==null){const z=this._terminals.splice(O,1)[0];z.setExitStatus(u,g),this._onDidCloseTerminal.fire(z.value)}}$acceptTerminalOpened(o,u,g,O){if(u){const B=this._getTerminalObjectIndexById(this._terminals,u);if(B!==null){this._terminals[B]._id=o,this._onDidOpenTerminal.fire(this.terminals[B]),this._terminals[B].isOpen=!0;return}}const z={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:L.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},H=new f(this._proxy,o,z,g);this._terminals.push(H),this._onDidOpenTerminal.fire(H.value),H.isOpen=!0}async $acceptTerminalProcessId(o,u){this._getTerminalById(o)?._setProcessId(u)}async $startExtensionTerminal(o,u){const g=this._getTerminalById(o);if(!g)return{message:(0,m.localize)(0,null,o)};g.isOpen||await new Promise(z=>{const H=this.onDidOpenTerminal(async B=>{B===g.value&&(H.dispose(),z())})});const O=this._terminalProcesses.get(o);O?O.startSendingEvents(u):this._extensionTerminalAwaitingStart[o]={initialDimensions:u}}_setupExtHostProcessListeners(o,u){const g=new h.DisposableStore;g.add(u.onProcessReady(z=>this._proxy.$sendProcessReady(o,z.pid,z.cwd,z.windowsPty))),g.add(u.onDidChangeProperty(z=>this._proxy.$sendProcessProperty(o,z))),this._bufferer.startBuffering(o,u.onProcessData),g.add(u.onProcessExit(z=>this._onProcessExit(o,z))),this._terminalProcesses.set(o,u);const O=this._extensionTerminalAwaitingStart[o];return O&&u instanceof C&&(u.startSendingEvents(O.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),g}$acceptProcessAckDataEvent(o,u){this._terminalProcesses.get(o)?.acknowledgeDataEvent(u)}$acceptProcessInput(o,u){this._terminalProcesses.get(o)?.input(u)}$acceptTerminalInteraction(o){const u=this._getTerminalById(o);u?.setInteractedWith()&&this._onDidChangeTerminalState.fire(u.value)}$acceptTerminalSelection(o,u){this._getTerminalById(o)?.setSelection(u)}$acceptProcessResize(o,u,g){try{this._terminalProcesses.get(o)?.resize(u,g)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(o,u){this._terminalProcesses.get(o)?.shutdown(u)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(u=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:u}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(u=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:u}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,u,g){if(this._profileProviders.has(u))throw new Error(`Terminal profile provider "${u}" already registered`);return this._profileProviders.set(u,g),this._proxy.$registerProfileProvider(u,o.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(u),this._proxy.$unregisterProfileProvider(u)})}registerTerminalQuickFixProvider(o,u,g){if(this._quickFixProviders.has(o))throw new Error(`Terminal quick fix provider "${o}" is already registered`);return this._quickFixProviders.set(o,g),this._proxy.$registerQuickFixProvider(o,u),new y.Disposable(()=>{this._quickFixProviders.delete(o),this._proxy.$unregisterQuickFixProvider(o)})}async $provideTerminalQuickFixes(o,u){const g=new l.CancellationTokenSource().token;if(g.isCancellationRequested)return;const O=this._quickFixProviders.get(o);if(!O)return;const z=await O.provideTerminalQuickFixes(u,g);if(z===null||Array.isArray(z)&&z.length===0)return;const H=new h.DisposableStore;if(this._lastQuickFixCommands.value=H,!Array.isArray(z))return z?i.TerminalQuickFix.from(z,this._extHostCommands.converter,H):void 0;const B=[];for(const $ of z){const x=i.TerminalQuickFix.from($,this._extHostCommands.converter,H);x&&B.push(x)}return B}async $createContributedProfileTerminal(o,u){const g=new l.CancellationTokenSource().token;let O=await this._profileProviders.get(o)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,u);return}this.createTerminalFromOptions(O.options,u)}}async $provideLinks(o,u){const g=this._getTerminalById(o);if(!g)return[];this._terminalLinkCache.delete(o),this._terminalLinkCancellationSource.get(o)?.dispose(!0);const z=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,z);const H=[],B={terminal:g.value,line:u},$=[];for(const ne of this._linkProviders)$.push(t.Promises.withAsyncBody(async Q=>{z.token.onCancellationRequested(()=>Q({provider:ne,links:[]}));const we=await ne.provideTerminalLinks(B,z.token)||[];z.token.isCancellationRequested||Q({provider:ne,links:we})}));const x=await Promise.all($);if(z.token.isCancellationRequested)return[];const M=new Map;for(const ne of x)ne&&ne.links.length>0&&H.push(...ne.links.map(Q=>{const we={id:k++,startIndex:Q.startIndex,length:Q.length,label:Q.tooltip};return M.set(we.id,{provider:ne.provider,link:Q}),we}));return this._terminalLinkCache.set(o,M),H}$activateLink(o,u){const g=this._terminalLinkCache.get(o)?.get(u);g&&g.provider.handleTerminalLink(g.link)}_onProcessExit(o,u){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const g=this._terminalProcessDisposables[o];g&&(g.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,u)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,u){const g=this._getTerminalObjectIndexById(o,u);return g!==null?o[g]:null}_getTerminalObjectIndexById(o,u){const g=o.findIndex(O=>O._id===u);return g===-1?null:g}getEnvironmentVariableCollection(o){let u=this._environmentVariableCollections.get(o.identifier.value);return u||(u=new a,this._setEnvironmentVariableCollection(o.identifier.value,u)),u.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(o,u){const g=(0,D.serializeEnvironmentVariableCollection)(u.map),O=(0,D.serializeEnvironmentDescriptionMap)(u.descriptionMap);this._proxy.$setEnvironmentVariableCollection(o,u.persistent,g.length===0?void 0:g,O)}$initEnvironmentVariableCollections(o){o.forEach(u=>{const g=u[0],O=new a(u[1]);this._setEnvironmentVariableCollection(g,O)})}$acceptDefaultProfile(o,u){const g=this._defaultProfile;this._defaultProfile=o,this._defaultAutomationProfile=u,g?.path!==o.path&&this._onDidChangeShell.fire(o.path)}_setEnvironmentVariableCollection(o,u){this._environmentVariableCollections.set(o,u),u.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,u)})}};e.BaseExtHostTerminalService=n,e.BaseExtHostTerminalService=n=Ve([ze(1,c.IExtHostCommands),ze(2,T.IExtHostRpcService)],n);class a{get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(o){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new S.Emitter,this.map=new Map(o)}getScopedEnvironmentVariableCollection(o){const u=this.getScopeKey(o);let g=this.scopedCollections.get(u);return g||(g=new r(this,o),this.scopedCollections.set(u,g),g.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),g}replace(o,u,g,O){this._setIfDiffers(o,{value:u,type:y.EnvironmentVariableMutatorType.Replace,options:g??{applyAtProcessCreation:!0},scope:O})}append(o,u,g,O){this._setIfDiffers(o,{value:u,type:y.EnvironmentVariableMutatorType.Append,options:g??{applyAtProcessCreation:!0},scope:O})}prepend(o,u,g,O){this._setIfDiffers(o,{value:u,type:y.EnvironmentVariableMutatorType.Prepend,options:g??{applyAtProcessCreation:!0},scope:O})}_setIfDiffers(o,u){if(u.options&&u.options.applyAtProcessCreation===!1&&!u.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const g=this.getKey(o,u.scope),O=this.map.get(g),z=u.options?{applyAtProcessCreation:u.options.applyAtProcessCreation??!1,applyAtShellIntegration:u.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!O||O.value!==u.value||O.type!==u.type||O.options?.applyAtProcessCreation!==z.applyAtProcessCreation||O.options?.applyAtShellIntegration!==z.applyAtShellIntegration||O.scope?.workspaceFolder?.index!==u.scope?.workspaceFolder?.index){const H=this.getKey(o,u.scope),B={variable:o,...u,options:z};this.map.set(H,B),this._onDidChangeCollection.fire()}}get(o,u){const g=this.getKey(o,u),O=this.map.get(g);return O?w(O):void 0}getKey(o,u){const g=this.getScopeKey(u);return g.length?`${o}:::${g}`:o}getScopeKey(o){return this.getWorkspaceKey(o?.workspaceFolder)??""}getWorkspaceKey(o){return o?o.uri.toString():void 0}getVariableMap(o){const u=new Map;for(const[g,O]of this.map)this.getScopeKey(O.scope)===this.getScopeKey(o)&&u.set(O.variable,w(O));return u}delete(o,u){const g=this.getKey(o,u);this.map.delete(g),this._onDidChangeCollection.fire()}clear(o){if(o?.workspaceFolder){for(const[u,g]of this.map)g.scope?.workspaceFolder?.index===o.workspaceFolder.index&&this.map.delete(u);this.clearDescription(o)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(o,u){const g=this.getScopeKey(u),O=this.descriptionMap.get(g);if(!O||O.description!==o){let z;typeof o=="string"?z=o:z=o?.value.split(`

`)[0];const H={description:z,scope:u};this.descriptionMap.set(g,H),this._onDidChangeCollection.fire()}}getDescription(o){const u=this.getScopeKey(o);return this.descriptionMap.get(u)?.description}clearDescription(o){const u=this.getScopeKey(o);this.descriptionMap.delete(u)}}class r{get persistent(){return this.collection.persistent}set persistent(o){this.collection.persistent=o}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(o,u){this.collection=o,this.scope=u,this._onDidChangeCollection=new S.Emitter}getScoped(o){return this.collection.getScopedEnvironmentVariableCollection(o)}replace(o,u,g){this.collection.replace(o,u,g,this.scope)}append(o,u,g){this.collection.append(o,u,g,this.scope)}prepend(o,u,g){this.collection.prepend(o,u,g,this.scope)}get(o){return this.collection.get(o,this.scope)}forEach(o,u){this.collection.getVariableMap(this.scope).forEach((g,O)=>o.call(u,O,g,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(o){this.collection.delete(o,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(o){this.collection.setDescription(o,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let s=class extends n{constructor(o,u){super(!1,o,u)}createTerminal(o,u,g){throw new P.NotSupportedError}createTerminalFromOptions(o,u){throw new P.NotSupportedError}};e.WorkerExtHostTerminalService=s,e.WorkerExtHostTerminalService=s=Ve([ze(0,c.IExtHostCommands),ze(1,T.IExtHostRpcService)],s);function b(_){if(!(!_||typeof _=="string"))return"id"in _?{id:_.id,color:_.color}:_}function p(_){return d.ThemeColor.isThemeColor(_)?_:void 0}function w(_){const o={..._};return delete o.scope,o.options=o.options??void 0,delete o.variable,o}}),define(Pe[252],Te([1,0,18,13,25,21,5,203,93,6,24,16,36,3,17,105,8,7,45,76,57,26]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t,i,c,f,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let n=class{constructor(B,$,x){this.editors=x,this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=B.getProxy(E.MainContext.MainThreadTesting),this.observer=new g(this.proxy),this.runTracker=new b(this.proxy),$.registerArgumentProcessor({processArgument:M=>{switch(M?.$mid){case 15:{const ne=M,Q=ne.tests[ne.tests.length-1].item.extId;return this.controllers.get(c.TestId.root(Q))?.collection.tree.get(Q)?.actual??(0,d.toItemFromContext)(M)}case 17:{const{extId:ne,message:Q}=M;return{test:this.controllers.get(c.TestId.root(ne))?.collection.tree.get(ne)?.actual,message:t.TestMessage.to(Q)}}default:return M}}}),$.registerCommand(!1,"testing.getExplorerSelection",async()=>{const M=await $.executeCommand("_testing.getExplorerSelection"),ne=Q=>{const we=this.controllers.get(c.TestId.root(Q));if(we)return c.TestId.isRoot(Q)?we.controller:we.collection.tree.get(Q)?.actual};return{include:M?.include.map(ne).filter(D.isDefined)||[],exclude:M?.exclude.map(ne).filter(D.isDefined)||[]}})}createTestController(B,$,x,M){if(this.controllers.has($))throw new Error(`Attempt to insert a duplicate controller with ID "${$}"`);const ne=new m.DisposableStore,Q=ne.add(new d.ExtHostTestItemCollection($,x,this.editors));Q.root.label=x;const we=new Map,_e=this.proxy,Ae={items:Q.root.children,get label(){return x},set label(he){x=he,Q.root.label=he,_e.$updateController($,{label:x})},get refreshHandler(){return M},set refreshHandler(he){M=he,_e.$updateController($,{canRefresh:!!he})},get id(){return $},createRunProfile:(he,ke,ae,J,le,N)=>{let q=(0,y.hash)(he);for(;we.has(q);)q++;return new O(this.proxy,we,$,q,he,ke,ae,J,le,N)},createTestItem(he,ke,ae){return new d.TestItemImpl($,he,ke,ae)},createTestRun:(he,ke,ae=!0)=>this.runTracker.createTestRun(B,$,Q,he,ke,ae),invalidateTestResults:he=>{if(he===void 0)this.proxy.$markTestRetired(void 0);else{const ke=he instanceof Array?he:[he];this.proxy.$markTestRetired(ke.map(ae=>c.TestId.fromExtHostTestItem(ae,$).toString()))}},set resolveHandler(he){Q.resolveHandler=he},get resolveHandler(){return Q.resolveHandler},dispose:()=>{ne.dispose()}};_e.$registerTestController($,x,!!M),ne.add((0,m.toDisposable)(()=>_e.$unregisterTestController($)));const Y={controller:Ae,collection:Q,profiles:we,extension:B};return this.controllers.set($,Y),ne.add((0,m.toDisposable)(()=>this.controllers.delete($))),ne.add(Q.onDidGenerateDiff(he=>_e.$publishDiff($,he.map(C.TestsDiffOp.serialize)))),Ae}createTestObserver(){return this.observer.checkout()}async runTests(B,$=L.CancellationToken.None){const x=p(B);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.controllers.get(x.controllerId);if(!M)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:B.include?.map(ne=>c.TestId.fromExtHostTestItem(ne,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:z[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:B.exclude?.map(ne=>ne.id)},$)}$syncTests(){for(const{collection:B}of this.controllers.values())B.flushDiff();return Promise.resolve()}$provideFileCoverage(B,$,x){return(0,S.mapFind)(this.runTracker.trackers,ne=>ne.id===B?ne.getCoverage($):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(B,$,x,M){return(0,S.mapFind)(this.runTracker.trackers,Q=>Q.id===B?Q.getCoverage($):void 0)?.resolveFileCoverage(x,M)??Promise.resolve([])}$configureRunProfile(B,$){this.controllers.get(B)?.profiles.get($)?.configureHandler?.()}async $refreshTests(B,$){await this.controllers.get(B)?.controller.refreshHandler?.($)}$publishTestResults(B){this.results=Object.freeze(B.map($=>(0,P.deepFreeze)(t.TestResults.to($))).concat(this.results).sort(($,x)=>x.completedAt-$.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(B,$){const x=this.controllers.get(c.TestId.fromString(B).controllerId)?.collection;x&&(await x.expand(B,$<0?1/0:$),x.flushDiff())}$acceptDiff(B){this.observer.applyDiff(B.map(C.TestsDiffOp.deserialize))}async $runControllerTests(B,$){return Promise.all(B.map(x=>this.runControllerTestRequest(x,!1,$)))}async $startContinuousRun(B,$){const x=new L.CancellationTokenSource($),M=await Promise.all(B.map(ne=>this.runControllerTestRequest(ne,!0,x.token)));return!$.isCancellationRequested&&!M.some(ne=>ne.error)&&await new Promise(ne=>$.onCancellationRequested(ne)),x.dispose(!0),M}async runControllerTestRequest(B,$,x){const M=this.controllers.get(B.controllerId);if(!M)return{};const{collection:ne,profiles:Q,extension:we}=M,_e=Q.get(B.profileId);if(!_e)return{};const Ae=B.testIds.map(ae=>ne.tree.get(ae)).filter(D.isDefined),Y=B.excludeExtIds.map(ae=>M.collection.tree.get(ae)).filter(D.isDefined).filter(ae=>Ae.some(J=>J.fullId.compare(ae.fullId)===2));if(!Ae.length)return{};const he=new i.TestRunRequest(Ae.some(ae=>ae.actual instanceof d.TestItemRootImpl)?void 0:Ae.map(ae=>ae.actual),Y.map(ae=>ae.actual),_e,$),ke=(0,C.isStartControllerTests)(B)&&this.runTracker.prepareForMainThreadTestRun(he,w.fromInternal(B,M.collection),we,x);try{return await _e.runHandler(he,x),{}}catch(ae){return{error:String(ae)}}finally{ke&&(ke.hasRunningTasks&&!x.isCancellationRequested&&await T.Event.toPromise(ke.onEnd),ke.dispose())}}$cancelExtensionTestRun(B){B===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(B)}};e.ExtHostTesting=n,e.ExtHostTesting=n=Ve([ze(0,v.IExtHostRpcService)],n);const a=1e4;var r;(function(H){H[H.Running=0]="Running",H[H.Cancelling=1]="Cancelling",H[H.Ended=2]="Ended"})(r||(r={}));class s extends m.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(B,$,x,M){super(),this.dto=B,this.proxy=$,this.extension=x,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new L.CancellationTokenSource(M));const ne=this._register(new A.RunOnceScheduler(()=>this.forciblyEndTasks(),a));this._register(this.cts.token.onCancellationRequested(()=>ne.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(B){return this.tasks.get(B)?.coverage}createRun(B){const $=this.dto.id,x=this.dto.controllerId,M=(0,l.generateUuid)(),ne=new _(this.proxy,$,M),Q=Y=>(he,...ke)=>{if(_e){console.warn(`Setting the state of test "${he.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(he)&&(this.ensureTestIsKnown(he),Y(he,...ke))},we=(Y,he)=>{const ke=he instanceof Array?he.map(t.TestMessage.from):[t.TestMessage.from(he)];if(ke.some(ae=>ae.contextValue!==void 0)&&(0,k.checkProposedApiEnabled)(this.extension,"testMessageContextValue"),Y.uri&&Y.range){const ae={range:t.Range.from(Y.range),uri:Y.uri};for(const J of ke)J.location=J.location||ae}this.proxy.$appendTestMessagesInRun($,M,c.TestId.fromExtHostTestItem(Y,x).toString(),ke)};let _e=!1;const Ae={isPersisted:this.dto.isPersisted,token:this.cts.token,name:B,get coverageProvider(){return ne.coverageProvider},set coverageProvider(Y){ne.coverageProvider=Y},enqueued:Q(Y=>{this.proxy.$updateTestStateInRun($,M,c.TestId.fromExtHostTestItem(Y,x).toString(),1)}),skipped:Q(Y=>{this.proxy.$updateTestStateInRun($,M,c.TestId.fromExtHostTestItem(Y,x).toString(),5)}),started:Q(Y=>{this.proxy.$updateTestStateInRun($,M,c.TestId.fromExtHostTestItem(Y,x).toString(),2)}),errored:Q((Y,he,ke)=>{we(Y,he),this.proxy.$updateTestStateInRun($,M,c.TestId.fromExtHostTestItem(Y,x).toString(),6,ke)}),failed:Q((Y,he,ke)=>{we(Y,he),this.proxy.$updateTestStateInRun($,M,c.TestId.fromExtHostTestItem(Y,x).toString(),4,ke)}),passed:Q((Y,he)=>{this.proxy.$updateTestStateInRun($,M,c.TestId.fromExtHostTestItem(Y,this.dto.controllerId).toString(),3,he)}),appendOutput:(Y,he,ke)=>{_e||(ke&&(this.dto.isIncluded(ke)?this.ensureTestIsKnown(ke):ke=void 0),this.proxy.$appendOutputToRun($,M,I.VSBuffer.fromString(Y),he&&t.location.from(he),ke&&c.TestId.fromExtHostTestItem(ke,x).toString()))},end:()=>{_e||(_e=!0,this.proxy.$finishedTestRunTask($,M),this.tasks.delete(M),this.tasks.size||this.markEnded())}};return this.tasks.set(M,{run:Ae,coverage:ne}),this.proxy.$startedTestRunTask($,{id:M,name:B,running:!0}),Ae}forciblyEndTasks(){for(const{run:B}of this.tasks.values())B.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(B){if(!(B instanceof d.TestItemImpl))throw new f.InvalidTestItemError(B.id);if(this.sharedTestIds.has(c.TestId.fromExtHostTestItem(B,this.dto.controllerId).toString()))return;const $=[],x=this.dto.colllection.root;for(;;){const M=t.TestItem.from(B);if($.unshift(M),this.sharedTestIds.has(M.extId)||(this.sharedTestIds.add(M.extId),B===x))break;B=B.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,$)}}class b{get trackers(){return this.tracked.values()}constructor(B){this.proxy=B,this.tracked=new Map}prepareForMainThreadTestRun(B,$,x,M){return this.getTracker(B,$,x,M)}cancelRunById(B){for(const $ of this.tracked.values())if($.id===B){$.cancel();return}}cancelAllRuns(){for(const B of this.tracked.values())B.cancel()}createTestRun(B,$,x,M,ne,Q){const we=this.tracked.get(M);if(we)return we.createRun(ne);const _e=w.fromPublic($,x,M,Q),Ae=p(M);this.proxy.$startedExtensionTestRun({controllerId:$,continuous:!!M.continuous,profile:Ae&&{group:z[Ae.kind],id:Ae.profileId},exclude:M.exclude?.map(he=>c.TestId.fromExtHostTestItem(he,x.root.id).toString())??[],id:_e.id,include:M.include?.map(he=>c.TestId.fromExtHostTestItem(he,x.root.id).toString())??[x.root.id],persist:Q});const Y=this.getTracker(M,_e,B);return Y.onEnd(()=>{this.proxy.$finishedExtensionTestRun(_e.id),Y.dispose()}),Y.createRun(ne)}getTracker(B,$,x,M){const ne=new s($,this.proxy,x,M);return this.tracked.set(B,ne),ne.onEnd(()=>this.tracked.delete(B)),ne}}e.TestRunCoordinator=b;const p=H=>{if(H.profile){if(!(H.profile instanceof O))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return H.profile}};class w{static fromPublic(B,$,x,M){return new w(B,(0,l.generateUuid)(),x.include?.map(ne=>c.TestId.fromExtHostTestItem(ne,B).toString())??[B],x.exclude?.map(ne=>c.TestId.fromExtHostTestItem(ne,B).toString())??[],M,$)}static fromInternal(B,$){return new w(B.controllerId,B.runId,B.testIds,B.excludeExtIds,!0,$)}constructor(B,$,x,M,ne,Q){this.controllerId=B,this.id=$,this.isPersisted=ne,this.colllection=Q,this.includePrefix=x.map(we=>we+"\0"),this.excludePrefix=M.map(we=>we+"\0")}isIncluded(B){const $=c.TestId.fromExtHostTestItem(B,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if($===x||$.startsWith(x))return!1;for(const x of this.includePrefix)if($===x||$.startsWith(x))return!0;return!1}}e.TestRunDto=w;class _{set coverageProvider(B){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");B&&(this._coverageProvider=B,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(B,$,x){this.proxy=B,this.runId=$,this.taskId=x}async provideFileCoverage(B){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(B))());try{return(await this.fileCoverage)?.map(t.TestCoverage.fromFile)??[]}catch($){throw this.fileCoverage=void 0,$}}async resolveFileCoverage(B,$){const x=await this.fileCoverage;let M=x?.[B];return!this._coverageProvider||!x||!M?[]:(M.detailedCoverage||(M=x[B]=await this._coverageProvider.resolveFileCoverage?.(M,$)??M),M.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class o{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(B){this.emitter=B,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(B){this.added.add(B)}update(B){Object.assign(B.revived,t.TestItem.toPlain(B.item)),this.added.has(B)||this.updated.add(B)}remove(B){if(this.added.has(B)){this.added.delete(B);return}this.updated.delete(B);const $=c.TestId.parentId(B.item.extId);if($&&this.alreadyRemoved.has($.toString())){this.alreadyRemoved.add(B.item.extId);return}this.removed.add(B)}getChangeEvent(){const{added:B,updated:$,removed:x}=this;return{get added(){return[...B].map(M=>M.revived)},get updated(){return[...$].map(M=>M.revived)},get removed(){return[...x].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class u extends C.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(B){return this.items.get(B)}getMirroredTestDataByReference(B){return this.items.get(B.id)}createItem(B,$){return{...B,revived:t.TestItem.toPlain(B.item),depth:$?$.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}class g{constructor(B){this.proxy=B}checkout(){this.current||(this.current=this.createObserverData());const B=this.current;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map($=>$.revived)},dispose:(0,h.once)(()=>{--B.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(B){return this.current?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.current?.tests.apply(B)}createObserverData(){const B=new u;return this.proxy.$subscribeToDiffs(),{observers:0,tests:B}}}class O{#e;#t;get label(){return this._label}set label(B){B!==this._label&&(this._label=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:B}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(B){B!==this._supportsContinuousRun&&(this._supportsContinuousRun=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:B}))}get isDefault(){return this._isDefault}set isDefault(B){B!==this._isDefault&&(this._isDefault=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:B?t.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(B){B!==this._configureHandler&&(this._configureHandler=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!B}))}constructor(B,$,x,M,ne,Q,we,_e=!1,Ae=void 0,Y=!1){this.controllerId=x,this.profileId=M,this._label=ne,this.kind=Q,this.runHandler=we,this._isDefault=_e,this._tag=Ae,this._supportsContinuousRun=Y,this.#e=B,this.#t=$,$.set(M,this);const he=z[Q];if(typeof he!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);this.#e.$publishTestRunProfile({profileId:M,controllerId:x,tag:Ae?t.TestTag.namespace(this.controllerId,Ae.id):null,label:ne,group:he,isDefault:_e,hasConfigurationHandler:!1,supportsContinuousRun:Y})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=O;const z={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Pe[253],Te([1,0,18,9,5,3,106,8,7]),function(ve,e,S,A,I,L,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class m{constructor(D,l){this._extHostDocumentsAndEditors=l,this._onDidChangeTextEditorSelection=new I.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new I.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new I.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new I.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new I.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new I.Emitter({onListenerError:A.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=D.getProxy(L.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(E=>this._onDidChangeVisibleTextEditors.fire(E)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(E=>this._onDidChangeActiveTextEditor.fire(E))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(D){const l=this._extHostDocumentsAndEditors.allEditors();return D?l:l.map(E=>E.value)}async showTextDocument(D,l,E){let v;typeof l=="number"?v={position:h.ViewColumn.from(l),preserveFocus:E}:typeof l=="object"?v={position:h.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selection:typeof l.selection=="object"?h.Range.from(l.selection):void 0,pinned:typeof l.preview=="boolean"?!l.preview:void 0}:v={preserveFocus:!1};const d=await this._proxy.$tryShowTextDocument(D.uri,v),t=d&&this._extHostDocumentsAndEditors.getEditor(d);if(t)return t.value;throw d?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,l){return new T.TextEditorDecorationType(this._proxy,D,l).value}$acceptEditorPropertiesChanged(D,l){const E=this._extHostDocumentsAndEditors.getEditor(D);if(!E)throw new Error("unknown text editor");if(l.options&&E._acceptOptions(l.options),l.selections){const v=l.selections.selections.map(h.Selection.to);E._acceptSelections(v)}if(l.visibleRanges){const v=S.coalesce(l.visibleRanges.map(h.Range.to));E._acceptVisibleRanges(v)}if(l.options&&this._onDidChangeTextEditorOptions.fire({textEditor:E.value,options:{...l.options,lineNumbers:h.TextEditorLineNumbersStyle.to(l.options.lineNumbers)}}),l.selections){const v=y.TextEditorSelectionChangeKind.fromValue(l.selections.source),d=l.selections.selections.map(h.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:E.value,selections:d,kind:v})}if(l.visibleRanges){const v=S.coalesce(l.visibleRanges.map(h.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:E.value,visibleRanges:v})}}$acceptEditorPositionData(D){for(const l in D){const E=this._extHostDocumentsAndEditors.getEditor(l);if(!E)throw new Error("Unknown text editor");const v=h.ViewColumn.to(D[l]);E.value.viewColumn!==v&&(E._acceptViewColumn(v),this._onDidChangeTextEditorViewColumn.fire({textEditor:E.value,viewColumn:v}))}}getDiffInformation(D){return Promise.resolve(this._proxy.$getDiffInformation(D))}}e.ExtHostEditors=m}),define(Pe[254],Te([1,0,2,4,3,6,7,8,20,16]),function(ve,e,S,A,I,L,T,h,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class P{constructor(E,v){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=E.getProxy(I.MainContext.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(d,t)=>{if(d&&d.$mid===12)if(this._providers.get(d.source)&&y.ExtensionIdentifier.equals(t,this._providers.get(d.source)?.extension)){const i=d.uri===void 0?void 0:S.URI.revive(d.uri);return this._itemsBySourceAndUriMap.get(d.source)?.get(D(i))?.get(d.handle)}else return;return d}})}async $getTimeline(E,v,d,t){return this._providers.get(E)?.provider.provideTimeline(S.URI.revive(v),d,t)}registerTimelineProvider(E,v,d,t){const i=new L.DisposableStore,c=this.convertTimelineItem(v.id,t,i).bind(this);let f;v.onDidChange&&(f=v.onDidChange(k=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...k,id:v.id}),this));const C=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...v,scheme:E,onDidChange:void 0,async provideTimeline(k,n,a){n?.resetCache&&(i.clear(),C.get(v.id)?.clear());const r=await v.provideTimeline(k,n,a);if(r==null)return;const s=c(k,n);return{...r,source:v.id,items:r.items.map(s)}},dispose(){for(const k of C.values())k.get(v.id)?.clear();f?.dispose(),i.dispose()}},d)}convertTimelineItem(E,v,d){return(t,i)=>{let c;if(i?.cacheResults){let f=this._itemsBySourceAndUriMap.get(E);f===void 0&&(f=new Map,this._itemsBySourceAndUriMap.set(E,f));const C=D(t);c=f.get(C),c===void 0&&(c=new Map,f.set(C,c))}return f=>{const{iconPath:C,...k}=f,n=`${E}|${f.id??f.timestamp}`;c?.set(n,f);let a,r,s;f.iconPath&&(C instanceof T.ThemeIcon?s={id:C.id,color:C.color}:S.URI.isUri(C)?(a=C,r=C):{light:a,dark:r}=C);let b;return T.MarkdownString.isMarkdownString(k.tooltip)?b=h.MarkdownString.from(k.tooltip):(0,m.isString)(k.tooltip)?b=k.tooltip:T.MarkdownString.isMarkdownString(k.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=h.MarkdownString.from(k.detail)):(0,m.isString)(k.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=k.detail),{...k,id:k.id??void 0,handle:n,source:E,command:f.command?v.toInternal(f.command,d):void 0,icon:a,iconDark:r,themeIcon:s,tooltip:b,accessibilityInformation:f.accessibilityInformation}}}}registerTimelineProviderCore(E,v){if(this._providers.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this._proxy.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this._providers.set(E.id,{provider:E,extension:v}),(0,L.toDisposable)(()=>{for(const t of this._itemsBySourceAndUriMap.values())t.get(E.id)?.clear();this._providers.delete(E.id),this._proxy.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=P;function D(l){return l?.toString()}}),define(Pe[86],Te([1,0,21,5,6,158,4,14,185,3,27,17,7]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class E extends y.DisposableTunnel{}var v;(function(t){function i(f){return{remoteAddress:f.remoteAddress,localAddress:f.localAddress,public:!!f.public,privacy:f.privacy??(f.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:f.protocol}}t.fromApiTunnel=i;function c(f){return{remoteAddress:{host:f.tunnelRemoteHost,port:f.tunnelRemotePort},localAddress:f.localAddress,public:f.privacy!==y.TunnelPrivacyId.ConstantPrivate&&f.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:f.privacy,protocol:f.protocol}}t.fromServiceTunnel=c})(v||(e.TunnelDtoConverter=v={})),e.IExtHostTunnelService=(0,T.createDecorator)("IExtHostTunnelService");let d=class extends I.Disposable{constructor(i,c,f){super(),this.logService=f,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new A.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=i.getProxy(m.MainContext.MainThreadTunnelService)}async openTunnel(i,c){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const f=await this._proxy.$openTunnel(c,i.displayName);if(f){const C=new E(f.remoteAddress,f.localAddress,()=>this._proxy.$closeTunnel(f.remoteAddress));return this._register(C),C}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(i,c){const f=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(f,{selector:i,provider:c}),this._proxy.$registerPortsAttributesProvider(i,f),new l.Disposable(()=>{this._portAttributesProviders.delete(f),this._proxy.$unregisterPortsAttributesProvider(f)})}async $providePortAttributes(i,c,f,C,k){const n=[];for(const r of i){const s=this._portAttributesProviders.get(r);if(!s)return[];n.push(...await Promise.all(c.map(async b=>{let p;try{p=await s.provider.providePortAttributes({port:b,pid:f,commandLine:C},k)}catch{p=await s.provider.providePortAttributes(b,f,C,k)}return{providedAttributes:p,port:b}})))}const a=n.filter(r=>!!r.providedAttributes);return a.length>0?a.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,c){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(C,k)=>await i.provideTunnel(C,k,new S.CancellationTokenSource().token)??void 0;const f=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this._proxy.$setTunnelProvider(f),Promise.resolve((0,I.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,c){if(i){i.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this._showCandidatePort=i.showCandidatePort,this._proxy.$setCandidateFilter());const f=i.tunnelFactory??(c?this.makeManagedTunnelFactory(c):void 0);if(f){this._forwardPortProvider=f;let C=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&C.length===0&&(C=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const k=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:C}:void 0;this._proxy.$setTunnelProvider(k)}}else this._forwardPortProvider=void 0;return(0,I.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(i){}async $closeTunnel(i,c){if(this._extensionTunnels.has(i.host)){const f=this._extensionTunnels.get(i.host);f.has(i.port)&&(c&&f.get(i.port).disposeListener.dispose(),await f.get(i.port).tunnel.dispose(),f.delete(i.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(i,c){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const f=this._forwardPortProvider(i,c);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),f!==void 0){const C=await f;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),C===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(i.remoteAddress.host)||this._extensionTunnels.set(i.remoteAddress.host,new Map);const k=this._register(C.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(C.remoteAddress))));return this._extensionTunnels.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:C,disposeListener:k}),v.fromApiTunnel(C)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(f){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),f instanceof Error)return f.message}}async $applyCandidateFilter(i){const c=await Promise.all(i.map(C=>this._showCandidatePort(C.host,C.port,C.detail??""))),f=i.filter((C,k)=>c[k]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(C=>C.port).join(", ")} to ${f.map(C=>C.port).join(", ")}`),f}};e.ExtHostTunnelService=d,e.ExtHostTunnelService=d=Ve([ze(0,D.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,h.ILogService)],d)}),define(Pe[255],Te([1,0,6,12,2,3]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{static{this.supportedSchemes=new Set([A.Schemas.http,A.Schemas.https])}constructor(y){this._openers=new Map,this._proxy=y.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,m,P,D){if(this._openers.has(m))throw new Error(`Opener with id '${m}' already registered`);const l=D.schemes.find(E=>!T.supportedSchemes.has(E));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(m,P),this._proxy.$registerUriOpener(m,D.schemes,y,D.label),(0,S.toDisposable)(()=>{this._openers.delete(m),this._proxy.$unregisterUriOpener(m)})}async $canOpenUri(y,m,P){const D=this._openers.get(y);if(!D)throw new Error(`Unknown opener with id: ${y}`);const l=I.URI.revive(m);return D.canOpenExternalUri(l,P)}async $openUri(y,m,P){const D=this._openers.get(y);if(!D)throw new Error(`Unknown opener id: '${y}'`);return D.openExternalUri(I.URI.revive(m.resolvedUri),{sourceUri:I.URI.revive(m.sourceUri)},P)}}e.ExtHostUriOpeners=T}),define(Pe[256],Te([1,0,3,2,6,9,20]),function(ve,e,S,A,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class h{static{this.HandlePool=0}constructor(m){this.handles=new T.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=m.getProxy(S.MainContext.MainThreadUrls)}registerUriHandler(m,P){const D=m.identifier;if(this.handles.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const l=h.HandlePool++;return this.handles.add(D),this.handlers.set(l,P),this._proxy.$registerUriHandler(l,D,m.displayName||m.name),(0,I.toDisposable)(()=>{this.handles.delete(D),this.handlers.delete(l),this._proxy.$unregisterUriHandler(l)})}$handleExternalUri(m,P){const D=this.handlers.get(m);if(!D)return Promise.resolve(void 0);try{D.handleUri(A.URI.revive(P))}catch(l){(0,L.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(m){return A.URI.revive(await this._proxy.$createAppUri(m))}}e.ExtHostUrls=h}),define(Pe[64],Te([1,0,5,12,24,2,170,192,77,3]),function(ve,e,S,A,I,L,T,h,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class P{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;constructor(f,C,k,n,a,r,s){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new S.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new S.Emitter,this._onDidDispose=this.#d.event,this.#e=f,this.#t=C,this.#r=k,this.#u=n,this.#l=a,this.#n=r,this.#c=D(r),this.#h=l(r),this.#i=s}#d;dispose(){this.#o=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return this.#a=!0,(0,y.asWebviewUri)(f,this.#u)}get cspSource(){const f=this.#n.extensionLocation;if(f.scheme===A.Schemas.https||f.scheme===A.Schemas.http){let C=f.toString();return C.endsWith("/")||(C+="/"),C+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#s}set html(f){this.assertNotDisposed(),this.#s!==f&&(this.#s=f,this.#h&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(f)))}get options(){return this.assertNotDisposed(),this.#r}set options(f){this.assertNotDisposed(),I.equals(this.#r,f)||this.#t.$setOptions(this.#e,d(this.#n,this.#l,f)),this.#r=f}async postMessage(f){if(this.#o)return!1;const C=(0,h.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,C.message,...C.buffers)}assertNotDisposed(){if(this.#o)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(f){if(!this.#h)return f;const C=this.#n.extensionLocation?.scheme===A.Schemas.vscodeRemote,k=this.#n.extensionLocation.scheme===A.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return f.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,a,r,s,b,p)=>{const w=L.URI.from({scheme:s||"file",path:decodeURIComponent(b)}),_=(0,y.asWebviewUri)(w,{isRemote:C,authority:k}).toString();return`${a}${_}${p}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,a,r,s,b,p)=>{const w=L.URI.from({scheme:s||"file",path:decodeURIComponent(b)}),_=(0,y.asWebviewUri)(w,{isRemote:C,authority:k}).toString();return`${a}${_}${p}`})}}e.ExtHostWebview=P;function D(c){try{const f=(0,T.normalizeVersion)((0,T.parseVersion)(c.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=D;function l(c){try{const f=(0,T.normalizeVersion)((0,T.parseVersion)(c.engines.vscode));return f?f.majorBase<1||f.majorBase===1&&f.minorBase<60:!1}catch{return!1}}class E{constructor(f,C,k,n,a){this.remoteInfo=C,this.workspace=k,this._logService=n,this._deprecationService=a,this._webviews=new Map,this._webviewProxy=f.getProxy(m.MainContext.MainThreadWebviews)}$onMessage(f,C,k){const n=this.getWebview(f);if(n){const{message:a}=(0,h.deserializeWebviewMessage)(C,k.value);n._onMessageEmitter.fire(a)}}$onMissingCsp(f,C){this._logService.warn(`${C} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,C,k){const n=new P(f,this._webviewProxy,t(C),this.remoteInfo,this.workspace,k,this._deprecationService);return this._webviews.set(f,n),n._onDidDispose(()=>{this._webviews.delete(f)}),n}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=E;function v(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=v;function d(c,f,C){return{enableCommandUris:C.enableCommandUris,enableScripts:C.enableScripts,enableForms:C.enableForms,portMapping:C.portMapping,localResourceRoots:C.localResourceRoots||i(c,f)}}e.serializeWebviewOptions=d;function t(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(f=>L.URI.from(f))}}function i(c,f){return[...(f?.getWorkspaceFolders()||[]).map(C=>C.uri),c.extensionLocation]}}),define(Pe[257],Te([1,0,21,93,6,12,23,2,8,64,55,3,7]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(a,r){this.document=a,this._storagePath=r,this._backupCounter=1,this._edits=new P.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,r){await this.getEdit(a).undo(),r||this.disposeBackup()}async redo(a,r){await this.getEdit(a).redo(),r||this.disposeBackup()}disposeEdits(a){for(const r of a)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=k(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const r=this._edits.get(a,0);if(!r)throw new Error("No edit found");return r}}class v{constructor(){this._documents=new Map}get(a,r){return this._documents.get(this.key(a,r))}add(a,r,s){const b=this.key(a,r.uri);if(this._documents.has(b))throw new Error(`Document already exists for viewType:${a} resource:${r.uri}`);const p=new E(r,s);return this._documents.set(b,p),p}delete(a,r){const s=this.key(a,r.uri);this._documents.delete(s)}key(a,r){return`${a}@@@${r}`}}var d;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(d||(d={}));class t{constructor(){this._providers=new Map}addTextProvider(a,r,s){return this.add(0,a,r,s)}addCustomProvider(a,r,s){return this.add(1,a,r,s)}get(a){return this._providers.get(a)}add(a,r,s,b){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:a,extension:s,provider:b}),new l.Disposable(()=>this._providers.delete(r))}}class i{constructor(a,r,s,b,p){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=b,this._extHostWebviewPanels=p,this._editorProviders=new t,this._documents=new v,this._proxy=a.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,r,s,b){const p=new I.DisposableStore;return f(s)?(p.add(this._editorProviders.addTextProvider(r,a,s)),this._proxy.$registerTextEditorProvider((0,m.toExtensionData)(a),r,b.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,m.shouldSerializeBuffersForPostMessage)(a))):(p.add(this._editorProviders.addCustomProvider(r,a,s)),c(s)&&p.add(s.onDidChangeCustomDocument(w=>{const _=this.getCustomDocumentEntry(r,w.document.uri);if(C(w)){const o=_.addEdit(w);this._proxy.$onDidEdit(w.document.uri,r,o,w.label)}else this._proxy.$onContentChange(w.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,m.toExtensionData)(a),r,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,m.shouldSerializeBuffersForPostMessage)(a))),l.Disposable.from(p,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(a,r,s,b,p){const w=this._editorProviders.get(r);if(!w)throw new Error(`No provider found for '${r}'`);if(w.type!==1)throw new Error(`Invalid provide type for '${r}'`);const _=h.URI.revive(a),o=await w.provider.openCustomDocument(_,{backupId:s,untitledDocumentData:b?.buffer},p);let u;return c(w.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(w.extension)??this._extensionStoragePaths.globalValue(w.extension)),this._documents.add(r,o,u),{editable:c(w.provider)}}async $disposeCustomDocument(a,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const b=h.URI.revive(a),{document:p}=this.getCustomDocumentEntry(r,b);this._documents.delete(r,p),p.dispose()}async $resolveCustomEditor(a,r,s,b,p,w){const _=this._editorProviders.get(s);if(!_)throw new Error(`No provider found for '${s}'`);const o=y.ViewColumn.to(p),u=this._extHostWebview.createNewWebview(r,b.contentOptions,_.extension),g=this._extHostWebviewPanels.createNewWebviewPanel(r,s,b.title,o,b.options,u,b.active),O=h.URI.revive(a);switch(_.type){case 1:{const{document:z}=this.getCustomDocumentEntry(s,O);return _.provider.resolveCustomEditor(z,g,w)}case 0:{const z=this._extHostDocuments.getDocument(O);return _.provider.resolveCustomTextEditor(z,g,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,r,s){this.getCustomDocumentEntry(r,a).disposeEdits(s)}async $onMoveCustomEditor(a,r,s){const b=this._editorProviders.get(s);if(!b)throw new Error(`No provider found for '${s}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const p=this._extHostWebviewPanels.getWebviewPanel(a);if(!p)throw new Error("No webview found");const w=h.URI.revive(r),_=this._extHostDocuments.getDocument(w);await b.provider.moveCustomTextEditor(_,p,S.CancellationToken.None)}async $undo(a,r,s,b){return this.getCustomDocumentEntry(r,a).undo(s,b)}async $redo(a,r,s,b){return this.getCustomDocumentEntry(r,a).redo(s,b)}async $revert(a,r,s){const b=this.getCustomDocumentEntry(r,a);await this.getCustomEditorProvider(r).revertCustomDocument(b.document,s),b.disposeBackup()}async $onSave(a,r,s){const b=this.getCustomDocumentEntry(r,a);await this.getCustomEditorProvider(r).saveCustomDocument(b.document,s),b.disposeBackup()}async $onSaveAs(a,r,s,b){const p=this.getCustomDocumentEntry(r,a);return this.getCustomEditorProvider(r).saveCustomDocumentAs(p.document,h.URI.revive(s),b)}async $backup(a,r,s){const b=this.getCustomDocumentEntry(r,a),w=await this.getCustomEditorProvider(r).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},s);return b.updateBackup(w),w.id}getCustomDocumentEntry(a,r){const s=this._documents.get(a,h.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(a){const s=this._editorProviders.get(a)?.provider;if(!s||!c(s))throw new Error("Custom document is not editable");return s}}e.ExtHostCustomEditors=i;function c(n){return!!n.onDidChangeCustomDocument}function f(n){return typeof n.resolveCustomTextEditor=="function"}function C(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function k(n){const a=n.scheme===L.Schemas.file||n.scheme===L.Schemas.untitled?n.fsPath:n.toString();return(0,A.hash)(a)+""}}),define(Pe[258],Te([1,0,5,6,2,36,8,64,3,7]),function(ve,e,S,A,I,L,T,h,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class P extends A.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;#d;constructor(v,d,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#h=this._register(new S.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new S.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=v,this.#t=d,this.#u=t,this.#i=i.viewType,this.#l=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#u.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#u}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#n}set title(v){this.assertNotDisposed(),this.#n!==v&&(this.#n=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.assertNotDisposed(),this.#s}set iconPath(v){this.assertNotDisposed(),this.#s!==v&&(this.#s=v,this.#t.$setIconPath(this.#e,I.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#l}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.assertNotDisposed(),this.#a}get visible(){return this.assertNotDisposed(),this.#o}_updateViewState(v){this.#c||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#a=v.active,this.#o=v.visible,this.#r=v.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(v,d){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:T.ViewColumn.from(v),preserveFocus:!!d})}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}}class D{static newHandle(){return(0,L.generateUuid)()}constructor(v,d,t){this.webviews=d,this.workspace=t,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=v.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(v,d,t,i,c={}){const f=typeof i=="object"?i.viewColumn:i,C={viewColumn:T.ViewColumn.from(f),preserveFocus:typeof i=="object"&&!!i.preserveFocus},k=(0,h.shouldSerializeBuffersForPostMessage)(v),n=D.newHandle();this._proxy.$createWebviewPanel((0,h.toExtensionData)(v),n,d,{title:t,panelOptions:l(c),webviewOptions:(0,h.serializeWebviewOptions)(v,this.workspace,c),serializeBuffersForPostMessage:k},C);const a=this.webviews.createNewWebview(n,c,v);return this.createNewWebviewPanel(n,d,t,f,c,a,!0)}$onDidChangeWebviewPanelViewStates(v){const d=Object.keys(v);d.sort((t,i)=>{const c=v[t],f=v[i];return c.active?1:f.active?-1:+c.visible-+f.visible});for(const t of d){const i=this.getWebviewPanel(t);if(!i)continue;const c=v[t];i._updateViewState({active:c.active,visible:c.visible,viewColumn:T.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this._webviewPanels.delete(v),this.webviews.deleteWebview(v)}registerWebviewPanelSerializer(v,d,t){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:t,extension:v}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,h.shouldSerializeBuffersForPostMessage)(v)}),new m.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(v,d,t,i){const c=this._serializers.get(d);if(!c)throw new Error(`No serializer found for '${d}'`);const{serializer:f,extension:C}=c,k=this.webviews.createNewWebview(v,t.webviewOptions,C),n=this.createNewWebviewPanel(v,d,t.title,i,t.panelOptions,k,t.active);await f.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel(v,d,t,i,c,f,C){const k=new P(v,this._proxy,f,{viewType:d,title:t,viewColumn:i,panelOptions:c,active:C});return this._webviewPanels.set(v,k),k}getWebviewPanel(v){return this._webviewPanels.get(v)}}e.ExtHostWebviewPanels=D;function l(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Pe[259],Te([1,0,5,6,64,8,3,7]),function(ve,e,S,A,I,L,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends A.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;constructor(D,l,E,v,d,t){super(),this.#l=!1,this.#a=this._register(new S.Emitter),this.onDidChangeVisibility=this.#a.event,this.#c=this._register(new S.Emitter),this.onDidDispose=this.#c.event,this.#i=E,this.#s=v,this.#e=D,this.#t=l,this.#u=d,this.#n=t}dispose(){this.#l||(this.#l=!0,this.#c.fire(),this.#u.dispose(),super.dispose())}#a;#c;get title(){return this.assertNotDisposed(),this.#s}set title(D){this.assertNotDisposed(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.assertNotDisposed(),this.#r}set description(D){this.assertNotDisposed(),this.#r!==D&&(this.#r=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#u}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#l||(this.#n=D,this.#a.fire())}get badge(){return this.assertNotDisposed(),this.#o}set badge(D){this.assertNotDisposed(),!(D?.value===this.#o?.value&&D?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.assertNotDisposed(),this.#t.$show(this.#e,!!D)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}}class m{constructor(D,l){this._extHostWebview=l,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(D,l,E,v){if(this._viewProviders.has(l))throw new Error(`View provider for '${l}' already registered`);return this._viewProviders.set(l,{provider:E,extension:D}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(D),l,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(D)}),new h.Disposable(()=>{this._viewProviders.delete(l),this._proxy.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(D,l,E,v,d){const t=this._viewProviders.get(l);if(!t)throw new Error(`No view provider found for '${l}'`);const{provider:i,extension:c}=t,f=this._extHostWebview.createNewWebview(D,{},c),C=new y(D,this._proxy,l,E,f,!0);this._webviewViews.set(D,C),await i.resolveWebviewView(C,{state:v},d)}async $onDidChangeWebviewViewVisibility(D,l){this.getWebviewView(D)._setVisible(l)}async $disposeWebviewView(D){const l=this.getWebviewView(D);this._webviewViews.delete(D),l.dispose(),this._extHostWebview.deleteWebview(D)}getWebviewView(D){const l=this._webviewViews.get(D);if(!l)throw new Error("No webview found");return l}}e.ExtHostWebviewViews=m}),define(Pe[109],Te([1,0,5,3,2,12,15,4,17,26]),function(ve,e,S,A,I,L,T,h,y,m){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class{static{P=this}static{this.InitialState={focused:!0,active:!0}}getState(E){const v=this._state;return{get focused(){return v.focused},get active(){return(0,m.checkProposedApiEnabled)(E,"windowActivity"),v.active}}}constructor(E){this._onDidChangeWindowState=new S.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=P.InitialState,this._proxy=E.getProxy(A.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:v,isActive:d})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,v){v!==this._state[E]&&(this._state={...this._state,[E]:v},this._onDidChangeWindowState.fire(this._state))}openUri(E,v){let d;if(typeof E=="string"){d=E;try{E=I.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,T.isFalsyOrWhitespace)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this._proxy.$openUri(E,d,v)}async asExternalUri(E,v){if((0,T.isFalsyOrWhitespace)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this._proxy.$asExternalUri(E,v);return I.URI.from(d)}};e.ExtHostWindow=D,e.ExtHostWindow=D=P=Ve([ze(0,y.IExtHostRpcService)],D),e.IExtHostWindow=(0,h.createDecorator)("IExtHostWindow")}),define(Pe[260],Te([1,0,227,27,17]),function(ve,e,S,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let L=class extends S.AbstractExtHostConsoleForwarder{constructor(h,y){super(h,y)}_nativeConsoleLogMessage(h,y,m){y.apply(console,m)}};e.ExtHostConsoleForwarder=L,e.ExtHostConsoleForwarder=L=Ve([ze(0,I.IExtHostRpcService),ze(1,A.IExtHostInitDataService)],L)}),define(Pe[261],Te([1,0,13,25,21,9,5,6,133,216,46]),function(ve,e,S,A,I,L,T,h,y,m,P){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function l(u,g){try{return JSON.stringify(u,g)}catch{return"null"}}const E="$$ref$$",v={[E]:-1};class d{constructor(g,O){this.jsonString=g,this.referencedBuffers=O}}function t(u,g=null,O=!1){const z=[];return{jsonString:(O?l:JSON.stringify)(u,(B,$)=>{if(typeof $>"u")return v;if(typeof $=="object"){if($ instanceof A.VSBuffer){const x=z.push($)-1;return{[E]:x}}if(g)return g(B,$)}return $}),referencedBuffers:z}}e.stringifyJsonWithBufferRefs=t;function i(u,g,O){return JSON.parse(u,(z,H)=>{if(H){const B=H[E];if(typeof B=="number")return g[B];if(O&&H.$mid===1)return O.transformIncoming(H)}return H})}e.parseJsonAndRestoreBufferRefs=i;function c(u,g){return JSON.stringify(u,g)}function f(u){return u?(g,O)=>O&&O.$mid===1?u.transformOutgoing(O):O:null}var C;(function(u){u[u.LocalSide=0]="LocalSide",u[u.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));var k;(function(u){u[u.Responsive=0]="Responsive",u[u.Unresponsive=1]="Unresponsive"})(k||(e.ResponsiveState=k={}));const n=()=>{},a=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends h.Disposable{static{D=a}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(g,O=null,z=null){super(),this[D]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=g,this._logger=O,this._uriTransformer=z,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let H=0,B=P.ProxyIdentifier.count;H<B;H++)this._locals[H]=null,this._proxies[H]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new S.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(H=>this._receiveOneMessage(H))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(g=>{this._pendingRPCReplies[g].resolveErr(L.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(g){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(g){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(g){this._responsiveState!==g&&(this._responsiveState=g,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(g){return this._uriTransformer?(0,y.transformIncomingURIs)(g,this._uriTransformer):g}getProxy(g){const{nid:O,sid:z}=g;return this._proxies[O]||(this._proxies[O]=this._createProxy(O,z)),this._proxies[O]}_createProxy(g,O){const z={get:(H,B)=>(typeof B=="string"&&!H[B]&&B.charCodeAt(0)===36&&(H[B]=(...$)=>this._remoteCall(g,B,$)),B===r?O:H[B])};return new Proxy(Object.create(null),z)}set(g,O){return this._locals[g.nid]=O,O}assertRegistered(g){for(let O=0,z=g.length;O<z;O++){const H=g[O];if(!this._locals[H.nid])throw new Error(`Missing proxy instance ${H.sid}`)}}_receiveOneMessage(g){if(this._isDisposed)return;const O=g.byteLength,z=b.read(g,0),H=z.readUInt8(),B=z.readUInt32();switch(H){case 1:case 2:{let{rpcId:$,method:x,args:M}=w.deserializeRequestJSONArgs(z);this._uriTransformer&&(M=(0,y.transformIncomingURIs)(M,this._uriTransformer)),this._receiveRequest(O,B,$,x,M,H===2);break}case 3:case 4:{let{rpcId:$,method:x,args:M}=w.deserializeRequestMixedArgs(z);this._uriTransformer&&(M=(0,y.transformIncomingURIs)(M,this._uriTransformer)),this._receiveRequest(O,B,$,x,M,H===4);break}case 5:{this._logger?.logIncoming(O,B,0,"ack"),this._onDidReceiveAcknowledge(B);break}case 6:{this._receiveCancel(O,B);break}case 7:{this._receiveReply(O,B,void 0);break}case 9:{let $=w.deserializeReplyOKJSON(z);this._uriTransformer&&($=(0,y.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(O,B,$);break}case 10:{const $=w.deserializeReplyOKJSONWithBuffers(z,this._uriTransformer);this._receiveReply(O,B,$);break}case 8:{const $=w.deserializeReplyOKVSBuffer(z);this._receiveReply(O,B,$);break}case 11:{let $=w.deserializeReplyErrError(z);this._uriTransformer&&($=(0,y.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(O,B,$);break}case 12:{this._receiveReplyErr(O,B,void 0);break}default:console.error("received unexpected message"),console.error(g)}}_receiveRequest(g,O,z,H,B,$){this._logger?.logIncoming(g,O,1,`receiveRequest ${(0,P.getStringIdentifierForProxy)(z)}.${H}(`,B);const x=String(O);let M,ne;if($){const we=new I.CancellationTokenSource;B.push(we.token),M=this._invokeHandler(z,H,B),ne=()=>we.cancel()}else M=this._invokeHandler(z,H,B),ne=n;this._cancelInvokedHandlers[x]=ne;const Q=w.serializeAcknowledged(O);this._logger?.logOutgoing(Q.byteLength,O,1,"ack"),this._protocol.send(Q),M.then(we=>{delete this._cancelInvokedHandlers[x];const _e=w.serializeReplyOK(O,we,this._uriReplacer);this._logger?.logOutgoing(_e.byteLength,O,1,"reply:",we),this._protocol.send(_e)},we=>{delete this._cancelInvokedHandlers[x];const _e=w.serializeReplyErr(O,we);this._logger?.logOutgoing(_e.byteLength,O,1,"replyErr:",we),this._protocol.send(_e)})}_receiveCancel(g,O){this._logger?.logIncoming(g,O,1,"receiveCancel");const z=String(O);this._cancelInvokedHandlers[z]?.()}_receiveReply(g,O,z){this._logger?.logIncoming(g,O,0,"receiveReply:",z);const H=String(O);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const B=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H],B.resolveOk(z)}_receiveReplyErr(g,O,z){this._logger?.logIncoming(g,O,0,"receiveReplyErr:",z);const H=String(O);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const B=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H];let $;z&&(z.$isError?($=new Error,$.name=z.name,$.message=z.message,$.stack=z.stack):$=z),B.resolveErr($)}_invokeHandler(g,O,z){try{return Promise.resolve(this._doInvokeHandler(g,O,z))}catch(H){return Promise.reject(H)}}_doInvokeHandler(g,O,z){const H=this._locals[g];if(!H)throw new Error("Unknown actor "+(0,P.getStringIdentifierForProxy)(g));const B=H[O];if(typeof B!="function")throw new Error("Unknown method "+O+" on actor "+(0,P.getStringIdentifierForProxy)(g));return B.apply(H,z)}_remoteCall(g,O,z){if(this._isDisposed)return new m.CanceledLazyPromise;let H=null;if(z.length>0&&I.CancellationToken.isCancellationToken(z[z.length-1])&&(H=z.pop()),H&&H.isCancellationRequested)return Promise.reject(L.canceled());const B=w.serializeRequestArguments(z,this._uriReplacer),$=++this._lastMessageId,x=String($),M=new m.LazyPromise;H&&H.onCancellationRequested(()=>{const Q=w.serializeCancel($);this._logger?.logOutgoing(Q.byteLength,$,0,"cancel"),this._protocol.send(w.serializeCancel($))}),this._pendingRPCReplies[x]=M,this._onWillSendRequest($);const ne=w.serializeRequest($,g,O,B,!!H);return this._logger?.logOutgoing(ne.byteLength,$,0,`request: ${(0,P.getStringIdentifierForProxy)(g)}.${O}(`,z),this._protocol.send(ne),M}}e.RPCProtocol=s;class b{static alloc(g,O,z){const H=new b(A.VSBuffer.alloc(z+1+4),0);return H.writeUInt8(g),H.writeUInt32(O),H}static read(g,O){return new b(g,O)}get buffer(){return this._buff}constructor(g,O){this._buff=g,this._offset=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(g){this._buff.writeUInt8(g,this._offset),this._offset+=1}readUInt8(){const g=this._buff.readUInt8(this._offset);return this._offset+=1,g}writeUInt32(g){this._buff.writeUInt32BE(g,this._offset),this._offset+=4}readUInt32(){const g=this._buff.readUInt32BE(this._offset);return this._offset+=4,g}static sizeShortString(g){return 1+g.byteLength}writeShortString(g){this._buff.writeUInt8(g.byteLength,this._offset),this._offset+=1,this._buff.set(g,this._offset),this._offset+=g.byteLength}readShortString(){const g=this._buff.readUInt8(this._offset);this._offset+=1;const z=this._buff.slice(this._offset,this._offset+g).toString();return this._offset+=g,z}static sizeLongString(g){return 4+g.byteLength}writeLongString(g){this._buff.writeUInt32BE(g.byteLength,this._offset),this._offset+=4,this._buff.set(g,this._offset),this._offset+=g.byteLength}readLongString(){const g=this._buff.readUInt32BE(this._offset);this._offset+=4;const z=this._buff.slice(this._offset,this._offset+g).toString();return this._offset+=g,z}writeBuffer(g){this._buff.writeUInt32BE(g.byteLength,this._offset),this._offset+=4,this._buff.set(g,this._offset),this._offset+=g.byteLength}static sizeVSBuffer(g){return 4+g.byteLength}writeVSBuffer(g){this._buff.writeUInt32BE(g.byteLength,this._offset),this._offset+=4,this._buff.set(g,this._offset),this._offset+=g.byteLength}readVSBuffer(){const g=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+g);return this._offset+=g,O}static sizeMixedArray(g){let O=0;O+=1;for(let z=0,H=g.length;z<H;z++){const B=g[z];switch(O+=1,B.type){case 1:O+=this.sizeLongString(B.value);break;case 2:O+=this.sizeVSBuffer(B.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(B.value);for(let $=0;$<B.buffers.length;++$)O+=this.sizeVSBuffer(B.buffers[$]);break;case 4:break}}return O}writeMixedArray(g){this._buff.writeUInt8(g.length,this._offset),this._offset+=1;for(let O=0,z=g.length;O<z;O++){const H=g[O];switch(H.type){case 1:this.writeUInt8(1),this.writeLongString(H.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(H.value);break;case 3:this.writeUInt8(3),this.writeUInt32(H.buffers.length),this.writeLongString(H.value);for(let B=0;B<H.buffers.length;++B)this.writeBuffer(H.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const g=this._buff.readUInt8(this._offset);this._offset+=1;const O=new Array(g);for(let z=0;z<g;z++)switch(this.readUInt8()){case 1:O[z]=this.readLongString();break;case 2:O[z]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),$=this.readLongString(),x=[];for(let M=0;M<B;++M)x.push(this.readVSBuffer());O[z]=new P.SerializableObjectWithBuffers(i($,x,null));break}case 4:O[z]=void 0;break}return O}}var p;(function(u){u[u.Simple=0]="Simple",u[u.Mixed=1]="Mixed"})(p||(p={}));class w{static _useMixedArgSerialization(g){for(let O=0,z=g.length;O<z;O++)if(g[O]instanceof A.VSBuffer||g[O]instanceof P.SerializableObjectWithBuffers||typeof g[O]>"u")return!0;return!1}static serializeRequestArguments(g,O){if(this._useMixedArgSerialization(g)){const z=[];for(let H=0,B=g.length;H<B;H++){const $=g[H];if($ instanceof A.VSBuffer)z[H]={type:2,value:$};else if(typeof $>"u")z[H]={type:4};else if($ instanceof P.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:M}=t($.value,O);z[H]={type:3,value:A.VSBuffer.fromString(x),buffers:M}}else z[H]={type:1,value:A.VSBuffer.fromString(c($,O))}}return{type:1,args:z}}return{type:0,args:c(g,O)}}static serializeRequest(g,O,z,H,B){switch(H.type){case 0:return this._requestJSONArgs(g,O,z,H.args,B);case 1:return this._requestMixedArgs(g,O,z,H.args,B)}}static _requestJSONArgs(g,O,z,H,B){const $=A.VSBuffer.fromString(z),x=A.VSBuffer.fromString(H);let M=0;M+=b.sizeUInt8(),M+=b.sizeShortString($),M+=b.sizeLongString(x);const ne=b.alloc(B?2:1,g,M);return ne.writeUInt8(O),ne.writeShortString($),ne.writeLongString(x),ne.buffer}static deserializeRequestJSONArgs(g){const O=g.readUInt8(),z=g.readShortString(),H=g.readLongString();return{rpcId:O,method:z,args:JSON.parse(H)}}static _requestMixedArgs(g,O,z,H,B){const $=A.VSBuffer.fromString(z);let x=0;x+=b.sizeUInt8(),x+=b.sizeShortString($),x+=b.sizeMixedArray(H);const M=b.alloc(B?4:3,g,x);return M.writeUInt8(O),M.writeShortString($),M.writeMixedArray(H),M.buffer}static deserializeRequestMixedArgs(g){const O=g.readUInt8(),z=g.readShortString(),H=g.readMixedArray(),B=new Array(H.length);for(let $=0,x=H.length;$<x;$++){const M=H[$];typeof M=="string"?B[$]=JSON.parse(M):B[$]=M}return{rpcId:O,method:z,args:B}}static serializeAcknowledged(g){return b.alloc(5,g,0).buffer}static serializeCancel(g){return b.alloc(6,g,0).buffer}static serializeReplyOK(g,O,z){if(typeof O>"u")return this._serializeReplyOKEmpty(g);if(O instanceof A.VSBuffer)return this._serializeReplyOKVSBuffer(g,O);if(O instanceof P.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:B}=t(O.value,z,!0);return this._serializeReplyOKJSONWithBuffers(g,H,B)}else return this._serializeReplyOKJSON(g,l(O,z))}static _serializeReplyOKEmpty(g){return b.alloc(7,g,0).buffer}static _serializeReplyOKVSBuffer(g,O){let z=0;z+=b.sizeVSBuffer(O);const H=b.alloc(8,g,z);return H.writeVSBuffer(O),H.buffer}static deserializeReplyOKVSBuffer(g){return g.readVSBuffer()}static _serializeReplyOKJSON(g,O){const z=A.VSBuffer.fromString(O);let H=0;H+=b.sizeLongString(z);const B=b.alloc(9,g,H);return B.writeLongString(z),B.buffer}static _serializeReplyOKJSONWithBuffers(g,O,z){const H=A.VSBuffer.fromString(O);let B=0;B+=b.sizeUInt32,B+=b.sizeLongString(H);for(const x of z)B+=b.sizeVSBuffer(x);const $=b.alloc(10,g,B);$.writeUInt32(z.length),$.writeLongString(H);for(const x of z)$.writeBuffer(x);return $.buffer}static deserializeReplyOKJSON(g){const O=g.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(g,O){const z=g.readUInt32(),H=g.readLongString(),B=[];for(let $=0;$<z;++$)B.push(g.readVSBuffer());return new P.SerializableObjectWithBuffers(i(H,B,O))}static serializeReplyErr(g,O){const z=O?l(L.transformErrorForSerialization(O),null):void 0;if(typeof z!="string")return this._serializeReplyErrEmpty(g);const H=A.VSBuffer.fromString(z);let B=0;B+=b.sizeLongString(H);const $=b.alloc(11,g,B);return $.writeLongString(H),$.buffer}static deserializeReplyErrError(g){const O=g.readLongString();return JSON.parse(O)}static _serializeReplyErrEmpty(g){return b.alloc(12,g,0).buffer}}var _;(function(u){u[u.RequestJSONArgs=1]="RequestJSONArgs",u[u.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",u[u.RequestMixedArgs=3]="RequestMixedArgs",u[u.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",u[u.Acknowledged=5]="Acknowledged",u[u.Cancel=6]="Cancel",u[u.ReplyOKEmpty=7]="ReplyOKEmpty",u[u.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",u[u.ReplyOKJSON=9]="ReplyOKJSON",u[u.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",u[u.ReplyErrError=11]="ReplyErrError",u[u.ReplyErrEmpty=12]="ReplyErrEmpty"})(_||(_={}));var o;(function(u){u[u.String=1]="String",u[u.VSBuffer=2]="VSBuffer",u[u.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",u[u.Undefined=4]="Undefined"})(o||(o={}))}),define(Pe[262],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const S=function(L){const T=h=>{globalThis.removeEventListener("message",T);const y=h.data;Object.defineProperties(globalThis,{postMessage:{value(m,P){y.postMessage(m,P)}},onmessage:{get(){return y.onmessage},set(m){y.onmessage=m}}}),y.addEventListener("message",m=>{globalThis.dispatchEvent(new MessageEvent("message",{data:m.data,ports:m.ports?[...m.ports]:void 0}))}),y.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",T)}.toString();class A extends EventTarget{constructor(L,T,h){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${S})('${T}'))`,m=new Blob([y],{type:"application/javascript"}),P=URL.createObjectURL(m),D=new MessageChannel,l=P,E={type:"_newWorker",id:l,port:D.port2,url:P,options:h};L(E,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{L({type:"_terminateWorker",id:l}),URL.revokeObjectURL(P),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(v){D.port1.onmessage=v}},onmessageerror:{get(){return D.port1.onmessageerror},set(v){D.port1.onmessageerror=v}}}),D.port1.addEventListener("messageerror",v=>{const d=new MessageEvent("messageerror",{data:v.data});this.dispatchEvent(d)}),D.port1.addEventListener("message",v=>{const d=new MessageEvent("message",{data:v.data});this.dispatchEvent(d)}),D.port1.start()}}e.NestedWorker=A}),define(Pe[263],Te([1,0,5,30,32,4]),function(ve,e,S,A,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)("outputService");var T;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class h{constructor(){this.channels=new Map,this._onDidRegisterChannel=new S.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new S.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(m){this.channels.has(m.id)||(this.channels.set(m.id,m),this._onDidRegisterChannel.fire(m.id))}getChannels(){const m=[];return this.channels.forEach(P=>m.push(P)),m}getChannel(m){return this.channels.get(m)}removeChannel(m){this.channels.delete(m),this._onDidRemoveChannel.fire(m)}}A.Registry.add(e.Extensions.OutputChannels,new h),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new I.RawContextKey("activeOutputChannel","")}),define(Pe[110],Te([1,0,3,4,17,20,14,263,62,27,39,130,25,16,38,5,6]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class i extends T.AbstractMessageLogger{get disposed(){return this._disposed}constructor(k,n,a,r,s){super(),this.id=k,this.name=n,this.logger=a,this.proxy=r,this.extension=s,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(a.getLevel()),this._register(a.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(k){this.append(k+`
`)}append(k){this.info(k)}clear(){const k=this.offset;this.logger.flush(),this.proxy.$update(this.id,h.OutputChannelUpdateMode.Clear,k)}replace(k){const n=this.offset;this.info(k),this.proxy.$update(this.id,h.OutputChannelUpdateMode.Replace,n),this.visible&&this.logger.flush()}show(k,n){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof k=="boolean"?k:n))}hide(){this.proxy.$close(this.id)}log(k,n){this.offset+=l.VSBuffer.fromString(n).byteLength,(0,T.log)(this.logger,k,n),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,h.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class c extends i{appendLine(k){this.append(k)}}let f=class{constructor(k,n,a,r,s,b){this.initData=n,this.extHostFileSystem=a,this.extHostFileSystemInfo=r,this.loggerService=s,this.logService=b,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=k.getProxy(S.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(n.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(k){this.visibleChannelId=k;for(const[n,a]of this.channels)a.visible=n===this.visibleChannelId}createOutputChannel(k,n,a){if(k=k.trim(),!k)throw new Error("illegal argument `name`. must not be falsy");const r=typeof n=="object"&&n.log,s=(0,E.isString)(n)?n:void 0;if((0,E.isString)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const p=this.initData.environment.extensionLogLevel?.find(([_])=>L.ExtensionIdentifier.equals(a.identifier,_))?.[1];p&&(b=(0,T.parseLogLevel)(p));const w=r?this.doCreateLogOutputChannel(k,b,a):this.doCreateOutputChannel(k,s,a);return w.then(_=>{this.channels.set(_.id,_),_.visible=_.id===this.visibleChannelId}),r?this.createExtHostLogOutputChannel(k,b??this.logService.getLevel(),w):this.createExtHostOutputChannel(k,w)}async doCreateOutputChannel(k,n,a){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const r=await this.outputDirectoryPromise,s=this.extHostFileSystemInfo.extUri.joinPath(r,`${this.namePool++}-${k.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.loggerService.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.proxy.$register(k,s,n,a.identifier.value);return new i(p,k,b,this.proxy,a)}async doCreateLogOutputChannel(k,n,a){const r=await this.createExtensionLogDirectory(a),s=k.replace(/[\\/:\*\?"<>\|]/g,""),b=this.extHostFileSystemInfo.extUri.joinPath(r,`${s}.log`),p=`${a.identifier.value}.${s}`,w=this.loggerService.createLogger(b,{id:p,name:k,logLevel:n,extensionId:a.identifier.value});return new c(p,k,w,this.proxy,a)}createExtensionLogDirectory(k){let n=this.extensionLogDirectoryPromise.get(k.identifier.value);if(!n){const a=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,k.identifier.value);this.extensionLogDirectoryPromise.set(k.identifier.value,n=(async()=>{try{await this.extHostFileSystem.value.createDirectory(a)}catch(r){if((0,v.toFileSystemProviderErrorCode)(r)!==v.FileSystemProviderErrorCode.FileExists)throw r}return a})())}return n}createExtHostOutputChannel(k,n){let a=!1;const r=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return k},append(s){r(),n.then(b=>b.append(s))},appendLine(s){r(),n.then(b=>b.appendLine(s))},clear(){r(),n.then(s=>s.clear())},replace(s){r(),n.then(b=>b.replace(s))},show(s,b){r(),n.then(p=>p.show(s,b))},hide(){r(),n.then(s=>s.hide())},dispose(){a=!0,n.then(s=>s.dispose())}}}createExtHostLogOutputChannel(k,n,a){const r=new t.DisposableStore,s=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},b=r.add(new d.Emitter);function p(w){n=w,b.fire(w)}return a.then(w=>{r.add(w),w.logLevel!==n&&p(w.logLevel),r.add(w.onDidChangeLogLevel(_=>p(_)))}),{...this.createExtHostOutputChannel(k,a),get logLevel(){return n},onDidChangeLogLevel:b.event,trace(w,..._){s(),a.then(o=>o.trace(w,..._))},debug(w,..._){s(),a.then(o=>o.debug(w,..._))},info(w,..._){s(),a.then(o=>o.info(w,..._))},warn(w,..._){s(),a.then(o=>o.warn(w,..._))},error(w,..._){s(),a.then(o=>o.error(w,..._))},dispose(){r.dispose()}}}};e.ExtHostOutputService=f,e.ExtHostOutputService=f=Ve([ze(0,I.IExtHostRpcService),ze(1,m.IExtHostInitDataService),ze(2,y.IExtHostConsumerFileSystem),ze(3,P.IExtHostFileSystemInfo),ze(4,T.ILoggerService),ze(5,T.ILogService)],f),e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(Pe[264],Te([1,0,4,13]),function(ve,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,S.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let L=1/0;for(let h=0;h<this.maxSampleCount;h++){const y=await I.getRoundTripTime();if(y===void 0)return;L=Math.min(L,y/2),await(0,A.timeout)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(L):T=this.initial.reduce((h,y)=>h+y,0)/this.initial.length,this.lastMeasurement={initial:T,current:L,average:this.average.reduce((h,y)=>h+y,0)/this.average.length,high:(()=>typeof T>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>T*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[265],Te([1,0,42,12,19,22,23,2,4,187,54,209,264]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let v=E=class{constructor(t,i,c,f){this.localUserHome=t,this.remoteAgentService=i,this.environmentService=c,this.contextService=f,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||L.OS)(),this.resolveUserHome=(async()=>{const C=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=C?.userHome??t})()}hasValidBasename(t,i,c){return typeof i=="string"||typeof i>"u"?this.resolveOS.then(f=>this.doHasValidBasename(t,f,i)):this.doHasValidBasename(t,i,c)}doHasValidBasename(t,i,c){return t.scheme===A.Schemas.file||t.scheme===A.Schemas.vscodeRemote?(0,S.isValidBasename)(c??(0,T.basename)(t),i===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return A.Schemas.vscodeRemote;const c=(0,m.getVirtualWorkspaceScheme)(i.getWorkspace());if(c)return c;const f=i.getWorkspace().folders[0];if(f)return f.uri.scheme;const C=i.getWorkspace().configuration;return C?C.scheme:A.Schemas.file}userHome(t){return t?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(t=>t===1?I.win32:I.posix)}async fileURI(t){let i="";if(await this.resolveOS===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const f=t.indexOf("/",2);f===-1?(i=t.substring(2),t="/"):(i=t.substring(2,f),t=t.substring(f)||"/")}return h.URI.from({scheme:A.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.AbstractPathService=v,e.AbstractPathService=v=E=Ve([ze(1,l.IRemoteAgentService),ze(2,D.IWorkbenchEnvironmentService),ze(3,P.IWorkspaceContextService)],v)}),define(Pe[111],Te([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class S{constructor(T,h){this.line=T,this.character=h}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,h){return new S(0,0)}with(T){return new S(0,0)}}e.Position=S;class A{constructor(T,h,y,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(T,h),this.end=new S(y,m)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new A(0,0,0,0)}with(T){return new A(0,0,0,0)}}e.Range=A;var I;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Pe[47],Te([1,0,18,37,24,42,15,4,19,9,111,13]),function(ve,e,S,A,I,L,T,h,y,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const l="\u27EA ",E=" characters skipped \u27EB",v=(l.length+E.length+5)*2;e.ISearchService=(0,h.createDecorator)("searchService");var d;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(d||(e.SearchProviderType=d={}));var t;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(t||(e.QueryType=t={}));function i(Y){return!!Y.preview}e.resultIsMatch=i;function c(Y){return!!Y.resource}e.isFileMatch=c;function f(Y){return!!Y.message}e.isProgressMessage=f;var C;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(C||(e.SearchCompletionExitCode=C={}));class k{constructor(he){this.resource=he,this.results=[]}}e.FileMatch=k;class n{constructor(he,ke,ae,J){this.ranges=ke,this.webviewIndex=J;const le=Array.isArray(ke)?ke:[ke];if(ae&&ae.matchLines===1&&a(le)){he=(0,T.getNLines)(he,ae.matchLines);let N="",q=0,ue=0;const Se=Math.floor(ae.charsPerLine/5),be=[];for(const Ee of le){const ye=Math.max(Ee.startColumn-Se,0),oe=Ee.startColumn+ae.charsPerLine;if(ye>ue+Se+v){const de=l+(ye-ue)+E;N+=de+he.slice(ye,oe),q+=ye-(ue+de.length)}else N+=he.slice(ue,oe);be.push(new s(0,Ee.startColumn-q,Ee.endColumn-q)),ue=oe}this.preview={text:N,matches:Array.isArray(this.ranges)?be:be[0]}}else{const N=Array.isArray(ke)?ke[0].startLineNumber:ke.startLineNumber;this.preview={text:he,matches:(0,S.mapArrayOrNot)(ke,q=>new r(q.startLineNumber-N,q.startColumn,q.endLineNumber-N,q.endColumn))}}}}e.TextSearchMatch=n;function a(Y){const he=Y[0].startLineNumber;for(const ke of Y)if(ke.startLineNumber!==he||ke.endLineNumber!==he)return!1;return!0}class r{constructor(he,ke,ae,J){this.startLineNumber=he,this.startColumn=ke,this.endLineNumber=ae,this.endColumn=J}}e.SearchRange=r;class s extends r{constructor(he,ke,ae){super(he,ke,he,ae)}}e.OneLineRange=s;var b;(function(Y){Y.List="list",Y.Tree="tree"})(b||(e.ViewMode=b={}));var p;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function w(Y,he=!0){const ke=Y&&Y.files&&Y.files.exclude,ae=he&&Y&&Y.search&&Y.search.exclude;if(!ke&&!ae)return;if(!ke||!ae)return ke||ae;let J=Object.create(null);return J=I.mixin(J,I.deepClone(ke)),J=I.mixin(J,I.deepClone(ae),!0),J}e.getExcludes=w;function _(Y,he){return Y.excludePattern&&A.match(Y.excludePattern,he)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&A.match(Y.includePattern,he)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(ke=>{const ae=ke.folder.fsPath;if(L.isEqualOrParent(he,ae)){const J=y.relative(ae,he);return!ke.includePattern||!!A.match(ke.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=_;var o;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(o||(e.SearchErrorCode=o={}));class u extends Error{constructor(he,ke){super(he),this.code=ke}}e.SearchError=u;function g(Y){const he=Y.message;if((0,m.isCancellationError)(Y))return new u(he,o.canceled);try{const ke=JSON.parse(he);return new u(ke.message,ke.code)}catch{return new u(he,o.other)}}e.deserializeSearchError=g;function O(Y){const he={message:Y.message,code:Y.code};return new Error(JSON.stringify(he))}e.serializeSearchError=O;function z(Y){return Y.type==="error"?!0:Y.type==="success"}e.isSerializedSearchComplete=z;function H(Y){return Y.type==="success"}e.isSerializedSearchSuccess=H;function B(Y){return!!Y.path}e.isSerializedFileMatch=B;function $(Y,he){const ke=Y.searchPath?Y.searchPath:Y.relativePath;return(0,T.fuzzyContains)(ke,he)}e.isFilePatternMatch=$;class x{constructor(he){this.path=he,this.results=[]}addMatch(he){this.results.push(he)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function M(Y,he){const ke={...Y||{},...he||{}};return Object.keys(ke).filter(ae=>{const J=ke[ae];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=M;class ne{constructor(he,ke){this._parsedIncludeExpression=null,this._excludeExpression={...he.excludePattern||{},...ke.excludePattern||{}},this._parsedExcludeExpression=A.parse(this._excludeExpression);let ae=he.includePattern;ke.includePattern&&(ae?ae={...ae,...ke.includePattern}:ae=ke.includePattern),ae&&(this._parsedIncludeExpression=A.parse(ae))}matchesExcludesSync(he,ke,ae){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(he,ke,ae))}includedInQuerySync(he,ke,ae){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(he,ke,ae)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(he,ke,ae))}includedInQuery(he,ke,ae){const J=this._parsedExcludeExpression(he,ke,ae),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(he,ke,ae):!0;return(0,D.isThenable)(J)?J.then(N=>N?!1:le()):le()}hasSiblingExcludeClauses(){return Q(this._excludeExpression)}}e.QueryGlobTester=ne;function Q(Y){for(const he in Y)if(typeof Y[he]!="boolean")return!0;return!1}function we(Y){if(!Y)return;let he;return ke=>(he||(he=(Y()||Promise.resolve([])).then(ae=>ae?Ae(ae):{})),he.then(ae=>!!ae[ke]))}e.hasSiblingPromiseFn=we;function _e(Y){if(!Y)return;let he;return ke=>{if(!he){const ae=Y();he=ae?Ae(ae):{}}return!!he[ke]}}e.hasSiblingFn=_e;function Ae(Y){const he={};for(const ke of Y)he[ke]=!0;return he}}),define(Pe[33],Te([1,0,18,13,21,5,6,48,12,118,23,15,2,159,4,14,176,54,39,27,17,8,7,56,47,3]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t,i,c,f,C,k,n,a,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function b(z,H,B){return new P.ExtUri($=>o($,B)).isEqual(z,H)}function p(z,H,B){return b(z.uri,H.uri,B)?0:(0,D.compare)(z.uri.toString(),H.uri.toString())}function w(z,H,B){return z.index!==H.index?z.index<H.index?-1:1:b(z.uri,H.uri,B)?(0,D.compare)(z.name,H.name):(0,D.compare)(z.uri.toString(),H.uri.toString())}function _(z,H,B,$){const x=z.slice(0).sort((ne,Q)=>B(ne,Q,$)),M=H.slice(0).sort((ne,Q)=>B(ne,Q,$));return(0,S.delta)(x,M,(ne,Q)=>B(ne,Q,$))}function o(z,H){const B=H.getCapabilities(z.scheme);return!(B&&B&1024)}class u extends i.Workspace{static toExtHostWorkspace(H,B,$,x){if(!H)return{workspace:null,added:[],removed:[]};const{id:M,name:ne,folders:Q,configuration:we,transient:_e,isUntitled:Ae}=H,Y=[],he=B;B?Q.forEach((le,N)=>{const q=l.URI.revive(le.uri),ue=u._findFolder($||B,q,x);ue?(ue.name=le.name,ue.index=le.index,Y.push(ue)):Y.push({uri:q,name:le.name,index:N})}):Y.push(...Q.map(({uri:le,name:N,index:q})=>({uri:l.URI.revive(le),name:N,index:q}))),Y.sort((le,N)=>le.index<N.index?-1:1);const ke=new u(M,ne,Y,!!_e,we?l.URI.revive(we):null,!!Ae,le=>o(le,x)),{added:ae,removed:J}=_(he?he.workspaceFolders:[],ke.workspaceFolders,p,x);return{workspace:ke,added:ae,removed:J}}static _findFolder(H,B,$){for(let x=0;x<H.folders.length;x++){const M=H.workspaceFolders[x];if(b(M.uri,B,$))return M}}constructor(H,B,$,x,M,ne,Q){super(H,$.map(we=>new i.WorkspaceFolder(we)),x,M,Q),this._name=B,this._isUntitled=ne,this._workspaceFolders=[],this._structure=h.TernarySearchTree.forUris(Q),$.forEach(we=>{this._workspaceFolders.push(we),this._structure.set(we.uri,we)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(H,B){return B&&this._structure.get(H)&&(H=(0,P.dirname)(H)),this._structure.findSubstr(H)}resolveWorkspaceFolder(H){return this._structure.get(H)}}let g=class{constructor(H,B,$,x,M){this._onDidChangeWorkspace=new L.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new L.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new L.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=x,this._extHostFileSystemInfo=$,this._uriTransformerService=M,this._requestIdProvider=new m.Counter,this._barrier=new A.Barrier,this._proxy=H.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=H.getProxy(s.MainContext.MainThreadMessageService);const ne=B.workspace;this._confirmedWorkspace=ne?new u(ne.id,ne.name,[],!!ne.transient,ne.configuration?l.URI.revive(ne.configuration):null,!!ne.isUntitled,Q=>o(Q,$)):void 0}$initializeWorkspace(H,B){this._trusted=B,this.$acceptWorkspaceData(H),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:y.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(H,B,$,...x){const M=[];if(Array.isArray(x)&&x.forEach(Ae=>{l.URI.isUri(Ae.uri)&&!M.some(Y=>b(Y.uri,Ae.uri,this._extHostFileSystemInfo))&&M.push({uri:Ae.uri,name:Ae.name||(0,P.basenameOrAuthority)(Ae.uri)})}),this._unconfirmedWorkspace||[B,$].some(Ae=>typeof Ae!="number"||Ae<0)||$===0&&M.length===0)return!1;const ne=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+$>ne.length)return!1;const Q=ne.slice(0);Q.splice(B,$,...M.map(Ae=>({uri:Ae.uri,name:Ae.name||(0,P.basenameOrAuthority)(Ae.uri),index:void 0})));for(let Ae=0;Ae<Q.length;Ae++){const Y=Q[Ae];if(Q.some((he,ke)=>ke!==Ae&&b(Y.uri,he.uri,this._extHostFileSystemInfo)))return!1}Q.forEach((Ae,Y)=>Ae.index=Y);const{added:we,removed:_e}=_(ne,Q,w,this._extHostFileSystemInfo);if(we.length===0&&_e.length===0)return!1;if(this._proxy){const Ae=H.displayName||H.name;this._proxy.$updateWorkspaceFolders(Ae,B,$,M).then(void 0,Y=>{this._unconfirmedWorkspace=void 0;const he={source:{identifier:H.identifier,label:H.displayName||H.name}};this._messageService.$showMessage(t.Severity.Error,(0,E.localize)(0,null,Ae,Y.toString()),he,[])})}return this.trySetWorkspaceFolders(Q),!0}getWorkspaceFolder(H,B){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(H,B)}async getWorkspaceFolder2(H,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(H,B)}async resolveWorkspaceFolder(H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(H)}getPath(){if(!this._actualWorkspace)return;const{folders:H}=this._actualWorkspace;if(H.length!==0)return H[0].uri.fsPath}getRelativePath(H,B){let $,x="";if(typeof H=="string"?($=l.URI.file(H),x=H):typeof H<"u"&&($=H,x=H.fsPath),!$)return x;const M=this.getWorkspaceFolder($,!0);if(!M)return x;typeof B>"u"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let ne=(0,P.relativePath)(M.uri,$);return B&&M.name&&(ne=`${M.name}/${ne}`),ne}trySetWorkspaceFolders(H){this._actualWorkspace&&(this._unconfirmedWorkspace=u.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:H,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(H){const{workspace:B,added:$,removed:x}=u.toExtHostWorkspace(H,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:$,removed:x}))}findFiles(H,B,$,x,M=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let ne;if(B===null?ne=!1:B&&(typeof B=="string"?ne=B:ne=B.pattern),M&&M.isCancellationRequested)return Promise.resolve([]);const{includePattern:Q,folder:we}=O(k.GlobPattern.from(H));return this._proxy.$startFileSearch(Q??null,we??null,ne??null,$??null,M).then(_e=>Array.isArray(_e)?_e.map(Ae=>l.URI.revive(Ae)):[])}async findTextInFiles(H,B,$,x,M=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const ne=this._requestIdProvider.getNext(),Q=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:we,folder:_e}=O(k.GlobPattern.from(B.include)),Ae=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,Y={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:Q,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:we,excludePattern:Ae},he=!1;if(this._activeSearchCallbacks[ne]=ke=>{if(he)return;const ae=l.URI.revive(ke.resource);ke.results.forEach(J=>{(0,r.resultIsMatch)(J)?$({uri:ae,preview:{text:J.preview.text,matches:(0,S.mapArrayOrNot)(J.preview.matches,le=>new n.Range(le.startLineNumber,le.startColumn,le.endLineNumber,le.endColumn))},ranges:(0,S.mapArrayOrNot)(J.ranges,le=>new n.Range(le.startLineNumber,le.startColumn,le.endLineNumber,le.endColumn))}):$({uri:ae,text:J.text,lineNumber:J.lineNumber})})},M.isCancellationRequested)return{};try{const ke=await this._proxy.$startTextSearch(H,_e??null,Y,ne,M);return delete this._activeSearchCallbacks[ne],ke||{}}catch(ke){throw delete this._activeSearchCallbacks[ne],ke}}$handleTextSearchResult(H,B){this._activeSearchCallbacks[B]?.(H)}async save(H){const B=await this._proxy.$save(H,{saveAs:!1});return l.URI.revive(B)}async saveAs(H){const B=await this._proxy.$save(H,{saveAs:!0});return l.URI.revive(B)}saveAll(H){return this._proxy.$saveAll(H)}resolveProxy(H){return this._proxy.$resolveProxy(H)}get trusted(){return this._trusted}requestWorkspaceTrust(H){return this._proxy.$requestWorkspaceTrust(H)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(H,B){if(this._editSessionIdentityProviders.has(H))throw new Error(`A provider has already been registered for scheme ${H}`);this._editSessionIdentityProviders.set(H,B);const $=this._uriTransformerService.transformOutgoingScheme(H),x=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(x,$),(0,T.toDisposable)(()=>{this._editSessionIdentityProviders.delete(H),this._proxy.$unregisterEditSessionIdentityProvider(x)})}async $getEditSessionIdentifier(H,B){this._logService.info("Getting edit session identifier for workspaceFolder",H);const $=await this.resolveWorkspaceFolder(l.URI.revive(H));if(!$){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",$);const x=this._editSessionIdentityProviders.get($.uri.scheme);if(this._logService.info(`Provider for scheme ${$.uri.scheme} is defined: `,!!x),!x)return;const M=await x.provideEditSessionIdentity($,B);if(this._logService.info("Provider returned edit session identifier: ",M),!!M)return M}async $provideEditSessionIdentityMatch(H,B,$,x){this._logService.info("Getting edit session identifier for workspaceFolder",H);const M=await this.resolveWorkspaceFolder(l.URI.revive(H));if(!M){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const ne=this._editSessionIdentityProviders.get(M.uri.scheme);if(this._logService.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!ne),!ne)return;const Q=await ne.provideEditSessionIdentityMatch?.(B,$,x);if(this._logService.info("Provider returned edit session identifier match result: ",Q),!!Q)return Q}getOnWillCreateEditSessionIdentityEvent(H){return(B,$,x)=>{const M=function(Q){B.call($,Q)};return M.extension=H,this._onWillCreateEditSessionIdentityEvent.event(M,void 0,x)}}async $onWillCreateEditSessionIdentity(H,B,$){const x=await this.resolveWorkspaceFolder(l.URI.revive(H));if(x===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:x},B,async(M,ne)=>{const Q=Date.now();await Promise.resolve(M),Date.now()-Q>$&&this._logService.warn("SLOW edit session create-participant",ne.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider(H,B){if(this._canonicalUriProviders.has(H))throw new Error(`A provider has already been registered for scheme ${H}`);this._canonicalUriProviders.set(H,B);const $=this._uriTransformerService.transformOutgoingScheme(H),x=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(x,$),(0,T.toDisposable)(()=>{this._canonicalUriProviders.delete(H),this._proxy.$unregisterCanonicalUriProvider(x)})}async provideCanonicalUri(H,B,$){const x=this._canonicalUriProviders.get(H.scheme);if(!x)return;const M=await x.provideCanonicalUri?.(l.URI.revive(H),B,$);if(M)return M}async $provideCanonicalUri(H,B,$){return this.provideCanonicalUri(l.URI.revive(H),{targetScheme:B},$)}};e.ExtHostWorkspace=g,e.ExtHostWorkspace=g=Ve([ze(0,C.IExtHostRpcService),ze(1,f.IExtHostInitDataService),ze(2,c.IExtHostFileSystemInfo),ze(3,d.ILogService),ze(4,a.IURITransformerService)],g),e.IExtHostWorkspace=(0,v.createDecorator)("IExtHostWorkspace");function O(z){let H,B;return z&&(typeof z=="string"?H=z:(H=z.pattern,B=l.URI.revive(z.baseUri))),{includePattern:H,folder:B}}}),define(Pe[34],Te([1,0,24,5,33,3,7,178,96,16,13,4,17,14,2]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(a,r){if(r){const s=r.split(".");let b=a;for(let p=0;b&&p<s.length;p++)b=b[s[p]];return b}}function t(a){return a instanceof v.URI}function i(a){return a&&a.uri instanceof v.URI&&a.languageId&&typeof a.languageId=="string"}function c(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function f(a){return a&&a.uri instanceof v.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function C(a){if(t(a))return{resource:a};if(i(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(c(a))return{overrideIdentifier:a.languageId};if(f(a))return{resource:a.uri};if(a===null)return{resource:null}}let k=class{constructor(r,s,b){this._proxy=r.getProxy(L.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=b,this._barrier=new P.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new n(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(r,s))}};e.ExtHostConfiguration=k,e.ExtHostConfiguration=k=Ve([ze(0,l.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,E.ILogService)],k);class n{constructor(r,s,b,p){this._onDidChangeConfiguration=new A.Emitter,this._proxy=r,this._logService=p,this._extHostWorkspace=s,this._configuration=h.Configuration.parse(b),this._configurationScopes=this._toMap(b.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const b={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=h.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,b))}getConfiguration(r,s,b){const p=C(s)||{},w=this._toReadonlyValue(r?d(this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,p,b?.identifier);function _(u){if(u==null)return null;if(typeof u=="boolean")return u?2:5;switch(u){case T.ConfigurationTarget.Global:return 2;case T.ConfigurationTarget.Workspace:return 5;case T.ConfigurationTarget.WorkspaceFolder:return 6}}const o={has(u){return typeof d(w,u)<"u"},get:(u,g)=>{this._validateConfigurationAccess(r?`${r}.${u}`:u,p,b?.identifier);let O=d(w,u);if(typeof O>"u")O=g;else{let z;const H=(B,$)=>{if((0,m.isObject)(B)){let x;const M=()=>{z=z||(0,S.deepClone)(w),x=x||d(z,$)};return new Proxy(B,{get:(ne,Q)=>{if(typeof Q=="string"&&Q.toLowerCase()==="tojson")return M(),()=>x;if(z)return x=x||d(z,$),x[Q];const we=ne[Q];return typeof Q=="string"?H(we,`${$}.${Q}`):we},set:(ne,Q,we)=>(M(),x&&(x[Q]=we),!0),deleteProperty:(ne,Q)=>(M(),x&&delete x[Q],!0),defineProperty:(ne,Q,we)=>(M(),x&&Object.defineProperty(x,Q,we),!0)})}return Array.isArray(B)?(0,S.deepClone)(B):B};O=H(O,u)}return O},update:(u,g,O,z)=>{u=r?`${r}.${u}`:u;const H=_(O);return g!==void 0?this._proxy.$updateConfigurationOption(H,u,g,p,z):this._proxy.$removeConfigurationOption(H,u,p,z)},inspect:u=>{u=r?`${r}.${u}`:u;const g=this._configuration.inspect(u,p,this._extHostWorkspace.workspace);if(g)return{key:u,defaultValue:(0,S.deepClone)(g.policy?.value??g.default?.value),globalValue:(0,S.deepClone)(g.user?.value??g.application?.value),workspaceValue:(0,S.deepClone)(g.workspace?.value),workspaceFolderValue:(0,S.deepClone)(g.workspaceFolder?.value),defaultLanguageValue:(0,S.deepClone)(g.default?.override),globalLanguageValue:(0,S.deepClone)(g.user?.override??g.application?.override),workspaceLanguageValue:(0,S.deepClone)(g.workspace?.override),workspaceFolderLanguageValue:(0,S.deepClone)(g.workspaceFolder?.override),languageIds:(0,S.deepClone)(g.overrideIdentifiers)}}};return typeof w=="object"&&(0,S.mixin)(o,w,!1),Object.freeze(o)}_toReadonlyValue(r){const s=b=>(0,m.isObject)(b)?new Proxy(b,{get:(p,w)=>s(p[w]),set:(p,w,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(p,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(p,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return s(r)}_validateConfigurationAccess(r,s,b){const p=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),w=b?`[${b.value}] `:"";if(p===4){typeof s?.resource>"u"&&this._logService.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){s?.resource&&this._logService.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const b=new h.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(p,w)=>b.affectsConfiguration(p,C(w))})}_toMap(r){return r.reduce((s,b)=>(s.set(b[0],b[1]),s),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")}),define(Pe[112],Te([1,0,2,13,5,3,7,33,60,34,21,63,17,27,4,12,22,14,80,215,9]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t,i,c,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var k;(function(H){function B(x){if(x!=null)return x}H.from=B;function $(x){if(x!=null)return x}H.to=$})(k||(k={}));var n;(function(H){function B(x){if(x!=null)return x}H.from=B;function $(x){if(x!=null)return x}H.to=$})(n||(n={}));var a;(function(H){function B(x){if(x!=null)return x}H.from=B;function $(x){if(x!=null)return x}H.to=$})(a||(a={}));var r;(function(H){function B(M){if(M){const ne=M;return ne&&!!ne.process}else return!1}H.is=B;function $(M){if(M==null)return;const ne={process:M.process,args:M.args};return M.options&&(ne.options=a.from(M.options)),ne}H.from=$;function x(M){if(M!=null)return new T.ProcessExecution(M.process,M.args,M.options)}H.to=x})(r||(r={}));var s;(function(H){function B(x){if(x!=null)return x}H.from=B;function $(x){if(x!=null)return x}H.to=$})(s||(s={}));var b;(function(H){function B(M){if(M){const ne=M;return ne&&(!!ne.commandLine||!!ne.command)}else return!1}H.is=B;function $(M){if(M==null)return;const ne={};return M.commandLine!==void 0?ne.commandLine=M.commandLine:(ne.command=M.command,ne.args=M.args),M.options&&(ne.options=s.from(M.options)),ne}H.from=$;function x(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new T.ShellExecution(M.commandLine,M.options):new T.ShellExecution(M.command,M.args?M.args:[],M.options)}H.to=x})(b||(b={}));var p;(function(H){function B(M){if(M){const ne=M;return ne&&ne.customExecution==="customExecution"}else return!1}H.is=B;function $(M){return{customExecution:"customExecution"}}H.from=$;function x(M,ne){return ne.get(M)}H.to=x})(p||(e.CustomExecutionDTO=p={}));var w;(function(H){function B($,x){let M;return $.scope!==void 0&&typeof $.scope!="number"?M=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===T.TaskScope.Workspace&&x&&x.workspaceFile?M=x.workspaceFile:M=f.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:M}}H.from=B})(w||(e.TaskHandleDTO=w={}));var _;(function(H){function B($){if($!=null)return{_id:$.id,isDefault:$.isDefault}}H.from=B})(_||(_={}));var o;(function(H){function B(M,ne){if(M==null)return[];const Q=[];for(const we of M){const _e=$(we,ne);_e&&Q.push(_e)}return Q}H.fromMany=B;function $(M,ne){if(M==null)return;let Q;M.execution instanceof T.ProcessExecution?Q=r.from(M.execution):M.execution instanceof T.ShellExecution?Q=b.from(M.execution):M.execution&&M.execution instanceof T.CustomExecution&&(Q=p.from(M.execution));const we=k.from(M.definition);let _e;return M.scope?typeof M.scope=="number"?_e=M.scope:_e=M.scope.uri:_e=T.TaskScope.Workspace,!we||!_e?void 0:{_id:M._id,definition:we,name:M.name,source:{extensionId:ne.identifier.value,label:M.source,scope:_e},execution:Q,isBackground:M.isBackground,group:_.from(M.group),presentationOptions:n.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}H.from=$;async function x(M,ne,Q){if(M==null)return;let we;r.is(M.execution)?we=r.to(M.execution):b.is(M.execution)?we=b.to(M.execution):p.is(M.execution)&&(we=p.to(M._id,Q));const _e=k.to(M.definition);let Ae;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?Ae=M.source.scope:Ae=await ne.resolveWorkspaceFolder(S.URI.revive(M.source.scope)):Ae=T.TaskScope.Workspace),!_e||!Ae)return;const Y=new T.Task(_e,Ae,M.name,M.source.label,we,M.problemMatchers);return M.isBackground!==void 0&&(Y.isBackground=M.isBackground),M.group!==void 0&&(Y.group=T.TaskGroup.from(M.group._id),Y.group&&M.group.isDefault&&(Y.group=new T.TaskGroup(Y.group.id,Y.group.label),M.group.isDefault===!0&&(Y.group.isDefault=M.group.isDefault))),M.presentationOptions&&(Y.presentationOptions=n.to(M.presentationOptions)),M._id&&(Y._id=M._id),M.detail&&(Y.detail=M.detail),Y}H.to=x})(o||(e.TaskDTO=o={}));var u;(function(H){function B(x){return x}H.from=B;function $(x){if(x)return Object.assign(Object.create(null),x)}H.to=$})(u||(u={}));class g{#e;constructor(B,$,x){this._id=$,this._task=x,this.#e=B}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}let O=class{constructor(B,$,x,M,ne,Q,we,_e){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=B.getProxy(L.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=M,this._configurationService=ne,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=we,this._deprecationService=_e,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,$,x){if(!x)return new T.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:$,provider:x,extension:B}),this._proxy.$registerTaskProvider(M,$),new T.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(B,$){this._proxy.$registerTaskSystem(B,$)}fetchTasks(B){return this._proxy.$fetchTasks(u.from(B)).then(async $=>{const x=[];for(const M of $){const ne=await o.to(M,this._workspaceProvider,this._providedCustomExecutions2);ne&&x.push(ne)}return x})}get taskExecutions(){const B=[];return this._taskExecutions.forEach($=>B.push($)),B}terminateTask(B){if(!(B instanceof g))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,$,x){const M=this._providedCustomExecutions2.get(B.id);M&&(this._activeCustomExecutions2.set(B.id,M),this._terminalService.attachPtyToTerminal($,await M.callback(x))),this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const $=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const $=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:$,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const $=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:B.exitCode})}$provideTasks(B,$){const x=this._handlers.get(B);if(!x)return Promise.reject(new Error("no handler found"));const M=[],ne=(0,A.asPromise)(()=>x.provider.provideTasks(P.CancellationToken.None)).then(Q=>this.provideTasksInternal($,M,x,Q));return new Promise(Q=>{ne.then(we=>{Promise.all(M).then(()=>{Q(we)})})})}async $resolveTask(B,$){const x=this._handlers.get(B);if(!x)return Promise.reject(new Error("no handler found"));if($.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${x.type}].`);const M=await o.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const ne=await x.provider.resolveTask(M,P.CancellationToken.None);if(!ne)return;this.checkDeprecation(ne,x);const Q=o.from(ne,x.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(ne.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(Q.execution)&&await this.addCustomExecution(Q,ne,!0),await this.resolveTaskInternal(Q)}nextHandle(){return this._handleCounter++}async addCustomExecution(B,$,x){const M=await this._proxy.$createTaskId(B);!x&&!this._providedCustomExecutions2.has(M)&&(this._notProvidedCustomExecutions.add(M),this._activeCustomExecutions2.set(M,$.execution)),this._providedCustomExecutions2.set(M,$.execution)}async getTaskExecution(B,$){if(typeof B=="string"){const ne=this._taskExecutionPromises.get(B);if(!ne)throw new C.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return ne}const x=this._taskExecutionPromises.get(B.id);if(x)return x;const M=new Promise((ne,Q)=>{function we(_e,Ae,Y){Y?ne(new g(_e,Ae.id,Y)):Q("Unexpected: Task does not exist.")}$?we(this,B,$):o.to(B.task,this._workspaceProvider,this._providedCustomExecutions2).then(_e=>we(this,B,_e))});return this._taskExecutionPromises.set(B.id,M),M.then(ne=>(this._taskExecutions.set(B.id,ne),ne),ne=>Promise.reject(ne))}checkDeprecation(B,$){B._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));const x=this._notProvidedCustomExecutions.values();let M=x.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=x.next()}};e.ExtHostTaskBase=O,e.ExtHostTaskBase=O=Ve([ze(0,l.IExtHostRpcService),ze(1,E.IExtHostInitDataService),ze(2,h.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,m.IExtHostConfiguration),ze(5,D.IExtHostTerminalService),ze(6,i.ILogService),ze(7,c.IExtHostApiDeprecationService)],O);let z=class extends O{constructor(B,$,x,M,ne,Q,we,_e){super(B,$,x,M,ne,Q,we,_e),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask(B,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const x=o.from($,B);if(x===void 0)throw new Error("Task is not valid");if(p.is(x.execution))await this.addCustomExecution(x,$,!1);else throw new C.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),$);return this._proxy.$executeTask(x).catch(ne=>{throw new Error(ne)}),M}provideTasksInternal(B,$,x,M){const ne=[];if(M)for(const Q of M){this.checkDeprecation(Q,x),(!Q.definition||!B[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const we=o.from(Q,x.extension);we&&p.is(we.execution)?(ne.push(we),$.push(this.addCustomExecution(we,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ne,extension:x.extension}}async resolveTaskInternal(B){if(p.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,$){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,$,x){}};e.WorkerExtHostTask=z,e.WorkerExtHostTask=z=Ve([ze(0,l.IExtHostRpcService),ze(1,E.IExtHostInitDataService),ze(2,h.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,m.IExtHostConfiguration),ze(5,D.IExtHostTerminalService),ze(6,i.ILogService),ze(7,c.IExtHostApiDeprecationService)],z),e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(Pe[266],Te([1,0,19,21,41,37,23,59,47]),function(ve,e,S,A,I,L,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class m{constructor(l,E,v){this.config=l,this.provider=E,this.sessionToken=v,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&L.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&L.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const E=this.config.folderQueries||[];return new Promise((v,d)=>{const t=i=>{this.resultCount++,l(i)};if(this.isCanceled)return v({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(i=>{const c=i.toString(),f=S.basename(c);this.globalExcludePattern&&this.globalExcludePattern(c,f)||this.matchFile(t,{base:i,basename:f})}),Promise.all(E.map(i=>this.searchInFolder(i,t))).then(i=>{v({limitHit:this.isLimitHit,stats:i[0]||void 0})},i=>{d(new Error((0,I.toErrorMessage)(i)))})})}async searchInFolder(l,E){const v=new A.CancellationTokenSource,d=this.getSearchOptionsForFolder(l),t=this.initDirectoryTree(),i=new y.QueryGlobTester(this.config,l),c=!i.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(v),f=h.StopWatch.create();const C=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,v.token),k=f.elapsed(),n=h.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(C&&C.forEach(a=>{const r=S.posix.relative(l.folder.path,a.path);if(c){const s=S.basename(a.path);this.matchFile(E,{base:l.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(t,l.folder,r,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(t,i,E),{providerTime:k,postProcessTime:n.elapsed()})}finally{v.dispose(),this.activeCancellationTokens.delete(v)}}getSearchOptionsForFolder(l){const E=(0,y.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),v=(0,y.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:v,includes:E,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},E,v,d){if(v===this.filePattern){const i=S.basename(this.filePattern);this.matchFile(d,{base:E,relativePath:this.filePattern,basename:i})}function t(i){const c=S.basename(i),f=S.dirname(i);let C=l[f];C||(C=l[f]=[],t(f)),C.push({base:E,relativePath:i,basename:c})}t(v)}matchDirectoryTree({rootEntries:l,pathToEntries:E},v,d){const t=this,i=this.filePattern;function c(f){const C=(0,y.hasSiblingFn)(()=>f.map(k=>k.basename));for(let k=0,n=f.length;k<n;k++){const a=f[k],{relativePath:r,basename:s}=a;if(v.matchesExcludesSync(r,s,i!==s?C:void 0))continue;const b=E[r];if(b)c(b);else{if(r===i)continue;t.matchFile(d,a)}if(t.isLimitHit)break}}c(l)}matchFile(l,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(E))}}class P{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(l,E,v,d){const t=this.getSessionTokenSource(l.cacheKey),i=new m(l,E,t&&t.token);let c=0;const f=C=>{c+=C.length,v(C.map(k=>this.rawMatchToSearchItem(k)))};return this.doSearch(i,P.BATCH_SIZE,f,d).then(C=>({limitHit:C.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:C.stats}}))}clearCache(l){this.getSessionTokenSource(l)?.cancel()}getSessionTokenSource(l){if(l)return this.sessions.has(l)||this.sessions.set(l,new A.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:T.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,E,v,d){d.onCancellationRequested(()=>{l.cancel()});const t=c=>{c&&(i.push(c),E>0&&i.length>=E&&(v(i),i=[]))};let i=[];return l.search(t).then(c=>(i.length&&v(i),c),c=>(i.length&&v(i),Promise.reject(c)))}}e.FileSearchManager=P}),define(Pe[267],Te([1,0,18,100,37,90,28,12,19,23,15,16,2,281,168,43,14,54,103,265,47]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t,i,c,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let k=class{constructor(u,g,O,z,H){this.configurationService=u,this.workspaceContextService=g,this.editorGroupsService=O,this.logService=z,this.pathService=H}text(u,g,O={}){u=this.getContentPattern(u,O);const z=this.configurationService.getValue(),H=g&&g.some($=>!this.configurationService.getValue({resource:$}).search.useRipgrep);return{...this.commonQuery(g?.map(i.toWorkspaceFolder),O),type:2,contentPattern:u,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:z.search.usePCRE2||H||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}getContentPattern(u,g){const O=this.configurationService.getValue();u.isRegExp&&(u.pattern=u.pattern.replace(/\r?\n/g,"\\n"));const z={...u,wordSeparators:O.editor.wordSeparators};return this.isCaseSensitive(u,g)&&(z.isCaseSensitive=!0),this.isMultiline(u)&&(z.isMultiline=!0),g.notebookSearchConfig?.includeMarkupInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownInput=g.notebookSearchConfig.includeMarkupInput),g.notebookSearchConfig?.includeMarkupPreview&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownPreview=g.notebookSearchConfig.includeMarkupPreview),g.notebookSearchConfig?.includeCodeInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellInput=g.notebookSearchConfig.includeCodeInput),g.notebookSearchConfig?.includeOutput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellOutput=g.notebookSearchConfig.includeOutput),z}file(u,g={}){return{...this.commonQuery(u,g),type:1,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey}}handleIncludeExclude(u,g){return u?(u=Array.isArray(u)?u.map(b):b(u),g?this.parseSearchPaths(u):{pattern:a(...Array.isArray(u)?u:[u])}):{}}commonQuery(u=[],g={}){const O=this.handleIncludeExclude(g.includePattern,g.expandPatterns),z=this.handleIncludeExclude(g.excludePattern,g.expandPatterns),H=u.length>1,B=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(M=>this.getFolderQueryForSearchPath(M,g,z)):u.map(M=>this.getFolderQueryForRoot(M,g,z,H))).filter(M=>!!M),$={_reason:g._reason,folderQueries:B,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:z.pattern,includePattern:O.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const M=S.coalesce(S.flatten(this.editorGroupsService.groups.map(we=>we.editors.map(_e=>_e.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const ne=M.filter(we=>(0,C.pathIncludedInQuery)($,we.fsPath)),Q=this.commonQueryFromFileList(ne);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Q)),{...$,...Q}}const x=g.extraFileResources&&g.extraFileResources.filter(M=>(0,C.pathIncludedInQuery)($,M.fsPath));return $.extraFileResources=x&&x.length?x:void 0,$}commonQueryFromFileList(u){const g=[],O=new T.ResourceMap,z={};let H=!1;return u.forEach(B=>{if(B.scheme===h.Schemas.walkThrough)return;if((0,m.isAbsolutePath)(B)){const x=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:y.dirname(B.fsPath)});let M=O.get(x);M||(H=!0,M={folder:x,includePattern:{}},g.push(M),O.set(x,M));const ne=y.relative(x.fsPath,B.fsPath);(0,D.assertIsDefined)(M.includePattern)[ne.replace(/\\/g,"/")]=!0}else B.fsPath&&(H=!0,z[B.fsPath]=!0)}),{folderQueries:g,includePattern:z,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}isCaseSensitive(u,g){if(g.isSmartCase){if(u.isRegExp){if(P.containsUppercaseCharacter(u.pattern,!0))return!0}else if(P.containsUppercaseCharacter(u.pattern))return!0}return!!u.isCaseSensitive}isMultiline(u){return u.isMultiline||u.isRegExp&&(0,E.isMultilineRegexSource)(u.pattern)||u.pattern.indexOf(`
`)>=0?!0:!!u.isMultiline}parseSearchPaths(u){const g=Q=>y.isAbsolute(Q)||/^\.\.?([\/\\]|$)/.test(Q),z=(Array.isArray(u)?u:r(u)).map(Q=>{const we=this.pathService.resolvedUserHome;return we?(0,L.untildify)(Q,we.scheme===h.Schemas.file?we.fsPath:we.path):Q}),H=A.groupBy(z,Q=>g(Q)?"searchPaths":"exprSegments"),B=(H.exprSegments||[]).map(Q=>P.rtrim(Q,"/")).map(Q=>P.rtrim(Q,"\\")).map(Q=>(Q[0]==="."&&(Q="*"+Q),s(Q))),$={},x=this.expandSearchPathPatterns(H.searchPaths||[]);x&&x.length&&($.searchPaths=x);const M=S.flatten(B),ne=a(...M);return ne&&($.pattern=ne),$}getExcludesForFolder(u,g){return g.disregardExcludeSettings?void 0:(0,C.getExcludes)(u,!g.disregardSearchExcludeSettings)}expandSearchPathPatterns(u){if(!u||!u.length)return[];const g=u.flatMap(z=>{let{pathPortion:H,globPortion:B}=n(z);return B&&(B=p(B)),this.expandOneSearchPath(H).flatMap(x=>this.resolveOneSearchPathPattern(x,B))}),O=new Map;return g.forEach(z=>{const H=z.searchPath.toString(),B=O.get(H);B?z.pattern&&(B.pattern=B.pattern||{},B.pattern[z.pattern]=!0):O.set(H,{searchPath:z.searchPath,pattern:z.pattern?a(z.pattern):void 0})}),Array.from(O.values())}expandOneSearchPath(u){if(y.isAbsolute(u)){const g=this.workspaceContextService.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==h.Schemas.file?[{searchPath:g[0].uri.with({path:u})}]:[{searchPath:l.URI.file(y.normalize(u))}]}if(this.workspaceContextService.getWorkbenchState()===2){const g=this.workspaceContextService.getWorkspace().folders[0].uri;if(u=b(u),u.startsWith("../")||u===".."){const z=y.posix.resolve(g.path,u);return[{searchPath:g.with({path:z})}]}const O=p(u);return[{searchPath:g,pattern:O}]}else{if(u==="./"||u===".\\")return[];{const g=u.replace(/^\.[\/\\]/,""),z=this.workspaceContextService.getWorkspace().folders.map(H=>{const B=g.match(new RegExp(`^${P.escapeRegExpCharacters(H.name)}(?:/(.*)|$)`));return B?{match:B,folder:H}:null}).filter(D.isDefined);if(z.length)return z.map(H=>{const B=H.match[1];return{searchPath:H.folder.uri,pattern:B&&p(B)}});{const H=u.match(/\.[\/\\](.+)[\/\\]?/),B=H?H[1]:u,$=v.localize(0,null,B);throw new Error($)}}}}resolveOneSearchPathPattern(u,g){const O=u.pattern&&g?`${u.pattern}/${g}`:u.pattern||g,z=[{searchPath:u.searchPath,pattern:O}];return O&&!O.endsWith("**")&&z.push({searchPath:u.searchPath,pattern:O+"/**"}),z}getFolderQueryForSearchPath(u,g,O){const z=this.getFolderQueryForRoot((0,i.toWorkspaceFolder)(u.searchPath),g,O,!1);return z?{...z,includePattern:u.pattern}:null}getFolderQueryForRoot(u,g,O,z){let H;const B=l.URI.isUri(u)?u:u.uri;if(O.searchPaths){const Q=O.searchPaths.filter(we=>(0,m.isEqual)(we.searchPath,B))[0];if(Q&&!Q.pattern)return null;Q&&(H=Q.pattern)}const $=this.configurationService.getValue({resource:B}),M={...this.getExcludesForFolder($,g)||{},...H||{}},ne=l.URI.isUri(u)?(0,m.basename)(u):u.name;return{folder:B,folderName:z?ne:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:$.files&&$.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!$.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!$.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof g.disregardParentIgnoreFiles=="boolean"?g.disregardParentIgnoreFiles:!$.search.useParentIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!$.search.followSymlinks}}};e.QueryBuilder=k,e.QueryBuilder=k=Ve([ze(0,d.IConfigurationService),ze(1,i.IWorkspaceContextService),ze(2,c.IEditorGroupsService),ze(3,t.ILogService),ze(4,f.IPathService)],k);function n(o){const u=o.match(/[\*\{\}\(\)\[\]\?]/);if(u){const g=u.index,O=o.substr(0,g).match(/[/|\\][^/\\]*$/);if(O){let z=o.substr(0,O.index);return z.match(/[/\\]/)||(z+="/"),{pathPortion:z,globPortion:o.substr((O.index||0)+1)}}}return{pathPortion:o}}function a(...o){return o.length?o.reduce((u,g)=>(u[g]=!0,u),Object.create(null)):void 0}function r(o){return I.splitGlobAware(o,",").map(u=>u.trim()).filter(u=>!!u.length)}function s(o){return[`**/${o}/**`,`**/${o}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function b(o){return o.replace(/\\/g,"/")}function p(o){return b(o).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(o){return o.replace(/([?*[\]])/g,"[$1]")}function _(o,u){o=S.distinct(o,z=>z.toString());const g=[],O=u.getWorkspace();return o&&o.forEach(z=>{let H;if(u.getWorkbenchState()===2)H=(0,m.relativePath)(O.folders[0].uri,z),H&&H!=="."&&(H="./"+H);else{const B=u.getWorkspaceFolder(z);if(B){const $=B.name;if(O.folders.filter(M=>M.name===$).length===1){const M=(0,m.relativePath)(B.uri,z);M===""?H=`./${B.name}`:H=`./${B.name}/${M}`}else H=z.fsPath}}H&&g.push(w(H))}),g}e.resolveResourcesForSearchIncludes=_}),define(Pe[268],Te([1,0,23,2,21,9,4,267,47,54]),function(ve,e,S,A,I,L,T,h,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const P=7e3;function D(d,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const c=[],f=[];for(const s of i)if(/^workspaceContains:/.test(s)){const b=s.substr(18);b.indexOf("*")>=0||b.indexOf("?")>=0||d.forceUsingSearch?f.push(b):c.push(b)}if(c.length===0&&f.length===0)return Promise.resolve(void 0);let C;const k=new Promise((s,b)=>{C=s}),n=s=>C({activationEvent:s}),a=Promise.all(c.map(s=>l(d,s,n))).then(()=>{}),r=E(d,t.identifier,f,n);return Promise.all([a,r]).then(()=>{C(void 0)}),k}e.checkActivateWorkspaceContainsExtension=D;async function l(d,t,i){for(const c of d.folders)if(await d.exists(S.joinPath(A.URI.revive(c),t))){i(`workspaceContains:${t}`);return}}async function E(d,t,i,c){if(i.length===0)return Promise.resolve(void 0);const f=new I.CancellationTokenSource,C=d.checkExists(d.folders,i,f.token),k=setTimeout(async()=>{f.cancel(),d.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let n=!1;try{n=await C}catch(a){L.isCancellationError(a)||L.onUnexpectedError(a)}f.dispose(),clearTimeout(k),n&&c(`workspaceContains:${i.join(",")}`)}function v(d,t,i,c){const f=d.get(T.IInstantiationService),C=d.get(y.ISearchService),n=f.createInstance(h.QueryBuilder).file(t.map(a=>(0,m.toWorkspaceFolder)(A.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return C.fileSearch(n,c).then(a=>!!a.limitHit,a=>L.isCancellationError(a)?!1:Promise.reject(a))}e.checkGlobFileExists=v}),define(Pe[35],Te([1,0,149,19,87,23,13,6,48,2,14,3,34,210,84,33,26,107,9,20,25,189,7,97,4,27,85,17,72,86,63,5,268,83,191,12,81,59,22,82]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t,i,c,f,C,k,n,a,r,s,b,p,w,_,o,u,g,O,z,H,B,$,x,M){"use strict";var ne;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let Q=ne=class extends h.Disposable{constructor(J,le,N,q,ue,Se,be,Ee,ye,oe,de,re){super(),this._extHostManagedSockets=re,this._onDidChangeRemoteConnectionData=this._register(new u.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=le,this._extHostContext=N,this._initData=be,this._extHostWorkspace=q,this._extHostConfiguration=ue,this._logService=Se,this._extHostTunnelService=ye,this._extHostTerminalService=oe,this._extHostLocalizationService=de,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(D.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(D.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(D.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._activationEventsReader=new ke(this._initData.activationEvents),this._globalRegistry=new i.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.allExtensions);const ie=new f.ExtensionIdentifierSet(this._initData.myExtensions);this._myRegistry=new i.ExtensionDescriptionRegistry(this._activationEventsReader,Y(this._globalRegistry,ie)),this._storage=new v.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Ee,this._instaService=J.createChild(new w.ServiceCollection([v.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState])),this._activator=this._register(new E.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(me,Ce,R)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(me,c.transformErrorForSerialization(Ce),R)},actualActivateExtension:async(me,Ce)=>{if(i.ExtensionDescriptionRegistry.isHostExtension(me,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(me,Ce),new E.HostExtension;const R=this._myRegistry.getExtensionDescription(me);return this._activateExtension(R,Ce)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(J){c.onUnexpectedError(J)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let J=[];try{J=this._myRegistry.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this._deactivate(ue))}catch{}await Promise.all(J)}terminate(J,le=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${J}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),c.setUnexpectedErrorHandler(q=>{this._logService.error(q)}),this._extHostContext.dispose();const N=this._deactivateAll();Promise.race([(0,T.timeout)(5e3),N]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${le}`):this._logService.info(`Extension host exiting with code ${le}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(le)})}isActivated(J){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(J):!1}async getExtension(J){const le=await this._mainThreadExtensionsProxy.$getExtension(J);return le&&{...le,identifier:new f.ExtensionIdentifier(le.identifier.value),extensionLocation:m.URI.revive(le.extensionLocation)}}_activateByEvent(J,le){return this._activator.activateByEvent(J,le)}_activateById(J,le){return this._activator.activateById(J,le)}activateByIdWithErrors(J,le){return this._activateById(J,le).then(()=>{const N=this._activator.getActivatedExtension(J);if(N.activationFailed)return Promise.reject(N.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(J=>this._myRegistry)}getExtensionExports(J){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(J).exports;try{return this._activator.getActivatedExtension(J).exports}catch{return null}}async _realPathExtensionUri(J){if(J.scheme===H.Schemas.file&&this._hostUtils.fsRealpath){const le=await this._hostUtils.fsRealpath(J.fsPath);return m.URI.file(le)}return J}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(J=>new he(J))),this._extensionPathIndex}async _createExtensionPathIndex(J){const le=y.TernarySearchTree.forUris(N=>L.extUriBiasedIgnorePathCase.ignorePathCasing(N));return await Promise.all(J.map(async N=>{if(this._getEntryPoint(N)){const q=await this._realPathExtensionUri(N.extensionLocation);le.set(q,N)}})),le}_deactivate(J){let le=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(J))return le;const N=this._activator.getActivatedExtension(J);if(!N)return le;try{typeof N.module.deactivate=="function"&&(le=Promise.resolve(N.module.deactivate()).then(void 0,q=>(this._logService.error(q),Promise.resolve(void 0))))}catch(q){this._logService.error(`An error occurred when deactivating the extension '${J.value}':`),this._logService.error(q)}try{(0,h.dispose)(N.subscriptions)}catch(q){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${J.value}':`),this._logService.error(q)}return le}async _activateExtension(J,le){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(J.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(J.identifier),this._doActivateExtension(J,le).then(N=>{const q=N.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(J.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,le),this._logExtensionActivationTimes(J,le,"success",q),N},N=>{throw this._logExtensionActivationTimes(J,le,"failure"),N})}_logExtensionActivationTimes(J,le,N,q){const ue=_e(J,le);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ue,...q||{},outcome:N})}_doActivateExtension(J,le){const N=_e(J,le);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",N);const q=this._getEntryPoint(J);if(!q)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${J.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${J.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this._logService.flush();const ue=new E.ExtensionActivationTimesBuilder(le.startup);return Promise.all([this._loadCommonJSModule(J,(0,L.joinPath)(J.extensionLocation,q),ue),this._loadExtensionContext(J)]).then(Se=>(I.mark(`code/extHost/willActivateExtension/${J.identifier.value}`),ne._callActivate(this._logService,J.identifier,Se[0],Se[1],ue))).then(Se=>(I.mark(`code/extHost/didActivateExtension/${J.identifier.value}`),Se))}_loadExtensionContext(J){const le=new k.ExtensionGlobalMemento(J,this._storage),N=new k.ExtensionMemento(J.identifier.value,!1,this._storage),q=new z.ExtensionSecrets(J,this._secretState),ue=J.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,Se=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${J.identifier.value}`),Promise.all([le.whenReady,N.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let Ee,ye;const oe=(0,t.isProposedApiEnabled)(J,"ipc")?this._initData.messagePorts?.get(f.ExtensionIdentifier.toKey(J.identifier)):void 0;return Object.freeze({globalState:le,workspaceState:N,secrets:q,subscriptions:[],get extensionUri(){return J.extensionLocation},get extensionPath(){return J.extensionLocation.fsPath},asAbsolutePath(de){return A.join(J.extensionLocation.fsPath,de)},get storagePath(){return be._storagePath.workspaceValue(J)?.fsPath},get globalStoragePath(){return be._storagePath.globalValue(J).fsPath},get logPath(){return A.join(be._initData.logsLocation.fsPath,J.identifier.value)},get logUri(){return m.URI.joinPath(be._initData.logsLocation,J.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(J)},get globalStorageUri(){return be._storagePath.globalValue(J)},get extensionMode(){return ue},get extension(){return Ee===void 0&&(Ee=new Ae(be,J.identifier,J,Se,!1)),Ee},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(J,"extensionRuntime"),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(J)},get messagePassingProtocol(){if(!ye){if(!oe)return;const de=u.Event.buffer(u.Event.fromDOMEventEmitter(oe,"message",re=>re.data));oe.start(),ye={onDidReceiveMessage:de,postMessage:oe.postMessage.bind(oe)}}return ye}})})}static _callActivate(J,le,N,q,ue){return N=N||{activate:void 0,deactivate:void 0},this._callActivateOptional(J,le,N,q,ue).then(Se=>new E.ActivatedExtension(!1,null,ue.build(),N,Se,q.subscriptions))}static _callActivateOptional(J,le,N,q,ue){if(typeof N.activate=="function")try{ue.activateCallStart(),J.trace(`ExtensionService#_callActivateOptional ${le.value}`);const Se=typeof global=="object"?global:self,be=N.activate.apply(Se,[q]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(be).then(Ee=>(ue.activateResolveStop(),Ee))}catch(Se){return Promise.reject(Se)}else return Promise.resolve(N)}_activateOneStartupFinished(J,le){this._activateById(J.identifier,{startup:!1,extensionId:J.identifier,activationEvent:le}).then(void 0,N=>{this._logService.error(N)})}_activateAllStartupFinishedDeferred(J,le=0){const q=Date.now();(0,x.setTimeout0)(()=>{for(let ue=le;ue<J.length;ue+=1){const Se=J[ue];for(const be of Se.activationEvents??[])if(be==="onStartupFinished")if(Date.now()-q>50){this._activateAllStartupFinishedDeferred(J,ue);break}else this._activateOneStartupFinished(Se,be)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks()),this._extHostConfiguration.getConfigProvider().then(J=>{const le=J.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),N=this._myRegistry.getAllExtensionDescriptions();if(le)this._activateAllStartupFinishedDeferred(N);else for(const q of N)if(q.activationEvents)for(const ue of q.activationEvents)ue==="onStartupFinished"&&this._activateOneStartupFinished(q,ue)})}_handleEagerExtensions(){const J=this._activateByEvent("*",!0).then(void 0,Se=>{this._logService.error(Se)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Se=>this._handleWorkspaceContainsEagerExtensions(Se.added)));const le=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],N=this._handleWorkspaceContainsEagerExtensions(le),q=this._handleRemoteResolverEagerExtensions(),ue=Promise.all([q,J,N]).then(()=>{});return Promise.race([ue,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ue}_handleWorkspaceContainsEagerExtensions(J){return J.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(le=>this._handleWorkspaceContainsEagerExtension(J,le))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(J,le){if(this.isActivated(le.identifier))return;const N=!this._initData.remote.isRemote&&!!this._initData.remote.authority,q={logService:this._logService,folders:J.map(Se=>Se.uri),forceUsingSearch:N||!this._hostUtils.fsExists,exists:Se=>this._hostUtils.fsExists(Se.fsPath),checkExists:(Se,be,Ee)=>this._mainThreadWorkspaceProxy.$checkExists(Se,be,Ee)},ue=await(0,g.checkActivateWorkspaceContainsExtension)(q,le);if(ue)return this._activateById(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:ue.activationEvent}).then(void 0,Se=>this._logService.error(Se))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(J){throw console.error(J),J}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:J,extensionTestsLocationURI:le}=this._initData.environment;if(!J||!le)throw new Error(S.localize(0,null));const N=await this._loadCommonJSModule(null,le,new E.ExtensionActivationTimesBuilder(!1));if(!N||typeof N.run!="function")throw new Error(S.localize(1,null,le.toString()));return new Promise((q,ue)=>{const Se=(ye,oe)=>{ye?ue(ye):q(typeof oe=="number"&&oe>0?1:0)},be=(0,L.originalFSPath)(le),Ee=N.run(be,Se);Ee&&Ee.then&&Ee.then(()=>{q(0)}).catch(ye=>{ue(ye instanceof Error&&ye.stack?ye.stack:String(ye))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,T.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(J,le){return this._resolvers[J]=le,(0,h.toDisposable)(()=>{delete this._resolvers[J]})}async getRemoteExecServer(J){const{resolver:le}=await this._activateAndGetResolver(J);return le?.resolveExecServer?.(J,{resolveAttempt:0})}async _activateAndGetResolver(J){const le=J.indexOf("+");if(le===-1)throw new n.RemoteAuthorityResolverError("Not an authority that can be resolved!",a.RemoteAuthorityResolverErrorCode.InvalidAuthority);const N=J.substr(0,le);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${N}`,!1),{authorityPrefix:N,resolver:this._resolvers[N]}}async $resolveAuthority(J,le){const N=$.StopWatch.create(!1),q=()=>`[resolveAuthority(${(0,a.getRemoteAuthorityPrefix)(J)},${le})][${N.elapsed()}ms] `,ue=K=>this._logService.info(`${q()}${K}`),Se=K=>this._logService.warn(`${q()}${K}`),be=(K,G=void 0)=>this._logService.error(`${q()}${K}`,G),Ee=K=>{if(K instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K},ye=async K=>{ue(`activating resolver for ${K}...`);const{resolver:G,authorityPrefix:V}=await this._activateAndGetResolver(K);if(!G)throw be(`no resolver for ${V}`),new n.RemoteAuthorityResolverError(`No remote extension installed to resolve ${V}.`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:V,remoteAuthority:K}},oe=J.split(/@|%40/g).reverse();ue(`activating remote resolvers ${oe.join(" -> ")}`);let de;try{de=await Promise.all(oe.map(ye)).catch(async K=>{if(!(K instanceof n.RemoteAuthorityResolverError)||K._code!==a.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw K;return Se(`resolving nested authorities failed: ${K.message}`),[await ye(J)]})}catch(K){return Ee(K)}const re=new T.IntervalTimer;re.cancelAndSet(()=>ue("waiting..."),1e3);let ie,me;for(const[K,{authorityPrefix:G,resolver:V,remoteAuthority:ee}]of de.entries())try{if(K===de.length-1)ue("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${G}`),ie=await V.resolve(ee,{resolveAttempt:le,execServer:me}),I.mark(`code/extHost/didResolveAuthorityOK/${G}`),ue("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(V,n.ManagedResolvedAuthority.isManagedResolvedAuthority(ie)?ie:void 0));else{if(ue(`invoking resolveExecServer() for ${ee}`),I.mark(`code/extHost/willResolveExecServer/${G}`),me=await V.resolveExecServer?.(ee,{resolveAttempt:le,execServer:me}),!me)throw new n.RemoteAuthorityResolverError(`Exec server was not available for ${ee}`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(ce){return I.mark(`code/extHost/didResolveAuthorityError/${G}`),be("returned an error",ce),re.dispose(),Ee(ce)}re.dispose();const Ce={environmentTunnels:ie.environmentTunnels,features:ie.tunnelFeatures},R={extensionHostEnv:ie.extensionHostEnv,isTrusted:ie.isTrusted,authenticationSession:ie.authenticationSessionForInitializingExtensions?{id:ie.authenticationSessionForInitializingExtensions.id,providerId:ie.authenticationSessionForInitializingExtensions.providerId}:void 0};ue(`returned ${n.ManagedResolvedAuthority.isManagedResolvedAuthority(ie)?"managed authority":`${ie.host}:${ie.port}`}`);let W;if(n.ManagedResolvedAuthority.isManagedResolvedAuthority(ie)){const K=le;this._extHostManagedSockets.setFactory(K,ie.makeConnection),W={authority:J,connectTo:new a.ManagedRemoteConnection(K),connectionToken:ie.connectionToken}}else W={authority:J,connectTo:new a.WebSocketRemoteConnection(ie.host,ie.port),connectionToken:ie.connectionToken};return{type:"ok",value:{authority:W,options:R,tunnelInformation:Ce}}}async $getCanonicalURI(J,le){this._logService.info(`$getCanonicalURI invoked for authority (${(0,a.getRemoteAuthorityPrefix)(J)})`);const{resolver:N}=await this._activateAndGetResolver(J);if(!N)return null;const q=m.URI.revive(le);if(typeof N.getCanonicalURI>"u")return q;const ue=await(0,T.asPromise)(()=>N.getCanonicalURI(q));return ue||q}$startExtensionHost(J){J.toAdd.forEach(q=>q.extensionLocation=m.URI.revive(q.extensionLocation));const{globalRegistry:le,myExtensions:N}=we(this._activationEventsReader,this._globalRegistry,this._myRegistry,J);return this._globalRegistry.set(le.getAllExtensionDescriptions()),this._myRegistry.set(N),this._startExtensionHost()}$activateByEvent(J,le){return le===1?this._almostReadyToRunExtensions.wait().then(N=>this._activateByEvent(J,!1)):this._readyToRunExtensions.wait().then(N=>this._activateByEvent(J,!1))}async $activate(J,le){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(J)?(await this._activateById(J,le),!0):!1}async $deltaExtensions(J){J.toAdd.forEach(Se=>Se.extensionLocation=m.URI.revive(Se.extensionLocation));const{globalRegistry:le,myExtensions:N}=we(this._activationEventsReader,this._globalRegistry,this._myRegistry,J),q=await this._createExtensionPathIndex(N);return(await this.getExtensionPathIndex()).setSearchTree(q),this._globalRegistry.set(le.getAllExtensionDescriptions()),this._myRegistry.set(N),Promise.resolve(void 0)}async $test_latency(J){return J}async $test_up(J){return J.byteLength}async $test_down(J){const le=C.VSBuffer.alloc(J),N=Math.random()%256;for(let q=0;q<J;q++)le.writeUInt8(N,q);return le}async $updateRemoteConnectionData(J){this._remoteConnectionData=J,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=Q,e.AbstractExtHostExtensionService=Q=ne=Ve([ze(0,r.IInstantiationService),ze(1,e.IHostUtils),ze(2,p.IExtHostRpcService),ze(3,d.IExtHostWorkspace),ze(4,l.IExtHostConfiguration),ze(5,P.ILogService),ze(6,s.IExtHostInitDataService),ze(7,b.IExtensionStoragePaths),ze(8,_.IExtHostTunnelService),ze(9,o.IExtHostTerminalService),ze(10,B.IExtHostLocalizationService),ze(11,M.IExtHostManagedSockets)],Q);function we(ae,J,le,N){ae.addActivationEvents(N.addActivationEvents);const q=new i.ExtensionDescriptionRegistry(ae,J.getAllExtensionDescriptions());q.deltaExtensions(N.toAdd,N.toRemove);const ue=new f.ExtensionIdentifierSet(le.getAllExtensionDescriptions().map(be=>be.identifier));for(const be of N.myToRemove)ue.delete(be);for(const be of N.myToAdd)ue.add(be);const Se=Y(q,ue);return{globalRegistry:q,myExtensions:Se}}function _e(ae,J){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:J.activationEvent,reasonId:J.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class Ae{#e;#t;#i;constructor(J,le,N,q,ue){this.#e=J,this.#t=le,this.#i=N.identifier,this.id=N.identifier.value,this.extensionUri=N.extensionLocation,this.extensionPath=A.normalize((0,L.originalFSPath)(N.extensionLocation)),this.packageJSON=N,this.extensionKind=q,this.isFromDifferentExtensionHost=ue}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=Ae;function Y(ae,J){return ae.getAllExtensionDescriptions().filter(le=>J.has(le.identifier))}class he{constructor(J){this._searchTree=J}setSearchTree(J){this._searchTree=J}findSubstr(J){return this._searchTree.findSubstr(J)}forEach(J){return this._searchTree.forEach(J)}}e.ExtensionPaths=he;class ke{constructor(J){this._map=new f.ExtensionIdentifierMap,this.addActivationEvents(J)}readActivationEvents(J){return this._map.get(J.identifier)}addActivationEvents(J){for(const le of Object.keys(J))this._map.set(le,J[le])}}}),define(Pe[269],Te([1,0,87,2,3,34,26,20,17,27,4,35,52,14,15]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let t=class{constructor(n,a,r,s,b,p,w){this._apiFactory=n,this._extensionRegistry=a,this._instaService=r,this._extHostConfiguration=s,this._extHostExtensionService=b,this._initData=p,this._logService=w,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),S.mark("code/extHost/willWaitForConfig");const n=await this._extHostConfiguration.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new c(this._apiFactory,a,this._extensionRegistry,n,this._logService)),this.register(this._instaService.createInstance(f,a)),this.register(this._instaService.createInstance(i)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(C,a,this._initData.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const a of n.nodeModuleName)this._factories.set(a,n);else this._factories.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this._alternatives.push(a=>n.alternativeModuleName(a))}};e.RequireInterceptor=t,e.RequireInterceptor=t=Ve([ze(2,P.IInstantiationService),ze(3,L.IExtHostConfiguration),ze(4,D.IExtHostExtensionService),ze(5,m.IExtHostInitDataService),ze(6,E.ILogService)],t);let i=class{static{d=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&d.aliased.size){const a=(0,v.escapeRegExpCharacters)(this.forceForwardSlashes(n.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,b="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${b}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(n){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(n));if(!a)return;const[,r,s,b]=a,p=d.aliased.get(s);if(p!==void 0)return console.warn(`${s} as been renamed to ${p}, please update your imports`),r+p+b}forceForwardSlashes(n){return n.replace(/\\/g,"/")}};i=d=Ve([ze(0,m.IExtHostInitDataService)],i);class c{constructor(n,a,r,s,b){this._apiFactory=n,this._extensionPaths=a,this._extensionRegistry=r,this._configProvider=s,this._logService=b,this.nodeModuleName="vscode",this._extApiImpl=new h.ExtensionIdentifierMap}load(n,a){const r=this._extensionPaths.findSubstr(a);if(r){let s=this._extApiImpl.get(r.identifier);return s||(s=this._apiFactory(r,this._extensionRegistry,this._configProvider),this._extApiImpl.set(r.identifier,s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((b,p)=>s+=`	${p} -> ${b.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let f=class{constructor(n,a,r){this._extensionPaths=n,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(I.MainContext.MainThreadTelemetry);const{environment:s}=r,b=a.getProxy(I.MainContext.MainThreadKeytar);if(s.appRoot){let p=s.appRoot.fsPath;l.platform==="win32"&&(p=p.replace(/\\/g,"/")),p[p.length-1]==="/"&&(p=p.substr(0,p.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${p}/node_modules.asar/keytar`),this.alternativeNames.add(`${p}/node_modules/keytar`)}this._impl={getPassword:(p,w)=>b.$getPassword(p,w),setPassword:(p,w,_)=>b.$setPassword(p,w,_),deletePassword:(p,w)=>b.$deletePassword(p,w),findPassword:p=>b.$findPassword(p),findCredentials(p){return b.$findCredentials(p)}}}load(n,a){const r=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:r?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(n){const a=n.length;if(a<=7||!this.alternativeNames)return;const r=a-7;if((n.charAt(r)==="/"||n.charAt(r)==="\\")&&n.endsWith("keytar")&&(n=n.replace(/\\/g,"/"),this.alternativeNames.has(n)))return"keytar"}};f=Ve([ze(1,y.IExtHostRpcService),ze(2,m.IExtHostInitDataService)],f);let C=class{constructor(n,a,r){this._extensionPaths=n,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=r.getProxy(I.MainContext.MainThreadTelemetry);const s=r.getProxy(I.MainContext.MainThreadWindow);this._impl=(b,p)=>{const w=A.URI.parse(b);return p?this.callOriginal(b,p):w.scheme==="http"||w.scheme==="https"?s.$openUri(w,b,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this._appUriScheme?s.$openUri(w,b,{}):this.callOriginal(b,p)}}load(n,a,r){const s=this._extensionPaths.findSubstr(a);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=r(n),this._impl}callOriginal(n,a){return this.sendNoForwardTelemetry(),this._original(n,a)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};C=Ve([ze(2,y.IExtHostRpcService)],C)}),define(Pe[113],Te([1,0,66,6,19,52,4,60,61,35,7,33,201,34]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,T.createDecorator)("IExtHostVariableResolverProvider");class v extends l.AbstractVariableResolverService{constructor(i,c,f,C,k,n,a){function r(){if(f){const s=f.activeEditor();if(s)return s.document.uri;const b=C.tabGroups.all.find(p=>p.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof P.TextDiffTabInput||b.input instanceof P.NotebookDiffEditorTabInput)return b.input.modified;if(b.input instanceof P.TextTabInput||b.input instanceof P.NotebookEditorTabInput||b.input instanceof P.CustomEditorTabInput)return b.input.uri}}}super({getFolderUri:s=>{const b=n.folders.filter(p=>p.name===s);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(s,b)=>k.getConfiguration(void 0,s).get(b),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=r();if(s)return I.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const s=r();if(s){const b=c.getWorkspaceFolder(s);if(b)return I.normalize(b.uri.fsPath)}}},getSelectedText:()=>{if(f){const s=f.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(f){const s=f.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>i.getExtension(s)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(L.env))}}let d=class extends A.Disposable{constructor(i,c,f,C,k){super(),this.extensionService=i,this.workspaceService=c,this.editorService=f,this.configurationService=C,this.editorTabs=k,this._resolver=new S.Lazy(async()=>{const n=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new v(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,n,r,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=d,e.ExtHostVariableResolverProviderService=d=Ve([ze(0,m.IExtHostExtensionService),ze(1,D.IExtHostWorkspace),ze(2,h.IExtHostDocumentsAndEditors),ze(3,E.IExtHostConfiguration),ze(4,y.IExtHostEditorTabs)],d)}),define(Pe[114],Te([1,0,13,5,2,4,3,61,35,17,7,33,194,196,34,113]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,L.createDecorator)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(a,r,s,b,p,w){this._workspaceService=r,this._extensionService=s,this._configurationService=b,this._editorTabs=p,this._variableResolver=w,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=a.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter,this._onDidChangeStackFrameFocus=new A.Emitter,this._activeDebugConsole=new c(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(_=>{_.onDidChange(o=>{this.registerAllDebugTypes(_)}),this.registerAllDebugTypes(_)})}asDebugSourceUri(a,r){const s=a;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let b=`debug:${encodeURIComponent(s.path||"")}`,p="?";return r&&(b+=`${p}session=${encodeURIComponent(r.id)}`,p="&"),b+=`${p}ref=${s.sourceReference}`,I.URI.parse(b)}else{if(s.path)return I.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(a){const r=[];for(const s of a.getAllExtensionDescriptions())if(s.contributes){const b=s.contributes.debuggers;if(b&&b.length>0)for(const p of b)(0,E.isDebuggerMainContribution)(p)&&r.push(p.type)}this._debugServiceProxy.$registerDebugTypes(r)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const a=[];return this._breakpoints.forEach(r=>a.push(r)),a}addBreakpoints(a){const r=a.filter(p=>{const w=p.id;return this._breakpoints.has(w)?!1:(this._breakpoints.set(w,p),!0)});this.fireBreakpointChanges(r,[],[]);const s=[],b=new Map;for(const p of r)if(p instanceof P.SourceBreakpoint){let w=b.get(p.location.uri.toString());w||(w={type:"sourceMulti",uri:p.location.uri,lines:[]},b.set(p.location.uri.toString(),w),s.push(w)),w.lines.push({id:p.id,enabled:p.enabled,condition:p.condition,hitCondition:p.hitCondition,logMessage:p.logMessage,line:p.location.range.start.line,character:p.location.range.start.character})}else p instanceof P.FunctionBreakpoint&&s.push({type:"function",id:p.id,enabled:p.enabled,hitCondition:p.hitCondition,logMessage:p.logMessage,condition:p.condition,functionName:p.functionName});return this._debugServiceProxy.$registerBreakpoints(s)}removeBreakpoints(a){const r=a.filter(w=>this._breakpoints.delete(w.id));this.fireBreakpointChanges([],r,[]);const s=r.filter(w=>w instanceof P.SourceBreakpoint).map(w=>w.id),b=r.filter(w=>w instanceof P.FunctionBreakpoint).map(w=>w.id),p=r.filter(w=>w instanceof P.DataBreakpoint).map(w=>w.id);return this._debugServiceProxy.$unregisterBreakpoints(s,b,p)}startDebugging(a,r,s){return this._debugServiceProxy.$startDebugging(a?a.uri:void 0,r,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,suppressSaveBeforeStart:s.suppressSaveBeforeStart,suppressDebugStatusbar:s.suppressDebugStatusbar??s.debugUI?.simple,suppressDebugToolbar:s.suppressDebugToolbar??s.debugUI?.simple,suppressDebugView:s.suppressDebugView??s.debugUI?.simple})}stopDebugging(a){return this._debugServiceProxy.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,r,s){if(!r)return new P.Disposable(()=>{});const b=this._configProviderHandleCounter++;return this._configProviders.push({type:a,handle:b,provider:r}),this._debugServiceProxy.$registerDebugConfigurationProvider(a,s,!!r.provideDebugConfigurations,!!r.resolveDebugConfiguration,!!r.resolveDebugConfigurationWithSubstitutedVariables,b),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(p=>p.provider!==r),this._debugServiceProxy.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(a,r,s){if(!s)return new P.Disposable(()=>{});if(!this.definesDebugType(a,r))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${r}' debugger.`);if(this.getAdapterDescriptorFactoryByType(r))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:r,handle:b,factory:s}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(r,b),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(p=>p.factory!==s),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(a,r){if(!r)return new P.Disposable(()=>{});const s=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:a,handle:s,factory:r}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(b=>b.factory!==r)})}async $runInTerminal(a,r){return Promise.resolve(void 0)}async $substituteVariables(a,r){let s;const b=await this.getFolder(a);return b&&(s={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(s,r)}createDebugAdapter(a,r){if(a.type==="implementation")return new C(a.implementation)}createSignService(){}async $startDASession(a,r){const s=this,b=await this.getSession(r);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(b.type),b).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const w=this.convertToDto(p),_=this.createDebugAdapter(w,b);if(!_)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const o=_;return this._debugAdapters.set(a,o),this.getDebugAdapterTrackers(b).then(u=>(u&&this._debugAdaptersTrackers.set(a,u),o.onMessage(async g=>{if(g.type==="request"&&g.command==="handshake"){const O=g,z={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(O.arguments.value);z.body={signature:H},o.sendResponse(z)}else throw new Error("no signer")}catch(H){z.success=!1,z.message=H.message,o.sendResponse(z)}}else u&&u.onDidSendMessage&&u.onDidSendMessage(g),g=(0,E.convertToVSCPaths)(g,!0),s._debugServiceProxy.$acceptDAMessage(a,g)}),o.onError(g=>{u&&u.onError&&u.onError(g),this._debugServiceProxy.$acceptDAError(a,g.name,g.message,g.stack)}),o.onExit(g=>{u&&u.onExit&&u.onExit(g??void 0,void 0),this._debugServiceProxy.$acceptDAExit(a,g??void 0,void 0)}),u&&u.onWillStartSession&&u.onWillStartSession(),o.startSession()))})}$sendDAMessage(a,r){r=(0,E.convertToDAPaths)(r,!1);const s=this._debugAdaptersTrackers.get(a);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(r),this._debugAdapters.get(a)?.sendMessage(r)}$stopDASession(a){const r=this._debugAdaptersTrackers.get(a);this._debugAdaptersTrackers.delete(a),r&&r.onWillStopSession&&r.onWillStopSession();const s=this._debugAdapters.get(a);return this._debugAdapters.delete(a),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const r=[],s=[],b=[];if(a.added)for(const p of a.added){const w=p.id;if(w&&!this._breakpoints.has(w)){let _;if(p.type==="function")_=new P.FunctionBreakpoint(p.functionName,p.enabled,p.condition,p.hitCondition,p.logMessage);else if(p.type==="data")_=new P.DataBreakpoint(p.label,p.dataId,p.canPersist,p.enabled,p.hitCondition,p.condition,p.logMessage);else{const o=I.URI.revive(p.uri);_=new P.SourceBreakpoint(new P.Location(o,new P.Position(p.line,p.character)),p.enabled,p.condition,p.hitCondition,p.logMessage)}(0,P.setBreakpointId)(_,w),this._breakpoints.set(w,_),r.push(_)}}if(a.removed)for(const p of a.removed){const w=this._breakpoints.get(p);w&&(this._breakpoints.delete(p),s.push(w))}if(a.changed){for(const p of a.changed)if(p.id){const w=this._breakpoints.get(p.id);if(w){if(w instanceof P.FunctionBreakpoint&&p.type==="function"){const _=w;_.enabled=p.enabled,_.condition=p.condition,_.hitCondition=p.hitCondition,_.logMessage=p.logMessage,_.functionName=p.functionName}else if(w instanceof P.SourceBreakpoint&&p.type==="source"){const _=w;_.enabled=p.enabled,_.condition=p.condition,_.hitCondition=p.hitCondition,_.logMessage=p.logMessage,_.location=new P.Location(I.URI.revive(p.uri),new P.Position(p.line,p.character))}b.push(w)}}}this.fireBreakpointChanges(r,s,b)}async $acceptStackFrameFocus(a){let r;const s=a.sessionId?await this.getSession(a.sessionId):void 0;if(!s)throw new Error("no DebugSession found for debug focus context");a.kind==="thread"?r=new P.ThreadFocus(s,a.threadId):r=new P.StackFrameFocus(s,a.threadId,a.frameId),this._stackFrameFocus=r,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(a,r,s){return(0,S.asPromise)(async()=>{const b=this.getConfigProviderByHandle(a);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const p=await this.getFolder(r);return b.provideDebugConfigurations(p,s)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(a,r,s,b){return(0,S.asPromise)(async()=>{const p=this.getConfigProviderByHandle(a);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const w=await this.getFolder(r);return p.resolveDebugConfiguration(w,s,b)})}$resolveDebugConfigurationWithSubstitutedVariables(a,r,s,b){return(0,S.asPromise)(async()=>{const p=this.getConfigProviderByHandle(a);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const w=await this.getFolder(r);return p.resolveDebugConfigurationWithSubstitutedVariables(w,s,b)})}async $provideDebugAdapter(a,r){const s=this.getAdapterDescriptorFactoryByHandle(a);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.getSession(r);return this.getAdapterDescriptor(s,b).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.convertToDto(p)})}async $acceptDebugSessionStarted(a){const r=await this.getSession(a);this._onDidStartDebugSession.fire(r)}async $acceptDebugSessionTerminated(a){const r=await this.getSession(a);r&&(this._onDidTerminateDebugSession.fire(r),this._debugSessions.delete(r.id))}async $acceptDebugSessionActiveChanged(a){this._activeDebugSession=a?await this.getSession(a):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(a,r){(await this.getSession(a))?._acceptNameChanged(r)}async $acceptDebugSessionCustomEvent(a,r){const b={session:await this.getSession(a),event:r.event,body:r.body};this._onDidReceiveDebugSessionCustomEvent.fire(b)}convertToDto(a){if(a instanceof P.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof P.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(a){const r=this._adapterFactories.filter(s=>s.type===a);if(r.length>0)return r[0].factory}getAdapterDescriptorFactoryByHandle(a){const r=this._adapterFactories.filter(s=>s.handle===a);if(r.length>0)return r[0].factory}getConfigProviderByHandle(a){const r=this._configProviders.filter(s=>s.handle===a);if(r.length>0)return r[0].provider}definesDebugType(a,r){if(a.contributes){const s=a.contributes.debuggers;if(s&&s.length>0){for(const b of s)if(b.label&&b.type&&b.type===r)return!0}}return!1}getDebugAdapterTrackers(a){const s=a.configuration.type,b=this._trackerFactories.filter(p=>p.type===s||p.type==="*").map(p=>(0,S.asPromise)(()=>p.factory.createDebugAdapterTracker(a)).then(w=>w,w=>null));return Promise.race([Promise.all(b).then(p=>{const w=p.filter(_=>!!_);if(w.length>0)return new f(w)}),new Promise(p=>setTimeout(()=>p(void 0),1e3))]).catch(p=>{})}async getAdapterDescriptor(a,r){const s=r.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new P.DebugAdapterServer(s));if(a){const p=await this._extensionService.getExtensionRegistry();return(0,S.asPromise)(()=>a.createDebugAdapterDescriptor(r,this.daExecutableFromPackage(r,p))).then(w=>{if(w)return w})}const b=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(r,b))}daExecutableFromPackage(a,r){}fireBreakpointChanges(a,r,s){(a.length>0||r.length>0||s.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:a,removed:r,changed:s}))}async getSession(a){if(a)if(typeof a=="string"){const r=this._debugSessions.get(a);if(r)return r}else{let r=this._debugSessions.get(a.id);if(!r){const s=await this.getFolder(a.folderUri),b=a.parent?this._debugSessions.get(a.parent):void 0;r=new i(this._debugServiceProxy,a.id,a.type,a.name,s,a.configuration,b),this._debugSessions.set(r.id,r),this._debugServiceProxy.$sessionCached(r.id)}return r}throw new Error("cannot find session")}getFolder(a){if(a){const r=I.URI.revive(a);return this._workspaceService.resolveWorkspaceFolder(r)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=t,e.ExtHostDebugServiceBase=t=Ve([ze(0,m.IExtHostRpcService),ze(1,D.IExtHostWorkspace),ze(2,y.IExtHostExtensionService),ze(3,v.IExtHostConfiguration),ze(4,h.IExtHostEditorTabs),ze(5,d.IExtHostVariableResolverProvider)],t);class i{constructor(a,r,s,b,p,w,_){this._debugServiceProxy=a,this._id=r,this._type=s,this._name=b,this._workspaceFolder=p,this._configuration=w,this._parentSession=_}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(a){this._name=a,this._debugServiceProxy.$setDebugSessionName(this._id,a)}get parentSession(){return this._parentSession}_acceptNameChanged(a){this._name=a}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(a,r){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,a,r)}getDebugProtocolBreakpoint(a){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,a.id)}}e.ExtHostDebugSession=i;class c{constructor(a){this.value=Object.freeze({append(r){a.$appendDebugConsole(r)},appendLine(r){this.append(r+`
`)}})}}e.ExtHostDebugConsole=c;class f{constructor(a){this.trackers=a}onWillStartSession(){this.trackers.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.trackers.forEach(r=>r.onWillReceiveMessage?r.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.trackers.forEach(r=>r.onDidSendMessage?r.onDidSendMessage(a):void 0)}onWillStopSession(){this.trackers.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.trackers.forEach(r=>r.onError?r.onError(a):void 0)}onExit(a,r){this.trackers.forEach(s=>s.onExit?s.onExit(a,r):void 0)}}class C extends l.AbstractDebugAdapter{constructor(a){super(),this.implementation=a,a.onDidSendMessage(r=>{this.acceptMessage(r)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.implementation.handleMessage(a)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let k=class extends t{constructor(a,r,s,b,p,w){super(a,r,s,b,p,w)}};e.WorkerExtHostDebugService=k,e.WorkerExtHostDebugService=k=Ve([ze(0,m.IExtHostRpcService),ze(1,D.IExtHostWorkspace),ze(2,y.IExtHostExtensionService),ze(3,v.IExtHostConfiguration),ze(4,h.IExtHostEditorTabs),ze(5,d.IExtHostVariableResolverProvider)],k)}),define(Pe[270],Te([1,0,9,87,2,3,261,14,71,72,27,173,17,56,35,58]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class t{static async installEarlyHandler(f){Error.stackTraceLimit=100;const C=f.get(h.ILogService),n=f.get(l.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);S.setUnexpectedErrorHandler(a=>{C.error(a);const r=S.transformErrorForSerialization(a);n.$onUnexpectedError(r)})}static async installFullHandler(f){const C=f.get(h.ILogService),k=f.get(l.IExtHostRpcService),n=f.get(v.IExtHostExtensionService),a=f.get(d.IExtHostTelemetry),r=k.getProxy(L.MainContext.MainThreadExtensionService),s=k.getProxy(L.MainContext.MainThreadErrors),b=await n.getExtensionPathIndex(),p=new WeakMap;function w(u,g){if(p.has(u))return p.get(u).stack;let O="",z,H;for(const $ of g)O+=`
	at ${$.toString()}`,H=$.getFileName(),!z&&H&&(z=b.findSubstr(I.URI.file(H)));const B=`${u.name||"Error"}: ${u.message||""}${O}`;return p.set(u,{extensionIdentifier:z?.identifier,stack:B}),B}const _=Symbol("prepareStackTrace wrapped");let o=w;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return o},set(u){if(u===w||!u||u[_]){o=u||w;return}o=function(g,O){return w(g,O),u.call(Error,g,O)},Object.assign(o,{[_]:!0})}}),S.setUnexpectedErrorHandler(u=>{C.error(u);const g=S.transformErrorForSerialization(u),O=p.get(u);if(!O?.extensionIdentifier){s.$onUnexpectedError(g);return}r.$onExtensionRuntimeError(O.extensionIdentifier,g);const z=a.onExtensionError(O.extensionIdentifier,u);C.trace("forwarded error to extension?",z,O)})}}e.ErrorHandler=t;class i{constructor(f,C,k,n,a){this._hostUtils=k,this._rpcProtocol=new T.RPCProtocol(f,null,n),C=i._transform(C,this._rpcProtocol);const r=new m.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());r.set(P.IExtHostInitDataService,{_serviceBrand:void 0,...C,messagePorts:a}),r.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),r.set(E.IURITransformerService,new E.URITransformerService(n)),r.set(v.IHostUtils,k);const s=new D.InstantiationService(r,!0);s.invokeFunction(t.installEarlyHandler),this._logService=s.invokeFunction(b=>b.get(h.ILogService)),A.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",C),this._extensionService=s.invokeFunction(b=>b.get(v.IExtHostExtensionService)),this._extensionService.initialize(),s.invokeFunction(t.installFullHandler)}async asBrowserUri(f){const C=this._rpcProtocol.getProxy(L.MainContext.MainThreadExtensionService);return I.URI.revive(await C.$asBrowserUri(f))}terminate(f){this._extensionService.terminate(f)}static _transform(f,C){f.allExtensions.forEach(n=>{n.extensionLocation=I.URI.revive(C.transformIncomingURIs(n.extensionLocation))}),f.environment.appRoot=I.URI.revive(C.transformIncomingURIs(f.environment.appRoot));const k=f.environment.extensionDevelopmentLocationURI;return k&&(f.environment.extensionDevelopmentLocationURI=k.map(n=>I.URI.revive(C.transformIncomingURIs(n)))),f.environment.extensionTestsLocationURI=I.URI.revive(C.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=I.URI.revive(C.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=I.URI.revive(C.transformIncomingURIs(f.environment.workspaceStorageHome)),f.environment.extensionTelemetryLogResource=I.URI.revive(C.transformIncomingURIs(f.environment.extensionTelemetryLogResource)),f.nlsBaseUrl=I.URI.revive(C.transformIncomingURIs(f.nlsBaseUrl)),f.logsLocation=I.URI.revive(C.transformIncomingURIs(f.logsLocation)),f.workspace=C.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=i}),define(Pe[271],Te([1,0,18,13,21,41,12,19,23,2,47]),function(ve,e,S,A,I,L,T,h,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(c,f,C,k){this.query=c,this.provider=f,this.fileUtils=C,this.processType=k,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,f){const C=this.query.folderQueries||[],k=new I.CancellationTokenSource;return f.onCancellationRequested(()=>k.cancel()),new Promise((n,a)=>{this.collector=new E(c);let r=!1;const s=(b,p)=>{if(!r&&!this.isLimitHit){const w=this.resultSize(b);d(b)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,r=!0,k.cancel(),b=this.trimResultToSize(b,this.query.maxResults-this.resultCount));const _=this.resultSize(b);this.resultCount+=_,(_>0||!d(b))&&this.collector.add(b,p)}};Promise.all(C.map((b,p)=>this.searchInFolder(b,w=>s(w,p),k.token))).then(b=>{k.dispose(),this.collector.flush();const p=b.some(w=>!!w&&!!w.limitHit);n({limitHit:this.isLimitHit||p,messages:(0,S.flatten)(b.map(w=>w?.message?Array.isArray(w.message)?w.message:[w.message]:[])),stats:{type:this.processType}})},b=>{k.dispose();const p=(0,L.toErrorMessage)(b);a(new Error(p))})})}resultSize(c){return d(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,f){const C=Array.isArray(c.ranges)?c.ranges:[c.ranges],k=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:C.slice(0,f),preview:{matches:k.slice(0,f),text:c.preview.text},uri:c.uri}}async searchInFolder(c,f,C){const k=new P.QueryGlobTester(this.query,c),n=[],a={report:b=>{if(!this.validateProviderResult(b))return;const p=c.folder.scheme===T.Schemas.file?(0,P.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(b.uri))):void 0,w=y.relativePath(c.folder,b.uri);if(w){const _=k.includedInQuery(w,h.basename(w),p);(0,A.isThenable)(_)?n.push(_.then(o=>{o&&f(b)})):_&&f(b)}}},r=this.getSearchOptionsForFolder(c),s=await this.provider.provideTextSearchResults(l(this.query.contentPattern),r,a,C);return n.length&&await Promise.all(n),s}validateProviderResult(c){if(d(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const f=(0,P.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),C=(0,P.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),k={folder:m.URI.from(c.folder),excludes:C,includes:f,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return k.usePCRE2=this.query.usePCRE2,k}}e.TextSearchManager=D;function l(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class E{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new t(512,f=>this.sendItems(f))}add(c,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!y.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(v(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=E;function v(i){return d(i)?{preview:{matches:(0,S.mapArrayOrNot)(i.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:i.preview.text},ranges:(0,S.mapArrayOrNot)(i.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function d(i){return!!i.preview}e.extensionResultIsMatch=d;class t{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(c,f){this.maxBatchSize=c,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,f){c&&this.addItemToBatch(c,f)}addItems(c,f){c&&this.addItemsToBatch(c,f)}addItemToBatch(c,f){this.batch.push(c),this.batchSize+=f,this.onUpdate()}addItemsToBatch(c,f){this.batch=this.batch.concat(c),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<t.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},t.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=t}),define(Pe[115],Te([1,0,6,3,4,266,17,56,14,2,271]),function(ve,e,S,A,I,L,T,h,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let D=class{constructor(d,t,i){this.extHostRpc=d,this._uriTransformer=t,this._logService=i,this._proxy=this.extHostRpc.getProxy(A.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new L.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,t){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const i=this._handlePool++;return this._textSearchProvider.set(i,t),this._proxy.$registerTextSearchProvider(i,this._transformScheme(d)),(0,S.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}registerFileSearchProvider(d,t){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const i=this._handlePool++;return this._fileSearchProvider.set(i,t),this._proxy.$registerFileSearchProvider(i,this._transformScheme(d)),(0,S.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}$provideFileSearchResults(d,t,i,c){const f=l(i),C=this._fileSearchProvider.get(d);if(C)return this._fileSearchManager.fileSearch(f,C,k=>{this._proxy.$handleFileMatch(d,t,k.map(n=>n.resource))},c);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,t,i,c){const f=this._textSearchProvider.get(d);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const C=l(i);return this.createTextSearchManager(C,f).search(n=>this._proxy.$handleTextMatch(d,t,n),c)}$enableExtensionHostSearch(){}createTextSearchManager(d,t){return new P.TextSearchManager(d,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.ExtHostSearch=D,e.ExtHostSearch=D=Ve([ze(0,T.IExtHostRpcService),ze(1,h.IURITransformerService),ze(2,y.ILogService)],D);function l(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(E),extraFileResources:v.extraFileResources&&v.extraFileResources.map(d=>m.URI.revive(d))}}e.reviveQuery=l;function E(v){return{...v,folder:m.URI.revive(v.folder)}}}),define(Pe[272],Te([1,0,21,9,5,29,2,136,282,125,134,38,3,79,225,224,31,226,34,228,229,230,204,231,60,35,233,234,239,240,242,110,208,248,249,251,84,63,253,211,8,7,53,256,64,109,33,20,199,238,51,108,112,114,115,14,56,17,27,243,197,86,80,218,254,85,62,259,257,258,219,39,252,255,83,61,58,244,111,245,12,95,207,190,236,6,26,195,81,186,246,247,220,235,206,237,82,250,221,222,223,217,232]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t,i,c,f,C,k,n,a,r,s,b,p,w,_,o,u,g,O,z,H,B,$,x,M,ne,Q,we,_e,Ae,Y,he,ke,ae,J,le,N,q,ue,Se,be,Ee,ye,oe,de,re,ie,me,Ce,R,W,K,G,V,ee,ce,Me,xe,Ge,je,et,Ye,Ze,it,tt,Ue,st,Z,X,pe,$e,Ne,Xe,nt,ft,Et,Ft,Xt,Ht,bt,Lt,Nt,qt,Tt,At,Ut,$t,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Bt(at){const ut=at.get(oe.IExtHostInitDataService),jt=at.get(Me.IExtHostFileSystemInfo),Pt=at.get(K.IExtHostConsumerFileSystem),yt=at.get(s.IExtHostExtensionService),ht=at.get(he.IExtHostWorkspace),It=at.get(Ye.IExtHostTelemetry),Mt=at.get(c.IExtHostConfiguration),St=at.get(Ee.IURITransformerService),He=at.get(ye.IExtHostRpcService),Ie=at.get(B.IExtHostStorage),Re=at.get(W.IExtensionStoragePaths),ge=at.get(be.ILoggerService),j=at.get(be.ILogService),Oe=at.get(ie.IExtHostTunnelService),Be=at.get(me.IExtHostApiDeprecationService),Ke=at.get(Y.IExtHostWindow),We=at.get(je.IExtHostSecretState),Je=at.get(et.IExtHostEditorTabs),pt=at.get(Nt.IExtHostManagedSockets);He.set(l.ExtHostContext.ExtHostFileSystemInfo,jt),He.set(l.ExtHostContext.ExtHostLogLevelServiceShape,ge),He.set(l.ExtHostContext.ExtHostWorkspace,ht),He.set(l.ExtHostContext.ExtHostConfiguration,Mt),He.set(l.ExtHostContext.ExtHostExtensionService,yt),He.set(l.ExtHostContext.ExtHostStorage,Ie),He.set(l.ExtHostContext.ExtHostTunnelService,Oe),He.set(l.ExtHostContext.ExtHostWindow,Ke),He.set(l.ExtHostContext.ExtHostSecretState,We),He.set(l.ExtHostContext.ExtHostTelemetry,It),He.set(l.ExtHostContext.ExtHostEditorTabs,Je),He.set(l.ExtHostContext.ExtHostManagedSockets,pt);const _t=He.set(l.ExtHostContext.ExtHostDecorations,at.get(N.IExtHostDecorations)),vt=He.set(l.ExtHostContext.ExtHostDocumentsAndEditors,at.get(r.IExtHostDocumentsAndEditors)),ct=He.set(l.ExtHostContext.ExtHostCommands,at.get(t.IExtHostCommands)),gt=He.set(l.ExtHostContext.ExtHostTerminalService,at.get($.IExtHostTerminalService)),Dt=He.set(l.ExtHostContext.ExtHostDebugService,at.get(ue.IExtHostDebugService)),mi=He.set(l.ExtHostContext.ExtHostSearch,at.get(Se.IExtHostSearch)),Vt=He.set(l.ExtHostContext.ExtHostTask,at.get(q.IExtHostTask)),_i=He.set(l.ExtHostContext.ExtHostOutputService,at.get(u.IExtHostOutputService)),zt=He.set(l.ExtHostContext.ExtHostLocalization,at.get(nt.IExtHostLocalizationService)),gi=He.set(l.ExtHostContext.ExtHostUrls,new _e.ExtHostUrls(He)),kt=He.set(l.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(He,vt)),yi=He.set(l.ExtHostContext.ExtHostDocumentContentProviders,new k.ExtHostDocumentContentProvider(He,vt,j)),Hi=He.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(j,kt,He.getProxy(l.MainContext.MainThreadBulkEdits))),Ct=He.set(l.ExtHostContext.ExtHostNotebook,new de.ExtHostNotebookController(He,ct,vt,kt,Pt)),ti=He.set(l.ExtHostContext.ExtHostNotebookDocuments,new X.ExtHostNotebookDocuments(Ct)),pi=He.set(l.ExtHostContext.ExtHostNotebookEditors,new Z.ExtHostNotebookEditors(j,Ct)),si=He.set(l.ExtHostContext.ExtHostNotebookKernels,new Ze.ExtHostNotebookKernels(He,ut,Ct,ct,j)),Di=He.set(l.ExtHostContext.ExtHostNotebookRenderers,new tt.ExtHostNotebookRenderers(He,Ct)),Ci=He.set(l.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new bt.ExtHostNotebookDocumentSaveParticipant(j,Ct,He.getProxy(l.MainContext.MainThreadBulkEdits))),Rt=He.set(l.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(He,vt)),vi=He.set(l.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(He.getProxy(l.MainContext.MainThreadTreeViews),ct,j)),Ii=He.set(l.ExtHostContext.ExtHostEditorInsets,new ae.ExtHostEditorInsets(He.getProxy(l.MainContext.MainThreadEditorInsets),Rt,ut.remote)),oi=He.set(l.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(He,j,jt,vt)),ai=He.set(l.ExtHostContext.ExtHostLanguages,new _.ExtHostLanguages(He,kt,ct.converter,St)),lt=He.set(l.ExtHostContext.ExtHostLanguageFeatures,new w.ExtHostLanguageFeatures(He,St,kt,ct,oi,j,Be,It)),Wi=He.set(l.ExtHostContext.ExtHostFileSystem,new b.ExtHostFileSystem(He,lt)),Qt=He.set(l.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(He,j,vt)),ii=He.set(l.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(He,ht,ct)),Ei=He.set(l.ExtHostContext.ExtHostSCM,new z.ExtHostSCM(He,ct,kt,j)),ki=He.set(l.ExtHostContext.ExtHostQuickDiff,new Ft.ExtHostQuickDiff(He,St)),Vi=He.set(l.ExtHostContext.ExtHostShare,new qt.ExtHostShare(He,St)),Pi=He.set(l.ExtHostContext.ExtHostComments,(0,i.createExtHostComments)(He,ct,kt)),bi=He.set(l.ExtHostContext.ExtHostProgress,new g.ExtHostProgress(He.getProxy(l.MainContext.MainThreadProgress))),qi=He.set(l.ExtHostContext.ExtHosLabelService,new J.ExtHostLabelService(He)),Ti=He.set(l.ExtHostContext.ExtHostTheming,new re.ExtHostTheming(He)),ci=He.set(l.ExtHostContext.ExtHostAuthentication,new Ce.ExtHostAuthentication(He)),ji=He.set(l.ExtHostContext.ExtHostTimeline,new R.ExtHostTimeline(He,ct)),wi=He.set(l.ExtHostContext.ExtHostWebviews,new Ae.ExtHostWebviews(He,ut.remote,ht,j,Be)),Ai=He.set(l.ExtHostContext.ExtHostWebviewPanels,new ee.ExtHostWebviewPanels(He,wi,ht)),cn=He.set(l.ExtHostContext.ExtHostCustomEditors,new V.ExtHostCustomEditors(He,kt,Re,wi,Ai)),Ri=He.set(l.ExtHostContext.ExtHostWebviewViews,new G.ExtHostWebviewViews(He,wi)),ni=He.set(l.ExtHostContext.ExtHostTesting,new xe.ExtHostTesting(He,ct,vt)),ln=He.set(l.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(He)),un=He.set(l.ExtHostContext.ExtHostProfileContentHandlers,new Et.ExtHostProfileContentHandlers(He));He.set(l.ExtHostContext.ExtHostInteractive,new pe.ExtHostInteractive(He,Ct,vt,ct,j));const Ki=He.set(l.ExtHostContext.ExtHostInlineChat,new Ht.ExtHostInteractiveEditor(He,ct,kt,j)),fi=He.set(l.ExtHostContext.ExtHostChatProvider,new Tt.ExtHostChatProvider(He,j)),Gi=He.set(l.ExtHostContext.ExtHostChatSlashCommands,new At.ExtHostChatSlashCommands(He,fi,j)),Xi=He.set(l.ExtHostContext.ExtHostChatVariables,new Ut.ExtHostChatVariables(He)),li=He.set(l.ExtHostContext.ExtHostChat,new Xt.ExtHostChat(He,j)),Qi=He.set(l.ExtHostContext.ExtHostAiRelatedInformation,new $t.ExtHostRelatedInformation(He)),Oi=He.set(l.ExtHostContext.ExtHostAiEmbeddingVector,new Wt.ExtHostAiEmbeddingVector(He)),Yi=He.set(l.ExtHostContext.ExtHostIssueReporter,new Lt.ExtHostIssueReporter(He)),Yt=He.set(l.ExtHostContext.ExtHostStatusBar,new H.ExtHostStatusBar(He,ct.converter)),Si=Object.values(l.ExtHostContext);He.assertRegistered(Si);const dn=new ce.ExtHostBulkEdits(He,vt),Kt=new d.ExtHostClipboard(He),ui=new o.ExtHostMessageService(He,j),Fi=new C.ExtHostDialogs(He);return v.ExtHostApiCommands.register(ct),function(Le,Jt,Li){const mt=function(){let te=!Le.isUnderDevelopment;function fe(){te||(j.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Fe(rt){if(Array.isArray(rt))rt.forEach(Fe);else if(typeof rt=="string")fe();else{const wt=rt;typeof wt.scheme>"u"&&fe(),typeof wt.exclusive=="boolean"&&(0,Ne.checkProposedApiEnabled)(Le,"documentFiltersExclusive")}return rt}}(),Ji={getSession(te,fe,Fe){return ci.getSession(Le,te,fe,Fe)},getSessions(te,fe){return(0,Ne.checkProposedApiEnabled)(Le,"authGetSessions"),ci.getSessions(Le,te,fe)},async hasSession(te,fe){return(0,Ne.checkProposedApiEnabled)(Le,"authSession"),!!await ci.getSession(Le,te,fe,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(te,fe,Fe,rt){return ci.registerAuthenticationProvider(te,fe,Fe,rt)}},Zi={registerCommand(te,fe,Fe){return ct.registerCommand(!0,te,fe,Fe,void 0,Le)},registerTextEditorCommand(te,fe,Fe){return ct.registerCommand(!0,te,(...rt)=>{const wt=Rt.getActiveTextEditor();if(!wt){j.warn("Cannot execute "+te+" because there is no active text editor.");return}return wt.edit(Ot=>{fe.apply(Fe,[wt,Ot,...rt])}).then(Ot=>{Ot||j.warn("Edits from command "+te+" were not applied.")},Ot=>{j.warn("An error occurred while running command "+te,Ot)})},void 0,void 0,Le)},registerDiffInformationCommand:(te,fe,Fe)=>((0,Ne.checkProposedApiEnabled)(Le,"diffCommand"),ct.registerCommand(!0,te,async(...rt)=>{const wt=vt.activeEditor(!0);if(!wt){j.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ot=await Rt.getDiffInformation(wt.id);fe.apply(Fe,[Ot,...rt])},void 0,void 0,Le)),executeCommand(te,...fe){return ct.executeCommand(te,...fe)},getCommands(te=!1){return ct.getCommands(te)}},en={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Kt.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ne.checkProposedApiEnabled)(Le,"envShellEvent"),gt.onDidChangeShell},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return It.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)(Le,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)(Le,"telemetry"),It.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.isNewAppInstall)(ut.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,fe){return Ye.ExtHostTelemetryLogger.validateSender(te),It.instantiateLogger(Le,te,fe)},openExternal(te,fe){return Ke.openUri(te,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ut.environment.appUriScheme)return gi.createAppUri(te);try{return await Ke.asExternalUri(te,{allowTunneling:!!ut.remote.authority})}catch(fe){if((0,st.matchesScheme)(te,Ue.Schemas.http)||(0,st.matchesScheme)(te,Ue.Schemas.https))return te;throw fe}},get remoteName(){return(0,le.getRemoteName)(ut.remote.authority)},get remoteAuthority(){return(0,Ne.checkProposedApiEnabled)(Le,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind},get logLevel(){return j.getLevel()},get onDidChangeLogLevel(){return j.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Ne.checkProposedApiEnabled)(Le,"handleIssueUri"),Yi.registerIssueUriRequestHandler(Le,te)},get appQuality(){return(0,Ne.checkProposedApiEnabled)(Le,"resolvers"),ut.quality},get appCommit(){return(0,Ne.checkProposedApiEnabled)(Le,"resolvers"),ut.commit}};ut.environment.extensionTestsLocationURI||Object.freeze(en);const hn={createTestController(te,fe,Fe){return ni.createTestController(Le,te,fe,Fe)},createTestObserver(){return(0,Ne.checkProposedApiEnabled)(Le,"testObserver"),ni.createTestObserver()},runTests(te){return(0,Ne.checkProposedApiEnabled)(Le,"testObserver"),ni.runTests(te)},get onDidChangeTestResults(){return(0,Ne.checkProposedApiEnabled)(Le,"testObserver"),ni.onResultsChanged},get testResults(){return(0,Ne.checkProposedApiEnabled)(Le,"testObserver"),ni.results}},di=ut.remote.isRemote?Q.ExtensionKind.Workspace:Q.ExtensionKind.UI,tn={getExtension(te,fe){(0,Ne.isProposedApiEnabled)(Le,"extensionsAny")||(fe=!1);const Fe=Jt.mine.getExtensionDescription(te);if(Fe)return new s.Extension(yt,Le.identifier,Fe,di,!1);if(fe){const rt=Jt.all.getExtensionDescription(te);if(rt)return new s.Extension(yt,Le.identifier,rt,di,!0)}},get all(){const te=[];for(const fe of Jt.mine.getAllExtensionDescriptions())te.push(new s.Extension(yt,Le.identifier,fe,di,!1));return te},get allAcrossExtensionHosts(){(0,Ne.checkProposedApiEnabled)(Le,"extensionsAny");const te=new ke.ExtensionIdentifierSet(Jt.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),fe=[];for(const Fe of Jt.all.getAllExtensionDescriptions()){const rt=!te.has(Fe.identifier);fe.push(new s.Extension(yt,Le.identifier,Fe,di,rt))}return fe},get onDidChange(){return(0,Ne.isProposedApiEnabled)(Le,"extensionsAny")?I.Event.any(Jt.mine.onDidChange,Jt.all.onDidChange):Jt.mine.onDidChange}},nn={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Le.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(te,fe){return ai.changeLanguage(te.uri,fe)},match(te,fe){const Fe=kt.getDocumentData(fe.uri)?.notebook;return(0,P.score)(ne.LanguageSelector.from(te),fe.uri,fe.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(te,fe,Fe){return lt.registerCodeActionProvider(Le,mt(te),fe,Fe)},registerDocumentPasteEditProvider(te,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"documentPaste"),lt.registerDocumentPasteEditProvider(Le,mt(te),fe,Fe)},registerCodeLensProvider(te,fe){return lt.registerCodeLensProvider(Le,mt(te),fe)},registerDefinitionProvider(te,fe){return lt.registerDefinitionProvider(Le,mt(te),fe)},registerDeclarationProvider(te,fe){return lt.registerDeclarationProvider(Le,mt(te),fe)},registerImplementationProvider(te,fe){return lt.registerImplementationProvider(Le,mt(te),fe)},registerTypeDefinitionProvider(te,fe){return lt.registerTypeDefinitionProvider(Le,mt(te),fe)},registerHoverProvider(te,fe){return lt.registerHoverProvider(Le,mt(te),fe,Le.identifier)},registerEvaluatableExpressionProvider(te,fe){return lt.registerEvaluatableExpressionProvider(Le,mt(te),fe,Le.identifier)},registerInlineValuesProvider(te,fe){return lt.registerInlineValuesProvider(Le,mt(te),fe,Le.identifier)},registerDocumentHighlightProvider(te,fe){return lt.registerDocumentHighlightProvider(Le,mt(te),fe)},registerLinkedEditingRangeProvider(te,fe){return lt.registerLinkedEditingRangeProvider(Le,mt(te),fe)},registerReferenceProvider(te,fe){return lt.registerReferenceProvider(Le,mt(te),fe)},registerRenameProvider(te,fe){return lt.registerRenameProvider(Le,mt(te),fe)},registerDocumentSymbolProvider(te,fe,Fe){return lt.registerDocumentSymbolProvider(Le,mt(te),fe,Fe)},registerWorkspaceSymbolProvider(te){return lt.registerWorkspaceSymbolProvider(Le,te)},registerDocumentFormattingEditProvider(te,fe){return lt.registerDocumentFormattingEditProvider(Le,mt(te),fe)},registerDocumentRangeFormattingEditProvider(te,fe){return lt.registerDocumentRangeFormattingEditProvider(Le,mt(te),fe)},registerOnTypeFormattingEditProvider(te,fe,Fe,...rt){return lt.registerOnTypeFormattingEditProvider(Le,mt(te),fe,[Fe].concat(rt))},registerDocumentSemanticTokensProvider(te,fe,Fe){return lt.registerDocumentSemanticTokensProvider(Le,mt(te),fe,Fe)},registerDocumentRangeSemanticTokensProvider(te,fe,Fe){return lt.registerDocumentRangeSemanticTokensProvider(Le,mt(te),fe,Fe)},registerSignatureHelpProvider(te,fe,Fe,...rt){return typeof Fe=="object"?lt.registerSignatureHelpProvider(Le,mt(te),fe,Fe):lt.registerSignatureHelpProvider(Le,mt(te),fe,typeof Fe>"u"?[]:[Fe,...rt])},registerCompletionItemProvider(te,fe,...Fe){return lt.registerCompletionItemProvider(Le,mt(te),fe,Fe)},registerInlineCompletionItemProvider(te,fe,Fe){return fe.handleDidShowCompletionItem&&(0,Ne.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Ne.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),Fe&&(0,Ne.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Le,mt(te),fe,Fe)},registerDocumentLinkProvider(te,fe){return lt.registerDocumentLinkProvider(Le,mt(te),fe)},registerColorProvider(te,fe){return lt.registerColorProvider(Le,mt(te),fe)},registerFoldingRangeProvider(te,fe){return lt.registerFoldingRangeProvider(Le,mt(te),fe)},registerSelectionRangeProvider(te,fe){return lt.registerSelectionRangeProvider(Le,te,fe)},registerCallHierarchyProvider(te,fe){return lt.registerCallHierarchyProvider(Le,te,fe)},registerTypeHierarchyProvider(te,fe){return lt.registerTypeHierarchyProvider(Le,te,fe)},setLanguageConfiguration:(te,fe)=>lt.setLanguageConfiguration(Le,te,fe),getTokenInformationAtPosition(te,fe){return(0,Ne.checkProposedApiEnabled)(Le,"tokenInformation"),ai.tokenAtPosition(te,fe)},registerInlayHintsProvider(te,fe){return lt.registerInlayHintsProvider(Le,te,fe)},createLanguageStatusItem(te,fe){return ai.createLanguageStatusItem(Le,te,fe)},registerDocumentDropEditProvider(te,fe,Fe){return lt.registerDocumentOnDropEditProvider(Le,te,fe,(0,Ne.isProposedApiEnabled)(Le,"dropMetadata")?Fe:void 0)}},rn={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(te,fe,Fe){const rt=await(T.URI.isUri(te)?Promise.resolve(sn.openTextDocument(te)):Promise.resolve(te));return Rt.showTextDocument(rt,fe,Fe)},createTextEditorDecorationType(te){return Rt.createTextEditorDecorationType(Le,te)},onDidChangeActiveTextEditor(te,fe,Fe){return Rt.onDidChangeActiveTextEditor(te,fe,Fe)},onDidChangeVisibleTextEditors(te,fe,Fe){return Rt.onDidChangeVisibleTextEditors(te,fe,Fe)},onDidChangeTextEditorSelection(te,fe,Fe){return Rt.onDidChangeTextEditorSelection(te,fe,Fe)},onDidChangeTextEditorOptions(te,fe,Fe){return Rt.onDidChangeTextEditorOptions(te,fe,Fe)},onDidChangeTextEditorVisibleRanges(te,fe,Fe){return Rt.onDidChangeTextEditorVisibleRanges(te,fe,Fe)},onDidChangeTextEditorViewColumn(te,fe,Fe){return Rt.onDidChangeTextEditorViewColumn(te,fe,Fe)},onDidCloseTerminal(te,fe,Fe){return gt.onDidCloseTerminal(te,fe,Fe)},onDidOpenTerminal(te,fe,Fe){return gt.onDidOpenTerminal(te,fe,Fe)},onDidChangeActiveTerminal(te,fe,Fe){return gt.onDidChangeActiveTerminal(te,fe,Fe)},onDidChangeTerminalDimensions(te,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"terminalDimensions"),gt.onDidChangeTerminalDimensions(te,fe,Fe)},onDidChangeTerminalState(te,fe,Fe){return gt.onDidChangeTerminalState(te,fe,Fe)},onDidWriteTerminalData(te,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(te,fe,Fe)},onDidExecuteTerminalCommand(te,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(te,fe,Fe)},get state(){return Ke.getState(Le)},onDidChangeWindowState(te,fe,Fe){return Ke.onDidChangeWindowState(te,fe,Fe)},showInformationMessage(te,...fe){return ui.showMessage(Le,L.default.Info,te,fe[0],fe.slice(1))},showWarningMessage(te,...fe){return ui.showMessage(Le,L.default.Warning,te,fe[0],fe.slice(1))},showErrorMessage(te,...fe){return ui.showMessage(Le,L.default.Error,te,fe[0],fe.slice(1))},showQuickPick(te,fe,Fe){return ii.showQuickPick(Le,te,fe,Fe)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,fe){return ii.showInput(te,fe)},showOpenDialog(te){return Fi.showOpenDialog(Le,te)},showSaveDialog(te){return Fi.showSaveDialog(te)},createStatusBarItem(te,fe,Fe){let rt,wt,Ot;return typeof te=="string"?(rt=te,wt=fe,Ot=Fe):(wt=te,Ot=fe),Yt.createStatusBarEntry(Le,rt,wt,Ot)},setStatusBarMessage(te,fe){return Yt.setStatusBarMessage(te,fe)},withScmProgress(te){return Be.report("window.withScmProgress",Le,"Use 'withProgress' instead."),bi.withProgress(Le,{location:Q.ProgressLocation.SourceControl},(fe,Fe)=>te({report(rt){}}))},withProgress(te,fe){return bi.withProgress(Le,te,fe)},createOutputChannel(te,fe){return _i.createOutputChannel(te,fe,Le)},createWebviewPanel(te,fe,Fe,rt){return Ai.createWebviewPanel(Le,te,fe,Fe,rt)},createWebviewTextEditorInset(te,fe,Fe,rt){return(0,Ne.checkProposedApiEnabled)(Le,"editorInsets"),Ii.createWebviewEditorInset(te,fe,Fe,rt,Le)},createTerminal(te,fe,Fe){return typeof te=="object"?"pty"in te?gt.createExtensionTerminal(te):gt.createTerminalFromOptions(te):gt.createTerminal(te,fe,Fe)},registerTerminalLinkProvider(te){return gt.registerLinkProvider(te)},registerTerminalProfileProvider(te,fe){return gt.registerProfileProvider(Le,te,fe)},registerTerminalQuickFixProvider(te,fe){return(0,Ne.checkProposedApiEnabled)(Le,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(te,Le.identifier.value,fe)},registerTreeDataProvider(te,fe){return vi.registerTreeDataProvider(te,fe,Le)},createTreeView(te,fe){return vi.createTreeView(te,fe,Le)},registerWebviewPanelSerializer:(te,fe)=>Ai.registerWebviewPanelSerializer(Le,te,fe),registerCustomEditorProvider:(te,fe,Fe={})=>cn.registerCustomEditorProvider(Le,te,fe,Fe),registerFileDecorationProvider(te){return _t.registerFileDecorationProvider(te,Le)},registerUriHandler(te){return gi.registerUriHandler(Le,te)},createQuickPick(){return ii.createQuickPick(Le)},createInputBox(){return ii.createInputBox(Le)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(te,fe,Fe){return Ti.onDidChangeActiveColorTheme(te,fe,Fe)},registerWebviewViewProvider(te,fe,Fe){return Ri.registerWebviewViewProvider(Le,te,fe,Fe?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,fe,Fe){return Ct.onDidChangeActiveNotebookEditor(te,fe,Fe)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Ct.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,fe,Fe){return pi.onDidChangeNotebookEditorSelection(te,fe,Fe)},onDidChangeNotebookEditorVisibleRanges(te,fe,Fe){return pi.onDidChangeNotebookEditorVisibleRanges(te,fe,Fe)},showNotebookDocument(te,fe){return Ct.showNotebookDocument(te,fe)},registerExternalUriOpener(te,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"externalUriOpener"),ln.registerExternalUriOpener(Le.identifier,te,fe,Fe)},registerProfileContentHandler(te,fe){return(0,Ne.checkProposedApiEnabled)(Le,"profileContentHandlers"),un.registrProfileContentHandler(Le,te,fe)},registerQuickDiffProvider(te,fe,Fe,rt){return(0,Ne.checkProposedApiEnabled)(Le,"quickDiffProvider"),ki.registerQuickDiffProvider(mt(te),fe,Fe,rt)},get tabGroups(){return Je.tabGroups},registerShareProvider(te,fe){return(0,Ne.checkProposedApiEnabled)(Le,"shareProvider"),Vi.registerShareProvider(mt(te),fe)}},sn={get rootPath(){return Be.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(te){throw A.readonly()},getWorkspaceFolder(te){return ht.getWorkspaceFolder(te)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(te){throw A.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(te){throw A.readonly()},updateWorkspaceFolders:(te,fe,...Fe)=>ht.updateWorkspaceFolders(Le,te,fe||0,...Fe),onDidChangeWorkspaceFolders:function(te,fe,Fe){return ht.onDidChangeWorkspace(te,fe,Fe)},asRelativePath:(te,fe)=>ht.getRelativePath(te,fe),findFiles:(te,fe,Fe,rt)=>ht.findFiles(te,fe,Fe,Le.identifier,rt),findTextInFiles:(te,fe,Fe,rt)=>{(0,Ne.checkProposedApiEnabled)(Le,"findTextInFiles");let wt,Ot;return typeof fe=="object"?(wt=fe,Ot=Fe):(wt={},Ot=fe,rt=Fe),ht.findTextInFiles(te,wt||{},Ot,Le.identifier,rt)},save:te=>((0,Ne.checkProposedApiEnabled)(Le,"saveEditor"),ht.save(te)),saveAs:te=>((0,Ne.checkProposedApiEnabled)(Le,"saveEditor"),ht.saveAs(te)),saveAll:te=>ht.saveAll(te),applyEdit(te,fe){return dn.applyWorkspaceEdit(te,Le,fe)},createFileSystemWatcher:(te,fe,Fe,rt)=>Qt.createFileSystemWatcher(ht,Le,te,fe,Fe,rt),get textDocuments(){return kt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw A.readonly()},openTextDocument(te){let fe;const Fe=te;if(typeof te=="string")fe=Promise.resolve(T.URI.file(te));else if(T.URI.isUri(te))fe=Promise.resolve(te);else if(!Fe||typeof Fe=="object")fe=kt.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(rt=>kt.ensureDocumentData(rt).then(wt=>wt.document))},onDidOpenTextDocument:(te,fe,Fe)=>kt.onDidAddDocument(te,fe,Fe),onDidCloseTextDocument:(te,fe,Fe)=>kt.onDidRemoveDocument(te,fe,Fe),onDidChangeTextDocument:(te,fe,Fe)=>kt.onDidChangeDocument(te,fe,Fe),onDidSaveTextDocument:(te,fe,Fe)=>kt.onDidSaveDocument(te,fe,Fe),onWillSaveTextDocument:(te,fe,Fe)=>Hi.getOnWillSaveTextDocumentEvent(Le)(te,fe,Fe),get notebookDocuments(){return Ct.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,fe){let Fe;if(T.URI.isUri(te))Fe=te,await Ct.openNotebookDocument(te);else if(typeof te=="string")Fe=T.URI.revive(await Ct.createNotebookDocument({viewType:te,content:fe}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(te,fe,Fe){return ti.onDidSaveNotebookDocument(te,fe,Fe)},onDidChangeNotebookDocument(te,fe,Fe){return ti.onDidChangeNotebookDocument(te,fe,Fe)},onWillSaveNotebookDocument(te,fe,Fe){return Ci.getOnWillSaveNotebookDocumentEvent(Le)(te,fe,Fe)},get onDidOpenNotebookDocument(){return Ct.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Ct.onDidCloseNotebookDocument},registerNotebookSerializer(te,fe,Fe,rt){return Ct.registerNotebookSerializer(Le,te,fe,Fe,(0,Ne.isProposedApiEnabled)(Le,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,fe,Fe)=>Li.onDidChangeConfiguration(te,fe,Fe),getConfiguration(te,fe){return fe=arguments.length===1?void 0:fe,Li.getConfiguration(te,fe,Le)},registerTextDocumentContentProvider(te,fe){return yi.registerTextDocumentContentProvider(te,fe)},registerTaskProvider:(te,fe)=>(Be.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Vt.registerTaskProvider(Le,te,fe)),registerFileSystemProvider(te,fe,Fe){return(0,$e.combinedDisposable)(Wi.registerFileSystemProvider(Le,te,fe,Fe),Pt.addFileSystemProvider(te,fe,Fe))},get fs(){return Pt.value},registerFileSearchProvider:(te,fe)=>((0,Ne.checkProposedApiEnabled)(Le,"fileSearchProvider"),mi.registerFileSearchProvider(te,fe)),registerTextSearchProvider:(te,fe)=>((0,Ne.checkProposedApiEnabled)(Le,"textSearchProvider"),mi.registerTextSearchProvider(te,fe)),registerRemoteAuthorityResolver:(te,fe)=>((0,Ne.checkProposedApiEnabled)(Le,"resolvers"),yt.registerRemoteAuthorityResolver(te,fe)),registerResourceLabelFormatter:te=>((0,Ne.checkProposedApiEnabled)(Le,"resolvers"),qi.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ne.checkProposedApiEnabled)(Le,"resolvers"),yt.getRemoteExecServer(te)),onDidCreateFiles:(te,fe,Fe)=>Qt.onDidCreateFile(te,fe,Fe),onDidDeleteFiles:(te,fe,Fe)=>Qt.onDidDeleteFile(te,fe,Fe),onDidRenameFiles:(te,fe,Fe)=>Qt.onDidRenameFile(te,fe,Fe),onWillCreateFiles:(te,fe,Fe)=>Qt.getOnWillCreateFileEvent(Le)(te,fe,Fe),onWillDeleteFiles:(te,fe,Fe)=>Qt.getOnWillDeleteFileEvent(Le)(te,fe,Fe),onWillRenameFiles:(te,fe,Fe)=>Qt.getOnWillRenameFileEvent(Le)(te,fe,Fe),openTunnel:te=>((0,Ne.checkProposedApiEnabled)(Le,"tunnels"),Oe.openTunnel(Le,te).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Ne.checkProposedApiEnabled)(Le,"tunnels"),Oe.getTunnels()},onDidChangeTunnels:(te,fe,Fe)=>((0,Ne.checkProposedApiEnabled)(Le,"tunnels"),Oe.onDidChangeTunnels(te,fe,Fe)),registerPortAttributesProvider:(te,fe)=>((0,Ne.checkProposedApiEnabled)(Le,"portsAttributes"),Oe.registerPortsAttributesProvider(te,fe)),registerTunnelProvider:(te,fe)=>((0,Ne.checkProposedApiEnabled)(Le,"tunnelFactory"),Oe.registerTunnelProvider(te,fe)),registerTimelineProvider:(te,fe)=>((0,Ne.checkProposedApiEnabled)(Le,"timeline"),ji.registerTimelineProvider(te,fe,Le.identifier,ct.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:te=>((0,Ne.checkProposedApiEnabled)(Le,"workspaceTrust"),ht.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,fe,Fe)=>ht.onDidGrantWorkspaceTrust(te,fe,Fe),registerEditSessionIdentityProvider:(te,fe)=>((0,Ne.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(te,fe)),onWillCreateEditSessionIdentity:(te,fe,Fe)=>((0,Ne.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Le)(te,fe,Fe)),registerCanonicalUriProvider:(te,fe)=>((0,Ne.checkProposedApiEnabled)(Le,"canonicalUriProvider"),ht.registerCanonicalUriProvider(te,fe)),getCanonicalUri:(te,fe,Fe)=>((0,Ne.checkProposedApiEnabled)(Le,"canonicalUriProvider"),ht.provideCanonicalUri(te,fe,Fe))},fn={get inputBox(){return Be.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),Ei.getLastInputBox(Le)},createSourceControl(te,fe,Fe){return Ei.createSourceControl(Le,te,fe,Fe)}},on={createCommentController(te,fe){return Pi.createCommentController(Le,te,fe)}},an={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get stackFrameFocus(){return Dt.stackFrameFocus},onDidStartDebugSession(te,fe,Fe){return Dt.onDidStartDebugSession(te,fe,Fe)},onDidTerminateDebugSession(te,fe,Fe){return Dt.onDidTerminateDebugSession(te,fe,Fe)},onDidChangeActiveDebugSession(te,fe,Fe){return Dt.onDidChangeActiveDebugSession(te,fe,Fe)},onDidReceiveDebugSessionCustomEvent(te,fe,Fe){return Dt.onDidReceiveDebugSessionCustomEvent(te,fe,Fe)},onDidChangeBreakpoints(te,fe,Fe){return Dt.onDidChangeBreakpoints(te,fe,Fe)},onDidChangeStackFrameFocus(te,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"debugFocus"),Dt.onDidChangeStackFrameFocus(te,fe,Fe)},registerDebugConfigurationProvider(te,fe,Fe){return Dt.registerDebugConfigurationProvider(te,fe,Fe||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,fe){return Dt.registerDebugAdapterDescriptorFactory(Le,te,fe)},registerDebugAdapterTrackerFactory(te,fe){return Dt.registerDebugAdapterTrackerFactory(te,fe)},startDebugging(te,fe,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?Dt.startDebugging(te,fe,{parentSession:Fe}):Dt.startDebugging(te,fe,Fe||{})},stopDebugging(te){return Dt.stopDebugging(te)},addBreakpoints(te){return Dt.addBreakpoints(te)},removeBreakpoints(te){return Dt.removeBreakpoints(te)},asDebugSourceUri(te,fe){return Dt.asDebugSourceUri(te,fe)}},Mi={registerTaskProvider:(te,fe)=>Vt.registerTaskProvider(Le,te,fe),fetchTasks:te=>Vt.fetchTasks(te),executeTask:te=>Vt.executeTask(Le,te),get taskExecutions(){return Vt.taskExecutions},onDidStartTask:(te,fe,Fe)=>Vt.onDidStartTask(te,fe,Fe),onDidEndTask:(te,fe,Fe)=>Vt.onDidEndTask(te,fe,Fe),onDidStartTaskProcess:(te,fe,Fe)=>Vt.onDidStartTaskProcess(te,fe,Fe),onDidEndTaskProcess:(te,fe,Fe)=>Vt.onDidEndTaskProcess(te,fe,Fe)},Ni={createNotebookController(te,fe,Fe,rt,wt){return si.createNotebookController(Le,te,fe,Fe,rt,(0,Ne.isProposedApiEnabled)(Le,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(te,fe)=>Ct.registerNotebookCellStatusBarItemProvider(Le,te,fe),createRendererMessaging(te){return Di.createRendererMessaging(Le,te)},createNotebookControllerDetectionTask(te){return(0,Ne.checkProposedApiEnabled)(Le,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Le,te)},registerKernelSourceActionProvider(te,fe){return(0,Ne.checkProposedApiEnabled)(Le,"notebookKernelSource"),si.registerKernelSourceActionProvider(Le,te,fe)},onDidChangeNotebookCellExecutionState(te,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,fe,Fe)}},Ui={t(...te){if(typeof te[0]=="string"){const fe=te.shift(),Fe=!te||typeof te[0]!="object"?te:te[0];return zt.getMessage(Le.identifier.value,{message:fe,args:Fe})}return zt.getMessage(Le.identifier.value,te[0])},get bundle(){return zt.getBundle(Le.identifier.value)},get uri(){return zt.getBundleUri(Le.identifier.value)}},hi={_version:1,registerInteractiveEditorSessionProvider(te){return(0,Ne.checkProposedApiEnabled)(Le,"interactive"),Ki.registerProvider(Le,te)},registerInteractiveSessionProvider(te,fe){return(0,Ne.checkProposedApiEnabled)(Le,"interactive"),li.registerChatProvider(Le,te,fe)},addInteractiveRequest(te){return(0,Ne.checkProposedApiEnabled)(Le,"interactive"),li.addChatRequest(te)},sendInteractiveRequestToProvider(te,fe){return(0,Ne.checkProposedApiEnabled)(Le,"interactive"),li.sendInteractiveRequestToProvider(te,fe)},get onDidPerformUserAction(){return(0,Ne.checkProposedApiEnabled)(Le,"interactiveUserActions"),li.onDidPerformUserAction},transferChatSession(te,fe){return(0,Ne.checkProposedApiEnabled)(Le,"interactive"),li.transferChatSession(te,fe)}},xi={getRelatedInformation(te,fe){return(0,Ne.checkProposedApiEnabled)(Le,"aiRelatedInformation"),Qi.getRelatedInformation(Le,te,fe)},registerRelatedInformationProvider(te,fe){return(0,Ne.checkProposedApiEnabled)(Le,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Le,te,fe)},registerEmbeddingVectorProvider(te,fe){return(0,Ne.checkProposedApiEnabled)(Le,"aiRelatedInformation"),Oi.registerEmbeddingVectorProvider(Le,te,fe)}},$i={registerChatResponseProvider(te,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"chatProvider"),fi.registerProvider(Le.identifier,te,fe,Fe)},registerSlashCommand(te,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"chatSlashCommands"),Gi.registerCommand(Le.identifier,te,fe,Fe??{description:""})},requestChatAccess(te){return(0,Ne.checkProposedApiEnabled)(Le,"chatRequestAccess"),fi.requestChatResponseProvider(Le.identifier,te)},registerVariable(te,fe,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"chatVariables"),Xi.registerVariableResolver(Le,te,fe,Fe)},registerMappedEditsProvider(te,fe){return(0,Ne.checkProposedApiEnabled)(Le,"mappedEditsProvider"),lt.registerMappedEditsProvider(Le,te,fe)}};return{version:ut.version,ai:xi,authentication:Ji,commands:Zi,comments:on,chat:$i,debug:an,env:en,extensions:tn,interactive:hi,l10n:Ui,languages:nn,notebooks:Ni,scm:fn,tasks:Mi,tests:hn,window:rn,workspace:sn,Breakpoint:Q.Breakpoint,TerminalOutputAnchor:Q.TerminalOutputAnchor,ChatMessage:Q.ChatMessage,ChatMessageRole:Q.ChatMessageRole,ChatVariableLevel:Q.ChatVariableLevel,CallHierarchyIncomingCall:Q.CallHierarchyIncomingCall,CallHierarchyItem:Q.CallHierarchyItem,CallHierarchyOutgoingCall:Q.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:S.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:Q.CodeAction,CodeActionKind:Q.CodeActionKind,CodeActionTriggerKind:Q.CodeActionTriggerKind,CodeLens:Q.CodeLens,Color:Q.Color,ColorInformation:Q.ColorInformation,ColorPresentation:Q.ColorPresentation,ColorThemeKind:Q.ColorThemeKind,CommentMode:Q.CommentMode,CommentState:Q.CommentState,CommentThreadCollapsibleState:Q.CommentThreadCollapsibleState,CommentThreadState:Q.CommentThreadState,CompletionItem:Q.CompletionItem,CompletionItemKind:Q.CompletionItemKind,CompletionItemTag:Q.CompletionItemTag,CompletionList:Q.CompletionList,CompletionTriggerKind:Q.CompletionTriggerKind,ConfigurationTarget:Q.ConfigurationTarget,CustomExecution:Q.CustomExecution,DebugAdapterExecutable:Q.DebugAdapterExecutable,DebugAdapterInlineImplementation:Q.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Q.DebugAdapterNamedPipeServer,DebugAdapterServer:Q.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Q.DebugConsoleMode,DecorationRangeBehavior:Q.DecorationRangeBehavior,Diagnostic:Q.Diagnostic,DiagnosticRelatedInformation:Q.DiagnosticRelatedInformation,DiagnosticSeverity:Q.DiagnosticSeverity,DiagnosticTag:Q.DiagnosticTag,Disposable:Q.Disposable,DocumentHighlight:Q.DocumentHighlight,DocumentHighlightKind:Q.DocumentHighlightKind,DocumentLink:Q.DocumentLink,DocumentSymbol:Q.DocumentSymbol,EndOfLine:Q.EndOfLine,EnvironmentVariableMutatorType:Q.EnvironmentVariableMutatorType,EvaluatableExpression:Q.EvaluatableExpression,InlineValueText:Q.InlineValueText,InlineValueVariableLookup:Q.InlineValueVariableLookup,InlineValueEvaluatableExpression:Q.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Q.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:Q.ExtensionKind,ExtensionMode:Q.ExtensionMode,ExternalUriOpenerPriority:Q.ExternalUriOpenerPriority,FileChangeType:Q.FileChangeType,FileDecoration:Q.FileDecoration,FileDecoration2:Q.FileDecoration,FileSystemError:Q.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:Q.FoldingRange,FoldingRangeKind:Q.FoldingRangeKind,FunctionBreakpoint:Q.FunctionBreakpoint,InlineCompletionItem:Q.InlineSuggestion,InlineCompletionList:Q.InlineSuggestionList,Hover:Q.Hover,IndentAction:m.IndentAction,Location:Q.Location,MarkdownString:Q.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:Q.ParameterInformation,PortAutoForwardAction:Q.PortAutoForwardAction,Position:Q.Position,ProcessExecution:Q.ProcessExecution,ProgressLocation:Q.ProgressLocation,QuickInputButtons:Q.QuickInputButtons,Range:Q.Range,RelativePattern:Q.RelativePattern,Selection:Q.Selection,SelectionRange:Q.SelectionRange,SemanticTokens:Q.SemanticTokens,SemanticTokensBuilder:Q.SemanticTokensBuilder,SemanticTokensEdit:Q.SemanticTokensEdit,SemanticTokensEdits:Q.SemanticTokensEdits,SemanticTokensLegend:Q.SemanticTokensLegend,ShellExecution:Q.ShellExecution,ShellQuoting:Q.ShellQuoting,SignatureHelp:Q.SignatureHelp,SignatureHelpTriggerKind:Q.SignatureHelpTriggerKind,SignatureInformation:Q.SignatureInformation,SnippetString:Q.SnippetString,SourceBreakpoint:Q.SourceBreakpoint,StandardTokenType:Q.StandardTokenType,StatusBarAlignment:Q.StatusBarAlignment,SymbolInformation:Q.SymbolInformation,SymbolKind:Q.SymbolKind,SymbolTag:Q.SymbolTag,Task:Q.Task,TaskGroup:Q.TaskGroup,TaskPanelKind:Q.TaskPanelKind,TaskRevealKind:Q.TaskRevealKind,TaskScope:Q.TaskScope,TerminalLink:Q.TerminalLink,TerminalQuickFixExecuteTerminalCommand:Q.TerminalQuickFixCommand,TerminalQuickFixOpener:Q.TerminalQuickFixOpener,TerminalLocation:Q.TerminalLocation,TerminalProfile:Q.TerminalProfile,TerminalExitReason:Q.TerminalExitReason,TextDocumentSaveReason:Q.TextDocumentSaveReason,TextEdit:Q.TextEdit,SnippetTextEdit:Q.SnippetTextEdit,TextEditorCursorStyle:h.TextEditorCursorStyle,TextEditorLineNumbersStyle:Q.TextEditorLineNumbersStyle,TextEditorRevealType:Q.TextEditorRevealType,TextEditorSelectionChangeKind:Q.TextEditorSelectionChangeKind,TextDocumentChangeReason:Q.TextDocumentChangeReason,ThemeColor:Q.ThemeColor,ThemeIcon:Q.ThemeIcon,TreeItem:Q.TreeItem,TreeItemCheckboxState:Q.TreeItemCheckboxState,TreeItemCollapsibleState:Q.TreeItemCollapsibleState,TypeHierarchyItem:Q.TypeHierarchyItem,UIKind:E.UIKind,Uri:T.URI,ViewColumn:Q.ViewColumn,WorkspaceEdit:Q.WorkspaceEdit,DocumentDropEdit:Q.DocumentDropEdit,DocumentPasteEdit:Q.DocumentPasteEdit,InlayHint:Q.InlayHint,InlayHintLabelPart:Q.InlayHintLabelPart,InlayHintKind:Q.InlayHintKind,RemoteAuthorityResolverError:Q.RemoteAuthorityResolverError,ResolvedAuthority:Q.ResolvedAuthority,ManagedResolvedAuthority:Q.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Q.SourceControlInputBoxValidationType,ExtensionRuntime:Q.ExtensionRuntime,TimelineItem:Q.TimelineItem,NotebookRange:Q.NotebookRange,NotebookCellKind:Q.NotebookCellKind,NotebookCellExecutionState:Q.NotebookCellExecutionState,NotebookCellData:Q.NotebookCellData,NotebookData:Q.NotebookData,NotebookRendererScript:Q.NotebookRendererScript,NotebookCellStatusBarAlignment:Q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Q.NotebookEditorRevealType,NotebookCellOutput:Q.NotebookCellOutput,NotebookCellOutputItem:Q.NotebookCellOutputItem,NotebookCellStatusBarItem:Q.NotebookCellStatusBarItem,NotebookControllerAffinity:Q.NotebookControllerAffinity,NotebookControllerAffinity2:Q.NotebookControllerAffinity2,NotebookEdit:Q.NotebookEdit,NotebookKernelSourceAction:Q.NotebookKernelSourceAction,PortAttributes:Q.PortAttributes,LinkedEditingRanges:Q.LinkedEditingRanges,TestResultState:Q.TestResultState,TestRunRequest:Q.TestRunRequest,TestMessage:Q.TestMessage,TestMessage2:Q.TestMessage,TestTag:Q.TestTag,TestRunProfileKind:Q.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Q.DataTransfer,DataTransferItem:Q.DataTransferItem,CoveredCount:Q.CoveredCount,FileCoverage:Q.FileCoverage,StatementCoverage:Q.StatementCoverage,BranchCoverage:Q.BranchCoverage,FunctionCoverage:Q.FunctionCoverage,WorkspaceTrustState:Q.WorkspaceTrustState,LanguageStatusSeverity:Q.LanguageStatusSeverity,QuickPickItemKind:Q.QuickPickItemKind,InputBoxValidationSeverity:Q.InputBoxValidationSeverity,TabInputText:Q.TextTabInput,TabInputTextDiff:Q.TextDiffTabInput,TabInputTextMerge:Q.TextMergeTabInput,TabInputCustom:Q.CustomEditorTabInput,TabInputNotebook:Q.NotebookEditorTabInput,TabInputNotebookDiff:Q.NotebookDiffEditorTabInput,TabInputWebview:Q.WebviewEditorTabInput,TabInputTerminal:Q.TerminalEditorTabInput,TabInputInteractiveWindow:Q.InteractiveWindowInput,TelemetryTrustedValue:we.TelemetryTrustedValue,LogLevel:be.LogLevel,EditSessionIdentityMatch:ft.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Q.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Q.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Q.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Q.StackFrameFocus,ThreadFocus:Q.ThreadFocus,NotebookCodeActionKind:Q.NotebookCodeActionKind,RelatedInformationType:Q.RelatedInformationType}}}e.createApiFactoryAndRegisterActors=Bt}),define(Pe[273],Te([1,0,71,110,33,108,34,31,60,63,112,114,115,84,86,80,109,62,39,83,58,61,241,14,113,81,82]),function(ve,e,S,A,I,L,T,h,y,m,P,D,l,E,v,d,t,i,c,f,C,k,n,a,r,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,S.registerSingleton)(a.ILoggerService,n.ExtHostLoggerService,1),(0,S.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,S.registerSingleton)(h.IExtHostCommands,h.ExtHostCommands,0),(0,S.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration,0),(0,S.registerSingleton)(i.IExtHostConsumerFileSystem,i.ExtHostConsumerFileSystem,0),(0,S.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,0),(0,S.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,S.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,S.registerSingleton)(b.IExtHostManagedSockets,b.ExtHostManagedSockets,0),(0,S.registerSingleton)(c.IExtHostFileSystemInfo,c.ExtHostFileSystemInfo,0),(0,S.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService,1),(0,S.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch,0),(0,S.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage,0),(0,S.registerSingleton)(P.IExtHostTask,P.WorkerExtHostTask,0),(0,S.registerSingleton)(m.IExtHostTerminalService,m.WorkerExtHostTerminalService,0),(0,S.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService,0),(0,S.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,S.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace,0),(0,S.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState,0),(0,S.registerSingleton)(C.IExtHostTelemetry,C.ExtHostTelemetry,0),(0,S.registerSingleton)(k.IExtHostEditorTabs,k.ExtHostEditorTabs,0),(0,S.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(Pe[274],Te([1,0,272,35,2,269,7,13,260]),function(ve,e,S,A,I,L,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class m extends L.RequireInterceptor{_installInterceptor(){}getModule(E,v){for(const d of this._alternatives){const t=d(E);if(t){E=t;break}}if(this._factories.has(E))return this._factories.get(E).load(E,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends A.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(y.ExtHostConsoleForwarder);const E=this._instaService.invokeFunction(S.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(m,E,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(E){return E.browser}async _loadCommonJSModule(E,v,d){v=v.with({path:D(v.path,".js")});const t=E?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=I.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(v)),c=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const f=await c.text(),C=`${v.toString(!0)}#vscode-extension`,k=`${f}
//# sourceURL=${C}`;let n;try{n=new Function("module","exports","require",k)}catch(b){throw console.error(t?`Loading code for extension ${t} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${v.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}E&&await this._extHostLocalizationService.initializeLocalizedMessages(E);const a={},r={exports:a},s=b=>{const p=this._fakeModules.getModule(b,v);if(p===void 0)throw new Error(`Cannot load module '${b}'`);return p};try{return d.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(r,a,s),r.exports!==a?r.exports:a}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),d.codeLoadingStop()}}async $setRemoteEnvironment(E){}async _waitForDebuggerAttachment(E=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+E;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,h.timeout)(10)}}e.ExtHostExtensionService=P;function D(l,E){return l.endsWith(E)?l:l+E}}),define(Pe[275],Te([1,0,70,71,14,35,188,85,274]),function(ve,e,S,A,I,L,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,A.registerSingleton)(I.ILogService,new S.SyncDescriptor(T.ExtHostLogService,[!0],!0)),(0,A.registerSingleton)(L.IExtHostExtensionService,y.ExtHostExtensionService,0),(0,A.registerSingleton)(h.IExtensionStoragePaths,h.ExtensionStoragePaths,0)}),define(Pe[283],Te([1,0,25,5,79,270,262,19,87,12,2,273,275]),function(ve,e,S,A,I,L,T,h,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(n){return/^(file|vscode-remote):/i.test(n)}const v=fetch.bind(self);function d(n){self.fetch=async function(a,r){return a instanceof Request||E(String(a))&&(a=(await n(P.URI.parse(String(a)))).toString(!0)),v(a,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,r,s,b,p){(async()=>(E(r.toString())&&(r=(await n(P.URI.parse(r.toString()))).toString(!0)),super.open(a,r,s??!0,b,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(a,r){if(/^file:/i.test(a.toString()))a=m.FileAccess.uriToBrowserUri(P.URI.parse(a.toString())).toString(!0);else if(/^vscode-remote:/i.test(a.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(o){function u(z){return typeof z=="string"||z instanceof URL?String(z).replace(/^file:\/\//i,"vscode-file://vscode-app"):z}const g=fetch.bind(self);self.fetch=function(z,H){return z instanceof Request?g(z,H):g(u(z),H)},self.XMLHttpRequest=class extends XMLHttpRequest{open(z,H,B,$,x){return super.open(z,u(H),B??!0,$,x)}};const O=importScripts.bind(self);self.importScripts=(...z)=>{O(...z.map(u))},O(o)}.toString()}('${a}'))`;r=r||{},r.name=r.name||h.basename(a.toString());const p=new Blob([b],{type:"application/javascript"}),w=URL.createObjectURL(p);return new n(w,r)}}else self.Worker=class extends T.NestedWorker{constructor(n,a){super(l,n,{name:h.basename(n.toString()),...a})}};const t=new class{constructor(){this.pid=void 0}exit(n){D()}};class i{constructor(){const a=new MessageChannel,r=new A.Emitter;let s=!1;l(a.port2,[a.port2]),a.port1.onmessage=b=>{const{data:p}=b;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const w=S.VSBuffer.wrap(new Uint8Array(p,0,p.byteLength));if((0,I.isMessageOfType)(w,2)){s=!0,f("received terminate message from renderer");return}r.fire(w)},this.protocol={onMessage:r.event,send:b=>{if(!s){const p=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);a.port1.postMessage(p,[p])}}}}}function c(n){return new Promise(a=>{const r=n.onMessage(s=>{r.dispose();const b=JSON.parse(s.toString());n.send((0,I.createMessageOfType)(0)),a({protocol:n,initData:b})});n.send((0,I.createMessageOfType)(1))})}let f=n=>D();function C(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function k(){y.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(a){C(a)&&c(n.protocol).then(r=>{y.mark("code/extHost/didWaitForInitData");const s=new L.ExtensionHostMain(r.protocol,r.initData,t,null,a.data);d(b=>s.asBrowserUri(b)),f=b=>s.terminate(b)})}}}e.create=k})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a5004432af6600c99fa4f918a3f2f8df44df71e6/core/vs/workbench/api/worker/extensionHostWorker.js.map
