/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var W=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],j=function(U){for(var e=[],O=0,S=U.length;O<S;O++)e[O]=W[U[O]];return e};define(W[21],j([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class O{static get(){const k=new Map,w=new Map,s=new Map,c=new Map;function t(h,n){h.has(n.detail)||h.set(n.detail,-n.timestamp)}function o(h,n){const i=h.get(n.detail);i&&(i>=0||h.set(n.detail,i+n.timestamp))}let a=[];typeof U=="function"&&typeof U.getStats=="function"&&(a=U.getStats().slice(0).sort((h,n)=>h.timestamp-n.timestamp));for(const h of a)switch(h.type){case 10:t(k,h);break;case 11:case 12:o(k,h);break;case 21:t(w,h);break;case 22:o(w,h);break;case 33:t(s,h);break;case 34:o(s,h);break;case 31:t(c,h);break;case 32:o(c,h);break}let u=0;s.forEach(h=>u+=h);function d(h){const n=[];return h.forEach((i,r)=>n.push([r,i])),n}return{amdLoad:d(k),amdInvoke:d(w),nodeRequire:d(s),nodeEval:d(c),nodeRequireTotal:u}}static toMarkdownTable(k,w){let s="";const c=[];return k.forEach((t,o)=>{c[o]=t.length}),w.forEach(t=>{t.forEach((o,a)=>{typeof o>"u"&&(o=t[a]="-");const u=o.toString().length;c[a]=Math.max(u,c[a])})}),k.forEach((t,o)=>{s+=`| ${t+" ".repeat(c[o]-t.toString().length)} `}),s+=`|
`,k.forEach((t,o)=>{s+=`| ${"-".repeat(c[o])} `}),s+=`|
`,w.forEach(t=>{t.forEach((o,a)=>{typeof o<"u"&&(s+=`| ${o+" ".repeat(c[a]-o.toString().length)} `)}),s+=`|
`}),s}}e.LoaderStats=O}),define(W[4],j([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let O;function S(i){O=i}e.setLogger=S;function k(){return O}e.getLogger=k;class w{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(r){return s([c(h("|  ",this.indentation)),r])}formatInfo(r){return r.hadValue?r.didChange?[c(" "),o(a(r.oldValue,70),{color:"red",strikeThrough:!0}),c(" "),o(a(r.newValue,60),{color:"green"})]:[c(" (unchanged)")]:[c(" "),o(a(r.newValue,60),{color:"green"}),c(" (initial)")]}handleObservableChanged(r,b){console.log(...this.textToConsoleArgs([t("observable value changed"),o(r.debugName,{color:"BlueViolet"}),...this.formatInfo(b)]))}formatChanges(r){if(r.size!==0)return o(" (changed deps: "+[...r].map(b=>b.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const b=r.handleChange;this.changedObservablesSets.set(r,new Set),r.handleChange=(y,R)=>(this.changedObservablesSets.get(r).add(y),b.apply(r,[y,R]))}handleDerivedRecomputed(r,b){const y=this.changedObservablesSets.get(r);console.log(...this.textToConsoleArgs([t("derived recomputed"),o(r.debugName,{color:"BlueViolet"}),...this.formatInfo(b),this.formatChanges(y),{data:[{fn:r._computeFn}]}])),y.clear()}handleFromEventObservableTriggered(r,b){console.log(...this.textToConsoleArgs([t("observable from event triggered"),o(r.debugName,{color:"BlueViolet"}),...this.formatInfo(b),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const b=r.handleChange;this.changedObservablesSets.set(r,new Set),r.handleChange=(y,R)=>(this.changedObservablesSets.get(r).add(y),b.apply(r,[y,R]))}handleAutorunTriggered(r){const b=this.changedObservablesSets.get(r);console.log(...this.textToConsoleArgs([t("autorun"),o(r.debugName,{color:"BlueViolet"}),this.formatChanges(b),{data:[{fn:r._runFn}]}])),b.clear(),this.indentation++}handleAutorunFinished(r){this.indentation--}handleBeginTransaction(r){let b=r.getDebugName();b===void 0&&(b=""),console.log(...this.textToConsoleArgs([t("transaction"),o(b,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=w;function s(i){const r=new Array,b=[];let y="";function R(E){if("length"in E)for(const f of E)f&&R(f);else"text"in E?(y+=`%c${E.text}`,r.push(E.style),E.data&&b.push(...E.data)):"data"in E&&b.push(...E.data)}R(i);const N=[y,...r];return N.push(...b),N}function c(i){return o(i,{color:"black"})}function t(i){return o(n(`${i}: `,10),{color:"black",bold:!0})}function o(i,r={color:"black"}){function b(R){return Object.entries(R).reduce((N,[E,f])=>`${N}${E}:${f};`,"")}const y={color:r.color};return r.strikeThrough&&(y["text-decoration"]="line-through"),r.bold&&(y["font-weight"]="bold"),{text:i,style:b(y)}}function a(i,r){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=r?`"${i}"`:`"${i.substr(0,r-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?u(i,r):d(i,r);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function u(i,r){let b="[ ",y=!0;for(const R of i){if(y||(b+=", "),b.length-5>r){b+="...";break}y=!1,b+=`${a(R,r-b.length)}`}return b+=" ]",b}function d(i,r){let b="{ ",y=!0;for(const[R,N]of Object.entries(i)){if(y||(b+=", "),b.length-5>r){b+="...";break}y=!1,b+=`${R}: ${a(N,r-b.length)}`}return b+=" }",b}function h(i,r){let b="";for(let y=1;y<=r;y++)b+=i;return b}function n(i,r){for(;i.length<r;)i+=" ";return i}}),define(W[5],j([0,1,4]),function(U,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.disposableObservableValue=e.ObservableValue=e.observableValue=e.getFunctionName=e.TransactionImpl=e.subtransaction=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerived=void 0;let S;function k(i){S=i}e._setDerived=k;class w{get TChange(){return null}reportChanges(){this.get()}read(r){return r?r.readObservable(this):this.get()}map(r){return S(b=>r(this.read(b),b),()=>{const b=a(r);if(b!==void 0)return b;const R=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(r.toString());return R?`${this.debugName}.${R[2]}`:`${this.debugName} (mapped)`})}}e.ConvenientObservable=w;class s extends w{constructor(){super(...arguments),this.observers=new Set}addObserver(r){const b=this.observers.size;this.observers.add(r),b===0&&this.onFirstObserverAdded()}removeObserver(r){this.observers.delete(r)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=s;function c(i,r){const b=new o(i,r);try{i(b)}finally{b.finish()}}e.transaction=c;function t(i,r,b){i?r(i):c(r,b)}e.subtransaction=t;class o{constructor(r,b){this._fn=r,this._getDebugName=b,this.updatingObservers=[],(0,O.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():a(this._fn)}updateObserver(r,b){this.updatingObservers.push({observer:r,observable:b}),r.beginUpdate(b)}finish(){const r=this.updatingObservers;this.updatingObservers=null;for(const{observer:b,observable:y}of r)b.endUpdate(y);(0,O.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=o;function a(i){const r=i.toString(),y=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(r);return(y?y[1]:void 0)?.trim()}e.getFunctionName=a;function u(i,r){return new d(i,r)}e.observableValue=u;class d extends s{constructor(r,b){super(),this.debugName=r,this._value=b}get(){return this._value}set(r,b,y){if(this._value===r)return;let R;b||(b=R=new o(()=>{},()=>`Setting ${this.debugName}`));try{const N=this._value;this._setValue(r),(0,O.getLogger)()?.handleObservableChanged(this,{oldValue:N,newValue:r,change:y,didChange:!0,hadValue:!0});for(const E of this.observers)b.updateObserver(E,this),E.handleChange(this,y)}finally{R&&R.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(r){this._value=r}}e.ObservableValue=d;function h(i,r){return new n(i,r)}e.disposableObservableValue=h;class n extends d{_setValue(r){this._value!==r&&(this._value&&this._value.dispose(),this._value=r)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=n}),define(W[9],j([0,1,42,2,5,4]),function(U,e,O,S,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunDelta=e.AutorunObserver=e.autorunWithStore=e.autorunWithStoreHandleChanges=e.autorunHandleChanges=e.autorun=e.autorunOpts=void 0;function s(n,i){return new d(n.debugName,i,void 0,void 0)}e.autorunOpts=s;function c(n){return new d(void 0,n,void 0,void 0)}e.autorun=c;function t(n,i){return new d(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.autorunHandleChanges=t;function o(n,i){const r=new S.DisposableStore,b=t({debugName:n.debugName??(()=>(0,k.getFunctionName)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(y,R)=>{r.clear(),i(y,R,r)});return(0,S.toDisposable)(()=>{b.dispose(),r.dispose()})}e.autorunWithStoreHandleChanges=o;function a(n){const i=new S.DisposableStore,r=s({debugName:()=>(0,k.getFunctionName)(n)||"(anonymous)"},b=>{i.clear(),n(b,i)});return(0,S.toDisposable)(()=>{r.dispose(),i.dispose()})}e.autorunWithStore=a;var u;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(u||(u={}));class d{get debugName(){if(typeof this._debugName=="string")return this._debugName;if(typeof this._debugName=="function"){const r=this._debugName();if(r!==void 0)return r}const i=(0,k.getFunctionName)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,r,b,y){this._debugName=i,this._runFn=r,this.createChangeSummary=b,this._handleChange=y,this.state=2,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,w.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded()}dispose(){this.disposed=!0;for(const i of this.dependencies)i.removeObserver(this);this.dependencies.clear()}_runIfNeeded(){if(this.state===3)return;const i=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=i,this.state=3;try{if(!this.disposed){(0,w.getLogger)()?.handleAutorunTriggered(this);const r=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this._runFn(this,r)}}finally{(0,w.getLogger)()?.handleAutorunFinished(this);for(const r of this.dependenciesToBeRemoved)r.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===3&&(this.state=1),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===1){this.state=3;for(const i of this.dependencies)if(i.reportChanges(),this.state===2)break}this._runIfNeeded()}while(this.state!==3);this.updateCount--,(0,O.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(i){this.state===3&&this.dependencies.has(i)&&!this.dependenciesToBeRemoved.has(i)&&(this.state=1)}handleChange(i,r){this.dependencies.has(i)&&!this.dependenciesToBeRemoved.has(i)&&(!this._handleChange||this._handleChange({changedObservable:i,change:r,didChange:y=>y===i},this.changeSummary))&&(this.state=2)}readObservable(i){if(this.disposed)return i.get();i.addObserver(this);const r=i.get();return this.dependencies.add(i),this.dependenciesToBeRemoved.delete(i),r}}e.AutorunObserver=d,function(n){n.Observer=d}(c||(e.autorun=c={}));function h(n,i){let r;return s({debugName:()=>(0,k.getFunctionName)(i)},b=>{const y=n.read(b),R=r;r=y,i({lastValue:R,newValue:y})})}e.autorunDelta=h}),define(W[10],j([0,1,6,2,5,4]),function(U,e,O,S,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=void 0;const s=(h,n)=>h===n;function c(h,n){return new d(n,h,void 0,void 0,void 0,s)}e.derived=c;function t(h,n){return new d(h.debugName,n,void 0,void 0,void 0,h.equalityComparer??s)}e.derivedOpts=t;function o(h,n,i){return new d(h,i,n.createEmptyChangeSummary,n.handleChange,void 0,s)}e.derivedHandleChanges=o;function a(h,n){const i=new S.DisposableStore;return new d(h,r=>(i.clear(),n(r,i)),void 0,void 0,()=>i.dispose(),s)}e.derivedWithStore=a,(0,k._setDerived)(c);var u;(function(h){h[h.initial=0]="initial",h[h.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",h[h.stale=2]="stale",h[h.upToDate=3]="upToDate"})(u||(u={}));class d extends k.BaseObservable{get debugName(){return this._debugName?typeof this._debugName=="function"?this._debugName():this._debugName:(0,k.getFunctionName)(this._computeFn)||"(anonymous)"}constructor(n,i,r,b,y=void 0,R){super(),this._debugName=n,this._computeFn=i,this.createChangeSummary=r,this._handleChange=b,this._handleLastObserverRemoved=y,this._equalityComparator=R,this.state=0,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,w.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=0,this.value=void 0;for(const n of this.dependencies)n.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const n=this._computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),n}else{do{if(this.state===1){for(const n of this.dependencies)if(n.reportChanges(),this.state===2)break}this.state===1&&(this.state=3),this._recomputeIfNeeded()}while(this.state!==3);return this.value}}_recomputeIfNeeded(){if(this.state===3)return;const n=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=n;const i=this.state!==0,r=this.value;this.state=3;const b=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this._computeFn(this,b)}finally{for(const R of this.dependenciesToBeRemoved)R.removeObserver(this);this.dependenciesToBeRemoved.clear()}const y=i&&!this._equalityComparator(r,this.value);if((0,w.getLogger)()?.handleDerivedRecomputed(this,{oldValue:r,newValue:this.value,change:void 0,didChange:y,hadValue:i}),y)for(const R of this.observers)R.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.updateCount++;const i=this.updateCount===1;if(this.state===3&&(this.state=1,!i))for(const r of this.observers)r.handlePossibleChange(this);if(i)for(const r of this.observers)r.beginUpdate(this)}endUpdate(n){if(this.updateCount--,this.updateCount===0){const i=[...this.observers];for(const r of i)r.endUpdate(this)}if(this.updateCount<0)throw new O.BugIndicatingError}handlePossibleChange(n){if(this.state===3&&this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)){this.state=1;for(const i of this.observers)i.handlePossibleChange(this)}}handleChange(n,i){if(this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)){const r=this._handleChange?this._handleChange({changedObservable:n,change:i,didChange:y=>y===n},this.changeSummary):!0,b=this.state===3;if(r&&(this.state===1||b)&&(this.state=2,b))for(const y of this.observers)y.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.dependencies.add(n),this.dependenciesToBeRemoved.delete(n),i}addObserver(n){const i=!this.observers.has(n)&&this.updateCount>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.observers.has(n)&&this.updateCount>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.Derived=d}),define(W[22],j([0,1,2,9,5,10,4]),function(U,e,O,S,k,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.keepAlive=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.waitForState=e.observableFromPromise=e.constObservable=void 0;function c(v){return new t(v)}e.constObservable=c;class t extends k.ConvenientObservable{constructor(_){super(),this.value=_}get debugName(){return this.toString()}get(){return this.value}addObserver(_){}removeObserver(_){}toString(){return`Const: ${this.value}`}}function o(v){const _=(0,k.observableValue)("promiseValue",{});return v.then(p=>{_.set({value:p},void 0)}),_}e.observableFromPromise=o;function a(v,_){return new Promise(p=>{let D=!1,g=!1;const L=(0,S.autorun)(z=>{const B=v.read(z);_(B)&&(D?L.dispose():g=!0,p(B))});D=!0,g&&L.dispose()})}e.waitForState=a;function u(v,_){return new d(v,_)}e.observableFromEvent=u;class d extends k.BaseObservable{constructor(_,p){super(),this.event=_,this._getValue=p,this.hasValue=!1,this.handleEvent=D=>{const g=this._getValue(D),L=!this.hasValue||this.value!==g;(0,s.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:this.value,newValue:g,change:void 0,didChange:L,hadValue:this.hasValue}),L&&(this.value=g,this.hasValue&&(0,k.transaction)(z=>{for(const B of this.observers)z.updateObserver(B,this),B.handleChange(this,void 0)},()=>{const z=this.getDebugName();return"Event fired"+(z?`: ${z}`:"")}),this.hasValue=!0)}}getDebugName(){return(0,k.getFunctionName)(this._getValue)}get debugName(){const _=this.getDebugName();return"From Event"+(_?`: ${_}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this._getValue(void 0)}}e.FromEventObservable=d,function(v){v.Observer=d}(u||(e.observableFromEvent=u={}));function h(v,_){return new n(v,_)}e.observableSignalFromEvent=h;class n extends k.BaseObservable{constructor(_,p){super(),this.debugName=_,this.event=p,this.handleEvent=()=>{(0,k.transaction)(D=>{for(const g of this.observers)D.updateObserver(g,this),g.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function i(v){return new r(v)}e.observableSignal=i;class r extends k.BaseObservable{constructor(_){super(),this.debugName=_}trigger(_,p){if(!_){(0,k.transaction)(D=>{this.trigger(D,p)},()=>`Trigger signal ${this.debugName}`);return}for(const D of this.observers)_.updateObserver(D,this),D.handleChange(this,p)}get(){}}function b(v,_,p){const D=(0,k.observableValue)("debounced",void 0);let g;return p.add((0,S.autorun)(L=>{const z=v.read(L);g&&clearTimeout(g),g=setTimeout(()=>{(0,k.transaction)(B=>{D.set(z,B)})},_)})),D}e.debouncedObservable=b;function y(v,_,p){const D=(0,k.observableValue)("triggeredRecently",!1);let g;return p.add(v(()=>{D.set(!0,void 0),g&&clearTimeout(g),g=setTimeout(()=>{D.set(!1,void 0)},_)})),D}e.wasEventTriggeredRecently=y;function R(v,_){const p=new N(_??!1);return v.addObserver(p),_&&v.reportChanges(),(0,O.toDisposable)(()=>{v.removeObserver(p)})}e.keepAlive=R;class N{constructor(_){this.forceRecompute=_,this.counter=0}beginUpdate(_){this.counter++}endUpdate(_){this.counter--,this.counter===0&&this.forceRecompute&&_.reportChanges()}handlePossibleChange(_){}handleChange(_,p){}}function E(v,_){let p;return(0,w.derived)(g=>(p=_(g,p),p),v)}e.derivedObservableWithCache=E;function f(v,_){let p;const D=(0,k.observableValue)("derivedObservableWithWritableCache.counter",0),g=(0,w.derived)(L=>(D.read(L),p=_(L,p),p),v);return Object.assign(g,{clearCache:L=>{p=void 0,D.set(D.get()+1,L)}})}e.derivedObservableWithWritableCache=f}),define(W[11],j([0,1,5,10,9,22,4]),function(U,e,O,S,k,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.keepAlive=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return O.observableValue}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return O.disposableObservableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return O.transaction}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return O.subtransaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return S.derived}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return S.derivedOpts}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return S.derivedHandleChanges}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return S.derivedWithStore}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return k.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return k.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return k.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return k.autorunWithStore}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return k.autorunOpts}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return k.autorunWithStoreHandleChanges}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return w.constObservable}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return w.debouncedObservable}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return w.derivedObservableWithCache}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return w.derivedObservableWithWritableCache}}),Object.defineProperty(e,"keepAlive",{enumerable:!0,get:function(){return w.keepAlive}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return w.observableFromEvent}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return w.observableFromPromise}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return w.observableSignal}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return w.observableSignalFromEvent}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return w.waitForState}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return w.wasEventTriggeredRecently}}),!1&&(0,s.setLogger)(new s.ConsoleObservableLogger)}),define(W[23],j([0,1,6,2]),function(U,e,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(N){const E=N;return E?typeof E.read=="function":!1}e.isReadable=k;function w(N){const E=N;return E?[E.on,E.pause,E.resume,E.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=w;function s(N){const E=N;return E?w(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.isReadableBufferedStream=s;function c(N,E){return new t(N,E)}e.newWriteableStream=c;class t{constructor(E,f){this.reducer=E,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(E){if(!this.state.destroyed){if(this.state.flowing)this.emitData(E);else if(this.buffer.data.push(E),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(E){this.state.destroyed||(this.state.flowing?this.emitError(E):this.buffer.error.push(E))}end(E){this.state.destroyed||(typeof E<"u"&&this.write(E),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(E){this.listeners.data.slice(0).forEach(f=>f(E))}emitError(E){this.listeners.error.length===0?(0,O.onUnexpectedError)(E):this.listeners.error.slice(0).forEach(f=>f(E))}emitEnd(){this.listeners.end.slice(0).forEach(E=>E())}on(E,f){if(!this.state.destroyed)switch(E){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(E,f){if(this.state.destroyed)return;let v;switch(E){case"data":v=this.listeners.data;break;case"end":v=this.listeners.end;break;case"error":v=this.listeners.error;break}if(v){const _=v.indexOf(f);_>=0&&v.splice(_,1)}}flowData(){if(this.buffer.data.length>0){const E=this.reducer(this.buffer.data);this.emitData(E),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(v=>v())}}flowErrors(){if(this.listeners.error.length>0){for(const E of this.buffer.error)this.emitError(E);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function o(N,E){const f=[];let v;for(;(v=N.read())!==null;)f.push(v);return E(f)}e.consumeReadable=o;function a(N,E,f){const v=[];let _;for(;(_=N.read())!==null&&v.length<f;)v.push(_);return _===null&&v.length>0?E(v):{read:()=>{if(v.length>0)return v.shift();if(typeof _<"u"){const p=_;return _=void 0,p}return N.read()}}}e.peekReadable=a;function u(N,E){return new Promise((f,v)=>{const _=[];d(N,{onData:p=>{E&&_.push(p)},onError:p=>{E?v(p):f(void 0)},onEnd:()=>{f(E?E(_):void 0)}})})}e.consumeStream=u;function d(N,E,f){N.on("error",v=>{f?.isCancellationRequested||E.onError(v)}),N.on("end",()=>{f?.isCancellationRequested||E.onEnd()}),N.on("data",v=>{f?.isCancellationRequested||E.onData(v)})}e.listenStream=d;function h(N,E){return new Promise((f,v)=>{const _=new S.DisposableStore,p=[],D=z=>{if(p.push(z),p.length>E)return _.dispose(),N.pause(),f({stream:N,buffer:p,ended:!1})},g=z=>v(z),L=()=>f({stream:N,buffer:p,ended:!0});_.add((0,S.toDisposable)(()=>N.removeListener("error",g))),N.on("error",g),_.add((0,S.toDisposable)(()=>N.removeListener("end",L))),N.on("end",L),_.add((0,S.toDisposable)(()=>N.removeListener("data",D))),N.on("data",D)})}e.peekStream=h;function n(N,E){const f=c(E);return f.end(N),f}e.toStream=n;function i(){const N=c(()=>{throw new Error("not supported")});return N.end(),N}e.emptyStream=i;function r(N){let E=!1;return{read:()=>E?null:(E=!0,N)}}e.toReadable=r;function b(N,E,f){const v=c(f);return d(N,{onData:_=>v.write(E.data(_)),onError:_=>v.error(E.error?E.error(_):_),onEnd:()=>v.end()}),v}e.transform=b;function y(N,E,f){let v=!1;return{read:()=>{const _=E.read();return v?_:(v=!0,_!==null?f([N,_]):N)}}}e.prefixedReadable=y;function R(N,E,f){let v=!1;const _=c(f);return d(E,{onData:p=>v?_.write(p):(v=!0,_.write(f([N,p]))),onError:p=>_.error(p),onEnd:()=>{v||(v=!0,_.write(N)),_.end()}}),_}e.prefixedStream=R}),define(W[12],j([0,1,43,23]),function(U,e,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const k=typeof Buffer<"u",w=new O.Lazy(()=>new Uint8Array(256));let s,c;class t{static alloc(m){return k?new t(Buffer.allocUnsafe(m)):new t(new Uint8Array(m))}static wrap(m){return k&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new t(m)}static fromString(m,M){return!(M?.dontUseNodeBuffer||!1)&&k?new t(Buffer.from(m)):(s||(s=new TextEncoder),new t(s.encode(m)))}static fromByteArray(m){const M=t.alloc(m.length);for(let V=0,K=m.length;V<K;V++)M.buffer[V]=m[V];return M}static concat(m,M){if(typeof M>"u"){M=0;for(let $=0,G=m.length;$<G;$++)M+=m[$].byteLength}const V=t.alloc(M);let K=0;for(let $=0,G=m.length;$<G;$++){const q=m[$];V.set(q,K),K+=q.byteLength}return V}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=t.alloc(this.byteLength);return m.set(this),m}toString(){return k?this.buffer.toString():(c||(c=new TextDecoder),c.decode(this.buffer))}slice(m,M){return new t(this.buffer.subarray(m,M))}set(m,M){if(m instanceof t)this.buffer.set(m.buffer,M);else if(m instanceof Uint8Array)this.buffer.set(m,M);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),M);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return d(this.buffer,m)}writeUInt32BE(m,M){h(this.buffer,m,M)}readUInt32LE(m){return n(this.buffer,m)}writeUInt32LE(m,M){i(this.buffer,m,M)}readUInt8(m){return r(this.buffer,m)}writeUInt8(m,M){b(this.buffer,m,M)}indexOf(m,M=0){return o(this.buffer,m instanceof t?m.buffer:m,M)}}e.VSBuffer=t;function o(P,m,M=0){const V=m.byteLength,K=P.byteLength;if(V===0)return 0;if(V===1)return P.indexOf(m[0]);if(V>K-M)return-1;const $=w.value;$.fill(m.length);for(let J=0;J<m.length;J++)$[m[J]]=m.length-J-1;let G=M+m.length-1,q=G,H=-1;for(;G<K;)if(P[G]===m[q]){if(q===0){H=G;break}G--,q--}else G+=Math.max(m.length-q,$[P[G]]),q=m.length-1;return H}e.binaryIndexOf=o;function a(P,m){return P[m+0]<<0>>>0|P[m+1]<<8>>>0}e.readUInt16LE=a;function u(P,m,M){P[M+0]=m&255,m=m>>>8,P[M+1]=m&255}e.writeUInt16LE=u;function d(P,m){return P[m]*2**24+P[m+1]*2**16+P[m+2]*2**8+P[m+3]}e.readUInt32BE=d;function h(P,m,M){P[M+3]=m,m=m>>>8,P[M+2]=m,m=m>>>8,P[M+1]=m,m=m>>>8,P[M]=m}e.writeUInt32BE=h;function n(P,m){return P[m+0]<<0>>>0|P[m+1]<<8>>>0|P[m+2]<<16>>>0|P[m+3]<<24>>>0}e.readUInt32LE=n;function i(P,m,M){P[M+0]=m&255,m=m>>>8,P[M+1]=m&255,m=m>>>8,P[M+2]=m&255,m=m>>>8,P[M+3]=m&255}e.writeUInt32LE=i;function r(P,m){return P[m]}e.readUInt8=r;function b(P,m,M){P[M]=m}e.writeUInt8=b;function y(P){return S.consumeReadable(P,m=>t.concat(m))}e.readableToBuffer=y;function R(P){return S.toReadable(P)}e.bufferToReadable=R;function N(P){return S.consumeStream(P,m=>t.concat(m))}e.streamToBuffer=N;async function E(P){return P.ended?t.concat(P.buffer):t.concat([...P.buffer,await N(P.stream)])}e.bufferedStreamToBuffer=E;function f(P){return S.toStream(P,m=>t.concat(m))}e.bufferToStream=f;function v(P){return S.transform(P,{data:m=>typeof m=="string"?t.fromString(m):t.wrap(m)},m=>t.concat(m))}e.streamToBufferReadableStream=v;function _(P){return S.newWriteableStream(m=>t.concat(m),P)}e.newWriteableBufferStream=_;function p(P,m){return S.prefixedReadable(P,m,M=>t.concat(M))}e.prefixedBufferReadable=p;function D(P,m){return S.prefixedStream(P,m,M=>t.concat(M))}e.prefixedBufferStream=D;function g(P){let m=0,M=0,V=0;const K=new Uint8Array(Math.floor(P.length/4*3)),$=q=>{switch(M){case 3:K[V++]=m|q,M=0;break;case 2:K[V++]=m|q>>>2,m=q<<6,M=3;break;case 1:K[V++]=m|q>>>4,m=q<<4,M=2;break;default:m=q<<2,M=1}};for(let q=0;q<P.length;q++){const H=P.charCodeAt(q);if(H>=65&&H<=90)$(H-65);else if(H>=97&&H<=122)$(H-97+26);else if(H>=48&&H<=57)$(H-48+52);else if(H===43||H===45)$(62);else if(H===47||H===95)$(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${P[q]}`)}}const G=V;for(;M>0;)$(0);return t.wrap(K).slice(0,G)}e.decodeBase64=g;const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function B({buffer:P},m=!0,M=!1){const V=M?z:L;let K="";const $=P.byteLength%3;let G=0;for(;G<P.byteLength-$;G+=3){const q=P[G+0],H=P[G+1],J=P[G+2];K+=V[q>>>2],K+=V[(q<<4|H>>>4)&63],K+=V[(H<<2|J>>>6)&63],K+=V[J&63]}if($===1){const q=P[G+0];K+=V[q>>>2],K+=V[q<<4&63],m&&(K+="==")}else if($===2){const q=P[G+0],H=P[G+1];K+=V[q>>>2],K+=V[(q<<4|H>>>4)&63],K+=V[H<<2&63],m&&(K+="=")}return K}e.encodeBase64=B}),define(W[24],j([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(W[13],j([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var O;(function(k){k[k.Unknown=0]="Unknown",k[k.Invalid=3]="Invalid",k[k.LF=1]="LF",k[k.CRLF=2]="CRLF"})(O||(e.StringEOL=O={}));function S(k){let w=0,s=0,c=0,t=0;for(let o=0,a=k.length;o<a;o++){const u=k.charCodeAt(o);u===13?(w===0&&(s=o),w++,o+1<a&&k.charCodeAt(o+1)===10?(t|=2,o++):t|=3,c=o+1):u===10&&(t|=1,w===0&&(s=o),w++,c=o+1)}return w===0&&(s=k.length),[w,s,k.length-c,t]}e.countEOL=S}),define(W[14],j([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var O;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(O||(e.LanguageId=O={}));var S;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(S||(e.FontStyle=S={}));var k;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var w;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(w||(e.StandardTokenType=w={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class c{static getLanguageId(o){return(o&255)>>>0}static getTokenType(o){return(o&768)>>>8}static containsBalancedBrackets(o){return(o&1024)!==0}static getFontStyle(o){return(o&30720)>>>11}static getForeground(o){return(o&16744448)>>>15}static getBackground(o){return(o&4278190080)>>>24}static getClassNameFromMetadata(o){let u="mtk"+this.getForeground(o);const d=this.getFontStyle(o);return d&1&&(u+=" mtki"),d&2&&(u+=" mtkb"),d&4&&(u+=" mtku"),d&8&&(u+=" mtks"),u}static getInlineStyleFromMetadata(o,a){const u=this.getForeground(o),d=this.getFontStyle(o);let h=`color: ${a[u]};`;d&1&&(h+="font-style: italic;"),d&2&&(h+="font-weight: bold;");let n="";return d&4&&(n+=" underline"),d&8&&(n+=" line-through"),n&&(h+=`text-decoration:${n};`),h}static getPresentationFromMetadata(o){const a=this.getForeground(o),u=this.getFontStyle(o);return{foreground:a,italic:!!(u&1),bold:!!(u&2),underline:!!(u&4),strikethrough:!!(u&8)}}}e.TokenMetadata=c}),define(W[25],j([0,1,26]),function(U,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FixedArray=void 0;class S{constructor(s){this._default=s,this._store=[]}get(s){return s<this._store.length?this._store[s]:this._default}set(s,c){for(;s>=this._store.length;)this._store[this._store.length]=this._default;this._store[s]=c}replace(s,c,t){if(s>=this._store.length)return;if(c===0){this.insert(s,t);return}else if(t===0){this.delete(s,c);return}const o=this._store.slice(0,s),a=this._store.slice(s+c),u=k(t,this._default);this._store=o.concat(u,a)}delete(s,c){c===0||s>=this._store.length||this._store.splice(s,c)}insert(s,c){if(c===0||s>=this._store.length)return;const t=[];for(let o=0;o<c;o++)t[o]=this._default;this._store=(0,O.arrayInsert)(this._store,s,t)}}e.FixedArray=S;function k(w,s){const c=[];for(let t=0;t<w;t++)c[t]=s;return c}}),define(W[7],j([0,1,14]),function(U,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class S{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(s,c){const t=S.defaultTokenMetadata,o=new Uint32Array(2);return o[0]=s.length,o[1]=t,new S(o,s,c)}constructor(s,c,t){this._lineTokensBrand=void 0,this._tokens=s,this._tokensCount=this._tokens.length>>>1,this._text=c,this._languageIdCodec=t}equals(s){return s instanceof S?this.slicedEquals(s,0,this._tokensCount):!1}slicedEquals(s,c,t){if(this._text!==s._text||this._tokensCount!==s._tokensCount)return!1;const o=c<<1,a=o+(t<<1);for(let u=o;u<a;u++)if(this._tokens[u]!==s._tokens[u])return!1;return!0}getLineContent(){return this._text}getCount(){return this._tokensCount}getStartOffset(s){return s>0?this._tokens[s-1<<1]:0}getMetadata(s){return this._tokens[(s<<1)+1]}getLanguageId(s){const c=this._tokens[(s<<1)+1],t=O.TokenMetadata.getLanguageId(c);return this._languageIdCodec.decodeLanguageId(t)}getStandardTokenType(s){const c=this._tokens[(s<<1)+1];return O.TokenMetadata.getTokenType(c)}getForeground(s){const c=this._tokens[(s<<1)+1];return O.TokenMetadata.getForeground(c)}getClassName(s){const c=this._tokens[(s<<1)+1];return O.TokenMetadata.getClassNameFromMetadata(c)}getInlineStyle(s,c){const t=this._tokens[(s<<1)+1];return O.TokenMetadata.getInlineStyleFromMetadata(t,c)}getPresentation(s){const c=this._tokens[(s<<1)+1];return O.TokenMetadata.getPresentationFromMetadata(c)}getEndOffset(s){return this._tokens[s<<1]}findTokenIndexAtOffset(s){return S.findIndexInTokensArray(this._tokens,s)}inflate(){return this}sliceAndInflate(s,c,t){return new k(this,s,c,t)}static convertToEndOffset(s,c){const o=(s.length>>>1)-1;for(let a=0;a<o;a++)s[a<<1]=s[a+1<<1];s[o<<1]=c}static findIndexInTokensArray(s,c){if(s.length<=2)return 0;let t=0,o=(s.length>>>1)-1;for(;t<o;){const a=t+Math.floor((o-t)/2),u=s[a<<1];if(u===c)return a+1;u<c?t=a+1:u>c&&(o=a)}return t}withInserted(s){if(s.length===0)return this;let c=0,t=0,o="";const a=new Array;let u=0;for(;;){const d=c<this._tokensCount?this._tokens[c<<1]:-1,h=t<s.length?s[t]:null;if(d!==-1&&(h===null||d<=h.offset)){o+=this._text.substring(u,d);const n=this._tokens[(c<<1)+1];a.push(o.length,n),c++,u=d}else if(h){if(h.offset>u){o+=this._text.substring(u,h.offset);const n=this._tokens[(c<<1)+1];a.push(o.length,n),u=h.offset}o+=h.text,a.push(o.length,h.tokenMetadata),t++}else break}return new S(new Uint32Array(a),o,this._languageIdCodec)}}e.LineTokens=S;class k{constructor(s,c,t,o){this._source=s,this._startOffset=c,this._endOffset=t,this._deltaOffset=o,this._firstTokenIndex=s.findTokenIndexAtOffset(c),this._tokensCount=0;for(let a=this._firstTokenIndex,u=s.getCount();a<u&&!(s.getStartOffset(a)>=t);a++)this._tokensCount++}getMetadata(s){return this._source.getMetadata(this._firstTokenIndex+s)}getLanguageId(s){return this._source.getLanguageId(this._firstTokenIndex+s)}getLineContent(){return this._source.getLineContent().substring(this._startOffset,this._endOffset)}equals(s){return s instanceof k?this._startOffset===s._startOffset&&this._endOffset===s._endOffset&&this._deltaOffset===s._deltaOffset&&this._source.slicedEquals(s._source,this._firstTokenIndex,this._tokensCount):!1}getCount(){return this._tokensCount}getForeground(s){return this._source.getForeground(this._firstTokenIndex+s)}getEndOffset(s){const c=this._source.getEndOffset(this._firstTokenIndex+s);return Math.min(this._endOffset,c)-this._startOffset+this._deltaOffset}getClassName(s){return this._source.getClassName(this._firstTokenIndex+s)}getInlineStyle(s,c){return this._source.getInlineStyle(this._firstTokenIndex+s,c)}getPresentation(s){return this._source.getPresentation(this._firstTokenIndex+s)}findTokenIndexAtOffset(s){return this._source.findTokenIndexAtOffset(s+this._startOffset-this._deltaOffset)-this._firstTokenIndex}}}),define(W[27],j([0,1,7]),function(U,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class S{static deleteBeginning(s,c){return s===null||s===e.EMPTY_LINE_TOKENS?s:S.delete(s,0,c)}static deleteEnding(s,c){if(s===null||s===e.EMPTY_LINE_TOKENS)return s;const t=k(s),o=t[t.length-2];return S.delete(s,c,o)}static delete(s,c,t){if(s===null||s===e.EMPTY_LINE_TOKENS||c===t)return s;const o=k(s),a=o.length>>>1;if(c===0&&o[o.length-2]===t)return e.EMPTY_LINE_TOKENS;const u=O.LineTokens.findIndexInTokensArray(o,c),d=u>0?o[u-1<<1]:0,h=o[u<<1];if(t<h){const y=t-c;for(let R=u;R<a;R++)o[R<<1]-=y;return s}let n,i;d!==c?(o[u<<1]=c,n=u+1<<1,i=c):(n=u<<1,i=d);const r=t-c;for(let y=u+1;y<a;y++){const R=o[y<<1]-r;R>i&&(o[n++]=R,o[n++]=o[(y<<1)+1],i=R)}if(n===o.length)return s;const b=new Uint32Array(n);return b.set(o.subarray(0,n),0),b.buffer}static append(s,c){if(c===e.EMPTY_LINE_TOKENS)return s;if(s===e.EMPTY_LINE_TOKENS)return c;if(s===null)return s;if(c===null)return null;const t=k(s),o=k(c),a=o.length>>>1,u=new Uint32Array(t.length+o.length);u.set(t,0);let d=t.length;const h=t[t.length-2];for(let n=0;n<a;n++)u[d++]=o[n<<1]+h,u[d++]=o[(n<<1)+1];return u.buffer}static insert(s,c,t){if(s===null||s===e.EMPTY_LINE_TOKENS)return s;const o=k(s),a=o.length>>>1;let u=O.LineTokens.findIndexInTokensArray(o,c);u>0&&o[u-1<<1]===c&&u--;for(let d=u;d<a;d++)o[d<<1]+=t;return s}}e.ContiguousTokensEditing=S;function k(w){return w instanceof Uint32Array?w:new Uint32Array(w)}e.toUint32Array=k}),define(W[28],j([0,1,26,12,44,13,27,15]),function(U,e,O,S,k,w,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(a,u,d){const h=new Uint32Array(a.buffer),n=(0,S.readUInt32BE)(a,u);u+=4;const i=(0,S.readUInt32BE)(a,u);u+=4;const r=[];for(let b=0;b<i;b++){const y=(0,S.readUInt32BE)(a,u);u+=4,r.push(h.subarray(u/4,u/4+y/4)),u+=y}return d.push(new t(n,r)),u}get startLineNumber(){return this._startLineNumber}get endLineNumber(){return this._startLineNumber+this._tokens.length-1}constructor(a,u){this._startLineNumber=a,this._tokens=u}getLineRange(){return new c.LineRange(this._startLineNumber,this._startLineNumber+this._tokens.length)}getLineTokens(a){return this._tokens[a-this._startLineNumber]}appendLineTokens(a){this._tokens.push(a)}serializeSize(){let a=0;a+=4,a+=4;for(let u=0;u<this._tokens.length;u++){const d=this._tokens[u];if(!(d instanceof Uint32Array))throw new Error("Not supported!");a+=4,a+=d.byteLength}return a}serialize(a,u){(0,S.writeUInt32BE)(a,this._startLineNumber,u),u+=4,(0,S.writeUInt32BE)(a,this._tokens.length,u),u+=4;for(let d=0;d<this._tokens.length;d++){const h=this._tokens[d];if(!(h instanceof Uint32Array))throw new Error("Not supported!");(0,S.writeUInt32BE)(a,h.byteLength,u),u+=4,a.set(new Uint8Array(h.buffer),u),u+=h.byteLength}return u}applyEdit(a,u){const[d,h]=(0,w.countEOL)(u);this._acceptDeleteRange(a),this._acceptInsertText(new k.Position(a.startLineNumber,a.startColumn),d,h)}_acceptDeleteRange(a){if(a.startLineNumber===a.endLineNumber&&a.startColumn===a.endColumn)return;const u=a.startLineNumber-this._startLineNumber,d=a.endLineNumber-this._startLineNumber;if(d<0){const h=d-u;this._startLineNumber-=h;return}if(!(u>=this._tokens.length)){if(u<0&&d>=this._tokens.length){this._startLineNumber=0,this._tokens=[];return}if(u===d){this._tokens[u]=s.ContiguousTokensEditing.delete(this._tokens[u],a.startColumn-1,a.endColumn-1);return}if(u>=0)if(this._tokens[u]=s.ContiguousTokensEditing.deleteEnding(this._tokens[u],a.startColumn-1),d<this._tokens.length){const h=s.ContiguousTokensEditing.deleteBeginning(this._tokens[d],a.endColumn-1);this._tokens[u]=s.ContiguousTokensEditing.append(this._tokens[u],h),this._tokens.splice(u+1,d-u)}else this._tokens[u]=s.ContiguousTokensEditing.append(this._tokens[u],null),this._tokens=this._tokens.slice(0,u+1);else{const h=-u;this._startLineNumber-=h,this._tokens[d]=s.ContiguousTokensEditing.deleteBeginning(this._tokens[d],a.endColumn-1),this._tokens=this._tokens.slice(d)}}}_acceptInsertText(a,u,d){if(u===0&&d===0)return;const h=a.lineNumber-this._startLineNumber;if(h<0){this._startLineNumber+=u;return}if(!(h>=this._tokens.length)){if(u===0){this._tokens[h]=s.ContiguousTokensEditing.insert(this._tokens[h],a.column-1,d);return}this._tokens[h]=s.ContiguousTokensEditing.deleteEnding(this._tokens[h],a.column-1),this._tokens[h]=s.ContiguousTokensEditing.insert(this._tokens[h],a.column-1,d),this._insertLines(a.lineNumber,u)}}_insertLines(a,u){if(u===0)return;const d=[];for(let h=0;h<u;h++)d[h]=null;this._tokens=O.arrayInsert(this._tokens,a,d)}}e.ContiguousMultilineTokens=t}),define(W[16],j([0,1,12,28]),function(U,e,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class k{static deserialize(s){let c=0;const t=(0,O.readUInt32BE)(s,c);c+=4;const o=[];for(let a=0;a<t;a++)c=S.ContiguousMultilineTokens.deserialize(s,c,o);return o}constructor(){this._tokens=[]}add(s,c){if(this._tokens.length>0){const t=this._tokens[this._tokens.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(c);return}}this._tokens.push(new S.ContiguousMultilineTokens(s,[c]))}finalize(){return this._tokens}serialize(){const s=this._serializeSize(),c=new Uint8Array(s);return this._serialize(c),c}_serializeSize(){let s=0;s+=4;for(let c=0;c<this._tokens.length;c++)s+=this._tokens[c].serializeSize();return s}_serialize(s){let c=0;(0,O.writeUInt32BE)(s,this._tokens.length,c),c+=4;for(let t=0;t<this._tokens.length;t++)c=this._tokens[t].serialize(s,c)}}e.ContiguousMultilineTokensBuilder=k}),define(W[29],j([0,1,30,3,31,45]),function(U,e,O,S,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function s(g){return g===47||g===92}e.isPathSeparator=s;function c(g){return g.replace(/[\\/]/g,O.posix.sep)}e.toSlashes=c;function t(g){return g.indexOf("/")===-1&&(g=c(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}e.toPosixPath=t;function o(g,L=O.posix.sep){if(!g)return"";const z=g.length,B=g.charCodeAt(0);if(s(B)){if(s(g.charCodeAt(1))&&!s(g.charCodeAt(2))){let m=3;const M=m;for(;m<z&&!s(g.charCodeAt(m));m++);if(M!==m&&!s(g.charCodeAt(m+1))){for(m+=1;m<z;m++)if(s(g.charCodeAt(m)))return g.slice(0,m+1).replace(/[\\/]/g,L)}}return L}else if(b(B)&&g.charCodeAt(1)===58)return s(g.charCodeAt(2))?g.slice(0,2)+L:g.slice(0,2);let P=g.indexOf("://");if(P!==-1){for(P+=3;P<z;P++)if(s(g.charCodeAt(P)))return g.slice(0,P+1)}return""}e.getRoot=o;function a(g){if(!S.isWindows||!g||g.length<5)return!1;let L=g.charCodeAt(0);if(L!==92||(L=g.charCodeAt(1),L!==92))return!1;let z=2;const B=z;for(;z<g.length&&(L=g.charCodeAt(z),L!==92);z++);return!(B===z||(L=g.charCodeAt(z+1),isNaN(L)||L===92))}e.isUNC=a;const u=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(g,L=S.isWindows){const z=L?u:d;return!(!g||g.length===0||/^\s+$/.test(g)||(z.lastIndex=0,z.test(g))||L&&h.test(g)||g==="."||g===".."||L&&g[g.length-1]==="."||L&&g.length!==g.trim().length||g.length>255)}e.isValidBasename=n;function i(g,L,z){const B=g===L;return!z||B?B:!g||!L?!1:(0,k.equalsIgnoreCase)(g,L)}e.isEqual=i;function r(g,L,z,B=O.sep){if(g===L)return!0;if(!g||!L||L.length>g.length)return!1;if(z){if(!(0,k.startsWithIgnoreCase)(g,L))return!1;if(L.length===g.length)return!0;let m=L.length;return L.charAt(L.length-1)===B&&m--,g.charAt(m)===B}return L.charAt(L.length-1)!==B&&(L+=B),g.indexOf(L)===0}e.isEqualOrParent=r;function b(g){return g>=65&&g<=90||g>=97&&g<=122}e.isWindowsDriveLetter=b;function y(g,L){return S.isWindows&&g.endsWith(":")&&(g+=O.sep),(0,O.isAbsolute)(g)||(g=(0,O.join)(L,g)),g=(0,O.normalize)(g),S.isWindows?(g=(0,k.rtrim)(g,O.sep),g.endsWith(":")&&(g+=O.sep)):(g=(0,k.rtrim)(g,O.sep),g||(g=O.sep)),g}e.sanitizeFilePath=y;function R(g){const L=(0,O.normalize)(g);return S.isWindows?g.length>3?!1:N(L)&&(g.length===2||L.charCodeAt(2)===92):L===O.posix.sep}e.isRootOrDriveLetter=R;function N(g,L=S.isWindows){return L?b(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}e.hasDriveLetter=N;function E(g,L=S.isWindows){return N(g,L)?g[0]:void 0}e.getDriveLetter=E;function f(g,L,z){return L.length>g.length?-1:g===L?0:(z&&(g=g.toLowerCase(),L=L.toLowerCase()),g.indexOf(L))}e.indexOfPath=f;function v(g){const L=g.split(":");let z,B,P;for(const m of L){const M=Number(m);(0,w.isNumber)(M)?B===void 0?B=M:P===void 0&&(P=M):z=z?[z,m].join(":"):m}if(!z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:z,line:B!==void 0?B:void 0,column:P!==void 0?P:B!==void 0?1:void 0}}e.parseLineAndColumnAware=v;const _="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",p="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(g,L,z=8){let B="";for(let m=0;m<z;m++){let M;m===0&&S.isWindows&&!L&&(z===3||z===4)?M=p:M=_,B+=M.charAt(Math.floor(Math.random()*M.length))}let P;return L?P=`${L}-${B}`:P=B,g?(0,O.join)(g,P):P}e.randomPath=D}),define(W[17],j([0,1,6,3,8]),function(U,e,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(o){o.inMemory="inmemory",o.vscode="vscode",o.internal="private",o.walkThrough="walkThrough",o.walkThroughSnippet="walkThroughSnippet",o.http="http",o.https="https",o.file="file",o.mailto="mailto",o.untitled="untitled",o.data="data",o.command="command",o.vscodeRemote="vscode-remote",o.vscodeRemoteResource="vscode-remote-resource",o.vscodeManagedRemoteResource="vscode-managed-remote-resource",o.vscodeUserData="vscode-userdata",o.vscodeCustomEditor="vscode-custom-editor",o.vscodeNotebookCell="vscode-notebook-cell",o.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",o.vscodeNotebookCellOutput="vscode-notebook-cell-output",o.vscodeInteractiveInput="vscode-interactive-input",o.vscodeSettings="vscode-settings",o.vscodeWorkspaceTrust="vscode-workspace-trust",o.vscodeTerminal="vscode-terminal",o.vscodeChatSesssion="vscode-chat-editor",o.webviewPanel="webview-panel",o.vscodeWebview="vscode-webview",o.extension="extension",o.vscodeFileResource="vscode-file",o.tmp="tmp",o.vsls="vsls",o.vscodeSourceControl="vscode-scm"})(w||(e.Schemas=w={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class s{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${w.vscodeRemoteResource}`}setPreferredWebSchema(a){this._preferredWebSchema=a}setDelegate(a){this._delegate=a}setServerRootPath(a){this._remoteResourcesPath=`${a}/${w.vscodeRemoteResource}`}set(a,u,d){this._hosts[a]=u,this._ports[a]=d}setConnectionToken(a,u){this._connectionTokens[a]=u}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(a){if(this._delegate)try{return this._delegate(a)}catch(r){return O.onUnexpectedError(r),a}const u=a.authority;let d=this._hosts[u];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const h=this._ports[u],n=this._connectionTokens[u];let i=`path=${encodeURIComponent(a.path)}`;return typeof n=="string"&&(i+=`&${e.connectionTokenQueryName}=${encodeURIComponent(n)}`),k.URI.from({scheme:S.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${d}:${h}`,path:this._remoteResourcesPath,query:i})}}e.RemoteAuthorities=new s,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class c{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(a){const u=this.toUri(a,U);return this.uriToBrowserUri(u)}uriToBrowserUri(a){return a.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(a):a.scheme===w.file&&(S.isNative||S.isWebWorker&&S.globals.origin===`${w.vscodeFileResource}://${c.FALLBACK_AUTHORITY}`)?a.with({scheme:w.vscodeFileResource,authority:a.authority||c.FALLBACK_AUTHORITY,query:null,fragment:null}):a}asFileUri(a){const u=this.toUri(a,U);return this.uriToFileUri(u)}uriToFileUri(a){return a.scheme===w.vscodeFileResource?a.with({scheme:w.file,authority:a.authority!==c.FALLBACK_AUTHORITY?a.authority:null,query:null,fragment:null}):a}toUri(a,u){return k.URI.isUri(a)?a:k.URI.parse(u.toUrl(a))}}e.FileAccess=new c;var t;(function(o){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);o.CoopAndCoep=Object.freeze(a.get("3"));const u="vscode-coi";function d(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:k.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const r=i?.get(u);if(r)return a.get(r)}o.getHeadersFromQuery=d;function h(n,i,r){if(!globalThis.crossOriginIsolated)return;const b=i&&r?"3":r?"2":"1";n instanceof URLSearchParams?n.set(u,b):n[u]=b}o.addSearchParam=h})(t||(e.COI=t={}))}),define(W[32],j([0,1,21,17,3,8]),function(U,e,O,S,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class s{constructor(d,h,n){this.id=d,this.dependencies=h,this.callback=n}}class c{static{this.INSTANCE=new c}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(d,h,n)=>{typeof d!="string"&&(n=h,h=d,d=null),(typeof h!="object"||!Array.isArray(h))&&(n=h,h=null),this._defineCalls.push(new s(d,h,n))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this._initialize();const h=await(this._isWebWorker?this._workerLoadScript(d):this._isRenderer?this._rendererLoadScript(d):this._nodeJSLoadScript(d));if(!h)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}_rendererLoadScript(d){return new Promise((h,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const r=()=>{i.removeEventListener("load",b),i.removeEventListener("error",y)},b=R=>{r(),h(this._defineCalls.pop())},y=R=>{r(),n(R)};i.addEventListener("load",b),i.addEventListener("error",y),this._amdPolicy&&(d=this._amdPolicy.createScriptURL(d)),i.setAttribute("src",d),document.getElementsByTagName("head")[0].appendChild(i)})}_workerLoadScript(d){return new Promise((h,n)=>{try{this._amdPolicy&&(d=this._amdPolicy.createScriptURL(d)),importScripts(d),h(this._defineCalls.pop())}catch(i){n(i)}})}async _nodeJSLoadScript(d){try{const h=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,r=w.URI.parse(d).fsPath,b=h.readFileSync(r).toString(),y=i.wrap(b.replace(/^#!.*/,""));return new n.Script(y).runInThisContext().apply(),this._defineCalls.pop()}catch(h){throw h}}}const t=new Map;let o={};typeof globalThis.require=="object"&&(o=globalThis.require.paths??{});async function a(u,d,h){if(O.isESM){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),o[u]&&(u=o[u]);const n=`${u}/${d}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const R=`${h&&!k.isWeb?S.nodeModulesAsarPath:S.nodeModulesPath}/${n}`;i=S.FileAccess.asBrowserUri(R).toString(!0)}const r=c.INSTANCE.load(i);return t.set(n,r),r}else return await new Promise((n,i)=>{U([u],n,i)})}e.importAMDNodeModule=a}),define(W[18],j([0,1,29,17,30,3,31,8]),function(U,e,O,S,k,w,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(h){return(0,c.uriToFsPath)(h,!0)}e.originalFSPath=t;class o{constructor(n){this._ignorePathCasing=n}compare(n,i,r=!1){return n===i?0:(0,s.compare)(this.getComparisonKey(n,r),this.getComparisonKey(i,r))}isEqual(n,i,r=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,r)===this.getComparisonKey(i,r)}getComparisonKey(n,i=!1){return n.with({path:this._ignorePathCasing(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this._ignorePathCasing(n)}isEqualOrParent(n,i,r=!1){if(n.scheme===i.scheme){if(n.scheme===S.Schemas.file)return O.isEqualOrParent(t(n),t(i),this._ignorePathCasing(n))&&n.query===i.query&&(r||n.fragment===i.fragment);if((0,e.isEqualAuthority)(n.authority,i.authority))return O.isEqualOrParent(n.path,i.path,this._ignorePathCasing(n),"/")&&n.query===i.query&&(r||n.fragment===i.fragment)}return!1}joinPath(n,...i){return c.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.basename)(n)||n.authority}basename(n){return k.posix.basename(n.path)}extname(n){return k.posix.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===S.Schemas.file?i=c.URI.file(k.dirname(t(n))).path:(i=k.posix.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===S.Schemas.file?i=c.URI.file(k.normalize(t(n))).path:i=k.posix.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.isEqualAuthority)(n.authority,i.authority))return;if(n.scheme===S.Schemas.file){const y=k.relative(t(n),t(i));return w.isWindows?O.toSlashes(y):y}let r=n.path||"/";const b=i.path||"/";if(this._ignorePathCasing(n)){let y=0;for(const R=Math.min(r.length,b.length);y<R&&!(r.charCodeAt(y)!==b.charCodeAt(y)&&r.charAt(y).toLowerCase()!==b.charAt(y).toLowerCase());y++);r=b.substr(0,y)+r.substr(y)}return k.posix.relative(r,b)}resolvePath(n,i){if(n.scheme===S.Schemas.file){const r=c.URI.file(k.resolve(t(n),i));return n.with({authority:r.authority,path:r.path})}return i=O.toPosixPath(i),n.with({path:k.posix.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,s.equalsIgnoreCase)(n,i)}hasTrailingPathSeparator(n,i=k.sep){if(n.scheme===S.Schemas.file){const r=t(n);return r.length>O.getRoot(r).length&&r[r.length-1]===i}else{const r=n.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=k.sep){return(0,e.hasTrailingPathSeparator)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=k.sep){let r=!1;if(n.scheme===S.Schemas.file){const b=t(n);r=b!==void 0&&b.length===O.getRoot(b).length&&b[b.length-1]===i}else{i="/";const b=n.path;r=b.length===1&&b.charCodeAt(b.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(n,i)?n.with({path:n.path+"/"}):n}}e.ExtUri=o,e.extUri=new o(()=>!1),e.extUriBiasedIgnorePathCase=new o(h=>h.scheme===S.Schemas.file?!w.isLinux:!0),e.extUriIgnorePathCase=new o(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function a(h,n){const i=[];for(let r=0;r<h.length;r++){const b=n(h[r]);h.some((y,R)=>R===r?!1:(0,e.isEqualOrParent)(b,n(y)))||i.push(h[r])}return i}e.distinctParents=a;var u;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function n(i){const r=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(R=>{const[N,E]=R.split(":");N&&E&&r.set(N,E)});const y=i.path.substring(0,i.path.indexOf(";"));return y&&r.set(h.META_DATA_MIME,y),r}h.parseMetaData=n})(u||(e.DataUri=u={}));function d(h,n,i){if(n){let r=h.path;return r&&r[0]!==k.posix.sep&&(r=k.posix.sep+r),h.with({scheme:i,authority:n,path:r})}return h.with({scheme:i})}e.toLocalResource=d}),define(W[19],j([0,1,46,6,33,2,18,3,24]),function(U,e,O,S,k,w,s,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function o(I){return!!I&&typeof I.then=="function"}e.isThenable=o;function a(I){const l=new O.CancellationTokenSource,T=I(l.token),C=new Promise((A,F)=>{const Q=l.token.onCancellationRequested(()=>{Q.dispose(),l.dispose(),F(new S.CancellationError)});Promise.resolve(T).then(Z=>{Q.dispose(),l.dispose(),A(Z)},Z=>{Q.dispose(),l.dispose(),F(Z)})});return new class{cancel(){l.cancel()}then(A,F){return C.then(A,F)}catch(A){return this.then(void 0,A)}finally(A){return C.finally(A)}}}e.createCancelablePromise=a;function u(I,l,T){return new Promise((C,A)=>{const F=l.onCancellationRequested(()=>{F.dispose(),C(T)});I.then(C,A).finally(()=>F.dispose())})}e.raceCancellation=u;function d(I,l){return new Promise((T,C)=>{const A=l.onCancellationRequested(()=>{A.dispose(),C(new S.CancellationError)});I.then(T,C).finally(()=>A.dispose())})}e.raceCancellationError=d;async function h(I){let l=-1;const T=I.map((C,A)=>C.then(F=>(l=A,F)));try{return await Promise.race(T)}finally{I.forEach((C,A)=>{A!==l&&C.cancel()})}}e.raceCancellablePromises=h;function n(I,l,T){let C;const A=setTimeout(()=>{C?.(void 0),T?.()},l);return Promise.race([I.finally(()=>clearTimeout(A)),new Promise(F=>C=F)])}e.raceTimeout=n;function i(I){return new Promise((l,T)=>{const C=I();o(C)?C.then(l,T):l(C)})}e.asPromise=i;class r{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(l){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=l,!this.queuedPromise){const T=()=>{if(this.queuedPromise=null,this.isDisposed)return;const C=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,C};this.queuedPromise=new Promise(C=>{this.activePromise.then(T,T).then(C)})}return new Promise((T,C)=>{this.queuedPromise.then(T,C)})}return this.activePromise=l(),new Promise((T,C)=>{this.activePromise.then(A=>{this.activePromise=null,T(A)},A=>{this.activePromise=null,C(A)})})}dispose(){this.isDisposed=!0}}e.Throttler=r;class b{constructor(){this.current=Promise.resolve(null)}queue(l){return this.current=this.current.then(()=>l(),()=>l())}}e.Sequencer=b;class y{constructor(){this.promiseMap=new Map}queue(l,T){const A=(this.promiseMap.get(l)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(l)===A&&this.promiseMap.delete(l)});return this.promiseMap.set(l,A),A}}e.SequencerByKey=y;const R=(I,l)=>{let T=!0;const C=setTimeout(()=>{T=!1,l()},I);return{isTriggered:()=>T,dispose:()=>{clearTimeout(C),T=!1}}},N=I=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,I())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class E{constructor(l){this.defaultDelay=l,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(l,T=this.defaultDelay){this.task=l,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((A,F)=>{this.doResolve=A,this.doReject=F}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const A=this.task;return this.task=null,A()}}));const C=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=T===t.MicrotaskDelay?N(C):R(T,C),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new S.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=E;class f{constructor(l){this.delayer=new E(l),this.throttler=new r}trigger(l,T){return this.delayer.trigger(()=>this.throttler.queue(l),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=f;class v{constructor(){this._isOpen=!1,this._promise=new Promise((l,T)=>{this._completePromise=l})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class _ extends v{constructor(l){super(),this._timeout=setTimeout(()=>this.open(),l)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=_;function p(I,l){return l?new Promise((T,C)=>{const A=setTimeout(()=>{F.dispose(),T()},I),F=l.onCancellationRequested(()=>{clearTimeout(A),F.dispose(),C(new S.CancellationError)})}):a(T=>p(I,T))}e.timeout=p;function D(I,l=0){const T=setTimeout(I,l);return(0,w.toDisposable)(()=>clearTimeout(T))}e.disposableTimeout=D;function g(I){const l=[];let T=0;const C=I.length;function A(){return T<C?I[T++]():null}function F(Q){Q!=null&&l.push(Q);const Z=A();return Z?Z.then(F):Promise.resolve(l)}return Promise.resolve(null).then(F)}e.sequence=g;function L(I,l=C=>!!C,T=null){let C=0;const A=I.length,F=()=>{if(C>=A)return Promise.resolve(T);const Q=I[C++];return Promise.resolve(Q()).then(X=>l(X)?Promise.resolve(X):F())};return F()}e.first=L;function z(I,l=C=>!!C,T=null){if(I.length===0)return Promise.resolve(T);let C=I.length;const A=()=>{C=-1;for(const F of I)F.cancel?.()};return new Promise((F,Q)=>{for(const Z of I)Z.then(X=>{--C>=0&&l(X)?(A(),F(X)):C===0&&F(T)}).catch(X=>{--C>=0&&(A(),Q(X))})})}e.firstParallel=z;class B{constructor(l){this._size=0,this.maxDegreeOfParalellism=l,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(l){return this._size++,new Promise((T,C)=>{this.outstandingPromises.push({factory:l,c:T,e:C}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const l=this.outstandingPromises.shift();this.runningPromises++;const T=l.factory();T.then(l.c,l.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=B;class P extends B{constructor(){super(1)}}e.Queue=P;class m{constructor(){this.sequentializer=new x,this.tasks=0}queue(l){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,l())):this.sequentializer.run(this.tasks++,l())}}e.LimitedQueue=m;class M{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const l=new te;return this.drainers.add(l),l.p}isDrained(){for(const[,l]of this.queues)if(l.size>0)return!1;return!0}queueFor(l,T=s.extUri){const C=T.getComparisonKey(l);let A=this.queues.get(C);return A||(A=new P,k.Event.once(A.onDrained)(()=>{A?.dispose(),this.queues.delete(C),this.onDidQueueDrain()}),this.queues.set(C,A)),A}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const l of this.drainers)l.complete();this.drainers.clear()}dispose(){for(const[,l]of this.queues)l.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=M;class V{constructor(l,T){this._token=-1,typeof l=="function"&&typeof T=="number"&&this.setIfNotSet(l,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(l,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,l()},T)}setIfNotSet(l,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,l()},T))}}e.TimeoutTimer=V;class K{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(l,T){this.cancel(),this._token=setInterval(()=>{l()},T)}}e.IntervalTimer=K;class ${constructor(l,T){this.timeoutToken=-1,this.runner=l,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(l=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,l)}get delay(){return this.timeout}set delay(l){this.timeout=l}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=$;class G{constructor(l,T){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.runner=l,this.timeout=T,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(l=this.timeout){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(l/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=G;class q extends ${constructor(l,T){super(l,T),this.units=[]}work(l){this.units.push(l),this.isScheduled()||this.schedule()}doRun(){const l=this.units;this.units=[],this.runner?.(l)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=q;class H extends w.Disposable{constructor(l,T){super(),this.options=l,this.handler=T,this.pendingWork=[],this.throttler=this._register(new w.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(l){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+l.length>this.options.maxBufferedWork)return!1}else if(this.pending+l.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const T of l)this.pendingWork.push(T);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new $(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=I=>{(0,c.setTimeout0)(()=>{if(l)return;const T=Date.now()+15;I(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let l=!1;return{dispose(){l||(l=!0)}}}:e.runWhenIdle=(I,l)=>{const T=requestIdleCallback(I,typeof l=="number"?{timeout:l}:void 0);let C=!1;return{dispose(){C||(C=!0,cancelIdleCallback(T))}}}}();class J{constructor(l){this._didRun=!1,this._executor=()=>{try{this._value=l()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=J;async function se(I,l,T){let C;for(let A=0;A<T;A++)try{return await I()}catch(F){C=F,await p(l)}throw C}e.retry=se;class x{isRunning(l){return typeof l=="number"?this._running?.taskId===l:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(l,T,C){return this._running={taskId:l,cancel:()=>C?.(),promise:T},T.then(()=>this.doneRunning(l),()=>this.doneRunning(l)),T}doneRunning(l){this._running&&l===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const l=this._queued;this._queued=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this._queued)this._queued.run=l;else{let T,C;const A=new Promise((F,Q)=>{T=F,C=Q});this._queued={run:l,promise:A,promiseResolve:T,promiseReject:C}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=x;class oe{constructor(l,T=()=>Date.now()){this.interval=l,this.nowFn=T,this.lastIncrementTime=0,this.value=0}increment(){const l=this.nowFn();return l-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=l,this.value=0),this.value++,this.value}}e.IntervalCounter=oe;var ee;(function(I){I[I.Resolved=0]="Resolved",I[I.Rejected=1]="Rejected"})(ee||(ee={}));class te{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((l,T)=>{this.completeCallback=l,this.errorCallback=T})}complete(l){return new Promise(T=>{this.completeCallback(l),this.outcome={outcome:0,value:l},T()})}error(l){return new Promise(T=>{this.errorCallback(l),this.outcome={outcome:1,value:l},T()})}cancel(){return this.error(new S.CancellationError)}}e.DeferredPromise=te;var ne;(function(I){async function l(C){let A;const F=await Promise.all(C.map(Q=>Q.then(Z=>Z,Z=>{A||(A=Z)})));if(typeof A<"u")throw A;return F}I.settled=l;function T(C){return new Promise(async(A,F)=>{try{await C(A,F)}catch(Q){F(Q)}})}I.withAsyncBody=T})(ne||(e.Promises=ne={}));var ie;(function(I){I[I.Initial=0]="Initial",I[I.DoneOK=1]="DoneOK",I[I.DoneError=2]="DoneError"})(ie||(ie={}));class Y{static fromArray(l){return new Y(T=>{T.emitMany(l)})}static fromPromise(l){return new Y(async T=>{T.emitMany(await l)})}static fromPromises(l){return new Y(async T=>{await Promise.all(l.map(async C=>T.emitOne(await C)))})}static merge(l){return new Y(async T=>{await Promise.all(l.map(async C=>{for await(const A of C)T.emitOne(A)}))})}static{this.EMPTY=Y.fromArray([])}constructor(l){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const T={emitOne:C=>this.emitOne(C),emitMany:C=>this.emitMany(C),reject:C=>this.reject(C)};try{await Promise.resolve(l(T)),this.resolve()}catch(C){this.reject(C)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(l<this._results.length)return{done:!1,value:this._results[l++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(l,T){return new Y(async C=>{for await(const A of l)C.emitOne(T(A))})}map(l){return Y.map(this,l)}static filter(l,T){return new Y(async C=>{for await(const A of l)T(A)&&C.emitOne(A)})}filter(l){return Y.filter(this,l)}static coalesce(l){return Y.filter(l,T=>!!T)}coalesce(){return Y.coalesce(this)}static async toPromise(l){const T=[];for await(const C of l)T.push(C);return T}toPromise(){return Y.toPromise(this)}emitOne(l){this._state===0&&(this._results.push(l),this._onStateChanged.fire())}emitMany(l){this._state===0&&(this._results=this._results.concat(l),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(l){this._state===0&&(this._state=2,this._error=l,this._onStateChanged.fire())}}e.AsyncIterableObject=Y;class re extends Y{constructor(l,T){super(T),this._source=l}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=re;function ae(I){const l=new O.CancellationTokenSource,T=I(l.token);return new re(l,async C=>{const A=l.token.onCancellationRequested(()=>{A.dispose(),l.dispose(),C.reject(new S.CancellationError)});try{for await(const F of T){if(l.token.isCancellationRequested)return;C.emitOne(F)}A.dispose(),l.dispose()}catch(F){A.dispose(),l.dispose(),C.reject(F)}})}e.createCancelableAsyncIterable=ae}),define(W[20],j([0,1,34]),function(U,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(w){return this===w}};function S(w,s){return new O.TokenizationResult([new O.Token(0,"",w)],s)}e.nullTokenize=S;function k(w,s){const c=new Uint32Array(2);return c[0]=0,c[1]=(w<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new O.EncodedTokenizationResult(c,s===null?e.NullState:s)}e.nullTokenizeEncoded=k}),define(W[35],j([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(U,e,O,S,k,w,s,c,t,o,a,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultBackgroundTokenizer=e.RangePriorityQueueImpl=e.TokenizationStateStore=e.TrackingTokenizationStateStore=e.TokenizerWithStateStoreAndTextModel=e.TokenizerWithStateStore=void 0;var h;(function(E){E[E.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(h||(h={}));class n{constructor(f,v){this.tokenizationSupport=v,this.initialState=this.tokenizationSupport.getInitialState(),this.store=new r(f)}getStartState(f){return this.store.getStartState(f,this.initialState)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.initialState)}}e.TokenizerWithStateStore=n;class i extends n{constructor(f,v,_,p){super(f,v),this._textModel=_,this._languageIdCodec=p}updateTokensUntilLine(f,v){const _=this._textModel.getLanguageId();for(;;){const p=this.getFirstInvalidLine();if(!p||p.lineNumber>v)break;const D=this._textModel.getLineContent(p.lineNumber),g=R(this._languageIdCodec,_,this.tokenizationSupport,D,!0,p.startState);f.add(p.lineNumber,g.tokens),this.store.setEndState(p.lineNumber,g.endState)}}getTokenTypeIfInsertingCharacter(f,v){const _=this.getStartState(f.lineNumber);if(!_)return 0;const p=this._textModel.getLanguageId(),D=this._textModel.getLineContent(f.lineNumber),g=D.substring(0,f.column-1)+v+D.substring(f.column-1),L=R(this._languageIdCodec,p,this.tokenizationSupport,g,!0,_),z=new d.LineTokens(L.tokens,g,this._languageIdCodec);if(z.getCount()===0)return 0;const B=z.findTokenIndexAtOffset(f.column-1);return z.getStandardTokenType(B)}tokenizeLineWithEdit(f,v,_){const p=f.lineNumber,D=f.column,g=this.getStartState(p);if(!g)return null;const L=this._textModel.getLineContent(p),z=L.substring(0,D-1)+_+L.substring(D-1+v),B=this._textModel.getLanguageIdAtPosition(p,0),P=R(this._languageIdCodec,B,this.tokenizationSupport,z,!0,g);return new d.LineTokens(P.tokens,z,this._languageIdCodec)}isCheapToTokenize(f){const v=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<v||f===v&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,v,_){if(_<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(v<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,_),{heuristicTokens:!1};let p=this.guessStartState(v);const D=this._textModel.getLanguageId();for(let g=v;g<=_;g++){const L=this._textModel.getLineContent(g),z=R(this._languageIdCodec,D,this.tokenizationSupport,L,!0,p);f.add(g,z.tokens),p=z.endState}return{heuristicTokens:!0}}guessStartState(f){let v=this._textModel.getLineFirstNonWhitespaceColumn(f);const _=[];let p=null;for(let L=f-1;v>1&&L>=1;L--){const z=this._textModel.getLineFirstNonWhitespaceColumn(L);if(z!==0&&z<v&&(_.push(this._textModel.getLineContent(L)),v=z,p=this.getStartState(L),p))break}p||(p=this.tokenizationSupport.getInitialState()),_.reverse();const D=this._textModel.getLanguageId();let g=p;for(const L of _)g=R(this._languageIdCodec,D,this.tokenizationSupport,L,!1,g).endState;return g}}e.TokenizerWithStateStoreAndTextModel=i;class r{constructor(f){this.lineCount=f,this._tokenizationStateStore=new b,this._invalidEndStatesLineNumbers=new y,this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(1,f+1))}getEndState(f){return this._tokenizationStateStore.getEndState(f)}setEndState(f,v){if(!v)throw new S.BugIndicatingError("Cannot set null/undefined state");this._invalidEndStatesLineNumbers.delete(f);const _=this._tokenizationStateStore.setEndState(f,v);return _&&f<this.lineCount&&this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(f+1,f+2)),_}acceptChange(f,v){this.lineCount+=v-f.length,this._tokenizationStateStore.acceptChange(f,v),this._invalidEndStatesLineNumbers.addRangeAndResize(new t.OffsetRange(f.startLineNumber,f.endLineNumberExclusive),v)}acceptChanges(f){for(const v of f){const[_]=(0,s.countEOL)(v.text);this.acceptChange(new c.LineRange(v.range.startLineNumber,v.range.endLineNumber+1),_+1)}}invalidateEndStateRange(f){this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this._invalidEndStatesLineNumbers.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this._invalidEndStatesLineNumbers.min===null}getStartState(f,v){return f===1?v:this.getEndState(f-1)}getFirstInvalidLine(f){const v=this.getFirstInvalidEndStateLineNumber();if(v===null)return null;const _=this.getStartState(v,f);if(!_)throw new S.BugIndicatingError("Start state must be defined");return{lineNumber:v,startState:_}}}e.TrackingTokenizationStateStore=r;class b{constructor(){this._lineEndStates=new a.FixedArray(null)}getEndState(f){return this._lineEndStates.get(f)}setEndState(f,v){const _=this._lineEndStates.get(f);return _&&_.equals(v)?!1:(this._lineEndStates.set(f,v),!0)}acceptChange(f,v){let _=f.length;v>0&&_>0&&(_--,v--),this._lineEndStates.replace(f.startLineNumber,_,v)}acceptChanges(f){for(const v of f){const[_]=(0,s.countEOL)(v.text);this.acceptChange(new c.LineRange(v.range.startLineNumber,v.range.endLineNumber+1),_+1)}}}e.TokenizationStateStore=b;class y{constructor(){this._ranges=[]}getRanges(){return this._ranges}get min(){return this._ranges.length===0?null:this._ranges[0].start}removeMin(){if(this._ranges.length===0)return null;const f=this._ranges[0];return f.start+1===f.endExclusive?this._ranges.shift():this._ranges[0]=new t.OffsetRange(f.start+1,f.endExclusive),f.start}delete(f){const v=this._ranges.findIndex(_=>_.contains(f));if(v!==-1){const _=this._ranges[v];_.start===f?_.endExclusive===f+1?this._ranges.splice(v,1):this._ranges[v]=new t.OffsetRange(f+1,_.endExclusive):_.endExclusive===f+1?this._ranges[v]=new t.OffsetRange(_.start,f):this._ranges.splice(v,1,new t.OffsetRange(_.start,f),new t.OffsetRange(f+1,_.endExclusive))}}addRange(f){t.OffsetRange.addRange(f,this._ranges)}addRangeAndResize(f,v){let _=0;for(;!(_>=this._ranges.length||f.start<=this._ranges[_].endExclusive);)_++;let p=_;for(;!(p>=this._ranges.length||f.endExclusive<this._ranges[p].start);)p++;const D=v-f.length;for(let g=p;g<this._ranges.length;g++)this._ranges[g]=this._ranges[g].delta(D);if(_===p){const g=new t.OffsetRange(f.start,f.start+v);g.isEmpty||this._ranges.splice(_,0,g)}else{const g=Math.min(f.start,this._ranges[_].start),L=Math.max(f.endExclusive,this._ranges[p-1].endExclusive),z=new t.OffsetRange(g,L+D);z.isEmpty?this._ranges.splice(_,p-_):this._ranges.splice(_,p-_,z)}}toString(){return this._ranges.map(f=>f.toString()).join(" + ")}}e.RangePriorityQueueImpl=y;function R(E,f,v,_,p,D){let g=null;if(v)try{g=v.tokenizeEncoded(_,p,D.clone())}catch(L){(0,S.onUnexpectedError)(L)}return g||(g=(0,o.nullTokenizeEncoded)(E.encodeLanguageId(f),D)),d.LineTokens.convertToEndOffset(g.tokens,_.length),g}class N{constructor(f,v){this._tokenizerWithStateStore=f,this._backgroundTokenStore=v,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){this._isScheduled||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._isScheduled=!0,(0,O.runWhenIdle)(f=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(f)}))}_backgroundTokenizeWithDeadline(f){const v=Date.now()+f.timeRemaining(),_=()=>{this._isDisposed||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._backgroundTokenizeForAtLeast1ms(),Date.now()<v?(0,k.setTimeout0)(_):this._beginBackgroundTokenization())};_()}_backgroundTokenizeForAtLeast1ms(){const f=this._tokenizerWithStateStore._textModel.getLineCount(),v=new u.ContiguousMultilineTokensBuilder,_=w.StopWatch.create(!1);do if(_.elapsed()>1||this._tokenizeOneInvalidLine(v)>=f)break;while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(v.finalize()),this.checkFinished()}_hasLinesToTokenize(){return this._tokenizerWithStateStore?!this._tokenizerWithStateStore.store.allStatesValid():!1}_tokenizeOneInvalidLine(f){const v=this._tokenizerWithStateStore?.getFirstInvalidLine();return v?(this._tokenizerWithStateStore.updateTokensUntilLine(f,v.lineNumber),v.lineNumber):this._tokenizerWithStateStore._textModel.getLineCount()+1}checkFinished(){this._isDisposed||this._tokenizerWithStateStore.store.allStatesValid()&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(f,v){this._tokenizerWithStateStore.store.invalidateEndStateRange(new c.LineRange(f,v))}}e.DefaultBackgroundTokenizer=N}),define(W[37],j([0,1,33,2,36,14,34]),function(U,e,O,S,k,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class c extends S.Disposable{constructor(o,a,u,d,h,n,i){super(),this._grammar=o,this._initialState=a,this._containsEmbeddedLanguages=u,this._createBackgroundTokenizer=d,this._backgroundTokenizerShouldOnlyVerifyTokens=h,this._reportTokenizationTime=n,this._reportSlowTokenization=i,this._seenLanguages=[],this._onDidEncounterLanguage=this._register(new O.Emitter),this.onDidEncounterLanguage=this._onDidEncounterLanguage.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this._backgroundTokenizerShouldOnlyVerifyTokens()}getInitialState(){return this._initialState}tokenize(o,a,u){throw new Error("Not supported!")}createBackgroundTokenizer(o,a){if(this._createBackgroundTokenizer)return this._createBackgroundTokenizer(o,a)}tokenizeEncoded(o,a,u){const d=Math.random()*1e4<1,h=this._reportSlowTokenization||d,n=h?new k.StopWatch(!0):void 0,i=this._grammar.tokenizeLine2(o,u,500);if(h){const b=n.elapsed();(d||b>32)&&this._reportTokenizationTime(b,o.length,d)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${o.substring(0,100)}`),new s.EncodedTokenizationResult(i.tokens,u);if(this._containsEmbeddedLanguages){const b=this._seenLanguages,y=i.tokens;for(let R=0,N=y.length>>>1;R<N;R++){const E=y[(R<<1)+1],f=w.TokenMetadata.getLanguageId(E);b[f]||(b[f]=!0,this._onDidEncounterLanguage.fire(f))}}let r;return u.equals(i.ruleStack)?r=u:r=i.ruleStack,new s.EncodedTokenizationResult(i.tokens,r)}}e.TextMateTokenizationSupport=c}),define(W[38],j([0,1,20,2,11]),function(U,e,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class w extends S.Disposable{get backgroundTokenizerShouldOnlyVerifyTokens(){return this._actual.backgroundTokenizerShouldOnlyVerifyTokens}constructor(c,t,o){super(),this._encodedLanguageId=c,this._actual=t,this._maxTokenizationLineLength=o,this._register((0,k.keepAlive)(this._maxTokenizationLineLength))}getInitialState(){return this._actual.getInitialState()}tokenize(c,t,o){throw new Error("Not supported!")}tokenizeEncoded(c,t,o){return c.length>=this._maxTokenizationLineLength.get()?(0,O.nullTokenizeEncoded)(this._encodedLanguageId,o):this._actual.tokenizeEncoded(c,t,o)}createBackgroundTokenizer(c,t){if(this._actual.createBackgroundTokenizer)return this._actual.createBackgroundTokenizer(c,t)}}e.TokenizationSupportWithLineLimit=w}),define(W[39],j([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(U,e,O,S,k,w,s,c,t,o,a,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerTokenizer=void 0;class h extends c.MirrorTextModel{constructor(r,b,y,R,N,E,f,v){super(r,b,y,R),this._host=N,this._languageId=E,this._encodedLanguageId=f,this._tokenizerWithStateStore=null,this._isDisposed=!1,this._maxTokenizationLineLength=(0,k.observableValue)("_maxTokenizationLineLength",-1),this._tokenizeDebouncer=new S.RunOnceScheduler(()=>this._tokenize(),10),this._maxTokenizationLineLength.set(v,void 0),this._resetTokenization()}dispose(){this._isDisposed=!0,super.dispose()}onLanguageId(r,b){this._languageId=r,this._encodedLanguageId=b,this._resetTokenization()}onEvents(r){super.onEvents(r),this._tokenizerWithStateStore?.store.acceptChanges(r.changes),this._tokenizeDebouncer.schedule()}acceptMaxTokenizationLineLength(r){this._maxTokenizationLineLength.set(r,void 0)}retokenize(r,b){this._tokenizerWithStateStore&&(this._tokenizerWithStateStore.store.invalidateEndStateRange(new s.LineRange(r,b)),this._tokenizeDebouncer.schedule())}async _resetTokenization(){this._tokenizerWithStateStore=null;const r=this._languageId,b=this._encodedLanguageId,y=await this._host.getOrCreateGrammar(r,b);if(!(this._isDisposed||r!==this._languageId||b!==this._encodedLanguageId||!y)){if(y.grammar){const R=new d.TokenizationSupportWithLineLimit(this._encodedLanguageId,new u.TextMateTokenizationSupport(y.grammar,y.initialState,!1,void 0,()=>!1,(N,E,f)=>{this._host.reportTokenizationTime(N,r,y.sourceExtensionId,E,f)},!1),this._maxTokenizationLineLength);this._tokenizerWithStateStore=new t.TokenizerWithStateStore(this._lines.length,R)}else this._tokenizerWithStateStore=null;this._tokenize()}}async _tokenize(){if(this._isDisposed||!this._tokenizerWithStateStore)return;if(!this._diffStateStacksRefEqFn){const{diffStateStacksRefEq:b}=await(0,O.importAMDNodeModule)("vscode-textmate","release/main.js");this._diffStateStacksRefEqFn=b}const r=new Date().getTime();for(;;){let b=0;const y=new o.ContiguousMultilineTokensBuilder,R=new n;for(;;){const f=this._tokenizerWithStateStore.getFirstInvalidLine();if(f===null||b>200)break;b++;const v=this._lines[f.lineNumber-1],_=this._tokenizerWithStateStore.tokenizationSupport.tokenizeEncoded(v,!0,f.startState);if(this._tokenizerWithStateStore.store.setEndState(f.lineNumber,_.endState)){const D=this._diffStateStacksRefEqFn(f.startState,_.endState);R.setState(f.lineNumber,D)}else R.setState(f.lineNumber,null);if(a.LineTokens.convertToEndOffset(_.tokens,v.length),y.add(f.lineNumber,_.tokens),new Date().getTime()-r>20)break}if(b===0)break;const N=R.getStateDeltas();if(this._host.setTokensAndStates(this._versionId,y.serialize(),N),new Date().getTime()-r>20){(0,w.setTimeout0)(()=>this._tokenize());return}}}}e.TextMateWorkerTokenizer=h;class n{constructor(){this._lastStartLineNumber=-1,this._stateDeltas=[]}setState(r,b){r===this._lastStartLineNumber+1?this._stateDeltas[this._stateDeltas.length-1].stateDeltas.push(b):this._stateDeltas.push({startLineNumber:r,stateDeltas:[b]}),this._lastStartLineNumber=r}getStateDeltas(){return this._stateDeltas}}}),define(W[40],j([0,1,18]),function(U,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class S{constructor(){this._scopeNameToLanguageRegistration=Object.create(null)}reset(){this._scopeNameToLanguageRegistration=Object.create(null)}register(w){if(this._scopeNameToLanguageRegistration[w.scopeName]){const s=this._scopeNameToLanguageRegistration[w.scopeName];O.isEqual(s.location,w.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${w.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${w.location.toString()}`)}this._scopeNameToLanguageRegistration[w.scopeName]=w}getGrammarDefinition(w){return this._scopeNameToLanguageRegistration[w]||null}}e.TMScopeRegistry=S}),define(W[41],j([0,1,2,40]),function(U,e,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class k extends O.Disposable{constructor(s,c,t,o){super(),this._host=s,this._initialState=t.INITIAL,this._scopeRegistry=new S.TMScopeRegistry,this._injections={},this._injectedEmbeddedLanguages={},this._languageToScope=new Map,this._grammarRegistry=this._register(new t.Registry({onigLib:o,loadGrammar:async a=>{const u=this._scopeRegistry.getGrammarDefinition(a);if(!u)return this._host.logTrace(`No grammar found for scope ${a}`),null;const d=u.location;try{const h=await this._host.readFile(d);return t.parseRawGrammar(h,d.path)}catch(h){return this._host.logError(`Unable to load and parse grammar for scope ${a} from ${d}`,h),null}},getInjections:a=>{const u=a.split(".");let d=[];for(let h=1;h<=u.length;h++){const n=u.slice(0,h).join(".");d=[...d,...this._injections[n]||[]]}return d}}));for(const a of c){if(this._scopeRegistry.register(a),a.injectTo){for(const u of a.injectTo){let d=this._injections[u];d||(this._injections[u]=d=[]),d.push(a.scopeName)}if(a.embeddedLanguages)for(const u of a.injectTo){let d=this._injectedEmbeddedLanguages[u];d||(this._injectedEmbeddedLanguages[u]=d=[]),d.push(a.embeddedLanguages)}}a.language&&this._languageToScope.set(a.language,a.scopeName)}}has(s){return this._languageToScope.has(s)}setTheme(s,c){this._grammarRegistry.setTheme(s,c)}getColorMap(){return this._grammarRegistry.getColorMap()}async createGrammar(s,c){const t=this._languageToScope.get(s);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const o=this._scopeRegistry.getGrammarDefinition(t);if(!o)throw new Error(e.missingTMGrammarErrorMessage);const a=o.embeddedLanguages;if(this._injectedEmbeddedLanguages[t]){const h=this._injectedEmbeddedLanguages[t];for(const n of h)for(const i of Object.keys(n))a[i]=n[i]}const u=Object.keys(a).length>0;let d;try{d=await this._grammarRegistry.loadGrammarWithConfiguration(t,c,{embeddedLanguages:a,tokenTypes:o.tokenTypes,balancedBracketSelectors:o.balancedBracketSelectors,unbalancedBracketSelectors:o.unbalancedBracketSelectors})}catch(h){throw h.message&&h.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):h}return{languageId:s,grammar:d,initialState:this._initialState,containsEmbeddedLanguages:u,sourceExtensionId:o.sourceExtensionId}}}e.TMGrammarFactory=k}),define(W[49],j([0,1,8,41,39]),function(U,e,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function w(c,t){return new s(c,t)}e.create=w;class s{constructor(t,o){this._createData=o,this._models=new Map,this._grammarCache=[],this._host=t.host;const a=o.grammarDefinitions.map(u=>({location:O.URI.revive(u.location),language:u.language,scopeName:u.scopeName,embeddedLanguages:u.embeddedLanguages,tokenTypes:u.tokenTypes,injectTo:u.injectTo,balancedBracketSelectors:u.balancedBracketSelectors,unbalancedBracketSelectors:u.unbalancedBracketSelectors,sourceExtensionId:u.sourceExtensionId}));this._grammarFactory=this._loadTMGrammarFactory(a)}async _loadTMGrammarFactory(t){const o=this._createData.textmateMainUri,a=await new Promise((i,r)=>{U([o],i,r)}),u=await new Promise((i,r)=>{U([this._createData.onigurumaMainUri],i,r)}),h=await(await fetch(this._createData.onigurumaWASMUri)).arrayBuffer();await u.loadWASM(h);const n=Promise.resolve({createOnigScanner:i=>u.createOnigScanner(i),createOnigString:i=>u.createOnigString(i)});return new S.TMGrammarFactory({logTrace:i=>{},logError:(i,r)=>console.error(i,r),readFile:i=>this._host.readFile(i)},t,a,n)}acceptNewModel(t){const o=O.URI.revive(t.uri),a=this;this._models.set(t.controllerId,new k.TextMateWorkerTokenizer(o,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(u,d){const h=await a._grammarFactory;return h?(a._grammarCache[d]||(a._grammarCache[d]=h.createGrammar(u,d)),a._grammarCache[d]):Promise.resolve(null)},setTokensAndStates(u,d,h){a._host.setTokensAndStates(t.controllerId,u,d,h)},reportTokenizationTime(u,d,h,n,i){a._host.reportTokenizationTime(u,d,h,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,o){this._models.get(t).onEvents(o)}retokenize(t,o,a){this._models.get(t).retokenize(o,a)}acceptModelLanguageChanged(t,o,a){this._models.get(t).onLanguageId(o,a)}acceptRemovedModel(t){const o=this._models.get(t);o&&(o.dispose(),this._models.delete(t))}async acceptTheme(t,o){(await this._grammarFactory)?.setTheme(t,o)}acceptMaxTokenizationLineLength(t,o){this._models.get(t).acceptMaxTokenizationLineLength(o)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a5004432af6600c99fa4f918a3f2f8df44df71e6/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
